diff -pruN 5.6.2-2.1/ChangeLog 5.7.1-1/ChangeLog
--- 5.6.2-2.1/ChangeLog	2023-10-11 09:36:26.000000000 +0000
+++ 5.7.1-1/ChangeLog	2024-05-02 10:15:09.000000000 +0000
@@ -2,6 +2,40 @@
 = ChangeLog =
 -------------
 
+Changes from 5.7.0 to 5.7.1
+* Fixed dynamic libray creation for PORD
+* Avoid need to link with deprecated LAPACK routine [csdz]geqpf
+* Fixed an error with ICNTL(37)=1 in case of numerically difficult problems and 
+  very limited workspace
+
+Changes from 5.6.2 to 5.7.0
+* New feature: Evolution of the distributed RHS: exploit sparsity (empty rows)
+* New feature: more efficient multithreading (see ICNTL(48))
+* New feature: Improved null space detection with rank revealing (ICNTL(56))
+* New statistics about pivots and number of swaps
+* Reduced time spent in BLR clustering
+* OOC: add support for files > 2GB to avoid opening too many files
+* Increased various string max sizes: OOC_PREFIX(255), SAVE_PREFIX(255),
+  WRITE_PROBLEM(1023), OOC_TMPDIR(1023), SAVE_DIR(1023),
+* -DMUMPS_SCOTCHIMPORTOMPTHREADS: uses MUMPS OMP threads in SCOTCH
+* Improved size of BLR groups with analysis by blocks 
+* Allow for larger N (avoid need for 2*N to fit in a 32-bit integers)
+* Improved performance on small matrices (avoid costly string
+  comparisons when computing RINFO(7,8) and RINFOG(17,18))
+* -DNO_SAVE_RESTORE: suppress SAVE_RESTORE, RINFO(7,8), RINFOG(17,18)
+* Avoid calling MPI_IPROBE during solve in case of a single MPI process
+* MPI_ALLREDUCE workaround in case it fails for large buffers
+* Raise error -55 in case Nloc_RHS>0 on non-working host
+* Raise new error -88 in case of error during SCOTCH ordering
+* Fixed bound-check error in copies for 64 bit integer orderings and empty graph
+* Raise error -69 in case of installation with incorrect integer sizes
+* Compilation with -DNOSCALAPACK: suppress dependency on NUMROC
+* Fix for METIS > 5.1.0: METIS options indices no longer hardcoded
+* Fixed a bug in solve when restarting (JOB=8) with a new process
+* Fixed error with exploit sparsity during fwd phase on
+  reducible matrices and when Scalapack is used
+* Makefiles: introduced SHARED_OPT=-shared to allow defining different option
+
 Changes from 5.6.1 to 5.6.2
 * Fixed time for symbolic factorization
 * Fixed parallel analysis when PAR=0, 1 MPI per node, #MPI not a power of 2
@@ -17,7 +51,7 @@ Changes from 5.6.0 to 5.6.1
 * Fix incorrect error code -74 instead of -76 (save-restore)
 * Avoid a remaining hard-coded Fortran unit (save-restore)
 * Avoid -Wundef warning in case __STDC_VERSION__ is not defined
-* Avoid calling MPI_IPROBE in case of a single MPI process
+* Avoid calling MPI_IPROBE during factorization in case of a single MPI process
   (performance improvement on matrices with small fronts)
 * During analysis, write time for symbolic factorization
 * Update GEMMT link in INSTALL file
@@ -95,7 +129,6 @@ Changes from 5.4.1 to 5.5.0
 * -DALLOC_FROM_C introduced to fix dynamic memory management 
   with Cray compilers
 
-
 Changes from 5.4.0 to 5.4.1
 * Added feature to dump a matrix/rhs in binary form (see id%WRITE_PROBLEM)
 * Fixed error during constrained ordering (ICNTL(12)=3) leading to a segfault
@@ -771,6 +804,8 @@ Changes from 4.0.4 to 4.1.4
 = Release history =
 -------------------
 
+Release 5.7.1            : May 2024
+Release 5.7.0            : April 2024
 Release 5.6.2            : October 2023
 Release 5.6.1            : July 2023
 Release 5.6.0            : April 2023
diff -pruN 5.6.2-2.1/INSTALL 5.7.1-1/INSTALL
--- 5.6.2-2.1/INSTALL	2023-10-11 09:36:26.000000000 +0000
+++ 5.7.1-1/INSTALL	2024-05-02 10:15:09.000000000 +0000
@@ -1,5 +1,5 @@
 ===========================================
-MUMPS 5.6.2 INSTALLATION
+MUMPS 5.7.1 INSTALLATION
 ===========================================
 
 Pre-requisites
@@ -35,8 +35,8 @@ Installation
 
 The following steps can be applied.
 
-% tar zxvf MUMPS_5.6.2.tar.gz
-% cd MUMPS_5.6.2
+% tar zxvf MUMPS_5.7.1.tar.gz
+% cd MUMPS_5.7.1
 
 You then need to build a file called Makefile.inc corresponding
 to your architecture. A few examples are available in the
@@ -73,6 +73,9 @@ variables LIBBLAS (BLAS library), SCALAP
 INCPAR (include files for MPI), LIBPAR (library files for MPI) are concerned.
 We also strongly recommend to install METIS and/or SCOTCH, see the
 ordering section of Makefile.inc.
+Makefile.inc also contains a line "PLAT=" which defines an empty $(PLAT)
+Makefile variable. You can use it to add a default suffix to the generated
+libraries.
 
 By default, only the double precision version of MUMPS will be
 installed, with static MUMPS libraries. The command:
@@ -110,11 +113,11 @@ since dynamic libraries require the -fPI
 needed, the definition FPIC_OPT=-fPIC can be adapted in the Makefile.inc)
 
 The dynamic libraries (e.g. libmumps.so, libdmumps.so, etc.) are
-installed in the directory MUMPS_5.6.2/lib/
-so that including the directory MUMPS_5.6.2/lib in your
+installed in the directory MUMPS_5.7.1/lib/
+so that including the directory MUMPS_5.7.1/lib in your
 LD_LIBRARY_PATH environment variable will allow them to be successively
 loaded at runtime. Alternatively, you can uncomment and adapt the line
-#RPATH_OPT= -Wl,-rpath /path/to/MUMPS_5.6.2/lib
+#RPATH_OPT= -Wl,-rpath /path/to/MUMPS_5.7.1/lib
 in the Makefile.inc
 
 Although we do not currently support an official SONAME, note that, given a
@@ -122,8 +125,12 @@ version x.y.z of MUMPS, it is binary/ABI
 but not with x.y'.z'' versions.
 
 
-Preprocessing constants (Makefile.inc)
---------------------------------------
+Preprocessing constants
+-----------------------
+
+This section describes some preprocessing flags that can be added in the
+OPTF and OPTC variables of Makefile.inc.
+
 
 -DDETERMINISTIC_PARALLEL_GRAPH:
 When using several MPI processes, the order of the edges of the graphs
@@ -184,6 +191,21 @@ MPI environments where MPI_IN_PLACE is f
 avoid the use of MPI_IN_PLACE at the cost of more temporary memory
 allocation and possibly less efficient code.
 
+-DMUMPS_SCOTCHIMPORTOMPTHREADS:
+MUMPS provides OpenMP threads to multithreaded SCOTCH/PT-SCOTCH,
+instead of letting SCOTCH creating new threads. This feature can,
+in some cases, resolve thread affinity issues impacting performance
+negatively. Note that, when Scotch 7.0.4 is compiled with cmake, the
+symbol scotchfcontextrandomclone is missing from the Scotch library.
+To solve this issue, you may either compile Scotch 7.0.4 with make,
+or add "library_context_f.c" after "library_context.c" in the file
+"scotch-v7.0.4/src/libscotch/CMakeLists.txt".
+
+-DNO_SAVE_RESTORE:
+Disables the save restore feature.  RINFO(7), RINFO(8), RINFOG(17),
+RINFOG(18) will no longer be computed, and a call to MUMPS with
+JOB=7 or JOB=8 will lead to an error.
+
 
 Sequential version
 ------------------
@@ -365,6 +387,8 @@ Although the MUMPS development team is n
 may be interested by discussions on this topic in the archives
 of MUMPS users, or by links to contributions from users (see the
 MUMPS website, and follow "Links").
+-DMUMPS_WINLARGEFILES is designed to reduce the number of file
+descriptors under Windows and allow for files larger than 2GB.
 
 
 * FREEBSD AND SOLARIS
@@ -379,11 +403,12 @@ See the example Makefile.FREEBSD10 in th
 Note that the absence of space in the main Makefile
 is motivated by portability on Windows environments.
 
-* gfortran-10
-  -----------
+* gfortran versions >= 10
+  -----------------------
 
-For MUMPS to compile with gfortran-10, the option '-fallow-argument-mismatch'
-should be added to OPTF in your Makefile.inc
+For MUMPS to compile with gfortran versions greater or equal t 10,
+the option '-fallow-argument-mismatch' should be included in OPTF
+in your Makefile.inc
 
 * MAC OSX
   -------
@@ -393,20 +418,6 @@ Please check the "Links" page at http://
 http://brew.sh
 
 
-* IBM SP
-  ------
-On SP machines, use of PESSL, BLACS, MPI and ESSL is made.
-
-Note that MUMPS requires PESSL release 2 or greater. The version
-of MUMPS based on PESSL release 1.1 (that used descriptors of
-size 8) is no longer available. If PESSL release 2 is not
-available on your system, the public domain version of
-ScaLAPACK should be used instead. PESSL usually does not
-include single precision versions of the ScaLAPACK routines
-required by MUMPS. If the single precision or single
-complex versions of MUMPS are needed, then ScaLAPACK should
-then be used in place of PESSL.
-
 * LAM
   ---
 lam version 6.5.6 or greater is required for the double complex
@@ -419,9 +430,12 @@ due to truncated messages when using dou
 
 * CRAY
   ----
-On the CRAY, we recommend to link with the standard BLACS
-library from netlib, based on MPI. We observed problems
-(deadlock) when using the CRAY BLACS in host-node mode or
-when MUMPS is used on a subcommunicator of MPI_COMM_WORLD
+At least with old CRAY versions, we recommend to link with the
+standard BLACS library from netlib, based on MPI. We observed
+problems (deadlock) when using the CRAY BLACS in host-node mode
+or when MUMPS is used on a subcommunicator of MPI_COMM_WORLD
 of more than 1 processor.
+With recent Cray compilers, the flag -DMUMPS_ALLOC_FROM_C should
+be used, to avoid some Fortran pointer manipulations not allowed
+by the compiler.
 
diff -pruN 5.6.2-2.1/LICENSE 5.7.1-1/LICENSE
--- 5.6.2-2.1/LICENSE	2023-10-11 09:36:26.000000000 +0000
+++ 5.7.1-1/LICENSE	2024-05-02 10:15:09.000000000 +0000
@@ -1,5 +1,5 @@
 
-  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
   Mumps Technologies, University of Bordeaux.
 
   This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/MATLAB/make.inc 5.7.1-1/MATLAB/make.inc
--- 5.6.2-2.1/MATLAB/make.inc	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/MATLAB/make.inc	2024-05-02 10:15:12.000000000 +0000
@@ -12,7 +12,7 @@ MEX         = /opt/matlab/matlab/bin/mex
 # MEX         = mkoctfile -g --mex
 
 # Main MUMPS_DIR
-MUMPS_DIR = $(HOME)/MUMPS_5.6.2
+MUMPS_DIR = $(HOME)/MUMPS_5.7.1
 
 # Orderings (see main Makefile.inc file from MUMPS)
 LMETISDIR = ${HOME}/parmetis-4.0.3/build/Linux-x86_64/libmetis
diff -pruN 5.6.2-2.1/MATLAB/mumps_help.m 5.7.1-1/MATLAB/mumps_help.m
--- 5.6.2-2.1/MATLAB/mumps_help.m	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/MATLAB/mumps_help.m	2024-05-02 10:15:12.000000000 +0000
@@ -10,7 +10,7 @@
 %
 % - id.JOB: defines the action that will be realized by MUMPS: initialize, analyze and/or factorize and/or solve and release MUMPS internal C/Fortran data. It has to be set by the user before any call to MUMPS (except after a call to initmumps, which sets its value to -1).
 %
-% - id.ICNTL and id.CNTL: define control parameters that can be set after the initialization call (id.JOB = -1). See Section ``Control parameters'' of the MUMPS user's guide for more details. If the user does not modify an entry in id.ICNTL then MUMPS uses the default parameter. For example, if the user wants to use the AMD ordering, he/she should set id.ICNTL(7) = 0. Note that the following parameters are inhibited because they are automatically set within the interface: id.ICNTL(19) which controls the Schur complement option and id.ICNTL(20) which controls the format of the right-hand side. Note that parameters id.ICNTL(1:4) may not work properly depending on your compiler and your environment. In case of problem, we recommand to swith printing off by setting id.ICNL(1:4)=-1.
+% - id.ICNTL and id.CNTL: define control parameters that can be set after the initialization call (id.JOB = -1). See Section ``Control parameters'' of the MUMPS user's guide for more details. If the user does not modify an entry in id.ICNTL then MUMPS uses the default parameter. For example, if the user wants to use the AMD ordering, he/she should set id.ICNTL(7) = 0. Note that the following parameters are inhibited because they are automatically set within the interface: id.ICNTL(19) which controls the Schur complement option and id.ICNTL(20) which controls the format of the right-hand side. Some parameters related to distributed environments should not be modifed. For example, the solution should always be centralized and id.ICNTL(21) should thus remain to its default value, 0. Note that parameters id.ICNTL(1:4) may not work properly depending on your compiler and your environment. In case of problem, we recommand to swith printing off by setting id.ICNL(1:4)=-1.
 %
 % - id.PERM\_IN: corresponds to the given ordering option (see Section ``Input and output parameters'' of the MUMPS user's guide for more details). Note that this permutation is only accessed if the parameter id.ICNTL(7) is set to 1.
 %
diff -pruN 5.6.2-2.1/Make.inc/Makefile.FREEBSD10.PAR 5.7.1-1/Make.inc/Makefile.FREEBSD10.PAR
--- 5.6.2-2.1/Make.inc/Makefile.FREEBSD10.PAR	2023-10-11 09:36:26.000000000 +0000
+++ 5.7.1-1/Make.inc/Makefile.FREEBSD10.PAR	2024-05-02 10:15:09.000000000 +0000
@@ -1,6 +1,6 @@
 #
-#  This file is part of MUMPS 5.6.2, released
-#  on Wed Oct 11 09:36:25 UTC 2023
+#  This file is part of MUMPS 5.7.1, released
+#  on Thu May  2 10:15:09 UTC 2024
 #
 #Begin orderings
 
@@ -34,7 +34,7 @@
 
 LPORDDIR = $(topdir)/PORD/lib/
 IPORD    = -I$(topdir)/PORD/include/
-LPORD    = -L$(LPORDDIR) -lpord
+LPORD    = -L$(LPORDDIR) -lpord$(PLAT)
 
 #LMETISDIR = /opt/metis-5.1.0/build/Linux-x86_64/libmetis
 #IMETIS    = /opt/metis-5.1.0/include
@@ -68,6 +68,7 @@ PLAT    =
 LIBEXT  = .a
 LIBEXT_SHARED  = .so
 SONAME = -soname
+SHARED_OPT = -shared
 FPIC_OPT = -fPIC
 # Adapt/uncomment RPATH_OPT to avoid modifying
 # LD_LIBRARY_PATH in case of shared libraries
@@ -88,7 +89,7 @@ INCPAR  = -I/usr/local/include
 LIBPAR  = $(SCALAP) $(LAPACK) -L/usr/local/lib -lmpi
 
 INCSEQ  = -I$(topdir)/libseq
-LIBSEQ  = $(LAPACK) -L$(topdir)/libseq -lmpiseq
+LIBSEQ  = $(LAPACK) -L$(topdir)/libseq -lmpiseq$(PLAT)
 LIBBLAS = -lblas
 LIBOTHERS = -lpthread
 
diff -pruN 5.6.2-2.1/Make.inc/Makefile.FREEBSD10.SEQ 5.7.1-1/Make.inc/Makefile.FREEBSD10.SEQ
--- 5.6.2-2.1/Make.inc/Makefile.FREEBSD10.SEQ	2023-10-11 09:36:26.000000000 +0000
+++ 5.7.1-1/Make.inc/Makefile.FREEBSD10.SEQ	2024-05-02 10:15:09.000000000 +0000
@@ -1,6 +1,6 @@
 #
-#  This file is part of MUMPS 5.6.2, released
-#  on Wed Oct 11 09:36:25 UTC 2023
+#  This file is part of MUMPS 5.7.1, released
+#  on Thu May  2 10:15:09 UTC 2024
 #
 #Begin orderings
 
@@ -34,7 +34,7 @@
 
 LPORDDIR = $(topdir)/PORD/lib/
 IPORD    = -I$(topdir)/PORD/include/
-LPORD    = -L$(LPORDDIR) -lpord
+LPORD    = -L$(LPORDDIR) -lpord$(PLAT)
 
 #LMETISDIR = /opt/metis-5.1.0/build/Linux-x86_64/libmetis
 #IMETIS    = /opt/metis-5.1.0/include
@@ -68,6 +68,7 @@ PLAT    =
 LIBEXT  = .a
 LIBEXT_SHARED  = .so
 SONAME = -soname
+SHARED_OPT = -shared
 FPIC_OPT = -fPIC
 # Adapt/uncomment RPATH_OPT to avoid modifying
 # LD_LIBRARY_PATH in case of shared libraries
@@ -85,7 +86,7 @@ LAPACK  = -llapack
 
 
 INCSEQ  = -I$(topdir)/libseq
-LIBSEQ  = $(LAPACK) -L$(topdir)/libseq -lmpiseq
+LIBSEQ  = $(LAPACK) -L$(topdir)/libseq -lmpiseq$(PLAT)
 LIBBLAS = -lblas
 LIBOTHERS = -lpthread
 
diff -pruN 5.6.2-2.1/Make.inc/Makefile.G95.PAR 5.7.1-1/Make.inc/Makefile.G95.PAR
--- 5.6.2-2.1/Make.inc/Makefile.G95.PAR	2023-10-11 09:36:26.000000000 +0000
+++ 5.7.1-1/Make.inc/Makefile.G95.PAR	2024-05-02 10:15:09.000000000 +0000
@@ -1,6 +1,6 @@
 #
-#  This file is part of MUMPS 5.6.2, released
-#  on Wed Oct 11 09:36:25 UTC 2023
+#  This file is part of MUMPS 5.7.1, released
+#  on Thu May  2 10:15:09 UTC 2024
 #
 #Begin orderings
 
@@ -34,7 +34,7 @@
 
 LPORDDIR = $(topdir)/PORD/lib/
 IPORD    = -I$(topdir)/PORD/include/
-LPORD    = -L$(LPORDDIR) -lpord
+LPORD    = -L$(LPORDDIR) -lpord$(PLAT)
 
 #LMETISDIR = /opt/metis-5.1.0/build/Linux-x86_64/libmetis
 #IMETIS    = /opt/metis-5.1.0/include
@@ -68,6 +68,7 @@ PLAT =
 LIBEXT  = .a
 LIBEXT_SHARED  = .so
 SONAME = -soname
+SHARED_OPT = -shared
 FPIC_OPT = -fPIC
 # Adapt/uncomment RPATH_OPT to avoid modifying
 # LD_LIBRARY_PATH in case of shared libraries
@@ -87,7 +88,7 @@ INCPAR = -I/usr/local/mpich-1.2.7p1/incl
 LIBPAR = $(SCALAP) $(LAPACK) -L/usr/local/mpich-1.2.7p1/lib -lfmpich -lmpich
 
 INCSEQ = -I$(topdir)/libseq
-LIBSEQ  = $(LAPACK) -L$(topdir)/libseq -lmpiseq
+LIBSEQ  = $(LAPACK) -L$(topdir)/libseq -lmpiseq$(PLAT)
 
 #LIBBLAS = /usr/local/lib/libgoto_coppermine32p-r1.00.so
 LIBBLAS =/usr/local/ATLAS/lib/Linux_P4SSE2/libf77blas.a  /usr/local/ATLAS/lib/Linux_P4SSE2/libatlas.a -lg2c
diff -pruN 5.6.2-2.1/Make.inc/Makefile.G95.SEQ 5.7.1-1/Make.inc/Makefile.G95.SEQ
--- 5.6.2-2.1/Make.inc/Makefile.G95.SEQ	2023-10-11 09:36:26.000000000 +0000
+++ 5.7.1-1/Make.inc/Makefile.G95.SEQ	2024-05-02 10:15:09.000000000 +0000
@@ -1,6 +1,6 @@
 #
-#  This file is part of MUMPS 5.6.2, released
-#  on Wed Oct 11 09:36:25 UTC 2023
+#  This file is part of MUMPS 5.7.1, released
+#  on Thu May  2 10:15:09 UTC 2024
 #
 #Begin orderings
 
@@ -34,7 +34,7 @@
 
 LPORDDIR = $(topdir)/PORD/lib/
 IPORD    = -I$(topdir)/PORD/include/
-LPORD    = -L$(LPORDDIR) -lpord
+LPORD    = -L$(LPORDDIR) -lpord$(PLAT)
 
 #LMETISDIR = /opt/metis-5.1.0/build/Linux-x86_64/libmetis
 #IMETIS    = /opt/metis-5.1.0/include
@@ -68,6 +68,7 @@ PLAT =
 LIBEXT  = .a
 LIBEXT_SHARED  = .so
 SONAME = -soname
+SHARED_OPT = -shared
 FPIC_OPT = -fPIC
 # Adapt/uncomment RPATH_OPT to avoid modifying
 # LD_LIBRARY_PATH in case of shared libraries
@@ -84,7 +85,7 @@ RANLIB  = echo
 LAPACK =/usr/local/ATLAS/lib/Linux_P4SSE2/liblapack.a
 
 INCSEQ = -I$(topdir)/libseq
-LIBSEQ  = $(LAPACK) -L$(topdir)/libseq -lmpiseq
+LIBSEQ  = $(LAPACK) -L$(topdir)/libseq -lmpiseq$(PLAT)
 
 #LIBBLAS = /usr/local/lib/libgoto_coppermine32p-r1.00.so
 LIBBLAS =/usr/local/ATLAS/lib/Linux_P4SSE2/libf77blas.a  /usr/local/ATLAS/lib/Linux_P4SSE2/libatlas.a -lg2c
diff -pruN 5.6.2-2.1/Make.inc/Makefile.INTEL.PAR 5.7.1-1/Make.inc/Makefile.INTEL.PAR
--- 5.6.2-2.1/Make.inc/Makefile.INTEL.PAR	2023-10-11 09:36:26.000000000 +0000
+++ 5.7.1-1/Make.inc/Makefile.INTEL.PAR	2024-05-02 10:15:09.000000000 +0000
@@ -1,6 +1,6 @@
 #
-#  This file is part of MUMPS 5.6.2, released
-#  on Wed Oct 11 09:36:25 UTC 2023
+#  This file is part of MUMPS 5.7.1, released
+#  on Thu May  2 10:15:09 UTC 2024
 #
 #Begin orderings
 
@@ -34,7 +34,7 @@
 
 LPORDDIR = $(topdir)/PORD/lib/
 IPORD    = -I$(topdir)/PORD/include/
-LPORD    = -L$(LPORDDIR) -lpord
+LPORD    = -L$(LPORDDIR) -lpord$(PLAT)
 
 #LMETISDIR = /opt/metis-5.1.0/build/Linux-x86_64/libmetis
 #IMETIS    = /opt/metis-5.1.0/include
@@ -68,6 +68,7 @@ PLAT    =
 LIBEXT  = .a
 LIBEXT_SHARED  = .so
 SONAME = -soname
+SHARED_OPT = -shared
 FPIC_OPT = -fPIC
 # Adapt/uncomment RPATH_OPT to avoid modifying
 # LD_LIBRARY_PATH in case of shared libraries
@@ -90,7 +91,7 @@ SCALAP = -L$(MKLROOT) -lmkl_scalapack_lp
 LIBPAR = $(SCALAP) $(LAPACK)
 
 INCSEQ = -I$(topdir)/libseq
-LIBSEQ  = $(LAPACK) -L$(topdir)/libseq -lmpiseq
+LIBSEQ  = $(LAPACK) -L$(topdir)/libseq -lmpiseq$(PLAT)
 
 LIBBLAS = -L$(MKLROOT) -lmkl_intel_lp64 -lmkl_intel_thread -lmkl_core 
 LIBOTHERS = -lpthread
diff -pruN 5.6.2-2.1/Make.inc/Makefile.INTEL.SEQ 5.7.1-1/Make.inc/Makefile.INTEL.SEQ
--- 5.6.2-2.1/Make.inc/Makefile.INTEL.SEQ	2023-10-11 09:36:26.000000000 +0000
+++ 5.7.1-1/Make.inc/Makefile.INTEL.SEQ	2024-05-02 10:15:09.000000000 +0000
@@ -1,6 +1,6 @@
 #
-#  This file is part of MUMPS 5.6.2, released
-#  on Wed Oct 11 09:36:25 UTC 2023
+#  This file is part of MUMPS 5.7.1, released
+#  on Thu May  2 10:15:09 UTC 2024
 #
 #Begin orderings
 
@@ -34,7 +34,7 @@
 
 LPORDDIR = $(topdir)/PORD/lib/
 IPORD    = -I$(topdir)/PORD/include/
-LPORD    = -L$(LPORDDIR) -lpord
+LPORD    = -L$(LPORDDIR) -lpord$(PLAT)
 
 #LMETISDIR = /opt/metis-5.1.0/build/Linux-x86_64/libmetis
 #IMETIS    = /opt/metis-5.1.0/include
@@ -68,6 +68,7 @@ PLAT    =
 LIBEXT  = .a
 LIBEXT_SHARED  = .so
 SONAME = -soname
+SHARED_OPT = -shared
 FPIC_OPT = -fPIC
 # Adapt/uncomment RPATH_OPT to avoid modifying
 # LD_LIBRARY_PATH in case of shared libraries
@@ -88,7 +89,7 @@ LAPACK = -L$(MKLROOT) -lmkl_intel_lp64 -
 
 
 INCSEQ = -I$(topdir)/libseq
-LIBSEQ  = $(LAPACK) -L$(topdir)/libseq -lmpiseq
+LIBSEQ  = $(LAPACK) -L$(topdir)/libseq -lmpiseq$(PLAT)
 
 LIBBLAS = -L$(MKLROOT) -lmkl_intel_lp64 -lmkl_intel_thread -lmkl_core 
 LIBOTHERS = -lpthread
diff -pruN 5.6.2-2.1/Make.inc/Makefile.NEC.PAR 5.7.1-1/Make.inc/Makefile.NEC.PAR
--- 5.6.2-2.1/Make.inc/Makefile.NEC.PAR	2023-10-11 09:36:26.000000000 +0000
+++ 5.7.1-1/Make.inc/Makefile.NEC.PAR	2024-05-02 10:15:09.000000000 +0000
@@ -1,6 +1,6 @@
 #
-#  This file is part of MUMPS 5.6.2, released
-#  on Wed Oct 11 09:36:25 UTC 2023
+#  This file is part of MUMPS 5.7.1, released
+#  on Thu May  2 10:15:09 UTC 2024
 #
 #
 #Begin orderings
@@ -35,7 +35,7 @@
 
 LPORDDIR = $(topdir)/PORD/lib/
 IPORD    = -I$(topdir)/PORD/include/
-LPORD    = -L$(LPORDDIR) -lpord
+LPORD    = -L$(LPORDDIR) -lpord$(PLAT)
 
 #
 # The following section deals with Vector Host offloading of scalar code
@@ -85,6 +85,7 @@ PLAT    =
 LIBEXT  = .a
 LIBEXT_SHARED  = .so
 SONAME = -soname
+SHARED_OPT = -shared
 FPIC_OPT = -fPIC
 # Adapt/uncomment RPATH_OPT to avoid modifying
 # LD_LIBRARY_PATH in case of shared libraries
diff -pruN 5.6.2-2.1/Make.inc/Makefile.NEC.SEQ 5.7.1-1/Make.inc/Makefile.NEC.SEQ
--- 5.6.2-2.1/Make.inc/Makefile.NEC.SEQ	2023-10-11 09:36:26.000000000 +0000
+++ 5.7.1-1/Make.inc/Makefile.NEC.SEQ	2024-05-02 10:15:09.000000000 +0000
@@ -1,6 +1,6 @@
 #
-#  This file is part of MUMPS 5.6.2, released
-#  on Wed Oct 11 09:36:25 UTC 2023
+#  This file is part of MUMPS 5.7.1, released
+#  on Thu May  2 10:15:09 UTC 2024
 #
 #Begin orderings
 
@@ -34,7 +34,7 @@
 
 LPORDDIR = $(topdir)/PORD/lib/
 IPORD    = -I$(topdir)/PORD/include/
-LPORD    = -L$(LPORDDIR) -lpord
+LPORD    = -L$(LPORDDIR) -lpord$(PLAT)
 
 #
 # The following section deals with Vector Host offloading of scalar code
@@ -84,6 +84,7 @@ PLAT    =
 LIBEXT  = .a
 LIBEXT_SHARED  = .so
 SONAME = -soname
+SHARED_OPT = -shared
 FPIC_OPT = -fPIC
 # Adapt/uncomment RPATH_OPT to avoid modifying
 # LD_LIBRARY_PATH in case of shared libraries
@@ -101,7 +102,7 @@ LAPACK  = -llapack
 
 
 INCSEQ  = -I$(topdir)/libseq
-LIBSEQ  = $(LAPACK) -L$(topdir)/libseq -lmpiseq
+LIBSEQ  = $(LAPACK) -L$(topdir)/libseq -lmpiseq$(PLAT)
 
 LIBBLAS = -lblas_openmp
 LIBOTHERS = -lpthread
diff -pruN 5.6.2-2.1/Make.inc/Makefile.SGI.PAR 5.7.1-1/Make.inc/Makefile.SGI.PAR
--- 5.6.2-2.1/Make.inc/Makefile.SGI.PAR	2023-10-11 09:36:26.000000000 +0000
+++ 5.7.1-1/Make.inc/Makefile.SGI.PAR	2024-05-02 10:15:09.000000000 +0000
@@ -1,6 +1,6 @@
 #
-#  This file is part of MUMPS 5.6.2, released
-#  on Wed Oct 11 09:36:25 UTC 2023
+#  This file is part of MUMPS 5.7.1, released
+#  on Thu May  2 10:15:09 UTC 2024
 #
 #Begin orderings
 
@@ -34,7 +34,7 @@
 
 LPORDDIR = $(topdir)/PORD/lib/
 IPORD    = -I$(topdir)/PORD/include/
-LPORD    = -L$(LPORDDIR) -lpord
+LPORD    = -L$(LPORDDIR) -lpord$(PLAT)
 
 #LMETISDIR = /opt/metis-5.1.0/build/Linux-x86_64/libmetis
 #IMETIS    = /opt/metis-5.1.0/include
@@ -68,6 +68,7 @@ PLAT    =
 LIBEXT  = .a
 LIBEXT_SHARED  = .so
 SONAME = -soname
+SHARED_OPT = -shared
 FPIC_OPT = -fPIC
 # Adapt/uncomment RPATH_OPT to avoid modifying
 # LD_LIBRARY_PATH in case of shared libraries
@@ -85,7 +86,7 @@ SCALAP  = -L/usr/lib64 -lscalapack64 -lm
 INCPAR = -I/usr/include/
 LIBPAR = $(SCALAP) $(LAPACK) -L/usr/lib64/ -lmpi
 INCSEQ = -I$(topdir)/libseq
-LIBSEQ  = $(LAPACK) -L$(topdir)/libseq -lmpiseq
+LIBSEQ  = $(LAPACK) -L$(topdir)/libseq -lmpiseq$(PLAT)
 LIBBLAS = -lblas
 LIBOTHERS = -lpthread
 #Preprocessor defs for calling Fortran from C (-DAdd_ or -DAdd__ or -DUPPER)
diff -pruN 5.6.2-2.1/Make.inc/Makefile.SGI.SEQ 5.7.1-1/Make.inc/Makefile.SGI.SEQ
--- 5.6.2-2.1/Make.inc/Makefile.SGI.SEQ	2023-10-11 09:36:26.000000000 +0000
+++ 5.7.1-1/Make.inc/Makefile.SGI.SEQ	2024-05-02 10:15:09.000000000 +0000
@@ -1,6 +1,6 @@
 #
-#  This file is part of MUMPS 5.6.2, released
-#  on Wed Oct 11 09:36:25 UTC 2023
+#  This file is part of MUMPS 5.7.1, released
+#  on Thu May  2 10:15:09 UTC 2024
 #
 #Begin orderings
 
@@ -34,7 +34,7 @@
 
 LPORDDIR = $(topdir)/PORD/lib/
 IPORD    = -I$(topdir)/PORD/include/
-LPORD    = -L$(LPORDDIR) -lpord
+LPORD    = -L$(LPORDDIR) -lpord$(PLAT)
 
 #LMETISDIR = /opt/metis-5.1.0/build/Linux-x86_64/libmetis
 #IMETIS    = /opt/metis-5.1.0/include
@@ -68,6 +68,7 @@ PLAT    =
 LIBEXT  = .a
 LIBEXT_SHARED  = .so
 SONAME = -soname
+SHARED_OPT = -shared
 FPIC_OPT = -fPIC
 # Adapt/uncomment RPATH_OPT to avoid modifying
 # LD_LIBRARY_PATH in case of shared libraries
@@ -82,7 +83,7 @@ AR = ar vr
 RANLIB  = echo
 LAPACK  = /usr/lib64/libcomplib.sgimath.so
 INCSEQ = -I$(topdir)/libseq
-LIBSEQ  = $(LAPACK) -L$(topdir)/libseq -lmpiseq
+LIBSEQ  = $(LAPACK) -L$(topdir)/libseq -lmpiseq$(PLAT)
 LIBBLAS = -lblas
 LIBOTHERS = -lpthread
 #Preprocessor defs for calling Fortran from C (-DAdd_ or -DAdd__ or -DUPPER)
diff -pruN 5.6.2-2.1/Make.inc/Makefile.SP64.PAR 5.7.1-1/Make.inc/Makefile.SP64.PAR
--- 5.6.2-2.1/Make.inc/Makefile.SP64.PAR	2023-10-11 09:36:26.000000000 +0000
+++ 5.7.1-1/Make.inc/Makefile.SP64.PAR	2024-05-02 10:15:09.000000000 +0000
@@ -1,6 +1,6 @@
 #
-#  This file is part of MUMPS 5.6.2, released
-#  on Wed Oct 11 09:36:25 UTC 2023
+#  This file is part of MUMPS 5.7.1, released
+#  on Thu May  2 10:15:09 UTC 2024
 #
 #Begin orderings
 
@@ -34,7 +34,7 @@
 
 LPORDDIR = $(topdir)/PORD/lib/
 IPORD    = -I$(topdir)/PORD/include/
-LPORD    = -L$(LPORDDIR) -lpord
+LPORD    = -L$(LPORDDIR) -lpord$(PLAT)
 
 #LMETISDIR = /opt/metis-5.1.0/build/Linux-x86_64/libmetis
 #IMETIS    = /opt/metis-5.1.0/include
@@ -69,6 +69,7 @@ PLAT    =
 LIBEXT  = .a
 LIBEXT_SHARED  = .so
 SONAME = -soname
+SHARED_OPT = -shared
 FPIC_OPT = -fPIC
 # Adapt/uncomment RPATH_OPT to avoid modifying
 # LD_LIBRARY_PATH in case of shared libraries
@@ -91,7 +92,7 @@ SCALAP  = -lpesslsmp -lblacssmp
 INCPAR  = # -I/usr/lpp/ppe.poe/include
 LIBPAR  = $(SCALAP) $(LAPACK) # -L/usr/lpp/ppe.poe/lib -lmpi
 INCSEQ  = -I$(topdir)/libseq
-LIBSEQ  = $(LAPACK) -L$(topdir)/libseq -lmpiseq
+LIBSEQ  = $(LAPACK) -L$(topdir)/libseq -lmpiseq$(PLAT)
 LIBBLAS = -lessl
 LIBOTHERS = -lpthread
 #Preprocessor defs for calling Fortran from C (-DAdd_ or -DAdd__ or -DUPPER)
diff -pruN 5.6.2-2.1/Make.inc/Makefile.SP64.SEQ 5.7.1-1/Make.inc/Makefile.SP64.SEQ
--- 5.6.2-2.1/Make.inc/Makefile.SP64.SEQ	2023-10-11 09:36:26.000000000 +0000
+++ 5.7.1-1/Make.inc/Makefile.SP64.SEQ	2024-05-02 10:15:09.000000000 +0000
@@ -1,6 +1,6 @@
 #
-#  This file is part of MUMPS 5.6.2, released
-#  on Wed Oct 11 09:36:25 UTC 2023
+#  This file is part of MUMPS 5.7.1, released
+#  on Thu May  2 10:15:09 UTC 2024
 #
 #Begin orderings
 
@@ -34,7 +34,7 @@
 
 LPORDDIR = $(topdir)/PORD/lib/
 IPORD    = -I$(topdir)/PORD/include/
-LPORD    = -L$(LPORDDIR) -lpord
+LPORD    = -L$(LPORDDIR) -lpord$(PLAT)
 
 #LMETISDIR = /opt/metis-5.1.0/build/Linux-x86_64/libmetis
 #IMETIS    = /opt/metis-5.1.0/include
@@ -69,6 +69,7 @@ PLAT    =
 LIBEXT  = .a
 LIBEXT_SHARED  = .so
 SONAME = -soname
+SHARED_OPT = -shared
 FPIC_OPT = -fPIC
 # Adapt/uncomment RPATH_OPT to avoid modifying
 # LD_LIBRARY_PATH in case of shared libraries
@@ -88,7 +89,7 @@ LAPACK  = /usr/local/pub/LAPACK/lapack.a
 
 
 INCSEQ  = -I$(topdir)/libseq
-LIBSEQ  = $(LAPACK) -L$(topdir)/libseq -lmpiseq
+LIBSEQ  = $(LAPACK) -L$(topdir)/libseq -lmpiseq$(PLAT)
 LIBBLAS = -lessl
 LIBOTHERS = -lpthread
 #Preprocessor defs for calling Fortran from C (-DAdd_ or -DAdd__ or -DUPPER)
diff -pruN 5.6.2-2.1/Make.inc/Makefile.SUN.PAR 5.7.1-1/Make.inc/Makefile.SUN.PAR
--- 5.6.2-2.1/Make.inc/Makefile.SUN.PAR	2023-10-11 09:36:26.000000000 +0000
+++ 5.7.1-1/Make.inc/Makefile.SUN.PAR	2024-05-02 10:15:09.000000000 +0000
@@ -1,6 +1,6 @@
 #
-#  This file is part of MUMPS 5.6.2, released
-#  on Wed Oct 11 09:36:25 UTC 2023
+#  This file is part of MUMPS 5.7.1, released
+#  on Thu May  2 10:15:09 UTC 2024
 #
 #Begin orderings
 
@@ -34,7 +34,7 @@
 
 LPORDDIR = $(topdir)/PORD/lib/
 IPORD    = -I$(topdir)/PORD/include/
-LPORD    = -L$(LPORDDIR) -lpord
+LPORD    = -L$(LPORDDIR) -lpord$(PLAT)
 
 #LMETISDIR = /opt/metis-5.1.0/build/Linux-x86_64/libmetis
 #IMETIS    = /opt/metis-5.1.0/include
@@ -68,6 +68,7 @@ PLAT    =
 LIBEXT  = .a
 LIBEXT_SHARED  = .so
 SONAME = -soname
+SHARED_OPT = -shared
 FPIC_OPT = -fPIC
 # Adapt/uncomment RPATH_OPT to avoid modifying
 # LD_LIBRARY_PATH in case of shared libraries
@@ -87,7 +88,7 @@ SCALAP  = -ls3l -lhpcshm
 INCPAR  = -I/opt/SUNWhpc/include
 LIBPAR  = -L/opt/SUNWhpc/lib -R/opt/SUNWhpc/lib $(SCALAP) $(LAPACK) -lmpi 
 INCSEQ  = -I$(topdir)/libseq
-LIBSEQ  = $(LAPACK) -L$(topdir)/libseq -lmpiseq
+LIBSEQ  = $(LAPACK) -L$(topdir)/libseq -lmpiseq$(PLAT)
 LIBBLAS = -lsunperf -lf77compat
 LIBOTHERS = -lpthread
 #Preprocessor defs for calling Fortran from C (-DAdd_ or -DAdd__ or -DUPPER)
diff -pruN 5.6.2-2.1/Make.inc/Makefile.SUN.SEQ 5.7.1-1/Make.inc/Makefile.SUN.SEQ
--- 5.6.2-2.1/Make.inc/Makefile.SUN.SEQ	2023-10-11 09:36:26.000000000 +0000
+++ 5.7.1-1/Make.inc/Makefile.SUN.SEQ	2024-05-02 10:15:09.000000000 +0000
@@ -1,6 +1,6 @@
 #
-#  This file is part of MUMPS 5.6.2, released
-#  on Wed Oct 11 09:36:25 UTC 2023
+#  This file is part of MUMPS 5.7.1, released
+#  on Thu May  2 10:15:09 UTC 2024
 #
 #Begin orderings
 
@@ -34,7 +34,7 @@
 
 LPORDDIR = $(topdir)/PORD/lib/
 IPORD    = -I$(topdir)/PORD/include/
-LPORD    = -L$(LPORDDIR) -lpord
+LPORD    = -L$(LPORDDIR) -lpord$(PLAT)
 
 #LMETISDIR = /opt/metis-5.1.0/build/Linux-x86_64/libmetis
 #IMETIS    = /opt/metis-5.1.0/include
@@ -68,6 +68,7 @@ PLAT    =
 LIBEXT  = .a
 LIBEXT_SHARED  = .so
 SONAME = -soname
+SHARED_OPT = -shared
 FPIC_OPT = -fPIC
 # Adapt/uncomment RPATH_OPT to avoid modifying
 # LD_LIBRARY_PATH in case of shared libraries
@@ -84,7 +85,7 @@ RANLIB = echo
 
 LAPACK  = #included in SunPerf
 INCSEQ  = -I$(topdir)/libseq
-LIBSEQ  = $(LAPACK) -L$(topdir)/libseq -lmpiseq
+LIBSEQ  = $(LAPACK) -L$(topdir)/libseq -lmpiseq$(PLAT)
 LIBBLAS = -lsunperf -lf77compat
 LIBOTHERS = -lpthread
 #Preprocessor defs for calling Fortran from C (-DAdd_ or -DAdd__ or -DUPPER)
diff -pruN 5.6.2-2.1/Make.inc/Makefile.WIN.MS-G95.SEQ 5.7.1-1/Make.inc/Makefile.WIN.MS-G95.SEQ
--- 5.6.2-2.1/Make.inc/Makefile.WIN.MS-G95.SEQ	2023-10-11 09:36:26.000000000 +0000
+++ 5.7.1-1/Make.inc/Makefile.WIN.MS-G95.SEQ	2024-05-02 10:15:09.000000000 +0000
@@ -1,6 +1,6 @@
 #
-#  This file is part of MUMPS 5.6.2, released
-#  on Wed Oct 11 09:36:25 UTC 2023
+#  This file is part of MUMPS 5.7.1, released
+#  on Thu May  2 10:15:09 UTC 2024
 #
 # We are grateful to Evgenii Rudnyi for his help and suggestions
 # regarding Windows installation.
@@ -38,7 +38,7 @@
 LPORDDIR = $(topdir)/PORD/lib/
 IPORD    = -I$(topdir)/PORD/include/
 PATHPORD = -LIBPATH:$(LPORDDIR)
-LPORD    = libpord.lib
+LPORD    = libpord$(PLAT).lib
 
 #LMETISDIR = /opt/metis-5.1.0/build/Linux-x86_64/libmetis
 #PATHMETIS = -LIBPATH:$(LMETISDIR)
@@ -76,6 +76,7 @@ PLAT    =
 LIBEXT  = .lib
 LIBEXT_SHARED  = .so
 SONAME = -soname
+SHARED_OPT = -shared
 #FPIC_OPT = -fPIC
 #RPATH_OPT
 OUTC    = -Fo
@@ -89,7 +90,7 @@ RANLIB  = echo
 
 
 INCSEQ  = -I$(topdir)/libseq
-LIBSEQ  = $(topdir)/libseq/libmpiseq.lib
+LIBSEQ  = $(topdir)/libseq/libmpiseq$(PLAT).lib
 
 LIBBLAS = mkl_intel_c.lib mkl_intel_thread.lib mkl_core.lib libiomp5md.lib
 LIBOTHERS = libf95.lib libgcc.lib -link $(PATHORDERINGS)
diff -pruN 5.6.2-2.1/Make.inc/Makefile.WIN.MS-Intel.SEQ 5.7.1-1/Make.inc/Makefile.WIN.MS-Intel.SEQ
--- 5.6.2-2.1/Make.inc/Makefile.WIN.MS-Intel.SEQ	2023-10-11 09:36:26.000000000 +0000
+++ 5.7.1-1/Make.inc/Makefile.WIN.MS-Intel.SEQ	2024-05-02 10:15:09.000000000 +0000
@@ -1,6 +1,6 @@
 #
-#  This file is part of MUMPS 5.6.2, released
-#  on Wed Oct 11 09:36:25 UTC 2023
+#  This file is part of MUMPS 5.7.1, released
+#  on Thu May  2 10:15:09 UTC 2024
 #
 # We are grateful to Evgenii Rudnyi for his help and suggestions
 # regarding Windows installation.
@@ -38,7 +38,7 @@
 LPORDDIR = $(topdir)/PORD/lib/
 IPORD    = -I$(topdir)/PORD/include/
 PATHPORD = -LIBPATH:$(LPORDDIR)
-LPORD    = libpord.lib
+LPORD    = libpord$(PLAT).lib
 
 #LMETISDIR = /opt/metis-5.1.0/build/Linux-x86_64/libmetis
 #PATHMETIS = -LIBPATH:$(LMETISDIR)
@@ -76,6 +76,7 @@ PLAT    =
 LIBEXT  = .lib
 LIBEXT_SHARED  = .so
 SONAME = -soname
+SHARED_OPT = -shared
 #FPIC_OPT = -fPIC
 #RPATH_OPT
 OUTC    = -Fo
@@ -88,7 +89,7 @@ AR      = lib -out:
 #RANLIB = ranlib
 RANLIB  = echo
 INCSEQ  = -I$(topdir)/libseq
-LIBSEQ  = $(topdir)/libseq/libmpiseq.lib
+LIBSEQ  = $(topdir)/libseq/libmpiseq$(PLAT).lib
 #LIBBLAS = -L/usr/lib/xmm/ -lf77blas -latlas
 #LIBBLAS = -L/local/BLAS -lblas
 LIBBLAS = mkl_intel_c.lib mkl_intel_thread.lib mkl_core.lib libiomp5md.lib
diff -pruN 5.6.2-2.1/Make.inc/Makefile.debian.PAR 5.7.1-1/Make.inc/Makefile.debian.PAR
--- 5.6.2-2.1/Make.inc/Makefile.debian.PAR	2023-10-11 09:36:26.000000000 +0000
+++ 5.7.1-1/Make.inc/Makefile.debian.PAR	2024-05-02 10:15:09.000000000 +0000
@@ -1,6 +1,6 @@
 #
-#  This file is part of MUMPS 5.6.2, released
-#  on Wed Oct 11 09:36:25 UTC 2023
+#  This file is part of MUMPS 5.7.1, released
+#  on Thu May  2 10:15:09 UTC 2024
 #
 # These settings for a PC under Debian/linux with standard packages :
 # metis (parmetis), scotch (ptscotch), openmpi, gfortran
@@ -17,7 +17,7 @@ LSCOTCH   = -L$(LSCOTCHDIR) -lesmumps -l
 
 LPORDDIR = $(topdir)/PORD/lib/
 IPORD    = -I$(topdir)/PORD/include/
-LPORD    = -L$(LPORDDIR) -lpord
+LPORD    = -L$(LPORDDIR) -lpord$(PLAT)
 
 LMETISDIR = /usr/lib 
 #IMETIS    = -I/usr/include/parmetis
@@ -40,6 +40,7 @@ IORDERINGSC = $(IMETIS) $(IPORD) $(ISCOT
 PLAT    =
 LIBEXT_SHARED  = .so
 SONAME = -soname
+SHARED_OPT = -shared
 FPIC_OPT = -fPIC
 # Adapt/uncomment RPATH_OPT to avoid modifying
 # LD_LIBRARY_PATH in case of shared libraries
@@ -61,7 +62,7 @@ INCPAR = # not needed with mpif90/mpicc:
 LIBPAR = $(SCALAP) $(LAPACK) # not needed with mpif90/mpicc: -lmpi_mpifh -lmpi
 
 INCSEQ = -I$(topdir)/libseq
-LIBSEQ  = $(LAPACK) -L$(topdir)/libseq -lmpiseq
+LIBSEQ  = $(LAPACK) -L$(topdir)/libseq -lmpiseq$(PLAT)
 
 LIBBLAS = -lblas
 LIBOTHERS = -lpthread
@@ -70,9 +71,9 @@ LIBOTHERS = -lpthread
 CDEFS   = -DAdd_
 
 #Begin Optimized options
-OPTF    = -O -fopenmp
-# Use the line below if your version of gfortran is >= 10
-#OPTF    = -O -fopenmp -fallow-argument-mismatch
+OPTF    = -O -fopenmp -fallow-argument-mismatch
+# Uncomment the line below if your version of gfortran is < 10
+#OPTF    = -O -fopenmp
 OPTL    = -O -fopenmp
 OPTC    = -O -fopenmp
 #End Optimized options
diff -pruN 5.6.2-2.1/Make.inc/Makefile.debian.SEQ 5.7.1-1/Make.inc/Makefile.debian.SEQ
--- 5.6.2-2.1/Make.inc/Makefile.debian.SEQ	2023-10-11 09:36:26.000000000 +0000
+++ 5.7.1-1/Make.inc/Makefile.debian.SEQ	2024-05-02 10:15:09.000000000 +0000
@@ -1,6 +1,6 @@
 #
-#  This file is part of MUMPS 5.6.2, released
-#  on Wed Oct 11 09:36:25 UTC 2023
+#  This file is part of MUMPS 5.7.1, released
+#  on Thu May  2 10:15:09 UTC 2024
 #
 # These settings for a PC under Debian/linux with standard packages :
 # metis (parmetis), scotch (ptscotch), openmpi, gfortran
@@ -17,7 +17,7 @@ LSCOTCH   = -L$(LSCOTCHDIR) -lesmumps -l
 
 LPORDDIR = $(topdir)/PORD/lib/
 IPORD    = -I$(topdir)/PORD/include/
-LPORD    = -L$(LPORDDIR) -lpord
+LPORD    = -L$(LPORDDIR) -lpord$(PLAT)
 
 LMETISDIR = /usr/lib 
 #IMETIS    = -I/usr/include/parmetis
@@ -40,6 +40,7 @@ IORDERINGSC = $(IMETIS) $(IPORD) $(ISCOT
 PLAT    =
 LIBEXT_SHARED  = .so
 SONAME = -soname
+SHARED_OPT = -shared
 FPIC_OPT = -fPIC
 # Adapt/uncomment RPATH_OPT to avoid modifying
 # LD_LIBRARY_PATH in case of shared libraries
@@ -58,7 +59,7 @@ LAPACK = -llapack
 
 
 INCSEQ = -I$(topdir)/libseq
-LIBSEQ  = $(LAPACK) -L$(topdir)/libseq -lmpiseq
+LIBSEQ  = $(LAPACK) -L$(topdir)/libseq -lmpiseq$(PLAT)
 
 LIBBLAS = -lblas
 LIBOTHERS = -lpthread
@@ -67,9 +68,9 @@ LIBOTHERS = -lpthread
 CDEFS   = -DAdd_
 
 #Begin Optimized options
-OPTF    = -O -fopenmp
-# Use the line below if your version of gfortran is >= 10
-#OPTF    = -O -fopenmp -fallow-argument-mismatch
+OPTF    = -O -fopenmp -fallow-argument-mismatch
+# Uncomment the line below if your version of gfortran is < 10
+#OPTF    = -O -fopenmp
 OPTL    = -O -fopenmp
 OPTC    = -O -fopenmp
 #End Optimized options
diff -pruN 5.6.2-2.1/Make.inc/Makefile.inc.generic 5.7.1-1/Make.inc/Makefile.inc.generic
--- 5.6.2-2.1/Make.inc/Makefile.inc.generic	2023-10-11 09:36:26.000000000 +0000
+++ 5.7.1-1/Make.inc/Makefile.inc.generic	2024-05-02 10:15:09.000000000 +0000
@@ -1,6 +1,6 @@
 #
-#  This file is part of MUMPS 5.6.2, released
-#  on Wed Oct 11 09:36:25 UTC 2023
+#  This file is part of MUMPS 5.7.1, released
+#  on Thu May  2 10:15:09 UTC 2024
 #
 ################################################################################
 #
@@ -55,7 +55,7 @@
 
 LPORDDIR = $(topdir)/PORD/lib/
 IPORD    = -I$(topdir)/PORD/include/
-LPORD    = -L$(LPORDDIR) -lpord
+LPORD    = -L$(LPORDDIR) -lpord$(PLAT)
 
 #LMETISDIR = /opt/metis-5.1.0/build/Linux-x86_64/libmetis
 #IMETIS    = /opt/metis-5.1.0/include
@@ -89,8 +89,15 @@ IORDERINGSC = $(IMETIS) $(IPORD) $(ISCOT
 
 # PLAT : use it to add a default suffix to the generated libraries
 PLAT    = 
-# Library extension, + C and Fortran "-o" option
-# may be different under Windows
+# Suffix for libraries, -soname and -fPIC options, C and Fortran "-o" option
+# may be adapted
+LIBEXT_SHARED  = .so
+SONAME = -soname
+SHARED_OPT = -shared
+FPIC_OPT = -fPIC
+# Adapt/uncomment RPATH_OPT to avoid modifying
+# LD_LIBRARY_PATH in case of shared libraries
+# RPATH_OPT = -Wl,-rpath,/path/to/MUMPS_x.y.z/lib/
 LIBEXT  = .a
 OUTC    = -o 
 OUTF    = -o 
@@ -127,7 +134,7 @@ LIBPAR  = $(SCALAP) $(LAPACK) -L/usr/lib
 # They are related to the sequential library provided by MUMPS,
 # to use instead of ScaLAPACK and MPI.
 INCSEQ  = -I$(topdir)/libseq
-LIBSEQ  = $(LAPACK) -L$(topdir)/libseq -lmpiseq
+LIBSEQ  = $(LAPACK) -L$(topdir)/libseq -lmpiseq$(PLAT)
 
 # DEFINE HERE YOUR BLAS LIBRARY
 
diff -pruN 5.6.2-2.1/Make.inc/Makefile.inc.generic.SEQ 5.7.1-1/Make.inc/Makefile.inc.generic.SEQ
--- 5.6.2-2.1/Make.inc/Makefile.inc.generic.SEQ	2023-10-11 09:36:26.000000000 +0000
+++ 5.7.1-1/Make.inc/Makefile.inc.generic.SEQ	2024-05-02 10:15:09.000000000 +0000
@@ -1,6 +1,6 @@
 #
-#  This file is part of MUMPS 5.6.2, released
-#  on Wed Oct 11 09:36:25 UTC 2023
+#  This file is part of MUMPS 5.7.1, released
+#  on Thu May  2 10:15:09 UTC 2024
 #
 ################################################################################
 #
@@ -58,7 +58,7 @@
 
 LPORDDIR = $(topdir)/PORD/lib/
 IPORD    = -I$(topdir)/PORD/include/
-LPORD    = -L$(LPORDDIR) -lpord
+LPORD    = -L$(LPORDDIR) -lpord$(PLAT)
 
 #LMETISDIR = /opt/metis-5.1.0/build/Linux-x86_64/libmetis
 #IMETIS    = /opt/metis-5.1.0/include
@@ -92,8 +92,15 @@ IORDERINGSC = $(IMETIS) $(IPORD) $(ISCOT
 
 # PLAT : use it to add a default suffix to the generated libraries
 PLAT    = 
-# Library extension, + C and Fortran "-o" option
-# may be different under Windows
+# Suffix for libraries, -soname and -fPIC options, C and Fortran "-o" option
+# may be adapted
+LIBEXT_SHARED  = .so
+SONAME = -soname
+SHARED_OPT = -shared
+FPIC_OPT = -fPIC
+# Adapt/uncomment RPATH_OPT to avoid modifying
+# LD_LIBRARY_PATH in case of shared libraries
+# RPATH_OPT = -Wl,-rpath,/path/to/MUMPS_x.y.z/lib/
 LIBEXT  = .a
 OUTC    = -o 
 OUTF    = -o 
@@ -120,7 +127,7 @@ LAPACK = -llapack
 # the sequential library provided by MUMPS, to use instead
 # of ScaLAPACK and MPI.
 INCSEQ  = -I$(topdir)/libseq
-LIBSEQ  = $(LAPACK) -L$(topdir)/libseq -lmpiseq
+LIBSEQ  = $(LAPACK) -L$(topdir)/libseq -lmpiseq$(PLAT)
 
 # DEFINE HERE YOUR BLAS LIBRARY
 
diff -pruN 5.6.2-2.1/Makefile 5.7.1-1/Makefile
--- 5.6.2-2.1/Makefile	2023-10-11 09:36:26.000000000 +0000
+++ 5.7.1-1/Makefile	2024-05-02 10:15:09.000000000 +0000
@@ -1,6 +1,6 @@
 #
-#  This file is part of MUMPS 5.6.2, released
-#  on Wed Oct 11 09:36:25 UTC 2023
+#  This file is part of MUMPS 5.7.1, released
+#  on Thu May  2 10:15:09 UTC 2024
 #
 topdir = .
 libdir = $(topdir)/lib
diff -pruN 5.6.2-2.1/PORD/lib/Makefile 5.7.1-1/PORD/lib/Makefile
--- 5.6.2-2.1/PORD/lib/Makefile	2023-10-11 09:36:26.000000000 +0000
+++ 5.7.1-1/PORD/lib/Makefile	2024-05-02 10:15:09.000000000 +0000
@@ -7,6 +7,8 @@
 # RANLIB must be passed to make.
 #
 
+.PHONY: clean realclean
+
 INCLUDES = -I../include
 
 COPTIONS = $(INCLUDES) $(CFLAGS) $(OPTFLAGS) $(FPIC)
diff -pruN 5.6.2-2.1/README 5.7.1-1/README
--- 5.6.2-2.1/README	2023-10-11 09:36:26.000000000 +0000
+++ 5.7.1-1/README	2024-05-02 10:15:09.000000000 +0000
@@ -1,8 +1,8 @@
 ===========================================
-MUMPS 5.6.2
+MUMPS 5.7.1
 ===========================================
 
-MUMPS 5.6.2 solves a sparse system of linear equations A x = b
+MUMPS 5.7.1 solves a sparse system of linear equations A x = b
 using Gaussian elimination. Please read this README file and
 the documentation (in ./doc/) for a complete list of
 functionalities. Documentation and publications related
diff -pruN 5.6.2-2.1/SCILAB/Help/help_dmumps.html 5.7.1-1/SCILAB/Help/help_dmumps.html
--- 5.6.2-2.1/SCILAB/Help/help_dmumps.html	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/SCILAB/Help/help_dmumps.html	2024-05-02 10:15:12.000000000 +0000
@@ -44,6 +44,9 @@ of the MUMPS user's guide
       within the interface: id.ICNTL(19) which controls the Schur 
       complement option and id.ICNTL(20) which controls the 
       format of the right-hand side.
+      Some parameters related to distributed environments should not be modifed.
+      For example, the solution should always be centralized and id.ICNTL(21)
+      should thus remain to its default value, 0.
       Note that parameters id.ICNTL(1:4) may not work properly
       depending on your compiler and your environment. In case of
       problem, we recommand to swith printing off by setting
diff -pruN 5.6.2-2.1/SCILAB/Help/help_dmumps.xml 5.7.1-1/SCILAB/Help/help_dmumps.xml
--- 5.6.2-2.1/SCILAB/Help/help_dmumps.xml	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/SCILAB/Help/help_dmumps.xml	2024-05-02 10:15:12.000000000 +0000
@@ -57,6 +57,9 @@ of the MUMPS user's guide
       within the interface: id.ICNTL(19) which controls the Schur 
       complement option and id.ICNTL(20) which controls the 
       format of the right-hand side.
+      Some parameters related to distributed environments should not be modifed.
+      For example, the solution should always be centralized and id.ICNTL(21)
+      should thus remain to its default value, 0.
       Note that parameters id.ICNTL(1:4) may not work properly
       depending on your compiler and your environment. In case of
       problem, we recommand to swith printing off by setting
diff -pruN 5.6.2-2.1/SCILAB/Help/help_zmumps.html 5.7.1-1/SCILAB/Help/help_zmumps.html
--- 5.6.2-2.1/SCILAB/Help/help_zmumps.html	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/SCILAB/Help/help_zmumps.html	2024-05-02 10:15:12.000000000 +0000
@@ -44,6 +44,9 @@ of the MUMPS user's guide
       within the interface: id.ICNTL(19) which controls the Schur 
       complement option and id.ICNTL(20) which controls the 
       format of the right-hand side.
+      Some parameters related to distributed environments should not be modifed.
+      For example, the solution should always be centralized and id.ICNTL(21)
+      should thus remain to its default value, 0.
       Note that parameters id.ICNTL(1:4) may not work properly
       depending on your compiler and your environment. In case of
       problem, we recommand to swith printing off by setting
diff -pruN 5.6.2-2.1/SCILAB/Help/help_zmumps.xml 5.7.1-1/SCILAB/Help/help_zmumps.xml
--- 5.6.2-2.1/SCILAB/Help/help_zmumps.xml	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/SCILAB/Help/help_zmumps.xml	2024-05-02 10:15:12.000000000 +0000
@@ -57,6 +57,9 @@ of the MUMPS user's guide
       within the interface: id.ICNTL(19) which controls the Schur 
       complement option and id.ICNTL(20) which controls the 
       format of the right-hand side.
+      Some parameters related to distributed environments should not be modifed.
+      For example, the solution should always be centralized and id.ICNTL(21)
+      should thus remain to its default value, 0.
       Note that parameters id.ICNTL(1:4) may not work properly
       depending on your compiler and your environment. In case of
       problem, we recommand to swith printing off by setting
diff -pruN 5.6.2-2.1/SCILAB/builder.sce 5.7.1-1/SCILAB/builder.sce
--- 5.6.2-2.1/SCILAB/builder.sce	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/SCILAB/builder.sce	2024-05-02 10:15:12.000000000 +0000
@@ -5,7 +5,7 @@
 
 // -- MUMPS:
 
-MUMPS_DIR = home + "/MUMPS_5.6.2";
+MUMPS_DIR = home + "/MUMPS_5.7.1";
 MUMPS_INC_DIR = MUMPS_DIR+"/include"; //path until dmumps_c.h and zmumps_c.h
 MUMPS_LIB_DIR = MUMPS_DIR+"/lib";     //path until libdmumps.a, libzmumps.a and libpord.a
 MUMPS_LIB  = MUMPS_LIB_DIR+"/libmumps_common.a";
diff -pruN 5.6.2-2.1/VERSION 5.7.1-1/VERSION
--- 5.6.2-2.1/VERSION	2023-10-11 09:36:26.000000000 +0000
+++ 5.7.1-1/VERSION	2024-05-02 10:15:09.000000000 +0000
@@ -1,2 +1,2 @@
-MUMPS 5.6.2
-Wed Oct 11 09:36:25 UTC 2023
+MUMPS 5.7.1
+Thu May 2 10:15:09 UTC 2024
diff -pruN 5.6.2-2.1/debian/Makefile.par.inc 5.7.1-1/debian/Makefile.par.inc
--- 5.6.2-2.1/debian/Makefile.par.inc	2023-11-29 13:54:48.000000000 +0000
+++ 5.7.1-1/debian/Makefile.par.inc	2024-05-03 16:27:18.000000000 +0000
@@ -48,6 +48,7 @@ PLAT    =
 LIBEXT  = .a
 LIBEXT_SHARED  = .so
 SONAME = -soname
+SHARED_OPT = -shared
 FPIC_OPT = -fPIC
 OUTC    = -o 
 OUTF    = -o 
diff -pruN 5.6.2-2.1/debian/Makefile.ptscotch.inc 5.7.1-1/debian/Makefile.ptscotch.inc
--- 5.6.2-2.1/debian/Makefile.ptscotch.inc	2023-11-29 13:54:48.000000000 +0000
+++ 5.7.1-1/debian/Makefile.ptscotch.inc	2024-05-03 16:27:18.000000000 +0000
@@ -45,6 +45,7 @@ PLAT    =
 LIBEXT  = .a
 LIBEXT_SHARED  = .so
 SONAME = -soname
+SHARED_OPT = -shared
 FPIC_OPT = -fPIC
 OUTC    = -o 
 OUTF    = -o 
diff -pruN 5.6.2-2.1/debian/Makefile.scotch.inc 5.7.1-1/debian/Makefile.scotch.inc
--- 5.6.2-2.1/debian/Makefile.scotch.inc	2023-11-29 13:54:48.000000000 +0000
+++ 5.7.1-1/debian/Makefile.scotch.inc	2024-05-03 16:27:18.000000000 +0000
@@ -45,6 +45,7 @@ PLAT    =
 LIBEXT  = .a
 LIBEXT_SHARED  = .so
 SONAME = -soname
+SHARED_OPT = -shared
 FPIC_OPT = -fPIC
 OUTC    = -o 
 OUTF    = -o 
diff -pruN 5.6.2-2.1/debian/Makefile.seq.inc 5.7.1-1/debian/Makefile.seq.inc
--- 5.6.2-2.1/debian/Makefile.seq.inc	2023-11-29 13:54:48.000000000 +0000
+++ 5.7.1-1/debian/Makefile.seq.inc	2024-05-03 16:27:18.000000000 +0000
@@ -45,6 +45,7 @@ PLAT    =
 LIBEXT  = .a
 LIBEXT_SHARED  = .so
 SONAME = -soname
+SHARED_OPT = -shared
 FPIC_OPT = -fPIC
 OUTC    = -o 
 OUTF    = -o 
diff -pruN 5.6.2-2.1/debian/changelog 5.7.1-1/debian/changelog
--- 5.6.2-2.1/debian/changelog	2024-02-28 20:55:10.000000000 +0000
+++ 5.7.1-1/debian/changelog	2024-05-03 16:27:18.000000000 +0000
@@ -1,3 +1,11 @@
+mumps (5.7.1-1) experimental; urgency=medium
+
+  * Team upload.
+  * New upstream release. New ABI 5.7.
+  * define SHARED_OPT = -shared in Makefile*.inc config files
+
+ -- Drew Parsons <dparsons@debian.org>  Fri, 03 May 2024 18:27:18 +0200
+
 mumps (5.6.2-2.1) unstable; urgency=medium
 
   * Non-maintainer upload.
diff -pruN 5.6.2-2.1/debian/control 5.7.1-1/debian/control
--- 5.6.2-2.1/debian/control	2024-02-28 20:55:10.000000000 +0000
+++ 5.7.1-1/debian/control	2024-05-03 16:27:18.000000000 +0000
@@ -24,7 +24,7 @@ Section: libdevel
 Multi-Arch: same
 Depends:
  libmumps-headers-dev (= ${source:Version}),
- libmumps-5.6t64 (= ${binary:Version}),
+ libmumps-5.7 (= ${binary:Version}),
  libscalapack-mpi-dev,
  mpi-default-dev,
  ${misc:Depends},
@@ -56,7 +56,7 @@ Multi-Arch: same
 Depends:
  libmumps-dev (= ${binary:Version}),
  libmumps-headers-dev (= ${source:Version}),
- libmumps-seq-5.6t64 (= ${binary:Version}),
+ libmumps-seq-5.7 (= ${binary:Version}),
  ${misc:Depends},
 Description: Direct linear systems solver - non-parallel development files
  MUMPS implements a direct solver for large sparse linear systems, with a
@@ -68,10 +68,7 @@ Description: Direct linear systems solve
  Unless you know that you specifically need this, then you almost
  certainly want the libmumps-dev package.
 
-Package: libmumps-5.6t64
-Provides: ${t64:Provides}
-Replaces: libmumps-5.6
-Breaks: libmumps-5.6 (<< ${source:Version})
+Package: libmumps-5.7
 Architecture: any
 Section: libs
 Multi-Arch: same
@@ -86,10 +83,7 @@ Description: Direct linear systems solve
  operate on distributed matrices e.g. over a cluster.  It has Fortran and
  C interfaces, and can interface with ordering tools such as Scotch.
 
-Package: libmumps-seq-5.6t64
-Provides: ${t64:Provides}
-Replaces: libmumps-seq-5.6
-Breaks: libmumps-seq-5.6 (<< ${source:Version})
+Package: libmumps-seq-5.7
 Architecture: any
 Section: libs
 Multi-Arch: same
@@ -104,12 +98,9 @@ Description: Direct linear systems solve
  .
  This package is built the MUMPS libseq dummy sequential MPI library.
  Unless you know that you specifically need this, then you almost
- certainly want the libmumps-5.6t64 package.
+ certainly want the libmumps-5.7 package.
 
-Package: libmumps-scotch-5.6t64
-Provides: ${t64:Provides}
-Replaces: libmumps-scotch-5.6
-Breaks: libmumps-scotch-5.6 (<< ${source:Version})
+Package: libmumps-scotch-5.7
 Architecture: any
 Section: libs
 Multi-Arch: same
@@ -131,7 +122,7 @@ Section: libdevel
 Multi-Arch: same
 Depends:
  libmumps-dev,
- libmumps-scotch-5.6t64 (= ${binary:Version}),
+ libmumps-scotch-5.7 (= ${binary:Version}),
  ${misc:Depends},
 Description: Direct linear systems solver - Scotch-version development files
  MUMPS implements a direct solver for large sparse linear systems, with a
@@ -142,10 +133,7 @@ Description: Direct linear systems solve
  This package provides static libaries enabling reordering of data using
  SCOTCH.
 
-Package: libmumps-ptscotch-5.6t64
-Provides: ${t64:Provides}
-Replaces: libmumps-ptscotch-5.6
-Breaks: libmumps-ptscotch-5.6 (<< ${source:Version})
+Package: libmumps-ptscotch-5.7
 Architecture: any
 Section: libs
 Multi-Arch: same
@@ -168,7 +156,7 @@ Section: libdevel
 Multi-Arch: same
 Depends:
  libmumps-dev,
- libmumps-ptscotch-5.6t64 (= ${binary:Version}),
+ libmumps-ptscotch-5.7 (= ${binary:Version}),
  ${misc:Depends},
 Description: Direct linear systems solver - PTScotch-version development files
  MUMPS implements a direct solver for large sparse linear systems, with a
@@ -185,7 +173,7 @@ Section: libdevel
 Multi-Arch: same
 Depends:
  libmumps-headers-dev (= ${source:Version}),
- libmumps-64pord-5.6t64 (= ${binary:Version}),
+ libmumps-64pord-5.7 (= ${binary:Version}),
  libscalapack-mpi-dev,
  mpi-default-dev,
  ${misc:Depends},
@@ -204,7 +192,7 @@ Multi-Arch: same
 Depends:
  libmumps64-dev (= ${binary:Version}),
  libmumps-headers-dev (= ${source:Version}),
- libmumps-64pord-seq-5.6t64 (= ${binary:Version}),
+ libmumps-64pord-seq-5.7 (= ${binary:Version}),
  ${misc:Depends},
 Description: Direct linear systems solver (64 bit) - non-parallel development files
  MUMPS implements a direct solver for large sparse linear systems, with a
@@ -218,10 +206,7 @@ Description: Direct linear systems solve
  .
  This package supports 64-bit ordering (-DPORD_INTSIZE64).
 
-Package: libmumps-64pord-5.6t64
-Provides: ${t64:Provides}
-Replaces: libmumps-64pord-5.6
-Breaks: libmumps-64pord-5.6 (<< ${source:Version})
+Package: libmumps-64pord-5.7
 Architecture: any
 Section: libs
 Multi-Arch: same
@@ -238,10 +223,7 @@ Description: Direct linear systems solve
  .
  This package supports 64-bit ordering (-DPORD_INTSIZE64).
 
-Package: libmumps-64pord-seq-5.6t64
-Provides: ${t64:Provides}
-Replaces: libmumps-64pord-seq-5.6
-Breaks: libmumps-64pord-seq-5.6 (<< ${source:Version})
+Package: libmumps-64pord-seq-5.7
 Architecture: any
 Section: libs
 Multi-Arch: same
@@ -256,14 +238,11 @@ Description: Direct linear systems solve
  .
  This package is built the MUMPS libseq dummy sequential MPI library.
  Unless you know that you specifically need this, then you almost
- certainly want the libmumps-64pord-5.6t64 package.
+ certainly want the libmumps-64pord-5.7 package.
  .
  This package supports 64-bit ordering (-DPORD_INTSIZE64).
 
-Package: libmumps-64pord-scotch-5.6t64
-Provides: ${t64:Provides}
-Replaces: libmumps-64pord-scotch-5.6
-Breaks: libmumps-64pord-scotch-5.6 (<< ${source:Version})
+Package: libmumps-64pord-scotch-5.7
 Architecture: any
 Section: libs
 Multi-Arch: same
@@ -285,7 +264,7 @@ Section: libdevel
 Multi-Arch: same
 Depends:
  libmumps64-dev,
- libmumps-64pord-scotch-5.6t64 (= ${binary:Version}),
+ libmumps-64pord-scotch-5.7 (= ${binary:Version}),
  ${misc:Depends},
 Description: Direct linear systems solver (64 bit) - Scotch-version development files
  MUMPS implements a direct solver for large sparse linear systems, with a
@@ -296,10 +275,7 @@ Description: Direct linear systems solve
  This package provides static libaries enabling reordering of data using
  SCOTCH. It supports 64-bit ordering (-DPORD_INTSIZE64).
 
-Package: libmumps-64pord-ptscotch-5.6t64
-Provides: ${t64:Provides}
-Replaces: libmumps-64pord-ptscotch-5.6
-Breaks: libmumps-64pord-ptscotch-5.6 (<< ${source:Version})
+Package: libmumps-64pord-ptscotch-5.7
 Architecture: any
 Section: libs
 Multi-Arch: same
@@ -321,7 +297,7 @@ Section: libdevel
 Multi-Arch: same
 Depends:
  libmumps64-dev,
- libmumps-64pord-ptscotch-5.6t64 (= ${binary:Version}),
+ libmumps-64pord-ptscotch-5.7 (= ${binary:Version}),
  ${misc:Depends},
 Description: Direct linear systems solver (64 bit) - PTScotch-version development files
  MUMPS implements a direct solver for large sparse linear systems, with a
diff -pruN 5.6.2-2.1/debian/libmumps-5.6t64.install 5.7.1-1/debian/libmumps-5.6t64.install
--- 5.6.2-2.1/debian/libmumps-5.6t64.install	2023-11-29 13:54:48.000000000 +0000
+++ 5.7.1-1/debian/libmumps-5.6t64.install	1970-01-01 00:00:00.000000000 +0000
@@ -1,2 +0,0 @@
-#! /bin/sh
-echo libmumps/lib*-*.so usr/lib/${DEB_HOST_MULTIARCH}/
diff -pruN 5.6.2-2.1/debian/libmumps-5.6t64.lintian-overrides 5.7.1-1/debian/libmumps-5.6t64.lintian-overrides
--- 5.6.2-2.1/debian/libmumps-5.6t64.lintian-overrides	2024-02-28 20:55:03.000000000 +0000
+++ 5.7.1-1/debian/libmumps-5.6t64.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
@@ -1,3 +0,0 @@
-# several variants of libmumps are provided by libmumps-*
-package-name-doesnt-match-sonames libcmumps-* libdmumps-* libmumps-common-* libpord-* libsmumps-* libzmumps-*
-libmumps-5.6t64: package-name-doesnt-match-sonames libmumps-5.6
diff -pruN 5.6.2-2.1/debian/libmumps-5.7.install 5.7.1-1/debian/libmumps-5.7.install
--- 5.6.2-2.1/debian/libmumps-5.7.install	1970-01-01 00:00:00.000000000 +0000
+++ 5.7.1-1/debian/libmumps-5.7.install	2024-05-03 16:27:18.000000000 +0000
@@ -0,0 +1,2 @@
+#! /bin/sh
+echo libmumps/lib*-*.so usr/lib/${DEB_HOST_MULTIARCH}/
diff -pruN 5.6.2-2.1/debian/libmumps-5.7.lintian-overrides 5.7.1-1/debian/libmumps-5.7.lintian-overrides
--- 5.6.2-2.1/debian/libmumps-5.7.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
+++ 5.7.1-1/debian/libmumps-5.7.lintian-overrides	2024-05-03 16:27:18.000000000 +0000
@@ -0,0 +1,2 @@
+# several variants of libmumps are provided by libmumps-*
+package-name-doesnt-match-sonames libcmumps-* libdmumps-* libmumps-common-* libpord-* libsmumps-* libzmumps-*
diff -pruN 5.6.2-2.1/debian/libmumps-64pord-5.6t64.install 5.7.1-1/debian/libmumps-64pord-5.6t64.install
--- 5.6.2-2.1/debian/libmumps-64pord-5.6t64.install	2023-11-29 13:54:48.000000000 +0000
+++ 5.7.1-1/debian/libmumps-64pord-5.6t64.install	1970-01-01 00:00:00.000000000 +0000
@@ -1,2 +0,0 @@
-#! /bin/sh
-echo libmumps64/lib*-*.so usr/lib/${DEB_HOST_MULTIARCH}/
diff -pruN 5.6.2-2.1/debian/libmumps-64pord-5.6t64.lintian-overrides 5.7.1-1/debian/libmumps-64pord-5.6t64.lintian-overrides
--- 5.6.2-2.1/debian/libmumps-64pord-5.6t64.lintian-overrides	2024-02-28 20:55:03.000000000 +0000
+++ 5.7.1-1/debian/libmumps-64pord-5.6t64.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
@@ -1,4 +0,0 @@
-# several variants of libmumps are provided by libmumps-64pord-*
-package-name-doesnt-match-sonames libcmumps-64pord-* libdmumps-64pord-* libmumps-common-64pord-* libpord-64pord-* libsmumps-64pord-* libzmumps-64pord-*
-
-libmumps-64pord-5.6t64: package-name-doesnt-match-sonames libmumps-64pord-5.6
diff -pruN 5.6.2-2.1/debian/libmumps-64pord-5.7.install 5.7.1-1/debian/libmumps-64pord-5.7.install
--- 5.6.2-2.1/debian/libmumps-64pord-5.7.install	1970-01-01 00:00:00.000000000 +0000
+++ 5.7.1-1/debian/libmumps-64pord-5.7.install	2024-05-03 16:27:18.000000000 +0000
@@ -0,0 +1,2 @@
+#! /bin/sh
+echo libmumps64/lib*-*.so usr/lib/${DEB_HOST_MULTIARCH}/
diff -pruN 5.6.2-2.1/debian/libmumps-64pord-5.7.lintian-overrides 5.7.1-1/debian/libmumps-64pord-5.7.lintian-overrides
--- 5.6.2-2.1/debian/libmumps-64pord-5.7.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
+++ 5.7.1-1/debian/libmumps-64pord-5.7.lintian-overrides	2024-05-03 16:27:18.000000000 +0000
@@ -0,0 +1,3 @@
+# several variants of libmumps are provided by libmumps-64pord-*
+package-name-doesnt-match-sonames libcmumps-64pord-* libdmumps-64pord-* libmumps-common-64pord-* libpord-64pord-* libsmumps-64pord-* libzmumps-64pord-*
+
diff -pruN 5.6.2-2.1/debian/libmumps-64pord-ptscotch-5.6t64.install 5.7.1-1/debian/libmumps-64pord-ptscotch-5.6t64.install
--- 5.6.2-2.1/debian/libmumps-64pord-ptscotch-5.6t64.install	2023-11-29 13:54:48.000000000 +0000
+++ 5.7.1-1/debian/libmumps-64pord-ptscotch-5.6t64.install	1970-01-01 00:00:00.000000000 +0000
@@ -1,2 +0,0 @@
-#! /bin/sh
-echo libmumps64_ptscotch/lib*-*.so usr/lib/${DEB_HOST_MULTIARCH}/
diff -pruN 5.6.2-2.1/debian/libmumps-64pord-ptscotch-5.6t64.lintian-overrides 5.7.1-1/debian/libmumps-64pord-ptscotch-5.6t64.lintian-overrides
--- 5.6.2-2.1/debian/libmumps-64pord-ptscotch-5.6t64.lintian-overrides	2024-02-28 20:55:03.000000000 +0000
+++ 5.7.1-1/debian/libmumps-64pord-ptscotch-5.6t64.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
@@ -1,3 +0,0 @@
-# several variants of libmumps-64pord-ptscotch are provided by libmumps-64pord-ptscotch-*
-package-name-doesnt-match-sonames libcmumps-64pord-ptscotch-* libdmumps-64pord-ptscotch-* libmumps-common-64pord-ptscotch-* libpord-64pord-ptscotch-* libsmumps-64pord-ptscotch-* libzmumps-64pord-ptscotch-*
-libmumps-64pord-ptscotch-5.6t64: package-name-doesnt-match-sonames libmumps-64pord-ptscotch-5.6
diff -pruN 5.6.2-2.1/debian/libmumps-64pord-ptscotch-5.7.install 5.7.1-1/debian/libmumps-64pord-ptscotch-5.7.install
--- 5.6.2-2.1/debian/libmumps-64pord-ptscotch-5.7.install	1970-01-01 00:00:00.000000000 +0000
+++ 5.7.1-1/debian/libmumps-64pord-ptscotch-5.7.install	2024-05-03 16:27:18.000000000 +0000
@@ -0,0 +1,2 @@
+#! /bin/sh
+echo libmumps64_ptscotch/lib*-*.so usr/lib/${DEB_HOST_MULTIARCH}/
diff -pruN 5.6.2-2.1/debian/libmumps-64pord-ptscotch-5.7.lintian-overrides 5.7.1-1/debian/libmumps-64pord-ptscotch-5.7.lintian-overrides
--- 5.6.2-2.1/debian/libmumps-64pord-ptscotch-5.7.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
+++ 5.7.1-1/debian/libmumps-64pord-ptscotch-5.7.lintian-overrides	2024-05-03 16:27:18.000000000 +0000
@@ -0,0 +1,2 @@
+# several variants of libmumps-64pord-ptscotch are provided by libmumps-64pord-ptscotch-*
+package-name-doesnt-match-sonames libcmumps-64pord-ptscotch-* libdmumps-64pord-ptscotch-* libmumps-common-64pord-ptscotch-* libpord-64pord-ptscotch-* libsmumps-64pord-ptscotch-* libzmumps-64pord-ptscotch-*
diff -pruN 5.6.2-2.1/debian/libmumps-64pord-scotch-5.6t64.install 5.7.1-1/debian/libmumps-64pord-scotch-5.6t64.install
--- 5.6.2-2.1/debian/libmumps-64pord-scotch-5.6t64.install	2023-11-29 13:54:48.000000000 +0000
+++ 5.7.1-1/debian/libmumps-64pord-scotch-5.6t64.install	1970-01-01 00:00:00.000000000 +0000
@@ -1,2 +0,0 @@
-#! /bin/sh
-echo libmumps64_scotch/lib*-*.so usr/lib/${DEB_HOST_MULTIARCH}/
diff -pruN 5.6.2-2.1/debian/libmumps-64pord-scotch-5.6t64.lintian-overrides 5.7.1-1/debian/libmumps-64pord-scotch-5.6t64.lintian-overrides
--- 5.6.2-2.1/debian/libmumps-64pord-scotch-5.6t64.lintian-overrides	2024-02-28 20:55:03.000000000 +0000
+++ 5.7.1-1/debian/libmumps-64pord-scotch-5.6t64.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
@@ -1,3 +0,0 @@
-# several variants of libmumps-64pord-scotch are provided by libmumps-64pord-scotch-*
-package-name-doesnt-match-sonames libcmumps-64pord-scotch-* libdmumps-64pord-scotch-* libmpiseq-64pord-scotch-* libmumps-common-64pord-scotch-* libpord-64pord-scotch-* libsmumps-64pord-scotch-* libzmumps-64pord-scotch-*
-libmumps-64pord-scotch-5.6t64: package-name-doesnt-match-sonames libmumps-64pord-scotch-5.6
diff -pruN 5.6.2-2.1/debian/libmumps-64pord-scotch-5.7.install 5.7.1-1/debian/libmumps-64pord-scotch-5.7.install
--- 5.6.2-2.1/debian/libmumps-64pord-scotch-5.7.install	1970-01-01 00:00:00.000000000 +0000
+++ 5.7.1-1/debian/libmumps-64pord-scotch-5.7.install	2024-05-03 16:27:18.000000000 +0000
@@ -0,0 +1,2 @@
+#! /bin/sh
+echo libmumps64_scotch/lib*-*.so usr/lib/${DEB_HOST_MULTIARCH}/
diff -pruN 5.6.2-2.1/debian/libmumps-64pord-scotch-5.7.lintian-overrides 5.7.1-1/debian/libmumps-64pord-scotch-5.7.lintian-overrides
--- 5.6.2-2.1/debian/libmumps-64pord-scotch-5.7.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
+++ 5.7.1-1/debian/libmumps-64pord-scotch-5.7.lintian-overrides	2024-05-03 16:27:18.000000000 +0000
@@ -0,0 +1,2 @@
+# several variants of libmumps-64pord-scotch are provided by libmumps-64pord-scotch-*
+package-name-doesnt-match-sonames libcmumps-64pord-scotch-* libdmumps-64pord-scotch-* libmpiseq-64pord-scotch-* libmumps-common-64pord-scotch-* libpord-64pord-scotch-* libsmumps-64pord-scotch-* libzmumps-64pord-scotch-*
diff -pruN 5.6.2-2.1/debian/libmumps-64pord-seq-5.6t64.install 5.7.1-1/debian/libmumps-64pord-seq-5.6t64.install
--- 5.6.2-2.1/debian/libmumps-64pord-seq-5.6t64.install	2023-11-29 13:54:48.000000000 +0000
+++ 5.7.1-1/debian/libmumps-64pord-seq-5.6t64.install	1970-01-01 00:00:00.000000000 +0000
@@ -1,2 +0,0 @@
-#! /bin/sh
-echo libmumps64_seq/lib*-*.so usr/lib/${DEB_HOST_MULTIARCH}/
diff -pruN 5.6.2-2.1/debian/libmumps-64pord-seq-5.6t64.lintian-overrides 5.7.1-1/debian/libmumps-64pord-seq-5.6t64.lintian-overrides
--- 5.6.2-2.1/debian/libmumps-64pord-seq-5.6t64.lintian-overrides	2024-02-28 20:55:03.000000000 +0000
+++ 5.7.1-1/debian/libmumps-64pord-seq-5.6t64.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
@@ -1,3 +0,0 @@
-# several variants of libmumps-64pord-seq are provided by libmumps-64pord-seq-*
-package-name-doesnt-match-sonames libcmumps-64pord-seq-* libdmumps-64pord-seq-* libmpiseq-64pord-seq-* libmumps-common-64pord-seq-* libpord-64pord-seq-* libsmumps-64pord-seq-* libzmumps-64pord-seq-*
-libmumps-64pord-seq-5.6t64: package-name-doesnt-match-sonames libmumps-64pord-seq-5.6
diff -pruN 5.6.2-2.1/debian/libmumps-64pord-seq-5.7.install 5.7.1-1/debian/libmumps-64pord-seq-5.7.install
--- 5.6.2-2.1/debian/libmumps-64pord-seq-5.7.install	1970-01-01 00:00:00.000000000 +0000
+++ 5.7.1-1/debian/libmumps-64pord-seq-5.7.install	2024-05-03 16:27:18.000000000 +0000
@@ -0,0 +1,2 @@
+#! /bin/sh
+echo libmumps64_seq/lib*-*.so usr/lib/${DEB_HOST_MULTIARCH}/
diff -pruN 5.6.2-2.1/debian/libmumps-64pord-seq-5.7.lintian-overrides 5.7.1-1/debian/libmumps-64pord-seq-5.7.lintian-overrides
--- 5.6.2-2.1/debian/libmumps-64pord-seq-5.7.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
+++ 5.7.1-1/debian/libmumps-64pord-seq-5.7.lintian-overrides	2024-05-03 16:27:18.000000000 +0000
@@ -0,0 +1,2 @@
+# several variants of libmumps-64pord-seq are provided by libmumps-64pord-seq-*
+package-name-doesnt-match-sonames libcmumps-64pord-seq-* libdmumps-64pord-seq-* libmpiseq-64pord-seq-* libmumps-common-64pord-seq-* libpord-64pord-seq-* libsmumps-64pord-seq-* libzmumps-64pord-seq-*
diff -pruN 5.6.2-2.1/debian/libmumps-ptscotch-5.6t64.install 5.7.1-1/debian/libmumps-ptscotch-5.6t64.install
--- 5.6.2-2.1/debian/libmumps-ptscotch-5.6t64.install	2023-11-29 13:54:48.000000000 +0000
+++ 5.7.1-1/debian/libmumps-ptscotch-5.6t64.install	1970-01-01 00:00:00.000000000 +0000
@@ -1,2 +0,0 @@
-#! /bin/sh
-echo libmumps_ptscotch/lib*-*.so usr/lib/${DEB_HOST_MULTIARCH}/
diff -pruN 5.6.2-2.1/debian/libmumps-ptscotch-5.6t64.lintian-overrides 5.7.1-1/debian/libmumps-ptscotch-5.6t64.lintian-overrides
--- 5.6.2-2.1/debian/libmumps-ptscotch-5.6t64.lintian-overrides	2024-02-28 20:55:03.000000000 +0000
+++ 5.7.1-1/debian/libmumps-ptscotch-5.6t64.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
@@ -1,3 +0,0 @@
-# several variants of libmumps-ptscotch are provided by libmumps-ptscotch-*
-package-name-doesnt-match-sonames libcmumps-ptscotch-* libdmumps-ptscotch-* libmumps-common-ptscotch-* libpord-ptscotch-* libsmumps-ptscotch-* libzmumps-ptscotch-*
-libmumps-ptscotch-5.6t64: package-name-doesnt-match-sonames libmumps-ptscotch-5.6
diff -pruN 5.6.2-2.1/debian/libmumps-ptscotch-5.7.install 5.7.1-1/debian/libmumps-ptscotch-5.7.install
--- 5.6.2-2.1/debian/libmumps-ptscotch-5.7.install	1970-01-01 00:00:00.000000000 +0000
+++ 5.7.1-1/debian/libmumps-ptscotch-5.7.install	2024-05-03 16:27:18.000000000 +0000
@@ -0,0 +1,2 @@
+#! /bin/sh
+echo libmumps_ptscotch/lib*-*.so usr/lib/${DEB_HOST_MULTIARCH}/
diff -pruN 5.6.2-2.1/debian/libmumps-ptscotch-5.7.lintian-overrides 5.7.1-1/debian/libmumps-ptscotch-5.7.lintian-overrides
--- 5.6.2-2.1/debian/libmumps-ptscotch-5.7.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
+++ 5.7.1-1/debian/libmumps-ptscotch-5.7.lintian-overrides	2024-05-03 16:27:18.000000000 +0000
@@ -0,0 +1,2 @@
+# several variants of libmumps-ptscotch are provided by libmumps-ptscotch-*
+package-name-doesnt-match-sonames libcmumps-ptscotch-* libdmumps-ptscotch-* libmumps-common-ptscotch-* libpord-ptscotch-* libsmumps-ptscotch-* libzmumps-ptscotch-*
diff -pruN 5.6.2-2.1/debian/libmumps-scotch-5.6t64.install 5.7.1-1/debian/libmumps-scotch-5.6t64.install
--- 5.6.2-2.1/debian/libmumps-scotch-5.6t64.install	2023-11-29 13:54:48.000000000 +0000
+++ 5.7.1-1/debian/libmumps-scotch-5.6t64.install	1970-01-01 00:00:00.000000000 +0000
@@ -1,2 +0,0 @@
-#! /bin/sh
-echo libmumps_scotch/lib*-*.so usr/lib/${DEB_HOST_MULTIARCH}/
diff -pruN 5.6.2-2.1/debian/libmumps-scotch-5.6t64.lintian-overrides 5.7.1-1/debian/libmumps-scotch-5.6t64.lintian-overrides
--- 5.6.2-2.1/debian/libmumps-scotch-5.6t64.lintian-overrides	2024-02-28 20:55:03.000000000 +0000
+++ 5.7.1-1/debian/libmumps-scotch-5.6t64.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
@@ -1,3 +0,0 @@
-# several variants of libmumps-scotch are provided by libmumps-scotch-*
-package-name-doesnt-match-sonames libcmumps-scotch-* libdmumps-scotch-* libmpiseq-scotch-* libmumps-common-scotch-* libpord-scotch-* libsmumps-scotch-* libzmumps-scotch-*
-libmumps-scotch-5.6t64: package-name-doesnt-match-sonames libmumps-scotch-5.6
diff -pruN 5.6.2-2.1/debian/libmumps-scotch-5.7.install 5.7.1-1/debian/libmumps-scotch-5.7.install
--- 5.6.2-2.1/debian/libmumps-scotch-5.7.install	1970-01-01 00:00:00.000000000 +0000
+++ 5.7.1-1/debian/libmumps-scotch-5.7.install	2024-05-03 16:27:18.000000000 +0000
@@ -0,0 +1,2 @@
+#! /bin/sh
+echo libmumps_scotch/lib*-*.so usr/lib/${DEB_HOST_MULTIARCH}/
diff -pruN 5.6.2-2.1/debian/libmumps-scotch-5.7.lintian-overrides 5.7.1-1/debian/libmumps-scotch-5.7.lintian-overrides
--- 5.6.2-2.1/debian/libmumps-scotch-5.7.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
+++ 5.7.1-1/debian/libmumps-scotch-5.7.lintian-overrides	2024-05-03 16:27:18.000000000 +0000
@@ -0,0 +1,2 @@
+# several variants of libmumps-scotch are provided by libmumps-scotch-*
+package-name-doesnt-match-sonames libcmumps-scotch-* libdmumps-scotch-* libmpiseq-scotch-* libmumps-common-scotch-* libpord-scotch-* libsmumps-scotch-* libzmumps-scotch-*
diff -pruN 5.6.2-2.1/debian/libmumps-seq-5.6t64.install 5.7.1-1/debian/libmumps-seq-5.6t64.install
--- 5.6.2-2.1/debian/libmumps-seq-5.6t64.install	2023-11-29 13:54:48.000000000 +0000
+++ 5.7.1-1/debian/libmumps-seq-5.6t64.install	1970-01-01 00:00:00.000000000 +0000
@@ -1,2 +0,0 @@
-#! /bin/sh
-echo libmumps_seq/lib*-*.so usr/lib/${DEB_HOST_MULTIARCH}/
diff -pruN 5.6.2-2.1/debian/libmumps-seq-5.6t64.lintian-overrides 5.7.1-1/debian/libmumps-seq-5.6t64.lintian-overrides
--- 5.6.2-2.1/debian/libmumps-seq-5.6t64.lintian-overrides	2024-02-28 20:55:03.000000000 +0000
+++ 5.7.1-1/debian/libmumps-seq-5.6t64.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
@@ -1,2 +0,0 @@
-# several variants of libmumps-seq are provided by libmumps-seq-*
-package-name-doesnt-match-sonames libcmumps-seq-* libdmumps-seq-* libmpiseq-seq-* libmumps-common-seq-* libpord-seq-* libsmumps-seq-* libzmumps-seq-*libmumps-seq-5.6t64: package-name-doesnt-match-sonames libmumps-seq-5.6
diff -pruN 5.6.2-2.1/debian/libmumps-seq-5.7.install 5.7.1-1/debian/libmumps-seq-5.7.install
--- 5.6.2-2.1/debian/libmumps-seq-5.7.install	1970-01-01 00:00:00.000000000 +0000
+++ 5.7.1-1/debian/libmumps-seq-5.7.install	2024-05-03 16:27:18.000000000 +0000
@@ -0,0 +1,2 @@
+#! /bin/sh
+echo libmumps_seq/lib*-*.so usr/lib/${DEB_HOST_MULTIARCH}/
diff -pruN 5.6.2-2.1/debian/libmumps-seq-5.7.lintian-overrides 5.7.1-1/debian/libmumps-seq-5.7.lintian-overrides
--- 5.6.2-2.1/debian/libmumps-seq-5.7.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
+++ 5.7.1-1/debian/libmumps-seq-5.7.lintian-overrides	2024-05-03 16:27:18.000000000 +0000
@@ -0,0 +1,2 @@
+# several variants of libmumps-seq are provided by libmumps-seq-*
+package-name-doesnt-match-sonames libcmumps-seq-* libdmumps-seq-* libmpiseq-seq-* libmumps-common-seq-* libpord-seq-* libsmumps-seq-* libzmumps-seq-*
\ No newline at end of file
diff -pruN 5.6.2-2.1/debian/patches/makefile_version.patch 5.7.1-1/debian/patches/makefile_version.patch
--- 5.6.2-2.1/debian/patches/makefile_version.patch	2023-11-29 13:54:48.000000000 +0000
+++ 5.7.1-1/debian/patches/makefile_version.patch	2024-05-03 16:27:18.000000000 +0000
@@ -1,13 +1,13 @@
 Index: mumps/Makefile
 ===================================================================
---- mumps.orig/Makefile	2023-11-01 01:22:13.116334477 +0100
-+++ mumps/Makefile	2023-11-01 01:22:13.108334408 +0100
+--- mumps.orig/Makefile	2024-05-03 17:18:40.507257047 +0200
++++ mumps/Makefile	2024-05-03 17:18:49.499337112 +0200
 @@ -2,6 +2,9 @@
- #  This file is part of MUMPS 5.6.2, released
- #  on Wed Oct 11 09:36:25 UTC 2023
+ #  This file is part of MUMPS 5.7.1, released
+ #  on Thu May  2 10:15:09 UTC 2024
  #
-+export VERSION   = 5.6.1
-+export SOVERSION = 5.6
++export VERSION   = 5.7.1
++export SOVERSION = 5.7
 +
  topdir = .
  libdir = $(topdir)/lib
diff -pruN 5.6.2-2.1/debian/patches/shared-libseq.patch 5.7.1-1/debian/patches/shared-libseq.patch
--- 5.6.2-2.1/debian/patches/shared-libseq.patch	2023-11-29 13:54:48.000000000 +0000
+++ 5.7.1-1/debian/patches/shared-libseq.patch	2024-05-03 16:27:18.000000000 +0000
@@ -2,14 +2,14 @@ Create a shared version of the sequentia
 
 Index: mumps/libseq/Makefile
 ===================================================================
---- mumps.orig/libseq/Makefile	2022-05-07 10:24:05.953920233 +0200
-+++ mumps/libseq/Makefile	2022-05-07 10:24:05.945920147 +0200
+--- mumps.orig/libseq/Makefile	2024-05-03 18:18:13.628702451 +0200
++++ mumps/libseq/Makefile	2024-05-03 18:19:19.861297130 +0200
 @@ -19,7 +19,9 @@
  	$(MAKE) FPIC="$(FPIC_OPT)" libmpiseq$(PLAT)$(LIBEXT_SHARED)
  
  libmpiseq$(PLAT)$(LIBEXT_SHARED): mpi.o mpic.o elapse.o
--	$(FC) -shared mpi.o mpic.o elapse.o -o libmpiseq$(PLAT)$(LIBEXT_SHARED)
-+	$(FC) -shared -Wl,-soname,libmpiseq$(PLAT)-$(SOVERSION).so mpi.o mpic.o elapse.o -o libmpiseq$(PLAT)-$(VERSION)$(LIBEXT_SHARED)
+-	$(FC) $(SHARED_OPT) mpi.o mpic.o elapse.o -o libmpiseq$(PLAT)$(LIBEXT_SHARED)
++	$(FC) $(SHARED_OPT) -Wl,-soname,libmpiseq$(PLAT)-$(SOVERSION).so mpi.o mpic.o elapse.o -o libmpiseq$(PLAT)-$(VERSION)$(LIBEXT_SHARED)
 +	ln -s libmpiseq$(PLAT)-$(VERSION)$(LIBEXT_SHARED) libmpiseq$(PLAT)-$(SOVERSION)$(LIBEXT_SHARED)
 +	ln -s libmpiseq$(PLAT)-$(VERSION)$(LIBEXT_SHARED) $@
  
@@ -23,8 +23,8 @@ Index: mumps/libseq/Makefile
 +	$(RM) *.o *$(LIBEXT) *$(LIBEXT_SHARED)
 Index: mumps/Makefile
 ===================================================================
---- mumps.orig/Makefile	2022-05-07 10:24:05.857919202 +0200
-+++ mumps/Makefile	2022-05-09 16:44:15.291392199 +0200
+--- mumps.orig/Makefile	2024-05-03 18:18:13.628702451 +0200
++++ mumps/Makefile	2024-05-03 18:18:13.624702415 +0200
 @@ -80,7 +80,7 @@
  sharedlibseq:
  
diff -pruN 5.6.2-2.1/debian/patches/shared-mumps.patch 5.7.1-1/debian/patches/shared-mumps.patch
--- 5.6.2-2.1/debian/patches/shared-mumps.patch	2023-11-29 13:54:48.000000000 +0000
+++ 5.7.1-1/debian/patches/shared-mumps.patch	2024-05-03 16:27:18.000000000 +0000
@@ -2,8 +2,8 @@ Create a shared version of the MUMPS lib
 
 Index: mumps/src/Makefile
 ===================================================================
---- mumps.orig/src/Makefile	2023-05-17 10:31:17.513484107 +0200
-+++ mumps/src/Makefile	2023-05-17 10:38:54.051384774 +0200
+--- mumps.orig/src/Makefile	2024-05-03 18:10:47.344697277 +0200
++++ mumps/src/Makefile	2024-05-03 18:16:25.459731266 +0200
 @@ -14,19 +14,19 @@
  all: $(incdir)/mumps_int_def.h libcommon s d c z
  
@@ -29,12 +29,12 @@ Index: mumps/src/Makefile
  
  
  # Rules for shared libraries
-@@ -214,14 +214,18 @@
+@@ -217,14 +217,18 @@
  	$(RANLIB) $@
  
  $(libdir)/libmumps_common$(PLAT)$(LIBEXT_SHARED):      $(OBJS_COMMON_MOD) $(OBJS_COMMON_OTHER)
--	$(FC) $(OPTL) -shared $^ -Wl,$(SONAME),libmumps_common$(PLAT)$(LIBEXT_SHARED) -L$(libdir) $(RPATH_OPT) $(LORDERINGS) $(LIBS) $(LIBOTHERS) -o $@ 
-+	$(FC) $(OPTL) -shared $^ -Wl,$(SONAME),libmumps_common$(PLAT)-$(SOVERSION)$(LIBEXT_SHARED) -L$(libdir) $(RPATH_OPT) $(LORDERINGS) $(LIBS) $(LIBOTHERS) -o $(libdir)/libmumps_common$(PLAT)-$(VERSION)$(LIBEXT_SHARED)
+-	$(FC) $(OPTL) $(SHARED_OPT) $^ -Wl,$(SONAME),libmumps_common$(PLAT)$(LIBEXT_SHARED) -L$(libdir) $(RPATH_OPT) $(LORDERINGS) $(LIBS) $(LIBOTHERS) -o $@ 
++	$(FC) $(OPTL) $(SHARED_OPT) $^ -Wl,$(SONAME),libmumps_common$(PLAT)-$(SOVERSION)$(LIBEXT_SHARED) -L$(libdir) $(RPATH_OPT) $(LORDERINGS) $(LIBS) $(LIBOTHERS) -o $(libdir)/libmumps_common$(PLAT)-$(VERSION)$(LIBEXT_SHARED)
 +	ln -s libmumps_common$(PLAT)-$(VERSION)$(LIBEXT_SHARED) $(libdir)/libmumps_common$(PLAT)-$(SOVERSION)$(LIBEXT_SHARED)
 +	ln -s libmumps_common$(PLAT)-$(VERSION)$(LIBEXT_SHARED) $@
  
@@ -43,8 +43,8 @@ Index: mumps/src/Makefile
  	$(RANLIB) $@
  
  $(libdir)/lib$(ARITH)mumps$(PLAT)$(LIBEXT_SHARED):    $(OBJS_MOD) $(OBJS_OTHER) $(libdir)/libmumps_common$(PLAT)$(LIBEXT_SHARED)
--	$(FC) $(OPTL) -shared $(OBJS_MOD) $(OBJS_OTHER) -L$(libdir) $(LORDERINGS) $(LIBS) $(LIBOTHERS) -lmumps_common$(PLAT) -o $@ $(RPATH_OPT)
-+	$(FC) $(OPTL) -shared -Wl,-soname,lib$(ARITH)mumps$(PLAT)-$(SOVERSION)$(LIBEXT_SHARED) $(OBJS_MOD) $(OBJS_OTHER) -L$(libdir) $(LORDERINGS) $(LIBS) $(LIBOTHERS) -lmumps_common$(PLAT) -o $(libdir)/lib$(ARITH)mumps$(PLAT)-$(VERSION)$(LIBEXT_SHARED) $(RPATH_OPT)
+-	$(FC) $(OPTL) $(SHARED_OPT) $(OBJS_MOD) $(OBJS_OTHER) -L$(libdir) $(LORDERINGS) $(LIBS) $(LIBOTHERS) -lmumps_common$(PLAT) -o $@ $(RPATH_OPT)
++	$(FC) $(OPTL) $(SHARED_OPT) -Wl,-soname,lib$(ARITH)mumps$(PLAT)-$(SOVERSION)$(LIBEXT_SHARED) $(OBJS_MOD) $(OBJS_OTHER) -L$(libdir) $(LORDERINGS) $(LIBS) $(LIBOTHERS) -lmumps_common$(PLAT) -o $(libdir)/lib$(ARITH)mumps$(PLAT)-$(VERSION)$(LIBEXT_SHARED) $(RPATH_OPT)
 +	ln -s lib$(ARITH)mumps$(PLAT)-$(VERSION)$(LIBEXT_SHARED) $(libdir)/lib$(ARITH)mumps$(PLAT)-$(SOVERSION)$(LIBEXT_SHARED)
 +	ln -s lib$(ARITH)mumps$(PLAT)-$(VERSION)$(LIBEXT_SHARED) $@
  
diff -pruN 5.6.2-2.1/debian/patches/shared-pord.patch 5.7.1-1/debian/patches/shared-pord.patch
--- 5.6.2-2.1/debian/patches/shared-pord.patch	2023-11-29 13:54:48.000000000 +0000
+++ 5.7.1-1/debian/patches/shared-pord.patch	2024-05-03 16:27:18.000000000 +0000
@@ -2,8 +2,8 @@ Create static and shared versions of the
 
 Index: mumps/PORD/lib/Makefile
 ===================================================================
---- mumps.orig/PORD/lib/Makefile	2023-11-03 14:12:07.168161568 +0100
-+++ mumps/PORD/lib/Makefile	2023-11-03 14:12:07.164161533 +0100
+--- mumps.orig/PORD/lib/Makefile	2024-05-03 18:20:07.845727993 +0200
++++ mumps/PORD/lib/Makefile	2024-05-03 18:20:07.841727957 +0200
 @@ -1,7 +1,7 @@
  
  # To compile directly, uncomment the line below.
@@ -13,7 +13,7 @@ Index: mumps/PORD/lib/Makefile
  #
  # Otherwise, adequate variables for CC, CFLAGS, AR and
  # RANLIB must be passed to make.
-@@ -29,10 +29,12 @@
+@@ -31,10 +31,12 @@
  	$(RANLIB) $@
  
  libpord$(PLAT)$(LIBEXT_SHARED):$(OBJS)
@@ -30,8 +30,8 @@ Index: mumps/PORD/lib/Makefile
 +	rm -f *.o libpord$(PLAT)$(LIBEXT) libpord$(PLAT)*$(LIBEXT_SHARED)
 Index: mumps/Makefile
 ===================================================================
---- mumps.orig/Makefile	2023-11-03 14:12:07.168161568 +0100
-+++ mumps/Makefile	2023-11-03 14:12:23.240302577 +0100
+--- mumps.orig/Makefile	2024-05-03 18:20:07.845727993 +0200
++++ mumps/Makefile	2024-05-03 18:20:07.841727957 +0200
 @@ -91,7 +91,7 @@
  $(libdir)/libpord$(PLAT)$(LIBEXT):
  	if [ "$(LPORDDIR)" != "" ] ; then \
Binary files 5.6.2-2.1/doc/userguide_5.6.2.pdf and 5.7.1-1/doc/userguide_5.6.2.pdf differ
Binary files 5.6.2-2.1/doc/userguide_5.7.1.pdf and 5.7.1-1/doc/userguide_5.7.1.pdf differ
diff -pruN 5.6.2-2.1/examples/Makefile 5.7.1-1/examples/Makefile
--- 5.6.2-2.1/examples/Makefile	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/examples/Makefile	2024-05-02 10:15:13.000000000 +0000
@@ -1,6 +1,6 @@
 #
-#  This file is part of MUMPS 5.6.2, released
-#  on Wed Oct 11 09:36:25 UTC 2023
+#  This file is part of MUMPS 5.7.1, released
+#  on Thu May  2 10:15:09 UTC 2024
 #
 topdir = ..
 libdir = $(topdir)/lib
diff -pruN 5.6.2-2.1/examples/c_example.c 5.7.1-1/examples/c_example.c
--- 5.6.2-2.1/examples/c_example.c	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/examples/c_example.c	2024-05-02 10:15:12.000000000 +0000
@@ -1,7 +1,7 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  */
 /* Example program using the C interface to the 
@@ -48,7 +48,7 @@ int main(int argc, char ** argv)
   double rhs[2];
 
 /* When compiling with -DINTSIZE64, MUMPS_INT is 64-bit but MPI
-   ilp64 versions may still require standard int for C interface. */
+   ilp64 versions normally still require standard int for C */
 /* MUMPS_INT myid, ierr; */
   int myid, ierr;
 
diff -pruN 5.6.2-2.1/examples/c_example_save_restore.c 5.7.1-1/examples/c_example_save_restore.c
--- 5.6.2-2.1/examples/c_example_save_restore.c	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/examples/c_example_save_restore.c	2024-05-02 10:15:12.000000000 +0000
@@ -1,7 +1,7 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  */
 /* Example program using the C interface to the 
diff -pruN 5.6.2-2.1/examples/csimpletest.F 5.7.1-1/examples/csimpletest.F
--- 5.6.2-2.1/examples/csimpletest.F	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/examples/csimpletest.F	2024-05-02 10:15:13.000000000 +0000
@@ -1,6 +1,6 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
       PROGRAM MUMPS_TEST
       IMPLICIT NONE
diff -pruN 5.6.2-2.1/examples/csimpletest_save_restore.F 5.7.1-1/examples/csimpletest_save_restore.F
--- 5.6.2-2.1/examples/csimpletest_save_restore.F	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/examples/csimpletest_save_restore.F	2024-05-02 10:15:13.000000000 +0000
@@ -1,6 +1,6 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
       PROGRAM MUMPS_TEST_SAVE_RESTORE
       IMPLICIT NONE
@@ -68,7 +68,7 @@ C  Destroy the instance (deallocate inte
       CALL CMUMPS(mumps_par_save)
 C  Now mumps_par_save has be destroyed
 C  We use a new instance mumps_par_restore to finish the computation
-C  Define a communicator for the package on the new instace.
+C  Define a communicator for the package on the new instance.
       mumps_par_restore%COMM = MPI_COMM_WORLD
 C  Initialize a new instance of the package
 C  for L U factorization (sym = 0, with working host)
diff -pruN 5.6.2-2.1/examples/dsimpletest.F 5.7.1-1/examples/dsimpletest.F
--- 5.6.2-2.1/examples/dsimpletest.F	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/examples/dsimpletest.F	2024-05-02 10:15:13.000000000 +0000
@@ -1,6 +1,6 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
       PROGRAM MUMPS_TEST
       IMPLICIT NONE
diff -pruN 5.6.2-2.1/examples/dsimpletest_save_restore.F 5.7.1-1/examples/dsimpletest_save_restore.F
--- 5.6.2-2.1/examples/dsimpletest_save_restore.F	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/examples/dsimpletest_save_restore.F	2024-05-02 10:15:13.000000000 +0000
@@ -1,6 +1,6 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
       PROGRAM MUMPS_TEST_SAVE_RESTORE
       IMPLICIT NONE
@@ -68,7 +68,7 @@ C  Destroy the instance (deallocate inte
       CALL DMUMPS(mumps_par_save)
 C  Now mumps_par_save has be destroyed
 C  We use a new instance mumps_par_restore to finish the computation
-C  Define a communicator for the package on the new instace.
+C  Define a communicator for the package on the new instance.
       mumps_par_restore%COMM = MPI_COMM_WORLD
 C  Initialize a new instance of the package
 C  for L U factorization (sym = 0, with working host)
diff -pruN 5.6.2-2.1/examples/multiple_arithmetics_example.F 5.7.1-1/examples/multiple_arithmetics_example.F
--- 5.6.2-2.1/examples/multiple_arithmetics_example.F	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/examples/multiple_arithmetics_example.F	2024-05-02 10:15:12.000000000 +0000
@@ -1,6 +1,6 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
       PROGRAM MUMPS_MULTIPLE_ARITHMETICS_TEST
       IMPLICIT NONE
@@ -68,7 +68,7 @@ C  for L U factorization (sym = 0, with
       END IF
 
       IF ( smumps_par%MYID .eq. 0 )THEN
-         write(6,'(A)') "Creation of all instaces went well"
+         write(6,'(A)') "Creation of all instances went well"
       ENDIF
            
 C     Destroy the instances (deallocate internal data structures)
diff -pruN 5.6.2-2.1/examples/ssimpletest.F 5.7.1-1/examples/ssimpletest.F
--- 5.6.2-2.1/examples/ssimpletest.F	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/examples/ssimpletest.F	2024-05-02 10:15:12.000000000 +0000
@@ -1,6 +1,6 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
       PROGRAM MUMPS_TEST
       IMPLICIT NONE
diff -pruN 5.6.2-2.1/examples/ssimpletest_save_restore.F 5.7.1-1/examples/ssimpletest_save_restore.F
--- 5.6.2-2.1/examples/ssimpletest_save_restore.F	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/examples/ssimpletest_save_restore.F	2024-05-02 10:15:12.000000000 +0000
@@ -1,6 +1,6 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
       PROGRAM MUMPS_TEST_SAVE_RESTORE
       IMPLICIT NONE
@@ -68,7 +68,7 @@ C  Destroy the instance (deallocate inte
       CALL SMUMPS(mumps_par_save)
 C  Now mumps_par_save has be destroyed
 C  We use a new instance mumps_par_restore to finish the computation
-C  Define a communicator for the package on the new instace.
+C  Define a communicator for the package on the new instance.
       mumps_par_restore%COMM = MPI_COMM_WORLD
 C  Initialize a new instance of the package
 C  for L U factorization (sym = 0, with working host)
diff -pruN 5.6.2-2.1/examples/zsimpletest.F 5.7.1-1/examples/zsimpletest.F
--- 5.6.2-2.1/examples/zsimpletest.F	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/examples/zsimpletest.F	2024-05-02 10:15:13.000000000 +0000
@@ -1,6 +1,6 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
       PROGRAM MUMPS_TEST
       IMPLICIT NONE
diff -pruN 5.6.2-2.1/examples/zsimpletest_save_restore.F 5.7.1-1/examples/zsimpletest_save_restore.F
--- 5.6.2-2.1/examples/zsimpletest_save_restore.F	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/examples/zsimpletest_save_restore.F	2024-05-02 10:15:13.000000000 +0000
@@ -1,6 +1,6 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
       PROGRAM MUMPS_TEST_SAVE_RESTORE
       IMPLICIT NONE
@@ -68,7 +68,7 @@ C  Destroy the instance (deallocate inte
       CALL ZMUMPS(mumps_par_save)
 C  Now mumps_par_save has be destroyed
 C  We use a new instance mumps_par_restore to finish the computation
-C  Define a communicator for the package on the new instace.
+C  Define a communicator for the package on the new instance.
       mumps_par_restore%COMM = MPI_COMM_WORLD
 C  Initialize a new instance of the package
 C  for L U factorization (sym = 0, with working host)
diff -pruN 5.6.2-2.1/include/cmumps_c.h 5.7.1-1/include/cmumps_c.h
--- 5.6.2-2.1/include/cmumps_c.h	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/include/cmumps_c.h	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
@@ -29,7 +29,7 @@ extern "C" {
 
 #ifndef MUMPS_VERSION
 /* Protected in case headers of other arithmetics are included */
-#define MUMPS_VERSION "5.6.2"
+#define MUMPS_VERSION "5.7.1"
 #endif
 #ifndef MUMPS_VERSION_MAX_LEN
 #define MUMPS_VERSION_MAX_LEN 30
@@ -91,12 +91,22 @@ typedef struct {
     MUMPS_INT colsca_from_mumps;
     MUMPS_INT rowsca_from_mumps;
 
+    /* Distributed scaling(out) */
+    CMUMPS_REAL    *colsca_loc;
+    CMUMPS_REAL    *rowsca_loc;
+
+    /* Info after facto */
+    MUMPS_INT      *rowind;
+    MUMPS_INT      *colind;
+    CMUMPS_COMPLEX *pivots;
+
     /* RHS, solution, ouptput data and statistics */
-    CMUMPS_COMPLEX *rhs, *redrhs, *rhs_sparse, *sol_loc, *rhs_loc;
-    MUMPS_INT      *irhs_sparse, *irhs_ptr, *isol_loc, *irhs_loc;
-    MUMPS_INT      nrhs, lrhs, lredrhs, nz_rhs, lsol_loc, nloc_rhs, lrhs_loc;
+    CMUMPS_COMPLEX *rhs, *redrhs, *rhs_sparse, *sol_loc, *rhs_loc, *rhsintr;
+    MUMPS_INT      *irhs_sparse, *irhs_ptr, *isol_loc, *irhs_loc, *glob2loc_rhs, *glob2loc_sol;
+    MUMPS_INT      nrhs, lrhs, lredrhs, nz_rhs, lsol_loc, nloc_rhs, lrhs_loc, nsol_loc;
     MUMPS_INT      schur_mloc, schur_nloc, schur_lld;
     MUMPS_INT      mblock, nblock, nprow, npcol;
+    MUMPS_INT      ld_rhsintr;
     MUMPS_INT      info[80],infog[80];
     CMUMPS_REAL    rinfo[40], rinfog[40];
 
@@ -104,30 +114,33 @@ typedef struct {
     MUMPS_INT      deficiency;
     MUMPS_INT      *pivnul_list;
     MUMPS_INT      *mapping;
+    CMUMPS_REAL    *singular_values;
 
     /* Schur */
     MUMPS_INT      size_schur;
     MUMPS_INT      *listvar_schur;
     CMUMPS_COMPLEX *schur;
 
-    /* Internal parameters */
-    MUMPS_INT      instance_number;
+    /* user workspace */
     CMUMPS_COMPLEX *wk_user;
 
-    /* Version number: length=14 in FORTRAN + 1 for final \0 + 1 for alignment */
+    /* Version number: length=30 in FORTRAN + 1 for final \0 + 1 for alignment */
     char version_number[MUMPS_VERSION_MAX_LEN + 1 + 1];
     /* For out-of-core */
-    char ooc_tmpdir[256];
-    char ooc_prefix[64];
+    char ooc_tmpdir[1024];
+    char ooc_prefix[256];
     /* To save the matrix in matrix market format */
-    char write_problem[256];
+    char write_problem[1024];
     MUMPS_INT      lwk_user;
     /* For save/restore feature */
-    char save_dir[256];
+    char save_dir[1024];
     char save_prefix[256];
 
     /* Metis options */
     MUMPS_INT metis_options[40];
+
+    /* Internal parameters */
+    MUMPS_INT      instance_number;
 } CMUMPS_STRUC_C;
 
 
diff -pruN 5.6.2-2.1/include/cmumps_root.h 5.7.1-1/include/cmumps_root.h
--- 5.6.2-2.1/include/cmumps_root.h	2023-10-11 09:37:02.000000000 +0000
+++ 5.7.1-1/include/cmumps_root.h	2024-05-02 10:15:25.000000000 +0000
@@ -1,9 +1,9 @@
 !
-!  This file is part of MUMPS 5.6.2, released
-!  on Wed Oct 11 09:36:25 UTC 2023
+!  This file is part of MUMPS 5.7.1, released
+!  on Thu May  2 10:15:09 UTC 2024
 !
 !
-!  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+!  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 !  Mumps Technologies, University of Bordeaux.
 !
 !  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/include/cmumps_struc.h 5.7.1-1/include/cmumps_struc.h
--- 5.6.2-2.1/include/cmumps_struc.h	2023-10-11 09:37:02.000000000 +0000
+++ 5.7.1-1/include/cmumps_struc.h	2024-05-02 10:15:25.000000000 +0000
@@ -1,9 +1,9 @@
 !
-!  This file is part of MUMPS 5.6.2, released
-!  on Wed Oct 11 09:36:25 UTC 2023
+!  This file is part of MUMPS 5.7.1, released
+!  on Thu May  2 10:15:09 UTC 2024
 !
 !
-!  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+!  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 !  Mumps Technologies, University of Bordeaux.
 !
 !  This version of MUMPS is provided to you free of charge. It is
@@ -46,7 +46,14 @@
         INTEGER(8) :: NNZ ! 64-bit integer input
         COMPLEX, DIMENSION(:), POINTER :: A
         INTEGER, DIMENSION(:), POINTER :: IRN, JCN
-        REAL, DIMENSION(:), POINTER :: COLSCA, ROWSCA, pad0
+!    --------------
+!    Scaling arrays
+!    --------------
+        REAL, DIMENSION(:), POINTER :: COLSCA, ROWSCA
+        REAL, DIMENSION(:), POINTER :: COLSCA_loc
+        REAL, DIMENSION(:), POINTER :: ROWSCA_loc
+        INTEGER, DIMENSION(:), POINTER :: ROWIND, COLIND
+        COMPLEX, DIMENSION(:), POINTER :: PIVOTS
 !
 !       ------------------------------------
 !       Case of distributed assembled matrix
@@ -96,7 +103,8 @@
         INTEGER, DIMENSION(:), POINTER :: ISOL_loc
         INTEGER, DIMENSION(:), POINTER :: IRHS_loc
         INTEGER :: LRHS, NRHS, NZ_RHS, Nloc_RHS, LRHS_loc, LREDRHS
-        INTEGER :: LSOL_loc, pad6
+        INTEGER :: LSOL_loc, NSOL_loc
+        INTEGER :: LD_RHSINTR, pad6
 !    ----------------------------
 !    Control parameters,
 !    statistics and output data
@@ -138,16 +146,16 @@
 !    -----------
 !    Out-of-core
 !    -----------
-        CHARACTER(LEN=255) :: OOC_TMPDIR
-        CHARACTER(LEN=63) :: OOC_PREFIX
+        CHARACTER(LEN=1023) :: OOC_TMPDIR
+        CHARACTER(LEN=255) :: OOC_PREFIX
 !    ------------------------------------------
 !    Name of file to dump a matrix/rhs to disk
 !    ------------------------------------------
-        CHARACTER(LEN=255) ::  WRITE_PROBLEM
+        CHARACTER(LEN=1023) ::  WRITE_PROBLEM
 !    -----------
 !    Save/Restore
 !    -----------
-        CHARACTER(LEN=255) :: SAVE_DIR
+        CHARACTER(LEN=1023) :: SAVE_DIR
         CHARACTER(LEN=255)  :: SAVE_PREFIX
         CHARACTER(LEN=7)   ::  pad7  
 !
@@ -199,10 +207,10 @@
 !       For heterogeneous architecture
         INTEGER, DIMENSION(:), POINTER :: MEM_DIST
 !       Compressed RHS
-        INTEGER, DIMENSION(:),   POINTER :: POSINRHSCOMP_ROW
-        LOGICAL  :: POSINRHSCOMP_COL_ALLOC, pad11
-        INTEGER, DIMENSION(:),   POINTER :: POSINRHSCOMP_COL
-        COMPLEX, DIMENSION(:),   POINTER :: RHSCOMP
+        INTEGER, DIMENSION(:),   POINTER :: GLOB2LOC_RHS
+        LOGICAL  :: GLOB2LOC_SOL_ALLOC, pad11
+        INTEGER, DIMENSION(:),   POINTER :: GLOB2LOC_SOL
+        COMPLEX, DIMENSION(:),   POINTER :: RHSINTR
 !       Info on the subtrees to be used during factorization
         DOUBLE PRECISION, DIMENSION(:), POINTER :: MEM_SUBTREE
         DOUBLE PRECISION, DIMENSION(:), POINTER :: COST_TRAV
@@ -216,7 +224,7 @@
         INTEGER, DIMENSION(:),   POINTER :: SCHED_GRP
         INTEGER, DIMENSION(:),   POINTER :: SCHED_SBTR
         INTEGER, DIMENSION(:),   POINTER :: CROIX_MANU
-        COMPLEX, DIMENSION(:), POINTER :: WK_USER
+        COMPLEX, DIMENSION(:),   POINTER :: WK_USER
         INTEGER :: NBSA_LOCAL
         INTEGER :: LWK_USER
 !    Internal control array
@@ -277,7 +285,7 @@
 ! Mapping of the subtree nodes
         INTEGER, DIMENSION(:), POINTER :: L0_OMP_MAPPING
 ! Mpi to omp - mumps agile
-        INTEGER, DIMENSION(:), POINTER :: MPITOOMP_PROCS_MAP
+        INTEGER, DIMENSION(:), POINTER :: MTKO_PROCS_MAP
 ! for RR on root
         REAL, DIMENSION(:), POINTER :: SINGULAR_VALUES
         INTEGER ::  NB_SINGULAR_VALUES
diff -pruN 5.6.2-2.1/include/dmumps_c.h 5.7.1-1/include/dmumps_c.h
--- 5.6.2-2.1/include/dmumps_c.h	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/include/dmumps_c.h	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
@@ -29,7 +29,7 @@ extern "C" {
 
 #ifndef MUMPS_VERSION
 /* Protected in case headers of other arithmetics are included */
-#define MUMPS_VERSION "5.6.2"
+#define MUMPS_VERSION "5.7.1"
 #endif
 #ifndef MUMPS_VERSION_MAX_LEN
 #define MUMPS_VERSION_MAX_LEN 30
@@ -91,12 +91,22 @@ typedef struct {
     MUMPS_INT colsca_from_mumps;
     MUMPS_INT rowsca_from_mumps;
 
+    /* Distributed scaling(out) */
+    DMUMPS_REAL    *colsca_loc;
+    DMUMPS_REAL    *rowsca_loc;
+
+    /* Info after facto */
+    MUMPS_INT      *rowind;
+    MUMPS_INT      *colind;
+    DMUMPS_COMPLEX *pivots;
+
     /* RHS, solution, ouptput data and statistics */
-    DMUMPS_COMPLEX *rhs, *redrhs, *rhs_sparse, *sol_loc, *rhs_loc;
-    MUMPS_INT      *irhs_sparse, *irhs_ptr, *isol_loc, *irhs_loc;
-    MUMPS_INT      nrhs, lrhs, lredrhs, nz_rhs, lsol_loc, nloc_rhs, lrhs_loc;
+    DMUMPS_COMPLEX *rhs, *redrhs, *rhs_sparse, *sol_loc, *rhs_loc, *rhsintr;
+    MUMPS_INT      *irhs_sparse, *irhs_ptr, *isol_loc, *irhs_loc, *glob2loc_rhs, *glob2loc_sol;
+    MUMPS_INT      nrhs, lrhs, lredrhs, nz_rhs, lsol_loc, nloc_rhs, lrhs_loc, nsol_loc;
     MUMPS_INT      schur_mloc, schur_nloc, schur_lld;
     MUMPS_INT      mblock, nblock, nprow, npcol;
+    MUMPS_INT      ld_rhsintr;
     MUMPS_INT      info[80],infog[80];
     DMUMPS_REAL    rinfo[40], rinfog[40];
 
@@ -104,30 +114,33 @@ typedef struct {
     MUMPS_INT      deficiency;
     MUMPS_INT      *pivnul_list;
     MUMPS_INT      *mapping;
+    DMUMPS_REAL    *singular_values;
 
     /* Schur */
     MUMPS_INT      size_schur;
     MUMPS_INT      *listvar_schur;
     DMUMPS_COMPLEX *schur;
 
-    /* Internal parameters */
-    MUMPS_INT      instance_number;
+    /* user workspace */
     DMUMPS_COMPLEX *wk_user;
 
-    /* Version number: length=14 in FORTRAN + 1 for final \0 + 1 for alignment */
+    /* Version number: length=30 in FORTRAN + 1 for final \0 + 1 for alignment */
     char version_number[MUMPS_VERSION_MAX_LEN + 1 + 1];
     /* For out-of-core */
-    char ooc_tmpdir[256];
-    char ooc_prefix[64];
+    char ooc_tmpdir[1024];
+    char ooc_prefix[256];
     /* To save the matrix in matrix market format */
-    char write_problem[256];
+    char write_problem[1024];
     MUMPS_INT      lwk_user;
     /* For save/restore feature */
-    char save_dir[256];
+    char save_dir[1024];
     char save_prefix[256];
 
     /* Metis options */
     MUMPS_INT metis_options[40];
+
+    /* Internal parameters */
+    MUMPS_INT      instance_number;
 } DMUMPS_STRUC_C;
 
 
diff -pruN 5.6.2-2.1/include/dmumps_root.h 5.7.1-1/include/dmumps_root.h
--- 5.6.2-2.1/include/dmumps_root.h	2023-10-11 09:37:02.000000000 +0000
+++ 5.7.1-1/include/dmumps_root.h	2024-05-02 10:15:25.000000000 +0000
@@ -1,9 +1,9 @@
 !
-!  This file is part of MUMPS 5.6.2, released
-!  on Wed Oct 11 09:36:25 UTC 2023
+!  This file is part of MUMPS 5.7.1, released
+!  on Thu May  2 10:15:09 UTC 2024
 !
 !
-!  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+!  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 !  Mumps Technologies, University of Bordeaux.
 !
 !  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/include/dmumps_struc.h 5.7.1-1/include/dmumps_struc.h
--- 5.6.2-2.1/include/dmumps_struc.h	2023-10-11 09:37:02.000000000 +0000
+++ 5.7.1-1/include/dmumps_struc.h	2024-05-02 10:15:25.000000000 +0000
@@ -1,9 +1,9 @@
 !
-!  This file is part of MUMPS 5.6.2, released
-!  on Wed Oct 11 09:36:25 UTC 2023
+!  This file is part of MUMPS 5.7.1, released
+!  on Thu May  2 10:15:09 UTC 2024
 !
 !
-!  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+!  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 !  Mumps Technologies, University of Bordeaux.
 !
 !  This version of MUMPS is provided to you free of charge. It is
@@ -46,7 +46,14 @@
         INTEGER(8) :: NNZ ! 64-bit integer input
         DOUBLE PRECISION, DIMENSION(:), POINTER :: A
         INTEGER, DIMENSION(:), POINTER :: IRN, JCN
-        DOUBLE PRECISION, DIMENSION(:), POINTER :: COLSCA, ROWSCA, pad0
+!    --------------
+!    Scaling arrays
+!    --------------
+        DOUBLE PRECISION, DIMENSION(:), POINTER :: COLSCA, ROWSCA
+        DOUBLE PRECISION, DIMENSION(:), POINTER :: COLSCA_loc
+        DOUBLE PRECISION, DIMENSION(:), POINTER :: ROWSCA_loc
+        INTEGER, DIMENSION(:), POINTER :: ROWIND, COLIND
+        DOUBLE PRECISION, DIMENSION(:), POINTER :: PIVOTS
 !
 !       ------------------------------------
 !       Case of distributed assembled matrix
@@ -96,7 +103,8 @@
         INTEGER, DIMENSION(:), POINTER :: ISOL_loc
         INTEGER, DIMENSION(:), POINTER :: IRHS_loc
         INTEGER :: LRHS, NRHS, NZ_RHS, Nloc_RHS, LRHS_loc, LREDRHS
-        INTEGER :: LSOL_loc, pad6
+        INTEGER :: LSOL_loc, NSOL_loc
+        INTEGER :: LD_RHSINTR, pad6
 !    ----------------------------
 !    Control parameters,
 !    statistics and output data
@@ -138,16 +146,16 @@
 !    -----------
 !    Out-of-core
 !    -----------
-        CHARACTER(LEN=255) :: OOC_TMPDIR
-        CHARACTER(LEN=63) :: OOC_PREFIX
+        CHARACTER(LEN=1023) :: OOC_TMPDIR
+        CHARACTER(LEN=255) :: OOC_PREFIX
 !    ------------------------------------------
 !    Name of file to dump a matrix/rhs to disk
 !    ------------------------------------------
-        CHARACTER(LEN=255) ::  WRITE_PROBLEM
+        CHARACTER(LEN=1023) ::  WRITE_PROBLEM
 !    -----------
 !    Save/Restore
 !    -----------
-        CHARACTER(LEN=255) :: SAVE_DIR
+        CHARACTER(LEN=1023) :: SAVE_DIR
         CHARACTER(LEN=255)  :: SAVE_PREFIX
         CHARACTER(LEN=7)   ::  pad7  
 !
@@ -199,10 +207,10 @@
 !       For heterogeneous architecture
         INTEGER, DIMENSION(:), POINTER :: MEM_DIST
 !       Compressed RHS
-        INTEGER, DIMENSION(:),   POINTER :: POSINRHSCOMP_ROW
-        LOGICAL  :: POSINRHSCOMP_COL_ALLOC, pad11
-        INTEGER, DIMENSION(:),   POINTER :: POSINRHSCOMP_COL
-        DOUBLE PRECISION, DIMENSION(:),   POINTER :: RHSCOMP
+        INTEGER, DIMENSION(:),   POINTER :: GLOB2LOC_RHS
+        LOGICAL  :: GLOB2LOC_SOL_ALLOC, pad11
+        INTEGER, DIMENSION(:),   POINTER :: GLOB2LOC_SOL
+        DOUBLE PRECISION, DIMENSION(:),   POINTER :: RHSINTR
 !       Info on the subtrees to be used during factorization
         DOUBLE PRECISION, DIMENSION(:), POINTER :: MEM_SUBTREE
         DOUBLE PRECISION, DIMENSION(:), POINTER :: COST_TRAV
@@ -216,7 +224,7 @@
         INTEGER, DIMENSION(:),   POINTER :: SCHED_GRP
         INTEGER, DIMENSION(:),   POINTER :: SCHED_SBTR
         INTEGER, DIMENSION(:),   POINTER :: CROIX_MANU
-        DOUBLE PRECISION, DIMENSION(:), POINTER :: WK_USER
+        DOUBLE PRECISION, DIMENSION(:),   POINTER :: WK_USER
         INTEGER :: NBSA_LOCAL
         INTEGER :: LWK_USER
 !    Internal control array
@@ -277,7 +285,7 @@
 ! Mapping of the subtree nodes
         INTEGER, DIMENSION(:), POINTER :: L0_OMP_MAPPING
 ! Mpi to omp - mumps agile
-        INTEGER, DIMENSION(:), POINTER :: MPITOOMP_PROCS_MAP
+        INTEGER, DIMENSION(:), POINTER :: MTKO_PROCS_MAP
 ! for RR on root
         DOUBLE PRECISION, DIMENSION(:), POINTER :: SINGULAR_VALUES
         INTEGER ::  NB_SINGULAR_VALUES
diff -pruN 5.6.2-2.1/include/mumps_c_types.h 5.7.1-1/include/mumps_c_types.h
--- 5.6.2-2.1/include/mumps_c_types.h	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/include/mumps_c_types.h	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
@@ -68,5 +68,6 @@ typedef struct {double r,i;} mumps_doubl
 #define MUMPS_ARITH_SINGLE ( MUMPS_ARITH_s | MUMPS_ARITH_c )
 #define MUMPS_ARITH_DBL    ( MUMPS_ARITH_d | MUMPS_ARITH_z )
 
+#define MUMPS_OFF_T MUMPS_INT8
 
 #endif /* MUMPS_C_TYPES_H */
diff -pruN 5.6.2-2.1/include/mumps_compat.h 5.7.1-1/include/mumps_compat.h
--- 5.6.2-2.1/include/mumps_compat.h	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/include/mumps_compat.h	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/include/smumps_c.h 5.7.1-1/include/smumps_c.h
--- 5.6.2-2.1/include/smumps_c.h	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/include/smumps_c.h	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
@@ -29,7 +29,7 @@ extern "C" {
 
 #ifndef MUMPS_VERSION
 /* Protected in case headers of other arithmetics are included */
-#define MUMPS_VERSION "5.6.2"
+#define MUMPS_VERSION "5.7.1"
 #endif
 #ifndef MUMPS_VERSION_MAX_LEN
 #define MUMPS_VERSION_MAX_LEN 30
@@ -91,12 +91,22 @@ typedef struct {
     MUMPS_INT colsca_from_mumps;
     MUMPS_INT rowsca_from_mumps;
 
+    /* Distributed scaling(out) */
+    SMUMPS_REAL    *colsca_loc;
+    SMUMPS_REAL    *rowsca_loc;
+
+    /* Info after facto */
+    MUMPS_INT      *rowind;
+    MUMPS_INT      *colind;
+    SMUMPS_COMPLEX *pivots;
+
     /* RHS, solution, ouptput data and statistics */
-    SMUMPS_COMPLEX *rhs, *redrhs, *rhs_sparse, *sol_loc, *rhs_loc;
-    MUMPS_INT      *irhs_sparse, *irhs_ptr, *isol_loc, *irhs_loc;
-    MUMPS_INT      nrhs, lrhs, lredrhs, nz_rhs, lsol_loc, nloc_rhs, lrhs_loc;
+    SMUMPS_COMPLEX *rhs, *redrhs, *rhs_sparse, *sol_loc, *rhs_loc, *rhsintr;
+    MUMPS_INT      *irhs_sparse, *irhs_ptr, *isol_loc, *irhs_loc, *glob2loc_rhs, *glob2loc_sol;
+    MUMPS_INT      nrhs, lrhs, lredrhs, nz_rhs, lsol_loc, nloc_rhs, lrhs_loc, nsol_loc;
     MUMPS_INT      schur_mloc, schur_nloc, schur_lld;
     MUMPS_INT      mblock, nblock, nprow, npcol;
+    MUMPS_INT      ld_rhsintr;
     MUMPS_INT      info[80],infog[80];
     SMUMPS_REAL    rinfo[40], rinfog[40];
 
@@ -104,30 +114,33 @@ typedef struct {
     MUMPS_INT      deficiency;
     MUMPS_INT      *pivnul_list;
     MUMPS_INT      *mapping;
+    SMUMPS_REAL    *singular_values;
 
     /* Schur */
     MUMPS_INT      size_schur;
     MUMPS_INT      *listvar_schur;
     SMUMPS_COMPLEX *schur;
 
-    /* Internal parameters */
-    MUMPS_INT      instance_number;
+    /* user workspace */
     SMUMPS_COMPLEX *wk_user;
 
-    /* Version number: length=14 in FORTRAN + 1 for final \0 + 1 for alignment */
+    /* Version number: length=30 in FORTRAN + 1 for final \0 + 1 for alignment */
     char version_number[MUMPS_VERSION_MAX_LEN + 1 + 1];
     /* For out-of-core */
-    char ooc_tmpdir[256];
-    char ooc_prefix[64];
+    char ooc_tmpdir[1024];
+    char ooc_prefix[256];
     /* To save the matrix in matrix market format */
-    char write_problem[256];
+    char write_problem[1024];
     MUMPS_INT      lwk_user;
     /* For save/restore feature */
-    char save_dir[256];
+    char save_dir[1024];
     char save_prefix[256];
 
     /* Metis options */
     MUMPS_INT metis_options[40];
+
+    /* Internal parameters */
+    MUMPS_INT      instance_number;
 } SMUMPS_STRUC_C;
 
 
diff -pruN 5.6.2-2.1/include/smumps_root.h 5.7.1-1/include/smumps_root.h
--- 5.6.2-2.1/include/smumps_root.h	2023-10-11 09:37:02.000000000 +0000
+++ 5.7.1-1/include/smumps_root.h	2024-05-02 10:15:25.000000000 +0000
@@ -1,9 +1,9 @@
 !
-!  This file is part of MUMPS 5.6.2, released
-!  on Wed Oct 11 09:36:25 UTC 2023
+!  This file is part of MUMPS 5.7.1, released
+!  on Thu May  2 10:15:09 UTC 2024
 !
 !
-!  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+!  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 !  Mumps Technologies, University of Bordeaux.
 !
 !  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/include/smumps_struc.h 5.7.1-1/include/smumps_struc.h
--- 5.6.2-2.1/include/smumps_struc.h	2023-10-11 09:37:02.000000000 +0000
+++ 5.7.1-1/include/smumps_struc.h	2024-05-02 10:15:25.000000000 +0000
@@ -1,9 +1,9 @@
 !
-!  This file is part of MUMPS 5.6.2, released
-!  on Wed Oct 11 09:36:25 UTC 2023
+!  This file is part of MUMPS 5.7.1, released
+!  on Thu May  2 10:15:09 UTC 2024
 !
 !
-!  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+!  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 !  Mumps Technologies, University of Bordeaux.
 !
 !  This version of MUMPS is provided to you free of charge. It is
@@ -46,7 +46,14 @@
         INTEGER(8) :: NNZ ! 64-bit integer input
         REAL, DIMENSION(:), POINTER :: A
         INTEGER, DIMENSION(:), POINTER :: IRN, JCN
-        REAL, DIMENSION(:), POINTER :: COLSCA, ROWSCA, pad0
+!    --------------
+!    Scaling arrays
+!    --------------
+        REAL, DIMENSION(:), POINTER :: COLSCA, ROWSCA
+        REAL, DIMENSION(:), POINTER :: COLSCA_loc
+        REAL, DIMENSION(:), POINTER :: ROWSCA_loc
+        INTEGER, DIMENSION(:), POINTER :: ROWIND, COLIND
+        REAL, DIMENSION(:), POINTER :: PIVOTS
 !
 !       ------------------------------------
 !       Case of distributed assembled matrix
@@ -96,7 +103,8 @@
         INTEGER, DIMENSION(:), POINTER :: ISOL_loc
         INTEGER, DIMENSION(:), POINTER :: IRHS_loc
         INTEGER :: LRHS, NRHS, NZ_RHS, Nloc_RHS, LRHS_loc, LREDRHS
-        INTEGER :: LSOL_loc, pad6
+        INTEGER :: LSOL_loc, NSOL_loc
+        INTEGER :: LD_RHSINTR, pad6
 !    ----------------------------
 !    Control parameters,
 !    statistics and output data
@@ -138,16 +146,16 @@
 !    -----------
 !    Out-of-core
 !    -----------
-        CHARACTER(LEN=255) :: OOC_TMPDIR
-        CHARACTER(LEN=63) :: OOC_PREFIX
+        CHARACTER(LEN=1023) :: OOC_TMPDIR
+        CHARACTER(LEN=255) :: OOC_PREFIX
 !    ------------------------------------------
 !    Name of file to dump a matrix/rhs to disk
 !    ------------------------------------------
-        CHARACTER(LEN=255) ::  WRITE_PROBLEM
+        CHARACTER(LEN=1023) ::  WRITE_PROBLEM
 !    -----------
 !    Save/Restore
 !    -----------
-        CHARACTER(LEN=255) :: SAVE_DIR
+        CHARACTER(LEN=1023) :: SAVE_DIR
         CHARACTER(LEN=255)  :: SAVE_PREFIX
         CHARACTER(LEN=7)   ::  pad7  
 !
@@ -199,10 +207,10 @@
 !       For heterogeneous architecture
         INTEGER, DIMENSION(:), POINTER :: MEM_DIST
 !       Compressed RHS
-        INTEGER, DIMENSION(:),   POINTER :: POSINRHSCOMP_ROW
-        LOGICAL  :: POSINRHSCOMP_COL_ALLOC, pad11
-        INTEGER, DIMENSION(:),   POINTER :: POSINRHSCOMP_COL
-        REAL, DIMENSION(:),   POINTER :: RHSCOMP
+        INTEGER, DIMENSION(:),   POINTER :: GLOB2LOC_RHS
+        LOGICAL  :: GLOB2LOC_SOL_ALLOC, pad11
+        INTEGER, DIMENSION(:),   POINTER :: GLOB2LOC_SOL
+        REAL, DIMENSION(:),   POINTER :: RHSINTR
 !       Info on the subtrees to be used during factorization
         DOUBLE PRECISION, DIMENSION(:), POINTER :: MEM_SUBTREE
         DOUBLE PRECISION, DIMENSION(:), POINTER :: COST_TRAV
@@ -216,7 +224,7 @@
         INTEGER, DIMENSION(:),   POINTER :: SCHED_GRP
         INTEGER, DIMENSION(:),   POINTER :: SCHED_SBTR
         INTEGER, DIMENSION(:),   POINTER :: CROIX_MANU
-        REAL, DIMENSION(:), POINTER :: WK_USER
+        REAL, DIMENSION(:),   POINTER :: WK_USER
         INTEGER :: NBSA_LOCAL
         INTEGER :: LWK_USER
 !    Internal control array
@@ -277,7 +285,7 @@
 ! Mapping of the subtree nodes
         INTEGER, DIMENSION(:), POINTER :: L0_OMP_MAPPING
 ! Mpi to omp - mumps agile
-        INTEGER, DIMENSION(:), POINTER :: MPITOOMP_PROCS_MAP
+        INTEGER, DIMENSION(:), POINTER :: MTKO_PROCS_MAP
 ! for RR on root
         REAL, DIMENSION(:), POINTER :: SINGULAR_VALUES
         INTEGER ::  NB_SINGULAR_VALUES
diff -pruN 5.6.2-2.1/include/zmumps_c.h 5.7.1-1/include/zmumps_c.h
--- 5.6.2-2.1/include/zmumps_c.h	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/include/zmumps_c.h	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
@@ -29,7 +29,7 @@ extern "C" {
 
 #ifndef MUMPS_VERSION
 /* Protected in case headers of other arithmetics are included */
-#define MUMPS_VERSION "5.6.2"
+#define MUMPS_VERSION "5.7.1"
 #endif
 #ifndef MUMPS_VERSION_MAX_LEN
 #define MUMPS_VERSION_MAX_LEN 30
@@ -91,12 +91,22 @@ typedef struct {
     MUMPS_INT colsca_from_mumps;
     MUMPS_INT rowsca_from_mumps;
 
+    /* Distributed scaling(out) */
+    ZMUMPS_REAL    *colsca_loc;
+    ZMUMPS_REAL    *rowsca_loc;
+
+    /* Info after facto */
+    MUMPS_INT      *rowind;
+    MUMPS_INT      *colind;
+    ZMUMPS_COMPLEX *pivots;
+
     /* RHS, solution, ouptput data and statistics */
-    ZMUMPS_COMPLEX *rhs, *redrhs, *rhs_sparse, *sol_loc, *rhs_loc;
-    MUMPS_INT      *irhs_sparse, *irhs_ptr, *isol_loc, *irhs_loc;
-    MUMPS_INT      nrhs, lrhs, lredrhs, nz_rhs, lsol_loc, nloc_rhs, lrhs_loc;
+    ZMUMPS_COMPLEX *rhs, *redrhs, *rhs_sparse, *sol_loc, *rhs_loc, *rhsintr;
+    MUMPS_INT      *irhs_sparse, *irhs_ptr, *isol_loc, *irhs_loc, *glob2loc_rhs, *glob2loc_sol;
+    MUMPS_INT      nrhs, lrhs, lredrhs, nz_rhs, lsol_loc, nloc_rhs, lrhs_loc, nsol_loc;
     MUMPS_INT      schur_mloc, schur_nloc, schur_lld;
     MUMPS_INT      mblock, nblock, nprow, npcol;
+    MUMPS_INT      ld_rhsintr;
     MUMPS_INT      info[80],infog[80];
     ZMUMPS_REAL    rinfo[40], rinfog[40];
 
@@ -104,30 +114,33 @@ typedef struct {
     MUMPS_INT      deficiency;
     MUMPS_INT      *pivnul_list;
     MUMPS_INT      *mapping;
+    ZMUMPS_REAL    *singular_values;
 
     /* Schur */
     MUMPS_INT      size_schur;
     MUMPS_INT      *listvar_schur;
     ZMUMPS_COMPLEX *schur;
 
-    /* Internal parameters */
-    MUMPS_INT      instance_number;
+    /* user workspace */
     ZMUMPS_COMPLEX *wk_user;
 
-    /* Version number: length=14 in FORTRAN + 1 for final \0 + 1 for alignment */
+    /* Version number: length=30 in FORTRAN + 1 for final \0 + 1 for alignment */
     char version_number[MUMPS_VERSION_MAX_LEN + 1 + 1];
     /* For out-of-core */
-    char ooc_tmpdir[256];
-    char ooc_prefix[64];
+    char ooc_tmpdir[1024];
+    char ooc_prefix[256];
     /* To save the matrix in matrix market format */
-    char write_problem[256];
+    char write_problem[1024];
     MUMPS_INT      lwk_user;
     /* For save/restore feature */
-    char save_dir[256];
+    char save_dir[1024];
     char save_prefix[256];
 
     /* Metis options */
     MUMPS_INT metis_options[40];
+
+    /* Internal parameters */
+    MUMPS_INT      instance_number;
 } ZMUMPS_STRUC_C;
 
 
diff -pruN 5.6.2-2.1/include/zmumps_root.h 5.7.1-1/include/zmumps_root.h
--- 5.6.2-2.1/include/zmumps_root.h	2023-10-11 09:37:02.000000000 +0000
+++ 5.7.1-1/include/zmumps_root.h	2024-05-02 10:15:25.000000000 +0000
@@ -1,9 +1,9 @@
 !
-!  This file is part of MUMPS 5.6.2, released
-!  on Wed Oct 11 09:36:25 UTC 2023
+!  This file is part of MUMPS 5.7.1, released
+!  on Thu May  2 10:15:09 UTC 2024
 !
 !
-!  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+!  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 !  Mumps Technologies, University of Bordeaux.
 !
 !  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/include/zmumps_struc.h 5.7.1-1/include/zmumps_struc.h
--- 5.6.2-2.1/include/zmumps_struc.h	2023-10-11 09:37:02.000000000 +0000
+++ 5.7.1-1/include/zmumps_struc.h	2024-05-02 10:15:25.000000000 +0000
@@ -1,9 +1,9 @@
 !
-!  This file is part of MUMPS 5.6.2, released
-!  on Wed Oct 11 09:36:25 UTC 2023
+!  This file is part of MUMPS 5.7.1, released
+!  on Thu May  2 10:15:09 UTC 2024
 !
 !
-!  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+!  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 !  Mumps Technologies, University of Bordeaux.
 !
 !  This version of MUMPS is provided to you free of charge. It is
@@ -46,7 +46,14 @@
         INTEGER(8) :: NNZ ! 64-bit integer input
         COMPLEX(kind=8), DIMENSION(:), POINTER :: A
         INTEGER, DIMENSION(:), POINTER :: IRN, JCN
-        DOUBLE PRECISION, DIMENSION(:), POINTER :: COLSCA, ROWSCA, pad0
+!    --------------
+!    Scaling arrays
+!    --------------
+        DOUBLE PRECISION, DIMENSION(:), POINTER :: COLSCA, ROWSCA
+        DOUBLE PRECISION, DIMENSION(:), POINTER :: COLSCA_loc
+        DOUBLE PRECISION, DIMENSION(:), POINTER :: ROWSCA_loc
+        INTEGER, DIMENSION(:), POINTER :: ROWIND, COLIND
+        COMPLEX(kind=8), DIMENSION(:), POINTER :: PIVOTS
 !
 !       ------------------------------------
 !       Case of distributed assembled matrix
@@ -96,7 +103,8 @@
         INTEGER, DIMENSION(:), POINTER :: ISOL_loc
         INTEGER, DIMENSION(:), POINTER :: IRHS_loc
         INTEGER :: LRHS, NRHS, NZ_RHS, Nloc_RHS, LRHS_loc, LREDRHS
-        INTEGER :: LSOL_loc, pad6
+        INTEGER :: LSOL_loc, NSOL_loc
+        INTEGER :: LD_RHSINTR, pad6
 !    ----------------------------
 !    Control parameters,
 !    statistics and output data
@@ -138,16 +146,16 @@
 !    -----------
 !    Out-of-core
 !    -----------
-        CHARACTER(LEN=255) :: OOC_TMPDIR
-        CHARACTER(LEN=63) :: OOC_PREFIX
+        CHARACTER(LEN=1023) :: OOC_TMPDIR
+        CHARACTER(LEN=255) :: OOC_PREFIX
 !    ------------------------------------------
 !    Name of file to dump a matrix/rhs to disk
 !    ------------------------------------------
-        CHARACTER(LEN=255) ::  WRITE_PROBLEM
+        CHARACTER(LEN=1023) ::  WRITE_PROBLEM
 !    -----------
 !    Save/Restore
 !    -----------
-        CHARACTER(LEN=255) :: SAVE_DIR
+        CHARACTER(LEN=1023) :: SAVE_DIR
         CHARACTER(LEN=255)  :: SAVE_PREFIX
         CHARACTER(LEN=7)   ::  pad7  
 !
@@ -199,10 +207,10 @@
 !       For heterogeneous architecture
         INTEGER, DIMENSION(:), POINTER :: MEM_DIST
 !       Compressed RHS
-        INTEGER, DIMENSION(:),   POINTER :: POSINRHSCOMP_ROW
-        LOGICAL  :: POSINRHSCOMP_COL_ALLOC, pad11
-        INTEGER, DIMENSION(:),   POINTER :: POSINRHSCOMP_COL
-        COMPLEX(kind=8), DIMENSION(:),   POINTER :: RHSCOMP
+        INTEGER, DIMENSION(:),   POINTER :: GLOB2LOC_RHS
+        LOGICAL  :: GLOB2LOC_SOL_ALLOC, pad11
+        INTEGER, DIMENSION(:),   POINTER :: GLOB2LOC_SOL
+        COMPLEX(kind=8), DIMENSION(:),   POINTER :: RHSINTR
 !       Info on the subtrees to be used during factorization
         DOUBLE PRECISION, DIMENSION(:), POINTER :: MEM_SUBTREE
         DOUBLE PRECISION, DIMENSION(:), POINTER :: COST_TRAV
@@ -216,7 +224,7 @@
         INTEGER, DIMENSION(:),   POINTER :: SCHED_GRP
         INTEGER, DIMENSION(:),   POINTER :: SCHED_SBTR
         INTEGER, DIMENSION(:),   POINTER :: CROIX_MANU
-        COMPLEX(kind=8), DIMENSION(:), POINTER :: WK_USER
+        COMPLEX(kind=8), DIMENSION(:),   POINTER :: WK_USER
         INTEGER :: NBSA_LOCAL
         INTEGER :: LWK_USER
 !    Internal control array
@@ -277,7 +285,7 @@
 ! Mapping of the subtree nodes
         INTEGER, DIMENSION(:), POINTER :: L0_OMP_MAPPING
 ! Mpi to omp - mumps agile
-        INTEGER, DIMENSION(:), POINTER :: MPITOOMP_PROCS_MAP
+        INTEGER, DIMENSION(:), POINTER :: MTKO_PROCS_MAP
 ! for RR on root
         DOUBLE PRECISION, DIMENSION(:), POINTER :: SINGULAR_VALUES
         INTEGER ::  NB_SINGULAR_VALUES
diff -pruN 5.6.2-2.1/libseq/Makefile 5.7.1-1/libseq/Makefile
--- 5.6.2-2.1/libseq/Makefile	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/libseq/Makefile	2024-05-02 10:15:12.000000000 +0000
@@ -1,6 +1,6 @@
 #
-#  This file is part of MUMPS 5.6.2, released
-#  on Wed Oct 11 09:36:25 UTC 2023
+#  This file is part of MUMPS 5.7.1, released
+#  on Thu May  2 10:15:09 UTC 2024
 #
 all: staticlibmpiseq
 
@@ -19,7 +19,7 @@ sharedlibmpiseq:
 	$(MAKE) FPIC="$(FPIC_OPT)" libmpiseq$(PLAT)$(LIBEXT_SHARED)
 
 libmpiseq$(PLAT)$(LIBEXT_SHARED): mpi.o mpic.o elapse.o
-	$(FC) -shared mpi.o mpic.o elapse.o -o libmpiseq$(PLAT)$(LIBEXT_SHARED)
+	$(FC) $(SHARED_OPT) mpi.o mpic.o elapse.o -o libmpiseq$(PLAT)$(LIBEXT_SHARED)
 
 .f.o:
 	$(FC) $(OPTF) $(FPIC)              -c $*.f $(OUTF)$*.o
diff -pruN 5.6.2-2.1/libseq/elapse.c 5.7.1-1/libseq/elapse.c
--- 5.6.2-2.1/libseq/elapse.c	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/libseq/elapse.c	2024-05-02 10:15:12.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/libseq/elapse.h 5.7.1-1/libseq/elapse.h
--- 5.6.2-2.1/libseq/elapse.h	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/libseq/elapse.h	2024-05-02 10:15:12.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/libseq/mpi.f 5.7.1-1/libseq/mpi.f
--- 5.6.2-2.1/libseq/mpi.f	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/libseq/mpi.f	2024-05-02 10:15:12.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -51,19 +51,22 @@ C***************************************
       RETURN
       END SUBROUTINE MPI_BUFFER_DETACH
       SUBROUTINE MPI_GATHER( SENDBUF, CNT, 
-     &         DATATYPE, RECVBUF, RECCNT, RECTYPE,
+     &         DATATYPE, RECVBUF, RECVCNT, RECTYPE,
      &         ROOT, COMM, IERR )
       IMPLICIT NONE
-      INTEGER CNT, DATATYPE, RECCNT, RECTYPE, ROOT, COMM, IERR
+      INTEGER CNT, DATATYPE, RECVCNT, RECTYPE, ROOT, COMM, IERR
       INTEGER SENDBUF(*), RECVBUF(*)
-      IF ( RECCNT .NE. CNT ) THEN
-        WRITE(*,*) 'ERROR in MPI_GATHER, RECCNT != CNT'
-        STOP
-      ELSE
-        CALL MUMPS_COPY( CNT, SENDBUF, RECVBUF, DATATYPE, IERR )
-        IF ( IERR .NE. 0 ) THEN
-          WRITE(*,*) 'ERROR in MPI_GATHER, DATATYPE=',DATATYPE
+      LOGICAL, EXTERNAL :: MUMPS_IS_IN_PLACE
+      IF (.NOT. MUMPS_IS_IN_PLACE(SENDBUF, CNT)) THEN
+        IF ( RECVCNT .NE. CNT ) THEN
+          WRITE(*,*) 'ERROR in MPI_GATHER, RECVCNT != CNT'
           STOP
+        ELSE
+          CALL MUMPS_COPY( CNT, SENDBUF, RECVBUF, 0, 0, DATATYPE, IERR )
+          IF ( IERR .NE. 0 ) THEN
+            WRITE(*,*) 'ERROR in MPI_GATHER, DATATYPE=',DATATYPE
+            STOP
+          END IF
         END IF
       END IF
       IERR = 0
@@ -71,29 +74,28 @@ C***************************************
       END SUBROUTINE MPI_GATHER
 C***********************************************************************
       SUBROUTINE MPI_GATHERV( SENDBUF, CNT, 
-     &         DATATYPE, RECVBUF, RECCNT, DISPLS, RECTYPE,
+     &         DATATYPE, RECVBUF, RECVCNT, DISPLS, RECTYPE,
      &         ROOT, COMM, IERR )
       IMPLICIT NONE
       INTEGER CNT, DATATYPE, RECTYPE, ROOT, COMM, IERR
-      INTEGER RECCNT(1)
+      INTEGER RECVCNT(1)
       INTEGER SENDBUF(*), RECVBUF(*)
       INTEGER DISPLS(*)
+      LOGICAL, EXTERNAL :: MUMPS_IS_IN_PLACE
 C
-C     Note that DISPLS is ignored in this version. One may
-C     want to copy in reception buffer with a shift DISPLS(1).
-C     This requires passing the offset DISPLS(1) to
-C     "MUMPS_COPY_DATATYPE" routines.
-C
-      IF ( RECCNT(1) .NE. CNT ) THEN
-        WRITE(*,*) 'ERROR in MPI_GATHERV, RECCNT(1) != CNT'
-        STOP
-      ELSE
-        CALL MUMPS_COPY( CNT, SENDBUF, RECVBUF, DATATYPE, IERR )
-        IF ( IERR .NE. 0 ) THEN
-          WRITE(*,*) 'ERROR in MPI_GATHERV, DATATYPE=',DATATYPE
+      IF (.NOT. MUMPS_IS_IN_PLACE(SENDBUF, CNT)) THEN
+        IF ( RECVCNT(1) .NE. CNT ) THEN
+          WRITE(*,*) 'ERROR in MPI_GATHERV, RECVCNT(1) != CNT'
           STOP
+        ELSE
+          CALL MUMPS_COPY( CNT, SENDBUF, RECVBUF, 0, DISPLS(1),
+     &                     DATATYPE, IERR )
+          IF ( IERR .NE. 0 ) THEN
+            WRITE(*,*) 'ERROR in MPI_GATHERV, DATATYPE=',DATATYPE
+            STOP
+          END IF
         END IF
-      END IF
+      ENDIF
       IERR = 0
       RETURN
       END SUBROUTINE MPI_GATHERV
@@ -105,7 +107,7 @@ C***************************************
       INTEGER SENDBUF(*), RECVBUF(*)
       LOGICAL, EXTERNAL :: MUMPS_IS_IN_PLACE
       IF (.NOT. MUMPS_IS_IN_PLACE(SENDBUF, CNT)) THEN
-        CALL MUMPS_COPY( CNT, SENDBUF, RECVBUF, DATATYPE, IERR )
+        CALL MUMPS_COPY( CNT, SENDBUF, RECVBUF, 0, 0, DATATYPE, IERR )
         IF ( IERR .NE. 0 ) THEN
           WRITE(*,*) 'ERROR in MPI_ALLREDUCE, DATATYPE=',DATATYPE
           STOP
@@ -122,7 +124,7 @@ C***************************************
       INTEGER SENDBUF(*), RECVBUF(*)
       LOGICAL, EXTERNAL :: MUMPS_IS_IN_PLACE
       IF (.NOT. MUMPS_IS_IN_PLACE(SENDBUF, CNT)) THEN
-        CALL MUMPS_COPY( CNT, SENDBUF, RECVBUF, DATATYPE, IERR )
+        CALL MUMPS_COPY( CNT, SENDBUF, RECVBUF, 0, 0, DATATYPE, IERR )
         IF ( IERR .NE. 0 ) THEN
           WRITE(*,*) 'ERROR in MPI_REDUCE, DATATYPE=',DATATYPE
           STOP
@@ -132,14 +134,15 @@ C***************************************
       RETURN
       END SUBROUTINE MPI_REDUCE
 C***********************************************************************
-      SUBROUTINE MPI_REDUCE_SCATTER( SENDBUF, RECVBUF, RCVCNT, 
+      SUBROUTINE MPI_REDUCE_SCATTER( SENDBUF, RECVBUF, RECVCNT, 
      &           DATATYPE, OP, COMM, IERR )
       IMPLICIT NONE
-      INTEGER RCVCNT, DATATYPE, OP, COMM, IERR
+      INTEGER RECVCNT, DATATYPE, OP, COMM, IERR
       INTEGER SENDBUF(*), RECVBUF(*)
       LOGICAL, EXTERNAL :: MUMPS_IS_IN_PLACE
-      IF (.NOT. MUMPS_IS_IN_PLACE(SENDBUF, RCVCNT)) THEN
-        CALL MUMPS_COPY( RCVCNT, SENDBUF, RECVBUF, DATATYPE, IERR )
+      IF (.NOT. MUMPS_IS_IN_PLACE(SENDBUF, RECVCNT)) THEN
+        CALL MUMPS_COPY( RECVCNT, SENDBUF, RECVBUF, 0, 0,
+     &                   DATATYPE, IERR )
         IF ( IERR .NE. 0 ) THEN
           WRITE(*,*) 'ERROR in MPI_REDUCE_SCATTER, DATATYPE=',DATATYPE
           STOP
@@ -161,23 +164,56 @@ C***************************************
       IMPLICIT NONE
       INTEGER SENDCNT, SENDTYPE, RECVCNT, RECVTYPE, COMM, IERR
       INTEGER SENDBUF(*), RECVBUF(*)
-      IF ( RECVCNT .NE. SENDCNT ) THEN
-        WRITE(*,*) 'ERROR in MPI_ALLTOALL, RECVCNT != SENDCNT'
-        STOP
-      ELSE IF ( RECVTYPE .NE. SENDTYPE ) THEN
-        WRITE(*,*) 'ERROR in MPI_ALLTOALL, RECVTYPE != SENDTYPE'
-        STOP
-      ELSE
-        CALL MUMPS_COPY( SENDCNT, SENDBUF, RECVBUF, SENDTYPE, IERR )
-        IF ( IERR .NE. 0 ) THEN
-          WRITE(*,*) 'ERROR in MPI_ALLTOALL, SENDTYPE=',SENDTYPE
+      LOGICAL, EXTERNAL :: MUMPS_IS_IN_PLACE
+      IF (.NOT. MUMPS_IS_IN_PLACE(SENDBUF, RECVCNT)) THEN
+        IF ( RECVCNT .NE. SENDCNT ) THEN
+          WRITE(*,*) 'ERROR in MPI_ALLTOALL, RECVCNT != SENDCNT'
+          STOP
+        ELSE IF ( RECVTYPE .NE. SENDTYPE ) THEN
+          WRITE(*,*) 'ERROR in MPI_ALLTOALL, RECVTYPE != SENDTYPE'
           STOP
+        ELSE
+          CALL MUMPS_COPY( SENDCNT, SENDBUF, RECVBUF,
+     &                     0, 0, SENDTYPE, IERR )
+          IF ( IERR .NE. 0 ) THEN
+            WRITE(*,*) 'ERROR in MPI_ALLTOALL, SENDTYPE=',SENDTYPE
+            STOP
+          END IF
         END IF
-      END IF
+      ENDIF
       IERR = 0
       RETURN
       END SUBROUTINE MPI_ALLTOALL
 C***********************************************************************
+      SUBROUTINE MPI_ALLTOALLV( SENDBUF, SENDCNT, SDISPLS, SENDTYPE, 
+     &                         RECVBUF, RECVCNT, RDISPLS, RECVTYPE, 
+     &                         COMM, IERR)
+
+      IMPLICIT NONE
+      INTEGER SENDCNT, SENDTYPE, RECVCNT, RECVTYPE, COMM, IERR
+      INTEGER SENDBUF(*), RECVBUF(*), SDISPLS(*), RDISPLS(*)
+      LOGICAL, EXTERNAL :: MUMPS_IS_IN_PLACE
+      IF (.NOT. MUMPS_IS_IN_PLACE(SENDBUF, RECVCNT)) THEN
+        IF ( RECVCNT .NE. SENDCNT ) THEN
+          WRITE(*,*) 'ERROR in MPI_ALLTOALLV, RECVCNT != SENDCNT'
+          STOP
+        ELSE IF ( RECVTYPE .NE. SENDTYPE ) THEN
+          WRITE(*,*) 'ERROR in MPI_ALLTOALLV, RECVTYPE != SENDTYPE'
+          STOP
+        ELSE
+          CALL MUMPS_COPY( SENDCNT, SENDBUF, RECVBUF,
+     &                     SDISPLS(1), RDISPLS(1), SENDTYPE, IERR )
+          IF ( IERR .NE. 0 ) THEN
+            WRITE(*,*) 'ERROR in MPI_ALLTOALL, SENDTYPE=',SENDTYPE
+            STOP
+          END IF
+        END IF
+      ENDIF
+      IERR = 0
+      RETURN
+      END SUBROUTINE MPI_ALLTOALLV
+C***********************************************************************
+
       SUBROUTINE MPI_ATTR_PUT( COMM, KEY, VAL, IERR )
       IMPLICIT NONE
       INTEGER COMM, KEY, VAL, IERR
@@ -501,6 +537,17 @@ C***************************************
       RETURN
       END SUBROUTINE MPI_TEST
 C***********************************************************************
+      SUBROUTINE MPI_TESTANY( CNT, IREQARRAY, IND, FLAG, STATUS, IERR)
+      IMPLICIT NONE
+      INCLUDE 'mpif.h'
+      LOGICAL FLAG
+      INTEGER IND, IERR, CNT
+      INTEGER IREQARRAY(IND), STATUS(MPI_STATUS_SIZE)
+      FLAG=.FALSE.
+      IERR=0
+      RETURN
+      END SUBROUTINE MPI_TESTANY
+C***********************************************************************
       SUBROUTINE MPI_UNPACK( INBUF, INSIZE, POSITION, OUTBUF, OUTCNT,
      &           DATATYPE, COMM, IERR )
       IMPLICIT NONE
@@ -613,30 +660,32 @@ C  Utilities to copy data
 C
 C***********************************************************************
 
-      SUBROUTINE MUMPS_COPY( CNT, SENDBUF, RECVBUF, DATATYPE, IERR )
+      SUBROUTINE MUMPS_COPY( CNT, SENDBUF, RECVBUF, SS, RS,
+     &                       DATATYPE, IERR )
       IMPLICIT NONE
       INCLUDE 'mpif.h'
-      INTEGER CNT, DATATYPE, IERR
+C     SS/RS: shift for SENDBUF/RECVBUF
+      INTEGER CNT, DATATYPE, IERR, SS, RS
       INTEGER SENDBUF(*), RECVBUF(*)
       IF ( DATATYPE .EQ. MPI_INTEGER ) THEN
-         CALL MUMPS_COPY_INTEGER( SENDBUF, RECVBUF, CNT )
+      CALL MUMPS_COPY_INTEGER( SENDBUF, RECVBUF, CNT, SS, RS )
       ELSEIF ( DATATYPE .EQ. MPI_LOGICAL ) THEN
-         CALL MUMPS_COPY_LOGICAL( SENDBUF, RECVBUF, CNT )
+      CALL MUMPS_COPY_LOGICAL( SENDBUF, RECVBUF, CNT, SS, RS )
       ELSE IF ( DATATYPE .EQ. MPI_REAL ) THEN
-         CALL MUMPS_COPY_REAL( SENDBUF, RECVBUF, CNT )
+      CALL MUMPS_COPY_REAL( SENDBUF, RECVBUF, CNT, SS, RS )
       ELSE IF ( DATATYPE .EQ. MPI_DOUBLE_PRECISION .OR.
      &        DATATYPE .EQ. MPI_REAL8 ) THEN
-         CALL MUMPS_COPY_DOUBLE_PRECISION( SENDBUF, RECVBUF, CNT )
+      CALL MUMPS_COPY_DOUBLE_PRECISION( SENDBUF, RECVBUF, CNT, SS, RS )
       ELSE IF ( DATATYPE .EQ. MPI_COMPLEX ) THEN
-         CALL MUMPS_COPY_COMPLEX( SENDBUF, RECVBUF, CNT )
+      CALL MUMPS_COPY_COMPLEX( SENDBUF, RECVBUF, CNT, SS, RS )
       ELSE IF ( DATATYPE .EQ. MPI_DOUBLE_COMPLEX ) THEN
-         CALL MUMPS_COPY_DOUBLE_COMPLEX( SENDBUF, RECVBUF, CNT )
+      CALL MUMPS_COPY_DOUBLE_COMPLEX( SENDBUF, RECVBUF, CNT, SS, RS )
       ELSE IF ( DATATYPE .EQ. MPI_2DOUBLE_PRECISION) THEN
-         CALL MUMPS_COPY_2DOUBLE_PRECISION( SENDBUF, RECVBUF, CNT )
+      CALL MUMPS_COPY_2DOUBLE_PRECISION( SENDBUF, RECVBUF, CNT, SS, RS )
       ELSE IF ( DATATYPE .EQ. MPI_2INTEGER) THEN
-         CALL MUMPS_COPY_2INTEGER( SENDBUF, RECVBUF, CNT )
+      CALL MUMPS_COPY_2INTEGER( SENDBUF, RECVBUF, CNT, SS, RS )
       ELSE IF ( DATATYPE .EQ. MPI_INTEGER8) THEN
-        CALL MUMPS_COPY_INTEGER8( SENDBUF, RECVBUF, CNT )
+      CALL MUMPS_COPY_INTEGER8( SENDBUF, RECVBUF, CNT, SS, RS )
       ELSE
         IERR=1
         RETURN
@@ -645,101 +694,101 @@ C***************************************
       RETURN
       END SUBROUTINE MUMPS_COPY
 
-      SUBROUTINE MUMPS_COPY_INTEGER( S, R, N )
+      SUBROUTINE MUMPS_COPY_INTEGER( S, R, N, SS, RS )
       IMPLICIT NONE
-      INTEGER N
+      INTEGER N, SS, RS
       INTEGER S(N),R(N)
       INTEGER I
       DO I = 1, N
-        R(I) = S(I)
+        R(I+RS) = S(I+SS)
       END DO
       RETURN
       END SUBROUTINE MUMPS_COPY_INTEGER
-      SUBROUTINE MUMPS_COPY_INTEGER8( S, R, N )
+      SUBROUTINE MUMPS_COPY_INTEGER8( S, R, N, SS, RS )
       IMPLICIT NONE
-      INTEGER N
+      INTEGER N, SS, RS
       INTEGER(8) S(N),R(N)
       INTEGER I
       DO I = 1, N
-        R(I) = S(I)
+        R(I+RS) = S(I+SS)
       END DO
       RETURN
       END SUBROUTINE MUMPS_COPY_INTEGER8
-      SUBROUTINE MUMPS_COPY_LOGICAL( S, R, N )
+      SUBROUTINE MUMPS_COPY_LOGICAL( S, R, N, SS, RS )
       IMPLICIT NONE
-      INTEGER N
+      INTEGER N, SS, RS
       LOGICAL S(N),R(N)
       INTEGER I
       DO I = 1, N
-        R(I) = S(I)
+        R(I+RS) = S(I+SS)
       END DO
       RETURN
       END
-      SUBROUTINE MUMPS_COPY_2INTEGER( S, R, N )
+      SUBROUTINE MUMPS_COPY_2INTEGER( S, R, N, SS, RS )
       IMPLICIT NONE
-      INTEGER N
+      INTEGER N, SS, RS
       INTEGER S(N+N),R(N+N)
       INTEGER I
       DO I = 1, N+N
-        R(I) = S(I)
+        R(I+RS+RS) = S(I+SS+SS)
       END DO
       RETURN
       END SUBROUTINE MUMPS_COPY_2INTEGER
-      SUBROUTINE MUMPS_COPY_REAL( S, R, N )
+      SUBROUTINE MUMPS_COPY_REAL( S, R, N, SS, RS )
       IMPLICIT NONE
-      INTEGER N
+      INTEGER N, SS, RS
       REAL S(N),R(N)
       INTEGER I
       DO I = 1, N
-        R(I) = S(I)
+        R(I+RS) = S(I+SS)
       END DO
       RETURN
       END
-      SUBROUTINE MUMPS_COPY_2DOUBLE_PRECISION( S, R, N )
+      SUBROUTINE MUMPS_COPY_2DOUBLE_PRECISION( S, R, N, SS, RS )
       IMPLICIT NONE
-      INTEGER N
+      INTEGER N, SS, RS
       DOUBLE PRECISION S(N+N),R(N+N)
       INTEGER I
       DO I = 1, N+N
-        R(I) = S(I)
+        R(I+RS+RS) = S(I+SS+SS)
       END DO
       RETURN
       END SUBROUTINE MUMPS_COPY_2DOUBLE_PRECISION
-      SUBROUTINE MUMPS_COPY_DOUBLE_PRECISION( S, R, N )
+      SUBROUTINE MUMPS_COPY_DOUBLE_PRECISION( S, R, N, SS, RS )
       IMPLICIT NONE
-      INTEGER N
+      INTEGER N, SS, RS
       DOUBLE PRECISION S(N),R(N)
       INTEGER I
       DO I = 1, N
-        R(I) = S(I)
+        R(I+RS) = S(I+SS)
       END DO
       RETURN
       END
-      SUBROUTINE MUMPS_COPY_COMPLEX( S, R, N )
+      SUBROUTINE MUMPS_COPY_COMPLEX( S, R, N, SS, RS )
       IMPLICIT NONE
-      INTEGER N
+      INTEGER N, SS, RS
       COMPLEX S(N),R(N)
       INTEGER I
       DO I = 1, N
-        R(I) = S(I)
+        R(I+RS) = S(I+SS)
       END DO
       RETURN
       END SUBROUTINE MUMPS_COPY_COMPLEX
-      SUBROUTINE MUMPS_COPY_DOUBLE_COMPLEX( S, R, N )
+      SUBROUTINE MUMPS_COPY_DOUBLE_COMPLEX( S, R, N, SS, RS )
       IMPLICIT NONE
-      INTEGER N
+      INTEGER N, SS, RS
 C     DOUBLE COMPLEX S(N),R(N)
       COMPLEX(kind=kind(0.0D0)) :: S(N),R(N)
       INTEGER I
       DO I = 1, N
-        R(I) = S(I)
+        R(I+RS) = S(I+SS)
       END DO
       RETURN
       END
       LOGICAL FUNCTION MUMPS_IS_IN_PLACE( SENDBUF, CNT )
       INTEGER SENDBUF(*), CNT
       INCLUDE 'mpif.h'
-      INTEGER :: I
+      INTEGER(8) :: I
 C     Check address using C code
       MUMPS_IS_IN_PLACE = .FALSE.
       IF ( CNT .GT. 0 ) THEN
@@ -1653,4 +1702,16 @@ C***************************************
         STOP
       RETURN
       END SUBROUTINE descset
+      SUBROUTINE MPI_COMM_CREATE_ERRHANDLER(COMM_ERRHANDLER_FN,
+     & ERRHANDLER, IERROR)
+      IMPLICIT NONE
+      EXTERNAL COMM_ERRHANDLER_FN
+      INTEGER ERRHANDLER, IERROR
+      RETURN
+      END SUBROUTINE MPI_COMM_CREATE_ERRHANDLER
+      SUBROUTINE MPI_ERRHANDLER_FREE(ERRHANDLER, IERROR)
+      IMPLICIT NONE
+      INTEGER ERRHANDLER, IERROR
+      RETURN
+      END SUBROUTINE MPI_ERRHANDLER_FREE
 
diff -pruN 5.6.2-2.1/libseq/mpi.h 5.7.1-1/libseq/mpi.h
--- 5.6.2-2.1/libseq/mpi.h	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/libseq/mpi.h	2024-05-02 10:15:12.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
@@ -13,13 +13,21 @@
  *  https://cecill.info/licences/Licence_CeCILL-C_V1-en.html)
  *
  */
-#ifdef INTSIZE64
+/* libseq is currently compiled independently of MUMPS
+ * and mumps_c_types.h and default integer size relies
+ * on compilation with -DINTSIZE64
+ */
+
 #include <inttypes.h>
+#ifdef INTSIZE64
 #define LIBSEQ_INT int64_t
+#define LIBSEQ_INT8 int64_t
 #else
 #define LIBSEQ_INT int
+#define LIBSEQ_INT8 int64_t
 #endif
 
+
 #if ! defined(LIBSEQ_CALL)
 #if defined(_WIN32) && ! defined(__MINGW32__)
 /* Choose between next lines or modify according
@@ -45,23 +53,22 @@ extern "C" {
 
 /* This is the minimum to have the C interface to MUMPS work with the
  * C example provided. Other stub functions of the MPI standard may be
- * added if needed. */
+ * added as needed. */
 
 typedef LIBSEQ_INT MPI_Comm; /* Simple type for MPI communicator */
-typedef LIBSEQ_INT MPI_Fint; /* Simple type for MPI communicator */
 static MPI_Comm MPI_COMM_WORLD=(MPI_Comm)0;
 
-LIBSEQ_INT LIBSEQ_CALL MPI_Init(LIBSEQ_INT *pargc, char ***pargv);
-LIBSEQ_INT LIBSEQ_CALL MPI_Comm_rank(MPI_Comm  comm, LIBSEQ_INT  *rank);
-LIBSEQ_INT LIBSEQ_CALL MPI_Finalize(void);
+int LIBSEQ_CALL MPI_Init(int *pargc, char ***pargv);
+int LIBSEQ_CALL MPI_Comm_rank(MPI_Comm  comm, int  *rank);
+int LIBSEQ_CALL MPI_Finalize(void);
 MPI_Comm LIBSEQ_CALL MPI_Comm_f2c(LIBSEQ_INT comm);
 
 /* For MPI_IS_IN_PLACE tests */
-void LIBSEQ_CALL MUMPS_CHECKADDREQUAL(char *a, char*b, LIBSEQ_INT *i);
-void LIBSEQ_CALL MUMPS_CHECKADDREQUAL_(char *a, char*b, LIBSEQ_INT *i);
-void LIBSEQ_CALL mumps_checkaddrequal_(char *a, char*b, LIBSEQ_INT *i);
-void LIBSEQ_CALL mumps_checkaddrequal__(char *a, char*b, LIBSEQ_INT *i);
-double LIBSEQ_CALL MPI_Wtime();
+void LIBSEQ_CALL MUMPS_CHECKADDREQUAL(char *a, char*b, LIBSEQ_INT8 *i);
+void LIBSEQ_CALL MUMPS_CHECKADDREQUAL_(char *a, char*b, LIBSEQ_INT8 *i);
+void LIBSEQ_CALL mumps_checkaddrequal_(char *a, char*b, LIBSEQ_INT8 *i);
+void LIBSEQ_CALL mumps_checkaddrequal__(char *a, char*b, LIBSEQ_INT8 *i);
+double LIBSEQ_CALL MPI_Wtime(void);
 
 #ifdef __cplusplus
 }
diff -pruN 5.6.2-2.1/libseq/mpic.c 5.7.1-1/libseq/mpic.c
--- 5.6.2-2.1/libseq/mpic.c	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/libseq/mpic.c	2024-05-02 10:15:12.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
@@ -20,24 +20,24 @@ MPI_Comm LIBSEQ_CALL MPI_Comm_f2c(LIBSEQ
   return 0;
 }
 
-LIBSEQ_INT LIBSEQ_CALL MPI_Init(LIBSEQ_INT *pargc, char ***pargv)
+int LIBSEQ_CALL MPI_Init(int *pargc, char ***pargv)
 {
   return 0;
 }
 
-LIBSEQ_INT LIBSEQ_CALL MPI_Comm_rank(MPI_Comm comm, LIBSEQ_INT *rank)
+int LIBSEQ_CALL MPI_Comm_rank(MPI_Comm comm, int *rank)
 {
   *rank=0;
   return 0;
 }
-LIBSEQ_INT LIBSEQ_CALL MPI_Finalize(void)
+int LIBSEQ_CALL MPI_Finalize(void)
 {
    return 0;
 }
 
 /* Internal: for MPI_IS_IN_PLACE tests from Fortran */
 
-void LIBSEQ_CALL MUMPS_CHECKADDREQUAL(char *a, char*b, LIBSEQ_INT *i)
+void LIBSEQ_CALL MUMPS_CHECKADDREQUAL(char *a, char*b, LIBSEQ_INT8 *i)
 {
   if (a - b == 0)
    {
@@ -49,15 +49,15 @@ void LIBSEQ_CALL MUMPS_CHECKADDREQUAL(ch
    }
 }
 
-void LIBSEQ_CALL MUMPS_CHECKADDREQUAL_(char *a, char*b, LIBSEQ_INT *i)
+void LIBSEQ_CALL MUMPS_CHECKADDREQUAL_(char *a, char*b, LIBSEQ_INT8 *i)
  {
    MUMPS_CHECKADDREQUAL(a,b,i);
  }
-void LIBSEQ_CALL mumps_checkaddrequal_(char *a, char*b, LIBSEQ_INT *i)
+void LIBSEQ_CALL mumps_checkaddrequal_(char *a, char*b, LIBSEQ_INT8 *i)
  {
    MUMPS_CHECKADDREQUAL(a,b,i);
  }
-void LIBSEQ_CALL mumps_checkaddrequal__(char *a, char*b, LIBSEQ_INT *i)
+void LIBSEQ_CALL mumps_checkaddrequal__(char *a, char*b, LIBSEQ_INT8 *i)
  {
    MUMPS_CHECKADDREQUAL(a,b,i);
  }
diff -pruN 5.6.2-2.1/libseq/mpif.h 5.7.1-1/libseq/mpif.h
--- 5.6.2-2.1/libseq/mpif.h	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/libseq/mpif.h	2024-05-02 10:15:12.000000000 +0000
@@ -1,9 +1,9 @@
 !
-!  This file is part of MUMPS 5.6.2, released
-!  on Wed Oct 11 09:36:25 UTC 2023
+!  This file is part of MUMPS 5.7.1, released
+!  on Thu May  2 10:15:09 UTC 2024
 !
 !
-!  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+!  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 !  Mumps Technologies, University of Bordeaux.
 !
 !  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/Makefile 5.7.1-1/src/Makefile
--- 5.6.2-2.1/src/Makefile	2023-10-11 09:36:26.000000000 +0000
+++ 5.7.1-1/src/Makefile	2024-05-02 10:15:09.000000000 +0000
@@ -1,6 +1,6 @@
 #
-#  This file is part of MUMPS 5.6.2, released
-#  on Wed Oct 11 09:36:25 UTC 2023
+#  This file is part of MUMPS 5.7.1, released
+#  on Thu May  2 10:15:09 UTC 2024
 #
 #
 topdir = ..
@@ -64,6 +64,7 @@ OBJS_COMMON_MOD = \
         mumps_memory_mod.o\
         mumps_mpitoomp_m.o\
         mumps_ooc_common.o\
+	sol_ds_common_m.o\
         mumps_static_mapping.o\
         omp_tps_common_m.o
 
@@ -75,7 +76,6 @@ OBJS_COMMON_OTHER = \
         ana_AMDMF.o\
         bcast_errors.o\
         estim_flops.o\
-        mumps_type_size.o \
         mumps_type2_blocking.o \
         mumps_version.o \
         mumps_print_defined.o \
@@ -144,6 +144,7 @@ OBJS_OTHER = \
         $(ARITH)fac_driver.o\
         $(ARITH)sol_driver.o\
         $(ARITH)sol_distrhs.o\
+        $(ARITH)sol_distsol.o\
         $(ARITH)end_driver.o\
         $(ARITH)ana_aux_ELT.o\
         $(ARITH)ana_dist_m.o\
@@ -154,7 +155,9 @@ OBJS_OTHER = \
         $(ARITH)fac_asm_ELT.o\
         $(ARITH)fac_asm.o\
         $(ARITH)fac_b.o\
+        $(ARITH)fac_diag.o\
         $(ARITH)fac_distrib_distentry.o\
+        $(ARITH)fac_dist_arrowheads_omp.o\
         $(ARITH)fac_distrib_ELT.o\
         $(ARITH)fac_lastrtnelind.o\
         $(ARITH)fac_mem_alloc_cb.o\
@@ -214,14 +217,14 @@ $(libdir)/libmumps_common$(PLAT)$(LIBEXT
 	$(RANLIB) $@
 
 $(libdir)/libmumps_common$(PLAT)$(LIBEXT_SHARED):      $(OBJS_COMMON_MOD) $(OBJS_COMMON_OTHER)
-	$(FC) $(OPTL) -shared $^ -Wl,$(SONAME),libmumps_common$(PLAT)$(LIBEXT_SHARED) -L$(libdir) $(RPATH_OPT) $(LORDERINGS) $(LIBS) $(LIBOTHERS) -o $@ 
+	$(FC) $(OPTL) $(SHARED_OPT) $^ -Wl,$(SONAME),libmumps_common$(PLAT)$(LIBEXT_SHARED) -L$(libdir) $(RPATH_OPT) $(LORDERINGS) $(LIBS) $(LIBOTHERS) -o $@ 
 
 $(libdir)/lib$(ARITH)mumps$(PLAT)$(LIBEXT):    $(OBJS_MOD) $(OBJS_OTHER)
 	$(AR)$@ $?
 	$(RANLIB) $@
 
 $(libdir)/lib$(ARITH)mumps$(PLAT)$(LIBEXT_SHARED):    $(OBJS_MOD) $(OBJS_OTHER) $(libdir)/libmumps_common$(PLAT)$(LIBEXT_SHARED)
-	$(FC) $(OPTL) -shared $(OBJS_MOD) $(OBJS_OTHER) -L$(libdir) $(LORDERINGS) $(LIBS) $(LIBOTHERS) -lmumps_common$(PLAT) -o $@ $(RPATH_OPT)
+	$(FC) $(OPTL) $(SHARED_OPT) $(OBJS_MOD) $(OBJS_OTHER) -L$(libdir) $(LORDERINGS) $(LIBS) $(LIBOTHERS) -lmumps_common$(PLAT) -o $@ $(RPATH_OPT)
 
 
 # Dependencies between modules:
diff -pruN 5.6.2-2.1/src/ana_AMDMF.F 5.7.1-1/src/ana_AMDMF.F
--- 5.6.2-2.1/src/ana_AMDMF.F	2023-10-11 09:36:34.000000000 +0000
+++ 5.7.1-1/src/ana_AMDMF.F	2024-05-02 10:15:13.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -994,10 +994,6 @@ C
         prev_nbr = 0
         do jidx=1, n
            j = abs(porder(jidx))
-#if defined(check)
-           if (parent(j).eq.0)
-     &     write(6,*) " ========= jidx,j= ", jidx,j," is a rootnode "
-#endif
            if(parent(j) .ne. 0) then
               if (KEEP378.eq.1) then
                if (cc(parent(j)) .lt. 0) then
diff -pruN 5.6.2-2.1/src/ana_blk.F 5.7.1-1/src/ana_blk.F
--- 5.6.2-2.1/src/ana_blk.F	2023-10-11 09:36:34.000000000 +0000
+++ 5.7.1-1/src/ana_blk.F	2024-05-02 10:15:13.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -11,14 +11,15 @@ C  released under the CeCILL-C license
 C  (see doc/CeCILL-C_V1-en.txt, doc/CeCILL-C_V1-fr.txt, and
 C  https://cecill.info/licences/Licence_CeCILL-C_V1-en.html)
 C
-      SUBROUTINE MUMPS_AB_FREE_LMAT ( LMAT )
+      SUBROUTINE MUMPS_AB_FREE_LMAT ( LMAT, K147 )
       USE MUMPS_ANA_BLK_M, ONLY : LMATRIX_T
       IMPLICIT NONE
-      TYPE(LMATRIX_T) :: LMAT
+      TYPE(LMATRIX_T)     :: LMAT
+      INTEGER, INTENT(IN) :: K147
       INTEGER :: J
       IF (associated(LMAT%COL)) THEN
         IF (LMAT%NBCOL_LOC.GT.0) THEN
-         DO J = 1,LMAT%NBCOL_LOC
+         DO J = 1,LMAT%NBCOL_LOC, K147
            IF (associated(LMAT%COL(J)%IRN)) THEN
              DEALLOCATE(LMAT%COL(J)%IRN)
              NULLIFY(LMAT%COL(J)%IRN)
@@ -86,8 +87,9 @@ C
       LOGICAL :: LU_WITH_SYM_STRUCT, NO_DUPPLICATES
       INTEGER, ALLOCATABLE, DIMENSION(:) :: FLAG
       INTEGER :: allocok, IERROR_LOC
-      INTEGER :: I, J, JJB, IIB, IB, JB, NB, PT
-      INTEGER(8) :: I8
+      INTEGER :: I, J, JJ, JJB, IIB, IB, JB, PT
+      INTEGER(8) :: I8, NB_8, PT_CUR, SIZE_TO_ALLOC_8
+      INTEGER, POINTER, DIMENSION(:) :: BLOCK_PTR
       LU_WITH_SYM_STRUCT = (KEEP(202).EQ.1)
       NO_DUPPLICATES     = (KEEP(203).EQ.1)
       LMAT%NBCOL = NBLK
@@ -136,18 +138,34 @@ C
            IERROR = IERROR_LOC
          ENDIF
       ENDIF
-      DO JB=1,LMAT%NBCOL_LOC
-       NB =  LMAT%COL(JB)%NBINCOL
-       IF (NB.GT.0) THEN
-        ALLOCATE(LMAT%COL(JB)%IRN(NB), STAT=allocok)
-        IF (allocok.NE.0) THEN
-           IFLAG  = -7
-           IERROR = NB
-           IF ( LPOK ) THEN
-              WRITE(LP, *) " ERROR allocate of LMAT%COL"
-           END IF
-           RETURN
-        ENDIF
+      DO JB=1,LMAT%NBCOL_LOC, KEEP(147)
+       SIZE_TO_ALLOC_8 = 0_8
+       DO JJ=JB, min(JB+KEEP(147)-1,LMAT%NBCOL_LOC)
+         SIZE_TO_ALLOC_8 = SIZE_TO_ALLOC_8 + 
+     &                     int(LMAT%COL(JJ)%NBINCOL, 8)
+       ENDDO
+       ALLOCATE(LMAT%COL(JB)%IRN(SIZE_TO_ALLOC_8), STAT=allocok)
+       IF (allocok.NE.0) THEN
+          IFLAG  = -7
+          CALL MUMPS_SET_IERROR(SIZE_TO_ALLOC_8, IERROR)
+          IF ( LPOK ) THEN
+             WRITE(LP, *) " ERROR allocate block of ", 
+     &               KEEP(147), " columns in LMAT%COL",
+     &               " of size ", SIZE_TO_ALLOC_8
+          END IF
+          RETURN
+       ENDIF
+       IF (KEEP(147).GT.1) THEN
+         BLOCK_PTR => LMAT%COL(JB)%IRN
+         NB_8    = int(LMAT%COL(JB)%NBINCOL, 8) 
+         PT_CUR = 1_8 + NB_8 
+         DO JJ=JB+1, min(JB+KEEP(147)-1,LMAT%NBCOL_LOC)
+           NB_8 =  int(LMAT%COL(JJ)%NBINCOL,8)
+           IF (NB_8.GT.0) THEN
+            LMAT%COL(JJ)%IRN => BLOCK_PTR(PT_CUR: PT_CUR+NB_8-1_8)
+            PT_CUR = PT_CUR + NB_8
+           ENDIF
+         ENDDO
        ENDIF
       ENDDO
       DO I8=1, NNZ
@@ -176,81 +194,94 @@ C
      &     )
      &   THEN
         CALL MUMPS_AB_LOCALCLEAN_LMAT ( MYID,
-     &     LMAT, FLAG(1), LMAT%NBCOL, IFLAG, IERROR, LP, LPOK
+     &     LMAT, KEEP(147), 
+     &     FLAG(1), LMAT%NBCOL, IFLAG, IERROR, LP, LPOK
      &   )
       ENDIF
       DEALLOCATE(FLAG)
       RETURN
       END SUBROUTINE MUMPS_AB_COORD_TO_LMAT
       SUBROUTINE MUMPS_AB_LOCALCLEAN_LMAT (  MYID,
-     &     LMAT, FLAG, NBCOL, IFLAG, IERROR, LP, LPOK
+     &     LMAT, K147, FLAG, NBCOL, IFLAG, IERROR, LP, LPOK
      &     )
       USE MUMPS_ANA_BLK_M, ONLY : LMATRIX_T
       IMPLICIT NONE
       INTEGER, INTENT(IN) :: MYID, LP
       LOGICAL, INTENT(IN) :: LPOK
-      INTEGER, INTENT(IN)  :: NBCOL
+      INTEGER, INTENT(IN)  :: NBCOL, K147
       INTEGER, INTENT(OUT) :: FLAG(NBCOL)
       INTEGER, INTENT(INOUT) :: IFLAG, IERROR
       TYPE(LMATRIX_T), INTENT(INOUT)  :: LMAT
       INTEGER, POINTER, DIMENSION(:)     :: PTCLEAN
-      INTEGER :: allocok, IB, JB, NB, LMAT_FIRST, NBCOL_LOC
+      INTEGER :: allocok, IB, JB, JJ, LMAT_FIRST, NBCOL_LOC
+      INTEGER(8) :: NB_8, PT_CUR, SIZE_TO_ALLOC_8
       LMAT_FIRST = LMAT%FIRST
       NBCOL_LOC  = LMAT%NBCOL_LOC
       DO JB=1, NBCOL
         FLAG(JB) = 0
       ENDDO
       LMAT%NZL = 0_8
-      DO JB=1, NBCOL_LOC
-       IF ( LMAT%COL(JB)%NBINCOL.EQ.0) CYCLE
-       NB = 0
-       DO IB=1,  LMAT%COL(JB)%NBINCOL
-        IF (FLAG(LMAT%COL(JB)%IRN(IB)).EQ.JB+LMAT_FIRST-1) THEN
-         LMAT%COL(JB)%IRN(IB)=0
-        ELSE
-         NB = NB+1
-         LMAT%NZL = LMAT%NZL+1_8
-         FLAG(LMAT%COL(JB)%IRN(IB)) = JB+LMAT_FIRST-1
-        ENDIF
+      DO JB=1, NBCOL_LOC, K147
+       SIZE_TO_ALLOC_8 = 0_8
+       DO JJ=JB, min(JB+K147-1,NBCOL_LOC)
+         IF ( LMAT%COL(JJ)%NBINCOL.EQ.0) CYCLE
+         DO IB=1,  LMAT%COL(JJ)%NBINCOL
+          IF (FLAG(LMAT%COL(JJ)%IRN(IB)).EQ.JJ+LMAT_FIRST-1) THEN
+           LMAT%COL(JJ)%IRN(IB)=0
+          ELSE
+           SIZE_TO_ALLOC_8 = SIZE_TO_ALLOC_8 + 1_8
+           LMAT%NZL = LMAT%NZL+1_8
+           FLAG(LMAT%COL(JJ)%IRN(IB)) = JJ+LMAT_FIRST-1
+          ENDIF
+         ENDDO
        ENDDO
-       IF (NB.GT.0) THEN
-         ALLOCATE(PTCLEAN(NB), STAT=allocok)
+       IF (SIZE_TO_ALLOC_8.GT.0) THEN
+         ALLOCATE(PTCLEAN(SIZE_TO_ALLOC_8), STAT=allocok)
          IF (allocok.NE.0) THEN
            IFLAG     = -7
-           IERROR    = NB
+           CALL MUMPS_SET_IERROR(SIZE_TO_ALLOC_8, IERROR)
            IF ( LPOK ) THEN
               WRITE(LP, *) " ERROR allocate PTCLEAN of size", 
      &                     IERROR
            END IF
            RETURN
          ENDIF
-         NB=0
-         DO IB=1,  LMAT%COL(JB)%NBINCOL
-          IF (LMAT%COL(JB)%IRN(IB).NE.0) THEN
-           NB = NB+1
-           PTCLEAN(NB)=LMAT%COL(JB)%IRN(IB)
-          ENDIF
+         PT_CUR = 1_8
+         DO JJ=JB, min(JB+K147-1,NBCOL_LOC)
+           NB_8   = 0_8
+           DO IB=1,  LMAT%COL(JJ)%NBINCOL
+            IF (LMAT%COL(JJ)%IRN(IB).NE.0) THEN
+             PTCLEAN(PT_CUR+NB_8)=LMAT%COL(JJ)%IRN(IB)
+             NB_8 = NB_8 + 1_8
+            ENDIF
+           ENDDO
+           LMAT%COL(JJ)%NBINCOL = int(NB_8)
+           IF (JJ.GT.JB) 
+     &     LMAT%COL(JJ)%IRN     => PTCLEAN(PT_CUR: PT_CUR+NB_8-1_8)
+           PT_CUR = PT_CUR + NB_8
          ENDDO
-         LMAT%COL(JB)%NBINCOL  = NB
          deallocate(LMAT%COL(JB)%IRN)
          LMAT%COL(JB)%IRN => PTCLEAN
          NULLIFY(PTCLEAN)
        ELSE
-          if (associated(LMAT%COL(JB)%IRN)) 
+         if (associated(LMAT%COL(JB)%IRN)) 
      &           deallocate(LMAT%COL(JB)%IRN)
-          NULLIFY(LMAT%COL(JB)%IRN)
+         NULLIFY(LMAT%COL(JB)%IRN)
        ENDIF
       ENDDO
       RETURN
       END SUBROUTINE MUMPS_AB_LOCALCLEAN_LMAT
       SUBROUTINE MUMPS_AB_CLEANLMAT_TO_LUMAT( 
-     &     LMAT, LUMAT, INFO, ICNTL )
+     &     LMAT, LUMAT, K147, INFO, ICNTL )
       USE MUMPS_ANA_BLK_M, ONLY : LMATRIX_T
       IMPLICIT NONE
       TYPE(LMATRIX_T)        :: LMAT, LUMAT
+      INTEGER, INTENT(IN)    :: K147
       INTEGER, INTENT(IN)    :: ICNTL(60)
       INTEGER, INTENT(INOUT) :: INFO(80)
-      INTEGER    :: IB, IIB, JB, allocok, LP, MPG, NB, IERR
+      INTEGER    :: IB, JJ, IIB, JB, allocok, LP, MPG, NB
+      INTEGER(8) :: NB_8, PT_CUR, SIZE_TO_ALLOC_8
+      INTEGER, POINTER, DIMENSION(:) :: BLOCK_PTR
       LOGICAL LPOK, PROKG
       LP    = ICNTL( 1 )
       LPOK  = ((LP.GT.0).AND.(ICNTL(4).GE.1))
@@ -278,17 +309,35 @@ C
           LUMAT%COL(IIB)%NBINCOL = LUMAT%COL(IIB)%NBINCOL + 1
         ENDDO
       ENDDO
-      DO JB=1,  LMAT%NBCOL_LOC
-        NB = LUMAT%COL(JB)%NBINCOL
-        ALLOCATE(LUMAT%COL(JB)%IRN(NB), STAT=IERR)
-        IF (IERR.NE.0) THEN
+      DO JB=1,  LMAT%NBCOL_LOC, K147
+        SIZE_TO_ALLOC_8 = 0_8
+        DO JJ=JB, min(JB+K147-1,LUMAT%NBCOL_LOC)
+         SIZE_TO_ALLOC_8 = SIZE_TO_ALLOC_8 + 
+     &                     int(LUMAT%COL(JJ)%NBINCOL, 8)
+        ENDDO
+        ALLOCATE(LUMAT%COL(JB)%IRN(SIZE_TO_ALLOC_8), STAT=allocok)
+        IF (allocok.NE.0) THEN
            INFO(1)  = -7
-           INFO(2)  = NB
+           CALL MUMPS_SET_IERROR(SIZE_TO_ALLOC_8, INFO(2))
            IF ( LPOK ) THEN
-              WRITE(LP, *) " ERROR allocating columns of LUMAT"
+              WRITE(LP, *) " ERROR allocate block of ", 
+     &                K147, " columns in LUMAT%COL",
+     &                " of size ", SIZE_TO_ALLOC_8
            END IF
            RETURN
         ENDIF
+        IF (K147.GT.1) THEN
+          BLOCK_PTR => LUMAT%COL(JB)%IRN
+          NB_8    = int(LUMAT%COL(JB)%NBINCOL, 8) 
+          PT_CUR = 1_8 + NB_8 
+          DO JJ=JB+1, min(JB+K147-1,LUMAT%NBCOL_LOC)
+            NB_8 =  int(LUMAT%COL(JJ)%NBINCOL,8)
+            IF (NB_8.GT.0) THEN
+             LUMAT%COL(JJ)%IRN => BLOCK_PTR(PT_CUR: PT_CUR+NB_8-1_8)
+             PT_CUR = PT_CUR + NB_8
+            ENDIF
+          ENDDO
+        ENDIF
       ENDDO
       DO JB=1, LMAT%NBCOL_LOC
         LUMAT%COL(JB)%NBINCOL = 0
@@ -572,7 +621,8 @@ C
         DO I = 1, LMAT%NBCOL_LOC
          MAPCOL(I) = LMAT%COL(I)%NBINCOL
         ENDDO
-        CALL MPI_ALLREDUCE(MAPCOL(1), NZ_ROW(1), NBLK, 
+        CALL MUMPS_BIGALLREDUCE(.FALSE.,
+     &        MAPCOL(1), NZ_ROW(1), NBLK, 
      &        MPI_INTEGER, MPI_SUM, COMM, IERR)
         CALL MPI_ALLREDUCE(NZL, NNZ, 1, 
      &        MPI_INTEGER8, MPI_SUM, COMM, IERR)
@@ -680,8 +730,10 @@ C
       INTEGER, INTENT(INOUT)          :: MAPCOL(SIZEMAPCOL)
       TYPE(LMATRIX_T), INTENT(OUT)    :: LUMAT
       INTEGER ::      NBLKloc, IERR, JB, IB, LP, NB, I,
-     &                NBRECORDS
+     &                NBRECORDS, JJ
       INTEGER(8)  ::  NNZ, NZ_locMAX8, NSEND8, NLOCAL8
+      INTEGER(8) :: NB_8, PT_CUR, SIZE_TO_ALLOC_8
+      INTEGER, POINTER, DIMENSION(:) :: BLOCK_PTR
       LOGICAL :: LPOK
       INTEGER, ALLOCATABLE, DIMENSION(:) :: WT, WNBINCOL
       INTEGER OPTION
@@ -715,7 +767,8 @@ C
         WT(I)= WT(I)+1
        ENDDO
       ENDDO
-      CALL MPI_ALLREDUCE(WT(1), WNBINCOL(1), NBLK, 
+      CALL MUMPS_BIGALLREDUCE(.FALSE.,
+     &        WT(1), WNBINCOL(1), NBLK, 
      &        MPI_INTEGER, MPI_SUM, COMM, IERR)
       IF (allocated(WT)) DEALLOCATE(WT)
       IF (MAPCOLonLUMAT) THEN
@@ -777,17 +830,37 @@ C
           NB = 0
          ENDIF
         ENDIF
-        IF (NB.GT.0) THEN
-         ALLOCATE(LUMAT%COL(JB-LUMAT%FIRST+1)%IRN(NB), STAT=IERR)
+       ENDDO
+       DO JB=1,LUMAT%NBCOL_LOC, KEEP(147)
+        SIZE_TO_ALLOC_8 = 0_8
+        DO JJ=JB, min(JB+KEEP(147)-1,LUMAT%NBCOL_LOC)
+         SIZE_TO_ALLOC_8 = SIZE_TO_ALLOC_8 + LUMAT%COL(JJ)%NBINCOL
+        ENDDO
+        IF (SIZE_TO_ALLOC_8.GT.0) THEN
+         ALLOCATE(LUMAT%COL(JB)%IRN(SIZE_TO_ALLOC_8), 
+     &            STAT=IERR)
          IF (IERR.NE.0) THEN
            INFO(1)  = -7
-           INFO(2)  = NB
+           CALL MUMPS_SET_IERROR(SIZE_TO_ALLOC_8, INFO(2))
            IF ( LPOK ) THEN
               WRITE(LP, *) " ERROR allocate of LUMAT%COL"
            END IF
            EXIT
          ENDIF
         ENDIF
+        IF (KEEP(147).GT.1.AND.SIZE_TO_ALLOC_8.GT.0) THEN
+         BLOCK_PTR => LUMAT%COL(JB)%IRN
+         NB_8    = int(LUMAT%COL(JB)%NBINCOL, 8) 
+         PT_CUR = 1_8 + NB_8 
+         DO JJ=JB+1, min(JB+KEEP(147)-1,LUMAT%NBCOL_LOC)
+           NB_8 =  int(LUMAT%COL(JJ)%NBINCOL,8)
+           IF (NB_8.GT.0) THEN
+            LUMAT%COL(JJ)%IRN => 
+     &                      BLOCK_PTR(PT_CUR: PT_CUR+NB_8-1_8)
+            PT_CUR = PT_CUR + NB_8
+           ENDIF
+         ENDDO
+        ENDIF
        ENDDO
       ENDIF
       CALL MUMPS_PROPINFO(  ICNTL(1), INFO(1),
@@ -807,7 +880,7 @@ C
      &  LMAT, MAPCOL, SIZEMAPCOL, STEP, SIZESTEP, 
      &  LUMAT, NBRECORDS, NSEND8, NLOCAL8
      &  )
-      CALL MUMPS_AB_FREE_LMAT(LMAT)
+      CALL MUMPS_AB_FREE_LMAT(LMAT, KEEP(147))
       CALL MUMPS_PROPINFO(  ICNTL(1), INFO(1),
      &     COMM, MYID )
       IF ( INFO(1) .LT. 0 ) GOTO 500
@@ -821,7 +894,8 @@ C
            GOTO 400
       ENDIF
       CALL MUMPS_AB_LOCALCLEAN_LMAT ( MYID,
-     &     LUMAT, WT(1), LUMAT%NBCOL, INFO(1), INFO(2), LP, LPOK
+     &     LUMAT, KEEP(147), 
+     &     WT(1), LUMAT%NBCOL, INFO(1), INFO(2), LP, LPOK
      & )
       DEALLOCATE(WT)
  400  CONTINUE
@@ -837,6 +911,7 @@ C
       END SUBROUTINE MUMPS_AB_BUILD_DCLEAN_LUMATRIX
       SUBROUTINE MUMPS_INIALIZE_REDIST_LUMAT (
      &  INFO, ICNTL, KEEP, COMM, MYID, NBLK, 
+     &  NPROCS,
      &  LUMAT, PROCNODE_STEPS, NSTEPS, MAPCOL,
      &  LUMAT_REMAP, NBRECORDS, STEP 
      &  )
@@ -847,7 +922,7 @@ C
       INTEGER  :: IERR, MASTER
       PARAMETER (MASTER=0)
       INTEGER, INTENT(IN) :: MYID, NBLK, NSTEPS, KEEP(500)
-      INTEGER, INTENT(IN)   :: ICNTL(60), COMM
+      INTEGER, INTENT(IN)   :: ICNTL(60), COMM, NPROCS
       INTEGER               :: INFO(80)
       INTEGER, INTENT(IN) :: PROCNODE_STEPS(NSTEPS)
       TYPE(LMATRIX_T), INTENT(IN)  :: LUMAT
@@ -855,7 +930,9 @@ C
       TYPE(LMATRIX_T), INTENT(INOUT) :: LUMAT_REMAP
       INTEGER, INTENT(OUT) :: NBRECORDS
       INTEGER, INTENT(OUT) :: MAPCOL(NSTEPS)
-      INTEGER :: LP, MP, ISTEP, JB, NB
+      INTEGER :: LP, MP, ISTEP, JB, JJ
+      INTEGER(8) :: NB_8, PT_CUR, SIZE_TO_ALLOC_8
+      INTEGER, POINTER, DIMENSION(:) :: BLOCK_PTR
       LOGICAL :: LPOK
       INTEGER, ALLOCATABLE, DIMENSION(:) :: WT, WNBINCOL
       INTEGER MUMPS_PROCNODE
@@ -878,14 +955,20 @@ C
       DO JB=1, LUMAT%NBCOL_LOC
        WT(JB+LUMAT%FIRST-1) = LUMAT%COL(JB)%NBINCOL
       ENDDO
-      CALL MPI_ALLREDUCE(WT(1), WNBINCOL(1), NBLK, 
-     &        MPI_INTEGER, MPI_SUM, COMM, IERR)
+      CALL MUMPS_BIGALLREDUCE(.FALSE., WT(1), WNBINCOL(1),
+     &     NBLK, MPI_INTEGER, MPI_SUM, COMM, IERR)
       IF (allocated(WT)) DEALLOCATE(WT)
       IF (MYID.EQ.MASTER) THEN
-       DO ISTEP=1, NSTEPS
-        MAPCOL(ISTEP) = 
-     &              MUMPS_PROCNODE(PROCNODE_STEPS(ISTEP),KEEP(199)) 
-       ENDDO
+       IF (KEEP(381).GT.1) THEN
+         DO ISTEP=1, NSTEPS
+          MAPCOL(ISTEP) = mod(ISTEP,NPROCS)
+         ENDDO
+       ELSE
+         DO ISTEP=1, NSTEPS
+          MAPCOL(ISTEP) = 
+     &     MUMPS_PROCNODE(PROCNODE_STEPS(ISTEP),KEEP(199)) 
+         ENDDO
+       ENDIF
       ENDIF
       CALL MPI_BCAST( MAPCOL(1), NSTEPS, MPI_INTEGER,
      &     MASTER, COMM, IERR )
@@ -904,24 +987,42 @@ C
       ENDIF
       IF ( INFO(1) .GE. 0 ) THEN
        LUMAT_REMAP%NZL = 0_8
-       DO JB=1,NBLK
-        NB =  WNBINCOL(JB)
-        IF (MAPCOL(abs(STEP(JB))).EQ.MYID) THEN
-         LUMAT_REMAP%NZL             = LUMAT_REMAP%NZL + int(NB,8)
-        ELSE
-         NB = 0
+       DO JB=1,NBLK, KEEP(147)
+        SIZE_TO_ALLOC_8 = 0_8
+        DO JJ=JB, min(JB+KEEP(147)-1,NBLK)
+          NB_8 =  WNBINCOL(JJ)
+          IF (MAPCOL(abs(STEP(JJ))).EQ.MYID) THEN
+           LUMAT_REMAP%NZL  = LUMAT_REMAP%NZL + NB_8
+          ELSE
+           NB_8 = 0_8
+          ENDIF
+          SIZE_TO_ALLOC_8 = SIZE_TO_ALLOC_8 + NB_8
+          LUMAT_REMAP%COL(JJ)%NBINCOL = int(NB_8)
+        ENDDO
+        IF (SIZE_TO_ALLOC_8.GT.0) THEN
+           ALLOCATE(LUMAT_REMAP%COL(JB)%IRN(SIZE_TO_ALLOC_8), 
+     &              STAT=IERR)
+           IF (IERR.NE.0) THEN
+             INFO(1)  = -7
+             CALL MUMPS_SET_IERROR(SIZE_TO_ALLOC_8, INFO(2))
+             IF ( LPOK ) THEN
+                WRITE(LP, *) " ERROR allocate of LUMAT_REMAP%COL"
+             END IF
+             EXIT
+           ENDIF
         ENDIF
-        LUMAT_REMAP%COL(JB)%NBINCOL = NB
-        IF (NB.GT.0) THEN
-         ALLOCATE(LUMAT_REMAP%COL(JB)%IRN(NB), STAT=IERR)
-         IF (IERR.NE.0) THEN
-           INFO(1)  = -7
-           INFO(2)  = NB
-           IF ( LPOK ) THEN
-              WRITE(LP, *) " ERROR allocate of LUMAT_REMAP%COL"
-           END IF
-           EXIT
-         ENDIF
+        IF (KEEP(147).GT.1) THEN
+         BLOCK_PTR => LUMAT_REMAP%COL(JB)%IRN
+         NB_8    = int(LUMAT_REMAP%COL(JB)%NBINCOL, 8) 
+         PT_CUR = 1_8 + NB_8 
+         DO JJ=JB+1, min(JB+KEEP(147)-1,LUMAT_REMAP%NBCOL_LOC)
+           NB_8 =  int(LUMAT_REMAP%COL(JJ)%NBINCOL,8)
+           IF (NB_8.GT.0) THEN
+            LUMAT_REMAP%COL(JJ)%IRN => 
+     &                      BLOCK_PTR(PT_CUR: PT_CUR+NB_8-1_8)
+            PT_CUR = PT_CUR + NB_8
+           ENDIF
+         ENDDO
         ENDIF
        ENDDO
       ENDIF
@@ -1033,7 +1134,7 @@ C
      &     COMM, MYID )
       IF ( INFO(1) .LT. 0 ) GOTO 500
       IF (KEEP(494).EQ.0) THEN
-       CALL MUMPS_AB_FREE_LMAT(LUMAT)
+       CALL MUMPS_AB_FREE_LMAT(LUMAT, KEEP(147))
        LUMAT_AVAIL=.FALSE.
       ELSE
        LUMAT_AVAIL=.TRUE.
@@ -1041,8 +1142,8 @@ C
       GOTO 600
   500 CONTINUE
       IF (allocated(MAPCOL))  DEALLOCATE(MAPCOL)
-      CALL MUMPS_AB_FREE_LMAT(LMAT)
-      CALL MUMPS_AB_FREE_LMAT(LUMAT)
+      CALL MUMPS_AB_FREE_LMAT(LMAT, KEEP(147))
+      CALL MUMPS_AB_FREE_LMAT(LUMAT, KEEP(147))
       LUMAT_AVAIL=.FALSE.
   600 CONTINUE
       RETURN
@@ -1105,8 +1206,8 @@ C
      &          LMAT, OFFDIAG,  KEEP )
       CALL MPI_ALLREDUCE (OFFDIAG, KEEP8(127), 1, MPI_INTEGER8,
      &     MPI_SUM, COMM, IERR)
-      KEEP8(127) = KEEP8(127)+3*NDOF
-      KEEP8(126) = KEEP8(127)-2*NDOF
+      KEEP8(127) = KEEP8(127)+3_8*int(NDOF,8)
+      KEEP8(126) = KEEP8(127)-2_8*int(NDOF,8)
       CALL MUMPS_PROPINFO(  ICNTL(1), INFO(1),
      &     COMM, MYID )
       IF ( INFO(1) .LT. 0 ) GOTO 500
@@ -1148,8 +1249,8 @@ C
       GOTO 600
   500 CONTINUE
       IF (allocated(MAPCOL))  DEALLOCATE(MAPCOL)
-      CALL MUMPS_AB_FREE_LMAT(LMAT)
-      CALL MUMPS_AB_FREE_LMAT(LUMAT)
+      CALL MUMPS_AB_FREE_LMAT(LMAT, KEEP(147))
+      CALL MUMPS_AB_FREE_LMAT(LUMAT, KEEP(147))
   600 CONTINUE
       RETURN
       END SUBROUTINE MUMPS_AB_DCOORD_TO_DLUMAT
@@ -1235,8 +1336,8 @@ C
       GOTO 600
   500 CONTINUE
       IF (allocated(DOF2BLOCK))  DEALLOCATE(DOF2BLOCK)
-      CALL MUMPS_AB_FREE_LMAT(LMAT)
-      CALL MUMPS_AB_FREE_LMAT(LUMAT)
+      CALL MUMPS_AB_FREE_LMAT(LMAT, KEEP(147))
+      CALL MUMPS_AB_FREE_LMAT(LUMAT, KEEP(147))
   600 CONTINUE
       RETURN
  150  FORMAT(
diff -pruN 5.6.2-2.1/src/ana_blk_m.F 5.7.1-1/src/ana_blk_m.F
--- 5.6.2-2.1/src/ana_blk_m.F	2023-10-11 09:36:34.000000000 +0000
+++ 5.7.1-1/src/ana_blk_m.F	2024-05-02 10:15:13.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/ana_omp_m.F 5.7.1-1/src/ana_omp_m.F
--- 5.6.2-2.1/src/ana_omp_m.F	2023-10-11 09:36:35.000000000 +0000
+++ 5.7.1-1/src/ana_omp_m.F	2024-05-02 10:15:13.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/ana_orderings_wrappers_m.F 5.7.1-1/src/ana_orderings_wrappers_m.F
--- 5.6.2-2.1/src/ana_orderings_wrappers_m.F	2023-10-11 09:36:35.000000000 +0000
+++ 5.7.1-1/src/ana_orderings_wrappers_m.F	2024-05-02 10:15:14.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -145,7 +145,8 @@ C
      &           IKEEP2(1), IKEEP1(1) )
       ELSE
        IF (INPLACE64_GRAPH_COPY)  THEN
-          CALL MUMPS_ICOPY_32TO64_64C_IP(IW(1), IPE8(NCMP+1)-1_8)
+          CALL MUMPS_ICOPY_32TO64_64C_IP(IW(1), IPE8(NCMP+1)-1_8,
+     &    2_8*IPE8(NCMP+1)-2_8) 
        ELSE
          ALLOCATE(IW8(IPE8(NCMP+1)-1_8),
      &             stat=allocok)
@@ -177,11 +178,11 @@ C
        IF (INPLACE64_GRAPH_COPY)  THEN
          CALL METIS_NODEWND(NCMP, IPE8(1), IW(1),FRERE8,
      &           NUMFLAG, OPTIONS_METIS,
-     &           IKEEP2(1), IKEEP1(1) )
+     &           IKEEP28(1), IKEEP18(1) )
        ELSE
          CALL METIS_NODEWND(NCMP, IPE8(1), IW8,FRERE8,
      &           NUMFLAG, OPTIONS_METIS,
-     &           IKEEP2(1), IKEEP1(1) )
+     &           IKEEP28(1), IKEEP18(1) )
        ENDIF
        CALL MUMPS_ICOPY_64TO32(IKEEP18, NCMP, IKEEP1(1))
        CALL MUMPS_ICOPY_64TO32(IKEEP28, NCMP, IKEEP2(1))
@@ -217,7 +218,8 @@ C
      &           IKEEP2(1), IKEEP1(1) )
       ELSE
         IF (INPLACE64_GRAPH_COPY)  THEN
-          CALL MUMPS_ICOPY_32TO64_64C_IP(IW(1), IPE8(NCMP+1)-1_8)
+          CALL MUMPS_ICOPY_32TO64_64C_IP(IW(1), IPE8(NCMP+1)-1_8,
+     &    2_8*IPE8(NCMP+1)-2_8) 
         ELSE
           ALLOCATE(IW8(IPE8(NCMP+1)-1_8), stat=allocok)
           IF (allocok > 0) THEN
@@ -253,7 +255,8 @@ C
         CALL MUMPS_ICOPY_64TO32(IKEEP28, NCMP, IKEEP2(1))
         IF (INPLACE64_GRAPH_COPY) THEN
          IF (INPLACE64_RESTORE_GRAPH) THEN
-          CALL MUMPS_ICOPY_64TO32_64C_IP(IW(1), IPE8(NCMP+1)-1_8)
+          CALL MUMPS_ICOPY_64TO32_64C_IP(IW(1), IPE8(NCMP+1)-1_8,
+     &    2_8*IPE8(NCMP+1)-2_8) 
          ENDIF
          DEALLOCATE(IKEEP18, IKEEP28)
         ELSE
@@ -288,7 +291,8 @@ C
      &      OPTIONS_METIS, IKEEP2(1), IKEEP1(1) )
       ELSE
         IF (INPLACE64_GRAPH_COPY)  THEN
-          CALL MUMPS_ICOPY_32TO64_64C_IP(IW(1), IPE8(NCMP+1)-1_8)
+          CALL MUMPS_ICOPY_32TO64_64C_IP(IW(1), IPE8(NCMP+1)-1_8,
+     &    2_8*IPE8(NCMP+1)-2_8) 
         ELSE
           ALLOCATE(IW8(IPE8(NCMP+1)-1_8), stat=allocok)
           IF (allocok > 0) THEN
@@ -328,7 +332,8 @@ C
         CALL MUMPS_ICOPY_64TO32(IKEEP28, NCMP, IKEEP2(1))
         IF (INPLACE64_GRAPH_COPY) THEN
          IF (INPLACE64_RESTORE_GRAPH) THEN
-            CALL MUMPS_ICOPY_64TO32_64C_IP(IW(1), IPE8(NCMP+1)-1_8)
+            CALL MUMPS_ICOPY_64TO32_64C_IP(IW(1), IPE8(NCMP+1)-1_8,
+     &      2_8*IPE8(NCMP+1)-2_8) 
          ENDIF
          DEALLOCATE(FRERE8, IKEEP18, IKEEP28, OPTIONS_METIS8)
         ELSE
@@ -365,7 +370,14 @@ C
       LOGICAL,    INTENT(IN)    :: SCOTCH_SYMBOLIC
       INTEGER, DIMENSION(:), ALLOCATABLE :: IPE
       INTEGER :: allocok
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+      INCLUDE 'scotchf.h'
+      INTEGER          :: IOMP, NOMP
+      DOUBLE PRECISION :: CONTDAT(SCOTCH_CONTEXTDIM)
+      INTEGER(4)       :: IERR_SCOTCH
+#else
       INTEGER :: PTHREAD_NUMBER, NOMP
+#endif
       IF (IWFR8 .GE. int(huge(IW),8)) THEN
         INFO(1) = -51
         CALL MUMPS_SET_IERROR(IPE8(NCMP+1), INFO(2))
@@ -380,29 +392,67 @@ C
         RETURN
       ENDIF
       CALL MUMPS_ICOPY_64TO32(IPE8(1),NCMP+1,IPE)
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+!$OMP PARALLEL PRIVATE(IOMP, IERR_SCOTCH)
+!$OMP SINGLE
+      NOMP=omp_get_num_threads()
+!$OMP END SINGLE
+      IOMP=omp_get_thread_num()
+      IF (IOMP.EQ.0) THEN
+        CALL SCOTCHFCONTEXTINIT(CONTDAT, IERR_SCOTCH)
+        CALL SCOTCHFCONTEXTRANDOMCLONE(CONTDAT, IERR_SCOTCH)
+        CALL SCOTCHFCONTEXTTHREADIMPORT1(CONTDAT, NOMP,IERR_SCOTCH)
+      ENDIF
+!$OMP BARRIER
+      CALL SCOTCHFCONTEXTTHREADIMPORT2(CONTDAT, IOMP, IERR_SCOTCH)
+#else
       NOMP=0
 !$    NOMP=omp_get_max_threads()
       IF (NOMP .GT. 0) THEN
         CALL MUMPS_SCOTCH_GET_PTHREAD_NUMBER (PTHREAD_NUMBER)
         CALL MUMPS_SCOTCH_SET_PTHREAD_NUMBER (NOMP)
       ENDIF
-      IF (SCOTCH_SYMBOLIC) THEN
-         CALL MUMPS_SCOTCH( NCMP, int(LIW8), IPE, int(IWFR8),
+#endif
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+      IF (IOMP.EQ.0) THEN
+#endif
+        IF (SCOTCH_SYMBOLIC) THEN
+           CALL MUMPS_SCOTCH( NCMP, int(LIW8), IPE, int(IWFR8),
      &                   PTRAR, IW(1), IWL1, IKEEP1(1),
      &                   IKEEP2(1), NCMPA,
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+     &                   CONTDAT,
+#endif
      &                   WEIGHTUSED, WEIGHTREQUESTED )
-      ELSE
-         CALL MUMPS_SCOTCH_ORD ( NCMP, int(LIW8), IPE, int(IWFR8),
+        ELSE
+           CALL MUMPS_SCOTCH_ORD ( NCMP, int(LIW8), IPE, int(IWFR8),
      &                   PTRAR, IW(1), IWL1, IKEEP1(1),
      &                   IKEEP2(1), NCMPA,
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+     &                   CONTDAT,
+#endif
      &                   WEIGHTUSED, WEIGHTREQUESTED )
-      ENDIF
+        ENDIF
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+        CALL SCOTCHFCONTEXTEXIT(CONTDAT)
+      ENDIF 
+!$OMP END PARALLEL
+#else
       IF (NOMP .GT. 0) THEN
         CALL MUMPS_SCOTCH_SET_PTHREAD_NUMBER (PTHREAD_NUMBER)
       ENDIF
+#endif
+      IF (NCMPA .NE.0) THEN
+        IF (LPOK) WRITE(LP,*) 
+     &            ' Error on output from SCOTCH, NCMPA=', NCMPA
+        INFO(1) = -88
+        INFO(2) = NCMPA
+        GOTO 500
+      ENDIF
       IF (SCOTCH_SYMBOLIC) THEN
          PARENT(1:NCMP)=IPE(1:NCMP)
       ENDIF
+ 500  CONTINUE
       DEALLOCATE(IPE)
       RETURN
       END SUBROUTINE MUMPS_SCOTCH_MIXEDto32
@@ -410,14 +460,14 @@ C
      &           NCMP, LIW8, IPE8, PARENT, IWFR8,
      &           PTRAR, IW, IWL1, IKEEP1,
      &           IKEEP2, NCMPA, INFO, LP, LPOK, KEEP10,
-     &           INPLACE64_GRAPH_COPY,
+     &           INPLACE64_GRAPH_COPY, INPLACE64_RESTORE_GRAPH,
      &           WEIGHTUSED, WEIGHTREQUESTED, SCOTCH_SYMBOLIC)
 !$    USE OMP_LIB
       IMPLICIT NONE
       INTEGER,    INTENT(IN)    :: NCMP
       INTEGER(8), INTENT(IN)    :: LIW8
       INTEGER,    INTENT(OUT)   :: NCMPA
-      INTEGER(8), INTENT(INOUT) :: IPE8(:) 
+      INTEGER(8), INTENT(INOUT), target :: IPE8(:) 
       INTEGER,    INTENT(OUT)   :: PARENT(NCMP)
       INTEGER(8), INTENT(IN)    :: IWFR8
       INTEGER                   :: PTRAR(NCMP)
@@ -430,52 +480,109 @@ C
       LOGICAL,    INTENT(IN)    :: LPOK
       INTEGER,    INTENT(IN)    :: KEEP10
       LOGICAL, INTENT(IN)       :: INPLACE64_GRAPH_COPY
+      LOGICAL, INTENT(IN)       :: INPLACE64_RESTORE_GRAPH
       INTEGER,    INTENT(OUT)   :: WEIGHTUSED
       INTEGER,    INTENT(IN)    :: WEIGHTREQUESTED
       LOGICAL,    INTENT(IN)    :: SCOTCH_SYMBOLIC
       INTEGER(8), DIMENSION(:), ALLOCATABLE :: 
      &                     PTRAR8, IW8, IWL18, IKEEP18,
-     &                     IKEEP28, IPE8_TEMP
-      INTEGER :: allocok
+     &                     IKEEP28
+      INTEGER(8), DIMENSION(:), POINTER :: IPE8_TEMP
+      INTEGER :: allocok, I
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+      INCLUDE 'scotchf.h'
+      INTEGER          :: IOMP, NOMP
+      DOUBLE PRECISION :: CONTDAT(SCOTCH_CONTEXTDIM)
+      INTEGER(4)       :: IERR_SCOTCH
+#else
       INTEGER :: PTHREAD_NUMBER, NOMP
-      ALLOCATE( IPE8_TEMP(NCMP+1), stat=allocok )
-      IF (allocok > 0) THEN
-        IF (LPOK) WRITE(LP,*)
+#endif
+      LOGICAL :: IPE8_TEMP_ALLOCATED
+      IPE8_TEMP_ALLOCATED =.FALSE.
+      NULLIFY(IPE8_TEMP)
+      CALL MUMPS_SCOTCH_WEIGHTUSED (WEIGHTUSED)
+      IF ( (.NOT.SCOTCH_SYMBOLIC) .OR. 
+     &     ( (WEIGHTREQUESTED.EQ.1).AND.(WEIGHTUSED.EQ.0)) 
+     &   ) THEN
+       ALLOCATE( IPE8_TEMP(NCMP+1), stat=allocok )
+       IF (allocok > 0) THEN
+         IF (LPOK) WRITE(LP,*)
      &  "ERROR memory allocation in MUMPS_SCOTCH_MIXEDto64"
         INFO(1) = -7
         INFO(2) = NCMP+1
         RETURN
+       ENDIF
+       IPE8_TEMP_ALLOCATED = .TRUE.
+       DO I=1, NCMP+1
+         IPE8_TEMP(I) = IPE8(I)
+       ENDDO
+      ELSE
+       IPE8_TEMP =>  IPE8(1:NCMP+1)
       ENDIF
-      IPE8_TEMP(1:NCMP+1) = IPE8(1:NCMP+1)
-      NOMP=0
-!$    NOMP=omp_get_max_threads()
       IF (KEEP10.EQ.1) THEN
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+!$OMP   PARALLEL PRIVATE(IOMP, IERR_SCOTCH)
+!$OMP   SINGLE
+        NOMP=omp_get_num_threads()
+!$OMP   END SINGLE
+        IOMP=omp_get_thread_num()
+        IF (IOMP.EQ.0) THEN
+          CALL SCOTCHFCONTEXTINIT(CONTDAT, IERR_SCOTCH)
+          CALL SCOTCHFCONTEXTRANDOMCLONE(CONTDAT, IERR_SCOTCH)
+          CALL SCOTCHFCONTEXTTHREADIMPORT1(CONTDAT, NOMP,IERR_SCOTCH)
+        ENDIF
+!$OMP   BARRIER
+        CALL SCOTCHFCONTEXTTHREADIMPORT2(CONTDAT, IOMP, IERR_SCOTCH)
+#else
+        NOMP=0
+!$      NOMP=omp_get_max_threads()
         IF (NOMP .GT. 0) THEN
           CALL MUMPS_SCOTCH_GET_PTHREAD_NUMBER (PTHREAD_NUMBER)
           CALL MUMPS_SCOTCH_SET_PTHREAD_NUMBER (NOMP)
         ENDIF
-        IF (SCOTCH_SYMBOLIC) THEN
-          CALL MUMPS_SCOTCH_64( NCMP, LIW8,
-     &                        IPE8_TEMP(1), 
-     &                        IWFR8,
-     &                        PTRAR, IW(1), IWL1, IKEEP1(1),
-     &                        IKEEP2(1), NCMPA,
-     &                        WEIGHTUSED, WEIGHTREQUESTED)
-          PARENT(1:NCMP) = int(IPE8_TEMP(1:NCMP))
-        ELSE
-          CALL MUMPS_SCOTCH_ORD_64( NCMP, LIW8,
-     &                        IPE8_TEMP(1), 
-     &                        IWFR8,
-     &                        PTRAR, IW(1), IWL1, IKEEP1(1),
-     &                        IKEEP2(1), NCMPA,
-     &                        WEIGHTUSED, WEIGHTREQUESTED)
-        ENDIF
+#endif
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+        IF (IOMP.EQ.0) THEN
+#endif
+          IF (SCOTCH_SYMBOLIC) THEN
+            CALL MUMPS_SCOTCH_64( NCMP, LIW8,
+     &                          IPE8_TEMP(1), 
+     &                          IWFR8,
+     &                          PTRAR, IW(1), IWL1, IKEEP1(1),
+     &                          IKEEP2(1), NCMPA,
+     &                          WEIGHTUSED, WEIGHTREQUESTED)
+            PARENT(1:NCMP) = int(IPE8_TEMP(1:NCMP))
+          ELSE
+            CALL MUMPS_SCOTCH_ORD_64( NCMP, LIW8,
+     &                          IPE8_TEMP(1), 
+     &                          IWFR8,
+     &                          PTRAR, IW(1), IWL1, IKEEP1(1),
+     &                          IKEEP2(1), NCMPA,
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+     &                          CONTDAT,
+#endif
+     &                          WEIGHTUSED, WEIGHTREQUESTED)
+          ENDIF
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+          CALL SCOTCHFCONTEXTEXIT(CONTDAT)
+        ENDIF 
+!$OMP   END PARALLEL
+#else
         IF (NOMP .GT. 0) THEN
           CALL MUMPS_SCOTCH_SET_PTHREAD_NUMBER (PTHREAD_NUMBER)
         ENDIF
+#endif
+        IF (NCMPA .NE. 0) THEN
+           IF (LPOK) WRITE(LP,*) 
+     &               ' Error on output from SCOTCH, NCMPA=', NCMPA
+           INFO( 1 ) = -88
+           INFO( 2 ) = NCMPA
+           GOTO 600 
+        ENDIF
       ELSE
         IF (INPLACE64_GRAPH_COPY)  THEN
-          CALL MUMPS_ICOPY_32TO64_64C_IP(IW(1), IPE8_TEMP(NCMP+1)-1_8)
+          CALL MUMPS_ICOPY_32TO64_64C_IP(IW(1), IPE8_TEMP(NCMP+1)-1_8,
+     &    2_8*IPE8(NCMP+1)-2_8) 
         ELSE
          ALLOCATE( IW8(LIW8), stat=allocok )
          IF (allocok > 0) THEN
@@ -504,61 +611,99 @@ C
         IF (WEIGHTREQUESTED.EQ.1) THEN
          CALL MUMPS_ICOPY_32TO64(IWL1,NCMP,IWL18)
         ENDIF
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+!$OMP   PARALLEL PRIVATE(IOMP, IERR_SCOTCH)
+!$OMP   SINGLE
+        NOMP=omp_get_num_threads()
+!$OMP   END SINGLE
+        IOMP=omp_get_thread_num()
+        IF (IOMP.EQ.0) THEN
+          CALL SCOTCHFCONTEXTINIT(CONTDAT, IERR_SCOTCH)
+          CALL SCOTCHFCONTEXTRANDOMCLONE(CONTDAT, IERR_SCOTCH)
+          CALL SCOTCHFCONTEXTTHREADIMPORT1(CONTDAT, NOMP,IERR_SCOTCH)
+        ENDIF
+!$OMP   BARRIER
+        CALL SCOTCHFCONTEXTTHREADIMPORT2(CONTDAT, IOMP, IERR_SCOTCH)
+#else
+        NOMP=0
+!$      NOMP=omp_get_max_threads()
         IF (NOMP .GT. 0) THEN
           CALL MUMPS_SCOTCH_GET_PTHREAD_NUMBER (PTHREAD_NUMBER)
           CALL MUMPS_SCOTCH_SET_PTHREAD_NUMBER (NOMP)
         ENDIF
-        IF (INPLACE64_GRAPH_COPY) THEN
-         IF (SCOTCH_SYMBOLIC) THEN
-           CALL MUMPS_SCOTCH_64( 
-     &                 int(NCMP,8), LIW8, 
-     &                 IPE8_TEMP(1),         
-     &                 IWFR8,                
-     &                 PTRAR8, IW(1), IWL18, 
-     &                 IKEEP1(1), IKEEP2(1), NCMPA, 
-     &                 WEIGHTUSED,           
-     &                 WEIGHTREQUESTED )     
-         ELSE
-           CALL MUMPS_SCOTCH_ORD_64 (
-     &                 int(NCMP,8), LIW8,    
-     &                 IPE8_TEMP(1),         
-     &                 IWFR8,                
-     &                 PTRAR8, IW(1), IWL18, 
-     &                 IKEEP1(1),            
-     &                 IKEEP2(1), NCMPA, 
-     &                 WEIGHTUSED,           
-     &                 WEIGHTREQUESTED )     
-         ENDIF
-        ELSE
-         IF (SCOTCH_SYMBOLIC) THEN
-           CALL MUMPS_SCOTCH_64( 
-     &                 int(NCMP,8), LIW8,    
-     &                 IPE8_TEMP(1),         
-     &                 IWFR8,                
-     &                 PTRAR8, IW8, IWL18,   
-     &                 IKEEP1(1), IKEEP2(1), NCMPA, 
-     &                 WEIGHTUSED,           
-     &                 WEIGHTREQUESTED )     
-         ELSE
-           CALL MUMPS_SCOTCH_ORD_64( 
-     &                 int(NCMP,8), LIW8,    
-     &                 IPE8_TEMP(1),         
-     &                 IWFR8,                
-     &                 PTRAR8, IW8, IWL18,   
-     &                 IKEEP1(1),            
-     &                 IKEEP2(1), NCMPA, 
-     &                 WEIGHTUSED,           
-     &                 WEIGHTREQUESTED )     
-         ENDIF
-        ENDIF
+#endif
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+        IF (IOMP.EQ.0) THEN
+#endif
+          IF (INPLACE64_GRAPH_COPY) THEN
+            IF (SCOTCH_SYMBOLIC) THEN
+              CALL MUMPS_SCOTCH_64( 
+     &                    int(NCMP,8), LIW8, 
+     &                    IPE8_TEMP(1),         
+     &                    IWFR8,                
+     &                    PTRAR8, IW(1), IWL18, 
+     &                    IKEEP18(1), IKEEP28(1), NCMPA, 
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+     &                    CONTDAT,
+#endif
+     &                    WEIGHTUSED,           
+     &                    WEIGHTREQUESTED )     
+            ELSE
+              CALL MUMPS_SCOTCH_ORD_64 (
+     &                    int(NCMP,8), LIW8,    
+     &                    IPE8_TEMP(1),         
+     &                    IWFR8,                
+     &                    PTRAR8, IW(1), IWL18, 
+     &                    IKEEP18(1),            
+     &                    IKEEP28(1), NCMPA, 
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+     &                    CONTDAT,
+#endif
+     &                    WEIGHTUSED,           
+     &                    WEIGHTREQUESTED )     
+            ENDIF
+          ELSE
+            IF (SCOTCH_SYMBOLIC) THEN
+              CALL MUMPS_SCOTCH_64( 
+     &                    int(NCMP,8), LIW8,    
+     &                    IPE8_TEMP(1),         
+     &                    IWFR8,                
+     &                    PTRAR8, IW8, IWL18,   
+     &                    IKEEP18(1), IKEEP28(1), NCMPA, 
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+     &                    CONTDAT,
+#endif
+     &                    WEIGHTUSED,           
+     &                    WEIGHTREQUESTED )     
+            ELSE
+              CALL MUMPS_SCOTCH_ORD_64( 
+     &                    int(NCMP,8), LIW8,    
+     &                    IPE8_TEMP(1),         
+     &                    IWFR8,                
+     &                    PTRAR8, IW8, IWL18,   
+     &                    IKEEP18(1),            
+     &                    IKEEP28(1), NCMPA, 
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+     &                    CONTDAT,
+#endif
+     &                    WEIGHTUSED,           
+     &                    WEIGHTREQUESTED )     
+            ENDIF
+          ENDIF
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+          CALL SCOTCHFCONTEXTEXIT(CONTDAT)
+        ENDIF 
+!$OMP   END PARALLEL
+#else
         IF (NOMP .GT. 0) THEN
           CALL MUMPS_SCOTCH_SET_PTHREAD_NUMBER (PTHREAD_NUMBER)
         ENDIF
-        IF (NCMPA .LT. 0) THEN
+#endif
+        IF (NCMPA .NE. 0) THEN
            IF (LPOK) WRITE(LP,*) 
      &               ' Error on output from SCOTCH, NCMPA=', NCMPA
-           INFO( 1 ) = -9999
-           INFO( 2 ) = 3
+           INFO( 1 ) = -88
+           INFO( 2 ) = NCMPA
            GOTO 500 
         ENDIF
         CALL MUMPS_ICOPY_64TO32(IWL18,NCMP,IWL1)
@@ -566,17 +711,23 @@ C
         CALL MUMPS_ICOPY_64TO32(IKEEP28,NCMP,IKEEP2(1))
         IF (SCOTCH_SYMBOLIC) THEN
          CALL MUMPS_ICOPY_64TO32(IPE8_TEMP(1),NCMP,PARENT)
+        ELSE IF (INPLACE64_GRAPH_COPY) THEN
+          IF (INPLACE64_RESTORE_GRAPH) THEN
+            CALL MUMPS_ICOPY_64TO32_64C_IP(IW(1), IPE8(NCMP+1)-1_8,
+     &      2_8*IPE8(NCMP+1)-2_8) 
+          ENDIF
         ENDIF
  500    CONTINUE
         IF (.NOT.INPLACE64_GRAPH_COPY) THEN
-         IF (ALLOCATED(IW8)) DEALLOCATE(IW8)
+          IF (ALLOCATED(IW8)) DEALLOCATE(IW8)
         ENDIF
         IF (ALLOCATED(PTRAR8)) DEALLOCATE(PTRAR8)
         IF (ALLOCATED(IWL18)) DEALLOCATE(IWL18)
         IF (ALLOCATED(IKEEP18)) DEALLOCATE(IKEEP18)
         IF (ALLOCATED(IKEEP28)) DEALLOCATE(IKEEP28)
       ENDIF
-      IF (ALLOCATED(IPE8_TEMP)) DEALLOCATE(IPE8_TEMP)
+ 600  CONTINUE
+      IF (IPE8_TEMP_ALLOCATED ) DEALLOCATE(IPE8_TEMP)
       RETURN
       END SUBROUTINE MUMPS_SCOTCH_MIXEDto64
 #endif
@@ -921,7 +1072,8 @@ C
         ENDDO
       ELSE
         IF (INPLACE64_GRAPH_COPY)  THEN
-          CALL MUMPS_ICOPY_32TO64_64C_IP(IW(1), NEDGES8)
+          CALL MUMPS_ICOPY_32TO64_64C_IP(IW(1), NEDGES8,
+     &    2_8*NEDGES8 ) 
         ELSE
          ALLOCATE(IW8(NEDGES8), stat=allocok)
          IF (allocok > 0) THEN
@@ -1023,7 +1175,8 @@ C
         CALL MUMPS_ICOPY_64TO32(XADJ8(1), NVTX, PARENT)
       ELSE
         IF (INPLACE64_GRAPH_COPY)  THEN
-          CALL MUMPS_ICOPY_32TO64_64C_IP(IW(1), NEDGES8)
+          CALL MUMPS_ICOPY_32TO64_64C_IP(IW(1), NEDGES8,
+     &    2_8*NEDGES8 ) 
         ELSE
           ALLOCATE(IW8(NEDGES8), stat=allocok)
           IF (allocok > 0) THEN
diff -pruN 5.6.2-2.1/src/ana_set_ordering.F 5.7.1-1/src/ana_set_ordering.F
--- 5.6.2-2.1/src/ana_set_ordering.F	2023-10-11 09:36:34.000000000 +0000
+++ 5.7.1-1/src/ana_set_ordering.F	2024-05-02 10:15:13.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -55,7 +55,11 @@ C
              IF (NBQD.GE.MAXQD) THEN
                IORD = 6         
              ELSE
+              IF (KEEP(53).GT.0) THEN
+                IORD = 0
+              ELSE
                IORD = 2         
+              ENDIF
              ENDIF
           ELSE
 #if  defined(metis) || defined(parmetis) || defined(metis4) || defined(parmetis3)
@@ -77,7 +81,11 @@ C
             IF (NBQD.GE.MAXQD) THEN
               IORD = 6  
             ELSE
+              IF (KEEP(53).GT.0) THEN
+                IORD = 0
+              ELSE
               IORD = 2   
+              ENDIF
             ENDIF
           ELSE
 #if  defined(metis) || defined(parmetis) || defined(metis4) || defined(parmetis3)
diff -pruN 5.6.2-2.1/src/bcast_errors.F 5.7.1-1/src/bcast_errors.F
--- 5.6.2-2.1/src/bcast_errors.F	2023-10-11 09:36:34.000000000 +0000
+++ 5.7.1-1/src/bcast_errors.F	2024-05-02 10:15:13.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/cana_LDLT_preprocess.F 5.7.1-1/src/cana_LDLT_preprocess.F
--- 5.6.2-2.1/src/cana_LDLT_preprocess.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/cana_LDLT_preprocess.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/cana_aux.F 5.7.1-1/src/cana_aux.F
--- 5.6.2-2.1/src/cana_aux.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/cana_aux.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -50,7 +50,7 @@ C
       INTEGER, INTENT(IN)    :: METIS_OPTIONS(40)
 #endif      
       INTEGER, INTENT(IN), OPTIONAL     :: NORIG_ARG
-      INTEGER, INTENT(IN), OPTIONAL     :: SIZEOFBLOCKS(N)
+      INTEGER, INTENT(IN), TARGET, OPTIONAL  :: SIZEOFBLOCKS(N)
       LOGICAL, INTENT(IN), OPTIONAL     :: GCOMP_PROVIDED_IN
       TYPE(COMPACT_GRAPH_T), OPTIONAL   :: GCOMP
       INTEGER, DIMENSION(:), ALLOCATABLE, TARGET :: IWALLOC
@@ -92,10 +92,9 @@ C
       PARAMETER (MINSYM=50)
       INTEGER(8) :: K79REF
       PARAMETER(K79REF=12000000_8)
-      INTEGER, PARAMETER :: LIDUMMY = 1 
-      INTEGER            :: IDUMMY(1)   
       INTEGER MTRANS, COMPRESS,NCMP,IERROR,J,JPERM,NCST
       INTEGER TOTEL 
+      INTEGER NFR
 #if defined(pord)
       INTEGER TOTW
 #endif
@@ -103,6 +102,8 @@ C
 #if defined(scotch) || defined(ptscotch)
       INTEGER WEIGHTREQUESTED
 #endif
+      INTEGER HOW_TO_SPLIT_ROOT, INODE_Scalapack_CAND, 
+     &        NBSONS_Scalapack_CAND
       LOGICAL SCOTCH_SYMBOLIC
       LOGICAL IDENT,SPLITROOT
       LOGICAL FREE_CENTRALIZED_MATRIX
@@ -110,32 +111,22 @@ C
       LOGICAL INPLACE64_GRAPH_COPY, INPLACE64_RESTORE_GRAPH
       INTEGER(8) :: LIW8, NZG8
       DOUBLE PRECISION TIMEB
+      INTEGER, POINTER, DIMENSION(:) :: SIZEOFBLOCKS_PTR
+      INTEGER, TARGET    :: IDUMMY_ARRAY(1)
+      INTEGER            :: LSIZEOFBLOCKS_PTR
+      LOGICAL            :: SIZEOFBLOCKS_AVAIL
       EXTERNAL MUMPS_ANA_H, CMUMPS_ANA_J, 
      &     CMUMPS_ANA_K, CMUMPS_ANA_GNEW,
      &     CMUMPS_ANA_LNEW, CMUMPS_ANA_M
       EXTERNAL CMUMPS_GNEW_SCHUR
       EXTERNAL CMUMPS_LDLT_COMPRESS, CMUMPS_EXPAND_PERMUTATION,
      &     CMUMPS_SET_CONSTRAINTS
-      IF (LIWALLOC.GT.0_8) THEN
-        ALLOCATE( IWALLOC (LIWALLOC), stat = IERR )
-        IF ( IERR .GT. 0 ) THEN
-         INFO( 1 ) = -7
-         CALL MUMPS_SET_IERROR(LIWALLOC,INFO(2))
-         GOTO 90                
-        ENDIF
-      ENDIF
       ALLOCATE( IWL1 (N), stat = IERR )
       IF ( IERR .GT. 0 ) THEN
          INFO( 1 ) = -7
          INFO( 2 ) = N
          GOTO 90                
       ENDIF
-      ALLOCATE( IPEALLOC(N+1), stat = IERR )
-      IF ( IERR .GT. 0 ) THEN
-         INFO( 1 ) = -7
-         INFO( 2 ) = (N+1)*KEEP(10)
-         GOTO 90                
-      ENDIF
       ALLOCATE( PTRAR (N,3), stat = IERR )
       IF ( IERR .GT. 0 ) THEN
          INFO( 1 ) = -7
@@ -143,6 +134,9 @@ C
          GOTO 90                
       ENDIF
       SCOTCH_SYMBOLIC=(KEEP(270).EQ.0) 
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+      SCOTCH_SYMBOLIC=.FALSE.
+#endif
       symmetry      = INFO(8)
       NBQD          = 0
       GCOMP_PROVIDED=.FALSE.
@@ -160,13 +154,6 @@ C
         INFO(2) = 1
         RETURN
       ENDIF
-      IF ( (LIWALLOC.EQ.0_8).AND.(.not.GCOMP_PROVIDED)) THEN
-        INFO(1) = -900
-        WRITE(6,*) " INTERNAL ERROR in MUMPS(ANA_F) ", 
-     &  "LIWALLOC, GCOMP_PROVIDED=", LIWALLOC, GCOMP_PROVIDED
-        INFO(2) = 2
-        RETURN
-      ENDIF
       IF (GCOMP_PROVIDED) THEN
         NZG8 =  GCOMP%NZG
         LIW8 =  NZG8 + int(GCOMP%NG,8)+1_8
@@ -176,9 +163,30 @@ C
           PTRAR(I,2) = int(IPE(I+1)-IPE(I))
          ENDDO
       ELSE
+        IF (LIWALLOC.GT.0_8) THEN
+          ALLOCATE( IWALLOC (LIWALLOC), stat = IERR )
+          IF ( IERR .GT. 0 ) THEN
+           INFO( 1 ) = -7
+           CALL MUMPS_SET_IERROR(LIWALLOC,INFO(2))
+           GOTO 90                
+          ENDIF
+        ENDIF
+        IF ( LIWALLOC.EQ.0_8 ) THEN
+          INFO(1) = -900
+          WRITE(6,*) " INTERNAL ERROR in MUMPS(ANA_F) ", 
+     &    "LIWALLOC, GCOMP_PROVIDED=", LIWALLOC, GCOMP_PROVIDED
+          INFO(2) = 2
+          RETURN
+        ENDIF
         LIW8 =  LIWALLOC
-        NZG8 = NZ8
+        NZG8 =  NZ8
         IW   => IWALLOC(1:LIW8)
+        ALLOCATE( IPEALLOC(N+1), stat = IERR )
+        IF ( IERR .GT. 0 ) THEN
+          INFO( 1 ) = -7
+          INFO( 2 ) = (N+1)*KEEP(10)
+          GOTO 90                
+        ENDIF
         IPE  => IPEALLOC(1:N+1)
       ENDIF
       LP    = ICNTL(1)
@@ -187,6 +195,16 @@ C
       PROK  = ((MP.GT.0).AND.(ICNTL(4).GE.2))
       LDIAG = ICNTL(4)
       COMPRESS_SCHUR = .FALSE.
+      IF (present(SIZEOFBLOCKS)) THEN
+       SIZEOFBLOCKS_PTR => SIZEOFBLOCKS(1:N)
+       LSIZEOFBLOCKS_PTR = N
+       SIZEOFBLOCKS_AVAIL = .TRUE.
+      ELSE
+       SIZEOFBLOCKS_PTR => IDUMMY_ARRAY
+       SIZEOFBLOCKS_AVAIL = .FALSE.
+       LSIZEOFBLOCKS_PTR = 1
+       IDUMMY_ARRAY(1) = -1
+      ENDIF
       IF (PROK) THEN
         IF (present(GCOMP)) THEN
          WRITE(MP,'(A,I10,A,I13,A)') " Processing a graph of size:", N
@@ -228,7 +246,7 @@ C
           WRITE (MP,99999) N, NZG8, LIW8, INFO(1)
           IF (J8.GT.0_8) WRITE (MP,99998) (IRN(I8),ICN(I8),I8=1_8,J8)
         ENDIF
-         K = min0(10,N)
+         K = min(10,N)
          IF (LDIAG.EQ.4) K = N
          IF (IORD.EQ.1 .AND. K.GT.0) THEN
             WRITE (MP,99997) (IKEEP1(I),I=1,K)
@@ -609,7 +627,7 @@ C
      &              PARENT, IWFR8,
      &              PTRAR(1,2), IW, IWL1, IKEEP1,
      &              IKEEP2, NCMPA, INFO, LP, LPOK, KEEP(10),
-     &              INPLACE64_GRAPH_COPY,
+     &              INPLACE64_GRAPH_COPY, INPLACE64_RESTORE_GRAPH,
      &              WEIGHTUSED, WEIGHTREQUESTED, SCOTCH_SYMBOLIC)
                ELSE
                  WRITE(*,*)
@@ -971,10 +989,10 @@ C
               INFO(1)= -99998
               GOTO 90
            ELSE
-            ALLOCATE( WTEMP ( 2*N ), stat = IERR )
+            ALLOCATE( WTEMP ( 2_8*int(N,8) ), stat = IERR )
             IF ( IERR .GT. 0 ) THEN
                INFO( 1 ) = -7
-               INFO( 2 ) = 2*N
+               CALL MUMPS_SET_IERROR(2_8*int(N,8), INFO(2) )
                GOTO 90          
             ENDIF
             THRESH = -1
@@ -1035,24 +1053,15 @@ C
          INFO( 2 ) = N
          GOTO 90                
       ENDIF
-      IF (present(SIZEOFBLOCKS)) THEN
-       CALL CMUMPS_ANA_LNEW
+      CALL CMUMPS_ANA_LNEW
      &     (N, PARENT, IWL1, IKEEP1(1), IKEEP2(1), IKEEP3(1),
      &     NFSIZ(1), PTRAR, INFO(6), FILS(1), FRERE(1), 
      &     PTRAR(1,3), NEMIN, WTEMP, KEEP(60),
      &     KEEP(20),KEEP(38),PTRAR(1,2),KEEP(104),IW(1),KEEP(50), 
-     &     ICNTL(13), KEEP(37), KEEP(197), NSLAVES, KEEP(250).EQ.1 
-     &     , .TRUE. , SIZEOFBLOCKS, N
+     &     ICNTL(13), KEEP(37), KEEP(197), NSLAVES, KEEP(250).EQ.1,
+     &     SIZEOFBLOCKS_AVAIL, SIZEOFBLOCKS_PTR(1), LSIZEOFBLOCKS_PTR
+     &     , INODE_Scalapack_CAND, NBSONS_Scalapack_CAND, KEEP(11)
      &      )
-      ELSE
-       CALL CMUMPS_ANA_LNEW
-     &     (N, PARENT, IWL1, IKEEP1(1), IKEEP2(1), IKEEP3(1),
-     &     NFSIZ(1), PTRAR, INFO(6), FILS(1), FRERE(1), 
-     &     PTRAR(1,3), NEMIN, WTEMP, KEEP(60),
-     &     KEEP(20),KEEP(38),PTRAR(1,2),KEEP(104),IW(1),KEEP(50), 
-     &     ICNTL(13), KEEP(37), KEEP(197), NSLAVES, KEEP(250).EQ.1 
-     &     , .FALSE., IDUMMY, LIDUMMY )
-      ENDIF
       DEALLOCATE(WTEMP)
       IF (KEEP(60).NE.0)  THEN
          IF (KEEP(60)==1) THEN
@@ -1085,6 +1094,8 @@ C
       IF ( KEEP(53) .NE. 0 ) THEN
          CALL MUMPS_MAKE1ROOT( N, FRERE(1), FILS(1), NFSIZ(1),
      &                         KEEP(20) )
+         INODE_Scalapack_CAND = KEEP(20)
+         NBSONS_Scalapack_CAND = 1
       END IF
       IF (  (KEEP(48) == 4 .AND. KEEP8(21).GT.0_8)
      &     .OR.
@@ -1099,61 +1110,95 @@ C
       IF (KEEP(210).EQ.1.AND.KEEP8(79).LE.0_8) THEN
         KEEP8(79)=K79REF * int(NSLAVES,8)
       ENDIF
-      IF ( (KEEP(79).EQ.0).OR.(KEEP(79).EQ.2).OR.
+      IF (KEEP(11).EQ.0) THEN
+       IF ( (KEEP(79).EQ.0).OR.(KEEP(79).EQ.2).OR.
      &     (KEEP(79).EQ.3).OR.(KEEP(79).EQ.5).OR.
      &     (KEEP(79).EQ.6)
      &   )  THEN
-       IF (KEEP(210).EQ.1) THEN
-        SPLITROOT = .FALSE. 
-        IF ( KEEP(62).GE.1) THEN
-          IWL1(1) = -1
-          IF (present(SIZEOFBLOCKS)) THEN
-            DO I= 1, N
-               IWL1(I) = SIZEOFBLOCKS(I)
-            ENDDO
-          ENDIF
-          CALL CMUMPS_CUTNODES(N, FRERE(1), FILS(1), NFSIZ(1), 
-     &                       IWL1(1), N, INFO(6),
-     &                       NSLAVES, KEEP,KEEP8, SPLITROOT,
-     &                       MP, LDIAG, INFO(1), INFO(2))
-          IF (INFO(1).LT.0) GOTO 90 
-          IF (PROK) THEN
+        IF (KEEP(210).EQ.1) THEN
+         SPLITROOT = .FALSE. 
+         IF ( KEEP(62).GE.1) THEN
+           CALL CMUMPS_CUTNODES(N, FRERE(1), FILS(1), NFSIZ(1), 
+     &         SIZEOFBLOCKS_PTR(1), LSIZEOFBLOCKS_PTR, INFO(6),
+     &         NSLAVES, KEEP,KEEP8, SPLITROOT,
+     &         MP, LDIAG, INFO(1), INFO(2))
+           IF (INFO(1).LT.0) GOTO 90 
+           IF (PROK) THEN
                WRITE(MP,*) " Number of split nodes in pre-splitting=",
      &         KEEP(61)
-          ENDIF
+           ENDIF
+         ENDIF
         ENDIF
        ENDIF
       ENDIF
+      HOW_TO_SPLIT_ROOT = 0 
       SPLITROOT = ICNTL(13) .EQ. -1
+      IF (KEEP(11).GT.1) THEN
+       NFR = NFSIZ(INODE_Scalapack_CAND)
+#if defined(NOSCALAPACK)
+        SPLITROOT = SPLITROOT .OR. 
+     & ( NSLAVES.GT.0.AND. 
+     &   ( REAL(NFR) - REAL(NFR)/REAL(max(2,NSLAVES))
+     &    .GT. REAL(KEEP(9)) )
+     & )
+#else
+        SPLITROOT = SPLITROOT .OR.
+     &  ( ICNTL(13).GT.0 .AND. NSLAVES .GT. ICNTL(13). AND.
+     &    ( REAL(NFR) - REAL(NFR)/REAL(max(2,NSLAVES)) 
+     &     .GT. REAL(KEEP(9)) )
+     &  )
+#endif
+      ELSE
 #if defined(NOSCALAPACK)
-      SPLITROOT = SPLITROOT .OR. NSLAVES.GT.0
+        SPLITROOT = SPLITROOT .OR. NSLAVES.GT.0
 #else
-      SPLITROOT = SPLITROOT .OR.
-     &            (ICNTL(13).GT.0 .AND. NSLAVES .GT. ICNTL(13))
+        SPLITROOT = SPLITROOT .OR.
+     &            (ICNTL(13).GT.0 .AND. NSLAVES .GT. ICNTL(13)
+     &            )
 #endif
+      ENDIF
+      IF (SPLITROOT.AND.KEEP(11).GT.0) HOW_TO_SPLIT_ROOT =1 
       IF (KEEP(53) .NE. 0) THEN
-         SPLITROOT = .TRUE.
+         SPLITROOT         = .TRUE.
+         IF (KEEP(11).GT.0) HOW_TO_SPLIT_ROOT = 2
+      ENDIF
+#if defined(NOSCALAPACK)
+#else
+      IF ( KEEP(11).GT.0) THEN 
+        IF (.NOT.SPLITROOT .AND. 
+     &    (KEEP(60).EQ.0).AND.   
+     &    ( (NFSIZ(INODE_Scalapack_CAND).GT.KEEP(37))
+     &     .AND.(ICNTL(13).LE.0) )
+     &    .AND.
+     &    (NBSONS_Scalapack_CAND.GT.KEEP(11)) 
+     &    ) THEN
+          HOW_TO_SPLIT_ROOT = 3
+          SPLITROOT=.TRUE.
+        ENDIF
       ENDIF
+#endif
       SPLITROOT = (SPLITROOT.AND.( (KEEP(60).EQ.0) ))
       IF (SPLITROOT) THEN
-         IWL1(1) = -1
-         IF (present(SIZEOFBLOCKS)) THEN
-            DO I= 1, N
-               IWL1(I) = SIZEOFBLOCKS(I)
-            ENDDO
-         ENDIF
-         CALL CMUMPS_CUTNODES(N, FRERE(1), FILS(1), NFSIZ(1), 
-     &                    IWL1(1), N, INFO(6),
-     &                    NSLAVES, KEEP,KEEP8, SPLITROOT,
-     &                    MP, LDIAG, INFO(1), INFO(2))
-         IF (INFO(1).LT.0) GOTO 90 
-         IF ( KEEP(53) .NE. 0 ) THEN
-          CALL MUMPS_MAKE1ROOT( N, FRERE(1), FILS(1), NFSIZ(1),
-     &                          KEEP(20) )
-         ENDIF
+        IF (KEEP(11).EQ.0) THEN
+          CALL CMUMPS_CUTNODES(N, FRERE(1), FILS(1), NFSIZ(1), 
+     &              SIZEOFBLOCKS_PTR(1), LSIZEOFBLOCKS_PTR, INFO(6),
+     &              NSLAVES, KEEP,KEEP8, SPLITROOT,
+     &              MP, LDIAG, INFO(1), INFO(2))
+          IF (INFO(1).LT.0) GOTO 90 
+          IF ( KEEP(53) .NE. 0 ) THEN
+           CALL MUMPS_MAKE1ROOT( N, FRERE(1), FILS(1), NFSIZ(1),
+     &                           KEEP(20) )
+          ENDIF
+        ELSE
+         CALL CMUMPS_SPLIT_ROOT( NSLAVES, 
+     &            HOW_TO_SPLIT_ROOT, INODE_Scalapack_CAND,
+     &            N, FRERE(1), FILS(1), NFSIZ(1), 
+     &            KEEP(1), KEEP8(1),
+     &            SIZEOFBLOCKS_PTR(1), LSIZEOFBLOCKS_PTR, INFO(6))
+        ENDIF
       ENDIF
       IF (LDIAG.GT.2 .AND. MP.GT.0) THEN
-         K = min0(10,N)
+         K = min(10,N)
          IF (LDIAG.EQ.4) K = N
          IF (K.GT.0) WRITE (MP,99987) (NFSIZ(I),I=1,K)
          IF (K.GT.0) WRITE (MP,99989) (FILS(I),I=1,K)
@@ -1250,9 +1295,9 @@ C
  70      CONTINUE
       END IF
       IF (id%KEEP(54) .EQ. 3) THEN
-         CALL MPI_ALLREDUCE(IWORK1(1), NBINCOL(1), id%N,
+         CALL MUMPS_BIGALLREDUCE(.FALSE., IWORK1(1), NBINCOL(1), id%N,
      &        MPI_INTEGER, MPI_SUM, id%COMM, IERR )
-         CALL MPI_ALLREDUCE(IWORK2(1), NBINROW(1), id%N,
+         CALL MUMPS_BIGALLREDUCE(.FALSE., IWORK2(1), NBINROW(1), id%N,
      &        MPI_INTEGER, MPI_SUM, id%COMM, IERR )
          deallocate(IWORK2)
       ELSE
@@ -1263,7 +1308,8 @@ C
       END IF
       RETURN
       END SUBROUTINE CMUMPS_ANA_N_DIST
-      SUBROUTINE CMUMPS_ANA_O( N, NZ, MTRANS, PERM, IKEEPALLOC,
+      SUBROUTINE CMUMPS_ANA_O( N, NZ, MTRANS, PERM,
+     &     IKEEPALLOC, LIKEEPALLOC,
      &     idIRN, idJCN, idA, idROWSCA, idCOLSCA, WORK2, KEEP,
      &     ICNTL, INFO, INFOG )
       IMPLICIT NONE
@@ -1273,7 +1319,8 @@ C
       INTEGER, POINTER, DIMENSION(:) :: idIRN, idJCN
       COMPLEX, POINTER, DIMENSION(:) :: idA
       REAL, POINTER, DIMENSION(:) :: idROWSCA, idCOLSCA
-      INTEGER, TARGET        :: IKEEPALLOC(3*N)
+      INTEGER(8), INTENT(IN) :: LIKEEPALLOC
+      INTEGER, TARGET        :: IKEEPALLOC(LIKEEPALLOC)
       INTEGER, INTENT(INOUT) :: MTRANS
       INTEGER                :: KEEP(500)
       INTEGER, INTENT(IN)    :: ICNTL(60)
@@ -1398,7 +1445,7 @@ C
          NZTOT = NZ
       ENDIF
       ZERODIAG => IKEEPALLOC(1:N) 
-      STR_KER => IKEEPALLOC(N+1:2*N)
+      STR_KER  => IKEEPALLOC(int(N+1,8):2_8*int(N,8))
       CALL CMUMPS_MTRANSI(ICNTL64,CNTL64)
       ICNTL64(1) = ICNTL(1)
       ICNTL64(2) = ICNTL(2)
@@ -1446,7 +1493,8 @@ C
       ALLOCATE( IPQ8(N), IPE(N+1), stat = allocok )
       IF ( allocok .GT. 0 ) THEN
          INFO( 1 ) = -7
-         INFO( 2 ) = (2*N+1)*KEEP(10)
+         CALL MUMPS_SET_IERROR( (2_8*int(N,8)+1_8) * int(KEEP(10),8),
+     &                         INFO(2) )
          GOTO 500               
       ENDIF
       IF (MTRANSLOC.EQ.1) THEN
@@ -1456,8 +1504,8 @@ C
       IF (MTRANSLOC.EQ.3) LDWMIN = max( NZTOT+1_8 , N8+3_8 )
       IF (MTRANSLOC.EQ.4) LDWMIN = 2_8 * N8 + 
      &                             max( NZTOT , N8+3_8 )
-      IF (MTRANSLOC.EQ.5) LDWMIN = 3_8*N8 + NZTOT
-      IF (MTRANSLOC.EQ.6) LDWMIN = 4_8*N8 + NZTOT
+      IF (MTRANSLOC.EQ.5) LDWMIN = 3_8 * N8 + NZTOT
+      IF (MTRANSLOC.EQ.6) LDWMIN = 4_8 * N8 + NZTOT
       LDW   = LDWMIN
       ALLOCATE(S2(LDW), stat=allocok)
       IF (allocok .GT. 0 ) THEN
@@ -1626,7 +1674,7 @@ C
       ENDIF
       DUPPLI = .FALSE.
       NZsave = NZREAL
-      FLAG => IKEEPALLOC(2*N+1:3*N)
+      FLAG => IKEEPALLOC(2_8*int(N,8)+1:3_8*int(N,8))
       IF(MTRANSLOC.NE.1) THEN
          CALL CMUMPS_SUPPRESS_DUPPLI_VAL(N,NZREAL,IPE(1),IW(IRNW),S2,
      &        PERM(1),IPQ8(1))
@@ -1853,8 +1901,8 @@ C
             ICNTL_SYM_MWM(1) = 0
             ICNTL_SYM_MWM(2) = 1
          ENDIF
-         MARKED => IKEEPALLOC(N+1:2*N)
-         FLAG => IKEEPALLOC(2*N+1:3*N)
+         MARKED  => IKEEPALLOC(    int(N,8)+1_8 : 2_8*int(N,8))
+         FLAG    => IKEEPALLOC(2_8*int(N,8)+1_8 : 3_8*int(N,8))
          PIV_OUT => WORK2(1:N)
          IF(MTRANSLOC .LT. 4) THEN
             LSC = 1
@@ -1976,7 +2024,7 @@ C
    30       IP = LWFR
             JP = IPE(IE)
    40       IW(IWFR) = JS
-            MINJS = min0(MINJS,IPS(JS)+0)
+            MINJS = min(MINJS,IPS(JS)+0)
             IWFR = IWFR + 1_8
    50     CONTINUE
    60     IPE(IE) = int(-ME,8)
@@ -2073,7 +2121,7 @@ C
       LBIG = 0
       DO 100 I=1,N
         L1 = IQ(I)
-        LBIG = max0(L1,LBIG)
+        LBIG = max(L1,LBIG)
         IWFR = IWFR + int(L1,8)
         IPE(I) = IWFR - 1_8
   100 CONTINUE
@@ -2191,6 +2239,8 @@ C
      &               CUMUL,KEEP50, ICNTL13, KEEP37, KEEP197, NSLAVES,
      &               ALLOW_AMALG_TINY_NODES 
      &               , BLKON, SIZEOFBLOCKS, LSIZEOFBLOCKS
+     &               , INODE_Scalapack_CAND, NBSONS_Scalapack_CAND
+     &               , KEEP11
      &               )
       IMPLICIT NONE
       INTEGER  N, NSTEPS, KEEP60, KEEP20, KEEP38, KEEP50
@@ -2208,6 +2258,9 @@ C
       LOGICAL, INTENT(IN) :: BLKON
       INTEGER, INTENT(IN) :: LSIZEOFBLOCKS
       INTEGER, INTENT(IN) :: SIZEOFBLOCKS(LSIZEOFBLOCKS) 
+      INTEGER, INTENT(OUT):: INODE_Scalapack_CAND, 
+     &                       NBSONS_Scalapack_CAND
+      INTEGER, INTENT(IN) :: KEEP11
 #if  defined(NOAMALGTOFATHER)
 #else
 #endif
@@ -2216,6 +2269,8 @@ C
       INTEGER INOS,IB,IL
       INTEGER IPERM
       INTEGER MAXNODE
+      INTEGER SIZE_Scalapack_CAND, NBSONS_current_root
+      LOGICAL ROOT_WITH_FEW_SONS
 #if defined(NOAMALGTOFATHER)
       INTEGER INB,INF,INFS,INL,INSW,INT1,NR1
 #else
@@ -2223,6 +2278,10 @@ C
 #endif
       LOGICAL AMALG_TO_father_OK
       AMALG_COUNT = 0
+      INODE_Scalapack_CAND  = -1
+      NBSONS_Scalapack_CAND = -1
+      SIZE_Scalapack_CAND   = -1
+      NBSONS_current_root   = 0
       DO 10 I=1,N
         CUMUL(I)= 0
         IPS(I)  = 0
@@ -2332,6 +2391,16 @@ C
          NR = NR + 1
          IL = N
          NA(N) = 0
+         NBSONS_current_root =0
+         IF (IPS(I).LT.0) THEN
+          IB = -IPS(I)
+          NBSONS_current_root = NBSONS_current_root + 1
+  69      IB =FRERE(IB)
+          IF (IB.GT.0) THEN
+             NBSONS_current_root = NBSONS_current_root + 1
+             GOTO 69
+          ENDIF
+         ENDIF
         ENDIF
         DO 70 L=1,N
           IF (IPS(I).GE.0) EXIT
@@ -2341,8 +2410,14 @@ C
           IL = IL - 1
           NA(IL) = 0
    70   CONTINUE
-#if ! defined(NOAMALGTOFATHER)
         DADI = -IPE(I)  
+        IF (DADI.EQ.0) THEN
+         IF (NV(I) .GT. SIZE_Scalapack_CAND) THEN
+           INODE_Scalapack_CAND = I
+           SIZE_Scalapack_CAND  = NV(I)
+         ENDIF
+        ENDIF
+#if ! defined(NOAMALGTOFATHER)
         IF ( (DADI.NE.0) .AND.
      &      (
      &       (KEEP60.EQ.0).OR.
@@ -2387,9 +2462,25 @@ C
                  AMALG_TO_father_OK = .FALSE.
               ENDIF
            ENDIF
+           ROOT_WITH_FEW_SONS =.TRUE.
+           IF (KEEP11.GT.0) THEN
+             IF (IPE(DADI).EQ.0) THEN
+                IF 
+     &          (NA(IL)+max(NA(IL+1),NBSONS_current_root)
+     &                    .GT.KEEP11)
+     &          ROOT_WITH_FEW_SONS= .FALSE.
+             ELSE
+                IF 
+     &          (NA(IL)+NA(IL+1)+max(NA(N),NBSONS_current_root)
+     &                    .GT.KEEP11)
+     &          ROOT_WITH_FEW_SONS= .FALSE.
+             ENDIF
+           ENDIF
            IF ( (NV(I).GT. 50*NV(DADI)).AND. (NSLAVES.GT.1) 
      &          .AND. (ICNTL13.LE.0)
-     &          .AND. (NV(I).GT. KEEP37) )  THEN
+     &          .AND. (NV(I).GT. KEEP37) 
+     &          .AND. ROOT_WITH_FEW_SONS
+     &        )  THEN
              IF ( ( ACCU / SIZE_DADI_AMALGAMATED ) .LT. 0.2 ) THEN
                AMALG_TO_father_OK = .TRUE.
              ENDIF
@@ -2536,6 +2627,17 @@ C
         ENDIF
   160 CONTINUE
       NSTEPS = IS - 1
+        I = INODE_Scalapack_CAND
+        INOS = -FILS(I)  
+        NBSONS_Scalapack_CAND = 0
+        IF (INOS.GT.0) THEN
+          NBSONS_Scalapack_CAND = NBSONS_Scalapack_CAND+1
+          INO = FRERE(INOS)
+          DO WHILE (INO.GT.0 .AND. INO.LE.N) 
+           NBSONS_Scalapack_CAND = NBSONS_Scalapack_CAND+1
+           INO = FRERE(INO)
+          ENDDO
+        ENDIF
       DO I=1, N
         IF (NV(I).EQ.0) THEN
           FRERE(I) = N+1
@@ -2647,7 +2749,7 @@ C
       REAL, INTENT(IN)       :: RINFO(40), RINFOG(40)
       INCLUDE 'mpif.h'
       INTEGER MASTER, MPG
-      INTEGER ITMP
+      INTEGER ITMP, ICNTL48_EFF
       PARAMETER( MASTER = 0 )
       MPG = ICNTL(3)
       IF ( MYID.eq.MASTER.and.MPG.GT.0.AND.ICNTL(4).GE.2) THEN
@@ -2655,12 +2757,17 @@ C
        IF (ICNTL(15).EQ.0) THEN
           ITMP = 0
        ENDIF
+       IF (KEEP(400).GT.0) THEN 
+          ICNTL48_EFF=1
+       ELSE
+          ICNTL48_EFF=0
+       ENDIF
        WRITE(MPG, 99992) INFO(1), INFO(2),
      &  KEEP8(109), KEEP8(111), INFOG(4),
      &  INFOG(5), KEEP(28), INFOG(32), INFOG(7), KEEP(23), 
-     &  ICNTL(7), ICNTL(13), KEEP(12), 
+     &  ICNTL(7), KEEP(95), ICNTL(13), KEEP(12), 
      &  ITMP,
-     &  ICNTL(18),
+     &  ICNTL(18), KEEP(252), KEEP(494), ICNTL48_EFF,
      &  KEEP(106),
      &  KEEP(56), KEEP(61), RINFOG(1)
        IF (KEEP(95).GT.1)             
@@ -2683,10 +2790,14 @@ C
      &       ' --  (7) Ordering option effectively used       =',I16/
      &       ' ICNTL (6) Maximum transversal option           =',I16/
      &       ' ICNTL (7) Pivot order option                   =',I16/
+     &       ' ICNTL(12) Ordering symmetric indef. matrices   =',I16/
      &       ' ICNTL(13) Parallelism/splitting of root node   =',I16/
      &       ' ICNTL(14) Percentage of memory relaxation      =',I16/
      &       ' ICNTL(15) Analysis by block effectively used   =',I16/
      &       ' ICNTL(18) Distributed input matrix (on if >0)  =',I16/
+     &       ' ICNTL(32) Forward elimination during facto.    =',I16/
+     &       ' ICNTL(35) BLR activation                       =',I16/
+     &       ' ICNTL(48) Tree based multithreading (effective)=',I16/
      &       ' ICNTL(58) Symbolic factorization option        =',I16/
      &       ' Number of level 2 nodes                        =',I16/
      &       ' Number of split nodes                          =',I16/
@@ -3004,6 +3115,138 @@ C
       ENDIF
       RETURN
       END SUBROUTINE CMUMPS_SPLIT_1NODE
+      SUBROUTINE CMUMPS_SPLIT_ROOT
+     & ( NSLAVES, HOW, INODE, N, FRERE, FILS, NFSIZ, KEEP, KEEP8,
+     &   SIZEOFBLOCKS, LSIZEOFBLOCKS, NSTEPS)
+      IMPLICIT NONE
+      INTEGER, INTENT(in)    :: NSLAVES, HOW
+      INTEGER, INTENT(in)    :: INODE, N
+      INTEGER(8), INTENT(in) :: KEEP8(150)
+      INTEGER, INTENT(inout) :: NSTEPS
+      INTEGER, INTENT(inout) :: KEEP(500)
+      INTEGER, INTENT(inout) :: FRERE( N ), FILS( N ), NFSIZ( N )
+      INTEGER, INTENT(IN)    :: LSIZEOFBLOCKS
+      INTEGER, INTENT(IN)    :: SIZEOFBLOCKS(LSIZEOFBLOCKS)
+      LOGICAL    :: BLKON
+      INTEGER(8) :: K79
+      INTEGER I, IN, NPIV, NFRONT
+      INTEGER INODE_SON, INODE_FATH, IN_SON, IN_FATH, IN_GRANDFATH
+      INTEGER NPIV_COMPG, NPIV_SON_COMPG, NPIV_FATH_COMPG
+      INTEGER NPIV_SON, NPIV_FATH, NPIV_TEMP
+      INTEGER, PARAMETER :: K_HOW1 = 4000
+      IF (FRERE(INODE).NE.0) RETURN
+      BLKON = .NOT.(SIZEOFBLOCKS(1).EQ.-1) 
+      K79 = max(KEEP8(79), 4_8)
+      K79 = min(20000_8*20000_8,K79) 
+      IF (KEEP(72).EQ.1) THEN
+          K79 = min(3_8*3_8,K79)
+      ENDIF
+      IF ((HOW.LT.1) .OR. (HOW.GT.3)) THEN
+       RETURN 
+      ENDIF
+      IF (HOW.EQ.2) THEN
+       K79 = min(K79, 121_8*121_8)
+      ENDIF
+      NFRONT = NFSIZ (INODE)
+      NPIV = NFRONT
+      IF (NPIV .LE. 1 ) RETURN
+      IF (BLKON) THEN
+       IN = INODE
+       NPIV_COMPG = 0 
+       DO WHILE( IN > 0 )
+         NPIV_COMPG = NPIV_COMPG + 1
+         IN = FILS( IN )
+       ENDDO
+      ELSE 
+        NPIV_COMPG = NPIV
+      ENDIF
+      IF (HOW.EQ.1) THEN
+        IF ( (NFRONT/2) .LT. K_HOW1 ) RETURN
+        NPIV_FATH = max(NFRONT/max(NSLAVES,2), 1)
+        NPIV_FATH = max(NPIV_FATH, K_HOW1/2)
+        NPIV_FATH = min(NPIV_FATH, max(NFRONT/2,1))
+        NPIV_FATH = min(int(sqrt(real(K79))), NPIV_FATH)
+        NPIV_SON  = NPIV - NPIV_FATH
+      ELSE IF (HOW.EQ.2) THEN
+        NPIV_FATH = min(int(sqrt(real(K79))), int(NPIV/2))
+        NPIV_SON  = NPIV - NPIV_FATH
+      ELSE  
+        NPIV_FATH = max(NFRONT - 3*KEEP(6),1) 
+        NPIV_SON  = NPIV - NPIV_FATH
+      ENDIF
+       INODE_SON = INODE
+       IF (BLKON) THEN
+         NPIV_TEMP       = 0
+         NPIV_SON_COMPG  = 0
+         IN_SON = INODE
+         DO WHILE (IN_SON > 0) 
+           NPIV_TEMP = NPIV_TEMP + SIZEOFBLOCKS(IN_SON)
+           NPIV_SON_COMPG  = NPIV_SON_COMPG +1
+           IF (NPIV_TEMP.GE.NPIV_SON) EXIT
+           IN_SON = FILS( IN_SON )
+         END DO
+         NPIV_FATH_COMPG = NPIV_COMPG - NPIV_SON_COMPG
+         NPIV_SON        = NPIV_TEMP
+         NPIV_FATH       = NPIV - NPIV_SON 
+       ELSE
+         NPIV_SON_COMPG  = NPIV_SON
+         NPIV_FATH_COMPG = NPIV_FATH
+         IN_SON = INODE
+         DO I = 1, NPIV_SON_COMPG - 1
+           IN_SON = FILS( IN_SON )
+         END DO
+       ENDIF
+       IF (NPIV_FATH_COMPG.EQ.0)  RETURN
+       INODE_FATH = FILS( IN_SON )
+       IF ( INODE_FATH .LT. 0 ) THEN
+       write(*,*) 'Error: INODE_FATH < 0 ', INODE_FATH
+       END IF
+       IN_FATH = INODE_FATH
+       DO WHILE ( FILS( IN_FATH ) > 0 )
+         IN_FATH = FILS( IN_FATH )
+       END DO
+       FRERE( INODE_FATH ) = FRERE( INODE_SON )
+       FRERE( INODE_SON  ) = - INODE_FATH
+       FILS ( IN_SON     ) = FILS( IN_FATH )
+       FILS ( IN_FATH    ) = - INODE_SON
+       IN = FRERE( INODE_FATH )
+       DO WHILE ( IN > 0 )
+           IN = FRERE( IN )
+       END DO
+       IF ( IN .eq. 0 )  GO TO 10
+       IN = -IN
+       DO WHILE ( FILS( IN ) > 0 )
+           IN = FILS( IN )
+       END DO
+       IN_GRANDFATH = IN
+       IF ( FILS( IN_GRANDFATH ) .eq. - INODE_SON ) THEN
+           FILS( IN_GRANDFATH ) = -INODE_FATH
+       ELSE
+           IN = IN_GRANDFATH
+           IN = - FILS ( IN )
+           DO WHILE ( FRERE( IN ) > 0 )
+             IF ( FRERE( IN ) .eq. INODE_SON ) THEN
+               FRERE( IN ) = INODE_FATH
+               GOTO 10
+             END IF
+             IN = FRERE( IN )
+           END DO
+           WRITE(*,*) 'ERROR 2 in SPLIT NODE',
+     &          IN_GRANDFATH, IN, FRERE(IN)
+       END IF
+ 10    CONTINUE
+       NFSIZ(INODE_SON) = NFRONT
+       NFSIZ(INODE_FATH) = NFRONT - NPIV_SON
+       KEEP(2) = max( KEEP(2), NFRONT - NPIV_SON )
+       NSTEPS  = NSTEPS + 1
+       IF ( (KEEP(53).EQ.0) .AND. NSLAVES.GT.1) THEN
+         KEEP(38) = INODE_FATH
+       ENDIF
+       IF ( KEEP(53).NE.0 ) THEN
+         KEEP(20) = INODE_FATH
+       ENDIF
+      RETURN
+      END SUBROUTINE CMUMPS_SPLIT_ROOT
       SUBROUTINE CMUMPS_ANA_GNEW
      & (N, NZ, IRN, ICN, IW, LW, IPE, LEN,
      & IQ, FLAG, IWFR,
@@ -3415,7 +3658,7 @@ C
      &         CMUMPS_MTRANSS,CMUMPS_MTRANSW
       INTRINSIC abs,log
       RINF = CNTL(2)
-      RINF2 = huge(RINF2)/real(2*N)
+      RINF2 = huge(RINF2)/real(int(2,8)*int(N,8))
       RINF3 = 0.0E0
       WARN1 = 0
       WARN2 = 0
@@ -3444,12 +3687,12 @@ C
          IF (ICNTL(1).GE.0) WRITE(ICNTL(1),9001) INFO(1),'NE',NE
          GO TO 99
       ENDIF
-      IF (JOB.EQ.1) K = int(4*N +   M,8)
-      IF (JOB.EQ.2) K = int(N + 2*M,8)
-      IF (JOB.EQ.3) K = int(8*N + 2*M + NE,8)
-      IF (JOB.EQ.4) K = int(N + M,8)
-      IF (JOB.EQ.5) K = int(3*N + 2*M,8)
-      IF (JOB.EQ.6) K = int(3*N + 2*M + NE,8)
+      IF (JOB.EQ.1) K = 4_8*int(N,8)+int(M,8)
+      IF (JOB.EQ.2) K = int(N,8) + 2_8*int(M,8)
+      IF (JOB.EQ.3) K = 8_8*int(N,8) + 2*int(M,8) + NE
+      IF (JOB.EQ.4) K = int(N,8) + int(M,8)
+      IF (JOB.EQ.5) K = 3_8*int(N,8) + 2_8*int(M,8)
+      IF (JOB.EQ.6) K = 3_8*int(N,8) + 2_8*int(M,8) + NE
       IF (LIW.LT.K) THEN
          INFO(1) = -4
          CALL MUMPS_SET_IERROR(K,INFO(2))
@@ -3457,11 +3700,11 @@ C
          GO TO 99
       ENDIF
       IF (JOB.GT.1) THEN
-         IF (JOB.EQ.2) K = int(      M,8)
+         IF (JOB.EQ.2) K = int(M,8)
          IF (JOB.EQ.3) K = int(1,8)
-         IF (JOB.EQ.4) K = int(    2*M,8)
-         IF (JOB.EQ.5) K = int(N + 2*M,8)
-         IF (JOB.EQ.6) K = int(N + 3*M,8)
+         IF (JOB.EQ.4) K = 2_8*int(M,8)
+         IF (JOB.EQ.5) K = int(N,8) + 2_8*int(M,8)
+         IF (JOB.EQ.6) K = int(N,8) + 3_8*int(M,8)
          IF (LDW .LT. K) THEN
             INFO(1) = -5
             CALL MUMPS_SET_IERROR(K,INFO(2))
@@ -3518,13 +3761,18 @@ C
             IW(J) = int(IP(J+1) - IP(J))
  10      CONTINUE
          CALL CMUMPS_MTRANSZ(M,N,IRN,NE,IP,IW(1),PERM,NUM,
-     &        IW(N+1),IW(2*N+1),IW(3*N+1),IW(3*N+M+1))
+     &        IW(    int(N,8)+1_8),
+     &        IW(2_8*int(N,8)+1_8),
+     &        IW(3_8*int(N,8)+1_8),
+     &        IW(3_8*int(N,8)+int(M,8)+1_8))
          GO TO 90
       ENDIF
       IF (JOB.EQ.2) THEN
          DW(1) = max(ZERO,CNTL(1))
          CALL CMUMPS_MTRANSB(M,N,NE,IP,IRN,A,PERM,NUM,
-     &        IW(1),IPQ8,IW(N+1),IW(N+M+1),DW,RINF2)
+     &        IW(1),IPQ8,IW(int(N,8)+1_8),
+     &        IW(int(N,8)+int(M,8)+1_8),
+     &        DW,RINF2)
          GO TO 90
       ENDIF
       IF (JOB.EQ.3) THEN
@@ -3533,16 +3781,21 @@ C
  20      CONTINUE
          CALL CMUMPS_MTRANSR(N,NE,IP,IW,A)
          FACT = max(ZERO,CNTL(1))
-         CALL CMUMPS_MTRANSS(M,N,NE,IP,IW(1),A,PERM,NUM,IW(NE+1),
-     &        IW(NE+N+1),IW(NE+2*N+1),IW(NE+3*N+1),IW(NE+4*N+1),
-     &        IW(NE+5*N+1),IW(NE+5*N+M+1),FACT,RINF2)
+         CALL CMUMPS_MTRANSS(M,N,NE,IP,IW(1),A,PERM,NUM,IW(NE+1_8),
+     &        IW(NE+int(N,8)+1_8),IW(NE+2_8*int(N,8)+1_8),
+     &        IW(NE+3_8*int(N,8)+1_8),
+     &        IW(NE+4_8*int(N,8)+1_8),
+     &        IW(NE+5_8*int(N,8)+1_8),
+     &        IW(NE+5_8*int(N,8)+int(M,8)+1_8),
+     &        FACT,RINF2)
          GO TO 90
       ENDIF
       IF ((JOB.EQ.4).OR.(JOB.EQ.5).or.(JOB.EQ.6)) THEN
-           ALLOCATE(IWtemp8(M+N+N), stat=allocok)
+           ALLOCATE(IWtemp8(int(M,8)+int(N,8)+int(N,8)), stat=allocok)
            IF (allocok.GT.0) THEN
              INFOMUMPS(1) = -7
-             INFOMUMPS(2) = M+N+N
+             CALL MUMPS_SET_IERROR( int(M,8)+int(N,8)+int(N,8),
+     &                               INFOMUMPS(2) )
              GOTO 90
            ENDIF
       ENDIF
@@ -3561,9 +3814,10 @@ C
          DW(2)      = RINF3
          IWtemp8(1) = int(JOB,8)
          CALL CMUMPS_MTRANSW(M,N,NE,IP,IRN,A,PERM,NUM,
-     &        IWtemp8(1),IW(1),IWtemp8(N+1),IPQ8,IW(N+1),
-     &        IWtemp8(2*N+1),
-     &        DW(1),DW(M+1),RINF2)
+     &        IWtemp8(1),IW(1),IWtemp8(int(N,8)+1_8),IPQ8,
+     &        IW(int(N,8)+1_8),
+     &        IWtemp8(2_8*int(N,8)+1_8),
+     &        DW(1),DW(int(M,8)+1_8),RINF2)
          DEALLOCATE(IWtemp8)  
          GO TO 90
       ENDIF
@@ -3575,7 +3829,7 @@ C
                DO 60 K = IP(J),IP(J+1)-1_8
                   IF (A(K).GT.FACT) FACT = A(K)
  60            CONTINUE
-               DW(2*M+J) = FACT
+               DW(2_8*int(M,8)+int(J,8)) = FACT
                IF (FACT.NE.ZERO) THEN
                   FACT = log(FACT)
                   IF(FACT .GT. RINF3) RINF3=FACT
@@ -3596,38 +3850,40 @@ C
          ENDIF
          IF (JOB.EQ.6) THEN
             DO 175 K = 1,NE
-               IW(3*N+2*M+K) = IRN(K)
+               IW(3_8*int(N,8)+2_8*int(M,8)+int(K,8)) = IRN(K)
  175        CONTINUE
             DO 61 I = 1,M
-               DW(2*M+N+I) = ZERO
+               DW(2_8*int(M,8)+int(N,8)+int(I,8)) = ZERO
  61         CONTINUE
             DO 63 J = 1,N
                DO 62 K = IP(J),IP(J+1)-1_8
                   I = IRN(K)
-                  IF (A(K).GT.DW(2*M+N+I)) THEN
-                     DW(2*M+N+I) = A(K)
+                  IF (A(K).GT.DW(2_8*int(M,8)+int(N,8)+int(I,8))) THEN
+                     DW(2_8*int(M,8)+int(N,8)+int(I,8)) = A(K)
                   ENDIF
  62            CONTINUE
  63         CONTINUE
             DO 64 I = 1,M
-               IF (DW(2*M+N+I).NE.ZERO) THEN
-                  DW(2*M+N+I) = 1.0E0/DW(2*M+N+I)
+               IF (DW(2_8*int(M,8)+int(N,8)+int(I,8)).NE.ZERO) THEN
+                   DW(2_8*int(M,8)+int(N,8)+int(I,8)) =
+     &                      1.0E0/DW(2_8*int(M,8)+int(N,8)+int(I,8))
                ENDIF
  64         CONTINUE
             DO 66 J = 1,N
                DO 65 K = IP(J),IP(J+1)-1
                   I = IRN(K)
-                  A(K) = DW(2*M+N+I) * A(K)
+                  A(K) = DW(2_8*int(M,8)+int(N,8)+int(I,8)) * A(K)
  65            CONTINUE
  66         CONTINUE
-            CALL CMUMPS_MTRANSR(N,NE,IP,IW(3*N+2*M+1),A)
+            CALL CMUMPS_MTRANSR(N,NE,IP,
+     &           IW(3_8*int(N,8)+2_8*int(M,8)+1_8),A)
             DO 176 J = 1,N
                IF (IP(J).NE.IP(J+1)) THEN
                   FACT = A(IP(J))
                ELSE
                   FACT = ZERO
                ENDIF
-               DW(2*M+J) = FACT
+               DW(2_8*int(M,8)+int(J,8)) = FACT
                IF (FACT.NE.ZERO) THEN
                   FACT = log(FACT)
                   DO 170 K = IP(J),IP(J+1)-1_8
@@ -3651,34 +3907,38 @@ C
          IWtemp8(1) = int(JOB,8)
           IF (JOB.EQ.5) THEN
          CALL CMUMPS_MTRANSW(M,N,NE,IP,IRN,A,PERM,NUM,
-     &        IWtemp8(1),IW(1),IWtemp8(N+1),IPQ8,IW(N+1),
-     &        IWtemp8(2*N+1),
-     &        DW(1),DW(M+1),RINF2)
+     &        IWtemp8(1),IW(1),IWtemp8(int(N,8)+1_8),IPQ8,
+     &        IW(int(N,8)+1_8),
+     &        IWtemp8(2_8*int(N,8)+1_8),
+     &        DW(1),DW(int(M,8)+1_8),RINF2)
          ENDIF
          IF (JOB.EQ.6) THEN
-         CALL CMUMPS_MTRANSW(M,N,NE,IP,IW(3*N+2*M+1),A,PERM,NUM,
-     &        IWtemp8(1),IW(1),IWtemp8(N+1),IPQ8,IW(N+1),
-     &        IWtemp8(2*N+1),
-     &        DW(1),DW(M+1),RINF2)
+         CALL CMUMPS_MTRANSW(M,N,NE,IP,
+     &        IW(3_8*int(N,8)+2_8*int(M,8)+1_8),A,PERM,NUM,
+     &        IWtemp8(1),IW(1),IWtemp8(int(N,8)+1_8),IPQ8,
+     &        IW(int(N,8)+1_8),
+     &        IWtemp8(2_8*int(N,8)+1_8),
+     &        DW(1),DW(int(M,8)+1_8),RINF2)
          ENDIF
          IF ((JOB.EQ.5).or.(JOB.EQ.6)) THEN
           DEALLOCATE(IWtemp8)
          ENDIF
          IF (JOB.EQ.6) THEN
-            DO 79 I = 1,M
-               IF (DW(2*M+N+I).NE.0.0E0) THEN
-                  DW(I) = DW(I) + log(DW(2*M+N+I))
-               ENDIF
- 79         CONTINUE
+           DO 79 I = 1,M
+             IF (DW(2_8*int(M,8)+int(N,8)+int(I,8)).NE.0.0E0) THEN
+               DW(I) = DW(I) + log(DW(2_8*int(M,8)+int(N,8)+int(I,8)))
+             ENDIF
+ 79        CONTINUE
          ENDIF
          IF (NUM.EQ.N) THEN
-            DO 80 J = 1,N
-               IF (DW(2*M+J).NE.ZERO) THEN
-                  DW(M+J) = DW(M+J) - log(DW(2*M+J))
-               ELSE
-                  DW(M+J) = ZERO
-               ENDIF
- 80         CONTINUE
+           DO 80 J = 1,N
+             IF (DW(2_8*int(M,8)+int(J,8)).NE.ZERO) THEN
+               DW(int(M,8)+int(J,8)) = DW(int(M,8)+int(J,8)) -
+     &                                 log(DW(2_8*int(M,8)+int(J,8)))
+             ELSE
+               DW(int(M,8)+int(J,8)) = ZERO
+             ENDIF
+ 80        CONTINUE
          ENDIF
          FACT = 0.5E0*log(RINF2)
          DO 86 I = 1,M
@@ -3714,13 +3974,15 @@ C
                WRITE(ICNTL(3),9032) (PERM(J),J=1,min(10,M))
                IF (JOB.EQ.5 .OR. JOB.EQ.6) THEN
                   WRITE(ICNTL(3),9033) (DW(J),J=1,min(10,M))
-                  WRITE(ICNTL(3),9034) (DW(M+J),J=1,min(10,N))
+                  WRITE(ICNTL(3),9034) (DW(int(M,8)+int(J,8)),
+     &                                  J=1,min(10,N))
                ENDIF
             ELSEIF (ICNTL(4).EQ.1) THEN
                WRITE(ICNTL(3),9032) (PERM(J),J=1,M)
                IF (JOB.EQ.5 .OR. JOB.EQ.6) THEN
                   WRITE(ICNTL(3),9033) (DW(J),J=1,M)
-                  WRITE(ICNTL(3),9034) (DW(M+J),J=1,N)
+                  WRITE(ICNTL(3),9034) (DW(int(M,8)+int(J,8)),
+     &                                  J=1,N)
                ENDIF
             ENDIF
          ENDIF
@@ -4003,6 +4265,7 @@ C
       REAL PEAK
       INTEGER, intent(IN) :: LSIZEOFBLOCKS
       INTEGER, intent(IN) :: SIZEOFBLOCKS(LSIZEOFBLOCKS)
+      CALL MUMPS_SET_K78_83_91 (NSLAVES,KEEP(78),KEEP(83),KEEP(91))
       CALL MUMPS_DISTRIBUTE(N,NSLAVES,
      &     ICNTL,INFOG, NE, NFSIZ,
      &     FRERE, FILS,
diff -pruN 5.6.2-2.1/src/cana_aux_ELT.F 5.7.1-1/src/cana_aux_ELT.F
--- 5.6.2-2.1/src/cana_aux_ELT.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/cana_aux_ELT.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -24,7 +24,8 @@ C
      &            )
       USE MUMPS_ANA_ORD_WRAPPERS
       IMPLICIT NONE
-      INTEGER, INTENT(IN)    :: N,  NELT, SIZE_SCHUR, NSLAVES, LIW
+      INTEGER, INTENT(IN)    :: N,  NELT, SIZE_SCHUR, NSLAVES
+      INTEGER(8), INTENT(IN) :: LIW
       INTEGER, INTENT(IN)    :: ELTPTR(NELT+1) 
       INTEGER, INTENT(IN)    :: ELTVAR(ELTPTR(NELT+1)-1)
       INTEGER, INTENT(IN)    :: LISTVAR_SCHUR(SIZE_SCHUR)
@@ -38,7 +39,8 @@ C
 #if defined(metis) || defined(parmetis) || defined(metis4) || defined(parmetis3)      
       INTEGER, INTENT(IN)    :: METIS_OPTIONS(40)
 #endif
-      INTEGER K,I,L1,L2,NCMPA,IFSON,IN
+      INTEGER K,I,NCMPA,IFSON,IN
+      INTEGER(8) :: L1, L2
       INTEGER NEMIN, MPRINT, LP, MP, LDIAG
       INTEGER(8)  :: NZ8, LLIW8, IWFR8
       INTEGER allocok, ITEMP
@@ -46,6 +48,8 @@ C
       INTEGER(8) :: K79REF
       PARAMETER(K79REF=12000000_8)
       LOGICAL SPLITROOT
+      INTEGER HOW_TO_SPLIT_ROOT, INODE_Scalapack_CAND, 
+     &        NBSONS_Scalapack_CAND
       INTEGER, PARAMETER :: LIDUMMY = 1
       INTEGER :: IDUMMY(1) 
       INTEGER, DIMENSION(:), ALLOCATABLE :: IW
@@ -73,7 +77,7 @@ C
         ALLOCATE( IW ( LIW ), stat = allocok )
         IF ( allocok .GT. 0 ) THEN
           INFO( 1 ) = -7
-          INFO( 2 ) = LIW
+          CALL MUMPS_SET_IERROR(LIW, INFO( 2 ))
           GOTO 90 
         ENDIF
         ALLOCATE( IPE8 ( N + 1 ), stat = allocok )
@@ -85,7 +89,7 @@ C
         ALLOCATE( PARENT(N), IWtemp ( N, 3 ), stat = allocok )
         IF ( allocok .GT. 0 ) THEN
           INFO( 1 ) = -7
-          INFO( 2 ) = 4*N
+          CALL MUMPS_SET_IERROR(4_8*int(N,8), INFO( 2 ))
           GOTO 90 
         ENDIF
       MPRINT= ICNTL(3)
@@ -118,42 +122,42 @@ C
       NEMIN = KEEP(1)
       IF (LDIAG.LE.2 .OR. MP.LE.0) GO TO 10
       WRITE (MP,99999) N, NELT, LIW, INFO(1)
-      K = min0(10,NELT+1)
+      K = min(10,NELT+1)
       IF (LDIAG.EQ.4) K = NELT+1
       IF (K.GT.0) WRITE (MP,99998) (ELTPTR(I),I=1,K)
-      K = min0(10,ELTPTR(NELT+1)-1)
+      K = min(10,ELTPTR(NELT+1)-1)
       IF (LDIAG.EQ.4) K = ELTPTR(NELT+1)-1
       IF (K.GT.0) WRITE (MP,99995) (ELTVAR(I),I=1,K)
-      K = min0(10,N)
+      K = min(10,N)
       IF (LDIAG.EQ.4) K = N
       IF (IORD.EQ.1 .AND. K.GT.0) THEN
         WRITE (MP,99997) (IKEEP(I,1),I=1,K)
       ENDIF
-   10 L1 = 1
-      L2 = L1 + N
-      IF (LIW .LT. 3*N) THEN
+   10 L1 = 1_8
+      L2 = L1 + int(N,8)
+      IF (LIW .LT. 3_8*int(N,8)) THEN
           INFO(1) = -2002
-          INFO(2) = LIW
+          CALL MUMPS_SET_IERROR( LIW, INFO(2) )
       ENDIF
 #if defined(metis) || defined(parmetis) || defined(metis4) || defined(parmetis3)
       IF ( IORD == 5 ) THEN
-        IF (LIW .LT. N+N+1) THEN
+        IF (LIW .LT. int(N,8)+int(N,8)+1_8) THEN
           INFO(1)= -2002
-          INFO(2) = LIW
+          CALL MUMPS_SET_IERROR( LIW, INFO(2) )
           GOTO 90 
         ENDIF
       ELSE
 #endif
       IF (NOSUPERVAR) THEN
-        IF ( LIW .LT. 2*N ) THEN
+        IF ( LIW .LT. 2_8*int(N,8) ) THEN
           INFO(1)= -2002
-          INFO(2) = LIW
+          CALL MUMPS_SET_IERROR( LIW, INFO(2) )
           GOTO 90 
         END IF
       ELSE
-        IF ( LIW .LT.  4*N+4 ) THEN
+        IF ( LIW .LT.  4_8*int(N,8)+4_8 ) THEN
           INFO(1)= -2002
-          INFO(2) = LIW
+          CALL MUMPS_SET_IERROR( LIW, INFO(2) )
           GOTO 90 
         END IF
       ENDIF
@@ -170,9 +174,9 @@ C
      &              ELTPTR, ELTVAR, XNODEL, NODEL,
      &              IWtemp(1,2), IW(L1))
         ELSE
-         CALL CMUMPS_ANA_G11_ELT(N, NZ8, NELT, ELTPTR(NELT+1)-1, 
+          CALL CMUMPS_ANA_G11_ELT(N, NZ8, NELT, ELTPTR(NELT+1)-1, 
      &              ELTPTR, ELTVAR, XNODEL, NODEL,
-     &              IWtemp(1,2), 4*N+4, IW(L1))
+     &              IWtemp(1,2), 4_8*int(N,8)+4_8, IW(L1))
         ENDIF
         LLIW8 = max(NZ8,int(N,8))
         ALLOCATE( IW2(LLIW8), stat = allocok )
@@ -288,15 +292,15 @@ C
         ENDIF
 #endif
        DO K=1,N
-         IW(L1+K) = 0
+         IW(L1+int(K,8)) = 0
        ENDDO
        DO K=1,N
          IF ((IKEEP(K,1).LE.0).OR.(IKEEP(K,1).GT.N)) 
      &    GO TO 40
-         IF (IW(L1+IKEEP(K,1)).EQ.1) THEN
+         IF (IW(L1+int(IKEEP(K,1),8)).EQ.1) THEN
           GOTO 40
          ELSE
-          IW(L1+IKEEP(K,1)) = 1
+          IW(L1+int(IKEEP(K,1),8)) = 1
          ENDIF
        ENDDO
        CALL CMUMPS_ANA_J1_ELT(N, NZ8, NELT, ELTPTR(NELT+1)-1,
@@ -335,9 +339,10 @@ C
      &     NFSIZ, IWtemp(1,2), 
      &     INFO(6), FILS, FRERE, IWtemp(1,3), NEMIN, 
      &     IW(L2),  KEEP(60), KEEP(20), KEEP(38),
-     &     IW2,KEEP(104),IW(L2+N),KEEP(50),
+     &     IW2,KEEP(104),IW(L2+int(N,8)),KEEP(50),
      &     ICNTL(13), KEEP(37), KEEP(197), NSLAVES, KEEP(250).EQ.1,
-     &     .FALSE., IDUMMY, LIDUMMY)
+     &     .FALSE., IDUMMY, LIDUMMY, 
+     &     INODE_Scalapack_CAND, NBSONS_Scalapack_CAND, KEEP(11) )
       DEALLOCATE(IW2)
       IF (KEEP(60).NE.0) THEN
          IF (KEEP(60)==1) THEN
@@ -368,6 +373,8 @@ C
      &  KEEP(6), KEEP(226), KEEP(253))
       IF ( KEEP(53) .NE. 0 ) THEN
         CALL MUMPS_MAKE1ROOT( N, FRERE, FILS, NFSIZ, KEEP(20) )
+        INODE_Scalapack_CAND  = KEEP(20)
+        NBSONS_Scalapack_CAND = 1
       END IF
       IF ( KEEP(48) == 4 .OR.
      &   ( (KEEP(24).NE.0).AND.(KEEP8(21).GT.0_8) ) ) THEN
@@ -379,23 +386,26 @@ C
       IF (KEEP(210).EQ.1.AND.KEEP8(79).LE.0_8) THEN
         KEEP8(79)=K79REF * int(NSLAVES,8)
       ENDIF
-      IF (KEEP(79).EQ.0) THEN
-       IF (KEEP(210).EQ.1) THEN
-        SPLITROOT = .FALSE. 
-        IF ( KEEP(62).GE.1) THEN
-          IDUMMY(1)= -1
-          CALL CMUMPS_CUTNODES(N, FRERE, FILS, NFSIZ,
-     &                       IDUMMY, LIDUMMY, INFO(6),
-     &                       NSLAVES, KEEP,KEEP8, SPLITROOT,
-     &                       MP, LDIAG, INFO(1), INFO(2))
-          IF (INFO(1).LT.0) GOTO 90 
-          IF (PROK) THEN
-               WRITE(MP,*) " Number of split nodes in pre-splitting=",
-     &         KEEP(61)
+      IF (KEEP(11).EQ.0) THEN
+        IF (KEEP(79).EQ.0) THEN
+         IF (KEEP(210).EQ.1) THEN
+          SPLITROOT = .FALSE. 
+          IF ( KEEP(62).GE.1) THEN
+            IDUMMY(1)= -1
+            CALL CMUMPS_CUTNODES(N, FRERE, FILS, NFSIZ,
+     &                         IDUMMY, LIDUMMY, INFO(6),
+     &                         NSLAVES, KEEP,KEEP8, SPLITROOT,
+     &                         MP, LDIAG, INFO(1), INFO(2))
+            IF (INFO(1).LT.0) GOTO 90 
+            IF (PROK) THEN
+                 WRITE(MP,*) " Number of split nodes in pre-splitting=",
+     &           KEEP(61)
+            ENDIF
           ENDIF
+         ENDIF
         ENDIF
-       ENDIF
       ENDIF
+      HOW_TO_SPLIT_ROOT = 0 
       SPLITROOT = ICNTL(13) .EQ. -1
 #if defined(NOSCALAPACK)
       SPLITROOT = SPLITROOT .OR. NSLAVES.GT.0
@@ -403,23 +413,50 @@ C
       SPLITROOT = SPLITROOT .OR.
      &            (ICNTL(13).GT.0 .AND. NSLAVES .GT. ICNTL(13))
 #endif
+      HOW_TO_SPLIT_ROOT = 0 
+      IF (SPLITROOT.AND.KEEP(11).GT.0) HOW_TO_SPLIT_ROOT =1 
       IF (KEEP(53) .NE. 0) THEN
-         SPLITROOT = .TRUE.
+         SPLITROOT         = .TRUE.
+         IF (KEEP(11).GT.0) HOW_TO_SPLIT_ROOT = 2
       ENDIF
       SPLITROOT = (SPLITROOT.AND.( (KEEP(60).EQ.0) ))
+#if defined(NOSCALAPACK)
+#else
+      IF ( KEEP(11).GT.0) THEN 
+        IF (.NOT.SPLITROOT .AND. 
+     &    (KEEP(60).EQ.0).AND.   
+     &    ( (NFSIZ(INODE_Scalapack_CAND).GT.KEEP(37))
+     &      .AND.(ICNTL(13).LE.0) )
+     &    .AND.
+     &    (NBSONS_Scalapack_CAND.GT.KEEP(11)) 
+     &    ) THEN
+          HOW_TO_SPLIT_ROOT = 3
+          SPLITROOT=.TRUE.
+        ENDIF
+      ENDIF
+#endif
       IF (SPLITROOT) THEN
-         IDUMMY(1) = -1
-         CALL CMUMPS_CUTNODES(N, FRERE, FILS, NFSIZ,
-     &                    IDUMMY, LIDUMMY, INFO(6),
-     &                    NSLAVES, KEEP,KEEP8, SPLITROOT,
-     &                    MP, LDIAG, INFO(1), INFO(2))
-         IF (INFO(1).LT.0) GOTO 90 
-         IF ( KEEP(53) .NE. 0 ) THEN
-          CALL MUMPS_MAKE1ROOT( N, FRERE, FILS, NFSIZ, KEEP(20) )
-         ENDIF
+        IDUMMY(1) = -1
+        IF (KEEP(11).EQ.0) THEN
+          CALL CMUMPS_CUTNODES(N, FRERE(1), FILS(1), NFSIZ(1), 
+     &                     IDUMMY, LIDUMMY, INFO(6),
+     &                     NSLAVES, KEEP,KEEP8, SPLITROOT,
+     &                     MP, LDIAG, INFO(1), INFO(2))
+          IF (INFO(1).LT.0) GOTO 90 
+          IF ( KEEP(53) .NE. 0 ) THEN
+           CALL MUMPS_MAKE1ROOT( N, FRERE(1), FILS(1), NFSIZ(1),
+     &                           KEEP(20) )
+          ENDIF
+        ELSE
+         CALL CMUMPS_SPLIT_ROOT( NSLAVES,
+     &               HOW_TO_SPLIT_ROOT, INODE_Scalapack_CAND,
+     &               N, FRERE(1), FILS(1), NFSIZ(1), 
+     &               KEEP, KEEP8,
+     &               IDUMMY, LIDUMMY, INFO(6))
+        ENDIF
       ENDIF
       IF (LDIAG.GT.2 .AND. MP.GT.0) THEN
-         K = min0(10,N)
+         K = min(10,N)
          IF (LDIAG.EQ.4) K = N
          IF (K.GT.0) WRITE (MP,99997) (IKEEP(I,1),I=1,K)
          IF (K.GT.0) WRITE (MP,99991) (IKEEP(I,2),I=1,K)
@@ -955,7 +992,8 @@ C
      &  XELNOD, ELNOD, XNODEL, NODEL, 
      &  LEN, LW, IW)
       IMPLICIT NONE
-      INTEGER N,NELT,NELNOD,LW
+      INTEGER N,NELT,NELNOD
+      INTEGER(8) :: LW
       INTEGER(8), INTENT(OUT) :: NZ
       INTEGER XELNOD(NELT+1), ELNOD(NELNOD)
       INTEGER LEN(N)
@@ -966,7 +1004,8 @@ C
       EXTERNAL CMUMPS_SUPVAR
       LP = 6
       CALL CMUMPS_SUPVAR(N,NELT,XELNOD(NELT+1)-1,ELNOD,XELNOD,
-     &           NSUP,IW(3*N+3+1),3*N+3,IW,LP,INFO44)
+     &           NSUP,IW(3_8*int(N,8)+3_8+1_8),
+     &           3_8*int(N,8)+3_8,IW,LP,INFO44)
       IF (INFO44(1) .LT. 0) THEN
         IF (LP.GE.0) WRITE(LP,*) 
      &     'Error return from CMUMPS_SUPVAR. INFO(1) = ',INFO44(1) 
@@ -974,7 +1013,7 @@ C
       IW(1:NSUP) = 0
       LEN(1:N) = 0
       DO I = 1,N
-        SUPVAR = IW(3*N+3+1+I)
+        SUPVAR = IW(3_8*int(N,8)+3_8+1_8+int(I,8))
         IF (SUPVAR .EQ. 0) CYCLE
         IF (IW(SUPVAR).NE.0) THEN
           LEN(I) = -IW(SUPVAR)
@@ -982,7 +1021,7 @@ C
           IW(SUPVAR) = I
         ENDIF
       ENDDO
-      IW(N+1:2*N) = 0
+      IW(int(N+1,8):2_8*int(N,8)) = 0
       NZ = 0_8
       DO SUPVAR = 1,NSUP
         I = IW(SUPVAR)
@@ -992,8 +1031,8 @@ C
             J = ELNOD(K3)
             IF ((J.GE.1) .AND. (J.LE.N)) THEN
               IF (LEN(J).GE.0) THEN
-                IF ((I.NE.J) .AND. (IW(N+J).NE.I)) THEN
-                  IW(N+J) = I
+                IF ((I.NE.J) .AND. (IW(int(N,8)+int(J,8)).NE.I)) THEN
+                  IW(int(N,8)+int(J,8)) = I
                   LEN(I) = LEN(I) + 1
                 ENDIF
               ENDIF
@@ -1049,12 +1088,12 @@ C
       END SUBROUTINE CMUMPS_ANA_G12_ELT
       SUBROUTINE CMUMPS_SUPVAR(N,NELT,NZ,ELTVAR,ELTPTR,NSUP,SVAR,
      &                 LIW,IW,LP,INFO)
-      INTEGER LIW,LP,N,NELT,NSUP,NZ
+      INTEGER LP,N,NELT,NSUP,NZ
+      INTEGER(8)::LIW
       INTEGER INFO(6)
       INTEGER ELTPTR(NELT+1),ELTVAR(NZ)
       INTEGER IW(LIW),SVAR(0:N)
-      INTEGER FLAG,NEW,VARS
-      EXTERNAL CMUMPS_SUPVARB
+      INTEGER(8) :: FLAG,NEW,VARS
       INFO(1) = 0
       INFO(2) = 0
       INFO(3) = 0
@@ -1063,19 +1102,20 @@ C
       IF (NELT.LT.1) GO TO 20
       IF (NZ.LT.ELTPTR(NELT+1)-1) GO TO 30
       IF (LIW.LT.6) THEN
-         INFO(4) = 3*N + 3
+         INFO(4) = N + 1
          GO TO 40
       END IF
-      NEW = 1
-      VARS = NEW + LIW/3
-      FLAG = VARS + LIW/3
-      CALL CMUMPS_SUPVARB(N,NELT,ELTPTR,NZ,ELTVAR,SVAR,NSUP,LIW/3-1,
+      NEW = 1_8
+      VARS = NEW + LIW/3_8
+      FLAG = VARS + LIW/3_8
+      CALL CMUMPS_SUPVARB(N,NELT,ELTPTR,NZ,ELTVAR,SVAR,NSUP,
+     &           int(min(int(huge(NSUP)-1,8),LIW/3_8-1_8)),
      &           IW(NEW),IW(VARS),IW(FLAG),INFO)
       IF (INFO(1).EQ.-4) THEN
-         INFO(4) = 3*N + 3
+         INFO(4) = N + 1
          GO TO 40
       ELSE
-         INFO(4) = 3*NSUP + 3
+         INFO(4) = NSUP + 1
       END IF
       GO TO 50
    10 INFO(1) = -1
@@ -1090,12 +1130,12 @@ C
    40 INFO(1) = -4
       IF (LP.GT.0) THEN
          WRITE (LP,FMT=9000) INFO(1)
-         WRITE (LP,FMT=9010) INFO(4)
+         WRITE (LP,FMT=9010) 3_8*int(INFO(4),8)
       END IF
    50 RETURN
  9000 FORMAT (/3X,'Error message from CMUMPS_SUPVAR: INFO(1) = ',I2)
  9010 FORMAT (3X,'LIW is insufficient. Upper bound on required work',
-     &       'space is ',I8)
+     &       'space is ',I12)
       END SUBROUTINE CMUMPS_SUPVAR
       SUBROUTINE CMUMPS_SUPVARB( N, NELT, ELTPTR, NZ, ELTVAR,
      &           SVAR, NSUP, MAXSUP, NEW, VARS, FLAG, INFO )
diff -pruN 5.6.2-2.1/src/cana_aux_par.F 5.7.1-1/src/cana_aux_par.F
--- 5.6.2-2.1/src/cana_aux_par.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/cana_aux_par.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -53,19 +53,25 @@ C
       LOGICAL    :: PROK, PROKG, LPOK
       INTEGER N, NORIG
       CONTAINS
-      SUBROUTINE CMUMPS_ANA_F_PAR(id, WORK1, WORK2, NFSIZ, FILS,
+      SUBROUTINE CMUMPS_ANA_F_PAR(id, WORK1, WORK2, LWORK1, LWORK2,
+     &     NFSIZ, FILS,
      &     FRERE, COMM_PARASYMB, LUMAT, SIZEOFBLOCKS, 
      &     COMM_PARAORD, NPROCS_PARAORD, 
      &     RKinSYMB_PROC0ORD)
       USE CMUMPS_STRUC_DEF
       IMPLICIT NONE
       TYPE(CMUMPS_STRUC)   :: id
-      INTEGER, TARGET     :: WORK1(:), WORK2(:)
-      INTEGER, ALLOCATABLE :: FILS(:)
-      INTEGER, POINTER    :: NFSIZ(:), FRERE(:)
-      INTEGER, INTENT(IN) :: COMM_PARASYMB
+      INTEGER, TARGET        :: WORK1(:), WORK2(:)
+      INTEGER(8), INTENT(IN) :: LWORK1, LWORK2
+#if defined(MUMPS_NOF2003)
+      INTEGER, POINTER       :: FILS(:)
+#else
+      INTEGER, ALLOCATABLE   :: FILS(:)
+#endif
+      INTEGER, POINTER       :: NFSIZ(:), FRERE(:)
+      INTEGER, INTENT(IN)    :: COMM_PARASYMB
       TYPE(LMATRIX_T), OPTIONAL       :: LUMAT
-      INTEGER, INTENT(IN), OPTIONAL   :: SIZEOFBLOCKS(id%NBLK)
+      INTEGER, INTENT(IN), TARGET, OPTIONAL   :: SIZEOFBLOCKS(id%NBLK)
       INTEGER, INTENT(IN), OPTIONAL   :: COMM_PARAORD, 
      &                                   NPROCS_PARAORD, 
      &                                   RKinSYMB_PROC0ORD
@@ -78,9 +84,13 @@ C
       INTEGER              :: MYID, NPROCS, IERR, NEMIN, LDIAG
       LOGICAL              :: SPLITROOT
       INTEGER(8), PARAMETER :: K79REF=12000000_8
-      INTEGER, PARAMETER :: LIDUMMY = 1
-      INTEGER :: IDUMMY(1) 
       DOUBLE PRECISION      :: TIMEB
+      INTEGER HOW_TO_SPLIT_ROOT, INODE_Scalapack_CAND, 
+     &        NBSONS_Scalapack_CAND
+      INTEGER, POINTER, DIMENSION(:) :: SIZEOFBLOCKS_PTR
+      INTEGER, TARGET    :: IDUMMY_ARRAY(1)
+      INTEGER            :: LSIZEOFBLOCKS_PTR
+      LOGICAL            :: SIZEOFBLOCKS_AVAIL
       nullify(IPE, NV, NE, NA, NODE, ND, SUBORD, NAMALG, IPS,
      &     CUMUL, SAVEIRN, SAVEJCN)
       CALL MPI_COMM_RANK (COMM_PARASYMB, MYID, IERR)
@@ -99,6 +109,16 @@ C
       PROKG = (MPG.GT.0) .AND. (MYID .EQ. 0)
       LPOK  = (LP.GT.0) .AND. (id%ICNTL(4).GE.1)
       LDIAG = id%ICNTL(4)
+      IF (present(SIZEOFBLOCKS)) THEN
+       SIZEOFBLOCKS_PTR => SIZEOFBLOCKS(1:N)
+       LSIZEOFBLOCKS_PTR = N
+       SIZEOFBLOCKS_AVAIL = .TRUE.
+      ELSE
+       SIZEOFBLOCKS_PTR => IDUMMY_ARRAY
+       SIZEOFBLOCKS_AVAIL = .FALSE.
+       LSIZEOFBLOCKS_PTR = 1
+       IDUMMY_ARRAY(1) = -1
+      ENDIF
       IF (PROKG) THEN
          WRITE(MPG,'(A,I10)') 
      &   " Parallel analysis, processing a graph of size:", N
@@ -121,12 +141,17 @@ C
       CALL CMUMPS_SET_PAR_ORD(id, COMM_PARASYMB, MYID, NPROCS, 
      &     ord, COMM_PARAORD, NPROCS_PARAORD,
      &     RKinSYMB_PROC0ORD)
-      IF (ord%COMM.NE.MPI_COMM_NULL) THEN
-       ord%PERMTAB => WORK1(1        : N)
-       ord%PERITAB => WORK1(N+1   : 2*N)
-       ord%TREETAB => WORK1(2*N+1 : 3*N)
+      IF ( LWORK1 .LT. 3_8 *int(N,8) ) THEN
+         WRITE(LP,*)
+     &      'Insufficient workspace in CMUMPS_ANA_F_PAR' 
+         CALL MUMPS_ABORT()
       ENDIF
-      IF(id%KEEP(54) .NE. 3) THEN
+      IF ( ord%COMM .NE. MPI_COMM_NULL ) THEN
+        ord%PERMTAB => WORK1(         1       : N)
+        ord%PERITAB => WORK1(    int(N,8)+1_8 : 2_8*int(N,8))
+        ord%TREETAB => WORK1(2_8*int(N,8)+1_8 : 3_8*int(N,8))
+      ENDIF
+      IF ( id%KEEP(54) .NE. 3 ) THEN
          IF(MYID.EQ.0) THEN
             SAVEIRN    => id%IRN_loc
             SAVEJCN    => id%JCN_loc
@@ -143,10 +168,10 @@ C
       IF (PROKG) CALL MUMPS_SECDEB( TIMEB )
       IF (id%KEEP(339).GT.0) THEN
         CALL CMUMPS_DO_PAR_ORD(id, MYID, NPROCS, 
-     &                       ord, WORK2, LUMAT, SIZEOFBLOCKS)
+     &       ord, WORK2, LWORK2, LUMAT, SIZEOFBLOCKS)
       ELSE
         CALL CMUMPS_DO_PAR_ORD(id, MYID, NPROCS, 
-     &                       ord, WORK2)
+     &       ord, WORK2, LWORK2)
       ENDIF
       IF (PROKG) THEN
        CALL MUMPS_SECFIN( TIMEB )
@@ -167,11 +192,12 @@ C
       END IF
       ord%SUBSTRAT = 0
       ord%TOPSTRAT = 0
-      IF (id%KEEP(339).GT.1) THEN
-        CALL CMUMPS_PARSYMFACT_LUMAT(id, ord, IPE, NV, WORK2, LUMAT,
+      IF (id%KEEP(339).NE.0) THEN
+        CALL CMUMPS_PARSYMFACT_LUMAT(id, ord, IPE, NV,
+     &                               WORK2, LWORK2, LUMAT,
      &                               SIZEOFBLOCKS)
       ELSE
-        CALL CMUMPS_PARSYMFACT(id, ord, IPE, NV, WORK2)
+        CALL CMUMPS_PARSYMFACT(id, ord, IPE, NV, WORK2, LWORK2)
       ENDIF
       IF(id%KEEP(54) .NE. 3) THEN
          IF(ord%MYID.EQ.0) THEN
@@ -188,32 +214,25 @@ C
       CALL MUMPS_IDEALLOC(ord%FIRST, ord%LAST, MEMCNT=MEMCNT)
       IF (MYID .EQ. 0) THEN
          IPS => WORK1(1:N)
-         NE     => WORK1(N+1   : 2*N)
-         NA     => WORK1(2*N+1 : 3*N)
-         NODE   => WORK2(1        : N  )
-         ND     => WORK2(N+1   : 2*N)
-         SUBORD => WORK2(2*N+1 : 3*N)
-         NAMALG => WORK2(3*N+1 : 4*N)
+         NE     => WORK1(    int(N,8)+1_8 : 2_8*int(N,8))
+         NA     => WORK1(2_8*int(N,8)+1_8 : 3_8*int(N,8))
+         NODE   => WORK2(             1   : N  )
+         ND     => WORK2(    int(N,8)+1_8 : 2_8*int(N,8))
+         SUBORD => WORK2(2_8*int(N,8)+1_8 : 3_8*int(N,8))
+         NAMALG => WORK2(3_8*int(N,8)+1_8 : 4_8*int(N,8))
          CALL MUMPS_REALLOC(CUMUL, N, id%INFO, LP,
      &        STRING='CUMUL', MEMCNT=MEMCNT, ERRCODE=-7)
          IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
          NEMIN  = id%KEEP(1)
-         IF (N.LT.NORIG) THEN
-          CALL CMUMPS_ANA_LNEW(N, IPE(1), NV(1), IPS(1), NE(1),
-     &        NA(1), NFSIZ(1), NODE(1), id%INFOG(6), FILS(1), FRERE(1),
-     &        ND(1), NEMIN, SUBORD(1), id%KEEP(60), id%KEEP(20),
-     &        id%KEEP(38), NAMALG(1), id%KEEP(104), CUMUL(1),
-     &        id%KEEP(50), id%ICNTL(13), id%KEEP(37), id%KEEP(197),
-     &        id%NSLAVES, id%KEEP(250).EQ.1, .TRUE., 
-     &        SIZEOFBLOCKS, N)
-         ELSE
-          CALL CMUMPS_ANA_LNEW(N, IPE(1), NV(1), IPS(1), NE(1),
-     &        NA(1), NFSIZ(1), NODE(1), id%INFOG(6), FILS(1), FRERE(1),
-     &        ND(1), NEMIN, SUBORD(1), id%KEEP(60), id%KEEP(20),
-     &        id%KEEP(38), NAMALG(1), id%KEEP(104), CUMUL(1),
-     &        id%KEEP(50), id%ICNTL(13), id%KEEP(37), id%KEEP(197),
-     &        id%NSLAVES, id%KEEP(250).EQ.1, .FALSE., IDUMMY, LIDUMMY)
-         ENDIF
+         CALL CMUMPS_ANA_LNEW(N, IPE(1), NV(1), IPS(1), NE(1),
+     &       NA(1), NFSIZ(1), NODE(1), id%INFOG(6), FILS(1), FRERE(1),
+     &       ND(1), NEMIN, SUBORD(1), id%KEEP(60), id%KEEP(20),
+     &       id%KEEP(38), NAMALG(1), id%KEEP(104), CUMUL(1),
+     &       id%KEEP(50), id%ICNTL(13), id%KEEP(37), id%KEEP(197),
+     &       id%NSLAVES, id%KEEP(250).EQ.1, SIZEOFBLOCKS_AVAIL, 
+     &       SIZEOFBLOCKS_PTR(1), LSIZEOFBLOCKS_PTR,
+     &       INODE_Scalapack_CAND, NBSONS_Scalapack_CAND, 
+     &       id%KEEP(11))
          CALL MUMPS_DEALLOC(CUMUL, NV, IPE, MEMCNT=MEMCNT)
          CALL CMUMPS_ANA_M(NE(1), ND(1), id%INFOG(6), id%INFOG(5),
      &        id%KEEP(2), id%KEEP(50), id%KEEP8(101), id%KEEP(108),
@@ -221,6 +240,8 @@ C
          IF ( id%KEEP(53) .NE. 0 ) THEN
             CALL MUMPS_MAKE1ROOT(N, FRERE(1), FILS(1), NFSIZ(1),
      &           id%KEEP(20))
+            INODE_Scalapack_CAND  = id%KEEP(20)
+            NBSONS_Scalapack_CAND = 1
          END IF
          IF (  (id%KEEP(48) == 4 .AND. id%KEEP8(21).GT.0_8)
      &        .OR.
@@ -230,56 +251,84 @@ C
             CALL CMUMPS_SET_K821_SURFACE(id%KEEP8(21), id%KEEP(2),
      &           id%KEEP(48), id%KEEP(50), id%NSLAVES)
          END IF
-      IF (id%KEEP(210).LT.1.OR.id%KEEP(210).GT.2) id%KEEP(210)=2
-      IF (id%KEEP(210).EQ.2) id%KEEP8(79)=huge(id%KEEP8(79))
-      IF (id%KEEP(210).EQ.1.AND.id%KEEP8(79).LE.0_8) THEN
-       id%KEEP8(79)=K79REF * int(id%NSLAVES,8)
-      ENDIF
-         IF ( (id%KEEP(79).EQ.0).OR.(id%KEEP(79).EQ.2).OR.
-     &        (id%KEEP(79).EQ.3).OR.(id%KEEP(79).EQ.5).OR.
-     &        (id%KEEP(79).EQ.6)
-     &   )  THEN
-          IF (id%KEEP(210).EQ.1) THEN
+         IF (id%KEEP(210).LT.1.OR.id%KEEP(210).GT.2) id%KEEP(210)=2
+         IF (id%KEEP(210).EQ.2) id%KEEP8(79)=huge(id%KEEP8(79))
+         IF (id%KEEP(210).EQ.1.AND.id%KEEP8(79).LE.0_8) THEN
+          id%KEEP8(79)=K79REF * int(id%NSLAVES,8)
+         ENDIF
+         IF (id%KEEP(11).EQ.0) THEN
+          IF ( (id%KEEP(79).EQ.0).OR.(id%KEEP(79).EQ.2).OR.
+     &         (id%KEEP(79).EQ.3).OR.(id%KEEP(79).EQ.5).OR.
+     &         (id%KEEP(79).EQ.6)
+     &    )  THEN
+           IF (id%KEEP(210).EQ.1) THEN
             SPLITROOT = .FALSE. 
             IF ( id%KEEP(62).GE.1) THEN
-               IDUMMY(1) = -1
                CALL CMUMPS_CUTNODES(N, FRERE(1), FILS(1),
-     &              NFSIZ(1), IDUMMY, LIDUMMY, id%INFOG(6),
-     &              id%NSLAVES, id%KEEP(1), id%KEEP8(1), SPLITROOT,
-     &              MP, LDIAG, id%INFOG(1), id%INFOG(2))
+     &           NFSIZ(1), 
+     &           SIZEOFBLOCKS_PTR(1), LSIZEOFBLOCKS_PTR, id%INFOG(6), 
+     &           id%NSLAVES, id%KEEP(1), id%KEEP8(1), SPLITROOT,
+     &           MP, LDIAG, id%INFOG(1), id%INFOG(2))
                IF (id%INFOG(1).LT.0) RETURN
             ENDIF
+           ENDIF
           ENDIF
          ENDIF
-      SPLITROOT = id%ICNTL(13) .EQ. -1
+         HOW_TO_SPLIT_ROOT = 0 
+         SPLITROOT = id%ICNTL(13) .EQ. -1
 #if defined(NOSCALAPACK)
-      SPLITROOT = SPLITROOT .OR. id%NSLAVES.GT.0
+         SPLITROOT = SPLITROOT .OR. id%NSLAVES.GT.0
 #else
-      SPLITROOT = SPLITROOT .OR.
+         SPLITROOT = SPLITROOT .OR.
      &            (id%ICNTL(13).GT.0 .AND. id%NSLAVES.GT.id%ICNTL(13))
 #endif
-      IF (id%KEEP(53) .NE. 0) THEN
-         SPLITROOT = .TRUE.
-      ENDIF
+         IF (SPLITROOT.AND.id%KEEP(11).GT.0) HOW_TO_SPLIT_ROOT =1 
+         IF (id%KEEP(53) .NE. 0) THEN
+           SPLITROOT = .TRUE.
+           IF (id%KEEP(11).GT.0) HOW_TO_SPLIT_ROOT = 2
+         ENDIF
+#if defined(NOSCALAPACK)
+#else
+         IF ( id%KEEP(11).GT.0 .AND. (id%KEEP(339).NE.0) ) THEN 
+           IF (.NOT.SPLITROOT .AND. 
+     &       (id%KEEP(60).EQ.0).AND.   
+     &       ( (NFSIZ(INODE_Scalapack_CAND).GT.id%KEEP(37))
+     &        .AND.(id%ICNTL(13).LE.0) )
+     &       .AND.
+     &       (NBSONS_Scalapack_CAND.GT.id%KEEP(11)) 
+     &       ) THEN
+             HOW_TO_SPLIT_ROOT = 3
+             SPLITROOT=.TRUE.
+           ENDIF
+         ENDIF
+#endif
          SPLITROOT = (SPLITROOT.AND.( (id%KEEP(60).EQ.0) ))
          IF (SPLITROOT) THEN
            IF (id%KEEP(339).EQ.0) THEN
-            IDUMMY(1) = -1
             CALL CMUMPS_CUTNODES(N, FRERE(1), FILS(1), NFSIZ(1),
-     &           IDUMMY, LIDUMMY, id%INFOG(6), 
+     &           SIZEOFBLOCKS_PTR(1), LSIZEOFBLOCKS_PTR, id%INFOG(6), 
      &           id%NSLAVES, id%KEEP(1), id%KEEP8(1),
      &           SPLITROOT, MP, LDIAG, id%INFOG(1), id%INFOG(2))
            ELSE
-            CALL CMUMPS_CUTNODES(N, FRERE(1), FILS(1), NFSIZ(1),
-     &           SIZEOFBLOCKS, id%NBLK, id%INFOG(6), 
+            IF (id%KEEP(11).EQ.0) THEN
+              CALL CMUMPS_CUTNODES(N, FRERE(1), FILS(1), NFSIZ(1),
+     &           SIZEOFBLOCKS_PTR(1), LSIZEOFBLOCKS_PTR, id%INFOG(6), 
      &           id%NSLAVES, id%KEEP(1), id%KEEP8(1),
      &           SPLITROOT, MP, LDIAG, id%INFOG(1), id%INFOG(2))
-           ENDIF
-            IF (id%INFOG(1).LT.0) RETURN
-            IF ( id%KEEP(53) .NE. 0 ) THEN
-              CALL MUMPS_MAKE1ROOT(N, FRERE(1), FILS(1), NFSIZ(1),
-     &           id%KEEP(20))
+              IF (id%INFOG(1).LT.0) RETURN
+              IF ( id%KEEP(53) .NE. 0 ) THEN
+                CALL MUMPS_MAKE1ROOT(N, FRERE(1), FILS(1), NFSIZ(1),
+     &             id%KEEP(20))
+              END IF
+            ELSE
+              CALL CMUMPS_SPLIT_ROOT( id%NSLAVES,
+     &                    HOW_TO_SPLIT_ROOT, INODE_Scalapack_CAND,
+     &                    N, FRERE(1), FILS(1), NFSIZ(1), 
+     &                    id%KEEP(1), id%KEEP8(1),
+     &                    SIZEOFBLOCKS_PTR(1), LSIZEOFBLOCKS_PTR,
+     &                    id%INFOG(6))
             END IF
+           END IF
          ENDIF
       END IF
       RETURN
@@ -415,13 +464,15 @@ C
        END IF
       ENDIF
       END SUBROUTINE CMUMPS_SET_PAR_ORD
-      SUBROUTINE CMUMPS_DO_PAR_ORD(id, MYID, NPROCS, ord, WORK, LUMAT, 
+      SUBROUTINE CMUMPS_DO_PAR_ORD(id, MYID, NPROCS, ord,
+     &                             WORK, LWORK, LUMAT, 
      &                             SIZEOFBLOCKS)
       IMPLICIT NONE
       TYPE(CMUMPS_STRUC)       :: id
       INTEGER, INTENT(IN)      :: MYID, NPROCS
       TYPE(ORD_TYPE)           :: ord
       INTEGER                  :: WORK(:)
+      INTEGER(8), INTENT(IN)   :: LWORK
       TYPE(LMATRIX_T), OPTIONAL       :: LUMAT
       INTEGER, INTENT(IN), OPTIONAL   :: SIZEOFBLOCKS(N)
 #if defined(parmetis) || defined(parmetis3)
@@ -440,10 +491,11 @@ C
       IF (ord%ORDTOOL .EQ. 1) THEN
 #if defined(ptscotch)
         IF (id%KEEP(339).NE.0) THEN
-         CALL CMUMPS_PTSCOTCH_ORD(id, ord, WORK, GCOMP_DIST,
+         CALL CMUMPS_PTSCOTCH_ORD(id, ord, WORK, LWORK,
+     &                     GCOMP_DIST,
      &                     SIZEOFBLOCKS )
         ELSE
-         CALL CMUMPS_PTSCOTCH_ORD(id, ord, WORK)
+         CALL CMUMPS_PTSCOTCH_ORD(id, ord, WORK, LWORK)
         ENDIF
 #else
          id%INFOG(1) = -38
@@ -454,10 +506,11 @@ C
       ELSE IF (ord%ORDTOOL .EQ. 2) THEN
 #if defined(parmetis) || defined(parmetis3)
          IF (id%KEEP(339).GT.0) THEN
-         CALL CMUMPS_PARMETIS_ORD_LUMAT (id, ord, WORK, GCOMP_DIST,
+         CALL CMUMPS_PARMETIS_ORD_LUMAT (id, ord, WORK, LWORK,
+     &                            GCOMP_DIST,
      &                            SIZEOFBLOCKS)
          ELSE
-           CALL CMUMPS_PARMETIS_ORD(id, ord, WORK)
+           CALL CMUMPS_PARMETIS_ORD(id, ord, WORK, LWORK)
          ENDIF
          IF (id%KEEP(339).EQ.0) THEN
           if(ord%IDO) CALL MPI_COMM_FREE(ord%COMM_PARAORD, IERR)
@@ -475,14 +528,14 @@ C
       RETURN
       END SUBROUTINE CMUMPS_DO_PAR_ORD
 #if defined(parmetis) || defined(parmetis3)
-      SUBROUTINE CMUMPS_PARMETIS_ORD(id, ord, WORK) 
+      SUBROUTINE CMUMPS_PARMETIS_ORD(id, ord, WORK, LWORK) 
       IMPLICIT NONE
-      TYPE(CMUMPS_STRUC)  :: id
-      TYPE(ORD_TYPE)      :: ord
-      INTEGER, TARGET    :: WORK(:)
+      TYPE(CMUMPS_STRUC)      :: id
+      TYPE(ORD_TYPE)          :: ord
+      INTEGER, TARGET         :: WORK(:)
+      INTEGER(8), INTENT (IN) :: LWORK
       INTEGER             :: I, MYID, NPROCS, IERR, BASE, METIS_IDX_SIZE
-      INTEGER, POINTER    :: FIRST(:),
-     &     LAST(:), SWORK(:)
+      INTEGER, POINTER    :: FIRST(:), LAST(:), SWORK(:)
       INTEGER             :: BASEVAL, VERTLOCNBR,
      &     OPTIONS(10)
       INTEGER(8), POINTER :: VERTLOCTAB(:)
@@ -497,7 +550,7 @@ C
       NPROCS          = ord%NPROCS
       IERR            = 0
       SIZE_IDUMMY_PTR = 0
-      IF(size(WORK) .LT. N*3 .OR.size(WORK).LT.NPROCS+1) THEN
+      IF( LWORK.LT. int(N,8)*3_8 .OR. LWORK .LT. int(NPROCS+1,8)) THEN
          WRITE(LP,
      &        '("Insufficient workspace inside CMUMPS_PARMETIS_ORD")')
          CALL MUMPS_ABORT()
@@ -510,14 +563,15 @@ C
       IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
       BASE    = id%NPROCS-id%NSLAVES
       CALL CMUMPS_GRAPH_DIST(id, ord, FIRST,
-     &     LAST, BASE, NPROCS, WORK(1: 2*N), TYPE=2)
+     &     LAST, BASE, NPROCS, WORK(1_8: 2_8*int(N,8)),
+     &     2_8*int(N,8), TYPE=2)
       VERTLOCNBR = LAST(MYID+1)-FIRST(MYID+1) + 1
       CALL MUMPS_I8REALLOC(VERTLOCTAB, VERTLOCNBR+1, id%INFO,
      &        LP, STRING='VERTLOCTAB', MEMCNT=MEMCNT, ERRCODE=-7)
       IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
-      SWORK => WORK(N+1:3*N)
+      SWORK => WORK(int(N+1,8):3_8*int(N,8))
       CALL CMUMPS_BUILD_DIST_GRAPH(id, ord, FIRST, LAST, VERTLOCTAB,
-     &     EDGELOCTAB, SWORK)
+     &     EDGELOCTAB, SWORK, 2_8 * int(N,8))
       CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &     ord%COMM, ord%MYID )
       IF(id%INFO(1).LT.0) GOTO 20
@@ -608,19 +662,20 @@ C
       CALL MUMPS_DEALLOC(ord%RANGTAB, MEMCNT=MEMCNT)
       RETURN
       END SUBROUTINE CMUMPS_PARMETIS_ORD
-      SUBROUTINE CMUMPS_PARMETIS_ORD_LUMAT (id, ord, WORK, GCOMP_DIST,
+      SUBROUTINE CMUMPS_PARMETIS_ORD_LUMAT (id, ord, WORK, LWORK,
+     &                              GCOMP_DIST,
      &                              SIZEOFBLOCKS )
       IMPLICIT NONE
-      TYPE(CMUMPS_STRUC)  :: id
-      TYPE(ORD_TYPE)      :: ord
-      INTEGER, TARGET    :: WORK(:)
+      TYPE(CMUMPS_STRUC)     :: id
+      TYPE(ORD_TYPE)         :: ord
+      INTEGER, TARGET        :: WORK(:)
+      INTEGER(8), INTENT(IN) :: LWORK
       TYPE(COMPACT_GRAPH_T), OPTIONAL       :: GCOMP_DIST
       INTEGER, INTENT(IN), OPTIONAL, TARGET :: SIZEOFBLOCKS(N)
       INTEGER             :: I, MYID, NPROCS, IERR, BASE, METIS_IDX_SIZE
       INTEGER             :: MASTER
       PARAMETER     (MASTER=0)
-      INTEGER, POINTER    :: FIRST(:),
-     &     LAST(:), SWORK(:)
+      INTEGER, POINTER    :: FIRST(:), LAST(:), SWORK(:)
       INTEGER             :: BASEVAL, VERTLOCNBR,
      &     OPTIONS(10)
       INTEGER(8), POINTER :: VERTLOCTAB(:)
@@ -637,7 +692,7 @@ C
       NPROCS          = ord%NPROCS
       IERR            = 0
       SIZE_VELOLOCTAB = 0
-      IF(size(WORK) .LT. N*3 .OR.size(WORK).LT.NPROCS+1) THEN
+      IF( LWORK.LT. int(N,8)*3_8 .OR. LWORK .LT. int(NPROCS+1,8)) THEN
          WRITE(LP,
      &        '("Insufficient workspace inside CMUMPS_PARMETIS_ORD")')
          CALL MUMPS_ABORT()
@@ -661,7 +716,7 @@ C
          EDGELOCNBR = GCOMP_DIST%NZG
          VERTLOCTAB => GCOMP_DIST%IPE
          EDGELOCTAB => GCOMP_DIST%ADJ
-         IF (id%KEEP(339).GE.6) THEN
+         IF (id%KEEP(339).NE.0) THEN
           VELOLOCTAB=>SIZEOFBLOCKS(GCOMP_DIST%FIRST:GCOMP_DIST%LAST)
           SIZE_VELOLOCTAB = VERTLOCNBR
          ENDIF
@@ -788,14 +843,14 @@ C
       END SUBROUTINE CMUMPS_PARMETIS_ORD_LUMAT
 #endif
 #if defined(ptscotch)
-      SUBROUTINE CMUMPS_PTSCOTCH_ORD(id, ord, WORK, GCOMP_DIST,
+      SUBROUTINE CMUMPS_PTSCOTCH_ORD(id, ord, WORK, LWORK, GCOMP_DIST,
      &                               SIZEOFBLOCKS)
 !$    USE OMP_LIB
       IMPLICIT NONE
-      INCLUDE 'ptscotchf.h'
       TYPE(CMUMPS_STRUC)                :: id
       TYPE(ORD_TYPE)                    :: ord
       INTEGER, TARGET                   :: WORK(:)
+      INTEGER(8), INTENT(IN)            :: LWORK
       TYPE(COMPACT_GRAPH_T), OPTIONAL   :: GCOMP_DIST
       INTEGER, INTENT(IN), OPTIONAL, TARGET:: SIZEOFBLOCKS(N)
       INTEGER                       :: MYID, NPROCS, IERR
@@ -809,7 +864,14 @@ C
       INTEGER, POINTER              :: VELOLOCTAB(:)
       INTEGER                       :: SIZE_VELOLOCTAB
       INTEGER, TARGET               :: IDUMMY(1)
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+      INCLUDE 'scotchf.h' 
+      INTEGER          :: IOMP, NOMP
+      DOUBLE PRECISION :: CONTDAT(SCOTCH_CONTEXTDIM)
+      INTEGER(4)       :: IERR_SCOTCH
+#else
       INTEGER :: PTHREAD_NUMBER, NOMP
+#endif
       nullify(FIRST, LAST, SWORK, VERTLOCTAB, EDGELOCTAB)
       VELOLOCTAB => IDUMMY 
       CALL MPI_BARRIER(ord%COMM, IERR)
@@ -822,12 +884,12 @@ C
         EDGELOCNBR = GCOMP_DIST%NZG
         VERTLOCTAB => GCOMP_DIST%IPE
         EDGELOCTAB => GCOMP_DIST%ADJ
-        IF (id%KEEP(339).GE.6) THEN
+        IF (id%KEEP(339).NE.0) THEN
          VELOLOCTAB => SIZEOFBLOCKS(GCOMP_DIST%FIRST:GCOMP_DIST%LAST)
          SIZE_VELOLOCTAB = VERTLOCNBR
         ENDIF
       ELSE
-        IF (size(WORK) .LT. N*3) THEN
+        IF (LWORK .LT. int(N,8)*3_8) THEN
             WRITE(LP,
      &      '("Insufficient workspace inside CMUMPS_PTSCOTCH_ORD")')
             CALL MUMPS_ABORT()
@@ -839,14 +901,15 @@ C
      &     MEMCNT=MEMCNT, ERRCODE=-7)
         IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
         CALL CMUMPS_GRAPH_DIST(id, ord, FIRST,
-     &     LAST, BASE, NPROCS, WORK(1: 2*N), TYPE=2)
+     &     LAST, BASE, NPROCS, WORK(1: 2_8*int(N,8)),
+     &     2_8*int(N,8), TYPE=2)
         VERTLOCNBR = LAST(MYID+1)-FIRST(MYID+1) + 1
         CALL MUMPS_I8REALLOC(VERTLOCTAB, VERTLOCNBR+1, id%INFO,
      &        LP, STRING='VERTLOCTAB', MEMCNT=MEMCNT, ERRCODE=-7)
         IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
-        SWORK => WORK(N+1:3*N)
+        SWORK => WORK(int(N+1,8):3_8*int(N,8))
         CALL CMUMPS_BUILD_DIST_GRAPH(id, ord, FIRST, LAST, VERTLOCTAB,
-     &     EDGELOCTAB, SWORK)
+     &     EDGELOCTAB, SWORK, 2_8*int(N,8))
         CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &     ord%COMM, ord%MYID )
         IF ( id%INFO(1) .LT. 0 ) GOTO 11
@@ -863,35 +926,65 @@ C
       IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
       IF(ord%IDO) THEN
          CALL MUMPS_SCOTCH_INTSIZE(SCOTCH_INT_SIZE)
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+!$OMP PARALLEL PRIVATE(IOMP, IERR_SCOTCH)
+!$OMP SINGLE
+         NOMP=omp_get_num_threads()
+!$OMP END SINGLE
+         IOMP=omp_get_thread_num()
+         IF (IOMP.EQ.0) THEN
+           CALL SCOTCHFCONTEXTINIT(CONTDAT, IERR_SCOTCH)
+           CALL SCOTCHFCONTEXTRANDOMCLONE(CONTDAT, IERR_SCOTCH)
+           CALL SCOTCHFCONTEXTTHREADIMPORT1(CONTDAT, NOMP, IERR_SCOTCH)
+         ENDIF
+!$OMP BARRIER
+         CALL SCOTCHFCONTEXTTHREADIMPORT2(CONTDAT, IOMP, IERR_SCOTCH)
+#else
          NOMP=0
 !$       NOMP=omp_get_max_threads()
          IF (NOMP .GT. 0) THEN
            CALL MUMPS_SCOTCH_GET_PTHREAD_NUMBER (PTHREAD_NUMBER)
            CALL MUMPS_SCOTCH_SET_PTHREAD_NUMBER (NOMP)
          ENDIF
-         IF(SCOTCH_INT_SIZE.EQ.32) THEN
-           IF (id%KEEP(10).EQ.1) THEN
-            id%INFO(1) = -52
-            id%INFO(2) = 2
+#endif
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+         IF (IOMP.EQ.0) THEN
+#endif
+           IF(SCOTCH_INT_SIZE.EQ.32) THEN
+             IF (id%KEEP(10).EQ.1) THEN
+              id%INFO(1) = -52
+              id%INFO(2) = 2
+             ELSE
+              CALL MUMPS_PTSCOTCH_MIXEDto32(id, ord,
+     &             BASEVAL, 
+     &             VERTLOCNBR, VERTLOCTAB,
+     &             EDGELOCNBR, EDGELOCTAB,
+     &             VELOLOCTAB, SIZE_VELOLOCTAB,
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+     &             CONTDAT, SCOTCH_CONTEXTDIM,
+#endif
+     &             IERR)
+            ENDIF
            ELSE
-            CALL MUMPS_PTSCOTCH_MIXEDto32(id, ord,
-     &           BASEVAL, 
-     &           VERTLOCNBR, VERTLOCTAB,
-     &           EDGELOCNBR, EDGELOCTAB,
-     &           VELOLOCTAB, SIZE_VELOLOCTAB,
-     &           IERR)
-          ENDIF
-         ELSE
-            CALL MUMPS_PTSCOTCH_MIXEDto64(id, ord,
-     &           BASEVAL, 
-     &           VERTLOCNBR, VERTLOCTAB,
-     &           EDGELOCNBR, EDGELOCTAB,
-     &           VELOLOCTAB, SIZE_VELOLOCTAB,
-     &           IERR)
-         END IF
+              CALL MUMPS_PTSCOTCH_MIXEDto64(id, ord,
+     &             BASEVAL, 
+     &             VERTLOCNBR, VERTLOCTAB,
+     &             EDGELOCNBR, EDGELOCTAB,
+     &             VELOLOCTAB, SIZE_VELOLOCTAB,
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+     &             CONTDAT, SCOTCH_CONTEXTDIM,
+#endif
+     &             IERR)
+           END IF
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+           CALL SCOTCHFCONTEXTEXIT(CONTDAT)
+         ENDIF 
+!$OMP END PARALLEL
+#else
          IF (NOMP .GT. 0) THEN
            CALL MUMPS_SCOTCH_SET_PTHREAD_NUMBER (PTHREAD_NUMBER)
          ENDIF
+#endif
       END IF
       IF(IERR.NE.0) THEN
          id%INFO(1:2) = -50
@@ -996,7 +1089,7 @@ C
       HOSTMEM = 12*N 
       NZ4=int(id%KEEP8(28))
       NZ_ROW = 2*(NZ4/N) 
-      IF (id%KEEP(339).GT.2) THEN
+      IF (id%KEEP(339).NE.0) THEN
          NRL = 0
       ELSE
         IF(id%KEEP(46) .EQ. 0) THEN
@@ -1152,7 +1245,7 @@ C
       CALL CMUMPS_MERGESORT(ANODE, AWEIGHTS(1:ANODE), WORK(0:ANODE+1))
       CALL CMUMPS_MERGESWAP(ANODE, WORK(0:ANODE+1), AWEIGHTS(1:ANODE), 
      &     ALIST(1:ANODE))
-      IF (id%KEEP(339).GE.4) THEN
+      IF (id%KEEP(339).NE.0) THEN
        Iprocdeb = ord%NPROCS-ANODE+1
        IF (Iprocdeb.GT.1) THEN
          DO I=1, Iprocdeb-1
@@ -1216,28 +1309,26 @@ C
  90   continue
       RETURN
       END SUBROUTINE CMUMPS_GET_SUBTREES
-      SUBROUTINE CMUMPS_PARSYMFACT(id, ord, GPE, GNV, WORK)  
+      SUBROUTINE CMUMPS_PARSYMFACT(id, ord, GPE, GNV, WORK, LWORK)  
       IMPLICIT NONE
-      TYPE(CMUMPS_STRUC)   :: id
-      TYPE(ORD_TYPE)       :: ord
-      INTEGER, POINTER     :: GPE(:), GNV(:)
-      INTEGER, TARGET      :: WORK(:)
-      TYPE(GRAPH_TYPE)     :: top_graph
-      INTEGER(8), POINTER  :: IPE(:), IPET(:),
-     &     BUF_PE1(:), BUF_PE2(:), TMP1(:)
-      INTEGER, POINTER     :: PE(:),
-     &     LENG(:), I_HALO_MAP(:)
-      INTEGER, POINTER     :: NDENSE(:), LAST(:),
-     &     DEGREE(:), W(:), PERM(:),
-     &     LISTVAR_SCHUR(:), NEXT(:),
-     &     HEAD(:), NV(:), ELEN(:),
-     &     LSTVAR(:)
-      INTEGER, POINTER     :: MYLIST(:),
-     &     LPERM(:),
-     &     LIPERM(:),
-     &     NVT(:), BUF_NV1(:),
-     &     BUF_NV2(:), ROOTPERM(:),
-     &     TMP2(:), BWORK(:), NCLIQUES(:)
+      TYPE(CMUMPS_STRUC)     :: id
+      TYPE(ORD_TYPE)         :: ord
+      INTEGER, POINTER       :: GPE(:), GNV(:)
+      INTEGER, TARGET        :: WORK(:)
+      INTEGER(8), INTENT(IN) :: LWORK
+      TYPE(GRAPH_TYPE)       :: top_graph
+      INTEGER(8), POINTER    :: IPE(:), IPET(:),
+     &                          BUF_PE1(:), BUF_PE2(:), TMP1(:)
+      INTEGER, POINTER       :: PE(:), LENG(:), I_HALO_MAP(:)
+      INTEGER, POINTER       :: NDENSE(:), LAST(:),
+     &                          DEGREE(:), W(:), PERM(:),
+     &                          LISTVAR_SCHUR(:), NEXT(:),
+     &                          HEAD(:), NV(:), ELEN(:),
+     &                          LSTVAR(:)
+      INTEGER, POINTER       :: MYLIST(:), LPERM(:), LIPERM(:),
+     &                          NVT(:), BUF_NV1(:),
+     &                          BUF_NV2(:), ROOTPERM(:),
+     &                          TMP2(:), BWORK(:), NCLIQUES(:)
       INTEGER              :: MYNCLIQUES, MYMAXVARS, ICLIQUES,
      &     TOTNCLIQUES
       INTEGER(8)           :: MYNVARS, TOTNVARS
@@ -1262,14 +1353,14 @@ C
      &     BUF_NV1, BUF_NV2, ROOTPERM, TMP1, TMP2, BWORK)
       MYID   = ord%MYID
       NPROCS = ord%NPROCS
-      IF(size(WORK) .LT. 4*N) THEN
+      IF(LWORK .LT. 4_8*int(N,8)) THEN
          WRITE(LP,*)'Insufficient workspace in CMUMPS_PARSYMFACT'
          CALL MUMPS_ABORT()
       ELSE
-         HEAD => WORK(       1 :   N)
-         ELEN => WORK(  N+1 : 2*N)
-         LENG => WORK(2*N+1 : 3*N)
-         PERM => WORK(3*N+1 : 4*N)
+         HEAD => WORK(              1 :         N    )
+         ELEN => WORK(     int(N,8)+1 : 2_8*int(N,8) )
+         LENG => WORK( 2_8*int(N,8)+1 : 3_8*int(N,8) )
+         PERM => WORK( 3_8*int(N,8)+1 : 4_8*int(N,8) )
       END IF
       CALL CMUMPS_GET_SUBTREES(ord, id)
       CALL MUMPS_IDEALLOC(ord%SON, ord%BROTHER, ord%NW,
@@ -1277,9 +1368,9 @@ C
       NROWS_LOC = ord%LAST(MYID+1)-ord%FIRST(MYID+1)+1
       NRL = NROWS_LOC
       TOPROWS = ord%TOPNODES(2)
-      BWORK => WORK(1 : 2*N)
+      BWORK => WORK(1_8 : 2_8*int(N,8))
       CALL CMUMPS_BUILD_LOC_GRAPH(id, ord, HIDX, IPE, PE, LENG,
-     &     I_HALO_MAP, top_graph, BWORK)
+     &     I_HALO_MAP, top_graph, BWORK, 2_8*int(N,8))
       CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &     ord%COMM, ord%MYID )
       IF(id%INFO(1).lt.0) RETURN
@@ -1377,7 +1468,7 @@ C
      &              PROC, ITAG, ord%COMM, STATUSCLIQUES, IERR)
             END DO
          END DO
-         LPERM => WORK(3*N+1 : 4*N)
+         LPERM => WORK(3_8*int(N,8)+1_8 : 4_8*int(N,8))
          NTVAR   = ord%TOPNODES(2)
          CALL CMUMPS_MAKE_LOC_IDX(id, ord%TOPNODES, LPERM, LIPERM, ord)
          CALL CMUMPS_ASSEMBLE_TOP_GRAPH(id, ord%TOPNODES(2), LPERM,
@@ -1563,7 +1654,7 @@ C
       NULLIFY(HEAD, ELEN, LENG, PERM)
       RETURN
       END SUBROUTINE CMUMPS_PARSYMFACT
-      SUBROUTINE CMUMPS_PARSYMFACT_LUMAT(id, ord, GPE, GNV, WORK, 
+      SUBROUTINE CMUMPS_PARSYMFACT_LUMAT(id, ord, GPE, GNV, WORK, LWORK,
      &                                   LUMAT, SIZEOFBLOCKS)  
       IMPLICIT NONE
       TYPE(CMUMPS_STRUC)   :: id
@@ -1590,7 +1681,7 @@ C
      &     TMP2(:), BWORK(:), NCLIQUES(:), MAPTAB(:)
       INTEGER              :: MYNCLIQUES, MYMAXVARS, ICLIQUES,
      &     TOTNCLIQUES
-      INTEGER(8)           :: MYNVARS, TOTNVARS
+      INTEGER(8)           :: MYNVARS, TOTNVARS, LWORK
       INTEGER(8), POINTER  :: LVARPT(:)
       INTEGER              :: HIDX, TOTEL, 
      &     NCMPA, I, J, SIZE_SCHUR, MYID,
@@ -1612,26 +1703,25 @@ C
      &     BUF_NV1, BUF_NV2, ROOTPERM, TMP1, TMP2, BWORK, MAPTAB)
       MYID   = ord%MYID
       NPROCS = ord%NPROCS
-      IF(size(WORK) .LT. 4*N) THEN
+      IF( LWORK .LT. 4_8*int(N,8) ) THEN
          WRITE(LP,*)
      &      'Insufficient workspace in CMUMPS_PARSYMFACT_LUMAT'
          CALL MUMPS_ABORT()
-      ELSE
-         HEAD => WORK(       1 :   N)
-         ELEN => WORK(  N+1 : 2*N)
-         LENG => WORK(2*N+1 : 3*N)
-         PERM => WORK(3*N+1 : 4*N)
-      END IF
+      ENDIF
+      HEAD => WORK(              1   :         N    )
+      ELEN => WORK(     int(N,8)+1_8 : 2_8*int(N,8) )
+      LENG => WORK( 2_8*int(N,8)+1_8 : 3_8*int(N,8) )
+      PERM => WORK( 3_8*int(N,8)+1_8 : 4_8*int(N,8) )
       CALL CMUMPS_GET_SUBTREES(ord, id)
       CALL MUMPS_IDEALLOC(ord%SON, ord%BROTHER, ord%NW,
      &     ord%RANGTAB, MEMCNT=MEMCNT)
       NROWS_LOC = ord%LAST(MYID+1)-ord%FIRST(MYID+1)+1
       NRL = NROWS_LOC
       TOPROWS = ord%TOPNODES(2)
-      BWORK  => WORK(1 : 2*N)
+      BWORK  => WORK(1_8 : 2_8*int(N,8))
        CALL CMUMPS_LUMAT_TO_LOC_GRAPH(
      &     LUMAT, id, ord, HIDX, IPE, PE, LENG,
-     &     I_HALO_MAP, BWORK)
+     &     I_HALO_MAP, BWORK, 2_8*int(N,8))
       CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &     ord%COMM, ord%MYID )
       IF(id%INFO(1).lt.0) RETURN
@@ -1680,7 +1770,7 @@ C
          IF(HIDX .GT.0) THEN
            NV(1) = -1 
            TOTEL = HIDX
-           IF ((N.LT.NORIG).OR.(id%KEEP(339).GE.4)) THEN
+           IF ((N.LT.NORIG).OR.(id%KEEP(339).NE.0)) THEN
              TOTEL = 0
              DO I=1,NROWS_LOC
                NV(I) = SIZEOFBLOCKS (
@@ -1759,13 +1849,13 @@ C
          END DO
       END IF
       CALL MUMPS_DEALLOC(PE, MEMCNT=MEMCNT) 
-      IF (id%KEEP(339).GT.2) THEN
+      IF (id%KEEP(339).NE.0) THEN
           MAPTAB => WORK(1:N)
           CALL MUMPS_BUILD_TOP_GRAPH (LUMAT, id, ord, top_graph, MAPTAB)
       ENDIF
       IF (MYID.EQ.0) THEN
-        LPERM => WORK(3*N+1 : 4*N)
-        NTVAR   = ord%TOPNODES(2)
+        LPERM => WORK( 3_8*int(N,8)+1_8 : 4_8*int(N,8) )
+        NTVAR = ord%TOPNODES(2)
         CALL CMUMPS_MAKE_LOC_IDX(id, ord%TOPNODES, LPERM, LIPERM, ord)
         CALL CMUMPS_ASSEMBLE_TOP_GRAPH(id, ord%TOPNODES(2), LPERM,
      &        top_graph, TOTNCLIQUES, LSTVAR, LVARPT, IPET, PE,
@@ -1813,7 +1903,7 @@ C
             IF(TGSIZE.GT.0) THEN 
               NVT(1) = -1 
               TOTEL = TGSIZE
-              IF ((N.LT.NORIG).OR.(id%KEEP(339).GE.4)) THEN
+              IF ((N.LT.NORIG).OR.(id%KEEP(339).NE.0)) THEN
                 TOTEL = TOTNCLIQUES
                 DO I=1,NTVAR
                   NVT(I) = SIZEOFBLOCKS( LIPERM(I) )
@@ -1939,7 +2029,7 @@ C
      &     MEMCNT=MEMCNT)
       CALL MUMPS_DEALLOC(LPERM, LIPERM, NVT, MEMCNT=MEMCNT)
       CALL MUMPS_DEALLOC(ROOTPERM, TMP2, MEMCNT=MEMCNT)
-      NULLIFY(HEAD, ELEN, LENG, PERM)
+      NULLIFY(HEAD, ELEN, LENG, PERM, BWORK, MAPTAB, LPERM)
       RETURN
       END SUBROUTINE CMUMPS_PARSYMFACT_LUMAT
       SUBROUTINE CMUMPS_MAKE_LOC_IDX(id, TOPNODES, LPERM, LIPERM, ord)
@@ -2115,13 +2205,14 @@ C
 #endif
 #if defined(ptscotch) || defined(parmetis) || defined(parmetis3)
       SUBROUTINE CMUMPS_BUILD_DIST_GRAPH(id, ord, FIRST, LAST, IPE,
-     &     PE, WORK)
+     &     PE, WORK, LWORK)
       IMPLICIT NONE
       TYPE(CMUMPS_STRUC)      :: id
       TYPE(ORD_TYPE)          :: ord
       INTEGER(8), POINTER     :: IPE(:)
       INTEGER, POINTER        :: FIRST(:), LAST(:), PE(:),
      &     WORK(:)
+      INTEGER(8), INTENT(IN)  :: LWORK
       INTEGER                 :: IERR, MYID, NPROCS
       INTEGER                 :: I, PROC, J, LOC_ROW
       INTEGER(8)              :: LOCNNZ, INNZ, NEW_LOCNNZ, OFFDIAG,
@@ -2148,7 +2239,7 @@ C
       nullify(TSENDI, TSENDJ, RCVBUF, APNT)
       MYID   = ord%MYID
       NPROCS = ord%NPROCS
-      IF(MUMPS_GETSIZE(WORK) .LT. N*2) THEN
+      IF(LWORK .LT. int(N,8)*2_8) THEN
          WRITE(LP,
      &        '("Insufficient workspace inside BUILD_SCOTCH_GRAPH")')
          CALL MUMPS_ABORT()
@@ -2174,8 +2265,8 @@ C
       BUFSIZE = id%KEEP(39)
       LOCNNZ = id%KEEP8(29)
       NROWS_LOC = LAST(MYID+1)-FIRST(MYID+1)+1
-      MAPTAB => WORK(     1 :   N)
-      LENG   => WORK(N+1 : 2*N)
+      MAPTAB => WORK(       1    :         N )
+      LENG   => WORK( int(N+1,8) : 2_8*int(N,8) )
       MAXS = 0
       DO I=1, NPROCS
          IF((LAST(I)-FIRST(I)+1) .GT. MAXS) THEN
@@ -2321,7 +2412,7 @@ C
       END SUBROUTINE CMUMPS_BUILD_DIST_GRAPH
 #endif      
       SUBROUTINE CMUMPS_BUILD_LOC_GRAPH(id, ord, GSIZE, IPE, PE, LENG,
-     &     I_HALO_MAP, top_graph, WORK)
+     &     I_HALO_MAP, top_graph, WORK, LWORK)
       IMPLICIT NONE
       TYPE(CMUMPS_STRUC)   :: id
       TYPE(ORD_TYPE)       :: ord
@@ -2329,6 +2420,7 @@ C
       INTEGER(8), POINTER  :: IPE(:)
       INTEGER, POINTER     :: PE(:), LENG(:),
      &     I_HALO_MAP(:), WORK(:)
+      INTEGER(8), INTENT(in) :: LWORK
       INTEGER              :: GSIZE
       INTEGER                :: IERR, MYID, NPROCS
       INTEGER                :: I, PROC, J, LOC_ROW
@@ -2355,13 +2447,13 @@ C
       nullify(TSENDI, TSENDJ, RCVBUF, APNT)
       MYID   = ord%MYID
       NPROCS = ord%NPROCS
-      IF(MUMPS_GETSIZE(WORK) .LT. N*2) THEN
+      IF( LWORK .LT. int(N,8)*2_8 ) THEN
          WRITE(LP,
      &        '("Insufficient workspace inside BUILD_LOC_GRAPH")')
          CALL MUMPS_ABORT()
       END IF
-      MAPTAB   => WORK(     1 :   N)
-      HALO_MAP => WORK(N+1 : 2*N)
+      MAPTAB   => WORK(      1    :         N   )
+      HALO_MAP => WORK(int(N+1,8) : 2_8*int(N,8))
       CALL MUMPS_I8REALLOC(SNDCNT, NPROCS, id%INFO, LP,
      &     MEMCNT=MEMCNT, ERRCODE=-7)
       CALL MUMPS_I8REALLOC(RCVCNT, NPROCS, id%INFO, LP,
@@ -2643,7 +2735,7 @@ C
       END SUBROUTINE CMUMPS_BUILD_LOC_GRAPH
       SUBROUTINE CMUMPS_LUMAT_TO_LOC_GRAPH 
      &     (LUMAT, id, ord, GSIZE, IPE, PE, LENG,
-     &     I_HALO_MAP, WORK)
+     &     I_HALO_MAP, WORK, LWORK)
       IMPLICIT NONE
       TYPE(LMATRIX_T), INTENT(IN) :: LUMAT
       TYPE(CMUMPS_STRUC)   :: id
@@ -2651,6 +2743,7 @@ C
       INTEGER(8), POINTER  :: IPE(:)
       INTEGER, POINTER     :: PE(:), LENG(:),
      &     I_HALO_MAP(:), WORK(:)
+      INTEGER(8), INTENT(IN) :: LWORK
       INTEGER              :: GSIZE
       INTEGER                :: IERR, MYID, NPROCS
       INTEGER                :: I, PROC, J, LOC_ROW 
@@ -2674,13 +2767,13 @@ C
       nullify( RCVBUF, APNT)
       MYID   = ord%MYID
       NPROCS = ord%NPROCS
-      IF(MUMPS_GETSIZE(WORK) .LT. N) THEN
+      IF ( LWORK .LT.2_8 * int(N,8) ) THEN
          WRITE(LP,
      &   '("Insufficient workspace inside CMUMPS_LUMAT_TO_LOC_GRAPH")')
          CALL MUMPS_ABORT()
       END IF
-      MAPTAB   => WORK(     1 :   N)
-      HALO_MAP => WORK(N+1 : 2*N)
+      MAPTAB   => WORK(       1    :         N   )
+      HALO_MAP => WORK( int(N+1,8) : 2_8*int(N,8))
       CALL MUMPS_I8REALLOC(SNDCNT, NPROCS, id%INFO, LP,
      &     MEMCNT=MEMCNT, ERRCODE=-7)
       CALL MUMPS_I8REALLOC(RCVCNT, NPROCS, id%INFO, LP,
@@ -3139,15 +3232,16 @@ C
       RETURN
       END SUBROUTINE CMUMPS_BUILD_TREE
       SUBROUTINE CMUMPS_GRAPH_DIST(id, ord, FIRST,
-     &     LAST, BASE, NPROCS, WORK, TYPE)
+     &     LAST, BASE, NPROCS, WORK, LWORK, TYPE)
       IMPLICIT NONE
-      TYPE(CMUMPS_STRUC)   :: id
-      TYPE(ORD_TYPE)       :: ord
-      INTEGER              :: FIRST(:), LAST(:), BASE, NPROCS, TYPE
-      INTEGER, TARGET      :: WORK(:)
-      INTEGER, POINTER     :: TMP(:), NZ_ROW(:)
-      INTEGER              :: I, IERR, P, F, J
-      INTEGER(8)           :: LOCNNZ, INNZ, LOCOFFDIAG,
+      TYPE(CMUMPS_STRUC)     :: id
+      TYPE(ORD_TYPE)         :: ord
+      INTEGER                :: FIRST(:), LAST(:), BASE, NPROCS, TYPE
+      INTEGER, TARGET        :: WORK(:)
+      INTEGER(8), INTENT(IN) :: LWORK
+      INTEGER, POINTER       :: TMP(:), NZ_ROW(:)
+      INTEGER                :: I, IERR, P, F, J
+      INTEGER(8)             :: LOCNNZ, INNZ, LOCOFFDIAG,
      &     OFFDIAG, T, SHARE
       DO I=0, BASE-1
          FIRST(I+1) = 0
@@ -3166,8 +3260,12 @@ C
             LAST (BASE+I) = N
          END DO
       ELSE IF (TYPE.EQ.2) THEN
+         IF (LWORK .LT. 2_8*int(N,8)) THEN
+           WRITE(*,*) "Insufficient workspace in CMUMPS_GRAPH_DIST"
+           CALL MUMPS_ABORT()
+         ENDIF
          TMP    => WORK(1:N)
-         NZ_ROW => WORK(N+1:2*N)
+         NZ_ROW => WORK(int(N+1,8):2-8*int(N,8))
          TMP = 0
          LOCOFFDIAG = 0_8
          LOCNNZ = id%KEEP8(29)
@@ -3181,7 +3279,7 @@ C
                END IF
             END IF
          END DO
-         CALL MPI_ALLREDUCE(TMP(1), NZ_ROW(1), N,
+         CALL MUMPS_BIGALLREDUCE(.FALSE., TMP(1), NZ_ROW(1), N,
      &        MPI_INTEGER, MPI_SUM, ord%COMM, IERR)
          CALL MPI_ALLREDUCE(LOCOFFDIAG, OFFDIAG, 1,
      &        MPI_INTEGER8, MPI_SUM, ord%COMM, IERR)
@@ -3284,7 +3382,7 @@ C
       IF (L(N+1) == 0) THEN
          RETURN 
       ELSE
-         L(N+1) = iabs(L(N+1))
+         L(N+1) = abs(L(N+1))
       END IF
  200  CONTINUE
       S = 0
@@ -3371,7 +3469,7 @@ C
       IF (SIZE_VELOLOCTAB.EQ.VERTLOCNBR) THEN
        CALL MUMPS_PARMETIS_VWGT(FIRST(1+BASE), VERTLOCTAB_I4(1),
      &     EDGELOCTAB(1), BASEVAL, OPTIONS(1), ORDER(1),
-     &     SIZES(1), COMM, VELOLOCTAB, IERR)
+     &     SIZES(1), COMM, VELOLOCTAB(1), IERR)
       ELSE
        CALL MUMPS_PARMETIS(FIRST(1+BASE), VERTLOCTAB_I4(1),
      &     EDGELOCTAB(1), BASEVAL, OPTIONS(1), ORDER(1),
@@ -3421,7 +3519,7 @@ C
      &     EDGELOCTAB(1),
      &     BASEVAL, OPTIONS(1),
      &     ORDER(1),
-     &     SIZES(1), COMM, VELOLOCTAB, IERR)
+     &     SIZES(1), COMM, VELOLOCTAB(1), IERR)
        ELSE
         CALL MUMPS_PARMETIS_64(FIRST(1+BASE), VERTLOCTAB(1),
      &     EDGELOCTAB(1),
@@ -3469,7 +3567,7 @@ C
      &     BASEVAL_I8, OPTIONS_I8(1),
 #endif
      &     ORDER_I8(1),
-     &     SIZES_I8(1), COMM, VELOLOCTAB_I8,
+     &     SIZES_I8(1), COMM, VELOLOCTAB_I8(1),
      &     IERR)
        ELSE
         CALL MUMPS_PARMETIS_64(FIRST_I8(1+BASE), VERTLOCTAB(1),
@@ -3514,6 +3612,9 @@ C
      &     VERTLOCNBR, VERTLOCTAB,
      &     EDGELOCNBR, EDGELOCTAB, 
      &     VELOLOCTAB, SIZE_VELOLOCTAB,
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+     &             CONTDAT, LCONTDAT,
+#endif
      &     IERR)
       IMPLICIT NONE
       INCLUDE 'ptscotchf.h'
@@ -3532,6 +3633,11 @@ C
      &     ORDEDAT(SCOTCH_DORDERDIM), STRADAT(SCOTCH_STRATDIM),
      &     CORDEDAT(SCOTCH_ORDERDIM)
       CHARACTER  STRSTRING*1024
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+      INTEGER             :: LCONTDAT
+      DOUBLE PRECISION    :: CONTDAT(LCONTDAT)
+      DOUBLE PRECISION    :: GRAPHDAT_BEFORE_CONTEXT(SCOTCH_DGRAPHDIM)
+#endif
       IF (.NOT.ord%IDO) RETURN
       nullify(VERTLOCTAB_I4)
       CALL MUMPS_REALLOC(VERTLOCTAB_I4, VERTLOCNBR+1, id%INFO, LP,
@@ -3554,7 +3660,14 @@ C
       ELSE
          MYWORKID = -1
       END IF
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+      CALL MUMPS_DGRAPHINIT(GRAPHDAT_BEFORE_CONTEXT, ord%COMM_PARAORD,
+     &                      IERR)
+      CALL SCOTCHFCONTEXTBINDDGRAPH(CONTDAT, GRAPHDAT_BEFORE_CONTEXT,
+     &                              GRAPHDAT, IERR)
+#else
       CALL MUMPS_DGRAPHINIT(GRAPHDAT, ord%COMM_PARAORD, IERR)
+#endif
       IF(IERR.NE.0) THEN
          id%INFO(1:2) = -50
       END IF
@@ -3641,8 +3754,11 @@ C
       IF(MYWORKID .EQ. 0) 
      &     CALL SCOTCHFDGRAPHCORDEREXIT(GRAPHDAT, CORDEDAT)
       CALL SCOTCHFDGRAPHORDEREXIT(GRAPHDAT, ORDEDAT)
-      CALL SCOTCHFSTRATEXIT(STRADAT) 
+      CALL SCOTCHFSTRATEXIT(STRADAT)
       CALL SCOTCHFDGRAPHEXIT(GRAPHDAT)
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+      CALL SCOTCHFDGRAPHEXIT(GRAPHDAT_BEFORE_CONTEXT)
+#endif
  10   CONTINUE
       CALL MUMPS_DEALLOC(VERTLOCTAB_I4, MEMCNT=MEMCNT)
       RETURN
@@ -3652,6 +3768,9 @@ C
      &     VERTLOCNBR, VERTLOCTAB,
      &     EDGELOCNBR, EDGELOCTAB,
      &     VELOLOCTAB, SIZE_VELOLOCTAB,
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+     &             CONTDAT, LCONTDAT,
+#endif
      &     IERR)
       IMPLICIT NONE
       INCLUDE 'ptscotchf.h'
@@ -3669,6 +3788,11 @@ C
      &     ORDEDAT(SCOTCH_DORDERDIM), STRADAT(SCOTCH_STRATDIM),
      &     CORDEDAT(SCOTCH_ORDERDIM)
       CHARACTER  STRSTRING*1024
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+      INTEGER             :: LCONTDAT
+      DOUBLE PRECISION    :: CONTDAT(LCONTDAT)
+      DOUBLE PRECISION    :: GRAPHDAT_BEFORE_CONTEXT(SCOTCH_DGRAPHDIM)
+#endif
       INTEGER(8), POINTER :: EDGELOCTAB_I8(:), PERMTAB_I8(:),
      &     PERITAB_I8(:), RANGTAB_I8(:), TREETAB_I8(:), VELOLOCTAB_I8(:)
       INTEGER(8)          :: CBLKNBR_I8, VERTLOCNBR_I8, BASEVAL_I8
@@ -3722,7 +3846,14 @@ C
        ENDIF
        BASEVAL_I8    = int(BASEVAL,8)
       ENDIF
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+      CALL MUMPS_DGRAPHINIT(GRAPHDAT_BEFORE_CONTEXT, ord%COMM_PARAORD,
+     &                      IERR)
+      CALL SCOTCHFCONTEXTBINDDGRAPH(CONTDAT, GRAPHDAT_BEFORE_CONTEXT,
+     &                              GRAPHDAT, IERR)
+#else
       CALL MUMPS_DGRAPHINIT(GRAPHDAT, ord%COMM_PARAORD, IERR)
+#endif
       IF(IERR.NE.0) THEN
          id%INFO(1:2) = -50
       END IF
@@ -3828,16 +3959,20 @@ C
       CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &     ord%COMM_PARAORD, ord%MYID_PARAORD )
       IF ( id%INFO(1) .LT. 0 ) GOTO 10
+      IF(MYWORKID .EQ. 0) 
+     &     CALL SCOTCHFDGRAPHCORDEREXIT(GRAPHDAT, CORDEDAT)
       CALL SCOTCHFDGRAPHORDEREXIT(GRAPHDAT, ORDEDAT)
       CALL SCOTCHFSTRATEXIT(STRADAT) 
       CALL SCOTCHFDGRAPHEXIT(GRAPHDAT)
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+      CALL SCOTCHFDGRAPHEXIT(GRAPHDAT_BEFORE_CONTEXT)
+#endif
  10   CONTINUE
       IF (id%KEEP(10).NE.1) THEN
        CALL MUMPS_I8DEALLOC(EDGELOCTAB_I8, MEMCNT=MEMCNT)
        IF (SIZE_VELOLOCTAB.GT.0)
      & CALL MUMPS_I8DEALLOC(VELOLOCTAB_I8, MEMCNT=MEMCNT)
        IF(MYWORKID .EQ. 0) THEN
-         CALL SCOTCHFDGRAPHCORDEREXIT(GRAPHDAT, CORDEDAT)
          CALL MUMPS_ICOPY_64TO32(PERMTAB_I8(1),
      &        size(ord%PERMTAB), ord%PERMTAB(1))
          CALL MUMPS_ICOPY_64TO32(PERITAB_I8(1),
diff -pruN 5.6.2-2.1/src/cana_dist_m.F 5.7.1-1/src/cana_dist_m.F
--- 5.6.2-2.1/src/cana_dist_m.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/cana_dist_m.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -80,6 +80,8 @@ C
       INTEGER  ISTEP_TO_INIV2( KEEP(71) )
       LOGICAL  I_AM_CAND(NMB_PAR2)
       INTEGER  CANDIDATES( SLAVEF+1, NMB_PAR2 )
+      INTEGER  PHASE
+      PARAMETER (PHASE=0)
       REAL OPSA
       DOUBLE PRECISION OPSA_LOC 
       INTEGER(8) MAX_SIZE_FACTOR
@@ -144,10 +146,15 @@ C
       INTEGER :: FLAG_L0OMP
       PARAMETER (FLAG_L0OMP=-2014)
       INCLUDE 'mumps_headers.h'
+      LOGICAL ROOT_OWNER
+      INTEGER(8) LWK_RR
+      INTEGER LIWK_RR
+      INTEGER IROOT, SIZE_ROOT
       INTEGER WHAT
       INTEGER(4) :: I4
       INTEGER(8) IDUMMY8
-      INTRINSIC min, int, real
+      INTRINSIC min, int
+      INTRINSIC real
       INTEGER CMUMPS_OOC_GET_PANEL_SIZE
       EXTERNAL CMUMPS_OOC_GET_PANEL_SIZE
       INTEGER MUMPS_PROCNODE, MUMPS_TYPENODE
@@ -410,7 +417,7 @@ C
      &                KEEP(494), 1, KEEP(490),
      &                KEEP(491), KEEP(492),
      &                KEEP(20), KEEP(60), DAD(STEP(INODE)), KEEP(38),
-     &                LRSTATUS, IDUMMY)
+     &                KEEP(123), LRSTATUS, IDUMMY)
       COMPRESS_PANEL = (LRSTATUS.GE.2)
       COMPRESS_CB    = ((LRSTATUS.EQ.1).OR.(LRSTATUS.EQ.3))
       IF (COMPRESS_PANEL.OR.COMPRESS_CB) NBNODES_BLR = NBNODES_BLR+1
@@ -720,9 +727,9 @@ C
              ENDIF
             ENDIF
          ENDIF
-         NIRNEC = max0(NIRNEC,
+         NIRNEC = max(NIRNEC,
      &             NIRADU+ISTKI+SIZECBI+MAXITEMPCB)
-         NIRNEC_OOC = max0(NIRNEC_OOC,
+         NIRNEC_OOC = max(NIRNEC_OOC,
      &             NIRADU_OOC+ISTKI_OOC+SIZECBI+MAXITEMPCB +
      &             (XSIZE_OOC-XSIZE_IC) ) 
          CURRENT_ACTIVE_MEM = ISTKR+SIZECBINFR
@@ -852,7 +859,7 @@ C
      &                KEEP(494), 1, KEEP(490),
      &                KEEP(491), KEEP(492),
      &                KEEP(20), KEEP(60), DAD(STEP(IFSON)), KEEP(38),
-     &                LRSTATUSS, IDUMMY)
+     &                KEEP(123), LRSTATUSS, IDUMMY)
                COMPRESS_CBS   = ((LRSTATUSS.EQ.1).OR.(LRSTATUSS.EQ.3))
                IF (COMPRESS_CBS) THEN
                  K465_8    = int(KEEP(465),8)
@@ -1448,8 +1455,8 @@ C
            LSTKR(ITOP) = SIZECB
            ISTKR = ISTKR + LSTKR(ITOP)
            NRLNEC = max(NRLNEC,NRLADU+ISTKR+MAXTEMPCB)
-           NIRNEC = max0(NIRNEC,NIRADU+ISTKI+MAXITEMPCB)
-           NIRNEC_OOC = max0(NIRNEC_OOC,NIRADU_OOC+ISTKI_OOC+
+           NIRNEC = max(NIRNEC,NIRADU+ISTKI+MAXITEMPCB)
+           NIRNEC_OOC = max(NIRNEC_OOC,NIRADU_OOC+ISTKI_OOC+
      &          MAXITEMPCB + 
      &          (XSIZE_OOC-XSIZE_IC) ) 
            NRLNEC_if_LR_LU    =  max(NRLNEC_if_LR_LU,
@@ -1482,6 +1489,73 @@ C
          ENDIF
       ENDIF 
  115  CONTINUE
+      IF ( KEEP(53) .NE. 0 ) THEN
+        IF ( KEEP(38) .ne. 0 ) THEN
+          IROOT = KEEP( 38 )
+        ELSE
+          IROOT = KEEP( 20 )
+        END IF
+        ROOT_OWNER = ( MYID .eq.
+     &  MUMPS_PROCNODE( PROCNODE(STEP(IROOT)), KEEP(199) ) )
+        SIZE_ROOT = ND(STEP(IROOT))+KEEP(253)
+        CALL CMUMPS_SVD_QR_ESTIM_WK( PHASE, 
+     &       KEEP(51), KEEP(51), SIZE_ROOT,
+     &       LOCAL_M, LOCAL_N, ROOT_OWNER, KEEP,KEEP8,
+     &       LIWK_RR, LWK_RR )
+        IF ( NRLNEC-NRLADU .LT. LWK_RR ) THEN
+          NRLNEC = NRLADU + LWK_RR
+          NRLNEC_if_LR_LU   = NRLNEC_if_LR_LU + LWK_RR
+          NRLNEC_if_LR_CB   = NRLNEC_if_LR_CB + LWK_RR
+          NRLNEC_if_LR_LUCB = NRLNEC_if_LR_LUCB + LWK_RR
+          NRLNEC_ACTIVE     = NRLNEC_ACTIVE     + LWK_RR
+          NRLNECOOC_if_LR_LUCB = NRLNECOOC_if_LR_LUCB  + LWK_RR
+          PEAK_LRLU_UD = 
+     &             max(PEAK_LRLU_UD,
+     &             NRLNEC_if_LR_LU + NRLADULR_UD)
+          PEAK_OOC_LRLU_UD = 
+     &             max(PEAK_OOC_LRLU_UD,
+     &             NRLNEC_ACTIVE + NRLADULR_UD)
+          PEAK_OOC_LRLU_WC = 
+     &             max(PEAK_OOC_LRLU_WC,
+     &             NRLNEC_ACTIVE + NRLADULR_WC)
+          PEAK_LRLUCB_UD = 
+     &             max(PEAK_LRLUCB_UD,
+     &             NRLNEC_if_LR_LUCB + NRLNECLR_LUCB_UD)
+          PEAK_LRLUCB_WC = 
+     &             max(PEAK_LRLUCB_WC,
+     &             NRLNEC_if_LR_LUCB + NRLNECLR_LUCB_WC)
+          PEAK_OOC_LRLUCB_UD = 
+     &             max(PEAK_OOC_LRLUCB_UD,
+     &             NRLNECOOC_if_LR_LUCB + NRLNECLR_LUCB_UD)
+          PEAK_OOC_LRLUCB_WC = 
+     &             max(PEAK_OOC_LRLUCB_WC,
+     &             NRLNECOOC_if_LR_LUCB + NRLNECLR_LUCB_WC)
+          PEAK_LRCB_UD =
+     &             max(PEAK_LRCB_UD,
+     &             NRLNEC_if_LR_CB + NRLNECLR_CB_UD)
+          PEAK_OOC_LRCB_UD =
+     &             max(PEAK_OOC_LRCB_UD,
+     &             NRLNECOOC_if_LR_LUCB + NRLNECLR_CB_UD)
+          IF (ABOVE_L0) THEN
+           PEAK_DYN_LRLU_UD   = max( PEAK_DYN_LRLU_UD,
+     &          SIZECB_UNDER_L0 + NRLADULR_UD )
+           PEAK_DYN_LRCB_UD   = max( PEAK_DYN_LRCB_UD,
+     &          SIZECB_UNDER_L0_IF_LRCB + ISTKR_if_LRCB)
+           PEAK_DYN_LRLUCB_UD = max( PEAK_DYN_LRLUCB_UD,
+     &      SIZECB_UNDER_L0_IF_LRCB + ISTKR_if_LRCB + NRLADULR_UD)
+           PEAK_DYN_LRLU_WC   = max( PEAK_DYN_LRLU_WC,
+     &          SIZECB_UNDER_L0 + NRLADULR_WC)
+           PEAK_DYN_LRLUCB_WC = max( PEAK_DYN_LRLUCB_WC,
+     &          SIZECB_UNDER_L0 + ISTKRLR_CB_WC + NRLADULR_WC)
+          ENDIF
+        END IF
+        IF ( NIRNEC-NIRADU .LT. LIWK_RR ) THEN
+          NIRNEC = NIRADU + LIWK_RR
+        END IF
+        IF ( NIRNEC_OOC-NIRADU_OOC .LT. LIWK_RR ) THEN
+          NIRNEC_OOC = NIRADU_OOC + LIWK_RR
+        END IF
+      END IF
       NRLNEC = max(NRLNEC, NRLADU+int(KEEP(30),8))
       NRLNEC_ACTIVE = max(NRLNEC_ACTIVE, MAX_SIZE_FACTOR+
      &                    int(KEEP(30),8))
@@ -1938,7 +2012,7 @@ C
      &                KEEP(494), 1, KEEP(490),
      &                KEEP(491), KEEP(492),
      &                KEEP(20), KEEP(60), DAD(STEP(INODE)), KEEP(38),
-     &                LRSTATUS, IDUMMY)
+     &                KEEP(123), LRSTATUS, IDUMMY)
       COMPRESS_PANEL = (LRSTATUS.GE.2)
       COMPRESS_CB    = ((LRSTATUS.EQ.1).OR.(LRSTATUS.EQ.3))
       IF (COMPRESS_PANEL.OR.COMPRESS_CB) NBNODES_BLR = NBNODES_BLR+1
@@ -2010,9 +2084,9 @@ C
                NRLADU_if_LR_LU = NRLADU_if_LR_LU + NRLADU_CURRENT
       ENDIF
       SIZECBI        = 2* NCB  + SIZEHEADER
-      NIRNEC = max0(NIRNEC,
+      NIRNEC = max(NIRNEC,
      &             NIRADU+ISTKI+SIZECBI+MAXITEMPCB)
-      NIRNEC_OOC = max0(NIRNEC_OOC,
+      NIRNEC_OOC = max(NIRNEC_OOC,
      &             NIRADU_OOC+ISTKI_OOC+SIZECBI+MAXITEMPCB +
      &             (XSIZE_OOC-XSIZE_IC) ) 
       CURRENT_ACTIVE_MEM = ISTKR+SIZECBINFR
@@ -2243,8 +2317,8 @@ C
            LSTKR(ITOP) = SIZECB
            ISTKR = ISTKR + LSTKR(ITOP)
            NRLNEC = max(NRLNEC,NRLADU+ISTKR)
-           NIRNEC = max0(NIRNEC,NIRADU+ISTKI)
-           NIRNEC_OOC = max0(NIRNEC_OOC,NIRADU_OOC+ISTKI_OOC)
+           NIRNEC = max(NIRNEC,NIRADU+ISTKI)
+           NIRNEC_OOC = max(NIRNEC_OOC,NIRADU_OOC+ISTKI_OOC)
            NRLNEC_if_LR_LU  =  max(NRLNEC_if_LR_LU,
      &                             NRLADU_if_LR_LU+ISTKR)
            LSTKR_if_LRCB(ITOP) = SIZECB_if_LRCB
diff -pruN 5.6.2-2.1/src/cana_driver.F 5.7.1-1/src/cana_driver.F
--- 5.6.2-2.1/src/cana_driver.F	2023-10-11 09:37:10.000000000 +0000
+++ 5.7.1-1/src/cana_driver.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -48,15 +48,14 @@ C     Local variables
 C     ===============
 C     
 C     
-C     Pointers inside integer array, various data
-      INTEGER IKEEP, NE, NA
+C     Pointers inside integer array IKEEPALLOC, various data
+      INTEGER(8) IKEEP, NE, NA
       INTEGER I, allocok
 C     Other locals
       INTEGER NB_NIV2, IDEST
       INTEGER :: STATUS(MPI_STATUS_SIZE)
       INTEGER LOCAL_M, LOCAL_N
-      INTEGER numroc
-      EXTERNAL numroc
+      INTEGER, EXTERNAL :: MUMPS_NUMROC
       INTEGER IRANK
       INTEGER MP, LP, MPG
       LOGICAL PROK, PROKG, LISTVAR_SCHUR_2BE_FREED, LPOK
@@ -148,7 +147,7 @@ C     Element matrix entry
       INTEGER :: OOC_STRAT, BLR_STRAT
       INTEGER :: IDUMMY
       INTEGER, TARGET    :: IDUMMY_ARRAY(1)
-      INTEGER(8)                     :: NNZ_loc
+      INTEGER(8)                     :: NNZ_loc, NNZ_TMP
       INTEGER, POINTER, DIMENSION(:) :: IRN_loc_PTR
       INTEGER, POINTER, DIMENSION(:) :: JCN_loc_PTR
       INTEGER, POINTER, DIMENSION(:) :: IRN_PTR
@@ -158,6 +157,7 @@ C     Element matrix entry
       LOGICAL :: BDUMMY
       INTEGER(8) :: K8_33relaxed, K8_34relaxed, K8_35relaxed,
      &              K8_50relaxed
+!$    INTEGER :: NOMP, NOMPMAX, NOMPMIN
       LOGICAL :: SUM_OF_PEAKS
       INTEGER MUMPS_TYPENODE, MUMPS_PROCNODE
       EXTERNAL MUMPS_TYPENODE, MUMPS_PROCNODE
@@ -219,11 +219,16 @@ C
      &     NFSIZPTR,
      &     FREREPTR, NE_STEPSPTR,
      &     IKEEP1, IKEEP2, IKEEP3
-      INTEGER, ALLOCATABLE, DIMENSION(:) :: FILS_TMP, STEP_TMP, 
+#if defined(MUMPS_NOF2003)
+      INTEGER, POINTER, DIMENSION(:) ::  FILS_TMPPTR
+#endif
+      INTEGER, ALLOCATABLE, DIMENSION(:), TARGET :: FILS_TMP
+      INTEGER, ALLOCATABLE, DIMENSION(:) :: STEP_TMP,
      &                                      LRGROUPS_TMP
       INTEGER, ALLOCATABLE, DIMENSION(:), TARGET :: IKEEPALLOC
       INTEGER, ALLOCATABLE, DIMENSION(:) :: WORK2ALLOC
-      INTEGER :: SIZEIKEEPALLOC, SIZELRGROUPS_TMP
+      INTEGER :: SIZELRGROUPS_TMP
+      INTEGER(8) :: SIZEIKEEPALLOC, SIZEWORK2ALLOC
 C     NBINROW_TMP, NBINCOL_TMP are computed in CMUMPS_ANA_DIST_N
 C     and used in CMUMPS_ANA_DIST_ARROWHEADS
       INTEGER, ALLOCATABLE, DIMENSION(:) :: NBINROW_TMP, NBINCOL_TMP
@@ -233,7 +238,7 @@ C     and used in CMUMPS_ANA_DIST_ARROWH
       INTEGER(kind=8) :: NZ8, LIW8
 C     NBLK : id%N or order of blocked matrix
       INTEGER :: NBLK, idNBLKSAVE
-      INTEGER :: LIW_ELT
+      INTEGER(8) :: LIW8_ELT
 C     GATHER_MATRIX_ALLOCATED: 
 C     To be sure that id%IRN and id%JCN are
 C     deallocated only when CMUMPS_GATHER_MATRIX was called
@@ -407,8 +412,25 @@ C     Broadcast KEEP(251,252,253) define
       CALL MPI_BCAST( KEEP(251), 3, MPI_INTEGER,MASTER,id%COMM,IERR)
 C
       CALL MPI_BCAST( KEEP(400), 1, MPI_INTEGER,MASTER,id%COMM,IERR)
+!$    IF (id%KEEP(400).GT.0) THEN
+!$       NOMP = OMP_GET_MAX_THREADS()
+!$       CALL MPI_ALLREDUCE(NOMP,NOMPMIN,1,MPI_INTEGER,MPI_MIN,
+!$   &                      id%COMM,IERR)
+!$       CALL MPI_ALLREDUCE(NOMP,NOMPMAX,1,MPI_INTEGER,MPI_MAX,
+!$   &                      id%COMM,IERR)
+!$       IF ( NOMPMIN .NE. NOMPMAX ) THEN
+!$          IF (PROKG) THEN
+!$             WRITE(MPG, '(A,A,I4,A,I4,A)')
+!$   &  '      WARNING tree parallelism (ICNTL(48)) switched off', 
+!$   &  ' because of different number of threads per MPI proc (max ',
+!$   &         NOMPMAX, ', min ', NOMPMIN, ')'
+!$          ENDIF
+!$          KEEP(400) = 0
+!$       END IF
+!$      ENDIF 
       CALL MPI_BCAST( id%KEEP(490), 5, MPI_INTEGER, MASTER,
      &     id%COMM, IERR )
+      CALL MPI_BCAST( KEEP(123),1,MPI_INTEGER,MASTER,id%COMM,IERR)
 C     ----------------------------------------------
 C     Broadcast N 
 C     ----------------------------------------------
@@ -472,7 +494,7 @@ C     test IRN_loc and JCN_loc allocated
       id%MEM_DIST(0:id%NSLAVES-1) = 0
       CALL MUMPS_INIT_ARCH_PARAMETERS(
      &     id%COMM,id%COMM_NODES,KEEP(69),KEEP(46),
-     &     id%NSLAVES,id%MEM_DIST,INFO)
+     &     id%NSLAVES,id%MEM_DIST,INFO )
 C     ========================
 C     Write problem to a file,
 C     if requested by the user
@@ -708,23 +730,38 @@ C         ===================
 C{        Sequential analysis
 C         ===================
 C         =======================
-          IF (KEEP(54).NE.3) THEN
+          IF (KEEP(54).NE.3.OR.id%NPROCS.EQ.1) THEN
 C         =======================
 C{        Matrix structure available on host
+C         also case of distributed input matrix format 
+C         with one mpi proc
 C         ---------------------
            KEEP(14) = 0 
            IF (id%MYID.EQ.MASTER) THEN
 C            Store input matrix (IRN/JCN) as a cleaned blocked Lmatrix 
 C            of nodes (indices \in [1,NBLK])
-             IF (id%KEEP8(28) .EQ. 0_8) THEN
-               IRN_PTR => IDUMMY_ARRAY
-               JCN_PTR => IDUMMY_ARRAY
+             IF (KEEP(54).NE.3) THEN
+               IF (id%KEEP8(28) .EQ. 0_8) THEN
+                 IRN_PTR => IDUMMY_ARRAY
+                 JCN_PTR => IDUMMY_ARRAY
+               ELSE
+                 IRN_PTR => id%IRN
+                 JCN_PTR => id%JCN
+               ENDIF
+               NNZ_TMP = id%KEEP8(28) 
              ELSE
-               IRN_PTR => id%IRN
-               JCN_PTR => id%JCN
-             ENDIF
+               IF (id%KEEP8(29) .EQ. 0_8) THEN ! NNZ_loc or NZ_loc
+                 IRN_PTR => IDUMMY_ARRAY
+                 JCN_PTR => IDUMMY_ARRAY
+                 id%KEEP8(29) = 0_8
+               ELSE
+                 IRN_PTR => id%IRN_loc
+                 JCN_PTR => id%JCN_loc
+               ENDIF
+               NNZ_TMP = id%KEEP8(29) 
+             ENDIF 
              CALL MUMPS_AB_COORD_TO_LMAT ( id%MYID,
-     &             NBLK, id%N, id%KEEP8(28), IRN_PTR(1), JCN_PTR(1),
+     &             NBLK, id%N, NNZ_TMP, IRN_PTR(1), JCN_PTR(1),
      &             DOF2BLOCK, 
      &             INFO(1), INFO(2), LP, LPOK, 
      &             LMAT_BLOCK, IDUMMY8, KEEP(1) )
@@ -742,7 +779,7 @@ C            symmetrizing the Lmatrix
      &            INFO(1), ICNTL(1), MEMCNT)
              GCOMP_PROVIDED = .TRUE.
              IF (KEEP(494).EQ.0.OR.KEEP(487).NE.1) THEN
-               CALL MUMPS_AB_FREE_LMAT(LMAT_BLOCK)
+               CALL MUMPS_AB_FREE_LMAT(LMAT_BLOCK, KEEP(147))
                LMAT_BLOCK_AVAIL_I = 0
              ELSE
                LMAT_BLOCK_AVAIL_I = 1
@@ -801,7 +838,7 @@ C             Build GCOMP, the centraliz
      &             LUMAT, LUMAT_AVAIL, GCOMP_DIST, READY_FOR_ANA_F)
             ENDIF
             IF (LUMAT_AVAIL.AND.KEEP(487).NE.1) THEN
-               CALL MUMPS_AB_FREE_LMAT(LUMAT)
+               CALL MUMPS_AB_FREE_LMAT(LUMAT, KEEP(147))
                LUMAT_AVAIL = .FALSE.
             ENDIF
 C        
@@ -839,6 +876,8 @@ C     Collect on the host -- if matrix i
 C     at analysis -- all integer information needed
 C     to perform ordering
 C     -----------------------------------------------
+C FIXME: one should test instead if GCOMP_DIST available 
+C        instead of retestinf KEEP(13) and NPROCS.NE.1
           IF (KEEP(13).NE.0) THEN
            IF (id%NPROCS.NE.1) THEN
              CALL MUMPS_AB_GATHER_GRAPH(
@@ -914,14 +953,15 @@ C                Maximum transversal is
 C                entry format
 C              UNS_PERM that might be set to
 C              to permutation computed during Max transversal
-               ALLOCATE(id%UNS_PERM(id%N),IKEEPALLOC(3*id%N),
+               ALLOCATE(id%UNS_PERM(id%N),IKEEPALLOC(3_8*int(id%N,8)),
      &                  WORK2ALLOC(id%N), stat=IERR)
                IF (IERR.GT.0) THEN
                 INFO(1)=-7
-                INFO(2)=5*id%N
+                CALL MUMPS_SET_IERROR( 5_8 * int(id%N,8), INFO(2) )
                ELSE
                 CALL CMUMPS_ANA_O(id%N, id%KEEP8(28), KEEP(23),
-     &              id%UNS_PERM, IKEEPALLOC, id%IRN, id%JCN, id%A,
+     &              id%UNS_PERM, IKEEPALLOC, 3_8*int(id%N,8),
+     &              id%IRN, id%JCN, id%A,
      &              id%ROWSCA, id%COLSCA,
      &              WORK2ALLOC, id%KEEP, id%ICNTL, id%INFO, id%INFOG)
                 IF (allocated(WORK2ALLOC)) DEALLOCATE(WORK2ALLOC)
@@ -966,15 +1006,16 @@ C          be given to ANA_F.
      &               NFSIZPTR(NBLK), stat=IERR)
              IF (IERR.GT.0) THEN
               INFO(1)=-7
-              INFO(2)=3*NBLK
+              CALL MUMPS_SET_IERROR(int(NBLK,8)*3_8, INFO(2))
              ENDIF
            ELSE
-             ALLOCATE(IKEEPALLOC(NBLK+2*id%N), 
+             ALLOCATE(IKEEPALLOC(int(NBLK,8)+2_8*int(id%N,8)), 
      &               FILS_TMP(NBLK), FREREPTR(NBLK),
      &               NFSIZPTR(NBLK), stat=IERR)
             IF (IERR.GT.0) THEN
              INFO(1)=-7
-             INFO(2)=4*NBLK+2*id%N
+             CALL MUMPS_SET_IERROR(int(NBLK,8)*4_8+2_8*int(id%N,8),
+     &            INFO(2))
             ENDIF
            ENDIF
          ENDIF
@@ -1038,19 +1079,20 @@ C
 C                 we suppress supervariable detection when Schur
 C                 is active or when METIS is applied
 C                 Workspaces for FLAG(N), and either LEN(N) or some pointers(N+1)
-                  LIW_ELT = id%N + id%N + 1
+                  LIW8_ELT = int(id%N,8) + int(id%N,8) + 1_8
                ELSE
 C                 Spaces FLAG(N), LEN(N), N+3, SVAR(0:N),
-                  LIW_ELT =  id%N + id%N + id%N + 3 + id%N + 1
+                  LIW8_ELT =  int(id%N,8) + int(id%N,8) +
+     &                       int(id%N,8)+3_8 + int(id%N,8)+1_8
                ENDIF
 C     
             ENDIF
 C           We must ensure that an array of order
 C           3*N is available for CMUMPS_ANA_LNEW
             IF (KEEP(55) .EQ. 0) THEN
-              IF (LIW8.LT.3_8*int(NBLK,8)) LIW8 = 3_8*int(NBLK,8)
+              IF (LIW8.LT.3_8*int(NBLK,8)) LIW8=3_8*int(NBLK,8)
             ELSE
-              IF (LIW_ELT.LT.3*id%N) LIW_ELT = 3*id%N
+              IF (LIW8_ELT.LT.3_8*int(id%N,8)) LIW8_ELT=3_8*int(id%N,8)
             ENDIF
 C
             IF ( KEEP(256) .EQ. 1 ) THEN
@@ -1058,7 +1100,7 @@ C            It has been checked that id
 C            values of pivot order will be checked later and
 C            should be checked here too
 C            PERM_IN( I ) = position of I in the pivot order
-             IKEEP2 => IKEEPALLOC(NBLK+1:NBLK+id%N)
+             IKEEP2 => IKEEPALLOC(int(NBLK+1,8):int(NBLK,8)+int(id%N,8))
 C            Build inverse permutation and check PERM_IN 
              DO I = 1, id%N
                 IKEEP2(I) = 0
@@ -1100,6 +1142,11 @@ C             IKEEP2 holds inverse permu
                   I       = IKEEP2(IPOS)
                   IB      = DOF2BLOCK(I)
                   IF (IB.NE.IBcurrent) THEN
+                   IF (PROKG) THEN
+                    WRITE(MPG,'(A,A)') 
+     &               " ERROR: given permutation (ICNTL(7)=1)",
+     &               " incompatible with block format"
+                   ENDIF
                    INFO(1)= -4
                    INFO(2)= I
                    GOTO 10
@@ -1111,6 +1158,11 @@ C             IKEEP2 holds inverse permu
 C             IF PERM_IN is correct then
 C             on exit last position should be NBLK
               IF (IPOSB.NE.NBLK) THEN
+                   IF (PROKG) THEN
+                    WRITE(MPG,'(A,A)') 
+     &               " ERROR: given permutation (ICNTL(7)=1)",
+     &               " incompatible with block format"
+                   ENDIF
                    INFO(1)= -4
 C                  N+1 to indicate "global" error
                    INFO(2)= id%N+1
@@ -1129,8 +1181,10 @@ C           Initialize structural symmet
             INFOG(8) = -1
             IF (KEEP(55) .EQ. 0) THEN
                IKEEP1 => IKEEPALLOC(1:NBLK)
-               IKEEP2 => IKEEPALLOC(NBLK+1:NBLK+id%N)
-               IKEEP3 => IKEEPALLOC(NBLK+id%N+1:NBLK+2*id%N)
+               IKEEP2 => IKEEPALLOC(int(NBLK+1,8):
+     &                              int(NBLK,8)+int(id%N,8))
+               IKEEP3 => IKEEPALLOC(int(NBLK,8)+int(id%N+1,8):
+     &                              int(NBLK,8)+2_8*int(id%N,8))
 C              id%UNS_PERM corresponds to argument PIV
 C              in CMUMPS_ANA_F, it should be an assumed-shape
 C              array rather than a possibly null pointer:
@@ -1144,7 +1198,8 @@ C              array rather than a possi
      &              id%IRN, id%JCN,
      &              LIW8, IKEEP1, IKEEP2, IKEEP3,
      &              KEEP(256), NFSIZPTR,
-     &              FILS_TMP, FREREPTR,
+     &              FILS_TMP,
+     &              FREREPTR,
      &              id%LISTVAR_SCHUR, SIZE_SCHUR_PASSED,
      &              id%ICNTL, id%INFOG, id%KEEP,id%KEEP8,id%NSLAVES, 
      &              UNS_PERM_PTR,
@@ -1204,7 +1259,7 @@ C     -- internal error
                   GOTO 10
                ENDIF
                CALL CMUMPS_ANA_F_ELT(id%N, NELT,
-     &              id%ELTPTR(1), id%ELTVAR(1), LIW_ELT,
+     &              id%ELTPTR(1), id%ELTVAR(1), LIW8_ELT,
      &              IKEEPALLOC(1),
      &              KEEP(256), NFSIZPTR(1), FILS_TMP(1),
      &              FREREPTR(1), id%LISTVAR_SCHUR(1),
@@ -1238,9 +1293,9 @@ C           ----------------------------
             INFO(2)=INFOG(2)
 C           save statistics in KEEP array.
             KEEP(28) = INFOG(6)
-            IKEEP = 1
-            NA      = IKEEP +     id%N
-            NE      = IKEEP + 2 * id%N
+            IKEEP = 1_8
+            NA      = IKEEP +       int(id%N,8)
+            NE      = IKEEP + 2_8 * int(id%N,8)
 C       -- if (id%myid.eq.master)
         ENDIF
 C       -- if sequential analysis
@@ -1302,24 +1357,34 @@ C{    Parallel analysis
 C             KEEPALLOC reuse later 
 C             FIXME allocate of size 2*NBLK and 
 C                   allocate of size 3*id%N after call ana_aux_par
-              SIZEIKEEPALLOC = 3*id%N
+              SIZEIKEEPALLOC = 3_8*int(id%N,8)
+              SIZEWORK2ALLOC = max(4_8*int(NBLK,8), int(id%NPROCS+1,8))
             ALLOCATE( IKEEPALLOC(SIZEIKEEPALLOC), 
-     &                WORK2ALLOC(max(4*NBLK,id%NPROCS+1)), 
+     &                WORK2ALLOC(SIZEWORK2ALLOC),
      &                FILS_TMP(NBLK), FREREPTR(NBLK), NFSIZPTR(NBLK),
      &      stat=IERR)
          ELSE IF (COMM_PARASYMB.NE.MPI_COMM_NULL) THEN
 C           Allocate only on procs concerned by parallel analysis
-            ALLOCATE(IKEEPALLOC(3*NBLK),WORK2ALLOC(4*NBLK), stat=IERR )
+            SIZEIKEEPALLOC = 3_8*int(NBLK,8)
+            SIZEWORK2ALLOC = 4_8*int(NBLK,8)
+            ALLOCATE(IKEEPALLOC(SIZEIKEEPALLOC),
+     &               WORK2ALLOC(SIZEWORK2ALLOC), stat=IERR )
          ELSE
 C           Not concerned by CMUMPS_ANA_F_PAR
             IERR = 0
+            SIZEIKEEPALLOC = 0_8
+            SIZEWORK2ALLOC = 0_8
          ENDIF
          IF (IERR.GT.0) THEN
            INFO(1) = -7
            IF (id%MYID .EQ. MASTER) THEN
-             INFO( 2 ) = SIZEIKEEPALLOC+7*NBLK
+             CALL MUMPS_SET_IERROR(
+     &            SIZEIKEEPALLOC+SIZEWORK2ALLOC+3_8*int(NBLK,8),
+     &            INFO(2) )
            ELSE
-             INFO( 2 ) = 7*NBLK
+             CALL MUMPS_SET_IERROR(
+     &            SIZEIKEEPALLOC+SIZEWORK2ALLOC,
+     &            INFO(2) )
            ENDIF
          ENDIF
          CALL MUMPS_PROPINFO( ICNTL(1), INFO(1), id%COMM, id%MYID )
@@ -1327,6 +1392,16 @@ C           Not concerned by CMUMPS_ANA_
 C        save value provided by user
          idNBLKSAVE= id%NBLK
 C
+#if defined(MUMPS_NOF2003)
+C        Allocatable not allowed in CMUMPS_ANA_F_PAR,
+C        use a pointer instead. FILS_TMP is typically
+C        allocated only on MPI rank 0.
+         IF (allocated(FILS_TMP)) THEN
+           FILS_TMPPTR => FILS_TMP
+         ELSE
+           FILS_TMPPTR => IDUMMY_ARRAY
+         ENDIF
+#endif
          IF (LUMAT_AVAIL) THEN
 C{
 C             
@@ -1336,18 +1411,24 @@ C
             CALL CMUMPS_ANA_F_PAR(id,
      &        IKEEPALLOC,
      &        WORK2ALLOC,
+     &        SIZEIKEEPALLOC,
+     &        SIZEWORK2ALLOC,
      &        NFSIZPTR,
+#if defined(MUMPS_NOF2003)
+     &        FILS_TMPPTR,
+#else
      &        FILS_TMP,
+#endif
      &        FREREPTR,
      &        COMM_PARASYMB
-!    optionnal:
+!    optional:
      &        , LUMAT, SIZEOFBLOCKS
      &        , COMM_PARAORD, NPROCS_PARAORD
      &        , RKinSYMB_PROC0ORD
      & )
            ENDIF
            IF (KEEP(494).EQ.0.OR.KEEP(487).NE.1) THEN
-            CALL MUMPS_AB_FREE_LMAT(LUMAT)
+            CALL MUMPS_AB_FREE_LMAT(LUMAT,KEEP(147))
             LUMAT_AVAIL = .FALSE.
            ELSE
             LUMAT_AVAIL = .TRUE.
@@ -1360,8 +1441,14 @@ C{         LUMAT not available and COMM_
            CALL CMUMPS_ANA_F_PAR(id,
      &        IKEEPALLOC,
      &        WORK2ALLOC,
+     &        SIZEIKEEPALLOC,
+     &        SIZEWORK2ALLOC,
      &        NFSIZPTR,
+#if defined(MUMPS_NOF2003)
+     &        FILS_TMPPTR,
+#else
      &        FILS_TMP,
+#endif
      &        FREREPTR,
      &        id%COMM
      & )
@@ -1392,9 +1479,9 @@ C        Check error after freeing commu
          IF ( INFO(1) < 0 ) GOTO 500
 C
          IF (id%MYID.EQ.MASTER) THEN
-           IKEEP   = 1
-           NA      = IKEEP +     id%N
-           NE      = IKEEP + 2 * id%N 
+           IKEEP   = 1_8
+           NA      = IKEEP +       int(id%N,8)
+           NE      = IKEEP + 2_8 * int(id%N,8)
          ENDIF
 C        ---------------------------------------------------------
 C        Check whether FILS_TMP, FREREPTR, NFSIZPTR
@@ -1413,7 +1500,7 @@ C              allways copied back in st
           IF (IERR.GT.0) THEN
            INFO(1) = -7
            IF (id%MYID .EQ. MASTER) THEN
-             INFO( 2 ) = 3*id%N
+             CALL MUMPS_SET_IERROR(3_8*int(id%N,8), INFO(2))
            ENDIF
          ENDIF
          CALL MUMPS_PROPINFO( ICNTL(1), INFO(1), id%COMM, id%MYID )
@@ -1530,7 +1617,7 @@ C      peak is set by default to 1 large
      &        real(id%KEEP(2))*real(id%KEEP(2))     ! cb bloc
 C     IKEEP(1:N,1) can be used as a work space since it is set
 C     to its final state by the SORT_PERM subroutine below.
-            SSARBR => IKEEPALLOC(IKEEP:IKEEP+NBLK-1)
+            SSARBR => IKEEPALLOC(IKEEP:IKEEP+int(NBLK-1,8))
 C     ======================================================
 C     Map nodes and assign candidates for dynamic scheduling
 C     ======================================================
@@ -1864,15 +1951,15 @@ C     (the two useful informations for f
          IF (NBLK.eq.1) THEN
             NBROOT = 1
             NBLEAF = 1
-         ELSE IF (IKEEPALLOC(NA+NBLK-1) .LT.0) THEN
+         ELSE IF (IKEEPALLOC(NA+int(NBLK-1,8)) .LT.0) THEN
             NBLEAF= NBLK
             NBROOT= NBLK
-         ELSE IF (IKEEPALLOC(NA+NBLK-2) .LT.0) THEN
+         ELSE IF (IKEEPALLOC(NA+int(NBLK-2,8)) .LT.0) THEN
             NBLEAF = NBLK-1
-            NBROOT = IKEEPALLOC(NA+NBLK-1)
+            NBROOT = IKEEPALLOC(NA+int(NBLK-1,8))
          ELSE
-            NBLEAF = IKEEPALLOC(NA+NBLK-2)
-            NBROOT = IKEEPALLOC(NA+NBLK-1)
+            NBLEAF = IKEEPALLOC(NA+int(NBLK-2,8))
+            NBROOT = IKEEPALLOC(NA+int(NBLK-1,8))
          ENDIF
          id%LNA = 2+NBLEAF+NBROOT
       ENDIF
@@ -1897,26 +1984,26 @@ C        Initialize NA with the leaves a
          IF ( NBLK == 1 ) THEN
             id%NA(LEAF) = 1
             LEAF = LEAF + 1
-         ELSE IF (IKEEPALLOC(NA+NBLK-1) < 0) THEN
-            id%NA(LEAF) = - IKEEPALLOC(NA+NBLK-1)-1
+         ELSE IF (IKEEPALLOC(NA+int(NBLK-1,8)) < 0) THEN
+            id%NA(LEAF) = - IKEEPALLOC(NA+int(NBLK-1,8))-1
             LEAF = LEAF + 1
             DO I = 1, NBLEAF - 1
-               id%NA(LEAF) = IKEEPALLOC(NA+I-1)
+               id%NA(LEAF) = IKEEPALLOC(NA+int(I-1,8))
                LEAF = LEAF + 1
             ENDDO
-         ELSE IF (IKEEPALLOC(NA+NBLK-2) < 0 ) THEN
-            INODE = - IKEEPALLOC(NA+NBLK-2) - 1
+         ELSE IF (IKEEPALLOC(NA+int(NBLK-2,8)) < 0 ) THEN
+            INODE = - IKEEPALLOC(NA+int(NBLK-2,8)) - 1
             id%NA(LEAF) = INODE
             LEAF =LEAF + 1
             IF ( NBLEAF > 1 ) THEN
                DO I = 1, NBLEAF - 1
-                  id%NA(LEAF) = IKEEPALLOC(NA+I-1)
+                  id%NA(LEAF) = IKEEPALLOC(NA+int(I-1,8))
                   LEAF = LEAF + 1
                ENDDO
             ENDIF
          ELSE
             DO I = 1, NBLEAF
-               id%NA(LEAF) = IKEEPALLOC(NA+I-1)
+               id%NA(LEAF) = IKEEPALLOC(NA+int(I-1,8))
                LEAF = LEAF + 1
             ENDDO
          END IF
@@ -1963,8 +2050,8 @@ C        copies to NSTEP array should be
             IF (FREREPTR(I) .NE. NBLK+1) THEN
                id%PROCNODE_STEPS(STEP_TMP(I)) = PROCNODE( I )
                id%FRERE_STEPS(STEP_TMP(I))    = FREREPTR(I)
-               id%NE_STEPS(STEP_TMP(I))    = IKEEPALLOC(NE+I-1)
-               id%ND_STEPS(STEP_TMP(I))    = NFSIZPTR(I)
+               id%NE_STEPS(STEP_TMP(I)) = IKEEPALLOC(NE+int(I-1,8))
+               id%ND_STEPS(STEP_TMP(I)) = NFSIZPTR(I)
             ENDIF
          ENDDO
 C        ===============================
@@ -2039,6 +2126,7 @@ C         Broadcast errors
 C
           CALL MUMPS_INIALIZE_REDIST_LUMAT ( 
      &     id%INFO, id%ICNTL, id%KEEP, id%COMM, id%MYID, NBLK,
+     &     id%NPROCS,
      &     LUMAT, id%PROCNODE_STEPS(1), id%KEEP(28), MAPCOL, 
      &     LUMAT_REMAP, NBRECORDS, STEP_TMP(1))
 C         INFO(1) has been broadcasted already in routine
@@ -2053,7 +2141,7 @@ C         -- Redistribute LUMAT into LU_
      &      LUMAT_REMAP, NBRECORDS, NSEND8, NLOCAL8
      &     )
            LUMAT_REMAP_DIST_AVAIL = .TRUE.
-          CALL MUMPS_AB_FREE_LMAT(LUMAT)
+          CALL MUMPS_AB_FREE_LMAT(LUMAT,KEEP(147))
 C         Distribute SIZEOFBLOCKS that was defined only on master
           CALL MPI_BCAST( SIZEOFBLOCKS, NBLK, MPI_INTEGER, MASTER, 
      &     id%COMM, IERR )
@@ -2062,12 +2150,14 @@ C}
 C{        Centralized matrix and clean LMAT_BLOCK available
 C        
           IF (id%MYID.EQ.MASTER) THEN
+C
            CALL MUMPS_AB_CLEANLMAT_TO_LUMAT ( 
-     &              LMAT_BLOCK, LUMAT_REMAP,
+     &              LMAT_BLOCK, LUMAT_REMAP, KEEP(147),
      &              INFO(1), ICNTL(1))
            LUMAT_REMAP_CENT_AVAIL=.TRUE.
 C            --- LMAT_BLOCK not needed anymore
-           CALL MUMPS_AB_FREE_LMAT(LMAT_BLOCK)
+           CALL MUMPS_AB_FREE_LMAT(LMAT_BLOCK,KEEP(147))
+C
           ENDIF
 C         Broadcast errors
           CALL MUMPS_PROPINFO( ICNTL(1), INFO(1),
@@ -2170,6 +2260,8 @@ C         Broadcast errors
           CALL MUMPS_PROPINFO( ICNTL(1), INFO(1),
      &      id%COMM, id%MYID )
           IF ( INFO(1).LT.0 ) GOTO 500
+          CALL MPI_BCAST( id%ND_STEPS(1), KEEP(28), MPI_INTEGER,
+     &    MASTER, id%COMM, IERR )
           CALL CMUMPS_AB_LR_MPI_GROUPING(NBLK, 
      &           MAPCOL, id%KEEP(28), 
      &           id%KEEP(28), LUMAT_REMAP, FILS_TMP(1), 
@@ -2182,7 +2274,8 @@ C         Broadcast errors
      &           id%KEEP(264), id%KEEP(265), id%KEEP(482), id%KEEP(472),
      &           id%KEEP(127), id%KEEP(469), id%KEEP(10), 
      &           id%KEEP(54), id%KEEP(142), 
-     &           LPOK, LP, id%COMM, id%MYID, id%NPROCS)
+     &           LPOK, LP, id%COMM, id%MYID, id%NPROCS,
+     &           id%KEEP(1), id%ND_STEPS)
           IF (allocated(MAPCOL)) DEALLOCATE(MAPCOL)
           IF (id%MYID.NE.MASTER) DEALLOCATE(FILS_TMP)
 C}
@@ -2204,7 +2297,8 @@ C
      &           id%KEEP(264), id%KEEP(265), id%KEEP(482), id%KEEP(472),
      &           id%KEEP(127), id%KEEP(469), id%KEEP(10), 
      &           id%KEEP(54), id%KEEP(142), 
-     &           LPOK, LP, id%COMM, id%MYID, id%NPROCS)
+     &           LPOK, LP, id%COMM, id%MYID, id%NPROCS,
+     &           id%KEEP(1), id%ND_STEPS)
 C}
             ELSE
 C{           grouping based on centralized matrix
@@ -2221,7 +2315,8 @@ C{           grouping based on centraliz
      &           id%KEEP(264), id%KEEP(265), id%KEEP(482), id%KEEP(472),
      &           id%KEEP(127), id%KEEP(10), 
      &           id%KEEP(54), id%KEEP(142), 
-     &           LPOK, LP, GATHER_MATRIX_ALLOCATED)
+     &           LPOK, LP, GATHER_MATRIX_ALLOCATED, 
+     &           id%KEEP(1), id%ND_STEPS)
              ELSE
                CALL CMUMPS_LR_GROUPING_NEW(id%N, id%KEEP8(28), 
      &           id%KEEP(28), id%IRN,
@@ -2234,7 +2329,8 @@ C{           grouping based on centraliz
      &           id%KEEP(264), id%KEEP(265), id%KEEP(482), id%KEEP(472),
      &           id%KEEP(127), id%KEEP(469), id%KEEP(10), 
      &           id%KEEP(54), id%KEEP(142), 
-     &           LPOK, LP, GATHER_MATRIX_ALLOCATED)
+     &           LPOK, LP, GATHER_MATRIX_ALLOCATED,
+     &           id%KEEP(1), id%ND_STEPS)
              ENDIF
 C}
             ENDIF
@@ -2251,7 +2347,7 @@ C     III/ CLEANUP
 C     ============
 C       Free LUMAT_REMAP if allocated
         IF (LUMAT_REMAP_DIST_AVAIL.OR.LUMAT_REMAP_CENT_AVAIL)
-     &      CALL MUMPS_AB_FREE_LMAT(LUMAT_REMAP)
+     &      CALL MUMPS_AB_FREE_LMAT(LUMAT_REMAP,KEEP(147))
         IF (allocated(MAPCOL)) DEALLOCATE(MAPCOL)
         IF (allocated(SIZEOFBLOCKS)) DEALLOCATE(SIZEOFBLOCKS)
         IF ( (KEEP(54).EQ.3) .AND. (KEEP(244).EQ.2).AND.
@@ -2343,7 +2439,7 @@ C           and update arrays of size NS
      &           ) 
             NULLIFY(PAR2_NODESPTR)
 C
-C
+C         }
           ELSE
 C{           NBLK=N
 C            perform local copies
@@ -2376,6 +2472,17 @@ C          and not used/initialized
           ENDIF
 C}
         ENDIF
+C
+C       -------------------------------------------
+C       Adjust LR_GROUPING to bound size of groups 
+C       and update KEEP(142): maximum group size
+C       -------------------------------------------
+        IF (id%N.GT.NBLK.AND.KEEP(494).NE.0) THEN
+          CALL MUMPS_ADJUST_SIZE_LRGROUPS ( 
+     &     id%STEP(1), id%FILS(1), id%N, 
+     &     id%ND_STEPS(1), id%KEEP(28), id%KEEP(1), 
+     &     id%LRGROUPS(1), INFO(1), INFO(2))
+         ENDIF
 C}
       ENDIF
 C
@@ -2385,6 +2492,7 @@ C
       IF (allocated(LRGROUPS_TMP)) DEALLOCATE(LRGROUPS_TMP)
       IF (allocated(FILS_TMP)) DEALLOCATE(FILS_TMP)
 C
+C
         CALL MUMPS_REALLOC(id%SYM_PERM, id%N, id%INFO, LP, 
      &  FORCE=.TRUE.,
      &  STRING='id%SYM_PERM (Analysis)', ERRCODE=-7)
@@ -3245,11 +3353,11 @@ C           and allocate CANDIDATES
 C           ===================================================
 C     
             IF ( id%root%yes ) THEN
-              LOCAL_M = numroc( id%ND_STEPS(id%STEP(KEEP(38))),
+              LOCAL_M = MUMPS_NUMROC( id%ND_STEPS(id%STEP(KEEP(38))),
      &              id%root%MBLOCK, id%root%MYROW, 0,
      &              id%root%NPROW )
               LOCAL_M = max(1, LOCAL_M)
-              LOCAL_N = numroc( id%ND_STEPS(id%STEP(KEEP(38))),
+              LOCAL_N = MUMPS_NUMROC( id%ND_STEPS(id%STEP(KEEP(38))),
      &              id%root%NBLOCK, id%root%MYCOL, 0,
      &              id%root%NPCOL )
             ELSE
@@ -3627,7 +3735,7 @@ C            Note that RECV buffer shoul
 C            to both PEAK_UNDER_L0 and PEAK_ABOVE_L0
              PEAK_UNDER_L0 = SUM_NRLNEC + MIN_NRLNEC + 
      &        int(
-     &        (REAL(id%N*KEEP(400))*REAL(KEEP(34)))/REAL(KEEP(35)),
+     &        (real(id%N*KEEP(400))*real(KEEP(34)))/real(KEEP(35)),
      &               8)
 C            Estimate send buffer size 
 C            and convert it in nb of reals
@@ -3636,12 +3744,10 @@ C
 C            Convert SUM_NIRNEC SUM_NIRNEC_OOC into nb of reals 
              PEAK_ABOVE_L0 =  KEEP8(53)+ SUM_NRLADU + 
      &            ! SEND buffer
-     &              max ( int( 
-     &              (REAL(SBUF_SEND_FR)*REAL(KEEP(34)))/REAL(KEEP(35))
-     &                     , 8), 100000_8 ) +
+     &            max( int(SBUF_SEND_FR,8),  100000_8) +
      &            ! MAXIS_above :
      &             int( 
-     &              (REAL(KEEP(15))*REAL(KEEP(34)))/REAL(KEEP(35)),
+     &              (real(KEEP(15))*real(KEEP(34)))/real(KEEP(35)),
      &               8)
 C            ===============================================
 C            Update memory peaks:
@@ -3672,7 +3778,7 @@ C            SUM_NIRNEC_OOC under L0 OMP
 C           DKEEP(15) is used for dynamic load balancing only
 C           it corresponds to the number of local operations
 C           (in Millions)
-            id%DKEEP(15)    = RINFO(1)/1000000.0
+            id%DKEEP(15)    = RINFO(1)/1000000.0E0
             IF(ASSOCIATED(locI_AM_CAND)) NULLIFY(locI_AM_CAND)
             id%MAX_SURF_MASTER = KEEP8(15)
 C
@@ -3737,7 +3843,10 @@ C
          UPDATE_BUFFER = .TRUE.
 C
          MIN_BUF_SIZE8 = KEEP8(22) / int(KEEP(238),8)
-         MIN_BUF_SIZE8 = min(MIN_BUF_SIZE8,int(huge(I4),8))
+C        MIN_BUF_SIZE8 is in number of entries of size (KEEP(35) bytes)
+C        and max buffer size in bytes is an integer*4
+         MIN_BUF_SIZE8 = min(MIN_BUF_SIZE8,
+     &                       int(huge(I4),8)/int(KEEP(35),8) )
          MIN_BUF_SIZE  = int( MIN_BUF_SIZE8 )
          IF (UPDATE_BUFFER) THEN
 C          Send buffer 
@@ -3893,7 +4002,7 @@ C     Per compute node factor real space
       CALL MPI_REDUCE( SUM_KEEP811_THIS_NODE, MAX_SUM_KEEP811_THIS_NODE,
      &                 1, MPI_INTEGER8, MPI_MAX, 0, id%COMM, IERR )
       IF (PROKG .AND. PRINT_NODEINFO) THEN
-        WRITE(MPG,'(A,I12)')
+        WRITE(MPG,'(A,I16)')
      &  '    Max. estimated space for factors per compute node       :',
      &  MAX_SUM_KEEP811_THIS_NODE ! * KEEP(35)/1000000_8
       ENDIF
@@ -3956,7 +4065,7 @@ C
            TOTAL_BYTES  = max (TOTAL_BYTES, TOTAL_BYTES_UNDER_L0)
          ENDIF
          IF ( PROK ) THEN
-            WRITE(MP,'(A,I12) ')
+            WRITE(MP,'(A,I16) ')
      & ' Estimated space in MBytes for IC factorization   (INFO(15)):',
      &           TOTAL_MBYTES
          END IF
@@ -3974,11 +4083,11 @@ C
      &     id%INFO(15), id%INFOG(16), IRANK )
       IF ( PROKG ) THEN
        IF (PRINT_MAXAVG) THEN
-         WRITE( MPG,'(A,I12) ')
+         WRITE( MPG,'(A,I16) ')
      & '    Maximum estim. space in Mbytes, IC facto.    (INFOG(16)):',
      &        id%INFOG(16)
        ENDIF
-       WRITE(MPG,'(A,I12) ')
+       WRITE(MPG,'(A,I16) ')
      & '    Total space in MBytes, IC factorization      (INFOG(17)):'
      &        ,id%INFOG(17)
       END IF
@@ -3989,7 +4098,7 @@ C     Per compute node memory informatio
       CALL MPI_REDUCE( SUM_INFO15_THIS_NODE, MAX_SUM_INFO15_THIS_NODE,
      &                 1, MPI_INTEGER, MPI_MAX, 0, id%COMM, IERR )
       IF ( PROKG .AND. PRINT_NODEINFO ) THEN
-        WRITE(MPG,'(A,I12)')
+        WRITE(MPG,'(A,I16)')
      &  '    Max. estim. space per compute node, in MBytes, IC fact  :',
      &  MAX_SUM_INFO15_THIS_NODE
       ENDIF
@@ -4066,11 +4175,11 @@ C
      &     id%INFO(17), id%INFOG(26), IRANK )
       IF ( PROKG  ) THEN
        IF (PRINT_MAXAVG) THEN
-         WRITE( MPG,'(A,I12) ')
+         WRITE( MPG,'(A,I16) ')
      & '    Maximum estim. space in Mbytes, OOC facto.   (INFOG(26)):',
      &        id%INFOG(26)
        ENDIF
-       WRITE(MPG,'(A,I12) ')
+       WRITE(MPG,'(A,I16) ')
      & '    Total space in MBytes,  OOC factorization    (INFOG(27)):'
      &        ,id%INFOG(27)
       END IF
@@ -4080,7 +4189,7 @@ C
       CALL MPI_REDUCE( SUM_INFO17_THIS_NODE, MAX_SUM_INFO17_THIS_NODE,
      &                 1, MPI_INTEGER, MPI_MAX, 0, id%COMM, IERR )
       IF (PROKG .AND. PRINT_NODEINFO) THEN
-        WRITE(MPG,'(A,I12)')
+        WRITE(MPG,'(A,I16)')
      &  '    Max. estim. space per compute node, in MBytes, OOC fact :',
      &  MAX_SUM_INFO17_THIS_NODE
       ENDIF
@@ -4181,9 +4290,9 @@ C     Deallocate allocated working space
       IF (allocated(FLAGGED_LEAVES)) DEALLOCATE(FLAGGED_LEAVES)
       IF (allocated(SIZEOFBLOCKS)) DEALLOCATE(SIZEOFBLOCKS)
       IF (allocated(DOF2BLOCK)) DEALLOCATE(DOF2BLOCK)
-      CALL MUMPS_AB_FREE_LMAT(LMAT_BLOCK)
-      CALL MUMPS_AB_FREE_LMAT(LUMAT)
-      CALL MUMPS_AB_FREE_LMAT(LUMAT_REMAP)
+      CALL MUMPS_AB_FREE_LMAT(LMAT_BLOCK,KEEP(147))
+      CALL MUMPS_AB_FREE_LMAT(LUMAT,KEEP(147))
+      CALL MUMPS_AB_FREE_LMAT(LUMAT_REMAP,KEEP(147))
       CALL MUMPS_AB_FREE_GCOMP(GCOMP, MEMCNT)
       CALL MUMPS_AB_FREE_GCOMP(GCOMP_DIST, MEMCNT)
       IF (INFO(1) .LT. 0) THEN
@@ -4266,7 +4375,11 @@ C     to stat that are incremented such
 C     the number of split nodes:
       id%KEEP(61)=0
       IF (id%MYID.eq.MASTER) THEN
+        id%KEEP(38) = 0 
+        id%KEEP(20) = 0 
+        id%KEEP(401) = 0
         id%KEEP(400) = 0
+        IF (id%ICNTL(48).EQ.1) id%KEEP(401)=1
         IF (id%KEEP(401) .GT. 0) THEN
 !$        id%KEEP(400)=omp_get_max_threads()
           IF ( id%KEEP(400) .EQ. 0 ) THEN
@@ -4274,14 +4387,14 @@ C           Compilation without OMP!
             id%INFO(1)=-58
             id%INFO(2)=0
             IF (LPOK) WRITE(LP,'(A)')
-     &      " FAILURE DETECTED IN ANALYSIS: KEEP(401) requires OpenMP"
+     &      " FAILURE DETECTED IN ANALYSIS: ICNTL(48) requires OpenMP"
             RETURN
           ELSE
-            IF ( PROKG ) THEN
-              WRITE(MPG, '(A,I8,A)')
-     &       'KEEP(401) config at analysis:', id%KEEP(400),
-     &       ' threads expected for multithreaded tree parallelism'
-            END IF
+C            IF ( PROKG ) THEN
+C              WRITE(MPG, '(A,I8,A)')
+C     &       'ICNTL(48) config at analysis:', id%KEEP(400),
+C     &       ' threads expected for multithreaded tree parallelism'
+C            END IF
 C           L0OMP feature is on (possibly with a single thread!)
             IF (id%KEEP(400).EQ.1
      &       ) THEN
@@ -4846,7 +4959,18 @@ C     Save ICNTL(56) (QR) in KEEP(53)
 C     Will be broadcasted to all other
 C     nodes in routine CMUMPS_BDCAST
 C     --------------------------------
-         id%KEEP(53)=0
+         id%KEEP(53) = id%ICNTL(56)
+C     ---------------------------
+C     Possible values are 0..2 
+C     Other values are treated as 0
+C     ------------------------------
+         IF ( id%KEEP(53) .LT. 0 .OR.
+     &        id%KEEP(53) .GE. 2 
+     &      ) THEN
+            id%KEEP(53) = 0
+            IF (PROKG) WRITE(MPG,'(A)')
+     &    ' WARNING: ICNTL(56) treated as if set to 0 '
+         END IF
          IF(id%KEEP(86).EQ.1)THEN
 C     Force the exchange of both the memory and flops information during 
 C     the factorization
@@ -5430,11 +5554,16 @@ C
       INTEGER, TARGET                :: IRN_DUMMY(1), JCN_DUMMY(1)
       INTEGER, POINTER, DIMENSION(:) :: IRN_PASSED, JCN_PASSED
       COMPLEX, POINTER, DIMENSION(:) :: A_PASSED
+      INTEGER              :: MPG
+      LOGICAL              :: PROKG
       PARAMETER( MASTER = 0 )
       I_AM_SLAVE = ( id%MYID .NE. MASTER  .OR.
      &     ( id%MYID .EQ. MASTER .AND.
      &     id%KEEP(46) .EQ. 1 ) )
       I_AM_MASTER = (id%MYID.EQ.MASTER)
+      MPG = id%ICNTL( 3 )
+      PROKG = ( MPG .GT. 0 .and. id%MYID .eq. MASTER )
+      PROKG = (PROKG.AND.(id%ICNTL(4).GE.2))
       NAME_INITIALIZED = id%WRITE_PROBLEM(1:20)
      &     .NE. "NAME_NOT_INITIALIZED"
       BINARY_FORMAT = .FALSE.
@@ -5450,6 +5579,11 @@ C
           BINARY_FORMAT = .TRUE.
         ENDIF
       ENDIF
+      IF (NAME_INITIALIZED.AND.PROKG) THEN
+        WRITE(MPG,'(/A,A/)') 
+     &    " Write input matrix to file, WRITE_PROBLEM= ", 
+     &    id%WRITE_PROBLEM(1:L)
+      ENDIF
 C     Check if RHS should also be dumped
       DUMP_RHS = id%MYID.EQ.MASTER .AND.
      &     associated(id%RHS) .AND. NAME_INITIALIZED
@@ -5740,14 +5874,14 @@ C     then describe binary file content
      &  '%    N,IRN(i),JCN(i): 32 bits',
      &  '%    NNZ: 64 bits'
       ENDIF
-      WRITE(IUNIT,FMT='(A,I12)') '% Matrix order: N=',N
-      WRITE(IUNIT,FMT='(A,I12)') '% Matrix nonzeros: NNZ=',NNZTOT
+      WRITE(IUNIT,FMT='(A,I16)') '% Matrix order: N=',N
+      WRITE(IUNIT,FMT='(A,I16)') '% Matrix nonzeros: NNZ=',NNZTOT
       IF (DUMP_RHS) THEN
         WRITE(IUNIT,FMT='(A)') '%'
         WRITE(IUNIT,FMT='(A,/,A,I10,A,I5)')
      &  '% A RHS was also written to disk by columns in binary form.',
      &  '%    Size: N rows x NRHS columns with N=',N,'  NRHS=',NRHS
-        WRITE(IUNIT,FMT='(A,I12,A)')
+        WRITE(IUNIT,FMT='(A,I16,A)')
      &  '%    Total:',int(N,8)*int(NRHS,8),' scalar values.'
         WRITE(IUNIT,'(A)') '%    Single complex storage'
       ENDIF
diff -pruN 5.6.2-2.1/src/cana_lr.F 5.7.1-1/src/cana_lr.F
--- 5.6.2-2.1/src/cana_lr.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/cana_lr.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -65,10 +65,12 @@ C
       ENDIF 
       if(allocated(BIG_CUT)) DEALLOCATE(BIG_CUT)
       END SUBROUTINE GET_CUT
-      SUBROUTINE SEP_GROUPING(NV, VLIST, N, NZ, LRGROUPS, NBGROUPS, IW, 
+      SUBROUTINE SEP_GROUPING( NFRONT, KEEP,
+     &   NV, VLIST, N, NZ, LRGROUPS, NBGROUPS, IW, 
      &   LW, IPE, LEN, GROUP_SIZE, HALO_DEPTH, TRACE, WORKH, NODE,
      &   GEN2HALO, K482, K472, K469, SEP_SIZE, MAXSIZE_PARTS,
      &   KEEP10, LP, LPOK, IFLAG, IERROR)
+        INTEGER, INTENT(IN)    :: NFRONT, KEEP(500)
         INTEGER(8), INTENT(IN) :: NZ, LW
         INTEGER, INTENT(IN)    :: NV, N, GROUP_SIZE, HALO_DEPTH
         INTEGER, INTENT(IN)    :: IW(LW), LEN(N), NODE, K482
@@ -84,7 +86,7 @@ C
         INTEGER(8), ALLOCATABLE, DIMENSION(:) :: IPTRHALO
         INTEGER,    ALLOCATABLE, DIMENSION(:) :: PARTS, JCNHALO
         INTEGER(8) :: HALOEDGENBR
-        INTEGER    :: NHALO,
+        INTEGER    :: NHALO, NBG_CAPT,
      &       NBGROUPS_KWAY, I, GROUP_SIZE2, LRGROUPS_SIGN, IERR
         INTEGER    :: MAXSIZE_PARTS_LOC
 #if defined (metis) || defined (parmetis) || defined (metis4) || defined (parmetis3)
@@ -93,7 +95,8 @@ C
 #if defined (scotch) || defined (ptscotch)
         INTEGER :: SCOTCH_IDX_SIZE
 #endif
-        CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NV)
+        CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NV, 
+     &                       NFRONT, KEEP(35))
         NBGROUPS_KWAY = MAX(
      &                INT(real(NV+GROUP_SIZE2-1)/real(GROUP_SIZE2))
      &                ,1)
@@ -187,7 +190,7 @@ C
                WRITE(LP,*) " Internal error in SCOTCH during ",
      &                     " Kway partitioning, SCOTCHFGRAPHPART, " 
                WRITE(LP,*) 
-     &         " also provide METIS package to MUMPS "
+     &         " please also provide METIS package to MUMPS "
              ENDIF
 #endif
           ELSE
@@ -197,16 +200,17 @@ C
           IF (IFLAG.LT.0) GOTO 500
           CALL GET_GLOBAL_GROUPS(PARTS, VLIST, NV, 
      &     NBGROUPS_KWAY, LRGROUPS, N, NBGROUPS, LRGROUPS_SIGN,
-     &     MAXSIZE_PARTS_LOC)
+     &     MAXSIZE_PARTS_LOC, .FALSE., GROUP_SIZE2)
            MAXSIZE_PARTS = max(MAXSIZE_PARTS, MAXSIZE_PARTS_LOC)
         ELSE 
           MAXSIZE_PARTS = max(MAXSIZE_PARTS,NV)
-!$OMP CRITICAL(lrgrouping_cri)
+!$OMP ATOMIC CAPTURE
+          NBG_CAPT = NBGROUPS
+          NBGROUPS = NBGROUPS + 1
+!$OMP END ATOMIC 
           DO I=1,NV
-            LRGROUPS(VLIST(I)) = LRGROUPS_SIGN*(NBGROUPS + 1)
+            LRGROUPS(VLIST(I)) = LRGROUPS_SIGN*(NBG_CAPT + 1)
           END DO
-            NBGROUPS = NBGROUPS + 1
-!$OMP END CRITICAL(lrgrouping_cri)
         END IF
   500   IF (allocated(IPTRHALO)) then
            DEALLOCATE(IPTRHALO)
@@ -219,11 +223,13 @@ C
         ENDIF
         RETURN
       END SUBROUTINE SEP_GROUPING
-      SUBROUTINE SEP_GROUPING_AB (NV, NVEXPANDED, 
+      SUBROUTINE SEP_GROUPING_AB ( NFRONT, KEEP,
+     &   NV, NVEXPANDED, 
      &   VLIST, N, LRGROUPS, NBGROUPS, LUMAT, SIZEOFBLOCKS,
      &   GROUP_SIZE, HALO_DEPTH, TRACE, WORKH, NODE,
      &   GEN2HALO, K482, K472, K469, SEP_SIZE, MAXSIZE_PARTS,
      &   KEEP10, LP, LPOK, IFLAG, IERROR)
+        INTEGER, INTENT(IN)    :: NFRONT, KEEP(500)
         TYPE(LMATRIX_T)        :: LUMAT
         INTEGER, INTENT(IN)    :: NV, NVEXPANDED, 
      &                            N, GROUP_SIZE, HALO_DEPTH
@@ -241,17 +247,20 @@ C
         INTEGER,    ALLOCATABLE, DIMENSION(:) :: PARTS, JCNHALO
         INTEGER,    ALLOCATABLE, DIMENSION(:) :: VWGT
         INTEGER(8) :: HALOEDGENBR
-        INTEGER    :: NHALO,
+        INTEGER    :: NHALO, NBG_CAPT,
      &       NBGROUPS_KWAY, I, GROUP_SIZE2, LRGROUPS_SIGN, IERR
         INTEGER    :: MAXSIZE_PARTS_LOC
         REAL       :: COMPRESS_RATIO
+        LOGICAL    :: AB_ACTIVE
 #if defined (metis) || defined (parmetis) || defined (metis4) || defined (parmetis3)
         INTEGER :: METIS_IDX_SIZE
 #endif
 #if defined (scotch) || defined (ptscotch)
         INTEGER :: SCOTCH_IDX_SIZE
 #endif
-        CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NVEXPANDED)
+       AB_ACTIVE = (NVEXPANDED.GT.NV)
+        CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NVEXPANDED,
+     &                       NFRONT, KEEP(35))
         COMPRESS_RATIO= real(NVEXPANDED)/real(NV)
         NBGROUPS_KWAY = MAX(
      &          INT(real(NVEXPANDED+GROUP_SIZE2-1)/real(GROUP_SIZE2))
@@ -365,17 +374,18 @@ C
           IF (IFLAG.LT.0) GOTO 500
           CALL GET_GLOBAL_GROUPS(PARTS,VLIST, NV, 
      &     NBGROUPS_KWAY, LRGROUPS, N, NBGROUPS, LRGROUPS_SIGN,
-     &     MAXSIZE_PARTS_LOC)
+     &     MAXSIZE_PARTS_LOC, AB_ACTIVE, GROUP_SIZE2)
            MAXSIZE_PARTS = max( MAXSIZE_PARTS, 
      &                   int(real(MAXSIZE_PARTS_LOC*COMPRESS_RATIO))  )
         ELSE 
           MAXSIZE_PARTS = max(MAXSIZE_PARTS,NV)
-!$OMP CRITICAL(lrgrouping_cri)
+!$OMP ATOMIC CAPTURE
+          NBG_CAPT = NBGROUPS
+          NBGROUPS = NBGROUPS + 1
+!$OMP END ATOMIC 
           DO I=1,NV
-            LRGROUPS(VLIST(I)) = LRGROUPS_SIGN*(NBGROUPS + 1)
+            LRGROUPS(VLIST(I)) = LRGROUPS_SIGN*(NBG_CAPT + 1)
           END DO
-            NBGROUPS = NBGROUPS + 1
-!$OMP END CRITICAL(lrgrouping_cri)
         END IF
   500   IF (allocated(IPTRHALO)) then
            DEALLOCATE(IPTRHALO)
@@ -495,9 +505,10 @@ C
       END SUBROUTINE GETHALOGRAPH_AB
       SUBROUTINE GET_GLOBAL_GROUPS(PARTS, SEP, NSEP, NPARTS, 
      &                    LRGROUPS, N, NBGROUPS, LRGROUPS_SIGN,
-     &                    MAXSIZE_PARTS_LOC)
-      INTEGER,INTENT(IN) :: NSEP, N, LRGROUPS_SIGN
+     &                    MAXSIZE_PARTS_LOC, AB_ACTIVE, GROUP_SIZE2)
+      INTEGER,INTENT(IN) :: NSEP, N, LRGROUPS_SIGN, GROUP_SIZE2
       INTEGER :: PARTS(:)
+      LOGICAL :: AB_ACTIVE
       INTEGER,DIMENSION(:),INTENT(INOUT) :: SEP 
       INTEGER, INTENT(INOUT) :: NPARTS 
       INTEGER, INTENT(INOUT) :: NBGROUPS
@@ -506,7 +517,7 @@ C
       INTRINSIC maxval
       INTEGER:: I,CNT,NB_PARTS_WITHOUT_SEP_NODE,allocok
       INTEGER:: TARGET_SIZE_KWAY
-      INTEGER:: MAXSIZE_PARTS_LOC_NEW
+      INTEGER:: MAXSIZE_PARTS_LOC_NEW, NBG_CAPT
       INTEGER,DIMENSION(:),ALLOCATABLE::SIZES, RIGHTPART
       INTEGER,DIMENSION(:),ALLOCATABLE::PARTPTR
 #if ! defined(NO_SPLIT_IN_BLRGROUPING)
@@ -522,8 +533,9 @@ C
          write(*,*) "Allocation error in GET_GLOBAL_GROUPS"
          CALL MUMPS_ABORT()
       ENDIF
-      TARGET_SIZE_KWAY  = (NSEP+NPARTS-1) / NPARTS
-      TARGET_SIZE_SPLIT = 2*TARGET_SIZE_KWAY
+      TARGET_SIZE_KWAY  = GROUP_SIZE2
+      TARGET_SIZE_SPLIT = TARGET_SIZE_KWAY
+      IF (AB_ACTIVE) TARGET_SIZE_SPLIT =huge(TARGET_SIZE_SPLIT)
       NB_PARTS_WITHOUT_SEP_NODE = 0
       RIGHTPART     = 0
       SIZES = 0
@@ -549,16 +561,17 @@ C
 #if ! defined(NO_SPLIT_IN_BLRGROUPING)
        IF (MAXSIZE_PARTS_LOC.LT.TARGET_SIZE_SPLIT) THEN
 #endif
-!$OMP    CRITICAL(lrgrouping_cri)
+!$OMP ATOMIC CAPTURE
+         NBG_CAPT = NBGROUPS
+         NBGROUPS = NBGROUPS + NPARTS
+!$OMP END ATOMIC 
          DO I=1,NSEP
           NEWSEP(PARTPTR(PARTS(I))) = SEP(I)  
           LRGROUPS(SEP(I)) = LRGROUPS_SIGN*(RIGHTPART(PARTS(I)) 
-     &      + NBGROUPS)
+     &      + NBG_CAPT)
           PARTPTR(PARTS(I)) = 
      &      PARTPTR(PARTS(I)) + 1
          END DO
-         NBGROUPS = NBGROUPS + NPARTS
-!$OMP    END CRITICAL(lrgrouping_cri)
          SEP = NEWSEP
 #if ! defined(NO_SPLIT_IN_BLRGROUPING)
       ELSE
@@ -572,9 +585,23 @@ C
          DO I=2,NPARTS+1
            PARTPTR(I) = PARTPTR(I-1) + SIZES(I-1)
          ENDDO
-         NB_PARTS_WITH_SPLIT = 0
+         NB_PARTS_WITH_SPLIT   = 0
          MAXSIZE_PARTS_LOC_NEW = 0
-!$OMP    CRITICAL(lrgrouping_cri)
+         DO IP =1, NPARTS
+           NB_SPLIT =   (SIZES(IP) + TARGET_SIZE_SPLIT-1) 
+     &                    / TARGET_SIZE_SPLIT
+           SZ_FINAL     = (SIZES(IP) + NB_SPLIT-1) / NB_SPLIT 
+           NB_PARTS_WITH_SPLIT = NB_PARTS_WITH_SPLIT +
+     &      ( 
+     &         ( (PARTPTR(IP+1) - PARTPTR(IP))+ SZ_FINAL-1 ) /
+     &          SZ_FINAL
+     &      )
+         ENDDO
+!$OMP ATOMIC CAPTURE
+         NBG_CAPT = NBGROUPS
+         NBGROUPS = NBGROUPS + NB_PARTS_WITH_SPLIT
+!$OMP END ATOMIC 
+         NB_PARTS_WITH_SPLIT = 0
          DO IP=1,NPARTS
            NB_SPLIT =   (SIZES(IP) + TARGET_SIZE_SPLIT-1) 
      &                    / TARGET_SIZE_SPLIT
@@ -585,12 +612,10 @@ C
              NB_PARTS_WITH_SPLIT = NB_PARTS_WITH_SPLIT +1
              DO II=I, min(I+SZ_FINAL-1,PARTPTR(IP+1)-1)
                LRGROUPS(SEP(II)) = LRGROUPS_SIGN*(NB_PARTS_WITH_SPLIT
-     &                           + NBGROUPS)
+     &                           + NBG_CAPT)
              ENDDO
            ENDDO
          ENDDO
-         NBGROUPS = NBGROUPS + NB_PARTS_WITH_SPLIT
-!$OMP    END CRITICAL(lrgrouping_cri)
          NPARTS = NB_PARTS_WITH_SPLIT
          MAXSIZE_PARTS_LOC = MAXSIZE_PARTS_LOC_NEW
       ENDIF
@@ -787,7 +812,8 @@ C
      &     LRGROUPS, SYM, ICNTL, HALO_DEPTH, GROUP_SIZE, SEP_SIZE,
      &     K38, K20, K60,
      &     IFLAG, IERROR, K264, K265, K482, K472, MAXFRONT, K10, 
-     &     K54, K142, LPOK, LP, GATHER_MATRIX_ALLOCATED)
+     &     K54, K142, LPOK, LP, GATHER_MATRIX_ALLOCATED,
+     &     KEEP, ND_STEPS)
       IMPLICIT NONE
       INTEGER, INTENT(IN)    :: N, NSTEPS, LNA, SYM,
      &     HALO_DEPTH, SEP_SIZE, GROUP_SIZE
@@ -804,6 +830,7 @@ C
       INTEGER             :: FILS(N), STEP(N), LRGROUPS(N)
       INTEGER, INTENT(IN)    :: K472, MAXFRONT
       LOGICAL, INTENT(INOUT) :: GATHER_MATRIX_ALLOCATED
+      INTEGER, INTENT(IN) :: KEEP(500), ND_STEPS(:)
       INTEGER :: K482_LOC, K38ou20
       INTEGER :: I, F, PV, NV, NLEAVES, NROOTS, PP, C, NF, NODE,
      &     SYMTRY, NBQD, AD
@@ -914,7 +941,8 @@ C
             WORK(NV) = F
             F = FILS(F)
          END DO
-         CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NV)
+         CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NV,
+     &                        ND_STEPS(NODE), KEEP(35))
          IF (NV .GE. GROUP_SIZE2)  THEN
            IF ( (K482_LOC.EQ.3)
      &           .OR.
@@ -926,7 +954,8 @@ C
                END DO
                NBGROUPS = NBGROUPS + (NV-1)/GROUP_SIZE2 + 1
             ELSE
-              CALL SEP_GROUPING(NV, WORK(1), N, NZ8,
+              CALL SEP_GROUPING( ND_STEPS(NODE), KEEP, 
+     &              NV, WORK(1), N, NZ8,
      &              LRGROUPS, NBGROUPS, IW(1), LW, IPE(1), LEN(1),
      &              GROUP_SIZE, HALO_DEPTH, TRACE(1), WORKH(1), NODE,
      &              GEN2HALO(1), K482_LOC, K472, 0, SEP_SIZE, K142,
@@ -986,7 +1015,8 @@ C
      &     FRERE_STEPS, DAD_STEPS, STEP, NA, LNA, LRGROUPS, 
      &     SYM, ICNTL, HALO_DEPTH, GROUP_SIZE, SEP_SIZE, K38, K20,
      &     K60, IFLAG, IERROR, K264, K265, K482, K472, MAXFRONT, K469, 
-     &     K10, K54, K142, LPOK, LP, GATHER_MATRIX_ALLOCATED)
+     &     K10, K54, K142, LPOK, LP, GATHER_MATRIX_ALLOCATED,
+     &     KEEP, ND_STEPS)
       IMPLICIT NONE
       INTEGER, INTENT(IN)    :: N, NSTEPS, LNA, SYM,
      &     HALO_DEPTH, SEP_SIZE, GROUP_SIZE
@@ -1003,12 +1033,13 @@ C
       INTEGER, INTENT(IN) :: K472, K469
       LOGICAL, INTENT(INOUT) :: GATHER_MATRIX_ALLOCATED
       INTEGER, INTENT(OUT)   :: K142
+      INTEGER, INTENT(IN) :: KEEP(500), ND_STEPS(:)
       INTEGER :: K482_LOC,  K469_LOC, K38ou20
       INTEGER :: I, F, PV, NV, NODE,
      &     SYMTRY, NBQD, AD
       LOGICAL :: PVSCHANGED
       INTEGER(8) :: LW, IWFR, NRORM, NIORM
-      INTEGER :: NBGROUPS, NBGROUPS_local
+      INTEGER :: NBGROUPS, NBGROUPS_local, NBG_CAPT
       INTEGER, ALLOCATABLE, DIMENSION (:) :: PVS, WORK
       INTEGER, ALLOCATABLE, DIMENSION (:) :: LEN, IW
       INTEGER(8), ALLOCATABLE, DIMENSION (:) :: IPE, IQ
@@ -1125,7 +1156,7 @@ C
       PVSCHANGED = .FALSE.
       OMP_NUM = 1
 !$    OMP_NUM = omp_get_max_threads()
-      OMP_NUM = min(OMP_NUM,8)
+      OMP_NUM = min(OMP_NUM,5)
 !$OMP PARALLEL PRIVATE(I, NODE, PV, NV, F, GROUP_SIZE2, WORK, IERR_PRIV,
 !$OMP&         WORKH_PRV, TRACE_PRV, GEN2HALO_PRV, NBGROUPS_local
 !$OMP&         )
@@ -1183,28 +1214,34 @@ C
           WORK(NV) = F
           F = FILS(F)
         END DO
-        CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NV)
-        IF (NV .GE. GROUP_SIZE2)  THEN
+        CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NV,
+     &                        ND_STEPS(NODE), KEEP(35))
+        IF (NV .GE. GROUP_SIZE2
+     &     .AND. NV.GE.int(dble(SEP_SIZE)*dble(1.5))
+     &      )  THEN
           IF ( (K482_LOC.EQ.3)
      &           .OR.
      &         ( (K60.NE.0).AND.(WORK(1).EQ.K38ou20) )
      &        ) 
      &    THEN
-!$OMP CRITICAL(lrgrouping_cri)
+!$OMP ATOMIC CAPTURE
+            NBG_CAPT = NBGROUPS
+            NBGROUPS = NBGROUPS + (NV-1)/GROUP_SIZE2 + 1
+!$OMP END ATOMIC 
             DO I=1,NV
-              LRGROUPS(WORK(I))=NBGROUPS+1+(I-1)/GROUP_SIZE2
+              LRGROUPS(WORK(I))=NBG_CAPT+1+(I-1)/GROUP_SIZE2
             END DO
-            NBGROUPS = NBGROUPS + (NV-1)/GROUP_SIZE2 + 1
-!$OMP END CRITICAL(lrgrouping_cri)
           ELSE
             IF (K469_LOC .EQ. 2) THEN
-              CALL SEP_GROUPING(NV, WORK(1), N, NZ8,
+              CALL SEP_GROUPING( ND_STEPS(NODE), KEEP,
+     &              NV, WORK(1), N, NZ8,
      &              LRGROUPS, NBGROUPS, IW(1), LW, IPE(1), LEN(1),
      &              GROUP_SIZE, HALO_DEPTH, TRACE_PRV, WORKH_PRV, 
      &              NODE, GEN2HALO_PRV, K482_LOC, K472, K469_LOC, 
      &              SEP_SIZE, K142, K10, LP, LPOK, IFLAG, IERROR)
             ELSE
-              CALL SEP_GROUPING(NV, WORK(1), N, NZ8,
+              CALL SEP_GROUPING( ND_STEPS(NODE), KEEP,
+     &              NV, WORK(1), N, NZ8,
      &              LRGROUPS, NBGROUPS, IW(1), LW, IPE(1), LEN(1),
      &              GROUP_SIZE, HALO_DEPTH, TRACE, WORKH, 
      &              NODE, GEN2HALO, K482_LOC, K472, K469_LOC, 
@@ -1232,10 +1269,10 @@ C
             ENDDO
           ENDIF
         ELSE
-!$OMP CRITICAL(lrgrouping_cri)
+!$OMP ATOMIC CAPTURE
           NBGROUPS = NBGROUPS + 1
           NBGROUPS_local = NBGROUPS
-!$OMP END CRITICAL(lrgrouping_cri)
+!$OMP END ATOMIC 
           IF (NV .GE. SEP_SIZE) THEN
             DO I = 1, NV
               LRGROUPS( WORK(I) ) = NBGROUPS_local
@@ -1306,7 +1343,8 @@ C
      &     SEP_SIZE, K38, K20,
      &     K60, IFLAG, IERROR, K264, K265, K482, K472, MAXFRONT, K469, 
      &     K10, K54, K142, LPOK, LP, 
-     &     COMM, MYID, NPROCS_ARG
+     &     COMM, MYID, NPROCS_ARG,
+     &     KEEP, ND_STEPS
      &     )
       IMPLICIT NONE
       INCLUDE 'mpif.h'
@@ -1331,13 +1369,14 @@ C
       INTEGER             :: FILS(N), STEP(N), LRGROUPS(N)
       INTEGER, INTENT(IN) :: SIZEOFBLOCKS(N)
       INTEGER, INTENT(IN) :: K472, K469
+      INTEGER, INTENT(IN) :: KEEP(500), ND_STEPS(:)
       INTEGER :: NPROCS
       INTEGER :: K482_LOC,  K469_LOC, K38ou20, K142_GLOB
       INTEGER :: I, F, PV, NV, NVEXPANDED, NODE
       REAL    :: COMPRESS_RATIO
       LOGICAL :: PVSCHANGED
       INTEGER :: PVSCHANGED_INT, PVSCHANGED_INT_GLOB, IPROC
-      INTEGER :: NBGROUPS, NBGROUPS_local 
+      INTEGER :: NBGROUPS, NBGROUPS_local, NBG_CAPT
       INTEGER, ALLOCATABLE, DIMENSION (:) :: PVS, WORK
       INTEGER :: NBGROUPS_sent
       INTEGER :: NBNODES_LOC, SIZE_SENT, ISHIFT, 
@@ -1347,7 +1386,7 @@ C
       INTEGER, ALLOCATABLE, DIMENSION (:) :: TRACE_PRV, WORKH_PRV, 
      &                                   GEN2HALO_PRV
       INTEGER :: STEP_SCALAPACK_ROOT
-      INTEGER :: GROUP_SIZE2, IERR, OMP_NUM
+      INTEGER :: GROUP_SIZE2, GROUP_SIZE2_TMP, IERR, OMP_NUM
       INTEGER :: IERR_PRIV 
       LOGICAL :: MAPCOL_PROVIDED
 #if defined(ptscotch) || defined(scotch)     
@@ -1453,10 +1492,10 @@ C
       PVSCHANGED = .FALSE.
       OMP_NUM = 1
 !$    OMP_NUM = omp_get_max_threads()
-      OMP_NUM = min(OMP_NUM,8)
+      OMP_NUM = min(OMP_NUM,5)
 !$OMP PARALLEL PRIVATE(I, NODE, PV, NV, F, GROUP_SIZE2, WORK, IERR_PRIV,
 !$OMP&         WORKH_PRV, TRACE_PRV, GEN2HALO_PRV, NBGROUPS_local,
-!$OMP&         NVEXPANDED, COMPRESS_RATIO, IPROC
+!$OMP&         NVEXPANDED, COMPRESS_RATIO, IPROC, GROUP_SIZE2_TMP
 !$OMP&         )
 !$OMP&         REDUCTION( max : K142)
 !$OMP&         IF (K469_LOC.GT.1) NUM_THREADS(OMP_NUM)
@@ -1522,29 +1561,37 @@ C
           F = FILS(F)
         END DO
         COMPRESS_RATIO = real(NVEXPANDED)/real(NV)
-        CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NVEXPANDED)
-        IF (NVEXPANDED .GE. GROUP_SIZE2)  THEN
+        CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NVEXPANDED,
+     &                        ND_STEPS(NODE), KEEP(35))
+        IF (NVEXPANDED .GE. GROUP_SIZE2
+     &     .AND. NVEXPANDED.GE.int(dble(SEP_SIZE)*dble(1.5))
+     &     )  THEN
           IF ( (K482_LOC.EQ.3)
      &           .OR.
      &         ( (K60.NE.0).AND.(WORK(1).EQ.K38ou20) )
      &        ) 
      &    THEN
-            GROUP_SIZE2 = max(int(real(GROUP_SIZE2)/COMPRESS_RATIO), 1)
-!$OMP CRITICAL(lrgrouping_cri)
+            GROUP_SIZE2_TMP = GROUP_SIZE2
+            GROUP_SIZE2_TMP = max( int(real(GROUP_SIZE2_TMP)
+     &                             /COMPRESS_RATIO), 1)
+!$OMP ATOMIC CAPTURE
+          NBG_CAPT = NBGROUPS
+          NBGROUPS = NBGROUPS + (NV-1)/GROUP_SIZE2_TMP + 1
+!$OMP END ATOMIC 
             DO I=1,NV
-              LRGROUPS(WORK(I))=NBGROUPS+1+(I-1)/GROUP_SIZE2
+              LRGROUPS(WORK(I))=NBG_CAPT+1+(I-1)/GROUP_SIZE2_TMP
             END DO
-            NBGROUPS = NBGROUPS + (NV-1)/GROUP_SIZE2 + 1
-!$OMP END CRITICAL(lrgrouping_cri)
           ELSE
             IF (K469_LOC .EQ. 2) THEN
-              CALL SEP_GROUPING_AB(NV, NVEXPANDED, WORK(1), N, 
+              CALL SEP_GROUPING_AB(  ND_STEPS(NODE), KEEP,
+     &              NV, NVEXPANDED, WORK(1), N, 
      &              LRGROUPS, NBGROUPS, LUMAT, SIZEOFBLOCKS,
      &              GROUP_SIZE, HALO_DEPTH, TRACE_PRV, WORKH_PRV, 
      &              NODE, GEN2HALO_PRV, K482_LOC, K472, K469_LOC, 
      &              SEP_SIZE, K142, K10, LP, LPOK, IFLAG, IERROR)
             ELSE
-              CALL SEP_GROUPING_AB(NV, NVEXPANDED, WORK(1), N, 
+              CALL SEP_GROUPING_AB(  ND_STEPS(NODE), KEEP,
+     &              NV, NVEXPANDED, WORK(1), N, 
      &              LRGROUPS, NBGROUPS, LUMAT, SIZEOFBLOCKS,
      &              GROUP_SIZE, HALO_DEPTH, TRACE, WORKH, 
      &              NODE, GEN2HALO, K482_LOC, K472, K469_LOC, 
diff -pruN 5.6.2-2.1/src/cana_mtrans.F 5.7.1-1/src/cana_mtrans.F
--- 5.6.2-2.1/src/cana_mtrans.F	2023-10-11 09:37:10.000000000 +0000
+++ 5.7.1-1/src/cana_mtrans.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/cana_reordertree.F 5.7.1-1/src/cana_reordertree.F
--- 5.6.2-2.1/src/cana_reordertree.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/cana_reordertree.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -26,8 +26,6 @@ C
       INTEGER INFO(80)
       INTEGER SLAVEF,PROCNODE(NSTEPS)
       INTEGER :: SBTR_WHICH_M
-      EXTERNAL MUMPS_PROCNODE
-      INTEGER MUMPS_PROCNODE
       REAL PEAK
       REAL, DIMENSION(:), ALLOCATABLE :: COST_TRAV
       INTEGER, DIMENSION (:), ALLOCATABLE :: DEPTH
diff -pruN 5.6.2-2.1/src/carrowheads.F 5.7.1-1/src/carrowheads.F
--- 5.6.2-2.1/src/carrowheads.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/carrowheads.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -185,10 +185,8 @@ C
       INTEGER    :: INTARR( LINTARR )
       COMPLEX    :: DBLARR( LDBLARR )
       COMPLEX    :: A( LA )
-      INTEGER MUMPS_PROCNODE, MUMPS_TYPENODE, numroc, 
-     &        MUMPS_TYPESPLIT
-      EXTERNAL MUMPS_PROCNODE, MUMPS_TYPENODE, numroc, 
-     &        MUMPS_TYPESPLIT
+      INTEGER MUMPS_TYPESPLIT
+      EXTERNAL MUMPS_TYPESPLIT
       INTEGER LP
       LOGICAL LPOK
       COMPLEX VAL, VAL_SHR
@@ -767,8 +765,6 @@ C
       PARAMETER(MASTER=0)
       INTEGER :: IERR
       INTEGER :: STATUS(MPI_STATUS_SIZE)
-      INTEGER numroc
-      EXTERNAL numroc
       TYPE_PARALL = KEEP(46)
       LP = ICNTL(1)
       LPOK = ( LP .GT. 0 .AND. ICNTL(4) .GE. 1 )
@@ -995,11 +991,11 @@ C
       INTEGER,    INTENT(OUT) :: LOCAL_M, LOCAL_N
       INTEGER(8), INTENT(OUT) :: PTR_ROOT
       INTEGER(8), INTENT(IN)  :: LA
-      INTEGER, EXTERNAL :: numroc
-      LOCAL_M = numroc( root%ROOT_SIZE, root%MBLOCK,
+      INTEGER, EXTERNAL :: MUMPS_NUMROC
+      LOCAL_M = MUMPS_NUMROC( root%ROOT_SIZE, root%MBLOCK,
      &         root%MYROW, 0, root%NPROW )
       LOCAL_M = max( 1, LOCAL_M )
-      LOCAL_N = numroc( root%ROOT_SIZE, root%NBLOCK,
+      LOCAL_N = MUMPS_NUMROC( root%ROOT_SIZE, root%NBLOCK,
      &         root%MYCOL, 0, root%NPCOL )
       PTR_ROOT = LA - int(LOCAL_M,8) * int(LOCAL_N,8) + 1_8
       RETURN
diff -pruN 5.6.2-2.1/src/cbcast_int.F 5.7.1-1/src/cbcast_int.F
--- 5.6.2-2.1/src/cbcast_int.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/cbcast_int.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/cend_driver.F 5.7.1-1/src/cend_driver.F
--- 5.6.2-2.1/src/cend_driver.F	2023-10-11 09:37:10.000000000 +0000
+++ 5.7.1-1/src/cend_driver.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -323,9 +323,9 @@ C     Allocated at analysis:
         ENDIF
 !     ENDIF
 C     Allocated at analysis:
-      IF (associated(id%MPITOOMP_PROCS_MAP)) THEN
-        DEALLOCATE(id%MPITOOMP_PROCS_MAP)
-        NULLIFY(id%MPITOOMP_PROCS_MAP)
+      IF (associated(id%MTKO_PROCS_MAP)) THEN
+        DEALLOCATE(id%MTKO_PROCS_MAP)
+        NULLIFY(id%MTKO_PROCS_MAP)
       ENDIF
 C     Allocated at analysis:
       IF (associated(id%IPOOL_B_L0_OMP)) THEN
@@ -514,6 +514,16 @@ C     (this includes suppression of OOC
         DEALLOCATE(id%PIVNUL_LIST)
         NULLIFY(id%PIVNUL_LIST)
       ENDIF
+      IF (associated(id%ROWSCA_loc)) THEN
+        DEALLOCATE(id%ROWSCA_loc)
+        NULLIFY(id%ROWSCA_loc)
+      ENDIF
+      IF (id%KEEP(50) .EQ. 0) THEN
+        IF (associated(id%COLSCA_loc)) THEN
+          DEALLOCATE(id%COLSCA_loc)
+        ENDIF
+      ENDIF
+      NULLIFY(id%COLSCA_loc)
 C     IPIV is used both for ScaLAPACK and RR
 C     Keep it outside CMUMPS_RR_FREE_POINTERS
       IF (associated(id%root%IPIV))    THEN
@@ -572,19 +582,19 @@ C     Data allocated during solve
 C     ---------------------------
 C
 C     (or for some of it, factorization -- forward during factorization)
-      IF (associated(id%RHSCOMP)) THEN
-        DEALLOCATE(id%RHSCOMP)
-        NULLIFY(id%RHSCOMP)
+      IF (associated(id%RHSINTR)) THEN
+        DEALLOCATE(id%RHSINTR)
+        NULLIFY(id%RHSINTR)
         id%KEEP8(25)=0_8
       ENDIF
-      IF (associated(id%POSINRHSCOMP_ROW)) THEN
-        DEALLOCATE(id%POSINRHSCOMP_ROW)
-        NULLIFY(id%POSINRHSCOMP_ROW)
-      ENDIF
-      IF (id%POSINRHSCOMP_COL_ALLOC) THEN
-        DEALLOCATE(id%POSINRHSCOMP_COL)
-        NULLIFY(id%POSINRHSCOMP_COL)
-        id%POSINRHSCOMP_COL_ALLOC = .FALSE.
+      IF (associated(id%GLOB2LOC_RHS)) THEN
+        DEALLOCATE(id%GLOB2LOC_RHS)
+        NULLIFY(id%GLOB2LOC_RHS)
+      ENDIF
+      IF (id%GLOB2LOC_SOL_ALLOC) THEN
+        DEALLOCATE(id%GLOB2LOC_SOL)
+        NULLIFY(id%GLOB2LOC_SOL)
+        id%GLOB2LOC_SOL_ALLOC = .FALSE.
       ENDIF
 C     Allocated during solve:
 C     (even in case of fwd in facto)
@@ -598,3 +608,39 @@ C     (even in case of fwd in facto)
       END IF
       RETURN
       END SUBROUTINE CMUMPS_FREE_DATA_FACTO
+      SUBROUTINE CMUMPS_FREE_DATA_RHSINTR(id)
+C
+C     Purpose:
+C     -------
+C       Free RHSINTR related data that might 
+C       have been generated after a forward only step (ICNTL(26)=1)
+C     Module depencies
+C     ----------------
+      USE CMUMPS_STRUC_DEF
+      IMPLICIT NONE
+C
+C     Argument:
+C     --------
+C
+C     id is the main MUMPS structure, giving access to all internal
+C     objects allocated by the package.
+C
+      TYPE( CMUMPS_STRUC) :: id
+C
+      IF (associated(id%RHSINTR)) THEN
+        DEALLOCATE(id%RHSINTR)
+        NULLIFY(id%RHSINTR)
+        id%KEEP8(25)=0_8
+        id%LD_RHSINTR = 0
+      ENDIF
+      IF (associated(id%GLOB2LOC_RHS)) THEN
+        DEALLOCATE(id%GLOB2LOC_RHS)
+        NULLIFY(id%GLOB2LOC_RHS)
+      ENDIF
+      IF (id%GLOB2LOC_SOL_ALLOC) THEN
+        DEALLOCATE(id%GLOB2LOC_SOL)
+        NULLIFY(id%GLOB2LOC_SOL)
+        id%GLOB2LOC_SOL_ALLOC = .FALSE.
+      ENDIF
+      RETURN
+      END SUBROUTINE CMUMPS_FREE_DATA_RHSINTR
diff -pruN 5.6.2-2.1/src/cfac_asm.F 5.7.1-1/src/cfac_asm.F
--- 5.6.2-2.1/src/cfac_asm.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_asm.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -41,7 +41,7 @@ C
       IOLDPS = PTLUST_S(STEP(INODE))
       POSELT = PTRAST(STEP(INODE))
       NFRONT = IW(IOLDPS+KEEP(IXSZ))
-      NASS1  = iabs(IW(IOLDPS + 2+KEEP(IXSZ)))
+      NASS1  = abs(IW(IOLDPS + 2+KEEP(IXSZ)))
       NSLAVES= IW(IOLDPS+5+KEEP(IXSZ))
       IF (KEEP(50).EQ.0) THEN
         LDAFS_PERE = NFRONT
@@ -145,7 +145,7 @@ C
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
       INTEGER, INTENT(IN) :: NINROWARR(KEEP(195))
       INTEGER, INTENT(IN) :: PTRDEBARR(KEEP(196))
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       COMPLEX :: A(LA)
       INTEGER :: INTARR(KEEP8(27))
       COMPLEX :: DBLARR(KEEP8(26))
@@ -202,7 +202,7 @@ C
       INTEGER NBROWS
       INTEGER IW(LIW), ITLOC(N+KEEP(253)), STEP(N),
      &        PTRIST(KEEP(28))
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INCLUDE 'mumps_headers.h'
       INTEGER IOLDPS, NBCOLF, NBROWF, NSLAVES, HF,
      &        K1,K2,K,J
@@ -238,7 +238,7 @@ C
       INTEGER ROWLIST(NBROWS), COLLIST(NBCOLS)
       INTEGER IW(LIW), ITLOC(N+KEEP(253)), STEP(N),
      &        PTRIST(KEEP(28)), FILS(N)
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INTEGER(8) :: PTRAST(KEEP(28))
       COMPLEX A(LA), VALSON(LDA_VALSON,NBROWS)
       DOUBLE PRECISION OPASSW, OPELIW
@@ -609,7 +609,7 @@ C
       INTRINSIC real
       IOLDPS = PTLUST_S(STEP(INODE))
       POSELT = PTRAST(STEP(INODE))
-      NASS1  = iabs(IW(IOLDPS + 2 + KEEP(IXSZ)))
+      NASS1  = abs(IW(IOLDPS + 2 + KEEP(IXSZ)))
       NSLAVES= IW(IOLDPS+5 + KEEP(IXSZ))
       HF      = 6 + NSLAVES + KEEP(IXSZ)
       ISTCHK = PIMASTER(STEP(ISON))
@@ -655,7 +655,7 @@ C
       INTEGER(8), intent(in) :: KEEP8(150)
       INTEGER, intent(inout) :: ITLOC(N+KEEP(253))
       COMPLEX, intent(inout) :: A(LA)
-      COMPLEX, intent(in)    :: RHS_MUMPS(KEEP(255))
+      COMPLEX, intent(in)    :: RHS_MUMPS(KEEP8(85))
       COMPLEX, intent(in)    :: DBLARR(LDBLARR)
       INTEGER, intent(in)    :: INTARR(LINTARR)
       INTEGER, intent(in)    :: FILS(N)
@@ -709,8 +709,9 @@ C
           NB_BLR_LS = NPARTSCB
           call MAX_CLUSTER(BEGS_BLR_LS,NB_BLR_LS+1,MAXI_CLUSTER)
           DEALLOCATE(BEGS_BLR_LS)
-          CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS)
-          MINSIZE = int(IBCKSZ2 / 2)
+          CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS, 
+     &                         NBCOLF, KEEP(35))
+          MINSIZE = int(IBCKSZ2 / 3)
           TOPDIAG = max(2*MINSIZE + MAXI_CLUSTER-1, TOPDIAG)
         ENDIF
 !$      CHUNK = max( KEEP(360)/2,
diff -pruN 5.6.2-2.1/src/cfac_asm_ELT.F 5.7.1-1/src/cfac_asm_ELT.F
--- 5.6.2-2.1/src/cfac_asm_ELT.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_asm_ELT.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -31,7 +31,7 @@ C
       INTEGER IW(LIW), ITLOC(N+KEEP(253)), STEP(N),
      &        PTRIST(KEEP(28)), FILS(N)
       INTEGER(8), INTENT(IN) :: PTRARW(NELT+1), PTRAIW(NELT+1)
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INTEGER INTARR(KEEP8(27))
       INTEGER FRT_PTR(N+1), FRT_ELT(NELT)
       COMPLEX :: A(LA)
@@ -92,7 +92,7 @@ C
       INTEGER(8), intent(in) :: KEEP8(150)
       INTEGER, intent(inout) :: ITLOC(N+KEEP(253))
       COMPLEX, intent(inout) :: A(LA)
-      COMPLEX, intent(in)    :: RHS_MUMPS(KEEP(255))
+      COMPLEX, intent(in)    :: RHS_MUMPS(KEEP8(85))
       INTEGER, intent(in)    :: INTARR(LINTARR)
       COMPLEX, intent(in)    :: DBLARR(LDBLARR)
       INTEGER, intent(in)    :: FRT_PTR(N+1), FRT_ELT(NELT)
@@ -148,8 +148,9 @@ C
           NB_BLR_LS = NPARTSCB
           call MAX_CLUSTER(BEGS_BLR_LS,NB_BLR_LS+1,MAXI_CLUSTER)
           DEALLOCATE(BEGS_BLR_LS)
-          CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS)
-          MINSIZE = int(IBCKSZ2 / 2)
+          CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS,
+     &                         NBCOLF, KEEP(35))
+          MINSIZE = int(IBCKSZ2 / 3)
           TOPDIAG = max(2*MINSIZE + MAXI_CLUSTER-1, TOPDIAG)
         ENDIF
 !$      CHUNK = max( KEEP(360)/2,
diff -pruN 5.6.2-2.1/src/cfac_asm_master_ELT_m.F 5.7.1-1/src/cfac_asm_master_ELT_m.F
--- 5.6.2-2.1/src/cfac_asm_master_ELT_m.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_asm_master_ELT_m.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -78,7 +78,7 @@ C
      &        FILS(N), FRERE(KEEP(28)), DAD(KEEP(28)),
      &        PTRIST(KEEP(28)), PTLUST(KEEP(28)),
      &        STEP(N), PIMASTER(KEEP(28))
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INTEGER(8) :: PTRFAC(KEEP(28)), PTRAST(KEEP(28)),
      &              PAMASTER(KEEP(28))
       INTEGER COMM, NBFIN, SLAVEF, MYID
@@ -224,7 +224,7 @@ C
      &       NUMORG, KEEP(486),
      &       KEEP(489), KEEP(490), KEEP(491), KEEP(492), 
      &       KEEP(20), KEEP(60), DAD(STEP(INODE)), KEEP(38),
-     &       LRSTATUS, KEEP(280), LRGROUPS)
+     &       KEEP(123), LRSTATUS, KEEP(280), LRGROUPS)
       IF (DAD(STEP(INODE)).NE.0) THEN
         IF ( MUMPS_PROCNODE(PROCNODE_STEPS(STEP(DAD(STEP(INODE)))),
      &                                     KEEP(199) )
@@ -338,7 +338,7 @@ C
      &       IOLDPS + HF + 2 * NFRONT, IW, LIW)
       ENDIF
       NCB   = NFRONT - NASS1
-      MAXFRW = max0(MAXFRW, NFRONT)
+      MAXFRW = max(MAXFRW, NFRONT)
       ICT11 = IOLDPS + HF - 1 + NFRONT
       CALL CMUMPS_SET_PARPIVT1 ( INODE, NFRONT, NASS1, KEEP, 
      &                           LR_ACTIVATED, PARPIV_T1) 
@@ -413,8 +413,9 @@ C
             NB_BLR = NPARTSASS + NPARTSCB
          CALL MAX_CLUSTER(BEGS_BLR,NB_BLR,MAXI_CLUSTER)
          DEALLOCATE(BEGS_BLR)
-         CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS1)
-         MINSIZE = int(IBCKSZ2 / 2)
+         CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS1,
+     &                        NFRONT, KEEP(35))
+         MINSIZE = int(IBCKSZ2 / 3)
          TOPDIAG = max(2*MINSIZE + MAXI_CLUSTER-1,TOPDIAG)
         ENDIF
         NUMROWS = NFRONT8
@@ -926,7 +927,7 @@ C
      &        STEP(N),
      & PIMASTER(KEEP(28)),
      &        NSTK_S(KEEP(28)), PERM(N)
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INTEGER   CAND(SLAVEF+1, max(1,KEEP(56)))
       INTEGER   ISTEP_TO_INIV2(KEEP(71)), 
      &          TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
@@ -1059,7 +1060,7 @@ C
       CALL IS_FRONT_BLR_CANDIDATE(INODE, 2, NFRONT, NASS1, KEEP(486),
      &       KEEP(489), KEEP(490), KEEP(491), KEEP(492), 
      &       KEEP(20), KEEP(60), DAD(STEP(INODE)), KEEP(38),
-     &       LRSTATUS, KEEP(280), LRGROUPS)
+     &       KEEP(123), LRSTATUS, KEEP(280), LRGROUPS)
       COMPRESS_PANEL = (LRSTATUS.GE.2)
       COMPRESS_CB    = ((LRSTATUS.EQ.1).OR.
      &                  (LRSTATUS.EQ.3))
@@ -1311,7 +1312,7 @@ C
      &       NBPANELS_L, NBPANELS_U, NASS1, 
      &       IOLDPS + HF + 2 * NFRONT, IW, LIW)
       ENDIF
-      MAXFRW = max0(MAXFRW, NFRONT)
+      MAXFRW = max(MAXFRW, NFRONT)
       PTLUST(STEP(INODE)) = IOLDPS
       IW(IOLDPS+KEEP(IXSZ))     = NFRONT
       IW(IOLDPS + 1+KEEP(IXSZ)) = 0
@@ -1432,8 +1433,9 @@ C
          NB_BLR = NPARTSASS + NPARTSCB
          CALL MAX_CLUSTER(BEGS_BLR,NB_BLR,MAXI_CLUSTER)
          DEALLOCATE(BEGS_BLR)
-         CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS1)
-         MINSIZE = int(IBCKSZ2 / 2)
+         CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS1,
+     &                        NFRONT, KEEP(35))
+         MINSIZE = int(IBCKSZ2 / 3)
          TOPDIAG = max(2*MINSIZE + MAXI_CLUSTER-1, TOPDIAG)
         ENDIF
 !$      CHUNK = max(KEEP(360)/2,
diff -pruN 5.6.2-2.1/src/cfac_asm_master_m.F 5.7.1-1/src/cfac_asm_master_m.F
--- 5.6.2-2.1/src/cfac_asm_master_m.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_asm_master_m.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -76,7 +76,7 @@ C
      &        FILS(N), FRERE(KEEP(28)), DAD(KEEP(28)),
      &        PTRIST(KEEP(28)), PTLUST(KEEP(28)),
      &        STEP(N), PIMASTER(KEEP(28))
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INTEGER(8) :: PTRFAC(KEEP(28)), PTRAST(KEEP(28)),
      &              PAMASTER(KEEP(28))
       INTEGER COMM, NBFIN, SLAVEF, MYID
@@ -193,7 +193,7 @@ C
         ETATASS= 2 
         IOLDPS = PTLUST(STEP(INODE)) 
         NFRONT = IW(IOLDPS + KEEP(IXSZ)) 
-        NASS1  = iabs(IW(IOLDPS + 2 + KEEP(IXSZ)))
+        NASS1  = abs(IW(IOLDPS + 2 + KEEP(IXSZ)))
         ICT11 = IOLDPS + HF - 1 + NFRONT
         SSARBR=MUMPS_INSSARBR(PROCNODE_STEPS(STEP(INODE)),
      &                        KEEP(199))
@@ -246,7 +246,7 @@ C
      &       NUMORG, KEEP(486),
      &       KEEP(489), KEEP(490), KEEP(491), KEEP(492), 
      &       KEEP(20), KEEP(60), DAD(STEP(INODE)), KEEP(38),
-     &       LRSTATUS, KEEP(280), LRGROUPS)
+     &       KEEP(123), LRSTATUS, KEEP(280), LRGROUPS)
       IF (DAD(STEP(INODE)).NE.0) THEN
         IF ( MUMPS_PROCNODE(PROCNODE_STEPS(STEP(DAD(STEP(INODE)))),
      &                                     KEEP(199) )
@@ -384,7 +384,7 @@ C
      &       IOLDPS + HF + 2 * NFRONT, IW, LIW)
       ENDIF
       NCB   = NFRONT - NASS1
-      MAXFRW = max0(MAXFRW, NFRONT)
+      MAXFRW = max(MAXFRW, NFRONT)
       ICT11 = IOLDPS + HF - 1 + NFRONT
       CALL CMUMPS_SET_PARPIVT1 ( INODE, NFRONT, NASS1, KEEP, 
      &                           LR_ACTIVATED, PARPIV_T1) 
@@ -465,8 +465,9 @@ C
             NB_BLR = NPARTSASS + NPARTSCB
          CALL MAX_CLUSTER(BEGS_BLR,NB_BLR,MAXI_CLUSTER)
          DEALLOCATE(BEGS_BLR)
-         CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS1)
-         MINSIZE = int(IBCKSZ2 / 2)
+         CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS1,
+     &                        NFRONT, KEEP(35))
+         MINSIZE = int(IBCKSZ2 / 3)
          TOPDIAG = max(2*MINSIZE + MAXI_CLUSTER-1,TOPDIAG)
         ENDIF
         IF (ETATASS.EQ.1) THEN
@@ -654,14 +655,6 @@ C
           ELSE
             IACHK = PAMASTER(STEP(ISON))
           ENDIF
-          IF (IS_CB_LR .AND. LEVEL1) THEN
-            POSEL1 = PTRAST(STEP(INODE))
-            CALL CMUMPS_BLR_ASM_NIV1 (A, LA,
-     &           POSEL1, NFRONT, NASS1, SON_IW(ISTCHK+XXF),
-     &           SON_IW, SON_LIW,
-     &           LSTK, NELIM, K1, K1+LSTK-1, KEEP(50),
-     &           KEEP, KEEP8, OPASSW)
-          ENDIF
           IF ( KEEP(50) .eq. 0 ) THEN
             POSEL1 = PTRAST(STEP(INODE)) - NFRONT8
             IF (NFRONT .EQ. LSTK.AND. ISON.EQ.ISON_IN_PLACE
@@ -750,6 +743,14 @@ C
               ENDIF
             ENDIF 
           ENDIF
+          IF (IS_CB_LR .AND. LEVEL1) THEN
+            POSEL1 = PTRAST(STEP(INODE))
+            CALL CMUMPS_BLR_ASM_NIV1 (A, LA,
+     &           POSEL1, NFRONT, NASS1, SON_IW(ISTCHK+XXF),
+     &           SON_IW, SON_LIW,
+     &           LSTK, NELIM, K1, K1+LSTK-1, KEEP(50),
+     &           KEEP, KEEP8, OPASSW)
+          ENDIF
   205     IF (LEVEL1) THEN 
            IF (SAME_PROC) ISTCHK = PTRIST(STEP(ISON))
            IF ((SAME_PROC).AND.ETATASS.NE.1) THEN
@@ -1077,7 +1078,7 @@ C
      &        STEP(N),
      & PIMASTER(KEEP(28)),
      &        NSTK_S(KEEP(28)), PERM(N)
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INTEGER   CAND(SLAVEF+1, max(1,KEEP(56)))
       INTEGER   ISTEP_TO_INIV2(KEEP(71)), 
      &          TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
@@ -1202,7 +1203,7 @@ C
       CALL IS_FRONT_BLR_CANDIDATE(INODE, 2, NFRONT, NASS1, KEEP(486),
      &       KEEP(489), KEEP(490), KEEP(491), KEEP(492), 
      &       KEEP(20), KEEP(60), DAD(STEP(INODE)), KEEP(38),
-     &       LRSTATUS, KEEP(280), LRGROUPS)
+     &       KEEP(123), LRSTATUS, KEEP(280), LRGROUPS)
       COMPRESS_PANEL = (LRSTATUS.GE.2)
       COMPRESS_CB    = ((LRSTATUS.EQ.1).OR.
      &                  (LRSTATUS.EQ.3))
@@ -1452,7 +1453,7 @@ C
      &       NBPANELS_L, NBPANELS_U, NASS1, 
      &       IOLDPS + HF + 2 * NFRONT, IW, LIW)
       ENDIF
-      MAXFRW = max0(MAXFRW, NFRONT)
+      MAXFRW = max(MAXFRW, NFRONT)
       PTLUST(STEP(INODE)) = IOLDPS
       IW(IOLDPS+KEEP(IXSZ))     = NFRONT
       IW(IOLDPS + 1+KEEP(IXSZ)) = 0
@@ -1571,8 +1572,9 @@ C
          NB_BLR = NPARTSASS + NPARTSCB
          CALL MAX_CLUSTER(BEGS_BLR,NB_BLR,MAXI_CLUSTER)
          DEALLOCATE(BEGS_BLR)
-         CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS1)
-         MINSIZE = int(IBCKSZ2 / 2)
+         CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS1,
+     &                        NFRONT, KEEP(35))
+         MINSIZE = int(IBCKSZ2 / 3)
          TOPDIAG = max(2*MINSIZE + MAXI_CLUSTER-1, TOPDIAG)
         ENDIF
 !$      CHUNK = max(KEEP(360)/2,
diff -pruN 5.6.2-2.1/src/cfac_b.F 5.7.1-1/src/cfac_b.F
--- 5.6.2-2.1/src/cfac_b.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_b.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -71,7 +71,7 @@ C
       INTEGER(8) :: PTRFAC(KEEP(28))
       INTEGER   PTRIST(KEEP(28)), PTLUST_S(KEEP(28))
       INTEGER   IW1(2*KEEP(28)), ITLOC(N+KEEP(253)), POOL(LPOOL)
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INTEGER(8) :: IW2(2*KEEP(28))
       INTEGER   PROCNODE_STEPS(KEEP(28))
       INTEGER   COMM_LOAD, ASS_IRECV
@@ -96,8 +96,8 @@ C
       INTEGER, INTENT (IN) :: LL0_OMP_MAPPING
       INTEGER, INTENT (OUT):: L0_OMP_MAPPING( LL0_OMP_MAPPING )
       INTEGER, INTENT (IN) :: LL0_OMP_FACTORS
-      TYPE(CMUMPS_L0OMPFAC_T), INTENT (OUT) :: L0_OMP_FACTORS(
-     &                                         LL0_OMP_FACTORS )
+      TYPE(CMUMPS_L0OMPFAC_T), INTENT (INOUT) :: L0_OMP_FACTORS(
+     &                                           LL0_OMP_FACTORS )
       INTEGER, INTENT (IN) :: NBSTATS_I4, NBSTATS_I8
       INTEGER, INTENT (IN) :: NBCOLS_I4, NBCOLS_I8
       INTEGER, INTENT (IN) :: I4_L0_OMP(NBSTATS_I4, NBCOLS_I4)
@@ -552,7 +552,7 @@ C
       INTEGER LPOOL
       INTEGER PROCNODE_STEPS(KEEP(28))
       INTEGER ITLOC(N+KEEP(253))
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INTEGER IW(LIW), NSTK_STEPS(KEEP(28))
       INTEGER(8), INTENT(IN) :: PTRARW(LPTRAR), PTRAIW(LPTRAR)
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
diff -pruN 5.6.2-2.1/src/cfac_determinant.F 5.7.1-1/src/cfac_determinant.F
--- 5.6.2-2.1/src/cfac_determinant.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_determinant.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -159,25 +159,24 @@ C
       NEXP=-NEXP
       RETURN
       END SUBROUTINE CMUMPS_DETER_SCALING_INVERSE
-      SUBROUTINE CMUMPS_DETER_SIGN_PERM(DETER, N, VISITED, PERM)
+      SUBROUTINE CMUMPS_DETER_SIGN_PERM(DETER, N, PERM)
       IMPLICIT NONE
       COMPLEX, intent(inout) :: DETER
       INTEGER, intent(in)    :: N
-      INTEGER, intent(inout) :: VISITED(N)
-      INTEGER, intent(in)    :: PERM(N)
+      INTEGER, intent(inout) :: PERM(N)
       INTEGER I, J, K
       K = 0
       DO I = 1, N
-        IF (VISITED(I) .GT. N) THEN
-          VISITED(I)=VISITED(I)-N-N-1
-          CYCLE
+        IF (PERM(I) .LT. 0) THEN
+          PERM(I)=-PERM(I)
+        ELSE 
+          J = PERM(I)
+          DO WHILE (J.NE.I)
+            PERM(J)=-PERM(J)
+            K = K + 1
+            J = -PERM(J) 
+          ENDDO
         ENDIF
-        J = PERM(I)
-        DO WHILE (J.NE.I)
-          VISITED(J) = VISITED(J) + N + N + 1
-          K = K + 1
-          J = PERM(J)
-        ENDDO
       ENDDO
       IF (mod(K,2).EQ.1) THEN
         DETER = -DETER
diff -pruN 5.6.2-2.1/src/cfac_diag.F 5.7.1-1/src/cfac_diag.F
--- 5.6.2-2.1/src/cfac_diag.F	1970-01-01 00:00:00.000000000 +0000
+++ 5.7.1-1/src/cfac_diag.F	2024-05-02 10:15:28.000000000 +0000
@@ -0,0 +1,20 @@
+C
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
+C
+C
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Mumps Technologies, University of Bordeaux.
+C
+C  This version of MUMPS is provided to you free of charge. It is
+C  released under the CeCILL-C license 
+C  (see doc/CeCILL-C_V1-en.txt, doc/CeCILL-C_V1-fr.txt, and
+C  https://cecill.info/licences/Licence_CeCILL-C_V1-en.html)
+C
+      SUBROUTINE CMUMPS_GETSETDIAGRETURN()
+C
+C     This file contain code to access/return the
+C     diagonal of a factorized matrix in the future.
+C
+      RETURN
+      END SUBROUTINE CMUMPS_GETSETDIAGRETURN
diff -pruN 5.6.2-2.1/src/cfac_dist_arrowheads_omp.F 5.7.1-1/src/cfac_dist_arrowheads_omp.F
--- 5.6.2-2.1/src/cfac_dist_arrowheads_omp.F	1970-01-01 00:00:00.000000000 +0000
+++ 5.7.1-1/src/cfac_dist_arrowheads_omp.F	2024-05-02 10:15:27.000000000 +0000
@@ -0,0 +1,1350 @@
+C
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
+C
+C
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Mumps Technologies, University of Bordeaux.
+C
+C  This version of MUMPS is provided to you free of charge. It is
+C  released under the CeCILL-C license 
+C  (see doc/CeCILL-C_V1-en.txt, doc/CeCILL-C_V1-fr.txt, and
+C  https://cecill.info/licences/Licence_CeCILL-C_V1-en.html)
+C
+#if ! defined(PCPRET)
+      SUBROUTINE CMUMPS_FAC_DIST_ARROWHEADS_OMP  (      
+     & N, NZ_loc8, 
+     &    A_loc, IRN_loc, JCN_loc, 
+     &    SIZESCAL, LSCAL, COLSCA, ROWSCA, 
+     & DBLARR, LDBLARR, INTARR, LINTARR,
+     & PTR8ARR, NINCOLARR, NINROWARR, PTRDEBARR,
+     & FILS, KEEP,KEEP8, MYID, COMM, NBRECORDS,
+     &
+     & S, LA, root, PROCNODE_STEPS, NPROCS, SLAVEF, PERM, STEP,
+     & ICNTL, INFO, NSEND8, NLOCAL8,
+     & ISTEP_TO_INIV2, CANDIDATES
+     & )
+!$    USE OMP_LIB
+      USE CMUMPS_STRUC_DEF
+      IMPLICIT NONE
+      INTEGER, INTENT(IN)    :: N, SIZESCAL
+      LOGICAL, INTENT(IN)    :: LSCAL
+      INTEGER(8), INTENT(IN) :: NZ_loc8
+      INTEGER, INTENT(IN)    :: IRN_LOC(max(1_8,NZ_loc8)), 
+     &                          JCN_LOC(max(1_8,NZ_loc8))
+      COMPLEX, INTENT(IN)    :: A_loc(max(1_8,NZ_loc8))
+      REAL, INTENT(IN)       :: ROWSCA(SIZESCAL),
+     &                          COLSCA(SIZESCAL)
+      INTEGER(8), INTENT(IN) :: LDBLARR, LINTARR
+      COMPLEX, INTENT(OUT)   :: DBLARR( LDBLARR )
+      INTEGER, INTENT(OUT)   :: INTARR( LINTARR )
+      INTEGER, INTENT(INOUT) :: KEEP(500)   
+      INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
+      INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
+      INTEGER, INTENT(IN) :: NINROWARR(KEEP(195))
+      INTEGER, INTENT(IN) :: PTRDEBARR(KEEP(196))
+      INTEGER(8), INTENT(INOUT):: KEEP8(150) 
+      INTEGER, INTENT(IN)    :: FILS( N )
+      INTEGER, INTENT(IN)    :: MYID, COMM, NBRECORDS
+      INTEGER(8), INTENT(IN) :: LA
+      INTEGER, INTENT(IN)    :: NPROCS, SLAVEF
+      INTEGER(8), INTENT(OUT):: NSEND8, NLOCAL8
+      INTEGER, INTENT(IN)    :: ISTEP_TO_INIV2(KEEP(71))
+      INTEGER, INTENT(IN)    :: CANDIDATES(SLAVEF+1, max(1,KEEP(56)))
+      COMPLEX, INTENT(INOUT) :: S( LA )
+      TYPE (CMUMPS_ROOT_STRUC), INTENT(INOUT) :: root
+      INTEGER, INTENT(IN)    :: PROCNODE_STEPS(KEEP(28)), 
+     &                         PERM( N ), STEP( N )
+      INTEGER, INTENT(INOUT) :: INFO( 80 ) 
+      INTEGER, INTENT(IN)    :: ICNTL(60)
+      INCLUDE 'mumps_tags.h'
+      INCLUDE 'mpif.h'
+      COMPLEX ZERO
+      PARAMETER( ZERO = (0.0E0,0.0E0) )
+      INTEGER, ALLOCATABLE, DIMENSION(:,:)  :: IW4
+      INTEGER(8), ALLOCATABLE, DIMENSION(:) :: PTRAW
+      INTEGER, ALLOCATABLE, DIMENSION(:,:,:) :: BUFSENDI
+      COMPLEX, ALLOCATABLE, DIMENSION(:,:,:) :: BUFSENDR
+      INTEGER, ALLOCATABLE, DIMENSION(:,:)   :: BUFSEND_POSRESERVED
+      INTEGER, ALLOCATABLE, DIMENSION(:,:) :: BUFRECVI
+      COMPLEX, ALLOCATABLE, DIMENSION(:,:) :: BUFRECVR
+      INTEGER, ALLOCATABLE, DIMENSION(:) :: IACT, ISENDREQI, ISENDREQR
+      LOGICAL, ALLOCATABLE, DIMENSION(:) :: SEND_ACTIVE
+      INTEGER, ALLOCATABLE, DIMENSION(:) :: IRECVREQI, IRECVREQR
+      INTEGER, ALLOCATABLE, DIMENSION(:):: RECV_BUF_STATUS
+         INTEGER, PARAMETER :: Processed_IrecNeeded          = 1
+         INTEGER, PARAMETER :: IrecPosted                    = 2
+         INTEGER, PARAMETER :: Received_NotProcessed         = 3
+         INTEGER, PARAMETER :: Processed_IrecNotneeded       = 4
+         INTEGER, PARAMETER :: Treating                      = 5
+         INTEGER, PARAMETER :: BeingTreatednotbyme           = 6 
+      INTEGER(8) :: ILOC8
+      INTEGER :: EndNZloc, NB_END_MSG_2_RECV
+      LOGICAL :: MPI_End_Send, End_TreatRecvBuf, MPI_InvolvedinSend, 
+     &           MPI_InvolvedinRecv, TH_InvolvedinComm, 
+     &           NO_ATOMIC_Wsendbuf, NO_ATOMIC_Warrow, FINISHED,
+     &           TH_InvolvedinArrange, TH_InvolvedinTreatRecv
+      INTEGER(8) :: PTR_ROOT
+      INTEGER    :: LOCAL_M, LOCAL_N, ARROW_ROOT
+      LOGICAL :: EARLYT3ROOTINS
+      LOGICAL :: I_AM_SLAVE, OneMPI
+      INTEGER :: IARR1, IORG, NOMP, NOMP_MAX
+      INTEGER :: ISTEP, ISLAVE_MAIN, IMAIN, JMAIN
+      INTEGER :: allocok 
+      LOGICAL :: OMP_FLAG
+      INTEGER(8) :: IS8MAIN
+      INTEGER :: TYPE_NODE_P, MASTER_NODE_P, NBJ_P
+      INTEGER(8) :: IS8_P
+      INTEGER :: LP, MP
+      LOGICAL :: LPOK, PROK
+      INTEGER(8) :: NB_RANGE_8
+      INTEGER :: SHIFT_PID
+      INTEGER :: NOMP_SHARED
+      LOGICAL    :: NOTHINGTOARRANGE_P
+      INTEGER    :: IOMP, NB_RANGE_P, EndNZloc_P
+      LOGICAL    :: ThWorking
+      INTEGER(8) :: ILOC8_P
+      INTEGER, PARAMETER :: MPI_MASTER = 0  
+      NSEND8  = 0_8
+      NLOCAL8 = 0_8
+      LP = ICNTL(1)
+      MP = ICNTL(2)
+      LPOK    = ((LP.GT.0).AND.(ICNTL(4).GE.1))
+      PROK    = ((MP.GT.0).AND.(ICNTL(4).GE.2))
+      NB_RANGE_8        = int(max(NBRECORDS/10, 1), 8)
+      IF (KEEP(46).EQ.0) THEN
+       SHIFT_PID = 1
+      ELSE
+       SHIFT_PID = 0
+      ENDIF
+      I_AM_SLAVE = (MYID.NE.0.OR.KEEP(46).EQ.1)
+      OneMPI     = NPROCS.EQ.1 
+      IF ( OneMPI.OR. 
+     &     (KEEP(54).EQ.0.AND.(MYID.NE.MPI_MASTER)) 
+     &   ) THEN
+        MPI_InvolvedinSend = .FALSE.  
+        MPI_End_Send       = .TRUE.
+      ELSE
+        MPI_InvolvedinSend = .TRUE.   
+        MPI_End_Send       = .FALSE.
+      ENDIF
+      IF (.NOT.OneMPI) THEN
+        ALLOCATE( 
+     &    BUFSENDI(NBRECORDS * 2 + 1, 2, NPROCS),  
+     &    BUFSENDR(NBRECORDS, 2, NPROCS),
+     &    IACT(NPROCS), SEND_ACTIVE(NPROCS), 
+     &    ISENDREQI(NPROCS), ISENDREQR(NPROCS),
+     &    BUFSEND_POSRESERVED(2, NPROCS),
+     &    stat=allocok)
+        IF ( allocok .GT. 0 ) THEN
+          IF ( LPOK ) THEN
+            WRITE(LP,*)
+     &     '** Error allocating SEND buffers for matrix distribution'
+          END IF
+          INFO(1) = -13
+          INFO(2) =  ( NBRECORDS * 2 + 1 ) * NPROCS * 2 +
+     &             NBRECORDS * NPROCS * 2 + 
+     &             NPROCS*6
+          GOTO 20
+        END IF
+        DO ISLAVE_MAIN=1, NPROCS
+          IACT (ISLAVE_MAIN)         = 1
+          ISENDREQI(ISLAVE_MAIN) = MPI_REQUEST_NULL
+          ISENDREQR(ISLAVE_MAIN) = MPI_REQUEST_NULL
+          BUFSENDI(1, 1, ISLAVE_MAIN)       = 0
+          BUFSEND_POSRESERVED(1,ISLAVE_MAIN)= 0
+          BUFSENDI(1, 2, ISLAVE_MAIN)       = NBRECORDS  
+          BUFSEND_POSRESERVED(2,ISLAVE_MAIN)= NBRECORDS
+          SEND_ACTIVE(ISLAVE_MAIN)   =  .FALSE.
+        ENDDO
+      ENDIF
+      IF (OneMPI.OR. 
+     &    (KEEP(54).EQ.0.AND.(MYID.EQ.MPI_MASTER))
+     &   ) THEN
+        NB_END_MSG_2_RECV  = 0
+        MPI_InvolvedinRecv = .FALSE. 
+        End_TreatRecvBuf   = .TRUE.
+      ELSE IF (KEEP(54).EQ.0.AND.MYID.NE.MPI_MASTER) THEN
+        NB_END_MSG_2_RECV  =  1
+        MPI_InvolvedinRecv = .TRUE.  
+        End_TreatRecvBuf   = .FALSE.
+      ELSE
+        NB_END_MSG_2_RECV  = NPROCS-1
+        MPI_InvolvedinRecv = .TRUE.  
+        End_TreatRecvBuf   = .FALSE.
+      ENDIF
+      IF (.NOT.OneMPI) THEN
+        ALLOCATE( 
+     &  BUFRECVI(NBRECORDS * 2 + 1, NPROCS),
+     &  BUFRECVR(NBRECORDS, NPROCS),
+     &  IRECVREQI(NPROCS), IRECVREQR(NPROCS), 
+     &  RECV_BUF_STATUS(NPROCS),
+     &            stat=allocok)
+        IF ( allocok .GT. 0 ) THEN
+           IF ( LPOK ) THEN
+             WRITE(LP,*)
+     &      '** Error allocating RECV buffers for matrix distribution'
+           END IF
+           INFO(1) = -13
+           INFO(2) =  ( NBRECORDS * 2 + 1 ) * NPROCS +
+     &              NBRECORDS * NPROCS  +      
+     &              NPROCS*3
+           GOTO 20
+        ENDIF
+        BUFRECVI(1, 1:NPROCS) = 0
+        IRECVREQI(1:NPROCS)   = MPI_REQUEST_NULL
+        IRECVREQR(1:NPROCS)   = MPI_REQUEST_NULL
+        RECV_BUF_STATUS (1:NPROCS)= Processed_IrecNeeded
+        RECV_BUF_STATUS (MYID+1)  = Processed_IrecNotneeded
+        IF (KEEP(54).EQ.0) THEN
+         DO ISLAVE_MAIN=1, NPROCS
+           RECV_BUF_STATUS (ISLAVE_MAIN)= Processed_IrecNotneeded
+         ENDDO
+         IF (MYID.NE.MPI_MASTER) THEN
+           RECV_BUF_STATUS(MPI_MASTER+1)  = Processed_IrecNeeded
+         ENDIF
+        ENDIF
+      ENDIF
+      ALLOCATE( IW4( N, 2 ), stat = allocok )
+      IF ( allocok .GT. 0 ) THEN
+        WRITE(LP,*) '** Error allocating IW4 for matrix distribution'
+        INFO(1) = -13
+        CALL MUMPS_SET_IERROR( int(N,8) * 2_8, INFO(2) )
+        GOTO 20
+      END IF
+      ALLOCATE( PTRAW( N ), stat = allocok )
+      IF ( allocok .GT. 0 ) THEN
+        WRITE(LP,*) '** Error allocating IW4 for matrix distribution'
+        INFO(1) = -13
+        CALL MUMPS_SET_IERROR( int(N,8) * KEEP(10), INFO(2) )
+        GOTO 20
+      END IF
+ 20   CONTINUE
+      CALL MUMPS_PROPINFO( ICNTL, INFO, COMM, MYID )
+      IF ( INFO(1) .LT. 0 ) GOTO 100
+      ARROW_ROOT = 0
+      EARLYT3ROOTINS = KEEP(200) .EQ.0
+     &        .OR.  ( KEEP(200) .LT. 0 .AND. KEEP(400) .EQ. 0 )
+      IF (I_AM_SLAVE) THEN
+       DO JMAIN = 1, N
+        ISTEP=STEP(JMAIN)
+        IF (ISTEP .GT. 0) THEN
+          IARR1 = PTRDEBARR( ISTEP )
+          IF ( IARR1 .GT. 0 ) THEN
+            IMAIN = JMAIN
+            IORG = 0
+            DO WHILE ( IMAIN .GT. 0 )
+              IORG = IORG + 1
+              IW4(IMAIN, 1)  = NINCOLARR( IARR1 + IORG - 1 )
+              IW4(IMAIN, 2)  = NINROWARR( IARR1 + IORG - 1 ) +
+     &                     NINCOLARR( IARR1 + IORG - 1 )
+              IS8MAIN        = PTR8ARR( IARR1 + IORG - 1 )
+              PTRAW( IMAIN ) = IS8MAIN
+              INTARR( IS8MAIN ) = IMAIN
+              DBLARR( IS8MAIN ) = ZERO
+              IMAIN = FILS(IMAIN)
+            ENDDO
+          ENDIF
+        ENDIF
+       ENDDO
+       IF ( KEEP(38) .NE. 0 .AND. EARLYT3ROOTINS ) THEN
+         CALL CMUMPS_GET_ROOT_INFO(root,LOCAL_M, LOCAL_N, PTR_ROOT, LA)
+         CALL CMUMPS_SET_ROOT_TO_ZERO(root, KEEP, S, LA)
+       ELSE
+         LOCAL_M = -19999; LOCAL_N = -29999; PTR_ROOT = -99999_8
+       END IF
+      ELSE 
+         LOCAL_M = -19999; LOCAL_N = -29999; PTR_ROOT = -99999_8
+      ENDIF
+      NOMP=1
+!$    NOMP=omp_get_max_threads()
+      NOMP_MAX = NOMP
+      IF (NOMP_MAX.GT.2.AND.KEEP(399).EQ.2) THEN
+       IF (.NOT.OneMPI) THEN
+        NOMP_MAX = 2
+       ENDIF
+      ENDIF
+      IF (NOMP_MAX.GT.3.AND.KEEP(399).EQ.3) THEN
+       IF (.NOT.OneMPI) THEN
+        NOMP_MAX = 3
+       ENDIF
+      ENDIF
+      ILOC8      = 1_8  
+      OMP_FLAG   = ((NOMP .GE.2).AND.(KEEP(399).NE.99))
+      FINISHED = .FALSE.
+      NOMP_SHARED = 1
+!$OMP PARALLEL 
+!$OMP&  NUM_THREADS(NOMP_MAX)
+!$OMP&    PRIVATE(
+!$OMP&         IOMP, ThWorking, ILOC8_P, NB_RANGE_P,
+!$OMP&         NOTHINGTOARRANGE_P, EndNZloc_P, TH_InvolvedinComm,
+!$OMP&         TH_InvolvedinTreatRecv,  TH_InvolvedinArrange )
+!$OMP& REDUCTION(+:NSEND8, NLOCAL8, ARROW_ROOT) 
+!$OMP& IF (OMP_FLAG)
+      IOMP        = 0
+!$    IOMP=omp_get_thread_num()
+!$OMP SINGLE
+!$      NOMP_SHARED= omp_get_num_threads()  
+        IF (OneMPI) THEN
+         EndNZloc = NOMP_SHARED
+        ELSE
+         EndNZloc = max(1,NOMP_SHARED -1)
+         IF ( KEEP(399).EQ.2.OR.KEEP(399).EQ.3 ) THEN
+          EndNZloc = min(EndNZloc,1)
+         ENDIF
+        ENDIF
+        IF (NZ_loc8.EQ.0_8) EndNZloc = 0  
+        IF (.NOT.MPI_InvolvedinSend.AND.(EndNZloc.EQ.0)) EndNZloc=-1
+        NO_ATOMIC_Wsendbuf = ( NOMP_SHARED.EQ.1 )
+        NO_ATOMIC_Warrow   = ( NOMP_SHARED.EQ.1 )
+        IF (NPROCS.GT.1) THEN
+          NO_ATOMIC_Warrow = (NOMP_SHARED.LE.2)
+          IF ( KEEP(399).EQ.2 .OR. KEEP(399).EQ.3) THEN
+           NO_ATOMIC_Wsendbuf =  .TRUE.
+           IF (.NOT.MPI_InvolvedinSend) NO_ATOMIC_Warrow=.TRUE.
+           IF (.NOT.MPI_InvolvedinRecv) NO_ATOMIC_Warrow=.TRUE.
+          ENDIF
+        ENDIF
+!$OMP END SINGLE
+      ThWorking          =  OneMPI.OR.
+     &                     (NOMP_SHARED.EQ.1) .OR. (IOMP.NE.0)
+      TH_InvolvedinTreatRecv = (MPI_InvolvedinRecv.AND.ThWorking)
+      IF ( TH_InvolvedinTreatRecv.AND.
+     &     (NOMP_SHARED.EQ.3).AND.(KEEP(399).EQ.3) ) THEN
+          IF (IOMP.NE.2) TH_InvolvedinTreatRecv = .FALSE.
+      ENDIF
+      TH_InvolvedinArrange = ThWorking
+      IF (.NOT.OneMPI.AND.ThWorking) THEN
+        IF (KEEP(399).EQ.2.OR.KEEP(399).EQ.3) 
+     &    THEN
+          IF ((NOMP_SHARED.NE.1).AND.(IOMP.NE.1)) 
+     &       TH_InvolvedinArrange = .FALSE.
+        ENDIF
+      ENDIF
+      TH_InvolvedinComm  = ((.NOT.OneMPI).AND.(IOMP.EQ.0))
+      NOTHINGTOARRANGE_P = (NZ_loc8.EQ.0_8)
+      ILOC8_P            = 0_8
+       DO WHILE ( .NOT.FINISHED )
+          IF (TH_InvolvedinComm) THEN
+            CALL CMUMPS_ARROW_TRY_PROGRESS_COMM ( IOMP, MYID,
+     &       NPROCS, NBRECORDS, MPI_InvolvedinSend, MPI_InvolvedinRecv, 
+     &       COMM, ISENDREQI, ISENDREQR, BUFSENDI, BUFSENDR, 
+     &       IACT, SEND_ACTIVE, BUFSEND_POSRESERVED, 
+     &       IRECVREQI, IRECVREQR, BUFRECVI, BUFRECVR,
+     &       RECV_BUF_STATUS, NB_END_MSG_2_RECV, 
+     &       EndNZloc, MPI_End_Send, End_TreatRecvBuf
+     &        )
+          ENDIF
+          IF (.NOT.ThWorking) THEN
+            CALL MUMPS_USLEEP(20)
+            GOTO  50
+          ENDIF
+          IF (TH_InvolvedinTreatRecv) THEN
+            CALL CMUMPS_ARROW_TRY_TREAT_RECV_BUF ( IOMP,
+     &             BUFRECVI, BUFRECVR, RECV_BUF_STATUS, 
+     &             NPROCS, NBRECORDS, N, IW4,
+     &             KEEP, LOCAL_M, LOCAL_N, root, PTR_ROOT, S, LA,
+     &             NB_END_MSG_2_RECV, MYID, PROCNODE_STEPS,
+     &             SLAVEF,
+     &             PTRAW, 
+     &             PTR8ARR, NINCOLARR, NINROWARR, PTRDEBARR,
+     &             PERM, STEP,
+     &             INTARR, LINTARR, DBLARR, LDBLARR, 
+     &             NOMP_SHARED, EARLYT3ROOTINS, NO_ATOMIC_Warrow )
+            IF (NOMP_SHARED.EQ.1) THEN
+              CALL CMUMPS_ARROW_TRY_PROGRESS_COMM ( IOMP, MYID,
+     &        NPROCS, NBRECORDS, 
+     &        MPI_InvolvedinSend, MPI_InvolvedinRecv,
+     &        COMM, ISENDREQI, ISENDREQR, BUFSENDI, BUFSENDR, 
+     &        IACT, SEND_ACTIVE, BUFSEND_POSRESERVED, 
+     &        IRECVREQI, IRECVREQR, BUFRECVI, BUFRECVR,
+     &        RECV_BUF_STATUS, NB_END_MSG_2_RECV, 
+     &        EndNZloc, MPI_End_Send, End_TreatRecvBuf
+     &        )
+            ENDIF
+          ENDIF
+          IF (.NOT. NOTHINGTOARRANGE_P.AND.TH_InvolvedinArrange) THEN
+!$OMP ATOMIC CAPTURE
+            ILOC8_P = ILOC8
+            ILOC8   = ILOC8 + NB_RANGE_8
+!$OMP END ATOMIC 
+            IF (ILOC8_P.LE.NZ_loc8) THEN
+              NB_RANGE_P = int(min(NB_RANGE_8, NZ_loc8-ILOC8_P+1))
+              CALL CMUMPS_FAC_ARROW_ARRANGE ( MYID, IOMP, N, SHIFT_PID,
+     &   SLAVEF, LSCAL, NSEND8, NLOCAL8, ILOC8_P, NB_RANGE_P, 
+     &   NZ_loc8, IRN_LOC, JCN_LOC, A_loc, SIZESCAL, ROWSCA, COLSCA,
+     &   ISTEP_TO_INIV2, CANDIDATES, KEEP, MPI_MASTER, NO_ATOMIC_Warrow,
+     &   NO_ATOMIC_Wsendbuf, TH_InvolvedinTreatRecv,
+     &   NPROCS, NBRECORDS, MPI_InvolvedinSend, MPI_InvolvedinRecv, 
+     &   COMM, ISENDREQI, ISENDREQR, BUFSENDI, BUFSENDR, IACT,
+     &   SEND_ACTIVE, BUFSEND_POSRESERVED, IRECVREQI, IRECVREQR,
+     &   BUFRECVI, BUFRECVR, RECV_BUF_STATUS, EndNZloc, MPI_End_Send,
+     &   End_TreatRecvBuf,
+     &   root, PTR_ROOT, ARROW_ROOT, EARLYT3ROOTINS, LOCAL_M, LOCAL_N,
+     &   S, LA, NB_END_MSG_2_RECV, PROCNODE_STEPS, IW4, PTRAW, PTR8ARR,
+     &   NINCOLARR, NINROWARR, PTRDEBARR, PERM, STEP, INTARR, LINTARR,
+     &   DBLARR, LDBLARR, NOMP_SHARED )
+            ENDIF
+            IF (ILOC8_P+NB_RANGE_8.GT.NZ_loc8) THEN
+              IF (.NOT. NOTHINGTOARRANGE_P) THEN
+               NOTHINGTOARRANGE_P=.TRUE. 
+!$OMP          ATOMIC CAPTURE
+               EndNZloc   = EndNZloc-1
+               EndNZloc_P = EndNZloc
+!$OMP          END ATOMIC
+               IF (MPI_End_Send.AND.EndNZloc_P.EQ.0) THEN
+!$OMP           ATOMIC WRITE
+                EndNZloc=-1
+!$OMP           END ATOMIC
+               ENDIF
+              ENDIF
+            ENDIF
+          ENDIF
+  50      CONTINUE  
+!$OMP     MASTER
+!$OMP     ATOMIC WRITE
+          FINISHED = ( (EndNZloc.EQ.-1) 
+     &            .AND.(MPI_End_Send.OR.(.not.MPI_InvolvedinSend))
+     &            .AND. End_TreatRecvBuf
+     &               )
+!$OMP     END ATOMIC
+!$OMP     END MASTER
+       ENDDO
+!$OMP END PARALLEL
+!$OMP PARALLEL DO SCHEDULE(DYNAMIC,1)
+!$OMP&         PRIVATE(ISTEP, TYPE_NODE_P, MASTER_NODE_P, NBJ_P, 
+!$OMP&                 IARR1, IS8_P  )
+!$OMP&        IF (OMP_FLAG)
+      DO ISTEP=1, KEEP(28)
+        CALL MUMPS_TYPEANDPROCNODE( TYPE_NODE_P, MASTER_NODE_P,
+     &    PROCNODE_STEPS(ISTEP), KEEP(199) )
+        MASTER_NODE_P = MASTER_NODE_P + SHIFT_PID
+        IF ( MASTER_NODE_P.NE.MYID.OR.
+     &      (  (TYPE_NODE_P.NE.1) .AND. (TYPE_NODE_P.NE.2) )
+     &     ) CYCLE
+        IARR1  = PTRDEBARR( ISTEP )
+        NBJ_P  = NINCOLARR( IARR1)
+        IF (NBJ_P.LE.0) CYCLE
+        IS8_P  = PTR8ARR( IARR1) + 1_8
+        CALL CMUMPS_QUICK_SORT_ARROWHEADS( N, PERM,
+     &              INTARR( IS8_P ),
+     &              DBLARR( IS8_P ),
+     &              NBJ_P, 1, NBJ_P )
+      ENDDO
+!$OMP END PARALLEL DO
+ 100  CONTINUE
+      IF (ALLOCATED(IW4))         DEALLOCATE( IW4 )
+      IF (ALLOCATED(PTRAW))       DEALLOCATE( PTRAW )
+      IF (ALLOCATED(BUFSENDI))    DEALLOCATE( BUFSENDI )
+      IF (ALLOCATED(BUFSENDR))    DEALLOCATE( BUFSENDR )
+      IF (ALLOCATED(BUFRECVI))    DEALLOCATE( BUFRECVI )
+      IF (ALLOCATED(BUFRECVR))    DEALLOCATE( BUFRECVR )
+      IF (ALLOCATED(IACT))        DEALLOCATE( IACT )
+      IF (ALLOCATED(ISENDREQI))   DEALLOCATE( ISENDREQI )
+      IF (ALLOCATED(ISENDREQR))   DEALLOCATE( ISENDREQR )
+      IF (ALLOCATED(IRECVREQI))   DEALLOCATE( IRECVREQI )
+      IF (ALLOCATED(IRECVREQR))   DEALLOCATE( IRECVREQR )
+      IF (ALLOCATED(SEND_ACTIVE)) DEALLOCATE( SEND_ACTIVE )
+      IF (ALLOCATED(BUFSEND_POSRESERVED))   
+     &                      DEALLOCATE( BUFSEND_POSRESERVED )
+      IF (ALLOCATED(RECV_BUF_STATUS)) DEALLOCATE( RECV_BUF_STATUS )
+      RETURN
+      END SUBROUTINE CMUMPS_FAC_DIST_ARROWHEADS_OMP 
+      SUBROUTINE CMUMPS_ARROW_TRY_PROGRESS_COMM ( IOMP, MYID,
+     &     NPROCS, NBRECORDS, MPI_InvolvedinSend, MPI_InvolvedinRecv,
+     &     COMM, ISENDREQI, ISENDREQR, BUFSENDI, BUFSENDR, 
+     &     IACT, SEND_ACTIVE, BUFSEND_POSRESERVED, 
+     &     IRECVREQI, IRECVREQR, BUFRECVI, BUFRECVR,
+     &     RECV_BUF_STATUS, NB_END_MSG_2_RECV, 
+     &     EndNZloc, MPI_End_Send, End_TreatRecvBuf
+     &        )
+      IMPLICIT NONE
+      INTEGER, INTENT(IN) :: IOMP, MYID, NPROCS, NBRECORDS, COMM
+      LOGICAL, INTENT(IN) :: MPI_InvolvedinSend, MPI_InvolvedinRecv
+      INTEGER, INTENT(IN) :: NB_END_MSG_2_RECV
+      INTEGER, INTENT(INOUT) :: EndNZloc
+      LOGICAL, INTENT(INOUT) :: MPI_End_Send, End_TreatRecvBuf
+      INTEGER, INTENT(INOUT) :: 
+     &     ISENDREQI(NPROCS), ISENDREQR(NPROCS), 
+     &     BUFSENDI(NBRECORDS * 2 + 1, 2, NPROCS), 
+     &     IACT(NPROCS), BUFSEND_POSRESERVED(2,NPROCS)
+      COMPLEX, INTENT(INOUT) :: BUFSENDR(NBRECORDS, 2, NPROCS)
+      LOGICAL, INTENT(INOUT) :: SEND_ACTIVE(NPROCS)
+      INTEGER, INTENT(INOUT) :: 
+     &     IRECVREQI(NPROCS), IRECVREQR(NPROCS), 
+     &     BUFRECVI(NBRECORDS * 2 + 1, NPROCS),
+     &     RECV_BUF_STATUS(NPROCS)
+      COMPLEX, INTENT(INOUT) ::  BUFRECVR(NBRECORDS, NPROCS)
+         INTEGER, PARAMETER :: Processed_IrecNeeded          = 1
+         INTEGER, PARAMETER :: IrecPosted                    = 2
+         INTEGER, PARAMETER :: Received_NotProcessed         = 3
+         INTEGER, PARAMETER :: Processed_IrecNotneeded       = 4
+         INTEGER, PARAMETER :: Treating                      = 5
+      INCLUDE 'mumps_tags.h'
+      INCLUDE 'mpif.h'
+      INTEGER :: EndNZloc_copy, ISLAVE, NBREC, STATE, 
+     &           NB_END_MSG_2_RECV_COPY, ISLAVE_RECV 
+      INTEGER :: IERR, IACT_P, NEXT_IACT
+      INTEGER :: TAILLE_SEND_I, TAILLE_SEND_R
+      LOGICAL :: FLAG, FLAGRECV, ALL_LAST_MESS_SENT
+      INTEGER :: STATUS(MPI_STATUS_SIZE)
+      IF (MPI_InvolvedinSend.and.(.NOT.MPI_End_Send)) THEN
+        DO ISLAVE = 1, NPROCS
+          IF (ISLAVE-1.EQ.MYID) CYCLE
+          IF (SEND_ACTIVE( ISLAVE )) THEN
+              CALL MPI_TEST( ISENDREQR( ISLAVE ), FLAG, STATUS, IERR )
+              IF (FLAG) THEN
+                CALL MPI_WAIT( ISENDREQI( ISLAVE ), STATUS, IERR )
+                SEND_ACTIVE( ISLAVE ) = .FALSE.
+              ENDIF
+          ENDIF
+        ENDDO
+!$OMP   ATOMIC READ
+        EndNZloc_copy = EndNZloc
+!$OMP   END ATOMIC 
+        ALL_LAST_MESS_SENT = (EndNZloc_copy.EQ.0)
+        IF (EndNZloc_copy.NE.-1) THEN
+          DO ISLAVE=1, NPROCS
+            IF (ISLAVE-1.EQ.MYID) CYCLE
+            IF (EndNZloc_copy .EQ. 0) THEN
+             NBREC = 
+     &         min(BUFSEND_POSRESERVED(IACT(ISLAVE),ISLAVE),NBRECORDS)
+             IF (NBREC.EQ.-99) CYCLE
+             BUFSENDI(1,IACT(ISLAVE),ISLAVE) = - NBREC
+            ELSE
+!$OMP         ATOMIC READ
+              NBREC = BUFSENDI(1,IACT(ISLAVE),ISLAVE)
+!$OMP         END ATOMIC
+            ENDIF
+            IF ((EndNZloc_copy.EQ.0).OR.(NBREC.EQ.NBRECORDS)) THEN
+              IF (.NOT.SEND_ACTIVE(ISLAVE)) THEN
+                TAILLE_SEND_I = NBREC * 2 + 1
+                TAILLE_SEND_R = NBREC
+                IACT_P = IACT(ISLAVE)
+                CALL MPI_ISEND( BUFSENDI(1, IACT_P, ISLAVE ),
+     &              TAILLE_SEND_I,
+     &              MPI_INTEGER, ISLAVE - 1, 
+     &              ARR_INT, COMM,
+     &              ISENDREQI( ISLAVE ), IERR )
+                CALL MPI_ISEND( BUFSENDR(1, IACT_P, ISLAVE ),
+     &              TAILLE_SEND_R,
+     &              MPI_COMPLEX, ISLAVE - 1, 
+     &              ARR_REAL, COMM,
+     &              ISENDREQR( ISLAVE ), IERR )
+                SEND_ACTIVE( ISLAVE ) = .TRUE.
+                IF (EndNZloc_copy.NE.0) THEN
+                  NEXT_IACT = 3-IACT_P
+!$OMP             ATOMIC WRITE
+                  BUFSEND_POSRESERVED(NEXT_IACT,ISLAVE) = 0
+!$OMP             END ATOMIC
+!$OMP             ATOMIC WRITE
+                  BUFSENDI(1,NEXT_IACT,ISLAVE) = 0
+!$OMP             END ATOMIC
+!$OMP             ATOMIC WRITE
+                  IACT( ISLAVE ) = NEXT_IACT
+!$OMP             END ATOMIC
+                ELSE
+                  BUFSEND_POSRESERVED(IACT_P,ISLAVE) = -99
+                ENDIF
+              ELSE
+                ALL_LAST_MESS_SENT=.FALSE.
+              ENDIF
+            ENDIF
+          ENDDO
+        ENDIF
+        IF (EndNZloc_copy.EQ.0.AND.ALL_LAST_MESS_SENT) THEN 
+            EndNZloc      = -1  
+            EndNZloc_copy = -1  
+        ENDIF
+        IF (.NOT.MPI_End_Send) THEN
+          IF ( (EndNZloc_copy.EQ.-1) )  THEN
+            MPI_End_Send = .TRUE.
+            DO ISLAVE = 1, NPROCS
+               IF (ISLAVE-1.EQ.MYID) CYCLE
+               IF (SEND_ACTIVE( ISLAVE )) THEN 
+                 MPI_End_Send=.FALSE.
+                 EXIT
+               ENDIF
+            ENDDO
+          ENDIF
+        ENDIF
+      ENDIF
+      IF (MPI_InvolvedinRecv.AND.(.NOT.End_TreatRecvBuf)) THEN
+        CALL MPI_TESTANY(NPROCS, IRECVREQR, ISLAVE_RECV, 
+     &                   FLAGRECV, STATUS,IERR)
+        IF (FLAGRECV.AND.(ISLAVE_RECV.NE.MPI_UNDEFINED)) 
+     &            THEN
+            CALL MPI_WAIT(IRECVREQI(ISLAVE_RECV),STATUS,IERR)
+!$OMP       ATOMIC WRITE
+            RECV_BUF_STATUS(ISLAVE_RECV)=Received_NotProcessed
+!$OMP       END ATOMIC
+        ENDIF
+        DO  ISLAVE = 1, NPROCS
+          IF (ISLAVE - 1 .EQ. MYID) CYCLE
+!$OMP     ATOMIC READ
+          STATE = RECV_BUF_STATUS(ISLAVE)
+!$OMP     END ATOMIC
+          IF (STATE.EQ.Processed_IrecNeeded) THEN
+            CALL MPI_IRECV ( BUFRECVI(1,ISLAVE), NBRECORDS * 2 + 1,  
+     &              MPI_INTEGER, ISLAVE-1, ARR_INT, COMM, 
+     &              IRECVREQI(ISLAVE), IERR)
+            CALL MPI_IRECV ( BUFRECVR(1,ISLAVE), NBRECORDS,
+     &              MPI_COMPLEX, ISLAVE-1, 
+     &              ARR_REAL, COMM,
+     &              IRECVREQR(ISLAVE), IERR)
+!$OMP       ATOMIC WRITE
+            RECV_BUF_STATUS(ISLAVE) = IrecPosted
+!$OMP       END ATOMIC
+          ENDIF
+        ENDDO
+!$OMP   ATOMIC READ
+        NB_END_MSG_2_RECV_COPY = NB_END_MSG_2_RECV
+!$OMP   END ATOMIC
+        IF (NB_END_MSG_2_RECV_COPY.EQ.0) THEN
+          End_TreatRecvBuf = .TRUE.
+          DO ISLAVE = 1, NPROCS
+            IF (ISLAVE - 1 .EQ. MYID) CYCLE
+            IF (RECV_BUF_STATUS(ISLAVE).NE.Processed_IrecNotneeded) THEN
+               End_TreatRecvBuf = .FALSE.
+               EXIT
+            ENDIF
+          ENDDO
+        ENDIF
+      ENDIF
+      RETURN
+      END SUBROUTINE CMUMPS_ARROW_TRY_PROGRESS_COMM 
+      SUBROUTINE CMUMPS_ARROW_TRY_TREAT_RECV_BUF (IOMP,
+     &             BUFRECVI, BUFRECVR, RECV_BUF_STATUS, 
+     &             NPROCS, NBRECORDS, N, IW4,
+     &             KEEP, LOCAL_M, LOCAL_N, root, PTR_ROOT, S, LA,
+     &             NB_END_MSG_2_RECV, MYID, PROCNODE_STEPS,
+     &             SLAVEF,
+     &             PTRAW, 
+     &             PTR8ARR, NINCOLARR, NINROWARR, PTRDEBARR,
+     &             PERM, STEP,
+     &             INTARR, LINTARR, DBLARR, LDBLARR, 
+     &             NOMP_SHARED, EARLYT3ROOTINS, NO_ATOMIC_Warrow )
+      USE CMUMPS_STRUC_DEF, ONLY : CMUMPS_ROOT_STRUC
+      IMPLICIT NONE
+      TYPE (CMUMPS_ROOT_STRUC) :: root
+      INTEGER, INTENT(IN):: IOMP, NPROCS, NBRECORDS, N, MYID, SLAVEF,
+     &                      NOMP_SHARED
+      LOGICAL, INTENT(IN):: EARLYT3ROOTINS
+      INTEGER, INTENT(IN):: BUFRECVI( NBRECORDS * 2 + 1, NPROCS )
+      COMPLEX, INTENT(IN):: BUFRECVR( NBRECORDS, NPROCS )
+      INTEGER, INTENT(INOUT) :: RECV_BUF_STATUS(NPROCS)
+      INTEGER, INTENT(INOUT):: IW4( N, 2 )
+      INTEGER, INTENT(IN):: KEEP(500)
+      INTEGER, INTENT(INOUT):: NB_END_MSG_2_RECV
+      INTEGER(8), INTENT(IN) :: PTRAW( N )
+      INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
+      INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
+      INTEGER, INTENT(IN) :: NINROWARR(KEEP(195))
+      INTEGER, INTENT(IN) :: PTRDEBARR(KEEP(196))
+      INTEGER, INTENT(IN) :: PERM( N ), STEP( N )
+      INTEGER, INTENT(IN) :: PROCNODE_STEPS( KEEP(28) )
+      INTEGER(8), INTENT(IN) :: LINTARR, LDBLARR
+      INTEGER, INTENT(INOUT) ::  INTARR( LINTARR )
+      INTEGER, INTENT(IN)::  LOCAL_M, LOCAL_N
+      INTEGER(8), INTENT(IN) :: PTR_ROOT, LA
+      COMPLEX, INTENT(INOUT) :: S( LA ), DBLARR( LDBLARR )
+      LOGICAL, INTENT(IN)    :: NO_ATOMIC_Warrow
+         INTEGER, PARAMETER :: Processed_IrecNeeded          = 1
+         INTEGER, PARAMETER :: IrecPosted                    = 2
+         INTEGER, PARAMETER :: Received_NotProcessed         = 3
+         INTEGER, PARAMETER :: Processed_IrecNotneeded       = 4
+         INTEGER, PARAMETER :: Treating                      = 5
+         INTEGER, PARAMETER :: BeingTreatednotbyme           = 6
+      INTEGER MUMPS_TYPENODE
+      EXTERNAL MUMPS_TYPENODE
+      INTEGER STATE, ISLAVE
+      DO ISLAVE =1, NPROCS
+         IF (MYID.EQ.ISLAVE-1) CYCLE
+!$OMP    ATOMIC READ
+         STATE = RECV_BUF_STATUS(ISLAVE)
+!$OMP    END ATOMIC
+         IF (STATE.EQ.Treating) CYCLE
+         IF (STATE.EQ.Received_NotProcessed) THEN
+          IF (NOMP_SHARED.EQ.1) THEN
+            RECV_BUF_STATUS(ISLAVE) = Treating
+            STATE                   = Treating
+          ELSE IF (KEEP(399).LE.3) THEN
+!$OMP       ATOMIC WRITE
+            RECV_BUF_STATUS(ISLAVE) = Treating
+!$OMP       END ATOMIC
+            STATE                   = Treating
+          ELSE
+!$OMP      CRITICAL(ARROW_RECV_BUF_STATUS)
+!$OMP        ATOMIC READ
+             STATE = RECV_BUF_STATUS(ISLAVE)
+!$OMP        END ATOMIC
+             IF (STATE.EQ.Received_NotProcessed) THEN
+!$OMP          ATOMIC WRITE
+               RECV_BUF_STATUS(ISLAVE) = Treating
+!$OMP          END ATOMIC 
+               STATE                   = Treating
+             ELSE
+               STATE                   = BeingTreatednotbyme
+             ENDIF
+!$OMP      END CRITICAL(ARROW_ RECV_BUF_STATUS)
+          ENDIF
+         ENDIF
+        IF (STATE.NE.Treating) CYCLE
+        IF (NO_ATOMIC_Warrow) THEN
+          CALL CMUMPS_ARROW_TREAT_RECV_BUF_1TH()
+        ELSE
+          CALL CMUMPS_ARROW_TREAT_RECV_BUF()
+        ENDIF
+      ENDDO 
+      RETURN
+      CONTAINS
+      SUBROUTINE  CMUMPS_ARROW_TREAT_RECV_BUF()
+      INTEGER :: IREC, NB_REC, TYPE_NODE
+      INTEGER :: IPOSROOT, JPOSROOT, ILOCROOT, JLOCROOT
+      INTEGER(8) :: IS8
+      INTEGER    :: IARR, JARR, IW4_CAPTURED
+      INTEGER    :: NB_END_MSG_2_RECV_COPY
+      COMPLEX    :: VAL
+      LOGICAL    :: LAST_MESSAGE
+      LAST_MESSAGE = .FALSE.
+      NB_REC = BUFRECVI( 1, ISLAVE )
+      TYPE_NODE = -998
+      IF ( NB_REC .LE. 0 ) THEN
+        LAST_MESSAGE = .TRUE.
+!$OMP ATOMIC CAPTURE
+        NB_END_MSG_2_RECV_COPY = NB_END_MSG_2_RECV
+        NB_END_MSG_2_RECV      = NB_END_MSG_2_RECV - 1   
+!$OMP END ATOMIC
+        NB_REC = - NB_REC
+      END IF
+      IF ( NB_REC .eq. 0 ) GOTO 100
+      DO IREC = 1, NB_REC
+        IARR = BUFRECVI( IREC * 2, ISLAVE )
+        JARR = BUFRECVI( IREC * 2 + 1, ISLAVE )
+        VAL  = BUFRECVR( IREC, ISLAVE )
+        IF (EARLYT3ROOTINS) THEN
+          TYPE_NODE = MUMPS_TYPENODE( 
+     &              PROCNODE_STEPS(abs(STEP(abs( IARR )))),
+     &              KEEP(199) )
+        ENDIF
+        IF ( TYPE_NODE .eq. 3 .AND. EARLYT3ROOTINS ) THEN
+          IF ( IARR .GT. 0 ) THEN
+            IPOSROOT = root%RG2L( IARR )
+            JPOSROOT = root%RG2L( JARR )
+          ELSE
+            IPOSROOT = root%RG2L( JARR )
+            JPOSROOT = root%RG2L( -IARR )
+          END IF
+          ILOCROOT = root%MBLOCK * ( ( IPOSROOT - 1 ) /
+     &                 ( root%MBLOCK * root%NPROW ) )
+     &               + mod( IPOSROOT - 1, root%MBLOCK ) + 1
+          JLOCROOT = root%NBLOCK * ( ( JPOSROOT - 1 ) /
+     &                 ( root%NBLOCK * root%NPCOL ) )
+     &               + mod( JPOSROOT - 1, root%NBLOCK ) + 1
+          IF (KEEP(60)==0) THEN
+!$OMP ATOMIC UPDATE
+            S( PTR_ROOT + int(JLOCROOT-1,8) * int(LOCAL_M,8)
+     &        + int(ILOCROOT-1,8)) =  S( PTR_ROOT
+     &        + int(JLOCROOT - 1,8) * int(LOCAL_M,8)
+     &        + int(ILOCROOT - 1,8) )
+     &      + VAL
+!$OMP END ATOMIC
+          ELSE
+!$OMP ATOMIC UPDATE
+            root%SCHUR_POINTER( int(JLOCROOT-1,8)
+     &                      * int(root%SCHUR_LLD,8)
+     &                      + int(ILOCROOT,8) )
+     &      = root%SCHUR_POINTER( int(JLOCROOT - 1,8)
+     &                      * int(root%SCHUR_LLD,8)
+     &                      + int(ILOCROOT,8))
+     &      + VAL
+!$OMP END ATOMIC
+          ENDIF
+        ELSE IF (IARR.GE.0) THEN
+          IF (IARR.EQ.JARR) THEN
+            IS8 = PTRAW(IARR)
+!$OMP ATOMIC UPDATE
+            DBLARR(IS8) = DBLARR(IS8) + VAL
+!$OMP END ATOMIC
+          ELSE
+!$OMP ATOMIC CAPTURE
+            IW4_CAPTURED= IW4(IARR,2)
+            IW4(IARR,2) = IW4(IARR,2) - 1
+!$OMP END ATOMIC
+            IS8         = PTRAW(IARR)+int(IW4_CAPTURED,8)
+            INTARR(IS8) = JARR
+            DBLARR(IS8) = VAL
+          ENDIF
+        ELSE
+          IARR         = -IARR
+!$OMP ATOMIC CAPTURE
+          IW4_CAPTURED   = IW4(IARR,1)
+          IW4(IARR,1)    = IW4(IARR,1) - 1
+!$OMP END ATOMIC
+          IS8          = PTRAW(IARR) + int(IW4_CAPTURED,8)
+          INTARR(IS8)  = JARR
+          DBLARR(IS8)  = VAL
+        ENDIF
+      ENDDO
+ 100  CONTINUE
+      IF (LAST_MESSAGE) THEN
+!$OMP ATOMIC WRITE
+         RECV_BUF_STATUS(ISLAVE) = Processed_IrecNotneeded
+!$OMP END ATOMIC
+      ELSE
+!$OMP ATOMIC WRITE
+         RECV_BUF_STATUS(ISLAVE) = Processed_IrecNeeded
+!$OMP END ATOMIC
+      ENDIF
+      RETURN
+      END SUBROUTINE  CMUMPS_ARROW_TREAT_RECV_BUF
+      SUBROUTINE  CMUMPS_ARROW_TREAT_RECV_BUF_1TH()
+      INTEGER :: IREC, NB_REC, TYPE_NODE
+      INTEGER :: IPOSROOT, JPOSROOT, ILOCROOT, JLOCROOT
+      INTEGER(8) :: IS8
+      INTEGER    :: IARR, JARR
+      INTEGER    :: NB_END_MSG_2_RECV_COPY
+      COMPLEX    :: VAL
+      LOGICAL    :: LAST_MESSAGE
+      LAST_MESSAGE = .FALSE.
+      NB_REC = BUFRECVI( 1, ISLAVE )
+      IF ( NB_REC .LE. 0 ) THEN
+        LAST_MESSAGE = .TRUE.
+!$OMP ATOMIC CAPTURE
+        NB_END_MSG_2_RECV_COPY = NB_END_MSG_2_RECV
+        NB_END_MSG_2_RECV      = NB_END_MSG_2_RECV - 1   
+!$OMP END ATOMIC
+        NB_REC = - NB_REC
+      END IF 
+      IF ( NB_REC .eq. 0 ) GOTO 100
+      DO IREC = 1, NB_REC
+        IARR = BUFRECVI( IREC * 2, ISLAVE )
+        JARR = BUFRECVI( IREC * 2 + 1, ISLAVE )
+        VAL  = BUFRECVR( IREC, ISLAVE )
+        IF (EARLYT3ROOTINS) THEN
+          TYPE_NODE = MUMPS_TYPENODE( 
+     &              PROCNODE_STEPS(abs(STEP(abs( IARR )))),
+     &              KEEP(199) )
+        ENDIF
+        IF ( TYPE_NODE .eq. 3 .AND. EARLYT3ROOTINS ) THEN
+          IF ( IARR .GT. 0 ) THEN
+            IPOSROOT = root%RG2L( IARR )
+            JPOSROOT = root%RG2L( JARR )
+          ELSE
+            IPOSROOT = root%RG2L( JARR )
+            JPOSROOT = root%RG2L( -IARR )
+          END IF
+          ILOCROOT = root%MBLOCK * ( ( IPOSROOT - 1 ) /
+     &                 ( root%MBLOCK * root%NPROW ) )
+     &               + mod( IPOSROOT - 1, root%MBLOCK ) + 1
+          JLOCROOT = root%NBLOCK * ( ( JPOSROOT - 1 ) /
+     &                 ( root%NBLOCK * root%NPCOL ) )
+     &               + mod( JPOSROOT - 1, root%NBLOCK ) + 1
+          IF (KEEP(60)==0) THEN
+            S( PTR_ROOT + int(JLOCROOT-1,8) * int(LOCAL_M,8)
+     &        + int(ILOCROOT-1,8)) =  S( PTR_ROOT
+     &        + int(JLOCROOT - 1,8) * int(LOCAL_M,8)
+     &        + int(ILOCROOT - 1,8) )
+     &      + VAL
+          ELSE
+            root%SCHUR_POINTER( int(JLOCROOT-1,8)
+     &                      * int(root%SCHUR_LLD,8)
+     &                      + int(ILOCROOT,8) )
+     &      = root%SCHUR_POINTER( int(JLOCROOT - 1,8)
+     &                      * int(root%SCHUR_LLD,8)
+     &                      + int(ILOCROOT,8))
+     &      + VAL
+          ENDIF
+        ELSE IF (IARR.GE.0) THEN
+          IF (IARR.EQ.JARR) THEN
+            IS8 = PTRAW(IARR)
+            DBLARR(IS8) = DBLARR(IS8) + VAL
+          ELSE
+            IS8         = PTRAW(IARR)+IW4(IARR,2)
+            IW4(IARR,2) = IW4(IARR,2) - 1
+            INTARR(IS8) = JARR
+            DBLARR(IS8) = VAL
+          ENDIF
+        ELSE
+          IARR         = -IARR
+          IS8          = PTRAW(IARR)+IW4(IARR,1)
+          IW4(IARR,1)  = IW4(IARR,1) - 1
+          INTARR(IS8)  = JARR
+          DBLARR(IS8)  = VAL
+        ENDIF
+      ENDDO
+ 100  CONTINUE
+      IF (LAST_MESSAGE) THEN
+!$OMP ATOMIC WRITE
+         RECV_BUF_STATUS(ISLAVE) = Processed_IrecNotneeded
+!$OMP END ATOMIC
+      ELSE
+!$OMP ATOMIC WRITE
+         RECV_BUF_STATUS(ISLAVE) = Processed_IrecNeeded
+!$OMP END ATOMIC
+      ENDIF
+      RETURN
+      END SUBROUTINE  CMUMPS_ARROW_TREAT_RECV_BUF_1TH
+      END SUBROUTINE CMUMPS_ARROW_TRY_TREAT_RECV_BUF 
+      SUBROUTINE CMUMPS_FAC_ARROW_ARRANGE ( 
+     &  MYID, IOMP, N, SHIFT_PID, SLAVEF, LSCAL, NSEND8, NLOCAL8,
+     &  ILOC8_P, NB_RANGE_P, NZ_loc8, IRN_LOC, JCN_LOC, A_loc, SIZESCAL,
+     &  ROWSCA, COLSCA, ISTEP_TO_INIV2, CANDIDATES, KEEP, MPI_MASTER, 
+     &  NO_ATOMIC_Warrow, NO_ATOMIC_Wsendbuf, TH_InvolvedinTreatRecv,
+     &  NPROCS, NBRECORDS, MPI_InvolvedinSend, MPI_InvolvedinRecv,
+     &  COMM, ISENDREQI, ISENDREQR, BUFSENDI, BUFSENDR, IACT,
+     &  SEND_ACTIVE, BUFSEND_POSRESERVED, IRECVREQI, IRECVREQR,
+     &  BUFRECVI, BUFRECVR, RECV_BUF_STATUS, EndNZloc, MPI_End_Send,
+     &  End_TreatRecvBuf,
+     &  root, PTR_ROOT, ARROW_ROOT, EARLYT3ROOTINS, LOCAL_M, LOCAL_N,
+     &  S, LA, NB_END_MSG_2_RECV, PROCNODE_STEPS, IW4, PTRAW, 
+     &  PTR8ARR, NINCOLARR, NINROWARR, PTRDEBARR,
+     &  PERM, STEP, INTARR, LINTARR, DBLARR, LDBLARR, NOMP_SHARED )
+!$    USE OMP_LIB
+      USE CMUMPS_STRUC_DEF, ONLY : CMUMPS_ROOT_STRUC
+      IMPLICIT NONE
+      INTEGER, INTENT(IN)      :: MYID, IOMP, N, SHIFT_PID, 
+     &                            SLAVEF, SIZESCAL, MPI_MASTER
+      INTEGER, INTENT(IN)      :: NB_RANGE_P, KEEP(500)
+      INTEGER(8), INTENT(IN)   :: NZ_loc8, ILOC8_P
+      INTEGER(8), INTENT(INOUT):: NSEND8, NLOCAL8
+      INTEGER, INTENT(IN)      :: IRN_LOC(max(1_8,NZ_loc8)), 
+     &                            JCN_LOC(max(1_8,NZ_loc8))
+      INTEGER, INTENT(IN):: ISTEP_TO_INIV2(KEEP(71))
+      INTEGER, INTENT(IN):: CANDIDATES(SLAVEF+1, max(1,KEEP(56)))
+      COMPLEX, INTENT(IN):: A_loc(max(1_8,NZ_loc8))
+      REAL, INTENT(IN)   :: ROWSCA(SIZESCAL),
+     &                      COLSCA(SIZESCAL)
+      LOGICAL, INTENT(IN):: NO_ATOMIC_Warrow, NO_ATOMIC_Wsendbuf, 
+     &                      TH_InvolvedinTreatRecv
+      INTEGER, INTENT(IN) :: NPROCS, NBRECORDS, COMM, NOMP_SHARED
+      LOGICAL, INTENT(IN) :: MPI_InvolvedinSend, MPI_InvolvedinRecv, 
+     &                       LSCAL
+      INTEGER, INTENT(INOUT) :: EndNZloc
+      LOGICAL, INTENT(INOUT) :: MPI_End_Send, End_TreatRecvBuf
+      INTEGER, INTENT(INOUT) :: ISENDREQI(NPROCS), ISENDREQR(NPROCS), 
+     &     BUFSENDI(NBRECORDS * 2 + 1, 2, NPROCS), 
+     &     IACT(NPROCS), BUFSEND_POSRESERVED(2,NPROCS)
+      COMPLEX, INTENT(INOUT) :: BUFSENDR(NBRECORDS, 2, NPROCS)
+      LOGICAL, INTENT(INOUT) :: SEND_ACTIVE(NPROCS)
+      INTEGER, INTENT(INOUT) :: IRECVREQI(NPROCS), IRECVREQR(NPROCS), 
+     &     BUFRECVI(NBRECORDS * 2 + 1, NPROCS),
+     &     RECV_BUF_STATUS(NPROCS)
+      COMPLEX, INTENT(INOUT) :: BUFRECVR(NBRECORDS, NPROCS)
+         INTEGER, PARAMETER :: Processed_IrecNeeded          = 1
+         INTEGER, PARAMETER :: IrecPosted                    = 2
+         INTEGER, PARAMETER :: Received_NotProcessed         = 3
+         INTEGER, PARAMETER :: Processed_IrecNotneeded       = 4
+         INTEGER, PARAMETER :: Treating                      = 5
+      TYPE (CMUMPS_ROOT_STRUC) :: root
+      INTEGER, INTENT(IN)      :: LOCAL_M, LOCAL_N
+      LOGICAL, INTENT(IN)      :: EARLYT3ROOTINS
+      INTEGER, INTENT(INOUT)   :: ARROW_ROOT
+      INTEGER, INTENT(INOUT):: IW4( N, 2 )
+      INTEGER, INTENT(INOUT):: NB_END_MSG_2_RECV
+      INTEGER(8), INTENT(IN) :: PTRAW( N )
+      INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
+      INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
+      INTEGER, INTENT(IN) :: NINROWARR(KEEP(195))
+      INTEGER, INTENT(IN) :: PTRDEBARR(KEEP(196))
+      INTEGER, INTENT(IN) :: PERM( N ), STEP( N )
+      INTEGER, INTENT(IN) :: PROCNODE_STEPS( KEEP(28) )
+      INTEGER(8), INTENT(IN) :: LINTARR, LDBLARR
+      INTEGER, INTENT(INOUT) ::  INTARR( LINTARR )
+      INTEGER(8), INTENT(IN) :: PTR_ROOT, LA
+      COMPLEX, INTENT(INOUT) ::  S( LA ), DBLARR( LDBLARR )
+      INTEGER MUMPS_TYPESPLIT
+      EXTERNAL MUMPS_TYPESPLIT
+      INTEGER     :: DEST, JSEND, ISEND , DEST_SAVE
+      INTEGER     :: I, INIV2, NCAND, T4MASTER
+      INTEGER     :: IOLD, JOLD, IARR, TYPESPLIT
+      INTEGER(8)  :: IS8, IZ8, LAST8
+      LOGICAL     :: T4_MASTER_CONCERNED
+      INTEGER     :: MASTER_NODE, TYPE_NODE, ISTEP_P
+      INTEGER     :: IPOSROOT, JPOSROOT, ILOCROOT, JLOCROOT
+      INTEGER     :: IROW_GRID, JCOL_GRID, IW4_CAPTURED
+      LOGICAL     :: LOCAL_ASSEMBLY, LOCAL
+      COMPLEX     :: VAL
+      INTEGER     :: ISTEP_T3_1PROC
+      LAST8 = ILOC8_P + int(NB_RANGE_P-1,8)
+      LOCAL_ASSEMBLY  =  (NPROCS.EQ.1)
+      IF (NPROCS.EQ.1 .AND. KEEP(38).EQ.0) THEN
+        TYPE_NODE = 1
+        ISTEP_T3_1PROC  = -9999
+      ELSE IF (NPROCS.EQ.1 .AND. KEEP(38).NE.0) THEN
+        ISTEP_T3_1PROC = STEP(KEEP(38))
+      ELSE
+        ISTEP_T3_1PROC = -99999
+      ENDIF
+      DO IZ8=ILOC8_P, LAST8
+          IOLD = IRN_loc(IZ8)
+          JOLD = JCN_loc(IZ8)
+          IF ( (IOLD.GT.N).OR.(JOLD.GT.N).OR.(IOLD.LT.1)
+     &                 .OR.(JOLD.LT.1) ) THEN
+            CYCLE
+          ENDIF
+          IF (IOLD.EQ.JOLD) THEN
+            ISEND = IOLD
+            JSEND = IOLD
+            IARR  = IOLD
+          ELSE IF (PERM(IOLD).LT.PERM(JOLD)) THEN
+            IARR  = IOLD
+            IF ( KEEP(50) .NE. 0 ) THEN
+              ISEND = -IOLD
+            ELSE
+              ISEND = IOLD
+            ENDIF
+            JSEND = JOLD
+          ELSE
+            IARR  = JOLD
+            ISEND = -JOLD
+            JSEND = IOLD
+          ENDIF
+          VAL = A_loc(IZ8)
+          IF (LSCAL) THEN
+            VAL = VAL * ROWSCA(IOLD)*COLSCA(JOLD)
+          ENDIF
+          IF (NPROCS.GT.1 .OR. KEEP(38).NE.0) THEN
+            ISTEP_P = abs(STEP(IARR))
+            IF ( NPROCS.EQ.1 .AND. ISTEP_P.NE.ISTEP_T3_1PROC ) THEN
+              TYPE_NODE=1
+            ELSE IF (NPROCS.EQ.1) THEN
+              TYPE_NODE=3
+              IF (EARLYT3ROOTINS) THEN
+                IF ( ISEND < 0 ) THEN
+                  IPOSROOT = root%RG2L(JSEND)
+                  JPOSROOT = root%RG2L(IARR )
+                ELSE
+                  IPOSROOT = root%RG2L(IARR )
+                  JPOSROOT = root%RG2L(JSEND)
+                END IF
+              END IF
+            ELSE
+            ISTEP_P = abs(STEP(IARR))
+            CALL MUMPS_TYPEANDPROCNODE( TYPE_NODE, MASTER_NODE,
+     &      PROCNODE_STEPS(ISTEP_P), KEEP(199) )
+            MASTER_NODE = MASTER_NODE + SHIFT_PID
+            T4_MASTER_CONCERNED = .FALSE.
+            T4MASTER            = -9999
+            IF ( TYPE_NODE .eq. 1 ) THEN
+              DEST = MASTER_NODE
+            ELSE IF ( TYPE_NODE .eq. 2 ) THEN
+              IF ( ISEND .LT. 0 ) THEN
+                DEST = -1
+              ELSE
+                DEST = MASTER_NODE
+              END IF
+              INIV2         = ISTEP_TO_INIV2(ISTEP_P)
+              IF ( KEEP(79) .GT. 0) THEN
+                TYPESPLIT  = MUMPS_TYPESPLIT( PROCNODE_STEPS(ISTEP_P),
+     &                                        KEEP(199) )
+                IF ( (TYPESPLIT.EQ.5).OR.(TYPESPLIT.EQ.6)) THEN
+                  T4_MASTER_CONCERNED = .TRUE.
+                  T4MASTER=
+     &                   CANDIDATES(CANDIDATES(SLAVEF+1,INIV2)+1,INIV2)
+     &                 + SHIFT_PID
+                ENDIF
+              ENDIF
+            ELSE 
+              ARROW_ROOT = ARROW_ROOT + 1
+              IF (EARLYT3ROOTINS) THEN
+                IF ( ISEND < 0 ) THEN
+                  IPOSROOT = root%RG2L(JSEND)
+                  JPOSROOT = root%RG2L(IARR )
+                ELSE
+                  IPOSROOT = root%RG2L(IARR )
+                  JPOSROOT = root%RG2L(JSEND)
+                END IF
+                IROW_GRID = mod( ( IPOSROOT-1 )/root%MBLOCK, root%NPROW)
+                JCOL_GRID = mod( ( JPOSROOT-1 )/root%NBLOCK, root%NPCOL)
+                DEST = IROW_GRID * root%NPCOL + JCOL_GRID + SHIFT_PID
+              ELSE
+                DEST = -2
+              ENDIF
+            ENDIF
+            IF (DEST .eq. -1) THEN
+              NLOCAL8 = NLOCAL8 + 1_8
+              NSEND8  = NSEND8 + int(SLAVEF -1,8)
+            ELSE IF (DEST .EQ. -2) THEN
+              NLOCAL8 = NLOCAL8 + 1_8
+              NSEND8  = NSEND8 + int(SLAVEF -1,8)
+            ELSE
+              IF (DEST .eq.MYID ) THEN
+                NLOCAL8 = NLOCAL8 + 1_8
+              ELSE
+                NSEND8 = NSEND8 + 1_8
+              ENDIF
+            ENDIF
+            LOCAL_ASSEMBLY = .FALSE.
+            IF ( DEST.EQ.-1) THEN
+              INIV2 = ISTEP_TO_INIV2(ISTEP_P)
+              NCAND = CANDIDATES(SLAVEF+1,INIV2)
+              IF (KEEP(79) .GT. 0) THEN
+                DO I=1, SLAVEF
+                  DEST=CANDIDATES(I,INIV2) + SHIFT_PID
+                  IF (DEST.LT.0) EXIT 
+                  LOCAL = (DEST.EQ.MYID)
+                  IF (LOCAL) LOCAL_ASSEMBLY = .TRUE.
+                  IF (LOCAL) CYCLE
+                  IF (I.EQ.NCAND+1) CYCLE
+                  CALL CMUMPS_DIST_FILL_SEND_BUFFER()
+                ENDDO
+              ELSE
+                DO I=1, NCAND
+                  DEST=CANDIDATES(I,INIV2) + SHIFT_PID
+                  LOCAL = (DEST.EQ.MYID)
+                  IF (LOCAL) LOCAL_ASSEMBLY = .TRUE.
+                  IF (LOCAL) CYCLE
+                  CALL CMUMPS_DIST_FILL_SEND_BUFFER()
+                ENDDO
+              ENDIF
+              IF ( LOCAL_ASSEMBLY ) THEN
+                DEST_SAVE = DEST
+                DEST      = MASTER_NODE
+                IF (DEST.NE.MYID)
+     &           CALL CMUMPS_DIST_FILL_SEND_BUFFER()
+                IF (T4_MASTER_CONCERNED) THEN
+                  DEST   = T4MASTER
+                  IF (DEST.NE.MYID)
+     &             CALL CMUMPS_DIST_FILL_SEND_BUFFER()
+                ENDIF
+                DEST = DEST_SAVE
+              ELSE
+                DEST=MASTER_NODE
+                LOCAL_ASSEMBLY = (DEST.EQ.MYID)
+                IF (.NOT.LOCAL_ASSEMBLY) 
+     &           CALL CMUMPS_DIST_FILL_SEND_BUFFER()
+                IF (T4_MASTER_CONCERNED) THEN
+                  DEST = T4MASTER
+                  LOCAL_ASSEMBLY = (DEST.EQ.MYID)
+                  IF (.NOT.LOCAL_ASSEMBLY) 
+     &             CALL CMUMPS_DIST_FILL_SEND_BUFFER()
+                ENDIF
+              ENDIF
+            ELSE IF (DEST .GE. 0) THEN
+              LOCAL_ASSEMBLY = (DEST.EQ.MYID)
+              IF (.NOT.LOCAL_ASSEMBLY) 
+     &             CALL CMUMPS_DIST_FILL_SEND_BUFFER()
+              IF (T4_MASTER_CONCERNED) THEN
+                DEST = T4MASTER
+                LOCAL_ASSEMBLY = (DEST.EQ.MYID)
+                IF (.NOT.LOCAL_ASSEMBLY) 
+     &             CALL CMUMPS_DIST_FILL_SEND_BUFFER()
+              ENDIF
+            ELSE IF (DEST .EQ. -2) THEN
+              DO I = 0, SLAVEF-1
+                DEST=I + SHIFT_PID
+                IF (DEST.NE.MYID) 
+     &             CALL CMUMPS_DIST_FILL_SEND_BUFFER()
+              ENDDO
+              IF (SHIFT_PID.EQ.1.AND.MYID.EQ.MPI_MASTER) THEN
+                LOCAL_ASSEMBLY=.FALSE.
+              ELSE
+                LOCAL_ASSEMBLY=.TRUE. 
+              ENDIF
+            ENDIF
+          ENDIF
+          ENDIF
+          IF (LOCAL_ASSEMBLY) THEN
+            IF ( TYPE_NODE .eq. 3 .AND. EARLYT3ROOTINS ) THEN
+              ILOCROOT = root%MBLOCK * ( ( IPOSROOT - 1 ) /
+     &                     ( root%MBLOCK * root%NPROW ) )
+     &                   + mod( IPOSROOT - 1, root%MBLOCK ) + 1
+              JLOCROOT = root%NBLOCK * ( ( JPOSROOT - 1 ) /
+     &                     ( root%NBLOCK * root%NPCOL ) )
+     &                   + mod( JPOSROOT - 1, root%NBLOCK ) + 1
+              IF (KEEP(60)==0) THEN
+!$OMP ATOMIC UPDATE
+                S( PTR_ROOT + int(JLOCROOT-1,8) * int(LOCAL_M,8)
+     &            + int(ILOCROOT-1,8)) =  S( PTR_ROOT
+     &            + int(JLOCROOT - 1,8) * int(LOCAL_M,8)
+     &            + int(ILOCROOT - 1,8) )
+     &          + VAL
+!$OMP END ATOMIC
+              ELSE
+!$OMP ATOMIC UPDATE
+                root%SCHUR_POINTER( int(JLOCROOT-1,8)
+     &                          * int(root%SCHUR_LLD,8)
+     &                          + int(ILOCROOT,8) )
+     &          = root%SCHUR_POINTER( int(JLOCROOT - 1,8)
+     &                          * int(root%SCHUR_LLD,8)
+     &                          + int(ILOCROOT,8))
+     &          + VAL
+!$OMP END ATOMIC
+              ENDIF
+            ELSE
+      IF (NO_ATOMIC_Warrow) THEN
+             IF (ISEND.EQ.JSEND) THEN
+               IS8         = PTRAW(ISEND)
+               DBLARR(IS8) = DBLARR(IS8) + VAL
+             ELSE IF (ISEND.GE.0) THEN 
+               IS8         = PTRAW(IARR)+IW4(IARR,2)
+               IW4(IARR,2) = IW4(IARR,2) - 1
+               INTARR(IS8) = JSEND
+               DBLARR(IS8) = VAL
+             ELSE 
+               IS8         = PTRAW(IARR)+IW4(IARR,1)
+               IW4(IARR,1) = IW4(IARR,1) - 1
+               INTARR(IS8) = JSEND
+               DBLARR(IS8) = VAL
+             ENDIF
+      ELSE
+             IF (ISEND.EQ.JSEND) THEN
+               IS8         = PTRAW(ISEND)
+!$OMP ATOMIC UPDATE
+               DBLARR(IS8) = DBLARR(IS8) + VAL
+!$OMP END ATOMIC
+             ELSE IF (ISEND.GE.0) THEN 
+!$OMP ATOMIC CAPTURE
+               IW4_CAPTURED = IW4(IARR,2)
+               IW4(IARR,2)  = IW4(IARR,2) - 1
+!$OMP END ATOMIC
+               IS8         = PTRAW(IARR) + int(IW4_CAPTURED,8)
+               INTARR(IS8) = JSEND
+               DBLARR(IS8) = VAL
+             ELSE 
+!$OMP ATOMIC CAPTURE
+               IW4_CAPTURED = IW4(IARR,1)
+               IW4(IARR,1)  = IW4(IARR,1) - 1
+!$OMP END ATOMIC
+               IS8         = PTRAW(IARR) + int(IW4_CAPTURED,8)
+               INTARR(IS8) = JSEND
+               DBLARR(IS8) = VAL
+             ENDIF
+      ENDIF
+            ENDIF
+          ENDIF
+      ENDDO
+      RETURN
+      CONTAINS
+      SUBROUTINE CMUMPS_DIST_FILL_SEND_BUFFER( )
+      INTEGER IREQ, IACT_P, ISLAVE
+      ISLAVE = DEST+1
+ 100  CONTINUE
+!$OMP ATOMIC READ
+      IACT_P = IACT(ISLAVE)
+!$OMP END ATOMIC
+      IF (NO_ATOMIC_Wsendbuf) THEN
+        BUFSEND_POSRESERVED(IACT_P,ISLAVE) = 
+     &         BUFSEND_POSRESERVED(IACT_P, ISLAVE) + 1
+        IREQ = BUFSEND_POSRESERVED(IACT_P, ISLAVE)
+       IF (IREQ > NBRECORDS ) THEN
+         IF (IREQ > huge(NBRECORDS)-1000 - NOMP_SHARED-2) THEN
+          BUFSEND_POSRESERVED(IACT_P, ISLAVE) =  min(NBRECORDS+1, 
+     &                     BUFSEND_POSRESERVED(IACT_P, ISLAVE) )
+         ENDIF
+           IF (NOMP_SHARED.EQ.1)
+     &      CALL CMUMPS_ARROW_TRY_PROGRESS_COMM (IOMP,
+     &       MYID, NPROCS, NBRECORDS, 
+     &       MPI_InvolvedinSend, MPI_InvolvedinRecv, 
+     &       COMM, ISENDREQI, ISENDREQR, BUFSENDI, BUFSENDR, 
+     &       IACT, SEND_ACTIVE, BUFSEND_POSRESERVED, 
+     &       IRECVREQI, IRECVREQR, BUFRECVI, BUFRECVR,
+     &       RECV_BUF_STATUS, NB_END_MSG_2_RECV, 
+     &       EndNZloc, MPI_End_Send, End_TreatRecvBuf
+     &       )
+          IF (TH_InvolvedinTreatRecv) 
+     &    CALL CMUMPS_ARROW_TRY_TREAT_RECV_BUF (IOMP,
+     &             BUFRECVI, BUFRECVR, RECV_BUF_STATUS, 
+     &             NPROCS, NBRECORDS, N, IW4,
+     &             KEEP, LOCAL_M, LOCAL_N, root, PTR_ROOT, S, LA,
+     &             NB_END_MSG_2_RECV, MYID, PROCNODE_STEPS,
+     &             SLAVEF,
+     &             PTRAW, 
+     &             PTR8ARR, NINCOLARR, NINROWARR, PTRDEBARR,
+     &             PERM, STEP,
+     &             INTARR, LINTARR, DBLARR, LDBLARR, 
+     &             NOMP_SHARED, EARLYT3ROOTINS, NO_ATOMIC_Warrow)
+           IF (NOMP_SHARED.EQ.1) THEN
+             CALL CMUMPS_ARROW_TRY_PROGRESS_COMM (IOMP,
+     &        MYID, NPROCS, NBRECORDS, 
+     &        MPI_InvolvedinSend, MPI_InvolvedinRecv, 
+     &        COMM, ISENDREQI, ISENDREQR, BUFSENDI, BUFSENDR, 
+     &        IACT, SEND_ACTIVE, BUFSEND_POSRESERVED, 
+     &        IRECVREQI, IRECVREQR, BUFRECVI, BUFRECVR,
+     &        RECV_BUF_STATUS, NB_END_MSG_2_RECV, 
+     &        EndNZloc, MPI_End_Send, End_TreatRecvBuf
+     &        )
+           ELSE
+              IF (.NOT.TH_InvolvedinTreatRecv) THEN
+               CALL MUMPS_USLEEP(200)
+              ELSE
+               CALL MUMPS_USLEEP(20)
+              ENDIF
+           ENDIF
+         GOTO 100
+       ENDIF
+       BUFSENDI(IREQ*2,IACT_P,ISLAVE)   = ISEND
+       BUFSENDI(IREQ*2+1,IACT_P,ISLAVE) = JSEND
+       BUFSENDR(IREQ,IACT_P,ISLAVE )    = VAL
+       IF (IREQ.EQ.NBRECORDS) THEN
+!$OMP    ATOMIC WRITE
+            BUFSENDI(1,IACT_P,ISLAVE) = NBRECORDS
+!$OMP    END ATOMIC 
+       ENDIF
+      ELSE
+!$OMP  ATOMIC CAPTURE
+       BUFSEND_POSRESERVED(IACT_P,ISLAVE) = 
+     &         BUFSEND_POSRESERVED(IACT_P, ISLAVE) + 1
+       IREQ = BUFSEND_POSRESERVED(IACT_P, ISLAVE)
+!$OMP  END ATOMIC
+       IF (IREQ > huge(NBRECORDS)-NOMP_SHARED-2) THEN
+!$OMP   ATOMIC UPDATE
+        BUFSEND_POSRESERVED(IACT_P, ISLAVE) =  min(NBRECORDS+1, 
+     &                     BUFSEND_POSRESERVED(IACT_P, ISLAVE) )
+!$OMP   END ATOMIC
+       ENDIF
+       IF (IREQ > NBRECORDS ) THEN
+          IF (NOMP_SHARED.EQ.1) THEN
+            CALL CMUMPS_ARROW_TRY_PROGRESS_COMM (IOMP,
+     &       MYID, NPROCS, NBRECORDS, 
+     &       MPI_InvolvedinSend, MPI_InvolvedinRecv, 
+     &       COMM, ISENDREQI, ISENDREQR, BUFSENDI, BUFSENDR, 
+     &       IACT, SEND_ACTIVE, BUFSEND_POSRESERVED, 
+     &       IRECVREQI, IRECVREQR, BUFRECVI, BUFRECVR,
+     &       RECV_BUF_STATUS, NB_END_MSG_2_RECV, 
+     &       EndNZloc, MPI_End_Send, End_TreatRecvBuf
+     &       )
+          ENDIF
+          IF (TH_InvolvedinTreatRecv) 
+     &    CALL CMUMPS_ARROW_TRY_TREAT_RECV_BUF (IOMP,
+     &             BUFRECVI, BUFRECVR, RECV_BUF_STATUS, 
+     &             NPROCS, NBRECORDS, N, IW4,
+     &             KEEP, LOCAL_M, LOCAL_N, root, PTR_ROOT, S, LA,
+     &             NB_END_MSG_2_RECV, MYID, PROCNODE_STEPS,
+     &             SLAVEF,
+     &             PTRAW, 
+     &             PTR8ARR, NINCOLARR, NINROWARR, PTRDEBARR,
+     &             PERM, STEP,
+     &             INTARR, LINTARR, DBLARR, LDBLARR, 
+     &             NOMP_SHARED, EARLYT3ROOTINS, NO_ATOMIC_Warrow)
+          IF (NOMP_SHARED.EQ.1) THEN
+             CALL CMUMPS_ARROW_TRY_PROGRESS_COMM (IOMP,
+     &        MYID, NPROCS, NBRECORDS, 
+     &        MPI_InvolvedinSend, MPI_InvolvedinRecv, 
+     &        COMM, ISENDREQI, ISENDREQR, BUFSENDI, BUFSENDR, 
+     &        IACT, SEND_ACTIVE, BUFSEND_POSRESERVED, 
+     &        IRECVREQI, IRECVREQR, BUFRECVI, BUFRECVR,
+     &        RECV_BUF_STATUS, NB_END_MSG_2_RECV, 
+     &        EndNZloc, MPI_End_Send, End_TreatRecvBuf
+     &        )
+          ELSE 
+            IF (.NOT.TH_InvolvedinTreatRecv) THEN
+             CALL MUMPS_USLEEP(200)
+            ELSE
+             CALL MUMPS_USLEEP(20)
+            ENDIF
+          ENDIF
+         GOTO 100
+         ENDIF
+         BUFSENDI(IREQ*2,IACT_P,ISLAVE)   = ISEND
+         BUFSENDI(IREQ*2+1,IACT_P,ISLAVE) = JSEND
+         BUFSENDR(IREQ,IACT_P,ISLAVE )    = VAL
+!$OMP    ATOMIC UPDATE
+         BUFSENDI(1,IACT_P,ISLAVE) = BUFSENDI(1,IACT_P,ISLAVE) + 1
+!$OMP    END ATOMIC 
+      ENDIF
+      RETURN
+      END SUBROUTINE CMUMPS_DIST_FILL_SEND_BUFFER
+      END SUBROUTINE CMUMPS_FAC_ARROW_ARRANGE
+#endif
diff -pruN 5.6.2-2.1/src/cfac_distrib_ELT.F 5.7.1-1/src/cfac_distrib_ELT.F
--- 5.6.2-2.1/src/cfac_distrib_ELT.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_distrib_ELT.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -38,8 +38,6 @@ C
       COMPLEX A( LA )
       TYPE(CMUMPS_STRUC)     :: id
       TYPE(CMUMPS_ROOT_STRUC) :: root
-      INTEGER numroc
-      EXTERNAL numroc
       INCLUDE 'mpif.h'
       INCLUDE 'mumps_tags.h'
       INTEGER :: IERR_MPI
diff -pruN 5.6.2-2.1/src/cfac_distrib_distentry.F 5.7.1-1/src/cfac_distrib_distentry.F
--- 5.6.2-2.1/src/cfac_distrib_distentry.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_distrib_distentry.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -126,10 +126,8 @@ C
       TYPE (CMUMPS_ROOT_STRUC) :: root
       INTEGER PROCNODE_STEPS(KEEP(28)), PERM( N ), STEP( N )
       INTEGER INFO( 80 ), ICNTL(60)
-      INTEGER MUMPS_PROCNODE, MUMPS_TYPENODE, numroc, 
-     &        MUMPS_TYPESPLIT
-      EXTERNAL MUMPS_PROCNODE, MUMPS_TYPENODE, numroc, 
-     &        MUMPS_TYPESPLIT
+      INTEGER MUMPS_TYPESPLIT
+      EXTERNAL MUMPS_TYPESPLIT
       INCLUDE 'mumps_tags.h'
       INCLUDE 'mpif.h'
       INTEGER :: IERR, MSGSOU
@@ -626,6 +624,7 @@ C
       KEEP(49) = ARROW_ROOT
  100  CONTINUE
       IF (ALLOCATED(IW4))     DEALLOCATE( IW4 )
+      IF (ALLOCATED(PTRAW))   DEALLOCATE( PTRAW )
       IF (ALLOCATED(BUFI))    DEALLOCATE( BUFI )
       IF (ALLOCATED(BUFR))    DEALLOCATE( BUFR )
       IF (ALLOCATED(BUFRECI)) DEALLOCATE( BUFRECI )
diff -pruN 5.6.2-2.1/src/cfac_driver.F 5.7.1-1/src/cfac_driver.F
--- 5.6.2-2.1/src/cfac_driver.F	2023-10-11 09:37:10.000000000 +0000
+++ 5.7.1-1/src/cfac_driver.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -137,8 +137,9 @@ C     (pointer to point on used-data in
       LOGICAL, PARAMETER :: BDUMMY =.FALSE.
       INTEGER, PARAMETER :: PANEL_TABSIZE = 20
       INTEGER COLOUR, COMM_FOR_SCALING ! For Simultaneous scaling
-      INTEGER LIWK, LWK_REAL
-      INTEGER(8) :: LWK
+      INTEGER(8) :: LIWK
+      INTEGER(8) :: LWK, LWK_REAL, LWRKR_TH, LWRKC_TH
+      INTEGER    :: NOMP_MAX
 C     I_AM_SLAVE: used to determine if proc has the role of a slave
 C     WK_USER_PROVIDED is set to true when WK_USER is provided by user
       LOGICAL I_AM_SLAVE, PERLU_ON, WK_USER_PROVIDED, EARLYT3ROOTINS
@@ -154,6 +155,7 @@ C     WK_USER_PROVIDED is set to true wh
 C temporary variables for collecting stats from all processors
       DOUBLE PRECISION :: TMP_MRY_LU_FR
       DOUBLE PRECISION :: TMP_MRY_LU_LRGAIN
+      INTEGER :: KEEP399_SAVE
       DOUBLE PRECISION :: TMP_MRY_CB_FR
       DOUBLE PRECISION :: TMP_MRY_CB_LRGAIN
       DOUBLE PRECISION :: TMP_FLOP_LRGAIN
@@ -203,18 +205,21 @@ C temporary variables for collecting sta
       DOUBLE PRECISION :: TMP_TIME_FRASM_MAPLIG1
       DOUBLE PRECISION :: TMP_TIME_FRASM_CONTRIB2
 C
-C  Workspace.
+C  Workspace
 C
       INTEGER, DIMENSION(:), ALLOCATABLE :: IWK
       COMPLEX, DIMENSION(:), ALLOCATABLE :: WK
-      REAL, DIMENSION(:), ALLOCATABLE :: WK_REAL
+      REAL, DIMENSION(:), ALLOCATABLE    :: WK_REAL
+      REAL, DIMENSION(:,:), ALLOCATABLE:: WRKR_TH, 
+     &                                    WRKC_TH
       INTEGER(8), DIMENSION(:), ALLOCATABLE :: IWK8
       INTEGER, DIMENSION(:), ALLOCATABLE :: BURP
       INTEGER, DIMENSION(:), ALLOCATABLE :: BUCP
       INTEGER, DIMENSION(:), ALLOCATABLE :: BURS
       INTEGER, DIMENSION(:), ALLOCATABLE :: BUCS
-      INTEGER BUREGISTRE(12)
-      INTEGER BUINTSZ, BURESZ, BUJOB
+      INTEGER(8) :: BUREGISTRE(12)
+      INTEGER(8) :: BUINTSZ, BURESZ, NZ_loc8
+      INTEGER    :: BUJOB
       INTEGER BUMAXMN, M, SCMYID, SCNPROCS
       REAL    SCONEERR, SCINFERR
 C
@@ -224,21 +229,23 @@ C
 *     Control parameters: see description in CMUMPSID
       REAL,DIMENSION(:),POINTER::RINFO, RINFOG
       REAL,DIMENSION(:),POINTER::    CNTL
-      INTEGER,DIMENSION(:),POINTER:: INFOG, KEEP
-      INTEGER, DIMENSION(:), POINTER :: MYIRN_loc, MYJCN_loc
-      COMPLEX, DIMENSION(:), POINTER :: MYA_loc
+      INTEGER,DIMENSION(:),POINTER   :: INFOG, KEEP
+      INTEGER, DIMENSION(:), POINTER :: IRN_loc_PTR, JCN_loc_PTR
+      REAL, DIMENSION(:), POINTER   :: COLSCA_PTR, 
+     &                                 ROWSCA_PTR
+      COMPLEX, DIMENSION(:), POINTER:: A_loc_PTR
       INTEGER, TARGET :: DUMMYIRN_loc(1), DUMMYJCN_loc(1)
+      REAL, TARGET    :: DUMMYSCA(1)
       COMPLEX, TARGET :: DUMMYA_loc(1)
       INTEGER,DIMENSION(:),POINTER::ICNTL
       EXTERNAL MUMPS_GET_POOL_LENGTH
-      INTEGER MUMPS_GET_POOL_LENGTH
+      INTEGER MUMPS_GET_POOL_LENGTH, SIZESCAL
       INTEGER(8) :: TOTAL_BYTES
       INTEGER(8) :: I8TMP, LWK_USER_SUM8
 C
 C  External references
 C  ===================
-      INTEGER numroc
-      EXTERNAL numroc
+      INTEGER, EXTERNAL :: MUMPS_NUMROC
       INTEGER:: NWORKING
       LOGICAL:: MEM_EFF_ALLOCATED
       INTEGER   :: TOTAL_MBYTES_UNDER_L0
@@ -260,13 +267,13 @@ C     --------------------------
       KEEP=>id%KEEP
       ICNTL=>id%ICNTL
       IF (id%KEEP8(29) .NE. 0) THEN
-        MYIRN_loc=>id%IRN_loc
-        MYJCN_loc=>id%JCN_loc
-        MYA_loc=>id%A_loc
+        IRN_loc_PTR=>id%IRN_loc
+        JCN_loc_PTR=>id%JCN_loc
+        A_loc_PTR=>id%A_loc
       ELSE
-        MYIRN_loc=>DUMMYIRN_loc
-        MYJCN_loc=>DUMMYJCN_loc
-        MYA_loc=>DUMMYA_loc
+        IRN_loc_PTR=>DUMMYIRN_loc
+        JCN_loc_PTR=>DUMMYJCN_loc
+        A_loc_PTR=>DUMMYA_loc
       ENDIF
       NOMP = 1 
       N = id%N
@@ -295,13 +302,6 @@ C     Number of symmetric swaps
       id%KEEP8(80)=0_8
 C     Largest increase of internal panel size
       id%KEEP(425) =0
-C     and KEEP8(83) to the ddress of ICNTL(50)
-C     Set KEEP8(84) to the address of RINFO(3)
-      IF (id%KEEP(500) .EQ. 0 ) THEN ! MUMPS called from Fortran
-        CALL MUMPS_ADDR_C( ICNTL(50), id%KEEP8(83) )
-        CALL MUMPS_ADDR_C( RINFO (3), id%KEEP8(84) )
-      ENDIF
-C
       PRINT_MAXAVG = .NOT.(id%NSLAVES.EQ.1 .AND. KEEP(46).EQ.1)
 C     Print per node informtation only in case ther are several
 C     compute nodes (id%KEEP(412): #MPI procs on comupte node)
@@ -451,15 +451,19 @@ C       For symmetric (non general) matr
 C       set (directly) CNTL1 = 0.0
 C       ---------------------------------------
         KEEP(17)=0
-        IF ( KEEP(50) .eq. 1 ) THEN
-          IF (CNTL1 .ne. ZERO ) THEN
-            IF ( PROKG ) THEN
-              WRITE(MPG,'(A)')
-     & '** Warning : SPD solver called, resetting CNTL(1) to 0.0E0'
-            END IF
-          END IF
-          CNTL1 = ZERO
-        END IF
+C       Automatic choice if CNTL(1)<0
+C       For rank-revealing (KEEP(19).GT.0) then
+C       set CNTL1=0.1 even if SYM=1 
+        IF (CNTL1.LT.ZERO) THEN
+C        automatic choice
+         IF (KEEP(19).GT.0) THEN
+          CNTL1=0.1E0
+         ELSE IF (KEEP(50).EQ.1) THEN
+          CNTL1=ZERO
+         ELSE
+          CNTL1=0.01E0
+         ENDIF
+        ENDIF
 C       CNTL1 threshold value must be between 
 C       0.0 and 1.0 (for SYM=0) and 0.5 (for SYM=1,2)
         IF (CNTL1.GT.ONE)   CNTL1=ONE
@@ -482,7 +486,7 @@ C        out of range values
          PARPIV_T1 =0
         ENDIF
 C       note that KEEP(50).EQ.1 => CNTL1=0.0
-        IF (CNTL1.EQ.0.0.OR.(KEEP(50).eq.1)) PARPIV_T1 = 0 
+        IF (CNTL1.EQ.0.0E0.OR.(KEEP(50).eq.1)) PARPIV_T1 = 0 
 C
         IF (PARPIV_T1.EQ.-2) THEN
          IF (KEEP(19).NE.0) THEN
@@ -498,6 +502,22 @@ C         but do NOT switch off PARPIV_1
         CALL MPI_BCAST( KEEP(269), 1, MPI_INTEGER,
      &                  MASTER, id%COMM, IERR )
         IF (id%MYID.EQ.MASTER) THEN
+C{
+C         OMP parallelization of arrowheads
+C         out of range are treated as zero
+          IF (KEEP(399).LT.-1) KEEP(399)=-1
+          KEEP399_SAVE = KEEP(399)
+          IF (KEEP(399).EQ.-1) THEN
+            IF ((KEEP(54).EQ.0).AND.(id%NPROCS.GT.1)) THEN
+              KEEP(399) = 1
+            ELSE
+              KEEP(399) = 3
+            ENDIF
+          ENDIF
+#if defined(PCPRET)
+C         new multithreaded >=2 algo does not compile on PCPRET
+          KEEP(399) = 1
+#endif
 C         -----------------------------------------------------
 C         Decoding of ICNTL(35) for factorization: same as
 C         at analysis except that we store a copy of ICNTL(35)
@@ -628,11 +648,16 @@ C             Reset to 3 if 5 or to 4 if
             ENDIF
           ENDIF
  105    CONTINUE
+C}
         ENDIF  ! id%MYID .EQ. MASTER
         CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                        id%COMM, id%MYID )
 C
         IF (id%INFO(1).LT.0) GOTO 530
+        CALL MPI_BCAST( KEEP(281), 1, MPI_INTEGER,
+     &                  MASTER, id%COMM, IERR )
+        CALL MPI_BCAST( KEEP(399), 1, MPI_INTEGER,
+     &                  MASTER, id%COMM, IERR )
         CALL MPI_BCAST( KEEP(473), 14, MPI_INTEGER,
      &                  MASTER, id%COMM, IERR )
         IF (KEEP(486).NE.0) THEN
@@ -669,6 +694,8 @@ C         -- Low Level I/O strategy
      &                  MASTER, id%COMM, IERR )
           CALL MPI_BCAST( KEEP(211), 1, MPI_INTEGER,
      &                  MASTER, id%COMM, IERR )
+          CALL MPI_BCAST( KEEP(255), 1, MPI_INTEGER,
+     &                  MASTER, id%COMM, IERR )
         ENDIF
 C     Fwd in facto: explicitly forbid
 C     sparse RHS and A-1 computation
@@ -833,7 +860,7 @@ C       -- More expensive setting of SIM
 C
         IF ( ((KEEP(52).EQ.7).OR.(KEEP(52).EQ.8)) .AND. 
      &       KEEP(54).NE.0 ) THEN
-C         ------------------------------
+C{        ------------------------------
 C         Scaling for distributed matrix
 C         We need to allocate scaling
 C         arrays on all processors, not
@@ -858,13 +885,14 @@ C         ------------------------------
          M = N
          BUMAXMN=M
          IF(N > BUMAXMN) BUMAXMN = N
-         LIWK = 4*BUMAXMN
-         ALLOCATE (IWK(LIWK),BURP(M),BUCP(N),
-     &            BURS(2* (id%NPROCS)),BUCS(2* (id%NPROCS)),
+         LIWK = 4_8*int(BUMAXMN,8)
+         ALLOCATE (IWK(LIWK), BURP(M), BUCP(N),
+     &            BURS(2* id%NPROCS), BUCS(2* id%NPROCS),
      &            stat=allocok)
          IF (allocok > 0) THEN
             id%INFO(1)=-13
-            id%INFO(2)=LIWK+M+N+4* (id%NPROCS)
+            CALL MUMPS_SET_IERROR(LIWK+int(M,8)+int(N,8)+
+     &      4_8*int(id%NPROCS,8) , id%INFO(2))
          ENDIF
 C        --- Propagate enventual error
          CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
@@ -873,27 +901,38 @@ C        --- Propagate enventual error
 C        -- estimation of memory and construction of partvecs
          BUJOB = 1
 C        -- LWK not used
-         LWK_REAL   = 1
+         LWK_REAL = 1_8
+         LWRKR_TH = 1_8
+         LWRKC_TH = 1_8
+         NOMP_MAX   = 1
          ALLOCATE(WK_REAL(LWK_REAL),
+     &            WRKR_TH(LWRKR_TH,NOMP_MAX),
+     &            WRKC_TH(LWRKC_TH,NOMP_MAX),
      &            stat=allocok)
          IF (allocok > 0) THEN
             id%INFO(1)=-13
-            id%INFO(2)=LWK_REAL
+            CALL MUMPS_SET_IERROR(
+     &             LWK_REAL+ 
+     &             LWRKR_TH*int(NOMP_MAX,8)+
+     &             LWRKC_TH*int(NOMP_MAX,8),
+     &             id%INFO(2))
          ENDIF
 C        --- Propagate enventual error
          CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
      &        id%COMM, id%MYID )
          IF (id%INFO(1).LT.0) GOTO 517
          CALL CMUMPS_SIMSCALEABS(
-     &        MYIRN_loc(1), MYJCN_loc(1), MYA_loc(1),
+     &        IRN_loc_PTR(1), JCN_loc_PTR(1), A_loc_PTR(1),
      &        id%KEEP8(29),
      &        M, N,  id%NPROCS, id%MYID, id%COMM,
      &        BURP, BUCP,
      &        BURS, BUCS, BUREGISTRE,
      &        IWK, LIWK,
      &        BUINTSZ, BURESZ, BUJOB,
-     &        id%ROWSCA(1), id%COLSCA(1), WK_REAL, LWK_REAL,
-     &        id%KEEP(50),
+     &        id%ROWSCA(1), id%COLSCA(1), WK_REAL, LWK_REAL, 
+     &        WRKR_TH, LWRKR_TH, 
+     &        WRKC_TH, LWRKC_TH,
+     &        NOMP_MAX, id%KEEP(50),
      &        K231, K232, K233, 
      &        id%DKEEP(3),
      &        SCONEERR, SCINFERR)
@@ -903,15 +942,40 @@ C        --- Propagate enventual error
             ALLOCATE(IWK(LIWK), stat=allocok)
             IF (allocok > 0) THEN
                id%INFO(1)=-13
-               id%INFO(2)=LIWK
+               CALL MUMPS_SET_IERROR(LIWK,id%INFO(2))
             ENDIF
          ENDIF
-         LWK_REAL = BURESZ
-         DEALLOCATE(WK_REAL)
-         ALLOCATE (WK_REAL(LWK_REAL), stat=allocok)
+         DEALLOCATE(WK_REAL, WRKR_TH, WRKC_TH)
+         LWK_REAL     = BURESZ
+C
+C        -- Set NOMP_MAX from KEEP(281)
+         CALL CMUMPS_SET_NOMP_MAX(id%KEEP(281), id%KEEP(361), 
+     &                            N, NOMP_MAX)
+C
+         IF (NOMP_MAX.LE.1) THEN
+C          temp array per thread not used
+           LWRKR_TH = 1
+           LWRKC_TH = 1
+         ELSE
+           LWRKR_TH = N
+           IF (id%KEEP(50).NE.0) THEN
+C            WRKC_TH not used on symmetric matrices
+             LWRKC_TH = 1
+           ELSE
+             LWRKC_TH = N
+           ENDIF
+         ENDIF
+         ALLOCATE(WK_REAL(LWK_REAL),
+     &            WRKR_TH(LWRKR_TH,max(NOMP_MAX,1)),
+     &            WRKC_TH(LWRKC_TH,max(NOMP_MAX,1)),
+     &            stat=allocok)
          IF (allocok > 0) THEN
             id%INFO(1)=-13
-            id%INFO(2)=LWK_REAL
+            CALL MUMPS_SET_IERROR(
+     &             LWK_REAL+ 
+     &             LWRKR_TH*int(max(NOMP_MAX,1),8)+
+     &             LWRKC_TH*int(max(NOMP_MAX,1),8),
+     &             id%INFO(2))
          ENDIF
 C        --- Propagate enventual error
          CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
@@ -920,7 +984,7 @@ C        --- Propagate enventual error
 C        -- estimation of memory and construction of partvecs
          BUJOB = 2
          CALL CMUMPS_SIMSCALEABS(
-     &        MYIRN_loc(1), MYJCN_loc(1), MYA_loc(1),
+     &        IRN_loc_PTR(1), JCN_loc_PTR(1), A_loc_PTR(1),
      &        id%KEEP8(29),
      &        M, N,  id%NPROCS, id%MYID, id%COMM,
      &        BURP, BUCP,
@@ -928,16 +992,20 @@ C        -- estimation of memory and con
      &        IWK, LIWK,
      &        BUINTSZ, BURESZ, BUJOB,
      &        id%ROWSCA(1), id%COLSCA(1), WK_REAL, LWK_REAL,
-     &        id%KEEP(50),
+     &        WRKR_TH, LWRKR_TH, 
+     &        WRKC_TH, LWRKC_TH,
+     &        NOMP_MAX, id%KEEP(50),
      &        K231, K232, K233, 
      &        id%DKEEP(3),
      &        SCONEERR, SCINFERR)
          id%DKEEP(4) = SCONEERR
          id%DKEEP(5) = SCINFERR
 CXXXX 
-         DEALLOCATE(IWK, WK_REAL,BURP,BUCP,BURS, BUCS)
+         DEALLOCATE(IWK, BURP,BUCP,BURS, BUCS)
+         DEALLOCATE(WK_REAL, WRKR_TH, WRKC_TH)
+C}
         ELSE IF ( KEEP(54) .EQ. 0 ) THEN
-C         ------------------
+C{        ------------------
 C         Centralized matrix
 C         ------------------
           IF ((KEEP(52).EQ.7).OR.(KEEP(52).EQ.8))  THEN
@@ -955,21 +1023,45 @@ C             --------------------------
                  M = N
                  BUMAXMN=N
                  IF(N > BUMAXMN) BUMAXMN = N
-                 LIWK = 1
-                 ALLOCATE(IWK(LIWK),BURP(1),BUCP(1),
-     &                BURS(1),BUCS(1),
+                 LIWK = 1_8
+                 ALLOCATE(IWK(LIWK), BURP(1), BUCP(1),
+     &                BURS(1), BUCS(1),
      &                stat=allocok)
                  IF (allocok > 0) THEN
                     id%INFO(1)=-13
-                    id%INFO(2)=LIWK+1+1+1+1
+                    CALL MUMPS_SET_IERROR( LIWK+4_8, id%INFO(2) )
                     GOTO 400
                  ENDIF
-                 LWK_REAL = M + N  
-                 ALLOCATE (WK_REAL(LWK_REAL), stat=allocok)
+                 LWK_REAL = int(M,8) + int(N,8)  
+C
+C                -- Set NOMP_MAX from KEEP(281)
+                 CALL CMUMPS_SET_NOMP_MAX(id%KEEP(281), id%KEEP(361), 
+     &                                    N, NOMP_MAX)
+C
+                 IF (NOMP_MAX.LE.1) THEN
+C                  temp array per thread not used
+                   LWRKR_TH = 1
+                   LWRKC_TH = 1
+                 ELSE
+                   LWRKR_TH = N
+                   IF (id%KEEP(50).NE.0) THEN
+C                    WRKC_TH not used on symmetric matrices
+                     LWRKC_TH = 1
+                   ELSE
+                     LWRKC_TH = N
+                   ENDIF
+                 ENDIF
+                 ALLOCATE(WK_REAL(LWK_REAL),
+     &                    WRKR_TH(LWRKR_TH,max(NOMP_MAX,1)),
+     &                    WRKC_TH(LWRKC_TH,max(NOMP_MAX,1)),
+     &                    stat=allocok)
                  IF (allocok > 0) THEN
                     id%INFO(1)=-13
-                    id%INFO(2)=LWK_REAL
-                    GOTO 400
+                    CALL MUMPS_SET_IERROR(
+     &                     LWK_REAL+ 
+     &                     LWRKR_TH*int(max(NOMP_MAX,1),8)+
+     &                     LWRKC_TH*int(max(NOMP_MAX,1),8),
+     &                     id%INFO(2))
                  ENDIF
                  CALL MPI_COMM_RANK(COMM_FOR_SCALING, SCMYID, IERR)
                  CALL MPI_COMM_SIZE(COMM_FOR_SCALING, SCNPROCS, IERR)
@@ -983,7 +1075,9 @@ C             --------------------------
      &                IWK, LIWK,
      &                BUINTSZ, BURESZ, BUJOB,
      &                id%ROWSCA(1), id%COLSCA(1), WK_REAL, LWK_REAL,
-     &                id%KEEP(50),
+     &                WRKR_TH, LWRKR_TH, 
+     &                WRKC_TH, LWRKC_TH,
+     &                NOMP_MAX, id%KEEP(50),
      &                K231, K232, K233, 
      &                id%DKEEP(3),
      &                SCONEERR, SCINFERR)
@@ -1001,7 +1095,9 @@ C             --------------------------
      &                IWK, LIWK,
      &                BUINTSZ, BURESZ, BUJOB,
      &                id%ROWSCA(1), id%COLSCA(1), WK_REAL, LWK_REAL,
-     &                id%KEEP(50),
+     &                WRKR_TH, LWRKR_TH, 
+     &                WRKC_TH, LWRKC_TH,
+     &                NOMP_MAX, id%KEEP(50),
      &                K231, K232, K233, 
      &                id%DKEEP(3),
      &                SCONEERR, SCINFERR)
@@ -1009,6 +1105,8 @@ C             --------------------------
                  id%DKEEP(5) = SCINFERR
  400             CONTINUE
                  IF (allocated(WK_REAL)) DEALLOCATE(WK_REAL)
+                 IF (allocated(WRKR_TH)) DEALLOCATE(WRKR_TH)
+                 IF (allocated(WRKC_TH)) DEALLOCATE(WRKC_TH)
                  IF (allocated(IWK))     DEALLOCATE(IWK)
                  IF (allocated(BURP))    DEALLOCATE(BURP)
                  IF (allocated(BUCP))    DEALLOCATE(BUCP)
@@ -1027,31 +1125,34 @@ C               freed on the master proc
      &             id%COMM, id%MYID)
               IF (id%INFO(1).LT.0) GOTO 517
           ELSE IF (id%MYID.EQ.MASTER) THEN
-C           ----------------------------------
-C           Centralized scaling, options 1 to 6
-C           ----------------------------------
+C           -------------------
+C           Centralized scaling
+C           -------------------
             IF (KEEP(52).GT.0 .AND. KEEP(52).LE.6) THEN
 C             ---------------------
 C             Allocate temporary
 C             workspace for scaling
 C             ---------------------
-              IF ( KEEP(52) .eq. 5 .or. 
-     &          KEEP(52) .eq. 6 ) THEN
-C               We have an explicit copy of the original
-C               matrix in complex format which should probably
-C               be avoided (but do we want to keep all
-C               those old scaling options ?)
-                LWK = id%KEEP8(28)
-              ELSE
+              IF (KEEP(52) .eq. 1 ) THEN
+C               No workspace indeed needed
                 LWK = 1_8
+                LWK_REAL = 1_8
+              ELSE IF ( KEEP(52) .eq. 3 ) THEN 
+                LWK = 1_8
+                LWK_REAL = int(N,8)
+              ELSE IF ( KEEP(52) .eq. 4 ) THEN
+C               Options 3 or 4
+                LWK = 1_8
+                LWK_REAL = 2_8*int(N,8)
               END IF
-              LWK_REAL = 5 * N
+C             Real workarray
               ALLOCATE( WK_REAL( LWK_REAL ), stat = IERR )
               IF ( IERR .GT. 0 ) THEN
                 id%INFO(1) = -13
-                id%INFO(2) = LWK_REAL
+                CALL MUMPS_SET_IERROR( LWK_REAL, id%INFO(2) )
                 GOTO 137
               END IF
+C             Real/complex workarray
               ALLOCATE( WK( LWK ), stat = IERR )
               IF ( IERR .GT. 0 ) THEN
                 id%INFO(1) = -13
@@ -1066,11 +1167,12 @@ C               those old scaling option
               DEALLOCATE( WK )
             ENDIF
           ENDIF
+C}
         ENDIF ! Scaling distributed matrices or centralized
         IF (KEEP(125).NE.0) THEN
 C         ------------------------
 C           If we enable the scaling of the |A11 A12| block
-C           we et to 1 the scaling corresponding to the Schur
+C           we set to 1 the scaling corresponding to the Schur
 C           complement matrix A22
 C         ------------------------
             IF ((KEEP(60).GT.0) .and. (KEEP(116).GT.0)) THEN
@@ -1098,6 +1200,7 @@ C             Scaling available on maste
         IF (id%MYID.EQ.MASTER) THEN
             CALL MUMPS_SECFIN(TIMEET)
             id%DKEEP(92)=real(TIMEET)
+          IF (PROKG) WRITE( MPG, 140 ) TIMEET
 C         Print inf-norm after last KEEP(233) iterations of
 C         scaling option KEEP(52)=7 or 8 (SimScale)
 C
@@ -1147,6 +1250,9 @@ C       of the original matrix.
 C       ********************
 C
  137  CONTINUE
+      CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
+     &     id%COMM, id%MYID )
+      IF (id%INFO(1).LT.0) GOTO 517
 C     Fwd in facto: in case of repeated factorizations
 C     with different Schur options we prefer to free
 C     systematically this array now than waiting for
@@ -1172,11 +1278,11 @@ C     to make it available on all proces
       IF (id%KEEP(252) .EQ. 1) THEN
           IF ( id%MYID.NE.MASTER ) THEN
             id%KEEP(254) = N              ! Leading dimension
-            id%KEEP(255) = N*id%KEEP(253) ! Tot size
-            ALLOCATE(RHS_MUMPS(id%KEEP(255)),stat=IERR)
+            id%KEEP8(85) = int(N,8)*int(id%KEEP(253),8) ! Tot size
+            ALLOCATE(RHS_MUMPS(id%KEEP8(85)),stat=IERR)
             IF (IERR > 0) THEN
                id%INFO(1)=-13
-               id%INFO(2)=id%KEEP(255)
+               CALL MUMPS_SET_IERROR(id%KEEP8(85), id%INFO(2))
                IF (LPOK)
      &         WRITE(LP,*) 'ERROR while allocating RHS on a slave'
                NULLIFY(RHS_MUMPS)
@@ -1185,7 +1291,8 @@ C     to make it available on all proces
           ELSE 
 C           Case of non working master
             id%KEEP(254)=id%LRHS              ! Leading dimension
-            id%KEEP(255)=id%LRHS*(id%KEEP(253)-1)+id%N ! Tot size
+            id%KEEP8(85)=int(id%LRHS,8)*int(id%KEEP(253)-1,8)+
+     &                   int(id%N,8) ! Tot size
             RHS_MUMPS=>id%RHS
             RHS_MUMPS_ALLOCATED = .FALSE.
             IF (LSCAL) THEN
@@ -1202,7 +1309,7 @@ C             transpose).
             ENDIF
           ENDIF
       ELSE
-          id%KEEP(255)=1
+          id%KEEP8(85)=1_8
           ALLOCATE(RHS_MUMPS(1),stat=IERR)
           IF (IERR > 0) THEN
              id%INFO(1)=-13
@@ -1215,7 +1322,7 @@ C             transpose).
       ENDIF
       CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
      &                    id%COMM, id%MYID )
-      IF ( id%INFO(1).lt.0 ) GOTO 517
+      IF ( id%INFO(1).lt.0 ) GOTO 516
       IF (KEEP(252) .EQ. 1) THEN
 C
 C         Broadcast the columns of the right-hand side
@@ -1236,7 +1343,7 @@ C       KEEP(110) defaults to 0 for out
       ENDIF
       CALL MPI_BCAST(KEEP(110), 1, MPI_INTEGER,
      &               MASTER, id%COMM, IERR)
-      IF (KEEP(219).NE.0) THEN
+      IF ((KEEP(50).EQ.2).AND.(KEEP(219).NE.0)) THEN
        CALL CMUMPS_BUF_MAX_ARRAY_MINSIZE(max(KEEP(108),1),IERR)
        IF (IERR .NE. 0) THEN
 C      ------------------------
@@ -1254,6 +1361,7 @@ C               ( A row is considered as
 C         CNTL(5) is then used to define if a large 
 C                 value is set on the diagonal or if a 1 is set
 C                 and other values in the row are reset to zeros.
+C       -rank revealing on the Schur (ICNTL(56)/KEEP(19))
 C         SEUIL* corresponds to the minimum required 
 C                absolute value of pivot.
 C         SEUIL_LDLT_NIV2 is used only in the 
@@ -1338,6 +1446,10 @@ C      sing val.
          ELSE IF  (CNTL3 .GT. ZERO) THEN
            id%DKEEP(9) = CNTL3*ANORMINF
          ELSE  !  (CNTL(3) .EQ. ZERO) THEN
+           CALL MUMPS_NPIV_CRITICAL_PATH(
+     &     N, KEEP(28), id%STEP(1), id%FRERE_STEPS(1), id%FILS(1),
+     &     id%NA(1), id%LNA, id%NE_STEPS(1), NPIV_CRITICAL_PATH )
+           id%DKEEP(9) = sqrt(REAL(NPIV_CRITICAL_PATH))*EPS*ANORMINF  
          ENDIF
          IF (PROKG) THEN 
            WRITE(MPG, '(A,I16)')
@@ -1430,6 +1542,7 @@ C     Find id of root node if RR is on
       ENDIF
 C Second pass:  set parameters for null pivot detection
 C Allocate PIVNUL_LIST_STRUCT in case of null pivot detection
+C and in case of rank revealing
       KEEP(109) = 0
       LPN_LIST  = 0
       IF(KEEP(110) .EQ. 1) THEN
@@ -1451,7 +1564,7 @@ C Allocate PIVNUL_LIST_STRUCT in case of
 C end set parameter for null pivot detection
       CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
      &                    id%COMM, id%MYID )
-      IF ( id%INFO(1).lt.0 ) GOTO 517
+      IF ( id%INFO(1).lt.0 ) GOTO 516
 C   --------------------------------------------------------------
 C   STATIC PIVOTING
 C     -- Static pivoting only when RR and Null pivot detection OFF
@@ -1515,7 +1628,7 @@ C       -- Set MAXS to size of WK_USER_
       CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
      &                    id%COMM, id%MYID )
       IF (id%INFO(1) .LT. 0) THEN
-        GOTO 517
+        GOTO 516
       ENDIF
 C
       id%KEEP8(75) = huge(id%KEEP8(75))
@@ -1604,7 +1717,7 @@ C
       CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
      &                    id%COMM, id%MYID )
       IF (id%INFO(1) .LT. 0) THEN
-        GOTO 517
+        GOTO 516
       ENDIF
       CALL MUMPS_SETI8TOI4(MAXS, id%INFO(39))
       CALL CMUMPS_AVGMAX_STAT8(PROKG, MPG, MAXS, id%NSLAVES,
@@ -1996,11 +2109,11 @@ C     id%S will be checked later)
 C     ---------------------------------------------
       IF (EARLYT3ROOTINS .AND. KEEP(38).NE.0 .AND.
      &    KEEP(60) .EQ.0 .AND. I_AM_SLAVE) THEN
-        LWK = int(numroc( id%root%ROOT_SIZE, id%root%MBLOCK,
+        LWK = int(MUMPS_NUMROC( id%root%ROOT_SIZE, id%root%MBLOCK,
      &             id%root%MYROW, 0, id%root%NPROW ),8)
         LWK = max( 1_8, LWK )
         LWK = LWK*
-     &        int(numroc( id%root%ROOT_SIZE, id%root%NBLOCK,
+     &        int(MUMPS_NUMROC( id%root%ROOT_SIZE, id%root%NBLOCK,
      &        id%root%MYCOL, 0, id%root%NPCOL ),8)
         LWK = max( 1_8, LWK )
       ELSE
@@ -2017,6 +2130,122 @@ C     arrowheads of root.
      &                        id%COMM, id%MYID )
       IF ( id%INFO(1).LT.0 ) GOTO 500
 C
+C     =====================================================
+      IF (KEEP(399).GE.2) THEN
+C{    Multihtreaded algorithm taking into account all cases
+C     =====================================================
+C
+C        Timing on master.
+         IF (id%MYID.EQ.MASTER) THEN
+           CALL MUMPS_SECDEB(TIME)
+         END IF
+C
+         NZ_loc8   = 0_8
+         NBRECORDS = KEEP(39)
+         SIZESCAL = id%N
+C        Set  NZ_loc8, A_loc_PTR, IRN_loc_PTR, JCN_loc_PTR
+C        and update NBRECORDS
+         IF (KEEP(54).EQ.0) THEN
+C         centralized matrix
+          IF (id%KEEP8(28) .LT. int(NBRECORDS,8)) THEN
+              NBRECORDS = int(id%KEEP8(28))
+          ENDIF
+          IF (id%MYID.EQ.MASTER) THEN
+           NZ_loc8 = id%KEEP8(28)
+           A_loc_PTR   => id%A
+           IRN_loc_PTR => id%IRN
+           JCN_loc_PTR => id%JCN
+           IF (LSCAL) THEN
+             COLSCA_PTR => id%COLSCA
+             ROWSCA_PTR => id%ROWSCA
+           ELSE
+             COLSCA_PTR  => DUMMYSCA
+             ROWSCA_PTR  => DUMMYSCA
+             SIZESCAL  = 1
+           ENDIF
+          ELSE
+           A_loc_PTR   => DUMMYA_loc
+           IRN_loc_PTR => DUMMYIRN_loc
+           JCN_loc_PTR => DUMMYJCN_loc
+           COLSCA_PTR  => DUMMYSCA
+           ROWSCA_PTR  => DUMMYSCA
+           SIZESCAL  = 1
+          ENDIF
+         ELSE
+C         distributed matrix
+C         ---------------------------------------------------
+C         In order to have possibly IRN_loc/JCN_loc/A_loc
+C         of size 0, avoid to pass them inside REDISTRIBUTION
+C         and pass id instead
+C         NZ_locMAX8 gives as a maximum buffer size (send/recv) used
+C          an upper bound to limit buffers on small matrices
+C         ---------------------------------------------------
+          CALL MPI_ALLREDUCE(id%KEEP8(29), NZ_locMAX8, 1, 
+     &              MPI_INTEGER8, MPI_MAX, id%COMM, IERR)
+          IF (NZ_locMAX8 .LT. int(NBRECORDS,8)) THEN
+              NBRECORDS = int(NZ_locMAX8)
+          ENDIF
+          NZ_loc8 = id%KEEP8(29)
+          LSCAL   = (KEEP(52).EQ.7).OR.(KEEP(52).EQ.8)
+C         available on all MPI
+          IF (LSCAL) THEN
+            COLSCA_PTR => id%COLSCA
+            ROWSCA_PTR => id%ROWSCA
+          ELSE
+           COLSCA_PTR  => DUMMYSCA
+           ROWSCA_PTR  => DUMMYSCA
+           SIZESCAL  = 1
+          ENDIF
+         ENDIF
+#if ! defined(PCPRET)
+          IF (id%KEEP(72).EQ.1) THEN
+           NBRECORDS = max(3,NBRECORDS/10)
+          ENDIF
+         CALL CMUMPS_FAC_DIST_ARROWHEADS_OMP ( id%N,
+     &     NZ_loc8, 
+C          replace id by:
+     &        A_loc_PTR(1), IRN_loc_PTR(1), JCN_loc_PTR(1),
+     &        SIZESCAL, LSCAL, COLSCA_PTR(1), ROWSCA_PTR(1), 
+     &     DBLARR(1), id%KEEP8(26), INTARR(1),
+     &     id%KEEP8(27),
+     &     id%PTR8ARR(1), id%NINCOLARR(1),
+     &     id%NINROWARR(1), id%PTRDEBARR(1),
+     &     id%FILS(1),
+     &     KEEP(1), id%KEEP8(1), id%MYID, id%COMM, NBRECORDS,
+     &     S_PTR_ARG(1), MAXS_ARG, id%root, id%PROCNODE_STEPS(1),
+     &     id%NPROCS, id%NSLAVES, id%SYM_PERM(1), id%STEP(1),
+     &     id%ICNTL(1), id%INFO(1), NSEND8, NLOCAL8,
+     &     id%ISTEP_TO_INIV2(1),
+     &     id%CANDIDATES(1,1) 
+     &     )
+         CALL MPI_BARRIER(id%COMM, IERR)
+#else 
+#endif
+C     
+         IF ( KEEP(46) .eq. 0 .AND. id%MYID.eq.MASTER ) THEN
+C          ------------------------------
+C          The host is not working -> had
+C          no data from initial matrix
+C          ------------------------------
+           NSEND8  = 0_8
+           NLOCAL8 = 0_8
+         END IF
+C        -------------------------
+C        Check for possible errors
+C        -------------------------
+         CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
+     &                    id%COMM, id%MYID )
+         IF ( id%INFO( 1 ) .LT. 0 ) GOTO 500
+         CALL MPI_REDUCE( NSEND8, NSEND_TOT8, 1, MPI_INTEGER8,
+     &                 MPI_SUM, MASTER, id%COMM, IERR )
+         CALL MPI_REDUCE( NLOCAL8, NLOCAL_TOT8, 1, MPI_INTEGER8,
+     &                 MPI_SUM, MASTER, id%COMM, IERR )
+         IF ( PROKG ) THEN
+           WRITE(MPG,125) NLOCAL_TOT8, NSEND_TOT8
+         END IF
+C}        
+      ELSE
+C{   =======================================================
       IF ( KEEP(54) .eq. 0 ) THEN
 C     {
 C       ================================================
@@ -2243,6 +2472,8 @@ C     --------------------------
 C     }
       ENDIF ! distributed matrix
 C     }
+      ENDIF !  "old" multithreaded algorithm 
+C     }
       ELSE
 C     {
 C       -------------------
@@ -2306,8 +2537,9 @@ C       We check the number of threads.
             id%INFO(1)=-58
             id%INFO(2)=KEEP(400)
             IF (LPOK) WRITE(LP,'(A,A,I5,A,I5)')
-     &" FAILURE DETECTED IN FACTORIZATION: #threads for KEEP(401)",
-     &" changed from",KEEP(400)," at analysis to", NOMP
+     &" FAILURE DETECTED IN FACTORIZATION: #threads for multithreaded",
+     &" tree parallelism changed from",KEEP(400)," at analysis to", 
+     &  NOMP
           ENDIF
 C       error check
         CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
@@ -2394,6 +2626,13 @@ C
         CMUMPS_LBUFR_BYTES8 = min(CMUMPS_LBUFR_BYTES8,
      &                            int(huge(I4)-100,8))
         CMUMPS_LBUFR_BYTES  = int( CMUMPS_LBUFR_BYTES8 )
+C       CMUMPS_LBUFR is the size of the buffer as a number of integers,
+C       we round CMUMPS_LBUFR (size in #integers) above to have at least
+C       CMUMPS_LBUFR_BYTES available in the buffer.
+        CMUMPS_LBUFR = (CMUMPS_LBUFR_BYTES+KEEP(34)-1)/KEEP(34)
+C       Finally, make CMUMPS_LBUFR_BYTES a multiple of KEEP(34) by setting
+C       CMUMPS_LBUFR_BYTES to the number of bytes that will be allocated
+        CMUMPS_LBUFR_BYTES = CMUMPS_LBUFR*KEEP(34)
         IF (KEEP(48)==5) THEN
 C          Since the buffer is going to be allocated, use
 C          it as the constraint for memory/granularity
@@ -2464,12 +2703,17 @@ C       are in numbers of bytes).
         IF ( PROK ) THEN
           WRITE( MP, 9999 ) CMUMPS_LBUFR_BYTES,
      &                      CMUMPS_LBUF, CMUMPS_LBUF_INT
+        ELSE 
+         IF (PROKG) THEN
+          WRITE( MPG, 9999 ) CMUMPS_LBUFR_BYTES,
+     &                      CMUMPS_LBUF, CMUMPS_LBUF_INT
+         ENDIF
         END IF
  9999   FORMAT( /,' Allocated buffers',/,' ------------------',/,
-     &  ' Size of reception buffer in bytes ...... = ', I10,
+     &  ' Size of reception buffer in bytes ...... = ', I12,
      &  /,
-     &  ' Size of async. emission buffer (bytes).. = ', I10,/,
-     &  ' Small emission buffer (bytes) .......... = ', I10)
+     &  ' Size of async. emission buffer (bytes).. = ', I12,/,
+     &  ' Small emission buffer (bytes) .......... = ', I12)
 C       --------------------------
 C       Allocate small send buffer
 C       required for CMUMPS_FAC_B
@@ -2491,7 +2735,6 @@ C       --------------------------------
 C       Allocate reception buffer on all procs
 C       This is done now.
 C       --------------------------------------
-        CMUMPS_LBUFR = (CMUMPS_LBUFR_BYTES+KEEP(34)-1)/KEEP(34)
         ALLOCATE( BUFR( CMUMPS_LBUFR ),stat=IERR )
         IF ( IERR .NE. 0 ) THEN
           id%INFO(1) = -13
@@ -2821,7 +3064,7 @@ C     --------------------------------
       IF (allocated(BUFR)) DEALLOCATE(BUFR)
       CALL CMUMPS_BUF_DEALL_SMALL_BUF( IERR )
 C//PIV
-      IF (KEEP(219).NE.0) THEN
+      IF ((KEEP(50).EQ.2).AND.(KEEP(219).NE.0)) THEN
       CALL CMUMPS_BUF_DEALL_MAX_ARRAY()
       ENDIF
 C
@@ -2833,6 +3076,10 @@ C     not be necessary.
      &                    id%COMM, id%MYID )
 C
       CALL CMUMPS_EXTRACT_SCHUR_REDRHS(id)
+C     return to user singular values
+      IF (id%KEEP(19) .NE.0) THEN
+       CALL CMUMPS_EXTRACT_SINGULAR_VALUES(id)
+      ENDIF
       IF (KEEP(201) .GT. 0) THEN
          IF ((KEEP(201).EQ.1) .OR. (KEEP(201).EQ.2)) THEN
             IF ( I_AM_SLAVE ) THEN
@@ -3405,6 +3652,9 @@ C           flops when BLR activated
           ELSE
             RINFOG(14) = 0.0E00
           ENDIF
+        IF (id%MYID .eq. MASTER) THEN
+          KEEP(399) = KEEP399_SAVE
+        ENDIF
       ENDIF
 C     ==============================
 C     NULL PIVOTS AND RANK-REVEALING
@@ -3446,7 +3696,7 @@ C      (do not allocate)
         ENDIF
        ELSE
 C       id%PIVNUL_LIST(1:KEEP(109)) used during sol_driver on slaves 
-C       to initialize id%RHSCOMP
+C       to initialize id%RHSINTR
         IF (KEEP(109).GT.0) THEN
           ALLOCATE(id%PIVNUL_LIST(KEEP(109)), stat=IERR)
           IF ( IERR .GT. 0 ) THEN
@@ -3460,6 +3710,34 @@ C}
       CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
      &                    id%COMM, id%MYID )
       IF ( id%INFO(1).lt.0 ) GOTO 490
+      IF ( (KEEP(19).NE.0) .AND. (KEEP(143) .NE. KEEP(17)) ) THEN
+C
+C         Raise a warning (on all MPI processes) since determinant or
+C         inertia or null pivot list is not consistent with deficiency
+C         computed with ICNTL(46)=1.
+C
+        id%INFO(1) = id%INFO(1)+16
+        id%INFO(2) = KEEP(112)+KEEP(143)
+        IF (KEEP(118) .GE. 40) THEN
+          IF ( PROKG ) THEN
+            WRITE(MPG,'(/A,A/,A,A,I8/,A,A,I8/)')
+     &      " WARNING: in the context of rank-revealing,",
+     &      " the inertia, determinant and pivnul list",  
+     &      " are computed with RR (rank-revealing)-LU,", 
+     &      " but the deficiency found by RR-LU: ", 
+     &      id%INFO(2),
+     &      " is different from the deficiency computed",
+     &      " with ICNTL(56)>0: ",  KEEP(112)+KEEP(17)
+          ENDIF
+        ELSE
+          IF ( LP .GT. 0 ) THEN
+            WRITE(LP,'(/A,A/,A/)')
+     &      " ERROR : in the context of rank-revealing,",
+     &      " the inertia, determinant and pivnul list",  
+     &      " are not correct because RR LU not called "
+          ENDIF
+        ENDIF
+      ENDIF
 C     ========================================
 C     We now provide to the host the part of
 C     PIVNUL_LIST resulting from the processing
@@ -3617,9 +3895,6 @@ C         of max-weighted matching)
           IF (id%KEEP(23).NE.0) THEN
             CALL CMUMPS_DETER_SIGN_PERM(
      &           RINFOG(12), id%N,
-C           id%STEP: used as workspace of size N still
-C                    allocated on master; restored on exit
-     &           id%STEP(1),
      &           id%UNS_PERM(1) )
 C           Remark that RINFOG(12/13) are modified only
 C           on the host but will be broadcast on exit
@@ -3692,6 +3967,14 @@ c         IF ( KEEP(17) .ne. 0 )
           !Total deficiency
           IF (KEEP(110).NE.0.OR.KEEP(19).NE.0)
      &    WRITE(MPG, 99992) KEEP(17)+KEEP(112) ! = INFOG(28)
+          !Smallest pivot with also null pivots in abs value
+          WRITE(MPG, 99995) RINFOG(19)
+          !Smallest pivot in abs value
+          WRITE(MPG, 99993) RINFOG(20)
+          !Largest pivot in abs value
+          WRITE(MPG, 99994) RINFOG(21)
+          !value of ICNTL(12) that was effectively used.
+          WRITE(MPG, 99996) INFOG(24)
           ! Memory compress
           WRITE(MPG, 99981) INFOG(14)
           ! Extra copies due to ip stack in unsym case
@@ -3909,7 +4192,7 @@ C     at the end of a phase S is always
       END IF
 C
 C     Goto 513 is done in case of error where LOAD_INIT was
-C     called but not OOC_INIT_FACTO.
+C     called but not the scaling nor OOC_INIT_FACTO.
  513  CONTINUE
       IF ( I_AM_SLAVE ) THEN
          CALL CMUMPS_LOAD_END( id%INFO(1), id%NSLAVES, IERR )
@@ -3918,9 +4201,37 @@ C     called but not OOC_INIT_FACTO.
       CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
      &     id%COMM, id%MYID )
 C
-C     Goto 517 is done when an error occurs when GPU initialization
-C     has been performed but not LOAD_INIT or OOC_INIT_FACTO
+C     Goto 516 is done in case of error when GPU initialiwqtion
+C     has been performed and scaling was optionally computed but
+C     not LOAD_INIT nor OOC_INIT_FACTO. We can then extract
+C     scaling arrays in case of error.
+ 516  CONTINUE
+C     --------------------------------------------
+C     We now build id%ROWSCA_loc and id%COLSCA_loc
+C     in case of successful factorization, in the
+C     numbering associated to the fully summed
+C     variables of the frontal matrices.
+C     This requires the factorization to be
+C     successful because otherwise we do not have
+C     the final lists of pivots associated to
+C     the fronts, including delayed pivots and
+C     symmetric/unsymmetric permutations done
+C     during the factorization process.
+C     --------------------------------------------
+      IF (LSCAL .AND. id%INFO(1).GE.0) THEN
+        CALL CMUMPS_EXTRACT_SCALING(id)
+C       occurs during scaling extraction, keep the error.
+        IF ( id%INFO(1) .LT. 0 ) THEN
+          IF (LPOK) THEN
+            WRITE(LP,*) "Facto OK but error during EXTRACT_SCALING",
+     &      id%INFO(1:2)
+          ENDIF
+        ENDIF
+      ENDIF
 C
+C     Goto 517 is done when an error occurs when GPU initialization
+C     has been performed but not LOAD_INIT or OOC_INIT_FACTO, e.g.
+C     when an error occurred during the scaling.
  517  CONTINUE
       IF (associated( PIVNUL_LIST_STRUCT%PIVNUL_LIST)) THEN
         DEALLOCATE(PIVNUL_LIST_STRUCT%PIVNUL_LIST)
@@ -3941,10 +4252,12 @@ C
  120  FORMAT(/' Local redistrib: data local/sent           =',I16,I16)
  125  FORMAT(/' Redistrib: total data local/sent           =',I16,I16)
  130  FORMAT(//'****** FACTORIZATION STEP ********'/)
+ 140  FORMAT(/' Statistics on the scaling phase'
+     & /' Elapsed time for scaling                   =',F12.4)
  160  FORMAT(
-     & /' Elapsed time to reformat/distribute matrix =',F12.4)
+     & ' Elapsed time to reformat/distribute matrix =',F12.4/)
  166  FORMAT(' Max difference from 1 after scaling the entries',
-     &       ' for ONE-NORM (option 7/8)   =',D9.2)
+     &       ' for ONE-NORM (option 7/8)   =',D9.2/)
  170  FORMAT(' STATISTICS PRIOR NUMERICAL FACTORIZATION ...'/
      &        ' Size of internal working array S           =',I16/
      &        ' Size of internal working array IS          =',I16/
@@ -4002,6 +4315,14 @@ C
      &      I16)
 99992 FORMAT( ' INFOG (28) Estimated deficiency                    =',
      &      I16)
+99995 FORMAT( ' RINFOG(19) Smallest pivot WITH perturbed pivots    =',
+     &     1PD10.3)
+99993 FORMAT( ' RINFOG(20) Smallest pivot WITHOUT perturbed pivots =',
+     &     1PD10.3)
+99994 FORMAT( ' RINFOG(21) Largest pivot in absolute value         =',
+     &     1PD10.3)
+99996 FORMAT( ' INFOG (24) Effective value of ICNTL(12)            =',
+     &     I16)
 99984 FORMAT(/'Leaving factorization with ...'/
      &        ' RINFOG (2) Operations in node assembly             =',
      &          1PD10.3/                                   
@@ -4088,6 +4409,186 @@ C
  110  FORMAT(A48,I18)
       END SUBROUTINE CMUMPS_AVGMAX_STAT8
 C
+C
+C     ==================================================================
+C
+      SUBROUTINE CMUMPS_EXTRACT_SCALING(id)
+      USE CMUMPS_STRUC_DEF
+      IMPLICIT NONE
+C
+C     Purpose:
+C     =======
+C
+C     Extract distributed scaling arrays from CMUMPS_EXTRACT_SCALING
+C     In case of unsymmetric permutation, ROWSCA and COLSCA correspond
+C     to Dr and Dc, in the expression Dr A Q Dc. In other terms, Dc
+C     is compatbile with the front column indices, it does not
+C     correspond to the column indices of A, meaning that Q is not
+C     needed to just extract the scaling values.
+C
+C
+      TYPE(CMUMPS_STRUC) :: id
+      INTEGER, EXTERNAL  :: MUMPS_PROCNODE
+C
+C     MPI
+C     ===
+C
+      INCLUDE 'mpif.h'
+C
+C     Local declarations
+C     ==================
+C
+      REAL, DIMENSION(:), POINTER :: COLSCA
+      REAL, DIMENSION(:), POINTER :: ROWSCA
+      INTEGER, PARAMETER :: MASTER = 0
+C
+      INTEGER    :: ISTEP, NPIV, LIELL
+      INTEGER    :: IERR_MPI, allocok
+      INTEGER    :: ISCA
+      INTEGER    :: JROW, JCOL, IPOS, JJ ! access to IS
+      INTEGER    :: LIW_PASSED
+      INTEGER(8) :: LALLOC
+C
+C     Free and reallocate distributed scaling arrays :
+C     - in symmetric, COLSCA_loc points on ROWSCA_loc.
+C     - not allocated if KEEP(89)=0
+C
+      NULLIFY(ROWSCA)
+      NULLIFY(COLSCA)
+      IF (associated(id%ROWSCA_loc)) THEN
+        DEALLOCATE(id%ROWSCA_loc)
+        NULLIFY(id%ROWSCA_loc)
+      ENDIF
+      IF (associated(id%COLSCA_loc)) THEN
+        IF (id%KEEP(50) .EQ. 0) THEN
+          DEALLOCATE(id%COLSCA_loc)
+        ENDIF
+        NULLIFY(id%COLSCA_loc)
+      ENDIF
+C     id%ROWSCA and id%COLSCA are available on master,
+C     allocate ROWSCA and COLSCA of order N on other procs
+      IF ( id%MYID .EQ. MASTER ) THEN
+        ROWSCA => id%ROWSCA
+        COLSCA => id%COLSCA
+        IF (.NOT. associated(ROWSCA)) THEN
+          WRITE(*,*) "Internal error 1 in CMUMPS_EXTRACT_SCALING"
+          CALL MUMPS_ABORT()
+        ENDIF
+        IF (.NOT. associated(COLSCA)) THEN
+          WRITE(*,*) "Internal error 2 in CMUMPS_EXTRACT_SCALING"
+          CALL MUMPS_ABORT()
+        ENDIF
+      ELSE
+        IF (id%KEEP(50).EQ.0) THEN
+          ALLOCATE(ROWSCA(id%N),COLSCA(id%N),stat=allocok)
+          LALLOC = int(id%N+id%N,8)
+        ELSE
+          ALLOCATE(ROWSCA(id%N),stat=allocok)
+          COLSCA => ROWSCA
+          LALLOC = int(id%N,8)
+        ENDIF
+        IF (allocok .GT. 0) THEN
+          id%INFO(1)=-13
+          CALL MUMPS_SET_IERROR(LALLOC,id%INFO(2))
+        ENDIF
+      ENDIF
+      CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                        id%COMM, id%MYID )
+C     Jump to 110 in case of error on ROWSCA or COLSCA
+C     on one of the MPI processes.
+      IF (id%INFO(1) .LT. 0) GOTO 110
+C
+      IF ( id%KEEP(89) .GT. 0) THEN
+        IF (id%KEEP(50).EQ.0) THEN
+          ALLOCATE(id%ROWSCA_loc(id%KEEP(89)),
+     &             id%COLSCA_loc(id%KEEP(89)),stat=allocok)
+          LALLOC = int(id%KEEP(89),8)*2_8
+        ELSE
+          ALLOCATE(id%ROWSCA_loc(id%KEEP(89)),stat=allocok)
+          id%COLSCA_loc => id%ROWSCA_loc
+          LALLOC = int(id%KEEP(89),8)
+        ENDIF
+        IF (allocok .GT. 0) THEN
+          id%INFO(1)=-13
+          CALL MUMPS_SET_IERROR(LALLOC,id%INFO(2))
+        ENDIF
+      ENDIF
+      CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                        id%COMM, id%MYID )
+C     Jump to 100 in case of error (we free everything)
+      IF (id%INFO(1) .LT. 0) GOTO 100
+      CALL MPI_BCAST(ROWSCA(1), id%N, MPI_REAL,
+     &               MASTER, id%COMM, IERR_MPI)
+      IF (id%KEEP(50) .EQ. 0) THEN
+        CALL MPI_BCAST(COLSCA(1), id%N, MPI_REAL,
+     &                 MASTER, id%COMM, IERR_MPI)
+      ENDIF
+      LIW_PASSED = max(id%KEEP(32),1)
+      ISCA = 1
+      IF ( id%MYID .ne. MASTER .OR.
+     &     id%KEEP(46) .eq. 1 ) THEN ! I_AM_SLAVE
+        DO ISTEP = 1, id%KEEP(28)
+          IF ( id%MYID_NODES.EQ. MUMPS_PROCNODE(
+     &         id%PROCNODE_STEPS(ISTEP),
+     &         id%KEEP(199) ) ) THEN
+              CALL MUMPS_SOL_GET_NPIV_LIELL_IPOS( ISTEP, id%KEEP,
+     &        NPIV, LIELL, IPOS,
+     &        id%IS(1), LIW_PASSED, id%PTLUST_S(1), id%STEP(1), id%N)
+            IF ( id%KEEP(50) .EQ. 0 ) THEN
+C             Row indices:
+              JROW = IPOS + 1
+C             Column indices:
+              JCOL = IPOS + 1 + LIELL
+            ELSE
+C             Use row indices because column indices may have
+C             been set to negative to flag 2x2 pivots
+              JROW = IPOS + 1
+            ENDIF
+            IF (id%KEEP(50).EQ.0) THEN
+              DO JJ = 1, NPIV
+                id%ROWSCA_loc(ISCA+JJ-1) = ROWSCA(id%IS(JROW+JJ-1))
+                id%COLSCA_loc(ISCA+JJ-1) = COLSCA(id%IS(JCOL+JJ-1))
+              ENDDO
+            ELSE
+              DO JJ = 1, NPIV
+                id%ROWSCA_loc(ISCA+JJ-1) = ROWSCA(id%IS(JROW+JJ-1))
+              ENDDO
+            ENDIF
+            ISCA = ISCA + NPIV
+          ENDIF
+        ENDDO
+      ENDIF
+C     End of EXTRACT_SCALING, we keep id%ROWSCA_loc and id%COLSCA_loc
+C     but free ROWSCA and COLSCA
+      GOTO 110
+      RETURN
+ 100  CONTINUE
+C     Exit with error, free what was allocated
+      IF (associated(id%ROWSCA_loc)) THEN
+        DEALLOCATE(id%ROWSCA_loc)
+        NULLIFY(id%ROWSCA_loc)
+      ENDIF
+      IF (associated(id%COLSCA_loc)) THEN
+        IF (id%KEEP(50) .EQ. 0) THEN
+          DEALLOCATE(id%COLSCA_loc)
+        ENDIF
+        NULLIFY(id%COLSCA_loc)
+      ENDIF
+ 110  CONTINUE
+C     Free local ROWSCA and COLSCA arrays
+      IF ( id%MYID .NE. 0) THEN
+        IF (associated(ROWSCA)) DEALLOCATE(ROWSCA)
+        IF ( id%KEEP(50) .EQ. 0 ) THEN
+          IF (associated(COLSCA)) DEALLOCATE(COLSCA)
+        ENDIF
+      ENDIF
+      NULLIFY(ROWSCA)
+      NULLIFY(COLSCA)
+      RETURN
+      END SUBROUTINE CMUMPS_EXTRACT_SCALING
+C
+C     ==================================================================
+C
       SUBROUTINE CMUMPS_EXTRACT_SCHUR_REDRHS(id)
       USE CMUMPS_STRUC_DEF
       IMPLICIT NONE
@@ -4328,3 +4829,145 @@ C                 of size SIZE_SCHUR.
       ENDIF
       RETURN
       END SUBROUTINE CMUMPS_EXTRACT_SCHUR_REDRHS
+      SUBROUTINE CMUMPS_EXTRACT_SINGULAR_VALUES(id)
+      USE CMUMPS_STRUC_DEF
+      IMPLICIT NONE
+C
+C  Purpose
+C  =======
+C
+C     
+      TYPE(CMUMPS_STRUC) :: id
+C
+C  Local variables
+C  ===============
+C
+      INCLUDE 'mpif.h'
+      INCLUDE 'mumps_tags.h'
+      INCLUDE 'mumps_headers.h'
+      INTEGER :: STATUS(MPI_STATUS_SIZE)
+      INTEGER :: IERR
+      INTEGER, PARAMETER :: MASTER = 0
+      INTEGER :: ID_ROOT, ALLOCOK
+C
+C  External functions
+C  ==================
+C
+      INTEGER MUMPS_PROCNODE
+      EXTERNAL MUMPS_PROCNODE
+C     Quick return in case factorization did not terminate correctly
+      IF (id%INFO(1) .LT. 0) RETURN
+C     Quick return if Postponing + rank revealing option off
+      IF (id%KEEP(19) .EQ. 0) RETURN
+C     Get Root id
+      ID_ROOT =MUMPS_PROCNODE(
+     &    id%PROCNODE_STEPS(id%STEP(id%KEEP(20))),
+     &    id%KEEP(199))
+      IF ( id%KEEP( 46 )  .NE. 1 ) THEN
+        ID_ROOT = ID_ROOT + 1
+      END IF  
+C     =================================
+C     Singular values are stored in 
+C     root%SINGULAR_VALUES
+C     We copy it to id%SINGULAR_VALUES
+C     =================================
+      IF ((ID_ROOT.EQ.id%MYID).AND.(id%MYID.EQ.MASTER)) THEN
+C        write(6,*) " singular_values already on host"
+         IF (associated(id%SINGULAR_VALUES))
+     &        DEALLOCATE(id%SINGULAR_VALUES)
+         NULLIFY(id%SINGULAR_VALUES)
+         id%NB_SINGULAR_VALUES=id%root%NB_SINGULAR_VALUES
+         ALLOCATE(id%SINGULAR_VALUES(id%NB_SINGULAR_VALUES)
+     &        , stat=ALLOCOK)
+         IF (ALLOCOK.GT.0) THEN
+            id%INFO(1)=-13
+            id%INFO(2)= id%NB_SINGULAR_VALUES
+            RETURN
+         END IF
+         CALL scopy(id%NB_SINGULAR_VALUES,
+     &        id%root%SINGULAR_VALUES(1), 1,
+     &        id%SINGULAR_VALUES(1), 1)
+      ELSE
+         IF (id%MYID.EQ.ID_ROOT) THEN
+C     Send
+C           write(6,*) " id%MYID sends singular_values "
+            CALL MPI_SEND(
+     &           id%root%NB_SINGULAR_VALUES,
+     &           1,
+     &           MPI_INTEGER,
+     &           MASTER, TAG_ROOT1,
+     &           id%COMM, IERR )
+            CALL MPI_SEND(
+     &           id%root%SINGULAR_VALUES(1),
+     &           id%root%NB_SINGULAR_VALUES,
+     &           MPI_REAL,
+     &           MASTER, TAG_ROOT2,
+     &           id%COMM, IERR )
+         ELSEIF (id%MYID.EQ.MASTER) THEN
+C     Receive
+            CALL MPI_RECV( id%NB_SINGULAR_VALUES,
+     &           1,
+     &           MPI_INTEGER, ID_ROOT, TAG_ROOT1,
+     &           id%COMM, STATUS, IERR )
+            IF (associated(id%SINGULAR_VALUES))
+     &           DEALLOCATE(id%SINGULAR_VALUES)
+            NULLIFY(id%SINGULAR_VALUES)
+            ALLOCATE(id%SINGULAR_VALUES(id%NB_SINGULAR_VALUES)
+     &           , stat=ALLOCOK)
+            IF (ALLOCOK.GT.0) THEN
+               id%INFO(1)=-13
+               id%INFO(2)= id%NB_SINGULAR_VALUES
+               RETURN
+            END IF
+            CALL MPI_RECV( id%SINGULAR_VALUES(1),
+     &           id%NB_SINGULAR_VALUES,
+     &           MPI_REAL, ID_ROOT, TAG_ROOT2,
+     &           id%COMM, STATUS, IERR )
+         ENDIF
+      ENDIF
+      RETURN
+      END SUBROUTINE CMUMPS_EXTRACT_SINGULAR_VALUES
+      SUBROUTINE CMUMPS_SET_NOMP_MAX(KEEP281, KEEP361,
+     &                               N, NOMP_MAX)
+!$    USE OMP_LIB
+C
+C  Purpose
+C  =======
+C     set NOMP_MAX from KEEP(281)
+C     on output NOMP_MAX >=0
+C
+C  Parameters
+C  ==========
+C
+      INTEGER, INTENT(IN)    :: KEEP281, KEEP361, N
+      INTEGER, INTENT(OUT)   :: NOMP_MAX
+C     
+C     Local variables
+C   
+      INTEGER :: NOMP
+C
+C     out-of-range entries treated as -1
+      NOMP_MAX= max(-1, KEEP281)
+      NOMP    = 1
+!$    NOMP = omp_get_max_threads()
+      IF (NOMP_MAX.EQ.-1) THEN
+C     automatic setting
+       IF (N.LE.KEEP361) THEN
+         NOMP_MAX = 0
+         RETURN
+       ENDIF
+       IF (NOMP.GT.1) THEN
+C       conservative because of memory allocation
+        NOMP_MAX = min(NOMP, 10)
+       ELSE
+C       no multithreading and all parallel do suppressed
+        NOMP_MAX = 0
+       ENDIF
+      ELSE
+C     NOMP_MAX >=0
+C     use provided value
+       NOMP_MAX = min(NOMP_MAX, NOMP)
+      ENDIF
+C
+      RETURN
+      END SUBROUTINE CMUMPS_SET_NOMP_MAX
diff -pruN 5.6.2-2.1/src/cfac_front_LDLT_type1.F 5.7.1-1/src/cfac_front_LDLT_type1.F
--- 5.6.2-2.1/src/cfac_front_LDLT_type1.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_front_LDLT_type1.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -136,7 +136,7 @@ C
       XSIZE  = KEEP(IXSZ)
       NFRONT = IW(IOLDPS+XSIZE)
       LDA    = NFRONT
-      NASS   = iabs(IW(IOLDPS+2+XSIZE))
+      NASS   = abs(IW(IOLDPS+2+XSIZE))
       IW(IOLDPS+3+XSIZE) =  -99999
       LR_ACTIVATED= .FALSE.        
       COMPRESS_PANEL = .FALSE.
@@ -251,7 +251,8 @@ C
      &        NFRONT-NASS, LRGROUPS, NPARTSCB, 
      &        NPARTSASS, BEGS_BLR)
          CALL REGROUPING2(BEGS_BLR, NPARTSASS, NASS, NPARTSCB,
-     &        NFRONT-NASS, KEEP(488), .FALSE., KEEP(472))     
+     &        NFRONT-NASS, KEEP(488), .FALSE., KEEP(472), 
+     &        NFRONT, KEEP(1))     
          NB_BLR = NPARTSASS + NPARTSCB
          call MAX_CLUSTER(BEGS_BLR,NB_BLR,MAXI_CLUSTER)
          MAXI_RANK = KEEP(479)*MAXI_CLUSTER
diff -pruN 5.6.2-2.1/src/cfac_front_LDLT_type2.F 5.7.1-1/src/cfac_front_LDLT_type2.F
--- 5.6.2-2.1/src/cfac_front_LDLT_type2.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_front_LDLT_type2.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -74,7 +74,7 @@ C
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
       INTEGER, INTENT(IN) :: NINROWARR(KEEP(195))
       INTEGER, INTENT(IN) :: PTRDEBARR(KEEP(196))
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INTEGER(8) :: PTRAST(KEEP(28))
       INTEGER(8) :: PTRFAC(KEEP(28))
       INTEGER(8) :: PAMASTER(KEEP(28))
@@ -187,7 +187,7 @@ C
       IOLDPS = PTLUST_S(STEP( INODE ))
       POSELT = PTRAST(STEP( INODE ))
       NFRONT = IW(IOLDPS+XSIZE)
-      NASS   = iabs(IW(IOLDPS+2+XSIZE))
+      NASS   = abs(IW(IOLDPS+2+XSIZE))
       LDAFS  = NASS
       IF ((KEEP(219).EQ.1).AND.(KEEP(207).EQ.1).AND.(KEEP(50).EQ.2)
      &   ) THEN
@@ -299,7 +299,8 @@ C
      &        0, LRGROUPS, NPARTSCB, 
      &        NPARTSASS, BEGS_BLR)
          CALL REGROUPING2(BEGS_BLR, NPARTSASS, NASS, NPARTSCB,
-     &        0, KEEP(488), .FALSE., KEEP(472))     
+     &        0, KEEP(488), .FALSE., KEEP(472), 
+     &        NFRONT, KEEP(1))     
          NB_BLR = NPARTSASS + NPARTSCB
          call MAX_CLUSTER(BEGS_BLR,NB_BLR,MAXI_CLUSTER)
          MAXI_RANK = KEEP(479)*MAXI_CLUSTER
diff -pruN 5.6.2-2.1/src/cfac_front_LU_type1.F 5.7.1-1/src/cfac_front_LU_type1.F
--- 5.6.2-2.1/src/cfac_front_LU_type1.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_front_LU_type1.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -143,7 +143,7 @@ C
       LAFAC  = -9999_8  
       XSIZE      = KEEP(IXSZ)
       NFRONT     = IW(IOLDPS+XSIZE)
-      NASS       = iabs(IW(IOLDPS+2+XSIZE))
+      NASS       = abs(IW(IOLDPS+2+XSIZE))
       IW(IOLDPS+3+XSIZE) =  -99999
       LR_ACTIVATED = .FALSE.        
       COMPRESS_PANEL = .FALSE.
@@ -257,7 +257,8 @@ C
      &        NFRONT-NASS, LRGROUPS, NPARTSCB, 
      &        NPARTSASS, BEGS_BLR)
          CALL REGROUPING2(BEGS_BLR, NPARTSASS, NASS, NPARTSCB,
-     &        NFRONT-NASS, KEEP(488), .FALSE., KEEP(472))     
+     &        NFRONT-NASS, KEEP(488), .FALSE., KEEP(472), 
+     &        NFRONT, KEEP(1))     
          NB_BLR = NPARTSASS + NPARTSCB
          call MAX_CLUSTER(BEGS_BLR,NB_BLR,MAXI_CLUSTER)
          MAXI_RANK = KEEP(479)*MAXI_CLUSTER
diff -pruN 5.6.2-2.1/src/cfac_front_LU_type2.F 5.7.1-1/src/cfac_front_LU_type2.F
--- 5.6.2-2.1/src/cfac_front_LU_type2.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_front_LU_type2.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -75,7 +75,7 @@ C
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
       INTEGER, INTENT(IN) :: NINROWARR(KEEP(195))
       INTEGER, INTENT(IN) :: PTRDEBARR(KEEP(196))
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INTEGER(8) :: PTRAST(KEEP(28))
       INTEGER(8) :: PTRFAC(KEEP(28))
       INTEGER(8) :: PAMASTER(KEEP(28))
@@ -166,7 +166,7 @@ C
       POSELT = PTRAST(STEP( INODE ))
       XSIZE  = KEEP(IXSZ)
       NFRONT = IW(IOLDPS+XSIZE)
-      NASS   = iabs(IW(IOLDPS+2+XSIZE))
+      NASS   = abs(IW(IOLDPS+2+XSIZE))
       IW(IOLDPS+3+XSIZE) =  -99999
       LR_ACTIVATED   = (IW(IOLDPS+XXLR).GT.0)
       COMPRESS_PANEL = (IW(IOLDPS+XXLR).GE.2)
@@ -286,7 +286,8 @@ C
      &        NFRONT-NASS, LRGROUPS, NPARTSCB, 
      &        NPARTSASS, BEGS_BLR)
          CALL REGROUPING2(BEGS_BLR, NPARTSASS, NASS, NPARTSCB,
-     &        NFRONT-NASS, KEEP(488), .FALSE., KEEP(472))     
+     &        NFRONT-NASS, KEEP(488), .FALSE., KEEP(472), 
+     &        NFRONT, KEEP(1))     
          NB_BLR = NPARTSASS + NPARTSCB
          call MAX_CLUSTER(BEGS_BLR,NB_BLR,MAXI_CLUSTER)
          MAXI_RANK = KEEP(479)*MAXI_CLUSTER
diff -pruN 5.6.2-2.1/src/cfac_front_aux.F 5.7.1-1/src/cfac_front_aux.F
--- 5.6.2-2.1/src/cfac_front_aux.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_front_aux.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -129,7 +129,7 @@ C
             ELSE
               IF (J3.EQ.0) GOTO 370
 #if defined(_OPENMP)
-              IF (KEEP(351).EQ.1 .AND. J3.GE.KEEP(360)) THEN
+              IF (J3.GE.KEEP(360)) THEN
                 J1_ini = J1
                 CHUNK = max(KEEP(360)/2,(J3+NOMP-1)/NOMP)
 !$OMP  PARALLEL DO schedule(static, CHUNK)
@@ -289,7 +289,7 @@ C
           ENDIF
         ENDIF
 #endif
-        IF (KEEP(351).EQ.2) THEN
+        IF (KEEP(351).EQ.1) THEN
           MAXFROMN = 0.0E0
           IF (NEL2 > 0) THEN
             IS_MAXFROMN_AVAIL = .TRUE.
@@ -677,6 +677,9 @@ C
         NPIV   = IW(IOLDPS+1+XSIZE)
         IBEG_BLOCK = NPIV
         IF (NASS.EQ.NPIV) GOTO 500
+        IF (KEEP(19).GT.0) THEN
+         GOTO 500
+        ENDIF
         IS_MAXFROMN_AVAIL = .FALSE.
  120    CALL CMUMPS_FAC_H(NFRONT,NASS,IW,LIW,A,LA,
      &     INOPV, NOFFW,
@@ -762,6 +765,7 @@ C
       COMPLEX ZERO
       PARAMETER( ZERO = (0.0E0,0.0E0) )
       REAL RZERO, RMAX, AMROW, MAX_PREV_in_PARPIV
+      REAL RCMAX
       INTEGER(8) :: APOSMAX, APOSROW
       REAL       :: RMAX_NORELAX
       REAL PIVNUL, ABS_PIVOT
@@ -1006,11 +1010,45 @@ C
             RMAX         = max(RMAX,abs(RMAX_NORELAX))
             IF (ABS_PIVOT .GE. UU*RMAX .AND.
      &          ABS_PIVOT .GT. max(SEUIL,tiny(RMAX))) THEN
+               IF (KEEP(19).GT.0) THEN
+                 IF (LAST_ROW.EQ.NFRONT) THEN
+                   LRLOC = LAST_ROW -KEEP(253)-NVSCHUR
+                 ELSE
+                   LRLOC = LAST_ROW
+                 ENDIF
+                 J1=POSELT+int(IPIV-1,8)+int(NPIV,8)*NFRONT8
+                 J2=POSELT+int(IPIV-1,8)+int(LRLOC-1,8)*NFRONT8
+                 RCMAX = RZERO
+                 DO JJ=J1, J2, NFRONT8
+                   RCMAX = max(abs(A(JJ)),RCMAX)
+                 ENDDO
+                 IF (ABS_PIVOT .GE. UU*RCMAX) THEN
+                   JMAX = IPIV - NPIV
+                   GO TO 380
+                 ENDIF
+               ELSE
                 JMAX = IPIV - NPIV
                 GO TO 380
+               ENDIF
             ENDIF
             IF ( .NOT. (AMROW .GE. UU*RMAX .AND.
      &                  AMROW .GT. max(SEUIL,tiny(RMAX))) ) GO TO 460
+            IF (KEEP(19).GT.0) THEN
+              IF (LAST_ROW.EQ.NFRONT) THEN
+                LRLOC = LAST_ROW -KEEP(253)-NVSCHUR
+              ELSE
+                LRLOC = LAST_ROW
+              ENDIF
+              J1=POSELT+int(NPIV+JMAX-1,8)+int(NPIV,8)*NFRONT8
+              J2=POSELT+int(NPIV+JMAX-1,8)+int(LRLOC-1,8)*NFRONT8
+              RCMAX = RZERO
+              DO JJ=J1, J2, NFRONT8
+                RCMAX = max(abs(A(JJ)),RCMAX)
+              ENDDO
+              IF (.NOT.(AMROW .GE. UU*RCMAX) ) THEN 
+                GO TO 460
+              ENDIF
+            ENDIF 
             NOFFW = NOFFW + 1
   380       CONTINUE
           IF (K206.GE.1) THEN
@@ -1844,10 +1882,6 @@ C
          LPOS1   = POSPV2 + LDA8 - 1_8
          LPOS2   = LPOS1 + 1_8
 #if defined(__ve__)
-#if defined(check)
-         IF (LDA8.NE.NFRONT8) CALL MUMPS_ABORT()
-         IF (NEL2 + NCB1.NE.LAST_ROW-NPIV_NEW) CALL MUMPS_ABORT()
-#endif
          CALL ccopy(LAST_ROW-NPIV_NEW, A(LPOS1), LDA, A(POSPV1+2_8), 1)
          CALL ccopy(LAST_ROW-NPIV_NEW, A(LPOS2), LDA, A(POSPV2+1_8), 1)
 !$       OMP_FLAG = (NEL2+NCB1 > 300)
@@ -2014,21 +2048,6 @@ C
            BLSIZE = LAST_COL_GEMM - IEND_BLOCK
           END IF
           IF ( LAST_COL_GEMM - IEND_BLOCK .GT. 0 ) THEN
-#if defined(SAK_BYROW)
-           DO IROW = IEND_BLOCK+1, LAST_COL_GEMM, BLSIZE
-            Block = min( BLSIZE, LAST_COL_GEMM - IROW + 1 )
-            LPOS = POSELT + int(IROW  - 1,8) * LDA8 +
-     &                      int(IBEG_BLOCK - 1,8)
-            UPOS = POSELT + int(IBEG_BLOCK - 1,8) * LDA8 +
-     &                      int(IROW - 1,8)
-            APOS = POSELT + int(IROW  - 1,8) * LDA8 + 
-     &             int(IEND_BLOCK,8)
-            CALL cgemm( 'N','N', IROW + Block - IEND_BLOCK - 1, 
-     &             Block, NPIV_BLOCK,
-     &                 ALPHA, A( UPOS ), LDA,
-     &                 A( LPOS ), LDA, ONE, A( APOS ), LDA )
-           ENDDO
-#else
            DO IROW = IEND_BLOCK+1, LAST_COL_GEMM, BLSIZE
             Block = min( BLSIZE, LAST_COL_GEMM - IROW + 1 )
             LPOS = POSELT + int( IROW - 1,8) * LDA8 +
@@ -2040,7 +2059,6 @@ C
      &                 NPIV_BLOCK, ALPHA, A( UPOS ), LDA,
      &                 A( LPOS ), LDA, ONE, A( APOS ), LDA )
            END DO
-#endif
           END IF
 #if defined(GEMMT_AVAILABLE)
          END IF 
diff -pruN 5.6.2-2.1/src/cfac_front_type2_aux.F 5.7.1-1/src/cfac_front_type2_aux.F
--- 5.6.2-2.1/src/cfac_front_type2_aux.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_front_type2_aux.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -728,7 +728,7 @@ C
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
       INTEGER, INTENT(IN) :: NINROWARR(KEEP(195))
       INTEGER, INTENT(IN) :: PTRDEBARR(KEEP(196))
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INTEGER(8) :: PTRAST  (KEEP(28))
       INTEGER(8) :: PTRFAC  (KEEP(28))
       INTEGER(8) :: PAMASTER(KEEP(28))
@@ -798,7 +798,7 @@ C
      &               NSLAVES, WIDTH, COMM,
      &               NELIM, NPARTSASS, CURRENT_BLR_PANEL,
      &               LR_ACTIVATED, BLR_LorU, 
-     &        IERR )
+     &               ICNTL, IERR )
           IF (IERR.EQ.-1) THEN
             BLOCKING  = .FALSE.
             SET_IRECV = .TRUE.
diff -pruN 5.6.2-2.1/src/cfac_lastrtnelind.F 5.7.1-1/src/cfac_lastrtnelind.F
--- 5.6.2-2.1/src/cfac_lastrtnelind.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_lastrtnelind.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -68,7 +68,7 @@ C
      &        TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
       DOUBLE PRECISION OPASSW, OPELIW
       INTEGER ITLOC( N+KEEP(253) ), FILS( N ), DAD( KEEP(28) )
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
diff -pruN 5.6.2-2.1/src/cfac_lr.F 5.7.1-1/src/cfac_lr.F
--- 5.6.2-2.1/src/cfac_lr.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/cfac_lr.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/cfac_mem_alloc_cb.F 5.7.1-1/src/cfac_mem_alloc_cb.F
--- 5.6.2-2.1/src/cfac_mem_alloc_cb.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_mem_alloc_cb.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/cfac_mem_compress_cb.F 5.7.1-1/src/cfac_mem_compress_cb.F
--- 5.6.2-2.1/src/cfac_mem_compress_cb.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_mem_compress_cb.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -148,9 +148,6 @@ C
       INTEGER(8) :: RCURRENT_SIZE, DYN_SIZE
       LOGICAL :: RECORD_CAN_BE_COMPRESSED
       INTEGER IXXP
-      INTEGER, EXTERNAL :: MUMPS_TYPENODE
-      INTEGER, EXTERNAL :: MUMPS_PROCNODE
-      LOGICAL, EXTERNAL :: CMUMPS_ISBAND
       EXTERNAL MPI_WTIME
       DOUBLE PRECISION MPI_WTIME
       DOUBLE PRECISION TIME_STRT
diff -pruN 5.6.2-2.1/src/cfac_mem_dynamic.F 5.7.1-1/src/cfac_mem_dynamic.F
--- 5.6.2-2.1/src/cfac_mem_dynamic.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_mem_dynamic.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -251,7 +251,7 @@ C
             ENDIF
           ENDIF
           IF ( MOVE2DYNAMIC ) THEN
-#if defined(MUMPS_ALLOC_FROM_C)
+#if defined(MUMPS_ALLOC_FROM_C) || defined(_CRAYFTN)
             CALL MUMPS_MALLOC_C( TMP_ADDRESS,
      &      RCURRENT_SIZE * KEEP(35) )
             IF (TMP_ADDRESS .EQ. 0_8) THEN
@@ -279,7 +279,7 @@ C
      &        LIW-ICURRENT+1, SIZEHOLE, KEEP(IXSZ))
             ENDIF
             CALL MUMPS_STOREI8(RCURRENT_SIZE,IW(ICURRENT+XXD))
-#if defined(MUMPS_ALLOC_FROM_C)
+#if defined(MUMPS_ALLOC_FROM_C) || defined(_CRAYFTN)
             CALL CMUMPS_DM_SET_PTR( TMP_ADDRESS, RCURRENT_SIZE,
      &                              DYNAMIC_CB )
 #else
@@ -438,7 +438,7 @@ C
       LOGICAL, INTENT(IN) :: ATOMIC_UPDATES
       INTEGER(8) :: KEEP8(150)
       INTEGER IDUMMY
-#if defined(MUMPS_ALLOC_FROM_C)
+#if defined(MUMPS_ALLOC_FROM_C) || defined(_CRAYFTN)
       CALL MUMPS_FREE_C(DYNPTR(1))
 #else
       DEALLOCATE(DYNPTR)
diff -pruN 5.6.2-2.1/src/cfac_mem_free_block_cb.F 5.7.1-1/src/cfac_mem_free_block_cb.F
--- 5.6.2-2.1/src/cfac_mem_free_block_cb.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_mem_free_block_cb.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/cfac_mem_stack.F 5.7.1-1/src/cfac_mem_stack.F
--- 5.6.2-2.1/src/cfac_mem_stack.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_mem_stack.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -58,7 +58,7 @@ C
       INTEGER INTARR(KEEP8(27)) 
       INTEGER ITLOC( N + KEEP(253) ), FILS( N ), DAD( KEEP(28) ),
      &        ND( KEEP(28) ), FRERE( KEEP(28) )
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INTEGER ISTEP_TO_INIV2(KEEP(71)), 
      &        TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
       INTEGER NELT, LPTRAR
@@ -111,9 +111,8 @@ C
       DOUBLE PRECISION FLOP1, FLOP1_EFFECTIVE
       LOGICAL BLOCKING, SET_IRECV, MESSAGE_RECEIVED
       LOGICAL SSARBR, SSARBR_ROOT, MUMPS_INSSARBR,
-     & MUMPS_IN_OR_ROOT_SSARBR, MUMPS_ROOTSSARBR
-      EXTERNAL MUMPS_INSSARBR, MUMPS_IN_OR_ROOT_SSARBR,
-     & MUMPS_ROOTSSARBR
+     & MUMPS_IN_OR_ROOT_SSARBR
+      EXTERNAL MUMPS_INSSARBR, MUMPS_IN_OR_ROOT_SSARBR
       LP = ICNTL(1)
       IF (ICNTL(4) .LE. 0) LP = -1
       INPLACE = .FALSE.
@@ -123,7 +122,7 @@ C
       NFRONT = IW(IOLDPS+KEEP(IXSZ))
       NPIV   = IW(IOLDPS + 1+KEEP(IXSZ))       
       NMAXNPIV = max(NPIV, NMAXNPIV)
-      NASS   = iabs(IW(IOLDPS + 2+KEEP(IXSZ))) 
+      NASS   = abs(IW(IOLDPS + 2+KEEP(IXSZ))) 
       NSLAVES=  IW(IOLDPS+5+KEEP(IXSZ))
       H_INODE= 6 + NSLAVES + KEEP(IXSZ)
       LCONT = NFRONT - NPIV
diff -pruN 5.6.2-2.1/src/cfac_mem_stack_aux.F 5.7.1-1/src/cfac_mem_stack_aux.F
--- 5.6.2-2.1/src/cfac_mem_stack_aux.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_mem_stack_aux.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/cfac_omp_m.F 5.7.1-1/src/cfac_omp_m.F
--- 5.6.2-2.1/src/cfac_omp_m.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_omp_m.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -64,7 +64,7 @@ C
       INTEGER(8), INTENT(IN) :: THREAD_LA
       INTEGER PROCNODE_STEPS(KEEP(28))
       INTEGER ITLOC(N+KEEP(253))
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INTEGER NSTK_STEPS(KEEP(28))
       INTEGER(8), INTENT(IN) :: PTRARW(LPTRAR), PTRAIW(LPTRAR)
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
@@ -118,14 +118,8 @@ C
       INTEGER, INTENT (IN)    :: NBCOLS_I4, NBCOLS_I8
       INTEGER, INTENT (IN)    :: I4_L0_OMP(NBSTATS_I4, NBCOLS_I4)
       INTEGER(8), INTENT (IN) :: I8_L0_OMP(NBSTATS_I8, NBCOLS_I8)
-      EXTERNAL MUMPS_TYPENODE, MUMPS_PROCNODE
-      INTEGER MUMPS_TYPENODE, MUMPS_PROCNODE
-      LOGICAL MUMPS_INSSARBR,MUMPS_ROOTSSARBR
-      EXTERNAL MUMPS_INSSARBR,MUMPS_ROOTSSARBR
       LOGICAL CMUMPS_POOL_EMPTY
       EXTERNAL CMUMPS_POOL_EMPTY, CMUMPS_EXTRACT_POOL
-      INTEGER numroc
-      EXTERNAL numroc
       INTEGER :: MYTHREAD_ID, ITH  
       INTEGER :: THREAD_ID_P       
       DOUBLE PRECISION, PARAMETER :: DZERO = 0.0D0, DONE = 1.0D0
@@ -1216,7 +1210,7 @@ C
       INTEGER ITLOC( N + KEEP(253) ), FILS( N ),
      &        ND( KEEP(28) ), FRERE( KEEP(28) )
       INTEGER DAD( KEEP(28) )
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INTEGER ISTEP_TO_INIV2(KEEP(71)), 
      &        TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
       INTEGER NELT, LPTRAR
diff -pruN 5.6.2-2.1/src/cfac_par_m.F 5.7.1-1/src/cfac_par_m.F
--- 5.6.2-2.1/src/cfac_par_m.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_par_m.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -32,6 +32,7 @@ C
 !$    USE OMP_LIB
       USE CMUMPS_DYNAMIC_MEMORY_M, ONLY : 
      &                                    CMUMPS_DM_FREEALLDYNAMICCB
+      USE CMUMPS_BUF, ONLY : CMUMPS_BUF_TEST
       USE CMUMPS_LOAD
       USE CMUMPS_OOC
       USE CMUMPS_FAC_ASM_MASTER_M
@@ -64,7 +65,7 @@ C
       INTEGER LPOOL
       INTEGER PROCNODE_STEPS(KEEP(28))
       INTEGER ITLOC(N+KEEP(253))
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INTEGER IW(LIW), NSTK_STEPS(KEEP(28))
       INTEGER(8), INTENT(IN) :: PTRARW(LPTRAR), PTRAIW(LPTRAR)
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
@@ -132,15 +133,31 @@ C
       INTEGER LOCAL_M, LOCAL_N
       INTEGER LRHS_CNTR_MASTER_ROOT, FWD_LOCAL_N_RHS
       LOGICAL ROOT_OWNER
+!$    INTEGER :: NOMP
+!$    INTEGER(8) :: CHUNK8  
+      INTEGER  LIWK_RR, PHASE, MBLOCK, NBLOCK
+      INTEGER(8) :: LWK_RR
+      INTEGER(8) :: I8
+      INTEGER  I, K, KEEP17_LU
+      INTEGER  NOFFNEGPV_ROOT, NTOTPV_ROOT, NB22T1_ROOT, NBTINY_ROOT,
+     &         NULLNEGPV_ROOT,
+     &         DET_EXP_ROOT, DET_SIGN_ROOT, 
+     &         LRecord, Header_ROOT(5)
+      COMPLEX  DET_MANT_ROOT  
+      REAL DKEEP_SAVE(230)
+      COMPLEX, DIMENSION(:), POINTER     :: A_ROOT_SAVE
+      LOGICAL                            :: IS_A_ROOT_SAVE_ALLOCATED
+      INTEGER, DIMENSION(:), ALLOCATABLE :: RECORD_ROOT
+      INTEGER KEEP_SAVE(500)             
+      INTEGER(8) KEEP8_SAVE(150)
       EXTERNAL MUMPS_TYPENODE, MUMPS_PROCNODE
       INTEGER MUMPS_TYPENODE, MUMPS_PROCNODE
-      LOGICAL MUMPS_INSSARBR,MUMPS_ROOTSSARBR
-      EXTERNAL MUMPS_INSSARBR,MUMPS_ROOTSSARBR
+      LOGICAL MUMPS_INSSARBR
+      EXTERNAL MUMPS_INSSARBR
       LOGICAL CMUMPS_POOL_EMPTY
       EXTERNAL CMUMPS_POOL_EMPTY, CMUMPS_EXTRACT_POOL
       LOGICAL STACK_RIGHT_AUTHORIZED
-      INTEGER numroc
-      EXTERNAL numroc
+      INTEGER, EXTERNAL :: MUMPS_NUMROC
       INTEGER JOBASS, ETATASS
       INTEGER(8) :: LAFAC
       INTEGER LIWFAC, STRAT, TYPEFile, NextPiv2beWritten,
@@ -153,13 +170,6 @@ C
       DOUBLE PRECISION :: ROOTTIME
       INTEGER:: ITH
       DOUBLE PRECISION :: DUMMY_FLOP_ESTIM_ACC
-#if defined(multicore_profiling)
-      DOUBLE PRECISION :: LATIME, LFTIME, LSTIME
-      DOUBLE PRECISION :: GATIME, GFTIME, GSTIME
-      GATIME = 0
-      GFTIME = 0
-      GSTIME = 0
-#endif
       DUMMY_FLOP_ESTIM_ACC = 0.0d0
       ITLOC(1:N+KEEP(253)) =0
       ASS_IRECV = MPI_REQUEST_NULL
@@ -169,6 +179,9 @@ C
       NULLIFY(BUFRX)
       IS_BUFRX_ALLOCATED = .FALSE.
       KEEP(143) = -1
+      KEEP17_LU = -1
+      NULLIFY(A_ROOT_SAVE)
+      IS_A_ROOT_SAVE_ALLOCATED = .FALSE.
       IF ( INFO(1) .LT. 0 ) THEN
         GOTO 640
       ENDIF
@@ -301,6 +314,8 @@ C
      &         MYID_NODES,KEEP,KEEP8,N)
             END IF
             GOTO 30
+          ELSE
+            CALL CMUMPS_BUF_TEST()
           ENDIF
       ENDIF
       GO TO 20
@@ -532,8 +547,26 @@ C
           WRITE(*,*) "ERROR 2 in CMUMPS_FAC_PAR", POSELT
           GOTO 635
         ENDIF
+        IF (KEEP(118).GE.40) THEN
+          IOLDPS = PTLUST(STEP(INODE))
+          LRecord = IW(IOLDPS+XXI)
+          IF (allocated(RECORD_ROOT)) DEALLOCATE(RECORD_ROOT)
+          ALLOCATE(RECORD_ROOT(LRecord), stat=IERR)
+          IF (IERR.GT.0) THEN
+            INFO(1)= -13
+            INFO(2)= LRecord
+            IF (LP > 0)
+     &      write(LP,*) "ERROR allocate RECORD_ROOT"
+            GOTO 635
+          ENDIF
+          RECORD_ROOT(1:LRecord) = IW(IOLDPS:IOLDPS+LRecord-1)
+        ENDIF
         CALL CMUMPS_CHANGE_HEADER
      &       ( IW(PTLUST(STEP(INODE))+KEEP(IXSZ)), KEEP(253) )
+        IF (KEEP(118).GE.40) THEN
+          Header_ROOT(1:5) = IW(PTLUST(STEP(INODE))+KEEP(IXSZ):
+     &                        PTLUST(STEP(INODE))+KEEP(IXSZ)+4)
+        ENDIF
         GOTO 200
       END IF
       POSELT = PTRAST(STEP(INODE))
@@ -554,11 +587,6 @@ C
      &           , PERM
      &           )
            IF (INFO(1).LT.0) GOTO 635
-#if defined(multicore_profiling)
-         LFTIME = MPI_WTIME() - LFTIME
-         GFTIME = GFTIME + LFTIME
-         WRITE(*,*)'FAC ',LFTIME
-#endif
       ELSE  
             IW( IOLDPS+4+KEEP(IXSZ) ) = 1
               CALL CMUMPS_FAC1_LDLT( N, INODE,
@@ -577,9 +605,6 @@ C
           ENDIF 
           JOBASS = ETATASS          
           IF (JOBASS.EQ.1) THEN
-#if defined(multicore_profiling)
-              LATIME = MPI_WTIME()
-#endif
               CALL CMUMPS_FAC_ASM_NIV1(COMM_LOAD, ASS_IRECV,
      &        N,INODE,IW,LIW,A,LA,
      &        INFO(1),ND,
@@ -598,11 +623,6 @@ C
      &        JOBASS,ETATASS
      &               , LRGROUPS
      &         )
-#if defined(multicore_profiling)
-         LATIME = MPI_WTIME() - LATIME
-         GATIME = GATIME + LATIME
-         WRITE(*,*)'ASS ',LATIME
-#endif
           ENDIF
           IF (MPA.GT.0)
      &    CALL MUMPS_PRINT_STILL_ACTIVE (MYID_NODES, KEEP, 
@@ -617,9 +637,6 @@ C
       ELSE
         TYPEF = -9999
       END IF
-#if defined(multicore_profiling)
-         LSTIME = MPI_WTIME()
-#endif
       CALL CMUMPS_FAC_STACK( COMM_LOAD, ASS_IRECV,
      &       N,INODE,TYPE,TYPEF,LA,IW,LIW,A,
      &       INFO(1),INFO(2),OPELI,NELVA,NMAXNPIV,
@@ -638,11 +655,6 @@ C
      &               , LRGROUPS
      &       ,DUMMY_FLOP_ESTIM_ACC
      &       )
-#if defined(multicore_profiling)
-         LSTIME = MPI_WTIME() - LSTIME
-         GSTIME = GSTIME + LSTIME
-         WRITE(*,*)'STK ',LSTIME
-#endif
       IF (MPA.GT.0)
      &   CALL MUMPS_PRINT_STILL_ACTIVE (MYID_NODES, KEEP, 
      &                        dble(DKEEP(17)), 
@@ -712,6 +724,7 @@ C
       ENDIF
       GO TO 20
  635  CONTINUE
+      IF (allocated(RECORD_ROOT)) DEALLOCATE(RECORD_ROOT)
       CALL CMUMPS_BDC_ERROR( MYID_NODES, SLAVEF, COMM_NODES, KEEP )
  640  CONTINUE
         CALL CMUMPS_CANCEL_IRECV( INFO(1),
@@ -914,8 +927,8 @@ C
                   CALL MUMPS_PROPINFO( ICNTL, INFO, COMM_NODES,
      &            MYID_NODES)
                   IF (root%yes .AND. INFO(1).GE.0) THEN
-                    FWD_LOCAL_N_RHS = numroc(KEEP(253), root%NBLOCK,
-     &              root%MYCOL, 0, root%NPCOL)
+                    FWD_LOCAL_N_RHS = MUMPS_NUMROC(KEEP(253),
+     &              root%NBLOCK, root%MYCOL, 0, root%NPCOL)
                     FWD_LOCAL_N_RHS = max(1,FWD_LOCAL_N_RHS)
                     CALL CMUMPS_GATHER_ROOT( MYID_NODES,
      &              root%TOT_ROOT_SIZE, KEEP(253),
@@ -941,6 +954,280 @@ C
                    NTOTPV = NTOTPV + NFRONT 
                    NMAXNPIV = max(NMAXNPIV,NFRONT)
                 END IF
+                IF ( KEEP(60) .EQ. 0 ) THEN
+                 IF ( ROOT_OWNER ) THEN
+                  IF (KEEP(118).GE.40) THEN
+                   NOFFNEGPV_ROOT = 0        
+                   NULLNEGPV_ROOT = 0        
+                   NTOTPV_ROOT = 0
+                   NB22T1_ROOT = 0
+                   NBTINY_ROOT = 0
+                   DET_SIGN_ROOT = 1
+                   DET_EXP_ROOT = 0
+                   DET_MANT_ROOT = cmplx(1.0E0,0.0E0, 
+     &                                   kind=kind(1.0E0))
+                   DKEEP_SAVE(:) = DKEEP(:)
+                   KEEP_SAVE(:)  = KEEP(:)
+                   KEEP8_SAVE(:) = KEEP8(:)
+                   KEEP_SAVE(201) = 0
+                   IF (KEEP(110).EQ.0) THEN
+                     KEEP_SAVE(110)= 1        
+                     IF (KEEP(118).EQ.40) THEN
+                      IF ((DKEEP(10).LE.0).OR.(DKEEP(10).GT.1)) THEN
+                             DKEEP_SAVE(1) = DKEEP(9)*1E-1
+                      ELSE
+                             DKEEP_SAVE(1) = DKEEP(9)*DKEEP(10) 
+                      ENDIF    
+                     ELSE IF (KEEP(118).EQ.41) THEN
+                        DKEEP_SAVE(1) = DKEEP(9)
+                     ELSE IF (KEEP(118).EQ.42) THEN
+                      IF (DKEEP(13).LT.1)  THEN
+                          DKEEP_SAVE(1) = DKEEP(9)*10 
+                      ELSE
+                         DKEEP_SAVE(1) = DKEEP(9)*DKEEP(13)       
+                      ENDIF
+                     ENDIF  
+                   ELSE 
+                     DKEEP_SAVE(1) = DKEEP(9)
+                   ENDIF 
+                   IS_A_ROOT_SAVE_ALLOCATED = .FALSE.
+                   IF (LRLU.GT.NFRONT8*NFRONT8) THEN
+                     A_ROOT_SAVE  => A(POSFAC:POSFAC+LRLU-1_8)
+                   ELSE
+                    IF (associated(A_ROOT_SAVE)) 
+     &                               DEALLOCATE(A_ROOT_SAVE)
+                    ALLOCATE(A_ROOT_SAVE(NFRONT8*NFRONT8),stat=IERR)
+                    IF (IERR.GT.0) THEN
+                     INFO(1) = -13
+                     CALL MUMPS_SET_IERROR(NFRONT8*NFRONT8, INFO(2) )
+                     IF (LP > 0 )
+     &                 write(LP,*) "ERROR allocating A_ROOT_SAVE ",
+     &                 " of size ", NFRONT*NFRONT
+                     GOTO 735
+                    ENDIF
+                    IS_A_ROOT_SAVE_ALLOCATED = .TRUE.
+                   ENDIF
+!$        NOMP = OMP_GET_MAX_THREADS()
+!$        CHUNK8=int(KEEP(361),8)
+!$OMP     PARALLEL DO PRIVATE(I8) SCHEDULE(STATIC, CHUNK8)
+!$OMP&    IF ( NFRONT8*NFRONT8 > int(KEEP(361),8) .AND. NOMP .GT. 1)
+                   DO I8 =1_8, NFRONT8*NFRONT8
+                       A_ROOT_SAVE(I8) = 
+     &                   A(PTRAST(STEP(KEEP(20)))+I8-1_8)
+                   ENDDO
+                   IW(PTLUST(STEP(INODE))+KEEP(IXSZ): 
+     &                    PTLUST(STEP(INODE))+KEEP(IXSZ)+4)
+     &                 = RECORD_ROOT(KEEP(IXSZ)+1:KEEP(IXSZ)+5)
+                   IW(PTLUST(STEP(INODE))+XXLR) = 0
+                   IF (KEEP(50).EQ.0) THEN
+                    CALL CMUMPS_FAC1_LU_I ( 
+     &               N, INODE, IW, LIW, A_ROOT_SAVE(1),
+     &               NFRONT8*NFRONT8, IPOSROOT, 1_8,
+     &               INFO(1), INFO(2), UU, NOFFNEGPV_ROOT, NTOTPV_ROOT,
+     &               NBTINY_ROOT,
+     &               DET_EXP_ROOT, DET_MANT_ROOT, DET_SIGN_ROOT,
+     &               KEEP_SAVE,KEEP8_SAVE,
+     &               STEP, PROCNODE_STEPS, MYID_NODES, SLAVEF,
+     &               SEUIL, AVOID_DELAYED, ETATASS,
+     &               DKEEP_SAVE(1), PIVNUL_LIST_STRUCT, IWPOS 
+     &               , LRGROUPS
+     &               , PERM
+     &               )
+                    IF (INFO(1).LT.0) THEN
+                     IF (LP.GT.0) 
+     &               write(LP,*) "ERROR after CMUMPS_FAC1_LU ",
+     &               "on the root INFO(1)= ", INFO(1)
+                     GOTO 735
+                    ENDIF 
+                   ELSE
+                    CALL CMUMPS_FAC1_LDLT_I (N,KEEP_SAVE(20),
+     &               IW, LIW, A_ROOT_SAVE(1), NFRONT8*NFRONT8,
+     &               IPOSROOT, 1_8,
+     &               INFO(1), INFO(2), UU,
+     &               NOFFNEGPV_ROOT, NULLNEGPV_ROOT, NTOTPV_ROOT,
+     &               NB22T1_ROOT, NBTINY_ROOT, 
+     &               DET_EXP_ROOT, DET_MANT_ROOT, DET_SIGN_ROOT,
+     &               KEEP_SAVE,KEEP8_SAVE, MYID_NODES, SEUIL, 
+     &               AVOID_DELAYED, ETATASS, DKEEP_SAVE(1),
+     &               PIVNUL_LIST_STRUCT, IWPOS
+     &               , LRGROUPS
+     &               , PERM
+     &               )
+                     IF (INFO(1).LT.0) THEN
+                      IF (LP.GT.0) 
+     &                write(LP,*) "ERROR after CMUMPS_FAC1_LDLT ",
+     &                "on the root INFO(1)= ", INFO(1)
+                      GOTO 735
+                     ENDIF 
+                   ENDIF 
+                   LRecord = IW(IOLDPS+XXI)
+                   IW(PTLUST(STEP(INODE)):
+     &                PTLUST(STEP(INODE))+LRecord-1) = 
+     &                                    RECORD_ROOT(1:LRecord) 
+                   IW(PTLUST(STEP(INODE))+KEEP(IXSZ): 
+     &                PTLUST(STEP(INODE))+KEEP(IXSZ)+4) =
+     &                                          Header_ROOT(1:5)
+                   KEEP17_LU = KEEP_SAVE(109)-KEEP(109)
+                   IF (KEEP_SAVE(109).GT.KEEP(109)) THEN
+                     K = 1
+                     DO I = KEEP(109)+1, KEEP(109)+KEEP17_LU
+                        RECORD_ROOT(K) = 
+     &                          PIVNUL_LIST_STRUCT%PIVNUL_LIST(I)
+                        K = K+1
+                     ENDDO
+                   ENDIF
+                   IF (IS_A_ROOT_SAVE_ALLOCATED) DEALLOCATE(A_ROOT_SAVE)
+                   NULLIFY(A_ROOT_SAVE)
+                   IS_A_ROOT_SAVE_ALLOCATED = .FALSE.
+                   DET_SIGN = DET_SIGN * DET_SIGN_ROOT
+                   DET_EXP  = DET_EXP + DET_EXP_ROOT
+                   CALL CMUMPS_UPDATEDETER ( DET_MANT_ROOT, 
+     &                                       DET_MANT, DET_EXP)
+                   NOFFNEGPV = NOFFNEGPV + NOFFNEGPV_ROOT
+                   NULLNEGPV = NULLNEGPV + NULLNEGPV_ROOT
+                  ENDIF 
+                  LOCAL_M = 0
+                  LOCAL_N = 0
+                  MBLOCK  = 0
+                  NBLOCK  = 0
+                  PHASE   = 1  
+                  CALL CMUMPS_SVD_QR_ESTIM_WK( PHASE,
+     &             MBLOCK, NBLOCK, NFRONT, LOCAL_M, LOCAL_N,
+     &             ROOT_OWNER, KEEP,KEEP8,
+     &             LIWK_RR, LWK_RR )    
+                  LBUFRX             = LWK_RR
+                  IS_BUFRX_ALLOCATED = .FALSE.
+                  IF ( LRLU .GT. LBUFRX ) THEN
+                      BUFRX => A(POSFAC:POSFAC+LBUFRX-1_8)
+                  ELSE
+                      ALLOCATE( BUFRX( LBUFRX ), stat = IERR )
+                      IF (IERR.gt.0) THEN
+                        INFO(1) = -13
+                        CALL MUMPS_SET_IERROR(LBUFRX, INFO(2))
+                        IF (LP.GT.0)
+     &                  write(LP,*) ' Error allocating, real
+     &                        array ','of size ', LBUFRX,
+     &                        ' before CMUMPS_SEQ_FACTO_ROOT_SVD_QR'
+                        GOTO 735
+                      ENDIF
+                      IS_BUFRX_ALLOCATED = .TRUE.
+                  ENDIF
+                 IF (PIVNUL_LIST_STRUCT%SIZE_PIVNUL_LIST .LT. 
+     &               KEEP(109)+NFRONT) THEN
+                  CALL MUMPS_RESIZE_PIVNUL(KEEP, N, PIVNUL_LIST_STRUCT, 
+     &                             KEEP(109)+NFRONT, INFO(1), INFO(2) ) 
+                  IF (INFO(1).LT.0) GOTO 735
+                 ENDIF
+                  CALL CMUMPS_SEQ_FACTO_ROOT_SVD_QR(
+     &                 NFRONT,A(PTRAST(STEP(KEEP(20)))),
+     &                 root,
+     &                 BUFRX(1), int(LBUFRX),
+     &                 KEEP,KEEP8, INFO, LP, DKEEP,
+     &                 GLOBK109, OPELI,
+     &                 PIVNUL_LIST_STRUCT%PIVNUL_LIST(KEEP(109)+1),
+     &                 PIVNUL_LIST_STRUCT%SIZE_PIVNUL_LIST- KEEP(109), 
+     &                 IW(IPOSROOTROWINDICES))
+                  IF (IS_BUFRX_ALLOCATED) DEALLOCATE ( BUFRX )
+                  NULLIFY(BUFRX)
+                  IS_BUFRX_ALLOCATED = .FALSE.
+                  IF (INFO(1).LT.0) GOTO 735
+                  IF (MPA.GT.0)
+     &            CALL MUMPS_PRINT_STILL_ACTIVE (MYID_NODES, KEEP, 
+     &                     dble(DKEEP(17)), 
+     &                     OPELI,
+     &                     OPLAST_PRINTED, MPA)
+                  CALL CMUMPS_UPDATE_PROGRESS( OPELI, KEEP8 )
+                  KEEP(143) = KEEP17_LU
+                  IF (KEEP(118).GE.40) THEN
+                    K = 1 
+                    IF (KEEP(17).GT.0) THEN
+                     DO I = KEEP(109)+1, KEEP(109)+KEEP(17)
+                      IF ( K .GT. KEEP17_LU ) THEN
+                        PIVNUL_LIST_STRUCT%PIVNUL_LIST(I) = -1
+                      ELSE
+                        PIVNUL_LIST_STRUCT%PIVNUL_LIST(I) = 
+     &                                 RECORD_ROOT(K)
+                      ENDIF
+                      K = K+1
+                     ENDDO
+                    ENDIF
+                  ENDIF
+                  IF (allocated(RECORD_ROOT)) DEALLOCATE(RECORD_ROOT)
+                      IF (KEEP(201).EQ.1) THEN 
+                        CALL MUMPS_GETI8(LAFAC, IW(IPOSROOT+XXR))
+                        LIWFAC    = IW(IPOSROOT+XXI)
+                        TYPEFile  = TYPEF_L
+                        NextPiv2beWritten = 1 
+                        MonBloc%INODE    = KEEP(20)   
+                        MonBloc%MASTER   = .TRUE.
+                        MonBloc%Typenode = 3
+                        MonBloc%NCOL     = NFRONT
+                        MonBloc%NROW     = NFRONT
+                        MonBloc%NFS      = NFRONT
+                        MonBloc%Last     = .TRUE.   
+                        MonBloc%LastPiv  = MonBloc%NCOL
+                        MonBloc%LastPanelWritten_L=-9999 
+                        MonBloc%LastPanelWritten_U=-9999 
+                        NULLIFY(MonBloc%INDICES)
+                        STRAT        = STRAT_WRITE_MAX
+                        MonBloc%Last = .TRUE.
+                        LAST_CALL    = .TRUE.
+                        CALL CMUMPS_OOC_IO_LU_PANEL
+     &                                 ( STRAT, TYPEFile,
+     &                                  A(PTRAST(STEP(KEEP(20)))),
+     &                                  LAFAC, MonBloc,
+     &                                  NextPiv2beWritten, IDUMMY,
+     &                                  IW(IPOSROOT), LIWFAC,
+     &                              MYID, KEEP8(31), IERR, LAST_CALL)
+                        IF(IERR.LT.0)THEN
+                        IF (LP > 0)
+     &                  WRITE(LP,*)MYID,
+     &                  ': Error raised in CMUMPS_OOC_IO_LU_PANEL',
+     &                  IERR
+                        INFO(1)=IERR
+                        ENDIF
+                      ELSE IF (KEEP(201).EQ.2) THEN 
+                        KEEP8(31)=KEEP8(31)+NFRONT8*NFRONT8
+                        CALL CMUMPS_NEW_FACTOR(KEEP(20),PTRFAC,
+     &                  KEEP,KEEP8,A,LA, NFRONT8*NFRONT8, IERR)
+                        IF(IERR.LT.0)THEN
+                        WRITE(*,*)MYID,
+     &                  ': Internal error in CMUMPS_NEW_FACTOR',
+     &                  IERR
+                        GOTO 735
+                        ENDIF
+                      ENDIF
+                      ITMP8  =  NFRONT8*NFRONT8
+                      IF(KEEP(201).NE.0)THEN 
+                        IF (PTRFAC(STEP(KEEP(20))).EQ.
+     &                      POSFAC-ITMP8) THEN
+                          POSFAC = POSFAC  - ITMP8
+                          LRLU   = LRLU    + ITMP8
+                          LRLUS  = LRLUS   + ITMP8
+                          KEEP8(69) = KEEP8(69) - ITMP8
+                        ELSE
+                          IF (LP.GT.0) 
+     &                    WRITE(LP,*) "Internal error",
+     &                    POSFAC,NFRONT8,
+     &                    "root KEEP(20) not on top in OOC"
+                          GOTO 735
+                         ENDIF
+                      ENDIF
+                      CALL CMUMPS_LOAD_MEM_UPDATE(.FALSE.,.FALSE.,
+     &                LA-LRLUS,ITMP8,0_8,KEEP,KEEP8,LRLUS)
+                ENDIF
+ 735         CONTINUE
+             CALL MUMPS_PROPINFO( ICNTL, INFO, COMM_NODES, MYID_NODES )
+             IF (INFO(1).LT.0) GOTO 745
+                 CALL MPI_BCAST( KEEP(17), 1, MPI_INTEGER,
+     &                MUMPS_PROCNODE(PROCNODE_STEPS(STEP(KEEP(20))),
+     &                               KEEP(199)),
+     &                COMM_NODES, IERR )
+                 CALL MPI_BCAST( KEEP(143), 1, MPI_INTEGER,
+     &                MUMPS_PROCNODE(PROCNODE_STEPS(STEP(KEEP(20))),
+     &                               KEEP(199)),
+     &                COMM_NODES, IERR )
+                END IF
                 IF (ROOT_OWNER.AND.KEEP(60).NE.0) THEN 
                   ITMP8 = NFRONT8*NFRONT8
                   IF ( PTRFAC(STEP(KEEP(20))) .EQ. POSFAC -
@@ -954,6 +1241,12 @@ C
                   ENDIF
                 ENDIF
             END IF
+            GOTO 750
+ 745  CONTINUE
+            IF (allocated(RECORD_ROOT)) DEALLOCATE(RECORD_ROOT)
+            IF (IS_A_ROOT_SAVE_ALLOCATED) DEALLOCATE(A_ROOT_SAVE)
+            NULLIFY(A_ROOT_SAVE)
+ 750  CONTINUE
             IF (INFO(1).LT.0) GOTO 500
             CALL MUMPS_SECFIN(ROOTTIME)
             DKEEP(99)=real(ROOTTIME)
diff -pruN 5.6.2-2.1/src/cfac_process_band.F 5.7.1-1/src/cfac_process_band.F
--- 5.6.2-2.1/src/cfac_process_band.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_process_band.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -46,7 +46,7 @@ C
       INTEGER PTRIST(KEEP(28)), STEP(N), 
      & PIMASTER(KEEP(28)), 
      & ITLOC( N + KEEP(253) )
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INTEGER :: ISTEP_TO_INIV2(KEEP(71))
 #if ! defined(NO_FDM_DESCBAND)
       INTEGER IWHANDLER_IN
@@ -124,7 +124,7 @@ C
      &       COMP, LRLUS, KEEP8(67), IFLAG, IERROR
      &     )
         IF ( IFLAG .LT. 0 ) RETURN
-#if defined(MUMPS_ALLOC_FROM_C)
+#if defined(MUMPS_ALLOC_FROM_C) || defined(_CRAYFTN)
         CALL MUMPS_MALLOC_C( TMP_ADDRESS,
      &      LREQCB * int(KEEP(35),8) )
         IF (TMP_ADDRESS .EQ. 0_8) THEN
@@ -145,7 +145,7 @@ C
      &    KEEP8, IFLAG, IERROR,
      &    .TRUE., 
      &    .FALSE. ) 
-#if ! defined(MUMPS_ALLOC_FROM_C)
+#if ! defined(MUMPS_ALLOC_FROM_C) && ! defined(_CRAYFTN)
           CALL MUMPS_ADDR_C( DYNAMIC_CB(1), TMP_ADDRESS )
 #endif
           CALL MUMPS_STOREI8(LREQCB, IW(IWPOSCB+1+XXD))
@@ -289,7 +289,7 @@ C
       INTEGER NELT, LPTRAR
       INTEGER FRTPTR( N+1 ), FRTELT( NELT )
       INTEGER ITLOC( N + KEEP(253) ), FILS( N ), DAD( KEEP(28) )
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
diff -pruN 5.6.2-2.1/src/cfac_process_bf.F 5.7.1-1/src/cfac_process_bf.F
--- 5.6.2-2.1/src/cfac_process_bf.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_process_bf.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/cfac_process_blfac_slave.F 5.7.1-1/src/cfac_process_blfac_slave.F
--- 5.6.2-2.1/src/cfac_process_blfac_slave.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_process_blfac_slave.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -75,7 +75,7 @@ C
       INTEGER COMM, MYID
       INTEGER PTLUST_S(KEEP(28))
       INTEGER ITLOC( N + KEEP(253)), FILS( N ), DAD( KEEP(28) )
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INTEGER ND( KEEP(28) ), FRERE_STEPS( KEEP(28) )
       DOUBLE PRECISION OPASSW, OPELIW
       DOUBLE PRECISION FLOP1
diff -pruN 5.6.2-2.1/src/cfac_process_blocfacto.F 5.7.1-1/src/cfac_process_blocfacto.F
--- 5.6.2-2.1/src/cfac_process_blocfacto.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_process_blocfacto.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -71,7 +71,7 @@ C
       INTEGER FRTPTR( N+1 ), FRTELT( NELT )
       INTEGER PTLUST_S(KEEP(28)),
      &        ITLOC(N+KEEP(253)), FILS(N), DAD(KEEP(28)), ND(KEEP(28))
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) :: PTRAIW( LPTRAR ), PTRARW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
@@ -132,8 +132,6 @@ C
       INTEGER NPARTSASS, NPARTSCB, MAXI_CLUSTER, LWORK,
      &        MAXI_CLUSTER_L, MAXI_CLUSTER_U, MAXI_CLUSTER_COL
       INTEGER  :: allocok
-      INTEGER MUMPS_PROCNODE
-      EXTERNAL MUMPS_PROCNODE
       KEEP_BEGS_BLR_L = .FALSE.
       nullify(BEGS_BLR_L)
       NB_BLR_U = -7654321
@@ -384,8 +382,9 @@ C
           CALL GET_CUT(IW(IOLDPS+HS:IOLDPS+HS+NROW1-1), 0,
      &                    NROW1, LRGROUPS, NPARTSCB, 
      &                    NPARTSASS, BEGS_BLR_L)
-          CALL REGROUPING2(BEGS_BLR_L, NPARTSASS, 0, NPARTSCB,
-     &                        NROW1-0, KEEP(488), .TRUE., KEEP(472))
+          CALL REGROUPING2(BEGS_BLR_L, NPARTSASS, NASS1, NPARTSCB,
+     &                        NROW1-0, KEEP(488), .TRUE., KEEP(472),
+     &                        NCOL1, KEEP(1))
           NB_BLR_L =  NPARTSCB
           IF (IPANEL.EQ.1) THEN
            BEGS_BLR_COL=>BEGS_BLR_U
diff -pruN 5.6.2-2.1/src/cfac_process_blocfacto_LDLT.F 5.7.1-1/src/cfac_process_blocfacto_LDLT.F
--- 5.6.2-2.1/src/cfac_process_blocfacto_LDLT.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_process_blocfacto_LDLT.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -70,7 +70,7 @@ C
       INTEGER COMM, MYID
       INTEGER PTLUST_S(KEEP(28)),
      &        ITLOC(N+KEEP(253)), FILS(N), DAD(KEEP(28)), ND(KEEP(28))
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) :: PTRAIW( LPTRAR ), PTRARW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
@@ -564,8 +564,9 @@ C
           CALL GET_CUT(IW(IOLDPS+HS:IOLDPS+HS+NROW1-1), 0,
      &                    NROW1, LRGROUPS, NPARTSCB, 
      &                    NPARTSASS, BEGS_BLR_LS)
-              CALL REGROUPING2(BEGS_BLR_LS, NPARTSASS, 0, NPARTSCB,
-     &                        NROW1-0, KEEP(488), .TRUE., KEEP(472))
+              CALL REGROUPING2(BEGS_BLR_LS, NPARTSASS, NASS1, NPARTSCB,
+     &                        NROW1-0, KEEP(488), .TRUE., KEEP(472),
+     &                        NCOL1, KEEP(1))
              NB_BLR_LS = NPARTSCB
         ENDIF
         call MAX_CLUSTER(BEGS_BLR_LM,NB_BLR_LM+1,MAXI_CLUSTER_LM)
@@ -579,7 +580,8 @@ C
      &                    NPARTSASS_COL, BEGS_BLR_COL)
           CALL REGROUPING2(BEGS_BLR_COL, NPARTSASS_COL, NASS1, 
      &                     NPARTSCB_COL,
-     &                     NCOL1-NASS1, KEEP(488), .FALSE., KEEP(472))
+     &                     NCOL1-NASS1, KEEP(488), .FALSE., KEEP(472),
+     &                     NCOL1, KEEP(1))
           NB_BLR_COL = NPARTSCB_COL + NPARTSASS_COL
           IF (NPARTSASS_MASTER.NE.NPARTSASS_COL) THEN
              ALLOCATE(BEGS_BLR_COL_TMP(
diff -pruN 5.6.2-2.1/src/cfac_process_contrib_type1.F 5.7.1-1/src/cfac_process_contrib_type1.F
--- 5.6.2-2.1/src/cfac_process_contrib_type1.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_process_contrib_type1.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -42,7 +42,7 @@ C
       INTEGER COMP, FPERE
       LOGICAL FLAG
       INTEGER NSTK_S( KEEP(28) ), ITLOC( N + KEEP(253) )
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INTEGER IFLAG, IERROR, COMM
       INTEGER POSITION, FINODE, FLCONT, LREQ
       INTEGER(8) :: LREQCB
diff -pruN 5.6.2-2.1/src/cfac_process_contrib_type2.F 5.7.1-1/src/cfac_process_contrib_type2.F
--- 5.6.2-2.1/src/cfac_process_contrib_type2.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_process_contrib_type2.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -58,7 +58,7 @@ C
       INTEGER, intent(in) :: LRGROUPS(KEEP(280))
       INTEGER ITLOC( N + KEEP(253)), NSTK_S( KEEP(28) )
       INTEGER :: FILS( N ), DAD(KEEP(28))
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INTEGER ND(KEEP(28)), FRERE_STEPS( KEEP(28) )
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
@@ -449,7 +449,7 @@ C
              NSLAVES= IW(IOLDPS+5+KEEP(IXSZ))
              IF (NSLAVES.EQ.0) THEN 
                NFRONT = IW(IOLDPS+KEEP(IXSZ))
-               NASS1  = iabs(IW(IOLDPS + 2+KEEP(IXSZ)))
+               NASS1  = abs(IW(IOLDPS + 2+KEEP(IXSZ)))
                POSELT = PTRAST(STEP(INODE))
                PARPIV_T1 = -999 
                LR_ACTIVATED = (IW(IOLDPS+XXLR).GT.0)
diff -pruN 5.6.2-2.1/src/cfac_process_contrib_type3.F 5.7.1-1/src/cfac_process_contrib_type3.F
--- 5.6.2-2.1/src/cfac_process_contrib_type3.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_process_contrib_type3.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -45,7 +45,7 @@ C
       INTEGER PTRIST(KEEP(28))
       INTEGER PTLUST(KEEP(28))
       INTEGER STEP(N), PIMASTER(KEEP(28)), ITLOC( N+KEEP(253) )
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INTEGER BUFR( LBUFR_BYTES )
       INTEGER IW( LIW )
       INTEGER ND(KEEP(28)), PROCNODE_STEPS(KEEP(28))
@@ -65,8 +65,6 @@ C
       DOUBLE PRECISION OPASSW
         INCLUDE 'mpif.h'
         INTEGER IERR
-        EXTERNAL MUMPS_PROCNODE
-        INTEGER MUMPS_PROCNODE
         INTEGER POSITION, LOCAL_M, LOCAL_N, LREQI
         INTEGER(8) :: LREQA, POS_ROOT
         INTEGER NSUBSET_ROW, NSUBSET_COL, IROOT, ISON, NSUBSET_COL_EFF
diff -pruN 5.6.2-2.1/src/cfac_process_end_facto_slave.F 5.7.1-1/src/cfac_process_end_facto_slave.F
--- 5.6.2-2.1/src/cfac_process_end_facto_slave.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_process_end_facto_slave.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -71,7 +71,7 @@ C
       INTEGER NBFIN, SLAVEF
       DOUBLE PRECISION OPASSW, OPELIW
       INTEGER ITLOC( N + KEEP(253) ), FILS( N ), DAD( KEEP(28) )
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INTEGER ND( KEEP(28) )
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
diff -pruN 5.6.2-2.1/src/cfac_process_maprow.F 5.7.1-1/src/cfac_process_maprow.F
--- 5.6.2-2.1/src/cfac_process_maprow.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_process_maprow.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -84,7 +84,7 @@ C
       INTEGER LPTRAR, NELT
       INTEGER FRTPTR( N+1 ), FRTELT( NELT )
       INTEGER ITLOC( N+KEEP(253) ), FILS( N ), DAD( KEEP(28) )
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) ::  PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
@@ -573,6 +573,9 @@ C
                    IS_ERROR_BROADCASTED=.TRUE.
                    GOTO 600
                  ENDIF
+                 IF (.NOT. MESSAGE_RECEIVED) THEN
+                   CALL MUMPS_USLEEP(1000)
+                 ENDIF
                END IF
              END IF 
            ENDDO
@@ -708,7 +711,7 @@ C
       INTEGER PROCNODE_STEPS( KEEP(28) )
       INTEGER FRTPTR( N+1 ), FRTELT( NELT )
       INTEGER ITLOC( N+KEEP(253) ), FILS( N ), DAD( KEEP(28) )
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
@@ -1350,7 +1353,7 @@ C
       INTEGER, intent(inout) :: ITLOC(N)
       INTEGER, intent(in) :: FRTPTR( N+1 ), FRTELT( NELT )
       DOUBLE PRECISION, intent(inout) :: OPASSW, OPELIW
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INTEGER, intent(in) :: KEEP253_LOC, NVSCHUR
       INTEGER, intent(in) :: FILS(N), DAD( KEEP(28) )
       INTEGER(8), intent(in) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
diff -pruN 5.6.2-2.1/src/cfac_process_master2.F 5.7.1-1/src/cfac_process_master2.F
--- 5.6.2-2.1/src/cfac_process_master2.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_process_master2.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -43,7 +43,7 @@ C
       INTEGER(8) :: PAMASTER(KEEP(28))
       INTEGER PTRIST(KEEP(28)), STEP(N), PIMASTER(KEEP(28))
       INTEGER PROCNODE_STEPS( KEEP(28) ), ITLOC( N +KEEP(253) )
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INTEGER COMP
       INTEGER NSTK_S( KEEP(28) )
       INTEGER IFLAG, IERROR, COMM, COMM_LOAD
diff -pruN 5.6.2-2.1/src/cfac_process_message.F 5.7.1-1/src/cfac_process_message.F
--- 5.6.2-2.1/src/cfac_process_message.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_process_message.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -65,7 +65,7 @@ C
       INTEGER NELT, LPTRAR
       INTEGER FRTPTR( N+1), FRTELT( NELT )
       INTEGER ITLOC( N+KEEP(253) ), FILS( N ), DAD(KEEP(28))
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
@@ -515,7 +515,7 @@ C
       INTEGER NELT, LPTRAR
       INTEGER FRTPTR( N+1 ), FRTELT( NELT )
       INTEGER ITLOC( N+KEEP(253) ), FILS( N ), DAD( KEEP(28) )
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
@@ -623,7 +623,7 @@ C
       INTEGER NELT, LPTRAR
       INTEGER FRTPTR( N+1 ), FRTELT( NELT )
       INTEGER ITLOC( N + KEEP(253) ), FILS( N ), DAD( KEEP(28) )
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
@@ -749,7 +749,7 @@ C
                   IF ( IFLAG .LT. 0 ) RETURN
             ENDIF
           ENDIF
-       ENDIF
+       ENDIF 
       ELSE
         IF (BLOCKING) THEN
            CALL MPI_PROBE(MSGSOU,MSGTAG,
diff -pruN 5.6.2-2.1/src/cfac_process_root2slave.F 5.7.1-1/src/cfac_process_root2slave.F
--- 5.6.2-2.1/src/cfac_process_root2slave.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_process_root2slave.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -65,7 +65,7 @@ C
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
       INTEGER, INTENT(IN) :: NINROWARR(KEEP(195))
       INTEGER, INTENT(IN) :: PTRDEBARR(KEEP(196))
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INTEGER INTARR(KEEP8(27))
       COMPLEX DBLARR(KEEP8(26))
       INTEGER ::  allocok
@@ -80,17 +80,17 @@ C
       COMPLEX ZERO
       PARAMETER( ZERO = (0.0E0,0.0E0) )
       INCLUDE 'mumps_headers.h'
-      INTEGER numroc, MUMPS_PROCNODE
-      EXTERNAL numroc, MUMPS_PROCNODE
+      INTEGER MUMPS_NUMROC, MUMPS_PROCNODE
+      EXTERNAL MUMPS_NUMROC, MUMPS_PROCNODE
       IROOT = KEEP( 38 )
       root%TOT_ROOT_SIZE = TOT_ROOT_SIZE
       MASTER_OF_ROOT = ( MYID .EQ. 
      &                   MUMPS_PROCNODE( PROCNODE_STEPS(STEP(IROOT)),
      &                   KEEP(199) ) )
-      NEW_LOCAL_M  = numroc( TOT_ROOT_SIZE, root%MBLOCK,
+      NEW_LOCAL_M  = MUMPS_NUMROC( TOT_ROOT_SIZE, root%MBLOCK,
      &               root%MYROW, 0, root%NPROW )
       NEW_LOCAL_M  = max( 1, NEW_LOCAL_M )
-      NEW_LOCAL_N  = numroc( TOT_ROOT_SIZE, root%NBLOCK,
+      NEW_LOCAL_N  = MUMPS_NUMROC( TOT_ROOT_SIZE, root%NBLOCK,
      &               root%MYCOL, 0, root%NPCOL )
       IF ( PTRIST(STEP( IROOT )).GT.0) THEN
         OLD_LOCAL_N = -IW( PTRIST(STEP( IROOT )) + KEEP(IXSZ) )
@@ -275,7 +275,7 @@ C
       ENDIF 
       IF ( NO_OLD_ROOT ) THEN
           IF (KEEP(253) .GT.0) THEN
-            root%RHS_NLOC = numroc( KEEP(253), root%NBLOCK,
+            root%RHS_NLOC = MUMPS_NUMROC( KEEP(253), root%NBLOCK,
      &                      root%MYCOL, 0, root%NPCOL )
             root%RHS_NLOC = max( root%RHS_NLOC, 1 )
           ELSE
@@ -291,8 +291,8 @@ C
           ENDIF
           IF (KEEP(253) .NE. 0) THEN
             root%RHS_ROOT=ZERO
-            CALL CMUMPS_ASM_RHS_ROOT( N, FILS, root, KEEP, RHS_MUMPS,
-     &      IFLAG, IERROR )
+            CALL CMUMPS_ASM_RHS_ROOT( N, FILS, root, KEEP, KEEP8,
+     &      RHS_MUMPS, IFLAG, IERROR )
           ENDIF
       ELSE IF (NEW_LOCAL_M.GT.OLD_LOCAL_M .AND. KEEP(253) .GT.0) THEN
           TMP => root%RHS_ROOT
diff -pruN 5.6.2-2.1/src/cfac_process_root2son.F 5.7.1-1/src/cfac_process_root2son.F
--- 5.6.2-2.1/src/cfac_process_root2son.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_process_root2son.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -64,7 +64,7 @@ C
       INTEGER MYID, SLAVEF, NBFIN
       DOUBLE PRECISION OPASSW, OPELIW
       INTEGER ITLOC( N + KEEP(253) ), FILS( N ), DAD(KEEP(28))
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
@@ -97,7 +97,7 @@ C
        IOLDPS   = PTLUST_S(STEP(INODE))
        NFRONT   = IW(IOLDPS+KEEP(IXSZ))
        NPIV     = IW(IOLDPS+1+KEEP(IXSZ))
-       NASS     = iabs(IW(IOLDPS + 2+KEEP(IXSZ)))
+       NASS     = abs(IW(IOLDPS + 2+KEEP(IXSZ)))
        NSLAVES  =  IW(IOLDPS+5+KEEP(IXSZ))
        H_INODE  = 6 + NSLAVES + KEEP(IXSZ)
        NELIM    = NASS - NPIV
diff -pruN 5.6.2-2.1/src/cfac_process_rtnelind.F 5.7.1-1/src/cfac_process_rtnelind.F
--- 5.6.2-2.1/src/cfac_process_rtnelind.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_process_rtnelind.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -46,7 +46,7 @@ C
       INTEGER STEP(N), PIMASTER(KEEP(28))
       INTEGER COMP
       INTEGER NSTK_S(KEEP(28)), ITLOC( N + KEEP(253) )
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INTEGER PROCNODE_STEPS( KEEP(28) )
       INTEGER IFLAG, IERROR
       INTEGER LPOOL, LEAF
diff -pruN 5.6.2-2.1/src/cfac_root_parallel.F 5.7.1-1/src/cfac_root_parallel.F
--- 5.6.2-2.1/src/cfac_root_parallel.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_root_parallel.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -51,8 +51,7 @@ C
       INTEGER FWD_LOCAL_N_RHS, FWD_MTYPE 
 #endif
       INCLUDE 'mumps_headers.h'
-      EXTERNAL numroc
-      INTEGER numroc
+      INTEGER, EXTERNAL :: MUMPS_NUMROC
         IF ( .NOT. root%yes ) RETURN
         IF ( KEEP(60) .NE. 0 ) THEN
           IF ((LDLT == 1 .OR. LDLT == 2) .AND. KEEP(60) == 3 ) THEN
@@ -181,7 +180,7 @@ C
      &         LDLT)
         ENDIF
         IF (KEEP(252) .NE. 0) THEN
-          FWD_LOCAL_N_RHS = numroc(KEEP(253), root%NBLOCK,
+          FWD_LOCAL_N_RHS = MUMPS_NUMROC(KEEP(253), root%NBLOCK,
      &                      root%MYCOL, 0, root%NPCOL)
           FWD_LOCAL_N_RHS = max(1,FWD_LOCAL_N_RHS)
           FWD_MTYPE       = 1 
diff -pruN 5.6.2-2.1/src/cfac_scalings.F 5.7.1-1/src/cfac_scalings.F
--- 5.6.2-2.1/src/cfac_scalings.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_scalings.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -22,54 +22,61 @@ C
       COMPLEX, INTENT(IN) :: ASPK(NZ8)
       REAL COLSCA(*), ROWSCA(*)
       INTEGER(8), INTENT(IN) :: LWK8
-      INTEGER LWK_REAL
+      INTEGER(8), INTENT(IN) :: LWK_REAL
       COMPLEX    WK(LWK8)
       REAL WK_REAL(LWK_REAL)
       INTEGER MPG,LP
-      INTEGER IWNOR
       INTEGER I
-      LOGICAL PROK
+      LOGICAL PROKG
       REAL ONE
       PARAMETER( ONE = 1.0E0 )
       LP      = ICNTL(1)
       MPG     = ICNTL(2)
       MPG    = ICNTL(3)
-      PROK   = ((MPG.GT.0).AND.(ICNTL(4).GE.2))
-      IF (PROK) THEN
+      PROKG  = ((MPG.GT.0).AND.(ICNTL(4).GE.2))
+      IF (PROKG) THEN
         WRITE(MPG,101)
       ELSE
         MPG = 0
       ENDIF
- 101    FORMAT(/' ****** SCALING OF ORIGINAL MATRIX '/)
-        IF (NSCA.EQ.1) THEN
-         IF (PROK)
-     &    WRITE (MPG,*) ' DIAGONAL SCALING '
-        ELSEIF (NSCA.EQ.3) THEN
-         IF (PROK)
+ 101  FORMAT(/' ****** SCALING OF ORIGINAL MATRIX '/)
+      IF (NSCA.EQ.1) THEN
+        IF (PROKG) WRITE (MPG,*) ' DIAGONAL SCALING '
+      ELSEIF (NSCA.EQ.3) THEN
+         IF (PROKG)
      &   WRITE (MPG,*) ' COLUMN SCALING'
-        ELSEIF (NSCA.EQ.4) THEN
-         IF (PROK)
+      ELSEIF (NSCA.EQ.4) THEN
+         IF (PROKG)
      &   WRITE (MPG,*) ' ROW AND COLUMN SCALING (1 Pass)'
-       ENDIF
-        DO 10 I=1,N
-            COLSCA(I) = ONE
-            ROWSCA(I) = ONE
- 10     CONTINUE
-        IF (5*N.GT.LWK_REAL) GOTO 410
-        IWNOR = 1
-          IF (NSCA.EQ.1) THEN
+      ENDIF
+      DO 10 I=1,N
+        COLSCA(I) = ONE
+        ROWSCA(I) = ONE
+ 10   CONTINUE
+      IF (NSCA.EQ.1) THEN
             CALL CMUMPS_FAC_V(N,NZ8,ASPK,IRN,ICN,
-     &        COLSCA,ROWSCA,MPG)
-          ELSEIF (NSCA.EQ.3) THEN
-            CALL CMUMPS_FAC_Y(N,NZ8,ASPK,IRN,ICN,WK_REAL(IWNOR),
+     &      COLSCA,ROWSCA,MPG)
+      ELSEIF (NSCA.EQ.3) THEN
+            IF ( LWK_REAL .LT. int(N,8) ) THEN
+              GOTO 420
+            ENDIF
+            CALL CMUMPS_FAC_Y(N,NZ8,ASPK,IRN,ICN,WK_REAL(1),
      &      COLSCA, MPG)
-          ELSEIF (NSCA.EQ.4) THEN
+      ELSEIF (NSCA.EQ.4) THEN
+            IF ( LWK_REAL .LT. 2_8*int(N,8) ) THEN
+              GOTO 430
+            ENDIF
             CALL CMUMPS_ROWCOL(N,NZ8,IRN,ICN,ASPK,
-     &      WK_REAL(IWNOR),WK_REAL(IWNOR+N),COLSCA,ROWSCA,MPG)
-          ENDIF
+     &      WK_REAL(1),WK_REAL(1+N),COLSCA,ROWSCA,MPG)
+      ENDIF
+      GOTO 500
+ 420  INFO(1) = -5
+      CALL MUMPS_SET_IERROR(int(N,8)-LWK_REAL, INFO(2))
+      IF ((LP.GT.0).AND.(ICNTL(4).GE.1))
+     & WRITE(LP,*) '*** ERROR: Not enough space to scale matrix'
       GOTO 500
- 410  INFO(1) = -5
-      INFO(2) = 5*N-LWK_REAL
+ 430  INFO(1) = -5
+      CALL MUMPS_SET_IERROR(2_8*int(N,8)-LWK_REAL, INFO(2))
       IF ((LP.GT.0).AND.(ICNTL(4).GE.1))
      & WRITE(LP,*) '*** ERROR: Not enough space to scale matrix'
       GOTO 500
diff -pruN 5.6.2-2.1/src/cfac_scalings_simScaleAbs.F 5.7.1-1/src/cfac_scalings_simScaleAbs.F
--- 5.6.2-2.1/src/cfac_scalings_simScaleAbs.F	2023-10-11 09:37:10.000000000 +0000
+++ 5.7.1-1/src/cfac_scalings_simScaleAbs.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -18,7 +18,9 @@ C
      &     IWRK, IWRKSZ,
      &     INTSZ, RESZ, OP,
      &     ROWSCA, COLSCA, WRKRC, ISZWRKRC,
-     &     SYM, NB1, NB2, NB3, EPS,
+     &     WRKR_TH, LWRKR_TH,
+     &     WRKC_TH, LWRKC_TH,
+     &     NOMP_MAX, SYM, NB1, NB2, NB3, EPS,
      &     ONENORMERR,INFNORMERR)
 C----------------------------------------------------------------------
 C    IF SYM=0 CALLs unsymmetric variant CMUMPS_SIMSCALEABSUNS.
@@ -29,13 +31,16 @@ C    For details, see the two subroutine
 C         CMUMPS_SIMSCALEABSUNS and CMUMPS_SIMSCALEABSSYM
 C ---------------------------------------------------------------------
 C
+!$    USE OMP_LIB
       IMPLICIT NONE
       INCLUDE 'mpif.h'
       INTEGER(8) NZ_loc
-      INTEGER IWRKSZ, ISZWRKRC
+      INTEGER(8) :: IWRKSZ
+      INTEGER(8) :: ISZWRKRC, LWRKR_TH, LWRKC_TH
+      INTEGER    :: NOMP_MAX
       INTEGER M, N, OP
       INTEGER NUMPROCS, MYID, COMM
-      INTEGER INTSZ, RESZ
+      INTEGER(8) :: INTSZ, RESZ
       INTEGER IRN_loc(NZ_loc)
       INTEGER JCN_loc(NZ_loc)
       COMPLEX A_loc(NZ_loc)
@@ -44,21 +49,29 @@ C
       INTEGER CPARTVEC(N) 
       INTEGER CSNDRCVSZ(2*NUMPROCS)
       INTEGER IWRK(IWRKSZ)
-      INTEGER REGISTRE(12)
+      INTEGER(8) :: REGISTRE(12)
       REAL ROWSCA(M)
       REAL COLSCA(N)
       REAL WRKRC(ISZWRKRC)
+      REAL WRKR_TH(LWRKR_TH,max(NOMP_MAX,1))
+      REAL WRKC_TH(LWRKC_TH,max(NOMP_MAX,1))
       REAL ONENORMERR,INFNORMERR
 C     LOCALS
-C IMPORTANT POINTERS
 C     FOR the scaling phase
       INTEGER SYM, NB1, NB2, NB3
       REAL EPS
 C     EXTERNALS
       EXTERNAL CMUMPS_SIMSCALEABSUNS,CMUMPS_SIMSCALEABSSYM, 
-     &     CMUMPS_INITREAL
+     &         CMUMPS_INITREAL
 C     MUST HAVE IT
       INTEGER I
+      INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER    :: NOMP 
+!$    INTEGER    :: CHUNK
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP  = omp_get_max_threads()
+!$     CHUNK= max(K361/2, (N+NOMP-1) / NOMP )
+!$    ENDIF
       IF(SYM.EQ.0) THEN
          CALL CMUMPS_SIMSCALEABSUNS(IRN_loc, JCN_loc, A_loc, 
      &        NZ_loc,
@@ -67,7 +80,9 @@ C     MUST HAVE IT
      &        RSNDRCVSZ, CSNDRCVSZ, REGISTRE,
      &        IWRK, IWRKSZ,
      &        INTSZ, RESZ, OP,
-     &        ROWSCA, COLSCA, WRKRC, ISZWRKRC,
+     &        ROWSCA, COLSCA, WRKRC, ISZWRKRC, 
+     &        WRKR_TH, LWRKR_TH,
+     &        WRKC_TH, LWRKC_TH, NOMP_MAX,
      &        NB1, NB2, NB3, EPS,
      &        ONENORMERR, INFNORMERR)  
       ELSE
@@ -78,12 +93,24 @@ C     MUST HAVE IT
      &        RSNDRCVSZ, REGISTRE,
      &        IWRK, IWRKSZ,
      &        INTSZ, RESZ, OP,
-     &        ROWSCA, WRKRC, ISZWRKRC,
+     &        ROWSCA, WRKRC, ISZWRKRC,  
+     &        WRKR_TH, LWRKR_TH, NOMP_MAX,
      &        NB1, NB2, NB3, EPS,
      &        ONENORMERR, INFNORMERR)  
-         DO I=1,N
-            COLSCA(I) = ROWSCA(I)
-         ENDDO
+         IF (OP.EQ.2) THEN
+          IF (NOMP_MAX.LE.0) THEN
+            DO I=1,N
+             COLSCA(I) = ROWSCA(I)
+            ENDDO
+          ELSE 
+!$OMP      PARALLEL DO PRIVATE(I)
+!$OMP&     SCHEDULE(STATIC,CHUNK)
+!$OMP&     IF ( N > K361 .AND. NOMP .GT. 1)
+            DO I=1,N
+             COLSCA(I) = ROWSCA(I)
+            ENDDO
+          ENDIF
+         ENDIF
       ENDIF
       RETURN
       END SUBROUTINE CMUMPS_SIMSCALEABS
@@ -93,7 +120,9 @@ C     MUST HAVE IT
      &     RSNDRCVSZ, CSNDRCVSZ, REGISTRE,
      &     IWRK, IWRKSZ,
      &     INTSZ, RESZ, OP,
-     &     ROWSCA, COLSCA, WRKRC, ISZWRKRC,
+     &     ROWSCA, COLSCA, WRKRC, ISZWRKRC, 
+     &     WRKR_TH, LWRKR_TH,
+     &     WRKC_TH, LWRKC_TH, NOMP_MAX,
      &     NB1, NB2, NB3, EPS,
      &     ONENORMERR, INFNORMERR)    
 C----------------------------------------------------------------------
@@ -191,13 +220,15 @@ C         In proceedings of VECPAR'08-In
 C         Performance Computing for Computational Science, Jan'08.
 C     and was supported by ANR-SOLSTICE project (ANR-06-CIS6-010)
 C ---------------------------------------------------------------------
+!$    USE OMP_LIB
       IMPLICIT NONE
       INCLUDE 'mpif.h'
-      INTEGER(8) NZ_loc
-      INTEGER IWRKSZ, INTSZ, ISZWRKRC
-      INTEGER M, N, OP
-      INTEGER NUMPROCS, MYID, COMM
-      INTEGER RESZ
+      INTEGER(8) :: NZ_loc
+      INTEGER(8) :: IWRKSZ, INTSZ
+      INTEGER(8) :: ISZWRKRC, LWRKR_TH, LWRKC_TH
+      INTEGER    :: M, N, OP
+      INTEGER    :: NUMPROCS, MYID, COMM, NOMP_MAX
+      INTEGER(8) :: RESZ
       INTEGER IRN_loc(NZ_loc)
       INTEGER JCN_loc(NZ_loc)
       COMPLEX A_loc(NZ_loc)
@@ -205,11 +236,13 @@ C --------------------------------------
       INTEGER CPARTVEC(N) 
       INTEGER RSNDRCVSZ(2*NUMPROCS)
       INTEGER CSNDRCVSZ(2*NUMPROCS)
-      INTEGER REGISTRE(12)
+      INTEGER(8) :: REGISTRE(12)
       INTEGER IWRK(IWRKSZ)
       REAL ROWSCA(M)
       REAL COLSCA(N)
-      REAL WRKRC(ISZWRKRC)  
+      REAL WRKRC(ISZWRKRC)
+      REAL WRKR_TH(LWRKR_TH,max(NOMP_MAX,1))
+      REAL WRKC_TH(LWRKC_TH,max(NOMP_MAX,1))
       REAL ONENORMERR,INFNORMERR
 C     LOCALS
       INTEGER IRSNDRCVNUM, ORSNDRCVNUM
@@ -218,14 +251,14 @@ C     LOCALS
       INTEGER ICSNDRCVVOL, OCSNDRCVVOL
       INTEGER  INUMMYR, INUMMYC
 C IMPORTANT POINTERS
-      INTEGER IMYRPTR,IMYCPTR 
-      INTEGER IRNGHBPRCS, IRSNDRCVIA,IRSNDRCVJA
-      INTEGER ORNGHBPRCS, ORSNDRCVIA,ORSNDRCVJA
-      INTEGER ICNGHBPRCS, ICSNDRCVIA,ICSNDRCVJA
-      INTEGER OCNGHBPRCS, OCSNDRCVIA,OCSNDRCVJA
-      INTEGER ISTATUS, REQUESTS, TMPWORK
-      INTEGER ITDRPTR, ITDCPTR, ISRRPTR
-      INTEGER OSRRPTR, ISRCPTR, OSRCPTR
+      INTEGER(8) :: IMYRPTR,IMYCPTR 
+      INTEGER(8) :: IRNGHBPRCS, IRSNDRCVIA,IRSNDRCVJA
+      INTEGER(8) :: ORNGHBPRCS, ORSNDRCVIA,ORSNDRCVJA
+      INTEGER(8) :: ICNGHBPRCS, ICSNDRCVIA,ICSNDRCVJA
+      INTEGER(8) :: OCNGHBPRCS, OCSNDRCVIA,OCSNDRCVJA
+      INTEGER(8) :: ISTATUS, REQUESTS, TMPWORK
+      INTEGER(8) :: ITDRPTR, ITDCPTR, ISRRPTR
+      INTEGER(8) :: OSRRPTR, ISRCPTR, OSRCPTR
 C     FOR the scaling phase
       INTEGER NB1, NB2, NB3
       REAL EPS
@@ -244,32 +277,39 @@ C     FUNCTIONS
       EXTERNAL CMUMPS_CREATEPARTVEC,
      &     CMUMPS_NUMVOLSNDRCV, 
      &     CMUMPS_SETUPCOMMS,
-     &     CMUMPS_FINDNUMMYROWCOL, 
-     &     CMUMPS_CHKCONVGLO,
-     &     CMUMPS_CHK1CONV,
      &     CMUMPS_FILLMYROWCOLINDICES,
      &     CMUMPS_INITREAL,
      &     CMUMPS_INITREALLST,
      &     CMUMPS_DOCOMMINF,
      &     CMUMPS_DOCOMM1N
-      INTEGER CMUMPS_CHKCONVGLO 
-      INTEGER CMUMPS_CHK1CONV
       REAL CMUMPS_ERRSCALOC
       REAL CMUMPS_ERRSCA1
       INTRINSIC abs
       REAL RONE, RZERO
       PARAMETER(RONE=1.0E0,RZERO=0.0E0)
 C     TMP VARS
-      INTEGER RESZR, RESZC
-      INTEGER INTSZR, INTSZC
+      INTEGER(8) :: RESZR, RESZC
+      INTEGER(8) :: INTSZR, INTSZC
       INTEGER MAXMN
-      INTEGER I, IERROR
+      INTEGER I, IERROR, IOMP
       REAL ONEERRROW, ONEERRCOL, ONEERRL, ONEERRG
       REAL INFERRROW, INFERRCOL, INFERRL, INFERRG
-      INTEGER OORANGEIND
+      LOGICAL OORANGEIND
+      INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER    :: NOMP
+!$    INTEGER    :: CHUNK, CHUNK_NZ
+!$    ! Too large => pb with cache L3 ?
+!$    ! INTEGER(8) :: CHUNK8 
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP     = omp_get_max_threads()
+!$     CHUNK    = max(K361/2, (N+NOMP-1) / NOMP )
+!$    ! CHUNK8= (NZ_loc+int(NOMP-1,8) / int(NOMP,8) ) )
+!$     CHUNK_NZ = max(K361/2, (N+NOMP_MAX-1) / NOMP_MAX )
+!$    ENDIF
+C
+      OORANGEIND = .FALSE.
       INFERRG = -RONE
       ONEERRG = -RONE
-      OORANGEIND = 0
       MAXMN = M
       IF(MAXMN < N) MAXMN = N
 C     Create row partvec and col partvec
@@ -280,11 +320,11 @@ C     IF(IWRKSZ.LT.4*MAXMN) THEN   ERROR
             CALL CMUMPS_CREATEPARTVEC(MYID, NUMPROCS, COMM,
      &           IRN_loc, JCN_loc, NZ_loc,
      &           RPARTVEC, M, N,
-     &           IWRK, IWRKSZ)
+     &           IWRK, IWRKSZ, INUMMYR, NOMP_MAX)
             CALL CMUMPS_CREATEPARTVEC(MYID, NUMPROCS, COMM,
      &           JCN_loc, IRN_loc,  NZ_loc,
      &           CPARTVEC, N, M,
-     &           IWRK, IWRKSZ)         
+     &           IWRK, IWRKSZ, INUMMYC, NOMP_MAX)
 C     Compute sndrcv sizes, store them for later use           
             CALL CMUMPS_NUMVOLSNDRCV(MYID, NUMPROCS, M, RPARTVEC,
      &           NZ_loc, IRN_loc, N, JCN_loc,
@@ -298,20 +338,14 @@ C     Compute sndrcv sizes, store them f
      &           OCSNDRCVNUM,OCSNDRCVVOL,
      &           IWRK,IWRKSZ, 
      &           CSNDRCVSZ(1), CSNDRCVSZ(1+NUMPROCS), COMM)         
-            CALL CMUMPS_FINDNUMMYROWCOL(MYID, NUMPROCS, COMM,
-     &           IRN_loc, JCN_loc, NZ_loc,
-     &           RPARTVEC, CPARTVEC, M, N,
-     &           INUMMYR,
-     &           INUMMYC,     
-     &           IWRK, IWRKSZ)
-            INTSZR =  IRSNDRCVNUM + ORSNDRCVNUM + 
-     &           IRSNDRCVVOL + ORSNDRCVVOL +
-     &           2*(NUMPROCS+1) + INUMMYR
-            INTSZC = ICSNDRCVNUM + OCSNDRCVNUM + 
-     &           ICSNDRCVVOL + OCSNDRCVVOL +
-     &           2*(NUMPROCS+1) + INUMMYC
-            INTSZ = INTSZR + INTSZC + MAXMN + 
-     &           (MPI_STATUS_SIZE +1) *  NUMPROCS
+            INTSZR =  int(IRSNDRCVNUM,8) + int(ORSNDRCVNUM,8) + 
+     &           int(IRSNDRCVVOL,8) + int(ORSNDRCVVOL,8) +
+     &           2_8*int(NUMPROCS+1,8) + int(INUMMYR,8)
+            INTSZC = int(ICSNDRCVNUM,8) + int(OCSNDRCVNUM,8) + 
+     &           int(ICSNDRCVVOL,8) + int(OCSNDRCVVOL,8) +
+     &           2_8*int(NUMPROCS+1,8) + int(INUMMYC,8)
+            INTSZ = INTSZR + INTSZC + int(MAXMN,8) + 
+     &           int(MPI_STATUS_SIZE +1,8) * int(NUMPROCS,8)
          ELSE
 C     NUMPROCS IS 1
              IRSNDRCVNUM = 0
@@ -324,39 +358,39 @@ C     NUMPROCS IS 1
              ICSNDRCVVOL = 0
              OCSNDRCVVOL  = 0
              INUMMYC = 0
-             INTSZ = 0
+             INTSZ = 0_8
           ENDIF
 C     CALCULATE NECESSARY REAL SPACE
-          RESZR = M + IRSNDRCVVOL + ORSNDRCVVOL
-          RESZC = N + ICSNDRCVVOL + OCSNDRCVVOL
+          RESZR = int(M,8) + int(IRSNDRCVVOL,8) + int(ORSNDRCVVOL,8)
+          RESZC = int(N,8) + int(ICSNDRCVVOL,8) + int(OCSNDRCVVOL,8)
           RESZ = RESZR  + RESZC  
 C     CALCULATE NECESSARY INT SPACE
 C     The last maxmn is tmpwork for setup comm and fillmyrowcol
-          REGISTRE(1) = IRSNDRCVNUM 
-          REGISTRE(2) = ORSNDRCVNUM
-          REGISTRE(3) = IRSNDRCVVOL 
-          REGISTRE(4) = ORSNDRCVVOL
-          REGISTRE(5) = ICSNDRCVNUM 
-          REGISTRE(6) = OCSNDRCVNUM
-          REGISTRE(7) = ICSNDRCVVOL
-          REGISTRE(8) = OCSNDRCVVOL
-          REGISTRE(9) = INUMMYR
-          REGISTRE(10) = INUMMYC
+          REGISTRE(1)  = int(IRSNDRCVNUM,8)
+          REGISTRE(2)  = int(ORSNDRCVNUM,8)
+          REGISTRE(3)  = int(IRSNDRCVVOL,8)
+          REGISTRE(4)  = int(ORSNDRCVVOL,8)
+          REGISTRE(5)  = int(ICSNDRCVNUM,8)
+          REGISTRE(6)  = int(OCSNDRCVNUM,8)
+          REGISTRE(7)  = int(ICSNDRCVVOL,8)
+          REGISTRE(8)  = int(OCSNDRCVVOL,8)
+          REGISTRE(9)  = int(INUMMYR,8)
+          REGISTRE(10) = int(INUMMYC,8)
           REGISTRE(11) = INTSZ
           REGISTRE(12) = RESZ
        ELSE
 C     else of op=1. That is op=2 now.
 C     restore the numbers
-          IRSNDRCVNUM = REGISTRE(1) 
-          ORSNDRCVNUM = REGISTRE(2) 
-          IRSNDRCVVOL = REGISTRE(3)
-          ORSNDRCVVOL = REGISTRE(4) 
-          ICSNDRCVNUM = REGISTRE(5) 
-          OCSNDRCVNUM = REGISTRE(6) 
-          ICSNDRCVVOL = REGISTRE(7) 
-          OCSNDRCVVOL = REGISTRE(8) 
-          INUMMYR = REGISTRE(9) 
-          INUMMYC = REGISTRE(10)
+          IRSNDRCVNUM = int(REGISTRE(1))
+          ORSNDRCVNUM = int(REGISTRE(2))
+          IRSNDRCVVOL = int(REGISTRE(3))
+          ORSNDRCVVOL = int(REGISTRE(4))
+          ICSNDRCVNUM = int(REGISTRE(5))
+          OCSNDRCVNUM = int(REGISTRE(6))
+          ICSNDRCVVOL = int(REGISTRE(7))
+          OCSNDRCVVOL = int(REGISTRE(8))
+          INUMMYR     = int(REGISTRE(9))
+          INUMMYC     = int(REGISTRE(10))
           IF(NUMPROCS > 1) THEN
 C     Check done outsize
 C             IF(INTSZ < REGISTRE(11)) THEN ERROR
@@ -365,35 +399,36 @@ C     Fill up myrows and my colsX
              CALL CMUMPS_FILLMYROWCOLINDICES(MYID, NUMPROCS,COMM,    
      &            IRN_loc, JCN_loc, NZ_loc,
      &            RPARTVEC, CPARTVEC, M, N,
-     &            IWRK(1), INUMMYR,
-     &            IWRK(1+INUMMYR), INUMMYC,     
-     &            IWRK(1+INUMMYR+INUMMYC), IWRKSZ-INUMMYR-INUMMYC )
-             IMYRPTR = 1
-             IMYCPTR = IMYRPTR + INUMMYR
+     &            IWRK(1_8), INUMMYR,
+     &            IWRK(1_8+int(INUMMYR,8)), INUMMYC,     
+     &            IWRK(1_8+int(INUMMYR,8)+int(INUMMYC,8)),
+     &            IWRKSZ-int(INUMMYR,8)-int(INUMMYC,8), NOMP_MAX )
+             IMYRPTR = 1_8
+             IMYCPTR = IMYRPTR + int(INUMMYR,8)
 C     Set up comm and run.
 C     set pointers in iwrk (4 parts)
 C     
 C     ROWS    [---------------------------------------------]
-             IRNGHBPRCS = IMYCPTR+ INUMMYC
-             IRSNDRCVIA = IRNGHBPRCS+IRSNDRCVNUM
-             IRSNDRCVJA = IRSNDRCVIA + NUMPROCS+1
-             ORNGHBPRCS = IRSNDRCVJA + IRSNDRCVVOL
-             ORSNDRCVIA = ORNGHBPRCS + ORSNDRCVNUM
-             ORSNDRCVJA = ORSNDRCVIA + NUMPROCS + 1
+             IRNGHBPRCS = IMYCPTR    + int(INUMMYC    ,8)
+             IRSNDRCVIA = IRNGHBPRCS + int(IRSNDRCVNUM,8)
+             IRSNDRCVJA = IRSNDRCVIA + int(NUMPROCS+1 ,8)
+             ORNGHBPRCS = IRSNDRCVJA + int(IRSNDRCVVOL,8)
+             ORSNDRCVIA = ORNGHBPRCS + int(ORSNDRCVNUM,8)
+             ORSNDRCVJA = ORSNDRCVIA + int(NUMPROCS+1 ,8)
 C     COLS    [---------------------------------------------]
-             ICNGHBPRCS = ORSNDRCVJA + ORSNDRCVVOL
-             ICSNDRCVIA = ICNGHBPRCS + ICSNDRCVNUM
-             ICSNDRCVJA = ICSNDRCVIA + NUMPROCS+1
-             OCNGHBPRCS = ICSNDRCVJA + ICSNDRCVVOL
-             OCSNDRCVIA = OCNGHBPRCS + OCSNDRCVNUM
-             OCSNDRCVJA = OCSNDRCVIA +  NUMPROCS + 1
+             ICNGHBPRCS = ORSNDRCVJA + int(ORSNDRCVVOL,8)
+             ICSNDRCVIA = ICNGHBPRCS + int(ICSNDRCVNUM,8)
+             ICSNDRCVJA = ICSNDRCVIA + int(NUMPROCS+1 ,8)
+             OCNGHBPRCS = ICSNDRCVJA + int(ICSNDRCVVOL,8)
+             OCSNDRCVIA = OCNGHBPRCS + int(OCSNDRCVNUM,8)
+             OCSNDRCVJA = OCSNDRCVIA + int(NUMPROCS+1 ,8)
 C     
 C     MPI     [-----------------]
-             REQUESTS = OCSNDRCVJA + OCSNDRCVVOL
-             ISTATUS = REQUESTS + NUMPROCS
+             REQUESTS = OCSNDRCVJA + int(OCSNDRCVVOL,8)
+             ISTATUS = REQUESTS + int(NUMPROCS,8)
 C     
 C     TMPWRK  [-----------------]
-             TMPWORK = ISTATUS + MPI_STATUS_SIZE *  NUMPROCS
+             TMPWORK = ISTATUS + int(MPI_STATUS_SIZE,8)*int(NUMPROCS,8)
              CALL CMUMPS_SETUPCOMMS(MYID, NUMPROCS, M, RPARTVEC,
      &            NZ_loc, IRN_loc,N, JCN_loc,
      &            IRSNDRCVNUM, IRSNDRCVVOL, 
@@ -416,80 +451,165 @@ C     TMPWRK  [-----------------]
      &            IWRK(TMPWORK), 
      &            IWRK(ISTATUS),  IWRK(REQUESTS),
      &            TAG_COMM_COL, COMM)
-             CALL CMUMPS_INITREAL(ROWSCA, M, RZERO)
-             CALL CMUMPS_INITREAL(COLSCA, N, RZERO)
+             CALL CMUMPS_INITREAL(ROWSCA, M, RZERO, NOMP_MAX)
+             CALL CMUMPS_INITREAL(COLSCA, N, RZERO, NOMP_MAX)
              CALL CMUMPS_INITREALLST(ROWSCA, M, 
-     &            IWRK(IMYRPTR),INUMMYR, RONE)
+     &            IWRK(IMYRPTR),INUMMYR, RONE, NOMP_MAX)
              CALL CMUMPS_INITREALLST(COLSCA, N, 
-     &            IWRK(IMYCPTR),INUMMYC, RONE)   
+     &            IWRK(IMYCPTR),INUMMYC, RONE, NOMP_MAX)   
           ELSE
-             CALL CMUMPS_INITREAL(ROWSCA, M, RONE)
-             CALL CMUMPS_INITREAL(COLSCA, N, RONE)            
+             CALL CMUMPS_INITREAL(ROWSCA, M, RONE, NOMP_MAX)
+             CALL CMUMPS_INITREAL(COLSCA, N, RONE, NOMP_MAX)            
           ENDIF
-          ITDRPTR = 1
-          ITDCPTR = ITDRPTR + M
+          ITDRPTR = 1_8
+          ITDCPTR = ITDRPTR + int(M,8)
 C     
-          ISRRPTR = ITDCPTR + N
-          OSRRPTR = ISRRPTR + IRSNDRCVVOL
+          ISRRPTR = ITDCPTR + int(N,8)
+          OSRRPTR = ISRRPTR + int(IRSNDRCVVOL,8)
 C     
-          ISRCPTR = OSRRPTR + ORSNDRCVVOL
-          OSRCPTR = ISRCPTR + ICSNDRCVVOL
+          ISRCPTR = OSRRPTR + int(ORSNDRCVVOL,8)
+          OSRCPTR = ISRCPTR + int(ICSNDRCVVOL,8)
 C     To avoid bound check errors...
           IF(NUMPROCS == 1)THEN
-             OSRCPTR = OSRCPTR - 1
-             ISRCPTR = ISRCPTR - 1
-             OSRRPTR = OSRRPTR - 1
-             ISRRPTR = ISRRPTR - 1
+             OSRCPTR = OSRCPTR - 1_8
+             ISRCPTR = ISRCPTR - 1_8
+             OSRRPTR = OSRRPTR - 1_8
+             ISRRPTR = ISRRPTR - 1_8
           ELSE
-             IF(IRSNDRCVVOL == 0) ISRRPTR = ISRRPTR - 1
-             IF(ORSNDRCVVOL == 0) OSRRPTR = OSRRPTR - 1
-             IF(ICSNDRCVVOL == 0) ISRCPTR = ISRCPTR - 1
-             IF(OCSNDRCVVOL == 0) OSRCPTR = OSRCPTR - 1
+             IF(IRSNDRCVVOL == 0) ISRRPTR = ISRRPTR - 1_8
+             IF(ORSNDRCVVOL == 0) OSRRPTR = OSRRPTR - 1_8
+             IF(ICSNDRCVVOL == 0) ISRCPTR = ISRCPTR - 1_8
+             IF(OCSNDRCVVOL == 0) OSRCPTR = OSRCPTR - 1_8
           ENDIF
           ITER = 1
           DO WHILE (ITER.LE.NB1+NB2+NB3)
-C     CLEAR temporary Dr and Dc
-             IF(NUMPROCS > 1) THEN
-                CALL CMUMPS_ZEROOUT(WRKRC(ITDRPTR),M,
-     &               IWRK(IMYRPTR),INUMMYR)
-                CALL CMUMPS_ZEROOUT(WRKRC(ITDCPTR),N,
-     &               IWRK(IMYCPTR),INUMMYC)
-             ELSE
-                CALL CMUMPS_INITREAL(WRKRC(ITDRPTR),M, RZERO)
-                CALL CMUMPS_INITREAL(WRKRC(ITDCPTR),N, RZERO)
+C{
+C           -------------------------
+C           CLEAR temporary Dr and Dc
+C           -------------------------
+            IF (NOMP_MAX.GT.1 .AND. 
+     &        (ITER.GT.NB1 .AND.ITER.LE.NB1+NB2)
+     &      ) THEN
+C{
+!$OMP         PARALLEL
+!$OMP&         PRIVATE(IOMP)
+!$OMP&         NUM_THREADS(NOMP_MAX)
+               IOMP  = 1
+!$             IOMP = OMP_GET_THREAD_NUM() + 1
+               IF(NUMPROCS > 1) THEN
+                 CALL CMUMPS_ZEROOUT(WRKR_TH(1,IOMP),N,
+     &                 IWRK(IMYRPTR),INUMMYR, 0)
+                 CALL CMUMPS_ZEROOUT(WRKC_TH(1,IOMP),N,
+     &                 IWRK(IMYCPTR),INUMMYC, 0)
+               ELSE
+                 CALL CMUMPS_INITREAL(WRKR_TH(1,IOMP),N, RZERO, 
+     &                                0)
+                 CALL CMUMPS_INITREAL(WRKC_TH(1,IOMP),N, RZERO, 
+     &                                0)
+               ENDIF
+!$OMP         END PARALLEL
+C}
+            ELSE
+C{
+               IF(NUMPROCS > 1) THEN
+                  CALL CMUMPS_ZEROOUT(WRKRC(ITDRPTR),M,
+     &                 IWRK(IMYRPTR),INUMMYR, NOMP_MAX)
+                  CALL CMUMPS_ZEROOUT(WRKRC(ITDCPTR),N,
+     &                 IWRK(IMYCPTR),INUMMYC, NOMP_MAX)
+               ELSE
+                  CALL CMUMPS_INITREAL(WRKRC(ITDRPTR),M, RZERO, 
+     &                                NOMP_MAX)
+                  CALL CMUMPS_INITREAL(WRKRC(ITDCPTR),N, RZERO, 
+     &                                NOMP_MAX)
+               ENDIF
+C}
              ENDIF
              IF((ITER.LE.NB1).OR.(ITER > NB1+NB2)) THEN
+C     ------------------
 C     INF-NORM ITERATION
-                IF((ITER.EQ.1).OR.(OORANGEIND.EQ.1)) THEN
+C     ------------------
+               IF (NOMP_MAX.LE.0) THEN
+                IF((ITER.EQ.1).OR.(OORANGEIND)) THEN
                    DO NZIND=1_8,NZ_loc
                       IR = IRN_loc(NZIND)
                       IC = JCN_loc(NZIND)
                       IF((IR.GE.1).AND.(IR.LE.M).AND.
      &                     (IC.GE.1).AND.(IC.LE.N)) THEN
                          ELM = abs(A_loc(NZIND))*ROWSCA(IR)*COLSCA(IC)
-                         IF(WRKRC(ITDRPTR-1+IR)<ELM) THEN
-                            WRKRC(ITDRPTR-1+IR)= ELM
-                         ENDIF
-                         IF(WRKRC(ITDCPTR-1+IC)<ELM) THEN
-                            WRKRC(ITDCPTR-1+IC)= ELM
-                         ENDIF
+                         IF(WRKRC(IR)<ELM) WRKRC(IR)= ELM
+                         IF(WRKRC(ITDCPTR-1_8+int(IC,8))<ELM) 
+     &                      WRKRC(ITDCPTR-1_8+int(IC,8))= ELM
                       ELSE
-                         OORANGEIND = 1
+                         OORANGEIND = .TRUE.
                       ENDIF
                    ENDDO
-                ELSEIF(OORANGEIND.EQ.0) THEN
+                ELSEIF(.NOT.OORANGEIND) THEN
                    DO NZIND=1,NZ_loc
                       IR = IRN_loc(NZIND)
                       IC = JCN_loc(NZIND)
                       ELM = abs(A_loc(NZIND))*ROWSCA(IR)*COLSCA(IC)
-                      IF(WRKRC(ITDRPTR-1+IR)<ELM) THEN
-                         WRKRC(ITDRPTR-1+IR)= ELM
-                      ENDIF
-                      IF(WRKRC(ITDCPTR-1+IC)<ELM) THEN
-                         WRKRC(ITDCPTR-1+IC)= ELM
+                      IF(WRKRC(IR)<ELM) WRKRC(IR)= ELM
+                      IF(WRKRC(ITDCPTR-1_8+int(IC,8))<ELM) 
+     &                   WRKRC(ITDCPTR-1_8+int(IC,8))= ELM
+                   ENDDO
+                ENDIF
+               ELSE
+                IF((ITER.EQ.1).OR.(OORANGEIND)) THEN
+!$OMP   PARALLEL DO PRIVATE(NZIND,IR,IC,ELM) 
+!$OMP&  SCHEDULE(STATIC,CHUNK_NZ)
+!$OMP&  IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
+!$OMP&  REDUCTION(.OR.:OORANGEIND)
+                   DO NZIND=1_8,NZ_loc
+                      IR = IRN_loc(NZIND)
+                      IC = JCN_loc(NZIND)
+                      IF((IR.GE.1).AND.(IR.LE.M).AND.
+     &                     (IC.GE.1).AND.(IC.LE.N)) THEN
+                         ELM = abs(A_loc(NZIND))*ROWSCA(IR)*COLSCA(IC)
+!$OMP                    ATOMIC UPDATE
+                         WRKRC(IR)= max (ELM, WRKRC(IR))
+!$OMP                    END ATOMIC
+C                         IF(WRKRC(ITDRPTR-1_8+int(IR,8))<ELM) THEN
+C                            WRKRC(ITDRPTR-1_8+int(IR,8))= ELM
+C                         ENDIF
+C                        IF(WRKRC(ITDCPTR-1_8+int(IC,8))<ELM) THEN
+C                           WRKRC(ITDCPTR-1_8+int(IC,8))= ELM
+C                         ENDIF
+C                        ITDCPTR+IC might be > int4
+!$OMP                    ATOMIC UPDATE
+                         WRKRC(ITDCPTR-1_8+int(IC,8)) = 
+     &                   max (ELM,WRKRC(ITDCPTR-1_8+int(IC,8)))
+!$OMP                    END ATOMIC
+                      ELSE
+                         OORANGEIND = .TRUE.
                       ENDIF
                    ENDDO
+!$OMP   END PARALLEL DO
+                ELSEIF(.NOT.OORANGEIND) THEN
+!$OMP   PARALLEL DO PRIVATE(NZIND,IR,IC,ELM) 
+!$OMP&  SCHEDULE(STATIC,CHUNK_NZ)
+!$OMP&  IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
+                   DO NZIND=1,NZ_loc
+                      IR = IRN_loc(NZIND)
+                      IC = JCN_loc(NZIND)
+                      ELM = abs(A_loc(NZIND))*ROWSCA(IR)*COLSCA(IC)
+C                      IF(WRKRC(ITDRPTR-1_8+int(IR,8))<ELM) THEN
+C                         WRKRC(ITDRPTR-1_8+int(IR,8))= ELM
+C                      ENDIF
+!$OMP                 ATOMIC UPDATE
+                      WRKRC(IR)= max (ELM, WRKRC(IR))
+!$OMP                 END ATOMIC
+C                      IF(WRKRC(ITDCPTR-1_8+int(IC,8))<ELM) THEN
+C                         WRKRC(ITDCPTR-1_8+int(IC,8))= ELM
+C                      ENDIF
+!$OMP                 ATOMIC UPDATE
+                      WRKRC(ITDCPTR-1_8+int(IC,8)) = 
+     &                   max (ELM,WRKRC(ITDCPTR-1_8+int(IC,8)))
+!$OMP                 END ATOMIC
+                   ENDDO
+!$OMP   END PARALLEL DO
                 ENDIF
+C}
+               ENDIF
                 IF(NUMPROCS > 1) THEN
                    CALL CMUMPS_DOCOMMINF(MYID, NUMPROCS,
      &                  WRKRC(ITDCPTR), N, TAG_ITERS+ITER, 
@@ -518,11 +638,11 @@ C
      &                 (NB1+NB3.GT.0))) THEN
                      INFERRROW = CMUMPS_ERRSCALOC(ROWSCA, 
      &                    WRKRC(ITDRPTR), M,
-     &                    IWRK(IMYRPTR),INUMMYR)
+     &                    IWRK(IMYRPTR),INUMMYR, NOMP_MAX)
 C     find error for the cols
                      INFERRCOL = CMUMPS_ERRSCALOC(COLSCA,  
      &                    WRKRC(ITDCPTR), N,
-     &                    IWRK(IMYCPTR),INUMMYC)
+     &                    IWRK(IMYCPTR),INUMMYC, NOMP_MAX)
 C     get max of those two errors
                      INFERRL = INFERRCOL
                      IF(INFERRROW > INFERRL ) THEN
@@ -535,10 +655,10 @@ C
                      IF(INFERRG.LE.EPS) THEN
                         CALL CMUMPS_UPDATESCALE(COLSCA,  
      &                       WRKRC(ITDCPTR),N,
-     &                       IWRK(IMYCPTR),INUMMYC)
+     &                       IWRK(IMYCPTR),INUMMYC, NOMP_MAX)
                         CALL CMUMPS_UPDATESCALE(ROWSCA,  
      &                       WRKRC(ITDRPTR),M,
-     &                       IWRK(IMYRPTR),INUMMYR)         
+     &                       IWRK(IMYRPTR),INUMMYR, NOMP_MAX)         
                         IF(ITER .LE. NB1) THEN
                            ITER = NB1+1
                            CYCLE
@@ -554,10 +674,10 @@ C     SINGLE PROCESSOR CASE: INF-NORM ER
      &                 ((ITER.EQ.NB1+NB2+NB3).AND.
      &                 (NB1+NB3.GT.0))) THEN
                      INFERRROW = CMUMPS_ERRSCA1(ROWSCA, 
-     &                    WRKRC(ITDRPTR), M)
+     &                    WRKRC(ITDRPTR), M, NOMP_MAX)
 C     find error for the cols
                      INFERRCOL = CMUMPS_ERRSCA1(COLSCA,  
-     &                    WRKRC(ITDCPTR), N)
+     &                    WRKRC(ITDCPTR), N, NOMP_MAX)
 C     get max of those two errors
                      INFERRL = INFERRCOL
                      IF(INFERRROW > INFERRL) THEN
@@ -565,8 +685,10 @@ C     get max of those two errors
                      ENDIF                     
                      INFERRG = INFERRL
                      IF(INFERRG.LE.EPS) THEN
-                        CALL CMUMPS_UPSCALE1(COLSCA,  WRKRC(ITDCPTR), N)
-                        CALL CMUMPS_UPSCALE1(ROWSCA,  WRKRC(ITDRPTR), M)
+                        CALL CMUMPS_UPSCALE1(COLSCA, WRKRC(ITDCPTR), N, 
+     &                                       NOMP_MAX)
+                        CALL CMUMPS_UPSCALE1(ROWSCA, WRKRC(ITDRPTR), M, 
+     &                                       NOMP_MAX)
                         IF(ITER .LE. NB1) THEN
                            ITER = NB1+1
                            CYCLE
@@ -577,30 +699,102 @@ C     get max of those two errors
                   ENDIF
                ENDIF
             ELSE
+C     ----------------------------------------
 C     WE HAVE ITER.GT.NB1 AND ITER.LE.NB1+NB2. 
 C     ONE-NORM ITERATION
-               IF((ITER .EQ.1).OR.(OORANGEIND.EQ.1))THEN
+C     ----------------------------------------
+             IF (NOMP_MAX.LE.1) THEN
+               IF((ITER .EQ.1).OR.(OORANGEIND))THEN
+                  DO NZIND=1_8,NZ_loc
+                     IR = IRN_loc(NZIND)
+                     IC = JCN_loc(NZIND)
+                     IF((IR.GE.1).AND.(IR.LE.M).AND.
+     &                    (IC.GE.1).AND.(IC.LE.N)) THEN
+                        ELM = abs(A_loc(NZIND))*ROWSCA(IR)*COLSCA(IC)
+C                       WRKRC(ITDRPTR-1_8+int(IR,8)) =
+C     &                 WRKRC(ITDRPTR-1_8+int(IR,8)) + ELM
+                        WRKRC(IR) =  WRKRC(IR) + ELM
+                        WRKRC(ITDCPTR-1_8+int(IC,8)) =
+     &                  WRKRC(ITDCPTR-1_8+int(IC,8)) + ELM
+                     ELSE
+                        OORANGEIND = .TRUE.
+                     ENDIF
+                  ENDDO
+               ELSEIF(.NOT.OORANGEIND) THEN
+                  DO NZIND=1,NZ_loc
+                     IR = IRN_loc(NZIND)
+                     IC = JCN_loc(NZIND)
+                     ELM = abs(A_loc(NZIND))*ROWSCA(IR)*COLSCA(IC)
+C                    WRKRC(ITDRPTR-1_8+int(IR,8)) =
+C     &              WRKRC(ITDRPTR-1_8+int(IR,8)) + ELM
+                     WRKRC(IR) =  WRKRC(IR) + ELM
+                     WRKRC(ITDCPTR-1_8+int(IC,8)) =
+     &               WRKRC(ITDCPTR-1_8+int(IC,8)) + ELM
+                  ENDDO
+               ENDIF
+C}
+             ELSE  ! NOMP_MAX>1
+               IF((ITER .EQ.1).OR.(OORANGEIND))THEN
+!$OMP   PARALLEL PRIVATE(IOMP)
+!$OMP&  NUM_THREADS(NOMP_MAX)
+!$OMP&    IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
+                    IOMP  = 1
+!$                  IOMP = OMP_GET_THREAD_NUM() + 1
+!$OMP     DO PRIVATE(NZIND,IR,IC,ELM)
+!$OMP&    SCHEDULE(STATIC,CHUNK_NZ)
+!$OMP&    REDUCTION(.OR.:OORANGEIND)
                   DO NZIND=1_8,NZ_loc
                      IR = IRN_loc(NZIND)
                      IC = JCN_loc(NZIND)
                      IF((IR.GE.1).AND.(IR.LE.M).AND.
      &                    (IC.GE.1).AND.(IC.LE.N)) THEN
                         ELM = abs(A_loc(NZIND))*ROWSCA(IR)*COLSCA(IC)
-                        WRKRC(ITDRPTR-1+IR) = WRKRC(ITDRPTR-1+IR) + ELM
-                        WRKRC(ITDCPTR-1+IC) = WRKRC(ITDCPTR-1+IC) + ELM
+                        WRKR_TH(IR,IOMP) = WRKR_TH(IR,IOMP) + ELM
+                        IF (IR.NE.IC)
+     &                  WRKC_TH(IC,IOMP) = WRKC_TH(IC,IOMP) + ELM
                      ELSE
-                        OORANGEIND = 1
+                        OORANGEIND = .TRUE.
                      ENDIF
                   ENDDO
-               ELSEIF(OORANGEIND.EQ.0) THEN
+!$OMP     END DO
+!$OMP   END PARALLEL
+               ELSEIF(.NOT.OORANGEIND) THEN
+!$OMP   PARALLEL PRIVATE(IOMP)
+!$OMP&  NUM_THREADS(NOMP_MAX)
+!$OMP&    IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
+                    IOMP  = 1
+!$                  IOMP = OMP_GET_THREAD_NUM() + 1
+!$OMP     DO PRIVATE(NZIND,IR,IC,ELM)
+!$OMP&    SCHEDULE(STATIC,CHUNK_NZ)
                   DO NZIND=1,NZ_loc
                      IR = IRN_loc(NZIND)
                      IC = JCN_loc(NZIND)
                      ELM = abs(A_loc(NZIND))*ROWSCA(IR)*COLSCA(IC)
-                     WRKRC(ITDRPTR-1+IR) = WRKRC(ITDRPTR-1+IR) + ELM
-                     WRKRC(ITDCPTR-1+IC) = WRKRC(ITDCPTR-1+IC) + ELM
+                     WRKR_TH(IR,IOMP) = WRKR_TH(IR,IOMP) + ELM
+                     IF (IR.NE.IC)
+     &               WRKC_TH(IC,IOMP) = WRKC_TH(IC,IOMP) + ELM
                   ENDDO
+!$OMP     END DO
+!$OMP   END PARALLEL
+               ENDIF
+C
+C              For all i on MYID:
+C              Build WRKRC(i) = Sum       (WRKR_TH(i,IOMP)
+C                              IOMP \in [1:NOMP_MAX]
+               IF(NUMPROCS > 1) THEN
+                 CALL CMUMPS_REDUCE_WRK_MPI (WRKRC, N, WRKR_TH, 
+     &                 NOMP_MAX, 
+     &                 IWRK(IMYRPTR),INUMMYR)
+                 CALL CMUMPS_REDUCE_WRK_MPI (WRKRC(ITDCPTR), 
+     &                 N, WRKC_TH, NOMP_MAX, 
+     &                 IWRK(IMYCPTR),INUMMYC)
+               ELSE
+                 CALL CMUMPS_REDUCE_WRK (WRKRC, N, WRKR_TH, NOMP_MAX)
+                 CALL CMUMPS_REDUCE_WRK (WRKRC(ITDCPTR), 
+     &                 N, WRKC_TH, NOMP_MAX)
                ENDIF
+C}
+             ENDIF
                IF(NUMPROCS > 1) THEN                 
                   CALL CMUMPS_DOCOMM1N(MYID, NUMPROCS,
      &                 WRKRC(ITDCPTR), N, TAG_ITERS+ITER, 
@@ -628,11 +822,11 @@ C
      &                 (NB2.GT.0))) THEN
                      ONEERRROW = CMUMPS_ERRSCALOC(ROWSCA, 
      &                    WRKRC(ITDRPTR), M,
-     &                    IWRK(IMYRPTR),INUMMYR)
+     &                    IWRK(IMYRPTR),INUMMYR, NOMP_MAX)
 C     find error for the cols
                      ONEERRCOL = CMUMPS_ERRSCALOC(COLSCA,  
      &                    WRKRC(ITDCPTR), N,
-     &                    IWRK(IMYCPTR),INUMMYC)
+     &                    IWRK(IMYCPTR),INUMMYC, NOMP_MAX)
 C     get max of those two errors
                      ONEERRL = ONEERRCOL
                      IF(ONEERRROW > ONEERRL ) THEN
@@ -645,10 +839,10 @@ C
                      IF(ONEERRG.LE.EPS) THEN
                         CALL CMUMPS_UPDATESCALE(COLSCA,
      &                       WRKRC(ITDCPTR),N,
-     &                       IWRK(IMYCPTR),INUMMYC)
+     &                       IWRK(IMYCPTR),INUMMYC, NOMP_MAX)
                         CALL CMUMPS_UPDATESCALE(ROWSCA,
      &                       WRKRC(ITDRPTR),M,
-     &                       IWRK(IMYRPTR),INUMMYR)          
+     &                       IWRK(IMYRPTR),INUMMYR, NOMP_MAX)
                         ITER = NB1+NB2+1
                         CYCLE
                      ENDIF
@@ -659,10 +853,10 @@ C     SINGLE-PROCESSOR CASE: ONE-NORM ER
      &                 ((ITER.EQ.NB1+NB2).AND.
      &                 (NB2.GT.0))) THEN
                      ONEERRROW = CMUMPS_ERRSCA1(ROWSCA, 
-     &                    WRKRC(ITDRPTR), M)
+     &                    WRKRC(ITDRPTR), M, NOMP_MAX)
 C     find error for the cols
                      ONEERRCOL = CMUMPS_ERRSCA1(COLSCA,  
-     &                    WRKRC(ITDCPTR), N)
+     &                    WRKRC(ITDCPTR), N, NOMP_MAX)
 C     get max of those two errors
                      ONEERRL = ONEERRCOL
                      IF(ONEERRROW > ONEERRL) THEN
@@ -670,30 +864,36 @@ C     get max of those two errors
                      ENDIF                     
                      ONEERRG = ONEERRL
                      IF(ONEERRG.LE.EPS) THEN
-                        CALL CMUMPS_UPSCALE1(COLSCA,  WRKRC(ITDCPTR), N)
-                        CALL CMUMPS_UPSCALE1(ROWSCA,  WRKRC(ITDRPTR), M)
-                        ITER = NB1+NB2+1                        
-                        CYCLE
+                       CALL CMUMPS_UPSCALE1(COLSCA, WRKRC(ITDCPTR), N, 
+     &                                      NOMP_MAX)
+                       CALL CMUMPS_UPSCALE1(ROWSCA, WRKRC(ITDRPTR), M, 
+     &                                      NOMP_MAX)
+                       ITER = NB1+NB2+1                        
+                       CYCLE
                      ENDIF
                   ENDIF                  
                ENDIF 
             ENDIF
             IF(NUMPROCS > 1) THEN               
                CALL CMUMPS_UPDATESCALE(COLSCA,  WRKRC(ITDCPTR), N,
-     &              IWRK(IMYCPTR),INUMMYC)
+     &              IWRK(IMYCPTR),INUMMYC, NOMP_MAX)
                CALL CMUMPS_UPDATESCALE(ROWSCA,  WRKRC(ITDRPTR), M,
-     &              IWRK(IMYRPTR),INUMMYR)               
+     &              IWRK(IMYRPTR),INUMMYR, NOMP_MAX)               
 C   
             ELSE
 C     SINGLE PROCESSOR CASE: Conv check and update of sca arrays
-               CALL CMUMPS_UPSCALE1(COLSCA,  WRKRC(ITDCPTR), N)
-               CALL CMUMPS_UPSCALE1(ROWSCA,  WRKRC(ITDRPTR), M)
+               CALL CMUMPS_UPSCALE1(COLSCA, WRKRC(ITDCPTR), N, 
+     &                              NOMP_MAX)
+               CALL CMUMPS_UPSCALE1(ROWSCA, WRKRC(ITDRPTR), M, 
+     &                              NOMP_MAX)
             ENDIF
             ITER = ITER + 1
+C}
          ENDDO
          ONENORMERR = ONEERRG 
          INFNORMERR = INFERRG 
          IF(NUMPROCS > 1) THEN
+C{
             CALL MPI_REDUCE(ROWSCA, WRKRC(1), M, MPI_REAL,
      &           MPI_MAX, 0, 
      &           COMM, IERROR)
@@ -707,14 +907,28 @@ C     WRITE (6,*) MYID, 'ROWSCA=',ROWSCA
 C     WRITE (6,*) MYID, 'COLSCA=',COLSCA
 C     CALL FLUSH(6)
 c     REduce the whole scaling factors to processor 0 of COMM
-            CALL MPI_REDUCE(COLSCA, WRKRC(1+M), N, MPI_REAL,
+            CALL MPI_REDUCE(COLSCA, WRKRC(1_8+int(M,8)), N, 
+     &           MPI_REAL,
      &           MPI_MAX, 0, 
      &           COMM, IERROR)
-            If(MYID.EQ.0) THEN
+            IF(MYID.EQ.0) THEN
+C{
+              IF (NOMP_MAX.LE.0) THEN
                DO I=1, N
-                  COLSCA(I) = WRKRC(I+M)
+                  COLSCA(I) = WRKRC(int(I,8)+int(M,8))
                ENDDO
+              ELSE
+!$OMP       PARALLEL DO PRIVATE(I)
+!$OMP&      SCHEDULE(STATIC,CHUNK)
+!$OMP&      IF ( N > K361 .AND. NOMP .GT. 1)
+               DO I=1, N
+                  COLSCA(I) = WRKRC(int(I,8)+int(M,8))
+               ENDDO
+!$OMP       END PARALLEL DO
+              ENDIF
+C}
             ENDIF         
+C}
          ENDIF
       ENDIF
       RETURN
@@ -732,6 +946,7 @@ C
      &     IWRK, IWRKSZ,
      &     INTSZ, RESZ, OP,
      &     SCA, WRKRC, ISZWRKRC,
+     &     WRKR_TH, LWRKR_TH, NOMP_MAX,
      &     NB1, NB2, NB3, EPS,
      &     ONENORMERR, INFNORMERR)    
 C----------------------------------------------------------------------
@@ -821,31 +1036,34 @@ C         In proceedings of VECPAR'08-In
 C         Performance Computing for Computational Science, Jan'08.
 C     and was supported by ANR-SOLSTICE project (ANR-06-CIS6-010)
 C ---------------------------------------------------------------------
+!$    USE OMP_LIB
       IMPLICIT NONE
       INCLUDE 'mpif.h'
       INTEGER(8) :: NZ_loc 
-      INTEGER N, IWRKSZ, OP
-      INTEGER NUMPROCS, MYID, COMM
-      INTEGER INTSZ, RESZ
+      INTEGER N, OP
+      INTEGER(8) :: IWRKSZ, LWRKR_TH
+      INTEGER NUMPROCS, MYID, COMM, NOMP_MAX
+      INTEGER(8) :: INTSZ, RESZ
       INTEGER IRN_loc(NZ_loc)
       INTEGER JCN_loc(NZ_loc)
       COMPLEX A_loc(NZ_loc)
       INTEGER PARTVEC(N), RSNDRCVSZ(2*NUMPROCS)
       INTEGER IWRK(IWRKSZ)
-      INTEGER REGISTRE(12)
+      INTEGER(8) :: REGISTRE(12)
       REAL SCA(N)
-      INTEGER ISZWRKRC
-      REAL WRKRC(ISZWRKRC)
+      INTEGER(8) :: ISZWRKRC
+      REAL WRKRC(ISZWRKRC), 
+     &     WRKR_TH(LWRKR_TH, max(NOMP_MAX,1))
 C     LOCALS
       INTEGER IRSNDRCVNUM, ORSNDRCVNUM
       INTEGER IRSNDRCVVOL, ORSNDRCVVOL
       INTEGER  INUMMYR
 C IMPORTANT POINTERS
-      INTEGER IMYRPTR,IMYCPTR 
-      INTEGER IRNGHBPRCS, IRSNDRCVIA,IRSNDRCVJA
-      INTEGER ORNGHBPRCS, ORSNDRCVIA,ORSNDRCVJA
-      INTEGER ISTATUS, REQUESTS, TMPWORK
-      INTEGER ITDRPTR, ISRRPTR, OSRRPTR
+      INTEGER(8) :: IMYRPTR,IMYCPTR 
+      INTEGER(8) :: IRNGHBPRCS, IRSNDRCVIA,IRSNDRCVJA
+      INTEGER(8) :: ORNGHBPRCS, ORSNDRCVIA,ORSNDRCVJA
+      INTEGER(8) :: ISTATUS, REQUESTS, TMPWORK
+      INTEGER(8) :: ITDRPTR, ISRRPTR, OSRRPTR
       REAL ONENORMERR,INFNORMERR
 C     FOR the scaling phase  
       INTEGER NB1, NB2, NB3
@@ -863,58 +1081,65 @@ C     FUNCTIONS
       EXTERNAL CMUMPS_CREATEPARTVECSYM,
      &     CMUMPS_NUMVOLSNDRCVSYM, 
      &     CMUMPS_SETUPCOMMSSYM,
-     &     CMUMPS_FINDNUMMYROWCOLSYM, 
-     &     CMUMPS_CHKCONVGLOSYM,
-     &     CMUMPS_CHK1CONV,
      &     CMUMPS_FILLMYROWCOLINDICESSYM,
      &     CMUMPS_DOCOMMINF,
      &     CMUMPS_DOCOMM1N,
      &     CMUMPS_INITREAL,
      &     CMUMPS_INITREALLST
-      INTEGER CMUMPS_CHKCONVGLOSYM 
-      INTEGER CMUMPS_CHK1CONV
       REAL CMUMPS_ERRSCALOC
       REAL CMUMPS_ERRSCA1
       INTRINSIC abs
       REAL RONE, RZERO
       PARAMETER(RONE=1.0E0,RZERO=0.0E0)
 C     TMP VARS
-      INTEGER INTSZR
+      INTEGER(8) :: INTSZR
       INTEGER MAXMN
       INTEGER I, IERROR
       REAL ONEERRL, ONEERRG
       REAL INFERRL, INFERRG
-      INTEGER OORANGEIND
-      OORANGEIND = 0
+      LOGICAL OORANGEIND
+      INTEGER, PARAMETER :: K361 = 2048
+      INTEGER            :: IOMP
+!$    INTEGER    :: NOMP
+!$    INTEGER    :: CHUNK, CHUNK_NZ
+!$    ! Too large => pb with cache L3 ?
+!$    ! INTEGER(8) :: CHUNK8 
+!$    ! CHUNK8= max(int(K361/2,8), 
+!$    !  &   (NZ_loc+int(NOMP-1,8) / int(NOMP,8) ) )
+!$    ! CHUNK8   = min(CHUNK8, huge(CHUNK)-1_8)
+!$    NOMP  = omp_get_max_threads()
+!$    CHUNK= max(K361/2, (N+NOMP-1) / NOMP )
+!$    IF (NOMP_MAX.GT.0) THEN
+!$      CHUNK_NZ = max(K361/2, (N+NOMP_MAX-1) / NOMP_MAX )
+!$    ENDIF
+C
+      OORANGEIND = .FALSE.
       INFERRG = -RONE
       ONEERRG = -RONE
       MAXMN = N
       IF(OP == 1) THEN
+C{
          IF(NUMPROCS > 1) THEN
 C     Check done outside
 C     IF(IWRKSZ.LT.2*MAXMN) THEN   ERROR.... 
             CALL CMUMPS_CREATEPARTVECSYM(MYID, NUMPROCS, COMM,
      &           IRN_loc, JCN_loc, NZ_loc,
      &           PARTVEC, N,
-     &           IWRK, IWRKSZ)
-C     
+     &           IWRK, IWRKSZ, INUMMYR )
+C
+C     Check done outside
             CALL CMUMPS_NUMVOLSNDRCVSYM(MYID, NUMPROCS, N, PARTVEC,
      &           NZ_loc, IRN_loc, JCN_loc, IRSNDRCVNUM,IRSNDRCVVOL,
      &           ORSNDRCVNUM, ORSNDRCVVOL,
      &           IWRK,IWRKSZ, 
      &           RSNDRCVSZ(1), RSNDRCVSZ(1+NUMPROCS), COMM)
 C     
-            CALL CMUMPS_FINDNUMMYROWCOLSYM(MYID, NUMPROCS, COMM,
-     &           IRN_loc, JCN_loc, NZ_loc,
-     &           PARTVEC, N,
-     &           INUMMYR,
-     &           IWRK, IWRKSZ)
 C     
-            INTSZR =  IRSNDRCVNUM + ORSNDRCVNUM + 
-     &           IRSNDRCVVOL + ORSNDRCVVOL +
-     &           2*(NUMPROCS+1) + INUMMYR
-            INTSZ = INTSZR + N + 
-     &           (MPI_STATUS_SIZE +1) *  NUMPROCS
+            INTSZR =  int(IRSNDRCVNUM,8) + int(ORSNDRCVNUM,8) + 
+     &           int(IRSNDRCVVOL,8) + int(ORSNDRCVVOL,8) +
+     &           2_8*int(NUMPROCS+1,8) + int(INUMMYR,8)
+            INTSZ = INTSZR + int(N,8) + 
+     &           int(MPI_STATUS_SIZE +1,8) * int(NUMPROCS,8)
          ELSE
 C     NUMPROCS IS 1
             IRSNDRCVNUM = 0
@@ -922,25 +1147,27 @@ C     NUMPROCS IS 1
             IRSNDRCVVOL = 0 
             ORSNDRCVVOL = 0
             INUMMYR = 0
-            INTSZ = 0
+            INTSZ = 0_8
          ENDIF
 C     CALCULATE NECESSARY REAL SPACE
-         RESZ = N + IRSNDRCVVOL + ORSNDRCVVOL
-         REGISTRE(1) = IRSNDRCVNUM 
-         REGISTRE(2) = ORSNDRCVNUM
-         REGISTRE(3) = IRSNDRCVVOL 
-         REGISTRE(4) = ORSNDRCVVOL
-         REGISTRE(9) = INUMMYR
+         RESZ = int(N,8) + int(IRSNDRCVVOL,8) + int(ORSNDRCVVOL,8)
+         REGISTRE(1)  = int(IRSNDRCVNUM,8)
+         REGISTRE(2)  = int(ORSNDRCVNUM,8)
+         REGISTRE(3)  = int(IRSNDRCVVOL,8)
+         REGISTRE(4)  = int(ORSNDRCVVOL,8)
+         REGISTRE(9)  = int(INUMMYR,8)
          REGISTRE(11) = INTSZ
          REGISTRE(12) = RESZ
+C}
       ELSE
+C{
 C     else of op=1. That is op=2 now.
 C     restore the numbers
-         IRSNDRCVNUM = REGISTRE(1) 
-         ORSNDRCVNUM = REGISTRE(2) 
-         IRSNDRCVVOL = REGISTRE(3)
-         ORSNDRCVVOL = REGISTRE(4) 
-         INUMMYR = REGISTRE(9) 
+         IRSNDRCVNUM = int(REGISTRE(1))
+         ORSNDRCVNUM = int(REGISTRE(2))
+         IRSNDRCVVOL = int(REGISTRE(3))
+         ORSNDRCVVOL = int(REGISTRE(4))
+         INUMMYR     = int(REGISTRE(9))
           IF(NUMPROCS > 1) THEN
 C     Check done outsize
 C             IF(INTSZ < REGISTRE(11)) THEN ERROR
@@ -950,24 +1177,24 @@ C     Fill up myrows and my colsX
      &            IRN_loc, JCN_loc, NZ_loc,
      &            PARTVEC, N,
      &            IWRK(1), INUMMYR,
-     &            IWRK(1+INUMMYR), IWRKSZ-INUMMYR)
-             IMYRPTR = 1
-             IMYCPTR = IMYRPTR + INUMMYR
+     &            IWRK(1+INUMMYR), IWRKSZ-int(INUMMYR,8), NOMP_MAX)
+             IMYRPTR = 1_8
+             IMYCPTR = IMYRPTR + int(INUMMYR,8)
 C     Set up comm and run.
 C     set pointers in iwrk (3 parts)
 C     
 C     ROWS    [---------------------------------------------]
              IRNGHBPRCS = IMYCPTR 
-             IRSNDRCVIA = IRNGHBPRCS+IRSNDRCVNUM
-             IRSNDRCVJA = IRSNDRCVIA + NUMPROCS+1
-             ORNGHBPRCS = IRSNDRCVJA + IRSNDRCVVOL
-             ORSNDRCVIA = ORNGHBPRCS + ORSNDRCVNUM
-             ORSNDRCVJA = ORSNDRCVIA + NUMPROCS + 1
+             IRSNDRCVIA = IRNGHBPRCS + int(IRSNDRCVNUM,8)
+             IRSNDRCVJA = IRSNDRCVIA + int(NUMPROCS+1,8)
+             ORNGHBPRCS = IRSNDRCVJA + int(IRSNDRCVVOL,8)
+             ORSNDRCVIA = ORNGHBPRCS + int(ORSNDRCVNUM,8)
+             ORSNDRCVJA = ORSNDRCVIA + int(NUMPROCS + 1,8)
 C     MPI     [-----------------]
-             REQUESTS = ORSNDRCVJA + ORSNDRCVVOL 
-             ISTATUS = REQUESTS + NUMPROCS
+             REQUESTS = ORSNDRCVJA + int(ORSNDRCVVOL,8)
+             ISTATUS = REQUESTS + int(NUMPROCS,8)
 C     TMPWRK  [-----------------]
-             TMPWORK = ISTATUS + MPI_STATUS_SIZE *  NUMPROCS
+             TMPWORK = ISTATUS + int(MPI_STATUS_SIZE,8)*int(NUMPROCS,8)
              CALL CMUMPS_SETUPCOMMSSYM(MYID, NUMPROCS, N, PARTVEC,
      &            NZ_loc, IRN_loc, JCN_loc,
      &            IRSNDRCVNUM, IRSNDRCVVOL, 
@@ -978,15 +1205,15 @@ C     TMPWRK  [-----------------]
      &            IWRK(TMPWORK), 
      &            IWRK(ISTATUS), IWRK(REQUESTS),
      &            TAG_COMM_ROW, COMM)
-             CALL CMUMPS_INITREAL(SCA, N, RZERO)
+             CALL CMUMPS_INITREAL(SCA, N, RZERO, NOMP_MAX)
              CALL CMUMPS_INITREALLST(SCA, N, 
-     &            IWRK(IMYRPTR),INUMMYR, RONE)
+     &            IWRK(IMYRPTR),INUMMYR, RONE, NOMP_MAX)
           ELSE
-             CALL CMUMPS_INITREAL(SCA, N, RONE)
+             CALL CMUMPS_INITREAL(SCA, N, RONE, NOMP_MAX)
           ENDIF
-          ITDRPTR = 1
-          ISRRPTR = ITDRPTR + N
-          OSRRPTR = ISRRPTR + IRSNDRCVVOL
+          ITDRPTR = 1_8
+          ISRRPTR = ITDRPTR + int(N,8)
+          OSRRPTR = ISRRPTR + int(IRSNDRCVVOL,8)
 C     
 C     To avoid bound check errors...
           IF(NUMPROCS == 1)THEN
@@ -999,46 +1226,123 @@ C     To avoid bound check errors...
 C     computation starts
           ITER = 1
           DO WHILE(ITER.LE.NB1+NB2+NB3)
-C     CLEAR temporary Dr and Dc
-             IF(NUMPROCS > 1) THEN
-                CALL CMUMPS_ZEROOUT(WRKRC(ITDRPTR),N,
-     &               IWRK(IMYRPTR),INUMMYR)
+C{
+C            -------------------------
+C            CLEAR temporary Dr and Dc 
+C            -------------------------
+             IF (NOMP_MAX.GT.1 .AND. 
+     &         (ITER.GT.NB1 .AND.ITER.LE.NB1+NB2)
+     &       ) THEN
+C             if one norm iteration and multithreading activated
+C             WRKR_TH need be initialized and 
+C             WRKRC will be set by reduction of WRKR_TH
+!$OMP         PARALLEL
+!$OMP&         PRIVATE(IOMP)
+!$OMP&         NUM_THREADS(NOMP_MAX)
+               IOMP  = 1
+!$             IOMP = OMP_GET_THREAD_NUM() + 1
+               IF(NUMPROCS > 1) THEN
+                 CALL CMUMPS_ZEROOUT(WRKR_TH(1,IOMP),N,
+     &                 IWRK(IMYRPTR),INUMMYR, 0)
+               ELSE
+                 CALL CMUMPS_INITREAL(WRKR_TH(1,IOMP),N, RZERO, 
+     &                                0)
+               ENDIF
+!$OMP         END PARALLEL
              ELSE
-                CALL CMUMPS_INITREAL(WRKRC(ITDRPTR),N, RZERO)
+              IF(NUMPROCS > 1) THEN
+CFIXME         Size N should be adjusted to effective size
+                 CALL CMUMPS_ZEROOUT(WRKRC(ITDRPTR),N,
+     &                IWRK(IMYRPTR),INUMMYR, NOMP_MAX)
+              ELSE
+                 CALL CMUMPS_INITREAL(WRKRC(ITDRPTR),N, RZERO,
+     &                                NOMP_MAX)
+              ENDIF
              ENDIF
+C
              IF((ITER.LE.NB1).OR.(ITER > NB1+NB2)) THEN
-C     INF-NORM ITERATION
-                IF((ITER.EQ.1).OR.(OORANGEIND.EQ.1)) THEN
+C            ------------------
+C{           INF-NORM ITERATION
+C            ------------------
+               IF (NOMP_MAX.LE.0) THEN
+                 IF((ITER .EQ.1).OR.(OORANGEIND))THEN
                    DO NZIND=1_8,NZ_loc
                       IR = IRN_loc(NZIND)
                       IC = JCN_loc(NZIND)
                       IF((IR.GE.1).AND.(IR.LE.N).AND.
      &                     (IC.GE.1).AND.(IC.LE.N)) THEN
                          ELM = abs(A_loc(NZIND))*SCA(IR)*SCA(IC)
-                         IF(WRKRC(ITDRPTR-1+IR)<ELM) THEN
-                            WRKRC(ITDRPTR-1+IR)= ELM
-                         ENDIF
-                         IF(WRKRC(ITDRPTR-1+IC)<ELM) THEN
-                            WRKRC(ITDRPTR-1+IC)= ELM
-                         ENDIF
+                         IF (WRKRC(IR)<ELM) WRKRC(IR)= ELM
+                         IF (WRKRC(IC)<ELM) WRKRC(IC)= ELM
                       ELSE
-                         OORANGEIND = 1
+                         OORANGEIND = .TRUE.
                       ENDIF
                    ENDDO
-                ELSEIF(OORANGEIND.EQ.0) THEN
+                 ELSEIF(.NOT.OORANGEIND) THEN
                    DO NZIND=1_8,NZ_loc
                       IR = IRN_loc(NZIND)
                       IC = JCN_loc(NZIND)
                       ELM = abs(A_loc(NZIND))*SCA(IR)*SCA(IC)
-                      IF(WRKRC(ITDRPTR-1+IR)<ELM) THEN
-                         WRKRC(ITDRPTR-1+IR)= ELM
-                      ENDIF
-                      IF(WRKRC(ITDRPTR-1+IC)<ELM) THEN
-                         WRKRC(ITDRPTR-1+IC)= ELM
+                      IF (WRKRC(IR)<ELM) WRKRC(IR)= ELM
+                      IF (WRKRC(IC)<ELM) WRKRC(IC)= ELM
+                   ENDDO
+                 ENDIF                      
+               ELSE
+                IF((ITER.EQ.1).OR.(OORANGEIND)) THEN
+!$OMP   PARALLEL DO PRIVATE(NZIND,IR,IC,ELM) 
+!$OMP&  SCHEDULE(STATIC,CHUNK_NZ)
+!$OMP&  IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
+!$OMP&  REDUCTION(.OR.:OORANGEIND)
+                   DO NZIND=1_8,NZ_loc
+                      IR = IRN_loc(NZIND)
+                      IC = JCN_loc(NZIND)
+                      IF((IR.GE.1).AND.(IR.LE.N).AND.
+     &                     (IC.GE.1).AND.(IC.LE.N)) THEN
+                         ELM = abs(A_loc(NZIND))*SCA(IR)*SCA(IC)
+!$OMP                    ATOMIC UPDATE
+                         WRKRC(IR)= max (ELM, WRKRC(IR))
+!$OMP                    END ATOMIC
+C                         IF(WRKRC(ITDRPTR-1_8+int(IR,8))<ELM) THEN
+C                            WRKRC(ITDRPTR-1_8+int(IR,8))= ELM
+C                         ENDIF
+!$OMP                    ATOMIC UPDATE
+                         WRKRC(IC) = max (ELM,WRKRC(IC))
+!$OMP                    END ATOMIC
+C                         IF(WRKRC(ITDRPTR-1_8+int(IC,8))<ELM) THEN
+C                            WRKRC(ITDRPTR-1_8+int(IC,8))= ELM
+C                         ENDIF
+                      ELSE
+                         OORANGEIND = .TRUE.
                       ENDIF
                    ENDDO
+!$OMP   END PARALLEL DO
+                ELSEIF(.NOT.OORANGEIND) THEN
+!$OMP   PARALLEL DO PRIVATE(NZIND,IR,IC,ELM) 
+!$OMP&  SCHEDULE(STATIC,CHUNK_NZ)
+!$OMP&  IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
+                   DO NZIND=1_8,NZ_loc
+                      IR = IRN_loc(NZIND)
+                      IC = JCN_loc(NZIND)
+                      ELM = abs(A_loc(NZIND))*SCA(IR)*SCA(IC)
+!$OMP                 ATOMIC UPDATE
+                      WRKRC(IR)= max (ELM, WRKRC(IR))
+!$OMP                 END ATOMIC
+C                      IF(WRKRC(ITDRPTR-1_8+int(IR,8))<ELM) THEN
+C                         WRKRC(ITDRPTR-1_8+int(IR,8))= ELM
+C                      ENDIF
+!$OMP                 ATOMIC UPDATE
+                      WRKRC(IC) = max (ELM, WRKRC(IC))
+!$OMP                 END ATOMIC
+C                      IF(WRKRC(ITDRPTR-1_8+int(IC,8))<ELM) THEN
+C                         WRKRC(ITDRPTR-1_8+int(IC,8))= ELM
+C                      ENDIF
+                   ENDDO
+!$OMP   END PARALLEL DO
                 ENDIF                      
-                IF(NUMPROCS > 1) THEN
+C}
+               ENDIF
+               IF(NUMPROCS > 1) THEN
+C{
                   CALL CMUMPS_DOCOMMINF(MYID, NUMPROCS,
      &                  WRKRC(ITDRPTR), N, TAG_ITERS+2+ITER, 
      &                  IRSNDRCVNUM,IWRK(IRNGHBPRCS),
@@ -1049,19 +1353,20 @@ C     INF-NORM ITERATION
      &                  WRKRC( OSRRPTR),
      &                  IWRK(ISTATUS),IWRK(REQUESTS),
      &                  COMM)
+CCCC FIXME #if defined(dev_version)
                   IF((EPS .GT. RZERO) .OR. 
      &                 (ITER.EQ.NB1).OR.
      &                 ((ITER.EQ.NB1+NB2+NB3).AND.
      &                 (NB1+NB3.GT.0))) THEN
                      INFERRL = CMUMPS_ERRSCALOC(SCA,  
      &                    WRKRC(ITDRPTR), N,
-     &                    IWRK(IMYRPTR),INUMMYR)                  
+     &                    IWRK(IMYRPTR),INUMMYR, NOMP_MAX) 
                      CALL MPI_ALLREDUCE(INFERRL, INFERRG, 
      &                    1, MPI_REAL,
      &                    MPI_MAX, COMM, IERROR)   
                      IF(INFERRG.LE.EPS) THEN
                         CALL CMUMPS_UPDATESCALE(SCA,  WRKRC(ITDRPTR), N,
-     &                       IWRK(IMYRPTR),INUMMYR)
+     &                       IWRK(IMYRPTR),INUMMYR, NOMP_MAX)
                         IF(ITER .LE. NB1) THEN
                            ITER = NB1+1
                            CYCLE
@@ -1070,17 +1375,20 @@ C     INF-NORM ITERATION
                         ENDIF
                      ENDIF
                   ENDIF
+CCC #endif
+C}
                ELSE
-C     SINGLE PROCESSOR CASE: INF-NORM ERROR COMPUTATION
+C{             SINGLE PROCESSOR CASE: INF-NORM ERROR COMPUTATION
                   IF((EPS .GT. RZERO) .OR. 
      &                 (ITER.EQ.NB1).OR.
      &                 ((ITER.EQ.NB1+NB2+NB3).AND.
      &                 (NB1+NB3.GT.0))) THEN
                      INFERRL = CMUMPS_ERRSCA1(SCA, 
-     &                    WRKRC(ITDRPTR), N)
+     &                    WRKRC(ITDRPTR), N, NOMP_MAX)
                      INFERRG = INFERRL
                      IF(INFERRG.LE.EPS) THEN
-                        CALL CMUMPS_UPSCALE1(SCA,  WRKRC(ITDRPTR), N)
+                        CALL CMUMPS_UPSCALE1(SCA, WRKRC(ITDRPTR), N,
+     &                                       NOMP_MAX)
                         IF(ITER .LE. NB1) THEN
                            ITER = NB1+1
                            CYCLE
@@ -1089,38 +1397,102 @@ C     SINGLE PROCESSOR CASE: INF-NORM ER
                         ENDIF
                      ENDIF 
                   ENDIF
+C}
                ENDIF
+C}
             ELSE
-C     WE HAVE ITER.GT.NB1 AND ITER.LE.NB1+NB2. 
-C     ONE-NORM ITERATION
-               IF((ITER.EQ.1).OR.(OORANGEIND.EQ.1))THEN
+C           ----------------------------------------
+C{          WE HAVE ITER.GT.NB1 AND ITER.LE.NB1+NB2. 
+C           ONE-NORM ITERATION
+C           ----------------------------------------
+             IF (NOMP_MAX.LE.1) THEN
+               IF((ITER.EQ.1).OR.(OORANGEIND))THEN
+                  DO NZIND=1_8,NZ_loc
+                     IR = IRN_loc(NZIND)
+                     IC = JCN_loc(NZIND)
+                     IF((IR.GE.1).AND.(IR.LE.N).AND.
+     &                    (IC.GE.1).AND.(IC.LE.N)) THEN
+                        ELM = abs(A_loc(NZIND))*SCA(IR)*SCA(IC)
+                        WRKRC(IR) = WRKRC(IR) + ELM
+                        IF(IR.NE.IC) THEN
+                           WRKRC(IC) = WRKRC(IC) + ELM
+                        ENDIF
+                     ELSE
+                        OORANGEIND = .TRUE.
+                     ENDIF
+                  ENDDO
+               ELSEIF(.NOT.OORANGEIND)THEN
+                  DO NZIND=1_8,NZ_loc
+                     IR = IRN_loc(NZIND)
+                     IC = JCN_loc(NZIND)
+                     ELM = abs(A_loc(NZIND))*SCA(IR)*SCA(IC)
+                     WRKRC(IR) = WRKRC(IR) + ELM
+                     IF(IR.NE.IC) THEN
+                        WRKRC(IC) = WRKRC(IC) + ELM
+                     ENDIF
+                  ENDDO
+               ENDIF
+             ELSE ! NOMP_MAX>1
+               IF((ITER.EQ.1).OR.(OORANGEIND))THEN
+!$OMP   PARALLEL PRIVATE(IOMP)
+!$OMP&  NUM_THREADS(NOMP_MAX)
+!$OMP&    IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
+                    IOMP  = 1
+!$                  IOMP = OMP_GET_THREAD_NUM() + 1
+!$OMP     DO PRIVATE(NZIND,IR,IC,ELM)
+!$OMP&    SCHEDULE(STATIC,CHUNK_NZ)
+!$OMP&    REDUCTION(.OR.:OORANGEIND)
                   DO NZIND=1_8,NZ_loc
                      IR = IRN_loc(NZIND)
                      IC = JCN_loc(NZIND)
                      IF((IR.GE.1).AND.(IR.LE.N).AND.
      &                    (IC.GE.1).AND.(IC.LE.N)) THEN
                         ELM = abs(A_loc(NZIND))*SCA(IR)*SCA(IC)
-                        WRKRC(ITDRPTR-1+IR) = WRKRC(ITDRPTR-1+IR) + ELM
+                        WRKR_TH(IR,IOMP) = WRKR_TH(IR,IOMP) + ELM
                         IF(IR.NE.IC) THEN
-                           WRKRC(ITDRPTR-1+IC) = 
-     &                          WRKRC(ITDRPTR-1+IC) + ELM
+                          WRKR_TH(IC,IOMP) = WRKR_TH(IC,IOMP) + ELM
                         ENDIF
                      ELSE
-                        OORANGEIND = 1
+                        OORANGEIND = .TRUE.
                      ENDIF
                   ENDDO
-               ELSEIF(OORANGEIND.EQ.0)THEN
+!$OMP     END DO
+!$OMP   END PARALLEL
+               ELSEIF(.NOT.OORANGEIND)THEN
+!$OMP   PARALLEL PRIVATE(IOMP)
+!$OMP&  NUM_THREADS(NOMP_MAX)
+!$OMP&    IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
+                    IOMP  = 1
+!$                  IOMP = OMP_GET_THREAD_NUM() + 1
+!$OMP     DO PRIVATE(NZIND,IR,IC,ELM)
+!$OMP&    SCHEDULE(STATIC,CHUNK_NZ)
                   DO NZIND=1_8,NZ_loc
                      IR = IRN_loc(NZIND)
                      IC = JCN_loc(NZIND)
                      ELM = abs(A_loc(NZIND))*SCA(IR)*SCA(IC)
-                     WRKRC(ITDRPTR-1+IR) = WRKRC(ITDRPTR-1+IR) + ELM
+                     WRKR_TH(IR,IOMP) = WRKR_TH(IR,IOMP) + ELM
                      IF(IR.NE.IC) THEN
-                        WRKRC(ITDRPTR-1+IC) = WRKRC(ITDRPTR-1+IC) + ELM
+                       WRKR_TH(IC,IOMP) = WRKR_TH(IC,IOMP) + ELM
                      ENDIF
                   ENDDO
+!$OMP     END DO
+!$OMP   END PARALLEL
+C}
+               ENDIF
+C
+C              For all i on MYID:
+C              Build WRKRC(i) = Sum       (WRKR_TH(i,IOMP)
+C                              IOMP \in [1:NOMP_MAX]
+               IF(NUMPROCS > 1) THEN
+                 CALL CMUMPS_REDUCE_WRK_MPI (WRKRC, N, WRKR_TH, 
+     &                 NOMP_MAX, 
+     &                 IWRK(IMYRPTR),INUMMYR)
+               ELSE
+                 CALL CMUMPS_REDUCE_WRK (WRKRC, N, WRKR_TH, NOMP_MAX)
                ENDIF
+             ENDIF
                IF(NUMPROCS > 1) THEN
+C{
                   CALL CMUMPS_DOCOMM1N(MYID, NUMPROCS,
      &                 WRKRC(ITDRPTR), N, TAG_ITERS+2+ITER, 
      &                 IRSNDRCVNUM, IWRK(IRNGHBPRCS),
@@ -1136,54 +1508,72 @@ C     ONE-NORM ITERATION
      &                 (NB2.GT.0))) THEN
                      ONEERRL = CMUMPS_ERRSCALOC(SCA,  
      &                    WRKRC(ITDRPTR), N,
-     &                    IWRK(IMYRPTR),INUMMYR) 
+     &                    IWRK(IMYRPTR),INUMMYR, NOMP_MAX) 
 C     mpi allreduce.
                      CALL MPI_ALLREDUCE(ONEERRL, ONEERRG, 
      &                    1, MPI_REAL,
      &                    MPI_MAX, COMM, IERROR)
                      IF(ONEERRG.LE.EPS) THEN
                         CALL CMUMPS_UPDATESCALE(SCA,  WRKRC(ITDRPTR), N,
-     &                       IWRK(IMYRPTR),INUMMYR)
+     &                       IWRK(IMYRPTR),INUMMYR, NOMP_MAX)
                         ITER = NB1+NB2+1
                         CYCLE
                      ENDIF
                   ENDIF
+C}
                ELSE
-C     SINGLE-PROCESSOR CASE: ONE-NORM ERROR COMPUTATION
+C{             SINGLE-PROCESSOR CASE: ONE-NORM ERROR COMPUTATION
                   IF((EPS .GT. RZERO) .OR. 
      &                 ((ITER.EQ.NB1+NB2).AND.
      &                 (NB2.GT.0))) THEN
                      ONEERRL = CMUMPS_ERRSCA1(SCA, 
-     &                    WRKRC(ITDRPTR), N)
+     &                    WRKRC(ITDRPTR), N, NOMP_MAX)
                      ONEERRG = ONEERRL
                      IF(ONEERRG.LE.EPS) THEN
-                        CALL CMUMPS_UPSCALE1(SCA,  WRKRC(ITDRPTR), N)
+                        CALL CMUMPS_UPSCALE1(SCA, WRKRC(ITDRPTR), N,
+     &                                       NOMP_MAX)
                         ITER = NB1+NB2+1
                         CYCLE
                      ENDIF
                   ENDIF
                ENDIF
+C}
             ENDIF
             IF(NUMPROCS > 1) THEN
-               CALL CMUMPS_UPDATESCALE(SCA,  WRKRC(ITDRPTR), N,
-     &              IWRK(IMYRPTR),INUMMYR)
+               CALL CMUMPS_UPDATESCALE(SCA, WRKRC(ITDRPTR), N,
+     &              IWRK(IMYRPTR),INUMMYR, NOMP_MAX)
             ELSE
-               CALL CMUMPS_UPSCALE1(SCA,  WRKRC(ITDRPTR), N)
+               CALL CMUMPS_UPSCALE1(SCA, WRKRC(ITDRPTR), N, 
+     &                              NOMP_MAX)
             ENDIF     
             ITER = ITER + 1
+C}
          ENDDO
          ONENORMERR = ONEERRG 
          INFNORMERR = INFERRG 
          IF(NUMPROCS > 1) THEN
+C{
             CALL MPI_REDUCE(SCA, WRKRC(1), N, MPI_REAL,
      &           MPI_MAX, 0, 
      &           COMM, IERROR)
             IF(MYID.EQ.0) THEN
+              IF (NOMP_MAX.LE.0) THEN
+               DO I=1, N
+                  SCA(I) = WRKRC(I)
+               ENDDO
+              ELSE
+!$OMP       PARALLEL DO PRIVATE(I)
+!$OMP&      SCHEDULE(STATIC,CHUNK)
+!$OMP&      IF ( N > K361 .AND. NOMP .GT. 1)
                DO I=1, N
                   SCA(I) = WRKRC(I)
                ENDDO
+!$OMP       END PARALLEL DO
+              ENDIF
             ENDIF
+C}
          ENDIF
+C}
       ENDIF
       RETURN
       END SUBROUTINE CMUMPS_SIMSCALEABSSYM
diff -pruN 5.6.2-2.1/src/cfac_scalings_simScale_util.F 5.7.1-1/src/cfac_scalings_simScale_util.F
--- 5.6.2-2.1/src/cfac_scalings_simScale_util.F	2023-10-11 09:37:10.000000000 +0000
+++ 5.7.1-1/src/cfac_scalings_simScale_util.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -14,19 +14,23 @@ C
       SUBROUTINE CMUMPS_CREATEPARTVEC(MYID, NUMPROCS, COMM,
      & IRN_loc, JCN_loc, NZ_loc,
      & IPARTVEC, ISZ, OSZ,
-     & IWRK, IWSZ)
+     & IWRK, IWSZ, INUMMY, NOMP_MAX )
+!$    USE OMP_LIB
 C
       IMPLICIT NONE
       EXTERNAL CMUMPS_BUREDUCE
-      INTEGER, INTENT(IN)    :: MYID, NUMPROCS, COMM
+      INTEGER, INTENT(IN)    :: MYID, NUMPROCS, COMM, NOMP_MAX
       INTEGER(8), INTENT(IN) :: NZ_loc 
-      INTEGER, INTENT(IN)    :: IWSZ
+      INTEGER(8), INTENT(IN) :: IWSZ
       INTEGER, INTENT(IN)    :: ISZ, OSZ
       INTEGER, INTENT(IN)    :: IRN_loc(NZ_loc), JCN_loc(NZ_loc)
 C  OUTPUT
 C     IPARTVEC(I) = proc number with largest number of entries 
 C                in row/col I
+C     INUMMY = number of local rows/columns with
+C              at least one local entry (NUMPROCS .NE. 1 only)
       INTEGER, INTENT(OUT) :: IPARTVEC(ISZ)
+      INTEGER, INTENT(OUT) :: INUMMY
 C
 C  INTERNAL WORKING ARRAY
 C     IWRK (1:2*ISZ) is initialized to couples (MYID, Nb of entries
@@ -46,42 +50,87 @@ C     LOCAL VARS
       INTEGER(8) :: I8
       INTEGER OP, IERROR
       INTEGER IR, IC
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
 C
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP  = omp_get_max_threads()
+!$     CHUNK= max(K361/2, (ISZ+NOMP-1) / NOMP )
+!$    ENDIF
+C
+      INUMMY = 0
       IF(NUMPROCS.NE.1) THEN
 C     CHECK done outsize
 C     IF(IWSZ < 4*ISZ) THEN
 C     CHECK ENDS
          CALL MPI_OP_CREATE(CMUMPS_BUREDUCE, .TRUE., OP, IERROR)
 C     PERFORM THE REDUCTION
-#if defined(WORKAROUNDINTELILP64MPI2INTEGER)
-        CALL CMUMPS_IBUINIT(IWRK, 4*ISZ, int(ISZ,4))
-#else
-        CALL CMUMPS_IBUINIT(IWRK, 4*ISZ, ISZ)
-#endif
 C     WE FIRST ZERO OUT  
+       IF (NOMP_MAX.LE.0) THEN
+         DO I=1,ISZ
+            IWRK(2_8*int(I,8)-1_8) = 0
+            IWRK(2_8*int(I,8))     = MYID
+         ENDDO
+       ELSE
+!$OMP   PARALLEL DO PRIVATE(I) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1.AND.ISZ > K361 )
          DO I=1,ISZ
-            IWRK(2*I-1) = 0
-            IWRK(2*I) = MYID
+            IWRK(2_8*int(I,8)-1_8) = 0
+            IWRK(2_8*int(I,8))     = MYID
          ENDDO
+!$OMP   END PARALLEL DO
+       ENDIF
          DO I8=1_8,NZ_loc
             IR = IRN_loc(I8)
             IC = JCN_loc(I8)
             IF((IR.GE.1).AND.(IR.LE.ISZ).AND.
      &           (IC.GE.1).AND.(IC.LE.OSZ)) THEN
-               IWRK(2*IR-1) = IWRK(2*IR-1) + 1
+               IWRK(2_8*int(IR,8)-1_8) = IWRK(2_8*int(IR,8)-1_8) + 1
             ENDIF
          ENDDO
-         CALL MPI_ALLREDUCE(IWRK(1), IWRK(1+2*ISZ), ISZ,
+         CALL MUMPS_BIGALLREDUCE(.FALSE., IWRK(1),
+     &        IWRK(1_8+2_8*int(ISZ,8)), ISZ,
      &        MPI_2INTEGER, OP, COMM, IERROR)      
-         DO I=1,ISZ
-            IPARTVEC(I) = IWRK(2*I+2*ISZ)
-         ENDDO
+C
+        IF (NOMP_MAX.LE.0) THEN
+          DO I=1,ISZ
+             IPARTVEC(I) = IWRK(2_8*int(I,8)+2_8*int(ISZ,8))
+C            Compute INUMMY directly
+             IF ( IPARTVEC(I) .EQ. MYID. OR.
+     &            IWRK(2_8*int(I,8)-1_8) .GT. 0 ) THEN
+               INUMMY=INUMMY+1
+             ENDIF
+          ENDDO
+        ELSE
+!$OMP   PARALLEL DO PRIVATE(I) SCHEDULE(STATIC,CHUNK)
+!$OMP&  IF ( ISZ > K361 .AND. NOMP .GT. 1)
+!$OMP&  REDUCTION(+:INUMMY)
+          DO I=1,ISZ
+             IPARTVEC(I) = IWRK(2_8*int(I,8)+2_8*int(ISZ,8))
+C            Compute INUMMY directly
+             IF ( IPARTVEC(I) .EQ. MYID. OR.
+     &            IWRK(2_8*int(I,8)-1_8) .GT. 0 ) THEN
+               INUMMY=INUMMY+1
+             ENDIF
+          ENDDO
+!$OMP   END PARALLEL DO
+        ENDIF
 C     FREE THE OPERATOR
          CALL MPI_OP_FREE(OP, IERROR)
       ELSE
-         DO I=1,ISZ
-            IPARTVEC(I) = 0
-         ENDDO
+        IF (NOMP_MAX.LE.0) THEN
+          DO I=1,ISZ
+             IPARTVEC(I) = 0
+          ENDDO
+        ELSE
+!$OMP    PARALLEL DO PRIVATE(I) SCHEDULE(STATIC,CHUNK)
+!$OMP&   IF ( ISZ > K361 .AND. NOMP .GT. 1)
+          DO I=1,ISZ
+             IPARTVEC(I) = 0
+          ENDDO
+!$OMP    END PARALLEL DO
+       ENDIF
       ENDIF
       RETURN
       END SUBROUTINE CMUMPS_CREATEPARTVEC
@@ -89,94 +138,17 @@ C
 C     SEPARATOR: Another function begins
 C
 C 
-      SUBROUTINE CMUMPS_FINDNUMMYROWCOL(MYID, NUMPROCS, COMM,
-     &     IRN_loc, JCN_loc, NZ_loc,
-     &     ROWPARTVEC, COLPARTVEC, M, N,
-     &     INUMMYR,
-     &     INUMMYC,     
-     &     IWRK, IWSZ)
-      IMPLICIT NONE
-      INTEGER(8), INTENT(IN) :: NZ_loc
-      INTEGER, INTENT(IN) :: MYID, NUMPROCS, M, N, IWSZ
-      INTEGER, INTENT(IN) :: IRN_loc(NZ_loc), JCN_loc(NZ_loc)
-C     [ROW/COL]PARTVEC(I) holds proc number with largest number of entries 
-C                in row/col I
-      INTEGER, INTENT(IN) :: ROWPARTVEC(M)
-      INTEGER, INTENT(IN) :: COLPARTVEC(N)
-      INTEGER, INTENT(IN) :: COMM
-C
-C  OUTPUT PARAMETERS
-C     INUMMYR < M and INUMMYC < N  (CPA or <= ??)
-C     INUMMYR holds the number of rows allocated to me 
-C             or non empty on my proc
-C     INUMMYC idem with columns
-      INTEGER INUMMYR, INUMMYC
-C
-C  INTERNAL working array
-      INTEGER IWRK(IWSZ)
-C
-C   Local variables
-      INTEGER I, IR, IC
-      INTEGER(8) ::  I8
-C check done outsize     
-C     IF(IWSZ < M) THEN ERROR
-C     IF(IWSZ < N) THEN ERROR
-      INUMMYR = 0
-      INUMMYC = 0
-C     MARK MY ROWS. FIRST COUNT,
-C          IF DYNAMIC MEMORY ALLOCATIOn WILL USED
-C     INUMMYR first counts number of rows affected to me
-C             (that will be centralized on MYID)
-      DO I=1,M
-         IWRK(I) = 0
-         IF(ROWPARTVEC(I).EQ.MYID) THEN
-            IWRK(I)=1
-            INUMMYR = INUMMYR + 1
-         ENDIF
-      ENDDO
-      DO I8=1_8,NZ_loc
-         IR = IRN_loc(I8)
-         IC = JCN_loc(I8)
-         IF((IR.GE.1).AND.(IR.LE.M).AND.
-     &        ((IC.GE.1).AND.(IC.LE.N)) ) THEN
-            IF(IWRK(IR) .EQ. 0) THEN
-               IWRK(IR)= 1
-               INUMMYR = INUMMYR + 1
-            ENDIF
-         ENDIF
-      ENDDO
-C     DO THE SMAME THING FOR COLS
-      DO I=1,N
-         IWRK(I) = 0
-         IF(COLPARTVEC(I).EQ.MYID) THEN
-            IWRK(I)= 1
-            INUMMYC = INUMMYC + 1
-         ENDIF
-      ENDDO
-      DO I8=1_8,NZ_loc
-         IC = JCN_loc(I8)
-         IR = IRN_loc(I8)
-         IF((IR.GE.1).AND.(IR.LE.M).AND.
-     &        ((IC.GE.1).AND.(IC.LE.N)) ) THEN
-            IF(IWRK(IC) .EQ. 0) THEN
-               IWRK(IC)= 1
-               INUMMYC = INUMMYC + 1
-            ENDIF
-         ENDIF
-      ENDDO
-C
-      RETURN
-      END SUBROUTINE CMUMPS_FINDNUMMYROWCOL
       SUBROUTINE CMUMPS_FILLMYROWCOLINDICES(MYID, NUMPROCS,COMM,    
      &     IRN_loc, JCN_loc, NZ_loc,
      &     ROWPARTVEC, COLPARTVEC, M, N,
      &     MYROWINDICES, INUMMYR,
      &     MYCOLINDICES, INUMMYC,     
-     &     IWRK, IWSZ  )
+     &     IWRK, IWSZ, NOMP_MAX  )
+!$    USE OMP_LIB
       IMPLICIT NONE
-      INTEGER(8) :: NZ_loc
-      INTEGER MYID, NUMPROCS, M, N
-      INTEGER INUMMYR, INUMMYC, IWSZ
+      INTEGER(8) :: NZ_loc, IWSZ
+      INTEGER MYID, NUMPROCS, M, N, NOMP_MAX
+      INTEGER INUMMYR, INUMMYC
       INTEGER IRN_loc(NZ_loc), JCN_loc(NZ_loc)
       INTEGER ROWPARTVEC(M)
       INTEGER COLPARTVEC(N)
@@ -188,11 +160,32 @@ C
       INTEGER I, IR, IC, ITMP
       INTEGER(8) :: I8
 C      
+      INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP=omp_get_max_threads()
+C      note that M=N
+!$     CHUNK= max(K361/2, (M+NOMP-1) / NOMP )
+!$    ENDIF
+C      
 C     MARK MY ROWS. 
-      DO I=1,M
-         IWRK(I) = 0
-         IF(ROWPARTVEC(I).EQ.MYID) IWRK(I)=1
-      ENDDO
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,M
+           IWRK(I) = 0
+           IF(ROWPARTVEC(I).EQ.MYID) IWRK(I)=1
+        ENDDO
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I) 
+!$OMP&  SCHEDULE(STATIC,CHUNK)
+!$OMP&  IF ( M > K361 .AND. NOMP .GT. 1)
+        DO I=1,M
+           IWRK(I) = 0
+           IF(ROWPARTVEC(I).EQ.MYID) IWRK(I)=1
+        ENDDO
+!$OMP END PARALLEL DO
+      ENDIF
+CTEMP !$OMP  PARALLEL DO PRIVATE(I8,IR,IC) SCHEDULE(STATIC,CHUNK)
+CTEMP !$OMP& IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
       DO I8=1,NZ_loc
          IR = IRN_loc(I8)         
          IC = JCN_loc(I8)
@@ -201,6 +194,7 @@ C     MARK MY ROWS.
             IF(IWRK(IR) .EQ. 0) IWRK(IR)= 1
          ENDIF
       ENDDO
+CTEMP !$OMP END PARALLEL DO
 C     PUT MY ROWS INTO MYROWINDICES
       ITMP = 1
       DO I=1,M
@@ -212,10 +206,24 @@ C     PUT MY ROWS INTO MYROWINDICES
 C
 C
 C     DO THE SMAME THING FOR COLS
-      DO I=1,N
-         IWRK(I) = 0
-         IF(COLPARTVEC(I).EQ.MYID) IWRK(I)= 1
-      ENDDO
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,N
+           IWRK(I) = 0
+           IF(COLPARTVEC(I).EQ.MYID) IWRK(I)= 1
+        ENDDO
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I) 
+!$OMP&  SCHEDULE(STATIC,CHUNK)
+!$OMP&  IF ( N > K361 .AND. NOMP .GT. 1)
+        DO I=1,N
+           IWRK(I) = 0
+           IF(COLPARTVEC(I).EQ.MYID) IWRK(I)= 1
+        ENDDO
+!$OMP END PARALLEL DO
+      ENDIF
+C
+CTEMP !$OMP  PARALLEL DO PRIVATE(I8,IR,IC) SCHEDULE(STATIC,CHUNK)
+CTEMP !$OMP& IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
       DO I8=1,NZ_loc
          IR = IRN_loc(I8)         
          IC = JCN_loc(I8)
@@ -224,6 +232,7 @@ C     DO THE SMAME THING FOR COLS
             IF(IWRK(IC) .EQ. 0) IWRK(IC)= 1
          ENDIF
       ENDDO
+CTEMP !$OMP END PARALLEL DO
 C     PUT MY ROWS INTO MYROWINDICES
       ITMP = 1
       DO I=1,N
@@ -305,11 +314,12 @@ C
 C     SEPARATOR: Another function begins
 C
       REAL FUNCTION CMUMPS_ERRSCALOC(D, TMPD, DSZ,
-     &     INDX, INDXSZ)
+     &     INDX, INDXSZ, NOMP_MAX)
+!$    USE OMP_LIB
 C     THE VAR D IS NOT USED IN COMPUTATIONS.
 C     IT IS THERE FOR READIBLITY OF THE *simScaleAbs.F
       IMPLICIT NONE 
-      INTEGER DSZ, INDXSZ
+      INTEGER, INTENT(IN):: DSZ, INDXSZ, NOMP_MAX
       REAL D(DSZ)
       REAL TMPD(DSZ)
       INTEGER INDX(INDXSZ)
@@ -319,19 +329,40 @@ C     LOCAL VARS
       INTEGER I, IIND
       REAL ERRMAX
       INTRINSIC abs
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
       ERRMAX = -RONE
-      DO I=1,INDXSZ
-         IIND = INDX(I)
-         IF(abs(RONE-TMPD(IIND)).GT.ERRMAX) THEN
-            ERRMAX = abs(RONE-TMPD(IIND))
-         ENDIF
-      ENDDO           
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP  = OMP_GET_MAX_THREADS()
+!$     CHUNK= max(K361/2, (INDXSZ+NOMP-1) / NOMP )
+!$    ENDIF
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,INDXSZ
+           IIND = INDX(I)
+           IF(abs(RONE-TMPD(IIND)).GT.ERRMAX) THEN
+              ERRMAX = abs(RONE-TMPD(IIND))
+           ENDIF
+        ENDDO           
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I,IIND) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1 .AND. INDXSZ > K361 )
+!$OMP&  REDUCTION(max:ERRMAX)
+        DO I=1,INDXSZ
+           IIND = INDX(I)
+           IF(abs(RONE-TMPD(IIND)).GT.ERRMAX) THEN
+              ERRMAX = abs(RONE-TMPD(IIND))
+           ENDIF
+        ENDDO           
+!$OMP   END PARALLEL DO
+      ENDIF
       CMUMPS_ERRSCALOC = ERRMAX
       RETURN
       END FUNCTION CMUMPS_ERRSCALOC
-      REAL FUNCTION CMUMPS_ERRSCA1(D, TMPD, DSZ)
+      REAL FUNCTION CMUMPS_ERRSCA1(D, TMPD, DSZ, NOMP_MAX)
+!$    USE OMP_LIB
       IMPLICIT NONE 
-      INTEGER DSZ
+      INTEGER, INTENT(IN):: DSZ, NOMP_MAX
       REAL D(DSZ)
       REAL TMPD(DSZ)
 C     LOCAL VARS
@@ -340,12 +371,31 @@ C     LOCAL VARS
       INTEGER I
       REAL ERRMAX1
       INTRINSIC abs
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
       ERRMAX1 = -RONE
-      DO I=1,DSZ
-         IF(abs(RONE-TMPD(I)).GT.ERRMAX1) THEN
-            ERRMAX1 = abs(RONE-TMPD(I))
-         ENDIF
-      ENDDO
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP  = OMP_GET_MAX_THREADS()
+!$     CHUNK= max(K361/2, (DSZ+NOMP-1) / NOMP )
+!$    ENDIF
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,DSZ
+           IF(abs(RONE-TMPD(I)).GT.ERRMAX1) THEN
+              ERRMAX1 = abs(RONE-TMPD(I))
+           ENDIF
+        ENDDO
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1.AND.DSZ > K361 )
+!$OMP&  REDUCTION(max:ERRMAX1)
+        DO I=1,DSZ
+           IF(abs(RONE-TMPD(I)).GT.ERRMAX1) THEN
+              ERRMAX1 = abs(RONE-TMPD(I))
+           ENDIF
+        ENDDO
+!$OMP   END PARALLEL DO
+      ENDIF
       CMUMPS_ERRSCA1 = ERRMAX1
       RETURN
       END FUNCTION CMUMPS_ERRSCA1
@@ -353,9 +403,10 @@ C
 C     SEPARATOR: Another function begins
 C
       SUBROUTINE CMUMPS_UPDATESCALE(D,  TMPD, DSZ,
-     &        INDX, INDXSZ)
+     &        INDX, INDXSZ, NOMP_MAX)
+!$    USE OMP_LIB
       IMPLICIT NONE
-      INTEGER DSZ, INDXSZ
+      INTEGER, INTENT(in) :: DSZ, INDXSZ, NOMP_MAX
       REAL D(DSZ)
       REAL TMPD(DSZ)
       INTEGER INDX(INDXSZ)
@@ -364,15 +415,34 @@ C     LOCAL VARS
       INTEGER I, IIND
       REAL RZERO
       PARAMETER(RZERO=0.0E0)
-      DO I=1,INDXSZ
-         IIND = INDX(I)
-         IF (TMPD(IIND).NE.RZERO) D(IIND) = D(IIND)/sqrt(TMPD(IIND))
-      ENDDO
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP  = OMP_GET_MAX_THREADS()
+!$     CHUNK= max(K361/2, (INDXSZ+NOMP-1) / NOMP )
+!$    ENDIF
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,INDXSZ
+           IIND = INDX(I)
+           IF (TMPD(IIND).NE.RZERO) D(IIND)=D(IIND)/sqrt(TMPD(IIND))
+        ENDDO
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I,IIND) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1.AND.  INDXSZ> K361 )
+        DO I=1,INDXSZ
+           IIND = INDX(I)
+           IF (TMPD(IIND).NE.RZERO) D(IIND)=D(IIND)/sqrt(TMPD(IIND))
+        ENDDO
+!$OMP   END PARALLEL DO
+      ENDIF
       RETURN
       END SUBROUTINE CMUMPS_UPDATESCALE
-      SUBROUTINE CMUMPS_UPSCALE1(D,  TMPD, DSZ)
+C
+      SUBROUTINE CMUMPS_UPSCALE1(D,  TMPD, DSZ, NOMP_MAX)
+!$    USE OMP_LIB
       IMPLICIT NONE
-      INTEGER DSZ
+      INTEGER, INTENT(IN):: DSZ, NOMP_MAX
       REAL D(DSZ)
       REAL TMPD(DSZ)
       INTRINSIC sqrt
@@ -380,74 +450,186 @@ C     LOCAL VARS
       INTEGER I
       REAL RZERO
       PARAMETER(RZERO=0.0E0)
-      DO I=1,DSZ
-         IF (TMPD(I) .NE. RZERO) D(I) = D(I)/sqrt(TMPD(I))
-      ENDDO
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
+!$    IF (NOMP_MAX.GT.0) THEN
+!$      NOMP  = OMP_GET_MAX_THREADS()
+!$      CHUNK= max(K361/2, (DSZ+NOMP-1) / NOMP )
+!$    ENDIF
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,DSZ
+           IF (TMPD(I) .NE. RZERO) D(I) = D(I)/sqrt(TMPD(I))
+        ENDDO
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1.AND.  DSZ> K361 )
+        DO I=1,DSZ
+           IF (TMPD(I) .NE. RZERO) D(I) = D(I)/sqrt(TMPD(I))
+        ENDDO
+!$OMP   END PARALLEL DO
+      ENDIF
       RETURN
       END SUBROUTINE CMUMPS_UPSCALE1
 C
 C     SEPARATOR: Another function begins
 C
-      SUBROUTINE CMUMPS_INITREALLST(D, DSZ, INDX, INDXSZ, VAL)
+      SUBROUTINE CMUMPS_INITREALLST(D, DSZ, INDX, INDXSZ, VAL,
+     &                              NOMP_MAX)
+!$    USE OMP_LIB
       IMPLICIT NONE
-      INTEGER DSZ, INDXSZ
+      INTEGER, INTENT(IN):: DSZ, INDXSZ, NOMP_MAX
       REAL D(DSZ)
       INTEGER INDX(INDXSZ)
       REAL VAL
 C     LOCAL VARS
       INTEGER I, IIND
-      DO I=1,INDXSZ
-         IIND = INDX(I)
-         D(IIND) = VAL
-      ENDDO
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP  = OMP_GET_MAX_THREADS()
+!$     CHUNK= max(K361/2, (INDXSZ+NOMP-1) / NOMP )
+!$    ENDIF
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,INDXSZ
+           IIND = INDX(I)
+           D(IIND) = VAL
+        ENDDO
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I,IIND) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1.AND.  INDXSZ > K361 )
+        DO I=1,INDXSZ
+           IIND = INDX(I)
+           D(IIND) = VAL
+        ENDDO
+!$OMP   END PARALLEL DO
+      ENDIF
       RETURN
       END SUBROUTINE CMUMPS_INITREALLST
 C
 C     SEPARATOR: Another function begins
 C
-      SUBROUTINE CMUMPS_INVLIST(D, DSZ, INDX, INDXSZ)
-      IMPLICIT NONE
-      INTEGER DSZ, INDXSZ
-      REAL D(DSZ)
-      INTEGER INDX(INDXSZ)
-C     LOCALS
-      INTEGER I, IIND
-      DO I=1,INDXSZ
-         IIND  = INDX(I)
-         D(IIND) = 1.0E0/D(IIND)
-      ENDDO
-      RETURN
-      END SUBROUTINE CMUMPS_INVLIST
 C
 C     SEPARATOR: Another function begins
 C
-      SUBROUTINE CMUMPS_INITREAL(D, DSZ, VAL)
+      SUBROUTINE CMUMPS_INITREAL(D, DSZ, VAL, NOMP_MAX)
+!$    USE OMP_LIB
       IMPLICIT NONE
-      INTEGER DSZ
+      INTEGER, INTENT(IN):: DSZ, NOMP_MAX
       REAL D(DSZ)
       REAL VAL
 C     LOCAL VARS
       INTEGER I
-      DO I=1,DSZ
-         D(I) = VAL
-      ENDDO
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP  = omp_get_max_threads()
+!$     CHUNK= max(K361/2, (DSZ+NOMP-1) / NOMP )
+!$    ENDIF
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,DSZ
+           D(I) = VAL
+        ENDDO
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1.AND.DSZ > K361 )
+        DO I=1,DSZ
+           D(I) = VAL
+        ENDDO
+!$OMP   END PARALLEL DO
+      ENDIF
       RETURN
       END SUBROUTINE CMUMPS_INITREAL
 C
 C     SEPARATOR: Another function begins
 C
-      SUBROUTINE CMUMPS_ZEROOUT(TMPD, TMPSZ, INDX, INDXSZ)
+      SUBROUTINE CMUMPS_REDUCE_WRK(WRK, N, WRK_TH, NOMP_MAX)
+C     Called only when NOMP_MAX>0
+!$    USE OMP_LIB
       IMPLICIT NONE
-      INTEGER TMPSZ,INDXSZ 
-      REAL TMPD(TMPSZ)
+      INTEGER N,NOMP_MAX
+      REAL WRK(N), WRK_TH(N,NOMP_MAX)
+C     LOCAL VAR
+      INTEGER I, IOMP
+      REAL DZERO
+      PARAMETER(DZERO=0.0E0)
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
+!$    NOMP  = OMP_GET_MAX_THREADS()
+!$    CHUNK= max(K361/2, (N+NOMP-1) / NOMP )
+!$OMP   PARALLEL DO PRIVATE(I,IOMP) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1.AND.  N > K361 )
+      DO I=1,N
+         WRK(I) = DZERO
+         DO IOMP=1,NOMP_MAX
+           WRK(I) = WRK_TH(I,IOMP) +  WRK(I)
+         ENDDO
+      ENDDO      
+!$OMP END PARALLEL DO
+      RETURN
+      END SUBROUTINE CMUMPS_REDUCE_WRK
+      SUBROUTINE CMUMPS_REDUCE_WRK_MPI(WRK, N, WRK_TH, NOMP_MAX, 
+     &           INDX, INDXSZ)
+C     Called only when NOMP_MAX>0
+!$    USE OMP_LIB
+      IMPLICIT NONE
+      INTEGER N,NOMP_MAX,INDXSZ 
+      REAL WRK(N), WRK_TH(N,NOMP_MAX)
       INTEGER INDX(INDXSZ)
 C     LOCAL VAR
-      INTEGER I
+      INTEGER I, J, IOMP
       REAL DZERO
       PARAMETER(DZERO=0.0E0)
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
+!$      NOMP  = OMP_GET_MAX_THREADS()
+!$      CHUNK= max(K361/2, (INDXSZ+NOMP-1) / NOMP )
+!$OMP   PARALLEL DO PRIVATE(I,J,IOMP) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1.AND.  INDXSZ > K361 )
       DO I=1,INDXSZ
-         TMPD(INDX(I)) = DZERO
+         J = INDX(I)
+         WRK(J) = DZERO
+         DO IOMP=1,NOMP_MAX
+           WRK(J) = WRK_TH(J,IOMP) + WRK(J)
+         ENDDO
       ENDDO      
+!$OMP END PARALLEL DO
+      RETURN
+      END SUBROUTINE CMUMPS_REDUCE_WRK_MPI
+      SUBROUTINE CMUMPS_ZEROOUT(TMPD, TMPSZ, INDX, INDXSZ, 
+     &                          NOMP_MAX)
+!$    USE OMP_LIB
+      IMPLICIT NONE
+      INTEGER, INTENT(IN):: TMPSZ,INDXSZ, NOMP_MAX
+      REAL TMPD(TMPSZ)
+      INTEGER INDX(INDXSZ)
+C     LOCAL VAR
+      INTEGER I
+      REAL DZERO
+      PARAMETER(DZERO=0.0E0)
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP  = OMP_GET_MAX_THREADS()
+!$     CHUNK= max(K361/2, (INDXSZ+NOMP-1) / NOMP )
+!$    ENDIF
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,INDXSZ
+           TMPD(INDX(I)) = DZERO
+        ENDDO      
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1.AND.  INDXSZ > K361 )
+        DO I=1,INDXSZ
+           TMPD(INDX(I)) = DZERO
+        ENDDO      
+!$OMP END PARALLEL DO
+      ENDIF
       RETURN
       END SUBROUTINE CMUMPS_ZEROOUT
 C
@@ -509,7 +691,7 @@ C     SEPARATOR: Another function begins
 C
       SUBROUTINE CMUMPS_IBUINIT(IW, IWSZ, IVAL)
       IMPLICIT NONE
-      INTEGER IWSZ
+      INTEGER(8) :: IWSZ
 #if defined(WORKAROUNDINTELILP64MPI2INTEGER)
       INTEGER(4) IW(IWSZ)
       INTEGER(4) IVAL
@@ -517,8 +699,8 @@ C
       INTEGER IW(IWSZ)
       INTEGER IVAL
 #endif
-      INTEGER I
-      DO I=1,IWSZ
+      INTEGER(8) :: I
+      DO I=1_8,IWSZ
          IW(I)=IVAL
       ENDDO
       RETURN
@@ -535,10 +717,10 @@ C
      &     IWRK,IWRKSZ, SNDSZ, RCVSZ, COMM)
       IMPLICIT NONE
       INTEGER(8), INTENT(IN) :: NZ_loc
-      INTEGER, INTENT(IN)    :: IWRKSZ
+      INTEGER(8), INTENT(IN) :: IWRKSZ
       INTEGER, INTENT(IN) ::  MYID, NUMPROCS, ISZ, OSZ
       INTEGER, INTENT(IN) ::  COMM
-C     When INDX holds row indices O(ther)INDX hold col indices
+C     When INDX holds row indices O(ther)INDX holds col indices
       INTEGER, INTENT(IN) :: INDX(NZ_loc)
       INTEGER, INTENT(IN) :: OINDX(NZ_loc)
 C     On entry IPARTVEC(I) holds proc number with largest number of entries 
@@ -582,7 +764,7 @@ C      IF(ISZ>IWRKSZ) THEN ERROR
          SNDSZ(I) = 0
          RCVSZ(I) = 0
       ENDDO
-      DO I=1,IWRKSZ
+      DO I=1,max(ISZ,OSZ)
          IWRK(I) = 0
       ENDDO
 C
@@ -595,7 +777,7 @@ C     set SNDSZ
             PIND = IPARTVEC(IIND)
             IF(PIND .NE. MYID) THEN
 C              MYID will send row/col IIND to proc PIND 
-C              (PIND has the largest nb of entries in row/con IIND
+C              (PIND has the largest nb of entries in row/col IIND
                IF(IWRK(IIND).EQ.0) THEN
                   IWRK(IIND) = 1
                   SNDSZ(PIND+1) = SNDSZ(PIND+1)+1
@@ -926,18 +1108,22 @@ C     COMMUNICATE THE UPDATED ONES
       SUBROUTINE CMUMPS_CREATEPARTVECSYM(MYID, NUMPROCS, COMM,
      & IRN_loc, JCN_loc, NZ_loc,
      & IPARTVEC, ISZ,
-     & IWRK, IWSZ)
+     & IWRK, IWSZ, INUMMY)
+!$    USE OMP_LIB
       IMPLICIT NONE
       EXTERNAL CMUMPS_BUREDUCE
       INTEGER, INTENT(IN) :: MYID, NUMPROCS, COMM
-      INTEGER(8)          :: NZ_loc
-      INTEGER, INTENT(IN) :: ISZ, IWSZ
+      INTEGER(8)          :: NZ_loc, IWSZ
+      INTEGER, INTENT(IN) :: ISZ
       INTEGER, INTENT(IN) :: IRN_loc(NZ_loc), JCN_loc(NZ_loc)
 C
 C  OUTPUT
 C     IPARTVEC(I) = proc number with largest number of entries 
 C                in row/col I
+C     INUMMY = number of local rows/columns with
+C              at least one local entry (NUMPROCS .NE. 1 only)
       INTEGER, INTENT(OUT) :: IPARTVEC(ISZ)
+      INTEGER, INTENT(OUT) :: INUMMY
 C
 C  INTERNAL WORKING ARRAY
 C     IWRK (1:2*ISZ) is initialized to couples (MYID, Nb of entries
@@ -957,39 +1143,55 @@ C     LOCAL VARS
       INTEGER(8) :: I8
       INTEGER OP, IERROR
       INTEGER IR, IC
+      INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
 C
+      INUMMY = 0
+!$    NOMP=omp_get_max_threads()
+!$    CHUNK= max(K361/2, (ISZ+NOMP-1) / NOMP )
       IF(NUMPROCS.NE.1) THEN
 C     CHECK done outsize
 C     IF(IWSZ < 2*ISZ) THEN
 C     CHECK ENDS
          CALL MPI_OP_CREATE(CMUMPS_BUREDUCE, .TRUE., OP, IERROR)
 C     PERFORM THE REDUCTION
-#if defined(WORKAROUNDINTELILP64MPI2INTEGER)
-         CALL CMUMPS_IBUINIT(IWRK, 4*ISZ, int(ISZ,4))
-#else
-         CALL CMUMPS_IBUINIT(IWRK, 4*ISZ, ISZ)
-#endif
+!$OMP   PARALLEL DO PRIVATE(I) SCHEDULE(STATIC,CHUNK)
+!$OMP&  IF ( ISZ > K361 .AND. NOMP .GT. 1)
          DO I=1,ISZ
-            IWRK(2*I-1) = 0
-            IWRK(2*I) = MYID
+            IWRK(2_8*int(I,8)-1_8) = 0
+            IWRK(2_8*int(I,8)) = MYID
          ENDDO
+!$OMP   END PARALLEL DO
          DO I8=1_8,NZ_loc
             IR = IRN_loc(I8)
             IC = JCN_loc(I8)
             IF((IR.GE.1).AND.(IR.LE.ISZ).AND.
      &           (IC.GE.1).AND.(IC.LE.ISZ)) THEN
-               IWRK(2*IR-1) = IWRK(2*IR-1) + 1
-               IWRK(2*IC-1) = IWRK(2*IC-1) + 1
+               IWRK(2_8*int(IR,8)-1_8) = IWRK(2_8*int(IR,8)-1_8) + 1
+               IWRK(2_8*int(IC,8)-1_8) = IWRK(2_8*int(IC,8)-1_8) + 1
             ENDIF
          ENDDO
-         CALL MPI_ALLREDUCE(IWRK(1), IWRK(1+2*ISZ), ISZ,
+         CALL MUMPS_BIGALLREDUCE(.FALSE.,
+     &        IWRK(1), IWRK(1_8+2_8*int(ISZ,8)), ISZ,
      &        MPI_2INTEGER, OP, COMM, IERROR)      
+C       CHUNK computed in previous // do
+!$OMP   PARALLEL DO PRIVATE(I) SCHEDULE(STATIC,CHUNK)
+!$OMP&  IF ( ISZ > K361 .AND. NOMP .GT. 1)
+!$OMP&  REDUCTION(+:INUMMY)
          DO I=1,ISZ
-            IPARTVEC(I) = IWRK(2*I+2*ISZ)
+            IPARTVEC(I) = IWRK(2_8*int(I,8)+2_8*int(ISZ,8))
+C           Compute INUMMY directly
+            IF ( IPARTVEC(I) .EQ. MYID. OR.
+     &           IWRK(2_8*int(I,8)-1_8) .GT. 0 ) THEN
+              INUMMY=INUMMY+1
+            ENDIF
          ENDDO
+!$OMP   END PARALLEL DO
 C     FREE THE OPERATOR
          CALL MPI_OP_FREE(OP, IERROR)
       ELSE
+!$OMP   PARALLEL DO PRIVATE(I) SCHEDULE(STATIC,CHUNK)
+!$OMP&  IF ( ISZ > K361 .AND. NOMP .GT. 1)
          DO I=1,ISZ
             IPARTVEC(I) = 0
          ENDDO
@@ -1001,7 +1203,7 @@ C     FREE THE OPERATOR
      & IWRK,IWRKSZ, SNDSZ, RCVSZ, COMM)
       IMPLICIT NONE
       INTEGER(8), INTENT(IN) :: NZ_loc 
-      INTEGER, INTENT(IN)    :: IWRKSZ
+      INTEGER(8), INTENT(IN) :: IWRKSZ
       INTEGER, INTENT(IN)    :: MYID, NUMPROCS, ISZ
       INTEGER, INTENT(IN)    :: INDX(NZ_loc), OINDX(NZ_loc)
       INTEGER, INTENT(IN)    :: IPARTVEC(ISZ)
@@ -1044,7 +1246,7 @@ C      IF(ISZ>IWRKSZ) THEN ERROR
          SNDSZ(I) = 0
          RCVSZ(I) = 0
       ENDDO
-      DO I=1,IWRKSZ
+      DO I=1,ISZ
          IWRK(I) = 0
       ENDDO
 C
@@ -1057,7 +1259,7 @@ C     set SNDSZ
             PIND = IPARTVEC(IIND)
             IF(PIND .NE. MYID) THEN
 C              MYID will send row/col IIND to proc PIND 
-C              (PIND has the largest nb of entries in row/con IIND
+C              (PIND has the largest nb of entries in row/col IIND
                IF(IWRK(IIND).EQ.0) THEN
                   IWRK(IIND) = 1
                   SNDSZ(PIND+1) = SNDSZ(PIND+1)+1
@@ -1092,59 +1294,6 @@ C     number of row/col sent by MYID.
       ENDDO
       RETURN
       END SUBROUTINE CMUMPS_NUMVOLSNDRCVSYM
-      SUBROUTINE CMUMPS_FINDNUMMYROWCOLSYM(MYID, NUMPROCS, COMM,
-     &     IRN_loc, JCN_loc, NZ_loc,
-     &     PARTVEC, N,
-     &     INUMMYR,
-     &     IWRK, IWSZ)
-      IMPLICIT NONE
-      INTEGER MYID, NUMPROCS, N
-      INTEGER(8) :: NZ_loc
-      INTEGER IRN_loc(NZ_loc), JCN_loc(NZ_loc)
-      INTEGER PARTVEC(N)
-      INTEGER INUMMYR
-      INTEGER IWSZ
-      INTEGER IWRK(IWSZ)
-      INTEGER COMM
-C
-      INTEGER I, IR, IC
-      INTEGER(8) :: I8
-C check done outsize     
-C     IF(IWSZ < M) THEN ERROR
-C     IF(IWSZ < N) THEN ERROR
-      INUMMYR = 0
-C     MARK MY ROWS. FIRST COUNT,
-C          IF DYNAMIC MEMORY ALLOCATIOn WILL USED
-      DO I=1,N
-         IWRK(I) = 0
-         IF(PARTVEC(I).EQ.MYID) THEN
-            IWRK(I)=1
-            INUMMYR = INUMMYR + 1
-         ENDIF
-      ENDDO
-      DO I8=1_8,NZ_loc
-         IR = IRN_loc(I8)
-         IC = JCN_loc(I8)
-         IF((IR.GE.1).AND.(IR.LE.N).AND.
-     &        ((IC.GE.1).AND.(IC.LE.N))) THEN
-            IF(IWRK(IR) .EQ. 0) THEN
-               IWRK(IR)= 1
-               INUMMYR = INUMMYR + 1
-            ENDIF
-         ENDIF
-         IF((IR.GE.1).AND.(IR.LE.N).AND.
-     &        ((IC.GE.1).AND.(IC.LE.N))) THEN
-            IF(IWRK(IC).EQ.0) THEN
-               IWRK(IC)= 1
-               INUMMYR = INUMMYR + 1
-            ENDIF
-         ENDIF
-      ENDDO
-C     THE SMAME THING APPLIES FOR COLS
-C     No need to do anything
-C
-      RETURN
-      END SUBROUTINE CMUMPS_FINDNUMMYROWCOLSYM
       INTEGER FUNCTION CMUMPS_CHKCONVGLOSYM(D, N, INDXR, INDXRSZ,
      &     EPS, COMM)
       IMPLICIT NONE
@@ -1169,11 +1318,12 @@ C
      &     IRN_loc, JCN_loc, NZ_loc,
      &     PARTVEC, N,
      &     MYROWINDICES, INUMMYR,
-     &     IWRK, IWSZ  )
+     &     IWRK, IWSZ, NOMP_MAX )
+!$    USE OMP_LIB
       IMPLICIT NONE
-      INTEGER MYID, NUMPROCS, N
-      INTEGER(8) :: NZ_loc
-      INTEGER INUMMYR, IWSZ
+      INTEGER MYID, NUMPROCS, N, NOMP_MAX
+      INTEGER(8) :: NZ_loc, IWSZ
+      INTEGER INUMMYR
       INTEGER IRN_loc(NZ_loc), JCN_loc(NZ_loc)
       INTEGER PARTVEC(N)
       INTEGER MYROWINDICES(INUMMYR)
@@ -1182,21 +1332,36 @@ C
 C
       INTEGER I, IR, IC, ITMP
       INTEGER(8) :: I8
+      INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
+!$    IF (NOMP_MAX.GT.0) THEN
+!$      NOMP=omp_get_max_threads()
+!$      CHUNK= max(K361/2, (N+NOMP-1) / NOMP )
+!$    ENDIF
 C      
 C     MARK MY ROWS. 
-      DO I=1,N
-         IWRK(I) = 0
-         IF(PARTVEC(I).EQ.MYID) IWRK(I)=1
-      ENDDO
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,N
+           IWRK(I) = 0
+           IF(PARTVEC(I).EQ.MYID) IWRK(I)=1
+        ENDDO
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I) 
+!$OMP&  SCHEDULE(STATIC,CHUNK)
+!$OMP&  IF ( N > K361 .AND. NOMP .GT. 1)
+        DO I=1,N
+           IWRK(I) = 0
+           IF(PARTVEC(I).EQ.MYID) IWRK(I)=1
+        ENDDO
+!$OMP END PARALLEL DO
+      ENDIF
+C
       DO I8=1_8,NZ_loc
          IR = IRN_loc(I8)   
          IC = JCN_loc(I8)
          IF((IR.GE.1).AND.(IR.LE.N).AND.
      &        ((IC.GE.1).AND.(IC.LE.N))) THEN
             IF(IWRK(IR) .EQ. 0) IWRK(IR)= 1
-         ENDIF
-         IF((IR.GE.1).AND.(IR.LE.N).AND.
-     &        ((IC.GE.1).AND.(IC.LE.N))) THEN
             IF(IWRK(IC) .EQ.0) IWRK(IC)=1
          ENDIF
       ENDDO
diff -pruN 5.6.2-2.1/src/cfac_sispointers_m.F 5.7.1-1/src/cfac_sispointers_m.F
--- 5.6.2-2.1/src/cfac_sispointers_m.F	2023-10-11 09:37:10.000000000 +0000
+++ 5.7.1-1/src/cfac_sispointers_m.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/cfac_sol_l0omp_m.F 5.7.1-1/src/cfac_sol_l0omp_m.F
--- 5.6.2-2.1/src/cfac_sol_l0omp_m.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_sol_l0omp_m.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -15,7 +15,14 @@ C
       PRIVATE
       PUBLIC :: CMUMPS_INIT_L0_OMP_FACTORS
      &        , CMUMPS_FREE_L0_OMP_FACTORS
+#if ! defined(NO_SAVE_RESTORE)
      &        , CMUMPS_SAVE_RESTORE_L0FACARRAY
+#endif
+#if ! defined(NO_SAVE_RESTORE)
+#endif
+#if ! defined(NO_SAVE_RESTORE)
+      INCLUDE 'mumps_save_restore_modes.h'
+#endif
       CONTAINS
       SUBROUTINE CMUMPS_INIT_L0_OMP_FACTORS(id_L0_OMP_FACTORS)
       USE CMUMPS_STRUC_DEF, ONLY : CMUMPS_L0OMPFAC_T
@@ -48,6 +55,7 @@ C
       ENDIF
       RETURN
       END SUBROUTINE CMUMPS_FREE_L0_OMP_FACTORS
+#if ! defined(NO_SAVE_RESTORE)
       SUBROUTINE CMUMPS_SAVE_RESTORE_L0FACARRAY(L0_OMP_FACTORS
      &                 ,unit,MYID,mode
      &                 ,SIZE_GEST,SIZE_VARIABLES
@@ -59,7 +67,7 @@ C
       IMPLICIT NONE
       TYPE (CMUMPS_L0OMPFAC_T), DIMENSION(:), POINTER :: L0_OMP_FACTORS
       INTEGER,intent(IN)::unit,MYID
-      CHARACTER(len=*),intent(IN) :: mode
+      INTEGER,intent(IN) :: mode
       INTEGER,INTENT(OUT) :: SIZE_GEST
       INTEGER(8),intent(OUT) :: SIZE_VARIABLES
       INTEGER,intent(INOUT):: INFO(2)
@@ -79,7 +87,7 @@ C
       SIZE_GEST_L0FAC_ARRAY_j1=0
       SIZE_VARIABLES_L0FAC_ARRAY_j1=0
       NbRecords = 0
-      IF (trim(mode).EQ."memory_save") THEN
+      IF (mode.EQ.memory_save_mode) THEN
         IF (associated(L0_OMP_FACTORS)) THEN
           NbRecords      = 1 
           SIZE_GEST      = SIZE_INT 
@@ -87,7 +95,7 @@ C
           DO j1=1,size(L0_OMP_FACTORS)
             CALL CMUMPS_SAVE_RESTORE_L0FAC(
      &           L0_OMP_FACTORS(j1)
-     &           ,unit,MYID,"memory_save"
+     &           ,unit,MYID,memory_save_mode
      &           ,SIZE_GEST_L0FAC_ARRAY_j1
      &           ,SIZE_VARIABLES_L0FAC_ARRAY_J1
      &           ,SIZE_INT,SIZE_INT8,SIZE_ARITH_DEP
@@ -105,7 +113,7 @@ C
           SIZE_GEST      = 2*SIZE_INT
           SIZE_VARIABLES = 0
         ENDIF
-      ELSEIF (trim(mode).EQ."save") THEN
+      ELSEIF (mode.EQ.save_mode) THEN
         IF (associated(L0_OMP_FACTORS)) THEN
           NbRecords      = 1 
           SIZE_GEST      = SIZE_INT
@@ -120,7 +128,7 @@ C
           DO j1=1,size(L0_OMP_FACTORS)
             CALL CMUMPS_SAVE_RESTORE_L0FAC(
      &           L0_OMP_FACTORS(j1)
-     &           ,unit,MYID,"save"
+     &           ,unit,MYID,save_mode
      &           ,SIZE_GEST_L0FAC_ARRAY_J1
      &           ,SIZE_VARIABLES_L0FAC_ARRAY_J1
      &           ,SIZE_INT,SIZE_INT8,SIZE_ARITH_DEP
@@ -147,7 +155,7 @@ C
             endif
             IF ( INFO(1) .LT. 0 ) GOTO 100
         ENDIF
-      ELSE IF (trim(mode).EQ."restore") THEN
+      ELSE IF (mode.EQ.restore_mode) THEN
         NULLIFY(L0_OMP_FACTORS)
          read(unit,iostat=err) size_array1
          if(err.ne.0) THEN
@@ -181,7 +189,7 @@ C
            DO j1=1,size(L0_OMP_FACTORS)
              CALL CMUMPS_SAVE_RESTORE_L0FAC(
      &            L0_OMP_FACTORS(j1)
-     &            ,unit,MYID,"restore"
+     &            ,unit,MYID,restore_mode
      &            ,SIZE_GEST_L0FAC_ARRAY_J1
      &            ,SIZE_VARIABLES_L0FAC_ARRAY_J1
      &            ,SIZE_INT, SIZE_INT8, SIZE_ARITH_DEP
@@ -196,19 +204,19 @@ C
            ENDDO
          endif
       ENDIF
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          NbSubRecords=int(SIZE_VARIABLES/huge(I4))
          IF(NbSubRecords.GT.0) then
             NbRecords=NbRecords+NbSubRecords
          ENDIF
-      elseif(trim(mode).EQ."save") then
+      elseif(mode.EQ.save_mode) then
          size_written=size_written+SIZE_VARIABLES
      &        +int(SIZE_GEST,kind=8)
 #if defined(MUMPS_NOF2003)
          size_written=size_written
      &        +int(2*SIZE_INT*NbRecords,kind=8)
 #endif
-      elseif(trim(mode).EQ."restore") then
+      elseif(mode.EQ.restore_mode) then
          size_allocated=size_allocated+SIZE_VARIABLES
          size_read=size_read+SIZE_VARIABLES
      &        +int(SIZE_GEST,kind=8)
@@ -217,7 +225,7 @@ C
      &        +int(2*SIZE_INT*NbRecords,kind=8)
 #endif
       endif
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          SIZE_VARIABLES=SIZE_VARIABLES+SIZE_VARIABLES_L0FAC_ARRAY
          SIZE_GEST=SIZE_GEST+SIZE_GEST_L0FAC_ARRAY
 #if defined(MUMPS_NOF2003)
@@ -239,7 +247,7 @@ C
       IMPLICIT NONE
       TYPE (CMUMPS_L0OMPFAC_T) :: L0_OMP_FACTORS_1THREAD
       INTEGER,intent(IN)::unit,MYID
-      CHARACTER(len=*),intent(IN) :: mode
+      INTEGER,intent(IN) :: mode
       INTEGER,INTENT(OUT) :: Local_SIZE_GEST
       INTEGER(8),intent(OUT) :: Local_SIZE_VARIABLES
       INTEGER,intent(INOUT):: INFO(2)
@@ -252,9 +260,9 @@ C
       Local_SIZE_GEST = 0
       Local_SIZE_VARIABLES = 0_8
       Local_NbRecords = Local_NbRecords+1
-      IF (trim(mode) .EQ. "memory_save") THEN
+      IF (mode .EQ. memory_save_mode) THEN
         Local_SIZE_VARIABLES = Local_SIZE_VARIABLES + SIZE_INT8
-      ELSE IF (trim(mode) .EQ. "save") THEN
+      ELSE IF (mode .EQ. save_mode) THEN
         Local_SIZE_VARIABLES = Local_SIZE_VARIABLES + SIZE_INT8
         WRITE(unit,iostat=err) L0_OMP_FACTORS_1THREAD%LA
         IF (err .NE. 0) THEN
@@ -264,7 +272,7 @@ C
           GOTO 100
         ENDIF
         size_written=size_written+SIZE_INT8
-      ELSE IF (trim(mode) .EQ. "restore") THEN
+      ELSE IF (mode .EQ. restore_mode) THEN
         Local_SIZE_VARIABLES = Local_SIZE_VARIABLES + SIZE_INT8
         READ(unit,iostat=err) L0_OMP_FACTORS_1THREAD%LA
         IF (err .NE. 0) THEN
@@ -275,7 +283,7 @@ C
         ENDIF
         size_read=size_read+SIZE_INT8
       ENDIF
-      IF (trim(mode).EQ."memory_save") THEN
+      IF (mode.EQ.memory_save_mode) THEN
         IF (associated(L0_OMP_FACTORS_1THREAD%A)) THEN
           Local_NbRecords = Local_NbRecords + 2
           Local_SIZE_GEST = Local_SIZE_GEST + SIZE_INT8
@@ -286,7 +294,7 @@ C
           Local_SIZE_GEST = Local_SIZE_GEST + SIZE_INT8
           Local_SIZE_VARIABLES = Local_SIZE_VARIABLES + 0
         ENDIF
-      ELSEIF (trim(mode).EQ."save") THEN
+      ELSEIF (mode.EQ.save_mode) THEN
         IF (associated(L0_OMP_FACTORS_1THREAD%A)) THEN
           Local_NbRecords = Local_NbRecords + 2
           write(unit,iostat=err) int(0,8) 
@@ -317,7 +325,7 @@ C
           endif
           size_written=size_written+SIZE_INT8
         ENDIF
-      ELSEIF (trim(mode).EQ."restore") THEN
+      ELSEIF (mode.EQ.restore_mode) THEN
         NULLIFY(L0_OMP_FACTORS_1THREAD%A)
         READ(unit,iostat=err) itmp
         if(err.ne.0) THEN
@@ -356,15 +364,16 @@ C
         ENDIF
       ENDIF
 #if defined(MUMPS_NOF2003)
-      IF (trim(mode).EQ."memory_save") THEN
+      IF (mode.EQ.memory_save_mode) THEN
         Local_SIZE_GEST = Local_SIZE_GEST+2*SIZE_INT*Local_NbRecords
-      ELSE IF (trim(mode).EQ."save") THEN
+      ELSE IF (mode.EQ.save_mode) THEN
         size_written = size_written+2*SIZE_INT*Local_NbRecords
-      ELSE IF (trim(mode).EQ."restore") THEN
+      ELSE IF (mode.EQ.restore_mode) THEN
         size_read = size_read+2*SIZE_INT*Local_NbRecords
       ENDIF
 #endif
   100 CONTINUE
       RETURN
       END SUBROUTINE CMUMPS_SAVE_RESTORE_L0FAC
+#endif
       END MODULE CMUMPS_FACSOL_L0OMP_M
diff -pruN 5.6.2-2.1/src/cfac_sol_pool.F 5.7.1-1/src/cfac_sol_pool.F
--- 5.6.2-2.1/src/cfac_sol_pool.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_sol_pool.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -177,8 +177,6 @@ C
      &        ND(KEEP(28))
       EXTERNAL MUMPS_INSSARBR, MUMPS_ROOTSSARBR, CMUMPS_POOL_EMPTY
       LOGICAL MUMPS_INSSARBR, MUMPS_ROOTSSARBR, CMUMPS_POOL_EMPTY
-      EXTERNAL MUMPS_PROCNODE
-      INTEGER MUMPS_PROCNODE
       INTEGER NBINSUBTREE, NBTOP, INSUBTREE, INODE_EFF, MYID
       LOGICAL LEFT, ATOMIC_SUBTREE,UPPER,FLAG_MEM,SBTR_FLAG,PROC_FLAG
       LOGICAL FORCE_EXTRACT_TOP_SBTR
@@ -386,8 +384,6 @@ C
       INTEGER INODE,LPOOL,N,MYID,SLAVEF,PROC,MIN_PROC
       INTEGER POOL(LPOOL),KEEP(500),STEP(N),PROCNODE(KEEP(28))
       INTEGER(8) KEEP8(150)
-      INTEGER MUMPS_PROCNODE
-      EXTERNAL MUMPS_PROCNODE
       LOGICAL SBTR,FLAG_SAME_PROC
       INTEGER POS_TO_EXTRACT,NODE_TO_EXTRACT,NBTOP,I,INSUBTREE,
      &     NBINSUBTREE
diff -pruN 5.6.2-2.1/src/cfac_type3_symmetrize.F 5.7.1-1/src/cfac_type3_symmetrize.F
--- 5.6.2-2.1/src/cfac_type3_symmetrize.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cfac_type3_symmetrize.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/cini_defaults.F 5.7.1-1/src/cini_defaults.F
--- 5.6.2-2.1/src/cini_defaults.F	2023-10-11 09:37:10.000000000 +0000
+++ 5.7.1-1/src/cini_defaults.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -108,8 +108,9 @@ C     are set by CMUMPSID.  The elements
 C     and INFO provide information on the action of CMUMPS.
 C  
 C  CNTL(1) threshold for partial pivoting
-C     has default value 0.0 when SYM=1 and 0.01 otherwise
-C     Values and less than zero as treated as zero.
+C     has default -1.0 (automatic choice):
+C      0.1 in case of rank-revealing (ICNTL(56)=1,2)
+C      otherwise  0.0 when SYM=1 and 0.01 otherwise.
 C     Values greater than 1.0 are treated as 1.0 for
 C     SYM=1 and as 0.5 for SYM=2
 C     In general, a larger value of CNTL(1) leads to 
@@ -127,6 +128,7 @@ C     Default value is sqrt(macheps).
 C     Values less than zero are treated as sqrt(macheps).
 C
 C  CNTL(3) is used with null pivot row detection (ICNTL(24) .eq. 1)
+C     and/or with Rank-Revealing (RR) option (ICNTL(56)).
 C     Default value is 0.0. 
 C     Let A_{preproc} be the preprocessed matrix to be factored (see
 C       equation in the user's guide).
@@ -135,6 +137,35 @@ C     row/column is smaller than a thres
 C     machine precision and ||.|| be the infinite norm.
 C     The absolute value to detect a null pivot row (when ICNTL(24) .EQ.1) 
 C     is stored in DKEEP(1).
+C     In case of RR, CNTL(3) will define the thresholds for :
+C      
+C       - Postponing pseudo singularities (SEUIL):
+C         The computed threshold value for postponing pivots
+C         is stored in "SEUIL" and then "SEUIL_LDLT_NIV2"
+C         which are identical in current version.
+C
+C       - Defining singularities on root (DKEEP(9))
+C
+C       - Defining null pivot rows if ICNTL(24).EQ.1 (DKEEP(1)) 
+C         in this case DKEEP(1) must be smaller than DKEEP(9)
+C
+C     IF (ICNTL(56).NE.0) THEN 
+C      RR on root is active 
+C      IF  (CNTL3 .LT. ZERO) THEN
+C          DKEEP(9) = abs(CNTL(3))
+C      ELSE IF  (CNTL3 .GT. ZERO) THEN
+C          DKEEP(9) = CNTL3*||A_{preproc}||
+C      ELSE  !  (CNTL(3) .EQ. ZERO) THEN
+C          DKEEP(9) = sqrt(N_h)*MACHEPS*||A_{preproc}||  
+C          where Nh is the number of pivots on the deepest branch
+C          of the elimination tree.
+C      ENDIF
+C      IF (ICNTL(24).EQ.1) THEN
+C       null pivot detection
+C         DKEEP(1) = DKEEP(9)*DKEEP(10)
+C      ENDIF
+C
+C     ELSE (ONLY NULL PIVOT detection is active) 
 C      IF CNTL(3)  > 0 THEN
 C          DKEEP(1) = CNTL(3)  ||A_{preproc}|| 
 C      ELSE IF CNTL(3)  = 0.0 THEN 
@@ -143,6 +174,7 @@ C      ELSE IF CNTL(3)  < 0 THEN
 C          DKEEP(1) = abs(CNTL(3))! this was added for EDF 
 C                                 ! in the context of SOLSTICE project
 C      ENDIF
+C     ENDIF
 C
 C  CNTL(4) must be set to value for static pivoting.
 C     Default value is -1.0
@@ -387,6 +419,9 @@ C               The order of the root no
 C            ENDIF
 C            If ICNTL(13) .EQ. -1 then splitting of the root
 C            is done whatever the nb of procs is. 
+C            Authorizing extra root spliting during analysis might be
+C            interesting to further split the root node (combined for 
+C            example with null pivot detection option ICNTL(24)=1 OR ICNTL(56))
 C             
 C            To summarize:
 C               -1         : root splitting and scalapack on
@@ -647,12 +682,14 @@ C            For all other values, the d
 C            null pivots and static pivots are excluded from the
 C            computation of the determinant.
 C
+#if ! defined(NO_SAVE_RESTORE)
 C   ICNTL(34) Must be set before a call to MUMPS with JOB=-3 in case
 C             the save/restore feature was used and user wants to clean
 C             save/restore files (and possibly OOC files). 
 C             ICTNL(34)=0 => user wants to be able to restore instance later
 C             ICTNL(34)=1 => user will not restore the instance again (clean
 C                            to be done)
+#endif
 C
 C    ICNTL(35) : Block Low-Rank (BLR) functionality, 
 C                need be set before analysis
@@ -697,6 +734,25 @@ C                Between 0 and 1000; oth
 C                corresponds to an estimated compression rate of
 C                ICNTL(39)/1000%.
 C                Default value: 500 (50.0% compression rate).
+C
+C  ICNTL(56) has default value 0 and is only accessed by the host.
+C      During the analysis phase, a positive value prepares the data for
+C       later use of null space functionalities (saved in KEEP(53)).
+C       (the tree is modified to have only one root in analysis)
+C       If ICNTL(56) is negative or zero, null space feature will
+C       be forbidden during the factorization phase.
+C      During the factorization phase, if ICNTL(56) was positive 
+C      (KEEP(53)>0) for analysis, then the values of ICNTL(56) (saved
+C      in KEEP(19)) have the following meaning.
+C          0: No null space analysis,
+C          1: Null space analysis on last root node using SVD,
+C          2: Null space analysis on last root node using QR,
+C
+C       The singular values (ICNTL(56)=1) or the diagonal entries of R
+C       (ICNTL(56)=2) are available in root%SINGULAR_VALUES
+C
+C
+C
 C 
 C   ICNTL(58): strategy for symbolic factorization used
 C              with centralized ordering based on METIS (ICNTL(7)=5)
@@ -782,6 +838,10 @@ C  INFO(18)  On exit to factorization:
 C              Local number of null pivots (ICNTL(24)=1) 
 C              on the local processor even on master. 
 C              (local size of array PIVNUL_LIST).
+C              Note that it also includes null pivots 
+C              that might have been further detected on 
+C              the root if ICNTL(56).NE.0. and root 
+C              processed by MYID
 C
 C  INFO(19) - after analysis: 
 C           Estimated size of the main internal integer workarray IS
@@ -858,7 +918,7 @@ C     for the elimination process on the
 C
 C  RINFOG(3)  Number of floating-point operations
 C     for the elimination process on all processors.
-C
+C  
 C----------------------------------------------------
 C Statistics produced after solve with error analysis
 C----------------------------------------------------
@@ -919,6 +979,25 @@ C
 C  RINFOG(21) -  after factorization: largest pivot in absolute 
 C             value selected during factorization of the preprocessed
 C             matrix A_pre.
+C  
+C  RINFOG(22) - after factorization: 
+C             total number of floating-point operations offloaded to 
+C             the accelerator(s) by all MPI processes (see RINFO(9))
+C
+C  RINFOG(23) - after factorization: average (over all MPI processes) 
+C            time spent in operations offloaded to the accelerators
+C            including communication (see RINFO(10)).
+C
+C  Computed when solve involves exploit sparsity (fwd and/or bwd)
+C  here we only report off diagonal flops)
+C
+#if defined(STAT_ES_SOLVE)
+C  RINFOG(24) - FR FLOPS (off diagonal flops)
+C  RINFOG(25) - FR FLOPS (off diag) with Exploit sparsity 
+C               (possibly with nb_sparse algo used)
+#endif
+C
+C
 C===========================
 C DESCRIPTION OF KEEP8 ARRAY
 C===========================
@@ -926,6 +1005,8 @@ C
 C   KEEP8 is a 64-bit integer array of length 150 that need not
 C   be set by the user
 C
+#if ! defined(NO_SAVE_RESTORE)
+#endif
 C===========================
 C DESCRIPTION OF KEEP ARRAY
 C===========================
@@ -972,11 +1053,8 @@ C     Only options 0, 1, or 2 are availa
 C     -------------------------------------
       IF ( KEEP(50).NE.1 .and. KEEP(50).NE.2 ) KEEP( 50 ) = 0
 C     threshold value for pivoting
-      IF ( KEEP(50) .NE. 1 ) THEN
-        CNTL(1)   = 0.01E0
-      ELSE
-        CNTL(1)   = 0.0E0
-      END IF
+C     Automatic choice depending on (SYM and ICNTL(56))
+      CNTL(1) = -1.0E0
       CNTL(2) = sqrt(epsilon(0.0E0))
       CNTL(3) = 0.0E0
       CNTL(4) = -1.0E0
@@ -1067,6 +1145,14 @@ C     Default BLR compression rate of fa
       ICNTL(38) = 600
 C     Default BLR compression rate of factors (50%)
       ICNTL(39) = 500
+C     L0-thread feature
+#if defined(_OPENMP)
+C     Activate L0OMP
+      ICNTL(48) = 1
+#else
+C     Do not activate L0OMP
+      ICNTL(48) = 0
+#endif
       ICNTL(55) = 0
       ICNTL(56) = 0
       ICNTL(57) = 0
@@ -1092,7 +1178,7 @@ C===================================
         KEEP(6)  = 32
         KEEP(9)  = 700
         KEEP(85) =  300
-        KEEP(62) =  50
+        KEEP(62) =  10
       ELSE
         KEEP(4)  = 24
         KEEP(3)  = 96
@@ -1100,8 +1186,9 @@ C===================================
         KEEP(6)  = 32
         KEEP(9)  = 400
         KEEP(85) = 100
-        KEEP(62) = 50
+        KEEP(62) = 10
       END IF
+        KEEP(11)=200
       KEEP(63) = 60
       KEEP(48) = 5
       CALL CMUMPS_SET_TYPE_SIZES( KEEP(34), KEEP(35),
@@ -1130,36 +1217,24 @@ C     Forcing proportional is ok with st
       KEEP(75) = 1
       KEEP(76) = 2
       KEEP(77) = 30
+      KEEP(78)= -1
       KEEP(79) = 0  ! old splitting
-      IF (NSLAVES.GT.4) THEN
-          KEEP(78)=max(
-     &       int(log(real(NSLAVES))/log(real(2))) - 2 
-     &       , 0         )
-      ENDIF
       KEEP(210) = 2 
       KEEP8(79) = -10_8
       KEEP(80) = 1
       KEEP(81) = 0
-      KEEP(82) = 30
-      KEEP(83) = min(8,NSLAVES/4)
-      KEEP(83) = max(min(4,NSLAVES),max(KEEP(83),1))
+      IF (SYM.EQ.0) THEN
+       KEEP(82)= 15
+      ELSE
+       KEEP(82) = 10
+      ENDIF
+      KEEP(83) = -1
       KEEP(86)=1
       KEEP(87)=0
       KEEP(88)=0
       KEEP(90)=1
-      KEEP(91)=min(8, NSLAVES)
-      KEEP(91) = max(min(4,NSLAVES),min(KEEP(83),KEEP(91)))
-      IF(NSLAVES.LT.48)THEN
-         KEEP(102)=150
-      ELSEIF(NSLAVES.LT.128)THEN
-         KEEP(102)=150
-      ELSEIF(NSLAVES.LT.256)THEN
-         KEEP(102)=200
-      ELSEIF(NSLAVES.LT.512)THEN
-         KEEP(102)=300
-      ELSEIF(NSLAVES.GE.512)THEN
-         KEEP(102)=400
-      ENDIF
+      KEEP(91)= -1
+      KEEP(102)= -1
 #if defined(OLD_OOC_NOPANEL)
       KEEP(99)=0  ! no panel -> synchronous / no buffer
 #else
@@ -1174,6 +1249,8 @@ C     strategy for MUMPS_BLOC2_GET_NSLAV
       KEEP(119)=0
 C     Scaling is enabled by default with the Schur complement option
       KEEP(125)=1
+C     Columns of LMAT handled by block of size KEEP(147)
+      KEEP(147)=20000
 C     More amalgamation of tiny fronts
       KEEP(197)=1
 C     KEEP(199) for MUMPS_PROCNODE, MUMPS_TYPENODE, etc
@@ -1190,6 +1267,9 @@ C     allocate id%S later otherwise.
       KEEP(107)=0
       KEEP(121)=-999999
       KEEP(122)=15
+C     Size of CB for which we want to force BLR compressCB
+C     even if NASS is small.
+      KEEP(123)=10000
        KEEP(141)=1 ! min needed
       KEEP(206)=1 
       KEEP(207) = 1
@@ -1203,7 +1283,11 @@ C     allocate id%S later otherwise.
       KEEP(215)=0
       KEEP(216)=1
       KEEP(218)=250
-      KEEP(219)=1
+      IF (SYM.EQ.2) THEN
+       KEEP(219)=1
+      ELSE
+       KEEP(219)=0
+      ENDIF
       IF (KEEP(50).EQ.2) THEN
         KEEP(227)= max(2,32)
       ELSE
@@ -1221,7 +1305,7 @@ C     allocate id%S later otherwise.
                         ! (default value is 10 set in fac_driver.F)
       DKEEP(24) = 1000.0E0 ! gap should be larger than dkeep(14)
       DKEEP(25) = 10.0E0 ! gap precision
-      DKEEP(22) = 0.2E0 ! to check for slow convergence
+      DKEEP(22) = 0.5E0 ! to check for slow convergence
       KEEP(238)=18
       KEEP(234)= 1
       KEEP(235)=-1
@@ -1229,9 +1313,11 @@ C     allocate id%S later otherwise.
       DKEEP(18)= 1.0E12
       KEEP(242) = -9
       KEEP(243) = -1
+      KEEP(255)=100
+      KEEP(281) = 0
 C     Parallel analysis compatible with analysis by blocks
 C                       and detection out-of-range 
-      KEEP(339)= 6
+      KEEP(339)= 1
       KEEP(249)=1
 !$    KEEP(249) = OMP_GET_MAX_THREADS()
       KEEP(250) = 1
@@ -1249,17 +1335,20 @@ C                       and detection ou
       KEEP(363) = 512
       KEEP(364) = 32768
       KEEP(378) = 1
-C     OMP parallelization of arrowheads
       KEEP(399) = 1
       KEEP(397) = -1
-#if defined(__ve__)
-      KEEP(401) = 1
-#else
-      KEEP(401) = 0
-#endif
       KEEP(402) = 1
       KEEP(405) = 0 ! 1 under L0OMP
       KEEP(406) = 2 
+#if defined(__PGLLVM__)
+C     With aocc version of Classic flang, we want to
+C     avoid an OpenMP bug during L0thread copies by
+C     switching to simpler copy algorithm.
+C     Since we cannot test __aocc__ in Fortran, we rely on the
+C     slower algorithm as soon as __PGLLVM__ is detected, even
+C     if this is "too careful".
+      KEEP(406)=0
+#endif
 C     0.9 equilibration
       KEEP(408) = 90
       KEEP(420) =  4*KEEP(6)   ! if KEEP(6)=32 then 128
@@ -1306,11 +1395,10 @@ C     probably a cache miss on the pivot
       KEEP(490) = 128
       KEEP(491) = 1000
 #if defined(__ve__)
-      KEEP(491)=512
+      KEEP(490)=512
       KEEP(491)=8000
 #endif
       KEEP(492) = 1
-      KEEP(82) = 30
       KEEP(493) = 0
       KEEP(496) = 1
       KEEP(495) = -1
@@ -1330,6 +1418,8 @@ C
          id%KEEP(5)=1
          id%KEEP(6)=2
          id%KEEP(9)=3
+C        KEEP(11) not too small either
+         id%KEEP(11)=3
          id%KEEP(39)=300
          id%KEEP(7) = 3
          id%KEEP(8) = 2
@@ -1342,6 +1432,8 @@ C
          id%KEEP(85)=-4
          id%KEEP(62) = 2  
          id%KEEP(1)  = 1   
+         id%KEEP(123) = 6
+         id%KEEP(147) = 3
          id%KEEP(197)  = 0
          id%KEEP(51) = 2
 !$       id%KEEP(360) = 2
@@ -1356,15 +1448,9 @@ C
          id%ICNTL(27)=-3
          id%KEEP(227)=3
          id%KEEP(30) = 1000
-#if defined(_OPENMP)
-C        Activate L0OMP with test_mumps in case KEEP(72)=1,
-C        but only if compiilation is with OpenMP
-         id%KEEP(401) = 1
-#endif
       ELSE IF (id%KEEP(72)==2) THEN
          id%KEEP(85)=2            ! default is 
          id%KEEP(85)=-10000         ! default is 160 
-         id%KEEP(62) = 10       ! default is 50
          id%KEEP(210) = 1       ! defaults is 0 (automatic)
          id%KEEP8(79) = 160000_8   
          id%KEEP(1) = 2  ! default is 8
diff -pruN 5.6.2-2.1/src/cini_driver.F 5.7.1-1/src/cini_driver.F
--- 5.6.2-2.1/src/cini_driver.F	2023-10-11 09:37:10.000000000 +0000
+++ 5.7.1-1/src/cini_driver.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -31,6 +31,10 @@ C
       INTEGER MASTER, IERR,PAR_loc,SYM_loc
       PARAMETER( MASTER = 0 )
       INTEGER color
+#if defined(metis) || defined(parmetis)
+      INTEGER I
+#endif
+      INTEGER(8) :: I8
 C     -----------------------------
 C     Initialize MPI related data
 C     -----------------------------
@@ -88,8 +92,10 @@ C     ----------------------------------
       CALL MUMPS_SET_VERSION( id%VERSION_NUMBER )
       id%OOC_TMPDIR="NAME_NOT_INITIALIZED"
       id%OOC_PREFIX="NAME_NOT_INITIALIZED"
+#if ! defined(NO_SAVE_RESTORE)
       id%SAVE_DIR="NAME_NOT_INITIALIZED"
       id%SAVE_PREFIX="NAME_NOT_INITIALIZED"
+#endif
 C     Default value for NRHS is 1
       id%NRHS = 1
 C     Leading dimension will be reset to id%N is CMUMPS_SOL_DRIVER
@@ -118,13 +124,11 @@ C     set to default options
 C     Useful size is 40  
 C     This sets the default values
       CALL METIS_SETDEFAULTOPTIONS(id%METIS_OPTIONS)
-C     This number, 18, corresponds to METIS_OPTIONS_NUMBERING which
-C     tells METIS to use fortran numbering and is found in metis.h
-C     In Metis 5.0.3 and Parmetis 4.0.2, METIS_OPTIONS_NUMBERING 
-C     was METIS_OPTIONS(17). MUMPS doesnot support those versions anymore.
-C     To use them, just change METIS_OPTIONS(18) into METIS_OPTIONS(17)
-C     like that: METIS_OPTIONS(17) = 1
-      id%METIS_OPTIONS(18) = 1
+      CALL MUMPS_METIS_OPTION_NUMBERING(I)
+C     The value of I corresponds to "METIS_OPTION_NUMBERING", which tells
+C     METIS to use Fortran numbering. METIS_OPTION_NUMBERING is defined
+C     in metis.h and accessed through a C wrapper.
+      id%METIS_OPTIONS(I+1) = 1 ! +1 for Fortran indexing
 #endif
 #endif      
 C
@@ -154,6 +158,8 @@ C
       NULLIFY(id%RHS_loc)
       NULLIFY(id%COLSCA)
       NULLIFY(id%ROWSCA)
+      NULLIFY(id%ROWSCA_loc)
+      NULLIFY(id%COLSCA_loc)
       NULLIFY(id%PERM_IN)
       NULLIFY(id%IS)
       NULLIFY(id%STEP)
@@ -198,10 +204,11 @@ C     Info for pruning tree
       NULLIFY(id%MY_FIRST_LEAF)
       NULLIFY(id%MY_NB_LEAF)
       NULLIFY(id%COST_TRAV)
-      NULLIFY(id%RHSCOMP)
-      NULLIFY(id%POSINRHSCOMP_ROW)
-      NULLIFY(id%POSINRHSCOMP_COL)
-      id%POSINRHSCOMP_COL_ALLOC = .FALSE.
+      NULLIFY(id%RHSINTR)
+      id%LD_RHSINTR = 0
+      NULLIFY(id%GLOB2LOC_RHS)
+      NULLIFY(id%GLOB2LOC_SOL)
+      id%GLOB2LOC_SOL_ALLOC = .FALSE.
 C
 C     Out of Core management related data
 C
@@ -215,7 +222,7 @@ C
       NULLIFY(id%LRGROUPS)
       NULLIFY(id%FDM_F_ENCODING)
       NULLIFY(id%BLRARRAY_ENCODING)
-      NULLIFY(id%MPITOOMP_PROCS_MAP)
+      NULLIFY(id%MTKO_PROCS_MAP)
 C     Must be nullified because of routine
 C     CMUMPS_SIZE_IN_STRUCT
       NULLIFY(id%CB_SON_SIZE)
@@ -286,6 +293,14 @@ C
 C
 C     Initializations for Rank detection/null space
 C
+C         -----------------------------
+C         RCOND is a threshold such that:
+C                   A * P = Q * [ R11 R12 ]
+C                               [  0  R22 ]
+C         with R11 defined as the largest leading submatrix whose estimated
+C         condition number is less than 1/RCOND.
+C         -------------------------------------------
+      id%ROOT%QR_RCOND = 1.0E-06
       NULLIFY(id%SINGULAR_VALUES)
       CALL CMUMPS_RR_INIT_POINTERS(id)
 C     Architecture data
@@ -313,5 +328,21 @@ C     ----------------------------------
       ELSE
           id%MYID_NODES = -464646
       ENDIF
+C
+C     Check that KEEP(34), the size of a Fortran INTEGER,
+C     as initialized above during CMUMPSID
+C     matches the size of an integer in C. If not,
+C     raise an error immediately.
+C
+      CALL MUMPS_INT_SIZE_C(I8)
+      IF (int(I8) .NE. id%KEEP(34)) THEN
+        id%INFO(1)=-69
+        id%INFO(2)=int(I8) ! size of MUMPS_INT
+C       Installation problem!
+C       WRITE on unit 6 since ICNTL(1:4) are not set by the user yet
+        IF (id%MYID .EQ. 0) WRITE(6,995) int(I8)
+ 995    FORMAT(' Installation error -69: ',
+     &' MUMPS_INT size (',I4,') incompatible with INTEGER size')
+      ENDIF
       RETURN
       END SUBROUTINE CMUMPS_INI_DRIVER
diff -pruN 5.6.2-2.1/src/clr_core.F 5.7.1-1/src/clr_core.F
--- 5.6.2-2.1/src/clr_core.F	2023-10-11 09:37:10.000000000 +0000
+++ 5.7.1-1/src/clr_core.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -41,8 +41,9 @@ C
       SUBROUTINE IS_FRONT_BLR_CANDIDATE(INODE, NIV, NFRONT, NASS, 
      &                    BLRON, K489,
      &                    K490, K491, K492, K20, K60, IDAD, K38,
-     &                    LRSTATUS, K280, LRGROUPS)
-        INTEGER,INTENT(IN) :: INODE, NFRONT, NASS, BLRON, K489, K490,
+     &                    K123, LRSTATUS, K280, LRGROUPS)
+        INTEGER,INTENT(IN) :: INODE, NFRONT, NASS, BLRON, K123,
+     &                        K489, K490,
      &                        K491, K492, NIV, K20, K60, IDAD, K38
         INTEGER,INTENT(OUT):: LRSTATUS 
         INTEGER, INTENT(IN):: K280
@@ -180,8 +181,9 @@ C
         ENDIF
       END SUBROUTINE ALLOC_LRB_FROM_ACC
       SUBROUTINE REGROUPING2(CUT, NPARTSASS, NASS,
-     &                   NPARTSCB, NCB, IBCKSZ, ONLYCB, K472)
-        INTEGER, INTENT(IN) :: IBCKSZ, NASS, NCB
+     &                   NPARTSCB, NCB, IBCKSZ, ONLYCB, K472, 
+     &                   NFRONT, KEEP)
+        INTEGER, INTENT(IN) :: IBCKSZ, NASS, NCB, NFRONT, KEEP(500)
         INTEGER, INTENT(INOUT) :: NPARTSCB, NPARTSASS
         INTEGER, POINTER, DIMENSION(:) :: CUT
         INTEGER, POINTER, DIMENSION(:) :: NEW_CUT
@@ -197,8 +199,9 @@ C
      &          ' not enough memory? memory requested = ' , IERROR
            RETURN
         ENDIF
-        CALL COMPUTE_BLR_VCS(K472, IBCKSZ2, IBCKSZ, NASS)
-        MINSIZE = int(IBCKSZ2 / 2)
+        CALL COMPUTE_BLR_VCS(K472, IBCKSZ2, IBCKSZ, NASS, 
+     &                       NFRONT, KEEP(35))
+        MINSIZE = int(IBCKSZ2 / 3)
         NEW_NPARTSASS = max(NPARTSASS,1)
         IF (.NOT. ONLYCB) THEN
            NEW_CUT(1) = 1
@@ -435,7 +438,6 @@ CC
      &                          Y_RRQR(:,:)
         INTEGER, ALLOCATABLE :: JPVT_RRQR(:)
         INTEGER :: allocok, MREQ
-        REAL, EXTERNAL ::scnrm2
         COMPLEX :: ONE, MONE, ZERO
         PARAMETER (ONE=(1.0E0,0.0E0), MONE=(-1.0E0,0.0E0))
         PARAMETER (ZERO=(0.0E0,0.0E0))
@@ -875,10 +877,10 @@ C     Alloc NOT ok!!
         INTEGER(8), INTENT(IN) :: POSELTT
         INTEGER,intent(in) :: MIDBLK_COMPRESS, KPERCENT_RMB
         REAL, intent(in) :: TOLEPS
-        REAL,    ALLOCATABLE :: RWORK_RRQR(:)
-        COMPLEX, ALLOCATABLE :: WORK_RRQR(:), TAU_RRQR(:)
-        COMPLEX, ALLOCATABLE, DIMENSION(:,:), TARGET :: Q1, R1, 
-     &                                                  Q2, R2
+        REAL,    ALLOCATABLE:: RWORK_RRQR(:)
+        COMPLEX, ALLOCATABLE:: WORK_RRQR(:), TAU_RRQR(:)
+        COMPLEX, ALLOCATABLE, DIMENSION(:,:),TARGET:: Q1, R1,
+     &                                                Q2, R2
         INTEGER, ALLOCATABLE :: JPVT_RRQR(:)
         TYPE(LRB_TYPE)       :: LRB1, LRB2
         INTEGER :: INFO, RANK1, RANK2, RANK, MAXRANK, LWORK
diff -pruN 5.6.2-2.1/src/clr_stats.F 5.7.1-1/src/clr_stats.F
--- 5.6.2-2.1/src/clr_stats.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/clr_stats.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/clr_type.F 5.7.1-1/src/clr_type.F
--- 5.6.2-2.1/src/clr_type.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/clr_type.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/cmumps_comm_buffer.F 5.7.1-1/src/cmumps_comm_buffer.F
--- 5.6.2-2.1/src/cmumps_comm_buffer.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cmumps_comm_buffer.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -13,7 +13,7 @@ C  https://cecill.info/licences/Licence_
 C
         MODULE CMUMPS_BUF
         PRIVATE
-        PUBLIC :: CMUMPS_BUF_TRY_FREE_CB, CMUMPS_BUF_INIT,
+        PUBLIC :: CMUMPS_BUF_INIT,
      &   CMUMPS_BUF_INI_MYID,
      &   CMUMPS_BUF_ALLOC_CB ,       CMUMPS_BUF_DEALL_CB ,
      &   CMUMPS_BUF_ALLOC_SMALL_BUF, CMUMPS_BUF_DEALL_SMALL_BUF,
@@ -52,34 +52,6 @@ C
      &       , SAVE, TARGET :: BUF_MAX_ARRAY
         PUBLIC :: BUF_LMAX_ARRAY, BUF_MAX_ARRAY
       CONTAINS
-        SUBROUTINE CMUMPS_BUF_TRY_FREE_CB()
-        CALL CMUMPS_BUF_TRY_FREE(BUF_CB)
-        RETURN
-        END SUBROUTINE CMUMPS_BUF_TRY_FREE_CB
-        SUBROUTINE CMUMPS_BUF_TRY_FREE(B)
-        IMPLICIT NONE
-        TYPE ( CMUMPS_COMM_BUFFER_TYPE ) :: B
-        INCLUDE 'mpif.h'
-        LOGICAL :: FLAG
-        INTEGER :: IERR_MPI
-        INTEGER :: STATUS(MPI_STATUS_SIZE)
-        IF ( B%HEAD .NE. B%TAIL ) THEN
- 10       CONTINUE
-          CALL MPI_TEST( B%CONTENT( B%HEAD + REQ ), FLAG,
-     &                   STATUS, IERR_MPI )
-          IF ( FLAG ) THEN
-            B%HEAD = B%CONTENT( B%HEAD + NEXT )
-            IF ( B%HEAD .EQ. 0 ) B%HEAD = B%TAIL
-            IF ( B%HEAD .NE. B%TAIL ) GOTO 10
-          END IF
-        END IF
-        IF ( B%HEAD .EQ. B%TAIL ) THEN
-          B%HEAD = 1
-          B%TAIL = 1
-          B%ILASTMSG = 1
-        END iF
-        RETURN
-        END SUBROUTINE CMUMPS_BUF_TRY_FREE
         SUBROUTINE CMUMPS_BUF_INI_MYID( MYID )
         IMPLICIT NONE
         INTEGER MYID
@@ -319,7 +291,7 @@ C
           ENDIF
         ENDIF
         IF (NBROWS_PACKET + NBROWS_ALREADY_SENT.NE.LCONT .AND.
-     &     SIZE_PACK  .LT. SIZE_RBUF_BYTES / 4
+     &     SIZE_PACK  .LT. SIZE_RBUF_BYTES / 10
      &    .AND. 
      &    .NOT. RECV_BUF_SMALLER_THAN_SEND)
      &       THEN
@@ -499,16 +471,16 @@ C
         SUBROUTINE CMUMPS_BUF_SEND_VCB( NRHS_B, NODE1, NODE2, NCB, LDW,
      &             LONG,
      &             IW, W, JBDEB, JBFIN,
-     &             RHSCOMP, NRHS, LRHSCOMP, IPOSINRHSCOMP, NPIV,
+     &             RHSINTR, NRHS, LRHSINTR, IPOSINRHSINTR, NPIV,
      &             KEEP,
      &             DEST, TAG, COMM, IERR )
         IMPLICIT NONE
         INTEGER LDW, DEST, TAG, COMM, IERR
         INTEGER NRHS_B, NODE1, NODE2, NCB, LONG, JBDEB, JBFIN
         INTEGER IW( max( 1, LONG ) )
-        INTEGER, INTENT(IN) :: LRHSCOMP, NRHS, IPOSINRHSCOMP, NPIV
+        INTEGER, INTENT(IN) :: LRHSINTR, NRHS, IPOSINRHSINTR, NPIV
         COMPLEX W( max( 1, LDW * NRHS_B ) )
-        COMPLEX RHSCOMP(LRHSCOMP,NRHS)
+        COMPLEX RHSINTR(LRHSINTR,NRHS)
         INTEGER, INTENT(INOUT) :: KEEP(500)
         INCLUDE 'mpif.h'
         INTEGER :: IERR_MPI
@@ -566,7 +538,7 @@ C
           IF (NODE2.EQ.0) THEN
             DO K=1, NRHS_B
               IF (NPIV.GT.0) THEN
-              CALL MPI_PACK( RHSCOMP(IPOSINRHSCOMP,JBDEB+K-1), NPIV,
+              CALL MPI_PACK( RHSINTR(IPOSINRHSINTR,JBDEB+K-1), NPIV,
      &                          MPI_COMPLEX,
      &                          BUF_CB%CONTENT( IPOS ), SIZE,
      &                          POSITION, COMM, IERR_MPI )
@@ -653,14 +625,13 @@ C
         FLAG = ( B%HEAD == B%TAIL )
         RETURN
         END SUBROUTINE CMUMPS_BUF_EMPTY
-        SUBROUTINE CMUMPS_BUF_SIZE_AVAILABLE( B, SIZE_AV )
+        SUBROUTINE CMUMPS_BUF_FREEREQUESTS( B )
         IMPLICIT NONE
         TYPE ( CMUMPS_COMM_BUFFER_TYPE ) :: B
-        INTEGER SIZE_AV
         INCLUDE 'mpif.h'
-        INTEGER :: IERR_MPI
+        INTEGER :: IERR_MPI, CURRENT, LAST_NOT_FREE, LAST_NOT_FREE_TAIL
         INTEGER :: STATUS(MPI_STATUS_SIZE)
-        LOGICAL :: FLAG
+        LOGICAL :: FLAG, BROADCAST_NOT_FREE
         IF ( B%HEAD .NE. B%TAIL ) THEN
  10       CONTINUE
           CALL MPI_TEST( B%CONTENT( B%HEAD + REQ ), FLAG, STATUS,
@@ -669,6 +640,41 @@ C
             B%HEAD = B%CONTENT( B%HEAD + NEXT )
             IF ( B%HEAD .EQ. 0 ) B%HEAD = B%TAIL
             IF ( B%HEAD .NE. B%TAIL ) GOTO 10
+          ELSE
+            LAST_NOT_FREE = B%HEAD
+            CURRENT = B%CONTENT( LAST_NOT_FREE + NEXT )
+            LAST_NOT_FREE_TAIL = CURRENT
+            BROADCAST_NOT_FREE = B%CONTENT(LAST_NOT_FREE+NEXT).EQ.
+     &                              LAST_NOT_FREE+OVHSIZE 
+            DO WHILE ( CURRENT .NE. 0 )
+              IF (BROADCAST_NOT_FREE) THEN
+                FLAG = .FALSE.
+              ELSE
+                CALL MPI_TEST( B%CONTENT( CURRENT + REQ ), FLAG, STATUS,
+     &                       IERR_MPI )
+              ENDIF
+              IF (FLAG) THEN
+                CURRENT = B%CONTENT( CURRENT + NEXT )
+                B%CONTENT( LAST_NOT_FREE + NEXT ) = CURRENT
+              ELSE
+                LAST_NOT_FREE = CURRENT
+                CURRENT = B%CONTENT( CURRENT + NEXT )
+                IF ( CURRENT .NE. 0 ) THEN
+                  LAST_NOT_FREE_TAIL = CURRENT
+                ELSE
+                  LAST_NOT_FREE_TAIL = B%TAIL
+                ENDIF
+                BROADCAST_NOT_FREE = B%CONTENT(LAST_NOT_FREE+NEXT).EQ.
+     &                               LAST_NOT_FREE+OVHSIZE 
+              ENDIF
+            ENDDO
+            IF ( LAST_NOT_FREE_TAIL .NE. 0 ) THEN
+              B%TAIL = LAST_NOT_FREE_TAIL
+              B%ILASTMSG = LAST_NOT_FREE
+            ELSE IF (B%ILASTMSG .NE. LAST_NOT_FREE) THEN
+              WRITE(*,*) "ABORT", B%ILASTMSG, LAST_NOT_FREE
+              CALL MUMPS_ABORT()
+            ENDIF
           END IF
         END IF
         IF ( B%HEAD .EQ. B%TAIL ) THEN
@@ -676,86 +682,78 @@ C
           B%TAIL = 1
           B%ILASTMSG = 1
         END IF
+        RETURN
+        END SUBROUTINE CMUMPS_BUF_FREEREQUESTS
+        SUBROUTINE CMUMPS_BUF_SIZE_AVAILABLE( B, SIZE_AV, SIZE_AV2 )
+        IMPLICIT NONE
+        TYPE ( CMUMPS_COMM_BUFFER_TYPE ) :: B
+        INTEGER, INTENT(OUT) :: SIZE_AV
+        INTEGER, OPTIONAL, INTENT(OUT) :: SIZE_AV2
+        CALL CMUMPS_BUF_FREEREQUESTS( B )
         IF ( B%HEAD .LE. B%TAIL ) THEN
-           SIZE_AV = max( B%LBUF_INT - B%TAIL, B%HEAD - 2 )
+          SIZE_AV = max( B%LBUF_INT - B%TAIL, B%HEAD - 2 )
+          IF ( B%LBUF_INT - B%TAIL .GT. B%HEAD - 2 ) THEN
+            SIZE_AV  = B%LBUF_INT - B%TAIL
+            IF (present(SIZE_AV2)) SIZE_AV2 = 0
+          ELSE
+            SIZE_AV = B%HEAD - 2
+            IF (present(SIZE_AV2)) SIZE_AV2 = B%LBUF_INT - B%TAIL
+          ENDIF
         ELSE
-           SIZE_AV = B%HEAD - B%TAIL - 1
+          SIZE_AV  = B%HEAD - B%TAIL - 1
+          IF (present(SIZE_AV2)) SIZE_AV2 = 0
         END IF
-        SIZE_AV = min(SIZE_AV - OVHSIZE, SIZE_AV)
+        SIZE_AV = max(0,SIZE_AV - OVHSIZE)
         SIZE_AV = SIZE_AV * SIZEofINT
+        IF (present(SIZE_AV2)) THEN
+          IF (SIZE_AV2 .NE. 0) THEN
+            SIZE_AV = max(0,SIZE_AV2 - OVHSIZE)
+            SIZE_AV2 = SIZE_AV2 * SIZEofINT
+          ENDIF
+        ENDIF
         RETURN
         END SUBROUTINE CMUMPS_BUF_SIZE_AVAILABLE
         SUBROUTINE CMUMPS_BUF_TEST()
-        INTEGER :: IPOS, IREQ, IERR
-        INTEGER, PARAMETER :: IONE=1
-        INTEGER :: MSG_SIZE
-        INTEGER :: DEST2(1)
-        DEST2=-10
-        MSG_SIZE=1
-        CALL BUF_LOOK( BUF_CB, IPOS, IREQ, MSG_SIZE, IERR, 
-     &                 IONE , DEST2,.TRUE.)
+        CALL CMUMPS_BUF_FREEREQUESTS(BUF_CB)
         RETURN
         END SUBROUTINE CMUMPS_BUF_TEST
         SUBROUTINE BUF_LOOK( B, IPOS, IREQ, MSG_SIZE, IERR, 
-     &    NDEST , PDEST, TEST_ONLY)
+     &    NDEST , PDEST )
         IMPLICIT NONE
         TYPE ( CMUMPS_COMM_BUFFER_TYPE ) :: B
         INTEGER, INTENT(IN)        :: MSG_SIZE
         INTEGER, INTENT(OUT)       :: IPOS, IREQ, IERR
-        LOGICAL, INTENT(IN), OPTIONAL :: TEST_ONLY
         INTEGER NDEST
         INTEGER, INTENT(IN)        :: PDEST(max(1,NDEST))
         INCLUDE 'mpif.h'
-        INTEGER :: IERR_MPI
         INTEGER :: MSG_SIZE_INT
         INTEGER :: IBUF
-        LOGICAL :: FLAG
-        INTEGER :: STATUS(MPI_STATUS_SIZE)
         IERR = 0
-        IF ( B%HEAD .NE. B%TAIL ) THEN
- 10       CONTINUE
-          CALL MPI_TEST( B%CONTENT( B%HEAD + REQ ), FLAG, STATUS,
-     &                   IERR_MPI )
-          IF ( FLAG ) THEN
-            B%HEAD = B%CONTENT( B%HEAD + NEXT )
-            IF ( B%HEAD .EQ. 0 ) B%HEAD = B%TAIL
-            IF ( B%HEAD .NE. B%TAIL ) GOTO 10
-          END IF
-        END IF
-        IF ( B%HEAD .EQ. B%TAIL ) THEN
-          B%HEAD = 1
-          B%TAIL = 1
-          B%ILASTMSG = 1
-        END iF
+        CALL CMUMPS_BUF_FREEREQUESTS( B )
         MSG_SIZE_INT = ( MSG_SIZE + ( SIZEofINT - 1 ) ) / SIZEofINT
         MSG_SIZE_INT = MSG_SIZE_INT + OVHSIZE
-        IF (present(TEST_ONLY)) RETURN
-        FLAG = (     ( B%HEAD .LE. B%TAIL )
-     &               .AND. (
-     &                 ( MSG_SIZE_INT .LE. B%LBUF_INT - B%TAIL )
-     &                 .OR. ( MSG_SIZE_INT .LE. B%HEAD - 2 ) ) )
-     &         .OR.
-     &               ( ( B%HEAD .GT. B%TAIL )
-     &               .AND. ( MSG_SIZE_INT .LE. B%HEAD - B%TAIL - 1 ) )
-        IF ( .NOT. FLAG
-     &       ) THEN
-        IERR = -1
         IF ( MSG_SIZE_INT .GT. B%LBUF_INT - 1 ) THEN
-           IERR = -2
-        ENDIF
-        IPOS = -1
-        IREQ = -1
-        RETURN
-      END IF
+          IERR = -2
+          IPOS = -1
+          IREQ = -1
+          RETURN
+        END IF
         IF ( B%HEAD .LE. B%TAIL ) THEN
-          IF ( MSG_SIZE_INT .LE. B%LBUF_INT - B%TAIL + 1 ) THEN
+          IF ( MSG_SIZE_INT .LE. B%LBUF_INT - B%TAIL ) THEN
             IBUF = B%TAIL
-          ELSE IF ( MSG_SIZE_INT .LE. B%HEAD - 1 ) THEN
+          ELSE IF ( MSG_SIZE_INT .LE. B%HEAD - 2 ) THEN
             IBUF = 1
+          ELSE
+            IERR = -1
           END IF
         ELSE
-          IBUF = B%TAIL
+          IF ( MSG_SIZE_INT .LE . B%HEAD - B%TAIL - 1) THEN
+            IBUF = B%TAIL
+          ELSE
+            IERR = -1
+          ENDIF
         END IF
+        IF (IERR .LT. 0) RETURN
         B%CONTENT( B%ILASTMSG + NEXT ) = IBUF
         B%ILASTMSG = IBUF
         B%TAIL = IBUF + MSG_SIZE_INT
@@ -955,7 +953,7 @@ C
           ENDIF
         ENDIF
        IF (NBROWS_PACKET + NBROWS_ALREADY_SENT.NE.NROW .AND.
-     &   SIZE_PACK - SIZE1  .LT. ( SIZE_RBUF_BYTES - SIZE1 ) / 2
+     &   SIZE_PACK - SIZE1  .LT. ( SIZE_RBUF_BYTES - SIZE1 ) / 10
      &  .AND. 
      &   .NOT. RECV_BUF_SMALLER_THAN_SEND)
      &       THEN
@@ -1239,17 +1237,14 @@ C
                SIZE1 = SIZE1+SIZE0
           ENDIF
       ENDIF
-      IF (KEEP(50) .EQ. 0) THEN
-        ONEorTWO = 1
-      ELSE
-        ONEorTWO = 2
-      ENDIF
+      ONEorTWO = 1
       IF (PDEST .EQ.PDEST_MASTER) THEN
         L = 0
       ELSE IF (KEEP(50) .EQ. 0) THEN
         L = LROW
       ELSE
         L = LROW + PERM(1) - LMAP + NBROWS_ALREADY_SENT - 1
+        ONEorTWO=ONEorTWO+1
       ENDIF
       NBINT = 6 + L + 1 
       IF (CB_IS_LR.AND.NBROW.GT.0) THEN
@@ -1269,7 +1264,8 @@ C
      &       SIZE_AV / ( ONEorTWO*SIZEofINT+LROW*SIZEofREAL)
         ELSE
           B = 2 * ONEorTWO + 
-     &      ( 1 + 2 *  LROW + 2 * PERM(1) + 2 * NBROWS_ALREADY_SENT )
+     &      ( -1 + 2 *  LROW + 2 * PERM(1) -2*LMAP
+     &                                  + 2 * NBROWS_ALREADY_SENT )
      &      * SIZEofREAL / SIZEofINT
           NBROWS_PACKET=int((dble(-B)+sqrt((dble(B)*dble(B))+
      &        dble(4)*dble(2)*dble(SIZE_AV)/dble(SIZEofINT) *
@@ -1318,9 +1314,9 @@ C
           MAX_ROW_LENGTH = -99999
           SIZE_REALS = NBROWS_PACKET * LROW
         ELSE
-          SIZE_REALS = (  LROW + PERM(1) + NBROWS_ALREADY_SENT ) *
+          SIZE_REALS = ( LROW + PERM(1) - LMAP + NBROWS_ALREADY_SENT ) *
      &      NBROWS_PACKET + ( NBROWS_PACKET *
-     &     ( NBROWS_PACKET + 1) ) / 2
+     &     ( NBROWS_PACKET - 1) ) / 2
           MAX_ROW_LENGTH = LROW+PERM(1)-LMAP+NBROWS_ALREADY_SENT
      &                 + NBROWS_PACKET-1
         ENDIF
@@ -1346,7 +1342,7 @@ C
       ENDIF
         SIZE_PACK = SIZE1 + SIZE2 + SIZE3
         IF (NBROWS_PACKET + NBROWS_ALREADY_SENT.NE.NBROW .AND.
-     &       SIZE_PACK  .LT. SIZE_RBUF_BYTES / 4 .AND.
+     &       SIZE_PACK  .LT. SIZE_RBUF_BYTES / 10 .AND.
      &    .NOT. RECV_BUF_SMALLER_THAN_SEND .AND.
      &    .NOT. CB_IS_LR)
      &       THEN
@@ -1804,7 +1800,7 @@ C
      &             WIDTH, COMM,
      &             NELIM, NPARTSASS, CURRENT_BLR_PANEL, 
      &             LR_ACTIVATED, BLR_LorU,
-     &
+     &             ICNTL,
      &             IERR )
       USE CMUMPS_LR_TYPE
       IMPLICIT NONE
@@ -1820,19 +1816,28 @@ C
         LOGICAL, intent(in) :: LR_ACTIVATED
         INTEGER, intent(in) :: NELIM, NPARTSASS, CURRENT_BLR_PANEL
         TYPE (LRB_TYPE), DIMENSION(:), intent(in) :: BLR_LorU
+        INTEGER, intent(in) :: ICNTL(60)
         INTEGER, intent(inout) :: IERR
         INCLUDE 'mpif.h'
         INCLUDE 'mumps_tags.h'
         INTEGER :: IERR_MPI
-        INTEGER POSITION, IREQ, IPOS, SIZE1, SIZE2, SIZE3, SIZET,
+        INTEGER POSITION, IREQ, IPOS, SIZE1, SIZE3, SIZET,
      &          IDEST, IPOSMSG, I
+        LOGICAL OVERFLOW
+        INTEGER(8) :: SIZE2_8, SIZE3_8, SIZET_8, SIZE_OVERFLOW
         INTEGER NPIVSENT
         INTEGER SSS
         INTEGER  :: NBMSGS
+        INTEGER :: LP
+        LOGICAL :: LPOK
         INTEGER :: LRELAY_INFO, DEST_BLOCFACTO, TAG_BLOCFACTO
         INTEGER :: LR_ACTIVATED_INT
+        LP  = ICNTL( 1 )
+        LPOK    = ( LP.GT.0 .AND. ICNTL(4).GE.1 )
         IERR = 0
         LRELAY_INFO = 0
+        OVERFLOW = .FALSE.
+        SIZE_OVERFLOW = 0_8
         NBMSGS = NDEST
         IF ( LASTBL ) THEN
           IF ( KEEP(50) .eq. 0 ) THEN
@@ -1855,28 +1860,56 @@ C
      &                          MPI_INTEGER, COMM, SIZE1, IERR_MPI )
           END IF
         END IF
-        SIZE2 = 0
+        SIZE2_8 = 0_8
         CALL MPI_PACK_SIZE( 4, MPI_INTEGER, COMM, SIZE3, IERR_MPI )
-        SIZE2=SIZE2+SIZE3
+        SIZE2_8=SIZE2_8+SIZE3
         IF ( KEEP(50).NE.0 ) THEN
           CALL MPI_PACK_SIZE( 1, MPI_INTEGER, COMM, SIZE3, IERR_MPI )
-          SIZE2=SIZE2+SIZE3
+          SIZE2_8=SIZE2_8+SIZE3
         ENDIF
         IF ((NPIV.GT.0)
      &     ) THEN
           IF (.NOT. LR_ACTIVATED) THEN
-            CALL MPI_PACK_SIZE( NPIV*NCOL, MPI_COMPLEX,
+            SIZE3_8 = int(NPIV,8)*int(NCOL,8)*int(KEEP(35),8)
+            IF (SIZE3_8 .GT. int(huge(SIZE3),8))  THEN
+              OVERFLOW      = .TRUE.
+              SIZE_OVERFLOW = SIZE3_8
+            ELSE
+              CALL MPI_PACK_SIZE( NPIV*NCOL, 
+     &                      MPI_COMPLEX,
      &                      COMM, SIZE3, IERR_MPI )
-            SIZE2 = SIZE2+SIZE3
+              SIZE2_8 = SIZE2_8 + int(SIZE3,8)
+            ENDIF
           ELSE
-            CALL MPI_PACK_SIZE( NPIV*(NPIV+NELIM), MPI_COMPLEX,
+            SIZE3_8 = int(NPIV,8)*int(NPIV+NELIM,8)*int(KEEP(35),8)
+            IF (SIZE3_8 .GT. int(huge(SIZE3),8)) THEN
+              OVERFLOW = .TRUE.
+              SIZE_OVERFLOW = SIZE3_8
+            ELSE
+              CALL MPI_PACK_SIZE( NPIV*(NPIV+NELIM), 
+     &                      MPI_COMPLEX,
      &                      COMM, SIZE3, IERR_MPI )
-            SIZE2 = SIZE2+SIZE3
-              CALL MUMPS_MPI_PACK_SIZE_LR( BLR_LorU, SIZE3, COMM, IERR )
-            SIZE2 = SIZE2+SIZE3
-          ENDIF
+              SIZE2_8 = SIZE2_8+SIZE3
+            ENDIF
+              CALL MUMPS_MPI_PACK_SIZE_LR( BLR_LorU, SIZE3_8, 
+     &                                     COMM, IERR )
+            SIZE2_8 = SIZE2_8+SIZE3_8
+          ENDIF
+        ENDIF
+        SIZET_8 = int(SIZE1,8) + SIZE2_8
+        IF (SIZET_8 .GT. int(huge(SIZE3),8)) THEN
+              OVERFLOW      = .TRUE.
+              SIZE_OVERFLOW = SIZET_8
+        ENDIF
+        IF (OVERFLOW) THEN
+          IERR=-3
+          IF (LPOK) WRITE(LP,*)
+     & "Integer overflow message inCMUMPS_BUF_SEND_BLOCFACTO",
+     & "SIZE_OVERFLOW,NPIV,NFRONT,NELIM=",
+     &  SIZE_OVERFLOW, NPIV, NFRONT, NELIM
+          RETURN
         ENDIF
-        SIZET = SIZE1 + SIZE2 
+        SIZET = int(SIZET_8)
         IF (SIZET.GT.SIZE_RBUF_BYTES) THEN
           SSS = 0 
           IF ( LASTBL ) THEN
@@ -1896,7 +1929,7 @@ C
      &                        MPI_INTEGER, COMM, SSS, IERR_MPI )
            END IF
           END IF
-          SSS = SSS + SIZE2  
+          SSS = SSS + int(SIZE2_8)  
           IF (SSS.GT.SIZE_RBUF_BYTES) THEN
            IERR = -3 
             RETURN
@@ -2043,30 +2076,50 @@ C
         INCLUDE 'mumps_tags.h'
         INTEGER :: IERR_MPI
         INTEGER LR_ACTIVATED_INT
-        INTEGER POSITION, IREQ, IPOS, SIZE1, SIZE2, SIZET,
+        INTEGER POSITION, IREQ, IPOS, SIZE1, SIZET,
      &          IDEST, IPOSMSG, SSS, SSLR
-        IERR = 0
+        INTEGER(8) :: SIZE2_8, SSLR_8, SIZET_8, SIZE_OVERFLOW
+        LOGICAL    :: OVERFLOW
+        IERR          = 0
+        OVERFLOW      = .FALSE.
+        SIZE_OVERFLOW = 0_8
         CALL MPI_PACK_SIZE( 6 + ( NDEST - 1 ) * OVHSIZE,
      &                      MPI_INTEGER, COMM, SIZE1, IERR_MPI )
-        SIZE2  = 0
+        SIZE2_8  = 0_8
         CALL MPI_PACK_SIZE(2, MPI_INTEGER, COMM, SSLR, IERR_MPI )
-        SIZE2=SIZE2+SSLR
+        SIZE2_8 = SIZE2_8 + SSLR
         IF (.NOT. LR_ACTIVATED) THEN
-        CALL MPI_PACK_SIZE( abs(NPIV)*NCOLU, MPI_COMPLEX,
+          SSLR_8 = int(abs(NPIV),8)*int(NCOLU,8)
+          IF (SSLR_8 .GT. int(huge(SSLR),8))  THEN
+              OVERFLOW      = .TRUE.
+              SIZE_OVERFLOW = SSLR_8
+          ELSE
+           CALL MPI_PACK_SIZE( abs(NPIV)*NCOLU, 
+     &                      MPI_COMPLEX,
      &                      COMM, SSLR, IERR_MPI )
-         SIZE2=SIZE2+SSLR
+           SIZE2_8=SIZE2_8 + int(SSLR,8)
+          ENDIF
         ELSE
-          CALL MUMPS_MPI_PACK_SIZE_LR( BLR_LS, SSLR, COMM, IERR )
-          SIZE2=SIZE2+SSLR
+          CALL MUMPS_MPI_PACK_SIZE_LR( BLR_LS, SSLR_8, COMM, IERR )
+          SIZE2_8=SIZE2_8 + SSLR_8
+        ENDIF
+        SIZET_8 = int(SIZE1,8) + SIZE2_8
+        IF (SIZET_8 .GT. int(huge(SSLR),8)) THEN
+              OVERFLOW      = .TRUE.
+              SIZE_OVERFLOW = SIZET_8
         ENDIF
-        SIZET = SIZE1 + SIZE2
+        IF (OVERFLOW) THEN
+          IERR=-3
+          RETURN
+        ENDIF
+        SIZET = int(SIZET_8)
         IF (SIZET.GT.SIZE_RBUF_BYTES) THEN
          CALL MPI_PACK_SIZE( 6 ,
      &                      MPI_INTEGER, COMM, SSS, IERR_MPI )
-         SSS = SSS+SIZE2
-         IF (SSS.GT.SIZE_RBUF_BYTES) THEN
+         SIZE2_8 = int(SSS,8)+SIZE2_8
+         IF (int(SIZE2_8).GT.SIZE_RBUF_BYTES) THEN
            IERR = -2
-      RETURN
+           RETURN
          ENDIF
         END IF
         CALL BUF_LOOK( BUF_CB, IPOS, IREQ, SIZET, IERR, 
@@ -2254,7 +2307,7 @@ C
           ENDIF
           IF (N_PACKET + N_ALREADY_SENT .NE. NSUBSET_ROW - NSUPROW
      &         .AND.
-     &         SIZE_PACK .LT. SIZE_RBUF_BYTES / 4
+     &         SIZE_PACK .LT. SIZE_RBUF_BYTES / 10
      &         .AND. .NOT. RECV_BUF_SMALLER_THAN_SEND)
      &         THEN
              IERR = -1
@@ -2797,11 +2850,11 @@ C
      &             ( WHAT, COMM, NPROCS, 
      &               FUTURE_NIV2,
      &               LOAD, UPD_LOAD,
-     &               MYID, KEEP, IERR)
+     &               MYID, KEEP267, IERR)
         IMPLICIT NONE
         INTEGER COMM, NPROCS, MYID, IERR, WHAT
         DOUBLE PRECISION LOAD,UPD_LOAD
-        INTEGER, INTENT(INOUT) :: KEEP(500)
+        INTEGER, INTENT(INOUT) :: KEEP267
         INCLUDE 'mpif.h'
         INCLUDE 'mumps_tags.h'
         INTEGER :: IERR_MPI
@@ -2870,7 +2923,7 @@ C
         DO I = 0, NPROCS - 1
           IF ( I .NE. MYID .AND. FUTURE_NIV2(I+1) .NE. 0) THEN
             IDEST = IDEST + 1
-            KEEP(267)=KEEP(267)+1
+            KEEP267 = KEEP267 + 1
             CALL MPI_ISEND( BUF_LOAD%CONTENT( IPOSMSG ),
      &                      POSITION, MPI_PACKED, I,
      &                      UPDATE_LOAD, COMM,
@@ -2913,7 +2966,7 @@ C
      &          MPI_INTEGER, COMM,
      &          SIZE, IERR_MPI )
         ELSE
-           CALL MPI_PACK_SIZE( 2 + OVHSIZE, 
+           CALL MPI_PACK_SIZE( 2, 
      &          MPI_INTEGER, COMM,
      &          SIZE, IERR_MPI )
         ENDIF
@@ -3153,22 +3206,23 @@ C
         SIZE_RBUF_BYTES = CMUMPS_LBUFR_BYTES
         RETURN
       END SUBROUTINE CMUMPS_BUF_DIST_IRECV_SIZE
-      SUBROUTINE MUMPS_MPI_PACK_SIZE_LR( BLR_LorU, SIZE_OUT, COMM,
+      SUBROUTINE MUMPS_MPI_PACK_SIZE_LR( BLR_LorU, SIZE_OUT8, COMM,
      &                                   IERR )
       USE CMUMPS_LR_TYPE
-      INTEGER, intent(out) :: SIZE_OUT, IERR
+      INTEGER, intent(out)     :: IERR
+      INTEGER(8), intent(out)  :: SIZE_OUT8
       INTEGER, intent(in)  :: COMM
       TYPE (LRB_TYPE), DIMENSION(:), intent(in) :: BLR_LorU
-      INTEGER :: I, SIZE_LOC, IERR_MPI
+      INTEGER     :: I, SIZE_LOC, IERR_MPI
       INCLUDE 'mpif.h'
-        IERR = 0
-        SIZE_OUT = 0
+        IERR      = 0
+        SIZE_OUT8 = 0_8
         CALL MPI_PACK_SIZE( 1, MPI_INTEGER, COMM, SIZE_LOC,  IERR_MPI )
-        SIZE_OUT = SIZE_OUT + SIZE_LOC
+        SIZE_OUT8 = SIZE_OUT8 + SIZE_LOC
         DO I = 1, size(BLR_LorU)
           CALL MUMPS_MPI_PACK_SIZE_LRB(BLR_LorU(I), SIZE_LOC, COMM, 
      &                                 IERR )
-          SIZE_OUT = SIZE_OUT + SIZE_LOC
+          SIZE_OUT8 = SIZE_OUT8 + SIZE_LOC
         ENDDO
         RETURN
       END SUBROUTINE MUMPS_MPI_PACK_SIZE_LR
diff -pruN 5.6.2-2.1/src/cmumps_config_file.F 5.7.1-1/src/cmumps_config_file.F
--- 5.6.2-2.1/src/cmumps_config_file.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/cmumps_config_file.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/cmumps_driver.F 5.7.1-1/src/cmumps_driver.F
--- 5.6.2-2.1/src/cmumps_driver.F	2023-10-11 09:37:10.000000000 +0000
+++ 5.7.1-1/src/cmumps_driver.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -21,7 +21,9 @@ C
       USE MUMPS_MEMORY_MOD
       USE CMUMPS_STRUC_DEF
       USE CMUMPS_STATIC_PTR_M ! For Schur pointer
+#if ! defined(NO_SAVE_RESTORE)
       USE CMUMPS_SAVE_RESTORE
+#endif
 C      
 !$    USE OMP_LIB
 C
@@ -345,6 +347,14 @@ C
 * Values 4, 5, 6 for the parameter JOB can invoke combinations
 * of the three basic operations corresponding to JOB=1, 2 or 3.
 * 
+* JOB = -4 : frees all data structures from the factorization
+* while keeping data structures from the analysis. Can be
+* followed by a JOB = 2 call.
+*
+#if ! defined(NO_SAVE_RESTORE)
+* JOB = -3, 7, 8 : save and restore feature, see userguide
+#endif
+* JOB = 9 : provide suggested data distribution for IRHS_LOC
 C
 *********
 C     --------------------------------------
@@ -584,7 +594,7 @@ C
 !$    INTEGER NOMP, NOMPMIN, NOMPMAX
       INTEGER I, J, MP, LP, MPG, KEEP235SAVE, KEEP242SAVE,
      &        KEEP243SAVE, KEEP495SAVE, KEEP497SAVE,
-     &        KEEP77SAVE, KEEP83SAVE, KEEP91SAVE
+     &        KEEP77SAVE, KEEP78SAVE, KEEP83SAVE, KEEP91SAVE
       INTEGER(8) :: I8
       LOGICAL LANA, LFACTO, LSOLVE, PROK, LPOK, FLAG, PROKG
       LOGICAL NOERRORBEFOREPERM
@@ -599,7 +609,9 @@ C     Local copy of JOB
       INTEGER, DIMENSION(:), ALLOCATABLE :: UNS_PERM_INV
 C     TIMINGS
       DOUBLE PRECISION TIMEG, TIMETOTAL
+#if ! defined(NO_SAVE_RESTORE)
       INTEGER(8) :: FILE_SIZE,STRUC_SIZE
+#endif
       INTEGER:: ICNTL16_LOC
 !$    INTEGER:: PREVIOUS_OMP_THREADS_NUM
       IF (id%JOB .EQ. -200) THEN
@@ -613,12 +625,14 @@ C       JOB=-200 to just suppress the ex
 C       before terminating the application and killing all
 C       processes. No checks are performed in this case,
 C       data is not freed and MPI should not be called
-C       (since MPI might no longer work)
+C       (since MPI might no longer work). In particular, there is
+C       no check that the value of JOB is the same on all the
+C       calling MPI processes.
         CALL CMUMPS_OOC_CLEAN_FILES(id,IERR)
         RETURN
       ENDIF
       NOERRORBEFOREPERM = .FALSE.
-      UNS_PERM_DONE = .FALSE.
+      UNS_PERM_DONE     = .FALSE.
       LANA  = .FALSE.
       LFACTO = .FALSE.
       LSOLVE = .FALSE.
@@ -627,6 +641,14 @@ C
 C     Initialize error return codes to 0.
       id%INFO(1) = 0
       id%INFO(2) = 0
+C
+C     Default setting for printing, before ICNTL(1:4) are initialized
+      LP = 6
+      MP = 0
+      MPG = 0
+      LPOK  = .TRUE.
+      PROK  = .FALSE.
+      PROKG = .FALSE.
 C     -----------------------------------
 C     Check that MPI has been initialized
 C     -----------------------------------
@@ -636,7 +658,9 @@ C     ----------------------------------
         id%INFO(2) =   0
         id%INFOG(1) = -23
         id%INFOG(2) =   0
-        WRITE(6,990)
+C       JOB=-1: LPOK is true and LP=6 (see
+C       above) because not set yet by the user
+        IF (LPOK) WRITE(LP,990)
  990  FORMAT(' Unrecoverable Error in CMUMPS initialization: ',
      &       ' MPI is not running.')
         RETURN               
@@ -646,16 +670,8 @@ C     Duplicate user communicator
 C     to avoid communications not
 C     related to CMUMPS
 C     ---------------------------
-       COMM_SAVE = id%COMM
-       CALL MPI_COMM_DUP( COMM_SAVE, id%COMM, IERR )
-C
-C     Default setting for printing
-      LP = 6
-      MP = 0
-      MPG = 0
-      LPOK  = .TRUE.
-      PROK  = .FALSE.
-      PROKG = .FALSE.
+      COMM_SAVE = id%COMM
+      CALL MPI_COMM_DUP( COMM_SAVE, id%COMM, IERR )
       ICNTL16_LOC = 0
 C     -------------------------
 C     Check if value of JOB is
@@ -673,7 +689,11 @@ C     -------------------------
 C   
 C     Check value of JOB and previous value of JOB
 C
+#if ! defined(NO_SAVE_RESTORE)
       IF ((JOB.LT.-3.OR.JOB.EQ.0.OR.JOB.GT.8)
+#else
+      IF ((JOB.LT.-2.OR.JOB.EQ.0.OR.JOB.GT.6) 
+#endif
      &    .AND. JOB.NE.9
      &    .AND. JOB.NE.-4
      &  ) THEN
@@ -695,6 +715,7 @@ C      Warning: non initialized value
         GOTO 499
        END IF
       END IF
+#if ! defined(NO_SAVE_RESTORE)
       IF(JOB.NE.-1) THEN
 C     Always allow JOB=-1
          IF((JOB.GT.-2).AND.(id%KEEP(140).EQ.1)) then
@@ -705,6 +726,7 @@ C     are -2 or -3
             GOTO 499
          END IF
       ENDIF
+#endif
 C     ----------------------------------
 C     Initialize, LANA, LFACTO, LSOLVE
 C     LANA indicates if analysis must be performed
@@ -730,6 +752,7 @@ C       Value defined on MASTER is the r
      &         IERR )
         IF (LANA) THEN
            KEEP77SAVE = id%KEEP(77)
+           KEEP78SAVE = id%KEEP(78)
            KEEP83SAVE = id%KEEP(83)
            KEEP91SAVE = id%KEEP(91)
            id%KEEP(198) = 0
@@ -786,9 +809,11 @@ C       and factorization:
       ENDIF
 C
       IF (JOB.EQ.-2.OR.JOB.EQ.1.OR.JOB.EQ.2.OR.JOB.EQ.3.OR.
-     &    JOB.EQ.4.OR.JOB.EQ.5.OR.JOB.EQ.6
+     &    JOB.EQ.4.OR.JOB.EQ.5.OR.JOB.EQ.6.OR.JOB.EQ.-4
+#if ! defined(NO_SAVE_RESTORE)
      &     .OR.JOB.EQ.7.OR.JOB.EQ.8.OR.JOB.EQ.-3
-     *     .OR. JOB.EQ.9 ! LATER .OR.JOB.EQ.10
+#endif
+     &     .OR. JOB.EQ.9 
      &     ) THEN
 C       Value of JOB is correct and differnet from -1
 C       ICNTL should have been initialized and can be used
@@ -803,6 +828,10 @@ C       ICNTL should have been initializ
           FROM_C_INTERFACE_STRING=" from C interface"
         ELSE
           FROM_C_INTERFACE_STRING=" "
+C         and KEEP8(83) to the ddress of ICNTL(50)
+C         Set KEEP8(84) to the address of RINFO(3)
+          CALL MUMPS_ADDR_C( id%ICNTL(50), id%KEEP8(83) )
+          CALL MUMPS_ADDR_C( id%RINFO (3), id%KEEP8(84) )
         ENDIF
 C       -----------------------------
 C       Set the number of threads if required.
@@ -832,10 +861,14 @@ C       -----------------------------
         IF (PROKG) THEN
 C          Print basic information on MUMPS call
            IF (JOB .EQ. -2
+#            if ! defined(NO_SAVE_RESTORE)
      &       .OR. JOB .EQ. 8
+#            endif
      &       ) THEN
 C            N, NELT, NNZ not meaningful
+#            if ! defined(NO_SAVE_RESTORE)
 C            or not defined yet (JOB=8).
+#            endif
              WRITE(MPG,'(/A,A,A,A,I4)') 
      &               'Entering CMUMPS ',
      &               trim(adjustl(id%VERSION_NUMBER)),
@@ -885,11 +918,6 @@ C          MPI and OpenMP information
 99996       FORMAT(/'Advanced settings:'/
      &       '   KEEP(370) Static mapping              =',I10/
      &       '   KEEP(371) Advanced optimizations      =',I10)
-            IF (id%KEEP(401) .GE. 1) THEN
-              WRITE(MPG, 99997) id%KEEP(401)
-            ENDIF
-99997       FORMAT('L0 thread based multithreading setting:'/
-     &       '   KEEP(401) (>=1 : ON)                  =',I10)
             WRITE(MPG, '(A)')
           ENDIF
         ENDIF
@@ -908,18 +936,18 @@ C
 C       ------------------------------------------
 C       Check that we have called (JOB=-2), ie
 C       that the previous JOB is not 1 2 or 3,
+C       or even -1
 C       before calling the initialization routine.
 C       --------------------------------------------
         id%INFO(1)=0
         id%INFO(2)=0
         OLDJOB = id%KEEP( 40 ) + 456789
-        IF ( OLDJOB .EQ. 1 .OR.
+        IF ( OLDJOB .EQ. -1 .OR.
+     &       OLDJOB .EQ. 1 .OR.
      &       OLDJOB .EQ. 2 .OR.
      &       OLDJOB .EQ. 3  ) THEN
-          IF ( id%N > 0 ) THEN
            id%INFO(1)=-3
            id%INFO(2)=JOB
-          ENDIF
         ENDIF
 C       Initialize id%MYID now because it is
 C       required by MUMPS_PROPINFO. id%MYID
@@ -976,6 +1004,7 @@ C
         id%DKEEP(70)=0.0E0
         CALL MUMPS_SECDEB(TIMETOTAL)
       ENDIF
+#if ! defined(NO_SAVE_RESTORE)
 C
 C----------------------------------------------------------------
 C
@@ -1046,6 +1075,7 @@ C
         IF ( id%INFO(1) .LT. 0 ) GOTO 499
         GOTO 500
       ENDIF
+#endif
 C----------------------------------------------------------------
 C
 C     JOB =  9 : fill IRHS_loc
@@ -1076,11 +1106,13 @@ C       Allowed if last factorization fa
           CALL CMUMPS_FREE_DATA_FACTO(id)
 C         Reset last successful phase
           OLDJOB=min(OLDJOB, 1)
+          id%KEEP(40) = OLDJOB - 456789
         ENDIF
         IF ( id%INFO(1) .LT .0 ) GOTO 499
         GOTO 500
       ENDIF
 C
+C
 C----------------------------------------------------------------
 C
 C     MAIN DRIVER
@@ -1168,7 +1200,6 @@ C      refinement and error analysis)
 C     ------------------------------------------
 #if ! defined (LARGEMATRICES)
       NOERRORBEFOREPERM =.TRUE.
-      UNS_PERM_DONE=.FALSE.
       IF (id%MYID .eq. MASTER .AND. id%KEEP(23) .NE. 0) THEN
         IF ( id%JOB .EQ. 2 .OR. id%JOB .EQ. 5 .OR.
      &       (id%JOB .EQ. 3 .AND. (id%ICNTL(10) .NE.0 .OR.
@@ -1238,10 +1269,10 @@ C       ----------------------------
 C
         IF (id%MYID.EQ.MASTER) THEN
 C         Check N, [N]NZ, NELT
-          IF ((id%N.LE.0).OR.((id%N+id%N+id%N)/3.NE.id%N)) THEN
-             id%INFO(1) = -16
-             id%INFO(2) = id%N
-             GOTO 100
+          IF (id%N.LE.0) THEN
+            id%INFO(1) = -16
+            id%INFO(2) = id%N
+            GOTO 100
           END IF
           IF (id%ICNTL(5).NE.1) THEN
 C           Assembled input
@@ -1419,8 +1450,27 @@ C       ANALYSIS PHASE:
         CALL CMUMPS_ANA_DRIVER( id )
 C       restore values
         id%KEEP(77) =  KEEP77SAVE 
+        id%KEEP(78) =  KEEP78SAVE 
         id%KEEP(83) =  KEEP83SAVE
         id%KEEP(91) =  KEEP91SAVE
+#if ! defined(LARGEMATRICES)
+        IF (id%MYID .eq. MASTER .AND. id%KEEP(23) .NE. 0) THEN
+         IF (.not.associated(id%UNS_PERM)) THEN
+C         I may happen 
+C           (for ex in case of error -7 during analysis:
+C           UNS_PERM can be not associated, 
+C           KEEP(23) was set to to automatic choice(=7) and
+C           an error of memory allocation occurs during analysis
+C           before having decided value of KEEP(23))
+C         UNS_PERM not associated and KEEP(23).NE.0
+C         Permuting JCN back does not make sense and KEEP(23) 
+C         should be reset to zero
+          id%KEEP(23) = 0
+         ELSE
+          UNS_PERM_DONE = .TRUE.
+         ENDIF
+        ENDIF
+#endif
 C
 C Check and save scaling option in INFOG(33)
         IF (id%MYID .eq. MASTER) THEN
@@ -1482,6 +1532,7 @@ C
 C-
 C-------------------------------------------------------
       IF ( LFACTO ) THEN
+C{
          IF (id%MYID .eq. MASTER) THEN
             id%DKEEP(91)=0.0E0
             CALL MUMPS_SECDEB(TIMEG)
@@ -1794,14 +1845,19 @@ C
              CALL CMUMPS_CHECK_DENSE_RHS
      &       (id%RHS,id%INFO,id%N,id%NRHS,id%LRHS)
 C            Sets KEEP(221) and do some checks
-             CALL CMUMPS_SET_K221(id)
-             CALL CMUMPS_CHECK_REDRHS(id)
+C            in case of Schur check if reduced RHS 
+C            requested
+              CALL CMUMPS_SET_K221(id,.FALSE.)
+             CALL CMUMPS_CHECK_K221andREDRHS(id)
           ENDIF
  200      CONTINUE
         END IF        ! End of IF (MYID .eq. MASTER)
 C       KEEP(221) was set in CMUMPS_SET_K221 but not broadcast
         CALL MPI_BCAST( id%KEEP(221), 1, MPI_INTEGER, MASTER, id%COMM,
      &       IERR )
+C       broadcast RR option 
+        CALL MPI_BCAST( id%KEEP(19), 1, MPI_INTEGER, MASTER, id%COMM,
+     &       IERR )
 C
 C       Check distributed matrices on all processors.
         I_AM_SLAVE = ( id%MYID .ne. MASTER  .OR.
@@ -1969,6 +2025,7 @@ C
 C       Update last successful step
 C
         id%KEEP(40) = 2 - 456789
+C}
       END IF
 C-------------------------------------------------------
 C-
@@ -2082,26 +2139,13 @@ C       done (no iterative refinement/
 C       error analysis), then we do not
 C       permute JCN back.
 C       -------------------------------
-        IF (id%JOB .NE. 3 .OR. UNS_PERM_DONE) THEN
-         IF (.not.associated(id%UNS_PERM)) THEN
-C         I may happen 
-C           (for ex in case of error -7 during analysis:
-C           UNS_PERM can be not associated, 
-C           KEEP(23) was set to to automatic choice(=7) and
-C           an error of memory allocation occurs during analysis
-C           before having decided value of KEEP(23))
-C         UNS_PERM not associated and KEEP(23).NE.0
-C         Permuting JCN back does not make sense and KEEP(23) 
-C         should be reset to zero
-          id%KEEP(23) = 0
-         ELSE
+        IF (UNS_PERM_DONE) THEN
            DO I8 = 1_8, id%KEEP8(28)
             J=id%JCN(I8)
 C           -- skip out-of range (that are ignored in ANA_O)
             IF (J.LE.0.OR.J.GT.id%N) CYCLE
             id%JCN(I8)=id%UNS_PERM(J)
            END DO
-          ENDIF
         END IF
       END IF
 #endif
@@ -2131,6 +2175,7 @@ C     the next time MUMPS is entered thr
 C     ------------------------------------------------------------
       NULLIFY(id%SCHUR_CINTERFACE)
 C
+#if ! defined(NO_SAVE_RESTORE)
 *=======================
 * Compute space for save
 *=======================
@@ -2147,6 +2192,7 @@ C
          id%RINFOG(17)=REAL(id%KEEP8(57))/1E6
          id%RINFOG(18)=REAL(id%KEEP8(58))/1E6
       ENDIF
+#endif
 !$    IF (ICNTL16_LOC .GT. 0) THEN
 #if defined(WORKAROUNDINTELILP64OPENMPLIMITATION)
 !$      CALL omp_set_num_threads(int(PREVIOUS_OMP_THREADS_NUM,4))
@@ -2168,8 +2214,8 @@ C
 C     -------------------------
 C     Restore user communicator
 C     -------------------------
-       CALL MPI_COMM_FREE( id%COMM, IERR )
-       id%COMM = COMM_SAVE
+      CALL MPI_COMM_FREE( id%COMM, IERR )
+      id%COMM = COMM_SAVE
       RETURN
 *
 99995 FORMAT (' ** ERROR RETURN ** FROM CMUMPS INFO(1)=', I5)
@@ -2242,7 +2288,7 @@ C        INFOG(2) = MYID
         CALL MPI_BCAST( INFOG(2), 1, MPI_INTEGER, ROOT, COMM, IERR )
       END IF
 C
-C    Make INFOG available on all procs:
+C     Make INFOG available on all procs:
 C
       CALL MPI_BCAST(INFOG(3), SIZE_INFOG-2, MPI_INTEGER,
      &               MASTER, COMM, IERR )
@@ -2279,12 +2325,12 @@ C---------------------------------------
             WRITE (LP,991) ICNTL(5),ICNTL(6),ICNTL(7),ICNTL(12),
      &          ICNTL(13),
      &          ICNTL(15),
-     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(58)
+     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(48),ICNTL(58)
            ELSE
             WRITE (LP,891) ICNTL(5),ICNTL(6),ICNTL(7),
      &          ICNTL(13),
      &          ICNTL(15),
-     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(58)
+     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(48),ICNTL(58)
            ENDIF
            IF ((ICNTL(6).EQ.5).OR.(ICNTL(6).EQ.6).OR.
      &          (ICNTL(12).NE.1) )  THEN
@@ -2293,6 +2339,7 @@ C---------------------------------------
            IF (id%ICNTL(19).NE.0)
      &      WRITE(LP,998) id%SIZE_SCHUR
            WRITE (LP,993) ICNTL(14)
+           WRITE (LP,996) ICNTL(56)
          CASE(2);
            WRITE (LP,980) 
            WRITE (LP,981) CNTL(1), CNTL(3), CNTL(4), CNTL(5), CNTL(7)
@@ -2301,21 +2348,34 @@ C---------------------------------------
            WRITE (LP,993) ICNTL(14) 
            WRITE (LP,923) ICNTL(24), ICNTL(31), ICNTL(32), ICNTL(33),
      &                    ICNTL(35), ICNTL(36), ICNTL(49)
+           WRITE (LP,996) ICNTL(56)
          CASE(3);
            WRITE (LP,980)
            WRITE (LP,990) ICNTL(1),ICNTL(2),ICNTL(3),ICNTL(4)
            WRITE (LP,995)
-     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21)
+     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21),ICNTL(26)
          CASE(4);
            WRITE (LP,980) 
            WRITE (LP,981) CNTL(1), CNTL(3), CNTL(4), CNTL(5), CNTL(7)
            WRITE (LP,990) ICNTL(1),ICNTL(2),ICNTL(3),ICNTL(4)
+           IF (id%SYM.EQ.2) THEN
+            WRITE (LP,991) ICNTL(5),ICNTL(6),ICNTL(7),ICNTL(12),
+     &          ICNTL(13),
+     &          ICNTL(15),
+     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(48),ICNTL(58)
+           ELSE
+            WRITE (LP,891) ICNTL(5),ICNTL(6),ICNTL(7),
+     &          ICNTL(13),
+     &          ICNTL(15),
+     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(48),ICNTL(58)
+           ENDIF
            WRITE (LP,992) ICNTL(8)
            IF (id%ICNTL(19).NE.0)
      &      WRITE(LP,998) id%SIZE_SCHUR
            WRITE (LP,993) ICNTL(14)
            WRITE (LP,923) ICNTL(24), ICNTL(31), ICNTL(32), ICNTL(33),
      &                    ICNTL(35), ICNTL(36), ICNTL(49)
+           WRITE (LP,996) ICNTL(56)
          CASE(5);
            WRITE (LP,980) 
            WRITE (LP,981) CNTL(1), CNTL(3), CNTL(4), CNTL(5), CNTL(7)
@@ -2324,19 +2384,20 @@ C---------------------------------------
             WRITE (LP,991) ICNTL(5),ICNTL(6),ICNTL(7),ICNTL(12),
      &          ICNTL(13),
      &          ICNTL(15),
-     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(58)
+     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(48),ICNTL(58)
            ELSE
             WRITE (LP,891) ICNTL(5),ICNTL(6),ICNTL(7),
      &          ICNTL(13),
      &          ICNTL(15),
-     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(58)
+     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(48),ICNTL(58)
            ENDIF
            WRITE (LP,992) ICNTL(8)
            WRITE (LP,993) ICNTL(14)
            WRITE (LP,995)
-     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21)
+     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21),ICNTL(26)
            WRITE (LP,923) ICNTL(24), ICNTL(31), ICNTL(32), ICNTL(33),
      &                    ICNTL(35), ICNTL(36), ICNTL(49)
+           WRITE (LP,996) ICNTL(56)
          CASE(6);
            WRITE (LP,980)
            WRITE (LP,981) CNTL(1), CNTL(3), CNTL(4), CNTL(5), CNTL(7)
@@ -2345,27 +2406,28 @@ C---------------------------------------
             WRITE (LP,991) ICNTL(5),ICNTL(6),ICNTL(7),ICNTL(12),
      &          ICNTL(13),
      &          ICNTL(15),
-     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(58)
+     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(48),ICNTL(58)
            ELSE
             WRITE (LP,891) ICNTL(5),ICNTL(6),ICNTL(7),
      &          ICNTL(13),
      &          ICNTL(15),
-     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(58)
+     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(48),ICNTL(58)
            ENDIF
            IF (id%ICNTL(19).NE.0)
      &      WRITE(LP,998) id%SIZE_SCHUR
            WRITE (LP,992) ICNTL(8)
            WRITE (LP,995)
-     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21)
+     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21), ICNTL(26)
            WRITE (LP,993) ICNTL(14)
            WRITE (LP,923) ICNTL(24), ICNTL(31), ICNTL(32), ICNTL(33),
      &                    ICNTL(35), ICNTL(36), ICNTL(49)
+           WRITE (LP,996) ICNTL(56)
         END SELECT
       ENDIF
  980  FORMAT (/'***********CONTROL PARAMETERS (ICNTL)**************'/)
  981  FORMAT (
      &     ' CNTL(1)   Threshold for numerical pivoting        =',D16.4/
-     &     ' CNTL(3)   Null pivot detection threshold          =',D16.4/
+     &     ' CNTL(3)   Threshold to detect singularities       =',D16.4/
      &     ' CNTL(4)   Threshold for static pivoting           =',D16.4/
      &     ' CNTL(5)   Fixation for null pivots                =',D16.4/
      &     ' CNTL(7)   Dropping threshold for BLR compression  =',D16.4)
@@ -2375,25 +2437,27 @@ C---------------------------------------
      &     'ICNTL(3)   Output stream for global information    =',I10/
      &     'ICNTL(4)   Level of printing                       =',I10)
  991  FORMAT (
-     &     'ICNTL(5)   Matrix format  ( keep(55) )             =',I10/
-     &     'ICNTL(6)   Maximum transversal  ( keep(23) )       =',I10/
+     &     'ICNTL(5)   Matrix format                           =',I10/
+     &     'ICNTL(6)   Maximum transversal                     =',I10/
      &     'ICNTL(7)   Ordering                                =',I10/
-     &     'ICNTL(12)  LDLT ordering strat ( keep(95) )        =',I10/
+     &     'ICNTL(12)  LDLT ordering strat                     =',I10/
      &     'ICNTL(13)  Parallel root (0=on, 1=off)             =',I10/
      &     'ICNTL(15)  Analysis by block                       =',I10/
-     &     'ICNTL(18)  Distributed matrix  ( keep(54) )        =',I10/
+     &     'ICNTL(18)  Distributed matrix                      =',I10/
      &     'ICNTL(19)  Schur option ( keep(60) 0=off,else=on ) =',I10/
      &     'ICNTL(22)  Out-of-core option (1=on, off otherwise)=',I10/
+     &     'ICNTL(48)  Tree based multithreading               =',I10/
      &     'ICNTL(58)  Symbolic factorization option           =',I10)
  891  FORMAT (
-     &     'ICNTL(5)   Matrix format  ( keep(55) )             =',I10/
-     &     'ICNTL(6)   Maximum transversal  ( keep(23) )       =',I10/
+     &     'ICNTL(5)   Matrix format                           =',I10/
+     &     'ICNTL(6)   Maximum transversal                     =',I10/
      &     'ICNTL(7)   Ordering                                =',I10/
      &     'ICNTL(13)  Parallel root (0=on, 1=off)             =',I10/
      &     'ICNTL(15)  Analysis by block                       =',I10/
-     &     'ICNTL(18)  Distributed matrix  ( keep(54) )        =',I10/
-     &     'ICNTL(19)  Schur option ( keep(60) 0=off,else=on ) =',I10/
+     &     'ICNTL(18)  Distributed matrix                      =',I10/
+     &     'ICNTL(19)  Schur option ( 0=off,else=on )          =',I10/
      &     'ICNTL(22)  Out-of-core option (1=on, off otherwise)=',I10/
+     &     'ICNTL(48)  Tree based multithreading               =',I10/
      &     'ICNTL(58)  Symbolic factorization option           =',I10)
  992  FORMAT (
      &     'ICNTL(8)   Scaling strategy                        =',I10)
@@ -2407,12 +2471,15 @@ C---------------------------------------
      &     'ICNTL(49)  Compact workarray S (end of facto.)     =',I10)
  993  FORMAT (
      &     'ICNTL(14)  Percent of memory increase              =',I10)
+ 996  FORMAT (
+     &     'ICNTL(56)  Null space functionality                =',I10) 
  995  FORMAT (
      &     'ICNTL(9)   Solve A x=b (1) or A''x = b (else)       =',I10/
      &     'ICNTL(10)  Max steps iterative refinement          =',I10/
      &     'ICNTL(11)  Error analysis (1=all,2=some,else=off)  =',I10/
      &     'ICNTL(20)  Den.(0)/sparse(1,2,3)/dist.(10,11) RHS  =',I10/
-     &     'ICNTL(21)  Gathered (0) or distributed(1) solution =',I10)
+     &     'ICNTL(21)  Gathered (0) or distributed(1) solution =',I10/
+     &     'ICNTL(26)  Solution step                           =',I10)
  998  FORMAT (
      &     '           Size of SCHUR matrix (SIZE_SCHUR)       =',I10)
       END SUBROUTINE CMUMPS_PRINT_ICNTL
@@ -2452,11 +2519,13 @@ C---------------------------------------
               WRITE (LP,992) KEEP(52)
            ENDIF   
            WRITE (LP,993) KEEP(12)
+           WRITE (LP,996) KEEP(19), KEEP(118)
+           WRITE (LP,994) KEEP(21)
          CASE(3);
            WRITE (LP,980)
            WRITE (LP,990) ICNTL(1),ICNTL(2),ICNTL(3),ICNTL(4) 
            WRITE (LP,995)
-     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21)
+     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21), ICNTL(26)
          CASE(4);
            WRITE (LP,980) 
            WRITE (LP,990) ICNTL(1),ICNTL(2),ICNTL(3),ICNTL(4)
@@ -2466,8 +2535,11 @@ C---------------------------------------
            WRITE (LP,991) KEEP(55),KEEP(23),ICNTL(7),KEEP(95),
      &          ICNTL(13),KEEP(54),KEEP(60),ICNTL(22)
            WRITE (LP,995)
-     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21)
+     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21), ICNTL(26)
            WRITE (LP,993) KEEP(12)
+           WRITE (LP,997) KEEP(53)
+           WRITE (LP,996) KEEP(19), KEEP(118)
+           WRITE (LP,994) KEEP(21)
          CASE(5);
            WRITE (LP,980) 
            WRITE (LP,990) ICNTL(1),ICNTL(2),ICNTL(3),ICNTL(4)
@@ -2481,6 +2553,8 @@ C---------------------------------------
               WRITE (LP,992) KEEP(52)
            ENDIF   
            WRITE (LP,993) KEEP(12)
+           WRITE (LP,996) KEEP(19), KEEP(118)
+           WRITE (LP,994) KEEP(21)
          CASE(6);
            WRITE (LP,980)
            WRITE (LP,990) ICNTL(1),ICNTL(2),ICNTL(3),ICNTL(4)
@@ -2494,8 +2568,11 @@ C---------------------------------------
               WRITE (LP,992) KEEP(52)
            ENDIF   
            WRITE (LP,995)
-     &     ICNTL(9),ICNTL(10),ICNTL(11),KEEP(248),ICNTL(21)
+     &     ICNTL(9),ICNTL(10),ICNTL(11),KEEP(248),ICNTL(21), ICNTL(26)
            WRITE (LP,993) KEEP(12)
+           WRITE (LP,997) KEEP(53)
+           WRITE (LP,996) KEEP(19), KEEP(118)
+           WRITE (LP,994) KEEP(21)
         END SELECT
       ENDIF
  980  FORMAT (/'******INTERNAL VALUE OF PARAMETERS (ICNTL/KEEP)****'/)
@@ -2522,7 +2599,15 @@ C---------------------------------------
      &     'ICNTL(10)  Max steps iterative refinement          =',I10/
      &     'ICNTL(11)  Error analysis ( 0= off, else=on)       =',I10/
      &     'ICNTL(20)  Den.(0)/sparse(1,2,3)/dist.(10,11) RHS  =',I10/
-     &     'ICNTL(21)  Gathered (0) or distributed(1) solution =',I10)
+     &     'ICNTL(21)  Gathered (0) or distributed(1) solution =',I10/
+     &     'ICNTL(26)  Solution step                           =',I10)
+ 997  FORMAT (
+     &     'ICNTL(56)  Null space-analysis      ( keep(53) )   =',I10) 
+ 996  FORMAT (
+     &     'ICNTL(56)  Null space-factorisation ( keep(19) )   =',I10/ 
+     &     'KEEP(118)  Algorithm used for null space           =',I10) 
+ 994  FORMAT (
+     &     'ICNTL(57)  Estimate of null space size ( keep(21) )=',I10)
       END SUBROUTINE CMUMPS_PRINT_KEEP
       SUBROUTINE CMUMPS_CHECK_DENSE_RHS
      &       (idRHS, idINFO, idN, idNRHS, idLRHS)
@@ -2581,7 +2666,7 @@ C           perform the check if minimal
       RETURN
       END SUBROUTINE CMUMPS_CHECK_DENSE_RHS
 C
-      SUBROUTINE CMUMPS_SET_K221(id)
+      SUBROUTINE CMUMPS_SET_K221(id,ATSOLVE)
       USE CMUMPS_STRUC_DEF
       IMPLICIT NONE
 C
@@ -2589,21 +2674,30 @@ C     Purpose:
 C     =======
 C
 C     Sets KEEP(221) on master.
-C     Constraint: must be called before CMUMPS_CHECK_REDRHS.
-C     Can be called at factorization or solve phase
+C     [Schur only] must be called before CMUMPS_CHECK_REDRHS 
+C       
+C     Can be called at factorization 
+C     (in case of fwd in facto) or at solve phase
+C     ATSOLVE=.TRUE. if called during solve phase
 C
       TYPE (CMUMPS_STRUC) :: id
+      LOGICAL, INTENT(IN) :: ATSOLVE 
+      LOGICAL :: PROKG
+      INTEGER :: MPG
       INTEGER MASTER
       PARAMETER( MASTER = 0 )
+      MPG = id%ICNTL( 3 )
+      PROKG = ( MPG .GT. 0 .and. id%MYID .eq. MASTER )
+      PROKG = (PROKG.AND.(id%ICNTL(4).GE.2))
       IF (id%MYID.EQ.MASTER) THEN
         id%KEEP(221)=id%ICNTL(26)
-        IF (id%KEEP(221).ne.0 .and. id%KEEP(221) .NE.1
-     &      .AND.id%KEEP(221).ne.2) id%KEEP(221)=0
+        IF (id%KEEP(221).NE.0 .AND. id%KEEP(221) .NE.1
+     &      .AND.id%KEEP(221).NE.2) id%KEEP(221)=0
       ENDIF
       RETURN
       END SUBROUTINE CMUMPS_SET_K221
 C
-      SUBROUTINE CMUMPS_CHECK_REDRHS(id)
+      SUBROUTINE CMUMPS_CHECK_K221andREDRHS(id)
       USE CMUMPS_STRUC_DEF
       IMPLICIT NONE
 C
@@ -2616,17 +2710,22 @@ C  * Constraints:
 C    - Must be called after solve phase.
 C    - KEEP(60) must have been set (ok to check
 C    since KEEP(60) was set during analysis phase)
-C  * Remark that during solve phase, ICNTL(26)=1 is
+C  * Remark that during solve phase, ICNTL(26)#0 is
 C    forbidden in case of fwd in facto.
 C
       TYPE (CMUMPS_STRUC) :: id
       INTEGER MASTER
       PARAMETER( MASTER = 0 )
+C     write(6,*) " Entering CMUMPS_CHECK_K221andREDRHS with : ", 
+C    & " id%JOB, id%KEEP(221), id%KEEP(60), id%SIZE_SCHUR= ", 
+C    & id%JOB, id%KEEP(221), id%KEEP(60), id%SIZE_SCHUR
       IF (id%MYID .EQ. MASTER) THEN
           IF ( id%KEEP(221) == 1 .or. id%KEEP(221) == 2 ) THEN
-            IF (id%KEEP(221) == 2 .and. id%JOB == 2) THEN
-              id%INFO(1)=-35
-              id%INFO(2)=id%KEEP(221)
+            IF (id%KEEP(221) == 2 .and. 
+     &                ( id%JOB .NE.3 )
+     &         ) THEN
+              id%INFO(1)=-33
+              id%INFO(2)=id%JOB
               GOTO 333
             ENDIF
             IF (id%KEEP(221) == 1 .and. id%KEEP(252) == 1
@@ -2637,29 +2736,39 @@ C
             IF ( id%KEEP(60).eq. 0 .or. id%SIZE_SCHUR.EQ.0 ) THEN
               id%INFO(1)=-33
               id%INFO(2)=id%KEEP(221)
+C              write(6,*) " id%KEEP(60), id%SIZE_SCHUR=", 
+C     &            id%KEEP(60), id%SIZE_SCHUR
               GOTO 333
             ENDIF
-            IF ( .NOT. associated( id%REDRHS)) THEN
-              id%INFO(1)=-22
-              id%INFO(2)=15
-              GOTO 333
-            ELSE IF (id%NRHS.EQ.1) THEN
-              IF (size(id%REDRHS) < id%SIZE_SCHUR ) THEN
+            IF ( id%KEEP(60).NE.0 ) THEN
+C           Schur feature
+              IF ( id%SIZE_SCHUR.EQ.0 ) THEN
+                id%INFO(1)=-33
+                id%INFO(2)=id%KEEP(221)
+                GOTO 333
+              ENDIF
+              IF ( .NOT. associated( id%REDRHS)) THEN
+                id%INFO(1)=-22
+                id%INFO(2)=15
+                GOTO 333
+              ELSE IF (id%NRHS.EQ.1) THEN
+                IF (size(id%REDRHS) < id%SIZE_SCHUR ) THEN
+                  id%INFO(1)=-22
+                  id%INFO(2)=15
+                  GOTO 333
+                ENDIF
+              ELSE IF (id%LREDRHS < id%SIZE_SCHUR) THEN
+                id%INFO(1)=-34
+                id%INFO(2)=id%LREDRHS
+                GOTO 333
+              ELSE IF
+     &        (size(id%REDRHS)<
+     &           id%NRHS*id%LREDRHS-id%LREDRHS+id%SIZE_SCHUR)
+     &        THEN
                 id%INFO(1)=-22
                 id%INFO(2)=15
                 GOTO 333
               ENDIF
-            ELSE IF (id%LREDRHS < id%SIZE_SCHUR) THEN
-              id%INFO(1)=-34
-              id%INFO(2)=id%LREDRHS
-              GOTO 333
-            ELSE IF
-     &      (size(id%REDRHS)<
-     &         id%NRHS*id%LREDRHS-id%LREDRHS+id%SIZE_SCHUR)
-     &      THEN
-              id%INFO(1)=-22
-              id%INFO(2)=15
-              GOTO 333
             ENDIF
           ENDIF
       ENDIF
@@ -2668,4 +2777,4 @@ C     Error is not propagated. It should
 C     The reason to propagate it outside is that there can be
 C     one call to PROPINFO instead of several ones.
       RETURN
-      END SUBROUTINE CMUMPS_CHECK_REDRHS
+      END SUBROUTINE CMUMPS_CHECK_K221andREDRHS
diff -pruN 5.6.2-2.1/src/cmumps_f77.F 5.7.1-1/src/cmumps_f77.F
--- 5.6.2-2.1/src/cmumps_f77.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/cmumps_f77.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -16,8 +16,9 @@ C
      &     JCNhere, A, Ahere, NZ_loc, NNZ_loc, IRN_loc, IRN_lochere,
      &     JCN_loc, JCN_lochere, A_loc, A_lochere, NELT, ELTPTR,
      &     ELTPTRhere,  ELTVAR, ELTVARhere, A_ELT, A_ELThere,
-     &     BLKPTR, BLKPTRhere, BLKVAR, BLKVARhere,
-     &     PERM_IN, PERM_INhere, RHS, RHShere, REDRHS, REDRHShere,
+     &     BLKPTR, BLKPTRhere, BLKVAR, BLKVARhere, PERM_IN, PERM_INhere,
+     &     ROWIND, ROWINDhere, COLIND, COLINDhere, PIVOTS, PIVOTShere,
+     &     RHS, RHShere, REDRHS, REDRHShere,
      &     INFO, RINFO, INFOG, RINFOG, DEFICIENCY, LWK_USER,
      &     SIZE_SCHUR, LISTVAR_SCHUR, LISTVAR_SCHURhere, SCHUR,
      &     SCHURhere, WK_USER, WK_USERhere, COLSCA, COLSCAhere,
@@ -26,31 +27,38 @@ C
      &     RHS_loc, RHS_lochere,
      &     IRHS_SPARSE, IRHS_SPARSEhere, IRHS_PTR, IRHS_PTRhere,
      &     ISOL_loc, ISOL_lochere, IRHS_loc, IRHS_lochere, NZ_RHS,
-     &     LSOL_loc, LRHS_loc, Nloc_RHS,
+     &     LSOL_loc, LRHS_loc, NSOL_loc, Nloc_RHS,
      &     SCHUR_MLOC, SCHUR_NLOC, SCHUR_LLD,
-     &     MBLOCK, NBLOCK, NPROW, NPCOL,  
+     &     MBLOCK, NBLOCK, NPROW, NPCOL, LD_RHSINTR,
      &     OOC_TMPDIR, OOC_PREFIX, WRITE_PROBLEM,
+#if ! defined(NO_SAVE_RESTORE)
      &     SAVE_DIR, SAVE_PREFIX,
+#endif
      &     TMPDIRLEN, PREFIXLEN, WRITE_PROBLEMLEN,
+#if ! defined(NO_SAVE_RESTORE)
      &     SAVE_DIRLEN, SAVE_PREFIXLEN,
+#endif
      &     METIS_OPTIONS
      &     )
       USE CMUMPS_STRUC_DEF
       IMPLICIT NONE
       INTEGER OOC_PREFIX_MAX_LENGTH, OOC_TMPDIR_MAX_LENGTH
       INTEGER PB_MAX_LENGTH
-      PARAMETER(OOC_PREFIX_MAX_LENGTH=63, OOC_TMPDIR_MAX_LENGTH=255)
-      PARAMETER(PB_MAX_LENGTH=255)
-      INTEGER, PARAMETER :: SAVE_DIR_MAX_LENGTH    = 255
+      PARAMETER(OOC_PREFIX_MAX_LENGTH=255, OOC_TMPDIR_MAX_LENGTH=1023)
+      PARAMETER(PB_MAX_LENGTH=1023)
+#if ! defined(NO_SAVE_RESTORE)
+      INTEGER, PARAMETER :: SAVE_DIR_MAX_LENGTH    = 1023
       INTEGER, PARAMETER :: SAVE_PREFIX_MAX_LENGTH = 255
+#endif
       INTEGER JOB, SYM, PAR, COMM_F77, N, NBLK, NZ, NZ_loc, NELT,
      &        DEFICIENCY, LWK_USER, SIZE_SCHUR, INSTANCE_NUMBER,
      &        NRHS, LRHS,
-     &        NZ_RHS, LSOL_loc,Nloc_RHS, LRHS_loc, LREDRHS
+     &        NZ_RHS, LSOL_loc,Nloc_RHS, LRHS_loc, NSOL_loc, LREDRHS
       INTEGER(8) :: NNZ, NNZ_loc
       INTEGER ICNTL(60), INFO(80), INFOG(80), KEEP(500)
       INTEGER SCHUR_MLOC, SCHUR_NLOC, SCHUR_LLD
       INTEGER MBLOCK, NBLOCK, NPROW, NPCOL
+      INTEGER LD_RHSINTR
       INTEGER TMPDIRLEN, PREFIXLEN, WRITE_PROBLEMLEN
       REAL CNTL(15), RINFO(40), RINFOG(40), DKEEP(230)
       INTEGER(8) KEEP8(150)
@@ -61,6 +69,8 @@ C
       INTEGER, TARGET :: ISOL_loc(*), IRHS_loc(*)
       INTEGER, TARGET :: BLKPTR(*), BLKVAR(*)
       COMPLEX, TARGET :: A(*), A_ELT(*), A_loc(*), RHS(*)
+      INTEGER, TARGET :: ROWIND(*), COLIND(*)
+      COMPLEX, TARGET :: PIVOTS(*)
       COMPLEX, TARGET :: WK_USER(*)
       COMPLEX, TARGET :: REDRHS(*)
       REAL, TARGET :: ROWSCA(*), COLSCA(*)
@@ -69,13 +79,15 @@ C
       INTEGER, INTENT(inout) :: OOC_TMPDIR(OOC_TMPDIR_MAX_LENGTH)
       INTEGER, INTENT(inout) :: OOC_PREFIX(OOC_PREFIX_MAX_LENGTH)
       INTEGER, INTENT(in) :: WRITE_PROBLEM(PB_MAX_LENGTH)
+#if ! defined(NO_SAVE_RESTORE)
       INTEGER SAVE_DIRLEN, SAVE_PREFIXLEN
       INTEGER, INTENT(in) :: SAVE_DIR(SAVE_DIR_MAX_LENGTH)
       INTEGER, INTENT(in) :: SAVE_PREFIX(SAVE_PREFIX_MAX_LENGTH)
+#endif
       INTEGER METIS_OPTIONS(40)
       INTEGER IRNhere, JCNhere, Ahere, ELTPTRhere, ELTVARhere,
      &        A_ELThere, BLKPTRhere, BLKVARhere, PERM_INhere,
-     &        WK_USERhere,
+     &        WK_USERhere, ROWINDhere, COLINDhere, PIVOTShere,
      &        RHShere, REDRHShere, IRN_lochere,
      &        JCN_lochere, A_lochere, LISTVAR_SCHURhere,
      &        SCHURhere, COLSCAhere, ROWSCAhere, RHS_SPARSEhere,
@@ -99,9 +111,27 @@ C
       EXTERNAL MUMPS_ASSIGN_MAPPING,
      &         MUMPS_ASSIGN_PIVNUL_LIST,
      &         MUMPS_ASSIGN_SYM_PERM,
-     &         MUMPS_ASSIGN_UNS_PERM
+     &         MUMPS_ASSIGN_UNS_PERM,
+     &         MUMPS_ASSIGN_GLOB2LOC_RHS,
+     &         MUMPS_ASSIGN_GLOB2LOC_SOL
+      EXTERNAL MUMPS_NULLIFY_C_MAPPING,
+     &         MUMPS_NULLIFY_C_PIVNUL_LIST,
+     &         MUMPS_NULLIFY_C_SYM_PERM,
+     &         MUMPS_NULLIFY_C_UNS_PERM,
+     &         MUMPS_NULLIFY_C_GLOB2LOC_RHS,
+     &         MUMPS_NULLIFY_C_GLOB2LOC_SOL
       EXTERNAL CMUMPS_ASSIGN_COLSCA,
-     &         CMUMPS_ASSIGN_ROWSCA
+     &         CMUMPS_ASSIGN_ROWSCA,
+     &         CMUMPS_ASSIGN_ROWSCA_LOC,
+     &         CMUMPS_ASSIGN_COLSCA_LOC,
+     &         CMUMPS_ASSIGN_RHSINTR,
+     &         CMUMPS_ASSIGN_SINGULAR_VALUES
+      EXTERNAL CMUMPS_NULLIFY_C_COLSCA,
+     &         CMUMPS_NULLIFY_C_ROWSCA,
+     &         CMUMPS_NULLIFY_C_ROWSCA_LOC,
+     &         CMUMPS_NULLIFY_C_COLSCA_LOC,
+     &         CMUMPS_NULLIFY_C_RHSINTR,
+     &         CMUMPS_NULLIFY_C_SING_VALUES
       IF (JOB == -1) THEN
         DO I = 1, CMUMPS_STRUC_ARRAY_SIZE
           IF ( .NOT. associated(mumps_par_array(I)%PTR) ) GOTO 10
@@ -175,20 +205,22 @@ C
       CALL MUMPS_ADDR_C( ICNTL(50), mumps_par%KEEP8(83) )
       CALL MUMPS_ADDR_C( RINFO(3), mumps_par%KEEP8(84) )
       mumps_par%METIS_OPTIONS(1:40)=METIS_OPTIONS(1:40)
-      mumps_par%NRHS  = NRHS
-      mumps_par%LRHS  = LRHS
-      mumps_par%LREDRHS = LREDRHS
-      mumps_par%NZ_RHS   = NZ_RHS
-      mumps_par%LSOL_loc = LSOL_loc
-      mumps_par%Nloc_RHS = Nloc_RHS
-      mumps_par%LRHS_loc = LRHS_loc
+      mumps_par%NRHS         = NRHS
+      mumps_par%LRHS         = LRHS
+      mumps_par%LREDRHS      = LREDRHS
+      mumps_par%NZ_RHS       = NZ_RHS
+      mumps_par%LSOL_loc     = LSOL_loc
+      mumps_par%Nloc_RHS     = Nloc_RHS
+      mumps_par%LRHS_loc     = LRHS_loc
+      mumps_par%NSOL_loc     = NSOL_loc
       mumps_par%SCHUR_MLOC   = SCHUR_MLOC
       mumps_par%SCHUR_NLOC   = SCHUR_NLOC
       mumps_par%SCHUR_LLD    = SCHUR_LLD
-      mumps_par%MBLOCK = MBLOCK
-      mumps_par%NBLOCK = NBLOCK
-      mumps_par%NPROW  = NPROW
-      mumps_par%NPCOL  = NPCOL
+      mumps_par%MBLOCK       = MBLOCK
+      mumps_par%NBLOCK       = NBLOCK
+      mumps_par%NPROW        = NPROW
+      mumps_par%NPCOL        = NPCOL
+      mumps_par%LD_RHSINTR   = LD_RHSINTR
       IF ( COMM_F77 .NE. -987654 ) THEN
         mumps_par%COMM = COMM_F77
       ELSE
@@ -226,6 +258,20 @@ C
       IF ( SCHURhere /= 0 ) THEN
         mumps_par%SCHUR_CINTERFACE=>SCHUR(1:1)
       ENDIF
+      IF (ROWINDhere /= 0) THEN
+        mumps_par%ROWIND => ROWIND(1:KEEP(89))
+      ENDIF
+      IF (COLINDhere /= 0) THEN
+        mumps_par%COLIND => COLIND(1:KEEP(89))
+      ENDIF
+      IF (PIVOTShere /= 0) THEN
+        IF (KEEP(50) .EQ.0 .OR.KEEP(50).EQ.1) THEN
+          mumps_par%PIVOTS => PIVOTS(1:KEEP(89))
+        ELSE
+          mumps_par%PIVOTS => PIVOTS(1_8:
+     &                        int(KEEP(89),8)+int(KEEP(89),8))
+        ENDIF
+      ENDIF
       IF (NRHS .NE. 1) THEN
         IF ( RHShere /= 0 ) mumps_par%RHS =>
      &                      RHS(1_8:int(NRHS,8)*int(LRHS,8))
@@ -276,6 +322,7 @@ C
       DO I=WRITE_PROBLEMLEN+1,PB_MAX_LENGTH
         mumps_par%WRITE_PROBLEM(I:I)=' '
       ENDDO
+#if ! defined(NO_SAVE_RESTORE)
       DO I=1,SAVE_DIRLEN
         mumps_par%SAVE_DIR(I:I)=char(SAVE_DIR(I))
       ENDDO
@@ -288,6 +335,7 @@ C
       DO I=SAVE_PREFIXLEN+1,SAVE_PREFIX_MAX_LENGTH
         mumps_par%SAVE_PREFIX(I:I)=' '
       ENDDO
+#endif
       CALL CMUMPS( mumps_par )
       INFO(1:80)=mumps_par%INFO(1:80)
       INFOG(1:80)=mumps_par%INFOG(1:80)
@@ -315,6 +363,7 @@ C
       LSOL_loc   = mumps_par%LSOL_loc
       Nloc_RHS   = mumps_par%Nloc_RHS
       LRHS_loc   = mumps_par%LRHS_loc
+      NSOL_loc   = mumps_par%NSOL_loc
       SIZE_SCHUR = mumps_par%SIZE_SCHUR
       LWK_USER   = mumps_par%LWK_USER
       NELT       = mumps_par%NELT
@@ -326,6 +375,7 @@ C
       NBLOCK     = mumps_par%NBLOCK
       NPROW      = mumps_par%NPROW
       NPCOL      = mumps_par%NPCOL
+      LD_RHSINTR = mumps_par%LD_RHSINTR
       IF ( associated (mumps_par%MAPPING) ) THEN
          CALL MUMPS_ASSIGN_MAPPING(mumps_par%MAPPING(1))
       ELSE
@@ -336,6 +386,12 @@ C
       ELSE
          CALL MUMPS_NULLIFY_C_PIVNUL_LIST()
       ENDIF
+      IF ( associated (mumps_par%SINGULAR_VALUES) ) THEN
+         CALL CMUMPS_ASSIGN_SINGULAR_VALUES(
+     &                  mumps_par%SINGULAR_VALUES(1))
+      ELSE
+         CALL CMUMPS_NULLIFY_C_SING_VALUES()
+      ENDIF
       IF ( associated (mumps_par%SYM_PERM) ) THEN
          CALL MUMPS_ASSIGN_SYM_PERM(mumps_par%SYM_PERM(1))
       ELSE
@@ -346,22 +402,47 @@ C
       ELSE
          CALL MUMPS_NULLIFY_C_UNS_PERM()
       ENDIF
-      IF (associated( mumps_par%COLSCA)) THEN
+      IF ( associated (mumps_par%COLSCA_loc) ) THEN
+         CALL CMUMPS_ASSIGN_COLSCA_LOC(1)
+      ELSE
+         CALL CMUMPS_NULLIFY_C_COLSCA_LOC()
+      ENDIF
+      IF ( associated (mumps_par%ROWSCA_loc) ) THEN
+         CALL CMUMPS_ASSIGN_ROWSCA_LOC(1)
+      ELSE
+         CALL CMUMPS_NULLIFY_C_ROWSCA_LOC()
+      ENDIF
+      IF (associated( mumps_par%COLSCA )) THEN
           CALL CMUMPS_ASSIGN_COLSCA(mumps_par%COLSCA(1))
       ELSE
           CALL CMUMPS_NULLIFY_C_COLSCA()
       ENDIF
-      IF (associated( mumps_par%ROWSCA)) THEN
+      IF (associated( mumps_par%ROWSCA )) THEN
           CALL CMUMPS_ASSIGN_ROWSCA(mumps_par%ROWSCA(1))
       ELSE
           CALL CMUMPS_NULLIFY_C_ROWSCA()
       ENDIF
+      IF (associated( mumps_par%RHSINTR )) THEN
+          CALL CMUMPS_ASSIGN_RHSINTR(mumps_par%RHSINTR(1))
+      ELSE
+          CALL CMUMPS_NULLIFY_C_RHSINTR()
+      ENDIF
+      IF (associated(mumps_par%GLOB2LOC_RHS)) THEN
+          CALL MUMPS_ASSIGN_GLOB2LOC_RHS(mumps_par%GLOB2LOC_RHS(1))
+      ELSE
+          CALL MUMPS_NULLIFY_C_GLOB2LOC_RHS()
+      ENDIF
+      IF (associated(mumps_par%GLOB2LOC_SOL)) THEN
+          CALL MUMPS_ASSIGN_GLOB2LOC_SOL(mumps_par%GLOB2LOC_SOL(1))
+      ELSE
+          CALL MUMPS_NULLIFY_C_GLOB2LOC_SOL()
+      ENDIF
       TMPDIRLEN=len_trim(mumps_par%OOC_TMPDIR)
-      DO I=1,OOC_TMPDIR_MAX_LENGTH
+      DO I=1,TMPDIRLEN
          OOC_TMPDIR(I)=ichar(mumps_par%OOC_TMPDIR(I:I))
       ENDDO
       PREFIXLEN=len_trim(mumps_par%OOC_PREFIX)
-      DO I=1,OOC_PREFIX_MAX_LENGTH
+      DO I=1,PREFIXLEN
          OOC_PREFIX(I)=ichar(mumps_par%OOC_PREFIX(I:I))
       ENDDO
       IF ( JOB == -2 ) THEN
diff -pruN 5.6.2-2.1/src/cmumps_gpu.c 5.7.1-1/src/cmumps_gpu.c
--- 5.6.2-2.1/src/cmumps_gpu.c	2023-10-11 09:36:34.000000000 +0000
+++ 5.7.1-1/src/cmumps_gpu.c	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/cmumps_gpu.h 5.7.1-1/src/cmumps_gpu.h
--- 5.6.2-2.1/src/cmumps_gpu.h	2023-10-11 09:36:34.000000000 +0000
+++ 5.7.1-1/src/cmumps_gpu.h	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/cmumps_iXamax.F 5.7.1-1/src/cmumps_iXamax.F
--- 5.6.2-2.1/src/cmumps_iXamax.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/cmumps_iXamax.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/cmumps_load.F 5.7.1-1/src/cmumps_load.F
--- 5.6.2-2.1/src/cmumps_load.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/cmumps_load.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -793,7 +793,7 @@ C
          CALL CMUMPS_BUF_BROADCAST( WHAT,
      &        COMM_LD, NPROCS,
      &        FUTURE_NIV2,
-     &        dble(MEMORY_MD),dble(0) ,MYID, id%KEEP, IERR  )
+     &        dble(MEMORY_MD),dble(0) ,MYID, id%KEEP(267), IERR )
          WHAT=9
          MEMORY_SENT = dble(LA-MAX_SURF_MASTER)-MAX_SBTR
      &      - max( dble(LA) * dble(3) / dble(100),
@@ -811,7 +811,7 @@ C
      &        COMM_LD, NPROCS,
      &        FUTURE_NIV2,
      &        MEMORY_SENT,
-     &        dble(0),MYID, id%KEEP, IERR  )
+     &        dble(0),MYID, id%KEEP(267), IERR  )
       ENDIF
       RETURN
       END SUBROUTINE CMUMPS_LOAD_INIT
@@ -1907,7 +1907,7 @@ C
         CALL CMUMPS_BUF_BROADCAST( WHAT,
      &         COMM, SLAVEF,
      &               FUTURE_NIV2,
-     &         COST, dble(0), MYID, KEEP, IERR  )
+     &         COST, dble(0), MYID, KEEP(267), IERR  )
         POOL_LAST_COST_SENT = COST
         POOL_MEM(MYID)=COST
         IF ( IERR == -1 )THEN
@@ -1970,7 +1970,7 @@ C
      &           WHAT, COMM, SLAVEF,
      &           FUTURE_NIV2,
      &           dble(MEM_SUBTREE(INDICE_SBTR)), dble(0),
-     &           MYID, KEEP, IERR  )
+     &           MYID, KEEP(267), IERR  )
             IF ( IERR == -1 )THEN
                CALL CMUMPS_LOAD_RECV_MSGS(COMM_LD)
                CALL MUMPS_CHECK_COMM_NODES(COMM_NODES, EXIT_FLAG)
@@ -2000,7 +2000,7 @@ C
                CALL CMUMPS_BUF_BROADCAST(
      &              WHAT, COMM, SLAVEF,
      &              FUTURE_NIV2,
-     &              COST, dble(0), MYID, KEEP, IERR  )
+     &              COST, dble(0), MYID, KEEP(267), IERR  )
                IF ( IERR == -1 )THEN
                   CALL CMUMPS_LOAD_RECV_MSGS(COMM_LD)
                   CALL MUMPS_CHECK_COMM_NODES(COMM_NODES, EXIT_FLAG)
@@ -4648,10 +4648,8 @@ C
       INTEGER J
       DOUBLE PRECISION MEM_COST
       INTEGER NBINSUBTREE,i,NBTOP
-      EXTERNAL CMUMPS_POOL_EMPTY,
-     & MUMPS_IN_OR_ROOT_SSARBR
-      LOGICAL CMUMPS_POOL_EMPTY,
-     & MUMPS_IN_OR_ROOT_SSARBR
+      EXTERNAL MUMPS_IN_OR_ROOT_SSARBR
+      LOGICAL MUMPS_IN_OR_ROOT_SSARBR
       NBINSUBTREE = POOL(LPOOL)
       NBTOP       = POOL(LPOOL - 1)
       IF(KEEP(47).LT.2)THEN
@@ -4755,8 +4753,6 @@ C
       LOGICAL FLAG, EXIT_FLAG
       DOUBLE PRECISION COST
       DOUBLE PRECISION TO_BE_SENT
-      EXTERNAL MUMPS_TYPENODE
-      INTEGER MUMPS_TYPENODE
       IF(FLAG)THEN
          WHAT=17 
          IF(BDC_M2_FLOPS)THEN
@@ -4783,7 +4779,7 @@ C
      &               FUTURE_NIV2,
      &         COST, 
      &         TO_BE_SENT, 
-     &         MYID, KEEP_LOAD, IERR  )
+     &         MYID, KEEP_LOAD(267), IERR  )
       IF ( IERR == -1 )THEN
          CALL CMUMPS_LOAD_RECV_MSGS(COMM_LD)
          CALL MUMPS_CHECK_COMM_NODES(COMM_NODES, EXIT_FLAG)
@@ -4946,8 +4942,6 @@ C
       RECURSIVE SUBROUTINE CMUMPS_PROCESS_NIV2_MEM_MSG(INODE)
       IMPLICIT NONE
       INTEGER INODE
-      EXTERNAL MUMPS_TYPENODE
-      INTEGER MUMPS_TYPENODE
       IF((INODE.EQ.KEEP_LOAD(20)).OR.
      &     (INODE.EQ.KEEP_LOAD(38)))THEN
          RETURN
@@ -4985,8 +4979,6 @@ C
       RECURSIVE SUBROUTINE CMUMPS_PROCESS_NIV2_FLOPS_MSG(INODE)
       IMPLICIT NONE
       INTEGER INODE
-      EXTERNAL MUMPS_TYPENODE
-      INTEGER MUMPS_TYPENODE
       IF((INODE.EQ.KEEP_LOAD(20)).OR.
      &     (INODE.EQ.KEEP_LOAD(38)))THEN
          RETURN
diff -pruN 5.6.2-2.1/src/cmumps_lr_data_m.F 5.7.1-1/src/cmumps_lr_data_m.F
--- 5.6.2-2.1/src/cmumps_lr_data_m.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/cmumps_lr_data_m.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -35,7 +35,9 @@ C
      &  , BLR_STRUC_T, blr_panel_type, diag_block_type
 #endif
      &  , CMUMPS_BLR_SAVE_DIAG_BLOCK, CMUMPS_BLR_RETRIEVE_DIAG_BLOCK
+#if ! defined(NO_SAVE_RESTORE)
      &  , CMUMPS_SAVE_RESTORE_BLR
+#endif      
       TYPE blr_panel_type
          integer                 :: NB_ACCESSES_LEFT
          type(LRB_TYPE), pointer :: LRB_PANEL(:)
@@ -68,6 +70,9 @@ C
      &           PANELS_NOTUSED=-1111, PANELS_FREED=-2222, 
      &           NB_PANELS_NOTINIT=-3333, 
      &           NFS4FATHER_NOTINIT=-4444 )
+#if ! defined(NO_SAVE_RESTORE)
+      INCLUDE 'mumps_save_restore_modes.h'
+#endif
       CONTAINS
       SUBROUTINE CMUMPS_BLR_INIT_MODULE(INITIAL_SIZE, INFO)
        INTEGER, INTENT(IN) :: INITIAL_SIZE
@@ -1062,6 +1067,7 @@ C
        ENDIF
        RETURN
        END SUBROUTINE CMUMPS_BLR_FREE_ALL_PANELS
+#if ! defined(NO_SAVE_RESTORE)
       SUBROUTINE CMUMPS_SAVE_RESTORE_BLR(id_BLRARRAY_ENCODING
      &                 ,unit,MYID,mode
      &                 ,SIZE_GEST,SIZE_VARIABLES
@@ -1072,7 +1078,7 @@ C
       INCLUDE 'mpif.h'
       CHARACTER, DIMENSION(:), POINTER :: id_BLRARRAY_ENCODING
       INTEGER,intent(IN)::unit,MYID
-      CHARACTER(len=*),intent(IN) :: mode
+      INTEGER,intent(IN) :: mode
       INTEGER,INTENT(OUT) :: SIZE_GEST
       INTEGER(8),intent(OUT) :: SIZE_VARIABLES
       INTEGER(8),intent(IN) :: TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
@@ -1090,10 +1096,10 @@ C
       SIZE_VARIABLES_BLR_ARRAY_j1=0_8
       SIZE_GEST=0
       SIZE_VARIABLES=0_8
-      if((trim(mode).EQ."memory_save").OR.(trim(mode).EQ."save")) then
+      if(mode.EQ.memory_save_mode.OR.mode.EQ.save_mode) then
          call CMUMPS_BLR_STRUC_TO_MOD(id_BLRARRAY_ENCODING)
       endif
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          IF(associated(BLR_ARRAY)) THEN
             NbRecords=1
             SIZE_GEST=SIZE_INT
@@ -1101,7 +1107,7 @@ C
             DO j1=1,size(BLR_ARRAY,1)
                CALL CMUMPS_SAVE_RESTORE_BLR_STRUC(
      &              BLR_ARRAY(j1)
-     &              ,unit,MYID,"memory_save"
+     &              ,unit,MYID,memory_save_mode
      &              ,SIZE_GEST_BLR_ARRAY_j1
      &              ,SIZE_VARIABLES_BLR_ARRAY_j1
      &              ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -1118,7 +1124,7 @@ C
             SIZE_GEST=SIZE_INT*2
             SIZE_VARIABLES=0
          ENDIF
-      elseif(trim(mode).EQ."save") then
+      elseif(mode.EQ.save_mode) then
          IF(associated(BLR_ARRAY)) THEN
             NbRecords=1
             SIZE_GEST=SIZE_INT
@@ -1133,7 +1139,7 @@ C
             DO j1=1,size(BLR_ARRAY,1)
                CALL CMUMPS_SAVE_RESTORE_BLR_STRUC(
      &              BLR_ARRAY(j1)
-     &              ,unit,MYID,"save"
+     &              ,unit,MYID,save_mode
      &              ,SIZE_GEST_BLR_ARRAY_j1
      &              ,SIZE_VARIABLES_BLR_ARRAY_j1
      &              ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -1161,7 +1167,7 @@ C
             endif
             IF ( INFO(1) .LT. 0 ) GOTO 100
          ENDIF 
-      elseif(trim(mode).EQ."restore") then
+      elseif(mode.EQ.restore_mode) then
          nullify(BLR_ARRAY)
          read(unit,iostat=err) size_array1
          if(err.ne.0) THEN
@@ -1195,7 +1201,7 @@ C
             DO j1=1,size_array1
                CALL CMUMPS_SAVE_RESTORE_BLR_STRUC(
      &              BLR_ARRAY(j1)
-     &              ,unit,MYID,"restore"
+     &              ,unit,MYID,restore_mode
      &              ,SIZE_GEST_BLR_ARRAY_j1
      &              ,SIZE_VARIABLES_BLR_ARRAY_j1
      &              ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -1209,19 +1215,19 @@ C
             ENDDO
          endif
       endif
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          NbSubRecords=int(SIZE_VARIABLES/huge(I4))
          IF(NbSubRecords.GT.0) then
             NbRecords=NbRecords+NbSubRecords
          ENDIF
-      elseif(trim(mode).EQ."save") then
+      elseif(mode.EQ.save_mode) then
          size_written=size_written+SIZE_VARIABLES
      &        +int(SIZE_GEST,kind=8)
 #if defined(MUMPS_NOF2003)
          size_written=size_written
      &        +int(2*SIZE_INT*NbRecords,kind=8)
 #endif
-      elseif(trim(mode).EQ."restore") then
+      elseif(mode.EQ.restore_mode) then
          size_allocated=size_allocated+SIZE_VARIABLES
          size_read=size_read+SIZE_VARIABLES
      &        +int(SIZE_GEST,kind=8)
@@ -1230,7 +1236,7 @@ C
      &        +int(2*SIZE_INT*NbRecords,kind=8)
 #endif
       endif
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          SIZE_VARIABLES=SIZE_VARIABLES+SIZE_VARIABLES_BLR_ARRAY
          SIZE_GEST=SIZE_GEST+SIZE_GEST_BLR_ARRAY
 #if defined(MUMPS_NOF2003)
@@ -1251,18 +1257,29 @@ C
       INCLUDE 'mpif.h'
       TYPE(BLR_STRUC_T) :: BLR_STRUC
       INTEGER,intent(IN)::unit,MYID
-      CHARACTER(len=*),intent(IN) :: mode
+      INTEGER,intent(IN) :: mode
       INTEGER,INTENT(OUT) :: Local_SIZE_GEST
       INTEGER(8),intent(OUT) :: Local_SIZE_VARIABLES
       INTEGER,intent(INOUT):: INFO(2)
       INTEGER,intent(IN):: SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
       INTEGER(8),intent(IN) :: TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
       INTEGER(8),intent(INOUT):: size_read,size_allocated,size_written
-      INTEGER :: NBVARIABLES_BLR_STRUC_T
-      PARAMETER (NBVARIABLES_BLR_STRUC_T = 15)
-      CHARACTER(len=30), dimension(NBVARIABLES_BLR_STRUC_T)::
-     &     VARIABLES_BLR_STRUC_T
-      CHARACTER(len=30) :: TMP_STRING
+      INTEGER, PARAMETER :: NBVARIABLES_BLR_STRUC_T = 15
+      INTEGER, PARAMETER :: B_IsSYM=1
+      INTEGER, PARAMETER :: B_IsT2=2
+      INTEGER, PARAMETER :: B_IsSLAVE=3
+      INTEGER, PARAMETER :: B_PANELS_L=4
+      INTEGER, PARAMETER :: B_PANELS_U=5
+      INTEGER, PARAMETER :: B_CB_LRB=6
+      INTEGER, PARAMETER :: B_DIAG_BLOCKS=7
+      INTEGER, PARAMETER :: B_BEGS_BLR_STATIC=8
+      INTEGER, PARAMETER :: B_BEGS_BLR_DYNAMIC=9
+      INTEGER, PARAMETER :: B_BEGS_BLR_L=10
+      INTEGER, PARAMETER :: B_BEGS_BLR_COL=11
+      INTEGER, PARAMETER :: B_NB_ACCESSES_INIT=12
+      INTEGER, PARAMETER :: B_NB_PANELS=13
+      INTEGER, PARAMETER :: B_NFS4FATHER=14
+      INTEGER, PARAMETER :: B_M_ARRAY=15
       INTEGER(8),dimension(NBVARIABLES_BLR_STRUC_T)::
      &     SIZE_VARIABLES_BLR_STRUC_T
       INTEGER,dimension(NBVARIABLES_BLR_STRUC_T)::SIZE_GEST_BLR_STRUC_T
@@ -1282,21 +1299,6 @@ C
       INTEGER(8)::SIZE_VARIABLES_DIAG_BLOCKS
       INTEGER(8)::SIZE_VARIABLES_DIAG_BLOCKS_j1
       INTEGER(4)::I4
-      VARIABLES_BLR_STRUC_T(1)="IsSYM"
-      VARIABLES_BLR_STRUC_T(2)="IsT2"
-      VARIABLES_BLR_STRUC_T(3)="IsSLAVE"
-      VARIABLES_BLR_STRUC_T(4)="PANELS_L"
-      VARIABLES_BLR_STRUC_T(5)="PANELS_U"
-      VARIABLES_BLR_STRUC_T(6)="CB_LRB"
-      VARIABLES_BLR_STRUC_T(7)="BEGS_BLR_STATIC"
-      VARIABLES_BLR_STRUC_T(8)="BEGS_BLR_DYNAMIC"
-      VARIABLES_BLR_STRUC_T(9)="BEGS_BLR_L"
-      VARIABLES_BLR_STRUC_T(10)="BEGS_BLR_COL"
-      VARIABLES_BLR_STRUC_T(11)="NB_ACCESSES_INIT"
-      VARIABLES_BLR_STRUC_T(12)="NB_PANELS"
-      VARIABLES_BLR_STRUC_T(13)="DIAG_BLOCKS"
-      VARIABLES_BLR_STRUC_T(14)="NFS4FATHER"
-      VARIABLES_BLR_STRUC_T(15)="M_ARRAY"
       SIZE_VARIABLES_BLR_STRUC_T(:)=0_8
       SIZE_GEST_BLR_STRUC_T(:)=0
       NbRecords_BLR_STRUC_T(:)=0
@@ -1317,13 +1319,12 @@ C
       SIZE_VARIABLES_DIAG_BLOCKS=0_8
       SIZE_VARIABLES_DIAG_BLOCKS_j1=0_8
       DO i1=1,NBVARIABLES_BLR_STRUC_T 
-         TMP_STRING = VARIABLES_BLR_STRUC_T(i1)
-         SELECT CASE(TMP_STRING)
-         CASE("IsSYM")
+         SELECT CASE(i1)
+         CASE(B_IsSYM)
             NbRecords_BLR_STRUC_T(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_LOGICAL
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_LOGICAL
                write(unit,iostat=err) BLR_STRUC%IsSYM
                if(err.ne.0) then
@@ -1332,7 +1333,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_LOGICAL
                read(unit,iostat=err) BLR_STRUC%IsSYM
                if(err.ne.0) THEN
@@ -1342,11 +1343,11 @@ C
                endif 
                IF (INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("IsT2")
+         CASE(B_IsT2)
             NbRecords_BLR_STRUC_T(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_LOGICAL
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_LOGICAL
                write(unit,iostat=err) BLR_STRUC%IsT2
                if(err.ne.0) then
@@ -1355,7 +1356,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_LOGICAL
                read(unit,iostat=err) BLR_STRUC%IsT2
                if(err.ne.0) THEN
@@ -1365,11 +1366,11 @@ C
                endif 
                IF (INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("IsSLAVE")
+         CASE(B_IsSLAVE)
             NbRecords_BLR_STRUC_T(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_LOGICAL
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_LOGICAL
                write(unit,iostat=err) BLR_STRUC%IsSLAVE
                if(err.ne.0) then
@@ -1378,7 +1379,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_LOGICAL
                read(unit,iostat=err) BLR_STRUC%IsSLAVE
                if(err.ne.0) THEN
@@ -1388,9 +1389,9 @@ C
                endif 
                IF (INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("BEGS_BLR_STATIC")
+         CASE(B_BEGS_BLR_STATIC)
             NbRecords_BLR_STRUC_T(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(BLR_STRUC%BEGS_BLR_STATIC)) THEN
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=
@@ -1399,7 +1400,7 @@ C
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*2
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(BLR_STRUC%BEGS_BLR_STATIC)) THEN
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=
@@ -1431,7 +1432,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(BLR_STRUC%BEGS_BLR_STATIC)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -1465,9 +1466,9 @@ C
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("BEGS_BLR_DYNAMIC")
+         CASE(B_BEGS_BLR_DYNAMIC)
             NbRecords_BLR_STRUC_T(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(BLR_STRUC%BEGS_BLR_DYNAMIC)) THEN
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=
@@ -1476,7 +1477,7 @@ C
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*2
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(BLR_STRUC%BEGS_BLR_DYNAMIC)) THEN
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=
@@ -1508,7 +1509,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(BLR_STRUC%BEGS_BLR_DYNAMIC)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -1542,9 +1543,9 @@ C
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("BEGS_BLR_L")
+         CASE(B_BEGS_BLR_L)
             NbRecords_BLR_STRUC_T(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(BLR_STRUC%BEGS_BLR_L)) THEN
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=
@@ -1553,7 +1554,7 @@ C
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*2
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(BLR_STRUC%BEGS_BLR_L)) THEN
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=
@@ -1585,7 +1586,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(BLR_STRUC%BEGS_BLR_L)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -1619,9 +1620,9 @@ C
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("BEGS_BLR_COL")
+         CASE(B_BEGS_BLR_COL)
             NbRecords_BLR_STRUC_T(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(BLR_STRUC%BEGS_BLR_COL)) THEN
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=
@@ -1630,7 +1631,7 @@ C
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*2
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(BLR_STRUC%BEGS_BLR_COL)) THEN
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=
@@ -1662,7 +1663,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(BLR_STRUC%BEGS_BLR_COL)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -1696,11 +1697,11 @@ C
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("NB_ACCESSES_INIT")
+         CASE(B_NB_ACCESSES_INIT)
             NbRecords_BLR_STRUC_T(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_INT
                write(unit,iostat=err) BLR_STRUC%NB_ACCESSES_INIT
                if(err.ne.0) then
@@ -1709,7 +1710,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_INT
                read(unit,iostat=err) BLR_STRUC%NB_ACCESSES_INIT
                if(err.ne.0) THEN
@@ -1719,11 +1720,11 @@ C
                endif 
                IF (INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("NB_PANELS")
+         CASE(B_NB_PANELS)
             NbRecords_BLR_STRUC_T(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_INT
                write(unit,iostat=err) BLR_STRUC%NB_PANELS
                if(err.ne.0) then
@@ -1732,7 +1733,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_INT
                read(unit,iostat=err) BLR_STRUC%NB_PANELS
                if(err.ne.0) THEN
@@ -1742,8 +1743,8 @@ C
                endif 
                IF (INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PANELS_L")
-            if(trim(mode).EQ."memory_save") then
+         CASE(B_PANELS_L)
+            if(mode.EQ.memory_save_mode) then
                IF(associated(BLR_STRUC%PANELS_L)) THEN
                   NbRecords_BLR_STRUC_T(i1)=1
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
@@ -1751,7 +1752,7 @@ C
                   DO j1=1,size(BLR_STRUC%PANELS_L,1)
                      CALL CMUMPS_SAVE_RESTORE_BLR_PANEL(
      &                    BLR_STRUC%PANELS_L(j1)
-     &                    ,unit,MYID,"memory_save"
+     &                    ,unit,MYID,memory_save_mode
      &                    ,SIZE_GEST_PANELS_L_j1
      &                    ,SIZE_VARIABLES_PANELS_L_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -1768,7 +1769,7 @@ C
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*2
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(BLR_STRUC%PANELS_L)) THEN
                   NbRecords_BLR_STRUC_T(i1)=1
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
@@ -1783,7 +1784,7 @@ C
                   DO j1=1,size(BLR_STRUC%PANELS_L,1)
                      CALL CMUMPS_SAVE_RESTORE_BLR_PANEL(
      &                    BLR_STRUC%PANELS_L(j1)
-     &                    ,unit,MYID,"save"
+     &                    ,unit,MYID,save_mode
      &                    ,SIZE_GEST_PANELS_L_j1
      &                    ,SIZE_VARIABLES_PANELS_L_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -1811,7 +1812,7 @@ C
                   endif
                   IF ( INFO(1) .LT. 0 ) GOTO 100
                ENDIF 
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(BLR_STRUC%PANELS_L)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -1846,7 +1847,7 @@ C
                   DO j1=1,size_array1
                      CALL CMUMPS_SAVE_RESTORE_BLR_PANEL(
      &                    BLR_STRUC%PANELS_L(j1)
-     &                    ,unit,MYID,"restore"
+     &                    ,unit,MYID,restore_mode
      &                    ,SIZE_GEST_PANELS_L_j1
      &                    ,SIZE_VARIABLES_PANELS_L_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -1860,8 +1861,8 @@ C
                   ENDDO
                endif
             endif
-            CASE("PANELS_U")
-            if(trim(mode).EQ."memory_save") then
+            CASE(B_PANELS_U)
+            if(mode.EQ.memory_save_mode) then
                IF(associated(BLR_STRUC%PANELS_U)) THEN
                   NbRecords_BLR_STRUC_T(i1)=1
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
@@ -1869,7 +1870,7 @@ C
                   DO j1=1,size(BLR_STRUC%PANELS_U,1)
                      CALL CMUMPS_SAVE_RESTORE_BLR_PANEL(
      &                    BLR_STRUC%PANELS_U(j1)
-     &                    ,unit,MYID,"memory_save"
+     &                    ,unit,MYID,memory_save_mode
      &                    ,SIZE_GEST_PANELS_U_j1
      &                    ,SIZE_VARIABLES_PANELS_U_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -1886,7 +1887,7 @@ C
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*2
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(BLR_STRUC%PANELS_U)) THEN
                   NbRecords_BLR_STRUC_T(i1)=1
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
@@ -1901,7 +1902,7 @@ C
                   DO j1=1,size(BLR_STRUC%PANELS_U,1)
                      CALL CMUMPS_SAVE_RESTORE_BLR_PANEL(
      &                    BLR_STRUC%PANELS_U(j1)
-     &                    ,unit,MYID,"save"
+     &                    ,unit,MYID,save_mode
      &                    ,SIZE_GEST_PANELS_U_j1
      &                    ,SIZE_VARIABLES_PANELS_U_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -1929,7 +1930,7 @@ C
                   endif
                   IF ( INFO(1) .LT. 0 ) GOTO 100
                ENDIF 
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(BLR_STRUC%PANELS_U)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -1964,7 +1965,7 @@ C
                   DO j1=1,size_array1
                      CALL CMUMPS_SAVE_RESTORE_BLR_PANEL(
      &                    BLR_STRUC%PANELS_U(j1)
-     &                    ,unit,MYID,"restore"
+     &                    ,unit,MYID,restore_mode
      &                    ,SIZE_GEST_PANELS_U_j1
      &                    ,SIZE_VARIABLES_PANELS_U_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -1978,8 +1979,8 @@ C
                   ENDDO
                endif
             endif
-         CASE("CB_LRB")
-            if(trim(mode).EQ."memory_save") then
+         CASE(B_CB_LRB)
+            if(mode.EQ.memory_save_mode) then
                IF(associated(BLR_STRUC%CB_LRB)) THEN
                   NbRecords_BLR_STRUC_T(i1)=1
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*2
@@ -1988,7 +1989,7 @@ C
                      DO j2=1,size(BLR_STRUC%CB_LRB,2)
                         CALL CMUMPS_SAVE_RESTORE_LRB(
      &                       BLR_STRUC%CB_LRB(j1,j2)
-     &                       ,unit,MYID,"memory_save"
+     &                       ,unit,MYID,memory_save_mode
      &                       ,SIZE_GEST_CB_LRB_j1j2
      &                       ,SIZE_VARIABLES_CB_LRB_j1j2
      &                       ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -2006,7 +2007,7 @@ C
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*3
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(BLR_STRUC%CB_LRB)) THEN
                   NbRecords_BLR_STRUC_T(i1)=1
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*2
@@ -2022,7 +2023,7 @@ C
                      DO j2=1,size(BLR_STRUC%CB_LRB,2)
                         CALL CMUMPS_SAVE_RESTORE_LRB(
      &                       BLR_STRUC%CB_LRB(j1,j2)
-     &                       ,unit,MYID,"save"
+     &                       ,unit,MYID,save_mode
      &                       ,SIZE_GEST_CB_LRB_j1j2
      &                       ,SIZE_VARIABLES_CB_LRB_j1j2
      &                       ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -2051,7 +2052,7 @@ C
                   endif
                   IF ( INFO(1) .LT. 0 ) GOTO 100
                ENDIF 
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(BLR_STRUC%CB_LRB)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -2087,7 +2088,7 @@ C
                      DO j2=1,size_array2
                         CALL CMUMPS_SAVE_RESTORE_LRB(
      &                       BLR_STRUC%CB_LRB(j1,j2)
-     &                       ,unit,MYID,"restore"
+     &                       ,unit,MYID,restore_mode
      &                       ,SIZE_GEST_CB_LRB_j1j2
      &                       ,SIZE_VARIABLES_CB_LRB_j1j2
      &                       ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -2102,8 +2103,8 @@ C
                   ENDDO
                endif
             endif
-         CASE("DIAG_BLOCKS")
-            if(trim(mode).EQ."memory_save") then
+         CASE(B_DIAG_BLOCKS)
+            if(mode.EQ.memory_save_mode) then
                IF(associated(BLR_STRUC%DIAG_BLOCKS)) THEN
                   NbRecords_BLR_STRUC_T(i1)=1
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
@@ -2111,7 +2112,7 @@ C
                   DO j1=1,size(BLR_STRUC%DIAG_BLOCKS,1)
                      CALL CMUMPS_SAVE_RESTORE_DIAG_BLOCK(
      &                    BLR_STRUC%DIAG_BLOCKS(j1)
-     &                    ,unit,MYID,"memory_save"
+     &                    ,unit,MYID,memory_save_mode
      &                    ,SIZE_GEST_DIAG_BLOCKS_j1
      &                    ,SIZE_VARIABLES_DIAG_BLOCKS_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP
@@ -2129,7 +2130,7 @@ C
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*2
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(BLR_STRUC%DIAG_BLOCKS)) THEN
                   NbRecords_BLR_STRUC_T(i1)=1
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
@@ -2144,7 +2145,7 @@ C
                   DO j1=1,size(BLR_STRUC%DIAG_BLOCKS,1)
                      CALL CMUMPS_SAVE_RESTORE_DIAG_BLOCK(
      &                    BLR_STRUC%DIAG_BLOCKS(j1)
-     &                    ,unit,MYID,"save"
+     &                    ,unit,MYID,save_mode
      &                    ,SIZE_GEST_DIAG_BLOCKS_j1
      &                    ,SIZE_VARIABLES_DIAG_BLOCKS_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP
@@ -2172,7 +2173,7 @@ C
                   endif
                   IF ( INFO(1) .LT. 0 ) GOTO 100
                ENDIF 
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(BLR_STRUC%DIAG_BLOCKS)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -2207,7 +2208,7 @@ C
                   DO j1=1,size_array1
                      CALL CMUMPS_SAVE_RESTORE_DIAG_BLOCK(
      &                    BLR_STRUC%DIAG_BLOCKS(j1)
-     &                    ,unit,MYID,"restore"
+     &                    ,unit,MYID,restore_mode
      &                    ,SIZE_GEST_DIAG_BLOCKS_j1
      &                    ,SIZE_VARIABLES_DIAG_BLOCKS_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP
@@ -2222,11 +2223,11 @@ C
                   ENDDO
                endif
             endif
-         CASE("NFS4FATHER")
+         CASE(B_NFS4FATHER)
             NbRecords_BLR_STRUC_T(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_INT
                write(unit,iostat=err) BLR_STRUC%NFS4FATHER
                if(err.ne.0) then
@@ -2235,7 +2236,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_INT
                read(unit,iostat=err) BLR_STRUC%NFS4FATHER
                if(err.ne.0) THEN
@@ -2245,26 +2246,26 @@ C
                endif 
                IF (INFO(1) .LT. 0 ) GOTO 100
             endif
-            CASE("M_ARRAY")
-               if(trim(mode).EQ."restore") then
+            CASE(B_M_ARRAY)
+               if(mode.EQ.restore_mode) then
                   nullify(BLR_STRUC%M_ARRAY)
                endif
          CASE DEFAULT
          END SELECT
-         if(trim(mode).EQ."memory_save") then
+         if(mode.EQ.memory_save_mode) then
             NbSubRecords=int(SIZE_VARIABLES_BLR_STRUC_T(i1)/huge(I4))
             IF(NbSubRecords.GT.0) then
                NbRecords_BLR_STRUC_T(i1)=NbRecords_BLR_STRUC_T(i1)
      &              +NbSubRecords
             ENDIF
-         elseif(trim(mode).EQ."save") then
+         elseif(mode.EQ.save_mode) then
             size_written=size_written+SIZE_VARIABLES_BLR_STRUC_T(i1)
      &           +int(SIZE_GEST_BLR_STRUC_T(i1),kind=8)
 #if defined(MUMPS_NOF2003)
             size_written=size_written
      &           +int(2*SIZE_INT*NbRecords_BLR_STRUC_T(i1),kind=8)
 #endif
-         elseif(trim(mode).EQ."restore") then
+         elseif(mode.EQ.restore_mode) then
             size_allocated=size_allocated+
      &           SIZE_VARIABLES_BLR_STRUC_T(i1)
             size_read=size_read+SIZE_VARIABLES_BLR_STRUC_T(i1)
@@ -2275,7 +2276,7 @@ C
 #endif
          endif
       ENDDO
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          Local_SIZE_VARIABLES=sum(SIZE_VARIABLES_BLR_STRUC_T)
      &        +SIZE_VARIABLES_PANELS_L
      &        +SIZE_VARIABLES_PANELS_U
@@ -2304,18 +2305,20 @@ C
       INCLUDE 'mpif.h'
       TYPE(LRB_TYPE) :: LRB_T
       INTEGER,intent(IN)::unit,MYID
-      CHARACTER(len=*),intent(IN) :: mode
+      INTEGER,intent(IN) :: mode
       INTEGER,INTENT(OUT) :: Local_SIZE_GEST
       INTEGER(8),intent(OUT) :: Local_SIZE_VARIABLES
       INTEGER,intent(INOUT):: INFO(2)
       INTEGER,intent(IN):: SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
       INTEGER(8),intent(IN) :: TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
       INTEGER(8),intent(INOUT):: size_read,size_allocated,size_written
-      INTEGER :: NBVARIABLES_LRB_TYPE
-      PARAMETER (NBVARIABLES_LRB_TYPE = 6)
-      CHARACTER(len=30), dimension(NBVARIABLES_LRB_TYPE)::
-     &     VARIABLES_LRB_TYPE
-      CHARACTER(len=30) :: TMP_STRING
+      INTEGER, PARAMETER :: LRB_Q=1
+      INTEGER, PARAMETER :: LRB_R=2
+      INTEGER, PARAMETER :: LRB_K=3
+      INTEGER, PARAMETER :: LRB_M=4
+      INTEGER, PARAMETER :: LRB_N=5
+      INTEGER, PARAMETER :: LRB_ISLR=6
+      INTEGER, PARAMETER :: NBVARIABLES_LRB_TYPE=6
       INTEGER(8),dimension(NBVARIABLES_LRB_TYPE)::
      &     SIZE_VARIABLES_LRB_TYPE
       INTEGER,dimension(NBVARIABLES_LRB_TYPE)::
@@ -2328,21 +2331,14 @@ C
       INTEGER:: Local_NbRecords
 #endif
       INTEGER(4) ::I4
-      VARIABLES_LRB_TYPE(1)="Q"
-      VARIABLES_LRB_TYPE(2)="R"
-      VARIABLES_LRB_TYPE(3)="K"
-      VARIABLES_LRB_TYPE(4)="M"
-      VARIABLES_LRB_TYPE(5)="N"
-      VARIABLES_LRB_TYPE(6)="ISLR"
       SIZE_VARIABLES_LRB_TYPE(:)=0_8
       SIZE_GEST_LRB_TYPE(:)=0
       NbRecords_LRB_TYPE(:)=0
       DO i1=1,NBVARIABLES_LRB_TYPE
-         TMP_STRING = VARIABLES_LRB_TYPE(i1)
-         SELECT CASE(TMP_STRING)
-         CASE("Q")
+         SELECT CASE(i1)
+         CASE(LRB_Q)
             NbRecords_LRB_TYPE(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(LRB_T%Q)) THEN
                   SIZE_GEST_LRB_TYPE(i1)=SIZE_INT*2
                   SIZE_VARIABLES_LRB_TYPE(i1)=
@@ -2352,7 +2348,7 @@ C
                   SIZE_GEST_LRB_TYPE(i1)=SIZE_INT*3
                   SIZE_VARIABLES_LRB_TYPE(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(LRB_T%Q)) THEN
                   SIZE_GEST_LRB_TYPE(i1)=SIZE_INT*2
                   SIZE_VARIABLES_LRB_TYPE(i1)=
@@ -2384,7 +2380,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 300
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(LRB_T%Q)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -2419,9 +2415,9 @@ C
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 300
             endif
-         CASE("R")
+         CASE(LRB_R)
             NbRecords_LRB_TYPE(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(LRB_T%R)) THEN
                   SIZE_GEST_LRB_TYPE(i1)=SIZE_INT*2
                   SIZE_VARIABLES_LRB_TYPE(i1)=
@@ -2431,7 +2427,7 @@ C
                   SIZE_GEST_LRB_TYPE(i1)=SIZE_INT*3
                   SIZE_VARIABLES_LRB_TYPE(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(LRB_T%R)) THEN
                   SIZE_GEST_LRB_TYPE(i1)=SIZE_INT*2
                   SIZE_VARIABLES_LRB_TYPE(i1)=
@@ -2463,7 +2459,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 300
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(LRB_T%R)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -2498,11 +2494,11 @@ C
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 300
             endif
-         CASE("K")
+         CASE(LRB_K)
             NbRecords_LRB_TYPE(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_INT
                write(unit,iostat=err) LRB_T%K
                if(err.ne.0) then
@@ -2511,7 +2507,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 300
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_INT
                read(unit,iostat=err) LRB_T%K
                if(err.ne.0) THEN
@@ -2521,11 +2517,11 @@ C
                endif 
                IF ( INFO(1) .LT. 0 ) GOTO 300
             endif
-         CASE("M")
+         CASE(LRB_M)
             NbRecords_LRB_TYPE(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_INT
                write(unit,iostat=err) LRB_T%M
                if(err.ne.0) then
@@ -2534,7 +2530,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 300
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_INT
                read(unit,iostat=err) LRB_T%M
                if(err.ne.0) THEN
@@ -2544,11 +2540,11 @@ C
                endif 
                IF ( INFO(1) .LT. 0 ) GOTO 300
             endif
-         CASE("N")
+         CASE(LRB_N)
             NbRecords_LRB_TYPE(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_INT
                write(unit,iostat=err) LRB_T%N
                if(err.ne.0) then
@@ -2557,7 +2553,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 300
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_INT
                read(unit,iostat=err) LRB_T%N
                if(err.ne.0) THEN
@@ -2567,11 +2563,11 @@ C
                endif 
                IF ( INFO(1) .LT. 0 ) GOTO 300
             endif
-         CASE("ISLR")
+         CASE(LRB_ISLR)
             NbRecords_LRB_TYPE(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_LOGICAL
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_LOGICAL
                write(unit,iostat=err) LRB_T%ISLR
                if(err.ne.0) then
@@ -2580,7 +2576,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 300
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_LOGICAL
                read(unit,iostat=err) LRB_T%ISLR
                if(err.ne.0) THEN
@@ -2592,21 +2588,21 @@ C
             endif   
          CASE DEFAULT
          END SELECT
-         if(trim(mode).EQ."memory_save") then
+         if(mode.EQ.memory_save_mode) then
             NbSubRecords=int(SIZE_VARIABLES_LRB_TYPE(i1)/huge(I4))
             IF(NbSubRecords.GT.0) then
                NbRecords_LRB_TYPE(i1)=
      &              NbRecords_LRB_TYPE(i1)
      &              +NbSubRecords
             ENDIF
-         elseif(trim(mode).EQ."save") then
+         elseif(mode.EQ.save_mode) then
             size_written=size_written+SIZE_VARIABLES_LRB_TYPE(i1)
      &           +int(SIZE_GEST_LRB_TYPE(i1),kind=8)
 #if defined(MUMPS_NOF2003)
             size_written=size_written
      &           +int(2*SIZE_INT*NbRecords_LRB_TYPE(i1),kind=8)
 #endif
-         elseif(trim(mode).EQ."restore") then
+         elseif(mode.EQ.restore_mode) then
             size_allocated=size_allocated+
      &           SIZE_VARIABLES_LRB_TYPE(i1)
             size_read=size_read+SIZE_VARIABLES_LRB_TYPE(i1)
@@ -2617,7 +2613,7 @@ C
 #endif
          endif
       ENDDO
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          Local_SIZE_VARIABLES=sum(SIZE_VARIABLES_LRB_TYPE)
          Local_SIZE_GEST=sum(SIZE_GEST_LRB_TYPE)
 #if defined(MUMPS_NOF2003)
@@ -2638,18 +2634,16 @@ C
       INCLUDE 'mpif.h'
       TYPE(blr_panel_type) :: BLR_PANEL_T
       INTEGER,intent(IN)::unit,MYID
-      CHARACTER(len=*),intent(IN) :: mode
+      INTEGER,intent(IN) :: mode
       INTEGER,INTENT(OUT) :: Local_SIZE_GEST
       INTEGER(8),intent(OUT) :: Local_SIZE_VARIABLES
       INTEGER,intent(INOUT):: INFO(2)
       INTEGER,intent(IN):: SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
       INTEGER(8),intent(IN) :: TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
       INTEGER(8),intent(INOUT):: size_read,size_allocated,size_written
-      INTEGER :: NBVARIABLES_BLR_PANEL_TYPE
-      PARAMETER (NBVARIABLES_BLR_PANEL_TYPE = 2)
-      CHARACTER(len=30), dimension(NBVARIABLES_BLR_PANEL_TYPE)::
-     &     VARIABLES_BLR_PANEL_TYPE
-      CHARACTER(len=30) :: TMP_STRING
+      INTEGER, PARAMETER :: P_NB_ACCESSES_LEFT=1
+      INTEGER, PARAMETER :: P_LRB_PANEL=2
+      INTEGER, PARAMETER :: NBVARIABLES_BLR_PANEL_TYPE = 2
       INTEGER(8),dimension(NBVARIABLES_BLR_PANEL_TYPE)::
      &     SIZE_VARIABLES_BLR_PANEL_TYPE
       INTEGER,dimension(NBVARIABLES_BLR_PANEL_TYPE)::
@@ -2664,8 +2658,6 @@ C
       INTEGER:: SIZE_GEST_LRB_PANEL_j1,SIZE_GEST_LRB_PANEL
       INTEGER(8)::SIZE_VARIABLES_LRB_PANEL_j1,SIZE_VARIABLES_LRB_PANEL
       INTEGER(4)::I4
-      VARIABLES_BLR_PANEL_TYPE(1)="NB_ACCESSES_LEFT"
-      VARIABLES_BLR_PANEL_TYPE(2)="LRB_PANEL"
       SIZE_VARIABLES_BLR_PANEL_TYPE(:)=0_8
       SIZE_GEST_BLR_PANEL_TYPE(:)=0
       NbRecords_BLR_PANEL_TYPE(:)=0
@@ -2674,13 +2666,12 @@ C
       SIZE_VARIABLES_LRB_PANEL_j1=0_8
       SIZE_VARIABLES_LRB_PANEL=0_8
       DO i1=1,NBVARIABLES_BLR_PANEL_TYPE
-         TMP_STRING = VARIABLES_BLR_PANEL_TYPE(i1)
-         SELECT CASE(TMP_STRING)
-         CASE("NB_ACCESSES_LEFT")
+         SELECT CASE(i1)
+         CASE(P_NB_ACCESSES_LEFT)
             NbRecords_BLR_PANEL_TYPE(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_BLR_PANEL_TYPE(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_BLR_PANEL_TYPE(i1)=SIZE_INT
                write(unit,iostat=err) BLR_PANEL_T%NB_ACCESSES_LEFT
                if(err.ne.0) then
@@ -2689,7 +2680,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 400
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_BLR_PANEL_TYPE(i1)=SIZE_INT
                read(unit,iostat=err) BLR_PANEL_T%NB_ACCESSES_LEFT
                if(err.ne.0) THEN
@@ -2699,8 +2690,8 @@ C
                endif 
                IF ( INFO(1) .LT. 0 ) GOTO 400
             endif
-         CASE("LRB_PANEL")
-            if(trim(mode).EQ."memory_save") then
+         CASE(P_LRB_PANEL)
+            if(mode.EQ.memory_save_mode) then
                IF(associated(BLR_PANEL_T%LRB_PANEL)) THEN
                   NbRecords_BLR_PANEL_TYPE(i1)=1
                   SIZE_GEST_BLR_PANEL_TYPE(i1)=SIZE_INT
@@ -2708,7 +2699,7 @@ C
                   DO j1=1,size(BLR_PANEL_T%LRB_PANEL,1)
                      CALL CMUMPS_SAVE_RESTORE_LRB(
      &                    BLR_PANEL_T%LRB_PANEL(j1)
-     &                    ,unit,MYID,"memory_save"
+     &                    ,unit,MYID,memory_save_mode
      &                    ,SIZE_GEST_LRB_PANEL_j1
      &                    ,SIZE_VARIABLES_LRB_PANEL_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -2725,7 +2716,7 @@ C
                   SIZE_GEST_BLR_PANEL_TYPE(i1)=SIZE_INT*2
                   SIZE_VARIABLES_BLR_PANEL_TYPE(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(BLR_PANEL_T%LRB_PANEL)) THEN
                   NbRecords_BLR_PANEL_TYPE(i1)=1
                   SIZE_GEST_BLR_PANEL_TYPE(i1)=SIZE_INT
@@ -2740,7 +2731,7 @@ C
                   DO j1=1,size(BLR_PANEL_T%LRB_PANEL,1)
                      CALL CMUMPS_SAVE_RESTORE_LRB(
      &                    BLR_PANEL_T%LRB_PANEL(j1)
-     &                    ,unit,MYID,"save"
+     &                    ,unit,MYID,save_mode
      &                    ,SIZE_GEST_LRB_PANEL_j1
      &                    ,SIZE_VARIABLES_LRB_PANEL_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -2768,7 +2759,7 @@ C
                   endif
                   IF ( INFO(1) .LT. 0 ) GOTO 400
                ENDIF 
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(BLR_PANEL_T%LRB_PANEL)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -2803,7 +2794,7 @@ C
                   DO j1=1,size_array1
                      CALL CMUMPS_SAVE_RESTORE_LRB(
      &                    BLR_PANEL_T%LRB_PANEL(j1)
-     &                    ,unit,MYID,"restore"
+     &                    ,unit,MYID,restore_mode
      &                    ,SIZE_GEST_LRB_PANEL_j1
      &                    ,SIZE_VARIABLES_LRB_PANEL_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -2819,21 +2810,21 @@ C
             endif
          CASE DEFAULT
          END SELECT
-         if(trim(mode).EQ."memory_save") then
+         if(mode.EQ.memory_save_mode) then
             NbSubRecords=int(SIZE_VARIABLES_BLR_PANEL_TYPE(i1)/huge(I4))
             IF(NbSubRecords.GT.0) then
                NbRecords_BLR_PANEL_TYPE(i1)=
      &              NbRecords_BLR_PANEL_TYPE(i1)
      &              +NbSubRecords
             ENDIF
-         elseif(trim(mode).EQ."save") then
+         elseif(mode.EQ.save_mode) then
             size_written=size_written+SIZE_VARIABLES_BLR_PANEL_TYPE(i1)
      &           +int(SIZE_GEST_BLR_PANEL_TYPE(i1),kind=8)
 #if defined(MUMPS_NOF2003)
             size_written=size_written
      &           +int(2*SIZE_INT*NbRecords_BLR_PANEL_TYPE(i1),kind=8)
 #endif
-         elseif(trim(mode).EQ."restore") then
+         elseif(mode.EQ.restore_mode) then
             size_allocated=size_allocated+
      &           SIZE_VARIABLES_BLR_PANEL_TYPE(i1)
             size_read=size_read+SIZE_VARIABLES_BLR_PANEL_TYPE(i1)
@@ -2844,7 +2835,7 @@ C
 #endif
          endif
       ENDDO
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          Local_SIZE_VARIABLES=sum(SIZE_VARIABLES_BLR_PANEL_TYPE)+
      &        SIZE_VARIABLES_LRB_PANEL
          Local_SIZE_GEST=sum(SIZE_GEST_BLR_PANEL_TYPE)+
@@ -2867,18 +2858,15 @@ C
       INCLUDE 'mpif.h'
       TYPE(diag_block_type) :: DIAG_BLOCK_T
       INTEGER,intent(IN)::unit,MYID
-      CHARACTER(len=*),intent(IN) :: mode
+      INTEGER,intent(IN) :: mode
       INTEGER,INTENT(OUT) :: Local_SIZE_GEST
       INTEGER(8),intent(OUT) :: Local_SIZE_VARIABLES
       INTEGER,intent(INOUT):: INFO(2)
       INTEGER,intent(IN):: SIZE_INT, SIZE_ARITH_DEP
       INTEGER(8),intent(IN) :: TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
       INTEGER(8),intent(INOUT):: size_read,size_allocated,size_written
-      INTEGER :: NBVARIABLES_DIAG_BLOCK_TYPE
-      PARAMETER (NBVARIABLES_DIAG_BLOCK_TYPE = 1)
-      CHARACTER(len=30), dimension(NBVARIABLES_DIAG_BLOCK_TYPE)::
-     &     VARIABLES_DIAG_BLOCK_TYPE
-      CHARACTER(len=30) :: TMP_STRING
+      INTEGER, PARAMETER :: D_DIAG_BLOCK=1
+      INTEGER, PARAMETER :: NBVARIABLES_DIAG_BLOCK_TYPE = 1
       INTEGER(8),dimension(NBVARIABLES_DIAG_BLOCK_TYPE)::
      &     SIZE_VARIABLES_DIAG_BLOCK_TYPE
       INTEGER,dimension(NBVARIABLES_DIAG_BLOCK_TYPE)::
@@ -2891,16 +2879,14 @@ C
       INTEGER:: Local_NbRecords
 #endif
       INTEGER(4) :: I4
-      VARIABLES_DIAG_BLOCK_TYPE(1)="DIAG_BLOCK"
       SIZE_VARIABLES_DIAG_BLOCK_TYPE(:)=0_8
       SIZE_GEST_DIAG_BLOCK_TYPE(:)=0
       NbRecords_DIAG_BLOCK_TYPE(:)=0
       DO i1=1,NBVARIABLES_DIAG_BLOCK_TYPE
-         TMP_STRING = VARIABLES_DIAG_BLOCK_TYPE(i1)
-         SELECT CASE(TMP_STRING)
-         CASE("DIAG_BLOCK")
+         SELECT CASE(i1)
+         CASE(D_DIAG_BLOCK)
             NbRecords_DIAG_BLOCK_TYPE(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(DIAG_BLOCK_T%DIAG_BLOCK)) THEN
                   SIZE_GEST_DIAG_BLOCK_TYPE(i1)=SIZE_INT
                   SIZE_VARIABLES_DIAG_BLOCK_TYPE(i1)=
@@ -2910,7 +2896,7 @@ C
                   SIZE_GEST_DIAG_BLOCK_TYPE(i1)=SIZE_INT*2
                   SIZE_VARIABLES_DIAG_BLOCK_TYPE(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(DIAG_BLOCK_T%DIAG_BLOCK)) THEN
                   SIZE_GEST_DIAG_BLOCK_TYPE(i1)=SIZE_INT
                   SIZE_VARIABLES_DIAG_BLOCK_TYPE(i1)=
@@ -2942,7 +2928,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 200
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(DIAG_BLOCK_T%DIAG_BLOCK)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -2979,7 +2965,7 @@ C
             endif
          CASE DEFAULT
          END SELECT
-         if(trim(mode).EQ."memory_save") then
+         if(mode.EQ.memory_save_mode) then
             NbSubRecords=int(SIZE_VARIABLES_DIAG_BLOCK_TYPE(i1)/
      &      huge(I4))
             IF(NbSubRecords.GT.0) then
@@ -2987,14 +2973,14 @@ C
      &              NbRecords_DIAG_BLOCK_TYPE(i1)
      &              +NbSubRecords
             ENDIF
-         elseif(trim(mode).EQ."save") then
+         elseif(mode.EQ.save_mode) then
             size_written=size_written+SIZE_VARIABLES_DIAG_BLOCK_TYPE(i1)
      &           +int(SIZE_GEST_DIAG_BLOCK_TYPE(i1),kind=8)
 #if defined(MUMPS_NOF2003)
             size_written=size_written
      &           +int(2*SIZE_INT*NbRecords_DIAG_BLOCK_TYPE(i1),kind=8)
 #endif
-         elseif(trim(mode).EQ."restore") then
+         elseif(mode.EQ.restore_mode) then
             size_allocated=size_allocated+
      &           SIZE_VARIABLES_DIAG_BLOCK_TYPE(i1)
             size_read=size_read+SIZE_VARIABLES_DIAG_BLOCK_TYPE(i1)
@@ -3005,7 +2991,7 @@ C
 #endif
          endif
       ENDDO
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          Local_SIZE_VARIABLES=sum(SIZE_VARIABLES_DIAG_BLOCK_TYPE)
          Local_SIZE_GEST=sum(SIZE_GEST_DIAG_BLOCK_TYPE)
 #if defined(MUMPS_NOF2003)
@@ -3016,4 +3002,5 @@ C
  200  continue
       RETURN
       END SUBROUTINE CMUMPS_SAVE_RESTORE_DIAG_BLOCK
+#endif
       END MODULE CMUMPS_LR_DATA_M
diff -pruN 5.6.2-2.1/src/cmumps_mpi3_mod.F 5.7.1-1/src/cmumps_mpi3_mod.F
--- 5.6.2-2.1/src/cmumps_mpi3_mod.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cmumps_mpi3_mod.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/cmumps_ooc.F 5.7.1-1/src/cmumps_ooc.F
--- 5.6.2-2.1/src/cmumps_ooc.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/cmumps_ooc.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -17,6 +17,7 @@ C
 !$   &                    OMP_INIT_LOCK, OMP_DESTROY_LOCK, OMP_TEST_LOCK
       IMPLICIT NONE
 !$     INTEGER(KIND=OMP_LOCK_KIND) :: LOCK_FOR_L0OMP
+      INTEGER, PARAMETER :: FILENAMELENGTH=1300
       INTEGER NOT_IN_MEM,BEING_READ,NOT_USED,PERMUTED,USED,
      &     USED_NOT_PERMUTED,ALREADY_USED
       PARAMETER (NOT_IN_MEM=0,BEING_READ=-1,NOT_USED=-2,
@@ -44,7 +45,6 @@ C
      &     ,NB_CALLED,REQ_ACT,NB_CALL
       INTEGER(8), SAVE :: OOC_VADDR_PTR
       INTEGER(8), SAVE :: SIZE_ZONE_REQ
-      DOUBLE PRECISION,SAVE :: MAX_OOC_FILE_SIZE
       INTEGER(8), DIMENSION(:), ALLOCATABLE :: SIZE_OF_READ, READ_DEST
       INTEGER,DIMENSION(:),ALLOCATABLE :: FIRST_POS_IN_READ,
      &     READ_MNG,REQ_TO_ZONE,POS_HOLE_T,
@@ -114,18 +114,16 @@ C
       USE CMUMPS_STRUC_DEF
       USE CMUMPS_OOC_BUFFER
       IMPLICIT NONE
-      INTEGER TMPDIR_MAX_LENGTH, PREFIX_MAX_LENGTH
-      PARAMETER (TMPDIR_MAX_LENGTH=255, PREFIX_MAX_LENGTH=63)
+      INTEGER OOC_TMPDIR_MAX_LENGTH, OOC_PREFIX_MAX_LENGTH
+      PARAMETER (OOC_TMPDIR_MAX_LENGTH=1023, OOC_PREFIX_MAX_LENGTH=255)
       INTEGER(8), intent(in) :: MAXS  
       TYPE(CMUMPS_STRUC), TARGET :: id
       INTEGER IERR
       INTEGER allocok
-      CHARACTER(len=1):: TMP_DIR(TMPDIR_MAX_LENGTH),
-     &            TMP_PREFIX(PREFIX_MAX_LENGTH)
-      INTEGER DIM_DIR,DIM_PREFIX
+      INTEGER DIM_TMPDIR,DIM_PREFIX
       INTEGER, DIMENSION(:), ALLOCATABLE :: FILE_FLAG_TAB
       INTEGER TMP
-      INTEGER K211_LOC
+      INTEGER KEEP211_LOC
       ICNTL1=id%ICNTL(1)
       MAX_SIZE_FACTOR_OOC=0_8
       N_OOC=id%N
@@ -234,14 +232,10 @@ C
       ENDIF
       DIM_ERR_STR_OOC = ERR_STR_OOC_MAX_LEN
       CALL MUMPS_LOW_LEVEL_INIT_ERR_STR(DIM_ERR_STR_OOC,ERR_STR_OOC)
-      DIM_DIR=len(trim(id%OOC_TMPDIR))
+      DIM_TMPDIR=len(trim(id%OOC_TMPDIR))
       DIM_PREFIX=len(trim(id%OOC_PREFIX))
-      CALL CMUMPS_CONVERT_STR_TO_CHR_ARRAY(TMP_DIR(1),
-     &     id%OOC_TMPDIR, TMPDIR_MAX_LENGTH, DIM_DIR )
-      CALL CMUMPS_CONVERT_STR_TO_CHR_ARRAY(TMP_PREFIX(1),
-     &     id%OOC_PREFIX, PREFIX_MAX_LENGTH, DIM_PREFIX)
-      CALL MUMPS_LOW_LEVEL_INIT_PREFIX(DIM_PREFIX, TMP_PREFIX)
-      CALL MUMPS_LOW_LEVEL_INIT_TMPDIR(DIM_DIR, TMP_DIR)
+      CALL MUMPS_LOW_LEVEL_INIT_PREFIX(DIM_PREFIX, id%OOC_PREFIX)
+      CALL MUMPS_LOW_LEVEL_INIT_TMPDIR(DIM_TMPDIR, id%OOC_TMPDIR)
       ALLOCATE(FILE_FLAG_TAB(OOC_NB_FILE_TYPE),
      &     stat=allocok)
       IF (allocok .GT. 0) THEN
@@ -260,8 +254,8 @@ C
          TMP=max(1,TMP/2)
       ENDIF
       CALL MUMPS_LOW_LEVEL_INIT_OOC_C(MYID_OOC,TMP,
-     &     id%KEEP(35),LOW_LEVEL_STRAT_IO,K211_LOC,OOC_NB_FILE_TYPE,
-     &     FILE_FLAG_TAB,IERR)
+     &     id%KEEP(35),LOW_LEVEL_STRAT_IO,KEEP211_LOC,OOC_NB_FILE_TYPE,
+     &     FILE_FLAG_TAB,id%KEEP(255),IERR)
       IF(IERR.LT.0)THEN
          IF (ICNTL1 .GT. 0 ) THEN
            WRITE(ICNTL1,*)MYID_OOC,': PB in MUMPS_LOW_LEVEL_INIT_OOC_C'
@@ -271,7 +265,6 @@ C
          id%INFO(2) = 0
          RETURN
       ENDIF
-      CALL MUMPS_GET_MAX_FILE_SIZE_C(MAX_OOC_FILE_SIZE)
       DEALLOCATE(FILE_FLAG_TAB)
       RETURN
       END SUBROUTINE CMUMPS_OOC_INIT_FACTO
@@ -506,7 +499,7 @@ C
       TYPE(CMUMPS_STRUC), TARGET :: id
       INTEGER IERR
       INTEGER I,J,I1,K
-      CHARACTER(len=1):: TMP_NAME(350)
+      CHARACTER(len=1):: TMP_NAME(FILENAMELENGTH)
       IERR=0
       K=1
       IF(.NOT. id%ASSOCIATED_OOC_FILES) THEN
@@ -1367,7 +1360,9 @@ C
       IMPLICIT NONE
       INTEGER INODE
       IF ( (KEEP_OOC(237).EQ.0)
-     &     .AND. (KEEP_OOC(235).EQ.0) ) THEN
+     &     .AND. (KEEP_OOC(235).EQ.0) 
+     &     .AND. (KEEP_OOC(212).EQ.0)
+     &   ) THEN
       IF(OOC_STATE_NODE(STEP_OOC(INODE)).NE.NOT_USED)THEN
          WRITE(*,*)MYID_OOC,': INTERNAL ERROR (51) in OOC',INODE,
      &        OOC_STATE_NODE(STEP_OOC(INODE))
@@ -2618,7 +2613,8 @@ C
                  SET_POS_SEQUENCE = .FALSE.
                  CUR_POS_SEQUENCE = I
                ENDIF
-               IF (KEEP_OOC(237).EQ.0 .AND. KEEP_OOC(235).EQ.0) THEN
+               IF (KEEP_OOC(237).EQ.0 .AND. KEEP_OOC(235).EQ.0
+     &              .AND. KEEP_OOC(212).EQ.0 ) THEN
                  OOC_STATE_NODE(STEP_OOC(J)) = NOT_IN_MEM
                ENDIF
                CYCLE
@@ -2638,7 +2634,8 @@ C
                         CALL MUMPS_ABORT()
                      ENDIF                     
                   ENDIF
-                 IF (KEEP_OOC(237).NE.0 .OR. KEEP_OOC(235).NE.0) 
+                 IF (KEEP_OOC(237).NE.0 .OR. KEEP_OOC(235).NE.0
+     &               .OR.  KEEP_OOC(212).NE.0 ) 
      &              THEN
                   IF (OOC_STATE_NODE(STEP_OOC(J)).EQ.NOT_IN_MEM) THEN
                      OOC_STATE_NODE(STEP_OOC(J)) = USED
@@ -2657,13 +2654,15 @@ C
                     CALL MUMPS_ABORT()
                   ENDIF
                  ENDIF
-                 IF (KEEP_OOC(237).EQ.0 .AND. KEEP_OOC(235).EQ.0) THEN
+                 IF (KEEP_OOC(237).EQ.0 .AND. KEEP_OOC(235).EQ.0
+     &               .AND. KEEP_OOC(212).EQ.0 ) THEN
                     CALL CMUMPS_SOLVE_UPD_NODE_INFO(J,PTRFAC,NSTEPS)
                  ENDIF
                ENDIF
             ENDIF 
       ENDDO
-         IF (KEEP_OOC(237).NE.0 .OR. KEEP_OOC(235).NE.0) 
+         IF (KEEP_OOC(237).NE.0 .OR. KEEP_OOC(235).NE.0 .OR.
+     &       KEEP_OOC(212).NE.0 ) 
      &      THEN
            IF (COMPRESS_TO_BE_DONE) THEN 
              DO ZONE=1,NB_Z-1
@@ -2789,7 +2788,7 @@ C
       TYPE(CMUMPS_STRUC), TARGET :: id
       INTEGER, intent(out) :: IERR
       INTEGER I,DIM,J,TMP,SIZE,K,I1
-      CHARACTER(len=1):: TMP_NAME(350)
+      CHARACTER(len=1):: TMP_NAME(FILENAMELENGTH)
       EXTERNAL MUMPS_OOC_GET_NB_FILES_C, MUMPS_OOC_GET_FILE_NAME_C
       IERR=0
       SIZE=0
@@ -2803,7 +2802,7 @@ C
          DEALLOCATE(id%OOC_FILE_NAMES)
          NULLIFY(id%OOC_FILE_NAMES)
       ENDIF
-      ALLOCATE(id%OOC_FILE_NAMES(SIZE,350),stat=IERR)
+      ALLOCATE(id%OOC_FILE_NAMES(SIZE,FILENAMELENGTH),stat=IERR)
       IF (IERR .GT. 0) THEN
          IF (ICNTL1.GT.0) THEN
             WRITE(ICNTL1,*) 'PB allocation in ',
@@ -2812,7 +2811,7 @@ C
          IERR=-1
          IF(id%INFO(1).GE.0)THEN
             id%INFO(1) = -13
-            id%INFO(2) = SIZE*350
+            id%INFO(2) = SIZE*FILENAMELENGTH
             RETURN
          ENDIF
       ENDIF
@@ -2850,10 +2849,9 @@ C
       USE CMUMPS_STRUC_DEF
       IMPLICIT NONE
       TYPE(CMUMPS_STRUC), TARGET :: id
-      CHARACTER(len=1):: TMP_NAME(350)
+      CHARACTER(len=1):: TMP_NAME(FILENAMELENGTH)
       INTEGER I,I1,TMP,J,K,L,DIM,IERR
       INTEGER, DIMENSION(:),ALLOCATABLE :: NB_FILES
-      INTEGER K211
       ALLOCATE(NB_FILES(OOC_NB_FILE_TYPE),stat=IERR)
       IF (IERR .GT. 0) THEN
          IERR=-1
@@ -2872,7 +2870,6 @@ C
       I=id%MYID
       K=id%KEEP(35)
       L=mod(id%KEEP(204),3)
-      K211=id%KEEP(211)
       CALL MUMPS_OOC_ALLOC_POINTERS_C(OOC_NB_FILE_TYPE,NB_FILES,IERR)
       IF(IERR.LT.0)THEN
          IF (ICNTL1.GT.0)
@@ -2880,7 +2877,7 @@ C
          id%INFO(1)=IERR
          RETURN
       ENDIF
-      CALL MUMPS_OOC_INIT_VARS_C(I,K,L,K211,IERR)
+      CALL MUMPS_OOC_INIT_VARS_C(I,K,L,id%KEEP(211),id%KEEP(255),IERR)
       IF(IERR.LT.0)THEN
          IF (ICNTL1.GT.0)
      &   WRITE(ICNTL1,*)MYID_OOC,': ',ERR_STR_OOC(1:DIM_ERR_STR_OOC)
@@ -2916,16 +2913,6 @@ C
       DEALLOCATE(NB_FILES)
       RETURN
       END SUBROUTINE CMUMPS_OOC_OPEN_FILES_FOR_SOLVE      
-      SUBROUTINE CMUMPS_CONVERT_STR_TO_CHR_ARRAY(DEST,SRC,NB,NB_EFF)
-      IMPLICIT NONE
-      INTEGER NB, NB_EFF
-      CHARACTER(LEN=NB):: SRC
-      CHARACTER(len=1):: DEST(NB)
-      INTEGER I
-      DO I=1,NB_EFF
-         DEST(I)=SRC(I:I)
-      ENDDO
-      END SUBROUTINE CMUMPS_CONVERT_STR_TO_CHR_ARRAY
       SUBROUTINE CMUMPS_FORCE_WRITE_BUF(IERR)
       USE CMUMPS_OOC_BUFFER
       IMPLICIT NONE
diff -pruN 5.6.2-2.1/src/cmumps_ooc_buffer.F 5.7.1-1/src/cmumps_ooc_buffer.F
--- 5.6.2-2.1/src/cmumps_ooc_buffer.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/cmumps_ooc_buffer.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/cmumps_save_restore.F 5.7.1-1/src/cmumps_save_restore.F
--- 5.6.2-2.1/src/cmumps_save_restore.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/cmumps_save_restore.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -11,15 +11,18 @@ C  released under the CeCILL-C license
 C  (see doc/CeCILL-C_V1-en.txt, doc/CeCILL-C_V1-fr.txt, and
 C  https://cecill.info/licences/Licence_CeCILL-C_V1-en.html)
 C
+#if ! defined(NO_SAVE_RESTORE)
       MODULE CMUMPS_SAVE_RESTORE
       USE CMUMPS_STRUC_DEF
       USE CMUMPS_SAVE_RESTORE_FILES
       USE CMUMPS_LR_DATA_M
       USE MUMPS_FRONT_DATA_MGT_M
       IMPLICIT NONE
+      INCLUDE 'mumps_save_restore_modes.h'
       CONTAINS
       SUBROUTINE CMUMPS_REMOVE_SAVED(id)
-      USE CMUMPS_OOC
+      USE CMUMPS_OOC 
+      IMPLICIT NONE
       INCLUDE 'mpif.h'
       INTEGER MASTER
       PARAMETER ( MASTER = 0 )
@@ -151,6 +154,7 @@ C
       RETURN
       END SUBROUTINE CMUMPS_REMOVE_SAVED
       SUBROUTINE CMUMPS_RESTORE_OOC(localid)
+      IMPLICIT NONE
       INCLUDE 'mpif.h'
       INTEGER::ierr,IN,NBVARIABLES,NBVARIABLES_ROOT
       CHARACTER(len=LEN_SAVE_FILE):: restore_file_ooc,INFO_FILE
@@ -161,7 +165,7 @@ C
       INTEGER:: INFO1,INFO2,INFOG1,INFOG2,allocok
       INTEGER(8) :: TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
       TYPE (CMUMPS_STRUC) :: localid
-      NBVARIABLES=188
+      NBVARIABLES=194
       NBVARIABLES_ROOT=33
       allocate(SIZE_VARIABLES(NBVARIABLES),  stat=allocok)
       if (allocok .GT. 0) THEN
@@ -227,7 +231,7 @@ C
       CALL MUMPS_PROPINFO( localid%ICNTL(1), localid%INFO(1),
      &     localid%COMM, localid%MYID )
       IF ( localid%INFO(1) .LT. 0 ) RETURN
-      CALL CMUMPS_SAVE_RESTORE_STRUCTURE(localid,IN,"restore_ooc"
+      CALL CMUMPS_SAVE_RESTORE_STRUCTURE(localid,IN,restore_ooc_mode
      &     ,NBVARIABLES,SIZE_VARIABLES,SIZE_GEST
      &     ,NBVARIABLES_ROOT,SIZE_VARIABLES_ROOT,SIZE_GEST_ROOT
      &     ,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
@@ -239,6 +243,7 @@ C
       END SUBROUTINE CMUMPS_RESTORE_OOC
       SUBROUTINE CMUMPS_COMPUTE_MEMORY_SAVE(id,
      &     TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE)
+      IMPLICIT NONE
       INCLUDE 'mpif.h'
       INTEGER::NBVARIABLES,NBVARIABLES_ROOT
       INTEGER(8),allocatable, dimension(:)::SIZE_VARIABLES
@@ -248,7 +253,7 @@ C
       INTEGER :: INFO1,INFO2,INFOG1,INFOG2,allocok
       INTEGER(8) :: TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
       TYPE (CMUMPS_STRUC) :: id
-      NBVARIABLES=188
+      NBVARIABLES=194
       NBVARIABLES_ROOT=33
       allocate(SIZE_VARIABLES(NBVARIABLES),  stat=allocok)
       if (allocok .GT. 0) THEN
@@ -292,7 +297,7 @@ C
       INFO2 = -999
       INFOG1 = -999
       INFOG2 = -999
-      CALL CMUMPS_SAVE_RESTORE_STRUCTURE(id,0,"memory_save"
+      CALL CMUMPS_SAVE_RESTORE_STRUCTURE(id,0,memory_save_mode
      &     ,NBVARIABLES,SIZE_VARIABLES,SIZE_GEST
      &     ,NBVARIABLES_ROOT,SIZE_VARIABLES_ROOT,SIZE_GEST_ROOT
      &     ,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
@@ -302,6 +307,7 @@ C
       RETURN
       END SUBROUTINE CMUMPS_COMPUTE_MEMORY_SAVE
       SUBROUTINE CMUMPS_SAVE(id)
+      IMPLICIT NONE
       INCLUDE 'mpif.h'
       INTEGER::ierr,OUT,NBVARIABLES,NBVARIABLES_ROOT,OUTINFO
       CHARACTER(len=LEN_SAVE_FILE):: SAVE_FILE,INFO_FILE
@@ -326,7 +332,7 @@ C
       id%INFOG(2)=0
       MPG= id%ICNTL(3)
       PROKG   = ( MPG .GT. 0 .and. id%MYID .eq. 0 )
-      NBVARIABLES=188
+      NBVARIABLES=194
       NBVARIABLES_ROOT=33
       allocate(SIZE_VARIABLES(NBVARIABLES),  stat=allocok)
       if (allocok .GT. 0) THEN
@@ -367,7 +373,7 @@ C
       TOTAL_FILE_SIZE=0_8
       TOTAL_STRUC_SIZE=0_8
       TMP_OOC_NAMES(:)="?"
-      CALL CMUMPS_SAVE_RESTORE_STRUCTURE(id,0,"memory_save"
+      CALL CMUMPS_SAVE_RESTORE_STRUCTURE(id,0,memory_save_mode
      &     ,NBVARIABLES,SIZE_VARIABLES,SIZE_GEST
      &     ,NBVARIABLES_ROOT,SIZE_VARIABLES_ROOT,SIZE_GEST_ROOT
      &     ,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
@@ -426,7 +432,7 @@ C
       CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &     id%COMM, id%MYID )
       IF ( id%INFO(1) .LT. 0 ) RETURN
-      CALL CMUMPS_SAVE_RESTORE_STRUCTURE(id,OUT,"save"
+      CALL CMUMPS_SAVE_RESTORE_STRUCTURE(id,OUT,save_mode
      &     ,NBVARIABLES,SIZE_VARIABLES,SIZE_GEST
      &     ,NBVARIABLES_ROOT,SIZE_VARIABLES_ROOT,SIZE_GEST_ROOT
      &     ,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
@@ -513,6 +519,7 @@ C
       RETURN
       END SUBROUTINE CMUMPS_SAVE
       SUBROUTINE CMUMPS_RESTORE(id)
+      IMPLICIT NONE
       INCLUDE 'mpif.h'
       INTEGER::ierr,IN,NBVARIABLES,NBVARIABLES_ROOT
       CHARACTER(len=LEN_SAVE_FILE):: restore_file,INFO_FILE
@@ -526,7 +533,7 @@ C
       INTEGER :: I,J,K,H,allocok
       CHARACTER(len=1) :: TMP_OOC_NAMES(350)
       TYPE (CMUMPS_STRUC) :: id
-      NBVARIABLES=188
+      NBVARIABLES=194
       NBVARIABLES_ROOT=33
       allocate(SIZE_VARIABLES(NBVARIABLES),  stat=allocok)
       if (allocok .GT. 0) THEN
@@ -595,7 +602,7 @@ C
       IF ( id%INFO(1) .LT. 0 ) RETURN
       MP= id%ICNTL(2)
       MPG= id%ICNTL(3)
-      CALL CMUMPS_SAVE_RESTORE_STRUCTURE(id,IN,"restore"
+      CALL CMUMPS_SAVE_RESTORE_STRUCTURE(id,IN,restore_mode
      &     ,NBVARIABLES,SIZE_VARIABLES,SIZE_GEST
      &     ,NBVARIABLES_ROOT,SIZE_VARIABLES_ROOT,SIZE_GEST_ROOT
      &     ,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
@@ -660,8 +667,8 @@ C
       USE CMUMPS_FACSOL_L0OMP_M, ONLY : CMUMPS_SAVE_RESTORE_L0FACARRAY
       IMPLICIT NONE
       INCLUDE 'mpif.h'
-      INTEGER,intent(in)::unit,NBVARIABLES,NBVARIABLES_ROOT
-      CHARACTER(len=*),intent(in) :: mode
+      INTEGER, intent(in) ::unit,NBVARIABLES,NBVARIABLES_ROOT
+      INTEGER, intent(in) :: mode
       INTEGER(8),dimension(NBVARIABLES)::SIZE_VARIABLES
       INTEGER(8),dimension(NBVARIABLES_ROOT)::SIZE_VARIABLES_ROOT
       INTEGER,dimension(NBVARIABLES)::SIZE_GEST
@@ -669,9 +676,6 @@ C
       INTEGER(8) :: TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
       INTEGER:: INFO1,INFO2,INFOG1,INFOG2
       INTEGER:: j,i1,i2,err,ierr
-      CHARACTER(len=30), allocatable, dimension(:)::VARIABLES
-      CHARACTER(len=30), allocatable, dimension(:)::VARIABLES_ROOT
-      CHARACTER(len=30) :: TMP_STRING1, TMP_STRING2
       CHARACTER :: ARITH,READ_ARITH
       INTEGER(8) :: size_written,gest_size,WRITTEN_STRUC_SIZE
       INTEGER:: SIZE_INT, SIZE_INT8, SIZE_RL_OR_DBL, SIZE_ARITH_DEP
@@ -701,246 +705,237 @@ C
      &            SIZE_VARIABLES_L0FAC
       INTEGER::SIZE_GEST_BLR,SIZE_GEST_FRONT_DATA,SIZE_GEST_L0FAC
       INTEGER :: KEEP410_SAVE, KEEP411_SAVE 
+      INTEGER(8) :: KEEP883_SAVE, KEEP884_SAVE 
       INTEGER(4) :: I4
       TYPE (CMUMPS_STRUC) :: id
-      allocate(VARIABLES(NBVARIABLES),  stat=allocok)
-      if (allocok .GT. 0) THEN
-       id%INFO(1)  =-13
-       id%INFO(2) = NBVARIABLES
-      endif
-      CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &     id%COMM, id%MYID )
-      IF ( id%INFO(1) .LT. 0 ) GOTO 100
-      VARIABLES(188)="ASSOCIATED_OOC_FILES"
-      VARIABLES(187)="pad16"
-      VARIABLES(186)="Deficiency"
-      VARIABLES(185)="NB_SINGULAR_VALUES"
-      VARIABLES(184)="SINGULAR_VALUES"
-      VARIABLES(183)="MPITOOMP_PROCS_MAP"
-      VARIABLES(182)="L0_OMP_MAPPING"
-      VARIABLES(181)="PTR_LEAFS_L0_OMP"
-      VARIABLES(180)="PERM_L0_OMP"
-      VARIABLES(179)="VIRT_L0_OMP_MAPPING"
-      VARIABLES(178)="VIRT_L0_OMP"
-      VARIABLES(177)="PHYS_L0_OMP"
-      VARIABLES(176)="IPOOL_A_L0_OMP"
-      VARIABLES(175)="IPOOL_B_L0_OMP"
-      VARIABLES(174)="I8_L0_OMP"
-      VARIABLES(173)="I4_L0_OMP"
-      VARIABLES(172)="THREAD_LA"
-      VARIABLES(171)="LL0_OMP_FACTORS"
-      VARIABLES(170)="LL0_OMP_MAPPING"
-      VARIABLES(169)="L_VIRT_L0_OMP"
-      VARIABLES(168)="L_PHYS_L0_OMP"
-      VARIABLES(167)="LPOOL_B_L0_OMP"
-      VARIABLES(166)="LPOOL_A_L0_OMP"
-      VARIABLES(165)="L0_OMP_FACTORS"
-      VARIABLES(164)="BLRARRAY_ENCODING"
-      VARIABLES(163)="FDM_F_ENCODING"
-      VARIABLES(162)="pad13"
-      VARIABLES(161)="NBGRP"
-      VARIABLES(160)="LRGROUPS"
-      VARIABLES(159)="root"
-      VARIABLES(158)="WORKING"
-      VARIABLES(157)="IPTR_WORKING"
-      VARIABLES(156)="pad14"
-      VARIABLES(155)="SUP_PROC"
-      VARIABLES(154)="PIVNUL_LIST"
-      VARIABLES(153)="OOC_FILE_NAMES"
-      VARIABLES(152)="OOC_FILE_NAME_LENGTH"
-      VARIABLES(151)="pad12"
-      VARIABLES(150)="OOC_NB_FILE_TYPE"
-      VARIABLES(149)="OOC_NB_FILES"
-      VARIABLES(148)="OOC_TOTAL_NB_NODES"
-      VARIABLES(147)="OOC_VADDR"
-      VARIABLES(146)="OOC_SIZE_OF_BLOCK"
-      VARIABLES(145)="OOC_INODE_SEQUENCE"
-      VARIABLES(144)="OOC_MAX_NB_NODES_FOR_ZONE"
-      VARIABLES(143)="INSTANCE_NUMBER"
-      VARIABLES(142)="CB_SON_SIZE"
-      VARIABLES(141)="DKEEP"
-      VARIABLES(140)="LWK_USER"
-      VARIABLES(139)="NBSA_LOCAL"
-      VARIABLES(138)="WK_USER"
-      VARIABLES(137)="CROIX_MANU"
-      VARIABLES(136)="SCHED_SBTR"
-      VARIABLES(135)="SCHED_GRP"
-      VARIABLES(134)="SCHED_DEP"
-      VARIABLES(133)="SBTR_ID"
-      VARIABLES(132)="DEPTH_FIRST_SEQ"
-      VARIABLES(131)="DEPTH_FIRST"
-      VARIABLES(130)="MY_NB_LEAF"
-      VARIABLES(129)="MY_FIRST_LEAF"
-      VARIABLES(128)="MY_ROOT_SBTR"
-      VARIABLES(127)="COST_TRAV"
-      VARIABLES(126)="MEM_SUBTREE"
-      VARIABLES(125)="RHSCOMP"
-      VARIABLES(124)="POSINRHSCOMP_COL"
-      VARIABLES(123)="pad11"
-      VARIABLES(122)="POSINRHSCOMP_COL_ALLOC"
-      VARIABLES(121)="POSINRHSCOMP_ROW"
-      VARIABLES(120)="MEM_DIST"
-      VARIABLES(119)="I_AM_CAND"
-      VARIABLES(118)="TAB_POS_IN_PERE"
-      VARIABLES(117)="FUTURE_NIV2"
-      VARIABLES(116)="ISTEP_TO_INIV2"
-      VARIABLES(115)="CANDIDATES"
-      VARIABLES(114)="ELTPROC"
-      VARIABLES(113)="LELTVAR"
-      VARIABLES(112)="NELT_loc"
-      VARIABLES(111)="PROCNODE"
-      VARIABLES(110)="S"
-      VARIABLES(109)="PTRFAC"
-      VARIABLES(108)="PTLUST_S"
-      VARIABLES(107)="Step2node"
-      VARIABLES(106)="PROCNODE_STEPS"
-      VARIABLES(105)="NA"
-      VARIABLES(104)="PTRDEBARR"
-      VARIABLES(103)="NINROWARR"
-      VARIABLES(102)="NINCOLARR"
-      VARIABLES(101)="PTR8ARR"
-      VARIABLES(100)="PTRAR"
-      VARIABLES(99)="FRTELT"
-      VARIABLES(98)="FRTPTR"
-      VARIABLES(97)="FILS"
-      VARIABLES(96)="DAD_STEPS"
-      VARIABLES(95)="FRERE_STEPS"
-      VARIABLES(94)="ND_STEPS"
-      VARIABLES(93)="NE_STEPS"
-      VARIABLES(92)="STEP"
-      VARIABLES(91)="NBSA"
-      VARIABLES(90)="LNA"
-      VARIABLES(89)="KEEP"
-      VARIABLES(88)="IS"
-      VARIABLES(87)="ASS_IRECV"
-      VARIABLES(86)="NSLAVES"
-      VARIABLES(85)="NPROCS"
-      VARIABLES(84)="MYID"
-      VARIABLES(83)="COMM_LOAD"
-      VARIABLES(82)="MYID_NODES"
-      VARIABLES(81)="COMM_NODES"
-      VARIABLES(80)="INST_Number"
-      VARIABLES(79)="MAX_SURF_MASTER"
-      VARIABLES(78)="KEEP8"
-      VARIABLES(77)="pad7"
-      VARIABLES(76)="SAVE_PREFIX"
-      VARIABLES(75)="SAVE_DIR"
-      VARIABLES(74)="WRITE_PROBLEM"
-      VARIABLES(73)="OOC_PREFIX"
-      VARIABLES(72)="OOC_TMPDIR"
-      VARIABLES(71)="VERSION_NUMBER"
-      VARIABLES(70)="MAPPING"
-      VARIABLES(69)="LISTVAR_SCHUR"
-      VARIABLES(68)="SCHUR_CINTERFACE"
-      VARIABLES(67)="SCHUR"
-      VARIABLES(66)="SIZE_SCHUR"
-      VARIABLES(65)="SCHUR_LLD"
-      VARIABLES(64)="SCHUR_NLOC"
-      VARIABLES(63)="SCHUR_MLOC"
-      VARIABLES(62)="NBLOCK"
-      VARIABLES(61)="MBLOCK"
-      VARIABLES(60)="NPCOL"
-      VARIABLES(59)="NPROW"
-      VARIABLES(58)="UNS_PERM"
-      VARIABLES(57)="SYM_PERM"
-      VARIABLES(56)="METIS_OPTIONS"
-      VARIABLES(55)="RINFOG"
-      VARIABLES(54)="RINFO"
-      VARIABLES(53)="CNTL"
-      VARIABLES(52)="COST_SUBTREES"
-      VARIABLES(51)="INFOG"
-      VARIABLES(50)="INFO"
-      VARIABLES(49)="ICNTL"
-      VARIABLES(48)="pad6"
-      VARIABLES(47)="LSOL_loc"
-      VARIABLES(46)="LREDRHS"
-      VARIABLES(45)="LRHS_loc"
-      VARIABLES(44)="Nloc_RHS"
-      VARIABLES(43)="NZ_RHS"
-      VARIABLES(42)="NRHS"
-      VARIABLES(41)="LRHS"
-      VARIABLES(40)="IRHS_loc"
-      VARIABLES(39)="ISOL_loc"
-      VARIABLES(38)="IRHS_PTR"
-      VARIABLES(37)="IRHS_SPARSE"
-      VARIABLES(36)="RHS_loc"
-      VARIABLES(35)="SOL_loc"
-      VARIABLES(34)="RHS_SPARSE"
-      VARIABLES(33)="REDRHS"
-      VARIABLES(32)="RHS"
-      VARIABLES(31)="BLKVAR"
-      VARIABLES(30)="BLKPTR"
-      VARIABLES(29)="pad5"
-      VARIABLES(28)="NBLK"
-      VARIABLES(27)="PERM_IN"
-      VARIABLES(26)="pad4"
-      VARIABLES(25)="A_ELT"
-      VARIABLES(24)="ELTVAR"
-      VARIABLES(23)="ELTPTR"
-      VARIABLES(22)="pad3"
-      VARIABLES(21)="NELT"
-      VARIABLES(20)="pad2"
-      VARIABLES(19)="A_loc"
-      VARIABLES(18)="JCN_loc"
-      VARIABLES(17)="IRN_loc"
-      VARIABLES(16)="NNZ_loc"
-      VARIABLES(15)="pad1"
-      VARIABLES(14)="NZ_loc"
-      VARIABLES(13)="pad0"
-      VARIABLES(12)="ROWSCA"
-      VARIABLES(11)="COLSCA"
-      VARIABLES(10)="JCN"
-      VARIABLES(9)="IRN"
-      VARIABLES(8)="A"
-      VARIABLES(7)="NNZ"
-      VARIABLES(6)="NZ"
-      VARIABLES(5)="N"
-      VARIABLES(4)="JOB"
-      VARIABLES(3)="PAR"
-      VARIABLES(2)="SYM"
-      VARIABLES(1)="COMM"
-      allocate(VARIABLES_ROOT(NBVARIABLES_ROOT),  stat=allocok)
-      if (allocok .GT. 0) THEN
-       id%INFO(1)  =-13
-       id%INFO(2) = NBVARIABLES_ROOT
-      endif
-      CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &        id%COMM, id%MYID )
-      IF ( id%INFO(1) .LT. 0 ) GOTO 100
-      VARIABLES_ROOT(33)="rootpad4"
-      VARIABLES_ROOT(32)="NB_SINGULAR_VALUES"
-      VARIABLES_ROOT(31)="SINGULAR_VALUES"
-      VARIABLES_ROOT(30)="SVD_VT"
-      VARIABLES_ROOT(29)="SVD_U"
-      VARIABLES_ROOT(28)="gridinit_done"
-      VARIABLES_ROOT(27)="yes"
-      VARIABLES_ROOT(26)="rootpad3"
-      VARIABLES_ROOT(25)="QR_RCOND"
-      VARIABLES_ROOT(24)="rootpad2"
-      VARIABLES_ROOT(23)="RHS_ROOT"
-      VARIABLES_ROOT(22)="rootpad1"
-      VARIABLES_ROOT(21)="QR_TAU"
-      VARIABLES_ROOT(20)="SCHUR_POINTER"
-      VARIABLES_ROOT(19)="RHS_CNTR_MASTER_ROOT"
-      VARIABLES_ROOT(18)="IPIV"
-      VARIABLES_ROOT(17)="RG2L"
-      VARIABLES_ROOT(16)="rootpad0"
-      VARIABLES_ROOT(15)="LPIV"
-      VARIABLES_ROOT(14)="CNTXT_BLACS"
-      VARIABLES_ROOT(13)="DESCRIPTOR"
-      VARIABLES_ROOT(12)="TOT_ROOT_SIZE"
-      VARIABLES_ROOT(11)="ROOT_SIZE"
-      VARIABLES_ROOT(10)="RHS_NLOC"
-      VARIABLES_ROOT(9)="SCHUR_LLD"
-      VARIABLES_ROOT(8)="SCHUR_NLOC"
-      VARIABLES_ROOT(7)="SCHUR_MLOC"
-      VARIABLES_ROOT(6)="MYCOL"
-      VARIABLES_ROOT(5)="MYROW"
-      VARIABLES_ROOT(4)="NPCOL"
-      VARIABLES_ROOT(3)="NPROW"
-      VARIABLES_ROOT(2)="NBLOCK"
-      VARIABLES_ROOT(1)="MBLOCK"
-      OOC_INDICES=(/149,150,152,153/)
+      INTEGER, PARAMETER :: S_ASSOCIATED_OOC_FILES=194
+      INTEGER, PARAMETER :: S_pad16=193
+      INTEGER, PARAMETER :: S_Deficiency=192
+      INTEGER, PARAMETER :: S_NB_SINGULAR_VALUES=191
+      INTEGER, PARAMETER :: S_SINGULAR_VALUES=190
+      INTEGER, PARAMETER :: S_MTKO_PROCS_MAP=189
+      INTEGER, PARAMETER :: S_L0_OMP_MAPPING=188
+      INTEGER, PARAMETER :: S_PTR_LEAFS_L0_OMP=187
+      INTEGER, PARAMETER :: S_PERM_L0_OMP=186
+      INTEGER, PARAMETER :: S_VIRT_L0_OMP_MAPPING=185
+      INTEGER, PARAMETER :: S_VIRT_L0_OMP=184
+      INTEGER, PARAMETER :: S_PHYS_L0_OMP=183
+      INTEGER, PARAMETER :: S_IPOOL_A_L0_OMP=182
+      INTEGER, PARAMETER :: S_IPOOL_B_L0_OMP=181
+      INTEGER, PARAMETER :: S_I8_L0_OMP=180
+      INTEGER, PARAMETER :: S_I4_L0_OMP=179
+      INTEGER, PARAMETER :: S_THREAD_LA=178
+      INTEGER, PARAMETER :: S_LL0_OMP_FACTORS=177
+      INTEGER, PARAMETER :: S_LL0_OMP_MAPPING=176
+      INTEGER, PARAMETER :: S_L_VIRT_L0_OMP=175
+      INTEGER, PARAMETER :: S_L_PHYS_L0_OMP=174
+      INTEGER, PARAMETER :: S_LPOOL_B_L0_OMP=173
+      INTEGER, PARAMETER :: S_LPOOL_A_L0_OMP=172
+      INTEGER, PARAMETER :: S_L0_OMP_FACTORS=171
+      INTEGER, PARAMETER :: S_BLRARRAY_ENCODING=170
+      INTEGER, PARAMETER :: S_FDM_F_ENCODING=169
+      INTEGER, PARAMETER :: S_pad13=168
+      INTEGER, PARAMETER :: S_NBGRP=167
+      INTEGER, PARAMETER :: S_LRGROUPS=166
+      INTEGER, PARAMETER :: S_root=165
+      INTEGER, PARAMETER :: S_WORKING=164
+      INTEGER, PARAMETER :: S_IPTR_WORKING=163
+      INTEGER, PARAMETER :: S_pad14=162
+      INTEGER, PARAMETER :: S_SUP_PROC=161
+      INTEGER, PARAMETER :: S_PIVNUL_LIST=160
+      INTEGER, PARAMETER :: S_OOC_FILE_NAMES=159
+      INTEGER, PARAMETER :: S_OOC_FILE_NAME_LENGTH=158
+      INTEGER, PARAMETER :: S_pad12=157
+      INTEGER, PARAMETER :: S_OOC_NB_FILE_TYPE=156
+      INTEGER, PARAMETER :: S_OOC_NB_FILES=155
+      INTEGER, PARAMETER :: S_OOC_TOTAL_NB_NODES=154
+      INTEGER, PARAMETER :: S_OOC_VADDR=153
+      INTEGER, PARAMETER :: S_OOC_SIZE_OF_BLOCK=152
+      INTEGER, PARAMETER :: S_OOC_INODE_SEQUENCE=151
+      INTEGER, PARAMETER :: S_OOC_MAX_NB_NODES_FOR_ZONE=150
+      INTEGER, PARAMETER :: S_INSTANCE_NUMBER=149
+      INTEGER, PARAMETER :: S_CB_SON_SIZE=148
+      INTEGER, PARAMETER :: S_DKEEP=147
+      INTEGER, PARAMETER :: S_LWK_USER=146
+      INTEGER, PARAMETER :: S_NBSA_LOCAL=145
+      INTEGER, PARAMETER :: S_WK_USER=144
+      INTEGER, PARAMETER :: S_CROIX_MANU=143
+      INTEGER, PARAMETER :: S_SCHED_SBTR=142
+      INTEGER, PARAMETER :: S_SCHED_GRP=141
+      INTEGER, PARAMETER :: S_SCHED_DEP=140
+      INTEGER, PARAMETER :: S_SBTR_ID=139
+      INTEGER, PARAMETER :: S_DEPTH_FIRST_SEQ=138
+      INTEGER, PARAMETER :: S_DEPTH_FIRST=137
+      INTEGER, PARAMETER :: S_MY_NB_LEAF=136
+      INTEGER, PARAMETER :: S_MY_FIRST_LEAF=135
+      INTEGER, PARAMETER :: S_MY_ROOT_SBTR=134
+      INTEGER, PARAMETER :: S_COST_TRAV=133
+      INTEGER, PARAMETER :: S_MEM_SUBTREE=132
+      INTEGER, PARAMETER :: S_RHSINTR=131
+      INTEGER, PARAMETER :: S_GLOB2LOC_SOL=130
+      INTEGER, PARAMETER :: S_pad11=129
+      INTEGER, PARAMETER :: S_GLOB2LOC_SOL_ALLOC=128
+      INTEGER, PARAMETER :: S_GLOB2LOC_RHS=127
+      INTEGER, PARAMETER :: S_MEM_DIST=126
+      INTEGER, PARAMETER :: S_I_AM_CAND=125
+      INTEGER, PARAMETER :: S_TAB_POS_IN_PERE=124
+      INTEGER, PARAMETER :: S_FUTURE_NIV2=123
+      INTEGER, PARAMETER :: S_ISTEP_TO_INIV2=122
+      INTEGER, PARAMETER :: S_CANDIDATES=121
+      INTEGER, PARAMETER :: S_ELTPROC=120
+      INTEGER, PARAMETER :: S_LELTVAR=119
+      INTEGER, PARAMETER :: S_NELT_loc=118
+      INTEGER, PARAMETER :: S_PROCNODE=117
+      INTEGER, PARAMETER :: S_S=116
+      INTEGER, PARAMETER :: S_PTRFAC=115
+      INTEGER, PARAMETER :: S_PTLUST_S=114
+      INTEGER, PARAMETER :: S_Step2node=113
+      INTEGER, PARAMETER :: S_PROCNODE_STEPS=112
+      INTEGER, PARAMETER :: S_NA=111
+      INTEGER, PARAMETER :: S_PTRDEBARR=110
+      INTEGER, PARAMETER :: S_NINROWARR=109
+      INTEGER, PARAMETER :: S_NINCOLARR=108
+      INTEGER, PARAMETER :: S_PTR8ARR=107
+      INTEGER, PARAMETER :: S_PTRAR=106
+      INTEGER, PARAMETER :: S_FRTELT=105
+      INTEGER, PARAMETER :: S_FRTPTR=104
+      INTEGER, PARAMETER :: S_FILS=103
+      INTEGER, PARAMETER :: S_DAD_STEPS=102
+      INTEGER, PARAMETER :: S_FRERE_STEPS=101
+      INTEGER, PARAMETER :: S_ND_STEPS=100
+      INTEGER, PARAMETER :: S_NE_STEPS=99
+      INTEGER, PARAMETER :: S_STEP=98
+      INTEGER, PARAMETER :: S_NBSA=97
+      INTEGER, PARAMETER :: S_LNA=96
+      INTEGER, PARAMETER :: S_KEEP=95
+      INTEGER, PARAMETER :: S_IS=94
+      INTEGER, PARAMETER :: S_ASS_IRECV=93
+      INTEGER, PARAMETER :: S_NSLAVES=92
+      INTEGER, PARAMETER :: S_NPROCS=91
+      INTEGER, PARAMETER :: S_MYID=90
+      INTEGER, PARAMETER :: S_COMM_LOAD=89
+      INTEGER, PARAMETER :: S_MYID_NODES=88
+      INTEGER, PARAMETER :: S_COMM_NODES=87
+      INTEGER, PARAMETER :: S_INST_Number=86
+      INTEGER, PARAMETER :: S_MAX_SURF_MASTER=85
+      INTEGER, PARAMETER :: S_KEEP8=84
+      INTEGER, PARAMETER :: S_pad7=83
+      INTEGER, PARAMETER :: S_SAVE_PREFIX=82
+      INTEGER, PARAMETER :: S_SAVE_DIR=81
+      INTEGER, PARAMETER :: S_WRITE_PROBLEM=80
+      INTEGER, PARAMETER :: S_OOC_PREFIX=79
+      INTEGER, PARAMETER :: S_OOC_TMPDIR=78
+      INTEGER, PARAMETER :: S_VERSION_NUMBER=77
+      INTEGER, PARAMETER :: S_MAPPING=76
+      INTEGER, PARAMETER :: S_LISTVAR_SCHUR=75
+      INTEGER, PARAMETER :: S_SCHUR_CINTERFACE=74
+      INTEGER, PARAMETER :: S_SCHUR=73
+      INTEGER, PARAMETER :: S_SIZE_SCHUR=72
+      INTEGER, PARAMETER :: S_SCHUR_LLD=71
+      INTEGER, PARAMETER :: S_SCHUR_NLOC=70
+      INTEGER, PARAMETER :: S_SCHUR_MLOC=69
+      INTEGER, PARAMETER :: S_NBLOCK=68
+      INTEGER, PARAMETER :: S_MBLOCK=67
+      INTEGER, PARAMETER :: S_NPCOL=66
+      INTEGER, PARAMETER :: S_NPROW=65
+      INTEGER, PARAMETER :: S_UNS_PERM=64
+      INTEGER, PARAMETER :: S_SYM_PERM=63
+      INTEGER, PARAMETER :: S_METIS_OPTIONS=62
+      INTEGER, PARAMETER :: S_RINFOG=61
+      INTEGER, PARAMETER :: S_RINFO=60
+      INTEGER, PARAMETER :: S_CNTL=59
+      INTEGER, PARAMETER :: S_COST_SUBTREES=58
+      INTEGER, PARAMETER :: S_INFOG=57
+      INTEGER, PARAMETER :: S_INFO=56
+      INTEGER, PARAMETER :: S_ICNTL=55
+      INTEGER, PARAMETER :: S_pad6=54
+      INTEGER, PARAMETER :: S_LD_RHSINTR=53
+      INTEGER, PARAMETER :: S_NSOL_loc=52
+      INTEGER, PARAMETER :: S_LSOL_loc=51
+      INTEGER, PARAMETER :: S_LREDRHS=50
+      INTEGER, PARAMETER :: S_LRHS_loc=49
+      INTEGER, PARAMETER :: S_Nloc_RHS=48
+      INTEGER, PARAMETER :: S_NZ_RHS=47
+      INTEGER, PARAMETER :: S_NRHS=46
+      INTEGER, PARAMETER :: S_LRHS=45
+      INTEGER, PARAMETER :: S_IRHS_loc=44
+      INTEGER, PARAMETER :: S_ISOL_loc=43
+      INTEGER, PARAMETER :: S_IRHS_PTR=42
+      INTEGER, PARAMETER :: S_IRHS_SPARSE=41
+      INTEGER, PARAMETER :: S_RHS_loc=40
+      INTEGER, PARAMETER :: S_SOL_loc=39
+      INTEGER, PARAMETER :: S_RHS_SPARSE=38
+      INTEGER, PARAMETER :: S_REDRHS=37
+      INTEGER, PARAMETER :: S_RHS=36
+      INTEGER, PARAMETER :: S_BLKVAR=35
+      INTEGER, PARAMETER :: S_BLKPTR=34
+      INTEGER, PARAMETER :: S_pad5=33
+      INTEGER, PARAMETER :: S_NBLK=32
+      INTEGER, PARAMETER :: S_PERM_IN=31
+      INTEGER, PARAMETER :: S_pad4=30
+      INTEGER, PARAMETER :: S_A_ELT=29
+      INTEGER, PARAMETER :: S_ELTVAR=28
+      INTEGER, PARAMETER :: S_ELTPTR=27
+      INTEGER, PARAMETER :: S_pad3=26
+      INTEGER, PARAMETER :: S_NELT=25
+      INTEGER, PARAMETER :: S_pad2=24
+      INTEGER, PARAMETER :: S_A_loc=23
+      INTEGER, PARAMETER :: S_JCN_loc=22
+      INTEGER, PARAMETER :: S_IRN_loc=21
+      INTEGER, PARAMETER :: S_NNZ_loc=20
+      INTEGER, PARAMETER :: S_pad1=19
+      INTEGER, PARAMETER :: S_NZ_loc=18
+      INTEGER, PARAMETER :: S_PIVOTS=17
+      INTEGER, PARAMETER :: S_COLIND=16
+      INTEGER, PARAMETER :: S_ROWIND=15
+      INTEGER, PARAMETER :: S_ROWSCA_loc=14
+      INTEGER, PARAMETER :: S_COLSCA_loc=13
+      INTEGER, PARAMETER :: S_ROWSCA=12
+      INTEGER, PARAMETER :: S_COLSCA=11
+      INTEGER, PARAMETER :: S_JCN=10
+      INTEGER, PARAMETER :: S_IRN=9
+      INTEGER, PARAMETER :: S_A=8
+      INTEGER, PARAMETER :: S_NNZ=7
+      INTEGER, PARAMETER :: S_NZ=6
+      INTEGER, PARAMETER :: S_N=5
+      INTEGER, PARAMETER :: S_JOB=4
+      INTEGER, PARAMETER :: S_PAR=3
+      INTEGER, PARAMETER :: S_SYM=2
+      INTEGER, PARAMETER :: S_COMM=1
+      INTEGER,  PARAMETER :: R_rootpad4=33
+      INTEGER,  PARAMETER :: R_NB_SINGULAR_VALUES=32
+      INTEGER,  PARAMETER :: R_SINGULAR_VALUES=31
+      INTEGER,  PARAMETER :: R_SVD_VT=30
+      INTEGER,  PARAMETER :: R_SVD_U=29
+      INTEGER,  PARAMETER :: R_gridinit_done=28
+      INTEGER,  PARAMETER :: R_yes=27
+      INTEGER,  PARAMETER :: R_rootpad3=26
+      INTEGER,  PARAMETER :: R_QR_RCOND=25
+      INTEGER,  PARAMETER :: R_rootpad2=24
+      INTEGER,  PARAMETER :: R_RHS_ROOT=23
+      INTEGER,  PARAMETER :: R_rootpad1=22
+      INTEGER,  PARAMETER :: R_QR_TAU=21
+      INTEGER,  PARAMETER :: R_SCHUR_POINTER=20
+      INTEGER,  PARAMETER :: R_RHS_CNTR_MASTER_ROOT=19
+      INTEGER,  PARAMETER :: R_IPIV=18
+      INTEGER,  PARAMETER :: R_RG2L=17
+      INTEGER,  PARAMETER :: R_rootpad0=16
+      INTEGER,  PARAMETER :: R_LPIV=15
+      INTEGER,  PARAMETER :: R_CNTXT_BLACS=14
+      INTEGER,  PARAMETER :: R_DESCRIPTOR=13
+      INTEGER,  PARAMETER :: R_TOT_ROOT_SIZE=12
+      INTEGER,  PARAMETER :: R_ROOT_SIZE=11
+      INTEGER,  PARAMETER :: R_RHS_NLOC=10
+      INTEGER,  PARAMETER :: R_SCHUR_LLD=9
+      INTEGER,  PARAMETER :: R_SCHUR_NLOC=8
+      INTEGER,  PARAMETER :: R_SCHUR_MLOC=7
+      INTEGER,  PARAMETER :: R_MYCOL=6
+      INTEGER,  PARAMETER :: R_MYROW=5
+      INTEGER,  PARAMETER :: R_NPCOL=4
+      INTEGER,  PARAMETER :: R_NPROW=3
+      INTEGER,  PARAMETER :: R_NBLOCK=2
+      INTEGER,  PARAMETER :: R_MBLOCK=1
+      OOC_INDICES=(/155,156,158,159/)
       SIZE_INT = id%KEEP(34)
       SIZE_INT8 = id%KEEP(34)*id%KEEP(10)
       SIZE_RL_OR_DBL = id%KEEP(16)
@@ -964,8 +959,8 @@ C
       SIZE_GEST_FRONT_DATA=0
       SIZE_VARIABLES_L0FAC=0
       SIZE_GEST_L0FAC=0
-      if(trim(mode).EQ."memory_save") then
-      elseif(trim(mode).EQ."save") then
+      if(mode.EQ.memory_save_mode) then
+      elseif(mode.EQ.save_mode) then
          write(unit,iostat=err) "MUMPS"
          if(err.ne.0) THEN
             id%INFO(1) = -72
@@ -1125,8 +1120,8 @@ C
      &           +int(2*id%KEEP(34)*1,kind=8)
 #endif
          ENDIF
-      elseif((trim(mode).EQ."restore").OR.
-     &        (trim(mode).EQ."restore_ooc")) then
+      elseif((mode.EQ.restore_mode).OR.
+     &        (mode.EQ.restore_ooc_mode)) then
         CALL MUMPS_READ_HEADER(unit,err,size_read,SIZE_INT,SIZE_INT8,
      &       TOTAL_FILE_SIZE, TOTAL_STRUC_SIZE, READ_ARITH,
      &       READ_INT_TYPE_64, READ_OOC_FILE_NAME_LENGTH,
@@ -1144,14 +1139,14 @@ C
      &        id%COMM, id%MYID )
          IF ( id%INFO(1) .LT. 0 ) GOTO 100
          BASIC_CHECK = .false.
-         IF (trim(mode).EQ."restore_ooc") THEN
+         IF (mode.EQ.restore_ooc_mode) THEN
            BASIC_CHECK = .true.
          ENDIF
          CALL CMUMPS_CHECK_HEADER(id,BASIC_CHECK,READ_INT_TYPE_64,
      &              READ_HASH, READ_NPROCS,
      &              READ_ARITH, READ_SYM, READ_PAR)
          IF (id%INFO(1) .LT. 0) GOTO 100
-      elseif(trim(mode).EQ."fake_restore") then
+      elseif(mode.EQ.fake_restore_mode) then
          read(unit,iostat=err) READ_HASH
          if(err.ne.0) GOTO 100
          read(unit,iostat=err) TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
@@ -1163,11 +1158,10 @@ C
       endif
       DO j=1,size(OOC_INDICES)
          i1=OOC_INDICES(j)
-         TMP_STRING1 = VARIABLES(i1)
-         SELECT CASE(TMP_STRING1)
-         CASE("OOC_NB_FILES")
+         SELECT CASE(i1)
+         CASE(S_OOC_NB_FILES)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%OOC_NB_FILES)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%OOC_NB_FILES,1)*SIZE_INT
@@ -1175,7 +1169,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%OOC_NB_FILES)) THEN
                   write(unit,iostat=err) size(id%OOC_NB_FILES,1)
                   if(err.ne.0) then
@@ -1207,8 +1201,8 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif((trim(mode).EQ."restore").OR.
-     &             (trim(mode).EQ."restore_ooc")) then
+            elseif((mode.EQ.restore_mode).OR.
+     &             (mode.EQ.restore_ooc_mode)) then
                nullify(id%OOC_NB_FILES)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -1247,11 +1241,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("OOC_NB_FILE_TYPE")
+         CASE(S_OOC_NB_FILE_TYPE)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%OOC_NB_FILE_TYPE
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1261,8 +1255,8 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif((trim(mode).EQ."restore").OR.
-     &             (trim(mode).EQ."restore_ooc")) then
+            elseif((mode.EQ.restore_mode).OR.
+     &             (mode.EQ.restore_ooc_mode)) then
                SIZE_VARIABLES(i1)=SIZE_INT
                read(unit,iostat=err) id%OOC_NB_FILE_TYPE
                if(err.ne.0) THEN
@@ -1274,9 +1268,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("OOC_FILE_NAMES")
+         CASE(S_OOC_FILE_NAMES)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%OOC_FILE_NAMES)) THEN
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=size(id%OOC_FILE_NAMES,1)
@@ -1285,7 +1279,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*3
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%OOC_FILE_NAMES)) THEN
                   write(unit,iostat=err) size(id%OOC_FILE_NAMES,1)
      &                 ,size(id%OOC_FILE_NAMES,2)
@@ -1318,8 +1312,8 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif((trim(mode).EQ."restore").OR.
-     &             (trim(mode).EQ."restore_ooc")) then
+            elseif((mode.EQ.restore_mode).OR.
+     &             (mode.EQ.restore_ooc_mode)) then
                nullify(id%OOC_FILE_NAMES)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -1360,9 +1354,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("OOC_FILE_NAME_LENGTH")
+         CASE(S_OOC_FILE_NAME_LENGTH)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%OOC_FILE_NAME_LENGTH)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
@@ -1371,7 +1365,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%OOC_FILE_NAME_LENGTH)) THEN
                   write(unit,iostat=err) size(id%OOC_FILE_NAME_LENGTH,1)
                   if(err.ne.0) then
@@ -1403,8 +1397,8 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif((trim(mode).EQ."restore").OR.
-     &             (trim(mode).EQ."restore_ooc")) then
+            elseif((mode.EQ.restore_mode).OR.
+     &             (mode.EQ.restore_ooc_mode)) then
                nullify(id%OOC_FILE_NAME_LENGTH)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -1447,111 +1441,41 @@ C
          CASE DEFAULT
          END SELECT
       ENDDO
-      if(trim(mode).EQ."restore_ooc") then
+      if(mode.EQ.restore_ooc_mode) then
          goto 200
       endif
       DO i1=1,NBVARIABLES 
-         TMP_STRING1 = VARIABLES(i1)
-         SELECT CASE(TMP_STRING1)
-         CASE("COMM")
-            if(trim(mode).EQ."memory_save") then
+         SELECT CASE(i1)
+         CASE(S_COMM)
+            if(mode.EQ.memory_save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
             endif
-         CASE("SYM")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%SYM
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%SYM
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read,
-     &                 id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("PAR")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%PAR
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%PAR
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("JOB")
-            if(trim(mode).EQ."memory_save") then
+         CASE(S_SYM)
+           CALL MUMPS_SAVE_INT(id%SYM)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_PAR)
+           CALL MUMPS_SAVE_INT(id%PAR)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_JOB)
+            if(mode.EQ.memory_save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
             endif
-         CASE("N")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%N
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%N
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("ICNTL")
+         CASE(S_N)
+           CALL MUMPS_SAVE_INT(id%N)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_ICNTL)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%ICNTL,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%ICNTL
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1561,7 +1485,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%ICNTL,1)
                read(unit,iostat=err) id%ICNTL
                if(err.ne.0) THEN
@@ -1573,11 +1497,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("INFO")
+         CASE(S_INFO)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%INFO,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) INFO1,INFO2
      &              ,id%INFO(3:size(id%INFO,1))
                if(err.ne.0) then
@@ -1588,7 +1512,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%INFO,1)
                read(unit,iostat=err) INFO1,INFO2
      &              ,id%INFO(3:size(id%INFO,1))
@@ -1601,11 +1525,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("INFOG")
+         CASE(S_INFOG)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%INFOG,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) INFOG1,INFOG2
      &              ,id%INFOG(3:size(id%INFOG,1))
                if(err.ne.0) then
@@ -1616,7 +1540,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%INFOG,1)
                read(unit,iostat=err) INFOG1,INFOG2
      &              ,id%INFOG(3:size(id%INFOG,1))
@@ -1629,11 +1553,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("COST_SUBTREES")
+         CASE(S_COST_SUBTREES)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%COST_SUBTREES
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1643,7 +1567,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL
                read(unit,iostat=err) id%COST_SUBTREES
                if(err.ne.0) THEN
@@ -1655,11 +1579,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("CNTL")
+         CASE(S_CNTL)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL*size(id%CNTL,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%CNTL
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1669,7 +1593,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL*size(id%CNTL,1)
                read(unit,iostat=err) id%CNTL
                if(err.ne.0) THEN
@@ -1681,11 +1605,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("RINFO")
+         CASE(S_RINFO)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL*size(id%RINFO,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%RINFO
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1695,7 +1619,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL*size(id%RINFO,1)
                read(unit,iostat=err) id%RINFO
                if(err.ne.0) THEN
@@ -1707,11 +1631,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("RINFOG")
+         CASE(S_RINFOG)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL*size(id%RINFOG,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%RINFOG
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1721,7 +1645,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL*size(id%RINFOG,1)
                read(unit,iostat=err) id%RINFOG
                if(err.ne.0) THEN
@@ -1733,11 +1657,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("KEEP8")
+         CASE(S_KEEP8)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8*size(id%KEEP8,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%KEEP8
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1747,9 +1671,13 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8*size(id%KEEP8,1)
+               KEEP883_SAVE=id%KEEP8(83)
+               KEEP884_SAVE=id%KEEP8(84)
                read(unit,iostat=err) id%KEEP8
+               id%KEEP8(83)=KEEP883_SAVE
+               id%KEEP8(84)=KEEP884_SAVE
                if(err.ne.0) THEN
                   id%INFO(1) = -75
                   CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
@@ -1759,11 +1687,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("KEEP")
+         CASE(S_KEEP)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%KEEP,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%KEEP
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1773,7 +1701,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%KEEP,1)
                KEEP410_SAVE = id%KEEP(410)
                KEEP411_SAVE = id%KEEP(411)
@@ -1789,11 +1717,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("DKEEP")
+         CASE(S_DKEEP)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL*size(id%DKEEP,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%DKEEP
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1803,7 +1731,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL*size(id%DKEEP,1)
                read(unit,iostat=err) id%DKEEP
                if(err.ne.0) THEN
@@ -1815,37 +1743,14 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("NZ")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NZ
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NZ
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("NNZ")
+         CASE(S_NZ)
+           CALL MUMPS_SAVE_INT(id%NZ)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NNZ)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%NNZ
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1855,7 +1760,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8
                read(unit,iostat=err) id%NNZ
                if(err.ne.0) THEN
@@ -1867,174 +1772,32 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif  
-         CASE("A")
-         CASE("IRN")
-         CASE("JCN")
-         CASE("COLSCA")
+         CASE(S_A)
+         CASE(S_IRN)
+         CASE(S_JCN)
+         CASE(S_COLSCA)
             IF(id%KEEP(52).NE.-1) THEN
-               NbRecords(i1)=2
-               if(trim(mode).EQ."memory_save") then
-                  IF(associated(id%COLSCA)) THEN
-                     SIZE_GEST(i1)=SIZE_INT
-                     SIZE_VARIABLES(i1)=size(id%COLSCA,1)*SIZE_RL_OR_DBL
-                  ELSE
-                     SIZE_GEST(i1)=SIZE_INT*2
-                     SIZE_VARIABLES(i1)=0_8
-                  ENDIF
-               elseif(trim(mode).EQ."save") then
-                  IF(associated(id%COLSCA)) THEN
-                     write(unit,iostat=err) size(id%COLSCA,1)
-                     if(err.ne.0) then
-                        id%INFO(1) = -72
-                        CALL MUMPS_SETI8TOI4(
-     &                       TOTAL_FILE_SIZE-size_written,
-     &                       id%INFO(2))
-                     endif
-                     write(unit,iostat=err) id%COLSCA
-                  ELSE
-                     write(unit,iostat=err) -999
-                     if(err.ne.0) then
-                        id%INFO(1) = -72
-                        CALL MUMPS_SETI8TOI4(
-     &                       TOTAL_FILE_SIZE-size_written,
-     &                       id%INFO(2))
-                     endif
-                     write(unit,iostat=err) -999
-                  ENDIF 
-                  if(err.ne.0) then
-                     id%INFO(1) = -72
-                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-                  endif
-                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &                 id%COMM, id%MYID )
-                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
-                  nullify(id%COLSCA)
-                  read(unit,iostat=err) size_array1
-                  if(err.ne.0) THEN
-                     id%INFO(1) = -75
-                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                    ,id%INFO(2))
-                  endif
-                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &                 id%COMM, id%MYID )
-                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
-                  if(size_array1.EQ.-999) then
-                     SIZE_GEST(i1)=SIZE_INT*2
-                     SIZE_VARIABLES(i1)=0_8
-                     read(unit,iostat=err) dummy
-                  else
-                     SIZE_GEST(i1)=SIZE_INT
-                     SIZE_VARIABLES(i1)=size_array1*SIZE_RL_OR_DBL
-                     allocate(id%COLSCA(size_array1), stat=allocok)
-                     if (allocok .GT. 0) THEN
-                        id%INFO(1) = -78
-                        CALL MUMPS_SETI8TOI4(
-     &                       TOTAL_STRUC_SIZE-size_allocated
-     &                       ,id%INFO(2))
-                     endif
-                     read(unit,iostat=err) id%COLSCA
-                  endif
-                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &                 id%COMM, id%MYID )
-                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
-                  if(err.ne.0) THEN
-                     id%INFO(1) = -75
-                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                    ,id%INFO(2))
-                  endif
-                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &                 id%COMM, id%MYID )
-                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               endif
+              CALL MUMPS_SAVERSTR_REALARRAY(id%COLSCA)
             ELSE
             ENDIF
-         CASE("ROWSCA")
+            IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_ROWSCA)
             IF(id%KEEP(52).NE.-1) THEN
-               NbRecords(i1)=2
-               if(trim(mode).EQ."memory_save") then
-                  IF(associated(id%ROWSCA)) THEN
-                     SIZE_GEST(i1)=SIZE_INT
-                     SIZE_VARIABLES(i1)=size(id%ROWSCA,1)*SIZE_RL_OR_DBL
-                  ELSE
-                     SIZE_GEST(i1)=SIZE_INT*2
-                     SIZE_VARIABLES(i1)=0_8
-                  ENDIF
-               elseif(trim(mode).EQ."save") then
-                  IF(associated(id%ROWSCA)) THEN
-                     write(unit,iostat=err) size(id%ROWSCA,1)
-                     if(err.ne.0) then
-                        id%INFO(1) = -72
-                        CALL MUMPS_SETI8TOI4(
-     &                       TOTAL_FILE_SIZE-size_written,
-     &                       id%INFO(2))
-                     endif
-                     write(unit,iostat=err) id%ROWSCA
-                  ELSE
-                     write(unit,iostat=err) -999
-                     if(err.ne.0) then
-                        id%INFO(1) = -72
-                        CALL MUMPS_SETI8TOI4(
-     &                       TOTAL_FILE_SIZE-size_written,
-     &                       id%INFO(2))
-                     endif
-                     write(unit,iostat=err) -999
-                  ENDIF 
-                  if(err.ne.0) then
-                     id%INFO(1) = -72
-                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-                  endif
-                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &                 id%COMM, id%MYID )
-                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
-                  nullify(id%ROWSCA)
-                  read(unit,iostat=err) size_array1
-                  if(err.ne.0) THEN
-                     id%INFO(1) = -75
-                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                    ,id%INFO(2))
-                  endif
-                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &                 id%COMM, id%MYID )
-                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
-                  if(size_array1.EQ.-999) then
-                     SIZE_GEST(i1)=SIZE_INT*2
-                     SIZE_VARIABLES(i1)=0_8
-                     read(unit,iostat=err) dummy
-                  else
-                     SIZE_GEST(i1)=SIZE_INT
-                     SIZE_VARIABLES(i1)=size_array1*SIZE_RL_OR_DBL
-                     allocate(id%ROWSCA(size_array1), stat=allocok)
-                     if (allocok .GT. 0) THEN
-                        id%INFO(1) = -78
-                        CALL MUMPS_SETI8TOI4(
-     &                       TOTAL_STRUC_SIZE-size_allocated
-     &                       ,id%INFO(2))
-                     endif
-                     read(unit,iostat=err) id%ROWSCA
-                  endif
-                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &                 id%COMM, id%MYID )
-                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
-                  if(err.ne.0) THEN
-                     id%INFO(1) = -75
-                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                    ,id%INFO(2))
-                  endif 
-                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &                 id%COMM, id%MYID )
-                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               endif
+              CALL MUMPS_SAVERSTR_REALARRAY(id%ROWSCA)
             ELSE
             ENDIF
-         CASE("NZ_loc")
+            IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_COLSCA_loc)
+            CALL MUMPS_SAVERSTR_REALARRAY(id%COLSCA_loc)
+            IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_ROWSCA_loc)
+            CALL MUMPS_SAVERSTR_REALARRAY(id%ROWSCA_loc)
+            IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NZ_loc)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%NZ_loc
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -2044,7 +1807,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT
                read(unit,iostat=err) id%NZ_loc
                if(err.ne.0) THEN
@@ -2056,11 +1819,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("NNZ_loc")
+         CASE(S_NNZ_loc)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%NNZ_loc
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -2070,7 +1833,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8
                read(unit,iostat=err) id%NNZ_loc
                if(err.ne.0) THEN
@@ -2082,215 +1845,67 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("IRN_loc")
-         CASE("JCN_loc")
-         CASE("A_loc")
-         CASE("NELT")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NELT
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NELT
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("NBLK")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NBLK
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NBLK
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("ELTPTR")
-         CASE("ELTVAR")
-         CASE("A_ELT")
-         CASE("PERM_IN")
-         CASE("BLKPTR")
-         CASE("BLKVAR")
-         CASE("RHS")
-         CASE("REDRHS")
-         CASE("RHS_SPARSE")
-         CASE("SOL_loc")
-         CASE("RHS_loc")
-         CASE("IRHS_SPARSE")
-         CASE("IRHS_PTR")
-         CASE("ISOL_loc")
-         CASE("IRHS_loc")
-         CASE("LRHS")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%LRHS
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%LRHS
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("NRHS")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NRHS
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NRHS
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("NZ_RHS")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NZ_RHS
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NZ_RHS
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("LRHS_loc")
-         CASE("Nloc_RHS")
-         CASE("LSOL_loc")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%LSOL_loc
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%LSOL_loc
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("LREDRHS")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%LREDRHS
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%LREDRHS
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("SYM_PERM")
+         CASE(S_IRN_loc)
+         CASE(S_JCN_loc)
+         CASE(S_A_loc)
+         CASE(S_NELT)
+           CALL MUMPS_SAVE_INT(id%NELT)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NBLK)
+           CALL MUMPS_SAVE_INT(id%NBLK)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_ELTPTR)
+         CASE(S_ELTVAR)
+         CASE(S_A_ELT)
+         CASE(S_PERM_IN)
+         CASE(S_BLKPTR)
+         CASE(S_BLKVAR)
+         CASE(S_COLIND)
+         CASE(S_PIVOTS)
+         CASE(S_RHS)
+         CASE(S_REDRHS)
+         CASE(S_ROWIND)
+         CASE(S_RHS_SPARSE)
+         CASE(S_SOL_loc)
+         CASE(S_RHS_loc)
+         CASE(S_IRHS_SPARSE)
+         CASE(S_IRHS_PTR)
+         CASE(S_ISOL_loc)
+         CASE(S_IRHS_loc)
+         CASE(S_LRHS)
+         CALL MUMPS_SAVE_INT(id%LRHS)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NRHS)
+         CALL MUMPS_SAVE_INT(id%NRHS)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NZ_RHS)
+         CALL MUMPS_SAVE_INT(id%NZ_RHS)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_LRHS_loc)
+         CALL MUMPS_SAVE_INT(id%LRHS_loc)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_Nloc_RHS)
+         CALL MUMPS_SAVE_INT(id%Nloc_RHS)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_LD_RHSINTR)
+         CALL MUMPS_SAVE_INT(id%LD_RHSINTR)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NSOL_loc)
+         CALL MUMPS_SAVE_INT(id%NSOL_loc)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_LSOL_loc)
+         CALL MUMPS_SAVE_INT(id%LSOL_loc)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_LREDRHS)
+         CALL MUMPS_SAVE_INT(id%LREDRHS)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_SYM_PERM)
             CALL CMUMPS_SAVE_INT_SHPTR_ARRAY(id%SYM_PERM
      &           ) 
             IF (id%INFO(1) .LT. 0 ) GOTO 100
-         CASE("UNS_PERM")
+         CASE(S_UNS_PERM)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%UNS_PERM)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%UNS_PERM,1)*SIZE_INT
@@ -2298,7 +1913,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%UNS_PERM)) THEN
                   write(unit,iostat=err) size(id%UNS_PERM,1)
                   if(err.ne.0) then
@@ -2330,7 +1945,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%UNS_PERM)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -2369,222 +1984,36 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("NPROW")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NPROW
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NPROW
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("NPCOL")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NPCOL
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               NbRecords(i1)=1
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NPCOL
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("MBLOCK")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%MBLOCK
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%MBLOCK
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("NBLOCK")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NBLOCK
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NBLOCK
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("SCHUR_MLOC")
-             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%SCHUR_MLOC
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%SCHUR_MLOC
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("SCHUR_NLOC")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%SCHUR_NLOC
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%SCHUR_NLOC
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("SCHUR_LLD")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%SCHUR_LLD
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%SCHUR_LLD
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("SIZE_SCHUR")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%SIZE_SCHUR
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               NbRecords(i1)=1
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%SIZE_SCHUR
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("SCHUR")
-         CASE("SCHUR_CINTERFACE")
-          CASE("LISTVAR_SCHUR")
-         CASE("MAPPING")
+         CASE(S_NPROW)
+         CALL MUMPS_SAVE_INT(id%NPROW)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NPCOL)
+         CALL MUMPS_SAVE_INT(id%NPCOL)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_MBLOCK)
+         CALL MUMPS_SAVE_INT(id%MBLOCK)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NBLOCK)
+         CALL MUMPS_SAVE_INT(id%NBLOCK)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_SCHUR_MLOC)
+         CALL MUMPS_SAVE_INT(id%SCHUR_MLOC)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_SCHUR_NLOC)
+         CALL MUMPS_SAVE_INT(id%SCHUR_NLOC)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_SCHUR_LLD)
+         CALL MUMPS_SAVE_INT(id%SCHUR_LLD)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_SIZE_SCHUR)
+         CALL MUMPS_SAVE_INT(id%SIZE_SCHUR)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_SCHUR)
+         CASE(S_SCHUR_CINTERFACE)
+          CASE(S_LISTVAR_SCHUR)
+         CASE(S_MAPPING)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%MAPPING)) THEN
                   SIZE_GEST(i1)=SIZE_INT8
                   SIZE_VARIABLES(i1)=id%KEEP8(28)*SIZE_INT
@@ -2592,7 +2021,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT8+SIZE_INT
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%MAPPING)) THEN
                   write(unit,iostat=err) id%KEEP8(28)
                   if(err.ne.0) then
@@ -2624,7 +2053,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%MAPPING)
                read(unit,iostat=err) size_array_INT8_1
                if(err.ne.0) THEN
@@ -2663,12 +2092,12 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("VERSION_NUMBER")
+         CASE(S_VERSION_NUMBER)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=len(id%VERSION_NUMBER)
      &              *SIZE_CHARACTER
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%VERSION_NUMBER
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -2678,7 +2107,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=len(id%VERSION_NUMBER)
      &              *SIZE_CHARACTER
                read(unit,iostat=err) id%VERSION_NUMBER
@@ -2691,12 +2120,12 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("OOC_TMPDIR")
+         CASE(S_OOC_TMPDIR)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=len(id%OOC_TMPDIR)
      &              *SIZE_CHARACTER
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%OOC_TMPDIR
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -2706,7 +2135,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=len(id%OOC_TMPDIR)
      &              *SIZE_CHARACTER
                read(unit,iostat=err) id%OOC_TMPDIR
@@ -2719,12 +2148,12 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("OOC_PREFIX")
+         CASE(S_OOC_PREFIX)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=len(id%OOC_PREFIX)
      &              *SIZE_CHARACTER
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%OOC_PREFIX
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -2735,7 +2164,7 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
                NbRecords(i1)=1
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=len(id%OOC_PREFIX)
      &              *SIZE_CHARACTER
                read(unit,iostat=err) id%OOC_PREFIX
@@ -2748,12 +2177,12 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("WRITE_PROBLEM")
+         CASE(S_WRITE_PROBLEM)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=len(id%WRITE_PROBLEM)
      &              *SIZE_CHARACTER
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%WRITE_PROBLEM
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -2763,7 +2192,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=len(id%WRITE_PROBLEM)
      &              *SIZE_CHARACTER
                read(unit,iostat=err) id%WRITE_PROBLEM
@@ -2776,11 +2205,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("MAX_SURF_MASTER")
+         CASE(S_MAX_SURF_MASTER)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%MAX_SURF_MASTER
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -2790,7 +2219,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8
                read(unit,iostat=err) id%MAX_SURF_MASTER
                if(err.ne.0) THEN
@@ -2802,181 +2231,43 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("INST_Number")
-               NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%INST_Number
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%INST_Number
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("COMM_NODES")
-            if(trim(mode).EQ."memory_save") then
+         CASE(S_INST_Number)
+           CALL MUMPS_SAVE_INT(id%INST_Number)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_COMM_NODES)
+            if(mode.EQ.memory_save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
             endif
-         CASE("MYID_NODES")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%MYID_NODES
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%MYID_NODES
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("COMM_LOAD")
-            if(trim(mode).EQ."memory_save") then
+         CASE(S_MYID_NODES)
+           CALL MUMPS_SAVE_INT(id%MYID_NODES)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_COMM_LOAD)
+            if(mode.EQ.memory_save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
             endif
-         CASE("MYID")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%MYID
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%MYID
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("NPROCS")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NPROCS
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NPROCS
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("NSLAVES")
-             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NSLAVES
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NSLAVES
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("ASS_IRECV")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%ASS_IRECV
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%ASS_IRECV
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif  
-         CASE("IS")
+         CASE(S_MYID)
+           CALL MUMPS_SAVE_INT(id%MYID)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NPROCS)
+           CALL MUMPS_SAVE_INT(id%NPROCS)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NSLAVES)
+           CALL MUMPS_SAVE_INT(id%NSLAVES)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_ASS_IRECV)
+           CALL MUMPS_SAVE_INT(id%ASS_IRECV)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_IS)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%IS)) THEN
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=id%KEEP(32)*SIZE_INT
@@ -2986,7 +2277,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*3
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%IS)) THEN
                   write(unit,iostat=err) size(id%IS,1),id%KEEP(32)
                   if(err.ne.0) then
@@ -3020,7 +2311,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%IS)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -3061,91 +2352,22 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("Deficiency")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%Deficiency
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%Deficiency
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("LNA")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%LNA
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%LNA
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("NBSA")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NBSA
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NBSA
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("STEP")
+         CASE(S_Deficiency)
+           CALL MUMPS_SAVE_INT(id%Deficiency)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_LNA)
+           CALL MUMPS_SAVE_INT(id%LNA)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NBSA)
+           CALL MUMPS_SAVE_INT(id%NBSA)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_STEP)
             CALL CMUMPS_SAVE_INT_SHPTR_ARRAY(id%STEP
      &           ) 
             IF (id%INFO(1) .LT. 0 ) GOTO 100
-         CASE("NE_STEPS")
+         CASE(S_NE_STEPS)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%NE_STEPS)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%NE_STEPS,1)*SIZE_INT
@@ -3153,7 +2375,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%NE_STEPS)) THEN
                   write(unit,iostat=err) size(id%NE_STEPS,1)
                   if(err.ne.0) then
@@ -3185,7 +2407,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%NE_STEPS)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3224,9 +2446,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("ND_STEPS")
+         CASE(S_ND_STEPS)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%ND_STEPS)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%ND_STEPS,1)*SIZE_INT
@@ -3234,7 +2456,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%ND_STEPS)) THEN
                   write(unit,iostat=err) size(id%ND_STEPS,1)
                   if(err.ne.0) then
@@ -3266,7 +2488,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%ND_STEPS)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3305,9 +2527,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("Step2node")
+         CASE(S_Step2node)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%Step2node)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%Step2node,1)*SIZE_INT
@@ -3315,7 +2537,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%Step2node)) THEN
                   write(unit,iostat=err) size(id%Step2node,1)
                   if(err.ne.0) then
@@ -3347,7 +2569,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%Step2node)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3386,9 +2608,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("FRERE_STEPS")
+         CASE(S_FRERE_STEPS)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%FRERE_STEPS)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%FRERE_STEPS,1)*SIZE_INT
@@ -3396,7 +2618,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%FRERE_STEPS)) THEN
                   write(unit,iostat=err) size(id%FRERE_STEPS,1)
                   if(err.ne.0) then
@@ -3428,7 +2650,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%FRERE_STEPS)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3467,9 +2689,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("DAD_STEPS")
+         CASE(S_DAD_STEPS)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%DAD_STEPS)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%DAD_STEPS,1)*SIZE_INT
@@ -3477,7 +2699,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%DAD_STEPS)) THEN
                   write(unit,iostat=err) size(id%DAD_STEPS,1)
                   if(err.ne.0) then
@@ -3509,7 +2731,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%DAD_STEPS)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3548,13 +2770,13 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("FILS")
+         CASE(S_FILS)
             CALL CMUMPS_SAVE_INT_SHPTR_ARRAY(id%FILS
      &           ) 
             IF ( id%INFO(1) .LT. 0 ) GOTO 100
-         CASE("PTR8ARR")
+         CASE(S_PTR8ARR)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%PTR8ARR)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%PTR8ARR,1)*SIZE_INT8
@@ -3562,7 +2784,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PTR8ARR)) THEN
                   write(unit,iostat=err) size(id%PTR8ARR,1)
                   if(err.ne.0) then
@@ -3595,7 +2817,7 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
                NbRecords(i1)=2
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PTR8ARR)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3634,9 +2856,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("NINCOLARR")
+         CASE(S_NINCOLARR)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                NbRecords(i1)=2
                IF(associated(id%NINCOLARR)) THEN
                   SIZE_GEST(i1)=SIZE_INT
@@ -3645,7 +2867,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%NINCOLARR)) THEN
                   write(unit,iostat=err) size(id%NINCOLARR,1)
                   if(err.ne.0) then
@@ -3677,7 +2899,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%NINCOLARR)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3716,9 +2938,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("NINROWARR")
+         CASE(S_NINROWARR)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                NbRecords(i1)=2
                IF(associated(id%NINROWARR)) THEN
                   SIZE_GEST(i1)=SIZE_INT
@@ -3727,7 +2949,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%NINROWARR)) THEN
                   write(unit,iostat=err) size(id%NINROWARR,1)
                   if(err.ne.0) then
@@ -3759,7 +2981,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%NINROWARR)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3798,9 +3020,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PTRDEBARR")
+         CASE(S_PTRDEBARR)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                NbRecords(i1)=2
                IF(associated(id%PTRDEBARR)) THEN
                   SIZE_GEST(i1)=SIZE_INT
@@ -3809,7 +3031,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PTRDEBARR)) THEN
                   write(unit,iostat=err) size(id%PTRDEBARR,1)
                   if(err.ne.0) then
@@ -3841,7 +3063,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PTRDEBARR)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3880,9 +3102,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PTRAR")
+         CASE(S_PTRAR)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%PTRAR)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%PTRAR,1)*SIZE_INT8
@@ -3890,7 +3112,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PTRAR)) THEN
                   write(unit,iostat=err) size(id%PTRAR,1)
                   if(err.ne.0) then
@@ -3923,7 +3145,7 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
                NbRecords(i1)=2
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PTRAR)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3962,9 +3184,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("FRTPTR")
+         CASE(S_FRTPTR)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%FRTPTR)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%FRTPTR,1)*SIZE_INT
@@ -3972,7 +3194,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%FRTPTR)) THEN
                   write(unit,iostat=err) size(id%FRTPTR,1)
                   if(err.ne.0) then
@@ -4004,7 +3226,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%FRTPTR)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -4042,9 +3264,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("FRTELT")
+         CASE(S_FRTELT)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%FRTELT)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%FRTELT,1)*SIZE_INT
@@ -4052,7 +3274,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%FRTELT)) THEN
                   write(unit,iostat=err) size(id%FRTELT,1)
                   if(err.ne.0) then
@@ -4078,7 +3300,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%FRTELT)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -4117,9 +3339,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("NA")
+         CASE(S_NA)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%NA)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%NA,1)*SIZE_INT
@@ -4127,7 +3349,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%NA)) THEN
                   write(unit,iostat=err) size(id%NA,1)
                   if(err.ne.0) then
@@ -4153,7 +3375,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%NA)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -4192,9 +3414,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PROCNODE_STEPS")
+         CASE(S_PROCNODE_STEPS)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                NbRecords(i1)=2
                IF(associated(id%PROCNODE_STEPS)) THEN
                   SIZE_GEST(i1)=SIZE_INT
@@ -4203,7 +3425,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PROCNODE_STEPS)) THEN
                   write(unit,iostat=err) size(id%PROCNODE_STEPS,1)
                   if(err.ne.0) then
@@ -4235,7 +3457,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PROCNODE_STEPS)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -4274,9 +3496,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PTLUST_S")
+         CASE(S_PTLUST_S)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%PTLUST_S)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%PTLUST_S,1)*SIZE_INT
@@ -4284,7 +3506,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PTLUST_S)) THEN
                   write(unit,iostat=err) size(id%PTLUST_S,1)
                   if(err.ne.0) then
@@ -4316,7 +3538,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PTLUST_S)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -4355,9 +3577,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PTRFAC")
+         CASE(S_PTRFAC)
             NbRecords(i1)=2  
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%PTRFAC)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%PTRFAC,1)*SIZE_INT8
@@ -4365,7 +3587,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PTRFAC)) THEN
                   write(unit,iostat=err) size(id%PTRFAC,1)
                   if(err.ne.0) then
@@ -4396,7 +3618,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PTRFAC)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -4435,9 +3657,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("S")
+         CASE(S_S)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%S)) THEN
                   SIZE_GEST(i1)=SIZE_INT8*2
                   SIZE_VARIABLES(i1)=id%KEEP8(31)*SIZE_ARITH_DEP
@@ -4447,7 +3669,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT8*2+SIZE_INT
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%S)) THEN
                   write(unit,iostat=err) id%KEEP8(23),id%KEEP8(31)
                   if(err.ne.0) then
@@ -4482,7 +3704,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%S)
                read(unit,iostat=err) size_array_INT8_1,size_array_INT8_2
                if(err.ne.0) THEN
@@ -4524,62 +3746,16 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PROCNODE")
-         CASE("NELT_loc")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NELT_loc
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NELT_loc
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("LELTVAR")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%LELTVAR
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%LELTVAR
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("ELTPROC")
+         CASE(S_PROCNODE)
+         CASE(S_NELT_loc)
+           CALL MUMPS_SAVE_INT(id%NELT_loc)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_LELTVAR)
+           CALL MUMPS_SAVE_INT(id%LELTVAR)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_ELTPROC)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%ELTPROC)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%ELTPROC,1)*SIZE_INT
@@ -4587,7 +3763,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%ELTPROC)) THEN
                   write(unit,iostat=err) size(id%ELTPROC,1)
                   if(err.ne.0) then
@@ -4619,7 +3795,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%ELTPROC)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -4658,9 +3834,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("I4_L0_OMP")
+         CASE(S_I4_L0_OMP)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%I4_L0_OMP)) THEN
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=size(id%I4_L0_OMP,1)
@@ -4669,7 +3845,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*3
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%I4_L0_OMP)) THEN
                   write(unit,iostat=err) size(id%I4_L0_OMP,1)
      &                 ,size(id%I4_L0_OMP,2)
@@ -4702,7 +3878,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%I4_L0_OMP)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -4742,9 +3918,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("I8_L0_OMP")
+         CASE(S_I8_L0_OMP)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%I8_L0_OMP)) THEN
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=size(id%I8_L0_OMP,1)
@@ -4753,7 +3929,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*3
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%I8_L0_OMP)) THEN
                   write(unit,iostat=err) size(id%I8_L0_OMP,1)
      &                 ,size(id%I8_L0_OMP,2)
@@ -4786,7 +3962,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%I8_L0_OMP)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -4826,9 +4002,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("CANDIDATES")
+         CASE(S_CANDIDATES)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%CANDIDATES)) THEN
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=size(id%CANDIDATES,1)
@@ -4837,7 +4013,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*3
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%CANDIDATES)) THEN
                   write(unit,iostat=err) size(id%CANDIDATES,1)
      &                 ,size(id%CANDIDATES,2)
@@ -4870,7 +4046,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%CANDIDATES)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -4910,9 +4086,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("ISTEP_TO_INIV2")
+         CASE(S_ISTEP_TO_INIV2)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%ISTEP_TO_INIV2)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%ISTEP_TO_INIV2,1)*SIZE_INT
@@ -4920,7 +4096,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%ISTEP_TO_INIV2)) THEN
                   write(unit,iostat=err) size(id%ISTEP_TO_INIV2,1)
                   if(err.ne.0) then
@@ -4952,7 +4128,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%ISTEP_TO_INIV2)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -4991,9 +4167,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("FUTURE_NIV2")
+         CASE(S_FUTURE_NIV2)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%FUTURE_NIV2)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%FUTURE_NIV2,1)*SIZE_INT
@@ -5001,7 +4177,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%FUTURE_NIV2)) THEN
                   write(unit,iostat=err) size(id%FUTURE_NIV2,1)
                   if(err.ne.0) then
@@ -5033,7 +4209,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%FUTURE_NIV2)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -5072,9 +4248,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("TAB_POS_IN_PERE")
+         CASE(S_TAB_POS_IN_PERE)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%TAB_POS_IN_PERE)) THEN
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=size(id%TAB_POS_IN_PERE,1)
@@ -5083,7 +4259,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*3
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%TAB_POS_IN_PERE)) THEN
                   write(unit,iostat=err) size(id%TAB_POS_IN_PERE,1)
      &                 ,size(id%TAB_POS_IN_PERE,2)
@@ -5116,7 +4292,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%TAB_POS_IN_PERE)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -5156,9 +4332,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("I_AM_CAND")
+         CASE(S_I_AM_CAND)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%I_AM_CAND)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%I_AM_CAND,1)*SIZE_LOGICAL
@@ -5166,7 +4342,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%I_AM_CAND)) THEN
                   write(unit,iostat=err) size(id%I_AM_CAND,1)
                   if(err.ne.0) then
@@ -5198,7 +4374,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%I_AM_CAND)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -5237,9 +4413,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("MEM_DIST")
+         CASE(S_MEM_DIST)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%MEM_DIST)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%MEM_DIST,1)*SIZE_INT
@@ -5247,7 +4423,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%MEM_DIST)) THEN
                   write(unit,iostat=err) size(id%MEM_DIST,1)
                   if(err.ne.0) then
@@ -5277,7 +4453,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%MEM_DIST)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -5316,20 +4492,20 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("POSINRHSCOMP_ROW")
+         CASE(S_GLOB2LOC_RHS)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
-               IF(associated(id%POSINRHSCOMP_ROW)) THEN
+            if(mode.EQ.memory_save_mode) then
+               IF(associated(id%GLOB2LOC_RHS)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
-     &                 size(id%POSINRHSCOMP_ROW,1)*SIZE_INT
+     &                 size(id%GLOB2LOC_RHS,1)*SIZE_INT
                ELSE
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
-               IF(associated(id%POSINRHSCOMP_ROW)) THEN
-                  write(unit,iostat=err) size(id%POSINRHSCOMP_ROW,1)
+            elseif(mode.EQ.save_mode) then
+               IF(associated(id%GLOB2LOC_RHS)) THEN
+                  write(unit,iostat=err) size(id%GLOB2LOC_RHS,1)
                   if(err.ne.0) then
                      id%INFO(1) = -72
                      CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
@@ -5338,7 +4514,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-                  write(unit,iostat=err) id%POSINRHSCOMP_ROW
+                  write(unit,iostat=err) id%GLOB2LOC_RHS
                ELSE
                   write(unit,iostat=err) -999
                   if(err.ne.0) then
@@ -5359,8 +4535,8 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               nullify(id%POSINRHSCOMP_ROW)
+            elseif(mode.EQ.restore_mode) then
+               nullify(id%GLOB2LOC_RHS)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
                   id%INFO(1) = -75
@@ -5377,7 +4553,7 @@ C
                else
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size_array1*SIZE_INT
-                  allocate(id%POSINRHSCOMP_ROW(size_array1), 
+                  allocate(id%GLOB2LOC_RHS(size_array1), 
      &                 stat=allocok)
                   if (allocok .GT. 0) THEN
                      id%INFO(1) = -78
@@ -5385,7 +4561,7 @@ C
      &                    TOTAL_STRUC_SIZE-size_allocated
      &                    ,id%INFO(2))
                   endif
-                  read(unit,iostat=err) id%POSINRHSCOMP_ROW
+                  read(unit,iostat=err) id%GLOB2LOC_RHS
                endif
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
@@ -5399,12 +4575,12 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("POSINRHSCOMP_COL_ALLOC")
+         CASE(S_GLOB2LOC_SOL_ALLOC)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_LOGICAL
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%POSINRHSCOMP_COL_ALLOC
+            elseif(mode.EQ.save_mode) then
+               write(unit,iostat=err) id%GLOB2LOC_SOL_ALLOC
                if(err.ne.0) then
                   id%INFO(1) = -72
                   CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
@@ -5413,9 +4589,9 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_LOGICAL
-               read(unit,iostat=err) id%POSINRHSCOMP_COL_ALLOC
+               read(unit,iostat=err) id%GLOB2LOC_SOL_ALLOC
                if(err.ne.0) THEN
                   id%INFO(1) = -75
                   CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
@@ -5425,14 +4601,14 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("POSINRHSCOMP_COL")
+         CASE(S_GLOB2LOC_SOL)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
-               IF(associated(id%POSINRHSCOMP_COL)) THEN
-                  IF(id%POSINRHSCOMP_COL_ALLOC) THEN
+            if(mode.EQ.memory_save_mode) then
+               IF(associated(id%GLOB2LOC_SOL)) THEN
+                  IF(id%GLOB2LOC_SOL_ALLOC) THEN
                      SIZE_GEST(i1)=SIZE_INT
                      SIZE_VARIABLES(i1)=
-     &                    size(id%POSINRHSCOMP_COL,1)*SIZE_INT
+     &                    size(id%GLOB2LOC_SOL,1)*SIZE_INT
                   ELSE
                      SIZE_GEST(i1)=SIZE_INT*2
                      SIZE_VARIABLES(i1)=0_8
@@ -5441,10 +4617,10 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
-               IF(associated(id%POSINRHSCOMP_COL)) THEN
-                  IF(id%POSINRHSCOMP_COL_ALLOC) THEN
-                     write(unit,iostat=err) size(id%POSINRHSCOMP_COL,1)
+            elseif(mode.EQ.save_mode) then
+               IF(associated(id%GLOB2LOC_SOL)) THEN
+                  IF(id%GLOB2LOC_SOL_ALLOC) THEN
+                     write(unit,iostat=err) size(id%GLOB2LOC_SOL,1)
                      if(err.ne.0) then
                         id%INFO(1) = -72
                         CALL MUMPS_SETI8TOI4(
@@ -5454,9 +4630,9 @@ C
                      CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                    id%COMM, id%MYID )
                      IF ( id%INFO(1) .LT. 0 ) GOTO 100
-                     write(unit,iostat=err) id%POSINRHSCOMP_COL
+                     write(unit,iostat=err) id%GLOB2LOC_SOL
                   ELSE
-                     write(unit,iostat=err) size(id%POSINRHSCOMP_COL,1)
+                     write(unit,iostat=err) size(id%GLOB2LOC_SOL,1)
                      if(err.ne.0) then
                         id%INFO(1) = -72
                         CALL MUMPS_SETI8TOI4(
@@ -5488,8 +4664,8 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               nullify(id%POSINRHSCOMP_COL)
+            elseif(mode.EQ.restore_mode) then
+               nullify(id%GLOB2LOC_SOL)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
                   id%INFO(1) = -75
@@ -5504,10 +4680,10 @@ C
                   SIZE_VARIABLES(i1)=0_8
                   read(unit,iostat=err) dummy
                else
-                  if(id%POSINRHSCOMP_COL_ALLOC) then
+                  if(id%GLOB2LOC_SOL_ALLOC) then
                      SIZE_GEST(i1)=SIZE_INT
                      SIZE_VARIABLES(i1)=size_array1*SIZE_INT
-                     allocate(id%POSINRHSCOMP_COL(size_array1), 
+                     allocate(id%GLOB2LOC_SOL(size_array1), 
      &                    stat=allocok)
                      if (allocok .GT. 0) THEN
                         id%INFO(1) = -78
@@ -5515,12 +4691,12 @@ C
      &                       TOTAL_STRUC_SIZE-size_allocated
      &                       ,id%INFO(2))
                      endif
-                     read(unit,iostat=err) id%POSINRHSCOMP_COL
+                     read(unit,iostat=err) id%GLOB2LOC_SOL
                   else
                      SIZE_GEST(i1)=SIZE_INT*2
                      SIZE_VARIABLES(i1)=0_8
                      read(unit,iostat=err) dummy
-                     id%POSINRHSCOMP_COL=>id%POSINRHSCOMP_ROW
+                     id%GLOB2LOC_SOL=>id%GLOB2LOC_RHS
                   endif
                endif
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
@@ -5535,18 +4711,18 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("RHSCOMP")
+         CASE(S_RHSINTR)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
-               IF(associated(id%RHSCOMP)) THEN
+            if(mode.EQ.memory_save_mode) then
+               IF(associated(id%RHSINTR)) THEN
                   SIZE_GEST(i1)=SIZE_INT8
                   SIZE_VARIABLES(i1)=id%KEEP8(25)*SIZE_ARITH_DEP
                ELSE
                   SIZE_GEST(i1)=SIZE_INT8+SIZE_INT
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
-               IF(associated(id%RHSCOMP)) THEN
+            elseif(mode.EQ.save_mode) then
+               IF(associated(id%RHSINTR)) THEN
                   write(unit,iostat=err) id%KEEP8(25)
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -5556,7 +4732,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-                  write(unit,iostat=err) id%RHSCOMP
+                  write(unit,iostat=err) id%RHSINTR
                ELSE
                   write(unit,iostat=err) int(-999,8)
                   if(err.ne.0) then
@@ -5577,8 +4753,8 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               nullify(id%RHSCOMP)
+            elseif(mode.EQ.restore_mode) then
+               nullify(id%RHSINTR)
                read(unit,iostat=err) size_array_INT8_1
                if(err.ne.0) THEN
                   id%INFO(1) = -75
@@ -5595,14 +4771,14 @@ C
                else
                   SIZE_GEST(i1)=SIZE_INT8
                   SIZE_VARIABLES(i1)=size_array_INT8_1*SIZE_ARITH_DEP
-                  allocate(id%RHSCOMP(size_array_INT8_1), stat=allocok)
+                  allocate(id%RHSINTR(size_array_INT8_1), stat=allocok)
                   if (allocok .GT. 0) THEN
                      id%INFO(1) = -78
                      CALL MUMPS_SETI8TOI4(
      &                    TOTAL_STRUC_SIZE-size_allocated
      &                    ,id%INFO(2))
                   endif
-                  read(unit,iostat=err) id%RHSCOMP
+                  read(unit,iostat=err) id%RHSINTR
                endif
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
@@ -5616,9 +4792,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("MEM_SUBTREE")
+         CASE(S_MEM_SUBTREE)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%MEM_SUBTREE)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
@@ -5627,7 +4803,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%MEM_SUBTREE)) THEN
                   write(unit,iostat=err) size(id%MEM_SUBTREE,1)
                   if(err.ne.0) then
@@ -5659,7 +4835,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%MEM_SUBTREE)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -5698,9 +4874,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("COST_TRAV")
+         CASE(S_COST_TRAV)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%COST_TRAV)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
@@ -5709,7 +4885,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%COST_TRAV)) THEN
                   write(unit,iostat=err) size(id%COST_TRAV,1)
                   if(err.ne.0) then
@@ -5741,7 +4917,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%COST_TRAV)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -5780,9 +4956,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("MY_ROOT_SBTR")
+         CASE(S_MY_ROOT_SBTR)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%MY_ROOT_SBTR)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%MY_ROOT_SBTR,1)*SIZE_INT
@@ -5790,7 +4966,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%MY_ROOT_SBTR)) THEN
                   write(unit,iostat=err) size(id%MY_ROOT_SBTR,1)
                   if(err.ne.0) then
@@ -5822,7 +4998,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%MY_ROOT_SBTR)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -5861,9 +5037,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("MY_FIRST_LEAF")
+         CASE(S_MY_FIRST_LEAF)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%MY_FIRST_LEAF)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%MY_FIRST_LEAF,1)*SIZE_INT
@@ -5871,7 +5047,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%MY_FIRST_LEAF)) THEN
                   write(unit,iostat=err) size(id%MY_FIRST_LEAF,1)
                   if(err.ne.0) then
@@ -5903,7 +5079,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%MY_FIRST_LEAF)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -5942,9 +5118,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("MY_NB_LEAF")
+         CASE(S_MY_NB_LEAF)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%MY_NB_LEAF)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%MY_NB_LEAF,1)*SIZE_INT
@@ -5952,7 +5128,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%MY_NB_LEAF)) THEN
                   write(unit,iostat=err) size(id%MY_NB_LEAF,1)
                   if(err.ne.0) then
@@ -5984,7 +5160,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%MY_NB_LEAF)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -6023,9 +5199,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("DEPTH_FIRST")
+         CASE(S_DEPTH_FIRST)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%DEPTH_FIRST)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%DEPTH_FIRST,1)*SIZE_INT
@@ -6033,7 +5209,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%DEPTH_FIRST)) THEN
                   write(unit,iostat=err) size(id%DEPTH_FIRST,1)
                   if(err.ne.0) then
@@ -6065,7 +5241,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%DEPTH_FIRST)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -6104,9 +5280,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("DEPTH_FIRST_SEQ")
+         CASE(S_DEPTH_FIRST_SEQ)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%DEPTH_FIRST_SEQ)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%DEPTH_FIRST_SEQ,1)*SIZE_INT
@@ -6114,7 +5290,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%DEPTH_FIRST_SEQ)) THEN
                   write(unit,iostat=err) size(id%DEPTH_FIRST_SEQ,1)
                   if(err.ne.0) then
@@ -6146,7 +5322,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%DEPTH_FIRST_SEQ)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -6186,9 +5362,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("SBTR_ID")
+         CASE(S_SBTR_ID)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%SBTR_ID)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%SBTR_ID,1)*SIZE_INT
@@ -6196,7 +5372,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%SBTR_ID)) THEN
                   write(unit,iostat=err) size(id%SBTR_ID,1)
                   if(err.ne.0) then
@@ -6228,7 +5404,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%SBTR_ID)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -6267,100 +5443,31 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("SCHED_DEP")
-         CASE("SCHED_GRP")
-         CASE("CROIX_MANU")
-         CASE("WK_USER")
-         CASE("NBSA_LOCAL")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NBSA_LOCAL
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NBSA_LOCAL
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("LWK_USER")
-            if(trim(mode).EQ."memory_save") then
+         CASE(S_SCHED_DEP)
+         CASE(S_SCHED_GRP)
+         CASE(S_CROIX_MANU)
+         CASE(S_WK_USER)
+         CASE(S_NBSA_LOCAL)
+           CALL MUMPS_SAVE_INT(id%NBSA_LOCAL)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_LWK_USER)
+            if(mode.EQ.memory_save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
             endif
-         CASE("CB_SON_SIZE")
-         CASE("INSTANCE_NUMBER")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%INSTANCE_NUMBER
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%INSTANCE_NUMBER
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("OOC_MAX_NB_NODES_FOR_ZONE")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%OOC_MAX_NB_NODES_FOR_ZONE
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%OOC_MAX_NB_NODES_FOR_ZONE
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("OOC_INODE_SEQUENCE")
+         CASE(S_CB_SON_SIZE)
+         CASE(S_INSTANCE_NUMBER)
+           CALL MUMPS_SAVE_INT(id%INSTANCE_NUMBER)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_OOC_MAX_NB_NODES_FOR_ZONE)
+           CALL MUMPS_SAVE_INT(id%OOC_MAX_NB_NODES_FOR_ZONE)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_OOC_INODE_SEQUENCE)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%OOC_INODE_SEQUENCE)) THEN
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=size(id%OOC_INODE_SEQUENCE,1)
@@ -6369,7 +5476,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*3
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%OOC_INODE_SEQUENCE)) THEN
                   write(unit,iostat=err) size(id%OOC_INODE_SEQUENCE,1)
      &                 ,size(id%OOC_INODE_SEQUENCE,2)
@@ -6402,7 +5509,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%OOC_INODE_SEQUENCE)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -6442,9 +5549,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("OOC_SIZE_OF_BLOCK")
+         CASE(S_OOC_SIZE_OF_BLOCK)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%OOC_SIZE_OF_BLOCK)) THEN
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=size(id%OOC_SIZE_OF_BLOCK,1)
@@ -6453,7 +5560,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*3
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%OOC_SIZE_OF_BLOCK)) THEN
                   write(unit,iostat=err) size(id%OOC_SIZE_OF_BLOCK,1)
      &                 ,size(id%OOC_SIZE_OF_BLOCK,2)
@@ -6486,7 +5593,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%OOC_SIZE_OF_BLOCK)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -6526,9 +5633,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("OOC_VADDR")
+         CASE(S_OOC_VADDR)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%OOC_VADDR)) THEN
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=size(id%OOC_VADDR,1)
@@ -6537,7 +5644,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*3
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%OOC_VADDR)) THEN
                   write(unit,iostat=err) size(id%OOC_VADDR,1)
      &                 ,size(id%OOC_VADDR,2)
@@ -6570,7 +5677,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%OOC_VADDR)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -6610,9 +5717,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("OOC_TOTAL_NB_NODES")
+         CASE(S_OOC_TOTAL_NB_NODES)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%OOC_TOTAL_NB_NODES)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
@@ -6621,7 +5728,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%OOC_TOTAL_NB_NODES)) THEN
                   write(unit,iostat=err) size(id%OOC_TOTAL_NB_NODES,1)
                   if(err.ne.0) then
@@ -6653,7 +5760,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%OOC_TOTAL_NB_NODES)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -6693,13 +5800,13 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("OOC_NB_FILES")
-         CASE("OOC_NB_FILE_TYPE")
-         CASE("OOC_FILE_NAMES")
-         CASE("OOC_FILE_NAME_LENGTH")
-         CASE("PIVNUL_LIST")
+         CASE(S_OOC_NB_FILES)
+         CASE(S_OOC_NB_FILE_TYPE)
+         CASE(S_OOC_FILE_NAMES)
+         CASE(S_OOC_FILE_NAME_LENGTH)
+         CASE(S_PIVNUL_LIST)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%PIVNUL_LIST)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%PIVNUL_LIST,1)*SIZE_INT
@@ -6707,7 +5814,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PIVNUL_LIST)) THEN
                   write(unit,iostat=err) size(id%PIVNUL_LIST,1)
                   if(err.ne.0) then
@@ -6739,7 +5846,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PIVNUL_LIST)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -6778,10 +5885,10 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("SUP_PROC")
-         CASE("IPTR_WORKING")
+         CASE(S_SUP_PROC)
+         CASE(S_IPTR_WORKING)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%IPTR_WORKING)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%IPTR_WORKING,1)*SIZE_INT
@@ -6789,7 +5896,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%IPTR_WORKING)) THEN
                   write(unit,iostat=err) size(id%IPTR_WORKING,1)
                   if(err.ne.0) then
@@ -6821,7 +5928,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%IPTR_WORKING)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -6860,9 +5967,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("WORKING")
+         CASE(S_WORKING)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%WORKING)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%WORKING,1)*SIZE_INT
@@ -6870,7 +5977,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%WORKING)) THEN
                   write(unit,iostat=err) size(id%WORKING,1)
                   if(err.ne.0) then
@@ -6902,7 +6009,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%WORKING)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -6941,15 +6048,14 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("root")
+         CASE(S_root)
             DO i2=1,NBVARIABLES_ROOT
-            TMP_STRING2 = VARIABLES_ROOT(i2)
-            SELECT CASE(TMP_STRING2)
-            CASE("MBLOCK")
+            SELECT CASE(i2)
+            CASE(R_MBLOCK)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%MBLOCK
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -6959,7 +6065,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%MBLOCK
                   if(err.ne.0) THEN
@@ -6971,11 +6077,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("NBLOCK")
+            CASE(R_NBLOCK)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%NBLOCK
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -6985,7 +6091,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100        
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%NBLOCK
                   if(err.ne.0) THEN
@@ -6997,11 +6103,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-            CASE("NPROW")
+            CASE(R_NPROW)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%NPROW
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7011,7 +6117,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100                 
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%NPROW
                   if(err.ne.0) THEN
@@ -7023,11 +6129,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("NPCOL")
+            CASE(R_NPCOL)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%NPCOL
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7037,7 +6143,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100                
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%NPCOL
                   if(err.ne.0) THEN
@@ -7049,12 +6155,12 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("MYROW")
+            CASE(R_MYROW)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   NbRecords_ROOT(i2)=1
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%MYROW
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7064,7 +6170,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%MYROW
                   if(err.ne.0) THEN
@@ -7076,11 +6182,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("MYCOL")
+            CASE(R_MYCOL)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%MYCOL
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7090,7 +6196,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%MYCOL
                   if(err.ne.0) THEN
@@ -7102,11 +6208,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("SCHUR_MLOC")
+            CASE(R_SCHUR_MLOC)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%SCHUR_MLOC
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7116,7 +6222,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%SCHUR_MLOC
                   if(err.ne.0) THEN
@@ -7128,11 +6234,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("SCHUR_NLOC")
+            CASE(R_SCHUR_NLOC)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%SCHUR_NLOC
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7142,7 +6248,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%SCHUR_NLOC
                   if(err.ne.0) THEN
@@ -7154,11 +6260,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("SCHUR_LLD")
+            CASE(R_SCHUR_LLD)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%SCHUR_LLD
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7168,7 +6274,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%SCHUR_LLD
                   if(err.ne.0) THEN
@@ -7180,11 +6286,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("RHS_NLOC")
+            CASE(R_RHS_NLOC)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%RHS_NLOC
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7194,7 +6300,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%RHS_NLOC
                   if(err.ne.0) THEN
@@ -7206,11 +6312,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("ROOT_SIZE")
+            CASE(R_ROOT_SIZE)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%ROOT_SIZE
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7220,7 +6326,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%ROOT_SIZE
                   if(err.ne.0) THEN
@@ -7232,11 +6338,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("TOT_ROOT_SIZE")
+            CASE(R_TOT_ROOT_SIZE)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%TOT_ROOT_SIZE
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7246,7 +6352,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%TOT_ROOT_SIZE
                   if(err.ne.0) THEN
@@ -7258,12 +6364,12 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("DESCRIPTOR")
+            CASE(R_DESCRIPTOR)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=size(id%root%DESCRIPTOR,1)
      &                 *SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%DESCRIPTOR
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7273,7 +6379,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT*
      &                 size(id%root%DESCRIPTOR,1)
                   read(unit,iostat=err) id%root%DESCRIPTOR
@@ -7286,11 +6392,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("CNTXT_BLACS")
+            CASE(R_CNTXT_BLACS)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%CNTXT_BLACS
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7300,7 +6406,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%CNTXT_BLACS
                   if(err.ne.0) THEN
@@ -7312,11 +6418,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("LPIV")
+            CASE(R_LPIV)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%LPIV
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7326,7 +6432,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%LPIV
                   if(err.ne.0) THEN
@@ -7338,10 +6444,10 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("RG2L")
-            CASE("IPIV")
+            CASE(R_RG2L)
+            CASE(R_IPIV)
                NbRecords_ROOT(i2)=2
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   IF(associated(id%root%IPIV)) THEN
                      SIZE_GEST_ROOT(i2)=SIZE_INT
                      SIZE_VARIABLES_ROOT(i2)=
@@ -7350,7 +6456,7 @@ C
                      SIZE_GEST_ROOT(i2)=SIZE_INT*2
                      SIZE_VARIABLES_ROOT(i2)=0_8
                   ENDIF
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   IF(associated(id%root%IPIV)) THEN
                      write(unit,iostat=err) size(id%root%IPIV,1)
                      if(err.ne.0) then
@@ -7384,7 +6490,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   nullify(id%root%IPIV)
                   read(unit,iostat=err) size_array1
                   if(err.ne.0) THEN
@@ -7423,9 +6529,9 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("RHS_CNTR_MASTER_ROOT")
+            CASE(R_RHS_CNTR_MASTER_ROOT)
                NbRecords_ROOT(i2)=2
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   IF(associated(id%root%RHS_CNTR_MASTER_ROOT)) THEN
                      SIZE_GEST_ROOT(i2)=SIZE_INT
                      SIZE_VARIABLES_ROOT(i2)=
@@ -7435,7 +6541,7 @@ C
                      SIZE_GEST_ROOT(i2)=SIZE_INT*2
                      SIZE_VARIABLES_ROOT(i2)=0_8
                   ENDIF
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   IF(associated(id%root%RHS_CNTR_MASTER_ROOT)) THEN
                      write(unit,iostat=err) 
      &                    size(id%root%RHS_CNTR_MASTER_ROOT,1)
@@ -7470,7 +6576,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   nullify(id%root%RHS_CNTR_MASTER_ROOT)
                   read(unit,iostat=err) size_array1
                   if(err.ne.0) THEN
@@ -7510,11 +6616,94 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("SCHUR_POINTER")
-            CASE("QR_TAU")
-            CASE("RHS_ROOT")
+            CASE(R_SCHUR_POINTER)
+            CASE(R_QR_TAU)
                NbRecords_ROOT(i2)=2
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
+                  IF(associated(id%root%QR_TAU)) THEN
+                     SIZE_GEST_ROOT(i2)=SIZE_INT
+                     SIZE_VARIABLES_ROOT(i2)=
+     &                    size(id%root%QR_TAU,1)*SIZE_ARITH_DEP
+                  ELSE
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*2
+                     SIZE_VARIABLES_ROOT(i2)=0_8
+                  ENDIF
+               elseif(mode.EQ.save_mode) then
+                  IF(associated(id%root%QR_TAU)) THEN
+                     write(unit,iostat=err) size(id%root%QR_TAU,1)
+                     if(err.ne.0) then
+                        id%INFO(1) = -72
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_FILE_SIZE-size_written
+     &                       ,id%INFO(2))
+                     endif
+                     CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                    id%COMM, id%MYID )
+                     IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                     write(unit,iostat=err) id%root%QR_TAU
+                  ELSE
+                     write(unit,iostat=err) -999
+                     if(err.ne.0) then
+                        id%INFO(1) = -72
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_FILE_SIZE-size_written
+     &                       ,id%INFO(2))
+                     endif
+                     CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                    id%COMM, id%MYID )
+                     IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                     write(unit,iostat=err) -999
+                  ENDIF 
+                  if(err.ne.0) then
+                     id%INFO(1) = -72
+                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written
+     &                    ,id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               elseif(mode.EQ.restore_mode) then
+                  nullify(id%root%QR_TAU)
+                  read(unit,iostat=err) size_array1
+                  if(err.ne.0) THEN
+                     id%INFO(1) = -75
+                     CALL MUMPS_SETI8TOI4(SIZE_VARIABLES_ROOT(i2),
+     &                    id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                  if(size_array1.EQ.-999) then
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*2
+                     SIZE_VARIABLES_ROOT(i2)=0_8
+                     read(unit,iostat=err) dummy
+                  else
+                     SIZE_GEST_ROOT(i2)=SIZE_INT
+                     SIZE_VARIABLES_ROOT(i2)=size_array1*SIZE_ARITH_DEP
+                     allocate(id%root%QR_TAU(size_array1), stat=allocok)
+                     if (allocok .GT. 0) THEN
+                        id%INFO(1) = -78
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_STRUC_SIZE-size_allocated
+     &                       ,id%INFO(2))
+                     endif
+                     read(unit,iostat=err) id%root%QR_TAU
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                  if(err.ne.0) THEN
+                     id%INFO(1) = -75
+                     CALL MUMPS_SETI8TOI4(SIZE_VARIABLES_ROOT(i2),
+     &                    id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               endif
+            CASE(R_RHS_ROOT)
+               NbRecords_ROOT(i2)=2
+               if(mode.EQ.memory_save_mode) then
                   IF(associated(id%root%RHS_ROOT)) THEN
                      SIZE_GEST_ROOT(i2)=SIZE_INT*2
                      SIZE_VARIABLES_ROOT(i2)=size(id%root%RHS_ROOT,1)
@@ -7523,7 +6712,7 @@ C
                      SIZE_GEST_ROOT(i2)=SIZE_INT*3
                      SIZE_VARIABLES_ROOT(i2)=0_8
                   ENDIF
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   IF(associated(id%root%RHS_ROOT)) THEN
                      write(unit,iostat=err) size(id%root%RHS_ROOT,1)
      &                    ,size(id%root%RHS_ROOT,2)
@@ -7558,7 +6747,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   nullify(id%root%RHS_ROOT)
                   read(unit,iostat=err) size_array1,size_array2
                   if(err.ne.0) THEN
@@ -7599,11 +6788,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("QR_RCOND")
+            CASE(R_QR_RCOND)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_RL_OR_DBL
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%QR_RCOND
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7613,7 +6802,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_RL_OR_DBL
                   read(unit,iostat=err) id%root%QR_RCOND
                   if(err.ne.0) THEN
@@ -7625,11 +6814,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("yes")
+            CASE(R_yes)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_LOGICAL
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%yes
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7639,7 +6828,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_LOGICAL
                   read(unit,iostat=err) id%root%yes
                   if(err.ne.0) THEN
@@ -7651,11 +6840,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("gridinit_done")
+            CASE(R_gridinit_done)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_LOGICAL
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%gridinit_done
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7665,7 +6854,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_LOGICAL
                   read(unit,iostat=err) id%root%gridinit_done
                   if(err.ne.0) THEN
@@ -7677,14 +6866,272 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("SVD_U")
-            CASE("SVD_VT")
-            CASE("SINGULAR_VALUES")
-            CASE("NB_SINGULAR_VALUES")
+            CASE(R_SVD_U)
+               NbRecords_ROOT(i2)=2
+               if(mode.EQ.memory_save_mode) then
+                  IF(associated(id%root%SVD_U)) THEN
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*2
+                     SIZE_VARIABLES_ROOT(i2)=size(id%root%SVD_U,1)
+     &                    *size(id%root%SVD_U,2)*SIZE_ARITH_DEP
+                  ELSE
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*3
+                     SIZE_VARIABLES_ROOT(i2)=0_8
+                  ENDIF
+               elseif(mode.EQ.save_mode) then
+                  IF(associated(id%root%SVD_U)) THEN
+                     write(unit,iostat=err) size(id%root%SVD_U,1)
+     &                    ,size(id%root%SVD_U,2)
+                     if(err.ne.0) then
+                        id%INFO(1) = -72
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_FILE_SIZE-size_written
+     &                       ,id%INFO(2))
+                     endif
+                     CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                    id%COMM, id%MYID )
+                     IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                     write(unit,iostat=err) id%root%SVD_U
+                  ELSE
+                     write(unit,iostat=err) -999,-998
+                     if(err.ne.0) then
+                        id%INFO(1) = -72
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_FILE_SIZE-size_written
+     &                       ,id%INFO(2))
+                     endif
+                     CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                    id%COMM, id%MYID )
+                     IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                     write(unit,iostat=err) -999
+                  ENDIF 
+                  if(err.ne.0) then
+                     id%INFO(1) = -72
+                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written
+     &                    ,id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               elseif(mode.EQ.restore_mode) then
+                  nullify(id%root%SVD_U)
+                  read(unit,iostat=err) size_array1,size_array2
+                  if(err.ne.0) THEN
+                     id%INFO(1) = -75
+                     CALL MUMPS_SETI8TOI4(SIZE_VARIABLES_ROOT(i2),
+     &                    id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                  if(size_array1.EQ.-999) then
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*3
+                     SIZE_VARIABLES_ROOT(i2)=0_8
+                     read(unit,iostat=err) dummy
+                  else
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*2
+                     SIZE_VARIABLES_ROOT(i2)=size_array1*size_array2
+     &                    *SIZE_ARITH_DEP
+                     allocate(id%root%SVD_U(size_array1,size_array2),
+     &                    stat=allocok)
+                     if (allocok .GT. 0) THEN
+                        id%INFO(1) = -78
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_STRUC_SIZE-size_allocated
+     &                       ,id%INFO(2))
+                     endif
+                     read(unit,iostat=err) id%root%SVD_U
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                  if(err.ne.0) THEN
+                     id%INFO(1) = -75
+                     CALL MUMPS_SETI8TOI4(SIZE_VARIABLES_ROOT(i2),
+     &                    id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               endif
+            CASE(R_SVD_VT)
+               NbRecords_ROOT(i2)=2
+               if(mode.EQ.memory_save_mode) then
+                  IF(associated(id%root%SVD_VT)) THEN
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*2
+                     SIZE_VARIABLES_ROOT(i2)=size(id%root%SVD_VT,1)
+     &                    *size(id%root%SVD_VT,2)*SIZE_ARITH_DEP
+                  ELSE
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*3
+                     SIZE_VARIABLES_ROOT(i2)=0_8
+                  ENDIF
+               elseif(mode.EQ.save_mode) then
+                  IF(associated(id%root%SVD_VT)) THEN
+                     write(unit,iostat=err) size(id%root%SVD_VT,1)
+     &                    ,size(id%root%SVD_VT,2)
+                     if(err.ne.0) then
+                        id%INFO(1) = -72
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_FILE_SIZE-size_written
+     &                       ,id%INFO(2))
+                     endif
+                     CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                    id%COMM, id%MYID )
+                     IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                     write(unit,iostat=err) id%root%SVD_VT
+                  ELSE
+                     write(unit,iostat=err) -999,-998
+                     if(err.ne.0) then
+                        id%INFO(1) = -72
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_FILE_SIZE-size_written
+     &                       ,id%INFO(2))
+                     endif
+                     CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                    id%COMM, id%MYID )
+                     IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                     write(unit,iostat=err) -999
+                  ENDIF 
+                  if(err.ne.0) then
+                     id%INFO(1) = -72
+                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written
+     &                    ,id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               elseif(mode.EQ.restore_mode) then
+                  nullify(id%root%SVD_VT)
+                  read(unit,iostat=err) size_array1,size_array2
+                  if(err.ne.0) THEN
+                     id%INFO(1) = -75
+                     CALL MUMPS_SETI8TOI4(SIZE_VARIABLES_ROOT(i2),
+     &                    id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                  if(size_array1.EQ.-999) then
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*3
+                     SIZE_VARIABLES_ROOT(i2)=0_8
+                     read(unit,iostat=err) dummy
+                  else
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*2
+                     SIZE_VARIABLES_ROOT(i2)=size_array1*size_array2
+     &                    *SIZE_ARITH_DEP
+                     allocate(id%root%SVD_VT(size_array1,size_array2),
+     &                    stat=allocok)
+                     if (allocok .GT. 0) THEN
+                        id%INFO(1) = -78
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_STRUC_SIZE-size_allocated
+     &                       ,id%INFO(2))
+                     endif
+                     read(unit,iostat=err) id%root%SVD_VT
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                  if(err.ne.0) THEN
+                     id%INFO(1) = -75
+                     CALL MUMPS_SETI8TOI4(SIZE_VARIABLES_ROOT(i2),
+     &                    id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               endif
+            CASE(R_SINGULAR_VALUES)
+               NbRecords_ROOT(i2)=2
+               if(mode.EQ.memory_save_mode) then
+                  IF(associated(id%root%SINGULAR_VALUES)) THEN
+                     SIZE_GEST_ROOT(i2)=SIZE_INT
+                     SIZE_VARIABLES_ROOT(i2)=
+     &                    size(id%root%SINGULAR_VALUES,1)
+     &                    *SIZE_RL_OR_DBL
+                  ELSE
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*2
+                     SIZE_VARIABLES_ROOT(i2)=0_8
+                  ENDIF
+               elseif(mode.EQ.save_mode) then
+                  IF(associated(id%root%SINGULAR_VALUES)) THEN
+                     write(unit,iostat=err) 
+     &                    size(id%root%SINGULAR_VALUES,1)
+                     if(err.ne.0) then
+                        id%INFO(1) = -72
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_FILE_SIZE-size_written
+     &                       ,id%INFO(2))
+                     endif
+                     CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                    id%COMM, id%MYID )
+                     IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                     write(unit,iostat=err) id%root%SINGULAR_VALUES
+                  ELSE
+                     write(unit,iostat=err) -999
+                     if(err.ne.0) then
+                        id%INFO(1) = -72
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_FILE_SIZE-size_written
+     &                       ,id%INFO(2))
+                     endif
+                     CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                    id%COMM, id%MYID )
+                     IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                     write(unit,iostat=err) -999
+                  ENDIF 
+                  if(err.ne.0) then
+                     id%INFO(1) = -72
+                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written
+     &                    ,id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               elseif(mode.EQ.restore_mode) then
+                  nullify(id%root%SINGULAR_VALUES)
+                  read(unit,iostat=err) size_array1
+                  if(err.ne.0) THEN
+                     id%INFO(1) = -75
+                     CALL MUMPS_SETI8TOI4(SIZE_VARIABLES_ROOT(i2)
+     &                    ,id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                  if(size_array1.EQ.-999) then
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*2
+                     SIZE_VARIABLES_ROOT(i2)=0_8
+                     read(unit,iostat=err) dummy
+                  else
+                     SIZE_GEST_ROOT(i2)=SIZE_INT
+                     SIZE_VARIABLES_ROOT(i2)=size_array1*SIZE_RL_OR_DBL
+                     allocate(id%root%SINGULAR_VALUES(size_array1),
+     &                    stat=allocok)
+                     if (allocok .GT. 0) THEN
+                        id%INFO(1) = -78
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_STRUC_SIZE-size_allocated
+     &                       ,id%INFO(2))
+                     endif
+                     read(unit,iostat=err) id%root%SINGULAR_VALUES
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                  if(err.ne.0) THEN
+                     id%INFO(1) = -75
+                     CALL MUMPS_SETI8TOI4(SIZE_VARIABLES_ROOT(i2)
+     &                    ,id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               endif
+            CASE(R_NB_SINGULAR_VALUES)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%NB_SINGULAR_VALUES
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7694,7 +7141,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%NB_SINGULAR_VALUES
                   if(err.ne.0) THEN
@@ -7706,23 +7153,23 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("rootpad0","rootpad1","rootpad2","rootpad",
-     &              "rootpad3","rootpad4")
+            CASE(R_rootpad0,R_rootpad1,R_rootpad2,
+     &           R_rootpad3,R_rootpad4)
             CASE DEFAULT
             END SELECT
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                NbSubRecords=int(SIZE_VARIABLES_ROOT(i2)/huge(I4))
                IF(NbSubRecords.GT.0) then
                   NbRecords_ROOT(i2)=NbRecords_ROOT(i2)+NbSubRecords
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                size_written=size_written+SIZE_VARIABLES_ROOT(i2)
      &              +SIZE_GEST_ROOT(i2)
 #if defined(MUMPS_NOF2003)
                size_written=size_written
      &              +int(2*id%KEEP(34)*NbRecords_ROOT(i2),kind=8)
 #endif
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                size_allocated=size_allocated+SIZE_VARIABLES_ROOT(i2)+
      &              DIFF_SIZE_ALLOC_READ_ROOT(i2)
                size_read=size_read+SIZE_VARIABLES_ROOT(i2)
@@ -7731,53 +7178,30 @@ C
                size_read=size_read
      &              +int(2*id%KEEP(34)*NbRecords_ROOT(i2),kind=8)
 #endif
-            elseif(trim(mode).EQ."fake_restore") then
+            elseif(mode.EQ.fake_restore_mode) then
             endif
          ENDDO
-         CASE("NBGRP")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NBGRP
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NBGRP
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-        CASE("LRGROUPS")
+         CASE(S_NBGRP)
+           CALL MUMPS_SAVE_INT(id%NBGRP)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_LRGROUPS)
             CALL CMUMPS_SAVE_INT_SHPTR_ARRAY(id%LRGROUPS
      &           ) 
             IF (id%INFO(1) .LT. 0 ) GOTO 100
-         CASE("FDM_F_ENCODING")
+         CASE(S_FDM_F_ENCODING)
             NbRecords(i1)=1
             SIZE_GEST(i1)=SIZE_INT
             SIZE_VARIABLES(i1)=0_8
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%FDM_F_ENCODING)) THEN
                   CALL MUMPS_SAVE_RESTORE_FRONT_DATA(id%FDM_F_ENCODING
-     &                 ,unit,id%MYID,"memory_save"
+     &                 ,unit,id%MYID,memory_save_mode
      &                 ,SIZE_GEST_FRONT_DATA,SIZE_VARIABLES_FRONT_DATA
      &                 ,SIZE_INT,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
      &                 ,size_read,size_allocated,size_written
      &                 ,id%INFO(1))                 
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%FDM_F_ENCODING)) THEN
                   write(unit,iostat=err) size(id%FDM_F_ENCODING,1)
                   if(err.ne.0) then
@@ -7789,7 +7213,7 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                   CALL MUMPS_SAVE_RESTORE_FRONT_DATA(id%FDM_F_ENCODING
-     &                 ,unit,id%MYID,"save"
+     &                 ,unit,id%MYID,save_mode
      &                 ,SIZE_GEST_FRONT_DATA,SIZE_VARIABLES_FRONT_DATA
      &                 ,SIZE_INT,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
      &                 ,size_read,size_allocated,size_written
@@ -7813,7 +7237,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%FDM_F_ENCODING)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -7826,7 +7250,7 @@ C
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
                if(size_array1.NE.-999) then
                   CALL MUMPS_SAVE_RESTORE_FRONT_DATA(id%FDM_F_ENCODING
-     &                 ,unit,id%MYID,"restore"
+     &                 ,unit,id%MYID,restore_mode
      &                 ,SIZE_GEST_FRONT_DATA,SIZE_VARIABLES_FRONT_DATA
      &                 ,SIZE_INT,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
      &                 ,size_read,size_allocated,size_written
@@ -7844,21 +7268,21 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("BLRARRAY_ENCODING")            
+         CASE(S_BLRARRAY_ENCODING)            
             NbRecords(i1)=1
             SIZE_GEST(i1)=SIZE_INT
             SIZE_VARIABLES(i1)=0_8
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%BLRARRAY_ENCODING)) THEN
                   CALL CMUMPS_SAVE_RESTORE_BLR(id%BLRARRAY_ENCODING
-     &                 ,unit,id%MYID,"memory_save"
+     &                 ,unit,id%MYID,memory_save_mode
      &                 ,SIZE_GEST_BLR,SIZE_VARIABLES_BLR
      &                 ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
      &                 ,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
      &                 ,size_read,size_allocated,size_written
      &                 ,id%INFO(1))                 
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%BLRARRAY_ENCODING)) THEN
                   write(unit,iostat=err) size(id%BLRARRAY_ENCODING,1)
                   if(err.ne.0) then
@@ -7870,7 +7294,7 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                   CALL CMUMPS_SAVE_RESTORE_BLR(id%BLRARRAY_ENCODING
-     &                 ,unit,id%MYID,"save"
+     &                 ,unit,id%MYID,save_mode
      &                 ,SIZE_GEST_BLR,SIZE_VARIABLES_BLR
      &                 ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
      &                 ,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
@@ -7895,7 +7319,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%BLRARRAY_ENCODING)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -7908,7 +7332,7 @@ C
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
                if(size_array1.NE.-999) then
                   CALL CMUMPS_SAVE_RESTORE_BLR(id%BLRARRAY_ENCODING
-     &                 ,unit,id%MYID,"restore"
+     &                 ,unit,id%MYID,restore_mode
      &                 ,SIZE_GEST_BLR,SIZE_VARIABLES_BLR
      &                 ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
      &                 ,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
@@ -7927,179 +7351,41 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("L0_OMP_FACTORS")
+         CASE(S_L0_OMP_FACTORS)
             NbRecords(i1)     =0   
             SIZE_GEST(i1)     =0   
             SIZE_VARIABLES(i1)=0_8 
             CALL CMUMPS_SAVE_RESTORE_L0FACARRAY(id%L0_OMP_FACTORS
-     &                 ,unit,id%MYID,trim(mode)
+     &                 ,unit,id%MYID,mode
      &                 ,SIZE_GEST_L0FAC,SIZE_VARIABLES_L0FAC
      &                 ,SIZE_INT, SIZE_INT8, SIZE_ARITH_DEP
      &                 ,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
      &                 ,size_read,size_allocated,size_written
      &                 ,id%INFO(1))                 
-         CASE("SCHED_SBTR")
-         CASE("LPOOL_A_L0_OMP")
+         CASE(S_SCHED_SBTR)
+         CASE(S_LPOOL_A_L0_OMP)
+           CALL MUMPS_SAVE_INT(id%LPOOL_A_L0_OMP)
+           IF ( id%INFO(1) .LT. 0 ) GOTO 100
+         CASE(S_LPOOL_B_L0_OMP)
+           CALL MUMPS_SAVE_INT(id%LPOOL_B_L0_OMP)
+           IF ( id%INFO(1) .LT. 0 ) GOTO 100
+         CASE(S_L_PHYS_L0_OMP)
+           CALL MUMPS_SAVE_INT(id%L_PHYS_L0_OMP)
+           IF ( id%INFO(1) .LT. 0 ) GOTO 100
+         CASE(S_L_VIRT_L0_OMP)     
+           CALL MUMPS_SAVE_INT(id%L_VIRT_L0_OMP)
+           IF ( id%INFO(1) .LT. 0 ) GOTO 100
+         CASE(S_LL0_OMP_MAPPING)
+           CALL MUMPS_SAVE_INT(id%LL0_OMP_MAPPING)
+           IF ( id%INFO(1) .LT. 0 ) GOTO 100
+         CASE(S_LL0_OMP_FACTORS)
+           CALL MUMPS_SAVE_INT(id%LL0_OMP_FACTORS)
+           IF ( id%INFO(1) .LT. 0 ) GOTO 100
+         CASE(S_THREAD_LA)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%LPOOL_A_L0_OMP
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%LPOOL_A_L0_OMP
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("LPOOL_B_L0_OMP")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%LPOOL_B_L0_OMP
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%LPOOL_B_L0_OMP
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("L_PHYS_L0_OMP")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%L_PHYS_L0_OMP
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%L_PHYS_L0_OMP
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("L_VIRT_L0_OMP")     
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%L_VIRT_L0_OMP
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%L_VIRT_L0_OMP
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("LL0_OMP_MAPPING")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%LL0_OMP_MAPPING
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%LL0_OMP_MAPPING
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("LL0_OMP_FACTORS")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%LL0_OMP_FACTORS
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%LL0_OMP_FACTORS
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("THREAD_LA")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%THREAD_LA
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -8109,7 +7395,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8
                read(unit,iostat=err) id%THREAD_LA
                if(err.ne.0) THEN
@@ -8121,9 +7407,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("IPOOL_A_L0_OMP")
+         CASE(S_IPOOL_A_L0_OMP)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%IPOOL_A_L0_OMP)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
@@ -8132,7 +7418,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%IPOOL_A_L0_OMP)) THEN
                   write(unit,iostat=err) size(id%IPOOL_A_L0_OMP,1)
                   if(err.ne.0) then
@@ -8164,7 +7450,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%IPOOL_A_L0_OMP)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -8204,9 +7490,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("IPOOL_B_L0_OMP")
+         CASE(S_IPOOL_B_L0_OMP)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%IPOOL_B_L0_OMP)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
@@ -8215,7 +7501,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%IPOOL_B_L0_OMP)) THEN
                   write(unit,iostat=err) size(id%IPOOL_B_L0_OMP,1)
                   if(err.ne.0) then
@@ -8247,7 +7533,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%IPOOL_B_L0_OMP)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -8287,9 +7573,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PHYS_L0_OMP")
+         CASE(S_PHYS_L0_OMP)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%PHYS_L0_OMP)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
@@ -8298,7 +7584,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PHYS_L0_OMP)) THEN
                   write(unit,iostat=err) size(id%PHYS_L0_OMP,1)
                   if(err.ne.0) then
@@ -8330,7 +7616,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PHYS_L0_OMP)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -8369,9 +7655,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("VIRT_L0_OMP")
+         CASE(S_VIRT_L0_OMP)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%VIRT_L0_OMP)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%VIRT_L0_OMP,1)*SIZE_INT
@@ -8379,7 +7665,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%VIRT_L0_OMP)) THEN
                   write(unit,iostat=err) size(id%VIRT_L0_OMP,1)
                   if(err.ne.0) then
@@ -8411,7 +7697,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%VIRT_L0_OMP)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -8450,9 +7736,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("VIRT_L0_OMP_MAPPING")
+         CASE(S_VIRT_L0_OMP_MAPPING)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%VIRT_L0_OMP_MAPPING)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%VIRT_L0_OMP_MAPPING,1)
@@ -8461,7 +7747,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%VIRT_L0_OMP_MAPPING)) THEN
                   write(unit,iostat=err) size(id%VIRT_L0_OMP_MAPPING,1)
                   if(err.ne.0) then
@@ -8493,7 +7779,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%VIRT_L0_OMP_MAPPING)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -8533,9 +7819,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PERM_L0_OMP")
+         CASE(S_PERM_L0_OMP)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%PERM_L0_OMP)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%PERM_L0_OMP,1)*SIZE_INT
@@ -8543,7 +7829,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PERM_L0_OMP)) THEN
                   write(unit,iostat=err) size(id%PERM_L0_OMP,1)
                   if(err.ne.0) then
@@ -8575,7 +7861,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PERM_L0_OMP)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -8614,9 +7900,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PTR_LEAFS_L0_OMP")
+         CASE(S_PTR_LEAFS_L0_OMP)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%PTR_LEAFS_L0_OMP)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
@@ -8625,7 +7911,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PTR_LEAFS_L0_OMP)) THEN
                   write(unit,iostat=err) size(id%PTR_LEAFS_L0_OMP,1)
                   if(err.ne.0) then
@@ -8657,7 +7943,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PTR_LEAFS_L0_OMP)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -8697,9 +7983,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("L0_OMP_MAPPING")
+         CASE(S_L0_OMP_MAPPING)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%L0_OMP_MAPPING)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
@@ -8708,7 +7994,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%L0_OMP_MAPPING)) THEN
                   write(unit,iostat=err) size(id%L0_OMP_MAPPING,1)
                   if(err.ne.0) then
@@ -8740,7 +8026,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%L0_OMP_MAPPING)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -8779,46 +8065,102 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("SINGULAR_VALUES")
-        CASE("NB_SINGULAR_VALUES")
-           NbRecords(i1)=1
-           if(trim(mode).EQ."memory_save") then
-              SIZE_VARIABLES(i1)=SIZE_INT
-           elseif(trim(mode).EQ."save") then
-              write(unit,iostat=err) id%NB_SINGULAR_VALUES
+         CASE(S_SINGULAR_VALUES)
+            NbRecords(i1)=2
+            if(mode.EQ.memory_save_mode) then
+               IF(associated(id%SINGULAR_VALUES)) THEN
+                  SIZE_GEST(i1)=SIZE_INT
+                  SIZE_VARIABLES(i1)=
+     &                 size(id%SINGULAR_VALUES,1)*SIZE_RL_OR_DBL
+              ELSE
+                 SIZE_GEST(i1)=SIZE_INT*2
+                 SIZE_VARIABLES(i1)=0_8
+              ENDIF
+           elseif(mode.EQ.save_mode) then
+              IF(associated(id%SINGULAR_VALUES)) THEN
+                 write(unit,iostat=err) size(id%SINGULAR_VALUES,1)
+                 if(err.ne.0) then
+                    id%INFO(1) = -72
+                    CALL MUMPS_SETI8TOI4(size_written,id%INFO(2))
+                 endif
+                 CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                id%COMM, id%MYID )
+                 IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                 write(unit,iostat=err) id%SINGULAR_VALUES
+              ELSE
+                 write(unit,iostat=err) -999
+                 if(err.ne.0) then
+                    id%INFO(1) = -72
+                    CALL MUMPS_SETI8TOI4(size_written,id%INFO(2))
+                 endif
+                 CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                id%COMM, id%MYID )
+                 IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                 write(unit,iostat=err) -999
+              ENDIF 
               if(err.ne.0) then
                  id%INFO(1) = -72
-                 CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                id%INFO(2))
+                 CALL MUMPS_SETI8TOI4(size_written,id%INFO(2))
               endif
               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &             id%COMM, id%MYID )
               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-           elseif(trim(mode).EQ."restore") then
-              SIZE_VARIABLES(i1)=SIZE_INT
-              read(unit,iostat=err) id%NB_SINGULAR_VALUES
-              if(err.ne.0) THEN
-                 id%INFO(1) = -75
-                 CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                ,id%INFO(2))
-              endif 
-              CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &             id%COMM, id%MYID )
-              IF ( id%INFO(1) .LT. 0 ) GOTO 100
+           elseif(mode.EQ.restore_mode) then
+              nullify(id%SINGULAR_VALUES)
+               read(unit,iostat=err) size_array1
+               if(err.ne.0) THEN
+                  id%INFO(1) = -75
+                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
+     &                 ,id%INFO(2))
+               endif
+               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &              id%COMM, id%MYID )
+               IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               if(size_array1.EQ.-999) then
+                  SIZE_GEST(i1)=SIZE_INT*2
+                  SIZE_VARIABLES(i1)=0_8
+                  read(unit,iostat=err) dummy
+               else
+                  SIZE_GEST(i1)=SIZE_INT
+                  SIZE_VARIABLES(i1)=size_array1*SIZE_RL_OR_DBL
+                  allocate(id%SINGULAR_VALUES(size_array1),
+     &                 stat=allocok)
+                  if (allocok .GT. 0) THEN
+                     id%INFO(1) = -78
+                     CALL MUMPS_SETI8TOI4(
+     &                    TOTAL_STRUC_SIZE-size_allocated
+     &                    ,id%INFO(2))
+                  endif
+                  read(unit,iostat=err) id%SINGULAR_VALUES
+               endif
+               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &              id%COMM, id%MYID )
+               IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               if(err.ne.0) THEN
+                  id%INFO(1) = -75
+                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
+     &                 ,id%INFO(2))
+               endif
+               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &              id%COMM, id%MYID )
+               IF ( id%INFO(1) .LT. 0 ) GOTO 100
            endif
-        CASE("ASSOCIATED_OOC_FILES")
-            if(trim(mode).EQ."memory_save") then
+        CASE(S_NB_SINGULAR_VALUES)
+           CALL MUMPS_SAVE_INT(id%NB_SINGULAR_VALUES)
+           IF ( id%INFO(1) .LT. 0 ) GOTO 100
+        CASE(S_ASSOCIATED_OOC_FILES)
+            if(mode.EQ.memory_save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_LOGICAL
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_LOGICAL
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_LOGICAL
             endif
-        CASE("SAVE_DIR")
+        CASE(S_SAVE_DIR)
            NbRecords(i1)=1
-           if(trim(mode).EQ."memory_save") then
+           if(mode.EQ.memory_save_mode) then
               SIZE_VARIABLES(i1)=len(id%SAVE_DIR)*SIZE_CHARACTER
-           elseif(trim(mode).EQ."save") then
+           elseif(mode.EQ.save_mode) then
               write(unit,iostat=err) id%SAVE_DIR
               if(err.ne.0) then
                  id%INFO(1) = -72
@@ -8828,7 +8170,7 @@ C
               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &             id%COMM, id%MYID )
               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-           elseif(trim(mode).EQ."restore") then
+           elseif(mode.EQ.restore_mode) then
               SIZE_VARIABLES(i1)=len(id%SAVE_DIR)*SIZE_CHARACTER
               read(unit,iostat=err) id%SAVE_DIR
               if(err.ne.0) THEN
@@ -8840,11 +8182,11 @@ C
      &             id%COMM, id%MYID )
               IF ( id%INFO(1) .LT. 0 ) GOTO 100
            endif
-        CASE("SAVE_PREFIX")
+        CASE(S_SAVE_PREFIX)
            NbRecords(i1)=1
-           if(trim(mode).EQ."memory_save") then
+           if(mode.EQ.memory_save_mode) then
               SIZE_VARIABLES(i1)=len(id%SAVE_PREFIX)*SIZE_CHARACTER
-           elseif(trim(mode).EQ."save") then
+           elseif(mode.EQ.save_mode) then
               write(unit,iostat=err) id%SAVE_PREFIX
               if(err.ne.0) then
                  id%INFO(1) = -72
@@ -8854,7 +8196,7 @@ C
               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &             id%COMM, id%MYID )
               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-           elseif(trim(mode).EQ."restore") then
+           elseif(mode.EQ.restore_mode) then
               SIZE_VARIABLES(i1)=len(id%SAVE_PREFIX)*SIZE_CHARACTER
               read(unit,iostat=err) id%SAVE_PREFIX
               if(err.ne.0) THEN
@@ -8866,20 +8208,20 @@ C
      &             id%COMM, id%MYID )
               IF ( id%INFO(1) .LT. 0 ) GOTO 100
            endif
-        CASE("MPITOOMP_PROCS_MAP")
+        CASE(S_MTKO_PROCS_MAP)
            NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
-               IF(associated(id%MPITOOMP_PROCS_MAP)) THEN
+            if(mode.EQ.memory_save_mode) then
+               IF(associated(id%MTKO_PROCS_MAP)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
-     &                 size(id%MPITOOMP_PROCS_MAP,1)*SIZE_INT
+     &                 size(id%MTKO_PROCS_MAP,1)*SIZE_INT
                ELSE
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
-               IF(associated(id%MPITOOMP_PROCS_MAP)) THEN
-                  write(unit,iostat=err) size(id%MPITOOMP_PROCS_MAP,1)
+            elseif(mode.EQ.save_mode) then
+               IF(associated(id%MTKO_PROCS_MAP)) THEN
+                  write(unit,iostat=err) size(id%MTKO_PROCS_MAP,1)
                   if(err.ne.0) then
                      id%INFO(1) = -72
                      CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
@@ -8888,7 +8230,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-                  write(unit,iostat=err) id%MPITOOMP_PROCS_MAP
+                  write(unit,iostat=err) id%MTKO_PROCS_MAP
                ELSE
                   write(unit,iostat=err) -999
                   if(err.ne.0) then
@@ -8909,8 +8251,8 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               nullify(id%MPITOOMP_PROCS_MAP)
+            elseif(mode.EQ.restore_mode) then
+               nullify(id%MTKO_PROCS_MAP)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
                   id%INFO(1) = -75
@@ -8927,7 +8269,7 @@ C
                else
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size_array1*SIZE_INT
-                  allocate(id%MPITOOMP_PROCS_MAP(size_array1),
+                  allocate(id%MTKO_PROCS_MAP(0:size_array1-1),
      &                 stat=allocok)
                   if (allocok .GT. 0) THEN
                      id%INFO(1) = -78
@@ -8935,7 +8277,7 @@ C
      &                    TOTAL_STRUC_SIZE-size_allocated
      &                    ,id%INFO(2))
                   endif
-                  read(unit,iostat=err) id%MPITOOMP_PROCS_MAP
+                  read(unit,iostat=err) id%MTKO_PROCS_MAP
                endif
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
@@ -8949,11 +8291,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("METIS_OPTIONS")
+         CASE(S_METIS_OPTIONS)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%METIS_OPTIONS,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%METIS_OPTIONS
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -8963,7 +8305,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%METIS_OPTIONS,1)
                read(unit,iostat=err) id%METIS_OPTIONS
                if(err.ne.0) THEN
@@ -8975,23 +8317,23 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif      
-      CASE("pad0","pad1","pad2","pad3","pad4","pad5","pad6","pad7",
-     &     "pad11","pad111", "pad12","pad13","pad14","pad15","pad16")
+      CASE(S_pad1,S_pad2,S_pad3,S_pad4,S_pad5,S_pad6,S_pad7,
+     &     S_pad11,S_pad12,S_pad13,S_pad14,S_pad16)
       CASE DEFAULT
       END SELECT
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          NbSubRecords=int(SIZE_VARIABLES(i1)/huge(I4))
          IF(NbSubRecords.GT.0) then
             NbRecords(i1)=NbRecords(i1)+NbSubRecords
          ENDIF
-      elseif(trim(mode).EQ."save") then
+      elseif(mode.EQ.save_mode) then
          size_written=size_written+SIZE_VARIABLES(i1)
      &        +int(SIZE_GEST(i1),kind=8)
 #if defined(MUMPS_NOF2003)
          size_written=size_written
      &        +int(2*id%KEEP(34)*NbRecords(i1),kind=8)
 #endif
-      elseif(trim(mode).EQ."restore") then
+      elseif(mode.EQ.restore_mode) then
          size_allocated=size_allocated+SIZE_VARIABLES(i1)+
      &        DIFF_SIZE_ALLOC_READ(i1)
          size_read=size_read+SIZE_VARIABLES(i1)
@@ -9000,11 +8342,11 @@ C
          size_read=size_read
      &        +int(2*id%KEEP(34)*NbRecords(i1),kind=8)
 #endif
-      elseif(trim(mode).EQ."fake_restore") then
+      elseif(mode.EQ.fake_restore_mode) then
       endif
       ENDDO
  200  continue
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          WRITTEN_STRUC_SIZE=sum(SIZE_VARIABLES)+sum(SIZE_VARIABLES_ROOT)
      &        +SIZE_VARIABLES_BLR+SIZE_VARIABLES_FRONT_DATA+
      &         SIZE_VARIABLES_L0FAC
@@ -9031,8 +8373,8 @@ C
          gest_size=gest_size+int(2*id%KEEP(34)*tot_NbRecords,kind=8)
 #endif
          TOTAL_FILE_SIZE=WRITTEN_STRUC_SIZE+gest_size
-      elseif(trim(mode).EQ."save") then
-      elseif(trim(mode).EQ."restore") then
+      elseif(mode.EQ.save_mode) then
+      elseif(mode.EQ.restore_mode) then
 #if ! defined(NOSCALAPACK)
          if(id%root%gridinit_done) then
             id%root%CNTXT_BLACS = id%COMM_NODES
@@ -9042,18 +8384,131 @@ C
             id%root%DESCRIPTOR(2) = id%root%CNTXT_BLACS
          endif
 #endif
-      elseif(trim(mode).EQ."fake_restore") then
-      elseif(trim(mode).EQ."restore_ooc") then
+      elseif(mode.EQ.fake_restore_mode) then
+      elseif(mode.EQ.restore_ooc_mode) then
       endif
  100  continue
-      deallocate(VARIABLES, VARIABLES_ROOT)
       RETURN
       CONTAINS
+      SUBROUTINE MUMPS_SAVERSTR_REALARRAY(idREAL)
+      IMPLICIT NONE
+      REAL, DIMENSION(:), POINTER :: idREAL
+      NbRecords(i1)=2
+      if(mode.EQ.memory_save_mode) then
+         IF(associated(idREAL)) THEN
+            SIZE_GEST(i1)=SIZE_INT
+            SIZE_VARIABLES(i1)=size(idREAL,1)*SIZE_RL_OR_DBL
+         ELSE
+            SIZE_GEST(i1)=SIZE_INT*2
+            SIZE_VARIABLES(i1)=0_8
+         ENDIF
+      elseif(mode.EQ.save_mode) then
+         IF(associated(idREAL)) THEN
+            write(unit,iostat=err) size(idreal,1)
+            if(err.ne.0) then
+               id%INFO(1) = -72
+               CALL MUMPS_SETI8TOI4(
+     &              TOTAL_FILE_SIZE-size_written,
+     &              id%INFO(2))
+            endif
+            write(unit,iostat=err) idREAL
+         ELSE
+            write(unit,iostat=err) -999
+            if(err.ne.0) then
+               id%INFO(1) = -72
+               CALL MUMPS_SETI8TOI4(
+     &         TOTAL_FILE_SIZE-size_written,
+     &         id%INFO(2))
+            endif
+            write(unit,iostat=err) -999
+         ENDIF 
+         if(err.ne.0) then
+               id%INFO(1) = -72
+               CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
+     &         id%INFO(2))
+         endif
+         CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+         IF ( id%INFO(1) .LT. 0 ) GOTO 100
+      elseif(mode.EQ.restore_mode) then
+         nullify(idREAL)
+         read(unit,iostat=err) size_array1
+         if (err.ne.0) THEN
+           id%INFO(1) = -75
+           CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
+     &                    ,id%INFO(2))
+         endif
+         CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+         IF ( id%INFO(1) .LT. 0 ) GOTO 100
+           if (size_array1.EQ.-999) then
+                     SIZE_GEST(i1)=SIZE_INT*2
+                     SIZE_VARIABLES(i1)=0_8
+                     read(unit,iostat=err) dummy
+           else
+                     SIZE_GEST(i1)=SIZE_INT
+                     SIZE_VARIABLES(i1)=size_array1*SIZE_RL_OR_DBL
+                     allocate(idREAL(size_array1), stat=allocok)
+                     if (allocok .GT. 0) THEN
+                        id%INFO(1) = -78
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_STRUC_SIZE-size_allocated
+     &                       ,id%INFO(2))
+                     endif
+                     read(unit,iostat=err) idREAL
+           endif
+           CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                          id%COMM, id%MYID )
+           IF ( id%INFO(1) .LT. 0 ) GOTO 100
+           if (err.ne.0) THEN
+               id%INFO(1) = -75
+               CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
+     &                    ,id%INFO(2))
+           endif 
+           CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                          id%COMM, id%MYID )
+           IF ( id%INFO(1) .LT. 0 ) GOTO 100
+      endif
+ 100  CONTINUE
+      RETURN
+      END SUBROUTINE MUMPS_SAVERSTR_REALARRAY
+      SUBROUTINE MUMPS_SAVE_INT(idINT)
+      IMPLICIT NONE
+      INTEGER, INTENT(INOUT) :: idINT
+      NbRecords(i1)=1
+      if(mode.EQ.memory_save_mode) then
+         SIZE_VARIABLES(i1)=SIZE_INT
+      elseif(mode.EQ.save_mode) then
+         write(unit,iostat=err) idINT
+         if(err.ne.0) then
+           id%INFO(1) = -72
+           CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
+     &          id%INFO(2))
+         endif
+         CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &        id%COMM, id%MYID )
+         IF ( id%INFO(1) .LT. 0 ) GOTO 100
+      elseif(mode.EQ.restore_mode) then
+         SIZE_VARIABLES(i1)=SIZE_INT
+         read(unit,iostat=err) idINT
+         if(err.ne.0) THEN
+            id%INFO(1) = -75
+            CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
+     &           ,id%INFO(2))
+         endif 
+         CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &        id%COMM, id%MYID )
+         IF ( id%INFO(1) .LT. 0 ) GOTO 100
+      endif
+ 100  CONTINUE
+      RETURN
+      END SUBROUTINE MUMPS_SAVE_INT
       SUBROUTINE CMUMPS_SAVE_INT_SHPTR_ARRAY(id_INTPTR
      &  )
+      IMPLICIT NONE
       INTEGER, POINTER, DIMENSION(:) :: id_INTPTR
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id_INTPTR)
      &            ) THEN
                   SIZE_GEST(i1)=SIZE_INT
@@ -9062,7 +8517,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id_INTPTR)
      &            ) THEN
                   write(unit,iostat=err) size(id_INTPTR,1)
@@ -9095,7 +8550,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id_INTPTR)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -9142,3 +8597,8 @@ C
       END SUBROUTINE CMUMPS_SAVE_INT_SHPTR_ARRAY
       END SUBROUTINE CMUMPS_SAVE_RESTORE_STRUCTURE
       END MODULE CMUMPS_SAVE_RESTORE
+#else
+      SUBROUTINE CMUMPS_SAVE_RESTORE_RETURN()
+      RETURN
+      END SUBROUTINE CMUMPS_SAVE_RESTORE_RETURN
+#endif
diff -pruN 5.6.2-2.1/src/cmumps_save_restore_files.F 5.7.1-1/src/cmumps_save_restore_files.F
--- 5.6.2-2.1/src/cmumps_save_restore_files.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/cmumps_save_restore_files.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -11,11 +11,11 @@ C  released under the CeCILL-C license
 C  (see doc/CeCILL-C_V1-en.txt, doc/CeCILL-C_V1-fr.txt, and
 C  https://cecill.info/licences/Licence_CeCILL-C_V1-en.html)
 C
+#if ! defined(NO_SAVE_RESTORE)
       MODULE CMUMPS_SAVE_RESTORE_FILES
       USE CMUMPS_STRUC_DEF
       IMPLICIT NONE
-      INTEGER :: LEN_SAVE_FILE
-      PARAMETER( LEN_SAVE_FILE = 550)
+      INTEGER, PARAMETER :: LEN_SAVE_FILE = 1318
       CONTAINS
       SUBROUTINE MUMPS_READ_HEADER(fileunit, ierr, size_read, SIZE_INT
      &     ,SIZE_INT8, TOTAL_FILE_SIZE, TOTAL_STRUC_SIZE
@@ -113,10 +113,6 @@ C
         size_read=size_read
      &           +int(2*SIZE_INT*1,kind=8)
 #endif
-#if defined(OOC_VERBOSE)
-        write(*,*) 'First ooc file: ',
-     &   READ_OOC_FIRST_FILE_NAME(1:READ_OOC_FILE_NAME_LENGTH-2)
-#endif
       ENDIF
  100  continue
       RETURN
@@ -237,60 +233,76 @@ C
       TYPE (CMUMPS_STRUC),intent(inout) :: id
       CHARACTER(len=LEN_SAVE_FILE),intent(out):: SAVE_FILE, INFO_FILE
       INTEGER::len_save_dir,len_save_prefix
-      CHARACTER(len=255):: tmp_savedir,savedir
-      CHARACTER(len=255):: tmp_saveprefix,saveprefix
+      INTEGER, PARAMETER :: SAVE_PREFIX_MAX_LENGTH =  255
+      INTEGER, PARAMETER :: SAVE_DIR_MAX_LENGTH    = 1023
+      CHARACTER(len=SAVE_DIR_MAX_LENGTH)    :: tmp_save_dir
+      CHARACTER(len=SAVE_DIR_MAX_LENGTH)    :: save_dir
+      CHARACTER(len=SAVE_PREFIX_MAX_LENGTH) :: save_prefix
+      CHARACTER(len=SAVE_PREFIX_MAX_LENGTH) :: tmp_save_prefix
       CHARACTER(len=10):: STRING_MYID
       CHARACTER:: LAST_CHAR_DIR
       INFO_FILE=''
       SAVE_FILE=''
-      tmp_savedir=''
-      tmp_saveprefix=''
+      tmp_save_dir=''
+      tmp_save_prefix=''
       IF(id%SAVE_DIR.EQ."NAME_NOT_INITIALIZED") THEN
-         call mumps_get_save_dir_C(len_save_dir,tmp_savedir)
-         if(tmp_savedir(1:len_save_dir).EQ."NAME_NOT_INITIALIZED") then
-            id%INFO(1) = -77
-            id%INFO(2) = 0 
+         call MUMPS_GET_SAVE_DIR_C(len_save_dir,tmp_save_dir)
+         len_save_dir=min(SAVE_DIR_MAX_LENGTH,len_save_dir)
+         if (len_save_dir > SAVE_DIR_MAX_LENGTH) then
+           id%INFO(1) = -77
+           id%INFO(2) = SAVE_DIR_MAX_LENGTH
+         else if(tmp_save_dir(1:len_save_dir).EQ."NAME_NOT_INITIALIZED")
+     &     then
+           id%INFO(1) = -77
+           id%INFO(2) = 0 
          else
-            savedir=trim(adjustl(tmp_savedir(1:len_save_dir)))
-            len_save_dir=len_trim(savedir(1:len_save_dir))
+           save_dir=trim(adjustl(tmp_save_dir(1:len_save_dir)))
+           len_save_dir=len_trim(save_dir(1:len_save_dir))
          endif
       ELSE
-         savedir=trim(adjustl(id%SAVE_DIR))
-         len_save_dir=len_trim(savedir)
+         save_dir=trim(adjustl(id%SAVE_DIR))
+         len_save_dir=len_trim(save_dir)
       ENDIF
       CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &     id%COMM, id%MYID )
       IF ( id%INFO(1) .LT. 0 ) GOTO 100
       IF(id%SAVE_PREFIX.EQ."NAME_NOT_INITIALIZED") THEN
-         call mumps_get_save_prefix_C(len_save_prefix,tmp_saveprefix)
-         if(tmp_saveprefix(1:len_save_prefix).EQ."NAME_NOT_INITIALIZED")
-     &        then
-            saveprefix="save"
-            len_save_prefix=len_trim(saveprefix)
-         else
-            saveprefix=
-     &           trim(adjustl(tmp_saveprefix(1:len_save_prefix)))
-            len_save_prefix=len_trim(saveprefix(1:len_save_prefix))
-         endif
+        call MUMPS_GET_SAVE_PREFIX_C(len_save_prefix,tmp_save_prefix)
+        len_save_prefix=min(SAVE_PREFIX_MAX_LENGTH,len_save_prefix)
+        if(len_save_prefix.GT.SAVE_PREFIX_MAX_LENGTH) then
+          id%INFO(1)=-77
+          id%INFO(2)=-SAVE_PREFIX_MAX_LENGTH
+        else if(tmp_save_prefix(1:len_save_prefix).EQ.
+     &  "NAME_NOT_INITIALIZED") then
+           save_prefix="save"
+           len_save_prefix=len_trim(save_prefix)
+        else
+           save_prefix=
+     &          trim(adjustl(tmp_save_prefix(1:len_save_prefix)))
+           len_save_prefix=len_trim(save_prefix(1:len_save_prefix))
+        endif
       ELSE
-         saveprefix=trim(adjustl(id%SAVE_PREFIX))
-         len_save_prefix=len_trim(saveprefix)
+        save_prefix=trim(adjustl(id%SAVE_PREFIX))
+        len_save_prefix=len_trim(save_prefix)
       ENDIF
+      CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &     id%COMM, id%MYID )
+      IF ( id%INFO(1) .LT. 0 ) GOTO 100
       write(STRING_MYID,'(I10)') id%MYID
-      LAST_CHAR_DIR=savedir(len_save_dir:len_save_dir)
+      LAST_CHAR_DIR=save_dir(len_save_dir:len_save_dir)
       if(LAST_CHAR_DIR.NE."/") then
-         SAVE_FILE=trim(adjustl(savedir))//"/"
+         SAVE_FILE=trim(adjustl(save_dir))//"/"
       else
-         SAVE_FILE=trim(adjustl(savedir))
+         SAVE_FILE=trim(adjustl(save_dir))
       endif
       INFO_FILE=trim(adjustl(SAVE_FILE))
       SAVE_FILE=trim(adjustl(SAVE_FILE))
-     &     //trim(adjustl(saveprefix))
+     &     //trim(adjustl(save_prefix))
      &     //"_"
      &     //trim(adjustl(STRING_MYID))
      &     //".mumps"
       INFO_FILE=trim(adjustl(INFO_FILE))
-     &        //trim(adjustl(saveprefix))
+     &        //trim(adjustl(save_prefix))
      &        //"_"
      &        //trim(adjustl(STRING_MYID))
      &        //".info"
@@ -323,3 +335,8 @@ C
       ENDIF
       END SUBROUTINE CMUMPS_CHECK_FILE_NAME      
       END MODULE CMUMPS_SAVE_RESTORE_FILES
+#else
+      SUBROUTINE CMUMPS_SAVE_FILES_RETURN()
+      RETURN
+      END SUBROUTINE CMUMPS_SAVE_FILES_RETURN
+#endif
diff -pruN 5.6.2-2.1/src/cmumps_sol_es.F 5.7.1-1/src/cmumps_sol_es.F
--- 5.6.2-2.1/src/cmumps_sol_es.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/cmumps_sol_es.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -13,16 +13,24 @@ C  https://cecill.info/licences/Licence_
 C
       MODULE CMUMPS_SOL_ES
       PRIVATE
-      PUBLIC:: PRUNED_SIZE_LOADED
       PUBLIC:: CMUMPS_CHAIN_PRUN_NODES
       PUBLIC:: CMUMPS_CHAIN_PRUN_NODES_STATS
       PUBLIC:: CMUMPS_INITIALIZE_RHS_BOUNDS
       PUBLIC:: CMUMPS_PROPAGATE_RHS_BOUNDS
       PUBLIC:: CMUMPS_TREE_PRUN_NODES
-      PUBLIC:: CMUMPS_TREE_PRUN_NODES_STATS
       PUBLIC:: CMUMPS_SOL_ES_INIT
+#     if defined(STAT_ES_SOLVE)
+      PUBLIC:: CMUMPS_SOL_ES_PRINT_STATS
+#     endif
+      PUBLIC:: CMUMPS_ES_GET_SUM_Nloc
+      PUBLIC:: CMUMPS_ES_NODES_SIZE_AND_FILL
       INTEGER(8), POINTER, DIMENSION(:,:) :: SIZE_OF_BLOCK
-      INTEGER(8) :: PRUNED_SIZE_LOADED
+#     if defined(STAT_ES_SOLVE)
+      DOUBLE PRECISION :: nb_flops,
+     &                    nb_sparse_flops,
+     &                    total_efficiency
+      INTEGER :: total_procs, total_blocks
+#endif
       INCLUDE 'mumps_headers.h'
       CONTAINS
       SUBROUTINE CMUMPS_SOL_ES_INIT(SIZE_OF_BLOCK_ARG, KEEP201)
@@ -34,6 +42,13 @@ C
       ELSE
         NULLIFY(SIZE_OF_BLOCK)
       ENDIF
+#if defined(STAT_ES_SOLVE)
+      nb_flops=0.0d0
+      nb_sparse_flops=0.0d0
+      total_efficiency=0.0d0
+      total_procs=0
+      total_blocks=0
+#endif
       RETURN
       END SUBROUTINE CMUMPS_SOL_ES_INIT
       SUBROUTINE CMUMPS_TREE_PRUN_NODES( 
@@ -50,7 +65,7 @@ C
       INTEGER, INTENT(IN) :: N, KEEP28
       INTEGER, INTENT(IN) :: DAD(KEEP28),NE_STEPS(KEEP28),FRERE(KEEP28)
       INTEGER, INTENT(IN) :: FILS(N), STEP(N)
-      INTEGER, INTENT(IN) :: nodes_RHS(KEEP28),  nb_nodes_RHS
+      INTEGER, INTENT(IN) :: nodes_RHS(:),  nb_nodes_RHS
       INTEGER :: nb_prun_nodes
       INTEGER, OPTIONAL, INTENT(INOUT):: Pruned_List(nb_prun_nodes)
       INTEGER :: nb_prun_roots
@@ -143,15 +158,15 @@ C
       INTEGER, INTENT(IN) :: KEEP28
       INTEGER, INTENT(IN) :: DAD(KEEP28)
       INTEGER, INTENT(IN) :: nb_nodes_RHS
-      INTEGER, INTENT(IN) :: nodes_RHS(nb_nodes_RHS)
-      INTEGER :: nb_prun_nodes
+      INTEGER, INTENT(IN) :: nodes_RHS(max(nb_nodes_RHS,1))
+      INTEGER, INTENT(INOUT) :: nb_prun_nodes
       INTEGER, OPTIONAL, INTENT(INOUT):: Pruned_List(nb_prun_nodes)
-      INTEGER :: nb_prun_roots
+      INTEGER, INTENT(INOUT) :: nb_prun_roots
       INTEGER, OPTIONAL, INTENT(INOUT):: Pruned_Roots(nb_prun_roots)
-      INTEGER :: nb_prun_leaves
+      INTEGER, INTENT(INOUT) :: nb_prun_leaves
       INTEGER, OPTIONAL, INTENT(INOUT):: Pruned_Leaves(nb_prun_leaves)
-      INTEGER :: Pruned_SONS(KEEP28)
-      LOGICAL :: TO_PROCESS(KEEP28)
+      INTEGER, INTENT(OUT) :: Pruned_SONS(KEEP28)
+      LOGICAL, INTENT(OUT) :: TO_PROCESS(KEEP28)
       INTEGER :: IN, I, ISTEP, TMP
       nb_prun_nodes = 0
       nb_prun_roots = 0
@@ -265,6 +280,10 @@ C
      & STEP, N, Pruned_SONS,
      & DAD, RHS_BOUNDS, NSTEPS,
      & MYID, COMM, KEEP485,
+#if defined(STAT_ES_SOLVE)
+     & KEEP46,
+     & IPTR_WORKING, SIZE_IPTR_WORKING, WORKING, SIZE_WORKING,
+#endif
      & IW, LIW, PTRIST, KIXSZ,OOC_FCT_LOC, PHASE, LDLT, K38)
       IMPLICIT NONE
       INCLUDE 'mpif.h'
@@ -275,10 +294,26 @@ C
       INTEGER, INTENT(IN) :: pruned_leaves(nb_pruned_leaves)
       INTEGER, INTENT(IN) :: LIW, IW(LIW), PTRIST(NSTEPS)
       INTEGER, INTENT(IN) :: KIXSZ, OOC_FCT_LOC, PHASE, LDLT, K38
+#     if defined(STAT_ES_SOLVE)
+      INTEGER, INTENT(IN) :: KEEP46 
+      INTEGER, INTENT(IN) :: SIZE_IPTR_WORKING, SIZE_WORKING, 
+     &                       IPTR_WORKING(SIZE_IPTR_WORKING),
+     &                       WORKING(SIZE_WORKING)
+#endif
       INTEGER, INTENT(INOUT):: RHS_BOUNDS(2*NSTEPS)
       INTEGER :: I, node, father, size_pool, next_size_pool
       INTEGER :: IERR
       INTEGER, ALLOCATABLE, DIMENSION(:) :: POOL, NBSONS
+#if defined(STAT_ES_SOLVE)
+      LOGICAL, ALLOCATABLE, DIMENSION(:) :: isleaf
+      INTEGER :: J, NPROCS, proc, allocok
+      LOGICAL :: found
+      DOUBLE PRECISION :: avg_load, efficiency, max_load, effmax
+      DOUBLE PRECISION, ALLOCATABLE, DIMENSION(:) :: proc_flops_buf
+      DOUBLE PRECISION :: proc_block_flops, block_flops
+      INTEGER :: SK38  
+      INTEGER, PARAMETER :: MASTER  = 0
+#endif
       ALLOCATE(POOL(nb_pruned_leaves),
      &         NBSONS(NSTEPS),
      &         STAT=IERR)
@@ -289,6 +324,37 @@ C
       size_pool = nb_pruned_leaves
       POOL = pruned_leaves
       NBSONS = Pruned_SONS
+#     if defined(STAT_ES_SOLVE)
+      NPROCS = SIZE_IPTR_WORKING-1
+      IF((MYID.EQ.MASTER).AND.(KEEP46.EQ.1)) THEN
+        ALLOCATE(isleaf(NSTEPS), STAT=IERR)
+        IF (IERR.NE.0) THEN
+          WRITE(6,*)'Allocation problem in CMUMPS_PROPAGATE_RHS_BOUNDS'
+          CALL MUMPS_ABORT()
+        END IF
+        isleaf = .FALSE.
+        DO I=1,nb_pruned_leaves
+          isleaf(abs(STEP(pruned_leaves(I)))) = .true.
+        END DO
+        proc = 0
+        DO I=1,NPROCS
+          found = .FALSE.
+          J = IPTR_WORKING(I)
+          DO WHILE((J.LE.IPTR_WORKING(I+1)-1).AND.(.NOT.found))
+            IF (isleaf(WORKING(J)))THEN
+              found = .TRUE.            
+            END IF
+            J = J + 1
+          END DO
+          IF(found) THEN
+            proc = proc + 1
+          END IF
+        END DO
+        total_procs = total_procs + proc
+        total_blocks = total_blocks + 1
+        DEALLOCATE(isleaf)
+      END IF
+#     endif
       DO WHILE (size_pool.ne.0)
         next_size_pool =0 
         DO I=1, size_pool 
@@ -314,6 +380,76 @@ C
         size_pool = next_size_pool 
       END DO
       DEALLOCATE(POOL, NBSONS)
+#     if defined(STAT_ES_SOLVE)
+      IF (KEEP46.EQ.1) THEN
+       IF(MYID.EQ.MASTER) THEN
+        block_flops = 0D0
+       END IF
+       proc_block_flops = 0D0
+       IF (K38 .GT. 0) THEN
+        SK38 = STEP(K38)
+       ELSE
+        SK38 = 0
+       END IF
+       DO I=1,NSTEPS
+        IF (RHS_BOUNDS(2*I).NE.0) THEN 
+          IF(PTRIST(I).GT.0) THEN
+            proc_block_flops = proc_block_flops
+     &           + dble(2*(RHS_BOUNDS(2*I) - RHS_BOUNDS(2*I-1) +1))
+     &           * dble(CMUMPS_LOCAL_FACTOR_SIZE(IW, LIW,
+     &             PTRIST(I)+KIXSZ, 
+     &             PHASE,LDLT,I.EQ.SK38))
+          END IF
+        END IF
+       END DO
+       IF(MYID.EQ.MASTER) THEN
+          ALLOCATE(proc_flops_buf(SIZE_IPTR_WORKING-1),stat=allocok)
+          IF(allocok.GT.0) THEN
+             WRITE(6,*)'Allocation problem of proc_flops_buf'
+     &            ,' in CMUMPS_PROPAGATE_RHS_BOUNDS'
+             CALL MUMPS_ABORT()
+          ENDIF
+          proc_flops_buf=0.0d0
+       ELSE 
+          ALLOCATE(proc_flops_buf(1),stat=allocok)
+          IF(allocok.GT.0) THEN
+             WRITE(6,*)'Allocation problem of proc_flops_buf'
+     &            ,' in CMUMPS_PROPAGATE_RHS_BOUNDS'
+             CALL MUMPS_ABORT()
+          ENDIF
+          proc_flops_buf=0.0d0
+       END IF
+       CALL MPI_GATHER(proc_block_flops, 1, MPI_DOUBLE_PRECISION,
+     &       proc_flops_buf, 1, MPI_DOUBLE_PRECISION,
+     &       0, COMM, IERR)
+       CALL MPI_REDUCE(proc_block_flops, block_flops, 1,
+     &  MPI_DOUBLE_PRECISION, MPI_SUM, 0, COMM, IERR)  
+       IF(MYID.EQ.MASTER) THEN                         
+        nb_sparse_flops = nb_sparse_flops+block_flops
+        avg_load = sum(proc_flops_buf)/dble(NPROCS)
+        max_load = maxval(proc_flops_buf)
+        efficiency = 0D0
+        effmax = 0D0
+        DO I=1,NPROCS
+          efficiency= efficiency + (proc_flops_buf(I)-avg_load)**2
+          IF (proc_flops_buf(I)-avg_load.GT.0.0D0) THEN
+            effmax = effmax + (max_load-avg_load)**2
+          ELSE IF (proc_flops_buf(I)-avg_load.LT.0.0D0) THEN
+            effmax = effmax + avg_load**2
+          END IF
+        END DO
+        efficiency = sqrt(efficiency/dble(NPROCS))
+        effmax = sqrt(effmax/dble(NPROCS))
+        IF(effmax.ne.0.0d0) efficiency = efficiency / effmax
+        efficiency = 1.0d0 - efficiency
+        efficiency = efficiency * block_flops 
+        total_efficiency = total_efficiency + efficiency
+        DEALLOCATE(proc_flops_buf)
+       ELSE
+        DEALLOCATE(proc_flops_buf)
+       END IF
+      END IF
+#endif
       RETURN
       END SUBROUTINE CMUMPS_PROPAGATE_RHS_BOUNDS
       INTEGER(8) FUNCTION CMUMPS_LOCAL_FACTOR_SIZE(IW,LIW,PTR,
@@ -340,7 +476,7 @@ C
      &            NPIV*(NPIV-1_8)/2_8 + (NROW-NPIV)*NPIV
           ELSE
             CMUMPS_LOCAL_FACTOR_SIZE =
-     &      NPIV*(NPIV+1_8)/2_8 + (LIELL-NPIV)*NPIV
+     &      NPIV*(NPIV-1_8)/2_8 + (LIELL-NPIV)*NPIV
           ENDIF
         ELSE
           CMUMPS_LOCAL_FACTOR_SIZE =
@@ -348,90 +484,13 @@ C
         END IF
       RETURN
       END FUNCTION CMUMPS_LOCAL_FACTOR_SIZE
-      INTEGER(8) FUNCTION CMUMPS_LOCAL_FACTOR_SIZE_BLR(IW,LIW,PTR,
-     &                                LRSTATUS, IWHANDLER,
-     &                                PHASE, LDLT, IS_ROOT)
-      USE CMUMPS_LR_DATA_M
-      USE CMUMPS_LR_TYPE
-        INTEGER, INTENT(IN) :: LIW, PTR, PHASE, LDLT
-        INTEGER, INTENT(IN) :: LRSTATUS, IWHANDLER
-        INTEGER, INTENT(IN) :: IW(LIW)
-        LOGICAL, INTENT(IN) :: IS_ROOT
-        INTEGER(8) :: NPIV, NROW, FACTOR_SIZE
-        INTEGER :: NB_PANELS, IPANEL, LorU, IBLOCK
-        LOGICAL :: LR_ACTIVATED
-        TYPE(LRB_TYPE), POINTER, DIMENSION(:) :: LRB_PANEL
-        NROW  = int(IW(PTR+2),8)
-        NPIV  = int(IW(PTR+3),8)
-        LR_ACTIVATED=(LRSTATUS.GE.2)
-        IF (LR_ACTIVATED) THEN
-          FACTOR_SIZE = 0_8
-          CALL CMUMPS_BLR_RETRIEVE_NB_PANELS(IWHANDLER, NB_PANELS)
-          IF (LDLT.EQ.0) THEN 
-            LorU = PHASE
-          ELSE
-            LorU = 0
-          ENDIF
-          DO IPANEL=1,NB_PANELS
-            IF (IS_ROOT.AND.IPANEL.EQ.NB_PANELS) THEN
-              CYCLE
-            ENDIF
-            IF (CMUMPS_BLR_EMPTY_PANEL_LORU(IWHANDLER, LorU, IPANEL))
-     &        THEN
-              CYCLE
-            ENDIF
-             CALL CMUMPS_BLR_RETRIEVE_PANEL_LORU(IWHANDLER, LorU,
-     &                       IPANEL, LRB_PANEL)
-            IF (size(LRB_PANEL).GT.0) THEN
-              IF (PHASE.EQ.0) THEN
-                FACTOR_SIZE = FACTOR_SIZE + 
-     &            int(LRB_PANEL(1)%N,8)*(int(LRB_PANEL(1)%N,8)-1_8)/2_8
-              ELSE
-                FACTOR_SIZE = FACTOR_SIZE + 
-     &           int(LRB_PANEL(1)%N,8)*(int(LRB_PANEL(1)%N,8)+1_8)/2_8
-              ENDIF
-            ENDIF
-            DO IBLOCK=1,size(LRB_PANEL)
-              IF (LRB_PANEL(IBLOCK)%ISLR) THEN
-                FACTOR_SIZE = FACTOR_SIZE + int(LRB_PANEL(IBLOCK)%K,8)*
-     &            int(LRB_PANEL(IBLOCK)%M+LRB_PANEL(IBLOCK)%M,8)
-              ELSE
-                FACTOR_SIZE = FACTOR_SIZE +
-     &             int(LRB_PANEL(IBLOCK)%M*LRB_PANEL(IBLOCK)%N,8)
-              ENDIF
-            ENDDO
-          ENDDO
-          CMUMPS_LOCAL_FACTOR_SIZE_BLR = FACTOR_SIZE
-        ELSE
-          CMUMPS_LOCAL_FACTOR_SIZE_BLR = 
-     &      CMUMPS_LOCAL_FACTOR_SIZE(IW, LIW, PTR, PHASE, LDLT, IS_ROOT)
-        ENDIF
-      RETURN
-      END FUNCTION CMUMPS_LOCAL_FACTOR_SIZE_BLR
-      SUBROUTINE CMUMPS_TREE_PRUN_NODES_STATS(MYID, N, KEEP28, KEEP201,
-     &           FR_FACT,
-     &           STEP, Pruned_List, nb_prun_nodes, OOC_FCT_TYPE_LOC)
-      INTEGER, intent(in) :: KEEP28, KEEP201, OOC_FCT_TYPE_LOC, MYID, N
-      INTEGER(8), intent(in) :: FR_FACT
-      INTEGER, intent(in) :: nb_prun_nodes
-      INTEGER, intent(in) :: Pruned_List(nb_prun_nodes)
-      INTEGER, intent(in) :: STEP(N)
-      INTEGER I, ISTEP
-      INTEGER(8) :: Pruned_Size
-      IF (KEEP201 .GT. 0) THEN
-        Pruned_Size = 0_8
-        DO I = 1, nb_prun_nodes
-          ISTEP = STEP(Pruned_List(I))
-          Pruned_Size = Pruned_Size + SIZE_OF_BLOCK
-     &                  (ISTEP, OOC_FCT_TYPE_LOC)
-        ENDDO
-        PRUNED_SIZE_LOADED = PRUNED_SIZE_LOADED +Pruned_Size
-      ENDIF
-      RETURN
-      END SUBROUTINE CMUMPS_TREE_PRUN_NODES_STATS
       SUBROUTINE CMUMPS_CHAIN_PRUN_NODES_STATS
      &                (MYID, N, KEEP28, KEEP201, KEEP485, FR_FACT,
      &                STEP, Pruned_List, nb_prun_nodes, OOC_FCT_TYPE_LOC
+#     if defined(STAT_ES_SOLVE)
+     &                , NRHS, COMM, IW, LIW, PTRIST, KIXSZ, PHASE,
+     &                  LDLT, K38
+#endif     
      & )
       IMPLICIT NONE
       INTEGER, intent(in) :: KEEP28, KEEP201, OOC_FCT_TYPE_LOC, N,
@@ -440,24 +499,203 @@ C
       INTEGER, intent(in) :: nb_prun_nodes, MYID
       INTEGER, intent(in) :: Pruned_List(nb_prun_nodes)
       INTEGER, intent(in) :: STEP(N)
+#if defined(STAT_ES_SOLVE)
+      INTEGER, INTENT(IN):: LIW, COMM, NRHS, LDLT, K38
+      INTEGER, INTENT(IN):: IW(LIW), PTRIST(KEEP28), KIXSZ, PHASE  
+      DOUBLE PRECISION :: proc_block_flops, block_flops
+      INTEGER(8) :: Pruned_Size_ic 
+      INTEGER :: IERR
+      INTEGER :: SK38 
+#endif
       INCLUDE 'mpif.h'
       INTEGER I, ISTEP
       INTEGER(8) :: Pruned_Size
+#if defined(STAT_ES_SOLVE)
+      Pruned_Size_ic = 0_8
+#endif
       Pruned_Size = 0_8
+#if defined(STAT_ES_SOLVE)
+      IF (K38 .GT. 0) THEN
+        SK38 = STEP(K38)
+      ELSE
+        SK38 = 0
+      END IF
+#endif
       DO I = 1, nb_prun_nodes
         ISTEP = STEP(Pruned_List(I))
         IF (KEEP201 .GT. 0) THEN
             Pruned_Size = Pruned_Size + SIZE_OF_BLOCK
      &                    (ISTEP, OOC_FCT_TYPE_LOC)
         ENDIF
+#if       defined(STAT_ES_SOLVE)
+          IF (PTRIST(ISTEP) .GT. 0) THEN
+            Pruned_Size_ic = Pruned_Size_ic + 
+     &               CMUMPS_LOCAL_FACTOR_SIZE(IW, LIW,
+     &               PTRIST(ISTEP)+KIXSZ, 
+     &               PHASE, LDLT,
+     &               ISTEP.EQ.SK38)
+          ENDIF
+#         endif
       ENDDO
-      IF (KEEP201.GT.0) THEN
-        IF (FR_FACT .NE. 0_8) THEN
-          PRUNED_SIZE_LOADED = PRUNED_SIZE_LOADED +Pruned_Size
-        ENDIF
-      ENDIF
+#if defined(STAT_ES_SOLVE)
+      proc_block_flops = dble(2_8*Pruned_Size_ic)*dble(NRHS)
+      CALL MPI_REDUCE(proc_block_flops, block_flops, 1,
+     & MPI_DOUBLE_PRECISION, MPI_SUM, 0, COMM, IERR)
+      IF(MYID.EQ.0) nb_flops = nb_flops + block_flops
+#endif
       RETURN
       END SUBROUTINE CMUMPS_CHAIN_PRUN_NODES_STATS
+#if   defined(STAT_ES_SOLVE)
+      SUBROUTINE CMUMPS_SOL_ES_PRINT_STATS(
+     &                  K212, K235, K237, K485, K497, NZLU8,
+     &                  NRHS, ICNTL27, N, K50, DKEEPS, RINFOGS, MPG)
+      IMPLICIT NONE
+      INTEGER, intent(in)    ::  K212, K235, K237, K485, K497, 
+     &                           NRHS, MPG, ICNTL27, N, K50
+      INTEGER(8), intent(in) :: NZLU8
+      REAL, intent(out)    :: DKEEPS(5), RINFOGS(5)
+      LOGICAL              :: AM1, ES_FWD, ES_BWD, DO_NBSPARSE
+      IF (MPG.LE.0) RETURN
+      AM1         = (K237 .NE. 0)
+      ES_FWD      = (K235 .NE. 0) .AND. (.NOT. AM1)
+      ES_BWD      = (K212 .NE. 0) .AND. (.NOT. AM1)
+      DO_NBSPARSE = (K497.NE.0).AND.(NRHS.GT.1).AND.(ICNTL27.GT.1)
+      IF (AM1) 
+     & WRITE(MPG,'(/A)') ' ** FLOPS SUMMARY during SOLVE AM1 ** '
+      IF ((ES_FWD).AND. (.NOT.ES_BWD)) 
+     & WRITE(MPG,'(/A,A)') ' ** FLOPS SUMMARY during fwd step',
+     &                  ' (exploit RHS sparsity) ** '
+      IF ((.NOT.ES_FWD).AND. (ES_BWD))
+     & WRITE(MPG,'(/A,A)') ' ** FLOPS SUMMARY during bwd step',
+     &                  ' (selected entries in solution) ** '
+      IF ((ES_FWD).AND. (ES_BWD)) 
+     & WRITE(MPG,'(/A,/A)') 
+     & ' ** FLOPS SUMMARY during SOLVE (fwd+bwd steps)',
+     & '    (sparse RHS and selected entries in solution) **'
+      IF (
+     &     (ES_FWD) .AND. (.NOT.ES_BWD)
+     &    .OR.
+     &     (.NOT.ES_FWD) .AND. (ES_BWD)
+     &   ) THEN
+       IF (K50.NE.0) THEN
+         DKEEPS(1)=(real(NZLU8)-real(N))*real(2*NRHS)
+       ELSE
+         DKEEPS(1)=(real(NZLU8)-real(N))*real(NRHS)
+       ENDIF
+      ELSE IF ((ES_FWD).AND.(ES_BWD)) THEN
+       IF (K50.NE.0) THEN
+         DKEEPS(1) = (real(NZLU8)-real(N))*real(4*NRHS)
+       ELSE
+         DKEEPS(1)=(real(NZLU8)-real(N))*real(2*NRHS)
+       ENDIF
+      ENDIF
+      RINFOGS(1) = DKEEPS(1)
+      IF (.NOT.AM1) THEN
+       WRITE(MPG,'(A,F25.1)') 
+     & ' RINFOG(24) FLOPS with dense full rank format  =', DKEEPS(1)
+      ENDIF
+      DKEEPS(2)=real(nb_flops) 
+      IF (DO_NBSPARSE) DKEEPS(4)=real(nb_sparse_flops)
+      IF (DO_NBSPARSE) THEN
+       RINFOGS(2)= DKEEPS(4)
+      ELSE
+       RINFOGS(2)= DKEEPS(2)
+      ENDIF
+      WRITE(MPG,'(A,F25.1)') 
+     & ' RINFOG(25) FLOPS with exploit sparsity (ES)   =', RINFOGS(2)
+      RETURN
+      END SUBROUTINE CMUMPS_SOL_ES_PRINT_STATS
+#endif
+      SUBROUTINE CMUMPS_ES_GET_SUM_Nloc (
+     &           N, Nloc_ITAB, ITAB_loc, COMM,
+     &           SUM_idNloc_8 )
+      IMPLICIT NONE
+      INTEGER, INTENT(IN)  :: N
+#if defined(MUMPS_NOF2003)
+        INTEGER, POINTER :: ITAB_loc (:)
+#else
+        INTEGER, INTENT( IN ), POINTER :: ITAB_loc (:)
+#endif
+      INTEGER, INTENT(IN)  :: Nloc_ITAB
+      INTEGER, INTENT(IN)  :: COMM
+      INTEGER(8)   :: SUM_idNloc_8
+      INCLUDE 'mpif.h'
+      INTEGER I, II, IERR_MPI 
+      INTEGER(8) :: idNloc_8
+      idNloc_8 = 0_8
+      DO I= 1, Nloc_ITAB
+          II = ITAB_loc(I)
+          IF (II.GE.1 .and. II.LE.N) 
+     &    idNloc_8 = idNloc_8 + 1_8
+      ENDDO
+      CALL MPI_ALLREDUCE (idNloc_8, SUM_idNloc_8, 1, 
+     &                  MPI_INTEGER8,
+     &                  MPI_SUM, COMM, IERR_MPI )
+      RETURN
+      END SUBROUTINE CMUMPS_ES_GET_SUM_Nloc
+      SUBROUTINE CMUMPS_ES_NODES_SIZE_AND_FILL (
+     &           fill, 
+     &           N, NSTEPS, KEEP, STEP, Step2node,
+     &           ITAB_loc, Nloc_ITAB, 
+     &           MYID, COMM,
+     &           Pruned_Sons, Lnodes_ITAB
+#if defined(AVOID_MPI_IN_PLACE)
+     &           , TMP_INT_ARRAY
+#endif
+     &           , nodes_ITAB
+     &           )
+      IMPLICIT NONE
+      LOGICAL, INTENT(IN)  :: fill
+      INTEGER, INTENT(IN)  :: N, NSTEPS, KEEP(500) 
+      INTEGER, INTENT(IN)  :: Nloc_ITAB
+      INTEGER, INTENT(IN)  :: STEP(N), Step2node(NSTEPS), 
+     &                        ITAB_loc(max(1,Nloc_ITAB))
+      INTEGER, INTENT(IN)  :: MYID, COMM
+#if defined(AVOID_MPI_IN_PLACE)
+      INTEGER              :: TMP_INT_ARRAY(NSTEPS) 
+#endif
+      INTEGER, INTENT(INOUT) :: Pruned_Sons(NSTEPS), Lnodes_ITAB
+      INTEGER, OPTIONAL, INTENT(OUT) :: nodes_ITAB(max(1,Lnodes_ITAB))
+      INCLUDE 'mpif.h'
+      INTEGER I, II, ISTEP, IERR_MPI, Lnodes_ITAB_loc, INODE_PRINC
+      IF (.NOT.fill) THEN
+        Pruned_SONS = 0
+        DO I= 1, Nloc_ITAB
+          II = ITAB_loc(I)
+          IF (II.GE.1 .and. II.LE.N) THEN
+            ISTEP = abs(STEP(II))
+            IF ( Pruned_SONS(ISTEP) .eq. 0 ) THEN
+              Pruned_SONS(ISTEP) = 1
+            ENDIF
+           ENDIF
+        ENDDO
+#if defined(AVOID_MPI_IN_PLACE)
+        TMP_INT_ARRAY = Pruned_Sons
+#endif
+        CALL MPI_ALLREDUCE(
+#if defined(AVOID_MPI_IN_PLACE)
+     &         TMP_INT_ARRAY, 
+#else
+     &         MPI_IN_PLACE,
+#endif
+     &         Pruned_Sons, NSTEPS, 
+     &         MPI_INTEGER, MPI_SUM, COMM, IERR_MPI)
+        Lnodes_ITAB = 0
+        DO ISTEP=1,NSTEPS
+          if (Pruned_SONS(ISTEP) .NE.0) Lnodes_ITAB=Lnodes_ITAB+1
+        ENDDO
+      ELSE IF (Lnodes_ITAB.GT.0) THEN
+        Lnodes_ITAB_loc = 0
+        DO ISTEP=1,NSTEPS
+          if (Pruned_SONS(ISTEP) .GT. 0) then
+            Lnodes_ITAB_loc=Lnodes_ITAB_loc+1
+            INODE_PRINC = Step2node( ISTEP )
+            nodes_ITAB(Lnodes_ITAB_loc)  = INODE_PRINC
+          endif
+        ENDDO
+      ENDIF
+      RETURN
+      END SUBROUTINE CMUMPS_ES_NODES_SIZE_AND_FILL
       END MODULE CMUMPS_SOL_ES
       SUBROUTINE CMUMPS_PERMUTE_RHS_GS
      &          (LP, LPOK, PROKG, MPG, PERM_STRAT, 
diff -pruN 5.6.2-2.1/src/cmumps_struc_def.F 5.7.1-1/src/cmumps_struc_def.F
--- 5.6.2-2.1/src/cmumps_struc_def.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/cmumps_struc_def.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/comp_tps_m.F 5.7.1-1/src/comp_tps_m.F
--- 5.6.2-2.1/src/comp_tps_m.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/comp_tps_m.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/cooc_panel_piv.F 5.7.1-1/src/cooc_panel_piv.F
--- 5.6.2-2.1/src/cooc_panel_piv.F	2023-10-11 09:37:10.000000000 +0000
+++ 5.7.1-1/src/cooc_panel_piv.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/crank_revealing.F 5.7.1-1/src/crank_revealing.F
--- 5.6.2-2.1/src/crank_revealing.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/crank_revealing.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -15,6 +15,25 @@ C
       IMPLICIT NONE
           INTEGER N, KEEP(500), ICNTL(60), MPG
           KEEP(19)=0
+          KEEP(19)=ICNTL(56)
+          IF ((KEEP(19).LT.1).OR.(KEEP(19).GE.2)) KEEP(19)=0
+          IF ( KEEP(53) .LE. 0 .and.
+     &         KEEP(19) .NE. 0 ) THEN
+             KEEP(19) = 0
+             IF ( MPG .GT. 0 ) THEN
+      WRITE( MPG,'(A)') '** Warning:  ICNTL(56) null space option'
+      WRITE( MPG,'(A)') '** disabled (incompatibility with analysis)'
+             END IF
+          END IF
+          KEEP(21) = min(ICNTL(57),N)
+          KEEP(22) = max(ICNTL(55),0)
+          IF ( KEEP(19) .ne. 0 .and. KEEP(60) .ne. 0 ) THEN
+             IF ( MPG .GT. 0 ) THEN
+      WRITE( MPG,'(A)') '** Warning: ICNTL(56)  null space option'
+      WRITE( MPG,'(A)') '** disabled (incompatibility with Schur)'
+             END IF
+            KEEP(19) = 0
+          END IF
           RETURN
       END SUBROUTINE CMUMPS_GET_NS_OPTIONS_FACTO
       SUBROUTINE CMUMPS_GET_NS_OPTIONS_SOLVE(ICNTL, KEEP, 
@@ -144,3 +163,522 @@ C
       ENDIF
       RETURN
       END SUBROUTINE CMUMPS_RR_FREE_POINTERS
+      SUBROUTINE CMUMPS_SEQ_SYMMETRIZE(N,A)
+      INTEGER N
+      COMPLEX A( N, N )
+      INTEGER I,J
+      DO I = 2, N
+        DO J = 1, I - 1
+          A( I, J ) = A( J, I )
+        END DO
+      END DO
+      RETURN
+      END SUBROUTINE CMUMPS_SEQ_SYMMETRIZE
+      SUBROUTINE CMUMPS_UXVSBP(N,PERM,X,RN01)
+      INTEGER N,PERM(N),I
+      COMPLEX RN01(N),X(N)
+      DO I=1,N
+        RN01(PERM(I))=X(I)
+      ENDDO
+      DO I=1,N
+        X(I)=RN01(I)
+      ENDDO
+      RETURN
+      END SUBROUTINE CMUMPS_UXVSBP
+      SUBROUTINE CMUMPS_UXVSFP(N,PERM,X,RN01)
+      INTEGER N,PERM(N),I
+      COMPLEX RN01(N),X(N)
+      DO I=1,N
+        RN01(I)=X(PERM(I))
+      ENDDO
+      DO I=1,N
+        X(I)=RN01(I)
+      ENDDO
+      RETURN
+      END SUBROUTINE CMUMPS_UXVSFP
+      SUBROUTINE CMUMPS_SVD_QR_ESTIM_WK( PHASE, MBLOCK, NBLOCK, 
+     &           SIZE_ROOT_ARG,
+     &           LOCAL_M, LOCAL_N, ROOT_OWNER, KEEP,KEEP8,
+     &           LIWK_RR, LWK_RR )
+      IMPLICIT NONE
+      INTEGER, INTENT(IN) :: PHASE, SIZE_ROOT_ARG
+      INTEGER, INTENT(IN) :: MBLOCK, NBLOCK, LOCAL_M, LOCAL_N
+      LOGICAL, INTENT(IN) :: ROOT_OWNER
+      INTEGER, INTENT(IN) :: KEEP(500)
+      INTEGER(8), INTENT(IN) :: KEEP8(150)
+      INTEGER, INTENT(OUT):: LIWK_RR
+      INTEGER(8), INTENT(OUT):: LWK_RR
+      INTEGER SIZE_ROOT
+      INTEGER NBPOSPONED_ESTIM
+      PARAMETER (NBPOSPONED_ESTIM=2000)
+      INTEGER SVD_QR,PAR_ROOT
+      SVD_QR = KEEP(19)
+      PAR_ROOT = KEEP(38)
+      LIWK_RR = 0
+      LWK_RR = 0_8
+      IF (PAR_ROOT.EQ.0) THEN
+         IF(ROOT_OWNER) THEN
+           IF (PHASE.EQ.0) THEN
+                  SIZE_ROOT=SIZE_ROOT_ARG+NBPOSPONED_ESTIM
+           ELSE
+                  SIZE_ROOT=SIZE_ROOT_ARG
+           ENDIF
+           IF(SVD_QR.EQ.1) THEN
+              LWK_RR=int(3*SIZE_ROOT+1,8)
+           ELSEIF(SVD_QR.EQ.2) THEN
+              LWK_RR=int(SIZE_ROOT+1,8)
+           END IF
+         END IF
+      ENDIF
+      RETURN
+      END SUBROUTINE CMUMPS_SVD_QR_ESTIM_WK
+      SUBROUTINE CMUMPS_SEQ_FACTO_ROOT_SVD_QR
+     &(NN,A,ROOT,WR03,LWR03,KEEP,KEEP8,INFO,LP,DKEEP,
+     & GLOBK109,OPELIW,PIVNUL_LIST,LPIVNUL_LIST,
+     & ROW_INDICES)
+      USE CMUMPS_STRUC_DEF, ONLY : CMUMPS_ROOT_STRUC
+      IMPLICIT NONE
+      TYPE ( CMUMPS_ROOT_STRUC ) :: ROOT
+      INTEGER :: NN,LP,LWR03,LWR03_MINSIZE
+      COMPLEX :: A(NN*NN)
+      INTEGER :: INFO(2),KEEP(500)
+      INTEGER(8) :: KEEP8(150)
+      REAL :: DKEEP(230)
+      DOUBLE PRECISION :: OPELIW
+      INTEGER :: GLOBK109
+      INTEGER :: LPIVNUL_LIST
+      INTEGER :: PIVNUL_LIST(LPIVNUL_LIST)
+      INTEGER :: ROW_INDICES(NN)
+      COMPLEX :: WR03(LWR03)
+      INTEGER LDLT,DEFICIENCY
+      REAL, DIMENSION(:), ALLOCATABLE :: RWORK
+      INTEGER :: I,LDA,LDU,LDVT,J
+      INTEGER :: IERR, LAST_BEFORE_GAP_IND
+      INTEGER :: LAST_BEFORE_GAPLIMIT_IND, FIRST_AFTER_MinPiv, 
+     &           FIRST_AFTER_GAPLIMIT, START_POINT, END_POINT 
+      INTEGER :: ALLOCOK,MAXDEF,MINDEF
+      REAL :: EPS, ZERO, GAPLIMIT, MaxGap, MaxGap1,
+     &        MinPiv, Tol_MaxGap
+      PARAMETER(ZERO=0.0E0)
+      EPS = epsilon(ZERO)
+      LDLT=KEEP(50)
+      IF ((KEEP(19) .NE. 1).AND.(KEEP(19) .NE. 2)) THEN
+        INFO(1)=-107
+        INFO(2)= KEEP(19)
+        IF ( LP .GT. 0 ) THEN
+            WRITE(LP,*) " *** Option ",KEEP(19),
+     &           " for null space no more available."
+        ENDIF  
+        GOTO 100
+      ENDIF
+      IF(KEEP(19).EQ.1) THEN
+              LWR03_MINSIZE=3*NN+1
+      ELSEIF(KEEP(19).EQ.2) THEN
+              LWR03_MINSIZE=NN+1
+      END IF
+      MAXDEF=KEEP(21)
+      IF ( MAXDEF .LE. 0 ) THEN
+        MAXDEF = NN
+      ELSE
+        MAXDEF = max(MAXDEF - GLOBK109,0)
+      ENDIF
+      MINDEF = max(KEEP(22) - GLOBK109,0)
+      MINDEF = min(MINDEF,NN)
+      MAXDEF = min(MAXDEF,NN)
+      IF(KEEP(19).EQ.1) THEN
+         OPELIW = OPELIW + dble(26)*dble(NN)*dble(NN)*dble(NN)
+      ELSEIF(KEEP(19).EQ.2) THEN
+         OPELIW = OPELIW +  dble(4)*dble(NN)*dble(NN)*dble(NN)/dble(3)
+      ENDIF
+      IF (associated(ROOT%SINGULAR_VALUES)) 
+     &     DEALLOCATE(ROOT%SINGULAR_VALUES)
+      NULLIFY(ROOT%SINGULAR_VALUES)
+      ROOT%NB_SINGULAR_VALUES=NN
+      ALLOCATE(ROOT%SINGULAR_VALUES(NN), stat=ALLOCOK)
+      IF (ALLOCOK.GT.0) THEN
+         INFO(1)=-13
+         INFO(2)=NN
+         IF ( LP .GT. 0 )
+     &        WRITE(LP,*) 'CMUMPS_SEQ_FACTO_ROOT_SVD_QR: Problem '
+     &        //'allocating SINGULAR_VALUES'
+         GOTO 100
+      END IF
+      IF(KEEP(19).EQ.1) THEN     
+         IF(associated(ROOT%SVD_U)) DEALLOCATE(ROOT%SVD_U)
+         NULLIFY(ROOT%SVD_U)
+         ALLOCATE(ROOT%SVD_U(NN,NN),stat=ALLOCOK )
+         IF(ALLOCOK.GT.0) THEN
+            INFO(1)=-13
+            INFO(2)=NN*NN
+            IF ( LP .GT. 0 )
+     &           WRITE(LP,*) 'CMUMPS_SEQ_FACTO_ROOT_SVD_QR: Problem '
+     &           //'allocating SVD_U'
+            GOTO 100
+         END IF
+         IF (associated(ROOT%SVD_VT)) DEALLOCATE(ROOT%SVD_VT)
+         NULLIFY(ROOT%SVD_VT)
+         ALLOCATE(ROOT%SVD_VT(NN,NN), stat=ALLOCOK)
+         IF (ALLOCOK.GT.0) THEN
+            INFO(1)=-13
+            INFO(2)=NN*NN
+            IF ( LP .GT. 0 )
+     &           WRITE(LP,*) 'CMUMPS_SEQ_FACTO_ROOT_SVD_QR: Problem '
+     &           //'allocating SVD_VT'
+            GOTO 100
+         END IF
+         IF (allocated(RWORK)) DEALLOCATE(RWORK)
+         ALLOCATE(RWORK(5*NN), stat=ALLOCOK)
+         IF (ALLOCOK.GT.0) THEN
+            INFO(1)=-13
+            INFO(2)=5*NN
+            IF ( LP .GT. 0 )
+     &           WRITE(LP,*) 
+     &           'CMUMPS_SEQ_FACTO_ROOT_SVD_QR: Problem '
+     &           //'allocating RWORK'
+            GOTO 100
+         END IF
+      ELSEIF(KEEP(19).EQ.2) THEN
+         IF (associated(ROOT%QR_TAU)) DEALLOCATE(ROOT%QR_TAU)
+         NULLIFY(ROOT%QR_TAU)
+         ALLOCATE(ROOT%QR_TAU(NN), stat=ALLOCOK)
+         IF (ALLOCOK.GT.0) THEN
+            INFO(1)=-13
+            INFO(2)=NN
+            IF ( LP .GT. 0 )
+     &           WRITE(LP,*) 
+     &           'CMUMPS_SEQ_FACTO_ROOT_SVD_QR: Problem '
+     &           //'allocating QR_TAU'
+            GOTO 100
+         END IF
+         IF (associated(ROOT%IPIV)) DEALLOCATE(ROOT%IPIV)
+         NULLIFY(ROOT%IPIV)
+         ALLOCATE(ROOT%IPIV(NN), stat=ALLOCOK)
+         IF (ALLOCOK.GT.0) THEN
+            INFO(1)=-13
+            INFO(2)=NN
+            IF ( LP .GT. 0 )
+     &           WRITE(LP,*) 
+     &           'CMUMPS_SEQ_FACTO_ROOT_SVD_QR: Problem '
+     &           //'allocating IPIV'
+            GOTO 100
+         END IF
+         IF (allocated(RWORK)) DEALLOCATE(RWORK)
+         ALLOCATE(RWORK(2*NN), stat=ALLOCOK)
+         IF (ALLOCOK.GT.0) THEN
+            INFO(1)=-13
+            INFO(2)=2*NN
+            IF ( LP .GT. 0 )
+     &           WRITE(LP,*) 
+     &           'CMUMPS_SEQ_FACTO_ROOT_SVD_QR: Problem '
+     &           //'allocating RWORK'
+            GOTO 100
+         END IF
+      ENDIF
+      IF (LDLT.NE.0) THEN
+         CALL CMUMPS_SEQ_SYMMETRIZE(NN,A)
+      END IF
+      LDA=NN
+      LDU=NN
+      LDVT=NN
+      IERR = 0
+      IF(KEEP(19).EQ.1) THEN
+         CALL cgesvd('A','A',NN,NN,A,LDA,ROOT%SINGULAR_VALUES(1)
+     &        ,ROOT%SVD_U(1,1)
+     &        ,LDU,ROOT%SVD_VT(1,1),LDVT,WR03,LWR03,RWORK,IERR)
+      ENDIF
+      IF(IERR.NE.0) THEN
+         INFO(1)=-107
+         INFO(2)=IERR
+         IF (LP.GT.0) THEN
+            IF(KEEP(19).EQ.1) THEN
+               WRITE(LP,*) ' Problem in cgesvd : IERR = ', IERR
+            ELSEIF(KEEP(19).EQ.2) THEN
+               WRITE(LP,*) ' Problem in cgeqpf : IERR = ', IERR
+            ENDIF
+           GOTO 100
+         END IF
+      ENDIF
+      IF(KEEP(19).EQ.2) THEN
+         DO I=1,NN
+            ROOT%SINGULAR_VALUES(I)=abs(A(I+NN*(I-1)))
+         ENDDO
+      ENDIF
+      DEFICIENCY=0
+      MinPiv = DKEEP(20)
+      GAPLIMIT = DKEEP(9)
+      IF (ROOT%SINGULAR_VALUES(NN).GT.MinPiv) THEN
+              DEFICIENCY = 0
+              GOTO 170
+      ENDIF
+      IF (ROOT%SINGULAR_VALUES(1).LE.GAPLIMIT) THEN
+           DEFICIENCY = NN
+           GOTO 170
+      ENDIF
+      LAST_BEFORE_GAPLIMIT_IND = 0
+      LAST_BEFORE_GAP_IND  = 0
+      FIRST_AFTER_MinPiv   = 0
+      FIRST_AFTER_GAPLIMIT = 0
+      MaxGap  = 0
+      MaxGap1 = 0
+      Tol_MaxGap = DKEEP(24)
+      DO I=NN,1,-1
+              IF (FIRST_AFTER_MinPiv.GT.0)  exit   
+         IF(ROOT%SINGULAR_VALUES(I).LE.GAPLIMIT) THEN
+                  LAST_BEFORE_GAPLIMIT_IND = I
+         ELSE IF  ((FIRST_AFTER_GAPLIMIT.EQ.0).AND.
+     &               (ROOT%SINGULAR_VALUES(I).LE.MinPiv)) THEN
+                 FIRST_AFTER_GAPLIMIT = I
+         ELSE IF (ROOT%SINGULAR_VALUES(I).GT.MinPiv) THEN
+                 FIRST_AFTER_MinPiv = I
+                 IF (FIRST_AFTER_GAPLIMIT.EQ.0) FIRST_AFTER_GAPLIMIT = I
+         ENDIF
+      ENDDO
+      START_POINT = LAST_BEFORE_GAPLIMIT_IND
+      IF ((LAST_BEFORE_GAPLIMIT_IND.EQ.0).AND.
+     &    (FIRST_AFTER_GAPLIMIT.GT. FIRST_AFTER_MinPiv)) 
+     &               START_POINT = FIRST_AFTER_GAPLIMIT
+      END_POINT = FIRST_AFTER_MinPiv
+      IF (FIRST_AFTER_MinPiv.EQ.0) END_POINT = 1
+      DO I=START_POINT,END_POINT+1,-1
+          IF (ROOT%SINGULAR_VALUES(I).EQ.0) THEN
+             LAST_BEFORE_GAP_IND = I
+          ELSE
+              MaxGap1 = ROOT%SINGULAR_VALUES(I-1)*
+     &                                    (1/ROOT%SINGULAR_VALUES(I))
+             IF (MaxGap1.GE. Tol_MaxGap) THEN
+                  IF (MaxGap1.GE. DKEEP(25)*MaxGap ) THEN 
+                     LAST_BEFORE_GAP_IND = I
+                     MaxGap =  MaxGap1
+                  ENDIF  
+             ENDIF  
+          ENDIF
+      ENDDO
+      IF (MaxGap.EQ.ZERO) THEN        
+          IF (LAST_BEFORE_GAPLIMIT_IND.EQ.0) THEN
+               DEFICIENCY = 0
+          ELSE
+               DEFICIENCY = NN - LAST_BEFORE_GAPLIMIT_IND +1  
+          ENDIF
+      ELSE
+          DEFICIENCY = NN - LAST_BEFORE_GAP_IND +1  
+      ENDIF 
+ 170  CONTINUE
+      DEFICIENCY=min(DEFICIENCY,MAXDEF)
+      DEFICIENCY=max(DEFICIENCY,MINDEF)      
+      KEEP(17)=DEFICIENCY
+      IF(KEEP(19).EQ.2) THEN
+         IF(DEFICIENCY.GT.0) THEN
+            CALL ctrtrs('U','N','N',NN-DEFICIENCY,DEFICIENCY,
+     &           A,LDA,A(LDA*(NN-DEFICIENCY)+1),LDA,IERR)
+            IF ( IERR .NE. 0 ) THEN
+               IF (LP.GT.0) 
+     &         WRITE(LP,*) ' Internal error in ctrtrs: IERR = ',IERR
+               CALL MUMPS_ABORT()
+            END IF
+         END IF
+      ENDIF
+      DO J=NN-DEFICIENCY+1, NN
+         IF(KEEP(19).EQ.1) THEN
+            PIVNUL_LIST(J-NN+DEFICIENCY) = ROW_INDICES(J)
+         ELSEIF(KEEP(19).EQ.2) THEN
+            PIVNUL_LIST(J-NN+DEFICIENCY) = ROW_INDICES(ROOT%IPIV(J))
+         ENDIF
+      ENDDO
+ 100  CONTINUE     
+      IF (allocated(RWORK)) DEALLOCATE(RWORK)
+      RETURN
+      END SUBROUTINE CMUMPS_SEQ_FACTO_ROOT_SVD_QR
+      SUBROUTINE CMUMPS_SEQ_SOLVE_ROOT_SVD_QR
+     &  (NRHS,NN,A,ROOT,
+     &   IBEG_ROOT_DEF, IEND_ROOT_DEF,
+     &   RHS,KEEP,KEEP8,MTYPE,INFO,LWK8,WK, LP)
+      USE CMUMPS_STRUC_DEF, ONLY : CMUMPS_ROOT_STRUC
+      IMPLICIT NONE
+      INTEGER NN, NRHS
+      INTEGER(8), INTENT(IN) :: LWK8
+      TYPE ( CMUMPS_ROOT_STRUC ) :: root
+      COMPLEX A(NN*NN)
+      INTEGER IBEG_ROOT_DEF, IEND_ROOT_DEF, MTYPE
+      INTEGER INFO(2),KEEP(500)
+      INTEGER(8) KEEP8(150)
+      COMPLEX RHS(NN,NRHS), WK(LWK8)
+      INTEGER LP
+      INTEGER :: LWK
+      COMPLEX,DIMENSION(:,:), allocatable :: TEMP_RHS
+      INTEGER :: I,IERR,K
+      INTEGER :: LDLT,RRSTRAT,DEFICIENCY,LDA,LDRHS
+      INTEGER :: ALLOCOK
+      REAL, PARAMETER    :: RONE=1.0E+0
+      COMPLEX ZERO, ONE, MINUSONE
+      PARAMETER( ZERO = (0.0E0,0.0E0), ONE = (1.0E0,0.0E0))
+      PARAMETER( MINUSONE=(-1.0E0,0.0E0))
+      LDLT      = KEEP(50)
+      RRSTRAT   = KEEP(19)
+      DEFICIENCY = KEEP(17)
+      LDA = NN
+      LDRHS = NN
+      LWK = int(min(int(huge(LWK),8),LWK8))
+      IERR = 0
+      IF ((RRSTRAT .NE. 1).AND.(RRSTRAT .NE. 2)) THEN
+         WRITE(*,*) " *** Internal error ption ",RRSTRAT,
+     &        " for null space no more available."
+         CALL MUMPS_ABORT()
+      ENDIF
+      IF (KEEP(111).EQ.0) THEN
+         IF(KEEP(19).EQ.1) THEN
+           IF ((MTYPE.EQ.0).OR.(LDLT.GT.0)) THEN
+               allocate(TEMP_RHS(NN,NRHS), stat=ALLOCOK)
+               IF (ALLOCOK.GT.0) THEN
+                 INFO(1)=-13
+                 INFO(2)=NN*NRHS
+                 IF ( LP .GT. 0 )
+     &              WRITE(LP,*) 
+     &              'CMUMPS_SEQ_SOLVE_ROOT_SVD_QR: Problem '
+     &              //'allocating TEMP_RHS'
+                 RETURN
+               END IF
+               CALL cgemm('Conjugate transpose','N',NN,NRHS,NN,ONE,
+     &              root%SVD_U(1,1),NN,RHS,
+     &              NN,ZERO,TEMP_RHS,NN)
+               DO I=1,NN-DEFICIENCY
+                  TEMP_RHS( I, 1:NRHS ) = 
+     &         cmplx(RONE/root%SINGULAR_VALUES(I),kind=kind(TEMP_RHS))*
+     &                          TEMP_RHS( I, 1:NRHS )
+               ENDDO
+               DO I=NN-DEFICIENCY +1, NN
+                  TEMP_RHS(I, 1:NRHS) = ZERO 
+               ENDDO
+               CALL cgemm('Conjugate transpose','N',NN,NRHS,NN,ONE,
+     &               root%SVD_VT(1,1),NN,
+     &              TEMP_RHS, NN,ZERO,RHS,NN)
+               DEALLOCATE(TEMP_RHS)
+           ELSEIF(MTYPE.EQ.1) THEN
+               allocate(TEMP_RHS(NRHS,NN), stat=ALLOCOK)
+               IF (ALLOCOK.GT.0) THEN
+                  INFO(1)=-13
+                  INFO(2)=NN*NRHS
+                  IF ( LP .GT. 0 )
+     &              WRITE(LP,*) 
+     &              'CMUMPS_SEQ_SOLVE_ROOT_SVD_QR: Problem '
+     &              //'allocating TEMP_RHS'
+                  RETURN
+               END IF
+               CALL cgemm('T','C',NRHS,NN, NN,ONE,RHS, NN, 
+     &               root%SVD_VT(1,1),NN,
+     &              ZERO,TEMP_RHS,NRHS)
+               DO I=1,NN-DEFICIENCY
+                  RHS(I, 1:NRHS ) = 
+     &         cmplx(RONE/root%SINGULAR_VALUES(I),kind=kind(TEMP_RHS))*
+     &                          TEMP_RHS(1:NRHS,I ) 
+               ENDDO
+               DO I=NN-DEFICIENCY +1, NN
+                  RHS(I,1:NRHS) = ZERO 
+               ENDDO
+               CALL cgemm('T','C',NRHS,NN,NN,ONE,RHS, NN, 
+     &             root%SVD_U(1,1),NN,
+     &             ZERO,TEMP_RHS,NRHS)
+                  DO I=1,NRHS
+                  RHS(1:NN,I) =TEMP_RHS(I,1:NN )
+                  ENDDO
+                 DEALLOCATE(TEMP_RHS)
+            ENDIF
+         ELSEIF(KEEP(19).EQ.2) THEN
+            IF ((MTYPE.EQ.0).OR.(LDLT.GT.0)) THEN
+               CALL cunmqr('L','Conjugate transpose',NN,NRHS,NN,
+     &              A,LDA,root%QR_TAU(1),
+     &              RHS,LDRHS,WK(1),LWK,IERR)
+               IF(IERR.LT.0) THEN
+                  WRITE(*,*) 
+     &         'Error return from cunmqr in root solve: IERR=', IERR
+                  RETURN
+               END IF
+               CALL ctrtrs('U','N','N',NN-DEFICIENCY,NRHS,A,LDA,
+     &              RHS,LDRHS,IERR)
+               IF ( IERR .LT. 0 ) THEN
+                  WRITE(*,*) 
+     &         'Error return from ctrtrs in roor solve: IERR =',IERR
+                  RETURN
+               END IF
+               DO I=1,NRHS
+                  RHS( NN - DEFICIENCY + 1: NN, I ) = ZERO  
+               ENDDO
+               DO I=1,NRHS
+                  CALL CMUMPS_UXVSBP(NN,root%IPIV(1),RHS(1,I),WK)
+               ENDDO
+           ELSEIF(MTYPE.EQ.1) THEN
+               DO I=1,NRHS
+                 CALL CMUMPS_UXVSFP(NN,root%IPIV(1),RHS(1,I),WK)
+               ENDDO
+               CALL ctrtrs('U','T','N',NN-DEFICIENCY,NRHS,
+     &              A,LDA,RHS,LDRHS,IERR)
+               IF(IERR.NE.0) THEN
+                  WRITE(*,*) 'Error return from trtrs: IERR=', IERR
+                  STOP    
+               END IF
+               allocate(TEMP_RHS(NRHS,NN), stat=ALLOCOK)
+               IF (ALLOCOK.GT.0) THEN
+                  INFO(1)=-13
+                  INFO(2)=NN*NRHS
+                  IF ( LP .GT. 0 )
+     &              WRITE(LP,*) 
+     &              'CMUMPS_SEQ_SOLVE_ROOT_SVD_QR: Problem '
+     &              //'allocating TEMP_RHS'
+                  RETURN
+               END IF
+               DO I=1,NRHS
+                  TEMP_RHS(I,1:NN-DEFICIENCY)=RHS(1:NN-DEFICIENCY, I)
+               ENDDO
+               DO I=NN - DEFICIENCY + 1,NN
+                  TEMP_RHS( 1: NRHS, I ) = ZERO  
+               ENDDO
+                CALL cunmqr( 'R','Conjugate transpose',NRHS,NN,NN,A,LDA,
+     &              root%QR_TAU(1),
+     &              TEMP_RHS,NRHS,WK,LWK,IERR)
+               IF(IERR.LT.0) THEN
+                  WRITE(*,*) 'Error return from cunmqr: IERR=', IERR
+                  RETURN
+               END IF
+                DO I=1,NRHS
+                  RHS(1:NN, I)= TEMP_RHS(I,1:NN)
+               ENDDO
+               DEALLOCATE(TEMP_RHS)
+            ENDIF
+         ENDIF
+      ELSE
+         IF(KEEP(19).EQ.1) THEN
+           IF ((MTYPE.EQ.0).OR.(LDLT.GT.0)) THEN
+               DO I=IBEG_ROOT_DEF,IEND_ROOT_DEF
+                  RHS(:,I+1-IBEG_ROOT_DEF) = 
+     &                 CONJG(root%SVD_VT(NN-DEFICIENCY+I,:))
+               ENDDO
+           ELSEIF(MTYPE.EQ.1) THEN
+               DO I=IBEG_ROOT_DEF,IEND_ROOT_DEF
+                  RHS(:,I+1-IBEG_ROOT_DEF) = 
+     &               CONJG(root%SVD_U(:,NN-DEFICIENCY+I))
+               ENDDO
+            ENDIF
+         ELSEIF(KEEP(19).EQ.2) THEN
+           IF((MTYPE.EQ.0).OR.(LDLT.GT.0)) THEN        
+               DO I=IBEG_ROOT_DEF,IEND_ROOT_DEF
+                  RHS(NN-DEFICIENCY+I,I-IBEG_ROOT_DEF+1) = MINUSONE
+                  DO K=1,NN-DEFICIENCY
+                     RHS(K,I-IBEG_ROOT_DEF+1)=
+     &                    A(K + LDA*(NN-DEFICIENCY+I-1))
+                  ENDDO
+               ENDDO
+               DO I=1,IEND_ROOT_DEF-IBEG_ROOT_DEF+1
+                  CALL CMUMPS_UXVSBP(NN,root%IPIV(1),RHS(1,I),WK)
+               ENDDO 
+           ELSEIF(MTYPE.EQ.1) THEN
+               WRITE(*,*) 'Computation of a null space basis'
+     &              // ' of A is unavailable for unsymetric matrices'
+            DO I=IBEG_ROOT_DEF,IEND_ROOT_DEF
+               RHS(NN-DEFICIENCY+I,I-IBEG_ROOT_DEF+1) = ONE
+            ENDDO
+            CALL cunmqr('L','N',NN,NRHS,NN, A,LDA,root%QR_TAU(1),
+     &              RHS,LDRHS,WK(1),LWK,IERR)
+            ENDIF
+         ENDIf
+      ENDIF
+      RETURN
+      END SUBROUTINE CMUMPS_SEQ_SOLVE_ROOT_SVD_QR
diff -pruN 5.6.2-2.1/src/csol_aux.F 5.7.1-1/src/csol_aux.F
--- 5.6.2-2.1/src/csol_aux.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/csol_aux.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -307,7 +307,8 @@ C
       COMPLEX W(N), X(N)
       REAL, intent(inout)    :: EST
       INTEGER, intent(in)    :: GRAIN
-      INTRINSIC abs, nint, real, sign
+      INTRINSIC abs, nint, sign
+      INTRINSIC real
       INTEGER CMUMPS_IXAMAX
       EXTERNAL CMUMPS_IXAMAX
       INTEGER ITMAX
@@ -408,7 +409,7 @@ C
       DO 170 I = 1, N
         TEMP = TEMP + abs(X(I))
   170 CONTINUE
-      TEMP = 2.0E0 * TEMP / real(3 * N)
+      TEMP = 2.0E0/3.0E0 * TEMP / real(N)
       IF (TEMP .GT. EST) THEN
         DO 180 I = 1, N
           W(I) = X(I)
@@ -954,7 +955,7 @@ C
       REAL, PARAMETER :: ZERO = 0.0E0
       REAL, PARAMETER :: ONE  = 1.0E0
       INTEGER CMUMPS_IXAMAX
-      INTRINSIC     abs, max
+      INTRINSIC     abs
       SAVE LCOND1, LCOND2, JUMP,  DXIMAX, DXMAX
       IF (KASE .EQ. 0) THEN
         LCOND1 = .FALSE.
@@ -1034,14 +1035,14 @@ C
   170 CONTINUE
       RETURN
       END SUBROUTINE CMUMPS_SOL_LCOND
-      SUBROUTINE CMUMPS_SOL_CPY_FS2RHSCOMP( JBDEB, JBFIN, NBROWS,
-     &   KEEP, RHSCOMP, NRHS, LRHSCOMP, FIRST_ROW_RHSCOMP, W, LD_W,
+      SUBROUTINE CMUMPS_SOL_CPY_FS2RHSINTR( JBDEB, JBFIN, NBROWS,
+     &   KEEP, RHSINTR, NRHS, LRHSINTR, FIRST_ROW_RHSINTR, W, LD_W,
      &   FIRST_ROW_W )
          INTEGER :: JBDEB, JBFIN, NBROWS
-         INTEGER :: NRHS, LRHSCOMP
-         INTEGER :: FIRST_ROW_RHSCOMP
+         INTEGER :: NRHS, LRHSINTR
+         INTEGER :: FIRST_ROW_RHSINTR
          INTEGER, INTENT(IN) :: KEEP(500)
-         COMPLEX, INTENT(INOUT) :: RHSCOMP(LRHSCOMP,NRHS)
+         COMPLEX, INTENT(INOUT) :: RHSINTR(LRHSINTR,NRHS)
          INTEGER :: LD_W, FIRST_ROW_W
          COMPLEX :: W(LD_W*(JBFIN-JBDEB+1))
          INTEGER :: JJ, K, ISHIFT
@@ -1051,33 +1052,33 @@ C
          DO K = JBDEB, JBFIN
            ISHIFT = FIRST_ROW_W + LD_W * (K-JBDEB)
            DO JJ = 0, NBROWS-1
-              RHSCOMP(FIRST_ROW_RHSCOMP+JJ,K) = W(ISHIFT+JJ)
+              RHSINTR(FIRST_ROW_RHSINTR+JJ,K) = W(ISHIFT+JJ)
            END DO
          END DO
 !$OMP    END PARALLEL DO
       RETURN
-      END SUBROUTINE CMUMPS_SOL_CPY_FS2RHSCOMP
+      END SUBROUTINE CMUMPS_SOL_CPY_FS2RHSINTR
       SUBROUTINE CMUMPS_SOL_BWD_GTHR( JBDEB, JBFIN, J1, J2,
-     &   RHSCOMP, NRHS, LRHSCOMP, W, LD_W, FIRST_ROW_W,
-     &   IW, LIW, KEEP, N, POSINRHSCOMP_BWD )
+     &   RHSINTR, NRHS, LRHSINTR, W, LD_W, FIRST_ROW_W,
+     &   IW, LIW, KEEP, N, POSINRHSINTR_BWD )
       INTEGER, INTENT(IN) :: JBDEB, JBFIN, J1, J2
-      INTEGER, INTENT(IN) :: NRHS, LRHSCOMP
+      INTEGER, INTENT(IN) :: NRHS, LRHSINTR
       INTEGER, INTENT(IN) :: FIRST_ROW_W, LD_W, LIW
       INTEGER, INTENT(IN) :: IW(LIW)
       INTEGER, INTENT(IN) :: KEEP(500)
-      COMPLEX, INTENT(INOUT) :: RHSCOMP(LRHSCOMP,NRHS)
+      COMPLEX, INTENT(INOUT) :: RHSINTR(LRHSINTR,NRHS)
       COMPLEX :: W(LD_W*(JBFIN-JBDEB+1))
       INTEGER, INTENT(IN) :: N
-      INTEGER, INTENT(IN) :: POSINRHSCOMP_BWD(N)
-      INTEGER :: ISHIFT, JJ, K, IPOSINRHSCOMP
-!$OMP PARALLEL DO PRIVATE(JJ,ISHIFT,IPOSINRHSCOMP), IF
+      INTEGER, INTENT(IN) :: POSINRHSINTR_BWD(N)
+      INTEGER :: ISHIFT, JJ, K, IPOSINRHSINTR
+!$OMP PARALLEL DO PRIVATE(JJ,ISHIFT,IPOSINRHSINTR), IF
 !$OMP& ((JBFIN-JBDEB+1 > 2*KEEP(362) .AND.
 !$OMP& (JBFIN-JBDEB+1)*(J2-KEEP(253)-J1+1)>2*KEEP(363)))
              DO K=JBDEB, JBFIN
                ISHIFT = FIRST_ROW_W+(K-JBDEB)*LD_W
                DO JJ = J1, J2-KEEP(253)   
-                 IPOSINRHSCOMP =  abs(POSINRHSCOMP_BWD(IW(JJ)))
-                 W(ISHIFT+JJ-J1)= RHSCOMP(IPOSINRHSCOMP,K)
+                 IPOSINRHSINTR =  abs(POSINRHSINTR_BWD(IW(JJ)))
+                 W(ISHIFT+JJ-J1)= RHSINTR(IPOSINRHSINTR,K)
                ENDDO
              ENDDO
 !$OMP END PARALLEL DO
@@ -1135,11 +1136,11 @@ C
       RESL2 = sqrt(RESL2)
       IF (PROK) WRITE( MPRINT, 90 ) RESMAX, RESL2, ANORM, XNORM, 
      &      SCLNRM
-   90  FORMAT (/' RESIDUAL IS ............ (MAX-NORM)        =',1PD9.2/
+   90  FORMAT (/' RESIDUAL IS ............ (INF-NORM)        =',1PD9.2/
      &       '                       .. (2-NORM)          =',1PD9.2/
-     &       ' RINFOG(4):NORM OF input  Matrix  (MAX-NORM)=',1PD9.2/
-     &       ' RINFOG(5):NORM OF Computed SOLUT (MAX-NORM)=',1PD9.2/
-     &       ' RINFOG(6):SCALED RESIDUAL ...... (MAX-NORM)=',1PD9.2)
+     &       ' RINFOG(4):NORM OF input  Matrix  (INF-NORM)=',1PD9.2/
+     &       ' RINFOG(5):NORM OF Computed SOLUT (INF-NORM)=',1PD9.2/
+     &       ' RINFOG(6):SCALED RESIDUAL ...... (INF-NORM)=',1PD9.2)
       RETURN
       END SUBROUTINE CMUMPS_SOL_Q
       SUBROUTINE CMUMPS_SOLVE_FWD_TRSOLVE (A, LA, APOS, NPIV, LDADIAG, 
@@ -1372,8 +1373,8 @@ C
      &  IW, IPOS, LIW, 
      &  A, LA, APOS,
      &  WCB, LWCB, LD_WCBPIV, 
-     &  RHSCOMP, LRHSCOMP, NRHS, 
-     &  POSINRHSCOMP_FWD, JBDEB, JBFIN, 
+     &  RHSINTR, LRHSINTR, NRHS, 
+     &  POSINRHSINTR_FWD, JBDEB, JBFIN, 
      &  MTYPE, KEEP, OOCWRITE_COMPATIBLE_WITH_BLR,
      &  IGNORE_K459
      &  )
@@ -1381,18 +1382,18 @@ C
       IMPLICIT NONE
       INTEGER, INTENT(IN) :: MTYPE, INODE, N, NPIV, LIELL,
      &                       NELIM, NSLAVES
-      INTEGER, INTENT(IN) :: LRHSCOMP, NRHS, LIW, JBDEB, JBFIN
-      INTEGER, INTENT(IN) :: IW(LIW), IPOS, POSINRHSCOMP_FWD(N)
+      INTEGER, INTENT(IN) :: LRHSINTR, NRHS, LIW, JBDEB, JBFIN
+      INTEGER, INTENT(IN) :: IW(LIW), IPOS, POSINRHSINTR_FWD(N)
       INTEGER(8), INTENT(IN) :: LWCB, APOS, LA, PPIV_COURANT
       INTEGER, INTENT(IN) :: LD_WCBPIV
       INTEGER, INTENT(IN) :: KEEP(500)
       COMPLEX, INTENT(IN) ::  WCB( LWCB )
       COMPLEX, INTENT(IN) :: A( LA )
-      COMPLEX, INTENT(INOUT) :: RHSCOMP(LRHSCOMP, NRHS)
+      COMPLEX, INTENT(INOUT) :: RHSINTR(LRHSINTR, NRHS)
       LOGICAL, INTENT(IN) :: OOCWRITE_COMPATIBLE_WITH_BLR
       LOGICAL, INTENT(IN) :: IGNORE_K459
       INTEGER    :: J1, J3
-      INTEGER    :: IPOSINRHSCOMP, JJ, K,
+      INTEGER    :: IPOSINRHSINTR, JJ, K,
      &              LDAJ, NRHS_B
       INTEGER(8) :: IFR8 , APOS1, APOS2, APOSOFF, IFR_ini8, 
      &              POSWCB1, POSWCB2
@@ -1414,7 +1415,7 @@ C
          J1 = IPOS + LIELL + 1
          J3 = IPOS + LIELL + NPIV
       END IF
-      IPOSINRHSCOMP =  POSINRHSCOMP_FWD(IW(J1)) 
+      IPOSINRHSINTR =  POSINRHSINTR_FWD(IW(J1)) 
       IF ( KEEP(50) .eq. 0 ) THEN
          OMP_FLAG = .FALSE.
 !$       OMP_FLAG=(int(NRHS_B,8)*int(NPIV,8).GE.int(KEEP(363),8))
@@ -1422,7 +1423,7 @@ C
 !$OMP PARALLEL DO PRIVATE(IFR8) COLLAPSE(2)
            DO K = JBDEB, JBFIN
              DO IFR8 = 0_8, int(NPIV-1,8)
-               RHSCOMP(IPOSINRHSCOMP+IFR8, K) =
+               RHSINTR(IPOSINRHSINTR+IFR8, K) =
      &            WCB(PPIV_COURANT+(K-JBDEB)*LD_WCBPIV+IFR8)
              ENDDO
            ENDDO
@@ -1430,7 +1431,7 @@ C
          ELSE
            DO K = JBDEB, JBFIN
              DO IFR8 = 0_8, int(NPIV-1,8)
-               RHSCOMP(IPOSINRHSCOMP+IFR8, K) =
+               RHSINTR(IPOSINRHSINTR+IFR8, K) =
      &            WCB(PPIV_COURANT+(K-JBDEB)*LD_WCBPIV+IFR8)
              ENDDO
            ENDDO
@@ -1450,7 +1451,7 @@ C
             DO JJ = J1, J3
               IPANEL = (JJ-J1)/NB_TARGET + 1
               IF ( JJ-J1+1 .LT. PANEL_COL(IPANEL) ) IPANEL = IPANEL -1
-              ICOL = JJ-J1+1 - PANEL_COL(IPANEL) + 1
+              ICOL = JJ-J1+1 - PANEL_COL(IPANEL) + 1 
               LDAJ = PANEL_COL(IPANEL+1) - PANEL_COL(IPANEL)
               APOS1 = APOS-1_8+PANEL_POS( IPANEL ) + int(ICOL-1,8) *
      &                int(LDAJ+1,8)
@@ -1468,7 +1469,7 @@ C
               IF (SKIP_IT) THEN
               ELSE IF ( IW(JJ+LIELL) .GT. 0 ) THEN
                 VALPIV  = ONE/A( APOS1 )
-                RHSCOMP(IPOSINRHSCOMP+JJ-J1 , K ) = 
+                RHSINTR(IPOSINRHSINTR+JJ-J1 , K ) = 
      &                 WCB( IFR8 ) * VALPIV
                 APOS1 = APOS1 + int(LDAJ + 1,8)
               ELSE
@@ -1483,10 +1484,10 @@ C
                 A12 = -A12/DETPIV
                 POSWCB1 = IFR8
                 POSWCB2 = POSWCB1+1_8
-                RHSCOMP(IPOSINRHSCOMP+JJ-J1,K) =
+                RHSINTR(IPOSINRHSINTR+JJ-J1,K) =
      &                 WCB(POSWCB1)*A11
      &                 + WCB(POSWCB2)*A12
-                RHSCOMP(IPOSINRHSCOMP+JJ-J1+1,K) = 
+                RHSINTR(IPOSINRHSINTR+JJ-J1+1,K) = 
      &                   WCB(POSWCB1)*A12
      &                   + WCB(POSWCB2)*A22
               ENDIF  
@@ -1502,26 +1503,26 @@ C
      &  IW, IPOS, LIW, 
      &  A, LA, APOS,
      &  WCB, LWCB, LD_WCBPIV, 
-     &  RHSCOMP, LRHSCOMP, NRHS, 
-     &  POSINRHSCOMP_FWD, JBDEB, JBFIN, 
+     &  RHSINTR, LRHSINTR, NRHS, 
+     &  POSINRHSINTR_FWD, JBDEB, JBFIN, 
      &  MTYPE, KEEP, OOCWRITE_COMPATIBLE_WITH_BLR,
      &  IGNORE_K459
      &  )
       USE CMUMPS_OOC 
       INTEGER, INTENT(IN) :: MTYPE, INODE, N, NPIV, LIELL,
      &                       NELIM, NSLAVES
-      INTEGER, INTENT(IN) :: LRHSCOMP, NRHS, LIW, JBDEB, JBFIN
-      INTEGER, INTENT(IN) :: IW(LIW), IPOS, POSINRHSCOMP_FWD(N)
+      INTEGER, INTENT(IN) :: LRHSINTR, NRHS, LIW, JBDEB, JBFIN
+      INTEGER, INTENT(IN) :: IW(LIW), IPOS, POSINRHSINTR_FWD(N)
       INTEGER(8), INTENT(IN) :: LWCB, APOS, LA, PPIV_COURANT
       INTEGER, INTENT(IN) :: LD_WCBPIV
       INTEGER, INTENT(IN) :: KEEP(500)
       COMPLEX, INTENT(IN) ::  WCB( LWCB )
       COMPLEX, INTENT(IN) :: A( LA )
-      COMPLEX, INTENT(INOUT) :: RHSCOMP(LRHSCOMP, NRHS)
+      COMPLEX, INTENT(INOUT) :: RHSINTR(LRHSINTR, NRHS)
       LOGICAL, INTENT(IN) :: OOCWRITE_COMPATIBLE_WITH_BLR
       LOGICAL, INTENT(IN) :: IGNORE_K459
       INTEGER    :: TempNROW, J1, J3, PANEL_SIZE
-      INTEGER    :: IPOSINRHSCOMP, JJ, K, NBK, LDAJ, 
+      INTEGER    :: IPOSINRHSINTR, JJ, K, NBK, LDAJ, 
      &              LDAJ_ini, NBK_ini, LDAJ_FIRST_PANEL, NRHS_B
       INTEGER(8) :: IFR8 , APOS1, APOS2, APOSOFF, IFR_ini8, 
      &              POSWCB1, POSWCB2
@@ -1537,13 +1538,13 @@ C
          J1 = IPOS + LIELL + 1
          J3 = IPOS + LIELL + NPIV
       END IF
-      IPOSINRHSCOMP =  POSINRHSCOMP_FWD(IW(J1)) 
+      IPOSINRHSINTR =  POSINRHSINTR_FWD(IW(J1)) 
       IF ( KEEP(50) .eq. 0 ) THEN
 !$         OMP_FLAG=(NRHS_B.GE.KEEP(362).AND.NRHS_B*NPIV.GE.KEEP(363))
 !$OMP PARALLEL DO PRIVATE(IFR8) IF (OMP_FLAG)
            DO K=JBDEB,JBFIN
              IFR8 =  PPIV_COURANT + (K-JBDEB)*LD_WCBPIV
-             RHSCOMP(IPOSINRHSCOMP:IPOSINRHSCOMP+NPIV-1, K) =
+             RHSINTR(IPOSINRHSINTR:IPOSINRHSINTR+NPIV-1, K) =
      &            WCB(IFR8:IFR8+int(NPIV-1,8))
            ENDDO
 !$OMP END PARALLEL DO
@@ -1596,7 +1597,7 @@ C
             IFR8  = IFR8 + 1_8
             IF (IW(JJ+LIELL) .GT. 0) THEN
                VALPIV  = ONE/A( APOS1 )
-               RHSCOMP(IPOSINRHSCOMP+JJ-J1 , K ) = 
+               RHSINTR(IPOSINRHSINTR+JJ-J1 , K ) = 
      &                 WCB( IFR8 ) * VALPIV
               IF (KEEP(201).EQ.1.AND.OOCWRITE_COMPATIBLE_WITH_BLR)
      &        THEN
@@ -1629,10 +1630,10 @@ C
               A12 = -A12/DETPIV
               POSWCB1 = IFR8
               POSWCB2 = POSWCB1+1_8
-              RHSCOMP(IPOSINRHSCOMP+JJ-J1,K) =
+              RHSINTR(IPOSINRHSINTR+JJ-J1,K) =
      &               WCB(POSWCB1)*A11
      &               + WCB(POSWCB2)*A12
-              RHSCOMP(IPOSINRHSCOMP+JJ-J1+1,K) = 
+              RHSINTR(IPOSINRHSINTR+JJ-J1+1,K) = 
      &                 WCB(POSWCB1)*A12
      &                 + WCB(POSWCB2)*A22
               IF (KEEP(201).EQ.1.AND.OOCWRITE_COMPATIBLE_WITH_BLR)
@@ -1661,6 +1662,7 @@ C
         SEQUENCE
         REAL, dimension(:), pointer :: SCALING
         REAL, dimension(:), pointer :: SCALING_LOC
+        INTEGER, dimension(:), pointer :: SCALING_IND
       end type scaling_data_t
       type (scaling_data_t), INTENT(INOUT) :: scaling_data
       INTEGER, INTENT(IN) :: N, LILOC, COMM, MYID, MASTER, LP
diff -pruN 5.6.2-2.1/src/csol_bwd.F 5.7.1-1/src/csol_bwd.F
--- 5.6.2-2.1/src/csol_bwd.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/csol_bwd.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -13,7 +13,7 @@ C  https://cecill.info/licences/Licence_
 C
       SUBROUTINE CMUMPS_SOL_S(N, A, LA, IW, LIW, W, LWC,
      &    NRHS, 
-     &    RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &    RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &    PTRICB, PTRACB, IWCB, LIWW, W2, 
      &    NE_STEPS, STEP,
      &    FRERE, DAD, FILS, IPOOL, LPOOL, PTRIST, PTRFAC, 
@@ -59,8 +59,8 @@ C
       INTEGER BUFR(LBUFR)
       INTEGER ISTEP_TO_INIV2(KEEP(71)), 
      &        TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
-      INTEGER LRHSCOMP, POSINRHSCOMP_BWD(N)
-      COMPLEX RHSCOMP(LRHSCOMP,NRHS)
+      INTEGER LRHSINTR, POSINRHSINTR_BWD(N)
+      COMPLEX RHSINTR(LRHSINTR,NRHS)
       INTEGER(8), intent(in) :: LRHS_ROOT
       COMPLEX RHS_ROOT( LRHS_ROOT )
       LOGICAL, INTENT(in) :: PRUN_BELOW
@@ -124,22 +124,26 @@ C
       ERROR_WAS_BROADCASTED = .FALSE.
       DO_MCAST2_TERMBWD = .FALSE.
       DO WHILE ( NBFINF .NE. 0 .OR. MYLEAF_LEFT .NE. 0 )
-        BLOQ = (  III .EQ. IIPOOL  )
-        CALL CMUMPS_BACKSLV_RECV_AND_TREAT( BLOQ, FLAG, BUFR, LBUFR,
-     &     LBUFR_BYTES, MYID, SLAVEF, COMM,
-     &     N, IWCB, LIWW, POSIWCB,
-     &     W, LWC, POSWCB,
-     &     IIPOOL, NBFINF, PTRICB, PTRACB, INFO,
-     &     IPOOL, LPOOL, PANEL_POS, LPANEL_POS,
-     &     STEP,  FRERE, FILS, PROCNODE_STEPS,
-     &     PLEFTW, KEEP,KEEP8, DKEEP,
-     &     PTRIST, PTRFAC, IW, LIW, A, LA, W2, MYLEAF_LEFT, 
-     &     NRHS, MTYPE, 
-     &     RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD
-     &     , PRUN_BELOW, TO_PROCESS, SIZE_TO_PROCESS
-     &     , FROM_PP
+        IF ( SLAVEF.EQ.1 ) THEN
+          FLAG = .FALSE.
+        ELSE
+          BLOQ = (  III .EQ. IIPOOL  )
+          CALL CMUMPS_BACKSLV_RECV_AND_TREAT( BLOQ, FLAG, BUFR, LBUFR,
+     &       LBUFR_BYTES, MYID, SLAVEF, COMM,
+     &       N, IWCB, LIWW, POSIWCB,
+     &       W, LWC, POSWCB,
+     &       IIPOOL, NBFINF, PTRICB, PTRACB, INFO,
+     &       IPOOL, LPOOL, PANEL_POS, LPANEL_POS,
+     &       STEP,  FRERE, FILS, PROCNODE_STEPS,
+     &       PLEFTW, KEEP,KEEP8, DKEEP,
+     &       PTRIST, PTRFAC, IW, LIW, A, LA, W2, MYLEAF_LEFT, 
+     &       NRHS, MTYPE, 
+     &       RHSINTR, LRHSINTR, POSINRHSINTR_BWD
+     &       , PRUN_BELOW, TO_PROCESS, SIZE_TO_PROCESS
+     &       , FROM_PP
      &     )
-        IF ( INFO(1) .LT. 0 ) GOTO 340 
+          IF ( INFO(1) .LT. 0 ) GOTO 340 
+        ENDIF
         IF ( .NOT. FLAG ) THEN
           IF (III .NE. IIPOOL) THEN
             INODE = IPOOL(IIPOOL-1)
@@ -161,7 +165,7 @@ C
      &        N, IPOOL, LPOOL, IIPOOL, NBFINF,
      &        A_PTR(1), LA_PTR, IW, LIW, W, LWC, NRHS,
      &        POSWCB, PLEFTW, POSIWCB,
-     &        RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &        RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &        PTRICB, PTRACB, IWCB, LIWW, W2, 
      &        NE_STEPS, STEP,
      &        FRERE, FILS, PTRIST, PTRFAC,
diff -pruN 5.6.2-2.1/src/csol_bwd_aux.F 5.7.1-1/src/csol_bwd_aux.F
--- 5.6.2-2.1/src/csol_bwd_aux.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/csol_bwd_aux.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -15,7 +15,7 @@ C
      &       N, IPOOL, LPOOL, IIPOOL, NBFINF,
      &       A, LA, IW, LIW, W, LWC, NRHS, 
      &       POSWCB, PLEFTW, POSIWCB,
-     &    RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &    RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &    PTRICB, PTRACB, IWCB, LIWW, W2, 
      &    NE_STEPS, STEP,
      &    FRERE, FILS, PTRIST, PTRFAC, 
@@ -62,8 +62,8 @@ C
       INTEGER BUFR(LBUFR)
       INTEGER ISTEP_TO_INIV2(KEEP(71)), 
      &        TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
-      INTEGER LRHSCOMP, POSINRHSCOMP_BWD(N)
-      COMPLEX RHSCOMP(LRHSCOMP,NRHS)
+      INTEGER LRHSINTR, POSINRHSINTR_BWD(N)
+      COMPLEX RHSINTR(LRHSINTR,NRHS)
       INTEGER(8), intent(in) :: LRHS_ROOT
       COMPLEX RHS_ROOT( LRHS_ROOT )
       LOGICAL, INTENT( IN ) :: PRUN_BELOW
@@ -99,7 +99,7 @@ C
       INTEGER :: PROCDEST, DEST
       INTEGER(8) :: PTWCB, PPIV_COURANT
       INTEGER :: Offset, EffectiveSize, ISLAVE, FirstIndex
-      INTEGER :: POSINDICES, IPOSINRHSCOMP, IPOSINRHSCOMP_PANEL
+      INTEGER :: POSINDICES, IPOSINRHSINTR, IPOSINRHSINTR_PANEL
       INTEGER(8) :: APOS, IST
       INTEGER(8) :: IFR8
       INTEGER(8) :: APOSDEB, NBENTRIES_ALLPANELS
@@ -141,9 +141,9 @@ C
             J2   = IPOS + NPIV
          END IF
          IFR8  = 0_8
-         IPOSINRHSCOMP = POSINRHSCOMP_BWD(IW(J1))  
-         CALL CMUMPS_SOL_CPY_FS2RHSCOMP(JBDEB, JBFIN, J2-J1+1,
-     &          KEEP, RHSCOMP, NRHS, LRHSCOMP, IPOSINRHSCOMP,
+         IPOSINRHSINTR = POSINRHSINTR_BWD(IW(J1))  
+         CALL CMUMPS_SOL_CPY_FS2RHSINTR(JBDEB, JBFIN, J2-J1+1,
+     &          KEEP, RHSINTR, NRHS, LRHSINTR, IPOSINRHSINTR,
      &          RHS_ROOT(1+NPIV*(JBDEB-1)), NPIV, 1)
         IN = INODE
  270    IN = FILS(IN)
@@ -210,8 +210,8 @@ C
      &                 LONG, LONG, IW( J1 ),
      &                 RHS_ROOT( 1+NPIV*(JBDEB-1) ), 
      &                 JBDEB, JBFIN,
-     &                 RHSCOMP(1, 1), NRHS, LRHSCOMP,
-     &                 IPOSINRHSCOMP, NPIV,
+     &                 RHSINTR(1, 1), NRHS, LRHSINTR,
+     &                 IPOSINRHSINTR, NPIV,
      &                 KEEP, PROCDEST,
      &                 NOEUD, COMM, IERR )
                 IF ( IERR .EQ. -1 ) THEN
@@ -228,7 +228,7 @@ C
      &                  PTRIST, PTRFAC, IW, LIW, A, LA, W2,
      &                  MYLEAF_LEFT, 
      &                  NRHS, MTYPE,
-     &                  RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &                  RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &                  PRUN_BELOW, TO_PROCESS, SIZE_TO_PROCESS
      &                  , FROM_PP
      &                  )
@@ -349,9 +349,9 @@ C
            END IF
            IFR8 = PTRACB(STEP( INODE )) - 1_8
           CALL CMUMPS_SOL_BWD_GTHR( JBDEB, JBFIN, J1, J2,
-     &       RHSCOMP, NRHS, LRHSCOMP,
+     &       RHSINTR, NRHS, LRHSINTR,
      &       W(PTRACB(STEP(INODE))), NCB, 1,
-     &       IW, LIW, KEEP, N, POSINRHSCOMP_BWD )
+     &       IW, LIW, KEEP, N, POSINRHSINTR_BWD )
              IFR8 = IFR8 + int(J2-KEEP(253)-J1+1,8)
            IF (KEEP(252).NE.0) THEN
              DO JJ = J2-KEEP(253)+1, J2
@@ -394,7 +394,7 @@ C
      &              PROCNODE_STEPS, PLEFTW, KEEP,KEEP8, DKEEP,
      &              PTRIST, PTRFAC, IW, LIW, A, LA, W2, MYLEAF_LEFT,
      &              NRHS, MTYPE,
-     &              RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &              RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &              PRUN_BELOW , TO_PROCESS, SIZE_TO_PROCESS
      &               , FROM_PP
      &               )
@@ -518,15 +518,15 @@ C
         PTWCB = PTRACB(STEP( INODE ))
       ENDIF
       IF (J2.GE.J1) THEN
-        IPOSINRHSCOMP = POSINRHSCOMP_BWD(IW(J1)) 
+        IPOSINRHSINTR = POSINRHSINTR_BWD(IW(J1)) 
       ELSE
-        IPOSINRHSCOMP = -99999
+        IPOSINRHSINTR = -99999
       ENDIF
       IF (J2.GE.J1) THEN
         DO K=JBDEB, JBFIN
             IF (KEEP(252).NE.0) THEN
               DO JJ = J1, J2
-                RHSCOMP(IPOSINRHSCOMP+JJ-J1,K) = ZERO
+                RHSINTR(IPOSINRHSINTR+JJ-J1,K) = ZERO
               ENDDO
             ENDIF
         END DO
@@ -541,9 +541,9 @@ C
           J2 = IPOS + LIELL
         END IF
         CALL CMUMPS_SOL_BWD_GTHR( JBDEB, JBFIN, J1, J2,
-     &       RHSCOMP, NRHS, LRHSCOMP,
+     &       RHSINTR, NRHS, LRHSINTR,
      &       W(PTWCB), LIELL, NPIV+1,
-     &       IW, LIW, KEEP, N, POSINRHSCOMP_BWD )
+     &       IW, LIW, KEEP, N, POSINRHSINTR_BWD )
           IFR8 = IFR8 + int(J2-KEEP(253)-J1+1,8)
         IF (KEEP(252).NE.0) THEN
           DO JJ = J2-KEEP(253)+1, J2
@@ -603,7 +603,7 @@ C
             ENDIF
             LDAJ    = LIELL-BEG_PANEL+1 
             APOSDEB = APOSDEB - int(NBJ,8)*int(LDAJ,8)
-            IPOSINRHSCOMP_PANEL = IPOSINRHSCOMP + BEG_PANEL - 1
+            IPOSINRHSINTR_PANEL = IPOSINRHSINTR + BEG_PANEL - 1
             NCB_PANEL   = LDAJ - NBJ
             IF (KEEP(50).NE.1.AND.MUST_BE_PERMUTED) THEN
               CALL CMUMPS_GET_OOC_PERM_PTR(TYPEF, TMP_NBPANELS,
@@ -625,24 +625,24 @@ C
                   IF (NCB_PANEL - NCB.NE. 0) THEN
                     CALL cgemv( 'T', NCB_PANEL-NCB, NBJ, ALPHA, 
      &              A( APOSDEB + int(NBJ,8) ), LDAJ,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL+NBJ,JBDEB),
+     &              RHSINTR(IPOSINRHSINTR_PANEL+NBJ,JBDEB),
      &              1, ONE,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), 1 )
+     &              RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), 1 )
                   ENDIF
                   IF (NCB .NE. 0) THEN
                     CALL cgemv( 'T', NCB, NBJ, ALPHA,
      &              A( APOSDEB + int(LDAJ-NCB,8) ), LDAJ,
      &              W( PTWCB  + int(NPIV,8) ),
      &              1, ONE,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), 1 )
+     &              RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), 1 )
                   ENDIF
               ENDIF
               IF (MTYPE.NE.1) THEN
                 CALL ctrsv('L','T','U', NBJ, A(APOSDEB), LDAJ,
-     &            RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), 1)
+     &            RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), 1)
               ELSE
                 CALL ctrsv('L','T','N', NBJ, A(APOSDEB), LDAJ,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), 1)
+     &              RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), 1)
               ENDIF
             ELSE
 #endif
@@ -651,24 +651,24 @@ C
                   CALL cgemm( 'T', 'N', NBJ, NRHS_B,
      &                                         NCB_PANEL-NCB, ALPHA,
      &              A(APOSDEB +int(NBJ,8)), LDAJ,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL+NBJ,JBDEB), LRHSCOMP,
-     &              ONE, RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), LRHSCOMP)
+     &              RHSINTR(IPOSINRHSINTR_PANEL+NBJ,JBDEB), LRHSINTR,
+     &              ONE, RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), LRHSINTR)
                   ENDIF
                   IF (NCB .NE. 0) THEN
                   CALL cgemm( 'T', 'N', NBJ, NRHS_B, NCB, ALPHA,
      &              A(APOSDEB +int(LDAJ-NCB,8)), LDAJ,
      &              W( PTWCB+int(NPIV,8) ), LIELL,
-     &              ONE, RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB),LRHSCOMP)
+     &              ONE, RHSINTR(IPOSINRHSINTR_PANEL,JBDEB),LRHSINTR)
                   ENDIF
               ENDIF
               IF (MTYPE.NE.1) THEN
                 CALL ctrsm('L','L','T','U',NBJ, NRHS_B, ONE,
      &          A(APOSDEB), 
-     &          LDAJ, RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), LRHSCOMP)
+     &          LDAJ, RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), LRHSINTR)
               ELSE
                 CALL ctrsm('L','L','T','N',NBJ, NRHS_B, ONE,
      &          A(APOSDEB),
-     &          LDAJ, RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), LRHSCOMP)
+     &          LDAJ, RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), LRHSINTR)
               ENDIF
 #if defined(MUMPS_USE_BLAS2)
             ENDIF
@@ -682,8 +682,8 @@ C
           CALL CMUMPS_SOL_BWD_LR_SU (
      &           INODE, IWHDLR, NPIV, NSLAVES, 
      &           LIELL, W, LWC, NRHS_B, PTWCB,
-     &           RHSCOMP, LRHSCOMP, NRHS,
-     &           IPOSINRHSCOMP, JBDEB, 
+     &           RHSINTR, LRHSINTR, NRHS,
+     &           IPOSINRHSINTR, JBDEB, 
      &           MTYPE, KEEP, KEEP8,
      &           INFO(1), INFO(2) )
           IF (INFO(1).LT.0) THEN
@@ -699,13 +699,13 @@ C
                 CALL cgemv( 'T', NCB, NPIV, ALPHA, A(IST), LIELL,
      &                 W(PTWCB+int(NPIV,8)), 1,
      &                 ONE,
-     &                 RHSCOMP(IPOSINRHSCOMP,JBDEB), 1 )
+     &                 RHSINTR(IPOSINRHSINTR,JBDEB), 1 )
               ELSE
 #endif
                 CALL cgemm('T','N', NPIV, NRHS_B, NCB, ALPHA,
      &                 A(IST),
      &                 LIELL, W(PTWCB+int(NPIV,8)), LIELL, ONE,
-     &                 RHSCOMP(IPOSINRHSCOMP,JBDEB), LRHSCOMP)
+     &                 RHSINTR(IPOSINRHSINTR,JBDEB), LRHSINTR)
 #if defined(MUMPS_USE_BLAS2)
               ENDIF
 #endif
@@ -725,13 +725,13 @@ C
                  CALL cgemv( 'N', NPIV, NCB, ALPHA, A( IST ), NPIV,
      &                W( PTWCB + int(NPIV,8) ),
      &                1, ONE,
-     &                RHSCOMP(IPOSINRHSCOMP,JBDEB), 1 )
+     &                RHSINTR(IPOSINRHSINTR,JBDEB), 1 )
               ELSE
 #endif
                  CALL cgemm( 'N', 'N', NPIV, NRHS_B, NCB, ALPHA,
      &                A(IST),
      &                NPIV, W(PTWCB+int(NPIV,8)), LIELL,
-     &                ONE, RHSCOMP(IPOSINRHSCOMP,JBDEB), LRHSCOMP)
+     &                ONE, RHSINTR(IPOSINRHSINTR,JBDEB), LRHSINTR)
 #if defined(MUMPS_USE_BLAS2)
               END IF
 #endif
@@ -750,17 +750,17 @@ C
               ENDIF
             ENDIF
           END IF 
-          PPIV_COURANT = int(JBDEB-1,8)*int(LRHSCOMP,8)
-     &                 + int(IPOSINRHSCOMP,8)
+          PPIV_COURANT = int(JBDEB-1,8)*int(LRHSINTR,8)
+     &                 + int(IPOSINRHSINTR,8)
           IF (KEEP(459).GT.1 .AND. KEEP(50).NE.0) THEN
           CALL CMUMPS_SOLVE_BWD_PANELS( A, LA, APOS,
      &      NPIV, IW(IPOS+1+LIELL),
-     &      NRHS_B, RHSCOMP(1,1), KEEP8(25), LRHSCOMP, PPIV_COURANT, 
+     &      NRHS_B, RHSINTR(1,1), KEEP8(25), LRHSINTR, PPIV_COURANT, 
      &      MTYPE, KEEP )
           ELSE
           CALL CMUMPS_SOLVE_BWD_TRSOLVE( A, LA, APOS,
      &      NPIV, LDAJ,
-     &      NRHS_B, RHSCOMP(1,1), KEEP8(25), LRHSCOMP, PPIV_COURANT, 
+     &      NRHS_B, RHSINTR(1,1), KEEP8(25), LRHSINTR, PPIV_COURANT, 
      &      MTYPE, KEEP )
           ENDIF
         ENDIF  
@@ -770,7 +770,7 @@ C
       ELSE
         J1 = IPOS + 1
       END IF
-      IPOSINRHSCOMP =  POSINRHSCOMP_BWD(IW(J1)) 
+      IPOSINRHSINTR =  POSINRHSINTR_BWD(IW(J1)) 
   160 CONTINUE
       IF (KEEP(201).GT.0.AND.OOCWRITE_COMPATIBLE_WITH_BLR) THEN
          CALL CMUMPS_FREE_FACTORS_FOR_SOLVE(INODE,PTRFAC,KEEP(28),
@@ -876,8 +876,8 @@ C
      &          LIELL, LIELL - KEEP(253),
      &          IW( POSINDICES ),
      &          W( PTRACB(STEP(INODE)) ), JBDEB, JBFIN,
-     &          RHSCOMP(1, 1), NRHS, LRHSCOMP,
-     &          IPOSINRHSCOMP, NPIV,
+     &          RHSINTR(1, 1), NRHS, LRHSINTR,
+     &          IPOSINRHSINTR, NPIV,
      &          KEEP, PROCDEST, NOEUD, COMM, IERR )
               IF ( IERR .EQ. -1 ) THEN
                 CALL CMUMPS_BACKSLV_RECV_AND_TREAT(
@@ -892,7 +892,7 @@ C
      &          PLEFTW, KEEP, KEEP8, DKEEP,
      &          PTRIST, PTRFAC, IW, LIW, A, LA, W2, MYLEAF_LEFT,
      &          NRHS, MTYPE, 
-     &          RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &          RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &          PRUN_BELOW, TO_PROCESS, SIZE_TO_PROCESS
      &            , FROM_PP
      &            )
@@ -960,7 +960,7 @@ C
      &     PLEFTW, KEEP, KEEP8, DKEEP,
      &     PTRIST, PTRFAC, IW, LIW, A, LA, W2, MYLEAF_LEFT, 
      &     NRHS, MTYPE,
-     &     RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &     RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &     PRUN_BELOW, TO_PROCESS, SIZE_TO_PROCESS
      &     , FROM_PP
      &    )
@@ -992,8 +992,8 @@ C
       COMPLEX A( LA ), W2( KEEP(133) )
       INTEGER NRHS
       INTEGER MYLEAF_LEFT, MTYPE
-      INTEGER LRHSCOMP, POSINRHSCOMP_BWD(N)
-      COMPLEX RHSCOMP(LRHSCOMP,NRHS)
+      INTEGER LRHSINTR, POSINRHSINTR_BWD(N)
+      COMPLEX RHSINTR(LRHSINTR,NRHS)
       LOGICAL, INTENT(IN) :: PRUN_BELOW
       INTEGER SIZE_TO_PROCESS
       LOGICAL TO_PROCESS(SIZE_TO_PROCESS)
@@ -1037,7 +1037,7 @@ C
      &                KEEP, KEEP8, DKEEP,
      &                PTRIST, PTRFAC, IW, LIW, A, LA, W2, MYLEAF_LEFT, 
      &                NRHS, MTYPE, 
-     &                RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &                RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &               PRUN_BELOW, TO_PROCESS, SIZE_TO_PROCESS
      &               , FROM_PP
      &          )
@@ -1057,7 +1057,7 @@ C
      &                KEEP, KEEP8, DKEEP,
      &                PTRIST, PTRFAC, IW, LIW, A, LA, W2, MYLEAF_LEFT, 
      &                NRHS, MTYPE, 
-     &                RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &                RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &                PRUN_BELOW, TO_PROCESS, SIZE_TO_PROCESS
      &               , FROM_PP
      &           )
@@ -1093,8 +1093,8 @@ C
       COMPLEX A( LA ), W2( KEEP(133) )
       INTEGER NRHS
       INTEGER MYLEAF_LEFT, MTYPE
-      INTEGER LRHSCOMP, POSINRHSCOMP_BWD(N)
-      COMPLEX RHSCOMP(LRHSCOMP,NRHS)
+      INTEGER LRHSINTR, POSINRHSINTR_BWD(N)
+      COMPLEX RHSINTR(LRHSINTR,NRHS)
       LOGICAL, INTENT(IN) :: PRUN_BELOW
       INTEGER  SIZE_TO_PROCESS
       LOGICAL TO_PROCESS(SIZE_TO_PROCESS), NO_CHILDREN
@@ -1108,7 +1108,7 @@ C
       INTEGER(8) :: IFR8
       INTEGER I, JJ, IN, PROCDEST, J1, J2, LDA
       INTEGER NSLAVES, NELIM, J, POSINDICES, INODEPOS,
-     &     IPOSINRHSCOMP, IPOSINRHSCOMP_PANEL
+     &     IPOSINRHSINTR, IPOSINRHSINTR_PANEL
       INTEGER JBDEB, JBFIN, NRHS_B, allocok
       INTEGER(8) :: P_UPDATE, P_SOL_MAS         
       INTEGER :: IWHDLR, MTYPE_SLAVE, LDA_SLAVE 
@@ -1190,11 +1190,11 @@ C
      &           W(POSWCB + 1), LONG, 
      &           MPI_COMPLEX, COMM, IERR)
               DO JJ=0, LONG-1
-                IPOSINRHSCOMP = abs( POSINRHSCOMP_BWD( IWCB(
+                IPOSINRHSINTR = abs( POSINRHSINTR_BWD( IWCB(
      &                                    POSIWCB+1+JJ ) ) )
-                IF ( (IPOSINRHSCOMP.EQ.0) .OR.
-     &            ( IPOSINRHSCOMP.GT.N ) ) CYCLE  
-                RHSCOMP(IPOSINRHSCOMP,K) = W(POSWCB+1+JJ)
+                IF ( (IPOSINRHSINTR.EQ.0) .OR.
+     &            ( IPOSINRHSINTR.GT.N ) ) CYCLE  
+                RHSINTR(IPOSINRHSINTR,K) = W(POSWCB+1+JJ)
               ENDDO
             ENDDO
             POSIWCB = POSIWCB + LONG
@@ -1346,7 +1346,7 @@ C
      &     KEEP, KEEP8, DKEEP,
      &     PTRIST, PTRFAC, IW, LIW, A, LA, W2, MYLEAF_LEFT,
      &     NRHS, MTYPE,
-     &     RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &     RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &     PRUN_BELOW, TO_PROCESS, SIZE_TO_PROCESS
      &      , FROM_PP
      &      )
@@ -1400,7 +1400,7 @@ C
         J1 = IPOS + 1
         J2 = IPOS + NPIV
       ENDIF
-        IPOSINRHSCOMP =  POSINRHSCOMP_BWD(IW(J1)) 
+        IPOSINRHSINTR =  POSINRHSINTR_BWD(IW(J1)) 
         DO K=JBDEB, JBFIN
           CALL MPI_UNPACK( BUFR, LBUFR_BYTES, POSITION,
      &                     W2, NPIV, MPI_COMPLEX,
@@ -1410,13 +1410,13 @@ C
      &         (IW(PTRIST(STEP(INODE))+XXS).EQ.C_FINI+NSLAVES) 
      &       ) THEN
           DO JJ = J1,J2   
-            RHSCOMP(IPOSINRHSCOMP+JJ-J1,K) = W2(I)
+            RHSINTR(IPOSINRHSINTR+JJ-J1,K) = W2(I)
             I = I+1
           ENDDO
          ELSE
           DO JJ = J1,J2   
-            RHSCOMP(IPOSINRHSCOMP+JJ-J1,K) = 
-     &      RHSCOMP(IPOSINRHSCOMP+JJ-J1,K) + W2(I)
+            RHSINTR(IPOSINRHSINTR+JJ-J1,K) = 
+     &      RHSINTR(IPOSINRHSINTR+JJ-J1,K) + W2(I)
             I = I+1
           ENDDO
          ENDIF
@@ -1482,7 +1482,7 @@ C
            POSINDICES = IPOS + 1
         END IF
         PTWCB = PTRACB(STEP( INODE ))
-        IPOSINRHSCOMP =  POSINRHSCOMP_BWD(IW(J1)) 
+        IPOSINRHSINTR =  POSINRHSINTR_BWD(IW(J1)) 
         IFR8 = PTRACB(STEP( INODE ))
       IFR8   = PTWCB + int(NPIV - 1,8)
         IF ( MTYPE .EQ. 1 .AND. KEEP(50).EQ.0 ) THEN
@@ -1493,9 +1493,9 @@ C
           J2 = IPOS + LIELL
         END IF
         CALL CMUMPS_SOL_BWD_GTHR( JBDEB, JBFIN, J1, J2,
-     &       RHSCOMP, NRHS, LRHSCOMP,
+     &       RHSINTR, NRHS, LRHSINTR,
      &       W(PTWCB), LIELL, NPIV+1,
-     &       IW, LIW, KEEP, N, POSINRHSCOMP_BWD )
+     &       IW, LIW, KEEP, N, POSINRHSINTR_BWD )
           IFR8 = IFR8 + int(J2-KEEP(253)-J1+1,8)
       IF ( KEEP(201).EQ.1 .AND. OOCWRITE_COMPATIBLE_WITH_BLR .AND.
      &    (( NELIM .GT. 0 ).OR. (MTYPE.NE.1 )))  THEN
@@ -1540,7 +1540,7 @@ C
             LDAJ    = NROW_L-BEG_PANEL+1 
             APOSDEB = APOSDEB - int(NBJ,8)*int(LDAJ,8)
             PTWCB   = PTRACB(STEP(INODE))
-            IPOSINRHSCOMP_PANEL = IPOSINRHSCOMP + BEG_PANEL - 1
+            IPOSINRHSINTR_PANEL = IPOSINRHSINTR + BEG_PANEL - 1
             NCB_PANEL   = LDAJ - NBJ
             NCB     = NROW_L - NPIV
             IF (KEEP(50).NE.1 .AND.MUST_BE_PERMUTED) THEN
@@ -1559,24 +1559,24 @@ C
                   IF (NCB_PANEL - NCB.NE. 0) THEN
                     CALL cgemv( 'T', NCB_PANEL-NCB, NBJ, ALPHA, 
      &              A( APOSDEB + int(NBJ,8) ), LDAJ,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL+NBJ,JBDEB),
+     &              RHSINTR(IPOSINRHSINTR_PANEL+NBJ,JBDEB),
      &              1, ONE,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), 1 )
+     &              RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), 1 )
                   ENDIF
                   IF (NCB .NE. 0) THEN
                     CALL cgemv( 'T', NCB, NBJ, ALPHA,
      &              A( APOSDEB + int(LDAJ-NCB,8) ), LDAJ,
      &              W( PTWCB  + int(NPIV,8) ),
      &              1, ONE,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), 1 )
+     &              RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), 1 )
                   ENDIF
               ENDIF
               IF (MTYPE.NE.1) THEN
                 CALL ctrsv('L','T','U', NBJ, A(APOSDEB), LDAJ,
-     &            RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), 1)
+     &            RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), 1)
               ELSE
                 CALL ctrsv('L','T','N', NBJ, A(APOSDEB), LDAJ,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), 1)
+     &              RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), 1)
               ENDIF
             ELSE
 #endif
@@ -1585,24 +1585,24 @@ C
                   CALL cgemm( 'T', 'N', NBJ, NRHS_B,
      &                                         NCB_PANEL-NCB, ALPHA,
      &              A(APOSDEB +int(NBJ,8)), LDAJ,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL+NBJ,JBDEB), LRHSCOMP,
-     &              ONE, RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), LRHSCOMP)
+     &              RHSINTR(IPOSINRHSINTR_PANEL+NBJ,JBDEB), LRHSINTR,
+     &              ONE, RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), LRHSINTR)
                   ENDIF
                   IF (NCB .NE. 0) THEN
                   CALL cgemm( 'T', 'N', NBJ, NRHS_B, NCB, ALPHA,
      &              A(APOSDEB +int(LDAJ-NCB,8)), LDAJ,
      &              W( PTWCB+int(NPIV,8) ), LIELL,
-     &              ONE, RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB),LRHSCOMP)
+     &              ONE, RHSINTR(IPOSINRHSINTR_PANEL,JBDEB),LRHSINTR)
                   ENDIF
               ENDIF
               IF (MTYPE.NE.1) THEN
                 CALL ctrsm('L','L','T','U',NBJ, NRHS_B, ONE,
      &          A(APOSDEB), 
-     &          LDAJ, RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), LRHSCOMP)
+     &          LDAJ, RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), LRHSINTR)
               ELSE
                 CALL ctrsm('L','L','T','N',NBJ, NRHS_B, ONE,
      &          A(APOSDEB),
-     &          LDAJ, RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), LRHSCOMP)
+     &          LDAJ, RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), LRHSINTR)
               ENDIF
 #if defined(MUMPS_USE_BLAS2)
             ENDIF
@@ -1617,8 +1617,8 @@ C
           CALL CMUMPS_SOL_BWD_LR_SU (
      &           INODE, IWHDLR, NPIV, NSLAVES,
      &           LIELL, W, LWC, NRHS_B, PTRACB(STEP(INODE)), 
-     &           RHSCOMP, LRHSCOMP, NRHS,
-     &           IPOSINRHSCOMP, JBDEB, 
+     &           RHSINTR, LRHSINTR, NRHS,
+     &           IPOSINRHSINTR, JBDEB, 
      &           MTYPE, KEEP, KEEP8,
      &           INFO(1), INFO(2) )
         ELSE
@@ -1638,27 +1638,27 @@ C
                  CALL cgemv( 'N', NPIV, NELIM, ALPHA, A( IST ), NPIV,
      &                 W( NPIV + PTRACB(STEP(INODE)) ),
      &                 1, ONE,
-     &                 RHSCOMP(IPOSINRHSCOMP,JBDEB), 1 )
+     &                 RHSINTR(IPOSINRHSINTR,JBDEB), 1 )
               ELSE
 #endif
                  CALL cgemm( 'N', 'N', NPIV, NRHS_B, NELIM, ALPHA,
      &                A(IST), NPIV, W(NPIV+PTRACB(STEP(INODE))), LIELL,
-     &                ONE, RHSCOMP(IPOSINRHSCOMP,JBDEB), LRHSCOMP)
+     &                ONE, RHSINTR(IPOSINRHSINTR,JBDEB), LRHSINTR)
 #if defined(MUMPS_USE_BLAS2)
               END IF
 #endif
           ENDIF 
-          PPIV_COURANT = int(JBDEB-1,8)*int(LRHSCOMP,8)
-     &                 + int(IPOSINRHSCOMP,8)
+          PPIV_COURANT = int(JBDEB-1,8)*int(LRHSINTR,8)
+     &                 + int(IPOSINRHSINTR,8)
           IF (KEEP(459).GT.1 .AND. KEEP(50).NE.0) THEN
           CALL CMUMPS_SOLVE_BWD_PANELS( A, LA, APOS,
      &      NPIV, IW(IPOS+1+LIELL),
-     &      NRHS_B, RHSCOMP(1,1), KEEP8(25), LRHSCOMP, PPIV_COURANT, 
+     &      NRHS_B, RHSINTR(1,1), KEEP8(25), LRHSINTR, PPIV_COURANT, 
      &      MTYPE, KEEP )
           ELSE
           CALL CMUMPS_SOLVE_BWD_TRSOLVE( A, LA, APOS,
      &      NPIV, LDA,
-     &      NRHS_B, RHSCOMP(1,1), KEEP8(25), LRHSCOMP, PPIV_COURANT, 
+     &      NRHS_B, RHSINTR(1,1), KEEP8(25), LRHSINTR, PPIV_COURANT, 
      &      MTYPE, KEEP )
           ENDIF
        ENDIF
@@ -1673,7 +1673,7 @@ C
            ENDIF
           ENDIF
           IPOS =   PTRIST(STEP(INODE)) +  KEEP(IXSZ) + 6 + NSLAVES
-          IPOSINRHSCOMP     = POSINRHSCOMP_BWD(IW(IPOS))
+          IPOSINRHSINTR     = POSINRHSINTR_BWD(IW(IPOS))
           IN = INODE
   170     IN = FILS(IN)
           IF (IN .GT. 0) GOTO 170
@@ -1734,8 +1734,8 @@ C
      &          LIELL, LIELL - KEEP(253),
      &          IW( POSINDICES ),
      &          W( PTRACB(STEP(INODE)) ), JBDEB, JBFIN,
-     &          RHSCOMP(1, 1), NRHS, LRHSCOMP,
-     &          IPOSINRHSCOMP, NPIV,
+     &          RHSINTR(1, 1), NRHS, LRHSINTR,
+     &          IPOSINRHSINTR, NPIV,
      &          KEEP, PROCDEST, NOEUD, COMM, IERR )
               IF ( IERR .EQ. -1 ) THEN
                 CALL CMUMPS_BACKSLV_RECV_AND_TREAT(
@@ -1750,7 +1750,7 @@ C
      &          PLEFTW, KEEP, KEEP8, DKEEP,
      &          PTRIST, PTRFAC, IW, LIW, A, LA, W2, MYLEAF_LEFT,
      &          NRHS, MTYPE, 
-     &          RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &          RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &          PRUN_BELOW, TO_PROCESS, SIZE_TO_PROCESS
      &            , FROM_PP
      &            )
diff -pruN 5.6.2-2.1/src/csol_c.F 5.7.1-1/src/csol_c.F
--- 5.6.2-2.1/src/csol_c.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/csol_c.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -18,11 +18,16 @@ C
      & COMM_NODES, MYID, MYID_NODES, BUFR, LBUFR, LBUFR_BYTES,
      & ISTEP_TO_INIV2, TAB_POS_IN_PERE, IBEG_ROOT_DEF, IEND_ROOT_DEF,
      & IROOT_DEF_RHS_COL1, RHS_ROOT, LRHS_ROOT, SIZE_ROOT, MASTER_ROOT,
-     & RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD, POSINRHSCOMP_BWD,
+     & RHSINTR, LRHSINTR, POSINRHSINTR_FWD, POSINRHSINTR_BWD,
+     &           Lnodes_FWD, Lnodes_BWD,
+     &           nodes_FWD, nodes_BWD,
      & NZ_RHS, NBCOL_INBLOC, NRHS_ORIG, JBEG_RHS, Step2node, LStep2node,
      & IRHS_SPARSE, IRHS_PTR, SIZE_PERM_RHS, PERM_RHS,
-     & SIZE_UNS_PERM_INV, UNS_PERM_INV, NB_FS_IN_RHSCOMP_F,
-     & NB_FS_IN_RHSCOMP_TOT, DO_NBSPARSE , RHS_BOUNDS, LRHS_BOUNDS
+     & SIZE_UNS_PERM_INV, UNS_PERM_INV, NB_FS_IN_RHSINTR_F,
+     & NB_FS_IN_RHSINTR_TOT, DO_NBSPARSE , RHS_BOUNDS, LRHS_BOUNDS
+#if defined(STAT_ES_SOLVE)
+     & , IPTR_WORKING, SIZE_IPTR_WORKING, WORKING, SIZE_WORKING
+#endif
      &  ,IPOOL_B_L0_OMP, LPOOL_B_L0_OMP, IPOOL_A_L0_OMP, LPOOL_A_L0_OMP,
      &  L_VIRT_L0_OMP, VIRT_L0_OMP, L_PHYS_L0_OMP, PHYS_L0_OMP,
      &  PERM_L0_OMP, PTR_LEAFS_L0_OMP, L0_OMP_MAPPING, LL0_OMP_MAPPING,
@@ -51,22 +56,26 @@ C
       INTEGER(8) ::  PTRFAC(KEEP(28))
       INTEGER    ::  LIWK_PTRACB
       INTEGER(8) ::  PTRACB(LIWK_PTRACB)
-      INTEGER NRHS, LRHSCOMP, NB_FS_IN_RHSCOMP_F, NB_FS_IN_RHSCOMP_TOT
+      INTEGER NRHS, LRHSINTR, NB_FS_IN_RHSINTR_F, NB_FS_IN_RHSINTR_TOT
       COMPLEX    A(LA), W(LWC), 
      &        W2(KEEP(133))
-      COMPLEX ::  RHSCOMP(LRHSCOMP,NRHS)
+      COMPLEX ::  RHSINTR(LRHSINTR,NRHS)
       INTEGER SLAVEF, COMM_NODES, MYID, MYID_NODES
-      INTEGER PROCNODE_STEPS(KEEP(28)), POSINRHSCOMP_FWD(N), 
-     &        POSINRHSCOMP_BWD(N)
+      INTEGER PROCNODE_STEPS(KEEP(28)), POSINRHSINTR_FWD(N), 
+     &        POSINRHSINTR_BWD(N)
       INTEGER LBUFR, LBUFR_BYTES
       INTEGER BUFR(LBUFR)
       INTEGER ISTEP_TO_INIV2(KEEP(71)), 
      &        TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
       INTEGER IBEG_ROOT_DEF, IEND_ROOT_DEF, IROOT_DEF_RHS_COL1
+      INTEGER NRHS_LOC
       INTEGER SIZE_ROOT, MASTER_ROOT
       INTEGER(8) :: LRHS_ROOT
       COMPLEX RHS_ROOT(LRHS_ROOT)
       LOGICAL, intent(in) :: FROM_PP 
+      INTEGER, intent(in) :: Lnodes_FWD, Lnodes_BWD
+      INTEGER, intent(in) :: nodes_FWD(max(1,Lnodes_FWD)), 
+     &                       nodes_BWD(max(1,Lnodes_BWD))
       INTEGER, intent(in)      :: NZ_RHS, NBCOL_INBLOC, NRHS_ORIG
       INTEGER, intent(in)      :: SIZE_UNS_PERM_INV 
       INTEGER, intent(in)      :: SIZE_PERM_RHS 
@@ -80,6 +89,11 @@ C
       LOGICAL, intent(in)  :: DO_NBSPARSE  
       INTEGER, intent(in)     :: LRHS_BOUNDS
       INTEGER, intent(inout)  :: RHS_BOUNDS (LRHS_BOUNDS) 
+#if defined(STAT_ES_SOLVE)
+       INTEGER, INTENT(IN) :: SIZE_WORKING, SIZE_IPTR_WORKING,
+     &                        IPTR_WORKING(SIZE_IPTR_WORKING),
+     &                        WORKING(SIZE_WORKING)
+#endif
       INTEGER, INTENT (IN) :: LPOOL_B_L0_OMP
       INTEGER, INTENT (IN) :: IPOOL_B_L0_OMP( LPOOL_B_L0_OMP )
       INTEGER, INTENT (IN) :: LPOOL_A_L0_OMP
@@ -103,6 +117,7 @@ C
       INTEGER NSTK_S,IPOOL,IPANEL_POS,PTRICB
       INTEGER MTYPE_LOC
       INTEGER MODE_RHS_BOUNDS 
+      INTEGER IPT_RHS_ROOT_LOC
       INTEGER IERR
       INTEGER(8) :: IAPOS
       INTEGER       IOLDPS,
@@ -116,26 +131,28 @@ C
       LOGICAL I_WORKED_ON_ROOT, SPECIAL_ROOT_REACHED
       INTEGER IROOT
       LOGICAL DOROOT_FWD_OOC, DOROOT_BWD_PANEL
-      LOGICAL SWITCH_OFF_ES
       LOGICAL DUMMY_BOOL
       INTEGER :: IDUMMY
       INTEGER :: NBROOT_UNDER_L0
       COMPLEX, PARAMETER :: ZERO = (0.0E0,0.0E0)
       INCLUDE 'mumps_headers.h'
-      INTEGER, DIMENSION(:), ALLOCATABLE ::  nodes_RHS
-      INTEGER nb_nodes_RHS
+      INTEGER, DIMENSION(:), POINTER             ::  nodes_BWD_PTR
+      INTEGER, DIMENSION(:), ALLOCATABLE, TARGET :: Pruned_Roots_FWD
+      INTEGER, DIMENSION(:), ALLOCATABLE, TARGET :: Pruned_Roots_NS
+      INTEGER  :: Lnodes_BWD_PTR, LPruned_Roots_NS
+      INTEGER :: Lnodes_BWD_ROOTS
       INTEGER nb_prun_leaves
       INTEGER, DIMENSION(:), ALLOCATABLE :: Pruned_Leaves
       INTEGER, DIMENSION(:), ALLOCATABLE ::  Pruned_List
       INTEGER  nb_prun_nodes
-      INTEGER nb_prun_roots, JAM1
+      INTEGER INODE_PRINC, nb_prun_roots
       INTEGER, DIMENSION(:), ALLOCATABLE ::  Pruned_SONS, Pruned_Roots
       INTEGER                            :: SIZE_TO_PROCESS
       LOGICAL, DIMENSION(:), ALLOCATABLE :: TO_PROCESS
-      INTEGER ISTEP, INODE_PRINC
+      INTEGER ISTEP
       INTEGER :: INODE, ICHILD
-      LOGICAL AM1, DO_PRUN
-      LOGICAL Exploit_Sparsity
+      LOGICAL AM1, DO_PRUN_FWD, DO_PRUN_BWD
+      LOGICAL Exploit_Sparsity_FWD, Exploit_Sparsity_BWD
       LOGICAL DO_NBSPARSE_BWD, PRUN_BELOW_BWD
       INTEGER :: OOC_FCT_TYPE_TMP
       INTEGER :: MUMPS_OOC_GET_FCT_TYPE
@@ -179,7 +196,6 @@ C
       DOFORWARD = .TRUE.
       DOBACKWARD= .TRUE.
       SPECIAL_ROOT_REACHED = .TRUE.
-      SWITCH_OFF_ES    = .FALSE.
       IF ( KEEP(111).NE.0 .OR. KEEP(252).NE.0 ) THEN
         DOFORWARD = .FALSE.
       ENDIF
@@ -202,23 +218,28 @@ C
      &                     .AND. KEEP(201).EQ.1
       DOROOT_FWD_OOC = DOROOT .AND. .NOT.DOROOT_BWD_PANEL
       AM1              = (KEEP(237) .NE. 0)
-      Exploit_Sparsity = (KEEP(235) .NE. 0) .AND. (.NOT. AM1)
-      DO_PRUN          = (Exploit_Sparsity.OR.AM1)
+      Exploit_Sparsity_FWD  = (KEEP(235) .NE. 0) .AND. (.NOT. AM1)
+      Exploit_Sparsity_BWD  = (KEEP(212) .NE. 0) .AND. (.NOT. AM1)
+      Lnodes_BWD_ROOTS = NA(2)
+      DO_PRUN_FWD          = (Exploit_Sparsity_FWD.OR.AM1)
+      DO_PRUN_BWD          = (Exploit_Sparsity_BWD.OR.AM1)
       IF (FROM_PP) THEN
-        Exploit_Sparsity = .FALSE.
-        DO_PRUN          = .FALSE.
+        Exploit_Sparsity_FWD = .FALSE.
+        DO_PRUN_FWD          = .FALSE.
+        Exploit_Sparsity_BWD = .FALSE.
+        DO_PRUN_BWD          = .FALSE.
            IF ( AM1 ) THEN
           WRITE(*,*) "Internal error 2 in CMUMPS_SOL_C"
           CALL MUMPS_ABORT()
         ENDIF
       ENDIF
-      DO_L0OMP_FWD= ( (KEEP(401).GT.0).AND.(KEEP(400).GT.0)
+      DO_L0OMP_FWD= ( (KEEP(401).EQ.1).AND.(KEEP(400).GT.0)
      &             .AND.DOFORWARD )
       DO_L0OMP_FWD = DO_L0OMP_FWD .AND. KEEP(201).EQ.0
-      DO_L0OMP_BWD = ( (KEEP(401).GT.0).AND.(KEEP(400).GT.0)
+      DO_L0OMP_BWD = ( (KEEP(401).EQ.1).AND.(KEEP(400).GT.0)
      &              .AND.DOBACKWARD )
       DO_L0OMP_BWD = DO_L0OMP_BWD .AND. KEEP(201).EQ.0
-      IF ( DO_PRUN ) THEN
+      IF ( DO_PRUN_FWD.OR.DO_PRUN_BWD ) THEN
          ALLOCATE (Pruned_SONS(KEEP(28)), stat=I)
          IF(I.GT.0) THEN
                INFO(1)=-13
@@ -227,7 +248,7 @@ C
          CALL MUMPS_PROPINFO(ICNTL, INFO, COMM_NODES, MYID )
          IF(INFO(1).LT.0) GOTO 500
       ENDIF
-      IF ( DO_PRUN 
+      IF ( DO_PRUN_FWD.OR.DO_PRUN_BWD
      &     .OR. DO_L0OMP_BWD
      &   ) THEN
          SIZE_TO_PROCESS = KEEP(28)
@@ -241,84 +262,12 @@ C
       END IF
       CALL MUMPS_PROPINFO(ICNTL, INFO, COMM_NODES, MYID )
       IF(INFO(1).LT.0) GOTO 500
-      IF ( DOFORWARD .AND. DO_PRUN ) THEN
-         nb_prun_nodes = 0
-         nb_prun_roots = 0
-         Pruned_SONS(:) = -1
-         IF ( Exploit_Sparsity ) THEN
-            nb_nodes_RHS = 0
-            DO I = 1, NZ_RHS
-               ISTEP       = abs( STEP(IRHS_SPARSE(I)) )
-               INODE_PRINC = Step2node( ISTEP )
-               IF ( Pruned_SONS(ISTEP) .eq. -1) THEN
-                  nb_nodes_RHS = nb_nodes_RHS +1
-                  Pruned_SONS(ISTEP) = 0 
-               ENDIF
-            ENDDO
-            ALLOCATE(nodes_RHS(nb_nodes_RHS), STAT = allocok)
-            IF(allocok.GT.0) THEN
-              INFO(1)=-13
-              INFO(2)=nb_nodes_RHS
-            END IF
-            CALL MUMPS_PROPINFO(ICNTL, INFO, COMM_NODES, MYID )
-            IF(INFO(1).LT.0) GOTO 500
-            nb_nodes_RHS = 0
-            Pruned_SONS = -1
-            DO I = 1, NZ_RHS
-               ISTEP       = abs( STEP(IRHS_SPARSE(I)) )
-               INODE_PRINC = Step2node( ISTEP )
-               IF ( Pruned_SONS(ISTEP) .eq. -1) THEN
-                  nb_nodes_RHS = nb_nodes_RHS +1
-                  nodes_RHS(nb_nodes_RHS)  = INODE_PRINC
-                  Pruned_SONS(ISTEP) = 0 
-               ENDIF
-            ENDDO
-         ELSE IF ( AM1 ) THEN  
-            nb_nodes_RHS = 0
-            DO I = 1, NBCOL_INBLOC
-              IF ( (IRHS_PTR(I+1)-IRHS_PTR(I)).EQ.0) CYCLE
-              IF ( (KEEP(242) .NE. 0 ).OR. (KEEP(243).NE.0) ) THEN
-                   JAM1 = PERM_RHS(JBEG_RHS+I-1)
-              ELSE
-                   JAM1 = JBEG_RHS+I-1
-              ENDIF       
-              ISTEP = abs(STEP(JAM1))
-              INODE_PRINC = Step2node(ISTEP)
-              IF ( Pruned_SONS(ISTEP) .eq. -1) THEN
-                 nb_nodes_RHS = nb_nodes_RHS +1
-                 Pruned_SONS(ISTEP) = 0                 
-              ENDIF
-            ENDDO
-            ALLOCATE(nodes_RHS(nb_nodes_RHS), STAT = allocok)
-            IF(allocok.GT.0) THEN
-               INFO(1)=-13
-               INFO(2)=nb_nodes_RHS
-            END IF
-            CALL MUMPS_PROPINFO(ICNTL, INFO, COMM_NODES, MYID )
-            IF(INFO(1).LT.0) GOTO 500
-            nb_nodes_RHS = 0
-            Pruned_SONS = -1
-            DO I = 1, NBCOL_INBLOC
-              IF ( (IRHS_PTR(I+1)-IRHS_PTR(I)).EQ.0) CYCLE
-              IF ( (KEEP(242) .NE. 0 ).OR. (KEEP(243).NE.0) ) THEN
-                   JAM1 = PERM_RHS(JBEG_RHS+I-1)
-              ELSE
-                   JAM1 = JBEG_RHS+I-1
-              ENDIF
-              ISTEP = abs(STEP(JAM1))
-              INODE_PRINC = Step2node(ISTEP)
-              IF ( Pruned_SONS(ISTEP) .eq. -1) THEN
-                 nb_nodes_RHS = nb_nodes_RHS +1
-                 nodes_RHS(nb_nodes_RHS)  = INODE_PRINC
-                 Pruned_SONS(ISTEP) = 0
-              ENDIF
-            ENDDO            
-         ENDIF                  
+      IF ( DOFORWARD .AND. DO_PRUN_FWD ) THEN
          CALL CMUMPS_CHAIN_PRUN_NODES( 
      &        .FALSE.,
      &        DAD, KEEP(28),
      &        STEP, N,
-     &        nodes_RHS, nb_nodes_RHS,
+     &        nodes_FWD, Lnodes_FWD,
      &        Pruned_SONS, TO_PROCESS,
      &        nb_prun_nodes, nb_prun_roots,
      &        nb_prun_leaves )  
@@ -347,11 +296,10 @@ C
      &        .TRUE.,
      &        DAD, KEEP(28),
      &        STEP, N,
-     &        nodes_RHS, nb_nodes_RHS,
+     &        nodes_FWD, Lnodes_FWD,
      &        Pruned_SONS, TO_PROCESS,
      &        nb_prun_nodes, nb_prun_roots, nb_prun_leaves,
      &        Pruned_List, Pruned_Roots, Pruned_Leaves )
-         IF(allocated(nodes_RHS)) DEALLOCATE(nodes_RHS)
          CALL CMUMPS_OOC_SET_STATES_ES(N,
      &          KEEP(201), Pruned_List, nb_prun_nodes,
      &          STEP)
@@ -365,11 +313,15 @@ C
      &        MYID_NODES, N, KEEP(28), KEEP(201), KEEP(485), 
      &        KEEP8(31)+KEEP8(64), 
      &        STEP, Pruned_List, nb_prun_nodes, OOC_FCT_TYPE_TMP
+#if defined(STAT_ES_SOLVE)
+     &        , NRHS, COMM_NODES, IW, LIW, PTRIST,KEEP(IXSZ),0,
+     &        KEEP(50), KEEP(38)
+#endif
      &   )
          IF (DO_NBSPARSE) THEN
            nb_sparse = max(1,KEEP(497))
            MODE_RHS_BOUNDS = 0 
-           IF (Exploit_Sparsity) MODE_RHS_BOUNDS = 2
+           IF (Exploit_Sparsity_FWD) MODE_RHS_BOUNDS = 2
            CALL CMUMPS_INITIALIZE_RHS_BOUNDS(
      &      STEP, N,
      &      IRHS_PTR, NBCOL_INBLOC, IRHS_SPARSE, NZ_RHS,
@@ -383,6 +335,10 @@ C
      &      STEP, N, Pruned_SONS,
      &      DAD, RHS_BOUNDS, KEEP(28),
      &      MYID_NODES, COMM_NODES, KEEP(485),
+#if defined(STAT_ES_SOLVE)
+     &      KEEP(46), 
+     &      IPTR_WORKING, SIZE_IPTR_WORKING, WORKING, SIZE_WORKING,
+#endif
      &      IW, LIW, PTRIST,KEEP(IXSZ),OOC_FCT_TYPE_TMP,0,
      &      KEEP(50), KEEP(38))
          END IF
@@ -416,7 +372,7 @@ C
 #if defined(V_T)
         CALL VTBEGIN(forw_soln,ierr)
 #endif
-        IF ( .NOT. DO_PRUN ) THEN
+        IF ( .NOT. DO_PRUN_FWD ) THEN
           CALL MUMPS_INIT_NROOT_DIST(N, NBROOT, MYROOT, MYID_NODES,
      &           SLAVEF, NA, LNA, KEEP, STEP, PROCNODE_STEPS)
           DO ISTEP =1, KEEP(28)
@@ -427,12 +383,20 @@ C
      &         nb_prun_roots, Pruned_Roots,
      &         MYROOT, MYID_NODES, SLAVEF, KEEP, STEP,
      &         PROCNODE_STEPS )
-          IF (AM1) THEN 
+          IF ((Exploit_Sparsity_FWD).AND.(nb_prun_roots.NE.NA(2))) THEN
+             Lnodes_BWD_ROOTS = nb_prun_roots
+            ALLOCATE(Pruned_Roots_FWD(Lnodes_BWD_ROOTS), STAT=allocok)
+            IF(allocok.GT.0) THEN
+              WRITE(*,*)'Problem with allocation of nodes_FWD'
+              INFO(1) = -13
+              INFO(2) = Lnodes_BWD_ROOTS
+              CALL MUMPS_ABORT()
+            END IF
+            Pruned_Roots_FWD(1:Lnodes_BWD_ROOTS)=
+     &                        Pruned_Roots(1:Lnodes_BWD_ROOTS)
             DEALLOCATE(Pruned_Roots)
-          END IF
-          IF ((Exploit_Sparsity).AND.(nb_prun_roots.EQ.NA(2))) THEN
+          ELSE
             DEALLOCATE(Pruned_Roots)
-            SWITCH_OFF_ES = .TRUE.   
           ENDIF
           DO ISTEP = 1, KEEP(28)
             IW1(NSTK_S+ISTEP-1) = Pruned_SONS(ISTEP)
@@ -441,7 +405,7 @@ C
         IF ( DO_L0OMP_FWD ) THEN
           KEEP(405)=1
           CALL CMUMPS_SOL_L0OMP_R( N, MTYPE_LOC, NRHS, LIW, IW,
-     &    IW1(PTRICB), RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD,
+     &    IW1(PTRICB), RHSINTR, LRHSINTR, POSINRHSINTR_FWD,
      &    STEP, FRERE, DAD, FILS, IW1(NSTK_S), 
      &    PTRIST, PTRFAC, INFO,
      &    KEEP, KEEP8, DKEEP, PROCNODE_STEPS, SLAVEF,
@@ -458,7 +422,7 @@ C
      &    PERM_L0_OMP, PTR_LEAFS_L0_OMP,
      &    L0_OMP_MAPPING, LL0_OMP_MAPPING,
      &    L0_OMP_FACTORS, LL0_OMP_FACTORS,
-     &    DO_PRUN, TO_PROCESS
+     &    DO_PRUN_FWD, TO_PROCESS
      &    )
           CALL MUMPS_STOP_ON_USER_REQUEST( KEEP, KEEP8, ICNTL,
      &                                    INFO, MYID )
@@ -469,7 +433,7 @@ C
           MYROOT = MYROOT - NBROOT_UNDER_L0
         ENDIF
         IF ( DO_L0OMP_FWD ) THEN
-          IF ( DO_PRUN ) THEN
+          IF ( DO_PRUN_FWD ) THEN
             MYLEAF_NOT_PRUNED = IPOOL_A_L0_OMP(LPOOL_A_L0_OMP)
             DO I=1, MYLEAF_NOT_PRUNED
               IF ( TO_PROCESS( STEP( IPOOL_A_L0_OMP(I) ))) THEN
@@ -513,7 +477,7 @@ C
             ENDDO
           ENDIF
         ELSE
-          IF ( DO_PRUN ) THEN
+          IF ( DO_PRUN_FWD ) THEN
             CALL MUMPS_INIT_POOL_DIST_NONA( N, MYLEAF, MYID_NODES,
      &            nb_prun_leaves, Pruned_Leaves, KEEP, KEEP8,
      &            STEP, PROCNODE_STEPS, IW1(IPOOL), LPOOL )
@@ -529,7 +493,7 @@ C
         CALL CMUMPS_SOL_R(N, A(1), LA, IW(1), LIW, W(1),
      &       LWC, NRHS,
      &       IW1(PTRICB), IWCB, LIWW,
-     &       RHSCOMP,LRHSCOMP,POSINRHSCOMP_FWD,
+     &       RHSINTR,LRHSINTR,POSINRHSINTR_FWD,
      &       STEP, FRERE,DAD,FILS,
      &       IW1(NSTK_S),IW1(IPOOL),LPOOL,PTRIST,PTRFAC,
      &       MYLEAF, MYROOT, INFO,
@@ -543,7 +507,7 @@ C
      &          , L0_OMP_MAPPING, LL0_OMP_MAPPING,
      &            L0_OMP_FACTORS, LL0_OMP_FACTORS
      &       )
-        IF (DO_PRUN) THEN
+        IF (DO_PRUN_FWD) THEN
           MYLEAF = -1
         ENDIF
 #if defined(V_T)
@@ -567,9 +531,11 @@ C
          CALL MUMPS_SECFIN(TIME_FWD)
          DKEEP(117)=real(TIME_FWD) + DKEEP(117)
       ENDIF
-      IF (DO_PRUN.AND.SWITCH_OFF_ES) THEN
-         DO_PRUN          = .FALSE.
-         Exploit_Sparsity = .FALSE.
+      IF ( .NOT.( 
+     &       DOBACKWARD.AND.
+     &      (DO_PRUN_BWD.OR.(Lnodes_BWD_ROOTS.NE.NA(2)))
+     &          )
+     &   ) THEN
          IF (.NOT. DO_L0OMP_BWD ) THEN
            IF ( allocated(TO_PROCESS) .AND. SIZE_TO_PROCESS.NE.1 ) THEN
              DEALLOCATE (TO_PROCESS)
@@ -578,58 +544,60 @@ C
            ENDIF
          ENDIF
       ENDIF
-      IF ( DOBACKWARD .AND. DO_PRUN )  THEN
-         nb_prun_leaves = 0
-        IF ( Exploit_Sparsity .AND. (KEEP(111).EQ.0) ) THEN
-          nb_nodes_RHS = nb_prun_roots
-          ALLOCATE(nodes_RHS(nb_nodes_RHS), STAT = allocok)
-          IF(allocok.GT.0) THEN
-            WRITE(*,*)'Problem with allocation of nodes_RHS'
-            INFO(1) = -13
-            INFO(2) = nb_nodes_RHS
-            CALL MUMPS_ABORT()
-          END IF
-          nodes_RHS(1:nb_prun_roots)=Pruned_Roots(1:nb_prun_roots)
-          DEALLOCATE(Pruned_Roots)
-        ELSE
-         nb_nodes_RHS = 0
-         Pruned_SONS(:) = -1 
-         DO II = 1, NZ_RHS
+      IF ( (KEEP(111).NE.0).AND.DOBACKWARD.AND.
+     &     (
+     &      DO_PRUN_BWD
+     &     )
+     &   )   THEN
+        nb_prun_leaves = 0
+        IF ( Lnodes_BWD_ROOTS.NE.NA(2) ) THEN
+          nodes_BWD_PTR => Pruned_Roots_FWD
+          Lnodes_BWD_PTR = Lnodes_BWD_ROOTS
+        ELSE IF ( (Exploit_Sparsity_BWD.AND.KEEP(111).NE.0) 
+     &          ) THEN
+          LPruned_Roots_NS = 0
+          Pruned_SONS(:)   = -1 
+          DO II = 1, NZ_RHS
             I = IRHS_SPARSE(II)
             IF (KEEP(23).NE.0) I = UNS_PERM_INV(I)          
             ISTEP = abs(STEP(I))
             IF ( Pruned_SONS(ISTEP) .eq. -1) THEN
-               nb_nodes_RHS = nb_nodes_RHS +1
+               LPruned_Roots_NS   = LPruned_Roots_NS +1
                Pruned_SONS(ISTEP) = 0
             ENDIF
-         ENDDO
-         ALLOCATE(nodes_RHS(nb_nodes_RHS), STAT = allocok)           
-         IF(allocok.GT.0) THEN
-           WRITE(*,*)'Problem with allocation of nodes_RHS'
+          ENDDO
+          ALLOCATE(Pruned_Roots_NS(LPruned_Roots_NS), STAT = allocok) 
+          IF(allocok.GT.0) THEN
+           WRITE(*,*)'Problem with allocation of nodes_BWD'
            INFO(1) = -13
-           INFO(2) = nb_nodes_RHS
+           INFO(2) = LPruned_Roots_NS
            CALL MUMPS_ABORT()
-         END IF
-         nb_nodes_RHS = 0         
-         Pruned_SONS(:) = -1  
-         DO II = 1, NZ_RHS
+          END IF
+          LPruned_Roots_NS = 0         
+          Pruned_SONS(:) = -1  
+          DO II = 1, NZ_RHS
             I = IRHS_SPARSE(II)
             IF (KEEP(23).NE.0) I = UNS_PERM_INV(I)
             ISTEP = abs(STEP(I))
             INODE_PRINC = Step2node(ISTEP)
             IF ( Pruned_SONS(ISTEP) .eq. -1) THEN
-               nb_nodes_RHS = nb_nodes_RHS +1
-               nodes_RHS(nb_nodes_RHS)  = INODE_PRINC
+               LPruned_Roots_NS = LPruned_Roots_NS +1
+               Pruned_Roots_NS(LPruned_Roots_NS)  = INODE_PRINC
                Pruned_SONS(ISTEP) = 0
             ENDIF
-         ENDDO
+          ENDDO
+          nodes_BWD_PTR => Pruned_Roots_NS
+          Lnodes_BWD_PTR = LPruned_Roots_NS
         ENDIF
-        IF ( Exploit_Sparsity ) THEN
+        IF ( 
+     &       (Exploit_Sparsity_BWD.AND.KEEP(111).NE.0) .OR.
+     &       (Lnodes_BWD_ROOTS.NE.NA(2))
+     &     ) THEN
            CALL CMUMPS_TREE_PRUN_NODES( 
      &     .FALSE.,
      &     DAD, NE_STEPS, FRERE, KEEP(28),
      &     FILS, STEP, N,
-     &     nodes_RHS, nb_nodes_RHS,
+     &     nodes_BWD_PTR, Lnodes_BWD_PTR,
      &     TO_PROCESS,
      &     nb_prun_nodes, nb_prun_roots, nb_prun_leaves
      &     )
@@ -658,27 +626,22 @@ C
      &     .TRUE.,
      &     DAD, NE_STEPS, FRERE, KEEP(28),
      &     FILS, STEP, N,
-     &     nodes_RHS, nb_nodes_RHS,
+     &     nodes_BWD_PTR, Lnodes_BWD_PTR,
      &     TO_PROCESS,
      &     nb_prun_nodes, nb_prun_roots, nb_prun_leaves,
      &     Pruned_List, Pruned_Roots, Pruned_Leaves
      &     )
+           IF(allocated(Pruned_Roots_NS)) DEALLOCATE(Pruned_Roots_NS)
+           IF(allocated(Pruned_Roots_FWD)) DEALLOCATE(Pruned_Roots_FWD)
            CALL CMUMPS_OOC_SET_STATES_ES(N,
      &          KEEP(201), Pruned_List, nb_prun_nodes,
      &          STEP)
-           IF(allocated(nodes_RHS)) DEALLOCATE(nodes_RHS)
            IF (KEEP(201).GT.0) THEN
              OOC_FCT_TYPE_TMP=MUMPS_OOC_GET_FCT_TYPE
      &                    ('B',MTYPE,KEEP(201),KEEP(50))
            ELSE
              OOC_FCT_TYPE_TMP = -5959 
            ENDIF
-           CALL CMUMPS_TREE_PRUN_NODES_STATS(
-     &          MYID_NODES, N, KEEP(28), KEEP(201),
-     &        KEEP8(31)+KEEP8(64), 
-     &          STEP,
-     &          Pruned_List,
-     &          nb_prun_nodes, OOC_FCT_TYPE_TMP)
         ENDIF
       ENDIF
       IF(KEEP(201).EQ.1.AND.DOROOT_BWD_PANEL) THEN
@@ -705,7 +668,7 @@ C
         IF ( KEEP(60) .EQ. 0 .AND. KEEP(252) .EQ. 0 ) THEN
           IF ( root%yes ) THEN
             IF (KEEP(201).GT.0) THEN
-              IF ( (Exploit_Sparsity.AND.(KEEP(111).NE.0)) .and.
+              IF ( (Exploit_Sparsity_FWD.AND.(KEEP(111).NE.0)) .and.
      &            (OOC_STATE_NODE(STEP(KEEP(38))).eq.-6) ) THEN
                   GOTO 1010
               ENDIF
@@ -756,6 +719,49 @@ C
         ENDIF
       ELSE IF ( ( KEEP(20) .NE. 0) .AND. SPECIAL_ROOT_REACHED ) THEN
         IF ( MYID_NODES .eq.  MASTER_ROOT ) THEN
+          IF ( KEEP(60) .eq. 0 ) THEN
+            IF (KEEP(201).GT.0) THEN
+              CALL CMUMPS_SOLVE_GET_OOC_NODE(
+     &              KEEP(20),PTRFAC,KEEP,A,LA,
+     &              STEP,KEEP8,N,DUMMY_BOOL,IERR)
+              IF(IERR.LT.0)THEN
+                INFO(1)=IERR
+                INFO(2)=0
+                WRITE(*,*) '** ERROR after CMUMPS_SOLVE_GET_OOC_NODE', 
+     &          INFO(1)
+                call MUMPS_ABORT()
+              ENDIF
+            END IF
+            NRHS_LOC         = NRHS
+            IPT_RHS_ROOT_LOC = 1
+            IF ( KEEP(111).NE.0 ) THEN
+              RHS_ROOT( 1: NRHS*SIZE_ROOT) = ZERO
+              NRHS_LOC = IEND_ROOT_DEF - IBEG_ROOT_DEF + 1
+              IPT_RHS_ROOT_LOC = IPT_RHS_ROOT_LOC +
+     &                           (IROOT_DEF_RHS_COL1-1)*SIZE_ROOT
+           ENDIF
+           IF (NRHS_LOC .GT. 0) THEN
+              CALL CMUMPS_SEQ_SOLVE_ROOT_SVD_QR(NRHS_LOC,
+     &             SIZE_ROOT,A( PTRFAC(
+     &             IW( PTRIST(STEP(KEEP(20)))+4+KEEP(IXSZ)))),
+     &             root, IBEG_ROOT_DEF, IEND_ROOT_DEF,
+     &             RHS_ROOT( IPT_RHS_ROOT_LOC ),
+     &             KEEP,KEEP8,
+     &             MTYPE,INFO,LWC,W(1), LP)
+        ENDIF
+            IF(KEEP(201).GT.0)THEN
+              CALL CMUMPS_FREE_FACTORS_FOR_SOLVE(KEEP(20),
+     &             PTRFAC,KEEP(28),A,LA,.FALSE.,IERR)
+              IF(IERR.LT.0)THEN
+                 INFO(1)=IERR
+                 INFO(2)=0
+                 WRITE(*,*)
+     &           '** ERROR after CMUMPS_FREE_FACTORS_FOR_SOLVE ', 
+     &           INFO(1)
+                 call MUMPS_ABORT()
+              ENDIF
+            ENDIF
+          ENDIF
         END IF 
       END IF 
       IF (.NOT.FROM_PP) THEN
@@ -773,13 +779,13 @@ C
      &    THEN
           I_WORKED_ON_ROOT = DOROOT
           IF (KEEP(38).gt.0 ) THEN
-             IF ( ( Exploit_Sparsity.AND.(KEEP(111).EQ.0) )
+             IF ( ( Exploit_Sparsity_FWD.AND.(KEEP(111).EQ.0) )
      &            .OR. AM1 ) THEN
                 IF (OOC_STATE_NODE(STEP(KEEP(38))).eq.-6) THEN
                    OOC_STATE_NODE(STEP(KEEP(38)))=-4
                 ENDIF
              ENDIF
-             IF (Exploit_Sparsity.AND.(KEEP(111).NE.0)) THEN
+             IF (Exploit_Sparsity_FWD.AND.(KEEP(111).NE.0)) THEN
                 IF (OOC_STATE_NODE(STEP(KEEP(38))).eq.-6) THEN
                    I_WORKED_ON_ROOT = .FALSE.
                 ENDIF
@@ -791,14 +797,14 @@ C
         ELSE
           DO_NBSPARSE_BWD = DO_NBSPARSE
         ENDIF
-        PRUN_BELOW_BWD = AM1
+        PRUN_BELOW_BWD = DO_PRUN_BWD .AND. KEEP(111).EQ.0
         PRUN_BELOW_BWD = PRUN_BELOW_BWD .OR. DO_L0OMP_BWD
-        IF ( AM1 ) THEN
+        IF ( DO_PRUN_BWD )  THEN
           CALL CMUMPS_CHAIN_PRUN_NODES( 
      &        .FALSE.,
      &        DAD, KEEP(28),
      &        STEP, N,
-     &        nodes_RHS, nb_nodes_RHS,
+     &        nodes_BWD, Lnodes_BWD,
      &        Pruned_SONS, TO_PROCESS,
      &        nb_prun_nodes, nb_prun_roots,
      &        nb_prun_leaves)  
@@ -823,11 +829,11 @@ C
           END IF
           CALL MUMPS_PROPINFO(ICNTL, INFO, COMM_NODES, MYID )
           IF(INFO(1).LT.0) GOTO 500
-          CALL CMUMPS_CHAIN_PRUN_NODES( 
+          CALL CMUMPS_CHAIN_PRUN_NODES(
      &        .TRUE.,
      &        DAD, KEEP(28),
      &        STEP, N,
-     &        nodes_RHS, nb_nodes_RHS,
+     &        nodes_BWD, Lnodes_BWD,
      &        Pruned_SONS, TO_PROCESS,
      &        nb_prun_nodes, nb_prun_roots, nb_prun_leaves,
      &        Pruned_List, Pruned_Roots, Pruned_Leaves )
@@ -843,6 +849,10 @@ C
           CALL CMUMPS_CHAIN_PRUN_NODES_STATS(
      &    MYID_NODES, N, KEEP(28), KEEP(201), KEEP(485), KEEP8(31),
      &    STEP, Pruned_List, nb_prun_nodes, OOC_FCT_TYPE_TMP
+#if defined(STAT_ES_SOLVE)
+     &          , NRHS, COMM_NODES, IW, LIW, PTRIST,KEEP(IXSZ),1,
+     &          KEEP(50), KEEP(38)
+#endif
      &    )
           IF (DO_NBSPARSE_BWD) THEN
             nb_sparse = max(1,KEEP(497))
@@ -859,6 +869,10 @@ C
      &       STEP, N, Pruned_SONS,
      &       DAD, RHS_BOUNDS, KEEP(28),
      &       MYID_NODES, COMM_NODES, KEEP(485),
+#if defined(STAT_ES_SOLVE)
+     &       KEEP(46), 
+     &       IPTR_WORKING, SIZE_IPTR_WORKING, WORKING, SIZE_WORKING,
+#endif     
      &       IW, LIW, PTRIST,KEEP(IXSZ),OOC_FCT_TYPE_TMP,1,
      &       KEEP(50), KEEP(38))
          END IF
@@ -882,17 +896,17 @@ C
         IF ( .NOT.SPECIAL_ROOT_REACHED ) THEN
           RHS_ROOT(1:NRHS*SIZE_ROOT) = ZERO
         ENDIF
-        IF (AM1.AND.(NB_FS_IN_RHSCOMP_F.NE.NB_FS_IN_RHSCOMP_TOT)) THEN
+        IF (AM1.AND.(NB_FS_IN_RHSINTR_F.NE.NB_FS_IN_RHSINTR_TOT)) THEN
          DO I =1, N
-           II = POSINRHSCOMP_BWD(I)
-           IF ((II.GT.0).AND.(II.GT.NB_FS_IN_RHSCOMP_F)) THEN
+           II = POSINRHSINTR_BWD(I)
+           IF ((II.GT.0).AND.(II.GT.NB_FS_IN_RHSINTR_F)) THEN
             DO K=1,NRHS
-             RHSCOMP(II, K) = ZERO
+             RHSINTR(II, K) = ZERO
             ENDDO
            ENDIF
          ENDDO
         ENDIF
-        IF ( .NOT. DO_PRUN ) THEN
+        IF ( .NOT. DO_PRUN_BWD ) THEN
            IF ( .NOT. DO_L0OMP_BWD ) THEN
              IF (DO_L0OMP_FWD) THEN
                MYLEAF = -1
@@ -988,7 +1002,7 @@ C
               IF ( .NOT. MUMPS_IN_OR_ROOT_SSARBR(PROCNODE_STEPS(I),
      &        KEEP(199)) ) THEN
                 IF ( L0_OMP_MAPPING(I) .EQ. 0 ) THEN
-                  IF ( DO_PRUN
+                  IF ( DO_PRUN_BWD
      &                 .OR. DO_L0OMP_BWD 
      &               ) THEN
                     IF ( TO_PROCESS(I) ) THEN
@@ -1007,7 +1021,7 @@ C
       IF(INFO(1).LT.0) GOTO 500
         CALL CMUMPS_SOL_S( N, A, LA, IW, LIW, W(1), LWC,
      &          NRHS,
-     &          RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &          RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &          IW1(PTRICB),PTRACB,IWCB,LIWW, W2,
      &          NE_STEPS,
      &          STEP, FRERE,DAD,FILS,
@@ -1023,7 +1037,7 @@ C
      &          , L0_OMP_MAPPING, LL0_OMP_MAPPING,
      &            L0_OMP_FACTORS, LL0_OMP_FACTORS
      &          )
-        IF ( DO_L0OMP_BWD .AND. DO_PRUN ) THEN
+        IF ( DO_L0OMP_BWD .AND. DO_PRUN_BWD ) THEN
           DO I = 1, L_PHYS_L0_OMP
             IF ( PHYS_L0_OMP( I ) .LT. 0 ) THEN
               PHYS_L0_OMP( I ) = -PHYS_L0_OMP( I )
@@ -1034,10 +1048,10 @@ C
         CALL MUMPS_STOP_ON_USER_REQUEST(KEEP, KEEP8, ICNTL, INFO, MYID)
         IF (DO_L0OMP_BWD .AND. INFO(1) .GE. 0) THEN
           KEEP(31) = 0
-          PRUN_BELOW_BWD = AM1
+          PRUN_BELOW_BWD = DO_PRUN_BWD .AND. KEEP(111).EQ.0
           KEEP(405)=1
           CALL CMUMPS_SOL_L0OMP_S(N, MTYPE_LOC, NRHS, LIW, IW,
-     &      IW1(PTRICB), PTRACB, RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &      IW1(PTRICB), PTRACB, RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &      STEP, FRERE, FILS, NE_STEPS, PTRIST, PTRFAC, INFO,
      &      KEEP, KEEP8, DKEEP, PROCNODE_STEPS, SLAVEF,
      &      COMM_NODES, MYID_NODES, BUFR, LBUFR, LBUFR_BYTES, 
@@ -1070,21 +1084,24 @@ C
       ENDIF
       IF (LDIAG.GT.2 .AND. MP.GT.0) THEN
         IF (DOFORWARD) THEN
-        K = min0(10,size(RHSCOMP,1))
-        IF (LDIAG.EQ.4) K = size(RHSCOMP,1)
+        K = min(10,size(RHSINTR,1))
+        IF (LDIAG.EQ.4) K = size(RHSINTR,1)
         IF ( .NOT. FROM_PP) THEN
           WRITE (MP,99992)
-          IF (size(RHSCOMP,1).GT.0) 
-     &    WRITE (MP,99993) (RHSCOMP(I,1),I=1,K)
-          IF (size(RHSCOMP,1).GT.0.and.NRHS>1) 
-     &              WRITE (MP,99994) (RHSCOMP(I,2),I=1,K)
+          IF (size(RHSINTR,1).GT.0) 
+     &    WRITE (MP,99993) (RHSINTR(I,1),I=1,K)
+          IF (size(RHSINTR,1).GT.0.and.NRHS>1) 
+     &              WRITE (MP,99994) (RHSINTR(I,2),I=1,K)
           ENDIF
         ENDIF
       ENDIF
 500   CONTINUE
       IF ( allocated(TO_PROCESS)) DEALLOCATE (TO_PROCESS)
-      IF (Exploit_Sparsity.OR.AM1.OR.SWITCH_OFF_ES) THEN
-         IF ( allocated(nodes_RHS)) DEALLOCATE (nodes_RHS)
+      IF (DO_PRUN_FWD.OR.DO_PRUN_BWD) THEN
+         IF ( allocated(Pruned_Roots_FWD)) 
+     &        DEALLOCATE (Pruned_Roots_FWD)
+         IF ( allocated(Pruned_Roots_NS)) 
+     &        DEALLOCATE (Pruned_Roots_NS)
          IF ( allocated(Pruned_SONS)) DEALLOCATE (Pruned_SONS)
          IF ( allocated(Pruned_Roots)) DEALLOCATE (Pruned_Roots)
          IF ( allocated(Pruned_List)) DEALLOCATE (Pruned_List)
@@ -1095,20 +1112,81 @@ C
 99994 FORMAT (' RHS (internal, 2 nd  column)'/(1X,1P,5E14.6))
 99992 FORMAT (//' LEAVING SOLVE (CMUMPS_SOL_C) WITH')
       END SUBROUTINE CMUMPS_SOL_C
+      SUBROUTINE CMUMPS_SET_POSTPros (KEEP, ICNTL, NBRHS, MPG, PROKG, 
+     &                               ICNTL10, ICNTL11, POSTPros)
+      IMPLICIT NONE
+      INTEGER, INTENT(IN)  :: KEEP(500), ICNTL(60), NBRHS, MPG
+      LOGICAL, INTENT(IN)  :: PROKG
+      INTEGER, INTENT(OUT) :: ICNTL10, ICNTL11
+      LOGICAL, INTENT(OUT) :: POSTPros
+      POSTPros = .FALSE.
+      IF (ICNTL11.NE.0 .OR. ICNTL10.NE.0) THEN
+        POSTPros = .TRUE.
+        IF (KEEP(111).NE.0) THEN
+            IF (PROKG) WRITE(MPG,'(A,A)')
+     &     ' WARNING: Incompatible features: null space basis',
+     &              ' and Iter. Ref and/or Err. Anal.'
+            POSTPros = .FALSE.
+        ELSE IF ( KEEP(237) .NE.0 ) THEN
+            IF (PROKG) WRITE(MPG,'(A,A)')
+     &     ' WARNING: Incompatible features: AM1',
+     &              ' and Iter. Ref and/or Err. Anal.'
+            POSTPros = .FALSE.
+        ELSE IF ( KEEP(252) .NE.0 ) THEN
+            IF (PROKG) WRITE(MPG,'(A,A)')
+     &     ' WARNING: Incompatible features: Fwd in facto ',
+     &              ' and Iter. Ref and/or Err. Anal.'
+            POSTPros = .FALSE.
+        ELSE IF (KEEP(221).NE.0) THEN
+            IF (PROKG) WRITE(MPG,'(A,A)')
+     &     ' WARNING: Incompatible features: reduced RHS',
+     &     ' and Iter. Ref and/or Err. Anal.'
+            POSTPros = .FALSE.
+        ELSE IF  (NBRHS.GT. 1 .OR. ICNTL(21) .GT. 0) THEN
+            IF (PROKG) WRITE(MPG,'(A,A)')
+     &     ' WARNING:  Incompatible features: nrhs>1 or distrib sol',
+     &     ' and Iter. Ref and/or Err. Anal.'
+            POSTPros = .FALSE.
+        ELSE IF ( KEEP(248) .EQ. -1 ) THEN
+            IF (PROKG) WRITE(MPG,'(A,A)')
+     &     ' WARNING:  Incompatible features: distrib rhs',
+     &     ' and Iter. Ref and/or Err. Anal.'
+            POSTPros = .FALSE.
+        ENDIF  
+        IF (.NOT.POSTPros) THEN
+          ICNTL11 = 0
+          ICNTL10 = 0
+        ENDIF
+      ENDIF
+      IF ((ICNTL(10) .NE. 0) .AND. (ICNTL10 .EQ. 0)) THEN
+          IF (PROKG) WRITE(MPG,'(A)')
+     &  ' WARNING: ICNTL(10) treated as if set to 0 '
+      ENDIF
+      IF ((ICNTL(11) .NE. 0)
+     &      .AND.(ICNTL11 .EQ. 0)) THEN
+          IF (PROKG) WRITE(MPG,'(A)')
+     &  ' WARNING: ICNTL(11) treated as if set to 0 '
+      ENDIF
+      RETURN
+      END SUBROUTINE CMUMPS_SET_POSTPros
       SUBROUTINE CMUMPS_GATHER_SOLUTION( NSLAVES, N, MYID, COMM,
      &           NRHS,
      &           MTYPE, RHS, LRHS, NCOL_RHS, JBEG_RHS, PTRIST,
      &           KEEP,KEEP8, PROCNODE_STEPS, IW, LIW, STEP, BUFFER,
      &           SIZE_BUF, SIZE_BUF_BYTES, CWORK, LCWORK,
+#if defined(USE_OLD_SCALING)
      &           LSCAL, SCALING, LSCALING, 
-     &           RHSCOMP, LRHSCOMP, NCOL_RHSCOMP, 
-     &           POSINRHSCOMP, LPOS_N, PERM_RHS, SIZE_PERM_RHS )
+#else
+     &           LSCAL, SCALING_LOC_BWD, LSCALING_LOC_BWD, 
+#endif
+     &           RHSINTR, LRHSINTR, NCOL_RHSINTR, 
+     &           POSINRHSINTR, LPOS_N, PERM_RHS, SIZE_PERM_RHS )
 !$    USE OMP_LIB
       IMPLICIT NONE
       INCLUDE 'mpif.h'
       INCLUDE 'mumps_tags.h'
       INTEGER NSLAVES, N, MYID, COMM, LIW, MTYPE, NCOL_RHS
-      INTEGER NRHS, LRHS, LCWORK, LPOS_N, NCOL_RHSCOMP
+      INTEGER NRHS, LRHS, LCWORK, LPOS_N, NCOL_RHSINTR
       COMPLEX RHS   (LRHS, NCOL_RHS)
       INTEGER, INTENT(in) :: JBEG_RHS
       INTEGER KEEP(500)
@@ -1118,11 +1196,17 @@ C
       INTEGER IW(LIW), STEP(N)
       INTEGER SIZE_BUF, SIZE_BUF_BYTES
       INTEGER BUFFER(SIZE_BUF)
-      INTEGER LRHSCOMP, POSINRHSCOMP(LPOS_N) 
-      COMPLEX, intent(in) :: RHSCOMP(LRHSCOMP, NCOL_RHSCOMP)
-      LOGICAL, intent(in) :: LSCAL
+      INTEGER LRHSINTR, POSINRHSINTR(LPOS_N) 
+#if defined(USE_OLD_SCALING)
+      COMPLEX, intent(in) :: RHSINTR(LRHSINTR, NCOL_RHSINTR)
       INTEGER, intent(in) :: LSCALING
       REAL, intent(in)    :: SCALING(LSCALING)
+#else
+      COMPLEX, intent(inout) :: RHSINTR(LRHSINTR, NCOL_RHSINTR)
+      INTEGER, intent(in) :: LSCALING_LOC_BWD
+      REAL, intent(in) :: SCALING_LOC_BWD(LSCALING_LOC_BWD)
+#endif
+      LOGICAL, intent(in) :: LSCAL
       INTEGER, INTENT(in) :: SIZE_PERM_RHS
       INTEGER, INTENT(in) :: PERM_RHS(SIZE_PERM_RHS)
       INTEGER I, II, J, J1, ISTEP, MASTER,
@@ -1133,7 +1217,7 @@ C
       PARAMETER(MASTER=0)
       LOGICAL I_AM_SLAVE
       INTEGER RECORD_SIZE_P_1, SIZE1, SIZE2
-      INTEGER POS_BUF, N2SEND, IPOSINRHSCOMP
+      INTEGER POS_BUF, N2SEND, IPOSINRHSINTR
       INTEGER :: JCOL_RHS
       INTEGER :: K242
       LOGICAL :: OMP_FLAG
@@ -1167,7 +1251,7 @@ C
              ENDIF
              IF (OMP_FLAG) THEN
 !$OMP PARALLEL FIRSTPRIVATE(JBEG_RHS,N,K242)
-!$OMP&  PRIVATE(J,IPOSINRHSCOMP,I,JCOL_RHS)
+!$OMP&  PRIVATE(J,IPOSINRHSINTR,I,JCOL_RHS)
                DO J=1, NRHS
                  IF (K242.EQ.0) THEN
                    JCOL_RHS = J+JBEG_RHS-1
@@ -1176,10 +1260,14 @@ C
                  ENDIF
 !$OMP DO SCHEDULE(DYNAMIC,CHUNK)
                  DO I=1, N
-                   IPOSINRHSCOMP = POSINRHSCOMP(I)
-                   IF (IPOSINRHSCOMP.GT.0) THEN 
-                     RHS(I,JCOL_RHS) =
-     &                   RHSCOMP(IPOSINRHSCOMP,J)*SCALING(I)
+                   IPOSINRHSINTR = POSINRHSINTR(I)
+                   IF (IPOSINRHSINTR.GT.0) THEN 
+                     RHS(I,JCOL_RHS) = RHSINTR(IPOSINRHSINTR,J)*
+#if defined(USE_OLD_SCALING)
+     &               SCALING(I)
+#else
+     &               SCALING_LOC_BWD(IPOSINRHSINTR)
+#endif
                    ELSE
                     RHS(I,JCOL_RHS) = ZERO
                   ENDIF
@@ -1195,10 +1283,14 @@ C
                    JCOL_RHS = PERM_RHS(J+JBEG_RHS-1)
                  ENDIF
                  DO I=1, N
-                   IPOSINRHSCOMP = POSINRHSCOMP(I)
-                   IF (IPOSINRHSCOMP.GT.0) THEN 
-                     RHS(I,JCOL_RHS) =
-     &                   RHSCOMP(IPOSINRHSCOMP,J)*SCALING(I)
+                   IPOSINRHSINTR = POSINRHSINTR(I)
+                   IF (IPOSINRHSINTR.GT.0) THEN 
+                     RHS(I,JCOL_RHS) = RHSINTR(IPOSINRHSINTR,J)*
+#if defined(USE_OLD_SCALING)
+     &               SCALING(I)
+#else
+     &               SCALING_LOC_BWD(IPOSINRHSINTR)
+#endif
                    ELSE
                      RHS(I,JCOL_RHS) = ZERO
                    ENDIF
@@ -1221,7 +1313,7 @@ C
              ENDIF
              IF (OMP_FLAG) THEN
 !$OMP PARALLEL FIRSTPRIVATE(JBEG_RHS,N,K242)
-!$OMP&  PRIVATE(IPOSINRHSCOMP,I,JCOL_RHS) IF (OMP_FLAG)
+!$OMP&  PRIVATE(IPOSINRHSINTR,I,JCOL_RHS) IF (OMP_FLAG)
                DO J=1, NRHS
                  IF (K242.EQ.0) THEN
                    JCOL_RHS = J+JBEG_RHS-1
@@ -1230,9 +1322,9 @@ C
                  ENDIF
 !$OMP DO SCHEDULE(DYNAMIC,CHUNK)
                  DO I=1, N
-                   IPOSINRHSCOMP = POSINRHSCOMP(I)
-                   IF (IPOSINRHSCOMP.GT.0) THEN
-                     RHS(I,JCOL_RHS) = RHSCOMP(IPOSINRHSCOMP,J)
+                   IPOSINRHSINTR = POSINRHSINTR(I)
+                   IF (IPOSINRHSINTR.GT.0) THEN
+                     RHS(I,JCOL_RHS) = RHSINTR(IPOSINRHSINTR,J)
                    ELSE
                      RHS(I,JCOL_RHS) = ZERO
                    ENDIF
@@ -1248,9 +1340,9 @@ C
                    JCOL_RHS = PERM_RHS(J+JBEG_RHS-1)
                  ENDIF
                  DO I=1, N
-                   IPOSINRHSCOMP = POSINRHSCOMP(I)
-                   IF (IPOSINRHSCOMP.GT.0) THEN
-                     RHS(I,JCOL_RHS) = RHSCOMP(IPOSINRHSCOMP,J)
+                   IPOSINRHSINTR = POSINRHSINTR(I)
+                   IF (IPOSINRHSINTR.GT.0) THEN
+                     RHS(I,JCOL_RHS) = RHSINTR(IPOSINRHSINTR,J)
                    ELSE
                      RHS(I,JCOL_RHS) = ZERO
                    ENDIF
@@ -1339,15 +1431,20 @@ C
             CALL MPI_UNPACK(BUFFER, SIZE_BUF_BYTES, POS_BUF,
      &                 CWORK, NPIV, MPI_COMPLEX,
      &                 COMM, IERR)
+#if defined(USE_OLD_SCALING)
             IF (LSCAL) THEN
               DO I=1,NPIV
                 RHS(IROWlist(I),JCOL_RHS)=CWORK(I)*SCALING(IROWlist(I))
               ENDDO
             ELSE
+#else
+#endif
               DO I=1,NPIV
                 RHS(IROWlist(I),JCOL_RHS)=CWORK(I)
               ENDDO
+#if defined(USE_OLD_SCALING)
             ENDIF
+#endif
           ENDDO
           N2RECV=N2RECV-NPIV
           CALL MPI_UNPACK( BUFFER, SIZE_BUF_BYTES, POS_BUF,
@@ -1361,11 +1458,11 @@ C
         SUBROUTINE CMUMPS_NPIV_BLOCK_ADD ( ON_MASTER )
         LOGICAL, intent(in) ::  ON_MASTER     
         INTEGER :: JPOS, K242
-        LOGICAL :: LOCAL_LSCAL
+        LOGICAL :: PRIV_LSCAL
         IF (ON_MASTER) THEN
         IF (KEEP(350).EQ.2
      &  .AND. (NRHS.EQ.1.OR.((NPIV*NRHS*2*KEEP(16)).GE.KEEP(364)))) THEN
-          LOCAL_LSCAL = LSCAL
+          PRIV_LSCAL = LSCAL
           K242 = KEEP(242)
           DO J=1, NRHS
             IF (K242.EQ.0) THEN
@@ -1375,53 +1472,67 @@ C
             ENDIF
             DO II=1,NPIV
               I=IW(J1+II-1)
-              IPOSINRHSCOMP= POSINRHSCOMP(I) 
-              IF (LOCAL_LSCAL) THEN
-                RHS(I,JPOS) = RHSCOMP(IPOSINRHSCOMP,J)*SCALING(I)
+              IPOSINRHSINTR= POSINRHSINTR(I) 
+              IF (PRIV_LSCAL) THEN
+                RHS(I,JPOS) = RHSINTR(IPOSINRHSINTR,J)*
+#if defined(USE_OLD_SCALING)
+     &          SCALING(I)
+#else
+     &          SCALING_LOC_BWD(IPOSINRHSINTR)
+#endif
               ELSE
-                RHS(I,JPOS) = RHSCOMP(IPOSINRHSCOMP,J)
+                RHS(I,JPOS) = RHSINTR(IPOSINRHSINTR,J)
               ENDIF
             ENDDO
           ENDDO
         ELSE
          IF (KEEP(242).EQ.0) THEN
            IF (LSCAL) THEN
-            DO II=1,NPIV
+             DO II=1,NPIV
                 I=IW(J1+II-1)
-                IPOSINRHSCOMP= POSINRHSCOMP(I) 
+                IPOSINRHSINTR= POSINRHSINTR(I) 
                 DO J=1, NRHS
-                  RHS(I,J+JBEG_RHS-1) =
-     &               RHSCOMP(IPOSINRHSCOMP,J)*SCALING(I)
+                  RHS(I,J+JBEG_RHS-1) = RHSINTR(IPOSINRHSINTR,J)*
+#if defined(USE_OLD_SCALING)
+     &            SCALING(I)
+#else
+     &            SCALING_LOC_BWD(IPOSINRHSINTR)
+#endif
                 ENDDO
-            ENDDO
+             ENDDO
            ELSE
-            DO II=1,NPIV
+             DO II=1,NPIV
                 I=IW(J1+II-1)
-                IPOSINRHSCOMP= POSINRHSCOMP(I)
+                IPOSINRHSINTR= POSINRHSINTR(I)
                 DO J=1, NRHS
-                  RHS(I,J+JBEG_RHS-1) = RHSCOMP(IPOSINRHSCOMP,J)
+                  RHS(I,J+JBEG_RHS-1) = RHSINTR(IPOSINRHSINTR,J)
                 ENDDO
-            ENDDO
+             ENDDO
            ENDIF
          ELSE
            IF (LSCAL) THEN
               DO II=1,NPIV
                 I=IW(J1+II-1)
-                IPOSINRHSCOMP= POSINRHSCOMP(I)
+                IPOSINRHSINTR= POSINRHSINTR(I)
 !DIR$ NOVECTOR
                 DO J=1, NRHS
                   RHS(I,PERM_RHS(J+JBEG_RHS-1)) =
-     &               RHSCOMP(IPOSINRHSCOMP,J)*SCALING(I)
+     &               RHSINTR(IPOSINRHSINTR,J)*
+#if defined(USE_OLD_SCALING)
+     &               SCALING(I)
+#else
+     &               SCALING_LOC_BWD(IPOSINRHSINTR)
+#endif
                 ENDDO
               ENDDO
            ELSE
               DO II=1,NPIV
                 I=IW(J1+II-1)
-                IPOSINRHSCOMP= POSINRHSCOMP(I)
+                IPOSINRHSINTR= POSINRHSINTR(I)
 !DIR$ NOVECTOR
                 DO J=1, NRHS
                   RHS(I,PERM_RHS(J+JBEG_RHS-1)) =
-     &               RHSCOMP(IPOSINRHSCOMP,J)
+     &               RHSINTR(IPOSINRHSINTR,J)
                 ENDDO
               ENDDO
            ENDIF
@@ -1433,9 +1544,17 @@ C
      &                SIZE_BUF_BYTES, POS_BUF, COMM, IERR )
         CALL MPI_PACK(IW(J1), NPIV, MPI_INTEGER, BUFFER,
      &                SIZE_BUF_BYTES, POS_BUF, COMM, IERR )
-        IPOSINRHSCOMP= POSINRHSCOMP(IW(J1)) 
+        IPOSINRHSINTR= POSINRHSINTR(IW(J1)) 
         DO J=1,NRHS
-          CALL MPI_PACK(RHSCOMP(IPOSINRHSCOMP,J), NPIV,
+#if ! defined(USE_OLD_SCALING)
+          IF (LSCAL) THEN
+            DO II=IPOSINRHSINTR, IPOSINRHSINTR+NPIV-1
+              RHSINTR(II,J)=
+     &        RHSINTR(II,J)*SCALING_LOC_BWD(II)
+            ENDDO
+          ENDIF
+#endif
+          CALL MPI_PACK(RHSINTR(IPOSINRHSINTR,J), NPIV,
      &              MPI_COMPLEX,
      &              BUFFER, SIZE_BUF_BYTES, POS_BUF, COMM,
      &              IERR)
@@ -1459,38 +1578,47 @@ C
         END SUBROUTINE CMUMPS_NPIV_BLOCK_SEND
       END SUBROUTINE CMUMPS_GATHER_SOLUTION
       SUBROUTINE CMUMPS_GATHER_SOLUTION_AM1(NSLAVES, N, MYID, COMM,
-     &           NRHS, RHSCOMP,  LRHSCOMP, NRHSCOMP_COL,
+     &           NRHS, RHSINTR,  LRHSINTR, NRHSINTR_COL,
      &           KEEP, BUFFER,
      &           SIZE_BUF, SIZE_BUF_BYTES, 
+#if defined(USE_OLD_SCALING)
      &           LSCAL, SCALING, LSCALING,
+#else
+     &           LSCAL, SCALING_LOC_BWD, LSCALING_LOC_BWD, 
+#endif
      &          IRHS_PTR_COPY, LIRHS_PTR_COPY, 
      &          IRHS_SPARSE_COPY, LIRHS_SPARSE_COPY,
      &          RHS_SPARSE_COPY, LRHS_SPARSE_COPY,
      &          UNS_PERM_INV, LUNS_PERM_INV,
-     &          POSINRHSCOMP, LPOS_ROW, NB_FS_IN_RHSCOMP )
+     &          POSINRHSINTR, LPOS_ROW, NB_FS_IN_RHSINTR )
       IMPLICIT NONE
       INCLUDE 'mpif.h'
       INCLUDE 'mumps_tags.h'
       INTEGER NSLAVES, N, MYID, COMM
-      INTEGER NRHS, LRHSCOMP, NRHSCOMP_COL 
-      COMPLEX, intent(in) :: RHSCOMP (LRHSCOMP, NRHSCOMP_COL)
+      INTEGER NRHS, LRHSINTR, NRHSINTR_COL 
+      COMPLEX, intent(in) :: RHSINTR (LRHSINTR, NRHSINTR_COL)
       INTEGER KEEP(500)
       INTEGER SIZE_BUF, SIZE_BUF_BYTES, LPOS_ROW
       INTEGER BUFFER(SIZE_BUF)
       INTEGER, intent(in) :: LIRHS_PTR_COPY, LIRHS_SPARSE_COPY, 
      &                       LRHS_SPARSE_COPY, LUNS_PERM_INV, 
-     &                       NB_FS_IN_RHSCOMP
+     &                       NB_FS_IN_RHSINTR
       INTEGER :: IRHS_SPARSE_COPY(LIRHS_SPARSE_COPY), 
      &           IRHS_PTR_COPY(LIRHS_PTR_COPY), 
      &           UNS_PERM_INV(LUNS_PERM_INV), 
-     &           POSINRHSCOMP(LPOS_ROW) 
+     &           POSINRHSINTR(LPOS_ROW) 
       COMPLEX :: RHS_SPARSE_COPY(LRHS_SPARSE_COPY)
-      LOGICAL, intent(in) :: LSCAL
+#if defined(USE_OLD_SCALING)
       INTEGER, intent(in) :: LSCALING
       REAL, intent(in)    :: SCALING(LSCALING)
+#else
+      INTEGER, intent(in) :: LSCALING_LOC_BWD
+      REAL, intent(in) :: SCALING_LOC_BWD(LSCALING_LOC_BWD)
+#endif
+      LOGICAL, intent(in) :: LSCAL
       INTEGER COLSIZE, K, IZ, IPREV, NBCOL_INBLOC
       INTEGER I, II, J, MASTER,
-     &         TYPE_PARAL, N2RECV, IPOSINRHSCOMP
+     &         TYPE_PARAL, N2RECV, IPOSINRHSINTR
       INTEGER :: STATUS(MPI_STATUS_SIZE)
       INTEGER :: IERR
       PARAMETER(MASTER=0)
@@ -1510,15 +1638,20 @@ C
            DO IZ=IRHS_PTR_COPY(J), IRHS_PTR_COPY(J+1)-1
              I = IRHS_SPARSE_COPY(IZ)
              IF (KEEP(23).NE.0) I = UNS_PERM_INV(I)
-             IPOSINRHSCOMP = POSINRHSCOMP(I)
-             IF (IPOSINRHSCOMP.GT.0) THEN 
+             IPOSINRHSINTR = POSINRHSINTR(I)
+             IF (IPOSINRHSINTR.GT.0) THEN 
                 IF (LSCAL) THEN
-                 RHS_SPARSE_COPY(IZ)=
-     &                      RHSCOMP(IPOSINRHSCOMP,K)*SCALING(I)
+                  RHS_SPARSE_COPY(IZ)=
+     &                      RHSINTR(IPOSINRHSINTR,K)
+#if defined(USE_OLD_SCALING)
+     &                      * SCALING(I)
+#else
+     &                      * SCALING_LOC_BWD(IPOSINRHSINTR)
+#endif
                 ELSE
-                 RHS_SPARSE_COPY(IZ)=RHSCOMP(IPOSINRHSCOMP,K)
+                  RHS_SPARSE_COPY(IZ)=RHSINTR(IPOSINRHSINTR,K)
                 ENDIF
-             ENDIF          
+             ENDIF
            ENDDO
            K = K + 1
         ENDDO
@@ -1532,9 +1665,18 @@ C
            DO IZ=IRHS_PTR_COPY(J), IRHS_PTR_COPY(J+1)-1
              I = IRHS_SPARSE_COPY(IZ)
              IF (KEEP(23).NE.0) I = UNS_PERM_INV(I)
-             IPOSINRHSCOMP = POSINRHSCOMP(I)
-             IF (IPOSINRHSCOMP.GT.0) THEN 
-               RHS_SPARSE_COPY(IZ)=RHSCOMP(IPOSINRHSCOMP,K)
+             IPOSINRHSINTR = POSINRHSINTR(I)
+             IF (IPOSINRHSINTR.GT.0) THEN 
+#if ! defined(USE_OLD_SCALING)
+               IF (LSCAL) THEN
+                 RHS_SPARSE_COPY(IZ)=RHSINTR(IPOSINRHSINTR,K)
+     &           * SCALING_LOC_BWD(IPOSINRHSINTR)
+               ELSE
+#endif
+                 RHS_SPARSE_COPY(IZ)=RHSINTR(IPOSINRHSINTR,K)
+#if ! defined(USE_OLD_SCALING)
+               ENDIF
+#endif
              ENDIF          
            ENDDO
            K = K + 1
@@ -1566,19 +1708,25 @@ C
              I = IRHS_SPARSE_COPY(IZ)
              II = I
              IF  (KEEP(23).NE.0) II = UNS_PERM_INV(I)
-             IPOSINRHSCOMP = POSINRHSCOMP(II)
-             IF (IPOSINRHSCOMP.GT.0) THEN
+             IPOSINRHSINTR = POSINRHSINTR(II)
+             IF (IPOSINRHSINTR.GT.0) THEN
                IF (MYID .EQ. MASTER) THEN
                   N2RECV=N2RECV-1
+#if defined(USE_OLD_SCALING)
                   IF (LSCAL) 
      &            CALL CMUMPS_AM1_BLOCK_ADD ( .TRUE. )
+#endif
                   IRHS_SPARSE_COPY( IRHS_PTR_COPY(J) + K) =
      &               I
                   RHS_SPARSE_COPY( IRHS_PTR_COPY(J) + K) =
      &                RHS_SPARSE_COPY(IZ)
                   K = K+1 
                ELSE
-                  CALL CMUMPS_AM1_BLOCK_ADD (  .FALSE. )
+#if defined(USE_OLD_SCALING)
+                  CALL CMUMPS_AM1_BLOCK_ADD ( .FALSE. )
+#else
+                  CALL CMUMPS_AM1_BLOCK_ADD ()
+#endif
                ENDIF
               ENDIF          
             ENDDO
@@ -1603,10 +1751,12 @@ C
           CALL MPI_UNPACK(BUFFER, SIZE_BUF_BYTES, POS_BUF,
      &             RHS_SPARSE_COPY(IZ), 1, MPI_COMPLEX,
      &             COMM, IERR)
+#if defined(USE_OLD_SCALING)
           IF (LSCAL) THEN
               IF (KEEP(23).NE.0) I = UNS_PERM_INV(I)
               RHS_SPARSE_COPY(IZ) = RHS_SPARSE_COPY(IZ)*SCALING(I)    
           ENDIF
+#endif
           N2RECV=N2RECV-1
           IRHS_PTR_COPY(J) = IRHS_PTR_COPY(J) + 1
           CALL MPI_UNPACK( BUFFER, SIZE_BUF_BYTES, POS_BUF,
@@ -1622,10 +1772,21 @@ C
       ENDIF
       RETURN
       CONTAINS
-        SUBROUTINE CMUMPS_AM1_BLOCK_ADD ( SCALE_ONLY )
+        SUBROUTINE CMUMPS_AM1_BLOCK_ADD (
+#if defined(USE_OLD_SCALING)
+     &                                    SCALE_ONLY 
+#endif
+     &                                               )
+#if defined(USE_OLD_SCALING)
         LOGICAL, intent(in) ::  SCALE_ONLY    
+#endif
+#if defined(USE_OLD_SCALING)
         INTEGER III
+#endif
+#if defined(USE_OLD_SCALING)
         IF (SCALE_ONLY) THEN
+          WRITE(*,*) "CMUMPS_AM1_BLOCK_ADD(true) should not be called"
+          CALL MUMPS_ABORT()
          III = I
          IF (KEEP(23).NE.0) III = UNS_PERM_INV(I)
          IF (LSCAL) THEN
@@ -1633,6 +1794,7 @@ C
          ENDIF
          RETURN
         ENDIF
+#endif
         CALL MPI_PACK(J, 1, MPI_INTEGER, BUFFER,
      &                SIZE_BUF_BYTES, POS_BUF, COMM, IERR )
         CALL MPI_PACK(I, 1, MPI_INTEGER, BUFFER,
@@ -1661,8 +1823,11 @@ C
       SUBROUTINE CMUMPS_DISTSOL_INDICES(MTYPE, ISOL_LOC,
      &             PTRIST, KEEP,KEEP8,
      &             IW, LIW_PASSED, MYID_NODES, N, STEP,
-     &             PROCNODE, NSLAVES, scaling_data, LSCAL
-     &             , IRHS_loc_MEANINGFUL, IRHS_loc, Nloc_RHS
+     &             PROCNODE, NSLAVES,
+#if defined(USE_OLD_SCALING)
+     &             scaling_data, LSCAL,
+#endif
+     &             IRHS_loc_MEANINGFUL, IRHS_loc, Nloc_RHS
      &             )
       IMPLICIT NONE
       INTEGER MTYPE, MYID_NODES, N, NSLAVES
@@ -1673,16 +1838,21 @@ C
       INTEGER LIW_PASSED
       INTEGER IW(LIW_PASSED)
       INTEGER STEP(N)
+#if defined(USE_OLD_SCALING)
       LOGICAL LSCAL
+#endif
       LOGICAL :: IRHS_loc_MEANINGFUL
       INTEGER :: Nloc_RHS
       INTEGER :: IRHS_loc(Nloc_RHS)
+#if defined(USE_OLD_SCALING)
       type scaling_data_t
         SEQUENCE
         REAL, dimension(:), pointer :: SCALING
         REAL, dimension(:), pointer :: SCALING_LOC
+        INTEGER, dimension(:), pointer :: SCALING_IND 
       end type scaling_data_t
       type (scaling_data_t) :: scaling_data
+#endif
       INTEGER MUMPS_PROCNODE
       EXTERNAL MUMPS_PROCNODE
       INTEGER ISTEP, K
@@ -1720,49 +1890,103 @@ C
                     ENDIF
                   ENDIF
                   ISOL_LOC(K)=IW(JJ)
+#if defined(USE_OLD_SCALING)
                   IF (LSCAL) THEN
                     scaling_data%SCALING_LOC(K)=
      &              scaling_data%SCALING(IW(JJ))
                   ENDIF
+#endif
               ENDDO
           ENDIF
       ENDDO
       RETURN
       END SUBROUTINE CMUMPS_DISTSOL_INDICES
+#if ! defined(USE_OLD_SCALING)
+      SUBROUTINE CMUMPS_SCALINGRHSINTR(LSCAL, N,
+     &           SCALING_LOC, SCALING_RHSINTR,
+     &           L, POSINRHSINTR, KEEP, ROWORCOL, PTRIST,
+     &           IW, LIW_PASSED, MYID_NODES, STEP,
+     &           PROCNODE, NSLAVES)
+      IMPLICIT NONE
+      INTEGER              :: KEEP(500)
+      LOGICAL, INTENT(IN)  :: LSCAL
+      INTEGER, INTENT(IN)  :: N, L
+      INTEGER, INTENT(IN)  :: POSINRHSINTR(N)
+      REAL   , INTENT(IN)  :: SCALING_LOC(max(KEEP(89),1))
+      REAL   , INTENT(OUT) :: SCALING_RHSINTR(L)
+      INTEGER, INTENT(IN)  :: ROWORCOL, NSLAVES, LIW_PASSED, MYID_NODES
+      INTEGER, INTENT(IN)  :: STEP(KEEP(28)),
+     &                        PROCNODE(KEEP(28)),
+     &                        PTRIST(KEEP(28)),
+     &                        IW(LIW_PASSED)
+      INTEGER :: IPOSINRHSINTR
+      INTEGER, EXTERNAL :: MUMPS_PROCNODE
+      INTEGER :: ISTEP
+      INTEGER :: KLOC, J1, JJ, LIELL, IPOS, NPIV
+      IF (.NOT. LSCAL) THEN
+        WRITE(*,*) "Internal error 1 in CMUMPS_DS_SCALINGRHSINTR"
+        CALL MUMPS_ABORT()
+      ENDIF
+      IF (ROWORCOL .NE. 1 .AND. ROWORCOL.NE.2) THEN
+        WRITE(*,*) "Internal error 2 in CMUMPS_DS_SCALINGRHSINTR",
+     &  ROWORCOL
+      ENDIF
+      IF (KEEP(89).EQ.0) RETURN
+      KLOC = 1
+      DO ISTEP=1, KEEP(28)
+        IF ( MYID_NODES == MUMPS_PROCNODE( PROCNODE(ISTEP),
+     &               KEEP(199))) THEN
+          CALL MUMPS_SOL_GET_NPIV_LIELL_IPOS( ISTEP, KEEP,
+     &    NPIV, LIELL, IPOS, IW, LIW_PASSED, PTRIST, STEP, N)
+          IF (ROWORCOL .EQ. 1) THEN
+               J1=IPOS+1
+          ELSE
+               J1=IPOS+1+LIELL
+          END IF
+          IPOSINRHSINTR = POSINRHSINTR(IW(J1)) 
+          IF ( IPOSINRHSINTR .GT. 0 ) THEN
+            DO JJ=1, NPIV
+             SCALING_RHSINTR(IPOSINRHSINTR+JJ-1) =
+     &       SCALING_LOC(KLOC+JJ-1)
+            ENDDO
+          ENDIF
+          KLOC = KLOC + NPIV
+        ENDIF
+      ENDDO
+      RETURN
+      END SUBROUTINE CMUMPS_SCALINGRHSINTR
+#endif
       SUBROUTINE CMUMPS_DISTRIBUTED_SOLUTION(
      &           SLAVEF, N, MYID_NODES,
-     &           MTYPE, RHSCOMP, LRHSCOMP, NBRHS_EFF,
-     &           POSINRHSCOMP,
+     &           MTYPE, RHSINTR, LRHSINTR, NBRHS_EFF,
+     &           POSINRHSINTR,
      &           ISOL_LOC, 
      &           SOL_LOC, NRHS, BEG_RHS, LSOL_LOC,
      &           PTRIST,
      &           PROCNODE_STEPS, KEEP,KEEP8, IW, LIW, STEP,
-     &           scaling_data, LSCAL, NB_RHSSKIPPED,
+     &           SCALING_LOC_BWD, LSCALING_LOC_BWD,
+     &           LSCAL, NB_RHSSKIPPED,
      &           PERM_RHS, SIZE_PERM_RHS)
       IMPLICIT NONE
       INCLUDE 'mpif.h'
       INCLUDE 'mumps_tags.h'
-      type scaling_data_t
-        SEQUENCE
-        REAL, dimension(:), pointer :: SCALING
-        REAL, dimension(:), pointer :: SCALING_LOC
-      end type scaling_data_t
-      TYPE (scaling_data_t) :: scaling_data
-      LOGICAL LSCAL
-      INTEGER SLAVEF, N, MYID_NODES, LIW, MTYPE, NBRHS_EFF, LRHSCOMP
-      INTEGER POSINRHSCOMP(N), NB_RHSSKIPPED
+      LOGICAL, intent(in) :: LSCAL
+      INTEGER, intent(in) :: LSCALING_LOC_BWD
+      REAL, intent(in) :: SCALING_LOC_BWD(LSCALING_LOC_BWD)
+      INTEGER SLAVEF, N, MYID_NODES, LIW, MTYPE, NBRHS_EFF, LRHSINTR
+      INTEGER POSINRHSINTR(N), NB_RHSSKIPPED
       INTEGER LSOL_LOC, BEG_RHS
       INTEGER ISOL_LOC(LSOL_LOC)
       INTEGER, INTENT(in) :: NRHS 
       COMPLEX SOL_LOC( LSOL_LOC, NRHS )
-      COMPLEX RHSCOMP( LRHSCOMP, NBRHS_EFF )
+      COMPLEX RHSINTR( LRHSINTR, NBRHS_EFF )
       INTEGER KEEP(500)
       INTEGER(8) KEEP8(150)
       INTEGER PTRIST(KEEP(28)), PROCNODE_STEPS(KEEP(28))
       INTEGER IW(LIW), STEP(N)
       INTEGER, INTENT(in) :: SIZE_PERM_RHS
       INTEGER, INTENT(in) :: PERM_RHS( SIZE_PERM_RHS )
-      INTEGER :: JJ, J1, ISTEP, K, KLOC, IPOSINRHSCOMP, JEMPTY
+      INTEGER :: JJ, J1, ISTEP, K, KLOC, IPOSINRHSINTR, JEMPTY
       INTEGER :: JCOL, JCOL_PERM
       INTEGER :: IPOS, LIELL, NPIV, JEND
       LOGICAL :: ROOT
@@ -1814,7 +2038,7 @@ C
             ENDIF
 !$            OMP_FLAG = ( JEND-JEMPTY.GE.KEEP(362) .AND.
 !$   &                     (NPIV*(JEND-JEMPTY) .GE. KEEP(363)/2 ) )
-!$OMP PARALLEL DO PRIVATE(JCOL,JCOL_PERM,KLOC,JJ,IPOSINRHSCOMP) 
+!$OMP PARALLEL DO PRIVATE(JCOL,JCOL_PERM,KLOC,JJ,IPOSINRHSINTR) 
 !$OMP&         IF(OMP_FLAG)
             DO JCOL = JEMPTY+1, JEND
               IF (KEEP(242) .NE. 0) THEN
@@ -1824,14 +2048,13 @@ C
               ENDIF
               DO JJ=J1,J1+NPIV-1
                  KLOC=K + JJ-J1 + 1
-                IPOSINRHSCOMP = POSINRHSCOMP(IW(JJ))
                 IF (LSCAL) THEN
                   SOL_LOC(KLOC,JCOL_PERM) =
-     &            scaling_data%SCALING_LOC(KLOC)*
-     &            RHSCOMP(IPOSINRHSCOMP,JCOL-JEMPTY)
+     &            SCALING_LOC_BWD(KLOC)*
+     &            RHSINTR(KLOC,JCOL-JEMPTY)
                 ELSE
                   SOL_LOC(KLOC,JCOL_PERM) =
-     &            RHSCOMP(IPOSINRHSCOMP,JCOL-JEMPTY)
+     &            RHSINTR(KLOC,JCOL-JEMPTY)
                 ENDIF
               ENDDO
             ENDDO
@@ -1843,9 +2066,10 @@ C
       END SUBROUTINE CMUMPS_DISTRIBUTED_SOLUTION
       SUBROUTINE CMUMPS_SCATTER_RHS
      &           (NSLAVES, N, MYID, COMM,
+     &           LSCAL, SCALING_LOC_FWD,
      &           MTYPE, RHS, LRHS, NCOL_RHS, NRHS,
-     &           RHSCOMP, LRHSCOMP, NCOL_RHSCOMP,
-     &           POSINRHSCOMP_FWD, NB_FS_IN_RHSCOMP_F,
+     &           RHSINTR, LRHSINTR, NCOL_RHSINTR,
+     &           POSINRHSINTR_FWD, NB_FS_IN_RHSINTR_F,
      &           PTRIST,
      &           KEEP,KEEP8, PROCNODE_STEPS, IW, LIW, STEP, 
      &           ICNTL, INFO)
@@ -1854,15 +2078,17 @@ C
       INCLUDE 'mpif.h'
       INCLUDE 'mumps_tags.h'
       INTEGER NSLAVES, N, MYID, COMM, LIW, MTYPE
-      INTEGER NRHS, LRHS, NCOL_RHS,  LRHSCOMP, NCOL_RHSCOMP
+      INTEGER NRHS, LRHS, NCOL_RHS,  LRHSINTR, NCOL_RHSINTR
       INTEGER ICNTL(60), INFO(80)
       COMPLEX, intent(in)  :: RHS (LRHS, NCOL_RHS)
-      COMPLEX, intent(out) :: RHSCOMP(LRHSCOMP, NCOL_RHSCOMP)
-      INTEGER, intent(in)  :: POSINRHSCOMP_FWD(N), NB_FS_IN_RHSCOMP_F
+      COMPLEX, intent(out) :: RHSINTR(LRHSINTR, NCOL_RHSINTR)
+      INTEGER, intent(in)  :: POSINRHSINTR_FWD(N), NB_FS_IN_RHSINTR_F
       INTEGER KEEP(500)
       INTEGER(8) KEEP8(150)
       INTEGER PTRIST(KEEP(28)), PROCNODE_STEPS(KEEP(28))
       INTEGER IW(LIW), STEP(N) 
+      LOGICAL, intent(in) :: LSCAL
+      REAL, intent(in) :: SCALING_LOC_FWD(max(1,KEEP(89)))
       INTEGER BUF_MAXSIZE, BUF_MAXREF
       PARAMETER (BUF_MAXREF=200000)
       INTEGER, ALLOCATABLE, DIMENSION(:) :: BUF_INDX
@@ -1913,10 +2139,10 @@ C
       IF (MYID.EQ.MASTER) THEN
         ENTRIES_2_PROCESS = N - KEEP(89)
         IF (TYPE_PARAL.EQ.1.AND.ENTRIES_2_PROCESS.NE.0) THEN
-         IF (NB_FS_IN_RHSCOMP_F.LT.LRHSCOMP) THEN
-           DO K=1, NCOL_RHSCOMP
-            DO I = NB_FS_IN_RHSCOMP_F +1, LRHSCOMP
-             RHSCOMP (I, K) = ZERO
+         IF (NB_FS_IN_RHSINTR_F.LT.LRHSINTR) THEN
+           DO K=1, NCOL_RHSINTR
+            DO I = NB_FS_IN_RHSINTR_F +1, LRHSINTR
+             RHSINTR (I, K) = ZERO
             ENDDO
            ENDDO
          ENDIF
@@ -1973,10 +2199,10 @@ C
       ENDIF
       IF (I_AM_SLAVE) THEN
         IF (MYID.NE.MASTER) THEN
-         IF (NB_FS_IN_RHSCOMP_F.LT.LRHSCOMP) THEN
-           DO K=1, NCOL_RHSCOMP
-            DO I = NB_FS_IN_RHSCOMP_F +1, LRHSCOMP
-             RHSCOMP (I, K) = ZERO
+         IF (NB_FS_IN_RHSINTR_F.LT.LRHSINTR) THEN
+           DO K=1, NCOL_RHSINTR
+            DO I = NB_FS_IN_RHSINTR_F +1, LRHSINTR
+             RHSINTR (I, K) = ZERO
             ENDDO
            ENDDO
          ENDIF
@@ -1992,7 +2218,7 @@ C
                    J1=IPOS+1+LIELL
               END IF
               IF (MYID.EQ.MASTER) THEN
-                INDX = POSINRHSCOMP_FWD(IW(J1))
+                INDX = POSINRHSINTR_FWD(IW(J1))
                 IF (KEEP(350).EQ.2 .AND.
      &   (NRHS.EQ.1.OR.((NPIV*NRHS*2*KEEP(16)).GE.KEEP(364)))) THEN
 !$                 OMP_FLAG = .FALSE.
@@ -2001,22 +2227,53 @@ C
 !$                   OMP_FLAG = .TRUE.
 !$                   CHUNK = max((NPIV*NRHS+NOMP-1)/NOMP,KEEP(363)/2)
 !$                 ENDIF
+#if ! defined(USE_OLD_SCALING)
+                  IF (LSCAL) THEN
+!$OMP PARALLEL DO COLLAPSE(2) SCHEDULE(STATIC,CHUNK) PRIVATE(J,JJ)
+!$OMP&  FIRSTPRIVATE(INDX) IF (OMP_FLAG)
+                     DO K = 1, NRHS
+                       DO JJ=J1,J1+NPIV-1
+                         J=IW(JJ)
+                         RHSINTR( INDX+JJ-J1, K ) = RHS( J, K ) *
+     &                   SCALING_LOC_FWD( INDX+JJ-J1 )
+                       ENDDO
+                     ENDDO
+!$OMP END PARALLEL DO
+                  ELSE
+#endif
 !$OMP PARALLEL DO COLLAPSE(2) SCHEDULE(STATIC,CHUNK) PRIVATE(J,JJ)
 !$OMP&  FIRSTPRIVATE(INDX) IF (OMP_FLAG)
-                   DO K = 1, NRHS
+                    DO K = 1, NRHS
                       DO JJ=J1,J1+NPIV-1
                          J=IW(JJ)
-                         RHSCOMP( INDX+JJ-J1, K ) = RHS( J, K )
+                         RHSINTR( INDX+JJ-J1, K ) = RHS( J, K )
                       ENDDO
-                   ENDDO
+                    ENDDO
 !$OMP END PARALLEL DO
+#if ! defined(USE_OLD_SCALING)
+                  ENDIF
+#endif
                 ELSE 
+#if ! defined(USE_OLD_SCALING)
+                  IF (LSCAL) THEN
+                   DO JJ=J1,J1+NPIV-1
+                      J=IW(JJ)
+                      DO K = 1, NRHS
+                         RHSINTR( INDX+JJ-J1, K ) = RHS( J, K )
+     &                 * SCALING_LOC_FWD( INDX + JJ - J1 )
+                      ENDDO
+                   ENDDO
+                  ELSE
+#endif
                    DO JJ=J1,J1+NPIV-1
                       J=IW(JJ)
                       DO K = 1, NRHS
-                         RHSCOMP( INDX+JJ-J1, K ) = RHS( J, K )
+                         RHSINTR( INDX+JJ-J1, K ) = RHS( J, K )
                       ENDDO
                    ENDDO
+#if ! defined(USE_OLD_SCALING)
+                  ENDIF
+#endif
                 END IF 
               ELSE
                 DO JJ=J1,J1+NPIV-1
@@ -2053,40 +2310,72 @@ C
 !$                    OMP_FLAG = .TRUE.
 !$              CHUNK = max((BUF_EFFSIZE*NRHS+NOMP-1)/NOMP,KEEP(363)/2)
 !$                  ENDIF
+#if ! defined(USE_OLD_SCALING)
+                    IF (LSCAL) THEN
 !$OMP PARALLEL DO COLLAPSE(2) SCHEDULE(STATIC,CHUNK) PRIVATE(INDX)
 !$OMP&  IF (OMP_FLAG)
-                    DO K = 1, NRHS
+                      DO K = 1, NRHS
                         DO I = 1, BUF_EFFSIZE
-                           INDX = POSINRHSCOMP_FWD(BUF_INDX(I))
-                           RHSCOMP( INDX, K ) =
-     &                              BUF_RHS_2( I+(K-1)*BUF_EFFSIZE)
+                           INDX = POSINRHSINTR_FWD(BUF_INDX(I))
+                          RHSINTR( INDX, K ) =
+     &                           BUF_RHS_2( I+(K-1)*BUF_EFFSIZE) *
+     &                           SCALING_LOC_FWD( INDX )
                         ENDDO
-                     ENDDO
+                      ENDDO
+!$OMP END PARALLEL DO
+                    ELSE
+#endif
+!$OMP PARALLEL DO COLLAPSE(2) SCHEDULE(STATIC,CHUNK) PRIVATE(INDX)
+!$OMP&  IF (OMP_FLAG)
+                      DO K = 1, NRHS
+                        DO I = 1, BUF_EFFSIZE
+                           INDX = POSINRHSINTR_FWD(BUF_INDX(I))
+                          RHSINTR( INDX, K ) =
+     &                           BUF_RHS_2( I+(K-1)*BUF_EFFSIZE)
+                        ENDDO
+                      ENDDO
 !$OMP END PARALLEL DO
+#if ! defined(USE_OLD_SCALING)
+                    ENDIF
+#endif
                    ELSE
                      CALL MPI_RECV(BUF_RHS, BUF_EFFSIZE*NRHS,
      &                 MPI_COMPLEX,
      &                 MASTER,
      &                 ScatterRhsR, COMM, STATUS, IERR )
+#if ! defined(USE_OLD_SCALING)
+                     IF (LSCAL) THEN
+                     DO I = 1, BUF_EFFSIZE
+                        INDX = POSINRHSINTR_FWD(BUF_INDX(I))
+                        DO K = 1, NRHS
+                           RHSINTR( INDX, K ) = BUF_RHS( K, I )
+     &                     * SCALING_LOC_FWD( INDX )
+                        ENDDO
+                     ENDDO
+                     ELSE
+#endif
                      DO I = 1, BUF_EFFSIZE
-                        INDX = POSINRHSCOMP_FWD(BUF_INDX(I))
+                        INDX = POSINRHSINTR_FWD(BUF_INDX(I))
                         DO K = 1, NRHS
-                           RHSCOMP( INDX, K ) = BUF_RHS( K, I )
+                           RHSINTR( INDX, K ) = BUF_RHS( K, I )
                         ENDDO
                      ENDDO
+#if ! defined(USE_OLD_SCALING)
+                     ENDIF
+#endif
                   END IF 
                   BUF_EFFSIZE = 0
                   RETURN
                   END SUBROUTINE CMUMPS_GET_BUF_INDX_RHS
       END SUBROUTINE CMUMPS_SCATTER_RHS
-      SUBROUTINE CMUMPS_BUILD_POSINRHSCOMP
+      SUBROUTINE CMUMPS_BUILD_GLOB2LOC
      &           (NSLAVES, N, MYID_NODES,
      &           PTRIST,
      &           KEEP,KEEP8, PROCNODE_STEPS, IW, LIW, STEP, 
-     &           POSINRHSCOMP_ROW, POSINRHSCOMP_COL,
-     &           POSINRHSCOMP_COL_ALLOC,
+     &           GLOB2LOC_RHS, GLOB2LOC_SOL,
+     &           GLOB2LOC_SOL_ALLOC,
      &           MTYPE,
-     &           NBENT_RHSCOMP, NB_FS_IN_RHSCOMP )
+     &           NBENT_RHSINTR, NB_FS_IN_RHSINTR )
       IMPLICIT NONE
       INCLUDE 'mpif.h'
       INCLUDE 'mumps_tags.h'
@@ -2096,20 +2385,20 @@ C
       INTEGER, intent(in) :: PTRIST(KEEP(28)), PROCNODE_STEPS(KEEP(28))
       INTEGER, intent(in) :: IW(LIW), STEP(N)
       INTEGER, intent(in) :: MTYPE 
-      LOGICAL, intent(in) :: POSINRHSCOMP_COL_ALLOC
-      INTEGER, intent(out):: POSINRHSCOMP_ROW(N),POSINRHSCOMP_COL(N) 
-      INTEGER, intent(out):: NBENT_RHSCOMP, NB_FS_IN_RHSCOMP
+      LOGICAL, intent(in) :: GLOB2LOC_SOL_ALLOC
+      INTEGER, intent(out):: GLOB2LOC_RHS(N), GLOB2LOC_SOL(N) 
+      INTEGER, intent(out):: NBENT_RHSINTR, NB_FS_IN_RHSINTR
       INTEGER ISTEP
       INTEGER NPIV
       INTEGER IPOS, LIELL
       INTEGER JJ, J1, JCOL
-      INTEGER IPOSINRHSCOMP, IPOSINRHSCOMP_COL
+      INTEGER IPOSINRHSINTR, IPOSINRHSINTR_SOL
       INCLUDE 'mumps_headers.h'
       INTEGER MUMPS_PROCNODE
       EXTERNAL MUMPS_PROCNODE
-      POSINRHSCOMP_ROW = 0
-      IF (POSINRHSCOMP_COL_ALLOC) POSINRHSCOMP_COL = 0
-      IPOSINRHSCOMP   = 1     
+      GLOB2LOC_RHS = 0
+      IF (GLOB2LOC_SOL_ALLOC) GLOB2LOC_SOL = 0
+      IPOSINRHSINTR   = 1     
       DO ISTEP = 1, KEEP(28)
         IF (MYID_NODES == MUMPS_PROCNODE(PROCNODE_STEPS(ISTEP),
      &     KEEP(199))) THEN
@@ -2126,19 +2415,19 @@ C
                    JCOL = IPOS+1
            ENDIF
            DO JJ = J1, J1+NPIV-1
-                POSINRHSCOMP_ROW(IW(JJ)) = IPOSINRHSCOMP+JJ-J1
+                GLOB2LOC_RHS(IW(JJ)) = IPOSINRHSINTR+JJ-J1
            ENDDO
-           IF (POSINRHSCOMP_COL_ALLOC) THEN
+           IF (GLOB2LOC_SOL_ALLOC) THEN
              DO JJ = JCOL, JCOL+NPIV-1
-               POSINRHSCOMP_COL(IW(JJ)) = IPOSINRHSCOMP+JJ-JCOL
+               GLOB2LOC_SOL(IW(JJ)) = IPOSINRHSINTR+JJ-JCOL
              ENDDO
            ENDIF
-           IPOSINRHSCOMP       = IPOSINRHSCOMP + NPIV
+           IPOSINRHSINTR       = IPOSINRHSINTR + NPIV
         ENDIF
       ENDDO
-      NB_FS_IN_RHSCOMP = IPOSINRHSCOMP -1
-      IF (POSINRHSCOMP_COL_ALLOC) IPOSINRHSCOMP_COL=IPOSINRHSCOMP
-      IF (IPOSINRHSCOMP.GT.N) GOTO 500 
+      NB_FS_IN_RHSINTR = IPOSINRHSINTR -1
+      IF (GLOB2LOC_SOL_ALLOC) IPOSINRHSINTR_SOL=IPOSINRHSINTR
+      IF (IPOSINRHSINTR.GT.N) GOTO 500 
       DO ISTEP = 1, KEEP(28)
         IF (MYID_NODES == MUMPS_PROCNODE(PROCNODE_STEPS(ISTEP),
      &     KEEP(199))) THEN
@@ -2154,92 +2443,267 @@ C
            ELSE
                    JCOL = IPOS+1
            ENDIF
-           IF (POSINRHSCOMP_COL_ALLOC) THEN
+           IF (GLOB2LOC_SOL_ALLOC) THEN
             DO JJ = NPIV, LIELL-1-KEEP(253)
-              IF (POSINRHSCOMP_ROW(IW(J1+JJ)).EQ.0) THEN
-               POSINRHSCOMP_ROW(IW(J1+JJ)) = - IPOSINRHSCOMP
-               IPOSINRHSCOMP = IPOSINRHSCOMP + 1
-              ENDIF
-              IF (POSINRHSCOMP_COL(IW(JCOL+JJ)).EQ.0) THEN
-               POSINRHSCOMP_COL(IW(JCOL+JJ)) = - IPOSINRHSCOMP_COL
-               IPOSINRHSCOMP_COL = IPOSINRHSCOMP_COL + 1
+              IF (GLOB2LOC_RHS(IW(J1+JJ)).EQ.0) THEN
+               GLOB2LOC_RHS(IW(J1+JJ)) = - IPOSINRHSINTR
+               IPOSINRHSINTR = IPOSINRHSINTR + 1
+              ENDIF
+              IF (GLOB2LOC_SOL(IW(JCOL+JJ)).EQ.0) THEN
+               GLOB2LOC_SOL(IW(JCOL+JJ)) = - IPOSINRHSINTR_SOL
+               IPOSINRHSINTR_SOL = IPOSINRHSINTR_SOL + 1
               ENDIF
              ENDDO
            ELSE
              DO JJ = J1+NPIV, J1+LIELL-1-KEEP(253)
-              IF (POSINRHSCOMP_ROW(IW(JJ)).EQ.0) THEN
-               POSINRHSCOMP_ROW(IW(JJ)) = - IPOSINRHSCOMP
-               IPOSINRHSCOMP = IPOSINRHSCOMP + 1
+              IF (GLOB2LOC_RHS(IW(JJ)).EQ.0) THEN
+               GLOB2LOC_RHS(IW(JJ)) = - IPOSINRHSINTR
+               IPOSINRHSINTR = IPOSINRHSINTR + 1
               ENDIF
              ENDDO
            ENDIF
         ENDIF
       ENDDO
- 500  NBENT_RHSCOMP = IPOSINRHSCOMP - 1
-      IF (POSINRHSCOMP_COL_ALLOC) 
-     &     NBENT_RHSCOMP = max(NBENT_RHSCOMP, IPOSINRHSCOMP_COL-1)
+ 500  NBENT_RHSINTR = IPOSINRHSINTR - 1
+      IF (GLOB2LOC_SOL_ALLOC) 
+     &     NBENT_RHSINTR = max(NBENT_RHSINTR, IPOSINRHSINTR_SOL-1)
       RETURN
-      END SUBROUTINE CMUMPS_BUILD_POSINRHSCOMP
-      SUBROUTINE CMUMPS_BUILD_POSINRHSCOMP_AM1
-     &           (NSLAVES, N, MYID_NODES,
+      END SUBROUTINE CMUMPS_BUILD_GLOB2LOC
+      SUBROUTINE CMUMPS_NODES_FWD_BWD_SIZE_FILL (
+     &           fill, ICNTL,
+     &           N, NSTEPS, KEEP, STEP, Step2node,
+     &           IRHS_loc, Nloc_RHS, 
+     &           IRHS_PTR, NBCOL_INBLOC, IRHS_SPARSE, NZ_RHS,
+     &           PERM_RHS, SIZE_PERM_RHS, JBEG_RHS,
+     &           UNS_PERM_INV, SIZE_UNS_PERM_INV,
+     &           ICNTL21, 
+     &           MYID, COMM,
+     &           INFO, 
+     &           Pruned_Sons_FWD, Pruned_Sons_BWD, 
+     &           Lnodes_FWD, Lnodes_BWD
+     &           , nodes_FWD, nodes_BWD
+     &           , Lnodes_FWD_in, Lnodes_BWD_in
+     &           )
+      USE CMUMPS_SOL_ES, ONLY : CMUMPS_ES_NODES_SIZE_AND_FILL
+      IMPLICIT NONE
+      LOGICAL, INTENT(IN)  :: fill
+      INTEGER, INTENT(IN)  :: ICNTL(60),N, NSTEPS, KEEP(500) 
+      INTEGER, INTENT(IN)  :: STEP(N), Step2node(NSTEPS)
+      INTEGER, INTENT(IN)  :: Nloc_RHS, 
+     &                        IRHS_loc(max(1,Nloc_RHS))
+      INTEGER, intent(in) :: NBCOL_INBLOC, IRHS_PTR(NBCOL_INBLOC+1)
+      INTEGER, intent(in) :: NZ_RHS, IRHS_SPARSE(NZ_RHS)
+      INTEGER, intent(in) :: SIZE_PERM_RHS, PERM_RHS(SIZE_PERM_RHS)
+      INTEGER, intent(in) :: JBEG_RHS, SIZE_UNS_PERM_INV
+      INTEGER, intent(in) :: UNS_PERM_INV(SIZE_UNS_PERM_INV)
+      INTEGER, intent(IN)  :: ICNTL21
+      INTEGER, intent(in)  :: MYID, COMM
+      INTEGER, intent(inout) :: INFO(80)
+      INTEGER, intent(inout) :: Pruned_Sons_FWD(NSTEPS), 
+     &                          Pruned_Sons_BWD(NSTEPS)
+      INTEGER, intent(inout) :: Lnodes_FWD, Lnodes_BWD
+      INTEGER, intent(in) :: Lnodes_FWD_in, Lnodes_BWD_in
+      INTEGER, intent(out) :: nodes_FWD(Lnodes_FWD_in), 
+     &                        nodes_BWD(Lnodes_BWD_in)
+      INCLUDE 'mpif.h'
+      LOGICAL :: DO_PRUN_FWD, AM1, Exploit_Sparsity_FWD, 
+     &           Exploit_Sparsity_BWD
+      INTEGER :: Lnodes_FWD_loc, Lnodes_BWD_loc, ISTEP,
+     &           INODE_PRINC, I, II, JAM1
+#if defined(AVOID_MPI_IN_PLACE)
+      INTEGER, DIMENSION(:), ALLOCATABLE ::  TMP_INT_ARRAY
+#endif
+#if defined(AVOID_MPI_IN_PLACE)
+      ALLOCATE(TMP_INT_ARRAY(KEEP(28)), STAT = allocok)
+      IF(allocok.GT.0) THEN
+        INFO(1)=-13
+        INFO(2)=KEEP(28)
+      END IF
+      CALL MUMPS_PROPINFO(ICNTL, INFO, COMM, MYID )
+      IF(INFO(1).LT.0) GOTO 500
+#endif
+      AM1                  = (KEEP(237) .NE. 0)
+      Exploit_Sparsity_FWD = (KEEP(235) .NE. 0) .AND. (.NOT. AM1)
+      DO_PRUN_FWD          = (Exploit_Sparsity_FWD.OR.AM1)
+      Exploit_Sparsity_BWD = (KEEP(212) .NE. 0) .AND. (.NOT. AM1)
+      IF (.NOT.fill) Lnodes_FWD=-1
+      IF (.NOT.fill) Lnodes_BWD=-1
+      IF (.NOT.fill.AND.KEEP(252).NE.0) THEN
+        Lnodes_FWD = 0
+      ENDIF
+      IF ( KEEP(252).NE.0 ) DO_PRUN_FWD = .FALSE.  
+      IF ( DO_PRUN_FWD ) THEN
+        IF ( Exploit_Sparsity_FWD.AND.KEEP(248).EQ.-1 ) THEN
+         IF (.NOT.fill) THEN
+           CALL CMUMPS_ES_NODES_SIZE_AND_FILL ( fill,
+     &           N, KEEP(28), KEEP, STEP, Step2node,
+     &           IRHS_loc, Nloc_RHS, MYID, COMM,
+     &           Pruned_Sons_FWD, Lnodes_FWD 
+#if defined(AVOID_MPI_IN_PLACE)
+     &           , TMP_INT_ARRAY
+#endif
+     &           )
+         ELSE IF (Lnodes_FWD.GT.0) THEN
+            CALL CMUMPS_ES_NODES_SIZE_AND_FILL ( fill,
+     &           N, KEEP(28), KEEP, STEP, Step2node,
+     &           IRHS_loc, Nloc_RHS, MYID, COMM,
+     &           Pruned_Sons_FWD, Lnodes_FWD, 
+#if defined(AVOID_MPI_IN_PLACE)
+     &            TMP_INT_ARRAY, 
+#endif
+     &           nodes_FWD
+     &           )
+         ENDIF
+        ELSE IF ( Exploit_Sparsity_FWD.AND.KEEP(248).NE.-1 ) THEN
+           IF (.NOT.fill) THEN
+            Lnodes_FWD = 0
+            Pruned_Sons_FWD(:) = -1
+            DO I = 1, NZ_RHS
+               ISTEP       = abs( STEP(IRHS_SPARSE(I)) )
+               IF ( Pruned_Sons_FWD(ISTEP) .eq. -1) THEN
+                  Lnodes_FWD = Lnodes_FWD +1
+                  Pruned_Sons_FWD(ISTEP) = 0 
+               ENDIF
+            ENDDO
+           ELSE IF (Lnodes_FWD.GT.0) THEN
+            Lnodes_FWD_loc = 0
+            Pruned_Sons_FWD(:) = -1
+            DO I = 1, NZ_RHS
+               ISTEP       = abs( STEP(IRHS_SPARSE(I)) )
+               INODE_PRINC = Step2node( ISTEP )
+               IF ( Pruned_Sons_FWD(ISTEP) .eq. -1) THEN
+                  Lnodes_FWD_loc = Lnodes_FWD_loc +1
+                  nodes_FWD(Lnodes_FWD_loc)  = INODE_PRINC
+                  Pruned_Sons_FWD(ISTEP) = 0 
+               ENDIF
+            ENDDO
+           ENDIF
+        ELSE IF ( AM1 ) THEN  
+          IF (.NOT.fill) THEN
+            Lnodes_FWD = 0
+            Pruned_Sons_FWD(:) = -1
+            DO I = 1, NBCOL_INBLOC
+              IF ( (IRHS_PTR(I+1)-IRHS_PTR(I)).EQ.0) CYCLE
+              IF ( (KEEP(242) .NE. 0 ).OR. (KEEP(243).NE.0) ) THEN
+                   JAM1 = PERM_RHS(JBEG_RHS+I-1)
+              ELSE
+                   JAM1 = JBEG_RHS+I-1
+              ENDIF       
+              ISTEP = abs(STEP(JAM1))
+              INODE_PRINC = Step2node(ISTEP)
+              IF ( Pruned_Sons_FWD(ISTEP) .eq. -1) THEN
+                 Lnodes_FWD = Lnodes_FWD +1
+                 Pruned_Sons_FWD(ISTEP) = 0                 
+              ENDIF
+            ENDDO
+          ELSE IF (Lnodes_FWD.GT.0) THEN
+            Lnodes_FWD_loc = 0
+            Pruned_Sons_FWD = -1
+            DO I = 1, NBCOL_INBLOC
+              IF ( (IRHS_PTR(I+1)-IRHS_PTR(I)).EQ.0) CYCLE
+              IF ( (KEEP(242) .NE. 0 ).OR. (KEEP(243).NE.0) ) THEN
+                   JAM1 = PERM_RHS(JBEG_RHS+I-1)
+              ELSE
+                   JAM1 = JBEG_RHS+I-1
+              ENDIF
+              ISTEP = abs(STEP(JAM1))
+              INODE_PRINC = Step2node(ISTEP)
+              IF ( Pruned_Sons_FWD(ISTEP) .eq. -1) THEN
+                 Lnodes_FWD_loc = Lnodes_FWD_loc +1
+                 nodes_FWD(Lnodes_FWD_loc)  = INODE_PRINC
+                 Pruned_Sons_FWD(ISTEP) = 0
+              ENDIF
+            ENDDO            
+          ENDIF
+         ENDIF                  
+      ENDIF
+      IF (AM1) THEN
+        IF (.NOT.fill) THEN
+         Lnodes_BWD = 0
+         Pruned_Sons_BWD(:) = -1 
+         DO II = 1, NZ_RHS
+            I = IRHS_SPARSE(II)
+            IF (KEEP(23).NE.0) I = UNS_PERM_INV(I)          
+            ISTEP = abs(STEP(I))
+            IF ( Pruned_Sons_BWD(ISTEP) .eq. -1) THEN
+               Lnodes_BWD = Lnodes_BWD +1
+               Pruned_Sons_BWD(ISTEP) = 0
+            ENDIF
+         ENDDO
+        ELSE IF (Lnodes_BWD.GT.0) THEN
+         Lnodes_BWD_loc = 0         
+         Pruned_Sons_BWD(:) = -1  
+         DO II = 1, NZ_RHS
+            I = IRHS_SPARSE(II)
+            IF (KEEP(23).NE.0) I = UNS_PERM_INV(I)
+            ISTEP = abs(STEP(I))
+            INODE_PRINC = Step2node(ISTEP)
+            IF ( Pruned_Sons_BWD(ISTEP) .eq. -1) THEN
+               Lnodes_BWD_loc = Lnodes_BWD_loc +1
+               nodes_BWD(Lnodes_BWD_loc)  = INODE_PRINC
+               Pruned_Sons_BWD(ISTEP) = 0
+            ENDIF
+         ENDDO
+        ENDIF
+      ENDIF
+#if defined(AVOID_MPI_IN_PLACE)
+      GOTO 600  
+  500 CONTINUE
+      Lnodes_FWD = -1
+      Lnodes_BWD = -1
+  600 CONTINUE
+#endif
+#if defined(AVOID_MPI_IN_PLACE)
+      IF ( allocated(TMP_INT_ARRAY)) DEALLOCATE(TMP_INT_ARRAY)
+#endif
+      RETURN
+      END SUBROUTINE CMUMPS_NODES_FWD_BWD_SIZE_FILL
+      SUBROUTINE CMUMPS_BUILD_GLOB2LOC_NODES_ES (
+     &           NSLAVES, N, MYID_NODES,
      &           PTRIST, DAD,
      &           KEEP,KEEP8, PROCNODE_STEPS, IW, LIW, STEP,
-     &           POSINRHSCOMP_ROW, POSINRHSCOMP_COL,
-     &           POSINRHSCOMP_COL_ALLOC,
+     &           Lnodes_FWD, Lnodes_BWD,
+     &           nodes_FWD, nodes_BWD,
+     &           GLOB2LOC_RHS, GLOB2LOC_SOL,
+     &           GLOB2LOC_SOL_ALLOC,
      &           MTYPE,
-     &           IRHS_PTR, NBCOL_INBLOC, IRHS_SPARSE, NZ_RHS,
-     &           PERM_RHS, SIZE_PERM_RHS, JBEG_RHS,
-     &           NBENT_RHSCOMP,
-     &           NB_FS_IN_RHSCOMP_FWD, NB_FS_IN_RHSCOMP_TOT,
-     &           UNS_PERM_INV, SIZE_UNS_PERM_INV
+     &           NBENT_RHSINTR,
+     &           NB_FS_IN_RHSINTR_FWD, NB_FS_IN_RHSINTR_TOT
      &            )
       IMPLICIT NONE
       INCLUDE 'mpif.h'
       INCLUDE 'mumps_tags.h'
-      INTEGER, intent(in) :: NSLAVES, N, MYID_NODES, LIW, 
-     &                       SIZE_UNS_PERM_INV
-      INTEGER, intent(in) :: KEEP(500)
+      INTEGER, intent(in)    :: NSLAVES, N, MYID_NODES, LIW
+      INTEGER, intent(in)    :: KEEP(500)
       INTEGER(8), intent(in) :: KEEP8(150)
       INTEGER, intent(in) :: PTRIST(KEEP(28)), PROCNODE_STEPS(KEEP(28))
+      INTEGER, intent(in) :: Lnodes_FWD, Lnodes_BWD
+      INTEGER, intent(in) :: nodes_FWD(max(1,Lnodes_FWD)), 
+     &                       nodes_BWD(max(1,Lnodes_BWD))
       INTEGER, intent(inout) :: DAD(KEEP(28))
       INTEGER, intent(in) :: IW(LIW), STEP(N)
-      INTEGER, intent(in) :: NBCOL_INBLOC, IRHS_PTR(NBCOL_INBLOC+1)
-      INTEGER, intent(in) :: NZ_RHS, IRHS_SPARSE(NZ_RHS)
-      INTEGER, intent(in) :: SIZE_PERM_RHS, PERM_RHS(SIZE_PERM_RHS)
-      INTEGER, intent(in) :: JBEG_RHS
       INTEGER, intent(in) :: MTYPE
-      LOGICAL, intent(in) :: POSINRHSCOMP_COL_ALLOC
-      INTEGER, intent(out):: POSINRHSCOMP_ROW(N),POSINRHSCOMP_COL(N)
-      INTEGER, intent(out):: NBENT_RHSCOMP
-      INTEGER, intent(out):: NB_FS_IN_RHSCOMP_FWD, NB_FS_IN_RHSCOMP_TOT
-      INTEGER, intent(in) :: UNS_PERM_INV(SIZE_UNS_PERM_INV)
-      INTEGER I, JAM1
+      LOGICAL, intent(in) :: GLOB2LOC_SOL_ALLOC
+      INTEGER, intent(out):: GLOB2LOC_RHS(N), GLOB2LOC_SOL(N)
+      INTEGER, intent(out):: NBENT_RHSINTR
+      INTEGER, intent(out):: NB_FS_IN_RHSINTR_FWD, NB_FS_IN_RHSINTR_TOT
+      INTEGER I
       INTEGER ISTEP, OLDISTEP
       INTEGER NPIV
       INTEGER IPOS, LIELL
       INTEGER JJ, J1, JCOL, ABSJCOL
-      INTEGER IPOSINRHSCOMP_ROW, IPOSINRHSCOMP_COL
-      INTEGER NBENT_RHSCOMP_ROW, NBENT_RHSCOMP_COL
+      INTEGER IPOSINRHSINTR_RHS, IPOSINRHSINTR_SOL
+      INTEGER NBENT_RHSINTR_ROW, NBENT_RHSINTR_COL
       LOGICAL GO_UP
       INCLUDE 'mumps_headers.h'
       INTEGER MUMPS_PROCNODE
       EXTERNAL MUMPS_PROCNODE
-      IF(KEEP(237).EQ.0) THEN
-        WRITE(*,*)'BUILD_POSINRHSCOMP_SPARSE available for A-1 only !'
-        CALL MUMPS_ABORT()
-      END IF
-      POSINRHSCOMP_ROW = 0
-      IF (POSINRHSCOMP_COL_ALLOC) POSINRHSCOMP_COL = 0
-      IPOSINRHSCOMP_ROW = 0
-      IPOSINRHSCOMP_COL = 0
-      DO I = 1, NBCOL_INBLOC
-        IF ((IRHS_PTR(I+1)-IRHS_PTR(I)).EQ.0) CYCLE 
-        IF (KEEP(242).NE.0) THEN 
-          JAM1 = PERM_RHS(JBEG_RHS+I-1)
-        ELSE
-          JAM1 = JBEG_RHS+I-1
-        END IF
-        ISTEP = abs(STEP(JAM1))
+      GLOB2LOC_RHS = 0
+      IF (GLOB2LOC_SOL_ALLOC) GLOB2LOC_SOL = 0
+      IPOSINRHSINTR_RHS = 0
+      IPOSINRHSINTR_SOL = 0
+      DO I = 1, Lnodes_FWD
+        ISTEP = STEP(nodes_FWD(I))
         GO_UP = .TRUE.
         DO WHILE(GO_UP) 
           IF(MYID_NODES.EQ.
@@ -2257,18 +2721,18 @@ C
               JCOL = IPOS+1
             ENDIF
             IF(NPIV.GT.0) THEN 
-              IF(POSINRHSCOMP_ROW(IW(J1)).EQ.0) THEN 
+              IF(GLOB2LOC_RHS(IW(J1)).EQ.0) THEN 
                 DO JJ = J1, J1+NPIV-1
-                  POSINRHSCOMP_ROW(IW(JJ))
-     &            = IPOSINRHSCOMP_ROW + JJ - J1 + 1
+                  GLOB2LOC_RHS(IW(JJ))
+     &            = IPOSINRHSINTR_RHS + JJ - J1 + 1
                 ENDDO
-                IPOSINRHSCOMP_ROW = IPOSINRHSCOMP_ROW + NPIV
-                IF (POSINRHSCOMP_COL_ALLOC) THEN
+                IPOSINRHSINTR_RHS = IPOSINRHSINTR_RHS + NPIV
+                IF (GLOB2LOC_SOL_ALLOC) THEN
                   DO JJ = JCOL, JCOL+NPIV-1
-                    POSINRHSCOMP_COL(IW(JJ))
-     &              = - N - (IPOSINRHSCOMP_COL + JJ - JCOL + 1)
+                    GLOB2LOC_SOL(IW(JJ))
+     &              = - (IPOSINRHSINTR_SOL + JJ - JCOL + 1)
                   ENDDO
-                  IPOSINRHSCOMP_COL = IPOSINRHSCOMP_COL + NPIV
+                  IPOSINRHSINTR_SOL = IPOSINRHSINTR_SOL + NPIV
                 ENDIF
               ELSE
                 GO_UP = .FALSE. 
@@ -2282,12 +2746,10 @@ C
           END IF
         END DO 
       END DO 
-      NB_FS_IN_RHSCOMP_FWD = IPOSINRHSCOMP_ROW
-      IF(POSINRHSCOMP_COL_ALLOC) THEN 
-        DO I =1, NZ_RHS
-          JAM1 = IRHS_SPARSE(I)
-          IF (KEEP(23).NE.0) JAM1 = UNS_PERM_INV(JAM1)
-          ISTEP = abs(STEP(JAM1))
+      NB_FS_IN_RHSINTR_FWD = IPOSINRHSINTR_RHS
+      IF(GLOB2LOC_SOL_ALLOC) THEN 
+        DO I=1, Lnodes_BWD
+          ISTEP = STEP(nodes_BWD(I))
           GO_UP = .TRUE.
           DO WHILE(GO_UP) 
             IF(MYID_NODES.EQ.
@@ -2306,21 +2768,17 @@ C
               ENDIF
               ABSJCOL = abs(IW(JCOL))
               IF(NPIV.GT.0) THEN 
-                IF(POSINRHSCOMP_COL(ABSJCOL).EQ.0)  THEN
+                IF(GLOB2LOC_SOL(ABSJCOL).EQ.0)  THEN
                   DO JJ = JCOL, JCOL+NPIV-1
-                    POSINRHSCOMP_COL(abs(IW(JJ))) = 
-     &                     IPOSINRHSCOMP_COL+JJ-JCOL+1
+                    GLOB2LOC_SOL(abs(IW(JJ))) = 
+     &                     IPOSINRHSINTR_SOL+JJ-JCOL+1
                   END DO
-                  IPOSINRHSCOMP_COL = IPOSINRHSCOMP_COL + NPIV
-                ELSE IF (POSINRHSCOMP_COL(ABSJCOL).LT.-N) THEN
+                  IPOSINRHSINTR_SOL = IPOSINRHSINTR_SOL + NPIV
+                ELSE IF (GLOB2LOC_SOL(ABSJCOL).LT.0) THEN
                   DO JJ = JCOL, JCOL+NPIV-1
-                    POSINRHSCOMP_COL(abs(IW(JJ)))=
-     &                -(N+POSINRHSCOMP_COL(abs(IW(JJ))))
+                    GLOB2LOC_SOL(abs(IW(JJ)))=
+     &                -(GLOB2LOC_SOL(abs(IW(JJ))))
                   END DO
-                ELSE IF ((POSINRHSCOMP_COL(ABSJCOL).LT.0).AND.
-     &                 (POSINRHSCOMP_COL(ABSJCOL).GE.-N))THEN
-                  WRITE(*,*)'Internal error 7 in BUILD...SPARSE'
-                  CALL MUMPS_ABORT()
                 ELSE
                   GO_UP = .FALSE.
                 END IF
@@ -2334,16 +2792,10 @@ C
           END DO 
         END DO 
       END IF 
-      NB_FS_IN_RHSCOMP_TOT = IPOSINRHSCOMP_COL
-            IF (NSLAVES.NE.1) THEN
-      DO I = 1, NBCOL_INBLOC
-        IF ((IRHS_PTR(I+1)-IRHS_PTR(I)).EQ.0) CYCLE 
-        IF (KEEP(242).NE.0) THEN 
-          JAM1 = PERM_RHS(JBEG_RHS+I-1)
-        ELSE
-          JAM1 = JBEG_RHS+I-1
-        END IF
-        ISTEP = abs(STEP(JAM1))
+      NB_FS_IN_RHSINTR_TOT = IPOSINRHSINTR_SOL
+      IF (NSLAVES.NE.1) THEN
+      DO I = 1, Lnodes_FWD
+        ISTEP = STEP(nodes_FWD(I))
         GO_UP = .TRUE.
         DO WHILE(GO_UP) 
           IF(MYID_NODES.EQ.
@@ -2361,10 +2813,9 @@ C
               JCOL = IPOS+1
             ENDIF
             DO JJ = NPIV, LIELL-1-KEEP(253)
-              IF(POSINRHSCOMP_ROW(IW(J1+JJ)).EQ.0) THEN 
-                IPOSINRHSCOMP_ROW = IPOSINRHSCOMP_ROW + 1
-                POSINRHSCOMP_ROW(IW(JJ+J1))
-     &          = -IPOSINRHSCOMP_ROW
+              IF(GLOB2LOC_RHS(IW(J1+JJ)).EQ.0) THEN 
+                IPOSINRHSINTR_RHS = IPOSINRHSINTR_RHS + 1
+                GLOB2LOC_RHS(IW(JJ+J1)) = -IPOSINRHSINTR_RHS
               END IF
             END DO
           END IF
@@ -2378,11 +2829,9 @@ C
         END DO 
       END DO 
       DAD=ABS(DAD)
-      IF(POSINRHSCOMP_COL_ALLOC) THEN
-        DO I =1, NZ_RHS
-          JAM1 = IRHS_SPARSE(I)
-          IF (KEEP(23).NE.0) JAM1 = UNS_PERM_INV(JAM1)
-          ISTEP = abs(STEP(JAM1))
+      IF(GLOB2LOC_SOL_ALLOC) THEN
+        DO I=1, Lnodes_BWD
+        ISTEP = STEP(nodes_BWD(I))
           GO_UP = .TRUE.
           DO WHILE(GO_UP) 
             IF(MYID_NODES.EQ.
@@ -2399,16 +2848,10 @@ C
               ELSE
                 JCOL = IPOS+1
               ENDIF
-              IF (KEEP(23).NE.0) JAM1 = UNS_PERM_INV(JAM1)
               DO JJ = NPIV, LIELL-1-KEEP(253)
-                IF(POSINRHSCOMP_COL(IW(JCOL+JJ)).EQ.0) THEN 
-                  IPOSINRHSCOMP_COL = IPOSINRHSCOMP_COL + 1
-                  POSINRHSCOMP_COL(IW(JCOL+JJ))
-     &            = -IPOSINRHSCOMP_COL
-                ELSE IF (POSINRHSCOMP_COL(IW(JCOL+JJ)).LT.-N) THEN
-                  IPOSINRHSCOMP_COL = IPOSINRHSCOMP_COL + 1
-                  POSINRHSCOMP_COL(IW(JCOL+JJ))
-     &            = POSINRHSCOMP_COL(IW(JCOL+JJ)) + N              
+                IF(GLOB2LOC_SOL(IW(JCOL+JJ)).EQ.0) THEN 
+                  IPOSINRHSINTR_SOL = IPOSINRHSINTR_SOL + 1
+                  GLOB2LOC_SOL(IW(JCOL+JJ)) = -IPOSINRHSINTR_SOL
                 END IF
               END DO
             END IF
@@ -2424,8 +2867,8 @@ C
        DAD=ABS(DAD)
       END IF
       ENDIF
-      NBENT_RHSCOMP_ROW = IPOSINRHSCOMP_ROW
-      NBENT_RHSCOMP_COL = IPOSINRHSCOMP_COL
-      NBENT_RHSCOMP = max(NBENT_RHSCOMP_ROW,NBENT_RHSCOMP_COL)
+      NBENT_RHSINTR_ROW = IPOSINRHSINTR_RHS
+      NBENT_RHSINTR_COL = IPOSINRHSINTR_SOL
+      NBENT_RHSINTR = max(NBENT_RHSINTR_ROW,NBENT_RHSINTR_COL)
       RETURN
-      END SUBROUTINE CMUMPS_BUILD_POSINRHSCOMP_AM1
+      END SUBROUTINE CMUMPS_BUILD_GLOB2LOC_NODES_ES
diff -pruN 5.6.2-2.1/src/csol_distrhs.F 5.7.1-1/src/csol_distrhs.F
--- 5.6.2-2.1/src/csol_distrhs.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/csol_distrhs.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -17,9 +17,14 @@ C
      &           NRHS_COL, NRHS_loc, LRHS_loc,
      &           MAP_RHS_loc,
      &           IRHS_loc, RHS_loc, RHS_loc_size,
-     &           RHSCOMP, LD_RHSCOMP,
-     &           POSINRHSCOMP_FWD, NB_FS_IN_RHSCOMP,
-     &           LSCAL, scaling_data_dr,
+     &           RHSINTR, LD_RHSINTR,
+     &           POSINRHSINTR_FWD, NB_FS_IN_RHSINTR,
+     &           LSCAL,
+#if defined(USE_OLD_SCALING)
+     &           scaling_data_dr,
+#else
+     &           SCALING_RHSINTR_FWD, LSCALING_RHSINTR_FWD,
+#endif
      &           LP, LPOK, KEEP, NB_BYTES_LOC, INFO )
       USE CMUMPS_STRUC_DEF
 !$    USE OMP_LIB
@@ -32,17 +37,23 @@ C
       INTEGER, INTENT(IN)    :: IRHS_loc(NRHS_loc)
       INTEGER(8), INTENT(IN) :: RHS_loc_size
       COMPLEX, INTENT(IN)    :: RHS_loc(RHS_loc_size)
-      INTEGER, INTENT(IN)    :: NB_FS_IN_RHSCOMP, LD_RHSCOMP
-      INTEGER, INTENT(IN)    :: POSINRHSCOMP_FWD(N)
-      COMPLEX, INTENT(OUT)   :: RHSCOMP(LD_RHSCOMP, NRHS_COL)
+      INTEGER, INTENT(IN)    :: NB_FS_IN_RHSINTR, LD_RHSINTR
+      INTEGER, INTENT(IN)    :: POSINRHSINTR_FWD(N)
+      COMPLEX, INTENT(OUT)   :: RHSINTR(LD_RHSINTR, NRHS_COL)
       INTEGER                :: KEEP(500)
       LOGICAL, INTENT(IN)    :: LSCAL
+#if defined(USE_OLD_SCALING)
       type scaling_data_t
         SEQUENCE
-        REAL, dimension(:), pointer :: SCALING
-        REAL, dimension(:), pointer :: SCALING_LOC
+        REAL,    dimension(:), pointer :: SCALING
+        REAL,    dimension(:), pointer :: SCALING_LOC
+        INTEGER, dimension(:), pointer :: SCALING_IND 
       end type scaling_data_t
       type(scaling_data_t), INTENT(IN) :: scaling_data_dr
+#else
+      INTEGER :: LSCALING_RHSINTR_FWD
+      REAL :: SCALING_RHSINTR_FWD( LSCALING_RHSINTR_FWD )
+#endif
       LOGICAL, INTENT(IN)    :: LPOK
       INTEGER, INTENT(IN)    :: LP      
       INTEGER, INTENT(INOUT) :: INFO(2) 
@@ -135,7 +146,7 @@ C
      &         IS_SEND_ACTIVE(MAX_ACTIVE_SENDS),
      &         BUFRECI(MAXRECORDS),                
      &         BUFRECR(MAXRECORDS*NRHS_COL),       
-     &         TOUCHED(NB_FS_IN_RHSCOMP),          
+     &         TOUCHED(NB_FS_IN_RHSINTR),          
      &         stat=allocok)
       IF (allocok .GT. 0) THEN
         IF (LP .GT. 0) WRITE(LP, '(A)')
@@ -143,11 +154,11 @@ C
         INFO(1)=-13
         INFO(2)=NRHS_COL*MAXRECORDS*MAX_ACTIVE_SENDS+
      &          3*MAX_ACTIVE_SENDS+MAXRECORDS*(1+NRHS_COL)
-     &          + NB_FS_IN_RHSCOMP
+     &          + NB_FS_IN_RHSINTR
       ENDIF
       NB_BYTES_LOC=NB_BYTES_LOC +
      &  KEEP(34) * ( int(2*MAX_ACTIVE_SENDS,8) + int(MAXRECORDS,8) ) +
-     &  KEEP(34) * (int(MAX_ACTIVE_SENDS,8) + int(NB_FS_IN_RHSCOMP,8)) +
+     &  KEEP(34) * (int(MAX_ACTIVE_SENDS,8) + int(NB_FS_IN_RHSINTR,8)) +
      &  KEEP(35) * (
      &      int( MAXRECORDS,8)*int(NRHS_COL,8)*int(MAX_ACTIVE_SENDS,8)
      &      + int(MAXRECORDS,8) * int(NRHS_COL,8) )
@@ -160,7 +171,7 @@ C
         IS_SEND_ACTIVE(IREQ) = .FALSE.
       ENDDO
       NB_FS_TOUCHED = 0
-      DO IFS = 1, NB_FS_IN_RHSCOMP
+      DO IFS = 1, NB_FS_IN_RHSINTR
         TOUCHED(IFS) = .FALSE.
       ENDDO
       IPROC_MAX=maxloc(NBROWSTOSEND,DIM=1)-1
@@ -223,7 +234,7 @@ C
         INTEGER, INTENT(INOUT) :: BUFRECI_ARG(NBRECORDS) 
         COMPLEX, INTENT(IN) :: BUFRECR_ARG(NBRECORDS,
      &                                     NRHS_COL)
-        INTEGER :: I, K, IRHSCOMP, IFIRSTNOTTOUCHED, ILASTNOTTOUCHED
+        INTEGER :: I, K, IRHSINTR, IFIRSTNOTTOUCHED, ILASTNOTTOUCHED
         IFIRSTNOTTOUCHED = NBRECORDS+1
         ILASTNOTTOUCHED  = 0
         DO I = 1, NBRECORDS
@@ -232,9 +243,9 @@ C
      &      I, BUFRECI(I), BUFRECI(1)
             CALL MUMPS_ABORT()
           ENDIF
-          IRHSCOMP=POSINRHSCOMP_FWD(BUFRECI(I))
-          BUFRECI_ARG(I)=IRHSCOMP
-          IF ( .NOT. TOUCHED(IRHSCOMP) ) THEN
+          IRHSINTR=POSINRHSINTR_FWD(BUFRECI(I))
+          BUFRECI_ARG(I)=IRHSINTR
+          IF ( .NOT. TOUCHED(IRHSINTR) ) THEN
             IFIRSTNOTTOUCHED=min(IFIRSTNOTTOUCHED,I)
             ILASTNOTTOUCHED=max(ILASTNOTTOUCHED,I)
           ENDIF
@@ -243,41 +254,67 @@ C
 !$      OMP_FLAG = ( NRHS_COL.GE.KEEP(362) .AND.
 !$   &               NRHS_COL*NBRECORDS .GE. KEEP(363)/2)
         IF (OMP_FLAG) THEN
-!$OMP PARALLEL DO PRIVATE(I,IRHSCOMP) IF (OMP_FLAG)
+!$OMP PARALLEL DO PRIVATE(I,IRHSINTR)
         DO K = 1, NRHS_COL
           DO I = IFIRSTNOTTOUCHED, ILASTNOTTOUCHED
-            IRHSCOMP=BUFRECI_ARG(I)
-            IF (.NOT. TOUCHED(IRHSCOMP)) THEN
-              RHSCOMP(IRHSCOMP,K)=ZERO
+            IRHSINTR=BUFRECI_ARG(I)
+            IF (.NOT. TOUCHED(IRHSINTR)) THEN
+              RHSINTR(IRHSINTR,K)=ZERO
             ENDIF
           ENDDO
-          DO I = 1, NBRECORDS
-            IRHSCOMP=BUFRECI_ARG(I)
-            RHSCOMP(IRHSCOMP,K) = RHSCOMP(IRHSCOMP,K) +
+#if ! defined(USE_OLD_SCALING)
+          IF (LSCAL) THEN
+            DO I = 1, NBRECORDS
+              IRHSINTR=BUFRECI_ARG(I)
+              RHSINTR(IRHSINTR,K) = RHSINTR(IRHSINTR,K) +
+     &                            SCALING_RHSINTR_FWD(IRHSINTR) *
      &                            BUFRECR_ARG(I,K)
-          ENDDO
+            ENDDO
+          ELSE
+#endif
+            DO I = 1, NBRECORDS
+              IRHSINTR=BUFRECI_ARG(I)
+              RHSINTR(IRHSINTR,K) = RHSINTR(IRHSINTR,K) +
+     &                            BUFRECR_ARG(I,K)
+            ENDDO
+#if ! defined(USE_OLD_SCALING)
+          ENDIF
+#endif
         ENDDO
 !$OMP END PARALLEL DO
         ELSE
-        DO K = 1, NRHS_COL
-          DO I = IFIRSTNOTTOUCHED, ILASTNOTTOUCHED
-            IRHSCOMP=BUFRECI_ARG(I)
-            IF (.NOT. TOUCHED(IRHSCOMP)) THEN
-              RHSCOMP(IRHSCOMP,K)=ZERO
+          DO K = 1, NRHS_COL
+            DO I = IFIRSTNOTTOUCHED, ILASTNOTTOUCHED
+              IRHSINTR=BUFRECI_ARG(I)
+              IF (.NOT. TOUCHED(IRHSINTR)) THEN
+                RHSINTR(IRHSINTR,K)=ZERO
+              ENDIF
+            ENDDO
+#if ! defined(USE_OLD_SCALING)
+            IF ( LSCAL ) THEN
+              DO I = 1, NBRECORDS
+                IRHSINTR=BUFRECI_ARG(I)
+                RHSINTR(IRHSINTR,K) = RHSINTR(IRHSINTR,K) +
+     &                                SCALING_RHSINTR_FWD(IRHSINTR) *
+     &                                BUFRECR_ARG(I,K)
+              ENDDO
+            ELSE
+#endif
+              DO I = 1, NBRECORDS
+                IRHSINTR=BUFRECI_ARG(I)
+                RHSINTR(IRHSINTR,K) = RHSINTR(IRHSINTR,K) +
+     &                                BUFRECR_ARG(I,K)
+              ENDDO
+#if ! defined(USE_OLD_SCALING)
             ENDIF
+#endif
           ENDDO
-          DO I = 1, NBRECORDS
-            IRHSCOMP=BUFRECI_ARG(I)
-            RHSCOMP(IRHSCOMP,K) = RHSCOMP(IRHSCOMP,K) +
-     &                            BUFRECR_ARG(I,K)
-          ENDDO
-        ENDDO
         ENDIF
         DO I = 1, NBRECORDS
-          IRHSCOMP = BUFRECI_ARG(I)
-          IF (.NOT. TOUCHED(IRHSCOMP)) THEN
+          IRHSINTR = BUFRECI_ARG(I)
+          IF (.NOT. TOUCHED(IRHSINTR)) THEN
             NB_FS_TOUCHED = NB_FS_TOUCHED + 1
-            TOUCHED(IRHSCOMP) = .TRUE.
+            TOUCHED(IRHSINTR) = .TRUE.
           ENDIF
         ENDDO
         NBROWSTORECV = NBROWSTORECV - NBRECORDS
@@ -287,7 +324,7 @@ C
         INTEGER :: NBRECORDS, I, K, IFIRSTNOTTOUCHED
         INTEGER :: Iloc       
         INTEGER :: Iglob      
-        INTEGER :: IRHSCOMP   
+        INTEGER :: IRHSINTR   
         INTEGER(8) :: ISHIFT
         IF ( NBROWSTOSEND(MYID_NODES+1) .EQ. 0) THEN
           WRITE(*,*) "Internal error in CMUMPS_DR_ASSEMBLE_LOCAL"
@@ -296,9 +333,9 @@ C
         NBRECORDS=min(MAXRECORDS, NBROWSTOSEND(MYID_NODES+1))
         IFIRSTNOTTOUCHED=NBRECORDS+1
         DO I = 1, NBRECORDS
-          IRHSCOMP = POSINRHSCOMP_FWD(IRHS_loc(
+          IRHSINTR = POSINRHSINTR_FWD(IRHS_loc(
      &               IRHS_loc_sorted(NEXTROWTOSEND(MYID_NODES+1)+I-1)))
-          IF (.NOT. TOUCHED(IRHSCOMP)) THEN
+          IF (.NOT. TOUCHED(IRHSINTR)) THEN
             IFIRSTNOTTOUCHED=I
             EXIT
           ENDIF
@@ -306,57 +343,61 @@ C
         IF (LSCAL) THEN
 !$        OMP_FLAG = (NRHS_COL.GE.KEEP(362) .AND.
 !$   &                NRHS_COL*NBRECORDS .GE. KEEP(363)/2)
-!$OMP PARALLEL DO PRIVATE(K, ISHIFT, I, IRHSCOMP, Iloc, Iglob)
+!$OMP PARALLEL DO PRIVATE(K, ISHIFT, I, IRHSINTR, Iloc, Iglob)
 !$OMP&  FIRSTPRIVATE(NBRECORDS) IF (OMP_FLAG)
           DO K = 1, NRHS_COL
-            ISHIFT = (K-1) * LRHS_loc
+            ISHIFT = int(K-1,8) * int(LRHS_loc,8)
             DO I = IFIRSTNOTTOUCHED, NBRECORDS
-              IRHSCOMP = POSINRHSCOMP_FWD(IRHS_loc(
+              IRHSINTR = POSINRHSINTR_FWD(IRHS_loc(
      &               IRHS_loc_sorted(NEXTROWTOSEND(MYID_NODES+1)+I-1)))
-               IF (.NOT. TOUCHED(IRHSCOMP)) THEN
-                 RHSCOMP(IRHSCOMP,K)=ZERO
+               IF (.NOT. TOUCHED(IRHSINTR)) THEN
+                 RHSINTR(IRHSINTR,K)=ZERO
                ENDIF
             ENDDO
             DO I = 1, NBRECORDS
               Iloc = IRHS_loc_sorted(NEXTROWTOSEND(MYID_NODES+1)+I-1)
               Iglob = IRHS_loc(Iloc)
-              IRHSCOMP = POSINRHSCOMP_FWD(Iglob)
-              RHSCOMP(IRHSCOMP,K) = RHSCOMP(IRHSCOMP,K)+
+              IRHSINTR = POSINRHSINTR_FWD(Iglob)
+              RHSINTR(IRHSINTR,K) = RHSINTR(IRHSINTR,K)+
      &                              RHS_loc(Iloc+ISHIFT)*
+#if defined(USE_OLD_SCALING)
      &                        scaling_data_dr%SCALING_LOC(Iloc)
+#else
+     &                        SCALING_RHSINTR_FWD(IRHSINTR)
+#endif
             ENDDO
           ENDDO
 !$OMP END PARALLEL DO
         ELSE
 !$        OMP_FLAG = (NRHS_COL.GE.KEEP(362) .AND.
 !$   &                NRHS_COL*NBRECORDS .GE. KEEP(363)/2)
-!$OMP PARALLEL DO PRIVATE(K, ISHIFT, I, IRHSCOMP, Iloc, Iglob)
+!$OMP PARALLEL DO PRIVATE(K, ISHIFT, I, IRHSINTR, Iloc, Iglob)
 !$OMP&  FIRSTPRIVATE(NBRECORDS) IF (OMP_FLAG)
           DO K = 1, NRHS_COL
-            ISHIFT = (K-1) * LRHS_loc
+            ISHIFT = int(K-1,8) * int(LRHS_loc,8)
             DO I = IFIRSTNOTTOUCHED, NBRECORDS
-              IRHSCOMP = POSINRHSCOMP_FWD(IRHS_loc(
+              IRHSINTR = POSINRHSINTR_FWD(IRHS_loc(
      &               IRHS_loc_sorted(NEXTROWTOSEND(MYID_NODES+1)+I-1)))
-               IF (.NOT. TOUCHED(IRHSCOMP)) THEN
-                 RHSCOMP(IRHSCOMP,K)=ZERO
+               IF (.NOT. TOUCHED(IRHSINTR)) THEN
+                 RHSINTR(IRHSINTR,K)=ZERO
                ENDIF
             ENDDO
             DO I = 1, NBRECORDS
               Iloc = IRHS_loc_sorted(NEXTROWTOSEND(MYID_NODES+1)+I-1)
               Iglob = IRHS_loc(Iloc)
-              IRHSCOMP = POSINRHSCOMP_FWD(Iglob)
-              RHSCOMP(IRHSCOMP,K) = RHSCOMP(IRHSCOMP,K)+
+              IRHSINTR = POSINRHSINTR_FWD(Iglob)
+              RHSINTR(IRHSINTR,K) = RHSINTR(IRHSINTR,K) +
      &                              RHS_loc(Iloc+ISHIFT)
             ENDDO
           ENDDO
 !$OMP END PARALLEL DO
         ENDIF
         DO I = 1, NBRECORDS
-          IRHSCOMP = POSINRHSCOMP_FWD(IRHS_loc(
+          IRHSINTR = POSINRHSINTR_FWD(IRHS_loc(
      &               IRHS_loc_sorted(NEXTROWTOSEND(MYID_NODES+1)+I-1)))
-          IF (.NOT. TOUCHED(IRHSCOMP)) THEN
+          IF (.NOT. TOUCHED(IRHSINTR)) THEN
             NB_FS_TOUCHED = NB_FS_TOUCHED + 1
-            TOUCHED(IRHSCOMP) = .TRUE.
+            TOUCHED(IRHSINTR) = .TRUE.
           ENDIF
         ENDDO
         NEXTROWTOSEND(MYID_NODES+1)=NEXTROWTOSEND(MYID_NODES+1)+
@@ -434,8 +475,10 @@ C
                 IPOSRHS = int(K-1,8)*int(LRHS_loc,8)
                 Iloc = IRHS_loc_sorted(NEXTROWTOSEND(IPROC_ARG+1)+I-1)
                 BUFR( IPOSBUF + I, IBUF )
-     &                = RHS_loc( IPOSRHS + Iloc ) *
-     &                  scaling_data_dr%SCALING_LOC(Iloc)
+     &                = RHS_loc( IPOSRHS + Iloc )
+#if defined(USE_OLD_SCALING)
+     &                  * scaling_data_dr%SCALING_LOC(Iloc)
+#endif
               ENDDO
             ENDDO
 !$OMP END PARALLEL DO
@@ -475,24 +518,25 @@ C
         END SUBROUTINE CMUMPS_DR_TRY_SEND
         SUBROUTINE CMUMPS_DR_EMPTY_ROWS()
         INTEGER :: K, IFS
-        IF ( NB_FS_TOUCHED .NE. NB_FS_IN_RHSCOMP ) THEN
+        IF ( NB_FS_TOUCHED .NE. NB_FS_IN_RHSINTR ) THEN
 !$        OMP_FLAG = (NRHS_COL .GE. KEEP(362)) .AND.
-!$   &    (NRHS_COL*NB_FS_IN_RHSCOMP >  KEEP(363)/2)
-!$OMP PARALLEL DO FIRSTPRIVATE(NB_FS_IN_RHSCOMP) IF (OMP_FLAG)
+!$   &    (NRHS_COL*NB_FS_IN_RHSINTR >  KEEP(363)/2)
+!$OMP PARALLEL DO FIRSTPRIVATE(NB_FS_IN_RHSINTR)
+!$OMP&    PRIVATE(IFS) IF (OMP_FLAG)
           DO K = 1, NRHS_COL
-            DO IFS = 1, NB_FS_IN_RHSCOMP
+            DO IFS = 1, NB_FS_IN_RHSINTR
               IF ( .NOT. TOUCHED(IFS) ) THEN
-                RHSCOMP( IFS, K) = ZERO
+                RHSINTR( IFS, K) = ZERO
               ENDIF
             ENDDO
-            DO IFS = NB_FS_IN_RHSCOMP +1, LD_RHSCOMP
-              RHSCOMP (IFS, K) = ZERO
+            DO IFS = NB_FS_IN_RHSINTR +1, LD_RHSINTR
+              RHSINTR (IFS, K) = ZERO
             ENDDO
           ENDDO
 !$OMP END PARALLEL DO
         ELSE
 !$        OMP_FLAG = .FALSE.
-!$        CHUNK8 = int(NRHS_COL,8)*int(LD_RHSCOMP-NB_FS_IN_RHSCOMP,8)
+!$        CHUNK8 = int(NRHS_COL,8)*int(LD_RHSINTR-NB_FS_IN_RHSINTR,8)
 !$        CHUNK8 = max(CHUNK8,1_8)
 !$        IF (CHUNK8 .GE. int(KEEP(363),8)) THEN
 !$          OMP_FLAG = .TRUE.
@@ -501,8 +545,8 @@ C
 !$OMP PARALLEL DO COLLAPSE(2) SCHEDULE(STATIC,CHUNK8)
 !$OMP&  IF (OMP_FLAG)
           DO K = 1, NRHS_COL
-            DO IFS = NB_FS_IN_RHSCOMP +1, LD_RHSCOMP
-             RHSCOMP (IFS, K) = ZERO
+            DO IFS = NB_FS_IN_RHSINTR +1, LD_RHSINTR
+             RHSINTR (IFS, K) = ZERO
             ENDDO
           ENDDO
 !$OMP END PARALLEL DO
@@ -532,15 +576,19 @@ C
      &               ( id%MYID .eq. MASTER .AND.
      &                 id%KEEP(46) .eq. 1 ) )
         IF (id%MYID .EQ. MASTER) THEN
-          IF (id%ICNTL(20).EQ.10) THEN
-            ROW_OR_COL_INDICES = 0 
-          ELSE IF (id%ICNTL(20).EQ.11) THEN
-            ROW_OR_COL_INDICES = 1 
-          ELSE 
-            ROW_OR_COL_INDICES = 0 
-          ENDIF
-          IF (id%ICNTL(9) .NE. 1) THEN
-            ROW_OR_COL_INDICES = 1 - ROW_OR_COL_INDICES
+          IF (id%KEEP(50).NE.0) THEN
+            ROW_OR_COL_INDICES = 0
+          ELSE
+            IF (id%ICNTL(20).EQ.10 .OR. id%KEEP(50).EQ.0) THEN
+              ROW_OR_COL_INDICES = 0 
+            ELSE IF (id%ICNTL(20).EQ.11) THEN
+              ROW_OR_COL_INDICES = 1 
+            ELSE 
+              ROW_OR_COL_INDICES = 0 
+            ENDIF
+            IF (id%ICNTL(9) .NE. 1) THEN
+              ROW_OR_COL_INDICES = 1 - ROW_OR_COL_INDICES
+            ENDIF
           ENDIF
           IF (id%KEEP(23).NE.0 .AND. id%ICNTL(9) .NE.1) THEN
             UNS_PERM_TO_BE_DONE = 1
@@ -577,7 +625,8 @@ C
           ELSE
             idIRHS_loc => IDUMMY
           ENDIF
-          CALL MUMPS_BUILD_IRHS_loc(id%MYID_NODES, id%NSLAVES, id%N,
+          CALL MUMPS_GET_INDICES
+     &    (id%MYID_NODES, id%NSLAVES, id%N,
      &    id%PTLUST_S(1), id%KEEP(1), id%KEEP8(1), id%IS(1),
      &    max(1, id%KEEP(32)),
      &    id%STEP(1), id%PROCNODE_STEPS(1), idIRHS_loc(1),
diff -pruN 5.6.2-2.1/src/csol_distsol.F 5.7.1-1/src/csol_distsol.F
--- 5.6.2-2.1/src/csol_distsol.F	1970-01-01 00:00:00.000000000 +0000
+++ 5.7.1-1/src/csol_distsol.F	2024-05-02 10:15:27.000000000 +0000
@@ -0,0 +1,16 @@
+C
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
+C
+C
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Mumps Technologies, University of Bordeaux.
+C
+C  This version of MUMPS is provided to you free of charge. It is
+C  released under the CeCILL-C license 
+C  (see doc/CeCILL-C_V1-en.txt, doc/CeCILL-C_V1-fr.txt, and
+C  https://cecill.info/licences/Licence_CeCILL-C_V1-en.html)
+C
+      SUBROUTINE CMUMPS_DS_RETURN()
+      RETURN
+      END SUBROUTINE CMUMPS_DS_RETURN
diff -pruN 5.6.2-2.1/src/csol_driver.F 5.7.1-1/src/csol_driver.F
--- 5.6.2-2.1/src/csol_driver.F	2023-10-11 09:37:10.000000000 +0000
+++ 5.7.1-1/src/csol_driver.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -25,7 +25,7 @@ C  Performs solution phase (solve), Iter
 C  and Error analysis.
 C
 C
-C
+c
 C
       USE CMUMPS_BUF
       USE CMUMPS_OOC
@@ -34,7 +34,9 @@ C
      &                           , CMUMPS_BLR_MOD_TO_STRUC
       USE MUMPS_FRONT_DATA_MGT_M, only : MUMPS_FDM_STRUC_TO_MOD,
      &                                   MUMPS_FDM_MOD_TO_STRUC
+#if ! defined(NO_SAVE_RESTORE)
       USE CMUMPS_SAVE_RESTORE
+#endif
 !$    USE OMP_LIB
       IMPLICIT NONE
 C     -------------------
@@ -76,8 +78,11 @@ C
       LOGICAL PROK, PROKG, LPOK
       INTEGER MTYPE, ICNTL21
       LOGICAL LSCAL, POSTPros, GIVSOL
-      INTEGER ICNTL10, ICNTL11
-      INTEGER I,IPERM,K,JPERM, J, II, IZ2
+      INTEGER ICNTL10, ICNTL11, ICNTL48_EFF
+      INTEGER I,K,JPERM, J, II, IZ2
+#if defined(USE_OLD_SCALING)
+      INTEGER IPERM
+#endif
       INTEGER IZ, NZ_THIS_BLOCK, PJ
 C     pointers in IS
       INTEGER LIW
@@ -101,6 +106,7 @@ C
       INTEGER NITREF, NOITER, SOLVET, KASE
 C     Meaningful only with tree pruning and sparse RHS
       LOGICAL INTERLEAVE_PAR, DO_PERMUTE_RHS
+      LOGICAL CALL_NODES_FWD_BWD, FIRST_CALL_NODES_FWD_BWD
 C     true if CMUMPS_SOL_C called during postprocessing
       LOGICAL FROM_PP
 C
@@ -125,17 +131,23 @@ C     ----------------------------------
 C
       INTEGER, DIMENSION(:), ALLOCATABLE :: MAP_RHS_loc
       INTEGER, DIMENSION(:), POINTER :: IRHS_loc_PTR
-      LOGICAL :: IRHS_loc_PTR_allocated
+      LOGICAL :: IRHS_loc_PTR_ALLOCATED
+      INTEGER(8) :: SUM_idNloc_RHS_8
       COMPLEX, DIMENSION(:), POINTER :: idRHS_loc
       INTEGER(8) :: DIFF_SOL_loc_RHS_loc
       INTEGER(8) :: RHS_loc_size, RHS_loc_shift
       INTEGER(8)  :: NBT
       INTEGER     :: NBCOL, COLSIZE, JBEG_RHS, JEND_RHS, JBEG_NEW,
-     &               NBCOL_INBLOC, IPOS, IPOSRHSCOMP
+     &               NBCOL_INBLOC, IPOS, IPOSRHSINTR
+C     Nb of pruned NE_STEPS, useful for FWD step; and list of root nodes
+      LOGICAL    :: fill
+      INTEGER, DIMENSION(:), ALLOCATABLE ::  Pruned_Sons_FWD, 
+     &                                       Pruned_Sons_BWD
       INTEGER, DIMENSION(:), ALLOCATABLE :: PERM_RHS
-      INTEGER, DIMENSION(:), POINTER :: PTR_POSINRHSCOMP_FWD,
-     &                                  PTR_POSINRHSCOMP_BWD
+      INTEGER, DIMENSION(:), POINTER :: PTR_POSINRHSINTR_FWD,
+     &                                  PTR_POSINRHSINTR_BWD
       COMPLEX, DIMENSION(:), POINTER :: PTR_RHS
+      INTEGER, DIMENSION(:), POINTER :: idIPTR_WORKING, idWORKING
       INTEGER :: SIZE_IPTR_WORKING, SIZE_WORKING
 C     NRHS_NONEMPTY: holds
 C         either the original number of RHS (id%NRHS defined on host)
@@ -191,11 +203,12 @@ C     arrays only used for distributed m
 C     (KEEP(54) .NE. 0).
       REAL,    ALLOCATABLE, DIMENSION(:) :: R_LOCWK54
       COMPLEX, ALLOCATABLE, DIMENSION(:) :: C_LOCWK54
-      INTEGER   :: NBENT_RHSCOMP, NB_FS_RHSCOMP_F,
-     &             NB_FS_RHSCOMP_TOT
+      INTEGER   :: NBENT_RHSINTR, NB_FS_RHSINTR_F,
+     &             NB_FS_RHSINTR_TOT
       INTEGER, DIMENSION(:), ALLOCATABLE :: UNS_PERM_INV
       LOGICAL :: UNS_PERM_INV_NEEDED_INMAINLOOP,
-     &           UNS_PERM_INV_NEEDED_BEFMAINLOOP
+     &           UNS_PERM_INV_NEEDED_BEFMAINLOOP,
+     &           UNS_PERM_INV_NEEDED_ONSLAVES
       INTEGER LIWK_SOLVE, LIWCB
       INTEGER, ALLOCATABLE :: IW1(:), IWK_SOLVE(:), IWCB(:)
       INTEGER ::  LIWK_PTRACB
@@ -214,7 +227,7 @@ C     SCALING issues:
 C       When scaling was performed
 C       RHS holds the solution of the scaled system
 C       The unscaled second member (b0) was given
-C       then we have to scale both rhs adn solution:
+C       then we have to scale both rhs and solution:
 C        A(sca) = LU  = D1*A*D2 , with D2 = COLSCA
 C                                      D1 = ROWSCA
 C        --------------
@@ -222,33 +235,65 @@ C        CASE OF A X =B
 C        --------------
 C         (ICNTL(9)=1 or MTYPE=1)
 C           A*x0 = b0
-C           b(sca) = D1 * b0 = ROWSCA*S(ISTW3)
+C           b(sca) = D1 * b0 = ROWSCA*b0
 C           A(sca) [(D2) **(-1)] x0 = b(sca)
-C           so the computed solution by Check y0 of LU *y0 = b(sca)
-C           is : y0 =[(D2) **(-1)] x0 and so x0= D2*y0 is modified
+C           so the computed solution of LU * x(sca) = b(sca)
+C           is : x(sca) =[(D2) **(-1)] x0 and so x0= D2*x(sca)
 C        --------------
 C        CASE OF AT X =B
 C        --------------
 C         (ICNTL(9).NE.1 or MTYPE=0)
 C           A(sca) = LU  = D1*A*D2
-C           AT*x0 = b0 => D2ATD1 D1-1 x0 = D2b0
-C           b(sca) = D2 * b0 = COLSCA*S(ISTW3)
+C           AT*x0 = b0 => D2*AT*D1 * D1-1 x0 = D2 * b0
+C           b(sca) = D2 * b0 = COLSCA*b0
 C           A(sca)T [(D1) **(-1)] x0 = b(sca)
-C           so the computed solution by Check y0 of LU *y0 = b(sca)
-C           is : y0 =[(D1) **(-1)] x0 and so x0= D1*y0 is modified
+C           so the computed solution of (LU)^T * x(sca) = b(sca)
+C           is : x(sca) =[(D1) **(-1)] x0 and so x0= D1*y0 is modified
 C
-C      In case of distributed RHS we need
-C      scaling information on each processor
+C     In case of distributed RHS or distributed solution we need
+C     scaling information on each processor and this information has
+C     been stored in ROWSCA_loc(1:INFO(23)) and COLSCA_loc(1:INFO(23))
+C     such that:
+C
+C     ----------------
+C     CASE OF A X  = B
+C     ----------------
+C
+C     - the scaling factor of row i of A is stored on the
+C     processor for which GLOB2LOC_RHS(i) > 0 at position
+C     ROWSCA_loc(GLOB2LOC_RHS(i))
+C     
+C     - the scaling factor of column j of A is stored on the
+C     processor for which GLOB2LOC_SOL(j) > 0 at position
+C     COLSCA_loc(GLOB2LOC_SOL(j))
+C
+C     ------------------
+C     CASE OF A^T X  = B
+C     ------------------
+C
+C     - the scaling factor of row i of A^T is stored on the
+C     processor for which GLOB2LOC_RHS(i) > 0 at position
+C     COLSCA_loc(GLOB2LOC_RHS(i))
+C     
+C     - the scaling factor of column j of A^T is stored on the
+C     processor for which GLOB2LOC_SOL(j) > 0 at position
+C     ROWSCA_loc(GLOB2LOC_SOL(j))
 C
+#if defined(USE_OLD_SCALING)
           type scaling_data_t
             SEQUENCE
-            REAL, dimension(:), pointer :: SCALING
-            REAL, dimension(:), pointer :: SCALING_LOC
+            REAL   , dimension(:), pointer :: SCALING
+            REAL   , dimension(:), pointer :: SCALING_LOC
+            INTEGER, dimension(:), pointer :: SCALING_IND
           end type scaling_data_t
-          type (scaling_data_t) :: scaling_data_sol, scaling_data_dr
-C      To scale on the fly during GATHER SOLUTION
+          type (scaling_data_t) :: scaling_data_dr
+          type (scaling_data_t) :: scaling_data_sol
+C      To scale on the fly during GATHER SOLUTION:
           REAL, DIMENSION(:), POINTER :: PT_SCALING
           REAL, TARGET                :: Dummy_SCAL(1)
+#else
+          INTEGER :: ROWORCOL
+#endif
 C
 C  ==================== END OF SCALING related data ================
 C
@@ -273,8 +318,8 @@ C     Interval associated to the subbloc
      &        MASTER_ROOT, MASTER_ROOT_IN_COMM
       INTEGER SIZE_ROOT, LD_REDRHS
       INTEGER(8) :: IPT_RHS_ROOT
-      INTEGER(8) :: IBEG, IBEG_RHSCOMP, KDEC, IBEG_loc, IBEG_REDRHS
-      INTEGER LD_RHSCOMP, NCOL_RHS_loc
+      INTEGER(8) :: IBEG, IBEG_RHSINTR, KDEC, IBEG_loc, IBEG_REDRHS
+      INTEGER NCOL_RHS_loc
       INTEGER LD_RHS_loc, JBEG_RHS_loc
       INTEGER NB_K133, IRANK, TSIZE
       INTEGER KMAX_246_247
@@ -292,8 +337,25 @@ C  Vampir
       INTEGER soln_drive_class, glob_comm_ini, perm_scal_ini, soln_dist,
      &        soln_assem, perm_scal_post
 #endif
-      LOGICAL I_AM_SLAVE, BUILD_POSINRHSCOMP
+      LOGICAL I_AM_SLAVE, BUILD_POSINRHSINTR
       LOGICAL :: BUILD_RHSMAPINFO
+      REAL, TARGET :: RDUMMY_TARGET(1)
+      LOGICAL :: ES_RHSINTR
+      INTEGER, DIMENSION(:), POINTER :: nodes_FWD, nodes_BWD
+C     to manage sparsity: compute target nodes for starting chains
+C     Lnodes_FWD/Lnodes_BWD = -1 => all nodes to be processed
+      INTEGER, DIMENSION(:), POINTER :: nodes_FWD_PTR, nodes_BWD_PTR
+      INTEGER :: Lnodes_FWD, Lnodes_BWD, Lnodes_FWD_PTR, Lnodes_BWD_PTR
+      REAL, POINTER, DIMENSION(:) :: SCALING_loc_FWD
+      REAL, POINTER, DIMENSION(:) :: SCALING_loc_BWD
+      REAL, POINTER, DIMENSION(:) :: SCALING_RHSINTR_BWD
+      REAL, POINTER, DIMENSION(:) :: SCALING_RHSINTR_FWD
+      INTEGER :: LSCALING_RHSINTR_BWD, LSCALING_RHSINTR_FWD
+      LOGICAL :: SCALING_RHSINTR_BWD_ALLOCATED,
+     &           SCALING_RHSINTR_FWD_ALLOCATED,
+     &           BUILD_SCALING_RHSINTR
+C    NSOL_loc will be equal to KEEP(89) in case ICNTL(21)=1
+      INTEGER :: NSOL_loc
       LOGICAL WORK_WCB_ALLOCATED, IS_INIT_OOC_DONE
       LOGICAL :: IS_LR_MOD_TO_STRUC_DONE
       INTEGER :: KEEP350_SAVE
@@ -303,7 +365,6 @@ C  Vampir
       INTEGER  MAT_ALLOC_LOC, MAT_ALLOC
       INTEGER MUMPS_PROCNODE
       EXTERNAL MUMPS_PROCNODE
-      INTEGER(8) :: FILE_SIZE,STRUC_SIZE
 C
 C  First executable statement
 C
@@ -318,9 +379,25 @@ C
       CALL VTFUNCDEF( 'perm_scal_post',soln_drive_class,
      &     perm_scal_post,IERR)
 #endif
+C     Depending on the type of parallelism,
+C     the master can have the role of a slave
+      I_AM_SLAVE = ( id%MYID .ne. MASTER  .OR.
+     &             ( id%MYID .eq. MASTER .AND.
+     &               id%KEEP(46) .eq. 1 ) )
 C     -- The following pointers xxCOPY might be allocated but then
 C     -- the associated xxCOPY_ALLOCATED will be set to
 C     -- enable deallocation
+      SCALING_RHSINTR_FWD_ALLOCATED = .FALSE.
+      SCALING_RHSINTR_BWD_ALLOCATED = .FALSE.
+C     Initialize scalings to possilby pass them as arguments
+C     (e.g. to CMUMPS_DS_ALL2ALL) even on non working host
+C     and/or when LSCAL is false
+      SCALING_RHSINTR_FWD => RDUMMY_TARGET
+      SCALING_RHSINTR_BWD => RDUMMY_TARGET
+      LSCALING_RHSINTR_FWD = 1
+      LSCALING_RHSINTR_BWD = 1
+      SCALING_LOC_FWD => RDUMMY_TARGET
+      SCALING_LOC_BWD => RDUMMY_TARGET
       IRHS_PTR_COPY => IDUMMY_TARGET
       IRHS_PTR_COPY_ALLOCATED = .FALSE.
       IRHS_SPARSE_COPY => IDUMMY_TARGET
@@ -329,10 +406,16 @@ C     -- enable deallocation
       RHS_SPARSE_COPY_ALLOCATED=.FALSE.
       NULLIFY(RHS_IR)
       NULLIFY(WORK_WCB)
+#if defined(USE_OLD_SCALING)
       NULLIFY(scaling_data_dr%SCALING)
       NULLIFY(scaling_data_dr%SCALING_LOC)
+      NULLIFY(scaling_data_dr%SCALING_IND)
       NULLIFY(scaling_data_sol%SCALING)
       NULLIFY(scaling_data_sol%SCALING_LOC)
+      NULLIFY(scaling_data_sol%SCALING_IND)
+#endif
+      NULLIFY(nodes_FWD)
+      NULLIFY(nodes_BWD)
       IRHS_loc_PTR_allocated = .FALSE.
       IS_INIT_OOC_DONE   = .FALSE.
       IS_LR_MOD_TO_STRUC_DONE = .FALSE.
@@ -344,9 +427,6 @@ C     -- enable deallocation
       IS   =>id%IS
       ICNTL=>id%ICNTL
       INFO =>id%INFO
-C      ASPK =>id%A
-C      COLSCA =>id%COLSCA
-C      ROWSCA =>id%ROWSCA
       RINFOG =>id%RINFOG
       LP  = ICNTL( 1 )
       MP  = ICNTL( 2 )
@@ -366,7 +446,7 @@ C      ROWSCA =>id%ROWSCA
       K34_8    = int(KEEP(34), 8)
       K35_8    = int(KEEP(35), 8)
       K16_8    = int(KEEP(16), 8)
-      NBENT_RHSCOMP = 0
+      NBENT_RHSINTR = 0
 C     Used by DISTRIBUTED_SOLUTION to skip empty columns
 C     that are skipped (case of sparse RHS)
       NB_RHSSKIPPED = 0
@@ -375,47 +455,48 @@ C     to free space allocated
       LSCAL              = .FALSE.
       WORK_WCB_ALLOCATED = .FALSE.
       ICNTL21  = -99998  ! will be bcasted later to slaves
-      IBEG_RHSCOMP =-152525_8  ! Should not be used
-      BUILD_POSINRHSCOMP = .TRUE.
+      IBEG_RHSINTR =-152525_8  ! Should not be used
+      BUILD_POSINRHSINTR      = .TRUE.
+C     NSOL_loc, KEEP(212) will be set if ICNTL(21).EQ.2
+      NSOL_loc = 0
+      KEEP(212)= 0
+C     SCALING_RHSINTR was initialized to a dummy array of size 1
+C     on the non working host, no need to reset it at each block
+      BUILD_SCALING_RHSINTR = I_AM_SLAVE
       IBEG_GLOB_DEF = -9888  ! unitialized state
       IEND_GLOB_DEF = -9888  ! unitialized state
       IBEG_ROOT_DEF = -9777  ! unitialized state
       IEND_ROOT_DEF = -9777  ! unitialized state
       IROOT_DEF_RHS_COL1 = -9666 ! unitialized state
-C     Not needed anymore (since new version of gather)
-C     LD_RHSCOMP = max(KEEP(89),1)  ! at the nb of pivots eliminated on
-                                    ! that proc
-      LD_RHSCOMP = 1
-      NB_FS_RHSCOMP_TOT = KEEP(89)
+C     ------------------------------
+C     id%LD_RHSINTR will be set each
+C     time RHSINTR is allocated
+C     ------------------------------
+      NB_FS_RHSINTR_TOT = KEEP(89)
 !     number of FS var of the pruned tree
 !     mapped on this proc
-      NB_FS_RHSCOMP_F = NB_FS_RHSCOMP_TOT
+      NB_FS_RHSINTR_F = NB_FS_RHSINTR_TOT
 C     Save value of KEEP(350), in case of LR solve
 C     KEEP(350) may be overwritten and restored
 C     Old unoptimized version before 5.0.2 not available anymore
       IF (KEEP(350).LE.0) KEEP(350)=1
       IF (KEEP(350).GT.2) KEEP(350)=1
       KEEP350_SAVE = KEEP(350)
-C
-C     Depending on the type of parallelism,
-C     the master can have the role of a slave
-      I_AM_SLAVE = ( id%MYID .ne. MASTER  .OR.
-     &             ( id%MYID .eq. MASTER .AND.
-     &               KEEP(46) .eq. 1 ) )
 C     
 C     Compute the number of integers and nb of reals in the structure
       CALL CMUMPS_SIZE_IN_STRUCT (id, NB_INT, NB_CMPLX, NB_CHAR)
       NB_BYTES = NB_BYTES + NB_INT * K34_8 + NB_CMPLX * K35_8 + NB_CHAR
       NB_BYTES_ON_ENTRY = NB_BYTES !used to check alloc/dealloc count ok
-      CALL CMUMPS_COMPUTE_MEMORY_SAVE(id,FILE_SIZE,STRUC_SIZE)
       NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
 C     ======================================
 C     BEGIN CHECK KEEP ENTRIES AND INTERFACE
 C     ======================================
       IF (id%MYID .EQ. MASTER) THEN
 C     {
-c     subroutine only because called at facto and solve
-          CALL CMUMPS_SET_K221(id)
+C         Set ICNTL(26) -> KEEP(221)  (called at facto and solve)
+C         (might be called at facto in case of fwd in facto 
+C          with Schur+reduced RHS requested)
+          CALL CMUMPS_SET_K221(id, .TRUE.)
           id%KEEP(111) = id%ICNTL(25)
 C         For the case of ICNTL(20)=1 one could
 C         switch off exploit sparsity when RHS is too dense.
@@ -430,8 +511,12 @@ C         switch off exploit sparsity wh
           ELSE
             id%KEEP(248) = 0 !dense RHS
           ENDIF
+C
+C         set ICNTL21 and test for out-of range entries
           ICNTL21      = id%ICNTL(21)
-          IF (ICNTL21 .ne.0.and.ICNTL21.ne.1) ICNTL21=0
+          IF ( ICNTL21.NE.0 .AND. ICNTL21.NE.1
+     &       ) ICNTL21 = 0
+C
           IF ( id%ICNTL(30) .NE.0 ) THEN
 C           A-1 is on
             id%KEEP(237) = 1
@@ -445,25 +530,81 @@ C            Force KEEP(248) accordingly
              id%KEEP(248)=1
           ENDIF
           IF ((id%KEEP(221).EQ.2 ).AND.(id%KEEP(248).NE.0) ) THEN
-C          -- input RHS is indeed stored in REDRHS and RHSCOMP
-           id%KEEP(248) = 0
+           IF (KEEP(60).NE.0) THEN
+C            -- input RHS is stored in REDRHS and RHSINTR
+             id%KEEP(248) = 0
+           ENDIF
           ENDIF
+C}
+      ENDIF
+C     =============================================================
+C     KEEP(248) and KEEP(221): need be broadcasted
+C     before continuing other checking/settings
+      CALL MPI_BCAST( id%KEEP(221), 1, MPI_INTEGER, MASTER, id%COMM,
+     &                  IERR )
+      CALL MPI_BCAST( id%KEEP(248), 1, MPI_INTEGER, MASTER, id%COMM,
+     &                  IERR )
+      IF (KEEP(248).EQ.-1
+     &  ) THEN
+C{
+        CALL CMUMPS_CHECK_DISTRHS(
+     &       id%Nloc_RHS,
+     &       id%LRHS_loc,
+     &       id%NRHS,
+     &       id%IRHS_loc,
+     &       id%RHS_loc,
+     &       I_AM_SLAVE,
+     &       id%INFO)
+        CALL MUMPS_PROPINFO( id%ICNTL(1),
+     &                      id%INFO(1),
+     &                      id%COMM, id%MYID )
+        IF ( id%INFO(1) .LT. 0 ) GO TO 90
+C         Compute sum of id%Nloc_RHS (without out-of-range)
+C         and store it in SUM_idNloc_RHS_8
+C         (to be used to decide whether exploit sparsity 
+C         is exploited)
+          CALL CMUMPS_ES_GET_SUM_Nloc ( 
+     &             id%N, id%Nloc_RHS, id%IRHS_loc, id%COMM,
+     &             SUM_idNloc_RHS_8 )
+C}
+      ENDIF
+C     ===========================================================
+      IF (id%MYID .EQ. MASTER) THEN
+C     {
           IF ((id%KEEP(221).EQ.2 ).AND.(id%KEEP(235).NE.0) ) THEN
 C          -- input RHS is in fact effectively
-C          -- stored in REDRHS and RHSCOMP
-           id%KEEP(235) = 0
+C          -- stored in REDRHS and/or RHSINTR
+C          (for both Schur and bwd only)
+            id%KEEP(235) = 0
           ENDIF
           IF ( (id%KEEP(248).EQ.0).AND.(id%KEEP(111).EQ.0) ) THEN
 C           RHS is not sparse and thus exploit sparsity is reset to 0
             id%KEEP(235) = 0
           ENDIF
-          IF (KEEP(248) .EQ. -1) THEN
-C           V0 distributed RHS: no ES
-            id%KEEP(235) = 0
+          IF (id%KEEP(248) .EQ. -1
+     &       ) THEN
+            IF (id%KEEP(126).EQ.0)  THEN
+             id%KEEP(235) = 0
+            ELSE IF (id%KEEP(126).EQ.-1)  THEN
+             id%KEEP(235) = 1
+            ELSE IF (id%KEEP(126).GT.0) THEN
+             IF ( SUM_idNloc_RHS_8 .LE. 
+     &        int( 
+     &          (real(id%KEEP(126))/real(1000))*real(id%N)
+     &          , 8)
+     &          ) THEN
+               id%KEEP(235) = 1
+             ELSE
+               id%KEEP(235) = 0
+             ENDIF
+            ELSE
+             id%KEEP(235) = 0
+            ENDIF
           ENDIF
 C         Case of Automatic setting of exploit sparsity (KEEP(235)=-1)
 C         (in MUMPS_DRIVER original value of KEEP(235) is reset)
           IF(id%KEEP(111).NE.0) id%KEEP(235)=0
+          IF(id%KEEP(111).NE.0) id%KEEP(212)=0
 C
           IF (id%KEEP(235).EQ.-1) THEN
             IF (id%KEEP(237).NE.0) THEN
@@ -476,8 +617,10 @@ C            for A-1
             id%KEEP(235)=1
           ENDIF
 C         Setting of KEEP(242) (permute RHS)
-          IF ((KEEP(111).NE.0)) THEN
-C          In the context of null space, the null pivots
+          IF ((KEEP(111).NE.0).OR.(KEEP(248) .EQ. -1)) THEN
+C          In the context of 
+C          - distributed RHS, all columns share the same structure
+C          - null space, the null pivots
 C          are by default permuted to post-order
 C          However for null space there is in this case no need to
 C          permute null pivots since they are already in correct order.
@@ -520,8 +663,8 @@ C           Automatic setting of permute
             ENDIF
 C           }
           ENDIF
-          IF ( (id%KEEP(221).EQ.1 ).AND.(id%KEEP(235).NE.0) ) THEN
-C          -- Do not permute RHS with REDRHS for the time being
+          IF ( id%KEEP(221).NE.0 ) THEN
+C          -- Do not permute RHS with REDRHS/RHSINTR 
             id%KEEP(242) = 0
           ENDIF
           IF (KEEP(242).EQ.0) KEEP(243)=0 ! interleave off
@@ -575,24 +718,31 @@ C
           ENDIF
 C     }
       ENDIF
+      id%KEEP(401) = 0
+      IF (id%ICNTL(48).EQ.1) id%KEEP(401)=1
 C     Bcast id%KEEP(401) strategy (which
 C     may be switched off or on during solve)
       CALL MPI_BCAST( id%KEEP(401), 1, MPI_INTEGER, MASTER, id%COMM,
      &                  IERR )
+C     define ICNTL48_EFF on master
+      IF (id%MYID.EQ.MASTER) THEN
+        IF ( (id%KEEP(401).EQ.1). AND. (id%KEEP(400).GT.0) ) THEN
+          ICNTL48_EFF = 1
+        ELSE
+          ICNTL48_EFF = 0
+        ENDIF
+      ENDIF
       CALL MPI_BCAST(MTYPE,1,MPI_INTEGER,MASTER,
      &               id%COMM,IERR)
       CALL MPI_BCAST( id%KEEP(111), 1, MPI_INTEGER, MASTER, id%COMM,
      &                  IERR )
-      CALL MPI_BCAST( id%KEEP(221), 1, MPI_INTEGER, MASTER, id%COMM,
-     &                  IERR )
       CALL MPI_BCAST( id%KEEP(235), 1, MPI_INTEGER, MASTER, id%COMM,
      &                  IERR )
       CALL MPI_BCAST( id%KEEP(237), 1, MPI_INTEGER, MASTER, id%COMM,
      &                  IERR )
       CALL MPI_BCAST( id%KEEP(242), 2, MPI_INTEGER, MASTER, id%COMM,
      &                  IERR )
-      CALL MPI_BCAST( id%KEEP(248), 1, MPI_INTEGER, MASTER, id%COMM,
-     &                  IERR )
+C Allready done   CALL MPI_BCAST( id%KEEP(248), ...)
       CALL MPI_BCAST( id%KEEP(350), 1, MPI_INTEGER, MASTER, id%COMM,
      &                  IERR )
       CALL MPI_BCAST( id%KEEP(485), 1, MPI_INTEGER, MASTER, id%COMM,
@@ -700,7 +850,7 @@ C            Fwd in facto is not compati
              INFO(2) = 9
              IF (LPOK) THEN
                 WRITE(LP,'(A)')
-     &               ' ERROR: Transpose system (ICNTL(9).NE.0) not ',
+     &               ' ERROR: Transpose system (ICNTL(9).NE.1) not ',
      &               ' compatible with forward performed during',
      &               ' factorization (ICNTL(32)=1)'
              ENDIF
@@ -773,27 +923,30 @@ C            Sparse RHS may be due to A-
           ENDIF
 C         Entries of A-1 are stored in place of the input sparse RHS
 C         thus no need for RHS to be allocated.
-          IF ( (id%KEEP(237).EQ.0) ) THEN
+          IF (id%KEEP(237).EQ.0)  THEN
              IF ((id%KEEP(248) == 0 .AND.KEEP(221).NE.2)
-     &            .OR. ICNTL21==0) THEN
-C              RHS must be of size N on the master either to
+     &            .OR. 
+     &            (ICNTL21==0.AND.(KEEP(221).NE.1)) 
+     &          )THEN
+C              RHS must be of size N*NRHS on the master either to
 C              store the dense centralized RHS, either to store
 C              the dense centralized solution.
-               CALL CMUMPS_CHECK_DENSE_RHS
-     &         (id%RHS,id%INFO,id%N,id%NRHS,id%LRHS)
-               IF (id%INFO(1) .LT. 0) GOTO 333
+                CALL CMUMPS_CHECK_DENSE_RHS
+     &          (id%RHS,id%INFO,id%N,id%NRHS,id%LRHS)
+                IF (id%INFO(1) .LT. 0) GOTO 333
              ENDIF
           ELSE
-C           Check that the constraint NRHS=N is respected
+C           AM1: check that the constraint NRHS=N is respected
 C           Check for valid sparse RHS structure done
             IF (id%NRHS .NE. id%N) THEN
-              id%INFO(1)=-47
+              id%INFO(1)= -47
               id%INFO(2)=id%NRHS
               GOTO 333
             ENDIF
           ENDIF
-          IF (id%KEEP(248) == 1) THEN
-C           ------------------------------------
+          IF (id%KEEP(248) == 1
+     &       ) THEN
+C{          ------------------------------------
 C           RHS_SPARSE, IRHS_SPARSE and IRHS_PTR
 C           must be allocated of adequate size
 C           ------------------------------------
@@ -866,6 +1019,7 @@ C             Possible in case of duppli
               id%INFO(2)=10
               GOTO 333
             END IF
+C}
           ENDIF
 C         --------------------------------
 C         Set null space options for solve
@@ -879,16 +1033,20 @@ C
 C     --------------------------------------
 C     Check distributed solution vectors
 C     --------------------------------------
-      IF (ICNTL21==1) THEN
-          IF ( I_AM_SLAVE ) THEN
+      IF (ICNTL21 .NE. 0 ) THEN 
+          IF (I_AM_SLAVE) THEN
+            NSOL_loc = id%KEEP(89)
+          ELSE
+            NSOL_loc = 0
+          ENDIF
 C           (I)SOL_loc should be allocated to hold the
 C           distributed solution on exit
-            IF ( id%LSOL_loc < id%KEEP(89) ) THEN
+            IF ( id%LSOL_loc .LT. NSOL_loc ) THEN
               id%INFO(1)= -29
               id%INFO(2)= id%LSOL_loc
               GOTO 333
             ENDIF
-            IF (id%KEEP(89) .NE. 0) THEN
+            IF ( NSOL_loc .GT. 0 ) THEN
               IF ( .not. associated(id%ISOL_loc) )THEN
                 id%INFO(1)=-22
                 id%INFO(2)=13
@@ -899,7 +1057,7 @@ C           distributed solution on exit
                 id%INFO(2)=14
                 GOTO 333
               ENDIF
-              IF (size(id%ISOL_loc) < id%KEEP(89) ) THEN
+              IF (size(id%ISOL_loc) < NSOL_loc ) THEN
                 id%INFO(1)=-22
                 id%INFO(2)=13
                 GOTO 333
@@ -913,7 +1071,7 @@ C             can result in such a situa
 C             suppressed if needed but might be still be ok in case
 C             the right-hand side overflows too.
               IF (size(id%SOL_loc) <
-     &              (id%NRHS-1)*id%LSOL_loc+id%KEEP(89)) THEN
+     &              (id%NRHS-1)*id%LSOL_loc+NSOL_loc) THEN
                 id%INFO(1)=-22
                 id%INFO(2)=14
                 GOTO 333
@@ -921,17 +1079,17 @@ C             the right-hand side overfl
 #             else
               IF (size(id%SOL_loc,kind=8) <
      &              int(id%NRHS-1,8)*int(id%LSOL_loc,8)+
-     &              int(id%KEEP(89),8)) THEN
+     &              int(NSOL_loc,8)) THEN
                 id%INFO(1)=-22
                 id%INFO(2)=14
                 GOTO 333
               END IF
 #             endif
-            ENDIF
-          ENDIF
-      ENDIF
+            ENDIF ! NSOL_loc > 0
+      ENDIF ! ICNTL21 .NE. 0
       IF (id%MYID .NE. MASTER) THEN
-          IF (id%KEEP(248) == 1) THEN
+          IF (id%KEEP(248) == 1
+     &    ) THEN
 C          RHS should NOT be associated
 C          if I am not master since it is
 C          not even used to store the solution
@@ -957,16 +1115,6 @@ C          not even used to store the so
            END IF
           END IF
       ENDIF
-      IF (I_AM_SLAVE .AND. id%KEEP(248).EQ.-1) THEN
-        CALL CMUMPS_CHECK_DISTRHS(
-     &       id%Nloc_RHS,
-     &       id%LRHS_loc,
-     &       id%NRHS,
-     &       id%IRHS_loc,
-     &       id%RHS_loc,
-     &       id%INFO)
-        IF (id%INFO(1) .LT. 0) GOTO 333
-      ENDIF
 C     Prepare pointers to pass POINTERS(1) to
 C     routines with implicit interfaces which
 C     will then assume contiguous information
@@ -993,11 +1141,17 @@ C         so that IRHS_loc_PTR(1) is ok
       ELSE
         idRHS_loc=>CDUMMY_TARGET
       ENDIF
-      IF (I_AM_SLAVE .AND. ICNTL21.EQ.1 .AND.
-     &    KEEP(248) .EQ. -1) THEN  ! Dist RHS and dist solution
+C
+C
+C     Check as soon as solution is distributed
+      IF (I_AM_SLAVE .AND. ICNTL21.NE.0 .AND.
+     &    KEEP(248) .EQ. -1
+     &    ) THEN  ! Dist RHS and dist solution
+C
         IF (associated(id%RHS_loc) .AND.
      &      associated(id%SOL_loc)) THEN
-          IF (id%KEEP(89).GT.0) THEN
+C         NSOL_loc was defined earlier
+          IF (NSOL_loc.GT.0) THEN
 C           ----------------------------------------------------
 C           Check if RHS_loc and SOL_loc point to same object...
 C           id%SOL_loc(1) ok otherwise an error -22/14
@@ -1024,13 +1178,14 @@ C              we raise the error system
      &" ** Error RHS_loc and SOL_loc pointers match but LRHS_loc="
      &,id%LRHS_loc, " and LSOL_loc=", id%LSOL_loc
                ENDIF
+               GOTO 333
             ENDIF
           ENDIF
         ENDIF
       ENDIF
       IF (id%MYID.EQ.MASTER) THEN
-C         Do some checks (REDRHS), depending on KEEP(221)
-          CALL CMUMPS_CHECK_REDRHS(id)
+C         Do some checks on KEEP(221) and REDRHS (in case of Schur)
+          CALL CMUMPS_CHECK_K221andREDRHS(id)
       END IF ! MYID.EQ.MASTER
       IF (id%INFO(1) .LT. 0) GOTO 333
 C     -------------------------
@@ -1044,16 +1199,28 @@ C     -------------------------
 C     ====================================
 C     END CHECK INTERFACE AND KEEP ENTRIES
 C     ====================================
-C     ====================================
-C     Process case of NZ_RHS = 0  with
-C     sparse RHS and General Sparse (NOT A-1)
 C     -----------------------------------
       IF ((id%KEEP(248).EQ.1).AND.(id%KEEP(237).EQ.0)) THEN
-C
        CALL MPI_BCAST(id%NZ_RHS,1,MPI_INTEGER,MASTER,
      &               id%COMM,IERR)
+      ENDIF
 C
-       IF (id%NZ_RHS.EQ.0) THEN
+C     =======================================================
+C     BEGIN Test for empty RHS :
+C     sparse RHS and General Sparse (NOT A-1) and  NZ_RHS = 0
+C     OR
+C     Distributed RHS and sum of id%Nloc_RHS 
+C     (without off out-of-range) equal to 0
+C     =======================================================
+      IF 
+     & (
+     &     ( (id%KEEP(248).EQ.1).AND.(id%KEEP(237).EQ.0)
+     &       .AND. (id%NZ_RHS.EQ.0) ) 
+     &     .OR.
+     &     ( (id%KEEP(248).EQ.-1).AND. (SUM_idNloc_RHS_8.EQ.0_8)
+     &     ) 
+     & )  THEN
+C{      
 C       We reset solution to zero and we return
 C       (first freeing working space at label 90)
         IF ((ICNTL21.EQ.1).AND.(I_AM_SLAVE)) THEN
@@ -1073,38 +1240,46 @@ C         Note that LSOL_loc >= KEEP(89)
      &               id%KEEP(1),id%KEEP8(1),
      &               id%IS(1), LIW_PASSED,id%MYID_NODES,
      &               id%N, id%STEP(1), id%PROCNODE_STEPS(1),
-     &               id%NSLAVES, scaling_data_sol, LSCAL
+     &               id%NSLAVES,
+#if defined(USE_OLD_SCALING)
+     &               scaling_data_sol, .FALSE., ! empty RHS, no scaling
+#endif
 C                    For checking only
-     &               , .FALSE., IDUMMY(1), 1
+     &               .FALSE., IDUMMY(1), 1
      &               )
+          ENDIF
+        ENDIF
+C       Solution is null
+        IF (ICNTL21.NE.0) THEN  ! distributed solution
             DO J=1, id%NRHS
-              DO I=1, KEEP(89)
-                id%SOL_loc((J-1)*id%LSOL_loc + I) =ZERO
+C             (NSOL_loc=KEEP(89) or id%NSOL_loc, and in case
+C              ICNTL21=1, NSOL_loc is 0 on non-working host)
+              DO I=1, NSOL_loc
+                id%SOL_loc(int(J-1,8)*id%LSOL_loc + I) =ZERO
               ENDDO
             ENDDO
-          ENDIF
         ENDIF
-        IF (ICNTL21.NE.1) THEN  ! centralized solution
+        IF (ICNTL21.EQ.0) THEN  ! centralized solution
 C       ----------------------------
 C       RHS reset to zero on master
 C       ----------------------------
-         IF (id%MYID.EQ.MASTER) THEN
+          IF (id%MYID.EQ.MASTER) THEN
             DO J=1, id%NRHS
               DO I=1, id%N
                 id%RHS(int(J-1,8)*int(id%LRHS,8) + int(I,8)) =ZERO
               ENDDO
             ENDDO
-         ENDIF
+          ENDIF
         ENDIF
 C
 C       print solve phase stats if requested
         IF ( PROKG )  THEN
-C          write(6,*) " NZ_RHS is zero "
-           WRITE( MPG, 150 )
+            WRITE( MPG, 150 )
 C             ICNTL(35) should not been accessed during SOLVE thus
 C             print KEEP(486) value set during factorization
      &        id%NRHS, ICNTL(27), ICNTL(9), ICNTL(10), ICNTL(11),
-     &        ICNTL(20), ICNTL(21), ICNTL(30), KEEP(486)
+     &        ICNTL(20), ICNTL(21), ICNTL(30), KEEP(486), 
+     &        ICNTL48_EFF
            IF (KEEP(221).NE.0) THEN
             WRITE (MPG, 152) KEEP(221)
            ENDIF
@@ -1115,16 +1290,28 @@ C             print KEEP(486) value set
 C
 C       --------
         GOTO 90 ! end of solve deallocate what is needed
-C       ====================================
-C       END CHECK INTERFACE AND KEEP ENTRIES
-C       ====================================
-       ENDIF  ! test NZ_RHS.EQ.0
-C      --------
-      ENDIF ! (id%KEEP(248).EQ.1).AND.(id%KEEP(237).EQ.0)
+C}
+      ENDIF  ! test empty RHS (general sparse or Distributed)
+C     =======================================================
+C     END of Test for empty RHS :
+C     =======================================================
+C     ====================================
+C     END CHECK INTERFACE AND KEEP ENTRIES
+C     ====================================
       INTERLEAVE_PAR   =.FALSE.
       DO_PERMUTE_RHS   =.FALSE.
+      CALL_NODES_FWD_BWD       = .FALSE.
+      FIRST_CALL_NODES_FWD_BWD = .FALSE.
+C     Default is no sparsity exploited
+      nodes_FWD_PTR => IDUMMY_TARGET
+      nodes_BWD_PTR => IDUMMY_TARGET
+      Lnodes_FWD = -1
+      Lnodes_BWD = -1
 C
-      IF ((id%KEEP(235).NE.0).or.(id%KEEP(237).NE.0)) THEN
+      IF ((id%KEEP(235).NE.0).or.(id%KEEP(237).NE.0) 
+     &   ) THEN
+         CALL_NODES_FWD_BWD       = .TRUE.
+         FIRST_CALL_NODES_FWD_BWD = .TRUE.
 C        Case of pruned elimination tree or selected entries in A-1
          IF (id%KEEP(237).NE.0.AND.
      &        id%KEEP(248).EQ.0) THEN
@@ -1137,7 +1324,8 @@ C         sparse RHS has been forced to
           ENDIF
           CALL MUMPS_ABORT()
          ENDIF
-C        NBT is inout in MUMPS_REALLOC and should be initialized.
+C        NBT (in Bytes) is inout in MUMPS_REALLOC and 
+C                       should be initialized.
          NBT = 0
 C        -- Allocate Step2node on each proc
          CALL MUMPS_REALLOC(id%Step2node, id%KEEP(28), id%INFO, LP,
@@ -1161,26 +1349,37 @@ C          we reuse Step2node computed i
 C          Step2node is deallocated each time a new analysis is
 C          performed or when job=-2 is called
          ENDIF
-         NB_BYTES = NB_BYTES + NBT*K34_8
+C        --- NBT is the nb of extra bytes allocated
+         NB_BYTES = NB_BYTES + NBT
          NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
-         NB_BYTES_EXTRA = NB_BYTES_EXTRA + NBT * K34_8
+         NB_BYTES_EXTRA = NB_BYTES_EXTRA + NBT 
 C        Mapping information used during solve. In case of several
 C        facto+solve it has to be recomputed.
 C        In case of several solves with the same
 C        facto, it is not recomputed.
-C        It used to compute the interleaving
+C        It is used to compute the interleaving
 C        for A-1, and, in dev_version, passed to sol_c to compute
 C        some stats
          IF((KEEP(235).NE.0).OR.(KEEP(237).NE.0)) THEN
            IF(.NOT.associated(id%IPTR_WORKING)) THEN
              CALL CMUMPS_BUILD_MAPPING_INFO(id)
            END IF
+           idIPTR_WORKING => id%IPTR_WORKING
+           idWORKING => id%WORKING
+         ELSE 
+C           case of selected entries in solution
+C           with no ES during fwd
+            SIZE_WORKING = 1
+            SIZE_IPTR_WORKING = 1
+            idIPTR_WORKING => IDUMMY_TARGET
+            idWORKING => IDUMMY_TARGET
          END IF
       ENDIF
 C
 C     Initialize SIZE_OF_BLOCK from MUMPS_SOL_ES module
-      IF ( I_AM_SLAVE )
-     &  CALL CMUMPS_SOL_ES_INIT(id%OOC_SIZE_OF_BLOCK, id%KEEP(201))
+      IF ( I_AM_SLAVE ) THEN
+        CALL CMUMPS_SOL_ES_INIT(id%OOC_SIZE_OF_BLOCK, id%KEEP(201))
+      ENDIF
       DO_NULL_PIV = .TRUE.
       NBCOL_INBLOC = -9998
       NZ_THIS_BLOCK= -9998
@@ -1188,7 +1387,7 @@ C     Initialize SIZE_OF_BLOCK from MUMP
 c
       IF (id%MYID.EQ.MASTER) THEN ! Compute NRHS_NONEMPTY
 C
-C       -- Sparse RHS does
+C       -- Sparse RHS (general, centralized)
         IF ( KEEP(111)==0 .AND. KEEP(248)==1
      &   ) THEN
 C       -- Note that KEEP(111).NE.0 (null space on)
@@ -1196,8 +1395,9 @@ C       -- and KEEP(248).NE.0 will be ma
 C       -- When computing entries of A-1 (or SparseRHS only)
            NRHS_NONEMPTY = 0
            DO I=1, id%NRHS
-              IF (id%IRHS_PTR(I).LT.id%IRHS_PTR(I+1))
-     &             NRHS_NONEMPTY = NRHS_NONEMPTY+1 !ith col in non empty
+              IF (id%IRHS_PTR(I).LT.id%IRHS_PTR(I+1)) THEN
+                   NRHS_NONEMPTY = NRHS_NONEMPTY+1 !ith col in non empty
+              ENDIF
            ENDDO
            IF (NRHS_NONEMPTY.LE.0) THEN
 C           Internal error: tested before in mumps_driver
@@ -1247,6 +1447,7 @@ C     We work on a maximum of NBRHS at a
 C     The leading dimension of RHS is id%LRHS on the host process
 C     and it is set to N on slave processes.
       IF (id%MYID .eq. MASTER) THEN
+C{
         KEEP(84) = ICNTL(27)
 C     Treating ICNTL(27)=0 as if ICNTL(27)=1
         IF(ICNTL(27).EQ.0) KEEP(84)=1
@@ -1262,11 +1463,12 @@ C     Treating ICNTL(27)=0 as if ICNTL(2
           IF (NBRHS .GT. NRHS_NONEMPTY ) NBRHS = NRHS_NONEMPTY
 C
         ENDIF
+C}
       ENDIF
 #if defined(V_T)
       CALL VTBEGIN(glob_comm_ini,IERR)
 #endif
-C     NRHS_NONEMPTY needed on all procs to allocate RHSCOMP on slaves
+C     NRHS_NONEMPTY needed on all procs to allocate RHSINTR on slaves
       CALL MPI_BCAST(NRHS_NONEMPTY,1,MPI_INTEGER,MASTER,
      &               id%COMM,IERR)
       CALL MPI_BCAST(NBRHS,1,MPI_INTEGER,MASTER,
@@ -1342,7 +1544,11 @@ C
             ENDIF
           END IF
         ENDIF
-        LWCB8_MIN = int(NB_K133,8)*int(KEEP(133),8)*int(NBRHS,8)
+CPA2ALL: int(min(NRHS_NONEMPTY,NBRHS),8) instead of NBRHS
+C       LWCB8_MIN = int(NB_K133,8)*int(KEEP(133),8)*int(NBRHS,8)
+        LWCB8_MIN = int(NB_K133,8)*int(KEEP(133),8)*
+     &        int(min(NRHS_NONEMPTY,NBRHS),8)
+C
 C
 C       ---------------------------------------------------------------
 C       Set WK_USER_PROVIDED to true when workspace WK_USER is provided
@@ -1537,12 +1743,14 @@ C         Access to OOC data in module d
         ENDIF
       ENDIF
       IF (id%MYID.EQ.MASTER) THEN
+C{
         IF ( PROKG )  THEN
           WRITE( MPG, 150 )
 C             ICNTL(35) should not been accessed during SOLVE thus
 C             print KEEP(486) value set during factorization
      &        id%NRHS, NBRHS, ICNTL(9), ICNTL(10), ICNTL(11),
-     &        ICNTL(20), ICNTL(21), ICNTL(30), KEEP(486)
+     &        ICNTL(20), ICNTL(21), ICNTL(30), KEEP(486),
+     &        ICNTL48_EFF
           IF (KEEP(111).NE.0) THEN
             WRITE (MPG, 151) KEEP(111)
           ENDIF
@@ -1553,11 +1761,9 @@ C             print KEEP(486) value set
             WRITE (MPG, 153) KEEP(252)
           ENDIF
         ENDIF
-C
 C     ====================================
 C       Define LSCAL, ICNTL10 and ICNTL11
 C     ====================================
-C
         LSCAL = (((KEEP(52) .GT. 0) .AND. (KEEP(52) .LE. 8)) .OR. (
      &    KEEP(52) .EQ. -1) .OR. KEEP(52) .EQ. -2)
         ICNTL10 = ICNTL(10)
@@ -1568,71 +1774,10 @@ C       Values of ICNTL(11) out of range
            IF (PROKG) WRITE(MPG,'(A)')
      &    ' WARNING: ICNTL(11) out of range'
         ENDIF
-        POSTPros = .FALSE.
-        IF (ICNTL11.NE.0 .OR. ICNTL10.NE.0) THEN
-          POSTPros = .TRUE.
-C       FORBID ERROR ANALYSIS AND ITERATIVE REFINEMENT
-C       if there are options that are not compatible
-          IF (KEEP(111).NE.0) THEN
-C       IF WE RETURN A NULL SPACE BASIS or compute entries in A-1
-C        of Fwd in facto
-C       -When only one columns of A-1 is requested then
-C        we could try to reactivate IR even if
-C          -code need be updated
-C          -accuracy could be # when one or more columns are requested
-              IF (PROKG) WRITE(MPG,'(A,A)')
-     &       ' WARNING: Incompatible features: null space basis ',
-     &                ' and Iter. Ref and/or Err. Anal.'
-              POSTPros = .FALSE.
-           ELSE IF ( KEEP(237) .NE.0 ) THEN
-              IF (PROKG) WRITE(MPG,'(A,A)')
-     &       ' WARNING: Incompatible features: AM1',
-     &                ' and Iter. Ref and/or Err. Anal.'
-              POSTPros = .FALSE.
-           ELSE IF ( KEEP(252) .NE.0 ) THEN
-              IF (PROKG) WRITE(MPG,'(A,A)')
-     &       ' WARNING: Incompatible features: Fwd in facto ',
-     &                ' and Iter. Ref and/or Err. Anal.'
-              POSTPros = .FALSE.
-           ELSE IF (KEEP(221).NE.0) THEN
-C       Forbid error analysis and iterative refinement
-C       in case of reduced rhs/solution
-              IF (PROKG) WRITE(MPG,'(A,A)')
-     &       ' WARNING: Incompatible features: reduced RHS ',
-     &       '          and Iter. Ref and/or Err. Anal.'
-              POSTPros = .FALSE.
-            ELSE IF  (NBRHS.GT. 1 .OR. ICNTL(21) .GT. 0) THEN
-C          Forbid error analysis and iterative refinement if
-C       the solution is distributed or
-C       in the case where nrhs > 1
-              IF (PROKG) WRITE(MPG,'(A,A)')
-     &       ' WARNING:  Incompatible features: nrhs>1 or distrib sol',
-     &       '           and Iter. Ref and/or Err. Anal.'
-              POSTPros = .FALSE.
-            ELSE IF ( KEEP(248) .EQ. -1 ) THEN
-C          Forbid error analysis and iterative refinement
-C          in case of distributed RHS
-              IF (PROKG) WRITE(MPG,'(A,A)')
-     &       ' WARNING:  Incompatible features: distrib rhs',
-     &       '           and Iter. Ref and/or Err. Anal.'
-              POSTPros = .FALSE.
-            ENDIF  
-            IF (.NOT.POSTPros) THEN
-              ICNTL11 = 0
-              ICNTL10 = 0
-            ENDIF
-        ENDIF
-C   Write a warning.
-        IF ((ICNTL(10) .NE. 0) .AND. (ICNTL10 .EQ. 0)) THEN
-            IF (PROKG) WRITE(MPG,'(A)')
-     &    ' WARNING: ICNTL(10) treated as if set to 0 '
-        ENDIF
-        IF ((ICNTL(11) .NE. 0)
-     &        .AND.(ICNTL11 .EQ. 0)) THEN
-            IF (PROKG) WRITE(MPG,'(A)')
-     &    ' WARNING: ICNTL(11) treated as if set to 0 '
-        ENDIF
-C     -- end of test master
+        CALL CMUMPS_SET_POSTPros (
+     &                      KEEP(1), ICNTL(1), NBRHS, MPG, PROKG,
+     &                      ICNTL10, ICNTL11, POSTPros)
+C}    -- end of test master
       END IF
       CALL MPI_BCAST(POSTPros,1,MPI_LOGICAL,MASTER,
      &               id%COMM,IERR)
@@ -1687,28 +1832,29 @@ C        allocated, otherwise MAT_ALLOC_
       CALL MPI_REDUCE( MAT_ALLOC_LOC, MAT_ALLOC, 1,
      &                 MPI_INTEGER,
      &                 MPI_MIN, MASTER, id%COMM, IERR)
-      IF ( id%MYID .eq. MASTER ) THEN
+      IF ( POSTPros.and.(id%MYID .eq. MASTER) ) THEN
+C       if postprocessing requested matrix must be allocated
         IF (MAT_ALLOC.EQ.0) THEN
-            IF (KEEP(54).NE.0) THEN
+           IF (KEEP(54).NE.0) THEN
 C           Write on MPG this time (we wrote on MP before in
 C           case of distributed matrix and wrote on MPG already
 C           in case of centralized matrix)
             IF (PROKG) WRITE(MPG,'(A)')
      &      ' WARNING: original distributed matrix is not allocated'
-             ENDIF
-              POSTPros = .FALSE.
-              ICNTL11 = 0
-              ICNTL10 = 0
+           ENDIF
+           POSTPros = .FALSE.
+           ICNTL11 = 0
+           ICNTL10 = 0
 C   Write a warning.
            IF ((ICNTL(10) .NE. 0) .AND. (ICNTL10 .EQ. 0)) THEN
             IF (PROKG) WRITE(MPG,'(A)')
-     &    ' WARNING: ICNTL(10) treated as if set to 0'
+     &      ' WARNING: ICNTL(10) treated as if set to 0'
            ENDIF
            IF ((ICNTL(11) .EQ. 1).OR.(ICNTL(11) .EQ. 2) 
      &        .AND.(ICNTL11 .EQ. 0)) THEN
             IF (PROKG) WRITE(MPG,'(A)')
-     &    ' WARNING: ICNTL(11) treated as if set to 0 '
-          ENDIF
+     &      ' WARNING: ICNTL(11) treated as if set to 0 '
+           ENDIF
         ENDIF
         IF (POSTPros) THEN
             ALLOCATE(SAVERHS(id%N*NBRHS),stat = allocok)
@@ -1748,14 +1894,44 @@ C     ----------------------------------
      &               id%COMM,IERR)
       CALL MPI_BCAST(ICNTL11,1,MPI_INTEGER,MASTER,
      &               id%COMM,IERR)
-      CALL MPI_BCAST(ICNTL21,1,MPI_INTEGER,MASTER,
-     &               id%COMM,IERR)
       CALL MPI_BCAST(POSTPros,1,MPI_LOGICAL,MASTER,
      &               id%COMM,IERR)
       CALL MPI_BCAST(LSCAL,1,MPI_LOGICAL,MASTER,
      &               id%COMM,IERR)
       CALL MPI_BCAST(KEEP(237),1,MPI_INTEGER,MASTER,
      &               id%COMM,IERR)
+#if ! defined(USE_OLD_SCALING)
+C     ----------------------------------------------
+C     Initialize SCALING_LOC_FWD and SCALING_LOC_BWD
+C     They corespond to all pivots factorized on a
+C     given MPI process and point to a dummy array
+C     of size 1 on the host of if no pivot was
+C     factorized (KEEP(89))=0
+C     ----------------------------------------------
+      IF (LSCAL .AND. id%KEEP(89) .GT. 0) THEN
+          IF (MTYPE .EQ. 1) THEN
+            SCALING_LOC_FWD => id%ROWSCA_loc
+            SCALING_LOC_BWD => id%COLSCA_loc
+          ELSE
+            SCALING_LOC_FWD => id%COLSCA_loc
+            SCALING_LOC_BWD => id%ROWSCA_loc
+          ENDIF
+      ELSE ! includes non working master on which KEEP(89)=0
+          SCALING_LOC_FWD => RDUMMY_TARGET
+          SCALING_LOC_BWD => RDUMMY_TARGET
+      ENDIF
+C     Remarks related to scalings:
+C     * During postprocessing, one performs solves
+C       with alternatively A and A^T, meaning that
+C       SCALING_LOC_FWD and SCALING_LOC_BWD will
+C       be redefined.
+C     * In case of exploit sparsity, RHSINTR may
+C       have less rows than ROWSCA_loc/COLSCA_loc.
+C       SCALING_RHSINTR_FWD and SCALING_RHSINTR_BWD
+C       will then be extracted from
+C       SCALING_LOC_FWD and SCALING_LOC_BWD thanks
+C       to the subroutine CMUMPS_SCALINGRHSINTR
+#endif
 C     KEEP(248)==1 if not_NullSpace (KEEP(111)=0)
 C           and sparse RHS on input (id%ICNTL(20)/KEEP(248)==1)
 C     (KEEP(248)==1 implies KEEP(111) = 0, otherwise error was raised)
@@ -1965,81 +2141,85 @@ c         --- ALLOCATE outside loop RHS_
 C     --------------------------------------------------
       IF ( I_AM_SLAVE ) THEN
         IF ((KEEP(221).EQ.2 .AND. KEEP(252).EQ.0)) THEN
-C          -- RHSCOMP must have been allocated in
+C          -- RHSINTR must have been allocated in
 C          -- previous solve step (with option KEEP(221)=1)
-           IF (.NOT.associated(id%RHSCOMP)) THEN
+           IF (.NOT.associated(id%RHSINTR)) THEN
              INFO(1) = -35
              INFO(2) = 1
              GOTO 111
            ENDIF
 C          IF ((KEEP(248).EQ.0) .OR. (id%NRHS.EQ.1)) THEN
-C          POSINRHSCOMP_ROW/COL are meaningful and could even be reused
-           IF (.NOT.associated(id%POSINRHSCOMP_ROW) ) ! .OR.
-!    &        .NOT.(id%POSINRHSCOMP_COL_ALLOC))
+C          GLOB2LOC_RHS/SOL are meaningful and could even be reused
+           IF (.NOT.associated(id%GLOB2LOC_RHS) ) ! .OR.
+!    &        .NOT.(id%GLOB2LOC_SOL_ALLOC))
      &     THEN
              INFO(1) = -35
              INFO(2) = 2
              GOTO 111
            ENDIF
-           IF (.not.id%POSINRHSCOMP_COL_ALLOC) THEN
-C             POSINRHSCOMP_COL that is kept from
+           IF (.not.id%GLOB2LOC_SOL_ALLOC) THEN
+C             GLOB2LOC_SOL that is kept from
 C             previous call to solve must then (already)
-C             point to id%POSINRHSCOMP_ROW
-              id%POSINRHSCOMP_COL => id%POSINRHSCOMP_ROW
+C             point to id%GLOB2LOC_RHS
+              id%GLOB2LOC_SOL => id%GLOB2LOC_RHS
            ENDIF
         ELSE
 C         ----------------------
-C         Allocate POSINRHSCOMP_ROW/COL
+C         Allocate GLOB2LOC_RHS/SOL
 C         ----------------------
-C         The size of POSINRHSCOMP arrays
+C         The size of POSINRHSINTR arrays
 C         does not depend on the block of RHS
-C         POSINRHSCOMP_ROW/COL are initialized in the loop of RHS
-          IF (associated(id%POSINRHSCOMP_ROW)) THEN
+C         GLOB2LOC_RHS/SOL are initialized in the loop of RHS
+          IF (associated(id%GLOB2LOC_RHS)) THEN
             NB_BYTES = NB_BYTES -
-     &          int(size(id%POSINRHSCOMP_ROW),8)*K34_8
-            DEALLOCATE(id%POSINRHSCOMP_ROW)
+     &          int(size(id%GLOB2LOC_RHS),8)*K34_8
+            DEALLOCATE(id%GLOB2LOC_RHS)
           ENDIF
-          ALLOCATE (id%POSINRHSCOMP_ROW(id%N), stat = allocok)
+          ALLOCATE (id%GLOB2LOC_RHS(id%N), stat = allocok)
           IF ( allocok .GT. 0 ) THEN
              INFO(1)=-13
              INFO(2)=id%N
              GOTO 111
           END IF
           NB_BYTES = NB_BYTES +
-     &          int(size(id%POSINRHSCOMP_ROW),8)*K34_8
+     &          int(size(id%GLOB2LOC_RHS),8)*K34_8
           NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
-          IF (id%POSINRHSCOMP_COL_ALLOC) THEN
+          IF (id%GLOB2LOC_SOL_ALLOC) THEN
             NB_BYTES = NB_BYTES -
-     &          int(size(id%POSINRHSCOMP_COL),8)*K34_8
-            DEALLOCATE(id%POSINRHSCOMP_COL)
-            NULLIFY(id%POSINRHSCOMP_COL)
-            id%POSINRHSCOMP_COL_ALLOC = .FALSE.
+     &          int(size(id%GLOB2LOC_SOL),8)*K34_8
+            DEALLOCATE(id%GLOB2LOC_SOL)
+            NULLIFY(id%GLOB2LOC_SOL)
+            id%GLOB2LOC_SOL_ALLOC = .FALSE.
           ENDIF
 C
-          IF ((KEEP(50).EQ.0).OR.KEEP(237).NE.0) THEN
-           ALLOCATE (id%POSINRHSCOMP_COL(id%N), stat = allocok)
+          IF ( (KEEP(50).EQ.0).OR.(KEEP(237).NE.0).OR.
+     &         (KEEP(212).NE.0)
+     &       ) THEN
+           ALLOCATE (id%GLOB2LOC_SOL(id%N), stat = allocok)
            IF ( allocok .GT. 0 ) THEN
              INFO(1)=-13
              INFO(2)=id%N
              GOTO 111
            END IF
-           id%POSINRHSCOMP_COL_ALLOC = .TRUE.
+           id%GLOB2LOC_SOL_ALLOC = .TRUE.
            NB_BYTES = NB_BYTES +
-     &          int(size(id%POSINRHSCOMP_COL),8)*K34_8
+     &          int(size(id%GLOB2LOC_SOL),8)*K34_8
            NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
           ELSE
-C          Do no allocate POSINRHSCOMP_COL
-           id%POSINRHSCOMP_COL => id%POSINRHSCOMP_ROW
-           id%POSINRHSCOMP_COL_ALLOC = .FALSE.
+C          Do no allocate GLOB2LOC_SOL
+           id%GLOB2LOC_SOL => id%GLOB2LOC_RHS
+           id%GLOB2LOC_SOL_ALLOC = .FALSE.
           ENDIF
           IF (KEEP(221).NE.2) THEN
-C         -- only in the case of bwd after reduced RHS
-C         -- we have to keep "old" RHSCOMP
-            IF (associated(id%RHSCOMP)) THEN
+C         -- only in the case of bwd after 
+C         -- fwd only (with or without Schur)
+C         -- we have to keep "old" RHSINTR
+            IF (associated(id%RHSINTR)) THEN
              NB_BYTES = NB_BYTES - id%KEEP8(25)*K35_8
-             DEALLOCATE(id%RHSCOMP)
-             NULLIFY(id%RHSCOMP)
-             id%KEEP8(25)=0_8
+             DEALLOCATE(id%RHSINTR)
+             NULLIFY(id%RHSINTR)
+             id%KEEP8(25)  = 0_8
+             id%LD_RHSINTR = 0
             ENDIF
           ENDIF
         ENDIF
@@ -2138,16 +2318,22 @@ C          migrated outside the blocking
             UNS_PERM_INV_NEEDED_INMAINLOOP = .TRUE.
       ENDIF
       UNS_PERM_INV_NEEDED_BEFMAINLOOP = .FALSE.
+      IF (KEEP(23) .GT. 0 .AND. MTYPE.EQ.1 .AND. ICNTL21.EQ.2) THEN
+           UNS_PERM_INV_NEEDED_INMAINLOOP = .TRUE.
+      ENDIF
       IF ( KEEP(23) .GT.0 .AND.
      &            MTYPE .NE. 1 .AND. KEEP(248).EQ.-1 ) THEN
 C          Similar to sparse RHS case, we need to modify IRHS_loc
 C          indices in the distributed RHS case. However, we need
-C          UNS_PERM_INV on all processors. But only before theC
+C          UNS_PERM_INV on all processors. But only before the
 C          main loop on the RHS blocks.
            UNS_PERM_INV_NEEDED_BEFMAINLOOP = .TRUE.
       ENDIF
+C
+      UNS_PERM_INV_NEEDED_ONSLAVES = .FALSE.
       IF ( UNS_PERM_INV_NEEDED_INMAINLOOP .OR.
      &     UNS_PERM_INV_NEEDED_BEFMAINLOOP ) THEN
+C          We need UNS_PERM_INV
            ALLOCATE(UNS_PERM_INV(id%N),stat=allocok)
            if (allocok .GT.0 ) THEN
              INFO(1)=-13
@@ -2188,8 +2374,14 @@ C     Propagate errors
 C
 C     UNS_PERM_INV needed on slaves:
       IF ( KEEP(23).NE.0 .AND.
-     &     ( KEEP(237).NE.0 .OR.
-     &     ( MTYPE.NE.1 .AND. KEEP(248).EQ.-1 ) ) ) THEN
+     &     (  KEEP(237).NE.0 .OR.
+     &        ( MTYPE.NE.1 .AND. KEEP(248).EQ.-1 ) .OR.
+     &        ( MTYPE.EQ.1 .AND. ICNTL21.EQ.2)
+     &     ) 
+     &   ) THEN
+        UNS_PERM_INV_NEEDED_ONSLAVES = .TRUE.
+      ENDIF
+      IF (UNS_PERM_INV_NEEDED_ONSLAVES) THEN
 C       Broadcast UNS_PERM_INV
         CALL MPI_BCAST( UNS_PERM_INV,id%N,MPI_INTEGER,MASTER,
      &                  id%COMM,IERR )
@@ -2198,7 +2390,8 @@ C     -------------------------------
 C     BEGIN
 C     Preparation for distributed RHS
 C     -------------------------------
-      IF (I_AM_SLAVE .AND. KEEP(248).EQ.-1) THEN
+      IF (I_AM_SLAVE .AND. KEEP(248).EQ.-1
+     & ) THEN
 C       Distributed RHS case
         ALLOCATE(MAP_RHS_loc(max(id%Nloc_RHS,1)), stat=allocok)
         IF (allocok .GT. 0) THEN
@@ -2208,10 +2401,10 @@ C       Distributed RHS case
         ENDIF
         NB_BYTES = NB_BYTES + max(int(id%Nloc_RHS,8),1_8)*K34_8
       ENDIF
-C     MAP_RHS_loc will be built in the main
-C     loop, when processing the first block.
-C     It requires POSINRHSCOMP to be built.
-      BUILD_RHSMAPINFO = .TRUE.
+C      MAP_RHS_loc will be built in the main
+C      loop, when processing the first block.
+C      It requires POSINRHSINTR to be built.
+       BUILD_RHSMAPINFO = .TRUE.
  20   CONTINUE
       CALL MUMPS_PROPINFO( ICNTL(1), INFO(1),
      &                         id%COMM,id%MYID)
@@ -2221,7 +2414,8 @@ C     transpose system, use MUMPS intern
 C     for IRHS_loc_PTR. Done before scaling since
 C     scaling is on permuted matrix
       IF ( I_AM_SLAVE .AND. KEEP(23).GT.0 .AND. KEEP(248).EQ.-1
-     &     .AND. MTYPE.NE.1 ) THEN
+     &     .AND. MTYPE.NE.1 
+     &   ) THEN
           IF (id%Nloc_RHS .GT. 0) THEN
             ALLOCATE(IRHS_loc_PTR(id%Nloc_RHS),stat=allocok)
             IF (allocok.GT.0) THEN
@@ -2252,7 +2446,9 @@ C     to free memory
         ALLOCATE(UNS_PERM_INV(1))  ! to posibly pass it as an argument
         NB_BYTES = NB_BYTES + K34_8
       ENDIF
-      IF (LSCAL .AND. id%KEEP(248).EQ.-1) THEN
+#if defined(USE_OLD_SCALING)
+      IF (LSCAL .AND. id%KEEP(248).EQ.-1
+     &   ) THEN
 C       Scaling done based on original indices
 C       provided by user
         IF (MTYPE == 1) THEN
@@ -2268,6 +2464,7 @@ C         Transpose
      &       NB_BYTES, NB_BYTES_MAX, K16_8, LP, LPOK,
      &       ICNTL(1), INFO(1) )
       ENDIF
+#endif
 C     -------------------------------
 C     END
 C     Preparation for distributed RHS
@@ -2280,9 +2477,11 @@ C     ----------------------------------
 C     BEGIN
 C     Preparation for distributed solution
 C     -------------------------------------
-      IF ( ICNTL21==1 ) THEN
+      IF ( ICNTL21 .NE. 0 ) THEN
+C{
+#if defined(USE_OLD_SCALING)
         IF (LSCAL) THEN
-C         In case of scaling we will need to scale
+C{        In case of scaling we will need to scale
 C         back the sol. Put the values of the scaling
 C         arrays needed to do that on each processor.
           IF (id%MYID.NE.MASTER) THEN
@@ -2306,17 +2505,20 @@ C         arrays needed to do that on ea
      &                         id%COMM,id%MYID)
           IF (INFO(1) .LT.0 ) GOTO 90
           IF (I_AM_SLAVE) THEN
-            ALLOCATE(scaling_data_sol%SCALING_LOC(id%KEEP(89)),
-     &               stat=allocok)
+              ALLOCATE(scaling_data_sol%SCALING_LOC(max(1,id%KEEP(89))),
+     &                 stat=allocok)
             IF (allocok > 0) THEN
               IF (LPOK) THEN
                 WRITE(LP,*) 'Error allocating local scaling array'
               ENDIF
               INFO(1)=-13
-              INFO(2)=id%KEEP(89)
+              INFO(2)=max(1,id%KEEP(89))
               GOTO 38
             ENDIF
-            NB_BYTES = NB_BYTES + int(id%KEEP(89),8)*K16_8
+            IF (ICNTL21.NE.0) THEN
+C            Real entries for scaling
+             NB_BYTES = NB_BYTES + int(max(1,id%KEEP(89)),8)*K16_8
+            ENDIF
             NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
           ENDIF ! I_AM_SLAVE
  38       CONTINUE
@@ -2336,11 +2538,17 @@ C         arrays needed to do that on ea
      &                       id%COMM,IERR)
               scaling_data_sol%SCALING=>id%ROWSCA
           ENDIF
+C}
         ENDIF ! LSCAL
-        IF ( I_AM_SLAVE ) THEN
-C         ----------------------
+#endif
+        IF ( ICNTL21.EQ.1 .AND. I_AM_SLAVE 
+     &     ) THEN
+C         --------------------------------
 C         Prepare ISOL_loc array
-C         ----------------------
+#if defined(USE_OLD_SCALING)
+C         and on the fly, scaling_data_sol
+#endif
+C         --------------------------------
           LIW_PASSED=max(1,LIW)
 C         Only called if more than 1 pivot
 C         was eliminated by the processor.
@@ -2351,12 +2559,19 @@ C         Note that LSOL_loc >= KEEP(89)
      &               id%KEEP(1),id%KEEP8(1),
      &               id%IS(1), LIW_PASSED,id%MYID_NODES,
      &               id%N, id%STEP(1), id%PROCNODE_STEPS(1),
-     &               id%NSLAVES, scaling_data_sol, LSCAL
+     &               id%NSLAVES,
+#if defined(USE_OLD_SCALING)
+     &               scaling_data_sol, LSCAL,
+#endif
 C                    For checking only
-     &               , (KEEP(248).EQ.-1), IRHS_loc_PTR(1), id%Nloc_RHS
+     &               (KEEP(248).EQ.-1), IRHS_loc_PTR(1), id%Nloc_RHS
      &               )
           ENDIF 
-          IF (id%MYID.NE.MASTER .AND. LSCAL) THEN
+        ENDIF ! I_AM_SLAVE
+#if defined(USE_OLD_SCALING)
+#endif
+#if defined(USE_OLD_SCALING)
+        IF (id%MYID.NE.MASTER .AND. LSCAL) THEN
 C           ---------------------------------
 C           Local (small) scaling arrays have
 C           been built, free temporary copies
@@ -2369,8 +2584,15 @@ C           ----------------------------
               NULLIFY(id%ROWSCA)
             ENDIF
             NB_BYTES = NB_BYTES - int(id%N,8)*K16_8
-          ENDIF
-        ENDIF ! I_AM_SLAVE
+        ENDIF
+#endif
+C}
+      ENDIF ! ICNTL21 .NE. 0
+      IF (ICNTL21 .EQ.1) THEN
+C       ---------------------------------------------------
+C       Take into account unsymmetric permutation to modify
+C       ISOL_loc, in case ISOL_loc is provided by MUMPS
+C       ---------------------------------------------------
         IF (KEEP(23) .NE. 0 .AND. MTYPE==1) THEN
 C         Broadcast the unsymmetric permutation and
 C         permute the indices in ISOL_loc
@@ -2409,11 +2631,14 @@ C     ----------------------------------
 C     Preparation for distributed solution
 C     END
 C     --------------------------------------
-C     ----------------------------
-C     Preparation for reduced RHS
-C     ----------------------------
-      IF ( ( KEEP(221) .EQ. 1 ) .OR.
+C     ---------------------------------------------
+C     In case of Schur, preparation for reduced RHS
+C     ---------------------------------------------
+      IF ( (KEEP(60).NE.0) .AND. 
+     &    (
+     &     ( KEEP(221) .EQ. 1 ) .OR.
      &     ( KEEP(221) .EQ. 2 )
+     &    )
      &   ) THEN
 C       -- First compute MASTER_ROOT_IN_COMM proc number in
 C          COMM_NODES on which is mapped the master of the root.
@@ -2452,7 +2677,8 @@ C          -- other procs not concerned
          ENDIF
       ENDIF
 C
-      IF ( KEEP(248)==1 ) THEN  ! Sparse RHS (A-1 or general sparse)
+      IF ( KEEP(248)==1 
+     &   ) THEN  ! Sparse RHS (A-1 or general sparse)
 !        JBEG_RHS - current starting column within A-1 or sparse rhs
 !                      set in the loop below and used to obtain the
 !                      global index of the column of the sparse RHS
@@ -2539,9 +2765,9 @@ C     Propagate errors
 c --------------------------
 c --------------------------
       IF (id%NSLAVES .EQ. 1) THEN
-c     - In case of NS/A-1 we may want to permute RHS
-c     - for NS thus is to apply permutation to PIVNUL_LIST
-*     - before starting loop of NBRHS
+C{    - In case of NS/A-1 we may want to permute RHS
+C     - for NS thus is to apply permutation to PIVNUL_LIST
+C     - before starting loop of NBRHS
        IF (DO_PERMUTE_RHS .AND. KEEP(111).NE.0 ) THEN
 C     NOTE:
 C        when host not working both master and slaves have
@@ -2551,6 +2777,7 @@ C        in this case the complete list
      &                 ' not available yet '
             CALL MUMPS_ABORT()
        ENDIF                     ! End Permute_RHS
+C}
       ELSE
          IF (DO_PERMUTE_RHS .AND. KEEP(111).NE.0 ) THEN
             WRITE(*,*) id%MYID, ':INTERNAL ERROR 2 : ',
@@ -2558,7 +2785,6 @@ C        in this case the complete list
      &                 ' not available yet '
             CALL MUMPS_ABORT()
 C
-C
          ENDIF                  !  End DO_PERMUTE_RHS
          IF (INTERLEAVE_PAR.AND. (KEEP(111).NE.0)) THEN
             WRITE(*,*) id%MYID, ':INTERNAL ERROR 3 : ',
@@ -2601,15 +2827,15 @@ C          to permute the null column pi
      &            MPI_INTEGER,
      &            MASTER, id%COMM,IERR)
       ENDIF
-C   L0-threads to be activated iff KEEP(401)>0 and KEEP(400)>0
-          IF (KEEP(401) .GT. 0) THEN
+C   L0-threads to be activated iff KEEP(401)=1 and KEEP(400)>0
+          IF (KEEP(401) .EQ. 1) THEN
 C          L0-threads was requested for solve phase
 C          and will be effective only if KEEP(400) >0 
 C          which indicates that L0-threads was 
 C          performed during analysis+factorization
            IF ( KEEP(400) .GT. 0 ) THEN
 C           Check if number of threads is consistent with
-C           the one used during factorization
+C           the one used during factorization for all procs
 C{
             NOMP = 1
 !$          NOMP=omp_get_max_threads()
@@ -2617,17 +2843,23 @@ C{
 C               NOMP should be the one from analysis
                 id%INFO(1) = -58
                 id%INFO(2) = KEEP(400)
-            IF (LPOK) WRITE(LP,'(A,A,I5,A,I5)')
-     &" FAILURE DETECTED IN SOLVE: #threads for KEEP(401)",
-     &" changed from",KEEP(400)," at analysis to", NOMP
+                IF (LPOK) WRITE(LP,'(A,A,I5,A,I5)')
+     &" FAILURE DETECTED IN SOLVE: #threads for multithreaded",
+     &" tree parallelism changed from",KEEP(400)," at analysis to", 
+     &  NOMP
               ENDIF
            ENDIF
+C          error check
+           CALL MUMPS_PROPINFO( ICNTL(1), INFO(1),
+     &                    id%COMM,id%MYID)
+           IF ( id%INFO(1) .LT. 0 ) GO TO 90
 C}
           ENDIF
       IF (KEEP(400) .GT. 0) THEN
         CALL CMUMPS_SOL_L0OMP_LI(KEEP(400))
       ENDIF
 C     ==============================
+C     MAIN LOOP:
 C     BLOCKING ON the number of RHS
 C      We work on  a maximum of NBRHS at a time.
 C      the leading dimension of RHS is id%LRHS on master
@@ -2649,14 +2881,16 @@ C     {
 C       ==========================
 C       -- NBRHS     : Original block size
 C       -- BEG_RHS   : Column index of the first RHS in the list of
-C                      non empty RHS (RHS_LOC) to
+C                      non empty RHS (RHS_loc) to
 C                      be processed during this iteration
 C       -- NBRHS_EFF : Effective block size at current iteration
-C          In case of sparse RHS (KEEP(248)==1) NBRHS_EFF only refers to
-C                  non-empty columns and is used to compute NBCOL_INBLOC
-C          -- NBCOL_INBLOC  : the number of columns of sparse RHS needed
-C                        to get NBRHS_EFF non empty columns columns of
-C                        sparse RHS processed at each step
+C                      that we be set to nb of contiguous non empty 
+C                      columns
+C        In case of sparse RHS (KEEP(248)==1) NBRHS_EFF only refers to
+C                non-empty columns and is used to compute NBCOL_INBLOC
+C        -- NBCOL_INBLOC  : the number of columns of sparse RHS needed
+C                      to get NBRHS_EFF non empty columns columns of
+C                      sparse RHS processed at each step
 C
         NBRHS_EFF    = min(NRHS_NONEMPTY-BEG_RHS+1, NBRHS)
 C
@@ -2690,7 +2924,7 @@ C       id%RHS is accessed). Remark that
 C       overwritten later, in case of general sparse right-hand side
 C       and centralized solution to skip empty columns 
 C       ===========================================================
-        IF (
+        IF  (
 C           slave procs
      &      ( id%MYID .NE. MASTER )
 C       even on master when RHS not allocated
@@ -2734,7 +2968,8 @@ C       ================================
 C       Shift empty columns in case of sparse RHS
 C       ==========================================
         IF ( (id%MYID.EQ.MASTER) .AND.
-     &        KEEP(248)==1  ) THEN
+     &        KEEP(248)==1  
+     &     ) THEN
 C         update position of JBEG_RHS on first non-empty
 C         column of this block
           JBEG_RHS = JEND_RHS + 1
@@ -2743,7 +2978,8 @@ C         column of this block
      &          id%IRHS_PTR(PERM_RHS(JBEG_RHS)+1) )
 C             Empty column
               IF ((KEEP(237).EQ.0).AND.(ICNTL21.EQ.0).AND.
-     &              (KEEP(221).NE.1) ) THEN
+     &              (KEEP(221).NE.1) 
+     &           ) THEN
 C                General sparse RHS (NOT A-1) and centralized solution
 C                Set to zero part of the
 C                solution corresponding to empty columns
@@ -2758,7 +2994,8 @@ C                solution corresponding
             DO WHILE( id%IRHS_PTR(JBEG_RHS) .EQ.
      &        id%IRHS_PTR(JBEG_RHS+1) )
               IF ((KEEP(237).EQ.0).AND.(ICNTL21.EQ.0).AND.
-     &          (KEEP(221).NE.1) ) THEN
+     &             (KEEP(221).NE.1) 
+     &           ) THEN
 C               Case of general sparse RHS (NOT A-1) and
 C               centralized solution: set to zero part of
 C               the solution corresponding to empty columns
@@ -2768,11 +3005,13 @@ C               the solution correspondi
                 ENDDO
               ENDIF
               IF (KEEP(221).EQ.1) THEN
-C               Reduced RHS set to ZERO
-                DO I = 1, id%SIZE_SCHUR
-                  id%REDRHS(int(JBEG_RHS-1,8)*int(LD_REDRHS,8) +
-     &            int(I,8)) =  ZERO
-                ENDDO
+                IF (KEEP(60).NE.0) THEN
+C                 Fwd with Schur: reduced RHS set to ZERO
+                  DO I = 1, id%SIZE_SCHUR
+                    id%REDRHS(int(JBEG_RHS-1,8)*int(LD_REDRHS,8) +
+     &              int(I,8)) =  ZERO
+                  ENDDO
+                ENDIF
               ENDIF
               JBEG_RHS = JBEG_RHS +1
             ENDDO
@@ -2781,7 +3020,7 @@ C         Count nb of RHS columns skippe
 C         * CMUMPS_DISTRIBUTED_SOLUTION to reset those
 C           columns to zero.
 C         * in case of reduced right-hand side, to set
-C           corresponding entries of RHSCOMP to 0 after
+C           corresponding entries of RHSINTR to 0 after
 C           forward phase.
           NB_RHSSKIPPED = JBEG_RHS - (JEND_RHS + 1)
           IF ((KEEP(248).EQ.1).AND.(KEEP(237).EQ.0)
@@ -2798,7 +3037,8 @@ C           forward phase.
 C
 C       Shift on REDRHS in reduced RHS functionality
 C
-        IF (id%MYID.EQ.MASTER .AND. KEEP(221).NE.0) THEN
+        IF (id%MYID.EQ.MASTER .AND. KEEP(221).NE.0 
+     &       .AND. KEEP(60).NE.0 ) THEN
 C         Initialize IBEG_REDRHS
 C         Note that REDRHS always has id%NRHS Colmuns
           IBEG_REDRHS= int(JBEG_RHS-1,8)*int(LD_REDRHS,8) + 1_8
@@ -2814,11 +3054,12 @@ C
         CALL VTBEGIN(perm_scal_ini,IERR)
 #endif
         IF (id%MYID .eq. MASTER) THEN
-C         ======================
-          IF (KEEP(248)==1) THEN
-C         ======================
+C{        ======================
+          IF (KEEP(248)==1
+     &       ) THEN
+C{        ======================
 C
-C         Sparse RHS format ( A-1 or sparse input format)
+C         Sparse RHS format ( A-1 or sparse centralized input format)
 C         is provided as input by the user (IRHS_SPARSE ...)
 C         --------------------------------------------------
 C         Compute NZ_THIS_BLOCK and NBCOL_INBLOC
@@ -2840,7 +3081,10 @@ C         the first non empty column; th
 C         maximum size NBRHS_EFF except if we reach another empty
 C         column. (We are not sure to have a copy allocated
 C         and thus cannot compress on the fly, as done naturally
-C         for A-1).
+C         for A-1)
+C         For A-1 we process NBRHS_EFF non empty columns 
+C         in the bloc that contains NBCOL_INBLOC columns
+C         (empty+non empty)
           STOP_AT_NEXT_EMPTY_COL = .FALSE.
           DO I=JBEG_RHS, id%NRHS
             NBCOL_INBLOC = NBCOL_INBLOC +1
@@ -2861,15 +3105,19 @@ C              --  sparse case (not AM-1
                STOP_AT_NEXT_EMPTY_COL =.TRUE.
             ENDIF
             IF (COLSIZE.GT.0
+C{
      &      ) THEN
               NBCOL = NBCOL+1
               NZ_THIS_BLOCK = NZ_THIS_BLOCK + COLSIZE
+C}
             ELSE IF (STOP_AT_NEXT_EMPTY_COL) THEN
-C We have reached an empty column with already selected non empty 
-C columns: reduce block size to non empty columns reached so far.
+C{ We have reached an empty column with already selected non empty 
+C  columns: reduce block size to non empty columns reached so far.
               NBCOL_INBLOC = NBCOL_INBLOC -1
+C Note that NBRHS_EFF is udated only on master 
               NBRHS_EFF = NBCOL
               EXIT
+C}
             ENDIF
             IF (NBCOL.EQ.NBRHS_EFF) EXIT
           ENDDO
@@ -3000,9 +3248,16 @@ c    *                   (1:NZ_THIS_BLOC
      &          id%IRHS_SPARSE(id%IRHS_PTR(JBEG_RHS):
      &             id%IRHS_PTR(JBEG_RHS)+NZ_THIS_BLOCK-1)
             ENDIF
+#if defined(USE_OLD_SCALING)
+C           Centralized scaling: perform scaling on master
+C           in RHS_SPARSE_COPY
             IF (LSCAL.OR.DO_PERMUTE_RHS.OR.INTERLEAVE_PAR.OR.
      &          (KEEP(237).NE.0)) THEN
-C             if scaling is on or if columns of the RHS are
+#else
+            IF (DO_PERMUTE_RHS.OR.INTERLEAVE_PAR.OR.
+     &          (KEEP(237).NE.0)) THEN
+#endif
+C             if columns of the RHS are
 C             permuted then a copy of RHS_SPARSE is needed.
 C             Also always allocated with A-1,
 c             to enable receiving during mumps_gather_solution
@@ -3034,23 +3289,36 @@ c    *            (1:NZ_THIS_BLOCK)
             IF (DO_PERMUTE_RHS.OR.INTERLEAVE_PAR.OR.
      &          (id%KEEP(237).NE.0)) THEN
               IF (id%KEEP(237).NE.0) THEN
-C               --initialized to one; it might be
-C               modified if scaling is on (one first entry in each col is scaled)
+C               --initialized to one
+#if defined(USE_OLD_SCALING)
+C               it might be modified if scaling is on (one first entry
+C               in each col is scaled)
                 RHS_SPARSE_COPY = ONE
-              ELSE IF (.NOT. LSCAL) THEN
+#else
+C               Local scalings are used: RHSINTR is initialized
+C               directly on the workers and RHS_SPARSE_COPY will
+C               only be used during CMUMPS_GATHER_SOLUTION_AM1.
+#endif
+              ELSE
 C               -- Columns are not contiguous and need be copied one by one
+#if defined(USE_OLD_SCALING)
 C               -- This need not be done if scaling is on because it
 C               -- will done and scaled later.
-                IPOS = 1
-                DO I=JBEG_RHS, JBEG_RHS + NBCOL_INBLOC -1
-                  COLSIZE = id%IRHS_PTR(PERM_RHS(I)+1)
-     &                    - id%IRHS_PTR(PERM_RHS(I))
-                  IF (COLSIZE .EQ. 0) CYCLE
-                  RHS_SPARSE_COPY(IPOS:IPOS+COLSIZE-1) =
-     &            id%RHS_SPARSE(id%IRHS_PTR(PERM_RHS(I)):
-     &            id%IRHS_PTR(PERM_RHS(I)+1) -1)
-                  IPOS = IPOS + COLSIZE
-                ENDDO
+                IF (.NOT. LSCAL) THEN
+#endif
+                  IPOS = 1
+                  DO I=JBEG_RHS, JBEG_RHS + NBCOL_INBLOC -1
+                    COLSIZE = id%IRHS_PTR(PERM_RHS(I)+1)
+     &                      - id%IRHS_PTR(PERM_RHS(I))
+                    IF (COLSIZE .EQ. 0) CYCLE
+                    RHS_SPARSE_COPY(IPOS:IPOS+COLSIZE-1) =
+     &              id%RHS_SPARSE(id%IRHS_PTR(PERM_RHS(I)):
+     &              id%IRHS_PTR(PERM_RHS(I)+1) -1)
+                    IPOS = IPOS + COLSIZE
+                  ENDDO
+#if defined(USE_OLD_SCALING)
+                ENDIF
+#endif
               ENDIF
             ENDIF
 C           =========================
@@ -3085,9 +3353,9 @@ C                 (ii) columns might hav
               ENDIF ! MTYPE.NE.1
             ENDIF ! KEEP(23).NE.0
           ENDIF ! NZ_THIS_BLOCK .NE. 0
-C         -----
+C}        -----
           ENDIF  !  ============ KEEP(248)==1
-C         -----
+C}        -----
         ENDIF   !  (id%MYID .eq. MASTER)
 C
 C =====================  ERROR handling and propagation ================
@@ -3098,16 +3366,29 @@ C =====================  ERROR handling
 C ======================================================================
 C
 C       NBCOL_INBLOC depends on loop
-        IF (KEEP(248)==1) THEN
+        IF (KEEP(248)==1
+     &     ) THEN
             CALL MPI_BCAST( NBCOL_INBLOC,1, MPI_INTEGER,
      &           MASTER, id%COMM,IERR)
         ELSE
           NBCOL_INBLOC = NBRHS_EFF
         ENDIF
         JEND_RHS =JBEG_RHS + NBCOL_INBLOC - 1
+        IF ((KEEP(248).EQ.1).AND.(KEEP(237).EQ.0)) THEN
+C         Only case (in previous block) for which
+C         NBRHS_EFF has been modified only on master
+          ! case of general sparse: in case of empty columns
+          ! modifed version of
+          ! NBRHS_EFF need be broadcasted since it is used
+          ! to update BEG_RHS at the end of the DO WHILE
+            CALL MPI_BCAST( NBRHS_EFF,1, MPI_INTEGER,
+     &           MASTER, id%COMM,IERR)
+            CALL MPI_BCAST(NB_RHSSKIPPED,1,MPI_INTEGER,MASTER,
+     &               id%COMM,IERR)
+        ENDIF
         IF ((KEEP(111).eq.0).AND.(KEEP(252).EQ.0)
      &      .AND.(KEEP(221).NE.2 ).AND.(KEEP(248).EQ.1) ) THEN
-C         ----------------------------
+C{        ----------------------------
 C         -- SPARSE RIGHT-HAND-SIDE
 C         ----------------------------
           CALL MPI_BCAST( NZ_THIS_BLOCK,1, MPI_INTEGER,
@@ -3164,162 +3445,492 @@ C ======================================
      &             MPI_INTEGER,
      &             MASTER, id%COMM,IERR)
           ENDIF
+C}
         ENDIF
 C
 C       =========================================================
-C       INITIALIZE POSINRHSCOMP_ROW/COL, RHSCOMP and related data
-C       For distributed RHS, initialize RHSMAPINFO (at 1st block)
+C       INITIALIZE 
+C       - nodes_FWD and nodes_BWD
 C       =========================================================
-        IF ( I_AM_SLAVE ) THEN
-C         --------------------------------------------------
-C         If I am involved in the solve and if
-C         either
-C           no null space comput (keep(111)=0) and sparse rhs
-C         or
-C             null space computation
-C         then
-C           compute POSINRHSCOMP
-C         endif
+        IF (FIRST_CALL_NODES_FWD_BWD) THEN
+C{         First time CMUMPS_NODES_FWD_BWD_SIZE_FILL 
+C          is called allocated Pruned_Sons_FWD
+           IF (allocated(Pruned_Sons_FWD)) THEN 
+             NB_BYTES = NB_BYTES - size(Pruned_Sons_FWD) * K34_8
+             DEALLOCATE(Pruned_Sons_FWD)
+           ENDIF
+           IF (allocated(Pruned_Sons_BWD)) THEN 
+            NB_BYTES = NB_BYTES - size(Pruned_Sons_BWD) * K34_8
+            DEALLOCATE(Pruned_Sons_BWD)
+           ENDIF
+           ALLOCATE (Pruned_Sons_FWD(KEEP(28)),
+     &             Pruned_Sons_BWD(KEEP(28)), 
+     &             stat=allocok)
+           IF (allocok .GT. 0 ) THEN
+            INFO(1)=-13
+            INFO(2)= 2*KEEP(28)
+           ELSE
+            NB_BYTES = NB_BYTES + 
+     &                int(size(Pruned_Sons_FWD),8)*K34_8 +
+     &                int(size(Pruned_Sons_BWD),8)*K34_8 
+            NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
+           ENDIF
+C}
+        ENDIF
+C =====================  ERROR handling and propagation ==============
+        CALL MUMPS_PROPINFO( ICNTL(1), INFO(1),
+     &                       id%COMM,id%MYID)
+        IF (INFO(1) .LT.0 ) GOTO 90
+C=====================================================================
+C       Reset FIRST_CALL_NODES_FWD_BWD for not allocating
+C       (Pruned_Sons_FWD/BWD within loop)
+        FIRST_CALL_NODES_FWD_BWD = .FALSE.
 C
-C         Fwd in facto: in this case only POSINRHSCOMP need be computed
+        IF (CALL_NODES_FWD_BWD) THEN
+C{
+          fill = .FALSE.
+          nodes_FWD_PTR => IDUMMY_TARGET
+          Lnodes_FWD_PTR = 1
+          nodes_BWD_PTR => IDUMMY_TARGET
+          Lnodes_BWD_PTR = 1
+          CALL CMUMPS_NODES_FWD_BWD_SIZE_FILL (
+     &           fill, id%ICNTL(1), 
+     &           id%N, id%KEEP(28),  id%KEEP(1), 
+     &           id%STEP(1), id%Step2node(1),
+     &           IRHS_loc_PTR(1), id%Nloc_RHS,
+     &           IRHS_PTR_COPY(1), NBCOL_INBLOC, IRHS_SPARSE_COPY(1), 
+     &           NZ_THIS_BLOCK, PERM_RHS, size(PERM_RHS), JBEG_RHS,
+     &           UNS_PERM_INV, size(UNS_PERM_INV), ! size 1 if not used
+     &           ICNTL21, 
+     &           id%MYID, id%COMM,
+     &           id%INFO,
+     &           Pruned_Sons_FWD, Pruned_Sons_BWD,
+     &           Lnodes_FWD, Lnodes_BWD
+     &           , nodes_FWD_PTR(1), nodes_BWD_PTR(1)
+     &           , Lnodes_FWD_PTR, Lnodes_BWD_PTR
+     &           )
+C     
+C        ALLOCATE nodes_FWD and nodes_BWD  if needed
+C
+          IF (Lnodes_FWD.GT.0) THEN
+C           NBT is inout in MUMPS_REALLOC and should be initialized.
+            NBT = 0
+            CALL MUMPS_REALLOC(nodes_FWD, Lnodes_FWD, id%INFO, LP,
+     &         FORCE=.FALSE.,
+     &         STRING='nodes_FWD', MEMCNT=NBT, ERRCODE=-13)
+            IF (INFO(1).LT.0) GOTO 46
+C
+            nodes_FWD_PTR => nodes_FWD
+            Lnodes_FWD_PTR = Lnodes_FWD
+            NB_BYTES = NB_BYTES + NBT
+            NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
+          ELSE
+            nodes_FWD_PTR => IDUMMY_TARGET
+            Lnodes_FWD_PTR = 1
+          ENDIF
+          IF (Lnodes_BWD.GT.0) THEN
+C           NBT is inout in MUMPS_REALLOC and should be initialized.
+            NBT = 0
+            CALL MUMPS_REALLOC(nodes_BWD, Lnodes_BWD, id%INFO, LP,
+     &         FORCE=.FALSE.,
+     &         STRING='nodes_BWD', MEMCNT=NBT, ERRCODE=-13)
+            IF (INFO(1).LT.0) GOTO 46
+C
+            nodes_BWD_PTR => nodes_BWD
+            Lnodes_BWD_PTR = Lnodes_BWD
+            NB_BYTES = NB_BYTES + NBT
+            NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
+          ELSE
+            nodes_BWD_PTR => IDUMMY_TARGET
+            Lnodes_BWD_PTR = 1
+          ENDIF
 C
-C         (POSINRHSCOMP_ROW/COL indirection arrays should
+C =====================  ERROR handling and propagation ==============
+ 46       CONTINUE
+          CALL MUMPS_PROPINFO( ICNTL(1), INFO(1),
+     &                         id%COMM,id%MYID)
+          IF (INFO(1) .LT.0 ) GOTO 90
+C=====================================================================
+          IF (Lnodes_FWD.GT.0 .OR. Lnodes_BWD.GT.0) THEN
+C{
+C          we build nodes_FWD_PTR and/or nodes_BWD_PTR
+C          that will be used to prune flops 
+C          and even if one of the steps FWD/BWD does not
+C          lead to pruning (in this case 
+C          POSTINRHS_COMP will not benefit from pruning).
+           fill = .TRUE.
+           CALL CMUMPS_NODES_FWD_BWD_SIZE_FILL (
+     &           fill, id%ICNTL(1), 
+     &           id%N, id%KEEP(28),  id%KEEP(1), 
+     &           id%STEP(1), id%Step2node(1),
+     &           IRHS_loc_PTR(1), id%Nloc_RHS,
+     &           IRHS_PTR_COPY(1), NBCOL_INBLOC, IRHS_SPARSE_COPY(1), 
+     &           NZ_THIS_BLOCK, PERM_RHS, size(PERM_RHS), JBEG_RHS,
+     &           UNS_PERM_INV, size(UNS_PERM_INV), ! size 1 if not used
+     &           ICNTL21, 
+     &           id%MYID, id%COMM,
+     &           id%INFO, 
+     &           Pruned_Sons_FWD, Pruned_Sons_BWD,
+     &           Lnodes_FWD, Lnodes_BWD
+     &           , nodes_FWD_PTR(1), nodes_BWD_PTR(1)
+     &           , Lnodes_FWD_PTR, Lnodes_BWD_PTR
+     &           )
+C}
+          ENDIF
+C         ------------------------------------------------
+C         Update CALL_NODES_FWD_BWD and free workspace if 
+C         not used again in loop of RHS
+C         ------------------------------------------------
+          IF (
+     &          (KEEP(237) .NE. 0).OR.                   ! AM1
+     &          ((KEEP(235) .NE. 0).AND.KEEP(248).NE.-1) ! GS
+     &       ) THEN
+C           target nodes for chain pruning 
+C           need be updated in case of AM1 or General Sparse
+            CALL_NODES_FWD_BWD = .TRUE.
+          ELSE
+C           all other cases including 
+C           distributed RHS and distributed solution 
+            CALL_NODES_FWD_BWD = .FALSE.
+          ENDIF
+          IF (.NOT. CALL_NODES_FWD_BWD
+     &       ) THEN
+C           Not needed anymore in the loop of RHS
+            IF (allocated(Pruned_Sons_FWD)) THEN 
+             NB_BYTES = NB_BYTES - size(Pruned_Sons_FWD) * K34_8
+             DEALLOCATE(Pruned_Sons_FWD)
+            ENDIF
+            IF (allocated(Pruned_Sons_BWD)) THEN 
+             NB_BYTES = NB_BYTES - size(Pruned_Sons_BWD) * K34_8
+             DEALLOCATE(Pruned_Sons_BWD)
+            ENDIF
+C         ELSE
+C           deallocate later
+          ENDIF
+C}
+        ENDIF
+C       =========================================================
+C       INITIALIZE 
+C       - GLOB2LOC_RHS/SOL, RHSINTR and related data
+C       - For distributed RHS, initialize RHSMAPINFO (at 1st block)
+C       =========================================================
+C         
+C         Fwd in facto: in this case we peronrly peonly POSINRHSINTR need be computed
+C
+C         (GLOB2LOC_RHS/SOL indirection arrays should
 C         have been allocated once outside loop)
-C         Compute size of RHSCOMP since it might depend
+C         Compute size of RHSINTR since it might depend
 C            on the process index and of the sparsity of the RHS
 C            if it is exploited.
-C         Initialize POSINRHSCOMP_ROW/COL
+C         Initialize GLOB2LOC_RHS/SOL
 C
-C         Note that LD_RHSCOMP and id%KEEP8(25)
+C         Note that id%LD_RHSINTR and id%KEEP8(25)
 C         are not set on the host in this routine in
 C         the case of a non-working host.
-C         Note that POSINRHSCOMP is now always computed in SOL_DRIVER
+C         Note that POSINRHSINTR is now always computed in SOL_DRIVER
 C         at least during the first block of RHS when sparsity of RHS
 C         is not exploited.
 C         -------------------------------
-C         INITTIALZE POSINRHSCOMP_ROW/COL
+C         INITTIALZE GLOB2LOC_RHS/SOL
 C         -------------------------------
 C
-          IF ( KEEP(221).EQ.2 .AND. KEEP(252).EQ.0
-     &      .AND.  (KEEP(248).NE.1 .OR. (id%NRHS.EQ.1))
-     &      ) THEN
-C           Reduced RHS was already computed during
-C           a previous forward step AND is valid.
-C           By valid we mean:
-C            -no forward in facto  (KEEP(252)==0) during which
-C             POSINRHSCOMP was not computed
-C           AND
-C            -no exploit sparsity with multiple RHS
-C            because in this case POSINRHSCOMP would
-C            be valid only for the last block processed during fwd.
-C           In those cases since we only perform the backward step, we do not
-C           need to compute POSINRHSCOMP
-            BUILD_POSINRHSCOMP = .FALSE.
-          ENDIF
+C       next block ok for Schur only
+        IF ( KEEP(221).EQ.2 .AND. KEEP(252).EQ.0
+     &    .AND.  (KEEP(248).NE.1 .OR. (id%NRHS.EQ.1))
+     &    ) THEN
+C         Reduced RHS (Schur feature) was already computed during
+C         a previous forward step AND is valid.
+C         By valid we mean:
+C          -no forward in facto  (KEEP(252)==0) during which
+C           POSINRHSINTR was not computed
+C         AND
+C          -no exploit sparsity with multiple RHS
+C          because in this case POSINRHSINTR would
+C          be valid only for the last block processed during fwd.
+C         In those cases since we only perform the backward step, 
+c         we do not need to compute POSINRHSINTR
+          BUILD_POSINRHSINTR = .FALSE.
+        ENDIF
 C         ------------------------
-C         INITIALIZE POSINRHSCOMP
+C         INITIALIZE POSINRHSINTR
 C         ------------------------
-          IF (BUILD_POSINRHSCOMP) THEN
-C           -- we first set MTYPE_LOC and
-C           -- reset BUILD_POSINRHSCOMP for next iteration in loop
-C
-C           general case only POSINRHSCOMP is computed
-            BUILD_POSINRHSCOMP = .FALSE.
-!           POSINRHSCOMP does not change between blocks
-            MTYPE_LOC = MTYPE
+        IF (BUILD_POSINRHSINTR) THEN
+C{        -- we first set MTYPE_LOC and
+C         -- reset BUILD_POSINRHSINTR for next iteration in loop
+C
+C         general case only POSINRHSINTR is computed
+          BUILD_POSINRHSINTR = .FALSE.
+!         POSINRHSINTR does not change between blocks
+          MTYPE_LOC = MTYPE
 C
-            IF ( (KEEP(111).NE.0) .OR. (KEEP(237).NE.0) .OR.
+          IF ( (KEEP(111).NE.0) .OR. (KEEP(237).NE.0) .OR.
      &         (KEEP(252).NE.0) ) THEN
 C
-              IF (KEEP(111).NE.0) THEN
-C               -- in the context of null space, we need to
-C               -- build RHSCOMP to skip SOL_R. Therefore
-C               -- we need to know for each concerned
-C               -- row index its position in
-C               -- RHSCOMP
-C               We use row indices, as these are the ones that
-C               were used to detect zero pivots during factorization.
-C               POSINRHSCOMP_ROW will allow to find the (row) index of a
-C               zero in RHSCOMP before calling CMUMPS_SOL_S. Then
-C               CMUMPS_SOL_S uses column indices to build the solution
-C               (corresponding to null space vectors)
-                MTYPE_LOC = 1
-              ELSE IF  (KEEP(252).NE.0) THEN
-C               -- Fwd in facto: since fwd is skipped we need to build POSINRHSCOMP
-                MTYPE_LOC = 1  ! (no transpose)
-C     BUILD_POSINRHSCOMP = .FALSE.  ! POSINRHSCOMP does not change between blocks
-              ELSE
-C               -- A-1 only
-                MTYPE_LOC = MTYPE
-                BUILD_POSINRHSCOMP = .TRUE.
-              ENDIF
+            IF (KEEP(111).NE.0) THEN
+C             -- in the context of null space, we need to
+C             -- build RHSINTR to skip SOL_R. Therefore
+C             -- we need to know for each concerned
+C             -- row index its position in
+C             -- RHSINTR
+C             We use row indices, as these are the ones that
+C             were used to detect zero pivots during factorization.
+C             GLOB2LOC_RHS will allow to find the (row) index of a
+C             zero in RHSINTR before calling CMUMPS_SOL_S. Then
+C             CMUMPS_SOL_S uses column indices to build the solution
+C             (corresponding to null space vectors)
+              MTYPE_LOC = 1
+            ELSE IF  (KEEP(252).NE.0) THEN
+C             -- Fwd in facto: since fwd is skipped we need to build POSINRHSINTR
+              MTYPE_LOC = 1  ! (no transpose)
+            ELSE
+C             -- A-1 only
+              MTYPE_LOC = MTYPE
+              BUILD_POSINRHSINTR = .TRUE.
             ENDIF
-C           -- compute POSINRHSCOMP
-            LIW_PASSED=max(1,LIW)
-            IF (KEEP(237).EQ.0) THEN
-              CALL CMUMPS_BUILD_POSINRHSCOMP(
+          ENDIF
+C         -- compute POSINRHSINTR
+          LIW_PASSED=max(1,LIW)
+          IF ( 
+C                no sparsity at fwd or bwd:
+     &           (Lnodes_FWD.EQ.-1).OR.(Lnodes_BWD.EQ.-1)
+C              
+     &          ) THEN
+C
+C           RHSINTR is not sparse (in the sense that it has N rows
+C           distributed on the MPI procs) and thus POSINRHSINTR
+C           does not change with loop.
+C           Remarks:
+C             1/ sparsity might still be exploited during 
+C                fwd or bwd to reduce the number of operations.
+C             2/ 
+            BUILD_POSINRHSINTR = .FALSE.
+C
+            IF ( I_AM_SLAVE ) THEN
+C{
+              CALL CMUMPS_BUILD_GLOB2LOC(
      &           id%NSLAVES,id%N,
      &           id%MYID_NODES, id%PTLUST_S(1),
      &           id%KEEP(1),id%KEEP8(1),
      &           id%PROCNODE_STEPS(1), id%IS(1), LIW_PASSED,
      &           id%STEP(1),
-     &           id%POSINRHSCOMP_ROW(1), id%POSINRHSCOMP_COL(1),
-     &           id%POSINRHSCOMP_COL_ALLOC,
+     &           id%GLOB2LOC_RHS(1), id%GLOB2LOC_SOL(1),
+     &           id%GLOB2LOC_SOL_ALLOC,
      &           MTYPE_LOC,
-     &           NBENT_RHSCOMP, NB_FS_RHSCOMP_TOT )
-                NB_FS_RHSCOMP_F = NB_FS_RHSCOMP_TOT
-            ELSE
-              CALL CMUMPS_BUILD_POSINRHSCOMP_AM1(
+     &           NBENT_RHSINTR, NB_FS_RHSINTR_TOT )
+                NB_FS_RHSINTR_F = NB_FS_RHSINTR_TOT
+C}
+            ENDIF
+C
+          ELSE 
+C
+C  Note that POSINRHSINTR* need not be recomputed before IR :
+C  because distributed solution => NO IR.
+C
+C           Exploit sparsity in solution and RHS 
+C           (AM1 or (Sparse RHS and solution) )
+C           Since sparsity is exploited during
+C           both fwd and bwd then we need to recompute 
+C           POSINRHSINTR only  when CALL_NODES_FWD_BWD will
+C           be performed at next iteration.
+            IF (CALL_NODES_FWD_BWD) BUILD_POSINRHSINTR = .TRUE.
+C
+            IF ( I_AM_SLAVE ) THEN
+C{
+              CALL CMUMPS_BUILD_GLOB2LOC_NODES_ES(
      &           id%NSLAVES,id%N,
      &           id%MYID_NODES, id%PTLUST_S(1), id%DAD_STEPS(1),
      &           id%KEEP(1),id%KEEP8(1),
      &           id%PROCNODE_STEPS(1), id%IS(1), LIW,
      &           id%STEP(1),
-     &           id%POSINRHSCOMP_ROW(1), id%POSINRHSCOMP_COL(1),
-     &           id%POSINRHSCOMP_COL_ALLOC,
+C
+     &            Lnodes_FWD, Lnodes_BWD,
+     &            nodes_FWD_PTR(1), nodes_BWD_PTR(1),
+C
+     &           id%GLOB2LOC_RHS(1), id%GLOB2LOC_SOL(1),
+     &           id%GLOB2LOC_SOL_ALLOC,
      &           MTYPE_LOC,
-     &           IRHS_PTR_COPY(1), NBCOL_INBLOC, IRHS_SPARSE_COPY(1),
-     &           NZ_THIS_BLOCK,PERM_RHS, size(PERM_RHS) , JBEG_RHS,
-     &           NBENT_RHSCOMP,
-     &           NB_FS_RHSCOMP_F, NB_FS_RHSCOMP_TOT,
-     &            UNS_PERM_INV, size(UNS_PERM_INV) ! size 1 if not used
-     &            )
+     &           NBENT_RHSINTR,
+     &           NB_FS_RHSINTR_F, NB_FS_RHSINTR_TOT
+     &           )
+C}
             ENDIF
-          ENDIF   ! BUILD_POSINRHSCOMP=.TRUE.
-          IF (BUILD_RHSMAPINFO .AND. KEEP(248).EQ.-1) THEN
+          ENDIF
+C}
+        ENDIF   ! BUILD_POSINRHSINTR=.TRUE.
+        IF (BUILD_RHSMAPINFO .AND. KEEP(248).EQ.-1
+     &        ) THEN
 C
 C           Prepare symbolic data for sends.
-C           For the moment: MAP_RHS_loc
+C           For the moment: only MAP_RHS_loc
 C
+C           id%GLOB2LOC_RHS is always associated to the
+C           forward step (with or without transposed system)
+          IF ( I_AM_SLAVE ) THEN
+C{
             CALL MUMPS_SOL_RHSMAPINFO( id%N, id%Nloc_RHS, id%KEEP(89),
-     &            IRHS_loc_PTR(1), MAP_RHS_loc, id%POSINRHSCOMP_ROW(1),
+     &            IRHS_loc_PTR(1), MAP_RHS_loc, id%GLOB2LOC_RHS(1),
      &            id%NSLAVES, id%MYID_NODES,
      &            id%COMM_NODES, id%ICNTL(1), id%INFO(1) )
             BUILD_RHSMAPINFO = .FALSE.
 C           MUMPS_SOL_RHSMAPINFO does not propagate errors
-          ENDIF
+C}
+          ENDIF ! I_AM_SLAVE
         ENDIF
         CALL MUMPS_PROPINFO( ICNTL(1), INFO(1),
      &                   id%COMM,id%MYID)
         IF (INFO(1) .LT.0 ) GOTO 90
+        IF ( BUILD_SCALING_RHSINTR ) THEN
+C{
+          IF (SCALING_RHSINTR_BWD_ALLOCATED) THEN
+            NB_BYTES = NB_BYTES - LSCALING_RHSINTR_BWD * K16_8
+            DEALLOCATE(SCALING_RHSINTR_BWD)
+          ENDIF
+          IF (SCALING_RHSINTR_FWD_ALLOCATED) THEN
+            NB_BYTES = NB_BYTES - LSCALING_RHSINTR_FWD * K16_8
+            DEALLOCATE(SCALING_RHSINTR_FWD)
+          ENDIF
+          NULLIFY(SCALING_RHSINTR_BWD)
+          NULLIFY(SCALING_RHSINTR_FWD)
+          SCALING_RHSINTR_BWD_ALLOCATED = .FALSE.
+          SCALING_RHSINTR_FWD_ALLOCATED = .FALSE.
+          SCALING_RHSINTR_BWD => RDUMMY_TARGET
+          SCALING_RHSINTR_FWD => RDUMMY_TARGET
+          LSCALING_RHSINTR_BWD = 1
+          LSCALING_RHSINTR_FWD = 1
+C         Define or allocate SCALING_RHSINTR if needed:
+          IF (LSCAL .AND. I_AM_SLAVE ) THEN
+            IF (KEEP(221).EQ.2) THEN
+C             In case of sparsity during bwd, we cannot
+C             rely on the value of Lnodes_FWD to know
+C             whether the scaling will match SCALING_LOC
+C             and should thus consider that (Lnodes_FWD.NE.-1)
+              ES_RHSINTR = (Lnodes_BWD.NE.-1)
+            ELSE
+C             sparsity at fwd and at bwd:
+              ES_RHSINTR = (Lnodes_FWD.NE.-1).AND.(Lnodes_BWD.NE.-1)
+            ENDIF
+C           Scaling allocations performed only if needed
+C             Forward or normal solve:
+              IF ( ES_RHSINTR ) THEN
+                LSCALING_RHSINTR_FWD = max(1, NB_FS_RHSINTR_F )
+                ALLOCATE(SCALING_RHSINTR_FWD(LSCALING_RHSINTR_FWD),
+     &                   stat=allocok)
+                IF (allocok .GT. 0) THEN
+                  INFO(1)=-13
+                  INFO(2)=LSCALING_RHSINTR_FWD
+                ELSE
+                  SCALING_RHSINTR_FWD_ALLOCATED = .TRUE.
+                  NB_BYTES = NB_BYTES + LSCALING_RHSINTR_FWD * K16_8
+                ENDIF
+              ELSE
+C               RHSINTR matches SCALING_loc, no need to
+C               allocate and compute a different scaling
+                LSCALING_RHSINTR_FWD = max(1,KEEP(89))
+#if defined(USE_OLD_SCALING)
+#else
+                SCALING_RHSINTR_FWD => SCALING_LOC_FWD
+#endif
+              ENDIF
+              IF (ES_RHSINTR) THEN
+                  LSCALING_RHSINTR_BWD = max(1, NB_FS_RHSINTR_TOT )
+                ALLOCATE(SCALING_RHSINTR_BWD(LSCALING_RHSINTR_BWD),
+     &                   stat=allocok)
+                IF (allocok .GT. 0) THEN
+                  INFO(1)=-13
+                  INFO(2)=LSCALING_RHSINTR_BWD
+                ELSE
+                  SCALING_RHSINTR_BWD_ALLOCATED = .TRUE.
+                  NB_BYTES = NB_BYTES + LSCALING_RHSINTR_BWD * K16_8
+                ENDIF
+              ELSE
+C               RHSINTR matches SCALING_loc, no need to
+C               allocate and compute a different scaling
+                LSCALING_RHSINTR_BWD = max(1,KEEP(89))
+#if defined(USE_OLD_SCALING)
+                SCALING_RHSINTR_BWD => scaling_data_sol%SCALING_LOC
+#else
+                SCALING_RHSINTR_BWD => SCALING_LOC_BWD
+                SCALING_RHSINTR_FWD => SCALING_LOC_FWD
+#endif
+              ENDIF
+          ENDIF
+C}
+        ENDIF
+        CALL MUMPS_PROPINFO( id%ICNTL, id%INFO, id%COMM,id%MYID)
+        IF (id%INFO(1) .LT.0 ) GOTO 90
+        IF (BUILD_SCALING_RHSINTR) THEN
+C{
+          IF ( LSCAL .AND. I_AM_SLAVE. AND. ES_RHSINTR ) THEN
+#if ! defined(USE_OLD_SCALING)
+C             SCALING_RHSINTR_FWD has been allocated and should
+C             now be filled. It is a compressed version of the
+C             local scaling array SCALING_LOC_FWD:
+              IF (MTYPE.eq.0 .AND. KEEP(50).EQ.0) THEN ! tranpose
+                ROWORCOL = 2 ! access 2nd list -- col indices
+              ELSE
+                ROWORCOL = 1 ! access 1st list -- row indices
+              ENDIF
+              CALL CMUMPS_SCALINGRHSINTR(LSCAL, id%N,
+     &             SCALING_LOC_FWD(1),
+     &             SCALING_RHSINTR_FWD(1),
+     &             LSCALING_RHSINTR_FWD, id%GLOB2LOC_RHS(1),
+     &             id%KEEP, ROWORCOL, id%PTLUST_S(1),
+     &             id%IS(1), max(1,LIW),
+     &             id%MYID_NODES, id%STEP(1), id%PROCNODE_STEPS(1),
+     &             id%NSLAVES)
+C             SCALING_RHSINTR_BWD has been allocated and should
+C             now be filled. It is a compressed version of the
+C             local scaling array SCALING_LOC_BWD:
+              IF (MTYPE.eq.1 .AND. KEEP(50).EQ.0) THEN ! no tranpose
+C               access 2nd list corresponding to col indices
+                ROWORCOL = 2 
+              ELSE
+C               access 1st list corresponding to row indices
+                ROWORCOL = 1 
+              ENDIF
+              CALL CMUMPS_SCALINGRHSINTR(LSCAL, id%N,
+     &             SCALING_LOC_BWD(1),
+     &             SCALING_RHSINTR_BWD(1),
+     &             LSCALING_RHSINTR_BWD, id%GLOB2LOC_SOL(1),
+     &             id%KEEP, ROWORCOL, id%PTLUST_S(1),
+     &             id%IS(1), max(1,LIW),
+     &             id%MYID_NODES, id%STEP(1), id%PROCNODE_STEPS(1),
+     &             id%NSLAVES)
+#endif
+#if defined(USE_OLD_SCALING)
+#endif
+          ENDIF
+C         Rebuild SCALING_RHSINTR* next time
+C         only if POSINRHSINTR has to be built
+C         again next time:
+          BUILD_SCALING_RHSINTR= BUILD_POSINRHSINTR
+C}
+        ENDIF
         IF (I_AM_SLAVE) THEN
-          IF (KEEP(221).EQ.1) THEN
-C           we need to save the reduced RHS for all RHS to perform
-C           later the backward phase with an updated reduced RHS
-C           thus we allocate NRHS_NONEMPTY columns in one shot.
-C           Note that RHSCOMP might have been allocated in previous block
-C           and RHSCOMP has been deallocated previous to entering loop on RHS
-            IF (.not. associated(id%RHSCOMP)) THEN
+          IF ((KEEP(221).EQ.1).OR.KEEP(221).EQ.-1) THEN
+C         For the following cases:
+C          -[Schur] we need to save the reduced RHS for all RHS 
+C                 to perform later the backward phase with an
+C                 updated reduced RHS
+C          -[Fwd only] return RHSINTR to user
+C          -KEEP(221)=-1, allocate RHSINTR to enable bwd only step
+C         We need to allocate NRHS_NONEMPTY columns in one shot.
+C         Note that 
+C            -RHSINTR might have been allocated in previous block
+C            -RHSINTR has been deallocated previous to entering 
+C             loop on RHS
+            IF (.not. associated(id%RHSINTR)) THEN
 C             So far we cannot combine this to exploit sparsity
-C             so that NBENT_RHSCOMP will not change in the loop
-C             and can be used to dimension RHSCOMP
+C             so that NBENT_RHSINTR will not change in the loop
+C             and can be used to dimension RHSINTR
+C
 C             Furthermore, during bwd phase the REDRHS provided
 C             by the user might also have a different non empty
 C             column pattern than the sparse RHS provided on input to
 C             this phase: thus we need to allocate id%NRHS columns too.
-              LD_RHSCOMP = max(NBENT_RHSCOMP,1)
-              id%KEEP8(25) = int(LD_RHSCOMP,8)*int(id%NRHS,8)
-              ALLOCATE (id%RHSCOMP(id%KEEP8(25)),  stat = allocok)
+              id%LD_RHSINTR = max(NBENT_RHSINTR,1)
+              id%KEEP8(25) = int(id%LD_RHSINTR,8)*int(id%NRHS,8)
+              ALLOCATE (id%RHSINTR(id%KEEP8(25)),  stat = allocok)
               IF ( allocok .GT. 0 ) THEN
                  INFO(1)=-13
                  CALL MUMPS_SET_IERROR(id%KEEP8(25),INFO(2))
@@ -3330,34 +3941,35 @@ C             this phase: thus we need t
               NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
             ENDIF
           ENDIF
-          IF ((KEEP(221).NE.1).AND.
+C 
+C
+          IF ((KEEP(221).NE.1).AND. 
      &        ((KEEP(221).NE.2).OR.(KEEP(252).NE.0))
      &       ) THEN
 C           ------------------
-C           Allocate RHSCOMP (case of RHSCOMP allocated at each block of RHS)
+C           Allocate RHSINTR
+C           (case of RHSINTR allocated at each block of RHS)
 C           ------------------
-C           RHSCOMP allocated per block of maximum size NBRHS
-            LD_RHSCOMP = max(NBENT_RHSCOMP, LD_RHSCOMP)
+C           RHSINTR allocated per block of maximum size NBRHS
 C           NBRHS_EFF could be used instead on NBRHS
-            IF (associated(id%RHSCOMP)) THEN
-              IF ( (id%KEEP8(25).LT.int(LD_RHSCOMP,8)*int(NBRHS,8))
-     &          .OR. (KEEP(235).NE.0).OR.(KEEP(237).NE.0) ) THEN
-                ! deallocate and reallocate if:
-                ! _larger array needed
-                ! OR 
-                ! _exploit sparsity/A-1: since size of RHSCOMP 
-                ! is expected to vary much in these cases
-                ! this should improve locality
+            IF (associated(id%RHSINTR)) THEN
+C             RHSINTR already associated for previous
+C             block, check if we can reuse it.
+              id%LD_RHSINTR = max(NBENT_RHSINTR, 1)
+              IF (id%KEEP8(25).LT.int(id%LD_RHSINTR,8)*int(NBRHS,8))
+     &        THEN
+                ! deallocate and reallocate since larger array is needed
                  NB_BYTES = NB_BYTES - id%KEEP8(25)*K35_8
-                 DEALLOCATE(id%RHSCOMP)
-                 NULLIFY(id%RHSCOMP)
-                 id%KEEP8(25)=0_8
+                 DEALLOCATE(id%RHSINTR)
+                 NULLIFY(id%RHSINTR)
+                 id%KEEP8(25)  = 0_8
+                 id%LD_RHSINTR = 0
               ENDIF
             ENDIF
-            IF (.not. associated(id%RHSCOMP)) THEN
-              LD_RHSCOMP = max(NBENT_RHSCOMP, 1)
-              id%KEEP8(25) = int(LD_RHSCOMP,8)*int(NBRHS,8)
-              ALLOCATE (id%RHSCOMP(id%KEEP8(25)),  stat = allocok )
+            IF (.not. associated(id%RHSINTR)) THEN
+              id%LD_RHSINTR = max(NBENT_RHSINTR, 1)
+              id%KEEP8(25) = int(id%LD_RHSINTR,8)*int(NBRHS,8)
+              ALLOCATE (id%RHSINTR(id%KEEP8(25)),  stat = allocok )
               IF ( allocok .GT. 0 ) THEN
                INFO(1)=-13
                CALL MUMPS_SET_IERROR(id%KEEP8(25),INFO(2))
@@ -3367,22 +3979,16 @@ C           NBRHS_EFF could be used inst
               NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
             ENDIF
           ENDIF
-          IF (KEEP(221).EQ.2) THEN
-C           RHSCOMP has been allocated (call with KEEP(221).EQ.1)
-C           even in the case fwd in facto
-            ! Not correct: LD_RHSCOMP = LENRHSCOMP/id%NRHS_NONEMPTY
-            LD_RHSCOMP = int(id%KEEP8(25)/int(id%NRHS,8))
-          ENDIF
 C
-C         Shift on RHSCOMP
+C         Shift on RHSINTR
 C
           IF ( KEEP(221).EQ.0 ) THEN
-C            -- RHSCOMP reused in the loop
-             IBEG_RHSCOMP= 1_8
+C            -- RHSINTR reused in the loop
+             IBEG_RHSINTR= 1_8
           ELSE
-C            Initialize IBEG_RHSCOMP
+C            Initialize IBEG_RHSINTR
 C
-             IBEG_RHSCOMP= int(JBEG_RHS-1,8)*int(LD_RHSCOMP,8) + 1_8
+            IBEG_RHSINTR= int(JBEG_RHS-1,8)*int(id%LD_RHSINTR,8)+1_8
           ENDIF
         ENDIF   ! I_AM_SLAVE
 C =====================  ERROR handling and propagation ================
@@ -3396,7 +4002,8 @@ C       ---------------------------
 C       Prepare RHS on master (case
 C       of dense and sparse RHS)
 C       ---------------------------
-        IF (id%MYID .eq. MASTER) THEN
+        IF (id%MYID .eq. MASTER
+     &     ) THEN
 C         =========================
           IF (KEEP(23) .NE. 0) THEN
 C         =========================
@@ -3459,8 +4066,10 @@ C
               ENDDO
             ENDIF
           ENDIF
+#if defined(USE_OLD_SCALING)
 C
 C         RHS is set to scaled right hand side
+C         (case of centralized scaling only)
 C
           IF (LSCAL) THEN
 C           scaling was performed
@@ -3571,6 +4180,7 @@ C                     Original IRHS_PTR
               ENDIF
             ENDIF  ! KEEP(248)==1
           ENDIF  ! LSCAL
+#endif
         ENDIF  ! id%MYID.EQ.MASTER
 #if defined(V_T)
         CALL VTEND(perm_scal_ini,IERR)
@@ -3579,16 +4189,6 @@ C
 C       Prepare RHS on master
 C       END
 C       =====================
-        IF ((KEEP(248).EQ.1).AND.(KEEP(237).EQ.0)) THEN
-          ! case of general sparse: in case of empty columns
-          ! modifed version of
-          ! NBRHS_EFF need be broadcasted since it is used
-          ! to update BEG_RHS at the end of the DO WHILE
-            CALL MPI_BCAST( NBRHS_EFF,1, MPI_INTEGER,
-     &           MASTER, id%COMM,IERR)
-            CALL MPI_BCAST(NB_RHSSKIPPED,1,MPI_INTEGER,MASTER,
-     &               id%COMM,IERR)
-        ENDIF
 C       -----------------------------------
 C       Two main cases depending on option
 C       for null space computation:
@@ -3605,7 +4205,7 @@ C       --------------------------------
         TIMESCATTER1=MPI_WTIME()
         IF ((KEEP(111).eq.0).AND.(KEEP(252).EQ.0)
      &        .AND.(KEEP(221).NE.2 )) THEN
-C           ------------------------
+C{          ------------------------
 C           Use RHS provided by user
 C           when not null space and not Fwd in facto
 C           ------------------------
@@ -3616,7 +4216,7 @@ C             --------------------------
               IF ( .NOT.I_AM_SLAVE ) THEN
 C               -- Master not working
                 CALL CMUMPS_SCATTER_RHS(id%NSLAVES,id%N, id%MYID,
-     &          id%COMM,
+     &          id%COMM, LSCAL, SCALING_LOC_FWD(1),
      &          MTYPE, id%RHS(IBEG), LD_RHS, NBRHS_EFF,
      &          NBRHS_EFF,
      &          C_DUMMY, 1, 1,
@@ -3639,11 +4239,11 @@ C               -- Master not working
                 ENDIF
                 LIW_PASSED = max( LIW, 1 )
                 CALL CMUMPS_SCATTER_RHS(id%NSLAVES,id%N, id%MYID,
-     &          id%COMM,
+     &          id%COMM, LSCAL, SCALING_LOC_FWD(1),
      &          MTYPE, PTR_RHS(IBEG_loc),LD_RHS_loc,NCOL_RHS_loc,
      &          NBRHS_EFF,
-     &          id%RHSCOMP(IBEG_RHSCOMP), LD_RHSCOMP, NBRHS_EFF,
-     &          id%POSINRHSCOMP_ROW(1), NB_FS_RHSCOMP_F,
+     &          id%RHSINTR(IBEG_RHSINTR), id%LD_RHSINTR, NBRHS_EFF,
+     &          id%GLOB2LOC_RHS(1), NB_FS_RHSINTR_F,
 C
      &          id%PTLUST_S(1), id%KEEP(1), id%KEEP8(1),
      &          id%PROCNODE_STEPS(1),
@@ -3671,9 +4271,14 @@ C
      &          IRHS_loc_PTR(1),
      &          idRHS_loc(RHS_loc_shift),
      &          RHS_loc_size,
-     &          id%RHSCOMP(IBEG_RHSCOMP), LD_RHSCOMP,
-     &          id%POSINRHSCOMP_ROW(1), NB_FS_RHSCOMP_F,
-     &          LSCAL, scaling_data_dr,
+     &          id%RHSINTR(IBEG_RHSINTR), id%LD_RHSINTR,
+     &          id%GLOB2LOC_RHS(1), NB_FS_RHSINTR_F,
+     &          LSCAL,
+#if defined(USE_OLD_SCALING)
+     &          scaling_data_dr,
+#else
+     &          SCALING_RHSINTR_FWD(1), LSCALING_RHSINTR_FWD,
+#endif
      &          LP, LPOK, KEEP(1), NB_BYTES_LOC, INFO(1))
 C               NB_BYTES_LOC were allocated and freed above
                 NB_BYTES_MAX = max(NB_BYTES_MAX,
@@ -3686,14 +4291,20 @@ C               NB_BYTES_LOC were alloca
 C             ===  KEEP(248)==1 =========
 C             -- SPARSE RIGHT-HAND-SIDE
 C             ----------------------------
-              IF (NZ_THIS_BLOCK > 0) THEN
+              IF (NZ_THIS_BLOCK > 0
+#if ! defined(USE_OLD_SCALING)
+C               For AM1, no need to broadcast RHS_SPARSE
+C               when using local scalings. RHSINTR will
+C               be initialized directly and RHS_SPARSE
+C               is used during CMUMPS_GATHER_SOLUTION_AM1
+     &            .AND. id%KEEP(237) .EQ.0
+#endif
+     &        ) THEN
                 CALL MPI_BCAST(RHS_SPARSE_COPY(1),
      &                     NZ_THIS_BLOCK,
      &                     MPI_COMPLEX,
      &                     MASTER, id%COMM, IERR)
               ENDIF
-C             -- At this point each process has a copy of the
-C             -- sparse RHS. We need to store it into RHSCOMP.
 C
               IF (KEEP(237).NE.0)  THEN
                 IF ( I_AM_SLAVE ) THEN
@@ -3701,37 +4312,43 @@ C                 -----
 C                 case of A-1
 C                 -----
 C                 - Take columns with non-zero entry, say j,
-C                 - to build Ej and store it in RHSCOMP
-                  K=1              ! Column index in RHSCOMP
-                  id%RHSCOMP(1_8:int(NBRHS_EFF,8)*int(LD_RHSCOMP,8))
+C                 - to build Ej and store it in RHSINTR
+                  K=1              ! Column index in RHSINTR
+                  id%RHSINTR(1_8:int(NBRHS_EFF,8)*int(id%LD_RHSINTR,8))
      &            = ZERO
                   IPOS = 1
                   DO I = 1, NBCOL_INBLOC
                     COLSIZE = IRHS_PTR_COPY(I+1) - IRHS_PTR_COPY(I)
                     IF (COLSIZE.GT.0) THEN
                       ! Find global column index J and set
-                      ! column K of RHSCOMP to ej (here IBEG is one)
+                      ! column K of RHSINTR to ej (here IBEG is one)
                       J = I - 1 + JBEG_RHS
                       IF (DO_PERMUTE_RHS.OR.INTERLEAVE_PAR) THEN
                         J = PERM_RHS(J)
                       ENDIF
-                      IPOSRHSCOMP = id%POSINRHSCOMP_ROW(J)
-C                     IF ( (IPOSRHSCOMP.LE.NB_FS_RHSCOMP_F)
-C     &               .AND.(IPOSRHSCOMP.GT.0) ) THEN
-                      IF (IPOSRHSCOMP.GT.0)  THEN
+                      IPOSRHSINTR = id%GLOB2LOC_RHS(J)
+C                     IF ( (IPOSRHSINTR.LE.NB_FS_RHSINTR_F)
+C     &               .AND.(IPOSRHSINTR.GT.0) ) THEN
+                      IF (IPOSRHSINTR.GT.0)  THEN
 C                       Columns J corresponds to ej and thus to variable j
-C                       that is on my proc
-C                       Note that :
-C                       In first entry in column
-C                       we have and MUST have already scaled value of diagonal.
-C                       This need have been done on master because we do not
-C                       have scaling arrays available on slaves.
-C                       Furthermore we know that only one entry is
-C                       needed the diagonal entry (for the forward with A-1).
-C
-                        id%RHSCOMP(int(K-1,8)*int(LD_RHSCOMP,8)+
-     &                       int(IPOSRHSCOMP,8)) =
+C                       that is on my proc.
+C                       We know that only one entry is needed,
+C                       the diagonal entry (for the forward with A-1).
+C
+#if defined(USE_OLD_SCALING)
+                        id%RHSINTR(int(K-1,8)*int(id%LD_RHSINTR,8)+
+     &                       int(IPOSRHSINTR,8)) =
      &                       RHS_SPARSE_COPY(IPOS)
+#else
+                        IF (LSCAL) THEN
+                          id%RHSINTR(int(K-1,8)*int(id%LD_RHSINTR,8)+
+     &                    int(IPOSRHSINTR,8)) =
+     &                    SCALING_RHSINTR_FWD(IPOSRHSINTR)
+                        ELSE
+                          id%RHSINTR(int(K-1,8)*int(id%LD_RHSINTR,8)+
+     &                    int(IPOSRHSINTR,8)) = ONE
+                        ENDIF
+#endif
                       ENDIF               ! End of J on my proc
                       K = K + 1
                       IPOS = IPOS + COLSIZE  ! go to next column
@@ -3750,12 +4367,14 @@ C               -------
 C               --------------
 C               General sparse
 C               --------------
-C               -- reset to zero RHSCOMP for skipped columns (if any)
+C               -- At this point each process has a copy of the
+C               -- sparse RHS. We need to store it into RHSINTR.
+C               -- reset to zero RHSINTR for skipped columns (if any)
                 IF ((KEEP(221).EQ.1).AND.(NB_RHSSKIPPED.GT.0)
      &            .AND.I_AM_SLAVE) THEN
                   DO K = JBEG_RHS-NB_RHSSKIPPED, JBEG_RHS-1
-                    DO I = 1,  LD_RHSCOMP
-                      id%RHSCOMP(int(K-1,8)*int(LD_RHSCOMP,8)
+                    DO I = 1,  id%LD_RHSINTR
+                      id%RHSINTR(int(K-1,8)*int(id%LD_RHSINTR,8)
      &                           + int(I,8)) =  ZERO
                     ENDDO
                   ENDDO
@@ -3763,36 +4382,62 @@ C               -- reset to zero RHSCOMP
                 IF (I_AM_SLAVE) THEN
                   DO K = 1, NBCOL_INBLOC
 !                   it is equal to NBRHS_EFF in this case
-                    KDEC = int(K-1,8) * int(LD_RHSCOMP,8) +
-     &                     IBEG_RHSCOMP - 1_8
-                    id%RHSCOMP(KDEC+1_8:KDEC+NBENT_RHSCOMP) = ZERO
-                    DO IZ=IRHS_PTR_COPY(K), IRHS_PTR_COPY(K+1)-1
-                      I=IRHS_SPARSE_COPY(IZ)
-                      IPOSRHSCOMP = id%POSINRHSCOMP_ROW(I)
-C                     Since all fully summed variables mapped
-C                     on each proc are stored at the beginning
-C                     of RHSCOMP, we can compare to KEEP(89)
-C                     to know if RHSCOMP should be initialized
-C                     So far the tree has not been pruned to exploit
-C                     sparsity to compress RHSCOMP so we compare to
-C                     NB_FS_RHSCOMP_TOT
-                      IF ( (IPOSRHSCOMP.LE.NB_FS_RHSCOMP_TOT)
-     &                .AND.(IPOSRHSCOMP.GT.0) ) THEN
-C                        ! I is fully summed var mapped on my proc
-                        id%RHSCOMP(KDEC+IPOSRHSCOMP)=
-     &                  id%RHSCOMP(KDEC+IPOSRHSCOMP) +
-     &                  RHS_SPARSE_COPY(IZ)
-                      ENDIF
-                    ENDDO
+                    KDEC = int(K-1,8) * int(id%LD_RHSINTR,8) +
+     &                     IBEG_RHSINTR - 1_8
+                    id%RHSINTR(KDEC+1_8:KDEC+NBENT_RHSINTR) = ZERO
+#if ! defined(USE_OLD_SCALING)
+                    IF (LSCAL) THEN
+                      DO IZ=IRHS_PTR_COPY(K), IRHS_PTR_COPY(K+1)-1
+                        I=IRHS_SPARSE_COPY(IZ)
+                        IPOSRHSINTR = id%GLOB2LOC_RHS(I)
+C                       Since all fully summed variables mapped
+C                       on each proc are stored at the beginning
+C                       of RHSINTR, we can compare to KEEP(89)
+C                       to know if RHSINTR should be initialized
+C                       So far the tree has not been pruned to exploit
+C                       sparsity to compress RHSINTR so we compare to
+C                       NB_FS_RHSINTR_TOT
+                        IF ( (IPOSRHSINTR.LE.NB_FS_RHSINTR_TOT)
+     &                  .AND.(IPOSRHSINTR.GT.0) ) THEN
+C                          ! I is fully summed var mapped on my proc
+                          id%RHSINTR(KDEC+IPOSRHSINTR)=
+     &                    id%RHSINTR(KDEC+IPOSRHSINTR) +
+     &                    RHS_SPARSE_COPY(IZ)
+     &                    * SCALING_RHSINTR_FWD(IPOSRHSINTR)
+                        ENDIF
+                      ENDDO
+                    ELSE
+#endif
+                      DO IZ=IRHS_PTR_COPY(K), IRHS_PTR_COPY(K+1)-1
+                        I=IRHS_SPARSE_COPY(IZ)
+                        IPOSRHSINTR = id%GLOB2LOC_RHS(I)
+C                       Since all fully summed variables mapped
+C                       on each proc are stored at the beginning
+C                       of RHSINTR, we can compare to KEEP(89)
+C                       to know if RHSINTR should be initialized
+C                       So far the tree has not been pruned to exploit
+C                       sparsity to compress RHSINTR so we compare to
+C                       NB_FS_RHSINTR_TOT
+                        IF ( (IPOSRHSINTR.LE.NB_FS_RHSINTR_TOT)
+     &                  .AND.(IPOSRHSINTR.GT.0) ) THEN
+C                          ! I is fully summed var mapped on my proc
+                          id%RHSINTR(KDEC+IPOSRHSINTR)=
+     &                    id%RHSINTR(KDEC+IPOSRHSINTR) +
+     &                    RHS_SPARSE_COPY(IZ)
+                        ENDIF
+                      ENDDO
+#if ! defined(USE_OLD_SCALING)
+                    ENDIF
+#endif
                   ENDDO
                 END IF ! I_AM_SLAVE
               ENDIF ! KEEP(237)
             ENDIF  ! ==== KEEP(248)==1 =====
-C
+C}
         ELSE IF (I_AM_SLAVE) THEN
             ! I_AM_SLAVE AND (null space or Fwd in facto)
             IF (KEEP(111).NE.0) THEN
-C             -----------------------
+C{            -----------------------
 C             Null space computations
 C             -----------------------
 C
@@ -3889,10 +4534,10 @@ C ======================================
 C               End IF Exploit Sparsity
               ENDIF
 c
-C             Initialize RHSCOMP to 0  ! to be suppressed
+C             Initialize RHSINTR to 0  ! to be suppressed
               DO K=1, NBRHS_EFF
-                KDEC = int(K-1,8) * int(LD_RHSCOMP,8)
-                id%RHSCOMP(KDEC+1_8:KDEC+int(LD_RHSCOMP,8))=ZERO
+                KDEC = int(K-1,8) * int(id%LD_RHSINTR,8)
+                id%RHSINTR(KDEC+1_8:KDEC+int(id%LD_RHSINTR,8))=ZERO
               END DO
 C             Loop over the columns.
 C             Note that if ( KEEP(220)+KEEP(109)-1 < IBEG_GLOB_DEF
@@ -3907,18 +4552,18 @@ C               step incompatible, do on
      &               min(IEND_GLOB_DEF,KEEP(220)+KEEP(109)-1)
 C                 Local processor is concerned by I-th column of
 C                 global right-hand side.
-                  JJ= id%POSINRHSCOMP_ROW(id%PIVNUL_LIST(I-KEEP(220)+1))
+                  JJ= id%GLOB2LOC_RHS(id%PIVNUL_LIST(I-KEEP(220)+1))
                   IF (JJ.GT.0) THEN
                     IF (KEEP(50).EQ.0) THEN
                       ! unsymmetric : always set to fixation
-                      id%RHSCOMP( IBEG_RHSCOMP+
-     &                    int(I-IBEG_GLOB_DEF,8)*int(LD_RHSCOMP,8) +
+                      id%RHSINTR( IBEG_RHSINTR+
+     &                    int(I-IBEG_GLOB_DEF,8)*int(id%LD_RHSINTR,8)+
      &                    int(JJ-1,8) ) =
-     &                    cmplx(id%DKEEP(2),kind=kind(id%RHSCOMP))
+     &                    cmplx(id%DKEEP(2),kind=kind(id%RHSINTR))
                     ELSE
                       ! Symmetric: always set to one
-                      id%RHSCOMP( IBEG_RHSCOMP+
-     &                int(I-IBEG_GLOB_DEF,8)*int(LD_RHSCOMP,8)+
+                      id%RHSINTR( IBEG_RHSINTR+
+     &                int(I-IBEG_GLOB_DEF,8)*int(id%LD_RHSINTR,8)+
      &                int(JJ-1,8) )=
      &                ONE
                     ENDIF
@@ -3949,9 +4594,10 @@ C               for this set of right-ha
                 IEND_ROOT_DEF = -95999
                 IROOT_DEF_RHS_COL1= 1
               ENDIF
+C}
             ELSE  ! End of null space (test on KEEP(111))
 C             case of Fwd in facto
-C             id%RHSCOMP need not be initialized. It will be set on the fly
+C             id%RHSINTR need not be initialized. It will be set on the fly
 C             to zero for normal fully summed variables of the fronts and
 C             to -1 on the roots for the id%N+KEEP(253) variables added
 C             to the roots.
@@ -3990,7 +4636,7 @@ C             Otherwise, we use workspac
             LWCB8_SOL_C = LWCB8_SOL_C - LPTR_RHS_ROOT
           ENDIF
         ENDIF
-        IF (KEEP(221) .EQ. 2 ) THEN
+        IF (KEEP(221) .EQ. 2 .AND. KEEP(60).NE.0 ) THEN
 C         Copy/send REDRHS in PTR_RHS_ROOT
 C         (column by column if leading dimension LD_REDRHS
 C         of REDRHS is not equal to SIZE_ROOT).
@@ -4053,13 +4699,13 @@ C         -- other procs are not concern
           LIW_PASSED = max( LIW, 1 )
           LA_PASSED  = max( LA, 1_8 )
 C
-          IF ((id%KEEP(235).EQ.0).and.(id%KEEP(237).EQ.0) ) THEN
+          IF (Lnodes_FWD.EQ.-1 .AND. Lnodes_BWD.EQ.-1) THEN
 C
-C         --- Normal case : we do not exploit sparsity of the RHS
+C         --- Normal case : we do not exploit sparsity during
+C             foward and backward steps
 C
             FROM_PP = .FALSE.
             NBSPARSE_LOC = (DO_NBSPARSE.AND.NBRHS_EFF.GT.1)
-            PRUNED_SIZE_LOADED = 0_8  ! From CMUMPS_SOL_ES module
             CALL CMUMPS_SOL_C(id%root, id%N, id%S(1), LA_PASSED, IS(1),
      & LIW_PASSED, WORK_WCB(1), LWCB8_SOL_C, IWCB, LIWCB, NBRHS_EFF,
      & id%NA(1),id%LNA,id%NE_STEPS(1), SRW3, MTYPE, ICNTL(1), FROM_PP,
@@ -4070,10 +4716,15 @@ C
      & BUFR(1), LBUFR, LBUFR_BYTES, id%ISTEP_TO_INIV2(1),
      & id%TAB_POS_IN_PERE(1,1), IBEG_ROOT_DEF, IEND_ROOT_DEF,
      & IROOT_DEF_RHS_COL1, PTR_RHS_ROOT(1), LPTR_RHS_ROOT, SIZE_ROOT,
-     & MASTER_ROOT, id%RHSCOMP(IBEG_RHSCOMP), LD_RHSCOMP,
-     & id%POSINRHSCOMP_ROW(1), id%POSINRHSCOMP_COL(1)
+     & MASTER_ROOT, id%RHSINTR(IBEG_RHSINTR), id%LD_RHSINTR,
+     & id%GLOB2LOC_RHS(1), id%GLOB2LOC_SOL(1)
+     &  , -1, -1,
+     &  IDUMMY(1), IDUMMY(1)
      & , 1, 1, 1, 1, IDUMMY, 1, JDUMMY, KDUMMY, 1, LDUMMY, 1, MDUMMY
      & , 1, 1, NBSPARSE_LOC, PTR_RHS_BOUNDS(1), LPTR_RHS_BOUNDS
+#if defined(STAT_ES_SOLVE)
+     & , IDUMMY, 1, JDUMMY, 1
+#endif
      & , id%IPOOL_B_L0_OMP(1), id%LPOOL_B_L0_OMP, id%IPOOL_A_L0_OMP(1),
      & id%LPOOL_A_L0_OMP, id%L_VIRT_L0_OMP, id%VIRT_L0_OMP(1),
      & id%L_PHYS_L0_OMP, id%PHYS_L0_OMP(1), id%PERM_L0_OMP(1),
@@ -4095,12 +4746,18 @@ C
      & id%DKEEP(1),id%COMM_NODES,id%MYID,id%MYID_NODES,BUFR(1),LBUFR,
      & LBUFR_BYTES, id%ISTEP_TO_INIV2(1), id%TAB_POS_IN_PERE(1,1),
      & IBEG_ROOT_DEF,IEND_ROOT_DEF,IROOT_DEF_RHS_COL1,PTR_RHS_ROOT(1),
-     & LPTR_RHS_ROOT, SIZE_ROOT, MASTER_ROOT, id%RHSCOMP(IBEG_RHSCOMP),
-     & LD_RHSCOMP, id%POSINRHSCOMP_ROW(1), id%POSINRHSCOMP_COL(1),
+     & LPTR_RHS_ROOT, SIZE_ROOT, MASTER_ROOT, id%RHSINTR(IBEG_RHSINTR),
+     & id%LD_RHSINTR, id%GLOB2LOC_RHS(1), id%GLOB2LOC_SOL(1),
+     &  Lnodes_FWD, Lnodes_BWD,
+     &  nodes_FWD_PTR(1), nodes_BWD_PTR(1),
      & NZ_THIS_BLOCK, NBCOL_INBLOC, id%NRHS, JBEG_RHS, id%Step2node(1),
      & id%KEEP(28),IRHS_SPARSE_COPY(1),IRHS_PTR_COPY(1), size(PERM_RHS),
-     & PERM_RHS, size(UNS_PERM_INV), UNS_PERM_INV, NB_FS_RHSCOMP_F,
-     & NB_FS_RHSCOMP_TOT,NBSPARSE_LOC,PTR_RHS_BOUNDS(1),LPTR_RHS_BOUNDS
+     & PERM_RHS, size(UNS_PERM_INV), UNS_PERM_INV, NB_FS_RHSINTR_F,
+     & NB_FS_RHSINTR_TOT,NBSPARSE_LOC,PTR_RHS_BOUNDS(1),LPTR_RHS_BOUNDS
+#if defined(STAT_ES_SOLVE)
+     & ,idIPTR_WORKING(1),SIZE_IPTR_WORKING,idWORKING(1),SIZE_WORKING
+C     & ,id%IPTR_WORKING(1),SIZE_IPTR_WORKING,id%WORKING(1),SIZE_WORKING
+#endif
      & ,id%IPOOL_B_L0_OMP(1),id%LPOOL_B_L0_OMP,id%IPOOL_A_L0_OMP(1),
      & id%LPOOL_A_L0_OMP,id%L_VIRT_L0_OMP,id%VIRT_L0_OMP(1),
      & id%L_PHYS_L0_OMP, id%PHYS_L0_OMP(1), id%PERM_L0_OMP(1),
@@ -4139,7 +4796,8 @@ C       ================================
 C       ONLY FORWARD was performed (case of reduced RHS with Schur
 C                               option during factorisation)
 C       ======================================================
-        IF ( KEEP(221) .EQ. 1 ) THEN ! === Begin OF REDUCED RHS ======
+        IF ( (KEEP(60).NE.0) .AND. 
+     &       KEEP(221) .EQ. 1 ) THEN ! === Begin OF REDUCED RHS ======
 C         --------------------------------------
 C         Send (or copy) reduced RHS from PTR_RHS_ROOT located on
 C         MASTER_ROOT_IN_COMM to REDRHS located on MASTER (host node).
@@ -4199,14 +4857,14 @@ C               -- send all in on shot
             ENDIF
 C         -- other procs are not concerned
           ENDIF
-        ENDIF ! ====== END OF REDUCED RHS (Fwd only performed) ======
+        ENDIF ! ===== END OF REDUCED RHS (Schur+Fwd only performed) ==
 C       =======================================================
 C       BACKWARD was PERFORMED
 C       Postprocess solution that is distributed
         IF ( KEEP(221) .NE. 1 ) THEN  ! BACKWARD was PERFORMED
 C       -- KEEP(221).NE.1 => we are sure that backward has been performed
           IF (ICNTL21 == 0) THEN ! CENTRALIZED SOLUTION
-C           ========================================================
+C{          ========================================================
 C           GATHER SOLUTION computed during bwd
 C           Each proc holds the pieces of solution corresponding
 C           to all fully summed variables mapped on that processor
@@ -4250,8 +4908,9 @@ C           Propagate errors
      &                       id%COMM,id%MYID)
 C           Return in case of error.
             IF (INFO(1).LT.0) GO TO 90
+#if defined(USE_OLD_SCALING)
             IF ((id%MYID.NE.MASTER).OR. .NOT.LSCAL) THEN
-             PT_SCALING => Dummy_SCAL
+              PT_SCALING => Dummy_SCAL
             ELSE
               IF (MTYPE.EQ.1) THEN
                 PT_SCALING => id%COLSCA
@@ -4259,11 +4918,12 @@ C           Return in case of error.
                 PT_SCALING => id%ROWSCA
               ENDIF
             ENDIF
+#endif
             LIW_PASSED = max( LIW, 1 )
             TIMEGATHER1=MPI_WTIME()
             IF ( .NOT.I_AM_SLAVE ) THEN
 C             I did not participate to computing part of the solution
-C             (id%RHSCOMP not set/allocate) : receive solution, store
+C             (id%RHSINTR not set/allocate) : receive solution, store
 C             it and scale it.
               IF (KEEP(237).EQ.0) THEN
 C               We need a workspace of minimal size KEEP(247)
@@ -4274,8 +4934,12 @@ C               in order to unpack piece
      &              JDUMMY, id%KEEP(1), id%KEEP8(1),
      &              id%PROCNODE_STEPS(1), IDUMMY, 1,
      &              id%STEP(1), BUFR(1), LBUFR, LBUFR_BYTES,
-     &              CWORK(1), LCWORK,
-     &              LSCAL, PT_SCALING(1), size(PT_SCALING),
+     &              CWORK(1), LCWORK, LSCAL,
+#if defined(USE_OLD_SCALING)
+     &              PT_SCALING(1), size(PT_SCALING),
+#else
+     &              SCALING_LOC_BWD(1), size(SCALING_LOC_BWD),
+#endif
      &              C_DUMMY, 1 , 1, IDUMMY, 1,
      &              PERM_RHS, size(PERM_RHS) ! for sparse permuted RHS
      &              )
@@ -4285,7 +4949,12 @@ C               only gather target entri
      &              id%MYID, id%COMM, NBRHS_EFF,
      &              C_DUMMY, 1, 1,
      &              id%KEEP(1), BUFR(1), LBUFR, LBUFR_BYTES,
+#if defined(USE_OLD_SCALING)
      &              LSCAL, PT_SCALING(1), size(PT_SCALING)
+#else
+     &              LSCAL, SCALING_RHSINTR_BWD(1),
+     &              size(SCALING_RHSINTR_BWD)
+#endif
 C                   --- A-1 related entries
      &             ,IRHS_PTR_COPY(1), size(IRHS_PTR_COPY),
      &              IRHS_SPARSE_COPY(1), size(IRHS_SPARSE_COPY),
@@ -4316,23 +4985,31 @@ C             compilers would do otherwi
      &          id%PROCNODE_STEPS(1), IS(1), LIW_PASSED,
      &          id%STEP(1), BUFR(1), LBUFR, LBUFR_BYTES,
      &          CWORK(1), LCWORK,
+#if defined(USE_OLD_SCALING)
      &          LSCAL, PT_SCALING(1), size(PT_SCALING),
-     &          id%RHSCOMP(IBEG_RHSCOMP), LD_RHSCOMP, NBRHS_EFF,
-     &          id%POSINRHSCOMP_COL(1), id%N,
+#else
+     &          LSCAL, SCALING_LOC_BWD(1), size(SCALING_LOC_BWD),
+#endif
+     &          id%RHSINTR(IBEG_RHSINTR), id%LD_RHSINTR, NBRHS_EFF,
+     &          id%GLOB2LOC_SOL(1), id%N,
      &          PERM_RHS, size(PERM_RHS) ! For sparse permuted RHS
      &          )
               ELSE ! only gather target entries of A-1
                 CALL CMUMPS_GATHER_SOLUTION_AM1(id%NSLAVES,id%N,
      &          id%MYID, id%COMM, NBRHS_EFF,
-     &          id%RHSCOMP(IBEG_RHSCOMP), LD_RHSCOMP, NBRHS_EFF,
+     &          id%RHSINTR(IBEG_RHSINTR), id%LD_RHSINTR, NBRHS_EFF,
      &          id%KEEP(1), BUFR(1), LBUFR, LBUFR_BYTES,
+#if defined(USE_OLD_SCALING)
      &          LSCAL, PT_SCALING(1), size(PT_SCALING)
+#else
+     &          LSCAL, SCALING_RHSINTR_BWD(1), size(SCALING_RHSINTR_BWD)
+#endif
 C               --- A-1 related entries
      &          , IRHS_PTR_COPY(1), size(IRHS_PTR_COPY),
      &          IRHS_SPARSE_COPY(1), size(IRHS_SPARSE_COPY),
      &          RHS_SPARSE_COPY(1), size(RHS_SPARSE_COPY),
      &          UNS_PERM_INV, size(UNS_PERM_INV),
-     &          id%POSINRHSCOMP_COL(1), id%N, NB_FS_RHSCOMP_TOT
+     &          id%GLOB2LOC_SOL(1), id%N, NB_FS_RHSINTR_TOT
      &          )
               ENDIF
             ENDIF
@@ -4379,32 +5056,46 @@ C                 IZ - Column index in S
               ENDIF
             ENDIF             ! end A-1 on master
 C
-C         -- END of backward was performed with centralized solution
+C}        -- END of backward was performed with centralized solution
           ELSE   ! (KEEP(221).NE.1) .AND.(ICNTL21.NE.0))
 C
 C           BEGIN of backward performed with distributed solution
 C           time local copy + scaling
             TIMECOPYSCALE1=MPI_WTIME()
-C           The non working host should not do this:
-            IF ( I_AM_SLAVE ) THEN
-              LIW_PASSED = max( LIW, 1 )
-C             Only called if more than 1 pivot
-C             was eliminated by the processor.
-C             Note that LSOL_loc >= KEEP(89)
-              IF ( KEEP(89) .GT. 0 ) THEN
-                CALL CMUMPS_DISTRIBUTED_SOLUTION(id%NSLAVES,
-     &          id%N,id%MYID_NODES,
-     &          MTYPE, id%RHSCOMP(IBEG_RHSCOMP), LD_RHSCOMP,
-     &          NBRHS_EFF, id%POSINRHSCOMP_COL(1),
-     &          id%ISOL_loc(1), id%SOL_loc(1), id%NRHS,
-     &          JBEG_RHS-NB_RHSSKIPPED, id%LSOL_loc,
-     &          id%PTLUST_S(1), id%PROCNODE_STEPS(1),
-     &          id%KEEP(1),id%KEEP8(1),
-     &          IS(1), LIW_PASSED,
-     &          id%STEP(1), scaling_data_sol, LSCAL, NB_RHSSKIPPED,
-     &          PERM_RHS, size(PERM_RHS) ) ! For permuted sparse RHS
+C             The non working host should not do this:
+              IF ( I_AM_SLAVE ) THEN
+                LIW_PASSED = max( LIW, 1 )
+C               Only called if more than 1 pivot
+C               was eliminated by the processor.
+C               Note that LSOL_loc >= KEEP(89)
+                IF ( KEEP(89) .GT. 0 ) THEN
+            IF ( LSCAL .AND. id%KEEP(89).GT.0) THEN
+#if defined(USE_OLD_SCALING)
+              SCALING_LOC_BWD => scaling_data_sol%SCALING_LOC
+#else
+              IF (MTYPE.EQ.1) THEN
+                SCALING_LOC_BWD => id%COLSCA_loc
+              ELSE
+                SCALING_LOC_BWD => id%ROWSCA_loc
               ENDIF
+#endif
+            ELSE
+              SCALING_LOC_BWD => RDUMMY_TARGET
             ENDIF
+                  CALL CMUMPS_DISTRIBUTED_SOLUTION(id%NSLAVES,
+     &            id%N,id%MYID_NODES,
+     &            MTYPE, id%RHSINTR(IBEG_RHSINTR), id%LD_RHSINTR,
+     &            NBRHS_EFF, id%GLOB2LOC_SOL(1),
+     &            id%ISOL_loc(1), id%SOL_loc(1), id%NRHS,
+     &            JBEG_RHS-NB_RHSSKIPPED, id%LSOL_loc,
+     &            id%PTLUST_S(1), id%PROCNODE_STEPS(1),
+     &            id%KEEP(1),id%KEEP8(1),
+     &            IS(1), LIW_PASSED, id%STEP(1),
+     &            SCALING_LOC_BWD(1), size(SCALING_LOC_BWD),
+     &            LSCAL, NB_RHSSKIPPED,
+     &            PERM_RHS, size(PERM_RHS) ) ! For permuted sparse RHS
+                ENDIF
+              ENDIF
             TIMECOPYSCALE2=MPI_WTIME()-TIMECOPYSCALE1+TIMECOPYSCALE2
           ENDIF
 C         === BACKWARD was PERFORMED WITH DISTRIBUTED SOLUTION ===
@@ -4425,7 +5116,7 @@ C         Multiple RHS: apply a fixed nu
 C         of iterative refinement steps
 C         ----------------------------------
 C         DO I = 1, ICNTL10
-            write(6,*) ' Internal ERROR 15 in sol_driver '
+            write(6,*) ' Internal error 15 in sol_driver '
 C           Compute residual:  Y <- SAVERHS - A * RHS
 C           Solve RHS <- A^-1 Y, Y modified
 C           Assemble in RHS(REDUCE)
@@ -4433,7 +5124,7 @@ C           RHS <- RHS + Y
 C         END DO
         END IF
         IF (POSTPros) THEN
-C
+C{
 C         SAVERHS holds the original right hand side
 C         Sparse rhs are saved in SAVERHS as dense rhs
 C
@@ -5097,7 +5788,7 @@ C             We have used D only for LC
           DEALLOCATE(C_Y)
           DEALLOCATE(R_LOCWK54)
           DEALLOCATE(C_LOCWK54)
-C End POSTPros
+C} End POSTPros
         END IF
 C============================================
 C
@@ -5164,9 +5855,9 @@ C  ========================
 *         print out the solution
           IF ( INFO(1) .GE. 0 .AND. ICNTL(4).GE.3 .AND. ICNTL(3).GT.0)
      &    THEN
-            K = min0(10, id%N)
+            K = min(10, id%N)
             IF (ICNTL(4) .eq. 4 ) K = id%N
-            J = min0(10,NBRHS_EFF)
+            J = min(10,NBRHS_EFF)
             IF (ICNTL(4) .eq. 4 ) J = NBRHS_EFF
             DO II=1, J
               WRITE(ICNTL(3),110) BEG_RHS+II-1
@@ -5190,9 +5881,6 @@ C     }
       ENDDO
 C     END DO WHILE (BEG_RHS.LE.id%NRHS)
 C     =================================
-      IF (KEEP(400) .GT. 0) THEN
-        CALL CMUMPS_SOL_L0OMP_LD(KEEP(400))
-      ENDIF
 C
 C     ========================================================
 C     Reset RHS to zero for all remaining columns that
@@ -5226,14 +5914,14 @@ C     ==================================
       ENDIF
 C     ========================================================
 C     Reset id%SOL_loc to zero for all remaining columns that
-C     have not been processed because they were emtpy
+C     have not been processed because they were empty
 C     ========================================================
       IF ( I_AM_SLAVE .AND. (ICNTL21.NE.0) .AND.
      &      ( JEND_RHS .LT. id%NRHS ) .AND. KEEP(221).NE.1 ) THEN
         JBEG_NEW = JEND_RHS + 1
         IF (DO_PERMUTE_RHS.OR.INTERLEAVE_PAR) THEN
            DO WHILE ( JBEG_NEW.LE. id%NRHS)
-              DO I=1, KEEP(89)
+              DO I=1, NSOL_loc
                  id%SOL_loc(int(PERM_RHS(JBEG_NEW) -1,8)*
      &                      int(id%LSOL_loc,8)+int(I,8)) = ZERO
               ENDDO
@@ -5242,7 +5930,7 @@ C     ==================================
         ELSE
 C
            DO WHILE ( JBEG_NEW.LE. id%NRHS)
-            DO I=1, KEEP(89)
+            DO I=1, NSOL_loc
                 id%SOL_loc((JBEG_NEW -1)*id%LSOL_loc + I) = ZERO
             ENDDO
             JBEG_NEW = JBEG_NEW +1
@@ -5251,7 +5939,7 @@ C
       ENDIF
 C
 C     ================================================================
-C     Reset id%RHSCOMP and id%REDRHS to zero for all remaining columns
+C     Reset id%RHSINTR and id%REDRHS to zero for all remaining columns
 C     that have not been processed because they were emtpy
 C     ================================================================
       IF ((KEEP(221).EQ.1) .AND.
@@ -5269,8 +5957,8 @@ C     ==================================
        IF (I_AM_SLAVE) THEN
            JBEG_NEW = JEND_RHS + 1
            DO WHILE ( JBEG_NEW.LE. id%NRHS)
-            DO I=1,NBENT_RHSCOMP
-              id%RHSCOMP(int(JBEG_NEW -1,8)*int(LD_RHSCOMP,8) +
+            DO I=1,NBENT_RHSINTR
+              id%RHSINTR(int(JBEG_NEW -1,8)*int(id%LD_RHSINTR,8) +
      &                   int(I,8)) =  ZERO
             ENDDO
             JBEG_NEW = JBEG_NEW +1
@@ -5362,9 +6050,43 @@ C
         WRITE( MP, 431 ) id%DKEEP(122)
       END IF
  90   CONTINUE
+      IF (KEEP(400) .GT. 0) THEN
+        CALL CMUMPS_SOL_L0OMP_LD(KEEP(400))
+      ENDIF
       IF (INFO(1) .LT.0 ) THEN
          IF (INFO(1) .EQ. -80) INFO(1) = -81
       ENDIF
+C     -- related to exploit sparsity
+       IF (associated(nodes_FWD)) THEN 
+        NB_BYTES = NB_BYTES - size(nodes_FWD) * K34_8
+        DEALLOCATE(nodes_FWD)
+        NULLIFY(nodes_FWD)
+       ENDIF
+       IF (associated(nodes_BWD)) THEN 
+        NB_BYTES = NB_BYTES - size(nodes_BWD) * K34_8
+        DEALLOCATE(nodes_BWD)
+        NULLIFY(nodes_BWD)
+       ENDIF
+       IF (allocated(Pruned_Sons_FWD)) THEN 
+        NB_BYTES = NB_BYTES - size(Pruned_Sons_FWD) * K34_8
+        DEALLOCATE(Pruned_Sons_FWD)
+       ENDIF
+       IF (allocated(Pruned_Sons_BWD)) THEN 
+        NB_BYTES = NB_BYTES - size(Pruned_Sons_BWD) * K34_8
+        DEALLOCATE(Pruned_Sons_BWD)
+       ENDIF
+      IF (SCALING_RHSINTR_FWD_ALLOCATED) THEN
+        NB_BYTES = NB_BYTES - LSCALING_RHSINTR_FWD * K16_8
+        DEALLOCATE(SCALING_RHSINTR_FWD)
+      ENDIF
+      SCALING_RHSINTR_FWD_ALLOCATED = .FALSE.
+      NULLIFY(SCALING_RHSINTR_FWD)
+      IF (SCALING_RHSINTR_BWD_ALLOCATED) THEN
+        NB_BYTES = NB_BYTES - LSCALING_RHSINTR_BWD * K16_8
+        DEALLOCATE(SCALING_RHSINTR_BWD)
+      ENDIF
+      SCALING_RHSINTR_BWD_ALLOCATED = .FALSE.
+      NULLIFY(SCALING_RHSINTR_BWD)
       IF (KEEP(485) .EQ. 1) THEN
         KEEP(350) = KEEP350_SAVE
         IF (IS_LR_MOD_TO_STRUC_DONE) THEN
@@ -5421,12 +6143,16 @@ C       Free space and reset pointers if
          NULLIFY(IRHS_loc_PTR)
          IRHS_loc_PTR_ALLOCATED = .FALSE.
        ENDIF
+#if defined(USE_OLD_SCALING)
        IF (I_AM_SLAVE.AND.LSCAL.AND.KEEP(248).EQ.-1) THEN
-         NB_BYTES = NB_BYTES -
-     &   int(size(scaling_data_dr%SCALING_LOC),8)*K16_8
-         DEALLOCATE(scaling_data_dr%SCALING_LOC)
-         NULLIFY   (scaling_data_dr%SCALING_LOC)
+         IF (associated(scaling_data_dr%SCALING_LOC)) THEN
+           NB_BYTES = NB_BYTES -
+     &     int(size(scaling_data_dr%SCALING_LOC),8)*K16_8
+           DEALLOCATE(scaling_data_dr%SCALING_LOC)
+           NULLIFY   (scaling_data_dr%SCALING_LOC)
+         ENDIF
        ENDIF
+#endif
       IF (allocated(PERM_RHS)) THEN
         NB_BYTES = NB_BYTES - int(size(PERM_RHS),8)*K34_8
         DEALLOCATE(PERM_RHS)
@@ -5498,13 +6224,19 @@ C       Deallocate temporary workspace S
           NB_BYTES = NB_BYTES - int(size(SRW3),8)*K35_8
           DEALLOCATE(SRW3)
         ENDIF
-        IF (LSCAL .AND. ICNTL21==1) THEN
-C         Free local scaling arrays
-          NB_BYTES = NB_BYTES -
-     &              int(size(scaling_data_sol%SCALING_LOC),8)*K16_8
-          DEALLOCATE(scaling_data_sol%SCALING_LOC)
-          NULLIFY(scaling_data_sol%SCALING_LOC)
+#if defined(USE_OLD_SCALING)
+C       Free local scaling arrays
+        IF (LSCAL .AND. ICNTL21 .NE. 0) THEN
+          IF (associated(scaling_data_sol%SCALING_LOC)) THEN
+            NB_BYTES = NB_BYTES -
+     &                 int(size(scaling_data_sol%SCALING_LOC),8)*K16_8
+            DEALLOCATE(scaling_data_sol%SCALING_LOC)
+            NULLIFY(scaling_data_sol%SCALING_LOC)
+          ENDIF
         ENDIF
+#endif
+#if defined(USE_OLD_SCALING)
+#endif
 C       Free memory until next call to CMUMPS
         IF (WK_USER_PROVIDED) THEN
 C         S points to WK_USER provided by user
@@ -5528,28 +6260,30 @@ C         at the beginning of the solve,
           NB_BYTES  = NB_BYTES - KEEP8(23) * K35_8
           KEEP8(23) = 0_8
         ENDIF
-        IF (KEEP(221).NE.1) THEN
+        IF (KEEP(221).NE.1
+     &     ) THEN
 C       -- After reduction of RHS to Schur variables
 C       -- keep compressed RHS generated during FWD step
 C       -- to be used for future expansion
-         IF (associated(id%RHSCOMP)) THEN
+         IF (associated(id%RHSINTR)) THEN
             NB_BYTES = NB_BYTES - id%KEEP8(25)*K35_8
-            DEALLOCATE(id%RHSCOMP)
-            NULLIFY(id%RHSCOMP)
-            id%KEEP8(25)=0_8
+            DEALLOCATE(id%RHSINTR)
+            NULLIFY(id%RHSINTR)
+            id%KEEP8(25)  = 0_8
+            id%LD_RHSINTR = 0
          ENDIF
-         IF (associated(id%POSINRHSCOMP_ROW)) THEN
+         IF (associated(id%GLOB2LOC_RHS)) THEN
             NB_BYTES = NB_BYTES -
-     &                 int(size(id%POSINRHSCOMP_ROW),8)*K34_8
-            DEALLOCATE(id%POSINRHSCOMP_ROW)
-            NULLIFY(id%POSINRHSCOMP_ROW)
+     &                 int(size(id%GLOB2LOC_RHS),8)*K34_8
+            DEALLOCATE(id%GLOB2LOC_RHS)
+            NULLIFY(id%GLOB2LOC_RHS)
          ENDIF
-         IF (id%POSINRHSCOMP_COL_ALLOC) THEN
+         IF (id%GLOB2LOC_SOL_ALLOC) THEN
             NB_BYTES = NB_BYTES -
-     &                 int(size(id%POSINRHSCOMP_COL),8)*K34_8
-            DEALLOCATE(id%POSINRHSCOMP_COL)
-            NULLIFY(id%POSINRHSCOMP_COL)
-            id%POSINRHSCOMP_COL_ALLOC = .FALSE.
+     &                 int(size(id%GLOB2LOC_SOL),8)*K34_8
+            DEALLOCATE(id%GLOB2LOC_SOL)
+            NULLIFY(id%GLOB2LOC_SOL)
+            id%GLOB2LOC_SOL_ALLOC = .FALSE.
          ENDIF
         ENDIF
         IF ( WORK_WCB_ALLOCATED ) THEN
@@ -5560,6 +6294,23 @@ C       Otherwise, WORK_WCB may point to
 C       position inside id%S, nullify it
         NULLIFY( WORK_WCB )
       ENDIF
+#if defined(STAT_ES_SOLVE)
+      IF (
+     & (id%MYID.EQ.MASTER).AND.
+     & ( (id%KEEP(235).NE.0).OR.(id%KEEP(212).NE.0) )
+     &   )
+     & THEN
+C       If exploit sparsity then
+C       stats saved in DKEEP(200:204) and
+C       set RINFOG(24), RINFOG(25), RINFOG(26)
+        CALL CMUMPS_SOL_ES_PRINT_STATS( 
+     &      id%KEEP(212), id%KEEP(235), id%KEEP(237),
+     &      id%KEEP(485), id%KEEP(497), 
+     &      id%KEEP8(110),id%NRHS, id%ICNTL(27), id%N, 
+     &      id%KEEP(50), id%DKEEP(200:204),
+     &      id%RINFOG(24:28), MPG)
+      END IF
+#endif
  500  CONTINUE
       RETURN
  55   FORMAT (//' ERROR ANALYSIS BEFORE ITERATIVE REFINEMENT')
@@ -5572,7 +6323,7 @@ C       position inside id%S, nullify it
  437  FORMAT('  .. Time in ScaLAPACK root       =   ',F15.6)
  436  FORMAT('  .. Time in backward (bwd) step  =   ',F15.6)
  433  FORMAT(' Time to gather solution(cent.sol)=',F15.6)
- 431  FORMAT(' Time to copy/scale dist. solution=',F15.6)
+ 431  FORMAT(' Time for distributed solution    =',F15.6)
  150  FORMAT(' GLOBAL STATISTICS PRIOR SOLVE PHASE ...........'/
      &        ' Number of right-hand-sides                    =',I12/
      &        ' Blocking factor for multiple rhs              =',I12/
@@ -5582,7 +6333,8 @@ C       position inside id%S, nullify it
      &        '  --- (20)                                     =',I12/
      &        '  --- (21)                                     =',I12/
      &        '  --- (30)                                     =',I12/
-     &        '  --- (35)                                     =',I12
+     &        '  --- (35)                                     =',I12/
+     &        '  --- (48) (effective)                         =',I12
      &        )
  151  FORMAT ('  --- (25)                                     =',I12)
  152  FORMAT ('  --- (26)                                     =',I12)
@@ -5601,6 +6353,7 @@ C       position inside id%S, nullify it
      &       NRHS,
      &       idIRHS_loc,
      &       idRHS_loc,
+     &       I_AM_SLAVE,
      &       INFO)
 C
 C  Purpose:
@@ -5619,6 +6372,7 @@ C
         INTEGER, INTENT( IN ) :: idNloc_RHS
         INTEGER, INTENT( IN ) :: idLRHS_loc
         INTEGER, INTENT( IN ) :: NRHS
+        LOGICAL, INTENT( IN ) :: I_AM_SLAVE
 #if defined(MUMPS_NOF2003)
         INTEGER, POINTER :: idIRHS_loc (:)
         COMPLEX, POINTER :: idRHS_loc  (:)
@@ -5638,6 +6392,14 @@ C  =====================
 C
 C       Quick return if nothing on this proc
         IF (idNloc_RHS .LE. 0) RETURN
+        IF (idNloc_RHS .GT. 0 .AND. .NOT. I_AM_SLAVE) THEN
+C         Nloc_RHS should not be greater than 0
+C         on a non working host because the distribution
+C         of the RHS does not include the non working host.
+          INFO(1)=-55
+          INFO(2)=-idLRHS_loc
+          RETURN
+        ENDIF
 C       Check for leading dimension
         IF (NRHS.NE.1) THEN
           IF ( idLRHS_loc .LT. idNloc_RHS) THEN
@@ -5716,6 +6478,7 @@ C         We force SOLVET to have value
 C         to be able to test both values, and also, be able to
 C         test whether SOLVET = MTYPE or not.
           IF ( SOLVET.EQ.2 ) SOLVET = 0
+#if defined(USE_OLD_SCALING)
           IF ( LSCAL ) THEN
             IF ( SOLVET .EQ. 1 ) THEN
 C             Apply rowscaling
@@ -5729,19 +6492,31 @@ C             Apply column scaling
               END DO
             END IF
           END IF
+#endif
         END IF ! MYID.EQ.MASTER
 C       ------------------------------
 C       Broadcast SOLVET to the slaves
 C       ------------------------------
         CALL MPI_BCAST( SOLVET, 1, MPI_INTEGER, MASTER,
      &                  id%COMM, IERR)
+#if ! defined(USE_OLD_SCALING)
+        IF (LSCAL .AND. id%KEEP(89) .GT. 0) THEN
+          IF (SOLVET .EQ. 1) THEN
+            SCALING_LOC_FWD => id%ROWSCA_LOC
+          ELSE
+            SCALING_LOC_FWD => id%COLSCA_LOC
+          ENDIF
+        ELSE
+            SCALING_LOC_FWD => RDUMMY_TARGET
+        ENDIF
+#endif
 C       --------------------------------------------
 C       Scatter the right hand side C_Y on all procs
 C       --------------------------------------------
         IF ( .NOT.I_AM_SLAVE ) THEN
 C         -- Master not working
           CALL CMUMPS_SCATTER_RHS(id%NSLAVES,id%N, id%MYID,
-     &      id%COMM,
+     &      id%COMM, LSCAL, SCALING_LOC_FWD(1),
      &      SOLVET, C_Y(1), id%N, 1,
      &      1,
      &      C_DUMMY, 1, 1,
@@ -5752,21 +6527,21 @@ C         -- Master not working
      &      id%ICNTL(1),id%INFO(1))
         ELSE
           IF (SOLVET.EQ.MTYPE) THEN
-C           POSINRHSCOMP_ROW is with respect to the
+C           GLOB2LOC_RHS is with respect to the
 C           original linear system (transposed or not)
-            PTR_POSINRHSCOMP_FWD => id%POSINRHSCOMP_ROW
+            PTR_POSINRHSINTR_FWD => id%GLOB2LOC_RHS
           ELSE
 C           Transposed, use column indices of original
 C           system (ie, col indices of A or A^T)
-            PTR_POSINRHSCOMP_FWD => id%POSINRHSCOMP_COL
+            PTR_POSINRHSINTR_FWD => id%GLOB2LOC_SOL
           ENDIF
           LIW_PASSED = max( LIW, 1 )
           CALL CMUMPS_SCATTER_RHS(id%NSLAVES,id%N, id%MYID,
-     &      id%COMM,
+     &      id%COMM, LSCAL, SCALING_LOC_FWD(1),
      &      SOLVET,  C_Y(1), id%N, 1,
      &      1,
-     &      id%RHSCOMP(IBEG_RHSCOMP), LD_RHSCOMP, 1,
-     &      PTR_POSINRHSCOMP_FWD(1), NB_FS_RHSCOMP_F,
+     &      id%RHSINTR(IBEG_RHSINTR), id%LD_RHSINTR, 1,
+     &      PTR_POSINRHSINTR_FWD(1), NB_FS_RHSINTR_F,
 C
      &      id%PTLUST_S(1), id%KEEP(1), id%KEEP8(1),
      &      id%PROCNODE_STEPS(1),
@@ -5782,11 +6557,11 @@ C
           LIW_PASSED = max( LIW, 1 )
           LA_PASSED = max( LA, 1_8 )
           IF (SOLVET.EQ.MTYPE) THEN
-            PTR_POSINRHSCOMP_FWD => id%POSINRHSCOMP_ROW
-            PTR_POSINRHSCOMP_BWD => id%POSINRHSCOMP_COL
+            PTR_POSINRHSINTR_FWD => id%GLOB2LOC_RHS
+            PTR_POSINRHSINTR_BWD => id%GLOB2LOC_SOL
           ELSE
-            PTR_POSINRHSCOMP_FWD => id%POSINRHSCOMP_COL
-            PTR_POSINRHSCOMP_BWD => id%POSINRHSCOMP_ROW
+            PTR_POSINRHSINTR_FWD => id%GLOB2LOC_SOL
+            PTR_POSINRHSINTR_BWD => id%GLOB2LOC_RHS
           ENDIF
           FROM_PP=.TRUE.
           NBSPARSE_LOC = .FALSE.
@@ -5800,10 +6575,15 @@ C
      & LBUFR_BYTES, id%ISTEP_TO_INIV2(1), id%TAB_POS_IN_PERE(1,1),
 C      Next 3 arguments are not used in this call
      & IBEG_ROOT_DEF,IEND_ROOT_DEF,IROOT_DEF_RHS_COL1, PTR_RHS_ROOT(1),
-     & LPTR_RHS_ROOT, SIZE_ROOT, MASTER_ROOT, id%RHSCOMP(IBEG_RHSCOMP),
-     & LD_RHSCOMP,PTR_POSINRHSCOMP_FWD(1),PTR_POSINRHSCOMP_BWD(1),
+     & LPTR_RHS_ROOT, SIZE_ROOT, MASTER_ROOT, id%RHSINTR(IBEG_RHSINTR),
+     & id%LD_RHSINTR,PTR_POSINRHSINTR_FWD(1),PTR_POSINRHSINTR_BWD(1),
+     & -1, -1,
+     & IDUMMY(1), IDUMMY(1),
      & 1,1,1,1, IDUMMY, 1, JDUMMY, KDUMMY, 1, LDUMMY, 1, MDUMMY, 1,1,
      & NBSPARSE_LOC, PTR_RHS_BOUNDS(1), LPTR_RHS_BOUNDS
+#if defined(STAT_ES_SOLVE)
+     & , IDUMMY, 1, JDUMMY, 1
+#endif
      & , id%IPOOL_B_L0_OMP(1), id%LPOOL_B_L0_OMP, id%IPOOL_A_L0_OMP(1),
      & id%LPOOL_A_L0_OMP, id%L_VIRT_L0_OMP, id%VIRT_L0_OMP(1),
      & id%L_PHYS_L0_OMP, id%PHYS_L0_OMP(1), id%PERM_L0_OMP(1),
@@ -5847,6 +6627,7 @@ C       then necessarily NBRHS_EFF = 1)
 C
 C       === GATHER and SCALE solution ==============
 C
+#if defined(USE_OLD_SCALING)
         IF ((id%MYID.NE.MASTER).OR. .NOT.LSCAL) THEN
           PT_SCALING => Dummy_SCAL
         ELSE
@@ -5856,12 +6637,23 @@ C
             PT_SCALING => id%ROWSCA
           ENDIF
         ENDIF
+#else
+        IF (id%KEEP(89) .EQ. 0 .OR. .NOT. LSCAL) THEN
+          SCALING_LOC_BWD => RDUMMY_TARGET
+        ELSE
+          IF (SOLVET.EQ.1) THEN
+            SCALING_LOC_BWD => id%COLSCA_loc
+          ELSE
+            SCALING_LOC_BWD => id%ROWSCA_loc
+          ENDIF
+        ENDIF
+#endif
         LIW_PASSED = max( LIW, 1 )
 C       Solution computed during CMUMPS_SOL_C has been stored
-C       in id%RHSCOMP and is gathered on the master in C_Y
+C       in id%RHSINTR and is gathered on the master in C_Y
         IF ( .NOT. I_AM_SLAVE ) THEN
 C         I did not participate to computing part of the solution
-C         (id%RHSCOMP not set/allocate) : receive solution, store
+C         (id%RHSINTR not set/allocate) : receive solution, store
 C         it and scale it.
           CALL CMUMPS_GATHER_SOLUTION(id%NSLAVES,id%N,
      &      id%MYID, id%COMM, NBRHS_EFF,
@@ -5870,8 +6662,12 @@ C         it and scale it.
      &      IDUMMY, 1,
      &      id%STEP(1), BUFR(1), LBUFR, LBUFR_BYTES,
      &      CWORK(1), size(CWORK),
+#if defined(USE_OLD_SCALING)
      &      LSCAL, PT_SCALING(1), size(PT_SCALING),
-!     RHSCOMP not on non-working master
+#else
+     &      LSCAL, SCALING_LOC_BWD(1), size(SCALING_LOC_BWD),
+#endif
+!     RHSINTR not on non-working master
      &      C_DUMMY, 1 , 1, IDUMMY, 1,
 !     for sparse permuted RHS on host
      &      PERM_RHS, size(PERM_RHS)
@@ -5885,9 +6681,13 @@ C         it and scale it.
      &      IS(1), LIW_PASSED,
      &      id%STEP(1), BUFR(1), LBUFR, LBUFR_BYTES,
      &      CWORK(1), size(CWORK),
+#if defined(USE_OLD_SCALING)
      &      LSCAL, PT_SCALING(1), size(PT_SCALING),
-     &      id%RHSCOMP(IBEG_RHSCOMP), LD_RHSCOMP, NBRHS_EFF,
-     &      PTR_POSINRHSCOMP_BWD(1), id%N,
+#else
+     &      LSCAL, SCALING_LOC_BWD(1), size(SCALING_LOC_BWD),
+#endif
+     &      id%RHSINTR(IBEG_RHSINTR), id%LD_RHSINTR, NBRHS_EFF,
+     &      PTR_POSINRHSINTR_BWD(1), id%N,
      &      PERM_RHS, size(PERM_RHS)) ! for sparse permuted RHS on host
         ENDIF
         DEALLOCATE( CWORK )
diff -pruN 5.6.2-2.1/src/csol_fwd.F 5.7.1-1/src/csol_fwd.F
--- 5.6.2-2.1/src/csol_fwd.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/csol_fwd.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -14,7 +14,7 @@ C
       SUBROUTINE CMUMPS_SOL_R(N, A, LA, IW, LIW, WCB, LWCB,
      &    NRHS,
      &    PTRICB, IWCB, LIWCB, 
-     &    RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD, 
+     &    RHSINTR, LRHSINTR, POSINRHSINTR_FWD, 
      &    STEP,
      &    FRERE, DAD, FILS,
      &    NSTK, IPOOL, LPOOL, PTRIST, PTRFAC, MYLEAF, MYROOT,
@@ -59,8 +59,8 @@ C
       INTEGER IW( LIW ), IWCB( LIWCB )
       INTEGER ISTEP_TO_INIV2(KEEP(71)), 
      &        TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
-      INTEGER, intent(in) ::  POSINRHSCOMP_FWD(N), LRHSCOMP 
-      COMPLEX, intent(inout) :: RHSCOMP(LRHSCOMP,NRHS)
+      INTEGER, intent(in) ::  POSINRHSINTR_FWD(N), LRHSINTR 
+      COMPLEX, intent(inout) :: RHSINTR(LRHSINTR,NRHS)
       LOGICAL, intent(in) :: FROM_PP
       INTEGER, INTENT( in ) :: LL0_OMP_MAPPING, LL0_OMP_FACTORS
       INTEGER, INTENT( in ) :: L0_OMP_MAPPING( LL0_OMP_MAPPING )
@@ -108,21 +108,25 @@ C
      &          KEEP(208) )
         GOTO 60
       ENDIF
-      BLOQ = ( ( III .EQ. LEAF )
+      IF (SLAVEF .EQ. 1) THEN
+        FLAG = .FALSE.
+      ELSE
+        BLOQ = ( ( III .EQ. LEAF )
      &     )
-      CALL CMUMPS_SOLVE_RECV_AND_TREAT( BLOQ, FLAG,
-     &     BUFR, LBUFR, LBUFR_BYTES,
-     &     MYID, SLAVEF, COMM,
-     &     N, NRHS, IPOOL, LPOOL, LEAF,
-     &     NBFIN, NSTK, IW, LIW, A, LA, PTRIST, PTRFAC,
-     &     IWCB, LIWCB,
-     &     WCB, LWCB, POSWCB,
-     &     PLEFTWCB, POSIWCB,
-     &     PTRICB, INFO, KEEP,KEEP8, DKEEP, STEP,
-     &     PROCNODE_STEPS,
-     &     RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD
-     &     , FROM_PP
-     &    )
+        CALL CMUMPS_SOLVE_RECV_AND_TREAT( BLOQ, FLAG,
+     &       BUFR, LBUFR, LBUFR_BYTES,
+     &       MYID, SLAVEF, COMM,
+     &       N, NRHS, IPOOL, LPOOL, LEAF,
+     &       NBFIN, NSTK, IW, LIW, A, LA, PTRIST, PTRFAC,
+     &       IWCB, LIWCB,
+     &       WCB, LWCB, POSWCB,
+     &       PLEFTWCB, POSIWCB,
+     &       PTRICB, INFO, KEEP,KEEP8, DKEEP, STEP,
+     &       PROCNODE_STEPS,
+     &       RHSINTR, LRHSINTR, POSINRHSINTR_FWD
+     &       , FROM_PP
+     &      )
+      ENDIF
       IF ( INFO( 1 ) .LT. 0 .OR. NBFIN .EQ. 0 ) GOTO 260
       IF (.not. FLAG) THEN
          IF (III .NE. LEAF) THEN
@@ -158,7 +162,7 @@ C
      &        PTRICB, PTRIST, PTRFAC, PROCNODE_STEPS,
      &        FILS, STEP, FRERE, DAD,
      &        INFO, KEEP,KEEP8, DKEEP, RHS_ROOT, LRHS_ROOT, MTYPE,
-     &        RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD,
+     &        RHSINTR, LRHSINTR, POSINRHSINTR_FWD,
      &        ISTEP_TO_INIV2, TAB_POS_IN_PERE
      &        , RHS_BOUNDS, LRHS_BOUNDS, DO_NBSPARSE 
      &        , FROM_PP
diff -pruN 5.6.2-2.1/src/csol_fwd_aux.F 5.7.1-1/src/csol_fwd_aux.F
--- 5.6.2-2.1/src/csol_fwd_aux.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/csol_fwd_aux.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -21,7 +21,7 @@ C
      &     PLEFTWCB, POSIWCB,
      &     PTRICB,
      &     INFO, KEEP, KEEP8, DKEEP, STEP, PROCNODE_STEPS, 
-     &     RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD
+     &     RHSINTR, LRHSINTR, POSINRHSINTR_FWD
      &     , FROM_PP
      &    )
       USE CMUMPS_OOC 
@@ -32,7 +32,7 @@ C
       INTEGER MSGTAG, MSGSOU, MYID, SLAVEF, COMM
       INTEGER LIW
       INTEGER(8), INTENT(IN) :: LA, LWCB
-      INTEGER N, NRHS, LPOOL, LEAF, NBFIN, LRHSCOMP
+      INTEGER N, NRHS, LPOOL, LEAF, NBFIN, LRHSINTR
       INTEGER LIWCB, POSIWCB
       INTEGER(8) :: POSWCB, PLEFTWCB
       INTEGER INFO( 80 ), KEEP( 500)
@@ -47,8 +47,8 @@ C
       INTEGER STEP(N)
       INTEGER PROCNODE_STEPS(KEEP(28))
       COMPLEX WCB( LWCB ), A( LA )
-      COMPLEX RHSCOMP( LRHSCOMP, NRHS )
-      INTEGER, intent(in) :: POSINRHSCOMP_FWD(N)
+      COMPLEX RHSINTR( LRHSINTR, NRHS )
+      INTEGER, intent(in) :: POSINRHSINTR_FWD(N)
       LOGICAL, intent(in) :: FROM_PP
       INCLUDE 'mpif.h'
       INCLUDE 'mumps_tags.h'
@@ -57,7 +57,7 @@ C
       INTEGER :: IWHDLR, LDA_SLAVE
       INTEGER :: MTYPE_SLAVE 
       INTEGER FINODE, FPERE, LONG, NCB, POSITION, NCV, NPIV
-      INTEGER PDEST, I, IPOSINRHSCOMP
+      INTEGER PDEST, I, IPOSINRHSINTR
       INTEGER J1
       INTEGER(8) :: APOS
       LOGICAL DUMMY
@@ -119,9 +119,9 @@ C
 !NEC$ IVDEP
 #endif
                  DO I = 1, LONG
-                   IPOSINRHSCOMP= abs(POSINRHSCOMP_FWD(IWCB(I)))
-                   RHSCOMP(IPOSINRHSCOMP,JBDEB+K-1) = 
-     &             RHSCOMP(IPOSINRHSCOMP,JBDEB+K-1) + 
+                   IPOSINRHSINTR= abs(POSINRHSINTR_FWD(IWCB(I)))
+                   RHSINTR(IPOSINRHSINTR,JBDEB+K-1) = 
+     &             RHSINTR(IPOSINRHSINTR,JBDEB+K-1) + 
      &                 WCB(PLEFTWCB+I-1)
                  ENDDO
               END DO
@@ -246,7 +246,7 @@ C
 !$           OMP_FLAG = ( JBFIN-JBDEB+1.GE.KEEP(362) .AND.
 !$   &                     (NCV*(JBFIN-JBDEB+1) .GE. KEEP(363) ) )
              IF (OMP_FLAG) THEN
-!$OMP PARALLEL DO PRIVATE(I,JJ,IFR8,IPOSINRHSCOMP)
+!$OMP PARALLEL DO PRIVATE(I,JJ,IFR8,IPOSINRHSINTR)
                DO K=1, NRHS_B
                   IFR8 = PTRY+int(K-1,8)*int(NCV,8)
 #if defined(__ve__)
@@ -254,9 +254,9 @@ C
 #endif
                   DO I = 1,NCV
                     JJ = IW(J1+I)
-                    IPOSINRHSCOMP= abs(POSINRHSCOMP_FWD(JJ))
-                    RHSCOMP(IPOSINRHSCOMP,JBDEB+K-1)= 
-     &                RHSCOMP(IPOSINRHSCOMP,JBDEB+K-1)
+                    IPOSINRHSINTR= abs(POSINRHSINTR_FWD(JJ))
+                    RHSINTR(IPOSINRHSINTR,JBDEB+K-1)= 
+     &                RHSINTR(IPOSINRHSINTR,JBDEB+K-1)
      &                + WCB(IFR8+int(I-1,8))
                   ENDDO
                ENDDO
@@ -269,9 +269,9 @@ C
 #endif
                   DO I = 1,NCV
                     JJ = IW(J1+I)
-                    IPOSINRHSCOMP= abs(POSINRHSCOMP_FWD(JJ))
-                    RHSCOMP(IPOSINRHSCOMP,JBDEB+K-1)= 
-     &                RHSCOMP(IPOSINRHSCOMP,JBDEB+K-1)
+                    IPOSINRHSINTR= abs(POSINRHSINTR_FWD(JJ))
+                    RHSINTR(IPOSINRHSINTR,JBDEB+K-1)= 
+     &                RHSINTR(IPOSINRHSINTR,JBDEB+K-1)
      &                + WCB(IFR8+int(I-1,8))
                   ENDDO
                ENDDO
@@ -297,7 +297,7 @@ C
      &            IW(PTRIST(STEP( FINODE )) + 2 + KEEP(IXSZ) ), NCV,NCV,
      &            IW(PTRIST(STEP(FINODE))+4+ KEEP(IXSZ) ),
      &            WCB( PTRY ), JBDEB, JBFIN,
-     &            RHSCOMP, 1, 1, -9999, -9999,
+     &            RHSINTR, 1, 1, -9999, -9999,
      &            KEEP, PDEST, ContVec, COMM, IERR )
             IF ( IERR .EQ. -1 ) THEN
               CALL CMUMPS_SOLVE_RECV_AND_TREAT( .FALSE., FLAG,
@@ -309,7 +309,7 @@ C
      &              WCB, LWCB, POSWCB, PLEFTWCB, POSIWCB,
      &              PTRICB, INFO, KEEP,KEEP8, DKEEP, STEP,
      &              PROCNODE_STEPS, 
-     &              RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD
+     &              RHSINTR, LRHSINTR, POSINRHSINTR_FWD
      &              , FROM_PP
      &              )
               IF ( INFO( 1 )  .LT. 0 )  GOTO 270
@@ -356,7 +356,7 @@ C
      &     PTRICB, PTRIST, PTRFAC, PROCNODE_STEPS,
      &     FILS, STEP, FRERE, DAD,
      &     INFO, KEEP,KEEP8, DKEEP, RHS_ROOT, LRHS_ROOT, MTYPE,
-     &     RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD,
+     &     RHSINTR, LRHSINTR, POSINRHSINTR_FWD,
      &     
      &     ISTEP_TO_INIV2, TAB_POS_IN_PERE
      &    , RHS_BOUNDS, LRHS_BOUNDS, DO_NBSPARSE, FROM_PP
@@ -393,8 +393,8 @@ C
       INTEGER FILS( N ), STEP( N ), FRERE(KEEP(28)), DAD(KEEP(28))
       INTEGER ISTEP_TO_INIV2(KEEP(71)), 
      &     TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
-      INTEGER POSINRHSCOMP_FWD(N), LRHSCOMP
-      COMPLEX RHSCOMP(LRHSCOMP, NRHS)
+      INTEGER POSINRHSINTR_FWD(N), LRHSINTR
+      COMPLEX RHSINTR(LRHSINTR, NRHS)
       LOGICAL, intent(in) :: DO_NBSPARSE
       INTEGER, intent(in) :: LRHS_BOUNDS
       INTEGER, intent(in) :: RHS_BOUNDS(LRHS_BOUNDS)
@@ -413,10 +413,10 @@ C
       INTEGER I, J, K, IPOS, NSLAVES, J1, J2, J3, FPERE, FPERE_MAPPING,
      &     NPIV, NCB, LIELL, JJ, NELIM, IERR
       INTEGER(8) :: PCB_COURANT, PPIV_COURANT, PPIV_PANEL, PCB_PANEL
-      INTEGER IPOSINRHSCOMP_TMP
+      INTEGER IPOSINRHSINTR_TMP
       INTEGER Effective_CB_Size, NUPDATE, ISLAVE, PDEST, FirstIndex
       LOGICAL FLAG
-      INTEGER :: NUPDATE_NONCRITICAL, IPOSINRHSCOMPLASTFSDYN 
+      INTEGER :: NUPDATE_NONCRITICAL, IPOSINRHSINTRLASTFSDYN 
       LOGICAL :: OMP_FLAG
       INCLUDE 'mumps_headers.h'
       INTEGER(8) :: APOSDEB
@@ -519,27 +519,27 @@ C
       ENDIF
       IF ( INODE .eq. KEEP( 38 ) .OR. INODE .eq. KEEP(20) ) THEN
         IFR8 = 0_8
-        IPOSINRHSCOMP_TMP = POSINRHSCOMP_FWD(IW(J1)) 
+        IPOSINRHSINTR_TMP = POSINRHSINTR_FWD(IW(J1)) 
         IFR_ini8 = IFR8
         OMP_FLAG = .FALSE.
 !$      OMP_FLAG = ( JBFIN-JBDEB+1.GE.KEEP(362) .AND.
 !$   &                     (J3-J1+1)*(JBFIN-JBDEB+1) .GE. KEEP(363) )
         IF (OMP_FLAG) THEN
 !$OMP PARALLEL DO PRIVATE(IFR8,JJ)
-          DO K=JBDEB,JBFIN
+          DO K=1,NRHS
              IFR8 = IFR_ini8 + int(K-1,8)*int(NPIV,8)
              DO JJ = J1, J3
                RHS_ROOT(IFR8+int(JJ-J1+1,8)) = 
-     &                 RHSCOMP(IPOSINRHSCOMP_TMP+JJ-J1,K)
+     &                 RHSINTR(IPOSINRHSINTR_TMP+JJ-J1,K)
              ENDDO
           ENDDO
 !$OMP END PARALLEL DO
         ELSE
-          DO K=JBDEB,JBFIN
+          DO K=1,NRHS
              IFR8 = IFR_ini8 + int(K-1,8)*int(NPIV,8)
              DO JJ = J1, J3
                RHS_ROOT(IFR8+int(JJ-J1+1,8)) = 
-     &                 RHSCOMP(IPOSINRHSCOMP_TMP+JJ-J1,K)
+     &                 RHSINTR(IPOSINRHSINTR_TMP+JJ-J1,K)
              ENDDO
           ENDDO
         ENDIF
@@ -604,10 +604,10 @@ C
       ELSE
         CBINITZERO = .FALSE. 
       ENDIF
-      CALL CMUMPS_RHSCOMP_TO_WCB(
+      CALL CMUMPS_RHSINTR_TO_WCB(
      &     NPIV, NCB, LIELL, CBINITZERO, LDEQLIELLPANEL,
-     &     RHSCOMP(1, JBDEB), LRHSCOMP, NRHS_B,
-     &     POSINRHSCOMP_FWD, N,
+     &     RHSINTR(1, JBDEB), LRHSINTR, NRHS_B,
+     &     POSINRHSINTR_FWD, N,
      &     WCB(PPIV_COURANT),
      &     IW, LIW, J1, J3, J2, KEEP, DKEEP)
       IF ( NPIV .NE. 0 ) THEN
@@ -704,8 +704,8 @@ C
      &           LIELL, WCB, LWCB, 
      &           LD_WCBPIV, LD_WCBCB,
      &           PPIV_COURANT, PCB_COURANT, 
-     &           RHSCOMP, LRHSCOMP, NRHS, 
-     &           POSINRHSCOMP_FWD, JBDEB, JBFIN,
+     &           RHSINTR, LRHSINTR, NRHS, 
+     &           POSINRHSINTR_FWD, JBDEB, JBFIN,
      &           MTYPE, KEEP, KEEP8, OOCWRITE_COMPATIBLE_WITH_BLR,
      &           INFO(1), INFO(2) )
             IF (INFO(1).LT.0) THEN
@@ -769,8 +769,8 @@ C
      &    IW, IPOS, LIW, 
      &    A, LA, APOS,
      &    WCB, LWCB, LD_WCBPIV, 
-     &    RHSCOMP, LRHSCOMP, NRHS, 
-     &    POSINRHSCOMP_FWD, JBDEB, JBFIN, 
+     &    RHSINTR, LRHSINTR, NRHS, 
+     &    POSINRHSINTR_FWD, JBDEB, JBFIN, 
      &    MTYPE, KEEP, OOCWRITE_COMPATIBLE_WITH_BLR,
      &    .FALSE.
      &    )
@@ -781,8 +781,8 @@ C
      &    IW, IPOS, LIW, 
      &    A, LA, APOS,
      &    WCB, LWCB, LD_WCBPIV, 
-     &    RHSCOMP, LRHSCOMP, NRHS, 
-     &    POSINRHSCOMP_FWD, JBDEB, JBFIN, 
+     &    RHSINTR, LRHSINTR, NRHS, 
+     &    POSINRHSINTR_FWD, JBDEB, JBFIN, 
      &    MTYPE, KEEP, OOCWRITE_COMPATIBLE_WITH_BLR,
      &    .FALSE.
      &    )
@@ -811,14 +811,14 @@ C
             NUPDATE_NONCRITICAL = NUPDATE
             IF (LASTFSL0DYN .LE. N) THEN
               IF ( LASTFSL0DYN .EQ. 0 ) THEN
-                IPOSINRHSCOMPLASTFSDYN = 0
+                IPOSINRHSINTRLASTFSDYN = 0
               ELSE
-                IPOSINRHSCOMPLASTFSDYN =
-     &                          abs(POSINRHSCOMP_FWD(LASTFSL0DYN))
+                IPOSINRHSINTRLASTFSDYN =
+     &                          abs(POSINRHSINTR_FWD(LASTFSL0DYN))
               ENDIF
               DO I = 1, NUPDATE
-                IF ( abs(POSINRHSCOMP_FWD( IW(J3+I) )) .GT. 
-     &               IPOSINRHSCOMPLASTFSDYN ) THEN
+                IF ( abs(POSINRHSINTR_FWD( IW(J3+I) )) .GT. 
+     &               IPOSINRHSINTRLASTFSDYN ) THEN
                   IF (abs(STEP(IW(J3+I))) .GT.
      &                abs(STEP( LASTFSL0STA))
      &                .OR. KEEP(261) .NE. 1) THEN
@@ -832,17 +832,17 @@ C
 !$          OMP_FLAG = ( NRHS_B.GE.KEEP(362) .AND.
 !$   &                  (NUPDATE*NRHS_B .GE. KEEP(363)) )
             IF (OMP_FLAG) THEN
-!$OMP PARALLEL DO PRIVATE(I,IFR8,IPOSINRHSCOMP_TMP)
+!$OMP PARALLEL DO PRIVATE(I,IFR8,IPOSINRHSINTR_TMP)
               DO K = JBDEB, JBFIN
                 IFR8 = PCB_COURANT + int(K-JBDEB,8)*int(LD_WCBCB,8)
 #if defined(__ve__)
 !NEC$ IVDEP
 #endif
                 DO I = 1, NUPDATE_NONCRITICAL
-                  IPOSINRHSCOMP_TMP = 
-     &            abs(POSINRHSCOMP_FWD(IW(J3 + I)))
-                  RHSCOMP( IPOSINRHSCOMP_TMP, K ) = 
-     &            RHSCOMP( IPOSINRHSCOMP_TMP, K )
+                  IPOSINRHSINTR_TMP = 
+     &            abs(POSINRHSINTR_FWD(IW(J3 + I)))
+                  RHSINTR( IPOSINRHSINTR_TMP, K ) = 
+     &            RHSINTR( IPOSINRHSINTR_TMP, K )
      &            + WCB(IFR8 + int(I-1,8))
                 ENDDO
               ENDDO
@@ -854,10 +854,10 @@ C
 !NEC$ IVDEP
 #endif
                 DO I = 1, NUPDATE_NONCRITICAL
-                  IPOSINRHSCOMP_TMP = 
-     &            abs(POSINRHSCOMP_FWD(IW(J3 + I)))
-                  RHSCOMP( IPOSINRHSCOMP_TMP, K ) = 
-     &            RHSCOMP( IPOSINRHSCOMP_TMP, K )
+                  IPOSINRHSINTR_TMP = 
+     &            abs(POSINRHSINTR_FWD(IW(J3 + I)))
+                  RHSINTR( IPOSINRHSINTR_TMP, K ) = 
+     &            RHSINTR( IPOSINRHSINTR_TMP, K )
      &            + WCB(IFR8 + int(I-1,8))
                 ENDDO
               ENDDO
@@ -880,10 +880,10 @@ C
 !NEC$ IVDEP
 #endif
                     DO I = NUPDATE_NONCRITICAL+1, NUPDATE
-                      IPOSINRHSCOMP_TMP = 
-     &                  abs(POSINRHSCOMP_FWD(IW(J3 + I)))
-                      RHSCOMP( IPOSINRHSCOMP_TMP, K ) = 
-     &                   RHSCOMP( IPOSINRHSCOMP_TMP, K )
+                      IPOSINRHSINTR_TMP = 
+     &                  abs(POSINRHSINTR_FWD(IW(J3 + I)))
+                      RHSINTR( IPOSINRHSINTR_TMP, K ) = 
+     &                   RHSINTR( IPOSINRHSINTR_TMP, K )
      &                   + WCB(IFR8 + int(I-1,8))
                     ENDDO
                   ENDDO
@@ -901,7 +901,7 @@ C
      &          NCB, LD_WCBCB,
      &          NUPDATE,
      &          IW( J3 + 1 ), WCB( PCB_COURANT ), JBDEB, JBFIN,
-     &          RHSCOMP, 1, 1, -9999, -9999,
+     &          RHSINTR, 1, 1, -9999, -9999,
      &          KEEP,
      &          MUMPS_PROCNODE(PROCNODE_STEPS(STEP(FPERE)), KEEP(199)),
      &          ContVec,
@@ -916,7 +916,7 @@ C
      &            WCB, LWCB, POSWCB, PLEFTWCB, POSIWCB,
      &            PTRICB, INFO, KEEP,KEEP8, DKEEP, STEP,
      &            PROCNODE_STEPS,
-     &            RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD
+     &            RHSINTR, LRHSINTR, POSINRHSINTR_FWD
      &            , FROM_PP
      &            )
             IF ( INFO( 1 )  .LT. 0 )  THEN
@@ -967,7 +967,7 @@ C
      &              WCB, LWCB, POSWCB, PLEFTWCB, POSIWCB,
      &              PTRICB, INFO, KEEP,KEEP8, DKEEP, STEP,
      &              PROCNODE_STEPS,
-     &              RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD
+     &              RHSINTR, LRHSINTR, POSINRHSINTR_FWD
      &              , FROM_PP
      &              )
                IF ( INFO( 1 )  .LT. 0 ) THEN
@@ -1003,7 +1003,7 @@ C
      &           WCB, LWCB, POSWCB,
      &           PLEFTWCB, POSIWCB,
      &           PTRICB, INFO, KEEP,KEEP8, DKEEP, STEP, PROCNODE_STEPS,
-     &           RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD
+     &           RHSINTR, LRHSINTR, POSINRHSINTR_FWD
      &            , FROM_PP
      &            )
       IMPLICIT NONE
@@ -1028,8 +1028,8 @@ C
       INTEGER STEP(N)
       INTEGER PROCNODE_STEPS(KEEP(28))
       LOGICAL FLAG
-      INTEGER LRHSCOMP, POSINRHSCOMP_FWD(N)
-      COMPLEX RHSCOMP(LRHSCOMP,NRHS)
+      INTEGER LRHSINTR, POSINRHSINTR_FWD(N)
+      COMPLEX RHSINTR(LRHSINTR,NRHS)
       LOGICAL, intent(in) :: FROM_PP
       INCLUDE 'mpif.h'
       INCLUDE 'mumps_tags.h'
@@ -1067,27 +1067,27 @@ C
      &          PLEFTWCB, POSIWCB,
      &          PTRICB, INFO, KEEP,KEEP8, DKEEP, STEP,
      &          PROCNODE_STEPS, 
-     &          RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD
+     &          RHSINTR, LRHSINTR, POSINRHSINTR_FWD
      &          , FROM_PP
      &          )
          END IF
       END IF
       RETURN
       END SUBROUTINE CMUMPS_SOLVE_RECV_AND_TREAT
-      SUBROUTINE CMUMPS_RHSCOMP_TO_WCB(
+      SUBROUTINE CMUMPS_RHSINTR_TO_WCB(
      &      NPIV, NCB, LIELL, CBINITZERO, LDEQLIELLPANEL,
-     &      RHSCOMP, LRHSCOMP, NRHS_B,
-     &      POSINRHSCOMP_FWD, N,
+     &      RHSINTR, LRHSINTR, NRHS_B,
+     &      POSINRHSINTR_FWD, N,
      &      WCB,
      &      IW, LIW, J1, J3, J2, KEEP, DKEEP)
       IMPLICIT NONE
       INTEGER, INTENT( IN )    :: NPIV, NCB, LIELL, N,
-     &                            LRHSCOMP, NRHS_B,
+     &                            LRHSINTR, NRHS_B,
      &                            LIW, J1, J2, J3
       LOGICAL, INTENT( IN )    :: LDEQLIELLPANEL
       LOGICAL, INTENT( IN )    :: CBINITZERO
-      INTEGER, INTENT( IN )    :: POSINRHSCOMP_FWD( N ), IW( LIW )
-      COMPLEX, INTENT( INOUT ) :: RHSCOMP( LRHSCOMP, NRHS_B )
+      INTEGER, INTENT( IN )    :: POSINRHSINTR_FWD( N ), IW( LIW )
+      COMPLEX, INTENT( INOUT ) :: RHSINTR( LRHSINTR, NRHS_B )
       COMPLEX, INTENT( OUT )   :: WCB( int(LIELL,8)*
      &                                 int(NRHS_B,8) )
       INTEGER                  :: KEEP(500)
@@ -1095,7 +1095,7 @@ C
       INTEGER, PARAMETER :: ZERO = (0.0E0,0.0E0)
       INTEGER(8), PARAMETER :: PPIV_COURANT = 1_8
       INTEGER(8) :: PCB_COURANT
-      INTEGER :: LD_WCBCB, LD_WCBPIV, J, JJ, K, IPOSINRHSCOMP
+      INTEGER :: LD_WCBCB, LD_WCBPIV, J, JJ, K, IPOSINRHSINTR
       INTEGER(8) :: IFR8, IFR_ini8 
       INCLUDE 'mpif.h' 
       LOGICAL :: OMP_FLAG
@@ -1111,11 +1111,11 @@ C
       IF ( LDEQLIELLPANEL ) THEN  
         DO K=1, NRHS_B
            IFR8 = PPIV_COURANT+int(K-1,8)*int(LD_WCBPIV,8)-1_8
-           IPOSINRHSCOMP = POSINRHSCOMP_FWD(IW(J1)) 
+           IPOSINRHSINTR = POSINRHSINTR_FWD(IW(J1)) 
            DO JJ = J1, J3
               IFR8 = IFR8 + 1_8
-              WCB(IFR8) = RHSCOMP(IPOSINRHSCOMP,K) 
-              IPOSINRHSCOMP = IPOSINRHSCOMP + 1
+              WCB(IFR8) = RHSINTR(IPOSINRHSINTR,K) 
+              IPOSINRHSINTR = IPOSINRHSINTR + 1
            ENDDO
            IF (NCB.GT.0 .AND. .NOT. CBINITZERO) THEN
 #if defined(__ve__)
@@ -1124,9 +1124,9 @@ C
               DO JJ = J3+1, J2
                  J = IW(JJ)
                  IFR8 = IFR8 + 1_8
-                 IPOSINRHSCOMP = abs(POSINRHSCOMP_FWD(J))
-                 WCB(IFR8) = RHSCOMP(IPOSINRHSCOMP,K) 
-                 RHSCOMP (IPOSINRHSCOMP,K) = ZERO
+                 IPOSINRHSINTR = abs(POSINRHSINTR_FWD(J))
+                 WCB(IFR8) = RHSINTR(IPOSINRHSINTR,K) 
+                 RHSINTR (IPOSINRHSINTR,K) = ZERO
               ENDDO
            ENDIF
         ENDDO
@@ -1134,7 +1134,7 @@ C
         PCB_COURANT = PPIV_COURANT + LD_WCBPIV*NRHS_B
         IFR8 = PPIV_COURANT - 1_8
         IFR_ini8 = IFR8
-        IPOSINRHSCOMP = POSINRHSCOMP_FWD(IW(J1)) 
+        IPOSINRHSINTR = POSINRHSINTR_FWD(IW(J1)) 
         OMP_FLAG = .FALSE.
 !$      OMP_FLAG = ( NRHS_B .GE. KEEP(362) .AND.
 !$   &               int(NCB,8)*int(NRHS_B,8) .GE. KEEP(363) )
@@ -1144,7 +1144,7 @@ C
             IFR8 = IFR_ini8 + int(K-1,8)*int(NPIV,8)
             DO  JJ = J1, J3
              WCB(IFR8+int(JJ-J1+1,8)) = 
-     &            RHSCOMP(IPOSINRHSCOMP+JJ-J1,K)
+     &            RHSINTR(IPOSINRHSINTR+JJ-J1,K)
             ENDDO
           ENDDO
 !$OMP END PARALLEL DO
@@ -1153,7 +1153,7 @@ C
             IFR8 = IFR_ini8 + int(K-1,8)*int(NPIV,8)
             DO  JJ = J1, J3
              WCB(IFR8+int(JJ-J1+1,8)) = 
-     &            RHSCOMP(IPOSINRHSCOMP+JJ-J1,K)
+     &            RHSINTR(IPOSINRHSINTR+JJ-J1,K)
             ENDDO
           ENDDO
         ENDIF
@@ -1164,7 +1164,7 @@ C
 !$        OMP_FLAG = ( NRHS_B.GE.KEEP(362) .AND.
 !$   &                 NCB*NRHS_B .GE. KEEP(363) )
           IF (OMP_FLAG) THEN
-!$OMP PARALLEL DO PRIVATE (IFR8, JJ, J, IPOSINRHSCOMP)
+!$OMP PARALLEL DO PRIVATE (IFR8, JJ, J, IPOSINRHSINTR)
             DO K=1, NRHS_B
               IFR8 = IFR_ini8+(K-1)*NCB
 #if defined(__ve__)
@@ -1172,9 +1172,9 @@ C
 #endif
               DO JJ = J3 + 1, J2
                 J = IW(JJ)
-                IPOSINRHSCOMP = abs(POSINRHSCOMP_FWD(J))
-                WCB(IFR8+int(JJ-J3,8)) = RHSCOMP(IPOSINRHSCOMP,K)
-                RHSCOMP(IPOSINRHSCOMP,K)=ZERO
+                IPOSINRHSINTR = abs(POSINRHSINTR_FWD(J))
+                WCB(IFR8+int(JJ-J3,8)) = RHSINTR(IPOSINRHSINTR,K)
+                RHSINTR(IPOSINRHSINTR,K)=ZERO
               ENDDO
             ENDDO
 !$OMP END PARALLEL DO
@@ -1186,9 +1186,9 @@ C
 #endif
               DO JJ = J3 + 1, J2
                 J = IW(JJ)
-                IPOSINRHSCOMP = abs(POSINRHSCOMP_FWD(J))
-                WCB(IFR8+int(JJ-J3,8)) = RHSCOMP(IPOSINRHSCOMP,K)
-                RHSCOMP(IPOSINRHSCOMP,K)=ZERO
+                IPOSINRHSINTR = abs(POSINRHSINTR_FWD(J))
+                WCB(IFR8+int(JJ-J3,8)) = RHSINTR(IPOSINRHSINTR,K)
+                RHSINTR(IPOSINRHSINTR,K)=ZERO
               ENDDO
             ENDDO
           ENDIF
@@ -1214,4 +1214,4 @@ C
         ENDIF
       ENDIF
       RETURN
-      END SUBROUTINE CMUMPS_RHSCOMP_TO_WCB
+      END SUBROUTINE CMUMPS_RHSINTR_TO_WCB
diff -pruN 5.6.2-2.1/src/csol_lr.F 5.7.1-1/src/csol_lr.F
--- 5.6.2-2.1/src/csol_lr.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/csol_lr.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -24,20 +24,20 @@ C
      &     LIELL, WCB, LWCB, 
      &     LD_WCBPIV, LD_WCBCB,
      &     PPIV_INIT, PCB_INIT, 
-     &     RHSCOMP, LRHSCOMP, NRHS, 
-     &     POSINRHSCOMP_FWD, JBDEB, JBFIN, 
+     &     RHSINTR, LRHSINTR, NRHS, 
+     &     POSINRHSINTR_FWD, JBDEB, JBFIN, 
      &     MTYPE, KEEP, KEEP8, OOCWRITE_COMPATIBLE_WITH_BLR,
      &     IFLAG, IERROR )
        INTEGER, INTENT(IN) :: INODE, N, IWHDLR, NPIV_GLOBAL, NSLAVES
        INTEGER, INTENT(IN) :: MTYPE, LIELL, KEEP(500)
        INTEGER(8), INTENT(IN) :: KEEP8(150)
-       INTEGER, INTENT(IN) :: LIW, IPOS_INIT, LRHSCOMP
-       INTEGER, INTENT(IN) :: IW(LIW), POSINRHSCOMP_FWD(N)
+       INTEGER, INTENT(IN) :: LIW, IPOS_INIT, LRHSINTR
+       INTEGER, INTENT(IN) :: IW(LIW), POSINRHSINTR_FWD(N)
        INTEGER(8), INTENT(IN) :: LWCB, PPIV_INIT, PCB_INIT
        INTEGER, INTENT(IN) :: LD_WCBPIV, LD_WCBCB, NRHS, JBDEB, JBFIN
        COMPLEX, INTENT(INOUT) :: WCB(LWCB)
        INTEGER, INTENT(INOUT) :: IFLAG, IERROR
-       COMPLEX, INTENT(INOUT) :: RHSCOMP(LRHSCOMP, NRHS)
+       COMPLEX, INTENT(INOUT) :: RHSINTR(LRHSINTR, NRHS)
        LOGICAL, INTENT(IN)    :: OOCWRITE_COMPATIBLE_WITH_BLR
         INTEGER :: I, NPARTSASS, NB_BLR , NELIM, LDADIAG,
      &             DIAGSIZ_DYN, DIAGSIZ_STA, IBEG_BLR, IEND_BLR,
@@ -167,8 +167,8 @@ C
      &  IW, IPOS, LIW, 
      &  DIAG(1), int(size(DIAG),8), 1_8, 
      &  WCB, LWCB, LD_WCBPIV, 
-     &  RHSCOMP, LRHSCOMP, NRHS, 
-     &  POSINRHSCOMP_FWD, JBDEB, JBFIN, 
+     &  RHSINTR, LRHSINTR, NRHS, 
+     &  POSINRHSINTR_FWD, JBDEB, JBFIN, 
      &  MTYPE, KEEP, OOCWRITE_COMPATIBLE_WITH_BLR,
      &  .TRUE.  
      &  )
@@ -381,19 +381,19 @@ C
       SUBROUTINE CMUMPS_SOL_BWD_LR_SU 
      &   ( INODE, IWHDLR, NPIV_GLOBAL, NSLAVES,
      &     LIELL, WCB, LWCB, NRHS_B, PTWCB,
-     &     RHSCOMP, LRHSCOMP, NRHS,
-     &     IPOSINRHSCOMP, JBDEB, 
+     &     RHSINTR, LRHSINTR, NRHS,
+     &     IPOSINRHSINTR, JBDEB, 
      &     MTYPE, KEEP, KEEP8,
      &     IFLAG, IERROR )
        INTEGER, INTENT(IN) :: INODE, IWHDLR, NPIV_GLOBAL, NSLAVES
        INTEGER, INTENT(IN) :: MTYPE, LIELL, KEEP(500)
        INTEGER(8), INTENT(IN) :: KEEP8(150)
-       INTEGER, INTENT(IN) :: IPOSINRHSCOMP, JBDEB, LRHSCOMP, NRHS
+       INTEGER, INTENT(IN) :: IPOSINRHSINTR, JBDEB, LRHSINTR, NRHS
        INTEGER(8), INTENT(IN) :: LWCB, PTWCB
        INTEGER, INTENT(IN) ::  NRHS_B
        INTEGER, INTENT(INOUT) :: IFLAG, IERROR
        COMPLEX, INTENT(INOUT) :: WCB(LWCB)
-       COMPLEX RHSCOMP(LRHSCOMP,NRHS)
+       COMPLEX RHSINTR(LRHSINTR,NRHS)
         INTEGER :: I, NPARTSASS, NB_BLR, LAST_BLR, 
      &             NELIM_PANEL, LD_WCB,
      &             DIAGSIZ_DYN, DIAGSIZ_STA, LDADIAG,
@@ -441,15 +441,15 @@ C
         ENDIF 
         IF (DIAGSIZ_DYN.EQ.0) GOTO 1000
         NELIM_PANEL = DIAGSIZ_STA - DIAGSIZ_DYN
-         IPIV_PANEL = IPOSINRHSCOMP + IBEG_BLR -1
+         IPIV_PANEL = IPOSINRHSINTR + IBEG_BLR -1
          IF ( MTYPE .EQ. 1 .AND. KEEP(50).EQ.0) THEN
           BLR_PANEL => BLR_ARRAY(IWHDLR)%PANELS_U(I)%LRB_PANEL
          ELSE
           BLR_PANEL => BLR_ARRAY(IWHDLR)%PANELS_L(I)%LRB_PANEL
          END IF
         CALL CMUMPS_SOL_BWD_BLR_UPDATE ( 
-     &        RHSCOMP, int(LRHSCOMP,8), NRHS, LRHSCOMP, 
-     &        int(IPOSINRHSCOMP,8), JBDEB,
+     &        RHSINTR, int(LRHSINTR,8), NRHS, LRHSINTR, 
+     &        int(IPOSINRHSINTR,8), JBDEB,
      &        WCB, LWCB, LD_WCB, PWCB, 
      &        int(IPIV_PANEL,8), 
      &        NRHS_B, NPIV_GLOBAL,
@@ -465,26 +465,26 @@ C
              IF (IEND_BLR.EQ.NPIV_GLOBAL) THEN
                CALL cgemm('T', 'N', DIAGSIZ_DYN, NRHS_B, NELIM_PANEL, 
      &              MONE, DIAG(1+DIAGSIZ_DYN), DIAGSIZ_STA,  WCB(PWCB),
-     &              LD_WCB, ONE , RHSCOMP(IPIV_PANEL,JBDEB),LRHSCOMP)
+     &              LD_WCB, ONE , RHSINTR(IPIV_PANEL,JBDEB),LRHSINTR)
              ELSE
                IF (IEND_BLR+1.LE.NPIV_GLOBAL .AND.
      &            IEND_BLR+NELIM_PANEL.GT.NPIV_GLOBAL) THEN
                  CALL cgemm('T', 'N', DIAGSIZ_DYN, NRHS_B,
      &              NPIV_GLOBAL-IEND_BLR, 
      &              MONE, DIAG(1+DIAGSIZ_DYN), DIAGSIZ_STA, 
-     &              RHSCOMP(IPIV_PANEL+DIAGSIZ_DYN,JBDEB), LRHSCOMP,
-     &              ONE, RHSCOMP(IPIV_PANEL,JBDEB), LRHSCOMP)
+     &              RHSINTR(IPIV_PANEL+DIAGSIZ_DYN,JBDEB), LRHSINTR,
+     &              ONE, RHSINTR(IPIV_PANEL,JBDEB), LRHSINTR)
                  CALL cgemm('T', 'N', DIAGSIZ_DYN, NRHS_B,
      &              IEND_BLR+NELIM_PANEL-NPIV_GLOBAL, 
      &              MONE, DIAG(1+DIAGSIZ_DYN+NPIV_GLOBAL-IEND_BLR),
      &              DIAGSIZ_STA, 
      &              WCB(PWCB), LD_WCB,
-     &              ONE, RHSCOMP(IPIV_PANEL,JBDEB), LRHSCOMP)
+     &              ONE, RHSINTR(IPIV_PANEL,JBDEB), LRHSINTR)
                ELSE
                  CALL cgemm('T', 'N', DIAGSIZ_DYN, NRHS_B, NELIM_PANEL, 
      &              MONE, DIAG(1+DIAGSIZ_DYN), DIAGSIZ_STA, 
-     &              RHSCOMP(IPIV_PANEL+DIAGSIZ_DYN,JBDEB), LRHSCOMP,
-     &              ONE, RHSCOMP(IPIV_PANEL,JBDEB), LRHSCOMP)
+     &              RHSINTR(IPIV_PANEL+DIAGSIZ_DYN,JBDEB), LRHSINTR,
+     &              ONE, RHSINTR(IPIV_PANEL,JBDEB), LRHSINTR)
                ENDIF
              ENDIF
            ELSE
@@ -492,27 +492,27 @@ C
                CALL cgemm('N', 'N', DIAGSIZ_DYN, NRHS_B, NELIM_PANEL, 
      &              MONE, DIAG(1+DIAGSIZ_DYN*LDADIAG), DIAGSIZ_DYN, 
      &              WCB(PWCB), LD_WCB, ONE, 
-     &              RHSCOMP(IPIV_PANEL,JBDEB), LRHSCOMP)
+     &              RHSINTR(IPIV_PANEL,JBDEB), LRHSINTR)
              ELSE
                IF (IEND_BLR+1.LE.NPIV_GLOBAL .AND.
      &            IEND_BLR+NELIM_PANEL.GT.NPIV_GLOBAL) THEN
                  CALL cgemm('N', 'N', DIAGSIZ_DYN, NRHS_B,
      &              NPIV_GLOBAL-IEND_BLR, 
      &              MONE, DIAG(1+DIAGSIZ_DYN*LDADIAG), DIAGSIZ_DYN, 
-     &              RHSCOMP(IPIV_PANEL+DIAGSIZ_DYN,JBDEB), LRHSCOMP,
-     &              ONE, RHSCOMP(IPIV_PANEL,JBDEB), LRHSCOMP)
+     &              RHSINTR(IPIV_PANEL+DIAGSIZ_DYN,JBDEB), LRHSINTR,
+     &              ONE, RHSINTR(IPIV_PANEL,JBDEB), LRHSINTR)
                  CALL cgemm('N', 'N', DIAGSIZ_DYN, NRHS_B,
      &              IEND_BLR+NELIM_PANEL-NPIV_GLOBAL, 
      &              MONE, DIAG(1+DIAGSIZ_DYN*LDADIAG +
      &                  (NPIV_GLOBAL-IEND_BLR)*DIAGSIZ_DYN),
      &              DIAGSIZ_DYN, 
      &              WCB(PWCB), LD_WCB,
-     &              ONE, RHSCOMP(IPIV_PANEL,JBDEB), LRHSCOMP)
+     &              ONE, RHSINTR(IPIV_PANEL,JBDEB), LRHSINTR)
                ELSE
                  CALL cgemm('N', 'N', DIAGSIZ_DYN, NRHS_B, NELIM_PANEL, 
      &              MONE, DIAG(1+DIAGSIZ_DYN*LDADIAG), DIAGSIZ_DYN, 
-     &              RHSCOMP(IPIV_PANEL+DIAGSIZ_DYN,JBDEB), LRHSCOMP,
-     &              ONE, RHSCOMP(IPIV_PANEL,JBDEB), LRHSCOMP)
+     &              RHSINTR(IPIV_PANEL+DIAGSIZ_DYN,JBDEB), LRHSINTR,
+     &              ONE, RHSINTR(IPIV_PANEL,JBDEB), LRHSINTR)
                ENDIF
              ENDIF
            ENDIF
@@ -521,7 +521,7 @@ C
          CALL CMUMPS_SOLVE_BWD_LR_TRSOLVE  (
      &         DIAG(1), size(DIAG), DIAGSIZ_DYN, NELIM_PANEL, LIELL,
      &         NRHS_B, WCB, LWCB, 
-     &         RHSCOMP, LRHSCOMP, NRHS,
+     &         RHSINTR, LRHSINTR, NRHS,
      &         IPIV_PANEL, JBDEB, 
      &         MTYPE, KEEP )
  1000 CONTINUE         
@@ -697,24 +697,24 @@ C
       SUBROUTINE CMUMPS_SOLVE_BWD_LR_TRSOLVE (
      &           DIAG, LDIAG, NPIV, NELIM, LIELL,
      &           NRHS_B, W, LWC, 
-     &           RHSCOMP, LRHSCOMP, NRHS,
-     &           PPIVINRHSCOMP, JBDEB, 
+     &           RHSINTR, LRHSINTR, NRHS,
+     &           PPIVINRHSINTR, JBDEB, 
      &           MTYPE, KEEP)
        INTEGER, INTENT(IN) :: MTYPE, LIELL, NPIV, NELIM, KEEP(500)
        INTEGER, INTENT(IN) :: NRHS_B, LDIAG
-       INTEGER, INTENT(IN) :: PPIVINRHSCOMP, JBDEB, LRHSCOMP, NRHS
+       INTEGER, INTENT(IN) :: PPIVINRHSINTR, JBDEB, LRHSINTR, NRHS
        INTEGER(8), INTENT(IN) ::  LWC
        COMPLEX, INTENT(IN) :: DIAG(LDIAG)
        COMPLEX, INTENT(INOUT) :: W(LWC)
-       COMPLEX RHSCOMP(LRHSCOMP,NRHS)
+       COMPLEX RHSINTR(LRHSINTR,NRHS)
        INTEGER :: LDAJ
       COMPLEX ONE
       PARAMETER ( ONE=(1.0E0,0.0E0) )
         IF ( MTYPE .eq. 1 ) THEN
          LDAJ =  NPIV + NELIM
          CALL ctrsm('L','L','T','N', NPIV, NRHS_B, ONE, DIAG(1),
-     &              LDAJ, RHSCOMP(PPIVINRHSCOMP,JBDEB), 
-     &              LRHSCOMP)
+     &              LDAJ, RHSINTR(PPIVINRHSINTR,JBDEB), 
+     &              LRHSINTR)
         ELSE
          IF ( KEEP(50) .EQ. 0 ) THEN
            LDAJ=NPIV+NELIM
@@ -722,7 +722,7 @@ C
            LDAJ=NPIV
          ENDIF
          CALL ctrsm('L','U','N','U', NPIV, NRHS_B, ONE, DIAG(1),
-     &            LDAJ, RHSCOMP(PPIVINRHSCOMP,JBDEB), LRHSCOMP)
+     &            LDAJ, RHSINTR(PPIVINRHSINTR,JBDEB), LRHSINTR)
         END IF 
       RETURN
       END SUBROUTINE CMUMPS_SOLVE_BWD_LR_TRSOLVE
diff -pruN 5.6.2-2.1/src/csol_matvec.F 5.7.1-1/src/csol_matvec.F
--- 5.6.2-2.1/src/csol_matvec.F	2023-10-11 09:37:10.000000000 +0000
+++ 5.7.1-1/src/csol_matvec.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/csol_omp_m.F 5.7.1-1/src/csol_omp_m.F
--- 5.6.2-2.1/src/csol_omp_m.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/csol_omp_m.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -35,16 +35,18 @@ C
       IMPLICIT NONE
       INTEGER, INTENT(IN) :: K400
 !$    INTEGER :: I
-!$    IF (K400 .GT. 0) THEN
-!$      DO I = 1, min(NB_LOCK_MAX,K400)
-!$        CALL OMP_DESTROY_LOCK(LOCK_FOR_SCATTER(I))
-!$      ENDDO
-!$      DEALLOCATE(LOCK_FOR_SCATTER)
+!$    IF (allocated(LOCK_FOR_SCATTER)) THEN
+!$      IF (K400 .GT. 0) THEN
+!$        DO I = 1, min(NB_LOCK_MAX,K400)
+!$          CALL OMP_DESTROY_LOCK(LOCK_FOR_SCATTER(I))
+!$        ENDDO
+!$        DEALLOCATE(LOCK_FOR_SCATTER)
+!$      ENDIF
 !$    ENDIF
       RETURN
       END SUBROUTINE CMUMPS_SOL_L0OMP_LD
       SUBROUTINE CMUMPS_SOL_L0OMP_R(N, MTYPE,
-     &  NRHS, LIW, IW, PTRICB, RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD,
+     &  NRHS, LIW, IW, PTRICB, RHSINTR, LRHSINTR, POSINRHSINTR_FWD,
      &  STEP, FRERE, DAD, FILS, NSTK, PTRIST, PTRFAC, INFO,
      &  KEEP, KEEP8, DKEEP, PROCNODE_STEPS, SLAVEF,
      &  COMM, MYID,              
@@ -69,8 +71,8 @@ C
       REAL                  :: DKEEP(230)
       INTEGER, INTENT( in ) :: PROCNODE_STEPS( KEEP(28) )
       INTEGER               :: PTRICB( KEEP(28) ) 
-      INTEGER, INTENT( in ) :: POSINRHSCOMP_FWD(N), LRHSCOMP 
-      COMPLEX, INTENT(inout):: RHSCOMP(LRHSCOMP,NRHS)
+      INTEGER, INTENT( in ) :: POSINRHSINTR_FWD(N), LRHSINTR 
+      COMPLEX, INTENT(inout):: RHSINTR(LRHSINTR,NRHS)
       INTEGER, INTENT( in ) :: STEP(N), FRERE( KEEP(28) ), FILS( N ),
      &                         DAD( KEEP(28) )
       INTEGER, INTENT( inout ) :: NSTK(KEEP(28))
@@ -220,7 +222,7 @@ C
      &        PTRICB, PTRIST, PTRFAC, PROCNODE_STEPS,
      &        FILS, STEP, FRERE, DAD, INFO_P, KEEP, KEEP8, DKEEP,
      &        RHS_ROOT, LRHS_ROOT, MTYPE,
-     &        RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD,
+     &        RHSINTR, LRHSINTR, POSINRHSINTR_FWD,
      &        ISTEP_TO_INIV2, TAB_POS_IN_PERE, 
      &        RHS_BOUNDS, LRHS_BOUNDS, DO_NBSPARSE, FROM_PP
      &        , ERROR_WAS_BROADCASTED_P )
@@ -286,7 +288,7 @@ C
       RETURN
       END SUBROUTINE CMUMPS_SOL_L0OMP_R
       SUBROUTINE CMUMPS_SOL_L0OMP_S(N, MTYPE, NRHS, LIW, IW,
-     &  PTRICB, PTRACB, RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &  PTRICB, PTRACB, RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &  STEP, FRERE, FILS, NE_STEPS, PTRIST, PTRFAC, INFO,
      &  KEEP, KEEP8, DKEEP, PROCNODE_STEPS, SLAVEF,
      &  COMM, MYID, BUFR, LBUFR, LBUFR_BYTES, RHS_ROOT, LRHS_ROOT, 
@@ -307,8 +309,8 @@ C
       INTEGER, INTENT( in ) :: PROCNODE_STEPS( KEEP(28) )
       INTEGER               :: PTRICB( KEEP(28) ) 
       INTEGER(8)            :: PTRACB( KEEP(28) ) 
-      INTEGER, INTENT( in ) :: POSINRHSCOMP_BWD(N), LRHSCOMP 
-      COMPLEX, INTENT(inout):: RHSCOMP(LRHSCOMP,NRHS)
+      INTEGER, INTENT( in ) :: POSINRHSINTR_BWD(N), LRHSINTR 
+      COMPLEX, INTENT(inout):: RHSINTR(LRHSINTR,NRHS)
       INTEGER, INTENT( in ) :: STEP(N), FRERE( KEEP(28) ), FILS( N )
       INTEGER, INTENT( inout ) :: NE_STEPS(KEEP(28))
       INTEGER, INTENT( in )    :: PTRIST(KEEP(28))
@@ -440,7 +442,7 @@ C
      &      IIPOOL_P,  NBFIN_DUMMY, L0_OMP_FACTORS(IL0OMPFAC)%A(1),
      &      L0_OMP_FACTORS(IL0OMPFAC)%LA, IW, LIW, 
      &      WCB_P, LWCB_P, NRHS, POSWCB_P, PLEFTWCB_P, POSIWCB_P,
-     &      RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &      RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &      PTRICB, PTRACB, IWCB_P, LIWCB_P, W2_P, NE_STEPS, STEP,
      &      FRERE, FILS, PTRIST, PTRFAC, MYLEAF_LEFT_HUGE_P, INFO_P, 
      &      PROCNODE_STEPS,
diff -pruN 5.6.2-2.1/src/csol_root_parallel.F 5.7.1-1/src/csol_root_parallel.F
--- 5.6.2-2.1/src/csol_root_parallel.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/csol_root_parallel.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -29,11 +29,10 @@ C
       INTEGER IERR, NPROW, NPCOL, MYROW, MYCOL
       INTEGER LOCAL_N_RHS
       COMPLEX, ALLOCATABLE, DIMENSION( :,: ) ::RHS_PAR
-      EXTERNAL numroc
-      INTEGER  numroc
+      INTEGER, EXTERNAL :: MUMPS_NUMROC
       INTEGER allocok
       CALL blacs_gridinfo( CNTXT_PAR, NPROW, NPCOL, MYROW, MYCOL )
-      LOCAL_N_RHS = numroc(NRHS, NBLOCK, MYCOL, 0, NPCOL)
+      LOCAL_N_RHS = MUMPS_NUMROC(NRHS, NBLOCK, MYCOL, 0, NPCOL)
       LOCAL_N_RHS = max(1,LOCAL_N_RHS)
       ALLOCATE(RHS_PAR(LOCAL_M, LOCAL_N_RHS),stat=allocok)
       IF (allocok > 0 ) THEN
diff -pruN 5.6.2-2.1/src/cstatic_ptr_m.F 5.7.1-1/src/cstatic_ptr_m.F
--- 5.6.2-2.1/src/cstatic_ptr_m.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/cstatic_ptr_m.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/ctools.F 5.7.1-1/src/ctools.F
--- 5.6.2-2.1/src/ctools.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/ctools.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -638,14 +638,6 @@ C
      & '    Total space in MBytes, OOC factorization     (INFOG(39)):'
      &        ,INFOG(39)
       END IF
-      IF ( PROKG.AND.SUM_OF_PEAKS) THEN
-       WRITE( MPG,'(A,A)') 
-     & ' Estimations with BLR compression of only',
-     & ' Contribution Blocks (CB):'
-       WRITE( MPG,'(A,I6,A) ')
-     & ' ICNTL(39) Estimated compression rate of CB         =', 
-     &   KEEP(465), '/1000'
-      ENDIF
       IF (SUM_OF_PEAKS) THEN
        OOC_STAT  =  0  
        BLR_STRAT =  3  
@@ -686,16 +678,6 @@ C
           LRCB_UD(3) = LRCB_UD(2)/NSLAVES
         ENDIF
        ENDIF
-       IF ( PROKG.AND.SUM_OF_PEAKS ) THEN
-        IF (COMPUTE_MAXAVG) THEN
-         WRITE( MPG,'(A,I12) ')
-     & '    Maximum estim. space in Mbytes, IC facto.    (INFOG(44)):',
-     &        INFOG(44)
-        ENDIF
-        WRITE(MPG,'(A,I12) ')
-     & '    Total space in MBytes, IC factorization      (INFOG(45)):'
-     &        ,INFOG(45)
-       END IF
        OOC_STAT  =  1  
        BLR_STRAT =  3  
        BLR_CASE  =  1  
@@ -735,16 +717,6 @@ C
           OOC_LRCB_UD(3) = OOC_LRCB_UD(2)/NSLAVES
         ENDIF
        ENDIF
-       IF ( PROKG.AND.SUM_OF_PEAKS  ) THEN
-        IF (COMPUTE_MAXAVG) THEN
-         WRITE( MPG,'(A,I12) ')
-     & '    Maximum estim. space in Mbytes, OOC facto.   (INFOG(46)):',
-     &        INFOG(46)
-        ENDIF
-        WRITE(MPG,'(A,I12) ')
-     & '    Total space in MBytes, OOC factorization     (INFOG(47)):'
-     &        ,INFOG(47)
-       END IF
       END IF
       IF ( PROKG.AND.SUM_OF_PEAKS  ) THEN
        WRITE( MPG,'(A,A)') 
@@ -927,7 +899,7 @@ C
       NB_INT = NB_INT + 5_8 * NSTEPS8
       NB_INT = NB_INT + NSTEPS8 + int(KEEP(56),8)*int(NSLAVES+2,8)
         NB_INT = NB_INT + 3_8*N8 + KEEP(280)
-        IF (KEEP(38) .NE. 0) NB_INT = NB_INT + N8
+        IF (KEEP(38) .NE. 0 .AND.I_AM_SLAVE) NB_INT = NB_INT + N8 
       IF (KEEP(23).ne.0 .and. I_AM_MASTER) NB_INT=NB_INT + N8
       IF (KEEP(55).eq.0) THEN
         NB_INT = NB_INT + KEEP(193)*I8OVERI
@@ -1128,9 +1100,6 @@ C
      &         .and. KEEP(55) .ne. 0 ) ) THEN
         NB_INT  = NB_INT  + KEEP8(27)
       END IF
-      IF ( I_AM_SLAVE .and. KEEP(38) .ne. 0 ) THEN
-        NB_INT = NB_INT + N8
-      END IF
       TEMPI= 0_8
       TEMPR = 0_8
       NBRECORDS = KEEP(39)
@@ -1971,10 +1940,10 @@ C
      &  NB_INT=NB_INT+size(id%I_AM_CAND)
       IF (associated(id%MEM_DIST)) 
      &  NB_INT=NB_INT+size(id%MEM_DIST)
-      IF (associated(id%POSINRHSCOMP_ROW))
-     &     NB_INT=NB_INT+size(id%POSINRHSCOMP_ROW)
-      IF(id%POSINRHSCOMP_COL_ALLOC.AND.associated(id%POSINRHSCOMP_COL))
-     &     NB_INT=NB_INT+size(id%POSINRHSCOMP_COL)
+      IF (associated(id%GLOB2LOC_RHS))
+     &     NB_INT=NB_INT+size(id%GLOB2LOC_RHS)
+      IF(id%GLOB2LOC_SOL_ALLOC.AND.associated(id%GLOB2LOC_SOL))
+     &     NB_INT=NB_INT+size(id%GLOB2LOC_SOL)
       IF       (associated(id%MEM_SUBTREE))
      &  NB_REAL=NB_REAL+size(id%MEM_SUBTREE)*(id%KEEP(35)/id%KEEP(16))
       IF       (associated(id%MY_ROOT_SBTR))
@@ -2055,12 +2024,16 @@ C
      &     NB_CMPLX=NB_CMPLX+size(id%root%SVD_VT)
       IF (associated(id%root%SINGULAR_VALUES))
      &     NB_REAL=NB_REAL+size(id%root%SINGULAR_VALUES)
-      IF (associated(id%RHSCOMP)) NB_CMPLX = NB_CMPLX + id%KEEP8(25)
+      IF (associated(id%RHSINTR)) NB_CMPLX = NB_CMPLX + id%KEEP8(25)
       IF (associated(id%S))       NB_CMPLX=NB_CMPLX+id%KEEP8(23)
       IF (associated(id%COLSCA).AND.(id%KEEP(52).NE.-1))
      &     NB_REAL=NB_REAL+size(id%COLSCA)
       IF (associated(id%ROWSCA).AND.(id%KEEP(52).NE.-1))
      &     NB_REAL=NB_REAL+size(id%ROWSCA)
+      IF (associated(id%ROWSCA_loc)) 
+     &     NB_REAL=NB_REAL+size(id%ROWSCA_loc)
+      IF (associated(id%COLSCA_loc).AND.id%KEEP(50).EQ.0)
+     &     NB_REAL=NB_REAL+size(id%COLSCA_loc)
       NB_REAL=NB_REAL+size(id%CNTL)
       NB_REAL=NB_REAL+size(id%RINFO)
       NB_REAL=NB_REAL+size(id%RINFOG)
@@ -2083,7 +2056,6 @@ C
       INTEGER(8) :: SHIFT8, HUG8
       INTEGER    :: I, I4SIZE
       IF(int(huge(I4SIZE),8) .EQ. int(huge(HUG8),8)) THEN
-         CALL ccopy(N8, SRC(1), 1, DEST(1), 1)
          CALL ccopy(int(N8), SRC(1), 1, DEST(1), 1)
       ELSE
          HUG8=int(huge(I4SIZE),8)
diff -pruN 5.6.2-2.1/src/ctype3_root.F 5.7.1-1/src/ctype3_root.F
--- 5.6.2-2.1/src/ctype3_root.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/ctype3_root.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -127,7 +127,7 @@ C
       DOUBLE PRECISION OPASSW, OPELIW
       INTEGER PROCNODE_STEPS( KEEP(28) )
       INTEGER ITLOC( N + KEEP(253) ), FILS( N ), DAD(KEEP(28))
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INTEGER ND( KEEP(28) ), FRERE( KEEP(28) )
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
@@ -161,8 +161,6 @@ C
       INCLUDE 'mumps_headers.h'
       LOGICAL SKIPLAST_RHS_ROWS, BCP_SYM_NONEMPTY
       INTEGER BBPCBP
-      INTEGER MUMPS_PROCNODE
-      EXTERNAL MUMPS_PROCNODE
       BBPCBP  = 0   
       LP = ICNTL(1)
       IF ( ICNTL(4) .LE. 0 ) LP = -1
@@ -1176,7 +1174,7 @@ C
       INTEGER(8) :: PTRAST(KEEP(28)), PAMASTER(KEEP(28))
       INTEGER PIMASTER(KEEP(28))
       INTEGER ITLOC( N + KEEP(253) )
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INTEGER COMP, IFLAG, IERROR
       INCLUDE 'mumps_headers.h'
       INTEGER FILS( N ), DAD(KEEP(28))
@@ -1189,20 +1187,19 @@ C
       INTEGER, INTENT(IN) :: PTRDEBARR(KEEP(196))
       INTEGER INTARR(KEEP8(27))
       COMPLEX DBLARR(KEEP8(26))
-      INTEGER numroc
-      EXTERNAL numroc
+      INTEGER, EXTERNAL :: MUMPS_NUMROC
       COMPLEX ZERO
       PARAMETER( ZERO = (0.0E0,0.0E0) )
       INTEGER(8) :: LREQA_ROOT
       INTEGER LREQI_ROOT, LOCAL_M, LOCAL_N, allocok
       LOGICAL :: EARLYT3ROOTINS
-          LOCAL_M = numroc( root%ROOT_SIZE, root%MBLOCK,
+          LOCAL_M = MUMPS_NUMROC( root%ROOT_SIZE, root%MBLOCK,
      &              root%MYROW, 0, root%NPROW )
           LOCAL_M = max( 1, LOCAL_M )
-          LOCAL_N = numroc( root%ROOT_SIZE, root%NBLOCK,
+          LOCAL_N = MUMPS_NUMROC( root%ROOT_SIZE, root%NBLOCK,
      &              root%MYCOL, 0, root%NPCOL )
           IF (KEEP(253).GT.0) THEN
-            root%RHS_NLOC = numroc( KEEP(253), root%NBLOCK,
+            root%RHS_NLOC = MUMPS_NUMROC( KEEP(253), root%NBLOCK,
      &              root%MYCOL, 0, root%NPCOL )
             root%RHS_NLOC = max(1, root%RHS_NLOC)
           ELSE
@@ -1220,7 +1217,7 @@ C
           IF (KEEP(253).NE.0) THEN
             root%RHS_ROOT = ZERO
             CALL CMUMPS_ASM_RHS_ROOT (  N, FILS, 
-     &           root, KEEP, RHS_MUMPS, 
+     &           root, KEEP, KEEP8, RHS_MUMPS, 
      &           IFLAG, IERROR )
             IF ( IFLAG .LT. 0 ) RETURN
           ENDIF
@@ -1373,14 +1370,15 @@ C
       RETURN
       END SUBROUTINE CMUMPS_ASM_ELT_ROOT
       SUBROUTINE CMUMPS_ASM_RHS_ROOT
-     &           ( N, FILS, root, KEEP, RHS_MUMPS, 
+     &           ( N, FILS, root, KEEP, KEEP8, RHS_MUMPS, 
      &             IFLAG, IERROR )
       USE CMUMPS_STRUC_DEF, ONLY : CMUMPS_ROOT_STRUC
       IMPLICIT NONE
       INTEGER N, KEEP(500), IFLAG, IERROR
+      INTEGER(8) :: KEEP8(150)
       INTEGER FILS(N)
       TYPE (CMUMPS_ROOT_STRUC ) :: root
-      COMPLEX :: RHS_MUMPS(KEEP(255))
+      COMPLEX :: RHS_MUMPS(KEEP8(85))
       INTEGER JCOL, IPOS_ROOT, JPOS_ROOT,
      &        IROW_GRID, JCOL_GRID, ILOCRHS, JLOCRHS,
      &        INODE
diff -pruN 5.6.2-2.1/src/dana_LDLT_preprocess.F 5.7.1-1/src/dana_LDLT_preprocess.F
--- 5.6.2-2.1/src/dana_LDLT_preprocess.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/dana_LDLT_preprocess.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/dana_aux.F 5.7.1-1/src/dana_aux.F
--- 5.6.2-2.1/src/dana_aux.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/dana_aux.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -50,7 +50,7 @@ C
       INTEGER, INTENT(IN)    :: METIS_OPTIONS(40)
 #endif      
       INTEGER, INTENT(IN), OPTIONAL     :: NORIG_ARG
-      INTEGER, INTENT(IN), OPTIONAL     :: SIZEOFBLOCKS(N)
+      INTEGER, INTENT(IN), TARGET, OPTIONAL  :: SIZEOFBLOCKS(N)
       LOGICAL, INTENT(IN), OPTIONAL     :: GCOMP_PROVIDED_IN
       TYPE(COMPACT_GRAPH_T), OPTIONAL   :: GCOMP
       INTEGER, DIMENSION(:), ALLOCATABLE, TARGET :: IWALLOC
@@ -92,10 +92,9 @@ C
       PARAMETER (MINSYM=50)
       INTEGER(8) :: K79REF
       PARAMETER(K79REF=12000000_8)
-      INTEGER, PARAMETER :: LIDUMMY = 1 
-      INTEGER            :: IDUMMY(1)   
       INTEGER MTRANS, COMPRESS,NCMP,IERROR,J,JPERM,NCST
       INTEGER TOTEL 
+      INTEGER NFR
 #if defined(pord)
       INTEGER TOTW
 #endif
@@ -103,6 +102,8 @@ C
 #if defined(scotch) || defined(ptscotch)
       INTEGER WEIGHTREQUESTED
 #endif
+      INTEGER HOW_TO_SPLIT_ROOT, INODE_Scalapack_CAND, 
+     &        NBSONS_Scalapack_CAND
       LOGICAL SCOTCH_SYMBOLIC
       LOGICAL IDENT,SPLITROOT
       LOGICAL FREE_CENTRALIZED_MATRIX
@@ -110,32 +111,22 @@ C
       LOGICAL INPLACE64_GRAPH_COPY, INPLACE64_RESTORE_GRAPH
       INTEGER(8) :: LIW8, NZG8
       DOUBLE PRECISION TIMEB
+      INTEGER, POINTER, DIMENSION(:) :: SIZEOFBLOCKS_PTR
+      INTEGER, TARGET    :: IDUMMY_ARRAY(1)
+      INTEGER            :: LSIZEOFBLOCKS_PTR
+      LOGICAL            :: SIZEOFBLOCKS_AVAIL
       EXTERNAL MUMPS_ANA_H, DMUMPS_ANA_J, 
      &     DMUMPS_ANA_K, DMUMPS_ANA_GNEW,
      &     DMUMPS_ANA_LNEW, DMUMPS_ANA_M
       EXTERNAL DMUMPS_GNEW_SCHUR
       EXTERNAL DMUMPS_LDLT_COMPRESS, DMUMPS_EXPAND_PERMUTATION,
      &     DMUMPS_SET_CONSTRAINTS
-      IF (LIWALLOC.GT.0_8) THEN
-        ALLOCATE( IWALLOC (LIWALLOC), stat = IERR )
-        IF ( IERR .GT. 0 ) THEN
-         INFO( 1 ) = -7
-         CALL MUMPS_SET_IERROR(LIWALLOC,INFO(2))
-         GOTO 90                
-        ENDIF
-      ENDIF
       ALLOCATE( IWL1 (N), stat = IERR )
       IF ( IERR .GT. 0 ) THEN
          INFO( 1 ) = -7
          INFO( 2 ) = N
          GOTO 90                
       ENDIF
-      ALLOCATE( IPEALLOC(N+1), stat = IERR )
-      IF ( IERR .GT. 0 ) THEN
-         INFO( 1 ) = -7
-         INFO( 2 ) = (N+1)*KEEP(10)
-         GOTO 90                
-      ENDIF
       ALLOCATE( PTRAR (N,3), stat = IERR )
       IF ( IERR .GT. 0 ) THEN
          INFO( 1 ) = -7
@@ -143,6 +134,9 @@ C
          GOTO 90                
       ENDIF
       SCOTCH_SYMBOLIC=(KEEP(270).EQ.0) 
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+      SCOTCH_SYMBOLIC=.FALSE.
+#endif
       symmetry      = INFO(8)
       NBQD          = 0
       GCOMP_PROVIDED=.FALSE.
@@ -160,13 +154,6 @@ C
         INFO(2) = 1
         RETURN
       ENDIF
-      IF ( (LIWALLOC.EQ.0_8).AND.(.not.GCOMP_PROVIDED)) THEN
-        INFO(1) = -900
-        WRITE(6,*) " INTERNAL ERROR in MUMPS(ANA_F) ", 
-     &  "LIWALLOC, GCOMP_PROVIDED=", LIWALLOC, GCOMP_PROVIDED
-        INFO(2) = 2
-        RETURN
-      ENDIF
       IF (GCOMP_PROVIDED) THEN
         NZG8 =  GCOMP%NZG
         LIW8 =  NZG8 + int(GCOMP%NG,8)+1_8
@@ -176,9 +163,30 @@ C
           PTRAR(I,2) = int(IPE(I+1)-IPE(I))
          ENDDO
       ELSE
+        IF (LIWALLOC.GT.0_8) THEN
+          ALLOCATE( IWALLOC (LIWALLOC), stat = IERR )
+          IF ( IERR .GT. 0 ) THEN
+           INFO( 1 ) = -7
+           CALL MUMPS_SET_IERROR(LIWALLOC,INFO(2))
+           GOTO 90                
+          ENDIF
+        ENDIF
+        IF ( LIWALLOC.EQ.0_8 ) THEN
+          INFO(1) = -900
+          WRITE(6,*) " INTERNAL ERROR in MUMPS(ANA_F) ", 
+     &    "LIWALLOC, GCOMP_PROVIDED=", LIWALLOC, GCOMP_PROVIDED
+          INFO(2) = 2
+          RETURN
+        ENDIF
         LIW8 =  LIWALLOC
-        NZG8 = NZ8
+        NZG8 =  NZ8
         IW   => IWALLOC(1:LIW8)
+        ALLOCATE( IPEALLOC(N+1), stat = IERR )
+        IF ( IERR .GT. 0 ) THEN
+          INFO( 1 ) = -7
+          INFO( 2 ) = (N+1)*KEEP(10)
+          GOTO 90                
+        ENDIF
         IPE  => IPEALLOC(1:N+1)
       ENDIF
       LP    = ICNTL(1)
@@ -187,6 +195,16 @@ C
       PROK  = ((MP.GT.0).AND.(ICNTL(4).GE.2))
       LDIAG = ICNTL(4)
       COMPRESS_SCHUR = .FALSE.
+      IF (present(SIZEOFBLOCKS)) THEN
+       SIZEOFBLOCKS_PTR => SIZEOFBLOCKS(1:N)
+       LSIZEOFBLOCKS_PTR = N
+       SIZEOFBLOCKS_AVAIL = .TRUE.
+      ELSE
+       SIZEOFBLOCKS_PTR => IDUMMY_ARRAY
+       SIZEOFBLOCKS_AVAIL = .FALSE.
+       LSIZEOFBLOCKS_PTR = 1
+       IDUMMY_ARRAY(1) = -1
+      ENDIF
       IF (PROK) THEN
         IF (present(GCOMP)) THEN
          WRITE(MP,'(A,I10,A,I13,A)') " Processing a graph of size:", N
@@ -228,7 +246,7 @@ C
           WRITE (MP,99999) N, NZG8, LIW8, INFO(1)
           IF (J8.GT.0_8) WRITE (MP,99998) (IRN(I8),ICN(I8),I8=1_8,J8)
         ENDIF
-         K = min0(10,N)
+         K = min(10,N)
          IF (LDIAG.EQ.4) K = N
          IF (IORD.EQ.1 .AND. K.GT.0) THEN
             WRITE (MP,99997) (IKEEP1(I),I=1,K)
@@ -609,7 +627,7 @@ C
      &              PARENT, IWFR8,
      &              PTRAR(1,2), IW, IWL1, IKEEP1,
      &              IKEEP2, NCMPA, INFO, LP, LPOK, KEEP(10),
-     &              INPLACE64_GRAPH_COPY,
+     &              INPLACE64_GRAPH_COPY, INPLACE64_RESTORE_GRAPH,
      &              WEIGHTUSED, WEIGHTREQUESTED, SCOTCH_SYMBOLIC)
                ELSE
                  WRITE(*,*)
@@ -971,10 +989,10 @@ C
               INFO(1)= -99998
               GOTO 90
            ELSE
-            ALLOCATE( WTEMP ( 2*N ), stat = IERR )
+            ALLOCATE( WTEMP ( 2_8*int(N,8) ), stat = IERR )
             IF ( IERR .GT. 0 ) THEN
                INFO( 1 ) = -7
-               INFO( 2 ) = 2*N
+               CALL MUMPS_SET_IERROR(2_8*int(N,8), INFO(2) )
                GOTO 90          
             ENDIF
             THRESH = -1
@@ -1035,24 +1053,15 @@ C
          INFO( 2 ) = N
          GOTO 90                
       ENDIF
-      IF (present(SIZEOFBLOCKS)) THEN
-       CALL DMUMPS_ANA_LNEW
+      CALL DMUMPS_ANA_LNEW
      &     (N, PARENT, IWL1, IKEEP1(1), IKEEP2(1), IKEEP3(1),
      &     NFSIZ(1), PTRAR, INFO(6), FILS(1), FRERE(1), 
      &     PTRAR(1,3), NEMIN, WTEMP, KEEP(60),
      &     KEEP(20),KEEP(38),PTRAR(1,2),KEEP(104),IW(1),KEEP(50), 
-     &     ICNTL(13), KEEP(37), KEEP(197), NSLAVES, KEEP(250).EQ.1 
-     &     , .TRUE. , SIZEOFBLOCKS, N
+     &     ICNTL(13), KEEP(37), KEEP(197), NSLAVES, KEEP(250).EQ.1,
+     &     SIZEOFBLOCKS_AVAIL, SIZEOFBLOCKS_PTR(1), LSIZEOFBLOCKS_PTR
+     &     , INODE_Scalapack_CAND, NBSONS_Scalapack_CAND, KEEP(11)
      &      )
-      ELSE
-       CALL DMUMPS_ANA_LNEW
-     &     (N, PARENT, IWL1, IKEEP1(1), IKEEP2(1), IKEEP3(1),
-     &     NFSIZ(1), PTRAR, INFO(6), FILS(1), FRERE(1), 
-     &     PTRAR(1,3), NEMIN, WTEMP, KEEP(60),
-     &     KEEP(20),KEEP(38),PTRAR(1,2),KEEP(104),IW(1),KEEP(50), 
-     &     ICNTL(13), KEEP(37), KEEP(197), NSLAVES, KEEP(250).EQ.1 
-     &     , .FALSE., IDUMMY, LIDUMMY )
-      ENDIF
       DEALLOCATE(WTEMP)
       IF (KEEP(60).NE.0)  THEN
          IF (KEEP(60)==1) THEN
@@ -1085,6 +1094,8 @@ C
       IF ( KEEP(53) .NE. 0 ) THEN
          CALL MUMPS_MAKE1ROOT( N, FRERE(1), FILS(1), NFSIZ(1),
      &                         KEEP(20) )
+         INODE_Scalapack_CAND = KEEP(20)
+         NBSONS_Scalapack_CAND = 1
       END IF
       IF (  (KEEP(48) == 4 .AND. KEEP8(21).GT.0_8)
      &     .OR.
@@ -1099,61 +1110,95 @@ C
       IF (KEEP(210).EQ.1.AND.KEEP8(79).LE.0_8) THEN
         KEEP8(79)=K79REF * int(NSLAVES,8)
       ENDIF
-      IF ( (KEEP(79).EQ.0).OR.(KEEP(79).EQ.2).OR.
+      IF (KEEP(11).EQ.0) THEN
+       IF ( (KEEP(79).EQ.0).OR.(KEEP(79).EQ.2).OR.
      &     (KEEP(79).EQ.3).OR.(KEEP(79).EQ.5).OR.
      &     (KEEP(79).EQ.6)
      &   )  THEN
-       IF (KEEP(210).EQ.1) THEN
-        SPLITROOT = .FALSE. 
-        IF ( KEEP(62).GE.1) THEN
-          IWL1(1) = -1
-          IF (present(SIZEOFBLOCKS)) THEN
-            DO I= 1, N
-               IWL1(I) = SIZEOFBLOCKS(I)
-            ENDDO
-          ENDIF
-          CALL DMUMPS_CUTNODES(N, FRERE(1), FILS(1), NFSIZ(1), 
-     &                       IWL1(1), N, INFO(6),
-     &                       NSLAVES, KEEP,KEEP8, SPLITROOT,
-     &                       MP, LDIAG, INFO(1), INFO(2))
-          IF (INFO(1).LT.0) GOTO 90 
-          IF (PROK) THEN
+        IF (KEEP(210).EQ.1) THEN
+         SPLITROOT = .FALSE. 
+         IF ( KEEP(62).GE.1) THEN
+           CALL DMUMPS_CUTNODES(N, FRERE(1), FILS(1), NFSIZ(1), 
+     &         SIZEOFBLOCKS_PTR(1), LSIZEOFBLOCKS_PTR, INFO(6),
+     &         NSLAVES, KEEP,KEEP8, SPLITROOT,
+     &         MP, LDIAG, INFO(1), INFO(2))
+           IF (INFO(1).LT.0) GOTO 90 
+           IF (PROK) THEN
                WRITE(MP,*) " Number of split nodes in pre-splitting=",
      &         KEEP(61)
-          ENDIF
+           ENDIF
+         ENDIF
         ENDIF
        ENDIF
       ENDIF
+      HOW_TO_SPLIT_ROOT = 0 
       SPLITROOT = ICNTL(13) .EQ. -1
+      IF (KEEP(11).GT.1) THEN
+       NFR = NFSIZ(INODE_Scalapack_CAND)
+#if defined(NOSCALAPACK)
+        SPLITROOT = SPLITROOT .OR. 
+     & ( NSLAVES.GT.0.AND. 
+     &   ( dble(NFR) - dble(NFR)/dble(max(2,NSLAVES))
+     &    .GT. dble(KEEP(9)) )
+     & )
+#else
+        SPLITROOT = SPLITROOT .OR.
+     &  ( ICNTL(13).GT.0 .AND. NSLAVES .GT. ICNTL(13). AND.
+     &    ( dble(NFR) - dble(NFR)/dble(max(2,NSLAVES)) 
+     &     .GT. dble(KEEP(9)) )
+     &  )
+#endif
+      ELSE
 #if defined(NOSCALAPACK)
-      SPLITROOT = SPLITROOT .OR. NSLAVES.GT.0
+        SPLITROOT = SPLITROOT .OR. NSLAVES.GT.0
 #else
-      SPLITROOT = SPLITROOT .OR.
-     &            (ICNTL(13).GT.0 .AND. NSLAVES .GT. ICNTL(13))
+        SPLITROOT = SPLITROOT .OR.
+     &            (ICNTL(13).GT.0 .AND. NSLAVES .GT. ICNTL(13)
+     &            )
 #endif
+      ENDIF
+      IF (SPLITROOT.AND.KEEP(11).GT.0) HOW_TO_SPLIT_ROOT =1 
       IF (KEEP(53) .NE. 0) THEN
-         SPLITROOT = .TRUE.
+         SPLITROOT         = .TRUE.
+         IF (KEEP(11).GT.0) HOW_TO_SPLIT_ROOT = 2
+      ENDIF
+#if defined(NOSCALAPACK)
+#else
+      IF ( KEEP(11).GT.0) THEN 
+        IF (.NOT.SPLITROOT .AND. 
+     &    (KEEP(60).EQ.0).AND.   
+     &    ( (NFSIZ(INODE_Scalapack_CAND).GT.KEEP(37))
+     &     .AND.(ICNTL(13).LE.0) )
+     &    .AND.
+     &    (NBSONS_Scalapack_CAND.GT.KEEP(11)) 
+     &    ) THEN
+          HOW_TO_SPLIT_ROOT = 3
+          SPLITROOT=.TRUE.
+        ENDIF
       ENDIF
+#endif
       SPLITROOT = (SPLITROOT.AND.( (KEEP(60).EQ.0) ))
       IF (SPLITROOT) THEN
-         IWL1(1) = -1
-         IF (present(SIZEOFBLOCKS)) THEN
-            DO I= 1, N
-               IWL1(I) = SIZEOFBLOCKS(I)
-            ENDDO
-         ENDIF
-         CALL DMUMPS_CUTNODES(N, FRERE(1), FILS(1), NFSIZ(1), 
-     &                    IWL1(1), N, INFO(6),
-     &                    NSLAVES, KEEP,KEEP8, SPLITROOT,
-     &                    MP, LDIAG, INFO(1), INFO(2))
-         IF (INFO(1).LT.0) GOTO 90 
-         IF ( KEEP(53) .NE. 0 ) THEN
-          CALL MUMPS_MAKE1ROOT( N, FRERE(1), FILS(1), NFSIZ(1),
-     &                          KEEP(20) )
-         ENDIF
+        IF (KEEP(11).EQ.0) THEN
+          CALL DMUMPS_CUTNODES(N, FRERE(1), FILS(1), NFSIZ(1), 
+     &              SIZEOFBLOCKS_PTR(1), LSIZEOFBLOCKS_PTR, INFO(6),
+     &              NSLAVES, KEEP,KEEP8, SPLITROOT,
+     &              MP, LDIAG, INFO(1), INFO(2))
+          IF (INFO(1).LT.0) GOTO 90 
+          IF ( KEEP(53) .NE. 0 ) THEN
+           CALL MUMPS_MAKE1ROOT( N, FRERE(1), FILS(1), NFSIZ(1),
+     &                           KEEP(20) )
+          ENDIF
+        ELSE
+         CALL DMUMPS_SPLIT_ROOT( NSLAVES, 
+     &            HOW_TO_SPLIT_ROOT, INODE_Scalapack_CAND,
+     &            N, FRERE(1), FILS(1), NFSIZ(1), 
+     &            KEEP(1), KEEP8(1),
+     &            SIZEOFBLOCKS_PTR(1), LSIZEOFBLOCKS_PTR, INFO(6))
+        ENDIF
       ENDIF
       IF (LDIAG.GT.2 .AND. MP.GT.0) THEN
-         K = min0(10,N)
+         K = min(10,N)
          IF (LDIAG.EQ.4) K = N
          IF (K.GT.0) WRITE (MP,99987) (NFSIZ(I),I=1,K)
          IF (K.GT.0) WRITE (MP,99989) (FILS(I),I=1,K)
@@ -1250,9 +1295,9 @@ C
  70      CONTINUE
       END IF
       IF (id%KEEP(54) .EQ. 3) THEN
-         CALL MPI_ALLREDUCE(IWORK1(1), NBINCOL(1), id%N,
+         CALL MUMPS_BIGALLREDUCE(.FALSE., IWORK1(1), NBINCOL(1), id%N,
      &        MPI_INTEGER, MPI_SUM, id%COMM, IERR )
-         CALL MPI_ALLREDUCE(IWORK2(1), NBINROW(1), id%N,
+         CALL MUMPS_BIGALLREDUCE(.FALSE., IWORK2(1), NBINROW(1), id%N,
      &        MPI_INTEGER, MPI_SUM, id%COMM, IERR )
          deallocate(IWORK2)
       ELSE
@@ -1263,7 +1308,8 @@ C
       END IF
       RETURN
       END SUBROUTINE DMUMPS_ANA_N_DIST
-      SUBROUTINE DMUMPS_ANA_O( N, NZ, MTRANS, PERM, IKEEPALLOC,
+      SUBROUTINE DMUMPS_ANA_O( N, NZ, MTRANS, PERM,
+     &     IKEEPALLOC, LIKEEPALLOC,
      &     idIRN, idJCN, idA, idROWSCA, idCOLSCA, WORK2, KEEP,
      &     ICNTL, INFO, INFOG )
       IMPLICIT NONE
@@ -1273,7 +1319,8 @@ C
       INTEGER, POINTER, DIMENSION(:) :: idIRN, idJCN
       DOUBLE PRECISION, POINTER, DIMENSION(:) :: idA
       DOUBLE PRECISION, POINTER, DIMENSION(:) :: idROWSCA, idCOLSCA
-      INTEGER, TARGET        :: IKEEPALLOC(3*N)
+      INTEGER(8), INTENT(IN) :: LIKEEPALLOC
+      INTEGER, TARGET        :: IKEEPALLOC(LIKEEPALLOC)
       INTEGER, INTENT(INOUT) :: MTRANS
       INTEGER                :: KEEP(500)
       INTEGER, INTENT(IN)    :: ICNTL(60)
@@ -1398,7 +1445,7 @@ C
          NZTOT = NZ
       ENDIF
       ZERODIAG => IKEEPALLOC(1:N) 
-      STR_KER => IKEEPALLOC(N+1:2*N)
+      STR_KER  => IKEEPALLOC(int(N+1,8):2_8*int(N,8))
       CALL DMUMPS_MTRANSI(ICNTL64,CNTL64)
       ICNTL64(1) = ICNTL(1)
       ICNTL64(2) = ICNTL(2)
@@ -1446,7 +1493,8 @@ C
       ALLOCATE( IPQ8(N), IPE(N+1), stat = allocok )
       IF ( allocok .GT. 0 ) THEN
          INFO( 1 ) = -7
-         INFO( 2 ) = (2*N+1)*KEEP(10)
+         CALL MUMPS_SET_IERROR( (2_8*int(N,8)+1_8) * int(KEEP(10),8),
+     &                         INFO(2) )
          GOTO 500               
       ENDIF
       IF (MTRANSLOC.EQ.1) THEN
@@ -1456,8 +1504,8 @@ C
       IF (MTRANSLOC.EQ.3) LDWMIN = max( NZTOT+1_8 , N8+3_8 )
       IF (MTRANSLOC.EQ.4) LDWMIN = 2_8 * N8 + 
      &                             max( NZTOT , N8+3_8 )
-      IF (MTRANSLOC.EQ.5) LDWMIN = 3_8*N8 + NZTOT
-      IF (MTRANSLOC.EQ.6) LDWMIN = 4_8*N8 + NZTOT
+      IF (MTRANSLOC.EQ.5) LDWMIN = 3_8 * N8 + NZTOT
+      IF (MTRANSLOC.EQ.6) LDWMIN = 4_8 * N8 + NZTOT
       LDW   = LDWMIN
       ALLOCATE(S2(LDW), stat=allocok)
       IF (allocok .GT. 0 ) THEN
@@ -1626,7 +1674,7 @@ C
       ENDIF
       DUPPLI = .FALSE.
       NZsave = NZREAL
-      FLAG => IKEEPALLOC(2*N+1:3*N)
+      FLAG => IKEEPALLOC(2_8*int(N,8)+1:3_8*int(N,8))
       IF(MTRANSLOC.NE.1) THEN
          CALL DMUMPS_SUPPRESS_DUPPLI_VAL(N,NZREAL,IPE(1),IW(IRNW),S2,
      &        PERM(1),IPQ8(1))
@@ -1853,8 +1901,8 @@ C
             ICNTL_SYM_MWM(1) = 0
             ICNTL_SYM_MWM(2) = 1
          ENDIF
-         MARKED => IKEEPALLOC(N+1:2*N)
-         FLAG => IKEEPALLOC(2*N+1:3*N)
+         MARKED  => IKEEPALLOC(    int(N,8)+1_8 : 2_8*int(N,8))
+         FLAG    => IKEEPALLOC(2_8*int(N,8)+1_8 : 3_8*int(N,8))
          PIV_OUT => WORK2(1:N)
          IF(MTRANSLOC .LT. 4) THEN
             LSC = 1
@@ -1976,7 +2024,7 @@ C
    30       IP = LWFR
             JP = IPE(IE)
    40       IW(IWFR) = JS
-            MINJS = min0(MINJS,IPS(JS)+0)
+            MINJS = min(MINJS,IPS(JS)+0)
             IWFR = IWFR + 1_8
    50     CONTINUE
    60     IPE(IE) = int(-ME,8)
@@ -2073,7 +2121,7 @@ C
       LBIG = 0
       DO 100 I=1,N
         L1 = IQ(I)
-        LBIG = max0(L1,LBIG)
+        LBIG = max(L1,LBIG)
         IWFR = IWFR + int(L1,8)
         IPE(I) = IWFR - 1_8
   100 CONTINUE
@@ -2191,6 +2239,8 @@ C
      &               CUMUL,KEEP50, ICNTL13, KEEP37, KEEP197, NSLAVES,
      &               ALLOW_AMALG_TINY_NODES 
      &               , BLKON, SIZEOFBLOCKS, LSIZEOFBLOCKS
+     &               , INODE_Scalapack_CAND, NBSONS_Scalapack_CAND
+     &               , KEEP11
      &               )
       IMPLICIT NONE
       INTEGER  N, NSTEPS, KEEP60, KEEP20, KEEP38, KEEP50
@@ -2208,6 +2258,9 @@ C
       LOGICAL, INTENT(IN) :: BLKON
       INTEGER, INTENT(IN) :: LSIZEOFBLOCKS
       INTEGER, INTENT(IN) :: SIZEOFBLOCKS(LSIZEOFBLOCKS) 
+      INTEGER, INTENT(OUT):: INODE_Scalapack_CAND, 
+     &                       NBSONS_Scalapack_CAND
+      INTEGER, INTENT(IN) :: KEEP11
 #if  defined(NOAMALGTOFATHER)
 #else
 #endif
@@ -2216,6 +2269,8 @@ C
       INTEGER INOS,IB,IL
       INTEGER IPERM
       INTEGER MAXNODE
+      INTEGER SIZE_Scalapack_CAND, NBSONS_current_root
+      LOGICAL ROOT_WITH_FEW_SONS
 #if defined(NOAMALGTOFATHER)
       INTEGER INB,INF,INFS,INL,INSW,INT1,NR1
 #else
@@ -2223,6 +2278,10 @@ C
 #endif
       LOGICAL AMALG_TO_father_OK
       AMALG_COUNT = 0
+      INODE_Scalapack_CAND  = -1
+      NBSONS_Scalapack_CAND = -1
+      SIZE_Scalapack_CAND   = -1
+      NBSONS_current_root   = 0
       DO 10 I=1,N
         CUMUL(I)= 0
         IPS(I)  = 0
@@ -2332,6 +2391,16 @@ C
          NR = NR + 1
          IL = N
          NA(N) = 0
+         NBSONS_current_root =0
+         IF (IPS(I).LT.0) THEN
+          IB = -IPS(I)
+          NBSONS_current_root = NBSONS_current_root + 1
+  69      IB =FRERE(IB)
+          IF (IB.GT.0) THEN
+             NBSONS_current_root = NBSONS_current_root + 1
+             GOTO 69
+          ENDIF
+         ENDIF
         ENDIF
         DO 70 L=1,N
           IF (IPS(I).GE.0) EXIT
@@ -2341,8 +2410,14 @@ C
           IL = IL - 1
           NA(IL) = 0
    70   CONTINUE
-#if ! defined(NOAMALGTOFATHER)
         DADI = -IPE(I)  
+        IF (DADI.EQ.0) THEN
+         IF (NV(I) .GT. SIZE_Scalapack_CAND) THEN
+           INODE_Scalapack_CAND = I
+           SIZE_Scalapack_CAND  = NV(I)
+         ENDIF
+        ENDIF
+#if ! defined(NOAMALGTOFATHER)
         IF ( (DADI.NE.0) .AND.
      &      (
      &       (KEEP60.EQ.0).OR.
@@ -2387,9 +2462,25 @@ C
                  AMALG_TO_father_OK = .FALSE.
               ENDIF
            ENDIF
+           ROOT_WITH_FEW_SONS =.TRUE.
+           IF (KEEP11.GT.0) THEN
+             IF (IPE(DADI).EQ.0) THEN
+                IF 
+     &          (NA(IL)+max(NA(IL+1),NBSONS_current_root)
+     &                    .GT.KEEP11)
+     &          ROOT_WITH_FEW_SONS= .FALSE.
+             ELSE
+                IF 
+     &          (NA(IL)+NA(IL+1)+max(NA(N),NBSONS_current_root)
+     &                    .GT.KEEP11)
+     &          ROOT_WITH_FEW_SONS= .FALSE.
+             ENDIF
+           ENDIF
            IF ( (NV(I).GT. 50*NV(DADI)).AND. (NSLAVES.GT.1) 
      &          .AND. (ICNTL13.LE.0)
-     &          .AND. (NV(I).GT. KEEP37) )  THEN
+     &          .AND. (NV(I).GT. KEEP37) 
+     &          .AND. ROOT_WITH_FEW_SONS
+     &        )  THEN
              IF ( ( ACCU / SIZE_DADI_AMALGAMATED ) .LT. 0.2 ) THEN
                AMALG_TO_father_OK = .TRUE.
              ENDIF
@@ -2536,6 +2627,17 @@ C
         ENDIF
   160 CONTINUE
       NSTEPS = IS - 1
+        I = INODE_Scalapack_CAND
+        INOS = -FILS(I)  
+        NBSONS_Scalapack_CAND = 0
+        IF (INOS.GT.0) THEN
+          NBSONS_Scalapack_CAND = NBSONS_Scalapack_CAND+1
+          INO = FRERE(INOS)
+          DO WHILE (INO.GT.0 .AND. INO.LE.N) 
+           NBSONS_Scalapack_CAND = NBSONS_Scalapack_CAND+1
+           INO = FRERE(INO)
+          ENDDO
+        ENDIF
       DO I=1, N
         IF (NV(I).EQ.0) THEN
           FRERE(I) = N+1
@@ -2647,7 +2749,7 @@ C
       DOUBLE PRECISION, INTENT(IN)       :: RINFO(40), RINFOG(40)
       INCLUDE 'mpif.h'
       INTEGER MASTER, MPG
-      INTEGER ITMP
+      INTEGER ITMP, ICNTL48_EFF
       PARAMETER( MASTER = 0 )
       MPG = ICNTL(3)
       IF ( MYID.eq.MASTER.and.MPG.GT.0.AND.ICNTL(4).GE.2) THEN
@@ -2655,12 +2757,17 @@ C
        IF (ICNTL(15).EQ.0) THEN
           ITMP = 0
        ENDIF
+       IF (KEEP(400).GT.0) THEN 
+          ICNTL48_EFF=1
+       ELSE
+          ICNTL48_EFF=0
+       ENDIF
        WRITE(MPG, 99992) INFO(1), INFO(2),
      &  KEEP8(109), KEEP8(111), INFOG(4),
      &  INFOG(5), KEEP(28), INFOG(32), INFOG(7), KEEP(23), 
-     &  ICNTL(7), ICNTL(13), KEEP(12), 
+     &  ICNTL(7), KEEP(95), ICNTL(13), KEEP(12), 
      &  ITMP,
-     &  ICNTL(18),
+     &  ICNTL(18), KEEP(252), KEEP(494), ICNTL48_EFF,
      &  KEEP(106),
      &  KEEP(56), KEEP(61), RINFOG(1)
        IF (KEEP(95).GT.1)             
@@ -2683,10 +2790,14 @@ C
      &       ' --  (7) Ordering option effectively used       =',I16/
      &       ' ICNTL (6) Maximum transversal option           =',I16/
      &       ' ICNTL (7) Pivot order option                   =',I16/
+     &       ' ICNTL(12) Ordering symmetric indef. matrices   =',I16/
      &       ' ICNTL(13) Parallelism/splitting of root node   =',I16/
      &       ' ICNTL(14) Percentage of memory relaxation      =',I16/
      &       ' ICNTL(15) Analysis by block effectively used   =',I16/
      &       ' ICNTL(18) Distributed input matrix (on if >0)  =',I16/
+     &       ' ICNTL(32) Forward elimination during facto.    =',I16/
+     &       ' ICNTL(35) BLR activation                       =',I16/
+     &       ' ICNTL(48) Tree based multithreading (effective)=',I16/
      &       ' ICNTL(58) Symbolic factorization option        =',I16/
      &       ' Number of level 2 nodes                        =',I16/
      &       ' Number of split nodes                          =',I16/
@@ -3004,6 +3115,138 @@ C
       ENDIF
       RETURN
       END SUBROUTINE DMUMPS_SPLIT_1NODE
+      SUBROUTINE DMUMPS_SPLIT_ROOT
+     & ( NSLAVES, HOW, INODE, N, FRERE, FILS, NFSIZ, KEEP, KEEP8,
+     &   SIZEOFBLOCKS, LSIZEOFBLOCKS, NSTEPS)
+      IMPLICIT NONE
+      INTEGER, INTENT(in)    :: NSLAVES, HOW
+      INTEGER, INTENT(in)    :: INODE, N
+      INTEGER(8), INTENT(in) :: KEEP8(150)
+      INTEGER, INTENT(inout) :: NSTEPS
+      INTEGER, INTENT(inout) :: KEEP(500)
+      INTEGER, INTENT(inout) :: FRERE( N ), FILS( N ), NFSIZ( N )
+      INTEGER, INTENT(IN)    :: LSIZEOFBLOCKS
+      INTEGER, INTENT(IN)    :: SIZEOFBLOCKS(LSIZEOFBLOCKS)
+      LOGICAL    :: BLKON
+      INTEGER(8) :: K79
+      INTEGER I, IN, NPIV, NFRONT
+      INTEGER INODE_SON, INODE_FATH, IN_SON, IN_FATH, IN_GRANDFATH
+      INTEGER NPIV_COMPG, NPIV_SON_COMPG, NPIV_FATH_COMPG
+      INTEGER NPIV_SON, NPIV_FATH, NPIV_TEMP
+      INTEGER, PARAMETER :: K_HOW1 = 4000
+      IF (FRERE(INODE).NE.0) RETURN
+      BLKON = .NOT.(SIZEOFBLOCKS(1).EQ.-1) 
+      K79 = max(KEEP8(79), 4_8)
+      K79 = min(20000_8*20000_8,K79) 
+      IF (KEEP(72).EQ.1) THEN
+          K79 = min(3_8*3_8,K79)
+      ENDIF
+      IF ((HOW.LT.1) .OR. (HOW.GT.3)) THEN
+       RETURN 
+      ENDIF
+      IF (HOW.EQ.2) THEN
+       K79 = min(K79, 121_8*121_8)
+      ENDIF
+      NFRONT = NFSIZ (INODE)
+      NPIV = NFRONT
+      IF (NPIV .LE. 1 ) RETURN
+      IF (BLKON) THEN
+       IN = INODE
+       NPIV_COMPG = 0 
+       DO WHILE( IN > 0 )
+         NPIV_COMPG = NPIV_COMPG + 1
+         IN = FILS( IN )
+       ENDDO
+      ELSE 
+        NPIV_COMPG = NPIV
+      ENDIF
+      IF (HOW.EQ.1) THEN
+        IF ( (NFRONT/2) .LT. K_HOW1 ) RETURN
+        NPIV_FATH = max(NFRONT/max(NSLAVES,2), 1)
+        NPIV_FATH = max(NPIV_FATH, K_HOW1/2)
+        NPIV_FATH = min(NPIV_FATH, max(NFRONT/2,1))
+        NPIV_FATH = min(int(sqrt(dble(K79))), NPIV_FATH)
+        NPIV_SON  = NPIV - NPIV_FATH
+      ELSE IF (HOW.EQ.2) THEN
+        NPIV_FATH = min(int(sqrt(dble(K79))), int(NPIV/2))
+        NPIV_SON  = NPIV - NPIV_FATH
+      ELSE  
+        NPIV_FATH = max(NFRONT - 3*KEEP(6),1) 
+        NPIV_SON  = NPIV - NPIV_FATH
+      ENDIF
+       INODE_SON = INODE
+       IF (BLKON) THEN
+         NPIV_TEMP       = 0
+         NPIV_SON_COMPG  = 0
+         IN_SON = INODE
+         DO WHILE (IN_SON > 0) 
+           NPIV_TEMP = NPIV_TEMP + SIZEOFBLOCKS(IN_SON)
+           NPIV_SON_COMPG  = NPIV_SON_COMPG +1
+           IF (NPIV_TEMP.GE.NPIV_SON) EXIT
+           IN_SON = FILS( IN_SON )
+         END DO
+         NPIV_FATH_COMPG = NPIV_COMPG - NPIV_SON_COMPG
+         NPIV_SON        = NPIV_TEMP
+         NPIV_FATH       = NPIV - NPIV_SON 
+       ELSE
+         NPIV_SON_COMPG  = NPIV_SON
+         NPIV_FATH_COMPG = NPIV_FATH
+         IN_SON = INODE
+         DO I = 1, NPIV_SON_COMPG - 1
+           IN_SON = FILS( IN_SON )
+         END DO
+       ENDIF
+       IF (NPIV_FATH_COMPG.EQ.0)  RETURN
+       INODE_FATH = FILS( IN_SON )
+       IF ( INODE_FATH .LT. 0 ) THEN
+       write(*,*) 'Error: INODE_FATH < 0 ', INODE_FATH
+       END IF
+       IN_FATH = INODE_FATH
+       DO WHILE ( FILS( IN_FATH ) > 0 )
+         IN_FATH = FILS( IN_FATH )
+       END DO
+       FRERE( INODE_FATH ) = FRERE( INODE_SON )
+       FRERE( INODE_SON  ) = - INODE_FATH
+       FILS ( IN_SON     ) = FILS( IN_FATH )
+       FILS ( IN_FATH    ) = - INODE_SON
+       IN = FRERE( INODE_FATH )
+       DO WHILE ( IN > 0 )
+           IN = FRERE( IN )
+       END DO
+       IF ( IN .eq. 0 )  GO TO 10
+       IN = -IN
+       DO WHILE ( FILS( IN ) > 0 )
+           IN = FILS( IN )
+       END DO
+       IN_GRANDFATH = IN
+       IF ( FILS( IN_GRANDFATH ) .eq. - INODE_SON ) THEN
+           FILS( IN_GRANDFATH ) = -INODE_FATH
+       ELSE
+           IN = IN_GRANDFATH
+           IN = - FILS ( IN )
+           DO WHILE ( FRERE( IN ) > 0 )
+             IF ( FRERE( IN ) .eq. INODE_SON ) THEN
+               FRERE( IN ) = INODE_FATH
+               GOTO 10
+             END IF
+             IN = FRERE( IN )
+           END DO
+           WRITE(*,*) 'ERROR 2 in SPLIT NODE',
+     &          IN_GRANDFATH, IN, FRERE(IN)
+       END IF
+ 10    CONTINUE
+       NFSIZ(INODE_SON) = NFRONT
+       NFSIZ(INODE_FATH) = NFRONT - NPIV_SON
+       KEEP(2) = max( KEEP(2), NFRONT - NPIV_SON )
+       NSTEPS  = NSTEPS + 1
+       IF ( (KEEP(53).EQ.0) .AND. NSLAVES.GT.1) THEN
+         KEEP(38) = INODE_FATH
+       ENDIF
+       IF ( KEEP(53).NE.0 ) THEN
+         KEEP(20) = INODE_FATH
+       ENDIF
+      RETURN
+      END SUBROUTINE DMUMPS_SPLIT_ROOT
       SUBROUTINE DMUMPS_ANA_GNEW
      & (N, NZ, IRN, ICN, IW, LW, IPE, LEN,
      & IQ, FLAG, IWFR,
@@ -3415,7 +3658,7 @@ C
      &         DMUMPS_MTRANSS,DMUMPS_MTRANSW
       INTRINSIC abs,log
       RINF = CNTL(2)
-      RINF2 = huge(RINF2)/dble(2*N)
+      RINF2 = huge(RINF2)/dble(int(2,8)*int(N,8))
       RINF3 = 0.0D0
       WARN1 = 0
       WARN2 = 0
@@ -3444,12 +3687,12 @@ C
          IF (ICNTL(1).GE.0) WRITE(ICNTL(1),9001) INFO(1),'NE',NE
          GO TO 99
       ENDIF
-      IF (JOB.EQ.1) K = int(4*N +   M,8)
-      IF (JOB.EQ.2) K = int(N + 2*M,8)
-      IF (JOB.EQ.3) K = int(8*N + 2*M + NE,8)
-      IF (JOB.EQ.4) K = int(N + M,8)
-      IF (JOB.EQ.5) K = int(3*N + 2*M,8)
-      IF (JOB.EQ.6) K = int(3*N + 2*M + NE,8)
+      IF (JOB.EQ.1) K = 4_8*int(N,8)+int(M,8)
+      IF (JOB.EQ.2) K = int(N,8) + 2_8*int(M,8)
+      IF (JOB.EQ.3) K = 8_8*int(N,8) + 2*int(M,8) + NE
+      IF (JOB.EQ.4) K = int(N,8) + int(M,8)
+      IF (JOB.EQ.5) K = 3_8*int(N,8) + 2_8*int(M,8)
+      IF (JOB.EQ.6) K = 3_8*int(N,8) + 2_8*int(M,8) + NE
       IF (LIW.LT.K) THEN
          INFO(1) = -4
          CALL MUMPS_SET_IERROR(K,INFO(2))
@@ -3457,11 +3700,11 @@ C
          GO TO 99
       ENDIF
       IF (JOB.GT.1) THEN
-         IF (JOB.EQ.2) K = int(      M,8)
+         IF (JOB.EQ.2) K = int(M,8)
          IF (JOB.EQ.3) K = int(1,8)
-         IF (JOB.EQ.4) K = int(    2*M,8)
-         IF (JOB.EQ.5) K = int(N + 2*M,8)
-         IF (JOB.EQ.6) K = int(N + 3*M,8)
+         IF (JOB.EQ.4) K = 2_8*int(M,8)
+         IF (JOB.EQ.5) K = int(N,8) + 2_8*int(M,8)
+         IF (JOB.EQ.6) K = int(N,8) + 3_8*int(M,8)
          IF (LDW .LT. K) THEN
             INFO(1) = -5
             CALL MUMPS_SET_IERROR(K,INFO(2))
@@ -3518,13 +3761,18 @@ C
             IW(J) = int(IP(J+1) - IP(J))
  10      CONTINUE
          CALL DMUMPS_MTRANSZ(M,N,IRN,NE,IP,IW(1),PERM,NUM,
-     &        IW(N+1),IW(2*N+1),IW(3*N+1),IW(3*N+M+1))
+     &        IW(    int(N,8)+1_8),
+     &        IW(2_8*int(N,8)+1_8),
+     &        IW(3_8*int(N,8)+1_8),
+     &        IW(3_8*int(N,8)+int(M,8)+1_8))
          GO TO 90
       ENDIF
       IF (JOB.EQ.2) THEN
          DW(1) = max(ZERO,CNTL(1))
          CALL DMUMPS_MTRANSB(M,N,NE,IP,IRN,A,PERM,NUM,
-     &        IW(1),IPQ8,IW(N+1),IW(N+M+1),DW,RINF2)
+     &        IW(1),IPQ8,IW(int(N,8)+1_8),
+     &        IW(int(N,8)+int(M,8)+1_8),
+     &        DW,RINF2)
          GO TO 90
       ENDIF
       IF (JOB.EQ.3) THEN
@@ -3533,16 +3781,21 @@ C
  20      CONTINUE
          CALL DMUMPS_MTRANSR(N,NE,IP,IW,A)
          FACT = max(ZERO,CNTL(1))
-         CALL DMUMPS_MTRANSS(M,N,NE,IP,IW(1),A,PERM,NUM,IW(NE+1),
-     &        IW(NE+N+1),IW(NE+2*N+1),IW(NE+3*N+1),IW(NE+4*N+1),
-     &        IW(NE+5*N+1),IW(NE+5*N+M+1),FACT,RINF2)
+         CALL DMUMPS_MTRANSS(M,N,NE,IP,IW(1),A,PERM,NUM,IW(NE+1_8),
+     &        IW(NE+int(N,8)+1_8),IW(NE+2_8*int(N,8)+1_8),
+     &        IW(NE+3_8*int(N,8)+1_8),
+     &        IW(NE+4_8*int(N,8)+1_8),
+     &        IW(NE+5_8*int(N,8)+1_8),
+     &        IW(NE+5_8*int(N,8)+int(M,8)+1_8),
+     &        FACT,RINF2)
          GO TO 90
       ENDIF
       IF ((JOB.EQ.4).OR.(JOB.EQ.5).or.(JOB.EQ.6)) THEN
-           ALLOCATE(IWtemp8(M+N+N), stat=allocok)
+           ALLOCATE(IWtemp8(int(M,8)+int(N,8)+int(N,8)), stat=allocok)
            IF (allocok.GT.0) THEN
              INFOMUMPS(1) = -7
-             INFOMUMPS(2) = M+N+N
+             CALL MUMPS_SET_IERROR( int(M,8)+int(N,8)+int(N,8),
+     &                               INFOMUMPS(2) )
              GOTO 90
            ENDIF
       ENDIF
@@ -3561,9 +3814,10 @@ C
          DW(2)      = RINF3
          IWtemp8(1) = int(JOB,8)
          CALL DMUMPS_MTRANSW(M,N,NE,IP,IRN,A,PERM,NUM,
-     &        IWtemp8(1),IW(1),IWtemp8(N+1),IPQ8,IW(N+1),
-     &        IWtemp8(2*N+1),
-     &        DW(1),DW(M+1),RINF2)
+     &        IWtemp8(1),IW(1),IWtemp8(int(N,8)+1_8),IPQ8,
+     &        IW(int(N,8)+1_8),
+     &        IWtemp8(2_8*int(N,8)+1_8),
+     &        DW(1),DW(int(M,8)+1_8),RINF2)
          DEALLOCATE(IWtemp8)  
          GO TO 90
       ENDIF
@@ -3575,7 +3829,7 @@ C
                DO 60 K = IP(J),IP(J+1)-1_8
                   IF (A(K).GT.FACT) FACT = A(K)
  60            CONTINUE
-               DW(2*M+J) = FACT
+               DW(2_8*int(M,8)+int(J,8)) = FACT
                IF (FACT.NE.ZERO) THEN
                   FACT = log(FACT)
                   IF(FACT .GT. RINF3) RINF3=FACT
@@ -3596,38 +3850,40 @@ C
          ENDIF
          IF (JOB.EQ.6) THEN
             DO 175 K = 1,NE
-               IW(3*N+2*M+K) = IRN(K)
+               IW(3_8*int(N,8)+2_8*int(M,8)+int(K,8)) = IRN(K)
  175        CONTINUE
             DO 61 I = 1,M
-               DW(2*M+N+I) = ZERO
+               DW(2_8*int(M,8)+int(N,8)+int(I,8)) = ZERO
  61         CONTINUE
             DO 63 J = 1,N
                DO 62 K = IP(J),IP(J+1)-1_8
                   I = IRN(K)
-                  IF (A(K).GT.DW(2*M+N+I)) THEN
-                     DW(2*M+N+I) = A(K)
+                  IF (A(K).GT.DW(2_8*int(M,8)+int(N,8)+int(I,8))) THEN
+                     DW(2_8*int(M,8)+int(N,8)+int(I,8)) = A(K)
                   ENDIF
  62            CONTINUE
  63         CONTINUE
             DO 64 I = 1,M
-               IF (DW(2*M+N+I).NE.ZERO) THEN
-                  DW(2*M+N+I) = 1.0D0/DW(2*M+N+I)
+               IF (DW(2_8*int(M,8)+int(N,8)+int(I,8)).NE.ZERO) THEN
+                   DW(2_8*int(M,8)+int(N,8)+int(I,8)) =
+     &                      1.0D0/DW(2_8*int(M,8)+int(N,8)+int(I,8))
                ENDIF
  64         CONTINUE
             DO 66 J = 1,N
                DO 65 K = IP(J),IP(J+1)-1
                   I = IRN(K)
-                  A(K) = DW(2*M+N+I) * A(K)
+                  A(K) = DW(2_8*int(M,8)+int(N,8)+int(I,8)) * A(K)
  65            CONTINUE
  66         CONTINUE
-            CALL DMUMPS_MTRANSR(N,NE,IP,IW(3*N+2*M+1),A)
+            CALL DMUMPS_MTRANSR(N,NE,IP,
+     &           IW(3_8*int(N,8)+2_8*int(M,8)+1_8),A)
             DO 176 J = 1,N
                IF (IP(J).NE.IP(J+1)) THEN
                   FACT = A(IP(J))
                ELSE
                   FACT = ZERO
                ENDIF
-               DW(2*M+J) = FACT
+               DW(2_8*int(M,8)+int(J,8)) = FACT
                IF (FACT.NE.ZERO) THEN
                   FACT = log(FACT)
                   DO 170 K = IP(J),IP(J+1)-1_8
@@ -3651,34 +3907,38 @@ C
          IWtemp8(1) = int(JOB,8)
           IF (JOB.EQ.5) THEN
          CALL DMUMPS_MTRANSW(M,N,NE,IP,IRN,A,PERM,NUM,
-     &        IWtemp8(1),IW(1),IWtemp8(N+1),IPQ8,IW(N+1),
-     &        IWtemp8(2*N+1),
-     &        DW(1),DW(M+1),RINF2)
+     &        IWtemp8(1),IW(1),IWtemp8(int(N,8)+1_8),IPQ8,
+     &        IW(int(N,8)+1_8),
+     &        IWtemp8(2_8*int(N,8)+1_8),
+     &        DW(1),DW(int(M,8)+1_8),RINF2)
          ENDIF
          IF (JOB.EQ.6) THEN
-         CALL DMUMPS_MTRANSW(M,N,NE,IP,IW(3*N+2*M+1),A,PERM,NUM,
-     &        IWtemp8(1),IW(1),IWtemp8(N+1),IPQ8,IW(N+1),
-     &        IWtemp8(2*N+1),
-     &        DW(1),DW(M+1),RINF2)
+         CALL DMUMPS_MTRANSW(M,N,NE,IP,
+     &        IW(3_8*int(N,8)+2_8*int(M,8)+1_8),A,PERM,NUM,
+     &        IWtemp8(1),IW(1),IWtemp8(int(N,8)+1_8),IPQ8,
+     &        IW(int(N,8)+1_8),
+     &        IWtemp8(2_8*int(N,8)+1_8),
+     &        DW(1),DW(int(M,8)+1_8),RINF2)
          ENDIF
          IF ((JOB.EQ.5).or.(JOB.EQ.6)) THEN
           DEALLOCATE(IWtemp8)
          ENDIF
          IF (JOB.EQ.6) THEN
-            DO 79 I = 1,M
-               IF (DW(2*M+N+I).NE.0.0D0) THEN
-                  DW(I) = DW(I) + log(DW(2*M+N+I))
-               ENDIF
- 79         CONTINUE
+           DO 79 I = 1,M
+             IF (DW(2_8*int(M,8)+int(N,8)+int(I,8)).NE.0.0D0) THEN
+               DW(I) = DW(I) + log(DW(2_8*int(M,8)+int(N,8)+int(I,8)))
+             ENDIF
+ 79        CONTINUE
          ENDIF
          IF (NUM.EQ.N) THEN
-            DO 80 J = 1,N
-               IF (DW(2*M+J).NE.ZERO) THEN
-                  DW(M+J) = DW(M+J) - log(DW(2*M+J))
-               ELSE
-                  DW(M+J) = ZERO
-               ENDIF
- 80         CONTINUE
+           DO 80 J = 1,N
+             IF (DW(2_8*int(M,8)+int(J,8)).NE.ZERO) THEN
+               DW(int(M,8)+int(J,8)) = DW(int(M,8)+int(J,8)) -
+     &                                 log(DW(2_8*int(M,8)+int(J,8)))
+             ELSE
+               DW(int(M,8)+int(J,8)) = ZERO
+             ENDIF
+ 80        CONTINUE
          ENDIF
          FACT = 0.5D0*log(RINF2)
          DO 86 I = 1,M
@@ -3714,13 +3974,15 @@ C
                WRITE(ICNTL(3),9032) (PERM(J),J=1,min(10,M))
                IF (JOB.EQ.5 .OR. JOB.EQ.6) THEN
                   WRITE(ICNTL(3),9033) (DW(J),J=1,min(10,M))
-                  WRITE(ICNTL(3),9034) (DW(M+J),J=1,min(10,N))
+                  WRITE(ICNTL(3),9034) (DW(int(M,8)+int(J,8)),
+     &                                  J=1,min(10,N))
                ENDIF
             ELSEIF (ICNTL(4).EQ.1) THEN
                WRITE(ICNTL(3),9032) (PERM(J),J=1,M)
                IF (JOB.EQ.5 .OR. JOB.EQ.6) THEN
                   WRITE(ICNTL(3),9033) (DW(J),J=1,M)
-                  WRITE(ICNTL(3),9034) (DW(M+J),J=1,N)
+                  WRITE(ICNTL(3),9034) (DW(int(M,8)+int(J,8)),
+     &                                  J=1,N)
                ENDIF
             ENDIF
          ENDIF
@@ -4003,6 +4265,7 @@ C
       DOUBLE PRECISION PEAK
       INTEGER, intent(IN) :: LSIZEOFBLOCKS
       INTEGER, intent(IN) :: SIZEOFBLOCKS(LSIZEOFBLOCKS)
+      CALL MUMPS_SET_K78_83_91 (NSLAVES,KEEP(78),KEEP(83),KEEP(91))
       CALL MUMPS_DISTRIBUTE(N,NSLAVES,
      &     ICNTL,INFOG, NE, NFSIZ,
      &     FRERE, FILS,
diff -pruN 5.6.2-2.1/src/dana_aux_ELT.F 5.7.1-1/src/dana_aux_ELT.F
--- 5.6.2-2.1/src/dana_aux_ELT.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/dana_aux_ELT.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -24,7 +24,8 @@ C
      &            )
       USE MUMPS_ANA_ORD_WRAPPERS
       IMPLICIT NONE
-      INTEGER, INTENT(IN)    :: N,  NELT, SIZE_SCHUR, NSLAVES, LIW
+      INTEGER, INTENT(IN)    :: N,  NELT, SIZE_SCHUR, NSLAVES
+      INTEGER(8), INTENT(IN) :: LIW
       INTEGER, INTENT(IN)    :: ELTPTR(NELT+1) 
       INTEGER, INTENT(IN)    :: ELTVAR(ELTPTR(NELT+1)-1)
       INTEGER, INTENT(IN)    :: LISTVAR_SCHUR(SIZE_SCHUR)
@@ -38,7 +39,8 @@ C
 #if defined(metis) || defined(parmetis) || defined(metis4) || defined(parmetis3)      
       INTEGER, INTENT(IN)    :: METIS_OPTIONS(40)
 #endif
-      INTEGER K,I,L1,L2,NCMPA,IFSON,IN
+      INTEGER K,I,NCMPA,IFSON,IN
+      INTEGER(8) :: L1, L2
       INTEGER NEMIN, MPRINT, LP, MP, LDIAG
       INTEGER(8)  :: NZ8, LLIW8, IWFR8
       INTEGER allocok, ITEMP
@@ -46,6 +48,8 @@ C
       INTEGER(8) :: K79REF
       PARAMETER(K79REF=12000000_8)
       LOGICAL SPLITROOT
+      INTEGER HOW_TO_SPLIT_ROOT, INODE_Scalapack_CAND, 
+     &        NBSONS_Scalapack_CAND
       INTEGER, PARAMETER :: LIDUMMY = 1
       INTEGER :: IDUMMY(1) 
       INTEGER, DIMENSION(:), ALLOCATABLE :: IW
@@ -73,7 +77,7 @@ C
         ALLOCATE( IW ( LIW ), stat = allocok )
         IF ( allocok .GT. 0 ) THEN
           INFO( 1 ) = -7
-          INFO( 2 ) = LIW
+          CALL MUMPS_SET_IERROR(LIW, INFO( 2 ))
           GOTO 90 
         ENDIF
         ALLOCATE( IPE8 ( N + 1 ), stat = allocok )
@@ -85,7 +89,7 @@ C
         ALLOCATE( PARENT(N), IWtemp ( N, 3 ), stat = allocok )
         IF ( allocok .GT. 0 ) THEN
           INFO( 1 ) = -7
-          INFO( 2 ) = 4*N
+          CALL MUMPS_SET_IERROR(4_8*int(N,8), INFO( 2 ))
           GOTO 90 
         ENDIF
       MPRINT= ICNTL(3)
@@ -118,42 +122,42 @@ C
       NEMIN = KEEP(1)
       IF (LDIAG.LE.2 .OR. MP.LE.0) GO TO 10
       WRITE (MP,99999) N, NELT, LIW, INFO(1)
-      K = min0(10,NELT+1)
+      K = min(10,NELT+1)
       IF (LDIAG.EQ.4) K = NELT+1
       IF (K.GT.0) WRITE (MP,99998) (ELTPTR(I),I=1,K)
-      K = min0(10,ELTPTR(NELT+1)-1)
+      K = min(10,ELTPTR(NELT+1)-1)
       IF (LDIAG.EQ.4) K = ELTPTR(NELT+1)-1
       IF (K.GT.0) WRITE (MP,99995) (ELTVAR(I),I=1,K)
-      K = min0(10,N)
+      K = min(10,N)
       IF (LDIAG.EQ.4) K = N
       IF (IORD.EQ.1 .AND. K.GT.0) THEN
         WRITE (MP,99997) (IKEEP(I,1),I=1,K)
       ENDIF
-   10 L1 = 1
-      L2 = L1 + N
-      IF (LIW .LT. 3*N) THEN
+   10 L1 = 1_8
+      L2 = L1 + int(N,8)
+      IF (LIW .LT. 3_8*int(N,8)) THEN
           INFO(1) = -2002
-          INFO(2) = LIW
+          CALL MUMPS_SET_IERROR( LIW, INFO(2) )
       ENDIF
 #if defined(metis) || defined(parmetis) || defined(metis4) || defined(parmetis3)
       IF ( IORD == 5 ) THEN
-        IF (LIW .LT. N+N+1) THEN
+        IF (LIW .LT. int(N,8)+int(N,8)+1_8) THEN
           INFO(1)= -2002
-          INFO(2) = LIW
+          CALL MUMPS_SET_IERROR( LIW, INFO(2) )
           GOTO 90 
         ENDIF
       ELSE
 #endif
       IF (NOSUPERVAR) THEN
-        IF ( LIW .LT. 2*N ) THEN
+        IF ( LIW .LT. 2_8*int(N,8) ) THEN
           INFO(1)= -2002
-          INFO(2) = LIW
+          CALL MUMPS_SET_IERROR( LIW, INFO(2) )
           GOTO 90 
         END IF
       ELSE
-        IF ( LIW .LT.  4*N+4 ) THEN
+        IF ( LIW .LT.  4_8*int(N,8)+4_8 ) THEN
           INFO(1)= -2002
-          INFO(2) = LIW
+          CALL MUMPS_SET_IERROR( LIW, INFO(2) )
           GOTO 90 
         END IF
       ENDIF
@@ -170,9 +174,9 @@ C
      &              ELTPTR, ELTVAR, XNODEL, NODEL,
      &              IWtemp(1,2), IW(L1))
         ELSE
-         CALL DMUMPS_ANA_G11_ELT(N, NZ8, NELT, ELTPTR(NELT+1)-1, 
+          CALL DMUMPS_ANA_G11_ELT(N, NZ8, NELT, ELTPTR(NELT+1)-1, 
      &              ELTPTR, ELTVAR, XNODEL, NODEL,
-     &              IWtemp(1,2), 4*N+4, IW(L1))
+     &              IWtemp(1,2), 4_8*int(N,8)+4_8, IW(L1))
         ENDIF
         LLIW8 = max(NZ8,int(N,8))
         ALLOCATE( IW2(LLIW8), stat = allocok )
@@ -288,15 +292,15 @@ C
         ENDIF
 #endif
        DO K=1,N
-         IW(L1+K) = 0
+         IW(L1+int(K,8)) = 0
        ENDDO
        DO K=1,N
          IF ((IKEEP(K,1).LE.0).OR.(IKEEP(K,1).GT.N)) 
      &    GO TO 40
-         IF (IW(L1+IKEEP(K,1)).EQ.1) THEN
+         IF (IW(L1+int(IKEEP(K,1),8)).EQ.1) THEN
           GOTO 40
          ELSE
-          IW(L1+IKEEP(K,1)) = 1
+          IW(L1+int(IKEEP(K,1),8)) = 1
          ENDIF
        ENDDO
        CALL DMUMPS_ANA_J1_ELT(N, NZ8, NELT, ELTPTR(NELT+1)-1,
@@ -335,9 +339,10 @@ C
      &     NFSIZ, IWtemp(1,2), 
      &     INFO(6), FILS, FRERE, IWtemp(1,3), NEMIN, 
      &     IW(L2),  KEEP(60), KEEP(20), KEEP(38),
-     &     IW2,KEEP(104),IW(L2+N),KEEP(50),
+     &     IW2,KEEP(104),IW(L2+int(N,8)),KEEP(50),
      &     ICNTL(13), KEEP(37), KEEP(197), NSLAVES, KEEP(250).EQ.1,
-     &     .FALSE., IDUMMY, LIDUMMY)
+     &     .FALSE., IDUMMY, LIDUMMY, 
+     &     INODE_Scalapack_CAND, NBSONS_Scalapack_CAND, KEEP(11) )
       DEALLOCATE(IW2)
       IF (KEEP(60).NE.0) THEN
          IF (KEEP(60)==1) THEN
@@ -368,6 +373,8 @@ C
      &  KEEP(6), KEEP(226), KEEP(253))
       IF ( KEEP(53) .NE. 0 ) THEN
         CALL MUMPS_MAKE1ROOT( N, FRERE, FILS, NFSIZ, KEEP(20) )
+        INODE_Scalapack_CAND  = KEEP(20)
+        NBSONS_Scalapack_CAND = 1
       END IF
       IF ( KEEP(48) == 4 .OR.
      &   ( (KEEP(24).NE.0).AND.(KEEP8(21).GT.0_8) ) ) THEN
@@ -379,23 +386,26 @@ C
       IF (KEEP(210).EQ.1.AND.KEEP8(79).LE.0_8) THEN
         KEEP8(79)=K79REF * int(NSLAVES,8)
       ENDIF
-      IF (KEEP(79).EQ.0) THEN
-       IF (KEEP(210).EQ.1) THEN
-        SPLITROOT = .FALSE. 
-        IF ( KEEP(62).GE.1) THEN
-          IDUMMY(1)= -1
-          CALL DMUMPS_CUTNODES(N, FRERE, FILS, NFSIZ,
-     &                       IDUMMY, LIDUMMY, INFO(6),
-     &                       NSLAVES, KEEP,KEEP8, SPLITROOT,
-     &                       MP, LDIAG, INFO(1), INFO(2))
-          IF (INFO(1).LT.0) GOTO 90 
-          IF (PROK) THEN
-               WRITE(MP,*) " Number of split nodes in pre-splitting=",
-     &         KEEP(61)
+      IF (KEEP(11).EQ.0) THEN
+        IF (KEEP(79).EQ.0) THEN
+         IF (KEEP(210).EQ.1) THEN
+          SPLITROOT = .FALSE. 
+          IF ( KEEP(62).GE.1) THEN
+            IDUMMY(1)= -1
+            CALL DMUMPS_CUTNODES(N, FRERE, FILS, NFSIZ,
+     &                         IDUMMY, LIDUMMY, INFO(6),
+     &                         NSLAVES, KEEP,KEEP8, SPLITROOT,
+     &                         MP, LDIAG, INFO(1), INFO(2))
+            IF (INFO(1).LT.0) GOTO 90 
+            IF (PROK) THEN
+                 WRITE(MP,*) " Number of split nodes in pre-splitting=",
+     &           KEEP(61)
+            ENDIF
           ENDIF
+         ENDIF
         ENDIF
-       ENDIF
       ENDIF
+      HOW_TO_SPLIT_ROOT = 0 
       SPLITROOT = ICNTL(13) .EQ. -1
 #if defined(NOSCALAPACK)
       SPLITROOT = SPLITROOT .OR. NSLAVES.GT.0
@@ -403,23 +413,50 @@ C
       SPLITROOT = SPLITROOT .OR.
      &            (ICNTL(13).GT.0 .AND. NSLAVES .GT. ICNTL(13))
 #endif
+      HOW_TO_SPLIT_ROOT = 0 
+      IF (SPLITROOT.AND.KEEP(11).GT.0) HOW_TO_SPLIT_ROOT =1 
       IF (KEEP(53) .NE. 0) THEN
-         SPLITROOT = .TRUE.
+         SPLITROOT         = .TRUE.
+         IF (KEEP(11).GT.0) HOW_TO_SPLIT_ROOT = 2
       ENDIF
       SPLITROOT = (SPLITROOT.AND.( (KEEP(60).EQ.0) ))
+#if defined(NOSCALAPACK)
+#else
+      IF ( KEEP(11).GT.0) THEN 
+        IF (.NOT.SPLITROOT .AND. 
+     &    (KEEP(60).EQ.0).AND.   
+     &    ( (NFSIZ(INODE_Scalapack_CAND).GT.KEEP(37))
+     &      .AND.(ICNTL(13).LE.0) )
+     &    .AND.
+     &    (NBSONS_Scalapack_CAND.GT.KEEP(11)) 
+     &    ) THEN
+          HOW_TO_SPLIT_ROOT = 3
+          SPLITROOT=.TRUE.
+        ENDIF
+      ENDIF
+#endif
       IF (SPLITROOT) THEN
-         IDUMMY(1) = -1
-         CALL DMUMPS_CUTNODES(N, FRERE, FILS, NFSIZ,
-     &                    IDUMMY, LIDUMMY, INFO(6),
-     &                    NSLAVES, KEEP,KEEP8, SPLITROOT,
-     &                    MP, LDIAG, INFO(1), INFO(2))
-         IF (INFO(1).LT.0) GOTO 90 
-         IF ( KEEP(53) .NE. 0 ) THEN
-          CALL MUMPS_MAKE1ROOT( N, FRERE, FILS, NFSIZ, KEEP(20) )
-         ENDIF
+        IDUMMY(1) = -1
+        IF (KEEP(11).EQ.0) THEN
+          CALL DMUMPS_CUTNODES(N, FRERE(1), FILS(1), NFSIZ(1), 
+     &                     IDUMMY, LIDUMMY, INFO(6),
+     &                     NSLAVES, KEEP,KEEP8, SPLITROOT,
+     &                     MP, LDIAG, INFO(1), INFO(2))
+          IF (INFO(1).LT.0) GOTO 90 
+          IF ( KEEP(53) .NE. 0 ) THEN
+           CALL MUMPS_MAKE1ROOT( N, FRERE(1), FILS(1), NFSIZ(1),
+     &                           KEEP(20) )
+          ENDIF
+        ELSE
+         CALL DMUMPS_SPLIT_ROOT( NSLAVES,
+     &               HOW_TO_SPLIT_ROOT, INODE_Scalapack_CAND,
+     &               N, FRERE(1), FILS(1), NFSIZ(1), 
+     &               KEEP, KEEP8,
+     &               IDUMMY, LIDUMMY, INFO(6))
+        ENDIF
       ENDIF
       IF (LDIAG.GT.2 .AND. MP.GT.0) THEN
-         K = min0(10,N)
+         K = min(10,N)
          IF (LDIAG.EQ.4) K = N
          IF (K.GT.0) WRITE (MP,99997) (IKEEP(I,1),I=1,K)
          IF (K.GT.0) WRITE (MP,99991) (IKEEP(I,2),I=1,K)
@@ -955,7 +992,8 @@ C
      &  XELNOD, ELNOD, XNODEL, NODEL, 
      &  LEN, LW, IW)
       IMPLICIT NONE
-      INTEGER N,NELT,NELNOD,LW
+      INTEGER N,NELT,NELNOD
+      INTEGER(8) :: LW
       INTEGER(8), INTENT(OUT) :: NZ
       INTEGER XELNOD(NELT+1), ELNOD(NELNOD)
       INTEGER LEN(N)
@@ -966,7 +1004,8 @@ C
       EXTERNAL DMUMPS_SUPVAR
       LP = 6
       CALL DMUMPS_SUPVAR(N,NELT,XELNOD(NELT+1)-1,ELNOD,XELNOD,
-     &           NSUP,IW(3*N+3+1),3*N+3,IW,LP,INFO44)
+     &           NSUP,IW(3_8*int(N,8)+3_8+1_8),
+     &           3_8*int(N,8)+3_8,IW,LP,INFO44)
       IF (INFO44(1) .LT. 0) THEN
         IF (LP.GE.0) WRITE(LP,*) 
      &     'Error return from DMUMPS_SUPVAR. INFO(1) = ',INFO44(1) 
@@ -974,7 +1013,7 @@ C
       IW(1:NSUP) = 0
       LEN(1:N) = 0
       DO I = 1,N
-        SUPVAR = IW(3*N+3+1+I)
+        SUPVAR = IW(3_8*int(N,8)+3_8+1_8+int(I,8))
         IF (SUPVAR .EQ. 0) CYCLE
         IF (IW(SUPVAR).NE.0) THEN
           LEN(I) = -IW(SUPVAR)
@@ -982,7 +1021,7 @@ C
           IW(SUPVAR) = I
         ENDIF
       ENDDO
-      IW(N+1:2*N) = 0
+      IW(int(N+1,8):2_8*int(N,8)) = 0
       NZ = 0_8
       DO SUPVAR = 1,NSUP
         I = IW(SUPVAR)
@@ -992,8 +1031,8 @@ C
             J = ELNOD(K3)
             IF ((J.GE.1) .AND. (J.LE.N)) THEN
               IF (LEN(J).GE.0) THEN
-                IF ((I.NE.J) .AND. (IW(N+J).NE.I)) THEN
-                  IW(N+J) = I
+                IF ((I.NE.J) .AND. (IW(int(N,8)+int(J,8)).NE.I)) THEN
+                  IW(int(N,8)+int(J,8)) = I
                   LEN(I) = LEN(I) + 1
                 ENDIF
               ENDIF
@@ -1049,12 +1088,12 @@ C
       END SUBROUTINE DMUMPS_ANA_G12_ELT
       SUBROUTINE DMUMPS_SUPVAR(N,NELT,NZ,ELTVAR,ELTPTR,NSUP,SVAR,
      &                 LIW,IW,LP,INFO)
-      INTEGER LIW,LP,N,NELT,NSUP,NZ
+      INTEGER LP,N,NELT,NSUP,NZ
+      INTEGER(8)::LIW
       INTEGER INFO(6)
       INTEGER ELTPTR(NELT+1),ELTVAR(NZ)
       INTEGER IW(LIW),SVAR(0:N)
-      INTEGER FLAG,NEW,VARS
-      EXTERNAL DMUMPS_SUPVARB
+      INTEGER(8) :: FLAG,NEW,VARS
       INFO(1) = 0
       INFO(2) = 0
       INFO(3) = 0
@@ -1063,19 +1102,20 @@ C
       IF (NELT.LT.1) GO TO 20
       IF (NZ.LT.ELTPTR(NELT+1)-1) GO TO 30
       IF (LIW.LT.6) THEN
-         INFO(4) = 3*N + 3
+         INFO(4) = N + 1
          GO TO 40
       END IF
-      NEW = 1
-      VARS = NEW + LIW/3
-      FLAG = VARS + LIW/3
-      CALL DMUMPS_SUPVARB(N,NELT,ELTPTR,NZ,ELTVAR,SVAR,NSUP,LIW/3-1,
+      NEW = 1_8
+      VARS = NEW + LIW/3_8
+      FLAG = VARS + LIW/3_8
+      CALL DMUMPS_SUPVARB(N,NELT,ELTPTR,NZ,ELTVAR,SVAR,NSUP,
+     &           int(min(int(huge(NSUP)-1,8),LIW/3_8-1_8)),
      &           IW(NEW),IW(VARS),IW(FLAG),INFO)
       IF (INFO(1).EQ.-4) THEN
-         INFO(4) = 3*N + 3
+         INFO(4) = N + 1
          GO TO 40
       ELSE
-         INFO(4) = 3*NSUP + 3
+         INFO(4) = NSUP + 1
       END IF
       GO TO 50
    10 INFO(1) = -1
@@ -1090,12 +1130,12 @@ C
    40 INFO(1) = -4
       IF (LP.GT.0) THEN
          WRITE (LP,FMT=9000) INFO(1)
-         WRITE (LP,FMT=9010) INFO(4)
+         WRITE (LP,FMT=9010) 3_8*int(INFO(4),8)
       END IF
    50 RETURN
  9000 FORMAT (/3X,'Error message from DMUMPS_SUPVAR: INFO(1) = ',I2)
  9010 FORMAT (3X,'LIW is insufficient. Upper bound on required work',
-     &       'space is ',I8)
+     &       'space is ',I12)
       END SUBROUTINE DMUMPS_SUPVAR
       SUBROUTINE DMUMPS_SUPVARB( N, NELT, ELTPTR, NZ, ELTVAR,
      &           SVAR, NSUP, MAXSUP, NEW, VARS, FLAG, INFO )
diff -pruN 5.6.2-2.1/src/dana_aux_par.F 5.7.1-1/src/dana_aux_par.F
--- 5.6.2-2.1/src/dana_aux_par.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dana_aux_par.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -53,19 +53,25 @@ C
       LOGICAL    :: PROK, PROKG, LPOK
       INTEGER N, NORIG
       CONTAINS
-      SUBROUTINE DMUMPS_ANA_F_PAR(id, WORK1, WORK2, NFSIZ, FILS,
+      SUBROUTINE DMUMPS_ANA_F_PAR(id, WORK1, WORK2, LWORK1, LWORK2,
+     &     NFSIZ, FILS,
      &     FRERE, COMM_PARASYMB, LUMAT, SIZEOFBLOCKS, 
      &     COMM_PARAORD, NPROCS_PARAORD, 
      &     RKinSYMB_PROC0ORD)
       USE DMUMPS_STRUC_DEF
       IMPLICIT NONE
       TYPE(DMUMPS_STRUC)   :: id
-      INTEGER, TARGET     :: WORK1(:), WORK2(:)
-      INTEGER, ALLOCATABLE :: FILS(:)
-      INTEGER, POINTER    :: NFSIZ(:), FRERE(:)
-      INTEGER, INTENT(IN) :: COMM_PARASYMB
+      INTEGER, TARGET        :: WORK1(:), WORK2(:)
+      INTEGER(8), INTENT(IN) :: LWORK1, LWORK2
+#if defined(MUMPS_NOF2003)
+      INTEGER, POINTER       :: FILS(:)
+#else
+      INTEGER, ALLOCATABLE   :: FILS(:)
+#endif
+      INTEGER, POINTER       :: NFSIZ(:), FRERE(:)
+      INTEGER, INTENT(IN)    :: COMM_PARASYMB
       TYPE(LMATRIX_T), OPTIONAL       :: LUMAT
-      INTEGER, INTENT(IN), OPTIONAL   :: SIZEOFBLOCKS(id%NBLK)
+      INTEGER, INTENT(IN), TARGET, OPTIONAL   :: SIZEOFBLOCKS(id%NBLK)
       INTEGER, INTENT(IN), OPTIONAL   :: COMM_PARAORD, 
      &                                   NPROCS_PARAORD, 
      &                                   RKinSYMB_PROC0ORD
@@ -78,9 +84,13 @@ C
       INTEGER              :: MYID, NPROCS, IERR, NEMIN, LDIAG
       LOGICAL              :: SPLITROOT
       INTEGER(8), PARAMETER :: K79REF=12000000_8
-      INTEGER, PARAMETER :: LIDUMMY = 1
-      INTEGER :: IDUMMY(1) 
       DOUBLE PRECISION      :: TIMEB
+      INTEGER HOW_TO_SPLIT_ROOT, INODE_Scalapack_CAND, 
+     &        NBSONS_Scalapack_CAND
+      INTEGER, POINTER, DIMENSION(:) :: SIZEOFBLOCKS_PTR
+      INTEGER, TARGET    :: IDUMMY_ARRAY(1)
+      INTEGER            :: LSIZEOFBLOCKS_PTR
+      LOGICAL            :: SIZEOFBLOCKS_AVAIL
       nullify(IPE, NV, NE, NA, NODE, ND, SUBORD, NAMALG, IPS,
      &     CUMUL, SAVEIRN, SAVEJCN)
       CALL MPI_COMM_RANK (COMM_PARASYMB, MYID, IERR)
@@ -99,6 +109,16 @@ C
       PROKG = (MPG.GT.0) .AND. (MYID .EQ. 0)
       LPOK  = (LP.GT.0) .AND. (id%ICNTL(4).GE.1)
       LDIAG = id%ICNTL(4)
+      IF (present(SIZEOFBLOCKS)) THEN
+       SIZEOFBLOCKS_PTR => SIZEOFBLOCKS(1:N)
+       LSIZEOFBLOCKS_PTR = N
+       SIZEOFBLOCKS_AVAIL = .TRUE.
+      ELSE
+       SIZEOFBLOCKS_PTR => IDUMMY_ARRAY
+       SIZEOFBLOCKS_AVAIL = .FALSE.
+       LSIZEOFBLOCKS_PTR = 1
+       IDUMMY_ARRAY(1) = -1
+      ENDIF
       IF (PROKG) THEN
          WRITE(MPG,'(A,I10)') 
      &   " Parallel analysis, processing a graph of size:", N
@@ -121,12 +141,17 @@ C
       CALL DMUMPS_SET_PAR_ORD(id, COMM_PARASYMB, MYID, NPROCS, 
      &     ord, COMM_PARAORD, NPROCS_PARAORD,
      &     RKinSYMB_PROC0ORD)
-      IF (ord%COMM.NE.MPI_COMM_NULL) THEN
-       ord%PERMTAB => WORK1(1        : N)
-       ord%PERITAB => WORK1(N+1   : 2*N)
-       ord%TREETAB => WORK1(2*N+1 : 3*N)
+      IF ( LWORK1 .LT. 3_8 *int(N,8) ) THEN
+         WRITE(LP,*)
+     &      'Insufficient workspace in DMUMPS_ANA_F_PAR' 
+         CALL MUMPS_ABORT()
       ENDIF
-      IF(id%KEEP(54) .NE. 3) THEN
+      IF ( ord%COMM .NE. MPI_COMM_NULL ) THEN
+        ord%PERMTAB => WORK1(         1       : N)
+        ord%PERITAB => WORK1(    int(N,8)+1_8 : 2_8*int(N,8))
+        ord%TREETAB => WORK1(2_8*int(N,8)+1_8 : 3_8*int(N,8))
+      ENDIF
+      IF ( id%KEEP(54) .NE. 3 ) THEN
          IF(MYID.EQ.0) THEN
             SAVEIRN    => id%IRN_loc
             SAVEJCN    => id%JCN_loc
@@ -143,10 +168,10 @@ C
       IF (PROKG) CALL MUMPS_SECDEB( TIMEB )
       IF (id%KEEP(339).GT.0) THEN
         CALL DMUMPS_DO_PAR_ORD(id, MYID, NPROCS, 
-     &                       ord, WORK2, LUMAT, SIZEOFBLOCKS)
+     &       ord, WORK2, LWORK2, LUMAT, SIZEOFBLOCKS)
       ELSE
         CALL DMUMPS_DO_PAR_ORD(id, MYID, NPROCS, 
-     &                       ord, WORK2)
+     &       ord, WORK2, LWORK2)
       ENDIF
       IF (PROKG) THEN
        CALL MUMPS_SECFIN( TIMEB )
@@ -167,11 +192,12 @@ C
       END IF
       ord%SUBSTRAT = 0
       ord%TOPSTRAT = 0
-      IF (id%KEEP(339).GT.1) THEN
-        CALL DMUMPS_PARSYMFACT_LUMAT(id, ord, IPE, NV, WORK2, LUMAT,
+      IF (id%KEEP(339).NE.0) THEN
+        CALL DMUMPS_PARSYMFACT_LUMAT(id, ord, IPE, NV,
+     &                               WORK2, LWORK2, LUMAT,
      &                               SIZEOFBLOCKS)
       ELSE
-        CALL DMUMPS_PARSYMFACT(id, ord, IPE, NV, WORK2)
+        CALL DMUMPS_PARSYMFACT(id, ord, IPE, NV, WORK2, LWORK2)
       ENDIF
       IF(id%KEEP(54) .NE. 3) THEN
          IF(ord%MYID.EQ.0) THEN
@@ -188,32 +214,25 @@ C
       CALL MUMPS_IDEALLOC(ord%FIRST, ord%LAST, MEMCNT=MEMCNT)
       IF (MYID .EQ. 0) THEN
          IPS => WORK1(1:N)
-         NE     => WORK1(N+1   : 2*N)
-         NA     => WORK1(2*N+1 : 3*N)
-         NODE   => WORK2(1        : N  )
-         ND     => WORK2(N+1   : 2*N)
-         SUBORD => WORK2(2*N+1 : 3*N)
-         NAMALG => WORK2(3*N+1 : 4*N)
+         NE     => WORK1(    int(N,8)+1_8 : 2_8*int(N,8))
+         NA     => WORK1(2_8*int(N,8)+1_8 : 3_8*int(N,8))
+         NODE   => WORK2(             1   : N  )
+         ND     => WORK2(    int(N,8)+1_8 : 2_8*int(N,8))
+         SUBORD => WORK2(2_8*int(N,8)+1_8 : 3_8*int(N,8))
+         NAMALG => WORK2(3_8*int(N,8)+1_8 : 4_8*int(N,8))
          CALL MUMPS_REALLOC(CUMUL, N, id%INFO, LP,
      &        STRING='CUMUL', MEMCNT=MEMCNT, ERRCODE=-7)
          IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
          NEMIN  = id%KEEP(1)
-         IF (N.LT.NORIG) THEN
-          CALL DMUMPS_ANA_LNEW(N, IPE(1), NV(1), IPS(1), NE(1),
-     &        NA(1), NFSIZ(1), NODE(1), id%INFOG(6), FILS(1), FRERE(1),
-     &        ND(1), NEMIN, SUBORD(1), id%KEEP(60), id%KEEP(20),
-     &        id%KEEP(38), NAMALG(1), id%KEEP(104), CUMUL(1),
-     &        id%KEEP(50), id%ICNTL(13), id%KEEP(37), id%KEEP(197),
-     &        id%NSLAVES, id%KEEP(250).EQ.1, .TRUE., 
-     &        SIZEOFBLOCKS, N)
-         ELSE
-          CALL DMUMPS_ANA_LNEW(N, IPE(1), NV(1), IPS(1), NE(1),
-     &        NA(1), NFSIZ(1), NODE(1), id%INFOG(6), FILS(1), FRERE(1),
-     &        ND(1), NEMIN, SUBORD(1), id%KEEP(60), id%KEEP(20),
-     &        id%KEEP(38), NAMALG(1), id%KEEP(104), CUMUL(1),
-     &        id%KEEP(50), id%ICNTL(13), id%KEEP(37), id%KEEP(197),
-     &        id%NSLAVES, id%KEEP(250).EQ.1, .FALSE., IDUMMY, LIDUMMY)
-         ENDIF
+         CALL DMUMPS_ANA_LNEW(N, IPE(1), NV(1), IPS(1), NE(1),
+     &       NA(1), NFSIZ(1), NODE(1), id%INFOG(6), FILS(1), FRERE(1),
+     &       ND(1), NEMIN, SUBORD(1), id%KEEP(60), id%KEEP(20),
+     &       id%KEEP(38), NAMALG(1), id%KEEP(104), CUMUL(1),
+     &       id%KEEP(50), id%ICNTL(13), id%KEEP(37), id%KEEP(197),
+     &       id%NSLAVES, id%KEEP(250).EQ.1, SIZEOFBLOCKS_AVAIL, 
+     &       SIZEOFBLOCKS_PTR(1), LSIZEOFBLOCKS_PTR,
+     &       INODE_Scalapack_CAND, NBSONS_Scalapack_CAND, 
+     &       id%KEEP(11))
          CALL MUMPS_DEALLOC(CUMUL, NV, IPE, MEMCNT=MEMCNT)
          CALL DMUMPS_ANA_M(NE(1), ND(1), id%INFOG(6), id%INFOG(5),
      &        id%KEEP(2), id%KEEP(50), id%KEEP8(101), id%KEEP(108),
@@ -221,6 +240,8 @@ C
          IF ( id%KEEP(53) .NE. 0 ) THEN
             CALL MUMPS_MAKE1ROOT(N, FRERE(1), FILS(1), NFSIZ(1),
      &           id%KEEP(20))
+            INODE_Scalapack_CAND  = id%KEEP(20)
+            NBSONS_Scalapack_CAND = 1
          END IF
          IF (  (id%KEEP(48) == 4 .AND. id%KEEP8(21).GT.0_8)
      &        .OR.
@@ -230,56 +251,84 @@ C
             CALL DMUMPS_SET_K821_SURFACE(id%KEEP8(21), id%KEEP(2),
      &           id%KEEP(48), id%KEEP(50), id%NSLAVES)
          END IF
-      IF (id%KEEP(210).LT.1.OR.id%KEEP(210).GT.2) id%KEEP(210)=2
-      IF (id%KEEP(210).EQ.2) id%KEEP8(79)=huge(id%KEEP8(79))
-      IF (id%KEEP(210).EQ.1.AND.id%KEEP8(79).LE.0_8) THEN
-       id%KEEP8(79)=K79REF * int(id%NSLAVES,8)
-      ENDIF
-         IF ( (id%KEEP(79).EQ.0).OR.(id%KEEP(79).EQ.2).OR.
-     &        (id%KEEP(79).EQ.3).OR.(id%KEEP(79).EQ.5).OR.
-     &        (id%KEEP(79).EQ.6)
-     &   )  THEN
-          IF (id%KEEP(210).EQ.1) THEN
+         IF (id%KEEP(210).LT.1.OR.id%KEEP(210).GT.2) id%KEEP(210)=2
+         IF (id%KEEP(210).EQ.2) id%KEEP8(79)=huge(id%KEEP8(79))
+         IF (id%KEEP(210).EQ.1.AND.id%KEEP8(79).LE.0_8) THEN
+          id%KEEP8(79)=K79REF * int(id%NSLAVES,8)
+         ENDIF
+         IF (id%KEEP(11).EQ.0) THEN
+          IF ( (id%KEEP(79).EQ.0).OR.(id%KEEP(79).EQ.2).OR.
+     &         (id%KEEP(79).EQ.3).OR.(id%KEEP(79).EQ.5).OR.
+     &         (id%KEEP(79).EQ.6)
+     &    )  THEN
+           IF (id%KEEP(210).EQ.1) THEN
             SPLITROOT = .FALSE. 
             IF ( id%KEEP(62).GE.1) THEN
-               IDUMMY(1) = -1
                CALL DMUMPS_CUTNODES(N, FRERE(1), FILS(1),
-     &              NFSIZ(1), IDUMMY, LIDUMMY, id%INFOG(6),
-     &              id%NSLAVES, id%KEEP(1), id%KEEP8(1), SPLITROOT,
-     &              MP, LDIAG, id%INFOG(1), id%INFOG(2))
+     &           NFSIZ(1), 
+     &           SIZEOFBLOCKS_PTR(1), LSIZEOFBLOCKS_PTR, id%INFOG(6), 
+     &           id%NSLAVES, id%KEEP(1), id%KEEP8(1), SPLITROOT,
+     &           MP, LDIAG, id%INFOG(1), id%INFOG(2))
                IF (id%INFOG(1).LT.0) RETURN
             ENDIF
+           ENDIF
           ENDIF
          ENDIF
-      SPLITROOT = id%ICNTL(13) .EQ. -1
+         HOW_TO_SPLIT_ROOT = 0 
+         SPLITROOT = id%ICNTL(13) .EQ. -1
 #if defined(NOSCALAPACK)
-      SPLITROOT = SPLITROOT .OR. id%NSLAVES.GT.0
+         SPLITROOT = SPLITROOT .OR. id%NSLAVES.GT.0
 #else
-      SPLITROOT = SPLITROOT .OR.
+         SPLITROOT = SPLITROOT .OR.
      &            (id%ICNTL(13).GT.0 .AND. id%NSLAVES.GT.id%ICNTL(13))
 #endif
-      IF (id%KEEP(53) .NE. 0) THEN
-         SPLITROOT = .TRUE.
-      ENDIF
+         IF (SPLITROOT.AND.id%KEEP(11).GT.0) HOW_TO_SPLIT_ROOT =1 
+         IF (id%KEEP(53) .NE. 0) THEN
+           SPLITROOT = .TRUE.
+           IF (id%KEEP(11).GT.0) HOW_TO_SPLIT_ROOT = 2
+         ENDIF
+#if defined(NOSCALAPACK)
+#else
+         IF ( id%KEEP(11).GT.0 .AND. (id%KEEP(339).NE.0) ) THEN 
+           IF (.NOT.SPLITROOT .AND. 
+     &       (id%KEEP(60).EQ.0).AND.   
+     &       ( (NFSIZ(INODE_Scalapack_CAND).GT.id%KEEP(37))
+     &        .AND.(id%ICNTL(13).LE.0) )
+     &       .AND.
+     &       (NBSONS_Scalapack_CAND.GT.id%KEEP(11)) 
+     &       ) THEN
+             HOW_TO_SPLIT_ROOT = 3
+             SPLITROOT=.TRUE.
+           ENDIF
+         ENDIF
+#endif
          SPLITROOT = (SPLITROOT.AND.( (id%KEEP(60).EQ.0) ))
          IF (SPLITROOT) THEN
            IF (id%KEEP(339).EQ.0) THEN
-            IDUMMY(1) = -1
             CALL DMUMPS_CUTNODES(N, FRERE(1), FILS(1), NFSIZ(1),
-     &           IDUMMY, LIDUMMY, id%INFOG(6), 
+     &           SIZEOFBLOCKS_PTR(1), LSIZEOFBLOCKS_PTR, id%INFOG(6), 
      &           id%NSLAVES, id%KEEP(1), id%KEEP8(1),
      &           SPLITROOT, MP, LDIAG, id%INFOG(1), id%INFOG(2))
            ELSE
-            CALL DMUMPS_CUTNODES(N, FRERE(1), FILS(1), NFSIZ(1),
-     &           SIZEOFBLOCKS, id%NBLK, id%INFOG(6), 
+            IF (id%KEEP(11).EQ.0) THEN
+              CALL DMUMPS_CUTNODES(N, FRERE(1), FILS(1), NFSIZ(1),
+     &           SIZEOFBLOCKS_PTR(1), LSIZEOFBLOCKS_PTR, id%INFOG(6), 
      &           id%NSLAVES, id%KEEP(1), id%KEEP8(1),
      &           SPLITROOT, MP, LDIAG, id%INFOG(1), id%INFOG(2))
-           ENDIF
-            IF (id%INFOG(1).LT.0) RETURN
-            IF ( id%KEEP(53) .NE. 0 ) THEN
-              CALL MUMPS_MAKE1ROOT(N, FRERE(1), FILS(1), NFSIZ(1),
-     &           id%KEEP(20))
+              IF (id%INFOG(1).LT.0) RETURN
+              IF ( id%KEEP(53) .NE. 0 ) THEN
+                CALL MUMPS_MAKE1ROOT(N, FRERE(1), FILS(1), NFSIZ(1),
+     &             id%KEEP(20))
+              END IF
+            ELSE
+              CALL DMUMPS_SPLIT_ROOT( id%NSLAVES,
+     &                    HOW_TO_SPLIT_ROOT, INODE_Scalapack_CAND,
+     &                    N, FRERE(1), FILS(1), NFSIZ(1), 
+     &                    id%KEEP(1), id%KEEP8(1),
+     &                    SIZEOFBLOCKS_PTR(1), LSIZEOFBLOCKS_PTR,
+     &                    id%INFOG(6))
             END IF
+           END IF
          ENDIF
       END IF
       RETURN
@@ -415,13 +464,15 @@ C
        END IF
       ENDIF
       END SUBROUTINE DMUMPS_SET_PAR_ORD
-      SUBROUTINE DMUMPS_DO_PAR_ORD(id, MYID, NPROCS, ord, WORK, LUMAT, 
+      SUBROUTINE DMUMPS_DO_PAR_ORD(id, MYID, NPROCS, ord,
+     &                             WORK, LWORK, LUMAT, 
      &                             SIZEOFBLOCKS)
       IMPLICIT NONE
       TYPE(DMUMPS_STRUC)       :: id
       INTEGER, INTENT(IN)      :: MYID, NPROCS
       TYPE(ORD_TYPE)           :: ord
       INTEGER                  :: WORK(:)
+      INTEGER(8), INTENT(IN)   :: LWORK
       TYPE(LMATRIX_T), OPTIONAL       :: LUMAT
       INTEGER, INTENT(IN), OPTIONAL   :: SIZEOFBLOCKS(N)
 #if defined(parmetis) || defined(parmetis3)
@@ -440,10 +491,11 @@ C
       IF (ord%ORDTOOL .EQ. 1) THEN
 #if defined(ptscotch)
         IF (id%KEEP(339).NE.0) THEN
-         CALL DMUMPS_PTSCOTCH_ORD(id, ord, WORK, GCOMP_DIST,
+         CALL DMUMPS_PTSCOTCH_ORD(id, ord, WORK, LWORK,
+     &                     GCOMP_DIST,
      &                     SIZEOFBLOCKS )
         ELSE
-         CALL DMUMPS_PTSCOTCH_ORD(id, ord, WORK)
+         CALL DMUMPS_PTSCOTCH_ORD(id, ord, WORK, LWORK)
         ENDIF
 #else
          id%INFOG(1) = -38
@@ -454,10 +506,11 @@ C
       ELSE IF (ord%ORDTOOL .EQ. 2) THEN
 #if defined(parmetis) || defined(parmetis3)
          IF (id%KEEP(339).GT.0) THEN
-         CALL DMUMPS_PARMETIS_ORD_LUMAT (id, ord, WORK, GCOMP_DIST,
+         CALL DMUMPS_PARMETIS_ORD_LUMAT (id, ord, WORK, LWORK,
+     &                            GCOMP_DIST,
      &                            SIZEOFBLOCKS)
          ELSE
-           CALL DMUMPS_PARMETIS_ORD(id, ord, WORK)
+           CALL DMUMPS_PARMETIS_ORD(id, ord, WORK, LWORK)
          ENDIF
          IF (id%KEEP(339).EQ.0) THEN
           if(ord%IDO) CALL MPI_COMM_FREE(ord%COMM_PARAORD, IERR)
@@ -475,14 +528,14 @@ C
       RETURN
       END SUBROUTINE DMUMPS_DO_PAR_ORD
 #if defined(parmetis) || defined(parmetis3)
-      SUBROUTINE DMUMPS_PARMETIS_ORD(id, ord, WORK) 
+      SUBROUTINE DMUMPS_PARMETIS_ORD(id, ord, WORK, LWORK) 
       IMPLICIT NONE
-      TYPE(DMUMPS_STRUC)  :: id
-      TYPE(ORD_TYPE)      :: ord
-      INTEGER, TARGET    :: WORK(:)
+      TYPE(DMUMPS_STRUC)      :: id
+      TYPE(ORD_TYPE)          :: ord
+      INTEGER, TARGET         :: WORK(:)
+      INTEGER(8), INTENT (IN) :: LWORK
       INTEGER             :: I, MYID, NPROCS, IERR, BASE, METIS_IDX_SIZE
-      INTEGER, POINTER    :: FIRST(:),
-     &     LAST(:), SWORK(:)
+      INTEGER, POINTER    :: FIRST(:), LAST(:), SWORK(:)
       INTEGER             :: BASEVAL, VERTLOCNBR,
      &     OPTIONS(10)
       INTEGER(8), POINTER :: VERTLOCTAB(:)
@@ -497,7 +550,7 @@ C
       NPROCS          = ord%NPROCS
       IERR            = 0
       SIZE_IDUMMY_PTR = 0
-      IF(size(WORK) .LT. N*3 .OR.size(WORK).LT.NPROCS+1) THEN
+      IF( LWORK.LT. int(N,8)*3_8 .OR. LWORK .LT. int(NPROCS+1,8)) THEN
          WRITE(LP,
      &        '("Insufficient workspace inside DMUMPS_PARMETIS_ORD")')
          CALL MUMPS_ABORT()
@@ -510,14 +563,15 @@ C
       IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
       BASE    = id%NPROCS-id%NSLAVES
       CALL DMUMPS_GRAPH_DIST(id, ord, FIRST,
-     &     LAST, BASE, NPROCS, WORK(1: 2*N), TYPE=2)
+     &     LAST, BASE, NPROCS, WORK(1_8: 2_8*int(N,8)),
+     &     2_8*int(N,8), TYPE=2)
       VERTLOCNBR = LAST(MYID+1)-FIRST(MYID+1) + 1
       CALL MUMPS_I8REALLOC(VERTLOCTAB, VERTLOCNBR+1, id%INFO,
      &        LP, STRING='VERTLOCTAB', MEMCNT=MEMCNT, ERRCODE=-7)
       IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
-      SWORK => WORK(N+1:3*N)
+      SWORK => WORK(int(N+1,8):3_8*int(N,8))
       CALL DMUMPS_BUILD_DIST_GRAPH(id, ord, FIRST, LAST, VERTLOCTAB,
-     &     EDGELOCTAB, SWORK)
+     &     EDGELOCTAB, SWORK, 2_8 * int(N,8))
       CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &     ord%COMM, ord%MYID )
       IF(id%INFO(1).LT.0) GOTO 20
@@ -608,19 +662,20 @@ C
       CALL MUMPS_DEALLOC(ord%RANGTAB, MEMCNT=MEMCNT)
       RETURN
       END SUBROUTINE DMUMPS_PARMETIS_ORD
-      SUBROUTINE DMUMPS_PARMETIS_ORD_LUMAT (id, ord, WORK, GCOMP_DIST,
+      SUBROUTINE DMUMPS_PARMETIS_ORD_LUMAT (id, ord, WORK, LWORK,
+     &                              GCOMP_DIST,
      &                              SIZEOFBLOCKS )
       IMPLICIT NONE
-      TYPE(DMUMPS_STRUC)  :: id
-      TYPE(ORD_TYPE)      :: ord
-      INTEGER, TARGET    :: WORK(:)
+      TYPE(DMUMPS_STRUC)     :: id
+      TYPE(ORD_TYPE)         :: ord
+      INTEGER, TARGET        :: WORK(:)
+      INTEGER(8), INTENT(IN) :: LWORK
       TYPE(COMPACT_GRAPH_T), OPTIONAL       :: GCOMP_DIST
       INTEGER, INTENT(IN), OPTIONAL, TARGET :: SIZEOFBLOCKS(N)
       INTEGER             :: I, MYID, NPROCS, IERR, BASE, METIS_IDX_SIZE
       INTEGER             :: MASTER
       PARAMETER     (MASTER=0)
-      INTEGER, POINTER    :: FIRST(:),
-     &     LAST(:), SWORK(:)
+      INTEGER, POINTER    :: FIRST(:), LAST(:), SWORK(:)
       INTEGER             :: BASEVAL, VERTLOCNBR,
      &     OPTIONS(10)
       INTEGER(8), POINTER :: VERTLOCTAB(:)
@@ -637,7 +692,7 @@ C
       NPROCS          = ord%NPROCS
       IERR            = 0
       SIZE_VELOLOCTAB = 0
-      IF(size(WORK) .LT. N*3 .OR.size(WORK).LT.NPROCS+1) THEN
+      IF( LWORK.LT. int(N,8)*3_8 .OR. LWORK .LT. int(NPROCS+1,8)) THEN
          WRITE(LP,
      &        '("Insufficient workspace inside DMUMPS_PARMETIS_ORD")')
          CALL MUMPS_ABORT()
@@ -661,7 +716,7 @@ C
          EDGELOCNBR = GCOMP_DIST%NZG
          VERTLOCTAB => GCOMP_DIST%IPE
          EDGELOCTAB => GCOMP_DIST%ADJ
-         IF (id%KEEP(339).GE.6) THEN
+         IF (id%KEEP(339).NE.0) THEN
           VELOLOCTAB=>SIZEOFBLOCKS(GCOMP_DIST%FIRST:GCOMP_DIST%LAST)
           SIZE_VELOLOCTAB = VERTLOCNBR
          ENDIF
@@ -788,14 +843,14 @@ C
       END SUBROUTINE DMUMPS_PARMETIS_ORD_LUMAT
 #endif
 #if defined(ptscotch)
-      SUBROUTINE DMUMPS_PTSCOTCH_ORD(id, ord, WORK, GCOMP_DIST,
+      SUBROUTINE DMUMPS_PTSCOTCH_ORD(id, ord, WORK, LWORK, GCOMP_DIST,
      &                               SIZEOFBLOCKS)
 !$    USE OMP_LIB
       IMPLICIT NONE
-      INCLUDE 'ptscotchf.h'
       TYPE(DMUMPS_STRUC)                :: id
       TYPE(ORD_TYPE)                    :: ord
       INTEGER, TARGET                   :: WORK(:)
+      INTEGER(8), INTENT(IN)            :: LWORK
       TYPE(COMPACT_GRAPH_T), OPTIONAL   :: GCOMP_DIST
       INTEGER, INTENT(IN), OPTIONAL, TARGET:: SIZEOFBLOCKS(N)
       INTEGER                       :: MYID, NPROCS, IERR
@@ -809,7 +864,14 @@ C
       INTEGER, POINTER              :: VELOLOCTAB(:)
       INTEGER                       :: SIZE_VELOLOCTAB
       INTEGER, TARGET               :: IDUMMY(1)
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+      INCLUDE 'scotchf.h' 
+      INTEGER          :: IOMP, NOMP
+      DOUBLE PRECISION :: CONTDAT(SCOTCH_CONTEXTDIM)
+      INTEGER(4)       :: IERR_SCOTCH
+#else
       INTEGER :: PTHREAD_NUMBER, NOMP
+#endif
       nullify(FIRST, LAST, SWORK, VERTLOCTAB, EDGELOCTAB)
       VELOLOCTAB => IDUMMY 
       CALL MPI_BARRIER(ord%COMM, IERR)
@@ -822,12 +884,12 @@ C
         EDGELOCNBR = GCOMP_DIST%NZG
         VERTLOCTAB => GCOMP_DIST%IPE
         EDGELOCTAB => GCOMP_DIST%ADJ
-        IF (id%KEEP(339).GE.6) THEN
+        IF (id%KEEP(339).NE.0) THEN
          VELOLOCTAB => SIZEOFBLOCKS(GCOMP_DIST%FIRST:GCOMP_DIST%LAST)
          SIZE_VELOLOCTAB = VERTLOCNBR
         ENDIF
       ELSE
-        IF (size(WORK) .LT. N*3) THEN
+        IF (LWORK .LT. int(N,8)*3_8) THEN
             WRITE(LP,
      &      '("Insufficient workspace inside DMUMPS_PTSCOTCH_ORD")')
             CALL MUMPS_ABORT()
@@ -839,14 +901,15 @@ C
      &     MEMCNT=MEMCNT, ERRCODE=-7)
         IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
         CALL DMUMPS_GRAPH_DIST(id, ord, FIRST,
-     &     LAST, BASE, NPROCS, WORK(1: 2*N), TYPE=2)
+     &     LAST, BASE, NPROCS, WORK(1: 2_8*int(N,8)),
+     &     2_8*int(N,8), TYPE=2)
         VERTLOCNBR = LAST(MYID+1)-FIRST(MYID+1) + 1
         CALL MUMPS_I8REALLOC(VERTLOCTAB, VERTLOCNBR+1, id%INFO,
      &        LP, STRING='VERTLOCTAB', MEMCNT=MEMCNT, ERRCODE=-7)
         IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
-        SWORK => WORK(N+1:3*N)
+        SWORK => WORK(int(N+1,8):3_8*int(N,8))
         CALL DMUMPS_BUILD_DIST_GRAPH(id, ord, FIRST, LAST, VERTLOCTAB,
-     &     EDGELOCTAB, SWORK)
+     &     EDGELOCTAB, SWORK, 2_8*int(N,8))
         CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &     ord%COMM, ord%MYID )
         IF ( id%INFO(1) .LT. 0 ) GOTO 11
@@ -863,35 +926,65 @@ C
       IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
       IF(ord%IDO) THEN
          CALL MUMPS_SCOTCH_INTSIZE(SCOTCH_INT_SIZE)
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+!$OMP PARALLEL PRIVATE(IOMP, IERR_SCOTCH)
+!$OMP SINGLE
+         NOMP=omp_get_num_threads()
+!$OMP END SINGLE
+         IOMP=omp_get_thread_num()
+         IF (IOMP.EQ.0) THEN
+           CALL SCOTCHFCONTEXTINIT(CONTDAT, IERR_SCOTCH)
+           CALL SCOTCHFCONTEXTRANDOMCLONE(CONTDAT, IERR_SCOTCH)
+           CALL SCOTCHFCONTEXTTHREADIMPORT1(CONTDAT, NOMP, IERR_SCOTCH)
+         ENDIF
+!$OMP BARRIER
+         CALL SCOTCHFCONTEXTTHREADIMPORT2(CONTDAT, IOMP, IERR_SCOTCH)
+#else
          NOMP=0
 !$       NOMP=omp_get_max_threads()
          IF (NOMP .GT. 0) THEN
            CALL MUMPS_SCOTCH_GET_PTHREAD_NUMBER (PTHREAD_NUMBER)
            CALL MUMPS_SCOTCH_SET_PTHREAD_NUMBER (NOMP)
          ENDIF
-         IF(SCOTCH_INT_SIZE.EQ.32) THEN
-           IF (id%KEEP(10).EQ.1) THEN
-            id%INFO(1) = -52
-            id%INFO(2) = 2
+#endif
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+         IF (IOMP.EQ.0) THEN
+#endif
+           IF(SCOTCH_INT_SIZE.EQ.32) THEN
+             IF (id%KEEP(10).EQ.1) THEN
+              id%INFO(1) = -52
+              id%INFO(2) = 2
+             ELSE
+              CALL MUMPS_PTSCOTCH_MIXEDto32(id, ord,
+     &             BASEVAL, 
+     &             VERTLOCNBR, VERTLOCTAB,
+     &             EDGELOCNBR, EDGELOCTAB,
+     &             VELOLOCTAB, SIZE_VELOLOCTAB,
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+     &             CONTDAT, SCOTCH_CONTEXTDIM,
+#endif
+     &             IERR)
+            ENDIF
            ELSE
-            CALL MUMPS_PTSCOTCH_MIXEDto32(id, ord,
-     &           BASEVAL, 
-     &           VERTLOCNBR, VERTLOCTAB,
-     &           EDGELOCNBR, EDGELOCTAB,
-     &           VELOLOCTAB, SIZE_VELOLOCTAB,
-     &           IERR)
-          ENDIF
-         ELSE
-            CALL MUMPS_PTSCOTCH_MIXEDto64(id, ord,
-     &           BASEVAL, 
-     &           VERTLOCNBR, VERTLOCTAB,
-     &           EDGELOCNBR, EDGELOCTAB,
-     &           VELOLOCTAB, SIZE_VELOLOCTAB,
-     &           IERR)
-         END IF
+              CALL MUMPS_PTSCOTCH_MIXEDto64(id, ord,
+     &             BASEVAL, 
+     &             VERTLOCNBR, VERTLOCTAB,
+     &             EDGELOCNBR, EDGELOCTAB,
+     &             VELOLOCTAB, SIZE_VELOLOCTAB,
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+     &             CONTDAT, SCOTCH_CONTEXTDIM,
+#endif
+     &             IERR)
+           END IF
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+           CALL SCOTCHFCONTEXTEXIT(CONTDAT)
+         ENDIF 
+!$OMP END PARALLEL
+#else
          IF (NOMP .GT. 0) THEN
            CALL MUMPS_SCOTCH_SET_PTHREAD_NUMBER (PTHREAD_NUMBER)
          ENDIF
+#endif
       END IF
       IF(IERR.NE.0) THEN
          id%INFO(1:2) = -50
@@ -996,7 +1089,7 @@ C
       HOSTMEM = 12*N 
       NZ4=int(id%KEEP8(28))
       NZ_ROW = 2*(NZ4/N) 
-      IF (id%KEEP(339).GT.2) THEN
+      IF (id%KEEP(339).NE.0) THEN
          NRL = 0
       ELSE
         IF(id%KEEP(46) .EQ. 0) THEN
@@ -1152,7 +1245,7 @@ C
       CALL DMUMPS_MERGESORT(ANODE, AWEIGHTS(1:ANODE), WORK(0:ANODE+1))
       CALL DMUMPS_MERGESWAP(ANODE, WORK(0:ANODE+1), AWEIGHTS(1:ANODE), 
      &     ALIST(1:ANODE))
-      IF (id%KEEP(339).GE.4) THEN
+      IF (id%KEEP(339).NE.0) THEN
        Iprocdeb = ord%NPROCS-ANODE+1
        IF (Iprocdeb.GT.1) THEN
          DO I=1, Iprocdeb-1
@@ -1216,28 +1309,26 @@ C
  90   continue
       RETURN
       END SUBROUTINE DMUMPS_GET_SUBTREES
-      SUBROUTINE DMUMPS_PARSYMFACT(id, ord, GPE, GNV, WORK)  
+      SUBROUTINE DMUMPS_PARSYMFACT(id, ord, GPE, GNV, WORK, LWORK)  
       IMPLICIT NONE
-      TYPE(DMUMPS_STRUC)   :: id
-      TYPE(ORD_TYPE)       :: ord
-      INTEGER, POINTER     :: GPE(:), GNV(:)
-      INTEGER, TARGET      :: WORK(:)
-      TYPE(GRAPH_TYPE)     :: top_graph
-      INTEGER(8), POINTER  :: IPE(:), IPET(:),
-     &     BUF_PE1(:), BUF_PE2(:), TMP1(:)
-      INTEGER, POINTER     :: PE(:),
-     &     LENG(:), I_HALO_MAP(:)
-      INTEGER, POINTER     :: NDENSE(:), LAST(:),
-     &     DEGREE(:), W(:), PERM(:),
-     &     LISTVAR_SCHUR(:), NEXT(:),
-     &     HEAD(:), NV(:), ELEN(:),
-     &     LSTVAR(:)
-      INTEGER, POINTER     :: MYLIST(:),
-     &     LPERM(:),
-     &     LIPERM(:),
-     &     NVT(:), BUF_NV1(:),
-     &     BUF_NV2(:), ROOTPERM(:),
-     &     TMP2(:), BWORK(:), NCLIQUES(:)
+      TYPE(DMUMPS_STRUC)     :: id
+      TYPE(ORD_TYPE)         :: ord
+      INTEGER, POINTER       :: GPE(:), GNV(:)
+      INTEGER, TARGET        :: WORK(:)
+      INTEGER(8), INTENT(IN) :: LWORK
+      TYPE(GRAPH_TYPE)       :: top_graph
+      INTEGER(8), POINTER    :: IPE(:), IPET(:),
+     &                          BUF_PE1(:), BUF_PE2(:), TMP1(:)
+      INTEGER, POINTER       :: PE(:), LENG(:), I_HALO_MAP(:)
+      INTEGER, POINTER       :: NDENSE(:), LAST(:),
+     &                          DEGREE(:), W(:), PERM(:),
+     &                          LISTVAR_SCHUR(:), NEXT(:),
+     &                          HEAD(:), NV(:), ELEN(:),
+     &                          LSTVAR(:)
+      INTEGER, POINTER       :: MYLIST(:), LPERM(:), LIPERM(:),
+     &                          NVT(:), BUF_NV1(:),
+     &                          BUF_NV2(:), ROOTPERM(:),
+     &                          TMP2(:), BWORK(:), NCLIQUES(:)
       INTEGER              :: MYNCLIQUES, MYMAXVARS, ICLIQUES,
      &     TOTNCLIQUES
       INTEGER(8)           :: MYNVARS, TOTNVARS
@@ -1262,14 +1353,14 @@ C
      &     BUF_NV1, BUF_NV2, ROOTPERM, TMP1, TMP2, BWORK)
       MYID   = ord%MYID
       NPROCS = ord%NPROCS
-      IF(size(WORK) .LT. 4*N) THEN
+      IF(LWORK .LT. 4_8*int(N,8)) THEN
          WRITE(LP,*)'Insufficient workspace in DMUMPS_PARSYMFACT'
          CALL MUMPS_ABORT()
       ELSE
-         HEAD => WORK(       1 :   N)
-         ELEN => WORK(  N+1 : 2*N)
-         LENG => WORK(2*N+1 : 3*N)
-         PERM => WORK(3*N+1 : 4*N)
+         HEAD => WORK(              1 :         N    )
+         ELEN => WORK(     int(N,8)+1 : 2_8*int(N,8) )
+         LENG => WORK( 2_8*int(N,8)+1 : 3_8*int(N,8) )
+         PERM => WORK( 3_8*int(N,8)+1 : 4_8*int(N,8) )
       END IF
       CALL DMUMPS_GET_SUBTREES(ord, id)
       CALL MUMPS_IDEALLOC(ord%SON, ord%BROTHER, ord%NW,
@@ -1277,9 +1368,9 @@ C
       NROWS_LOC = ord%LAST(MYID+1)-ord%FIRST(MYID+1)+1
       NRL = NROWS_LOC
       TOPROWS = ord%TOPNODES(2)
-      BWORK => WORK(1 : 2*N)
+      BWORK => WORK(1_8 : 2_8*int(N,8))
       CALL DMUMPS_BUILD_LOC_GRAPH(id, ord, HIDX, IPE, PE, LENG,
-     &     I_HALO_MAP, top_graph, BWORK)
+     &     I_HALO_MAP, top_graph, BWORK, 2_8*int(N,8))
       CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &     ord%COMM, ord%MYID )
       IF(id%INFO(1).lt.0) RETURN
@@ -1377,7 +1468,7 @@ C
      &              PROC, ITAG, ord%COMM, STATUSCLIQUES, IERR)
             END DO
          END DO
-         LPERM => WORK(3*N+1 : 4*N)
+         LPERM => WORK(3_8*int(N,8)+1_8 : 4_8*int(N,8))
          NTVAR   = ord%TOPNODES(2)
          CALL DMUMPS_MAKE_LOC_IDX(id, ord%TOPNODES, LPERM, LIPERM, ord)
          CALL DMUMPS_ASSEMBLE_TOP_GRAPH(id, ord%TOPNODES(2), LPERM,
@@ -1563,7 +1654,7 @@ C
       NULLIFY(HEAD, ELEN, LENG, PERM)
       RETURN
       END SUBROUTINE DMUMPS_PARSYMFACT
-      SUBROUTINE DMUMPS_PARSYMFACT_LUMAT(id, ord, GPE, GNV, WORK, 
+      SUBROUTINE DMUMPS_PARSYMFACT_LUMAT(id, ord, GPE, GNV, WORK, LWORK,
      &                                   LUMAT, SIZEOFBLOCKS)  
       IMPLICIT NONE
       TYPE(DMUMPS_STRUC)   :: id
@@ -1590,7 +1681,7 @@ C
      &     TMP2(:), BWORK(:), NCLIQUES(:), MAPTAB(:)
       INTEGER              :: MYNCLIQUES, MYMAXVARS, ICLIQUES,
      &     TOTNCLIQUES
-      INTEGER(8)           :: MYNVARS, TOTNVARS
+      INTEGER(8)           :: MYNVARS, TOTNVARS, LWORK
       INTEGER(8), POINTER  :: LVARPT(:)
       INTEGER              :: HIDX, TOTEL, 
      &     NCMPA, I, J, SIZE_SCHUR, MYID,
@@ -1612,26 +1703,25 @@ C
      &     BUF_NV1, BUF_NV2, ROOTPERM, TMP1, TMP2, BWORK, MAPTAB)
       MYID   = ord%MYID
       NPROCS = ord%NPROCS
-      IF(size(WORK) .LT. 4*N) THEN
+      IF( LWORK .LT. 4_8*int(N,8) ) THEN
          WRITE(LP,*)
      &      'Insufficient workspace in DMUMPS_PARSYMFACT_LUMAT'
          CALL MUMPS_ABORT()
-      ELSE
-         HEAD => WORK(       1 :   N)
-         ELEN => WORK(  N+1 : 2*N)
-         LENG => WORK(2*N+1 : 3*N)
-         PERM => WORK(3*N+1 : 4*N)
-      END IF
+      ENDIF
+      HEAD => WORK(              1   :         N    )
+      ELEN => WORK(     int(N,8)+1_8 : 2_8*int(N,8) )
+      LENG => WORK( 2_8*int(N,8)+1_8 : 3_8*int(N,8) )
+      PERM => WORK( 3_8*int(N,8)+1_8 : 4_8*int(N,8) )
       CALL DMUMPS_GET_SUBTREES(ord, id)
       CALL MUMPS_IDEALLOC(ord%SON, ord%BROTHER, ord%NW,
      &     ord%RANGTAB, MEMCNT=MEMCNT)
       NROWS_LOC = ord%LAST(MYID+1)-ord%FIRST(MYID+1)+1
       NRL = NROWS_LOC
       TOPROWS = ord%TOPNODES(2)
-      BWORK  => WORK(1 : 2*N)
+      BWORK  => WORK(1_8 : 2_8*int(N,8))
        CALL DMUMPS_LUMAT_TO_LOC_GRAPH(
      &     LUMAT, id, ord, HIDX, IPE, PE, LENG,
-     &     I_HALO_MAP, BWORK)
+     &     I_HALO_MAP, BWORK, 2_8*int(N,8))
       CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &     ord%COMM, ord%MYID )
       IF(id%INFO(1).lt.0) RETURN
@@ -1680,7 +1770,7 @@ C
          IF(HIDX .GT.0) THEN
            NV(1) = -1 
            TOTEL = HIDX
-           IF ((N.LT.NORIG).OR.(id%KEEP(339).GE.4)) THEN
+           IF ((N.LT.NORIG).OR.(id%KEEP(339).NE.0)) THEN
              TOTEL = 0
              DO I=1,NROWS_LOC
                NV(I) = SIZEOFBLOCKS (
@@ -1759,13 +1849,13 @@ C
          END DO
       END IF
       CALL MUMPS_DEALLOC(PE, MEMCNT=MEMCNT) 
-      IF (id%KEEP(339).GT.2) THEN
+      IF (id%KEEP(339).NE.0) THEN
           MAPTAB => WORK(1:N)
           CALL MUMPS_BUILD_TOP_GRAPH (LUMAT, id, ord, top_graph, MAPTAB)
       ENDIF
       IF (MYID.EQ.0) THEN
-        LPERM => WORK(3*N+1 : 4*N)
-        NTVAR   = ord%TOPNODES(2)
+        LPERM => WORK( 3_8*int(N,8)+1_8 : 4_8*int(N,8) )
+        NTVAR = ord%TOPNODES(2)
         CALL DMUMPS_MAKE_LOC_IDX(id, ord%TOPNODES, LPERM, LIPERM, ord)
         CALL DMUMPS_ASSEMBLE_TOP_GRAPH(id, ord%TOPNODES(2), LPERM,
      &        top_graph, TOTNCLIQUES, LSTVAR, LVARPT, IPET, PE,
@@ -1813,7 +1903,7 @@ C
             IF(TGSIZE.GT.0) THEN 
               NVT(1) = -1 
               TOTEL = TGSIZE
-              IF ((N.LT.NORIG).OR.(id%KEEP(339).GE.4)) THEN
+              IF ((N.LT.NORIG).OR.(id%KEEP(339).NE.0)) THEN
                 TOTEL = TOTNCLIQUES
                 DO I=1,NTVAR
                   NVT(I) = SIZEOFBLOCKS( LIPERM(I) )
@@ -1939,7 +2029,7 @@ C
      &     MEMCNT=MEMCNT)
       CALL MUMPS_DEALLOC(LPERM, LIPERM, NVT, MEMCNT=MEMCNT)
       CALL MUMPS_DEALLOC(ROOTPERM, TMP2, MEMCNT=MEMCNT)
-      NULLIFY(HEAD, ELEN, LENG, PERM)
+      NULLIFY(HEAD, ELEN, LENG, PERM, BWORK, MAPTAB, LPERM)
       RETURN
       END SUBROUTINE DMUMPS_PARSYMFACT_LUMAT
       SUBROUTINE DMUMPS_MAKE_LOC_IDX(id, TOPNODES, LPERM, LIPERM, ord)
@@ -2115,13 +2205,14 @@ C
 #endif
 #if defined(ptscotch) || defined(parmetis) || defined(parmetis3)
       SUBROUTINE DMUMPS_BUILD_DIST_GRAPH(id, ord, FIRST, LAST, IPE,
-     &     PE, WORK)
+     &     PE, WORK, LWORK)
       IMPLICIT NONE
       TYPE(DMUMPS_STRUC)      :: id
       TYPE(ORD_TYPE)          :: ord
       INTEGER(8), POINTER     :: IPE(:)
       INTEGER, POINTER        :: FIRST(:), LAST(:), PE(:),
      &     WORK(:)
+      INTEGER(8), INTENT(IN)  :: LWORK
       INTEGER                 :: IERR, MYID, NPROCS
       INTEGER                 :: I, PROC, J, LOC_ROW
       INTEGER(8)              :: LOCNNZ, INNZ, NEW_LOCNNZ, OFFDIAG,
@@ -2148,7 +2239,7 @@ C
       nullify(TSENDI, TSENDJ, RCVBUF, APNT)
       MYID   = ord%MYID
       NPROCS = ord%NPROCS
-      IF(MUMPS_GETSIZE(WORK) .LT. N*2) THEN
+      IF(LWORK .LT. int(N,8)*2_8) THEN
          WRITE(LP,
      &        '("Insufficient workspace inside BUILD_SCOTCH_GRAPH")')
          CALL MUMPS_ABORT()
@@ -2174,8 +2265,8 @@ C
       BUFSIZE = id%KEEP(39)
       LOCNNZ = id%KEEP8(29)
       NROWS_LOC = LAST(MYID+1)-FIRST(MYID+1)+1
-      MAPTAB => WORK(     1 :   N)
-      LENG   => WORK(N+1 : 2*N)
+      MAPTAB => WORK(       1    :         N )
+      LENG   => WORK( int(N+1,8) : 2_8*int(N,8) )
       MAXS = 0
       DO I=1, NPROCS
          IF((LAST(I)-FIRST(I)+1) .GT. MAXS) THEN
@@ -2321,7 +2412,7 @@ C
       END SUBROUTINE DMUMPS_BUILD_DIST_GRAPH
 #endif      
       SUBROUTINE DMUMPS_BUILD_LOC_GRAPH(id, ord, GSIZE, IPE, PE, LENG,
-     &     I_HALO_MAP, top_graph, WORK)
+     &     I_HALO_MAP, top_graph, WORK, LWORK)
       IMPLICIT NONE
       TYPE(DMUMPS_STRUC)   :: id
       TYPE(ORD_TYPE)       :: ord
@@ -2329,6 +2420,7 @@ C
       INTEGER(8), POINTER  :: IPE(:)
       INTEGER, POINTER     :: PE(:), LENG(:),
      &     I_HALO_MAP(:), WORK(:)
+      INTEGER(8), INTENT(in) :: LWORK
       INTEGER              :: GSIZE
       INTEGER                :: IERR, MYID, NPROCS
       INTEGER                :: I, PROC, J, LOC_ROW
@@ -2355,13 +2447,13 @@ C
       nullify(TSENDI, TSENDJ, RCVBUF, APNT)
       MYID   = ord%MYID
       NPROCS = ord%NPROCS
-      IF(MUMPS_GETSIZE(WORK) .LT. N*2) THEN
+      IF( LWORK .LT. int(N,8)*2_8 ) THEN
          WRITE(LP,
      &        '("Insufficient workspace inside BUILD_LOC_GRAPH")')
          CALL MUMPS_ABORT()
       END IF
-      MAPTAB   => WORK(     1 :   N)
-      HALO_MAP => WORK(N+1 : 2*N)
+      MAPTAB   => WORK(      1    :         N   )
+      HALO_MAP => WORK(int(N+1,8) : 2_8*int(N,8))
       CALL MUMPS_I8REALLOC(SNDCNT, NPROCS, id%INFO, LP,
      &     MEMCNT=MEMCNT, ERRCODE=-7)
       CALL MUMPS_I8REALLOC(RCVCNT, NPROCS, id%INFO, LP,
@@ -2643,7 +2735,7 @@ C
       END SUBROUTINE DMUMPS_BUILD_LOC_GRAPH
       SUBROUTINE DMUMPS_LUMAT_TO_LOC_GRAPH 
      &     (LUMAT, id, ord, GSIZE, IPE, PE, LENG,
-     &     I_HALO_MAP, WORK)
+     &     I_HALO_MAP, WORK, LWORK)
       IMPLICIT NONE
       TYPE(LMATRIX_T), INTENT(IN) :: LUMAT
       TYPE(DMUMPS_STRUC)   :: id
@@ -2651,6 +2743,7 @@ C
       INTEGER(8), POINTER  :: IPE(:)
       INTEGER, POINTER     :: PE(:), LENG(:),
      &     I_HALO_MAP(:), WORK(:)
+      INTEGER(8), INTENT(IN) :: LWORK
       INTEGER              :: GSIZE
       INTEGER                :: IERR, MYID, NPROCS
       INTEGER                :: I, PROC, J, LOC_ROW 
@@ -2674,13 +2767,13 @@ C
       nullify( RCVBUF, APNT)
       MYID   = ord%MYID
       NPROCS = ord%NPROCS
-      IF(MUMPS_GETSIZE(WORK) .LT. N) THEN
+      IF ( LWORK .LT.2_8 * int(N,8) ) THEN
          WRITE(LP,
      &   '("Insufficient workspace inside DMUMPS_LUMAT_TO_LOC_GRAPH")')
          CALL MUMPS_ABORT()
       END IF
-      MAPTAB   => WORK(     1 :   N)
-      HALO_MAP => WORK(N+1 : 2*N)
+      MAPTAB   => WORK(       1    :         N   )
+      HALO_MAP => WORK( int(N+1,8) : 2_8*int(N,8))
       CALL MUMPS_I8REALLOC(SNDCNT, NPROCS, id%INFO, LP,
      &     MEMCNT=MEMCNT, ERRCODE=-7)
       CALL MUMPS_I8REALLOC(RCVCNT, NPROCS, id%INFO, LP,
@@ -3139,15 +3232,16 @@ C
       RETURN
       END SUBROUTINE DMUMPS_BUILD_TREE
       SUBROUTINE DMUMPS_GRAPH_DIST(id, ord, FIRST,
-     &     LAST, BASE, NPROCS, WORK, TYPE)
+     &     LAST, BASE, NPROCS, WORK, LWORK, TYPE)
       IMPLICIT NONE
-      TYPE(DMUMPS_STRUC)   :: id
-      TYPE(ORD_TYPE)       :: ord
-      INTEGER              :: FIRST(:), LAST(:), BASE, NPROCS, TYPE
-      INTEGER, TARGET      :: WORK(:)
-      INTEGER, POINTER     :: TMP(:), NZ_ROW(:)
-      INTEGER              :: I, IERR, P, F, J
-      INTEGER(8)           :: LOCNNZ, INNZ, LOCOFFDIAG,
+      TYPE(DMUMPS_STRUC)     :: id
+      TYPE(ORD_TYPE)         :: ord
+      INTEGER                :: FIRST(:), LAST(:), BASE, NPROCS, TYPE
+      INTEGER, TARGET        :: WORK(:)
+      INTEGER(8), INTENT(IN) :: LWORK
+      INTEGER, POINTER       :: TMP(:), NZ_ROW(:)
+      INTEGER                :: I, IERR, P, F, J
+      INTEGER(8)             :: LOCNNZ, INNZ, LOCOFFDIAG,
      &     OFFDIAG, T, SHARE
       DO I=0, BASE-1
          FIRST(I+1) = 0
@@ -3166,8 +3260,12 @@ C
             LAST (BASE+I) = N
          END DO
       ELSE IF (TYPE.EQ.2) THEN
+         IF (LWORK .LT. 2_8*int(N,8)) THEN
+           WRITE(*,*) "Insufficient workspace in DMUMPS_GRAPH_DIST"
+           CALL MUMPS_ABORT()
+         ENDIF
          TMP    => WORK(1:N)
-         NZ_ROW => WORK(N+1:2*N)
+         NZ_ROW => WORK(int(N+1,8):2-8*int(N,8))
          TMP = 0
          LOCOFFDIAG = 0_8
          LOCNNZ = id%KEEP8(29)
@@ -3181,7 +3279,7 @@ C
                END IF
             END IF
          END DO
-         CALL MPI_ALLREDUCE(TMP(1), NZ_ROW(1), N,
+         CALL MUMPS_BIGALLREDUCE(.FALSE., TMP(1), NZ_ROW(1), N,
      &        MPI_INTEGER, MPI_SUM, ord%COMM, IERR)
          CALL MPI_ALLREDUCE(LOCOFFDIAG, OFFDIAG, 1,
      &        MPI_INTEGER8, MPI_SUM, ord%COMM, IERR)
@@ -3284,7 +3382,7 @@ C
       IF (L(N+1) == 0) THEN
          RETURN 
       ELSE
-         L(N+1) = iabs(L(N+1))
+         L(N+1) = abs(L(N+1))
       END IF
  200  CONTINUE
       S = 0
@@ -3371,7 +3469,7 @@ C
       IF (SIZE_VELOLOCTAB.EQ.VERTLOCNBR) THEN
        CALL MUMPS_PARMETIS_VWGT(FIRST(1+BASE), VERTLOCTAB_I4(1),
      &     EDGELOCTAB(1), BASEVAL, OPTIONS(1), ORDER(1),
-     &     SIZES(1), COMM, VELOLOCTAB, IERR)
+     &     SIZES(1), COMM, VELOLOCTAB(1), IERR)
       ELSE
        CALL MUMPS_PARMETIS(FIRST(1+BASE), VERTLOCTAB_I4(1),
      &     EDGELOCTAB(1), BASEVAL, OPTIONS(1), ORDER(1),
@@ -3421,7 +3519,7 @@ C
      &     EDGELOCTAB(1),
      &     BASEVAL, OPTIONS(1),
      &     ORDER(1),
-     &     SIZES(1), COMM, VELOLOCTAB, IERR)
+     &     SIZES(1), COMM, VELOLOCTAB(1), IERR)
        ELSE
         CALL MUMPS_PARMETIS_64(FIRST(1+BASE), VERTLOCTAB(1),
      &     EDGELOCTAB(1),
@@ -3469,7 +3567,7 @@ C
      &     BASEVAL_I8, OPTIONS_I8(1),
 #endif
      &     ORDER_I8(1),
-     &     SIZES_I8(1), COMM, VELOLOCTAB_I8,
+     &     SIZES_I8(1), COMM, VELOLOCTAB_I8(1),
      &     IERR)
        ELSE
         CALL MUMPS_PARMETIS_64(FIRST_I8(1+BASE), VERTLOCTAB(1),
@@ -3514,6 +3612,9 @@ C
      &     VERTLOCNBR, VERTLOCTAB,
      &     EDGELOCNBR, EDGELOCTAB, 
      &     VELOLOCTAB, SIZE_VELOLOCTAB,
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+     &             CONTDAT, LCONTDAT,
+#endif
      &     IERR)
       IMPLICIT NONE
       INCLUDE 'ptscotchf.h'
@@ -3532,6 +3633,11 @@ C
      &     ORDEDAT(SCOTCH_DORDERDIM), STRADAT(SCOTCH_STRATDIM),
      &     CORDEDAT(SCOTCH_ORDERDIM)
       CHARACTER  STRSTRING*1024
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+      INTEGER             :: LCONTDAT
+      DOUBLE PRECISION    :: CONTDAT(LCONTDAT)
+      DOUBLE PRECISION    :: GRAPHDAT_BEFORE_CONTEXT(SCOTCH_DGRAPHDIM)
+#endif
       IF (.NOT.ord%IDO) RETURN
       nullify(VERTLOCTAB_I4)
       CALL MUMPS_REALLOC(VERTLOCTAB_I4, VERTLOCNBR+1, id%INFO, LP,
@@ -3554,7 +3660,14 @@ C
       ELSE
          MYWORKID = -1
       END IF
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+      CALL MUMPS_DGRAPHINIT(GRAPHDAT_BEFORE_CONTEXT, ord%COMM_PARAORD,
+     &                      IERR)
+      CALL SCOTCHFCONTEXTBINDDGRAPH(CONTDAT, GRAPHDAT_BEFORE_CONTEXT,
+     &                              GRAPHDAT, IERR)
+#else
       CALL MUMPS_DGRAPHINIT(GRAPHDAT, ord%COMM_PARAORD, IERR)
+#endif
       IF(IERR.NE.0) THEN
          id%INFO(1:2) = -50
       END IF
@@ -3641,8 +3754,11 @@ C
       IF(MYWORKID .EQ. 0) 
      &     CALL SCOTCHFDGRAPHCORDEREXIT(GRAPHDAT, CORDEDAT)
       CALL SCOTCHFDGRAPHORDEREXIT(GRAPHDAT, ORDEDAT)
-      CALL SCOTCHFSTRATEXIT(STRADAT) 
+      CALL SCOTCHFSTRATEXIT(STRADAT)
       CALL SCOTCHFDGRAPHEXIT(GRAPHDAT)
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+      CALL SCOTCHFDGRAPHEXIT(GRAPHDAT_BEFORE_CONTEXT)
+#endif
  10   CONTINUE
       CALL MUMPS_DEALLOC(VERTLOCTAB_I4, MEMCNT=MEMCNT)
       RETURN
@@ -3652,6 +3768,9 @@ C
      &     VERTLOCNBR, VERTLOCTAB,
      &     EDGELOCNBR, EDGELOCTAB,
      &     VELOLOCTAB, SIZE_VELOLOCTAB,
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+     &             CONTDAT, LCONTDAT,
+#endif
      &     IERR)
       IMPLICIT NONE
       INCLUDE 'ptscotchf.h'
@@ -3669,6 +3788,11 @@ C
      &     ORDEDAT(SCOTCH_DORDERDIM), STRADAT(SCOTCH_STRATDIM),
      &     CORDEDAT(SCOTCH_ORDERDIM)
       CHARACTER  STRSTRING*1024
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+      INTEGER             :: LCONTDAT
+      DOUBLE PRECISION    :: CONTDAT(LCONTDAT)
+      DOUBLE PRECISION    :: GRAPHDAT_BEFORE_CONTEXT(SCOTCH_DGRAPHDIM)
+#endif
       INTEGER(8), POINTER :: EDGELOCTAB_I8(:), PERMTAB_I8(:),
      &     PERITAB_I8(:), RANGTAB_I8(:), TREETAB_I8(:), VELOLOCTAB_I8(:)
       INTEGER(8)          :: CBLKNBR_I8, VERTLOCNBR_I8, BASEVAL_I8
@@ -3722,7 +3846,14 @@ C
        ENDIF
        BASEVAL_I8    = int(BASEVAL,8)
       ENDIF
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+      CALL MUMPS_DGRAPHINIT(GRAPHDAT_BEFORE_CONTEXT, ord%COMM_PARAORD,
+     &                      IERR)
+      CALL SCOTCHFCONTEXTBINDDGRAPH(CONTDAT, GRAPHDAT_BEFORE_CONTEXT,
+     &                              GRAPHDAT, IERR)
+#else
       CALL MUMPS_DGRAPHINIT(GRAPHDAT, ord%COMM_PARAORD, IERR)
+#endif
       IF(IERR.NE.0) THEN
          id%INFO(1:2) = -50
       END IF
@@ -3828,16 +3959,20 @@ C
       CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &     ord%COMM_PARAORD, ord%MYID_PARAORD )
       IF ( id%INFO(1) .LT. 0 ) GOTO 10
+      IF(MYWORKID .EQ. 0) 
+     &     CALL SCOTCHFDGRAPHCORDEREXIT(GRAPHDAT, CORDEDAT)
       CALL SCOTCHFDGRAPHORDEREXIT(GRAPHDAT, ORDEDAT)
       CALL SCOTCHFSTRATEXIT(STRADAT) 
       CALL SCOTCHFDGRAPHEXIT(GRAPHDAT)
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+      CALL SCOTCHFDGRAPHEXIT(GRAPHDAT_BEFORE_CONTEXT)
+#endif
  10   CONTINUE
       IF (id%KEEP(10).NE.1) THEN
        CALL MUMPS_I8DEALLOC(EDGELOCTAB_I8, MEMCNT=MEMCNT)
        IF (SIZE_VELOLOCTAB.GT.0)
      & CALL MUMPS_I8DEALLOC(VELOLOCTAB_I8, MEMCNT=MEMCNT)
        IF(MYWORKID .EQ. 0) THEN
-         CALL SCOTCHFDGRAPHCORDEREXIT(GRAPHDAT, CORDEDAT)
          CALL MUMPS_ICOPY_64TO32(PERMTAB_I8(1),
      &        size(ord%PERMTAB), ord%PERMTAB(1))
          CALL MUMPS_ICOPY_64TO32(PERITAB_I8(1),
diff -pruN 5.6.2-2.1/src/dana_dist_m.F 5.7.1-1/src/dana_dist_m.F
--- 5.6.2-2.1/src/dana_dist_m.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/dana_dist_m.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -80,6 +80,8 @@ C
       INTEGER  ISTEP_TO_INIV2( KEEP(71) )
       LOGICAL  I_AM_CAND(NMB_PAR2)
       INTEGER  CANDIDATES( SLAVEF+1, NMB_PAR2 )
+      INTEGER  PHASE
+      PARAMETER (PHASE=0)
       DOUBLE PRECISION OPSA
       DOUBLE PRECISION OPSA_LOC 
       INTEGER(8) MAX_SIZE_FACTOR
@@ -144,10 +146,15 @@ C
       INTEGER :: FLAG_L0OMP
       PARAMETER (FLAG_L0OMP=-2014)
       INCLUDE 'mumps_headers.h'
+      LOGICAL ROOT_OWNER
+      INTEGER(8) LWK_RR
+      INTEGER LIWK_RR
+      INTEGER IROOT, SIZE_ROOT
       INTEGER WHAT
       INTEGER(4) :: I4
       INTEGER(8) IDUMMY8
-      INTRINSIC min, int, real
+      INTRINSIC min, int
+      INTRINSIC dble
       INTEGER DMUMPS_OOC_GET_PANEL_SIZE
       EXTERNAL DMUMPS_OOC_GET_PANEL_SIZE
       INTEGER MUMPS_PROCNODE, MUMPS_TYPENODE
@@ -410,7 +417,7 @@ C
      &                KEEP(494), 1, KEEP(490),
      &                KEEP(491), KEEP(492),
      &                KEEP(20), KEEP(60), DAD(STEP(INODE)), KEEP(38),
-     &                LRSTATUS, IDUMMY)
+     &                KEEP(123), LRSTATUS, IDUMMY)
       COMPRESS_PANEL = (LRSTATUS.GE.2)
       COMPRESS_CB    = ((LRSTATUS.EQ.1).OR.(LRSTATUS.EQ.3))
       IF (COMPRESS_PANEL.OR.COMPRESS_CB) NBNODES_BLR = NBNODES_BLR+1
@@ -720,9 +727,9 @@ C
              ENDIF
             ENDIF
          ENDIF
-         NIRNEC = max0(NIRNEC,
+         NIRNEC = max(NIRNEC,
      &             NIRADU+ISTKI+SIZECBI+MAXITEMPCB)
-         NIRNEC_OOC = max0(NIRNEC_OOC,
+         NIRNEC_OOC = max(NIRNEC_OOC,
      &             NIRADU_OOC+ISTKI_OOC+SIZECBI+MAXITEMPCB +
      &             (XSIZE_OOC-XSIZE_IC) ) 
          CURRENT_ACTIVE_MEM = ISTKR+SIZECBINFR
@@ -852,7 +859,7 @@ C
      &                KEEP(494), 1, KEEP(490),
      &                KEEP(491), KEEP(492),
      &                KEEP(20), KEEP(60), DAD(STEP(IFSON)), KEEP(38),
-     &                LRSTATUSS, IDUMMY)
+     &                KEEP(123), LRSTATUSS, IDUMMY)
                COMPRESS_CBS   = ((LRSTATUSS.EQ.1).OR.(LRSTATUSS.EQ.3))
                IF (COMPRESS_CBS) THEN
                  K465_8    = int(KEEP(465),8)
@@ -1448,8 +1455,8 @@ C
            LSTKR(ITOP) = SIZECB
            ISTKR = ISTKR + LSTKR(ITOP)
            NRLNEC = max(NRLNEC,NRLADU+ISTKR+MAXTEMPCB)
-           NIRNEC = max0(NIRNEC,NIRADU+ISTKI+MAXITEMPCB)
-           NIRNEC_OOC = max0(NIRNEC_OOC,NIRADU_OOC+ISTKI_OOC+
+           NIRNEC = max(NIRNEC,NIRADU+ISTKI+MAXITEMPCB)
+           NIRNEC_OOC = max(NIRNEC_OOC,NIRADU_OOC+ISTKI_OOC+
      &          MAXITEMPCB + 
      &          (XSIZE_OOC-XSIZE_IC) ) 
            NRLNEC_if_LR_LU    =  max(NRLNEC_if_LR_LU,
@@ -1482,6 +1489,73 @@ C
          ENDIF
       ENDIF 
  115  CONTINUE
+      IF ( KEEP(53) .NE. 0 ) THEN
+        IF ( KEEP(38) .ne. 0 ) THEN
+          IROOT = KEEP( 38 )
+        ELSE
+          IROOT = KEEP( 20 )
+        END IF
+        ROOT_OWNER = ( MYID .eq.
+     &  MUMPS_PROCNODE( PROCNODE(STEP(IROOT)), KEEP(199) ) )
+        SIZE_ROOT = ND(STEP(IROOT))+KEEP(253)
+        CALL DMUMPS_SVD_QR_ESTIM_WK( PHASE, 
+     &       KEEP(51), KEEP(51), SIZE_ROOT,
+     &       LOCAL_M, LOCAL_N, ROOT_OWNER, KEEP,KEEP8,
+     &       LIWK_RR, LWK_RR )
+        IF ( NRLNEC-NRLADU .LT. LWK_RR ) THEN
+          NRLNEC = NRLADU + LWK_RR
+          NRLNEC_if_LR_LU   = NRLNEC_if_LR_LU + LWK_RR
+          NRLNEC_if_LR_CB   = NRLNEC_if_LR_CB + LWK_RR
+          NRLNEC_if_LR_LUCB = NRLNEC_if_LR_LUCB + LWK_RR
+          NRLNEC_ACTIVE     = NRLNEC_ACTIVE     + LWK_RR
+          NRLNECOOC_if_LR_LUCB = NRLNECOOC_if_LR_LUCB  + LWK_RR
+          PEAK_LRLU_UD = 
+     &             max(PEAK_LRLU_UD,
+     &             NRLNEC_if_LR_LU + NRLADULR_UD)
+          PEAK_OOC_LRLU_UD = 
+     &             max(PEAK_OOC_LRLU_UD,
+     &             NRLNEC_ACTIVE + NRLADULR_UD)
+          PEAK_OOC_LRLU_WC = 
+     &             max(PEAK_OOC_LRLU_WC,
+     &             NRLNEC_ACTIVE + NRLADULR_WC)
+          PEAK_LRLUCB_UD = 
+     &             max(PEAK_LRLUCB_UD,
+     &             NRLNEC_if_LR_LUCB + NRLNECLR_LUCB_UD)
+          PEAK_LRLUCB_WC = 
+     &             max(PEAK_LRLUCB_WC,
+     &             NRLNEC_if_LR_LUCB + NRLNECLR_LUCB_WC)
+          PEAK_OOC_LRLUCB_UD = 
+     &             max(PEAK_OOC_LRLUCB_UD,
+     &             NRLNECOOC_if_LR_LUCB + NRLNECLR_LUCB_UD)
+          PEAK_OOC_LRLUCB_WC = 
+     &             max(PEAK_OOC_LRLUCB_WC,
+     &             NRLNECOOC_if_LR_LUCB + NRLNECLR_LUCB_WC)
+          PEAK_LRCB_UD =
+     &             max(PEAK_LRCB_UD,
+     &             NRLNEC_if_LR_CB + NRLNECLR_CB_UD)
+          PEAK_OOC_LRCB_UD =
+     &             max(PEAK_OOC_LRCB_UD,
+     &             NRLNECOOC_if_LR_LUCB + NRLNECLR_CB_UD)
+          IF (ABOVE_L0) THEN
+           PEAK_DYN_LRLU_UD   = max( PEAK_DYN_LRLU_UD,
+     &          SIZECB_UNDER_L0 + NRLADULR_UD )
+           PEAK_DYN_LRCB_UD   = max( PEAK_DYN_LRCB_UD,
+     &          SIZECB_UNDER_L0_IF_LRCB + ISTKR_if_LRCB)
+           PEAK_DYN_LRLUCB_UD = max( PEAK_DYN_LRLUCB_UD,
+     &      SIZECB_UNDER_L0_IF_LRCB + ISTKR_if_LRCB + NRLADULR_UD)
+           PEAK_DYN_LRLU_WC   = max( PEAK_DYN_LRLU_WC,
+     &          SIZECB_UNDER_L0 + NRLADULR_WC)
+           PEAK_DYN_LRLUCB_WC = max( PEAK_DYN_LRLUCB_WC,
+     &          SIZECB_UNDER_L0 + ISTKRLR_CB_WC + NRLADULR_WC)
+          ENDIF
+        END IF
+        IF ( NIRNEC-NIRADU .LT. LIWK_RR ) THEN
+          NIRNEC = NIRADU + LIWK_RR
+        END IF
+        IF ( NIRNEC_OOC-NIRADU_OOC .LT. LIWK_RR ) THEN
+          NIRNEC_OOC = NIRADU_OOC + LIWK_RR
+        END IF
+      END IF
       NRLNEC = max(NRLNEC, NRLADU+int(KEEP(30),8))
       NRLNEC_ACTIVE = max(NRLNEC_ACTIVE, MAX_SIZE_FACTOR+
      &                    int(KEEP(30),8))
@@ -1938,7 +2012,7 @@ C
      &                KEEP(494), 1, KEEP(490),
      &                KEEP(491), KEEP(492),
      &                KEEP(20), KEEP(60), DAD(STEP(INODE)), KEEP(38),
-     &                LRSTATUS, IDUMMY)
+     &                KEEP(123), LRSTATUS, IDUMMY)
       COMPRESS_PANEL = (LRSTATUS.GE.2)
       COMPRESS_CB    = ((LRSTATUS.EQ.1).OR.(LRSTATUS.EQ.3))
       IF (COMPRESS_PANEL.OR.COMPRESS_CB) NBNODES_BLR = NBNODES_BLR+1
@@ -2010,9 +2084,9 @@ C
                NRLADU_if_LR_LU = NRLADU_if_LR_LU + NRLADU_CURRENT
       ENDIF
       SIZECBI        = 2* NCB  + SIZEHEADER
-      NIRNEC = max0(NIRNEC,
+      NIRNEC = max(NIRNEC,
      &             NIRADU+ISTKI+SIZECBI+MAXITEMPCB)
-      NIRNEC_OOC = max0(NIRNEC_OOC,
+      NIRNEC_OOC = max(NIRNEC_OOC,
      &             NIRADU_OOC+ISTKI_OOC+SIZECBI+MAXITEMPCB +
      &             (XSIZE_OOC-XSIZE_IC) ) 
       CURRENT_ACTIVE_MEM = ISTKR+SIZECBINFR
@@ -2243,8 +2317,8 @@ C
            LSTKR(ITOP) = SIZECB
            ISTKR = ISTKR + LSTKR(ITOP)
            NRLNEC = max(NRLNEC,NRLADU+ISTKR)
-           NIRNEC = max0(NIRNEC,NIRADU+ISTKI)
-           NIRNEC_OOC = max0(NIRNEC_OOC,NIRADU_OOC+ISTKI_OOC)
+           NIRNEC = max(NIRNEC,NIRADU+ISTKI)
+           NIRNEC_OOC = max(NIRNEC_OOC,NIRADU_OOC+ISTKI_OOC)
            NRLNEC_if_LR_LU  =  max(NRLNEC_if_LR_LU,
      &                             NRLADU_if_LR_LU+ISTKR)
            LSTKR_if_LRCB(ITOP) = SIZECB_if_LRCB
diff -pruN 5.6.2-2.1/src/dana_driver.F 5.7.1-1/src/dana_driver.F
--- 5.6.2-2.1/src/dana_driver.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/dana_driver.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -48,15 +48,14 @@ C     Local variables
 C     ===============
 C     
 C     
-C     Pointers inside integer array, various data
-      INTEGER IKEEP, NE, NA
+C     Pointers inside integer array IKEEPALLOC, various data
+      INTEGER(8) IKEEP, NE, NA
       INTEGER I, allocok
 C     Other locals
       INTEGER NB_NIV2, IDEST
       INTEGER :: STATUS(MPI_STATUS_SIZE)
       INTEGER LOCAL_M, LOCAL_N
-      INTEGER numroc
-      EXTERNAL numroc
+      INTEGER, EXTERNAL :: MUMPS_NUMROC
       INTEGER IRANK
       INTEGER MP, LP, MPG
       LOGICAL PROK, PROKG, LISTVAR_SCHUR_2BE_FREED, LPOK
@@ -148,7 +147,7 @@ C     Element matrix entry
       INTEGER :: OOC_STRAT, BLR_STRAT
       INTEGER :: IDUMMY
       INTEGER, TARGET    :: IDUMMY_ARRAY(1)
-      INTEGER(8)                     :: NNZ_loc
+      INTEGER(8)                     :: NNZ_loc, NNZ_TMP
       INTEGER, POINTER, DIMENSION(:) :: IRN_loc_PTR
       INTEGER, POINTER, DIMENSION(:) :: JCN_loc_PTR
       INTEGER, POINTER, DIMENSION(:) :: IRN_PTR
@@ -158,6 +157,7 @@ C     Element matrix entry
       LOGICAL :: BDUMMY
       INTEGER(8) :: K8_33relaxed, K8_34relaxed, K8_35relaxed,
      &              K8_50relaxed
+!$    INTEGER :: NOMP, NOMPMAX, NOMPMIN
       LOGICAL :: SUM_OF_PEAKS
       INTEGER MUMPS_TYPENODE, MUMPS_PROCNODE
       EXTERNAL MUMPS_TYPENODE, MUMPS_PROCNODE
@@ -219,11 +219,16 @@ C
      &     NFSIZPTR,
      &     FREREPTR, NE_STEPSPTR,
      &     IKEEP1, IKEEP2, IKEEP3
-      INTEGER, ALLOCATABLE, DIMENSION(:) :: FILS_TMP, STEP_TMP, 
+#if defined(MUMPS_NOF2003)
+      INTEGER, POINTER, DIMENSION(:) ::  FILS_TMPPTR
+#endif
+      INTEGER, ALLOCATABLE, DIMENSION(:), TARGET :: FILS_TMP
+      INTEGER, ALLOCATABLE, DIMENSION(:) :: STEP_TMP,
      &                                      LRGROUPS_TMP
       INTEGER, ALLOCATABLE, DIMENSION(:), TARGET :: IKEEPALLOC
       INTEGER, ALLOCATABLE, DIMENSION(:) :: WORK2ALLOC
-      INTEGER :: SIZEIKEEPALLOC, SIZELRGROUPS_TMP
+      INTEGER :: SIZELRGROUPS_TMP
+      INTEGER(8) :: SIZEIKEEPALLOC, SIZEWORK2ALLOC
 C     NBINROW_TMP, NBINCOL_TMP are computed in DMUMPS_ANA_DIST_N
 C     and used in DMUMPS_ANA_DIST_ARROWHEADS
       INTEGER, ALLOCATABLE, DIMENSION(:) :: NBINROW_TMP, NBINCOL_TMP
@@ -233,7 +238,7 @@ C     and used in DMUMPS_ANA_DIST_ARROWH
       INTEGER(kind=8) :: NZ8, LIW8
 C     NBLK : id%N or order of blocked matrix
       INTEGER :: NBLK, idNBLKSAVE
-      INTEGER :: LIW_ELT
+      INTEGER(8) :: LIW8_ELT
 C     GATHER_MATRIX_ALLOCATED: 
 C     To be sure that id%IRN and id%JCN are
 C     deallocated only when DMUMPS_GATHER_MATRIX was called
@@ -407,8 +412,25 @@ C     Broadcast KEEP(251,252,253) define
       CALL MPI_BCAST( KEEP(251), 3, MPI_INTEGER,MASTER,id%COMM,IERR)
 C
       CALL MPI_BCAST( KEEP(400), 1, MPI_INTEGER,MASTER,id%COMM,IERR)
+!$    IF (id%KEEP(400).GT.0) THEN
+!$       NOMP = OMP_GET_MAX_THREADS()
+!$       CALL MPI_ALLREDUCE(NOMP,NOMPMIN,1,MPI_INTEGER,MPI_MIN,
+!$   &                      id%COMM,IERR)
+!$       CALL MPI_ALLREDUCE(NOMP,NOMPMAX,1,MPI_INTEGER,MPI_MAX,
+!$   &                      id%COMM,IERR)
+!$       IF ( NOMPMIN .NE. NOMPMAX ) THEN
+!$          IF (PROKG) THEN
+!$             WRITE(MPG, '(A,A,I4,A,I4,A)')
+!$   &  '      WARNING tree parallelism (ICNTL(48)) switched off', 
+!$   &  ' because of different number of threads per MPI proc (max ',
+!$   &         NOMPMAX, ', min ', NOMPMIN, ')'
+!$          ENDIF
+!$          KEEP(400) = 0
+!$       END IF
+!$      ENDIF 
       CALL MPI_BCAST( id%KEEP(490), 5, MPI_INTEGER, MASTER,
      &     id%COMM, IERR )
+      CALL MPI_BCAST( KEEP(123),1,MPI_INTEGER,MASTER,id%COMM,IERR)
 C     ----------------------------------------------
 C     Broadcast N 
 C     ----------------------------------------------
@@ -472,7 +494,7 @@ C     test IRN_loc and JCN_loc allocated
       id%MEM_DIST(0:id%NSLAVES-1) = 0
       CALL MUMPS_INIT_ARCH_PARAMETERS(
      &     id%COMM,id%COMM_NODES,KEEP(69),KEEP(46),
-     &     id%NSLAVES,id%MEM_DIST,INFO)
+     &     id%NSLAVES,id%MEM_DIST,INFO )
 C     ========================
 C     Write problem to a file,
 C     if requested by the user
@@ -708,23 +730,38 @@ C         ===================
 C{        Sequential analysis
 C         ===================
 C         =======================
-          IF (KEEP(54).NE.3) THEN
+          IF (KEEP(54).NE.3.OR.id%NPROCS.EQ.1) THEN
 C         =======================
 C{        Matrix structure available on host
+C         also case of distributed input matrix format 
+C         with one mpi proc
 C         ---------------------
            KEEP(14) = 0 
            IF (id%MYID.EQ.MASTER) THEN
 C            Store input matrix (IRN/JCN) as a cleaned blocked Lmatrix 
 C            of nodes (indices \in [1,NBLK])
-             IF (id%KEEP8(28) .EQ. 0_8) THEN
-               IRN_PTR => IDUMMY_ARRAY
-               JCN_PTR => IDUMMY_ARRAY
+             IF (KEEP(54).NE.3) THEN
+               IF (id%KEEP8(28) .EQ. 0_8) THEN
+                 IRN_PTR => IDUMMY_ARRAY
+                 JCN_PTR => IDUMMY_ARRAY
+               ELSE
+                 IRN_PTR => id%IRN
+                 JCN_PTR => id%JCN
+               ENDIF
+               NNZ_TMP = id%KEEP8(28) 
              ELSE
-               IRN_PTR => id%IRN
-               JCN_PTR => id%JCN
-             ENDIF
+               IF (id%KEEP8(29) .EQ. 0_8) THEN ! NNZ_loc or NZ_loc
+                 IRN_PTR => IDUMMY_ARRAY
+                 JCN_PTR => IDUMMY_ARRAY
+                 id%KEEP8(29) = 0_8
+               ELSE
+                 IRN_PTR => id%IRN_loc
+                 JCN_PTR => id%JCN_loc
+               ENDIF
+               NNZ_TMP = id%KEEP8(29) 
+             ENDIF 
              CALL MUMPS_AB_COORD_TO_LMAT ( id%MYID,
-     &             NBLK, id%N, id%KEEP8(28), IRN_PTR(1), JCN_PTR(1),
+     &             NBLK, id%N, NNZ_TMP, IRN_PTR(1), JCN_PTR(1),
      &             DOF2BLOCK, 
      &             INFO(1), INFO(2), LP, LPOK, 
      &             LMAT_BLOCK, IDUMMY8, KEEP(1) )
@@ -742,7 +779,7 @@ C            symmetrizing the Lmatrix
      &            INFO(1), ICNTL(1), MEMCNT)
              GCOMP_PROVIDED = .TRUE.
              IF (KEEP(494).EQ.0.OR.KEEP(487).NE.1) THEN
-               CALL MUMPS_AB_FREE_LMAT(LMAT_BLOCK)
+               CALL MUMPS_AB_FREE_LMAT(LMAT_BLOCK, KEEP(147))
                LMAT_BLOCK_AVAIL_I = 0
              ELSE
                LMAT_BLOCK_AVAIL_I = 1
@@ -801,7 +838,7 @@ C             Build GCOMP, the centraliz
      &             LUMAT, LUMAT_AVAIL, GCOMP_DIST, READY_FOR_ANA_F)
             ENDIF
             IF (LUMAT_AVAIL.AND.KEEP(487).NE.1) THEN
-               CALL MUMPS_AB_FREE_LMAT(LUMAT)
+               CALL MUMPS_AB_FREE_LMAT(LUMAT, KEEP(147))
                LUMAT_AVAIL = .FALSE.
             ENDIF
 C        
@@ -839,6 +876,8 @@ C     Collect on the host -- if matrix i
 C     at analysis -- all integer information needed
 C     to perform ordering
 C     -----------------------------------------------
+C FIXME: one should test instead if GCOMP_DIST available 
+C        instead of retestinf KEEP(13) and NPROCS.NE.1
           IF (KEEP(13).NE.0) THEN
            IF (id%NPROCS.NE.1) THEN
              CALL MUMPS_AB_GATHER_GRAPH(
@@ -914,14 +953,15 @@ C                Maximum transversal is
 C                entry format
 C              UNS_PERM that might be set to
 C              to permutation computed during Max transversal
-               ALLOCATE(id%UNS_PERM(id%N),IKEEPALLOC(3*id%N),
+               ALLOCATE(id%UNS_PERM(id%N),IKEEPALLOC(3_8*int(id%N,8)),
      &                  WORK2ALLOC(id%N), stat=IERR)
                IF (IERR.GT.0) THEN
                 INFO(1)=-7
-                INFO(2)=5*id%N
+                CALL MUMPS_SET_IERROR( 5_8 * int(id%N,8), INFO(2) )
                ELSE
                 CALL DMUMPS_ANA_O(id%N, id%KEEP8(28), KEEP(23),
-     &              id%UNS_PERM, IKEEPALLOC, id%IRN, id%JCN, id%A,
+     &              id%UNS_PERM, IKEEPALLOC, 3_8*int(id%N,8),
+     &              id%IRN, id%JCN, id%A,
      &              id%ROWSCA, id%COLSCA,
      &              WORK2ALLOC, id%KEEP, id%ICNTL, id%INFO, id%INFOG)
                 IF (allocated(WORK2ALLOC)) DEALLOCATE(WORK2ALLOC)
@@ -966,15 +1006,16 @@ C          be given to ANA_F.
      &               NFSIZPTR(NBLK), stat=IERR)
              IF (IERR.GT.0) THEN
               INFO(1)=-7
-              INFO(2)=3*NBLK
+              CALL MUMPS_SET_IERROR(int(NBLK,8)*3_8, INFO(2))
              ENDIF
            ELSE
-             ALLOCATE(IKEEPALLOC(NBLK+2*id%N), 
+             ALLOCATE(IKEEPALLOC(int(NBLK,8)+2_8*int(id%N,8)), 
      &               FILS_TMP(NBLK), FREREPTR(NBLK),
      &               NFSIZPTR(NBLK), stat=IERR)
             IF (IERR.GT.0) THEN
              INFO(1)=-7
-             INFO(2)=4*NBLK+2*id%N
+             CALL MUMPS_SET_IERROR(int(NBLK,8)*4_8+2_8*int(id%N,8),
+     &            INFO(2))
             ENDIF
            ENDIF
          ENDIF
@@ -1038,19 +1079,20 @@ C
 C                 we suppress supervariable detection when Schur
 C                 is active or when METIS is applied
 C                 Workspaces for FLAG(N), and either LEN(N) or some pointers(N+1)
-                  LIW_ELT = id%N + id%N + 1
+                  LIW8_ELT = int(id%N,8) + int(id%N,8) + 1_8
                ELSE
 C                 Spaces FLAG(N), LEN(N), N+3, SVAR(0:N),
-                  LIW_ELT =  id%N + id%N + id%N + 3 + id%N + 1
+                  LIW8_ELT =  int(id%N,8) + int(id%N,8) +
+     &                       int(id%N,8)+3_8 + int(id%N,8)+1_8
                ENDIF
 C     
             ENDIF
 C           We must ensure that an array of order
 C           3*N is available for DMUMPS_ANA_LNEW
             IF (KEEP(55) .EQ. 0) THEN
-              IF (LIW8.LT.3_8*int(NBLK,8)) LIW8 = 3_8*int(NBLK,8)
+              IF (LIW8.LT.3_8*int(NBLK,8)) LIW8=3_8*int(NBLK,8)
             ELSE
-              IF (LIW_ELT.LT.3*id%N) LIW_ELT = 3*id%N
+              IF (LIW8_ELT.LT.3_8*int(id%N,8)) LIW8_ELT=3_8*int(id%N,8)
             ENDIF
 C
             IF ( KEEP(256) .EQ. 1 ) THEN
@@ -1058,7 +1100,7 @@ C            It has been checked that id
 C            values of pivot order will be checked later and
 C            should be checked here too
 C            PERM_IN( I ) = position of I in the pivot order
-             IKEEP2 => IKEEPALLOC(NBLK+1:NBLK+id%N)
+             IKEEP2 => IKEEPALLOC(int(NBLK+1,8):int(NBLK,8)+int(id%N,8))
 C            Build inverse permutation and check PERM_IN 
              DO I = 1, id%N
                 IKEEP2(I) = 0
@@ -1100,6 +1142,11 @@ C             IKEEP2 holds inverse permu
                   I       = IKEEP2(IPOS)
                   IB      = DOF2BLOCK(I)
                   IF (IB.NE.IBcurrent) THEN
+                   IF (PROKG) THEN
+                    WRITE(MPG,'(A,A)') 
+     &               " ERROR: given permutation (ICNTL(7)=1)",
+     &               " incompatible with block format"
+                   ENDIF
                    INFO(1)= -4
                    INFO(2)= I
                    GOTO 10
@@ -1111,6 +1158,11 @@ C             IKEEP2 holds inverse permu
 C             IF PERM_IN is correct then
 C             on exit last position should be NBLK
               IF (IPOSB.NE.NBLK) THEN
+                   IF (PROKG) THEN
+                    WRITE(MPG,'(A,A)') 
+     &               " ERROR: given permutation (ICNTL(7)=1)",
+     &               " incompatible with block format"
+                   ENDIF
                    INFO(1)= -4
 C                  N+1 to indicate "global" error
                    INFO(2)= id%N+1
@@ -1129,8 +1181,10 @@ C           Initialize structural symmet
             INFOG(8) = -1
             IF (KEEP(55) .EQ. 0) THEN
                IKEEP1 => IKEEPALLOC(1:NBLK)
-               IKEEP2 => IKEEPALLOC(NBLK+1:NBLK+id%N)
-               IKEEP3 => IKEEPALLOC(NBLK+id%N+1:NBLK+2*id%N)
+               IKEEP2 => IKEEPALLOC(int(NBLK+1,8):
+     &                              int(NBLK,8)+int(id%N,8))
+               IKEEP3 => IKEEPALLOC(int(NBLK,8)+int(id%N+1,8):
+     &                              int(NBLK,8)+2_8*int(id%N,8))
 C              id%UNS_PERM corresponds to argument PIV
 C              in DMUMPS_ANA_F, it should be an assumed-shape
 C              array rather than a possibly null pointer:
@@ -1144,7 +1198,8 @@ C              array rather than a possi
      &              id%IRN, id%JCN,
      &              LIW8, IKEEP1, IKEEP2, IKEEP3,
      &              KEEP(256), NFSIZPTR,
-     &              FILS_TMP, FREREPTR,
+     &              FILS_TMP,
+     &              FREREPTR,
      &              id%LISTVAR_SCHUR, SIZE_SCHUR_PASSED,
      &              id%ICNTL, id%INFOG, id%KEEP,id%KEEP8,id%NSLAVES, 
      &              UNS_PERM_PTR,
@@ -1204,7 +1259,7 @@ C     -- internal error
                   GOTO 10
                ENDIF
                CALL DMUMPS_ANA_F_ELT(id%N, NELT,
-     &              id%ELTPTR(1), id%ELTVAR(1), LIW_ELT,
+     &              id%ELTPTR(1), id%ELTVAR(1), LIW8_ELT,
      &              IKEEPALLOC(1),
      &              KEEP(256), NFSIZPTR(1), FILS_TMP(1),
      &              FREREPTR(1), id%LISTVAR_SCHUR(1),
@@ -1238,9 +1293,9 @@ C           ----------------------------
             INFO(2)=INFOG(2)
 C           save statistics in KEEP array.
             KEEP(28) = INFOG(6)
-            IKEEP = 1
-            NA      = IKEEP +     id%N
-            NE      = IKEEP + 2 * id%N
+            IKEEP = 1_8
+            NA      = IKEEP +       int(id%N,8)
+            NE      = IKEEP + 2_8 * int(id%N,8)
 C       -- if (id%myid.eq.master)
         ENDIF
 C       -- if sequential analysis
@@ -1302,24 +1357,34 @@ C{    Parallel analysis
 C             KEEPALLOC reuse later 
 C             FIXME allocate of size 2*NBLK and 
 C                   allocate of size 3*id%N after call ana_aux_par
-              SIZEIKEEPALLOC = 3*id%N
+              SIZEIKEEPALLOC = 3_8*int(id%N,8)
+              SIZEWORK2ALLOC = max(4_8*int(NBLK,8), int(id%NPROCS+1,8))
             ALLOCATE( IKEEPALLOC(SIZEIKEEPALLOC), 
-     &                WORK2ALLOC(max(4*NBLK,id%NPROCS+1)), 
+     &                WORK2ALLOC(SIZEWORK2ALLOC),
      &                FILS_TMP(NBLK), FREREPTR(NBLK), NFSIZPTR(NBLK),
      &      stat=IERR)
          ELSE IF (COMM_PARASYMB.NE.MPI_COMM_NULL) THEN
 C           Allocate only on procs concerned by parallel analysis
-            ALLOCATE(IKEEPALLOC(3*NBLK),WORK2ALLOC(4*NBLK), stat=IERR )
+            SIZEIKEEPALLOC = 3_8*int(NBLK,8)
+            SIZEWORK2ALLOC = 4_8*int(NBLK,8)
+            ALLOCATE(IKEEPALLOC(SIZEIKEEPALLOC),
+     &               WORK2ALLOC(SIZEWORK2ALLOC), stat=IERR )
          ELSE
 C           Not concerned by DMUMPS_ANA_F_PAR
             IERR = 0
+            SIZEIKEEPALLOC = 0_8
+            SIZEWORK2ALLOC = 0_8
          ENDIF
          IF (IERR.GT.0) THEN
            INFO(1) = -7
            IF (id%MYID .EQ. MASTER) THEN
-             INFO( 2 ) = SIZEIKEEPALLOC+7*NBLK
+             CALL MUMPS_SET_IERROR(
+     &            SIZEIKEEPALLOC+SIZEWORK2ALLOC+3_8*int(NBLK,8),
+     &            INFO(2) )
            ELSE
-             INFO( 2 ) = 7*NBLK
+             CALL MUMPS_SET_IERROR(
+     &            SIZEIKEEPALLOC+SIZEWORK2ALLOC,
+     &            INFO(2) )
            ENDIF
          ENDIF
          CALL MUMPS_PROPINFO( ICNTL(1), INFO(1), id%COMM, id%MYID )
@@ -1327,6 +1392,16 @@ C           Not concerned by DMUMPS_ANA_
 C        save value provided by user
          idNBLKSAVE= id%NBLK
 C
+#if defined(MUMPS_NOF2003)
+C        Allocatable not allowed in DMUMPS_ANA_F_PAR,
+C        use a pointer instead. FILS_TMP is typically
+C        allocated only on MPI rank 0.
+         IF (allocated(FILS_TMP)) THEN
+           FILS_TMPPTR => FILS_TMP
+         ELSE
+           FILS_TMPPTR => IDUMMY_ARRAY
+         ENDIF
+#endif
          IF (LUMAT_AVAIL) THEN
 C{
 C             
@@ -1336,18 +1411,24 @@ C
             CALL DMUMPS_ANA_F_PAR(id,
      &        IKEEPALLOC,
      &        WORK2ALLOC,
+     &        SIZEIKEEPALLOC,
+     &        SIZEWORK2ALLOC,
      &        NFSIZPTR,
+#if defined(MUMPS_NOF2003)
+     &        FILS_TMPPTR,
+#else
      &        FILS_TMP,
+#endif
      &        FREREPTR,
      &        COMM_PARASYMB
-!    optionnal:
+!    optional:
      &        , LUMAT, SIZEOFBLOCKS
      &        , COMM_PARAORD, NPROCS_PARAORD
      &        , RKinSYMB_PROC0ORD
      & )
            ENDIF
            IF (KEEP(494).EQ.0.OR.KEEP(487).NE.1) THEN
-            CALL MUMPS_AB_FREE_LMAT(LUMAT)
+            CALL MUMPS_AB_FREE_LMAT(LUMAT,KEEP(147))
             LUMAT_AVAIL = .FALSE.
            ELSE
             LUMAT_AVAIL = .TRUE.
@@ -1360,8 +1441,14 @@ C{         LUMAT not available and COMM_
            CALL DMUMPS_ANA_F_PAR(id,
      &        IKEEPALLOC,
      &        WORK2ALLOC,
+     &        SIZEIKEEPALLOC,
+     &        SIZEWORK2ALLOC,
      &        NFSIZPTR,
+#if defined(MUMPS_NOF2003)
+     &        FILS_TMPPTR,
+#else
      &        FILS_TMP,
+#endif
      &        FREREPTR,
      &        id%COMM
      & )
@@ -1392,9 +1479,9 @@ C        Check error after freeing commu
          IF ( INFO(1) < 0 ) GOTO 500
 C
          IF (id%MYID.EQ.MASTER) THEN
-           IKEEP   = 1
-           NA      = IKEEP +     id%N
-           NE      = IKEEP + 2 * id%N 
+           IKEEP   = 1_8
+           NA      = IKEEP +       int(id%N,8)
+           NE      = IKEEP + 2_8 * int(id%N,8)
          ENDIF
 C        ---------------------------------------------------------
 C        Check whether FILS_TMP, FREREPTR, NFSIZPTR
@@ -1413,7 +1500,7 @@ C              allways copied back in st
           IF (IERR.GT.0) THEN
            INFO(1) = -7
            IF (id%MYID .EQ. MASTER) THEN
-             INFO( 2 ) = 3*id%N
+             CALL MUMPS_SET_IERROR(3_8*int(id%N,8), INFO(2))
            ENDIF
          ENDIF
          CALL MUMPS_PROPINFO( ICNTL(1), INFO(1), id%COMM, id%MYID )
@@ -1530,7 +1617,7 @@ C      peak is set by default to 1 large
      &        dble(id%KEEP(2))*dble(id%KEEP(2))     ! cb bloc
 C     IKEEP(1:N,1) can be used as a work space since it is set
 C     to its final state by the SORT_PERM subroutine below.
-            SSARBR => IKEEPALLOC(IKEEP:IKEEP+NBLK-1)
+            SSARBR => IKEEPALLOC(IKEEP:IKEEP+int(NBLK-1,8))
 C     ======================================================
 C     Map nodes and assign candidates for dynamic scheduling
 C     ======================================================
@@ -1864,15 +1951,15 @@ C     (the two useful informations for f
          IF (NBLK.eq.1) THEN
             NBROOT = 1
             NBLEAF = 1
-         ELSE IF (IKEEPALLOC(NA+NBLK-1) .LT.0) THEN
+         ELSE IF (IKEEPALLOC(NA+int(NBLK-1,8)) .LT.0) THEN
             NBLEAF= NBLK
             NBROOT= NBLK
-         ELSE IF (IKEEPALLOC(NA+NBLK-2) .LT.0) THEN
+         ELSE IF (IKEEPALLOC(NA+int(NBLK-2,8)) .LT.0) THEN
             NBLEAF = NBLK-1
-            NBROOT = IKEEPALLOC(NA+NBLK-1)
+            NBROOT = IKEEPALLOC(NA+int(NBLK-1,8))
          ELSE
-            NBLEAF = IKEEPALLOC(NA+NBLK-2)
-            NBROOT = IKEEPALLOC(NA+NBLK-1)
+            NBLEAF = IKEEPALLOC(NA+int(NBLK-2,8))
+            NBROOT = IKEEPALLOC(NA+int(NBLK-1,8))
          ENDIF
          id%LNA = 2+NBLEAF+NBROOT
       ENDIF
@@ -1897,26 +1984,26 @@ C        Initialize NA with the leaves a
          IF ( NBLK == 1 ) THEN
             id%NA(LEAF) = 1
             LEAF = LEAF + 1
-         ELSE IF (IKEEPALLOC(NA+NBLK-1) < 0) THEN
-            id%NA(LEAF) = - IKEEPALLOC(NA+NBLK-1)-1
+         ELSE IF (IKEEPALLOC(NA+int(NBLK-1,8)) < 0) THEN
+            id%NA(LEAF) = - IKEEPALLOC(NA+int(NBLK-1,8))-1
             LEAF = LEAF + 1
             DO I = 1, NBLEAF - 1
-               id%NA(LEAF) = IKEEPALLOC(NA+I-1)
+               id%NA(LEAF) = IKEEPALLOC(NA+int(I-1,8))
                LEAF = LEAF + 1
             ENDDO
-         ELSE IF (IKEEPALLOC(NA+NBLK-2) < 0 ) THEN
-            INODE = - IKEEPALLOC(NA+NBLK-2) - 1
+         ELSE IF (IKEEPALLOC(NA+int(NBLK-2,8)) < 0 ) THEN
+            INODE = - IKEEPALLOC(NA+int(NBLK-2,8)) - 1
             id%NA(LEAF) = INODE
             LEAF =LEAF + 1
             IF ( NBLEAF > 1 ) THEN
                DO I = 1, NBLEAF - 1
-                  id%NA(LEAF) = IKEEPALLOC(NA+I-1)
+                  id%NA(LEAF) = IKEEPALLOC(NA+int(I-1,8))
                   LEAF = LEAF + 1
                ENDDO
             ENDIF
          ELSE
             DO I = 1, NBLEAF
-               id%NA(LEAF) = IKEEPALLOC(NA+I-1)
+               id%NA(LEAF) = IKEEPALLOC(NA+int(I-1,8))
                LEAF = LEAF + 1
             ENDDO
          END IF
@@ -1963,8 +2050,8 @@ C        copies to NSTEP array should be
             IF (FREREPTR(I) .NE. NBLK+1) THEN
                id%PROCNODE_STEPS(STEP_TMP(I)) = PROCNODE( I )
                id%FRERE_STEPS(STEP_TMP(I))    = FREREPTR(I)
-               id%NE_STEPS(STEP_TMP(I))    = IKEEPALLOC(NE+I-1)
-               id%ND_STEPS(STEP_TMP(I))    = NFSIZPTR(I)
+               id%NE_STEPS(STEP_TMP(I)) = IKEEPALLOC(NE+int(I-1,8))
+               id%ND_STEPS(STEP_TMP(I)) = NFSIZPTR(I)
             ENDIF
          ENDDO
 C        ===============================
@@ -2039,6 +2126,7 @@ C         Broadcast errors
 C
           CALL MUMPS_INIALIZE_REDIST_LUMAT ( 
      &     id%INFO, id%ICNTL, id%KEEP, id%COMM, id%MYID, NBLK,
+     &     id%NPROCS,
      &     LUMAT, id%PROCNODE_STEPS(1), id%KEEP(28), MAPCOL, 
      &     LUMAT_REMAP, NBRECORDS, STEP_TMP(1))
 C         INFO(1) has been broadcasted already in routine
@@ -2053,7 +2141,7 @@ C         -- Redistribute LUMAT into LU_
      &      LUMAT_REMAP, NBRECORDS, NSEND8, NLOCAL8
      &     )
            LUMAT_REMAP_DIST_AVAIL = .TRUE.
-          CALL MUMPS_AB_FREE_LMAT(LUMAT)
+          CALL MUMPS_AB_FREE_LMAT(LUMAT,KEEP(147))
 C         Distribute SIZEOFBLOCKS that was defined only on master
           CALL MPI_BCAST( SIZEOFBLOCKS, NBLK, MPI_INTEGER, MASTER, 
      &     id%COMM, IERR )
@@ -2062,12 +2150,14 @@ C}
 C{        Centralized matrix and clean LMAT_BLOCK available
 C        
           IF (id%MYID.EQ.MASTER) THEN
+C
            CALL MUMPS_AB_CLEANLMAT_TO_LUMAT ( 
-     &              LMAT_BLOCK, LUMAT_REMAP,
+     &              LMAT_BLOCK, LUMAT_REMAP, KEEP(147),
      &              INFO(1), ICNTL(1))
            LUMAT_REMAP_CENT_AVAIL=.TRUE.
 C            --- LMAT_BLOCK not needed anymore
-           CALL MUMPS_AB_FREE_LMAT(LMAT_BLOCK)
+           CALL MUMPS_AB_FREE_LMAT(LMAT_BLOCK,KEEP(147))
+C
           ENDIF
 C         Broadcast errors
           CALL MUMPS_PROPINFO( ICNTL(1), INFO(1),
@@ -2170,6 +2260,8 @@ C         Broadcast errors
           CALL MUMPS_PROPINFO( ICNTL(1), INFO(1),
      &      id%COMM, id%MYID )
           IF ( INFO(1).LT.0 ) GOTO 500
+          CALL MPI_BCAST( id%ND_STEPS(1), KEEP(28), MPI_INTEGER,
+     &    MASTER, id%COMM, IERR )
           CALL DMUMPS_AB_LR_MPI_GROUPING(NBLK, 
      &           MAPCOL, id%KEEP(28), 
      &           id%KEEP(28), LUMAT_REMAP, FILS_TMP(1), 
@@ -2182,7 +2274,8 @@ C         Broadcast errors
      &           id%KEEP(264), id%KEEP(265), id%KEEP(482), id%KEEP(472),
      &           id%KEEP(127), id%KEEP(469), id%KEEP(10), 
      &           id%KEEP(54), id%KEEP(142), 
-     &           LPOK, LP, id%COMM, id%MYID, id%NPROCS)
+     &           LPOK, LP, id%COMM, id%MYID, id%NPROCS,
+     &           id%KEEP(1), id%ND_STEPS)
           IF (allocated(MAPCOL)) DEALLOCATE(MAPCOL)
           IF (id%MYID.NE.MASTER) DEALLOCATE(FILS_TMP)
 C}
@@ -2204,7 +2297,8 @@ C
      &           id%KEEP(264), id%KEEP(265), id%KEEP(482), id%KEEP(472),
      &           id%KEEP(127), id%KEEP(469), id%KEEP(10), 
      &           id%KEEP(54), id%KEEP(142), 
-     &           LPOK, LP, id%COMM, id%MYID, id%NPROCS)
+     &           LPOK, LP, id%COMM, id%MYID, id%NPROCS,
+     &           id%KEEP(1), id%ND_STEPS)
 C}
             ELSE
 C{           grouping based on centralized matrix
@@ -2221,7 +2315,8 @@ C{           grouping based on centraliz
      &           id%KEEP(264), id%KEEP(265), id%KEEP(482), id%KEEP(472),
      &           id%KEEP(127), id%KEEP(10), 
      &           id%KEEP(54), id%KEEP(142), 
-     &           LPOK, LP, GATHER_MATRIX_ALLOCATED)
+     &           LPOK, LP, GATHER_MATRIX_ALLOCATED, 
+     &           id%KEEP(1), id%ND_STEPS)
              ELSE
                CALL DMUMPS_LR_GROUPING_NEW(id%N, id%KEEP8(28), 
      &           id%KEEP(28), id%IRN,
@@ -2234,7 +2329,8 @@ C{           grouping based on centraliz
      &           id%KEEP(264), id%KEEP(265), id%KEEP(482), id%KEEP(472),
      &           id%KEEP(127), id%KEEP(469), id%KEEP(10), 
      &           id%KEEP(54), id%KEEP(142), 
-     &           LPOK, LP, GATHER_MATRIX_ALLOCATED)
+     &           LPOK, LP, GATHER_MATRIX_ALLOCATED,
+     &           id%KEEP(1), id%ND_STEPS)
              ENDIF
 C}
             ENDIF
@@ -2251,7 +2347,7 @@ C     III/ CLEANUP
 C     ============
 C       Free LUMAT_REMAP if allocated
         IF (LUMAT_REMAP_DIST_AVAIL.OR.LUMAT_REMAP_CENT_AVAIL)
-     &      CALL MUMPS_AB_FREE_LMAT(LUMAT_REMAP)
+     &      CALL MUMPS_AB_FREE_LMAT(LUMAT_REMAP,KEEP(147))
         IF (allocated(MAPCOL)) DEALLOCATE(MAPCOL)
         IF (allocated(SIZEOFBLOCKS)) DEALLOCATE(SIZEOFBLOCKS)
         IF ( (KEEP(54).EQ.3) .AND. (KEEP(244).EQ.2).AND.
@@ -2343,7 +2439,7 @@ C           and update arrays of size NS
      &           ) 
             NULLIFY(PAR2_NODESPTR)
 C
-C
+C         }
           ELSE
 C{           NBLK=N
 C            perform local copies
@@ -2376,6 +2472,17 @@ C          and not used/initialized
           ENDIF
 C}
         ENDIF
+C
+C       -------------------------------------------
+C       Adjust LR_GROUPING to bound size of groups 
+C       and update KEEP(142): maximum group size
+C       -------------------------------------------
+        IF (id%N.GT.NBLK.AND.KEEP(494).NE.0) THEN
+          CALL MUMPS_ADJUST_SIZE_LRGROUPS ( 
+     &     id%STEP(1), id%FILS(1), id%N, 
+     &     id%ND_STEPS(1), id%KEEP(28), id%KEEP(1), 
+     &     id%LRGROUPS(1), INFO(1), INFO(2))
+         ENDIF
 C}
       ENDIF
 C
@@ -2385,6 +2492,7 @@ C
       IF (allocated(LRGROUPS_TMP)) DEALLOCATE(LRGROUPS_TMP)
       IF (allocated(FILS_TMP)) DEALLOCATE(FILS_TMP)
 C
+C
         CALL MUMPS_REALLOC(id%SYM_PERM, id%N, id%INFO, LP, 
      &  FORCE=.TRUE.,
      &  STRING='id%SYM_PERM (Analysis)', ERRCODE=-7)
@@ -3245,11 +3353,11 @@ C           and allocate CANDIDATES
 C           ===================================================
 C     
             IF ( id%root%yes ) THEN
-              LOCAL_M = numroc( id%ND_STEPS(id%STEP(KEEP(38))),
+              LOCAL_M = MUMPS_NUMROC( id%ND_STEPS(id%STEP(KEEP(38))),
      &              id%root%MBLOCK, id%root%MYROW, 0,
      &              id%root%NPROW )
               LOCAL_M = max(1, LOCAL_M)
-              LOCAL_N = numroc( id%ND_STEPS(id%STEP(KEEP(38))),
+              LOCAL_N = MUMPS_NUMROC( id%ND_STEPS(id%STEP(KEEP(38))),
      &              id%root%NBLOCK, id%root%MYCOL, 0,
      &              id%root%NPCOL )
             ELSE
@@ -3636,9 +3744,7 @@ C
 C            Convert SUM_NIRNEC SUM_NIRNEC_OOC into nb of reals 
              PEAK_ABOVE_L0 =  KEEP8(53)+ SUM_NRLADU + 
      &            ! SEND buffer
-     &              max ( int( 
-     &              (dble(SBUF_SEND_FR)*dble(KEEP(34)))/dble(KEEP(35))
-     &                     , 8), 100000_8 ) +
+     &            max( int(SBUF_SEND_FR,8),  100000_8) +
      &            ! MAXIS_above :
      &             int( 
      &              (dble(KEEP(15))*dble(KEEP(34)))/dble(KEEP(35)),
@@ -3672,7 +3778,7 @@ C            SUM_NIRNEC_OOC under L0 OMP
 C           DKEEP(15) is used for dynamic load balancing only
 C           it corresponds to the number of local operations
 C           (in Millions)
-            id%DKEEP(15)    = RINFO(1)/1000000.0
+            id%DKEEP(15)    = RINFO(1)/1000000.0D0
             IF(ASSOCIATED(locI_AM_CAND)) NULLIFY(locI_AM_CAND)
             id%MAX_SURF_MASTER = KEEP8(15)
 C
@@ -3737,7 +3843,10 @@ C
          UPDATE_BUFFER = .TRUE.
 C
          MIN_BUF_SIZE8 = KEEP8(22) / int(KEEP(238),8)
-         MIN_BUF_SIZE8 = min(MIN_BUF_SIZE8,int(huge(I4),8))
+C        MIN_BUF_SIZE8 is in number of entries of size (KEEP(35) bytes)
+C        and max buffer size in bytes is an integer*4
+         MIN_BUF_SIZE8 = min(MIN_BUF_SIZE8,
+     &                       int(huge(I4),8)/int(KEEP(35),8) )
          MIN_BUF_SIZE  = int( MIN_BUF_SIZE8 )
          IF (UPDATE_BUFFER) THEN
 C          Send buffer 
@@ -3893,7 +4002,7 @@ C     Per compute node factor real space
       CALL MPI_REDUCE( SUM_KEEP811_THIS_NODE, MAX_SUM_KEEP811_THIS_NODE,
      &                 1, MPI_INTEGER8, MPI_MAX, 0, id%COMM, IERR )
       IF (PROKG .AND. PRINT_NODEINFO) THEN
-        WRITE(MPG,'(A,I12)')
+        WRITE(MPG,'(A,I16)')
      &  '    Max. estimated space for factors per compute node       :',
      &  MAX_SUM_KEEP811_THIS_NODE ! * KEEP(35)/1000000_8
       ENDIF
@@ -3956,7 +4065,7 @@ C
            TOTAL_BYTES  = max (TOTAL_BYTES, TOTAL_BYTES_UNDER_L0)
          ENDIF
          IF ( PROK ) THEN
-            WRITE(MP,'(A,I12) ')
+            WRITE(MP,'(A,I16) ')
      & ' Estimated space in MBytes for IC factorization   (INFO(15)):',
      &           TOTAL_MBYTES
          END IF
@@ -3974,11 +4083,11 @@ C
      &     id%INFO(15), id%INFOG(16), IRANK )
       IF ( PROKG ) THEN
        IF (PRINT_MAXAVG) THEN
-         WRITE( MPG,'(A,I12) ')
+         WRITE( MPG,'(A,I16) ')
      & '    Maximum estim. space in Mbytes, IC facto.    (INFOG(16)):',
      &        id%INFOG(16)
        ENDIF
-       WRITE(MPG,'(A,I12) ')
+       WRITE(MPG,'(A,I16) ')
      & '    Total space in MBytes, IC factorization      (INFOG(17)):'
      &        ,id%INFOG(17)
       END IF
@@ -3989,7 +4098,7 @@ C     Per compute node memory informatio
       CALL MPI_REDUCE( SUM_INFO15_THIS_NODE, MAX_SUM_INFO15_THIS_NODE,
      &                 1, MPI_INTEGER, MPI_MAX, 0, id%COMM, IERR )
       IF ( PROKG .AND. PRINT_NODEINFO ) THEN
-        WRITE(MPG,'(A,I12)')
+        WRITE(MPG,'(A,I16)')
      &  '    Max. estim. space per compute node, in MBytes, IC fact  :',
      &  MAX_SUM_INFO15_THIS_NODE
       ENDIF
@@ -4066,11 +4175,11 @@ C
      &     id%INFO(17), id%INFOG(26), IRANK )
       IF ( PROKG  ) THEN
        IF (PRINT_MAXAVG) THEN
-         WRITE( MPG,'(A,I12) ')
+         WRITE( MPG,'(A,I16) ')
      & '    Maximum estim. space in Mbytes, OOC facto.   (INFOG(26)):',
      &        id%INFOG(26)
        ENDIF
-       WRITE(MPG,'(A,I12) ')
+       WRITE(MPG,'(A,I16) ')
      & '    Total space in MBytes,  OOC factorization    (INFOG(27)):'
      &        ,id%INFOG(27)
       END IF
@@ -4080,7 +4189,7 @@ C
       CALL MPI_REDUCE( SUM_INFO17_THIS_NODE, MAX_SUM_INFO17_THIS_NODE,
      &                 1, MPI_INTEGER, MPI_MAX, 0, id%COMM, IERR )
       IF (PROKG .AND. PRINT_NODEINFO) THEN
-        WRITE(MPG,'(A,I12)')
+        WRITE(MPG,'(A,I16)')
      &  '    Max. estim. space per compute node, in MBytes, OOC fact :',
      &  MAX_SUM_INFO17_THIS_NODE
       ENDIF
@@ -4181,9 +4290,9 @@ C     Deallocate allocated working space
       IF (allocated(FLAGGED_LEAVES)) DEALLOCATE(FLAGGED_LEAVES)
       IF (allocated(SIZEOFBLOCKS)) DEALLOCATE(SIZEOFBLOCKS)
       IF (allocated(DOF2BLOCK)) DEALLOCATE(DOF2BLOCK)
-      CALL MUMPS_AB_FREE_LMAT(LMAT_BLOCK)
-      CALL MUMPS_AB_FREE_LMAT(LUMAT)
-      CALL MUMPS_AB_FREE_LMAT(LUMAT_REMAP)
+      CALL MUMPS_AB_FREE_LMAT(LMAT_BLOCK,KEEP(147))
+      CALL MUMPS_AB_FREE_LMAT(LUMAT,KEEP(147))
+      CALL MUMPS_AB_FREE_LMAT(LUMAT_REMAP,KEEP(147))
       CALL MUMPS_AB_FREE_GCOMP(GCOMP, MEMCNT)
       CALL MUMPS_AB_FREE_GCOMP(GCOMP_DIST, MEMCNT)
       IF (INFO(1) .LT. 0) THEN
@@ -4266,7 +4375,11 @@ C     to stat that are incremented such
 C     the number of split nodes:
       id%KEEP(61)=0
       IF (id%MYID.eq.MASTER) THEN
+        id%KEEP(38) = 0 
+        id%KEEP(20) = 0 
+        id%KEEP(401) = 0
         id%KEEP(400) = 0
+        IF (id%ICNTL(48).EQ.1) id%KEEP(401)=1
         IF (id%KEEP(401) .GT. 0) THEN
 !$        id%KEEP(400)=omp_get_max_threads()
           IF ( id%KEEP(400) .EQ. 0 ) THEN
@@ -4274,14 +4387,14 @@ C           Compilation without OMP!
             id%INFO(1)=-58
             id%INFO(2)=0
             IF (LPOK) WRITE(LP,'(A)')
-     &      " FAILURE DETECTED IN ANALYSIS: KEEP(401) requires OpenMP"
+     &      " FAILURE DETECTED IN ANALYSIS: ICNTL(48) requires OpenMP"
             RETURN
           ELSE
-            IF ( PROKG ) THEN
-              WRITE(MPG, '(A,I8,A)')
-     &       'KEEP(401) config at analysis:', id%KEEP(400),
-     &       ' threads expected for multithreaded tree parallelism'
-            END IF
+C            IF ( PROKG ) THEN
+C              WRITE(MPG, '(A,I8,A)')
+C     &       'ICNTL(48) config at analysis:', id%KEEP(400),
+C     &       ' threads expected for multithreaded tree parallelism'
+C            END IF
 C           L0OMP feature is on (possibly with a single thread!)
             IF (id%KEEP(400).EQ.1
      &       ) THEN
@@ -4846,7 +4959,18 @@ C     Save ICNTL(56) (QR) in KEEP(53)
 C     Will be broadcasted to all other
 C     nodes in routine DMUMPS_BDCAST
 C     --------------------------------
-         id%KEEP(53)=0
+         id%KEEP(53) = id%ICNTL(56)
+C     ---------------------------
+C     Possible values are 0..2 
+C     Other values are treated as 0
+C     ------------------------------
+         IF ( id%KEEP(53) .LT. 0 .OR.
+     &        id%KEEP(53) .GE. 2 
+     &      ) THEN
+            id%KEEP(53) = 0
+            IF (PROKG) WRITE(MPG,'(A)')
+     &    ' WARNING: ICNTL(56) treated as if set to 0 '
+         END IF
          IF(id%KEEP(86).EQ.1)THEN
 C     Force the exchange of both the memory and flops information during 
 C     the factorization
@@ -5430,11 +5554,16 @@ C
       INTEGER, TARGET                :: IRN_DUMMY(1), JCN_DUMMY(1)
       INTEGER, POINTER, DIMENSION(:) :: IRN_PASSED, JCN_PASSED
       DOUBLE PRECISION, POINTER, DIMENSION(:) :: A_PASSED
+      INTEGER              :: MPG
+      LOGICAL              :: PROKG
       PARAMETER( MASTER = 0 )
       I_AM_SLAVE = ( id%MYID .NE. MASTER  .OR.
      &     ( id%MYID .EQ. MASTER .AND.
      &     id%KEEP(46) .EQ. 1 ) )
       I_AM_MASTER = (id%MYID.EQ.MASTER)
+      MPG = id%ICNTL( 3 )
+      PROKG = ( MPG .GT. 0 .and. id%MYID .eq. MASTER )
+      PROKG = (PROKG.AND.(id%ICNTL(4).GE.2))
       NAME_INITIALIZED = id%WRITE_PROBLEM(1:20)
      &     .NE. "NAME_NOT_INITIALIZED"
       BINARY_FORMAT = .FALSE.
@@ -5450,6 +5579,11 @@ C
           BINARY_FORMAT = .TRUE.
         ENDIF
       ENDIF
+      IF (NAME_INITIALIZED.AND.PROKG) THEN
+        WRITE(MPG,'(/A,A/)') 
+     &    " Write input matrix to file, WRITE_PROBLEM= ", 
+     &    id%WRITE_PROBLEM(1:L)
+      ENDIF
 C     Check if RHS should also be dumped
       DUMP_RHS = id%MYID.EQ.MASTER .AND.
      &     associated(id%RHS) .AND. NAME_INITIALIZED
@@ -5740,14 +5874,14 @@ C     then describe binary file content
      &  '%    N,IRN(i),JCN(i): 32 bits',
      &  '%    NNZ: 64 bits'
       ENDIF
-      WRITE(IUNIT,FMT='(A,I12)') '% Matrix order: N=',N
-      WRITE(IUNIT,FMT='(A,I12)') '% Matrix nonzeros: NNZ=',NNZTOT
+      WRITE(IUNIT,FMT='(A,I16)') '% Matrix order: N=',N
+      WRITE(IUNIT,FMT='(A,I16)') '% Matrix nonzeros: NNZ=',NNZTOT
       IF (DUMP_RHS) THEN
         WRITE(IUNIT,FMT='(A)') '%'
         WRITE(IUNIT,FMT='(A,/,A,I10,A,I5)')
      &  '% A RHS was also written to disk by columns in binary form.',
      &  '%    Size: N rows x NRHS columns with N=',N,'  NRHS=',NRHS
-        WRITE(IUNIT,FMT='(A,I12,A)')
+        WRITE(IUNIT,FMT='(A,I16,A)')
      &  '%    Total:',int(N,8)*int(NRHS,8),' scalar values.'
         WRITE(IUNIT,'(A)') '%    Double precision storage'
       ENDIF
diff -pruN 5.6.2-2.1/src/dana_lr.F 5.7.1-1/src/dana_lr.F
--- 5.6.2-2.1/src/dana_lr.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dana_lr.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -65,10 +65,12 @@ C
       ENDIF 
       if(allocated(BIG_CUT)) DEALLOCATE(BIG_CUT)
       END SUBROUTINE GET_CUT
-      SUBROUTINE SEP_GROUPING(NV, VLIST, N, NZ, LRGROUPS, NBGROUPS, IW, 
+      SUBROUTINE SEP_GROUPING( NFRONT, KEEP,
+     &   NV, VLIST, N, NZ, LRGROUPS, NBGROUPS, IW, 
      &   LW, IPE, LEN, GROUP_SIZE, HALO_DEPTH, TRACE, WORKH, NODE,
      &   GEN2HALO, K482, K472, K469, SEP_SIZE, MAXSIZE_PARTS,
      &   KEEP10, LP, LPOK, IFLAG, IERROR)
+        INTEGER, INTENT(IN)    :: NFRONT, KEEP(500)
         INTEGER(8), INTENT(IN) :: NZ, LW
         INTEGER, INTENT(IN)    :: NV, N, GROUP_SIZE, HALO_DEPTH
         INTEGER, INTENT(IN)    :: IW(LW), LEN(N), NODE, K482
@@ -84,7 +86,7 @@ C
         INTEGER(8), ALLOCATABLE, DIMENSION(:) :: IPTRHALO
         INTEGER,    ALLOCATABLE, DIMENSION(:) :: PARTS, JCNHALO
         INTEGER(8) :: HALOEDGENBR
-        INTEGER    :: NHALO,
+        INTEGER    :: NHALO, NBG_CAPT,
      &       NBGROUPS_KWAY, I, GROUP_SIZE2, LRGROUPS_SIGN, IERR
         INTEGER    :: MAXSIZE_PARTS_LOC
 #if defined (metis) || defined (parmetis) || defined (metis4) || defined (parmetis3)
@@ -93,7 +95,8 @@ C
 #if defined (scotch) || defined (ptscotch)
         INTEGER :: SCOTCH_IDX_SIZE
 #endif
-        CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NV)
+        CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NV, 
+     &                       NFRONT, KEEP(35))
         NBGROUPS_KWAY = MAX(
      &                INT(dble(NV+GROUP_SIZE2-1)/dble(GROUP_SIZE2))
      &                ,1)
@@ -187,7 +190,7 @@ C
                WRITE(LP,*) " Internal error in SCOTCH during ",
      &                     " Kway partitioning, SCOTCHFGRAPHPART, " 
                WRITE(LP,*) 
-     &         " also provide METIS package to MUMPS "
+     &         " please also provide METIS package to MUMPS "
              ENDIF
 #endif
           ELSE
@@ -197,16 +200,17 @@ C
           IF (IFLAG.LT.0) GOTO 500
           CALL GET_GLOBAL_GROUPS(PARTS, VLIST, NV, 
      &     NBGROUPS_KWAY, LRGROUPS, N, NBGROUPS, LRGROUPS_SIGN,
-     &     MAXSIZE_PARTS_LOC)
+     &     MAXSIZE_PARTS_LOC, .FALSE., GROUP_SIZE2)
            MAXSIZE_PARTS = max(MAXSIZE_PARTS, MAXSIZE_PARTS_LOC)
         ELSE 
           MAXSIZE_PARTS = max(MAXSIZE_PARTS,NV)
-!$OMP CRITICAL(lrgrouping_cri)
+!$OMP ATOMIC CAPTURE
+          NBG_CAPT = NBGROUPS
+          NBGROUPS = NBGROUPS + 1
+!$OMP END ATOMIC 
           DO I=1,NV
-            LRGROUPS(VLIST(I)) = LRGROUPS_SIGN*(NBGROUPS + 1)
+            LRGROUPS(VLIST(I)) = LRGROUPS_SIGN*(NBG_CAPT + 1)
           END DO
-            NBGROUPS = NBGROUPS + 1
-!$OMP END CRITICAL(lrgrouping_cri)
         END IF
   500   IF (allocated(IPTRHALO)) then
            DEALLOCATE(IPTRHALO)
@@ -219,11 +223,13 @@ C
         ENDIF
         RETURN
       END SUBROUTINE SEP_GROUPING
-      SUBROUTINE SEP_GROUPING_AB (NV, NVEXPANDED, 
+      SUBROUTINE SEP_GROUPING_AB ( NFRONT, KEEP,
+     &   NV, NVEXPANDED, 
      &   VLIST, N, LRGROUPS, NBGROUPS, LUMAT, SIZEOFBLOCKS,
      &   GROUP_SIZE, HALO_DEPTH, TRACE, WORKH, NODE,
      &   GEN2HALO, K482, K472, K469, SEP_SIZE, MAXSIZE_PARTS,
      &   KEEP10, LP, LPOK, IFLAG, IERROR)
+        INTEGER, INTENT(IN)    :: NFRONT, KEEP(500)
         TYPE(LMATRIX_T)        :: LUMAT
         INTEGER, INTENT(IN)    :: NV, NVEXPANDED, 
      &                            N, GROUP_SIZE, HALO_DEPTH
@@ -241,17 +247,20 @@ C
         INTEGER,    ALLOCATABLE, DIMENSION(:) :: PARTS, JCNHALO
         INTEGER,    ALLOCATABLE, DIMENSION(:) :: VWGT
         INTEGER(8) :: HALOEDGENBR
-        INTEGER    :: NHALO,
+        INTEGER    :: NHALO, NBG_CAPT,
      &       NBGROUPS_KWAY, I, GROUP_SIZE2, LRGROUPS_SIGN, IERR
         INTEGER    :: MAXSIZE_PARTS_LOC
         DOUBLE PRECISION       :: COMPRESS_RATIO
+        LOGICAL    :: AB_ACTIVE
 #if defined (metis) || defined (parmetis) || defined (metis4) || defined (parmetis3)
         INTEGER :: METIS_IDX_SIZE
 #endif
 #if defined (scotch) || defined (ptscotch)
         INTEGER :: SCOTCH_IDX_SIZE
 #endif
-        CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NVEXPANDED)
+       AB_ACTIVE = (NVEXPANDED.GT.NV)
+        CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NVEXPANDED,
+     &                       NFRONT, KEEP(35))
         COMPRESS_RATIO= dble(NVEXPANDED)/dble(NV)
         NBGROUPS_KWAY = MAX(
      &          INT(dble(NVEXPANDED+GROUP_SIZE2-1)/dble(GROUP_SIZE2))
@@ -365,17 +374,18 @@ C
           IF (IFLAG.LT.0) GOTO 500
           CALL GET_GLOBAL_GROUPS(PARTS,VLIST, NV, 
      &     NBGROUPS_KWAY, LRGROUPS, N, NBGROUPS, LRGROUPS_SIGN,
-     &     MAXSIZE_PARTS_LOC)
+     &     MAXSIZE_PARTS_LOC, AB_ACTIVE, GROUP_SIZE2)
            MAXSIZE_PARTS = max( MAXSIZE_PARTS, 
      &                   int(dble(MAXSIZE_PARTS_LOC*COMPRESS_RATIO))  )
         ELSE 
           MAXSIZE_PARTS = max(MAXSIZE_PARTS,NV)
-!$OMP CRITICAL(lrgrouping_cri)
+!$OMP ATOMIC CAPTURE
+          NBG_CAPT = NBGROUPS
+          NBGROUPS = NBGROUPS + 1
+!$OMP END ATOMIC 
           DO I=1,NV
-            LRGROUPS(VLIST(I)) = LRGROUPS_SIGN*(NBGROUPS + 1)
+            LRGROUPS(VLIST(I)) = LRGROUPS_SIGN*(NBG_CAPT + 1)
           END DO
-            NBGROUPS = NBGROUPS + 1
-!$OMP END CRITICAL(lrgrouping_cri)
         END IF
   500   IF (allocated(IPTRHALO)) then
            DEALLOCATE(IPTRHALO)
@@ -495,9 +505,10 @@ C
       END SUBROUTINE GETHALOGRAPH_AB
       SUBROUTINE GET_GLOBAL_GROUPS(PARTS, SEP, NSEP, NPARTS, 
      &                    LRGROUPS, N, NBGROUPS, LRGROUPS_SIGN,
-     &                    MAXSIZE_PARTS_LOC)
-      INTEGER,INTENT(IN) :: NSEP, N, LRGROUPS_SIGN
+     &                    MAXSIZE_PARTS_LOC, AB_ACTIVE, GROUP_SIZE2)
+      INTEGER,INTENT(IN) :: NSEP, N, LRGROUPS_SIGN, GROUP_SIZE2
       INTEGER :: PARTS(:)
+      LOGICAL :: AB_ACTIVE
       INTEGER,DIMENSION(:),INTENT(INOUT) :: SEP 
       INTEGER, INTENT(INOUT) :: NPARTS 
       INTEGER, INTENT(INOUT) :: NBGROUPS
@@ -506,7 +517,7 @@ C
       INTRINSIC maxval
       INTEGER:: I,CNT,NB_PARTS_WITHOUT_SEP_NODE,allocok
       INTEGER:: TARGET_SIZE_KWAY
-      INTEGER:: MAXSIZE_PARTS_LOC_NEW
+      INTEGER:: MAXSIZE_PARTS_LOC_NEW, NBG_CAPT
       INTEGER,DIMENSION(:),ALLOCATABLE::SIZES, RIGHTPART
       INTEGER,DIMENSION(:),ALLOCATABLE::PARTPTR
 #if ! defined(NO_SPLIT_IN_BLRGROUPING)
@@ -522,8 +533,9 @@ C
          write(*,*) "Allocation error in GET_GLOBAL_GROUPS"
          CALL MUMPS_ABORT()
       ENDIF
-      TARGET_SIZE_KWAY  = (NSEP+NPARTS-1) / NPARTS
-      TARGET_SIZE_SPLIT = 2*TARGET_SIZE_KWAY
+      TARGET_SIZE_KWAY  = GROUP_SIZE2
+      TARGET_SIZE_SPLIT = TARGET_SIZE_KWAY
+      IF (AB_ACTIVE) TARGET_SIZE_SPLIT =huge(TARGET_SIZE_SPLIT)
       NB_PARTS_WITHOUT_SEP_NODE = 0
       RIGHTPART     = 0
       SIZES = 0
@@ -549,16 +561,17 @@ C
 #if ! defined(NO_SPLIT_IN_BLRGROUPING)
        IF (MAXSIZE_PARTS_LOC.LT.TARGET_SIZE_SPLIT) THEN
 #endif
-!$OMP    CRITICAL(lrgrouping_cri)
+!$OMP ATOMIC CAPTURE
+         NBG_CAPT = NBGROUPS
+         NBGROUPS = NBGROUPS + NPARTS
+!$OMP END ATOMIC 
          DO I=1,NSEP
           NEWSEP(PARTPTR(PARTS(I))) = SEP(I)  
           LRGROUPS(SEP(I)) = LRGROUPS_SIGN*(RIGHTPART(PARTS(I)) 
-     &      + NBGROUPS)
+     &      + NBG_CAPT)
           PARTPTR(PARTS(I)) = 
      &      PARTPTR(PARTS(I)) + 1
          END DO
-         NBGROUPS = NBGROUPS + NPARTS
-!$OMP    END CRITICAL(lrgrouping_cri)
          SEP = NEWSEP
 #if ! defined(NO_SPLIT_IN_BLRGROUPING)
       ELSE
@@ -572,9 +585,23 @@ C
          DO I=2,NPARTS+1
            PARTPTR(I) = PARTPTR(I-1) + SIZES(I-1)
          ENDDO
-         NB_PARTS_WITH_SPLIT = 0
+         NB_PARTS_WITH_SPLIT   = 0
          MAXSIZE_PARTS_LOC_NEW = 0
-!$OMP    CRITICAL(lrgrouping_cri)
+         DO IP =1, NPARTS
+           NB_SPLIT =   (SIZES(IP) + TARGET_SIZE_SPLIT-1) 
+     &                    / TARGET_SIZE_SPLIT
+           SZ_FINAL     = (SIZES(IP) + NB_SPLIT-1) / NB_SPLIT 
+           NB_PARTS_WITH_SPLIT = NB_PARTS_WITH_SPLIT +
+     &      ( 
+     &         ( (PARTPTR(IP+1) - PARTPTR(IP))+ SZ_FINAL-1 ) /
+     &          SZ_FINAL
+     &      )
+         ENDDO
+!$OMP ATOMIC CAPTURE
+         NBG_CAPT = NBGROUPS
+         NBGROUPS = NBGROUPS + NB_PARTS_WITH_SPLIT
+!$OMP END ATOMIC 
+         NB_PARTS_WITH_SPLIT = 0
          DO IP=1,NPARTS
            NB_SPLIT =   (SIZES(IP) + TARGET_SIZE_SPLIT-1) 
      &                    / TARGET_SIZE_SPLIT
@@ -585,12 +612,10 @@ C
              NB_PARTS_WITH_SPLIT = NB_PARTS_WITH_SPLIT +1
              DO II=I, min(I+SZ_FINAL-1,PARTPTR(IP+1)-1)
                LRGROUPS(SEP(II)) = LRGROUPS_SIGN*(NB_PARTS_WITH_SPLIT
-     &                           + NBGROUPS)
+     &                           + NBG_CAPT)
              ENDDO
            ENDDO
          ENDDO
-         NBGROUPS = NBGROUPS + NB_PARTS_WITH_SPLIT
-!$OMP    END CRITICAL(lrgrouping_cri)
          NPARTS = NB_PARTS_WITH_SPLIT
          MAXSIZE_PARTS_LOC = MAXSIZE_PARTS_LOC_NEW
       ENDIF
@@ -787,7 +812,8 @@ C
      &     LRGROUPS, SYM, ICNTL, HALO_DEPTH, GROUP_SIZE, SEP_SIZE,
      &     K38, K20, K60,
      &     IFLAG, IERROR, K264, K265, K482, K472, MAXFRONT, K10, 
-     &     K54, K142, LPOK, LP, GATHER_MATRIX_ALLOCATED)
+     &     K54, K142, LPOK, LP, GATHER_MATRIX_ALLOCATED,
+     &     KEEP, ND_STEPS)
       IMPLICIT NONE
       INTEGER, INTENT(IN)    :: N, NSTEPS, LNA, SYM,
      &     HALO_DEPTH, SEP_SIZE, GROUP_SIZE
@@ -804,6 +830,7 @@ C
       INTEGER             :: FILS(N), STEP(N), LRGROUPS(N)
       INTEGER, INTENT(IN)    :: K472, MAXFRONT
       LOGICAL, INTENT(INOUT) :: GATHER_MATRIX_ALLOCATED
+      INTEGER, INTENT(IN) :: KEEP(500), ND_STEPS(:)
       INTEGER :: K482_LOC, K38ou20
       INTEGER :: I, F, PV, NV, NLEAVES, NROOTS, PP, C, NF, NODE,
      &     SYMTRY, NBQD, AD
@@ -914,7 +941,8 @@ C
             WORK(NV) = F
             F = FILS(F)
          END DO
-         CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NV)
+         CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NV,
+     &                        ND_STEPS(NODE), KEEP(35))
          IF (NV .GE. GROUP_SIZE2)  THEN
            IF ( (K482_LOC.EQ.3)
      &           .OR.
@@ -926,7 +954,8 @@ C
                END DO
                NBGROUPS = NBGROUPS + (NV-1)/GROUP_SIZE2 + 1
             ELSE
-              CALL SEP_GROUPING(NV, WORK(1), N, NZ8,
+              CALL SEP_GROUPING( ND_STEPS(NODE), KEEP, 
+     &              NV, WORK(1), N, NZ8,
      &              LRGROUPS, NBGROUPS, IW(1), LW, IPE(1), LEN(1),
      &              GROUP_SIZE, HALO_DEPTH, TRACE(1), WORKH(1), NODE,
      &              GEN2HALO(1), K482_LOC, K472, 0, SEP_SIZE, K142,
@@ -986,7 +1015,8 @@ C
      &     FRERE_STEPS, DAD_STEPS, STEP, NA, LNA, LRGROUPS, 
      &     SYM, ICNTL, HALO_DEPTH, GROUP_SIZE, SEP_SIZE, K38, K20,
      &     K60, IFLAG, IERROR, K264, K265, K482, K472, MAXFRONT, K469, 
-     &     K10, K54, K142, LPOK, LP, GATHER_MATRIX_ALLOCATED)
+     &     K10, K54, K142, LPOK, LP, GATHER_MATRIX_ALLOCATED,
+     &     KEEP, ND_STEPS)
       IMPLICIT NONE
       INTEGER, INTENT(IN)    :: N, NSTEPS, LNA, SYM,
      &     HALO_DEPTH, SEP_SIZE, GROUP_SIZE
@@ -1003,12 +1033,13 @@ C
       INTEGER, INTENT(IN) :: K472, K469
       LOGICAL, INTENT(INOUT) :: GATHER_MATRIX_ALLOCATED
       INTEGER, INTENT(OUT)   :: K142
+      INTEGER, INTENT(IN) :: KEEP(500), ND_STEPS(:)
       INTEGER :: K482_LOC,  K469_LOC, K38ou20
       INTEGER :: I, F, PV, NV, NODE,
      &     SYMTRY, NBQD, AD
       LOGICAL :: PVSCHANGED
       INTEGER(8) :: LW, IWFR, NRORM, NIORM
-      INTEGER :: NBGROUPS, NBGROUPS_local
+      INTEGER :: NBGROUPS, NBGROUPS_local, NBG_CAPT
       INTEGER, ALLOCATABLE, DIMENSION (:) :: PVS, WORK
       INTEGER, ALLOCATABLE, DIMENSION (:) :: LEN, IW
       INTEGER(8), ALLOCATABLE, DIMENSION (:) :: IPE, IQ
@@ -1125,7 +1156,7 @@ C
       PVSCHANGED = .FALSE.
       OMP_NUM = 1
 !$    OMP_NUM = omp_get_max_threads()
-      OMP_NUM = min(OMP_NUM,8)
+      OMP_NUM = min(OMP_NUM,5)
 !$OMP PARALLEL PRIVATE(I, NODE, PV, NV, F, GROUP_SIZE2, WORK, IERR_PRIV,
 !$OMP&         WORKH_PRV, TRACE_PRV, GEN2HALO_PRV, NBGROUPS_local
 !$OMP&         )
@@ -1183,28 +1214,34 @@ C
           WORK(NV) = F
           F = FILS(F)
         END DO
-        CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NV)
-        IF (NV .GE. GROUP_SIZE2)  THEN
+        CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NV,
+     &                        ND_STEPS(NODE), KEEP(35))
+        IF (NV .GE. GROUP_SIZE2
+     &     .AND. NV.GE.int(dble(SEP_SIZE)*dble(1.5))
+     &      )  THEN
           IF ( (K482_LOC.EQ.3)
      &           .OR.
      &         ( (K60.NE.0).AND.(WORK(1).EQ.K38ou20) )
      &        ) 
      &    THEN
-!$OMP CRITICAL(lrgrouping_cri)
+!$OMP ATOMIC CAPTURE
+            NBG_CAPT = NBGROUPS
+            NBGROUPS = NBGROUPS + (NV-1)/GROUP_SIZE2 + 1
+!$OMP END ATOMIC 
             DO I=1,NV
-              LRGROUPS(WORK(I))=NBGROUPS+1+(I-1)/GROUP_SIZE2
+              LRGROUPS(WORK(I))=NBG_CAPT+1+(I-1)/GROUP_SIZE2
             END DO
-            NBGROUPS = NBGROUPS + (NV-1)/GROUP_SIZE2 + 1
-!$OMP END CRITICAL(lrgrouping_cri)
           ELSE
             IF (K469_LOC .EQ. 2) THEN
-              CALL SEP_GROUPING(NV, WORK(1), N, NZ8,
+              CALL SEP_GROUPING( ND_STEPS(NODE), KEEP,
+     &              NV, WORK(1), N, NZ8,
      &              LRGROUPS, NBGROUPS, IW(1), LW, IPE(1), LEN(1),
      &              GROUP_SIZE, HALO_DEPTH, TRACE_PRV, WORKH_PRV, 
      &              NODE, GEN2HALO_PRV, K482_LOC, K472, K469_LOC, 
      &              SEP_SIZE, K142, K10, LP, LPOK, IFLAG, IERROR)
             ELSE
-              CALL SEP_GROUPING(NV, WORK(1), N, NZ8,
+              CALL SEP_GROUPING( ND_STEPS(NODE), KEEP,
+     &              NV, WORK(1), N, NZ8,
      &              LRGROUPS, NBGROUPS, IW(1), LW, IPE(1), LEN(1),
      &              GROUP_SIZE, HALO_DEPTH, TRACE, WORKH, 
      &              NODE, GEN2HALO, K482_LOC, K472, K469_LOC, 
@@ -1232,10 +1269,10 @@ C
             ENDDO
           ENDIF
         ELSE
-!$OMP CRITICAL(lrgrouping_cri)
+!$OMP ATOMIC CAPTURE
           NBGROUPS = NBGROUPS + 1
           NBGROUPS_local = NBGROUPS
-!$OMP END CRITICAL(lrgrouping_cri)
+!$OMP END ATOMIC 
           IF (NV .GE. SEP_SIZE) THEN
             DO I = 1, NV
               LRGROUPS( WORK(I) ) = NBGROUPS_local
@@ -1306,7 +1343,8 @@ C
      &     SEP_SIZE, K38, K20,
      &     K60, IFLAG, IERROR, K264, K265, K482, K472, MAXFRONT, K469, 
      &     K10, K54, K142, LPOK, LP, 
-     &     COMM, MYID, NPROCS_ARG
+     &     COMM, MYID, NPROCS_ARG,
+     &     KEEP, ND_STEPS
      &     )
       IMPLICIT NONE
       INCLUDE 'mpif.h'
@@ -1331,13 +1369,14 @@ C
       INTEGER             :: FILS(N), STEP(N), LRGROUPS(N)
       INTEGER, INTENT(IN) :: SIZEOFBLOCKS(N)
       INTEGER, INTENT(IN) :: K472, K469
+      INTEGER, INTENT(IN) :: KEEP(500), ND_STEPS(:)
       INTEGER :: NPROCS
       INTEGER :: K482_LOC,  K469_LOC, K38ou20, K142_GLOB
       INTEGER :: I, F, PV, NV, NVEXPANDED, NODE
       DOUBLE PRECISION    :: COMPRESS_RATIO
       LOGICAL :: PVSCHANGED
       INTEGER :: PVSCHANGED_INT, PVSCHANGED_INT_GLOB, IPROC
-      INTEGER :: NBGROUPS, NBGROUPS_local 
+      INTEGER :: NBGROUPS, NBGROUPS_local, NBG_CAPT
       INTEGER, ALLOCATABLE, DIMENSION (:) :: PVS, WORK
       INTEGER :: NBGROUPS_sent
       INTEGER :: NBNODES_LOC, SIZE_SENT, ISHIFT, 
@@ -1347,7 +1386,7 @@ C
       INTEGER, ALLOCATABLE, DIMENSION (:) :: TRACE_PRV, WORKH_PRV, 
      &                                   GEN2HALO_PRV
       INTEGER :: STEP_SCALAPACK_ROOT
-      INTEGER :: GROUP_SIZE2, IERR, OMP_NUM
+      INTEGER :: GROUP_SIZE2, GROUP_SIZE2_TMP, IERR, OMP_NUM
       INTEGER :: IERR_PRIV 
       LOGICAL :: MAPCOL_PROVIDED
 #if defined(ptscotch) || defined(scotch)     
@@ -1453,10 +1492,10 @@ C
       PVSCHANGED = .FALSE.
       OMP_NUM = 1
 !$    OMP_NUM = omp_get_max_threads()
-      OMP_NUM = min(OMP_NUM,8)
+      OMP_NUM = min(OMP_NUM,5)
 !$OMP PARALLEL PRIVATE(I, NODE, PV, NV, F, GROUP_SIZE2, WORK, IERR_PRIV,
 !$OMP&         WORKH_PRV, TRACE_PRV, GEN2HALO_PRV, NBGROUPS_local,
-!$OMP&         NVEXPANDED, COMPRESS_RATIO, IPROC
+!$OMP&         NVEXPANDED, COMPRESS_RATIO, IPROC, GROUP_SIZE2_TMP
 !$OMP&         )
 !$OMP&         REDUCTION( max : K142)
 !$OMP&         IF (K469_LOC.GT.1) NUM_THREADS(OMP_NUM)
@@ -1522,29 +1561,37 @@ C
           F = FILS(F)
         END DO
         COMPRESS_RATIO = dble(NVEXPANDED)/dble(NV)
-        CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NVEXPANDED)
-        IF (NVEXPANDED .GE. GROUP_SIZE2)  THEN
+        CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NVEXPANDED,
+     &                        ND_STEPS(NODE), KEEP(35))
+        IF (NVEXPANDED .GE. GROUP_SIZE2
+     &     .AND. NVEXPANDED.GE.int(dble(SEP_SIZE)*dble(1.5))
+     &     )  THEN
           IF ( (K482_LOC.EQ.3)
      &           .OR.
      &         ( (K60.NE.0).AND.(WORK(1).EQ.K38ou20) )
      &        ) 
      &    THEN
-            GROUP_SIZE2 = max(int(dble(GROUP_SIZE2)/COMPRESS_RATIO), 1)
-!$OMP CRITICAL(lrgrouping_cri)
+            GROUP_SIZE2_TMP = GROUP_SIZE2
+            GROUP_SIZE2_TMP = max( int(dble(GROUP_SIZE2_TMP)
+     &                             /COMPRESS_RATIO), 1)
+!$OMP ATOMIC CAPTURE
+          NBG_CAPT = NBGROUPS
+          NBGROUPS = NBGROUPS + (NV-1)/GROUP_SIZE2_TMP + 1
+!$OMP END ATOMIC 
             DO I=1,NV
-              LRGROUPS(WORK(I))=NBGROUPS+1+(I-1)/GROUP_SIZE2
+              LRGROUPS(WORK(I))=NBG_CAPT+1+(I-1)/GROUP_SIZE2_TMP
             END DO
-            NBGROUPS = NBGROUPS + (NV-1)/GROUP_SIZE2 + 1
-!$OMP END CRITICAL(lrgrouping_cri)
           ELSE
             IF (K469_LOC .EQ. 2) THEN
-              CALL SEP_GROUPING_AB(NV, NVEXPANDED, WORK(1), N, 
+              CALL SEP_GROUPING_AB(  ND_STEPS(NODE), KEEP,
+     &              NV, NVEXPANDED, WORK(1), N, 
      &              LRGROUPS, NBGROUPS, LUMAT, SIZEOFBLOCKS,
      &              GROUP_SIZE, HALO_DEPTH, TRACE_PRV, WORKH_PRV, 
      &              NODE, GEN2HALO_PRV, K482_LOC, K472, K469_LOC, 
      &              SEP_SIZE, K142, K10, LP, LPOK, IFLAG, IERROR)
             ELSE
-              CALL SEP_GROUPING_AB(NV, NVEXPANDED, WORK(1), N, 
+              CALL SEP_GROUPING_AB(  ND_STEPS(NODE), KEEP,
+     &              NV, NVEXPANDED, WORK(1), N, 
      &              LRGROUPS, NBGROUPS, LUMAT, SIZEOFBLOCKS,
      &              GROUP_SIZE, HALO_DEPTH, TRACE, WORKH, 
      &              NODE, GEN2HALO, K482_LOC, K472, K469_LOC, 
diff -pruN 5.6.2-2.1/src/dana_mtrans.F 5.7.1-1/src/dana_mtrans.F
--- 5.6.2-2.1/src/dana_mtrans.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/dana_mtrans.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/dana_reordertree.F 5.7.1-1/src/dana_reordertree.F
--- 5.6.2-2.1/src/dana_reordertree.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/dana_reordertree.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -26,8 +26,6 @@ C
       INTEGER INFO(80)
       INTEGER SLAVEF,PROCNODE(NSTEPS)
       INTEGER :: SBTR_WHICH_M
-      EXTERNAL MUMPS_PROCNODE
-      INTEGER MUMPS_PROCNODE
       DOUBLE PRECISION PEAK
       DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE :: COST_TRAV
       INTEGER, DIMENSION (:), ALLOCATABLE :: DEPTH
diff -pruN 5.6.2-2.1/src/darrowheads.F 5.7.1-1/src/darrowheads.F
--- 5.6.2-2.1/src/darrowheads.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/darrowheads.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -185,10 +185,8 @@ C
       INTEGER    :: INTARR( LINTARR )
       DOUBLE PRECISION    :: DBLARR( LDBLARR )
       DOUBLE PRECISION    :: A( LA )
-      INTEGER MUMPS_PROCNODE, MUMPS_TYPENODE, numroc, 
-     &        MUMPS_TYPESPLIT
-      EXTERNAL MUMPS_PROCNODE, MUMPS_TYPENODE, numroc, 
-     &        MUMPS_TYPESPLIT
+      INTEGER MUMPS_TYPESPLIT
+      EXTERNAL MUMPS_TYPESPLIT
       INTEGER LP
       LOGICAL LPOK
       DOUBLE PRECISION VAL, VAL_SHR
@@ -767,8 +765,6 @@ C
       PARAMETER(MASTER=0)
       INTEGER :: IERR
       INTEGER :: STATUS(MPI_STATUS_SIZE)
-      INTEGER numroc
-      EXTERNAL numroc
       TYPE_PARALL = KEEP(46)
       LP = ICNTL(1)
       LPOK = ( LP .GT. 0 .AND. ICNTL(4) .GE. 1 )
@@ -995,11 +991,11 @@ C
       INTEGER,    INTENT(OUT) :: LOCAL_M, LOCAL_N
       INTEGER(8), INTENT(OUT) :: PTR_ROOT
       INTEGER(8), INTENT(IN)  :: LA
-      INTEGER, EXTERNAL :: numroc
-      LOCAL_M = numroc( root%ROOT_SIZE, root%MBLOCK,
+      INTEGER, EXTERNAL :: MUMPS_NUMROC
+      LOCAL_M = MUMPS_NUMROC( root%ROOT_SIZE, root%MBLOCK,
      &         root%MYROW, 0, root%NPROW )
       LOCAL_M = max( 1, LOCAL_M )
-      LOCAL_N = numroc( root%ROOT_SIZE, root%NBLOCK,
+      LOCAL_N = MUMPS_NUMROC( root%ROOT_SIZE, root%NBLOCK,
      &         root%MYCOL, 0, root%NPCOL )
       PTR_ROOT = LA - int(LOCAL_M,8) * int(LOCAL_N,8) + 1_8
       RETURN
diff -pruN 5.6.2-2.1/src/dbcast_int.F 5.7.1-1/src/dbcast_int.F
--- 5.6.2-2.1/src/dbcast_int.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/dbcast_int.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/dend_driver.F 5.7.1-1/src/dend_driver.F
--- 5.6.2-2.1/src/dend_driver.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/dend_driver.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -323,9 +323,9 @@ C     Allocated at analysis:
         ENDIF
 !     ENDIF
 C     Allocated at analysis:
-      IF (associated(id%MPITOOMP_PROCS_MAP)) THEN
-        DEALLOCATE(id%MPITOOMP_PROCS_MAP)
-        NULLIFY(id%MPITOOMP_PROCS_MAP)
+      IF (associated(id%MTKO_PROCS_MAP)) THEN
+        DEALLOCATE(id%MTKO_PROCS_MAP)
+        NULLIFY(id%MTKO_PROCS_MAP)
       ENDIF
 C     Allocated at analysis:
       IF (associated(id%IPOOL_B_L0_OMP)) THEN
@@ -514,6 +514,16 @@ C     (this includes suppression of OOC
         DEALLOCATE(id%PIVNUL_LIST)
         NULLIFY(id%PIVNUL_LIST)
       ENDIF
+      IF (associated(id%ROWSCA_loc)) THEN
+        DEALLOCATE(id%ROWSCA_loc)
+        NULLIFY(id%ROWSCA_loc)
+      ENDIF
+      IF (id%KEEP(50) .EQ. 0) THEN
+        IF (associated(id%COLSCA_loc)) THEN
+          DEALLOCATE(id%COLSCA_loc)
+        ENDIF
+      ENDIF
+      NULLIFY(id%COLSCA_loc)
 C     IPIV is used both for ScaLAPACK and RR
 C     Keep it outside DMUMPS_RR_FREE_POINTERS
       IF (associated(id%root%IPIV))    THEN
@@ -572,19 +582,19 @@ C     Data allocated during solve
 C     ---------------------------
 C
 C     (or for some of it, factorization -- forward during factorization)
-      IF (associated(id%RHSCOMP)) THEN
-        DEALLOCATE(id%RHSCOMP)
-        NULLIFY(id%RHSCOMP)
+      IF (associated(id%RHSINTR)) THEN
+        DEALLOCATE(id%RHSINTR)
+        NULLIFY(id%RHSINTR)
         id%KEEP8(25)=0_8
       ENDIF
-      IF (associated(id%POSINRHSCOMP_ROW)) THEN
-        DEALLOCATE(id%POSINRHSCOMP_ROW)
-        NULLIFY(id%POSINRHSCOMP_ROW)
-      ENDIF
-      IF (id%POSINRHSCOMP_COL_ALLOC) THEN
-        DEALLOCATE(id%POSINRHSCOMP_COL)
-        NULLIFY(id%POSINRHSCOMP_COL)
-        id%POSINRHSCOMP_COL_ALLOC = .FALSE.
+      IF (associated(id%GLOB2LOC_RHS)) THEN
+        DEALLOCATE(id%GLOB2LOC_RHS)
+        NULLIFY(id%GLOB2LOC_RHS)
+      ENDIF
+      IF (id%GLOB2LOC_SOL_ALLOC) THEN
+        DEALLOCATE(id%GLOB2LOC_SOL)
+        NULLIFY(id%GLOB2LOC_SOL)
+        id%GLOB2LOC_SOL_ALLOC = .FALSE.
       ENDIF
 C     Allocated during solve:
 C     (even in case of fwd in facto)
@@ -598,3 +608,39 @@ C     (even in case of fwd in facto)
       END IF
       RETURN
       END SUBROUTINE DMUMPS_FREE_DATA_FACTO
+      SUBROUTINE DMUMPS_FREE_DATA_RHSINTR(id)
+C
+C     Purpose:
+C     -------
+C       Free RHSINTR related data that might 
+C       have been generated after a forward only step (ICNTL(26)=1)
+C     Module depencies
+C     ----------------
+      USE DMUMPS_STRUC_DEF
+      IMPLICIT NONE
+C
+C     Argument:
+C     --------
+C
+C     id is the main MUMPS structure, giving access to all internal
+C     objects allocated by the package.
+C
+      TYPE( DMUMPS_STRUC) :: id
+C
+      IF (associated(id%RHSINTR)) THEN
+        DEALLOCATE(id%RHSINTR)
+        NULLIFY(id%RHSINTR)
+        id%KEEP8(25)=0_8
+        id%LD_RHSINTR = 0
+      ENDIF
+      IF (associated(id%GLOB2LOC_RHS)) THEN
+        DEALLOCATE(id%GLOB2LOC_RHS)
+        NULLIFY(id%GLOB2LOC_RHS)
+      ENDIF
+      IF (id%GLOB2LOC_SOL_ALLOC) THEN
+        DEALLOCATE(id%GLOB2LOC_SOL)
+        NULLIFY(id%GLOB2LOC_SOL)
+        id%GLOB2LOC_SOL_ALLOC = .FALSE.
+      ENDIF
+      RETURN
+      END SUBROUTINE DMUMPS_FREE_DATA_RHSINTR
diff -pruN 5.6.2-2.1/src/dfac_asm.F 5.7.1-1/src/dfac_asm.F
--- 5.6.2-2.1/src/dfac_asm.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_asm.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -41,7 +41,7 @@ C
       IOLDPS = PTLUST_S(STEP(INODE))
       POSELT = PTRAST(STEP(INODE))
       NFRONT = IW(IOLDPS+KEEP(IXSZ))
-      NASS1  = iabs(IW(IOLDPS + 2+KEEP(IXSZ)))
+      NASS1  = abs(IW(IOLDPS + 2+KEEP(IXSZ)))
       NSLAVES= IW(IOLDPS+5+KEEP(IXSZ))
       IF (KEEP(50).EQ.0) THEN
         LDAFS_PERE = NFRONT
@@ -145,7 +145,7 @@ C
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
       INTEGER, INTENT(IN) :: NINROWARR(KEEP(195))
       INTEGER, INTENT(IN) :: PTRDEBARR(KEEP(196))
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       DOUBLE PRECISION :: A(LA)
       INTEGER :: INTARR(KEEP8(27))
       DOUBLE PRECISION :: DBLARR(KEEP8(26))
@@ -202,7 +202,7 @@ C
       INTEGER NBROWS
       INTEGER IW(LIW), ITLOC(N+KEEP(253)), STEP(N),
      &        PTRIST(KEEP(28))
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INCLUDE 'mumps_headers.h'
       INTEGER IOLDPS, NBCOLF, NBROWF, NSLAVES, HF,
      &        K1,K2,K,J
@@ -238,7 +238,7 @@ C
       INTEGER ROWLIST(NBROWS), COLLIST(NBCOLS)
       INTEGER IW(LIW), ITLOC(N+KEEP(253)), STEP(N),
      &        PTRIST(KEEP(28)), FILS(N)
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INTEGER(8) :: PTRAST(KEEP(28))
       DOUBLE PRECISION A(LA), VALSON(LDA_VALSON,NBROWS)
       DOUBLE PRECISION OPASSW, OPELIW
@@ -606,10 +606,10 @@ C
       INTEGER(8) POSELT, APOS, JJ2
       INCLUDE 'mumps_headers.h'
       LOGICAL SAME_PROC
-      INTRINSIC real
+      INTRINSIC dble
       IOLDPS = PTLUST_S(STEP(INODE))
       POSELT = PTRAST(STEP(INODE))
-      NASS1  = iabs(IW(IOLDPS + 2 + KEEP(IXSZ)))
+      NASS1  = abs(IW(IOLDPS + 2 + KEEP(IXSZ)))
       NSLAVES= IW(IOLDPS+5 + KEEP(IXSZ))
       HF      = 6 + NSLAVES + KEEP(IXSZ)
       ISTCHK = PIMASTER(STEP(ISON))
@@ -655,7 +655,7 @@ C
       INTEGER(8), intent(in) :: KEEP8(150)
       INTEGER, intent(inout) :: ITLOC(N+KEEP(253))
       DOUBLE PRECISION, intent(inout) :: A(LA)
-      DOUBLE PRECISION, intent(in)    :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION, intent(in)    :: RHS_MUMPS(KEEP8(85))
       DOUBLE PRECISION, intent(in)    :: DBLARR(LDBLARR)
       INTEGER, intent(in)    :: INTARR(LINTARR)
       INTEGER, intent(in)    :: FILS(N)
@@ -709,8 +709,9 @@ C
           NB_BLR_LS = NPARTSCB
           call MAX_CLUSTER(BEGS_BLR_LS,NB_BLR_LS+1,MAXI_CLUSTER)
           DEALLOCATE(BEGS_BLR_LS)
-          CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS)
-          MINSIZE = int(IBCKSZ2 / 2)
+          CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS, 
+     &                         NBCOLF, KEEP(35))
+          MINSIZE = int(IBCKSZ2 / 3)
           TOPDIAG = max(2*MINSIZE + MAXI_CLUSTER-1, TOPDIAG)
         ENDIF
 !$      CHUNK = max( KEEP(360)/2,
diff -pruN 5.6.2-2.1/src/dfac_asm_ELT.F 5.7.1-1/src/dfac_asm_ELT.F
--- 5.6.2-2.1/src/dfac_asm_ELT.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_asm_ELT.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -31,7 +31,7 @@ C
       INTEGER IW(LIW), ITLOC(N+KEEP(253)), STEP(N),
      &        PTRIST(KEEP(28)), FILS(N)
       INTEGER(8), INTENT(IN) :: PTRARW(NELT+1), PTRAIW(NELT+1)
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INTEGER INTARR(KEEP8(27))
       INTEGER FRT_PTR(N+1), FRT_ELT(NELT)
       DOUBLE PRECISION :: A(LA)
@@ -92,7 +92,7 @@ C
       INTEGER(8), intent(in) :: KEEP8(150)
       INTEGER, intent(inout) :: ITLOC(N+KEEP(253))
       DOUBLE PRECISION, intent(inout) :: A(LA)
-      DOUBLE PRECISION, intent(in)    :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION, intent(in)    :: RHS_MUMPS(KEEP8(85))
       INTEGER, intent(in)    :: INTARR(LINTARR)
       DOUBLE PRECISION, intent(in)    :: DBLARR(LDBLARR)
       INTEGER, intent(in)    :: FRT_PTR(N+1), FRT_ELT(NELT)
@@ -148,8 +148,9 @@ C
           NB_BLR_LS = NPARTSCB
           call MAX_CLUSTER(BEGS_BLR_LS,NB_BLR_LS+1,MAXI_CLUSTER)
           DEALLOCATE(BEGS_BLR_LS)
-          CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS)
-          MINSIZE = int(IBCKSZ2 / 2)
+          CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS,
+     &                         NBCOLF, KEEP(35))
+          MINSIZE = int(IBCKSZ2 / 3)
           TOPDIAG = max(2*MINSIZE + MAXI_CLUSTER-1, TOPDIAG)
         ENDIF
 !$      CHUNK = max( KEEP(360)/2,
diff -pruN 5.6.2-2.1/src/dfac_asm_master_ELT_m.F 5.7.1-1/src/dfac_asm_master_ELT_m.F
--- 5.6.2-2.1/src/dfac_asm_master_ELT_m.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_asm_master_ELT_m.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -78,7 +78,7 @@ C
      &        FILS(N), FRERE(KEEP(28)), DAD(KEEP(28)),
      &        PTRIST(KEEP(28)), PTLUST(KEEP(28)),
      &        STEP(N), PIMASTER(KEEP(28))
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INTEGER(8) :: PTRFAC(KEEP(28)), PTRAST(KEEP(28)),
      &              PAMASTER(KEEP(28))
       INTEGER COMM, NBFIN, SLAVEF, MYID
@@ -224,7 +224,7 @@ C
      &       NUMORG, KEEP(486),
      &       KEEP(489), KEEP(490), KEEP(491), KEEP(492), 
      &       KEEP(20), KEEP(60), DAD(STEP(INODE)), KEEP(38),
-     &       LRSTATUS, KEEP(280), LRGROUPS)
+     &       KEEP(123), LRSTATUS, KEEP(280), LRGROUPS)
       IF (DAD(STEP(INODE)).NE.0) THEN
         IF ( MUMPS_PROCNODE(PROCNODE_STEPS(STEP(DAD(STEP(INODE)))),
      &                                     KEEP(199) )
@@ -338,7 +338,7 @@ C
      &       IOLDPS + HF + 2 * NFRONT, IW, LIW)
       ENDIF
       NCB   = NFRONT - NASS1
-      MAXFRW = max0(MAXFRW, NFRONT)
+      MAXFRW = max(MAXFRW, NFRONT)
       ICT11 = IOLDPS + HF - 1 + NFRONT
       CALL DMUMPS_SET_PARPIVT1 ( INODE, NFRONT, NASS1, KEEP, 
      &                           LR_ACTIVATED, PARPIV_T1) 
@@ -413,8 +413,9 @@ C
             NB_BLR = NPARTSASS + NPARTSCB
          CALL MAX_CLUSTER(BEGS_BLR,NB_BLR,MAXI_CLUSTER)
          DEALLOCATE(BEGS_BLR)
-         CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS1)
-         MINSIZE = int(IBCKSZ2 / 2)
+         CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS1,
+     &                        NFRONT, KEEP(35))
+         MINSIZE = int(IBCKSZ2 / 3)
          TOPDIAG = max(2*MINSIZE + MAXI_CLUSTER-1,TOPDIAG)
         ENDIF
         NUMROWS = NFRONT8
@@ -926,7 +927,7 @@ C
      &        STEP(N),
      & PIMASTER(KEEP(28)),
      &        NSTK_S(KEEP(28)), PERM(N)
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INTEGER   CAND(SLAVEF+1, max(1,KEEP(56)))
       INTEGER   ISTEP_TO_INIV2(KEEP(71)), 
      &          TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
@@ -1059,7 +1060,7 @@ C
       CALL IS_FRONT_BLR_CANDIDATE(INODE, 2, NFRONT, NASS1, KEEP(486),
      &       KEEP(489), KEEP(490), KEEP(491), KEEP(492), 
      &       KEEP(20), KEEP(60), DAD(STEP(INODE)), KEEP(38),
-     &       LRSTATUS, KEEP(280), LRGROUPS)
+     &       KEEP(123), LRSTATUS, KEEP(280), LRGROUPS)
       COMPRESS_PANEL = (LRSTATUS.GE.2)
       COMPRESS_CB    = ((LRSTATUS.EQ.1).OR.
      &                  (LRSTATUS.EQ.3))
@@ -1311,7 +1312,7 @@ C
      &       NBPANELS_L, NBPANELS_U, NASS1, 
      &       IOLDPS + HF + 2 * NFRONT, IW, LIW)
       ENDIF
-      MAXFRW = max0(MAXFRW, NFRONT)
+      MAXFRW = max(MAXFRW, NFRONT)
       PTLUST(STEP(INODE)) = IOLDPS
       IW(IOLDPS+KEEP(IXSZ))     = NFRONT
       IW(IOLDPS + 1+KEEP(IXSZ)) = 0
@@ -1432,8 +1433,9 @@ C
          NB_BLR = NPARTSASS + NPARTSCB
          CALL MAX_CLUSTER(BEGS_BLR,NB_BLR,MAXI_CLUSTER)
          DEALLOCATE(BEGS_BLR)
-         CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS1)
-         MINSIZE = int(IBCKSZ2 / 2)
+         CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS1,
+     &                        NFRONT, KEEP(35))
+         MINSIZE = int(IBCKSZ2 / 3)
          TOPDIAG = max(2*MINSIZE + MAXI_CLUSTER-1, TOPDIAG)
         ENDIF
 !$      CHUNK = max(KEEP(360)/2,
diff -pruN 5.6.2-2.1/src/dfac_asm_master_m.F 5.7.1-1/src/dfac_asm_master_m.F
--- 5.6.2-2.1/src/dfac_asm_master_m.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_asm_master_m.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -76,7 +76,7 @@ C
      &        FILS(N), FRERE(KEEP(28)), DAD(KEEP(28)),
      &        PTRIST(KEEP(28)), PTLUST(KEEP(28)),
      &        STEP(N), PIMASTER(KEEP(28))
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INTEGER(8) :: PTRFAC(KEEP(28)), PTRAST(KEEP(28)),
      &              PAMASTER(KEEP(28))
       INTEGER COMM, NBFIN, SLAVEF, MYID
@@ -193,7 +193,7 @@ C
         ETATASS= 2 
         IOLDPS = PTLUST(STEP(INODE)) 
         NFRONT = IW(IOLDPS + KEEP(IXSZ)) 
-        NASS1  = iabs(IW(IOLDPS + 2 + KEEP(IXSZ)))
+        NASS1  = abs(IW(IOLDPS + 2 + KEEP(IXSZ)))
         ICT11 = IOLDPS + HF - 1 + NFRONT
         SSARBR=MUMPS_INSSARBR(PROCNODE_STEPS(STEP(INODE)),
      &                        KEEP(199))
@@ -246,7 +246,7 @@ C
      &       NUMORG, KEEP(486),
      &       KEEP(489), KEEP(490), KEEP(491), KEEP(492), 
      &       KEEP(20), KEEP(60), DAD(STEP(INODE)), KEEP(38),
-     &       LRSTATUS, KEEP(280), LRGROUPS)
+     &       KEEP(123), LRSTATUS, KEEP(280), LRGROUPS)
       IF (DAD(STEP(INODE)).NE.0) THEN
         IF ( MUMPS_PROCNODE(PROCNODE_STEPS(STEP(DAD(STEP(INODE)))),
      &                                     KEEP(199) )
@@ -384,7 +384,7 @@ C
      &       IOLDPS + HF + 2 * NFRONT, IW, LIW)
       ENDIF
       NCB   = NFRONT - NASS1
-      MAXFRW = max0(MAXFRW, NFRONT)
+      MAXFRW = max(MAXFRW, NFRONT)
       ICT11 = IOLDPS + HF - 1 + NFRONT
       CALL DMUMPS_SET_PARPIVT1 ( INODE, NFRONT, NASS1, KEEP, 
      &                           LR_ACTIVATED, PARPIV_T1) 
@@ -465,8 +465,9 @@ C
             NB_BLR = NPARTSASS + NPARTSCB
          CALL MAX_CLUSTER(BEGS_BLR,NB_BLR,MAXI_CLUSTER)
          DEALLOCATE(BEGS_BLR)
-         CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS1)
-         MINSIZE = int(IBCKSZ2 / 2)
+         CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS1,
+     &                        NFRONT, KEEP(35))
+         MINSIZE = int(IBCKSZ2 / 3)
          TOPDIAG = max(2*MINSIZE + MAXI_CLUSTER-1,TOPDIAG)
         ENDIF
         IF (ETATASS.EQ.1) THEN
@@ -654,14 +655,6 @@ C
           ELSE
             IACHK = PAMASTER(STEP(ISON))
           ENDIF
-          IF (IS_CB_LR .AND. LEVEL1) THEN
-            POSEL1 = PTRAST(STEP(INODE))
-            CALL DMUMPS_BLR_ASM_NIV1 (A, LA,
-     &           POSEL1, NFRONT, NASS1, SON_IW(ISTCHK+XXF),
-     &           SON_IW, SON_LIW,
-     &           LSTK, NELIM, K1, K1+LSTK-1, KEEP(50),
-     &           KEEP, KEEP8, OPASSW)
-          ENDIF
           IF ( KEEP(50) .eq. 0 ) THEN
             POSEL1 = PTRAST(STEP(INODE)) - NFRONT8
             IF (NFRONT .EQ. LSTK.AND. ISON.EQ.ISON_IN_PLACE
@@ -750,6 +743,14 @@ C
               ENDIF
             ENDIF 
           ENDIF
+          IF (IS_CB_LR .AND. LEVEL1) THEN
+            POSEL1 = PTRAST(STEP(INODE))
+            CALL DMUMPS_BLR_ASM_NIV1 (A, LA,
+     &           POSEL1, NFRONT, NASS1, SON_IW(ISTCHK+XXF),
+     &           SON_IW, SON_LIW,
+     &           LSTK, NELIM, K1, K1+LSTK-1, KEEP(50),
+     &           KEEP, KEEP8, OPASSW)
+          ENDIF
   205     IF (LEVEL1) THEN 
            IF (SAME_PROC) ISTCHK = PTRIST(STEP(ISON))
            IF ((SAME_PROC).AND.ETATASS.NE.1) THEN
@@ -1077,7 +1078,7 @@ C
      &        STEP(N),
      & PIMASTER(KEEP(28)),
      &        NSTK_S(KEEP(28)), PERM(N)
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INTEGER   CAND(SLAVEF+1, max(1,KEEP(56)))
       INTEGER   ISTEP_TO_INIV2(KEEP(71)), 
      &          TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
@@ -1202,7 +1203,7 @@ C
       CALL IS_FRONT_BLR_CANDIDATE(INODE, 2, NFRONT, NASS1, KEEP(486),
      &       KEEP(489), KEEP(490), KEEP(491), KEEP(492), 
      &       KEEP(20), KEEP(60), DAD(STEP(INODE)), KEEP(38),
-     &       LRSTATUS, KEEP(280), LRGROUPS)
+     &       KEEP(123), LRSTATUS, KEEP(280), LRGROUPS)
       COMPRESS_PANEL = (LRSTATUS.GE.2)
       COMPRESS_CB    = ((LRSTATUS.EQ.1).OR.
      &                  (LRSTATUS.EQ.3))
@@ -1452,7 +1453,7 @@ C
      &       NBPANELS_L, NBPANELS_U, NASS1, 
      &       IOLDPS + HF + 2 * NFRONT, IW, LIW)
       ENDIF
-      MAXFRW = max0(MAXFRW, NFRONT)
+      MAXFRW = max(MAXFRW, NFRONT)
       PTLUST(STEP(INODE)) = IOLDPS
       IW(IOLDPS+KEEP(IXSZ))     = NFRONT
       IW(IOLDPS + 1+KEEP(IXSZ)) = 0
@@ -1571,8 +1572,9 @@ C
          NB_BLR = NPARTSASS + NPARTSCB
          CALL MAX_CLUSTER(BEGS_BLR,NB_BLR,MAXI_CLUSTER)
          DEALLOCATE(BEGS_BLR)
-         CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS1)
-         MINSIZE = int(IBCKSZ2 / 2)
+         CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS1,
+     &                        NFRONT, KEEP(35))
+         MINSIZE = int(IBCKSZ2 / 3)
          TOPDIAG = max(2*MINSIZE + MAXI_CLUSTER-1, TOPDIAG)
         ENDIF
 !$      CHUNK = max(KEEP(360)/2,
diff -pruN 5.6.2-2.1/src/dfac_b.F 5.7.1-1/src/dfac_b.F
--- 5.6.2-2.1/src/dfac_b.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_b.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -71,7 +71,7 @@ C
       INTEGER(8) :: PTRFAC(KEEP(28))
       INTEGER   PTRIST(KEEP(28)), PTLUST_S(KEEP(28))
       INTEGER   IW1(2*KEEP(28)), ITLOC(N+KEEP(253)), POOL(LPOOL)
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INTEGER(8) :: IW2(2*KEEP(28))
       INTEGER   PROCNODE_STEPS(KEEP(28))
       INTEGER   COMM_LOAD, ASS_IRECV
@@ -96,8 +96,8 @@ C
       INTEGER, INTENT (IN) :: LL0_OMP_MAPPING
       INTEGER, INTENT (OUT):: L0_OMP_MAPPING( LL0_OMP_MAPPING )
       INTEGER, INTENT (IN) :: LL0_OMP_FACTORS
-      TYPE(DMUMPS_L0OMPFAC_T), INTENT (OUT) :: L0_OMP_FACTORS(
-     &                                         LL0_OMP_FACTORS )
+      TYPE(DMUMPS_L0OMPFAC_T), INTENT (INOUT) :: L0_OMP_FACTORS(
+     &                                           LL0_OMP_FACTORS )
       INTEGER, INTENT (IN) :: NBSTATS_I4, NBSTATS_I8
       INTEGER, INTENT (IN) :: NBCOLS_I4, NBCOLS_I8
       INTEGER, INTENT (IN) :: I4_L0_OMP(NBSTATS_I4, NBCOLS_I4)
@@ -556,7 +556,7 @@ C
       INTEGER LPOOL
       INTEGER PROCNODE_STEPS(KEEP(28))
       INTEGER ITLOC(N+KEEP(253))
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INTEGER IW(LIW), NSTK_STEPS(KEEP(28))
       INTEGER(8), INTENT(IN) :: PTRARW(LPTRAR), PTRAIW(LPTRAR)
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
diff -pruN 5.6.2-2.1/src/dfac_determinant.F 5.7.1-1/src/dfac_determinant.F
--- 5.6.2-2.1/src/dfac_determinant.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_determinant.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -152,25 +152,24 @@ C
       NEXP=-NEXP
       RETURN
       END SUBROUTINE DMUMPS_DETER_SCALING_INVERSE
-      SUBROUTINE DMUMPS_DETER_SIGN_PERM(DETER, N, VISITED, PERM)
+      SUBROUTINE DMUMPS_DETER_SIGN_PERM(DETER, N, PERM)
       IMPLICIT NONE
       DOUBLE PRECISION, intent(inout) :: DETER
       INTEGER, intent(in)    :: N
-      INTEGER, intent(inout) :: VISITED(N)
-      INTEGER, intent(in)    :: PERM(N)
+      INTEGER, intent(inout) :: PERM(N)
       INTEGER I, J, K
       K = 0
       DO I = 1, N
-        IF (VISITED(I) .GT. N) THEN
-          VISITED(I)=VISITED(I)-N-N-1
-          CYCLE
+        IF (PERM(I) .LT. 0) THEN
+          PERM(I)=-PERM(I)
+        ELSE 
+          J = PERM(I)
+          DO WHILE (J.NE.I)
+            PERM(J)=-PERM(J)
+            K = K + 1
+            J = -PERM(J) 
+          ENDDO
         ENDIF
-        J = PERM(I)
-        DO WHILE (J.NE.I)
-          VISITED(J) = VISITED(J) + N + N + 1
-          K = K + 1
-          J = PERM(J)
-        ENDDO
       ENDDO
       IF (mod(K,2).EQ.1) THEN
         DETER = -DETER
diff -pruN 5.6.2-2.1/src/dfac_diag.F 5.7.1-1/src/dfac_diag.F
--- 5.6.2-2.1/src/dfac_diag.F	1970-01-01 00:00:00.000000000 +0000
+++ 5.7.1-1/src/dfac_diag.F	2024-05-02 10:15:28.000000000 +0000
@@ -0,0 +1,20 @@
+C
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
+C
+C
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Mumps Technologies, University of Bordeaux.
+C
+C  This version of MUMPS is provided to you free of charge. It is
+C  released under the CeCILL-C license 
+C  (see doc/CeCILL-C_V1-en.txt, doc/CeCILL-C_V1-fr.txt, and
+C  https://cecill.info/licences/Licence_CeCILL-C_V1-en.html)
+C
+      SUBROUTINE DMUMPS_GETSETDIAGRETURN()
+C
+C     This file contain code to access/return the
+C     diagonal of a factorized matrix in the future.
+C
+      RETURN
+      END SUBROUTINE DMUMPS_GETSETDIAGRETURN
diff -pruN 5.6.2-2.1/src/dfac_dist_arrowheads_omp.F 5.7.1-1/src/dfac_dist_arrowheads_omp.F
--- 5.6.2-2.1/src/dfac_dist_arrowheads_omp.F	1970-01-01 00:00:00.000000000 +0000
+++ 5.7.1-1/src/dfac_dist_arrowheads_omp.F	2024-05-02 10:15:27.000000000 +0000
@@ -0,0 +1,1350 @@
+C
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
+C
+C
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Mumps Technologies, University of Bordeaux.
+C
+C  This version of MUMPS is provided to you free of charge. It is
+C  released under the CeCILL-C license 
+C  (see doc/CeCILL-C_V1-en.txt, doc/CeCILL-C_V1-fr.txt, and
+C  https://cecill.info/licences/Licence_CeCILL-C_V1-en.html)
+C
+#if ! defined(PCPRET)
+      SUBROUTINE DMUMPS_FAC_DIST_ARROWHEADS_OMP  (      
+     & N, NZ_loc8, 
+     &    A_loc, IRN_loc, JCN_loc, 
+     &    SIZESCAL, LSCAL, COLSCA, ROWSCA, 
+     & DBLARR, LDBLARR, INTARR, LINTARR,
+     & PTR8ARR, NINCOLARR, NINROWARR, PTRDEBARR,
+     & FILS, KEEP,KEEP8, MYID, COMM, NBRECORDS,
+     &
+     & S, LA, root, PROCNODE_STEPS, NPROCS, SLAVEF, PERM, STEP,
+     & ICNTL, INFO, NSEND8, NLOCAL8,
+     & ISTEP_TO_INIV2, CANDIDATES
+     & )
+!$    USE OMP_LIB
+      USE DMUMPS_STRUC_DEF
+      IMPLICIT NONE
+      INTEGER, INTENT(IN)    :: N, SIZESCAL
+      LOGICAL, INTENT(IN)    :: LSCAL
+      INTEGER(8), INTENT(IN) :: NZ_loc8
+      INTEGER, INTENT(IN)    :: IRN_LOC(max(1_8,NZ_loc8)), 
+     &                          JCN_LOC(max(1_8,NZ_loc8))
+      DOUBLE PRECISION, INTENT(IN)    :: A_loc(max(1_8,NZ_loc8))
+      DOUBLE PRECISION, INTENT(IN)       :: ROWSCA(SIZESCAL),
+     &                          COLSCA(SIZESCAL)
+      INTEGER(8), INTENT(IN) :: LDBLARR, LINTARR
+      DOUBLE PRECISION, INTENT(OUT)   :: DBLARR( LDBLARR )
+      INTEGER, INTENT(OUT)   :: INTARR( LINTARR )
+      INTEGER, INTENT(INOUT) :: KEEP(500)   
+      INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
+      INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
+      INTEGER, INTENT(IN) :: NINROWARR(KEEP(195))
+      INTEGER, INTENT(IN) :: PTRDEBARR(KEEP(196))
+      INTEGER(8), INTENT(INOUT):: KEEP8(150) 
+      INTEGER, INTENT(IN)    :: FILS( N )
+      INTEGER, INTENT(IN)    :: MYID, COMM, NBRECORDS
+      INTEGER(8), INTENT(IN) :: LA
+      INTEGER, INTENT(IN)    :: NPROCS, SLAVEF
+      INTEGER(8), INTENT(OUT):: NSEND8, NLOCAL8
+      INTEGER, INTENT(IN)    :: ISTEP_TO_INIV2(KEEP(71))
+      INTEGER, INTENT(IN)    :: CANDIDATES(SLAVEF+1, max(1,KEEP(56)))
+      DOUBLE PRECISION, INTENT(INOUT) :: S( LA )
+      TYPE (DMUMPS_ROOT_STRUC), INTENT(INOUT) :: root
+      INTEGER, INTENT(IN)    :: PROCNODE_STEPS(KEEP(28)), 
+     &                         PERM( N ), STEP( N )
+      INTEGER, INTENT(INOUT) :: INFO( 80 ) 
+      INTEGER, INTENT(IN)    :: ICNTL(60)
+      INCLUDE 'mumps_tags.h'
+      INCLUDE 'mpif.h'
+      DOUBLE PRECISION ZERO
+      PARAMETER( ZERO = 0.0D0 )
+      INTEGER, ALLOCATABLE, DIMENSION(:,:)  :: IW4
+      INTEGER(8), ALLOCATABLE, DIMENSION(:) :: PTRAW
+      INTEGER, ALLOCATABLE, DIMENSION(:,:,:) :: BUFSENDI
+      DOUBLE PRECISION, ALLOCATABLE, DIMENSION(:,:,:) :: BUFSENDR
+      INTEGER, ALLOCATABLE, DIMENSION(:,:)   :: BUFSEND_POSRESERVED
+      INTEGER, ALLOCATABLE, DIMENSION(:,:) :: BUFRECVI
+      DOUBLE PRECISION, ALLOCATABLE, DIMENSION(:,:) :: BUFRECVR
+      INTEGER, ALLOCATABLE, DIMENSION(:) :: IACT, ISENDREQI, ISENDREQR
+      LOGICAL, ALLOCATABLE, DIMENSION(:) :: SEND_ACTIVE
+      INTEGER, ALLOCATABLE, DIMENSION(:) :: IRECVREQI, IRECVREQR
+      INTEGER, ALLOCATABLE, DIMENSION(:):: RECV_BUF_STATUS
+         INTEGER, PARAMETER :: Processed_IrecNeeded          = 1
+         INTEGER, PARAMETER :: IrecPosted                    = 2
+         INTEGER, PARAMETER :: Received_NotProcessed         = 3
+         INTEGER, PARAMETER :: Processed_IrecNotneeded       = 4
+         INTEGER, PARAMETER :: Treating                      = 5
+         INTEGER, PARAMETER :: BeingTreatednotbyme           = 6 
+      INTEGER(8) :: ILOC8
+      INTEGER :: EndNZloc, NB_END_MSG_2_RECV
+      LOGICAL :: MPI_End_Send, End_TreatRecvBuf, MPI_InvolvedinSend, 
+     &           MPI_InvolvedinRecv, TH_InvolvedinComm, 
+     &           NO_ATOMIC_Wsendbuf, NO_ATOMIC_Warrow, FINISHED,
+     &           TH_InvolvedinArrange, TH_InvolvedinTreatRecv
+      INTEGER(8) :: PTR_ROOT
+      INTEGER    :: LOCAL_M, LOCAL_N, ARROW_ROOT
+      LOGICAL :: EARLYT3ROOTINS
+      LOGICAL :: I_AM_SLAVE, OneMPI
+      INTEGER :: IARR1, IORG, NOMP, NOMP_MAX
+      INTEGER :: ISTEP, ISLAVE_MAIN, IMAIN, JMAIN
+      INTEGER :: allocok 
+      LOGICAL :: OMP_FLAG
+      INTEGER(8) :: IS8MAIN
+      INTEGER :: TYPE_NODE_P, MASTER_NODE_P, NBJ_P
+      INTEGER(8) :: IS8_P
+      INTEGER :: LP, MP
+      LOGICAL :: LPOK, PROK
+      INTEGER(8) :: NB_RANGE_8
+      INTEGER :: SHIFT_PID
+      INTEGER :: NOMP_SHARED
+      LOGICAL    :: NOTHINGTOARRANGE_P
+      INTEGER    :: IOMP, NB_RANGE_P, EndNZloc_P
+      LOGICAL    :: ThWorking
+      INTEGER(8) :: ILOC8_P
+      INTEGER, PARAMETER :: MPI_MASTER = 0  
+      NSEND8  = 0_8
+      NLOCAL8 = 0_8
+      LP = ICNTL(1)
+      MP = ICNTL(2)
+      LPOK    = ((LP.GT.0).AND.(ICNTL(4).GE.1))
+      PROK    = ((MP.GT.0).AND.(ICNTL(4).GE.2))
+      NB_RANGE_8        = int(max(NBRECORDS/10, 1), 8)
+      IF (KEEP(46).EQ.0) THEN
+       SHIFT_PID = 1
+      ELSE
+       SHIFT_PID = 0
+      ENDIF
+      I_AM_SLAVE = (MYID.NE.0.OR.KEEP(46).EQ.1)
+      OneMPI     = NPROCS.EQ.1 
+      IF ( OneMPI.OR. 
+     &     (KEEP(54).EQ.0.AND.(MYID.NE.MPI_MASTER)) 
+     &   ) THEN
+        MPI_InvolvedinSend = .FALSE.  
+        MPI_End_Send       = .TRUE.
+      ELSE
+        MPI_InvolvedinSend = .TRUE.   
+        MPI_End_Send       = .FALSE.
+      ENDIF
+      IF (.NOT.OneMPI) THEN
+        ALLOCATE( 
+     &    BUFSENDI(NBRECORDS * 2 + 1, 2, NPROCS),  
+     &    BUFSENDR(NBRECORDS, 2, NPROCS),
+     &    IACT(NPROCS), SEND_ACTIVE(NPROCS), 
+     &    ISENDREQI(NPROCS), ISENDREQR(NPROCS),
+     &    BUFSEND_POSRESERVED(2, NPROCS),
+     &    stat=allocok)
+        IF ( allocok .GT. 0 ) THEN
+          IF ( LPOK ) THEN
+            WRITE(LP,*)
+     &     '** Error allocating SEND buffers for matrix distribution'
+          END IF
+          INFO(1) = -13
+          INFO(2) =  ( NBRECORDS * 2 + 1 ) * NPROCS * 2 +
+     &             NBRECORDS * NPROCS * 2 + 
+     &             NPROCS*6
+          GOTO 20
+        END IF
+        DO ISLAVE_MAIN=1, NPROCS
+          IACT (ISLAVE_MAIN)         = 1
+          ISENDREQI(ISLAVE_MAIN) = MPI_REQUEST_NULL
+          ISENDREQR(ISLAVE_MAIN) = MPI_REQUEST_NULL
+          BUFSENDI(1, 1, ISLAVE_MAIN)       = 0
+          BUFSEND_POSRESERVED(1,ISLAVE_MAIN)= 0
+          BUFSENDI(1, 2, ISLAVE_MAIN)       = NBRECORDS  
+          BUFSEND_POSRESERVED(2,ISLAVE_MAIN)= NBRECORDS
+          SEND_ACTIVE(ISLAVE_MAIN)   =  .FALSE.
+        ENDDO
+      ENDIF
+      IF (OneMPI.OR. 
+     &    (KEEP(54).EQ.0.AND.(MYID.EQ.MPI_MASTER))
+     &   ) THEN
+        NB_END_MSG_2_RECV  = 0
+        MPI_InvolvedinRecv = .FALSE. 
+        End_TreatRecvBuf   = .TRUE.
+      ELSE IF (KEEP(54).EQ.0.AND.MYID.NE.MPI_MASTER) THEN
+        NB_END_MSG_2_RECV  =  1
+        MPI_InvolvedinRecv = .TRUE.  
+        End_TreatRecvBuf   = .FALSE.
+      ELSE
+        NB_END_MSG_2_RECV  = NPROCS-1
+        MPI_InvolvedinRecv = .TRUE.  
+        End_TreatRecvBuf   = .FALSE.
+      ENDIF
+      IF (.NOT.OneMPI) THEN
+        ALLOCATE( 
+     &  BUFRECVI(NBRECORDS * 2 + 1, NPROCS),
+     &  BUFRECVR(NBRECORDS, NPROCS),
+     &  IRECVREQI(NPROCS), IRECVREQR(NPROCS), 
+     &  RECV_BUF_STATUS(NPROCS),
+     &            stat=allocok)
+        IF ( allocok .GT. 0 ) THEN
+           IF ( LPOK ) THEN
+             WRITE(LP,*)
+     &      '** Error allocating RECV buffers for matrix distribution'
+           END IF
+           INFO(1) = -13
+           INFO(2) =  ( NBRECORDS * 2 + 1 ) * NPROCS +
+     &              NBRECORDS * NPROCS  +      
+     &              NPROCS*3
+           GOTO 20
+        ENDIF
+        BUFRECVI(1, 1:NPROCS) = 0
+        IRECVREQI(1:NPROCS)   = MPI_REQUEST_NULL
+        IRECVREQR(1:NPROCS)   = MPI_REQUEST_NULL
+        RECV_BUF_STATUS (1:NPROCS)= Processed_IrecNeeded
+        RECV_BUF_STATUS (MYID+1)  = Processed_IrecNotneeded
+        IF (KEEP(54).EQ.0) THEN
+         DO ISLAVE_MAIN=1, NPROCS
+           RECV_BUF_STATUS (ISLAVE_MAIN)= Processed_IrecNotneeded
+         ENDDO
+         IF (MYID.NE.MPI_MASTER) THEN
+           RECV_BUF_STATUS(MPI_MASTER+1)  = Processed_IrecNeeded
+         ENDIF
+        ENDIF
+      ENDIF
+      ALLOCATE( IW4( N, 2 ), stat = allocok )
+      IF ( allocok .GT. 0 ) THEN
+        WRITE(LP,*) '** Error allocating IW4 for matrix distribution'
+        INFO(1) = -13
+        CALL MUMPS_SET_IERROR( int(N,8) * 2_8, INFO(2) )
+        GOTO 20
+      END IF
+      ALLOCATE( PTRAW( N ), stat = allocok )
+      IF ( allocok .GT. 0 ) THEN
+        WRITE(LP,*) '** Error allocating IW4 for matrix distribution'
+        INFO(1) = -13
+        CALL MUMPS_SET_IERROR( int(N,8) * KEEP(10), INFO(2) )
+        GOTO 20
+      END IF
+ 20   CONTINUE
+      CALL MUMPS_PROPINFO( ICNTL, INFO, COMM, MYID )
+      IF ( INFO(1) .LT. 0 ) GOTO 100
+      ARROW_ROOT = 0
+      EARLYT3ROOTINS = KEEP(200) .EQ.0
+     &        .OR.  ( KEEP(200) .LT. 0 .AND. KEEP(400) .EQ. 0 )
+      IF (I_AM_SLAVE) THEN
+       DO JMAIN = 1, N
+        ISTEP=STEP(JMAIN)
+        IF (ISTEP .GT. 0) THEN
+          IARR1 = PTRDEBARR( ISTEP )
+          IF ( IARR1 .GT. 0 ) THEN
+            IMAIN = JMAIN
+            IORG = 0
+            DO WHILE ( IMAIN .GT. 0 )
+              IORG = IORG + 1
+              IW4(IMAIN, 1)  = NINCOLARR( IARR1 + IORG - 1 )
+              IW4(IMAIN, 2)  = NINROWARR( IARR1 + IORG - 1 ) +
+     &                     NINCOLARR( IARR1 + IORG - 1 )
+              IS8MAIN        = PTR8ARR( IARR1 + IORG - 1 )
+              PTRAW( IMAIN ) = IS8MAIN
+              INTARR( IS8MAIN ) = IMAIN
+              DBLARR( IS8MAIN ) = ZERO
+              IMAIN = FILS(IMAIN)
+            ENDDO
+          ENDIF
+        ENDIF
+       ENDDO
+       IF ( KEEP(38) .NE. 0 .AND. EARLYT3ROOTINS ) THEN
+         CALL DMUMPS_GET_ROOT_INFO(root,LOCAL_M, LOCAL_N, PTR_ROOT, LA)
+         CALL DMUMPS_SET_ROOT_TO_ZERO(root, KEEP, S, LA)
+       ELSE
+         LOCAL_M = -19999; LOCAL_N = -29999; PTR_ROOT = -99999_8
+       END IF
+      ELSE 
+         LOCAL_M = -19999; LOCAL_N = -29999; PTR_ROOT = -99999_8
+      ENDIF
+      NOMP=1
+!$    NOMP=omp_get_max_threads()
+      NOMP_MAX = NOMP
+      IF (NOMP_MAX.GT.2.AND.KEEP(399).EQ.2) THEN
+       IF (.NOT.OneMPI) THEN
+        NOMP_MAX = 2
+       ENDIF
+      ENDIF
+      IF (NOMP_MAX.GT.3.AND.KEEP(399).EQ.3) THEN
+       IF (.NOT.OneMPI) THEN
+        NOMP_MAX = 3
+       ENDIF
+      ENDIF
+      ILOC8      = 1_8  
+      OMP_FLAG   = ((NOMP .GE.2).AND.(KEEP(399).NE.99))
+      FINISHED = .FALSE.
+      NOMP_SHARED = 1
+!$OMP PARALLEL 
+!$OMP&  NUM_THREADS(NOMP_MAX)
+!$OMP&    PRIVATE(
+!$OMP&         IOMP, ThWorking, ILOC8_P, NB_RANGE_P,
+!$OMP&         NOTHINGTOARRANGE_P, EndNZloc_P, TH_InvolvedinComm,
+!$OMP&         TH_InvolvedinTreatRecv,  TH_InvolvedinArrange )
+!$OMP& REDUCTION(+:NSEND8, NLOCAL8, ARROW_ROOT) 
+!$OMP& IF (OMP_FLAG)
+      IOMP        = 0
+!$    IOMP=omp_get_thread_num()
+!$OMP SINGLE
+!$      NOMP_SHARED= omp_get_num_threads()  
+        IF (OneMPI) THEN
+         EndNZloc = NOMP_SHARED
+        ELSE
+         EndNZloc = max(1,NOMP_SHARED -1)
+         IF ( KEEP(399).EQ.2.OR.KEEP(399).EQ.3 ) THEN
+          EndNZloc = min(EndNZloc,1)
+         ENDIF
+        ENDIF
+        IF (NZ_loc8.EQ.0_8) EndNZloc = 0  
+        IF (.NOT.MPI_InvolvedinSend.AND.(EndNZloc.EQ.0)) EndNZloc=-1
+        NO_ATOMIC_Wsendbuf = ( NOMP_SHARED.EQ.1 )
+        NO_ATOMIC_Warrow   = ( NOMP_SHARED.EQ.1 )
+        IF (NPROCS.GT.1) THEN
+          NO_ATOMIC_Warrow = (NOMP_SHARED.LE.2)
+          IF ( KEEP(399).EQ.2 .OR. KEEP(399).EQ.3) THEN
+           NO_ATOMIC_Wsendbuf =  .TRUE.
+           IF (.NOT.MPI_InvolvedinSend) NO_ATOMIC_Warrow=.TRUE.
+           IF (.NOT.MPI_InvolvedinRecv) NO_ATOMIC_Warrow=.TRUE.
+          ENDIF
+        ENDIF
+!$OMP END SINGLE
+      ThWorking          =  OneMPI.OR.
+     &                     (NOMP_SHARED.EQ.1) .OR. (IOMP.NE.0)
+      TH_InvolvedinTreatRecv = (MPI_InvolvedinRecv.AND.ThWorking)
+      IF ( TH_InvolvedinTreatRecv.AND.
+     &     (NOMP_SHARED.EQ.3).AND.(KEEP(399).EQ.3) ) THEN
+          IF (IOMP.NE.2) TH_InvolvedinTreatRecv = .FALSE.
+      ENDIF
+      TH_InvolvedinArrange = ThWorking
+      IF (.NOT.OneMPI.AND.ThWorking) THEN
+        IF (KEEP(399).EQ.2.OR.KEEP(399).EQ.3) 
+     &    THEN
+          IF ((NOMP_SHARED.NE.1).AND.(IOMP.NE.1)) 
+     &       TH_InvolvedinArrange = .FALSE.
+        ENDIF
+      ENDIF
+      TH_InvolvedinComm  = ((.NOT.OneMPI).AND.(IOMP.EQ.0))
+      NOTHINGTOARRANGE_P = (NZ_loc8.EQ.0_8)
+      ILOC8_P            = 0_8
+       DO WHILE ( .NOT.FINISHED )
+          IF (TH_InvolvedinComm) THEN
+            CALL DMUMPS_ARROW_TRY_PROGRESS_COMM ( IOMP, MYID,
+     &       NPROCS, NBRECORDS, MPI_InvolvedinSend, MPI_InvolvedinRecv, 
+     &       COMM, ISENDREQI, ISENDREQR, BUFSENDI, BUFSENDR, 
+     &       IACT, SEND_ACTIVE, BUFSEND_POSRESERVED, 
+     &       IRECVREQI, IRECVREQR, BUFRECVI, BUFRECVR,
+     &       RECV_BUF_STATUS, NB_END_MSG_2_RECV, 
+     &       EndNZloc, MPI_End_Send, End_TreatRecvBuf
+     &        )
+          ENDIF
+          IF (.NOT.ThWorking) THEN
+            CALL MUMPS_USLEEP(20)
+            GOTO  50
+          ENDIF
+          IF (TH_InvolvedinTreatRecv) THEN
+            CALL DMUMPS_ARROW_TRY_TREAT_RECV_BUF ( IOMP,
+     &             BUFRECVI, BUFRECVR, RECV_BUF_STATUS, 
+     &             NPROCS, NBRECORDS, N, IW4,
+     &             KEEP, LOCAL_M, LOCAL_N, root, PTR_ROOT, S, LA,
+     &             NB_END_MSG_2_RECV, MYID, PROCNODE_STEPS,
+     &             SLAVEF,
+     &             PTRAW, 
+     &             PTR8ARR, NINCOLARR, NINROWARR, PTRDEBARR,
+     &             PERM, STEP,
+     &             INTARR, LINTARR, DBLARR, LDBLARR, 
+     &             NOMP_SHARED, EARLYT3ROOTINS, NO_ATOMIC_Warrow )
+            IF (NOMP_SHARED.EQ.1) THEN
+              CALL DMUMPS_ARROW_TRY_PROGRESS_COMM ( IOMP, MYID,
+     &        NPROCS, NBRECORDS, 
+     &        MPI_InvolvedinSend, MPI_InvolvedinRecv,
+     &        COMM, ISENDREQI, ISENDREQR, BUFSENDI, BUFSENDR, 
+     &        IACT, SEND_ACTIVE, BUFSEND_POSRESERVED, 
+     &        IRECVREQI, IRECVREQR, BUFRECVI, BUFRECVR,
+     &        RECV_BUF_STATUS, NB_END_MSG_2_RECV, 
+     &        EndNZloc, MPI_End_Send, End_TreatRecvBuf
+     &        )
+            ENDIF
+          ENDIF
+          IF (.NOT. NOTHINGTOARRANGE_P.AND.TH_InvolvedinArrange) THEN
+!$OMP ATOMIC CAPTURE
+            ILOC8_P = ILOC8
+            ILOC8   = ILOC8 + NB_RANGE_8
+!$OMP END ATOMIC 
+            IF (ILOC8_P.LE.NZ_loc8) THEN
+              NB_RANGE_P = int(min(NB_RANGE_8, NZ_loc8-ILOC8_P+1))
+              CALL DMUMPS_FAC_ARROW_ARRANGE ( MYID, IOMP, N, SHIFT_PID,
+     &   SLAVEF, LSCAL, NSEND8, NLOCAL8, ILOC8_P, NB_RANGE_P, 
+     &   NZ_loc8, IRN_LOC, JCN_LOC, A_loc, SIZESCAL, ROWSCA, COLSCA,
+     &   ISTEP_TO_INIV2, CANDIDATES, KEEP, MPI_MASTER, NO_ATOMIC_Warrow,
+     &   NO_ATOMIC_Wsendbuf, TH_InvolvedinTreatRecv,
+     &   NPROCS, NBRECORDS, MPI_InvolvedinSend, MPI_InvolvedinRecv, 
+     &   COMM, ISENDREQI, ISENDREQR, BUFSENDI, BUFSENDR, IACT,
+     &   SEND_ACTIVE, BUFSEND_POSRESERVED, IRECVREQI, IRECVREQR,
+     &   BUFRECVI, BUFRECVR, RECV_BUF_STATUS, EndNZloc, MPI_End_Send,
+     &   End_TreatRecvBuf,
+     &   root, PTR_ROOT, ARROW_ROOT, EARLYT3ROOTINS, LOCAL_M, LOCAL_N,
+     &   S, LA, NB_END_MSG_2_RECV, PROCNODE_STEPS, IW4, PTRAW, PTR8ARR,
+     &   NINCOLARR, NINROWARR, PTRDEBARR, PERM, STEP, INTARR, LINTARR,
+     &   DBLARR, LDBLARR, NOMP_SHARED )
+            ENDIF
+            IF (ILOC8_P+NB_RANGE_8.GT.NZ_loc8) THEN
+              IF (.NOT. NOTHINGTOARRANGE_P) THEN
+               NOTHINGTOARRANGE_P=.TRUE. 
+!$OMP          ATOMIC CAPTURE
+               EndNZloc   = EndNZloc-1
+               EndNZloc_P = EndNZloc
+!$OMP          END ATOMIC
+               IF (MPI_End_Send.AND.EndNZloc_P.EQ.0) THEN
+!$OMP           ATOMIC WRITE
+                EndNZloc=-1
+!$OMP           END ATOMIC
+               ENDIF
+              ENDIF
+            ENDIF
+          ENDIF
+  50      CONTINUE  
+!$OMP     MASTER
+!$OMP     ATOMIC WRITE
+          FINISHED = ( (EndNZloc.EQ.-1) 
+     &            .AND.(MPI_End_Send.OR.(.not.MPI_InvolvedinSend))
+     &            .AND. End_TreatRecvBuf
+     &               )
+!$OMP     END ATOMIC
+!$OMP     END MASTER
+       ENDDO
+!$OMP END PARALLEL
+!$OMP PARALLEL DO SCHEDULE(DYNAMIC,1)
+!$OMP&         PRIVATE(ISTEP, TYPE_NODE_P, MASTER_NODE_P, NBJ_P, 
+!$OMP&                 IARR1, IS8_P  )
+!$OMP&        IF (OMP_FLAG)
+      DO ISTEP=1, KEEP(28)
+        CALL MUMPS_TYPEANDPROCNODE( TYPE_NODE_P, MASTER_NODE_P,
+     &    PROCNODE_STEPS(ISTEP), KEEP(199) )
+        MASTER_NODE_P = MASTER_NODE_P + SHIFT_PID
+        IF ( MASTER_NODE_P.NE.MYID.OR.
+     &      (  (TYPE_NODE_P.NE.1) .AND. (TYPE_NODE_P.NE.2) )
+     &     ) CYCLE
+        IARR1  = PTRDEBARR( ISTEP )
+        NBJ_P  = NINCOLARR( IARR1)
+        IF (NBJ_P.LE.0) CYCLE
+        IS8_P  = PTR8ARR( IARR1) + 1_8
+        CALL DMUMPS_QUICK_SORT_ARROWHEADS( N, PERM,
+     &              INTARR( IS8_P ),
+     &              DBLARR( IS8_P ),
+     &              NBJ_P, 1, NBJ_P )
+      ENDDO
+!$OMP END PARALLEL DO
+ 100  CONTINUE
+      IF (ALLOCATED(IW4))         DEALLOCATE( IW4 )
+      IF (ALLOCATED(PTRAW))       DEALLOCATE( PTRAW )
+      IF (ALLOCATED(BUFSENDI))    DEALLOCATE( BUFSENDI )
+      IF (ALLOCATED(BUFSENDR))    DEALLOCATE( BUFSENDR )
+      IF (ALLOCATED(BUFRECVI))    DEALLOCATE( BUFRECVI )
+      IF (ALLOCATED(BUFRECVR))    DEALLOCATE( BUFRECVR )
+      IF (ALLOCATED(IACT))        DEALLOCATE( IACT )
+      IF (ALLOCATED(ISENDREQI))   DEALLOCATE( ISENDREQI )
+      IF (ALLOCATED(ISENDREQR))   DEALLOCATE( ISENDREQR )
+      IF (ALLOCATED(IRECVREQI))   DEALLOCATE( IRECVREQI )
+      IF (ALLOCATED(IRECVREQR))   DEALLOCATE( IRECVREQR )
+      IF (ALLOCATED(SEND_ACTIVE)) DEALLOCATE( SEND_ACTIVE )
+      IF (ALLOCATED(BUFSEND_POSRESERVED))   
+     &                      DEALLOCATE( BUFSEND_POSRESERVED )
+      IF (ALLOCATED(RECV_BUF_STATUS)) DEALLOCATE( RECV_BUF_STATUS )
+      RETURN
+      END SUBROUTINE DMUMPS_FAC_DIST_ARROWHEADS_OMP 
+      SUBROUTINE DMUMPS_ARROW_TRY_PROGRESS_COMM ( IOMP, MYID,
+     &     NPROCS, NBRECORDS, MPI_InvolvedinSend, MPI_InvolvedinRecv,
+     &     COMM, ISENDREQI, ISENDREQR, BUFSENDI, BUFSENDR, 
+     &     IACT, SEND_ACTIVE, BUFSEND_POSRESERVED, 
+     &     IRECVREQI, IRECVREQR, BUFRECVI, BUFRECVR,
+     &     RECV_BUF_STATUS, NB_END_MSG_2_RECV, 
+     &     EndNZloc, MPI_End_Send, End_TreatRecvBuf
+     &        )
+      IMPLICIT NONE
+      INTEGER, INTENT(IN) :: IOMP, MYID, NPROCS, NBRECORDS, COMM
+      LOGICAL, INTENT(IN) :: MPI_InvolvedinSend, MPI_InvolvedinRecv
+      INTEGER, INTENT(IN) :: NB_END_MSG_2_RECV
+      INTEGER, INTENT(INOUT) :: EndNZloc
+      LOGICAL, INTENT(INOUT) :: MPI_End_Send, End_TreatRecvBuf
+      INTEGER, INTENT(INOUT) :: 
+     &     ISENDREQI(NPROCS), ISENDREQR(NPROCS), 
+     &     BUFSENDI(NBRECORDS * 2 + 1, 2, NPROCS), 
+     &     IACT(NPROCS), BUFSEND_POSRESERVED(2,NPROCS)
+      DOUBLE PRECISION, INTENT(INOUT) :: BUFSENDR(NBRECORDS, 2, NPROCS)
+      LOGICAL, INTENT(INOUT) :: SEND_ACTIVE(NPROCS)
+      INTEGER, INTENT(INOUT) :: 
+     &     IRECVREQI(NPROCS), IRECVREQR(NPROCS), 
+     &     BUFRECVI(NBRECORDS * 2 + 1, NPROCS),
+     &     RECV_BUF_STATUS(NPROCS)
+      DOUBLE PRECISION, INTENT(INOUT) ::  BUFRECVR(NBRECORDS, NPROCS)
+         INTEGER, PARAMETER :: Processed_IrecNeeded          = 1
+         INTEGER, PARAMETER :: IrecPosted                    = 2
+         INTEGER, PARAMETER :: Received_NotProcessed         = 3
+         INTEGER, PARAMETER :: Processed_IrecNotneeded       = 4
+         INTEGER, PARAMETER :: Treating                      = 5
+      INCLUDE 'mumps_tags.h'
+      INCLUDE 'mpif.h'
+      INTEGER :: EndNZloc_copy, ISLAVE, NBREC, STATE, 
+     &           NB_END_MSG_2_RECV_COPY, ISLAVE_RECV 
+      INTEGER :: IERR, IACT_P, NEXT_IACT
+      INTEGER :: TAILLE_SEND_I, TAILLE_SEND_R
+      LOGICAL :: FLAG, FLAGRECV, ALL_LAST_MESS_SENT
+      INTEGER :: STATUS(MPI_STATUS_SIZE)
+      IF (MPI_InvolvedinSend.and.(.NOT.MPI_End_Send)) THEN
+        DO ISLAVE = 1, NPROCS
+          IF (ISLAVE-1.EQ.MYID) CYCLE
+          IF (SEND_ACTIVE( ISLAVE )) THEN
+              CALL MPI_TEST( ISENDREQR( ISLAVE ), FLAG, STATUS, IERR )
+              IF (FLAG) THEN
+                CALL MPI_WAIT( ISENDREQI( ISLAVE ), STATUS, IERR )
+                SEND_ACTIVE( ISLAVE ) = .FALSE.
+              ENDIF
+          ENDIF
+        ENDDO
+!$OMP   ATOMIC READ
+        EndNZloc_copy = EndNZloc
+!$OMP   END ATOMIC 
+        ALL_LAST_MESS_SENT = (EndNZloc_copy.EQ.0)
+        IF (EndNZloc_copy.NE.-1) THEN
+          DO ISLAVE=1, NPROCS
+            IF (ISLAVE-1.EQ.MYID) CYCLE
+            IF (EndNZloc_copy .EQ. 0) THEN
+             NBREC = 
+     &         min(BUFSEND_POSRESERVED(IACT(ISLAVE),ISLAVE),NBRECORDS)
+             IF (NBREC.EQ.-99) CYCLE
+             BUFSENDI(1,IACT(ISLAVE),ISLAVE) = - NBREC
+            ELSE
+!$OMP         ATOMIC READ
+              NBREC = BUFSENDI(1,IACT(ISLAVE),ISLAVE)
+!$OMP         END ATOMIC
+            ENDIF
+            IF ((EndNZloc_copy.EQ.0).OR.(NBREC.EQ.NBRECORDS)) THEN
+              IF (.NOT.SEND_ACTIVE(ISLAVE)) THEN
+                TAILLE_SEND_I = NBREC * 2 + 1
+                TAILLE_SEND_R = NBREC
+                IACT_P = IACT(ISLAVE)
+                CALL MPI_ISEND( BUFSENDI(1, IACT_P, ISLAVE ),
+     &              TAILLE_SEND_I,
+     &              MPI_INTEGER, ISLAVE - 1, 
+     &              ARR_INT, COMM,
+     &              ISENDREQI( ISLAVE ), IERR )
+                CALL MPI_ISEND( BUFSENDR(1, IACT_P, ISLAVE ),
+     &              TAILLE_SEND_R,
+     &              MPI_DOUBLE_PRECISION, ISLAVE - 1, 
+     &              ARR_REAL, COMM,
+     &              ISENDREQR( ISLAVE ), IERR )
+                SEND_ACTIVE( ISLAVE ) = .TRUE.
+                IF (EndNZloc_copy.NE.0) THEN
+                  NEXT_IACT = 3-IACT_P
+!$OMP             ATOMIC WRITE
+                  BUFSEND_POSRESERVED(NEXT_IACT,ISLAVE) = 0
+!$OMP             END ATOMIC
+!$OMP             ATOMIC WRITE
+                  BUFSENDI(1,NEXT_IACT,ISLAVE) = 0
+!$OMP             END ATOMIC
+!$OMP             ATOMIC WRITE
+                  IACT( ISLAVE ) = NEXT_IACT
+!$OMP             END ATOMIC
+                ELSE
+                  BUFSEND_POSRESERVED(IACT_P,ISLAVE) = -99
+                ENDIF
+              ELSE
+                ALL_LAST_MESS_SENT=.FALSE.
+              ENDIF
+            ENDIF
+          ENDDO
+        ENDIF
+        IF (EndNZloc_copy.EQ.0.AND.ALL_LAST_MESS_SENT) THEN 
+            EndNZloc      = -1  
+            EndNZloc_copy = -1  
+        ENDIF
+        IF (.NOT.MPI_End_Send) THEN
+          IF ( (EndNZloc_copy.EQ.-1) )  THEN
+            MPI_End_Send = .TRUE.
+            DO ISLAVE = 1, NPROCS
+               IF (ISLAVE-1.EQ.MYID) CYCLE
+               IF (SEND_ACTIVE( ISLAVE )) THEN 
+                 MPI_End_Send=.FALSE.
+                 EXIT
+               ENDIF
+            ENDDO
+          ENDIF
+        ENDIF
+      ENDIF
+      IF (MPI_InvolvedinRecv.AND.(.NOT.End_TreatRecvBuf)) THEN
+        CALL MPI_TESTANY(NPROCS, IRECVREQR, ISLAVE_RECV, 
+     &                   FLAGRECV, STATUS,IERR)
+        IF (FLAGRECV.AND.(ISLAVE_RECV.NE.MPI_UNDEFINED)) 
+     &            THEN
+            CALL MPI_WAIT(IRECVREQI(ISLAVE_RECV),STATUS,IERR)
+!$OMP       ATOMIC WRITE
+            RECV_BUF_STATUS(ISLAVE_RECV)=Received_NotProcessed
+!$OMP       END ATOMIC
+        ENDIF
+        DO  ISLAVE = 1, NPROCS
+          IF (ISLAVE - 1 .EQ. MYID) CYCLE
+!$OMP     ATOMIC READ
+          STATE = RECV_BUF_STATUS(ISLAVE)
+!$OMP     END ATOMIC
+          IF (STATE.EQ.Processed_IrecNeeded) THEN
+            CALL MPI_IRECV ( BUFRECVI(1,ISLAVE), NBRECORDS * 2 + 1,  
+     &              MPI_INTEGER, ISLAVE-1, ARR_INT, COMM, 
+     &              IRECVREQI(ISLAVE), IERR)
+            CALL MPI_IRECV ( BUFRECVR(1,ISLAVE), NBRECORDS,
+     &              MPI_DOUBLE_PRECISION, ISLAVE-1, 
+     &              ARR_REAL, COMM,
+     &              IRECVREQR(ISLAVE), IERR)
+!$OMP       ATOMIC WRITE
+            RECV_BUF_STATUS(ISLAVE) = IrecPosted
+!$OMP       END ATOMIC
+          ENDIF
+        ENDDO
+!$OMP   ATOMIC READ
+        NB_END_MSG_2_RECV_COPY = NB_END_MSG_2_RECV
+!$OMP   END ATOMIC
+        IF (NB_END_MSG_2_RECV_COPY.EQ.0) THEN
+          End_TreatRecvBuf = .TRUE.
+          DO ISLAVE = 1, NPROCS
+            IF (ISLAVE - 1 .EQ. MYID) CYCLE
+            IF (RECV_BUF_STATUS(ISLAVE).NE.Processed_IrecNotneeded) THEN
+               End_TreatRecvBuf = .FALSE.
+               EXIT
+            ENDIF
+          ENDDO
+        ENDIF
+      ENDIF
+      RETURN
+      END SUBROUTINE DMUMPS_ARROW_TRY_PROGRESS_COMM 
+      SUBROUTINE DMUMPS_ARROW_TRY_TREAT_RECV_BUF (IOMP,
+     &             BUFRECVI, BUFRECVR, RECV_BUF_STATUS, 
+     &             NPROCS, NBRECORDS, N, IW4,
+     &             KEEP, LOCAL_M, LOCAL_N, root, PTR_ROOT, S, LA,
+     &             NB_END_MSG_2_RECV, MYID, PROCNODE_STEPS,
+     &             SLAVEF,
+     &             PTRAW, 
+     &             PTR8ARR, NINCOLARR, NINROWARR, PTRDEBARR,
+     &             PERM, STEP,
+     &             INTARR, LINTARR, DBLARR, LDBLARR, 
+     &             NOMP_SHARED, EARLYT3ROOTINS, NO_ATOMIC_Warrow )
+      USE DMUMPS_STRUC_DEF, ONLY : DMUMPS_ROOT_STRUC
+      IMPLICIT NONE
+      TYPE (DMUMPS_ROOT_STRUC) :: root
+      INTEGER, INTENT(IN):: IOMP, NPROCS, NBRECORDS, N, MYID, SLAVEF,
+     &                      NOMP_SHARED
+      LOGICAL, INTENT(IN):: EARLYT3ROOTINS
+      INTEGER, INTENT(IN):: BUFRECVI( NBRECORDS * 2 + 1, NPROCS )
+      DOUBLE PRECISION, INTENT(IN):: BUFRECVR( NBRECORDS, NPROCS )
+      INTEGER, INTENT(INOUT) :: RECV_BUF_STATUS(NPROCS)
+      INTEGER, INTENT(INOUT):: IW4( N, 2 )
+      INTEGER, INTENT(IN):: KEEP(500)
+      INTEGER, INTENT(INOUT):: NB_END_MSG_2_RECV
+      INTEGER(8), INTENT(IN) :: PTRAW( N )
+      INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
+      INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
+      INTEGER, INTENT(IN) :: NINROWARR(KEEP(195))
+      INTEGER, INTENT(IN) :: PTRDEBARR(KEEP(196))
+      INTEGER, INTENT(IN) :: PERM( N ), STEP( N )
+      INTEGER, INTENT(IN) :: PROCNODE_STEPS( KEEP(28) )
+      INTEGER(8), INTENT(IN) :: LINTARR, LDBLARR
+      INTEGER, INTENT(INOUT) ::  INTARR( LINTARR )
+      INTEGER, INTENT(IN)::  LOCAL_M, LOCAL_N
+      INTEGER(8), INTENT(IN) :: PTR_ROOT, LA
+      DOUBLE PRECISION, INTENT(INOUT) :: S( LA ), DBLARR( LDBLARR )
+      LOGICAL, INTENT(IN)    :: NO_ATOMIC_Warrow
+         INTEGER, PARAMETER :: Processed_IrecNeeded          = 1
+         INTEGER, PARAMETER :: IrecPosted                    = 2
+         INTEGER, PARAMETER :: Received_NotProcessed         = 3
+         INTEGER, PARAMETER :: Processed_IrecNotneeded       = 4
+         INTEGER, PARAMETER :: Treating                      = 5
+         INTEGER, PARAMETER :: BeingTreatednotbyme           = 6
+      INTEGER MUMPS_TYPENODE
+      EXTERNAL MUMPS_TYPENODE
+      INTEGER STATE, ISLAVE
+      DO ISLAVE =1, NPROCS
+         IF (MYID.EQ.ISLAVE-1) CYCLE
+!$OMP    ATOMIC READ
+         STATE = RECV_BUF_STATUS(ISLAVE)
+!$OMP    END ATOMIC
+         IF (STATE.EQ.Treating) CYCLE
+         IF (STATE.EQ.Received_NotProcessed) THEN
+          IF (NOMP_SHARED.EQ.1) THEN
+            RECV_BUF_STATUS(ISLAVE) = Treating
+            STATE                   = Treating
+          ELSE IF (KEEP(399).LE.3) THEN
+!$OMP       ATOMIC WRITE
+            RECV_BUF_STATUS(ISLAVE) = Treating
+!$OMP       END ATOMIC
+            STATE                   = Treating
+          ELSE
+!$OMP      CRITICAL(ARROW_RECV_BUF_STATUS)
+!$OMP        ATOMIC READ
+             STATE = RECV_BUF_STATUS(ISLAVE)
+!$OMP        END ATOMIC
+             IF (STATE.EQ.Received_NotProcessed) THEN
+!$OMP          ATOMIC WRITE
+               RECV_BUF_STATUS(ISLAVE) = Treating
+!$OMP          END ATOMIC 
+               STATE                   = Treating
+             ELSE
+               STATE                   = BeingTreatednotbyme
+             ENDIF
+!$OMP      END CRITICAL(ARROW_ RECV_BUF_STATUS)
+          ENDIF
+         ENDIF
+        IF (STATE.NE.Treating) CYCLE
+        IF (NO_ATOMIC_Warrow) THEN
+          CALL DMUMPS_ARROW_TREAT_RECV_BUF_1TH()
+        ELSE
+          CALL DMUMPS_ARROW_TREAT_RECV_BUF()
+        ENDIF
+      ENDDO 
+      RETURN
+      CONTAINS
+      SUBROUTINE  DMUMPS_ARROW_TREAT_RECV_BUF()
+      INTEGER :: IREC, NB_REC, TYPE_NODE
+      INTEGER :: IPOSROOT, JPOSROOT, ILOCROOT, JLOCROOT
+      INTEGER(8) :: IS8
+      INTEGER    :: IARR, JARR, IW4_CAPTURED
+      INTEGER    :: NB_END_MSG_2_RECV_COPY
+      DOUBLE PRECISION    :: VAL
+      LOGICAL    :: LAST_MESSAGE
+      LAST_MESSAGE = .FALSE.
+      NB_REC = BUFRECVI( 1, ISLAVE )
+      TYPE_NODE = -998
+      IF ( NB_REC .LE. 0 ) THEN
+        LAST_MESSAGE = .TRUE.
+!$OMP ATOMIC CAPTURE
+        NB_END_MSG_2_RECV_COPY = NB_END_MSG_2_RECV
+        NB_END_MSG_2_RECV      = NB_END_MSG_2_RECV - 1   
+!$OMP END ATOMIC
+        NB_REC = - NB_REC
+      END IF
+      IF ( NB_REC .eq. 0 ) GOTO 100
+      DO IREC = 1, NB_REC
+        IARR = BUFRECVI( IREC * 2, ISLAVE )
+        JARR = BUFRECVI( IREC * 2 + 1, ISLAVE )
+        VAL  = BUFRECVR( IREC, ISLAVE )
+        IF (EARLYT3ROOTINS) THEN
+          TYPE_NODE = MUMPS_TYPENODE( 
+     &              PROCNODE_STEPS(abs(STEP(abs( IARR )))),
+     &              KEEP(199) )
+        ENDIF
+        IF ( TYPE_NODE .eq. 3 .AND. EARLYT3ROOTINS ) THEN
+          IF ( IARR .GT. 0 ) THEN
+            IPOSROOT = root%RG2L( IARR )
+            JPOSROOT = root%RG2L( JARR )
+          ELSE
+            IPOSROOT = root%RG2L( JARR )
+            JPOSROOT = root%RG2L( -IARR )
+          END IF
+          ILOCROOT = root%MBLOCK * ( ( IPOSROOT - 1 ) /
+     &                 ( root%MBLOCK * root%NPROW ) )
+     &               + mod( IPOSROOT - 1, root%MBLOCK ) + 1
+          JLOCROOT = root%NBLOCK * ( ( JPOSROOT - 1 ) /
+     &                 ( root%NBLOCK * root%NPCOL ) )
+     &               + mod( JPOSROOT - 1, root%NBLOCK ) + 1
+          IF (KEEP(60)==0) THEN
+!$OMP ATOMIC UPDATE
+            S( PTR_ROOT + int(JLOCROOT-1,8) * int(LOCAL_M,8)
+     &        + int(ILOCROOT-1,8)) =  S( PTR_ROOT
+     &        + int(JLOCROOT - 1,8) * int(LOCAL_M,8)
+     &        + int(ILOCROOT - 1,8) )
+     &      + VAL
+!$OMP END ATOMIC
+          ELSE
+!$OMP ATOMIC UPDATE
+            root%SCHUR_POINTER( int(JLOCROOT-1,8)
+     &                      * int(root%SCHUR_LLD,8)
+     &                      + int(ILOCROOT,8) )
+     &      = root%SCHUR_POINTER( int(JLOCROOT - 1,8)
+     &                      * int(root%SCHUR_LLD,8)
+     &                      + int(ILOCROOT,8))
+     &      + VAL
+!$OMP END ATOMIC
+          ENDIF
+        ELSE IF (IARR.GE.0) THEN
+          IF (IARR.EQ.JARR) THEN
+            IS8 = PTRAW(IARR)
+!$OMP ATOMIC UPDATE
+            DBLARR(IS8) = DBLARR(IS8) + VAL
+!$OMP END ATOMIC
+          ELSE
+!$OMP ATOMIC CAPTURE
+            IW4_CAPTURED= IW4(IARR,2)
+            IW4(IARR,2) = IW4(IARR,2) - 1
+!$OMP END ATOMIC
+            IS8         = PTRAW(IARR)+int(IW4_CAPTURED,8)
+            INTARR(IS8) = JARR
+            DBLARR(IS8) = VAL
+          ENDIF
+        ELSE
+          IARR         = -IARR
+!$OMP ATOMIC CAPTURE
+          IW4_CAPTURED   = IW4(IARR,1)
+          IW4(IARR,1)    = IW4(IARR,1) - 1
+!$OMP END ATOMIC
+          IS8          = PTRAW(IARR) + int(IW4_CAPTURED,8)
+          INTARR(IS8)  = JARR
+          DBLARR(IS8)  = VAL
+        ENDIF
+      ENDDO
+ 100  CONTINUE
+      IF (LAST_MESSAGE) THEN
+!$OMP ATOMIC WRITE
+         RECV_BUF_STATUS(ISLAVE) = Processed_IrecNotneeded
+!$OMP END ATOMIC
+      ELSE
+!$OMP ATOMIC WRITE
+         RECV_BUF_STATUS(ISLAVE) = Processed_IrecNeeded
+!$OMP END ATOMIC
+      ENDIF
+      RETURN
+      END SUBROUTINE  DMUMPS_ARROW_TREAT_RECV_BUF
+      SUBROUTINE  DMUMPS_ARROW_TREAT_RECV_BUF_1TH()
+      INTEGER :: IREC, NB_REC, TYPE_NODE
+      INTEGER :: IPOSROOT, JPOSROOT, ILOCROOT, JLOCROOT
+      INTEGER(8) :: IS8
+      INTEGER    :: IARR, JARR
+      INTEGER    :: NB_END_MSG_2_RECV_COPY
+      DOUBLE PRECISION    :: VAL
+      LOGICAL    :: LAST_MESSAGE
+      LAST_MESSAGE = .FALSE.
+      NB_REC = BUFRECVI( 1, ISLAVE )
+      IF ( NB_REC .LE. 0 ) THEN
+        LAST_MESSAGE = .TRUE.
+!$OMP ATOMIC CAPTURE
+        NB_END_MSG_2_RECV_COPY = NB_END_MSG_2_RECV
+        NB_END_MSG_2_RECV      = NB_END_MSG_2_RECV - 1   
+!$OMP END ATOMIC
+        NB_REC = - NB_REC
+      END IF 
+      IF ( NB_REC .eq. 0 ) GOTO 100
+      DO IREC = 1, NB_REC
+        IARR = BUFRECVI( IREC * 2, ISLAVE )
+        JARR = BUFRECVI( IREC * 2 + 1, ISLAVE )
+        VAL  = BUFRECVR( IREC, ISLAVE )
+        IF (EARLYT3ROOTINS) THEN
+          TYPE_NODE = MUMPS_TYPENODE( 
+     &              PROCNODE_STEPS(abs(STEP(abs( IARR )))),
+     &              KEEP(199) )
+        ENDIF
+        IF ( TYPE_NODE .eq. 3 .AND. EARLYT3ROOTINS ) THEN
+          IF ( IARR .GT. 0 ) THEN
+            IPOSROOT = root%RG2L( IARR )
+            JPOSROOT = root%RG2L( JARR )
+          ELSE
+            IPOSROOT = root%RG2L( JARR )
+            JPOSROOT = root%RG2L( -IARR )
+          END IF
+          ILOCROOT = root%MBLOCK * ( ( IPOSROOT - 1 ) /
+     &                 ( root%MBLOCK * root%NPROW ) )
+     &               + mod( IPOSROOT - 1, root%MBLOCK ) + 1
+          JLOCROOT = root%NBLOCK * ( ( JPOSROOT - 1 ) /
+     &                 ( root%NBLOCK * root%NPCOL ) )
+     &               + mod( JPOSROOT - 1, root%NBLOCK ) + 1
+          IF (KEEP(60)==0) THEN
+            S( PTR_ROOT + int(JLOCROOT-1,8) * int(LOCAL_M,8)
+     &        + int(ILOCROOT-1,8)) =  S( PTR_ROOT
+     &        + int(JLOCROOT - 1,8) * int(LOCAL_M,8)
+     &        + int(ILOCROOT - 1,8) )
+     &      + VAL
+          ELSE
+            root%SCHUR_POINTER( int(JLOCROOT-1,8)
+     &                      * int(root%SCHUR_LLD,8)
+     &                      + int(ILOCROOT,8) )
+     &      = root%SCHUR_POINTER( int(JLOCROOT - 1,8)
+     &                      * int(root%SCHUR_LLD,8)
+     &                      + int(ILOCROOT,8))
+     &      + VAL
+          ENDIF
+        ELSE IF (IARR.GE.0) THEN
+          IF (IARR.EQ.JARR) THEN
+            IS8 = PTRAW(IARR)
+            DBLARR(IS8) = DBLARR(IS8) + VAL
+          ELSE
+            IS8         = PTRAW(IARR)+IW4(IARR,2)
+            IW4(IARR,2) = IW4(IARR,2) - 1
+            INTARR(IS8) = JARR
+            DBLARR(IS8) = VAL
+          ENDIF
+        ELSE
+          IARR         = -IARR
+          IS8          = PTRAW(IARR)+IW4(IARR,1)
+          IW4(IARR,1)  = IW4(IARR,1) - 1
+          INTARR(IS8)  = JARR
+          DBLARR(IS8)  = VAL
+        ENDIF
+      ENDDO
+ 100  CONTINUE
+      IF (LAST_MESSAGE) THEN
+!$OMP ATOMIC WRITE
+         RECV_BUF_STATUS(ISLAVE) = Processed_IrecNotneeded
+!$OMP END ATOMIC
+      ELSE
+!$OMP ATOMIC WRITE
+         RECV_BUF_STATUS(ISLAVE) = Processed_IrecNeeded
+!$OMP END ATOMIC
+      ENDIF
+      RETURN
+      END SUBROUTINE  DMUMPS_ARROW_TREAT_RECV_BUF_1TH
+      END SUBROUTINE DMUMPS_ARROW_TRY_TREAT_RECV_BUF 
+      SUBROUTINE DMUMPS_FAC_ARROW_ARRANGE ( 
+     &  MYID, IOMP, N, SHIFT_PID, SLAVEF, LSCAL, NSEND8, NLOCAL8,
+     &  ILOC8_P, NB_RANGE_P, NZ_loc8, IRN_LOC, JCN_LOC, A_loc, SIZESCAL,
+     &  ROWSCA, COLSCA, ISTEP_TO_INIV2, CANDIDATES, KEEP, MPI_MASTER, 
+     &  NO_ATOMIC_Warrow, NO_ATOMIC_Wsendbuf, TH_InvolvedinTreatRecv,
+     &  NPROCS, NBRECORDS, MPI_InvolvedinSend, MPI_InvolvedinRecv,
+     &  COMM, ISENDREQI, ISENDREQR, BUFSENDI, BUFSENDR, IACT,
+     &  SEND_ACTIVE, BUFSEND_POSRESERVED, IRECVREQI, IRECVREQR,
+     &  BUFRECVI, BUFRECVR, RECV_BUF_STATUS, EndNZloc, MPI_End_Send,
+     &  End_TreatRecvBuf,
+     &  root, PTR_ROOT, ARROW_ROOT, EARLYT3ROOTINS, LOCAL_M, LOCAL_N,
+     &  S, LA, NB_END_MSG_2_RECV, PROCNODE_STEPS, IW4, PTRAW, 
+     &  PTR8ARR, NINCOLARR, NINROWARR, PTRDEBARR,
+     &  PERM, STEP, INTARR, LINTARR, DBLARR, LDBLARR, NOMP_SHARED )
+!$    USE OMP_LIB
+      USE DMUMPS_STRUC_DEF, ONLY : DMUMPS_ROOT_STRUC
+      IMPLICIT NONE
+      INTEGER, INTENT(IN)      :: MYID, IOMP, N, SHIFT_PID, 
+     &                            SLAVEF, SIZESCAL, MPI_MASTER
+      INTEGER, INTENT(IN)      :: NB_RANGE_P, KEEP(500)
+      INTEGER(8), INTENT(IN)   :: NZ_loc8, ILOC8_P
+      INTEGER(8), INTENT(INOUT):: NSEND8, NLOCAL8
+      INTEGER, INTENT(IN)      :: IRN_LOC(max(1_8,NZ_loc8)), 
+     &                            JCN_LOC(max(1_8,NZ_loc8))
+      INTEGER, INTENT(IN):: ISTEP_TO_INIV2(KEEP(71))
+      INTEGER, INTENT(IN):: CANDIDATES(SLAVEF+1, max(1,KEEP(56)))
+      DOUBLE PRECISION, INTENT(IN):: A_loc(max(1_8,NZ_loc8))
+      DOUBLE PRECISION, INTENT(IN)   :: ROWSCA(SIZESCAL),
+     &                      COLSCA(SIZESCAL)
+      LOGICAL, INTENT(IN):: NO_ATOMIC_Warrow, NO_ATOMIC_Wsendbuf, 
+     &                      TH_InvolvedinTreatRecv
+      INTEGER, INTENT(IN) :: NPROCS, NBRECORDS, COMM, NOMP_SHARED
+      LOGICAL, INTENT(IN) :: MPI_InvolvedinSend, MPI_InvolvedinRecv, 
+     &                       LSCAL
+      INTEGER, INTENT(INOUT) :: EndNZloc
+      LOGICAL, INTENT(INOUT) :: MPI_End_Send, End_TreatRecvBuf
+      INTEGER, INTENT(INOUT) :: ISENDREQI(NPROCS), ISENDREQR(NPROCS), 
+     &     BUFSENDI(NBRECORDS * 2 + 1, 2, NPROCS), 
+     &     IACT(NPROCS), BUFSEND_POSRESERVED(2,NPROCS)
+      DOUBLE PRECISION, INTENT(INOUT) :: BUFSENDR(NBRECORDS, 2, NPROCS)
+      LOGICAL, INTENT(INOUT) :: SEND_ACTIVE(NPROCS)
+      INTEGER, INTENT(INOUT) :: IRECVREQI(NPROCS), IRECVREQR(NPROCS), 
+     &     BUFRECVI(NBRECORDS * 2 + 1, NPROCS),
+     &     RECV_BUF_STATUS(NPROCS)
+      DOUBLE PRECISION, INTENT(INOUT) :: BUFRECVR(NBRECORDS, NPROCS)
+         INTEGER, PARAMETER :: Processed_IrecNeeded          = 1
+         INTEGER, PARAMETER :: IrecPosted                    = 2
+         INTEGER, PARAMETER :: Received_NotProcessed         = 3
+         INTEGER, PARAMETER :: Processed_IrecNotneeded       = 4
+         INTEGER, PARAMETER :: Treating                      = 5
+      TYPE (DMUMPS_ROOT_STRUC) :: root
+      INTEGER, INTENT(IN)      :: LOCAL_M, LOCAL_N
+      LOGICAL, INTENT(IN)      :: EARLYT3ROOTINS
+      INTEGER, INTENT(INOUT)   :: ARROW_ROOT
+      INTEGER, INTENT(INOUT):: IW4( N, 2 )
+      INTEGER, INTENT(INOUT):: NB_END_MSG_2_RECV
+      INTEGER(8), INTENT(IN) :: PTRAW( N )
+      INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
+      INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
+      INTEGER, INTENT(IN) :: NINROWARR(KEEP(195))
+      INTEGER, INTENT(IN) :: PTRDEBARR(KEEP(196))
+      INTEGER, INTENT(IN) :: PERM( N ), STEP( N )
+      INTEGER, INTENT(IN) :: PROCNODE_STEPS( KEEP(28) )
+      INTEGER(8), INTENT(IN) :: LINTARR, LDBLARR
+      INTEGER, INTENT(INOUT) ::  INTARR( LINTARR )
+      INTEGER(8), INTENT(IN) :: PTR_ROOT, LA
+      DOUBLE PRECISION, INTENT(INOUT) ::  S( LA ), DBLARR( LDBLARR )
+      INTEGER MUMPS_TYPESPLIT
+      EXTERNAL MUMPS_TYPESPLIT
+      INTEGER     :: DEST, JSEND, ISEND , DEST_SAVE
+      INTEGER     :: I, INIV2, NCAND, T4MASTER
+      INTEGER     :: IOLD, JOLD, IARR, TYPESPLIT
+      INTEGER(8)  :: IS8, IZ8, LAST8
+      LOGICAL     :: T4_MASTER_CONCERNED
+      INTEGER     :: MASTER_NODE, TYPE_NODE, ISTEP_P
+      INTEGER     :: IPOSROOT, JPOSROOT, ILOCROOT, JLOCROOT
+      INTEGER     :: IROW_GRID, JCOL_GRID, IW4_CAPTURED
+      LOGICAL     :: LOCAL_ASSEMBLY, LOCAL
+      DOUBLE PRECISION     :: VAL
+      INTEGER     :: ISTEP_T3_1PROC
+      LAST8 = ILOC8_P + int(NB_RANGE_P-1,8)
+      LOCAL_ASSEMBLY  =  (NPROCS.EQ.1)
+      IF (NPROCS.EQ.1 .AND. KEEP(38).EQ.0) THEN
+        TYPE_NODE = 1
+        ISTEP_T3_1PROC  = -9999
+      ELSE IF (NPROCS.EQ.1 .AND. KEEP(38).NE.0) THEN
+        ISTEP_T3_1PROC = STEP(KEEP(38))
+      ELSE
+        ISTEP_T3_1PROC = -99999
+      ENDIF
+      DO IZ8=ILOC8_P, LAST8
+          IOLD = IRN_loc(IZ8)
+          JOLD = JCN_loc(IZ8)
+          IF ( (IOLD.GT.N).OR.(JOLD.GT.N).OR.(IOLD.LT.1)
+     &                 .OR.(JOLD.LT.1) ) THEN
+            CYCLE
+          ENDIF
+          IF (IOLD.EQ.JOLD) THEN
+            ISEND = IOLD
+            JSEND = IOLD
+            IARR  = IOLD
+          ELSE IF (PERM(IOLD).LT.PERM(JOLD)) THEN
+            IARR  = IOLD
+            IF ( KEEP(50) .NE. 0 ) THEN
+              ISEND = -IOLD
+            ELSE
+              ISEND = IOLD
+            ENDIF
+            JSEND = JOLD
+          ELSE
+            IARR  = JOLD
+            ISEND = -JOLD
+            JSEND = IOLD
+          ENDIF
+          VAL = A_loc(IZ8)
+          IF (LSCAL) THEN
+            VAL = VAL * ROWSCA(IOLD)*COLSCA(JOLD)
+          ENDIF
+          IF (NPROCS.GT.1 .OR. KEEP(38).NE.0) THEN
+            ISTEP_P = abs(STEP(IARR))
+            IF ( NPROCS.EQ.1 .AND. ISTEP_P.NE.ISTEP_T3_1PROC ) THEN
+              TYPE_NODE=1
+            ELSE IF (NPROCS.EQ.1) THEN
+              TYPE_NODE=3
+              IF (EARLYT3ROOTINS) THEN
+                IF ( ISEND < 0 ) THEN
+                  IPOSROOT = root%RG2L(JSEND)
+                  JPOSROOT = root%RG2L(IARR )
+                ELSE
+                  IPOSROOT = root%RG2L(IARR )
+                  JPOSROOT = root%RG2L(JSEND)
+                END IF
+              END IF
+            ELSE
+            ISTEP_P = abs(STEP(IARR))
+            CALL MUMPS_TYPEANDPROCNODE( TYPE_NODE, MASTER_NODE,
+     &      PROCNODE_STEPS(ISTEP_P), KEEP(199) )
+            MASTER_NODE = MASTER_NODE + SHIFT_PID
+            T4_MASTER_CONCERNED = .FALSE.
+            T4MASTER            = -9999
+            IF ( TYPE_NODE .eq. 1 ) THEN
+              DEST = MASTER_NODE
+            ELSE IF ( TYPE_NODE .eq. 2 ) THEN
+              IF ( ISEND .LT. 0 ) THEN
+                DEST = -1
+              ELSE
+                DEST = MASTER_NODE
+              END IF
+              INIV2         = ISTEP_TO_INIV2(ISTEP_P)
+              IF ( KEEP(79) .GT. 0) THEN
+                TYPESPLIT  = MUMPS_TYPESPLIT( PROCNODE_STEPS(ISTEP_P),
+     &                                        KEEP(199) )
+                IF ( (TYPESPLIT.EQ.5).OR.(TYPESPLIT.EQ.6)) THEN
+                  T4_MASTER_CONCERNED = .TRUE.
+                  T4MASTER=
+     &                   CANDIDATES(CANDIDATES(SLAVEF+1,INIV2)+1,INIV2)
+     &                 + SHIFT_PID
+                ENDIF
+              ENDIF
+            ELSE 
+              ARROW_ROOT = ARROW_ROOT + 1
+              IF (EARLYT3ROOTINS) THEN
+                IF ( ISEND < 0 ) THEN
+                  IPOSROOT = root%RG2L(JSEND)
+                  JPOSROOT = root%RG2L(IARR )
+                ELSE
+                  IPOSROOT = root%RG2L(IARR )
+                  JPOSROOT = root%RG2L(JSEND)
+                END IF
+                IROW_GRID = mod( ( IPOSROOT-1 )/root%MBLOCK, root%NPROW)
+                JCOL_GRID = mod( ( JPOSROOT-1 )/root%NBLOCK, root%NPCOL)
+                DEST = IROW_GRID * root%NPCOL + JCOL_GRID + SHIFT_PID
+              ELSE
+                DEST = -2
+              ENDIF
+            ENDIF
+            IF (DEST .eq. -1) THEN
+              NLOCAL8 = NLOCAL8 + 1_8
+              NSEND8  = NSEND8 + int(SLAVEF -1,8)
+            ELSE IF (DEST .EQ. -2) THEN
+              NLOCAL8 = NLOCAL8 + 1_8
+              NSEND8  = NSEND8 + int(SLAVEF -1,8)
+            ELSE
+              IF (DEST .eq.MYID ) THEN
+                NLOCAL8 = NLOCAL8 + 1_8
+              ELSE
+                NSEND8 = NSEND8 + 1_8
+              ENDIF
+            ENDIF
+            LOCAL_ASSEMBLY = .FALSE.
+            IF ( DEST.EQ.-1) THEN
+              INIV2 = ISTEP_TO_INIV2(ISTEP_P)
+              NCAND = CANDIDATES(SLAVEF+1,INIV2)
+              IF (KEEP(79) .GT. 0) THEN
+                DO I=1, SLAVEF
+                  DEST=CANDIDATES(I,INIV2) + SHIFT_PID
+                  IF (DEST.LT.0) EXIT 
+                  LOCAL = (DEST.EQ.MYID)
+                  IF (LOCAL) LOCAL_ASSEMBLY = .TRUE.
+                  IF (LOCAL) CYCLE
+                  IF (I.EQ.NCAND+1) CYCLE
+                  CALL DMUMPS_DIST_FILL_SEND_BUFFER()
+                ENDDO
+              ELSE
+                DO I=1, NCAND
+                  DEST=CANDIDATES(I,INIV2) + SHIFT_PID
+                  LOCAL = (DEST.EQ.MYID)
+                  IF (LOCAL) LOCAL_ASSEMBLY = .TRUE.
+                  IF (LOCAL) CYCLE
+                  CALL DMUMPS_DIST_FILL_SEND_BUFFER()
+                ENDDO
+              ENDIF
+              IF ( LOCAL_ASSEMBLY ) THEN
+                DEST_SAVE = DEST
+                DEST      = MASTER_NODE
+                IF (DEST.NE.MYID)
+     &           CALL DMUMPS_DIST_FILL_SEND_BUFFER()
+                IF (T4_MASTER_CONCERNED) THEN
+                  DEST   = T4MASTER
+                  IF (DEST.NE.MYID)
+     &             CALL DMUMPS_DIST_FILL_SEND_BUFFER()
+                ENDIF
+                DEST = DEST_SAVE
+              ELSE
+                DEST=MASTER_NODE
+                LOCAL_ASSEMBLY = (DEST.EQ.MYID)
+                IF (.NOT.LOCAL_ASSEMBLY) 
+     &           CALL DMUMPS_DIST_FILL_SEND_BUFFER()
+                IF (T4_MASTER_CONCERNED) THEN
+                  DEST = T4MASTER
+                  LOCAL_ASSEMBLY = (DEST.EQ.MYID)
+                  IF (.NOT.LOCAL_ASSEMBLY) 
+     &             CALL DMUMPS_DIST_FILL_SEND_BUFFER()
+                ENDIF
+              ENDIF
+            ELSE IF (DEST .GE. 0) THEN
+              LOCAL_ASSEMBLY = (DEST.EQ.MYID)
+              IF (.NOT.LOCAL_ASSEMBLY) 
+     &             CALL DMUMPS_DIST_FILL_SEND_BUFFER()
+              IF (T4_MASTER_CONCERNED) THEN
+                DEST = T4MASTER
+                LOCAL_ASSEMBLY = (DEST.EQ.MYID)
+                IF (.NOT.LOCAL_ASSEMBLY) 
+     &             CALL DMUMPS_DIST_FILL_SEND_BUFFER()
+              ENDIF
+            ELSE IF (DEST .EQ. -2) THEN
+              DO I = 0, SLAVEF-1
+                DEST=I + SHIFT_PID
+                IF (DEST.NE.MYID) 
+     &             CALL DMUMPS_DIST_FILL_SEND_BUFFER()
+              ENDDO
+              IF (SHIFT_PID.EQ.1.AND.MYID.EQ.MPI_MASTER) THEN
+                LOCAL_ASSEMBLY=.FALSE.
+              ELSE
+                LOCAL_ASSEMBLY=.TRUE. 
+              ENDIF
+            ENDIF
+          ENDIF
+          ENDIF
+          IF (LOCAL_ASSEMBLY) THEN
+            IF ( TYPE_NODE .eq. 3 .AND. EARLYT3ROOTINS ) THEN
+              ILOCROOT = root%MBLOCK * ( ( IPOSROOT - 1 ) /
+     &                     ( root%MBLOCK * root%NPROW ) )
+     &                   + mod( IPOSROOT - 1, root%MBLOCK ) + 1
+              JLOCROOT = root%NBLOCK * ( ( JPOSROOT - 1 ) /
+     &                     ( root%NBLOCK * root%NPCOL ) )
+     &                   + mod( JPOSROOT - 1, root%NBLOCK ) + 1
+              IF (KEEP(60)==0) THEN
+!$OMP ATOMIC UPDATE
+                S( PTR_ROOT + int(JLOCROOT-1,8) * int(LOCAL_M,8)
+     &            + int(ILOCROOT-1,8)) =  S( PTR_ROOT
+     &            + int(JLOCROOT - 1,8) * int(LOCAL_M,8)
+     &            + int(ILOCROOT - 1,8) )
+     &          + VAL
+!$OMP END ATOMIC
+              ELSE
+!$OMP ATOMIC UPDATE
+                root%SCHUR_POINTER( int(JLOCROOT-1,8)
+     &                          * int(root%SCHUR_LLD,8)
+     &                          + int(ILOCROOT,8) )
+     &          = root%SCHUR_POINTER( int(JLOCROOT - 1,8)
+     &                          * int(root%SCHUR_LLD,8)
+     &                          + int(ILOCROOT,8))
+     &          + VAL
+!$OMP END ATOMIC
+              ENDIF
+            ELSE
+      IF (NO_ATOMIC_Warrow) THEN
+             IF (ISEND.EQ.JSEND) THEN
+               IS8         = PTRAW(ISEND)
+               DBLARR(IS8) = DBLARR(IS8) + VAL
+             ELSE IF (ISEND.GE.0) THEN 
+               IS8         = PTRAW(IARR)+IW4(IARR,2)
+               IW4(IARR,2) = IW4(IARR,2) - 1
+               INTARR(IS8) = JSEND
+               DBLARR(IS8) = VAL
+             ELSE 
+               IS8         = PTRAW(IARR)+IW4(IARR,1)
+               IW4(IARR,1) = IW4(IARR,1) - 1
+               INTARR(IS8) = JSEND
+               DBLARR(IS8) = VAL
+             ENDIF
+      ELSE
+             IF (ISEND.EQ.JSEND) THEN
+               IS8         = PTRAW(ISEND)
+!$OMP ATOMIC UPDATE
+               DBLARR(IS8) = DBLARR(IS8) + VAL
+!$OMP END ATOMIC
+             ELSE IF (ISEND.GE.0) THEN 
+!$OMP ATOMIC CAPTURE
+               IW4_CAPTURED = IW4(IARR,2)
+               IW4(IARR,2)  = IW4(IARR,2) - 1
+!$OMP END ATOMIC
+               IS8         = PTRAW(IARR) + int(IW4_CAPTURED,8)
+               INTARR(IS8) = JSEND
+               DBLARR(IS8) = VAL
+             ELSE 
+!$OMP ATOMIC CAPTURE
+               IW4_CAPTURED = IW4(IARR,1)
+               IW4(IARR,1)  = IW4(IARR,1) - 1
+!$OMP END ATOMIC
+               IS8         = PTRAW(IARR) + int(IW4_CAPTURED,8)
+               INTARR(IS8) = JSEND
+               DBLARR(IS8) = VAL
+             ENDIF
+      ENDIF
+            ENDIF
+          ENDIF
+      ENDDO
+      RETURN
+      CONTAINS
+      SUBROUTINE DMUMPS_DIST_FILL_SEND_BUFFER( )
+      INTEGER IREQ, IACT_P, ISLAVE
+      ISLAVE = DEST+1
+ 100  CONTINUE
+!$OMP ATOMIC READ
+      IACT_P = IACT(ISLAVE)
+!$OMP END ATOMIC
+      IF (NO_ATOMIC_Wsendbuf) THEN
+        BUFSEND_POSRESERVED(IACT_P,ISLAVE) = 
+     &         BUFSEND_POSRESERVED(IACT_P, ISLAVE) + 1
+        IREQ = BUFSEND_POSRESERVED(IACT_P, ISLAVE)
+       IF (IREQ > NBRECORDS ) THEN
+         IF (IREQ > huge(NBRECORDS)-1000 - NOMP_SHARED-2) THEN
+          BUFSEND_POSRESERVED(IACT_P, ISLAVE) =  min(NBRECORDS+1, 
+     &                     BUFSEND_POSRESERVED(IACT_P, ISLAVE) )
+         ENDIF
+           IF (NOMP_SHARED.EQ.1)
+     &      CALL DMUMPS_ARROW_TRY_PROGRESS_COMM (IOMP,
+     &       MYID, NPROCS, NBRECORDS, 
+     &       MPI_InvolvedinSend, MPI_InvolvedinRecv, 
+     &       COMM, ISENDREQI, ISENDREQR, BUFSENDI, BUFSENDR, 
+     &       IACT, SEND_ACTIVE, BUFSEND_POSRESERVED, 
+     &       IRECVREQI, IRECVREQR, BUFRECVI, BUFRECVR,
+     &       RECV_BUF_STATUS, NB_END_MSG_2_RECV, 
+     &       EndNZloc, MPI_End_Send, End_TreatRecvBuf
+     &       )
+          IF (TH_InvolvedinTreatRecv) 
+     &    CALL DMUMPS_ARROW_TRY_TREAT_RECV_BUF (IOMP,
+     &             BUFRECVI, BUFRECVR, RECV_BUF_STATUS, 
+     &             NPROCS, NBRECORDS, N, IW4,
+     &             KEEP, LOCAL_M, LOCAL_N, root, PTR_ROOT, S, LA,
+     &             NB_END_MSG_2_RECV, MYID, PROCNODE_STEPS,
+     &             SLAVEF,
+     &             PTRAW, 
+     &             PTR8ARR, NINCOLARR, NINROWARR, PTRDEBARR,
+     &             PERM, STEP,
+     &             INTARR, LINTARR, DBLARR, LDBLARR, 
+     &             NOMP_SHARED, EARLYT3ROOTINS, NO_ATOMIC_Warrow)
+           IF (NOMP_SHARED.EQ.1) THEN
+             CALL DMUMPS_ARROW_TRY_PROGRESS_COMM (IOMP,
+     &        MYID, NPROCS, NBRECORDS, 
+     &        MPI_InvolvedinSend, MPI_InvolvedinRecv, 
+     &        COMM, ISENDREQI, ISENDREQR, BUFSENDI, BUFSENDR, 
+     &        IACT, SEND_ACTIVE, BUFSEND_POSRESERVED, 
+     &        IRECVREQI, IRECVREQR, BUFRECVI, BUFRECVR,
+     &        RECV_BUF_STATUS, NB_END_MSG_2_RECV, 
+     &        EndNZloc, MPI_End_Send, End_TreatRecvBuf
+     &        )
+           ELSE
+              IF (.NOT.TH_InvolvedinTreatRecv) THEN
+               CALL MUMPS_USLEEP(200)
+              ELSE
+               CALL MUMPS_USLEEP(20)
+              ENDIF
+           ENDIF
+         GOTO 100
+       ENDIF
+       BUFSENDI(IREQ*2,IACT_P,ISLAVE)   = ISEND
+       BUFSENDI(IREQ*2+1,IACT_P,ISLAVE) = JSEND
+       BUFSENDR(IREQ,IACT_P,ISLAVE )    = VAL
+       IF (IREQ.EQ.NBRECORDS) THEN
+!$OMP    ATOMIC WRITE
+            BUFSENDI(1,IACT_P,ISLAVE) = NBRECORDS
+!$OMP    END ATOMIC 
+       ENDIF
+      ELSE
+!$OMP  ATOMIC CAPTURE
+       BUFSEND_POSRESERVED(IACT_P,ISLAVE) = 
+     &         BUFSEND_POSRESERVED(IACT_P, ISLAVE) + 1
+       IREQ = BUFSEND_POSRESERVED(IACT_P, ISLAVE)
+!$OMP  END ATOMIC
+       IF (IREQ > huge(NBRECORDS)-NOMP_SHARED-2) THEN
+!$OMP   ATOMIC UPDATE
+        BUFSEND_POSRESERVED(IACT_P, ISLAVE) =  min(NBRECORDS+1, 
+     &                     BUFSEND_POSRESERVED(IACT_P, ISLAVE) )
+!$OMP   END ATOMIC
+       ENDIF
+       IF (IREQ > NBRECORDS ) THEN
+          IF (NOMP_SHARED.EQ.1) THEN
+            CALL DMUMPS_ARROW_TRY_PROGRESS_COMM (IOMP,
+     &       MYID, NPROCS, NBRECORDS, 
+     &       MPI_InvolvedinSend, MPI_InvolvedinRecv, 
+     &       COMM, ISENDREQI, ISENDREQR, BUFSENDI, BUFSENDR, 
+     &       IACT, SEND_ACTIVE, BUFSEND_POSRESERVED, 
+     &       IRECVREQI, IRECVREQR, BUFRECVI, BUFRECVR,
+     &       RECV_BUF_STATUS, NB_END_MSG_2_RECV, 
+     &       EndNZloc, MPI_End_Send, End_TreatRecvBuf
+     &       )
+          ENDIF
+          IF (TH_InvolvedinTreatRecv) 
+     &    CALL DMUMPS_ARROW_TRY_TREAT_RECV_BUF (IOMP,
+     &             BUFRECVI, BUFRECVR, RECV_BUF_STATUS, 
+     &             NPROCS, NBRECORDS, N, IW4,
+     &             KEEP, LOCAL_M, LOCAL_N, root, PTR_ROOT, S, LA,
+     &             NB_END_MSG_2_RECV, MYID, PROCNODE_STEPS,
+     &             SLAVEF,
+     &             PTRAW, 
+     &             PTR8ARR, NINCOLARR, NINROWARR, PTRDEBARR,
+     &             PERM, STEP,
+     &             INTARR, LINTARR, DBLARR, LDBLARR, 
+     &             NOMP_SHARED, EARLYT3ROOTINS, NO_ATOMIC_Warrow)
+          IF (NOMP_SHARED.EQ.1) THEN
+             CALL DMUMPS_ARROW_TRY_PROGRESS_COMM (IOMP,
+     &        MYID, NPROCS, NBRECORDS, 
+     &        MPI_InvolvedinSend, MPI_InvolvedinRecv, 
+     &        COMM, ISENDREQI, ISENDREQR, BUFSENDI, BUFSENDR, 
+     &        IACT, SEND_ACTIVE, BUFSEND_POSRESERVED, 
+     &        IRECVREQI, IRECVREQR, BUFRECVI, BUFRECVR,
+     &        RECV_BUF_STATUS, NB_END_MSG_2_RECV, 
+     &        EndNZloc, MPI_End_Send, End_TreatRecvBuf
+     &        )
+          ELSE 
+            IF (.NOT.TH_InvolvedinTreatRecv) THEN
+             CALL MUMPS_USLEEP(200)
+            ELSE
+             CALL MUMPS_USLEEP(20)
+            ENDIF
+          ENDIF
+         GOTO 100
+         ENDIF
+         BUFSENDI(IREQ*2,IACT_P,ISLAVE)   = ISEND
+         BUFSENDI(IREQ*2+1,IACT_P,ISLAVE) = JSEND
+         BUFSENDR(IREQ,IACT_P,ISLAVE )    = VAL
+!$OMP    ATOMIC UPDATE
+         BUFSENDI(1,IACT_P,ISLAVE) = BUFSENDI(1,IACT_P,ISLAVE) + 1
+!$OMP    END ATOMIC 
+      ENDIF
+      RETURN
+      END SUBROUTINE DMUMPS_DIST_FILL_SEND_BUFFER
+      END SUBROUTINE DMUMPS_FAC_ARROW_ARRANGE
+#endif
diff -pruN 5.6.2-2.1/src/dfac_distrib_ELT.F 5.7.1-1/src/dfac_distrib_ELT.F
--- 5.6.2-2.1/src/dfac_distrib_ELT.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_distrib_ELT.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -38,8 +38,6 @@ C
       DOUBLE PRECISION A( LA )
       TYPE(DMUMPS_STRUC)     :: id
       TYPE(DMUMPS_ROOT_STRUC) :: root
-      INTEGER numroc
-      EXTERNAL numroc
       INCLUDE 'mpif.h'
       INCLUDE 'mumps_tags.h'
       INTEGER :: IERR_MPI
diff -pruN 5.6.2-2.1/src/dfac_distrib_distentry.F 5.7.1-1/src/dfac_distrib_distentry.F
--- 5.6.2-2.1/src/dfac_distrib_distentry.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_distrib_distentry.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -126,10 +126,8 @@ C
       TYPE (DMUMPS_ROOT_STRUC) :: root
       INTEGER PROCNODE_STEPS(KEEP(28)), PERM( N ), STEP( N )
       INTEGER INFO( 80 ), ICNTL(60)
-      INTEGER MUMPS_PROCNODE, MUMPS_TYPENODE, numroc, 
-     &        MUMPS_TYPESPLIT
-      EXTERNAL MUMPS_PROCNODE, MUMPS_TYPENODE, numroc, 
-     &        MUMPS_TYPESPLIT
+      INTEGER MUMPS_TYPESPLIT
+      EXTERNAL MUMPS_TYPESPLIT
       INCLUDE 'mumps_tags.h'
       INCLUDE 'mpif.h'
       INTEGER :: IERR, MSGSOU
@@ -626,6 +624,7 @@ C
       KEEP(49) = ARROW_ROOT
  100  CONTINUE
       IF (ALLOCATED(IW4))     DEALLOCATE( IW4 )
+      IF (ALLOCATED(PTRAW))   DEALLOCATE( PTRAW )
       IF (ALLOCATED(BUFI))    DEALLOCATE( BUFI )
       IF (ALLOCATED(BUFR))    DEALLOCATE( BUFR )
       IF (ALLOCATED(BUFRECI)) DEALLOCATE( BUFRECI )
diff -pruN 5.6.2-2.1/src/dfac_driver.F 5.7.1-1/src/dfac_driver.F
--- 5.6.2-2.1/src/dfac_driver.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/dfac_driver.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -137,8 +137,9 @@ C     (pointer to point on used-data in
       LOGICAL, PARAMETER :: BDUMMY =.FALSE.
       INTEGER, PARAMETER :: PANEL_TABSIZE = 20
       INTEGER COLOUR, COMM_FOR_SCALING ! For Simultaneous scaling
-      INTEGER LIWK, LWK_REAL
-      INTEGER(8) :: LWK
+      INTEGER(8) :: LIWK
+      INTEGER(8) :: LWK, LWK_REAL, LWRKR_TH, LWRKC_TH
+      INTEGER    :: NOMP_MAX
 C     I_AM_SLAVE: used to determine if proc has the role of a slave
 C     WK_USER_PROVIDED is set to true when WK_USER is provided by user
       LOGICAL I_AM_SLAVE, PERLU_ON, WK_USER_PROVIDED, EARLYT3ROOTINS
@@ -154,6 +155,7 @@ C     WK_USER_PROVIDED is set to true wh
 C temporary variables for collecting stats from all processors
       DOUBLE PRECISION :: TMP_MRY_LU_FR
       DOUBLE PRECISION :: TMP_MRY_LU_LRGAIN
+      INTEGER :: KEEP399_SAVE
       DOUBLE PRECISION :: TMP_MRY_CB_FR
       DOUBLE PRECISION :: TMP_MRY_CB_LRGAIN
       DOUBLE PRECISION :: TMP_FLOP_LRGAIN
@@ -203,18 +205,21 @@ C temporary variables for collecting sta
       DOUBLE PRECISION :: TMP_TIME_FRASM_MAPLIG1
       DOUBLE PRECISION :: TMP_TIME_FRASM_CONTRIB2
 C
-C  Workspace.
+C  Workspace
 C
       INTEGER, DIMENSION(:), ALLOCATABLE :: IWK
       DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE :: WK
-      DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE :: WK_REAL
+      DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE    :: WK_REAL
+      DOUBLE PRECISION, DIMENSION(:,:), ALLOCATABLE:: WRKR_TH, 
+     &                                    WRKC_TH
       INTEGER(8), DIMENSION(:), ALLOCATABLE :: IWK8
       INTEGER, DIMENSION(:), ALLOCATABLE :: BURP
       INTEGER, DIMENSION(:), ALLOCATABLE :: BUCP
       INTEGER, DIMENSION(:), ALLOCATABLE :: BURS
       INTEGER, DIMENSION(:), ALLOCATABLE :: BUCS
-      INTEGER BUREGISTRE(12)
-      INTEGER BUINTSZ, BURESZ, BUJOB
+      INTEGER(8) :: BUREGISTRE(12)
+      INTEGER(8) :: BUINTSZ, BURESZ, NZ_loc8
+      INTEGER    :: BUJOB
       INTEGER BUMAXMN, M, SCMYID, SCNPROCS
       DOUBLE PRECISION    SCONEERR, SCINFERR
 C
@@ -224,21 +229,23 @@ C
 *     Control parameters: see description in DMUMPSID
       DOUBLE PRECISION,DIMENSION(:),POINTER::RINFO, RINFOG
       DOUBLE PRECISION,DIMENSION(:),POINTER::    CNTL
-      INTEGER,DIMENSION(:),POINTER:: INFOG, KEEP
-      INTEGER, DIMENSION(:), POINTER :: MYIRN_loc, MYJCN_loc
-      DOUBLE PRECISION, DIMENSION(:), POINTER :: MYA_loc
+      INTEGER,DIMENSION(:),POINTER   :: INFOG, KEEP
+      INTEGER, DIMENSION(:), POINTER :: IRN_loc_PTR, JCN_loc_PTR
+      DOUBLE PRECISION, DIMENSION(:), POINTER   :: COLSCA_PTR, 
+     &                                 ROWSCA_PTR
+      DOUBLE PRECISION, DIMENSION(:), POINTER:: A_loc_PTR
       INTEGER, TARGET :: DUMMYIRN_loc(1), DUMMYJCN_loc(1)
+      DOUBLE PRECISION, TARGET    :: DUMMYSCA(1)
       DOUBLE PRECISION, TARGET :: DUMMYA_loc(1)
       INTEGER,DIMENSION(:),POINTER::ICNTL
       EXTERNAL MUMPS_GET_POOL_LENGTH
-      INTEGER MUMPS_GET_POOL_LENGTH
+      INTEGER MUMPS_GET_POOL_LENGTH, SIZESCAL
       INTEGER(8) :: TOTAL_BYTES
       INTEGER(8) :: I8TMP, LWK_USER_SUM8
 C
 C  External references
 C  ===================
-      INTEGER numroc
-      EXTERNAL numroc
+      INTEGER, EXTERNAL :: MUMPS_NUMROC
       INTEGER:: NWORKING
       LOGICAL:: MEM_EFF_ALLOCATED
       INTEGER   :: TOTAL_MBYTES_UNDER_L0
@@ -260,13 +267,13 @@ C     --------------------------
       KEEP=>id%KEEP
       ICNTL=>id%ICNTL
       IF (id%KEEP8(29) .NE. 0) THEN
-        MYIRN_loc=>id%IRN_loc
-        MYJCN_loc=>id%JCN_loc
-        MYA_loc=>id%A_loc
+        IRN_loc_PTR=>id%IRN_loc
+        JCN_loc_PTR=>id%JCN_loc
+        A_loc_PTR=>id%A_loc
       ELSE
-        MYIRN_loc=>DUMMYIRN_loc
-        MYJCN_loc=>DUMMYJCN_loc
-        MYA_loc=>DUMMYA_loc
+        IRN_loc_PTR=>DUMMYIRN_loc
+        JCN_loc_PTR=>DUMMYJCN_loc
+        A_loc_PTR=>DUMMYA_loc
       ENDIF
       NOMP = 1 
       N = id%N
@@ -295,13 +302,6 @@ C     Number of symmetric swaps
       id%KEEP8(80)=0_8
 C     Largest increase of internal panel size
       id%KEEP(425) =0
-C     and KEEP8(83) to the ddress of ICNTL(50)
-C     Set KEEP8(84) to the address of RINFO(3)
-      IF (id%KEEP(500) .EQ. 0 ) THEN ! MUMPS called from Fortran
-        CALL MUMPS_ADDR_C( ICNTL(50), id%KEEP8(83) )
-        CALL MUMPS_ADDR_C( RINFO (3), id%KEEP8(84) )
-      ENDIF
-C
       PRINT_MAXAVG = .NOT.(id%NSLAVES.EQ.1 .AND. KEEP(46).EQ.1)
 C     Print per node informtation only in case ther are several
 C     compute nodes (id%KEEP(412): #MPI procs on comupte node)
@@ -451,15 +451,19 @@ C       For symmetric (non general) matr
 C       set (directly) CNTL1 = 0.0
 C       ---------------------------------------
         KEEP(17)=0
-        IF ( KEEP(50) .eq. 1 ) THEN
-          IF (CNTL1 .ne. ZERO ) THEN
-            IF ( PROKG ) THEN
-              WRITE(MPG,'(A)')
-     & '** Warning : SPD solver called, resetting CNTL(1) to 0.0D0'
-            END IF
-          END IF
-          CNTL1 = ZERO
-        END IF
+C       Automatic choice if CNTL(1)<0
+C       For rank-revealing (KEEP(19).GT.0) then
+C       set CNTL1=0.1 even if SYM=1 
+        IF (CNTL1.LT.ZERO) THEN
+C        automatic choice
+         IF (KEEP(19).GT.0) THEN
+          CNTL1=0.1D0
+         ELSE IF (KEEP(50).EQ.1) THEN
+          CNTL1=ZERO
+         ELSE
+          CNTL1=0.01D0
+         ENDIF
+        ENDIF
 C       CNTL1 threshold value must be between 
 C       0.0 and 1.0 (for SYM=0) and 0.5 (for SYM=1,2)
         IF (CNTL1.GT.ONE)   CNTL1=ONE
@@ -482,7 +486,7 @@ C        out of range values
          PARPIV_T1 =0
         ENDIF
 C       note that KEEP(50).EQ.1 => CNTL1=0.0
-        IF (CNTL1.EQ.0.0.OR.(KEEP(50).eq.1)) PARPIV_T1 = 0 
+        IF (CNTL1.EQ.0.0D0.OR.(KEEP(50).eq.1)) PARPIV_T1 = 0 
 C
         IF (PARPIV_T1.EQ.-2) THEN
          IF (KEEP(19).NE.0) THEN
@@ -498,6 +502,22 @@ C         but do NOT switch off PARPIV_1
         CALL MPI_BCAST( KEEP(269), 1, MPI_INTEGER,
      &                  MASTER, id%COMM, IERR )
         IF (id%MYID.EQ.MASTER) THEN
+C{
+C         OMP parallelization of arrowheads
+C         out of range are treated as zero
+          IF (KEEP(399).LT.-1) KEEP(399)=-1
+          KEEP399_SAVE = KEEP(399)
+          IF (KEEP(399).EQ.-1) THEN
+            IF ((KEEP(54).EQ.0).AND.(id%NPROCS.GT.1)) THEN
+              KEEP(399) = 1
+            ELSE
+              KEEP(399) = 3
+            ENDIF
+          ENDIF
+#if defined(PCPRET)
+C         new multithreaded >=2 algo does not compile on PCPRET
+          KEEP(399) = 1
+#endif
 C         -----------------------------------------------------
 C         Decoding of ICNTL(35) for factorization: same as
 C         at analysis except that we store a copy of ICNTL(35)
@@ -628,11 +648,16 @@ C             Reset to 3 if 5 or to 4 if
             ENDIF
           ENDIF
  105    CONTINUE
+C}
         ENDIF  ! id%MYID .EQ. MASTER
         CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                        id%COMM, id%MYID )
 C
         IF (id%INFO(1).LT.0) GOTO 530
+        CALL MPI_BCAST( KEEP(281), 1, MPI_INTEGER,
+     &                  MASTER, id%COMM, IERR )
+        CALL MPI_BCAST( KEEP(399), 1, MPI_INTEGER,
+     &                  MASTER, id%COMM, IERR )
         CALL MPI_BCAST( KEEP(473), 14, MPI_INTEGER,
      &                  MASTER, id%COMM, IERR )
         IF (KEEP(486).NE.0) THEN
@@ -669,6 +694,8 @@ C         -- Low Level I/O strategy
      &                  MASTER, id%COMM, IERR )
           CALL MPI_BCAST( KEEP(211), 1, MPI_INTEGER,
      &                  MASTER, id%COMM, IERR )
+          CALL MPI_BCAST( KEEP(255), 1, MPI_INTEGER,
+     &                  MASTER, id%COMM, IERR )
         ENDIF
 C     Fwd in facto: explicitly forbid
 C     sparse RHS and A-1 computation
@@ -832,7 +859,7 @@ C       -- More expensive setting of SIM
 C
         IF ( ((KEEP(52).EQ.7).OR.(KEEP(52).EQ.8)) .AND. 
      &       KEEP(54).NE.0 ) THEN
-C         ------------------------------
+C{        ------------------------------
 C         Scaling for distributed matrix
 C         We need to allocate scaling
 C         arrays on all processors, not
@@ -857,13 +884,14 @@ C         ------------------------------
          M = N
          BUMAXMN=M
          IF(N > BUMAXMN) BUMAXMN = N
-         LIWK = 4*BUMAXMN
-         ALLOCATE (IWK(LIWK),BURP(M),BUCP(N),
-     &            BURS(2* (id%NPROCS)),BUCS(2* (id%NPROCS)),
+         LIWK = 4_8*int(BUMAXMN,8)
+         ALLOCATE (IWK(LIWK), BURP(M), BUCP(N),
+     &            BURS(2* id%NPROCS), BUCS(2* id%NPROCS),
      &            stat=allocok)
          IF (allocok > 0) THEN
             id%INFO(1)=-13
-            id%INFO(2)=LIWK+M+N+4* (id%NPROCS)
+            CALL MUMPS_SET_IERROR(LIWK+int(M,8)+int(N,8)+
+     &      4_8*int(id%NPROCS,8) , id%INFO(2))
          ENDIF
 C        --- Propagate enventual error
          CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
@@ -872,27 +900,38 @@ C        --- Propagate enventual error
 C        -- estimation of memory and construction of partvecs
          BUJOB = 1
 C        -- LWK not used
-         LWK_REAL   = 1
+         LWK_REAL = 1_8
+         LWRKR_TH = 1_8
+         LWRKC_TH = 1_8
+         NOMP_MAX   = 1
          ALLOCATE(WK_REAL(LWK_REAL),
+     &            WRKR_TH(LWRKR_TH,NOMP_MAX),
+     &            WRKC_TH(LWRKC_TH,NOMP_MAX),
      &            stat=allocok)
          IF (allocok > 0) THEN
             id%INFO(1)=-13
-            id%INFO(2)=LWK_REAL
+            CALL MUMPS_SET_IERROR(
+     &             LWK_REAL+ 
+     &             LWRKR_TH*int(NOMP_MAX,8)+
+     &             LWRKC_TH*int(NOMP_MAX,8),
+     &             id%INFO(2))
          ENDIF
 C        --- Propagate enventual error
          CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
      &        id%COMM, id%MYID )
          IF (id%INFO(1).LT.0) GOTO 517
          CALL DMUMPS_SIMSCALEABS(
-     &        MYIRN_loc(1), MYJCN_loc(1), MYA_loc(1),
+     &        IRN_loc_PTR(1), JCN_loc_PTR(1), A_loc_PTR(1),
      &        id%KEEP8(29),
      &        M, N,  id%NPROCS, id%MYID, id%COMM,
      &        BURP, BUCP,
      &        BURS, BUCS, BUREGISTRE,
      &        IWK, LIWK,
      &        BUINTSZ, BURESZ, BUJOB,
-     &        id%ROWSCA(1), id%COLSCA(1), WK_REAL, LWK_REAL,
-     &        id%KEEP(50),
+     &        id%ROWSCA(1), id%COLSCA(1), WK_REAL, LWK_REAL, 
+     &        WRKR_TH, LWRKR_TH, 
+     &        WRKC_TH, LWRKC_TH,
+     &        NOMP_MAX, id%KEEP(50),
      &        K231, K232, K233, 
      &        id%DKEEP(3),
      &        SCONEERR, SCINFERR)
@@ -902,15 +941,40 @@ C        --- Propagate enventual error
             ALLOCATE(IWK(LIWK), stat=allocok)
             IF (allocok > 0) THEN
                id%INFO(1)=-13
-               id%INFO(2)=LIWK
+               CALL MUMPS_SET_IERROR(LIWK,id%INFO(2))
             ENDIF
          ENDIF
-         LWK_REAL = BURESZ
-         DEALLOCATE(WK_REAL)
-         ALLOCATE (WK_REAL(LWK_REAL), stat=allocok)
+         DEALLOCATE(WK_REAL, WRKR_TH, WRKC_TH)
+         LWK_REAL     = BURESZ
+C
+C        -- Set NOMP_MAX from KEEP(281)
+         CALL DMUMPS_SET_NOMP_MAX(id%KEEP(281), id%KEEP(361), 
+     &                            N, NOMP_MAX)
+C
+         IF (NOMP_MAX.LE.1) THEN
+C          temp array per thread not used
+           LWRKR_TH = 1
+           LWRKC_TH = 1
+         ELSE
+           LWRKR_TH = N
+           IF (id%KEEP(50).NE.0) THEN
+C            WRKC_TH not used on symmetric matrices
+             LWRKC_TH = 1
+           ELSE
+             LWRKC_TH = N
+           ENDIF
+         ENDIF
+         ALLOCATE(WK_REAL(LWK_REAL),
+     &            WRKR_TH(LWRKR_TH,max(NOMP_MAX,1)),
+     &            WRKC_TH(LWRKC_TH,max(NOMP_MAX,1)),
+     &            stat=allocok)
          IF (allocok > 0) THEN
             id%INFO(1)=-13
-            id%INFO(2)=LWK_REAL
+            CALL MUMPS_SET_IERROR(
+     &             LWK_REAL+ 
+     &             LWRKR_TH*int(max(NOMP_MAX,1),8)+
+     &             LWRKC_TH*int(max(NOMP_MAX,1),8),
+     &             id%INFO(2))
          ENDIF
 C        --- Propagate enventual error
          CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
@@ -919,7 +983,7 @@ C        --- Propagate enventual error
 C        -- estimation of memory and construction of partvecs
          BUJOB = 2
          CALL DMUMPS_SIMSCALEABS(
-     &        MYIRN_loc(1), MYJCN_loc(1), MYA_loc(1),
+     &        IRN_loc_PTR(1), JCN_loc_PTR(1), A_loc_PTR(1),
      &        id%KEEP8(29),
      &        M, N,  id%NPROCS, id%MYID, id%COMM,
      &        BURP, BUCP,
@@ -927,16 +991,20 @@ C        -- estimation of memory and con
      &        IWK, LIWK,
      &        BUINTSZ, BURESZ, BUJOB,
      &        id%ROWSCA(1), id%COLSCA(1), WK_REAL, LWK_REAL,
-     &        id%KEEP(50),
+     &        WRKR_TH, LWRKR_TH, 
+     &        WRKC_TH, LWRKC_TH,
+     &        NOMP_MAX, id%KEEP(50),
      &        K231, K232, K233, 
      &        id%DKEEP(3),
      &        SCONEERR, SCINFERR)
          id%DKEEP(4) = SCONEERR
          id%DKEEP(5) = SCINFERR
 CXXXX 
-         DEALLOCATE(IWK, WK_REAL,BURP,BUCP,BURS, BUCS)
+         DEALLOCATE(IWK, BURP,BUCP,BURS, BUCS)
+         DEALLOCATE(WK_REAL, WRKR_TH, WRKC_TH)
+C}
         ELSE IF ( KEEP(54) .EQ. 0 ) THEN
-C         ------------------
+C{        ------------------
 C         Centralized matrix
 C         ------------------
           IF ((KEEP(52).EQ.7).OR.(KEEP(52).EQ.8))  THEN
@@ -954,21 +1022,45 @@ C             --------------------------
                  M = N
                  BUMAXMN=N
                  IF(N > BUMAXMN) BUMAXMN = N
-                 LIWK = 1
-                 ALLOCATE(IWK(LIWK),BURP(1),BUCP(1),
-     &                BURS(1),BUCS(1),
+                 LIWK = 1_8
+                 ALLOCATE(IWK(LIWK), BURP(1), BUCP(1),
+     &                BURS(1), BUCS(1),
      &                stat=allocok)
                  IF (allocok > 0) THEN
                     id%INFO(1)=-13
-                    id%INFO(2)=LIWK+1+1+1+1
+                    CALL MUMPS_SET_IERROR( LIWK+4_8, id%INFO(2) )
                     GOTO 400
                  ENDIF
-                 LWK_REAL = M + N  
-                 ALLOCATE (WK_REAL(LWK_REAL), stat=allocok)
+                 LWK_REAL = int(M,8) + int(N,8)  
+C
+C                -- Set NOMP_MAX from KEEP(281)
+                 CALL DMUMPS_SET_NOMP_MAX(id%KEEP(281), id%KEEP(361), 
+     &                                    N, NOMP_MAX)
+C
+                 IF (NOMP_MAX.LE.1) THEN
+C                  temp array per thread not used
+                   LWRKR_TH = 1
+                   LWRKC_TH = 1
+                 ELSE
+                   LWRKR_TH = N
+                   IF (id%KEEP(50).NE.0) THEN
+C                    WRKC_TH not used on symmetric matrices
+                     LWRKC_TH = 1
+                   ELSE
+                     LWRKC_TH = N
+                   ENDIF
+                 ENDIF
+                 ALLOCATE(WK_REAL(LWK_REAL),
+     &                    WRKR_TH(LWRKR_TH,max(NOMP_MAX,1)),
+     &                    WRKC_TH(LWRKC_TH,max(NOMP_MAX,1)),
+     &                    stat=allocok)
                  IF (allocok > 0) THEN
                     id%INFO(1)=-13
-                    id%INFO(2)=LWK_REAL
-                    GOTO 400
+                    CALL MUMPS_SET_IERROR(
+     &                     LWK_REAL+ 
+     &                     LWRKR_TH*int(max(NOMP_MAX,1),8)+
+     &                     LWRKC_TH*int(max(NOMP_MAX,1),8),
+     &                     id%INFO(2))
                  ENDIF
                  CALL MPI_COMM_RANK(COMM_FOR_SCALING, SCMYID, IERR)
                  CALL MPI_COMM_SIZE(COMM_FOR_SCALING, SCNPROCS, IERR)
@@ -982,7 +1074,9 @@ C             --------------------------
      &                IWK, LIWK,
      &                BUINTSZ, BURESZ, BUJOB,
      &                id%ROWSCA(1), id%COLSCA(1), WK_REAL, LWK_REAL,
-     &                id%KEEP(50),
+     &                WRKR_TH, LWRKR_TH, 
+     &                WRKC_TH, LWRKC_TH,
+     &                NOMP_MAX, id%KEEP(50),
      &                K231, K232, K233, 
      &                id%DKEEP(3),
      &                SCONEERR, SCINFERR)
@@ -1000,7 +1094,9 @@ C             --------------------------
      &                IWK, LIWK,
      &                BUINTSZ, BURESZ, BUJOB,
      &                id%ROWSCA(1), id%COLSCA(1), WK_REAL, LWK_REAL,
-     &                id%KEEP(50),
+     &                WRKR_TH, LWRKR_TH, 
+     &                WRKC_TH, LWRKC_TH,
+     &                NOMP_MAX, id%KEEP(50),
      &                K231, K232, K233, 
      &                id%DKEEP(3),
      &                SCONEERR, SCINFERR)
@@ -1008,6 +1104,8 @@ C             --------------------------
                  id%DKEEP(5) = SCINFERR
  400             CONTINUE
                  IF (allocated(WK_REAL)) DEALLOCATE(WK_REAL)
+                 IF (allocated(WRKR_TH)) DEALLOCATE(WRKR_TH)
+                 IF (allocated(WRKC_TH)) DEALLOCATE(WRKC_TH)
                  IF (allocated(IWK))     DEALLOCATE(IWK)
                  IF (allocated(BURP))    DEALLOCATE(BURP)
                  IF (allocated(BUCP))    DEALLOCATE(BUCP)
@@ -1026,31 +1124,34 @@ C               freed on the master proc
      &             id%COMM, id%MYID)
               IF (id%INFO(1).LT.0) GOTO 517
           ELSE IF (id%MYID.EQ.MASTER) THEN
-C           ----------------------------------
-C           Centralized scaling, options 1 to 6
-C           ----------------------------------
+C           -------------------
+C           Centralized scaling
+C           -------------------
             IF (KEEP(52).GT.0 .AND. KEEP(52).LE.6) THEN
 C             ---------------------
 C             Allocate temporary
 C             workspace for scaling
 C             ---------------------
-              IF ( KEEP(52) .eq. 5 .or. 
-     &          KEEP(52) .eq. 6 ) THEN
-C               We have an explicit copy of the original
-C               matrix in complex format which should probably
-C               be avoided (but do we want to keep all
-C               those old scaling options ?)
-                LWK = id%KEEP8(28)
-              ELSE
+              IF (KEEP(52) .eq. 1 ) THEN
+C               No workspace indeed needed
                 LWK = 1_8
+                LWK_REAL = 1_8
+              ELSE IF ( KEEP(52) .eq. 3 ) THEN 
+                LWK = 1_8
+                LWK_REAL = int(N,8)
+              ELSE IF ( KEEP(52) .eq. 4 ) THEN
+C               Options 3 or 4
+                LWK = 1_8
+                LWK_REAL = 2_8*int(N,8)
               END IF
-              LWK_REAL = 5 * N
+C             Real workarray
               ALLOCATE( WK_REAL( LWK_REAL ), stat = IERR )
               IF ( IERR .GT. 0 ) THEN
                 id%INFO(1) = -13
-                id%INFO(2) = LWK_REAL
+                CALL MUMPS_SET_IERROR( LWK_REAL, id%INFO(2) )
                 GOTO 137
               END IF
+C             Real/complex workarray
               ALLOCATE( WK( LWK ), stat = IERR )
               IF ( IERR .GT. 0 ) THEN
                 id%INFO(1) = -13
@@ -1065,11 +1166,12 @@ C               those old scaling option
               DEALLOCATE( WK )
             ENDIF
           ENDIF
+C}
         ENDIF ! Scaling distributed matrices or centralized
         IF (KEEP(125).NE.0) THEN
 C         ------------------------
 C           If we enable the scaling of the |A11 A12| block
-C           we et to 1 the scaling corresponding to the Schur
+C           we set to 1 the scaling corresponding to the Schur
 C           complement matrix A22
 C         ------------------------
             IF ((KEEP(60).GT.0) .and. (KEEP(116).GT.0)) THEN
@@ -1097,6 +1199,7 @@ C             Scaling available on maste
         IF (id%MYID.EQ.MASTER) THEN
             CALL MUMPS_SECFIN(TIMEET)
             id%DKEEP(92)=TIMEET
+          IF (PROKG) WRITE( MPG, 140 ) TIMEET
 C         Print inf-norm after last KEEP(233) iterations of
 C         scaling option KEEP(52)=7 or 8 (SimScale)
 C
@@ -1146,6 +1249,9 @@ C       of the original matrix.
 C       ********************
 C
  137  CONTINUE
+      CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
+     &     id%COMM, id%MYID )
+      IF (id%INFO(1).LT.0) GOTO 517
 C     Fwd in facto: in case of repeated factorizations
 C     with different Schur options we prefer to free
 C     systematically this array now than waiting for
@@ -1171,11 +1277,11 @@ C     to make it available on all proces
       IF (id%KEEP(252) .EQ. 1) THEN
           IF ( id%MYID.NE.MASTER ) THEN
             id%KEEP(254) = N              ! Leading dimension
-            id%KEEP(255) = N*id%KEEP(253) ! Tot size
-            ALLOCATE(RHS_MUMPS(id%KEEP(255)),stat=IERR)
+            id%KEEP8(85) = int(N,8)*int(id%KEEP(253),8) ! Tot size
+            ALLOCATE(RHS_MUMPS(id%KEEP8(85)),stat=IERR)
             IF (IERR > 0) THEN
                id%INFO(1)=-13
-               id%INFO(2)=id%KEEP(255)
+               CALL MUMPS_SET_IERROR(id%KEEP8(85), id%INFO(2))
                IF (LPOK)
      &         WRITE(LP,*) 'ERROR while allocating RHS on a slave'
                NULLIFY(RHS_MUMPS)
@@ -1184,7 +1290,8 @@ C     to make it available on all proces
           ELSE 
 C           Case of non working master
             id%KEEP(254)=id%LRHS              ! Leading dimension
-            id%KEEP(255)=id%LRHS*(id%KEEP(253)-1)+id%N ! Tot size
+            id%KEEP8(85)=int(id%LRHS,8)*int(id%KEEP(253)-1,8)+
+     &                   int(id%N,8) ! Tot size
             RHS_MUMPS=>id%RHS
             RHS_MUMPS_ALLOCATED = .FALSE.
             IF (LSCAL) THEN
@@ -1201,7 +1308,7 @@ C             transpose).
             ENDIF
           ENDIF
       ELSE
-          id%KEEP(255)=1
+          id%KEEP8(85)=1_8
           ALLOCATE(RHS_MUMPS(1),stat=IERR)
           IF (IERR > 0) THEN
              id%INFO(1)=-13
@@ -1214,7 +1321,7 @@ C             transpose).
       ENDIF
       CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
      &                    id%COMM, id%MYID )
-      IF ( id%INFO(1).lt.0 ) GOTO 517
+      IF ( id%INFO(1).lt.0 ) GOTO 516
       IF (KEEP(252) .EQ. 1) THEN
 C
 C         Broadcast the columns of the right-hand side
@@ -1235,7 +1342,7 @@ C       KEEP(110) defaults to 0 for out
       ENDIF
       CALL MPI_BCAST(KEEP(110), 1, MPI_INTEGER,
      &               MASTER, id%COMM, IERR)
-      IF (KEEP(219).NE.0) THEN
+      IF ((KEEP(50).EQ.2).AND.(KEEP(219).NE.0)) THEN
        CALL DMUMPS_BUF_MAX_ARRAY_MINSIZE(max(KEEP(108),1),IERR)
        IF (IERR .NE. 0) THEN
 C      ------------------------
@@ -1253,6 +1360,7 @@ C               ( A row is considered as
 C         CNTL(5) is then used to define if a large 
 C                 value is set on the diagonal or if a 1 is set
 C                 and other values in the row are reset to zeros.
+C       -rank revealing on the Schur (ICNTL(56)/KEEP(19))
 C         SEUIL* corresponds to the minimum required 
 C                absolute value of pivot.
 C         SEUIL_LDLT_NIV2 is used only in the 
@@ -1337,6 +1445,10 @@ C      sing val.
          ELSE IF  (CNTL3 .GT. ZERO) THEN
            id%DKEEP(9) = CNTL3*ANORMINF
          ELSE  !  (CNTL(3) .EQ. ZERO) THEN
+           CALL MUMPS_NPIV_CRITICAL_PATH(
+     &     N, KEEP(28), id%STEP(1), id%FRERE_STEPS(1), id%FILS(1),
+     &     id%NA(1), id%LNA, id%NE_STEPS(1), NPIV_CRITICAL_PATH )
+           id%DKEEP(9) = sqrt(dble(NPIV_CRITICAL_PATH))*EPS*ANORMINF  
          ENDIF
          IF (PROKG) THEN 
            WRITE(MPG, '(A,I16)')
@@ -1429,6 +1541,7 @@ C     Find id of root node if RR is on
       ENDIF
 C Second pass:  set parameters for null pivot detection
 C Allocate PIVNUL_LIST_STRUCT in case of null pivot detection
+C and in case of rank revealing
       KEEP(109) = 0
       LPN_LIST  = 0
       IF(KEEP(110) .EQ. 1) THEN
@@ -1450,7 +1563,7 @@ C Allocate PIVNUL_LIST_STRUCT in case of
 C end set parameter for null pivot detection
       CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
      &                    id%COMM, id%MYID )
-      IF ( id%INFO(1).lt.0 ) GOTO 517
+      IF ( id%INFO(1).lt.0 ) GOTO 516
 C   --------------------------------------------------------------
 C   STATIC PIVOTING
 C     -- Static pivoting only when RR and Null pivot detection OFF
@@ -1514,7 +1627,7 @@ C       -- Set MAXS to size of WK_USER_
       CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
      &                    id%COMM, id%MYID )
       IF (id%INFO(1) .LT. 0) THEN
-        GOTO 517
+        GOTO 516
       ENDIF
 C
       id%KEEP8(75) = huge(id%KEEP8(75))
@@ -1603,7 +1716,7 @@ C
       CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
      &                    id%COMM, id%MYID )
       IF (id%INFO(1) .LT. 0) THEN
-        GOTO 517
+        GOTO 516
       ENDIF
       CALL MUMPS_SETI8TOI4(MAXS, id%INFO(39))
       CALL DMUMPS_AVGMAX_STAT8(PROKG, MPG, MAXS, id%NSLAVES,
@@ -1995,11 +2108,11 @@ C     id%S will be checked later)
 C     ---------------------------------------------
       IF (EARLYT3ROOTINS .AND. KEEP(38).NE.0 .AND.
      &    KEEP(60) .EQ.0 .AND. I_AM_SLAVE) THEN
-        LWK = int(numroc( id%root%ROOT_SIZE, id%root%MBLOCK,
+        LWK = int(MUMPS_NUMROC( id%root%ROOT_SIZE, id%root%MBLOCK,
      &             id%root%MYROW, 0, id%root%NPROW ),8)
         LWK = max( 1_8, LWK )
         LWK = LWK*
-     &        int(numroc( id%root%ROOT_SIZE, id%root%NBLOCK,
+     &        int(MUMPS_NUMROC( id%root%ROOT_SIZE, id%root%NBLOCK,
      &        id%root%MYCOL, 0, id%root%NPCOL ),8)
         LWK = max( 1_8, LWK )
       ELSE
@@ -2016,6 +2129,122 @@ C     arrowheads of root.
      &                        id%COMM, id%MYID )
       IF ( id%INFO(1).LT.0 ) GOTO 500
 C
+C     =====================================================
+      IF (KEEP(399).GE.2) THEN
+C{    Multihtreaded algorithm taking into account all cases
+C     =====================================================
+C
+C        Timing on master.
+         IF (id%MYID.EQ.MASTER) THEN
+           CALL MUMPS_SECDEB(TIME)
+         END IF
+C
+         NZ_loc8   = 0_8
+         NBRECORDS = KEEP(39)
+         SIZESCAL = id%N
+C        Set  NZ_loc8, A_loc_PTR, IRN_loc_PTR, JCN_loc_PTR
+C        and update NBRECORDS
+         IF (KEEP(54).EQ.0) THEN
+C         centralized matrix
+          IF (id%KEEP8(28) .LT. int(NBRECORDS,8)) THEN
+              NBRECORDS = int(id%KEEP8(28))
+          ENDIF
+          IF (id%MYID.EQ.MASTER) THEN
+           NZ_loc8 = id%KEEP8(28)
+           A_loc_PTR   => id%A
+           IRN_loc_PTR => id%IRN
+           JCN_loc_PTR => id%JCN
+           IF (LSCAL) THEN
+             COLSCA_PTR => id%COLSCA
+             ROWSCA_PTR => id%ROWSCA
+           ELSE
+             COLSCA_PTR  => DUMMYSCA
+             ROWSCA_PTR  => DUMMYSCA
+             SIZESCAL  = 1
+           ENDIF
+          ELSE
+           A_loc_PTR   => DUMMYA_loc
+           IRN_loc_PTR => DUMMYIRN_loc
+           JCN_loc_PTR => DUMMYJCN_loc
+           COLSCA_PTR  => DUMMYSCA
+           ROWSCA_PTR  => DUMMYSCA
+           SIZESCAL  = 1
+          ENDIF
+         ELSE
+C         distributed matrix
+C         ---------------------------------------------------
+C         In order to have possibly IRN_loc/JCN_loc/A_loc
+C         of size 0, avoid to pass them inside REDISTRIBUTION
+C         and pass id instead
+C         NZ_locMAX8 gives as a maximum buffer size (send/recv) used
+C          an upper bound to limit buffers on small matrices
+C         ---------------------------------------------------
+          CALL MPI_ALLREDUCE(id%KEEP8(29), NZ_locMAX8, 1, 
+     &              MPI_INTEGER8, MPI_MAX, id%COMM, IERR)
+          IF (NZ_locMAX8 .LT. int(NBRECORDS,8)) THEN
+              NBRECORDS = int(NZ_locMAX8)
+          ENDIF
+          NZ_loc8 = id%KEEP8(29)
+          LSCAL   = (KEEP(52).EQ.7).OR.(KEEP(52).EQ.8)
+C         available on all MPI
+          IF (LSCAL) THEN
+            COLSCA_PTR => id%COLSCA
+            ROWSCA_PTR => id%ROWSCA
+          ELSE
+           COLSCA_PTR  => DUMMYSCA
+           ROWSCA_PTR  => DUMMYSCA
+           SIZESCAL  = 1
+          ENDIF
+         ENDIF
+#if ! defined(PCPRET)
+          IF (id%KEEP(72).EQ.1) THEN
+           NBRECORDS = max(3,NBRECORDS/10)
+          ENDIF
+         CALL DMUMPS_FAC_DIST_ARROWHEADS_OMP ( id%N,
+     &     NZ_loc8, 
+C          replace id by:
+     &        A_loc_PTR(1), IRN_loc_PTR(1), JCN_loc_PTR(1),
+     &        SIZESCAL, LSCAL, COLSCA_PTR(1), ROWSCA_PTR(1), 
+     &     DBLARR(1), id%KEEP8(26), INTARR(1),
+     &     id%KEEP8(27),
+     &     id%PTR8ARR(1), id%NINCOLARR(1),
+     &     id%NINROWARR(1), id%PTRDEBARR(1),
+     &     id%FILS(1),
+     &     KEEP(1), id%KEEP8(1), id%MYID, id%COMM, NBRECORDS,
+     &     S_PTR_ARG(1), MAXS_ARG, id%root, id%PROCNODE_STEPS(1),
+     &     id%NPROCS, id%NSLAVES, id%SYM_PERM(1), id%STEP(1),
+     &     id%ICNTL(1), id%INFO(1), NSEND8, NLOCAL8,
+     &     id%ISTEP_TO_INIV2(1),
+     &     id%CANDIDATES(1,1) 
+     &     )
+         CALL MPI_BARRIER(id%COMM, IERR)
+#else 
+#endif
+C     
+         IF ( KEEP(46) .eq. 0 .AND. id%MYID.eq.MASTER ) THEN
+C          ------------------------------
+C          The host is not working -> had
+C          no data from initial matrix
+C          ------------------------------
+           NSEND8  = 0_8
+           NLOCAL8 = 0_8
+         END IF
+C        -------------------------
+C        Check for possible errors
+C        -------------------------
+         CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
+     &                    id%COMM, id%MYID )
+         IF ( id%INFO( 1 ) .LT. 0 ) GOTO 500
+         CALL MPI_REDUCE( NSEND8, NSEND_TOT8, 1, MPI_INTEGER8,
+     &                 MPI_SUM, MASTER, id%COMM, IERR )
+         CALL MPI_REDUCE( NLOCAL8, NLOCAL_TOT8, 1, MPI_INTEGER8,
+     &                 MPI_SUM, MASTER, id%COMM, IERR )
+         IF ( PROKG ) THEN
+           WRITE(MPG,125) NLOCAL_TOT8, NSEND_TOT8
+         END IF
+C}        
+      ELSE
+C{   =======================================================
       IF ( KEEP(54) .eq. 0 ) THEN
 C     {
 C       ================================================
@@ -2242,6 +2471,8 @@ C     --------------------------
 C     }
       ENDIF ! distributed matrix
 C     }
+      ENDIF !  "old" multithreaded algorithm 
+C     }
       ELSE
 C     {
 C       -------------------
@@ -2305,8 +2536,9 @@ C       We check the number of threads.
             id%INFO(1)=-58
             id%INFO(2)=KEEP(400)
             IF (LPOK) WRITE(LP,'(A,A,I5,A,I5)')
-     &" FAILURE DETECTED IN FACTORIZATION: #threads for KEEP(401)",
-     &" changed from",KEEP(400)," at analysis to", NOMP
+     &" FAILURE DETECTED IN FACTORIZATION: #threads for multithreaded",
+     &" tree parallelism changed from",KEEP(400)," at analysis to", 
+     &  NOMP
           ENDIF
 C       error check
         CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
@@ -2393,6 +2625,13 @@ C
         DMUMPS_LBUFR_BYTES8 = min(DMUMPS_LBUFR_BYTES8,
      &                            int(huge(I4)-100,8))
         DMUMPS_LBUFR_BYTES  = int( DMUMPS_LBUFR_BYTES8 )
+C       DMUMPS_LBUFR is the size of the buffer as a number of integers,
+C       we round DMUMPS_LBUFR (size in #integers) above to have at least
+C       DMUMPS_LBUFR_BYTES available in the buffer.
+        DMUMPS_LBUFR = (DMUMPS_LBUFR_BYTES+KEEP(34)-1)/KEEP(34)
+C       Finally, make DMUMPS_LBUFR_BYTES a multiple of KEEP(34) by setting
+C       DMUMPS_LBUFR_BYTES to the number of bytes that will be allocated
+        DMUMPS_LBUFR_BYTES = DMUMPS_LBUFR*KEEP(34)
         IF (KEEP(48)==5) THEN
 C          Since the buffer is going to be allocated, use
 C          it as the constraint for memory/granularity
@@ -2463,12 +2702,17 @@ C       are in numbers of bytes).
         IF ( PROK ) THEN
           WRITE( MP, 9999 ) DMUMPS_LBUFR_BYTES,
      &                      DMUMPS_LBUF, DMUMPS_LBUF_INT
+        ELSE 
+         IF (PROKG) THEN
+          WRITE( MPG, 9999 ) DMUMPS_LBUFR_BYTES,
+     &                      DMUMPS_LBUF, DMUMPS_LBUF_INT
+         ENDIF
         END IF
  9999   FORMAT( /,' Allocated buffers',/,' ------------------',/,
-     &  ' Size of reception buffer in bytes ...... = ', I10,
+     &  ' Size of reception buffer in bytes ...... = ', I12,
      &  /,
-     &  ' Size of async. emission buffer (bytes).. = ', I10,/,
-     &  ' Small emission buffer (bytes) .......... = ', I10)
+     &  ' Size of async. emission buffer (bytes).. = ', I12,/,
+     &  ' Small emission buffer (bytes) .......... = ', I12)
 C       --------------------------
 C       Allocate small send buffer
 C       required for DMUMPS_FAC_B
@@ -2490,7 +2734,6 @@ C       --------------------------------
 C       Allocate reception buffer on all procs
 C       This is done now.
 C       --------------------------------------
-        DMUMPS_LBUFR = (DMUMPS_LBUFR_BYTES+KEEP(34)-1)/KEEP(34)
         ALLOCATE( BUFR( DMUMPS_LBUFR ),stat=IERR )
         IF ( IERR .NE. 0 ) THEN
           id%INFO(1) = -13
@@ -2820,7 +3063,7 @@ C     --------------------------------
       IF (allocated(BUFR)) DEALLOCATE(BUFR)
       CALL DMUMPS_BUF_DEALL_SMALL_BUF( IERR )
 C//PIV
-      IF (KEEP(219).NE.0) THEN
+      IF ((KEEP(50).EQ.2).AND.(KEEP(219).NE.0)) THEN
       CALL DMUMPS_BUF_DEALL_MAX_ARRAY()
       ENDIF
 C
@@ -2832,6 +3075,10 @@ C     not be necessary.
      &                    id%COMM, id%MYID )
 C
       CALL DMUMPS_EXTRACT_SCHUR_REDRHS(id)
+C     return to user singular values
+      IF (id%KEEP(19) .NE.0) THEN
+       CALL DMUMPS_EXTRACT_SINGULAR_VALUES(id)
+      ENDIF
       IF (KEEP(201) .GT. 0) THEN
          IF ((KEEP(201).EQ.1) .OR. (KEEP(201).EQ.2)) THEN
             IF ( I_AM_SLAVE ) THEN
@@ -3402,6 +3649,9 @@ C           flops when BLR activated
           ELSE
             RINFOG(14) = 0.0D00
           ENDIF
+        IF (id%MYID .eq. MASTER) THEN
+          KEEP(399) = KEEP399_SAVE
+        ENDIF
       ENDIF
 C     ==============================
 C     NULL PIVOTS AND RANK-REVEALING
@@ -3443,7 +3693,7 @@ C      (do not allocate)
         ENDIF
        ELSE
 C       id%PIVNUL_LIST(1:KEEP(109)) used during sol_driver on slaves 
-C       to initialize id%RHSCOMP
+C       to initialize id%RHSINTR
         IF (KEEP(109).GT.0) THEN
           ALLOCATE(id%PIVNUL_LIST(KEEP(109)), stat=IERR)
           IF ( IERR .GT. 0 ) THEN
@@ -3457,6 +3707,34 @@ C}
       CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
      &                    id%COMM, id%MYID )
       IF ( id%INFO(1).lt.0 ) GOTO 490
+      IF ( (KEEP(19).NE.0) .AND. (KEEP(143) .NE. KEEP(17)) ) THEN
+C
+C         Raise a warning (on all MPI processes) since determinant or
+C         inertia or null pivot list is not consistent with deficiency
+C         computed with ICNTL(46)=1.
+C
+        id%INFO(1) = id%INFO(1)+16
+        id%INFO(2) = KEEP(112)+KEEP(143)
+        IF (KEEP(118) .GE. 40) THEN
+          IF ( PROKG ) THEN
+            WRITE(MPG,'(/A,A/,A,A,I8/,A,A,I8/)')
+     &      " WARNING: in the context of rank-revealing,",
+     &      " the inertia, determinant and pivnul list",  
+     &      " are computed with RR (rank-revealing)-LU,", 
+     &      " but the deficiency found by RR-LU: ", 
+     &      id%INFO(2),
+     &      " is different from the deficiency computed",
+     &      " with ICNTL(56)>0: ",  KEEP(112)+KEEP(17)
+          ENDIF
+        ELSE
+          IF ( LP .GT. 0 ) THEN
+            WRITE(LP,'(/A,A/,A/)')
+     &      " ERROR : in the context of rank-revealing,",
+     &      " the inertia, determinant and pivnul list",  
+     &      " are not correct because RR LU not called "
+          ENDIF
+        ENDIF
+      ENDIF
 C     ========================================
 C     We now provide to the host the part of
 C     PIVNUL_LIST resulting from the processing
@@ -3617,9 +3895,6 @@ C         of max-weighted matching)
           IF (id%KEEP(23).NE.0) THEN
             CALL DMUMPS_DETER_SIGN_PERM(
      &           RINFOG(12), id%N,
-C           id%STEP: used as workspace of size N still
-C                    allocated on master; restored on exit
-     &           id%STEP(1),
      &           id%UNS_PERM(1) )
 C           Remark that RINFOG(12/13) are modified only
 C           on the host but will be broadcast on exit
@@ -3701,6 +3976,14 @@ c         IF ( KEEP(17) .ne. 0 )
               WRITE(MPG, 99997) INFOG(50)
             ENDIF
           ENDIF
+          !Smallest pivot with also null pivots in abs value
+          WRITE(MPG, 99995) RINFOG(19)
+          !Smallest pivot in abs value
+          WRITE(MPG, 99993) RINFOG(20)
+          !Largest pivot in abs value
+          WRITE(MPG, 99994) RINFOG(21)
+          !value of ICNTL(12) that was effectively used.
+          WRITE(MPG, 99996) INFOG(24)
           ! Memory compress
           WRITE(MPG, 99981) INFOG(14)
           ! Extra copies due to ip stack in unsym case
@@ -3917,7 +4200,7 @@ C     at the end of a phase S is always
       END IF
 C
 C     Goto 513 is done in case of error where LOAD_INIT was
-C     called but not OOC_INIT_FACTO.
+C     called but not the scaling nor OOC_INIT_FACTO.
  513  CONTINUE
       IF ( I_AM_SLAVE ) THEN
          CALL DMUMPS_LOAD_END( id%INFO(1), id%NSLAVES, IERR )
@@ -3926,9 +4209,37 @@ C     called but not OOC_INIT_FACTO.
       CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
      &     id%COMM, id%MYID )
 C
-C     Goto 517 is done when an error occurs when GPU initialization
-C     has been performed but not LOAD_INIT or OOC_INIT_FACTO
+C     Goto 516 is done in case of error when GPU initialiwqtion
+C     has been performed and scaling was optionally computed but
+C     not LOAD_INIT nor OOC_INIT_FACTO. We can then extract
+C     scaling arrays in case of error.
+ 516  CONTINUE
+C     --------------------------------------------
+C     We now build id%ROWSCA_loc and id%COLSCA_loc
+C     in case of successful factorization, in the
+C     numbering associated to the fully summed
+C     variables of the frontal matrices.
+C     This requires the factorization to be
+C     successful because otherwise we do not have
+C     the final lists of pivots associated to
+C     the fronts, including delayed pivots and
+C     symmetric/unsymmetric permutations done
+C     during the factorization process.
+C     --------------------------------------------
+      IF (LSCAL .AND. id%INFO(1).GE.0) THEN
+        CALL DMUMPS_EXTRACT_SCALING(id)
+C       occurs during scaling extraction, keep the error.
+        IF ( id%INFO(1) .LT. 0 ) THEN
+          IF (LPOK) THEN
+            WRITE(LP,*) "Facto OK but error during EXTRACT_SCALING",
+     &      id%INFO(1:2)
+          ENDIF
+        ENDIF
+      ENDIF
 C
+C     Goto 517 is done when an error occurs when GPU initialization
+C     has been performed but not LOAD_INIT or OOC_INIT_FACTO, e.g.
+C     when an error occurred during the scaling.
  517  CONTINUE
       IF (associated( PIVNUL_LIST_STRUCT%PIVNUL_LIST)) THEN
         DEALLOCATE(PIVNUL_LIST_STRUCT%PIVNUL_LIST)
@@ -3949,10 +4260,12 @@ C
  120  FORMAT(/' Local redistrib: data local/sent           =',I16,I16)
  125  FORMAT(/' Redistrib: total data local/sent           =',I16,I16)
  130  FORMAT(//'****** FACTORIZATION STEP ********'/)
+ 140  FORMAT(/' Statistics on the scaling phase'
+     & /' Elapsed time for scaling                   =',F12.4)
  160  FORMAT(
-     & /' Elapsed time to reformat/distribute matrix =',F12.4)
+     & ' Elapsed time to reformat/distribute matrix =',F12.4/)
  166  FORMAT(' Max difference from 1 after scaling the entries',
-     &       ' for ONE-NORM (option 7/8)   =',D9.2)
+     &       ' for ONE-NORM (option 7/8)   =',D9.2/)
  170  FORMAT(' STATISTICS PRIOR NUMERICAL FACTORIZATION ...'/
      &        ' Size of internal working array S           =',I16/
      &        ' Size of internal working array IS          =',I16/
@@ -4010,6 +4323,14 @@ C
      &      I16)
 99997 FORMAT( ' INFOG (50) Number of negative AND null pivots      =',
      &      I16)
+99995 FORMAT( ' RINFOG(19) Smallest pivot WITH perturbed pivots    =',
+     &     1PD10.3)
+99993 FORMAT( ' RINFOG(20) Smallest pivot WITHOUT perturbed pivots =',
+     &     1PD10.3)
+99994 FORMAT( ' RINFOG(21) Largest pivot in absolute value         =',
+     &     1PD10.3)
+99996 FORMAT( ' INFOG (24) Effective value of ICNTL(12)            =',
+     &     I16)
 99984 FORMAT(/'Leaving factorization with ...'/
      &        ' RINFOG (2) Operations in node assembly             =',
      &          1PD10.3/                                   
@@ -4098,6 +4419,186 @@ C
  110  FORMAT(A48,I18)
       END SUBROUTINE DMUMPS_AVGMAX_STAT8
 C
+C
+C     ==================================================================
+C
+      SUBROUTINE DMUMPS_EXTRACT_SCALING(id)
+      USE DMUMPS_STRUC_DEF
+      IMPLICIT NONE
+C
+C     Purpose:
+C     =======
+C
+C     Extract distributed scaling arrays from DMUMPS_EXTRACT_SCALING
+C     In case of unsymmetric permutation, ROWSCA and COLSCA correspond
+C     to Dr and Dc, in the expression Dr A Q Dc. In other terms, Dc
+C     is compatbile with the front column indices, it does not
+C     correspond to the column indices of A, meaning that Q is not
+C     needed to just extract the scaling values.
+C
+C
+      TYPE(DMUMPS_STRUC) :: id
+      INTEGER, EXTERNAL  :: MUMPS_PROCNODE
+C
+C     MPI
+C     ===
+C
+      INCLUDE 'mpif.h'
+C
+C     Local declarations
+C     ==================
+C
+      DOUBLE PRECISION, DIMENSION(:), POINTER :: COLSCA
+      DOUBLE PRECISION, DIMENSION(:), POINTER :: ROWSCA
+      INTEGER, PARAMETER :: MASTER = 0
+C
+      INTEGER    :: ISTEP, NPIV, LIELL
+      INTEGER    :: IERR_MPI, allocok
+      INTEGER    :: ISCA
+      INTEGER    :: JROW, JCOL, IPOS, JJ ! access to IS
+      INTEGER    :: LIW_PASSED
+      INTEGER(8) :: LALLOC
+C
+C     Free and reallocate distributed scaling arrays :
+C     - in symmetric, COLSCA_loc points on ROWSCA_loc.
+C     - not allocated if KEEP(89)=0
+C
+      NULLIFY(ROWSCA)
+      NULLIFY(COLSCA)
+      IF (associated(id%ROWSCA_loc)) THEN
+        DEALLOCATE(id%ROWSCA_loc)
+        NULLIFY(id%ROWSCA_loc)
+      ENDIF
+      IF (associated(id%COLSCA_loc)) THEN
+        IF (id%KEEP(50) .EQ. 0) THEN
+          DEALLOCATE(id%COLSCA_loc)
+        ENDIF
+        NULLIFY(id%COLSCA_loc)
+      ENDIF
+C     id%ROWSCA and id%COLSCA are available on master,
+C     allocate ROWSCA and COLSCA of order N on other procs
+      IF ( id%MYID .EQ. MASTER ) THEN
+        ROWSCA => id%ROWSCA
+        COLSCA => id%COLSCA
+        IF (.NOT. associated(ROWSCA)) THEN
+          WRITE(*,*) "Internal error 1 in DMUMPS_EXTRACT_SCALING"
+          CALL MUMPS_ABORT()
+        ENDIF
+        IF (.NOT. associated(COLSCA)) THEN
+          WRITE(*,*) "Internal error 2 in DMUMPS_EXTRACT_SCALING"
+          CALL MUMPS_ABORT()
+        ENDIF
+      ELSE
+        IF (id%KEEP(50).EQ.0) THEN
+          ALLOCATE(ROWSCA(id%N),COLSCA(id%N),stat=allocok)
+          LALLOC = int(id%N+id%N,8)
+        ELSE
+          ALLOCATE(ROWSCA(id%N),stat=allocok)
+          COLSCA => ROWSCA
+          LALLOC = int(id%N,8)
+        ENDIF
+        IF (allocok .GT. 0) THEN
+          id%INFO(1)=-13
+          CALL MUMPS_SET_IERROR(LALLOC,id%INFO(2))
+        ENDIF
+      ENDIF
+      CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                        id%COMM, id%MYID )
+C     Jump to 110 in case of error on ROWSCA or COLSCA
+C     on one of the MPI processes.
+      IF (id%INFO(1) .LT. 0) GOTO 110
+C
+      IF ( id%KEEP(89) .GT. 0) THEN
+        IF (id%KEEP(50).EQ.0) THEN
+          ALLOCATE(id%ROWSCA_loc(id%KEEP(89)),
+     &             id%COLSCA_loc(id%KEEP(89)),stat=allocok)
+          LALLOC = int(id%KEEP(89),8)*2_8
+        ELSE
+          ALLOCATE(id%ROWSCA_loc(id%KEEP(89)),stat=allocok)
+          id%COLSCA_loc => id%ROWSCA_loc
+          LALLOC = int(id%KEEP(89),8)
+        ENDIF
+        IF (allocok .GT. 0) THEN
+          id%INFO(1)=-13
+          CALL MUMPS_SET_IERROR(LALLOC,id%INFO(2))
+        ENDIF
+      ENDIF
+      CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                        id%COMM, id%MYID )
+C     Jump to 100 in case of error (we free everything)
+      IF (id%INFO(1) .LT. 0) GOTO 100
+      CALL MPI_BCAST(ROWSCA(1), id%N, MPI_DOUBLE_PRECISION,
+     &               MASTER, id%COMM, IERR_MPI)
+      IF (id%KEEP(50) .EQ. 0) THEN
+        CALL MPI_BCAST(COLSCA(1), id%N, MPI_DOUBLE_PRECISION,
+     &                 MASTER, id%COMM, IERR_MPI)
+      ENDIF
+      LIW_PASSED = max(id%KEEP(32),1)
+      ISCA = 1
+      IF ( id%MYID .ne. MASTER .OR.
+     &     id%KEEP(46) .eq. 1 ) THEN ! I_AM_SLAVE
+        DO ISTEP = 1, id%KEEP(28)
+          IF ( id%MYID_NODES.EQ. MUMPS_PROCNODE(
+     &         id%PROCNODE_STEPS(ISTEP),
+     &         id%KEEP(199) ) ) THEN
+              CALL MUMPS_SOL_GET_NPIV_LIELL_IPOS( ISTEP, id%KEEP,
+     &        NPIV, LIELL, IPOS,
+     &        id%IS(1), LIW_PASSED, id%PTLUST_S(1), id%STEP(1), id%N)
+            IF ( id%KEEP(50) .EQ. 0 ) THEN
+C             Row indices:
+              JROW = IPOS + 1
+C             Column indices:
+              JCOL = IPOS + 1 + LIELL
+            ELSE
+C             Use row indices because column indices may have
+C             been set to negative to flag 2x2 pivots
+              JROW = IPOS + 1
+            ENDIF
+            IF (id%KEEP(50).EQ.0) THEN
+              DO JJ = 1, NPIV
+                id%ROWSCA_loc(ISCA+JJ-1) = ROWSCA(id%IS(JROW+JJ-1))
+                id%COLSCA_loc(ISCA+JJ-1) = COLSCA(id%IS(JCOL+JJ-1))
+              ENDDO
+            ELSE
+              DO JJ = 1, NPIV
+                id%ROWSCA_loc(ISCA+JJ-1) = ROWSCA(id%IS(JROW+JJ-1))
+              ENDDO
+            ENDIF
+            ISCA = ISCA + NPIV
+          ENDIF
+        ENDDO
+      ENDIF
+C     End of EXTRACT_SCALING, we keep id%ROWSCA_loc and id%COLSCA_loc
+C     but free ROWSCA and COLSCA
+      GOTO 110
+      RETURN
+ 100  CONTINUE
+C     Exit with error, free what was allocated
+      IF (associated(id%ROWSCA_loc)) THEN
+        DEALLOCATE(id%ROWSCA_loc)
+        NULLIFY(id%ROWSCA_loc)
+      ENDIF
+      IF (associated(id%COLSCA_loc)) THEN
+        IF (id%KEEP(50) .EQ. 0) THEN
+          DEALLOCATE(id%COLSCA_loc)
+        ENDIF
+        NULLIFY(id%COLSCA_loc)
+      ENDIF
+ 110  CONTINUE
+C     Free local ROWSCA and COLSCA arrays
+      IF ( id%MYID .NE. 0) THEN
+        IF (associated(ROWSCA)) DEALLOCATE(ROWSCA)
+        IF ( id%KEEP(50) .EQ. 0 ) THEN
+          IF (associated(COLSCA)) DEALLOCATE(COLSCA)
+        ENDIF
+      ENDIF
+      NULLIFY(ROWSCA)
+      NULLIFY(COLSCA)
+      RETURN
+      END SUBROUTINE DMUMPS_EXTRACT_SCALING
+C
+C     ==================================================================
+C
       SUBROUTINE DMUMPS_EXTRACT_SCHUR_REDRHS(id)
       USE DMUMPS_STRUC_DEF
       IMPLICIT NONE
@@ -4338,3 +4839,145 @@ C                 of size SIZE_SCHUR.
       ENDIF
       RETURN
       END SUBROUTINE DMUMPS_EXTRACT_SCHUR_REDRHS
+      SUBROUTINE DMUMPS_EXTRACT_SINGULAR_VALUES(id)
+      USE DMUMPS_STRUC_DEF
+      IMPLICIT NONE
+C
+C  Purpose
+C  =======
+C
+C     
+      TYPE(DMUMPS_STRUC) :: id
+C
+C  Local variables
+C  ===============
+C
+      INCLUDE 'mpif.h'
+      INCLUDE 'mumps_tags.h'
+      INCLUDE 'mumps_headers.h'
+      INTEGER :: STATUS(MPI_STATUS_SIZE)
+      INTEGER :: IERR
+      INTEGER, PARAMETER :: MASTER = 0
+      INTEGER :: ID_ROOT, ALLOCOK
+C
+C  External functions
+C  ==================
+C
+      INTEGER MUMPS_PROCNODE
+      EXTERNAL MUMPS_PROCNODE
+C     Quick return in case factorization did not terminate correctly
+      IF (id%INFO(1) .LT. 0) RETURN
+C     Quick return if Postponing + rank revealing option off
+      IF (id%KEEP(19) .EQ. 0) RETURN
+C     Get Root id
+      ID_ROOT =MUMPS_PROCNODE(
+     &    id%PROCNODE_STEPS(id%STEP(id%KEEP(20))),
+     &    id%KEEP(199))
+      IF ( id%KEEP( 46 )  .NE. 1 ) THEN
+        ID_ROOT = ID_ROOT + 1
+      END IF  
+C     =================================
+C     Singular values are stored in 
+C     root%SINGULAR_VALUES
+C     We copy it to id%SINGULAR_VALUES
+C     =================================
+      IF ((ID_ROOT.EQ.id%MYID).AND.(id%MYID.EQ.MASTER)) THEN
+C        write(6,*) " singular_values already on host"
+         IF (associated(id%SINGULAR_VALUES))
+     &        DEALLOCATE(id%SINGULAR_VALUES)
+         NULLIFY(id%SINGULAR_VALUES)
+         id%NB_SINGULAR_VALUES=id%root%NB_SINGULAR_VALUES
+         ALLOCATE(id%SINGULAR_VALUES(id%NB_SINGULAR_VALUES)
+     &        , stat=ALLOCOK)
+         IF (ALLOCOK.GT.0) THEN
+            id%INFO(1)=-13
+            id%INFO(2)= id%NB_SINGULAR_VALUES
+            RETURN
+         END IF
+         CALL dcopy(id%NB_SINGULAR_VALUES,
+     &        id%root%SINGULAR_VALUES(1), 1,
+     &        id%SINGULAR_VALUES(1), 1)
+      ELSE
+         IF (id%MYID.EQ.ID_ROOT) THEN
+C     Send
+C           write(6,*) " id%MYID sends singular_values "
+            CALL MPI_SEND(
+     &           id%root%NB_SINGULAR_VALUES,
+     &           1,
+     &           MPI_INTEGER,
+     &           MASTER, TAG_ROOT1,
+     &           id%COMM, IERR )
+            CALL MPI_SEND(
+     &           id%root%SINGULAR_VALUES(1),
+     &           id%root%NB_SINGULAR_VALUES,
+     &           MPI_DOUBLE_PRECISION,
+     &           MASTER, TAG_ROOT2,
+     &           id%COMM, IERR )
+         ELSEIF (id%MYID.EQ.MASTER) THEN
+C     Receive
+            CALL MPI_RECV( id%NB_SINGULAR_VALUES,
+     &           1,
+     &           MPI_INTEGER, ID_ROOT, TAG_ROOT1,
+     &           id%COMM, STATUS, IERR )
+            IF (associated(id%SINGULAR_VALUES))
+     &           DEALLOCATE(id%SINGULAR_VALUES)
+            NULLIFY(id%SINGULAR_VALUES)
+            ALLOCATE(id%SINGULAR_VALUES(id%NB_SINGULAR_VALUES)
+     &           , stat=ALLOCOK)
+            IF (ALLOCOK.GT.0) THEN
+               id%INFO(1)=-13
+               id%INFO(2)= id%NB_SINGULAR_VALUES
+               RETURN
+            END IF
+            CALL MPI_RECV( id%SINGULAR_VALUES(1),
+     &           id%NB_SINGULAR_VALUES,
+     &           MPI_DOUBLE_PRECISION, ID_ROOT, TAG_ROOT2,
+     &           id%COMM, STATUS, IERR )
+         ENDIF
+      ENDIF
+      RETURN
+      END SUBROUTINE DMUMPS_EXTRACT_SINGULAR_VALUES
+      SUBROUTINE DMUMPS_SET_NOMP_MAX(KEEP281, KEEP361,
+     &                               N, NOMP_MAX)
+!$    USE OMP_LIB
+C
+C  Purpose
+C  =======
+C     set NOMP_MAX from KEEP(281)
+C     on output NOMP_MAX >=0
+C
+C  Parameters
+C  ==========
+C
+      INTEGER, INTENT(IN)    :: KEEP281, KEEP361, N
+      INTEGER, INTENT(OUT)   :: NOMP_MAX
+C     
+C     Local variables
+C   
+      INTEGER :: NOMP
+C
+C     out-of-range entries treated as -1
+      NOMP_MAX= max(-1, KEEP281)
+      NOMP    = 1
+!$    NOMP = omp_get_max_threads()
+      IF (NOMP_MAX.EQ.-1) THEN
+C     automatic setting
+       IF (N.LE.KEEP361) THEN
+         NOMP_MAX = 0
+         RETURN
+       ENDIF
+       IF (NOMP.GT.1) THEN
+C       conservative because of memory allocation
+        NOMP_MAX = min(NOMP, 10)
+       ELSE
+C       no multithreading and all parallel do suppressed
+        NOMP_MAX = 0
+       ENDIF
+      ELSE
+C     NOMP_MAX >=0
+C     use provided value
+       NOMP_MAX = min(NOMP_MAX, NOMP)
+      ENDIF
+C
+      RETURN
+      END SUBROUTINE DMUMPS_SET_NOMP_MAX
diff -pruN 5.6.2-2.1/src/dfac_front_LDLT_type1.F 5.7.1-1/src/dfac_front_LDLT_type1.F
--- 5.6.2-2.1/src/dfac_front_LDLT_type1.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_front_LDLT_type1.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -136,7 +136,7 @@ C
       XSIZE  = KEEP(IXSZ)
       NFRONT = IW(IOLDPS+XSIZE)
       LDA    = NFRONT
-      NASS   = iabs(IW(IOLDPS+2+XSIZE))
+      NASS   = abs(IW(IOLDPS+2+XSIZE))
       IW(IOLDPS+3+XSIZE) =  -99999
       LR_ACTIVATED= .FALSE.        
       COMPRESS_PANEL = .FALSE.
@@ -251,7 +251,8 @@ C
      &        NFRONT-NASS, LRGROUPS, NPARTSCB, 
      &        NPARTSASS, BEGS_BLR)
          CALL REGROUPING2(BEGS_BLR, NPARTSASS, NASS, NPARTSCB,
-     &        NFRONT-NASS, KEEP(488), .FALSE., KEEP(472))     
+     &        NFRONT-NASS, KEEP(488), .FALSE., KEEP(472), 
+     &        NFRONT, KEEP(1))     
          NB_BLR = NPARTSASS + NPARTSCB
          call MAX_CLUSTER(BEGS_BLR,NB_BLR,MAXI_CLUSTER)
          MAXI_RANK = KEEP(479)*MAXI_CLUSTER
diff -pruN 5.6.2-2.1/src/dfac_front_LDLT_type2.F 5.7.1-1/src/dfac_front_LDLT_type2.F
--- 5.6.2-2.1/src/dfac_front_LDLT_type2.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_front_LDLT_type2.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -74,7 +74,7 @@ C
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
       INTEGER, INTENT(IN) :: NINROWARR(KEEP(195))
       INTEGER, INTENT(IN) :: PTRDEBARR(KEEP(196))
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INTEGER(8) :: PTRAST(KEEP(28))
       INTEGER(8) :: PTRFAC(KEEP(28))
       INTEGER(8) :: PAMASTER(KEEP(28))
@@ -187,7 +187,7 @@ C
       IOLDPS = PTLUST_S(STEP( INODE ))
       POSELT = PTRAST(STEP( INODE ))
       NFRONT = IW(IOLDPS+XSIZE)
-      NASS   = iabs(IW(IOLDPS+2+XSIZE))
+      NASS   = abs(IW(IOLDPS+2+XSIZE))
       LDAFS  = NASS
       IF ((KEEP(219).EQ.1).AND.(KEEP(207).EQ.1).AND.(KEEP(50).EQ.2)
      &   ) THEN
@@ -299,7 +299,8 @@ C
      &        0, LRGROUPS, NPARTSCB, 
      &        NPARTSASS, BEGS_BLR)
          CALL REGROUPING2(BEGS_BLR, NPARTSASS, NASS, NPARTSCB,
-     &        0, KEEP(488), .FALSE., KEEP(472))     
+     &        0, KEEP(488), .FALSE., KEEP(472), 
+     &        NFRONT, KEEP(1))     
          NB_BLR = NPARTSASS + NPARTSCB
          call MAX_CLUSTER(BEGS_BLR,NB_BLR,MAXI_CLUSTER)
          MAXI_RANK = KEEP(479)*MAXI_CLUSTER
diff -pruN 5.6.2-2.1/src/dfac_front_LU_type1.F 5.7.1-1/src/dfac_front_LU_type1.F
--- 5.6.2-2.1/src/dfac_front_LU_type1.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_front_LU_type1.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -143,7 +143,7 @@ C
       LAFAC  = -9999_8  
       XSIZE      = KEEP(IXSZ)
       NFRONT     = IW(IOLDPS+XSIZE)
-      NASS       = iabs(IW(IOLDPS+2+XSIZE))
+      NASS       = abs(IW(IOLDPS+2+XSIZE))
       IW(IOLDPS+3+XSIZE) =  -99999
       LR_ACTIVATED = .FALSE.        
       COMPRESS_PANEL = .FALSE.
@@ -257,7 +257,8 @@ C
      &        NFRONT-NASS, LRGROUPS, NPARTSCB, 
      &        NPARTSASS, BEGS_BLR)
          CALL REGROUPING2(BEGS_BLR, NPARTSASS, NASS, NPARTSCB,
-     &        NFRONT-NASS, KEEP(488), .FALSE., KEEP(472))     
+     &        NFRONT-NASS, KEEP(488), .FALSE., KEEP(472), 
+     &        NFRONT, KEEP(1))     
          NB_BLR = NPARTSASS + NPARTSCB
          call MAX_CLUSTER(BEGS_BLR,NB_BLR,MAXI_CLUSTER)
          MAXI_RANK = KEEP(479)*MAXI_CLUSTER
diff -pruN 5.6.2-2.1/src/dfac_front_LU_type2.F 5.7.1-1/src/dfac_front_LU_type2.F
--- 5.6.2-2.1/src/dfac_front_LU_type2.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_front_LU_type2.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -75,7 +75,7 @@ C
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
       INTEGER, INTENT(IN) :: NINROWARR(KEEP(195))
       INTEGER, INTENT(IN) :: PTRDEBARR(KEEP(196))
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INTEGER(8) :: PTRAST(KEEP(28))
       INTEGER(8) :: PTRFAC(KEEP(28))
       INTEGER(8) :: PAMASTER(KEEP(28))
@@ -166,7 +166,7 @@ C
       POSELT = PTRAST(STEP( INODE ))
       XSIZE  = KEEP(IXSZ)
       NFRONT = IW(IOLDPS+XSIZE)
-      NASS   = iabs(IW(IOLDPS+2+XSIZE))
+      NASS   = abs(IW(IOLDPS+2+XSIZE))
       IW(IOLDPS+3+XSIZE) =  -99999
       LR_ACTIVATED   = (IW(IOLDPS+XXLR).GT.0)
       COMPRESS_PANEL = (IW(IOLDPS+XXLR).GE.2)
@@ -286,7 +286,8 @@ C
      &        NFRONT-NASS, LRGROUPS, NPARTSCB, 
      &        NPARTSASS, BEGS_BLR)
          CALL REGROUPING2(BEGS_BLR, NPARTSASS, NASS, NPARTSCB,
-     &        NFRONT-NASS, KEEP(488), .FALSE., KEEP(472))     
+     &        NFRONT-NASS, KEEP(488), .FALSE., KEEP(472), 
+     &        NFRONT, KEEP(1))     
          NB_BLR = NPARTSASS + NPARTSCB
          call MAX_CLUSTER(BEGS_BLR,NB_BLR,MAXI_CLUSTER)
          MAXI_RANK = KEEP(479)*MAXI_CLUSTER
diff -pruN 5.6.2-2.1/src/dfac_front_aux.F 5.7.1-1/src/dfac_front_aux.F
--- 5.6.2-2.1/src/dfac_front_aux.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_front_aux.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -129,7 +129,7 @@ C
             ELSE
               IF (J3.EQ.0) GOTO 370
 #if defined(_OPENMP)
-              IF (KEEP(351).EQ.1 .AND. J3.GE.KEEP(360)) THEN
+              IF (J3.GE.KEEP(360)) THEN
                 J1_ini = J1
                 CHUNK = max(KEEP(360)/2,(J3+NOMP-1)/NOMP)
 !$OMP  PARALLEL DO schedule(static, CHUNK)
@@ -289,7 +289,7 @@ C
           ENDIF
         ENDIF
 #endif
-        IF (KEEP(351).EQ.2) THEN
+        IF (KEEP(351).EQ.1) THEN
           MAXFROMN = 0.0D0
           IF (NEL2 > 0) THEN
             IS_MAXFROMN_AVAIL = .TRUE.
@@ -677,6 +677,9 @@ C
         NPIV   = IW(IOLDPS+1+XSIZE)
         IBEG_BLOCK = NPIV
         IF (NASS.EQ.NPIV) GOTO 500
+        IF (KEEP(19).GT.0) THEN
+         GOTO 500
+        ENDIF
         IS_MAXFROMN_AVAIL = .FALSE.
  120    CALL DMUMPS_FAC_H(NFRONT,NASS,IW,LIW,A,LA,
      &     INOPV, NOFFW,
@@ -762,6 +765,7 @@ C
       DOUBLE PRECISION ZERO
       PARAMETER( ZERO = 0.0D0 )
       DOUBLE PRECISION RZERO, RMAX, AMROW, MAX_PREV_in_PARPIV
+      DOUBLE PRECISION RCMAX
       INTEGER(8) :: APOSMAX, APOSROW
       DOUBLE PRECISION       :: RMAX_NORELAX
       DOUBLE PRECISION PIVNUL, ABS_PIVOT
@@ -1006,11 +1010,45 @@ C
             RMAX         = max(RMAX,abs(RMAX_NORELAX))
             IF (ABS_PIVOT .GE. UU*RMAX .AND.
      &          ABS_PIVOT .GT. max(SEUIL,tiny(RMAX))) THEN
+               IF (KEEP(19).GT.0) THEN
+                 IF (LAST_ROW.EQ.NFRONT) THEN
+                   LRLOC = LAST_ROW -KEEP(253)-NVSCHUR
+                 ELSE
+                   LRLOC = LAST_ROW
+                 ENDIF
+                 J1=POSELT+int(IPIV-1,8)+int(NPIV,8)*NFRONT8
+                 J2=POSELT+int(IPIV-1,8)+int(LRLOC-1,8)*NFRONT8
+                 RCMAX = RZERO
+                 DO JJ=J1, J2, NFRONT8
+                   RCMAX = max(abs(A(JJ)),RCMAX)
+                 ENDDO
+                 IF (ABS_PIVOT .GE. UU*RCMAX) THEN
+                   JMAX = IPIV - NPIV
+                   GO TO 380
+                 ENDIF
+               ELSE
                 JMAX = IPIV - NPIV
                 GO TO 380
+               ENDIF
             ENDIF
             IF ( .NOT. (AMROW .GE. UU*RMAX .AND.
      &                  AMROW .GT. max(SEUIL,tiny(RMAX))) ) GO TO 460
+            IF (KEEP(19).GT.0) THEN
+              IF (LAST_ROW.EQ.NFRONT) THEN
+                LRLOC = LAST_ROW -KEEP(253)-NVSCHUR
+              ELSE
+                LRLOC = LAST_ROW
+              ENDIF
+              J1=POSELT+int(NPIV+JMAX-1,8)+int(NPIV,8)*NFRONT8
+              J2=POSELT+int(NPIV+JMAX-1,8)+int(LRLOC-1,8)*NFRONT8
+              RCMAX = RZERO
+              DO JJ=J1, J2, NFRONT8
+                RCMAX = max(abs(A(JJ)),RCMAX)
+              ENDDO
+              IF (.NOT.(AMROW .GE. UU*RCMAX) ) THEN 
+                GO TO 460
+              ENDIF
+            ENDIF 
             NOFFW = NOFFW + 1
   380       CONTINUE
           IF (K206.GE.1) THEN
@@ -1855,10 +1893,6 @@ C
          LPOS1   = POSPV2 + LDA8 - 1_8
          LPOS2   = LPOS1 + 1_8
 #if defined(__ve__)
-#if defined(check)
-         IF (LDA8.NE.NFRONT8) CALL MUMPS_ABORT()
-         IF (NEL2 + NCB1.NE.LAST_ROW-NPIV_NEW) CALL MUMPS_ABORT()
-#endif
          CALL dcopy(LAST_ROW-NPIV_NEW, A(LPOS1), LDA, A(POSPV1+2_8), 1)
          CALL dcopy(LAST_ROW-NPIV_NEW, A(LPOS2), LDA, A(POSPV2+1_8), 1)
 !$       OMP_FLAG = (NEL2+NCB1 > 300)
@@ -2025,21 +2059,6 @@ C
            BLSIZE = LAST_COL_GEMM - IEND_BLOCK
           END IF
           IF ( LAST_COL_GEMM - IEND_BLOCK .GT. 0 ) THEN
-#if defined(SAK_BYROW)
-           DO IROW = IEND_BLOCK+1, LAST_COL_GEMM, BLSIZE
-            Block = min( BLSIZE, LAST_COL_GEMM - IROW + 1 )
-            LPOS = POSELT + int(IROW  - 1,8) * LDA8 +
-     &                      int(IBEG_BLOCK - 1,8)
-            UPOS = POSELT + int(IBEG_BLOCK - 1,8) * LDA8 +
-     &                      int(IROW - 1,8)
-            APOS = POSELT + int(IROW  - 1,8) * LDA8 + 
-     &             int(IEND_BLOCK,8)
-            CALL dgemm( 'N','N', IROW + Block - IEND_BLOCK - 1, 
-     &             Block, NPIV_BLOCK,
-     &                 ALPHA, A( UPOS ), LDA,
-     &                 A( LPOS ), LDA, ONE, A( APOS ), LDA )
-           ENDDO
-#else
            DO IROW = IEND_BLOCK+1, LAST_COL_GEMM, BLSIZE
             Block = min( BLSIZE, LAST_COL_GEMM - IROW + 1 )
             LPOS = POSELT + int( IROW - 1,8) * LDA8 +
@@ -2051,7 +2070,6 @@ C
      &                 NPIV_BLOCK, ALPHA, A( UPOS ), LDA,
      &                 A( LPOS ), LDA, ONE, A( APOS ), LDA )
            END DO
-#endif
           END IF
 #if defined(GEMMT_AVAILABLE)
          END IF 
diff -pruN 5.6.2-2.1/src/dfac_front_type2_aux.F 5.7.1-1/src/dfac_front_type2_aux.F
--- 5.6.2-2.1/src/dfac_front_type2_aux.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_front_type2_aux.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -738,7 +738,7 @@ C
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
       INTEGER, INTENT(IN) :: NINROWARR(KEEP(195))
       INTEGER, INTENT(IN) :: PTRDEBARR(KEEP(196))
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INTEGER(8) :: PTRAST  (KEEP(28))
       INTEGER(8) :: PTRFAC  (KEEP(28))
       INTEGER(8) :: PAMASTER(KEEP(28))
@@ -808,7 +808,7 @@ C
      &               NSLAVES, WIDTH, COMM,
      &               NELIM, NPARTSASS, CURRENT_BLR_PANEL,
      &               LR_ACTIVATED, BLR_LorU, 
-     &        IERR )
+     &               ICNTL, IERR )
           IF (IERR.EQ.-1) THEN
             BLOCKING  = .FALSE.
             SET_IRECV = .TRUE.
diff -pruN 5.6.2-2.1/src/dfac_lastrtnelind.F 5.7.1-1/src/dfac_lastrtnelind.F
--- 5.6.2-2.1/src/dfac_lastrtnelind.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_lastrtnelind.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -68,7 +68,7 @@ C
      &        TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
       DOUBLE PRECISION OPASSW, OPELIW
       INTEGER ITLOC( N+KEEP(253) ), FILS( N ), DAD( KEEP(28) )
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
diff -pruN 5.6.2-2.1/src/dfac_lr.F 5.7.1-1/src/dfac_lr.F
--- 5.6.2-2.1/src/dfac_lr.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_lr.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/dfac_mem_alloc_cb.F 5.7.1-1/src/dfac_mem_alloc_cb.F
--- 5.6.2-2.1/src/dfac_mem_alloc_cb.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_mem_alloc_cb.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/dfac_mem_compress_cb.F 5.7.1-1/src/dfac_mem_compress_cb.F
--- 5.6.2-2.1/src/dfac_mem_compress_cb.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_mem_compress_cb.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -148,9 +148,6 @@ C
       INTEGER(8) :: RCURRENT_SIZE, DYN_SIZE
       LOGICAL :: RECORD_CAN_BE_COMPRESSED
       INTEGER IXXP
-      INTEGER, EXTERNAL :: MUMPS_TYPENODE
-      INTEGER, EXTERNAL :: MUMPS_PROCNODE
-      LOGICAL, EXTERNAL :: DMUMPS_ISBAND
       EXTERNAL MPI_WTIME
       DOUBLE PRECISION MPI_WTIME
       DOUBLE PRECISION TIME_STRT
diff -pruN 5.6.2-2.1/src/dfac_mem_dynamic.F 5.7.1-1/src/dfac_mem_dynamic.F
--- 5.6.2-2.1/src/dfac_mem_dynamic.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/dfac_mem_dynamic.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -251,7 +251,7 @@ C
             ENDIF
           ENDIF
           IF ( MOVE2DYNAMIC ) THEN
-#if defined(MUMPS_ALLOC_FROM_C)
+#if defined(MUMPS_ALLOC_FROM_C) || defined(_CRAYFTN)
             CALL MUMPS_MALLOC_C( TMP_ADDRESS,
      &      RCURRENT_SIZE * KEEP(35) )
             IF (TMP_ADDRESS .EQ. 0_8) THEN
@@ -279,7 +279,7 @@ C
      &        LIW-ICURRENT+1, SIZEHOLE, KEEP(IXSZ))
             ENDIF
             CALL MUMPS_STOREI8(RCURRENT_SIZE,IW(ICURRENT+XXD))
-#if defined(MUMPS_ALLOC_FROM_C)
+#if defined(MUMPS_ALLOC_FROM_C) || defined(_CRAYFTN)
             CALL DMUMPS_DM_SET_PTR( TMP_ADDRESS, RCURRENT_SIZE,
      &                              DYNAMIC_CB )
 #else
@@ -438,7 +438,7 @@ C
       LOGICAL, INTENT(IN) :: ATOMIC_UPDATES
       INTEGER(8) :: KEEP8(150)
       INTEGER IDUMMY
-#if defined(MUMPS_ALLOC_FROM_C)
+#if defined(MUMPS_ALLOC_FROM_C) || defined(_CRAYFTN)
       CALL MUMPS_FREE_C(DYNPTR(1))
 #else
       DEALLOCATE(DYNPTR)
diff -pruN 5.6.2-2.1/src/dfac_mem_free_block_cb.F 5.7.1-1/src/dfac_mem_free_block_cb.F
--- 5.6.2-2.1/src/dfac_mem_free_block_cb.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_mem_free_block_cb.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/dfac_mem_stack.F 5.7.1-1/src/dfac_mem_stack.F
--- 5.6.2-2.1/src/dfac_mem_stack.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_mem_stack.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -58,7 +58,7 @@ C
       INTEGER INTARR(KEEP8(27)) 
       INTEGER ITLOC( N + KEEP(253) ), FILS( N ), DAD( KEEP(28) ),
      &        ND( KEEP(28) ), FRERE( KEEP(28) )
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INTEGER ISTEP_TO_INIV2(KEEP(71)), 
      &        TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
       INTEGER NELT, LPTRAR
@@ -111,9 +111,8 @@ C
       DOUBLE PRECISION FLOP1, FLOP1_EFFECTIVE
       LOGICAL BLOCKING, SET_IRECV, MESSAGE_RECEIVED
       LOGICAL SSARBR, SSARBR_ROOT, MUMPS_INSSARBR,
-     & MUMPS_IN_OR_ROOT_SSARBR, MUMPS_ROOTSSARBR
-      EXTERNAL MUMPS_INSSARBR, MUMPS_IN_OR_ROOT_SSARBR,
-     & MUMPS_ROOTSSARBR
+     & MUMPS_IN_OR_ROOT_SSARBR
+      EXTERNAL MUMPS_INSSARBR, MUMPS_IN_OR_ROOT_SSARBR
       LP = ICNTL(1)
       IF (ICNTL(4) .LE. 0) LP = -1
       INPLACE = .FALSE.
@@ -123,7 +122,7 @@ C
       NFRONT = IW(IOLDPS+KEEP(IXSZ))
       NPIV   = IW(IOLDPS + 1+KEEP(IXSZ))       
       NMAXNPIV = max(NPIV, NMAXNPIV)
-      NASS   = iabs(IW(IOLDPS + 2+KEEP(IXSZ))) 
+      NASS   = abs(IW(IOLDPS + 2+KEEP(IXSZ))) 
       NSLAVES=  IW(IOLDPS+5+KEEP(IXSZ))
       H_INODE= 6 + NSLAVES + KEEP(IXSZ)
       LCONT = NFRONT - NPIV
diff -pruN 5.6.2-2.1/src/dfac_mem_stack_aux.F 5.7.1-1/src/dfac_mem_stack_aux.F
--- 5.6.2-2.1/src/dfac_mem_stack_aux.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_mem_stack_aux.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/dfac_omp_m.F 5.7.1-1/src/dfac_omp_m.F
--- 5.6.2-2.1/src/dfac_omp_m.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/dfac_omp_m.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -64,7 +64,7 @@ C
       INTEGER(8), INTENT(IN) :: THREAD_LA
       INTEGER PROCNODE_STEPS(KEEP(28))
       INTEGER ITLOC(N+KEEP(253))
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INTEGER NSTK_STEPS(KEEP(28))
       INTEGER(8), INTENT(IN) :: PTRARW(LPTRAR), PTRAIW(LPTRAR)
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
@@ -118,14 +118,8 @@ C
       INTEGER, INTENT (IN)    :: NBCOLS_I4, NBCOLS_I8
       INTEGER, INTENT (IN)    :: I4_L0_OMP(NBSTATS_I4, NBCOLS_I4)
       INTEGER(8), INTENT (IN) :: I8_L0_OMP(NBSTATS_I8, NBCOLS_I8)
-      EXTERNAL MUMPS_TYPENODE, MUMPS_PROCNODE
-      INTEGER MUMPS_TYPENODE, MUMPS_PROCNODE
-      LOGICAL MUMPS_INSSARBR,MUMPS_ROOTSSARBR
-      EXTERNAL MUMPS_INSSARBR,MUMPS_ROOTSSARBR
       LOGICAL DMUMPS_POOL_EMPTY
       EXTERNAL DMUMPS_POOL_EMPTY, DMUMPS_EXTRACT_POOL
-      INTEGER numroc
-      EXTERNAL numroc
       INTEGER :: MYTHREAD_ID, ITH  
       INTEGER :: THREAD_ID_P       
       DOUBLE PRECISION, PARAMETER :: DZERO = 0.0D0, DONE = 1.0D0
@@ -1216,7 +1210,7 @@ C
       INTEGER ITLOC( N + KEEP(253) ), FILS( N ),
      &        ND( KEEP(28) ), FRERE( KEEP(28) )
       INTEGER DAD( KEEP(28) )
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INTEGER ISTEP_TO_INIV2(KEEP(71)), 
      &        TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
       INTEGER NELT, LPTRAR
diff -pruN 5.6.2-2.1/src/dfac_par_m.F 5.7.1-1/src/dfac_par_m.F
--- 5.6.2-2.1/src/dfac_par_m.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/dfac_par_m.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -32,6 +32,7 @@ C
 !$    USE OMP_LIB
       USE DMUMPS_DYNAMIC_MEMORY_M, ONLY : 
      &                                    DMUMPS_DM_FREEALLDYNAMICCB
+      USE DMUMPS_BUF, ONLY : DMUMPS_BUF_TEST
       USE DMUMPS_LOAD
       USE DMUMPS_OOC
       USE DMUMPS_FAC_ASM_MASTER_M
@@ -64,7 +65,7 @@ C
       INTEGER LPOOL
       INTEGER PROCNODE_STEPS(KEEP(28))
       INTEGER ITLOC(N+KEEP(253))
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INTEGER IW(LIW), NSTK_STEPS(KEEP(28))
       INTEGER(8), INTENT(IN) :: PTRARW(LPTRAR), PTRAIW(LPTRAR)
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
@@ -132,15 +133,31 @@ C
       INTEGER LOCAL_M, LOCAL_N
       INTEGER LRHS_CNTR_MASTER_ROOT, FWD_LOCAL_N_RHS
       LOGICAL ROOT_OWNER
+!$    INTEGER :: NOMP
+!$    INTEGER(8) :: CHUNK8  
+      INTEGER  LIWK_RR, PHASE, MBLOCK, NBLOCK
+      INTEGER(8) :: LWK_RR
+      INTEGER(8) :: I8
+      INTEGER  I, K, KEEP17_LU
+      INTEGER  NOFFNEGPV_ROOT, NTOTPV_ROOT, NB22T1_ROOT, NBTINY_ROOT,
+     &         NULLNEGPV_ROOT,
+     &         DET_EXP_ROOT, DET_SIGN_ROOT, 
+     &         LRecord, Header_ROOT(5)
+      DOUBLE PRECISION  DET_MANT_ROOT  
+      DOUBLE PRECISION DKEEP_SAVE(230)
+      DOUBLE PRECISION, DIMENSION(:), POINTER     :: A_ROOT_SAVE
+      LOGICAL                            :: IS_A_ROOT_SAVE_ALLOCATED
+      INTEGER, DIMENSION(:), ALLOCATABLE :: RECORD_ROOT
+      INTEGER KEEP_SAVE(500)             
+      INTEGER(8) KEEP8_SAVE(150)
       EXTERNAL MUMPS_TYPENODE, MUMPS_PROCNODE
       INTEGER MUMPS_TYPENODE, MUMPS_PROCNODE
-      LOGICAL MUMPS_INSSARBR,MUMPS_ROOTSSARBR
-      EXTERNAL MUMPS_INSSARBR,MUMPS_ROOTSSARBR
+      LOGICAL MUMPS_INSSARBR
+      EXTERNAL MUMPS_INSSARBR
       LOGICAL DMUMPS_POOL_EMPTY
       EXTERNAL DMUMPS_POOL_EMPTY, DMUMPS_EXTRACT_POOL
       LOGICAL STACK_RIGHT_AUTHORIZED
-      INTEGER numroc
-      EXTERNAL numroc
+      INTEGER, EXTERNAL :: MUMPS_NUMROC
       INTEGER JOBASS, ETATASS
       INTEGER(8) :: LAFAC
       INTEGER LIWFAC, STRAT, TYPEFile, NextPiv2beWritten,
@@ -153,13 +170,6 @@ C
       DOUBLE PRECISION :: ROOTTIME
       INTEGER:: ITH
       DOUBLE PRECISION :: DUMMY_FLOP_ESTIM_ACC
-#if defined(multicore_profiling)
-      DOUBLE PRECISION :: LATIME, LFTIME, LSTIME
-      DOUBLE PRECISION :: GATIME, GFTIME, GSTIME
-      GATIME = 0
-      GFTIME = 0
-      GSTIME = 0
-#endif
       DUMMY_FLOP_ESTIM_ACC = 0.0d0
       ITLOC(1:N+KEEP(253)) =0
       ASS_IRECV = MPI_REQUEST_NULL
@@ -169,6 +179,9 @@ C
       NULLIFY(BUFRX)
       IS_BUFRX_ALLOCATED = .FALSE.
       KEEP(143) = -1
+      KEEP17_LU = -1
+      NULLIFY(A_ROOT_SAVE)
+      IS_A_ROOT_SAVE_ALLOCATED = .FALSE.
       IF ( INFO(1) .LT. 0 ) THEN
         GOTO 640
       ENDIF
@@ -301,6 +314,8 @@ C
      &         MYID_NODES,KEEP,KEEP8,N)
             END IF
             GOTO 30
+          ELSE
+            CALL DMUMPS_BUF_TEST()
           ENDIF
       ENDIF
       GO TO 20
@@ -532,8 +547,26 @@ C
           WRITE(*,*) "ERROR 2 in DMUMPS_FAC_PAR", POSELT
           GOTO 635
         ENDIF
+        IF (KEEP(118).GE.40) THEN
+          IOLDPS = PTLUST(STEP(INODE))
+          LRecord = IW(IOLDPS+XXI)
+          IF (allocated(RECORD_ROOT)) DEALLOCATE(RECORD_ROOT)
+          ALLOCATE(RECORD_ROOT(LRecord), stat=IERR)
+          IF (IERR.GT.0) THEN
+            INFO(1)= -13
+            INFO(2)= LRecord
+            IF (LP > 0)
+     &      write(LP,*) "ERROR allocate RECORD_ROOT"
+            GOTO 635
+          ENDIF
+          RECORD_ROOT(1:LRecord) = IW(IOLDPS:IOLDPS+LRecord-1)
+        ENDIF
         CALL DMUMPS_CHANGE_HEADER
      &       ( IW(PTLUST(STEP(INODE))+KEEP(IXSZ)), KEEP(253) )
+        IF (KEEP(118).GE.40) THEN
+          Header_ROOT(1:5) = IW(PTLUST(STEP(INODE))+KEEP(IXSZ):
+     &                        PTLUST(STEP(INODE))+KEEP(IXSZ)+4)
+        ENDIF
         GOTO 200
       END IF
       POSELT = PTRAST(STEP(INODE))
@@ -554,11 +587,6 @@ C
      &           , PERM
      &           )
            IF (INFO(1).LT.0) GOTO 635
-#if defined(multicore_profiling)
-         LFTIME = MPI_WTIME() - LFTIME
-         GFTIME = GFTIME + LFTIME
-         WRITE(*,*)'FAC ',LFTIME
-#endif
       ELSE  
             IW( IOLDPS+4+KEEP(IXSZ) ) = 1
               CALL DMUMPS_FAC1_LDLT( N, INODE,
@@ -577,9 +605,6 @@ C
           ENDIF 
           JOBASS = ETATASS          
           IF (JOBASS.EQ.1) THEN
-#if defined(multicore_profiling)
-              LATIME = MPI_WTIME()
-#endif
               CALL DMUMPS_FAC_ASM_NIV1(COMM_LOAD, ASS_IRECV,
      &        N,INODE,IW,LIW,A,LA,
      &        INFO(1),ND,
@@ -598,11 +623,6 @@ C
      &        JOBASS,ETATASS
      &               , LRGROUPS
      &         )
-#if defined(multicore_profiling)
-         LATIME = MPI_WTIME() - LATIME
-         GATIME = GATIME + LATIME
-         WRITE(*,*)'ASS ',LATIME
-#endif
           ENDIF
           IF (MPA.GT.0)
      &    CALL MUMPS_PRINT_STILL_ACTIVE (MYID_NODES, KEEP, 
@@ -617,9 +637,6 @@ C
       ELSE
         TYPEF = -9999
       END IF
-#if defined(multicore_profiling)
-         LSTIME = MPI_WTIME()
-#endif
       CALL DMUMPS_FAC_STACK( COMM_LOAD, ASS_IRECV,
      &       N,INODE,TYPE,TYPEF,LA,IW,LIW,A,
      &       INFO(1),INFO(2),OPELI,NELVA,NMAXNPIV,
@@ -638,11 +655,6 @@ C
      &               , LRGROUPS
      &       ,DUMMY_FLOP_ESTIM_ACC
      &       )
-#if defined(multicore_profiling)
-         LSTIME = MPI_WTIME() - LSTIME
-         GSTIME = GSTIME + LSTIME
-         WRITE(*,*)'STK ',LSTIME
-#endif
       IF (MPA.GT.0)
      &   CALL MUMPS_PRINT_STILL_ACTIVE (MYID_NODES, KEEP, 
      &                        dble(DKEEP(17)), 
@@ -712,6 +724,7 @@ C
       ENDIF
       GO TO 20
  635  CONTINUE
+      IF (allocated(RECORD_ROOT)) DEALLOCATE(RECORD_ROOT)
       CALL DMUMPS_BDC_ERROR( MYID_NODES, SLAVEF, COMM_NODES, KEEP )
  640  CONTINUE
         CALL DMUMPS_CANCEL_IRECV( INFO(1),
@@ -914,8 +927,8 @@ C
                   CALL MUMPS_PROPINFO( ICNTL, INFO, COMM_NODES,
      &            MYID_NODES)
                   IF (root%yes .AND. INFO(1).GE.0) THEN
-                    FWD_LOCAL_N_RHS = numroc(KEEP(253), root%NBLOCK,
-     &              root%MYCOL, 0, root%NPCOL)
+                    FWD_LOCAL_N_RHS = MUMPS_NUMROC(KEEP(253),
+     &              root%NBLOCK, root%MYCOL, 0, root%NPCOL)
                     FWD_LOCAL_N_RHS = max(1,FWD_LOCAL_N_RHS)
                     CALL DMUMPS_GATHER_ROOT( MYID_NODES,
      &              root%TOT_ROOT_SIZE, KEEP(253),
@@ -941,6 +954,279 @@ C
                    NTOTPV = NTOTPV + NFRONT 
                    NMAXNPIV = max(NMAXNPIV,NFRONT)
                 END IF
+                IF ( KEEP(60) .EQ. 0 ) THEN
+                 IF ( ROOT_OWNER ) THEN
+                  IF (KEEP(118).GE.40) THEN
+                   NOFFNEGPV_ROOT = 0        
+                   NULLNEGPV_ROOT = 0        
+                   NTOTPV_ROOT = 0
+                   NB22T1_ROOT = 0
+                   NBTINY_ROOT = 0
+                   DET_SIGN_ROOT = 1
+                   DET_EXP_ROOT = 0
+                   DET_MANT_ROOT = 1.0D0
+                   DKEEP_SAVE(:) = DKEEP(:)
+                   KEEP_SAVE(:)  = KEEP(:)
+                   KEEP8_SAVE(:) = KEEP8(:)
+                   KEEP_SAVE(201) = 0
+                   IF (KEEP(110).EQ.0) THEN
+                     KEEP_SAVE(110)= 1        
+                     IF (KEEP(118).EQ.40) THEN
+                      IF ((DKEEP(10).LE.0).OR.(DKEEP(10).GT.1)) THEN
+                             DKEEP_SAVE(1) = DKEEP(9)*1D-1
+                      ELSE
+                             DKEEP_SAVE(1) = DKEEP(9)*DKEEP(10) 
+                      ENDIF    
+                     ELSE IF (KEEP(118).EQ.41) THEN
+                        DKEEP_SAVE(1) = DKEEP(9)
+                     ELSE IF (KEEP(118).EQ.42) THEN
+                      IF (DKEEP(13).LT.1)  THEN
+                          DKEEP_SAVE(1) = DKEEP(9)*10 
+                      ELSE
+                         DKEEP_SAVE(1) = DKEEP(9)*DKEEP(13)       
+                      ENDIF
+                     ENDIF  
+                   ELSE 
+                     DKEEP_SAVE(1) = DKEEP(9)
+                   ENDIF 
+                   IS_A_ROOT_SAVE_ALLOCATED = .FALSE.
+                   IF (LRLU.GT.NFRONT8*NFRONT8) THEN
+                     A_ROOT_SAVE  => A(POSFAC:POSFAC+LRLU-1_8)
+                   ELSE
+                    IF (associated(A_ROOT_SAVE)) 
+     &                               DEALLOCATE(A_ROOT_SAVE)
+                    ALLOCATE(A_ROOT_SAVE(NFRONT8*NFRONT8),stat=IERR)
+                    IF (IERR.GT.0) THEN
+                     INFO(1) = -13
+                     CALL MUMPS_SET_IERROR(NFRONT8*NFRONT8, INFO(2) )
+                     IF (LP > 0 )
+     &                 write(LP,*) "ERROR allocating A_ROOT_SAVE ",
+     &                 " of size ", NFRONT*NFRONT
+                     GOTO 735
+                    ENDIF
+                    IS_A_ROOT_SAVE_ALLOCATED = .TRUE.
+                   ENDIF
+!$        NOMP = OMP_GET_MAX_THREADS()
+!$        CHUNK8=int(KEEP(361),8)
+!$OMP     PARALLEL DO PRIVATE(I8) SCHEDULE(STATIC, CHUNK8)
+!$OMP&    IF ( NFRONT8*NFRONT8 > int(KEEP(361),8) .AND. NOMP .GT. 1)
+                   DO I8 =1_8, NFRONT8*NFRONT8
+                       A_ROOT_SAVE(I8) = 
+     &                   A(PTRAST(STEP(KEEP(20)))+I8-1_8)
+                   ENDDO
+                   IW(PTLUST(STEP(INODE))+KEEP(IXSZ): 
+     &                    PTLUST(STEP(INODE))+KEEP(IXSZ)+4)
+     &                 = RECORD_ROOT(KEEP(IXSZ)+1:KEEP(IXSZ)+5)
+                   IW(PTLUST(STEP(INODE))+XXLR) = 0
+                   IF (KEEP(50).EQ.0) THEN
+                    CALL DMUMPS_FAC1_LU_I ( 
+     &               N, INODE, IW, LIW, A_ROOT_SAVE(1),
+     &               NFRONT8*NFRONT8, IPOSROOT, 1_8,
+     &               INFO(1), INFO(2), UU, NOFFNEGPV_ROOT, NTOTPV_ROOT,
+     &               NBTINY_ROOT,
+     &               DET_EXP_ROOT, DET_MANT_ROOT, DET_SIGN_ROOT,
+     &               KEEP_SAVE,KEEP8_SAVE,
+     &               STEP, PROCNODE_STEPS, MYID_NODES, SLAVEF,
+     &               SEUIL, AVOID_DELAYED, ETATASS,
+     &               DKEEP_SAVE(1), PIVNUL_LIST_STRUCT, IWPOS 
+     &               , LRGROUPS
+     &               , PERM
+     &               )
+                    IF (INFO(1).LT.0) THEN
+                     IF (LP.GT.0) 
+     &               write(LP,*) "ERROR after DMUMPS_FAC1_LU ",
+     &               "on the root INFO(1)= ", INFO(1)
+                     GOTO 735
+                    ENDIF 
+                   ELSE
+                    CALL DMUMPS_FAC1_LDLT_I (N,KEEP_SAVE(20),
+     &               IW, LIW, A_ROOT_SAVE(1), NFRONT8*NFRONT8,
+     &               IPOSROOT, 1_8,
+     &               INFO(1), INFO(2), UU,
+     &               NOFFNEGPV_ROOT, NULLNEGPV_ROOT, NTOTPV_ROOT,
+     &               NB22T1_ROOT, NBTINY_ROOT, 
+     &               DET_EXP_ROOT, DET_MANT_ROOT, DET_SIGN_ROOT,
+     &               KEEP_SAVE,KEEP8_SAVE, MYID_NODES, SEUIL, 
+     &               AVOID_DELAYED, ETATASS, DKEEP_SAVE(1),
+     &               PIVNUL_LIST_STRUCT, IWPOS
+     &               , LRGROUPS
+     &               , PERM
+     &               )
+                     IF (INFO(1).LT.0) THEN
+                      IF (LP.GT.0) 
+     &                write(LP,*) "ERROR after DMUMPS_FAC1_LDLT ",
+     &                "on the root INFO(1)= ", INFO(1)
+                      GOTO 735
+                     ENDIF 
+                   ENDIF 
+                   LRecord = IW(IOLDPS+XXI)
+                   IW(PTLUST(STEP(INODE)):
+     &                PTLUST(STEP(INODE))+LRecord-1) = 
+     &                                    RECORD_ROOT(1:LRecord) 
+                   IW(PTLUST(STEP(INODE))+KEEP(IXSZ): 
+     &                PTLUST(STEP(INODE))+KEEP(IXSZ)+4) =
+     &                                          Header_ROOT(1:5)
+                   KEEP17_LU = KEEP_SAVE(109)-KEEP(109)
+                   IF (KEEP_SAVE(109).GT.KEEP(109)) THEN
+                     K = 1
+                     DO I = KEEP(109)+1, KEEP(109)+KEEP17_LU
+                        RECORD_ROOT(K) = 
+     &                          PIVNUL_LIST_STRUCT%PIVNUL_LIST(I)
+                        K = K+1
+                     ENDDO
+                   ENDIF
+                   IF (IS_A_ROOT_SAVE_ALLOCATED) DEALLOCATE(A_ROOT_SAVE)
+                   NULLIFY(A_ROOT_SAVE)
+                   IS_A_ROOT_SAVE_ALLOCATED = .FALSE.
+                   DET_SIGN = DET_SIGN * DET_SIGN_ROOT
+                   DET_EXP  = DET_EXP + DET_EXP_ROOT
+                   CALL DMUMPS_UPDATEDETER ( DET_MANT_ROOT, 
+     &                                       DET_MANT, DET_EXP)
+                   NOFFNEGPV = NOFFNEGPV + NOFFNEGPV_ROOT
+                   NULLNEGPV = NULLNEGPV + NULLNEGPV_ROOT
+                  ENDIF 
+                  LOCAL_M = 0
+                  LOCAL_N = 0
+                  MBLOCK  = 0
+                  NBLOCK  = 0
+                  PHASE   = 1  
+                  CALL DMUMPS_SVD_QR_ESTIM_WK( PHASE,
+     &             MBLOCK, NBLOCK, NFRONT, LOCAL_M, LOCAL_N,
+     &             ROOT_OWNER, KEEP,KEEP8,
+     &             LIWK_RR, LWK_RR )    
+                  LBUFRX             = LWK_RR
+                  IS_BUFRX_ALLOCATED = .FALSE.
+                  IF ( LRLU .GT. LBUFRX ) THEN
+                      BUFRX => A(POSFAC:POSFAC+LBUFRX-1_8)
+                  ELSE
+                      ALLOCATE( BUFRX( LBUFRX ), stat = IERR )
+                      IF (IERR.gt.0) THEN
+                        INFO(1) = -13
+                        CALL MUMPS_SET_IERROR(LBUFRX, INFO(2))
+                        IF (LP.GT.0)
+     &                  write(LP,*) ' Error allocating, real
+     &                        array ','of size ', LBUFRX,
+     &                        ' before DMUMPS_SEQ_FACTO_ROOT_SVD_QR'
+                        GOTO 735
+                      ENDIF
+                      IS_BUFRX_ALLOCATED = .TRUE.
+                  ENDIF
+                 IF (PIVNUL_LIST_STRUCT%SIZE_PIVNUL_LIST .LT. 
+     &               KEEP(109)+NFRONT) THEN
+                  CALL MUMPS_RESIZE_PIVNUL(KEEP, N, PIVNUL_LIST_STRUCT, 
+     &                             KEEP(109)+NFRONT, INFO(1), INFO(2) ) 
+                  IF (INFO(1).LT.0) GOTO 735
+                 ENDIF
+                  CALL DMUMPS_SEQ_FACTO_ROOT_SVD_QR(
+     &                 NFRONT,A(PTRAST(STEP(KEEP(20)))),
+     &                 root,
+     &                 BUFRX(1), int(LBUFRX),
+     &                 KEEP,KEEP8, INFO, LP, DKEEP,
+     &                 GLOBK109, OPELI,
+     &                 PIVNUL_LIST_STRUCT%PIVNUL_LIST(KEEP(109)+1),
+     &                 PIVNUL_LIST_STRUCT%SIZE_PIVNUL_LIST- KEEP(109), 
+     &                 IW(IPOSROOTROWINDICES))
+                  IF (IS_BUFRX_ALLOCATED) DEALLOCATE ( BUFRX )
+                  NULLIFY(BUFRX)
+                  IS_BUFRX_ALLOCATED = .FALSE.
+                  IF (INFO(1).LT.0) GOTO 735
+                  IF (MPA.GT.0)
+     &            CALL MUMPS_PRINT_STILL_ACTIVE (MYID_NODES, KEEP, 
+     &                     dble(DKEEP(17)), 
+     &                     OPELI,
+     &                     OPLAST_PRINTED, MPA)
+                  CALL DMUMPS_UPDATE_PROGRESS( OPELI, KEEP8 )
+                  KEEP(143) = KEEP17_LU
+                  IF (KEEP(118).GE.40) THEN
+                    K = 1 
+                    IF (KEEP(17).GT.0) THEN
+                     DO I = KEEP(109)+1, KEEP(109)+KEEP(17)
+                      IF ( K .GT. KEEP17_LU ) THEN
+                        PIVNUL_LIST_STRUCT%PIVNUL_LIST(I) = -1
+                      ELSE
+                        PIVNUL_LIST_STRUCT%PIVNUL_LIST(I) = 
+     &                                 RECORD_ROOT(K)
+                      ENDIF
+                      K = K+1
+                     ENDDO
+                    ENDIF
+                  ENDIF
+                  IF (allocated(RECORD_ROOT)) DEALLOCATE(RECORD_ROOT)
+                      IF (KEEP(201).EQ.1) THEN 
+                        CALL MUMPS_GETI8(LAFAC, IW(IPOSROOT+XXR))
+                        LIWFAC    = IW(IPOSROOT+XXI)
+                        TYPEFile  = TYPEF_L
+                        NextPiv2beWritten = 1 
+                        MonBloc%INODE    = KEEP(20)   
+                        MonBloc%MASTER   = .TRUE.
+                        MonBloc%Typenode = 3
+                        MonBloc%NCOL     = NFRONT
+                        MonBloc%NROW     = NFRONT
+                        MonBloc%NFS      = NFRONT
+                        MonBloc%Last     = .TRUE.   
+                        MonBloc%LastPiv  = MonBloc%NCOL
+                        MonBloc%LastPanelWritten_L=-9999 
+                        MonBloc%LastPanelWritten_U=-9999 
+                        NULLIFY(MonBloc%INDICES)
+                        STRAT        = STRAT_WRITE_MAX
+                        MonBloc%Last = .TRUE.
+                        LAST_CALL    = .TRUE.
+                        CALL DMUMPS_OOC_IO_LU_PANEL
+     &                                 ( STRAT, TYPEFile,
+     &                                  A(PTRAST(STEP(KEEP(20)))),
+     &                                  LAFAC, MonBloc,
+     &                                  NextPiv2beWritten, IDUMMY,
+     &                                  IW(IPOSROOT), LIWFAC,
+     &                              MYID, KEEP8(31), IERR, LAST_CALL)
+                        IF(IERR.LT.0)THEN
+                        IF (LP > 0)
+     &                  WRITE(LP,*)MYID,
+     &                  ': Error raised in DMUMPS_OOC_IO_LU_PANEL',
+     &                  IERR
+                        INFO(1)=IERR
+                        ENDIF
+                      ELSE IF (KEEP(201).EQ.2) THEN 
+                        KEEP8(31)=KEEP8(31)+NFRONT8*NFRONT8
+                        CALL DMUMPS_NEW_FACTOR(KEEP(20),PTRFAC,
+     &                  KEEP,KEEP8,A,LA, NFRONT8*NFRONT8, IERR)
+                        IF(IERR.LT.0)THEN
+                        WRITE(*,*)MYID,
+     &                  ': Internal error in DMUMPS_NEW_FACTOR',
+     &                  IERR
+                        GOTO 735
+                        ENDIF
+                      ENDIF
+                      ITMP8  =  NFRONT8*NFRONT8
+                      IF(KEEP(201).NE.0)THEN 
+                        IF (PTRFAC(STEP(KEEP(20))).EQ.
+     &                      POSFAC-ITMP8) THEN
+                          POSFAC = POSFAC  - ITMP8
+                          LRLU   = LRLU    + ITMP8
+                          LRLUS  = LRLUS   + ITMP8
+                          KEEP8(69) = KEEP8(69) - ITMP8
+                        ELSE
+                          IF (LP.GT.0) 
+     &                    WRITE(LP,*) "Internal error",
+     &                    POSFAC,NFRONT8,
+     &                    "root KEEP(20) not on top in OOC"
+                          GOTO 735
+                         ENDIF
+                      ENDIF
+                      CALL DMUMPS_LOAD_MEM_UPDATE(.FALSE.,.FALSE.,
+     &                LA-LRLUS,ITMP8,0_8,KEEP,KEEP8,LRLUS)
+                ENDIF
+ 735         CONTINUE
+             CALL MUMPS_PROPINFO( ICNTL, INFO, COMM_NODES, MYID_NODES )
+             IF (INFO(1).LT.0) GOTO 745
+                 CALL MPI_BCAST( KEEP(17), 1, MPI_INTEGER,
+     &                MUMPS_PROCNODE(PROCNODE_STEPS(STEP(KEEP(20))),
+     &                               KEEP(199)),
+     &                COMM_NODES, IERR )
+                 CALL MPI_BCAST( KEEP(143), 1, MPI_INTEGER,
+     &                MUMPS_PROCNODE(PROCNODE_STEPS(STEP(KEEP(20))),
+     &                               KEEP(199)),
+     &                COMM_NODES, IERR )
+                END IF
                 IF (ROOT_OWNER.AND.KEEP(60).NE.0) THEN 
                   ITMP8 = NFRONT8*NFRONT8
                   IF ( PTRFAC(STEP(KEEP(20))) .EQ. POSFAC -
@@ -954,6 +1240,12 @@ C
                   ENDIF
                 ENDIF
             END IF
+            GOTO 750
+ 745  CONTINUE
+            IF (allocated(RECORD_ROOT)) DEALLOCATE(RECORD_ROOT)
+            IF (IS_A_ROOT_SAVE_ALLOCATED) DEALLOCATE(A_ROOT_SAVE)
+            NULLIFY(A_ROOT_SAVE)
+ 750  CONTINUE
             IF (INFO(1).LT.0) GOTO 500
             CALL MUMPS_SECFIN(ROOTTIME)
             DKEEP(99)=ROOTTIME
diff -pruN 5.6.2-2.1/src/dfac_process_band.F 5.7.1-1/src/dfac_process_band.F
--- 5.6.2-2.1/src/dfac_process_band.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_process_band.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -46,7 +46,7 @@ C
       INTEGER PTRIST(KEEP(28)), STEP(N), 
      & PIMASTER(KEEP(28)), 
      & ITLOC( N + KEEP(253) )
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INTEGER :: ISTEP_TO_INIV2(KEEP(71))
 #if ! defined(NO_FDM_DESCBAND)
       INTEGER IWHANDLER_IN
@@ -124,7 +124,7 @@ C
      &       COMP, LRLUS, KEEP8(67), IFLAG, IERROR
      &     )
         IF ( IFLAG .LT. 0 ) RETURN
-#if defined(MUMPS_ALLOC_FROM_C)
+#if defined(MUMPS_ALLOC_FROM_C) || defined(_CRAYFTN)
         CALL MUMPS_MALLOC_C( TMP_ADDRESS,
      &      LREQCB * int(KEEP(35),8) )
         IF (TMP_ADDRESS .EQ. 0_8) THEN
@@ -145,7 +145,7 @@ C
      &    KEEP8, IFLAG, IERROR,
      &    .TRUE., 
      &    .FALSE. ) 
-#if ! defined(MUMPS_ALLOC_FROM_C)
+#if ! defined(MUMPS_ALLOC_FROM_C) && ! defined(_CRAYFTN)
           CALL MUMPS_ADDR_C( DYNAMIC_CB(1), TMP_ADDRESS )
 #endif
           CALL MUMPS_STOREI8(LREQCB, IW(IWPOSCB+1+XXD))
@@ -289,7 +289,7 @@ C
       INTEGER NELT, LPTRAR
       INTEGER FRTPTR( N+1 ), FRTELT( NELT )
       INTEGER ITLOC( N + KEEP(253) ), FILS( N ), DAD( KEEP(28) )
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
diff -pruN 5.6.2-2.1/src/dfac_process_bf.F 5.7.1-1/src/dfac_process_bf.F
--- 5.6.2-2.1/src/dfac_process_bf.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_process_bf.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/dfac_process_blfac_slave.F 5.7.1-1/src/dfac_process_blfac_slave.F
--- 5.6.2-2.1/src/dfac_process_blfac_slave.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_process_blfac_slave.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -75,7 +75,7 @@ C
       INTEGER COMM, MYID
       INTEGER PTLUST_S(KEEP(28))
       INTEGER ITLOC( N + KEEP(253)), FILS( N ), DAD( KEEP(28) )
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INTEGER ND( KEEP(28) ), FRERE_STEPS( KEEP(28) )
       DOUBLE PRECISION OPASSW, OPELIW
       DOUBLE PRECISION FLOP1
diff -pruN 5.6.2-2.1/src/dfac_process_blocfacto.F 5.7.1-1/src/dfac_process_blocfacto.F
--- 5.6.2-2.1/src/dfac_process_blocfacto.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_process_blocfacto.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -71,7 +71,7 @@ C
       INTEGER FRTPTR( N+1 ), FRTELT( NELT )
       INTEGER PTLUST_S(KEEP(28)),
      &        ITLOC(N+KEEP(253)), FILS(N), DAD(KEEP(28)), ND(KEEP(28))
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) :: PTRAIW( LPTRAR ), PTRARW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
@@ -132,8 +132,6 @@ C
       INTEGER NPARTSASS, NPARTSCB, MAXI_CLUSTER, LWORK,
      &        MAXI_CLUSTER_L, MAXI_CLUSTER_U, MAXI_CLUSTER_COL
       INTEGER  :: allocok
-      INTEGER MUMPS_PROCNODE
-      EXTERNAL MUMPS_PROCNODE
       KEEP_BEGS_BLR_L = .FALSE.
       nullify(BEGS_BLR_L)
       NB_BLR_U = -7654321
@@ -384,8 +382,9 @@ C
           CALL GET_CUT(IW(IOLDPS+HS:IOLDPS+HS+NROW1-1), 0,
      &                    NROW1, LRGROUPS, NPARTSCB, 
      &                    NPARTSASS, BEGS_BLR_L)
-          CALL REGROUPING2(BEGS_BLR_L, NPARTSASS, 0, NPARTSCB,
-     &                        NROW1-0, KEEP(488), .TRUE., KEEP(472))
+          CALL REGROUPING2(BEGS_BLR_L, NPARTSASS, NASS1, NPARTSCB,
+     &                        NROW1-0, KEEP(488), .TRUE., KEEP(472),
+     &                        NCOL1, KEEP(1))
           NB_BLR_L =  NPARTSCB
           IF (IPANEL.EQ.1) THEN
            BEGS_BLR_COL=>BEGS_BLR_U
diff -pruN 5.6.2-2.1/src/dfac_process_blocfacto_LDLT.F 5.7.1-1/src/dfac_process_blocfacto_LDLT.F
--- 5.6.2-2.1/src/dfac_process_blocfacto_LDLT.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_process_blocfacto_LDLT.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -70,7 +70,7 @@ C
       INTEGER COMM, MYID
       INTEGER PTLUST_S(KEEP(28)),
      &        ITLOC(N+KEEP(253)), FILS(N), DAD(KEEP(28)), ND(KEEP(28))
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) :: PTRAIW( LPTRAR ), PTRARW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
@@ -564,8 +564,9 @@ C
           CALL GET_CUT(IW(IOLDPS+HS:IOLDPS+HS+NROW1-1), 0,
      &                    NROW1, LRGROUPS, NPARTSCB, 
      &                    NPARTSASS, BEGS_BLR_LS)
-              CALL REGROUPING2(BEGS_BLR_LS, NPARTSASS, 0, NPARTSCB,
-     &                        NROW1-0, KEEP(488), .TRUE., KEEP(472))
+              CALL REGROUPING2(BEGS_BLR_LS, NPARTSASS, NASS1, NPARTSCB,
+     &                        NROW1-0, KEEP(488), .TRUE., KEEP(472),
+     &                        NCOL1, KEEP(1))
              NB_BLR_LS = NPARTSCB
         ENDIF
         call MAX_CLUSTER(BEGS_BLR_LM,NB_BLR_LM+1,MAXI_CLUSTER_LM)
@@ -579,7 +580,8 @@ C
      &                    NPARTSASS_COL, BEGS_BLR_COL)
           CALL REGROUPING2(BEGS_BLR_COL, NPARTSASS_COL, NASS1, 
      &                     NPARTSCB_COL,
-     &                     NCOL1-NASS1, KEEP(488), .FALSE., KEEP(472))
+     &                     NCOL1-NASS1, KEEP(488), .FALSE., KEEP(472),
+     &                     NCOL1, KEEP(1))
           NB_BLR_COL = NPARTSCB_COL + NPARTSASS_COL
           IF (NPARTSASS_MASTER.NE.NPARTSASS_COL) THEN
              ALLOCATE(BEGS_BLR_COL_TMP(
diff -pruN 5.6.2-2.1/src/dfac_process_contrib_type1.F 5.7.1-1/src/dfac_process_contrib_type1.F
--- 5.6.2-2.1/src/dfac_process_contrib_type1.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_process_contrib_type1.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -42,7 +42,7 @@ C
       INTEGER COMP, FPERE
       LOGICAL FLAG
       INTEGER NSTK_S( KEEP(28) ), ITLOC( N + KEEP(253) )
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INTEGER IFLAG, IERROR, COMM
       INTEGER POSITION, FINODE, FLCONT, LREQ
       INTEGER(8) :: LREQCB
diff -pruN 5.6.2-2.1/src/dfac_process_contrib_type2.F 5.7.1-1/src/dfac_process_contrib_type2.F
--- 5.6.2-2.1/src/dfac_process_contrib_type2.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_process_contrib_type2.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -58,7 +58,7 @@ C
       INTEGER, intent(in) :: LRGROUPS(KEEP(280))
       INTEGER ITLOC( N + KEEP(253)), NSTK_S( KEEP(28) )
       INTEGER :: FILS( N ), DAD(KEEP(28))
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INTEGER ND(KEEP(28)), FRERE_STEPS( KEEP(28) )
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
@@ -449,7 +449,7 @@ C
              NSLAVES= IW(IOLDPS+5+KEEP(IXSZ))
              IF (NSLAVES.EQ.0) THEN 
                NFRONT = IW(IOLDPS+KEEP(IXSZ))
-               NASS1  = iabs(IW(IOLDPS + 2+KEEP(IXSZ)))
+               NASS1  = abs(IW(IOLDPS + 2+KEEP(IXSZ)))
                POSELT = PTRAST(STEP(INODE))
                PARPIV_T1 = -999 
                LR_ACTIVATED = (IW(IOLDPS+XXLR).GT.0)
diff -pruN 5.6.2-2.1/src/dfac_process_contrib_type3.F 5.7.1-1/src/dfac_process_contrib_type3.F
--- 5.6.2-2.1/src/dfac_process_contrib_type3.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_process_contrib_type3.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -45,7 +45,7 @@ C
       INTEGER PTRIST(KEEP(28))
       INTEGER PTLUST(KEEP(28))
       INTEGER STEP(N), PIMASTER(KEEP(28)), ITLOC( N+KEEP(253) )
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INTEGER BUFR( LBUFR_BYTES )
       INTEGER IW( LIW )
       INTEGER ND(KEEP(28)), PROCNODE_STEPS(KEEP(28))
@@ -65,8 +65,6 @@ C
       DOUBLE PRECISION OPASSW
         INCLUDE 'mpif.h'
         INTEGER IERR
-        EXTERNAL MUMPS_PROCNODE
-        INTEGER MUMPS_PROCNODE
         INTEGER POSITION, LOCAL_M, LOCAL_N, LREQI
         INTEGER(8) :: LREQA, POS_ROOT
         INTEGER NSUBSET_ROW, NSUBSET_COL, IROOT, ISON, NSUBSET_COL_EFF
diff -pruN 5.6.2-2.1/src/dfac_process_end_facto_slave.F 5.7.1-1/src/dfac_process_end_facto_slave.F
--- 5.6.2-2.1/src/dfac_process_end_facto_slave.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_process_end_facto_slave.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -71,7 +71,7 @@ C
       INTEGER NBFIN, SLAVEF
       DOUBLE PRECISION OPASSW, OPELIW
       INTEGER ITLOC( N + KEEP(253) ), FILS( N ), DAD( KEEP(28) )
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INTEGER ND( KEEP(28) )
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
diff -pruN 5.6.2-2.1/src/dfac_process_maprow.F 5.7.1-1/src/dfac_process_maprow.F
--- 5.6.2-2.1/src/dfac_process_maprow.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_process_maprow.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -84,7 +84,7 @@ C
       INTEGER LPTRAR, NELT
       INTEGER FRTPTR( N+1 ), FRTELT( NELT )
       INTEGER ITLOC( N+KEEP(253) ), FILS( N ), DAD( KEEP(28) )
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) ::  PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
@@ -573,6 +573,9 @@ C
                    IS_ERROR_BROADCASTED=.TRUE.
                    GOTO 600
                  ENDIF
+                 IF (.NOT. MESSAGE_RECEIVED) THEN
+                   CALL MUMPS_USLEEP(1000)
+                 ENDIF
                END IF
              END IF 
            ENDDO
@@ -708,7 +711,7 @@ C
       INTEGER PROCNODE_STEPS( KEEP(28) )
       INTEGER FRTPTR( N+1 ), FRTELT( NELT )
       INTEGER ITLOC( N+KEEP(253) ), FILS( N ), DAD( KEEP(28) )
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
@@ -1350,7 +1353,7 @@ C
       INTEGER, intent(inout) :: ITLOC(N)
       INTEGER, intent(in) :: FRTPTR( N+1 ), FRTELT( NELT )
       DOUBLE PRECISION, intent(inout) :: OPASSW, OPELIW
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INTEGER, intent(in) :: KEEP253_LOC, NVSCHUR
       INTEGER, intent(in) :: FILS(N), DAD( KEEP(28) )
       INTEGER(8), intent(in) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
diff -pruN 5.6.2-2.1/src/dfac_process_master2.F 5.7.1-1/src/dfac_process_master2.F
--- 5.6.2-2.1/src/dfac_process_master2.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_process_master2.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -43,7 +43,7 @@ C
       INTEGER(8) :: PAMASTER(KEEP(28))
       INTEGER PTRIST(KEEP(28)), STEP(N), PIMASTER(KEEP(28))
       INTEGER PROCNODE_STEPS( KEEP(28) ), ITLOC( N +KEEP(253) )
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INTEGER COMP
       INTEGER NSTK_S( KEEP(28) )
       INTEGER IFLAG, IERROR, COMM, COMM_LOAD
diff -pruN 5.6.2-2.1/src/dfac_process_message.F 5.7.1-1/src/dfac_process_message.F
--- 5.6.2-2.1/src/dfac_process_message.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_process_message.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -65,7 +65,7 @@ C
       INTEGER NELT, LPTRAR
       INTEGER FRTPTR( N+1), FRTELT( NELT )
       INTEGER ITLOC( N+KEEP(253) ), FILS( N ), DAD(KEEP(28))
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
@@ -515,7 +515,7 @@ C
       INTEGER NELT, LPTRAR
       INTEGER FRTPTR( N+1 ), FRTELT( NELT )
       INTEGER ITLOC( N+KEEP(253) ), FILS( N ), DAD( KEEP(28) )
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
@@ -623,7 +623,7 @@ C
       INTEGER NELT, LPTRAR
       INTEGER FRTPTR( N+1 ), FRTELT( NELT )
       INTEGER ITLOC( N + KEEP(253) ), FILS( N ), DAD( KEEP(28) )
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
@@ -749,7 +749,7 @@ C
                   IF ( IFLAG .LT. 0 ) RETURN
             ENDIF
           ENDIF
-       ENDIF
+       ENDIF 
       ELSE
         IF (BLOCKING) THEN
            CALL MPI_PROBE(MSGSOU,MSGTAG,
diff -pruN 5.6.2-2.1/src/dfac_process_root2slave.F 5.7.1-1/src/dfac_process_root2slave.F
--- 5.6.2-2.1/src/dfac_process_root2slave.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_process_root2slave.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -65,7 +65,7 @@ C
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
       INTEGER, INTENT(IN) :: NINROWARR(KEEP(195))
       INTEGER, INTENT(IN) :: PTRDEBARR(KEEP(196))
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INTEGER INTARR(KEEP8(27))
       DOUBLE PRECISION DBLARR(KEEP8(26))
       INTEGER ::  allocok
@@ -80,17 +80,17 @@ C
       DOUBLE PRECISION ZERO
       PARAMETER( ZERO = 0.0D0 )
       INCLUDE 'mumps_headers.h'
-      INTEGER numroc, MUMPS_PROCNODE
-      EXTERNAL numroc, MUMPS_PROCNODE
+      INTEGER MUMPS_NUMROC, MUMPS_PROCNODE
+      EXTERNAL MUMPS_NUMROC, MUMPS_PROCNODE
       IROOT = KEEP( 38 )
       root%TOT_ROOT_SIZE = TOT_ROOT_SIZE
       MASTER_OF_ROOT = ( MYID .EQ. 
      &                   MUMPS_PROCNODE( PROCNODE_STEPS(STEP(IROOT)),
      &                   KEEP(199) ) )
-      NEW_LOCAL_M  = numroc( TOT_ROOT_SIZE, root%MBLOCK,
+      NEW_LOCAL_M  = MUMPS_NUMROC( TOT_ROOT_SIZE, root%MBLOCK,
      &               root%MYROW, 0, root%NPROW )
       NEW_LOCAL_M  = max( 1, NEW_LOCAL_M )
-      NEW_LOCAL_N  = numroc( TOT_ROOT_SIZE, root%NBLOCK,
+      NEW_LOCAL_N  = MUMPS_NUMROC( TOT_ROOT_SIZE, root%NBLOCK,
      &               root%MYCOL, 0, root%NPCOL )
       IF ( PTRIST(STEP( IROOT )).GT.0) THEN
         OLD_LOCAL_N = -IW( PTRIST(STEP( IROOT )) + KEEP(IXSZ) )
@@ -275,7 +275,7 @@ C
       ENDIF 
       IF ( NO_OLD_ROOT ) THEN
           IF (KEEP(253) .GT.0) THEN
-            root%RHS_NLOC = numroc( KEEP(253), root%NBLOCK,
+            root%RHS_NLOC = MUMPS_NUMROC( KEEP(253), root%NBLOCK,
      &                      root%MYCOL, 0, root%NPCOL )
             root%RHS_NLOC = max( root%RHS_NLOC, 1 )
           ELSE
@@ -291,8 +291,8 @@ C
           ENDIF
           IF (KEEP(253) .NE. 0) THEN
             root%RHS_ROOT=ZERO
-            CALL DMUMPS_ASM_RHS_ROOT( N, FILS, root, KEEP, RHS_MUMPS,
-     &      IFLAG, IERROR )
+            CALL DMUMPS_ASM_RHS_ROOT( N, FILS, root, KEEP, KEEP8,
+     &      RHS_MUMPS, IFLAG, IERROR )
           ENDIF
       ELSE IF (NEW_LOCAL_M.GT.OLD_LOCAL_M .AND. KEEP(253) .GT.0) THEN
           TMP => root%RHS_ROOT
diff -pruN 5.6.2-2.1/src/dfac_process_root2son.F 5.7.1-1/src/dfac_process_root2son.F
--- 5.6.2-2.1/src/dfac_process_root2son.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_process_root2son.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -64,7 +64,7 @@ C
       INTEGER MYID, SLAVEF, NBFIN
       DOUBLE PRECISION OPASSW, OPELIW
       INTEGER ITLOC( N + KEEP(253) ), FILS( N ), DAD(KEEP(28))
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
@@ -97,7 +97,7 @@ C
        IOLDPS   = PTLUST_S(STEP(INODE))
        NFRONT   = IW(IOLDPS+KEEP(IXSZ))
        NPIV     = IW(IOLDPS+1+KEEP(IXSZ))
-       NASS     = iabs(IW(IOLDPS + 2+KEEP(IXSZ)))
+       NASS     = abs(IW(IOLDPS + 2+KEEP(IXSZ)))
        NSLAVES  =  IW(IOLDPS+5+KEEP(IXSZ))
        H_INODE  = 6 + NSLAVES + KEEP(IXSZ)
        NELIM    = NASS - NPIV
diff -pruN 5.6.2-2.1/src/dfac_process_rtnelind.F 5.7.1-1/src/dfac_process_rtnelind.F
--- 5.6.2-2.1/src/dfac_process_rtnelind.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_process_rtnelind.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -46,7 +46,7 @@ C
       INTEGER STEP(N), PIMASTER(KEEP(28))
       INTEGER COMP
       INTEGER NSTK_S(KEEP(28)), ITLOC( N + KEEP(253) )
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INTEGER PROCNODE_STEPS( KEEP(28) )
       INTEGER IFLAG, IERROR
       INTEGER LPOOL, LEAF
diff -pruN 5.6.2-2.1/src/dfac_root_parallel.F 5.7.1-1/src/dfac_root_parallel.F
--- 5.6.2-2.1/src/dfac_root_parallel.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/dfac_root_parallel.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -51,8 +51,7 @@ C
       INTEGER FWD_LOCAL_N_RHS, FWD_MTYPE 
 #endif
       INCLUDE 'mumps_headers.h'
-      EXTERNAL numroc
-      INTEGER numroc
+      INTEGER, EXTERNAL :: MUMPS_NUMROC
         IF ( .NOT. root%yes ) RETURN
         IF ( KEEP(60) .NE. 0 ) THEN
           IF ((LDLT == 1 .OR. LDLT == 2) .AND. KEEP(60) == 3 ) THEN
@@ -181,7 +180,7 @@ C
      &         LDLT)
         ENDIF
         IF (KEEP(252) .NE. 0) THEN
-          FWD_LOCAL_N_RHS = numroc(KEEP(253), root%NBLOCK,
+          FWD_LOCAL_N_RHS = MUMPS_NUMROC(KEEP(253), root%NBLOCK,
      &                      root%MYCOL, 0, root%NPCOL)
           FWD_LOCAL_N_RHS = max(1,FWD_LOCAL_N_RHS)
           FWD_MTYPE       = 1 
diff -pruN 5.6.2-2.1/src/dfac_scalings.F 5.7.1-1/src/dfac_scalings.F
--- 5.6.2-2.1/src/dfac_scalings.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_scalings.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -22,54 +22,61 @@ C
       DOUBLE PRECISION, INTENT(IN) :: ASPK(NZ8)
       DOUBLE PRECISION COLSCA(*), ROWSCA(*)
       INTEGER(8), INTENT(IN) :: LWK8
-      INTEGER LWK_REAL
+      INTEGER(8), INTENT(IN) :: LWK_REAL
       DOUBLE PRECISION    WK(LWK8)
       DOUBLE PRECISION WK_REAL(LWK_REAL)
       INTEGER MPG,LP
-      INTEGER IWNOR
       INTEGER I
-      LOGICAL PROK
+      LOGICAL PROKG
       DOUBLE PRECISION ONE
       PARAMETER( ONE = 1.0D0 )
       LP      = ICNTL(1)
       MPG     = ICNTL(2)
       MPG    = ICNTL(3)
-      PROK   = ((MPG.GT.0).AND.(ICNTL(4).GE.2))
-      IF (PROK) THEN
+      PROKG  = ((MPG.GT.0).AND.(ICNTL(4).GE.2))
+      IF (PROKG) THEN
         WRITE(MPG,101)
       ELSE
         MPG = 0
       ENDIF
- 101    FORMAT(/' ****** SCALING OF ORIGINAL MATRIX '/)
-        IF (NSCA.EQ.1) THEN
-         IF (PROK)
-     &    WRITE (MPG,*) ' DIAGONAL SCALING '
-        ELSEIF (NSCA.EQ.3) THEN
-         IF (PROK)
+ 101  FORMAT(/' ****** SCALING OF ORIGINAL MATRIX '/)
+      IF (NSCA.EQ.1) THEN
+        IF (PROKG) WRITE (MPG,*) ' DIAGONAL SCALING '
+      ELSEIF (NSCA.EQ.3) THEN
+         IF (PROKG)
      &   WRITE (MPG,*) ' COLUMN SCALING'
-        ELSEIF (NSCA.EQ.4) THEN
-         IF (PROK)
+      ELSEIF (NSCA.EQ.4) THEN
+         IF (PROKG)
      &   WRITE (MPG,*) ' ROW AND COLUMN SCALING (1 Pass)'
-       ENDIF
-        DO 10 I=1,N
-            COLSCA(I) = ONE
-            ROWSCA(I) = ONE
- 10     CONTINUE
-        IF (5*N.GT.LWK_REAL) GOTO 410
-        IWNOR = 1
-          IF (NSCA.EQ.1) THEN
+      ENDIF
+      DO 10 I=1,N
+        COLSCA(I) = ONE
+        ROWSCA(I) = ONE
+ 10   CONTINUE
+      IF (NSCA.EQ.1) THEN
             CALL DMUMPS_FAC_V(N,NZ8,ASPK,IRN,ICN,
-     &        COLSCA,ROWSCA,MPG)
-          ELSEIF (NSCA.EQ.3) THEN
-            CALL DMUMPS_FAC_Y(N,NZ8,ASPK,IRN,ICN,WK_REAL(IWNOR),
+     &      COLSCA,ROWSCA,MPG)
+      ELSEIF (NSCA.EQ.3) THEN
+            IF ( LWK_REAL .LT. int(N,8) ) THEN
+              GOTO 420
+            ENDIF
+            CALL DMUMPS_FAC_Y(N,NZ8,ASPK,IRN,ICN,WK_REAL(1),
      &      COLSCA, MPG)
-          ELSEIF (NSCA.EQ.4) THEN
+      ELSEIF (NSCA.EQ.4) THEN
+            IF ( LWK_REAL .LT. 2_8*int(N,8) ) THEN
+              GOTO 430
+            ENDIF
             CALL DMUMPS_ROWCOL(N,NZ8,IRN,ICN,ASPK,
-     &      WK_REAL(IWNOR),WK_REAL(IWNOR+N),COLSCA,ROWSCA,MPG)
-          ENDIF
+     &      WK_REAL(1),WK_REAL(1+N),COLSCA,ROWSCA,MPG)
+      ENDIF
+      GOTO 500
+ 420  INFO(1) = -5
+      CALL MUMPS_SET_IERROR(int(N,8)-LWK_REAL, INFO(2))
+      IF ((LP.GT.0).AND.(ICNTL(4).GE.1))
+     & WRITE(LP,*) '*** ERROR: Not enough space to scale matrix'
       GOTO 500
- 410  INFO(1) = -5
-      INFO(2) = 5*N-LWK_REAL
+ 430  INFO(1) = -5
+      CALL MUMPS_SET_IERROR(2_8*int(N,8)-LWK_REAL, INFO(2))
       IF ((LP.GT.0).AND.(ICNTL(4).GE.1))
      & WRITE(LP,*) '*** ERROR: Not enough space to scale matrix'
       GOTO 500
diff -pruN 5.6.2-2.1/src/dfac_scalings_simScaleAbs.F 5.7.1-1/src/dfac_scalings_simScaleAbs.F
--- 5.6.2-2.1/src/dfac_scalings_simScaleAbs.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/dfac_scalings_simScaleAbs.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -18,7 +18,9 @@ C
      &     IWRK, IWRKSZ,
      &     INTSZ, RESZ, OP,
      &     ROWSCA, COLSCA, WRKRC, ISZWRKRC,
-     &     SYM, NB1, NB2, NB3, EPS,
+     &     WRKR_TH, LWRKR_TH,
+     &     WRKC_TH, LWRKC_TH,
+     &     NOMP_MAX, SYM, NB1, NB2, NB3, EPS,
      &     ONENORMERR,INFNORMERR)
 C----------------------------------------------------------------------
 C    IF SYM=0 CALLs unsymmetric variant DMUMPS_SIMSCALEABSUNS.
@@ -29,13 +31,16 @@ C    For details, see the two subroutine
 C         DMUMPS_SIMSCALEABSUNS and DMUMPS_SIMSCALEABSSYM
 C ---------------------------------------------------------------------
 C
+!$    USE OMP_LIB
       IMPLICIT NONE
       INCLUDE 'mpif.h'
       INTEGER(8) NZ_loc
-      INTEGER IWRKSZ, ISZWRKRC
+      INTEGER(8) :: IWRKSZ
+      INTEGER(8) :: ISZWRKRC, LWRKR_TH, LWRKC_TH
+      INTEGER    :: NOMP_MAX
       INTEGER M, N, OP
       INTEGER NUMPROCS, MYID, COMM
-      INTEGER INTSZ, RESZ
+      INTEGER(8) :: INTSZ, RESZ
       INTEGER IRN_loc(NZ_loc)
       INTEGER JCN_loc(NZ_loc)
       DOUBLE PRECISION A_loc(NZ_loc)
@@ -44,21 +49,29 @@ C
       INTEGER CPARTVEC(N) 
       INTEGER CSNDRCVSZ(2*NUMPROCS)
       INTEGER IWRK(IWRKSZ)
-      INTEGER REGISTRE(12)
+      INTEGER(8) :: REGISTRE(12)
       DOUBLE PRECISION ROWSCA(M)
       DOUBLE PRECISION COLSCA(N)
       DOUBLE PRECISION WRKRC(ISZWRKRC)
+      DOUBLE PRECISION WRKR_TH(LWRKR_TH,max(NOMP_MAX,1))
+      DOUBLE PRECISION WRKC_TH(LWRKC_TH,max(NOMP_MAX,1))
       DOUBLE PRECISION ONENORMERR,INFNORMERR
 C     LOCALS
-C IMPORTANT POINTERS
 C     FOR the scaling phase
       INTEGER SYM, NB1, NB2, NB3
       DOUBLE PRECISION EPS
 C     EXTERNALS
       EXTERNAL DMUMPS_SIMSCALEABSUNS,DMUMPS_SIMSCALEABSSYM, 
-     &     DMUMPS_INITREAL
+     &         DMUMPS_INITREAL
 C     MUST HAVE IT
       INTEGER I
+      INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER    :: NOMP 
+!$    INTEGER    :: CHUNK
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP  = omp_get_max_threads()
+!$     CHUNK= max(K361/2, (N+NOMP-1) / NOMP )
+!$    ENDIF
       IF(SYM.EQ.0) THEN
          CALL DMUMPS_SIMSCALEABSUNS(IRN_loc, JCN_loc, A_loc, 
      &        NZ_loc,
@@ -67,7 +80,9 @@ C     MUST HAVE IT
      &        RSNDRCVSZ, CSNDRCVSZ, REGISTRE,
      &        IWRK, IWRKSZ,
      &        INTSZ, RESZ, OP,
-     &        ROWSCA, COLSCA, WRKRC, ISZWRKRC,
+     &        ROWSCA, COLSCA, WRKRC, ISZWRKRC, 
+     &        WRKR_TH, LWRKR_TH,
+     &        WRKC_TH, LWRKC_TH, NOMP_MAX,
      &        NB1, NB2, NB3, EPS,
      &        ONENORMERR, INFNORMERR)  
       ELSE
@@ -78,12 +93,24 @@ C     MUST HAVE IT
      &        RSNDRCVSZ, REGISTRE,
      &        IWRK, IWRKSZ,
      &        INTSZ, RESZ, OP,
-     &        ROWSCA, WRKRC, ISZWRKRC,
+     &        ROWSCA, WRKRC, ISZWRKRC,  
+     &        WRKR_TH, LWRKR_TH, NOMP_MAX,
      &        NB1, NB2, NB3, EPS,
      &        ONENORMERR, INFNORMERR)  
-         DO I=1,N
-            COLSCA(I) = ROWSCA(I)
-         ENDDO
+         IF (OP.EQ.2) THEN
+          IF (NOMP_MAX.LE.0) THEN
+            DO I=1,N
+             COLSCA(I) = ROWSCA(I)
+            ENDDO
+          ELSE 
+!$OMP      PARALLEL DO PRIVATE(I)
+!$OMP&     SCHEDULE(STATIC,CHUNK)
+!$OMP&     IF ( N > K361 .AND. NOMP .GT. 1)
+            DO I=1,N
+             COLSCA(I) = ROWSCA(I)
+            ENDDO
+          ENDIF
+         ENDIF
       ENDIF
       RETURN
       END SUBROUTINE DMUMPS_SIMSCALEABS
@@ -93,7 +120,9 @@ C     MUST HAVE IT
      &     RSNDRCVSZ, CSNDRCVSZ, REGISTRE,
      &     IWRK, IWRKSZ,
      &     INTSZ, RESZ, OP,
-     &     ROWSCA, COLSCA, WRKRC, ISZWRKRC,
+     &     ROWSCA, COLSCA, WRKRC, ISZWRKRC, 
+     &     WRKR_TH, LWRKR_TH,
+     &     WRKC_TH, LWRKC_TH, NOMP_MAX,
      &     NB1, NB2, NB3, EPS,
      &     ONENORMERR, INFNORMERR)    
 C----------------------------------------------------------------------
@@ -191,13 +220,15 @@ C         In proceedings of VECPAR'08-In
 C         Performance Computing for Computational Science, Jan'08.
 C     and was supported by ANR-SOLSTICE project (ANR-06-CIS6-010)
 C ---------------------------------------------------------------------
+!$    USE OMP_LIB
       IMPLICIT NONE
       INCLUDE 'mpif.h'
-      INTEGER(8) NZ_loc
-      INTEGER IWRKSZ, INTSZ, ISZWRKRC
-      INTEGER M, N, OP
-      INTEGER NUMPROCS, MYID, COMM
-      INTEGER RESZ
+      INTEGER(8) :: NZ_loc
+      INTEGER(8) :: IWRKSZ, INTSZ
+      INTEGER(8) :: ISZWRKRC, LWRKR_TH, LWRKC_TH
+      INTEGER    :: M, N, OP
+      INTEGER    :: NUMPROCS, MYID, COMM, NOMP_MAX
+      INTEGER(8) :: RESZ
       INTEGER IRN_loc(NZ_loc)
       INTEGER JCN_loc(NZ_loc)
       DOUBLE PRECISION A_loc(NZ_loc)
@@ -205,11 +236,13 @@ C --------------------------------------
       INTEGER CPARTVEC(N) 
       INTEGER RSNDRCVSZ(2*NUMPROCS)
       INTEGER CSNDRCVSZ(2*NUMPROCS)
-      INTEGER REGISTRE(12)
+      INTEGER(8) :: REGISTRE(12)
       INTEGER IWRK(IWRKSZ)
       DOUBLE PRECISION ROWSCA(M)
       DOUBLE PRECISION COLSCA(N)
-      DOUBLE PRECISION WRKRC(ISZWRKRC)  
+      DOUBLE PRECISION WRKRC(ISZWRKRC)
+      DOUBLE PRECISION WRKR_TH(LWRKR_TH,max(NOMP_MAX,1))
+      DOUBLE PRECISION WRKC_TH(LWRKC_TH,max(NOMP_MAX,1))
       DOUBLE PRECISION ONENORMERR,INFNORMERR
 C     LOCALS
       INTEGER IRSNDRCVNUM, ORSNDRCVNUM
@@ -218,14 +251,14 @@ C     LOCALS
       INTEGER ICSNDRCVVOL, OCSNDRCVVOL
       INTEGER  INUMMYR, INUMMYC
 C IMPORTANT POINTERS
-      INTEGER IMYRPTR,IMYCPTR 
-      INTEGER IRNGHBPRCS, IRSNDRCVIA,IRSNDRCVJA
-      INTEGER ORNGHBPRCS, ORSNDRCVIA,ORSNDRCVJA
-      INTEGER ICNGHBPRCS, ICSNDRCVIA,ICSNDRCVJA
-      INTEGER OCNGHBPRCS, OCSNDRCVIA,OCSNDRCVJA
-      INTEGER ISTATUS, REQUESTS, TMPWORK
-      INTEGER ITDRPTR, ITDCPTR, ISRRPTR
-      INTEGER OSRRPTR, ISRCPTR, OSRCPTR
+      INTEGER(8) :: IMYRPTR,IMYCPTR 
+      INTEGER(8) :: IRNGHBPRCS, IRSNDRCVIA,IRSNDRCVJA
+      INTEGER(8) :: ORNGHBPRCS, ORSNDRCVIA,ORSNDRCVJA
+      INTEGER(8) :: ICNGHBPRCS, ICSNDRCVIA,ICSNDRCVJA
+      INTEGER(8) :: OCNGHBPRCS, OCSNDRCVIA,OCSNDRCVJA
+      INTEGER(8) :: ISTATUS, REQUESTS, TMPWORK
+      INTEGER(8) :: ITDRPTR, ITDCPTR, ISRRPTR
+      INTEGER(8) :: OSRRPTR, ISRCPTR, OSRCPTR
 C     FOR the scaling phase
       INTEGER NB1, NB2, NB3
       DOUBLE PRECISION EPS
@@ -244,32 +277,39 @@ C     FUNCTIONS
       EXTERNAL DMUMPS_CREATEPARTVEC,
      &     DMUMPS_NUMVOLSNDRCV, 
      &     DMUMPS_SETUPCOMMS,
-     &     DMUMPS_FINDNUMMYROWCOL, 
-     &     DMUMPS_CHKCONVGLO,
-     &     DMUMPS_CHK1CONV,
      &     DMUMPS_FILLMYROWCOLINDICES,
      &     DMUMPS_INITREAL,
      &     DMUMPS_INITREALLST,
      &     DMUMPS_DOCOMMINF,
      &     DMUMPS_DOCOMM1N
-      INTEGER DMUMPS_CHKCONVGLO 
-      INTEGER DMUMPS_CHK1CONV
       DOUBLE PRECISION DMUMPS_ERRSCALOC
       DOUBLE PRECISION DMUMPS_ERRSCA1
       INTRINSIC abs
       DOUBLE PRECISION RONE, RZERO
       PARAMETER(RONE=1.0D0,RZERO=0.0D0)
 C     TMP VARS
-      INTEGER RESZR, RESZC
-      INTEGER INTSZR, INTSZC
+      INTEGER(8) :: RESZR, RESZC
+      INTEGER(8) :: INTSZR, INTSZC
       INTEGER MAXMN
-      INTEGER I, IERROR
+      INTEGER I, IERROR, IOMP
       DOUBLE PRECISION ONEERRROW, ONEERRCOL, ONEERRL, ONEERRG
       DOUBLE PRECISION INFERRROW, INFERRCOL, INFERRL, INFERRG
-      INTEGER OORANGEIND
+      LOGICAL OORANGEIND
+      INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER    :: NOMP
+!$    INTEGER    :: CHUNK, CHUNK_NZ
+!$    ! Too large => pb with cache L3 ?
+!$    ! INTEGER(8) :: CHUNK8 
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP     = omp_get_max_threads()
+!$     CHUNK    = max(K361/2, (N+NOMP-1) / NOMP )
+!$    ! CHUNK8= (NZ_loc+int(NOMP-1,8) / int(NOMP,8) ) )
+!$     CHUNK_NZ = max(K361/2, (N+NOMP_MAX-1) / NOMP_MAX )
+!$    ENDIF
+C
+      OORANGEIND = .FALSE.
       INFERRG = -RONE
       ONEERRG = -RONE
-      OORANGEIND = 0
       MAXMN = M
       IF(MAXMN < N) MAXMN = N
 C     Create row partvec and col partvec
@@ -280,11 +320,11 @@ C     IF(IWRKSZ.LT.4*MAXMN) THEN   ERROR
             CALL DMUMPS_CREATEPARTVEC(MYID, NUMPROCS, COMM,
      &           IRN_loc, JCN_loc, NZ_loc,
      &           RPARTVEC, M, N,
-     &           IWRK, IWRKSZ)
+     &           IWRK, IWRKSZ, INUMMYR, NOMP_MAX)
             CALL DMUMPS_CREATEPARTVEC(MYID, NUMPROCS, COMM,
      &           JCN_loc, IRN_loc,  NZ_loc,
      &           CPARTVEC, N, M,
-     &           IWRK, IWRKSZ)         
+     &           IWRK, IWRKSZ, INUMMYC, NOMP_MAX)
 C     Compute sndrcv sizes, store them for later use           
             CALL DMUMPS_NUMVOLSNDRCV(MYID, NUMPROCS, M, RPARTVEC,
      &           NZ_loc, IRN_loc, N, JCN_loc,
@@ -298,20 +338,14 @@ C     Compute sndrcv sizes, store them f
      &           OCSNDRCVNUM,OCSNDRCVVOL,
      &           IWRK,IWRKSZ, 
      &           CSNDRCVSZ(1), CSNDRCVSZ(1+NUMPROCS), COMM)         
-            CALL DMUMPS_FINDNUMMYROWCOL(MYID, NUMPROCS, COMM,
-     &           IRN_loc, JCN_loc, NZ_loc,
-     &           RPARTVEC, CPARTVEC, M, N,
-     &           INUMMYR,
-     &           INUMMYC,     
-     &           IWRK, IWRKSZ)
-            INTSZR =  IRSNDRCVNUM + ORSNDRCVNUM + 
-     &           IRSNDRCVVOL + ORSNDRCVVOL +
-     &           2*(NUMPROCS+1) + INUMMYR
-            INTSZC = ICSNDRCVNUM + OCSNDRCVNUM + 
-     &           ICSNDRCVVOL + OCSNDRCVVOL +
-     &           2*(NUMPROCS+1) + INUMMYC
-            INTSZ = INTSZR + INTSZC + MAXMN + 
-     &           (MPI_STATUS_SIZE +1) *  NUMPROCS
+            INTSZR =  int(IRSNDRCVNUM,8) + int(ORSNDRCVNUM,8) + 
+     &           int(IRSNDRCVVOL,8) + int(ORSNDRCVVOL,8) +
+     &           2_8*int(NUMPROCS+1,8) + int(INUMMYR,8)
+            INTSZC = int(ICSNDRCVNUM,8) + int(OCSNDRCVNUM,8) + 
+     &           int(ICSNDRCVVOL,8) + int(OCSNDRCVVOL,8) +
+     &           2_8*int(NUMPROCS+1,8) + int(INUMMYC,8)
+            INTSZ = INTSZR + INTSZC + int(MAXMN,8) + 
+     &           int(MPI_STATUS_SIZE +1,8) * int(NUMPROCS,8)
          ELSE
 C     NUMPROCS IS 1
              IRSNDRCVNUM = 0
@@ -324,39 +358,39 @@ C     NUMPROCS IS 1
              ICSNDRCVVOL = 0
              OCSNDRCVVOL  = 0
              INUMMYC = 0
-             INTSZ = 0
+             INTSZ = 0_8
           ENDIF
 C     CALCULATE NECESSARY DOUBLE PRECISION SPACE
-          RESZR = M + IRSNDRCVVOL + ORSNDRCVVOL
-          RESZC = N + ICSNDRCVVOL + OCSNDRCVVOL
+          RESZR = int(M,8) + int(IRSNDRCVVOL,8) + int(ORSNDRCVVOL,8)
+          RESZC = int(N,8) + int(ICSNDRCVVOL,8) + int(OCSNDRCVVOL,8)
           RESZ = RESZR  + RESZC  
 C     CALCULATE NECESSARY INT SPACE
 C     The last maxmn is tmpwork for setup comm and fillmyrowcol
-          REGISTRE(1) = IRSNDRCVNUM 
-          REGISTRE(2) = ORSNDRCVNUM
-          REGISTRE(3) = IRSNDRCVVOL 
-          REGISTRE(4) = ORSNDRCVVOL
-          REGISTRE(5) = ICSNDRCVNUM 
-          REGISTRE(6) = OCSNDRCVNUM
-          REGISTRE(7) = ICSNDRCVVOL
-          REGISTRE(8) = OCSNDRCVVOL
-          REGISTRE(9) = INUMMYR
-          REGISTRE(10) = INUMMYC
+          REGISTRE(1)  = int(IRSNDRCVNUM,8)
+          REGISTRE(2)  = int(ORSNDRCVNUM,8)
+          REGISTRE(3)  = int(IRSNDRCVVOL,8)
+          REGISTRE(4)  = int(ORSNDRCVVOL,8)
+          REGISTRE(5)  = int(ICSNDRCVNUM,8)
+          REGISTRE(6)  = int(OCSNDRCVNUM,8)
+          REGISTRE(7)  = int(ICSNDRCVVOL,8)
+          REGISTRE(8)  = int(OCSNDRCVVOL,8)
+          REGISTRE(9)  = int(INUMMYR,8)
+          REGISTRE(10) = int(INUMMYC,8)
           REGISTRE(11) = INTSZ
           REGISTRE(12) = RESZ
        ELSE
 C     else of op=1. That is op=2 now.
 C     restore the numbers
-          IRSNDRCVNUM = REGISTRE(1) 
-          ORSNDRCVNUM = REGISTRE(2) 
-          IRSNDRCVVOL = REGISTRE(3)
-          ORSNDRCVVOL = REGISTRE(4) 
-          ICSNDRCVNUM = REGISTRE(5) 
-          OCSNDRCVNUM = REGISTRE(6) 
-          ICSNDRCVVOL = REGISTRE(7) 
-          OCSNDRCVVOL = REGISTRE(8) 
-          INUMMYR = REGISTRE(9) 
-          INUMMYC = REGISTRE(10)
+          IRSNDRCVNUM = int(REGISTRE(1))
+          ORSNDRCVNUM = int(REGISTRE(2))
+          IRSNDRCVVOL = int(REGISTRE(3))
+          ORSNDRCVVOL = int(REGISTRE(4))
+          ICSNDRCVNUM = int(REGISTRE(5))
+          OCSNDRCVNUM = int(REGISTRE(6))
+          ICSNDRCVVOL = int(REGISTRE(7))
+          OCSNDRCVVOL = int(REGISTRE(8))
+          INUMMYR     = int(REGISTRE(9))
+          INUMMYC     = int(REGISTRE(10))
           IF(NUMPROCS > 1) THEN
 C     Check done outsize
 C             IF(INTSZ < REGISTRE(11)) THEN ERROR
@@ -365,35 +399,36 @@ C     Fill up myrows and my colsX
              CALL DMUMPS_FILLMYROWCOLINDICES(MYID, NUMPROCS,COMM,    
      &            IRN_loc, JCN_loc, NZ_loc,
      &            RPARTVEC, CPARTVEC, M, N,
-     &            IWRK(1), INUMMYR,
-     &            IWRK(1+INUMMYR), INUMMYC,     
-     &            IWRK(1+INUMMYR+INUMMYC), IWRKSZ-INUMMYR-INUMMYC )
-             IMYRPTR = 1
-             IMYCPTR = IMYRPTR + INUMMYR
+     &            IWRK(1_8), INUMMYR,
+     &            IWRK(1_8+int(INUMMYR,8)), INUMMYC,     
+     &            IWRK(1_8+int(INUMMYR,8)+int(INUMMYC,8)),
+     &            IWRKSZ-int(INUMMYR,8)-int(INUMMYC,8), NOMP_MAX )
+             IMYRPTR = 1_8
+             IMYCPTR = IMYRPTR + int(INUMMYR,8)
 C     Set up comm and run.
 C     set pointers in iwrk (4 parts)
 C     
 C     ROWS    [---------------------------------------------]
-             IRNGHBPRCS = IMYCPTR+ INUMMYC
-             IRSNDRCVIA = IRNGHBPRCS+IRSNDRCVNUM
-             IRSNDRCVJA = IRSNDRCVIA + NUMPROCS+1
-             ORNGHBPRCS = IRSNDRCVJA + IRSNDRCVVOL
-             ORSNDRCVIA = ORNGHBPRCS + ORSNDRCVNUM
-             ORSNDRCVJA = ORSNDRCVIA + NUMPROCS + 1
+             IRNGHBPRCS = IMYCPTR    + int(INUMMYC    ,8)
+             IRSNDRCVIA = IRNGHBPRCS + int(IRSNDRCVNUM,8)
+             IRSNDRCVJA = IRSNDRCVIA + int(NUMPROCS+1 ,8)
+             ORNGHBPRCS = IRSNDRCVJA + int(IRSNDRCVVOL,8)
+             ORSNDRCVIA = ORNGHBPRCS + int(ORSNDRCVNUM,8)
+             ORSNDRCVJA = ORSNDRCVIA + int(NUMPROCS+1 ,8)
 C     COLS    [---------------------------------------------]
-             ICNGHBPRCS = ORSNDRCVJA + ORSNDRCVVOL
-             ICSNDRCVIA = ICNGHBPRCS + ICSNDRCVNUM
-             ICSNDRCVJA = ICSNDRCVIA + NUMPROCS+1
-             OCNGHBPRCS = ICSNDRCVJA + ICSNDRCVVOL
-             OCSNDRCVIA = OCNGHBPRCS + OCSNDRCVNUM
-             OCSNDRCVJA = OCSNDRCVIA +  NUMPROCS + 1
+             ICNGHBPRCS = ORSNDRCVJA + int(ORSNDRCVVOL,8)
+             ICSNDRCVIA = ICNGHBPRCS + int(ICSNDRCVNUM,8)
+             ICSNDRCVJA = ICSNDRCVIA + int(NUMPROCS+1 ,8)
+             OCNGHBPRCS = ICSNDRCVJA + int(ICSNDRCVVOL,8)
+             OCSNDRCVIA = OCNGHBPRCS + int(OCSNDRCVNUM,8)
+             OCSNDRCVJA = OCSNDRCVIA + int(NUMPROCS+1 ,8)
 C     
 C     MPI     [-----------------]
-             REQUESTS = OCSNDRCVJA + OCSNDRCVVOL
-             ISTATUS = REQUESTS + NUMPROCS
+             REQUESTS = OCSNDRCVJA + int(OCSNDRCVVOL,8)
+             ISTATUS = REQUESTS + int(NUMPROCS,8)
 C     
 C     TMPWRK  [-----------------]
-             TMPWORK = ISTATUS + MPI_STATUS_SIZE *  NUMPROCS
+             TMPWORK = ISTATUS + int(MPI_STATUS_SIZE,8)*int(NUMPROCS,8)
              CALL DMUMPS_SETUPCOMMS(MYID, NUMPROCS, M, RPARTVEC,
      &            NZ_loc, IRN_loc,N, JCN_loc,
      &            IRSNDRCVNUM, IRSNDRCVVOL, 
@@ -416,80 +451,165 @@ C     TMPWRK  [-----------------]
      &            IWRK(TMPWORK), 
      &            IWRK(ISTATUS),  IWRK(REQUESTS),
      &            TAG_COMM_COL, COMM)
-             CALL DMUMPS_INITREAL(ROWSCA, M, RZERO)
-             CALL DMUMPS_INITREAL(COLSCA, N, RZERO)
+             CALL DMUMPS_INITREAL(ROWSCA, M, RZERO, NOMP_MAX)
+             CALL DMUMPS_INITREAL(COLSCA, N, RZERO, NOMP_MAX)
              CALL DMUMPS_INITREALLST(ROWSCA, M, 
-     &            IWRK(IMYRPTR),INUMMYR, RONE)
+     &            IWRK(IMYRPTR),INUMMYR, RONE, NOMP_MAX)
              CALL DMUMPS_INITREALLST(COLSCA, N, 
-     &            IWRK(IMYCPTR),INUMMYC, RONE)   
+     &            IWRK(IMYCPTR),INUMMYC, RONE, NOMP_MAX)   
           ELSE
-             CALL DMUMPS_INITREAL(ROWSCA, M, RONE)
-             CALL DMUMPS_INITREAL(COLSCA, N, RONE)            
+             CALL DMUMPS_INITREAL(ROWSCA, M, RONE, NOMP_MAX)
+             CALL DMUMPS_INITREAL(COLSCA, N, RONE, NOMP_MAX)            
           ENDIF
-          ITDRPTR = 1
-          ITDCPTR = ITDRPTR + M
+          ITDRPTR = 1_8
+          ITDCPTR = ITDRPTR + int(M,8)
 C     
-          ISRRPTR = ITDCPTR + N
-          OSRRPTR = ISRRPTR + IRSNDRCVVOL
+          ISRRPTR = ITDCPTR + int(N,8)
+          OSRRPTR = ISRRPTR + int(IRSNDRCVVOL,8)
 C     
-          ISRCPTR = OSRRPTR + ORSNDRCVVOL
-          OSRCPTR = ISRCPTR + ICSNDRCVVOL
+          ISRCPTR = OSRRPTR + int(ORSNDRCVVOL,8)
+          OSRCPTR = ISRCPTR + int(ICSNDRCVVOL,8)
 C     To avoid bound check errors...
           IF(NUMPROCS == 1)THEN
-             OSRCPTR = OSRCPTR - 1
-             ISRCPTR = ISRCPTR - 1
-             OSRRPTR = OSRRPTR - 1
-             ISRRPTR = ISRRPTR - 1
+             OSRCPTR = OSRCPTR - 1_8
+             ISRCPTR = ISRCPTR - 1_8
+             OSRRPTR = OSRRPTR - 1_8
+             ISRRPTR = ISRRPTR - 1_8
           ELSE
-             IF(IRSNDRCVVOL == 0) ISRRPTR = ISRRPTR - 1
-             IF(ORSNDRCVVOL == 0) OSRRPTR = OSRRPTR - 1
-             IF(ICSNDRCVVOL == 0) ISRCPTR = ISRCPTR - 1
-             IF(OCSNDRCVVOL == 0) OSRCPTR = OSRCPTR - 1
+             IF(IRSNDRCVVOL == 0) ISRRPTR = ISRRPTR - 1_8
+             IF(ORSNDRCVVOL == 0) OSRRPTR = OSRRPTR - 1_8
+             IF(ICSNDRCVVOL == 0) ISRCPTR = ISRCPTR - 1_8
+             IF(OCSNDRCVVOL == 0) OSRCPTR = OSRCPTR - 1_8
           ENDIF
           ITER = 1
           DO WHILE (ITER.LE.NB1+NB2+NB3)
-C     CLEAR temporary Dr and Dc
-             IF(NUMPROCS > 1) THEN
-                CALL DMUMPS_ZEROOUT(WRKRC(ITDRPTR),M,
-     &               IWRK(IMYRPTR),INUMMYR)
-                CALL DMUMPS_ZEROOUT(WRKRC(ITDCPTR),N,
-     &               IWRK(IMYCPTR),INUMMYC)
-             ELSE
-                CALL DMUMPS_INITREAL(WRKRC(ITDRPTR),M, RZERO)
-                CALL DMUMPS_INITREAL(WRKRC(ITDCPTR),N, RZERO)
+C{
+C           -------------------------
+C           CLEAR temporary Dr and Dc
+C           -------------------------
+            IF (NOMP_MAX.GT.1 .AND. 
+     &        (ITER.GT.NB1 .AND.ITER.LE.NB1+NB2)
+     &      ) THEN
+C{
+!$OMP         PARALLEL
+!$OMP&         PRIVATE(IOMP)
+!$OMP&         NUM_THREADS(NOMP_MAX)
+               IOMP  = 1
+!$             IOMP = OMP_GET_THREAD_NUM() + 1
+               IF(NUMPROCS > 1) THEN
+                 CALL DMUMPS_ZEROOUT(WRKR_TH(1,IOMP),N,
+     &                 IWRK(IMYRPTR),INUMMYR, 0)
+                 CALL DMUMPS_ZEROOUT(WRKC_TH(1,IOMP),N,
+     &                 IWRK(IMYCPTR),INUMMYC, 0)
+               ELSE
+                 CALL DMUMPS_INITREAL(WRKR_TH(1,IOMP),N, RZERO, 
+     &                                0)
+                 CALL DMUMPS_INITREAL(WRKC_TH(1,IOMP),N, RZERO, 
+     &                                0)
+               ENDIF
+!$OMP         END PARALLEL
+C}
+            ELSE
+C{
+               IF(NUMPROCS > 1) THEN
+                  CALL DMUMPS_ZEROOUT(WRKRC(ITDRPTR),M,
+     &                 IWRK(IMYRPTR),INUMMYR, NOMP_MAX)
+                  CALL DMUMPS_ZEROOUT(WRKRC(ITDCPTR),N,
+     &                 IWRK(IMYCPTR),INUMMYC, NOMP_MAX)
+               ELSE
+                  CALL DMUMPS_INITREAL(WRKRC(ITDRPTR),M, RZERO, 
+     &                                NOMP_MAX)
+                  CALL DMUMPS_INITREAL(WRKRC(ITDCPTR),N, RZERO, 
+     &                                NOMP_MAX)
+               ENDIF
+C}
              ENDIF
              IF((ITER.LE.NB1).OR.(ITER > NB1+NB2)) THEN
+C     ------------------
 C     INF-NORM ITERATION
-                IF((ITER.EQ.1).OR.(OORANGEIND.EQ.1)) THEN
+C     ------------------
+               IF (NOMP_MAX.LE.0) THEN
+                IF((ITER.EQ.1).OR.(OORANGEIND)) THEN
                    DO NZIND=1_8,NZ_loc
                       IR = IRN_loc(NZIND)
                       IC = JCN_loc(NZIND)
                       IF((IR.GE.1).AND.(IR.LE.M).AND.
      &                     (IC.GE.1).AND.(IC.LE.N)) THEN
                          ELM = abs(A_loc(NZIND))*ROWSCA(IR)*COLSCA(IC)
-                         IF(WRKRC(ITDRPTR-1+IR)<ELM) THEN
-                            WRKRC(ITDRPTR-1+IR)= ELM
-                         ENDIF
-                         IF(WRKRC(ITDCPTR-1+IC)<ELM) THEN
-                            WRKRC(ITDCPTR-1+IC)= ELM
-                         ENDIF
+                         IF(WRKRC(IR)<ELM) WRKRC(IR)= ELM
+                         IF(WRKRC(ITDCPTR-1_8+int(IC,8))<ELM) 
+     &                      WRKRC(ITDCPTR-1_8+int(IC,8))= ELM
                       ELSE
-                         OORANGEIND = 1
+                         OORANGEIND = .TRUE.
                       ENDIF
                    ENDDO
-                ELSEIF(OORANGEIND.EQ.0) THEN
+                ELSEIF(.NOT.OORANGEIND) THEN
                    DO NZIND=1,NZ_loc
                       IR = IRN_loc(NZIND)
                       IC = JCN_loc(NZIND)
                       ELM = abs(A_loc(NZIND))*ROWSCA(IR)*COLSCA(IC)
-                      IF(WRKRC(ITDRPTR-1+IR)<ELM) THEN
-                         WRKRC(ITDRPTR-1+IR)= ELM
-                      ENDIF
-                      IF(WRKRC(ITDCPTR-1+IC)<ELM) THEN
-                         WRKRC(ITDCPTR-1+IC)= ELM
+                      IF(WRKRC(IR)<ELM) WRKRC(IR)= ELM
+                      IF(WRKRC(ITDCPTR-1_8+int(IC,8))<ELM) 
+     &                   WRKRC(ITDCPTR-1_8+int(IC,8))= ELM
+                   ENDDO
+                ENDIF
+               ELSE
+                IF((ITER.EQ.1).OR.(OORANGEIND)) THEN
+!$OMP   PARALLEL DO PRIVATE(NZIND,IR,IC,ELM) 
+!$OMP&  SCHEDULE(STATIC,CHUNK_NZ)
+!$OMP&  IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
+!$OMP&  REDUCTION(.OR.:OORANGEIND)
+                   DO NZIND=1_8,NZ_loc
+                      IR = IRN_loc(NZIND)
+                      IC = JCN_loc(NZIND)
+                      IF((IR.GE.1).AND.(IR.LE.M).AND.
+     &                     (IC.GE.1).AND.(IC.LE.N)) THEN
+                         ELM = abs(A_loc(NZIND))*ROWSCA(IR)*COLSCA(IC)
+!$OMP                    ATOMIC UPDATE
+                         WRKRC(IR)= max (ELM, WRKRC(IR))
+!$OMP                    END ATOMIC
+C                         IF(WRKRC(ITDRPTR-1_8+int(IR,8))<ELM) THEN
+C                            WRKRC(ITDRPTR-1_8+int(IR,8))= ELM
+C                         ENDIF
+C                        IF(WRKRC(ITDCPTR-1_8+int(IC,8))<ELM) THEN
+C                           WRKRC(ITDCPTR-1_8+int(IC,8))= ELM
+C                         ENDIF
+C                        ITDCPTR+IC might be > int4
+!$OMP                    ATOMIC UPDATE
+                         WRKRC(ITDCPTR-1_8+int(IC,8)) = 
+     &                   max (ELM,WRKRC(ITDCPTR-1_8+int(IC,8)))
+!$OMP                    END ATOMIC
+                      ELSE
+                         OORANGEIND = .TRUE.
                       ENDIF
                    ENDDO
+!$OMP   END PARALLEL DO
+                ELSEIF(.NOT.OORANGEIND) THEN
+!$OMP   PARALLEL DO PRIVATE(NZIND,IR,IC,ELM) 
+!$OMP&  SCHEDULE(STATIC,CHUNK_NZ)
+!$OMP&  IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
+                   DO NZIND=1,NZ_loc
+                      IR = IRN_loc(NZIND)
+                      IC = JCN_loc(NZIND)
+                      ELM = abs(A_loc(NZIND))*ROWSCA(IR)*COLSCA(IC)
+C                      IF(WRKRC(ITDRPTR-1_8+int(IR,8))<ELM) THEN
+C                         WRKRC(ITDRPTR-1_8+int(IR,8))= ELM
+C                      ENDIF
+!$OMP                 ATOMIC UPDATE
+                      WRKRC(IR)= max (ELM, WRKRC(IR))
+!$OMP                 END ATOMIC
+C                      IF(WRKRC(ITDCPTR-1_8+int(IC,8))<ELM) THEN
+C                         WRKRC(ITDCPTR-1_8+int(IC,8))= ELM
+C                      ENDIF
+!$OMP                 ATOMIC UPDATE
+                      WRKRC(ITDCPTR-1_8+int(IC,8)) = 
+     &                   max (ELM,WRKRC(ITDCPTR-1_8+int(IC,8)))
+!$OMP                 END ATOMIC
+                   ENDDO
+!$OMP   END PARALLEL DO
                 ENDIF
+C}
+               ENDIF
                 IF(NUMPROCS > 1) THEN
                    CALL DMUMPS_DOCOMMINF(MYID, NUMPROCS,
      &                  WRKRC(ITDCPTR), N, TAG_ITERS+ITER, 
@@ -518,11 +638,11 @@ C
      &                 (NB1+NB3.GT.0))) THEN
                      INFERRROW = DMUMPS_ERRSCALOC(ROWSCA, 
      &                    WRKRC(ITDRPTR), M,
-     &                    IWRK(IMYRPTR),INUMMYR)
+     &                    IWRK(IMYRPTR),INUMMYR, NOMP_MAX)
 C     find error for the cols
                      INFERRCOL = DMUMPS_ERRSCALOC(COLSCA,  
      &                    WRKRC(ITDCPTR), N,
-     &                    IWRK(IMYCPTR),INUMMYC)
+     &                    IWRK(IMYCPTR),INUMMYC, NOMP_MAX)
 C     get max of those two errors
                      INFERRL = INFERRCOL
                      IF(INFERRROW > INFERRL ) THEN
@@ -535,10 +655,10 @@ C
                      IF(INFERRG.LE.EPS) THEN
                         CALL DMUMPS_UPDATESCALE(COLSCA,  
      &                       WRKRC(ITDCPTR),N,
-     &                       IWRK(IMYCPTR),INUMMYC)
+     &                       IWRK(IMYCPTR),INUMMYC, NOMP_MAX)
                         CALL DMUMPS_UPDATESCALE(ROWSCA,  
      &                       WRKRC(ITDRPTR),M,
-     &                       IWRK(IMYRPTR),INUMMYR)         
+     &                       IWRK(IMYRPTR),INUMMYR, NOMP_MAX)         
                         IF(ITER .LE. NB1) THEN
                            ITER = NB1+1
                            CYCLE
@@ -554,10 +674,10 @@ C     SINGLE PROCESSOR CASE: INF-NORM ER
      &                 ((ITER.EQ.NB1+NB2+NB3).AND.
      &                 (NB1+NB3.GT.0))) THEN
                      INFERRROW = DMUMPS_ERRSCA1(ROWSCA, 
-     &                    WRKRC(ITDRPTR), M)
+     &                    WRKRC(ITDRPTR), M, NOMP_MAX)
 C     find error for the cols
                      INFERRCOL = DMUMPS_ERRSCA1(COLSCA,  
-     &                    WRKRC(ITDCPTR), N)
+     &                    WRKRC(ITDCPTR), N, NOMP_MAX)
 C     get max of those two errors
                      INFERRL = INFERRCOL
                      IF(INFERRROW > INFERRL) THEN
@@ -565,8 +685,10 @@ C     get max of those two errors
                      ENDIF                     
                      INFERRG = INFERRL
                      IF(INFERRG.LE.EPS) THEN
-                        CALL DMUMPS_UPSCALE1(COLSCA,  WRKRC(ITDCPTR), N)
-                        CALL DMUMPS_UPSCALE1(ROWSCA,  WRKRC(ITDRPTR), M)
+                        CALL DMUMPS_UPSCALE1(COLSCA, WRKRC(ITDCPTR), N, 
+     &                                       NOMP_MAX)
+                        CALL DMUMPS_UPSCALE1(ROWSCA, WRKRC(ITDRPTR), M, 
+     &                                       NOMP_MAX)
                         IF(ITER .LE. NB1) THEN
                            ITER = NB1+1
                            CYCLE
@@ -577,30 +699,102 @@ C     get max of those two errors
                   ENDIF
                ENDIF
             ELSE
+C     ----------------------------------------
 C     WE HAVE ITER.GT.NB1 AND ITER.LE.NB1+NB2. 
 C     ONE-NORM ITERATION
-               IF((ITER .EQ.1).OR.(OORANGEIND.EQ.1))THEN
+C     ----------------------------------------
+             IF (NOMP_MAX.LE.1) THEN
+               IF((ITER .EQ.1).OR.(OORANGEIND))THEN
+                  DO NZIND=1_8,NZ_loc
+                     IR = IRN_loc(NZIND)
+                     IC = JCN_loc(NZIND)
+                     IF((IR.GE.1).AND.(IR.LE.M).AND.
+     &                    (IC.GE.1).AND.(IC.LE.N)) THEN
+                        ELM = abs(A_loc(NZIND))*ROWSCA(IR)*COLSCA(IC)
+C                       WRKRC(ITDRPTR-1_8+int(IR,8)) =
+C     &                 WRKRC(ITDRPTR-1_8+int(IR,8)) + ELM
+                        WRKRC(IR) =  WRKRC(IR) + ELM
+                        WRKRC(ITDCPTR-1_8+int(IC,8)) =
+     &                  WRKRC(ITDCPTR-1_8+int(IC,8)) + ELM
+                     ELSE
+                        OORANGEIND = .TRUE.
+                     ENDIF
+                  ENDDO
+               ELSEIF(.NOT.OORANGEIND) THEN
+                  DO NZIND=1,NZ_loc
+                     IR = IRN_loc(NZIND)
+                     IC = JCN_loc(NZIND)
+                     ELM = abs(A_loc(NZIND))*ROWSCA(IR)*COLSCA(IC)
+C                    WRKRC(ITDRPTR-1_8+int(IR,8)) =
+C     &              WRKRC(ITDRPTR-1_8+int(IR,8)) + ELM
+                     WRKRC(IR) =  WRKRC(IR) + ELM
+                     WRKRC(ITDCPTR-1_8+int(IC,8)) =
+     &               WRKRC(ITDCPTR-1_8+int(IC,8)) + ELM
+                  ENDDO
+               ENDIF
+C}
+             ELSE  ! NOMP_MAX>1
+               IF((ITER .EQ.1).OR.(OORANGEIND))THEN
+!$OMP   PARALLEL PRIVATE(IOMP)
+!$OMP&  NUM_THREADS(NOMP_MAX)
+!$OMP&    IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
+                    IOMP  = 1
+!$                  IOMP = OMP_GET_THREAD_NUM() + 1
+!$OMP     DO PRIVATE(NZIND,IR,IC,ELM)
+!$OMP&    SCHEDULE(STATIC,CHUNK_NZ)
+!$OMP&    REDUCTION(.OR.:OORANGEIND)
                   DO NZIND=1_8,NZ_loc
                      IR = IRN_loc(NZIND)
                      IC = JCN_loc(NZIND)
                      IF((IR.GE.1).AND.(IR.LE.M).AND.
      &                    (IC.GE.1).AND.(IC.LE.N)) THEN
                         ELM = abs(A_loc(NZIND))*ROWSCA(IR)*COLSCA(IC)
-                        WRKRC(ITDRPTR-1+IR) = WRKRC(ITDRPTR-1+IR) + ELM
-                        WRKRC(ITDCPTR-1+IC) = WRKRC(ITDCPTR-1+IC) + ELM
+                        WRKR_TH(IR,IOMP) = WRKR_TH(IR,IOMP) + ELM
+                        IF (IR.NE.IC)
+     &                  WRKC_TH(IC,IOMP) = WRKC_TH(IC,IOMP) + ELM
                      ELSE
-                        OORANGEIND = 1
+                        OORANGEIND = .TRUE.
                      ENDIF
                   ENDDO
-               ELSEIF(OORANGEIND.EQ.0) THEN
+!$OMP     END DO
+!$OMP   END PARALLEL
+               ELSEIF(.NOT.OORANGEIND) THEN
+!$OMP   PARALLEL PRIVATE(IOMP)
+!$OMP&  NUM_THREADS(NOMP_MAX)
+!$OMP&    IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
+                    IOMP  = 1
+!$                  IOMP = OMP_GET_THREAD_NUM() + 1
+!$OMP     DO PRIVATE(NZIND,IR,IC,ELM)
+!$OMP&    SCHEDULE(STATIC,CHUNK_NZ)
                   DO NZIND=1,NZ_loc
                      IR = IRN_loc(NZIND)
                      IC = JCN_loc(NZIND)
                      ELM = abs(A_loc(NZIND))*ROWSCA(IR)*COLSCA(IC)
-                     WRKRC(ITDRPTR-1+IR) = WRKRC(ITDRPTR-1+IR) + ELM
-                     WRKRC(ITDCPTR-1+IC) = WRKRC(ITDCPTR-1+IC) + ELM
+                     WRKR_TH(IR,IOMP) = WRKR_TH(IR,IOMP) + ELM
+                     IF (IR.NE.IC)
+     &               WRKC_TH(IC,IOMP) = WRKC_TH(IC,IOMP) + ELM
                   ENDDO
+!$OMP     END DO
+!$OMP   END PARALLEL
+               ENDIF
+C
+C              For all i on MYID:
+C              Build WRKRC(i) = Sum       (WRKR_TH(i,IOMP)
+C                              IOMP \in [1:NOMP_MAX]
+               IF(NUMPROCS > 1) THEN
+                 CALL DMUMPS_REDUCE_WRK_MPI (WRKRC, N, WRKR_TH, 
+     &                 NOMP_MAX, 
+     &                 IWRK(IMYRPTR),INUMMYR)
+                 CALL DMUMPS_REDUCE_WRK_MPI (WRKRC(ITDCPTR), 
+     &                 N, WRKC_TH, NOMP_MAX, 
+     &                 IWRK(IMYCPTR),INUMMYC)
+               ELSE
+                 CALL DMUMPS_REDUCE_WRK (WRKRC, N, WRKR_TH, NOMP_MAX)
+                 CALL DMUMPS_REDUCE_WRK (WRKRC(ITDCPTR), 
+     &                 N, WRKC_TH, NOMP_MAX)
                ENDIF
+C}
+             ENDIF
                IF(NUMPROCS > 1) THEN                 
                   CALL DMUMPS_DOCOMM1N(MYID, NUMPROCS,
      &                 WRKRC(ITDCPTR), N, TAG_ITERS+ITER, 
@@ -628,11 +822,11 @@ C
      &                 (NB2.GT.0))) THEN
                      ONEERRROW = DMUMPS_ERRSCALOC(ROWSCA, 
      &                    WRKRC(ITDRPTR), M,
-     &                    IWRK(IMYRPTR),INUMMYR)
+     &                    IWRK(IMYRPTR),INUMMYR, NOMP_MAX)
 C     find error for the cols
                      ONEERRCOL = DMUMPS_ERRSCALOC(COLSCA,  
      &                    WRKRC(ITDCPTR), N,
-     &                    IWRK(IMYCPTR),INUMMYC)
+     &                    IWRK(IMYCPTR),INUMMYC, NOMP_MAX)
 C     get max of those two errors
                      ONEERRL = ONEERRCOL
                      IF(ONEERRROW > ONEERRL ) THEN
@@ -645,10 +839,10 @@ C
                      IF(ONEERRG.LE.EPS) THEN
                         CALL DMUMPS_UPDATESCALE(COLSCA,
      &                       WRKRC(ITDCPTR),N,
-     &                       IWRK(IMYCPTR),INUMMYC)
+     &                       IWRK(IMYCPTR),INUMMYC, NOMP_MAX)
                         CALL DMUMPS_UPDATESCALE(ROWSCA,
      &                       WRKRC(ITDRPTR),M,
-     &                       IWRK(IMYRPTR),INUMMYR)          
+     &                       IWRK(IMYRPTR),INUMMYR, NOMP_MAX)
                         ITER = NB1+NB2+1
                         CYCLE
                      ENDIF
@@ -659,10 +853,10 @@ C     SINGLE-PROCESSOR CASE: ONE-NORM ER
      &                 ((ITER.EQ.NB1+NB2).AND.
      &                 (NB2.GT.0))) THEN
                      ONEERRROW = DMUMPS_ERRSCA1(ROWSCA, 
-     &                    WRKRC(ITDRPTR), M)
+     &                    WRKRC(ITDRPTR), M, NOMP_MAX)
 C     find error for the cols
                      ONEERRCOL = DMUMPS_ERRSCA1(COLSCA,  
-     &                    WRKRC(ITDCPTR), N)
+     &                    WRKRC(ITDCPTR), N, NOMP_MAX)
 C     get max of those two errors
                      ONEERRL = ONEERRCOL
                      IF(ONEERRROW > ONEERRL) THEN
@@ -670,30 +864,36 @@ C     get max of those two errors
                      ENDIF                     
                      ONEERRG = ONEERRL
                      IF(ONEERRG.LE.EPS) THEN
-                        CALL DMUMPS_UPSCALE1(COLSCA,  WRKRC(ITDCPTR), N)
-                        CALL DMUMPS_UPSCALE1(ROWSCA,  WRKRC(ITDRPTR), M)
-                        ITER = NB1+NB2+1                        
-                        CYCLE
+                       CALL DMUMPS_UPSCALE1(COLSCA, WRKRC(ITDCPTR), N, 
+     &                                      NOMP_MAX)
+                       CALL DMUMPS_UPSCALE1(ROWSCA, WRKRC(ITDRPTR), M, 
+     &                                      NOMP_MAX)
+                       ITER = NB1+NB2+1                        
+                       CYCLE
                      ENDIF
                   ENDIF                  
                ENDIF 
             ENDIF
             IF(NUMPROCS > 1) THEN               
                CALL DMUMPS_UPDATESCALE(COLSCA,  WRKRC(ITDCPTR), N,
-     &              IWRK(IMYCPTR),INUMMYC)
+     &              IWRK(IMYCPTR),INUMMYC, NOMP_MAX)
                CALL DMUMPS_UPDATESCALE(ROWSCA,  WRKRC(ITDRPTR), M,
-     &              IWRK(IMYRPTR),INUMMYR)               
+     &              IWRK(IMYRPTR),INUMMYR, NOMP_MAX)               
 C   
             ELSE
 C     SINGLE PROCESSOR CASE: Conv check and update of sca arrays
-               CALL DMUMPS_UPSCALE1(COLSCA,  WRKRC(ITDCPTR), N)
-               CALL DMUMPS_UPSCALE1(ROWSCA,  WRKRC(ITDRPTR), M)
+               CALL DMUMPS_UPSCALE1(COLSCA, WRKRC(ITDCPTR), N, 
+     &                              NOMP_MAX)
+               CALL DMUMPS_UPSCALE1(ROWSCA, WRKRC(ITDRPTR), M, 
+     &                              NOMP_MAX)
             ENDIF
             ITER = ITER + 1
+C}
          ENDDO
          ONENORMERR = ONEERRG 
          INFNORMERR = INFERRG 
          IF(NUMPROCS > 1) THEN
+C{
             CALL MPI_REDUCE(ROWSCA, WRKRC(1), M, MPI_DOUBLE_PRECISION,
      &           MPI_MAX, 0, 
      &           COMM, IERROR)
@@ -707,14 +907,28 @@ C     WRITE (6,*) MYID, 'ROWSCA=',ROWSCA
 C     WRITE (6,*) MYID, 'COLSCA=',COLSCA
 C     CALL FLUSH(6)
 c     REduce the whole scaling factors to processor 0 of COMM
-            CALL MPI_REDUCE(COLSCA, WRKRC(1+M), N, MPI_DOUBLE_PRECISION,
+            CALL MPI_REDUCE(COLSCA, WRKRC(1_8+int(M,8)), N, 
+     &           MPI_DOUBLE_PRECISION,
      &           MPI_MAX, 0, 
      &           COMM, IERROR)
-            If(MYID.EQ.0) THEN
+            IF(MYID.EQ.0) THEN
+C{
+              IF (NOMP_MAX.LE.0) THEN
                DO I=1, N
-                  COLSCA(I) = WRKRC(I+M)
+                  COLSCA(I) = WRKRC(int(I,8)+int(M,8))
                ENDDO
+              ELSE
+!$OMP       PARALLEL DO PRIVATE(I)
+!$OMP&      SCHEDULE(STATIC,CHUNK)
+!$OMP&      IF ( N > K361 .AND. NOMP .GT. 1)
+               DO I=1, N
+                  COLSCA(I) = WRKRC(int(I,8)+int(M,8))
+               ENDDO
+!$OMP       END PARALLEL DO
+              ENDIF
+C}
             ENDIF         
+C}
          ENDIF
       ENDIF
       RETURN
@@ -732,6 +946,7 @@ C
      &     IWRK, IWRKSZ,
      &     INTSZ, RESZ, OP,
      &     SCA, WRKRC, ISZWRKRC,
+     &     WRKR_TH, LWRKR_TH, NOMP_MAX,
      &     NB1, NB2, NB3, EPS,
      &     ONENORMERR, INFNORMERR)    
 C----------------------------------------------------------------------
@@ -821,31 +1036,34 @@ C         In proceedings of VECPAR'08-In
 C         Performance Computing for Computational Science, Jan'08.
 C     and was supported by ANR-SOLSTICE project (ANR-06-CIS6-010)
 C ---------------------------------------------------------------------
+!$    USE OMP_LIB
       IMPLICIT NONE
       INCLUDE 'mpif.h'
       INTEGER(8) :: NZ_loc 
-      INTEGER N, IWRKSZ, OP
-      INTEGER NUMPROCS, MYID, COMM
-      INTEGER INTSZ, RESZ
+      INTEGER N, OP
+      INTEGER(8) :: IWRKSZ, LWRKR_TH
+      INTEGER NUMPROCS, MYID, COMM, NOMP_MAX
+      INTEGER(8) :: INTSZ, RESZ
       INTEGER IRN_loc(NZ_loc)
       INTEGER JCN_loc(NZ_loc)
       DOUBLE PRECISION A_loc(NZ_loc)
       INTEGER PARTVEC(N), RSNDRCVSZ(2*NUMPROCS)
       INTEGER IWRK(IWRKSZ)
-      INTEGER REGISTRE(12)
+      INTEGER(8) :: REGISTRE(12)
       DOUBLE PRECISION SCA(N)
-      INTEGER ISZWRKRC
-      DOUBLE PRECISION WRKRC(ISZWRKRC)
+      INTEGER(8) :: ISZWRKRC
+      DOUBLE PRECISION WRKRC(ISZWRKRC), 
+     &     WRKR_TH(LWRKR_TH, max(NOMP_MAX,1))
 C     LOCALS
       INTEGER IRSNDRCVNUM, ORSNDRCVNUM
       INTEGER IRSNDRCVVOL, ORSNDRCVVOL
       INTEGER  INUMMYR
 C IMPORTANT POINTERS
-      INTEGER IMYRPTR,IMYCPTR 
-      INTEGER IRNGHBPRCS, IRSNDRCVIA,IRSNDRCVJA
-      INTEGER ORNGHBPRCS, ORSNDRCVIA,ORSNDRCVJA
-      INTEGER ISTATUS, REQUESTS, TMPWORK
-      INTEGER ITDRPTR, ISRRPTR, OSRRPTR
+      INTEGER(8) :: IMYRPTR,IMYCPTR 
+      INTEGER(8) :: IRNGHBPRCS, IRSNDRCVIA,IRSNDRCVJA
+      INTEGER(8) :: ORNGHBPRCS, ORSNDRCVIA,ORSNDRCVJA
+      INTEGER(8) :: ISTATUS, REQUESTS, TMPWORK
+      INTEGER(8) :: ITDRPTR, ISRRPTR, OSRRPTR
       DOUBLE PRECISION ONENORMERR,INFNORMERR
 C     FOR the scaling phase  
       INTEGER NB1, NB2, NB3
@@ -863,58 +1081,65 @@ C     FUNCTIONS
       EXTERNAL DMUMPS_CREATEPARTVECSYM,
      &     DMUMPS_NUMVOLSNDRCVSYM, 
      &     DMUMPS_SETUPCOMMSSYM,
-     &     DMUMPS_FINDNUMMYROWCOLSYM, 
-     &     DMUMPS_CHKCONVGLOSYM,
-     &     DMUMPS_CHK1CONV,
      &     DMUMPS_FILLMYROWCOLINDICESSYM,
      &     DMUMPS_DOCOMMINF,
      &     DMUMPS_DOCOMM1N,
      &     DMUMPS_INITREAL,
      &     DMUMPS_INITREALLST
-      INTEGER DMUMPS_CHKCONVGLOSYM 
-      INTEGER DMUMPS_CHK1CONV
       DOUBLE PRECISION DMUMPS_ERRSCALOC
       DOUBLE PRECISION DMUMPS_ERRSCA1
       INTRINSIC abs
       DOUBLE PRECISION RONE, RZERO
       PARAMETER(RONE=1.0D0,RZERO=0.0D0)
 C     TMP VARS
-      INTEGER INTSZR
+      INTEGER(8) :: INTSZR
       INTEGER MAXMN
       INTEGER I, IERROR
       DOUBLE PRECISION ONEERRL, ONEERRG
       DOUBLE PRECISION INFERRL, INFERRG
-      INTEGER OORANGEIND
-      OORANGEIND = 0
+      LOGICAL OORANGEIND
+      INTEGER, PARAMETER :: K361 = 2048
+      INTEGER            :: IOMP
+!$    INTEGER    :: NOMP
+!$    INTEGER    :: CHUNK, CHUNK_NZ
+!$    ! Too large => pb with cache L3 ?
+!$    ! INTEGER(8) :: CHUNK8 
+!$    ! CHUNK8= max(int(K361/2,8), 
+!$    !  &   (NZ_loc+int(NOMP-1,8) / int(NOMP,8) ) )
+!$    ! CHUNK8   = min(CHUNK8, huge(CHUNK)-1_8)
+!$    NOMP  = omp_get_max_threads()
+!$    CHUNK= max(K361/2, (N+NOMP-1) / NOMP )
+!$    IF (NOMP_MAX.GT.0) THEN
+!$      CHUNK_NZ = max(K361/2, (N+NOMP_MAX-1) / NOMP_MAX )
+!$    ENDIF
+C
+      OORANGEIND = .FALSE.
       INFERRG = -RONE
       ONEERRG = -RONE
       MAXMN = N
       IF(OP == 1) THEN
+C{
          IF(NUMPROCS > 1) THEN
 C     Check done outside
 C     IF(IWRKSZ.LT.2*MAXMN) THEN   ERROR.... 
             CALL DMUMPS_CREATEPARTVECSYM(MYID, NUMPROCS, COMM,
      &           IRN_loc, JCN_loc, NZ_loc,
      &           PARTVEC, N,
-     &           IWRK, IWRKSZ)
-C     
+     &           IWRK, IWRKSZ, INUMMYR )
+C
+C     Check done outside
             CALL DMUMPS_NUMVOLSNDRCVSYM(MYID, NUMPROCS, N, PARTVEC,
      &           NZ_loc, IRN_loc, JCN_loc, IRSNDRCVNUM,IRSNDRCVVOL,
      &           ORSNDRCVNUM, ORSNDRCVVOL,
      &           IWRK,IWRKSZ, 
      &           RSNDRCVSZ(1), RSNDRCVSZ(1+NUMPROCS), COMM)
 C     
-            CALL DMUMPS_FINDNUMMYROWCOLSYM(MYID, NUMPROCS, COMM,
-     &           IRN_loc, JCN_loc, NZ_loc,
-     &           PARTVEC, N,
-     &           INUMMYR,
-     &           IWRK, IWRKSZ)
 C     
-            INTSZR =  IRSNDRCVNUM + ORSNDRCVNUM + 
-     &           IRSNDRCVVOL + ORSNDRCVVOL +
-     &           2*(NUMPROCS+1) + INUMMYR
-            INTSZ = INTSZR + N + 
-     &           (MPI_STATUS_SIZE +1) *  NUMPROCS
+            INTSZR =  int(IRSNDRCVNUM,8) + int(ORSNDRCVNUM,8) + 
+     &           int(IRSNDRCVVOL,8) + int(ORSNDRCVVOL,8) +
+     &           2_8*int(NUMPROCS+1,8) + int(INUMMYR,8)
+            INTSZ = INTSZR + int(N,8) + 
+     &           int(MPI_STATUS_SIZE +1,8) * int(NUMPROCS,8)
          ELSE
 C     NUMPROCS IS 1
             IRSNDRCVNUM = 0
@@ -922,25 +1147,27 @@ C     NUMPROCS IS 1
             IRSNDRCVVOL = 0 
             ORSNDRCVVOL = 0
             INUMMYR = 0
-            INTSZ = 0
+            INTSZ = 0_8
          ENDIF
 C     CALCULATE NECESSARY DOUBLE PRECISION SPACE
-         RESZ = N + IRSNDRCVVOL + ORSNDRCVVOL
-         REGISTRE(1) = IRSNDRCVNUM 
-         REGISTRE(2) = ORSNDRCVNUM
-         REGISTRE(3) = IRSNDRCVVOL 
-         REGISTRE(4) = ORSNDRCVVOL
-         REGISTRE(9) = INUMMYR
+         RESZ = int(N,8) + int(IRSNDRCVVOL,8) + int(ORSNDRCVVOL,8)
+         REGISTRE(1)  = int(IRSNDRCVNUM,8)
+         REGISTRE(2)  = int(ORSNDRCVNUM,8)
+         REGISTRE(3)  = int(IRSNDRCVVOL,8)
+         REGISTRE(4)  = int(ORSNDRCVVOL,8)
+         REGISTRE(9)  = int(INUMMYR,8)
          REGISTRE(11) = INTSZ
          REGISTRE(12) = RESZ
+C}
       ELSE
+C{
 C     else of op=1. That is op=2 now.
 C     restore the numbers
-         IRSNDRCVNUM = REGISTRE(1) 
-         ORSNDRCVNUM = REGISTRE(2) 
-         IRSNDRCVVOL = REGISTRE(3)
-         ORSNDRCVVOL = REGISTRE(4) 
-         INUMMYR = REGISTRE(9) 
+         IRSNDRCVNUM = int(REGISTRE(1))
+         ORSNDRCVNUM = int(REGISTRE(2))
+         IRSNDRCVVOL = int(REGISTRE(3))
+         ORSNDRCVVOL = int(REGISTRE(4))
+         INUMMYR     = int(REGISTRE(9))
           IF(NUMPROCS > 1) THEN
 C     Check done outsize
 C             IF(INTSZ < REGISTRE(11)) THEN ERROR
@@ -950,24 +1177,24 @@ C     Fill up myrows and my colsX
      &            IRN_loc, JCN_loc, NZ_loc,
      &            PARTVEC, N,
      &            IWRK(1), INUMMYR,
-     &            IWRK(1+INUMMYR), IWRKSZ-INUMMYR)
-             IMYRPTR = 1
-             IMYCPTR = IMYRPTR + INUMMYR
+     &            IWRK(1+INUMMYR), IWRKSZ-int(INUMMYR,8), NOMP_MAX)
+             IMYRPTR = 1_8
+             IMYCPTR = IMYRPTR + int(INUMMYR,8)
 C     Set up comm and run.
 C     set pointers in iwrk (3 parts)
 C     
 C     ROWS    [---------------------------------------------]
              IRNGHBPRCS = IMYCPTR 
-             IRSNDRCVIA = IRNGHBPRCS+IRSNDRCVNUM
-             IRSNDRCVJA = IRSNDRCVIA + NUMPROCS+1
-             ORNGHBPRCS = IRSNDRCVJA + IRSNDRCVVOL
-             ORSNDRCVIA = ORNGHBPRCS + ORSNDRCVNUM
-             ORSNDRCVJA = ORSNDRCVIA + NUMPROCS + 1
+             IRSNDRCVIA = IRNGHBPRCS + int(IRSNDRCVNUM,8)
+             IRSNDRCVJA = IRSNDRCVIA + int(NUMPROCS+1,8)
+             ORNGHBPRCS = IRSNDRCVJA + int(IRSNDRCVVOL,8)
+             ORSNDRCVIA = ORNGHBPRCS + int(ORSNDRCVNUM,8)
+             ORSNDRCVJA = ORSNDRCVIA + int(NUMPROCS + 1,8)
 C     MPI     [-----------------]
-             REQUESTS = ORSNDRCVJA + ORSNDRCVVOL 
-             ISTATUS = REQUESTS + NUMPROCS
+             REQUESTS = ORSNDRCVJA + int(ORSNDRCVVOL,8)
+             ISTATUS = REQUESTS + int(NUMPROCS,8)
 C     TMPWRK  [-----------------]
-             TMPWORK = ISTATUS + MPI_STATUS_SIZE *  NUMPROCS
+             TMPWORK = ISTATUS + int(MPI_STATUS_SIZE,8)*int(NUMPROCS,8)
              CALL DMUMPS_SETUPCOMMSSYM(MYID, NUMPROCS, N, PARTVEC,
      &            NZ_loc, IRN_loc, JCN_loc,
      &            IRSNDRCVNUM, IRSNDRCVVOL, 
@@ -978,15 +1205,15 @@ C     TMPWRK  [-----------------]
      &            IWRK(TMPWORK), 
      &            IWRK(ISTATUS), IWRK(REQUESTS),
      &            TAG_COMM_ROW, COMM)
-             CALL DMUMPS_INITREAL(SCA, N, RZERO)
+             CALL DMUMPS_INITREAL(SCA, N, RZERO, NOMP_MAX)
              CALL DMUMPS_INITREALLST(SCA, N, 
-     &            IWRK(IMYRPTR),INUMMYR, RONE)
+     &            IWRK(IMYRPTR),INUMMYR, RONE, NOMP_MAX)
           ELSE
-             CALL DMUMPS_INITREAL(SCA, N, RONE)
+             CALL DMUMPS_INITREAL(SCA, N, RONE, NOMP_MAX)
           ENDIF
-          ITDRPTR = 1
-          ISRRPTR = ITDRPTR + N
-          OSRRPTR = ISRRPTR + IRSNDRCVVOL
+          ITDRPTR = 1_8
+          ISRRPTR = ITDRPTR + int(N,8)
+          OSRRPTR = ISRRPTR + int(IRSNDRCVVOL,8)
 C     
 C     To avoid bound check errors...
           IF(NUMPROCS == 1)THEN
@@ -999,46 +1226,123 @@ C     To avoid bound check errors...
 C     computation starts
           ITER = 1
           DO WHILE(ITER.LE.NB1+NB2+NB3)
-C     CLEAR temporary Dr and Dc
-             IF(NUMPROCS > 1) THEN
-                CALL DMUMPS_ZEROOUT(WRKRC(ITDRPTR),N,
-     &               IWRK(IMYRPTR),INUMMYR)
+C{
+C            -------------------------
+C            CLEAR temporary Dr and Dc 
+C            -------------------------
+             IF (NOMP_MAX.GT.1 .AND. 
+     &         (ITER.GT.NB1 .AND.ITER.LE.NB1+NB2)
+     &       ) THEN
+C             if one norm iteration and multithreading activated
+C             WRKR_TH need be initialized and 
+C             WRKRC will be set by reduction of WRKR_TH
+!$OMP         PARALLEL
+!$OMP&         PRIVATE(IOMP)
+!$OMP&         NUM_THREADS(NOMP_MAX)
+               IOMP  = 1
+!$             IOMP = OMP_GET_THREAD_NUM() + 1
+               IF(NUMPROCS > 1) THEN
+                 CALL DMUMPS_ZEROOUT(WRKR_TH(1,IOMP),N,
+     &                 IWRK(IMYRPTR),INUMMYR, 0)
+               ELSE
+                 CALL DMUMPS_INITREAL(WRKR_TH(1,IOMP),N, RZERO, 
+     &                                0)
+               ENDIF
+!$OMP         END PARALLEL
              ELSE
-                CALL DMUMPS_INITREAL(WRKRC(ITDRPTR),N, RZERO)
+              IF(NUMPROCS > 1) THEN
+CFIXME         Size N should be adjusted to effective size
+                 CALL DMUMPS_ZEROOUT(WRKRC(ITDRPTR),N,
+     &                IWRK(IMYRPTR),INUMMYR, NOMP_MAX)
+              ELSE
+                 CALL DMUMPS_INITREAL(WRKRC(ITDRPTR),N, RZERO,
+     &                                NOMP_MAX)
+              ENDIF
              ENDIF
+C
              IF((ITER.LE.NB1).OR.(ITER > NB1+NB2)) THEN
-C     INF-NORM ITERATION
-                IF((ITER.EQ.1).OR.(OORANGEIND.EQ.1)) THEN
+C            ------------------
+C{           INF-NORM ITERATION
+C            ------------------
+               IF (NOMP_MAX.LE.0) THEN
+                 IF((ITER .EQ.1).OR.(OORANGEIND))THEN
                    DO NZIND=1_8,NZ_loc
                       IR = IRN_loc(NZIND)
                       IC = JCN_loc(NZIND)
                       IF((IR.GE.1).AND.(IR.LE.N).AND.
      &                     (IC.GE.1).AND.(IC.LE.N)) THEN
                          ELM = abs(A_loc(NZIND))*SCA(IR)*SCA(IC)
-                         IF(WRKRC(ITDRPTR-1+IR)<ELM) THEN
-                            WRKRC(ITDRPTR-1+IR)= ELM
-                         ENDIF
-                         IF(WRKRC(ITDRPTR-1+IC)<ELM) THEN
-                            WRKRC(ITDRPTR-1+IC)= ELM
-                         ENDIF
+                         IF (WRKRC(IR)<ELM) WRKRC(IR)= ELM
+                         IF (WRKRC(IC)<ELM) WRKRC(IC)= ELM
                       ELSE
-                         OORANGEIND = 1
+                         OORANGEIND = .TRUE.
                       ENDIF
                    ENDDO
-                ELSEIF(OORANGEIND.EQ.0) THEN
+                 ELSEIF(.NOT.OORANGEIND) THEN
                    DO NZIND=1_8,NZ_loc
                       IR = IRN_loc(NZIND)
                       IC = JCN_loc(NZIND)
                       ELM = abs(A_loc(NZIND))*SCA(IR)*SCA(IC)
-                      IF(WRKRC(ITDRPTR-1+IR)<ELM) THEN
-                         WRKRC(ITDRPTR-1+IR)= ELM
-                      ENDIF
-                      IF(WRKRC(ITDRPTR-1+IC)<ELM) THEN
-                         WRKRC(ITDRPTR-1+IC)= ELM
+                      IF (WRKRC(IR)<ELM) WRKRC(IR)= ELM
+                      IF (WRKRC(IC)<ELM) WRKRC(IC)= ELM
+                   ENDDO
+                 ENDIF                      
+               ELSE
+                IF((ITER.EQ.1).OR.(OORANGEIND)) THEN
+!$OMP   PARALLEL DO PRIVATE(NZIND,IR,IC,ELM) 
+!$OMP&  SCHEDULE(STATIC,CHUNK_NZ)
+!$OMP&  IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
+!$OMP&  REDUCTION(.OR.:OORANGEIND)
+                   DO NZIND=1_8,NZ_loc
+                      IR = IRN_loc(NZIND)
+                      IC = JCN_loc(NZIND)
+                      IF((IR.GE.1).AND.(IR.LE.N).AND.
+     &                     (IC.GE.1).AND.(IC.LE.N)) THEN
+                         ELM = abs(A_loc(NZIND))*SCA(IR)*SCA(IC)
+!$OMP                    ATOMIC UPDATE
+                         WRKRC(IR)= max (ELM, WRKRC(IR))
+!$OMP                    END ATOMIC
+C                         IF(WRKRC(ITDRPTR-1_8+int(IR,8))<ELM) THEN
+C                            WRKRC(ITDRPTR-1_8+int(IR,8))= ELM
+C                         ENDIF
+!$OMP                    ATOMIC UPDATE
+                         WRKRC(IC) = max (ELM,WRKRC(IC))
+!$OMP                    END ATOMIC
+C                         IF(WRKRC(ITDRPTR-1_8+int(IC,8))<ELM) THEN
+C                            WRKRC(ITDRPTR-1_8+int(IC,8))= ELM
+C                         ENDIF
+                      ELSE
+                         OORANGEIND = .TRUE.
                       ENDIF
                    ENDDO
+!$OMP   END PARALLEL DO
+                ELSEIF(.NOT.OORANGEIND) THEN
+!$OMP   PARALLEL DO PRIVATE(NZIND,IR,IC,ELM) 
+!$OMP&  SCHEDULE(STATIC,CHUNK_NZ)
+!$OMP&  IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
+                   DO NZIND=1_8,NZ_loc
+                      IR = IRN_loc(NZIND)
+                      IC = JCN_loc(NZIND)
+                      ELM = abs(A_loc(NZIND))*SCA(IR)*SCA(IC)
+!$OMP                 ATOMIC UPDATE
+                      WRKRC(IR)= max (ELM, WRKRC(IR))
+!$OMP                 END ATOMIC
+C                      IF(WRKRC(ITDRPTR-1_8+int(IR,8))<ELM) THEN
+C                         WRKRC(ITDRPTR-1_8+int(IR,8))= ELM
+C                      ENDIF
+!$OMP                 ATOMIC UPDATE
+                      WRKRC(IC) = max (ELM, WRKRC(IC))
+!$OMP                 END ATOMIC
+C                      IF(WRKRC(ITDRPTR-1_8+int(IC,8))<ELM) THEN
+C                         WRKRC(ITDRPTR-1_8+int(IC,8))= ELM
+C                      ENDIF
+                   ENDDO
+!$OMP   END PARALLEL DO
                 ENDIF                      
-                IF(NUMPROCS > 1) THEN
+C}
+               ENDIF
+               IF(NUMPROCS > 1) THEN
+C{
                   CALL DMUMPS_DOCOMMINF(MYID, NUMPROCS,
      &                  WRKRC(ITDRPTR), N, TAG_ITERS+2+ITER, 
      &                  IRSNDRCVNUM,IWRK(IRNGHBPRCS),
@@ -1049,19 +1353,20 @@ C     INF-NORM ITERATION
      &                  WRKRC( OSRRPTR),
      &                  IWRK(ISTATUS),IWRK(REQUESTS),
      &                  COMM)
+CCCC FIXME #if defined(dev_version)
                   IF((EPS .GT. RZERO) .OR. 
      &                 (ITER.EQ.NB1).OR.
      &                 ((ITER.EQ.NB1+NB2+NB3).AND.
      &                 (NB1+NB3.GT.0))) THEN
                      INFERRL = DMUMPS_ERRSCALOC(SCA,  
      &                    WRKRC(ITDRPTR), N,
-     &                    IWRK(IMYRPTR),INUMMYR)                  
+     &                    IWRK(IMYRPTR),INUMMYR, NOMP_MAX) 
                      CALL MPI_ALLREDUCE(INFERRL, INFERRG, 
      &                    1, MPI_DOUBLE_PRECISION,
      &                    MPI_MAX, COMM, IERROR)   
                      IF(INFERRG.LE.EPS) THEN
                         CALL DMUMPS_UPDATESCALE(SCA,  WRKRC(ITDRPTR), N,
-     &                       IWRK(IMYRPTR),INUMMYR)
+     &                       IWRK(IMYRPTR),INUMMYR, NOMP_MAX)
                         IF(ITER .LE. NB1) THEN
                            ITER = NB1+1
                            CYCLE
@@ -1070,17 +1375,20 @@ C     INF-NORM ITERATION
                         ENDIF
                      ENDIF
                   ENDIF
+CCC #endif
+C}
                ELSE
-C     SINGLE PROCESSOR CASE: INF-NORM ERROR COMPUTATION
+C{             SINGLE PROCESSOR CASE: INF-NORM ERROR COMPUTATION
                   IF((EPS .GT. RZERO) .OR. 
      &                 (ITER.EQ.NB1).OR.
      &                 ((ITER.EQ.NB1+NB2+NB3).AND.
      &                 (NB1+NB3.GT.0))) THEN
                      INFERRL = DMUMPS_ERRSCA1(SCA, 
-     &                    WRKRC(ITDRPTR), N)
+     &                    WRKRC(ITDRPTR), N, NOMP_MAX)
                      INFERRG = INFERRL
                      IF(INFERRG.LE.EPS) THEN
-                        CALL DMUMPS_UPSCALE1(SCA,  WRKRC(ITDRPTR), N)
+                        CALL DMUMPS_UPSCALE1(SCA, WRKRC(ITDRPTR), N,
+     &                                       NOMP_MAX)
                         IF(ITER .LE. NB1) THEN
                            ITER = NB1+1
                            CYCLE
@@ -1089,38 +1397,102 @@ C     SINGLE PROCESSOR CASE: INF-NORM ER
                         ENDIF
                      ENDIF 
                   ENDIF
+C}
                ENDIF
+C}
             ELSE
-C     WE HAVE ITER.GT.NB1 AND ITER.LE.NB1+NB2. 
-C     ONE-NORM ITERATION
-               IF((ITER.EQ.1).OR.(OORANGEIND.EQ.1))THEN
+C           ----------------------------------------
+C{          WE HAVE ITER.GT.NB1 AND ITER.LE.NB1+NB2. 
+C           ONE-NORM ITERATION
+C           ----------------------------------------
+             IF (NOMP_MAX.LE.1) THEN
+               IF((ITER.EQ.1).OR.(OORANGEIND))THEN
+                  DO NZIND=1_8,NZ_loc
+                     IR = IRN_loc(NZIND)
+                     IC = JCN_loc(NZIND)
+                     IF((IR.GE.1).AND.(IR.LE.N).AND.
+     &                    (IC.GE.1).AND.(IC.LE.N)) THEN
+                        ELM = abs(A_loc(NZIND))*SCA(IR)*SCA(IC)
+                        WRKRC(IR) = WRKRC(IR) + ELM
+                        IF(IR.NE.IC) THEN
+                           WRKRC(IC) = WRKRC(IC) + ELM
+                        ENDIF
+                     ELSE
+                        OORANGEIND = .TRUE.
+                     ENDIF
+                  ENDDO
+               ELSEIF(.NOT.OORANGEIND)THEN
+                  DO NZIND=1_8,NZ_loc
+                     IR = IRN_loc(NZIND)
+                     IC = JCN_loc(NZIND)
+                     ELM = abs(A_loc(NZIND))*SCA(IR)*SCA(IC)
+                     WRKRC(IR) = WRKRC(IR) + ELM
+                     IF(IR.NE.IC) THEN
+                        WRKRC(IC) = WRKRC(IC) + ELM
+                     ENDIF
+                  ENDDO
+               ENDIF
+             ELSE ! NOMP_MAX>1
+               IF((ITER.EQ.1).OR.(OORANGEIND))THEN
+!$OMP   PARALLEL PRIVATE(IOMP)
+!$OMP&  NUM_THREADS(NOMP_MAX)
+!$OMP&    IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
+                    IOMP  = 1
+!$                  IOMP = OMP_GET_THREAD_NUM() + 1
+!$OMP     DO PRIVATE(NZIND,IR,IC,ELM)
+!$OMP&    SCHEDULE(STATIC,CHUNK_NZ)
+!$OMP&    REDUCTION(.OR.:OORANGEIND)
                   DO NZIND=1_8,NZ_loc
                      IR = IRN_loc(NZIND)
                      IC = JCN_loc(NZIND)
                      IF((IR.GE.1).AND.(IR.LE.N).AND.
      &                    (IC.GE.1).AND.(IC.LE.N)) THEN
                         ELM = abs(A_loc(NZIND))*SCA(IR)*SCA(IC)
-                        WRKRC(ITDRPTR-1+IR) = WRKRC(ITDRPTR-1+IR) + ELM
+                        WRKR_TH(IR,IOMP) = WRKR_TH(IR,IOMP) + ELM
                         IF(IR.NE.IC) THEN
-                           WRKRC(ITDRPTR-1+IC) = 
-     &                          WRKRC(ITDRPTR-1+IC) + ELM
+                          WRKR_TH(IC,IOMP) = WRKR_TH(IC,IOMP) + ELM
                         ENDIF
                      ELSE
-                        OORANGEIND = 1
+                        OORANGEIND = .TRUE.
                      ENDIF
                   ENDDO
-               ELSEIF(OORANGEIND.EQ.0)THEN
+!$OMP     END DO
+!$OMP   END PARALLEL
+               ELSEIF(.NOT.OORANGEIND)THEN
+!$OMP   PARALLEL PRIVATE(IOMP)
+!$OMP&  NUM_THREADS(NOMP_MAX)
+!$OMP&    IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
+                    IOMP  = 1
+!$                  IOMP = OMP_GET_THREAD_NUM() + 1
+!$OMP     DO PRIVATE(NZIND,IR,IC,ELM)
+!$OMP&    SCHEDULE(STATIC,CHUNK_NZ)
                   DO NZIND=1_8,NZ_loc
                      IR = IRN_loc(NZIND)
                      IC = JCN_loc(NZIND)
                      ELM = abs(A_loc(NZIND))*SCA(IR)*SCA(IC)
-                     WRKRC(ITDRPTR-1+IR) = WRKRC(ITDRPTR-1+IR) + ELM
+                     WRKR_TH(IR,IOMP) = WRKR_TH(IR,IOMP) + ELM
                      IF(IR.NE.IC) THEN
-                        WRKRC(ITDRPTR-1+IC) = WRKRC(ITDRPTR-1+IC) + ELM
+                       WRKR_TH(IC,IOMP) = WRKR_TH(IC,IOMP) + ELM
                      ENDIF
                   ENDDO
+!$OMP     END DO
+!$OMP   END PARALLEL
+C}
+               ENDIF
+C
+C              For all i on MYID:
+C              Build WRKRC(i) = Sum       (WRKR_TH(i,IOMP)
+C                              IOMP \in [1:NOMP_MAX]
+               IF(NUMPROCS > 1) THEN
+                 CALL DMUMPS_REDUCE_WRK_MPI (WRKRC, N, WRKR_TH, 
+     &                 NOMP_MAX, 
+     &                 IWRK(IMYRPTR),INUMMYR)
+               ELSE
+                 CALL DMUMPS_REDUCE_WRK (WRKRC, N, WRKR_TH, NOMP_MAX)
                ENDIF
+             ENDIF
                IF(NUMPROCS > 1) THEN
+C{
                   CALL DMUMPS_DOCOMM1N(MYID, NUMPROCS,
      &                 WRKRC(ITDRPTR), N, TAG_ITERS+2+ITER, 
      &                 IRSNDRCVNUM, IWRK(IRNGHBPRCS),
@@ -1136,54 +1508,72 @@ C     ONE-NORM ITERATION
      &                 (NB2.GT.0))) THEN
                      ONEERRL = DMUMPS_ERRSCALOC(SCA,  
      &                    WRKRC(ITDRPTR), N,
-     &                    IWRK(IMYRPTR),INUMMYR) 
+     &                    IWRK(IMYRPTR),INUMMYR, NOMP_MAX) 
 C     mpi allreduce.
                      CALL MPI_ALLREDUCE(ONEERRL, ONEERRG, 
      &                    1, MPI_DOUBLE_PRECISION,
      &                    MPI_MAX, COMM, IERROR)
                      IF(ONEERRG.LE.EPS) THEN
                         CALL DMUMPS_UPDATESCALE(SCA,  WRKRC(ITDRPTR), N,
-     &                       IWRK(IMYRPTR),INUMMYR)
+     &                       IWRK(IMYRPTR),INUMMYR, NOMP_MAX)
                         ITER = NB1+NB2+1
                         CYCLE
                      ENDIF
                   ENDIF
+C}
                ELSE
-C     SINGLE-PROCESSOR CASE: ONE-NORM ERROR COMPUTATION
+C{             SINGLE-PROCESSOR CASE: ONE-NORM ERROR COMPUTATION
                   IF((EPS .GT. RZERO) .OR. 
      &                 ((ITER.EQ.NB1+NB2).AND.
      &                 (NB2.GT.0))) THEN
                      ONEERRL = DMUMPS_ERRSCA1(SCA, 
-     &                    WRKRC(ITDRPTR), N)
+     &                    WRKRC(ITDRPTR), N, NOMP_MAX)
                      ONEERRG = ONEERRL
                      IF(ONEERRG.LE.EPS) THEN
-                        CALL DMUMPS_UPSCALE1(SCA,  WRKRC(ITDRPTR), N)
+                        CALL DMUMPS_UPSCALE1(SCA, WRKRC(ITDRPTR), N,
+     &                                       NOMP_MAX)
                         ITER = NB1+NB2+1
                         CYCLE
                      ENDIF
                   ENDIF
                ENDIF
+C}
             ENDIF
             IF(NUMPROCS > 1) THEN
-               CALL DMUMPS_UPDATESCALE(SCA,  WRKRC(ITDRPTR), N,
-     &              IWRK(IMYRPTR),INUMMYR)
+               CALL DMUMPS_UPDATESCALE(SCA, WRKRC(ITDRPTR), N,
+     &              IWRK(IMYRPTR),INUMMYR, NOMP_MAX)
             ELSE
-               CALL DMUMPS_UPSCALE1(SCA,  WRKRC(ITDRPTR), N)
+               CALL DMUMPS_UPSCALE1(SCA, WRKRC(ITDRPTR), N, 
+     &                              NOMP_MAX)
             ENDIF     
             ITER = ITER + 1
+C}
          ENDDO
          ONENORMERR = ONEERRG 
          INFNORMERR = INFERRG 
          IF(NUMPROCS > 1) THEN
+C{
             CALL MPI_REDUCE(SCA, WRKRC(1), N, MPI_DOUBLE_PRECISION,
      &           MPI_MAX, 0, 
      &           COMM, IERROR)
             IF(MYID.EQ.0) THEN
+              IF (NOMP_MAX.LE.0) THEN
+               DO I=1, N
+                  SCA(I) = WRKRC(I)
+               ENDDO
+              ELSE
+!$OMP       PARALLEL DO PRIVATE(I)
+!$OMP&      SCHEDULE(STATIC,CHUNK)
+!$OMP&      IF ( N > K361 .AND. NOMP .GT. 1)
                DO I=1, N
                   SCA(I) = WRKRC(I)
                ENDDO
+!$OMP       END PARALLEL DO
+              ENDIF
             ENDIF
+C}
          ENDIF
+C}
       ENDIF
       RETURN
       END SUBROUTINE DMUMPS_SIMSCALEABSSYM
diff -pruN 5.6.2-2.1/src/dfac_scalings_simScale_util.F 5.7.1-1/src/dfac_scalings_simScale_util.F
--- 5.6.2-2.1/src/dfac_scalings_simScale_util.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/dfac_scalings_simScale_util.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -14,19 +14,23 @@ C
       SUBROUTINE DMUMPS_CREATEPARTVEC(MYID, NUMPROCS, COMM,
      & IRN_loc, JCN_loc, NZ_loc,
      & IPARTVEC, ISZ, OSZ,
-     & IWRK, IWSZ)
+     & IWRK, IWSZ, INUMMY, NOMP_MAX )
+!$    USE OMP_LIB
 C
       IMPLICIT NONE
       EXTERNAL DMUMPS_BUREDUCE
-      INTEGER, INTENT(IN)    :: MYID, NUMPROCS, COMM
+      INTEGER, INTENT(IN)    :: MYID, NUMPROCS, COMM, NOMP_MAX
       INTEGER(8), INTENT(IN) :: NZ_loc 
-      INTEGER, INTENT(IN)    :: IWSZ
+      INTEGER(8), INTENT(IN) :: IWSZ
       INTEGER, INTENT(IN)    :: ISZ, OSZ
       INTEGER, INTENT(IN)    :: IRN_loc(NZ_loc), JCN_loc(NZ_loc)
 C  OUTPUT
 C     IPARTVEC(I) = proc number with largest number of entries 
 C                in row/col I
+C     INUMMY = number of local rows/columns with
+C              at least one local entry (NUMPROCS .NE. 1 only)
       INTEGER, INTENT(OUT) :: IPARTVEC(ISZ)
+      INTEGER, INTENT(OUT) :: INUMMY
 C
 C  INTERNAL WORKING ARRAY
 C     IWRK (1:2*ISZ) is initialized to couples (MYID, Nb of entries
@@ -46,42 +50,87 @@ C     LOCAL VARS
       INTEGER(8) :: I8
       INTEGER OP, IERROR
       INTEGER IR, IC
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
 C
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP  = omp_get_max_threads()
+!$     CHUNK= max(K361/2, (ISZ+NOMP-1) / NOMP )
+!$    ENDIF
+C
+      INUMMY = 0
       IF(NUMPROCS.NE.1) THEN
 C     CHECK done outsize
 C     IF(IWSZ < 4*ISZ) THEN
 C     CHECK ENDS
          CALL MPI_OP_CREATE(DMUMPS_BUREDUCE, .TRUE., OP, IERROR)
 C     PERFORM THE REDUCTION
-#if defined(WORKAROUNDINTELILP64MPI2INTEGER)
-        CALL DMUMPS_IBUINIT(IWRK, 4*ISZ, int(ISZ,4))
-#else
-        CALL DMUMPS_IBUINIT(IWRK, 4*ISZ, ISZ)
-#endif
 C     WE FIRST ZERO OUT  
+       IF (NOMP_MAX.LE.0) THEN
+         DO I=1,ISZ
+            IWRK(2_8*int(I,8)-1_8) = 0
+            IWRK(2_8*int(I,8))     = MYID
+         ENDDO
+       ELSE
+!$OMP   PARALLEL DO PRIVATE(I) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1.AND.ISZ > K361 )
          DO I=1,ISZ
-            IWRK(2*I-1) = 0
-            IWRK(2*I) = MYID
+            IWRK(2_8*int(I,8)-1_8) = 0
+            IWRK(2_8*int(I,8))     = MYID
          ENDDO
+!$OMP   END PARALLEL DO
+       ENDIF
          DO I8=1_8,NZ_loc
             IR = IRN_loc(I8)
             IC = JCN_loc(I8)
             IF((IR.GE.1).AND.(IR.LE.ISZ).AND.
      &           (IC.GE.1).AND.(IC.LE.OSZ)) THEN
-               IWRK(2*IR-1) = IWRK(2*IR-1) + 1
+               IWRK(2_8*int(IR,8)-1_8) = IWRK(2_8*int(IR,8)-1_8) + 1
             ENDIF
          ENDDO
-         CALL MPI_ALLREDUCE(IWRK(1), IWRK(1+2*ISZ), ISZ,
+         CALL MUMPS_BIGALLREDUCE(.FALSE., IWRK(1),
+     &        IWRK(1_8+2_8*int(ISZ,8)), ISZ,
      &        MPI_2INTEGER, OP, COMM, IERROR)      
-         DO I=1,ISZ
-            IPARTVEC(I) = IWRK(2*I+2*ISZ)
-         ENDDO
+C
+        IF (NOMP_MAX.LE.0) THEN
+          DO I=1,ISZ
+             IPARTVEC(I) = IWRK(2_8*int(I,8)+2_8*int(ISZ,8))
+C            Compute INUMMY directly
+             IF ( IPARTVEC(I) .EQ. MYID. OR.
+     &            IWRK(2_8*int(I,8)-1_8) .GT. 0 ) THEN
+               INUMMY=INUMMY+1
+             ENDIF
+          ENDDO
+        ELSE
+!$OMP   PARALLEL DO PRIVATE(I) SCHEDULE(STATIC,CHUNK)
+!$OMP&  IF ( ISZ > K361 .AND. NOMP .GT. 1)
+!$OMP&  REDUCTION(+:INUMMY)
+          DO I=1,ISZ
+             IPARTVEC(I) = IWRK(2_8*int(I,8)+2_8*int(ISZ,8))
+C            Compute INUMMY directly
+             IF ( IPARTVEC(I) .EQ. MYID. OR.
+     &            IWRK(2_8*int(I,8)-1_8) .GT. 0 ) THEN
+               INUMMY=INUMMY+1
+             ENDIF
+          ENDDO
+!$OMP   END PARALLEL DO
+        ENDIF
 C     FREE THE OPERATOR
          CALL MPI_OP_FREE(OP, IERROR)
       ELSE
-         DO I=1,ISZ
-            IPARTVEC(I) = 0
-         ENDDO
+        IF (NOMP_MAX.LE.0) THEN
+          DO I=1,ISZ
+             IPARTVEC(I) = 0
+          ENDDO
+        ELSE
+!$OMP    PARALLEL DO PRIVATE(I) SCHEDULE(STATIC,CHUNK)
+!$OMP&   IF ( ISZ > K361 .AND. NOMP .GT. 1)
+          DO I=1,ISZ
+             IPARTVEC(I) = 0
+          ENDDO
+!$OMP    END PARALLEL DO
+       ENDIF
       ENDIF
       RETURN
       END SUBROUTINE DMUMPS_CREATEPARTVEC
@@ -89,94 +138,17 @@ C
 C     SEPARATOR: Another function begins
 C
 C 
-      SUBROUTINE DMUMPS_FINDNUMMYROWCOL(MYID, NUMPROCS, COMM,
-     &     IRN_loc, JCN_loc, NZ_loc,
-     &     ROWPARTVEC, COLPARTVEC, M, N,
-     &     INUMMYR,
-     &     INUMMYC,     
-     &     IWRK, IWSZ)
-      IMPLICIT NONE
-      INTEGER(8), INTENT(IN) :: NZ_loc
-      INTEGER, INTENT(IN) :: MYID, NUMPROCS, M, N, IWSZ
-      INTEGER, INTENT(IN) :: IRN_loc(NZ_loc), JCN_loc(NZ_loc)
-C     [ROW/COL]PARTVEC(I) holds proc number with largest number of entries 
-C                in row/col I
-      INTEGER, INTENT(IN) :: ROWPARTVEC(M)
-      INTEGER, INTENT(IN) :: COLPARTVEC(N)
-      INTEGER, INTENT(IN) :: COMM
-C
-C  OUTPUT PARAMETERS
-C     INUMMYR < M and INUMMYC < N  (CPA or <= ??)
-C     INUMMYR holds the number of rows allocated to me 
-C             or non empty on my proc
-C     INUMMYC idem with columns
-      INTEGER INUMMYR, INUMMYC
-C
-C  INTERNAL working array
-      INTEGER IWRK(IWSZ)
-C
-C   Local variables
-      INTEGER I, IR, IC
-      INTEGER(8) ::  I8
-C check done outsize     
-C     IF(IWSZ < M) THEN ERROR
-C     IF(IWSZ < N) THEN ERROR
-      INUMMYR = 0
-      INUMMYC = 0
-C     MARK MY ROWS. FIRST COUNT,
-C          IF DYNAMIC MEMORY ALLOCATIOn WILL USED
-C     INUMMYR first counts number of rows affected to me
-C             (that will be centralized on MYID)
-      DO I=1,M
-         IWRK(I) = 0
-         IF(ROWPARTVEC(I).EQ.MYID) THEN
-            IWRK(I)=1
-            INUMMYR = INUMMYR + 1
-         ENDIF
-      ENDDO
-      DO I8=1_8,NZ_loc
-         IR = IRN_loc(I8)
-         IC = JCN_loc(I8)
-         IF((IR.GE.1).AND.(IR.LE.M).AND.
-     &        ((IC.GE.1).AND.(IC.LE.N)) ) THEN
-            IF(IWRK(IR) .EQ. 0) THEN
-               IWRK(IR)= 1
-               INUMMYR = INUMMYR + 1
-            ENDIF
-         ENDIF
-      ENDDO
-C     DO THE SMAME THING FOR COLS
-      DO I=1,N
-         IWRK(I) = 0
-         IF(COLPARTVEC(I).EQ.MYID) THEN
-            IWRK(I)= 1
-            INUMMYC = INUMMYC + 1
-         ENDIF
-      ENDDO
-      DO I8=1_8,NZ_loc
-         IC = JCN_loc(I8)
-         IR = IRN_loc(I8)
-         IF((IR.GE.1).AND.(IR.LE.M).AND.
-     &        ((IC.GE.1).AND.(IC.LE.N)) ) THEN
-            IF(IWRK(IC) .EQ. 0) THEN
-               IWRK(IC)= 1
-               INUMMYC = INUMMYC + 1
-            ENDIF
-         ENDIF
-      ENDDO
-C
-      RETURN
-      END SUBROUTINE DMUMPS_FINDNUMMYROWCOL
       SUBROUTINE DMUMPS_FILLMYROWCOLINDICES(MYID, NUMPROCS,COMM,    
      &     IRN_loc, JCN_loc, NZ_loc,
      &     ROWPARTVEC, COLPARTVEC, M, N,
      &     MYROWINDICES, INUMMYR,
      &     MYCOLINDICES, INUMMYC,     
-     &     IWRK, IWSZ  )
+     &     IWRK, IWSZ, NOMP_MAX  )
+!$    USE OMP_LIB
       IMPLICIT NONE
-      INTEGER(8) :: NZ_loc
-      INTEGER MYID, NUMPROCS, M, N
-      INTEGER INUMMYR, INUMMYC, IWSZ
+      INTEGER(8) :: NZ_loc, IWSZ
+      INTEGER MYID, NUMPROCS, M, N, NOMP_MAX
+      INTEGER INUMMYR, INUMMYC
       INTEGER IRN_loc(NZ_loc), JCN_loc(NZ_loc)
       INTEGER ROWPARTVEC(M)
       INTEGER COLPARTVEC(N)
@@ -188,11 +160,32 @@ C
       INTEGER I, IR, IC, ITMP
       INTEGER(8) :: I8
 C      
+      INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP=omp_get_max_threads()
+C      note that M=N
+!$     CHUNK= max(K361/2, (M+NOMP-1) / NOMP )
+!$    ENDIF
+C      
 C     MARK MY ROWS. 
-      DO I=1,M
-         IWRK(I) = 0
-         IF(ROWPARTVEC(I).EQ.MYID) IWRK(I)=1
-      ENDDO
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,M
+           IWRK(I) = 0
+           IF(ROWPARTVEC(I).EQ.MYID) IWRK(I)=1
+        ENDDO
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I) 
+!$OMP&  SCHEDULE(STATIC,CHUNK)
+!$OMP&  IF ( M > K361 .AND. NOMP .GT. 1)
+        DO I=1,M
+           IWRK(I) = 0
+           IF(ROWPARTVEC(I).EQ.MYID) IWRK(I)=1
+        ENDDO
+!$OMP END PARALLEL DO
+      ENDIF
+CTEMP !$OMP  PARALLEL DO PRIVATE(I8,IR,IC) SCHEDULE(STATIC,CHUNK)
+CTEMP !$OMP& IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
       DO I8=1,NZ_loc
          IR = IRN_loc(I8)         
          IC = JCN_loc(I8)
@@ -201,6 +194,7 @@ C     MARK MY ROWS.
             IF(IWRK(IR) .EQ. 0) IWRK(IR)= 1
          ENDIF
       ENDDO
+CTEMP !$OMP END PARALLEL DO
 C     PUT MY ROWS INTO MYROWINDICES
       ITMP = 1
       DO I=1,M
@@ -212,10 +206,24 @@ C     PUT MY ROWS INTO MYROWINDICES
 C
 C
 C     DO THE SMAME THING FOR COLS
-      DO I=1,N
-         IWRK(I) = 0
-         IF(COLPARTVEC(I).EQ.MYID) IWRK(I)= 1
-      ENDDO
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,N
+           IWRK(I) = 0
+           IF(COLPARTVEC(I).EQ.MYID) IWRK(I)= 1
+        ENDDO
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I) 
+!$OMP&  SCHEDULE(STATIC,CHUNK)
+!$OMP&  IF ( N > K361 .AND. NOMP .GT. 1)
+        DO I=1,N
+           IWRK(I) = 0
+           IF(COLPARTVEC(I).EQ.MYID) IWRK(I)= 1
+        ENDDO
+!$OMP END PARALLEL DO
+      ENDIF
+C
+CTEMP !$OMP  PARALLEL DO PRIVATE(I8,IR,IC) SCHEDULE(STATIC,CHUNK)
+CTEMP !$OMP& IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
       DO I8=1,NZ_loc
          IR = IRN_loc(I8)         
          IC = JCN_loc(I8)
@@ -224,6 +232,7 @@ C     DO THE SMAME THING FOR COLS
             IF(IWRK(IC) .EQ. 0) IWRK(IC)= 1
          ENDIF
       ENDDO
+CTEMP !$OMP END PARALLEL DO
 C     PUT MY ROWS INTO MYROWINDICES
       ITMP = 1
       DO I=1,N
@@ -305,11 +314,12 @@ C
 C     SEPARATOR: Another function begins
 C
       DOUBLE PRECISION FUNCTION DMUMPS_ERRSCALOC(D, TMPD, DSZ,
-     &     INDX, INDXSZ)
+     &     INDX, INDXSZ, NOMP_MAX)
+!$    USE OMP_LIB
 C     THE VAR D IS NOT USED IN COMPUTATIONS.
 C     IT IS THERE FOR READIBLITY OF THE *simScaleAbs.F
       IMPLICIT NONE 
-      INTEGER DSZ, INDXSZ
+      INTEGER, INTENT(IN):: DSZ, INDXSZ, NOMP_MAX
       DOUBLE PRECISION D(DSZ)
       DOUBLE PRECISION TMPD(DSZ)
       INTEGER INDX(INDXSZ)
@@ -319,19 +329,40 @@ C     LOCAL VARS
       INTEGER I, IIND
       DOUBLE PRECISION ERRMAX
       INTRINSIC abs
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
       ERRMAX = -RONE
-      DO I=1,INDXSZ
-         IIND = INDX(I)
-         IF(abs(RONE-TMPD(IIND)).GT.ERRMAX) THEN
-            ERRMAX = abs(RONE-TMPD(IIND))
-         ENDIF
-      ENDDO           
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP  = OMP_GET_MAX_THREADS()
+!$     CHUNK= max(K361/2, (INDXSZ+NOMP-1) / NOMP )
+!$    ENDIF
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,INDXSZ
+           IIND = INDX(I)
+           IF(abs(RONE-TMPD(IIND)).GT.ERRMAX) THEN
+              ERRMAX = abs(RONE-TMPD(IIND))
+           ENDIF
+        ENDDO           
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I,IIND) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1 .AND. INDXSZ > K361 )
+!$OMP&  REDUCTION(max:ERRMAX)
+        DO I=1,INDXSZ
+           IIND = INDX(I)
+           IF(abs(RONE-TMPD(IIND)).GT.ERRMAX) THEN
+              ERRMAX = abs(RONE-TMPD(IIND))
+           ENDIF
+        ENDDO           
+!$OMP   END PARALLEL DO
+      ENDIF
       DMUMPS_ERRSCALOC = ERRMAX
       RETURN
       END FUNCTION DMUMPS_ERRSCALOC
-      DOUBLE PRECISION FUNCTION DMUMPS_ERRSCA1(D, TMPD, DSZ)
+      DOUBLE PRECISION FUNCTION DMUMPS_ERRSCA1(D, TMPD, DSZ, NOMP_MAX)
+!$    USE OMP_LIB
       IMPLICIT NONE 
-      INTEGER DSZ
+      INTEGER, INTENT(IN):: DSZ, NOMP_MAX
       DOUBLE PRECISION D(DSZ)
       DOUBLE PRECISION TMPD(DSZ)
 C     LOCAL VARS
@@ -340,12 +371,31 @@ C     LOCAL VARS
       INTEGER I
       DOUBLE PRECISION ERRMAX1
       INTRINSIC abs
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
       ERRMAX1 = -RONE
-      DO I=1,DSZ
-         IF(abs(RONE-TMPD(I)).GT.ERRMAX1) THEN
-            ERRMAX1 = abs(RONE-TMPD(I))
-         ENDIF
-      ENDDO
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP  = OMP_GET_MAX_THREADS()
+!$     CHUNK= max(K361/2, (DSZ+NOMP-1) / NOMP )
+!$    ENDIF
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,DSZ
+           IF(abs(RONE-TMPD(I)).GT.ERRMAX1) THEN
+              ERRMAX1 = abs(RONE-TMPD(I))
+           ENDIF
+        ENDDO
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1.AND.DSZ > K361 )
+!$OMP&  REDUCTION(max:ERRMAX1)
+        DO I=1,DSZ
+           IF(abs(RONE-TMPD(I)).GT.ERRMAX1) THEN
+              ERRMAX1 = abs(RONE-TMPD(I))
+           ENDIF
+        ENDDO
+!$OMP   END PARALLEL DO
+      ENDIF
       DMUMPS_ERRSCA1 = ERRMAX1
       RETURN
       END FUNCTION DMUMPS_ERRSCA1
@@ -353,9 +403,10 @@ C
 C     SEPARATOR: Another function begins
 C
       SUBROUTINE DMUMPS_UPDATESCALE(D,  TMPD, DSZ,
-     &        INDX, INDXSZ)
+     &        INDX, INDXSZ, NOMP_MAX)
+!$    USE OMP_LIB
       IMPLICIT NONE
-      INTEGER DSZ, INDXSZ
+      INTEGER, INTENT(in) :: DSZ, INDXSZ, NOMP_MAX
       DOUBLE PRECISION D(DSZ)
       DOUBLE PRECISION TMPD(DSZ)
       INTEGER INDX(INDXSZ)
@@ -364,15 +415,34 @@ C     LOCAL VARS
       INTEGER I, IIND
       DOUBLE PRECISION RZERO
       PARAMETER(RZERO=0.0D0)
-      DO I=1,INDXSZ
-         IIND = INDX(I)
-         IF (TMPD(IIND).NE.RZERO) D(IIND) = D(IIND)/sqrt(TMPD(IIND))
-      ENDDO
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP  = OMP_GET_MAX_THREADS()
+!$     CHUNK= max(K361/2, (INDXSZ+NOMP-1) / NOMP )
+!$    ENDIF
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,INDXSZ
+           IIND = INDX(I)
+           IF (TMPD(IIND).NE.RZERO) D(IIND)=D(IIND)/sqrt(TMPD(IIND))
+        ENDDO
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I,IIND) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1.AND.  INDXSZ> K361 )
+        DO I=1,INDXSZ
+           IIND = INDX(I)
+           IF (TMPD(IIND).NE.RZERO) D(IIND)=D(IIND)/sqrt(TMPD(IIND))
+        ENDDO
+!$OMP   END PARALLEL DO
+      ENDIF
       RETURN
       END SUBROUTINE DMUMPS_UPDATESCALE
-      SUBROUTINE DMUMPS_UPSCALE1(D,  TMPD, DSZ)
+C
+      SUBROUTINE DMUMPS_UPSCALE1(D,  TMPD, DSZ, NOMP_MAX)
+!$    USE OMP_LIB
       IMPLICIT NONE
-      INTEGER DSZ
+      INTEGER, INTENT(IN):: DSZ, NOMP_MAX
       DOUBLE PRECISION D(DSZ)
       DOUBLE PRECISION TMPD(DSZ)
       INTRINSIC sqrt
@@ -380,74 +450,186 @@ C     LOCAL VARS
       INTEGER I
       DOUBLE PRECISION RZERO
       PARAMETER(RZERO=0.0D0)
-      DO I=1,DSZ
-         IF (TMPD(I) .NE. RZERO) D(I) = D(I)/sqrt(TMPD(I))
-      ENDDO
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
+!$    IF (NOMP_MAX.GT.0) THEN
+!$      NOMP  = OMP_GET_MAX_THREADS()
+!$      CHUNK= max(K361/2, (DSZ+NOMP-1) / NOMP )
+!$    ENDIF
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,DSZ
+           IF (TMPD(I) .NE. RZERO) D(I) = D(I)/sqrt(TMPD(I))
+        ENDDO
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1.AND.  DSZ> K361 )
+        DO I=1,DSZ
+           IF (TMPD(I) .NE. RZERO) D(I) = D(I)/sqrt(TMPD(I))
+        ENDDO
+!$OMP   END PARALLEL DO
+      ENDIF
       RETURN
       END SUBROUTINE DMUMPS_UPSCALE1
 C
 C     SEPARATOR: Another function begins
 C
-      SUBROUTINE DMUMPS_INITREALLST(D, DSZ, INDX, INDXSZ, VAL)
+      SUBROUTINE DMUMPS_INITREALLST(D, DSZ, INDX, INDXSZ, VAL,
+     &                              NOMP_MAX)
+!$    USE OMP_LIB
       IMPLICIT NONE
-      INTEGER DSZ, INDXSZ
+      INTEGER, INTENT(IN):: DSZ, INDXSZ, NOMP_MAX
       DOUBLE PRECISION D(DSZ)
       INTEGER INDX(INDXSZ)
       DOUBLE PRECISION VAL
 C     LOCAL VARS
       INTEGER I, IIND
-      DO I=1,INDXSZ
-         IIND = INDX(I)
-         D(IIND) = VAL
-      ENDDO
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP  = OMP_GET_MAX_THREADS()
+!$     CHUNK= max(K361/2, (INDXSZ+NOMP-1) / NOMP )
+!$    ENDIF
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,INDXSZ
+           IIND = INDX(I)
+           D(IIND) = VAL
+        ENDDO
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I,IIND) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1.AND.  INDXSZ > K361 )
+        DO I=1,INDXSZ
+           IIND = INDX(I)
+           D(IIND) = VAL
+        ENDDO
+!$OMP   END PARALLEL DO
+      ENDIF
       RETURN
       END SUBROUTINE DMUMPS_INITREALLST
 C
 C     SEPARATOR: Another function begins
 C
-      SUBROUTINE DMUMPS_INVLIST(D, DSZ, INDX, INDXSZ)
-      IMPLICIT NONE
-      INTEGER DSZ, INDXSZ
-      DOUBLE PRECISION D(DSZ)
-      INTEGER INDX(INDXSZ)
-C     LOCALS
-      INTEGER I, IIND
-      DO I=1,INDXSZ
-         IIND  = INDX(I)
-         D(IIND) = 1.0D0/D(IIND)
-      ENDDO
-      RETURN
-      END SUBROUTINE DMUMPS_INVLIST
 C
 C     SEPARATOR: Another function begins
 C
-      SUBROUTINE DMUMPS_INITREAL(D, DSZ, VAL)
+      SUBROUTINE DMUMPS_INITREAL(D, DSZ, VAL, NOMP_MAX)
+!$    USE OMP_LIB
       IMPLICIT NONE
-      INTEGER DSZ
+      INTEGER, INTENT(IN):: DSZ, NOMP_MAX
       DOUBLE PRECISION D(DSZ)
       DOUBLE PRECISION VAL
 C     LOCAL VARS
       INTEGER I
-      DO I=1,DSZ
-         D(I) = VAL
-      ENDDO
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP  = omp_get_max_threads()
+!$     CHUNK= max(K361/2, (DSZ+NOMP-1) / NOMP )
+!$    ENDIF
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,DSZ
+           D(I) = VAL
+        ENDDO
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1.AND.DSZ > K361 )
+        DO I=1,DSZ
+           D(I) = VAL
+        ENDDO
+!$OMP   END PARALLEL DO
+      ENDIF
       RETURN
       END SUBROUTINE DMUMPS_INITREAL
 C
 C     SEPARATOR: Another function begins
 C
-      SUBROUTINE DMUMPS_ZEROOUT(TMPD, TMPSZ, INDX, INDXSZ)
+      SUBROUTINE DMUMPS_REDUCE_WRK(WRK, N, WRK_TH, NOMP_MAX)
+C     Called only when NOMP_MAX>0
+!$    USE OMP_LIB
       IMPLICIT NONE
-      INTEGER TMPSZ,INDXSZ 
-      DOUBLE PRECISION TMPD(TMPSZ)
+      INTEGER N,NOMP_MAX
+      DOUBLE PRECISION WRK(N), WRK_TH(N,NOMP_MAX)
+C     LOCAL VAR
+      INTEGER I, IOMP
+      DOUBLE PRECISION DZERO
+      PARAMETER(DZERO=0.0D0)
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
+!$    NOMP  = OMP_GET_MAX_THREADS()
+!$    CHUNK= max(K361/2, (N+NOMP-1) / NOMP )
+!$OMP   PARALLEL DO PRIVATE(I,IOMP) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1.AND.  N > K361 )
+      DO I=1,N
+         WRK(I) = DZERO
+         DO IOMP=1,NOMP_MAX
+           WRK(I) = WRK_TH(I,IOMP) +  WRK(I)
+         ENDDO
+      ENDDO      
+!$OMP END PARALLEL DO
+      RETURN
+      END SUBROUTINE DMUMPS_REDUCE_WRK
+      SUBROUTINE DMUMPS_REDUCE_WRK_MPI(WRK, N, WRK_TH, NOMP_MAX, 
+     &           INDX, INDXSZ)
+C     Called only when NOMP_MAX>0
+!$    USE OMP_LIB
+      IMPLICIT NONE
+      INTEGER N,NOMP_MAX,INDXSZ 
+      DOUBLE PRECISION WRK(N), WRK_TH(N,NOMP_MAX)
       INTEGER INDX(INDXSZ)
 C     LOCAL VAR
-      INTEGER I
+      INTEGER I, J, IOMP
       DOUBLE PRECISION DZERO
       PARAMETER(DZERO=0.0D0)
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
+!$      NOMP  = OMP_GET_MAX_THREADS()
+!$      CHUNK= max(K361/2, (INDXSZ+NOMP-1) / NOMP )
+!$OMP   PARALLEL DO PRIVATE(I,J,IOMP) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1.AND.  INDXSZ > K361 )
       DO I=1,INDXSZ
-         TMPD(INDX(I)) = DZERO
+         J = INDX(I)
+         WRK(J) = DZERO
+         DO IOMP=1,NOMP_MAX
+           WRK(J) = WRK_TH(J,IOMP) + WRK(J)
+         ENDDO
       ENDDO      
+!$OMP END PARALLEL DO
+      RETURN
+      END SUBROUTINE DMUMPS_REDUCE_WRK_MPI
+      SUBROUTINE DMUMPS_ZEROOUT(TMPD, TMPSZ, INDX, INDXSZ, 
+     &                          NOMP_MAX)
+!$    USE OMP_LIB
+      IMPLICIT NONE
+      INTEGER, INTENT(IN):: TMPSZ,INDXSZ, NOMP_MAX
+      DOUBLE PRECISION TMPD(TMPSZ)
+      INTEGER INDX(INDXSZ)
+C     LOCAL VAR
+      INTEGER I
+      DOUBLE PRECISION DZERO
+      PARAMETER(DZERO=0.0D0)
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP  = OMP_GET_MAX_THREADS()
+!$     CHUNK= max(K361/2, (INDXSZ+NOMP-1) / NOMP )
+!$    ENDIF
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,INDXSZ
+           TMPD(INDX(I)) = DZERO
+        ENDDO      
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1.AND.  INDXSZ > K361 )
+        DO I=1,INDXSZ
+           TMPD(INDX(I)) = DZERO
+        ENDDO      
+!$OMP END PARALLEL DO
+      ENDIF
       RETURN
       END SUBROUTINE DMUMPS_ZEROOUT
 C
@@ -509,7 +691,7 @@ C     SEPARATOR: Another function begins
 C
       SUBROUTINE DMUMPS_IBUINIT(IW, IWSZ, IVAL)
       IMPLICIT NONE
-      INTEGER IWSZ
+      INTEGER(8) :: IWSZ
 #if defined(WORKAROUNDINTELILP64MPI2INTEGER)
       INTEGER(4) IW(IWSZ)
       INTEGER(4) IVAL
@@ -517,8 +699,8 @@ C
       INTEGER IW(IWSZ)
       INTEGER IVAL
 #endif
-      INTEGER I
-      DO I=1,IWSZ
+      INTEGER(8) :: I
+      DO I=1_8,IWSZ
          IW(I)=IVAL
       ENDDO
       RETURN
@@ -535,10 +717,10 @@ C
      &     IWRK,IWRKSZ, SNDSZ, RCVSZ, COMM)
       IMPLICIT NONE
       INTEGER(8), INTENT(IN) :: NZ_loc
-      INTEGER, INTENT(IN)    :: IWRKSZ
+      INTEGER(8), INTENT(IN) :: IWRKSZ
       INTEGER, INTENT(IN) ::  MYID, NUMPROCS, ISZ, OSZ
       INTEGER, INTENT(IN) ::  COMM
-C     When INDX holds row indices O(ther)INDX hold col indices
+C     When INDX holds row indices O(ther)INDX holds col indices
       INTEGER, INTENT(IN) :: INDX(NZ_loc)
       INTEGER, INTENT(IN) :: OINDX(NZ_loc)
 C     On entry IPARTVEC(I) holds proc number with largest number of entries 
@@ -582,7 +764,7 @@ C      IF(ISZ>IWRKSZ) THEN ERROR
          SNDSZ(I) = 0
          RCVSZ(I) = 0
       ENDDO
-      DO I=1,IWRKSZ
+      DO I=1,max(ISZ,OSZ)
          IWRK(I) = 0
       ENDDO
 C
@@ -595,7 +777,7 @@ C     set SNDSZ
             PIND = IPARTVEC(IIND)
             IF(PIND .NE. MYID) THEN
 C              MYID will send row/col IIND to proc PIND 
-C              (PIND has the largest nb of entries in row/con IIND
+C              (PIND has the largest nb of entries in row/col IIND
                IF(IWRK(IIND).EQ.0) THEN
                   IWRK(IIND) = 1
                   SNDSZ(PIND+1) = SNDSZ(PIND+1)+1
@@ -926,18 +1108,22 @@ C     COMMUNICATE THE UPDATED ONES
       SUBROUTINE DMUMPS_CREATEPARTVECSYM(MYID, NUMPROCS, COMM,
      & IRN_loc, JCN_loc, NZ_loc,
      & IPARTVEC, ISZ,
-     & IWRK, IWSZ)
+     & IWRK, IWSZ, INUMMY)
+!$    USE OMP_LIB
       IMPLICIT NONE
       EXTERNAL DMUMPS_BUREDUCE
       INTEGER, INTENT(IN) :: MYID, NUMPROCS, COMM
-      INTEGER(8)          :: NZ_loc
-      INTEGER, INTENT(IN) :: ISZ, IWSZ
+      INTEGER(8)          :: NZ_loc, IWSZ
+      INTEGER, INTENT(IN) :: ISZ
       INTEGER, INTENT(IN) :: IRN_loc(NZ_loc), JCN_loc(NZ_loc)
 C
 C  OUTPUT
 C     IPARTVEC(I) = proc number with largest number of entries 
 C                in row/col I
+C     INUMMY = number of local rows/columns with
+C              at least one local entry (NUMPROCS .NE. 1 only)
       INTEGER, INTENT(OUT) :: IPARTVEC(ISZ)
+      INTEGER, INTENT(OUT) :: INUMMY
 C
 C  INTERNAL WORKING ARRAY
 C     IWRK (1:2*ISZ) is initialized to couples (MYID, Nb of entries
@@ -957,39 +1143,55 @@ C     LOCAL VARS
       INTEGER(8) :: I8
       INTEGER OP, IERROR
       INTEGER IR, IC
+      INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
 C
+      INUMMY = 0
+!$    NOMP=omp_get_max_threads()
+!$    CHUNK= max(K361/2, (ISZ+NOMP-1) / NOMP )
       IF(NUMPROCS.NE.1) THEN
 C     CHECK done outsize
 C     IF(IWSZ < 2*ISZ) THEN
 C     CHECK ENDS
          CALL MPI_OP_CREATE(DMUMPS_BUREDUCE, .TRUE., OP, IERROR)
 C     PERFORM THE REDUCTION
-#if defined(WORKAROUNDINTELILP64MPI2INTEGER)
-         CALL DMUMPS_IBUINIT(IWRK, 4*ISZ, int(ISZ,4))
-#else
-         CALL DMUMPS_IBUINIT(IWRK, 4*ISZ, ISZ)
-#endif
+!$OMP   PARALLEL DO PRIVATE(I) SCHEDULE(STATIC,CHUNK)
+!$OMP&  IF ( ISZ > K361 .AND. NOMP .GT. 1)
          DO I=1,ISZ
-            IWRK(2*I-1) = 0
-            IWRK(2*I) = MYID
+            IWRK(2_8*int(I,8)-1_8) = 0
+            IWRK(2_8*int(I,8)) = MYID
          ENDDO
+!$OMP   END PARALLEL DO
          DO I8=1_8,NZ_loc
             IR = IRN_loc(I8)
             IC = JCN_loc(I8)
             IF((IR.GE.1).AND.(IR.LE.ISZ).AND.
      &           (IC.GE.1).AND.(IC.LE.ISZ)) THEN
-               IWRK(2*IR-1) = IWRK(2*IR-1) + 1
-               IWRK(2*IC-1) = IWRK(2*IC-1) + 1
+               IWRK(2_8*int(IR,8)-1_8) = IWRK(2_8*int(IR,8)-1_8) + 1
+               IWRK(2_8*int(IC,8)-1_8) = IWRK(2_8*int(IC,8)-1_8) + 1
             ENDIF
          ENDDO
-         CALL MPI_ALLREDUCE(IWRK(1), IWRK(1+2*ISZ), ISZ,
+         CALL MUMPS_BIGALLREDUCE(.FALSE.,
+     &        IWRK(1), IWRK(1_8+2_8*int(ISZ,8)), ISZ,
      &        MPI_2INTEGER, OP, COMM, IERROR)      
+C       CHUNK computed in previous // do
+!$OMP   PARALLEL DO PRIVATE(I) SCHEDULE(STATIC,CHUNK)
+!$OMP&  IF ( ISZ > K361 .AND. NOMP .GT. 1)
+!$OMP&  REDUCTION(+:INUMMY)
          DO I=1,ISZ
-            IPARTVEC(I) = IWRK(2*I+2*ISZ)
+            IPARTVEC(I) = IWRK(2_8*int(I,8)+2_8*int(ISZ,8))
+C           Compute INUMMY directly
+            IF ( IPARTVEC(I) .EQ. MYID. OR.
+     &           IWRK(2_8*int(I,8)-1_8) .GT. 0 ) THEN
+              INUMMY=INUMMY+1
+            ENDIF
          ENDDO
+!$OMP   END PARALLEL DO
 C     FREE THE OPERATOR
          CALL MPI_OP_FREE(OP, IERROR)
       ELSE
+!$OMP   PARALLEL DO PRIVATE(I) SCHEDULE(STATIC,CHUNK)
+!$OMP&  IF ( ISZ > K361 .AND. NOMP .GT. 1)
          DO I=1,ISZ
             IPARTVEC(I) = 0
          ENDDO
@@ -1001,7 +1203,7 @@ C     FREE THE OPERATOR
      & IWRK,IWRKSZ, SNDSZ, RCVSZ, COMM)
       IMPLICIT NONE
       INTEGER(8), INTENT(IN) :: NZ_loc 
-      INTEGER, INTENT(IN)    :: IWRKSZ
+      INTEGER(8), INTENT(IN) :: IWRKSZ
       INTEGER, INTENT(IN)    :: MYID, NUMPROCS, ISZ
       INTEGER, INTENT(IN)    :: INDX(NZ_loc), OINDX(NZ_loc)
       INTEGER, INTENT(IN)    :: IPARTVEC(ISZ)
@@ -1044,7 +1246,7 @@ C      IF(ISZ>IWRKSZ) THEN ERROR
          SNDSZ(I) = 0
          RCVSZ(I) = 0
       ENDDO
-      DO I=1,IWRKSZ
+      DO I=1,ISZ
          IWRK(I) = 0
       ENDDO
 C
@@ -1057,7 +1259,7 @@ C     set SNDSZ
             PIND = IPARTVEC(IIND)
             IF(PIND .NE. MYID) THEN
 C              MYID will send row/col IIND to proc PIND 
-C              (PIND has the largest nb of entries in row/con IIND
+C              (PIND has the largest nb of entries in row/col IIND
                IF(IWRK(IIND).EQ.0) THEN
                   IWRK(IIND) = 1
                   SNDSZ(PIND+1) = SNDSZ(PIND+1)+1
@@ -1092,59 +1294,6 @@ C     number of row/col sent by MYID.
       ENDDO
       RETURN
       END SUBROUTINE DMUMPS_NUMVOLSNDRCVSYM
-      SUBROUTINE DMUMPS_FINDNUMMYROWCOLSYM(MYID, NUMPROCS, COMM,
-     &     IRN_loc, JCN_loc, NZ_loc,
-     &     PARTVEC, N,
-     &     INUMMYR,
-     &     IWRK, IWSZ)
-      IMPLICIT NONE
-      INTEGER MYID, NUMPROCS, N
-      INTEGER(8) :: NZ_loc
-      INTEGER IRN_loc(NZ_loc), JCN_loc(NZ_loc)
-      INTEGER PARTVEC(N)
-      INTEGER INUMMYR
-      INTEGER IWSZ
-      INTEGER IWRK(IWSZ)
-      INTEGER COMM
-C
-      INTEGER I, IR, IC
-      INTEGER(8) :: I8
-C check done outsize     
-C     IF(IWSZ < M) THEN ERROR
-C     IF(IWSZ < N) THEN ERROR
-      INUMMYR = 0
-C     MARK MY ROWS. FIRST COUNT,
-C          IF DYNAMIC MEMORY ALLOCATIOn WILL USED
-      DO I=1,N
-         IWRK(I) = 0
-         IF(PARTVEC(I).EQ.MYID) THEN
-            IWRK(I)=1
-            INUMMYR = INUMMYR + 1
-         ENDIF
-      ENDDO
-      DO I8=1_8,NZ_loc
-         IR = IRN_loc(I8)
-         IC = JCN_loc(I8)
-         IF((IR.GE.1).AND.(IR.LE.N).AND.
-     &        ((IC.GE.1).AND.(IC.LE.N))) THEN
-            IF(IWRK(IR) .EQ. 0) THEN
-               IWRK(IR)= 1
-               INUMMYR = INUMMYR + 1
-            ENDIF
-         ENDIF
-         IF((IR.GE.1).AND.(IR.LE.N).AND.
-     &        ((IC.GE.1).AND.(IC.LE.N))) THEN
-            IF(IWRK(IC).EQ.0) THEN
-               IWRK(IC)= 1
-               INUMMYR = INUMMYR + 1
-            ENDIF
-         ENDIF
-      ENDDO
-C     THE SMAME THING APPLIES FOR COLS
-C     No need to do anything
-C
-      RETURN
-      END SUBROUTINE DMUMPS_FINDNUMMYROWCOLSYM
       INTEGER FUNCTION DMUMPS_CHKCONVGLOSYM(D, N, INDXR, INDXRSZ,
      &     EPS, COMM)
       IMPLICIT NONE
@@ -1169,11 +1318,12 @@ C
      &     IRN_loc, JCN_loc, NZ_loc,
      &     PARTVEC, N,
      &     MYROWINDICES, INUMMYR,
-     &     IWRK, IWSZ  )
+     &     IWRK, IWSZ, NOMP_MAX )
+!$    USE OMP_LIB
       IMPLICIT NONE
-      INTEGER MYID, NUMPROCS, N
-      INTEGER(8) :: NZ_loc
-      INTEGER INUMMYR, IWSZ
+      INTEGER MYID, NUMPROCS, N, NOMP_MAX
+      INTEGER(8) :: NZ_loc, IWSZ
+      INTEGER INUMMYR
       INTEGER IRN_loc(NZ_loc), JCN_loc(NZ_loc)
       INTEGER PARTVEC(N)
       INTEGER MYROWINDICES(INUMMYR)
@@ -1182,21 +1332,36 @@ C
 C
       INTEGER I, IR, IC, ITMP
       INTEGER(8) :: I8
+      INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
+!$    IF (NOMP_MAX.GT.0) THEN
+!$      NOMP=omp_get_max_threads()
+!$      CHUNK= max(K361/2, (N+NOMP-1) / NOMP )
+!$    ENDIF
 C      
 C     MARK MY ROWS. 
-      DO I=1,N
-         IWRK(I) = 0
-         IF(PARTVEC(I).EQ.MYID) IWRK(I)=1
-      ENDDO
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,N
+           IWRK(I) = 0
+           IF(PARTVEC(I).EQ.MYID) IWRK(I)=1
+        ENDDO
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I) 
+!$OMP&  SCHEDULE(STATIC,CHUNK)
+!$OMP&  IF ( N > K361 .AND. NOMP .GT. 1)
+        DO I=1,N
+           IWRK(I) = 0
+           IF(PARTVEC(I).EQ.MYID) IWRK(I)=1
+        ENDDO
+!$OMP END PARALLEL DO
+      ENDIF
+C
       DO I8=1_8,NZ_loc
          IR = IRN_loc(I8)   
          IC = JCN_loc(I8)
          IF((IR.GE.1).AND.(IR.LE.N).AND.
      &        ((IC.GE.1).AND.(IC.LE.N))) THEN
             IF(IWRK(IR) .EQ. 0) IWRK(IR)= 1
-         ENDIF
-         IF((IR.GE.1).AND.(IR.LE.N).AND.
-     &        ((IC.GE.1).AND.(IC.LE.N))) THEN
             IF(IWRK(IC) .EQ.0) IWRK(IC)=1
          ENDIF
       ENDDO
diff -pruN 5.6.2-2.1/src/dfac_sispointers_m.F 5.7.1-1/src/dfac_sispointers_m.F
--- 5.6.2-2.1/src/dfac_sispointers_m.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/dfac_sispointers_m.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/dfac_sol_l0omp_m.F 5.7.1-1/src/dfac_sol_l0omp_m.F
--- 5.6.2-2.1/src/dfac_sol_l0omp_m.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/dfac_sol_l0omp_m.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -15,7 +15,14 @@ C
       PRIVATE
       PUBLIC :: DMUMPS_INIT_L0_OMP_FACTORS
      &        , DMUMPS_FREE_L0_OMP_FACTORS
+#if ! defined(NO_SAVE_RESTORE)
      &        , DMUMPS_SAVE_RESTORE_L0FACARRAY
+#endif
+#if ! defined(NO_SAVE_RESTORE)
+#endif
+#if ! defined(NO_SAVE_RESTORE)
+      INCLUDE 'mumps_save_restore_modes.h'
+#endif
       CONTAINS
       SUBROUTINE DMUMPS_INIT_L0_OMP_FACTORS(id_L0_OMP_FACTORS)
       USE DMUMPS_STRUC_DEF, ONLY : DMUMPS_L0OMPFAC_T
@@ -48,6 +55,7 @@ C
       ENDIF
       RETURN
       END SUBROUTINE DMUMPS_FREE_L0_OMP_FACTORS
+#if ! defined(NO_SAVE_RESTORE)
       SUBROUTINE DMUMPS_SAVE_RESTORE_L0FACARRAY(L0_OMP_FACTORS
      &                 ,unit,MYID,mode
      &                 ,SIZE_GEST,SIZE_VARIABLES
@@ -59,7 +67,7 @@ C
       IMPLICIT NONE
       TYPE (DMUMPS_L0OMPFAC_T), DIMENSION(:), POINTER :: L0_OMP_FACTORS
       INTEGER,intent(IN)::unit,MYID
-      CHARACTER(len=*),intent(IN) :: mode
+      INTEGER,intent(IN) :: mode
       INTEGER,INTENT(OUT) :: SIZE_GEST
       INTEGER(8),intent(OUT) :: SIZE_VARIABLES
       INTEGER,intent(INOUT):: INFO(2)
@@ -79,7 +87,7 @@ C
       SIZE_GEST_L0FAC_ARRAY_j1=0
       SIZE_VARIABLES_L0FAC_ARRAY_j1=0
       NbRecords = 0
-      IF (trim(mode).EQ."memory_save") THEN
+      IF (mode.EQ.memory_save_mode) THEN
         IF (associated(L0_OMP_FACTORS)) THEN
           NbRecords      = 1 
           SIZE_GEST      = SIZE_INT 
@@ -87,7 +95,7 @@ C
           DO j1=1,size(L0_OMP_FACTORS)
             CALL DMUMPS_SAVE_RESTORE_L0FAC(
      &           L0_OMP_FACTORS(j1)
-     &           ,unit,MYID,"memory_save"
+     &           ,unit,MYID,memory_save_mode
      &           ,SIZE_GEST_L0FAC_ARRAY_j1
      &           ,SIZE_VARIABLES_L0FAC_ARRAY_J1
      &           ,SIZE_INT,SIZE_INT8,SIZE_ARITH_DEP
@@ -105,7 +113,7 @@ C
           SIZE_GEST      = 2*SIZE_INT
           SIZE_VARIABLES = 0
         ENDIF
-      ELSEIF (trim(mode).EQ."save") THEN
+      ELSEIF (mode.EQ.save_mode) THEN
         IF (associated(L0_OMP_FACTORS)) THEN
           NbRecords      = 1 
           SIZE_GEST      = SIZE_INT
@@ -120,7 +128,7 @@ C
           DO j1=1,size(L0_OMP_FACTORS)
             CALL DMUMPS_SAVE_RESTORE_L0FAC(
      &           L0_OMP_FACTORS(j1)
-     &           ,unit,MYID,"save"
+     &           ,unit,MYID,save_mode
      &           ,SIZE_GEST_L0FAC_ARRAY_J1
      &           ,SIZE_VARIABLES_L0FAC_ARRAY_J1
      &           ,SIZE_INT,SIZE_INT8,SIZE_ARITH_DEP
@@ -147,7 +155,7 @@ C
             endif
             IF ( INFO(1) .LT. 0 ) GOTO 100
         ENDIF
-      ELSE IF (trim(mode).EQ."restore") THEN
+      ELSE IF (mode.EQ.restore_mode) THEN
         NULLIFY(L0_OMP_FACTORS)
          read(unit,iostat=err) size_array1
          if(err.ne.0) THEN
@@ -181,7 +189,7 @@ C
            DO j1=1,size(L0_OMP_FACTORS)
              CALL DMUMPS_SAVE_RESTORE_L0FAC(
      &            L0_OMP_FACTORS(j1)
-     &            ,unit,MYID,"restore"
+     &            ,unit,MYID,restore_mode
      &            ,SIZE_GEST_L0FAC_ARRAY_J1
      &            ,SIZE_VARIABLES_L0FAC_ARRAY_J1
      &            ,SIZE_INT, SIZE_INT8, SIZE_ARITH_DEP
@@ -196,19 +204,19 @@ C
            ENDDO
          endif
       ENDIF
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          NbSubRecords=int(SIZE_VARIABLES/huge(I4))
          IF(NbSubRecords.GT.0) then
             NbRecords=NbRecords+NbSubRecords
          ENDIF
-      elseif(trim(mode).EQ."save") then
+      elseif(mode.EQ.save_mode) then
          size_written=size_written+SIZE_VARIABLES
      &        +int(SIZE_GEST,kind=8)
 #if defined(MUMPS_NOF2003)
          size_written=size_written
      &        +int(2*SIZE_INT*NbRecords,kind=8)
 #endif
-      elseif(trim(mode).EQ."restore") then
+      elseif(mode.EQ.restore_mode) then
          size_allocated=size_allocated+SIZE_VARIABLES
          size_read=size_read+SIZE_VARIABLES
      &        +int(SIZE_GEST,kind=8)
@@ -217,7 +225,7 @@ C
      &        +int(2*SIZE_INT*NbRecords,kind=8)
 #endif
       endif
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          SIZE_VARIABLES=SIZE_VARIABLES+SIZE_VARIABLES_L0FAC_ARRAY
          SIZE_GEST=SIZE_GEST+SIZE_GEST_L0FAC_ARRAY
 #if defined(MUMPS_NOF2003)
@@ -239,7 +247,7 @@ C
       IMPLICIT NONE
       TYPE (DMUMPS_L0OMPFAC_T) :: L0_OMP_FACTORS_1THREAD
       INTEGER,intent(IN)::unit,MYID
-      CHARACTER(len=*),intent(IN) :: mode
+      INTEGER,intent(IN) :: mode
       INTEGER,INTENT(OUT) :: Local_SIZE_GEST
       INTEGER(8),intent(OUT) :: Local_SIZE_VARIABLES
       INTEGER,intent(INOUT):: INFO(2)
@@ -252,9 +260,9 @@ C
       Local_SIZE_GEST = 0
       Local_SIZE_VARIABLES = 0_8
       Local_NbRecords = Local_NbRecords+1
-      IF (trim(mode) .EQ. "memory_save") THEN
+      IF (mode .EQ. memory_save_mode) THEN
         Local_SIZE_VARIABLES = Local_SIZE_VARIABLES + SIZE_INT8
-      ELSE IF (trim(mode) .EQ. "save") THEN
+      ELSE IF (mode .EQ. save_mode) THEN
         Local_SIZE_VARIABLES = Local_SIZE_VARIABLES + SIZE_INT8
         WRITE(unit,iostat=err) L0_OMP_FACTORS_1THREAD%LA
         IF (err .NE. 0) THEN
@@ -264,7 +272,7 @@ C
           GOTO 100
         ENDIF
         size_written=size_written+SIZE_INT8
-      ELSE IF (trim(mode) .EQ. "restore") THEN
+      ELSE IF (mode .EQ. restore_mode) THEN
         Local_SIZE_VARIABLES = Local_SIZE_VARIABLES + SIZE_INT8
         READ(unit,iostat=err) L0_OMP_FACTORS_1THREAD%LA
         IF (err .NE. 0) THEN
@@ -275,7 +283,7 @@ C
         ENDIF
         size_read=size_read+SIZE_INT8
       ENDIF
-      IF (trim(mode).EQ."memory_save") THEN
+      IF (mode.EQ.memory_save_mode) THEN
         IF (associated(L0_OMP_FACTORS_1THREAD%A)) THEN
           Local_NbRecords = Local_NbRecords + 2
           Local_SIZE_GEST = Local_SIZE_GEST + SIZE_INT8
@@ -286,7 +294,7 @@ C
           Local_SIZE_GEST = Local_SIZE_GEST + SIZE_INT8
           Local_SIZE_VARIABLES = Local_SIZE_VARIABLES + 0
         ENDIF
-      ELSEIF (trim(mode).EQ."save") THEN
+      ELSEIF (mode.EQ.save_mode) THEN
         IF (associated(L0_OMP_FACTORS_1THREAD%A)) THEN
           Local_NbRecords = Local_NbRecords + 2
           write(unit,iostat=err) int(0,8) 
@@ -317,7 +325,7 @@ C
           endif
           size_written=size_written+SIZE_INT8
         ENDIF
-      ELSEIF (trim(mode).EQ."restore") THEN
+      ELSEIF (mode.EQ.restore_mode) THEN
         NULLIFY(L0_OMP_FACTORS_1THREAD%A)
         READ(unit,iostat=err) itmp
         if(err.ne.0) THEN
@@ -356,15 +364,16 @@ C
         ENDIF
       ENDIF
 #if defined(MUMPS_NOF2003)
-      IF (trim(mode).EQ."memory_save") THEN
+      IF (mode.EQ.memory_save_mode) THEN
         Local_SIZE_GEST = Local_SIZE_GEST+2*SIZE_INT*Local_NbRecords
-      ELSE IF (trim(mode).EQ."save") THEN
+      ELSE IF (mode.EQ.save_mode) THEN
         size_written = size_written+2*SIZE_INT*Local_NbRecords
-      ELSE IF (trim(mode).EQ."restore") THEN
+      ELSE IF (mode.EQ.restore_mode) THEN
         size_read = size_read+2*SIZE_INT*Local_NbRecords
       ENDIF
 #endif
   100 CONTINUE
       RETURN
       END SUBROUTINE DMUMPS_SAVE_RESTORE_L0FAC
+#endif
       END MODULE DMUMPS_FACSOL_L0OMP_M
diff -pruN 5.6.2-2.1/src/dfac_sol_pool.F 5.7.1-1/src/dfac_sol_pool.F
--- 5.6.2-2.1/src/dfac_sol_pool.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_sol_pool.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -177,8 +177,6 @@ C
      &        ND(KEEP(28))
       EXTERNAL MUMPS_INSSARBR, MUMPS_ROOTSSARBR, DMUMPS_POOL_EMPTY
       LOGICAL MUMPS_INSSARBR, MUMPS_ROOTSSARBR, DMUMPS_POOL_EMPTY
-      EXTERNAL MUMPS_PROCNODE
-      INTEGER MUMPS_PROCNODE
       INTEGER NBINSUBTREE, NBTOP, INSUBTREE, INODE_EFF, MYID
       LOGICAL LEFT, ATOMIC_SUBTREE,UPPER,FLAG_MEM,SBTR_FLAG,PROC_FLAG
       LOGICAL FORCE_EXTRACT_TOP_SBTR
@@ -386,8 +384,6 @@ C
       INTEGER INODE,LPOOL,N,MYID,SLAVEF,PROC,MIN_PROC
       INTEGER POOL(LPOOL),KEEP(500),STEP(N),PROCNODE(KEEP(28))
       INTEGER(8) KEEP8(150)
-      INTEGER MUMPS_PROCNODE
-      EXTERNAL MUMPS_PROCNODE
       LOGICAL SBTR,FLAG_SAME_PROC
       INTEGER POS_TO_EXTRACT,NODE_TO_EXTRACT,NBTOP,I,INSUBTREE,
      &     NBINSUBTREE
diff -pruN 5.6.2-2.1/src/dfac_type3_symmetrize.F 5.7.1-1/src/dfac_type3_symmetrize.F
--- 5.6.2-2.1/src/dfac_type3_symmetrize.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dfac_type3_symmetrize.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/dini_defaults.F 5.7.1-1/src/dini_defaults.F
--- 5.6.2-2.1/src/dini_defaults.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/dini_defaults.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -107,8 +107,9 @@ C     are set by DMUMPSID.  The elements
 C     and INFO provide information on the action of DMUMPS.
 C  
 C  CNTL(1) threshold for partial pivoting
-C     has default value 0.0 when SYM=1 and 0.01 otherwise
-C     Values and less than zero as treated as zero.
+C     has default -1.0 (automatic choice):
+C      0.1 in case of rank-revealing (ICNTL(56)=1,2)
+C      otherwise  0.0 when SYM=1 and 0.01 otherwise.
 C     Values greater than 1.0 are treated as 1.0 for
 C     SYM=1 and as 0.5 for SYM=2
 C     In general, a larger value of CNTL(1) leads to 
@@ -126,6 +127,7 @@ C     Default value is sqrt(macheps).
 C     Values less than zero are treated as sqrt(macheps).
 C
 C  CNTL(3) is used with null pivot row detection (ICNTL(24) .eq. 1)
+C     and/or with Rank-Revealing (RR) option (ICNTL(56)).
 C     Default value is 0.0. 
 C     Let A_{preproc} be the preprocessed matrix to be factored (see
 C       equation in the user's guide).
@@ -134,6 +136,35 @@ C     row/column is smaller than a thres
 C     machine precision and ||.|| be the infinite norm.
 C     The absolute value to detect a null pivot row (when ICNTL(24) .EQ.1) 
 C     is stored in DKEEP(1).
+C     In case of RR, CNTL(3) will define the thresholds for :
+C      
+C       - Postponing pseudo singularities (SEUIL):
+C         The computed threshold value for postponing pivots
+C         is stored in "SEUIL" and then "SEUIL_LDLT_NIV2"
+C         which are identical in current version.
+C
+C       - Defining singularities on root (DKEEP(9))
+C
+C       - Defining null pivot rows if ICNTL(24).EQ.1 (DKEEP(1)) 
+C         in this case DKEEP(1) must be smaller than DKEEP(9)
+C
+C     IF (ICNTL(56).NE.0) THEN 
+C      RR on root is active 
+C      IF  (CNTL3 .LT. ZERO) THEN
+C          DKEEP(9) = abs(CNTL(3))
+C      ELSE IF  (CNTL3 .GT. ZERO) THEN
+C          DKEEP(9) = CNTL3*||A_{preproc}||
+C      ELSE  !  (CNTL(3) .EQ. ZERO) THEN
+C          DKEEP(9) = sqrt(N_h)*MACHEPS*||A_{preproc}||  
+C          where Nh is the number of pivots on the deepest branch
+C          of the elimination tree.
+C      ENDIF
+C      IF (ICNTL(24).EQ.1) THEN
+C       null pivot detection
+C         DKEEP(1) = DKEEP(9)*DKEEP(10)
+C      ENDIF
+C
+C     ELSE (ONLY NULL PIVOT detection is active) 
 C      IF CNTL(3)  > 0 THEN
 C          DKEEP(1) = CNTL(3)  ||A_{preproc}|| 
 C      ELSE IF CNTL(3)  = 0.0 THEN 
@@ -142,6 +173,7 @@ C      ELSE IF CNTL(3)  < 0 THEN
 C          DKEEP(1) = abs(CNTL(3))! this was added for EDF 
 C                                 ! in the context of SOLSTICE project
 C      ENDIF
+C     ENDIF
 C
 C  CNTL(4) must be set to value for static pivoting.
 C     Default value is -1.0
@@ -386,6 +418,9 @@ C               The order of the root no
 C            ENDIF
 C            If ICNTL(13) .EQ. -1 then splitting of the root
 C            is done whatever the nb of procs is. 
+C            Authorizing extra root spliting during analysis might be
+C            interesting to further split the root node (combined for 
+C            example with null pivot detection option ICNTL(24)=1 OR ICNTL(56))
 C             
 C            To summarize:
 C               -1         : root splitting and scalapack on
@@ -646,12 +681,14 @@ C            For all other values, the d
 C            null pivots and static pivots are excluded from the
 C            computation of the determinant.
 C
+#if ! defined(NO_SAVE_RESTORE)
 C   ICNTL(34) Must be set before a call to MUMPS with JOB=-3 in case
 C             the save/restore feature was used and user wants to clean
 C             save/restore files (and possibly OOC files). 
 C             ICTNL(34)=0 => user wants to be able to restore instance later
 C             ICTNL(34)=1 => user will not restore the instance again (clean
 C                            to be done)
+#endif
 C
 C    ICNTL(35) : Block Low-Rank (BLR) functionality, 
 C                need be set before analysis
@@ -696,6 +733,25 @@ C                Between 0 and 1000; oth
 C                corresponds to an estimated compression rate of
 C                ICNTL(39)/1000%.
 C                Default value: 500 (50.0% compression rate).
+C
+C  ICNTL(56) has default value 0 and is only accessed by the host.
+C      During the analysis phase, a positive value prepares the data for
+C       later use of null space functionalities (saved in KEEP(53)).
+C       (the tree is modified to have only one root in analysis)
+C       If ICNTL(56) is negative or zero, null space feature will
+C       be forbidden during the factorization phase.
+C      During the factorization phase, if ICNTL(56) was positive 
+C      (KEEP(53)>0) for analysis, then the values of ICNTL(56) (saved
+C      in KEEP(19)) have the following meaning.
+C          0: No null space analysis,
+C          1: Null space analysis on last root node using SVD,
+C          2: Null space analysis on last root node using QR,
+C
+C       The singular values (ICNTL(56)=1) or the diagonal entries of R
+C       (ICNTL(56)=2) are available in root%SINGULAR_VALUES
+C
+C
+C
 C 
 C   ICNTL(58): strategy for symbolic factorization used
 C              with centralized ordering based on METIS (ICNTL(7)=5)
@@ -781,6 +837,10 @@ C  INFO(18)  On exit to factorization:
 C              Local number of null pivots (ICNTL(24)=1) 
 C              on the local processor even on master. 
 C              (local size of array PIVNUL_LIST).
+C              Note that it also includes null pivots 
+C              that might have been further detected on 
+C              the root if ICNTL(56).NE.0. and root 
+C              processed by MYID
 C
 C  INFO(19) - after analysis: 
 C           Estimated size of the main internal integer workarray IS
@@ -857,7 +917,7 @@ C     for the elimination process on the
 C
 C  RINFOG(3)  Number of floating-point operations
 C     for the elimination process on all processors.
-C
+C  
 C----------------------------------------------------
 C Statistics produced after solve with error analysis
 C----------------------------------------------------
@@ -918,6 +978,25 @@ C
 C  RINFOG(21) -  after factorization: largest pivot in absolute 
 C             value selected during factorization of the preprocessed
 C             matrix A_pre.
+C  
+C  RINFOG(22) - after factorization: 
+C             total number of floating-point operations offloaded to 
+C             the accelerator(s) by all MPI processes (see RINFO(9))
+C
+C  RINFOG(23) - after factorization: average (over all MPI processes) 
+C            time spent in operations offloaded to the accelerators
+C            including communication (see RINFO(10)).
+C
+C  Computed when solve involves exploit sparsity (fwd and/or bwd)
+C  here we only report off diagonal flops)
+C
+#if defined(STAT_ES_SOLVE)
+C  RINFOG(24) - FR FLOPS (off diagonal flops)
+C  RINFOG(25) - FR FLOPS (off diag) with Exploit sparsity 
+C               (possibly with nb_sparse algo used)
+#endif
+C
+C
 C===========================
 C DESCRIPTION OF KEEP8 ARRAY
 C===========================
@@ -925,6 +1004,8 @@ C
 C   KEEP8 is a 64-bit integer array of length 150 that need not
 C   be set by the user
 C
+#if ! defined(NO_SAVE_RESTORE)
+#endif
 C===========================
 C DESCRIPTION OF KEEP ARRAY
 C===========================
@@ -962,11 +1043,8 @@ C     Only options 0, 1, or 2 are availa
 C     -------------------------------------
       IF ( KEEP(50).NE.1 .and. KEEP(50).NE.2 ) KEEP( 50 ) = 0
 C     threshold value for pivoting
-      IF ( KEEP(50) .NE. 1 ) THEN
-        CNTL(1)   = 0.01D0
-      ELSE
-        CNTL(1)   = 0.0D0
-      END IF
+C     Automatic choice depending on (SYM and ICNTL(56))
+      CNTL(1) = -1.0D0
       CNTL(2) = sqrt(epsilon(0.0D0))
       CNTL(3) = 0.0D0
       CNTL(4) = -1.0D0
@@ -1057,6 +1135,14 @@ C     Default BLR compression rate of fa
       ICNTL(38) = 600
 C     Default BLR compression rate of factors (50%)
       ICNTL(39) = 500
+C     L0-thread feature
+#if defined(_OPENMP)
+C     Activate L0OMP
+      ICNTL(48) = 1
+#else
+C     Do not activate L0OMP
+      ICNTL(48) = 0
+#endif
       ICNTL(55) = 0
       ICNTL(56) = 0
       ICNTL(57) = 0
@@ -1082,7 +1168,7 @@ C===================================
         KEEP(6)  = 32
         KEEP(9)  = 700
         KEEP(85) =  300
-        KEEP(62) =  50
+        KEEP(62) =  10
       ELSE
         KEEP(4)  = 24
         KEEP(3)  = 96
@@ -1090,8 +1176,9 @@ C===================================
         KEEP(6)  = 32
         KEEP(9)  = 400
         KEEP(85) = 100
-        KEEP(62) = 50
+        KEEP(62) = 10
       END IF
+        KEEP(11)=200
       KEEP(63) = 60
       KEEP(48) = 5
       CALL DMUMPS_SET_TYPE_SIZES( KEEP(34), KEEP(35),
@@ -1120,36 +1207,24 @@ C     Forcing proportional is ok with st
       KEEP(75) = 1
       KEEP(76) = 2
       KEEP(77) = 30
+      KEEP(78)= -1
       KEEP(79) = 0  ! old splitting
-      IF (NSLAVES.GT.4) THEN
-          KEEP(78)=max(
-     &       int(log(dble(NSLAVES))/log(dble(2))) - 2 
-     &       , 0         )
-      ENDIF
       KEEP(210) = 2 
       KEEP8(79) = -10_8
       KEEP(80) = 1
       KEEP(81) = 0
-      KEEP(82) = 30
-      KEEP(83) = min(8,NSLAVES/4)
-      KEEP(83) = max(min(4,NSLAVES),max(KEEP(83),1))
+      IF (SYM.EQ.0) THEN
+       KEEP(82)= 15
+      ELSE
+       KEEP(82) = 10
+      ENDIF
+      KEEP(83) = -1
       KEEP(86)=1
       KEEP(87)=0
       KEEP(88)=0
       KEEP(90)=1
-      KEEP(91)=min(8, NSLAVES)
-      KEEP(91) = max(min(4,NSLAVES),min(KEEP(83),KEEP(91)))
-      IF(NSLAVES.LT.48)THEN
-         KEEP(102)=150
-      ELSEIF(NSLAVES.LT.128)THEN
-         KEEP(102)=150
-      ELSEIF(NSLAVES.LT.256)THEN
-         KEEP(102)=200
-      ELSEIF(NSLAVES.LT.512)THEN
-         KEEP(102)=300
-      ELSEIF(NSLAVES.GE.512)THEN
-         KEEP(102)=400
-      ENDIF
+      KEEP(91)= -1
+      KEEP(102)= -1
 #if defined(OLD_OOC_NOPANEL)
       KEEP(99)=0  ! no panel -> synchronous / no buffer
 #else
@@ -1164,6 +1239,8 @@ C     strategy for MUMPS_BLOC2_GET_NSLAV
       KEEP(119)=0
 C     Scaling is enabled by default with the Schur complement option
       KEEP(125)=1
+C     Columns of LMAT handled by block of size KEEP(147)
+      KEEP(147)=20000
 C     More amalgamation of tiny fronts
       KEEP(197)=1
 C     KEEP(199) for MUMPS_PROCNODE, MUMPS_TYPENODE, etc
@@ -1180,6 +1257,9 @@ C     allocate id%S later otherwise.
       KEEP(107)=0
       KEEP(121)=-999999
       KEEP(122)=150
+C     Size of CB for which we want to force BLR compressCB
+C     even if NASS is small.
+      KEEP(123)=10000
        KEEP(141)=1 ! min needed
       KEEP(206)=1 
       KEEP(207) = 1
@@ -1193,7 +1273,11 @@ C     allocate id%S later otherwise.
       KEEP(215)=0
       KEEP(216)=1
       KEEP(218)=250
-      KEEP(219)=1
+      IF (SYM.EQ.2) THEN
+       KEEP(219)=1
+      ELSE
+       KEEP(219)=0
+      ENDIF
       IF (KEEP(50).EQ.2) THEN
         KEEP(227)= max(2,32)
       ELSE
@@ -1211,7 +1295,7 @@ C     allocate id%S later otherwise.
                         ! (default value is 10 set in fac_driver.F)
       DKEEP(24) = 1000.0D0 ! gap should be larger than dkeep(14)
       DKEEP(25) = 10.0D0 ! gap precision
-      DKEEP(22) = 0.2D0 ! to check for slow convergence
+      DKEEP(22) = 0.5D0 ! to check for slow convergence
       KEEP(238)=18
       KEEP(234)= 1
       KEEP(235)=-1
@@ -1219,9 +1303,11 @@ C     allocate id%S later otherwise.
       DKEEP(18)= 1.0D12
       KEEP(242) = -9
       KEEP(243) = -1
+      KEEP(255)=100
+      KEEP(281) = 0
 C     Parallel analysis compatible with analysis by blocks
 C                       and detection out-of-range 
-      KEEP(339)= 6
+      KEEP(339)= 1
       KEEP(249)=1
 !$    KEEP(249) = OMP_GET_MAX_THREADS()
       KEEP(250) = 1
@@ -1239,17 +1325,20 @@ C                       and detection ou
       KEEP(363) = 512
       KEEP(364) = 32768
       KEEP(378) = 1
-C     OMP parallelization of arrowheads
       KEEP(399) = 1
       KEEP(397) = -1
-#if defined(__ve__)
-      KEEP(401) = 1
-#else
-      KEEP(401) = 0
-#endif
       KEEP(402) = 1
       KEEP(405) = 0 ! 1 under L0OMP
       KEEP(406) = 2 
+#if defined(__PGLLVM__)
+C     With aocc version of Classic flang, we want to
+C     avoid an OpenMP bug during L0thread copies by
+C     switching to simpler copy algorithm.
+C     Since we cannot test __aocc__ in Fortran, we rely on the
+C     slower algorithm as soon as __PGLLVM__ is detected, even
+C     if this is "too careful".
+      KEEP(406)=0
+#endif
 C     0.9 equilibration
       KEEP(408) = 90
       KEEP(420) =  4*KEEP(6)   ! if KEEP(6)=32 then 128
@@ -1296,11 +1385,10 @@ C     probably a cache miss on the pivot
       KEEP(490) = 128
       KEEP(491) = 1000
 #if defined(__ve__)
-      KEEP(491)=512
+      KEEP(490)=512
       KEEP(491)=8000
 #endif
       KEEP(492) = 1
-      KEEP(82) = 30
       KEEP(493) = 0
       KEEP(496) = 1
       KEEP(495) = -1
@@ -1320,6 +1408,8 @@ C
          id%KEEP(5)=1
          id%KEEP(6)=2
          id%KEEP(9)=3
+C        KEEP(11) not too small either
+         id%KEEP(11)=3
          id%KEEP(39)=300
          id%KEEP(7) = 3
          id%KEEP(8) = 2
@@ -1332,6 +1422,8 @@ C
          id%KEEP(85)=-4
          id%KEEP(62) = 2  
          id%KEEP(1)  = 1   
+         id%KEEP(123) = 6
+         id%KEEP(147) = 3
          id%KEEP(197)  = 0
          id%KEEP(51) = 2
 !$       id%KEEP(360) = 2
@@ -1346,15 +1438,9 @@ C
          id%ICNTL(27)=-3
          id%KEEP(227)=3
          id%KEEP(30) = 1000
-#if defined(_OPENMP)
-C        Activate L0OMP with test_mumps in case KEEP(72)=1,
-C        but only if compiilation is with OpenMP
-         id%KEEP(401) = 1
-#endif
       ELSE IF (id%KEEP(72)==2) THEN
          id%KEEP(85)=2            ! default is 
          id%KEEP(85)=-10000         ! default is 160 
-         id%KEEP(62) = 10       ! default is 50
          id%KEEP(210) = 1       ! defaults is 0 (automatic)
          id%KEEP8(79) = 160000_8   
          id%KEEP(1) = 2  ! default is 8
diff -pruN 5.6.2-2.1/src/dini_driver.F 5.7.1-1/src/dini_driver.F
--- 5.6.2-2.1/src/dini_driver.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/dini_driver.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -31,6 +31,10 @@ C
       INTEGER MASTER, IERR,PAR_loc,SYM_loc
       PARAMETER( MASTER = 0 )
       INTEGER color
+#if defined(metis) || defined(parmetis)
+      INTEGER I
+#endif
+      INTEGER(8) :: I8
 C     -----------------------------
 C     Initialize MPI related data
 C     -----------------------------
@@ -88,8 +92,10 @@ C     ----------------------------------
       CALL MUMPS_SET_VERSION( id%VERSION_NUMBER )
       id%OOC_TMPDIR="NAME_NOT_INITIALIZED"
       id%OOC_PREFIX="NAME_NOT_INITIALIZED"
+#if ! defined(NO_SAVE_RESTORE)
       id%SAVE_DIR="NAME_NOT_INITIALIZED"
       id%SAVE_PREFIX="NAME_NOT_INITIALIZED"
+#endif
 C     Default value for NRHS is 1
       id%NRHS = 1
 C     Leading dimension will be reset to id%N is DMUMPS_SOL_DRIVER
@@ -118,13 +124,11 @@ C     set to default options
 C     Useful size is 40  
 C     This sets the default values
       CALL METIS_SETDEFAULTOPTIONS(id%METIS_OPTIONS)
-C     This number, 18, corresponds to METIS_OPTIONS_NUMBERING which
-C     tells METIS to use fortran numbering and is found in metis.h
-C     In Metis 5.0.3 and Parmetis 4.0.2, METIS_OPTIONS_NUMBERING 
-C     was METIS_OPTIONS(17). MUMPS doesnot support those versions anymore.
-C     To use them, just change METIS_OPTIONS(18) into METIS_OPTIONS(17)
-C     like that: METIS_OPTIONS(17) = 1
-      id%METIS_OPTIONS(18) = 1
+      CALL MUMPS_METIS_OPTION_NUMBERING(I)
+C     The value of I corresponds to "METIS_OPTION_NUMBERING", which tells
+C     METIS to use Fortran numbering. METIS_OPTION_NUMBERING is defined
+C     in metis.h and accessed through a C wrapper.
+      id%METIS_OPTIONS(I+1) = 1 ! +1 for Fortran indexing
 #endif
 #endif      
 C
@@ -154,6 +158,8 @@ C
       NULLIFY(id%RHS_loc)
       NULLIFY(id%COLSCA)
       NULLIFY(id%ROWSCA)
+      NULLIFY(id%ROWSCA_loc)
+      NULLIFY(id%COLSCA_loc)
       NULLIFY(id%PERM_IN)
       NULLIFY(id%IS)
       NULLIFY(id%STEP)
@@ -198,10 +204,11 @@ C     Info for pruning tree
       NULLIFY(id%MY_FIRST_LEAF)
       NULLIFY(id%MY_NB_LEAF)
       NULLIFY(id%COST_TRAV)
-      NULLIFY(id%RHSCOMP)
-      NULLIFY(id%POSINRHSCOMP_ROW)
-      NULLIFY(id%POSINRHSCOMP_COL)
-      id%POSINRHSCOMP_COL_ALLOC = .FALSE.
+      NULLIFY(id%RHSINTR)
+      id%LD_RHSINTR = 0
+      NULLIFY(id%GLOB2LOC_RHS)
+      NULLIFY(id%GLOB2LOC_SOL)
+      id%GLOB2LOC_SOL_ALLOC = .FALSE.
 C
 C     Out of Core management related data
 C
@@ -215,7 +222,7 @@ C
       NULLIFY(id%LRGROUPS)
       NULLIFY(id%FDM_F_ENCODING)
       NULLIFY(id%BLRARRAY_ENCODING)
-      NULLIFY(id%MPITOOMP_PROCS_MAP)
+      NULLIFY(id%MTKO_PROCS_MAP)
 C     Must be nullified because of routine
 C     DMUMPS_SIZE_IN_STRUCT
       NULLIFY(id%CB_SON_SIZE)
@@ -286,6 +293,14 @@ C
 C
 C     Initializations for Rank detection/null space
 C
+C         -----------------------------
+C         RCOND is a threshold such that:
+C                   A * P = Q * [ R11 R12 ]
+C                               [  0  R22 ]
+C         with R11 defined as the largest leading submatrix whose estimated
+C         condition number is less than 1/RCOND.
+C         -------------------------------------------
+      id%ROOT%QR_RCOND = 1.0D-11
       NULLIFY(id%SINGULAR_VALUES)
       CALL DMUMPS_RR_INIT_POINTERS(id)
 C     Architecture data
@@ -313,5 +328,21 @@ C     ----------------------------------
       ELSE
           id%MYID_NODES = -464646
       ENDIF
+C
+C     Check that KEEP(34), the size of a Fortran INTEGER,
+C     as initialized above during DMUMPSID
+C     matches the size of an integer in C. If not,
+C     raise an error immediately.
+C
+      CALL MUMPS_INT_SIZE_C(I8)
+      IF (int(I8) .NE. id%KEEP(34)) THEN
+        id%INFO(1)=-69
+        id%INFO(2)=int(I8) ! size of MUMPS_INT
+C       Installation problem!
+C       WRITE on unit 6 since ICNTL(1:4) are not set by the user yet
+        IF (id%MYID .EQ. 0) WRITE(6,995) int(I8)
+ 995    FORMAT(' Installation error -69: ',
+     &' MUMPS_INT size (',I4,') incompatible with INTEGER size')
+      ENDIF
       RETURN
       END SUBROUTINE DMUMPS_INI_DRIVER
diff -pruN 5.6.2-2.1/src/dlr_core.F 5.7.1-1/src/dlr_core.F
--- 5.6.2-2.1/src/dlr_core.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/dlr_core.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -41,8 +41,9 @@ C
       SUBROUTINE IS_FRONT_BLR_CANDIDATE(INODE, NIV, NFRONT, NASS, 
      &                    BLRON, K489,
      &                    K490, K491, K492, K20, K60, IDAD, K38,
-     &                    LRSTATUS, K280, LRGROUPS)
-        INTEGER,INTENT(IN) :: INODE, NFRONT, NASS, BLRON, K489, K490,
+     &                    K123, LRSTATUS, K280, LRGROUPS)
+        INTEGER,INTENT(IN) :: INODE, NFRONT, NASS, BLRON, K123,
+     &                        K489, K490,
      &                        K491, K492, NIV, K20, K60, IDAD, K38
         INTEGER,INTENT(OUT):: LRSTATUS 
         INTEGER, INTENT(IN):: K280
@@ -180,8 +181,9 @@ C
         ENDIF
       END SUBROUTINE ALLOC_LRB_FROM_ACC
       SUBROUTINE REGROUPING2(CUT, NPARTSASS, NASS,
-     &                   NPARTSCB, NCB, IBCKSZ, ONLYCB, K472)
-        INTEGER, INTENT(IN) :: IBCKSZ, NASS, NCB
+     &                   NPARTSCB, NCB, IBCKSZ, ONLYCB, K472, 
+     &                   NFRONT, KEEP)
+        INTEGER, INTENT(IN) :: IBCKSZ, NASS, NCB, NFRONT, KEEP(500)
         INTEGER, INTENT(INOUT) :: NPARTSCB, NPARTSASS
         INTEGER, POINTER, DIMENSION(:) :: CUT
         INTEGER, POINTER, DIMENSION(:) :: NEW_CUT
@@ -197,8 +199,9 @@ C
      &          ' not enough memory? memory requested = ' , IERROR
            RETURN
         ENDIF
-        CALL COMPUTE_BLR_VCS(K472, IBCKSZ2, IBCKSZ, NASS)
-        MINSIZE = int(IBCKSZ2 / 2)
+        CALL COMPUTE_BLR_VCS(K472, IBCKSZ2, IBCKSZ, NASS, 
+     &                       NFRONT, KEEP(35))
+        MINSIZE = int(IBCKSZ2 / 3)
         NEW_NPARTSASS = max(NPARTSASS,1)
         IF (.NOT. ONLYCB) THEN
            NEW_CUT(1) = 1
@@ -435,7 +438,6 @@ CC
      &                          Y_RRQR(:,:)
         INTEGER, ALLOCATABLE :: JPVT_RRQR(:)
         INTEGER :: allocok, MREQ
-        DOUBLE PRECISION, EXTERNAL ::dnrm2
         DOUBLE PRECISION :: ONE, MONE, ZERO
         PARAMETER (ONE = 1.0D0, MONE=-1.0D0)
         PARAMETER (ZERO=0.0D0)
@@ -875,10 +877,10 @@ C     Alloc NOT ok!!
         INTEGER(8), INTENT(IN) :: POSELTT
         INTEGER,intent(in) :: MIDBLK_COMPRESS, KPERCENT_RMB
         DOUBLE PRECISION, intent(in) :: TOLEPS
-        DOUBLE PRECISION,    ALLOCATABLE :: RWORK_RRQR(:)
-        DOUBLE PRECISION, ALLOCATABLE :: WORK_RRQR(:), TAU_RRQR(:)
-        DOUBLE PRECISION, ALLOCATABLE, DIMENSION(:,:), TARGET :: Q1, R1, 
-     &                                                  Q2, R2
+        DOUBLE PRECISION,    ALLOCATABLE:: RWORK_RRQR(:)
+        DOUBLE PRECISION, ALLOCATABLE:: WORK_RRQR(:), TAU_RRQR(:)
+        DOUBLE PRECISION, ALLOCATABLE, DIMENSION(:,:),TARGET:: Q1, R1,
+     &                                                Q2, R2
         INTEGER, ALLOCATABLE :: JPVT_RRQR(:)
         TYPE(LRB_TYPE)       :: LRB1, LRB2
         INTEGER :: INFO, RANK1, RANK2, RANK, MAXRANK, LWORK
diff -pruN 5.6.2-2.1/src/dlr_stats.F 5.7.1-1/src/dlr_stats.F
--- 5.6.2-2.1/src/dlr_stats.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dlr_stats.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/dlr_type.F 5.7.1-1/src/dlr_type.F
--- 5.6.2-2.1/src/dlr_type.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dlr_type.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/dmumps_comm_buffer.F 5.7.1-1/src/dmumps_comm_buffer.F
--- 5.6.2-2.1/src/dmumps_comm_buffer.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/dmumps_comm_buffer.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -13,7 +13,7 @@ C  https://cecill.info/licences/Licence_
 C
         MODULE DMUMPS_BUF
         PRIVATE
-        PUBLIC :: DMUMPS_BUF_TRY_FREE_CB, DMUMPS_BUF_INIT,
+        PUBLIC :: DMUMPS_BUF_INIT,
      &   DMUMPS_BUF_INI_MYID,
      &   DMUMPS_BUF_ALLOC_CB ,       DMUMPS_BUF_DEALL_CB ,
      &   DMUMPS_BUF_ALLOC_SMALL_BUF, DMUMPS_BUF_DEALL_SMALL_BUF,
@@ -52,34 +52,6 @@ C
      &       , SAVE, TARGET :: BUF_MAX_ARRAY
         PUBLIC :: BUF_LMAX_ARRAY, BUF_MAX_ARRAY
       CONTAINS
-        SUBROUTINE DMUMPS_BUF_TRY_FREE_CB()
-        CALL DMUMPS_BUF_TRY_FREE(BUF_CB)
-        RETURN
-        END SUBROUTINE DMUMPS_BUF_TRY_FREE_CB
-        SUBROUTINE DMUMPS_BUF_TRY_FREE(B)
-        IMPLICIT NONE
-        TYPE ( DMUMPS_COMM_BUFFER_TYPE ) :: B
-        INCLUDE 'mpif.h'
-        LOGICAL :: FLAG
-        INTEGER :: IERR_MPI
-        INTEGER :: STATUS(MPI_STATUS_SIZE)
-        IF ( B%HEAD .NE. B%TAIL ) THEN
- 10       CONTINUE
-          CALL MPI_TEST( B%CONTENT( B%HEAD + REQ ), FLAG,
-     &                   STATUS, IERR_MPI )
-          IF ( FLAG ) THEN
-            B%HEAD = B%CONTENT( B%HEAD + NEXT )
-            IF ( B%HEAD .EQ. 0 ) B%HEAD = B%TAIL
-            IF ( B%HEAD .NE. B%TAIL ) GOTO 10
-          END IF
-        END IF
-        IF ( B%HEAD .EQ. B%TAIL ) THEN
-          B%HEAD = 1
-          B%TAIL = 1
-          B%ILASTMSG = 1
-        END iF
-        RETURN
-        END SUBROUTINE DMUMPS_BUF_TRY_FREE
         SUBROUTINE DMUMPS_BUF_INI_MYID( MYID )
         IMPLICIT NONE
         INTEGER MYID
@@ -319,7 +291,7 @@ C
           ENDIF
         ENDIF
         IF (NBROWS_PACKET + NBROWS_ALREADY_SENT.NE.LCONT .AND.
-     &     SIZE_PACK  .LT. SIZE_RBUF_BYTES / 4
+     &     SIZE_PACK  .LT. SIZE_RBUF_BYTES / 10
      &    .AND. 
      &    .NOT. RECV_BUF_SMALLER_THAN_SEND)
      &       THEN
@@ -499,16 +471,16 @@ C
         SUBROUTINE DMUMPS_BUF_SEND_VCB( NRHS_B, NODE1, NODE2, NCB, LDW,
      &             LONG,
      &             IW, W, JBDEB, JBFIN,
-     &             RHSCOMP, NRHS, LRHSCOMP, IPOSINRHSCOMP, NPIV,
+     &             RHSINTR, NRHS, LRHSINTR, IPOSINRHSINTR, NPIV,
      &             KEEP,
      &             DEST, TAG, COMM, IERR )
         IMPLICIT NONE
         INTEGER LDW, DEST, TAG, COMM, IERR
         INTEGER NRHS_B, NODE1, NODE2, NCB, LONG, JBDEB, JBFIN
         INTEGER IW( max( 1, LONG ) )
-        INTEGER, INTENT(IN) :: LRHSCOMP, NRHS, IPOSINRHSCOMP, NPIV
+        INTEGER, INTENT(IN) :: LRHSINTR, NRHS, IPOSINRHSINTR, NPIV
         DOUBLE PRECISION W( max( 1, LDW * NRHS_B ) )
-        DOUBLE PRECISION RHSCOMP(LRHSCOMP,NRHS)
+        DOUBLE PRECISION RHSINTR(LRHSINTR,NRHS)
         INTEGER, INTENT(INOUT) :: KEEP(500)
         INCLUDE 'mpif.h'
         INTEGER :: IERR_MPI
@@ -566,7 +538,7 @@ C
           IF (NODE2.EQ.0) THEN
             DO K=1, NRHS_B
               IF (NPIV.GT.0) THEN
-              CALL MPI_PACK( RHSCOMP(IPOSINRHSCOMP,JBDEB+K-1), NPIV,
+              CALL MPI_PACK( RHSINTR(IPOSINRHSINTR,JBDEB+K-1), NPIV,
      &                          MPI_DOUBLE_PRECISION,
      &                          BUF_CB%CONTENT( IPOS ), SIZE,
      &                          POSITION, COMM, IERR_MPI )
@@ -653,14 +625,13 @@ C
         FLAG = ( B%HEAD == B%TAIL )
         RETURN
         END SUBROUTINE DMUMPS_BUF_EMPTY
-        SUBROUTINE DMUMPS_BUF_SIZE_AVAILABLE( B, SIZE_AV )
+        SUBROUTINE DMUMPS_BUF_FREEREQUESTS( B )
         IMPLICIT NONE
         TYPE ( DMUMPS_COMM_BUFFER_TYPE ) :: B
-        INTEGER SIZE_AV
         INCLUDE 'mpif.h'
-        INTEGER :: IERR_MPI
+        INTEGER :: IERR_MPI, CURRENT, LAST_NOT_FREE, LAST_NOT_FREE_TAIL
         INTEGER :: STATUS(MPI_STATUS_SIZE)
-        LOGICAL :: FLAG
+        LOGICAL :: FLAG, BROADCAST_NOT_FREE
         IF ( B%HEAD .NE. B%TAIL ) THEN
  10       CONTINUE
           CALL MPI_TEST( B%CONTENT( B%HEAD + REQ ), FLAG, STATUS,
@@ -669,6 +640,41 @@ C
             B%HEAD = B%CONTENT( B%HEAD + NEXT )
             IF ( B%HEAD .EQ. 0 ) B%HEAD = B%TAIL
             IF ( B%HEAD .NE. B%TAIL ) GOTO 10
+          ELSE
+            LAST_NOT_FREE = B%HEAD
+            CURRENT = B%CONTENT( LAST_NOT_FREE + NEXT )
+            LAST_NOT_FREE_TAIL = CURRENT
+            BROADCAST_NOT_FREE = B%CONTENT(LAST_NOT_FREE+NEXT).EQ.
+     &                              LAST_NOT_FREE+OVHSIZE 
+            DO WHILE ( CURRENT .NE. 0 )
+              IF (BROADCAST_NOT_FREE) THEN
+                FLAG = .FALSE.
+              ELSE
+                CALL MPI_TEST( B%CONTENT( CURRENT + REQ ), FLAG, STATUS,
+     &                       IERR_MPI )
+              ENDIF
+              IF (FLAG) THEN
+                CURRENT = B%CONTENT( CURRENT + NEXT )
+                B%CONTENT( LAST_NOT_FREE + NEXT ) = CURRENT
+              ELSE
+                LAST_NOT_FREE = CURRENT
+                CURRENT = B%CONTENT( CURRENT + NEXT )
+                IF ( CURRENT .NE. 0 ) THEN
+                  LAST_NOT_FREE_TAIL = CURRENT
+                ELSE
+                  LAST_NOT_FREE_TAIL = B%TAIL
+                ENDIF
+                BROADCAST_NOT_FREE = B%CONTENT(LAST_NOT_FREE+NEXT).EQ.
+     &                               LAST_NOT_FREE+OVHSIZE 
+              ENDIF
+            ENDDO
+            IF ( LAST_NOT_FREE_TAIL .NE. 0 ) THEN
+              B%TAIL = LAST_NOT_FREE_TAIL
+              B%ILASTMSG = LAST_NOT_FREE
+            ELSE IF (B%ILASTMSG .NE. LAST_NOT_FREE) THEN
+              WRITE(*,*) "ABORT", B%ILASTMSG, LAST_NOT_FREE
+              CALL MUMPS_ABORT()
+            ENDIF
           END IF
         END IF
         IF ( B%HEAD .EQ. B%TAIL ) THEN
@@ -676,86 +682,78 @@ C
           B%TAIL = 1
           B%ILASTMSG = 1
         END IF
+        RETURN
+        END SUBROUTINE DMUMPS_BUF_FREEREQUESTS
+        SUBROUTINE DMUMPS_BUF_SIZE_AVAILABLE( B, SIZE_AV, SIZE_AV2 )
+        IMPLICIT NONE
+        TYPE ( DMUMPS_COMM_BUFFER_TYPE ) :: B
+        INTEGER, INTENT(OUT) :: SIZE_AV
+        INTEGER, OPTIONAL, INTENT(OUT) :: SIZE_AV2
+        CALL DMUMPS_BUF_FREEREQUESTS( B )
         IF ( B%HEAD .LE. B%TAIL ) THEN
-           SIZE_AV = max( B%LBUF_INT - B%TAIL, B%HEAD - 2 )
+          SIZE_AV = max( B%LBUF_INT - B%TAIL, B%HEAD - 2 )
+          IF ( B%LBUF_INT - B%TAIL .GT. B%HEAD - 2 ) THEN
+            SIZE_AV  = B%LBUF_INT - B%TAIL
+            IF (present(SIZE_AV2)) SIZE_AV2 = 0
+          ELSE
+            SIZE_AV = B%HEAD - 2
+            IF (present(SIZE_AV2)) SIZE_AV2 = B%LBUF_INT - B%TAIL
+          ENDIF
         ELSE
-           SIZE_AV = B%HEAD - B%TAIL - 1
+          SIZE_AV  = B%HEAD - B%TAIL - 1
+          IF (present(SIZE_AV2)) SIZE_AV2 = 0
         END IF
-        SIZE_AV = min(SIZE_AV - OVHSIZE, SIZE_AV)
+        SIZE_AV = max(0,SIZE_AV - OVHSIZE)
         SIZE_AV = SIZE_AV * SIZEofINT
+        IF (present(SIZE_AV2)) THEN
+          IF (SIZE_AV2 .NE. 0) THEN
+            SIZE_AV = max(0,SIZE_AV2 - OVHSIZE)
+            SIZE_AV2 = SIZE_AV2 * SIZEofINT
+          ENDIF
+        ENDIF
         RETURN
         END SUBROUTINE DMUMPS_BUF_SIZE_AVAILABLE
         SUBROUTINE DMUMPS_BUF_TEST()
-        INTEGER :: IPOS, IREQ, IERR
-        INTEGER, PARAMETER :: IONE=1
-        INTEGER :: MSG_SIZE
-        INTEGER :: DEST2(1)
-        DEST2=-10
-        MSG_SIZE=1
-        CALL BUF_LOOK( BUF_CB, IPOS, IREQ, MSG_SIZE, IERR, 
-     &                 IONE , DEST2,.TRUE.)
+        CALL DMUMPS_BUF_FREEREQUESTS(BUF_CB)
         RETURN
         END SUBROUTINE DMUMPS_BUF_TEST
         SUBROUTINE BUF_LOOK( B, IPOS, IREQ, MSG_SIZE, IERR, 
-     &    NDEST , PDEST, TEST_ONLY)
+     &    NDEST , PDEST )
         IMPLICIT NONE
         TYPE ( DMUMPS_COMM_BUFFER_TYPE ) :: B
         INTEGER, INTENT(IN)        :: MSG_SIZE
         INTEGER, INTENT(OUT)       :: IPOS, IREQ, IERR
-        LOGICAL, INTENT(IN), OPTIONAL :: TEST_ONLY
         INTEGER NDEST
         INTEGER, INTENT(IN)        :: PDEST(max(1,NDEST))
         INCLUDE 'mpif.h'
-        INTEGER :: IERR_MPI
         INTEGER :: MSG_SIZE_INT
         INTEGER :: IBUF
-        LOGICAL :: FLAG
-        INTEGER :: STATUS(MPI_STATUS_SIZE)
         IERR = 0
-        IF ( B%HEAD .NE. B%TAIL ) THEN
- 10       CONTINUE
-          CALL MPI_TEST( B%CONTENT( B%HEAD + REQ ), FLAG, STATUS,
-     &                   IERR_MPI )
-          IF ( FLAG ) THEN
-            B%HEAD = B%CONTENT( B%HEAD + NEXT )
-            IF ( B%HEAD .EQ. 0 ) B%HEAD = B%TAIL
-            IF ( B%HEAD .NE. B%TAIL ) GOTO 10
-          END IF
-        END IF
-        IF ( B%HEAD .EQ. B%TAIL ) THEN
-          B%HEAD = 1
-          B%TAIL = 1
-          B%ILASTMSG = 1
-        END iF
+        CALL DMUMPS_BUF_FREEREQUESTS( B )
         MSG_SIZE_INT = ( MSG_SIZE + ( SIZEofINT - 1 ) ) / SIZEofINT
         MSG_SIZE_INT = MSG_SIZE_INT + OVHSIZE
-        IF (present(TEST_ONLY)) RETURN
-        FLAG = (     ( B%HEAD .LE. B%TAIL )
-     &               .AND. (
-     &                 ( MSG_SIZE_INT .LE. B%LBUF_INT - B%TAIL )
-     &                 .OR. ( MSG_SIZE_INT .LE. B%HEAD - 2 ) ) )
-     &         .OR.
-     &               ( ( B%HEAD .GT. B%TAIL )
-     &               .AND. ( MSG_SIZE_INT .LE. B%HEAD - B%TAIL - 1 ) )
-        IF ( .NOT. FLAG
-     &       ) THEN
-        IERR = -1
         IF ( MSG_SIZE_INT .GT. B%LBUF_INT - 1 ) THEN
-           IERR = -2
-        ENDIF
-        IPOS = -1
-        IREQ = -1
-        RETURN
-      END IF
+          IERR = -2
+          IPOS = -1
+          IREQ = -1
+          RETURN
+        END IF
         IF ( B%HEAD .LE. B%TAIL ) THEN
-          IF ( MSG_SIZE_INT .LE. B%LBUF_INT - B%TAIL + 1 ) THEN
+          IF ( MSG_SIZE_INT .LE. B%LBUF_INT - B%TAIL ) THEN
             IBUF = B%TAIL
-          ELSE IF ( MSG_SIZE_INT .LE. B%HEAD - 1 ) THEN
+          ELSE IF ( MSG_SIZE_INT .LE. B%HEAD - 2 ) THEN
             IBUF = 1
+          ELSE
+            IERR = -1
           END IF
         ELSE
-          IBUF = B%TAIL
+          IF ( MSG_SIZE_INT .LE . B%HEAD - B%TAIL - 1) THEN
+            IBUF = B%TAIL
+          ELSE
+            IERR = -1
+          ENDIF
         END IF
+        IF (IERR .LT. 0) RETURN
         B%CONTENT( B%ILASTMSG + NEXT ) = IBUF
         B%ILASTMSG = IBUF
         B%TAIL = IBUF + MSG_SIZE_INT
@@ -955,7 +953,7 @@ C
           ENDIF
         ENDIF
        IF (NBROWS_PACKET + NBROWS_ALREADY_SENT.NE.NROW .AND.
-     &   SIZE_PACK - SIZE1  .LT. ( SIZE_RBUF_BYTES - SIZE1 ) / 2
+     &   SIZE_PACK - SIZE1  .LT. ( SIZE_RBUF_BYTES - SIZE1 ) / 10
      &  .AND. 
      &   .NOT. RECV_BUF_SMALLER_THAN_SEND)
      &       THEN
@@ -1239,17 +1237,14 @@ C
                SIZE1 = SIZE1+SIZE0
           ENDIF
       ENDIF
-      IF (KEEP(50) .EQ. 0) THEN
-        ONEorTWO = 1
-      ELSE
-        ONEorTWO = 2
-      ENDIF
+      ONEorTWO = 1
       IF (PDEST .EQ.PDEST_MASTER) THEN
         L = 0
       ELSE IF (KEEP(50) .EQ. 0) THEN
         L = LROW
       ELSE
         L = LROW + PERM(1) - LMAP + NBROWS_ALREADY_SENT - 1
+        ONEorTWO=ONEorTWO+1
       ENDIF
       NBINT = 6 + L + 1 
       IF (CB_IS_LR.AND.NBROW.GT.0) THEN
@@ -1269,7 +1264,8 @@ C
      &       SIZE_AV / ( ONEorTWO*SIZEofINT+LROW*SIZEofREAL)
         ELSE
           B = 2 * ONEorTWO + 
-     &      ( 1 + 2 *  LROW + 2 * PERM(1) + 2 * NBROWS_ALREADY_SENT )
+     &      ( -1 + 2 *  LROW + 2 * PERM(1) -2*LMAP
+     &                                  + 2 * NBROWS_ALREADY_SENT )
      &      * SIZEofREAL / SIZEofINT
           NBROWS_PACKET=int((dble(-B)+sqrt((dble(B)*dble(B))+
      &        dble(4)*dble(2)*dble(SIZE_AV)/dble(SIZEofINT) *
@@ -1318,9 +1314,9 @@ C
           MAX_ROW_LENGTH = -99999
           SIZE_REALS = NBROWS_PACKET * LROW
         ELSE
-          SIZE_REALS = (  LROW + PERM(1) + NBROWS_ALREADY_SENT ) *
+          SIZE_REALS = ( LROW + PERM(1) - LMAP + NBROWS_ALREADY_SENT ) *
      &      NBROWS_PACKET + ( NBROWS_PACKET *
-     &     ( NBROWS_PACKET + 1) ) / 2
+     &     ( NBROWS_PACKET - 1) ) / 2
           MAX_ROW_LENGTH = LROW+PERM(1)-LMAP+NBROWS_ALREADY_SENT
      &                 + NBROWS_PACKET-1
         ENDIF
@@ -1346,7 +1342,7 @@ C
       ENDIF
         SIZE_PACK = SIZE1 + SIZE2 + SIZE3
         IF (NBROWS_PACKET + NBROWS_ALREADY_SENT.NE.NBROW .AND.
-     &       SIZE_PACK  .LT. SIZE_RBUF_BYTES / 4 .AND.
+     &       SIZE_PACK  .LT. SIZE_RBUF_BYTES / 10 .AND.
      &    .NOT. RECV_BUF_SMALLER_THAN_SEND .AND.
      &    .NOT. CB_IS_LR)
      &       THEN
@@ -1804,7 +1800,7 @@ C
      &             WIDTH, COMM,
      &             NELIM, NPARTSASS, CURRENT_BLR_PANEL, 
      &             LR_ACTIVATED, BLR_LorU,
-     &
+     &             ICNTL,
      &             IERR )
       USE DMUMPS_LR_TYPE
       IMPLICIT NONE
@@ -1820,19 +1816,28 @@ C
         LOGICAL, intent(in) :: LR_ACTIVATED
         INTEGER, intent(in) :: NELIM, NPARTSASS, CURRENT_BLR_PANEL
         TYPE (LRB_TYPE), DIMENSION(:), intent(in) :: BLR_LorU
+        INTEGER, intent(in) :: ICNTL(60)
         INTEGER, intent(inout) :: IERR
         INCLUDE 'mpif.h'
         INCLUDE 'mumps_tags.h'
         INTEGER :: IERR_MPI
-        INTEGER POSITION, IREQ, IPOS, SIZE1, SIZE2, SIZE3, SIZET,
+        INTEGER POSITION, IREQ, IPOS, SIZE1, SIZE3, SIZET,
      &          IDEST, IPOSMSG, I
+        LOGICAL OVERFLOW
+        INTEGER(8) :: SIZE2_8, SIZE3_8, SIZET_8, SIZE_OVERFLOW
         INTEGER NPIVSENT
         INTEGER SSS
         INTEGER  :: NBMSGS
+        INTEGER :: LP
+        LOGICAL :: LPOK
         INTEGER :: LRELAY_INFO, DEST_BLOCFACTO, TAG_BLOCFACTO
         INTEGER :: LR_ACTIVATED_INT
+        LP  = ICNTL( 1 )
+        LPOK    = ( LP.GT.0 .AND. ICNTL(4).GE.1 )
         IERR = 0
         LRELAY_INFO = 0
+        OVERFLOW = .FALSE.
+        SIZE_OVERFLOW = 0_8
         NBMSGS = NDEST
         IF ( LASTBL ) THEN
           IF ( KEEP(50) .eq. 0 ) THEN
@@ -1855,28 +1860,56 @@ C
      &                          MPI_INTEGER, COMM, SIZE1, IERR_MPI )
           END IF
         END IF
-        SIZE2 = 0
+        SIZE2_8 = 0_8
         CALL MPI_PACK_SIZE( 4, MPI_INTEGER, COMM, SIZE3, IERR_MPI )
-        SIZE2=SIZE2+SIZE3
+        SIZE2_8=SIZE2_8+SIZE3
         IF ( KEEP(50).NE.0 ) THEN
           CALL MPI_PACK_SIZE( 1, MPI_INTEGER, COMM, SIZE3, IERR_MPI )
-          SIZE2=SIZE2+SIZE3
+          SIZE2_8=SIZE2_8+SIZE3
         ENDIF
         IF ((NPIV.GT.0)
      &     ) THEN
           IF (.NOT. LR_ACTIVATED) THEN
-            CALL MPI_PACK_SIZE( NPIV*NCOL, MPI_DOUBLE_PRECISION,
+            SIZE3_8 = int(NPIV,8)*int(NCOL,8)*int(KEEP(35),8)
+            IF (SIZE3_8 .GT. int(huge(SIZE3),8))  THEN
+              OVERFLOW      = .TRUE.
+              SIZE_OVERFLOW = SIZE3_8
+            ELSE
+              CALL MPI_PACK_SIZE( NPIV*NCOL, 
+     &                      MPI_DOUBLE_PRECISION,
      &                      COMM, SIZE3, IERR_MPI )
-            SIZE2 = SIZE2+SIZE3
+              SIZE2_8 = SIZE2_8 + int(SIZE3,8)
+            ENDIF
           ELSE
-            CALL MPI_PACK_SIZE( NPIV*(NPIV+NELIM), MPI_DOUBLE_PRECISION,
+            SIZE3_8 = int(NPIV,8)*int(NPIV+NELIM,8)*int(KEEP(35),8)
+            IF (SIZE3_8 .GT. int(huge(SIZE3),8)) THEN
+              OVERFLOW = .TRUE.
+              SIZE_OVERFLOW = SIZE3_8
+            ELSE
+              CALL MPI_PACK_SIZE( NPIV*(NPIV+NELIM), 
+     &                      MPI_DOUBLE_PRECISION,
      &                      COMM, SIZE3, IERR_MPI )
-            SIZE2 = SIZE2+SIZE3
-              CALL MUMPS_MPI_PACK_SIZE_LR( BLR_LorU, SIZE3, COMM, IERR )
-            SIZE2 = SIZE2+SIZE3
-          ENDIF
+              SIZE2_8 = SIZE2_8+SIZE3
+            ENDIF
+              CALL MUMPS_MPI_PACK_SIZE_LR( BLR_LorU, SIZE3_8, 
+     &                                     COMM, IERR )
+            SIZE2_8 = SIZE2_8+SIZE3_8
+          ENDIF
+        ENDIF
+        SIZET_8 = int(SIZE1,8) + SIZE2_8
+        IF (SIZET_8 .GT. int(huge(SIZE3),8)) THEN
+              OVERFLOW      = .TRUE.
+              SIZE_OVERFLOW = SIZET_8
+        ENDIF
+        IF (OVERFLOW) THEN
+          IERR=-3
+          IF (LPOK) WRITE(LP,*)
+     & "Integer overflow message inDMUMPS_BUF_SEND_BLOCFACTO",
+     & "SIZE_OVERFLOW,NPIV,NFRONT,NELIM=",
+     &  SIZE_OVERFLOW, NPIV, NFRONT, NELIM
+          RETURN
         ENDIF
-        SIZET = SIZE1 + SIZE2 
+        SIZET = int(SIZET_8)
         IF (SIZET.GT.SIZE_RBUF_BYTES) THEN
           SSS = 0 
           IF ( LASTBL ) THEN
@@ -1896,7 +1929,7 @@ C
      &                        MPI_INTEGER, COMM, SSS, IERR_MPI )
            END IF
           END IF
-          SSS = SSS + SIZE2  
+          SSS = SSS + int(SIZE2_8)  
           IF (SSS.GT.SIZE_RBUF_BYTES) THEN
            IERR = -3 
             RETURN
@@ -2043,30 +2076,50 @@ C
         INCLUDE 'mumps_tags.h'
         INTEGER :: IERR_MPI
         INTEGER LR_ACTIVATED_INT
-        INTEGER POSITION, IREQ, IPOS, SIZE1, SIZE2, SIZET,
+        INTEGER POSITION, IREQ, IPOS, SIZE1, SIZET,
      &          IDEST, IPOSMSG, SSS, SSLR
-        IERR = 0
+        INTEGER(8) :: SIZE2_8, SSLR_8, SIZET_8, SIZE_OVERFLOW
+        LOGICAL    :: OVERFLOW
+        IERR          = 0
+        OVERFLOW      = .FALSE.
+        SIZE_OVERFLOW = 0_8
         CALL MPI_PACK_SIZE( 6 + ( NDEST - 1 ) * OVHSIZE,
      &                      MPI_INTEGER, COMM, SIZE1, IERR_MPI )
-        SIZE2  = 0
+        SIZE2_8  = 0_8
         CALL MPI_PACK_SIZE(2, MPI_INTEGER, COMM, SSLR, IERR_MPI )
-        SIZE2=SIZE2+SSLR
+        SIZE2_8 = SIZE2_8 + SSLR
         IF (.NOT. LR_ACTIVATED) THEN
-        CALL MPI_PACK_SIZE( abs(NPIV)*NCOLU, MPI_DOUBLE_PRECISION,
+          SSLR_8 = int(abs(NPIV),8)*int(NCOLU,8)
+          IF (SSLR_8 .GT. int(huge(SSLR),8))  THEN
+              OVERFLOW      = .TRUE.
+              SIZE_OVERFLOW = SSLR_8
+          ELSE
+           CALL MPI_PACK_SIZE( abs(NPIV)*NCOLU, 
+     &                      MPI_DOUBLE_PRECISION,
      &                      COMM, SSLR, IERR_MPI )
-         SIZE2=SIZE2+SSLR
+           SIZE2_8=SIZE2_8 + int(SSLR,8)
+          ENDIF
         ELSE
-          CALL MUMPS_MPI_PACK_SIZE_LR( BLR_LS, SSLR, COMM, IERR )
-          SIZE2=SIZE2+SSLR
+          CALL MUMPS_MPI_PACK_SIZE_LR( BLR_LS, SSLR_8, COMM, IERR )
+          SIZE2_8=SIZE2_8 + SSLR_8
+        ENDIF
+        SIZET_8 = int(SIZE1,8) + SIZE2_8
+        IF (SIZET_8 .GT. int(huge(SSLR),8)) THEN
+              OVERFLOW      = .TRUE.
+              SIZE_OVERFLOW = SIZET_8
         ENDIF
-        SIZET = SIZE1 + SIZE2
+        IF (OVERFLOW) THEN
+          IERR=-3
+          RETURN
+        ENDIF
+        SIZET = int(SIZET_8)
         IF (SIZET.GT.SIZE_RBUF_BYTES) THEN
          CALL MPI_PACK_SIZE( 6 ,
      &                      MPI_INTEGER, COMM, SSS, IERR_MPI )
-         SSS = SSS+SIZE2
-         IF (SSS.GT.SIZE_RBUF_BYTES) THEN
+         SIZE2_8 = int(SSS,8)+SIZE2_8
+         IF (int(SIZE2_8).GT.SIZE_RBUF_BYTES) THEN
            IERR = -2
-      RETURN
+           RETURN
          ENDIF
         END IF
         CALL BUF_LOOK( BUF_CB, IPOS, IREQ, SIZET, IERR, 
@@ -2254,7 +2307,7 @@ C
           ENDIF
           IF (N_PACKET + N_ALREADY_SENT .NE. NSUBSET_ROW - NSUPROW
      &         .AND.
-     &         SIZE_PACK .LT. SIZE_RBUF_BYTES / 4
+     &         SIZE_PACK .LT. SIZE_RBUF_BYTES / 10
      &         .AND. .NOT. RECV_BUF_SMALLER_THAN_SEND)
      &         THEN
              IERR = -1
@@ -2797,11 +2850,11 @@ C
      &             ( WHAT, COMM, NPROCS, 
      &               FUTURE_NIV2,
      &               LOAD, UPD_LOAD,
-     &               MYID, KEEP, IERR)
+     &               MYID, KEEP267, IERR)
         IMPLICIT NONE
         INTEGER COMM, NPROCS, MYID, IERR, WHAT
         DOUBLE PRECISION LOAD,UPD_LOAD
-        INTEGER, INTENT(INOUT) :: KEEP(500)
+        INTEGER, INTENT(INOUT) :: KEEP267
         INCLUDE 'mpif.h'
         INCLUDE 'mumps_tags.h'
         INTEGER :: IERR_MPI
@@ -2870,7 +2923,7 @@ C
         DO I = 0, NPROCS - 1
           IF ( I .NE. MYID .AND. FUTURE_NIV2(I+1) .NE. 0) THEN
             IDEST = IDEST + 1
-            KEEP(267)=KEEP(267)+1
+            KEEP267 = KEEP267 + 1
             CALL MPI_ISEND( BUF_LOAD%CONTENT( IPOSMSG ),
      &                      POSITION, MPI_PACKED, I,
      &                      UPDATE_LOAD, COMM,
@@ -2913,7 +2966,7 @@ C
      &          MPI_INTEGER, COMM,
      &          SIZE, IERR_MPI )
         ELSE
-           CALL MPI_PACK_SIZE( 2 + OVHSIZE, 
+           CALL MPI_PACK_SIZE( 2, 
      &          MPI_INTEGER, COMM,
      &          SIZE, IERR_MPI )
         ENDIF
@@ -3153,22 +3206,23 @@ C
         SIZE_RBUF_BYTES = DMUMPS_LBUFR_BYTES
         RETURN
       END SUBROUTINE DMUMPS_BUF_DIST_IRECV_SIZE
-      SUBROUTINE MUMPS_MPI_PACK_SIZE_LR( BLR_LorU, SIZE_OUT, COMM,
+      SUBROUTINE MUMPS_MPI_PACK_SIZE_LR( BLR_LorU, SIZE_OUT8, COMM,
      &                                   IERR )
       USE DMUMPS_LR_TYPE
-      INTEGER, intent(out) :: SIZE_OUT, IERR
+      INTEGER, intent(out)     :: IERR
+      INTEGER(8), intent(out)  :: SIZE_OUT8
       INTEGER, intent(in)  :: COMM
       TYPE (LRB_TYPE), DIMENSION(:), intent(in) :: BLR_LorU
-      INTEGER :: I, SIZE_LOC, IERR_MPI
+      INTEGER     :: I, SIZE_LOC, IERR_MPI
       INCLUDE 'mpif.h'
-        IERR = 0
-        SIZE_OUT = 0
+        IERR      = 0
+        SIZE_OUT8 = 0_8
         CALL MPI_PACK_SIZE( 1, MPI_INTEGER, COMM, SIZE_LOC,  IERR_MPI )
-        SIZE_OUT = SIZE_OUT + SIZE_LOC
+        SIZE_OUT8 = SIZE_OUT8 + SIZE_LOC
         DO I = 1, size(BLR_LorU)
           CALL MUMPS_MPI_PACK_SIZE_LRB(BLR_LorU(I), SIZE_LOC, COMM, 
      &                                 IERR )
-          SIZE_OUT = SIZE_OUT + SIZE_LOC
+          SIZE_OUT8 = SIZE_OUT8 + SIZE_LOC
         ENDDO
         RETURN
       END SUBROUTINE MUMPS_MPI_PACK_SIZE_LR
diff -pruN 5.6.2-2.1/src/dmumps_config_file.F 5.7.1-1/src/dmumps_config_file.F
--- 5.6.2-2.1/src/dmumps_config_file.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dmumps_config_file.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/dmumps_driver.F 5.7.1-1/src/dmumps_driver.F
--- 5.6.2-2.1/src/dmumps_driver.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/dmumps_driver.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -21,7 +21,9 @@ C
       USE MUMPS_MEMORY_MOD
       USE DMUMPS_STRUC_DEF
       USE DMUMPS_STATIC_PTR_M ! For Schur pointer
+#if ! defined(NO_SAVE_RESTORE)
       USE DMUMPS_SAVE_RESTORE
+#endif
 C      
 !$    USE OMP_LIB
 C
@@ -345,6 +347,14 @@ C
 * Values 4, 5, 6 for the parameter JOB can invoke combinations
 * of the three basic operations corresponding to JOB=1, 2 or 3.
 * 
+* JOB = -4 : frees all data structures from the factorization
+* while keeping data structures from the analysis. Can be
+* followed by a JOB = 2 call.
+*
+#if ! defined(NO_SAVE_RESTORE)
+* JOB = -3, 7, 8 : save and restore feature, see userguide
+#endif
+* JOB = 9 : provide suggested data distribution for IRHS_LOC
 C
 *********
 C     --------------------------------------
@@ -584,7 +594,7 @@ C
 !$    INTEGER NOMP, NOMPMIN, NOMPMAX
       INTEGER I, J, MP, LP, MPG, KEEP235SAVE, KEEP242SAVE,
      &        KEEP243SAVE, KEEP495SAVE, KEEP497SAVE,
-     &        KEEP77SAVE, KEEP83SAVE, KEEP91SAVE
+     &        KEEP77SAVE, KEEP78SAVE, KEEP83SAVE, KEEP91SAVE
       INTEGER(8) :: I8
       LOGICAL LANA, LFACTO, LSOLVE, PROK, LPOK, FLAG, PROKG
       LOGICAL NOERRORBEFOREPERM
@@ -599,7 +609,9 @@ C     Local copy of JOB
       INTEGER, DIMENSION(:), ALLOCATABLE :: UNS_PERM_INV
 C     TIMINGS
       DOUBLE PRECISION TIMEG, TIMETOTAL
+#if ! defined(NO_SAVE_RESTORE)
       INTEGER(8) :: FILE_SIZE,STRUC_SIZE
+#endif
       INTEGER:: ICNTL16_LOC
 !$    INTEGER:: PREVIOUS_OMP_THREADS_NUM
       IF (id%JOB .EQ. -200) THEN
@@ -613,12 +625,14 @@ C       JOB=-200 to just suppress the ex
 C       before terminating the application and killing all
 C       processes. No checks are performed in this case,
 C       data is not freed and MPI should not be called
-C       (since MPI might no longer work)
+C       (since MPI might no longer work). In particular, there is
+C       no check that the value of JOB is the same on all the
+C       calling MPI processes.
         CALL DMUMPS_OOC_CLEAN_FILES(id,IERR)
         RETURN
       ENDIF
       NOERRORBEFOREPERM = .FALSE.
-      UNS_PERM_DONE = .FALSE.
+      UNS_PERM_DONE     = .FALSE.
       LANA  = .FALSE.
       LFACTO = .FALSE.
       LSOLVE = .FALSE.
@@ -627,6 +641,14 @@ C
 C     Initialize error return codes to 0.
       id%INFO(1) = 0
       id%INFO(2) = 0
+C
+C     Default setting for printing, before ICNTL(1:4) are initialized
+      LP = 6
+      MP = 0
+      MPG = 0
+      LPOK  = .TRUE.
+      PROK  = .FALSE.
+      PROKG = .FALSE.
 C     -----------------------------------
 C     Check that MPI has been initialized
 C     -----------------------------------
@@ -636,7 +658,9 @@ C     ----------------------------------
         id%INFO(2) =   0
         id%INFOG(1) = -23
         id%INFOG(2) =   0
-        WRITE(6,990)
+C       JOB=-1: LPOK is true and LP=6 (see
+C       above) because not set yet by the user
+        IF (LPOK) WRITE(LP,990)
  990  FORMAT(' Unrecoverable Error in DMUMPS initialization: ',
      &       ' MPI is not running.')
         RETURN               
@@ -646,16 +670,8 @@ C     Duplicate user communicator
 C     to avoid communications not
 C     related to DMUMPS
 C     ---------------------------
-       COMM_SAVE = id%COMM
-       CALL MPI_COMM_DUP( COMM_SAVE, id%COMM, IERR )
-C
-C     Default setting for printing
-      LP = 6
-      MP = 0
-      MPG = 0
-      LPOK  = .TRUE.
-      PROK  = .FALSE.
-      PROKG = .FALSE.
+      COMM_SAVE = id%COMM
+      CALL MPI_COMM_DUP( COMM_SAVE, id%COMM, IERR )
       ICNTL16_LOC = 0
 C     -------------------------
 C     Check if value of JOB is
@@ -673,7 +689,11 @@ C     -------------------------
 C   
 C     Check value of JOB and previous value of JOB
 C
+#if ! defined(NO_SAVE_RESTORE)
       IF ((JOB.LT.-3.OR.JOB.EQ.0.OR.JOB.GT.8)
+#else
+      IF ((JOB.LT.-2.OR.JOB.EQ.0.OR.JOB.GT.6) 
+#endif
      &    .AND. JOB.NE.9
      &    .AND. JOB.NE.-4
      &  ) THEN
@@ -695,6 +715,7 @@ C      Warning: non initialized value
         GOTO 499
        END IF
       END IF
+#if ! defined(NO_SAVE_RESTORE)
       IF(JOB.NE.-1) THEN
 C     Always allow JOB=-1
          IF((JOB.GT.-2).AND.(id%KEEP(140).EQ.1)) then
@@ -705,6 +726,7 @@ C     are -2 or -3
             GOTO 499
          END IF
       ENDIF
+#endif
 C     ----------------------------------
 C     Initialize, LANA, LFACTO, LSOLVE
 C     LANA indicates if analysis must be performed
@@ -730,6 +752,7 @@ C       Value defined on MASTER is the r
      &         IERR )
         IF (LANA) THEN
            KEEP77SAVE = id%KEEP(77)
+           KEEP78SAVE = id%KEEP(78)
            KEEP83SAVE = id%KEEP(83)
            KEEP91SAVE = id%KEEP(91)
            id%KEEP(198) = 0
@@ -786,9 +809,11 @@ C       and factorization:
       ENDIF
 C
       IF (JOB.EQ.-2.OR.JOB.EQ.1.OR.JOB.EQ.2.OR.JOB.EQ.3.OR.
-     &    JOB.EQ.4.OR.JOB.EQ.5.OR.JOB.EQ.6
+     &    JOB.EQ.4.OR.JOB.EQ.5.OR.JOB.EQ.6.OR.JOB.EQ.-4
+#if ! defined(NO_SAVE_RESTORE)
      &     .OR.JOB.EQ.7.OR.JOB.EQ.8.OR.JOB.EQ.-3
-     *     .OR. JOB.EQ.9 ! LATER .OR.JOB.EQ.10
+#endif
+     &     .OR. JOB.EQ.9 
      &     ) THEN
 C       Value of JOB is correct and differnet from -1
 C       ICNTL should have been initialized and can be used
@@ -803,6 +828,10 @@ C       ICNTL should have been initializ
           FROM_C_INTERFACE_STRING=" from C interface"
         ELSE
           FROM_C_INTERFACE_STRING=" "
+C         and KEEP8(83) to the ddress of ICNTL(50)
+C         Set KEEP8(84) to the address of RINFO(3)
+          CALL MUMPS_ADDR_C( id%ICNTL(50), id%KEEP8(83) )
+          CALL MUMPS_ADDR_C( id%RINFO (3), id%KEEP8(84) )
         ENDIF
 C       -----------------------------
 C       Set the number of threads if required.
@@ -832,10 +861,14 @@ C       -----------------------------
         IF (PROKG) THEN
 C          Print basic information on MUMPS call
            IF (JOB .EQ. -2
+#            if ! defined(NO_SAVE_RESTORE)
      &       .OR. JOB .EQ. 8
+#            endif
      &       ) THEN
 C            N, NELT, NNZ not meaningful
+#            if ! defined(NO_SAVE_RESTORE)
 C            or not defined yet (JOB=8).
+#            endif
              WRITE(MPG,'(/A,A,A,A,I4)') 
      &               'Entering DMUMPS ',
      &               trim(adjustl(id%VERSION_NUMBER)),
@@ -885,11 +918,6 @@ C          MPI and OpenMP information
 99996       FORMAT(/'Advanced settings:'/
      &       '   KEEP(370) Static mapping              =',I10/
      &       '   KEEP(371) Advanced optimizations      =',I10)
-            IF (id%KEEP(401) .GE. 1) THEN
-              WRITE(MPG, 99997) id%KEEP(401)
-            ENDIF
-99997       FORMAT('L0 thread based multithreading setting:'/
-     &       '   KEEP(401) (>=1 : ON)                  =',I10)
             WRITE(MPG, '(A)')
           ENDIF
         ENDIF
@@ -908,18 +936,18 @@ C
 C       ------------------------------------------
 C       Check that we have called (JOB=-2), ie
 C       that the previous JOB is not 1 2 or 3,
+C       or even -1
 C       before calling the initialization routine.
 C       --------------------------------------------
         id%INFO(1)=0
         id%INFO(2)=0
         OLDJOB = id%KEEP( 40 ) + 456789
-        IF ( OLDJOB .EQ. 1 .OR.
+        IF ( OLDJOB .EQ. -1 .OR.
+     &       OLDJOB .EQ. 1 .OR.
      &       OLDJOB .EQ. 2 .OR.
      &       OLDJOB .EQ. 3  ) THEN
-          IF ( id%N > 0 ) THEN
            id%INFO(1)=-3
            id%INFO(2)=JOB
-          ENDIF
         ENDIF
 C       Initialize id%MYID now because it is
 C       required by MUMPS_PROPINFO. id%MYID
@@ -976,6 +1004,7 @@ C
         id%DKEEP(70)=0.0D0
         CALL MUMPS_SECDEB(TIMETOTAL)
       ENDIF
+#if ! defined(NO_SAVE_RESTORE)
 C
 C----------------------------------------------------------------
 C
@@ -1046,6 +1075,7 @@ C
         IF ( id%INFO(1) .LT. 0 ) GOTO 499
         GOTO 500
       ENDIF
+#endif
 C----------------------------------------------------------------
 C
 C     JOB =  9 : fill IRHS_loc
@@ -1076,11 +1106,13 @@ C       Allowed if last factorization fa
           CALL DMUMPS_FREE_DATA_FACTO(id)
 C         Reset last successful phase
           OLDJOB=min(OLDJOB, 1)
+          id%KEEP(40) = OLDJOB - 456789
         ENDIF
         IF ( id%INFO(1) .LT .0 ) GOTO 499
         GOTO 500
       ENDIF
 C
+C
 C----------------------------------------------------------------
 C
 C     MAIN DRIVER
@@ -1168,7 +1200,6 @@ C      refinement and error analysis)
 C     ------------------------------------------
 #if ! defined (LARGEMATRICES)
       NOERRORBEFOREPERM =.TRUE.
-      UNS_PERM_DONE=.FALSE.
       IF (id%MYID .eq. MASTER .AND. id%KEEP(23) .NE. 0) THEN
         IF ( id%JOB .EQ. 2 .OR. id%JOB .EQ. 5 .OR.
      &       (id%JOB .EQ. 3 .AND. (id%ICNTL(10) .NE.0 .OR.
@@ -1238,10 +1269,10 @@ C       ----------------------------
 C
         IF (id%MYID.EQ.MASTER) THEN
 C         Check N, [N]NZ, NELT
-          IF ((id%N.LE.0).OR.((id%N+id%N+id%N)/3.NE.id%N)) THEN
-             id%INFO(1) = -16
-             id%INFO(2) = id%N
-             GOTO 100
+          IF (id%N.LE.0) THEN
+            id%INFO(1) = -16
+            id%INFO(2) = id%N
+            GOTO 100
           END IF
           IF (id%ICNTL(5).NE.1) THEN
 C           Assembled input
@@ -1419,8 +1450,27 @@ C       ANALYSIS PHASE:
         CALL DMUMPS_ANA_DRIVER( id )
 C       restore values
         id%KEEP(77) =  KEEP77SAVE 
+        id%KEEP(78) =  KEEP78SAVE 
         id%KEEP(83) =  KEEP83SAVE
         id%KEEP(91) =  KEEP91SAVE
+#if ! defined(LARGEMATRICES)
+        IF (id%MYID .eq. MASTER .AND. id%KEEP(23) .NE. 0) THEN
+         IF (.not.associated(id%UNS_PERM)) THEN
+C         I may happen 
+C           (for ex in case of error -7 during analysis:
+C           UNS_PERM can be not associated, 
+C           KEEP(23) was set to to automatic choice(=7) and
+C           an error of memory allocation occurs during analysis
+C           before having decided value of KEEP(23))
+C         UNS_PERM not associated and KEEP(23).NE.0
+C         Permuting JCN back does not make sense and KEEP(23) 
+C         should be reset to zero
+          id%KEEP(23) = 0
+         ELSE
+          UNS_PERM_DONE = .TRUE.
+         ENDIF
+        ENDIF
+#endif
 C
 C Check and save scaling option in INFOG(33)
         IF (id%MYID .eq. MASTER) THEN
@@ -1482,6 +1532,7 @@ C
 C-
 C-------------------------------------------------------
       IF ( LFACTO ) THEN
+C{
          IF (id%MYID .eq. MASTER) THEN
             id%DKEEP(91)=0.0D0
             CALL MUMPS_SECDEB(TIMEG)
@@ -1794,14 +1845,19 @@ C
              CALL DMUMPS_CHECK_DENSE_RHS
      &       (id%RHS,id%INFO,id%N,id%NRHS,id%LRHS)
 C            Sets KEEP(221) and do some checks
-             CALL DMUMPS_SET_K221(id)
-             CALL DMUMPS_CHECK_REDRHS(id)
+C            in case of Schur check if reduced RHS 
+C            requested
+              CALL DMUMPS_SET_K221(id,.FALSE.)
+             CALL DMUMPS_CHECK_K221andREDRHS(id)
           ENDIF
  200      CONTINUE
         END IF        ! End of IF (MYID .eq. MASTER)
 C       KEEP(221) was set in DMUMPS_SET_K221 but not broadcast
         CALL MPI_BCAST( id%KEEP(221), 1, MPI_INTEGER, MASTER, id%COMM,
      &       IERR )
+C       broadcast RR option 
+        CALL MPI_BCAST( id%KEEP(19), 1, MPI_INTEGER, MASTER, id%COMM,
+     &       IERR )
 C
 C       Check distributed matrices on all processors.
         I_AM_SLAVE = ( id%MYID .ne. MASTER  .OR.
@@ -1969,6 +2025,7 @@ C
 C       Update last successful step
 C
         id%KEEP(40) = 2 - 456789
+C}
       END IF
 C-------------------------------------------------------
 C-
@@ -2082,26 +2139,13 @@ C       done (no iterative refinement/
 C       error analysis), then we do not
 C       permute JCN back.
 C       -------------------------------
-        IF (id%JOB .NE. 3 .OR. UNS_PERM_DONE) THEN
-         IF (.not.associated(id%UNS_PERM)) THEN
-C         I may happen 
-C           (for ex in case of error -7 during analysis:
-C           UNS_PERM can be not associated, 
-C           KEEP(23) was set to to automatic choice(=7) and
-C           an error of memory allocation occurs during analysis
-C           before having decided value of KEEP(23))
-C         UNS_PERM not associated and KEEP(23).NE.0
-C         Permuting JCN back does not make sense and KEEP(23) 
-C         should be reset to zero
-          id%KEEP(23) = 0
-         ELSE
+        IF (UNS_PERM_DONE) THEN
            DO I8 = 1_8, id%KEEP8(28)
             J=id%JCN(I8)
 C           -- skip out-of range (that are ignored in ANA_O)
             IF (J.LE.0.OR.J.GT.id%N) CYCLE
             id%JCN(I8)=id%UNS_PERM(J)
            END DO
-          ENDIF
         END IF
       END IF
 #endif
@@ -2131,6 +2175,7 @@ C     the next time MUMPS is entered thr
 C     ------------------------------------------------------------
       NULLIFY(id%SCHUR_CINTERFACE)
 C
+#if ! defined(NO_SAVE_RESTORE)
 *=======================
 * Compute space for save
 *=======================
@@ -2147,6 +2192,7 @@ C
          id%RINFOG(17)=dble(id%KEEP8(57))/1D6
          id%RINFOG(18)=dble(id%KEEP8(58))/1D6
       ENDIF
+#endif
 !$    IF (ICNTL16_LOC .GT. 0) THEN
 #if defined(WORKAROUNDINTELILP64OPENMPLIMITATION)
 !$      CALL omp_set_num_threads(int(PREVIOUS_OMP_THREADS_NUM,4))
@@ -2168,8 +2214,8 @@ C
 C     -------------------------
 C     Restore user communicator
 C     -------------------------
-       CALL MPI_COMM_FREE( id%COMM, IERR )
-       id%COMM = COMM_SAVE
+      CALL MPI_COMM_FREE( id%COMM, IERR )
+      id%COMM = COMM_SAVE
       RETURN
 *
 99995 FORMAT (' ** ERROR RETURN ** FROM DMUMPS INFO(1)=', I5)
@@ -2242,7 +2288,7 @@ C        INFOG(2) = MYID
         CALL MPI_BCAST( INFOG(2), 1, MPI_INTEGER, ROOT, COMM, IERR )
       END IF
 C
-C    Make INFOG available on all procs:
+C     Make INFOG available on all procs:
 C
       CALL MPI_BCAST(INFOG(3), SIZE_INFOG-2, MPI_INTEGER,
      &               MASTER, COMM, IERR )
@@ -2279,12 +2325,12 @@ C---------------------------------------
             WRITE (LP,991) ICNTL(5),ICNTL(6),ICNTL(7),ICNTL(12),
      &          ICNTL(13),
      &          ICNTL(15),
-     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(58)
+     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(48),ICNTL(58)
            ELSE
             WRITE (LP,891) ICNTL(5),ICNTL(6),ICNTL(7),
      &          ICNTL(13),
      &          ICNTL(15),
-     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(58)
+     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(48),ICNTL(58)
            ENDIF
            IF ((ICNTL(6).EQ.5).OR.(ICNTL(6).EQ.6).OR.
      &          (ICNTL(12).NE.1) )  THEN
@@ -2293,6 +2339,7 @@ C---------------------------------------
            IF (id%ICNTL(19).NE.0)
      &      WRITE(LP,998) id%SIZE_SCHUR
            WRITE (LP,993) ICNTL(14)
+           WRITE (LP,996) ICNTL(56)
          CASE(2);
            WRITE (LP,980) 
            WRITE (LP,981) CNTL(1), CNTL(3), CNTL(4), CNTL(5), CNTL(7)
@@ -2301,21 +2348,34 @@ C---------------------------------------
            WRITE (LP,993) ICNTL(14) 
            WRITE (LP,923) ICNTL(24), ICNTL(31), ICNTL(32), ICNTL(33),
      &                    ICNTL(35), ICNTL(36), ICNTL(49)
+           WRITE (LP,996) ICNTL(56)
          CASE(3);
            WRITE (LP,980)
            WRITE (LP,990) ICNTL(1),ICNTL(2),ICNTL(3),ICNTL(4)
            WRITE (LP,995)
-     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21)
+     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21),ICNTL(26)
          CASE(4);
            WRITE (LP,980) 
            WRITE (LP,981) CNTL(1), CNTL(3), CNTL(4), CNTL(5), CNTL(7)
            WRITE (LP,990) ICNTL(1),ICNTL(2),ICNTL(3),ICNTL(4)
+           IF (id%SYM.EQ.2) THEN
+            WRITE (LP,991) ICNTL(5),ICNTL(6),ICNTL(7),ICNTL(12),
+     &          ICNTL(13),
+     &          ICNTL(15),
+     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(48),ICNTL(58)
+           ELSE
+            WRITE (LP,891) ICNTL(5),ICNTL(6),ICNTL(7),
+     &          ICNTL(13),
+     &          ICNTL(15),
+     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(48),ICNTL(58)
+           ENDIF
            WRITE (LP,992) ICNTL(8)
            IF (id%ICNTL(19).NE.0)
      &      WRITE(LP,998) id%SIZE_SCHUR
            WRITE (LP,993) ICNTL(14)
            WRITE (LP,923) ICNTL(24), ICNTL(31), ICNTL(32), ICNTL(33),
      &                    ICNTL(35), ICNTL(36), ICNTL(49)
+           WRITE (LP,996) ICNTL(56)
          CASE(5);
            WRITE (LP,980) 
            WRITE (LP,981) CNTL(1), CNTL(3), CNTL(4), CNTL(5), CNTL(7)
@@ -2324,19 +2384,20 @@ C---------------------------------------
             WRITE (LP,991) ICNTL(5),ICNTL(6),ICNTL(7),ICNTL(12),
      &          ICNTL(13),
      &          ICNTL(15),
-     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(58)
+     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(48),ICNTL(58)
            ELSE
             WRITE (LP,891) ICNTL(5),ICNTL(6),ICNTL(7),
      &          ICNTL(13),
      &          ICNTL(15),
-     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(58)
+     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(48),ICNTL(58)
            ENDIF
            WRITE (LP,992) ICNTL(8)
            WRITE (LP,993) ICNTL(14)
            WRITE (LP,995)
-     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21)
+     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21),ICNTL(26)
            WRITE (LP,923) ICNTL(24), ICNTL(31), ICNTL(32), ICNTL(33),
      &                    ICNTL(35), ICNTL(36), ICNTL(49)
+           WRITE (LP,996) ICNTL(56)
          CASE(6);
            WRITE (LP,980)
            WRITE (LP,981) CNTL(1), CNTL(3), CNTL(4), CNTL(5), CNTL(7)
@@ -2345,27 +2406,28 @@ C---------------------------------------
             WRITE (LP,991) ICNTL(5),ICNTL(6),ICNTL(7),ICNTL(12),
      &          ICNTL(13),
      &          ICNTL(15),
-     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(58)
+     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(48),ICNTL(58)
            ELSE
             WRITE (LP,891) ICNTL(5),ICNTL(6),ICNTL(7),
      &          ICNTL(13),
      &          ICNTL(15),
-     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(58)
+     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(48),ICNTL(58)
            ENDIF
            IF (id%ICNTL(19).NE.0)
      &      WRITE(LP,998) id%SIZE_SCHUR
            WRITE (LP,992) ICNTL(8)
            WRITE (LP,995)
-     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21)
+     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21), ICNTL(26)
            WRITE (LP,993) ICNTL(14)
            WRITE (LP,923) ICNTL(24), ICNTL(31), ICNTL(32), ICNTL(33),
      &                    ICNTL(35), ICNTL(36), ICNTL(49)
+           WRITE (LP,996) ICNTL(56)
         END SELECT
       ENDIF
  980  FORMAT (/'***********CONTROL PARAMETERS (ICNTL)**************'/)
  981  FORMAT (
      &     ' CNTL(1)   Threshold for numerical pivoting        =',D16.4/
-     &     ' CNTL(3)   Null pivot detection threshold          =',D16.4/
+     &     ' CNTL(3)   Threshold to detect singularities       =',D16.4/
      &     ' CNTL(4)   Threshold for static pivoting           =',D16.4/
      &     ' CNTL(5)   Fixation for null pivots                =',D16.4/
      &     ' CNTL(7)   Dropping threshold for BLR compression  =',D16.4)
@@ -2375,25 +2437,27 @@ C---------------------------------------
      &     'ICNTL(3)   Output stream for global information    =',I10/
      &     'ICNTL(4)   Level of printing                       =',I10)
  991  FORMAT (
-     &     'ICNTL(5)   Matrix format  ( keep(55) )             =',I10/
-     &     'ICNTL(6)   Maximum transversal  ( keep(23) )       =',I10/
+     &     'ICNTL(5)   Matrix format                           =',I10/
+     &     'ICNTL(6)   Maximum transversal                     =',I10/
      &     'ICNTL(7)   Ordering                                =',I10/
-     &     'ICNTL(12)  LDLT ordering strat ( keep(95) )        =',I10/
+     &     'ICNTL(12)  LDLT ordering strat                     =',I10/
      &     'ICNTL(13)  Parallel root (0=on, 1=off)             =',I10/
      &     'ICNTL(15)  Analysis by block                       =',I10/
-     &     'ICNTL(18)  Distributed matrix  ( keep(54) )        =',I10/
+     &     'ICNTL(18)  Distributed matrix                      =',I10/
      &     'ICNTL(19)  Schur option ( keep(60) 0=off,else=on ) =',I10/
      &     'ICNTL(22)  Out-of-core option (1=on, off otherwise)=',I10/
+     &     'ICNTL(48)  Tree based multithreading               =',I10/
      &     'ICNTL(58)  Symbolic factorization option           =',I10)
  891  FORMAT (
-     &     'ICNTL(5)   Matrix format  ( keep(55) )             =',I10/
-     &     'ICNTL(6)   Maximum transversal  ( keep(23) )       =',I10/
+     &     'ICNTL(5)   Matrix format                           =',I10/
+     &     'ICNTL(6)   Maximum transversal                     =',I10/
      &     'ICNTL(7)   Ordering                                =',I10/
      &     'ICNTL(13)  Parallel root (0=on, 1=off)             =',I10/
      &     'ICNTL(15)  Analysis by block                       =',I10/
-     &     'ICNTL(18)  Distributed matrix  ( keep(54) )        =',I10/
-     &     'ICNTL(19)  Schur option ( keep(60) 0=off,else=on ) =',I10/
+     &     'ICNTL(18)  Distributed matrix                      =',I10/
+     &     'ICNTL(19)  Schur option ( 0=off,else=on )          =',I10/
      &     'ICNTL(22)  Out-of-core option (1=on, off otherwise)=',I10/
+     &     'ICNTL(48)  Tree based multithreading               =',I10/
      &     'ICNTL(58)  Symbolic factorization option           =',I10)
  992  FORMAT (
      &     'ICNTL(8)   Scaling strategy                        =',I10)
@@ -2407,12 +2471,15 @@ C---------------------------------------
      &     'ICNTL(49)  Compact workarray S (end of facto.)     =',I10)
  993  FORMAT (
      &     'ICNTL(14)  Percent of memory increase              =',I10)
+ 996  FORMAT (
+     &     'ICNTL(56)  Null space functionality                =',I10) 
  995  FORMAT (
      &     'ICNTL(9)   Solve A x=b (1) or A''x = b (else)       =',I10/
      &     'ICNTL(10)  Max steps iterative refinement          =',I10/
      &     'ICNTL(11)  Error analysis (1=all,2=some,else=off)  =',I10/
      &     'ICNTL(20)  Den.(0)/sparse(1,2,3)/dist.(10,11) RHS  =',I10/
-     &     'ICNTL(21)  Gathered (0) or distributed(1) solution =',I10)
+     &     'ICNTL(21)  Gathered (0) or distributed(1) solution =',I10/
+     &     'ICNTL(26)  Solution step                           =',I10)
  998  FORMAT (
      &     '           Size of SCHUR matrix (SIZE_SCHUR)       =',I10)
       END SUBROUTINE DMUMPS_PRINT_ICNTL
@@ -2452,11 +2519,13 @@ C---------------------------------------
               WRITE (LP,992) KEEP(52)
            ENDIF   
            WRITE (LP,993) KEEP(12)
+           WRITE (LP,996) KEEP(19), KEEP(118)
+           WRITE (LP,994) KEEP(21)
          CASE(3);
            WRITE (LP,980)
            WRITE (LP,990) ICNTL(1),ICNTL(2),ICNTL(3),ICNTL(4) 
            WRITE (LP,995)
-     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21)
+     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21), ICNTL(26)
          CASE(4);
            WRITE (LP,980) 
            WRITE (LP,990) ICNTL(1),ICNTL(2),ICNTL(3),ICNTL(4)
@@ -2466,8 +2535,11 @@ C---------------------------------------
            WRITE (LP,991) KEEP(55),KEEP(23),ICNTL(7),KEEP(95),
      &          ICNTL(13),KEEP(54),KEEP(60),ICNTL(22)
            WRITE (LP,995)
-     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21)
+     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21), ICNTL(26)
            WRITE (LP,993) KEEP(12)
+           WRITE (LP,997) KEEP(53)
+           WRITE (LP,996) KEEP(19), KEEP(118)
+           WRITE (LP,994) KEEP(21)
          CASE(5);
            WRITE (LP,980) 
            WRITE (LP,990) ICNTL(1),ICNTL(2),ICNTL(3),ICNTL(4)
@@ -2481,6 +2553,8 @@ C---------------------------------------
               WRITE (LP,992) KEEP(52)
            ENDIF   
            WRITE (LP,993) KEEP(12)
+           WRITE (LP,996) KEEP(19), KEEP(118)
+           WRITE (LP,994) KEEP(21)
          CASE(6);
            WRITE (LP,980)
            WRITE (LP,990) ICNTL(1),ICNTL(2),ICNTL(3),ICNTL(4)
@@ -2494,8 +2568,11 @@ C---------------------------------------
               WRITE (LP,992) KEEP(52)
            ENDIF   
            WRITE (LP,995)
-     &     ICNTL(9),ICNTL(10),ICNTL(11),KEEP(248),ICNTL(21)
+     &     ICNTL(9),ICNTL(10),ICNTL(11),KEEP(248),ICNTL(21), ICNTL(26)
            WRITE (LP,993) KEEP(12)
+           WRITE (LP,997) KEEP(53)
+           WRITE (LP,996) KEEP(19), KEEP(118)
+           WRITE (LP,994) KEEP(21)
         END SELECT
       ENDIF
  980  FORMAT (/'******INTERNAL VALUE OF PARAMETERS (ICNTL/KEEP)****'/)
@@ -2522,7 +2599,15 @@ C---------------------------------------
      &     'ICNTL(10)  Max steps iterative refinement          =',I10/
      &     'ICNTL(11)  Error analysis ( 0= off, else=on)       =',I10/
      &     'ICNTL(20)  Den.(0)/sparse(1,2,3)/dist.(10,11) RHS  =',I10/
-     &     'ICNTL(21)  Gathered (0) or distributed(1) solution =',I10)
+     &     'ICNTL(21)  Gathered (0) or distributed(1) solution =',I10/
+     &     'ICNTL(26)  Solution step                           =',I10)
+ 997  FORMAT (
+     &     'ICNTL(56)  Null space-analysis      ( keep(53) )   =',I10) 
+ 996  FORMAT (
+     &     'ICNTL(56)  Null space-factorisation ( keep(19) )   =',I10/ 
+     &     'KEEP(118)  Algorithm used for null space           =',I10) 
+ 994  FORMAT (
+     &     'ICNTL(57)  Estimate of null space size ( keep(21) )=',I10)
       END SUBROUTINE DMUMPS_PRINT_KEEP
       SUBROUTINE DMUMPS_CHECK_DENSE_RHS
      &       (idRHS, idINFO, idN, idNRHS, idLRHS)
@@ -2581,7 +2666,7 @@ C           perform the check if minimal
       RETURN
       END SUBROUTINE DMUMPS_CHECK_DENSE_RHS
 C
-      SUBROUTINE DMUMPS_SET_K221(id)
+      SUBROUTINE DMUMPS_SET_K221(id,ATSOLVE)
       USE DMUMPS_STRUC_DEF
       IMPLICIT NONE
 C
@@ -2589,21 +2674,30 @@ C     Purpose:
 C     =======
 C
 C     Sets KEEP(221) on master.
-C     Constraint: must be called before DMUMPS_CHECK_REDRHS.
-C     Can be called at factorization or solve phase
+C     [Schur only] must be called before DMUMPS_CHECK_REDRHS 
+C       
+C     Can be called at factorization 
+C     (in case of fwd in facto) or at solve phase
+C     ATSOLVE=.TRUE. if called during solve phase
 C
       TYPE (DMUMPS_STRUC) :: id
+      LOGICAL, INTENT(IN) :: ATSOLVE 
+      LOGICAL :: PROKG
+      INTEGER :: MPG
       INTEGER MASTER
       PARAMETER( MASTER = 0 )
+      MPG = id%ICNTL( 3 )
+      PROKG = ( MPG .GT. 0 .and. id%MYID .eq. MASTER )
+      PROKG = (PROKG.AND.(id%ICNTL(4).GE.2))
       IF (id%MYID.EQ.MASTER) THEN
         id%KEEP(221)=id%ICNTL(26)
-        IF (id%KEEP(221).ne.0 .and. id%KEEP(221) .NE.1
-     &      .AND.id%KEEP(221).ne.2) id%KEEP(221)=0
+        IF (id%KEEP(221).NE.0 .AND. id%KEEP(221) .NE.1
+     &      .AND.id%KEEP(221).NE.2) id%KEEP(221)=0
       ENDIF
       RETURN
       END SUBROUTINE DMUMPS_SET_K221
 C
-      SUBROUTINE DMUMPS_CHECK_REDRHS(id)
+      SUBROUTINE DMUMPS_CHECK_K221andREDRHS(id)
       USE DMUMPS_STRUC_DEF
       IMPLICIT NONE
 C
@@ -2616,17 +2710,22 @@ C  * Constraints:
 C    - Must be called after solve phase.
 C    - KEEP(60) must have been set (ok to check
 C    since KEEP(60) was set during analysis phase)
-C  * Remark that during solve phase, ICNTL(26)=1 is
+C  * Remark that during solve phase, ICNTL(26)#0 is
 C    forbidden in case of fwd in facto.
 C
       TYPE (DMUMPS_STRUC) :: id
       INTEGER MASTER
       PARAMETER( MASTER = 0 )
+C     write(6,*) " Entering DMUMPS_CHECK_K221andREDRHS with : ", 
+C    & " id%JOB, id%KEEP(221), id%KEEP(60), id%SIZE_SCHUR= ", 
+C    & id%JOB, id%KEEP(221), id%KEEP(60), id%SIZE_SCHUR
       IF (id%MYID .EQ. MASTER) THEN
           IF ( id%KEEP(221) == 1 .or. id%KEEP(221) == 2 ) THEN
-            IF (id%KEEP(221) == 2 .and. id%JOB == 2) THEN
-              id%INFO(1)=-35
-              id%INFO(2)=id%KEEP(221)
+            IF (id%KEEP(221) == 2 .and. 
+     &                ( id%JOB .NE.3 )
+     &         ) THEN
+              id%INFO(1)=-33
+              id%INFO(2)=id%JOB
               GOTO 333
             ENDIF
             IF (id%KEEP(221) == 1 .and. id%KEEP(252) == 1
@@ -2637,29 +2736,39 @@ C
             IF ( id%KEEP(60).eq. 0 .or. id%SIZE_SCHUR.EQ.0 ) THEN
               id%INFO(1)=-33
               id%INFO(2)=id%KEEP(221)
+C              write(6,*) " id%KEEP(60), id%SIZE_SCHUR=", 
+C     &            id%KEEP(60), id%SIZE_SCHUR
               GOTO 333
             ENDIF
-            IF ( .NOT. associated( id%REDRHS)) THEN
-              id%INFO(1)=-22
-              id%INFO(2)=15
-              GOTO 333
-            ELSE IF (id%NRHS.EQ.1) THEN
-              IF (size(id%REDRHS) < id%SIZE_SCHUR ) THEN
+            IF ( id%KEEP(60).NE.0 ) THEN
+C           Schur feature
+              IF ( id%SIZE_SCHUR.EQ.0 ) THEN
+                id%INFO(1)=-33
+                id%INFO(2)=id%KEEP(221)
+                GOTO 333
+              ENDIF
+              IF ( .NOT. associated( id%REDRHS)) THEN
+                id%INFO(1)=-22
+                id%INFO(2)=15
+                GOTO 333
+              ELSE IF (id%NRHS.EQ.1) THEN
+                IF (size(id%REDRHS) < id%SIZE_SCHUR ) THEN
+                  id%INFO(1)=-22
+                  id%INFO(2)=15
+                  GOTO 333
+                ENDIF
+              ELSE IF (id%LREDRHS < id%SIZE_SCHUR) THEN
+                id%INFO(1)=-34
+                id%INFO(2)=id%LREDRHS
+                GOTO 333
+              ELSE IF
+     &        (size(id%REDRHS)<
+     &           id%NRHS*id%LREDRHS-id%LREDRHS+id%SIZE_SCHUR)
+     &        THEN
                 id%INFO(1)=-22
                 id%INFO(2)=15
                 GOTO 333
               ENDIF
-            ELSE IF (id%LREDRHS < id%SIZE_SCHUR) THEN
-              id%INFO(1)=-34
-              id%INFO(2)=id%LREDRHS
-              GOTO 333
-            ELSE IF
-     &      (size(id%REDRHS)<
-     &         id%NRHS*id%LREDRHS-id%LREDRHS+id%SIZE_SCHUR)
-     &      THEN
-              id%INFO(1)=-22
-              id%INFO(2)=15
-              GOTO 333
             ENDIF
           ENDIF
       ENDIF
@@ -2668,4 +2777,4 @@ C     Error is not propagated. It should
 C     The reason to propagate it outside is that there can be
 C     one call to PROPINFO instead of several ones.
       RETURN
-      END SUBROUTINE DMUMPS_CHECK_REDRHS
+      END SUBROUTINE DMUMPS_CHECK_K221andREDRHS
diff -pruN 5.6.2-2.1/src/dmumps_f77.F 5.7.1-1/src/dmumps_f77.F
--- 5.6.2-2.1/src/dmumps_f77.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/dmumps_f77.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -16,8 +16,9 @@ C
      &     JCNhere, A, Ahere, NZ_loc, NNZ_loc, IRN_loc, IRN_lochere,
      &     JCN_loc, JCN_lochere, A_loc, A_lochere, NELT, ELTPTR,
      &     ELTPTRhere,  ELTVAR, ELTVARhere, A_ELT, A_ELThere,
-     &     BLKPTR, BLKPTRhere, BLKVAR, BLKVARhere,
-     &     PERM_IN, PERM_INhere, RHS, RHShere, REDRHS, REDRHShere,
+     &     BLKPTR, BLKPTRhere, BLKVAR, BLKVARhere, PERM_IN, PERM_INhere,
+     &     ROWIND, ROWINDhere, COLIND, COLINDhere, PIVOTS, PIVOTShere,
+     &     RHS, RHShere, REDRHS, REDRHShere,
      &     INFO, RINFO, INFOG, RINFOG, DEFICIENCY, LWK_USER,
      &     SIZE_SCHUR, LISTVAR_SCHUR, LISTVAR_SCHURhere, SCHUR,
      &     SCHURhere, WK_USER, WK_USERhere, COLSCA, COLSCAhere,
@@ -26,31 +27,38 @@ C
      &     RHS_loc, RHS_lochere,
      &     IRHS_SPARSE, IRHS_SPARSEhere, IRHS_PTR, IRHS_PTRhere,
      &     ISOL_loc, ISOL_lochere, IRHS_loc, IRHS_lochere, NZ_RHS,
-     &     LSOL_loc, LRHS_loc, Nloc_RHS,
+     &     LSOL_loc, LRHS_loc, NSOL_loc, Nloc_RHS,
      &     SCHUR_MLOC, SCHUR_NLOC, SCHUR_LLD,
-     &     MBLOCK, NBLOCK, NPROW, NPCOL,  
+     &     MBLOCK, NBLOCK, NPROW, NPCOL, LD_RHSINTR,
      &     OOC_TMPDIR, OOC_PREFIX, WRITE_PROBLEM,
+#if ! defined(NO_SAVE_RESTORE)
      &     SAVE_DIR, SAVE_PREFIX,
+#endif
      &     TMPDIRLEN, PREFIXLEN, WRITE_PROBLEMLEN,
+#if ! defined(NO_SAVE_RESTORE)
      &     SAVE_DIRLEN, SAVE_PREFIXLEN,
+#endif
      &     METIS_OPTIONS
      &     )
       USE DMUMPS_STRUC_DEF
       IMPLICIT NONE
       INTEGER OOC_PREFIX_MAX_LENGTH, OOC_TMPDIR_MAX_LENGTH
       INTEGER PB_MAX_LENGTH
-      PARAMETER(OOC_PREFIX_MAX_LENGTH=63, OOC_TMPDIR_MAX_LENGTH=255)
-      PARAMETER(PB_MAX_LENGTH=255)
-      INTEGER, PARAMETER :: SAVE_DIR_MAX_LENGTH    = 255
+      PARAMETER(OOC_PREFIX_MAX_LENGTH=255, OOC_TMPDIR_MAX_LENGTH=1023)
+      PARAMETER(PB_MAX_LENGTH=1023)
+#if ! defined(NO_SAVE_RESTORE)
+      INTEGER, PARAMETER :: SAVE_DIR_MAX_LENGTH    = 1023
       INTEGER, PARAMETER :: SAVE_PREFIX_MAX_LENGTH = 255
+#endif
       INTEGER JOB, SYM, PAR, COMM_F77, N, NBLK, NZ, NZ_loc, NELT,
      &        DEFICIENCY, LWK_USER, SIZE_SCHUR, INSTANCE_NUMBER,
      &        NRHS, LRHS,
-     &        NZ_RHS, LSOL_loc,Nloc_RHS, LRHS_loc, LREDRHS
+     &        NZ_RHS, LSOL_loc,Nloc_RHS, LRHS_loc, NSOL_loc, LREDRHS
       INTEGER(8) :: NNZ, NNZ_loc
       INTEGER ICNTL(60), INFO(80), INFOG(80), KEEP(500)
       INTEGER SCHUR_MLOC, SCHUR_NLOC, SCHUR_LLD
       INTEGER MBLOCK, NBLOCK, NPROW, NPCOL
+      INTEGER LD_RHSINTR
       INTEGER TMPDIRLEN, PREFIXLEN, WRITE_PROBLEMLEN
       DOUBLE PRECISION CNTL(15), RINFO(40), RINFOG(40), DKEEP(230)
       INTEGER(8) KEEP8(150)
@@ -61,6 +69,8 @@ C
       INTEGER, TARGET :: ISOL_loc(*), IRHS_loc(*)
       INTEGER, TARGET :: BLKPTR(*), BLKVAR(*)
       DOUBLE PRECISION, TARGET :: A(*), A_ELT(*), A_loc(*), RHS(*)
+      INTEGER, TARGET :: ROWIND(*), COLIND(*)
+      DOUBLE PRECISION, TARGET :: PIVOTS(*)
       DOUBLE PRECISION, TARGET :: WK_USER(*)
       DOUBLE PRECISION, TARGET :: REDRHS(*)
       DOUBLE PRECISION, TARGET :: ROWSCA(*), COLSCA(*)
@@ -69,13 +79,15 @@ C
       INTEGER, INTENT(inout) :: OOC_TMPDIR(OOC_TMPDIR_MAX_LENGTH)
       INTEGER, INTENT(inout) :: OOC_PREFIX(OOC_PREFIX_MAX_LENGTH)
       INTEGER, INTENT(in) :: WRITE_PROBLEM(PB_MAX_LENGTH)
+#if ! defined(NO_SAVE_RESTORE)
       INTEGER SAVE_DIRLEN, SAVE_PREFIXLEN
       INTEGER, INTENT(in) :: SAVE_DIR(SAVE_DIR_MAX_LENGTH)
       INTEGER, INTENT(in) :: SAVE_PREFIX(SAVE_PREFIX_MAX_LENGTH)
+#endif
       INTEGER METIS_OPTIONS(40)
       INTEGER IRNhere, JCNhere, Ahere, ELTPTRhere, ELTVARhere,
      &        A_ELThere, BLKPTRhere, BLKVARhere, PERM_INhere,
-     &        WK_USERhere,
+     &        WK_USERhere, ROWINDhere, COLINDhere, PIVOTShere,
      &        RHShere, REDRHShere, IRN_lochere,
      &        JCN_lochere, A_lochere, LISTVAR_SCHURhere,
      &        SCHURhere, COLSCAhere, ROWSCAhere, RHS_SPARSEhere,
@@ -99,9 +111,27 @@ C
       EXTERNAL MUMPS_ASSIGN_MAPPING,
      &         MUMPS_ASSIGN_PIVNUL_LIST,
      &         MUMPS_ASSIGN_SYM_PERM,
-     &         MUMPS_ASSIGN_UNS_PERM
+     &         MUMPS_ASSIGN_UNS_PERM,
+     &         MUMPS_ASSIGN_GLOB2LOC_RHS,
+     &         MUMPS_ASSIGN_GLOB2LOC_SOL
+      EXTERNAL MUMPS_NULLIFY_C_MAPPING,
+     &         MUMPS_NULLIFY_C_PIVNUL_LIST,
+     &         MUMPS_NULLIFY_C_SYM_PERM,
+     &         MUMPS_NULLIFY_C_UNS_PERM,
+     &         MUMPS_NULLIFY_C_GLOB2LOC_RHS,
+     &         MUMPS_NULLIFY_C_GLOB2LOC_SOL
       EXTERNAL DMUMPS_ASSIGN_COLSCA,
-     &         DMUMPS_ASSIGN_ROWSCA
+     &         DMUMPS_ASSIGN_ROWSCA,
+     &         DMUMPS_ASSIGN_ROWSCA_LOC,
+     &         DMUMPS_ASSIGN_COLSCA_LOC,
+     &         DMUMPS_ASSIGN_RHSINTR,
+     &         DMUMPS_ASSIGN_SINGULAR_VALUES
+      EXTERNAL DMUMPS_NULLIFY_C_COLSCA,
+     &         DMUMPS_NULLIFY_C_ROWSCA,
+     &         DMUMPS_NULLIFY_C_ROWSCA_LOC,
+     &         DMUMPS_NULLIFY_C_COLSCA_LOC,
+     &         DMUMPS_NULLIFY_C_RHSINTR,
+     &         DMUMPS_NULLIFY_C_SING_VALUES
       IF (JOB == -1) THEN
         DO I = 1, DMUMPS_STRUC_ARRAY_SIZE
           IF ( .NOT. associated(mumps_par_array(I)%PTR) ) GOTO 10
@@ -175,20 +205,22 @@ C
       CALL MUMPS_ADDR_C( ICNTL(50), mumps_par%KEEP8(83) )
       CALL MUMPS_ADDR_C( RINFO(3), mumps_par%KEEP8(84) )
       mumps_par%METIS_OPTIONS(1:40)=METIS_OPTIONS(1:40)
-      mumps_par%NRHS  = NRHS
-      mumps_par%LRHS  = LRHS
-      mumps_par%LREDRHS = LREDRHS
-      mumps_par%NZ_RHS   = NZ_RHS
-      mumps_par%LSOL_loc = LSOL_loc
-      mumps_par%Nloc_RHS = Nloc_RHS
-      mumps_par%LRHS_loc = LRHS_loc
+      mumps_par%NRHS         = NRHS
+      mumps_par%LRHS         = LRHS
+      mumps_par%LREDRHS      = LREDRHS
+      mumps_par%NZ_RHS       = NZ_RHS
+      mumps_par%LSOL_loc     = LSOL_loc
+      mumps_par%Nloc_RHS     = Nloc_RHS
+      mumps_par%LRHS_loc     = LRHS_loc
+      mumps_par%NSOL_loc     = NSOL_loc
       mumps_par%SCHUR_MLOC   = SCHUR_MLOC
       mumps_par%SCHUR_NLOC   = SCHUR_NLOC
       mumps_par%SCHUR_LLD    = SCHUR_LLD
-      mumps_par%MBLOCK = MBLOCK
-      mumps_par%NBLOCK = NBLOCK
-      mumps_par%NPROW  = NPROW
-      mumps_par%NPCOL  = NPCOL
+      mumps_par%MBLOCK       = MBLOCK
+      mumps_par%NBLOCK       = NBLOCK
+      mumps_par%NPROW        = NPROW
+      mumps_par%NPCOL        = NPCOL
+      mumps_par%LD_RHSINTR   = LD_RHSINTR
       IF ( COMM_F77 .NE. -987654 ) THEN
         mumps_par%COMM = COMM_F77
       ELSE
@@ -226,6 +258,20 @@ C
       IF ( SCHURhere /= 0 ) THEN
         mumps_par%SCHUR_CINTERFACE=>SCHUR(1:1)
       ENDIF
+      IF (ROWINDhere /= 0) THEN
+        mumps_par%ROWIND => ROWIND(1:KEEP(89))
+      ENDIF
+      IF (COLINDhere /= 0) THEN
+        mumps_par%COLIND => COLIND(1:KEEP(89))
+      ENDIF
+      IF (PIVOTShere /= 0) THEN
+        IF (KEEP(50) .EQ.0 .OR.KEEP(50).EQ.1) THEN
+          mumps_par%PIVOTS => PIVOTS(1:KEEP(89))
+        ELSE
+          mumps_par%PIVOTS => PIVOTS(1_8:
+     &                        int(KEEP(89),8)+int(KEEP(89),8))
+        ENDIF
+      ENDIF
       IF (NRHS .NE. 1) THEN
         IF ( RHShere /= 0 ) mumps_par%RHS =>
      &                      RHS(1_8:int(NRHS,8)*int(LRHS,8))
@@ -276,6 +322,7 @@ C
       DO I=WRITE_PROBLEMLEN+1,PB_MAX_LENGTH
         mumps_par%WRITE_PROBLEM(I:I)=' '
       ENDDO
+#if ! defined(NO_SAVE_RESTORE)
       DO I=1,SAVE_DIRLEN
         mumps_par%SAVE_DIR(I:I)=char(SAVE_DIR(I))
       ENDDO
@@ -288,6 +335,7 @@ C
       DO I=SAVE_PREFIXLEN+1,SAVE_PREFIX_MAX_LENGTH
         mumps_par%SAVE_PREFIX(I:I)=' '
       ENDDO
+#endif
       CALL DMUMPS( mumps_par )
       INFO(1:80)=mumps_par%INFO(1:80)
       INFOG(1:80)=mumps_par%INFOG(1:80)
@@ -315,6 +363,7 @@ C
       LSOL_loc   = mumps_par%LSOL_loc
       Nloc_RHS   = mumps_par%Nloc_RHS
       LRHS_loc   = mumps_par%LRHS_loc
+      NSOL_loc   = mumps_par%NSOL_loc
       SIZE_SCHUR = mumps_par%SIZE_SCHUR
       LWK_USER   = mumps_par%LWK_USER
       NELT       = mumps_par%NELT
@@ -326,6 +375,7 @@ C
       NBLOCK     = mumps_par%NBLOCK
       NPROW      = mumps_par%NPROW
       NPCOL      = mumps_par%NPCOL
+      LD_RHSINTR = mumps_par%LD_RHSINTR
       IF ( associated (mumps_par%MAPPING) ) THEN
          CALL MUMPS_ASSIGN_MAPPING(mumps_par%MAPPING(1))
       ELSE
@@ -336,6 +386,12 @@ C
       ELSE
          CALL MUMPS_NULLIFY_C_PIVNUL_LIST()
       ENDIF
+      IF ( associated (mumps_par%SINGULAR_VALUES) ) THEN
+         CALL DMUMPS_ASSIGN_SINGULAR_VALUES(
+     &                  mumps_par%SINGULAR_VALUES(1))
+      ELSE
+         CALL DMUMPS_NULLIFY_C_SING_VALUES()
+      ENDIF
       IF ( associated (mumps_par%SYM_PERM) ) THEN
          CALL MUMPS_ASSIGN_SYM_PERM(mumps_par%SYM_PERM(1))
       ELSE
@@ -346,22 +402,47 @@ C
       ELSE
          CALL MUMPS_NULLIFY_C_UNS_PERM()
       ENDIF
-      IF (associated( mumps_par%COLSCA)) THEN
+      IF ( associated (mumps_par%COLSCA_loc) ) THEN
+         CALL DMUMPS_ASSIGN_COLSCA_LOC(1)
+      ELSE
+         CALL DMUMPS_NULLIFY_C_COLSCA_LOC()
+      ENDIF
+      IF ( associated (mumps_par%ROWSCA_loc) ) THEN
+         CALL DMUMPS_ASSIGN_ROWSCA_LOC(1)
+      ELSE
+         CALL DMUMPS_NULLIFY_C_ROWSCA_LOC()
+      ENDIF
+      IF (associated( mumps_par%COLSCA )) THEN
           CALL DMUMPS_ASSIGN_COLSCA(mumps_par%COLSCA(1))
       ELSE
           CALL DMUMPS_NULLIFY_C_COLSCA()
       ENDIF
-      IF (associated( mumps_par%ROWSCA)) THEN
+      IF (associated( mumps_par%ROWSCA )) THEN
           CALL DMUMPS_ASSIGN_ROWSCA(mumps_par%ROWSCA(1))
       ELSE
           CALL DMUMPS_NULLIFY_C_ROWSCA()
       ENDIF
+      IF (associated( mumps_par%RHSINTR )) THEN
+          CALL DMUMPS_ASSIGN_RHSINTR(mumps_par%RHSINTR(1))
+      ELSE
+          CALL DMUMPS_NULLIFY_C_RHSINTR()
+      ENDIF
+      IF (associated(mumps_par%GLOB2LOC_RHS)) THEN
+          CALL MUMPS_ASSIGN_GLOB2LOC_RHS(mumps_par%GLOB2LOC_RHS(1))
+      ELSE
+          CALL MUMPS_NULLIFY_C_GLOB2LOC_RHS()
+      ENDIF
+      IF (associated(mumps_par%GLOB2LOC_SOL)) THEN
+          CALL MUMPS_ASSIGN_GLOB2LOC_SOL(mumps_par%GLOB2LOC_SOL(1))
+      ELSE
+          CALL MUMPS_NULLIFY_C_GLOB2LOC_SOL()
+      ENDIF
       TMPDIRLEN=len_trim(mumps_par%OOC_TMPDIR)
-      DO I=1,OOC_TMPDIR_MAX_LENGTH
+      DO I=1,TMPDIRLEN
          OOC_TMPDIR(I)=ichar(mumps_par%OOC_TMPDIR(I:I))
       ENDDO
       PREFIXLEN=len_trim(mumps_par%OOC_PREFIX)
-      DO I=1,OOC_PREFIX_MAX_LENGTH
+      DO I=1,PREFIXLEN
          OOC_PREFIX(I)=ichar(mumps_par%OOC_PREFIX(I:I))
       ENDDO
       IF ( JOB == -2 ) THEN
diff -pruN 5.6.2-2.1/src/dmumps_gpu.c 5.7.1-1/src/dmumps_gpu.c
--- 5.6.2-2.1/src/dmumps_gpu.c	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/dmumps_gpu.c	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/dmumps_gpu.h 5.7.1-1/src/dmumps_gpu.h
--- 5.6.2-2.1/src/dmumps_gpu.h	2023-10-11 09:36:34.000000000 +0000
+++ 5.7.1-1/src/dmumps_gpu.h	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/dmumps_iXamax.F 5.7.1-1/src/dmumps_iXamax.F
--- 5.6.2-2.1/src/dmumps_iXamax.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/dmumps_iXamax.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/dmumps_load.F 5.7.1-1/src/dmumps_load.F
--- 5.6.2-2.1/src/dmumps_load.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dmumps_load.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -793,7 +793,7 @@ C
          CALL DMUMPS_BUF_BROADCAST( WHAT,
      &        COMM_LD, NPROCS,
      &        FUTURE_NIV2,
-     &        dble(MEMORY_MD),dble(0) ,MYID, id%KEEP, IERR  )
+     &        dble(MEMORY_MD),dble(0) ,MYID, id%KEEP(267), IERR )
          WHAT=9
          MEMORY_SENT = dble(LA-MAX_SURF_MASTER)-MAX_SBTR
      &      - max( dble(LA) * dble(3) / dble(100),
@@ -811,7 +811,7 @@ C
      &        COMM_LD, NPROCS,
      &        FUTURE_NIV2,
      &        MEMORY_SENT,
-     &        dble(0),MYID, id%KEEP, IERR  )
+     &        dble(0),MYID, id%KEEP(267), IERR  )
       ENDIF
       RETURN
       END SUBROUTINE DMUMPS_LOAD_INIT
@@ -1907,7 +1907,7 @@ C
         CALL DMUMPS_BUF_BROADCAST( WHAT,
      &         COMM, SLAVEF,
      &               FUTURE_NIV2,
-     &         COST, dble(0), MYID, KEEP, IERR  )
+     &         COST, dble(0), MYID, KEEP(267), IERR  )
         POOL_LAST_COST_SENT = COST
         POOL_MEM(MYID)=COST
         IF ( IERR == -1 )THEN
@@ -1970,7 +1970,7 @@ C
      &           WHAT, COMM, SLAVEF,
      &           FUTURE_NIV2,
      &           dble(MEM_SUBTREE(INDICE_SBTR)), dble(0),
-     &           MYID, KEEP, IERR  )
+     &           MYID, KEEP(267), IERR  )
             IF ( IERR == -1 )THEN
                CALL DMUMPS_LOAD_RECV_MSGS(COMM_LD)
                CALL MUMPS_CHECK_COMM_NODES(COMM_NODES, EXIT_FLAG)
@@ -2000,7 +2000,7 @@ C
                CALL DMUMPS_BUF_BROADCAST(
      &              WHAT, COMM, SLAVEF,
      &              FUTURE_NIV2,
-     &              COST, dble(0), MYID, KEEP, IERR  )
+     &              COST, dble(0), MYID, KEEP(267), IERR  )
                IF ( IERR == -1 )THEN
                   CALL DMUMPS_LOAD_RECV_MSGS(COMM_LD)
                   CALL MUMPS_CHECK_COMM_NODES(COMM_NODES, EXIT_FLAG)
@@ -4648,10 +4648,8 @@ C
       INTEGER J
       DOUBLE PRECISION MEM_COST
       INTEGER NBINSUBTREE,i,NBTOP
-      EXTERNAL DMUMPS_POOL_EMPTY,
-     & MUMPS_IN_OR_ROOT_SSARBR
-      LOGICAL DMUMPS_POOL_EMPTY,
-     & MUMPS_IN_OR_ROOT_SSARBR
+      EXTERNAL MUMPS_IN_OR_ROOT_SSARBR
+      LOGICAL MUMPS_IN_OR_ROOT_SSARBR
       NBINSUBTREE = POOL(LPOOL)
       NBTOP       = POOL(LPOOL - 1)
       IF(KEEP(47).LT.2)THEN
@@ -4755,8 +4753,6 @@ C
       LOGICAL FLAG, EXIT_FLAG
       DOUBLE PRECISION COST
       DOUBLE PRECISION TO_BE_SENT
-      EXTERNAL MUMPS_TYPENODE
-      INTEGER MUMPS_TYPENODE
       IF(FLAG)THEN
          WHAT=17 
          IF(BDC_M2_FLOPS)THEN
@@ -4783,7 +4779,7 @@ C
      &               FUTURE_NIV2,
      &         COST, 
      &         TO_BE_SENT, 
-     &         MYID, KEEP_LOAD, IERR  )
+     &         MYID, KEEP_LOAD(267), IERR  )
       IF ( IERR == -1 )THEN
          CALL DMUMPS_LOAD_RECV_MSGS(COMM_LD)
          CALL MUMPS_CHECK_COMM_NODES(COMM_NODES, EXIT_FLAG)
@@ -4946,8 +4942,6 @@ C
       RECURSIVE SUBROUTINE DMUMPS_PROCESS_NIV2_MEM_MSG(INODE)
       IMPLICIT NONE
       INTEGER INODE
-      EXTERNAL MUMPS_TYPENODE
-      INTEGER MUMPS_TYPENODE
       IF((INODE.EQ.KEEP_LOAD(20)).OR.
      &     (INODE.EQ.KEEP_LOAD(38)))THEN
          RETURN
@@ -4985,8 +4979,6 @@ C
       RECURSIVE SUBROUTINE DMUMPS_PROCESS_NIV2_FLOPS_MSG(INODE)
       IMPLICIT NONE
       INTEGER INODE
-      EXTERNAL MUMPS_TYPENODE
-      INTEGER MUMPS_TYPENODE
       IF((INODE.EQ.KEEP_LOAD(20)).OR.
      &     (INODE.EQ.KEEP_LOAD(38)))THEN
          RETURN
diff -pruN 5.6.2-2.1/src/dmumps_lr_data_m.F 5.7.1-1/src/dmumps_lr_data_m.F
--- 5.6.2-2.1/src/dmumps_lr_data_m.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dmumps_lr_data_m.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -35,7 +35,9 @@ C
      &  , BLR_STRUC_T, blr_panel_type, diag_block_type
 #endif
      &  , DMUMPS_BLR_SAVE_DIAG_BLOCK, DMUMPS_BLR_RETRIEVE_DIAG_BLOCK
+#if ! defined(NO_SAVE_RESTORE)
      &  , DMUMPS_SAVE_RESTORE_BLR
+#endif      
       TYPE blr_panel_type
          integer                 :: NB_ACCESSES_LEFT
          type(LRB_TYPE), pointer :: LRB_PANEL(:)
@@ -68,6 +70,9 @@ C
      &           PANELS_NOTUSED=-1111, PANELS_FREED=-2222, 
      &           NB_PANELS_NOTINIT=-3333, 
      &           NFS4FATHER_NOTINIT=-4444 )
+#if ! defined(NO_SAVE_RESTORE)
+      INCLUDE 'mumps_save_restore_modes.h'
+#endif
       CONTAINS
       SUBROUTINE DMUMPS_BLR_INIT_MODULE(INITIAL_SIZE, INFO)
        INTEGER, INTENT(IN) :: INITIAL_SIZE
@@ -1062,6 +1067,7 @@ C
        ENDIF
        RETURN
        END SUBROUTINE DMUMPS_BLR_FREE_ALL_PANELS
+#if ! defined(NO_SAVE_RESTORE)
       SUBROUTINE DMUMPS_SAVE_RESTORE_BLR(id_BLRARRAY_ENCODING
      &                 ,unit,MYID,mode
      &                 ,SIZE_GEST,SIZE_VARIABLES
@@ -1072,7 +1078,7 @@ C
       INCLUDE 'mpif.h'
       CHARACTER, DIMENSION(:), POINTER :: id_BLRARRAY_ENCODING
       INTEGER,intent(IN)::unit,MYID
-      CHARACTER(len=*),intent(IN) :: mode
+      INTEGER,intent(IN) :: mode
       INTEGER,INTENT(OUT) :: SIZE_GEST
       INTEGER(8),intent(OUT) :: SIZE_VARIABLES
       INTEGER(8),intent(IN) :: TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
@@ -1090,10 +1096,10 @@ C
       SIZE_VARIABLES_BLR_ARRAY_j1=0_8
       SIZE_GEST=0
       SIZE_VARIABLES=0_8
-      if((trim(mode).EQ."memory_save").OR.(trim(mode).EQ."save")) then
+      if(mode.EQ.memory_save_mode.OR.mode.EQ.save_mode) then
          call DMUMPS_BLR_STRUC_TO_MOD(id_BLRARRAY_ENCODING)
       endif
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          IF(associated(BLR_ARRAY)) THEN
             NbRecords=1
             SIZE_GEST=SIZE_INT
@@ -1101,7 +1107,7 @@ C
             DO j1=1,size(BLR_ARRAY,1)
                CALL DMUMPS_SAVE_RESTORE_BLR_STRUC(
      &              BLR_ARRAY(j1)
-     &              ,unit,MYID,"memory_save"
+     &              ,unit,MYID,memory_save_mode
      &              ,SIZE_GEST_BLR_ARRAY_j1
      &              ,SIZE_VARIABLES_BLR_ARRAY_j1
      &              ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -1118,7 +1124,7 @@ C
             SIZE_GEST=SIZE_INT*2
             SIZE_VARIABLES=0
          ENDIF
-      elseif(trim(mode).EQ."save") then
+      elseif(mode.EQ.save_mode) then
          IF(associated(BLR_ARRAY)) THEN
             NbRecords=1
             SIZE_GEST=SIZE_INT
@@ -1133,7 +1139,7 @@ C
             DO j1=1,size(BLR_ARRAY,1)
                CALL DMUMPS_SAVE_RESTORE_BLR_STRUC(
      &              BLR_ARRAY(j1)
-     &              ,unit,MYID,"save"
+     &              ,unit,MYID,save_mode
      &              ,SIZE_GEST_BLR_ARRAY_j1
      &              ,SIZE_VARIABLES_BLR_ARRAY_j1
      &              ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -1161,7 +1167,7 @@ C
             endif
             IF ( INFO(1) .LT. 0 ) GOTO 100
          ENDIF 
-      elseif(trim(mode).EQ."restore") then
+      elseif(mode.EQ.restore_mode) then
          nullify(BLR_ARRAY)
          read(unit,iostat=err) size_array1
          if(err.ne.0) THEN
@@ -1195,7 +1201,7 @@ C
             DO j1=1,size_array1
                CALL DMUMPS_SAVE_RESTORE_BLR_STRUC(
      &              BLR_ARRAY(j1)
-     &              ,unit,MYID,"restore"
+     &              ,unit,MYID,restore_mode
      &              ,SIZE_GEST_BLR_ARRAY_j1
      &              ,SIZE_VARIABLES_BLR_ARRAY_j1
      &              ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -1209,19 +1215,19 @@ C
             ENDDO
          endif
       endif
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          NbSubRecords=int(SIZE_VARIABLES/huge(I4))
          IF(NbSubRecords.GT.0) then
             NbRecords=NbRecords+NbSubRecords
          ENDIF
-      elseif(trim(mode).EQ."save") then
+      elseif(mode.EQ.save_mode) then
          size_written=size_written+SIZE_VARIABLES
      &        +int(SIZE_GEST,kind=8)
 #if defined(MUMPS_NOF2003)
          size_written=size_written
      &        +int(2*SIZE_INT*NbRecords,kind=8)
 #endif
-      elseif(trim(mode).EQ."restore") then
+      elseif(mode.EQ.restore_mode) then
          size_allocated=size_allocated+SIZE_VARIABLES
          size_read=size_read+SIZE_VARIABLES
      &        +int(SIZE_GEST,kind=8)
@@ -1230,7 +1236,7 @@ C
      &        +int(2*SIZE_INT*NbRecords,kind=8)
 #endif
       endif
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          SIZE_VARIABLES=SIZE_VARIABLES+SIZE_VARIABLES_BLR_ARRAY
          SIZE_GEST=SIZE_GEST+SIZE_GEST_BLR_ARRAY
 #if defined(MUMPS_NOF2003)
@@ -1251,18 +1257,29 @@ C
       INCLUDE 'mpif.h'
       TYPE(BLR_STRUC_T) :: BLR_STRUC
       INTEGER,intent(IN)::unit,MYID
-      CHARACTER(len=*),intent(IN) :: mode
+      INTEGER,intent(IN) :: mode
       INTEGER,INTENT(OUT) :: Local_SIZE_GEST
       INTEGER(8),intent(OUT) :: Local_SIZE_VARIABLES
       INTEGER,intent(INOUT):: INFO(2)
       INTEGER,intent(IN):: SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
       INTEGER(8),intent(IN) :: TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
       INTEGER(8),intent(INOUT):: size_read,size_allocated,size_written
-      INTEGER :: NBVARIABLES_BLR_STRUC_T
-      PARAMETER (NBVARIABLES_BLR_STRUC_T = 15)
-      CHARACTER(len=30), dimension(NBVARIABLES_BLR_STRUC_T)::
-     &     VARIABLES_BLR_STRUC_T
-      CHARACTER(len=30) :: TMP_STRING
+      INTEGER, PARAMETER :: NBVARIABLES_BLR_STRUC_T = 15
+      INTEGER, PARAMETER :: B_IsSYM=1
+      INTEGER, PARAMETER :: B_IsT2=2
+      INTEGER, PARAMETER :: B_IsSLAVE=3
+      INTEGER, PARAMETER :: B_PANELS_L=4
+      INTEGER, PARAMETER :: B_PANELS_U=5
+      INTEGER, PARAMETER :: B_CB_LRB=6
+      INTEGER, PARAMETER :: B_DIAG_BLOCKS=7
+      INTEGER, PARAMETER :: B_BEGS_BLR_STATIC=8
+      INTEGER, PARAMETER :: B_BEGS_BLR_DYNAMIC=9
+      INTEGER, PARAMETER :: B_BEGS_BLR_L=10
+      INTEGER, PARAMETER :: B_BEGS_BLR_COL=11
+      INTEGER, PARAMETER :: B_NB_ACCESSES_INIT=12
+      INTEGER, PARAMETER :: B_NB_PANELS=13
+      INTEGER, PARAMETER :: B_NFS4FATHER=14
+      INTEGER, PARAMETER :: B_M_ARRAY=15
       INTEGER(8),dimension(NBVARIABLES_BLR_STRUC_T)::
      &     SIZE_VARIABLES_BLR_STRUC_T
       INTEGER,dimension(NBVARIABLES_BLR_STRUC_T)::SIZE_GEST_BLR_STRUC_T
@@ -1282,21 +1299,6 @@ C
       INTEGER(8)::SIZE_VARIABLES_DIAG_BLOCKS
       INTEGER(8)::SIZE_VARIABLES_DIAG_BLOCKS_j1
       INTEGER(4)::I4
-      VARIABLES_BLR_STRUC_T(1)="IsSYM"
-      VARIABLES_BLR_STRUC_T(2)="IsT2"
-      VARIABLES_BLR_STRUC_T(3)="IsSLAVE"
-      VARIABLES_BLR_STRUC_T(4)="PANELS_L"
-      VARIABLES_BLR_STRUC_T(5)="PANELS_U"
-      VARIABLES_BLR_STRUC_T(6)="CB_LRB"
-      VARIABLES_BLR_STRUC_T(7)="BEGS_BLR_STATIC"
-      VARIABLES_BLR_STRUC_T(8)="BEGS_BLR_DYNAMIC"
-      VARIABLES_BLR_STRUC_T(9)="BEGS_BLR_L"
-      VARIABLES_BLR_STRUC_T(10)="BEGS_BLR_COL"
-      VARIABLES_BLR_STRUC_T(11)="NB_ACCESSES_INIT"
-      VARIABLES_BLR_STRUC_T(12)="NB_PANELS"
-      VARIABLES_BLR_STRUC_T(13)="DIAG_BLOCKS"
-      VARIABLES_BLR_STRUC_T(14)="NFS4FATHER"
-      VARIABLES_BLR_STRUC_T(15)="M_ARRAY"
       SIZE_VARIABLES_BLR_STRUC_T(:)=0_8
       SIZE_GEST_BLR_STRUC_T(:)=0
       NbRecords_BLR_STRUC_T(:)=0
@@ -1317,13 +1319,12 @@ C
       SIZE_VARIABLES_DIAG_BLOCKS=0_8
       SIZE_VARIABLES_DIAG_BLOCKS_j1=0_8
       DO i1=1,NBVARIABLES_BLR_STRUC_T 
-         TMP_STRING = VARIABLES_BLR_STRUC_T(i1)
-         SELECT CASE(TMP_STRING)
-         CASE("IsSYM")
+         SELECT CASE(i1)
+         CASE(B_IsSYM)
             NbRecords_BLR_STRUC_T(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_LOGICAL
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_LOGICAL
                write(unit,iostat=err) BLR_STRUC%IsSYM
                if(err.ne.0) then
@@ -1332,7 +1333,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_LOGICAL
                read(unit,iostat=err) BLR_STRUC%IsSYM
                if(err.ne.0) THEN
@@ -1342,11 +1343,11 @@ C
                endif 
                IF (INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("IsT2")
+         CASE(B_IsT2)
             NbRecords_BLR_STRUC_T(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_LOGICAL
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_LOGICAL
                write(unit,iostat=err) BLR_STRUC%IsT2
                if(err.ne.0) then
@@ -1355,7 +1356,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_LOGICAL
                read(unit,iostat=err) BLR_STRUC%IsT2
                if(err.ne.0) THEN
@@ -1365,11 +1366,11 @@ C
                endif 
                IF (INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("IsSLAVE")
+         CASE(B_IsSLAVE)
             NbRecords_BLR_STRUC_T(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_LOGICAL
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_LOGICAL
                write(unit,iostat=err) BLR_STRUC%IsSLAVE
                if(err.ne.0) then
@@ -1378,7 +1379,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_LOGICAL
                read(unit,iostat=err) BLR_STRUC%IsSLAVE
                if(err.ne.0) THEN
@@ -1388,9 +1389,9 @@ C
                endif 
                IF (INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("BEGS_BLR_STATIC")
+         CASE(B_BEGS_BLR_STATIC)
             NbRecords_BLR_STRUC_T(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(BLR_STRUC%BEGS_BLR_STATIC)) THEN
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=
@@ -1399,7 +1400,7 @@ C
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*2
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(BLR_STRUC%BEGS_BLR_STATIC)) THEN
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=
@@ -1431,7 +1432,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(BLR_STRUC%BEGS_BLR_STATIC)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -1465,9 +1466,9 @@ C
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("BEGS_BLR_DYNAMIC")
+         CASE(B_BEGS_BLR_DYNAMIC)
             NbRecords_BLR_STRUC_T(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(BLR_STRUC%BEGS_BLR_DYNAMIC)) THEN
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=
@@ -1476,7 +1477,7 @@ C
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*2
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(BLR_STRUC%BEGS_BLR_DYNAMIC)) THEN
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=
@@ -1508,7 +1509,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(BLR_STRUC%BEGS_BLR_DYNAMIC)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -1542,9 +1543,9 @@ C
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("BEGS_BLR_L")
+         CASE(B_BEGS_BLR_L)
             NbRecords_BLR_STRUC_T(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(BLR_STRUC%BEGS_BLR_L)) THEN
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=
@@ -1553,7 +1554,7 @@ C
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*2
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(BLR_STRUC%BEGS_BLR_L)) THEN
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=
@@ -1585,7 +1586,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(BLR_STRUC%BEGS_BLR_L)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -1619,9 +1620,9 @@ C
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("BEGS_BLR_COL")
+         CASE(B_BEGS_BLR_COL)
             NbRecords_BLR_STRUC_T(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(BLR_STRUC%BEGS_BLR_COL)) THEN
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=
@@ -1630,7 +1631,7 @@ C
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*2
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(BLR_STRUC%BEGS_BLR_COL)) THEN
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=
@@ -1662,7 +1663,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(BLR_STRUC%BEGS_BLR_COL)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -1696,11 +1697,11 @@ C
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("NB_ACCESSES_INIT")
+         CASE(B_NB_ACCESSES_INIT)
             NbRecords_BLR_STRUC_T(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_INT
                write(unit,iostat=err) BLR_STRUC%NB_ACCESSES_INIT
                if(err.ne.0) then
@@ -1709,7 +1710,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_INT
                read(unit,iostat=err) BLR_STRUC%NB_ACCESSES_INIT
                if(err.ne.0) THEN
@@ -1719,11 +1720,11 @@ C
                endif 
                IF (INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("NB_PANELS")
+         CASE(B_NB_PANELS)
             NbRecords_BLR_STRUC_T(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_INT
                write(unit,iostat=err) BLR_STRUC%NB_PANELS
                if(err.ne.0) then
@@ -1732,7 +1733,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_INT
                read(unit,iostat=err) BLR_STRUC%NB_PANELS
                if(err.ne.0) THEN
@@ -1742,8 +1743,8 @@ C
                endif 
                IF (INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PANELS_L")
-            if(trim(mode).EQ."memory_save") then
+         CASE(B_PANELS_L)
+            if(mode.EQ.memory_save_mode) then
                IF(associated(BLR_STRUC%PANELS_L)) THEN
                   NbRecords_BLR_STRUC_T(i1)=1
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
@@ -1751,7 +1752,7 @@ C
                   DO j1=1,size(BLR_STRUC%PANELS_L,1)
                      CALL DMUMPS_SAVE_RESTORE_BLR_PANEL(
      &                    BLR_STRUC%PANELS_L(j1)
-     &                    ,unit,MYID,"memory_save"
+     &                    ,unit,MYID,memory_save_mode
      &                    ,SIZE_GEST_PANELS_L_j1
      &                    ,SIZE_VARIABLES_PANELS_L_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -1768,7 +1769,7 @@ C
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*2
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(BLR_STRUC%PANELS_L)) THEN
                   NbRecords_BLR_STRUC_T(i1)=1
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
@@ -1783,7 +1784,7 @@ C
                   DO j1=1,size(BLR_STRUC%PANELS_L,1)
                      CALL DMUMPS_SAVE_RESTORE_BLR_PANEL(
      &                    BLR_STRUC%PANELS_L(j1)
-     &                    ,unit,MYID,"save"
+     &                    ,unit,MYID,save_mode
      &                    ,SIZE_GEST_PANELS_L_j1
      &                    ,SIZE_VARIABLES_PANELS_L_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -1811,7 +1812,7 @@ C
                   endif
                   IF ( INFO(1) .LT. 0 ) GOTO 100
                ENDIF 
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(BLR_STRUC%PANELS_L)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -1846,7 +1847,7 @@ C
                   DO j1=1,size_array1
                      CALL DMUMPS_SAVE_RESTORE_BLR_PANEL(
      &                    BLR_STRUC%PANELS_L(j1)
-     &                    ,unit,MYID,"restore"
+     &                    ,unit,MYID,restore_mode
      &                    ,SIZE_GEST_PANELS_L_j1
      &                    ,SIZE_VARIABLES_PANELS_L_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -1860,8 +1861,8 @@ C
                   ENDDO
                endif
             endif
-            CASE("PANELS_U")
-            if(trim(mode).EQ."memory_save") then
+            CASE(B_PANELS_U)
+            if(mode.EQ.memory_save_mode) then
                IF(associated(BLR_STRUC%PANELS_U)) THEN
                   NbRecords_BLR_STRUC_T(i1)=1
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
@@ -1869,7 +1870,7 @@ C
                   DO j1=1,size(BLR_STRUC%PANELS_U,1)
                      CALL DMUMPS_SAVE_RESTORE_BLR_PANEL(
      &                    BLR_STRUC%PANELS_U(j1)
-     &                    ,unit,MYID,"memory_save"
+     &                    ,unit,MYID,memory_save_mode
      &                    ,SIZE_GEST_PANELS_U_j1
      &                    ,SIZE_VARIABLES_PANELS_U_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -1886,7 +1887,7 @@ C
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*2
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(BLR_STRUC%PANELS_U)) THEN
                   NbRecords_BLR_STRUC_T(i1)=1
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
@@ -1901,7 +1902,7 @@ C
                   DO j1=1,size(BLR_STRUC%PANELS_U,1)
                      CALL DMUMPS_SAVE_RESTORE_BLR_PANEL(
      &                    BLR_STRUC%PANELS_U(j1)
-     &                    ,unit,MYID,"save"
+     &                    ,unit,MYID,save_mode
      &                    ,SIZE_GEST_PANELS_U_j1
      &                    ,SIZE_VARIABLES_PANELS_U_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -1929,7 +1930,7 @@ C
                   endif
                   IF ( INFO(1) .LT. 0 ) GOTO 100
                ENDIF 
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(BLR_STRUC%PANELS_U)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -1964,7 +1965,7 @@ C
                   DO j1=1,size_array1
                      CALL DMUMPS_SAVE_RESTORE_BLR_PANEL(
      &                    BLR_STRUC%PANELS_U(j1)
-     &                    ,unit,MYID,"restore"
+     &                    ,unit,MYID,restore_mode
      &                    ,SIZE_GEST_PANELS_U_j1
      &                    ,SIZE_VARIABLES_PANELS_U_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -1978,8 +1979,8 @@ C
                   ENDDO
                endif
             endif
-         CASE("CB_LRB")
-            if(trim(mode).EQ."memory_save") then
+         CASE(B_CB_LRB)
+            if(mode.EQ.memory_save_mode) then
                IF(associated(BLR_STRUC%CB_LRB)) THEN
                   NbRecords_BLR_STRUC_T(i1)=1
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*2
@@ -1988,7 +1989,7 @@ C
                      DO j2=1,size(BLR_STRUC%CB_LRB,2)
                         CALL DMUMPS_SAVE_RESTORE_LRB(
      &                       BLR_STRUC%CB_LRB(j1,j2)
-     &                       ,unit,MYID,"memory_save"
+     &                       ,unit,MYID,memory_save_mode
      &                       ,SIZE_GEST_CB_LRB_j1j2
      &                       ,SIZE_VARIABLES_CB_LRB_j1j2
      &                       ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -2006,7 +2007,7 @@ C
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*3
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(BLR_STRUC%CB_LRB)) THEN
                   NbRecords_BLR_STRUC_T(i1)=1
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*2
@@ -2022,7 +2023,7 @@ C
                      DO j2=1,size(BLR_STRUC%CB_LRB,2)
                         CALL DMUMPS_SAVE_RESTORE_LRB(
      &                       BLR_STRUC%CB_LRB(j1,j2)
-     &                       ,unit,MYID,"save"
+     &                       ,unit,MYID,save_mode
      &                       ,SIZE_GEST_CB_LRB_j1j2
      &                       ,SIZE_VARIABLES_CB_LRB_j1j2
      &                       ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -2051,7 +2052,7 @@ C
                   endif
                   IF ( INFO(1) .LT. 0 ) GOTO 100
                ENDIF 
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(BLR_STRUC%CB_LRB)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -2087,7 +2088,7 @@ C
                      DO j2=1,size_array2
                         CALL DMUMPS_SAVE_RESTORE_LRB(
      &                       BLR_STRUC%CB_LRB(j1,j2)
-     &                       ,unit,MYID,"restore"
+     &                       ,unit,MYID,restore_mode
      &                       ,SIZE_GEST_CB_LRB_j1j2
      &                       ,SIZE_VARIABLES_CB_LRB_j1j2
      &                       ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -2102,8 +2103,8 @@ C
                   ENDDO
                endif
             endif
-         CASE("DIAG_BLOCKS")
-            if(trim(mode).EQ."memory_save") then
+         CASE(B_DIAG_BLOCKS)
+            if(mode.EQ.memory_save_mode) then
                IF(associated(BLR_STRUC%DIAG_BLOCKS)) THEN
                   NbRecords_BLR_STRUC_T(i1)=1
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
@@ -2111,7 +2112,7 @@ C
                   DO j1=1,size(BLR_STRUC%DIAG_BLOCKS,1)
                      CALL DMUMPS_SAVE_RESTORE_DIAG_BLOCK(
      &                    BLR_STRUC%DIAG_BLOCKS(j1)
-     &                    ,unit,MYID,"memory_save"
+     &                    ,unit,MYID,memory_save_mode
      &                    ,SIZE_GEST_DIAG_BLOCKS_j1
      &                    ,SIZE_VARIABLES_DIAG_BLOCKS_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP
@@ -2129,7 +2130,7 @@ C
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*2
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(BLR_STRUC%DIAG_BLOCKS)) THEN
                   NbRecords_BLR_STRUC_T(i1)=1
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
@@ -2144,7 +2145,7 @@ C
                   DO j1=1,size(BLR_STRUC%DIAG_BLOCKS,1)
                      CALL DMUMPS_SAVE_RESTORE_DIAG_BLOCK(
      &                    BLR_STRUC%DIAG_BLOCKS(j1)
-     &                    ,unit,MYID,"save"
+     &                    ,unit,MYID,save_mode
      &                    ,SIZE_GEST_DIAG_BLOCKS_j1
      &                    ,SIZE_VARIABLES_DIAG_BLOCKS_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP
@@ -2172,7 +2173,7 @@ C
                   endif
                   IF ( INFO(1) .LT. 0 ) GOTO 100
                ENDIF 
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(BLR_STRUC%DIAG_BLOCKS)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -2207,7 +2208,7 @@ C
                   DO j1=1,size_array1
                      CALL DMUMPS_SAVE_RESTORE_DIAG_BLOCK(
      &                    BLR_STRUC%DIAG_BLOCKS(j1)
-     &                    ,unit,MYID,"restore"
+     &                    ,unit,MYID,restore_mode
      &                    ,SIZE_GEST_DIAG_BLOCKS_j1
      &                    ,SIZE_VARIABLES_DIAG_BLOCKS_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP
@@ -2222,11 +2223,11 @@ C
                   ENDDO
                endif
             endif
-         CASE("NFS4FATHER")
+         CASE(B_NFS4FATHER)
             NbRecords_BLR_STRUC_T(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_INT
                write(unit,iostat=err) BLR_STRUC%NFS4FATHER
                if(err.ne.0) then
@@ -2235,7 +2236,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_INT
                read(unit,iostat=err) BLR_STRUC%NFS4FATHER
                if(err.ne.0) THEN
@@ -2245,26 +2246,26 @@ C
                endif 
                IF (INFO(1) .LT. 0 ) GOTO 100
             endif
-            CASE("M_ARRAY")
-               if(trim(mode).EQ."restore") then
+            CASE(B_M_ARRAY)
+               if(mode.EQ.restore_mode) then
                   nullify(BLR_STRUC%M_ARRAY)
                endif
          CASE DEFAULT
          END SELECT
-         if(trim(mode).EQ."memory_save") then
+         if(mode.EQ.memory_save_mode) then
             NbSubRecords=int(SIZE_VARIABLES_BLR_STRUC_T(i1)/huge(I4))
             IF(NbSubRecords.GT.0) then
                NbRecords_BLR_STRUC_T(i1)=NbRecords_BLR_STRUC_T(i1)
      &              +NbSubRecords
             ENDIF
-         elseif(trim(mode).EQ."save") then
+         elseif(mode.EQ.save_mode) then
             size_written=size_written+SIZE_VARIABLES_BLR_STRUC_T(i1)
      &           +int(SIZE_GEST_BLR_STRUC_T(i1),kind=8)
 #if defined(MUMPS_NOF2003)
             size_written=size_written
      &           +int(2*SIZE_INT*NbRecords_BLR_STRUC_T(i1),kind=8)
 #endif
-         elseif(trim(mode).EQ."restore") then
+         elseif(mode.EQ.restore_mode) then
             size_allocated=size_allocated+
      &           SIZE_VARIABLES_BLR_STRUC_T(i1)
             size_read=size_read+SIZE_VARIABLES_BLR_STRUC_T(i1)
@@ -2275,7 +2276,7 @@ C
 #endif
          endif
       ENDDO
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          Local_SIZE_VARIABLES=sum(SIZE_VARIABLES_BLR_STRUC_T)
      &        +SIZE_VARIABLES_PANELS_L
      &        +SIZE_VARIABLES_PANELS_U
@@ -2304,18 +2305,20 @@ C
       INCLUDE 'mpif.h'
       TYPE(LRB_TYPE) :: LRB_T
       INTEGER,intent(IN)::unit,MYID
-      CHARACTER(len=*),intent(IN) :: mode
+      INTEGER,intent(IN) :: mode
       INTEGER,INTENT(OUT) :: Local_SIZE_GEST
       INTEGER(8),intent(OUT) :: Local_SIZE_VARIABLES
       INTEGER,intent(INOUT):: INFO(2)
       INTEGER,intent(IN):: SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
       INTEGER(8),intent(IN) :: TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
       INTEGER(8),intent(INOUT):: size_read,size_allocated,size_written
-      INTEGER :: NBVARIABLES_LRB_TYPE
-      PARAMETER (NBVARIABLES_LRB_TYPE = 6)
-      CHARACTER(len=30), dimension(NBVARIABLES_LRB_TYPE)::
-     &     VARIABLES_LRB_TYPE
-      CHARACTER(len=30) :: TMP_STRING
+      INTEGER, PARAMETER :: LRB_Q=1
+      INTEGER, PARAMETER :: LRB_R=2
+      INTEGER, PARAMETER :: LRB_K=3
+      INTEGER, PARAMETER :: LRB_M=4
+      INTEGER, PARAMETER :: LRB_N=5
+      INTEGER, PARAMETER :: LRB_ISLR=6
+      INTEGER, PARAMETER :: NBVARIABLES_LRB_TYPE=6
       INTEGER(8),dimension(NBVARIABLES_LRB_TYPE)::
      &     SIZE_VARIABLES_LRB_TYPE
       INTEGER,dimension(NBVARIABLES_LRB_TYPE)::
@@ -2328,21 +2331,14 @@ C
       INTEGER:: Local_NbRecords
 #endif
       INTEGER(4) ::I4
-      VARIABLES_LRB_TYPE(1)="Q"
-      VARIABLES_LRB_TYPE(2)="R"
-      VARIABLES_LRB_TYPE(3)="K"
-      VARIABLES_LRB_TYPE(4)="M"
-      VARIABLES_LRB_TYPE(5)="N"
-      VARIABLES_LRB_TYPE(6)="ISLR"
       SIZE_VARIABLES_LRB_TYPE(:)=0_8
       SIZE_GEST_LRB_TYPE(:)=0
       NbRecords_LRB_TYPE(:)=0
       DO i1=1,NBVARIABLES_LRB_TYPE
-         TMP_STRING = VARIABLES_LRB_TYPE(i1)
-         SELECT CASE(TMP_STRING)
-         CASE("Q")
+         SELECT CASE(i1)
+         CASE(LRB_Q)
             NbRecords_LRB_TYPE(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(LRB_T%Q)) THEN
                   SIZE_GEST_LRB_TYPE(i1)=SIZE_INT*2
                   SIZE_VARIABLES_LRB_TYPE(i1)=
@@ -2352,7 +2348,7 @@ C
                   SIZE_GEST_LRB_TYPE(i1)=SIZE_INT*3
                   SIZE_VARIABLES_LRB_TYPE(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(LRB_T%Q)) THEN
                   SIZE_GEST_LRB_TYPE(i1)=SIZE_INT*2
                   SIZE_VARIABLES_LRB_TYPE(i1)=
@@ -2384,7 +2380,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 300
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(LRB_T%Q)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -2419,9 +2415,9 @@ C
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 300
             endif
-         CASE("R")
+         CASE(LRB_R)
             NbRecords_LRB_TYPE(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(LRB_T%R)) THEN
                   SIZE_GEST_LRB_TYPE(i1)=SIZE_INT*2
                   SIZE_VARIABLES_LRB_TYPE(i1)=
@@ -2431,7 +2427,7 @@ C
                   SIZE_GEST_LRB_TYPE(i1)=SIZE_INT*3
                   SIZE_VARIABLES_LRB_TYPE(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(LRB_T%R)) THEN
                   SIZE_GEST_LRB_TYPE(i1)=SIZE_INT*2
                   SIZE_VARIABLES_LRB_TYPE(i1)=
@@ -2463,7 +2459,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 300
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(LRB_T%R)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -2498,11 +2494,11 @@ C
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 300
             endif
-         CASE("K")
+         CASE(LRB_K)
             NbRecords_LRB_TYPE(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_INT
                write(unit,iostat=err) LRB_T%K
                if(err.ne.0) then
@@ -2511,7 +2507,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 300
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_INT
                read(unit,iostat=err) LRB_T%K
                if(err.ne.0) THEN
@@ -2521,11 +2517,11 @@ C
                endif 
                IF ( INFO(1) .LT. 0 ) GOTO 300
             endif
-         CASE("M")
+         CASE(LRB_M)
             NbRecords_LRB_TYPE(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_INT
                write(unit,iostat=err) LRB_T%M
                if(err.ne.0) then
@@ -2534,7 +2530,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 300
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_INT
                read(unit,iostat=err) LRB_T%M
                if(err.ne.0) THEN
@@ -2544,11 +2540,11 @@ C
                endif 
                IF ( INFO(1) .LT. 0 ) GOTO 300
             endif
-         CASE("N")
+         CASE(LRB_N)
             NbRecords_LRB_TYPE(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_INT
                write(unit,iostat=err) LRB_T%N
                if(err.ne.0) then
@@ -2557,7 +2553,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 300
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_INT
                read(unit,iostat=err) LRB_T%N
                if(err.ne.0) THEN
@@ -2567,11 +2563,11 @@ C
                endif 
                IF ( INFO(1) .LT. 0 ) GOTO 300
             endif
-         CASE("ISLR")
+         CASE(LRB_ISLR)
             NbRecords_LRB_TYPE(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_LOGICAL
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_LOGICAL
                write(unit,iostat=err) LRB_T%ISLR
                if(err.ne.0) then
@@ -2580,7 +2576,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 300
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_LOGICAL
                read(unit,iostat=err) LRB_T%ISLR
                if(err.ne.0) THEN
@@ -2592,21 +2588,21 @@ C
             endif   
          CASE DEFAULT
          END SELECT
-         if(trim(mode).EQ."memory_save") then
+         if(mode.EQ.memory_save_mode) then
             NbSubRecords=int(SIZE_VARIABLES_LRB_TYPE(i1)/huge(I4))
             IF(NbSubRecords.GT.0) then
                NbRecords_LRB_TYPE(i1)=
      &              NbRecords_LRB_TYPE(i1)
      &              +NbSubRecords
             ENDIF
-         elseif(trim(mode).EQ."save") then
+         elseif(mode.EQ.save_mode) then
             size_written=size_written+SIZE_VARIABLES_LRB_TYPE(i1)
      &           +int(SIZE_GEST_LRB_TYPE(i1),kind=8)
 #if defined(MUMPS_NOF2003)
             size_written=size_written
      &           +int(2*SIZE_INT*NbRecords_LRB_TYPE(i1),kind=8)
 #endif
-         elseif(trim(mode).EQ."restore") then
+         elseif(mode.EQ.restore_mode) then
             size_allocated=size_allocated+
      &           SIZE_VARIABLES_LRB_TYPE(i1)
             size_read=size_read+SIZE_VARIABLES_LRB_TYPE(i1)
@@ -2617,7 +2613,7 @@ C
 #endif
          endif
       ENDDO
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          Local_SIZE_VARIABLES=sum(SIZE_VARIABLES_LRB_TYPE)
          Local_SIZE_GEST=sum(SIZE_GEST_LRB_TYPE)
 #if defined(MUMPS_NOF2003)
@@ -2638,18 +2634,16 @@ C
       INCLUDE 'mpif.h'
       TYPE(blr_panel_type) :: BLR_PANEL_T
       INTEGER,intent(IN)::unit,MYID
-      CHARACTER(len=*),intent(IN) :: mode
+      INTEGER,intent(IN) :: mode
       INTEGER,INTENT(OUT) :: Local_SIZE_GEST
       INTEGER(8),intent(OUT) :: Local_SIZE_VARIABLES
       INTEGER,intent(INOUT):: INFO(2)
       INTEGER,intent(IN):: SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
       INTEGER(8),intent(IN) :: TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
       INTEGER(8),intent(INOUT):: size_read,size_allocated,size_written
-      INTEGER :: NBVARIABLES_BLR_PANEL_TYPE
-      PARAMETER (NBVARIABLES_BLR_PANEL_TYPE = 2)
-      CHARACTER(len=30), dimension(NBVARIABLES_BLR_PANEL_TYPE)::
-     &     VARIABLES_BLR_PANEL_TYPE
-      CHARACTER(len=30) :: TMP_STRING
+      INTEGER, PARAMETER :: P_NB_ACCESSES_LEFT=1
+      INTEGER, PARAMETER :: P_LRB_PANEL=2
+      INTEGER, PARAMETER :: NBVARIABLES_BLR_PANEL_TYPE = 2
       INTEGER(8),dimension(NBVARIABLES_BLR_PANEL_TYPE)::
      &     SIZE_VARIABLES_BLR_PANEL_TYPE
       INTEGER,dimension(NBVARIABLES_BLR_PANEL_TYPE)::
@@ -2664,8 +2658,6 @@ C
       INTEGER:: SIZE_GEST_LRB_PANEL_j1,SIZE_GEST_LRB_PANEL
       INTEGER(8)::SIZE_VARIABLES_LRB_PANEL_j1,SIZE_VARIABLES_LRB_PANEL
       INTEGER(4)::I4
-      VARIABLES_BLR_PANEL_TYPE(1)="NB_ACCESSES_LEFT"
-      VARIABLES_BLR_PANEL_TYPE(2)="LRB_PANEL"
       SIZE_VARIABLES_BLR_PANEL_TYPE(:)=0_8
       SIZE_GEST_BLR_PANEL_TYPE(:)=0
       NbRecords_BLR_PANEL_TYPE(:)=0
@@ -2674,13 +2666,12 @@ C
       SIZE_VARIABLES_LRB_PANEL_j1=0_8
       SIZE_VARIABLES_LRB_PANEL=0_8
       DO i1=1,NBVARIABLES_BLR_PANEL_TYPE
-         TMP_STRING = VARIABLES_BLR_PANEL_TYPE(i1)
-         SELECT CASE(TMP_STRING)
-         CASE("NB_ACCESSES_LEFT")
+         SELECT CASE(i1)
+         CASE(P_NB_ACCESSES_LEFT)
             NbRecords_BLR_PANEL_TYPE(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_BLR_PANEL_TYPE(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_BLR_PANEL_TYPE(i1)=SIZE_INT
                write(unit,iostat=err) BLR_PANEL_T%NB_ACCESSES_LEFT
                if(err.ne.0) then
@@ -2689,7 +2680,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 400
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_BLR_PANEL_TYPE(i1)=SIZE_INT
                read(unit,iostat=err) BLR_PANEL_T%NB_ACCESSES_LEFT
                if(err.ne.0) THEN
@@ -2699,8 +2690,8 @@ C
                endif 
                IF ( INFO(1) .LT. 0 ) GOTO 400
             endif
-         CASE("LRB_PANEL")
-            if(trim(mode).EQ."memory_save") then
+         CASE(P_LRB_PANEL)
+            if(mode.EQ.memory_save_mode) then
                IF(associated(BLR_PANEL_T%LRB_PANEL)) THEN
                   NbRecords_BLR_PANEL_TYPE(i1)=1
                   SIZE_GEST_BLR_PANEL_TYPE(i1)=SIZE_INT
@@ -2708,7 +2699,7 @@ C
                   DO j1=1,size(BLR_PANEL_T%LRB_PANEL,1)
                      CALL DMUMPS_SAVE_RESTORE_LRB(
      &                    BLR_PANEL_T%LRB_PANEL(j1)
-     &                    ,unit,MYID,"memory_save"
+     &                    ,unit,MYID,memory_save_mode
      &                    ,SIZE_GEST_LRB_PANEL_j1
      &                    ,SIZE_VARIABLES_LRB_PANEL_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -2725,7 +2716,7 @@ C
                   SIZE_GEST_BLR_PANEL_TYPE(i1)=SIZE_INT*2
                   SIZE_VARIABLES_BLR_PANEL_TYPE(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(BLR_PANEL_T%LRB_PANEL)) THEN
                   NbRecords_BLR_PANEL_TYPE(i1)=1
                   SIZE_GEST_BLR_PANEL_TYPE(i1)=SIZE_INT
@@ -2740,7 +2731,7 @@ C
                   DO j1=1,size(BLR_PANEL_T%LRB_PANEL,1)
                      CALL DMUMPS_SAVE_RESTORE_LRB(
      &                    BLR_PANEL_T%LRB_PANEL(j1)
-     &                    ,unit,MYID,"save"
+     &                    ,unit,MYID,save_mode
      &                    ,SIZE_GEST_LRB_PANEL_j1
      &                    ,SIZE_VARIABLES_LRB_PANEL_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -2768,7 +2759,7 @@ C
                   endif
                   IF ( INFO(1) .LT. 0 ) GOTO 400
                ENDIF 
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(BLR_PANEL_T%LRB_PANEL)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -2803,7 +2794,7 @@ C
                   DO j1=1,size_array1
                      CALL DMUMPS_SAVE_RESTORE_LRB(
      &                    BLR_PANEL_T%LRB_PANEL(j1)
-     &                    ,unit,MYID,"restore"
+     &                    ,unit,MYID,restore_mode
      &                    ,SIZE_GEST_LRB_PANEL_j1
      &                    ,SIZE_VARIABLES_LRB_PANEL_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -2819,21 +2810,21 @@ C
             endif
          CASE DEFAULT
          END SELECT
-         if(trim(mode).EQ."memory_save") then
+         if(mode.EQ.memory_save_mode) then
             NbSubRecords=int(SIZE_VARIABLES_BLR_PANEL_TYPE(i1)/huge(I4))
             IF(NbSubRecords.GT.0) then
                NbRecords_BLR_PANEL_TYPE(i1)=
      &              NbRecords_BLR_PANEL_TYPE(i1)
      &              +NbSubRecords
             ENDIF
-         elseif(trim(mode).EQ."save") then
+         elseif(mode.EQ.save_mode) then
             size_written=size_written+SIZE_VARIABLES_BLR_PANEL_TYPE(i1)
      &           +int(SIZE_GEST_BLR_PANEL_TYPE(i1),kind=8)
 #if defined(MUMPS_NOF2003)
             size_written=size_written
      &           +int(2*SIZE_INT*NbRecords_BLR_PANEL_TYPE(i1),kind=8)
 #endif
-         elseif(trim(mode).EQ."restore") then
+         elseif(mode.EQ.restore_mode) then
             size_allocated=size_allocated+
      &           SIZE_VARIABLES_BLR_PANEL_TYPE(i1)
             size_read=size_read+SIZE_VARIABLES_BLR_PANEL_TYPE(i1)
@@ -2844,7 +2835,7 @@ C
 #endif
          endif
       ENDDO
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          Local_SIZE_VARIABLES=sum(SIZE_VARIABLES_BLR_PANEL_TYPE)+
      &        SIZE_VARIABLES_LRB_PANEL
          Local_SIZE_GEST=sum(SIZE_GEST_BLR_PANEL_TYPE)+
@@ -2867,18 +2858,15 @@ C
       INCLUDE 'mpif.h'
       TYPE(diag_block_type) :: DIAG_BLOCK_T
       INTEGER,intent(IN)::unit,MYID
-      CHARACTER(len=*),intent(IN) :: mode
+      INTEGER,intent(IN) :: mode
       INTEGER,INTENT(OUT) :: Local_SIZE_GEST
       INTEGER(8),intent(OUT) :: Local_SIZE_VARIABLES
       INTEGER,intent(INOUT):: INFO(2)
       INTEGER,intent(IN):: SIZE_INT, SIZE_ARITH_DEP
       INTEGER(8),intent(IN) :: TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
       INTEGER(8),intent(INOUT):: size_read,size_allocated,size_written
-      INTEGER :: NBVARIABLES_DIAG_BLOCK_TYPE
-      PARAMETER (NBVARIABLES_DIAG_BLOCK_TYPE = 1)
-      CHARACTER(len=30), dimension(NBVARIABLES_DIAG_BLOCK_TYPE)::
-     &     VARIABLES_DIAG_BLOCK_TYPE
-      CHARACTER(len=30) :: TMP_STRING
+      INTEGER, PARAMETER :: D_DIAG_BLOCK=1
+      INTEGER, PARAMETER :: NBVARIABLES_DIAG_BLOCK_TYPE = 1
       INTEGER(8),dimension(NBVARIABLES_DIAG_BLOCK_TYPE)::
      &     SIZE_VARIABLES_DIAG_BLOCK_TYPE
       INTEGER,dimension(NBVARIABLES_DIAG_BLOCK_TYPE)::
@@ -2891,16 +2879,14 @@ C
       INTEGER:: Local_NbRecords
 #endif
       INTEGER(4) :: I4
-      VARIABLES_DIAG_BLOCK_TYPE(1)="DIAG_BLOCK"
       SIZE_VARIABLES_DIAG_BLOCK_TYPE(:)=0_8
       SIZE_GEST_DIAG_BLOCK_TYPE(:)=0
       NbRecords_DIAG_BLOCK_TYPE(:)=0
       DO i1=1,NBVARIABLES_DIAG_BLOCK_TYPE
-         TMP_STRING = VARIABLES_DIAG_BLOCK_TYPE(i1)
-         SELECT CASE(TMP_STRING)
-         CASE("DIAG_BLOCK")
+         SELECT CASE(i1)
+         CASE(D_DIAG_BLOCK)
             NbRecords_DIAG_BLOCK_TYPE(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(DIAG_BLOCK_T%DIAG_BLOCK)) THEN
                   SIZE_GEST_DIAG_BLOCK_TYPE(i1)=SIZE_INT
                   SIZE_VARIABLES_DIAG_BLOCK_TYPE(i1)=
@@ -2910,7 +2896,7 @@ C
                   SIZE_GEST_DIAG_BLOCK_TYPE(i1)=SIZE_INT*2
                   SIZE_VARIABLES_DIAG_BLOCK_TYPE(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(DIAG_BLOCK_T%DIAG_BLOCK)) THEN
                   SIZE_GEST_DIAG_BLOCK_TYPE(i1)=SIZE_INT
                   SIZE_VARIABLES_DIAG_BLOCK_TYPE(i1)=
@@ -2942,7 +2928,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 200
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(DIAG_BLOCK_T%DIAG_BLOCK)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -2979,7 +2965,7 @@ C
             endif
          CASE DEFAULT
          END SELECT
-         if(trim(mode).EQ."memory_save") then
+         if(mode.EQ.memory_save_mode) then
             NbSubRecords=int(SIZE_VARIABLES_DIAG_BLOCK_TYPE(i1)/
      &      huge(I4))
             IF(NbSubRecords.GT.0) then
@@ -2987,14 +2973,14 @@ C
      &              NbRecords_DIAG_BLOCK_TYPE(i1)
      &              +NbSubRecords
             ENDIF
-         elseif(trim(mode).EQ."save") then
+         elseif(mode.EQ.save_mode) then
             size_written=size_written+SIZE_VARIABLES_DIAG_BLOCK_TYPE(i1)
      &           +int(SIZE_GEST_DIAG_BLOCK_TYPE(i1),kind=8)
 #if defined(MUMPS_NOF2003)
             size_written=size_written
      &           +int(2*SIZE_INT*NbRecords_DIAG_BLOCK_TYPE(i1),kind=8)
 #endif
-         elseif(trim(mode).EQ."restore") then
+         elseif(mode.EQ.restore_mode) then
             size_allocated=size_allocated+
      &           SIZE_VARIABLES_DIAG_BLOCK_TYPE(i1)
             size_read=size_read+SIZE_VARIABLES_DIAG_BLOCK_TYPE(i1)
@@ -3005,7 +2991,7 @@ C
 #endif
          endif
       ENDDO
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          Local_SIZE_VARIABLES=sum(SIZE_VARIABLES_DIAG_BLOCK_TYPE)
          Local_SIZE_GEST=sum(SIZE_GEST_DIAG_BLOCK_TYPE)
 #if defined(MUMPS_NOF2003)
@@ -3016,4 +3002,5 @@ C
  200  continue
       RETURN
       END SUBROUTINE DMUMPS_SAVE_RESTORE_DIAG_BLOCK
+#endif
       END MODULE DMUMPS_LR_DATA_M
diff -pruN 5.6.2-2.1/src/dmumps_mpi3_mod.F 5.7.1-1/src/dmumps_mpi3_mod.F
--- 5.6.2-2.1/src/dmumps_mpi3_mod.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dmumps_mpi3_mod.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/dmumps_ooc.F 5.7.1-1/src/dmumps_ooc.F
--- 5.6.2-2.1/src/dmumps_ooc.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dmumps_ooc.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -17,6 +17,7 @@ C
 !$   &                    OMP_INIT_LOCK, OMP_DESTROY_LOCK, OMP_TEST_LOCK
       IMPLICIT NONE
 !$     INTEGER(KIND=OMP_LOCK_KIND) :: LOCK_FOR_L0OMP
+      INTEGER, PARAMETER :: FILENAMELENGTH=1300
       INTEGER NOT_IN_MEM,BEING_READ,NOT_USED,PERMUTED,USED,
      &     USED_NOT_PERMUTED,ALREADY_USED
       PARAMETER (NOT_IN_MEM=0,BEING_READ=-1,NOT_USED=-2,
@@ -44,7 +45,6 @@ C
      &     ,NB_CALLED,REQ_ACT,NB_CALL
       INTEGER(8), SAVE :: OOC_VADDR_PTR
       INTEGER(8), SAVE :: SIZE_ZONE_REQ
-      DOUBLE PRECISION,SAVE :: MAX_OOC_FILE_SIZE
       INTEGER(8), DIMENSION(:), ALLOCATABLE :: SIZE_OF_READ, READ_DEST
       INTEGER,DIMENSION(:),ALLOCATABLE :: FIRST_POS_IN_READ,
      &     READ_MNG,REQ_TO_ZONE,POS_HOLE_T,
@@ -114,18 +114,16 @@ C
       USE DMUMPS_STRUC_DEF
       USE DMUMPS_OOC_BUFFER
       IMPLICIT NONE
-      INTEGER TMPDIR_MAX_LENGTH, PREFIX_MAX_LENGTH
-      PARAMETER (TMPDIR_MAX_LENGTH=255, PREFIX_MAX_LENGTH=63)
+      INTEGER OOC_TMPDIR_MAX_LENGTH, OOC_PREFIX_MAX_LENGTH
+      PARAMETER (OOC_TMPDIR_MAX_LENGTH=1023, OOC_PREFIX_MAX_LENGTH=255)
       INTEGER(8), intent(in) :: MAXS  
       TYPE(DMUMPS_STRUC), TARGET :: id
       INTEGER IERR
       INTEGER allocok
-      CHARACTER(len=1):: TMP_DIR(TMPDIR_MAX_LENGTH),
-     &            TMP_PREFIX(PREFIX_MAX_LENGTH)
-      INTEGER DIM_DIR,DIM_PREFIX
+      INTEGER DIM_TMPDIR,DIM_PREFIX
       INTEGER, DIMENSION(:), ALLOCATABLE :: FILE_FLAG_TAB
       INTEGER TMP
-      INTEGER K211_LOC
+      INTEGER KEEP211_LOC
       ICNTL1=id%ICNTL(1)
       MAX_SIZE_FACTOR_OOC=0_8
       N_OOC=id%N
@@ -234,14 +232,10 @@ C
       ENDIF
       DIM_ERR_STR_OOC = ERR_STR_OOC_MAX_LEN
       CALL MUMPS_LOW_LEVEL_INIT_ERR_STR(DIM_ERR_STR_OOC,ERR_STR_OOC)
-      DIM_DIR=len(trim(id%OOC_TMPDIR))
+      DIM_TMPDIR=len(trim(id%OOC_TMPDIR))
       DIM_PREFIX=len(trim(id%OOC_PREFIX))
-      CALL DMUMPS_CONVERT_STR_TO_CHR_ARRAY(TMP_DIR(1),
-     &     id%OOC_TMPDIR, TMPDIR_MAX_LENGTH, DIM_DIR )
-      CALL DMUMPS_CONVERT_STR_TO_CHR_ARRAY(TMP_PREFIX(1),
-     &     id%OOC_PREFIX, PREFIX_MAX_LENGTH, DIM_PREFIX)
-      CALL MUMPS_LOW_LEVEL_INIT_PREFIX(DIM_PREFIX, TMP_PREFIX)
-      CALL MUMPS_LOW_LEVEL_INIT_TMPDIR(DIM_DIR, TMP_DIR)
+      CALL MUMPS_LOW_LEVEL_INIT_PREFIX(DIM_PREFIX, id%OOC_PREFIX)
+      CALL MUMPS_LOW_LEVEL_INIT_TMPDIR(DIM_TMPDIR, id%OOC_TMPDIR)
       ALLOCATE(FILE_FLAG_TAB(OOC_NB_FILE_TYPE),
      &     stat=allocok)
       IF (allocok .GT. 0) THEN
@@ -260,8 +254,8 @@ C
          TMP=max(1,TMP/2)
       ENDIF
       CALL MUMPS_LOW_LEVEL_INIT_OOC_C(MYID_OOC,TMP,
-     &     id%KEEP(35),LOW_LEVEL_STRAT_IO,K211_LOC,OOC_NB_FILE_TYPE,
-     &     FILE_FLAG_TAB,IERR)
+     &     id%KEEP(35),LOW_LEVEL_STRAT_IO,KEEP211_LOC,OOC_NB_FILE_TYPE,
+     &     FILE_FLAG_TAB,id%KEEP(255),IERR)
       IF(IERR.LT.0)THEN
          IF (ICNTL1 .GT. 0 ) THEN
            WRITE(ICNTL1,*)MYID_OOC,': PB in MUMPS_LOW_LEVEL_INIT_OOC_C'
@@ -271,7 +265,6 @@ C
          id%INFO(2) = 0
          RETURN
       ENDIF
-      CALL MUMPS_GET_MAX_FILE_SIZE_C(MAX_OOC_FILE_SIZE)
       DEALLOCATE(FILE_FLAG_TAB)
       RETURN
       END SUBROUTINE DMUMPS_OOC_INIT_FACTO
@@ -506,7 +499,7 @@ C
       TYPE(DMUMPS_STRUC), TARGET :: id
       INTEGER IERR
       INTEGER I,J,I1,K
-      CHARACTER(len=1):: TMP_NAME(350)
+      CHARACTER(len=1):: TMP_NAME(FILENAMELENGTH)
       IERR=0
       K=1
       IF(.NOT. id%ASSOCIATED_OOC_FILES) THEN
@@ -1367,7 +1360,9 @@ C
       IMPLICIT NONE
       INTEGER INODE
       IF ( (KEEP_OOC(237).EQ.0)
-     &     .AND. (KEEP_OOC(235).EQ.0) ) THEN
+     &     .AND. (KEEP_OOC(235).EQ.0) 
+     &     .AND. (KEEP_OOC(212).EQ.0)
+     &   ) THEN
       IF(OOC_STATE_NODE(STEP_OOC(INODE)).NE.NOT_USED)THEN
          WRITE(*,*)MYID_OOC,': INTERNAL ERROR (51) in OOC',INODE,
      &        OOC_STATE_NODE(STEP_OOC(INODE))
@@ -2618,7 +2613,8 @@ C
                  SET_POS_SEQUENCE = .FALSE.
                  CUR_POS_SEQUENCE = I
                ENDIF
-               IF (KEEP_OOC(237).EQ.0 .AND. KEEP_OOC(235).EQ.0) THEN
+               IF (KEEP_OOC(237).EQ.0 .AND. KEEP_OOC(235).EQ.0
+     &              .AND. KEEP_OOC(212).EQ.0 ) THEN
                  OOC_STATE_NODE(STEP_OOC(J)) = NOT_IN_MEM
                ENDIF
                CYCLE
@@ -2638,7 +2634,8 @@ C
                         CALL MUMPS_ABORT()
                      ENDIF                     
                   ENDIF
-                 IF (KEEP_OOC(237).NE.0 .OR. KEEP_OOC(235).NE.0) 
+                 IF (KEEP_OOC(237).NE.0 .OR. KEEP_OOC(235).NE.0
+     &               .OR.  KEEP_OOC(212).NE.0 ) 
      &              THEN
                   IF (OOC_STATE_NODE(STEP_OOC(J)).EQ.NOT_IN_MEM) THEN
                      OOC_STATE_NODE(STEP_OOC(J)) = USED
@@ -2657,13 +2654,15 @@ C
                     CALL MUMPS_ABORT()
                   ENDIF
                  ENDIF
-                 IF (KEEP_OOC(237).EQ.0 .AND. KEEP_OOC(235).EQ.0) THEN
+                 IF (KEEP_OOC(237).EQ.0 .AND. KEEP_OOC(235).EQ.0
+     &               .AND. KEEP_OOC(212).EQ.0 ) THEN
                     CALL DMUMPS_SOLVE_UPD_NODE_INFO(J,PTRFAC,NSTEPS)
                  ENDIF
                ENDIF
             ENDIF 
       ENDDO
-         IF (KEEP_OOC(237).NE.0 .OR. KEEP_OOC(235).NE.0) 
+         IF (KEEP_OOC(237).NE.0 .OR. KEEP_OOC(235).NE.0 .OR.
+     &       KEEP_OOC(212).NE.0 ) 
      &      THEN
            IF (COMPRESS_TO_BE_DONE) THEN 
              DO ZONE=1,NB_Z-1
@@ -2789,7 +2788,7 @@ C
       TYPE(DMUMPS_STRUC), TARGET :: id
       INTEGER, intent(out) :: IERR
       INTEGER I,DIM,J,TMP,SIZE,K,I1
-      CHARACTER(len=1):: TMP_NAME(350)
+      CHARACTER(len=1):: TMP_NAME(FILENAMELENGTH)
       EXTERNAL MUMPS_OOC_GET_NB_FILES_C, MUMPS_OOC_GET_FILE_NAME_C
       IERR=0
       SIZE=0
@@ -2803,7 +2802,7 @@ C
          DEALLOCATE(id%OOC_FILE_NAMES)
          NULLIFY(id%OOC_FILE_NAMES)
       ENDIF
-      ALLOCATE(id%OOC_FILE_NAMES(SIZE,350),stat=IERR)
+      ALLOCATE(id%OOC_FILE_NAMES(SIZE,FILENAMELENGTH),stat=IERR)
       IF (IERR .GT. 0) THEN
          IF (ICNTL1.GT.0) THEN
             WRITE(ICNTL1,*) 'PB allocation in ',
@@ -2812,7 +2811,7 @@ C
          IERR=-1
          IF(id%INFO(1).GE.0)THEN
             id%INFO(1) = -13
-            id%INFO(2) = SIZE*350
+            id%INFO(2) = SIZE*FILENAMELENGTH
             RETURN
          ENDIF
       ENDIF
@@ -2850,10 +2849,9 @@ C
       USE DMUMPS_STRUC_DEF
       IMPLICIT NONE
       TYPE(DMUMPS_STRUC), TARGET :: id
-      CHARACTER(len=1):: TMP_NAME(350)
+      CHARACTER(len=1):: TMP_NAME(FILENAMELENGTH)
       INTEGER I,I1,TMP,J,K,L,DIM,IERR
       INTEGER, DIMENSION(:),ALLOCATABLE :: NB_FILES
-      INTEGER K211
       ALLOCATE(NB_FILES(OOC_NB_FILE_TYPE),stat=IERR)
       IF (IERR .GT. 0) THEN
          IERR=-1
@@ -2872,7 +2870,6 @@ C
       I=id%MYID
       K=id%KEEP(35)
       L=mod(id%KEEP(204),3)
-      K211=id%KEEP(211)
       CALL MUMPS_OOC_ALLOC_POINTERS_C(OOC_NB_FILE_TYPE,NB_FILES,IERR)
       IF(IERR.LT.0)THEN
          IF (ICNTL1.GT.0)
@@ -2880,7 +2877,7 @@ C
          id%INFO(1)=IERR
          RETURN
       ENDIF
-      CALL MUMPS_OOC_INIT_VARS_C(I,K,L,K211,IERR)
+      CALL MUMPS_OOC_INIT_VARS_C(I,K,L,id%KEEP(211),id%KEEP(255),IERR)
       IF(IERR.LT.0)THEN
          IF (ICNTL1.GT.0)
      &   WRITE(ICNTL1,*)MYID_OOC,': ',ERR_STR_OOC(1:DIM_ERR_STR_OOC)
@@ -2916,16 +2913,6 @@ C
       DEALLOCATE(NB_FILES)
       RETURN
       END SUBROUTINE DMUMPS_OOC_OPEN_FILES_FOR_SOLVE      
-      SUBROUTINE DMUMPS_CONVERT_STR_TO_CHR_ARRAY(DEST,SRC,NB,NB_EFF)
-      IMPLICIT NONE
-      INTEGER NB, NB_EFF
-      CHARACTER(LEN=NB):: SRC
-      CHARACTER(len=1):: DEST(NB)
-      INTEGER I
-      DO I=1,NB_EFF
-         DEST(I)=SRC(I:I)
-      ENDDO
-      END SUBROUTINE DMUMPS_CONVERT_STR_TO_CHR_ARRAY
       SUBROUTINE DMUMPS_FORCE_WRITE_BUF(IERR)
       USE DMUMPS_OOC_BUFFER
       IMPLICIT NONE
diff -pruN 5.6.2-2.1/src/dmumps_ooc_buffer.F 5.7.1-1/src/dmumps_ooc_buffer.F
--- 5.6.2-2.1/src/dmumps_ooc_buffer.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dmumps_ooc_buffer.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/dmumps_save_restore.F 5.7.1-1/src/dmumps_save_restore.F
--- 5.6.2-2.1/src/dmumps_save_restore.F	2023-10-11 09:37:06.000000000 +0000
+++ 5.7.1-1/src/dmumps_save_restore.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -11,15 +11,18 @@ C  released under the CeCILL-C license
 C  (see doc/CeCILL-C_V1-en.txt, doc/CeCILL-C_V1-fr.txt, and
 C  https://cecill.info/licences/Licence_CeCILL-C_V1-en.html)
 C
+#if ! defined(NO_SAVE_RESTORE)
       MODULE DMUMPS_SAVE_RESTORE
       USE DMUMPS_STRUC_DEF
       USE DMUMPS_SAVE_RESTORE_FILES
       USE DMUMPS_LR_DATA_M
       USE MUMPS_FRONT_DATA_MGT_M
       IMPLICIT NONE
+      INCLUDE 'mumps_save_restore_modes.h'
       CONTAINS
       SUBROUTINE DMUMPS_REMOVE_SAVED(id)
-      USE DMUMPS_OOC
+      USE DMUMPS_OOC 
+      IMPLICIT NONE
       INCLUDE 'mpif.h'
       INTEGER MASTER
       PARAMETER ( MASTER = 0 )
@@ -151,6 +154,7 @@ C
       RETURN
       END SUBROUTINE DMUMPS_REMOVE_SAVED
       SUBROUTINE DMUMPS_RESTORE_OOC(localid)
+      IMPLICIT NONE
       INCLUDE 'mpif.h'
       INTEGER::ierr,IN,NBVARIABLES,NBVARIABLES_ROOT
       CHARACTER(len=LEN_SAVE_FILE):: restore_file_ooc,INFO_FILE
@@ -161,7 +165,7 @@ C
       INTEGER:: INFO1,INFO2,INFOG1,INFOG2,allocok
       INTEGER(8) :: TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
       TYPE (DMUMPS_STRUC) :: localid
-      NBVARIABLES=188
+      NBVARIABLES=194
       NBVARIABLES_ROOT=33
       allocate(SIZE_VARIABLES(NBVARIABLES),  stat=allocok)
       if (allocok .GT. 0) THEN
@@ -227,7 +231,7 @@ C
       CALL MUMPS_PROPINFO( localid%ICNTL(1), localid%INFO(1),
      &     localid%COMM, localid%MYID )
       IF ( localid%INFO(1) .LT. 0 ) RETURN
-      CALL DMUMPS_SAVE_RESTORE_STRUCTURE(localid,IN,"restore_ooc"
+      CALL DMUMPS_SAVE_RESTORE_STRUCTURE(localid,IN,restore_ooc_mode
      &     ,NBVARIABLES,SIZE_VARIABLES,SIZE_GEST
      &     ,NBVARIABLES_ROOT,SIZE_VARIABLES_ROOT,SIZE_GEST_ROOT
      &     ,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
@@ -239,6 +243,7 @@ C
       END SUBROUTINE DMUMPS_RESTORE_OOC
       SUBROUTINE DMUMPS_COMPUTE_MEMORY_SAVE(id,
      &     TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE)
+      IMPLICIT NONE
       INCLUDE 'mpif.h'
       INTEGER::NBVARIABLES,NBVARIABLES_ROOT
       INTEGER(8),allocatable, dimension(:)::SIZE_VARIABLES
@@ -248,7 +253,7 @@ C
       INTEGER :: INFO1,INFO2,INFOG1,INFOG2,allocok
       INTEGER(8) :: TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
       TYPE (DMUMPS_STRUC) :: id
-      NBVARIABLES=188
+      NBVARIABLES=194
       NBVARIABLES_ROOT=33
       allocate(SIZE_VARIABLES(NBVARIABLES),  stat=allocok)
       if (allocok .GT. 0) THEN
@@ -292,7 +297,7 @@ C
       INFO2 = -999
       INFOG1 = -999
       INFOG2 = -999
-      CALL DMUMPS_SAVE_RESTORE_STRUCTURE(id,0,"memory_save"
+      CALL DMUMPS_SAVE_RESTORE_STRUCTURE(id,0,memory_save_mode
      &     ,NBVARIABLES,SIZE_VARIABLES,SIZE_GEST
      &     ,NBVARIABLES_ROOT,SIZE_VARIABLES_ROOT,SIZE_GEST_ROOT
      &     ,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
@@ -302,6 +307,7 @@ C
       RETURN
       END SUBROUTINE DMUMPS_COMPUTE_MEMORY_SAVE
       SUBROUTINE DMUMPS_SAVE(id)
+      IMPLICIT NONE
       INCLUDE 'mpif.h'
       INTEGER::ierr,OUT,NBVARIABLES,NBVARIABLES_ROOT,OUTINFO
       CHARACTER(len=LEN_SAVE_FILE):: SAVE_FILE,INFO_FILE
@@ -326,7 +332,7 @@ C
       id%INFOG(2)=0
       MPG= id%ICNTL(3)
       PROKG   = ( MPG .GT. 0 .and. id%MYID .eq. 0 )
-      NBVARIABLES=188
+      NBVARIABLES=194
       NBVARIABLES_ROOT=33
       allocate(SIZE_VARIABLES(NBVARIABLES),  stat=allocok)
       if (allocok .GT. 0) THEN
@@ -367,7 +373,7 @@ C
       TOTAL_FILE_SIZE=0_8
       TOTAL_STRUC_SIZE=0_8
       TMP_OOC_NAMES(:)="?"
-      CALL DMUMPS_SAVE_RESTORE_STRUCTURE(id,0,"memory_save"
+      CALL DMUMPS_SAVE_RESTORE_STRUCTURE(id,0,memory_save_mode
      &     ,NBVARIABLES,SIZE_VARIABLES,SIZE_GEST
      &     ,NBVARIABLES_ROOT,SIZE_VARIABLES_ROOT,SIZE_GEST_ROOT
      &     ,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
@@ -426,7 +432,7 @@ C
       CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &     id%COMM, id%MYID )
       IF ( id%INFO(1) .LT. 0 ) RETURN
-      CALL DMUMPS_SAVE_RESTORE_STRUCTURE(id,OUT,"save"
+      CALL DMUMPS_SAVE_RESTORE_STRUCTURE(id,OUT,save_mode
      &     ,NBVARIABLES,SIZE_VARIABLES,SIZE_GEST
      &     ,NBVARIABLES_ROOT,SIZE_VARIABLES_ROOT,SIZE_GEST_ROOT
      &     ,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
@@ -513,6 +519,7 @@ C
       RETURN
       END SUBROUTINE DMUMPS_SAVE
       SUBROUTINE DMUMPS_RESTORE(id)
+      IMPLICIT NONE
       INCLUDE 'mpif.h'
       INTEGER::ierr,IN,NBVARIABLES,NBVARIABLES_ROOT
       CHARACTER(len=LEN_SAVE_FILE):: restore_file,INFO_FILE
@@ -526,7 +533,7 @@ C
       INTEGER :: I,J,K,H,allocok
       CHARACTER(len=1) :: TMP_OOC_NAMES(350)
       TYPE (DMUMPS_STRUC) :: id
-      NBVARIABLES=188
+      NBVARIABLES=194
       NBVARIABLES_ROOT=33
       allocate(SIZE_VARIABLES(NBVARIABLES),  stat=allocok)
       if (allocok .GT. 0) THEN
@@ -595,7 +602,7 @@ C
       IF ( id%INFO(1) .LT. 0 ) RETURN
       MP= id%ICNTL(2)
       MPG= id%ICNTL(3)
-      CALL DMUMPS_SAVE_RESTORE_STRUCTURE(id,IN,"restore"
+      CALL DMUMPS_SAVE_RESTORE_STRUCTURE(id,IN,restore_mode
      &     ,NBVARIABLES,SIZE_VARIABLES,SIZE_GEST
      &     ,NBVARIABLES_ROOT,SIZE_VARIABLES_ROOT,SIZE_GEST_ROOT
      &     ,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
@@ -660,8 +667,8 @@ C
       USE DMUMPS_FACSOL_L0OMP_M, ONLY : DMUMPS_SAVE_RESTORE_L0FACARRAY
       IMPLICIT NONE
       INCLUDE 'mpif.h'
-      INTEGER,intent(in)::unit,NBVARIABLES,NBVARIABLES_ROOT
-      CHARACTER(len=*),intent(in) :: mode
+      INTEGER, intent(in) ::unit,NBVARIABLES,NBVARIABLES_ROOT
+      INTEGER, intent(in) :: mode
       INTEGER(8),dimension(NBVARIABLES)::SIZE_VARIABLES
       INTEGER(8),dimension(NBVARIABLES_ROOT)::SIZE_VARIABLES_ROOT
       INTEGER,dimension(NBVARIABLES)::SIZE_GEST
@@ -669,9 +676,6 @@ C
       INTEGER(8) :: TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
       INTEGER:: INFO1,INFO2,INFOG1,INFOG2
       INTEGER:: j,i1,i2,err,ierr
-      CHARACTER(len=30), allocatable, dimension(:)::VARIABLES
-      CHARACTER(len=30), allocatable, dimension(:)::VARIABLES_ROOT
-      CHARACTER(len=30) :: TMP_STRING1, TMP_STRING2
       CHARACTER :: ARITH,READ_ARITH
       INTEGER(8) :: size_written,gest_size,WRITTEN_STRUC_SIZE
       INTEGER:: SIZE_INT, SIZE_INT8, SIZE_RL_OR_DBL, SIZE_ARITH_DEP
@@ -701,246 +705,237 @@ C
      &            SIZE_VARIABLES_L0FAC
       INTEGER::SIZE_GEST_BLR,SIZE_GEST_FRONT_DATA,SIZE_GEST_L0FAC
       INTEGER :: KEEP410_SAVE, KEEP411_SAVE 
+      INTEGER(8) :: KEEP883_SAVE, KEEP884_SAVE 
       INTEGER(4) :: I4
       TYPE (DMUMPS_STRUC) :: id
-      allocate(VARIABLES(NBVARIABLES),  stat=allocok)
-      if (allocok .GT. 0) THEN
-       id%INFO(1)  =-13
-       id%INFO(2) = NBVARIABLES
-      endif
-      CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &     id%COMM, id%MYID )
-      IF ( id%INFO(1) .LT. 0 ) GOTO 100
-      VARIABLES(188)="ASSOCIATED_OOC_FILES"
-      VARIABLES(187)="pad16"
-      VARIABLES(186)="Deficiency"
-      VARIABLES(185)="NB_SINGULAR_VALUES"
-      VARIABLES(184)="SINGULAR_VALUES"
-      VARIABLES(183)="MPITOOMP_PROCS_MAP"
-      VARIABLES(182)="L0_OMP_MAPPING"
-      VARIABLES(181)="PTR_LEAFS_L0_OMP"
-      VARIABLES(180)="PERM_L0_OMP"
-      VARIABLES(179)="VIRT_L0_OMP_MAPPING"
-      VARIABLES(178)="VIRT_L0_OMP"
-      VARIABLES(177)="PHYS_L0_OMP"
-      VARIABLES(176)="IPOOL_A_L0_OMP"
-      VARIABLES(175)="IPOOL_B_L0_OMP"
-      VARIABLES(174)="I8_L0_OMP"
-      VARIABLES(173)="I4_L0_OMP"
-      VARIABLES(172)="THREAD_LA"
-      VARIABLES(171)="LL0_OMP_FACTORS"
-      VARIABLES(170)="LL0_OMP_MAPPING"
-      VARIABLES(169)="L_VIRT_L0_OMP"
-      VARIABLES(168)="L_PHYS_L0_OMP"
-      VARIABLES(167)="LPOOL_B_L0_OMP"
-      VARIABLES(166)="LPOOL_A_L0_OMP"
-      VARIABLES(165)="L0_OMP_FACTORS"
-      VARIABLES(164)="BLRARRAY_ENCODING"
-      VARIABLES(163)="FDM_F_ENCODING"
-      VARIABLES(162)="pad13"
-      VARIABLES(161)="NBGRP"
-      VARIABLES(160)="LRGROUPS"
-      VARIABLES(159)="root"
-      VARIABLES(158)="WORKING"
-      VARIABLES(157)="IPTR_WORKING"
-      VARIABLES(156)="pad14"
-      VARIABLES(155)="SUP_PROC"
-      VARIABLES(154)="PIVNUL_LIST"
-      VARIABLES(153)="OOC_FILE_NAMES"
-      VARIABLES(152)="OOC_FILE_NAME_LENGTH"
-      VARIABLES(151)="pad12"
-      VARIABLES(150)="OOC_NB_FILE_TYPE"
-      VARIABLES(149)="OOC_NB_FILES"
-      VARIABLES(148)="OOC_TOTAL_NB_NODES"
-      VARIABLES(147)="OOC_VADDR"
-      VARIABLES(146)="OOC_SIZE_OF_BLOCK"
-      VARIABLES(145)="OOC_INODE_SEQUENCE"
-      VARIABLES(144)="OOC_MAX_NB_NODES_FOR_ZONE"
-      VARIABLES(143)="INSTANCE_NUMBER"
-      VARIABLES(142)="CB_SON_SIZE"
-      VARIABLES(141)="DKEEP"
-      VARIABLES(140)="LWK_USER"
-      VARIABLES(139)="NBSA_LOCAL"
-      VARIABLES(138)="WK_USER"
-      VARIABLES(137)="CROIX_MANU"
-      VARIABLES(136)="SCHED_SBTR"
-      VARIABLES(135)="SCHED_GRP"
-      VARIABLES(134)="SCHED_DEP"
-      VARIABLES(133)="SBTR_ID"
-      VARIABLES(132)="DEPTH_FIRST_SEQ"
-      VARIABLES(131)="DEPTH_FIRST"
-      VARIABLES(130)="MY_NB_LEAF"
-      VARIABLES(129)="MY_FIRST_LEAF"
-      VARIABLES(128)="MY_ROOT_SBTR"
-      VARIABLES(127)="COST_TRAV"
-      VARIABLES(126)="MEM_SUBTREE"
-      VARIABLES(125)="RHSCOMP"
-      VARIABLES(124)="POSINRHSCOMP_COL"
-      VARIABLES(123)="pad11"
-      VARIABLES(122)="POSINRHSCOMP_COL_ALLOC"
-      VARIABLES(121)="POSINRHSCOMP_ROW"
-      VARIABLES(120)="MEM_DIST"
-      VARIABLES(119)="I_AM_CAND"
-      VARIABLES(118)="TAB_POS_IN_PERE"
-      VARIABLES(117)="FUTURE_NIV2"
-      VARIABLES(116)="ISTEP_TO_INIV2"
-      VARIABLES(115)="CANDIDATES"
-      VARIABLES(114)="ELTPROC"
-      VARIABLES(113)="LELTVAR"
-      VARIABLES(112)="NELT_loc"
-      VARIABLES(111)="PROCNODE"
-      VARIABLES(110)="S"
-      VARIABLES(109)="PTRFAC"
-      VARIABLES(108)="PTLUST_S"
-      VARIABLES(107)="Step2node"
-      VARIABLES(106)="PROCNODE_STEPS"
-      VARIABLES(105)="NA"
-      VARIABLES(104)="PTRDEBARR"
-      VARIABLES(103)="NINROWARR"
-      VARIABLES(102)="NINCOLARR"
-      VARIABLES(101)="PTR8ARR"
-      VARIABLES(100)="PTRAR"
-      VARIABLES(99)="FRTELT"
-      VARIABLES(98)="FRTPTR"
-      VARIABLES(97)="FILS"
-      VARIABLES(96)="DAD_STEPS"
-      VARIABLES(95)="FRERE_STEPS"
-      VARIABLES(94)="ND_STEPS"
-      VARIABLES(93)="NE_STEPS"
-      VARIABLES(92)="STEP"
-      VARIABLES(91)="NBSA"
-      VARIABLES(90)="LNA"
-      VARIABLES(89)="KEEP"
-      VARIABLES(88)="IS"
-      VARIABLES(87)="ASS_IRECV"
-      VARIABLES(86)="NSLAVES"
-      VARIABLES(85)="NPROCS"
-      VARIABLES(84)="MYID"
-      VARIABLES(83)="COMM_LOAD"
-      VARIABLES(82)="MYID_NODES"
-      VARIABLES(81)="COMM_NODES"
-      VARIABLES(80)="INST_Number"
-      VARIABLES(79)="MAX_SURF_MASTER"
-      VARIABLES(78)="KEEP8"
-      VARIABLES(77)="pad7"
-      VARIABLES(76)="SAVE_PREFIX"
-      VARIABLES(75)="SAVE_DIR"
-      VARIABLES(74)="WRITE_PROBLEM"
-      VARIABLES(73)="OOC_PREFIX"
-      VARIABLES(72)="OOC_TMPDIR"
-      VARIABLES(71)="VERSION_NUMBER"
-      VARIABLES(70)="MAPPING"
-      VARIABLES(69)="LISTVAR_SCHUR"
-      VARIABLES(68)="SCHUR_CINTERFACE"
-      VARIABLES(67)="SCHUR"
-      VARIABLES(66)="SIZE_SCHUR"
-      VARIABLES(65)="SCHUR_LLD"
-      VARIABLES(64)="SCHUR_NLOC"
-      VARIABLES(63)="SCHUR_MLOC"
-      VARIABLES(62)="NBLOCK"
-      VARIABLES(61)="MBLOCK"
-      VARIABLES(60)="NPCOL"
-      VARIABLES(59)="NPROW"
-      VARIABLES(58)="UNS_PERM"
-      VARIABLES(57)="SYM_PERM"
-      VARIABLES(56)="METIS_OPTIONS"
-      VARIABLES(55)="RINFOG"
-      VARIABLES(54)="RINFO"
-      VARIABLES(53)="CNTL"
-      VARIABLES(52)="COST_SUBTREES"
-      VARIABLES(51)="INFOG"
-      VARIABLES(50)="INFO"
-      VARIABLES(49)="ICNTL"
-      VARIABLES(48)="pad6"
-      VARIABLES(47)="LSOL_loc"
-      VARIABLES(46)="LREDRHS"
-      VARIABLES(45)="LRHS_loc"
-      VARIABLES(44)="Nloc_RHS"
-      VARIABLES(43)="NZ_RHS"
-      VARIABLES(42)="NRHS"
-      VARIABLES(41)="LRHS"
-      VARIABLES(40)="IRHS_loc"
-      VARIABLES(39)="ISOL_loc"
-      VARIABLES(38)="IRHS_PTR"
-      VARIABLES(37)="IRHS_SPARSE"
-      VARIABLES(36)="RHS_loc"
-      VARIABLES(35)="SOL_loc"
-      VARIABLES(34)="RHS_SPARSE"
-      VARIABLES(33)="REDRHS"
-      VARIABLES(32)="RHS"
-      VARIABLES(31)="BLKVAR"
-      VARIABLES(30)="BLKPTR"
-      VARIABLES(29)="pad5"
-      VARIABLES(28)="NBLK"
-      VARIABLES(27)="PERM_IN"
-      VARIABLES(26)="pad4"
-      VARIABLES(25)="A_ELT"
-      VARIABLES(24)="ELTVAR"
-      VARIABLES(23)="ELTPTR"
-      VARIABLES(22)="pad3"
-      VARIABLES(21)="NELT"
-      VARIABLES(20)="pad2"
-      VARIABLES(19)="A_loc"
-      VARIABLES(18)="JCN_loc"
-      VARIABLES(17)="IRN_loc"
-      VARIABLES(16)="NNZ_loc"
-      VARIABLES(15)="pad1"
-      VARIABLES(14)="NZ_loc"
-      VARIABLES(13)="pad0"
-      VARIABLES(12)="ROWSCA"
-      VARIABLES(11)="COLSCA"
-      VARIABLES(10)="JCN"
-      VARIABLES(9)="IRN"
-      VARIABLES(8)="A"
-      VARIABLES(7)="NNZ"
-      VARIABLES(6)="NZ"
-      VARIABLES(5)="N"
-      VARIABLES(4)="JOB"
-      VARIABLES(3)="PAR"
-      VARIABLES(2)="SYM"
-      VARIABLES(1)="COMM"
-      allocate(VARIABLES_ROOT(NBVARIABLES_ROOT),  stat=allocok)
-      if (allocok .GT. 0) THEN
-       id%INFO(1)  =-13
-       id%INFO(2) = NBVARIABLES_ROOT
-      endif
-      CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &        id%COMM, id%MYID )
-      IF ( id%INFO(1) .LT. 0 ) GOTO 100
-      VARIABLES_ROOT(33)="rootpad4"
-      VARIABLES_ROOT(32)="NB_SINGULAR_VALUES"
-      VARIABLES_ROOT(31)="SINGULAR_VALUES"
-      VARIABLES_ROOT(30)="SVD_VT"
-      VARIABLES_ROOT(29)="SVD_U"
-      VARIABLES_ROOT(28)="gridinit_done"
-      VARIABLES_ROOT(27)="yes"
-      VARIABLES_ROOT(26)="rootpad3"
-      VARIABLES_ROOT(25)="QR_RCOND"
-      VARIABLES_ROOT(24)="rootpad2"
-      VARIABLES_ROOT(23)="RHS_ROOT"
-      VARIABLES_ROOT(22)="rootpad1"
-      VARIABLES_ROOT(21)="QR_TAU"
-      VARIABLES_ROOT(20)="SCHUR_POINTER"
-      VARIABLES_ROOT(19)="RHS_CNTR_MASTER_ROOT"
-      VARIABLES_ROOT(18)="IPIV"
-      VARIABLES_ROOT(17)="RG2L"
-      VARIABLES_ROOT(16)="rootpad0"
-      VARIABLES_ROOT(15)="LPIV"
-      VARIABLES_ROOT(14)="CNTXT_BLACS"
-      VARIABLES_ROOT(13)="DESCRIPTOR"
-      VARIABLES_ROOT(12)="TOT_ROOT_SIZE"
-      VARIABLES_ROOT(11)="ROOT_SIZE"
-      VARIABLES_ROOT(10)="RHS_NLOC"
-      VARIABLES_ROOT(9)="SCHUR_LLD"
-      VARIABLES_ROOT(8)="SCHUR_NLOC"
-      VARIABLES_ROOT(7)="SCHUR_MLOC"
-      VARIABLES_ROOT(6)="MYCOL"
-      VARIABLES_ROOT(5)="MYROW"
-      VARIABLES_ROOT(4)="NPCOL"
-      VARIABLES_ROOT(3)="NPROW"
-      VARIABLES_ROOT(2)="NBLOCK"
-      VARIABLES_ROOT(1)="MBLOCK"
-      OOC_INDICES=(/149,150,152,153/)
+      INTEGER, PARAMETER :: S_ASSOCIATED_OOC_FILES=194
+      INTEGER, PARAMETER :: S_pad16=193
+      INTEGER, PARAMETER :: S_Deficiency=192
+      INTEGER, PARAMETER :: S_NB_SINGULAR_VALUES=191
+      INTEGER, PARAMETER :: S_SINGULAR_VALUES=190
+      INTEGER, PARAMETER :: S_MTKO_PROCS_MAP=189
+      INTEGER, PARAMETER :: S_L0_OMP_MAPPING=188
+      INTEGER, PARAMETER :: S_PTR_LEAFS_L0_OMP=187
+      INTEGER, PARAMETER :: S_PERM_L0_OMP=186
+      INTEGER, PARAMETER :: S_VIRT_L0_OMP_MAPPING=185
+      INTEGER, PARAMETER :: S_VIRT_L0_OMP=184
+      INTEGER, PARAMETER :: S_PHYS_L0_OMP=183
+      INTEGER, PARAMETER :: S_IPOOL_A_L0_OMP=182
+      INTEGER, PARAMETER :: S_IPOOL_B_L0_OMP=181
+      INTEGER, PARAMETER :: S_I8_L0_OMP=180
+      INTEGER, PARAMETER :: S_I4_L0_OMP=179
+      INTEGER, PARAMETER :: S_THREAD_LA=178
+      INTEGER, PARAMETER :: S_LL0_OMP_FACTORS=177
+      INTEGER, PARAMETER :: S_LL0_OMP_MAPPING=176
+      INTEGER, PARAMETER :: S_L_VIRT_L0_OMP=175
+      INTEGER, PARAMETER :: S_L_PHYS_L0_OMP=174
+      INTEGER, PARAMETER :: S_LPOOL_B_L0_OMP=173
+      INTEGER, PARAMETER :: S_LPOOL_A_L0_OMP=172
+      INTEGER, PARAMETER :: S_L0_OMP_FACTORS=171
+      INTEGER, PARAMETER :: S_BLRARRAY_ENCODING=170
+      INTEGER, PARAMETER :: S_FDM_F_ENCODING=169
+      INTEGER, PARAMETER :: S_pad13=168
+      INTEGER, PARAMETER :: S_NBGRP=167
+      INTEGER, PARAMETER :: S_LRGROUPS=166
+      INTEGER, PARAMETER :: S_root=165
+      INTEGER, PARAMETER :: S_WORKING=164
+      INTEGER, PARAMETER :: S_IPTR_WORKING=163
+      INTEGER, PARAMETER :: S_pad14=162
+      INTEGER, PARAMETER :: S_SUP_PROC=161
+      INTEGER, PARAMETER :: S_PIVNUL_LIST=160
+      INTEGER, PARAMETER :: S_OOC_FILE_NAMES=159
+      INTEGER, PARAMETER :: S_OOC_FILE_NAME_LENGTH=158
+      INTEGER, PARAMETER :: S_pad12=157
+      INTEGER, PARAMETER :: S_OOC_NB_FILE_TYPE=156
+      INTEGER, PARAMETER :: S_OOC_NB_FILES=155
+      INTEGER, PARAMETER :: S_OOC_TOTAL_NB_NODES=154
+      INTEGER, PARAMETER :: S_OOC_VADDR=153
+      INTEGER, PARAMETER :: S_OOC_SIZE_OF_BLOCK=152
+      INTEGER, PARAMETER :: S_OOC_INODE_SEQUENCE=151
+      INTEGER, PARAMETER :: S_OOC_MAX_NB_NODES_FOR_ZONE=150
+      INTEGER, PARAMETER :: S_INSTANCE_NUMBER=149
+      INTEGER, PARAMETER :: S_CB_SON_SIZE=148
+      INTEGER, PARAMETER :: S_DKEEP=147
+      INTEGER, PARAMETER :: S_LWK_USER=146
+      INTEGER, PARAMETER :: S_NBSA_LOCAL=145
+      INTEGER, PARAMETER :: S_WK_USER=144
+      INTEGER, PARAMETER :: S_CROIX_MANU=143
+      INTEGER, PARAMETER :: S_SCHED_SBTR=142
+      INTEGER, PARAMETER :: S_SCHED_GRP=141
+      INTEGER, PARAMETER :: S_SCHED_DEP=140
+      INTEGER, PARAMETER :: S_SBTR_ID=139
+      INTEGER, PARAMETER :: S_DEPTH_FIRST_SEQ=138
+      INTEGER, PARAMETER :: S_DEPTH_FIRST=137
+      INTEGER, PARAMETER :: S_MY_NB_LEAF=136
+      INTEGER, PARAMETER :: S_MY_FIRST_LEAF=135
+      INTEGER, PARAMETER :: S_MY_ROOT_SBTR=134
+      INTEGER, PARAMETER :: S_COST_TRAV=133
+      INTEGER, PARAMETER :: S_MEM_SUBTREE=132
+      INTEGER, PARAMETER :: S_RHSINTR=131
+      INTEGER, PARAMETER :: S_GLOB2LOC_SOL=130
+      INTEGER, PARAMETER :: S_pad11=129
+      INTEGER, PARAMETER :: S_GLOB2LOC_SOL_ALLOC=128
+      INTEGER, PARAMETER :: S_GLOB2LOC_RHS=127
+      INTEGER, PARAMETER :: S_MEM_DIST=126
+      INTEGER, PARAMETER :: S_I_AM_CAND=125
+      INTEGER, PARAMETER :: S_TAB_POS_IN_PERE=124
+      INTEGER, PARAMETER :: S_FUTURE_NIV2=123
+      INTEGER, PARAMETER :: S_ISTEP_TO_INIV2=122
+      INTEGER, PARAMETER :: S_CANDIDATES=121
+      INTEGER, PARAMETER :: S_ELTPROC=120
+      INTEGER, PARAMETER :: S_LELTVAR=119
+      INTEGER, PARAMETER :: S_NELT_loc=118
+      INTEGER, PARAMETER :: S_PROCNODE=117
+      INTEGER, PARAMETER :: S_S=116
+      INTEGER, PARAMETER :: S_PTRFAC=115
+      INTEGER, PARAMETER :: S_PTLUST_S=114
+      INTEGER, PARAMETER :: S_Step2node=113
+      INTEGER, PARAMETER :: S_PROCNODE_STEPS=112
+      INTEGER, PARAMETER :: S_NA=111
+      INTEGER, PARAMETER :: S_PTRDEBARR=110
+      INTEGER, PARAMETER :: S_NINROWARR=109
+      INTEGER, PARAMETER :: S_NINCOLARR=108
+      INTEGER, PARAMETER :: S_PTR8ARR=107
+      INTEGER, PARAMETER :: S_PTRAR=106
+      INTEGER, PARAMETER :: S_FRTELT=105
+      INTEGER, PARAMETER :: S_FRTPTR=104
+      INTEGER, PARAMETER :: S_FILS=103
+      INTEGER, PARAMETER :: S_DAD_STEPS=102
+      INTEGER, PARAMETER :: S_FRERE_STEPS=101
+      INTEGER, PARAMETER :: S_ND_STEPS=100
+      INTEGER, PARAMETER :: S_NE_STEPS=99
+      INTEGER, PARAMETER :: S_STEP=98
+      INTEGER, PARAMETER :: S_NBSA=97
+      INTEGER, PARAMETER :: S_LNA=96
+      INTEGER, PARAMETER :: S_KEEP=95
+      INTEGER, PARAMETER :: S_IS=94
+      INTEGER, PARAMETER :: S_ASS_IRECV=93
+      INTEGER, PARAMETER :: S_NSLAVES=92
+      INTEGER, PARAMETER :: S_NPROCS=91
+      INTEGER, PARAMETER :: S_MYID=90
+      INTEGER, PARAMETER :: S_COMM_LOAD=89
+      INTEGER, PARAMETER :: S_MYID_NODES=88
+      INTEGER, PARAMETER :: S_COMM_NODES=87
+      INTEGER, PARAMETER :: S_INST_Number=86
+      INTEGER, PARAMETER :: S_MAX_SURF_MASTER=85
+      INTEGER, PARAMETER :: S_KEEP8=84
+      INTEGER, PARAMETER :: S_pad7=83
+      INTEGER, PARAMETER :: S_SAVE_PREFIX=82
+      INTEGER, PARAMETER :: S_SAVE_DIR=81
+      INTEGER, PARAMETER :: S_WRITE_PROBLEM=80
+      INTEGER, PARAMETER :: S_OOC_PREFIX=79
+      INTEGER, PARAMETER :: S_OOC_TMPDIR=78
+      INTEGER, PARAMETER :: S_VERSION_NUMBER=77
+      INTEGER, PARAMETER :: S_MAPPING=76
+      INTEGER, PARAMETER :: S_LISTVAR_SCHUR=75
+      INTEGER, PARAMETER :: S_SCHUR_CINTERFACE=74
+      INTEGER, PARAMETER :: S_SCHUR=73
+      INTEGER, PARAMETER :: S_SIZE_SCHUR=72
+      INTEGER, PARAMETER :: S_SCHUR_LLD=71
+      INTEGER, PARAMETER :: S_SCHUR_NLOC=70
+      INTEGER, PARAMETER :: S_SCHUR_MLOC=69
+      INTEGER, PARAMETER :: S_NBLOCK=68
+      INTEGER, PARAMETER :: S_MBLOCK=67
+      INTEGER, PARAMETER :: S_NPCOL=66
+      INTEGER, PARAMETER :: S_NPROW=65
+      INTEGER, PARAMETER :: S_UNS_PERM=64
+      INTEGER, PARAMETER :: S_SYM_PERM=63
+      INTEGER, PARAMETER :: S_METIS_OPTIONS=62
+      INTEGER, PARAMETER :: S_RINFOG=61
+      INTEGER, PARAMETER :: S_RINFO=60
+      INTEGER, PARAMETER :: S_CNTL=59
+      INTEGER, PARAMETER :: S_COST_SUBTREES=58
+      INTEGER, PARAMETER :: S_INFOG=57
+      INTEGER, PARAMETER :: S_INFO=56
+      INTEGER, PARAMETER :: S_ICNTL=55
+      INTEGER, PARAMETER :: S_pad6=54
+      INTEGER, PARAMETER :: S_LD_RHSINTR=53
+      INTEGER, PARAMETER :: S_NSOL_loc=52
+      INTEGER, PARAMETER :: S_LSOL_loc=51
+      INTEGER, PARAMETER :: S_LREDRHS=50
+      INTEGER, PARAMETER :: S_LRHS_loc=49
+      INTEGER, PARAMETER :: S_Nloc_RHS=48
+      INTEGER, PARAMETER :: S_NZ_RHS=47
+      INTEGER, PARAMETER :: S_NRHS=46
+      INTEGER, PARAMETER :: S_LRHS=45
+      INTEGER, PARAMETER :: S_IRHS_loc=44
+      INTEGER, PARAMETER :: S_ISOL_loc=43
+      INTEGER, PARAMETER :: S_IRHS_PTR=42
+      INTEGER, PARAMETER :: S_IRHS_SPARSE=41
+      INTEGER, PARAMETER :: S_RHS_loc=40
+      INTEGER, PARAMETER :: S_SOL_loc=39
+      INTEGER, PARAMETER :: S_RHS_SPARSE=38
+      INTEGER, PARAMETER :: S_REDRHS=37
+      INTEGER, PARAMETER :: S_RHS=36
+      INTEGER, PARAMETER :: S_BLKVAR=35
+      INTEGER, PARAMETER :: S_BLKPTR=34
+      INTEGER, PARAMETER :: S_pad5=33
+      INTEGER, PARAMETER :: S_NBLK=32
+      INTEGER, PARAMETER :: S_PERM_IN=31
+      INTEGER, PARAMETER :: S_pad4=30
+      INTEGER, PARAMETER :: S_A_ELT=29
+      INTEGER, PARAMETER :: S_ELTVAR=28
+      INTEGER, PARAMETER :: S_ELTPTR=27
+      INTEGER, PARAMETER :: S_pad3=26
+      INTEGER, PARAMETER :: S_NELT=25
+      INTEGER, PARAMETER :: S_pad2=24
+      INTEGER, PARAMETER :: S_A_loc=23
+      INTEGER, PARAMETER :: S_JCN_loc=22
+      INTEGER, PARAMETER :: S_IRN_loc=21
+      INTEGER, PARAMETER :: S_NNZ_loc=20
+      INTEGER, PARAMETER :: S_pad1=19
+      INTEGER, PARAMETER :: S_NZ_loc=18
+      INTEGER, PARAMETER :: S_PIVOTS=17
+      INTEGER, PARAMETER :: S_COLIND=16
+      INTEGER, PARAMETER :: S_ROWIND=15
+      INTEGER, PARAMETER :: S_ROWSCA_loc=14
+      INTEGER, PARAMETER :: S_COLSCA_loc=13
+      INTEGER, PARAMETER :: S_ROWSCA=12
+      INTEGER, PARAMETER :: S_COLSCA=11
+      INTEGER, PARAMETER :: S_JCN=10
+      INTEGER, PARAMETER :: S_IRN=9
+      INTEGER, PARAMETER :: S_A=8
+      INTEGER, PARAMETER :: S_NNZ=7
+      INTEGER, PARAMETER :: S_NZ=6
+      INTEGER, PARAMETER :: S_N=5
+      INTEGER, PARAMETER :: S_JOB=4
+      INTEGER, PARAMETER :: S_PAR=3
+      INTEGER, PARAMETER :: S_SYM=2
+      INTEGER, PARAMETER :: S_COMM=1
+      INTEGER,  PARAMETER :: R_rootpad4=33
+      INTEGER,  PARAMETER :: R_NB_SINGULAR_VALUES=32
+      INTEGER,  PARAMETER :: R_SINGULAR_VALUES=31
+      INTEGER,  PARAMETER :: R_SVD_VT=30
+      INTEGER,  PARAMETER :: R_SVD_U=29
+      INTEGER,  PARAMETER :: R_gridinit_done=28
+      INTEGER,  PARAMETER :: R_yes=27
+      INTEGER,  PARAMETER :: R_rootpad3=26
+      INTEGER,  PARAMETER :: R_QR_RCOND=25
+      INTEGER,  PARAMETER :: R_rootpad2=24
+      INTEGER,  PARAMETER :: R_RHS_ROOT=23
+      INTEGER,  PARAMETER :: R_rootpad1=22
+      INTEGER,  PARAMETER :: R_QR_TAU=21
+      INTEGER,  PARAMETER :: R_SCHUR_POINTER=20
+      INTEGER,  PARAMETER :: R_RHS_CNTR_MASTER_ROOT=19
+      INTEGER,  PARAMETER :: R_IPIV=18
+      INTEGER,  PARAMETER :: R_RG2L=17
+      INTEGER,  PARAMETER :: R_rootpad0=16
+      INTEGER,  PARAMETER :: R_LPIV=15
+      INTEGER,  PARAMETER :: R_CNTXT_BLACS=14
+      INTEGER,  PARAMETER :: R_DESCRIPTOR=13
+      INTEGER,  PARAMETER :: R_TOT_ROOT_SIZE=12
+      INTEGER,  PARAMETER :: R_ROOT_SIZE=11
+      INTEGER,  PARAMETER :: R_RHS_NLOC=10
+      INTEGER,  PARAMETER :: R_SCHUR_LLD=9
+      INTEGER,  PARAMETER :: R_SCHUR_NLOC=8
+      INTEGER,  PARAMETER :: R_SCHUR_MLOC=7
+      INTEGER,  PARAMETER :: R_MYCOL=6
+      INTEGER,  PARAMETER :: R_MYROW=5
+      INTEGER,  PARAMETER :: R_NPCOL=4
+      INTEGER,  PARAMETER :: R_NPROW=3
+      INTEGER,  PARAMETER :: R_NBLOCK=2
+      INTEGER,  PARAMETER :: R_MBLOCK=1
+      OOC_INDICES=(/155,156,158,159/)
       SIZE_INT = id%KEEP(34)
       SIZE_INT8 = id%KEEP(34)*id%KEEP(10)
       SIZE_RL_OR_DBL = id%KEEP(16)
@@ -964,8 +959,8 @@ C
       SIZE_GEST_FRONT_DATA=0
       SIZE_VARIABLES_L0FAC=0
       SIZE_GEST_L0FAC=0
-      if(trim(mode).EQ."memory_save") then
-      elseif(trim(mode).EQ."save") then
+      if(mode.EQ.memory_save_mode) then
+      elseif(mode.EQ.save_mode) then
          write(unit,iostat=err) "MUMPS"
          if(err.ne.0) THEN
             id%INFO(1) = -72
@@ -1125,8 +1120,8 @@ C
      &           +int(2*id%KEEP(34)*1,kind=8)
 #endif
          ENDIF
-      elseif((trim(mode).EQ."restore").OR.
-     &        (trim(mode).EQ."restore_ooc")) then
+      elseif((mode.EQ.restore_mode).OR.
+     &        (mode.EQ.restore_ooc_mode)) then
         CALL MUMPS_READ_HEADER(unit,err,size_read,SIZE_INT,SIZE_INT8,
      &       TOTAL_FILE_SIZE, TOTAL_STRUC_SIZE, READ_ARITH,
      &       READ_INT_TYPE_64, READ_OOC_FILE_NAME_LENGTH,
@@ -1144,14 +1139,14 @@ C
      &        id%COMM, id%MYID )
          IF ( id%INFO(1) .LT. 0 ) GOTO 100
          BASIC_CHECK = .false.
-         IF (trim(mode).EQ."restore_ooc") THEN
+         IF (mode.EQ.restore_ooc_mode) THEN
            BASIC_CHECK = .true.
          ENDIF
          CALL DMUMPS_CHECK_HEADER(id,BASIC_CHECK,READ_INT_TYPE_64,
      &              READ_HASH, READ_NPROCS,
      &              READ_ARITH, READ_SYM, READ_PAR)
          IF (id%INFO(1) .LT. 0) GOTO 100
-      elseif(trim(mode).EQ."fake_restore") then
+      elseif(mode.EQ.fake_restore_mode) then
          read(unit,iostat=err) READ_HASH
          if(err.ne.0) GOTO 100
          read(unit,iostat=err) TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
@@ -1163,11 +1158,10 @@ C
       endif
       DO j=1,size(OOC_INDICES)
          i1=OOC_INDICES(j)
-         TMP_STRING1 = VARIABLES(i1)
-         SELECT CASE(TMP_STRING1)
-         CASE("OOC_NB_FILES")
+         SELECT CASE(i1)
+         CASE(S_OOC_NB_FILES)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%OOC_NB_FILES)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%OOC_NB_FILES,1)*SIZE_INT
@@ -1175,7 +1169,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%OOC_NB_FILES)) THEN
                   write(unit,iostat=err) size(id%OOC_NB_FILES,1)
                   if(err.ne.0) then
@@ -1207,8 +1201,8 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif((trim(mode).EQ."restore").OR.
-     &             (trim(mode).EQ."restore_ooc")) then
+            elseif((mode.EQ.restore_mode).OR.
+     &             (mode.EQ.restore_ooc_mode)) then
                nullify(id%OOC_NB_FILES)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -1247,11 +1241,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("OOC_NB_FILE_TYPE")
+         CASE(S_OOC_NB_FILE_TYPE)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%OOC_NB_FILE_TYPE
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1261,8 +1255,8 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif((trim(mode).EQ."restore").OR.
-     &             (trim(mode).EQ."restore_ooc")) then
+            elseif((mode.EQ.restore_mode).OR.
+     &             (mode.EQ.restore_ooc_mode)) then
                SIZE_VARIABLES(i1)=SIZE_INT
                read(unit,iostat=err) id%OOC_NB_FILE_TYPE
                if(err.ne.0) THEN
@@ -1274,9 +1268,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("OOC_FILE_NAMES")
+         CASE(S_OOC_FILE_NAMES)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%OOC_FILE_NAMES)) THEN
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=size(id%OOC_FILE_NAMES,1)
@@ -1285,7 +1279,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*3
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%OOC_FILE_NAMES)) THEN
                   write(unit,iostat=err) size(id%OOC_FILE_NAMES,1)
      &                 ,size(id%OOC_FILE_NAMES,2)
@@ -1318,8 +1312,8 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif((trim(mode).EQ."restore").OR.
-     &             (trim(mode).EQ."restore_ooc")) then
+            elseif((mode.EQ.restore_mode).OR.
+     &             (mode.EQ.restore_ooc_mode)) then
                nullify(id%OOC_FILE_NAMES)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -1360,9 +1354,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("OOC_FILE_NAME_LENGTH")
+         CASE(S_OOC_FILE_NAME_LENGTH)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%OOC_FILE_NAME_LENGTH)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
@@ -1371,7 +1365,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%OOC_FILE_NAME_LENGTH)) THEN
                   write(unit,iostat=err) size(id%OOC_FILE_NAME_LENGTH,1)
                   if(err.ne.0) then
@@ -1403,8 +1397,8 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif((trim(mode).EQ."restore").OR.
-     &             (trim(mode).EQ."restore_ooc")) then
+            elseif((mode.EQ.restore_mode).OR.
+     &             (mode.EQ.restore_ooc_mode)) then
                nullify(id%OOC_FILE_NAME_LENGTH)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -1447,111 +1441,41 @@ C
          CASE DEFAULT
          END SELECT
       ENDDO
-      if(trim(mode).EQ."restore_ooc") then
+      if(mode.EQ.restore_ooc_mode) then
          goto 200
       endif
       DO i1=1,NBVARIABLES 
-         TMP_STRING1 = VARIABLES(i1)
-         SELECT CASE(TMP_STRING1)
-         CASE("COMM")
-            if(trim(mode).EQ."memory_save") then
+         SELECT CASE(i1)
+         CASE(S_COMM)
+            if(mode.EQ.memory_save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
             endif
-         CASE("SYM")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%SYM
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%SYM
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read,
-     &                 id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("PAR")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%PAR
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%PAR
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("JOB")
-            if(trim(mode).EQ."memory_save") then
+         CASE(S_SYM)
+           CALL MUMPS_SAVE_INT(id%SYM)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_PAR)
+           CALL MUMPS_SAVE_INT(id%PAR)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_JOB)
+            if(mode.EQ.memory_save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
             endif
-         CASE("N")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%N
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%N
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("ICNTL")
+         CASE(S_N)
+           CALL MUMPS_SAVE_INT(id%N)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_ICNTL)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%ICNTL,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%ICNTL
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1561,7 +1485,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%ICNTL,1)
                read(unit,iostat=err) id%ICNTL
                if(err.ne.0) THEN
@@ -1573,11 +1497,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("INFO")
+         CASE(S_INFO)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%INFO,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) INFO1,INFO2
      &              ,id%INFO(3:size(id%INFO,1))
                if(err.ne.0) then
@@ -1588,7 +1512,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%INFO,1)
                read(unit,iostat=err) INFO1,INFO2
      &              ,id%INFO(3:size(id%INFO,1))
@@ -1601,11 +1525,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("INFOG")
+         CASE(S_INFOG)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%INFOG,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) INFOG1,INFOG2
      &              ,id%INFOG(3:size(id%INFOG,1))
                if(err.ne.0) then
@@ -1616,7 +1540,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%INFOG,1)
                read(unit,iostat=err) INFOG1,INFOG2
      &              ,id%INFOG(3:size(id%INFOG,1))
@@ -1629,11 +1553,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("COST_SUBTREES")
+         CASE(S_COST_SUBTREES)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%COST_SUBTREES
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1643,7 +1567,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL
                read(unit,iostat=err) id%COST_SUBTREES
                if(err.ne.0) THEN
@@ -1655,11 +1579,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("CNTL")
+         CASE(S_CNTL)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL*size(id%CNTL,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%CNTL
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1669,7 +1593,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL*size(id%CNTL,1)
                read(unit,iostat=err) id%CNTL
                if(err.ne.0) THEN
@@ -1681,11 +1605,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("RINFO")
+         CASE(S_RINFO)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL*size(id%RINFO,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%RINFO
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1695,7 +1619,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL*size(id%RINFO,1)
                read(unit,iostat=err) id%RINFO
                if(err.ne.0) THEN
@@ -1707,11 +1631,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("RINFOG")
+         CASE(S_RINFOG)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL*size(id%RINFOG,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%RINFOG
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1721,7 +1645,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL*size(id%RINFOG,1)
                read(unit,iostat=err) id%RINFOG
                if(err.ne.0) THEN
@@ -1733,11 +1657,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("KEEP8")
+         CASE(S_KEEP8)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8*size(id%KEEP8,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%KEEP8
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1747,9 +1671,13 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8*size(id%KEEP8,1)
+               KEEP883_SAVE=id%KEEP8(83)
+               KEEP884_SAVE=id%KEEP8(84)
                read(unit,iostat=err) id%KEEP8
+               id%KEEP8(83)=KEEP883_SAVE
+               id%KEEP8(84)=KEEP884_SAVE
                if(err.ne.0) THEN
                   id%INFO(1) = -75
                   CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
@@ -1759,11 +1687,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("KEEP")
+         CASE(S_KEEP)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%KEEP,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%KEEP
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1773,7 +1701,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%KEEP,1)
                KEEP410_SAVE = id%KEEP(410)
                KEEP411_SAVE = id%KEEP(411)
@@ -1789,11 +1717,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("DKEEP")
+         CASE(S_DKEEP)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL*size(id%DKEEP,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%DKEEP
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1803,7 +1731,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL*size(id%DKEEP,1)
                read(unit,iostat=err) id%DKEEP
                if(err.ne.0) THEN
@@ -1815,37 +1743,14 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("NZ")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NZ
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NZ
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("NNZ")
+         CASE(S_NZ)
+           CALL MUMPS_SAVE_INT(id%NZ)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NNZ)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%NNZ
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1855,7 +1760,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8
                read(unit,iostat=err) id%NNZ
                if(err.ne.0) THEN
@@ -1867,174 +1772,32 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif  
-         CASE("A")
-         CASE("IRN")
-         CASE("JCN")
-         CASE("COLSCA")
+         CASE(S_A)
+         CASE(S_IRN)
+         CASE(S_JCN)
+         CASE(S_COLSCA)
             IF(id%KEEP(52).NE.-1) THEN
-               NbRecords(i1)=2
-               if(trim(mode).EQ."memory_save") then
-                  IF(associated(id%COLSCA)) THEN
-                     SIZE_GEST(i1)=SIZE_INT
-                     SIZE_VARIABLES(i1)=size(id%COLSCA,1)*SIZE_RL_OR_DBL
-                  ELSE
-                     SIZE_GEST(i1)=SIZE_INT*2
-                     SIZE_VARIABLES(i1)=0_8
-                  ENDIF
-               elseif(trim(mode).EQ."save") then
-                  IF(associated(id%COLSCA)) THEN
-                     write(unit,iostat=err) size(id%COLSCA,1)
-                     if(err.ne.0) then
-                        id%INFO(1) = -72
-                        CALL MUMPS_SETI8TOI4(
-     &                       TOTAL_FILE_SIZE-size_written,
-     &                       id%INFO(2))
-                     endif
-                     write(unit,iostat=err) id%COLSCA
-                  ELSE
-                     write(unit,iostat=err) -999
-                     if(err.ne.0) then
-                        id%INFO(1) = -72
-                        CALL MUMPS_SETI8TOI4(
-     &                       TOTAL_FILE_SIZE-size_written,
-     &                       id%INFO(2))
-                     endif
-                     write(unit,iostat=err) -999
-                  ENDIF 
-                  if(err.ne.0) then
-                     id%INFO(1) = -72
-                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-                  endif
-                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &                 id%COMM, id%MYID )
-                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
-                  nullify(id%COLSCA)
-                  read(unit,iostat=err) size_array1
-                  if(err.ne.0) THEN
-                     id%INFO(1) = -75
-                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                    ,id%INFO(2))
-                  endif
-                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &                 id%COMM, id%MYID )
-                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
-                  if(size_array1.EQ.-999) then
-                     SIZE_GEST(i1)=SIZE_INT*2
-                     SIZE_VARIABLES(i1)=0_8
-                     read(unit,iostat=err) dummy
-                  else
-                     SIZE_GEST(i1)=SIZE_INT
-                     SIZE_VARIABLES(i1)=size_array1*SIZE_RL_OR_DBL
-                     allocate(id%COLSCA(size_array1), stat=allocok)
-                     if (allocok .GT. 0) THEN
-                        id%INFO(1) = -78
-                        CALL MUMPS_SETI8TOI4(
-     &                       TOTAL_STRUC_SIZE-size_allocated
-     &                       ,id%INFO(2))
-                     endif
-                     read(unit,iostat=err) id%COLSCA
-                  endif
-                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &                 id%COMM, id%MYID )
-                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
-                  if(err.ne.0) THEN
-                     id%INFO(1) = -75
-                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                    ,id%INFO(2))
-                  endif
-                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &                 id%COMM, id%MYID )
-                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               endif
+              CALL MUMPS_SAVERSTR_REALARRAY(id%COLSCA)
             ELSE
             ENDIF
-         CASE("ROWSCA")
+            IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_ROWSCA)
             IF(id%KEEP(52).NE.-1) THEN
-               NbRecords(i1)=2
-               if(trim(mode).EQ."memory_save") then
-                  IF(associated(id%ROWSCA)) THEN
-                     SIZE_GEST(i1)=SIZE_INT
-                     SIZE_VARIABLES(i1)=size(id%ROWSCA,1)*SIZE_RL_OR_DBL
-                  ELSE
-                     SIZE_GEST(i1)=SIZE_INT*2
-                     SIZE_VARIABLES(i1)=0_8
-                  ENDIF
-               elseif(trim(mode).EQ."save") then
-                  IF(associated(id%ROWSCA)) THEN
-                     write(unit,iostat=err) size(id%ROWSCA,1)
-                     if(err.ne.0) then
-                        id%INFO(1) = -72
-                        CALL MUMPS_SETI8TOI4(
-     &                       TOTAL_FILE_SIZE-size_written,
-     &                       id%INFO(2))
-                     endif
-                     write(unit,iostat=err) id%ROWSCA
-                  ELSE
-                     write(unit,iostat=err) -999
-                     if(err.ne.0) then
-                        id%INFO(1) = -72
-                        CALL MUMPS_SETI8TOI4(
-     &                       TOTAL_FILE_SIZE-size_written,
-     &                       id%INFO(2))
-                     endif
-                     write(unit,iostat=err) -999
-                  ENDIF 
-                  if(err.ne.0) then
-                     id%INFO(1) = -72
-                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-                  endif
-                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &                 id%COMM, id%MYID )
-                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
-                  nullify(id%ROWSCA)
-                  read(unit,iostat=err) size_array1
-                  if(err.ne.0) THEN
-                     id%INFO(1) = -75
-                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                    ,id%INFO(2))
-                  endif
-                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &                 id%COMM, id%MYID )
-                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
-                  if(size_array1.EQ.-999) then
-                     SIZE_GEST(i1)=SIZE_INT*2
-                     SIZE_VARIABLES(i1)=0_8
-                     read(unit,iostat=err) dummy
-                  else
-                     SIZE_GEST(i1)=SIZE_INT
-                     SIZE_VARIABLES(i1)=size_array1*SIZE_RL_OR_DBL
-                     allocate(id%ROWSCA(size_array1), stat=allocok)
-                     if (allocok .GT. 0) THEN
-                        id%INFO(1) = -78
-                        CALL MUMPS_SETI8TOI4(
-     &                       TOTAL_STRUC_SIZE-size_allocated
-     &                       ,id%INFO(2))
-                     endif
-                     read(unit,iostat=err) id%ROWSCA
-                  endif
-                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &                 id%COMM, id%MYID )
-                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
-                  if(err.ne.0) THEN
-                     id%INFO(1) = -75
-                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                    ,id%INFO(2))
-                  endif 
-                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &                 id%COMM, id%MYID )
-                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               endif
+              CALL MUMPS_SAVERSTR_REALARRAY(id%ROWSCA)
             ELSE
             ENDIF
-         CASE("NZ_loc")
+            IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_COLSCA_loc)
+            CALL MUMPS_SAVERSTR_REALARRAY(id%COLSCA_loc)
+            IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_ROWSCA_loc)
+            CALL MUMPS_SAVERSTR_REALARRAY(id%ROWSCA_loc)
+            IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NZ_loc)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%NZ_loc
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -2044,7 +1807,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT
                read(unit,iostat=err) id%NZ_loc
                if(err.ne.0) THEN
@@ -2056,11 +1819,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("NNZ_loc")
+         CASE(S_NNZ_loc)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%NNZ_loc
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -2070,7 +1833,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8
                read(unit,iostat=err) id%NNZ_loc
                if(err.ne.0) THEN
@@ -2082,215 +1845,67 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("IRN_loc")
-         CASE("JCN_loc")
-         CASE("A_loc")
-         CASE("NELT")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NELT
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NELT
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("NBLK")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NBLK
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NBLK
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("ELTPTR")
-         CASE("ELTVAR")
-         CASE("A_ELT")
-         CASE("PERM_IN")
-         CASE("BLKPTR")
-         CASE("BLKVAR")
-         CASE("RHS")
-         CASE("REDRHS")
-         CASE("RHS_SPARSE")
-         CASE("SOL_loc")
-         CASE("RHS_loc")
-         CASE("IRHS_SPARSE")
-         CASE("IRHS_PTR")
-         CASE("ISOL_loc")
-         CASE("IRHS_loc")
-         CASE("LRHS")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%LRHS
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%LRHS
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("NRHS")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NRHS
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NRHS
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("NZ_RHS")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NZ_RHS
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NZ_RHS
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("LRHS_loc")
-         CASE("Nloc_RHS")
-         CASE("LSOL_loc")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%LSOL_loc
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%LSOL_loc
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("LREDRHS")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%LREDRHS
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%LREDRHS
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("SYM_PERM")
+         CASE(S_IRN_loc)
+         CASE(S_JCN_loc)
+         CASE(S_A_loc)
+         CASE(S_NELT)
+           CALL MUMPS_SAVE_INT(id%NELT)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NBLK)
+           CALL MUMPS_SAVE_INT(id%NBLK)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_ELTPTR)
+         CASE(S_ELTVAR)
+         CASE(S_A_ELT)
+         CASE(S_PERM_IN)
+         CASE(S_BLKPTR)
+         CASE(S_BLKVAR)
+         CASE(S_COLIND)
+         CASE(S_PIVOTS)
+         CASE(S_RHS)
+         CASE(S_REDRHS)
+         CASE(S_ROWIND)
+         CASE(S_RHS_SPARSE)
+         CASE(S_SOL_loc)
+         CASE(S_RHS_loc)
+         CASE(S_IRHS_SPARSE)
+         CASE(S_IRHS_PTR)
+         CASE(S_ISOL_loc)
+         CASE(S_IRHS_loc)
+         CASE(S_LRHS)
+         CALL MUMPS_SAVE_INT(id%LRHS)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NRHS)
+         CALL MUMPS_SAVE_INT(id%NRHS)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NZ_RHS)
+         CALL MUMPS_SAVE_INT(id%NZ_RHS)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_LRHS_loc)
+         CALL MUMPS_SAVE_INT(id%LRHS_loc)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_Nloc_RHS)
+         CALL MUMPS_SAVE_INT(id%Nloc_RHS)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_LD_RHSINTR)
+         CALL MUMPS_SAVE_INT(id%LD_RHSINTR)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NSOL_loc)
+         CALL MUMPS_SAVE_INT(id%NSOL_loc)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_LSOL_loc)
+         CALL MUMPS_SAVE_INT(id%LSOL_loc)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_LREDRHS)
+         CALL MUMPS_SAVE_INT(id%LREDRHS)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_SYM_PERM)
             CALL DMUMPS_SAVE_INT_SHPTR_ARRAY(id%SYM_PERM
      &           ) 
             IF (id%INFO(1) .LT. 0 ) GOTO 100
-         CASE("UNS_PERM")
+         CASE(S_UNS_PERM)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%UNS_PERM)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%UNS_PERM,1)*SIZE_INT
@@ -2298,7 +1913,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%UNS_PERM)) THEN
                   write(unit,iostat=err) size(id%UNS_PERM,1)
                   if(err.ne.0) then
@@ -2330,7 +1945,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%UNS_PERM)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -2369,222 +1984,36 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("NPROW")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NPROW
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NPROW
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("NPCOL")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NPCOL
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               NbRecords(i1)=1
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NPCOL
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("MBLOCK")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%MBLOCK
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%MBLOCK
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("NBLOCK")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NBLOCK
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NBLOCK
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("SCHUR_MLOC")
-             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%SCHUR_MLOC
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%SCHUR_MLOC
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("SCHUR_NLOC")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%SCHUR_NLOC
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%SCHUR_NLOC
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("SCHUR_LLD")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%SCHUR_LLD
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%SCHUR_LLD
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("SIZE_SCHUR")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%SIZE_SCHUR
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               NbRecords(i1)=1
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%SIZE_SCHUR
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("SCHUR")
-         CASE("SCHUR_CINTERFACE")
-          CASE("LISTVAR_SCHUR")
-         CASE("MAPPING")
+         CASE(S_NPROW)
+         CALL MUMPS_SAVE_INT(id%NPROW)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NPCOL)
+         CALL MUMPS_SAVE_INT(id%NPCOL)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_MBLOCK)
+         CALL MUMPS_SAVE_INT(id%MBLOCK)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NBLOCK)
+         CALL MUMPS_SAVE_INT(id%NBLOCK)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_SCHUR_MLOC)
+         CALL MUMPS_SAVE_INT(id%SCHUR_MLOC)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_SCHUR_NLOC)
+         CALL MUMPS_SAVE_INT(id%SCHUR_NLOC)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_SCHUR_LLD)
+         CALL MUMPS_SAVE_INT(id%SCHUR_LLD)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_SIZE_SCHUR)
+         CALL MUMPS_SAVE_INT(id%SIZE_SCHUR)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_SCHUR)
+         CASE(S_SCHUR_CINTERFACE)
+          CASE(S_LISTVAR_SCHUR)
+         CASE(S_MAPPING)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%MAPPING)) THEN
                   SIZE_GEST(i1)=SIZE_INT8
                   SIZE_VARIABLES(i1)=id%KEEP8(28)*SIZE_INT
@@ -2592,7 +2021,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT8+SIZE_INT
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%MAPPING)) THEN
                   write(unit,iostat=err) id%KEEP8(28)
                   if(err.ne.0) then
@@ -2624,7 +2053,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%MAPPING)
                read(unit,iostat=err) size_array_INT8_1
                if(err.ne.0) THEN
@@ -2663,12 +2092,12 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("VERSION_NUMBER")
+         CASE(S_VERSION_NUMBER)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=len(id%VERSION_NUMBER)
      &              *SIZE_CHARACTER
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%VERSION_NUMBER
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -2678,7 +2107,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=len(id%VERSION_NUMBER)
      &              *SIZE_CHARACTER
                read(unit,iostat=err) id%VERSION_NUMBER
@@ -2691,12 +2120,12 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("OOC_TMPDIR")
+         CASE(S_OOC_TMPDIR)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=len(id%OOC_TMPDIR)
      &              *SIZE_CHARACTER
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%OOC_TMPDIR
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -2706,7 +2135,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=len(id%OOC_TMPDIR)
      &              *SIZE_CHARACTER
                read(unit,iostat=err) id%OOC_TMPDIR
@@ -2719,12 +2148,12 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("OOC_PREFIX")
+         CASE(S_OOC_PREFIX)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=len(id%OOC_PREFIX)
      &              *SIZE_CHARACTER
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%OOC_PREFIX
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -2735,7 +2164,7 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
                NbRecords(i1)=1
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=len(id%OOC_PREFIX)
      &              *SIZE_CHARACTER
                read(unit,iostat=err) id%OOC_PREFIX
@@ -2748,12 +2177,12 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("WRITE_PROBLEM")
+         CASE(S_WRITE_PROBLEM)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=len(id%WRITE_PROBLEM)
      &              *SIZE_CHARACTER
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%WRITE_PROBLEM
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -2763,7 +2192,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=len(id%WRITE_PROBLEM)
      &              *SIZE_CHARACTER
                read(unit,iostat=err) id%WRITE_PROBLEM
@@ -2776,11 +2205,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("MAX_SURF_MASTER")
+         CASE(S_MAX_SURF_MASTER)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%MAX_SURF_MASTER
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -2790,7 +2219,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8
                read(unit,iostat=err) id%MAX_SURF_MASTER
                if(err.ne.0) THEN
@@ -2802,181 +2231,43 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("INST_Number")
-               NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%INST_Number
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%INST_Number
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("COMM_NODES")
-            if(trim(mode).EQ."memory_save") then
+         CASE(S_INST_Number)
+           CALL MUMPS_SAVE_INT(id%INST_Number)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_COMM_NODES)
+            if(mode.EQ.memory_save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
             endif
-         CASE("MYID_NODES")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%MYID_NODES
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%MYID_NODES
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("COMM_LOAD")
-            if(trim(mode).EQ."memory_save") then
+         CASE(S_MYID_NODES)
+           CALL MUMPS_SAVE_INT(id%MYID_NODES)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_COMM_LOAD)
+            if(mode.EQ.memory_save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
             endif
-         CASE("MYID")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%MYID
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%MYID
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("NPROCS")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NPROCS
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NPROCS
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("NSLAVES")
-             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NSLAVES
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NSLAVES
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("ASS_IRECV")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%ASS_IRECV
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%ASS_IRECV
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif  
-         CASE("IS")
+         CASE(S_MYID)
+           CALL MUMPS_SAVE_INT(id%MYID)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NPROCS)
+           CALL MUMPS_SAVE_INT(id%NPROCS)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NSLAVES)
+           CALL MUMPS_SAVE_INT(id%NSLAVES)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_ASS_IRECV)
+           CALL MUMPS_SAVE_INT(id%ASS_IRECV)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_IS)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%IS)) THEN
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=id%KEEP(32)*SIZE_INT
@@ -2986,7 +2277,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*3
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%IS)) THEN
                   write(unit,iostat=err) size(id%IS,1),id%KEEP(32)
                   if(err.ne.0) then
@@ -3020,7 +2311,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%IS)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -3061,91 +2352,22 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("Deficiency")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%Deficiency
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%Deficiency
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("LNA")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%LNA
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%LNA
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("NBSA")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NBSA
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NBSA
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("STEP")
+         CASE(S_Deficiency)
+           CALL MUMPS_SAVE_INT(id%Deficiency)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_LNA)
+           CALL MUMPS_SAVE_INT(id%LNA)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NBSA)
+           CALL MUMPS_SAVE_INT(id%NBSA)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_STEP)
             CALL DMUMPS_SAVE_INT_SHPTR_ARRAY(id%STEP
      &           ) 
             IF (id%INFO(1) .LT. 0 ) GOTO 100
-         CASE("NE_STEPS")
+         CASE(S_NE_STEPS)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%NE_STEPS)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%NE_STEPS,1)*SIZE_INT
@@ -3153,7 +2375,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%NE_STEPS)) THEN
                   write(unit,iostat=err) size(id%NE_STEPS,1)
                   if(err.ne.0) then
@@ -3185,7 +2407,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%NE_STEPS)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3224,9 +2446,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("ND_STEPS")
+         CASE(S_ND_STEPS)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%ND_STEPS)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%ND_STEPS,1)*SIZE_INT
@@ -3234,7 +2456,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%ND_STEPS)) THEN
                   write(unit,iostat=err) size(id%ND_STEPS,1)
                   if(err.ne.0) then
@@ -3266,7 +2488,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%ND_STEPS)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3305,9 +2527,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("Step2node")
+         CASE(S_Step2node)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%Step2node)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%Step2node,1)*SIZE_INT
@@ -3315,7 +2537,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%Step2node)) THEN
                   write(unit,iostat=err) size(id%Step2node,1)
                   if(err.ne.0) then
@@ -3347,7 +2569,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%Step2node)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3386,9 +2608,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("FRERE_STEPS")
+         CASE(S_FRERE_STEPS)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%FRERE_STEPS)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%FRERE_STEPS,1)*SIZE_INT
@@ -3396,7 +2618,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%FRERE_STEPS)) THEN
                   write(unit,iostat=err) size(id%FRERE_STEPS,1)
                   if(err.ne.0) then
@@ -3428,7 +2650,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%FRERE_STEPS)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3467,9 +2689,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("DAD_STEPS")
+         CASE(S_DAD_STEPS)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%DAD_STEPS)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%DAD_STEPS,1)*SIZE_INT
@@ -3477,7 +2699,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%DAD_STEPS)) THEN
                   write(unit,iostat=err) size(id%DAD_STEPS,1)
                   if(err.ne.0) then
@@ -3509,7 +2731,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%DAD_STEPS)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3548,13 +2770,13 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("FILS")
+         CASE(S_FILS)
             CALL DMUMPS_SAVE_INT_SHPTR_ARRAY(id%FILS
      &           ) 
             IF ( id%INFO(1) .LT. 0 ) GOTO 100
-         CASE("PTR8ARR")
+         CASE(S_PTR8ARR)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%PTR8ARR)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%PTR8ARR,1)*SIZE_INT8
@@ -3562,7 +2784,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PTR8ARR)) THEN
                   write(unit,iostat=err) size(id%PTR8ARR,1)
                   if(err.ne.0) then
@@ -3595,7 +2817,7 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
                NbRecords(i1)=2
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PTR8ARR)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3634,9 +2856,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("NINCOLARR")
+         CASE(S_NINCOLARR)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                NbRecords(i1)=2
                IF(associated(id%NINCOLARR)) THEN
                   SIZE_GEST(i1)=SIZE_INT
@@ -3645,7 +2867,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%NINCOLARR)) THEN
                   write(unit,iostat=err) size(id%NINCOLARR,1)
                   if(err.ne.0) then
@@ -3677,7 +2899,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%NINCOLARR)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3716,9 +2938,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("NINROWARR")
+         CASE(S_NINROWARR)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                NbRecords(i1)=2
                IF(associated(id%NINROWARR)) THEN
                   SIZE_GEST(i1)=SIZE_INT
@@ -3727,7 +2949,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%NINROWARR)) THEN
                   write(unit,iostat=err) size(id%NINROWARR,1)
                   if(err.ne.0) then
@@ -3759,7 +2981,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%NINROWARR)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3798,9 +3020,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PTRDEBARR")
+         CASE(S_PTRDEBARR)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                NbRecords(i1)=2
                IF(associated(id%PTRDEBARR)) THEN
                   SIZE_GEST(i1)=SIZE_INT
@@ -3809,7 +3031,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PTRDEBARR)) THEN
                   write(unit,iostat=err) size(id%PTRDEBARR,1)
                   if(err.ne.0) then
@@ -3841,7 +3063,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PTRDEBARR)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3880,9 +3102,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PTRAR")
+         CASE(S_PTRAR)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%PTRAR)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%PTRAR,1)*SIZE_INT8
@@ -3890,7 +3112,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PTRAR)) THEN
                   write(unit,iostat=err) size(id%PTRAR,1)
                   if(err.ne.0) then
@@ -3923,7 +3145,7 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
                NbRecords(i1)=2
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PTRAR)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3962,9 +3184,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("FRTPTR")
+         CASE(S_FRTPTR)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%FRTPTR)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%FRTPTR,1)*SIZE_INT
@@ -3972,7 +3194,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%FRTPTR)) THEN
                   write(unit,iostat=err) size(id%FRTPTR,1)
                   if(err.ne.0) then
@@ -4004,7 +3226,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%FRTPTR)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -4042,9 +3264,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("FRTELT")
+         CASE(S_FRTELT)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%FRTELT)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%FRTELT,1)*SIZE_INT
@@ -4052,7 +3274,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%FRTELT)) THEN
                   write(unit,iostat=err) size(id%FRTELT,1)
                   if(err.ne.0) then
@@ -4078,7 +3300,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%FRTELT)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -4117,9 +3339,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("NA")
+         CASE(S_NA)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%NA)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%NA,1)*SIZE_INT
@@ -4127,7 +3349,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%NA)) THEN
                   write(unit,iostat=err) size(id%NA,1)
                   if(err.ne.0) then
@@ -4153,7 +3375,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%NA)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -4192,9 +3414,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PROCNODE_STEPS")
+         CASE(S_PROCNODE_STEPS)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                NbRecords(i1)=2
                IF(associated(id%PROCNODE_STEPS)) THEN
                   SIZE_GEST(i1)=SIZE_INT
@@ -4203,7 +3425,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PROCNODE_STEPS)) THEN
                   write(unit,iostat=err) size(id%PROCNODE_STEPS,1)
                   if(err.ne.0) then
@@ -4235,7 +3457,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PROCNODE_STEPS)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -4274,9 +3496,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PTLUST_S")
+         CASE(S_PTLUST_S)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%PTLUST_S)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%PTLUST_S,1)*SIZE_INT
@@ -4284,7 +3506,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PTLUST_S)) THEN
                   write(unit,iostat=err) size(id%PTLUST_S,1)
                   if(err.ne.0) then
@@ -4316,7 +3538,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PTLUST_S)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -4355,9 +3577,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PTRFAC")
+         CASE(S_PTRFAC)
             NbRecords(i1)=2  
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%PTRFAC)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%PTRFAC,1)*SIZE_INT8
@@ -4365,7 +3587,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PTRFAC)) THEN
                   write(unit,iostat=err) size(id%PTRFAC,1)
                   if(err.ne.0) then
@@ -4396,7 +3618,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PTRFAC)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -4435,9 +3657,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("S")
+         CASE(S_S)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%S)) THEN
                   SIZE_GEST(i1)=SIZE_INT8*2
                   SIZE_VARIABLES(i1)=id%KEEP8(31)*SIZE_ARITH_DEP
@@ -4447,7 +3669,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT8*2+SIZE_INT
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%S)) THEN
                   write(unit,iostat=err) id%KEEP8(23),id%KEEP8(31)
                   if(err.ne.0) then
@@ -4482,7 +3704,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%S)
                read(unit,iostat=err) size_array_INT8_1,size_array_INT8_2
                if(err.ne.0) THEN
@@ -4524,62 +3746,16 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PROCNODE")
-         CASE("NELT_loc")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NELT_loc
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NELT_loc
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("LELTVAR")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%LELTVAR
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%LELTVAR
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("ELTPROC")
+         CASE(S_PROCNODE)
+         CASE(S_NELT_loc)
+           CALL MUMPS_SAVE_INT(id%NELT_loc)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_LELTVAR)
+           CALL MUMPS_SAVE_INT(id%LELTVAR)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_ELTPROC)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%ELTPROC)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%ELTPROC,1)*SIZE_INT
@@ -4587,7 +3763,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%ELTPROC)) THEN
                   write(unit,iostat=err) size(id%ELTPROC,1)
                   if(err.ne.0) then
@@ -4619,7 +3795,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%ELTPROC)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -4658,9 +3834,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("I4_L0_OMP")
+         CASE(S_I4_L0_OMP)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%I4_L0_OMP)) THEN
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=size(id%I4_L0_OMP,1)
@@ -4669,7 +3845,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*3
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%I4_L0_OMP)) THEN
                   write(unit,iostat=err) size(id%I4_L0_OMP,1)
      &                 ,size(id%I4_L0_OMP,2)
@@ -4702,7 +3878,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%I4_L0_OMP)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -4742,9 +3918,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("I8_L0_OMP")
+         CASE(S_I8_L0_OMP)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%I8_L0_OMP)) THEN
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=size(id%I8_L0_OMP,1)
@@ -4753,7 +3929,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*3
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%I8_L0_OMP)) THEN
                   write(unit,iostat=err) size(id%I8_L0_OMP,1)
      &                 ,size(id%I8_L0_OMP,2)
@@ -4786,7 +3962,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%I8_L0_OMP)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -4826,9 +4002,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("CANDIDATES")
+         CASE(S_CANDIDATES)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%CANDIDATES)) THEN
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=size(id%CANDIDATES,1)
@@ -4837,7 +4013,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*3
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%CANDIDATES)) THEN
                   write(unit,iostat=err) size(id%CANDIDATES,1)
      &                 ,size(id%CANDIDATES,2)
@@ -4870,7 +4046,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%CANDIDATES)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -4910,9 +4086,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("ISTEP_TO_INIV2")
+         CASE(S_ISTEP_TO_INIV2)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%ISTEP_TO_INIV2)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%ISTEP_TO_INIV2,1)*SIZE_INT
@@ -4920,7 +4096,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%ISTEP_TO_INIV2)) THEN
                   write(unit,iostat=err) size(id%ISTEP_TO_INIV2,1)
                   if(err.ne.0) then
@@ -4952,7 +4128,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%ISTEP_TO_INIV2)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -4991,9 +4167,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("FUTURE_NIV2")
+         CASE(S_FUTURE_NIV2)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%FUTURE_NIV2)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%FUTURE_NIV2,1)*SIZE_INT
@@ -5001,7 +4177,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%FUTURE_NIV2)) THEN
                   write(unit,iostat=err) size(id%FUTURE_NIV2,1)
                   if(err.ne.0) then
@@ -5033,7 +4209,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%FUTURE_NIV2)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -5072,9 +4248,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("TAB_POS_IN_PERE")
+         CASE(S_TAB_POS_IN_PERE)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%TAB_POS_IN_PERE)) THEN
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=size(id%TAB_POS_IN_PERE,1)
@@ -5083,7 +4259,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*3
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%TAB_POS_IN_PERE)) THEN
                   write(unit,iostat=err) size(id%TAB_POS_IN_PERE,1)
      &                 ,size(id%TAB_POS_IN_PERE,2)
@@ -5116,7 +4292,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%TAB_POS_IN_PERE)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -5156,9 +4332,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("I_AM_CAND")
+         CASE(S_I_AM_CAND)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%I_AM_CAND)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%I_AM_CAND,1)*SIZE_LOGICAL
@@ -5166,7 +4342,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%I_AM_CAND)) THEN
                   write(unit,iostat=err) size(id%I_AM_CAND,1)
                   if(err.ne.0) then
@@ -5198,7 +4374,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%I_AM_CAND)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -5237,9 +4413,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("MEM_DIST")
+         CASE(S_MEM_DIST)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%MEM_DIST)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%MEM_DIST,1)*SIZE_INT
@@ -5247,7 +4423,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%MEM_DIST)) THEN
                   write(unit,iostat=err) size(id%MEM_DIST,1)
                   if(err.ne.0) then
@@ -5277,7 +4453,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%MEM_DIST)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -5316,20 +4492,20 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("POSINRHSCOMP_ROW")
+         CASE(S_GLOB2LOC_RHS)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
-               IF(associated(id%POSINRHSCOMP_ROW)) THEN
+            if(mode.EQ.memory_save_mode) then
+               IF(associated(id%GLOB2LOC_RHS)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
-     &                 size(id%POSINRHSCOMP_ROW,1)*SIZE_INT
+     &                 size(id%GLOB2LOC_RHS,1)*SIZE_INT
                ELSE
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
-               IF(associated(id%POSINRHSCOMP_ROW)) THEN
-                  write(unit,iostat=err) size(id%POSINRHSCOMP_ROW,1)
+            elseif(mode.EQ.save_mode) then
+               IF(associated(id%GLOB2LOC_RHS)) THEN
+                  write(unit,iostat=err) size(id%GLOB2LOC_RHS,1)
                   if(err.ne.0) then
                      id%INFO(1) = -72
                      CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
@@ -5338,7 +4514,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-                  write(unit,iostat=err) id%POSINRHSCOMP_ROW
+                  write(unit,iostat=err) id%GLOB2LOC_RHS
                ELSE
                   write(unit,iostat=err) -999
                   if(err.ne.0) then
@@ -5359,8 +4535,8 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               nullify(id%POSINRHSCOMP_ROW)
+            elseif(mode.EQ.restore_mode) then
+               nullify(id%GLOB2LOC_RHS)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
                   id%INFO(1) = -75
@@ -5377,7 +4553,7 @@ C
                else
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size_array1*SIZE_INT
-                  allocate(id%POSINRHSCOMP_ROW(size_array1), 
+                  allocate(id%GLOB2LOC_RHS(size_array1), 
      &                 stat=allocok)
                   if (allocok .GT. 0) THEN
                      id%INFO(1) = -78
@@ -5385,7 +4561,7 @@ C
      &                    TOTAL_STRUC_SIZE-size_allocated
      &                    ,id%INFO(2))
                   endif
-                  read(unit,iostat=err) id%POSINRHSCOMP_ROW
+                  read(unit,iostat=err) id%GLOB2LOC_RHS
                endif
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
@@ -5399,12 +4575,12 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("POSINRHSCOMP_COL_ALLOC")
+         CASE(S_GLOB2LOC_SOL_ALLOC)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_LOGICAL
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%POSINRHSCOMP_COL_ALLOC
+            elseif(mode.EQ.save_mode) then
+               write(unit,iostat=err) id%GLOB2LOC_SOL_ALLOC
                if(err.ne.0) then
                   id%INFO(1) = -72
                   CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
@@ -5413,9 +4589,9 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_LOGICAL
-               read(unit,iostat=err) id%POSINRHSCOMP_COL_ALLOC
+               read(unit,iostat=err) id%GLOB2LOC_SOL_ALLOC
                if(err.ne.0) THEN
                   id%INFO(1) = -75
                   CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
@@ -5425,14 +4601,14 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("POSINRHSCOMP_COL")
+         CASE(S_GLOB2LOC_SOL)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
-               IF(associated(id%POSINRHSCOMP_COL)) THEN
-                  IF(id%POSINRHSCOMP_COL_ALLOC) THEN
+            if(mode.EQ.memory_save_mode) then
+               IF(associated(id%GLOB2LOC_SOL)) THEN
+                  IF(id%GLOB2LOC_SOL_ALLOC) THEN
                      SIZE_GEST(i1)=SIZE_INT
                      SIZE_VARIABLES(i1)=
-     &                    size(id%POSINRHSCOMP_COL,1)*SIZE_INT
+     &                    size(id%GLOB2LOC_SOL,1)*SIZE_INT
                   ELSE
                      SIZE_GEST(i1)=SIZE_INT*2
                      SIZE_VARIABLES(i1)=0_8
@@ -5441,10 +4617,10 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
-               IF(associated(id%POSINRHSCOMP_COL)) THEN
-                  IF(id%POSINRHSCOMP_COL_ALLOC) THEN
-                     write(unit,iostat=err) size(id%POSINRHSCOMP_COL,1)
+            elseif(mode.EQ.save_mode) then
+               IF(associated(id%GLOB2LOC_SOL)) THEN
+                  IF(id%GLOB2LOC_SOL_ALLOC) THEN
+                     write(unit,iostat=err) size(id%GLOB2LOC_SOL,1)
                      if(err.ne.0) then
                         id%INFO(1) = -72
                         CALL MUMPS_SETI8TOI4(
@@ -5454,9 +4630,9 @@ C
                      CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                    id%COMM, id%MYID )
                      IF ( id%INFO(1) .LT. 0 ) GOTO 100
-                     write(unit,iostat=err) id%POSINRHSCOMP_COL
+                     write(unit,iostat=err) id%GLOB2LOC_SOL
                   ELSE
-                     write(unit,iostat=err) size(id%POSINRHSCOMP_COL,1)
+                     write(unit,iostat=err) size(id%GLOB2LOC_SOL,1)
                      if(err.ne.0) then
                         id%INFO(1) = -72
                         CALL MUMPS_SETI8TOI4(
@@ -5488,8 +4664,8 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               nullify(id%POSINRHSCOMP_COL)
+            elseif(mode.EQ.restore_mode) then
+               nullify(id%GLOB2LOC_SOL)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
                   id%INFO(1) = -75
@@ -5504,10 +4680,10 @@ C
                   SIZE_VARIABLES(i1)=0_8
                   read(unit,iostat=err) dummy
                else
-                  if(id%POSINRHSCOMP_COL_ALLOC) then
+                  if(id%GLOB2LOC_SOL_ALLOC) then
                      SIZE_GEST(i1)=SIZE_INT
                      SIZE_VARIABLES(i1)=size_array1*SIZE_INT
-                     allocate(id%POSINRHSCOMP_COL(size_array1), 
+                     allocate(id%GLOB2LOC_SOL(size_array1), 
      &                    stat=allocok)
                      if (allocok .GT. 0) THEN
                         id%INFO(1) = -78
@@ -5515,12 +4691,12 @@ C
      &                       TOTAL_STRUC_SIZE-size_allocated
      &                       ,id%INFO(2))
                      endif
-                     read(unit,iostat=err) id%POSINRHSCOMP_COL
+                     read(unit,iostat=err) id%GLOB2LOC_SOL
                   else
                      SIZE_GEST(i1)=SIZE_INT*2
                      SIZE_VARIABLES(i1)=0_8
                      read(unit,iostat=err) dummy
-                     id%POSINRHSCOMP_COL=>id%POSINRHSCOMP_ROW
+                     id%GLOB2LOC_SOL=>id%GLOB2LOC_RHS
                   endif
                endif
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
@@ -5535,18 +4711,18 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("RHSCOMP")
+         CASE(S_RHSINTR)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
-               IF(associated(id%RHSCOMP)) THEN
+            if(mode.EQ.memory_save_mode) then
+               IF(associated(id%RHSINTR)) THEN
                   SIZE_GEST(i1)=SIZE_INT8
                   SIZE_VARIABLES(i1)=id%KEEP8(25)*SIZE_ARITH_DEP
                ELSE
                   SIZE_GEST(i1)=SIZE_INT8+SIZE_INT
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
-               IF(associated(id%RHSCOMP)) THEN
+            elseif(mode.EQ.save_mode) then
+               IF(associated(id%RHSINTR)) THEN
                   write(unit,iostat=err) id%KEEP8(25)
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -5556,7 +4732,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-                  write(unit,iostat=err) id%RHSCOMP
+                  write(unit,iostat=err) id%RHSINTR
                ELSE
                   write(unit,iostat=err) int(-999,8)
                   if(err.ne.0) then
@@ -5577,8 +4753,8 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               nullify(id%RHSCOMP)
+            elseif(mode.EQ.restore_mode) then
+               nullify(id%RHSINTR)
                read(unit,iostat=err) size_array_INT8_1
                if(err.ne.0) THEN
                   id%INFO(1) = -75
@@ -5595,14 +4771,14 @@ C
                else
                   SIZE_GEST(i1)=SIZE_INT8
                   SIZE_VARIABLES(i1)=size_array_INT8_1*SIZE_ARITH_DEP
-                  allocate(id%RHSCOMP(size_array_INT8_1), stat=allocok)
+                  allocate(id%RHSINTR(size_array_INT8_1), stat=allocok)
                   if (allocok .GT. 0) THEN
                      id%INFO(1) = -78
                      CALL MUMPS_SETI8TOI4(
      &                    TOTAL_STRUC_SIZE-size_allocated
      &                    ,id%INFO(2))
                   endif
-                  read(unit,iostat=err) id%RHSCOMP
+                  read(unit,iostat=err) id%RHSINTR
                endif
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
@@ -5616,9 +4792,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("MEM_SUBTREE")
+         CASE(S_MEM_SUBTREE)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%MEM_SUBTREE)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
@@ -5627,7 +4803,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%MEM_SUBTREE)) THEN
                   write(unit,iostat=err) size(id%MEM_SUBTREE,1)
                   if(err.ne.0) then
@@ -5659,7 +4835,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%MEM_SUBTREE)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -5698,9 +4874,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("COST_TRAV")
+         CASE(S_COST_TRAV)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%COST_TRAV)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
@@ -5709,7 +4885,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%COST_TRAV)) THEN
                   write(unit,iostat=err) size(id%COST_TRAV,1)
                   if(err.ne.0) then
@@ -5741,7 +4917,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%COST_TRAV)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -5780,9 +4956,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("MY_ROOT_SBTR")
+         CASE(S_MY_ROOT_SBTR)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%MY_ROOT_SBTR)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%MY_ROOT_SBTR,1)*SIZE_INT
@@ -5790,7 +4966,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%MY_ROOT_SBTR)) THEN
                   write(unit,iostat=err) size(id%MY_ROOT_SBTR,1)
                   if(err.ne.0) then
@@ -5822,7 +4998,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%MY_ROOT_SBTR)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -5861,9 +5037,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("MY_FIRST_LEAF")
+         CASE(S_MY_FIRST_LEAF)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%MY_FIRST_LEAF)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%MY_FIRST_LEAF,1)*SIZE_INT
@@ -5871,7 +5047,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%MY_FIRST_LEAF)) THEN
                   write(unit,iostat=err) size(id%MY_FIRST_LEAF,1)
                   if(err.ne.0) then
@@ -5903,7 +5079,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%MY_FIRST_LEAF)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -5942,9 +5118,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("MY_NB_LEAF")
+         CASE(S_MY_NB_LEAF)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%MY_NB_LEAF)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%MY_NB_LEAF,1)*SIZE_INT
@@ -5952,7 +5128,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%MY_NB_LEAF)) THEN
                   write(unit,iostat=err) size(id%MY_NB_LEAF,1)
                   if(err.ne.0) then
@@ -5984,7 +5160,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%MY_NB_LEAF)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -6023,9 +5199,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("DEPTH_FIRST")
+         CASE(S_DEPTH_FIRST)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%DEPTH_FIRST)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%DEPTH_FIRST,1)*SIZE_INT
@@ -6033,7 +5209,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%DEPTH_FIRST)) THEN
                   write(unit,iostat=err) size(id%DEPTH_FIRST,1)
                   if(err.ne.0) then
@@ -6065,7 +5241,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%DEPTH_FIRST)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -6104,9 +5280,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("DEPTH_FIRST_SEQ")
+         CASE(S_DEPTH_FIRST_SEQ)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%DEPTH_FIRST_SEQ)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%DEPTH_FIRST_SEQ,1)*SIZE_INT
@@ -6114,7 +5290,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%DEPTH_FIRST_SEQ)) THEN
                   write(unit,iostat=err) size(id%DEPTH_FIRST_SEQ,1)
                   if(err.ne.0) then
@@ -6146,7 +5322,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%DEPTH_FIRST_SEQ)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -6186,9 +5362,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("SBTR_ID")
+         CASE(S_SBTR_ID)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%SBTR_ID)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%SBTR_ID,1)*SIZE_INT
@@ -6196,7 +5372,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%SBTR_ID)) THEN
                   write(unit,iostat=err) size(id%SBTR_ID,1)
                   if(err.ne.0) then
@@ -6228,7 +5404,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%SBTR_ID)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -6267,100 +5443,31 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("SCHED_DEP")
-         CASE("SCHED_GRP")
-         CASE("CROIX_MANU")
-         CASE("WK_USER")
-         CASE("NBSA_LOCAL")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NBSA_LOCAL
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NBSA_LOCAL
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("LWK_USER")
-            if(trim(mode).EQ."memory_save") then
+         CASE(S_SCHED_DEP)
+         CASE(S_SCHED_GRP)
+         CASE(S_CROIX_MANU)
+         CASE(S_WK_USER)
+         CASE(S_NBSA_LOCAL)
+           CALL MUMPS_SAVE_INT(id%NBSA_LOCAL)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_LWK_USER)
+            if(mode.EQ.memory_save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
             endif
-         CASE("CB_SON_SIZE")
-         CASE("INSTANCE_NUMBER")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%INSTANCE_NUMBER
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%INSTANCE_NUMBER
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("OOC_MAX_NB_NODES_FOR_ZONE")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%OOC_MAX_NB_NODES_FOR_ZONE
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%OOC_MAX_NB_NODES_FOR_ZONE
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("OOC_INODE_SEQUENCE")
+         CASE(S_CB_SON_SIZE)
+         CASE(S_INSTANCE_NUMBER)
+           CALL MUMPS_SAVE_INT(id%INSTANCE_NUMBER)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_OOC_MAX_NB_NODES_FOR_ZONE)
+           CALL MUMPS_SAVE_INT(id%OOC_MAX_NB_NODES_FOR_ZONE)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_OOC_INODE_SEQUENCE)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%OOC_INODE_SEQUENCE)) THEN
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=size(id%OOC_INODE_SEQUENCE,1)
@@ -6369,7 +5476,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*3
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%OOC_INODE_SEQUENCE)) THEN
                   write(unit,iostat=err) size(id%OOC_INODE_SEQUENCE,1)
      &                 ,size(id%OOC_INODE_SEQUENCE,2)
@@ -6402,7 +5509,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%OOC_INODE_SEQUENCE)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -6442,9 +5549,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("OOC_SIZE_OF_BLOCK")
+         CASE(S_OOC_SIZE_OF_BLOCK)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%OOC_SIZE_OF_BLOCK)) THEN
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=size(id%OOC_SIZE_OF_BLOCK,1)
@@ -6453,7 +5560,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*3
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%OOC_SIZE_OF_BLOCK)) THEN
                   write(unit,iostat=err) size(id%OOC_SIZE_OF_BLOCK,1)
      &                 ,size(id%OOC_SIZE_OF_BLOCK,2)
@@ -6486,7 +5593,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%OOC_SIZE_OF_BLOCK)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -6526,9 +5633,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("OOC_VADDR")
+         CASE(S_OOC_VADDR)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%OOC_VADDR)) THEN
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=size(id%OOC_VADDR,1)
@@ -6537,7 +5644,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*3
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%OOC_VADDR)) THEN
                   write(unit,iostat=err) size(id%OOC_VADDR,1)
      &                 ,size(id%OOC_VADDR,2)
@@ -6570,7 +5677,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%OOC_VADDR)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -6610,9 +5717,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("OOC_TOTAL_NB_NODES")
+         CASE(S_OOC_TOTAL_NB_NODES)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%OOC_TOTAL_NB_NODES)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
@@ -6621,7 +5728,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%OOC_TOTAL_NB_NODES)) THEN
                   write(unit,iostat=err) size(id%OOC_TOTAL_NB_NODES,1)
                   if(err.ne.0) then
@@ -6653,7 +5760,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%OOC_TOTAL_NB_NODES)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -6693,13 +5800,13 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("OOC_NB_FILES")
-         CASE("OOC_NB_FILE_TYPE")
-         CASE("OOC_FILE_NAMES")
-         CASE("OOC_FILE_NAME_LENGTH")
-         CASE("PIVNUL_LIST")
+         CASE(S_OOC_NB_FILES)
+         CASE(S_OOC_NB_FILE_TYPE)
+         CASE(S_OOC_FILE_NAMES)
+         CASE(S_OOC_FILE_NAME_LENGTH)
+         CASE(S_PIVNUL_LIST)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%PIVNUL_LIST)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%PIVNUL_LIST,1)*SIZE_INT
@@ -6707,7 +5814,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PIVNUL_LIST)) THEN
                   write(unit,iostat=err) size(id%PIVNUL_LIST,1)
                   if(err.ne.0) then
@@ -6739,7 +5846,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PIVNUL_LIST)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -6778,10 +5885,10 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("SUP_PROC")
-         CASE("IPTR_WORKING")
+         CASE(S_SUP_PROC)
+         CASE(S_IPTR_WORKING)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%IPTR_WORKING)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%IPTR_WORKING,1)*SIZE_INT
@@ -6789,7 +5896,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%IPTR_WORKING)) THEN
                   write(unit,iostat=err) size(id%IPTR_WORKING,1)
                   if(err.ne.0) then
@@ -6821,7 +5928,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%IPTR_WORKING)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -6860,9 +5967,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("WORKING")
+         CASE(S_WORKING)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%WORKING)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%WORKING,1)*SIZE_INT
@@ -6870,7 +5977,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%WORKING)) THEN
                   write(unit,iostat=err) size(id%WORKING,1)
                   if(err.ne.0) then
@@ -6902,7 +6009,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%WORKING)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -6941,15 +6048,14 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("root")
+         CASE(S_root)
             DO i2=1,NBVARIABLES_ROOT
-            TMP_STRING2 = VARIABLES_ROOT(i2)
-            SELECT CASE(TMP_STRING2)
-            CASE("MBLOCK")
+            SELECT CASE(i2)
+            CASE(R_MBLOCK)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%MBLOCK
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -6959,7 +6065,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%MBLOCK
                   if(err.ne.0) THEN
@@ -6971,11 +6077,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("NBLOCK")
+            CASE(R_NBLOCK)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%NBLOCK
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -6985,7 +6091,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100        
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%NBLOCK
                   if(err.ne.0) THEN
@@ -6997,11 +6103,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-            CASE("NPROW")
+            CASE(R_NPROW)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%NPROW
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7011,7 +6117,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100                 
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%NPROW
                   if(err.ne.0) THEN
@@ -7023,11 +6129,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("NPCOL")
+            CASE(R_NPCOL)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%NPCOL
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7037,7 +6143,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100                
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%NPCOL
                   if(err.ne.0) THEN
@@ -7049,12 +6155,12 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("MYROW")
+            CASE(R_MYROW)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   NbRecords_ROOT(i2)=1
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%MYROW
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7064,7 +6170,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%MYROW
                   if(err.ne.0) THEN
@@ -7076,11 +6182,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("MYCOL")
+            CASE(R_MYCOL)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%MYCOL
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7090,7 +6196,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%MYCOL
                   if(err.ne.0) THEN
@@ -7102,11 +6208,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("SCHUR_MLOC")
+            CASE(R_SCHUR_MLOC)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%SCHUR_MLOC
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7116,7 +6222,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%SCHUR_MLOC
                   if(err.ne.0) THEN
@@ -7128,11 +6234,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("SCHUR_NLOC")
+            CASE(R_SCHUR_NLOC)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%SCHUR_NLOC
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7142,7 +6248,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%SCHUR_NLOC
                   if(err.ne.0) THEN
@@ -7154,11 +6260,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("SCHUR_LLD")
+            CASE(R_SCHUR_LLD)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%SCHUR_LLD
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7168,7 +6274,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%SCHUR_LLD
                   if(err.ne.0) THEN
@@ -7180,11 +6286,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("RHS_NLOC")
+            CASE(R_RHS_NLOC)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%RHS_NLOC
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7194,7 +6300,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%RHS_NLOC
                   if(err.ne.0) THEN
@@ -7206,11 +6312,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("ROOT_SIZE")
+            CASE(R_ROOT_SIZE)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%ROOT_SIZE
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7220,7 +6326,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%ROOT_SIZE
                   if(err.ne.0) THEN
@@ -7232,11 +6338,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("TOT_ROOT_SIZE")
+            CASE(R_TOT_ROOT_SIZE)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%TOT_ROOT_SIZE
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7246,7 +6352,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%TOT_ROOT_SIZE
                   if(err.ne.0) THEN
@@ -7258,12 +6364,12 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("DESCRIPTOR")
+            CASE(R_DESCRIPTOR)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=size(id%root%DESCRIPTOR,1)
      &                 *SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%DESCRIPTOR
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7273,7 +6379,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT*
      &                 size(id%root%DESCRIPTOR,1)
                   read(unit,iostat=err) id%root%DESCRIPTOR
@@ -7286,11 +6392,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("CNTXT_BLACS")
+            CASE(R_CNTXT_BLACS)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%CNTXT_BLACS
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7300,7 +6406,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%CNTXT_BLACS
                   if(err.ne.0) THEN
@@ -7312,11 +6418,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("LPIV")
+            CASE(R_LPIV)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%LPIV
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7326,7 +6432,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%LPIV
                   if(err.ne.0) THEN
@@ -7338,10 +6444,10 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("RG2L")
-            CASE("IPIV")
+            CASE(R_RG2L)
+            CASE(R_IPIV)
                NbRecords_ROOT(i2)=2
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   IF(associated(id%root%IPIV)) THEN
                      SIZE_GEST_ROOT(i2)=SIZE_INT
                      SIZE_VARIABLES_ROOT(i2)=
@@ -7350,7 +6456,7 @@ C
                      SIZE_GEST_ROOT(i2)=SIZE_INT*2
                      SIZE_VARIABLES_ROOT(i2)=0_8
                   ENDIF
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   IF(associated(id%root%IPIV)) THEN
                      write(unit,iostat=err) size(id%root%IPIV,1)
                      if(err.ne.0) then
@@ -7384,7 +6490,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   nullify(id%root%IPIV)
                   read(unit,iostat=err) size_array1
                   if(err.ne.0) THEN
@@ -7423,9 +6529,9 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("RHS_CNTR_MASTER_ROOT")
+            CASE(R_RHS_CNTR_MASTER_ROOT)
                NbRecords_ROOT(i2)=2
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   IF(associated(id%root%RHS_CNTR_MASTER_ROOT)) THEN
                      SIZE_GEST_ROOT(i2)=SIZE_INT
                      SIZE_VARIABLES_ROOT(i2)=
@@ -7435,7 +6541,7 @@ C
                      SIZE_GEST_ROOT(i2)=SIZE_INT*2
                      SIZE_VARIABLES_ROOT(i2)=0_8
                   ENDIF
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   IF(associated(id%root%RHS_CNTR_MASTER_ROOT)) THEN
                      write(unit,iostat=err) 
      &                    size(id%root%RHS_CNTR_MASTER_ROOT,1)
@@ -7470,7 +6576,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   nullify(id%root%RHS_CNTR_MASTER_ROOT)
                   read(unit,iostat=err) size_array1
                   if(err.ne.0) THEN
@@ -7510,11 +6616,94 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("SCHUR_POINTER")
-            CASE("QR_TAU")
-            CASE("RHS_ROOT")
+            CASE(R_SCHUR_POINTER)
+            CASE(R_QR_TAU)
                NbRecords_ROOT(i2)=2
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
+                  IF(associated(id%root%QR_TAU)) THEN
+                     SIZE_GEST_ROOT(i2)=SIZE_INT
+                     SIZE_VARIABLES_ROOT(i2)=
+     &                    size(id%root%QR_TAU,1)*SIZE_ARITH_DEP
+                  ELSE
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*2
+                     SIZE_VARIABLES_ROOT(i2)=0_8
+                  ENDIF
+               elseif(mode.EQ.save_mode) then
+                  IF(associated(id%root%QR_TAU)) THEN
+                     write(unit,iostat=err) size(id%root%QR_TAU,1)
+                     if(err.ne.0) then
+                        id%INFO(1) = -72
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_FILE_SIZE-size_written
+     &                       ,id%INFO(2))
+                     endif
+                     CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                    id%COMM, id%MYID )
+                     IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                     write(unit,iostat=err) id%root%QR_TAU
+                  ELSE
+                     write(unit,iostat=err) -999
+                     if(err.ne.0) then
+                        id%INFO(1) = -72
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_FILE_SIZE-size_written
+     &                       ,id%INFO(2))
+                     endif
+                     CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                    id%COMM, id%MYID )
+                     IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                     write(unit,iostat=err) -999
+                  ENDIF 
+                  if(err.ne.0) then
+                     id%INFO(1) = -72
+                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written
+     &                    ,id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               elseif(mode.EQ.restore_mode) then
+                  nullify(id%root%QR_TAU)
+                  read(unit,iostat=err) size_array1
+                  if(err.ne.0) THEN
+                     id%INFO(1) = -75
+                     CALL MUMPS_SETI8TOI4(SIZE_VARIABLES_ROOT(i2),
+     &                    id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                  if(size_array1.EQ.-999) then
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*2
+                     SIZE_VARIABLES_ROOT(i2)=0_8
+                     read(unit,iostat=err) dummy
+                  else
+                     SIZE_GEST_ROOT(i2)=SIZE_INT
+                     SIZE_VARIABLES_ROOT(i2)=size_array1*SIZE_ARITH_DEP
+                     allocate(id%root%QR_TAU(size_array1), stat=allocok)
+                     if (allocok .GT. 0) THEN
+                        id%INFO(1) = -78
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_STRUC_SIZE-size_allocated
+     &                       ,id%INFO(2))
+                     endif
+                     read(unit,iostat=err) id%root%QR_TAU
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                  if(err.ne.0) THEN
+                     id%INFO(1) = -75
+                     CALL MUMPS_SETI8TOI4(SIZE_VARIABLES_ROOT(i2),
+     &                    id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               endif
+            CASE(R_RHS_ROOT)
+               NbRecords_ROOT(i2)=2
+               if(mode.EQ.memory_save_mode) then
                   IF(associated(id%root%RHS_ROOT)) THEN
                      SIZE_GEST_ROOT(i2)=SIZE_INT*2
                      SIZE_VARIABLES_ROOT(i2)=size(id%root%RHS_ROOT,1)
@@ -7523,7 +6712,7 @@ C
                      SIZE_GEST_ROOT(i2)=SIZE_INT*3
                      SIZE_VARIABLES_ROOT(i2)=0_8
                   ENDIF
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   IF(associated(id%root%RHS_ROOT)) THEN
                      write(unit,iostat=err) size(id%root%RHS_ROOT,1)
      &                    ,size(id%root%RHS_ROOT,2)
@@ -7558,7 +6747,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   nullify(id%root%RHS_ROOT)
                   read(unit,iostat=err) size_array1,size_array2
                   if(err.ne.0) THEN
@@ -7599,11 +6788,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("QR_RCOND")
+            CASE(R_QR_RCOND)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_RL_OR_DBL
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%QR_RCOND
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7613,7 +6802,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_RL_OR_DBL
                   read(unit,iostat=err) id%root%QR_RCOND
                   if(err.ne.0) THEN
@@ -7625,11 +6814,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("yes")
+            CASE(R_yes)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_LOGICAL
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%yes
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7639,7 +6828,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_LOGICAL
                   read(unit,iostat=err) id%root%yes
                   if(err.ne.0) THEN
@@ -7651,11 +6840,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("gridinit_done")
+            CASE(R_gridinit_done)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_LOGICAL
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%gridinit_done
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7665,7 +6854,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_LOGICAL
                   read(unit,iostat=err) id%root%gridinit_done
                   if(err.ne.0) THEN
@@ -7677,14 +6866,272 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("SVD_U")
-            CASE("SVD_VT")
-            CASE("SINGULAR_VALUES")
-            CASE("NB_SINGULAR_VALUES")
+            CASE(R_SVD_U)
+               NbRecords_ROOT(i2)=2
+               if(mode.EQ.memory_save_mode) then
+                  IF(associated(id%root%SVD_U)) THEN
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*2
+                     SIZE_VARIABLES_ROOT(i2)=size(id%root%SVD_U,1)
+     &                    *size(id%root%SVD_U,2)*SIZE_ARITH_DEP
+                  ELSE
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*3
+                     SIZE_VARIABLES_ROOT(i2)=0_8
+                  ENDIF
+               elseif(mode.EQ.save_mode) then
+                  IF(associated(id%root%SVD_U)) THEN
+                     write(unit,iostat=err) size(id%root%SVD_U,1)
+     &                    ,size(id%root%SVD_U,2)
+                     if(err.ne.0) then
+                        id%INFO(1) = -72
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_FILE_SIZE-size_written
+     &                       ,id%INFO(2))
+                     endif
+                     CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                    id%COMM, id%MYID )
+                     IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                     write(unit,iostat=err) id%root%SVD_U
+                  ELSE
+                     write(unit,iostat=err) -999,-998
+                     if(err.ne.0) then
+                        id%INFO(1) = -72
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_FILE_SIZE-size_written
+     &                       ,id%INFO(2))
+                     endif
+                     CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                    id%COMM, id%MYID )
+                     IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                     write(unit,iostat=err) -999
+                  ENDIF 
+                  if(err.ne.0) then
+                     id%INFO(1) = -72
+                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written
+     &                    ,id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               elseif(mode.EQ.restore_mode) then
+                  nullify(id%root%SVD_U)
+                  read(unit,iostat=err) size_array1,size_array2
+                  if(err.ne.0) THEN
+                     id%INFO(1) = -75
+                     CALL MUMPS_SETI8TOI4(SIZE_VARIABLES_ROOT(i2),
+     &                    id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                  if(size_array1.EQ.-999) then
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*3
+                     SIZE_VARIABLES_ROOT(i2)=0_8
+                     read(unit,iostat=err) dummy
+                  else
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*2
+                     SIZE_VARIABLES_ROOT(i2)=size_array1*size_array2
+     &                    *SIZE_ARITH_DEP
+                     allocate(id%root%SVD_U(size_array1,size_array2),
+     &                    stat=allocok)
+                     if (allocok .GT. 0) THEN
+                        id%INFO(1) = -78
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_STRUC_SIZE-size_allocated
+     &                       ,id%INFO(2))
+                     endif
+                     read(unit,iostat=err) id%root%SVD_U
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                  if(err.ne.0) THEN
+                     id%INFO(1) = -75
+                     CALL MUMPS_SETI8TOI4(SIZE_VARIABLES_ROOT(i2),
+     &                    id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               endif
+            CASE(R_SVD_VT)
+               NbRecords_ROOT(i2)=2
+               if(mode.EQ.memory_save_mode) then
+                  IF(associated(id%root%SVD_VT)) THEN
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*2
+                     SIZE_VARIABLES_ROOT(i2)=size(id%root%SVD_VT,1)
+     &                    *size(id%root%SVD_VT,2)*SIZE_ARITH_DEP
+                  ELSE
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*3
+                     SIZE_VARIABLES_ROOT(i2)=0_8
+                  ENDIF
+               elseif(mode.EQ.save_mode) then
+                  IF(associated(id%root%SVD_VT)) THEN
+                     write(unit,iostat=err) size(id%root%SVD_VT,1)
+     &                    ,size(id%root%SVD_VT,2)
+                     if(err.ne.0) then
+                        id%INFO(1) = -72
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_FILE_SIZE-size_written
+     &                       ,id%INFO(2))
+                     endif
+                     CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                    id%COMM, id%MYID )
+                     IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                     write(unit,iostat=err) id%root%SVD_VT
+                  ELSE
+                     write(unit,iostat=err) -999,-998
+                     if(err.ne.0) then
+                        id%INFO(1) = -72
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_FILE_SIZE-size_written
+     &                       ,id%INFO(2))
+                     endif
+                     CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                    id%COMM, id%MYID )
+                     IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                     write(unit,iostat=err) -999
+                  ENDIF 
+                  if(err.ne.0) then
+                     id%INFO(1) = -72
+                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written
+     &                    ,id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               elseif(mode.EQ.restore_mode) then
+                  nullify(id%root%SVD_VT)
+                  read(unit,iostat=err) size_array1,size_array2
+                  if(err.ne.0) THEN
+                     id%INFO(1) = -75
+                     CALL MUMPS_SETI8TOI4(SIZE_VARIABLES_ROOT(i2),
+     &                    id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                  if(size_array1.EQ.-999) then
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*3
+                     SIZE_VARIABLES_ROOT(i2)=0_8
+                     read(unit,iostat=err) dummy
+                  else
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*2
+                     SIZE_VARIABLES_ROOT(i2)=size_array1*size_array2
+     &                    *SIZE_ARITH_DEP
+                     allocate(id%root%SVD_VT(size_array1,size_array2),
+     &                    stat=allocok)
+                     if (allocok .GT. 0) THEN
+                        id%INFO(1) = -78
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_STRUC_SIZE-size_allocated
+     &                       ,id%INFO(2))
+                     endif
+                     read(unit,iostat=err) id%root%SVD_VT
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                  if(err.ne.0) THEN
+                     id%INFO(1) = -75
+                     CALL MUMPS_SETI8TOI4(SIZE_VARIABLES_ROOT(i2),
+     &                    id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               endif
+            CASE(R_SINGULAR_VALUES)
+               NbRecords_ROOT(i2)=2
+               if(mode.EQ.memory_save_mode) then
+                  IF(associated(id%root%SINGULAR_VALUES)) THEN
+                     SIZE_GEST_ROOT(i2)=SIZE_INT
+                     SIZE_VARIABLES_ROOT(i2)=
+     &                    size(id%root%SINGULAR_VALUES,1)
+     &                    *SIZE_RL_OR_DBL
+                  ELSE
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*2
+                     SIZE_VARIABLES_ROOT(i2)=0_8
+                  ENDIF
+               elseif(mode.EQ.save_mode) then
+                  IF(associated(id%root%SINGULAR_VALUES)) THEN
+                     write(unit,iostat=err) 
+     &                    size(id%root%SINGULAR_VALUES,1)
+                     if(err.ne.0) then
+                        id%INFO(1) = -72
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_FILE_SIZE-size_written
+     &                       ,id%INFO(2))
+                     endif
+                     CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                    id%COMM, id%MYID )
+                     IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                     write(unit,iostat=err) id%root%SINGULAR_VALUES
+                  ELSE
+                     write(unit,iostat=err) -999
+                     if(err.ne.0) then
+                        id%INFO(1) = -72
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_FILE_SIZE-size_written
+     &                       ,id%INFO(2))
+                     endif
+                     CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                    id%COMM, id%MYID )
+                     IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                     write(unit,iostat=err) -999
+                  ENDIF 
+                  if(err.ne.0) then
+                     id%INFO(1) = -72
+                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written
+     &                    ,id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               elseif(mode.EQ.restore_mode) then
+                  nullify(id%root%SINGULAR_VALUES)
+                  read(unit,iostat=err) size_array1
+                  if(err.ne.0) THEN
+                     id%INFO(1) = -75
+                     CALL MUMPS_SETI8TOI4(SIZE_VARIABLES_ROOT(i2)
+     &                    ,id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                  if(size_array1.EQ.-999) then
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*2
+                     SIZE_VARIABLES_ROOT(i2)=0_8
+                     read(unit,iostat=err) dummy
+                  else
+                     SIZE_GEST_ROOT(i2)=SIZE_INT
+                     SIZE_VARIABLES_ROOT(i2)=size_array1*SIZE_RL_OR_DBL
+                     allocate(id%root%SINGULAR_VALUES(size_array1),
+     &                    stat=allocok)
+                     if (allocok .GT. 0) THEN
+                        id%INFO(1) = -78
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_STRUC_SIZE-size_allocated
+     &                       ,id%INFO(2))
+                     endif
+                     read(unit,iostat=err) id%root%SINGULAR_VALUES
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                  if(err.ne.0) THEN
+                     id%INFO(1) = -75
+                     CALL MUMPS_SETI8TOI4(SIZE_VARIABLES_ROOT(i2)
+     &                    ,id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               endif
+            CASE(R_NB_SINGULAR_VALUES)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%NB_SINGULAR_VALUES
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7694,7 +7141,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%NB_SINGULAR_VALUES
                   if(err.ne.0) THEN
@@ -7706,23 +7153,23 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("rootpad0","rootpad1","rootpad2","rootpad",
-     &              "rootpad3","rootpad4")
+            CASE(R_rootpad0,R_rootpad1,R_rootpad2,
+     &           R_rootpad3,R_rootpad4)
             CASE DEFAULT
             END SELECT
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                NbSubRecords=int(SIZE_VARIABLES_ROOT(i2)/huge(I4))
                IF(NbSubRecords.GT.0) then
                   NbRecords_ROOT(i2)=NbRecords_ROOT(i2)+NbSubRecords
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                size_written=size_written+SIZE_VARIABLES_ROOT(i2)
      &              +SIZE_GEST_ROOT(i2)
 #if defined(MUMPS_NOF2003)
                size_written=size_written
      &              +int(2*id%KEEP(34)*NbRecords_ROOT(i2),kind=8)
 #endif
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                size_allocated=size_allocated+SIZE_VARIABLES_ROOT(i2)+
      &              DIFF_SIZE_ALLOC_READ_ROOT(i2)
                size_read=size_read+SIZE_VARIABLES_ROOT(i2)
@@ -7731,53 +7178,30 @@ C
                size_read=size_read
      &              +int(2*id%KEEP(34)*NbRecords_ROOT(i2),kind=8)
 #endif
-            elseif(trim(mode).EQ."fake_restore") then
+            elseif(mode.EQ.fake_restore_mode) then
             endif
          ENDDO
-         CASE("NBGRP")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NBGRP
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NBGRP
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-        CASE("LRGROUPS")
+         CASE(S_NBGRP)
+           CALL MUMPS_SAVE_INT(id%NBGRP)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_LRGROUPS)
             CALL DMUMPS_SAVE_INT_SHPTR_ARRAY(id%LRGROUPS
      &           ) 
             IF (id%INFO(1) .LT. 0 ) GOTO 100
-         CASE("FDM_F_ENCODING")
+         CASE(S_FDM_F_ENCODING)
             NbRecords(i1)=1
             SIZE_GEST(i1)=SIZE_INT
             SIZE_VARIABLES(i1)=0_8
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%FDM_F_ENCODING)) THEN
                   CALL MUMPS_SAVE_RESTORE_FRONT_DATA(id%FDM_F_ENCODING
-     &                 ,unit,id%MYID,"memory_save"
+     &                 ,unit,id%MYID,memory_save_mode
      &                 ,SIZE_GEST_FRONT_DATA,SIZE_VARIABLES_FRONT_DATA
      &                 ,SIZE_INT,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
      &                 ,size_read,size_allocated,size_written
      &                 ,id%INFO(1))                 
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%FDM_F_ENCODING)) THEN
                   write(unit,iostat=err) size(id%FDM_F_ENCODING,1)
                   if(err.ne.0) then
@@ -7789,7 +7213,7 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                   CALL MUMPS_SAVE_RESTORE_FRONT_DATA(id%FDM_F_ENCODING
-     &                 ,unit,id%MYID,"save"
+     &                 ,unit,id%MYID,save_mode
      &                 ,SIZE_GEST_FRONT_DATA,SIZE_VARIABLES_FRONT_DATA
      &                 ,SIZE_INT,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
      &                 ,size_read,size_allocated,size_written
@@ -7813,7 +7237,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%FDM_F_ENCODING)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -7826,7 +7250,7 @@ C
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
                if(size_array1.NE.-999) then
                   CALL MUMPS_SAVE_RESTORE_FRONT_DATA(id%FDM_F_ENCODING
-     &                 ,unit,id%MYID,"restore"
+     &                 ,unit,id%MYID,restore_mode
      &                 ,SIZE_GEST_FRONT_DATA,SIZE_VARIABLES_FRONT_DATA
      &                 ,SIZE_INT,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
      &                 ,size_read,size_allocated,size_written
@@ -7844,21 +7268,21 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("BLRARRAY_ENCODING")            
+         CASE(S_BLRARRAY_ENCODING)            
             NbRecords(i1)=1
             SIZE_GEST(i1)=SIZE_INT
             SIZE_VARIABLES(i1)=0_8
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%BLRARRAY_ENCODING)) THEN
                   CALL DMUMPS_SAVE_RESTORE_BLR(id%BLRARRAY_ENCODING
-     &                 ,unit,id%MYID,"memory_save"
+     &                 ,unit,id%MYID,memory_save_mode
      &                 ,SIZE_GEST_BLR,SIZE_VARIABLES_BLR
      &                 ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
      &                 ,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
      &                 ,size_read,size_allocated,size_written
      &                 ,id%INFO(1))                 
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%BLRARRAY_ENCODING)) THEN
                   write(unit,iostat=err) size(id%BLRARRAY_ENCODING,1)
                   if(err.ne.0) then
@@ -7870,7 +7294,7 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                   CALL DMUMPS_SAVE_RESTORE_BLR(id%BLRARRAY_ENCODING
-     &                 ,unit,id%MYID,"save"
+     &                 ,unit,id%MYID,save_mode
      &                 ,SIZE_GEST_BLR,SIZE_VARIABLES_BLR
      &                 ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
      &                 ,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
@@ -7895,7 +7319,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%BLRARRAY_ENCODING)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -7908,7 +7332,7 @@ C
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
                if(size_array1.NE.-999) then
                   CALL DMUMPS_SAVE_RESTORE_BLR(id%BLRARRAY_ENCODING
-     &                 ,unit,id%MYID,"restore"
+     &                 ,unit,id%MYID,restore_mode
      &                 ,SIZE_GEST_BLR,SIZE_VARIABLES_BLR
      &                 ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
      &                 ,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
@@ -7927,179 +7351,41 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("L0_OMP_FACTORS")
+         CASE(S_L0_OMP_FACTORS)
             NbRecords(i1)     =0   
             SIZE_GEST(i1)     =0   
             SIZE_VARIABLES(i1)=0_8 
             CALL DMUMPS_SAVE_RESTORE_L0FACARRAY(id%L0_OMP_FACTORS
-     &                 ,unit,id%MYID,trim(mode)
+     &                 ,unit,id%MYID,mode
      &                 ,SIZE_GEST_L0FAC,SIZE_VARIABLES_L0FAC
      &                 ,SIZE_INT, SIZE_INT8, SIZE_ARITH_DEP
      &                 ,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
      &                 ,size_read,size_allocated,size_written
      &                 ,id%INFO(1))                 
-         CASE("SCHED_SBTR")
-         CASE("LPOOL_A_L0_OMP")
+         CASE(S_SCHED_SBTR)
+         CASE(S_LPOOL_A_L0_OMP)
+           CALL MUMPS_SAVE_INT(id%LPOOL_A_L0_OMP)
+           IF ( id%INFO(1) .LT. 0 ) GOTO 100
+         CASE(S_LPOOL_B_L0_OMP)
+           CALL MUMPS_SAVE_INT(id%LPOOL_B_L0_OMP)
+           IF ( id%INFO(1) .LT. 0 ) GOTO 100
+         CASE(S_L_PHYS_L0_OMP)
+           CALL MUMPS_SAVE_INT(id%L_PHYS_L0_OMP)
+           IF ( id%INFO(1) .LT. 0 ) GOTO 100
+         CASE(S_L_VIRT_L0_OMP)     
+           CALL MUMPS_SAVE_INT(id%L_VIRT_L0_OMP)
+           IF ( id%INFO(1) .LT. 0 ) GOTO 100
+         CASE(S_LL0_OMP_MAPPING)
+           CALL MUMPS_SAVE_INT(id%LL0_OMP_MAPPING)
+           IF ( id%INFO(1) .LT. 0 ) GOTO 100
+         CASE(S_LL0_OMP_FACTORS)
+           CALL MUMPS_SAVE_INT(id%LL0_OMP_FACTORS)
+           IF ( id%INFO(1) .LT. 0 ) GOTO 100
+         CASE(S_THREAD_LA)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%LPOOL_A_L0_OMP
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%LPOOL_A_L0_OMP
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("LPOOL_B_L0_OMP")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%LPOOL_B_L0_OMP
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%LPOOL_B_L0_OMP
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("L_PHYS_L0_OMP")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%L_PHYS_L0_OMP
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%L_PHYS_L0_OMP
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("L_VIRT_L0_OMP")     
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%L_VIRT_L0_OMP
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%L_VIRT_L0_OMP
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("LL0_OMP_MAPPING")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%LL0_OMP_MAPPING
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%LL0_OMP_MAPPING
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("LL0_OMP_FACTORS")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%LL0_OMP_FACTORS
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%LL0_OMP_FACTORS
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("THREAD_LA")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%THREAD_LA
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -8109,7 +7395,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8
                read(unit,iostat=err) id%THREAD_LA
                if(err.ne.0) THEN
@@ -8121,9 +7407,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("IPOOL_A_L0_OMP")
+         CASE(S_IPOOL_A_L0_OMP)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%IPOOL_A_L0_OMP)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
@@ -8132,7 +7418,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%IPOOL_A_L0_OMP)) THEN
                   write(unit,iostat=err) size(id%IPOOL_A_L0_OMP,1)
                   if(err.ne.0) then
@@ -8164,7 +7450,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%IPOOL_A_L0_OMP)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -8204,9 +7490,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("IPOOL_B_L0_OMP")
+         CASE(S_IPOOL_B_L0_OMP)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%IPOOL_B_L0_OMP)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
@@ -8215,7 +7501,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%IPOOL_B_L0_OMP)) THEN
                   write(unit,iostat=err) size(id%IPOOL_B_L0_OMP,1)
                   if(err.ne.0) then
@@ -8247,7 +7533,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%IPOOL_B_L0_OMP)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -8287,9 +7573,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PHYS_L0_OMP")
+         CASE(S_PHYS_L0_OMP)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%PHYS_L0_OMP)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
@@ -8298,7 +7584,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PHYS_L0_OMP)) THEN
                   write(unit,iostat=err) size(id%PHYS_L0_OMP,1)
                   if(err.ne.0) then
@@ -8330,7 +7616,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PHYS_L0_OMP)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -8369,9 +7655,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("VIRT_L0_OMP")
+         CASE(S_VIRT_L0_OMP)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%VIRT_L0_OMP)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%VIRT_L0_OMP,1)*SIZE_INT
@@ -8379,7 +7665,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%VIRT_L0_OMP)) THEN
                   write(unit,iostat=err) size(id%VIRT_L0_OMP,1)
                   if(err.ne.0) then
@@ -8411,7 +7697,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%VIRT_L0_OMP)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -8450,9 +7736,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("VIRT_L0_OMP_MAPPING")
+         CASE(S_VIRT_L0_OMP_MAPPING)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%VIRT_L0_OMP_MAPPING)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%VIRT_L0_OMP_MAPPING,1)
@@ -8461,7 +7747,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%VIRT_L0_OMP_MAPPING)) THEN
                   write(unit,iostat=err) size(id%VIRT_L0_OMP_MAPPING,1)
                   if(err.ne.0) then
@@ -8493,7 +7779,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%VIRT_L0_OMP_MAPPING)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -8533,9 +7819,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PERM_L0_OMP")
+         CASE(S_PERM_L0_OMP)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%PERM_L0_OMP)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%PERM_L0_OMP,1)*SIZE_INT
@@ -8543,7 +7829,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PERM_L0_OMP)) THEN
                   write(unit,iostat=err) size(id%PERM_L0_OMP,1)
                   if(err.ne.0) then
@@ -8575,7 +7861,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PERM_L0_OMP)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -8614,9 +7900,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PTR_LEAFS_L0_OMP")
+         CASE(S_PTR_LEAFS_L0_OMP)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%PTR_LEAFS_L0_OMP)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
@@ -8625,7 +7911,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PTR_LEAFS_L0_OMP)) THEN
                   write(unit,iostat=err) size(id%PTR_LEAFS_L0_OMP,1)
                   if(err.ne.0) then
@@ -8657,7 +7943,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PTR_LEAFS_L0_OMP)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -8697,9 +7983,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("L0_OMP_MAPPING")
+         CASE(S_L0_OMP_MAPPING)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%L0_OMP_MAPPING)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
@@ -8708,7 +7994,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%L0_OMP_MAPPING)) THEN
                   write(unit,iostat=err) size(id%L0_OMP_MAPPING,1)
                   if(err.ne.0) then
@@ -8740,7 +8026,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%L0_OMP_MAPPING)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -8779,46 +8065,102 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("SINGULAR_VALUES")
-        CASE("NB_SINGULAR_VALUES")
-           NbRecords(i1)=1
-           if(trim(mode).EQ."memory_save") then
-              SIZE_VARIABLES(i1)=SIZE_INT
-           elseif(trim(mode).EQ."save") then
-              write(unit,iostat=err) id%NB_SINGULAR_VALUES
+         CASE(S_SINGULAR_VALUES)
+            NbRecords(i1)=2
+            if(mode.EQ.memory_save_mode) then
+               IF(associated(id%SINGULAR_VALUES)) THEN
+                  SIZE_GEST(i1)=SIZE_INT
+                  SIZE_VARIABLES(i1)=
+     &                 size(id%SINGULAR_VALUES,1)*SIZE_RL_OR_DBL
+              ELSE
+                 SIZE_GEST(i1)=SIZE_INT*2
+                 SIZE_VARIABLES(i1)=0_8
+              ENDIF
+           elseif(mode.EQ.save_mode) then
+              IF(associated(id%SINGULAR_VALUES)) THEN
+                 write(unit,iostat=err) size(id%SINGULAR_VALUES,1)
+                 if(err.ne.0) then
+                    id%INFO(1) = -72
+                    CALL MUMPS_SETI8TOI4(size_written,id%INFO(2))
+                 endif
+                 CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                id%COMM, id%MYID )
+                 IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                 write(unit,iostat=err) id%SINGULAR_VALUES
+              ELSE
+                 write(unit,iostat=err) -999
+                 if(err.ne.0) then
+                    id%INFO(1) = -72
+                    CALL MUMPS_SETI8TOI4(size_written,id%INFO(2))
+                 endif
+                 CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                id%COMM, id%MYID )
+                 IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                 write(unit,iostat=err) -999
+              ENDIF 
               if(err.ne.0) then
                  id%INFO(1) = -72
-                 CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                id%INFO(2))
+                 CALL MUMPS_SETI8TOI4(size_written,id%INFO(2))
               endif
               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &             id%COMM, id%MYID )
               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-           elseif(trim(mode).EQ."restore") then
-              SIZE_VARIABLES(i1)=SIZE_INT
-              read(unit,iostat=err) id%NB_SINGULAR_VALUES
-              if(err.ne.0) THEN
-                 id%INFO(1) = -75
-                 CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                ,id%INFO(2))
-              endif 
-              CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &             id%COMM, id%MYID )
-              IF ( id%INFO(1) .LT. 0 ) GOTO 100
+           elseif(mode.EQ.restore_mode) then
+              nullify(id%SINGULAR_VALUES)
+               read(unit,iostat=err) size_array1
+               if(err.ne.0) THEN
+                  id%INFO(1) = -75
+                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
+     &                 ,id%INFO(2))
+               endif
+               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &              id%COMM, id%MYID )
+               IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               if(size_array1.EQ.-999) then
+                  SIZE_GEST(i1)=SIZE_INT*2
+                  SIZE_VARIABLES(i1)=0_8
+                  read(unit,iostat=err) dummy
+               else
+                  SIZE_GEST(i1)=SIZE_INT
+                  SIZE_VARIABLES(i1)=size_array1*SIZE_RL_OR_DBL
+                  allocate(id%SINGULAR_VALUES(size_array1),
+     &                 stat=allocok)
+                  if (allocok .GT. 0) THEN
+                     id%INFO(1) = -78
+                     CALL MUMPS_SETI8TOI4(
+     &                    TOTAL_STRUC_SIZE-size_allocated
+     &                    ,id%INFO(2))
+                  endif
+                  read(unit,iostat=err) id%SINGULAR_VALUES
+               endif
+               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &              id%COMM, id%MYID )
+               IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               if(err.ne.0) THEN
+                  id%INFO(1) = -75
+                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
+     &                 ,id%INFO(2))
+               endif
+               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &              id%COMM, id%MYID )
+               IF ( id%INFO(1) .LT. 0 ) GOTO 100
            endif
-        CASE("ASSOCIATED_OOC_FILES")
-            if(trim(mode).EQ."memory_save") then
+        CASE(S_NB_SINGULAR_VALUES)
+           CALL MUMPS_SAVE_INT(id%NB_SINGULAR_VALUES)
+           IF ( id%INFO(1) .LT. 0 ) GOTO 100
+        CASE(S_ASSOCIATED_OOC_FILES)
+            if(mode.EQ.memory_save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_LOGICAL
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_LOGICAL
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_LOGICAL
             endif
-        CASE("SAVE_DIR")
+        CASE(S_SAVE_DIR)
            NbRecords(i1)=1
-           if(trim(mode).EQ."memory_save") then
+           if(mode.EQ.memory_save_mode) then
               SIZE_VARIABLES(i1)=len(id%SAVE_DIR)*SIZE_CHARACTER
-           elseif(trim(mode).EQ."save") then
+           elseif(mode.EQ.save_mode) then
               write(unit,iostat=err) id%SAVE_DIR
               if(err.ne.0) then
                  id%INFO(1) = -72
@@ -8828,7 +8170,7 @@ C
               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &             id%COMM, id%MYID )
               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-           elseif(trim(mode).EQ."restore") then
+           elseif(mode.EQ.restore_mode) then
               SIZE_VARIABLES(i1)=len(id%SAVE_DIR)*SIZE_CHARACTER
               read(unit,iostat=err) id%SAVE_DIR
               if(err.ne.0) THEN
@@ -8840,11 +8182,11 @@ C
      &             id%COMM, id%MYID )
               IF ( id%INFO(1) .LT. 0 ) GOTO 100
            endif
-        CASE("SAVE_PREFIX")
+        CASE(S_SAVE_PREFIX)
            NbRecords(i1)=1
-           if(trim(mode).EQ."memory_save") then
+           if(mode.EQ.memory_save_mode) then
               SIZE_VARIABLES(i1)=len(id%SAVE_PREFIX)*SIZE_CHARACTER
-           elseif(trim(mode).EQ."save") then
+           elseif(mode.EQ.save_mode) then
               write(unit,iostat=err) id%SAVE_PREFIX
               if(err.ne.0) then
                  id%INFO(1) = -72
@@ -8854,7 +8196,7 @@ C
               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &             id%COMM, id%MYID )
               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-           elseif(trim(mode).EQ."restore") then
+           elseif(mode.EQ.restore_mode) then
               SIZE_VARIABLES(i1)=len(id%SAVE_PREFIX)*SIZE_CHARACTER
               read(unit,iostat=err) id%SAVE_PREFIX
               if(err.ne.0) THEN
@@ -8866,20 +8208,20 @@ C
      &             id%COMM, id%MYID )
               IF ( id%INFO(1) .LT. 0 ) GOTO 100
            endif
-        CASE("MPITOOMP_PROCS_MAP")
+        CASE(S_MTKO_PROCS_MAP)
            NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
-               IF(associated(id%MPITOOMP_PROCS_MAP)) THEN
+            if(mode.EQ.memory_save_mode) then
+               IF(associated(id%MTKO_PROCS_MAP)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
-     &                 size(id%MPITOOMP_PROCS_MAP,1)*SIZE_INT
+     &                 size(id%MTKO_PROCS_MAP,1)*SIZE_INT
                ELSE
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
-               IF(associated(id%MPITOOMP_PROCS_MAP)) THEN
-                  write(unit,iostat=err) size(id%MPITOOMP_PROCS_MAP,1)
+            elseif(mode.EQ.save_mode) then
+               IF(associated(id%MTKO_PROCS_MAP)) THEN
+                  write(unit,iostat=err) size(id%MTKO_PROCS_MAP,1)
                   if(err.ne.0) then
                      id%INFO(1) = -72
                      CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
@@ -8888,7 +8230,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-                  write(unit,iostat=err) id%MPITOOMP_PROCS_MAP
+                  write(unit,iostat=err) id%MTKO_PROCS_MAP
                ELSE
                   write(unit,iostat=err) -999
                   if(err.ne.0) then
@@ -8909,8 +8251,8 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               nullify(id%MPITOOMP_PROCS_MAP)
+            elseif(mode.EQ.restore_mode) then
+               nullify(id%MTKO_PROCS_MAP)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
                   id%INFO(1) = -75
@@ -8927,7 +8269,7 @@ C
                else
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size_array1*SIZE_INT
-                  allocate(id%MPITOOMP_PROCS_MAP(size_array1),
+                  allocate(id%MTKO_PROCS_MAP(0:size_array1-1),
      &                 stat=allocok)
                   if (allocok .GT. 0) THEN
                      id%INFO(1) = -78
@@ -8935,7 +8277,7 @@ C
      &                    TOTAL_STRUC_SIZE-size_allocated
      &                    ,id%INFO(2))
                   endif
-                  read(unit,iostat=err) id%MPITOOMP_PROCS_MAP
+                  read(unit,iostat=err) id%MTKO_PROCS_MAP
                endif
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
@@ -8949,11 +8291,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("METIS_OPTIONS")
+         CASE(S_METIS_OPTIONS)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%METIS_OPTIONS,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%METIS_OPTIONS
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -8963,7 +8305,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%METIS_OPTIONS,1)
                read(unit,iostat=err) id%METIS_OPTIONS
                if(err.ne.0) THEN
@@ -8975,23 +8317,23 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif      
-      CASE("pad0","pad1","pad2","pad3","pad4","pad5","pad6","pad7",
-     &     "pad11","pad111", "pad12","pad13","pad14","pad15","pad16")
+      CASE(S_pad1,S_pad2,S_pad3,S_pad4,S_pad5,S_pad6,S_pad7,
+     &     S_pad11,S_pad12,S_pad13,S_pad14,S_pad16)
       CASE DEFAULT
       END SELECT
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          NbSubRecords=int(SIZE_VARIABLES(i1)/huge(I4))
          IF(NbSubRecords.GT.0) then
             NbRecords(i1)=NbRecords(i1)+NbSubRecords
          ENDIF
-      elseif(trim(mode).EQ."save") then
+      elseif(mode.EQ.save_mode) then
          size_written=size_written+SIZE_VARIABLES(i1)
      &        +int(SIZE_GEST(i1),kind=8)
 #if defined(MUMPS_NOF2003)
          size_written=size_written
      &        +int(2*id%KEEP(34)*NbRecords(i1),kind=8)
 #endif
-      elseif(trim(mode).EQ."restore") then
+      elseif(mode.EQ.restore_mode) then
          size_allocated=size_allocated+SIZE_VARIABLES(i1)+
      &        DIFF_SIZE_ALLOC_READ(i1)
          size_read=size_read+SIZE_VARIABLES(i1)
@@ -9000,11 +8342,11 @@ C
          size_read=size_read
      &        +int(2*id%KEEP(34)*NbRecords(i1),kind=8)
 #endif
-      elseif(trim(mode).EQ."fake_restore") then
+      elseif(mode.EQ.fake_restore_mode) then
       endif
       ENDDO
  200  continue
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          WRITTEN_STRUC_SIZE=sum(SIZE_VARIABLES)+sum(SIZE_VARIABLES_ROOT)
      &        +SIZE_VARIABLES_BLR+SIZE_VARIABLES_FRONT_DATA+
      &         SIZE_VARIABLES_L0FAC
@@ -9031,8 +8373,8 @@ C
          gest_size=gest_size+int(2*id%KEEP(34)*tot_NbRecords,kind=8)
 #endif
          TOTAL_FILE_SIZE=WRITTEN_STRUC_SIZE+gest_size
-      elseif(trim(mode).EQ."save") then
-      elseif(trim(mode).EQ."restore") then
+      elseif(mode.EQ.save_mode) then
+      elseif(mode.EQ.restore_mode) then
 #if ! defined(NOSCALAPACK)
          if(id%root%gridinit_done) then
             id%root%CNTXT_BLACS = id%COMM_NODES
@@ -9042,18 +8384,131 @@ C
             id%root%DESCRIPTOR(2) = id%root%CNTXT_BLACS
          endif
 #endif
-      elseif(trim(mode).EQ."fake_restore") then
-      elseif(trim(mode).EQ."restore_ooc") then
+      elseif(mode.EQ.fake_restore_mode) then
+      elseif(mode.EQ.restore_ooc_mode) then
       endif
  100  continue
-      deallocate(VARIABLES, VARIABLES_ROOT)
       RETURN
       CONTAINS
+      SUBROUTINE MUMPS_SAVERSTR_REALARRAY(idREAL)
+      IMPLICIT NONE
+      DOUBLE PRECISION, DIMENSION(:), POINTER :: idREAL
+      NbRecords(i1)=2
+      if(mode.EQ.memory_save_mode) then
+         IF(associated(idREAL)) THEN
+            SIZE_GEST(i1)=SIZE_INT
+            SIZE_VARIABLES(i1)=size(idREAL,1)*SIZE_RL_OR_DBL
+         ELSE
+            SIZE_GEST(i1)=SIZE_INT*2
+            SIZE_VARIABLES(i1)=0_8
+         ENDIF
+      elseif(mode.EQ.save_mode) then
+         IF(associated(idREAL)) THEN
+            write(unit,iostat=err) size(idreal,1)
+            if(err.ne.0) then
+               id%INFO(1) = -72
+               CALL MUMPS_SETI8TOI4(
+     &              TOTAL_FILE_SIZE-size_written,
+     &              id%INFO(2))
+            endif
+            write(unit,iostat=err) idREAL
+         ELSE
+            write(unit,iostat=err) -999
+            if(err.ne.0) then
+               id%INFO(1) = -72
+               CALL MUMPS_SETI8TOI4(
+     &         TOTAL_FILE_SIZE-size_written,
+     &         id%INFO(2))
+            endif
+            write(unit,iostat=err) -999
+         ENDIF 
+         if(err.ne.0) then
+               id%INFO(1) = -72
+               CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
+     &         id%INFO(2))
+         endif
+         CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+         IF ( id%INFO(1) .LT. 0 ) GOTO 100
+      elseif(mode.EQ.restore_mode) then
+         nullify(idREAL)
+         read(unit,iostat=err) size_array1
+         if (err.ne.0) THEN
+           id%INFO(1) = -75
+           CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
+     &                    ,id%INFO(2))
+         endif
+         CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+         IF ( id%INFO(1) .LT. 0 ) GOTO 100
+           if (size_array1.EQ.-999) then
+                     SIZE_GEST(i1)=SIZE_INT*2
+                     SIZE_VARIABLES(i1)=0_8
+                     read(unit,iostat=err) dummy
+           else
+                     SIZE_GEST(i1)=SIZE_INT
+                     SIZE_VARIABLES(i1)=size_array1*SIZE_RL_OR_DBL
+                     allocate(idREAL(size_array1), stat=allocok)
+                     if (allocok .GT. 0) THEN
+                        id%INFO(1) = -78
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_STRUC_SIZE-size_allocated
+     &                       ,id%INFO(2))
+                     endif
+                     read(unit,iostat=err) idREAL
+           endif
+           CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                          id%COMM, id%MYID )
+           IF ( id%INFO(1) .LT. 0 ) GOTO 100
+           if (err.ne.0) THEN
+               id%INFO(1) = -75
+               CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
+     &                    ,id%INFO(2))
+           endif 
+           CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                          id%COMM, id%MYID )
+           IF ( id%INFO(1) .LT. 0 ) GOTO 100
+      endif
+ 100  CONTINUE
+      RETURN
+      END SUBROUTINE MUMPS_SAVERSTR_REALARRAY
+      SUBROUTINE MUMPS_SAVE_INT(idINT)
+      IMPLICIT NONE
+      INTEGER, INTENT(INOUT) :: idINT
+      NbRecords(i1)=1
+      if(mode.EQ.memory_save_mode) then
+         SIZE_VARIABLES(i1)=SIZE_INT
+      elseif(mode.EQ.save_mode) then
+         write(unit,iostat=err) idINT
+         if(err.ne.0) then
+           id%INFO(1) = -72
+           CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
+     &          id%INFO(2))
+         endif
+         CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &        id%COMM, id%MYID )
+         IF ( id%INFO(1) .LT. 0 ) GOTO 100
+      elseif(mode.EQ.restore_mode) then
+         SIZE_VARIABLES(i1)=SIZE_INT
+         read(unit,iostat=err) idINT
+         if(err.ne.0) THEN
+            id%INFO(1) = -75
+            CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
+     &           ,id%INFO(2))
+         endif 
+         CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &        id%COMM, id%MYID )
+         IF ( id%INFO(1) .LT. 0 ) GOTO 100
+      endif
+ 100  CONTINUE
+      RETURN
+      END SUBROUTINE MUMPS_SAVE_INT
       SUBROUTINE DMUMPS_SAVE_INT_SHPTR_ARRAY(id_INTPTR
      &  )
+      IMPLICIT NONE
       INTEGER, POINTER, DIMENSION(:) :: id_INTPTR
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id_INTPTR)
      &            ) THEN
                   SIZE_GEST(i1)=SIZE_INT
@@ -9062,7 +8517,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id_INTPTR)
      &            ) THEN
                   write(unit,iostat=err) size(id_INTPTR,1)
@@ -9095,7 +8550,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id_INTPTR)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -9142,3 +8597,8 @@ C
       END SUBROUTINE DMUMPS_SAVE_INT_SHPTR_ARRAY
       END SUBROUTINE DMUMPS_SAVE_RESTORE_STRUCTURE
       END MODULE DMUMPS_SAVE_RESTORE
+#else
+      SUBROUTINE DMUMPS_SAVE_RESTORE_RETURN()
+      RETURN
+      END SUBROUTINE DMUMPS_SAVE_RESTORE_RETURN
+#endif
diff -pruN 5.6.2-2.1/src/dmumps_save_restore_files.F 5.7.1-1/src/dmumps_save_restore_files.F
--- 5.6.2-2.1/src/dmumps_save_restore_files.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dmumps_save_restore_files.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -11,11 +11,11 @@ C  released under the CeCILL-C license
 C  (see doc/CeCILL-C_V1-en.txt, doc/CeCILL-C_V1-fr.txt, and
 C  https://cecill.info/licences/Licence_CeCILL-C_V1-en.html)
 C
+#if ! defined(NO_SAVE_RESTORE)
       MODULE DMUMPS_SAVE_RESTORE_FILES
       USE DMUMPS_STRUC_DEF
       IMPLICIT NONE
-      INTEGER :: LEN_SAVE_FILE
-      PARAMETER( LEN_SAVE_FILE = 550)
+      INTEGER, PARAMETER :: LEN_SAVE_FILE = 1318
       CONTAINS
       SUBROUTINE MUMPS_READ_HEADER(fileunit, ierr, size_read, SIZE_INT
      &     ,SIZE_INT8, TOTAL_FILE_SIZE, TOTAL_STRUC_SIZE
@@ -113,10 +113,6 @@ C
         size_read=size_read
      &           +int(2*SIZE_INT*1,kind=8)
 #endif
-#if defined(OOC_VERBOSE)
-        write(*,*) 'First ooc file: ',
-     &   READ_OOC_FIRST_FILE_NAME(1:READ_OOC_FILE_NAME_LENGTH-2)
-#endif
       ENDIF
  100  continue
       RETURN
@@ -237,60 +233,76 @@ C
       TYPE (DMUMPS_STRUC),intent(inout) :: id
       CHARACTER(len=LEN_SAVE_FILE),intent(out):: SAVE_FILE, INFO_FILE
       INTEGER::len_save_dir,len_save_prefix
-      CHARACTER(len=255):: tmp_savedir,savedir
-      CHARACTER(len=255):: tmp_saveprefix,saveprefix
+      INTEGER, PARAMETER :: SAVE_PREFIX_MAX_LENGTH =  255
+      INTEGER, PARAMETER :: SAVE_DIR_MAX_LENGTH    = 1023
+      CHARACTER(len=SAVE_DIR_MAX_LENGTH)    :: tmp_save_dir
+      CHARACTER(len=SAVE_DIR_MAX_LENGTH)    :: save_dir
+      CHARACTER(len=SAVE_PREFIX_MAX_LENGTH) :: save_prefix
+      CHARACTER(len=SAVE_PREFIX_MAX_LENGTH) :: tmp_save_prefix
       CHARACTER(len=10):: STRING_MYID
       CHARACTER:: LAST_CHAR_DIR
       INFO_FILE=''
       SAVE_FILE=''
-      tmp_savedir=''
-      tmp_saveprefix=''
+      tmp_save_dir=''
+      tmp_save_prefix=''
       IF(id%SAVE_DIR.EQ."NAME_NOT_INITIALIZED") THEN
-         call mumps_get_save_dir_C(len_save_dir,tmp_savedir)
-         if(tmp_savedir(1:len_save_dir).EQ."NAME_NOT_INITIALIZED") then
-            id%INFO(1) = -77
-            id%INFO(2) = 0 
+         call MUMPS_GET_SAVE_DIR_C(len_save_dir,tmp_save_dir)
+         len_save_dir=min(SAVE_DIR_MAX_LENGTH,len_save_dir)
+         if (len_save_dir > SAVE_DIR_MAX_LENGTH) then
+           id%INFO(1) = -77
+           id%INFO(2) = SAVE_DIR_MAX_LENGTH
+         else if(tmp_save_dir(1:len_save_dir).EQ."NAME_NOT_INITIALIZED")
+     &     then
+           id%INFO(1) = -77
+           id%INFO(2) = 0 
          else
-            savedir=trim(adjustl(tmp_savedir(1:len_save_dir)))
-            len_save_dir=len_trim(savedir(1:len_save_dir))
+           save_dir=trim(adjustl(tmp_save_dir(1:len_save_dir)))
+           len_save_dir=len_trim(save_dir(1:len_save_dir))
          endif
       ELSE
-         savedir=trim(adjustl(id%SAVE_DIR))
-         len_save_dir=len_trim(savedir)
+         save_dir=trim(adjustl(id%SAVE_DIR))
+         len_save_dir=len_trim(save_dir)
       ENDIF
       CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &     id%COMM, id%MYID )
       IF ( id%INFO(1) .LT. 0 ) GOTO 100
       IF(id%SAVE_PREFIX.EQ."NAME_NOT_INITIALIZED") THEN
-         call mumps_get_save_prefix_C(len_save_prefix,tmp_saveprefix)
-         if(tmp_saveprefix(1:len_save_prefix).EQ."NAME_NOT_INITIALIZED")
-     &        then
-            saveprefix="save"
-            len_save_prefix=len_trim(saveprefix)
-         else
-            saveprefix=
-     &           trim(adjustl(tmp_saveprefix(1:len_save_prefix)))
-            len_save_prefix=len_trim(saveprefix(1:len_save_prefix))
-         endif
+        call MUMPS_GET_SAVE_PREFIX_C(len_save_prefix,tmp_save_prefix)
+        len_save_prefix=min(SAVE_PREFIX_MAX_LENGTH,len_save_prefix)
+        if(len_save_prefix.GT.SAVE_PREFIX_MAX_LENGTH) then
+          id%INFO(1)=-77
+          id%INFO(2)=-SAVE_PREFIX_MAX_LENGTH
+        else if(tmp_save_prefix(1:len_save_prefix).EQ.
+     &  "NAME_NOT_INITIALIZED") then
+           save_prefix="save"
+           len_save_prefix=len_trim(save_prefix)
+        else
+           save_prefix=
+     &          trim(adjustl(tmp_save_prefix(1:len_save_prefix)))
+           len_save_prefix=len_trim(save_prefix(1:len_save_prefix))
+        endif
       ELSE
-         saveprefix=trim(adjustl(id%SAVE_PREFIX))
-         len_save_prefix=len_trim(saveprefix)
+        save_prefix=trim(adjustl(id%SAVE_PREFIX))
+        len_save_prefix=len_trim(save_prefix)
       ENDIF
+      CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &     id%COMM, id%MYID )
+      IF ( id%INFO(1) .LT. 0 ) GOTO 100
       write(STRING_MYID,'(I10)') id%MYID
-      LAST_CHAR_DIR=savedir(len_save_dir:len_save_dir)
+      LAST_CHAR_DIR=save_dir(len_save_dir:len_save_dir)
       if(LAST_CHAR_DIR.NE."/") then
-         SAVE_FILE=trim(adjustl(savedir))//"/"
+         SAVE_FILE=trim(adjustl(save_dir))//"/"
       else
-         SAVE_FILE=trim(adjustl(savedir))
+         SAVE_FILE=trim(adjustl(save_dir))
       endif
       INFO_FILE=trim(adjustl(SAVE_FILE))
       SAVE_FILE=trim(adjustl(SAVE_FILE))
-     &     //trim(adjustl(saveprefix))
+     &     //trim(adjustl(save_prefix))
      &     //"_"
      &     //trim(adjustl(STRING_MYID))
      &     //".mumps"
       INFO_FILE=trim(adjustl(INFO_FILE))
-     &        //trim(adjustl(saveprefix))
+     &        //trim(adjustl(save_prefix))
      &        //"_"
      &        //trim(adjustl(STRING_MYID))
      &        //".info"
@@ -323,3 +335,8 @@ C
       ENDIF
       END SUBROUTINE DMUMPS_CHECK_FILE_NAME      
       END MODULE DMUMPS_SAVE_RESTORE_FILES
+#else
+      SUBROUTINE DMUMPS_SAVE_FILES_RETURN()
+      RETURN
+      END SUBROUTINE DMUMPS_SAVE_FILES_RETURN
+#endif
diff -pruN 5.6.2-2.1/src/dmumps_sol_es.F 5.7.1-1/src/dmumps_sol_es.F
--- 5.6.2-2.1/src/dmumps_sol_es.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dmumps_sol_es.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -13,16 +13,24 @@ C  https://cecill.info/licences/Licence_
 C
       MODULE DMUMPS_SOL_ES
       PRIVATE
-      PUBLIC:: PRUNED_SIZE_LOADED
       PUBLIC:: DMUMPS_CHAIN_PRUN_NODES
       PUBLIC:: DMUMPS_CHAIN_PRUN_NODES_STATS
       PUBLIC:: DMUMPS_INITIALIZE_RHS_BOUNDS
       PUBLIC:: DMUMPS_PROPAGATE_RHS_BOUNDS
       PUBLIC:: DMUMPS_TREE_PRUN_NODES
-      PUBLIC:: DMUMPS_TREE_PRUN_NODES_STATS
       PUBLIC:: DMUMPS_SOL_ES_INIT
+#     if defined(STAT_ES_SOLVE)
+      PUBLIC:: DMUMPS_SOL_ES_PRINT_STATS
+#     endif
+      PUBLIC:: DMUMPS_ES_GET_SUM_Nloc
+      PUBLIC:: DMUMPS_ES_NODES_SIZE_AND_FILL
       INTEGER(8), POINTER, DIMENSION(:,:) :: SIZE_OF_BLOCK
-      INTEGER(8) :: PRUNED_SIZE_LOADED
+#     if defined(STAT_ES_SOLVE)
+      DOUBLE PRECISION :: nb_flops,
+     &                    nb_sparse_flops,
+     &                    total_efficiency
+      INTEGER :: total_procs, total_blocks
+#endif
       INCLUDE 'mumps_headers.h'
       CONTAINS
       SUBROUTINE DMUMPS_SOL_ES_INIT(SIZE_OF_BLOCK_ARG, KEEP201)
@@ -34,6 +42,13 @@ C
       ELSE
         NULLIFY(SIZE_OF_BLOCK)
       ENDIF
+#if defined(STAT_ES_SOLVE)
+      nb_flops=0.0d0
+      nb_sparse_flops=0.0d0
+      total_efficiency=0.0d0
+      total_procs=0
+      total_blocks=0
+#endif
       RETURN
       END SUBROUTINE DMUMPS_SOL_ES_INIT
       SUBROUTINE DMUMPS_TREE_PRUN_NODES( 
@@ -50,7 +65,7 @@ C
       INTEGER, INTENT(IN) :: N, KEEP28
       INTEGER, INTENT(IN) :: DAD(KEEP28),NE_STEPS(KEEP28),FRERE(KEEP28)
       INTEGER, INTENT(IN) :: FILS(N), STEP(N)
-      INTEGER, INTENT(IN) :: nodes_RHS(KEEP28),  nb_nodes_RHS
+      INTEGER, INTENT(IN) :: nodes_RHS(:),  nb_nodes_RHS
       INTEGER :: nb_prun_nodes
       INTEGER, OPTIONAL, INTENT(INOUT):: Pruned_List(nb_prun_nodes)
       INTEGER :: nb_prun_roots
@@ -143,15 +158,15 @@ C
       INTEGER, INTENT(IN) :: KEEP28
       INTEGER, INTENT(IN) :: DAD(KEEP28)
       INTEGER, INTENT(IN) :: nb_nodes_RHS
-      INTEGER, INTENT(IN) :: nodes_RHS(nb_nodes_RHS)
-      INTEGER :: nb_prun_nodes
+      INTEGER, INTENT(IN) :: nodes_RHS(max(nb_nodes_RHS,1))
+      INTEGER, INTENT(INOUT) :: nb_prun_nodes
       INTEGER, OPTIONAL, INTENT(INOUT):: Pruned_List(nb_prun_nodes)
-      INTEGER :: nb_prun_roots
+      INTEGER, INTENT(INOUT) :: nb_prun_roots
       INTEGER, OPTIONAL, INTENT(INOUT):: Pruned_Roots(nb_prun_roots)
-      INTEGER :: nb_prun_leaves
+      INTEGER, INTENT(INOUT) :: nb_prun_leaves
       INTEGER, OPTIONAL, INTENT(INOUT):: Pruned_Leaves(nb_prun_leaves)
-      INTEGER :: Pruned_SONS(KEEP28)
-      LOGICAL :: TO_PROCESS(KEEP28)
+      INTEGER, INTENT(OUT) :: Pruned_SONS(KEEP28)
+      LOGICAL, INTENT(OUT) :: TO_PROCESS(KEEP28)
       INTEGER :: IN, I, ISTEP, TMP
       nb_prun_nodes = 0
       nb_prun_roots = 0
@@ -265,6 +280,10 @@ C
      & STEP, N, Pruned_SONS,
      & DAD, RHS_BOUNDS, NSTEPS,
      & MYID, COMM, KEEP485,
+#if defined(STAT_ES_SOLVE)
+     & KEEP46,
+     & IPTR_WORKING, SIZE_IPTR_WORKING, WORKING, SIZE_WORKING,
+#endif
      & IW, LIW, PTRIST, KIXSZ,OOC_FCT_LOC, PHASE, LDLT, K38)
       IMPLICIT NONE
       INCLUDE 'mpif.h'
@@ -275,10 +294,26 @@ C
       INTEGER, INTENT(IN) :: pruned_leaves(nb_pruned_leaves)
       INTEGER, INTENT(IN) :: LIW, IW(LIW), PTRIST(NSTEPS)
       INTEGER, INTENT(IN) :: KIXSZ, OOC_FCT_LOC, PHASE, LDLT, K38
+#     if defined(STAT_ES_SOLVE)
+      INTEGER, INTENT(IN) :: KEEP46 
+      INTEGER, INTENT(IN) :: SIZE_IPTR_WORKING, SIZE_WORKING, 
+     &                       IPTR_WORKING(SIZE_IPTR_WORKING),
+     &                       WORKING(SIZE_WORKING)
+#endif
       INTEGER, INTENT(INOUT):: RHS_BOUNDS(2*NSTEPS)
       INTEGER :: I, node, father, size_pool, next_size_pool
       INTEGER :: IERR
       INTEGER, ALLOCATABLE, DIMENSION(:) :: POOL, NBSONS
+#if defined(STAT_ES_SOLVE)
+      LOGICAL, ALLOCATABLE, DIMENSION(:) :: isleaf
+      INTEGER :: J, NPROCS, proc, allocok
+      LOGICAL :: found
+      DOUBLE PRECISION :: avg_load, efficiency, max_load, effmax
+      DOUBLE PRECISION, ALLOCATABLE, DIMENSION(:) :: proc_flops_buf
+      DOUBLE PRECISION :: proc_block_flops, block_flops
+      INTEGER :: SK38  
+      INTEGER, PARAMETER :: MASTER  = 0
+#endif
       ALLOCATE(POOL(nb_pruned_leaves),
      &         NBSONS(NSTEPS),
      &         STAT=IERR)
@@ -289,6 +324,37 @@ C
       size_pool = nb_pruned_leaves
       POOL = pruned_leaves
       NBSONS = Pruned_SONS
+#     if defined(STAT_ES_SOLVE)
+      NPROCS = SIZE_IPTR_WORKING-1
+      IF((MYID.EQ.MASTER).AND.(KEEP46.EQ.1)) THEN
+        ALLOCATE(isleaf(NSTEPS), STAT=IERR)
+        IF (IERR.NE.0) THEN
+          WRITE(6,*)'Allocation problem in DMUMPS_PROPAGATE_RHS_BOUNDS'
+          CALL MUMPS_ABORT()
+        END IF
+        isleaf = .FALSE.
+        DO I=1,nb_pruned_leaves
+          isleaf(abs(STEP(pruned_leaves(I)))) = .true.
+        END DO
+        proc = 0
+        DO I=1,NPROCS
+          found = .FALSE.
+          J = IPTR_WORKING(I)
+          DO WHILE((J.LE.IPTR_WORKING(I+1)-1).AND.(.NOT.found))
+            IF (isleaf(WORKING(J)))THEN
+              found = .TRUE.            
+            END IF
+            J = J + 1
+          END DO
+          IF(found) THEN
+            proc = proc + 1
+          END IF
+        END DO
+        total_procs = total_procs + proc
+        total_blocks = total_blocks + 1
+        DEALLOCATE(isleaf)
+      END IF
+#     endif
       DO WHILE (size_pool.ne.0)
         next_size_pool =0 
         DO I=1, size_pool 
@@ -314,6 +380,76 @@ C
         size_pool = next_size_pool 
       END DO
       DEALLOCATE(POOL, NBSONS)
+#     if defined(STAT_ES_SOLVE)
+      IF (KEEP46.EQ.1) THEN
+       IF(MYID.EQ.MASTER) THEN
+        block_flops = 0D0
+       END IF
+       proc_block_flops = 0D0
+       IF (K38 .GT. 0) THEN
+        SK38 = STEP(K38)
+       ELSE
+        SK38 = 0
+       END IF
+       DO I=1,NSTEPS
+        IF (RHS_BOUNDS(2*I).NE.0) THEN 
+          IF(PTRIST(I).GT.0) THEN
+            proc_block_flops = proc_block_flops
+     &           + dble(2*(RHS_BOUNDS(2*I) - RHS_BOUNDS(2*I-1) +1))
+     &           * dble(DMUMPS_LOCAL_FACTOR_SIZE(IW, LIW,
+     &             PTRIST(I)+KIXSZ, 
+     &             PHASE,LDLT,I.EQ.SK38))
+          END IF
+        END IF
+       END DO
+       IF(MYID.EQ.MASTER) THEN
+          ALLOCATE(proc_flops_buf(SIZE_IPTR_WORKING-1),stat=allocok)
+          IF(allocok.GT.0) THEN
+             WRITE(6,*)'Allocation problem of proc_flops_buf'
+     &            ,' in DMUMPS_PROPAGATE_RHS_BOUNDS'
+             CALL MUMPS_ABORT()
+          ENDIF
+          proc_flops_buf=0.0d0
+       ELSE 
+          ALLOCATE(proc_flops_buf(1),stat=allocok)
+          IF(allocok.GT.0) THEN
+             WRITE(6,*)'Allocation problem of proc_flops_buf'
+     &            ,' in DMUMPS_PROPAGATE_RHS_BOUNDS'
+             CALL MUMPS_ABORT()
+          ENDIF
+          proc_flops_buf=0.0d0
+       END IF
+       CALL MPI_GATHER(proc_block_flops, 1, MPI_DOUBLE_PRECISION,
+     &       proc_flops_buf, 1, MPI_DOUBLE_PRECISION,
+     &       0, COMM, IERR)
+       CALL MPI_REDUCE(proc_block_flops, block_flops, 1,
+     &  MPI_DOUBLE_PRECISION, MPI_SUM, 0, COMM, IERR)  
+       IF(MYID.EQ.MASTER) THEN                         
+        nb_sparse_flops = nb_sparse_flops+block_flops
+        avg_load = sum(proc_flops_buf)/dble(NPROCS)
+        max_load = maxval(proc_flops_buf)
+        efficiency = 0D0
+        effmax = 0D0
+        DO I=1,NPROCS
+          efficiency= efficiency + (proc_flops_buf(I)-avg_load)**2
+          IF (proc_flops_buf(I)-avg_load.GT.0.0D0) THEN
+            effmax = effmax + (max_load-avg_load)**2
+          ELSE IF (proc_flops_buf(I)-avg_load.LT.0.0D0) THEN
+            effmax = effmax + avg_load**2
+          END IF
+        END DO
+        efficiency = sqrt(efficiency/dble(NPROCS))
+        effmax = sqrt(effmax/dble(NPROCS))
+        IF(effmax.ne.0.0d0) efficiency = efficiency / effmax
+        efficiency = 1.0d0 - efficiency
+        efficiency = efficiency * block_flops 
+        total_efficiency = total_efficiency + efficiency
+        DEALLOCATE(proc_flops_buf)
+       ELSE
+        DEALLOCATE(proc_flops_buf)
+       END IF
+      END IF
+#endif
       RETURN
       END SUBROUTINE DMUMPS_PROPAGATE_RHS_BOUNDS
       INTEGER(8) FUNCTION DMUMPS_LOCAL_FACTOR_SIZE(IW,LIW,PTR,
@@ -340,7 +476,7 @@ C
      &            NPIV*(NPIV-1_8)/2_8 + (NROW-NPIV)*NPIV
           ELSE
             DMUMPS_LOCAL_FACTOR_SIZE =
-     &      NPIV*(NPIV+1_8)/2_8 + (LIELL-NPIV)*NPIV
+     &      NPIV*(NPIV-1_8)/2_8 + (LIELL-NPIV)*NPIV
           ENDIF
         ELSE
           DMUMPS_LOCAL_FACTOR_SIZE =
@@ -348,90 +484,13 @@ C
         END IF
       RETURN
       END FUNCTION DMUMPS_LOCAL_FACTOR_SIZE
-      INTEGER(8) FUNCTION DMUMPS_LOCAL_FACTOR_SIZE_BLR(IW,LIW,PTR,
-     &                                LRSTATUS, IWHANDLER,
-     &                                PHASE, LDLT, IS_ROOT)
-      USE DMUMPS_LR_DATA_M
-      USE DMUMPS_LR_TYPE
-        INTEGER, INTENT(IN) :: LIW, PTR, PHASE, LDLT
-        INTEGER, INTENT(IN) :: LRSTATUS, IWHANDLER
-        INTEGER, INTENT(IN) :: IW(LIW)
-        LOGICAL, INTENT(IN) :: IS_ROOT
-        INTEGER(8) :: NPIV, NROW, FACTOR_SIZE
-        INTEGER :: NB_PANELS, IPANEL, LorU, IBLOCK
-        LOGICAL :: LR_ACTIVATED
-        TYPE(LRB_TYPE), POINTER, DIMENSION(:) :: LRB_PANEL
-        NROW  = int(IW(PTR+2),8)
-        NPIV  = int(IW(PTR+3),8)
-        LR_ACTIVATED=(LRSTATUS.GE.2)
-        IF (LR_ACTIVATED) THEN
-          FACTOR_SIZE = 0_8
-          CALL DMUMPS_BLR_RETRIEVE_NB_PANELS(IWHANDLER, NB_PANELS)
-          IF (LDLT.EQ.0) THEN 
-            LorU = PHASE
-          ELSE
-            LorU = 0
-          ENDIF
-          DO IPANEL=1,NB_PANELS
-            IF (IS_ROOT.AND.IPANEL.EQ.NB_PANELS) THEN
-              CYCLE
-            ENDIF
-            IF (DMUMPS_BLR_EMPTY_PANEL_LORU(IWHANDLER, LorU, IPANEL))
-     &        THEN
-              CYCLE
-            ENDIF
-             CALL DMUMPS_BLR_RETRIEVE_PANEL_LORU(IWHANDLER, LorU,
-     &                       IPANEL, LRB_PANEL)
-            IF (size(LRB_PANEL).GT.0) THEN
-              IF (PHASE.EQ.0) THEN
-                FACTOR_SIZE = FACTOR_SIZE + 
-     &            int(LRB_PANEL(1)%N,8)*(int(LRB_PANEL(1)%N,8)-1_8)/2_8
-              ELSE
-                FACTOR_SIZE = FACTOR_SIZE + 
-     &           int(LRB_PANEL(1)%N,8)*(int(LRB_PANEL(1)%N,8)+1_8)/2_8
-              ENDIF
-            ENDIF
-            DO IBLOCK=1,size(LRB_PANEL)
-              IF (LRB_PANEL(IBLOCK)%ISLR) THEN
-                FACTOR_SIZE = FACTOR_SIZE + int(LRB_PANEL(IBLOCK)%K,8)*
-     &            int(LRB_PANEL(IBLOCK)%M+LRB_PANEL(IBLOCK)%M,8)
-              ELSE
-                FACTOR_SIZE = FACTOR_SIZE +
-     &             int(LRB_PANEL(IBLOCK)%M*LRB_PANEL(IBLOCK)%N,8)
-              ENDIF
-            ENDDO
-          ENDDO
-          DMUMPS_LOCAL_FACTOR_SIZE_BLR = FACTOR_SIZE
-        ELSE
-          DMUMPS_LOCAL_FACTOR_SIZE_BLR = 
-     &      DMUMPS_LOCAL_FACTOR_SIZE(IW, LIW, PTR, PHASE, LDLT, IS_ROOT)
-        ENDIF
-      RETURN
-      END FUNCTION DMUMPS_LOCAL_FACTOR_SIZE_BLR
-      SUBROUTINE DMUMPS_TREE_PRUN_NODES_STATS(MYID, N, KEEP28, KEEP201,
-     &           FR_FACT,
-     &           STEP, Pruned_List, nb_prun_nodes, OOC_FCT_TYPE_LOC)
-      INTEGER, intent(in) :: KEEP28, KEEP201, OOC_FCT_TYPE_LOC, MYID, N
-      INTEGER(8), intent(in) :: FR_FACT
-      INTEGER, intent(in) :: nb_prun_nodes
-      INTEGER, intent(in) :: Pruned_List(nb_prun_nodes)
-      INTEGER, intent(in) :: STEP(N)
-      INTEGER I, ISTEP
-      INTEGER(8) :: Pruned_Size
-      IF (KEEP201 .GT. 0) THEN
-        Pruned_Size = 0_8
-        DO I = 1, nb_prun_nodes
-          ISTEP = STEP(Pruned_List(I))
-          Pruned_Size = Pruned_Size + SIZE_OF_BLOCK
-     &                  (ISTEP, OOC_FCT_TYPE_LOC)
-        ENDDO
-        PRUNED_SIZE_LOADED = PRUNED_SIZE_LOADED +Pruned_Size
-      ENDIF
-      RETURN
-      END SUBROUTINE DMUMPS_TREE_PRUN_NODES_STATS
       SUBROUTINE DMUMPS_CHAIN_PRUN_NODES_STATS
      &                (MYID, N, KEEP28, KEEP201, KEEP485, FR_FACT,
      &                STEP, Pruned_List, nb_prun_nodes, OOC_FCT_TYPE_LOC
+#     if defined(STAT_ES_SOLVE)
+     &                , NRHS, COMM, IW, LIW, PTRIST, KIXSZ, PHASE,
+     &                  LDLT, K38
+#endif     
      & )
       IMPLICIT NONE
       INTEGER, intent(in) :: KEEP28, KEEP201, OOC_FCT_TYPE_LOC, N,
@@ -440,24 +499,203 @@ C
       INTEGER, intent(in) :: nb_prun_nodes, MYID
       INTEGER, intent(in) :: Pruned_List(nb_prun_nodes)
       INTEGER, intent(in) :: STEP(N)
+#if defined(STAT_ES_SOLVE)
+      INTEGER, INTENT(IN):: LIW, COMM, NRHS, LDLT, K38
+      INTEGER, INTENT(IN):: IW(LIW), PTRIST(KEEP28), KIXSZ, PHASE  
+      DOUBLE PRECISION :: proc_block_flops, block_flops
+      INTEGER(8) :: Pruned_Size_ic 
+      INTEGER :: IERR
+      INTEGER :: SK38 
+#endif
       INCLUDE 'mpif.h'
       INTEGER I, ISTEP
       INTEGER(8) :: Pruned_Size
+#if defined(STAT_ES_SOLVE)
+      Pruned_Size_ic = 0_8
+#endif
       Pruned_Size = 0_8
+#if defined(STAT_ES_SOLVE)
+      IF (K38 .GT. 0) THEN
+        SK38 = STEP(K38)
+      ELSE
+        SK38 = 0
+      END IF
+#endif
       DO I = 1, nb_prun_nodes
         ISTEP = STEP(Pruned_List(I))
         IF (KEEP201 .GT. 0) THEN
             Pruned_Size = Pruned_Size + SIZE_OF_BLOCK
      &                    (ISTEP, OOC_FCT_TYPE_LOC)
         ENDIF
+#if       defined(STAT_ES_SOLVE)
+          IF (PTRIST(ISTEP) .GT. 0) THEN
+            Pruned_Size_ic = Pruned_Size_ic + 
+     &               DMUMPS_LOCAL_FACTOR_SIZE(IW, LIW,
+     &               PTRIST(ISTEP)+KIXSZ, 
+     &               PHASE, LDLT,
+     &               ISTEP.EQ.SK38)
+          ENDIF
+#         endif
       ENDDO
-      IF (KEEP201.GT.0) THEN
-        IF (FR_FACT .NE. 0_8) THEN
-          PRUNED_SIZE_LOADED = PRUNED_SIZE_LOADED +Pruned_Size
-        ENDIF
-      ENDIF
+#if defined(STAT_ES_SOLVE)
+      proc_block_flops = dble(2_8*Pruned_Size_ic)*dble(NRHS)
+      CALL MPI_REDUCE(proc_block_flops, block_flops, 1,
+     & MPI_DOUBLE_PRECISION, MPI_SUM, 0, COMM, IERR)
+      IF(MYID.EQ.0) nb_flops = nb_flops + block_flops
+#endif
       RETURN
       END SUBROUTINE DMUMPS_CHAIN_PRUN_NODES_STATS
+#if   defined(STAT_ES_SOLVE)
+      SUBROUTINE DMUMPS_SOL_ES_PRINT_STATS(
+     &                  K212, K235, K237, K485, K497, NZLU8,
+     &                  NRHS, ICNTL27, N, K50, DKEEPS, RINFOGS, MPG)
+      IMPLICIT NONE
+      INTEGER, intent(in)    ::  K212, K235, K237, K485, K497, 
+     &                           NRHS, MPG, ICNTL27, N, K50
+      INTEGER(8), intent(in) :: NZLU8
+      DOUBLE PRECISION, intent(out)    :: DKEEPS(5), RINFOGS(5)
+      LOGICAL              :: AM1, ES_FWD, ES_BWD, DO_NBSPARSE
+      IF (MPG.LE.0) RETURN
+      AM1         = (K237 .NE. 0)
+      ES_FWD      = (K235 .NE. 0) .AND. (.NOT. AM1)
+      ES_BWD      = (K212 .NE. 0) .AND. (.NOT. AM1)
+      DO_NBSPARSE = (K497.NE.0).AND.(NRHS.GT.1).AND.(ICNTL27.GT.1)
+      IF (AM1) 
+     & WRITE(MPG,'(/A)') ' ** FLOPS SUMMARY during SOLVE AM1 ** '
+      IF ((ES_FWD).AND. (.NOT.ES_BWD)) 
+     & WRITE(MPG,'(/A,A)') ' ** FLOPS SUMMARY during fwd step',
+     &                  ' (exploit RHS sparsity) ** '
+      IF ((.NOT.ES_FWD).AND. (ES_BWD))
+     & WRITE(MPG,'(/A,A)') ' ** FLOPS SUMMARY during bwd step',
+     &                  ' (selected entries in solution) ** '
+      IF ((ES_FWD).AND. (ES_BWD)) 
+     & WRITE(MPG,'(/A,/A)') 
+     & ' ** FLOPS SUMMARY during SOLVE (fwd+bwd steps)',
+     & '    (sparse RHS and selected entries in solution) **'
+      IF (
+     &     (ES_FWD) .AND. (.NOT.ES_BWD)
+     &    .OR.
+     &     (.NOT.ES_FWD) .AND. (ES_BWD)
+     &   ) THEN
+       IF (K50.NE.0) THEN
+         DKEEPS(1)=(dble(NZLU8)-dble(N))*dble(2*NRHS)
+       ELSE
+         DKEEPS(1)=(dble(NZLU8)-dble(N))*dble(NRHS)
+       ENDIF
+      ELSE IF ((ES_FWD).AND.(ES_BWD)) THEN
+       IF (K50.NE.0) THEN
+         DKEEPS(1) = (dble(NZLU8)-dble(N))*dble(4*NRHS)
+       ELSE
+         DKEEPS(1)=(dble(NZLU8)-dble(N))*dble(2*NRHS)
+       ENDIF
+      ENDIF
+      RINFOGS(1) = DKEEPS(1)
+      IF (.NOT.AM1) THEN
+       WRITE(MPG,'(A,F25.1)') 
+     & ' RINFOG(24) FLOPS with dense full rank format  =', DKEEPS(1)
+      ENDIF
+      DKEEPS(2)=dble(nb_flops) 
+      IF (DO_NBSPARSE) DKEEPS(4)=dble(nb_sparse_flops)
+      IF (DO_NBSPARSE) THEN
+       RINFOGS(2)= DKEEPS(4)
+      ELSE
+       RINFOGS(2)= DKEEPS(2)
+      ENDIF
+      WRITE(MPG,'(A,F25.1)') 
+     & ' RINFOG(25) FLOPS with exploit sparsity (ES)   =', RINFOGS(2)
+      RETURN
+      END SUBROUTINE DMUMPS_SOL_ES_PRINT_STATS
+#endif
+      SUBROUTINE DMUMPS_ES_GET_SUM_Nloc (
+     &           N, Nloc_ITAB, ITAB_loc, COMM,
+     &           SUM_idNloc_8 )
+      IMPLICIT NONE
+      INTEGER, INTENT(IN)  :: N
+#if defined(MUMPS_NOF2003)
+        INTEGER, POINTER :: ITAB_loc (:)
+#else
+        INTEGER, INTENT( IN ), POINTER :: ITAB_loc (:)
+#endif
+      INTEGER, INTENT(IN)  :: Nloc_ITAB
+      INTEGER, INTENT(IN)  :: COMM
+      INTEGER(8)   :: SUM_idNloc_8
+      INCLUDE 'mpif.h'
+      INTEGER I, II, IERR_MPI 
+      INTEGER(8) :: idNloc_8
+      idNloc_8 = 0_8
+      DO I= 1, Nloc_ITAB
+          II = ITAB_loc(I)
+          IF (II.GE.1 .and. II.LE.N) 
+     &    idNloc_8 = idNloc_8 + 1_8
+      ENDDO
+      CALL MPI_ALLREDUCE (idNloc_8, SUM_idNloc_8, 1, 
+     &                  MPI_INTEGER8,
+     &                  MPI_SUM, COMM, IERR_MPI )
+      RETURN
+      END SUBROUTINE DMUMPS_ES_GET_SUM_Nloc
+      SUBROUTINE DMUMPS_ES_NODES_SIZE_AND_FILL (
+     &           fill, 
+     &           N, NSTEPS, KEEP, STEP, Step2node,
+     &           ITAB_loc, Nloc_ITAB, 
+     &           MYID, COMM,
+     &           Pruned_Sons, Lnodes_ITAB
+#if defined(AVOID_MPI_IN_PLACE)
+     &           , TMP_INT_ARRAY
+#endif
+     &           , nodes_ITAB
+     &           )
+      IMPLICIT NONE
+      LOGICAL, INTENT(IN)  :: fill
+      INTEGER, INTENT(IN)  :: N, NSTEPS, KEEP(500) 
+      INTEGER, INTENT(IN)  :: Nloc_ITAB
+      INTEGER, INTENT(IN)  :: STEP(N), Step2node(NSTEPS), 
+     &                        ITAB_loc(max(1,Nloc_ITAB))
+      INTEGER, INTENT(IN)  :: MYID, COMM
+#if defined(AVOID_MPI_IN_PLACE)
+      INTEGER              :: TMP_INT_ARRAY(NSTEPS) 
+#endif
+      INTEGER, INTENT(INOUT) :: Pruned_Sons(NSTEPS), Lnodes_ITAB
+      INTEGER, OPTIONAL, INTENT(OUT) :: nodes_ITAB(max(1,Lnodes_ITAB))
+      INCLUDE 'mpif.h'
+      INTEGER I, II, ISTEP, IERR_MPI, Lnodes_ITAB_loc, INODE_PRINC
+      IF (.NOT.fill) THEN
+        Pruned_SONS = 0
+        DO I= 1, Nloc_ITAB
+          II = ITAB_loc(I)
+          IF (II.GE.1 .and. II.LE.N) THEN
+            ISTEP = abs(STEP(II))
+            IF ( Pruned_SONS(ISTEP) .eq. 0 ) THEN
+              Pruned_SONS(ISTEP) = 1
+            ENDIF
+           ENDIF
+        ENDDO
+#if defined(AVOID_MPI_IN_PLACE)
+        TMP_INT_ARRAY = Pruned_Sons
+#endif
+        CALL MPI_ALLREDUCE(
+#if defined(AVOID_MPI_IN_PLACE)
+     &         TMP_INT_ARRAY, 
+#else
+     &         MPI_IN_PLACE,
+#endif
+     &         Pruned_Sons, NSTEPS, 
+     &         MPI_INTEGER, MPI_SUM, COMM, IERR_MPI)
+        Lnodes_ITAB = 0
+        DO ISTEP=1,NSTEPS
+          if (Pruned_SONS(ISTEP) .NE.0) Lnodes_ITAB=Lnodes_ITAB+1
+        ENDDO
+      ELSE IF (Lnodes_ITAB.GT.0) THEN
+        Lnodes_ITAB_loc = 0
+        DO ISTEP=1,NSTEPS
+          if (Pruned_SONS(ISTEP) .GT. 0) then
+            Lnodes_ITAB_loc=Lnodes_ITAB_loc+1
+            INODE_PRINC = Step2node( ISTEP )
+            nodes_ITAB(Lnodes_ITAB_loc)  = INODE_PRINC
+          endif
+        ENDDO
+      ENDIF
+      RETURN
+      END SUBROUTINE DMUMPS_ES_NODES_SIZE_AND_FILL
       END MODULE DMUMPS_SOL_ES
       SUBROUTINE DMUMPS_PERMUTE_RHS_GS
      &          (LP, LPOK, PROKG, MPG, PERM_STRAT, 
diff -pruN 5.6.2-2.1/src/dmumps_struc_def.F 5.7.1-1/src/dmumps_struc_def.F
--- 5.6.2-2.1/src/dmumps_struc_def.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dmumps_struc_def.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/domp_tps_m.F 5.7.1-1/src/domp_tps_m.F
--- 5.6.2-2.1/src/domp_tps_m.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/domp_tps_m.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/dooc_panel_piv.F 5.7.1-1/src/dooc_panel_piv.F
--- 5.6.2-2.1/src/dooc_panel_piv.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/dooc_panel_piv.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/double_linked_list.F 5.7.1-1/src/double_linked_list.F
--- 5.6.2-2.1/src/double_linked_list.F	2023-10-11 09:36:35.000000000 +0000
+++ 5.7.1-1/src/double_linked_list.F	2024-05-02 10:15:14.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -44,7 +44,7 @@ C
 #if defined(MUMPS_NOF2003)
           TYPE ( IDLL_T ), POINTER :: DLL
 #else
-          TYPE ( IDLL_T ), POINTER, INTENT ( OUT ) :: DLL
+          TYPE ( IDLL_T ), POINTER, INTENT ( INOUT ) :: DLL
 #endif
           TYPE ( IDLL_NODE_T ), POINTER :: AUX
           IF ( .NOT. associated ( DLL ) ) THEN
diff -pruN 5.6.2-2.1/src/drank_revealing.F 5.7.1-1/src/drank_revealing.F
--- 5.6.2-2.1/src/drank_revealing.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/drank_revealing.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -15,6 +15,25 @@ C
       IMPLICIT NONE
           INTEGER N, KEEP(500), ICNTL(60), MPG
           KEEP(19)=0
+          KEEP(19)=ICNTL(56)
+          IF ((KEEP(19).LT.1).OR.(KEEP(19).GE.2)) KEEP(19)=0
+          IF ( KEEP(53) .LE. 0 .and.
+     &         KEEP(19) .NE. 0 ) THEN
+             KEEP(19) = 0
+             IF ( MPG .GT. 0 ) THEN
+      WRITE( MPG,'(A)') '** Warning:  ICNTL(56) null space option'
+      WRITE( MPG,'(A)') '** disabled (incompatibility with analysis)'
+             END IF
+          END IF
+          KEEP(21) = min(ICNTL(57),N)
+          KEEP(22) = max(ICNTL(55),0)
+          IF ( KEEP(19) .ne. 0 .and. KEEP(60) .ne. 0 ) THEN
+             IF ( MPG .GT. 0 ) THEN
+      WRITE( MPG,'(A)') '** Warning: ICNTL(56)  null space option'
+      WRITE( MPG,'(A)') '** disabled (incompatibility with Schur)'
+             END IF
+            KEEP(19) = 0
+          END IF
           RETURN
       END SUBROUTINE DMUMPS_GET_NS_OPTIONS_FACTO
       SUBROUTINE DMUMPS_GET_NS_OPTIONS_SOLVE(ICNTL, KEEP, 
@@ -144,3 +163,496 @@ C
       ENDIF
       RETURN
       END SUBROUTINE DMUMPS_RR_FREE_POINTERS
+      SUBROUTINE DMUMPS_SEQ_SYMMETRIZE(N,A)
+      INTEGER N
+      DOUBLE PRECISION A( N, N )
+      INTEGER I,J
+      DO I = 2, N
+        DO J = 1, I - 1
+          A( I, J ) = A( J, I )
+        END DO
+      END DO
+      RETURN
+      END SUBROUTINE DMUMPS_SEQ_SYMMETRIZE
+      SUBROUTINE DMUMPS_UXVSBP(N,PERM,X,RN01)
+      INTEGER N,PERM(N),I
+      DOUBLE PRECISION RN01(N),X(N)
+      DO I=1,N
+        RN01(PERM(I))=X(I)
+      ENDDO
+      DO I=1,N
+        X(I)=RN01(I)
+      ENDDO
+      RETURN
+      END SUBROUTINE DMUMPS_UXVSBP
+      SUBROUTINE DMUMPS_UXVSFP(N,PERM,X,RN01)
+      INTEGER N,PERM(N),I
+      DOUBLE PRECISION RN01(N),X(N)
+      DO I=1,N
+        RN01(I)=X(PERM(I))
+      ENDDO
+      DO I=1,N
+        X(I)=RN01(I)
+      ENDDO
+      RETURN
+      END SUBROUTINE DMUMPS_UXVSFP
+      SUBROUTINE DMUMPS_SVD_QR_ESTIM_WK( PHASE, MBLOCK, NBLOCK, 
+     &           SIZE_ROOT_ARG,
+     &           LOCAL_M, LOCAL_N, ROOT_OWNER, KEEP,KEEP8,
+     &           LIWK_RR, LWK_RR )
+      IMPLICIT NONE
+      INTEGER, INTENT(IN) :: PHASE, SIZE_ROOT_ARG
+      INTEGER, INTENT(IN) :: MBLOCK, NBLOCK, LOCAL_M, LOCAL_N
+      LOGICAL, INTENT(IN) :: ROOT_OWNER
+      INTEGER, INTENT(IN) :: KEEP(500)
+      INTEGER(8), INTENT(IN) :: KEEP8(150)
+      INTEGER, INTENT(OUT):: LIWK_RR
+      INTEGER(8), INTENT(OUT):: LWK_RR
+      INTEGER SIZE_ROOT
+      INTEGER NBPOSPONED_ESTIM
+      PARAMETER (NBPOSPONED_ESTIM=2000)
+      INTEGER SVD_QR,PAR_ROOT
+      SVD_QR = KEEP(19)
+      PAR_ROOT = KEEP(38)
+      LIWK_RR = 0
+      LWK_RR = 0_8
+      IF (PAR_ROOT.EQ.0) THEN
+         IF(ROOT_OWNER) THEN
+           IF (PHASE.EQ.0) THEN
+                  SIZE_ROOT=SIZE_ROOT_ARG+NBPOSPONED_ESTIM
+           ELSE
+                  SIZE_ROOT=SIZE_ROOT_ARG
+           ENDIF
+           IF(SVD_QR.EQ.1) THEN
+              LWK_RR=int(5*SIZE_ROOT+1,8)
+           ELSEIF(SVD_QR.EQ.2) THEN
+              LWK_RR=int(3*SIZE_ROOT+1,8)
+           END IF
+         END IF
+      ENDIF
+      RETURN
+      END SUBROUTINE DMUMPS_SVD_QR_ESTIM_WK
+      SUBROUTINE DMUMPS_SEQ_FACTO_ROOT_SVD_QR
+     &(NN,A,ROOT,WR03,LWR03,KEEP,KEEP8,INFO,LP,DKEEP,
+     & GLOBK109,OPELIW,PIVNUL_LIST,LPIVNUL_LIST,
+     & ROW_INDICES)
+      USE DMUMPS_STRUC_DEF, ONLY : DMUMPS_ROOT_STRUC
+      IMPLICIT NONE
+      TYPE ( DMUMPS_ROOT_STRUC ) :: ROOT
+      INTEGER :: NN,LP,LWR03,LWR03_MINSIZE
+      DOUBLE PRECISION :: A(NN*NN)
+      INTEGER :: INFO(2),KEEP(500)
+      INTEGER(8) :: KEEP8(150)
+      DOUBLE PRECISION :: DKEEP(230)
+      DOUBLE PRECISION :: OPELIW
+      INTEGER :: GLOBK109
+      INTEGER :: LPIVNUL_LIST
+      INTEGER :: PIVNUL_LIST(LPIVNUL_LIST)
+      INTEGER :: ROW_INDICES(NN)
+      DOUBLE PRECISION :: WR03(LWR03)
+      INTEGER LDLT,DEFICIENCY
+      DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE :: RWORK
+      INTEGER :: I,LDA,LDU,LDVT,J
+      INTEGER :: IERR, LAST_BEFORE_GAP_IND
+      INTEGER :: LAST_BEFORE_GAPLIMIT_IND, FIRST_AFTER_MinPiv, 
+     &           FIRST_AFTER_GAPLIMIT, START_POINT, END_POINT 
+      INTEGER :: ALLOCOK,MAXDEF,MINDEF
+      DOUBLE PRECISION :: EPS, ZERO, GAPLIMIT, MaxGap, MaxGap1,
+     &        MinPiv, Tol_MaxGap
+      PARAMETER(ZERO=0.0D0)
+      EPS = epsilon(ZERO)
+      LDLT=KEEP(50)
+      IF ((KEEP(19) .NE. 1).AND.(KEEP(19) .NE. 2)) THEN
+        INFO(1)=-107
+        INFO(2)= KEEP(19)
+        IF ( LP .GT. 0 ) THEN
+            WRITE(LP,*) " *** Option ",KEEP(19),
+     &           " for null space no more available."
+        ENDIF  
+        GOTO 100
+      ENDIF
+      IF(KEEP(19).EQ.1) THEN
+              LWR03_MINSIZE=5*NN+1
+      ELSEIF(KEEP(19).EQ.2) THEN
+              LWR03_MINSIZE=3*NN+1
+      END IF
+      MAXDEF=KEEP(21)
+      IF ( MAXDEF .LE. 0 ) THEN
+        MAXDEF = NN
+      ELSE
+        MAXDEF = max(MAXDEF - GLOBK109,0)
+      ENDIF
+      MINDEF = max(KEEP(22) - GLOBK109,0)
+      MINDEF = min(MINDEF,NN)
+      MAXDEF = min(MAXDEF,NN)
+      IF(KEEP(19).EQ.1) THEN
+         OPELIW = OPELIW + dble(26)*dble(NN)*dble(NN)*dble(NN)
+      ELSEIF(KEEP(19).EQ.2) THEN
+         OPELIW = OPELIW +  dble(4)*dble(NN)*dble(NN)*dble(NN)/dble(3)
+      ENDIF
+      IF (associated(ROOT%SINGULAR_VALUES)) 
+     &     DEALLOCATE(ROOT%SINGULAR_VALUES)
+      NULLIFY(ROOT%SINGULAR_VALUES)
+      ROOT%NB_SINGULAR_VALUES=NN
+      ALLOCATE(ROOT%SINGULAR_VALUES(NN), stat=ALLOCOK)
+      IF (ALLOCOK.GT.0) THEN
+         INFO(1)=-13
+         INFO(2)=NN
+         IF ( LP .GT. 0 )
+     &        WRITE(LP,*) 'DMUMPS_SEQ_FACTO_ROOT_SVD_QR: Problem '
+     &        //'allocating SINGULAR_VALUES'
+         GOTO 100
+      END IF
+      IF(KEEP(19).EQ.1) THEN     
+         IF(associated(ROOT%SVD_U)) DEALLOCATE(ROOT%SVD_U)
+         NULLIFY(ROOT%SVD_U)
+         ALLOCATE(ROOT%SVD_U(NN,NN),stat=ALLOCOK )
+         IF(ALLOCOK.GT.0) THEN
+            INFO(1)=-13
+            INFO(2)=NN*NN
+            IF ( LP .GT. 0 )
+     &           WRITE(LP,*) 'DMUMPS_SEQ_FACTO_ROOT_SVD_QR: Problem '
+     &           //'allocating SVD_U'
+            GOTO 100
+         END IF
+         IF (associated(ROOT%SVD_VT)) DEALLOCATE(ROOT%SVD_VT)
+         NULLIFY(ROOT%SVD_VT)
+         ALLOCATE(ROOT%SVD_VT(NN,NN), stat=ALLOCOK)
+         IF (ALLOCOK.GT.0) THEN
+            INFO(1)=-13
+            INFO(2)=NN*NN
+            IF ( LP .GT. 0 )
+     &           WRITE(LP,*) 'DMUMPS_SEQ_FACTO_ROOT_SVD_QR: Problem '
+     &           //'allocating SVD_VT'
+            GOTO 100
+         END IF
+         IF (allocated(RWORK)) DEALLOCATE(RWORK)
+         ALLOCATE(RWORK(1), stat=ALLOCOK)
+         IF (ALLOCOK.GT.0) THEN
+            INFO(1)=-13
+            INFO(2)=1
+            IF ( LP .GT. 0 )
+     &           WRITE(LP,*) 
+     &           'DMUMPS_SEQ_FACTO_ROOT_SVD_QR: Problem '
+     &           //'allocating RWORK'
+            GOTO 100
+         END IF
+      ELSEIF(KEEP(19).EQ.2) THEN
+         IF (associated(ROOT%QR_TAU)) DEALLOCATE(ROOT%QR_TAU)
+         NULLIFY(ROOT%QR_TAU)
+         ALLOCATE(ROOT%QR_TAU(NN), stat=ALLOCOK)
+         IF (ALLOCOK.GT.0) THEN
+            INFO(1)=-13
+            INFO(2)=NN
+            IF ( LP .GT. 0 )
+     &           WRITE(LP,*) 
+     &           'DMUMPS_SEQ_FACTO_ROOT_SVD_QR: Problem '
+     &           //'allocating QR_TAU'
+            GOTO 100
+         END IF
+         IF (associated(ROOT%IPIV)) DEALLOCATE(ROOT%IPIV)
+         NULLIFY(ROOT%IPIV)
+         ALLOCATE(ROOT%IPIV(NN), stat=ALLOCOK)
+         IF (ALLOCOK.GT.0) THEN
+            INFO(1)=-13
+            INFO(2)=NN
+            IF ( LP .GT. 0 )
+     &           WRITE(LP,*) 
+     &           'DMUMPS_SEQ_FACTO_ROOT_SVD_QR: Problem '
+     &           //'allocating IPIV'
+            GOTO 100
+         END IF
+         IF (allocated(RWORK)) DEALLOCATE(RWORK)
+         ALLOCATE(RWORK(1), stat=ALLOCOK)
+         IF (ALLOCOK.GT.0) THEN
+            INFO(1)=-13
+            INFO(2)=1
+            IF ( LP .GT. 0 )
+     &           WRITE(LP,*) 
+     &           'DMUMPS_SEQ_FACTO_ROOT_SVD_QR: Problem '
+     &           //'allocating RWORK'
+            GOTO 100
+         END IF
+      ENDIF
+      IF (LDLT.NE.0) THEN
+         CALL DMUMPS_SEQ_SYMMETRIZE(NN,A)
+      END IF
+      LDA=NN
+      LDU=NN
+      LDVT=NN
+      IERR = 0
+      IF(KEEP(19).EQ.1) THEN
+         CALL dgesvd('A','A',NN,NN,A,LDA,ROOT%SINGULAR_VALUES(1)
+     &        ,ROOT%SVD_U(1,1)
+     &        ,LDU,ROOT%SVD_VT(1,1),LDVT,WR03,LWR03,IERR)
+      ENDIF
+      IF(IERR.NE.0) THEN
+         INFO(1)=-107
+         INFO(2)=IERR
+         IF (LP.GT.0) THEN
+            IF(KEEP(19).EQ.1) THEN
+               WRITE(LP,*) ' Problem in dgesvd : IERR = ', IERR
+            ELSEIF(KEEP(19).EQ.2) THEN
+               WRITE(LP,*) ' Problem in dgeqpf : IERR = ', IERR
+            ENDIF
+           GOTO 100
+         END IF
+      ENDIF
+      IF(KEEP(19).EQ.2) THEN
+         DO I=1,NN
+            ROOT%SINGULAR_VALUES(I)=abs(A(I+NN*(I-1)))
+         ENDDO
+      ENDIF
+      DEFICIENCY=0
+      MinPiv = DKEEP(20)
+      GAPLIMIT = DKEEP(9)
+      IF (ROOT%SINGULAR_VALUES(NN).GT.MinPiv) THEN
+              DEFICIENCY = 0
+              GOTO 170
+      ENDIF
+      IF (ROOT%SINGULAR_VALUES(1).LE.GAPLIMIT) THEN
+           DEFICIENCY = NN
+           GOTO 170
+      ENDIF
+      LAST_BEFORE_GAPLIMIT_IND = 0
+      LAST_BEFORE_GAP_IND  = 0
+      FIRST_AFTER_MinPiv   = 0
+      FIRST_AFTER_GAPLIMIT = 0
+      MaxGap  = 0
+      MaxGap1 = 0
+      Tol_MaxGap = DKEEP(24)
+      DO I=NN,1,-1
+              IF (FIRST_AFTER_MinPiv.GT.0)  exit   
+         IF(ROOT%SINGULAR_VALUES(I).LE.GAPLIMIT) THEN
+                  LAST_BEFORE_GAPLIMIT_IND = I
+         ELSE IF  ((FIRST_AFTER_GAPLIMIT.EQ.0).AND.
+     &               (ROOT%SINGULAR_VALUES(I).LE.MinPiv)) THEN
+                 FIRST_AFTER_GAPLIMIT = I
+         ELSE IF (ROOT%SINGULAR_VALUES(I).GT.MinPiv) THEN
+                 FIRST_AFTER_MinPiv = I
+                 IF (FIRST_AFTER_GAPLIMIT.EQ.0) FIRST_AFTER_GAPLIMIT = I
+         ENDIF
+      ENDDO
+      START_POINT = LAST_BEFORE_GAPLIMIT_IND
+      IF ((LAST_BEFORE_GAPLIMIT_IND.EQ.0).AND.
+     &    (FIRST_AFTER_GAPLIMIT.GT. FIRST_AFTER_MinPiv)) 
+     &               START_POINT = FIRST_AFTER_GAPLIMIT
+      END_POINT = FIRST_AFTER_MinPiv
+      IF (FIRST_AFTER_MinPiv.EQ.0) END_POINT = 1
+      DO I=START_POINT,END_POINT+1,-1
+          IF (ROOT%SINGULAR_VALUES(I).EQ.0) THEN
+             LAST_BEFORE_GAP_IND = I
+          ELSE
+              MaxGap1 = ROOT%SINGULAR_VALUES(I-1)*
+     &                                    (1/ROOT%SINGULAR_VALUES(I))
+             IF (MaxGap1.GE. Tol_MaxGap) THEN
+                  IF (MaxGap1.GE. DKEEP(25)*MaxGap ) THEN 
+                     LAST_BEFORE_GAP_IND = I
+                     MaxGap =  MaxGap1
+                  ENDIF  
+             ENDIF  
+          ENDIF
+      ENDDO
+      IF (MaxGap.EQ.ZERO) THEN        
+          IF (LAST_BEFORE_GAPLIMIT_IND.EQ.0) THEN
+               DEFICIENCY = 0
+          ELSE
+               DEFICIENCY = NN - LAST_BEFORE_GAPLIMIT_IND +1  
+          ENDIF
+      ELSE
+          DEFICIENCY = NN - LAST_BEFORE_GAP_IND +1  
+      ENDIF 
+ 170  CONTINUE
+      DEFICIENCY=min(DEFICIENCY,MAXDEF)
+      DEFICIENCY=max(DEFICIENCY,MINDEF)      
+      KEEP(17)=DEFICIENCY
+      IF(KEEP(19).EQ.2) THEN
+         IF(DEFICIENCY.GT.0) THEN
+            CALL dtrtrs('U','N','N',NN-DEFICIENCY,DEFICIENCY,
+     &           A,LDA,A(LDA*(NN-DEFICIENCY)+1),LDA,IERR)
+            IF ( IERR .NE. 0 ) THEN
+               IF (LP.GT.0) 
+     &         WRITE(LP,*) ' Internal error in dtrtrs: IERR = ',IERR
+               CALL MUMPS_ABORT()
+            END IF
+         END IF
+      ENDIF
+      DO J=NN-DEFICIENCY+1, NN
+         IF(KEEP(19).EQ.1) THEN
+            PIVNUL_LIST(J-NN+DEFICIENCY) = ROW_INDICES(J)
+         ELSEIF(KEEP(19).EQ.2) THEN
+            PIVNUL_LIST(J-NN+DEFICIENCY) = ROW_INDICES(ROOT%IPIV(J))
+         ENDIF
+      ENDDO
+ 100  CONTINUE     
+      IF (allocated(RWORK)) DEALLOCATE(RWORK)
+      RETURN
+      END SUBROUTINE DMUMPS_SEQ_FACTO_ROOT_SVD_QR
+      SUBROUTINE DMUMPS_SEQ_SOLVE_ROOT_SVD_QR
+     &  (NRHS,NN,A,ROOT,
+     &   IBEG_ROOT_DEF, IEND_ROOT_DEF,
+     &   RHS,KEEP,KEEP8,MTYPE,INFO,LWK8,WK, LP)
+      USE DMUMPS_STRUC_DEF, ONLY : DMUMPS_ROOT_STRUC
+      IMPLICIT NONE
+      INTEGER NN, NRHS
+      INTEGER(8), INTENT(IN) :: LWK8
+      TYPE ( DMUMPS_ROOT_STRUC ) :: root
+      DOUBLE PRECISION A(NN*NN)
+      INTEGER IBEG_ROOT_DEF, IEND_ROOT_DEF, MTYPE
+      INTEGER INFO(2),KEEP(500)
+      INTEGER(8) KEEP8(150)
+      DOUBLE PRECISION RHS(NN,NRHS), WK(LWK8)
+      INTEGER LP
+      INTEGER :: LWK
+      DOUBLE PRECISION,DIMENSION(:,:), allocatable :: TEMP_RHS
+      INTEGER :: I,IERR,K
+      INTEGER :: LDLT,RRSTRAT,DEFICIENCY,LDA,LDRHS
+      INTEGER :: ALLOCOK
+      DOUBLE PRECISION, PARAMETER    :: RONE=1.0D+0
+      DOUBLE PRECISION ZERO, ONE, MINUSONE
+      PARAMETER( ZERO = 0.0D0, ONE = 1.0D0, MINUSONE=-1.0D0 )
+      LDLT      = KEEP(50)
+      RRSTRAT   = KEEP(19)
+      DEFICIENCY = KEEP(17)
+      LDA = NN
+      LDRHS = NN
+      LWK = int(min(int(huge(LWK),8),LWK8))
+      IERR = 0
+      IF ((RRSTRAT .NE. 1).AND.(RRSTRAT .NE. 2)) THEN
+         WRITE(*,*) " *** Internal error ption ",RRSTRAT,
+     &        " for null space no more available."
+         CALL MUMPS_ABORT()
+      ENDIF
+      IF (KEEP(111).EQ.0) THEN
+         IF(KEEP(19).EQ.1) THEN
+           IF ((MTYPE.EQ.0).OR.(LDLT.GT.0)) THEN
+               allocate(TEMP_RHS(NN,NRHS), stat=ALLOCOK)
+               IF (ALLOCOK.GT.0) THEN
+                 INFO(1)=-13
+                 INFO(2)=NN*NRHS
+                 IF ( LP .GT. 0 )
+     &              WRITE(LP,*) 
+     &              'DMUMPS_SEQ_SOLVE_ROOT_SVD_QR: Problem '
+     &              //'allocating TEMP_RHS'
+                 RETURN
+               END IF
+               CALL dgemm('Transpose','N',NN,NRHS,NN,ONE,
+     &              root%SVD_U(1,1),NN,RHS,
+     &              NN,ZERO,TEMP_RHS,NN)
+               DO I=1,NN-DEFICIENCY
+                  TEMP_RHS( I, 1:NRHS ) = (ONE/root%SINGULAR_VALUES(I))*
+     &                          TEMP_RHS( I, 1:NRHS )
+               ENDDO
+               DO I=NN-DEFICIENCY +1, NN
+                  TEMP_RHS(I, 1:NRHS) = ZERO 
+               ENDDO
+               CALL dgemm('Transpose','N',NN,NRHS,NN,ONE,
+     &               root%SVD_VT(1,1),NN,
+     &              TEMP_RHS, NN,ZERO,RHS,NN)
+               DEALLOCATE(TEMP_RHS)
+           ELSEIF(MTYPE.EQ.1) THEN
+               allocate(TEMP_RHS(NN,NRHS), stat=ALLOCOK)
+               IF (ALLOCOK.GT.0) THEN
+                  INFO(1)=-13
+                  INFO(2)=NN*NRHS
+                  IF ( LP .GT. 0 )
+     &              WRITE(LP,*) 
+     &              'DMUMPS_SEQ_SOLVE_ROOT_SVD_QR: Problem '
+     &              //'allocating TEMP_RHS'
+                  RETURN
+               END IF
+               CALL dgemm('N','N',NN,NRHS,NN,ONE,root%SVD_VT(1,1),NN,
+     &              RHS, NN,ZERO,TEMP_RHS,NN)
+               DO I=1,NN-DEFICIENCY
+                  TEMP_RHS( I, 1:NRHS ) = (ONE/root%SINGULAR_VALUES(I))*
+     &                          TEMP_RHS( I, 1:NRHS )
+               ENDDO
+               DO I=NN-DEFICIENCY +1, NN
+                  TEMP_RHS(I, 1:NRHS) = ZERO 
+               ENDDO
+               CALL dgemm('N','N',NN,NRHS,NN,ONE,root%SVD_U(1,1),NN,
+     &             TEMP_RHS,NN,ZERO,RHS,NN)
+               DEALLOCATE(TEMP_RHS)
+            ENDIF
+         ELSEIF(KEEP(19).EQ.2) THEN
+            IF ((MTYPE.EQ.0).OR.(LDLT.GT.0)) THEN
+               CALL dormqr('L','Transpose',NN,NRHS,NN,
+     &              A,LDA,root%QR_TAU(1),
+     &              RHS,LDRHS,WK(1),LWK,IERR)
+               IF(IERR.LT.0) THEN
+                  WRITE(*,*) 
+     &         'Error return from dormqr in root solve: IERR=', IERR
+                  RETURN
+               END IF
+               CALL dtrtrs('U','N','N',NN-DEFICIENCY,NRHS,A,LDA,
+     &              RHS,LDRHS,IERR)
+               IF ( IERR .LT. 0 ) THEN
+                  WRITE(*,*) 
+     &         'Error return from dtrtrs in roor solve: IERR =',IERR
+                  RETURN
+               END IF
+               DO I=1,NRHS
+                  RHS( NN - DEFICIENCY + 1: NN, I ) = ZERO  
+               ENDDO
+               DO I=1,NRHS
+                  CALL DMUMPS_UXVSBP(NN,root%IPIV(1),RHS(1,I),WK)
+               ENDDO
+           ELSEIF(MTYPE.EQ.1) THEN
+               DO I=1,NRHS
+                 CALL DMUMPS_UXVSFP(NN,root%IPIV(1),RHS(1,I),WK)
+               ENDDO
+               CALL dtrtrs('U','T','N',NN-DEFICIENCY,NRHS,
+     &              A,LDA,RHS,LDRHS,IERR)
+               IF(IERR.NE.0) THEN
+                  WRITE(*,*) 'Error return from trtrs: IERR=', IERR
+                  STOP    
+               END IF
+               DO I=1,NRHS
+                  RHS( NN - DEFICIENCY + 1: NN, I ) = ZERO  
+               ENDDO
+               CALL dormqr( 'L','N',NN,NRHS,NN,A,LDA,root%QR_TAU(1),
+     &              RHS,LDRHS,WK,LWK,IERR)
+               IF(IERR.LT.0) THEN
+                  WRITE(*,*) 'Error return from dormqr: IERR=', IERR
+                  RETURN
+               END IF
+            ENDIF
+         ENDIF
+      ELSE
+         IF(KEEP(19).EQ.1) THEN
+           IF ((MTYPE.EQ.0).OR.(LDLT.GT.0)) THEN
+               DO I=IBEG_ROOT_DEF,IEND_ROOT_DEF
+                  RHS(:,I+1-IBEG_ROOT_DEF) = 
+     &                 root%SVD_VT(NN-DEFICIENCY+I,:)
+               ENDDO
+           ELSEIF(MTYPE.EQ.1) THEN
+               DO I=IBEG_ROOT_DEF,IEND_ROOT_DEF
+                  RHS(:,I+1-IBEG_ROOT_DEF) = 
+     &                 root%SVD_U(:,NN-DEFICIENCY+I)
+               ENDDO
+            ENDIF
+         ELSEIF(KEEP(19).EQ.2) THEN
+           IF((MTYPE.EQ.0).OR.(LDLT.GT.0)) THEN        
+               DO I=IBEG_ROOT_DEF,IEND_ROOT_DEF
+                  RHS(NN-DEFICIENCY+I,I-IBEG_ROOT_DEF+1) = MINUSONE
+                  DO K=1,NN-DEFICIENCY
+                     RHS(K,I-IBEG_ROOT_DEF+1)=
+     &                    A(K + LDA*(NN-DEFICIENCY+I-1))
+                  ENDDO
+               ENDDO
+               DO I=1,IEND_ROOT_DEF-IBEG_ROOT_DEF+1
+                  CALL DMUMPS_UXVSBP(NN,root%IPIV(1),RHS(1,I),WK)
+               ENDDO 
+           ELSEIF(MTYPE.EQ.1) THEN
+               WRITE(*,*) 'Computation of a null space basis'
+     &              // ' of A is unavailable for unsymetric matrices'
+            DO I=IBEG_ROOT_DEF,IEND_ROOT_DEF
+               RHS(NN-DEFICIENCY+I,I-IBEG_ROOT_DEF+1) = ONE
+            ENDDO
+            CALL dormqr('L','N',NN,NRHS,NN, A,LDA,root%QR_TAU(1),
+     &              RHS,LDRHS,WK(1),LWK,IERR)
+            ENDIF
+         ENDIf
+      ENDIF
+      RETURN
+      END SUBROUTINE DMUMPS_SEQ_SOLVE_ROOT_SVD_QR
diff -pruN 5.6.2-2.1/src/dsol_aux.F 5.7.1-1/src/dsol_aux.F
--- 5.6.2-2.1/src/dsol_aux.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/dsol_aux.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -307,7 +307,8 @@ C
       DOUBLE PRECISION W(N), X(N)
       DOUBLE PRECISION, intent(inout)    :: EST
       INTEGER, intent(in)    :: GRAIN
-      INTRINSIC abs, nint, real, sign
+      INTRINSIC abs, nint, sign
+      INTRINSIC dble
       INTEGER DMUMPS_IXAMAX
       EXTERNAL DMUMPS_IXAMAX
       INTEGER ITMAX
@@ -407,7 +408,7 @@ C
       DO 170 I = 1, N
         TEMP = TEMP + abs(X(I))
   170 CONTINUE
-      TEMP = 2.0D0 * TEMP / dble(3 * N)
+      TEMP = 2.0D0/3.0D0 * TEMP / dble(N)
       IF (TEMP .GT. EST) THEN
         DO 180 I = 1, N
           W(I) = X(I)
@@ -953,7 +954,7 @@ C
       DOUBLE PRECISION, PARAMETER :: ZERO = 0.0D0
       DOUBLE PRECISION, PARAMETER :: ONE  = 1.0D0
       INTEGER DMUMPS_IXAMAX
-      INTRINSIC     abs, max
+      INTRINSIC     abs
       SAVE LCOND1, LCOND2, JUMP,  DXIMAX, DXMAX
       IF (KASE .EQ. 0) THEN
         LCOND1 = .FALSE.
@@ -1033,14 +1034,14 @@ C
   170 CONTINUE
       RETURN
       END SUBROUTINE DMUMPS_SOL_LCOND
-      SUBROUTINE DMUMPS_SOL_CPY_FS2RHSCOMP( JBDEB, JBFIN, NBROWS,
-     &   KEEP, RHSCOMP, NRHS, LRHSCOMP, FIRST_ROW_RHSCOMP, W, LD_W,
+      SUBROUTINE DMUMPS_SOL_CPY_FS2RHSINTR( JBDEB, JBFIN, NBROWS,
+     &   KEEP, RHSINTR, NRHS, LRHSINTR, FIRST_ROW_RHSINTR, W, LD_W,
      &   FIRST_ROW_W )
          INTEGER :: JBDEB, JBFIN, NBROWS
-         INTEGER :: NRHS, LRHSCOMP
-         INTEGER :: FIRST_ROW_RHSCOMP
+         INTEGER :: NRHS, LRHSINTR
+         INTEGER :: FIRST_ROW_RHSINTR
          INTEGER, INTENT(IN) :: KEEP(500)
-         DOUBLE PRECISION, INTENT(INOUT) :: RHSCOMP(LRHSCOMP,NRHS)
+         DOUBLE PRECISION, INTENT(INOUT) :: RHSINTR(LRHSINTR,NRHS)
          INTEGER :: LD_W, FIRST_ROW_W
          DOUBLE PRECISION :: W(LD_W*(JBFIN-JBDEB+1))
          INTEGER :: JJ, K, ISHIFT
@@ -1050,33 +1051,33 @@ C
          DO K = JBDEB, JBFIN
            ISHIFT = FIRST_ROW_W + LD_W * (K-JBDEB)
            DO JJ = 0, NBROWS-1
-              RHSCOMP(FIRST_ROW_RHSCOMP+JJ,K) = W(ISHIFT+JJ)
+              RHSINTR(FIRST_ROW_RHSINTR+JJ,K) = W(ISHIFT+JJ)
            END DO
          END DO
 !$OMP    END PARALLEL DO
       RETURN
-      END SUBROUTINE DMUMPS_SOL_CPY_FS2RHSCOMP
+      END SUBROUTINE DMUMPS_SOL_CPY_FS2RHSINTR
       SUBROUTINE DMUMPS_SOL_BWD_GTHR( JBDEB, JBFIN, J1, J2,
-     &   RHSCOMP, NRHS, LRHSCOMP, W, LD_W, FIRST_ROW_W,
-     &   IW, LIW, KEEP, N, POSINRHSCOMP_BWD )
+     &   RHSINTR, NRHS, LRHSINTR, W, LD_W, FIRST_ROW_W,
+     &   IW, LIW, KEEP, N, POSINRHSINTR_BWD )
       INTEGER, INTENT(IN) :: JBDEB, JBFIN, J1, J2
-      INTEGER, INTENT(IN) :: NRHS, LRHSCOMP
+      INTEGER, INTENT(IN) :: NRHS, LRHSINTR
       INTEGER, INTENT(IN) :: FIRST_ROW_W, LD_W, LIW
       INTEGER, INTENT(IN) :: IW(LIW)
       INTEGER, INTENT(IN) :: KEEP(500)
-      DOUBLE PRECISION, INTENT(INOUT) :: RHSCOMP(LRHSCOMP,NRHS)
+      DOUBLE PRECISION, INTENT(INOUT) :: RHSINTR(LRHSINTR,NRHS)
       DOUBLE PRECISION :: W(LD_W*(JBFIN-JBDEB+1))
       INTEGER, INTENT(IN) :: N
-      INTEGER, INTENT(IN) :: POSINRHSCOMP_BWD(N)
-      INTEGER :: ISHIFT, JJ, K, IPOSINRHSCOMP
-!$OMP PARALLEL DO PRIVATE(JJ,ISHIFT,IPOSINRHSCOMP), IF
+      INTEGER, INTENT(IN) :: POSINRHSINTR_BWD(N)
+      INTEGER :: ISHIFT, JJ, K, IPOSINRHSINTR
+!$OMP PARALLEL DO PRIVATE(JJ,ISHIFT,IPOSINRHSINTR), IF
 !$OMP& ((JBFIN-JBDEB+1 > 2*KEEP(362) .AND.
 !$OMP& (JBFIN-JBDEB+1)*(J2-KEEP(253)-J1+1)>2*KEEP(363)))
              DO K=JBDEB, JBFIN
                ISHIFT = FIRST_ROW_W+(K-JBDEB)*LD_W
                DO JJ = J1, J2-KEEP(253)   
-                 IPOSINRHSCOMP =  abs(POSINRHSCOMP_BWD(IW(JJ)))
-                 W(ISHIFT+JJ-J1)= RHSCOMP(IPOSINRHSCOMP,K)
+                 IPOSINRHSINTR =  abs(POSINRHSINTR_BWD(IW(JJ)))
+                 W(ISHIFT+JJ-J1)= RHSINTR(IPOSINRHSINTR,K)
                ENDDO
              ENDDO
 !$OMP END PARALLEL DO
@@ -1134,11 +1135,11 @@ C
       RESL2 = sqrt(RESL2)
       IF (PROK) WRITE( MPRINT, 90 ) RESMAX, RESL2, ANORM, XNORM, 
      &      SCLNRM
-   90  FORMAT (/' RESIDUAL IS ............ (MAX-NORM)        =',1PD9.2/
+   90  FORMAT (/' RESIDUAL IS ............ (INF-NORM)        =',1PD9.2/
      &       '                       .. (2-NORM)          =',1PD9.2/
-     &       ' RINFOG(4):NORM OF input  Matrix  (MAX-NORM)=',1PD9.2/
-     &       ' RINFOG(5):NORM OF Computed SOLUT (MAX-NORM)=',1PD9.2/
-     &       ' RINFOG(6):SCALED RESIDUAL ...... (MAX-NORM)=',1PD9.2)
+     &       ' RINFOG(4):NORM OF input  Matrix  (INF-NORM)=',1PD9.2/
+     &       ' RINFOG(5):NORM OF Computed SOLUT (INF-NORM)=',1PD9.2/
+     &       ' RINFOG(6):SCALED RESIDUAL ...... (INF-NORM)=',1PD9.2)
       RETURN
       END SUBROUTINE DMUMPS_SOL_Q
       SUBROUTINE DMUMPS_SOLVE_FWD_TRSOLVE (A, LA, APOS, NPIV, LDADIAG, 
@@ -1370,8 +1371,8 @@ C
      &  IW, IPOS, LIW, 
      &  A, LA, APOS,
      &  WCB, LWCB, LD_WCBPIV, 
-     &  RHSCOMP, LRHSCOMP, NRHS, 
-     &  POSINRHSCOMP_FWD, JBDEB, JBFIN, 
+     &  RHSINTR, LRHSINTR, NRHS, 
+     &  POSINRHSINTR_FWD, JBDEB, JBFIN, 
      &  MTYPE, KEEP, OOCWRITE_COMPATIBLE_WITH_BLR,
      &  IGNORE_K459
      &  )
@@ -1379,18 +1380,18 @@ C
       IMPLICIT NONE
       INTEGER, INTENT(IN) :: MTYPE, INODE, N, NPIV, LIELL,
      &                       NELIM, NSLAVES
-      INTEGER, INTENT(IN) :: LRHSCOMP, NRHS, LIW, JBDEB, JBFIN
-      INTEGER, INTENT(IN) :: IW(LIW), IPOS, POSINRHSCOMP_FWD(N)
+      INTEGER, INTENT(IN) :: LRHSINTR, NRHS, LIW, JBDEB, JBFIN
+      INTEGER, INTENT(IN) :: IW(LIW), IPOS, POSINRHSINTR_FWD(N)
       INTEGER(8), INTENT(IN) :: LWCB, APOS, LA, PPIV_COURANT
       INTEGER, INTENT(IN) :: LD_WCBPIV
       INTEGER, INTENT(IN) :: KEEP(500)
       DOUBLE PRECISION, INTENT(IN) ::  WCB( LWCB )
       DOUBLE PRECISION, INTENT(IN) :: A( LA )
-      DOUBLE PRECISION, INTENT(INOUT) :: RHSCOMP(LRHSCOMP, NRHS)
+      DOUBLE PRECISION, INTENT(INOUT) :: RHSINTR(LRHSINTR, NRHS)
       LOGICAL, INTENT(IN) :: OOCWRITE_COMPATIBLE_WITH_BLR
       LOGICAL, INTENT(IN) :: IGNORE_K459
       INTEGER    :: J1, J3
-      INTEGER    :: IPOSINRHSCOMP, JJ, K,
+      INTEGER    :: IPOSINRHSINTR, JJ, K,
      &              LDAJ, NRHS_B
       INTEGER(8) :: IFR8 , APOS1, APOS2, APOSOFF, IFR_ini8, 
      &              POSWCB1, POSWCB2
@@ -1412,7 +1413,7 @@ C
          J1 = IPOS + LIELL + 1
          J3 = IPOS + LIELL + NPIV
       END IF
-      IPOSINRHSCOMP =  POSINRHSCOMP_FWD(IW(J1)) 
+      IPOSINRHSINTR =  POSINRHSINTR_FWD(IW(J1)) 
       IF ( KEEP(50) .eq. 0 ) THEN
          OMP_FLAG = .FALSE.
 !$       OMP_FLAG=(int(NRHS_B,8)*int(NPIV,8).GE.int(KEEP(363),8))
@@ -1420,7 +1421,7 @@ C
 !$OMP PARALLEL DO PRIVATE(IFR8) COLLAPSE(2)
            DO K = JBDEB, JBFIN
              DO IFR8 = 0_8, int(NPIV-1,8)
-               RHSCOMP(IPOSINRHSCOMP+IFR8, K) =
+               RHSINTR(IPOSINRHSINTR+IFR8, K) =
      &            WCB(PPIV_COURANT+(K-JBDEB)*LD_WCBPIV+IFR8)
              ENDDO
            ENDDO
@@ -1428,7 +1429,7 @@ C
          ELSE
            DO K = JBDEB, JBFIN
              DO IFR8 = 0_8, int(NPIV-1,8)
-               RHSCOMP(IPOSINRHSCOMP+IFR8, K) =
+               RHSINTR(IPOSINRHSINTR+IFR8, K) =
      &            WCB(PPIV_COURANT+(K-JBDEB)*LD_WCBPIV+IFR8)
              ENDDO
            ENDDO
@@ -1448,7 +1449,7 @@ C
             DO JJ = J1, J3
               IPANEL = (JJ-J1)/NB_TARGET + 1
               IF ( JJ-J1+1 .LT. PANEL_COL(IPANEL) ) IPANEL = IPANEL -1
-              ICOL = JJ-J1+1 - PANEL_COL(IPANEL) + 1
+              ICOL = JJ-J1+1 - PANEL_COL(IPANEL) + 1 
               LDAJ = PANEL_COL(IPANEL+1) - PANEL_COL(IPANEL)
               APOS1 = APOS-1_8+PANEL_POS( IPANEL ) + int(ICOL-1,8) *
      &                int(LDAJ+1,8)
@@ -1466,7 +1467,7 @@ C
               IF (SKIP_IT) THEN
               ELSE IF ( IW(JJ+LIELL) .GT. 0 ) THEN
                 VALPIV  = ONE/A( APOS1 )
-                RHSCOMP(IPOSINRHSCOMP+JJ-J1 , K ) = 
+                RHSINTR(IPOSINRHSINTR+JJ-J1 , K ) = 
      &                 WCB( IFR8 ) * VALPIV
                 APOS1 = APOS1 + int(LDAJ + 1,8)
               ELSE
@@ -1481,10 +1482,10 @@ C
                 A12 = -A12/DETPIV
                 POSWCB1 = IFR8
                 POSWCB2 = POSWCB1+1_8
-                RHSCOMP(IPOSINRHSCOMP+JJ-J1,K) =
+                RHSINTR(IPOSINRHSINTR+JJ-J1,K) =
      &                 WCB(POSWCB1)*A11
      &                 + WCB(POSWCB2)*A12
-                RHSCOMP(IPOSINRHSCOMP+JJ-J1+1,K) = 
+                RHSINTR(IPOSINRHSINTR+JJ-J1+1,K) = 
      &                   WCB(POSWCB1)*A12
      &                   + WCB(POSWCB2)*A22
               ENDIF  
@@ -1500,26 +1501,26 @@ C
      &  IW, IPOS, LIW, 
      &  A, LA, APOS,
      &  WCB, LWCB, LD_WCBPIV, 
-     &  RHSCOMP, LRHSCOMP, NRHS, 
-     &  POSINRHSCOMP_FWD, JBDEB, JBFIN, 
+     &  RHSINTR, LRHSINTR, NRHS, 
+     &  POSINRHSINTR_FWD, JBDEB, JBFIN, 
      &  MTYPE, KEEP, OOCWRITE_COMPATIBLE_WITH_BLR,
      &  IGNORE_K459
      &  )
       USE DMUMPS_OOC 
       INTEGER, INTENT(IN) :: MTYPE, INODE, N, NPIV, LIELL,
      &                       NELIM, NSLAVES
-      INTEGER, INTENT(IN) :: LRHSCOMP, NRHS, LIW, JBDEB, JBFIN
-      INTEGER, INTENT(IN) :: IW(LIW), IPOS, POSINRHSCOMP_FWD(N)
+      INTEGER, INTENT(IN) :: LRHSINTR, NRHS, LIW, JBDEB, JBFIN
+      INTEGER, INTENT(IN) :: IW(LIW), IPOS, POSINRHSINTR_FWD(N)
       INTEGER(8), INTENT(IN) :: LWCB, APOS, LA, PPIV_COURANT
       INTEGER, INTENT(IN) :: LD_WCBPIV
       INTEGER, INTENT(IN) :: KEEP(500)
       DOUBLE PRECISION, INTENT(IN) ::  WCB( LWCB )
       DOUBLE PRECISION, INTENT(IN) :: A( LA )
-      DOUBLE PRECISION, INTENT(INOUT) :: RHSCOMP(LRHSCOMP, NRHS)
+      DOUBLE PRECISION, INTENT(INOUT) :: RHSINTR(LRHSINTR, NRHS)
       LOGICAL, INTENT(IN) :: OOCWRITE_COMPATIBLE_WITH_BLR
       LOGICAL, INTENT(IN) :: IGNORE_K459
       INTEGER    :: TempNROW, J1, J3, PANEL_SIZE
-      INTEGER    :: IPOSINRHSCOMP, JJ, K, NBK, LDAJ, 
+      INTEGER    :: IPOSINRHSINTR, JJ, K, NBK, LDAJ, 
      &              LDAJ_ini, NBK_ini, LDAJ_FIRST_PANEL, NRHS_B
       INTEGER(8) :: IFR8 , APOS1, APOS2, APOSOFF, IFR_ini8, 
      &              POSWCB1, POSWCB2
@@ -1535,13 +1536,13 @@ C
          J1 = IPOS + LIELL + 1
          J3 = IPOS + LIELL + NPIV
       END IF
-      IPOSINRHSCOMP =  POSINRHSCOMP_FWD(IW(J1)) 
+      IPOSINRHSINTR =  POSINRHSINTR_FWD(IW(J1)) 
       IF ( KEEP(50) .eq. 0 ) THEN
 !$         OMP_FLAG=(NRHS_B.GE.KEEP(362).AND.NRHS_B*NPIV.GE.KEEP(363))
 !$OMP PARALLEL DO PRIVATE(IFR8) IF (OMP_FLAG)
            DO K=JBDEB,JBFIN
              IFR8 =  PPIV_COURANT + (K-JBDEB)*LD_WCBPIV
-             RHSCOMP(IPOSINRHSCOMP:IPOSINRHSCOMP+NPIV-1, K) =
+             RHSINTR(IPOSINRHSINTR:IPOSINRHSINTR+NPIV-1, K) =
      &            WCB(IFR8:IFR8+int(NPIV-1,8))
            ENDDO
 !$OMP END PARALLEL DO
@@ -1594,7 +1595,7 @@ C
             IFR8  = IFR8 + 1_8
             IF (IW(JJ+LIELL) .GT. 0) THEN
                VALPIV  = ONE/A( APOS1 )
-               RHSCOMP(IPOSINRHSCOMP+JJ-J1 , K ) = 
+               RHSINTR(IPOSINRHSINTR+JJ-J1 , K ) = 
      &                 WCB( IFR8 ) * VALPIV
               IF (KEEP(201).EQ.1.AND.OOCWRITE_COMPATIBLE_WITH_BLR)
      &        THEN
@@ -1627,10 +1628,10 @@ C
               A12 = -A12/DETPIV
               POSWCB1 = IFR8
               POSWCB2 = POSWCB1+1_8
-              RHSCOMP(IPOSINRHSCOMP+JJ-J1,K) =
+              RHSINTR(IPOSINRHSINTR+JJ-J1,K) =
      &               WCB(POSWCB1)*A11
      &               + WCB(POSWCB2)*A12
-              RHSCOMP(IPOSINRHSCOMP+JJ-J1+1,K) = 
+              RHSINTR(IPOSINRHSINTR+JJ-J1+1,K) = 
      &                 WCB(POSWCB1)*A12
      &                 + WCB(POSWCB2)*A22
               IF (KEEP(201).EQ.1.AND.OOCWRITE_COMPATIBLE_WITH_BLR)
@@ -1659,6 +1660,7 @@ C
         SEQUENCE
         DOUBLE PRECISION, dimension(:), pointer :: SCALING
         DOUBLE PRECISION, dimension(:), pointer :: SCALING_LOC
+        INTEGER, dimension(:), pointer :: SCALING_IND
       end type scaling_data_t
       type (scaling_data_t), INTENT(INOUT) :: scaling_data
       INTEGER, INTENT(IN) :: N, LILOC, COMM, MYID, MASTER, LP
diff -pruN 5.6.2-2.1/src/dsol_bwd.F 5.7.1-1/src/dsol_bwd.F
--- 5.6.2-2.1/src/dsol_bwd.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/dsol_bwd.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -13,7 +13,7 @@ C  https://cecill.info/licences/Licence_
 C
       SUBROUTINE DMUMPS_SOL_S(N, A, LA, IW, LIW, W, LWC,
      &    NRHS, 
-     &    RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &    RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &    PTRICB, PTRACB, IWCB, LIWW, W2, 
      &    NE_STEPS, STEP,
      &    FRERE, DAD, FILS, IPOOL, LPOOL, PTRIST, PTRFAC, 
@@ -59,8 +59,8 @@ C
       INTEGER BUFR(LBUFR)
       INTEGER ISTEP_TO_INIV2(KEEP(71)), 
      &        TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
-      INTEGER LRHSCOMP, POSINRHSCOMP_BWD(N)
-      DOUBLE PRECISION RHSCOMP(LRHSCOMP,NRHS)
+      INTEGER LRHSINTR, POSINRHSINTR_BWD(N)
+      DOUBLE PRECISION RHSINTR(LRHSINTR,NRHS)
       INTEGER(8), intent(in) :: LRHS_ROOT
       DOUBLE PRECISION RHS_ROOT( LRHS_ROOT )
       LOGICAL, INTENT(in) :: PRUN_BELOW
@@ -124,22 +124,26 @@ C
       ERROR_WAS_BROADCASTED = .FALSE.
       DO_MCAST2_TERMBWD = .FALSE.
       DO WHILE ( NBFINF .NE. 0 .OR. MYLEAF_LEFT .NE. 0 )
-        BLOQ = (  III .EQ. IIPOOL  )
-        CALL DMUMPS_BACKSLV_RECV_AND_TREAT( BLOQ, FLAG, BUFR, LBUFR,
-     &     LBUFR_BYTES, MYID, SLAVEF, COMM,
-     &     N, IWCB, LIWW, POSIWCB,
-     &     W, LWC, POSWCB,
-     &     IIPOOL, NBFINF, PTRICB, PTRACB, INFO,
-     &     IPOOL, LPOOL, PANEL_POS, LPANEL_POS,
-     &     STEP,  FRERE, FILS, PROCNODE_STEPS,
-     &     PLEFTW, KEEP,KEEP8, DKEEP,
-     &     PTRIST, PTRFAC, IW, LIW, A, LA, W2, MYLEAF_LEFT, 
-     &     NRHS, MTYPE, 
-     &     RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD
-     &     , PRUN_BELOW, TO_PROCESS, SIZE_TO_PROCESS
-     &     , FROM_PP
+        IF ( SLAVEF.EQ.1 ) THEN
+          FLAG = .FALSE.
+        ELSE
+          BLOQ = (  III .EQ. IIPOOL  )
+          CALL DMUMPS_BACKSLV_RECV_AND_TREAT( BLOQ, FLAG, BUFR, LBUFR,
+     &       LBUFR_BYTES, MYID, SLAVEF, COMM,
+     &       N, IWCB, LIWW, POSIWCB,
+     &       W, LWC, POSWCB,
+     &       IIPOOL, NBFINF, PTRICB, PTRACB, INFO,
+     &       IPOOL, LPOOL, PANEL_POS, LPANEL_POS,
+     &       STEP,  FRERE, FILS, PROCNODE_STEPS,
+     &       PLEFTW, KEEP,KEEP8, DKEEP,
+     &       PTRIST, PTRFAC, IW, LIW, A, LA, W2, MYLEAF_LEFT, 
+     &       NRHS, MTYPE, 
+     &       RHSINTR, LRHSINTR, POSINRHSINTR_BWD
+     &       , PRUN_BELOW, TO_PROCESS, SIZE_TO_PROCESS
+     &       , FROM_PP
      &     )
-        IF ( INFO(1) .LT. 0 ) GOTO 340 
+          IF ( INFO(1) .LT. 0 ) GOTO 340 
+        ENDIF
         IF ( .NOT. FLAG ) THEN
           IF (III .NE. IIPOOL) THEN
             INODE = IPOOL(IIPOOL-1)
@@ -161,7 +165,7 @@ C
      &        N, IPOOL, LPOOL, IIPOOL, NBFINF,
      &        A_PTR(1), LA_PTR, IW, LIW, W, LWC, NRHS,
      &        POSWCB, PLEFTW, POSIWCB,
-     &        RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &        RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &        PTRICB, PTRACB, IWCB, LIWW, W2, 
      &        NE_STEPS, STEP,
      &        FRERE, FILS, PTRIST, PTRFAC,
diff -pruN 5.6.2-2.1/src/dsol_bwd_aux.F 5.7.1-1/src/dsol_bwd_aux.F
--- 5.6.2-2.1/src/dsol_bwd_aux.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/dsol_bwd_aux.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -15,7 +15,7 @@ C
      &       N, IPOOL, LPOOL, IIPOOL, NBFINF,
      &       A, LA, IW, LIW, W, LWC, NRHS, 
      &       POSWCB, PLEFTW, POSIWCB,
-     &    RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &    RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &    PTRICB, PTRACB, IWCB, LIWW, W2, 
      &    NE_STEPS, STEP,
      &    FRERE, FILS, PTRIST, PTRFAC, 
@@ -62,8 +62,8 @@ C
       INTEGER BUFR(LBUFR)
       INTEGER ISTEP_TO_INIV2(KEEP(71)), 
      &        TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
-      INTEGER LRHSCOMP, POSINRHSCOMP_BWD(N)
-      DOUBLE PRECISION RHSCOMP(LRHSCOMP,NRHS)
+      INTEGER LRHSINTR, POSINRHSINTR_BWD(N)
+      DOUBLE PRECISION RHSINTR(LRHSINTR,NRHS)
       INTEGER(8), intent(in) :: LRHS_ROOT
       DOUBLE PRECISION RHS_ROOT( LRHS_ROOT )
       LOGICAL, INTENT( IN ) :: PRUN_BELOW
@@ -99,7 +99,7 @@ C
       INTEGER :: PROCDEST, DEST
       INTEGER(8) :: PTWCB, PPIV_COURANT
       INTEGER :: Offset, EffectiveSize, ISLAVE, FirstIndex
-      INTEGER :: POSINDICES, IPOSINRHSCOMP, IPOSINRHSCOMP_PANEL
+      INTEGER :: POSINDICES, IPOSINRHSINTR, IPOSINRHSINTR_PANEL
       INTEGER(8) :: APOS, IST
       INTEGER(8) :: IFR8
       INTEGER(8) :: APOSDEB, NBENTRIES_ALLPANELS
@@ -139,9 +139,9 @@ C
             J2   = IPOS + NPIV
          END IF
          IFR8  = 0_8
-         IPOSINRHSCOMP = POSINRHSCOMP_BWD(IW(J1))  
-         CALL DMUMPS_SOL_CPY_FS2RHSCOMP(JBDEB, JBFIN, J2-J1+1,
-     &          KEEP, RHSCOMP, NRHS, LRHSCOMP, IPOSINRHSCOMP,
+         IPOSINRHSINTR = POSINRHSINTR_BWD(IW(J1))  
+         CALL DMUMPS_SOL_CPY_FS2RHSINTR(JBDEB, JBFIN, J2-J1+1,
+     &          KEEP, RHSINTR, NRHS, LRHSINTR, IPOSINRHSINTR,
      &          RHS_ROOT(1+NPIV*(JBDEB-1)), NPIV, 1)
         IN = INODE
  270    IN = FILS(IN)
@@ -208,8 +208,8 @@ C
      &                 LONG, LONG, IW( J1 ),
      &                 RHS_ROOT( 1+NPIV*(JBDEB-1) ), 
      &                 JBDEB, JBFIN,
-     &                 RHSCOMP(1, 1), NRHS, LRHSCOMP,
-     &                 IPOSINRHSCOMP, NPIV,
+     &                 RHSINTR(1, 1), NRHS, LRHSINTR,
+     &                 IPOSINRHSINTR, NPIV,
      &                 KEEP, PROCDEST,
      &                 NOEUD, COMM, IERR )
                 IF ( IERR .EQ. -1 ) THEN
@@ -226,7 +226,7 @@ C
      &                  PTRIST, PTRFAC, IW, LIW, A, LA, W2,
      &                  MYLEAF_LEFT, 
      &                  NRHS, MTYPE,
-     &                  RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &                  RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &                  PRUN_BELOW, TO_PROCESS, SIZE_TO_PROCESS
      &                  , FROM_PP
      &                  )
@@ -347,9 +347,9 @@ C
            END IF
            IFR8 = PTRACB(STEP( INODE )) - 1_8
           CALL DMUMPS_SOL_BWD_GTHR( JBDEB, JBFIN, J1, J2,
-     &       RHSCOMP, NRHS, LRHSCOMP,
+     &       RHSINTR, NRHS, LRHSINTR,
      &       W(PTRACB(STEP(INODE))), NCB, 1,
-     &       IW, LIW, KEEP, N, POSINRHSCOMP_BWD )
+     &       IW, LIW, KEEP, N, POSINRHSINTR_BWD )
              IFR8 = IFR8 + int(J2-KEEP(253)-J1+1,8)
            IF (KEEP(252).NE.0) THEN
              DO JJ = J2-KEEP(253)+1, J2
@@ -392,7 +392,7 @@ C
      &              PROCNODE_STEPS, PLEFTW, KEEP,KEEP8, DKEEP,
      &              PTRIST, PTRFAC, IW, LIW, A, LA, W2, MYLEAF_LEFT,
      &              NRHS, MTYPE,
-     &              RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &              RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &              PRUN_BELOW , TO_PROCESS, SIZE_TO_PROCESS
      &               , FROM_PP
      &               )
@@ -516,15 +516,15 @@ C
         PTWCB = PTRACB(STEP( INODE ))
       ENDIF
       IF (J2.GE.J1) THEN
-        IPOSINRHSCOMP = POSINRHSCOMP_BWD(IW(J1)) 
+        IPOSINRHSINTR = POSINRHSINTR_BWD(IW(J1)) 
       ELSE
-        IPOSINRHSCOMP = -99999
+        IPOSINRHSINTR = -99999
       ENDIF
       IF (J2.GE.J1) THEN
         DO K=JBDEB, JBFIN
             IF (KEEP(252).NE.0) THEN
               DO JJ = J1, J2
-                RHSCOMP(IPOSINRHSCOMP+JJ-J1,K) = ZERO
+                RHSINTR(IPOSINRHSINTR+JJ-J1,K) = ZERO
               ENDDO
             ENDIF
         END DO
@@ -539,9 +539,9 @@ C
           J2 = IPOS + LIELL
         END IF
         CALL DMUMPS_SOL_BWD_GTHR( JBDEB, JBFIN, J1, J2,
-     &       RHSCOMP, NRHS, LRHSCOMP,
+     &       RHSINTR, NRHS, LRHSINTR,
      &       W(PTWCB), LIELL, NPIV+1,
-     &       IW, LIW, KEEP, N, POSINRHSCOMP_BWD )
+     &       IW, LIW, KEEP, N, POSINRHSINTR_BWD )
           IFR8 = IFR8 + int(J2-KEEP(253)-J1+1,8)
         IF (KEEP(252).NE.0) THEN
           DO JJ = J2-KEEP(253)+1, J2
@@ -601,7 +601,7 @@ C
             ENDIF
             LDAJ    = LIELL-BEG_PANEL+1 
             APOSDEB = APOSDEB - int(NBJ,8)*int(LDAJ,8)
-            IPOSINRHSCOMP_PANEL = IPOSINRHSCOMP + BEG_PANEL - 1
+            IPOSINRHSINTR_PANEL = IPOSINRHSINTR + BEG_PANEL - 1
             NCB_PANEL   = LDAJ - NBJ
             IF (KEEP(50).NE.1.AND.MUST_BE_PERMUTED) THEN
               CALL DMUMPS_GET_OOC_PERM_PTR(TYPEF, TMP_NBPANELS,
@@ -623,24 +623,24 @@ C
                   IF (NCB_PANEL - NCB.NE. 0) THEN
                     CALL dgemv( 'T', NCB_PANEL-NCB, NBJ, ALPHA, 
      &              A( APOSDEB + int(NBJ,8) ), LDAJ,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL+NBJ,JBDEB),
+     &              RHSINTR(IPOSINRHSINTR_PANEL+NBJ,JBDEB),
      &              1, ONE,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), 1 )
+     &              RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), 1 )
                   ENDIF
                   IF (NCB .NE. 0) THEN
                     CALL dgemv( 'T', NCB, NBJ, ALPHA,
      &              A( APOSDEB + int(LDAJ-NCB,8) ), LDAJ,
      &              W( PTWCB  + int(NPIV,8) ),
      &              1, ONE,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), 1 )
+     &              RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), 1 )
                   ENDIF
               ENDIF
               IF (MTYPE.NE.1) THEN
                 CALL dtrsv('L','T','U', NBJ, A(APOSDEB), LDAJ,
-     &            RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), 1)
+     &            RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), 1)
               ELSE
                 CALL dtrsv('L','T','N', NBJ, A(APOSDEB), LDAJ,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), 1)
+     &              RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), 1)
               ENDIF
             ELSE
 #endif
@@ -649,24 +649,24 @@ C
                   CALL dgemm( 'T', 'N', NBJ, NRHS_B,
      &                                         NCB_PANEL-NCB, ALPHA,
      &              A(APOSDEB +int(NBJ,8)), LDAJ,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL+NBJ,JBDEB), LRHSCOMP,
-     &              ONE, RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), LRHSCOMP)
+     &              RHSINTR(IPOSINRHSINTR_PANEL+NBJ,JBDEB), LRHSINTR,
+     &              ONE, RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), LRHSINTR)
                   ENDIF
                   IF (NCB .NE. 0) THEN
                   CALL dgemm( 'T', 'N', NBJ, NRHS_B, NCB, ALPHA,
      &              A(APOSDEB +int(LDAJ-NCB,8)), LDAJ,
      &              W( PTWCB+int(NPIV,8) ), LIELL,
-     &              ONE, RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB),LRHSCOMP)
+     &              ONE, RHSINTR(IPOSINRHSINTR_PANEL,JBDEB),LRHSINTR)
                   ENDIF
               ENDIF
               IF (MTYPE.NE.1) THEN
                 CALL dtrsm('L','L','T','U',NBJ, NRHS_B, ONE,
      &          A(APOSDEB), 
-     &          LDAJ, RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), LRHSCOMP)
+     &          LDAJ, RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), LRHSINTR)
               ELSE
                 CALL dtrsm('L','L','T','N',NBJ, NRHS_B, ONE,
      &          A(APOSDEB),
-     &          LDAJ, RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), LRHSCOMP)
+     &          LDAJ, RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), LRHSINTR)
               ENDIF
 #if defined(MUMPS_USE_BLAS2)
             ENDIF
@@ -680,8 +680,8 @@ C
           CALL DMUMPS_SOL_BWD_LR_SU (
      &           INODE, IWHDLR, NPIV, NSLAVES, 
      &           LIELL, W, LWC, NRHS_B, PTWCB,
-     &           RHSCOMP, LRHSCOMP, NRHS,
-     &           IPOSINRHSCOMP, JBDEB, 
+     &           RHSINTR, LRHSINTR, NRHS,
+     &           IPOSINRHSINTR, JBDEB, 
      &           MTYPE, KEEP, KEEP8,
      &           INFO(1), INFO(2) )
           IF (INFO(1).LT.0) THEN
@@ -697,13 +697,13 @@ C
                 CALL dgemv( 'T', NCB, NPIV, ALPHA, A(IST), LIELL,
      &                 W(PTWCB+int(NPIV,8)), 1,
      &                 ONE,
-     &                 RHSCOMP(IPOSINRHSCOMP,JBDEB), 1 )
+     &                 RHSINTR(IPOSINRHSINTR,JBDEB), 1 )
               ELSE
 #endif
                 CALL dgemm('T','N', NPIV, NRHS_B, NCB, ALPHA,
      &                 A(IST),
      &                 LIELL, W(PTWCB+int(NPIV,8)), LIELL, ONE,
-     &                 RHSCOMP(IPOSINRHSCOMP,JBDEB), LRHSCOMP)
+     &                 RHSINTR(IPOSINRHSINTR,JBDEB), LRHSINTR)
 #if defined(MUMPS_USE_BLAS2)
               ENDIF
 #endif
@@ -723,13 +723,13 @@ C
                  CALL dgemv( 'N', NPIV, NCB, ALPHA, A( IST ), NPIV,
      &                W( PTWCB + int(NPIV,8) ),
      &                1, ONE,
-     &                RHSCOMP(IPOSINRHSCOMP,JBDEB), 1 )
+     &                RHSINTR(IPOSINRHSINTR,JBDEB), 1 )
               ELSE
 #endif
                  CALL dgemm( 'N', 'N', NPIV, NRHS_B, NCB, ALPHA,
      &                A(IST),
      &                NPIV, W(PTWCB+int(NPIV,8)), LIELL,
-     &                ONE, RHSCOMP(IPOSINRHSCOMP,JBDEB), LRHSCOMP)
+     &                ONE, RHSINTR(IPOSINRHSINTR,JBDEB), LRHSINTR)
 #if defined(MUMPS_USE_BLAS2)
               END IF
 #endif
@@ -748,17 +748,17 @@ C
               ENDIF
             ENDIF
           END IF 
-          PPIV_COURANT = int(JBDEB-1,8)*int(LRHSCOMP,8)
-     &                 + int(IPOSINRHSCOMP,8)
+          PPIV_COURANT = int(JBDEB-1,8)*int(LRHSINTR,8)
+     &                 + int(IPOSINRHSINTR,8)
           IF (KEEP(459).GT.1 .AND. KEEP(50).NE.0) THEN
           CALL DMUMPS_SOLVE_BWD_PANELS( A, LA, APOS,
      &      NPIV, IW(IPOS+1+LIELL),
-     &      NRHS_B, RHSCOMP(1,1), KEEP8(25), LRHSCOMP, PPIV_COURANT, 
+     &      NRHS_B, RHSINTR(1,1), KEEP8(25), LRHSINTR, PPIV_COURANT, 
      &      MTYPE, KEEP )
           ELSE
           CALL DMUMPS_SOLVE_BWD_TRSOLVE( A, LA, APOS,
      &      NPIV, LDAJ,
-     &      NRHS_B, RHSCOMP(1,1), KEEP8(25), LRHSCOMP, PPIV_COURANT, 
+     &      NRHS_B, RHSINTR(1,1), KEEP8(25), LRHSINTR, PPIV_COURANT, 
      &      MTYPE, KEEP )
           ENDIF
         ENDIF  
@@ -768,7 +768,7 @@ C
       ELSE
         J1 = IPOS + 1
       END IF
-      IPOSINRHSCOMP =  POSINRHSCOMP_BWD(IW(J1)) 
+      IPOSINRHSINTR =  POSINRHSINTR_BWD(IW(J1)) 
   160 CONTINUE
       IF (KEEP(201).GT.0.AND.OOCWRITE_COMPATIBLE_WITH_BLR) THEN
          CALL DMUMPS_FREE_FACTORS_FOR_SOLVE(INODE,PTRFAC,KEEP(28),
@@ -874,8 +874,8 @@ C
      &          LIELL, LIELL - KEEP(253),
      &          IW( POSINDICES ),
      &          W( PTRACB(STEP(INODE)) ), JBDEB, JBFIN,
-     &          RHSCOMP(1, 1), NRHS, LRHSCOMP,
-     &          IPOSINRHSCOMP, NPIV,
+     &          RHSINTR(1, 1), NRHS, LRHSINTR,
+     &          IPOSINRHSINTR, NPIV,
      &          KEEP, PROCDEST, NOEUD, COMM, IERR )
               IF ( IERR .EQ. -1 ) THEN
                 CALL DMUMPS_BACKSLV_RECV_AND_TREAT(
@@ -890,7 +890,7 @@ C
      &          PLEFTW, KEEP, KEEP8, DKEEP,
      &          PTRIST, PTRFAC, IW, LIW, A, LA, W2, MYLEAF_LEFT,
      &          NRHS, MTYPE, 
-     &          RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &          RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &          PRUN_BELOW, TO_PROCESS, SIZE_TO_PROCESS
      &            , FROM_PP
      &            )
@@ -958,7 +958,7 @@ C
      &     PLEFTW, KEEP, KEEP8, DKEEP,
      &     PTRIST, PTRFAC, IW, LIW, A, LA, W2, MYLEAF_LEFT, 
      &     NRHS, MTYPE,
-     &     RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &     RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &     PRUN_BELOW, TO_PROCESS, SIZE_TO_PROCESS
      &     , FROM_PP
      &    )
@@ -990,8 +990,8 @@ C
       DOUBLE PRECISION A( LA ), W2( KEEP(133) )
       INTEGER NRHS
       INTEGER MYLEAF_LEFT, MTYPE
-      INTEGER LRHSCOMP, POSINRHSCOMP_BWD(N)
-      DOUBLE PRECISION RHSCOMP(LRHSCOMP,NRHS)
+      INTEGER LRHSINTR, POSINRHSINTR_BWD(N)
+      DOUBLE PRECISION RHSINTR(LRHSINTR,NRHS)
       LOGICAL, INTENT(IN) :: PRUN_BELOW
       INTEGER SIZE_TO_PROCESS
       LOGICAL TO_PROCESS(SIZE_TO_PROCESS)
@@ -1035,7 +1035,7 @@ C
      &                KEEP, KEEP8, DKEEP,
      &                PTRIST, PTRFAC, IW, LIW, A, LA, W2, MYLEAF_LEFT, 
      &                NRHS, MTYPE, 
-     &                RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &                RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &               PRUN_BELOW, TO_PROCESS, SIZE_TO_PROCESS
      &               , FROM_PP
      &          )
@@ -1055,7 +1055,7 @@ C
      &                KEEP, KEEP8, DKEEP,
      &                PTRIST, PTRFAC, IW, LIW, A, LA, W2, MYLEAF_LEFT, 
      &                NRHS, MTYPE, 
-     &                RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &                RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &                PRUN_BELOW, TO_PROCESS, SIZE_TO_PROCESS
      &               , FROM_PP
      &           )
@@ -1091,8 +1091,8 @@ C
       DOUBLE PRECISION A( LA ), W2( KEEP(133) )
       INTEGER NRHS
       INTEGER MYLEAF_LEFT, MTYPE
-      INTEGER LRHSCOMP, POSINRHSCOMP_BWD(N)
-      DOUBLE PRECISION RHSCOMP(LRHSCOMP,NRHS)
+      INTEGER LRHSINTR, POSINRHSINTR_BWD(N)
+      DOUBLE PRECISION RHSINTR(LRHSINTR,NRHS)
       LOGICAL, INTENT(IN) :: PRUN_BELOW
       INTEGER  SIZE_TO_PROCESS
       LOGICAL TO_PROCESS(SIZE_TO_PROCESS), NO_CHILDREN
@@ -1106,7 +1106,7 @@ C
       INTEGER(8) :: IFR8
       INTEGER I, JJ, IN, PROCDEST, J1, J2, LDA
       INTEGER NSLAVES, NELIM, J, POSINDICES, INODEPOS,
-     &     IPOSINRHSCOMP, IPOSINRHSCOMP_PANEL
+     &     IPOSINRHSINTR, IPOSINRHSINTR_PANEL
       INTEGER JBDEB, JBFIN, NRHS_B, allocok
       INTEGER(8) :: P_UPDATE, P_SOL_MAS         
       INTEGER :: IWHDLR, MTYPE_SLAVE, LDA_SLAVE 
@@ -1186,11 +1186,11 @@ C
      &           W(POSWCB + 1), LONG, 
      &           MPI_DOUBLE_PRECISION, COMM, IERR)
               DO JJ=0, LONG-1
-                IPOSINRHSCOMP = abs( POSINRHSCOMP_BWD( IWCB(
+                IPOSINRHSINTR = abs( POSINRHSINTR_BWD( IWCB(
      &                                    POSIWCB+1+JJ ) ) )
-                IF ( (IPOSINRHSCOMP.EQ.0) .OR.
-     &            ( IPOSINRHSCOMP.GT.N ) ) CYCLE  
-                RHSCOMP(IPOSINRHSCOMP,K) = W(POSWCB+1+JJ)
+                IF ( (IPOSINRHSINTR.EQ.0) .OR.
+     &            ( IPOSINRHSINTR.GT.N ) ) CYCLE  
+                RHSINTR(IPOSINRHSINTR,K) = W(POSWCB+1+JJ)
               ENDDO
             ENDDO
             POSIWCB = POSIWCB + LONG
@@ -1342,7 +1342,7 @@ C
      &     KEEP, KEEP8, DKEEP,
      &     PTRIST, PTRFAC, IW, LIW, A, LA, W2, MYLEAF_LEFT,
      &     NRHS, MTYPE,
-     &     RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &     RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &     PRUN_BELOW, TO_PROCESS, SIZE_TO_PROCESS
      &      , FROM_PP
      &      )
@@ -1396,7 +1396,7 @@ C
         J1 = IPOS + 1
         J2 = IPOS + NPIV
       ENDIF
-        IPOSINRHSCOMP =  POSINRHSCOMP_BWD(IW(J1)) 
+        IPOSINRHSINTR =  POSINRHSINTR_BWD(IW(J1)) 
         DO K=JBDEB, JBFIN
           CALL MPI_UNPACK( BUFR, LBUFR_BYTES, POSITION,
      &                     W2, NPIV, MPI_DOUBLE_PRECISION,
@@ -1406,13 +1406,13 @@ C
      &         (IW(PTRIST(STEP(INODE))+XXS).EQ.C_FINI+NSLAVES) 
      &       ) THEN
           DO JJ = J1,J2   
-            RHSCOMP(IPOSINRHSCOMP+JJ-J1,K) = W2(I)
+            RHSINTR(IPOSINRHSINTR+JJ-J1,K) = W2(I)
             I = I+1
           ENDDO
          ELSE
           DO JJ = J1,J2   
-            RHSCOMP(IPOSINRHSCOMP+JJ-J1,K) = 
-     &      RHSCOMP(IPOSINRHSCOMP+JJ-J1,K) + W2(I)
+            RHSINTR(IPOSINRHSINTR+JJ-J1,K) = 
+     &      RHSINTR(IPOSINRHSINTR+JJ-J1,K) + W2(I)
             I = I+1
           ENDDO
          ENDIF
@@ -1478,7 +1478,7 @@ C
            POSINDICES = IPOS + 1
         END IF
         PTWCB = PTRACB(STEP( INODE ))
-        IPOSINRHSCOMP =  POSINRHSCOMP_BWD(IW(J1)) 
+        IPOSINRHSINTR =  POSINRHSINTR_BWD(IW(J1)) 
         IFR8 = PTRACB(STEP( INODE ))
       IFR8   = PTWCB + int(NPIV - 1,8)
         IF ( MTYPE .EQ. 1 .AND. KEEP(50).EQ.0 ) THEN
@@ -1489,9 +1489,9 @@ C
           J2 = IPOS + LIELL
         END IF
         CALL DMUMPS_SOL_BWD_GTHR( JBDEB, JBFIN, J1, J2,
-     &       RHSCOMP, NRHS, LRHSCOMP,
+     &       RHSINTR, NRHS, LRHSINTR,
      &       W(PTWCB), LIELL, NPIV+1,
-     &       IW, LIW, KEEP, N, POSINRHSCOMP_BWD )
+     &       IW, LIW, KEEP, N, POSINRHSINTR_BWD )
           IFR8 = IFR8 + int(J2-KEEP(253)-J1+1,8)
       IF ( KEEP(201).EQ.1 .AND. OOCWRITE_COMPATIBLE_WITH_BLR .AND.
      &    (( NELIM .GT. 0 ).OR. (MTYPE.NE.1 )))  THEN
@@ -1536,7 +1536,7 @@ C
             LDAJ    = NROW_L-BEG_PANEL+1 
             APOSDEB = APOSDEB - int(NBJ,8)*int(LDAJ,8)
             PTWCB   = PTRACB(STEP(INODE))
-            IPOSINRHSCOMP_PANEL = IPOSINRHSCOMP + BEG_PANEL - 1
+            IPOSINRHSINTR_PANEL = IPOSINRHSINTR + BEG_PANEL - 1
             NCB_PANEL   = LDAJ - NBJ
             NCB     = NROW_L - NPIV
             IF (KEEP(50).NE.1 .AND.MUST_BE_PERMUTED) THEN
@@ -1555,24 +1555,24 @@ C
                   IF (NCB_PANEL - NCB.NE. 0) THEN
                     CALL dgemv( 'T', NCB_PANEL-NCB, NBJ, ALPHA, 
      &              A( APOSDEB + int(NBJ,8) ), LDAJ,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL+NBJ,JBDEB),
+     &              RHSINTR(IPOSINRHSINTR_PANEL+NBJ,JBDEB),
      &              1, ONE,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), 1 )
+     &              RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), 1 )
                   ENDIF
                   IF (NCB .NE. 0) THEN
                     CALL dgemv( 'T', NCB, NBJ, ALPHA,
      &              A( APOSDEB + int(LDAJ-NCB,8) ), LDAJ,
      &              W( PTWCB  + int(NPIV,8) ),
      &              1, ONE,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), 1 )
+     &              RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), 1 )
                   ENDIF
               ENDIF
               IF (MTYPE.NE.1) THEN
                 CALL dtrsv('L','T','U', NBJ, A(APOSDEB), LDAJ,
-     &            RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), 1)
+     &            RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), 1)
               ELSE
                 CALL dtrsv('L','T','N', NBJ, A(APOSDEB), LDAJ,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), 1)
+     &              RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), 1)
               ENDIF
             ELSE
 #endif
@@ -1581,24 +1581,24 @@ C
                   CALL dgemm( 'T', 'N', NBJ, NRHS_B,
      &                                         NCB_PANEL-NCB, ALPHA,
      &              A(APOSDEB +int(NBJ,8)), LDAJ,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL+NBJ,JBDEB), LRHSCOMP,
-     &              ONE, RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), LRHSCOMP)
+     &              RHSINTR(IPOSINRHSINTR_PANEL+NBJ,JBDEB), LRHSINTR,
+     &              ONE, RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), LRHSINTR)
                   ENDIF
                   IF (NCB .NE. 0) THEN
                   CALL dgemm( 'T', 'N', NBJ, NRHS_B, NCB, ALPHA,
      &              A(APOSDEB +int(LDAJ-NCB,8)), LDAJ,
      &              W( PTWCB+int(NPIV,8) ), LIELL,
-     &              ONE, RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB),LRHSCOMP)
+     &              ONE, RHSINTR(IPOSINRHSINTR_PANEL,JBDEB),LRHSINTR)
                   ENDIF
               ENDIF
               IF (MTYPE.NE.1) THEN
                 CALL dtrsm('L','L','T','U',NBJ, NRHS_B, ONE,
      &          A(APOSDEB), 
-     &          LDAJ, RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), LRHSCOMP)
+     &          LDAJ, RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), LRHSINTR)
               ELSE
                 CALL dtrsm('L','L','T','N',NBJ, NRHS_B, ONE,
      &          A(APOSDEB),
-     &          LDAJ, RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), LRHSCOMP)
+     &          LDAJ, RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), LRHSINTR)
               ENDIF
 #if defined(MUMPS_USE_BLAS2)
             ENDIF
@@ -1613,8 +1613,8 @@ C
           CALL DMUMPS_SOL_BWD_LR_SU (
      &           INODE, IWHDLR, NPIV, NSLAVES,
      &           LIELL, W, LWC, NRHS_B, PTRACB(STEP(INODE)), 
-     &           RHSCOMP, LRHSCOMP, NRHS,
-     &           IPOSINRHSCOMP, JBDEB, 
+     &           RHSINTR, LRHSINTR, NRHS,
+     &           IPOSINRHSINTR, JBDEB, 
      &           MTYPE, KEEP, KEEP8,
      &           INFO(1), INFO(2) )
         ELSE
@@ -1634,27 +1634,27 @@ C
                  CALL dgemv( 'N', NPIV, NELIM, ALPHA, A( IST ), NPIV,
      &                 W( NPIV + PTRACB(STEP(INODE)) ),
      &                 1, ONE,
-     &                 RHSCOMP(IPOSINRHSCOMP,JBDEB), 1 )
+     &                 RHSINTR(IPOSINRHSINTR,JBDEB), 1 )
               ELSE
 #endif
                  CALL dgemm( 'N', 'N', NPIV, NRHS_B, NELIM, ALPHA,
      &                A(IST), NPIV, W(NPIV+PTRACB(STEP(INODE))), LIELL,
-     &                ONE, RHSCOMP(IPOSINRHSCOMP,JBDEB), LRHSCOMP)
+     &                ONE, RHSINTR(IPOSINRHSINTR,JBDEB), LRHSINTR)
 #if defined(MUMPS_USE_BLAS2)
               END IF
 #endif
           ENDIF 
-          PPIV_COURANT = int(JBDEB-1,8)*int(LRHSCOMP,8)
-     &                 + int(IPOSINRHSCOMP,8)
+          PPIV_COURANT = int(JBDEB-1,8)*int(LRHSINTR,8)
+     &                 + int(IPOSINRHSINTR,8)
           IF (KEEP(459).GT.1 .AND. KEEP(50).NE.0) THEN
           CALL DMUMPS_SOLVE_BWD_PANELS( A, LA, APOS,
      &      NPIV, IW(IPOS+1+LIELL),
-     &      NRHS_B, RHSCOMP(1,1), KEEP8(25), LRHSCOMP, PPIV_COURANT, 
+     &      NRHS_B, RHSINTR(1,1), KEEP8(25), LRHSINTR, PPIV_COURANT, 
      &      MTYPE, KEEP )
           ELSE
           CALL DMUMPS_SOLVE_BWD_TRSOLVE( A, LA, APOS,
      &      NPIV, LDA,
-     &      NRHS_B, RHSCOMP(1,1), KEEP8(25), LRHSCOMP, PPIV_COURANT, 
+     &      NRHS_B, RHSINTR(1,1), KEEP8(25), LRHSINTR, PPIV_COURANT, 
      &      MTYPE, KEEP )
           ENDIF
        ENDIF
@@ -1669,7 +1669,7 @@ C
            ENDIF
           ENDIF
           IPOS =   PTRIST(STEP(INODE)) +  KEEP(IXSZ) + 6 + NSLAVES
-          IPOSINRHSCOMP     = POSINRHSCOMP_BWD(IW(IPOS))
+          IPOSINRHSINTR     = POSINRHSINTR_BWD(IW(IPOS))
           IN = INODE
   170     IN = FILS(IN)
           IF (IN .GT. 0) GOTO 170
@@ -1730,8 +1730,8 @@ C
      &          LIELL, LIELL - KEEP(253),
      &          IW( POSINDICES ),
      &          W( PTRACB(STEP(INODE)) ), JBDEB, JBFIN,
-     &          RHSCOMP(1, 1), NRHS, LRHSCOMP,
-     &          IPOSINRHSCOMP, NPIV,
+     &          RHSINTR(1, 1), NRHS, LRHSINTR,
+     &          IPOSINRHSINTR, NPIV,
      &          KEEP, PROCDEST, NOEUD, COMM, IERR )
               IF ( IERR .EQ. -1 ) THEN
                 CALL DMUMPS_BACKSLV_RECV_AND_TREAT(
@@ -1746,7 +1746,7 @@ C
      &          PLEFTW, KEEP, KEEP8, DKEEP,
      &          PTRIST, PTRFAC, IW, LIW, A, LA, W2, MYLEAF_LEFT,
      &          NRHS, MTYPE, 
-     &          RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &          RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &          PRUN_BELOW, TO_PROCESS, SIZE_TO_PROCESS
      &            , FROM_PP
      &            )
diff -pruN 5.6.2-2.1/src/dsol_c.F 5.7.1-1/src/dsol_c.F
--- 5.6.2-2.1/src/dsol_c.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/dsol_c.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -18,11 +18,16 @@ C
      & COMM_NODES, MYID, MYID_NODES, BUFR, LBUFR, LBUFR_BYTES,
      & ISTEP_TO_INIV2, TAB_POS_IN_PERE, IBEG_ROOT_DEF, IEND_ROOT_DEF,
      & IROOT_DEF_RHS_COL1, RHS_ROOT, LRHS_ROOT, SIZE_ROOT, MASTER_ROOT,
-     & RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD, POSINRHSCOMP_BWD,
+     & RHSINTR, LRHSINTR, POSINRHSINTR_FWD, POSINRHSINTR_BWD,
+     &           Lnodes_FWD, Lnodes_BWD,
+     &           nodes_FWD, nodes_BWD,
      & NZ_RHS, NBCOL_INBLOC, NRHS_ORIG, JBEG_RHS, Step2node, LStep2node,
      & IRHS_SPARSE, IRHS_PTR, SIZE_PERM_RHS, PERM_RHS,
-     & SIZE_UNS_PERM_INV, UNS_PERM_INV, NB_FS_IN_RHSCOMP_F,
-     & NB_FS_IN_RHSCOMP_TOT, DO_NBSPARSE , RHS_BOUNDS, LRHS_BOUNDS
+     & SIZE_UNS_PERM_INV, UNS_PERM_INV, NB_FS_IN_RHSINTR_F,
+     & NB_FS_IN_RHSINTR_TOT, DO_NBSPARSE , RHS_BOUNDS, LRHS_BOUNDS
+#if defined(STAT_ES_SOLVE)
+     & , IPTR_WORKING, SIZE_IPTR_WORKING, WORKING, SIZE_WORKING
+#endif
      &  ,IPOOL_B_L0_OMP, LPOOL_B_L0_OMP, IPOOL_A_L0_OMP, LPOOL_A_L0_OMP,
      &  L_VIRT_L0_OMP, VIRT_L0_OMP, L_PHYS_L0_OMP, PHYS_L0_OMP,
      &  PERM_L0_OMP, PTR_LEAFS_L0_OMP, L0_OMP_MAPPING, LL0_OMP_MAPPING,
@@ -51,22 +56,26 @@ C
       INTEGER(8) ::  PTRFAC(KEEP(28))
       INTEGER    ::  LIWK_PTRACB
       INTEGER(8) ::  PTRACB(LIWK_PTRACB)
-      INTEGER NRHS, LRHSCOMP, NB_FS_IN_RHSCOMP_F, NB_FS_IN_RHSCOMP_TOT
+      INTEGER NRHS, LRHSINTR, NB_FS_IN_RHSINTR_F, NB_FS_IN_RHSINTR_TOT
       DOUBLE PRECISION    A(LA), W(LWC), 
      &        W2(KEEP(133))
-      DOUBLE PRECISION ::  RHSCOMP(LRHSCOMP,NRHS)
+      DOUBLE PRECISION ::  RHSINTR(LRHSINTR,NRHS)
       INTEGER SLAVEF, COMM_NODES, MYID, MYID_NODES
-      INTEGER PROCNODE_STEPS(KEEP(28)), POSINRHSCOMP_FWD(N), 
-     &        POSINRHSCOMP_BWD(N)
+      INTEGER PROCNODE_STEPS(KEEP(28)), POSINRHSINTR_FWD(N), 
+     &        POSINRHSINTR_BWD(N)
       INTEGER LBUFR, LBUFR_BYTES
       INTEGER BUFR(LBUFR)
       INTEGER ISTEP_TO_INIV2(KEEP(71)), 
      &        TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
       INTEGER IBEG_ROOT_DEF, IEND_ROOT_DEF, IROOT_DEF_RHS_COL1
+      INTEGER NRHS_LOC
       INTEGER SIZE_ROOT, MASTER_ROOT
       INTEGER(8) :: LRHS_ROOT
       DOUBLE PRECISION RHS_ROOT(LRHS_ROOT)
       LOGICAL, intent(in) :: FROM_PP 
+      INTEGER, intent(in) :: Lnodes_FWD, Lnodes_BWD
+      INTEGER, intent(in) :: nodes_FWD(max(1,Lnodes_FWD)), 
+     &                       nodes_BWD(max(1,Lnodes_BWD))
       INTEGER, intent(in)      :: NZ_RHS, NBCOL_INBLOC, NRHS_ORIG
       INTEGER, intent(in)      :: SIZE_UNS_PERM_INV 
       INTEGER, intent(in)      :: SIZE_PERM_RHS 
@@ -80,6 +89,11 @@ C
       LOGICAL, intent(in)  :: DO_NBSPARSE  
       INTEGER, intent(in)     :: LRHS_BOUNDS
       INTEGER, intent(inout)  :: RHS_BOUNDS (LRHS_BOUNDS) 
+#if defined(STAT_ES_SOLVE)
+       INTEGER, INTENT(IN) :: SIZE_WORKING, SIZE_IPTR_WORKING,
+     &                        IPTR_WORKING(SIZE_IPTR_WORKING),
+     &                        WORKING(SIZE_WORKING)
+#endif
       INTEGER, INTENT (IN) :: LPOOL_B_L0_OMP
       INTEGER, INTENT (IN) :: IPOOL_B_L0_OMP( LPOOL_B_L0_OMP )
       INTEGER, INTENT (IN) :: LPOOL_A_L0_OMP
@@ -103,6 +117,7 @@ C
       INTEGER NSTK_S,IPOOL,IPANEL_POS,PTRICB
       INTEGER MTYPE_LOC
       INTEGER MODE_RHS_BOUNDS 
+      INTEGER IPT_RHS_ROOT_LOC
       INTEGER IERR
       INTEGER(8) :: IAPOS
       INTEGER       IOLDPS,
@@ -116,26 +131,28 @@ C
       LOGICAL I_WORKED_ON_ROOT, SPECIAL_ROOT_REACHED
       INTEGER IROOT
       LOGICAL DOROOT_FWD_OOC, DOROOT_BWD_PANEL
-      LOGICAL SWITCH_OFF_ES
       LOGICAL DUMMY_BOOL
       INTEGER :: IDUMMY
       INTEGER :: NBROOT_UNDER_L0
       DOUBLE PRECISION, PARAMETER :: ZERO = 0.0D0
       INCLUDE 'mumps_headers.h'
-      INTEGER, DIMENSION(:), ALLOCATABLE ::  nodes_RHS
-      INTEGER nb_nodes_RHS
+      INTEGER, DIMENSION(:), POINTER             ::  nodes_BWD_PTR
+      INTEGER, DIMENSION(:), ALLOCATABLE, TARGET :: Pruned_Roots_FWD
+      INTEGER, DIMENSION(:), ALLOCATABLE, TARGET :: Pruned_Roots_NS
+      INTEGER  :: Lnodes_BWD_PTR, LPruned_Roots_NS
+      INTEGER :: Lnodes_BWD_ROOTS
       INTEGER nb_prun_leaves
       INTEGER, DIMENSION(:), ALLOCATABLE :: Pruned_Leaves
       INTEGER, DIMENSION(:), ALLOCATABLE ::  Pruned_List
       INTEGER  nb_prun_nodes
-      INTEGER nb_prun_roots, JAM1
+      INTEGER INODE_PRINC, nb_prun_roots
       INTEGER, DIMENSION(:), ALLOCATABLE ::  Pruned_SONS, Pruned_Roots
       INTEGER                            :: SIZE_TO_PROCESS
       LOGICAL, DIMENSION(:), ALLOCATABLE :: TO_PROCESS
-      INTEGER ISTEP, INODE_PRINC
+      INTEGER ISTEP
       INTEGER :: INODE, ICHILD
-      LOGICAL AM1, DO_PRUN
-      LOGICAL Exploit_Sparsity
+      LOGICAL AM1, DO_PRUN_FWD, DO_PRUN_BWD
+      LOGICAL Exploit_Sparsity_FWD, Exploit_Sparsity_BWD
       LOGICAL DO_NBSPARSE_BWD, PRUN_BELOW_BWD
       INTEGER :: OOC_FCT_TYPE_TMP
       INTEGER :: MUMPS_OOC_GET_FCT_TYPE
@@ -179,7 +196,6 @@ C
       DOFORWARD = .TRUE.
       DOBACKWARD= .TRUE.
       SPECIAL_ROOT_REACHED = .TRUE.
-      SWITCH_OFF_ES    = .FALSE.
       IF ( KEEP(111).NE.0 .OR. KEEP(252).NE.0 ) THEN
         DOFORWARD = .FALSE.
       ENDIF
@@ -202,23 +218,28 @@ C
      &                     .AND. KEEP(201).EQ.1
       DOROOT_FWD_OOC = DOROOT .AND. .NOT.DOROOT_BWD_PANEL
       AM1              = (KEEP(237) .NE. 0)
-      Exploit_Sparsity = (KEEP(235) .NE. 0) .AND. (.NOT. AM1)
-      DO_PRUN          = (Exploit_Sparsity.OR.AM1)
+      Exploit_Sparsity_FWD  = (KEEP(235) .NE. 0) .AND. (.NOT. AM1)
+      Exploit_Sparsity_BWD  = (KEEP(212) .NE. 0) .AND. (.NOT. AM1)
+      Lnodes_BWD_ROOTS = NA(2)
+      DO_PRUN_FWD          = (Exploit_Sparsity_FWD.OR.AM1)
+      DO_PRUN_BWD          = (Exploit_Sparsity_BWD.OR.AM1)
       IF (FROM_PP) THEN
-        Exploit_Sparsity = .FALSE.
-        DO_PRUN          = .FALSE.
+        Exploit_Sparsity_FWD = .FALSE.
+        DO_PRUN_FWD          = .FALSE.
+        Exploit_Sparsity_BWD = .FALSE.
+        DO_PRUN_BWD          = .FALSE.
            IF ( AM1 ) THEN
           WRITE(*,*) "Internal error 2 in DMUMPS_SOL_C"
           CALL MUMPS_ABORT()
         ENDIF
       ENDIF
-      DO_L0OMP_FWD= ( (KEEP(401).GT.0).AND.(KEEP(400).GT.0)
+      DO_L0OMP_FWD= ( (KEEP(401).EQ.1).AND.(KEEP(400).GT.0)
      &             .AND.DOFORWARD )
       DO_L0OMP_FWD = DO_L0OMP_FWD .AND. KEEP(201).EQ.0
-      DO_L0OMP_BWD = ( (KEEP(401).GT.0).AND.(KEEP(400).GT.0)
+      DO_L0OMP_BWD = ( (KEEP(401).EQ.1).AND.(KEEP(400).GT.0)
      &              .AND.DOBACKWARD )
       DO_L0OMP_BWD = DO_L0OMP_BWD .AND. KEEP(201).EQ.0
-      IF ( DO_PRUN ) THEN
+      IF ( DO_PRUN_FWD.OR.DO_PRUN_BWD ) THEN
          ALLOCATE (Pruned_SONS(KEEP(28)), stat=I)
          IF(I.GT.0) THEN
                INFO(1)=-13
@@ -227,7 +248,7 @@ C
          CALL MUMPS_PROPINFO(ICNTL, INFO, COMM_NODES, MYID )
          IF(INFO(1).LT.0) GOTO 500
       ENDIF
-      IF ( DO_PRUN 
+      IF ( DO_PRUN_FWD.OR.DO_PRUN_BWD
      &     .OR. DO_L0OMP_BWD
      &   ) THEN
          SIZE_TO_PROCESS = KEEP(28)
@@ -241,84 +262,12 @@ C
       END IF
       CALL MUMPS_PROPINFO(ICNTL, INFO, COMM_NODES, MYID )
       IF(INFO(1).LT.0) GOTO 500
-      IF ( DOFORWARD .AND. DO_PRUN ) THEN
-         nb_prun_nodes = 0
-         nb_prun_roots = 0
-         Pruned_SONS(:) = -1
-         IF ( Exploit_Sparsity ) THEN
-            nb_nodes_RHS = 0
-            DO I = 1, NZ_RHS
-               ISTEP       = abs( STEP(IRHS_SPARSE(I)) )
-               INODE_PRINC = Step2node( ISTEP )
-               IF ( Pruned_SONS(ISTEP) .eq. -1) THEN
-                  nb_nodes_RHS = nb_nodes_RHS +1
-                  Pruned_SONS(ISTEP) = 0 
-               ENDIF
-            ENDDO
-            ALLOCATE(nodes_RHS(nb_nodes_RHS), STAT = allocok)
-            IF(allocok.GT.0) THEN
-              INFO(1)=-13
-              INFO(2)=nb_nodes_RHS
-            END IF
-            CALL MUMPS_PROPINFO(ICNTL, INFO, COMM_NODES, MYID )
-            IF(INFO(1).LT.0) GOTO 500
-            nb_nodes_RHS = 0
-            Pruned_SONS = -1
-            DO I = 1, NZ_RHS
-               ISTEP       = abs( STEP(IRHS_SPARSE(I)) )
-               INODE_PRINC = Step2node( ISTEP )
-               IF ( Pruned_SONS(ISTEP) .eq. -1) THEN
-                  nb_nodes_RHS = nb_nodes_RHS +1
-                  nodes_RHS(nb_nodes_RHS)  = INODE_PRINC
-                  Pruned_SONS(ISTEP) = 0 
-               ENDIF
-            ENDDO
-         ELSE IF ( AM1 ) THEN  
-            nb_nodes_RHS = 0
-            DO I = 1, NBCOL_INBLOC
-              IF ( (IRHS_PTR(I+1)-IRHS_PTR(I)).EQ.0) CYCLE
-              IF ( (KEEP(242) .NE. 0 ).OR. (KEEP(243).NE.0) ) THEN
-                   JAM1 = PERM_RHS(JBEG_RHS+I-1)
-              ELSE
-                   JAM1 = JBEG_RHS+I-1
-              ENDIF       
-              ISTEP = abs(STEP(JAM1))
-              INODE_PRINC = Step2node(ISTEP)
-              IF ( Pruned_SONS(ISTEP) .eq. -1) THEN
-                 nb_nodes_RHS = nb_nodes_RHS +1
-                 Pruned_SONS(ISTEP) = 0                 
-              ENDIF
-            ENDDO
-            ALLOCATE(nodes_RHS(nb_nodes_RHS), STAT = allocok)
-            IF(allocok.GT.0) THEN
-               INFO(1)=-13
-               INFO(2)=nb_nodes_RHS
-            END IF
-            CALL MUMPS_PROPINFO(ICNTL, INFO, COMM_NODES, MYID )
-            IF(INFO(1).LT.0) GOTO 500
-            nb_nodes_RHS = 0
-            Pruned_SONS = -1
-            DO I = 1, NBCOL_INBLOC
-              IF ( (IRHS_PTR(I+1)-IRHS_PTR(I)).EQ.0) CYCLE
-              IF ( (KEEP(242) .NE. 0 ).OR. (KEEP(243).NE.0) ) THEN
-                   JAM1 = PERM_RHS(JBEG_RHS+I-1)
-              ELSE
-                   JAM1 = JBEG_RHS+I-1
-              ENDIF
-              ISTEP = abs(STEP(JAM1))
-              INODE_PRINC = Step2node(ISTEP)
-              IF ( Pruned_SONS(ISTEP) .eq. -1) THEN
-                 nb_nodes_RHS = nb_nodes_RHS +1
-                 nodes_RHS(nb_nodes_RHS)  = INODE_PRINC
-                 Pruned_SONS(ISTEP) = 0
-              ENDIF
-            ENDDO            
-         ENDIF                  
+      IF ( DOFORWARD .AND. DO_PRUN_FWD ) THEN
          CALL DMUMPS_CHAIN_PRUN_NODES( 
      &        .FALSE.,
      &        DAD, KEEP(28),
      &        STEP, N,
-     &        nodes_RHS, nb_nodes_RHS,
+     &        nodes_FWD, Lnodes_FWD,
      &        Pruned_SONS, TO_PROCESS,
      &        nb_prun_nodes, nb_prun_roots,
      &        nb_prun_leaves )  
@@ -347,11 +296,10 @@ C
      &        .TRUE.,
      &        DAD, KEEP(28),
      &        STEP, N,
-     &        nodes_RHS, nb_nodes_RHS,
+     &        nodes_FWD, Lnodes_FWD,
      &        Pruned_SONS, TO_PROCESS,
      &        nb_prun_nodes, nb_prun_roots, nb_prun_leaves,
      &        Pruned_List, Pruned_Roots, Pruned_Leaves )
-         IF(allocated(nodes_RHS)) DEALLOCATE(nodes_RHS)
          CALL DMUMPS_OOC_SET_STATES_ES(N,
      &          KEEP(201), Pruned_List, nb_prun_nodes,
      &          STEP)
@@ -365,11 +313,15 @@ C
      &        MYID_NODES, N, KEEP(28), KEEP(201), KEEP(485), 
      &        KEEP8(31)+KEEP8(64), 
      &        STEP, Pruned_List, nb_prun_nodes, OOC_FCT_TYPE_TMP
+#if defined(STAT_ES_SOLVE)
+     &        , NRHS, COMM_NODES, IW, LIW, PTRIST,KEEP(IXSZ),0,
+     &        KEEP(50), KEEP(38)
+#endif
      &   )
          IF (DO_NBSPARSE) THEN
            nb_sparse = max(1,KEEP(497))
            MODE_RHS_BOUNDS = 0 
-           IF (Exploit_Sparsity) MODE_RHS_BOUNDS = 2
+           IF (Exploit_Sparsity_FWD) MODE_RHS_BOUNDS = 2
            CALL DMUMPS_INITIALIZE_RHS_BOUNDS(
      &      STEP, N,
      &      IRHS_PTR, NBCOL_INBLOC, IRHS_SPARSE, NZ_RHS,
@@ -383,6 +335,10 @@ C
      &      STEP, N, Pruned_SONS,
      &      DAD, RHS_BOUNDS, KEEP(28),
      &      MYID_NODES, COMM_NODES, KEEP(485),
+#if defined(STAT_ES_SOLVE)
+     &      KEEP(46), 
+     &      IPTR_WORKING, SIZE_IPTR_WORKING, WORKING, SIZE_WORKING,
+#endif
      &      IW, LIW, PTRIST,KEEP(IXSZ),OOC_FCT_TYPE_TMP,0,
      &      KEEP(50), KEEP(38))
          END IF
@@ -416,7 +372,7 @@ C
 #if defined(V_T)
         CALL VTBEGIN(forw_soln,ierr)
 #endif
-        IF ( .NOT. DO_PRUN ) THEN
+        IF ( .NOT. DO_PRUN_FWD ) THEN
           CALL MUMPS_INIT_NROOT_DIST(N, NBROOT, MYROOT, MYID_NODES,
      &           SLAVEF, NA, LNA, KEEP, STEP, PROCNODE_STEPS)
           DO ISTEP =1, KEEP(28)
@@ -427,12 +383,20 @@ C
      &         nb_prun_roots, Pruned_Roots,
      &         MYROOT, MYID_NODES, SLAVEF, KEEP, STEP,
      &         PROCNODE_STEPS )
-          IF (AM1) THEN 
+          IF ((Exploit_Sparsity_FWD).AND.(nb_prun_roots.NE.NA(2))) THEN
+             Lnodes_BWD_ROOTS = nb_prun_roots
+            ALLOCATE(Pruned_Roots_FWD(Lnodes_BWD_ROOTS), STAT=allocok)
+            IF(allocok.GT.0) THEN
+              WRITE(*,*)'Problem with allocation of nodes_FWD'
+              INFO(1) = -13
+              INFO(2) = Lnodes_BWD_ROOTS
+              CALL MUMPS_ABORT()
+            END IF
+            Pruned_Roots_FWD(1:Lnodes_BWD_ROOTS)=
+     &                        Pruned_Roots(1:Lnodes_BWD_ROOTS)
             DEALLOCATE(Pruned_Roots)
-          END IF
-          IF ((Exploit_Sparsity).AND.(nb_prun_roots.EQ.NA(2))) THEN
+          ELSE
             DEALLOCATE(Pruned_Roots)
-            SWITCH_OFF_ES = .TRUE.   
           ENDIF
           DO ISTEP = 1, KEEP(28)
             IW1(NSTK_S+ISTEP-1) = Pruned_SONS(ISTEP)
@@ -441,7 +405,7 @@ C
         IF ( DO_L0OMP_FWD ) THEN
           KEEP(405)=1
           CALL DMUMPS_SOL_L0OMP_R( N, MTYPE_LOC, NRHS, LIW, IW,
-     &    IW1(PTRICB), RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD,
+     &    IW1(PTRICB), RHSINTR, LRHSINTR, POSINRHSINTR_FWD,
      &    STEP, FRERE, DAD, FILS, IW1(NSTK_S), 
      &    PTRIST, PTRFAC, INFO,
      &    KEEP, KEEP8, DKEEP, PROCNODE_STEPS, SLAVEF,
@@ -458,7 +422,7 @@ C
      &    PERM_L0_OMP, PTR_LEAFS_L0_OMP,
      &    L0_OMP_MAPPING, LL0_OMP_MAPPING,
      &    L0_OMP_FACTORS, LL0_OMP_FACTORS,
-     &    DO_PRUN, TO_PROCESS
+     &    DO_PRUN_FWD, TO_PROCESS
      &    )
           CALL MUMPS_STOP_ON_USER_REQUEST( KEEP, KEEP8, ICNTL,
      &                                    INFO, MYID )
@@ -469,7 +433,7 @@ C
           MYROOT = MYROOT - NBROOT_UNDER_L0
         ENDIF
         IF ( DO_L0OMP_FWD ) THEN
-          IF ( DO_PRUN ) THEN
+          IF ( DO_PRUN_FWD ) THEN
             MYLEAF_NOT_PRUNED = IPOOL_A_L0_OMP(LPOOL_A_L0_OMP)
             DO I=1, MYLEAF_NOT_PRUNED
               IF ( TO_PROCESS( STEP( IPOOL_A_L0_OMP(I) ))) THEN
@@ -513,7 +477,7 @@ C
             ENDDO
           ENDIF
         ELSE
-          IF ( DO_PRUN ) THEN
+          IF ( DO_PRUN_FWD ) THEN
             CALL MUMPS_INIT_POOL_DIST_NONA( N, MYLEAF, MYID_NODES,
      &            nb_prun_leaves, Pruned_Leaves, KEEP, KEEP8,
      &            STEP, PROCNODE_STEPS, IW1(IPOOL), LPOOL )
@@ -529,7 +493,7 @@ C
         CALL DMUMPS_SOL_R(N, A(1), LA, IW(1), LIW, W(1),
      &       LWC, NRHS,
      &       IW1(PTRICB), IWCB, LIWW,
-     &       RHSCOMP,LRHSCOMP,POSINRHSCOMP_FWD,
+     &       RHSINTR,LRHSINTR,POSINRHSINTR_FWD,
      &       STEP, FRERE,DAD,FILS,
      &       IW1(NSTK_S),IW1(IPOOL),LPOOL,PTRIST,PTRFAC,
      &       MYLEAF, MYROOT, INFO,
@@ -543,7 +507,7 @@ C
      &          , L0_OMP_MAPPING, LL0_OMP_MAPPING,
      &            L0_OMP_FACTORS, LL0_OMP_FACTORS
      &       )
-        IF (DO_PRUN) THEN
+        IF (DO_PRUN_FWD) THEN
           MYLEAF = -1
         ENDIF
 #if defined(V_T)
@@ -567,9 +531,11 @@ C
          CALL MUMPS_SECFIN(TIME_FWD)
          DKEEP(117)=TIME_FWD + DKEEP(117)
       ENDIF
-      IF (DO_PRUN.AND.SWITCH_OFF_ES) THEN
-         DO_PRUN          = .FALSE.
-         Exploit_Sparsity = .FALSE.
+      IF ( .NOT.( 
+     &       DOBACKWARD.AND.
+     &      (DO_PRUN_BWD.OR.(Lnodes_BWD_ROOTS.NE.NA(2)))
+     &          )
+     &   ) THEN
          IF (.NOT. DO_L0OMP_BWD ) THEN
            IF ( allocated(TO_PROCESS) .AND. SIZE_TO_PROCESS.NE.1 ) THEN
              DEALLOCATE (TO_PROCESS)
@@ -578,58 +544,60 @@ C
            ENDIF
          ENDIF
       ENDIF
-      IF ( DOBACKWARD .AND. DO_PRUN )  THEN
-         nb_prun_leaves = 0
-        IF ( Exploit_Sparsity .AND. (KEEP(111).EQ.0) ) THEN
-          nb_nodes_RHS = nb_prun_roots
-          ALLOCATE(nodes_RHS(nb_nodes_RHS), STAT = allocok)
-          IF(allocok.GT.0) THEN
-            WRITE(*,*)'Problem with allocation of nodes_RHS'
-            INFO(1) = -13
-            INFO(2) = nb_nodes_RHS
-            CALL MUMPS_ABORT()
-          END IF
-          nodes_RHS(1:nb_prun_roots)=Pruned_Roots(1:nb_prun_roots)
-          DEALLOCATE(Pruned_Roots)
-        ELSE
-         nb_nodes_RHS = 0
-         Pruned_SONS(:) = -1 
-         DO II = 1, NZ_RHS
+      IF ( (KEEP(111).NE.0).AND.DOBACKWARD.AND.
+     &     (
+     &      DO_PRUN_BWD
+     &     )
+     &   )   THEN
+        nb_prun_leaves = 0
+        IF ( Lnodes_BWD_ROOTS.NE.NA(2) ) THEN
+          nodes_BWD_PTR => Pruned_Roots_FWD
+          Lnodes_BWD_PTR = Lnodes_BWD_ROOTS
+        ELSE IF ( (Exploit_Sparsity_BWD.AND.KEEP(111).NE.0) 
+     &          ) THEN
+          LPruned_Roots_NS = 0
+          Pruned_SONS(:)   = -1 
+          DO II = 1, NZ_RHS
             I = IRHS_SPARSE(II)
             IF (KEEP(23).NE.0) I = UNS_PERM_INV(I)          
             ISTEP = abs(STEP(I))
             IF ( Pruned_SONS(ISTEP) .eq. -1) THEN
-               nb_nodes_RHS = nb_nodes_RHS +1
+               LPruned_Roots_NS   = LPruned_Roots_NS +1
                Pruned_SONS(ISTEP) = 0
             ENDIF
-         ENDDO
-         ALLOCATE(nodes_RHS(nb_nodes_RHS), STAT = allocok)           
-         IF(allocok.GT.0) THEN
-           WRITE(*,*)'Problem with allocation of nodes_RHS'
+          ENDDO
+          ALLOCATE(Pruned_Roots_NS(LPruned_Roots_NS), STAT = allocok) 
+          IF(allocok.GT.0) THEN
+           WRITE(*,*)'Problem with allocation of nodes_BWD'
            INFO(1) = -13
-           INFO(2) = nb_nodes_RHS
+           INFO(2) = LPruned_Roots_NS
            CALL MUMPS_ABORT()
-         END IF
-         nb_nodes_RHS = 0         
-         Pruned_SONS(:) = -1  
-         DO II = 1, NZ_RHS
+          END IF
+          LPruned_Roots_NS = 0         
+          Pruned_SONS(:) = -1  
+          DO II = 1, NZ_RHS
             I = IRHS_SPARSE(II)
             IF (KEEP(23).NE.0) I = UNS_PERM_INV(I)
             ISTEP = abs(STEP(I))
             INODE_PRINC = Step2node(ISTEP)
             IF ( Pruned_SONS(ISTEP) .eq. -1) THEN
-               nb_nodes_RHS = nb_nodes_RHS +1
-               nodes_RHS(nb_nodes_RHS)  = INODE_PRINC
+               LPruned_Roots_NS = LPruned_Roots_NS +1
+               Pruned_Roots_NS(LPruned_Roots_NS)  = INODE_PRINC
                Pruned_SONS(ISTEP) = 0
             ENDIF
-         ENDDO
+          ENDDO
+          nodes_BWD_PTR => Pruned_Roots_NS
+          Lnodes_BWD_PTR = LPruned_Roots_NS
         ENDIF
-        IF ( Exploit_Sparsity ) THEN
+        IF ( 
+     &       (Exploit_Sparsity_BWD.AND.KEEP(111).NE.0) .OR.
+     &       (Lnodes_BWD_ROOTS.NE.NA(2))
+     &     ) THEN
            CALL DMUMPS_TREE_PRUN_NODES( 
      &     .FALSE.,
      &     DAD, NE_STEPS, FRERE, KEEP(28),
      &     FILS, STEP, N,
-     &     nodes_RHS, nb_nodes_RHS,
+     &     nodes_BWD_PTR, Lnodes_BWD_PTR,
      &     TO_PROCESS,
      &     nb_prun_nodes, nb_prun_roots, nb_prun_leaves
      &     )
@@ -658,27 +626,22 @@ C
      &     .TRUE.,
      &     DAD, NE_STEPS, FRERE, KEEP(28),
      &     FILS, STEP, N,
-     &     nodes_RHS, nb_nodes_RHS,
+     &     nodes_BWD_PTR, Lnodes_BWD_PTR,
      &     TO_PROCESS,
      &     nb_prun_nodes, nb_prun_roots, nb_prun_leaves,
      &     Pruned_List, Pruned_Roots, Pruned_Leaves
      &     )
+           IF(allocated(Pruned_Roots_NS)) DEALLOCATE(Pruned_Roots_NS)
+           IF(allocated(Pruned_Roots_FWD)) DEALLOCATE(Pruned_Roots_FWD)
            CALL DMUMPS_OOC_SET_STATES_ES(N,
      &          KEEP(201), Pruned_List, nb_prun_nodes,
      &          STEP)
-           IF(allocated(nodes_RHS)) DEALLOCATE(nodes_RHS)
            IF (KEEP(201).GT.0) THEN
              OOC_FCT_TYPE_TMP=MUMPS_OOC_GET_FCT_TYPE
      &                    ('B',MTYPE,KEEP(201),KEEP(50))
            ELSE
              OOC_FCT_TYPE_TMP = -5959 
            ENDIF
-           CALL DMUMPS_TREE_PRUN_NODES_STATS(
-     &          MYID_NODES, N, KEEP(28), KEEP(201),
-     &        KEEP8(31)+KEEP8(64), 
-     &          STEP,
-     &          Pruned_List,
-     &          nb_prun_nodes, OOC_FCT_TYPE_TMP)
         ENDIF
       ENDIF
       IF(KEEP(201).EQ.1.AND.DOROOT_BWD_PANEL) THEN
@@ -705,7 +668,7 @@ C
         IF ( KEEP(60) .EQ. 0 .AND. KEEP(252) .EQ. 0 ) THEN
           IF ( root%yes ) THEN
             IF (KEEP(201).GT.0) THEN
-              IF ( (Exploit_Sparsity.AND.(KEEP(111).NE.0)) .and.
+              IF ( (Exploit_Sparsity_FWD.AND.(KEEP(111).NE.0)) .and.
      &            (OOC_STATE_NODE(STEP(KEEP(38))).eq.-6) ) THEN
                   GOTO 1010
               ENDIF
@@ -756,6 +719,49 @@ C
         ENDIF
       ELSE IF ( ( KEEP(20) .NE. 0) .AND. SPECIAL_ROOT_REACHED ) THEN
         IF ( MYID_NODES .eq.  MASTER_ROOT ) THEN
+          IF ( KEEP(60) .eq. 0 ) THEN
+            IF (KEEP(201).GT.0) THEN
+              CALL DMUMPS_SOLVE_GET_OOC_NODE(
+     &              KEEP(20),PTRFAC,KEEP,A,LA,
+     &              STEP,KEEP8,N,DUMMY_BOOL,IERR)
+              IF(IERR.LT.0)THEN
+                INFO(1)=IERR
+                INFO(2)=0
+                WRITE(*,*) '** ERROR after DMUMPS_SOLVE_GET_OOC_NODE', 
+     &          INFO(1)
+                call MUMPS_ABORT()
+              ENDIF
+            END IF
+            NRHS_LOC         = NRHS
+            IPT_RHS_ROOT_LOC = 1
+            IF ( KEEP(111).NE.0 ) THEN
+              RHS_ROOT( 1: NRHS*SIZE_ROOT) = ZERO
+              NRHS_LOC = IEND_ROOT_DEF - IBEG_ROOT_DEF + 1
+              IPT_RHS_ROOT_LOC = IPT_RHS_ROOT_LOC +
+     &                           (IROOT_DEF_RHS_COL1-1)*SIZE_ROOT
+           ENDIF
+           IF (NRHS_LOC .GT. 0) THEN
+              CALL DMUMPS_SEQ_SOLVE_ROOT_SVD_QR(NRHS_LOC,
+     &             SIZE_ROOT,A( PTRFAC(
+     &             IW( PTRIST(STEP(KEEP(20)))+4+KEEP(IXSZ)))),
+     &             root, IBEG_ROOT_DEF, IEND_ROOT_DEF,
+     &             RHS_ROOT( IPT_RHS_ROOT_LOC ),
+     &             KEEP,KEEP8,
+     &             MTYPE,INFO,LWC,W(1), LP)
+        ENDIF
+            IF(KEEP(201).GT.0)THEN
+              CALL DMUMPS_FREE_FACTORS_FOR_SOLVE(KEEP(20),
+     &             PTRFAC,KEEP(28),A,LA,.FALSE.,IERR)
+              IF(IERR.LT.0)THEN
+                 INFO(1)=IERR
+                 INFO(2)=0
+                 WRITE(*,*)
+     &           '** ERROR after DMUMPS_FREE_FACTORS_FOR_SOLVE ', 
+     &           INFO(1)
+                 call MUMPS_ABORT()
+              ENDIF
+            ENDIF
+          ENDIF
         END IF 
       END IF 
       IF (.NOT.FROM_PP) THEN
@@ -773,13 +779,13 @@ C
      &    THEN
           I_WORKED_ON_ROOT = DOROOT
           IF (KEEP(38).gt.0 ) THEN
-             IF ( ( Exploit_Sparsity.AND.(KEEP(111).EQ.0) )
+             IF ( ( Exploit_Sparsity_FWD.AND.(KEEP(111).EQ.0) )
      &            .OR. AM1 ) THEN
                 IF (OOC_STATE_NODE(STEP(KEEP(38))).eq.-6) THEN
                    OOC_STATE_NODE(STEP(KEEP(38)))=-4
                 ENDIF
              ENDIF
-             IF (Exploit_Sparsity.AND.(KEEP(111).NE.0)) THEN
+             IF (Exploit_Sparsity_FWD.AND.(KEEP(111).NE.0)) THEN
                 IF (OOC_STATE_NODE(STEP(KEEP(38))).eq.-6) THEN
                    I_WORKED_ON_ROOT = .FALSE.
                 ENDIF
@@ -791,14 +797,14 @@ C
         ELSE
           DO_NBSPARSE_BWD = DO_NBSPARSE
         ENDIF
-        PRUN_BELOW_BWD = AM1
+        PRUN_BELOW_BWD = DO_PRUN_BWD .AND. KEEP(111).EQ.0
         PRUN_BELOW_BWD = PRUN_BELOW_BWD .OR. DO_L0OMP_BWD
-        IF ( AM1 ) THEN
+        IF ( DO_PRUN_BWD )  THEN
           CALL DMUMPS_CHAIN_PRUN_NODES( 
      &        .FALSE.,
      &        DAD, KEEP(28),
      &        STEP, N,
-     &        nodes_RHS, nb_nodes_RHS,
+     &        nodes_BWD, Lnodes_BWD,
      &        Pruned_SONS, TO_PROCESS,
      &        nb_prun_nodes, nb_prun_roots,
      &        nb_prun_leaves)  
@@ -823,11 +829,11 @@ C
           END IF
           CALL MUMPS_PROPINFO(ICNTL, INFO, COMM_NODES, MYID )
           IF(INFO(1).LT.0) GOTO 500
-          CALL DMUMPS_CHAIN_PRUN_NODES( 
+          CALL DMUMPS_CHAIN_PRUN_NODES(
      &        .TRUE.,
      &        DAD, KEEP(28),
      &        STEP, N,
-     &        nodes_RHS, nb_nodes_RHS,
+     &        nodes_BWD, Lnodes_BWD,
      &        Pruned_SONS, TO_PROCESS,
      &        nb_prun_nodes, nb_prun_roots, nb_prun_leaves,
      &        Pruned_List, Pruned_Roots, Pruned_Leaves )
@@ -843,6 +849,10 @@ C
           CALL DMUMPS_CHAIN_PRUN_NODES_STATS(
      &    MYID_NODES, N, KEEP(28), KEEP(201), KEEP(485), KEEP8(31),
      &    STEP, Pruned_List, nb_prun_nodes, OOC_FCT_TYPE_TMP
+#if defined(STAT_ES_SOLVE)
+     &          , NRHS, COMM_NODES, IW, LIW, PTRIST,KEEP(IXSZ),1,
+     &          KEEP(50), KEEP(38)
+#endif
      &    )
           IF (DO_NBSPARSE_BWD) THEN
             nb_sparse = max(1,KEEP(497))
@@ -859,6 +869,10 @@ C
      &       STEP, N, Pruned_SONS,
      &       DAD, RHS_BOUNDS, KEEP(28),
      &       MYID_NODES, COMM_NODES, KEEP(485),
+#if defined(STAT_ES_SOLVE)
+     &       KEEP(46), 
+     &       IPTR_WORKING, SIZE_IPTR_WORKING, WORKING, SIZE_WORKING,
+#endif     
      &       IW, LIW, PTRIST,KEEP(IXSZ),OOC_FCT_TYPE_TMP,1,
      &       KEEP(50), KEEP(38))
          END IF
@@ -882,17 +896,17 @@ C
         IF ( .NOT.SPECIAL_ROOT_REACHED ) THEN
           RHS_ROOT(1:NRHS*SIZE_ROOT) = ZERO
         ENDIF
-        IF (AM1.AND.(NB_FS_IN_RHSCOMP_F.NE.NB_FS_IN_RHSCOMP_TOT)) THEN
+        IF (AM1.AND.(NB_FS_IN_RHSINTR_F.NE.NB_FS_IN_RHSINTR_TOT)) THEN
          DO I =1, N
-           II = POSINRHSCOMP_BWD(I)
-           IF ((II.GT.0).AND.(II.GT.NB_FS_IN_RHSCOMP_F)) THEN
+           II = POSINRHSINTR_BWD(I)
+           IF ((II.GT.0).AND.(II.GT.NB_FS_IN_RHSINTR_F)) THEN
             DO K=1,NRHS
-             RHSCOMP(II, K) = ZERO
+             RHSINTR(II, K) = ZERO
             ENDDO
            ENDIF
          ENDDO
         ENDIF
-        IF ( .NOT. DO_PRUN ) THEN
+        IF ( .NOT. DO_PRUN_BWD ) THEN
            IF ( .NOT. DO_L0OMP_BWD ) THEN
              IF (DO_L0OMP_FWD) THEN
                MYLEAF = -1
@@ -988,7 +1002,7 @@ C
               IF ( .NOT. MUMPS_IN_OR_ROOT_SSARBR(PROCNODE_STEPS(I),
      &        KEEP(199)) ) THEN
                 IF ( L0_OMP_MAPPING(I) .EQ. 0 ) THEN
-                  IF ( DO_PRUN
+                  IF ( DO_PRUN_BWD
      &                 .OR. DO_L0OMP_BWD 
      &               ) THEN
                     IF ( TO_PROCESS(I) ) THEN
@@ -1007,7 +1021,7 @@ C
       IF(INFO(1).LT.0) GOTO 500
         CALL DMUMPS_SOL_S( N, A, LA, IW, LIW, W(1), LWC,
      &          NRHS,
-     &          RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &          RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &          IW1(PTRICB),PTRACB,IWCB,LIWW, W2,
      &          NE_STEPS,
      &          STEP, FRERE,DAD,FILS,
@@ -1023,7 +1037,7 @@ C
      &          , L0_OMP_MAPPING, LL0_OMP_MAPPING,
      &            L0_OMP_FACTORS, LL0_OMP_FACTORS
      &          )
-        IF ( DO_L0OMP_BWD .AND. DO_PRUN ) THEN
+        IF ( DO_L0OMP_BWD .AND. DO_PRUN_BWD ) THEN
           DO I = 1, L_PHYS_L0_OMP
             IF ( PHYS_L0_OMP( I ) .LT. 0 ) THEN
               PHYS_L0_OMP( I ) = -PHYS_L0_OMP( I )
@@ -1034,10 +1048,10 @@ C
         CALL MUMPS_STOP_ON_USER_REQUEST(KEEP, KEEP8, ICNTL, INFO, MYID)
         IF (DO_L0OMP_BWD .AND. INFO(1) .GE. 0) THEN
           KEEP(31) = 0
-          PRUN_BELOW_BWD = AM1
+          PRUN_BELOW_BWD = DO_PRUN_BWD .AND. KEEP(111).EQ.0
           KEEP(405)=1
           CALL DMUMPS_SOL_L0OMP_S(N, MTYPE_LOC, NRHS, LIW, IW,
-     &      IW1(PTRICB), PTRACB, RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &      IW1(PTRICB), PTRACB, RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &      STEP, FRERE, FILS, NE_STEPS, PTRIST, PTRFAC, INFO,
      &      KEEP, KEEP8, DKEEP, PROCNODE_STEPS, SLAVEF,
      &      COMM_NODES, MYID_NODES, BUFR, LBUFR, LBUFR_BYTES, 
@@ -1070,21 +1084,24 @@ C
       ENDIF
       IF (LDIAG.GT.2 .AND. MP.GT.0) THEN
         IF (DOFORWARD) THEN
-        K = min0(10,size(RHSCOMP,1))
-        IF (LDIAG.EQ.4) K = size(RHSCOMP,1)
+        K = min(10,size(RHSINTR,1))
+        IF (LDIAG.EQ.4) K = size(RHSINTR,1)
         IF ( .NOT. FROM_PP) THEN
           WRITE (MP,99992)
-          IF (size(RHSCOMP,1).GT.0) 
-     &    WRITE (MP,99993) (RHSCOMP(I,1),I=1,K)
-          IF (size(RHSCOMP,1).GT.0.and.NRHS>1) 
-     &              WRITE (MP,99994) (RHSCOMP(I,2),I=1,K)
+          IF (size(RHSINTR,1).GT.0) 
+     &    WRITE (MP,99993) (RHSINTR(I,1),I=1,K)
+          IF (size(RHSINTR,1).GT.0.and.NRHS>1) 
+     &              WRITE (MP,99994) (RHSINTR(I,2),I=1,K)
           ENDIF
         ENDIF
       ENDIF
 500   CONTINUE
       IF ( allocated(TO_PROCESS)) DEALLOCATE (TO_PROCESS)
-      IF (Exploit_Sparsity.OR.AM1.OR.SWITCH_OFF_ES) THEN
-         IF ( allocated(nodes_RHS)) DEALLOCATE (nodes_RHS)
+      IF (DO_PRUN_FWD.OR.DO_PRUN_BWD) THEN
+         IF ( allocated(Pruned_Roots_FWD)) 
+     &        DEALLOCATE (Pruned_Roots_FWD)
+         IF ( allocated(Pruned_Roots_NS)) 
+     &        DEALLOCATE (Pruned_Roots_NS)
          IF ( allocated(Pruned_SONS)) DEALLOCATE (Pruned_SONS)
          IF ( allocated(Pruned_Roots)) DEALLOCATE (Pruned_Roots)
          IF ( allocated(Pruned_List)) DEALLOCATE (Pruned_List)
@@ -1095,20 +1112,81 @@ C
 99994 FORMAT (' RHS (internal, 2 nd  column)'/(1X,1P,5D14.6))
 99992 FORMAT (//' LEAVING SOLVE (DMUMPS_SOL_C) WITH')
       END SUBROUTINE DMUMPS_SOL_C
+      SUBROUTINE DMUMPS_SET_POSTPros (KEEP, ICNTL, NBRHS, MPG, PROKG, 
+     &                               ICNTL10, ICNTL11, POSTPros)
+      IMPLICIT NONE
+      INTEGER, INTENT(IN)  :: KEEP(500), ICNTL(60), NBRHS, MPG
+      LOGICAL, INTENT(IN)  :: PROKG
+      INTEGER, INTENT(OUT) :: ICNTL10, ICNTL11
+      LOGICAL, INTENT(OUT) :: POSTPros
+      POSTPros = .FALSE.
+      IF (ICNTL11.NE.0 .OR. ICNTL10.NE.0) THEN
+        POSTPros = .TRUE.
+        IF (KEEP(111).NE.0) THEN
+            IF (PROKG) WRITE(MPG,'(A,A)')
+     &     ' WARNING: Incompatible features: null space basis',
+     &              ' and Iter. Ref and/or Err. Anal.'
+            POSTPros = .FALSE.
+        ELSE IF ( KEEP(237) .NE.0 ) THEN
+            IF (PROKG) WRITE(MPG,'(A,A)')
+     &     ' WARNING: Incompatible features: AM1',
+     &              ' and Iter. Ref and/or Err. Anal.'
+            POSTPros = .FALSE.
+        ELSE IF ( KEEP(252) .NE.0 ) THEN
+            IF (PROKG) WRITE(MPG,'(A,A)')
+     &     ' WARNING: Incompatible features: Fwd in facto ',
+     &              ' and Iter. Ref and/or Err. Anal.'
+            POSTPros = .FALSE.
+        ELSE IF (KEEP(221).NE.0) THEN
+            IF (PROKG) WRITE(MPG,'(A,A)')
+     &     ' WARNING: Incompatible features: reduced RHS',
+     &     ' and Iter. Ref and/or Err. Anal.'
+            POSTPros = .FALSE.
+        ELSE IF  (NBRHS.GT. 1 .OR. ICNTL(21) .GT. 0) THEN
+            IF (PROKG) WRITE(MPG,'(A,A)')
+     &     ' WARNING:  Incompatible features: nrhs>1 or distrib sol',
+     &     ' and Iter. Ref and/or Err. Anal.'
+            POSTPros = .FALSE.
+        ELSE IF ( KEEP(248) .EQ. -1 ) THEN
+            IF (PROKG) WRITE(MPG,'(A,A)')
+     &     ' WARNING:  Incompatible features: distrib rhs',
+     &     ' and Iter. Ref and/or Err. Anal.'
+            POSTPros = .FALSE.
+        ENDIF  
+        IF (.NOT.POSTPros) THEN
+          ICNTL11 = 0
+          ICNTL10 = 0
+        ENDIF
+      ENDIF
+      IF ((ICNTL(10) .NE. 0) .AND. (ICNTL10 .EQ. 0)) THEN
+          IF (PROKG) WRITE(MPG,'(A)')
+     &  ' WARNING: ICNTL(10) treated as if set to 0 '
+      ENDIF
+      IF ((ICNTL(11) .NE. 0)
+     &      .AND.(ICNTL11 .EQ. 0)) THEN
+          IF (PROKG) WRITE(MPG,'(A)')
+     &  ' WARNING: ICNTL(11) treated as if set to 0 '
+      ENDIF
+      RETURN
+      END SUBROUTINE DMUMPS_SET_POSTPros
       SUBROUTINE DMUMPS_GATHER_SOLUTION( NSLAVES, N, MYID, COMM,
      &           NRHS,
      &           MTYPE, RHS, LRHS, NCOL_RHS, JBEG_RHS, PTRIST,
      &           KEEP,KEEP8, PROCNODE_STEPS, IW, LIW, STEP, BUFFER,
      &           SIZE_BUF, SIZE_BUF_BYTES, CWORK, LCWORK,
+#if defined(USE_OLD_SCALING)
      &           LSCAL, SCALING, LSCALING, 
-     &           RHSCOMP, LRHSCOMP, NCOL_RHSCOMP, 
-     &           POSINRHSCOMP, LPOS_N, PERM_RHS, SIZE_PERM_RHS )
+#else
+     &           LSCAL, SCALING_LOC_BWD, LSCALING_LOC_BWD, 
+#endif
+     &           RHSINTR, LRHSINTR, NCOL_RHSINTR, 
+     &           POSINRHSINTR, LPOS_N, PERM_RHS, SIZE_PERM_RHS )
 !$    USE OMP_LIB
       IMPLICIT NONE
       INCLUDE 'mpif.h'
       INCLUDE 'mumps_tags.h'
       INTEGER NSLAVES, N, MYID, COMM, LIW, MTYPE, NCOL_RHS
-      INTEGER NRHS, LRHS, LCWORK, LPOS_N, NCOL_RHSCOMP
+      INTEGER NRHS, LRHS, LCWORK, LPOS_N, NCOL_RHSINTR
       DOUBLE PRECISION RHS   (LRHS, NCOL_RHS)
       INTEGER, INTENT(in) :: JBEG_RHS
       INTEGER KEEP(500)
@@ -1118,11 +1196,17 @@ C
       INTEGER IW(LIW), STEP(N)
       INTEGER SIZE_BUF, SIZE_BUF_BYTES
       INTEGER BUFFER(SIZE_BUF)
-      INTEGER LRHSCOMP, POSINRHSCOMP(LPOS_N) 
-      DOUBLE PRECISION, intent(in) :: RHSCOMP(LRHSCOMP, NCOL_RHSCOMP)
-      LOGICAL, intent(in) :: LSCAL
+      INTEGER LRHSINTR, POSINRHSINTR(LPOS_N) 
+#if defined(USE_OLD_SCALING)
+      DOUBLE PRECISION, intent(in) :: RHSINTR(LRHSINTR, NCOL_RHSINTR)
       INTEGER, intent(in) :: LSCALING
       DOUBLE PRECISION, intent(in)    :: SCALING(LSCALING)
+#else
+      DOUBLE PRECISION, intent(inout) :: RHSINTR(LRHSINTR, NCOL_RHSINTR)
+      INTEGER, intent(in) :: LSCALING_LOC_BWD
+      DOUBLE PRECISION, intent(in) :: SCALING_LOC_BWD(LSCALING_LOC_BWD)
+#endif
+      LOGICAL, intent(in) :: LSCAL
       INTEGER, INTENT(in) :: SIZE_PERM_RHS
       INTEGER, INTENT(in) :: PERM_RHS(SIZE_PERM_RHS)
       INTEGER I, II, J, J1, ISTEP, MASTER,
@@ -1133,7 +1217,7 @@ C
       PARAMETER(MASTER=0)
       LOGICAL I_AM_SLAVE
       INTEGER RECORD_SIZE_P_1, SIZE1, SIZE2
-      INTEGER POS_BUF, N2SEND, IPOSINRHSCOMP
+      INTEGER POS_BUF, N2SEND, IPOSINRHSINTR
       INTEGER :: JCOL_RHS
       INTEGER :: K242
       LOGICAL :: OMP_FLAG
@@ -1167,7 +1251,7 @@ C
              ENDIF
              IF (OMP_FLAG) THEN
 !$OMP PARALLEL FIRSTPRIVATE(JBEG_RHS,N,K242)
-!$OMP&  PRIVATE(J,IPOSINRHSCOMP,I,JCOL_RHS)
+!$OMP&  PRIVATE(J,IPOSINRHSINTR,I,JCOL_RHS)
                DO J=1, NRHS
                  IF (K242.EQ.0) THEN
                    JCOL_RHS = J+JBEG_RHS-1
@@ -1176,10 +1260,14 @@ C
                  ENDIF
 !$OMP DO SCHEDULE(DYNAMIC,CHUNK)
                  DO I=1, N
-                   IPOSINRHSCOMP = POSINRHSCOMP(I)
-                   IF (IPOSINRHSCOMP.GT.0) THEN 
-                     RHS(I,JCOL_RHS) =
-     &                   RHSCOMP(IPOSINRHSCOMP,J)*SCALING(I)
+                   IPOSINRHSINTR = POSINRHSINTR(I)
+                   IF (IPOSINRHSINTR.GT.0) THEN 
+                     RHS(I,JCOL_RHS) = RHSINTR(IPOSINRHSINTR,J)*
+#if defined(USE_OLD_SCALING)
+     &               SCALING(I)
+#else
+     &               SCALING_LOC_BWD(IPOSINRHSINTR)
+#endif
                    ELSE
                     RHS(I,JCOL_RHS) = ZERO
                   ENDIF
@@ -1195,10 +1283,14 @@ C
                    JCOL_RHS = PERM_RHS(J+JBEG_RHS-1)
                  ENDIF
                  DO I=1, N
-                   IPOSINRHSCOMP = POSINRHSCOMP(I)
-                   IF (IPOSINRHSCOMP.GT.0) THEN 
-                     RHS(I,JCOL_RHS) =
-     &                   RHSCOMP(IPOSINRHSCOMP,J)*SCALING(I)
+                   IPOSINRHSINTR = POSINRHSINTR(I)
+                   IF (IPOSINRHSINTR.GT.0) THEN 
+                     RHS(I,JCOL_RHS) = RHSINTR(IPOSINRHSINTR,J)*
+#if defined(USE_OLD_SCALING)
+     &               SCALING(I)
+#else
+     &               SCALING_LOC_BWD(IPOSINRHSINTR)
+#endif
                    ELSE
                      RHS(I,JCOL_RHS) = ZERO
                    ENDIF
@@ -1221,7 +1313,7 @@ C
              ENDIF
              IF (OMP_FLAG) THEN
 !$OMP PARALLEL FIRSTPRIVATE(JBEG_RHS,N,K242)
-!$OMP&  PRIVATE(IPOSINRHSCOMP,I,JCOL_RHS) IF (OMP_FLAG)
+!$OMP&  PRIVATE(IPOSINRHSINTR,I,JCOL_RHS) IF (OMP_FLAG)
                DO J=1, NRHS
                  IF (K242.EQ.0) THEN
                    JCOL_RHS = J+JBEG_RHS-1
@@ -1230,9 +1322,9 @@ C
                  ENDIF
 !$OMP DO SCHEDULE(DYNAMIC,CHUNK)
                  DO I=1, N
-                   IPOSINRHSCOMP = POSINRHSCOMP(I)
-                   IF (IPOSINRHSCOMP.GT.0) THEN
-                     RHS(I,JCOL_RHS) = RHSCOMP(IPOSINRHSCOMP,J)
+                   IPOSINRHSINTR = POSINRHSINTR(I)
+                   IF (IPOSINRHSINTR.GT.0) THEN
+                     RHS(I,JCOL_RHS) = RHSINTR(IPOSINRHSINTR,J)
                    ELSE
                      RHS(I,JCOL_RHS) = ZERO
                    ENDIF
@@ -1248,9 +1340,9 @@ C
                    JCOL_RHS = PERM_RHS(J+JBEG_RHS-1)
                  ENDIF
                  DO I=1, N
-                   IPOSINRHSCOMP = POSINRHSCOMP(I)
-                   IF (IPOSINRHSCOMP.GT.0) THEN
-                     RHS(I,JCOL_RHS) = RHSCOMP(IPOSINRHSCOMP,J)
+                   IPOSINRHSINTR = POSINRHSINTR(I)
+                   IF (IPOSINRHSINTR.GT.0) THEN
+                     RHS(I,JCOL_RHS) = RHSINTR(IPOSINRHSINTR,J)
                    ELSE
                      RHS(I,JCOL_RHS) = ZERO
                    ENDIF
@@ -1339,15 +1431,20 @@ C
             CALL MPI_UNPACK(BUFFER, SIZE_BUF_BYTES, POS_BUF,
      &                 CWORK, NPIV, MPI_DOUBLE_PRECISION,
      &                 COMM, IERR)
+#if defined(USE_OLD_SCALING)
             IF (LSCAL) THEN
               DO I=1,NPIV
                 RHS(IROWlist(I),JCOL_RHS)=CWORK(I)*SCALING(IROWlist(I))
               ENDDO
             ELSE
+#else
+#endif
               DO I=1,NPIV
                 RHS(IROWlist(I),JCOL_RHS)=CWORK(I)
               ENDDO
+#if defined(USE_OLD_SCALING)
             ENDIF
+#endif
           ENDDO
           N2RECV=N2RECV-NPIV
           CALL MPI_UNPACK( BUFFER, SIZE_BUF_BYTES, POS_BUF,
@@ -1361,11 +1458,11 @@ C
         SUBROUTINE DMUMPS_NPIV_BLOCK_ADD ( ON_MASTER )
         LOGICAL, intent(in) ::  ON_MASTER     
         INTEGER :: JPOS, K242
-        LOGICAL :: LOCAL_LSCAL
+        LOGICAL :: PRIV_LSCAL
         IF (ON_MASTER) THEN
         IF (KEEP(350).EQ.2
      &  .AND. (NRHS.EQ.1.OR.((NPIV*NRHS*2*KEEP(16)).GE.KEEP(364)))) THEN
-          LOCAL_LSCAL = LSCAL
+          PRIV_LSCAL = LSCAL
           K242 = KEEP(242)
           DO J=1, NRHS
             IF (K242.EQ.0) THEN
@@ -1375,53 +1472,67 @@ C
             ENDIF
             DO II=1,NPIV
               I=IW(J1+II-1)
-              IPOSINRHSCOMP= POSINRHSCOMP(I) 
-              IF (LOCAL_LSCAL) THEN
-                RHS(I,JPOS) = RHSCOMP(IPOSINRHSCOMP,J)*SCALING(I)
+              IPOSINRHSINTR= POSINRHSINTR(I) 
+              IF (PRIV_LSCAL) THEN
+                RHS(I,JPOS) = RHSINTR(IPOSINRHSINTR,J)*
+#if defined(USE_OLD_SCALING)
+     &          SCALING(I)
+#else
+     &          SCALING_LOC_BWD(IPOSINRHSINTR)
+#endif
               ELSE
-                RHS(I,JPOS) = RHSCOMP(IPOSINRHSCOMP,J)
+                RHS(I,JPOS) = RHSINTR(IPOSINRHSINTR,J)
               ENDIF
             ENDDO
           ENDDO
         ELSE
          IF (KEEP(242).EQ.0) THEN
            IF (LSCAL) THEN
-            DO II=1,NPIV
+             DO II=1,NPIV
                 I=IW(J1+II-1)
-                IPOSINRHSCOMP= POSINRHSCOMP(I) 
+                IPOSINRHSINTR= POSINRHSINTR(I) 
                 DO J=1, NRHS
-                  RHS(I,J+JBEG_RHS-1) =
-     &               RHSCOMP(IPOSINRHSCOMP,J)*SCALING(I)
+                  RHS(I,J+JBEG_RHS-1) = RHSINTR(IPOSINRHSINTR,J)*
+#if defined(USE_OLD_SCALING)
+     &            SCALING(I)
+#else
+     &            SCALING_LOC_BWD(IPOSINRHSINTR)
+#endif
                 ENDDO
-            ENDDO
+             ENDDO
            ELSE
-            DO II=1,NPIV
+             DO II=1,NPIV
                 I=IW(J1+II-1)
-                IPOSINRHSCOMP= POSINRHSCOMP(I)
+                IPOSINRHSINTR= POSINRHSINTR(I)
                 DO J=1, NRHS
-                  RHS(I,J+JBEG_RHS-1) = RHSCOMP(IPOSINRHSCOMP,J)
+                  RHS(I,J+JBEG_RHS-1) = RHSINTR(IPOSINRHSINTR,J)
                 ENDDO
-            ENDDO
+             ENDDO
            ENDIF
          ELSE
            IF (LSCAL) THEN
               DO II=1,NPIV
                 I=IW(J1+II-1)
-                IPOSINRHSCOMP= POSINRHSCOMP(I)
+                IPOSINRHSINTR= POSINRHSINTR(I)
 !DIR$ NOVECTOR
                 DO J=1, NRHS
                   RHS(I,PERM_RHS(J+JBEG_RHS-1)) =
-     &               RHSCOMP(IPOSINRHSCOMP,J)*SCALING(I)
+     &               RHSINTR(IPOSINRHSINTR,J)*
+#if defined(USE_OLD_SCALING)
+     &               SCALING(I)
+#else
+     &               SCALING_LOC_BWD(IPOSINRHSINTR)
+#endif
                 ENDDO
               ENDDO
            ELSE
               DO II=1,NPIV
                 I=IW(J1+II-1)
-                IPOSINRHSCOMP= POSINRHSCOMP(I)
+                IPOSINRHSINTR= POSINRHSINTR(I)
 !DIR$ NOVECTOR
                 DO J=1, NRHS
                   RHS(I,PERM_RHS(J+JBEG_RHS-1)) =
-     &               RHSCOMP(IPOSINRHSCOMP,J)
+     &               RHSINTR(IPOSINRHSINTR,J)
                 ENDDO
               ENDDO
            ENDIF
@@ -1433,9 +1544,17 @@ C
      &                SIZE_BUF_BYTES, POS_BUF, COMM, IERR )
         CALL MPI_PACK(IW(J1), NPIV, MPI_INTEGER, BUFFER,
      &                SIZE_BUF_BYTES, POS_BUF, COMM, IERR )
-        IPOSINRHSCOMP= POSINRHSCOMP(IW(J1)) 
+        IPOSINRHSINTR= POSINRHSINTR(IW(J1)) 
         DO J=1,NRHS
-          CALL MPI_PACK(RHSCOMP(IPOSINRHSCOMP,J), NPIV,
+#if ! defined(USE_OLD_SCALING)
+          IF (LSCAL) THEN
+            DO II=IPOSINRHSINTR, IPOSINRHSINTR+NPIV-1
+              RHSINTR(II,J)=
+     &        RHSINTR(II,J)*SCALING_LOC_BWD(II)
+            ENDDO
+          ENDIF
+#endif
+          CALL MPI_PACK(RHSINTR(IPOSINRHSINTR,J), NPIV,
      &              MPI_DOUBLE_PRECISION,
      &              BUFFER, SIZE_BUF_BYTES, POS_BUF, COMM,
      &              IERR)
@@ -1459,38 +1578,47 @@ C
         END SUBROUTINE DMUMPS_NPIV_BLOCK_SEND
       END SUBROUTINE DMUMPS_GATHER_SOLUTION
       SUBROUTINE DMUMPS_GATHER_SOLUTION_AM1(NSLAVES, N, MYID, COMM,
-     &           NRHS, RHSCOMP,  LRHSCOMP, NRHSCOMP_COL,
+     &           NRHS, RHSINTR,  LRHSINTR, NRHSINTR_COL,
      &           KEEP, BUFFER,
      &           SIZE_BUF, SIZE_BUF_BYTES, 
+#if defined(USE_OLD_SCALING)
      &           LSCAL, SCALING, LSCALING,
+#else
+     &           LSCAL, SCALING_LOC_BWD, LSCALING_LOC_BWD, 
+#endif
      &          IRHS_PTR_COPY, LIRHS_PTR_COPY, 
      &          IRHS_SPARSE_COPY, LIRHS_SPARSE_COPY,
      &          RHS_SPARSE_COPY, LRHS_SPARSE_COPY,
      &          UNS_PERM_INV, LUNS_PERM_INV,
-     &          POSINRHSCOMP, LPOS_ROW, NB_FS_IN_RHSCOMP )
+     &          POSINRHSINTR, LPOS_ROW, NB_FS_IN_RHSINTR )
       IMPLICIT NONE
       INCLUDE 'mpif.h'
       INCLUDE 'mumps_tags.h'
       INTEGER NSLAVES, N, MYID, COMM
-      INTEGER NRHS, LRHSCOMP, NRHSCOMP_COL 
-      DOUBLE PRECISION, intent(in) :: RHSCOMP (LRHSCOMP, NRHSCOMP_COL)
+      INTEGER NRHS, LRHSINTR, NRHSINTR_COL 
+      DOUBLE PRECISION, intent(in) :: RHSINTR (LRHSINTR, NRHSINTR_COL)
       INTEGER KEEP(500)
       INTEGER SIZE_BUF, SIZE_BUF_BYTES, LPOS_ROW
       INTEGER BUFFER(SIZE_BUF)
       INTEGER, intent(in) :: LIRHS_PTR_COPY, LIRHS_SPARSE_COPY, 
      &                       LRHS_SPARSE_COPY, LUNS_PERM_INV, 
-     &                       NB_FS_IN_RHSCOMP
+     &                       NB_FS_IN_RHSINTR
       INTEGER :: IRHS_SPARSE_COPY(LIRHS_SPARSE_COPY), 
      &           IRHS_PTR_COPY(LIRHS_PTR_COPY), 
      &           UNS_PERM_INV(LUNS_PERM_INV), 
-     &           POSINRHSCOMP(LPOS_ROW) 
+     &           POSINRHSINTR(LPOS_ROW) 
       DOUBLE PRECISION :: RHS_SPARSE_COPY(LRHS_SPARSE_COPY)
-      LOGICAL, intent(in) :: LSCAL
+#if defined(USE_OLD_SCALING)
       INTEGER, intent(in) :: LSCALING
       DOUBLE PRECISION, intent(in)    :: SCALING(LSCALING)
+#else
+      INTEGER, intent(in) :: LSCALING_LOC_BWD
+      DOUBLE PRECISION, intent(in) :: SCALING_LOC_BWD(LSCALING_LOC_BWD)
+#endif
+      LOGICAL, intent(in) :: LSCAL
       INTEGER COLSIZE, K, IZ, IPREV, NBCOL_INBLOC
       INTEGER I, II, J, MASTER,
-     &         TYPE_PARAL, N2RECV, IPOSINRHSCOMP
+     &         TYPE_PARAL, N2RECV, IPOSINRHSINTR
       INTEGER :: STATUS(MPI_STATUS_SIZE)
       INTEGER :: IERR
       PARAMETER(MASTER=0)
@@ -1510,15 +1638,20 @@ C
            DO IZ=IRHS_PTR_COPY(J), IRHS_PTR_COPY(J+1)-1
              I = IRHS_SPARSE_COPY(IZ)
              IF (KEEP(23).NE.0) I = UNS_PERM_INV(I)
-             IPOSINRHSCOMP = POSINRHSCOMP(I)
-             IF (IPOSINRHSCOMP.GT.0) THEN 
+             IPOSINRHSINTR = POSINRHSINTR(I)
+             IF (IPOSINRHSINTR.GT.0) THEN 
                 IF (LSCAL) THEN
-                 RHS_SPARSE_COPY(IZ)=
-     &                      RHSCOMP(IPOSINRHSCOMP,K)*SCALING(I)
+                  RHS_SPARSE_COPY(IZ)=
+     &                      RHSINTR(IPOSINRHSINTR,K)
+#if defined(USE_OLD_SCALING)
+     &                      * SCALING(I)
+#else
+     &                      * SCALING_LOC_BWD(IPOSINRHSINTR)
+#endif
                 ELSE
-                 RHS_SPARSE_COPY(IZ)=RHSCOMP(IPOSINRHSCOMP,K)
+                  RHS_SPARSE_COPY(IZ)=RHSINTR(IPOSINRHSINTR,K)
                 ENDIF
-             ENDIF          
+             ENDIF
            ENDDO
            K = K + 1
         ENDDO
@@ -1532,9 +1665,18 @@ C
            DO IZ=IRHS_PTR_COPY(J), IRHS_PTR_COPY(J+1)-1
              I = IRHS_SPARSE_COPY(IZ)
              IF (KEEP(23).NE.0) I = UNS_PERM_INV(I)
-             IPOSINRHSCOMP = POSINRHSCOMP(I)
-             IF (IPOSINRHSCOMP.GT.0) THEN 
-               RHS_SPARSE_COPY(IZ)=RHSCOMP(IPOSINRHSCOMP,K)
+             IPOSINRHSINTR = POSINRHSINTR(I)
+             IF (IPOSINRHSINTR.GT.0) THEN 
+#if ! defined(USE_OLD_SCALING)
+               IF (LSCAL) THEN
+                 RHS_SPARSE_COPY(IZ)=RHSINTR(IPOSINRHSINTR,K)
+     &           * SCALING_LOC_BWD(IPOSINRHSINTR)
+               ELSE
+#endif
+                 RHS_SPARSE_COPY(IZ)=RHSINTR(IPOSINRHSINTR,K)
+#if ! defined(USE_OLD_SCALING)
+               ENDIF
+#endif
              ENDIF          
            ENDDO
            K = K + 1
@@ -1566,19 +1708,25 @@ C
              I = IRHS_SPARSE_COPY(IZ)
              II = I
              IF  (KEEP(23).NE.0) II = UNS_PERM_INV(I)
-             IPOSINRHSCOMP = POSINRHSCOMP(II)
-             IF (IPOSINRHSCOMP.GT.0) THEN
+             IPOSINRHSINTR = POSINRHSINTR(II)
+             IF (IPOSINRHSINTR.GT.0) THEN
                IF (MYID .EQ. MASTER) THEN
                   N2RECV=N2RECV-1
+#if defined(USE_OLD_SCALING)
                   IF (LSCAL) 
      &            CALL DMUMPS_AM1_BLOCK_ADD ( .TRUE. )
+#endif
                   IRHS_SPARSE_COPY( IRHS_PTR_COPY(J) + K) =
      &               I
                   RHS_SPARSE_COPY( IRHS_PTR_COPY(J) + K) =
      &                RHS_SPARSE_COPY(IZ)
                   K = K+1 
                ELSE
-                  CALL DMUMPS_AM1_BLOCK_ADD (  .FALSE. )
+#if defined(USE_OLD_SCALING)
+                  CALL DMUMPS_AM1_BLOCK_ADD ( .FALSE. )
+#else
+                  CALL DMUMPS_AM1_BLOCK_ADD ()
+#endif
                ENDIF
               ENDIF          
             ENDDO
@@ -1603,10 +1751,12 @@ C
           CALL MPI_UNPACK(BUFFER, SIZE_BUF_BYTES, POS_BUF,
      &             RHS_SPARSE_COPY(IZ), 1, MPI_DOUBLE_PRECISION,
      &             COMM, IERR)
+#if defined(USE_OLD_SCALING)
           IF (LSCAL) THEN
               IF (KEEP(23).NE.0) I = UNS_PERM_INV(I)
               RHS_SPARSE_COPY(IZ) = RHS_SPARSE_COPY(IZ)*SCALING(I)    
           ENDIF
+#endif
           N2RECV=N2RECV-1
           IRHS_PTR_COPY(J) = IRHS_PTR_COPY(J) + 1
           CALL MPI_UNPACK( BUFFER, SIZE_BUF_BYTES, POS_BUF,
@@ -1622,10 +1772,21 @@ C
       ENDIF
       RETURN
       CONTAINS
-        SUBROUTINE DMUMPS_AM1_BLOCK_ADD ( SCALE_ONLY )
+        SUBROUTINE DMUMPS_AM1_BLOCK_ADD (
+#if defined(USE_OLD_SCALING)
+     &                                    SCALE_ONLY 
+#endif
+     &                                               )
+#if defined(USE_OLD_SCALING)
         LOGICAL, intent(in) ::  SCALE_ONLY    
+#endif
+#if defined(USE_OLD_SCALING)
         INTEGER III
+#endif
+#if defined(USE_OLD_SCALING)
         IF (SCALE_ONLY) THEN
+          WRITE(*,*) "DMUMPS_AM1_BLOCK_ADD(true) should not be called"
+          CALL MUMPS_ABORT()
          III = I
          IF (KEEP(23).NE.0) III = UNS_PERM_INV(I)
          IF (LSCAL) THEN
@@ -1633,6 +1794,7 @@ C
          ENDIF
          RETURN
         ENDIF
+#endif
         CALL MPI_PACK(J, 1, MPI_INTEGER, BUFFER,
      &                SIZE_BUF_BYTES, POS_BUF, COMM, IERR )
         CALL MPI_PACK(I, 1, MPI_INTEGER, BUFFER,
@@ -1661,8 +1823,11 @@ C
       SUBROUTINE DMUMPS_DISTSOL_INDICES(MTYPE, ISOL_LOC,
      &             PTRIST, KEEP,KEEP8,
      &             IW, LIW_PASSED, MYID_NODES, N, STEP,
-     &             PROCNODE, NSLAVES, scaling_data, LSCAL
-     &             , IRHS_loc_MEANINGFUL, IRHS_loc, Nloc_RHS
+     &             PROCNODE, NSLAVES,
+#if defined(USE_OLD_SCALING)
+     &             scaling_data, LSCAL,
+#endif
+     &             IRHS_loc_MEANINGFUL, IRHS_loc, Nloc_RHS
      &             )
       IMPLICIT NONE
       INTEGER MTYPE, MYID_NODES, N, NSLAVES
@@ -1673,16 +1838,21 @@ C
       INTEGER LIW_PASSED
       INTEGER IW(LIW_PASSED)
       INTEGER STEP(N)
+#if defined(USE_OLD_SCALING)
       LOGICAL LSCAL
+#endif
       LOGICAL :: IRHS_loc_MEANINGFUL
       INTEGER :: Nloc_RHS
       INTEGER :: IRHS_loc(Nloc_RHS)
+#if defined(USE_OLD_SCALING)
       type scaling_data_t
         SEQUENCE
         DOUBLE PRECISION, dimension(:), pointer :: SCALING
         DOUBLE PRECISION, dimension(:), pointer :: SCALING_LOC
+        INTEGER, dimension(:), pointer :: SCALING_IND 
       end type scaling_data_t
       type (scaling_data_t) :: scaling_data
+#endif
       INTEGER MUMPS_PROCNODE
       EXTERNAL MUMPS_PROCNODE
       INTEGER ISTEP, K
@@ -1720,49 +1890,103 @@ C
                     ENDIF
                   ENDIF
                   ISOL_LOC(K)=IW(JJ)
+#if defined(USE_OLD_SCALING)
                   IF (LSCAL) THEN
                     scaling_data%SCALING_LOC(K)=
      &              scaling_data%SCALING(IW(JJ))
                   ENDIF
+#endif
               ENDDO
           ENDIF
       ENDDO
       RETURN
       END SUBROUTINE DMUMPS_DISTSOL_INDICES
+#if ! defined(USE_OLD_SCALING)
+      SUBROUTINE DMUMPS_SCALINGRHSINTR(LSCAL, N,
+     &           SCALING_LOC, SCALING_RHSINTR,
+     &           L, POSINRHSINTR, KEEP, ROWORCOL, PTRIST,
+     &           IW, LIW_PASSED, MYID_NODES, STEP,
+     &           PROCNODE, NSLAVES)
+      IMPLICIT NONE
+      INTEGER              :: KEEP(500)
+      LOGICAL, INTENT(IN)  :: LSCAL
+      INTEGER, INTENT(IN)  :: N, L
+      INTEGER, INTENT(IN)  :: POSINRHSINTR(N)
+      DOUBLE PRECISION   , INTENT(IN)  :: SCALING_LOC(max(KEEP(89),1))
+      DOUBLE PRECISION   , INTENT(OUT) :: SCALING_RHSINTR(L)
+      INTEGER, INTENT(IN)  :: ROWORCOL, NSLAVES, LIW_PASSED, MYID_NODES
+      INTEGER, INTENT(IN)  :: STEP(KEEP(28)),
+     &                        PROCNODE(KEEP(28)),
+     &                        PTRIST(KEEP(28)),
+     &                        IW(LIW_PASSED)
+      INTEGER :: IPOSINRHSINTR
+      INTEGER, EXTERNAL :: MUMPS_PROCNODE
+      INTEGER :: ISTEP
+      INTEGER :: KLOC, J1, JJ, LIELL, IPOS, NPIV
+      IF (.NOT. LSCAL) THEN
+        WRITE(*,*) "Internal error 1 in DMUMPS_DS_SCALINGRHSINTR"
+        CALL MUMPS_ABORT()
+      ENDIF
+      IF (ROWORCOL .NE. 1 .AND. ROWORCOL.NE.2) THEN
+        WRITE(*,*) "Internal error 2 in DMUMPS_DS_SCALINGRHSINTR",
+     &  ROWORCOL
+      ENDIF
+      IF (KEEP(89).EQ.0) RETURN
+      KLOC = 1
+      DO ISTEP=1, KEEP(28)
+        IF ( MYID_NODES == MUMPS_PROCNODE( PROCNODE(ISTEP),
+     &               KEEP(199))) THEN
+          CALL MUMPS_SOL_GET_NPIV_LIELL_IPOS( ISTEP, KEEP,
+     &    NPIV, LIELL, IPOS, IW, LIW_PASSED, PTRIST, STEP, N)
+          IF (ROWORCOL .EQ. 1) THEN
+               J1=IPOS+1
+          ELSE
+               J1=IPOS+1+LIELL
+          END IF
+          IPOSINRHSINTR = POSINRHSINTR(IW(J1)) 
+          IF ( IPOSINRHSINTR .GT. 0 ) THEN
+            DO JJ=1, NPIV
+             SCALING_RHSINTR(IPOSINRHSINTR+JJ-1) =
+     &       SCALING_LOC(KLOC+JJ-1)
+            ENDDO
+          ENDIF
+          KLOC = KLOC + NPIV
+        ENDIF
+      ENDDO
+      RETURN
+      END SUBROUTINE DMUMPS_SCALINGRHSINTR
+#endif
       SUBROUTINE DMUMPS_DISTRIBUTED_SOLUTION(
      &           SLAVEF, N, MYID_NODES,
-     &           MTYPE, RHSCOMP, LRHSCOMP, NBRHS_EFF,
-     &           POSINRHSCOMP,
+     &           MTYPE, RHSINTR, LRHSINTR, NBRHS_EFF,
+     &           POSINRHSINTR,
      &           ISOL_LOC, 
      &           SOL_LOC, NRHS, BEG_RHS, LSOL_LOC,
      &           PTRIST,
      &           PROCNODE_STEPS, KEEP,KEEP8, IW, LIW, STEP,
-     &           scaling_data, LSCAL, NB_RHSSKIPPED,
+     &           SCALING_LOC_BWD, LSCALING_LOC_BWD,
+     &           LSCAL, NB_RHSSKIPPED,
      &           PERM_RHS, SIZE_PERM_RHS)
       IMPLICIT NONE
       INCLUDE 'mpif.h'
       INCLUDE 'mumps_tags.h'
-      type scaling_data_t
-        SEQUENCE
-        DOUBLE PRECISION, dimension(:), pointer :: SCALING
-        DOUBLE PRECISION, dimension(:), pointer :: SCALING_LOC
-      end type scaling_data_t
-      TYPE (scaling_data_t) :: scaling_data
-      LOGICAL LSCAL
-      INTEGER SLAVEF, N, MYID_NODES, LIW, MTYPE, NBRHS_EFF, LRHSCOMP
-      INTEGER POSINRHSCOMP(N), NB_RHSSKIPPED
+      LOGICAL, intent(in) :: LSCAL
+      INTEGER, intent(in) :: LSCALING_LOC_BWD
+      DOUBLE PRECISION, intent(in) :: SCALING_LOC_BWD(LSCALING_LOC_BWD)
+      INTEGER SLAVEF, N, MYID_NODES, LIW, MTYPE, NBRHS_EFF, LRHSINTR
+      INTEGER POSINRHSINTR(N), NB_RHSSKIPPED
       INTEGER LSOL_LOC, BEG_RHS
       INTEGER ISOL_LOC(LSOL_LOC)
       INTEGER, INTENT(in) :: NRHS 
       DOUBLE PRECISION SOL_LOC( LSOL_LOC, NRHS )
-      DOUBLE PRECISION RHSCOMP( LRHSCOMP, NBRHS_EFF )
+      DOUBLE PRECISION RHSINTR( LRHSINTR, NBRHS_EFF )
       INTEGER KEEP(500)
       INTEGER(8) KEEP8(150)
       INTEGER PTRIST(KEEP(28)), PROCNODE_STEPS(KEEP(28))
       INTEGER IW(LIW), STEP(N)
       INTEGER, INTENT(in) :: SIZE_PERM_RHS
       INTEGER, INTENT(in) :: PERM_RHS( SIZE_PERM_RHS )
-      INTEGER :: JJ, J1, ISTEP, K, KLOC, IPOSINRHSCOMP, JEMPTY
+      INTEGER :: JJ, J1, ISTEP, K, KLOC, IPOSINRHSINTR, JEMPTY
       INTEGER :: JCOL, JCOL_PERM
       INTEGER :: IPOS, LIELL, NPIV, JEND
       LOGICAL :: ROOT
@@ -1814,7 +2038,7 @@ C
             ENDIF
 !$            OMP_FLAG = ( JEND-JEMPTY.GE.KEEP(362) .AND.
 !$   &                     (NPIV*(JEND-JEMPTY) .GE. KEEP(363)/2 ) )
-!$OMP PARALLEL DO PRIVATE(JCOL,JCOL_PERM,KLOC,JJ,IPOSINRHSCOMP) 
+!$OMP PARALLEL DO PRIVATE(JCOL,JCOL_PERM,KLOC,JJ,IPOSINRHSINTR) 
 !$OMP&         IF(OMP_FLAG)
             DO JCOL = JEMPTY+1, JEND
               IF (KEEP(242) .NE. 0) THEN
@@ -1824,14 +2048,13 @@ C
               ENDIF
               DO JJ=J1,J1+NPIV-1
                  KLOC=K + JJ-J1 + 1
-                IPOSINRHSCOMP = POSINRHSCOMP(IW(JJ))
                 IF (LSCAL) THEN
                   SOL_LOC(KLOC,JCOL_PERM) =
-     &            scaling_data%SCALING_LOC(KLOC)*
-     &            RHSCOMP(IPOSINRHSCOMP,JCOL-JEMPTY)
+     &            SCALING_LOC_BWD(KLOC)*
+     &            RHSINTR(KLOC,JCOL-JEMPTY)
                 ELSE
                   SOL_LOC(KLOC,JCOL_PERM) =
-     &            RHSCOMP(IPOSINRHSCOMP,JCOL-JEMPTY)
+     &            RHSINTR(KLOC,JCOL-JEMPTY)
                 ENDIF
               ENDDO
             ENDDO
@@ -1843,9 +2066,10 @@ C
       END SUBROUTINE DMUMPS_DISTRIBUTED_SOLUTION
       SUBROUTINE DMUMPS_SCATTER_RHS
      &           (NSLAVES, N, MYID, COMM,
+     &           LSCAL, SCALING_LOC_FWD,
      &           MTYPE, RHS, LRHS, NCOL_RHS, NRHS,
-     &           RHSCOMP, LRHSCOMP, NCOL_RHSCOMP,
-     &           POSINRHSCOMP_FWD, NB_FS_IN_RHSCOMP_F,
+     &           RHSINTR, LRHSINTR, NCOL_RHSINTR,
+     &           POSINRHSINTR_FWD, NB_FS_IN_RHSINTR_F,
      &           PTRIST,
      &           KEEP,KEEP8, PROCNODE_STEPS, IW, LIW, STEP, 
      &           ICNTL, INFO)
@@ -1854,15 +2078,17 @@ C
       INCLUDE 'mpif.h'
       INCLUDE 'mumps_tags.h'
       INTEGER NSLAVES, N, MYID, COMM, LIW, MTYPE
-      INTEGER NRHS, LRHS, NCOL_RHS,  LRHSCOMP, NCOL_RHSCOMP
+      INTEGER NRHS, LRHS, NCOL_RHS,  LRHSINTR, NCOL_RHSINTR
       INTEGER ICNTL(60), INFO(80)
       DOUBLE PRECISION, intent(in)  :: RHS (LRHS, NCOL_RHS)
-      DOUBLE PRECISION, intent(out) :: RHSCOMP(LRHSCOMP, NCOL_RHSCOMP)
-      INTEGER, intent(in)  :: POSINRHSCOMP_FWD(N), NB_FS_IN_RHSCOMP_F
+      DOUBLE PRECISION, intent(out) :: RHSINTR(LRHSINTR, NCOL_RHSINTR)
+      INTEGER, intent(in)  :: POSINRHSINTR_FWD(N), NB_FS_IN_RHSINTR_F
       INTEGER KEEP(500)
       INTEGER(8) KEEP8(150)
       INTEGER PTRIST(KEEP(28)), PROCNODE_STEPS(KEEP(28))
       INTEGER IW(LIW), STEP(N) 
+      LOGICAL, intent(in) :: LSCAL
+      DOUBLE PRECISION, intent(in) :: SCALING_LOC_FWD(max(1,KEEP(89)))
       INTEGER BUF_MAXSIZE, BUF_MAXREF
       PARAMETER (BUF_MAXREF=200000)
       INTEGER, ALLOCATABLE, DIMENSION(:) :: BUF_INDX
@@ -1913,10 +2139,10 @@ C
       IF (MYID.EQ.MASTER) THEN
         ENTRIES_2_PROCESS = N - KEEP(89)
         IF (TYPE_PARAL.EQ.1.AND.ENTRIES_2_PROCESS.NE.0) THEN
-         IF (NB_FS_IN_RHSCOMP_F.LT.LRHSCOMP) THEN
-           DO K=1, NCOL_RHSCOMP
-            DO I = NB_FS_IN_RHSCOMP_F +1, LRHSCOMP
-             RHSCOMP (I, K) = ZERO
+         IF (NB_FS_IN_RHSINTR_F.LT.LRHSINTR) THEN
+           DO K=1, NCOL_RHSINTR
+            DO I = NB_FS_IN_RHSINTR_F +1, LRHSINTR
+             RHSINTR (I, K) = ZERO
             ENDDO
            ENDDO
          ENDIF
@@ -1973,10 +2199,10 @@ C
       ENDIF
       IF (I_AM_SLAVE) THEN
         IF (MYID.NE.MASTER) THEN
-         IF (NB_FS_IN_RHSCOMP_F.LT.LRHSCOMP) THEN
-           DO K=1, NCOL_RHSCOMP
-            DO I = NB_FS_IN_RHSCOMP_F +1, LRHSCOMP
-             RHSCOMP (I, K) = ZERO
+         IF (NB_FS_IN_RHSINTR_F.LT.LRHSINTR) THEN
+           DO K=1, NCOL_RHSINTR
+            DO I = NB_FS_IN_RHSINTR_F +1, LRHSINTR
+             RHSINTR (I, K) = ZERO
             ENDDO
            ENDDO
          ENDIF
@@ -1992,7 +2218,7 @@ C
                    J1=IPOS+1+LIELL
               END IF
               IF (MYID.EQ.MASTER) THEN
-                INDX = POSINRHSCOMP_FWD(IW(J1))
+                INDX = POSINRHSINTR_FWD(IW(J1))
                 IF (KEEP(350).EQ.2 .AND.
      &   (NRHS.EQ.1.OR.((NPIV*NRHS*2*KEEP(16)).GE.KEEP(364)))) THEN
 !$                 OMP_FLAG = .FALSE.
@@ -2001,22 +2227,53 @@ C
 !$                   OMP_FLAG = .TRUE.
 !$                   CHUNK = max((NPIV*NRHS+NOMP-1)/NOMP,KEEP(363)/2)
 !$                 ENDIF
+#if ! defined(USE_OLD_SCALING)
+                  IF (LSCAL) THEN
+!$OMP PARALLEL DO COLLAPSE(2) SCHEDULE(STATIC,CHUNK) PRIVATE(J,JJ)
+!$OMP&  FIRSTPRIVATE(INDX) IF (OMP_FLAG)
+                     DO K = 1, NRHS
+                       DO JJ=J1,J1+NPIV-1
+                         J=IW(JJ)
+                         RHSINTR( INDX+JJ-J1, K ) = RHS( J, K ) *
+     &                   SCALING_LOC_FWD( INDX+JJ-J1 )
+                       ENDDO
+                     ENDDO
+!$OMP END PARALLEL DO
+                  ELSE
+#endif
 !$OMP PARALLEL DO COLLAPSE(2) SCHEDULE(STATIC,CHUNK) PRIVATE(J,JJ)
 !$OMP&  FIRSTPRIVATE(INDX) IF (OMP_FLAG)
-                   DO K = 1, NRHS
+                    DO K = 1, NRHS
                       DO JJ=J1,J1+NPIV-1
                          J=IW(JJ)
-                         RHSCOMP( INDX+JJ-J1, K ) = RHS( J, K )
+                         RHSINTR( INDX+JJ-J1, K ) = RHS( J, K )
                       ENDDO
-                   ENDDO
+                    ENDDO
 !$OMP END PARALLEL DO
+#if ! defined(USE_OLD_SCALING)
+                  ENDIF
+#endif
                 ELSE 
+#if ! defined(USE_OLD_SCALING)
+                  IF (LSCAL) THEN
+                   DO JJ=J1,J1+NPIV-1
+                      J=IW(JJ)
+                      DO K = 1, NRHS
+                         RHSINTR( INDX+JJ-J1, K ) = RHS( J, K )
+     &                 * SCALING_LOC_FWD( INDX + JJ - J1 )
+                      ENDDO
+                   ENDDO
+                  ELSE
+#endif
                    DO JJ=J1,J1+NPIV-1
                       J=IW(JJ)
                       DO K = 1, NRHS
-                         RHSCOMP( INDX+JJ-J1, K ) = RHS( J, K )
+                         RHSINTR( INDX+JJ-J1, K ) = RHS( J, K )
                       ENDDO
                    ENDDO
+#if ! defined(USE_OLD_SCALING)
+                  ENDIF
+#endif
                 END IF 
               ELSE
                 DO JJ=J1,J1+NPIV-1
@@ -2053,40 +2310,72 @@ C
 !$                    OMP_FLAG = .TRUE.
 !$              CHUNK = max((BUF_EFFSIZE*NRHS+NOMP-1)/NOMP,KEEP(363)/2)
 !$                  ENDIF
+#if ! defined(USE_OLD_SCALING)
+                    IF (LSCAL) THEN
 !$OMP PARALLEL DO COLLAPSE(2) SCHEDULE(STATIC,CHUNK) PRIVATE(INDX)
 !$OMP&  IF (OMP_FLAG)
-                    DO K = 1, NRHS
+                      DO K = 1, NRHS
                         DO I = 1, BUF_EFFSIZE
-                           INDX = POSINRHSCOMP_FWD(BUF_INDX(I))
-                           RHSCOMP( INDX, K ) =
-     &                              BUF_RHS_2( I+(K-1)*BUF_EFFSIZE)
+                           INDX = POSINRHSINTR_FWD(BUF_INDX(I))
+                          RHSINTR( INDX, K ) =
+     &                           BUF_RHS_2( I+(K-1)*BUF_EFFSIZE) *
+     &                           SCALING_LOC_FWD( INDX )
                         ENDDO
-                     ENDDO
+                      ENDDO
+!$OMP END PARALLEL DO
+                    ELSE
+#endif
+!$OMP PARALLEL DO COLLAPSE(2) SCHEDULE(STATIC,CHUNK) PRIVATE(INDX)
+!$OMP&  IF (OMP_FLAG)
+                      DO K = 1, NRHS
+                        DO I = 1, BUF_EFFSIZE
+                           INDX = POSINRHSINTR_FWD(BUF_INDX(I))
+                          RHSINTR( INDX, K ) =
+     &                           BUF_RHS_2( I+(K-1)*BUF_EFFSIZE)
+                        ENDDO
+                      ENDDO
 !$OMP END PARALLEL DO
+#if ! defined(USE_OLD_SCALING)
+                    ENDIF
+#endif
                    ELSE
                      CALL MPI_RECV(BUF_RHS, BUF_EFFSIZE*NRHS,
      &                 MPI_DOUBLE_PRECISION,
      &                 MASTER,
      &                 ScatterRhsR, COMM, STATUS, IERR )
+#if ! defined(USE_OLD_SCALING)
+                     IF (LSCAL) THEN
+                     DO I = 1, BUF_EFFSIZE
+                        INDX = POSINRHSINTR_FWD(BUF_INDX(I))
+                        DO K = 1, NRHS
+                           RHSINTR( INDX, K ) = BUF_RHS( K, I )
+     &                     * SCALING_LOC_FWD( INDX )
+                        ENDDO
+                     ENDDO
+                     ELSE
+#endif
                      DO I = 1, BUF_EFFSIZE
-                        INDX = POSINRHSCOMP_FWD(BUF_INDX(I))
+                        INDX = POSINRHSINTR_FWD(BUF_INDX(I))
                         DO K = 1, NRHS
-                           RHSCOMP( INDX, K ) = BUF_RHS( K, I )
+                           RHSINTR( INDX, K ) = BUF_RHS( K, I )
                         ENDDO
                      ENDDO
+#if ! defined(USE_OLD_SCALING)
+                     ENDIF
+#endif
                   END IF 
                   BUF_EFFSIZE = 0
                   RETURN
                   END SUBROUTINE DMUMPS_GET_BUF_INDX_RHS
       END SUBROUTINE DMUMPS_SCATTER_RHS
-      SUBROUTINE DMUMPS_BUILD_POSINRHSCOMP
+      SUBROUTINE DMUMPS_BUILD_GLOB2LOC
      &           (NSLAVES, N, MYID_NODES,
      &           PTRIST,
      &           KEEP,KEEP8, PROCNODE_STEPS, IW, LIW, STEP, 
-     &           POSINRHSCOMP_ROW, POSINRHSCOMP_COL,
-     &           POSINRHSCOMP_COL_ALLOC,
+     &           GLOB2LOC_RHS, GLOB2LOC_SOL,
+     &           GLOB2LOC_SOL_ALLOC,
      &           MTYPE,
-     &           NBENT_RHSCOMP, NB_FS_IN_RHSCOMP )
+     &           NBENT_RHSINTR, NB_FS_IN_RHSINTR )
       IMPLICIT NONE
       INCLUDE 'mpif.h'
       INCLUDE 'mumps_tags.h'
@@ -2096,20 +2385,20 @@ C
       INTEGER, intent(in) :: PTRIST(KEEP(28)), PROCNODE_STEPS(KEEP(28))
       INTEGER, intent(in) :: IW(LIW), STEP(N)
       INTEGER, intent(in) :: MTYPE 
-      LOGICAL, intent(in) :: POSINRHSCOMP_COL_ALLOC
-      INTEGER, intent(out):: POSINRHSCOMP_ROW(N),POSINRHSCOMP_COL(N) 
-      INTEGER, intent(out):: NBENT_RHSCOMP, NB_FS_IN_RHSCOMP
+      LOGICAL, intent(in) :: GLOB2LOC_SOL_ALLOC
+      INTEGER, intent(out):: GLOB2LOC_RHS(N), GLOB2LOC_SOL(N) 
+      INTEGER, intent(out):: NBENT_RHSINTR, NB_FS_IN_RHSINTR
       INTEGER ISTEP
       INTEGER NPIV
       INTEGER IPOS, LIELL
       INTEGER JJ, J1, JCOL
-      INTEGER IPOSINRHSCOMP, IPOSINRHSCOMP_COL
+      INTEGER IPOSINRHSINTR, IPOSINRHSINTR_SOL
       INCLUDE 'mumps_headers.h'
       INTEGER MUMPS_PROCNODE
       EXTERNAL MUMPS_PROCNODE
-      POSINRHSCOMP_ROW = 0
-      IF (POSINRHSCOMP_COL_ALLOC) POSINRHSCOMP_COL = 0
-      IPOSINRHSCOMP   = 1     
+      GLOB2LOC_RHS = 0
+      IF (GLOB2LOC_SOL_ALLOC) GLOB2LOC_SOL = 0
+      IPOSINRHSINTR   = 1     
       DO ISTEP = 1, KEEP(28)
         IF (MYID_NODES == MUMPS_PROCNODE(PROCNODE_STEPS(ISTEP),
      &     KEEP(199))) THEN
@@ -2126,19 +2415,19 @@ C
                    JCOL = IPOS+1
            ENDIF
            DO JJ = J1, J1+NPIV-1
-                POSINRHSCOMP_ROW(IW(JJ)) = IPOSINRHSCOMP+JJ-J1
+                GLOB2LOC_RHS(IW(JJ)) = IPOSINRHSINTR+JJ-J1
            ENDDO
-           IF (POSINRHSCOMP_COL_ALLOC) THEN
+           IF (GLOB2LOC_SOL_ALLOC) THEN
              DO JJ = JCOL, JCOL+NPIV-1
-               POSINRHSCOMP_COL(IW(JJ)) = IPOSINRHSCOMP+JJ-JCOL
+               GLOB2LOC_SOL(IW(JJ)) = IPOSINRHSINTR+JJ-JCOL
              ENDDO
            ENDIF
-           IPOSINRHSCOMP       = IPOSINRHSCOMP + NPIV
+           IPOSINRHSINTR       = IPOSINRHSINTR + NPIV
         ENDIF
       ENDDO
-      NB_FS_IN_RHSCOMP = IPOSINRHSCOMP -1
-      IF (POSINRHSCOMP_COL_ALLOC) IPOSINRHSCOMP_COL=IPOSINRHSCOMP
-      IF (IPOSINRHSCOMP.GT.N) GOTO 500 
+      NB_FS_IN_RHSINTR = IPOSINRHSINTR -1
+      IF (GLOB2LOC_SOL_ALLOC) IPOSINRHSINTR_SOL=IPOSINRHSINTR
+      IF (IPOSINRHSINTR.GT.N) GOTO 500 
       DO ISTEP = 1, KEEP(28)
         IF (MYID_NODES == MUMPS_PROCNODE(PROCNODE_STEPS(ISTEP),
      &     KEEP(199))) THEN
@@ -2154,92 +2443,267 @@ C
            ELSE
                    JCOL = IPOS+1
            ENDIF
-           IF (POSINRHSCOMP_COL_ALLOC) THEN
+           IF (GLOB2LOC_SOL_ALLOC) THEN
             DO JJ = NPIV, LIELL-1-KEEP(253)
-              IF (POSINRHSCOMP_ROW(IW(J1+JJ)).EQ.0) THEN
-               POSINRHSCOMP_ROW(IW(J1+JJ)) = - IPOSINRHSCOMP
-               IPOSINRHSCOMP = IPOSINRHSCOMP + 1
-              ENDIF
-              IF (POSINRHSCOMP_COL(IW(JCOL+JJ)).EQ.0) THEN
-               POSINRHSCOMP_COL(IW(JCOL+JJ)) = - IPOSINRHSCOMP_COL
-               IPOSINRHSCOMP_COL = IPOSINRHSCOMP_COL + 1
+              IF (GLOB2LOC_RHS(IW(J1+JJ)).EQ.0) THEN
+               GLOB2LOC_RHS(IW(J1+JJ)) = - IPOSINRHSINTR
+               IPOSINRHSINTR = IPOSINRHSINTR + 1
+              ENDIF
+              IF (GLOB2LOC_SOL(IW(JCOL+JJ)).EQ.0) THEN
+               GLOB2LOC_SOL(IW(JCOL+JJ)) = - IPOSINRHSINTR_SOL
+               IPOSINRHSINTR_SOL = IPOSINRHSINTR_SOL + 1
               ENDIF
              ENDDO
            ELSE
              DO JJ = J1+NPIV, J1+LIELL-1-KEEP(253)
-              IF (POSINRHSCOMP_ROW(IW(JJ)).EQ.0) THEN
-               POSINRHSCOMP_ROW(IW(JJ)) = - IPOSINRHSCOMP
-               IPOSINRHSCOMP = IPOSINRHSCOMP + 1
+              IF (GLOB2LOC_RHS(IW(JJ)).EQ.0) THEN
+               GLOB2LOC_RHS(IW(JJ)) = - IPOSINRHSINTR
+               IPOSINRHSINTR = IPOSINRHSINTR + 1
               ENDIF
              ENDDO
            ENDIF
         ENDIF
       ENDDO
- 500  NBENT_RHSCOMP = IPOSINRHSCOMP - 1
-      IF (POSINRHSCOMP_COL_ALLOC) 
-     &     NBENT_RHSCOMP = max(NBENT_RHSCOMP, IPOSINRHSCOMP_COL-1)
+ 500  NBENT_RHSINTR = IPOSINRHSINTR - 1
+      IF (GLOB2LOC_SOL_ALLOC) 
+     &     NBENT_RHSINTR = max(NBENT_RHSINTR, IPOSINRHSINTR_SOL-1)
       RETURN
-      END SUBROUTINE DMUMPS_BUILD_POSINRHSCOMP
-      SUBROUTINE DMUMPS_BUILD_POSINRHSCOMP_AM1
-     &           (NSLAVES, N, MYID_NODES,
+      END SUBROUTINE DMUMPS_BUILD_GLOB2LOC
+      SUBROUTINE DMUMPS_NODES_FWD_BWD_SIZE_FILL (
+     &           fill, ICNTL,
+     &           N, NSTEPS, KEEP, STEP, Step2node,
+     &           IRHS_loc, Nloc_RHS, 
+     &           IRHS_PTR, NBCOL_INBLOC, IRHS_SPARSE, NZ_RHS,
+     &           PERM_RHS, SIZE_PERM_RHS, JBEG_RHS,
+     &           UNS_PERM_INV, SIZE_UNS_PERM_INV,
+     &           ICNTL21, 
+     &           MYID, COMM,
+     &           INFO, 
+     &           Pruned_Sons_FWD, Pruned_Sons_BWD, 
+     &           Lnodes_FWD, Lnodes_BWD
+     &           , nodes_FWD, nodes_BWD
+     &           , Lnodes_FWD_in, Lnodes_BWD_in
+     &           )
+      USE DMUMPS_SOL_ES, ONLY : DMUMPS_ES_NODES_SIZE_AND_FILL
+      IMPLICIT NONE
+      LOGICAL, INTENT(IN)  :: fill
+      INTEGER, INTENT(IN)  :: ICNTL(60),N, NSTEPS, KEEP(500) 
+      INTEGER, INTENT(IN)  :: STEP(N), Step2node(NSTEPS)
+      INTEGER, INTENT(IN)  :: Nloc_RHS, 
+     &                        IRHS_loc(max(1,Nloc_RHS))
+      INTEGER, intent(in) :: NBCOL_INBLOC, IRHS_PTR(NBCOL_INBLOC+1)
+      INTEGER, intent(in) :: NZ_RHS, IRHS_SPARSE(NZ_RHS)
+      INTEGER, intent(in) :: SIZE_PERM_RHS, PERM_RHS(SIZE_PERM_RHS)
+      INTEGER, intent(in) :: JBEG_RHS, SIZE_UNS_PERM_INV
+      INTEGER, intent(in) :: UNS_PERM_INV(SIZE_UNS_PERM_INV)
+      INTEGER, intent(IN)  :: ICNTL21
+      INTEGER, intent(in)  :: MYID, COMM
+      INTEGER, intent(inout) :: INFO(80)
+      INTEGER, intent(inout) :: Pruned_Sons_FWD(NSTEPS), 
+     &                          Pruned_Sons_BWD(NSTEPS)
+      INTEGER, intent(inout) :: Lnodes_FWD, Lnodes_BWD
+      INTEGER, intent(in) :: Lnodes_FWD_in, Lnodes_BWD_in
+      INTEGER, intent(out) :: nodes_FWD(Lnodes_FWD_in), 
+     &                        nodes_BWD(Lnodes_BWD_in)
+      INCLUDE 'mpif.h'
+      LOGICAL :: DO_PRUN_FWD, AM1, Exploit_Sparsity_FWD, 
+     &           Exploit_Sparsity_BWD
+      INTEGER :: Lnodes_FWD_loc, Lnodes_BWD_loc, ISTEP,
+     &           INODE_PRINC, I, II, JAM1
+#if defined(AVOID_MPI_IN_PLACE)
+      INTEGER, DIMENSION(:), ALLOCATABLE ::  TMP_INT_ARRAY
+#endif
+#if defined(AVOID_MPI_IN_PLACE)
+      ALLOCATE(TMP_INT_ARRAY(KEEP(28)), STAT = allocok)
+      IF(allocok.GT.0) THEN
+        INFO(1)=-13
+        INFO(2)=KEEP(28)
+      END IF
+      CALL MUMPS_PROPINFO(ICNTL, INFO, COMM, MYID )
+      IF(INFO(1).LT.0) GOTO 500
+#endif
+      AM1                  = (KEEP(237) .NE. 0)
+      Exploit_Sparsity_FWD = (KEEP(235) .NE. 0) .AND. (.NOT. AM1)
+      DO_PRUN_FWD          = (Exploit_Sparsity_FWD.OR.AM1)
+      Exploit_Sparsity_BWD = (KEEP(212) .NE. 0) .AND. (.NOT. AM1)
+      IF (.NOT.fill) Lnodes_FWD=-1
+      IF (.NOT.fill) Lnodes_BWD=-1
+      IF (.NOT.fill.AND.KEEP(252).NE.0) THEN
+        Lnodes_FWD = 0
+      ENDIF
+      IF ( KEEP(252).NE.0 ) DO_PRUN_FWD = .FALSE.  
+      IF ( DO_PRUN_FWD ) THEN
+        IF ( Exploit_Sparsity_FWD.AND.KEEP(248).EQ.-1 ) THEN
+         IF (.NOT.fill) THEN
+           CALL DMUMPS_ES_NODES_SIZE_AND_FILL ( fill,
+     &           N, KEEP(28), KEEP, STEP, Step2node,
+     &           IRHS_loc, Nloc_RHS, MYID, COMM,
+     &           Pruned_Sons_FWD, Lnodes_FWD 
+#if defined(AVOID_MPI_IN_PLACE)
+     &           , TMP_INT_ARRAY
+#endif
+     &           )
+         ELSE IF (Lnodes_FWD.GT.0) THEN
+            CALL DMUMPS_ES_NODES_SIZE_AND_FILL ( fill,
+     &           N, KEEP(28), KEEP, STEP, Step2node,
+     &           IRHS_loc, Nloc_RHS, MYID, COMM,
+     &           Pruned_Sons_FWD, Lnodes_FWD, 
+#if defined(AVOID_MPI_IN_PLACE)
+     &            TMP_INT_ARRAY, 
+#endif
+     &           nodes_FWD
+     &           )
+         ENDIF
+        ELSE IF ( Exploit_Sparsity_FWD.AND.KEEP(248).NE.-1 ) THEN
+           IF (.NOT.fill) THEN
+            Lnodes_FWD = 0
+            Pruned_Sons_FWD(:) = -1
+            DO I = 1, NZ_RHS
+               ISTEP       = abs( STEP(IRHS_SPARSE(I)) )
+               IF ( Pruned_Sons_FWD(ISTEP) .eq. -1) THEN
+                  Lnodes_FWD = Lnodes_FWD +1
+                  Pruned_Sons_FWD(ISTEP) = 0 
+               ENDIF
+            ENDDO
+           ELSE IF (Lnodes_FWD.GT.0) THEN
+            Lnodes_FWD_loc = 0
+            Pruned_Sons_FWD(:) = -1
+            DO I = 1, NZ_RHS
+               ISTEP       = abs( STEP(IRHS_SPARSE(I)) )
+               INODE_PRINC = Step2node( ISTEP )
+               IF ( Pruned_Sons_FWD(ISTEP) .eq. -1) THEN
+                  Lnodes_FWD_loc = Lnodes_FWD_loc +1
+                  nodes_FWD(Lnodes_FWD_loc)  = INODE_PRINC
+                  Pruned_Sons_FWD(ISTEP) = 0 
+               ENDIF
+            ENDDO
+           ENDIF
+        ELSE IF ( AM1 ) THEN  
+          IF (.NOT.fill) THEN
+            Lnodes_FWD = 0
+            Pruned_Sons_FWD(:) = -1
+            DO I = 1, NBCOL_INBLOC
+              IF ( (IRHS_PTR(I+1)-IRHS_PTR(I)).EQ.0) CYCLE
+              IF ( (KEEP(242) .NE. 0 ).OR. (KEEP(243).NE.0) ) THEN
+                   JAM1 = PERM_RHS(JBEG_RHS+I-1)
+              ELSE
+                   JAM1 = JBEG_RHS+I-1
+              ENDIF       
+              ISTEP = abs(STEP(JAM1))
+              INODE_PRINC = Step2node(ISTEP)
+              IF ( Pruned_Sons_FWD(ISTEP) .eq. -1) THEN
+                 Lnodes_FWD = Lnodes_FWD +1
+                 Pruned_Sons_FWD(ISTEP) = 0                 
+              ENDIF
+            ENDDO
+          ELSE IF (Lnodes_FWD.GT.0) THEN
+            Lnodes_FWD_loc = 0
+            Pruned_Sons_FWD = -1
+            DO I = 1, NBCOL_INBLOC
+              IF ( (IRHS_PTR(I+1)-IRHS_PTR(I)).EQ.0) CYCLE
+              IF ( (KEEP(242) .NE. 0 ).OR. (KEEP(243).NE.0) ) THEN
+                   JAM1 = PERM_RHS(JBEG_RHS+I-1)
+              ELSE
+                   JAM1 = JBEG_RHS+I-1
+              ENDIF
+              ISTEP = abs(STEP(JAM1))
+              INODE_PRINC = Step2node(ISTEP)
+              IF ( Pruned_Sons_FWD(ISTEP) .eq. -1) THEN
+                 Lnodes_FWD_loc = Lnodes_FWD_loc +1
+                 nodes_FWD(Lnodes_FWD_loc)  = INODE_PRINC
+                 Pruned_Sons_FWD(ISTEP) = 0
+              ENDIF
+            ENDDO            
+          ENDIF
+         ENDIF                  
+      ENDIF
+      IF (AM1) THEN
+        IF (.NOT.fill) THEN
+         Lnodes_BWD = 0
+         Pruned_Sons_BWD(:) = -1 
+         DO II = 1, NZ_RHS
+            I = IRHS_SPARSE(II)
+            IF (KEEP(23).NE.0) I = UNS_PERM_INV(I)          
+            ISTEP = abs(STEP(I))
+            IF ( Pruned_Sons_BWD(ISTEP) .eq. -1) THEN
+               Lnodes_BWD = Lnodes_BWD +1
+               Pruned_Sons_BWD(ISTEP) = 0
+            ENDIF
+         ENDDO
+        ELSE IF (Lnodes_BWD.GT.0) THEN
+         Lnodes_BWD_loc = 0         
+         Pruned_Sons_BWD(:) = -1  
+         DO II = 1, NZ_RHS
+            I = IRHS_SPARSE(II)
+            IF (KEEP(23).NE.0) I = UNS_PERM_INV(I)
+            ISTEP = abs(STEP(I))
+            INODE_PRINC = Step2node(ISTEP)
+            IF ( Pruned_Sons_BWD(ISTEP) .eq. -1) THEN
+               Lnodes_BWD_loc = Lnodes_BWD_loc +1
+               nodes_BWD(Lnodes_BWD_loc)  = INODE_PRINC
+               Pruned_Sons_BWD(ISTEP) = 0
+            ENDIF
+         ENDDO
+        ENDIF
+      ENDIF
+#if defined(AVOID_MPI_IN_PLACE)
+      GOTO 600  
+  500 CONTINUE
+      Lnodes_FWD = -1
+      Lnodes_BWD = -1
+  600 CONTINUE
+#endif
+#if defined(AVOID_MPI_IN_PLACE)
+      IF ( allocated(TMP_INT_ARRAY)) DEALLOCATE(TMP_INT_ARRAY)
+#endif
+      RETURN
+      END SUBROUTINE DMUMPS_NODES_FWD_BWD_SIZE_FILL
+      SUBROUTINE DMUMPS_BUILD_GLOB2LOC_NODES_ES (
+     &           NSLAVES, N, MYID_NODES,
      &           PTRIST, DAD,
      &           KEEP,KEEP8, PROCNODE_STEPS, IW, LIW, STEP,
-     &           POSINRHSCOMP_ROW, POSINRHSCOMP_COL,
-     &           POSINRHSCOMP_COL_ALLOC,
+     &           Lnodes_FWD, Lnodes_BWD,
+     &           nodes_FWD, nodes_BWD,
+     &           GLOB2LOC_RHS, GLOB2LOC_SOL,
+     &           GLOB2LOC_SOL_ALLOC,
      &           MTYPE,
-     &           IRHS_PTR, NBCOL_INBLOC, IRHS_SPARSE, NZ_RHS,
-     &           PERM_RHS, SIZE_PERM_RHS, JBEG_RHS,
-     &           NBENT_RHSCOMP,
-     &           NB_FS_IN_RHSCOMP_FWD, NB_FS_IN_RHSCOMP_TOT,
-     &           UNS_PERM_INV, SIZE_UNS_PERM_INV
+     &           NBENT_RHSINTR,
+     &           NB_FS_IN_RHSINTR_FWD, NB_FS_IN_RHSINTR_TOT
      &            )
       IMPLICIT NONE
       INCLUDE 'mpif.h'
       INCLUDE 'mumps_tags.h'
-      INTEGER, intent(in) :: NSLAVES, N, MYID_NODES, LIW, 
-     &                       SIZE_UNS_PERM_INV
-      INTEGER, intent(in) :: KEEP(500)
+      INTEGER, intent(in)    :: NSLAVES, N, MYID_NODES, LIW
+      INTEGER, intent(in)    :: KEEP(500)
       INTEGER(8), intent(in) :: KEEP8(150)
       INTEGER, intent(in) :: PTRIST(KEEP(28)), PROCNODE_STEPS(KEEP(28))
+      INTEGER, intent(in) :: Lnodes_FWD, Lnodes_BWD
+      INTEGER, intent(in) :: nodes_FWD(max(1,Lnodes_FWD)), 
+     &                       nodes_BWD(max(1,Lnodes_BWD))
       INTEGER, intent(inout) :: DAD(KEEP(28))
       INTEGER, intent(in) :: IW(LIW), STEP(N)
-      INTEGER, intent(in) :: NBCOL_INBLOC, IRHS_PTR(NBCOL_INBLOC+1)
-      INTEGER, intent(in) :: NZ_RHS, IRHS_SPARSE(NZ_RHS)
-      INTEGER, intent(in) :: SIZE_PERM_RHS, PERM_RHS(SIZE_PERM_RHS)
-      INTEGER, intent(in) :: JBEG_RHS
       INTEGER, intent(in) :: MTYPE
-      LOGICAL, intent(in) :: POSINRHSCOMP_COL_ALLOC
-      INTEGER, intent(out):: POSINRHSCOMP_ROW(N),POSINRHSCOMP_COL(N)
-      INTEGER, intent(out):: NBENT_RHSCOMP
-      INTEGER, intent(out):: NB_FS_IN_RHSCOMP_FWD, NB_FS_IN_RHSCOMP_TOT
-      INTEGER, intent(in) :: UNS_PERM_INV(SIZE_UNS_PERM_INV)
-      INTEGER I, JAM1
+      LOGICAL, intent(in) :: GLOB2LOC_SOL_ALLOC
+      INTEGER, intent(out):: GLOB2LOC_RHS(N), GLOB2LOC_SOL(N)
+      INTEGER, intent(out):: NBENT_RHSINTR
+      INTEGER, intent(out):: NB_FS_IN_RHSINTR_FWD, NB_FS_IN_RHSINTR_TOT
+      INTEGER I
       INTEGER ISTEP, OLDISTEP
       INTEGER NPIV
       INTEGER IPOS, LIELL
       INTEGER JJ, J1, JCOL, ABSJCOL
-      INTEGER IPOSINRHSCOMP_ROW, IPOSINRHSCOMP_COL
-      INTEGER NBENT_RHSCOMP_ROW, NBENT_RHSCOMP_COL
+      INTEGER IPOSINRHSINTR_RHS, IPOSINRHSINTR_SOL
+      INTEGER NBENT_RHSINTR_ROW, NBENT_RHSINTR_COL
       LOGICAL GO_UP
       INCLUDE 'mumps_headers.h'
       INTEGER MUMPS_PROCNODE
       EXTERNAL MUMPS_PROCNODE
-      IF(KEEP(237).EQ.0) THEN
-        WRITE(*,*)'BUILD_POSINRHSCOMP_SPARSE available for A-1 only !'
-        CALL MUMPS_ABORT()
-      END IF
-      POSINRHSCOMP_ROW = 0
-      IF (POSINRHSCOMP_COL_ALLOC) POSINRHSCOMP_COL = 0
-      IPOSINRHSCOMP_ROW = 0
-      IPOSINRHSCOMP_COL = 0
-      DO I = 1, NBCOL_INBLOC
-        IF ((IRHS_PTR(I+1)-IRHS_PTR(I)).EQ.0) CYCLE 
-        IF (KEEP(242).NE.0) THEN 
-          JAM1 = PERM_RHS(JBEG_RHS+I-1)
-        ELSE
-          JAM1 = JBEG_RHS+I-1
-        END IF
-        ISTEP = abs(STEP(JAM1))
+      GLOB2LOC_RHS = 0
+      IF (GLOB2LOC_SOL_ALLOC) GLOB2LOC_SOL = 0
+      IPOSINRHSINTR_RHS = 0
+      IPOSINRHSINTR_SOL = 0
+      DO I = 1, Lnodes_FWD
+        ISTEP = STEP(nodes_FWD(I))
         GO_UP = .TRUE.
         DO WHILE(GO_UP) 
           IF(MYID_NODES.EQ.
@@ -2257,18 +2721,18 @@ C
               JCOL = IPOS+1
             ENDIF
             IF(NPIV.GT.0) THEN 
-              IF(POSINRHSCOMP_ROW(IW(J1)).EQ.0) THEN 
+              IF(GLOB2LOC_RHS(IW(J1)).EQ.0) THEN 
                 DO JJ = J1, J1+NPIV-1
-                  POSINRHSCOMP_ROW(IW(JJ))
-     &            = IPOSINRHSCOMP_ROW + JJ - J1 + 1
+                  GLOB2LOC_RHS(IW(JJ))
+     &            = IPOSINRHSINTR_RHS + JJ - J1 + 1
                 ENDDO
-                IPOSINRHSCOMP_ROW = IPOSINRHSCOMP_ROW + NPIV
-                IF (POSINRHSCOMP_COL_ALLOC) THEN
+                IPOSINRHSINTR_RHS = IPOSINRHSINTR_RHS + NPIV
+                IF (GLOB2LOC_SOL_ALLOC) THEN
                   DO JJ = JCOL, JCOL+NPIV-1
-                    POSINRHSCOMP_COL(IW(JJ))
-     &              = - N - (IPOSINRHSCOMP_COL + JJ - JCOL + 1)
+                    GLOB2LOC_SOL(IW(JJ))
+     &              = - (IPOSINRHSINTR_SOL + JJ - JCOL + 1)
                   ENDDO
-                  IPOSINRHSCOMP_COL = IPOSINRHSCOMP_COL + NPIV
+                  IPOSINRHSINTR_SOL = IPOSINRHSINTR_SOL + NPIV
                 ENDIF
               ELSE
                 GO_UP = .FALSE. 
@@ -2282,12 +2746,10 @@ C
           END IF
         END DO 
       END DO 
-      NB_FS_IN_RHSCOMP_FWD = IPOSINRHSCOMP_ROW
-      IF(POSINRHSCOMP_COL_ALLOC) THEN 
-        DO I =1, NZ_RHS
-          JAM1 = IRHS_SPARSE(I)
-          IF (KEEP(23).NE.0) JAM1 = UNS_PERM_INV(JAM1)
-          ISTEP = abs(STEP(JAM1))
+      NB_FS_IN_RHSINTR_FWD = IPOSINRHSINTR_RHS
+      IF(GLOB2LOC_SOL_ALLOC) THEN 
+        DO I=1, Lnodes_BWD
+          ISTEP = STEP(nodes_BWD(I))
           GO_UP = .TRUE.
           DO WHILE(GO_UP) 
             IF(MYID_NODES.EQ.
@@ -2306,21 +2768,17 @@ C
               ENDIF
               ABSJCOL = abs(IW(JCOL))
               IF(NPIV.GT.0) THEN 
-                IF(POSINRHSCOMP_COL(ABSJCOL).EQ.0)  THEN
+                IF(GLOB2LOC_SOL(ABSJCOL).EQ.0)  THEN
                   DO JJ = JCOL, JCOL+NPIV-1
-                    POSINRHSCOMP_COL(abs(IW(JJ))) = 
-     &                     IPOSINRHSCOMP_COL+JJ-JCOL+1
+                    GLOB2LOC_SOL(abs(IW(JJ))) = 
+     &                     IPOSINRHSINTR_SOL+JJ-JCOL+1
                   END DO
-                  IPOSINRHSCOMP_COL = IPOSINRHSCOMP_COL + NPIV
-                ELSE IF (POSINRHSCOMP_COL(ABSJCOL).LT.-N) THEN
+                  IPOSINRHSINTR_SOL = IPOSINRHSINTR_SOL + NPIV
+                ELSE IF (GLOB2LOC_SOL(ABSJCOL).LT.0) THEN
                   DO JJ = JCOL, JCOL+NPIV-1
-                    POSINRHSCOMP_COL(abs(IW(JJ)))=
-     &                -(N+POSINRHSCOMP_COL(abs(IW(JJ))))
+                    GLOB2LOC_SOL(abs(IW(JJ)))=
+     &                -(GLOB2LOC_SOL(abs(IW(JJ))))
                   END DO
-                ELSE IF ((POSINRHSCOMP_COL(ABSJCOL).LT.0).AND.
-     &                 (POSINRHSCOMP_COL(ABSJCOL).GE.-N))THEN
-                  WRITE(*,*)'Internal error 7 in BUILD...SPARSE'
-                  CALL MUMPS_ABORT()
                 ELSE
                   GO_UP = .FALSE.
                 END IF
@@ -2334,16 +2792,10 @@ C
           END DO 
         END DO 
       END IF 
-      NB_FS_IN_RHSCOMP_TOT = IPOSINRHSCOMP_COL
-            IF (NSLAVES.NE.1) THEN
-      DO I = 1, NBCOL_INBLOC
-        IF ((IRHS_PTR(I+1)-IRHS_PTR(I)).EQ.0) CYCLE 
-        IF (KEEP(242).NE.0) THEN 
-          JAM1 = PERM_RHS(JBEG_RHS+I-1)
-        ELSE
-          JAM1 = JBEG_RHS+I-1
-        END IF
-        ISTEP = abs(STEP(JAM1))
+      NB_FS_IN_RHSINTR_TOT = IPOSINRHSINTR_SOL
+      IF (NSLAVES.NE.1) THEN
+      DO I = 1, Lnodes_FWD
+        ISTEP = STEP(nodes_FWD(I))
         GO_UP = .TRUE.
         DO WHILE(GO_UP) 
           IF(MYID_NODES.EQ.
@@ -2361,10 +2813,9 @@ C
               JCOL = IPOS+1
             ENDIF
             DO JJ = NPIV, LIELL-1-KEEP(253)
-              IF(POSINRHSCOMP_ROW(IW(J1+JJ)).EQ.0) THEN 
-                IPOSINRHSCOMP_ROW = IPOSINRHSCOMP_ROW + 1
-                POSINRHSCOMP_ROW(IW(JJ+J1))
-     &          = -IPOSINRHSCOMP_ROW
+              IF(GLOB2LOC_RHS(IW(J1+JJ)).EQ.0) THEN 
+                IPOSINRHSINTR_RHS = IPOSINRHSINTR_RHS + 1
+                GLOB2LOC_RHS(IW(JJ+J1)) = -IPOSINRHSINTR_RHS
               END IF
             END DO
           END IF
@@ -2378,11 +2829,9 @@ C
         END DO 
       END DO 
       DAD=ABS(DAD)
-      IF(POSINRHSCOMP_COL_ALLOC) THEN
-        DO I =1, NZ_RHS
-          JAM1 = IRHS_SPARSE(I)
-          IF (KEEP(23).NE.0) JAM1 = UNS_PERM_INV(JAM1)
-          ISTEP = abs(STEP(JAM1))
+      IF(GLOB2LOC_SOL_ALLOC) THEN
+        DO I=1, Lnodes_BWD
+        ISTEP = STEP(nodes_BWD(I))
           GO_UP = .TRUE.
           DO WHILE(GO_UP) 
             IF(MYID_NODES.EQ.
@@ -2399,16 +2848,10 @@ C
               ELSE
                 JCOL = IPOS+1
               ENDIF
-              IF (KEEP(23).NE.0) JAM1 = UNS_PERM_INV(JAM1)
               DO JJ = NPIV, LIELL-1-KEEP(253)
-                IF(POSINRHSCOMP_COL(IW(JCOL+JJ)).EQ.0) THEN 
-                  IPOSINRHSCOMP_COL = IPOSINRHSCOMP_COL + 1
-                  POSINRHSCOMP_COL(IW(JCOL+JJ))
-     &            = -IPOSINRHSCOMP_COL
-                ELSE IF (POSINRHSCOMP_COL(IW(JCOL+JJ)).LT.-N) THEN
-                  IPOSINRHSCOMP_COL = IPOSINRHSCOMP_COL + 1
-                  POSINRHSCOMP_COL(IW(JCOL+JJ))
-     &            = POSINRHSCOMP_COL(IW(JCOL+JJ)) + N              
+                IF(GLOB2LOC_SOL(IW(JCOL+JJ)).EQ.0) THEN 
+                  IPOSINRHSINTR_SOL = IPOSINRHSINTR_SOL + 1
+                  GLOB2LOC_SOL(IW(JCOL+JJ)) = -IPOSINRHSINTR_SOL
                 END IF
               END DO
             END IF
@@ -2424,8 +2867,8 @@ C
        DAD=ABS(DAD)
       END IF
       ENDIF
-      NBENT_RHSCOMP_ROW = IPOSINRHSCOMP_ROW
-      NBENT_RHSCOMP_COL = IPOSINRHSCOMP_COL
-      NBENT_RHSCOMP = max(NBENT_RHSCOMP_ROW,NBENT_RHSCOMP_COL)
+      NBENT_RHSINTR_ROW = IPOSINRHSINTR_RHS
+      NBENT_RHSINTR_COL = IPOSINRHSINTR_SOL
+      NBENT_RHSINTR = max(NBENT_RHSINTR_ROW,NBENT_RHSINTR_COL)
       RETURN
-      END SUBROUTINE DMUMPS_BUILD_POSINRHSCOMP_AM1
+      END SUBROUTINE DMUMPS_BUILD_GLOB2LOC_NODES_ES
diff -pruN 5.6.2-2.1/src/dsol_distrhs.F 5.7.1-1/src/dsol_distrhs.F
--- 5.6.2-2.1/src/dsol_distrhs.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/dsol_distrhs.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -17,9 +17,14 @@ C
      &           NRHS_COL, NRHS_loc, LRHS_loc,
      &           MAP_RHS_loc,
      &           IRHS_loc, RHS_loc, RHS_loc_size,
-     &           RHSCOMP, LD_RHSCOMP,
-     &           POSINRHSCOMP_FWD, NB_FS_IN_RHSCOMP,
-     &           LSCAL, scaling_data_dr,
+     &           RHSINTR, LD_RHSINTR,
+     &           POSINRHSINTR_FWD, NB_FS_IN_RHSINTR,
+     &           LSCAL,
+#if defined(USE_OLD_SCALING)
+     &           scaling_data_dr,
+#else
+     &           SCALING_RHSINTR_FWD, LSCALING_RHSINTR_FWD,
+#endif
      &           LP, LPOK, KEEP, NB_BYTES_LOC, INFO )
       USE DMUMPS_STRUC_DEF
 !$    USE OMP_LIB
@@ -32,17 +37,23 @@ C
       INTEGER, INTENT(IN)    :: IRHS_loc(NRHS_loc)
       INTEGER(8), INTENT(IN) :: RHS_loc_size
       DOUBLE PRECISION, INTENT(IN)    :: RHS_loc(RHS_loc_size)
-      INTEGER, INTENT(IN)    :: NB_FS_IN_RHSCOMP, LD_RHSCOMP
-      INTEGER, INTENT(IN)    :: POSINRHSCOMP_FWD(N)
-      DOUBLE PRECISION, INTENT(OUT)   :: RHSCOMP(LD_RHSCOMP, NRHS_COL)
+      INTEGER, INTENT(IN)    :: NB_FS_IN_RHSINTR, LD_RHSINTR
+      INTEGER, INTENT(IN)    :: POSINRHSINTR_FWD(N)
+      DOUBLE PRECISION, INTENT(OUT)   :: RHSINTR(LD_RHSINTR, NRHS_COL)
       INTEGER                :: KEEP(500)
       LOGICAL, INTENT(IN)    :: LSCAL
+#if defined(USE_OLD_SCALING)
       type scaling_data_t
         SEQUENCE
-        DOUBLE PRECISION, dimension(:), pointer :: SCALING
-        DOUBLE PRECISION, dimension(:), pointer :: SCALING_LOC
+        DOUBLE PRECISION,    dimension(:), pointer :: SCALING
+        DOUBLE PRECISION,    dimension(:), pointer :: SCALING_LOC
+        INTEGER, dimension(:), pointer :: SCALING_IND 
       end type scaling_data_t
       type(scaling_data_t), INTENT(IN) :: scaling_data_dr
+#else
+      INTEGER :: LSCALING_RHSINTR_FWD
+      DOUBLE PRECISION :: SCALING_RHSINTR_FWD( LSCALING_RHSINTR_FWD )
+#endif
       LOGICAL, INTENT(IN)    :: LPOK
       INTEGER, INTENT(IN)    :: LP      
       INTEGER, INTENT(INOUT) :: INFO(2) 
@@ -135,7 +146,7 @@ C
      &         IS_SEND_ACTIVE(MAX_ACTIVE_SENDS),
      &         BUFRECI(MAXRECORDS),                
      &         BUFRECR(MAXRECORDS*NRHS_COL),       
-     &         TOUCHED(NB_FS_IN_RHSCOMP),          
+     &         TOUCHED(NB_FS_IN_RHSINTR),          
      &         stat=allocok)
       IF (allocok .GT. 0) THEN
         IF (LP .GT. 0) WRITE(LP, '(A)')
@@ -143,11 +154,11 @@ C
         INFO(1)=-13
         INFO(2)=NRHS_COL*MAXRECORDS*MAX_ACTIVE_SENDS+
      &          3*MAX_ACTIVE_SENDS+MAXRECORDS*(1+NRHS_COL)
-     &          + NB_FS_IN_RHSCOMP
+     &          + NB_FS_IN_RHSINTR
       ENDIF
       NB_BYTES_LOC=NB_BYTES_LOC +
      &  KEEP(34) * ( int(2*MAX_ACTIVE_SENDS,8) + int(MAXRECORDS,8) ) +
-     &  KEEP(34) * (int(MAX_ACTIVE_SENDS,8) + int(NB_FS_IN_RHSCOMP,8)) +
+     &  KEEP(34) * (int(MAX_ACTIVE_SENDS,8) + int(NB_FS_IN_RHSINTR,8)) +
      &  KEEP(35) * (
      &      int( MAXRECORDS,8)*int(NRHS_COL,8)*int(MAX_ACTIVE_SENDS,8)
      &      + int(MAXRECORDS,8) * int(NRHS_COL,8) )
@@ -160,7 +171,7 @@ C
         IS_SEND_ACTIVE(IREQ) = .FALSE.
       ENDDO
       NB_FS_TOUCHED = 0
-      DO IFS = 1, NB_FS_IN_RHSCOMP
+      DO IFS = 1, NB_FS_IN_RHSINTR
         TOUCHED(IFS) = .FALSE.
       ENDDO
       IPROC_MAX=maxloc(NBROWSTOSEND,DIM=1)-1
@@ -223,7 +234,7 @@ C
         INTEGER, INTENT(INOUT) :: BUFRECI_ARG(NBRECORDS) 
         DOUBLE PRECISION, INTENT(IN) :: BUFRECR_ARG(NBRECORDS,
      &                                     NRHS_COL)
-        INTEGER :: I, K, IRHSCOMP, IFIRSTNOTTOUCHED, ILASTNOTTOUCHED
+        INTEGER :: I, K, IRHSINTR, IFIRSTNOTTOUCHED, ILASTNOTTOUCHED
         IFIRSTNOTTOUCHED = NBRECORDS+1
         ILASTNOTTOUCHED  = 0
         DO I = 1, NBRECORDS
@@ -232,9 +243,9 @@ C
      &      I, BUFRECI(I), BUFRECI(1)
             CALL MUMPS_ABORT()
           ENDIF
-          IRHSCOMP=POSINRHSCOMP_FWD(BUFRECI(I))
-          BUFRECI_ARG(I)=IRHSCOMP
-          IF ( .NOT. TOUCHED(IRHSCOMP) ) THEN
+          IRHSINTR=POSINRHSINTR_FWD(BUFRECI(I))
+          BUFRECI_ARG(I)=IRHSINTR
+          IF ( .NOT. TOUCHED(IRHSINTR) ) THEN
             IFIRSTNOTTOUCHED=min(IFIRSTNOTTOUCHED,I)
             ILASTNOTTOUCHED=max(ILASTNOTTOUCHED,I)
           ENDIF
@@ -243,41 +254,67 @@ C
 !$      OMP_FLAG = ( NRHS_COL.GE.KEEP(362) .AND.
 !$   &               NRHS_COL*NBRECORDS .GE. KEEP(363)/2)
         IF (OMP_FLAG) THEN
-!$OMP PARALLEL DO PRIVATE(I,IRHSCOMP) IF (OMP_FLAG)
+!$OMP PARALLEL DO PRIVATE(I,IRHSINTR)
         DO K = 1, NRHS_COL
           DO I = IFIRSTNOTTOUCHED, ILASTNOTTOUCHED
-            IRHSCOMP=BUFRECI_ARG(I)
-            IF (.NOT. TOUCHED(IRHSCOMP)) THEN
-              RHSCOMP(IRHSCOMP,K)=ZERO
+            IRHSINTR=BUFRECI_ARG(I)
+            IF (.NOT. TOUCHED(IRHSINTR)) THEN
+              RHSINTR(IRHSINTR,K)=ZERO
             ENDIF
           ENDDO
-          DO I = 1, NBRECORDS
-            IRHSCOMP=BUFRECI_ARG(I)
-            RHSCOMP(IRHSCOMP,K) = RHSCOMP(IRHSCOMP,K) +
+#if ! defined(USE_OLD_SCALING)
+          IF (LSCAL) THEN
+            DO I = 1, NBRECORDS
+              IRHSINTR=BUFRECI_ARG(I)
+              RHSINTR(IRHSINTR,K) = RHSINTR(IRHSINTR,K) +
+     &                            SCALING_RHSINTR_FWD(IRHSINTR) *
      &                            BUFRECR_ARG(I,K)
-          ENDDO
+            ENDDO
+          ELSE
+#endif
+            DO I = 1, NBRECORDS
+              IRHSINTR=BUFRECI_ARG(I)
+              RHSINTR(IRHSINTR,K) = RHSINTR(IRHSINTR,K) +
+     &                            BUFRECR_ARG(I,K)
+            ENDDO
+#if ! defined(USE_OLD_SCALING)
+          ENDIF
+#endif
         ENDDO
 !$OMP END PARALLEL DO
         ELSE
-        DO K = 1, NRHS_COL
-          DO I = IFIRSTNOTTOUCHED, ILASTNOTTOUCHED
-            IRHSCOMP=BUFRECI_ARG(I)
-            IF (.NOT. TOUCHED(IRHSCOMP)) THEN
-              RHSCOMP(IRHSCOMP,K)=ZERO
+          DO K = 1, NRHS_COL
+            DO I = IFIRSTNOTTOUCHED, ILASTNOTTOUCHED
+              IRHSINTR=BUFRECI_ARG(I)
+              IF (.NOT. TOUCHED(IRHSINTR)) THEN
+                RHSINTR(IRHSINTR,K)=ZERO
+              ENDIF
+            ENDDO
+#if ! defined(USE_OLD_SCALING)
+            IF ( LSCAL ) THEN
+              DO I = 1, NBRECORDS
+                IRHSINTR=BUFRECI_ARG(I)
+                RHSINTR(IRHSINTR,K) = RHSINTR(IRHSINTR,K) +
+     &                                SCALING_RHSINTR_FWD(IRHSINTR) *
+     &                                BUFRECR_ARG(I,K)
+              ENDDO
+            ELSE
+#endif
+              DO I = 1, NBRECORDS
+                IRHSINTR=BUFRECI_ARG(I)
+                RHSINTR(IRHSINTR,K) = RHSINTR(IRHSINTR,K) +
+     &                                BUFRECR_ARG(I,K)
+              ENDDO
+#if ! defined(USE_OLD_SCALING)
             ENDIF
+#endif
           ENDDO
-          DO I = 1, NBRECORDS
-            IRHSCOMP=BUFRECI_ARG(I)
-            RHSCOMP(IRHSCOMP,K) = RHSCOMP(IRHSCOMP,K) +
-     &                            BUFRECR_ARG(I,K)
-          ENDDO
-        ENDDO
         ENDIF
         DO I = 1, NBRECORDS
-          IRHSCOMP = BUFRECI_ARG(I)
-          IF (.NOT. TOUCHED(IRHSCOMP)) THEN
+          IRHSINTR = BUFRECI_ARG(I)
+          IF (.NOT. TOUCHED(IRHSINTR)) THEN
             NB_FS_TOUCHED = NB_FS_TOUCHED + 1
-            TOUCHED(IRHSCOMP) = .TRUE.
+            TOUCHED(IRHSINTR) = .TRUE.
           ENDIF
         ENDDO
         NBROWSTORECV = NBROWSTORECV - NBRECORDS
@@ -287,7 +324,7 @@ C
         INTEGER :: NBRECORDS, I, K, IFIRSTNOTTOUCHED
         INTEGER :: Iloc       
         INTEGER :: Iglob      
-        INTEGER :: IRHSCOMP   
+        INTEGER :: IRHSINTR   
         INTEGER(8) :: ISHIFT
         IF ( NBROWSTOSEND(MYID_NODES+1) .EQ. 0) THEN
           WRITE(*,*) "Internal error in DMUMPS_DR_ASSEMBLE_LOCAL"
@@ -296,9 +333,9 @@ C
         NBRECORDS=min(MAXRECORDS, NBROWSTOSEND(MYID_NODES+1))
         IFIRSTNOTTOUCHED=NBRECORDS+1
         DO I = 1, NBRECORDS
-          IRHSCOMP = POSINRHSCOMP_FWD(IRHS_loc(
+          IRHSINTR = POSINRHSINTR_FWD(IRHS_loc(
      &               IRHS_loc_sorted(NEXTROWTOSEND(MYID_NODES+1)+I-1)))
-          IF (.NOT. TOUCHED(IRHSCOMP)) THEN
+          IF (.NOT. TOUCHED(IRHSINTR)) THEN
             IFIRSTNOTTOUCHED=I
             EXIT
           ENDIF
@@ -306,57 +343,61 @@ C
         IF (LSCAL) THEN
 !$        OMP_FLAG = (NRHS_COL.GE.KEEP(362) .AND.
 !$   &                NRHS_COL*NBRECORDS .GE. KEEP(363)/2)
-!$OMP PARALLEL DO PRIVATE(K, ISHIFT, I, IRHSCOMP, Iloc, Iglob)
+!$OMP PARALLEL DO PRIVATE(K, ISHIFT, I, IRHSINTR, Iloc, Iglob)
 !$OMP&  FIRSTPRIVATE(NBRECORDS) IF (OMP_FLAG)
           DO K = 1, NRHS_COL
-            ISHIFT = (K-1) * LRHS_loc
+            ISHIFT = int(K-1,8) * int(LRHS_loc,8)
             DO I = IFIRSTNOTTOUCHED, NBRECORDS
-              IRHSCOMP = POSINRHSCOMP_FWD(IRHS_loc(
+              IRHSINTR = POSINRHSINTR_FWD(IRHS_loc(
      &               IRHS_loc_sorted(NEXTROWTOSEND(MYID_NODES+1)+I-1)))
-               IF (.NOT. TOUCHED(IRHSCOMP)) THEN
-                 RHSCOMP(IRHSCOMP,K)=ZERO
+               IF (.NOT. TOUCHED(IRHSINTR)) THEN
+                 RHSINTR(IRHSINTR,K)=ZERO
                ENDIF
             ENDDO
             DO I = 1, NBRECORDS
               Iloc = IRHS_loc_sorted(NEXTROWTOSEND(MYID_NODES+1)+I-1)
               Iglob = IRHS_loc(Iloc)
-              IRHSCOMP = POSINRHSCOMP_FWD(Iglob)
-              RHSCOMP(IRHSCOMP,K) = RHSCOMP(IRHSCOMP,K)+
+              IRHSINTR = POSINRHSINTR_FWD(Iglob)
+              RHSINTR(IRHSINTR,K) = RHSINTR(IRHSINTR,K)+
      &                              RHS_loc(Iloc+ISHIFT)*
+#if defined(USE_OLD_SCALING)
      &                        scaling_data_dr%SCALING_LOC(Iloc)
+#else
+     &                        SCALING_RHSINTR_FWD(IRHSINTR)
+#endif
             ENDDO
           ENDDO
 !$OMP END PARALLEL DO
         ELSE
 !$        OMP_FLAG = (NRHS_COL.GE.KEEP(362) .AND.
 !$   &                NRHS_COL*NBRECORDS .GE. KEEP(363)/2)
-!$OMP PARALLEL DO PRIVATE(K, ISHIFT, I, IRHSCOMP, Iloc, Iglob)
+!$OMP PARALLEL DO PRIVATE(K, ISHIFT, I, IRHSINTR, Iloc, Iglob)
 !$OMP&  FIRSTPRIVATE(NBRECORDS) IF (OMP_FLAG)
           DO K = 1, NRHS_COL
-            ISHIFT = (K-1) * LRHS_loc
+            ISHIFT = int(K-1,8) * int(LRHS_loc,8)
             DO I = IFIRSTNOTTOUCHED, NBRECORDS
-              IRHSCOMP = POSINRHSCOMP_FWD(IRHS_loc(
+              IRHSINTR = POSINRHSINTR_FWD(IRHS_loc(
      &               IRHS_loc_sorted(NEXTROWTOSEND(MYID_NODES+1)+I-1)))
-               IF (.NOT. TOUCHED(IRHSCOMP)) THEN
-                 RHSCOMP(IRHSCOMP,K)=ZERO
+               IF (.NOT. TOUCHED(IRHSINTR)) THEN
+                 RHSINTR(IRHSINTR,K)=ZERO
                ENDIF
             ENDDO
             DO I = 1, NBRECORDS
               Iloc = IRHS_loc_sorted(NEXTROWTOSEND(MYID_NODES+1)+I-1)
               Iglob = IRHS_loc(Iloc)
-              IRHSCOMP = POSINRHSCOMP_FWD(Iglob)
-              RHSCOMP(IRHSCOMP,K) = RHSCOMP(IRHSCOMP,K)+
+              IRHSINTR = POSINRHSINTR_FWD(Iglob)
+              RHSINTR(IRHSINTR,K) = RHSINTR(IRHSINTR,K) +
      &                              RHS_loc(Iloc+ISHIFT)
             ENDDO
           ENDDO
 !$OMP END PARALLEL DO
         ENDIF
         DO I = 1, NBRECORDS
-          IRHSCOMP = POSINRHSCOMP_FWD(IRHS_loc(
+          IRHSINTR = POSINRHSINTR_FWD(IRHS_loc(
      &               IRHS_loc_sorted(NEXTROWTOSEND(MYID_NODES+1)+I-1)))
-          IF (.NOT. TOUCHED(IRHSCOMP)) THEN
+          IF (.NOT. TOUCHED(IRHSINTR)) THEN
             NB_FS_TOUCHED = NB_FS_TOUCHED + 1
-            TOUCHED(IRHSCOMP) = .TRUE.
+            TOUCHED(IRHSINTR) = .TRUE.
           ENDIF
         ENDDO
         NEXTROWTOSEND(MYID_NODES+1)=NEXTROWTOSEND(MYID_NODES+1)+
@@ -434,8 +475,10 @@ C
                 IPOSRHS = int(K-1,8)*int(LRHS_loc,8)
                 Iloc = IRHS_loc_sorted(NEXTROWTOSEND(IPROC_ARG+1)+I-1)
                 BUFR( IPOSBUF + I, IBUF )
-     &                = RHS_loc( IPOSRHS + Iloc ) *
-     &                  scaling_data_dr%SCALING_LOC(Iloc)
+     &                = RHS_loc( IPOSRHS + Iloc )
+#if defined(USE_OLD_SCALING)
+     &                  * scaling_data_dr%SCALING_LOC(Iloc)
+#endif
               ENDDO
             ENDDO
 !$OMP END PARALLEL DO
@@ -475,24 +518,25 @@ C
         END SUBROUTINE DMUMPS_DR_TRY_SEND
         SUBROUTINE DMUMPS_DR_EMPTY_ROWS()
         INTEGER :: K, IFS
-        IF ( NB_FS_TOUCHED .NE. NB_FS_IN_RHSCOMP ) THEN
+        IF ( NB_FS_TOUCHED .NE. NB_FS_IN_RHSINTR ) THEN
 !$        OMP_FLAG = (NRHS_COL .GE. KEEP(362)) .AND.
-!$   &    (NRHS_COL*NB_FS_IN_RHSCOMP >  KEEP(363)/2)
-!$OMP PARALLEL DO FIRSTPRIVATE(NB_FS_IN_RHSCOMP) IF (OMP_FLAG)
+!$   &    (NRHS_COL*NB_FS_IN_RHSINTR >  KEEP(363)/2)
+!$OMP PARALLEL DO FIRSTPRIVATE(NB_FS_IN_RHSINTR)
+!$OMP&    PRIVATE(IFS) IF (OMP_FLAG)
           DO K = 1, NRHS_COL
-            DO IFS = 1, NB_FS_IN_RHSCOMP
+            DO IFS = 1, NB_FS_IN_RHSINTR
               IF ( .NOT. TOUCHED(IFS) ) THEN
-                RHSCOMP( IFS, K) = ZERO
+                RHSINTR( IFS, K) = ZERO
               ENDIF
             ENDDO
-            DO IFS = NB_FS_IN_RHSCOMP +1, LD_RHSCOMP
-              RHSCOMP (IFS, K) = ZERO
+            DO IFS = NB_FS_IN_RHSINTR +1, LD_RHSINTR
+              RHSINTR (IFS, K) = ZERO
             ENDDO
           ENDDO
 !$OMP END PARALLEL DO
         ELSE
 !$        OMP_FLAG = .FALSE.
-!$        CHUNK8 = int(NRHS_COL,8)*int(LD_RHSCOMP-NB_FS_IN_RHSCOMP,8)
+!$        CHUNK8 = int(NRHS_COL,8)*int(LD_RHSINTR-NB_FS_IN_RHSINTR,8)
 !$        CHUNK8 = max(CHUNK8,1_8)
 !$        IF (CHUNK8 .GE. int(KEEP(363),8)) THEN
 !$          OMP_FLAG = .TRUE.
@@ -501,8 +545,8 @@ C
 !$OMP PARALLEL DO COLLAPSE(2) SCHEDULE(STATIC,CHUNK8)
 !$OMP&  IF (OMP_FLAG)
           DO K = 1, NRHS_COL
-            DO IFS = NB_FS_IN_RHSCOMP +1, LD_RHSCOMP
-             RHSCOMP (IFS, K) = ZERO
+            DO IFS = NB_FS_IN_RHSINTR +1, LD_RHSINTR
+             RHSINTR (IFS, K) = ZERO
             ENDDO
           ENDDO
 !$OMP END PARALLEL DO
@@ -532,15 +576,19 @@ C
      &               ( id%MYID .eq. MASTER .AND.
      &                 id%KEEP(46) .eq. 1 ) )
         IF (id%MYID .EQ. MASTER) THEN
-          IF (id%ICNTL(20).EQ.10) THEN
-            ROW_OR_COL_INDICES = 0 
-          ELSE IF (id%ICNTL(20).EQ.11) THEN
-            ROW_OR_COL_INDICES = 1 
-          ELSE 
-            ROW_OR_COL_INDICES = 0 
-          ENDIF
-          IF (id%ICNTL(9) .NE. 1) THEN
-            ROW_OR_COL_INDICES = 1 - ROW_OR_COL_INDICES
+          IF (id%KEEP(50).NE.0) THEN
+            ROW_OR_COL_INDICES = 0
+          ELSE
+            IF (id%ICNTL(20).EQ.10 .OR. id%KEEP(50).EQ.0) THEN
+              ROW_OR_COL_INDICES = 0 
+            ELSE IF (id%ICNTL(20).EQ.11) THEN
+              ROW_OR_COL_INDICES = 1 
+            ELSE 
+              ROW_OR_COL_INDICES = 0 
+            ENDIF
+            IF (id%ICNTL(9) .NE. 1) THEN
+              ROW_OR_COL_INDICES = 1 - ROW_OR_COL_INDICES
+            ENDIF
           ENDIF
           IF (id%KEEP(23).NE.0 .AND. id%ICNTL(9) .NE.1) THEN
             UNS_PERM_TO_BE_DONE = 1
@@ -577,7 +625,8 @@ C
           ELSE
             idIRHS_loc => IDUMMY
           ENDIF
-          CALL MUMPS_BUILD_IRHS_loc(id%MYID_NODES, id%NSLAVES, id%N,
+          CALL MUMPS_GET_INDICES
+     &    (id%MYID_NODES, id%NSLAVES, id%N,
      &    id%PTLUST_S(1), id%KEEP(1), id%KEEP8(1), id%IS(1),
      &    max(1, id%KEEP(32)),
      &    id%STEP(1), id%PROCNODE_STEPS(1), idIRHS_loc(1),
diff -pruN 5.6.2-2.1/src/dsol_distsol.F 5.7.1-1/src/dsol_distsol.F
--- 5.6.2-2.1/src/dsol_distsol.F	1970-01-01 00:00:00.000000000 +0000
+++ 5.7.1-1/src/dsol_distsol.F	2024-05-02 10:15:26.000000000 +0000
@@ -0,0 +1,16 @@
+C
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
+C
+C
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Mumps Technologies, University of Bordeaux.
+C
+C  This version of MUMPS is provided to you free of charge. It is
+C  released under the CeCILL-C license 
+C  (see doc/CeCILL-C_V1-en.txt, doc/CeCILL-C_V1-fr.txt, and
+C  https://cecill.info/licences/Licence_CeCILL-C_V1-en.html)
+C
+      SUBROUTINE DMUMPS_DS_RETURN()
+      RETURN
+      END SUBROUTINE DMUMPS_DS_RETURN
diff -pruN 5.6.2-2.1/src/dsol_driver.F 5.7.1-1/src/dsol_driver.F
--- 5.6.2-2.1/src/dsol_driver.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/dsol_driver.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -25,7 +25,7 @@ C  Performs solution phase (solve), Iter
 C  and Error analysis.
 C
 C
-C
+c
 C
       USE DMUMPS_BUF
       USE DMUMPS_OOC
@@ -34,7 +34,9 @@ C
      &                           , DMUMPS_BLR_MOD_TO_STRUC
       USE MUMPS_FRONT_DATA_MGT_M, only : MUMPS_FDM_STRUC_TO_MOD,
      &                                   MUMPS_FDM_MOD_TO_STRUC
+#if ! defined(NO_SAVE_RESTORE)
       USE DMUMPS_SAVE_RESTORE
+#endif
 !$    USE OMP_LIB
       IMPLICIT NONE
 C     -------------------
@@ -76,8 +78,11 @@ C
       LOGICAL PROK, PROKG, LPOK
       INTEGER MTYPE, ICNTL21
       LOGICAL LSCAL, POSTPros, GIVSOL
-      INTEGER ICNTL10, ICNTL11
-      INTEGER I,IPERM,K,JPERM, J, II, IZ2
+      INTEGER ICNTL10, ICNTL11, ICNTL48_EFF
+      INTEGER I,K,JPERM, J, II, IZ2
+#if defined(USE_OLD_SCALING)
+      INTEGER IPERM
+#endif
       INTEGER IZ, NZ_THIS_BLOCK, PJ
 C     pointers in IS
       INTEGER LIW
@@ -101,6 +106,7 @@ C
       INTEGER NITREF, NOITER, SOLVET, KASE
 C     Meaningful only with tree pruning and sparse RHS
       LOGICAL INTERLEAVE_PAR, DO_PERMUTE_RHS
+      LOGICAL CALL_NODES_FWD_BWD, FIRST_CALL_NODES_FWD_BWD
 C     true if DMUMPS_SOL_C called during postprocessing
       LOGICAL FROM_PP
 C
@@ -125,17 +131,23 @@ C     ----------------------------------
 C
       INTEGER, DIMENSION(:), ALLOCATABLE :: MAP_RHS_loc
       INTEGER, DIMENSION(:), POINTER :: IRHS_loc_PTR
-      LOGICAL :: IRHS_loc_PTR_allocated
+      LOGICAL :: IRHS_loc_PTR_ALLOCATED
+      INTEGER(8) :: SUM_idNloc_RHS_8
       DOUBLE PRECISION, DIMENSION(:), POINTER :: idRHS_loc
       INTEGER(8) :: DIFF_SOL_loc_RHS_loc
       INTEGER(8) :: RHS_loc_size, RHS_loc_shift
       INTEGER(8)  :: NBT
       INTEGER     :: NBCOL, COLSIZE, JBEG_RHS, JEND_RHS, JBEG_NEW,
-     &               NBCOL_INBLOC, IPOS, IPOSRHSCOMP
+     &               NBCOL_INBLOC, IPOS, IPOSRHSINTR
+C     Nb of pruned NE_STEPS, useful for FWD step; and list of root nodes
+      LOGICAL    :: fill
+      INTEGER, DIMENSION(:), ALLOCATABLE ::  Pruned_Sons_FWD, 
+     &                                       Pruned_Sons_BWD
       INTEGER, DIMENSION(:), ALLOCATABLE :: PERM_RHS
-      INTEGER, DIMENSION(:), POINTER :: PTR_POSINRHSCOMP_FWD,
-     &                                  PTR_POSINRHSCOMP_BWD
+      INTEGER, DIMENSION(:), POINTER :: PTR_POSINRHSINTR_FWD,
+     &                                  PTR_POSINRHSINTR_BWD
       DOUBLE PRECISION, DIMENSION(:), POINTER :: PTR_RHS
+      INTEGER, DIMENSION(:), POINTER :: idIPTR_WORKING, idWORKING
       INTEGER :: SIZE_IPTR_WORKING, SIZE_WORKING
 C     NRHS_NONEMPTY: holds
 C         either the original number of RHS (id%NRHS defined on host)
@@ -191,11 +203,12 @@ C     arrays only used for distributed m
 C     (KEEP(54) .NE. 0).
       DOUBLE PRECISION,    ALLOCATABLE, DIMENSION(:) :: R_LOCWK54
       DOUBLE PRECISION, ALLOCATABLE, DIMENSION(:) :: C_LOCWK54
-      INTEGER   :: NBENT_RHSCOMP, NB_FS_RHSCOMP_F,
-     &             NB_FS_RHSCOMP_TOT
+      INTEGER   :: NBENT_RHSINTR, NB_FS_RHSINTR_F,
+     &             NB_FS_RHSINTR_TOT
       INTEGER, DIMENSION(:), ALLOCATABLE :: UNS_PERM_INV
       LOGICAL :: UNS_PERM_INV_NEEDED_INMAINLOOP,
-     &           UNS_PERM_INV_NEEDED_BEFMAINLOOP
+     &           UNS_PERM_INV_NEEDED_BEFMAINLOOP,
+     &           UNS_PERM_INV_NEEDED_ONSLAVES
       INTEGER LIWK_SOLVE, LIWCB
       INTEGER, ALLOCATABLE :: IW1(:), IWK_SOLVE(:), IWCB(:)
       INTEGER ::  LIWK_PTRACB
@@ -214,7 +227,7 @@ C     SCALING issues:
 C       When scaling was performed
 C       RHS holds the solution of the scaled system
 C       The unscaled second member (b0) was given
-C       then we have to scale both rhs adn solution:
+C       then we have to scale both rhs and solution:
 C        A(sca) = LU  = D1*A*D2 , with D2 = COLSCA
 C                                      D1 = ROWSCA
 C        --------------
@@ -222,33 +235,65 @@ C        CASE OF A X =B
 C        --------------
 C         (ICNTL(9)=1 or MTYPE=1)
 C           A*x0 = b0
-C           b(sca) = D1 * b0 = ROWSCA*S(ISTW3)
+C           b(sca) = D1 * b0 = ROWSCA*b0
 C           A(sca) [(D2) **(-1)] x0 = b(sca)
-C           so the computed solution by Check y0 of LU *y0 = b(sca)
-C           is : y0 =[(D2) **(-1)] x0 and so x0= D2*y0 is modified
+C           so the computed solution of LU * x(sca) = b(sca)
+C           is : x(sca) =[(D2) **(-1)] x0 and so x0= D2*x(sca)
 C        --------------
 C        CASE OF AT X =B
 C        --------------
 C         (ICNTL(9).NE.1 or MTYPE=0)
 C           A(sca) = LU  = D1*A*D2
-C           AT*x0 = b0 => D2ATD1 D1-1 x0 = D2b0
-C           b(sca) = D2 * b0 = COLSCA*S(ISTW3)
+C           AT*x0 = b0 => D2*AT*D1 * D1-1 x0 = D2 * b0
+C           b(sca) = D2 * b0 = COLSCA*b0
 C           A(sca)T [(D1) **(-1)] x0 = b(sca)
-C           so the computed solution by Check y0 of LU *y0 = b(sca)
-C           is : y0 =[(D1) **(-1)] x0 and so x0= D1*y0 is modified
+C           so the computed solution of (LU)^T * x(sca) = b(sca)
+C           is : x(sca) =[(D1) **(-1)] x0 and so x0= D1*y0 is modified
 C
-C      In case of distributed RHS we need
-C      scaling information on each processor
+C     In case of distributed RHS or distributed solution we need
+C     scaling information on each processor and this information has
+C     been stored in ROWSCA_loc(1:INFO(23)) and COLSCA_loc(1:INFO(23))
+C     such that:
+C
+C     ----------------
+C     CASE OF A X  = B
+C     ----------------
+C
+C     - the scaling factor of row i of A is stored on the
+C     processor for which GLOB2LOC_RHS(i) > 0 at position
+C     ROWSCA_loc(GLOB2LOC_RHS(i))
+C     
+C     - the scaling factor of column j of A is stored on the
+C     processor for which GLOB2LOC_SOL(j) > 0 at position
+C     COLSCA_loc(GLOB2LOC_SOL(j))
+C
+C     ------------------
+C     CASE OF A^T X  = B
+C     ------------------
+C
+C     - the scaling factor of row i of A^T is stored on the
+C     processor for which GLOB2LOC_RHS(i) > 0 at position
+C     COLSCA_loc(GLOB2LOC_RHS(i))
+C     
+C     - the scaling factor of column j of A^T is stored on the
+C     processor for which GLOB2LOC_SOL(j) > 0 at position
+C     ROWSCA_loc(GLOB2LOC_SOL(j))
 C
+#if defined(USE_OLD_SCALING)
           type scaling_data_t
             SEQUENCE
-            DOUBLE PRECISION, dimension(:), pointer :: SCALING
-            DOUBLE PRECISION, dimension(:), pointer :: SCALING_LOC
+            DOUBLE PRECISION   , dimension(:), pointer :: SCALING
+            DOUBLE PRECISION   , dimension(:), pointer :: SCALING_LOC
+            INTEGER, dimension(:), pointer :: SCALING_IND
           end type scaling_data_t
-          type (scaling_data_t) :: scaling_data_sol, scaling_data_dr
-C      To scale on the fly during GATHER SOLUTION
+          type (scaling_data_t) :: scaling_data_dr
+          type (scaling_data_t) :: scaling_data_sol
+C      To scale on the fly during GATHER SOLUTION:
           DOUBLE PRECISION, DIMENSION(:), POINTER :: PT_SCALING
           DOUBLE PRECISION, TARGET                :: Dummy_SCAL(1)
+#else
+          INTEGER :: ROWORCOL
+#endif
 C
 C  ==================== END OF SCALING related data ================
 C
@@ -273,8 +318,8 @@ C     Interval associated to the subbloc
      &        MASTER_ROOT, MASTER_ROOT_IN_COMM
       INTEGER SIZE_ROOT, LD_REDRHS
       INTEGER(8) :: IPT_RHS_ROOT
-      INTEGER(8) :: IBEG, IBEG_RHSCOMP, KDEC, IBEG_loc, IBEG_REDRHS
-      INTEGER LD_RHSCOMP, NCOL_RHS_loc
+      INTEGER(8) :: IBEG, IBEG_RHSINTR, KDEC, IBEG_loc, IBEG_REDRHS
+      INTEGER NCOL_RHS_loc
       INTEGER LD_RHS_loc, JBEG_RHS_loc
       INTEGER NB_K133, IRANK, TSIZE
       INTEGER KMAX_246_247
@@ -292,8 +337,25 @@ C  Vampir
       INTEGER soln_drive_class, glob_comm_ini, perm_scal_ini, soln_dist,
      &        soln_assem, perm_scal_post
 #endif
-      LOGICAL I_AM_SLAVE, BUILD_POSINRHSCOMP
+      LOGICAL I_AM_SLAVE, BUILD_POSINRHSINTR
       LOGICAL :: BUILD_RHSMAPINFO
+      DOUBLE PRECISION, TARGET :: RDUMMY_TARGET(1)
+      LOGICAL :: ES_RHSINTR
+      INTEGER, DIMENSION(:), POINTER :: nodes_FWD, nodes_BWD
+C     to manage sparsity: compute target nodes for starting chains
+C     Lnodes_FWD/Lnodes_BWD = -1 => all nodes to be processed
+      INTEGER, DIMENSION(:), POINTER :: nodes_FWD_PTR, nodes_BWD_PTR
+      INTEGER :: Lnodes_FWD, Lnodes_BWD, Lnodes_FWD_PTR, Lnodes_BWD_PTR
+      DOUBLE PRECISION, POINTER, DIMENSION(:) :: SCALING_loc_FWD
+      DOUBLE PRECISION, POINTER, DIMENSION(:) :: SCALING_loc_BWD
+      DOUBLE PRECISION, POINTER, DIMENSION(:) :: SCALING_RHSINTR_BWD
+      DOUBLE PRECISION, POINTER, DIMENSION(:) :: SCALING_RHSINTR_FWD
+      INTEGER :: LSCALING_RHSINTR_BWD, LSCALING_RHSINTR_FWD
+      LOGICAL :: SCALING_RHSINTR_BWD_ALLOCATED,
+     &           SCALING_RHSINTR_FWD_ALLOCATED,
+     &           BUILD_SCALING_RHSINTR
+C    NSOL_loc will be equal to KEEP(89) in case ICNTL(21)=1
+      INTEGER :: NSOL_loc
       LOGICAL WORK_WCB_ALLOCATED, IS_INIT_OOC_DONE
       LOGICAL :: IS_LR_MOD_TO_STRUC_DONE
       INTEGER :: KEEP350_SAVE
@@ -303,7 +365,6 @@ C  Vampir
       INTEGER  MAT_ALLOC_LOC, MAT_ALLOC
       INTEGER MUMPS_PROCNODE
       EXTERNAL MUMPS_PROCNODE
-      INTEGER(8) :: FILE_SIZE,STRUC_SIZE
 C
 C  First executable statement
 C
@@ -318,9 +379,25 @@ C
       CALL VTFUNCDEF( 'perm_scal_post',soln_drive_class,
      &     perm_scal_post,IERR)
 #endif
+C     Depending on the type of parallelism,
+C     the master can have the role of a slave
+      I_AM_SLAVE = ( id%MYID .ne. MASTER  .OR.
+     &             ( id%MYID .eq. MASTER .AND.
+     &               id%KEEP(46) .eq. 1 ) )
 C     -- The following pointers xxCOPY might be allocated but then
 C     -- the associated xxCOPY_ALLOCATED will be set to
 C     -- enable deallocation
+      SCALING_RHSINTR_FWD_ALLOCATED = .FALSE.
+      SCALING_RHSINTR_BWD_ALLOCATED = .FALSE.
+C     Initialize scalings to possilby pass them as arguments
+C     (e.g. to DMUMPS_DS_ALL2ALL) even on non working host
+C     and/or when LSCAL is false
+      SCALING_RHSINTR_FWD => RDUMMY_TARGET
+      SCALING_RHSINTR_BWD => RDUMMY_TARGET
+      LSCALING_RHSINTR_FWD = 1
+      LSCALING_RHSINTR_BWD = 1
+      SCALING_LOC_FWD => RDUMMY_TARGET
+      SCALING_LOC_BWD => RDUMMY_TARGET
       IRHS_PTR_COPY => IDUMMY_TARGET
       IRHS_PTR_COPY_ALLOCATED = .FALSE.
       IRHS_SPARSE_COPY => IDUMMY_TARGET
@@ -329,10 +406,16 @@ C     -- enable deallocation
       RHS_SPARSE_COPY_ALLOCATED=.FALSE.
       NULLIFY(RHS_IR)
       NULLIFY(WORK_WCB)
+#if defined(USE_OLD_SCALING)
       NULLIFY(scaling_data_dr%SCALING)
       NULLIFY(scaling_data_dr%SCALING_LOC)
+      NULLIFY(scaling_data_dr%SCALING_IND)
       NULLIFY(scaling_data_sol%SCALING)
       NULLIFY(scaling_data_sol%SCALING_LOC)
+      NULLIFY(scaling_data_sol%SCALING_IND)
+#endif
+      NULLIFY(nodes_FWD)
+      NULLIFY(nodes_BWD)
       IRHS_loc_PTR_allocated = .FALSE.
       IS_INIT_OOC_DONE   = .FALSE.
       IS_LR_MOD_TO_STRUC_DONE = .FALSE.
@@ -344,9 +427,6 @@ C     -- enable deallocation
       IS   =>id%IS
       ICNTL=>id%ICNTL
       INFO =>id%INFO
-C      ASPK =>id%A
-C      COLSCA =>id%COLSCA
-C      ROWSCA =>id%ROWSCA
       RINFOG =>id%RINFOG
       LP  = ICNTL( 1 )
       MP  = ICNTL( 2 )
@@ -366,7 +446,7 @@ C      ROWSCA =>id%ROWSCA
       K34_8    = int(KEEP(34), 8)
       K35_8    = int(KEEP(35), 8)
       K16_8    = int(KEEP(16), 8)
-      NBENT_RHSCOMP = 0
+      NBENT_RHSINTR = 0
 C     Used by DISTRIBUTED_SOLUTION to skip empty columns
 C     that are skipped (case of sparse RHS)
       NB_RHSSKIPPED = 0
@@ -375,47 +455,48 @@ C     to free space allocated
       LSCAL              = .FALSE.
       WORK_WCB_ALLOCATED = .FALSE.
       ICNTL21  = -99998  ! will be bcasted later to slaves
-      IBEG_RHSCOMP =-152525_8  ! Should not be used
-      BUILD_POSINRHSCOMP = .TRUE.
+      IBEG_RHSINTR =-152525_8  ! Should not be used
+      BUILD_POSINRHSINTR      = .TRUE.
+C     NSOL_loc, KEEP(212) will be set if ICNTL(21).EQ.2
+      NSOL_loc = 0
+      KEEP(212)= 0
+C     SCALING_RHSINTR was initialized to a dummy array of size 1
+C     on the non working host, no need to reset it at each block
+      BUILD_SCALING_RHSINTR = I_AM_SLAVE
       IBEG_GLOB_DEF = -9888  ! unitialized state
       IEND_GLOB_DEF = -9888  ! unitialized state
       IBEG_ROOT_DEF = -9777  ! unitialized state
       IEND_ROOT_DEF = -9777  ! unitialized state
       IROOT_DEF_RHS_COL1 = -9666 ! unitialized state
-C     Not needed anymore (since new version of gather)
-C     LD_RHSCOMP = max(KEEP(89),1)  ! at the nb of pivots eliminated on
-                                    ! that proc
-      LD_RHSCOMP = 1
-      NB_FS_RHSCOMP_TOT = KEEP(89)
+C     ------------------------------
+C     id%LD_RHSINTR will be set each
+C     time RHSINTR is allocated
+C     ------------------------------
+      NB_FS_RHSINTR_TOT = KEEP(89)
 !     number of FS var of the pruned tree
 !     mapped on this proc
-      NB_FS_RHSCOMP_F = NB_FS_RHSCOMP_TOT
+      NB_FS_RHSINTR_F = NB_FS_RHSINTR_TOT
 C     Save value of KEEP(350), in case of LR solve
 C     KEEP(350) may be overwritten and restored
 C     Old unoptimized version before 5.0.2 not available anymore
       IF (KEEP(350).LE.0) KEEP(350)=1
       IF (KEEP(350).GT.2) KEEP(350)=1
       KEEP350_SAVE = KEEP(350)
-C
-C     Depending on the type of parallelism,
-C     the master can have the role of a slave
-      I_AM_SLAVE = ( id%MYID .ne. MASTER  .OR.
-     &             ( id%MYID .eq. MASTER .AND.
-     &               KEEP(46) .eq. 1 ) )
 C     
 C     Compute the number of integers and nb of reals in the structure
       CALL DMUMPS_SIZE_IN_STRUCT (id, NB_INT, NB_CMPLX, NB_CHAR)
       NB_BYTES = NB_BYTES + NB_INT * K34_8 + NB_CMPLX * K35_8 + NB_CHAR
       NB_BYTES_ON_ENTRY = NB_BYTES !used to check alloc/dealloc count ok
-      CALL DMUMPS_COMPUTE_MEMORY_SAVE(id,FILE_SIZE,STRUC_SIZE)
       NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
 C     ======================================
 C     BEGIN CHECK KEEP ENTRIES AND INTERFACE
 C     ======================================
       IF (id%MYID .EQ. MASTER) THEN
 C     {
-c     subroutine only because called at facto and solve
-          CALL DMUMPS_SET_K221(id)
+C         Set ICNTL(26) -> KEEP(221)  (called at facto and solve)
+C         (might be called at facto in case of fwd in facto 
+C          with Schur+reduced RHS requested)
+          CALL DMUMPS_SET_K221(id, .TRUE.)
           id%KEEP(111) = id%ICNTL(25)
 C         For the case of ICNTL(20)=1 one could
 C         switch off exploit sparsity when RHS is too dense.
@@ -430,8 +511,12 @@ C         switch off exploit sparsity wh
           ELSE
             id%KEEP(248) = 0 !dense RHS
           ENDIF
+C
+C         set ICNTL21 and test for out-of range entries
           ICNTL21      = id%ICNTL(21)
-          IF (ICNTL21 .ne.0.and.ICNTL21.ne.1) ICNTL21=0
+          IF ( ICNTL21.NE.0 .AND. ICNTL21.NE.1
+     &       ) ICNTL21 = 0
+C
           IF ( id%ICNTL(30) .NE.0 ) THEN
 C           A-1 is on
             id%KEEP(237) = 1
@@ -445,25 +530,81 @@ C            Force KEEP(248) accordingly
              id%KEEP(248)=1
           ENDIF
           IF ((id%KEEP(221).EQ.2 ).AND.(id%KEEP(248).NE.0) ) THEN
-C          -- input RHS is indeed stored in REDRHS and RHSCOMP
-           id%KEEP(248) = 0
+           IF (KEEP(60).NE.0) THEN
+C            -- input RHS is stored in REDRHS and RHSINTR
+             id%KEEP(248) = 0
+           ENDIF
           ENDIF
+C}
+      ENDIF
+C     =============================================================
+C     KEEP(248) and KEEP(221): need be broadcasted
+C     before continuing other checking/settings
+      CALL MPI_BCAST( id%KEEP(221), 1, MPI_INTEGER, MASTER, id%COMM,
+     &                  IERR )
+      CALL MPI_BCAST( id%KEEP(248), 1, MPI_INTEGER, MASTER, id%COMM,
+     &                  IERR )
+      IF (KEEP(248).EQ.-1
+     &  ) THEN
+C{
+        CALL DMUMPS_CHECK_DISTRHS(
+     &       id%Nloc_RHS,
+     &       id%LRHS_loc,
+     &       id%NRHS,
+     &       id%IRHS_loc,
+     &       id%RHS_loc,
+     &       I_AM_SLAVE,
+     &       id%INFO)
+        CALL MUMPS_PROPINFO( id%ICNTL(1),
+     &                      id%INFO(1),
+     &                      id%COMM, id%MYID )
+        IF ( id%INFO(1) .LT. 0 ) GO TO 90
+C         Compute sum of id%Nloc_RHS (without out-of-range)
+C         and store it in SUM_idNloc_RHS_8
+C         (to be used to decide whether exploit sparsity 
+C         is exploited)
+          CALL DMUMPS_ES_GET_SUM_Nloc ( 
+     &             id%N, id%Nloc_RHS, id%IRHS_loc, id%COMM,
+     &             SUM_idNloc_RHS_8 )
+C}
+      ENDIF
+C     ===========================================================
+      IF (id%MYID .EQ. MASTER) THEN
+C     {
           IF ((id%KEEP(221).EQ.2 ).AND.(id%KEEP(235).NE.0) ) THEN
 C          -- input RHS is in fact effectively
-C          -- stored in REDRHS and RHSCOMP
-           id%KEEP(235) = 0
+C          -- stored in REDRHS and/or RHSINTR
+C          (for both Schur and bwd only)
+            id%KEEP(235) = 0
           ENDIF
           IF ( (id%KEEP(248).EQ.0).AND.(id%KEEP(111).EQ.0) ) THEN
 C           RHS is not sparse and thus exploit sparsity is reset to 0
             id%KEEP(235) = 0
           ENDIF
-          IF (KEEP(248) .EQ. -1) THEN
-C           V0 distributed RHS: no ES
-            id%KEEP(235) = 0
+          IF (id%KEEP(248) .EQ. -1
+     &       ) THEN
+            IF (id%KEEP(126).EQ.0)  THEN
+             id%KEEP(235) = 0
+            ELSE IF (id%KEEP(126).EQ.-1)  THEN
+             id%KEEP(235) = 1
+            ELSE IF (id%KEEP(126).GT.0) THEN
+             IF ( SUM_idNloc_RHS_8 .LE. 
+     &        int( 
+     &          (dble(id%KEEP(126))/dble(1000))*dble(id%N)
+     &          , 8)
+     &          ) THEN
+               id%KEEP(235) = 1
+             ELSE
+               id%KEEP(235) = 0
+             ENDIF
+            ELSE
+             id%KEEP(235) = 0
+            ENDIF
           ENDIF
 C         Case of Automatic setting of exploit sparsity (KEEP(235)=-1)
 C         (in MUMPS_DRIVER original value of KEEP(235) is reset)
           IF(id%KEEP(111).NE.0) id%KEEP(235)=0
+          IF(id%KEEP(111).NE.0) id%KEEP(212)=0
 C
           IF (id%KEEP(235).EQ.-1) THEN
             IF (id%KEEP(237).NE.0) THEN
@@ -476,8 +617,10 @@ C            for A-1
             id%KEEP(235)=1
           ENDIF
 C         Setting of KEEP(242) (permute RHS)
-          IF ((KEEP(111).NE.0)) THEN
-C          In the context of null space, the null pivots
+          IF ((KEEP(111).NE.0).OR.(KEEP(248) .EQ. -1)) THEN
+C          In the context of 
+C          - distributed RHS, all columns share the same structure
+C          - null space, the null pivots
 C          are by default permuted to post-order
 C          However for null space there is in this case no need to
 C          permute null pivots since they are already in correct order.
@@ -520,8 +663,8 @@ C           Automatic setting of permute
             ENDIF
 C           }
           ENDIF
-          IF ( (id%KEEP(221).EQ.1 ).AND.(id%KEEP(235).NE.0) ) THEN
-C          -- Do not permute RHS with REDRHS for the time being
+          IF ( id%KEEP(221).NE.0 ) THEN
+C          -- Do not permute RHS with REDRHS/RHSINTR 
             id%KEEP(242) = 0
           ENDIF
           IF (KEEP(242).EQ.0) KEEP(243)=0 ! interleave off
@@ -575,24 +718,31 @@ C
           ENDIF
 C     }
       ENDIF
+      id%KEEP(401) = 0
+      IF (id%ICNTL(48).EQ.1) id%KEEP(401)=1
 C     Bcast id%KEEP(401) strategy (which
 C     may be switched off or on during solve)
       CALL MPI_BCAST( id%KEEP(401), 1, MPI_INTEGER, MASTER, id%COMM,
      &                  IERR )
+C     define ICNTL48_EFF on master
+      IF (id%MYID.EQ.MASTER) THEN
+        IF ( (id%KEEP(401).EQ.1). AND. (id%KEEP(400).GT.0) ) THEN
+          ICNTL48_EFF = 1
+        ELSE
+          ICNTL48_EFF = 0
+        ENDIF
+      ENDIF
       CALL MPI_BCAST(MTYPE,1,MPI_INTEGER,MASTER,
      &               id%COMM,IERR)
       CALL MPI_BCAST( id%KEEP(111), 1, MPI_INTEGER, MASTER, id%COMM,
      &                  IERR )
-      CALL MPI_BCAST( id%KEEP(221), 1, MPI_INTEGER, MASTER, id%COMM,
-     &                  IERR )
       CALL MPI_BCAST( id%KEEP(235), 1, MPI_INTEGER, MASTER, id%COMM,
      &                  IERR )
       CALL MPI_BCAST( id%KEEP(237), 1, MPI_INTEGER, MASTER, id%COMM,
      &                  IERR )
       CALL MPI_BCAST( id%KEEP(242), 2, MPI_INTEGER, MASTER, id%COMM,
      &                  IERR )
-      CALL MPI_BCAST( id%KEEP(248), 1, MPI_INTEGER, MASTER, id%COMM,
-     &                  IERR )
+C Allready done   CALL MPI_BCAST( id%KEEP(248), ...)
       CALL MPI_BCAST( id%KEEP(350), 1, MPI_INTEGER, MASTER, id%COMM,
      &                  IERR )
       CALL MPI_BCAST( id%KEEP(485), 1, MPI_INTEGER, MASTER, id%COMM,
@@ -700,7 +850,7 @@ C            Fwd in facto is not compati
              INFO(2) = 9
              IF (LPOK) THEN
                 WRITE(LP,'(A)')
-     &               ' ERROR: Transpose system (ICNTL(9).NE.0) not ',
+     &               ' ERROR: Transpose system (ICNTL(9).NE.1) not ',
      &               ' compatible with forward performed during',
      &               ' factorization (ICNTL(32)=1)'
              ENDIF
@@ -773,27 +923,30 @@ C            Sparse RHS may be due to A-
           ENDIF
 C         Entries of A-1 are stored in place of the input sparse RHS
 C         thus no need for RHS to be allocated.
-          IF ( (id%KEEP(237).EQ.0) ) THEN
+          IF (id%KEEP(237).EQ.0)  THEN
              IF ((id%KEEP(248) == 0 .AND.KEEP(221).NE.2)
-     &            .OR. ICNTL21==0) THEN
-C              RHS must be of size N on the master either to
+     &            .OR. 
+     &            (ICNTL21==0.AND.(KEEP(221).NE.1)) 
+     &          )THEN
+C              RHS must be of size N*NRHS on the master either to
 C              store the dense centralized RHS, either to store
 C              the dense centralized solution.
-               CALL DMUMPS_CHECK_DENSE_RHS
-     &         (id%RHS,id%INFO,id%N,id%NRHS,id%LRHS)
-               IF (id%INFO(1) .LT. 0) GOTO 333
+                CALL DMUMPS_CHECK_DENSE_RHS
+     &          (id%RHS,id%INFO,id%N,id%NRHS,id%LRHS)
+                IF (id%INFO(1) .LT. 0) GOTO 333
              ENDIF
           ELSE
-C           Check that the constraint NRHS=N is respected
+C           AM1: check that the constraint NRHS=N is respected
 C           Check for valid sparse RHS structure done
             IF (id%NRHS .NE. id%N) THEN
-              id%INFO(1)=-47
+              id%INFO(1)= -47
               id%INFO(2)=id%NRHS
               GOTO 333
             ENDIF
           ENDIF
-          IF (id%KEEP(248) == 1) THEN
-C           ------------------------------------
+          IF (id%KEEP(248) == 1
+     &       ) THEN
+C{          ------------------------------------
 C           RHS_SPARSE, IRHS_SPARSE and IRHS_PTR
 C           must be allocated of adequate size
 C           ------------------------------------
@@ -866,6 +1019,7 @@ C             Possible in case of duppli
               id%INFO(2)=10
               GOTO 333
             END IF
+C}
           ENDIF
 C         --------------------------------
 C         Set null space options for solve
@@ -879,16 +1033,20 @@ C
 C     --------------------------------------
 C     Check distributed solution vectors
 C     --------------------------------------
-      IF (ICNTL21==1) THEN
-          IF ( I_AM_SLAVE ) THEN
+      IF (ICNTL21 .NE. 0 ) THEN 
+          IF (I_AM_SLAVE) THEN
+            NSOL_loc = id%KEEP(89)
+          ELSE
+            NSOL_loc = 0
+          ENDIF
 C           (I)SOL_loc should be allocated to hold the
 C           distributed solution on exit
-            IF ( id%LSOL_loc < id%KEEP(89) ) THEN
+            IF ( id%LSOL_loc .LT. NSOL_loc ) THEN
               id%INFO(1)= -29
               id%INFO(2)= id%LSOL_loc
               GOTO 333
             ENDIF
-            IF (id%KEEP(89) .NE. 0) THEN
+            IF ( NSOL_loc .GT. 0 ) THEN
               IF ( .not. associated(id%ISOL_loc) )THEN
                 id%INFO(1)=-22
                 id%INFO(2)=13
@@ -899,7 +1057,7 @@ C           distributed solution on exit
                 id%INFO(2)=14
                 GOTO 333
               ENDIF
-              IF (size(id%ISOL_loc) < id%KEEP(89) ) THEN
+              IF (size(id%ISOL_loc) < NSOL_loc ) THEN
                 id%INFO(1)=-22
                 id%INFO(2)=13
                 GOTO 333
@@ -913,7 +1071,7 @@ C             can result in such a situa
 C             suppressed if needed but might be still be ok in case
 C             the right-hand side overflows too.
               IF (size(id%SOL_loc) <
-     &              (id%NRHS-1)*id%LSOL_loc+id%KEEP(89)) THEN
+     &              (id%NRHS-1)*id%LSOL_loc+NSOL_loc) THEN
                 id%INFO(1)=-22
                 id%INFO(2)=14
                 GOTO 333
@@ -921,17 +1079,17 @@ C             the right-hand side overfl
 #             else
               IF (size(id%SOL_loc,kind=8) <
      &              int(id%NRHS-1,8)*int(id%LSOL_loc,8)+
-     &              int(id%KEEP(89),8)) THEN
+     &              int(NSOL_loc,8)) THEN
                 id%INFO(1)=-22
                 id%INFO(2)=14
                 GOTO 333
               END IF
 #             endif
-            ENDIF
-          ENDIF
-      ENDIF
+            ENDIF ! NSOL_loc > 0
+      ENDIF ! ICNTL21 .NE. 0
       IF (id%MYID .NE. MASTER) THEN
-          IF (id%KEEP(248) == 1) THEN
+          IF (id%KEEP(248) == 1
+     &    ) THEN
 C          RHS should NOT be associated
 C          if I am not master since it is
 C          not even used to store the solution
@@ -957,16 +1115,6 @@ C          not even used to store the so
            END IF
           END IF
       ENDIF
-      IF (I_AM_SLAVE .AND. id%KEEP(248).EQ.-1) THEN
-        CALL DMUMPS_CHECK_DISTRHS(
-     &       id%Nloc_RHS,
-     &       id%LRHS_loc,
-     &       id%NRHS,
-     &       id%IRHS_loc,
-     &       id%RHS_loc,
-     &       id%INFO)
-        IF (id%INFO(1) .LT. 0) GOTO 333
-      ENDIF
 C     Prepare pointers to pass POINTERS(1) to
 C     routines with implicit interfaces which
 C     will then assume contiguous information
@@ -993,11 +1141,17 @@ C         so that IRHS_loc_PTR(1) is ok
       ELSE
         idRHS_loc=>CDUMMY_TARGET
       ENDIF
-      IF (I_AM_SLAVE .AND. ICNTL21.EQ.1 .AND.
-     &    KEEP(248) .EQ. -1) THEN  ! Dist RHS and dist solution
+C
+C
+C     Check as soon as solution is distributed
+      IF (I_AM_SLAVE .AND. ICNTL21.NE.0 .AND.
+     &    KEEP(248) .EQ. -1
+     &    ) THEN  ! Dist RHS and dist solution
+C
         IF (associated(id%RHS_loc) .AND.
      &      associated(id%SOL_loc)) THEN
-          IF (id%KEEP(89).GT.0) THEN
+C         NSOL_loc was defined earlier
+          IF (NSOL_loc.GT.0) THEN
 C           ----------------------------------------------------
 C           Check if RHS_loc and SOL_loc point to same object...
 C           id%SOL_loc(1) ok otherwise an error -22/14
@@ -1024,13 +1178,14 @@ C              we raise the error system
      &" ** Error RHS_loc and SOL_loc pointers match but LRHS_loc="
      &,id%LRHS_loc, " and LSOL_loc=", id%LSOL_loc
                ENDIF
+               GOTO 333
             ENDIF
           ENDIF
         ENDIF
       ENDIF
       IF (id%MYID.EQ.MASTER) THEN
-C         Do some checks (REDRHS), depending on KEEP(221)
-          CALL DMUMPS_CHECK_REDRHS(id)
+C         Do some checks on KEEP(221) and REDRHS (in case of Schur)
+          CALL DMUMPS_CHECK_K221andREDRHS(id)
       END IF ! MYID.EQ.MASTER
       IF (id%INFO(1) .LT. 0) GOTO 333
 C     -------------------------
@@ -1044,16 +1199,28 @@ C     -------------------------
 C     ====================================
 C     END CHECK INTERFACE AND KEEP ENTRIES
 C     ====================================
-C     ====================================
-C     Process case of NZ_RHS = 0  with
-C     sparse RHS and General Sparse (NOT A-1)
 C     -----------------------------------
       IF ((id%KEEP(248).EQ.1).AND.(id%KEEP(237).EQ.0)) THEN
-C
        CALL MPI_BCAST(id%NZ_RHS,1,MPI_INTEGER,MASTER,
      &               id%COMM,IERR)
+      ENDIF
 C
-       IF (id%NZ_RHS.EQ.0) THEN
+C     =======================================================
+C     BEGIN Test for empty RHS :
+C     sparse RHS and General Sparse (NOT A-1) and  NZ_RHS = 0
+C     OR
+C     Distributed RHS and sum of id%Nloc_RHS 
+C     (without off out-of-range) equal to 0
+C     =======================================================
+      IF 
+     & (
+     &     ( (id%KEEP(248).EQ.1).AND.(id%KEEP(237).EQ.0)
+     &       .AND. (id%NZ_RHS.EQ.0) ) 
+     &     .OR.
+     &     ( (id%KEEP(248).EQ.-1).AND. (SUM_idNloc_RHS_8.EQ.0_8)
+     &     ) 
+     & )  THEN
+C{      
 C       We reset solution to zero and we return
 C       (first freeing working space at label 90)
         IF ((ICNTL21.EQ.1).AND.(I_AM_SLAVE)) THEN
@@ -1073,38 +1240,46 @@ C         Note that LSOL_loc >= KEEP(89)
      &               id%KEEP(1),id%KEEP8(1),
      &               id%IS(1), LIW_PASSED,id%MYID_NODES,
      &               id%N, id%STEP(1), id%PROCNODE_STEPS(1),
-     &               id%NSLAVES, scaling_data_sol, LSCAL
+     &               id%NSLAVES,
+#if defined(USE_OLD_SCALING)
+     &               scaling_data_sol, .FALSE., ! empty RHS, no scaling
+#endif
 C                    For checking only
-     &               , .FALSE., IDUMMY(1), 1
+     &               .FALSE., IDUMMY(1), 1
      &               )
+          ENDIF
+        ENDIF
+C       Solution is null
+        IF (ICNTL21.NE.0) THEN  ! distributed solution
             DO J=1, id%NRHS
-              DO I=1, KEEP(89)
-                id%SOL_loc((J-1)*id%LSOL_loc + I) =ZERO
+C             (NSOL_loc=KEEP(89) or id%NSOL_loc, and in case
+C              ICNTL21=1, NSOL_loc is 0 on non-working host)
+              DO I=1, NSOL_loc
+                id%SOL_loc(int(J-1,8)*id%LSOL_loc + I) =ZERO
               ENDDO
             ENDDO
-          ENDIF
         ENDIF
-        IF (ICNTL21.NE.1) THEN  ! centralized solution
+        IF (ICNTL21.EQ.0) THEN  ! centralized solution
 C       ----------------------------
 C       RHS reset to zero on master
 C       ----------------------------
-         IF (id%MYID.EQ.MASTER) THEN
+          IF (id%MYID.EQ.MASTER) THEN
             DO J=1, id%NRHS
               DO I=1, id%N
                 id%RHS(int(J-1,8)*int(id%LRHS,8) + int(I,8)) =ZERO
               ENDDO
             ENDDO
-         ENDIF
+          ENDIF
         ENDIF
 C
 C       print solve phase stats if requested
         IF ( PROKG )  THEN
-C          write(6,*) " NZ_RHS is zero "
-           WRITE( MPG, 150 )
+            WRITE( MPG, 150 )
 C             ICNTL(35) should not been accessed during SOLVE thus
 C             print KEEP(486) value set during factorization
      &        id%NRHS, ICNTL(27), ICNTL(9), ICNTL(10), ICNTL(11),
-     &        ICNTL(20), ICNTL(21), ICNTL(30), KEEP(486)
+     &        ICNTL(20), ICNTL(21), ICNTL(30), KEEP(486), 
+     &        ICNTL48_EFF
            IF (KEEP(221).NE.0) THEN
             WRITE (MPG, 152) KEEP(221)
            ENDIF
@@ -1115,16 +1290,28 @@ C             print KEEP(486) value set
 C
 C       --------
         GOTO 90 ! end of solve deallocate what is needed
-C       ====================================
-C       END CHECK INTERFACE AND KEEP ENTRIES
-C       ====================================
-       ENDIF  ! test NZ_RHS.EQ.0
-C      --------
-      ENDIF ! (id%KEEP(248).EQ.1).AND.(id%KEEP(237).EQ.0)
+C}
+      ENDIF  ! test empty RHS (general sparse or Distributed)
+C     =======================================================
+C     END of Test for empty RHS :
+C     =======================================================
+C     ====================================
+C     END CHECK INTERFACE AND KEEP ENTRIES
+C     ====================================
       INTERLEAVE_PAR   =.FALSE.
       DO_PERMUTE_RHS   =.FALSE.
+      CALL_NODES_FWD_BWD       = .FALSE.
+      FIRST_CALL_NODES_FWD_BWD = .FALSE.
+C     Default is no sparsity exploited
+      nodes_FWD_PTR => IDUMMY_TARGET
+      nodes_BWD_PTR => IDUMMY_TARGET
+      Lnodes_FWD = -1
+      Lnodes_BWD = -1
 C
-      IF ((id%KEEP(235).NE.0).or.(id%KEEP(237).NE.0)) THEN
+      IF ((id%KEEP(235).NE.0).or.(id%KEEP(237).NE.0) 
+     &   ) THEN
+         CALL_NODES_FWD_BWD       = .TRUE.
+         FIRST_CALL_NODES_FWD_BWD = .TRUE.
 C        Case of pruned elimination tree or selected entries in A-1
          IF (id%KEEP(237).NE.0.AND.
      &        id%KEEP(248).EQ.0) THEN
@@ -1137,7 +1324,8 @@ C         sparse RHS has been forced to
           ENDIF
           CALL MUMPS_ABORT()
          ENDIF
-C        NBT is inout in MUMPS_REALLOC and should be initialized.
+C        NBT (in Bytes) is inout in MUMPS_REALLOC and 
+C                       should be initialized.
          NBT = 0
 C        -- Allocate Step2node on each proc
          CALL MUMPS_REALLOC(id%Step2node, id%KEEP(28), id%INFO, LP,
@@ -1161,26 +1349,37 @@ C          we reuse Step2node computed i
 C          Step2node is deallocated each time a new analysis is
 C          performed or when job=-2 is called
          ENDIF
-         NB_BYTES = NB_BYTES + NBT*K34_8
+C        --- NBT is the nb of extra bytes allocated
+         NB_BYTES = NB_BYTES + NBT
          NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
-         NB_BYTES_EXTRA = NB_BYTES_EXTRA + NBT * K34_8
+         NB_BYTES_EXTRA = NB_BYTES_EXTRA + NBT 
 C        Mapping information used during solve. In case of several
 C        facto+solve it has to be recomputed.
 C        In case of several solves with the same
 C        facto, it is not recomputed.
-C        It used to compute the interleaving
+C        It is used to compute the interleaving
 C        for A-1, and, in dev_version, passed to sol_c to compute
 C        some stats
          IF((KEEP(235).NE.0).OR.(KEEP(237).NE.0)) THEN
            IF(.NOT.associated(id%IPTR_WORKING)) THEN
              CALL DMUMPS_BUILD_MAPPING_INFO(id)
            END IF
+           idIPTR_WORKING => id%IPTR_WORKING
+           idWORKING => id%WORKING
+         ELSE 
+C           case of selected entries in solution
+C           with no ES during fwd
+            SIZE_WORKING = 1
+            SIZE_IPTR_WORKING = 1
+            idIPTR_WORKING => IDUMMY_TARGET
+            idWORKING => IDUMMY_TARGET
          END IF
       ENDIF
 C
 C     Initialize SIZE_OF_BLOCK from MUMPS_SOL_ES module
-      IF ( I_AM_SLAVE )
-     &  CALL DMUMPS_SOL_ES_INIT(id%OOC_SIZE_OF_BLOCK, id%KEEP(201))
+      IF ( I_AM_SLAVE ) THEN
+        CALL DMUMPS_SOL_ES_INIT(id%OOC_SIZE_OF_BLOCK, id%KEEP(201))
+      ENDIF
       DO_NULL_PIV = .TRUE.
       NBCOL_INBLOC = -9998
       NZ_THIS_BLOCK= -9998
@@ -1188,7 +1387,7 @@ C     Initialize SIZE_OF_BLOCK from MUMP
 c
       IF (id%MYID.EQ.MASTER) THEN ! Compute NRHS_NONEMPTY
 C
-C       -- Sparse RHS does
+C       -- Sparse RHS (general, centralized)
         IF ( KEEP(111)==0 .AND. KEEP(248)==1
      &   ) THEN
 C       -- Note that KEEP(111).NE.0 (null space on)
@@ -1196,8 +1395,9 @@ C       -- and KEEP(248).NE.0 will be ma
 C       -- When computing entries of A-1 (or SparseRHS only)
            NRHS_NONEMPTY = 0
            DO I=1, id%NRHS
-              IF (id%IRHS_PTR(I).LT.id%IRHS_PTR(I+1))
-     &             NRHS_NONEMPTY = NRHS_NONEMPTY+1 !ith col in non empty
+              IF (id%IRHS_PTR(I).LT.id%IRHS_PTR(I+1)) THEN
+                   NRHS_NONEMPTY = NRHS_NONEMPTY+1 !ith col in non empty
+              ENDIF
            ENDDO
            IF (NRHS_NONEMPTY.LE.0) THEN
 C           Internal error: tested before in mumps_driver
@@ -1247,6 +1447,7 @@ C     We work on a maximum of NBRHS at a
 C     The leading dimension of RHS is id%LRHS on the host process
 C     and it is set to N on slave processes.
       IF (id%MYID .eq. MASTER) THEN
+C{
         KEEP(84) = ICNTL(27)
 C     Treating ICNTL(27)=0 as if ICNTL(27)=1
         IF(ICNTL(27).EQ.0) KEEP(84)=1
@@ -1262,11 +1463,12 @@ C     Treating ICNTL(27)=0 as if ICNTL(2
           IF (NBRHS .GT. NRHS_NONEMPTY ) NBRHS = NRHS_NONEMPTY
 C
         ENDIF
+C}
       ENDIF
 #if defined(V_T)
       CALL VTBEGIN(glob_comm_ini,IERR)
 #endif
-C     NRHS_NONEMPTY needed on all procs to allocate RHSCOMP on slaves
+C     NRHS_NONEMPTY needed on all procs to allocate RHSINTR on slaves
       CALL MPI_BCAST(NRHS_NONEMPTY,1,MPI_INTEGER,MASTER,
      &               id%COMM,IERR)
       CALL MPI_BCAST(NBRHS,1,MPI_INTEGER,MASTER,
@@ -1342,7 +1544,11 @@ C
             ENDIF
           END IF
         ENDIF
-        LWCB8_MIN = int(NB_K133,8)*int(KEEP(133),8)*int(NBRHS,8)
+CPA2ALL: int(min(NRHS_NONEMPTY,NBRHS),8) instead of NBRHS
+C       LWCB8_MIN = int(NB_K133,8)*int(KEEP(133),8)*int(NBRHS,8)
+        LWCB8_MIN = int(NB_K133,8)*int(KEEP(133),8)*
+     &        int(min(NRHS_NONEMPTY,NBRHS),8)
+C
 C
 C       ---------------------------------------------------------------
 C       Set WK_USER_PROVIDED to true when workspace WK_USER is provided
@@ -1537,12 +1743,14 @@ C         Access to OOC data in module d
         ENDIF
       ENDIF
       IF (id%MYID.EQ.MASTER) THEN
+C{
         IF ( PROKG )  THEN
           WRITE( MPG, 150 )
 C             ICNTL(35) should not been accessed during SOLVE thus
 C             print KEEP(486) value set during factorization
      &        id%NRHS, NBRHS, ICNTL(9), ICNTL(10), ICNTL(11),
-     &        ICNTL(20), ICNTL(21), ICNTL(30), KEEP(486)
+     &        ICNTL(20), ICNTL(21), ICNTL(30), KEEP(486),
+     &        ICNTL48_EFF
           IF (KEEP(111).NE.0) THEN
             WRITE (MPG, 151) KEEP(111)
           ENDIF
@@ -1553,11 +1761,9 @@ C             print KEEP(486) value set
             WRITE (MPG, 153) KEEP(252)
           ENDIF
         ENDIF
-C
 C     ====================================
 C       Define LSCAL, ICNTL10 and ICNTL11
 C     ====================================
-C
         LSCAL = (((KEEP(52) .GT. 0) .AND. (KEEP(52) .LE. 8)) .OR. (
      &    KEEP(52) .EQ. -1) .OR. KEEP(52) .EQ. -2)
         ICNTL10 = ICNTL(10)
@@ -1568,71 +1774,10 @@ C       Values of ICNTL(11) out of range
            IF (PROKG) WRITE(MPG,'(A)')
      &    ' WARNING: ICNTL(11) out of range'
         ENDIF
-        POSTPros = .FALSE.
-        IF (ICNTL11.NE.0 .OR. ICNTL10.NE.0) THEN
-          POSTPros = .TRUE.
-C       FORBID ERROR ANALYSIS AND ITERATIVE REFINEMENT
-C       if there are options that are not compatible
-          IF (KEEP(111).NE.0) THEN
-C       IF WE RETURN A NULL SPACE BASIS or compute entries in A-1
-C        of Fwd in facto
-C       -When only one columns of A-1 is requested then
-C        we could try to reactivate IR even if
-C          -code need be updated
-C          -accuracy could be # when one or more columns are requested
-              IF (PROKG) WRITE(MPG,'(A,A)')
-     &       ' WARNING: Incompatible features: null space basis ',
-     &                ' and Iter. Ref and/or Err. Anal.'
-              POSTPros = .FALSE.
-           ELSE IF ( KEEP(237) .NE.0 ) THEN
-              IF (PROKG) WRITE(MPG,'(A,A)')
-     &       ' WARNING: Incompatible features: AM1',
-     &                ' and Iter. Ref and/or Err. Anal.'
-              POSTPros = .FALSE.
-           ELSE IF ( KEEP(252) .NE.0 ) THEN
-              IF (PROKG) WRITE(MPG,'(A,A)')
-     &       ' WARNING: Incompatible features: Fwd in facto ',
-     &                ' and Iter. Ref and/or Err. Anal.'
-              POSTPros = .FALSE.
-           ELSE IF (KEEP(221).NE.0) THEN
-C       Forbid error analysis and iterative refinement
-C       in case of reduced rhs/solution
-              IF (PROKG) WRITE(MPG,'(A,A)')
-     &       ' WARNING: Incompatible features: reduced RHS ',
-     &       '          and Iter. Ref and/or Err. Anal.'
-              POSTPros = .FALSE.
-            ELSE IF  (NBRHS.GT. 1 .OR. ICNTL(21) .GT. 0) THEN
-C          Forbid error analysis and iterative refinement if
-C       the solution is distributed or
-C       in the case where nrhs > 1
-              IF (PROKG) WRITE(MPG,'(A,A)')
-     &       ' WARNING:  Incompatible features: nrhs>1 or distrib sol',
-     &       '           and Iter. Ref and/or Err. Anal.'
-              POSTPros = .FALSE.
-            ELSE IF ( KEEP(248) .EQ. -1 ) THEN
-C          Forbid error analysis and iterative refinement
-C          in case of distributed RHS
-              IF (PROKG) WRITE(MPG,'(A,A)')
-     &       ' WARNING:  Incompatible features: distrib rhs',
-     &       '           and Iter. Ref and/or Err. Anal.'
-              POSTPros = .FALSE.
-            ENDIF  
-            IF (.NOT.POSTPros) THEN
-              ICNTL11 = 0
-              ICNTL10 = 0
-            ENDIF
-        ENDIF
-C   Write a warning.
-        IF ((ICNTL(10) .NE. 0) .AND. (ICNTL10 .EQ. 0)) THEN
-            IF (PROKG) WRITE(MPG,'(A)')
-     &    ' WARNING: ICNTL(10) treated as if set to 0 '
-        ENDIF
-        IF ((ICNTL(11) .NE. 0)
-     &        .AND.(ICNTL11 .EQ. 0)) THEN
-            IF (PROKG) WRITE(MPG,'(A)')
-     &    ' WARNING: ICNTL(11) treated as if set to 0 '
-        ENDIF
-C     -- end of test master
+        CALL DMUMPS_SET_POSTPros (
+     &                      KEEP(1), ICNTL(1), NBRHS, MPG, PROKG,
+     &                      ICNTL10, ICNTL11, POSTPros)
+C}    -- end of test master
       END IF
       CALL MPI_BCAST(POSTPros,1,MPI_LOGICAL,MASTER,
      &               id%COMM,IERR)
@@ -1687,28 +1832,29 @@ C        allocated, otherwise MAT_ALLOC_
       CALL MPI_REDUCE( MAT_ALLOC_LOC, MAT_ALLOC, 1,
      &                 MPI_INTEGER,
      &                 MPI_MIN, MASTER, id%COMM, IERR)
-      IF ( id%MYID .eq. MASTER ) THEN
+      IF ( POSTPros.and.(id%MYID .eq. MASTER) ) THEN
+C       if postprocessing requested matrix must be allocated
         IF (MAT_ALLOC.EQ.0) THEN
-            IF (KEEP(54).NE.0) THEN
+           IF (KEEP(54).NE.0) THEN
 C           Write on MPG this time (we wrote on MP before in
 C           case of distributed matrix and wrote on MPG already
 C           in case of centralized matrix)
             IF (PROKG) WRITE(MPG,'(A)')
      &      ' WARNING: original distributed matrix is not allocated'
-             ENDIF
-              POSTPros = .FALSE.
-              ICNTL11 = 0
-              ICNTL10 = 0
+           ENDIF
+           POSTPros = .FALSE.
+           ICNTL11 = 0
+           ICNTL10 = 0
 C   Write a warning.
            IF ((ICNTL(10) .NE. 0) .AND. (ICNTL10 .EQ. 0)) THEN
             IF (PROKG) WRITE(MPG,'(A)')
-     &    ' WARNING: ICNTL(10) treated as if set to 0'
+     &      ' WARNING: ICNTL(10) treated as if set to 0'
            ENDIF
            IF ((ICNTL(11) .EQ. 1).OR.(ICNTL(11) .EQ. 2) 
      &        .AND.(ICNTL11 .EQ. 0)) THEN
             IF (PROKG) WRITE(MPG,'(A)')
-     &    ' WARNING: ICNTL(11) treated as if set to 0 '
-          ENDIF
+     &      ' WARNING: ICNTL(11) treated as if set to 0 '
+           ENDIF
         ENDIF
         IF (POSTPros) THEN
             ALLOCATE(SAVERHS(id%N*NBRHS),stat = allocok)
@@ -1748,14 +1894,44 @@ C     ----------------------------------
      &               id%COMM,IERR)
       CALL MPI_BCAST(ICNTL11,1,MPI_INTEGER,MASTER,
      &               id%COMM,IERR)
-      CALL MPI_BCAST(ICNTL21,1,MPI_INTEGER,MASTER,
-     &               id%COMM,IERR)
       CALL MPI_BCAST(POSTPros,1,MPI_LOGICAL,MASTER,
      &               id%COMM,IERR)
       CALL MPI_BCAST(LSCAL,1,MPI_LOGICAL,MASTER,
      &               id%COMM,IERR)
       CALL MPI_BCAST(KEEP(237),1,MPI_INTEGER,MASTER,
      &               id%COMM,IERR)
+#if ! defined(USE_OLD_SCALING)
+C     ----------------------------------------------
+C     Initialize SCALING_LOC_FWD and SCALING_LOC_BWD
+C     They corespond to all pivots factorized on a
+C     given MPI process and point to a dummy array
+C     of size 1 on the host of if no pivot was
+C     factorized (KEEP(89))=0
+C     ----------------------------------------------
+      IF (LSCAL .AND. id%KEEP(89) .GT. 0) THEN
+          IF (MTYPE .EQ. 1) THEN
+            SCALING_LOC_FWD => id%ROWSCA_loc
+            SCALING_LOC_BWD => id%COLSCA_loc
+          ELSE
+            SCALING_LOC_FWD => id%COLSCA_loc
+            SCALING_LOC_BWD => id%ROWSCA_loc
+          ENDIF
+      ELSE ! includes non working master on which KEEP(89)=0
+          SCALING_LOC_FWD => RDUMMY_TARGET
+          SCALING_LOC_BWD => RDUMMY_TARGET
+      ENDIF
+C     Remarks related to scalings:
+C     * During postprocessing, one performs solves
+C       with alternatively A and A^T, meaning that
+C       SCALING_LOC_FWD and SCALING_LOC_BWD will
+C       be redefined.
+C     * In case of exploit sparsity, RHSINTR may
+C       have less rows than ROWSCA_loc/COLSCA_loc.
+C       SCALING_RHSINTR_FWD and SCALING_RHSINTR_BWD
+C       will then be extracted from
+C       SCALING_LOC_FWD and SCALING_LOC_BWD thanks
+C       to the subroutine DMUMPS_SCALINGRHSINTR
+#endif
 C     KEEP(248)==1 if not_NullSpace (KEEP(111)=0)
 C           and sparse RHS on input (id%ICNTL(20)/KEEP(248)==1)
 C     (KEEP(248)==1 implies KEEP(111) = 0, otherwise error was raised)
@@ -1965,81 +2141,85 @@ c         --- ALLOCATE outside loop RHS_
 C     --------------------------------------------------
       IF ( I_AM_SLAVE ) THEN
         IF ((KEEP(221).EQ.2 .AND. KEEP(252).EQ.0)) THEN
-C          -- RHSCOMP must have been allocated in
+C          -- RHSINTR must have been allocated in
 C          -- previous solve step (with option KEEP(221)=1)
-           IF (.NOT.associated(id%RHSCOMP)) THEN
+           IF (.NOT.associated(id%RHSINTR)) THEN
              INFO(1) = -35
              INFO(2) = 1
              GOTO 111
            ENDIF
 C          IF ((KEEP(248).EQ.0) .OR. (id%NRHS.EQ.1)) THEN
-C          POSINRHSCOMP_ROW/COL are meaningful and could even be reused
-           IF (.NOT.associated(id%POSINRHSCOMP_ROW) ) ! .OR.
-!    &        .NOT.(id%POSINRHSCOMP_COL_ALLOC))
+C          GLOB2LOC_RHS/SOL are meaningful and could even be reused
+           IF (.NOT.associated(id%GLOB2LOC_RHS) ) ! .OR.
+!    &        .NOT.(id%GLOB2LOC_SOL_ALLOC))
      &     THEN
              INFO(1) = -35
              INFO(2) = 2
              GOTO 111
            ENDIF
-           IF (.not.id%POSINRHSCOMP_COL_ALLOC) THEN
-C             POSINRHSCOMP_COL that is kept from
+           IF (.not.id%GLOB2LOC_SOL_ALLOC) THEN
+C             GLOB2LOC_SOL that is kept from
 C             previous call to solve must then (already)
-C             point to id%POSINRHSCOMP_ROW
-              id%POSINRHSCOMP_COL => id%POSINRHSCOMP_ROW
+C             point to id%GLOB2LOC_RHS
+              id%GLOB2LOC_SOL => id%GLOB2LOC_RHS
            ENDIF
         ELSE
 C         ----------------------
-C         Allocate POSINRHSCOMP_ROW/COL
+C         Allocate GLOB2LOC_RHS/SOL
 C         ----------------------
-C         The size of POSINRHSCOMP arrays
+C         The size of POSINRHSINTR arrays
 C         does not depend on the block of RHS
-C         POSINRHSCOMP_ROW/COL are initialized in the loop of RHS
-          IF (associated(id%POSINRHSCOMP_ROW)) THEN
+C         GLOB2LOC_RHS/SOL are initialized in the loop of RHS
+          IF (associated(id%GLOB2LOC_RHS)) THEN
             NB_BYTES = NB_BYTES -
-     &          int(size(id%POSINRHSCOMP_ROW),8)*K34_8
-            DEALLOCATE(id%POSINRHSCOMP_ROW)
+     &          int(size(id%GLOB2LOC_RHS),8)*K34_8
+            DEALLOCATE(id%GLOB2LOC_RHS)
           ENDIF
-          ALLOCATE (id%POSINRHSCOMP_ROW(id%N), stat = allocok)
+          ALLOCATE (id%GLOB2LOC_RHS(id%N), stat = allocok)
           IF ( allocok .GT. 0 ) THEN
              INFO(1)=-13
              INFO(2)=id%N
              GOTO 111
           END IF
           NB_BYTES = NB_BYTES +
-     &          int(size(id%POSINRHSCOMP_ROW),8)*K34_8
+     &          int(size(id%GLOB2LOC_RHS),8)*K34_8
           NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
-          IF (id%POSINRHSCOMP_COL_ALLOC) THEN
+          IF (id%GLOB2LOC_SOL_ALLOC) THEN
             NB_BYTES = NB_BYTES -
-     &          int(size(id%POSINRHSCOMP_COL),8)*K34_8
-            DEALLOCATE(id%POSINRHSCOMP_COL)
-            NULLIFY(id%POSINRHSCOMP_COL)
-            id%POSINRHSCOMP_COL_ALLOC = .FALSE.
+     &          int(size(id%GLOB2LOC_SOL),8)*K34_8
+            DEALLOCATE(id%GLOB2LOC_SOL)
+            NULLIFY(id%GLOB2LOC_SOL)
+            id%GLOB2LOC_SOL_ALLOC = .FALSE.
           ENDIF
 C
-          IF ((KEEP(50).EQ.0).OR.KEEP(237).NE.0) THEN
-           ALLOCATE (id%POSINRHSCOMP_COL(id%N), stat = allocok)
+          IF ( (KEEP(50).EQ.0).OR.(KEEP(237).NE.0).OR.
+     &         (KEEP(212).NE.0)
+     &       ) THEN
+           ALLOCATE (id%GLOB2LOC_SOL(id%N), stat = allocok)
            IF ( allocok .GT. 0 ) THEN
              INFO(1)=-13
              INFO(2)=id%N
              GOTO 111
            END IF
-           id%POSINRHSCOMP_COL_ALLOC = .TRUE.
+           id%GLOB2LOC_SOL_ALLOC = .TRUE.
            NB_BYTES = NB_BYTES +
-     &          int(size(id%POSINRHSCOMP_COL),8)*K34_8
+     &          int(size(id%GLOB2LOC_SOL),8)*K34_8
            NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
           ELSE
-C          Do no allocate POSINRHSCOMP_COL
-           id%POSINRHSCOMP_COL => id%POSINRHSCOMP_ROW
-           id%POSINRHSCOMP_COL_ALLOC = .FALSE.
+C          Do no allocate GLOB2LOC_SOL
+           id%GLOB2LOC_SOL => id%GLOB2LOC_RHS
+           id%GLOB2LOC_SOL_ALLOC = .FALSE.
           ENDIF
           IF (KEEP(221).NE.2) THEN
-C         -- only in the case of bwd after reduced RHS
-C         -- we have to keep "old" RHSCOMP
-            IF (associated(id%RHSCOMP)) THEN
+C         -- only in the case of bwd after 
+C         -- fwd only (with or without Schur)
+C         -- we have to keep "old" RHSINTR
+            IF (associated(id%RHSINTR)) THEN
              NB_BYTES = NB_BYTES - id%KEEP8(25)*K35_8
-             DEALLOCATE(id%RHSCOMP)
-             NULLIFY(id%RHSCOMP)
-             id%KEEP8(25)=0_8
+             DEALLOCATE(id%RHSINTR)
+             NULLIFY(id%RHSINTR)
+             id%KEEP8(25)  = 0_8
+             id%LD_RHSINTR = 0
             ENDIF
           ENDIF
         ENDIF
@@ -2138,16 +2318,22 @@ C          migrated outside the blocking
             UNS_PERM_INV_NEEDED_INMAINLOOP = .TRUE.
       ENDIF
       UNS_PERM_INV_NEEDED_BEFMAINLOOP = .FALSE.
+      IF (KEEP(23) .GT. 0 .AND. MTYPE.EQ.1 .AND. ICNTL21.EQ.2) THEN
+           UNS_PERM_INV_NEEDED_INMAINLOOP = .TRUE.
+      ENDIF
       IF ( KEEP(23) .GT.0 .AND.
      &            MTYPE .NE. 1 .AND. KEEP(248).EQ.-1 ) THEN
 C          Similar to sparse RHS case, we need to modify IRHS_loc
 C          indices in the distributed RHS case. However, we need
-C          UNS_PERM_INV on all processors. But only before theC
+C          UNS_PERM_INV on all processors. But only before the
 C          main loop on the RHS blocks.
            UNS_PERM_INV_NEEDED_BEFMAINLOOP = .TRUE.
       ENDIF
+C
+      UNS_PERM_INV_NEEDED_ONSLAVES = .FALSE.
       IF ( UNS_PERM_INV_NEEDED_INMAINLOOP .OR.
      &     UNS_PERM_INV_NEEDED_BEFMAINLOOP ) THEN
+C          We need UNS_PERM_INV
            ALLOCATE(UNS_PERM_INV(id%N),stat=allocok)
            if (allocok .GT.0 ) THEN
              INFO(1)=-13
@@ -2188,8 +2374,14 @@ C     Propagate errors
 C
 C     UNS_PERM_INV needed on slaves:
       IF ( KEEP(23).NE.0 .AND.
-     &     ( KEEP(237).NE.0 .OR.
-     &     ( MTYPE.NE.1 .AND. KEEP(248).EQ.-1 ) ) ) THEN
+     &     (  KEEP(237).NE.0 .OR.
+     &        ( MTYPE.NE.1 .AND. KEEP(248).EQ.-1 ) .OR.
+     &        ( MTYPE.EQ.1 .AND. ICNTL21.EQ.2)
+     &     ) 
+     &   ) THEN
+        UNS_PERM_INV_NEEDED_ONSLAVES = .TRUE.
+      ENDIF
+      IF (UNS_PERM_INV_NEEDED_ONSLAVES) THEN
 C       Broadcast UNS_PERM_INV
         CALL MPI_BCAST( UNS_PERM_INV,id%N,MPI_INTEGER,MASTER,
      &                  id%COMM,IERR )
@@ -2198,7 +2390,8 @@ C     -------------------------------
 C     BEGIN
 C     Preparation for distributed RHS
 C     -------------------------------
-      IF (I_AM_SLAVE .AND. KEEP(248).EQ.-1) THEN
+      IF (I_AM_SLAVE .AND. KEEP(248).EQ.-1
+     & ) THEN
 C       Distributed RHS case
         ALLOCATE(MAP_RHS_loc(max(id%Nloc_RHS,1)), stat=allocok)
         IF (allocok .GT. 0) THEN
@@ -2208,10 +2401,10 @@ C       Distributed RHS case
         ENDIF
         NB_BYTES = NB_BYTES + max(int(id%Nloc_RHS,8),1_8)*K34_8
       ENDIF
-C     MAP_RHS_loc will be built in the main
-C     loop, when processing the first block.
-C     It requires POSINRHSCOMP to be built.
-      BUILD_RHSMAPINFO = .TRUE.
+C      MAP_RHS_loc will be built in the main
+C      loop, when processing the first block.
+C      It requires POSINRHSINTR to be built.
+       BUILD_RHSMAPINFO = .TRUE.
  20   CONTINUE
       CALL MUMPS_PROPINFO( ICNTL(1), INFO(1),
      &                         id%COMM,id%MYID)
@@ -2221,7 +2414,8 @@ C     transpose system, use MUMPS intern
 C     for IRHS_loc_PTR. Done before scaling since
 C     scaling is on permuted matrix
       IF ( I_AM_SLAVE .AND. KEEP(23).GT.0 .AND. KEEP(248).EQ.-1
-     &     .AND. MTYPE.NE.1 ) THEN
+     &     .AND. MTYPE.NE.1 
+     &   ) THEN
           IF (id%Nloc_RHS .GT. 0) THEN
             ALLOCATE(IRHS_loc_PTR(id%Nloc_RHS),stat=allocok)
             IF (allocok.GT.0) THEN
@@ -2252,7 +2446,9 @@ C     to free memory
         ALLOCATE(UNS_PERM_INV(1))  ! to posibly pass it as an argument
         NB_BYTES = NB_BYTES + K34_8
       ENDIF
-      IF (LSCAL .AND. id%KEEP(248).EQ.-1) THEN
+#if defined(USE_OLD_SCALING)
+      IF (LSCAL .AND. id%KEEP(248).EQ.-1
+     &   ) THEN
 C       Scaling done based on original indices
 C       provided by user
         IF (MTYPE == 1) THEN
@@ -2268,6 +2464,7 @@ C         Transpose
      &       NB_BYTES, NB_BYTES_MAX, K16_8, LP, LPOK,
      &       ICNTL(1), INFO(1) )
       ENDIF
+#endif
 C     -------------------------------
 C     END
 C     Preparation for distributed RHS
@@ -2280,9 +2477,11 @@ C     ----------------------------------
 C     BEGIN
 C     Preparation for distributed solution
 C     -------------------------------------
-      IF ( ICNTL21==1 ) THEN
+      IF ( ICNTL21 .NE. 0 ) THEN
+C{
+#if defined(USE_OLD_SCALING)
         IF (LSCAL) THEN
-C         In case of scaling we will need to scale
+C{        In case of scaling we will need to scale
 C         back the sol. Put the values of the scaling
 C         arrays needed to do that on each processor.
           IF (id%MYID.NE.MASTER) THEN
@@ -2306,17 +2505,20 @@ C         arrays needed to do that on ea
      &                         id%COMM,id%MYID)
           IF (INFO(1) .LT.0 ) GOTO 90
           IF (I_AM_SLAVE) THEN
-            ALLOCATE(scaling_data_sol%SCALING_LOC(id%KEEP(89)),
-     &               stat=allocok)
+              ALLOCATE(scaling_data_sol%SCALING_LOC(max(1,id%KEEP(89))),
+     &                 stat=allocok)
             IF (allocok > 0) THEN
               IF (LPOK) THEN
                 WRITE(LP,*) 'Error allocating local scaling array'
               ENDIF
               INFO(1)=-13
-              INFO(2)=id%KEEP(89)
+              INFO(2)=max(1,id%KEEP(89))
               GOTO 38
             ENDIF
-            NB_BYTES = NB_BYTES + int(id%KEEP(89),8)*K16_8
+            IF (ICNTL21.NE.0) THEN
+C            Real entries for scaling
+             NB_BYTES = NB_BYTES + int(max(1,id%KEEP(89)),8)*K16_8
+            ENDIF
             NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
           ENDIF ! I_AM_SLAVE
  38       CONTINUE
@@ -2336,11 +2538,17 @@ C         arrays needed to do that on ea
      &                       id%COMM,IERR)
               scaling_data_sol%SCALING=>id%ROWSCA
           ENDIF
+C}
         ENDIF ! LSCAL
-        IF ( I_AM_SLAVE ) THEN
-C         ----------------------
+#endif
+        IF ( ICNTL21.EQ.1 .AND. I_AM_SLAVE 
+     &     ) THEN
+C         --------------------------------
 C         Prepare ISOL_loc array
-C         ----------------------
+#if defined(USE_OLD_SCALING)
+C         and on the fly, scaling_data_sol
+#endif
+C         --------------------------------
           LIW_PASSED=max(1,LIW)
 C         Only called if more than 1 pivot
 C         was eliminated by the processor.
@@ -2351,12 +2559,19 @@ C         Note that LSOL_loc >= KEEP(89)
      &               id%KEEP(1),id%KEEP8(1),
      &               id%IS(1), LIW_PASSED,id%MYID_NODES,
      &               id%N, id%STEP(1), id%PROCNODE_STEPS(1),
-     &               id%NSLAVES, scaling_data_sol, LSCAL
+     &               id%NSLAVES,
+#if defined(USE_OLD_SCALING)
+     &               scaling_data_sol, LSCAL,
+#endif
 C                    For checking only
-     &               , (KEEP(248).EQ.-1), IRHS_loc_PTR(1), id%Nloc_RHS
+     &               (KEEP(248).EQ.-1), IRHS_loc_PTR(1), id%Nloc_RHS
      &               )
           ENDIF 
-          IF (id%MYID.NE.MASTER .AND. LSCAL) THEN
+        ENDIF ! I_AM_SLAVE
+#if defined(USE_OLD_SCALING)
+#endif
+#if defined(USE_OLD_SCALING)
+        IF (id%MYID.NE.MASTER .AND. LSCAL) THEN
 C           ---------------------------------
 C           Local (small) scaling arrays have
 C           been built, free temporary copies
@@ -2369,8 +2584,15 @@ C           ----------------------------
               NULLIFY(id%ROWSCA)
             ENDIF
             NB_BYTES = NB_BYTES - int(id%N,8)*K16_8
-          ENDIF
-        ENDIF ! I_AM_SLAVE
+        ENDIF
+#endif
+C}
+      ENDIF ! ICNTL21 .NE. 0
+      IF (ICNTL21 .EQ.1) THEN
+C       ---------------------------------------------------
+C       Take into account unsymmetric permutation to modify
+C       ISOL_loc, in case ISOL_loc is provided by MUMPS
+C       ---------------------------------------------------
         IF (KEEP(23) .NE. 0 .AND. MTYPE==1) THEN
 C         Broadcast the unsymmetric permutation and
 C         permute the indices in ISOL_loc
@@ -2409,11 +2631,14 @@ C     ----------------------------------
 C     Preparation for distributed solution
 C     END
 C     --------------------------------------
-C     ----------------------------
-C     Preparation for reduced RHS
-C     ----------------------------
-      IF ( ( KEEP(221) .EQ. 1 ) .OR.
+C     ---------------------------------------------
+C     In case of Schur, preparation for reduced RHS
+C     ---------------------------------------------
+      IF ( (KEEP(60).NE.0) .AND. 
+     &    (
+     &     ( KEEP(221) .EQ. 1 ) .OR.
      &     ( KEEP(221) .EQ. 2 )
+     &    )
      &   ) THEN
 C       -- First compute MASTER_ROOT_IN_COMM proc number in
 C          COMM_NODES on which is mapped the master of the root.
@@ -2452,7 +2677,8 @@ C          -- other procs not concerned
          ENDIF
       ENDIF
 C
-      IF ( KEEP(248)==1 ) THEN  ! Sparse RHS (A-1 or general sparse)
+      IF ( KEEP(248)==1 
+     &   ) THEN  ! Sparse RHS (A-1 or general sparse)
 !        JBEG_RHS - current starting column within A-1 or sparse rhs
 !                      set in the loop below and used to obtain the
 !                      global index of the column of the sparse RHS
@@ -2539,9 +2765,9 @@ C     Propagate errors
 c --------------------------
 c --------------------------
       IF (id%NSLAVES .EQ. 1) THEN
-c     - In case of NS/A-1 we may want to permute RHS
-c     - for NS thus is to apply permutation to PIVNUL_LIST
-*     - before starting loop of NBRHS
+C{    - In case of NS/A-1 we may want to permute RHS
+C     - for NS thus is to apply permutation to PIVNUL_LIST
+C     - before starting loop of NBRHS
        IF (DO_PERMUTE_RHS .AND. KEEP(111).NE.0 ) THEN
 C     NOTE:
 C        when host not working both master and slaves have
@@ -2551,6 +2777,7 @@ C        in this case the complete list
      &                 ' not available yet '
             CALL MUMPS_ABORT()
        ENDIF                     ! End Permute_RHS
+C}
       ELSE
          IF (DO_PERMUTE_RHS .AND. KEEP(111).NE.0 ) THEN
             WRITE(*,*) id%MYID, ':INTERNAL ERROR 2 : ',
@@ -2558,7 +2785,6 @@ C        in this case the complete list
      &                 ' not available yet '
             CALL MUMPS_ABORT()
 C
-C
          ENDIF                  !  End DO_PERMUTE_RHS
          IF (INTERLEAVE_PAR.AND. (KEEP(111).NE.0)) THEN
             WRITE(*,*) id%MYID, ':INTERNAL ERROR 3 : ',
@@ -2601,15 +2827,15 @@ C          to permute the null column pi
      &            MPI_INTEGER,
      &            MASTER, id%COMM,IERR)
       ENDIF
-C   L0-threads to be activated iff KEEP(401)>0 and KEEP(400)>0
-          IF (KEEP(401) .GT. 0) THEN
+C   L0-threads to be activated iff KEEP(401)=1 and KEEP(400)>0
+          IF (KEEP(401) .EQ. 1) THEN
 C          L0-threads was requested for solve phase
 C          and will be effective only if KEEP(400) >0 
 C          which indicates that L0-threads was 
 C          performed during analysis+factorization
            IF ( KEEP(400) .GT. 0 ) THEN
 C           Check if number of threads is consistent with
-C           the one used during factorization
+C           the one used during factorization for all procs
 C{
             NOMP = 1
 !$          NOMP=omp_get_max_threads()
@@ -2617,17 +2843,23 @@ C{
 C               NOMP should be the one from analysis
                 id%INFO(1) = -58
                 id%INFO(2) = KEEP(400)
-            IF (LPOK) WRITE(LP,'(A,A,I5,A,I5)')
-     &" FAILURE DETECTED IN SOLVE: #threads for KEEP(401)",
-     &" changed from",KEEP(400)," at analysis to", NOMP
+                IF (LPOK) WRITE(LP,'(A,A,I5,A,I5)')
+     &" FAILURE DETECTED IN SOLVE: #threads for multithreaded",
+     &" tree parallelism changed from",KEEP(400)," at analysis to", 
+     &  NOMP
               ENDIF
            ENDIF
+C          error check
+           CALL MUMPS_PROPINFO( ICNTL(1), INFO(1),
+     &                    id%COMM,id%MYID)
+           IF ( id%INFO(1) .LT. 0 ) GO TO 90
 C}
           ENDIF
       IF (KEEP(400) .GT. 0) THEN
         CALL DMUMPS_SOL_L0OMP_LI(KEEP(400))
       ENDIF
 C     ==============================
+C     MAIN LOOP:
 C     BLOCKING ON the number of RHS
 C      We work on  a maximum of NBRHS at a time.
 C      the leading dimension of RHS is id%LRHS on master
@@ -2649,14 +2881,16 @@ C     {
 C       ==========================
 C       -- NBRHS     : Original block size
 C       -- BEG_RHS   : Column index of the first RHS in the list of
-C                      non empty RHS (RHS_LOC) to
+C                      non empty RHS (RHS_loc) to
 C                      be processed during this iteration
 C       -- NBRHS_EFF : Effective block size at current iteration
-C          In case of sparse RHS (KEEP(248)==1) NBRHS_EFF only refers to
-C                  non-empty columns and is used to compute NBCOL_INBLOC
-C          -- NBCOL_INBLOC  : the number of columns of sparse RHS needed
-C                        to get NBRHS_EFF non empty columns columns of
-C                        sparse RHS processed at each step
+C                      that we be set to nb of contiguous non empty 
+C                      columns
+C        In case of sparse RHS (KEEP(248)==1) NBRHS_EFF only refers to
+C                non-empty columns and is used to compute NBCOL_INBLOC
+C        -- NBCOL_INBLOC  : the number of columns of sparse RHS needed
+C                      to get NBRHS_EFF non empty columns columns of
+C                      sparse RHS processed at each step
 C
         NBRHS_EFF    = min(NRHS_NONEMPTY-BEG_RHS+1, NBRHS)
 C
@@ -2690,7 +2924,7 @@ C       id%RHS is accessed). Remark that
 C       overwritten later, in case of general sparse right-hand side
 C       and centralized solution to skip empty columns 
 C       ===========================================================
-        IF (
+        IF  (
 C           slave procs
      &      ( id%MYID .NE. MASTER )
 C       even on master when RHS not allocated
@@ -2734,7 +2968,8 @@ C       ================================
 C       Shift empty columns in case of sparse RHS
 C       ==========================================
         IF ( (id%MYID.EQ.MASTER) .AND.
-     &        KEEP(248)==1  ) THEN
+     &        KEEP(248)==1  
+     &     ) THEN
 C         update position of JBEG_RHS on first non-empty
 C         column of this block
           JBEG_RHS = JEND_RHS + 1
@@ -2743,7 +2978,8 @@ C         column of this block
      &          id%IRHS_PTR(PERM_RHS(JBEG_RHS)+1) )
 C             Empty column
               IF ((KEEP(237).EQ.0).AND.(ICNTL21.EQ.0).AND.
-     &              (KEEP(221).NE.1) ) THEN
+     &              (KEEP(221).NE.1) 
+     &           ) THEN
 C                General sparse RHS (NOT A-1) and centralized solution
 C                Set to zero part of the
 C                solution corresponding to empty columns
@@ -2758,7 +2994,8 @@ C                solution corresponding
             DO WHILE( id%IRHS_PTR(JBEG_RHS) .EQ.
      &        id%IRHS_PTR(JBEG_RHS+1) )
               IF ((KEEP(237).EQ.0).AND.(ICNTL21.EQ.0).AND.
-     &          (KEEP(221).NE.1) ) THEN
+     &             (KEEP(221).NE.1) 
+     &           ) THEN
 C               Case of general sparse RHS (NOT A-1) and
 C               centralized solution: set to zero part of
 C               the solution corresponding to empty columns
@@ -2768,11 +3005,13 @@ C               the solution correspondi
                 ENDDO
               ENDIF
               IF (KEEP(221).EQ.1) THEN
-C               Reduced RHS set to ZERO
-                DO I = 1, id%SIZE_SCHUR
-                  id%REDRHS(int(JBEG_RHS-1,8)*int(LD_REDRHS,8) +
-     &            int(I,8)) =  ZERO
-                ENDDO
+                IF (KEEP(60).NE.0) THEN
+C                 Fwd with Schur: reduced RHS set to ZERO
+                  DO I = 1, id%SIZE_SCHUR
+                    id%REDRHS(int(JBEG_RHS-1,8)*int(LD_REDRHS,8) +
+     &              int(I,8)) =  ZERO
+                  ENDDO
+                ENDIF
               ENDIF
               JBEG_RHS = JBEG_RHS +1
             ENDDO
@@ -2781,7 +3020,7 @@ C         Count nb of RHS columns skippe
 C         * DMUMPS_DISTRIBUTED_SOLUTION to reset those
 C           columns to zero.
 C         * in case of reduced right-hand side, to set
-C           corresponding entries of RHSCOMP to 0 after
+C           corresponding entries of RHSINTR to 0 after
 C           forward phase.
           NB_RHSSKIPPED = JBEG_RHS - (JEND_RHS + 1)
           IF ((KEEP(248).EQ.1).AND.(KEEP(237).EQ.0)
@@ -2798,7 +3037,8 @@ C           forward phase.
 C
 C       Shift on REDRHS in reduced RHS functionality
 C
-        IF (id%MYID.EQ.MASTER .AND. KEEP(221).NE.0) THEN
+        IF (id%MYID.EQ.MASTER .AND. KEEP(221).NE.0 
+     &       .AND. KEEP(60).NE.0 ) THEN
 C         Initialize IBEG_REDRHS
 C         Note that REDRHS always has id%NRHS Colmuns
           IBEG_REDRHS= int(JBEG_RHS-1,8)*int(LD_REDRHS,8) + 1_8
@@ -2814,11 +3054,12 @@ C
         CALL VTBEGIN(perm_scal_ini,IERR)
 #endif
         IF (id%MYID .eq. MASTER) THEN
-C         ======================
-          IF (KEEP(248)==1) THEN
-C         ======================
+C{        ======================
+          IF (KEEP(248)==1
+     &       ) THEN
+C{        ======================
 C
-C         Sparse RHS format ( A-1 or sparse input format)
+C         Sparse RHS format ( A-1 or sparse centralized input format)
 C         is provided as input by the user (IRHS_SPARSE ...)
 C         --------------------------------------------------
 C         Compute NZ_THIS_BLOCK and NBCOL_INBLOC
@@ -2840,7 +3081,10 @@ C         the first non empty column; th
 C         maximum size NBRHS_EFF except if we reach another empty
 C         column. (We are not sure to have a copy allocated
 C         and thus cannot compress on the fly, as done naturally
-C         for A-1).
+C         for A-1)
+C         For A-1 we process NBRHS_EFF non empty columns 
+C         in the bloc that contains NBCOL_INBLOC columns
+C         (empty+non empty)
           STOP_AT_NEXT_EMPTY_COL = .FALSE.
           DO I=JBEG_RHS, id%NRHS
             NBCOL_INBLOC = NBCOL_INBLOC +1
@@ -2861,15 +3105,19 @@ C              --  sparse case (not AM-1
                STOP_AT_NEXT_EMPTY_COL =.TRUE.
             ENDIF
             IF (COLSIZE.GT.0
+C{
      &      ) THEN
               NBCOL = NBCOL+1
               NZ_THIS_BLOCK = NZ_THIS_BLOCK + COLSIZE
+C}
             ELSE IF (STOP_AT_NEXT_EMPTY_COL) THEN
-C We have reached an empty column with already selected non empty 
-C columns: reduce block size to non empty columns reached so far.
+C{ We have reached an empty column with already selected non empty 
+C  columns: reduce block size to non empty columns reached so far.
               NBCOL_INBLOC = NBCOL_INBLOC -1
+C Note that NBRHS_EFF is udated only on master 
               NBRHS_EFF = NBCOL
               EXIT
+C}
             ENDIF
             IF (NBCOL.EQ.NBRHS_EFF) EXIT
           ENDDO
@@ -3000,9 +3248,16 @@ c    *                   (1:NZ_THIS_BLOC
      &          id%IRHS_SPARSE(id%IRHS_PTR(JBEG_RHS):
      &             id%IRHS_PTR(JBEG_RHS)+NZ_THIS_BLOCK-1)
             ENDIF
+#if defined(USE_OLD_SCALING)
+C           Centralized scaling: perform scaling on master
+C           in RHS_SPARSE_COPY
             IF (LSCAL.OR.DO_PERMUTE_RHS.OR.INTERLEAVE_PAR.OR.
      &          (KEEP(237).NE.0)) THEN
-C             if scaling is on or if columns of the RHS are
+#else
+            IF (DO_PERMUTE_RHS.OR.INTERLEAVE_PAR.OR.
+     &          (KEEP(237).NE.0)) THEN
+#endif
+C             if columns of the RHS are
 C             permuted then a copy of RHS_SPARSE is needed.
 C             Also always allocated with A-1,
 c             to enable receiving during mumps_gather_solution
@@ -3034,23 +3289,36 @@ c    *            (1:NZ_THIS_BLOCK)
             IF (DO_PERMUTE_RHS.OR.INTERLEAVE_PAR.OR.
      &          (id%KEEP(237).NE.0)) THEN
               IF (id%KEEP(237).NE.0) THEN
-C               --initialized to one; it might be
-C               modified if scaling is on (one first entry in each col is scaled)
+C               --initialized to one
+#if defined(USE_OLD_SCALING)
+C               it might be modified if scaling is on (one first entry
+C               in each col is scaled)
                 RHS_SPARSE_COPY = ONE
-              ELSE IF (.NOT. LSCAL) THEN
+#else
+C               Local scalings are used: RHSINTR is initialized
+C               directly on the workers and RHS_SPARSE_COPY will
+C               only be used during DMUMPS_GATHER_SOLUTION_AM1.
+#endif
+              ELSE
 C               -- Columns are not contiguous and need be copied one by one
+#if defined(USE_OLD_SCALING)
 C               -- This need not be done if scaling is on because it
 C               -- will done and scaled later.
-                IPOS = 1
-                DO I=JBEG_RHS, JBEG_RHS + NBCOL_INBLOC -1
-                  COLSIZE = id%IRHS_PTR(PERM_RHS(I)+1)
-     &                    - id%IRHS_PTR(PERM_RHS(I))
-                  IF (COLSIZE .EQ. 0) CYCLE
-                  RHS_SPARSE_COPY(IPOS:IPOS+COLSIZE-1) =
-     &            id%RHS_SPARSE(id%IRHS_PTR(PERM_RHS(I)):
-     &            id%IRHS_PTR(PERM_RHS(I)+1) -1)
-                  IPOS = IPOS + COLSIZE
-                ENDDO
+                IF (.NOT. LSCAL) THEN
+#endif
+                  IPOS = 1
+                  DO I=JBEG_RHS, JBEG_RHS + NBCOL_INBLOC -1
+                    COLSIZE = id%IRHS_PTR(PERM_RHS(I)+1)
+     &                      - id%IRHS_PTR(PERM_RHS(I))
+                    IF (COLSIZE .EQ. 0) CYCLE
+                    RHS_SPARSE_COPY(IPOS:IPOS+COLSIZE-1) =
+     &              id%RHS_SPARSE(id%IRHS_PTR(PERM_RHS(I)):
+     &              id%IRHS_PTR(PERM_RHS(I)+1) -1)
+                    IPOS = IPOS + COLSIZE
+                  ENDDO
+#if defined(USE_OLD_SCALING)
+                ENDIF
+#endif
               ENDIF
             ENDIF
 C           =========================
@@ -3085,9 +3353,9 @@ C                 (ii) columns might hav
               ENDIF ! MTYPE.NE.1
             ENDIF ! KEEP(23).NE.0
           ENDIF ! NZ_THIS_BLOCK .NE. 0
-C         -----
+C}        -----
           ENDIF  !  ============ KEEP(248)==1
-C         -----
+C}        -----
         ENDIF   !  (id%MYID .eq. MASTER)
 C
 C =====================  ERROR handling and propagation ================
@@ -3098,16 +3366,29 @@ C =====================  ERROR handling
 C ======================================================================
 C
 C       NBCOL_INBLOC depends on loop
-        IF (KEEP(248)==1) THEN
+        IF (KEEP(248)==1
+     &     ) THEN
             CALL MPI_BCAST( NBCOL_INBLOC,1, MPI_INTEGER,
      &           MASTER, id%COMM,IERR)
         ELSE
           NBCOL_INBLOC = NBRHS_EFF
         ENDIF
         JEND_RHS =JBEG_RHS + NBCOL_INBLOC - 1
+        IF ((KEEP(248).EQ.1).AND.(KEEP(237).EQ.0)) THEN
+C         Only case (in previous block) for which
+C         NBRHS_EFF has been modified only on master
+          ! case of general sparse: in case of empty columns
+          ! modifed version of
+          ! NBRHS_EFF need be broadcasted since it is used
+          ! to update BEG_RHS at the end of the DO WHILE
+            CALL MPI_BCAST( NBRHS_EFF,1, MPI_INTEGER,
+     &           MASTER, id%COMM,IERR)
+            CALL MPI_BCAST(NB_RHSSKIPPED,1,MPI_INTEGER,MASTER,
+     &               id%COMM,IERR)
+        ENDIF
         IF ((KEEP(111).eq.0).AND.(KEEP(252).EQ.0)
      &      .AND.(KEEP(221).NE.2 ).AND.(KEEP(248).EQ.1) ) THEN
-C         ----------------------------
+C{        ----------------------------
 C         -- SPARSE RIGHT-HAND-SIDE
 C         ----------------------------
           CALL MPI_BCAST( NZ_THIS_BLOCK,1, MPI_INTEGER,
@@ -3164,162 +3445,492 @@ C ======================================
      &             MPI_INTEGER,
      &             MASTER, id%COMM,IERR)
           ENDIF
+C}
         ENDIF
 C
 C       =========================================================
-C       INITIALIZE POSINRHSCOMP_ROW/COL, RHSCOMP and related data
-C       For distributed RHS, initialize RHSMAPINFO (at 1st block)
+C       INITIALIZE 
+C       - nodes_FWD and nodes_BWD
 C       =========================================================
-        IF ( I_AM_SLAVE ) THEN
-C         --------------------------------------------------
-C         If I am involved in the solve and if
-C         either
-C           no null space comput (keep(111)=0) and sparse rhs
-C         or
-C             null space computation
-C         then
-C           compute POSINRHSCOMP
-C         endif
+        IF (FIRST_CALL_NODES_FWD_BWD) THEN
+C{         First time DMUMPS_NODES_FWD_BWD_SIZE_FILL 
+C          is called allocated Pruned_Sons_FWD
+           IF (allocated(Pruned_Sons_FWD)) THEN 
+             NB_BYTES = NB_BYTES - size(Pruned_Sons_FWD) * K34_8
+             DEALLOCATE(Pruned_Sons_FWD)
+           ENDIF
+           IF (allocated(Pruned_Sons_BWD)) THEN 
+            NB_BYTES = NB_BYTES - size(Pruned_Sons_BWD) * K34_8
+            DEALLOCATE(Pruned_Sons_BWD)
+           ENDIF
+           ALLOCATE (Pruned_Sons_FWD(KEEP(28)),
+     &             Pruned_Sons_BWD(KEEP(28)), 
+     &             stat=allocok)
+           IF (allocok .GT. 0 ) THEN
+            INFO(1)=-13
+            INFO(2)= 2*KEEP(28)
+           ELSE
+            NB_BYTES = NB_BYTES + 
+     &                int(size(Pruned_Sons_FWD),8)*K34_8 +
+     &                int(size(Pruned_Sons_BWD),8)*K34_8 
+            NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
+           ENDIF
+C}
+        ENDIF
+C =====================  ERROR handling and propagation ==============
+        CALL MUMPS_PROPINFO( ICNTL(1), INFO(1),
+     &                       id%COMM,id%MYID)
+        IF (INFO(1) .LT.0 ) GOTO 90
+C=====================================================================
+C       Reset FIRST_CALL_NODES_FWD_BWD for not allocating
+C       (Pruned_Sons_FWD/BWD within loop)
+        FIRST_CALL_NODES_FWD_BWD = .FALSE.
 C
-C         Fwd in facto: in this case only POSINRHSCOMP need be computed
+        IF (CALL_NODES_FWD_BWD) THEN
+C{
+          fill = .FALSE.
+          nodes_FWD_PTR => IDUMMY_TARGET
+          Lnodes_FWD_PTR = 1
+          nodes_BWD_PTR => IDUMMY_TARGET
+          Lnodes_BWD_PTR = 1
+          CALL DMUMPS_NODES_FWD_BWD_SIZE_FILL (
+     &           fill, id%ICNTL(1), 
+     &           id%N, id%KEEP(28),  id%KEEP(1), 
+     &           id%STEP(1), id%Step2node(1),
+     &           IRHS_loc_PTR(1), id%Nloc_RHS,
+     &           IRHS_PTR_COPY(1), NBCOL_INBLOC, IRHS_SPARSE_COPY(1), 
+     &           NZ_THIS_BLOCK, PERM_RHS, size(PERM_RHS), JBEG_RHS,
+     &           UNS_PERM_INV, size(UNS_PERM_INV), ! size 1 if not used
+     &           ICNTL21, 
+     &           id%MYID, id%COMM,
+     &           id%INFO,
+     &           Pruned_Sons_FWD, Pruned_Sons_BWD,
+     &           Lnodes_FWD, Lnodes_BWD
+     &           , nodes_FWD_PTR(1), nodes_BWD_PTR(1)
+     &           , Lnodes_FWD_PTR, Lnodes_BWD_PTR
+     &           )
+C     
+C        ALLOCATE nodes_FWD and nodes_BWD  if needed
+C
+          IF (Lnodes_FWD.GT.0) THEN
+C           NBT is inout in MUMPS_REALLOC and should be initialized.
+            NBT = 0
+            CALL MUMPS_REALLOC(nodes_FWD, Lnodes_FWD, id%INFO, LP,
+     &         FORCE=.FALSE.,
+     &         STRING='nodes_FWD', MEMCNT=NBT, ERRCODE=-13)
+            IF (INFO(1).LT.0) GOTO 46
+C
+            nodes_FWD_PTR => nodes_FWD
+            Lnodes_FWD_PTR = Lnodes_FWD
+            NB_BYTES = NB_BYTES + NBT
+            NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
+          ELSE
+            nodes_FWD_PTR => IDUMMY_TARGET
+            Lnodes_FWD_PTR = 1
+          ENDIF
+          IF (Lnodes_BWD.GT.0) THEN
+C           NBT is inout in MUMPS_REALLOC and should be initialized.
+            NBT = 0
+            CALL MUMPS_REALLOC(nodes_BWD, Lnodes_BWD, id%INFO, LP,
+     &         FORCE=.FALSE.,
+     &         STRING='nodes_BWD', MEMCNT=NBT, ERRCODE=-13)
+            IF (INFO(1).LT.0) GOTO 46
+C
+            nodes_BWD_PTR => nodes_BWD
+            Lnodes_BWD_PTR = Lnodes_BWD
+            NB_BYTES = NB_BYTES + NBT
+            NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
+          ELSE
+            nodes_BWD_PTR => IDUMMY_TARGET
+            Lnodes_BWD_PTR = 1
+          ENDIF
 C
-C         (POSINRHSCOMP_ROW/COL indirection arrays should
+C =====================  ERROR handling and propagation ==============
+ 46       CONTINUE
+          CALL MUMPS_PROPINFO( ICNTL(1), INFO(1),
+     &                         id%COMM,id%MYID)
+          IF (INFO(1) .LT.0 ) GOTO 90
+C=====================================================================
+          IF (Lnodes_FWD.GT.0 .OR. Lnodes_BWD.GT.0) THEN
+C{
+C          we build nodes_FWD_PTR and/or nodes_BWD_PTR
+C          that will be used to prune flops 
+C          and even if one of the steps FWD/BWD does not
+C          lead to pruning (in this case 
+C          POSTINRHS_COMP will not benefit from pruning).
+           fill = .TRUE.
+           CALL DMUMPS_NODES_FWD_BWD_SIZE_FILL (
+     &           fill, id%ICNTL(1), 
+     &           id%N, id%KEEP(28),  id%KEEP(1), 
+     &           id%STEP(1), id%Step2node(1),
+     &           IRHS_loc_PTR(1), id%Nloc_RHS,
+     &           IRHS_PTR_COPY(1), NBCOL_INBLOC, IRHS_SPARSE_COPY(1), 
+     &           NZ_THIS_BLOCK, PERM_RHS, size(PERM_RHS), JBEG_RHS,
+     &           UNS_PERM_INV, size(UNS_PERM_INV), ! size 1 if not used
+     &           ICNTL21, 
+     &           id%MYID, id%COMM,
+     &           id%INFO, 
+     &           Pruned_Sons_FWD, Pruned_Sons_BWD,
+     &           Lnodes_FWD, Lnodes_BWD
+     &           , nodes_FWD_PTR(1), nodes_BWD_PTR(1)
+     &           , Lnodes_FWD_PTR, Lnodes_BWD_PTR
+     &           )
+C}
+          ENDIF
+C         ------------------------------------------------
+C         Update CALL_NODES_FWD_BWD and free workspace if 
+C         not used again in loop of RHS
+C         ------------------------------------------------
+          IF (
+     &          (KEEP(237) .NE. 0).OR.                   ! AM1
+     &          ((KEEP(235) .NE. 0).AND.KEEP(248).NE.-1) ! GS
+     &       ) THEN
+C           target nodes for chain pruning 
+C           need be updated in case of AM1 or General Sparse
+            CALL_NODES_FWD_BWD = .TRUE.
+          ELSE
+C           all other cases including 
+C           distributed RHS and distributed solution 
+            CALL_NODES_FWD_BWD = .FALSE.
+          ENDIF
+          IF (.NOT. CALL_NODES_FWD_BWD
+     &       ) THEN
+C           Not needed anymore in the loop of RHS
+            IF (allocated(Pruned_Sons_FWD)) THEN 
+             NB_BYTES = NB_BYTES - size(Pruned_Sons_FWD) * K34_8
+             DEALLOCATE(Pruned_Sons_FWD)
+            ENDIF
+            IF (allocated(Pruned_Sons_BWD)) THEN 
+             NB_BYTES = NB_BYTES - size(Pruned_Sons_BWD) * K34_8
+             DEALLOCATE(Pruned_Sons_BWD)
+            ENDIF
+C         ELSE
+C           deallocate later
+          ENDIF
+C}
+        ENDIF
+C       =========================================================
+C       INITIALIZE 
+C       - GLOB2LOC_RHS/SOL, RHSINTR and related data
+C       - For distributed RHS, initialize RHSMAPINFO (at 1st block)
+C       =========================================================
+C         
+C         Fwd in facto: in this case we peronrly peonly POSINRHSINTR need be computed
+C
+C         (GLOB2LOC_RHS/SOL indirection arrays should
 C         have been allocated once outside loop)
-C         Compute size of RHSCOMP since it might depend
+C         Compute size of RHSINTR since it might depend
 C            on the process index and of the sparsity of the RHS
 C            if it is exploited.
-C         Initialize POSINRHSCOMP_ROW/COL
+C         Initialize GLOB2LOC_RHS/SOL
 C
-C         Note that LD_RHSCOMP and id%KEEP8(25)
+C         Note that id%LD_RHSINTR and id%KEEP8(25)
 C         are not set on the host in this routine in
 C         the case of a non-working host.
-C         Note that POSINRHSCOMP is now always computed in SOL_DRIVER
+C         Note that POSINRHSINTR is now always computed in SOL_DRIVER
 C         at least during the first block of RHS when sparsity of RHS
 C         is not exploited.
 C         -------------------------------
-C         INITTIALZE POSINRHSCOMP_ROW/COL
+C         INITTIALZE GLOB2LOC_RHS/SOL
 C         -------------------------------
 C
-          IF ( KEEP(221).EQ.2 .AND. KEEP(252).EQ.0
-     &      .AND.  (KEEP(248).NE.1 .OR. (id%NRHS.EQ.1))
-     &      ) THEN
-C           Reduced RHS was already computed during
-C           a previous forward step AND is valid.
-C           By valid we mean:
-C            -no forward in facto  (KEEP(252)==0) during which
-C             POSINRHSCOMP was not computed
-C           AND
-C            -no exploit sparsity with multiple RHS
-C            because in this case POSINRHSCOMP would
-C            be valid only for the last block processed during fwd.
-C           In those cases since we only perform the backward step, we do not
-C           need to compute POSINRHSCOMP
-            BUILD_POSINRHSCOMP = .FALSE.
-          ENDIF
+C       next block ok for Schur only
+        IF ( KEEP(221).EQ.2 .AND. KEEP(252).EQ.0
+     &    .AND.  (KEEP(248).NE.1 .OR. (id%NRHS.EQ.1))
+     &    ) THEN
+C         Reduced RHS (Schur feature) was already computed during
+C         a previous forward step AND is valid.
+C         By valid we mean:
+C          -no forward in facto  (KEEP(252)==0) during which
+C           POSINRHSINTR was not computed
+C         AND
+C          -no exploit sparsity with multiple RHS
+C          because in this case POSINRHSINTR would
+C          be valid only for the last block processed during fwd.
+C         In those cases since we only perform the backward step, 
+c         we do not need to compute POSINRHSINTR
+          BUILD_POSINRHSINTR = .FALSE.
+        ENDIF
 C         ------------------------
-C         INITIALIZE POSINRHSCOMP
+C         INITIALIZE POSINRHSINTR
 C         ------------------------
-          IF (BUILD_POSINRHSCOMP) THEN
-C           -- we first set MTYPE_LOC and
-C           -- reset BUILD_POSINRHSCOMP for next iteration in loop
-C
-C           general case only POSINRHSCOMP is computed
-            BUILD_POSINRHSCOMP = .FALSE.
-!           POSINRHSCOMP does not change between blocks
-            MTYPE_LOC = MTYPE
+        IF (BUILD_POSINRHSINTR) THEN
+C{        -- we first set MTYPE_LOC and
+C         -- reset BUILD_POSINRHSINTR for next iteration in loop
+C
+C         general case only POSINRHSINTR is computed
+          BUILD_POSINRHSINTR = .FALSE.
+!         POSINRHSINTR does not change between blocks
+          MTYPE_LOC = MTYPE
 C
-            IF ( (KEEP(111).NE.0) .OR. (KEEP(237).NE.0) .OR.
+          IF ( (KEEP(111).NE.0) .OR. (KEEP(237).NE.0) .OR.
      &         (KEEP(252).NE.0) ) THEN
 C
-              IF (KEEP(111).NE.0) THEN
-C               -- in the context of null space, we need to
-C               -- build RHSCOMP to skip SOL_R. Therefore
-C               -- we need to know for each concerned
-C               -- row index its position in
-C               -- RHSCOMP
-C               We use row indices, as these are the ones that
-C               were used to detect zero pivots during factorization.
-C               POSINRHSCOMP_ROW will allow to find the (row) index of a
-C               zero in RHSCOMP before calling DMUMPS_SOL_S. Then
-C               DMUMPS_SOL_S uses column indices to build the solution
-C               (corresponding to null space vectors)
-                MTYPE_LOC = 1
-              ELSE IF  (KEEP(252).NE.0) THEN
-C               -- Fwd in facto: since fwd is skipped we need to build POSINRHSCOMP
-                MTYPE_LOC = 1  ! (no transpose)
-C     BUILD_POSINRHSCOMP = .FALSE.  ! POSINRHSCOMP does not change between blocks
-              ELSE
-C               -- A-1 only
-                MTYPE_LOC = MTYPE
-                BUILD_POSINRHSCOMP = .TRUE.
-              ENDIF
+            IF (KEEP(111).NE.0) THEN
+C             -- in the context of null space, we need to
+C             -- build RHSINTR to skip SOL_R. Therefore
+C             -- we need to know for each concerned
+C             -- row index its position in
+C             -- RHSINTR
+C             We use row indices, as these are the ones that
+C             were used to detect zero pivots during factorization.
+C             GLOB2LOC_RHS will allow to find the (row) index of a
+C             zero in RHSINTR before calling DMUMPS_SOL_S. Then
+C             DMUMPS_SOL_S uses column indices to build the solution
+C             (corresponding to null space vectors)
+              MTYPE_LOC = 1
+            ELSE IF  (KEEP(252).NE.0) THEN
+C             -- Fwd in facto: since fwd is skipped we need to build POSINRHSINTR
+              MTYPE_LOC = 1  ! (no transpose)
+            ELSE
+C             -- A-1 only
+              MTYPE_LOC = MTYPE
+              BUILD_POSINRHSINTR = .TRUE.
             ENDIF
-C           -- compute POSINRHSCOMP
-            LIW_PASSED=max(1,LIW)
-            IF (KEEP(237).EQ.0) THEN
-              CALL DMUMPS_BUILD_POSINRHSCOMP(
+          ENDIF
+C         -- compute POSINRHSINTR
+          LIW_PASSED=max(1,LIW)
+          IF ( 
+C                no sparsity at fwd or bwd:
+     &           (Lnodes_FWD.EQ.-1).OR.(Lnodes_BWD.EQ.-1)
+C              
+     &          ) THEN
+C
+C           RHSINTR is not sparse (in the sense that it has N rows
+C           distributed on the MPI procs) and thus POSINRHSINTR
+C           does not change with loop.
+C           Remarks:
+C             1/ sparsity might still be exploited during 
+C                fwd or bwd to reduce the number of operations.
+C             2/ 
+            BUILD_POSINRHSINTR = .FALSE.
+C
+            IF ( I_AM_SLAVE ) THEN
+C{
+              CALL DMUMPS_BUILD_GLOB2LOC(
      &           id%NSLAVES,id%N,
      &           id%MYID_NODES, id%PTLUST_S(1),
      &           id%KEEP(1),id%KEEP8(1),
      &           id%PROCNODE_STEPS(1), id%IS(1), LIW_PASSED,
      &           id%STEP(1),
-     &           id%POSINRHSCOMP_ROW(1), id%POSINRHSCOMP_COL(1),
-     &           id%POSINRHSCOMP_COL_ALLOC,
+     &           id%GLOB2LOC_RHS(1), id%GLOB2LOC_SOL(1),
+     &           id%GLOB2LOC_SOL_ALLOC,
      &           MTYPE_LOC,
-     &           NBENT_RHSCOMP, NB_FS_RHSCOMP_TOT )
-                NB_FS_RHSCOMP_F = NB_FS_RHSCOMP_TOT
-            ELSE
-              CALL DMUMPS_BUILD_POSINRHSCOMP_AM1(
+     &           NBENT_RHSINTR, NB_FS_RHSINTR_TOT )
+                NB_FS_RHSINTR_F = NB_FS_RHSINTR_TOT
+C}
+            ENDIF
+C
+          ELSE 
+C
+C  Note that POSINRHSINTR* need not be recomputed before IR :
+C  because distributed solution => NO IR.
+C
+C           Exploit sparsity in solution and RHS 
+C           (AM1 or (Sparse RHS and solution) )
+C           Since sparsity is exploited during
+C           both fwd and bwd then we need to recompute 
+C           POSINRHSINTR only  when CALL_NODES_FWD_BWD will
+C           be performed at next iteration.
+            IF (CALL_NODES_FWD_BWD) BUILD_POSINRHSINTR = .TRUE.
+C
+            IF ( I_AM_SLAVE ) THEN
+C{
+              CALL DMUMPS_BUILD_GLOB2LOC_NODES_ES(
      &           id%NSLAVES,id%N,
      &           id%MYID_NODES, id%PTLUST_S(1), id%DAD_STEPS(1),
      &           id%KEEP(1),id%KEEP8(1),
      &           id%PROCNODE_STEPS(1), id%IS(1), LIW,
      &           id%STEP(1),
-     &           id%POSINRHSCOMP_ROW(1), id%POSINRHSCOMP_COL(1),
-     &           id%POSINRHSCOMP_COL_ALLOC,
+C
+     &            Lnodes_FWD, Lnodes_BWD,
+     &            nodes_FWD_PTR(1), nodes_BWD_PTR(1),
+C
+     &           id%GLOB2LOC_RHS(1), id%GLOB2LOC_SOL(1),
+     &           id%GLOB2LOC_SOL_ALLOC,
      &           MTYPE_LOC,
-     &           IRHS_PTR_COPY(1), NBCOL_INBLOC, IRHS_SPARSE_COPY(1),
-     &           NZ_THIS_BLOCK,PERM_RHS, size(PERM_RHS) , JBEG_RHS,
-     &           NBENT_RHSCOMP,
-     &           NB_FS_RHSCOMP_F, NB_FS_RHSCOMP_TOT,
-     &            UNS_PERM_INV, size(UNS_PERM_INV) ! size 1 if not used
-     &            )
+     &           NBENT_RHSINTR,
+     &           NB_FS_RHSINTR_F, NB_FS_RHSINTR_TOT
+     &           )
+C}
             ENDIF
-          ENDIF   ! BUILD_POSINRHSCOMP=.TRUE.
-          IF (BUILD_RHSMAPINFO .AND. KEEP(248).EQ.-1) THEN
+          ENDIF
+C}
+        ENDIF   ! BUILD_POSINRHSINTR=.TRUE.
+        IF (BUILD_RHSMAPINFO .AND. KEEP(248).EQ.-1
+     &        ) THEN
 C
 C           Prepare symbolic data for sends.
-C           For the moment: MAP_RHS_loc
+C           For the moment: only MAP_RHS_loc
 C
+C           id%GLOB2LOC_RHS is always associated to the
+C           forward step (with or without transposed system)
+          IF ( I_AM_SLAVE ) THEN
+C{
             CALL MUMPS_SOL_RHSMAPINFO( id%N, id%Nloc_RHS, id%KEEP(89),
-     &            IRHS_loc_PTR(1), MAP_RHS_loc, id%POSINRHSCOMP_ROW(1),
+     &            IRHS_loc_PTR(1), MAP_RHS_loc, id%GLOB2LOC_RHS(1),
      &            id%NSLAVES, id%MYID_NODES,
      &            id%COMM_NODES, id%ICNTL(1), id%INFO(1) )
             BUILD_RHSMAPINFO = .FALSE.
 C           MUMPS_SOL_RHSMAPINFO does not propagate errors
-          ENDIF
+C}
+          ENDIF ! I_AM_SLAVE
         ENDIF
         CALL MUMPS_PROPINFO( ICNTL(1), INFO(1),
      &                   id%COMM,id%MYID)
         IF (INFO(1) .LT.0 ) GOTO 90
+        IF ( BUILD_SCALING_RHSINTR ) THEN
+C{
+          IF (SCALING_RHSINTR_BWD_ALLOCATED) THEN
+            NB_BYTES = NB_BYTES - LSCALING_RHSINTR_BWD * K16_8
+            DEALLOCATE(SCALING_RHSINTR_BWD)
+          ENDIF
+          IF (SCALING_RHSINTR_FWD_ALLOCATED) THEN
+            NB_BYTES = NB_BYTES - LSCALING_RHSINTR_FWD * K16_8
+            DEALLOCATE(SCALING_RHSINTR_FWD)
+          ENDIF
+          NULLIFY(SCALING_RHSINTR_BWD)
+          NULLIFY(SCALING_RHSINTR_FWD)
+          SCALING_RHSINTR_BWD_ALLOCATED = .FALSE.
+          SCALING_RHSINTR_FWD_ALLOCATED = .FALSE.
+          SCALING_RHSINTR_BWD => RDUMMY_TARGET
+          SCALING_RHSINTR_FWD => RDUMMY_TARGET
+          LSCALING_RHSINTR_BWD = 1
+          LSCALING_RHSINTR_FWD = 1
+C         Define or allocate SCALING_RHSINTR if needed:
+          IF (LSCAL .AND. I_AM_SLAVE ) THEN
+            IF (KEEP(221).EQ.2) THEN
+C             In case of sparsity during bwd, we cannot
+C             rely on the value of Lnodes_FWD to know
+C             whether the scaling will match SCALING_LOC
+C             and should thus consider that (Lnodes_FWD.NE.-1)
+              ES_RHSINTR = (Lnodes_BWD.NE.-1)
+            ELSE
+C             sparsity at fwd and at bwd:
+              ES_RHSINTR = (Lnodes_FWD.NE.-1).AND.(Lnodes_BWD.NE.-1)
+            ENDIF
+C           Scaling allocations performed only if needed
+C             Forward or normal solve:
+              IF ( ES_RHSINTR ) THEN
+                LSCALING_RHSINTR_FWD = max(1, NB_FS_RHSINTR_F )
+                ALLOCATE(SCALING_RHSINTR_FWD(LSCALING_RHSINTR_FWD),
+     &                   stat=allocok)
+                IF (allocok .GT. 0) THEN
+                  INFO(1)=-13
+                  INFO(2)=LSCALING_RHSINTR_FWD
+                ELSE
+                  SCALING_RHSINTR_FWD_ALLOCATED = .TRUE.
+                  NB_BYTES = NB_BYTES + LSCALING_RHSINTR_FWD * K16_8
+                ENDIF
+              ELSE
+C               RHSINTR matches SCALING_loc, no need to
+C               allocate and compute a different scaling
+                LSCALING_RHSINTR_FWD = max(1,KEEP(89))
+#if defined(USE_OLD_SCALING)
+#else
+                SCALING_RHSINTR_FWD => SCALING_LOC_FWD
+#endif
+              ENDIF
+              IF (ES_RHSINTR) THEN
+                  LSCALING_RHSINTR_BWD = max(1, NB_FS_RHSINTR_TOT )
+                ALLOCATE(SCALING_RHSINTR_BWD(LSCALING_RHSINTR_BWD),
+     &                   stat=allocok)
+                IF (allocok .GT. 0) THEN
+                  INFO(1)=-13
+                  INFO(2)=LSCALING_RHSINTR_BWD
+                ELSE
+                  SCALING_RHSINTR_BWD_ALLOCATED = .TRUE.
+                  NB_BYTES = NB_BYTES + LSCALING_RHSINTR_BWD * K16_8
+                ENDIF
+              ELSE
+C               RHSINTR matches SCALING_loc, no need to
+C               allocate and compute a different scaling
+                LSCALING_RHSINTR_BWD = max(1,KEEP(89))
+#if defined(USE_OLD_SCALING)
+                SCALING_RHSINTR_BWD => scaling_data_sol%SCALING_LOC
+#else
+                SCALING_RHSINTR_BWD => SCALING_LOC_BWD
+                SCALING_RHSINTR_FWD => SCALING_LOC_FWD
+#endif
+              ENDIF
+          ENDIF
+C}
+        ENDIF
+        CALL MUMPS_PROPINFO( id%ICNTL, id%INFO, id%COMM,id%MYID)
+        IF (id%INFO(1) .LT.0 ) GOTO 90
+        IF (BUILD_SCALING_RHSINTR) THEN
+C{
+          IF ( LSCAL .AND. I_AM_SLAVE. AND. ES_RHSINTR ) THEN
+#if ! defined(USE_OLD_SCALING)
+C             SCALING_RHSINTR_FWD has been allocated and should
+C             now be filled. It is a compressed version of the
+C             local scaling array SCALING_LOC_FWD:
+              IF (MTYPE.eq.0 .AND. KEEP(50).EQ.0) THEN ! tranpose
+                ROWORCOL = 2 ! access 2nd list -- col indices
+              ELSE
+                ROWORCOL = 1 ! access 1st list -- row indices
+              ENDIF
+              CALL DMUMPS_SCALINGRHSINTR(LSCAL, id%N,
+     &             SCALING_LOC_FWD(1),
+     &             SCALING_RHSINTR_FWD(1),
+     &             LSCALING_RHSINTR_FWD, id%GLOB2LOC_RHS(1),
+     &             id%KEEP, ROWORCOL, id%PTLUST_S(1),
+     &             id%IS(1), max(1,LIW),
+     &             id%MYID_NODES, id%STEP(1), id%PROCNODE_STEPS(1),
+     &             id%NSLAVES)
+C             SCALING_RHSINTR_BWD has been allocated and should
+C             now be filled. It is a compressed version of the
+C             local scaling array SCALING_LOC_BWD:
+              IF (MTYPE.eq.1 .AND. KEEP(50).EQ.0) THEN ! no tranpose
+C               access 2nd list corresponding to col indices
+                ROWORCOL = 2 
+              ELSE
+C               access 1st list corresponding to row indices
+                ROWORCOL = 1 
+              ENDIF
+              CALL DMUMPS_SCALINGRHSINTR(LSCAL, id%N,
+     &             SCALING_LOC_BWD(1),
+     &             SCALING_RHSINTR_BWD(1),
+     &             LSCALING_RHSINTR_BWD, id%GLOB2LOC_SOL(1),
+     &             id%KEEP, ROWORCOL, id%PTLUST_S(1),
+     &             id%IS(1), max(1,LIW),
+     &             id%MYID_NODES, id%STEP(1), id%PROCNODE_STEPS(1),
+     &             id%NSLAVES)
+#endif
+#if defined(USE_OLD_SCALING)
+#endif
+          ENDIF
+C         Rebuild SCALING_RHSINTR* next time
+C         only if POSINRHSINTR has to be built
+C         again next time:
+          BUILD_SCALING_RHSINTR= BUILD_POSINRHSINTR
+C}
+        ENDIF
         IF (I_AM_SLAVE) THEN
-          IF (KEEP(221).EQ.1) THEN
-C           we need to save the reduced RHS for all RHS to perform
-C           later the backward phase with an updated reduced RHS
-C           thus we allocate NRHS_NONEMPTY columns in one shot.
-C           Note that RHSCOMP might have been allocated in previous block
-C           and RHSCOMP has been deallocated previous to entering loop on RHS
-            IF (.not. associated(id%RHSCOMP)) THEN
+          IF ((KEEP(221).EQ.1).OR.KEEP(221).EQ.-1) THEN
+C         For the following cases:
+C          -[Schur] we need to save the reduced RHS for all RHS 
+C                 to perform later the backward phase with an
+C                 updated reduced RHS
+C          -[Fwd only] return RHSINTR to user
+C          -KEEP(221)=-1, allocate RHSINTR to enable bwd only step
+C         We need to allocate NRHS_NONEMPTY columns in one shot.
+C         Note that 
+C            -RHSINTR might have been allocated in previous block
+C            -RHSINTR has been deallocated previous to entering 
+C             loop on RHS
+            IF (.not. associated(id%RHSINTR)) THEN
 C             So far we cannot combine this to exploit sparsity
-C             so that NBENT_RHSCOMP will not change in the loop
-C             and can be used to dimension RHSCOMP
+C             so that NBENT_RHSINTR will not change in the loop
+C             and can be used to dimension RHSINTR
+C
 C             Furthermore, during bwd phase the REDRHS provided
 C             by the user might also have a different non empty
 C             column pattern than the sparse RHS provided on input to
 C             this phase: thus we need to allocate id%NRHS columns too.
-              LD_RHSCOMP = max(NBENT_RHSCOMP,1)
-              id%KEEP8(25) = int(LD_RHSCOMP,8)*int(id%NRHS,8)
-              ALLOCATE (id%RHSCOMP(id%KEEP8(25)),  stat = allocok)
+              id%LD_RHSINTR = max(NBENT_RHSINTR,1)
+              id%KEEP8(25) = int(id%LD_RHSINTR,8)*int(id%NRHS,8)
+              ALLOCATE (id%RHSINTR(id%KEEP8(25)),  stat = allocok)
               IF ( allocok .GT. 0 ) THEN
                  INFO(1)=-13
                  CALL MUMPS_SET_IERROR(id%KEEP8(25),INFO(2))
@@ -3330,34 +3941,35 @@ C             this phase: thus we need t
               NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
             ENDIF
           ENDIF
-          IF ((KEEP(221).NE.1).AND.
+C 
+C
+          IF ((KEEP(221).NE.1).AND. 
      &        ((KEEP(221).NE.2).OR.(KEEP(252).NE.0))
      &       ) THEN
 C           ------------------
-C           Allocate RHSCOMP (case of RHSCOMP allocated at each block of RHS)
+C           Allocate RHSINTR
+C           (case of RHSINTR allocated at each block of RHS)
 C           ------------------
-C           RHSCOMP allocated per block of maximum size NBRHS
-            LD_RHSCOMP = max(NBENT_RHSCOMP, LD_RHSCOMP)
+C           RHSINTR allocated per block of maximum size NBRHS
 C           NBRHS_EFF could be used instead on NBRHS
-            IF (associated(id%RHSCOMP)) THEN
-              IF ( (id%KEEP8(25).LT.int(LD_RHSCOMP,8)*int(NBRHS,8))
-     &          .OR. (KEEP(235).NE.0).OR.(KEEP(237).NE.0) ) THEN
-                ! deallocate and reallocate if:
-                ! _larger array needed
-                ! OR 
-                ! _exploit sparsity/A-1: since size of RHSCOMP 
-                ! is expected to vary much in these cases
-                ! this should improve locality
+            IF (associated(id%RHSINTR)) THEN
+C             RHSINTR already associated for previous
+C             block, check if we can reuse it.
+              id%LD_RHSINTR = max(NBENT_RHSINTR, 1)
+              IF (id%KEEP8(25).LT.int(id%LD_RHSINTR,8)*int(NBRHS,8))
+     &        THEN
+                ! deallocate and reallocate since larger array is needed
                  NB_BYTES = NB_BYTES - id%KEEP8(25)*K35_8
-                 DEALLOCATE(id%RHSCOMP)
-                 NULLIFY(id%RHSCOMP)
-                 id%KEEP8(25)=0_8
+                 DEALLOCATE(id%RHSINTR)
+                 NULLIFY(id%RHSINTR)
+                 id%KEEP8(25)  = 0_8
+                 id%LD_RHSINTR = 0
               ENDIF
             ENDIF
-            IF (.not. associated(id%RHSCOMP)) THEN
-              LD_RHSCOMP = max(NBENT_RHSCOMP, 1)
-              id%KEEP8(25) = int(LD_RHSCOMP,8)*int(NBRHS,8)
-              ALLOCATE (id%RHSCOMP(id%KEEP8(25)),  stat = allocok )
+            IF (.not. associated(id%RHSINTR)) THEN
+              id%LD_RHSINTR = max(NBENT_RHSINTR, 1)
+              id%KEEP8(25) = int(id%LD_RHSINTR,8)*int(NBRHS,8)
+              ALLOCATE (id%RHSINTR(id%KEEP8(25)),  stat = allocok )
               IF ( allocok .GT. 0 ) THEN
                INFO(1)=-13
                CALL MUMPS_SET_IERROR(id%KEEP8(25),INFO(2))
@@ -3367,22 +3979,16 @@ C           NBRHS_EFF could be used inst
               NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
             ENDIF
           ENDIF
-          IF (KEEP(221).EQ.2) THEN
-C           RHSCOMP has been allocated (call with KEEP(221).EQ.1)
-C           even in the case fwd in facto
-            ! Not correct: LD_RHSCOMP = LENRHSCOMP/id%NRHS_NONEMPTY
-            LD_RHSCOMP = int(id%KEEP8(25)/int(id%NRHS,8))
-          ENDIF
 C
-C         Shift on RHSCOMP
+C         Shift on RHSINTR
 C
           IF ( KEEP(221).EQ.0 ) THEN
-C            -- RHSCOMP reused in the loop
-             IBEG_RHSCOMP= 1_8
+C            -- RHSINTR reused in the loop
+             IBEG_RHSINTR= 1_8
           ELSE
-C            Initialize IBEG_RHSCOMP
+C            Initialize IBEG_RHSINTR
 C
-             IBEG_RHSCOMP= int(JBEG_RHS-1,8)*int(LD_RHSCOMP,8) + 1_8
+            IBEG_RHSINTR= int(JBEG_RHS-1,8)*int(id%LD_RHSINTR,8)+1_8
           ENDIF
         ENDIF   ! I_AM_SLAVE
 C =====================  ERROR handling and propagation ================
@@ -3396,7 +4002,8 @@ C       ---------------------------
 C       Prepare RHS on master (case
 C       of dense and sparse RHS)
 C       ---------------------------
-        IF (id%MYID .eq. MASTER) THEN
+        IF (id%MYID .eq. MASTER
+     &     ) THEN
 C         =========================
           IF (KEEP(23) .NE. 0) THEN
 C         =========================
@@ -3459,8 +4066,10 @@ C
               ENDDO
             ENDIF
           ENDIF
+#if defined(USE_OLD_SCALING)
 C
 C         RHS is set to scaled right hand side
+C         (case of centralized scaling only)
 C
           IF (LSCAL) THEN
 C           scaling was performed
@@ -3571,6 +4180,7 @@ C                     Original IRHS_PTR
               ENDIF
             ENDIF  ! KEEP(248)==1
           ENDIF  ! LSCAL
+#endif
         ENDIF  ! id%MYID.EQ.MASTER
 #if defined(V_T)
         CALL VTEND(perm_scal_ini,IERR)
@@ -3579,16 +4189,6 @@ C
 C       Prepare RHS on master
 C       END
 C       =====================
-        IF ((KEEP(248).EQ.1).AND.(KEEP(237).EQ.0)) THEN
-          ! case of general sparse: in case of empty columns
-          ! modifed version of
-          ! NBRHS_EFF need be broadcasted since it is used
-          ! to update BEG_RHS at the end of the DO WHILE
-            CALL MPI_BCAST( NBRHS_EFF,1, MPI_INTEGER,
-     &           MASTER, id%COMM,IERR)
-            CALL MPI_BCAST(NB_RHSSKIPPED,1,MPI_INTEGER,MASTER,
-     &               id%COMM,IERR)
-        ENDIF
 C       -----------------------------------
 C       Two main cases depending on option
 C       for null space computation:
@@ -3605,7 +4205,7 @@ C       --------------------------------
         TIMESCATTER1=MPI_WTIME()
         IF ((KEEP(111).eq.0).AND.(KEEP(252).EQ.0)
      &        .AND.(KEEP(221).NE.2 )) THEN
-C           ------------------------
+C{          ------------------------
 C           Use RHS provided by user
 C           when not null space and not Fwd in facto
 C           ------------------------
@@ -3616,7 +4216,7 @@ C             --------------------------
               IF ( .NOT.I_AM_SLAVE ) THEN
 C               -- Master not working
                 CALL DMUMPS_SCATTER_RHS(id%NSLAVES,id%N, id%MYID,
-     &          id%COMM,
+     &          id%COMM, LSCAL, SCALING_LOC_FWD(1),
      &          MTYPE, id%RHS(IBEG), LD_RHS, NBRHS_EFF,
      &          NBRHS_EFF,
      &          C_DUMMY, 1, 1,
@@ -3639,11 +4239,11 @@ C               -- Master not working
                 ENDIF
                 LIW_PASSED = max( LIW, 1 )
                 CALL DMUMPS_SCATTER_RHS(id%NSLAVES,id%N, id%MYID,
-     &          id%COMM,
+     &          id%COMM, LSCAL, SCALING_LOC_FWD(1),
      &          MTYPE, PTR_RHS(IBEG_loc),LD_RHS_loc,NCOL_RHS_loc,
      &          NBRHS_EFF,
-     &          id%RHSCOMP(IBEG_RHSCOMP), LD_RHSCOMP, NBRHS_EFF,
-     &          id%POSINRHSCOMP_ROW(1), NB_FS_RHSCOMP_F,
+     &          id%RHSINTR(IBEG_RHSINTR), id%LD_RHSINTR, NBRHS_EFF,
+     &          id%GLOB2LOC_RHS(1), NB_FS_RHSINTR_F,
 C
      &          id%PTLUST_S(1), id%KEEP(1), id%KEEP8(1),
      &          id%PROCNODE_STEPS(1),
@@ -3671,9 +4271,14 @@ C
      &          IRHS_loc_PTR(1),
      &          idRHS_loc(RHS_loc_shift),
      &          RHS_loc_size,
-     &          id%RHSCOMP(IBEG_RHSCOMP), LD_RHSCOMP,
-     &          id%POSINRHSCOMP_ROW(1), NB_FS_RHSCOMP_F,
-     &          LSCAL, scaling_data_dr,
+     &          id%RHSINTR(IBEG_RHSINTR), id%LD_RHSINTR,
+     &          id%GLOB2LOC_RHS(1), NB_FS_RHSINTR_F,
+     &          LSCAL,
+#if defined(USE_OLD_SCALING)
+     &          scaling_data_dr,
+#else
+     &          SCALING_RHSINTR_FWD(1), LSCALING_RHSINTR_FWD,
+#endif
      &          LP, LPOK, KEEP(1), NB_BYTES_LOC, INFO(1))
 C               NB_BYTES_LOC were allocated and freed above
                 NB_BYTES_MAX = max(NB_BYTES_MAX,
@@ -3686,14 +4291,20 @@ C               NB_BYTES_LOC were alloca
 C             ===  KEEP(248)==1 =========
 C             -- SPARSE RIGHT-HAND-SIDE
 C             ----------------------------
-              IF (NZ_THIS_BLOCK > 0) THEN
+              IF (NZ_THIS_BLOCK > 0
+#if ! defined(USE_OLD_SCALING)
+C               For AM1, no need to broadcast RHS_SPARSE
+C               when using local scalings. RHSINTR will
+C               be initialized directly and RHS_SPARSE
+C               is used during DMUMPS_GATHER_SOLUTION_AM1
+     &            .AND. id%KEEP(237) .EQ.0
+#endif
+     &        ) THEN
                 CALL MPI_BCAST(RHS_SPARSE_COPY(1),
      &                     NZ_THIS_BLOCK,
      &                     MPI_DOUBLE_PRECISION,
      &                     MASTER, id%COMM, IERR)
               ENDIF
-C             -- At this point each process has a copy of the
-C             -- sparse RHS. We need to store it into RHSCOMP.
 C
               IF (KEEP(237).NE.0)  THEN
                 IF ( I_AM_SLAVE ) THEN
@@ -3701,37 +4312,43 @@ C                 -----
 C                 case of A-1
 C                 -----
 C                 - Take columns with non-zero entry, say j,
-C                 - to build Ej and store it in RHSCOMP
-                  K=1              ! Column index in RHSCOMP
-                  id%RHSCOMP(1_8:int(NBRHS_EFF,8)*int(LD_RHSCOMP,8))
+C                 - to build Ej and store it in RHSINTR
+                  K=1              ! Column index in RHSINTR
+                  id%RHSINTR(1_8:int(NBRHS_EFF,8)*int(id%LD_RHSINTR,8))
      &            = ZERO
                   IPOS = 1
                   DO I = 1, NBCOL_INBLOC
                     COLSIZE = IRHS_PTR_COPY(I+1) - IRHS_PTR_COPY(I)
                     IF (COLSIZE.GT.0) THEN
                       ! Find global column index J and set
-                      ! column K of RHSCOMP to ej (here IBEG is one)
+                      ! column K of RHSINTR to ej (here IBEG is one)
                       J = I - 1 + JBEG_RHS
                       IF (DO_PERMUTE_RHS.OR.INTERLEAVE_PAR) THEN
                         J = PERM_RHS(J)
                       ENDIF
-                      IPOSRHSCOMP = id%POSINRHSCOMP_ROW(J)
-C                     IF ( (IPOSRHSCOMP.LE.NB_FS_RHSCOMP_F)
-C     &               .AND.(IPOSRHSCOMP.GT.0) ) THEN
-                      IF (IPOSRHSCOMP.GT.0)  THEN
+                      IPOSRHSINTR = id%GLOB2LOC_RHS(J)
+C                     IF ( (IPOSRHSINTR.LE.NB_FS_RHSINTR_F)
+C     &               .AND.(IPOSRHSINTR.GT.0) ) THEN
+                      IF (IPOSRHSINTR.GT.0)  THEN
 C                       Columns J corresponds to ej and thus to variable j
-C                       that is on my proc
-C                       Note that :
-C                       In first entry in column
-C                       we have and MUST have already scaled value of diagonal.
-C                       This need have been done on master because we do not
-C                       have scaling arrays available on slaves.
-C                       Furthermore we know that only one entry is
-C                       needed the diagonal entry (for the forward with A-1).
-C
-                        id%RHSCOMP(int(K-1,8)*int(LD_RHSCOMP,8)+
-     &                       int(IPOSRHSCOMP,8)) =
+C                       that is on my proc.
+C                       We know that only one entry is needed,
+C                       the diagonal entry (for the forward with A-1).
+C
+#if defined(USE_OLD_SCALING)
+                        id%RHSINTR(int(K-1,8)*int(id%LD_RHSINTR,8)+
+     &                       int(IPOSRHSINTR,8)) =
      &                       RHS_SPARSE_COPY(IPOS)
+#else
+                        IF (LSCAL) THEN
+                          id%RHSINTR(int(K-1,8)*int(id%LD_RHSINTR,8)+
+     &                    int(IPOSRHSINTR,8)) =
+     &                    SCALING_RHSINTR_FWD(IPOSRHSINTR)
+                        ELSE
+                          id%RHSINTR(int(K-1,8)*int(id%LD_RHSINTR,8)+
+     &                    int(IPOSRHSINTR,8)) = ONE
+                        ENDIF
+#endif
                       ENDIF               ! End of J on my proc
                       K = K + 1
                       IPOS = IPOS + COLSIZE  ! go to next column
@@ -3750,12 +4367,14 @@ C               -------
 C               --------------
 C               General sparse
 C               --------------
-C               -- reset to zero RHSCOMP for skipped columns (if any)
+C               -- At this point each process has a copy of the
+C               -- sparse RHS. We need to store it into RHSINTR.
+C               -- reset to zero RHSINTR for skipped columns (if any)
                 IF ((KEEP(221).EQ.1).AND.(NB_RHSSKIPPED.GT.0)
      &            .AND.I_AM_SLAVE) THEN
                   DO K = JBEG_RHS-NB_RHSSKIPPED, JBEG_RHS-1
-                    DO I = 1,  LD_RHSCOMP
-                      id%RHSCOMP(int(K-1,8)*int(LD_RHSCOMP,8)
+                    DO I = 1,  id%LD_RHSINTR
+                      id%RHSINTR(int(K-1,8)*int(id%LD_RHSINTR,8)
      &                           + int(I,8)) =  ZERO
                     ENDDO
                   ENDDO
@@ -3763,36 +4382,62 @@ C               -- reset to zero RHSCOMP
                 IF (I_AM_SLAVE) THEN
                   DO K = 1, NBCOL_INBLOC
 !                   it is equal to NBRHS_EFF in this case
-                    KDEC = int(K-1,8) * int(LD_RHSCOMP,8) +
-     &                     IBEG_RHSCOMP - 1_8
-                    id%RHSCOMP(KDEC+1_8:KDEC+NBENT_RHSCOMP) = ZERO
-                    DO IZ=IRHS_PTR_COPY(K), IRHS_PTR_COPY(K+1)-1
-                      I=IRHS_SPARSE_COPY(IZ)
-                      IPOSRHSCOMP = id%POSINRHSCOMP_ROW(I)
-C                     Since all fully summed variables mapped
-C                     on each proc are stored at the beginning
-C                     of RHSCOMP, we can compare to KEEP(89)
-C                     to know if RHSCOMP should be initialized
-C                     So far the tree has not been pruned to exploit
-C                     sparsity to compress RHSCOMP so we compare to
-C                     NB_FS_RHSCOMP_TOT
-                      IF ( (IPOSRHSCOMP.LE.NB_FS_RHSCOMP_TOT)
-     &                .AND.(IPOSRHSCOMP.GT.0) ) THEN
-C                        ! I is fully summed var mapped on my proc
-                        id%RHSCOMP(KDEC+IPOSRHSCOMP)=
-     &                  id%RHSCOMP(KDEC+IPOSRHSCOMP) +
-     &                  RHS_SPARSE_COPY(IZ)
-                      ENDIF
-                    ENDDO
+                    KDEC = int(K-1,8) * int(id%LD_RHSINTR,8) +
+     &                     IBEG_RHSINTR - 1_8
+                    id%RHSINTR(KDEC+1_8:KDEC+NBENT_RHSINTR) = ZERO
+#if ! defined(USE_OLD_SCALING)
+                    IF (LSCAL) THEN
+                      DO IZ=IRHS_PTR_COPY(K), IRHS_PTR_COPY(K+1)-1
+                        I=IRHS_SPARSE_COPY(IZ)
+                        IPOSRHSINTR = id%GLOB2LOC_RHS(I)
+C                       Since all fully summed variables mapped
+C                       on each proc are stored at the beginning
+C                       of RHSINTR, we can compare to KEEP(89)
+C                       to know if RHSINTR should be initialized
+C                       So far the tree has not been pruned to exploit
+C                       sparsity to compress RHSINTR so we compare to
+C                       NB_FS_RHSINTR_TOT
+                        IF ( (IPOSRHSINTR.LE.NB_FS_RHSINTR_TOT)
+     &                  .AND.(IPOSRHSINTR.GT.0) ) THEN
+C                          ! I is fully summed var mapped on my proc
+                          id%RHSINTR(KDEC+IPOSRHSINTR)=
+     &                    id%RHSINTR(KDEC+IPOSRHSINTR) +
+     &                    RHS_SPARSE_COPY(IZ)
+     &                    * SCALING_RHSINTR_FWD(IPOSRHSINTR)
+                        ENDIF
+                      ENDDO
+                    ELSE
+#endif
+                      DO IZ=IRHS_PTR_COPY(K), IRHS_PTR_COPY(K+1)-1
+                        I=IRHS_SPARSE_COPY(IZ)
+                        IPOSRHSINTR = id%GLOB2LOC_RHS(I)
+C                       Since all fully summed variables mapped
+C                       on each proc are stored at the beginning
+C                       of RHSINTR, we can compare to KEEP(89)
+C                       to know if RHSINTR should be initialized
+C                       So far the tree has not been pruned to exploit
+C                       sparsity to compress RHSINTR so we compare to
+C                       NB_FS_RHSINTR_TOT
+                        IF ( (IPOSRHSINTR.LE.NB_FS_RHSINTR_TOT)
+     &                  .AND.(IPOSRHSINTR.GT.0) ) THEN
+C                          ! I is fully summed var mapped on my proc
+                          id%RHSINTR(KDEC+IPOSRHSINTR)=
+     &                    id%RHSINTR(KDEC+IPOSRHSINTR) +
+     &                    RHS_SPARSE_COPY(IZ)
+                        ENDIF
+                      ENDDO
+#if ! defined(USE_OLD_SCALING)
+                    ENDIF
+#endif
                   ENDDO
                 END IF ! I_AM_SLAVE
               ENDIF ! KEEP(237)
             ENDIF  ! ==== KEEP(248)==1 =====
-C
+C}
         ELSE IF (I_AM_SLAVE) THEN
             ! I_AM_SLAVE AND (null space or Fwd in facto)
             IF (KEEP(111).NE.0) THEN
-C             -----------------------
+C{            -----------------------
 C             Null space computations
 C             -----------------------
 C
@@ -3889,10 +4534,10 @@ C ======================================
 C               End IF Exploit Sparsity
               ENDIF
 c
-C             Initialize RHSCOMP to 0  ! to be suppressed
+C             Initialize RHSINTR to 0  ! to be suppressed
               DO K=1, NBRHS_EFF
-                KDEC = int(K-1,8) * int(LD_RHSCOMP,8)
-                id%RHSCOMP(KDEC+1_8:KDEC+int(LD_RHSCOMP,8))=ZERO
+                KDEC = int(K-1,8) * int(id%LD_RHSINTR,8)
+                id%RHSINTR(KDEC+1_8:KDEC+int(id%LD_RHSINTR,8))=ZERO
               END DO
 C             Loop over the columns.
 C             Note that if ( KEEP(220)+KEEP(109)-1 < IBEG_GLOB_DEF
@@ -3907,18 +4552,18 @@ C               step incompatible, do on
      &               min(IEND_GLOB_DEF,KEEP(220)+KEEP(109)-1)
 C                 Local processor is concerned by I-th column of
 C                 global right-hand side.
-                  JJ= id%POSINRHSCOMP_ROW(id%PIVNUL_LIST(I-KEEP(220)+1))
+                  JJ= id%GLOB2LOC_RHS(id%PIVNUL_LIST(I-KEEP(220)+1))
                   IF (JJ.GT.0) THEN
                     IF (KEEP(50).EQ.0) THEN
                       ! unsymmetric : always set to fixation
-                      id%RHSCOMP( IBEG_RHSCOMP+
-     &                    int(I-IBEG_GLOB_DEF,8)*int(LD_RHSCOMP,8) +
+                      id%RHSINTR( IBEG_RHSINTR+
+     &                    int(I-IBEG_GLOB_DEF,8)*int(id%LD_RHSINTR,8)+
      &                    int(JJ-1,8) ) =
      &                    id%DKEEP(2)
                     ELSE
                       ! Symmetric: always set to one
-                      id%RHSCOMP( IBEG_RHSCOMP+
-     &                int(I-IBEG_GLOB_DEF,8)*int(LD_RHSCOMP,8)+
+                      id%RHSINTR( IBEG_RHSINTR+
+     &                int(I-IBEG_GLOB_DEF,8)*int(id%LD_RHSINTR,8)+
      &                int(JJ-1,8) )=
      &                ONE
                     ENDIF
@@ -3949,9 +4594,10 @@ C               for this set of right-ha
                 IEND_ROOT_DEF = -95999
                 IROOT_DEF_RHS_COL1= 1
               ENDIF
+C}
             ELSE  ! End of null space (test on KEEP(111))
 C             case of Fwd in facto
-C             id%RHSCOMP need not be initialized. It will be set on the fly
+C             id%RHSINTR need not be initialized. It will be set on the fly
 C             to zero for normal fully summed variables of the fronts and
 C             to -1 on the roots for the id%N+KEEP(253) variables added
 C             to the roots.
@@ -3990,7 +4636,7 @@ C             Otherwise, we use workspac
             LWCB8_SOL_C = LWCB8_SOL_C - LPTR_RHS_ROOT
           ENDIF
         ENDIF
-        IF (KEEP(221) .EQ. 2 ) THEN
+        IF (KEEP(221) .EQ. 2 .AND. KEEP(60).NE.0 ) THEN
 C         Copy/send REDRHS in PTR_RHS_ROOT
 C         (column by column if leading dimension LD_REDRHS
 C         of REDRHS is not equal to SIZE_ROOT).
@@ -4053,13 +4699,13 @@ C         -- other procs are not concern
           LIW_PASSED = max( LIW, 1 )
           LA_PASSED  = max( LA, 1_8 )
 C
-          IF ((id%KEEP(235).EQ.0).and.(id%KEEP(237).EQ.0) ) THEN
+          IF (Lnodes_FWD.EQ.-1 .AND. Lnodes_BWD.EQ.-1) THEN
 C
-C         --- Normal case : we do not exploit sparsity of the RHS
+C         --- Normal case : we do not exploit sparsity during
+C             foward and backward steps
 C
             FROM_PP = .FALSE.
             NBSPARSE_LOC = (DO_NBSPARSE.AND.NBRHS_EFF.GT.1)
-            PRUNED_SIZE_LOADED = 0_8  ! From DMUMPS_SOL_ES module
             CALL DMUMPS_SOL_C(id%root, id%N, id%S(1), LA_PASSED, IS(1),
      & LIW_PASSED, WORK_WCB(1), LWCB8_SOL_C, IWCB, LIWCB, NBRHS_EFF,
      & id%NA(1),id%LNA,id%NE_STEPS(1), SRW3, MTYPE, ICNTL(1), FROM_PP,
@@ -4070,10 +4716,15 @@ C
      & BUFR(1), LBUFR, LBUFR_BYTES, id%ISTEP_TO_INIV2(1),
      & id%TAB_POS_IN_PERE(1,1), IBEG_ROOT_DEF, IEND_ROOT_DEF,
      & IROOT_DEF_RHS_COL1, PTR_RHS_ROOT(1), LPTR_RHS_ROOT, SIZE_ROOT,
-     & MASTER_ROOT, id%RHSCOMP(IBEG_RHSCOMP), LD_RHSCOMP,
-     & id%POSINRHSCOMP_ROW(1), id%POSINRHSCOMP_COL(1)
+     & MASTER_ROOT, id%RHSINTR(IBEG_RHSINTR), id%LD_RHSINTR,
+     & id%GLOB2LOC_RHS(1), id%GLOB2LOC_SOL(1)
+     &  , -1, -1,
+     &  IDUMMY(1), IDUMMY(1)
      & , 1, 1, 1, 1, IDUMMY, 1, JDUMMY, KDUMMY, 1, LDUMMY, 1, MDUMMY
      & , 1, 1, NBSPARSE_LOC, PTR_RHS_BOUNDS(1), LPTR_RHS_BOUNDS
+#if defined(STAT_ES_SOLVE)
+     & , IDUMMY, 1, JDUMMY, 1
+#endif
      & , id%IPOOL_B_L0_OMP(1), id%LPOOL_B_L0_OMP, id%IPOOL_A_L0_OMP(1),
      & id%LPOOL_A_L0_OMP, id%L_VIRT_L0_OMP, id%VIRT_L0_OMP(1),
      & id%L_PHYS_L0_OMP, id%PHYS_L0_OMP(1), id%PERM_L0_OMP(1),
@@ -4095,12 +4746,18 @@ C
      & id%DKEEP(1),id%COMM_NODES,id%MYID,id%MYID_NODES,BUFR(1),LBUFR,
      & LBUFR_BYTES, id%ISTEP_TO_INIV2(1), id%TAB_POS_IN_PERE(1,1),
      & IBEG_ROOT_DEF,IEND_ROOT_DEF,IROOT_DEF_RHS_COL1,PTR_RHS_ROOT(1),
-     & LPTR_RHS_ROOT, SIZE_ROOT, MASTER_ROOT, id%RHSCOMP(IBEG_RHSCOMP),
-     & LD_RHSCOMP, id%POSINRHSCOMP_ROW(1), id%POSINRHSCOMP_COL(1),
+     & LPTR_RHS_ROOT, SIZE_ROOT, MASTER_ROOT, id%RHSINTR(IBEG_RHSINTR),
+     & id%LD_RHSINTR, id%GLOB2LOC_RHS(1), id%GLOB2LOC_SOL(1),
+     &  Lnodes_FWD, Lnodes_BWD,
+     &  nodes_FWD_PTR(1), nodes_BWD_PTR(1),
      & NZ_THIS_BLOCK, NBCOL_INBLOC, id%NRHS, JBEG_RHS, id%Step2node(1),
      & id%KEEP(28),IRHS_SPARSE_COPY(1),IRHS_PTR_COPY(1), size(PERM_RHS),
-     & PERM_RHS, size(UNS_PERM_INV), UNS_PERM_INV, NB_FS_RHSCOMP_F,
-     & NB_FS_RHSCOMP_TOT,NBSPARSE_LOC,PTR_RHS_BOUNDS(1),LPTR_RHS_BOUNDS
+     & PERM_RHS, size(UNS_PERM_INV), UNS_PERM_INV, NB_FS_RHSINTR_F,
+     & NB_FS_RHSINTR_TOT,NBSPARSE_LOC,PTR_RHS_BOUNDS(1),LPTR_RHS_BOUNDS
+#if defined(STAT_ES_SOLVE)
+     & ,idIPTR_WORKING(1),SIZE_IPTR_WORKING,idWORKING(1),SIZE_WORKING
+C     & ,id%IPTR_WORKING(1),SIZE_IPTR_WORKING,id%WORKING(1),SIZE_WORKING
+#endif
      & ,id%IPOOL_B_L0_OMP(1),id%LPOOL_B_L0_OMP,id%IPOOL_A_L0_OMP(1),
      & id%LPOOL_A_L0_OMP,id%L_VIRT_L0_OMP,id%VIRT_L0_OMP(1),
      & id%L_PHYS_L0_OMP, id%PHYS_L0_OMP(1), id%PERM_L0_OMP(1),
@@ -4139,7 +4796,8 @@ C       ================================
 C       ONLY FORWARD was performed (case of reduced RHS with Schur
 C                               option during factorisation)
 C       ======================================================
-        IF ( KEEP(221) .EQ. 1 ) THEN ! === Begin OF REDUCED RHS ======
+        IF ( (KEEP(60).NE.0) .AND. 
+     &       KEEP(221) .EQ. 1 ) THEN ! === Begin OF REDUCED RHS ======
 C         --------------------------------------
 C         Send (or copy) reduced RHS from PTR_RHS_ROOT located on
 C         MASTER_ROOT_IN_COMM to REDRHS located on MASTER (host node).
@@ -4199,14 +4857,14 @@ C               -- send all in on shot
             ENDIF
 C         -- other procs are not concerned
           ENDIF
-        ENDIF ! ====== END OF REDUCED RHS (Fwd only performed) ======
+        ENDIF ! ===== END OF REDUCED RHS (Schur+Fwd only performed) ==
 C       =======================================================
 C       BACKWARD was PERFORMED
 C       Postprocess solution that is distributed
         IF ( KEEP(221) .NE. 1 ) THEN  ! BACKWARD was PERFORMED
 C       -- KEEP(221).NE.1 => we are sure that backward has been performed
           IF (ICNTL21 == 0) THEN ! CENTRALIZED SOLUTION
-C           ========================================================
+C{          ========================================================
 C           GATHER SOLUTION computed during bwd
 C           Each proc holds the pieces of solution corresponding
 C           to all fully summed variables mapped on that processor
@@ -4250,8 +4908,9 @@ C           Propagate errors
      &                       id%COMM,id%MYID)
 C           Return in case of error.
             IF (INFO(1).LT.0) GO TO 90
+#if defined(USE_OLD_SCALING)
             IF ((id%MYID.NE.MASTER).OR. .NOT.LSCAL) THEN
-             PT_SCALING => Dummy_SCAL
+              PT_SCALING => Dummy_SCAL
             ELSE
               IF (MTYPE.EQ.1) THEN
                 PT_SCALING => id%COLSCA
@@ -4259,11 +4918,12 @@ C           Return in case of error.
                 PT_SCALING => id%ROWSCA
               ENDIF
             ENDIF
+#endif
             LIW_PASSED = max( LIW, 1 )
             TIMEGATHER1=MPI_WTIME()
             IF ( .NOT.I_AM_SLAVE ) THEN
 C             I did not participate to computing part of the solution
-C             (id%RHSCOMP not set/allocate) : receive solution, store
+C             (id%RHSINTR not set/allocate) : receive solution, store
 C             it and scale it.
               IF (KEEP(237).EQ.0) THEN
 C               We need a workspace of minimal size KEEP(247)
@@ -4274,8 +4934,12 @@ C               in order to unpack piece
      &              JDUMMY, id%KEEP(1), id%KEEP8(1),
      &              id%PROCNODE_STEPS(1), IDUMMY, 1,
      &              id%STEP(1), BUFR(1), LBUFR, LBUFR_BYTES,
-     &              CWORK(1), LCWORK,
-     &              LSCAL, PT_SCALING(1), size(PT_SCALING),
+     &              CWORK(1), LCWORK, LSCAL,
+#if defined(USE_OLD_SCALING)
+     &              PT_SCALING(1), size(PT_SCALING),
+#else
+     &              SCALING_LOC_BWD(1), size(SCALING_LOC_BWD),
+#endif
      &              C_DUMMY, 1 , 1, IDUMMY, 1,
      &              PERM_RHS, size(PERM_RHS) ! for sparse permuted RHS
      &              )
@@ -4285,7 +4949,12 @@ C               only gather target entri
      &              id%MYID, id%COMM, NBRHS_EFF,
      &              C_DUMMY, 1, 1,
      &              id%KEEP(1), BUFR(1), LBUFR, LBUFR_BYTES,
+#if defined(USE_OLD_SCALING)
      &              LSCAL, PT_SCALING(1), size(PT_SCALING)
+#else
+     &              LSCAL, SCALING_RHSINTR_BWD(1),
+     &              size(SCALING_RHSINTR_BWD)
+#endif
 C                   --- A-1 related entries
      &             ,IRHS_PTR_COPY(1), size(IRHS_PTR_COPY),
      &              IRHS_SPARSE_COPY(1), size(IRHS_SPARSE_COPY),
@@ -4316,23 +4985,31 @@ C             compilers would do otherwi
      &          id%PROCNODE_STEPS(1), IS(1), LIW_PASSED,
      &          id%STEP(1), BUFR(1), LBUFR, LBUFR_BYTES,
      &          CWORK(1), LCWORK,
+#if defined(USE_OLD_SCALING)
      &          LSCAL, PT_SCALING(1), size(PT_SCALING),
-     &          id%RHSCOMP(IBEG_RHSCOMP), LD_RHSCOMP, NBRHS_EFF,
-     &          id%POSINRHSCOMP_COL(1), id%N,
+#else
+     &          LSCAL, SCALING_LOC_BWD(1), size(SCALING_LOC_BWD),
+#endif
+     &          id%RHSINTR(IBEG_RHSINTR), id%LD_RHSINTR, NBRHS_EFF,
+     &          id%GLOB2LOC_SOL(1), id%N,
      &          PERM_RHS, size(PERM_RHS) ! For sparse permuted RHS
      &          )
               ELSE ! only gather target entries of A-1
                 CALL DMUMPS_GATHER_SOLUTION_AM1(id%NSLAVES,id%N,
      &          id%MYID, id%COMM, NBRHS_EFF,
-     &          id%RHSCOMP(IBEG_RHSCOMP), LD_RHSCOMP, NBRHS_EFF,
+     &          id%RHSINTR(IBEG_RHSINTR), id%LD_RHSINTR, NBRHS_EFF,
      &          id%KEEP(1), BUFR(1), LBUFR, LBUFR_BYTES,
+#if defined(USE_OLD_SCALING)
      &          LSCAL, PT_SCALING(1), size(PT_SCALING)
+#else
+     &          LSCAL, SCALING_RHSINTR_BWD(1), size(SCALING_RHSINTR_BWD)
+#endif
 C               --- A-1 related entries
      &          , IRHS_PTR_COPY(1), size(IRHS_PTR_COPY),
      &          IRHS_SPARSE_COPY(1), size(IRHS_SPARSE_COPY),
      &          RHS_SPARSE_COPY(1), size(RHS_SPARSE_COPY),
      &          UNS_PERM_INV, size(UNS_PERM_INV),
-     &          id%POSINRHSCOMP_COL(1), id%N, NB_FS_RHSCOMP_TOT
+     &          id%GLOB2LOC_SOL(1), id%N, NB_FS_RHSINTR_TOT
      &          )
               ENDIF
             ENDIF
@@ -4379,32 +5056,46 @@ C                 IZ - Column index in S
               ENDIF
             ENDIF             ! end A-1 on master
 C
-C         -- END of backward was performed with centralized solution
+C}        -- END of backward was performed with centralized solution
           ELSE   ! (KEEP(221).NE.1) .AND.(ICNTL21.NE.0))
 C
 C           BEGIN of backward performed with distributed solution
 C           time local copy + scaling
             TIMECOPYSCALE1=MPI_WTIME()
-C           The non working host should not do this:
-            IF ( I_AM_SLAVE ) THEN
-              LIW_PASSED = max( LIW, 1 )
-C             Only called if more than 1 pivot
-C             was eliminated by the processor.
-C             Note that LSOL_loc >= KEEP(89)
-              IF ( KEEP(89) .GT. 0 ) THEN
-                CALL DMUMPS_DISTRIBUTED_SOLUTION(id%NSLAVES,
-     &          id%N,id%MYID_NODES,
-     &          MTYPE, id%RHSCOMP(IBEG_RHSCOMP), LD_RHSCOMP,
-     &          NBRHS_EFF, id%POSINRHSCOMP_COL(1),
-     &          id%ISOL_loc(1), id%SOL_loc(1), id%NRHS,
-     &          JBEG_RHS-NB_RHSSKIPPED, id%LSOL_loc,
-     &          id%PTLUST_S(1), id%PROCNODE_STEPS(1),
-     &          id%KEEP(1),id%KEEP8(1),
-     &          IS(1), LIW_PASSED,
-     &          id%STEP(1), scaling_data_sol, LSCAL, NB_RHSSKIPPED,
-     &          PERM_RHS, size(PERM_RHS) ) ! For permuted sparse RHS
+C             The non working host should not do this:
+              IF ( I_AM_SLAVE ) THEN
+                LIW_PASSED = max( LIW, 1 )
+C               Only called if more than 1 pivot
+C               was eliminated by the processor.
+C               Note that LSOL_loc >= KEEP(89)
+                IF ( KEEP(89) .GT. 0 ) THEN
+            IF ( LSCAL .AND. id%KEEP(89).GT.0) THEN
+#if defined(USE_OLD_SCALING)
+              SCALING_LOC_BWD => scaling_data_sol%SCALING_LOC
+#else
+              IF (MTYPE.EQ.1) THEN
+                SCALING_LOC_BWD => id%COLSCA_loc
+              ELSE
+                SCALING_LOC_BWD => id%ROWSCA_loc
               ENDIF
+#endif
+            ELSE
+              SCALING_LOC_BWD => RDUMMY_TARGET
             ENDIF
+                  CALL DMUMPS_DISTRIBUTED_SOLUTION(id%NSLAVES,
+     &            id%N,id%MYID_NODES,
+     &            MTYPE, id%RHSINTR(IBEG_RHSINTR), id%LD_RHSINTR,
+     &            NBRHS_EFF, id%GLOB2LOC_SOL(1),
+     &            id%ISOL_loc(1), id%SOL_loc(1), id%NRHS,
+     &            JBEG_RHS-NB_RHSSKIPPED, id%LSOL_loc,
+     &            id%PTLUST_S(1), id%PROCNODE_STEPS(1),
+     &            id%KEEP(1),id%KEEP8(1),
+     &            IS(1), LIW_PASSED, id%STEP(1),
+     &            SCALING_LOC_BWD(1), size(SCALING_LOC_BWD),
+     &            LSCAL, NB_RHSSKIPPED,
+     &            PERM_RHS, size(PERM_RHS) ) ! For permuted sparse RHS
+                ENDIF
+              ENDIF
             TIMECOPYSCALE2=MPI_WTIME()-TIMECOPYSCALE1+TIMECOPYSCALE2
           ENDIF
 C         === BACKWARD was PERFORMED WITH DISTRIBUTED SOLUTION ===
@@ -4425,7 +5116,7 @@ C         Multiple RHS: apply a fixed nu
 C         of iterative refinement steps
 C         ----------------------------------
 C         DO I = 1, ICNTL10
-            write(6,*) ' Internal ERROR 15 in sol_driver '
+            write(6,*) ' Internal error 15 in sol_driver '
 C           Compute residual:  Y <- SAVERHS - A * RHS
 C           Solve RHS <- A^-1 Y, Y modified
 C           Assemble in RHS(REDUCE)
@@ -4433,7 +5124,7 @@ C           RHS <- RHS + Y
 C         END DO
         END IF
         IF (POSTPros) THEN
-C
+C{
 C         SAVERHS holds the original right hand side
 C         Sparse rhs are saved in SAVERHS as dense rhs
 C
@@ -5097,7 +5788,7 @@ C             We have used D only for LC
           DEALLOCATE(C_Y)
           DEALLOCATE(R_LOCWK54)
           DEALLOCATE(C_LOCWK54)
-C End POSTPros
+C} End POSTPros
         END IF
 C============================================
 C
@@ -5164,9 +5855,9 @@ C  ========================
 *         print out the solution
           IF ( INFO(1) .GE. 0 .AND. ICNTL(4).GE.3 .AND. ICNTL(3).GT.0)
      &    THEN
-            K = min0(10, id%N)
+            K = min(10, id%N)
             IF (ICNTL(4) .eq. 4 ) K = id%N
-            J = min0(10,NBRHS_EFF)
+            J = min(10,NBRHS_EFF)
             IF (ICNTL(4) .eq. 4 ) J = NBRHS_EFF
             DO II=1, J
               WRITE(ICNTL(3),110) BEG_RHS+II-1
@@ -5190,9 +5881,6 @@ C     }
       ENDDO
 C     END DO WHILE (BEG_RHS.LE.id%NRHS)
 C     =================================
-      IF (KEEP(400) .GT. 0) THEN
-        CALL DMUMPS_SOL_L0OMP_LD(KEEP(400))
-      ENDIF
 C
 C     ========================================================
 C     Reset RHS to zero for all remaining columns that
@@ -5226,14 +5914,14 @@ C     ==================================
       ENDIF
 C     ========================================================
 C     Reset id%SOL_loc to zero for all remaining columns that
-C     have not been processed because they were emtpy
+C     have not been processed because they were empty
 C     ========================================================
       IF ( I_AM_SLAVE .AND. (ICNTL21.NE.0) .AND.
      &      ( JEND_RHS .LT. id%NRHS ) .AND. KEEP(221).NE.1 ) THEN
         JBEG_NEW = JEND_RHS + 1
         IF (DO_PERMUTE_RHS.OR.INTERLEAVE_PAR) THEN
            DO WHILE ( JBEG_NEW.LE. id%NRHS)
-              DO I=1, KEEP(89)
+              DO I=1, NSOL_loc
                  id%SOL_loc(int(PERM_RHS(JBEG_NEW) -1,8)*
      &                      int(id%LSOL_loc,8)+int(I,8)) = ZERO
               ENDDO
@@ -5242,7 +5930,7 @@ C     ==================================
         ELSE
 C
            DO WHILE ( JBEG_NEW.LE. id%NRHS)
-            DO I=1, KEEP(89)
+            DO I=1, NSOL_loc
                 id%SOL_loc((JBEG_NEW -1)*id%LSOL_loc + I) = ZERO
             ENDDO
             JBEG_NEW = JBEG_NEW +1
@@ -5251,7 +5939,7 @@ C
       ENDIF
 C
 C     ================================================================
-C     Reset id%RHSCOMP and id%REDRHS to zero for all remaining columns
+C     Reset id%RHSINTR and id%REDRHS to zero for all remaining columns
 C     that have not been processed because they were emtpy
 C     ================================================================
       IF ((KEEP(221).EQ.1) .AND.
@@ -5269,8 +5957,8 @@ C     ==================================
        IF (I_AM_SLAVE) THEN
            JBEG_NEW = JEND_RHS + 1
            DO WHILE ( JBEG_NEW.LE. id%NRHS)
-            DO I=1,NBENT_RHSCOMP
-              id%RHSCOMP(int(JBEG_NEW -1,8)*int(LD_RHSCOMP,8) +
+            DO I=1,NBENT_RHSINTR
+              id%RHSINTR(int(JBEG_NEW -1,8)*int(id%LD_RHSINTR,8) +
      &                   int(I,8)) =  ZERO
             ENDDO
             JBEG_NEW = JBEG_NEW +1
@@ -5362,9 +6050,43 @@ C
         WRITE( MP, 431 ) id%DKEEP(122)
       END IF
  90   CONTINUE
+      IF (KEEP(400) .GT. 0) THEN
+        CALL DMUMPS_SOL_L0OMP_LD(KEEP(400))
+      ENDIF
       IF (INFO(1) .LT.0 ) THEN
          IF (INFO(1) .EQ. -80) INFO(1) = -81
       ENDIF
+C     -- related to exploit sparsity
+       IF (associated(nodes_FWD)) THEN 
+        NB_BYTES = NB_BYTES - size(nodes_FWD) * K34_8
+        DEALLOCATE(nodes_FWD)
+        NULLIFY(nodes_FWD)
+       ENDIF
+       IF (associated(nodes_BWD)) THEN 
+        NB_BYTES = NB_BYTES - size(nodes_BWD) * K34_8
+        DEALLOCATE(nodes_BWD)
+        NULLIFY(nodes_BWD)
+       ENDIF
+       IF (allocated(Pruned_Sons_FWD)) THEN 
+        NB_BYTES = NB_BYTES - size(Pruned_Sons_FWD) * K34_8
+        DEALLOCATE(Pruned_Sons_FWD)
+       ENDIF
+       IF (allocated(Pruned_Sons_BWD)) THEN 
+        NB_BYTES = NB_BYTES - size(Pruned_Sons_BWD) * K34_8
+        DEALLOCATE(Pruned_Sons_BWD)
+       ENDIF
+      IF (SCALING_RHSINTR_FWD_ALLOCATED) THEN
+        NB_BYTES = NB_BYTES - LSCALING_RHSINTR_FWD * K16_8
+        DEALLOCATE(SCALING_RHSINTR_FWD)
+      ENDIF
+      SCALING_RHSINTR_FWD_ALLOCATED = .FALSE.
+      NULLIFY(SCALING_RHSINTR_FWD)
+      IF (SCALING_RHSINTR_BWD_ALLOCATED) THEN
+        NB_BYTES = NB_BYTES - LSCALING_RHSINTR_BWD * K16_8
+        DEALLOCATE(SCALING_RHSINTR_BWD)
+      ENDIF
+      SCALING_RHSINTR_BWD_ALLOCATED = .FALSE.
+      NULLIFY(SCALING_RHSINTR_BWD)
       IF (KEEP(485) .EQ. 1) THEN
         KEEP(350) = KEEP350_SAVE
         IF (IS_LR_MOD_TO_STRUC_DONE) THEN
@@ -5421,12 +6143,16 @@ C       Free space and reset pointers if
          NULLIFY(IRHS_loc_PTR)
          IRHS_loc_PTR_ALLOCATED = .FALSE.
        ENDIF
+#if defined(USE_OLD_SCALING)
        IF (I_AM_SLAVE.AND.LSCAL.AND.KEEP(248).EQ.-1) THEN
-         NB_BYTES = NB_BYTES -
-     &   int(size(scaling_data_dr%SCALING_LOC),8)*K16_8
-         DEALLOCATE(scaling_data_dr%SCALING_LOC)
-         NULLIFY   (scaling_data_dr%SCALING_LOC)
+         IF (associated(scaling_data_dr%SCALING_LOC)) THEN
+           NB_BYTES = NB_BYTES -
+     &     int(size(scaling_data_dr%SCALING_LOC),8)*K16_8
+           DEALLOCATE(scaling_data_dr%SCALING_LOC)
+           NULLIFY   (scaling_data_dr%SCALING_LOC)
+         ENDIF
        ENDIF
+#endif
       IF (allocated(PERM_RHS)) THEN
         NB_BYTES = NB_BYTES - int(size(PERM_RHS),8)*K34_8
         DEALLOCATE(PERM_RHS)
@@ -5498,13 +6224,19 @@ C       Deallocate temporary workspace S
           NB_BYTES = NB_BYTES - int(size(SRW3),8)*K35_8
           DEALLOCATE(SRW3)
         ENDIF
-        IF (LSCAL .AND. ICNTL21==1) THEN
-C         Free local scaling arrays
-          NB_BYTES = NB_BYTES -
-     &              int(size(scaling_data_sol%SCALING_LOC),8)*K16_8
-          DEALLOCATE(scaling_data_sol%SCALING_LOC)
-          NULLIFY(scaling_data_sol%SCALING_LOC)
+#if defined(USE_OLD_SCALING)
+C       Free local scaling arrays
+        IF (LSCAL .AND. ICNTL21 .NE. 0) THEN
+          IF (associated(scaling_data_sol%SCALING_LOC)) THEN
+            NB_BYTES = NB_BYTES -
+     &                 int(size(scaling_data_sol%SCALING_LOC),8)*K16_8
+            DEALLOCATE(scaling_data_sol%SCALING_LOC)
+            NULLIFY(scaling_data_sol%SCALING_LOC)
+          ENDIF
         ENDIF
+#endif
+#if defined(USE_OLD_SCALING)
+#endif
 C       Free memory until next call to DMUMPS
         IF (WK_USER_PROVIDED) THEN
 C         S points to WK_USER provided by user
@@ -5528,28 +6260,30 @@ C         at the beginning of the solve,
           NB_BYTES  = NB_BYTES - KEEP8(23) * K35_8
           KEEP8(23) = 0_8
         ENDIF
-        IF (KEEP(221).NE.1) THEN
+        IF (KEEP(221).NE.1
+     &     ) THEN
 C       -- After reduction of RHS to Schur variables
 C       -- keep compressed RHS generated during FWD step
 C       -- to be used for future expansion
-         IF (associated(id%RHSCOMP)) THEN
+         IF (associated(id%RHSINTR)) THEN
             NB_BYTES = NB_BYTES - id%KEEP8(25)*K35_8
-            DEALLOCATE(id%RHSCOMP)
-            NULLIFY(id%RHSCOMP)
-            id%KEEP8(25)=0_8
+            DEALLOCATE(id%RHSINTR)
+            NULLIFY(id%RHSINTR)
+            id%KEEP8(25)  = 0_8
+            id%LD_RHSINTR = 0
          ENDIF
-         IF (associated(id%POSINRHSCOMP_ROW)) THEN
+         IF (associated(id%GLOB2LOC_RHS)) THEN
             NB_BYTES = NB_BYTES -
-     &                 int(size(id%POSINRHSCOMP_ROW),8)*K34_8
-            DEALLOCATE(id%POSINRHSCOMP_ROW)
-            NULLIFY(id%POSINRHSCOMP_ROW)
+     &                 int(size(id%GLOB2LOC_RHS),8)*K34_8
+            DEALLOCATE(id%GLOB2LOC_RHS)
+            NULLIFY(id%GLOB2LOC_RHS)
          ENDIF
-         IF (id%POSINRHSCOMP_COL_ALLOC) THEN
+         IF (id%GLOB2LOC_SOL_ALLOC) THEN
             NB_BYTES = NB_BYTES -
-     &                 int(size(id%POSINRHSCOMP_COL),8)*K34_8
-            DEALLOCATE(id%POSINRHSCOMP_COL)
-            NULLIFY(id%POSINRHSCOMP_COL)
-            id%POSINRHSCOMP_COL_ALLOC = .FALSE.
+     &                 int(size(id%GLOB2LOC_SOL),8)*K34_8
+            DEALLOCATE(id%GLOB2LOC_SOL)
+            NULLIFY(id%GLOB2LOC_SOL)
+            id%GLOB2LOC_SOL_ALLOC = .FALSE.
          ENDIF
         ENDIF
         IF ( WORK_WCB_ALLOCATED ) THEN
@@ -5560,6 +6294,23 @@ C       Otherwise, WORK_WCB may point to
 C       position inside id%S, nullify it
         NULLIFY( WORK_WCB )
       ENDIF
+#if defined(STAT_ES_SOLVE)
+      IF (
+     & (id%MYID.EQ.MASTER).AND.
+     & ( (id%KEEP(235).NE.0).OR.(id%KEEP(212).NE.0) )
+     &   )
+     & THEN
+C       If exploit sparsity then
+C       stats saved in DKEEP(200:204) and
+C       set RINFOG(24), RINFOG(25), RINFOG(26)
+        CALL DMUMPS_SOL_ES_PRINT_STATS( 
+     &      id%KEEP(212), id%KEEP(235), id%KEEP(237),
+     &      id%KEEP(485), id%KEEP(497), 
+     &      id%KEEP8(110),id%NRHS, id%ICNTL(27), id%N, 
+     &      id%KEEP(50), id%DKEEP(200:204),
+     &      id%RINFOG(24:28), MPG)
+      END IF
+#endif
  500  CONTINUE
       RETURN
  55   FORMAT (//' ERROR ANALYSIS BEFORE ITERATIVE REFINEMENT')
@@ -5572,7 +6323,7 @@ C       position inside id%S, nullify it
  437  FORMAT('  .. Time in ScaLAPACK root       =   ',F15.6)
  436  FORMAT('  .. Time in backward (bwd) step  =   ',F15.6)
  433  FORMAT(' Time to gather solution(cent.sol)=',F15.6)
- 431  FORMAT(' Time to copy/scale dist. solution=',F15.6)
+ 431  FORMAT(' Time for distributed solution    =',F15.6)
  150  FORMAT(' GLOBAL STATISTICS PRIOR SOLVE PHASE ...........'/
      &        ' Number of right-hand-sides                    =',I12/
      &        ' Blocking factor for multiple rhs              =',I12/
@@ -5582,7 +6333,8 @@ C       position inside id%S, nullify it
      &        '  --- (20)                                     =',I12/
      &        '  --- (21)                                     =',I12/
      &        '  --- (30)                                     =',I12/
-     &        '  --- (35)                                     =',I12
+     &        '  --- (35)                                     =',I12/
+     &        '  --- (48) (effective)                         =',I12
      &        )
  151  FORMAT ('  --- (25)                                     =',I12)
  152  FORMAT ('  --- (26)                                     =',I12)
@@ -5601,6 +6353,7 @@ C       position inside id%S, nullify it
      &       NRHS,
      &       idIRHS_loc,
      &       idRHS_loc,
+     &       I_AM_SLAVE,
      &       INFO)
 C
 C  Purpose:
@@ -5619,6 +6372,7 @@ C
         INTEGER, INTENT( IN ) :: idNloc_RHS
         INTEGER, INTENT( IN ) :: idLRHS_loc
         INTEGER, INTENT( IN ) :: NRHS
+        LOGICAL, INTENT( IN ) :: I_AM_SLAVE
 #if defined(MUMPS_NOF2003)
         INTEGER, POINTER :: idIRHS_loc (:)
         DOUBLE PRECISION, POINTER :: idRHS_loc  (:)
@@ -5638,6 +6392,14 @@ C  =====================
 C
 C       Quick return if nothing on this proc
         IF (idNloc_RHS .LE. 0) RETURN
+        IF (idNloc_RHS .GT. 0 .AND. .NOT. I_AM_SLAVE) THEN
+C         Nloc_RHS should not be greater than 0
+C         on a non working host because the distribution
+C         of the RHS does not include the non working host.
+          INFO(1)=-55
+          INFO(2)=-idLRHS_loc
+          RETURN
+        ENDIF
 C       Check for leading dimension
         IF (NRHS.NE.1) THEN
           IF ( idLRHS_loc .LT. idNloc_RHS) THEN
@@ -5716,6 +6478,7 @@ C         We force SOLVET to have value
 C         to be able to test both values, and also, be able to
 C         test whether SOLVET = MTYPE or not.
           IF ( SOLVET.EQ.2 ) SOLVET = 0
+#if defined(USE_OLD_SCALING)
           IF ( LSCAL ) THEN
             IF ( SOLVET .EQ. 1 ) THEN
 C             Apply rowscaling
@@ -5729,19 +6492,31 @@ C             Apply column scaling
               END DO
             END IF
           END IF
+#endif
         END IF ! MYID.EQ.MASTER
 C       ------------------------------
 C       Broadcast SOLVET to the slaves
 C       ------------------------------
         CALL MPI_BCAST( SOLVET, 1, MPI_INTEGER, MASTER,
      &                  id%COMM, IERR)
+#if ! defined(USE_OLD_SCALING)
+        IF (LSCAL .AND. id%KEEP(89) .GT. 0) THEN
+          IF (SOLVET .EQ. 1) THEN
+            SCALING_LOC_FWD => id%ROWSCA_LOC
+          ELSE
+            SCALING_LOC_FWD => id%COLSCA_LOC
+          ENDIF
+        ELSE
+            SCALING_LOC_FWD => RDUMMY_TARGET
+        ENDIF
+#endif
 C       --------------------------------------------
 C       Scatter the right hand side C_Y on all procs
 C       --------------------------------------------
         IF ( .NOT.I_AM_SLAVE ) THEN
 C         -- Master not working
           CALL DMUMPS_SCATTER_RHS(id%NSLAVES,id%N, id%MYID,
-     &      id%COMM,
+     &      id%COMM, LSCAL, SCALING_LOC_FWD(1),
      &      SOLVET, C_Y(1), id%N, 1,
      &      1,
      &      C_DUMMY, 1, 1,
@@ -5752,21 +6527,21 @@ C         -- Master not working
      &      id%ICNTL(1),id%INFO(1))
         ELSE
           IF (SOLVET.EQ.MTYPE) THEN
-C           POSINRHSCOMP_ROW is with respect to the
+C           GLOB2LOC_RHS is with respect to the
 C           original linear system (transposed or not)
-            PTR_POSINRHSCOMP_FWD => id%POSINRHSCOMP_ROW
+            PTR_POSINRHSINTR_FWD => id%GLOB2LOC_RHS
           ELSE
 C           Transposed, use column indices of original
 C           system (ie, col indices of A or A^T)
-            PTR_POSINRHSCOMP_FWD => id%POSINRHSCOMP_COL
+            PTR_POSINRHSINTR_FWD => id%GLOB2LOC_SOL
           ENDIF
           LIW_PASSED = max( LIW, 1 )
           CALL DMUMPS_SCATTER_RHS(id%NSLAVES,id%N, id%MYID,
-     &      id%COMM,
+     &      id%COMM, LSCAL, SCALING_LOC_FWD(1),
      &      SOLVET,  C_Y(1), id%N, 1,
      &      1,
-     &      id%RHSCOMP(IBEG_RHSCOMP), LD_RHSCOMP, 1,
-     &      PTR_POSINRHSCOMP_FWD(1), NB_FS_RHSCOMP_F,
+     &      id%RHSINTR(IBEG_RHSINTR), id%LD_RHSINTR, 1,
+     &      PTR_POSINRHSINTR_FWD(1), NB_FS_RHSINTR_F,
 C
      &      id%PTLUST_S(1), id%KEEP(1), id%KEEP8(1),
      &      id%PROCNODE_STEPS(1),
@@ -5782,11 +6557,11 @@ C
           LIW_PASSED = max( LIW, 1 )
           LA_PASSED = max( LA, 1_8 )
           IF (SOLVET.EQ.MTYPE) THEN
-            PTR_POSINRHSCOMP_FWD => id%POSINRHSCOMP_ROW
-            PTR_POSINRHSCOMP_BWD => id%POSINRHSCOMP_COL
+            PTR_POSINRHSINTR_FWD => id%GLOB2LOC_RHS
+            PTR_POSINRHSINTR_BWD => id%GLOB2LOC_SOL
           ELSE
-            PTR_POSINRHSCOMP_FWD => id%POSINRHSCOMP_COL
-            PTR_POSINRHSCOMP_BWD => id%POSINRHSCOMP_ROW
+            PTR_POSINRHSINTR_FWD => id%GLOB2LOC_SOL
+            PTR_POSINRHSINTR_BWD => id%GLOB2LOC_RHS
           ENDIF
           FROM_PP=.TRUE.
           NBSPARSE_LOC = .FALSE.
@@ -5800,10 +6575,15 @@ C
      & LBUFR_BYTES, id%ISTEP_TO_INIV2(1), id%TAB_POS_IN_PERE(1,1),
 C      Next 3 arguments are not used in this call
      & IBEG_ROOT_DEF,IEND_ROOT_DEF,IROOT_DEF_RHS_COL1, PTR_RHS_ROOT(1),
-     & LPTR_RHS_ROOT, SIZE_ROOT, MASTER_ROOT, id%RHSCOMP(IBEG_RHSCOMP),
-     & LD_RHSCOMP,PTR_POSINRHSCOMP_FWD(1),PTR_POSINRHSCOMP_BWD(1),
+     & LPTR_RHS_ROOT, SIZE_ROOT, MASTER_ROOT, id%RHSINTR(IBEG_RHSINTR),
+     & id%LD_RHSINTR,PTR_POSINRHSINTR_FWD(1),PTR_POSINRHSINTR_BWD(1),
+     & -1, -1,
+     & IDUMMY(1), IDUMMY(1),
      & 1,1,1,1, IDUMMY, 1, JDUMMY, KDUMMY, 1, LDUMMY, 1, MDUMMY, 1,1,
      & NBSPARSE_LOC, PTR_RHS_BOUNDS(1), LPTR_RHS_BOUNDS
+#if defined(STAT_ES_SOLVE)
+     & , IDUMMY, 1, JDUMMY, 1
+#endif
      & , id%IPOOL_B_L0_OMP(1), id%LPOOL_B_L0_OMP, id%IPOOL_A_L0_OMP(1),
      & id%LPOOL_A_L0_OMP, id%L_VIRT_L0_OMP, id%VIRT_L0_OMP(1),
      & id%L_PHYS_L0_OMP, id%PHYS_L0_OMP(1), id%PERM_L0_OMP(1),
@@ -5847,6 +6627,7 @@ C       then necessarily NBRHS_EFF = 1)
 C
 C       === GATHER and SCALE solution ==============
 C
+#if defined(USE_OLD_SCALING)
         IF ((id%MYID.NE.MASTER).OR. .NOT.LSCAL) THEN
           PT_SCALING => Dummy_SCAL
         ELSE
@@ -5856,12 +6637,23 @@ C
             PT_SCALING => id%ROWSCA
           ENDIF
         ENDIF
+#else
+        IF (id%KEEP(89) .EQ. 0 .OR. .NOT. LSCAL) THEN
+          SCALING_LOC_BWD => RDUMMY_TARGET
+        ELSE
+          IF (SOLVET.EQ.1) THEN
+            SCALING_LOC_BWD => id%COLSCA_loc
+          ELSE
+            SCALING_LOC_BWD => id%ROWSCA_loc
+          ENDIF
+        ENDIF
+#endif
         LIW_PASSED = max( LIW, 1 )
 C       Solution computed during DMUMPS_SOL_C has been stored
-C       in id%RHSCOMP and is gathered on the master in C_Y
+C       in id%RHSINTR and is gathered on the master in C_Y
         IF ( .NOT. I_AM_SLAVE ) THEN
 C         I did not participate to computing part of the solution
-C         (id%RHSCOMP not set/allocate) : receive solution, store
+C         (id%RHSINTR not set/allocate) : receive solution, store
 C         it and scale it.
           CALL DMUMPS_GATHER_SOLUTION(id%NSLAVES,id%N,
      &      id%MYID, id%COMM, NBRHS_EFF,
@@ -5870,8 +6662,12 @@ C         it and scale it.
      &      IDUMMY, 1,
      &      id%STEP(1), BUFR(1), LBUFR, LBUFR_BYTES,
      &      CWORK(1), size(CWORK),
+#if defined(USE_OLD_SCALING)
      &      LSCAL, PT_SCALING(1), size(PT_SCALING),
-!     RHSCOMP not on non-working master
+#else
+     &      LSCAL, SCALING_LOC_BWD(1), size(SCALING_LOC_BWD),
+#endif
+!     RHSINTR not on non-working master
      &      C_DUMMY, 1 , 1, IDUMMY, 1,
 !     for sparse permuted RHS on host
      &      PERM_RHS, size(PERM_RHS)
@@ -5885,9 +6681,13 @@ C         it and scale it.
      &      IS(1), LIW_PASSED,
      &      id%STEP(1), BUFR(1), LBUFR, LBUFR_BYTES,
      &      CWORK(1), size(CWORK),
+#if defined(USE_OLD_SCALING)
      &      LSCAL, PT_SCALING(1), size(PT_SCALING),
-     &      id%RHSCOMP(IBEG_RHSCOMP), LD_RHSCOMP, NBRHS_EFF,
-     &      PTR_POSINRHSCOMP_BWD(1), id%N,
+#else
+     &      LSCAL, SCALING_LOC_BWD(1), size(SCALING_LOC_BWD),
+#endif
+     &      id%RHSINTR(IBEG_RHSINTR), id%LD_RHSINTR, NBRHS_EFF,
+     &      PTR_POSINRHSINTR_BWD(1), id%N,
      &      PERM_RHS, size(PERM_RHS)) ! for sparse permuted RHS on host
         ENDIF
         DEALLOCATE( CWORK )
diff -pruN 5.6.2-2.1/src/dsol_fwd.F 5.7.1-1/src/dsol_fwd.F
--- 5.6.2-2.1/src/dsol_fwd.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/dsol_fwd.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -14,7 +14,7 @@ C
       SUBROUTINE DMUMPS_SOL_R(N, A, LA, IW, LIW, WCB, LWCB,
      &    NRHS,
      &    PTRICB, IWCB, LIWCB, 
-     &    RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD, 
+     &    RHSINTR, LRHSINTR, POSINRHSINTR_FWD, 
      &    STEP,
      &    FRERE, DAD, FILS,
      &    NSTK, IPOOL, LPOOL, PTRIST, PTRFAC, MYLEAF, MYROOT,
@@ -59,8 +59,8 @@ C
       INTEGER IW( LIW ), IWCB( LIWCB )
       INTEGER ISTEP_TO_INIV2(KEEP(71)), 
      &        TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
-      INTEGER, intent(in) ::  POSINRHSCOMP_FWD(N), LRHSCOMP 
-      DOUBLE PRECISION, intent(inout) :: RHSCOMP(LRHSCOMP,NRHS)
+      INTEGER, intent(in) ::  POSINRHSINTR_FWD(N), LRHSINTR 
+      DOUBLE PRECISION, intent(inout) :: RHSINTR(LRHSINTR,NRHS)
       LOGICAL, intent(in) :: FROM_PP
       INTEGER, INTENT( in ) :: LL0_OMP_MAPPING, LL0_OMP_FACTORS
       INTEGER, INTENT( in ) :: L0_OMP_MAPPING( LL0_OMP_MAPPING )
@@ -108,21 +108,25 @@ C
      &          KEEP(208) )
         GOTO 60
       ENDIF
-      BLOQ = ( ( III .EQ. LEAF )
+      IF (SLAVEF .EQ. 1) THEN
+        FLAG = .FALSE.
+      ELSE
+        BLOQ = ( ( III .EQ. LEAF )
      &     )
-      CALL DMUMPS_SOLVE_RECV_AND_TREAT( BLOQ, FLAG,
-     &     BUFR, LBUFR, LBUFR_BYTES,
-     &     MYID, SLAVEF, COMM,
-     &     N, NRHS, IPOOL, LPOOL, LEAF,
-     &     NBFIN, NSTK, IW, LIW, A, LA, PTRIST, PTRFAC,
-     &     IWCB, LIWCB,
-     &     WCB, LWCB, POSWCB,
-     &     PLEFTWCB, POSIWCB,
-     &     PTRICB, INFO, KEEP,KEEP8, DKEEP, STEP,
-     &     PROCNODE_STEPS,
-     &     RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD
-     &     , FROM_PP
-     &    )
+        CALL DMUMPS_SOLVE_RECV_AND_TREAT( BLOQ, FLAG,
+     &       BUFR, LBUFR, LBUFR_BYTES,
+     &       MYID, SLAVEF, COMM,
+     &       N, NRHS, IPOOL, LPOOL, LEAF,
+     &       NBFIN, NSTK, IW, LIW, A, LA, PTRIST, PTRFAC,
+     &       IWCB, LIWCB,
+     &       WCB, LWCB, POSWCB,
+     &       PLEFTWCB, POSIWCB,
+     &       PTRICB, INFO, KEEP,KEEP8, DKEEP, STEP,
+     &       PROCNODE_STEPS,
+     &       RHSINTR, LRHSINTR, POSINRHSINTR_FWD
+     &       , FROM_PP
+     &      )
+      ENDIF
       IF ( INFO( 1 ) .LT. 0 .OR. NBFIN .EQ. 0 ) GOTO 260
       IF (.not. FLAG) THEN
          IF (III .NE. LEAF) THEN
@@ -158,7 +162,7 @@ C
      &        PTRICB, PTRIST, PTRFAC, PROCNODE_STEPS,
      &        FILS, STEP, FRERE, DAD,
      &        INFO, KEEP,KEEP8, DKEEP, RHS_ROOT, LRHS_ROOT, MTYPE,
-     &        RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD,
+     &        RHSINTR, LRHSINTR, POSINRHSINTR_FWD,
      &        ISTEP_TO_INIV2, TAB_POS_IN_PERE
      &        , RHS_BOUNDS, LRHS_BOUNDS, DO_NBSPARSE 
      &        , FROM_PP
diff -pruN 5.6.2-2.1/src/dsol_fwd_aux.F 5.7.1-1/src/dsol_fwd_aux.F
--- 5.6.2-2.1/src/dsol_fwd_aux.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/dsol_fwd_aux.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -21,7 +21,7 @@ C
      &     PLEFTWCB, POSIWCB,
      &     PTRICB,
      &     INFO, KEEP, KEEP8, DKEEP, STEP, PROCNODE_STEPS, 
-     &     RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD
+     &     RHSINTR, LRHSINTR, POSINRHSINTR_FWD
      &     , FROM_PP
      &    )
       USE DMUMPS_OOC 
@@ -32,7 +32,7 @@ C
       INTEGER MSGTAG, MSGSOU, MYID, SLAVEF, COMM
       INTEGER LIW
       INTEGER(8), INTENT(IN) :: LA, LWCB
-      INTEGER N, NRHS, LPOOL, LEAF, NBFIN, LRHSCOMP
+      INTEGER N, NRHS, LPOOL, LEAF, NBFIN, LRHSINTR
       INTEGER LIWCB, POSIWCB
       INTEGER(8) :: POSWCB, PLEFTWCB
       INTEGER INFO( 80 ), KEEP( 500)
@@ -47,8 +47,8 @@ C
       INTEGER STEP(N)
       INTEGER PROCNODE_STEPS(KEEP(28))
       DOUBLE PRECISION WCB( LWCB ), A( LA )
-      DOUBLE PRECISION RHSCOMP( LRHSCOMP, NRHS )
-      INTEGER, intent(in) :: POSINRHSCOMP_FWD(N)
+      DOUBLE PRECISION RHSINTR( LRHSINTR, NRHS )
+      INTEGER, intent(in) :: POSINRHSINTR_FWD(N)
       LOGICAL, intent(in) :: FROM_PP
       INCLUDE 'mpif.h'
       INCLUDE 'mumps_tags.h'
@@ -57,7 +57,7 @@ C
       INTEGER :: IWHDLR, LDA_SLAVE
       INTEGER :: MTYPE_SLAVE 
       INTEGER FINODE, FPERE, LONG, NCB, POSITION, NCV, NPIV
-      INTEGER PDEST, I, IPOSINRHSCOMP
+      INTEGER PDEST, I, IPOSINRHSINTR
       INTEGER J1
       INTEGER(8) :: APOS
       LOGICAL DUMMY
@@ -119,9 +119,9 @@ C
 !NEC$ IVDEP
 #endif
                  DO I = 1, LONG
-                   IPOSINRHSCOMP= abs(POSINRHSCOMP_FWD(IWCB(I)))
-                   RHSCOMP(IPOSINRHSCOMP,JBDEB+K-1) = 
-     &             RHSCOMP(IPOSINRHSCOMP,JBDEB+K-1) + 
+                   IPOSINRHSINTR= abs(POSINRHSINTR_FWD(IWCB(I)))
+                   RHSINTR(IPOSINRHSINTR,JBDEB+K-1) = 
+     &             RHSINTR(IPOSINRHSINTR,JBDEB+K-1) + 
      &                 WCB(PLEFTWCB+I-1)
                  ENDDO
               END DO
@@ -246,7 +246,7 @@ C
 !$           OMP_FLAG = ( JBFIN-JBDEB+1.GE.KEEP(362) .AND.
 !$   &                     (NCV*(JBFIN-JBDEB+1) .GE. KEEP(363) ) )
              IF (OMP_FLAG) THEN
-!$OMP PARALLEL DO PRIVATE(I,JJ,IFR8,IPOSINRHSCOMP)
+!$OMP PARALLEL DO PRIVATE(I,JJ,IFR8,IPOSINRHSINTR)
                DO K=1, NRHS_B
                   IFR8 = PTRY+int(K-1,8)*int(NCV,8)
 #if defined(__ve__)
@@ -254,9 +254,9 @@ C
 #endif
                   DO I = 1,NCV
                     JJ = IW(J1+I)
-                    IPOSINRHSCOMP= abs(POSINRHSCOMP_FWD(JJ))
-                    RHSCOMP(IPOSINRHSCOMP,JBDEB+K-1)= 
-     &                RHSCOMP(IPOSINRHSCOMP,JBDEB+K-1)
+                    IPOSINRHSINTR= abs(POSINRHSINTR_FWD(JJ))
+                    RHSINTR(IPOSINRHSINTR,JBDEB+K-1)= 
+     &                RHSINTR(IPOSINRHSINTR,JBDEB+K-1)
      &                + WCB(IFR8+int(I-1,8))
                   ENDDO
                ENDDO
@@ -269,9 +269,9 @@ C
 #endif
                   DO I = 1,NCV
                     JJ = IW(J1+I)
-                    IPOSINRHSCOMP= abs(POSINRHSCOMP_FWD(JJ))
-                    RHSCOMP(IPOSINRHSCOMP,JBDEB+K-1)= 
-     &                RHSCOMP(IPOSINRHSCOMP,JBDEB+K-1)
+                    IPOSINRHSINTR= abs(POSINRHSINTR_FWD(JJ))
+                    RHSINTR(IPOSINRHSINTR,JBDEB+K-1)= 
+     &                RHSINTR(IPOSINRHSINTR,JBDEB+K-1)
      &                + WCB(IFR8+int(I-1,8))
                   ENDDO
                ENDDO
@@ -297,7 +297,7 @@ C
      &            IW(PTRIST(STEP( FINODE )) + 2 + KEEP(IXSZ) ), NCV,NCV,
      &            IW(PTRIST(STEP(FINODE))+4+ KEEP(IXSZ) ),
      &            WCB( PTRY ), JBDEB, JBFIN,
-     &            RHSCOMP, 1, 1, -9999, -9999,
+     &            RHSINTR, 1, 1, -9999, -9999,
      &            KEEP, PDEST, ContVec, COMM, IERR )
             IF ( IERR .EQ. -1 ) THEN
               CALL DMUMPS_SOLVE_RECV_AND_TREAT( .FALSE., FLAG,
@@ -309,7 +309,7 @@ C
      &              WCB, LWCB, POSWCB, PLEFTWCB, POSIWCB,
      &              PTRICB, INFO, KEEP,KEEP8, DKEEP, STEP,
      &              PROCNODE_STEPS, 
-     &              RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD
+     &              RHSINTR, LRHSINTR, POSINRHSINTR_FWD
      &              , FROM_PP
      &              )
               IF ( INFO( 1 )  .LT. 0 )  GOTO 270
@@ -356,7 +356,7 @@ C
      &     PTRICB, PTRIST, PTRFAC, PROCNODE_STEPS,
      &     FILS, STEP, FRERE, DAD,
      &     INFO, KEEP,KEEP8, DKEEP, RHS_ROOT, LRHS_ROOT, MTYPE,
-     &     RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD,
+     &     RHSINTR, LRHSINTR, POSINRHSINTR_FWD,
      &     
      &     ISTEP_TO_INIV2, TAB_POS_IN_PERE
      &    , RHS_BOUNDS, LRHS_BOUNDS, DO_NBSPARSE, FROM_PP
@@ -393,8 +393,8 @@ C
       INTEGER FILS( N ), STEP( N ), FRERE(KEEP(28)), DAD(KEEP(28))
       INTEGER ISTEP_TO_INIV2(KEEP(71)), 
      &     TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
-      INTEGER POSINRHSCOMP_FWD(N), LRHSCOMP
-      DOUBLE PRECISION RHSCOMP(LRHSCOMP, NRHS)
+      INTEGER POSINRHSINTR_FWD(N), LRHSINTR
+      DOUBLE PRECISION RHSINTR(LRHSINTR, NRHS)
       LOGICAL, intent(in) :: DO_NBSPARSE
       INTEGER, intent(in) :: LRHS_BOUNDS
       INTEGER, intent(in) :: RHS_BOUNDS(LRHS_BOUNDS)
@@ -411,10 +411,10 @@ C
       INTEGER I, J, K, IPOS, NSLAVES, J1, J2, J3, FPERE, FPERE_MAPPING,
      &     NPIV, NCB, LIELL, JJ, NELIM, IERR
       INTEGER(8) :: PCB_COURANT, PPIV_COURANT, PPIV_PANEL, PCB_PANEL
-      INTEGER IPOSINRHSCOMP_TMP
+      INTEGER IPOSINRHSINTR_TMP
       INTEGER Effective_CB_Size, NUPDATE, ISLAVE, PDEST, FirstIndex
       LOGICAL FLAG
-      INTEGER :: NUPDATE_NONCRITICAL, IPOSINRHSCOMPLASTFSDYN 
+      INTEGER :: NUPDATE_NONCRITICAL, IPOSINRHSINTRLASTFSDYN 
       LOGICAL :: OMP_FLAG
       INCLUDE 'mumps_headers.h'
       INTEGER(8) :: APOSDEB
@@ -517,27 +517,27 @@ C
       ENDIF
       IF ( INODE .eq. KEEP( 38 ) .OR. INODE .eq. KEEP(20) ) THEN
         IFR8 = 0_8
-        IPOSINRHSCOMP_TMP = POSINRHSCOMP_FWD(IW(J1)) 
+        IPOSINRHSINTR_TMP = POSINRHSINTR_FWD(IW(J1)) 
         IFR_ini8 = IFR8
         OMP_FLAG = .FALSE.
 !$      OMP_FLAG = ( JBFIN-JBDEB+1.GE.KEEP(362) .AND.
 !$   &                     (J3-J1+1)*(JBFIN-JBDEB+1) .GE. KEEP(363) )
         IF (OMP_FLAG) THEN
 !$OMP PARALLEL DO PRIVATE(IFR8,JJ)
-          DO K=JBDEB,JBFIN
+          DO K=1,NRHS
              IFR8 = IFR_ini8 + int(K-1,8)*int(NPIV,8)
              DO JJ = J1, J3
                RHS_ROOT(IFR8+int(JJ-J1+1,8)) = 
-     &                 RHSCOMP(IPOSINRHSCOMP_TMP+JJ-J1,K)
+     &                 RHSINTR(IPOSINRHSINTR_TMP+JJ-J1,K)
              ENDDO
           ENDDO
 !$OMP END PARALLEL DO
         ELSE
-          DO K=JBDEB,JBFIN
+          DO K=1,NRHS
              IFR8 = IFR_ini8 + int(K-1,8)*int(NPIV,8)
              DO JJ = J1, J3
                RHS_ROOT(IFR8+int(JJ-J1+1,8)) = 
-     &                 RHSCOMP(IPOSINRHSCOMP_TMP+JJ-J1,K)
+     &                 RHSINTR(IPOSINRHSINTR_TMP+JJ-J1,K)
              ENDDO
           ENDDO
         ENDIF
@@ -602,10 +602,10 @@ C
       ELSE
         CBINITZERO = .FALSE. 
       ENDIF
-      CALL DMUMPS_RHSCOMP_TO_WCB(
+      CALL DMUMPS_RHSINTR_TO_WCB(
      &     NPIV, NCB, LIELL, CBINITZERO, LDEQLIELLPANEL,
-     &     RHSCOMP(1, JBDEB), LRHSCOMP, NRHS_B,
-     &     POSINRHSCOMP_FWD, N,
+     &     RHSINTR(1, JBDEB), LRHSINTR, NRHS_B,
+     &     POSINRHSINTR_FWD, N,
      &     WCB(PPIV_COURANT),
      &     IW, LIW, J1, J3, J2, KEEP, DKEEP)
       IF ( NPIV .NE. 0 ) THEN
@@ -702,8 +702,8 @@ C
      &           LIELL, WCB, LWCB, 
      &           LD_WCBPIV, LD_WCBCB,
      &           PPIV_COURANT, PCB_COURANT, 
-     &           RHSCOMP, LRHSCOMP, NRHS, 
-     &           POSINRHSCOMP_FWD, JBDEB, JBFIN,
+     &           RHSINTR, LRHSINTR, NRHS, 
+     &           POSINRHSINTR_FWD, JBDEB, JBFIN,
      &           MTYPE, KEEP, KEEP8, OOCWRITE_COMPATIBLE_WITH_BLR,
      &           INFO(1), INFO(2) )
             IF (INFO(1).LT.0) THEN
@@ -767,8 +767,8 @@ C
      &    IW, IPOS, LIW, 
      &    A, LA, APOS,
      &    WCB, LWCB, LD_WCBPIV, 
-     &    RHSCOMP, LRHSCOMP, NRHS, 
-     &    POSINRHSCOMP_FWD, JBDEB, JBFIN, 
+     &    RHSINTR, LRHSINTR, NRHS, 
+     &    POSINRHSINTR_FWD, JBDEB, JBFIN, 
      &    MTYPE, KEEP, OOCWRITE_COMPATIBLE_WITH_BLR,
      &    .FALSE.
      &    )
@@ -779,8 +779,8 @@ C
      &    IW, IPOS, LIW, 
      &    A, LA, APOS,
      &    WCB, LWCB, LD_WCBPIV, 
-     &    RHSCOMP, LRHSCOMP, NRHS, 
-     &    POSINRHSCOMP_FWD, JBDEB, JBFIN, 
+     &    RHSINTR, LRHSINTR, NRHS, 
+     &    POSINRHSINTR_FWD, JBDEB, JBFIN, 
      &    MTYPE, KEEP, OOCWRITE_COMPATIBLE_WITH_BLR,
      &    .FALSE.
      &    )
@@ -809,14 +809,14 @@ C
             NUPDATE_NONCRITICAL = NUPDATE
             IF (LASTFSL0DYN .LE. N) THEN
               IF ( LASTFSL0DYN .EQ. 0 ) THEN
-                IPOSINRHSCOMPLASTFSDYN = 0
+                IPOSINRHSINTRLASTFSDYN = 0
               ELSE
-                IPOSINRHSCOMPLASTFSDYN =
-     &                          abs(POSINRHSCOMP_FWD(LASTFSL0DYN))
+                IPOSINRHSINTRLASTFSDYN =
+     &                          abs(POSINRHSINTR_FWD(LASTFSL0DYN))
               ENDIF
               DO I = 1, NUPDATE
-                IF ( abs(POSINRHSCOMP_FWD( IW(J3+I) )) .GT. 
-     &               IPOSINRHSCOMPLASTFSDYN ) THEN
+                IF ( abs(POSINRHSINTR_FWD( IW(J3+I) )) .GT. 
+     &               IPOSINRHSINTRLASTFSDYN ) THEN
                   IF (abs(STEP(IW(J3+I))) .GT.
      &                abs(STEP( LASTFSL0STA))
      &                .OR. KEEP(261) .NE. 1) THEN
@@ -830,17 +830,17 @@ C
 !$          OMP_FLAG = ( NRHS_B.GE.KEEP(362) .AND.
 !$   &                  (NUPDATE*NRHS_B .GE. KEEP(363)) )
             IF (OMP_FLAG) THEN
-!$OMP PARALLEL DO PRIVATE(I,IFR8,IPOSINRHSCOMP_TMP)
+!$OMP PARALLEL DO PRIVATE(I,IFR8,IPOSINRHSINTR_TMP)
               DO K = JBDEB, JBFIN
                 IFR8 = PCB_COURANT + int(K-JBDEB,8)*int(LD_WCBCB,8)
 #if defined(__ve__)
 !NEC$ IVDEP
 #endif
                 DO I = 1, NUPDATE_NONCRITICAL
-                  IPOSINRHSCOMP_TMP = 
-     &            abs(POSINRHSCOMP_FWD(IW(J3 + I)))
-                  RHSCOMP( IPOSINRHSCOMP_TMP, K ) = 
-     &            RHSCOMP( IPOSINRHSCOMP_TMP, K )
+                  IPOSINRHSINTR_TMP = 
+     &            abs(POSINRHSINTR_FWD(IW(J3 + I)))
+                  RHSINTR( IPOSINRHSINTR_TMP, K ) = 
+     &            RHSINTR( IPOSINRHSINTR_TMP, K )
      &            + WCB(IFR8 + int(I-1,8))
                 ENDDO
               ENDDO
@@ -852,10 +852,10 @@ C
 !NEC$ IVDEP
 #endif
                 DO I = 1, NUPDATE_NONCRITICAL
-                  IPOSINRHSCOMP_TMP = 
-     &            abs(POSINRHSCOMP_FWD(IW(J3 + I)))
-                  RHSCOMP( IPOSINRHSCOMP_TMP, K ) = 
-     &            RHSCOMP( IPOSINRHSCOMP_TMP, K )
+                  IPOSINRHSINTR_TMP = 
+     &            abs(POSINRHSINTR_FWD(IW(J3 + I)))
+                  RHSINTR( IPOSINRHSINTR_TMP, K ) = 
+     &            RHSINTR( IPOSINRHSINTR_TMP, K )
      &            + WCB(IFR8 + int(I-1,8))
                 ENDDO
               ENDDO
@@ -878,10 +878,10 @@ C
 !NEC$ IVDEP
 #endif
                     DO I = NUPDATE_NONCRITICAL+1, NUPDATE
-                      IPOSINRHSCOMP_TMP = 
-     &                  abs(POSINRHSCOMP_FWD(IW(J3 + I)))
-                      RHSCOMP( IPOSINRHSCOMP_TMP, K ) = 
-     &                   RHSCOMP( IPOSINRHSCOMP_TMP, K )
+                      IPOSINRHSINTR_TMP = 
+     &                  abs(POSINRHSINTR_FWD(IW(J3 + I)))
+                      RHSINTR( IPOSINRHSINTR_TMP, K ) = 
+     &                   RHSINTR( IPOSINRHSINTR_TMP, K )
      &                   + WCB(IFR8 + int(I-1,8))
                     ENDDO
                   ENDDO
@@ -899,7 +899,7 @@ C
      &          NCB, LD_WCBCB,
      &          NUPDATE,
      &          IW( J3 + 1 ), WCB( PCB_COURANT ), JBDEB, JBFIN,
-     &          RHSCOMP, 1, 1, -9999, -9999,
+     &          RHSINTR, 1, 1, -9999, -9999,
      &          KEEP,
      &          MUMPS_PROCNODE(PROCNODE_STEPS(STEP(FPERE)), KEEP(199)),
      &          ContVec,
@@ -914,7 +914,7 @@ C
      &            WCB, LWCB, POSWCB, PLEFTWCB, POSIWCB,
      &            PTRICB, INFO, KEEP,KEEP8, DKEEP, STEP,
      &            PROCNODE_STEPS,
-     &            RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD
+     &            RHSINTR, LRHSINTR, POSINRHSINTR_FWD
      &            , FROM_PP
      &            )
             IF ( INFO( 1 )  .LT. 0 )  THEN
@@ -965,7 +965,7 @@ C
      &              WCB, LWCB, POSWCB, PLEFTWCB, POSIWCB,
      &              PTRICB, INFO, KEEP,KEEP8, DKEEP, STEP,
      &              PROCNODE_STEPS,
-     &              RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD
+     &              RHSINTR, LRHSINTR, POSINRHSINTR_FWD
      &              , FROM_PP
      &              )
                IF ( INFO( 1 )  .LT. 0 ) THEN
@@ -1001,7 +1001,7 @@ C
      &           WCB, LWCB, POSWCB,
      &           PLEFTWCB, POSIWCB,
      &           PTRICB, INFO, KEEP,KEEP8, DKEEP, STEP, PROCNODE_STEPS,
-     &           RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD
+     &           RHSINTR, LRHSINTR, POSINRHSINTR_FWD
      &            , FROM_PP
      &            )
       IMPLICIT NONE
@@ -1026,8 +1026,8 @@ C
       INTEGER STEP(N)
       INTEGER PROCNODE_STEPS(KEEP(28))
       LOGICAL FLAG
-      INTEGER LRHSCOMP, POSINRHSCOMP_FWD(N)
-      DOUBLE PRECISION RHSCOMP(LRHSCOMP,NRHS)
+      INTEGER LRHSINTR, POSINRHSINTR_FWD(N)
+      DOUBLE PRECISION RHSINTR(LRHSINTR,NRHS)
       LOGICAL, intent(in) :: FROM_PP
       INCLUDE 'mpif.h'
       INCLUDE 'mumps_tags.h'
@@ -1065,27 +1065,27 @@ C
      &          PLEFTWCB, POSIWCB,
      &          PTRICB, INFO, KEEP,KEEP8, DKEEP, STEP,
      &          PROCNODE_STEPS, 
-     &          RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD
+     &          RHSINTR, LRHSINTR, POSINRHSINTR_FWD
      &          , FROM_PP
      &          )
          END IF
       END IF
       RETURN
       END SUBROUTINE DMUMPS_SOLVE_RECV_AND_TREAT
-      SUBROUTINE DMUMPS_RHSCOMP_TO_WCB(
+      SUBROUTINE DMUMPS_RHSINTR_TO_WCB(
      &      NPIV, NCB, LIELL, CBINITZERO, LDEQLIELLPANEL,
-     &      RHSCOMP, LRHSCOMP, NRHS_B,
-     &      POSINRHSCOMP_FWD, N,
+     &      RHSINTR, LRHSINTR, NRHS_B,
+     &      POSINRHSINTR_FWD, N,
      &      WCB,
      &      IW, LIW, J1, J3, J2, KEEP, DKEEP)
       IMPLICIT NONE
       INTEGER, INTENT( IN )    :: NPIV, NCB, LIELL, N,
-     &                            LRHSCOMP, NRHS_B,
+     &                            LRHSINTR, NRHS_B,
      &                            LIW, J1, J2, J3
       LOGICAL, INTENT( IN )    :: LDEQLIELLPANEL
       LOGICAL, INTENT( IN )    :: CBINITZERO
-      INTEGER, INTENT( IN )    :: POSINRHSCOMP_FWD( N ), IW( LIW )
-      DOUBLE PRECISION, INTENT( INOUT ) :: RHSCOMP( LRHSCOMP, NRHS_B )
+      INTEGER, INTENT( IN )    :: POSINRHSINTR_FWD( N ), IW( LIW )
+      DOUBLE PRECISION, INTENT( INOUT ) :: RHSINTR( LRHSINTR, NRHS_B )
       DOUBLE PRECISION, INTENT( OUT )   :: WCB( int(LIELL,8)*
      &                                 int(NRHS_B,8) )
       INTEGER                  :: KEEP(500)
@@ -1093,7 +1093,7 @@ C
       INTEGER, PARAMETER :: ZERO = 0.0D0
       INTEGER(8), PARAMETER :: PPIV_COURANT = 1_8
       INTEGER(8) :: PCB_COURANT
-      INTEGER :: LD_WCBCB, LD_WCBPIV, J, JJ, K, IPOSINRHSCOMP
+      INTEGER :: LD_WCBCB, LD_WCBPIV, J, JJ, K, IPOSINRHSINTR
       INTEGER(8) :: IFR8, IFR_ini8 
       INCLUDE 'mpif.h' 
       LOGICAL :: OMP_FLAG
@@ -1109,11 +1109,11 @@ C
       IF ( LDEQLIELLPANEL ) THEN  
         DO K=1, NRHS_B
            IFR8 = PPIV_COURANT+int(K-1,8)*int(LD_WCBPIV,8)-1_8
-           IPOSINRHSCOMP = POSINRHSCOMP_FWD(IW(J1)) 
+           IPOSINRHSINTR = POSINRHSINTR_FWD(IW(J1)) 
            DO JJ = J1, J3
               IFR8 = IFR8 + 1_8
-              WCB(IFR8) = RHSCOMP(IPOSINRHSCOMP,K) 
-              IPOSINRHSCOMP = IPOSINRHSCOMP + 1
+              WCB(IFR8) = RHSINTR(IPOSINRHSINTR,K) 
+              IPOSINRHSINTR = IPOSINRHSINTR + 1
            ENDDO
            IF (NCB.GT.0 .AND. .NOT. CBINITZERO) THEN
 #if defined(__ve__)
@@ -1122,9 +1122,9 @@ C
               DO JJ = J3+1, J2
                  J = IW(JJ)
                  IFR8 = IFR8 + 1_8
-                 IPOSINRHSCOMP = abs(POSINRHSCOMP_FWD(J))
-                 WCB(IFR8) = RHSCOMP(IPOSINRHSCOMP,K) 
-                 RHSCOMP (IPOSINRHSCOMP,K) = ZERO
+                 IPOSINRHSINTR = abs(POSINRHSINTR_FWD(J))
+                 WCB(IFR8) = RHSINTR(IPOSINRHSINTR,K) 
+                 RHSINTR (IPOSINRHSINTR,K) = ZERO
               ENDDO
            ENDIF
         ENDDO
@@ -1132,7 +1132,7 @@ C
         PCB_COURANT = PPIV_COURANT + LD_WCBPIV*NRHS_B
         IFR8 = PPIV_COURANT - 1_8
         IFR_ini8 = IFR8
-        IPOSINRHSCOMP = POSINRHSCOMP_FWD(IW(J1)) 
+        IPOSINRHSINTR = POSINRHSINTR_FWD(IW(J1)) 
         OMP_FLAG = .FALSE.
 !$      OMP_FLAG = ( NRHS_B .GE. KEEP(362) .AND.
 !$   &               int(NCB,8)*int(NRHS_B,8) .GE. KEEP(363) )
@@ -1142,7 +1142,7 @@ C
             IFR8 = IFR_ini8 + int(K-1,8)*int(NPIV,8)
             DO  JJ = J1, J3
              WCB(IFR8+int(JJ-J1+1,8)) = 
-     &            RHSCOMP(IPOSINRHSCOMP+JJ-J1,K)
+     &            RHSINTR(IPOSINRHSINTR+JJ-J1,K)
             ENDDO
           ENDDO
 !$OMP END PARALLEL DO
@@ -1151,7 +1151,7 @@ C
             IFR8 = IFR_ini8 + int(K-1,8)*int(NPIV,8)
             DO  JJ = J1, J3
              WCB(IFR8+int(JJ-J1+1,8)) = 
-     &            RHSCOMP(IPOSINRHSCOMP+JJ-J1,K)
+     &            RHSINTR(IPOSINRHSINTR+JJ-J1,K)
             ENDDO
           ENDDO
         ENDIF
@@ -1162,7 +1162,7 @@ C
 !$        OMP_FLAG = ( NRHS_B.GE.KEEP(362) .AND.
 !$   &                 NCB*NRHS_B .GE. KEEP(363) )
           IF (OMP_FLAG) THEN
-!$OMP PARALLEL DO PRIVATE (IFR8, JJ, J, IPOSINRHSCOMP)
+!$OMP PARALLEL DO PRIVATE (IFR8, JJ, J, IPOSINRHSINTR)
             DO K=1, NRHS_B
               IFR8 = IFR_ini8+(K-1)*NCB
 #if defined(__ve__)
@@ -1170,9 +1170,9 @@ C
 #endif
               DO JJ = J3 + 1, J2
                 J = IW(JJ)
-                IPOSINRHSCOMP = abs(POSINRHSCOMP_FWD(J))
-                WCB(IFR8+int(JJ-J3,8)) = RHSCOMP(IPOSINRHSCOMP,K)
-                RHSCOMP(IPOSINRHSCOMP,K)=ZERO
+                IPOSINRHSINTR = abs(POSINRHSINTR_FWD(J))
+                WCB(IFR8+int(JJ-J3,8)) = RHSINTR(IPOSINRHSINTR,K)
+                RHSINTR(IPOSINRHSINTR,K)=ZERO
               ENDDO
             ENDDO
 !$OMP END PARALLEL DO
@@ -1184,9 +1184,9 @@ C
 #endif
               DO JJ = J3 + 1, J2
                 J = IW(JJ)
-                IPOSINRHSCOMP = abs(POSINRHSCOMP_FWD(J))
-                WCB(IFR8+int(JJ-J3,8)) = RHSCOMP(IPOSINRHSCOMP,K)
-                RHSCOMP(IPOSINRHSCOMP,K)=ZERO
+                IPOSINRHSINTR = abs(POSINRHSINTR_FWD(J))
+                WCB(IFR8+int(JJ-J3,8)) = RHSINTR(IPOSINRHSINTR,K)
+                RHSINTR(IPOSINRHSINTR,K)=ZERO
               ENDDO
             ENDDO
           ENDIF
@@ -1212,4 +1212,4 @@ C
         ENDIF
       ENDIF
       RETURN
-      END SUBROUTINE DMUMPS_RHSCOMP_TO_WCB
+      END SUBROUTINE DMUMPS_RHSINTR_TO_WCB
diff -pruN 5.6.2-2.1/src/dsol_lr.F 5.7.1-1/src/dsol_lr.F
--- 5.6.2-2.1/src/dsol_lr.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dsol_lr.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -24,20 +24,20 @@ C
      &     LIELL, WCB, LWCB, 
      &     LD_WCBPIV, LD_WCBCB,
      &     PPIV_INIT, PCB_INIT, 
-     &     RHSCOMP, LRHSCOMP, NRHS, 
-     &     POSINRHSCOMP_FWD, JBDEB, JBFIN, 
+     &     RHSINTR, LRHSINTR, NRHS, 
+     &     POSINRHSINTR_FWD, JBDEB, JBFIN, 
      &     MTYPE, KEEP, KEEP8, OOCWRITE_COMPATIBLE_WITH_BLR,
      &     IFLAG, IERROR )
        INTEGER, INTENT(IN) :: INODE, N, IWHDLR, NPIV_GLOBAL, NSLAVES
        INTEGER, INTENT(IN) :: MTYPE, LIELL, KEEP(500)
        INTEGER(8), INTENT(IN) :: KEEP8(150)
-       INTEGER, INTENT(IN) :: LIW, IPOS_INIT, LRHSCOMP
-       INTEGER, INTENT(IN) :: IW(LIW), POSINRHSCOMP_FWD(N)
+       INTEGER, INTENT(IN) :: LIW, IPOS_INIT, LRHSINTR
+       INTEGER, INTENT(IN) :: IW(LIW), POSINRHSINTR_FWD(N)
        INTEGER(8), INTENT(IN) :: LWCB, PPIV_INIT, PCB_INIT
        INTEGER, INTENT(IN) :: LD_WCBPIV, LD_WCBCB, NRHS, JBDEB, JBFIN
        DOUBLE PRECISION, INTENT(INOUT) :: WCB(LWCB)
        INTEGER, INTENT(INOUT) :: IFLAG, IERROR
-       DOUBLE PRECISION, INTENT(INOUT) :: RHSCOMP(LRHSCOMP, NRHS)
+       DOUBLE PRECISION, INTENT(INOUT) :: RHSINTR(LRHSINTR, NRHS)
        LOGICAL, INTENT(IN)    :: OOCWRITE_COMPATIBLE_WITH_BLR
         INTEGER :: I, NPARTSASS, NB_BLR , NELIM, LDADIAG,
      &             DIAGSIZ_DYN, DIAGSIZ_STA, IBEG_BLR, IEND_BLR,
@@ -167,8 +167,8 @@ C
      &  IW, IPOS, LIW, 
      &  DIAG(1), int(size(DIAG),8), 1_8, 
      &  WCB, LWCB, LD_WCBPIV, 
-     &  RHSCOMP, LRHSCOMP, NRHS, 
-     &  POSINRHSCOMP_FWD, JBDEB, JBFIN, 
+     &  RHSINTR, LRHSINTR, NRHS, 
+     &  POSINRHSINTR_FWD, JBDEB, JBFIN, 
      &  MTYPE, KEEP, OOCWRITE_COMPATIBLE_WITH_BLR,
      &  .TRUE.  
      &  )
@@ -381,19 +381,19 @@ C
       SUBROUTINE DMUMPS_SOL_BWD_LR_SU 
      &   ( INODE, IWHDLR, NPIV_GLOBAL, NSLAVES,
      &     LIELL, WCB, LWCB, NRHS_B, PTWCB,
-     &     RHSCOMP, LRHSCOMP, NRHS,
-     &     IPOSINRHSCOMP, JBDEB, 
+     &     RHSINTR, LRHSINTR, NRHS,
+     &     IPOSINRHSINTR, JBDEB, 
      &     MTYPE, KEEP, KEEP8,
      &     IFLAG, IERROR )
        INTEGER, INTENT(IN) :: INODE, IWHDLR, NPIV_GLOBAL, NSLAVES
        INTEGER, INTENT(IN) :: MTYPE, LIELL, KEEP(500)
        INTEGER(8), INTENT(IN) :: KEEP8(150)
-       INTEGER, INTENT(IN) :: IPOSINRHSCOMP, JBDEB, LRHSCOMP, NRHS
+       INTEGER, INTENT(IN) :: IPOSINRHSINTR, JBDEB, LRHSINTR, NRHS
        INTEGER(8), INTENT(IN) :: LWCB, PTWCB
        INTEGER, INTENT(IN) ::  NRHS_B
        INTEGER, INTENT(INOUT) :: IFLAG, IERROR
        DOUBLE PRECISION, INTENT(INOUT) :: WCB(LWCB)
-       DOUBLE PRECISION RHSCOMP(LRHSCOMP,NRHS)
+       DOUBLE PRECISION RHSINTR(LRHSINTR,NRHS)
         INTEGER :: I, NPARTSASS, NB_BLR, LAST_BLR, 
      &             NELIM_PANEL, LD_WCB,
      &             DIAGSIZ_DYN, DIAGSIZ_STA, LDADIAG,
@@ -441,15 +441,15 @@ C
         ENDIF 
         IF (DIAGSIZ_DYN.EQ.0) GOTO 1000
         NELIM_PANEL = DIAGSIZ_STA - DIAGSIZ_DYN
-         IPIV_PANEL = IPOSINRHSCOMP + IBEG_BLR -1
+         IPIV_PANEL = IPOSINRHSINTR + IBEG_BLR -1
          IF ( MTYPE .EQ. 1 .AND. KEEP(50).EQ.0) THEN
           BLR_PANEL => BLR_ARRAY(IWHDLR)%PANELS_U(I)%LRB_PANEL
          ELSE
           BLR_PANEL => BLR_ARRAY(IWHDLR)%PANELS_L(I)%LRB_PANEL
          END IF
         CALL DMUMPS_SOL_BWD_BLR_UPDATE ( 
-     &        RHSCOMP, int(LRHSCOMP,8), NRHS, LRHSCOMP, 
-     &        int(IPOSINRHSCOMP,8), JBDEB,
+     &        RHSINTR, int(LRHSINTR,8), NRHS, LRHSINTR, 
+     &        int(IPOSINRHSINTR,8), JBDEB,
      &        WCB, LWCB, LD_WCB, PWCB, 
      &        int(IPIV_PANEL,8), 
      &        NRHS_B, NPIV_GLOBAL,
@@ -465,26 +465,26 @@ C
              IF (IEND_BLR.EQ.NPIV_GLOBAL) THEN
                CALL dgemm('T', 'N', DIAGSIZ_DYN, NRHS_B, NELIM_PANEL, 
      &              MONE, DIAG(1+DIAGSIZ_DYN), DIAGSIZ_STA,  WCB(PWCB),
-     &              LD_WCB, ONE , RHSCOMP(IPIV_PANEL,JBDEB),LRHSCOMP)
+     &              LD_WCB, ONE , RHSINTR(IPIV_PANEL,JBDEB),LRHSINTR)
              ELSE
                IF (IEND_BLR+1.LE.NPIV_GLOBAL .AND.
      &            IEND_BLR+NELIM_PANEL.GT.NPIV_GLOBAL) THEN
                  CALL dgemm('T', 'N', DIAGSIZ_DYN, NRHS_B,
      &              NPIV_GLOBAL-IEND_BLR, 
      &              MONE, DIAG(1+DIAGSIZ_DYN), DIAGSIZ_STA, 
-     &              RHSCOMP(IPIV_PANEL+DIAGSIZ_DYN,JBDEB), LRHSCOMP,
-     &              ONE, RHSCOMP(IPIV_PANEL,JBDEB), LRHSCOMP)
+     &              RHSINTR(IPIV_PANEL+DIAGSIZ_DYN,JBDEB), LRHSINTR,
+     &              ONE, RHSINTR(IPIV_PANEL,JBDEB), LRHSINTR)
                  CALL dgemm('T', 'N', DIAGSIZ_DYN, NRHS_B,
      &              IEND_BLR+NELIM_PANEL-NPIV_GLOBAL, 
      &              MONE, DIAG(1+DIAGSIZ_DYN+NPIV_GLOBAL-IEND_BLR),
      &              DIAGSIZ_STA, 
      &              WCB(PWCB), LD_WCB,
-     &              ONE, RHSCOMP(IPIV_PANEL,JBDEB), LRHSCOMP)
+     &              ONE, RHSINTR(IPIV_PANEL,JBDEB), LRHSINTR)
                ELSE
                  CALL dgemm('T', 'N', DIAGSIZ_DYN, NRHS_B, NELIM_PANEL, 
      &              MONE, DIAG(1+DIAGSIZ_DYN), DIAGSIZ_STA, 
-     &              RHSCOMP(IPIV_PANEL+DIAGSIZ_DYN,JBDEB), LRHSCOMP,
-     &              ONE, RHSCOMP(IPIV_PANEL,JBDEB), LRHSCOMP)
+     &              RHSINTR(IPIV_PANEL+DIAGSIZ_DYN,JBDEB), LRHSINTR,
+     &              ONE, RHSINTR(IPIV_PANEL,JBDEB), LRHSINTR)
                ENDIF
              ENDIF
            ELSE
@@ -492,27 +492,27 @@ C
                CALL dgemm('N', 'N', DIAGSIZ_DYN, NRHS_B, NELIM_PANEL, 
      &              MONE, DIAG(1+DIAGSIZ_DYN*LDADIAG), DIAGSIZ_DYN, 
      &              WCB(PWCB), LD_WCB, ONE, 
-     &              RHSCOMP(IPIV_PANEL,JBDEB), LRHSCOMP)
+     &              RHSINTR(IPIV_PANEL,JBDEB), LRHSINTR)
              ELSE
                IF (IEND_BLR+1.LE.NPIV_GLOBAL .AND.
      &            IEND_BLR+NELIM_PANEL.GT.NPIV_GLOBAL) THEN
                  CALL dgemm('N', 'N', DIAGSIZ_DYN, NRHS_B,
      &              NPIV_GLOBAL-IEND_BLR, 
      &              MONE, DIAG(1+DIAGSIZ_DYN*LDADIAG), DIAGSIZ_DYN, 
-     &              RHSCOMP(IPIV_PANEL+DIAGSIZ_DYN,JBDEB), LRHSCOMP,
-     &              ONE, RHSCOMP(IPIV_PANEL,JBDEB), LRHSCOMP)
+     &              RHSINTR(IPIV_PANEL+DIAGSIZ_DYN,JBDEB), LRHSINTR,
+     &              ONE, RHSINTR(IPIV_PANEL,JBDEB), LRHSINTR)
                  CALL dgemm('N', 'N', DIAGSIZ_DYN, NRHS_B,
      &              IEND_BLR+NELIM_PANEL-NPIV_GLOBAL, 
      &              MONE, DIAG(1+DIAGSIZ_DYN*LDADIAG +
      &                  (NPIV_GLOBAL-IEND_BLR)*DIAGSIZ_DYN),
      &              DIAGSIZ_DYN, 
      &              WCB(PWCB), LD_WCB,
-     &              ONE, RHSCOMP(IPIV_PANEL,JBDEB), LRHSCOMP)
+     &              ONE, RHSINTR(IPIV_PANEL,JBDEB), LRHSINTR)
                ELSE
                  CALL dgemm('N', 'N', DIAGSIZ_DYN, NRHS_B, NELIM_PANEL, 
      &              MONE, DIAG(1+DIAGSIZ_DYN*LDADIAG), DIAGSIZ_DYN, 
-     &              RHSCOMP(IPIV_PANEL+DIAGSIZ_DYN,JBDEB), LRHSCOMP,
-     &              ONE, RHSCOMP(IPIV_PANEL,JBDEB), LRHSCOMP)
+     &              RHSINTR(IPIV_PANEL+DIAGSIZ_DYN,JBDEB), LRHSINTR,
+     &              ONE, RHSINTR(IPIV_PANEL,JBDEB), LRHSINTR)
                ENDIF
              ENDIF
            ENDIF
@@ -521,7 +521,7 @@ C
          CALL DMUMPS_SOLVE_BWD_LR_TRSOLVE  (
      &         DIAG(1), size(DIAG), DIAGSIZ_DYN, NELIM_PANEL, LIELL,
      &         NRHS_B, WCB, LWCB, 
-     &         RHSCOMP, LRHSCOMP, NRHS,
+     &         RHSINTR, LRHSINTR, NRHS,
      &         IPIV_PANEL, JBDEB, 
      &         MTYPE, KEEP )
  1000 CONTINUE         
@@ -697,24 +697,24 @@ C
       SUBROUTINE DMUMPS_SOLVE_BWD_LR_TRSOLVE (
      &           DIAG, LDIAG, NPIV, NELIM, LIELL,
      &           NRHS_B, W, LWC, 
-     &           RHSCOMP, LRHSCOMP, NRHS,
-     &           PPIVINRHSCOMP, JBDEB, 
+     &           RHSINTR, LRHSINTR, NRHS,
+     &           PPIVINRHSINTR, JBDEB, 
      &           MTYPE, KEEP)
        INTEGER, INTENT(IN) :: MTYPE, LIELL, NPIV, NELIM, KEEP(500)
        INTEGER, INTENT(IN) :: NRHS_B, LDIAG
-       INTEGER, INTENT(IN) :: PPIVINRHSCOMP, JBDEB, LRHSCOMP, NRHS
+       INTEGER, INTENT(IN) :: PPIVINRHSINTR, JBDEB, LRHSINTR, NRHS
        INTEGER(8), INTENT(IN) ::  LWC
        DOUBLE PRECISION, INTENT(IN) :: DIAG(LDIAG)
        DOUBLE PRECISION, INTENT(INOUT) :: W(LWC)
-       DOUBLE PRECISION RHSCOMP(LRHSCOMP,NRHS)
+       DOUBLE PRECISION RHSINTR(LRHSINTR,NRHS)
        INTEGER :: LDAJ
       DOUBLE PRECISION ONE
       PARAMETER (ONE = 1.0D0)
         IF ( MTYPE .eq. 1 ) THEN
          LDAJ =  NPIV + NELIM
          CALL dtrsm('L','L','T','N', NPIV, NRHS_B, ONE, DIAG(1),
-     &              LDAJ, RHSCOMP(PPIVINRHSCOMP,JBDEB), 
-     &              LRHSCOMP)
+     &              LDAJ, RHSINTR(PPIVINRHSINTR,JBDEB), 
+     &              LRHSINTR)
         ELSE
          IF ( KEEP(50) .EQ. 0 ) THEN
            LDAJ=NPIV+NELIM
@@ -722,7 +722,7 @@ C
            LDAJ=NPIV
          ENDIF
          CALL dtrsm('L','U','N','U', NPIV, NRHS_B, ONE, DIAG(1),
-     &            LDAJ, RHSCOMP(PPIVINRHSCOMP,JBDEB), LRHSCOMP)
+     &            LDAJ, RHSINTR(PPIVINRHSINTR,JBDEB), LRHSINTR)
         END IF 
       RETURN
       END SUBROUTINE DMUMPS_SOLVE_BWD_LR_TRSOLVE
diff -pruN 5.6.2-2.1/src/dsol_matvec.F 5.7.1-1/src/dsol_matvec.F
--- 5.6.2-2.1/src/dsol_matvec.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/dsol_matvec.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/dsol_omp_m.F 5.7.1-1/src/dsol_omp_m.F
--- 5.6.2-2.1/src/dsol_omp_m.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dsol_omp_m.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -35,16 +35,18 @@ C
       IMPLICIT NONE
       INTEGER, INTENT(IN) :: K400
 !$    INTEGER :: I
-!$    IF (K400 .GT. 0) THEN
-!$      DO I = 1, min(NB_LOCK_MAX,K400)
-!$        CALL OMP_DESTROY_LOCK(LOCK_FOR_SCATTER(I))
-!$      ENDDO
-!$      DEALLOCATE(LOCK_FOR_SCATTER)
+!$    IF (allocated(LOCK_FOR_SCATTER)) THEN
+!$      IF (K400 .GT. 0) THEN
+!$        DO I = 1, min(NB_LOCK_MAX,K400)
+!$          CALL OMP_DESTROY_LOCK(LOCK_FOR_SCATTER(I))
+!$        ENDDO
+!$        DEALLOCATE(LOCK_FOR_SCATTER)
+!$      ENDIF
 !$    ENDIF
       RETURN
       END SUBROUTINE DMUMPS_SOL_L0OMP_LD
       SUBROUTINE DMUMPS_SOL_L0OMP_R(N, MTYPE,
-     &  NRHS, LIW, IW, PTRICB, RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD,
+     &  NRHS, LIW, IW, PTRICB, RHSINTR, LRHSINTR, POSINRHSINTR_FWD,
      &  STEP, FRERE, DAD, FILS, NSTK, PTRIST, PTRFAC, INFO,
      &  KEEP, KEEP8, DKEEP, PROCNODE_STEPS, SLAVEF,
      &  COMM, MYID,              
@@ -69,8 +71,8 @@ C
       DOUBLE PRECISION                  :: DKEEP(230)
       INTEGER, INTENT( in ) :: PROCNODE_STEPS( KEEP(28) )
       INTEGER               :: PTRICB( KEEP(28) ) 
-      INTEGER, INTENT( in ) :: POSINRHSCOMP_FWD(N), LRHSCOMP 
-      DOUBLE PRECISION, INTENT(inout):: RHSCOMP(LRHSCOMP,NRHS)
+      INTEGER, INTENT( in ) :: POSINRHSINTR_FWD(N), LRHSINTR 
+      DOUBLE PRECISION, INTENT(inout):: RHSINTR(LRHSINTR,NRHS)
       INTEGER, INTENT( in ) :: STEP(N), FRERE( KEEP(28) ), FILS( N ),
      &                         DAD( KEEP(28) )
       INTEGER, INTENT( inout ) :: NSTK(KEEP(28))
@@ -220,7 +222,7 @@ C
      &        PTRICB, PTRIST, PTRFAC, PROCNODE_STEPS,
      &        FILS, STEP, FRERE, DAD, INFO_P, KEEP, KEEP8, DKEEP,
      &        RHS_ROOT, LRHS_ROOT, MTYPE,
-     &        RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD,
+     &        RHSINTR, LRHSINTR, POSINRHSINTR_FWD,
      &        ISTEP_TO_INIV2, TAB_POS_IN_PERE, 
      &        RHS_BOUNDS, LRHS_BOUNDS, DO_NBSPARSE, FROM_PP
      &        , ERROR_WAS_BROADCASTED_P )
@@ -286,7 +288,7 @@ C
       RETURN
       END SUBROUTINE DMUMPS_SOL_L0OMP_R
       SUBROUTINE DMUMPS_SOL_L0OMP_S(N, MTYPE, NRHS, LIW, IW,
-     &  PTRICB, PTRACB, RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &  PTRICB, PTRACB, RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &  STEP, FRERE, FILS, NE_STEPS, PTRIST, PTRFAC, INFO,
      &  KEEP, KEEP8, DKEEP, PROCNODE_STEPS, SLAVEF,
      &  COMM, MYID, BUFR, LBUFR, LBUFR_BYTES, RHS_ROOT, LRHS_ROOT, 
@@ -307,8 +309,8 @@ C
       INTEGER, INTENT( in ) :: PROCNODE_STEPS( KEEP(28) )
       INTEGER               :: PTRICB( KEEP(28) ) 
       INTEGER(8)            :: PTRACB( KEEP(28) ) 
-      INTEGER, INTENT( in ) :: POSINRHSCOMP_BWD(N), LRHSCOMP 
-      DOUBLE PRECISION, INTENT(inout):: RHSCOMP(LRHSCOMP,NRHS)
+      INTEGER, INTENT( in ) :: POSINRHSINTR_BWD(N), LRHSINTR 
+      DOUBLE PRECISION, INTENT(inout):: RHSINTR(LRHSINTR,NRHS)
       INTEGER, INTENT( in ) :: STEP(N), FRERE( KEEP(28) ), FILS( N )
       INTEGER, INTENT( inout ) :: NE_STEPS(KEEP(28))
       INTEGER, INTENT( in )    :: PTRIST(KEEP(28))
@@ -440,7 +442,7 @@ C
      &      IIPOOL_P,  NBFIN_DUMMY, L0_OMP_FACTORS(IL0OMPFAC)%A(1),
      &      L0_OMP_FACTORS(IL0OMPFAC)%LA, IW, LIW, 
      &      WCB_P, LWCB_P, NRHS, POSWCB_P, PLEFTWCB_P, POSIWCB_P,
-     &      RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &      RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &      PTRICB, PTRACB, IWCB_P, LIWCB_P, W2_P, NE_STEPS, STEP,
      &      FRERE, FILS, PTRIST, PTRFAC, MYLEAF_LEFT_HUGE_P, INFO_P, 
      &      PROCNODE_STEPS,
diff -pruN 5.6.2-2.1/src/dsol_root_parallel.F 5.7.1-1/src/dsol_root_parallel.F
--- 5.6.2-2.1/src/dsol_root_parallel.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/dsol_root_parallel.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -29,11 +29,10 @@ C
       INTEGER IERR, NPROW, NPCOL, MYROW, MYCOL
       INTEGER LOCAL_N_RHS
       DOUBLE PRECISION, ALLOCATABLE, DIMENSION( :,: ) ::RHS_PAR
-      EXTERNAL numroc
-      INTEGER  numroc
+      INTEGER, EXTERNAL :: MUMPS_NUMROC
       INTEGER allocok
       CALL blacs_gridinfo( CNTXT_PAR, NPROW, NPCOL, MYROW, MYCOL )
-      LOCAL_N_RHS = numroc(NRHS, NBLOCK, MYCOL, 0, NPCOL)
+      LOCAL_N_RHS = MUMPS_NUMROC(NRHS, NBLOCK, MYCOL, 0, NPCOL)
       LOCAL_N_RHS = max(1,LOCAL_N_RHS)
       ALLOCATE(RHS_PAR(LOCAL_M, LOCAL_N_RHS),stat=allocok)
       IF (allocok > 0 ) THEN
diff -pruN 5.6.2-2.1/src/dstatic_ptr_m.F 5.7.1-1/src/dstatic_ptr_m.F
--- 5.6.2-2.1/src/dstatic_ptr_m.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/dstatic_ptr_m.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/dtools.F 5.7.1-1/src/dtools.F
--- 5.6.2-2.1/src/dtools.F	2023-10-11 09:37:05.000000000 +0000
+++ 5.7.1-1/src/dtools.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -638,14 +638,6 @@ C
      & '    Total space in MBytes, OOC factorization     (INFOG(39)):'
      &        ,INFOG(39)
       END IF
-      IF ( PROKG.AND.SUM_OF_PEAKS) THEN
-       WRITE( MPG,'(A,A)') 
-     & ' Estimations with BLR compression of only',
-     & ' Contribution Blocks (CB):'
-       WRITE( MPG,'(A,I6,A) ')
-     & ' ICNTL(39) Estimated compression rate of CB         =', 
-     &   KEEP(465), '/1000'
-      ENDIF
       IF (SUM_OF_PEAKS) THEN
        OOC_STAT  =  0  
        BLR_STRAT =  3  
@@ -686,16 +678,6 @@ C
           LRCB_UD(3) = LRCB_UD(2)/NSLAVES
         ENDIF
        ENDIF
-       IF ( PROKG.AND.SUM_OF_PEAKS ) THEN
-        IF (COMPUTE_MAXAVG) THEN
-         WRITE( MPG,'(A,I12) ')
-     & '    Maximum estim. space in Mbytes, IC facto.    (INFOG(44)):',
-     &        INFOG(44)
-        ENDIF
-        WRITE(MPG,'(A,I12) ')
-     & '    Total space in MBytes, IC factorization      (INFOG(45)):'
-     &        ,INFOG(45)
-       END IF
        OOC_STAT  =  1  
        BLR_STRAT =  3  
        BLR_CASE  =  1  
@@ -735,16 +717,6 @@ C
           OOC_LRCB_UD(3) = OOC_LRCB_UD(2)/NSLAVES
         ENDIF
        ENDIF
-       IF ( PROKG.AND.SUM_OF_PEAKS  ) THEN
-        IF (COMPUTE_MAXAVG) THEN
-         WRITE( MPG,'(A,I12) ')
-     & '    Maximum estim. space in Mbytes, OOC facto.   (INFOG(46)):',
-     &        INFOG(46)
-        ENDIF
-        WRITE(MPG,'(A,I12) ')
-     & '    Total space in MBytes, OOC factorization     (INFOG(47)):'
-     &        ,INFOG(47)
-       END IF
       END IF
       IF ( PROKG.AND.SUM_OF_PEAKS  ) THEN
        WRITE( MPG,'(A,A)') 
@@ -927,7 +899,7 @@ C
       NB_INT = NB_INT + 5_8 * NSTEPS8
       NB_INT = NB_INT + NSTEPS8 + int(KEEP(56),8)*int(NSLAVES+2,8)
         NB_INT = NB_INT + 3_8*N8 + KEEP(280)
-        IF (KEEP(38) .NE. 0) NB_INT = NB_INT + N8
+        IF (KEEP(38) .NE. 0 .AND.I_AM_SLAVE) NB_INT = NB_INT + N8 
       IF (KEEP(23).ne.0 .and. I_AM_MASTER) NB_INT=NB_INT + N8
       IF (KEEP(55).eq.0) THEN
         NB_INT = NB_INT + KEEP(193)*I8OVERI
@@ -1128,9 +1100,6 @@ C
      &         .and. KEEP(55) .ne. 0 ) ) THEN
         NB_INT  = NB_INT  + KEEP8(27)
       END IF
-      IF ( I_AM_SLAVE .and. KEEP(38) .ne. 0 ) THEN
-        NB_INT = NB_INT + N8
-      END IF
       TEMPI= 0_8
       TEMPR = 0_8
       NBRECORDS = KEEP(39)
@@ -1971,10 +1940,10 @@ C
      &  NB_INT=NB_INT+size(id%I_AM_CAND)
       IF (associated(id%MEM_DIST)) 
      &  NB_INT=NB_INT+size(id%MEM_DIST)
-      IF (associated(id%POSINRHSCOMP_ROW))
-     &     NB_INT=NB_INT+size(id%POSINRHSCOMP_ROW)
-      IF(id%POSINRHSCOMP_COL_ALLOC.AND.associated(id%POSINRHSCOMP_COL))
-     &     NB_INT=NB_INT+size(id%POSINRHSCOMP_COL)
+      IF (associated(id%GLOB2LOC_RHS))
+     &     NB_INT=NB_INT+size(id%GLOB2LOC_RHS)
+      IF(id%GLOB2LOC_SOL_ALLOC.AND.associated(id%GLOB2LOC_SOL))
+     &     NB_INT=NB_INT+size(id%GLOB2LOC_SOL)
       IF       (associated(id%MEM_SUBTREE))
      &  NB_REAL=NB_REAL+size(id%MEM_SUBTREE)*(id%KEEP(35)/id%KEEP(16))
       IF       (associated(id%MY_ROOT_SBTR))
@@ -2055,12 +2024,16 @@ C
      &     NB_CMPLX=NB_CMPLX+size(id%root%SVD_VT)
       IF (associated(id%root%SINGULAR_VALUES))
      &     NB_REAL=NB_REAL+size(id%root%SINGULAR_VALUES)
-      IF (associated(id%RHSCOMP)) NB_CMPLX = NB_CMPLX + id%KEEP8(25)
+      IF (associated(id%RHSINTR)) NB_CMPLX = NB_CMPLX + id%KEEP8(25)
       IF (associated(id%S))       NB_CMPLX=NB_CMPLX+id%KEEP8(23)
       IF (associated(id%COLSCA).AND.(id%KEEP(52).NE.-1))
      &     NB_REAL=NB_REAL+size(id%COLSCA)
       IF (associated(id%ROWSCA).AND.(id%KEEP(52).NE.-1))
      &     NB_REAL=NB_REAL+size(id%ROWSCA)
+      IF (associated(id%ROWSCA_loc)) 
+     &     NB_REAL=NB_REAL+size(id%ROWSCA_loc)
+      IF (associated(id%COLSCA_loc).AND.id%KEEP(50).EQ.0)
+     &     NB_REAL=NB_REAL+size(id%COLSCA_loc)
       NB_REAL=NB_REAL+size(id%CNTL)
       NB_REAL=NB_REAL+size(id%RINFO)
       NB_REAL=NB_REAL+size(id%RINFOG)
@@ -2083,7 +2056,6 @@ C
       INTEGER(8) :: SHIFT8, HUG8
       INTEGER    :: I, I4SIZE
       IF(int(huge(I4SIZE),8) .EQ. int(huge(HUG8),8)) THEN
-         CALL dcopy(N8, SRC(1), 1, DEST(1), 1)
          CALL dcopy(int(N8), SRC(1), 1, DEST(1), 1)
       ELSE
          HUG8=int(huge(I4SIZE),8)
diff -pruN 5.6.2-2.1/src/dtype3_root.F 5.7.1-1/src/dtype3_root.F
--- 5.6.2-2.1/src/dtype3_root.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/dtype3_root.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -127,7 +127,7 @@ C
       DOUBLE PRECISION OPASSW, OPELIW
       INTEGER PROCNODE_STEPS( KEEP(28) )
       INTEGER ITLOC( N + KEEP(253) ), FILS( N ), DAD(KEEP(28))
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INTEGER ND( KEEP(28) ), FRERE( KEEP(28) )
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
@@ -161,8 +161,6 @@ C
       INCLUDE 'mumps_headers.h'
       LOGICAL SKIPLAST_RHS_ROWS, BCP_SYM_NONEMPTY
       INTEGER BBPCBP
-      INTEGER MUMPS_PROCNODE
-      EXTERNAL MUMPS_PROCNODE
       BBPCBP  = 0   
       LP = ICNTL(1)
       IF ( ICNTL(4) .LE. 0 ) LP = -1
@@ -1176,7 +1174,7 @@ C
       INTEGER(8) :: PTRAST(KEEP(28)), PAMASTER(KEEP(28))
       INTEGER PIMASTER(KEEP(28))
       INTEGER ITLOC( N + KEEP(253) )
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INTEGER COMP, IFLAG, IERROR
       INCLUDE 'mumps_headers.h'
       INTEGER FILS( N ), DAD(KEEP(28))
@@ -1189,20 +1187,19 @@ C
       INTEGER, INTENT(IN) :: PTRDEBARR(KEEP(196))
       INTEGER INTARR(KEEP8(27))
       DOUBLE PRECISION DBLARR(KEEP8(26))
-      INTEGER numroc
-      EXTERNAL numroc
+      INTEGER, EXTERNAL :: MUMPS_NUMROC
       DOUBLE PRECISION ZERO
       PARAMETER( ZERO = 0.0D0 )
       INTEGER(8) :: LREQA_ROOT
       INTEGER LREQI_ROOT, LOCAL_M, LOCAL_N, allocok
       LOGICAL :: EARLYT3ROOTINS
-          LOCAL_M = numroc( root%ROOT_SIZE, root%MBLOCK,
+          LOCAL_M = MUMPS_NUMROC( root%ROOT_SIZE, root%MBLOCK,
      &              root%MYROW, 0, root%NPROW )
           LOCAL_M = max( 1, LOCAL_M )
-          LOCAL_N = numroc( root%ROOT_SIZE, root%NBLOCK,
+          LOCAL_N = MUMPS_NUMROC( root%ROOT_SIZE, root%NBLOCK,
      &              root%MYCOL, 0, root%NPCOL )
           IF (KEEP(253).GT.0) THEN
-            root%RHS_NLOC = numroc( KEEP(253), root%NBLOCK,
+            root%RHS_NLOC = MUMPS_NUMROC( KEEP(253), root%NBLOCK,
      &              root%MYCOL, 0, root%NPCOL )
             root%RHS_NLOC = max(1, root%RHS_NLOC)
           ELSE
@@ -1220,7 +1217,7 @@ C
           IF (KEEP(253).NE.0) THEN
             root%RHS_ROOT = ZERO
             CALL DMUMPS_ASM_RHS_ROOT (  N, FILS, 
-     &           root, KEEP, RHS_MUMPS, 
+     &           root, KEEP, KEEP8, RHS_MUMPS, 
      &           IFLAG, IERROR )
             IF ( IFLAG .LT. 0 ) RETURN
           ENDIF
@@ -1373,14 +1370,15 @@ C
       RETURN
       END SUBROUTINE DMUMPS_ASM_ELT_ROOT
       SUBROUTINE DMUMPS_ASM_RHS_ROOT
-     &           ( N, FILS, root, KEEP, RHS_MUMPS, 
+     &           ( N, FILS, root, KEEP, KEEP8, RHS_MUMPS, 
      &             IFLAG, IERROR )
       USE DMUMPS_STRUC_DEF, ONLY : DMUMPS_ROOT_STRUC
       IMPLICIT NONE
       INTEGER N, KEEP(500), IFLAG, IERROR
+      INTEGER(8) :: KEEP8(150)
       INTEGER FILS(N)
       TYPE (DMUMPS_ROOT_STRUC ) :: root
-      DOUBLE PRECISION :: RHS_MUMPS(KEEP(255))
+      DOUBLE PRECISION :: RHS_MUMPS(KEEP8(85))
       INTEGER JCOL, IPOS_ROOT, JPOS_ROOT,
      &        IROW_GRID, JCOL_GRID, ILOCRHS, JLOCRHS,
      &        INODE
diff -pruN 5.6.2-2.1/src/estim_flops.F 5.7.1-1/src/estim_flops.F
--- 5.6.2-2.1/src/estim_flops.F	2023-10-11 09:36:34.000000000 +0000
+++ 5.7.1-1/src/estim_flops.F	2024-05-02 10:15:13.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/fac_asm_build_sort_index_ELT_m.F 5.7.1-1/src/fac_asm_build_sort_index_ELT_m.F
--- 5.6.2-2.1/src/fac_asm_build_sort_index_ELT_m.F	2023-10-11 09:36:35.000000000 +0000
+++ 5.7.1-1/src/fac_asm_build_sort_index_ELT_m.F	2024-05-02 10:15:13.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/fac_asm_build_sort_index_m.F 5.7.1-1/src/fac_asm_build_sort_index_m.F
--- 5.6.2-2.1/src/fac_asm_build_sort_index_m.F	2023-10-11 09:36:35.000000000 +0000
+++ 5.7.1-1/src/fac_asm_build_sort_index_m.F	2024-05-02 10:15:13.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/fac_descband_data_m.F 5.7.1-1/src/fac_descband_data_m.F
--- 5.6.2-2.1/src/fac_descband_data_m.F	2023-10-11 09:36:35.000000000 +0000
+++ 5.7.1-1/src/fac_descband_data_m.F	2024-05-02 10:15:14.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/fac_future_niv2_mod.F 5.7.1-1/src/fac_future_niv2_mod.F
--- 5.6.2-2.1/src/fac_future_niv2_mod.F	2023-10-11 09:36:35.000000000 +0000
+++ 5.7.1-1/src/fac_future_niv2_mod.F	2024-05-02 10:15:13.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/fac_ibct_data_m.F 5.7.1-1/src/fac_ibct_data_m.F
--- 5.6.2-2.1/src/fac_ibct_data_m.F	2023-10-11 09:36:35.000000000 +0000
+++ 5.7.1-1/src/fac_ibct_data_m.F	2024-05-02 10:15:14.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/fac_maprow_data_m.F 5.7.1-1/src/fac_maprow_data_m.F
--- 5.6.2-2.1/src/fac_maprow_data_m.F	2023-10-11 09:36:35.000000000 +0000
+++ 5.7.1-1/src/fac_maprow_data_m.F	2024-05-02 10:15:14.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/front_data_mgt_m.F 5.7.1-1/src/front_data_mgt_m.F
--- 5.6.2-2.1/src/front_data_mgt_m.F	2023-10-11 09:36:35.000000000 +0000
+++ 5.7.1-1/src/front_data_mgt_m.F	2024-05-02 10:15:14.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -56,7 +56,9 @@ C     ===============
      &          MUMPS_FDM_END_IDX
      &          , MUMPS_FDM_MOD_TO_STRUC
      &          , MUMPS_FDM_STRUC_TO_MOD
+#if ! defined(NO_SAVE_RESTORE)      
      &          , MUMPS_SAVE_RESTORE_FRONT_DATA
+#endif
 C     STACK_FREE_IDX(1:NB_FREE_IDX) holds the NB_FREE_IDX indices
 C                                   of free handlers
 C     STACK_FREE_IDX(NB_FREE_IDX+1:size(STACK_FREE_IDX)) is trash data
@@ -66,6 +68,9 @@ C     STACK_FREE_IDX(NB_FREE_IDX+1:size(
         INTEGER, DIMENSION(:), POINTER :: COUNT_ACCESS   => null()
       END TYPE FDM_STRUC_T
       TYPE (FDM_STRUC_T), TARGET, SAVE :: FDM_A, FDM_F
+#if ! defined(NO_SAVE_RESTORE)
+      INCLUDE 'mumps_save_restore_modes.h'
+#endif
       CONTAINS
 C
       SUBROUTINE MUMPS_FDM_INIT(WHAT, INITIAL_SIZE, INFO)
@@ -373,6 +378,7 @@ C
       RETURN
       END SUBROUTINE MUMPS_FDM_SET_ALL_FREE
 C
+#if ! defined(NO_SAVE_RESTORE)
 !     ---------- MUMPS_SAVE_RESTORE_FRONT_DATA ----------------------- !
       SUBROUTINE MUMPS_SAVE_RESTORE_FRONT_DATA(id_FDM_F_ENCODING
      &                 ,unit,MYID,mode
@@ -409,8 +415,8 @@ C
 C     INFO                : copies of of INFO(1) and INFO(2) to allow save/restore of failled instaces
 C      
       CHARACTER, DIMENSION(:), POINTER :: id_FDM_F_ENCODING
-      INTEGER,intent(IN)::unit,MYID
-      CHARACTER(len=*),intent(IN) :: mode
+      INTEGER,intent(IN) :: unit,MYID
+      INTEGER,intent(IN) :: mode
       INTEGER,INTENT(OUT) :: SIZE_GEST
       INTEGER(8),intent(OUT) :: SIZE_VARIABLES
       INTEGER(8),intent(IN) :: TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
@@ -426,32 +432,32 @@ C
       SIZE_VARIABLES_FDM_F=0_8
       SIZE_GEST=0
       SIZE_VARIABLES=0_8
-      if((trim(mode).EQ."memory_save").OR.(trim(mode).EQ."save")) then
+      if((mode.EQ.memory_save_mode).OR.(mode.EQ.save_mode)) then
          call MUMPS_FDM_STRUC_TO_MOD("F",id_FDM_F_ENCODING)
       endif
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          CALL MUMPS_SAVE_RESTORE_FDM_STRUC(
      &        FDM_F
-     &        ,unit,MYID,"memory_save"
+     &        ,unit,MYID,memory_save_mode
      &        ,SIZE_GEST_FDM_F
      &        ,SIZE_VARIABLES_FDM_F
      &        ,SIZE_INT,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
      &        ,size_read,size_allocated,size_written
      &        ,INFO)
-      elseif(trim(mode).EQ."save") then
+      elseif(mode.EQ.save_mode) then
          CALL MUMPS_SAVE_RESTORE_FDM_STRUC(
      &        FDM_F
-     &        ,unit,MYID,"save"
+     &        ,unit,MYID,save_mode
      &        ,SIZE_GEST_FDM_F
      &        ,SIZE_VARIABLES_FDM_F
      &        ,SIZE_INT,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
      &        ,size_read,size_allocated,size_written
      &        ,INFO)
          IF ( INFO(1) .LT. 0 ) GOTO 100
-      elseif(trim(mode).EQ."restore") then
+      elseif(mode.EQ.restore_mode) then
          CALL MUMPS_SAVE_RESTORE_FDM_STRUC(
      &        FDM_F
-     &        ,unit,MYID,"restore"
+     &        ,unit,MYID,restore_mode
      &        ,SIZE_GEST_FDM_F
      &        ,SIZE_VARIABLES_FDM_F
      &        ,SIZE_INT, TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
@@ -459,7 +465,7 @@ C
      &        ,INFO)
          IF ( INFO(1) .LT. 0 ) GOTO 100
       endif
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
 C     If the size to write (SIZE_VARIABLES) is greater than 2^31
 C     Subrecords are created which need to be taken into account in
 C     the file size computation
@@ -467,14 +473,14 @@ C     the file size computation
          IF(NbSubRecords.GT.0) then
             NbRecords=NbRecords+NbSubRecords
          ENDIF
-      elseif(trim(mode).EQ."save") then
+      elseif(mode.EQ.save_mode) then
          size_written=size_written+SIZE_VARIABLES
      &        +int(SIZE_GEST,kind=8)
 #if defined(MUMPS_NOF2003)
          size_written=size_written
      &        +int(2*SIZE_INT*NbRecords,kind=8)
 #endif
-      elseif(trim(mode).EQ."restore") then
+      elseif(mode.EQ.restore_mode) then
          size_allocated=size_allocated+SIZE_VARIABLES
          size_read=size_read+SIZE_VARIABLES
      &        +int(SIZE_GEST,kind=8)
@@ -483,7 +489,7 @@ C     the file size computation
      &        +int(2*SIZE_INT*NbRecords,kind=8)
 #endif
       endif
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          SIZE_VARIABLES=SIZE_VARIABLES+SIZE_VARIABLES_FDM_F
          SIZE_GEST=SIZE_GEST+SIZE_GEST_FDM_F
 #if defined(MUMPS_NOF2003)
@@ -499,7 +505,7 @@ C        for each record
  100  continue
       RETURN
       END SUBROUTINE MUMPS_SAVE_RESTORE_FRONT_DATA
-!     --------------------------------- MUMPS_SAVE_RESTORE_BLR_STRUC ----------------------------- !
+!     ------------------ MUMPS_SAVE_RESTORE_BLR_STRUC ------------ !
       SUBROUTINE MUMPS_SAVE_RESTORE_FDM_STRUC(FDM_STRUC
      &     ,unit,MYID,mode
      &     ,Local_SIZE_GEST,Local_SIZE_VARIABLES
@@ -511,7 +517,8 @@ C  =======
 C  Purpose
 C  =======
 C
-C     This routine is designed to manage a BLR_STRUC_T structure (save, restore, compute memory)
+C     This routine is designed to manage a BLR_STRUC_T structure 
+C     (save, restore, compute memory)
 C     
 C  ==========
 C  Parameters
@@ -521,8 +528,9 @@ C     BLR_STRUC           : TYPE (BLR_ST
 C
 C     unit                : The unit of the file to be written or read
 C
-C     mode                : the type of operation to be performed by the routine 
-C                           memory_save  = compute the size of the save file and of the structure
+C     mode                : the type of operation to be performed by 
+C                           the routine memory_save  = compute the 
+C                           size of the save file and of the structure
 C                           save         = save the instace
 C                           restore      = restore the instace
 C
@@ -532,22 +540,23 @@ C     TOTAL_STRUC_SIZE    : size of the
 C
 C     SIZE_INT            : size of an integer      
 C
-C     INFO1/INFO2         : copies of of INFO(1) and INFO(2) to allow save/restore of failled instaces
+C     INFO1/INFO2         : copies of of INFO(1) and INFO(2) to allow 
+C                           save/restore of failled instaces
 C
       TYPE(FDM_STRUC_T) :: FDM_STRUC
       INTEGER,intent(IN)::unit,MYID
-      CHARACTER(len=*),intent(IN) :: mode
+      INTEGER,intent(IN) :: mode
       INTEGER,INTENT(OUT) :: Local_SIZE_GEST
       INTEGER(8),intent(OUT) :: Local_SIZE_VARIABLES
       INTEGER,intent(INOUT):: INFO(2)
       INTEGER,intent(IN):: SIZE_INT
       INTEGER(8),intent(IN) :: TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
       INTEGER(8),intent(INOUT):: size_read,size_allocated,size_written
-      INTEGER :: NBVARIABLES_FDM_STRUC_T
-      PARAMETER (NBVARIABLES_FDM_STRUC_T = 3)
-      CHARACTER(len=30), dimension(NBVARIABLES_FDM_STRUC_T)::
-     &     VARIABLES_FDM_STRUC_T
-      CHARACTER(len=30) :: TMP_STRING
+C     Done as for mumps_save_restore main structure but here by hand:
+      INTEGER, PARAMETER :: S_NB_FREE_IDX = 1
+      INTEGER, PARAMETER :: S_STACK_FREE_IDX = 2
+      INTEGER, PARAMETER :: S_COUNT_ACCESS = 3
+      INTEGER, PARAMETER :: NBVARIABLES_FDM_STRUC_T = 3
       INTEGER(8),dimension(NBVARIABLES_FDM_STRUC_T)::
      &     SIZE_VARIABLES_FDM_STRUC_T
       INTEGER,dimension(NBVARIABLES_FDM_STRUC_T)::SIZE_GEST_FDM_STRUC_T
@@ -558,9 +567,6 @@ C
       INTEGER:: Local_NbRecords
 #endif
       INTEGER(4) :: I4
-      VARIABLES_FDM_STRUC_T(1)="NB_FREE_IDX"
-      VARIABLES_FDM_STRUC_T(2)="STACK_FREE_IDX"
-      VARIABLES_FDM_STRUC_T(3)="COUNT_ACCESS"
       SIZE_VARIABLES_FDM_STRUC_T(:)=0_8
       SIZE_GEST_FDM_STRUC_T(:)=0
       NbRecords_FDM_STRUC_T(:)=0 
@@ -568,13 +574,12 @@ C
 C     BEGINNING OF THE MAIN LOOP ON ALL VARIABLES OF THE STRUCTURE
 C
       DO i1=1,NBVARIABLES_FDM_STRUC_T 
-         TMP_STRING = VARIABLES_FDM_STRUC_T(i1)
-         SELECT CASE(TMP_STRING)
-         CASE("NB_FREE_IDX")
+         SELECT CASE(i1)
+         CASE(S_NB_FREE_IDX)
             NbRecords_FDM_STRUC_T(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_FDM_STRUC_T(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_FDM_STRUC_T(i1)=SIZE_INT
                write(unit,iostat=err) FDM_STRUC%NB_FREE_IDX
                if(err.ne.0) then
@@ -583,7 +588,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_FDM_STRUC_T(i1)=SIZE_INT
                read(unit,iostat=err) FDM_STRUC%NB_FREE_IDX
                if(err.ne.0) THEN
@@ -593,9 +598,9 @@ C
                endif 
                IF ( INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("STACK_FREE_IDX")
+         CASE(S_STACK_FREE_IDX)
             NbRecords_FDM_STRUC_T(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(FDM_STRUC%STACK_FREE_IDX)) THEN
                   SIZE_GEST_FDM_STRUC_T(i1)=SIZE_INT
                   SIZE_VARIABLES_FDM_STRUC_T(i1)=
@@ -604,7 +609,7 @@ C
                   SIZE_GEST_FDM_STRUC_T(i1)=SIZE_INT*2
                   SIZE_VARIABLES_FDM_STRUC_T(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(FDM_STRUC%STACK_FREE_IDX)) THEN
                   SIZE_GEST_FDM_STRUC_T(i1)=SIZE_INT
                   SIZE_VARIABLES_FDM_STRUC_T(i1)=
@@ -636,7 +641,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(FDM_STRUC%STACK_FREE_IDX)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -670,9 +675,9 @@ C
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("COUNT_ACCESS")
+         CASE(S_COUNT_ACCESS)
             NbRecords_FDM_STRUC_T(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(FDM_STRUC%COUNT_ACCESS)) THEN
                   SIZE_GEST_FDM_STRUC_T(i1)=SIZE_INT
                   SIZE_VARIABLES_FDM_STRUC_T(i1)=
@@ -681,7 +686,7 @@ C
                   SIZE_GEST_FDM_STRUC_T(i1)=SIZE_INT*2
                   SIZE_VARIABLES_FDM_STRUC_T(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(FDM_STRUC%COUNT_ACCESS)) THEN
                   SIZE_GEST_FDM_STRUC_T(i1)=SIZE_INT
                   SIZE_VARIABLES_FDM_STRUC_T(i1)=
@@ -713,7 +718,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(FDM_STRUC%COUNT_ACCESS)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -749,7 +754,7 @@ C
             endif
          CASE DEFAULT
          END SELECT
-         if(trim(mode).EQ."memory_save") then
+         if(mode.EQ.memory_save_mode) then
 C     If the size to write (SIZE_VARIABLES_FDM_STRUC_T(i1)) is greater than 2^31
 C     Subrecords are created which need to be taken into account in
 C     the file size computation
@@ -758,14 +763,14 @@ C     the file size computation
                NbRecords_FDM_STRUC_T(i1)=NbRecords_FDM_STRUC_T(i1)
      &              +NbSubRecords
             ENDIF
-         elseif(trim(mode).EQ."save") then
+         elseif(mode.EQ.save_mode) then
             size_written=size_written+SIZE_VARIABLES_FDM_STRUC_T(i1)
      &           +int(SIZE_GEST_FDM_STRUC_T(i1),kind=8)
 #if defined(MUMPS_NOF2003)
             size_written=size_written
      &           +int(2*SIZE_INT*NbRecords_FDM_STRUC_T(i1),kind=8)
 #endif
-         elseif(trim(mode).EQ."restore") then
+         elseif(mode.EQ.restore_mode) then
             size_allocated=size_allocated+
      &           SIZE_VARIABLES_FDM_STRUC_T(i1)
             size_read=size_read+SIZE_VARIABLES_FDM_STRUC_T(i1)
@@ -776,7 +781,7 @@ C     the file size computation
 #endif
          endif
       ENDDO
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          Local_SIZE_VARIABLES=sum(SIZE_VARIABLES_FDM_STRUC_T)
          Local_SIZE_GEST=sum(SIZE_GEST_FDM_STRUC_T)        
 #if defined(MUMPS_NOF2003)
@@ -787,4 +792,5 @@ C     the file size computation
  100  continue
       RETURN
       END SUBROUTINE MUMPS_SAVE_RESTORE_FDM_STRUC
+#endif       
       END MODULE MUMPS_FRONT_DATA_MGT_M
diff -pruN 5.6.2-2.1/src/lr_common.F 5.7.1-1/src/lr_common.F
--- 5.6.2-2.1/src/lr_common.F	2023-10-11 09:36:35.000000000 +0000
+++ 5.7.1-1/src/lr_common.F	2024-05-02 10:15:14.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -14,9 +14,14 @@ C
       MODULE MUMPS_LR_COMMON
       IMPLICIT NONE
       CONTAINS
-      SUBROUTINE COMPUTE_BLR_VCS(K472, IBCKSZ, MAXSIZE, NASS)
-        INTEGER, INTENT(IN) :: MAXSIZE, NASS, K472
+      SUBROUTINE COMPUTE_BLR_VCS(K472, IBCKSZ, MAXSIZE, NASS,
+     &           NFRONT, K35)
+        INTEGER, INTENT(IN) ::  MAXSIZE, NASS, K472
+        INTEGER, INTENT(IN) ::  NFRONT, K35
         INTEGER, INTENT(OUT) :: IBCKSZ
+        INTEGER k
+        INTEGER    :: LARGEST_IBCKSZ, ADJUSTED_LARGEST
+        INTEGER(4) :: I4
         IF (K472.EQ.1) THEN
 #if defined(__ve__)
           IF (NASS.LE.1000) THEN
@@ -38,11 +43,21 @@ C
           ELSE
             IBCKSZ = 512
           ENDIF
+          IF (NFRONT.GT.20*NASS.AND.NFRONT.GT.100000) THEN
+            IBCKSZ = max(IBCKSZ,min(NASS,512))
+          ENDIF
 #endif
           IBCKSZ = min(IBCKSZ,MAXSIZE)
         ELSE
           IBCKSZ = MAXSIZE
         ENDIF
+        LARGEST_IBCKSZ  = int(dble(huge(I4)-10000000)/
+     &                    (dble(NFRONT)*dble(K35)))
+        k = 3
+        ADJUSTED_LARGEST = int((dble(LARGEST_IBCKSZ)*dble(k*7))/
+     &               dble(8*(k+1)))
+        IBCKSZ = min(IBCKSZ, ADJUSTED_LARGEST)
+      RETURN
       END SUBROUTINE COMPUTE_BLR_VCS
       SUBROUTINE MUMPS_UPD_TREE(NV, NSTEPS, N, FIRST, LPTR, RPTR, F,
      &     VLIST, FILS, FRERE_STEPS, STEP, DAD_STEPS, NE_STEPS, NA, LNA,
diff -pruN 5.6.2-2.1/src/mumps_addr.c 5.7.1-1/src/mumps_addr.c
--- 5.6.2-2.1/src/mumps_addr.c	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_addr.c	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
@@ -15,6 +15,10 @@
  */
 /* Utility to automatically get the sizes of Fortran types */
 #include "mumps_addr.h"
+void  MUMPS_CALL MUMPS_INT_SIZE_C( MUMPS_INT8 *i)
+{
+   *i=sizeof(MUMPS_INT);
+}
 void  MUMPS_CALL MUMPS_SIZE_C(char *a, char *b, MUMPS_INT8 *diff)
 {
     *diff = (MUMPS_INT8) (b - a);
@@ -45,3 +49,11 @@ void MUMPS_CALL MUMPS_SETDVAL_ADDR_C(DMU
 {
 *(DMUMPS_REAL*)*addr=*val;
 }
+void  MUMPS_CALL MUMPS_CLANGAOCC_C( MUMPS_INT8 *i8)
+{
+#if defined(__aocc__)
+   *i8=1;
+#else
+   *i8=0;
+#endif
+}
diff -pruN 5.6.2-2.1/src/mumps_addr.h 5.7.1-1/src/mumps_addr.h
--- 5.6.2-2.1/src/mumps_addr.h	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_addr.h	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
@@ -17,6 +17,9 @@
 #define MUMPS_ADDR_H
 #include "mumps_common.h"
 #include "mumps_c_types.h"
+#define MUMPS_INT_SIZE_C \
+        F_SYMBOL(int_size_c, INT_SIZE_C)
+void  MUMPS_CALL MUMPS_INT_SIZE_C(MUMPS_INT8 *i);
 #define MUMPS_SIZE_C \
         F_SYMBOL(size_c, SIZE_C)
 void  MUMPS_CALL MUMPS_SIZE_C(char *a, char *b, MUMPS_INT8 *diff);
@@ -32,4 +35,7 @@ void MUMPS_CALL MUMPS_SETRVAL_ADDR_C(SMU
 #define MUMPS_SETDVAL_ADDR_C \
         F_SYMBOL(setdval_addr_c, SETDVAL_ADDR_C)
 void MUMPS_CALL MUMPS_SETDVAL_ADDR_C(DMUMPS_REAL *val, MUMPS_INT8 *addr);
+#define MUMPS_CLANGAOCC_C \
+        F_SYMBOL(clangaocc_c, CLANGAOCC_C)
+void MUMPS_CALL MUMPS_CLANGAOCC_C(MUMPS_INT8 *i8);
 #endif
diff -pruN 5.6.2-2.1/src/mumps_c.c 5.7.1-1/src/mumps_c.c
--- 5.6.2-2.1/src/mumps_c.c	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_c.c	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
@@ -126,6 +126,12 @@ MUMPS_F77( MUMPS_INT      *job,
            MUMPS_INT      *blkvar_avail,
            MUMPS_INT      *perm_in,
            MUMPS_INT      *perm_in_avail,
+           MUMPS_INT      *rowind,
+           MUMPS_INT      *rowind_avail,
+           MUMPS_INT      *colind,
+           MUMPS_INT      *colind_avail,
+           MUMPS_COMPLEX  *pivots,
+           MUMPS_INT      *pivots_avail,
            MUMPS_COMPLEX  *rhs,
            MUMPS_INT      *rhs_avail,
            MUMPS_COMPLEX  *redrhs,
@@ -169,6 +175,7 @@ MUMPS_F77( MUMPS_INT      *job,
            MUMPS_INT      *lsol_loc,
            MUMPS_INT      *nloc_rhs,
            MUMPS_INT      *lrhs_loc,
+           MUMPS_INT      *nsol_loc,
            MUMPS_INT      *schur_mloc,
            MUMPS_INT      *schur_nloc,
            MUMPS_INT      *schur_lld,
@@ -176,16 +183,21 @@ MUMPS_F77( MUMPS_INT      *job,
            MUMPS_INT      *schur_nblock,
            MUMPS_INT      *schur_nprow,
            MUMPS_INT      *schur_npcol,
+           MUMPS_INT      *ld_rhsintr,
            MUMPS_INT      *ooc_tmpdir,
            MUMPS_INT      *ooc_prefix,
            MUMPS_INT      *write_problem,
+#if ! defined(NO_SAVE_RESTORE)
            MUMPS_INT      *save_dir,
            MUMPS_INT      *save_prefix,
+#endif
            MUMPS_INT      *ooc_tmpdirlen,
            MUMPS_INT      *ooc_prefixlen,
            MUMPS_INT      *write_problemlen,
+#if ! defined(NO_SAVE_RESTORE)
            MUMPS_INT      *save_dirlen,
            MUMPS_INT      *save_prefixlen,
+#endif
            MUMPS_INT      *metis_options
            );
 /*
@@ -193,22 +205,48 @@ MUMPS_F77( MUMPS_INT      *job,
  * might also be changed on return by MUMPS_ASSIGN_COLSCA/ROWSCA
  * NB: They are put here because they use MUMPS_REAL and need thus
  * one symbol per arithmetic.
+ * COLSCA_LOC and ROWSCA_LOC are also static. However, they are built
+ * at the end of the factorization and are always out arguments, they
+ * cannot be input.
+ * RHSINTR is the intermediate right-hand side. It is always allocated
+ * by MUMPS, although its content can be set or modified by the user.
+ * But the address of RHSINTR is out.
  */
 #if MUMPS_ARITH == MUMPS_ARITH_s
 # define MUMPS_COLSCA_STATIC SMUMPS_COLSCA_STATIC
 # define MUMPS_ROWSCA_STATIC SMUMPS_ROWSCA_STATIC
+# define MUMPS_COLSCA_LOC_STATIC SMUMPS_COLSCA_LOC_STATIC
+# define MUMPS_ROWSCA_LOC_STATIC SMUMPS_ROWSCA_LOC_STATIC
+# define MUMPS_RHSINTR_STATIC SMUMPS_RHSINTR_STATIC
+# define MUMPS_SINGULAR_VALUES_STATIC SMUMPS_SINGULAR_VALUES_STATIC
 #elif MUMPS_ARITH == MUMPS_ARITH_d
 # define MUMPS_COLSCA_STATIC DMUMPS_COLSCA_STATIC
 # define MUMPS_ROWSCA_STATIC DMUMPS_ROWSCA_STATIC
+# define MUMPS_COLSCA_LOC_STATIC DMUMPS_COLSCA_LOC_STATIC
+# define MUMPS_ROWSCA_LOC_STATIC DMUMPS_ROWSCA_LOC_STATIC
+# define MUMPS_RHSINTR_STATIC DMUMPS_RHSINTR_STATIC
+# define MUMPS_SINGULAR_VALUES_STATIC DMUMPS_SINGULAR_VALUES_STATIC
 #elif MUMPS_ARITH == MUMPS_ARITH_c
 # define MUMPS_COLSCA_STATIC CMUMPS_COLSCA_STATIC
 # define MUMPS_ROWSCA_STATIC CMUMPS_ROWSCA_STATIC
+# define MUMPS_COLSCA_LOC_STATIC CMUMPS_COLSCA_LOC_STATIC
+# define MUMPS_ROWSCA_LOC_STATIC CMUMPS_ROWSCA_LOC_STATIC
+# define MUMPS_RHSINTR_STATIC CMUMPS_RHSINTR_STATIC
+# define MUMPS_SINGULAR_VALUES_STATIC CMUMPS_SINGULAR_VALUES_STATIC
 #elif MUMPS_ARITH == MUMPS_ARITH_z
 # define MUMPS_COLSCA_STATIC ZMUMPS_COLSCA_STATIC
 # define MUMPS_ROWSCA_STATIC ZMUMPS_ROWSCA_STATIC
+# define MUMPS_COLSCA_LOC_STATIC ZMUMPS_COLSCA_LOC_STATIC
+# define MUMPS_ROWSCA_LOC_STATIC ZMUMPS_ROWSCA_LOC_STATIC
+# define MUMPS_RHSINTR_STATIC ZMUMPS_RHSINTR_STATIC
+# define MUMPS_SINGULAR_VALUES_STATIC ZMUMPS_SINGULAR_VALUES_STATIC
 #endif
 static MUMPS_REAL * MUMPS_COLSCA_STATIC;
 static MUMPS_REAL * MUMPS_ROWSCA_STATIC;
+static MUMPS_REAL * MUMPS_COLSCA_LOC_STATIC;
+static MUMPS_REAL * MUMPS_ROWSCA_LOC_STATIC;
+static MUMPS_COMPLEX * MUMPS_RHSINTR_STATIC;
+static MUMPS_REAL * MUMPS_SINGULAR_VALUES_STATIC;
 #define MUMPS_ASSIGN_COLSCA \
     F_SYM_ARITH(assign_colsca,ASSIGN_COLSCA)
 void MUMPS_CALL
@@ -237,6 +275,62 @@ MUMPS_NULLIFY_C_ROWSCA()
 {
   MUMPS_ROWSCA_STATIC = 0;
 }
+#define MUMPS_ASSIGN_COLSCA_LOC \
+    F_SYM_ARITH(assign_colsca_loc,ASSIGN_COLSCA_LOC)
+void MUMPS_CALL
+MUMPS_ASSIGN_COLSCA_LOC(MUMPS_REAL * f77colsca_loc)
+{
+  MUMPS_COLSCA_LOC_STATIC = f77colsca_loc;
+}
+#define MUMPS_NULLIFY_C_COLSCA_LOC \
+    F_SYM_ARITH(nullify_c_colsca_loc,NULLIFY_C_COLSCA_LOC)
+void MUMPS_CALL
+MUMPS_NULLIFY_C_COLSCA_LOC()
+{
+  MUMPS_COLSCA_LOC_STATIC = 0;
+}
+#define MUMPS_ASSIGN_ROWSCA_LOC \
+    F_SYM_ARITH(assign_rowsca_loc,ASSIGN_ROWSCA_LOC)
+void MUMPS_CALL
+MUMPS_ASSIGN_ROWSCA_LOC(MUMPS_REAL * f77rowsca_loc)
+{
+  MUMPS_ROWSCA_LOC_STATIC = f77rowsca_loc;
+}
+#define MUMPS_NULLIFY_C_ROWSCA_LOC \
+    F_SYM_ARITH(nullify_c_rowsca_loc,NULLIFY_C_ROWSCA_LOC)
+void MUMPS_CALL
+MUMPS_NULLIFY_C_ROWSCA_LOC()
+{
+  MUMPS_ROWSCA_LOC_STATIC = 0;
+}
+#define MUMPS_ASSIGN_RHSINTR \
+    F_SYM_ARITH(assign_rhsintr,ASSIGN_RHSINTR)
+void MUMPS_CALL
+MUMPS_ASSIGN_RHSINTR(MUMPS_COMPLEX * f77rhsintr)
+{
+  MUMPS_RHSINTR_STATIC = f77rhsintr;
+}
+#define MUMPS_NULLIFY_C_RHSINTR \
+    F_SYM_ARITH(nullify_c_rhsintr,NULLIFY_C_RHSINTR)
+void MUMPS_CALL
+MUMPS_NULLIFY_C_RHSINTR()
+{
+  MUMPS_RHSINTR_STATIC = 0;
+}
+#define MUMPS_ASSIGN_SINGULAR_VALUES \
+    F_SYM_ARITH(assign_singular_values,ASSIGN_SINGULAR_VALUES)
+void MUMPS_CALL
+MUMPS_ASSIGN_SINGULAR_VALUES(MUMPS_REAL * f77singular_values)
+{
+  MUMPS_SINGULAR_VALUES_STATIC = f77singular_values;
+}
+#define MUMPS_NULLIFY_C_SING_VALUES \
+    F_SYM_ARITH(nullify_c_sing_values,NULLIFY_C_SING_VALUES)
+void MUMPS_CALL
+MUMPS_NULLIFY_C_SING_VALUES()
+{
+  MUMPS_SINGULAR_VALUES_STATIC = 0;
+}
 /* FIXME: move CMUMPS_SET_TMP_PTR to another file */
 #define MUMPS_SET_TMP_PTR \
     F_SYM_ARITH(set_tmp_ptr,SET_TMP_PTR) /* Fortran routine <arith>MUMPS_SET_TMP_PTR called from C */
@@ -287,6 +381,8 @@ mumps_c(MUMPS_STRUC_C * mumps_par)
     MUMPS_INT *perm_in; MUMPS_INT perm_in_avail;
     MUMPS_INT *listvar_schur; MUMPS_INT listvar_schur_avail;
     MUMPS_COMPLEX *schur; MUMPS_INT schur_avail;
+    MUMPS_INT *rowind; MUMPS_INT *colind; MUMPS_COMPLEX *pivots;
+    MUMPS_INT rowind_avail; MUMPS_INT colind_avail; MUMPS_INT pivots_avail;
     MUMPS_COMPLEX *rhs; MUMPS_COMPLEX *redrhs;
     MUMPS_COMPLEX *wk_user; MUMPS_INT wk_user_avail;
     MUMPS_REAL *colsca; MUMPS_REAL *rowsca;
@@ -305,9 +401,11 @@ mumps_c(MUMPS_STRUC_C * mumps_par)
     MUMPS_INT irhs_sparse_avail, isol_loc_avail, irhs_loc_avail;
     MUMPS_INT *info; MUMPS_INT *infog;
     MUMPS_REAL *rinfo; MUMPS_REAL *rinfog;
-    MUMPS_INT ooc_tmpdir[255]; MUMPS_INT ooc_prefix[63];
-    MUMPS_INT write_problem[255];
-    MUMPS_INT save_dir[255]; MUMPS_INT save_prefix[255];
+    MUMPS_INT ooc_tmpdir[1023]; MUMPS_INT ooc_prefix[255];
+    MUMPS_INT write_problem[1023];
+#if ! defined(NO_SAVE_RESTORE)
+    MUMPS_INT save_dir[1023]; MUMPS_INT save_prefix[255];
+#endif
     /* Other local variables */
     MUMPS_INT idummy; MUMPS_INT *idummyp;
     MUMPS_REAL rdummy; MUMPS_REAL *rdummyp;
@@ -315,8 +413,10 @@ mumps_c(MUMPS_STRUC_C * mumps_par)
     /* String lengths to be passed to Fortran by address */
     MUMPS_INT ooc_tmpdirlen;
     MUMPS_INT ooc_prefixlen;
+#if ! defined(NO_SAVE_RESTORE)
     MUMPS_INT save_dirlen;
     MUMPS_INT save_prefixlen;
+#endif
     MUMPS_INT write_problemlen;
     MUMPS_INT *metis_options;
     int i;
@@ -331,50 +431,60 @@ mumps_c(MUMPS_STRUC_C * mumps_par)
      * strictly necessary. */
     MUMPS_COLSCA_STATIC=0;
     MUMPS_ROWSCA_STATIC=0;
+    MUMPS_COLSCA_LOC_STATIC=0;
+    MUMPS_ROWSCA_LOC_STATIC=0;
+    MUMPS_SINGULAR_VALUES_STATIC=0;
     /* Initialize pointers to zero for job == -1 */
     if ( mumps_par->job == -1 )
       { /* job = -1: we just reset all pointers to 0 */
         mumps_par->irn=0; mumps_par->jcn=0; mumps_par->a=0; mumps_par->rhs=0; mumps_par->wk_user=0;
         mumps_par->redrhs=0;
-        mumps_par->eltptr=0; mumps_par->eltvar=0; mumps_par->a_elt=0; mumps_par->blkptr=0; mumps_par->blkvar=0; mumps_par->perm_in=0; mumps_par->sym_perm=0; mumps_par->uns_perm=0; mumps_par->irn_loc=0;mumps_par->jcn_loc=0;mumps_par->a_loc=0; mumps_par->listvar_schur=0;mumps_par->schur=0;mumps_par->mapping=0;mumps_par->pivnul_list=0;mumps_par->colsca=0;mumps_par->colsca_from_mumps=0;mumps_par->rowsca=0;mumps_par->rowsca_from_mumps=0; mumps_par->rhs_sparse=0; mumps_par->irhs_sparse=0; mumps_par->sol_loc=0; mumps_par->rhs_loc=0; mumps_par->irhs_ptr=0; mumps_par->isol_loc=0; mumps_par->irhs_loc=0;
+        mumps_par->rowind=0; mumps_par->colind=0; mumps_par->pivots=0;
+        mumps_par->eltptr=0; mumps_par->eltvar=0; mumps_par->a_elt=0; mumps_par->blkptr=0; mumps_par->blkvar=0; mumps_par->perm_in=0; mumps_par->sym_perm=0; mumps_par->uns_perm=0; mumps_par->irn_loc=0;mumps_par->jcn_loc=0;mumps_par->a_loc=0; mumps_par->listvar_schur=0;mumps_par->schur=0;mumps_par->mapping=0;mumps_par->pivnul_list=0;mumps_par->colsca=0;mumps_par->colsca_from_mumps=0;mumps_par->rowsca=0;mumps_par->rowsca_from_mumps=0; mumps_par->colsca_loc=0; mumps_par->rowsca_loc=0; mumps_par->rhs_sparse=0; mumps_par->irhs_sparse=0; mumps_par->sol_loc=0; mumps_par->rhs_loc=0; mumps_par->irhs_ptr=0; mumps_par->isol_loc=0; mumps_par->irhs_loc=0; mumps_par->rhsintr=0; mumps_par->glob2loc_rhs=0; mumps_par->glob2loc_sol=0; mumps_par->singular_values=0;
         strcpy(mumps_par->ooc_tmpdir,"NAME_NOT_INITIALIZED");
         strcpy(mumps_par->ooc_prefix,"NAME_NOT_INITIALIZED");
         strcpy(mumps_par->write_problem,"NAME_NOT_INITIALIZED");
+#if ! defined(NO_SAVE_RESTORE)
         strcpy(mumps_par->save_dir,"NAME_NOT_INITIALIZED");
         strcpy(mumps_par->save_prefix,"NAME_NOT_INITIALIZED");
+#endif
         strncpy(mumps_par->version_number,MUMPS_VERSION,MUMPS_VERSION_MAX_LEN);
         mumps_par->version_number[MUMPS_VERSION_MAX_LEN+1] = '\0';
         /* Next line initializes scalars to arbitrary values.
          * Some of those will anyway be overwritten during the
          * call to Fortran routine [SDCZ]MUMPS_INIT_PHASE */
-        mumps_par->n=0; mumps_par->nblk=0; mumps_par->nz=0; mumps_par->nnz=0; mumps_par->nz_loc=0; mumps_par->nnz_loc=0; mumps_par->nelt=0;mumps_par->instance_number=0;mumps_par->deficiency=0;mumps_par->lwk_user=0;mumps_par->size_schur=0;mumps_par->lrhs=0; mumps_par->lredrhs=0; mumps_par->nrhs=0; mumps_par->nz_rhs=0; mumps_par->lsol_loc=0; mumps_par->nloc_rhs=0; mumps_par->lrhs_loc=0;
- mumps_par->schur_mloc=0; mumps_par->schur_nloc=0; mumps_par->schur_lld=0; mumps_par->mblock=0; mumps_par->nblock=0; mumps_par->nprow=0; mumps_par->npcol=0;
+        mumps_par->n=0; mumps_par->nblk=0; mumps_par->nz=0; mumps_par->nnz=0; mumps_par->nz_loc=0; mumps_par->nnz_loc=0; mumps_par->nelt=0;mumps_par->instance_number=0;mumps_par->deficiency=0;mumps_par->lwk_user=0;mumps_par->size_schur=0;mumps_par->lrhs=0; mumps_par->lredrhs=0; mumps_par->nrhs=0; mumps_par->nz_rhs=0; mumps_par->lsol_loc=0; mumps_par->nloc_rhs=0; mumps_par->lrhs_loc=0; mumps_par->nsol_loc=0;
+ mumps_par->schur_mloc=0; mumps_par->schur_nloc=0; mumps_par->schur_lld=0; mumps_par->mblock=0; mumps_par->nblock=0; mumps_par->nprow=0; mumps_par->npcol=0; mumps_par->ld_rhsintr=0;
       }
      ooc_tmpdirlen=(int)strlen(mumps_par->ooc_tmpdir);
      ooc_prefixlen=(int)strlen(mumps_par->ooc_prefix);
      write_problemlen=(int)strlen(mumps_par->write_problem);
+#if ! defined(NO_SAVE_RESTORE)
      save_dirlen   =(int)strlen(mumps_par->save_dir);
      save_prefixlen=(int)strlen(mumps_par->save_prefix);
+#endif
     /* Avoid the use of strnlen which may not be
      * available on all systems. Allow strings without
      * \0 at the end, if the file is not found, the
      * Fortran layer is responsible for raising an
      * error.  */
-    if(ooc_tmpdirlen > 255){
-        ooc_tmpdirlen=255;
+    if(ooc_tmpdirlen > 1023){
+        ooc_tmpdirlen=1023;
       }
-    if(ooc_prefixlen > 63){
-        ooc_prefixlen=63;
+    if(ooc_prefixlen > 255){
+        ooc_prefixlen=255;
       }
-    if(write_problemlen > 255){
-        write_problemlen=255;
+    if(write_problemlen > 1023){
+	write_problemlen=1023;
       }
-    if(save_dirlen > 255){
-        save_dirlen=255;
+#if ! defined(NO_SAVE_RESTORE)
+    if(save_dirlen > 1023){
+        save_dirlen=1023;
       }
     if(save_prefixlen > 255){
         save_prefixlen=255;
       }
+#endif
     /*
      * Extract info from the C structure to call the F77 interface. The
      * following macro avoids repeating the same code with risks of errors.
@@ -395,6 +505,9 @@ mumps_c(MUMPS_STRUC_C * mumps_par)
     EXTRACT_POINTERS(irn,idummyp);
     EXTRACT_POINTERS(jcn,idummyp);
     EXTRACT_POINTERS(rhs,cdummyp);
+    EXTRACT_POINTERS(rowind,idummyp);
+    EXTRACT_POINTERS(colind,idummyp);
+    EXTRACT_POINTERS(pivots,cdummyp);
     EXTRACT_POINTERS(wk_user,cdummyp);
     EXTRACT_POINTERS(redrhs,cdummyp);
     EXTRACT_POINTERS(irn_loc,idummyp);
@@ -474,12 +587,14 @@ mumps_c(MUMPS_STRUC_C * mumps_par)
     for(i=0;i<write_problemlen;i++){
       write_problem[i]=(int)mumps_par->write_problem[i];
     }
+#if ! defined(NO_SAVE_RESTORE)
     for(i=0;i<save_dirlen;i++){
       save_dir[i]=(int)mumps_par->save_dir[i];
     }
     for(i=0;i<save_prefixlen;i++){
       save_prefix[i]=(int)mumps_par->save_prefix[i];
     }
+#endif
     metis_options = mumps_par->metis_options;
     /* Call F77 interface */
     MUMPS_F77(&(mumps_par->job), &(mumps_par->sym), &(mumps_par->par), &(mumps_par->comm_fortran),
@@ -488,7 +603,7 @@ mumps_c(MUMPS_STRUC_C * mumps_par)
           &(mumps_par->nz_loc), &(mumps_par->nnz_loc), irn_loc, &irn_loc_avail, jcn_loc, &jcn_loc_avail,
           a_loc, &a_loc_avail,
           &(mumps_par->nelt), eltptr, &eltptr_avail, eltvar, &eltvar_avail, a_elt, &a_elt_avail, blkptr, &blkptr_avail, blkvar, &blkvar_avail,
-          perm_in, &perm_in_avail,
+          perm_in, &perm_in_avail, rowind, &rowind_avail, colind, &colind_avail, pivots, &pivots_avail,
           rhs, &rhs_avail, redrhs, &redrhs_avail, info, rinfo, infog, rinfog,
           &(mumps_par->deficiency), &(mumps_par->lwk_user), &(mumps_par->size_schur), listvar_schur, &listvar_schur_avail, schur,
           &schur_avail, wk_user, &wk_user_avail, colsca, &colsca_avail, rowsca, &rowsca_avail,
@@ -496,7 +611,7 @@ mumps_c(MUMPS_STRUC_C * mumps_par)
           &(mumps_par->lredrhs),
           rhs_sparse, &rhs_sparse_avail, sol_loc, &sol_loc_avail, rhs_loc, &rhs_loc_avail, irhs_sparse,
           &irhs_sparse_avail, irhs_ptr, &irhs_ptr_avail, isol_loc,
-          &isol_loc_avail, irhs_loc, &irhs_loc_avail, &(mumps_par->nz_rhs), &(mumps_par->lsol_loc), &(mumps_par->lrhs_loc), &(mumps_par->nloc_rhs)
+          &isol_loc_avail, irhs_loc, &irhs_loc_avail, &(mumps_par->nz_rhs), &(mumps_par->lsol_loc), &(mumps_par->lrhs_loc), &(mumps_par->nsol_loc), &(mumps_par->nloc_rhs)
           , &(mumps_par->schur_mloc)
           , &(mumps_par->schur_nloc)
           , &(mumps_par->schur_lld)
@@ -504,16 +619,21 @@ mumps_c(MUMPS_STRUC_C * mumps_par)
           , &(mumps_par->nblock)
           , &(mumps_par->nprow)
           , &(mumps_par->npcol)
+          , &(mumps_par->ld_rhsintr)
           , ooc_tmpdir
           , ooc_prefix
           , write_problem
+#if ! defined(NO_SAVE_RESTORE)
           , save_dir
           , save_prefix
+#endif
           , &ooc_tmpdirlen
           , &ooc_prefixlen
           , &write_problemlen
+#if ! defined(NO_SAVE_RESTORE)
           , &save_dirlen
           , &save_prefixlen
+#endif
           , metis_options    
     );
     /*
@@ -532,6 +652,11 @@ mumps_c(MUMPS_STRUC_C * mumps_par)
     /* to get permutations computed during analysis */
     mumps_par->sym_perm=mumps_get_sym_perm();
     mumps_par->uns_perm=mumps_get_uns_perm();
+    /* colsca_loc and rowsca_loc are always out */
+    mumps_par->colsca_loc=MUMPS_COLSCA_LOC_STATIC;
+    mumps_par->rowsca_loc=MUMPS_ROWSCA_LOC_STATIC;
+    /* singular_values is always out */
+    mumps_par->singular_values=MUMPS_SINGULAR_VALUES_STATIC;
     /*
      * colsca/rowsca can either be user data or have been modified
      * within mumps by calls to MUMPS_ASSIGN_COLSCA and/or
@@ -558,6 +683,10 @@ mumps_c(MUMPS_STRUC_C * mumps_par)
     }
     /*
      * Decode OOC_TMPDIR and OOC_PREFIX
+     * This is because they may have been set internally during MUMPS_F77
+#if ! defined(NO_SAVE_RESTORE)
+     * (which is not the case for save_prefix and save_dir)
+#endif
      */
     for(i=0;i<ooc_tmpdirlen;i++){
       mumps_par->ooc_tmpdir[i]=(char)ooc_tmpdir[i];
diff -pruN 5.6.2-2.1/src/mumps_comm_ibcast.F 5.7.1-1/src/mumps_comm_ibcast.F
--- 5.6.2-2.1/src/mumps_comm_ibcast.F	2023-10-11 09:36:35.000000000 +0000
+++ 5.7.1-1/src/mumps_comm_ibcast.F	2024-05-02 10:15:13.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/mumps_common.c 5.7.1-1/src/mumps_common.c
--- 5.6.2-2.1/src/mumps_common.c	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_common.c	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
@@ -21,6 +21,8 @@ static MUMPS_INT * MUMPS_PIVNUL_LIST;
 /* as uns_perm and sym_perm */
 static MUMPS_INT * MUMPS_SYM_PERM;
 static MUMPS_INT * MUMPS_UNS_PERM;
+static MUMPS_INT * MUMPS_GLOB2LOC_RHS;
+static MUMPS_INT * MUMPS_GLOB2LOC_SOL;
 MUMPS_INT*
 mumps_get_mapping()
 {
@@ -81,6 +83,36 @@ MUMPS_NULLIFY_C_UNS_PERM()
 {
     MUMPS_UNS_PERM = 0;
 }
+MUMPS_INT*
+mumps_get_glob2loc_rhs()
+{
+    return MUMPS_GLOB2LOC_RHS;
+}
+void MUMPS_CALL
+MUMPS_ASSIGN_GLOB2LOC_RHS(MUMPS_INT * f77glob2loc_rhs)
+{
+    MUMPS_GLOB2LOC_RHS = f77glob2loc_rhs;
+}
+void MUMPS_CALL
+MUMPS_NULLIFY_C_GLOB2LOC_RHS()
+{
+    MUMPS_GLOB2LOC_RHS = 0;
+}
+MUMPS_INT*
+mumps_get_glob2loc_sol()
+{
+    return MUMPS_GLOB2LOC_SOL;
+}
+void MUMPS_CALL
+MUMPS_ASSIGN_GLOB2LOC_SOL(MUMPS_INT * f77glob2loc_sol)
+{
+    MUMPS_GLOB2LOC_SOL = f77glob2loc_sol;
+}
+void MUMPS_CALL
+MUMPS_NULLIFY_C_GLOB2LOC_SOL()
+{
+    MUMPS_GLOB2LOC_SOL = 0;
+}
 void MUMPS_CALL
 MUMPS_ICOPY_32TO64_64C_IP_C(MUMPS_INT *inouttab, MUMPS_INT8 *sizetab)
 /* Copies in-place *sizetab int values starting at address inouttab
diff -pruN 5.6.2-2.1/src/mumps_common.h 5.7.1-1/src/mumps_common.h
--- 5.6.2-2.1/src/mumps_common.h	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_common.h	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
@@ -76,6 +76,26 @@ MUMPS_ASSIGN_SYM_PERM(MUMPS_INT * f77sym
     F_SYMBOL(nullify_c_sym_perm,NULLIFY_C_SYM_PERM)
 void MUMPS_CALL
 MUMPS_NULLIFY_C_SYM_PERM();
+MUMPS_INT*
+mumps_get_glob2loc_rhs();
+#define MUMPS_ASSIGN_GLOB2LOC_RHS \
+    F_SYMBOL(assign_glob2loc_rhs,ASSIGN_GLOB2LOC_RHS)
+void MUMPS_CALL
+MUMPS_ASSIGN_GLOB2LOC_RHS(MUMPS_INT * f77glob2loc_rhs);
+#define MUMPS_NULLIFY_C_GLOB2LOC_RHS \
+    F_SYMBOL(nullify_c_glob2loc_rhs,NULLIFY_C_GLOB2LOC_RHS)
+void MUMPS_CALL
+MUMPS_NULLIFY_C_GLOB2LOC_RHS();
+MUMPS_INT*
+mumps_get_glob2loc_sol();
+#define MUMPS_ASSIGN_GLOB2LOC_SOL \
+    F_SYMBOL(assign_glob2loc_sol,ASSIGN_GLOB2LOC_SOL)
+void MUMPS_CALL
+MUMPS_ASSIGN_GLOB2LOC_SOL(MUMPS_INT * f77glob2loc_sol);
+#define MUMPS_NULLIFY_C_GLOB2LOC_SOL \
+    F_SYMBOL(nullify_c_glob2loc_sol,NULLIFY_C_GLOB2LOC_SOL)
+void MUMPS_CALL
+MUMPS_NULLIFY_C_GLOB2LOC_SOL();
 #define MUMPS_ICOPY_32TO64_64C_IP_C \
     F_SYMBOL(icopy_32to64_64c_ip_c,ICOPY_32TO64_64C_IP_C)
 void MUMPS_CALL
diff -pruN 5.6.2-2.1/src/mumps_config_file_C.c 5.7.1-1/src/mumps_config_file_C.c
--- 5.6.2-2.1/src/mumps_config_file_C.c	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_config_file_C.c	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/mumps_config_file_C.h 5.7.1-1/src/mumps_config_file_C.h
--- 5.6.2-2.1/src/mumps_config_file_C.h	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_config_file_C.h	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/mumps_headers.h 5.7.1-1/src/mumps_headers.h
--- 5.6.2-2.1/src/mumps_headers.h	2023-10-11 09:36:35.000000000 +0000
+++ 5.7.1-1/src/mumps_headers.h	2024-05-02 10:15:14.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/mumps_int_def32_h.in 5.7.1-1/src/mumps_int_def32_h.in
--- 5.6.2-2.1/src/mumps_int_def32_h.in	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_int_def32_h.in	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/mumps_int_def64_h.in 5.7.1-1/src/mumps_int_def64_h.in
--- 5.6.2-2.1/src/mumps_int_def64_h.in	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_int_def64_h.in	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/mumps_io.c 5.7.1-1/src/mumps_io.c
--- 5.6.2-2.1/src/mumps_io.c	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_io.c	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
@@ -198,8 +198,8 @@ MUMPS_LOW_LEVEL_INIT_TMPDIR(MUMPS_INT *d
 /*   mumps_io_last_file_opened=-1; */
 void MUMPS_CALL
 MUMPS_LOW_LEVEL_INIT_OOC_C(MUMPS_INT *_myid, MUMPS_INT *total_size_io, MUMPS_INT *size_element,
-                           MUMPS_INT *async, MUMPS_INT *k211, MUMPS_INT *nb_file_type,
-                           MUMPS_INT *flag_tab, MUMPS_INT *ierr)
+                           MUMPS_INT *async, MUMPS_INT *keep211, MUMPS_INT *nb_file_type,
+                           MUMPS_INT *flag_tab, MUMPS_INT *keep255, MUMPS_INT *ierr )
 {
   char buf[128]; /* for error message */
   MUMPS_INT myid_loc,async_loc,size_element_loc,nb_file_type_loc,*flag_tab_loc;
@@ -237,7 +237,7 @@ MUMPS_LOW_LEVEL_INIT_OOC_C(MUMPS_INT *_m
 #endif
   total_vol=0;
   mumps_io_flag_async=async_loc;
-  mumps_io_k211=(MUMPS_INT)*k211;
+  mumps_io_k211=(MUMPS_INT)*keep211;
   if (MUMPS_OOC_STORE_PREFIXLEN==-1) {
     *ierr=-92;
     mumps_io_error((MUMPS_INT)*ierr,"Error: prefix not initialized\n");
@@ -261,7 +261,8 @@ MUMPS_LOW_LEVEL_INIT_OOC_C(MUMPS_INT *_m
    */
   MUMPS_OOC_STORE_PREFIXLEN=-1;
   MUMPS_OOC_STORE_TMPDIRLEN=-1;
-  *ierr=(MUMPS_INT)mumps_init_file_structure(&myid_loc,&total_size_io_loc,&size_element_loc,&nb_file_type_loc,flag_tab_loc);
+  *ierr=(MUMPS_INT)mumps_init_file_structure(&myid_loc,&total_size_io_loc,&size_element_loc,
+		   &nb_file_type_loc,flag_tab_loc,*keep255);
   free(flag_tab_loc);
   if(*ierr<0){
     return;
@@ -447,11 +448,8 @@ MUMPS_LOW_LEVEL_DIRECT_READ(void * addre
       if(*ierr<0){
          return;
       }
-    } else {
     }
 #if ! defined(MUMPS_WIN32)
-# if ! defined(WITHOUT_PTHREAD)
-# endif
   gettimeofday(&end_time,NULL);
   mumps_time_spent_in_sync=mumps_time_spent_in_sync+((double)end_time.tv_sec+((double)end_time.tv_usec/1000000))-((double)start_time.tv_sec+((double)start_time.tv_usec/1000000));
 #endif
@@ -463,7 +461,10 @@ void MUMPS_CALL
 MUMPS_CLEAN_IO_DATA_C(MUMPS_INT *myid,MUMPS_INT *step,MUMPS_INT *ierr)
 {
   char buf[64]; /* for error message */
-  MUMPS_INT step_loc,myid_loc,ierr_loc;
+  MUMPS_INT step_loc,myid_loc;
+#if !defined(MUMPS_WIN32) && !defined(WITHOUT_PTHREAD)
+  MUMPS_INT ierr_loc;
+#endif
   step_loc=(MUMPS_INT)*step;
   myid_loc=(MUMPS_INT)*myid;
   if(!mumps_io_is_init_called){
@@ -523,12 +524,6 @@ MUMPS_GET_MAX_NB_REQ_C(MUMPS_INT *max,MU
   return;
 }
 void MUMPS_CALL
-MUMPS_GET_MAX_FILE_SIZE_C(double * max_ooc_file_size)
-{
-  *max_ooc_file_size=(double)(MAX_FILE_SIZE);
-  return;
-}
-void MUMPS_CALL
 MUMPS_OOC_GET_NB_FILES_C(const MUMPS_INT *type,MUMPS_INT *nb_files)
 {
   MUMPS_INT type_loc,nb_files_loc;
@@ -576,19 +571,19 @@ MUMPS_OOC_ALLOC_POINTERS_C(MUMPS_INT *nb
   return;
 }
 void MUMPS_CALL
-MUMPS_OOC_INIT_VARS_C(MUMPS_INT *myid_arg,
-                        MUMPS_INT *size_element,MUMPS_INT *async, MUMPS_INT *k211,
-                        MUMPS_INT *ierr)
+MUMPS_OOC_INIT_VARS_C(MUMPS_INT *myid_arg, MUMPS_INT *size_element, MUMPS_INT *async,
+                      MUMPS_INT *keep211, MUMPS_INT *keep255,
+                      MUMPS_INT *ierr)
 {
   MUMPS_INT size_element_loc,async_loc,myid_arg_loc;
 #if ! defined(MUMPS_WIN32) && ! defined(WITHOUT_PTHREAD)
   mumps_time_spent_in_sync=0;
 #endif
-  mumps_io_k211=(MUMPS_INT)*k211;
+  mumps_io_k211=(MUMPS_INT)*keep211;
   size_element_loc=(MUMPS_INT)*size_element;
   async_loc=(MUMPS_INT)*async;
   myid_arg_loc=(MUMPS_INT)*myid_arg;
-  *ierr=(MUMPS_INT)mumps_io_init_vars(&myid_arg_loc,&size_element_loc,&async_loc);
+  *ierr=(MUMPS_INT)mumps_io_init_vars(&myid_arg_loc,&size_element_loc,&async_loc,*keep255);
   return;
 }
 void MUMPS_CALL
diff -pruN 5.6.2-2.1/src/mumps_io.h 5.7.1-1/src/mumps_io.h
--- 5.6.2-2.1/src/mumps_io.h	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_io.h	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
@@ -26,8 +26,8 @@
  *  MUST be called before low_level_init_ooc_c.
  * 
  */
-#define MUMPS_OOC_PREFIX_MAX_LENGTH 63
-#define MUMPS_OOC_TMPDIR_MAX_LENGTH 255
+#define MUMPS_OOC_PREFIX_MAX_LENGTH 255
+#define MUMPS_OOC_TMPDIR_MAX_LENGTH 1023
 static char MUMPS_OOC_STORE_PREFIX[MUMPS_OOC_PREFIX_MAX_LENGTH];
 static MUMPS_INT  MUMPS_OOC_STORE_PREFIXLEN=-1;
 static char MUMPS_OOC_STORE_TMPDIR[MUMPS_OOC_TMPDIR_MAX_LENGTH];
@@ -58,7 +58,7 @@ mumps_convert_2fint_to_longlong( MUMPS_I
 void MUMPS_CALL
 MUMPS_LOW_LEVEL_INIT_OOC_C(MUMPS_INT *_myid, MUMPS_INT *total_size_io,MUMPS_INT *size_element,
                            MUMPS_INT *async, MUMPS_INT *k211, MUMPS_INT *nb_file_type,
-                           MUMPS_INT *flag_tab , MUMPS_INT* ierr);
+                           MUMPS_INT *flag_tab , MUMPS_INT *keep255, MUMPS_INT* ierr);
 #define MUMPS_TEST_REQUEST_C \
     F_SYMBOL(test_request_c,TEST_REQUEST_C)
 void MUMPS_CALL
@@ -111,10 +111,6 @@ MUMPS_CLEAN_IO_DATA_C(MUMPS_INT *myid,MU
     F_SYMBOL(get_max_nb_req_c,GET_MAX_NB_REQ_C)
 void MUMPS_CALL
 MUMPS_GET_MAX_NB_REQ_C(MUMPS_INT *max,MUMPS_INT *ierr);
-#define MUMPS_GET_MAX_FILE_SIZE_C \
-    F_SYMBOL(get_max_file_size_c,GET_MAX_FILE_SIZE_C)
-void MUMPS_CALL
-MUMPS_GET_MAX_FILE_SIZE_C(double * max_ooc_file_size);
 #define MUMPS_OOC_GET_NB_FILES_C \
     F_SYMBOL(ooc_get_nb_files_c,OOC_GET_NB_FILES_C)
 void MUMPS_CALL
@@ -137,7 +133,7 @@ MUMPS_OOC_ALLOC_POINTERS_C(MUMPS_INT *nb
     F_SYMBOL(ooc_init_vars_c,OOC_INIT_VARS_C)
 void MUMPS_CALL
 MUMPS_OOC_INIT_VARS_C(MUMPS_INT *myid_arg, MUMPS_INT *size_element, MUMPS_INT *async,
-                      MUMPS_INT *k211, MUMPS_INT *ierr);
+                      MUMPS_INT *keep211, MUMPS_INT *keep255, MUMPS_INT *ierr);
 #define MUMPS_OOC_START_LOW_LEVEL \
     F_SYMBOL(ooc_start_low_level,OOC_START_LOW_LEVEL)
 void MUMPS_CALL
diff -pruN 5.6.2-2.1/src/mumps_io_basic.c 5.7.1-1/src/mumps_io_basic.c
--- 5.6.2-2.1/src/mumps_io_basic.c	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_io_basic.c	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
@@ -22,36 +22,66 @@
 #  include <pthread.h>
 pthread_mutex_t mumps_io_pwrite_mutex;
 # endif
-/* int* mumps_io_pfile_pointer_array; */
-/* int* mumps_io_current_file; */
-/* #else /\*MUMPS_WIN32*\/ */
-/* FILE** mumps_io_current_file; */
-/* FILE** mumps_io_pfile_pointer_array; */
 #endif /* MUMPS_WIN32 */
-/* mumps_file_struct* mumps_io_pfile_pointer_array;
-   mumps_file_struct* mumps_io_current_file; */
 mumps_file_type* mumps_files = NULL;
-/* int mumps_io_current_file_number; */
 char* mumps_ooc_file_prefix = NULL;
-/* char** mumps_io_pfile_name; */
-/* int mumps_io_current_file_position; */
-/* int mumps_io_write_pos; */
-/* int mumps_io_last_file_opened; */
 MUMPS_INT mumps_elementary_data_size;
 MUMPS_INT mumps_io_is_init_called;
 MUMPS_INT mumps_io_myid;
-MUMPS_INT mumps_io_max_file_size;
-/* int mumps_io_nb_file; */
+MUMPS_OFF_T mumps_io_max_file_size;
 MUMPS_INT mumps_io_flag_async;
 MUMPS_INT mumps_io_k211;
-/* int mumps_flag_open;*/
-MUMPS_INT mumps_directio_flag;
 MUMPS_INT mumps_io_nb_file_type;
 /* Functions */
+MUMPS_INLINE MUMPS_INT mumps_gen_file_info(long long vaddr, MUMPS_OFF_T * pos, MUMPS_INT * file){
+  *file=(MUMPS_INT)(vaddr/(long long)mumps_io_max_file_size);
+  *pos=(MUMPS_OFF_T)(vaddr%(long long)mumps_io_max_file_size);
+  return 0;
+}
+MUMPS_INLINE void mumps_init_max_file_size(MUMPS_OFF_T * mumps_io_max_file_size, MUMPS_INT keep255){
+  int force_small_files;
+  force_small_files=0;
+  /* Check if file size should be < 2GB */
+  if (sizeof(MUMPS_OFF_T)==4){
+    force_small_files=1; /* should not occur */
+  }
+# if defined(MUMPS_WIN32)
+# if ! defined(MUMPS_WINLARGEFILES)
+  force_small_files=1; /* fseek and fwrite use long which is 32-bit */
+# endif
+# else
+  /* lseek and pread/pwrite (WITH_PFUNC) use off_t */
+  if (sizeof(off_t)==4){
+    force_small_files=1;
+  }
+# endif
+  if (keep255 < 0) {
+   *mumps_io_max_file_size=-keep255;
+  }
+  else {
+    if (force_small_files ) { /* 1 or 2 GBytes */
+      if ( keep255 > 2 || keep255 == 0 ){
+        *mumps_io_max_file_size=2;
+        }
+      else {
+        *mumps_io_max_file_size=1;
+        }
+      }
+    else {
+      if ( keep255 == 0 ) {
+        *mumps_io_max_file_size=2;
+        }
+      else {
+        *mumps_io_max_file_size=keep255;
+      }
+    }
+    *mumps_io_max_file_size=*mumps_io_max_file_size*(MUMPS_OFF_T)(1000000000);
+    }
+}
 MUMPS_INT mumps_set_file(MUMPS_INT type,MUMPS_INT file_number_arg){
-  /* Defines the pattern for the file name. The last 6 'X' will be replaced
-     so as to name were unique */
-  char name[351];
+/* Define file name pattern.
+ * Last 6 'X' will be replaced to make file name unique */
+  char name[1300]; /* Larger than prefix(255)+tmpdir(1023)+base_name (20)+\0 (1) */
 #if ! defined(_WIN32)
   MUMPS_INT fd;
   char buf[64]; /* for error message */
@@ -74,17 +104,17 @@ MUMPS_INT mumps_set_file(MUMPS_INT type,
   }
   mumps_io_pfile_pointer_array=(mumps_files+type)->mumps_io_pfile_pointer_array;
   /* 
-     Do change the current file 
-     Careful: both mumps_io_current_file_number and
-              mumps_io_current_file must be changed
+   * Change the current file:
+   * Careful: both mumps_io_current_file_number and
+   *          mumps_io_current_file must be changed
    */
   ((mumps_files+type)->mumps_io_current_file_number)=file_number_arg;
   ((mumps_files+type)->mumps_io_current_file)=mumps_io_pfile_pointer_array+file_number_arg;
   if((mumps_io_pfile_pointer_array+file_number_arg)->is_opened!=0){
     /*
-       The file already exists and is open.
-       The i/o will be performed in the current file (which may not
-       be the last one.
+     * The file already exists and is open.
+     * The i/o will be performed in the current file (which may not
+     * be the last one.
      */
     return 0;
   }
@@ -97,11 +127,12 @@ MUMPS_INT mumps_set_file(MUMPS_INT type,
 #if ! defined(_WIN32)
   strcpy(name,mumps_ooc_file_prefix);
   fd=mkstemp(name);  
-  /* Note that a file name is built by mkstemp and that the file is 
-     opened. fd hold the file descriptor to access it.
-     We want to close the file that will be opened later
-     and might be removed before the end of the processus.
-  */
+  /*
+   * A file name is built by mkstemp and the file
+   * is opened. fd holds the file descriptor to access it.
+   * We want to close the file that will be opened later
+   * and might be removed before the end of the processus.
+   */
   if(fd < 0) {
     sprintf(buf,"File creation failure");
     return mumps_io_sys_error(-90,buf);
@@ -111,19 +142,10 @@ MUMPS_INT mumps_set_file(MUMPS_INT type,
 #else
   sprintf(name,"%s_%d_%d",mumps_ooc_file_prefix,((mumps_files+type)->mumps_io_current_file_number)+1,type);
 #endif
-/*   *(mumps_io_pfile_pointer_array+mumps_io_current_file_number)=fopen(name,"w+"); */
-/*   *(mumps_io_pfile_name+mumps_io_current_file_number)=(char *)malloc((strlen(name)+1)*sizeof(char)); */
-/*   if(*(mumps_io_pfile_name+mumps_io_current_file_number)==NULL){ */
-/*     sprintf(error_str,"Allocation problem in low-level OOC layer\n"); */
-/*     return -13; */
-/*   } */
   strcpy((mumps_io_pfile_pointer_array+(mumps_files+type)->mumps_io_current_file_number)->name,name);
   /* See mumps_io_basic.h for comments on the I/O flags passed to open */
 #if ! defined( MUMPS_WIN32 )
   (mumps_io_pfile_pointer_array+(mumps_files+type)->mumps_io_current_file_number)->file=open(name,(mumps_files+type)->mumps_flag_open,0666); 
-  /* 
-CPA: for LU factor file: 
-(mumps_io_pfile_pointer_array+(mumps_files+type)->mumps_io_current_file_number)->file= open(name, O_WRONLY | O_CREAT | O_TRUNC, 0666); */
   if((mumps_io_pfile_pointer_array+(mumps_files+type)->mumps_io_current_file_number)->file==-1){
     return mumps_io_sys_error(-90,"Unable to open OOC file");
   }
@@ -138,24 +160,20 @@ CPA: for LU factor file:
   if((mumps_files+type)->mumps_io_current_file_number>(mumps_files+type)->mumps_io_last_file_opened){
     (mumps_files+type)->mumps_io_last_file_opened=(mumps_files+type)->mumps_io_current_file_number;
   }
-  /*  if(*(mumps_io_pfile_pointer_array+mumps_io_current_file_number)==NULL) */
   ((mumps_files+type)->mumps_io_current_file)->write_pos=0;
   ((mumps_files+type)->mumps_io_current_file)->is_opened=1;
-  /*  printf("new file created -> num = %d \n", ((mumps_files+type)->mumps_io_last_file_opened));*/
-  /*  printf("new file created %d\n",mumps_io_current_file_number);*/
   return 0;
 }
 void mumps_update_current_file_position(mumps_file_struct* file_arg){
   file_arg->current_pos=file_arg->write_pos;
-/*   mumps_io_current_file_position=mumps_io_write_pos; */
 }
 MUMPS_INT mumps_compute_where_to_write(const double to_be_written,const MUMPS_INT type,long long vaddr,size_t already_written){
-  /* Check if the current file has enough memory to receive the whole block*/
+  /* Check if the current file has enough space to receive the whole block*/
   MUMPS_INT ret_code;
   MUMPS_INT file;
   mumps_file_struct *current_file;
   long long vaddr_loc;
-  MUMPS_INT pos;
+  MUMPS_OFF_T pos;
   /* Virtual address based file management scheme */
   vaddr_loc=vaddr*(long long)mumps_elementary_data_size+(long long)already_written;
   mumps_gen_file_info(vaddr_loc,&pos,&file);
@@ -168,29 +186,24 @@ MUMPS_INT mumps_compute_where_to_write(c
   mumps_update_current_file_position(current_file);
   return 0;
 }
-MUMPS_INT mumps_prepare_pointers_for_write(double to_be_written,MUMPS_INT * pos_in_file, MUMPS_INT * file_number,const MUMPS_INT type,long long vaddr,size_t already_written){
+MUMPS_INT mumps_prepare_pointers_for_write(double to_be_written, MUMPS_OFF_T * pos_in_file, MUMPS_INT * file_number,const MUMPS_INT type,long long vaddr,size_t already_written){
   MUMPS_INT ret_code;
   ret_code=mumps_compute_where_to_write(to_be_written,type,vaddr,already_written);
   if(ret_code<0){
     return ret_code;
   }
   *pos_in_file=((mumps_files+type)->mumps_io_current_file)->current_pos;
-  /* should be modified to take into account the file arg */
   *file_number=(mumps_files+type)->mumps_io_current_file_number;
   return 0;
 }
-MUMPS_INLINE MUMPS_INT mumps_gen_file_info(long long vaddr, MUMPS_INT * pos, MUMPS_INT * file){
-  *file=(MUMPS_INT)(vaddr/(long long)mumps_io_max_file_size);
-  *pos=(MUMPS_INT)(vaddr%(long long)mumps_io_max_file_size);
-  return 0;
-}
 MUMPS_INT mumps_compute_nb_concerned_files(long long block_size, MUMPS_INT * nb_concerned_files,long long vaddr){
-  MUMPS_INT file,pos,available_size;
+  MUMPS_INT file;
+  MUMPS_OFF_T pos, available_size;
   long long vaddr_loc;
   vaddr_loc=vaddr*(long long)mumps_elementary_data_size;
   mumps_gen_file_info(vaddr_loc,&pos,&file);
   available_size=mumps_io_max_file_size-pos+1;
-  *nb_concerned_files=(MUMPS_INT)my_ceil((double)(my_max(0,((block_size)*(double)(mumps_elementary_data_size))-available_size))/(double)mumps_io_max_file_size)+1;
+  *nb_concerned_files=(MUMPS_INT)my_ceil((double)(my_max(0,((block_size)*(double)(mumps_elementary_data_size))-(double)available_size))/(double)mumps_io_max_file_size)+1;
   return 0;
 }
 MUMPS_INT mumps_io_do_write_block(void * address_block,
@@ -203,14 +216,15 @@ MUMPS_INT mumps_io_do_write_block(void *
   size_t write_size;
   MUMPS_INT i;
   MUMPS_INT nb_concerned_files=0;
-  MUMPS_INT ret_code,file_number_loc,pos_in_file_loc;
+  MUMPS_INT ret_code,file_number_loc;
+  MUMPS_OFF_T pos_in_file_loc;
   double to_be_written;
 #if ! defined( MUMPS_WIN32 )
   MUMPS_INT* file;
 #else
   FILE** file;
 #endif
-  MUMPS_INT where;
+  MUMPS_OFF_T where;
   void* loc_addr;
   MUMPS_INT type;
   size_t already_written=0;
@@ -219,7 +233,6 @@ MUMPS_INT mumps_io_do_write_block(void *
   loc_addr=address_block;
   mumps_compute_nb_concerned_files(block_size,&nb_concerned_files,vaddr);
   to_be_written=((double)mumps_elementary_data_size)*((double)(block_size));
-  /*  printf("nb_concerned -> %d | %lf \n",nb_concerned_files,to_be_written); */
   for(i=0;i<nb_concerned_files;i++){
 #if ! defined( MUMPS_WIN32 ) && ! defined (WITHOUT_PTHREAD)
 # ifdef WITH_PFUNC
@@ -273,17 +286,11 @@ MUMPS_INT mumps_io_do_write_block(void *
     ((mumps_files+type)->mumps_io_current_file)->write_pos=((mumps_files+type)->mumps_io_current_file)->write_pos+((MUMPS_INT)write_size);
     to_be_written=to_be_written-((MUMPS_INT)write_size);
     loc_addr=(void*)((size_t)loc_addr+write_size);
-/*     mumps_io_write_pos=mumps_io_write_pos+((MUMPS_INT)write_size); */
-/*     to_be_written=to_be_written-((MUMPS_INT)write_size); */
-/*     loc_addr=(void*)((size_t)loc_addr+write_size); */
 #else
     /* fread and write */
-    ((mumps_files+type)->mumps_io_current_file)->write_pos=((mumps_files+type)->mumps_io_current_file)->write_pos+((MUMPS_INT)write_size*mumps_elementary_data_size);
+    ((mumps_files+type)->mumps_io_current_file)->write_pos=((mumps_files+type)->mumps_io_current_file)->write_pos+((MUMPS_INT8)write_size*mumps_elementary_data_size);
     to_be_written=to_be_written-((MUMPS_INT)write_size*mumps_elementary_data_size);
     loc_addr=(void*)((size_t)loc_addr+(size_t)((MUMPS_INT)write_size*mumps_elementary_data_size));
-/*     mumps_io_write_pos=mumps_io_write_pos+((MUMPS_INT)write_size*mumps_elementary_data_size); */
-/*     to_be_written=to_be_written-((MUMPS_INT)write_size*mumps_elementary_data_size); */
-/*     loc_addr=(void*)((size_t)loc_addr+(size_t)((MUMPS_INT)write_size*mumps_elementary_data_size)); */
 #endif
 #if ! defined( MUMPS_WIN32 ) && ! defined (WITHOUT_PTHREAD)
 # ifdef WITH_PFUNC
@@ -313,31 +320,23 @@ MUMPS_INT mumps_io_do_read_block(void *
   FILE** file;
 #endif
   double read_size;
-  MUMPS_INT local_fnum,local_offset;
+  MUMPS_INT local_fnum;
+  MUMPS_OFF_T local_offset;
   void *loc_addr;
   long long vaddr_loc;
   MUMPS_INT type;
   type=*type_arg;
-  /*  if(((double)(*block_size))*((double)(mumps_elementary_data_size))>(double)mumps_io_max_file_size){
-    sprintf(error_str,"Internal error in low-level I/O operation (requested size too big for file system) \n");
-    return -90;
-    }*/
   if(block_size==0){
     return 0;
   }
   read_size=(double)mumps_elementary_data_size*(double)(block_size);
-  /*  if((*file_number<0)&&(read_size<(double)mumps_io_max_file_size)){
-    sprintf(error_str,"Internal error (1) in low level read op\n");
-    return -90;
-    }*/
   loc_addr=address_block;
   vaddr_loc=vaddr*(long long)mumps_elementary_data_size;
   while(read_size>0){
     /* Virtual addressing based management stuff */
     local_fnum=(MUMPS_INT)(vaddr_loc/(long long)mumps_io_max_file_size);
-    local_offset=(MUMPS_INT)(vaddr_loc%(long long)mumps_io_max_file_size);
+    local_offset=(MUMPS_OFF_T)(vaddr_loc%(long long)mumps_io_max_file_size);
     file=&((((mumps_files+type)->mumps_io_pfile_pointer_array)+local_fnum)->file);
-    /* printf("1 read | file -> %d | fnum -> %d | vaddr -> %d \n",*file,local_fnum,(MUMPS_INT)vaddr_loc); */
 #if ! defined( MUMPS_WIN32 )
     if(read_size+(double)local_offset>(double)mumps_io_max_file_size){
       size=(size_t)mumps_io_max_file_size-(size_t)local_offset;
@@ -372,20 +371,11 @@ MUMPS_INT mumps_io_do_read_block(void *
 }
 MUMPS_INT mumps_free_file_pointers(MUMPS_INT *step){
   MUMPS_INT i,j,bound,ierr;
-/*   Free prefix only for facto  */
+  /* Free prefix only for facto */
   if (*step == 0) free(mumps_ooc_file_prefix);
   if(mumps_files == NULL )
       return 0;
-#if ! defined( MUMPS_WIN32 )
-#endif
   bound=mumps_io_nb_file_type;
-/*   if(*step==0){ */
-/*     /\* factorization *\/ */
-/*     bound=NB_FILE_TYPE_FACTO; */
-/*   }else{ */
-/*     /\* solve *\/ */
-/*     bound=NB_FILE_TYPE_SOLVE; */
-/*   } */
   for(j=0;j<bound;j++){
     if( mumps_files[j].mumps_io_pfile_pointer_array == NULL ) {
       continue;
@@ -402,14 +392,10 @@ MUMPS_INT mumps_free_file_pointers(MUMPS
         return mumps_io_error(-90,"Problem while closing OOC file\n");
       }    
 #endif
-      /*     free(*(mumps_io_pfile_name+i)); */
     }
     free((mumps_files+j)->mumps_io_pfile_pointer_array);
   }
-/*   free(mumps_io_pfile_name); */
   free(mumps_files);
-#if ! defined( MUMPS_WIN32 )
-#endif
   return 0;
 }
 /* Initialize the mumps_file_type structure at <which>th position in
@@ -436,7 +422,7 @@ MUMPS_INT mumps_io_alloc_file_struct(MUM
   }
   return 0;
 }
-MUMPS_INT mumps_init_file_structure(MUMPS_INT* _myid, long long *total_size_io,MUMPS_INT *size_element,MUMPS_INT *nb_file_type,MUMPS_INT *flag_tab)
+MUMPS_INT mumps_init_file_structure(MUMPS_INT* _myid, long long *total_size_io,MUMPS_INT *size_element,MUMPS_INT *nb_file_type,MUMPS_INT *flag_tab, MUMPS_INT keep255)
 {
   /* Computes the number of files needed. Uses ceil value. */
   MUMPS_INT ierr;
@@ -445,10 +431,9 @@ MUMPS_INT mumps_init_file_structure(MUMP
 #endif
   MUMPS_INT i,nb;
   MUMPS_INT mumps_io_nb_file;
-  mumps_io_max_file_size=MAX_FILE_SIZE;
+  mumps_init_max_file_size(&mumps_io_max_file_size, keep255);
   mumps_io_nb_file_type=*nb_file_type;
   mumps_io_nb_file=(MUMPS_INT)((((double)(*total_size_io)*1000000)*((double)(*size_element)))/(double)mumps_io_max_file_size)+1;
-  mumps_directio_flag=0;
 #if ! defined( MUMPS_WIN32 )
   mumps_flag_open=0;
 #endif
@@ -512,7 +497,6 @@ MUMPS_INT mumps_init_file_structure(MUMP
       return ierr;
     }
   }
-  /* Init the current file.*/
   return 0;
 }
 MUMPS_INT mumps_init_file_name(char* mumps_dir,char* mumps_file,
@@ -538,26 +522,15 @@ MUMPS_INT mumps_init_file_name(char* mum
     tmp_fname[i]=mumps_file[i];
   }
   tmp_fname[i]=0;  
-  if(strcmp(tmp_dir,UNITIALIZED)==0){
+  if(strcmp(tmp_dir,UNINITIALIZED)==0){
     dir_flag=1;
     free(tmp_dir);
     tmp_dir=getenv("MUMPS_OOC_TMPDIR");
     if(tmp_dir==NULL){
-#ifdef _AIX
-# ifndef CINES_
-      tmp_dir=getenv("TMPDIR");
-      if(tmp_dir==NULL){
-        tmp_dir=MUMPS_OOC_DEFAULT_DIR;
-      }
-# else
-      tmp_dir=MUMPS_OOC_DEFAULT_DIR;       
-# endif       
-#else
       tmp_dir=MUMPS_OOC_DEFAULT_DIR;
-#endif      
     }
   }
-  if(strcmp(tmp_fname,UNITIALIZED)==0){
+  if(strcmp(tmp_fname,UNINITIALIZED)==0){
     free(tmp_fname);
     tmp_fname=getenv("MUMPS_OOC_PREFIX");
     file_flag=1;
@@ -622,17 +595,15 @@ MUMPS_INT mumps_io_alloc_pointers(MUMPS_
   }
   return 0;
 }
-MUMPS_INT mumps_io_init_vars(MUMPS_INT* myid_arg,MUMPS_INT* size_element,MUMPS_INT* async_arg){
+MUMPS_INT mumps_io_init_vars(MUMPS_INT* myid_arg,MUMPS_INT* size_element,MUMPS_INT* async_arg,MUMPS_INT keep255){
 #if ! defined( MUMPS_WIN32 )
   MUMPS_INT mumps_flag_open;
 #endif
   MUMPS_INT i;
-  mumps_io_max_file_size=MAX_FILE_SIZE;
-  mumps_directio_flag=0;
+  mumps_init_max_file_size(&mumps_io_max_file_size, keep255);
 #if ! defined( MUMPS_WIN32 )
   mumps_flag_open=0;
 #endif
-  /* must be changed when we will have more than one file type during solve step */
   for(i=0;i<mumps_io_nb_file_type;i++){
 #if ! defined( MUMPS_WIN32 )
     (mumps_files+i)->mumps_flag_open=mumps_flag_open|O_RDONLY;
@@ -648,11 +619,6 @@ MUMPS_INT mumps_io_init_vars(MUMPS_INT*
 MUMPS_INT mumps_io_set_file_name(MUMPS_INT* indice,char* name,MUMPS_INT* length,MUMPS_INT* type){
   MUMPS_INT i;
   i=(*indice)-1;
-/*   *(mumps_io_pfile_name+i)=(char *) malloc((*length)*strlen(name)); */
-/*   if(*(mumps_io_pfile_name+i)==NULL){ */
-/*     sprintf(error_str,"Allocation problem in low-level OOC layer"); */
-/*     return -13; */
-/*   } */
   strcpy((((mumps_files+*type)->mumps_io_pfile_pointer_array)+i)->name,name);
   return 0;  
 }
@@ -706,14 +672,12 @@ MUMPS_INT mumps_io_destroy_pointers_lock
 }
 # endif /*WITH_PFUNC*/
 #endif /* _WIN32 && WITHOUT_PTHREAD */
- MUMPS_INT mumps_io_read__(void * file,void * loc_addr,size_t size,MUMPS_INT local_offset,MUMPS_INT type){
-  MUMPS_INT ret_code;
+MUMPS_INT mumps_io_read__(void * file,void * loc_addr,size_t size,MUMPS_OFF_T local_offset,MUMPS_INT type){
+MUMPS_INT ret_code;
 #if ! defined( MUMPS_WIN32 )
-  if(!mumps_directio_flag){
-    ret_code=mumps_io_read_os_buff__(file,loc_addr, size,local_offset);
-    if(ret_code<0){
-      return ret_code;
-    }
+  ret_code=mumps_io_read_os_buff__(file,loc_addr, size,local_offset);
+  if(ret_code<0){
+    return ret_code;
   }
 #else
   ret_code=mumps_io_read_win32__(file,loc_addr, size,local_offset);
@@ -724,13 +688,12 @@ MUMPS_INT mumps_io_destroy_pointers_lock
   return 0;
 }
 #if ! defined( MUMPS_WIN32 )
-MUMPS_INT mumps_io_read_os_buff__(void * file,void * loc_addr,size_t size,MUMPS_INT local_offset){
+MUMPS_INT mumps_io_read_os_buff__(void * file,void * loc_addr,size_t size, MUMPS_OFF_T local_offset){
   size_t ret_code;
-  /* printf("Read with buff %d %d %d\n",(MUMPS_INT) size, local_offset,*((MUMPS_INT *)file)); */
 # ifdef WITH_PFUNC
-  ret_code=pread(*(MUMPS_INT *)file,loc_addr,size,local_offset);
+  ret_code=pread(*(MUMPS_INT *)file,loc_addr,size,(off_t)local_offset);
 # else
-  lseek(*(MUMPS_INT *)file,(long) local_offset,SEEK_SET);
+  lseek(*(MUMPS_INT *)file, (off_t)local_offset,SEEK_SET);
   ret_code=read(*(MUMPS_INT *)file,loc_addr,size);
 # endif
   if((MUMPS_INT) ret_code==-1){
@@ -740,9 +703,13 @@ MUMPS_INT mumps_io_read_os_buff__(void *
 }
 #endif
 #if defined( MUMPS_WIN32 )
-MUMPS_INT mumps_io_read_win32__(void * file,void * loc_addr,size_t size,MUMPS_INT local_offset){
+MUMPS_INT mumps_io_read_win32__(void * file, void * loc_addr,size_t size, MUMPS_OFF_T local_offset){
   size_t ret_code;
+#if defined(MUMPS_WINLARGEFILES)
+  _fseeki64(*(FILE **)file,local_offset,SEEK_SET); /* expects where to be __int64 */
+#else
   fseek(*(FILE **)file,(long) local_offset,SEEK_SET);
+#endif
   ret_code=fread(loc_addr,mumps_elementary_data_size,size,*(FILE **)file);
   if((ret_code!=size)||(ferror(*(FILE**)file))){
     return mumps_io_error(-90,"Problem with I/O operation\n");
@@ -750,14 +717,12 @@ MUMPS_INT mumps_io_read_win32__(void * f
   return 0;
 }
 #endif
-MUMPS_INT mumps_io_write__(void *file, void *loc_addr, size_t write_size, MUMPS_INT where,MUMPS_INT type){
+MUMPS_INT mumps_io_write__(void *file, void *loc_addr, size_t write_size, MUMPS_OFF_T where, MUMPS_INT type){
   MUMPS_INT ret_code;
 #if ! defined( MUMPS_WIN32 )
-  if(!mumps_directio_flag){
-    ret_code=mumps_io_write_os_buff__(file,loc_addr, write_size,where);
-    if(ret_code<0){
-      return ret_code;
-    }
+  ret_code=mumps_io_write_os_buff__(file,loc_addr, write_size,where);
+  if(ret_code<0){
+    return ret_code;
   }
 #else
   ret_code=mumps_io_write_win32__(file,loc_addr, write_size,where);
@@ -768,15 +733,14 @@ MUMPS_INT mumps_io_write__(void *file, v
   return 0;
 }
 #if ! defined( MUMPS_WIN32 )
-MUMPS_INT mumps_io_write_os_buff__(void *file, void *loc_addr, size_t write_size, MUMPS_INT where){
+MUMPS_INT mumps_io_write_os_buff__(void *file, void *loc_addr, size_t write_size, MUMPS_OFF_T where){
   size_t ret_code;
-  /* printf("write with buff %d %d %d\n",(MUMPS_INT) write_size, where,*((MUMPS_INT *)file)); */
 # ifdef WITH_PFUNC
-  ret_code=pwrite(*(MUMPS_INT *)file,loc_addr,write_size,where);
+  ret_code=pwrite(*(MUMPS_INT *)file,loc_addr,write_size,(off_t)where);
 # else
   /*in this case all the I/O's are made by the I/O thread => we don't
     need to protect the file pointer.*/
-  lseek(*(MUMPS_INT *)file,(long)where,SEEK_SET); 
+  lseek(*(MUMPS_INT *)file,(off_t)where,SEEK_SET); 
   ret_code=write(*(MUMPS_INT *)file,loc_addr,write_size);
 # endif
   if((MUMPS_INT)ret_code==-1){
@@ -788,9 +752,13 @@ MUMPS_INT mumps_io_write_os_buff__(void
 }
 #endif
 #if defined( MUMPS_WIN32 )
-MUMPS_INT mumps_io_write_win32__(void *file, void *loc_addr, size_t write_size, MUMPS_INT where){
+MUMPS_INT mumps_io_write_win32__(void *file, void *loc_addr, size_t write_size, MUMPS_OFF_T where){
   size_t ret_code;
-  fseek(*(FILE **)file,(long)where,SEEK_SET);  
+#if defined(MUMPS_WINLARGEFILES)
+  _fseeki64(*(FILE **)file,where,SEEK_SET); /* expects where to be __int64 */
+#else
+  fseek(*(FILE **)file,(long)where,SEEK_SET);
+#endif
   ret_code=fwrite(loc_addr,mumps_elementary_data_size, write_size,*(FILE**)file);
   if((ret_code!=write_size)||(ferror(*(FILE**)file))){
     return mumps_io_error(-90,"Problem with I/O operation\n");
@@ -798,26 +766,3 @@ MUMPS_INT mumps_io_write_win32__(void *f
   return 0;
 }
 #endif
-MUMPS_INT mumps_compute_file_size(void *file,size_t *size){
-  /* Compute the size of the file pointed by file and return it in
-     size */
-#if defined(MUMPS_WIN32)
-  /* This works well as soon as we don't use threads under WIN32 */
-  MUMPS_INT ret_code;
-  long pos=0;
-  /* Get the current position */
-  pos=ftell(*(FILE **)file);
-  /* Move the file pointer to the end of the file */
-  fseek(*(FILE **)file,0,SEEK_END);
-  /* Get the current position which is in fact the size */
-  *size=(size_t)ftell(*(FILE **)file);
-  /* Restore the old position */
-  fseek(*(FILE **)file,pos,SEEK_SET);
-#else
-  struct stat file_info;
-  /* fstat does everything :-) */
-  fstat(*(MUMPS_INT *)file, &file_info);
-  *size = (size_t)file_info.st_size;
-#endif
-  return 0;
-}
diff -pruN 5.6.2-2.1/src/mumps_io_basic.h 5.7.1-1/src/mumps_io_basic.h
--- 5.6.2-2.1/src/mumps_io_basic.h	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_io_basic.h	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
@@ -33,13 +33,6 @@
 #  define _XOPEN_SOURCE 500
 # endif
 #endif
-#define MAX_FILE_SIZE 1879048192 /* (2^31)-1-(2^27) */
-/*                                                      */
-/* Important Note :                                     */
-/* ================                                     */
-/* On GNU systems, __USE_GNU must be defined to have    */
-/* access to the O_DIRECT I/O flag.                     */
-/*                                                      */
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
@@ -52,10 +45,6 @@
 # include <sys/time.h>
 # include <time.h>
 #endif
-#if ! defined (MUMPS_WIN32)
-# define MUMPS_IO_FLAG_O_DIRECT 0
-#endif
-/* Force WITH_PFUNC on architectures where we know that it should work */
 #if (defined (sgi) || defined (__sgi)) || defined(_AIX) || (defined(sun) || defined(__sun)) || defined(_GNU_SOURCE)
 # undef WITH_PFUNC
 # define WITH_PFUNC
@@ -65,7 +54,7 @@
 #define IO_ASYNC_AIO 2
 #define IO_READ 1
 #define IO_WRITE 0
-#define UNITIALIZED "NAME_NOT_INITIALIZED"
+#define UNINITIALIZED "NAME_NOT_INITIALIZED"
 #define MUMPS_OOC_DEFAULT_DIR "/tmp"
 #if defined(MUMPS_WIN32)
 # define SEPARATOR "\\"
@@ -75,17 +64,17 @@
 /* #define NB_FILE_TYPE_FACTO 1 */
 /* #define NB_FILE_TYPE_SOLVE 1 */
 #define my_max(x,y) ( (x) > (y) ? (x) : (y) ) 
-#define my_ceil(x) ( (MUMPS_INT)(x) >= (x) ? (MUMPS_INT)(x) : ( (MUMPS_INT)(x) + 1 ) )
+#define my_ceil(x) ( (MUMPS_INT8)(x) >= (x) ? (MUMPS_INT8)(x) : ( (MUMPS_INT8)(x) + 1 ) )
 typedef struct __mumps_file_struct{
-  MUMPS_INT write_pos;
-  MUMPS_INT current_pos;
+  MUMPS_OFF_T write_pos;
+  MUMPS_OFF_T current_pos;
   MUMPS_INT is_opened;
 #if ! defined (MUMPS_WIN32)
   MUMPS_INT file;
 #else
   FILE* file;
 #endif
-  char name[351]; /* Should be large enough to hold tmpdir, prefix, suffix */
+  char name[1300]; /* Larger than prefix(255)+tmpdir(1023)+base_name (20)+\0 (1) */
 }mumps_file_struct;
 typedef struct __mumps_file_type{
 #if ! defined (MUMPS_WIN32)
@@ -106,69 +95,51 @@ typedef struct __mumps_file_type{
 #  include <pthread.h>
 extern pthread_mutex_t mumps_io_pwrite_mutex;
 # endif
-/* extern MUMPS_INT* mumps_io_pfile_pointer_array; */
-/* extern MUMPS_INT* mumps_io_current_file; */
-/* #else /\*_WIN32*\/ */
-/* extern FILE** mumps_io_current_file; */
-/* extern FILE** mumps_io_pfile_pointer_array; */
 #endif /* MUMPS_WIN32 */
-/*extern mumps_file_struct* mumps_io_pfile_pointer_array;
-  extern mumps_file_struct* mumps_io_current_file;*/
 extern mumps_file_type* mumps_files;
-/* extern MUMPS_INT mumps_io_current_file_number; */
 extern char* mumps_ooc_file_prefix;
-/* extern char** mumps_io_pfile_name; */
-/* extern MUMPS_INT mumps_io_current_file_position; */
-/* extern MUMPS_INT mumps_io_write_pos; */
-/* extern MUMPS_INT mumps_io_last_file_opened; */
 extern MUMPS_INT mumps_elementary_data_size;
 extern MUMPS_INT mumps_io_is_init_called;
 extern MUMPS_INT mumps_io_myid;
-extern MUMPS_INT mumps_io_max_file_size;
-/* extern MUMPS_INT mumps_io_nb_file; */
+extern MUMPS_OFF_T mumps_io_max_file_size;
 extern MUMPS_INT mumps_io_flag_async;
 extern MUMPS_INT mumps_io_k211;
-/* extern MUMPS_INT mumps_flag_open; */
-extern MUMPS_INT directio_flag;
-extern MUMPS_INT mumps_directio_flag;
 extern MUMPS_INT mumps_io_nb_file_type;
 /* Exported functions */
 MUMPS_INT mumps_set_file(MUMPS_INT type,MUMPS_INT file_number_arg);
 void mumps_update_current_file_position(mumps_file_struct* file_arg);
 MUMPS_INT mumps_compute_where_to_write(const double to_be_written,const MUMPS_INT type,long long vaddr,size_t already_written);
-MUMPS_INT mumps_prepare_pointers_for_write(double to_be_written,MUMPS_INT * pos_in_file, MUMPS_INT * file_number,const MUMPS_INT type,long long vaddr,size_t already_written);
+MUMPS_INT mumps_prepare_pointers_for_write(double to_be_written,MUMPS_OFF_T * pos_in_file, MUMPS_INT * file_number,const MUMPS_INT type,long long vaddr,size_t already_written);
 MUMPS_INT mumps_io_do_write_block(void * address_block,long long block_size,MUMPS_INT * type,long long vaddr,MUMPS_INT * ierr);
 MUMPS_INT mumps_io_do_read_block(void * address_block,long long block_size,MUMPS_INT * type,long long vaddr,MUMPS_INT * ierr);
 MUMPS_INT mumps_compute_nb_concerned_files(long long block_size,MUMPS_INT * nb_concerned_files,long long vaddr);
-MUMPS_INLINE MUMPS_INT mumps_gen_file_info(long long vaddr, MUMPS_INT * pos, MUMPS_INT * file);
 MUMPS_INT mumps_free_file_pointers(MUMPS_INT* step);
-MUMPS_INT mumps_init_file_structure(MUMPS_INT *_myid, long long *total_size_io,MUMPS_INT *size_element,MUMPS_INT *nb_file_type,MUMPS_INT *flag_tab);
+MUMPS_INT mumps_init_file_structure(MUMPS_INT *_myid, long long *total_size_io,MUMPS_INT *size_element,MUMPS_INT *nb_file_type,MUMPS_INT *flag_tab, MUMPS_INT keep255);
 MUMPS_INT mumps_init_file_name(char* mumps_dir,char* mumps_file,MUMPS_INT* mumps_dim_dir,MUMPS_INT* mumps_dim_file,MUMPS_INT* _myid);
 void mumps_io_init_file_struct(MUMPS_INT* nb,MUMPS_INT which);
 MUMPS_INT mumps_io_alloc_file_struct(MUMPS_INT* nb,MUMPS_INT which);
 MUMPS_INT mumps_io_get_nb_files(MUMPS_INT* nb_files, const MUMPS_INT* type);
 MUMPS_INT mumps_io_get_file_name(MUMPS_INT* indice,char* name,MUMPS_INT* length,MUMPS_INT* type);
 MUMPS_INT mumps_io_alloc_pointers(MUMPS_INT * nb_file_type, MUMPS_INT * dim);
-MUMPS_INT mumps_io_init_vars(MUMPS_INT* myid_arg,MUMPS_INT* size_element,MUMPS_INT* async_arg);
+MUMPS_INT mumps_io_init_vars(MUMPS_INT* myid_arg,MUMPS_INT* size_element,MUMPS_INT* async_arg,MUMPS_INT keep255);
 MUMPS_INT mumps_io_set_file_name(MUMPS_INT* indice,char* name,MUMPS_INT* length,MUMPS_INT* type);
 MUMPS_INT mumps_io_open_files_for_read();
 MUMPS_INT mumps_io_set_last_file(MUMPS_INT* dim,MUMPS_INT* type);
-MUMPS_INT mumps_io_write__(void *file, void *loc_add, size_t write_size, MUMPS_INT where,MUMPS_INT type);
+MUMPS_INT mumps_io_write__(void *file, void *loc_add, size_t write_size, MUMPS_OFF_T where,MUMPS_INT type);
 #if ! defined (MUMPS_WIN32)
-MUMPS_INT mumps_io_write_os_buff__(void *file, void *loc_add, size_t write_size, MUMPS_INT where);
-MUMPS_INT mumps_io_write_direct_io__(void *file, void *loc_addr, size_t write_size, MUMPS_INT where,MUMPS_INT type);
+MUMPS_INT mumps_io_write_os_buff__(void *file, void *loc_add, size_t write_size, MUMPS_OFF_T where);
+MUMPS_INT mumps_io_write_direct_io__(void *file, void *loc_addr, size_t write_size, MUMPS_OFF_T where,MUMPS_INT type);
 MUMPS_INT mumps_io_flush_write__(MUMPS_INT type);
 #else
-MUMPS_INT mumps_io_write_win32__(void *file, void *loc_add, size_t write_size, MUMPS_INT where);
+MUMPS_INT mumps_io_write_win32__(void *file, void *loc_add, size_t write_size, MUMPS_OFF_T where);
 #endif
-MUMPS_INT mumps_io_read__(void * file,void * loc_addr,size_t size,MUMPS_INT local_offset,MUMPS_INT type);
+MUMPS_INT mumps_io_read__(void * file,void * loc_addr,size_t size, MUMPS_OFF_T local_offset,MUMPS_INT type);
 #if ! defined (MUMPS_WIN32)
-MUMPS_INT mumps_io_read_os_buff__(void * file,void * loc_addr,size_t size,MUMPS_INT local_offset);
-MUMPS_INT mumps_io_read_direct_io__(void * file,void * loc_addr,size_t size,MUMPS_INT local_offset,MUMPS_INT type);
+MUMPS_INT mumps_io_read_os_buff__(void * file,void * loc_addr,size_t size, MUMPS_OFF_T local_offset);
+MUMPS_INT mumps_io_read_direct_io__(void * file,void * loc_addr,size_t size, MUMPS_OFF_T local_offset,MUMPS_INT type);
 #else
-MUMPS_INT mumps_io_read_win32__(void * file,void * loc_addr,size_t size,MUMPS_INT local_offset);
+MUMPS_INT mumps_io_read_win32__(void * file,void * loc_addr,size_t size, MUMPS_OFF_T local_offset);
 #endif
-MUMPS_INT mumps_compute_file_size(void *file,size_t *size);
 #if ! defined (MUMPS_WIN32) && ! defined (WITHOUT_PTHREAD)
 # if defined (WITH_PFUNC)
 MUMPS_INT mumps_io_protect_pointers();
diff -pruN 5.6.2-2.1/src/mumps_io_err.c 5.7.1-1/src/mumps_io_err.c
--- 5.6.2-2.1/src/mumps_io_err.c	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_io_err.c	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/mumps_io_err.h 5.7.1-1/src/mumps_io_err.h
--- 5.6.2-2.1/src/mumps_io_err.h	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_io_err.h	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/mumps_io_thread.c 5.7.1-1/src/mumps_io_thread.c
--- 5.6.2-2.1/src/mumps_io_thread.c	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_io_thread.c	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/mumps_io_thread.h 5.7.1-1/src/mumps_io_thread.h
--- 5.6.2-2.1/src/mumps_io_thread.h	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_io_thread.h	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/mumps_l0_omp_m.F 5.7.1-1/src/mumps_l0_omp_m.F
--- 5.6.2-2.1/src/mumps_l0_omp_m.F	2023-10-11 09:36:35.000000000 +0000
+++ 5.7.1-1/src/mumps_l0_omp_m.F	2024-05-02 10:15:14.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/mumps_memory_mod.F 5.7.1-1/src/mumps_memory_mod.F
--- 5.6.2-2.1/src/mumps_memory_mod.F	2023-10-11 09:36:35.000000000 +0000
+++ 5.7.1-1/src/mumps_memory_mod.F	2024-05-02 10:15:13.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/mumps_metis.c 5.7.1-1/src/mumps_metis.c
--- 5.6.2-2.1/src/mumps_metis.c	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_metis.c	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
@@ -132,18 +132,17 @@ MUMPS_METIS_KWAY(MUMPS_INT *n,     MUMPS
 #else /* METIS >= 5 */
   int ierr;
 #  if (IDXTYPEWIDTH == 32)
-  MUMPS_INT ncon, edgecut, options[40];
+  MUMPS_INT ncon, edgecut, options[METIS_NOPTIONS];
   ierr=METIS_SetDefaultOptions(options);
-  options[0]  = 0;
   /* Use 1-based fortran numbering */
-  options[17] = 1;
+  options[METIS_OPTION_NUMBERING] = 1;
   ncon        = 1;
   ierr = METIS_PartGraphKway(n, &ncon, iptr, jcn,
                              NULL, NULL, NULL,
                              k, NULL, NULL, options,
                              &edgecut, part);
 #  else
-  /* SHOULD NEVER BE CALLED */
+  /* SHOULD NEVER BE REACHED */
   printf("** Error: METIS version >= 4, IDXTYPE WIDTH !=32, but MUMPS_METIS_KWAY was called\n");
   ierr=1;
 #  endif
@@ -159,8 +158,8 @@ MUMPS_METIS_KWAY_AB(MUMPS_INT *n,     MU
    iptr  -- pointer to the beginning of each node's adjacency list
    jcn   -- jcn[iptr[i]:iptr[i+1]-1] contains the list of neighbors of node i
    k     -- the number of parts
-   part  -- part[i] is the part node i belongs to 
-   vwgt  -- weights of the vertices*/
+   part  -- part[i] is the part node i belongs to
+   vwgt  -- weights of the vertices */
  {
 #if defined(metis4) || defined(parmetis3)
   MUMPS_INT numflag, edgecut, wgtflag, options[8];
@@ -178,18 +177,17 @@ MUMPS_METIS_KWAY_AB(MUMPS_INT *n,     MU
 #else /* METIS >= 5 */
   int ierr;
 #  if (IDXTYPEWIDTH == 32)
-  MUMPS_INT ncon, edgecut, options[40];
+  MUMPS_INT ncon, edgecut, options[METIS_NOPTIONS];
   ierr=METIS_SetDefaultOptions(options);
-  options[0]  = 0;
   /* Use 1-based fortran numbering */
-  options[17] = 1;
+  options[METIS_OPTION_NUMBERING] = 1;
   ncon        = 1;
   ierr = METIS_PartGraphKway(n, &ncon, iptr, jcn,
                              vwgt, NULL, NULL,
                              k, NULL, NULL, options,
                              &edgecut, part);
 #  else
-  /* SHOULD NEVER BE CALLED */
+  /* SHOULD NEVER BE REACHED */
   printf("** Error: METIS version >= 4, IDXTYPE WIDTH !=32, but MUMPS_METIS_KWAY_AB was called\n");
   ierr=1;
 #  endif
diff -pruN 5.6.2-2.1/src/mumps_metis.h 5.7.1-1/src/mumps_metis.h
--- 5.6.2-2.1/src/mumps_metis.h	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_metis.h	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/mumps_metis64.c 5.7.1-1/src/mumps_metis64.c
--- 5.6.2-2.1/src/mumps_metis64.c	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_metis64.c	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
@@ -89,7 +89,7 @@ MUMPS_PARMETIS_VWGT_64(MUMPS_INT8 *first
 #elif defined(parmetis)
 #  if (IDXTYPEWIDTH == 64)
       *ierr=0;
-     iierr=ParMETIS_V32_NodeND(first, vertloctab, edgeloctab, vwgt, numflag, 
+      iierr=ParMETIS_V32_NodeND(first, vertloctab, edgeloctab, vwgt, numflag, 
                                 NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
                                 order, sizes, &int_comm);
       if(iierr != METIS_OK)
@@ -147,19 +147,19 @@ MUMPS_METIS_KWAY_64(MUMPS_INT8 *n,     M
 #else /* METIS >= 5 */
   int ierr;
 #  if (IDXTYPEWIDTH == 64)
-  MUMPS_INT8 ncon, edgecut, options[40];
+  MUMPS_INT8 ncon, edgecut, options[METIS_NOPTIONS];
   ierr=METIS_SetDefaultOptions(options);
-  options[0]  = 0;
   /* Use 1-based fortran numbering */
-  options[17] = 1;
+  options[METIS_OPTION_NUMBERING] = 1;
   ncon        = 1;
-     ierr = METIS_PartGraphKway(n, &ncon, iptr, jcn,
-     NULL, NULL, NULL,
-     k, NULL, NULL, options,
-     &edgecut, part);
+  ierr = METIS_PartGraphKway(n, &ncon, iptr, jcn,
+                             NULL, NULL, NULL,
+                             k, NULL, NULL, options,
+                             &edgecut, part);
 #  else
-     printf("** Error: METIS version >= 4, IDXTYPE WIDTH !=64, but MUMPS_METIS_KWAY_64 was called\n");
-     ierr=1;
+  /* SHOULD NEVER BE REACHED */
+  printf("** Error: METIS version >= 4, IDXTYPE WIDTH !=64, but MUMPS_METIS_KWAY_64 was called\n");
+  ierr=1;
 #  endif
 #endif
   return;
@@ -173,7 +173,8 @@ MUMPS_METIS_KWAY_AB_64(MUMPS_INT8 *n,
    iptr  -- pointer to the beginning of each node's adjacency list
    jcn   -- jcn[iptr[i]:iptr[i+1]-1] contains the list of neighbors of node i
    k     -- the number of parts
-   part  -- part[i] is the part node i belongs to */
+   part  -- part[i] is the part node i belongs to
+   vwgt  -- weights of the vertices */
 /* SELECTIVE I8 FIXME: add an argument *ierr, check it on exit */
  {
 #if defined(metis4) || defined(parmetis3)
@@ -196,19 +197,19 @@ MUMPS_METIS_KWAY_AB_64(MUMPS_INT8 *n,
 #else /* METIS >= 5 */
   int ierr;
 #  if (IDXTYPEWIDTH == 64)
-  MUMPS_INT8 ncon, edgecut, options[40];
+  MUMPS_INT8 ncon, edgecut, options[METIS_NOPTIONS];
   ierr=METIS_SetDefaultOptions(options);
-  options[0]  = 0;
   /* Use 1-based fortran numbering */
-  options[17] = 1;
+  options[METIS_OPTION_NUMBERING] = 1;
   ncon        = 1;
-     ierr = METIS_PartGraphKway(n, &ncon, iptr, jcn,
-     vwgt, NULL, NULL,
-     k, NULL, NULL, options,
-     &edgecut, part);
+  ierr = METIS_PartGraphKway(n, &ncon, iptr, jcn,
+                             vwgt, NULL, NULL,
+                             k, NULL, NULL, options,
+                             &edgecut, part);
 #  else
-     printf("** Error: METIS version >= 4, IDXTYPE WIDTH !=64, but MUMPS_METIS_KWAY_AB_64 was called\n");
-     ierr=1;
+  /* SHOULD NEVER BE REACHED */
+  printf("** Error: METIS version >= 4, IDXTYPE WIDTH !=64, but MUMPS_METIS_KWAY_AB_64 was called\n");
+  ierr=1;
 #  endif
 #endif
   return;
diff -pruN 5.6.2-2.1/src/mumps_metis64.h 5.7.1-1/src/mumps_metis64.h
--- 5.6.2-2.1/src/mumps_metis64.h	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_metis64.h	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/mumps_metis_int.c 5.7.1-1/src/mumps_metis_int.c
--- 5.6.2-2.1/src/mumps_metis_int.c	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_metis_int.c	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
@@ -24,7 +24,7 @@
         with different int sizes */
      void MUMPS_CALL
      MUMPS_METIS_IDXSIZE(MUMPS_INT *metis_idx_size)
-     {         
+     {
        *metis_idx_size=8*sizeof(idxtype);
      }
 #  else
@@ -35,6 +35,12 @@
        /* *metis_idx_size=sizeof(idx_t); */
        *metis_idx_size=IDXTYPEWIDTH;
      }
+    /* Retrieve METIS_OPTION_NUMERING */
+     void MUMPS_CALL
+     MUMPS_METIS_OPTION_NUMBERING(MUMPS_INT *i)
+     {
+       *i=METIS_OPTION_NUMBERING;
+     }
 #  endif
 #else
   void MUMPS_CALL
@@ -42,4 +48,9 @@
   {
     *metis_int_size=-99999;
   }
+  void MUMPS_CALL
+  MUMPS_METIS_OPTION_NUMBERING(MUMPS_INT *i)
+  {
+    *i=-99999;
+  }
 #endif
diff -pruN 5.6.2-2.1/src/mumps_metis_int.h 5.7.1-1/src/mumps_metis_int.h
--- 5.6.2-2.1/src/mumps_metis_int.h	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_metis_int.h	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
@@ -20,4 +20,8 @@
   F_SYMBOL(metis_idxsize,METIS_IDXSIZE)
 void MUMPS_CALL
 MUMPS_METIS_IDXSIZE(MUMPS_INT *metis_idx_size);
+#define MUMPS_METIS_OPTION_NUMBERING \
+  F_SYMBOL(metis_option_numbering,METIS_OPTION_NUMBERING)
+void MUMPS_CALL
+     MUMPS_METIS_OPTION_NUMBERING(MUMPS_INT *i);
 #endif
diff -pruN 5.6.2-2.1/src/mumps_mpitoomp_m.F 5.7.1-1/src/mumps_mpitoomp_m.F
--- 5.6.2-2.1/src/mumps_mpitoomp_m.F	2023-10-11 09:36:35.000000000 +0000
+++ 5.7.1-1/src/mumps_mpitoomp_m.F	2024-05-02 10:15:14.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/mumps_numa.c 5.7.1-1/src/mumps_numa.c
--- 5.6.2-2.1/src/mumps_numa.c	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_numa.c	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/mumps_ooc_common.F 5.7.1-1/src/mumps_ooc_common.F
--- 5.6.2-2.1/src/mumps_ooc_common.F	2023-10-11 09:36:35.000000000 +0000
+++ 5.7.1-1/src/mumps_ooc_common.F	2024-05-02 10:15:13.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/mumps_pivnul_mod.F 5.7.1-1/src/mumps_pivnul_mod.F
--- 5.6.2-2.1/src/mumps_pivnul_mod.F	2023-10-11 09:36:35.000000000 +0000
+++ 5.7.1-1/src/mumps_pivnul_mod.F	2024-05-02 10:15:14.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/mumps_pord.c 5.7.1-1/src/mumps_pord.c
--- 5.6.2-2.1/src/mumps_pord.c	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_pord.c	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/mumps_pord.h 5.7.1-1/src/mumps_pord.h
--- 5.6.2-2.1/src/mumps_pord.h	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_pord.h	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/mumps_print_defined.F 5.7.1-1/src/mumps_print_defined.F
--- 5.6.2-2.1/src/mumps_print_defined.F	2023-10-11 09:36:34.000000000 +0000
+++ 5.7.1-1/src/mumps_print_defined.F	2024-05-02 10:15:13.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -16,43 +16,25 @@ C
       INTEGER, INTENT(IN) :: MPG
       IF (MPG.LE.0) RETURN
       write(MPG,*) "================================================="
-#if defined(ALLOC_FROM_C)
-      WRITE(MPG,*) " MUMPS compiled with option -DALLOC_FROM_C"
-#endif
-#if defined(AVOID_MPI_IN_PLACE)
-      WRITE(MPG,*)
-     &  " MUMPS compiled with -DAVOID_MPI_IN_PLACE"
+#if defined(MTKO_VERBOSE)
+      write(MPG, *) 
+     & "WARNING: ",
+     & "MUMPS should not be compiled with -DMTKO_VERBOSE",
+     &              " without -DMPI_TO_K_OMP"
 #endif
 #if defined(AFFINITY_VERBOSE)
       write(MPG, *) "MUMPS compiled with option -DAFFINITY_VERBOSE"
 #endif
-#if defined(MTKO_ADVANCED_VERBOSE)
-#if ! defined(MTKO_ADVANCED)
-      write(MPG, *) "MUMPS should not be compiled with ",
-     &              "-DMTKO_ADVANCED_VERBOSE without -DMTKO_ADVANCED"
-      CALL MUMPS_ABORT()
-#else
-      write(MPG, *) "MUMPS compiled with option -DMTKO_ADVANCED_VERBOSE"
-#endif
-#endif
-#if defined(ZERO_TRIANGLE)
-      write(MPG,*) "MUMPS compiled with option -DZERO_TRIANGLE"
+#if defined(AVOID_MPI_IN_PLACE)
+      WRITE(MPG,*)
+     &  " MUMPS compiled with option -DAVOID_MPI_IN_PLACE"
 #endif
-#if defined(PRINT_BACKTRACE_ON_ABORT)
-      write(MPG, *)
-     &  "MUMPS compiled with option -DPRINT_BACKTRACE_ON_ABORT"
+#if defined(LARGEMATRICES)
+      write(MPG,*) "MUMPS compiled with option -DLARGEMATRICES"
 #endif
 #if defined(GEMMT_AVAILABLE)
       write(MPG, *) "MUMPS compiled with option -DGEMMT_AVAILABLE"
 #endif
-#if defined(WORKAROUNDINTELILP64MPI2INTEGER)
-      write(MPG,*) "MUMPS compiled with option"
-     &     ," -DWORKAROUNDINTELILP64MPI2INTEGER"
-#endif
-#if defined(WORKAROUNDILP64MPICUSTOMREDUCE)
-      write(MPG,*) "MUMPS compiled with option"
-     &     ," -DWORKAROUNDILP64MPICUSTOMREDUCE"
-#endif
 #if defined(DETERMINISTIC_PARALLEL_GRAPH)
       write(MPG,*) "MUMPS compiled with option"
      &     ," -DDETERMINISTIC_PARALLEL_GRAPH"
@@ -63,9 +45,22 @@ C
 #if defined(metis4)
       write(MPG,*) "MUMPS compiled with option -Dmetis4"
 #endif
+#if defined(MUMPS_ALLOC_FROM_C)
+      WRITE(MPG,*) " MUMPS compiled with option -DMUMPS_ALLOC_FROM_C"
+#endif
 #if defined(MUMPS_NOF2003)
       write(MPG,*) "MUMPS compiled with option -DMUMPS_NOF2003"
 #endif
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+      write(MPG,*)
+     &"MUMPS compiled with option -DMUMPS_SCOTCH_IMPORTTHREADS"
+#endif
+#if defined(MUMPS_WINLARGEFILES)
+      write(MPG,*) "MUMPS compiled with option -DMUMPS_WINLARGEFILES"
+#endif
+#if defined(MUMPS_USE_BLAS2)
+      write(MPG,*) "MUMPS compiled with option -DMUMPS_USE_BLAS2"
+#endif
 #if defined(NOSCALAPACK)
       write(MPG,*) "MUMPS compiled with option -DNOSCALAPACK"
 #endif
@@ -81,21 +76,76 @@ C
 #if defined(pord)
       write(MPG,*) "MUMPS compiled with option -Dpord"
 #endif
+#if defined(PRINT_BACKTRACE_ON_ABORT)
+      write(MPG, *)
+     &  "MUMPS compiled with option -DPRINT_BACKTRACE_ON_ABORT"
+#endif
 #if defined(ptscotch)
       write(MPG,*) "MUMPS compiled with option -Dptscotch"
 #endif
 #if defined(scotch)
       write(MPG,*) "MUMPS compiled with option -Dscotch"
 #endif
-#if defined(MUMPS_USE_BLAS2)
-      write(MPG,*) "MUMPS compiled with option -DMUMPS_USE_BLAS2"
+#if defined(NOAGG1)
+      write(MPG,*) "MUMPS compiled with option -DNOAGG1"
 #endif
-#if defined(BLR_NOOPENMP)
-      write(MPG,*) "MUMPS compiled with option -DBLR_NOOPENMP"
+#if defined(NOAGG2)
+      write(MPG,*) "MUMPS compiled with option -DNOAGG2"
+#endif
+#if defined(NOAGG3)
+      write(MPG,*) "MUMPS compiled with option -DNOAGG3"
+#endif
+#if defined(NOAGG4)
+      write(MPG,*) "MUMPS compiled with option -DNOAGG4"
+#endif
+#if defined(NOAGG5)
+      write(MPG,*) "MUMPS compiled with option -DNOAGG5"
+#endif
+#if defined(NOAMALGTOFATHER)
+      write(MPG,*) "MUMPS compiled with -DNOAMALGTOFATHER"
+#endif
+#if defined(NO_FDM_DESCBAND)
+      write(MPG,*) "MUMPS compiled with -DNO_FDM_DESCBAND"
+#endif
+#if defined(NO_FDM_MAPROW)
+      write(MPG,*) "MUMPS compiled with -DNO_FDM_MAPROW"
+#endif
+#if defined(NO_SAVE_RESTORE)
+      write(MPG,*) "MUMPS compiled with -DNO_SAVE_RESTORE"
+#endif
+#if defined(NO_SPLIT_IN_BLRGROUPING)
+      write(MPG,*) "MUMPS compiled with -DNO_SPLIT_IN_BLRGROUPING"
 #endif
 #if defined(NODYNAMICCB)
       write(MPG,*) "MUMPS compiled with option -DNODYNAMICCB"
 #endif
+#if defined(USE_OLD_SCALING)
+      write(MPG,*) "MUMPS compiled with option -DUSE_OLD_SCALING"
+#endif
+#if defined(VHOFFLOAD)
+      write(MPG,*) "MUMPS compiled with -DVHOFFLOAD"
+#endif
+#if defined(WORKAROUNDINTELILP64MPI2INTEGER)
+      write(MPG,*) "MUMPS compiled with option"
+     &     ," -DWORKAROUNDINTELILP64MPI2INTEGER"
+#endif
+#if defined(WORKAROUNDILP64MPICUSTOMREDUCE)
+      write(MPG,*) "MUMPS compiled with option"
+     &     ," -DWORKAROUNDILP64MPICUSTOMREDUCE"
+#endif
+#if defined(WORKAROUNDINTELILP64OPENMPLIMITATION)
+      write(MPG,*) "MUMPS compiled with option"
+     &     ," -DWORKAROUNDINTELILP64OPENMPLIMITATION"
+#endif
+#if defined(ZERO_TRIANGLE)
+      write(MPG,*) "MUMPS compiled with option -DZERO_TRIANGLE"
+#endif
+#if defined(BLR_NOOPENMP)
+      write(MPG,*) "MUMPS compiled with option -DBLR_NOOPENMP"
+#endif
+#if defined(STAT_ES_SOLVE)
+      write(MPG,*) "MUMPS compiled with option -DSTAT_ES_SOLVE"
+#endif
       write(MPG,*) "================================================="
       RETURN
       END SUBROUTINE MUMPS_PRINT_IF_DEFINED
diff -pruN 5.6.2-2.1/src/mumps_register_thread.c 5.7.1-1/src/mumps_register_thread.c
--- 5.6.2-2.1/src/mumps_register_thread.c	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_register_thread.c	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/mumps_register_thread.h 5.7.1-1/src/mumps_register_thread.h
--- 5.6.2-2.1/src/mumps_register_thread.h	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_register_thread.h	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/mumps_save_restore_C.c 5.7.1-1/src/mumps_save_restore_C.c
--- 5.6.2-2.1/src/mumps_save_restore_C.c	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_save_restore_C.c	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
@@ -18,6 +18,7 @@
 #include <string.h>
 #include "mumps_save_restore_C.h"
 #include "mumps_common.h"
+#if ! defined(NO_SAVE_RESTORE)
 /* Functions */
 void MUMPS_CALL
 MUMPS_GET_SAVE_DIR_C(MUMPS_INT *len_save_dir, char* save_dir, mumps_ftnlen l1)
@@ -43,10 +44,9 @@ MUMPS_GET_SAVE_PREFIX_C(MUMPS_INT *len_s
   *len_save_prefix = strlen(tmp_save_prefix);
   save_prefix = strncpy(save_prefix, tmp_save_prefix, l1); 
 }
+#else
 void MUMPS_CALL
 MUMPS_SAVE_RESTORE_RETURN_C()
 {
-  /*
-  Save/restore feature will be available in the future
-  */
 }
+#endif
diff -pruN 5.6.2-2.1/src/mumps_save_restore_C.h 5.7.1-1/src/mumps_save_restore_C.h
--- 5.6.2-2.1/src/mumps_save_restore_C.h	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_save_restore_C.h	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
@@ -16,6 +16,7 @@
 #ifndef MUMPS_SAVE_RESTORE_C_H
 #define MUMPS_SAVE_RESTORE_C_H
 #include "mumps_common.h"
+#if ! defined(NO_SAVE_RESTORE)
 #define MUMPS_GET_SAVE_DIR_C \
     F_SYMBOL(get_save_dir_c,GET_SAVE_DIR_C)
 void MUMPS_CALL
@@ -24,6 +25,7 @@ MUMPS_GET_SAVE_DIR_C(MUMPS_INT *len_save
     F_SYMBOL(get_save_prefix_c,GET_SAVE_PREFIX_C)
 void MUMPS_CALL
 MUMPS_GET_SAVE_PREFIX_C(MUMPS_INT *len_save_prefix, char* save_prefix, mumps_ftnlen l1);
+#endif
 #define MUMPS_SAVE_RESTORE_RETURN_C \
     F_SYMBOL(save_restore_return_c,SAVE_RESTORE_RETURN_C)
 void MUMPS_CALL
diff -pruN 5.6.2-2.1/src/mumps_save_restore_modes.h 5.7.1-1/src/mumps_save_restore_modes.h
--- 5.6.2-2.1/src/mumps_save_restore_modes.h	1970-01-01 00:00:00.000000000 +0000
+++ 5.7.1-1/src/mumps_save_restore_modes.h	2024-05-02 10:15:14.000000000 +0000
@@ -0,0 +1,30 @@
+C
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
+C
+C
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Mumps Technologies, University of Bordeaux.
+C
+C  This version of MUMPS is provided to you free of charge. It is
+C  released under the CeCILL-C license 
+C  (see doc/CeCILL-C_V1-en.txt, doc/CeCILL-C_V1-fr.txt, and
+C  https://cecill.info/licences/Licence_CeCILL-C_V1-en.html)
+C
+C     Define constants for possible modes:
+C
+C       memory_save  = compute the size of the save
+C                      file and of the structure
+C       save         = save the instance
+C       restore      = restore the instance
+C       restore_ooc  = restore the ooc part of the
+C                      instance
+C       fake_restore = extract from the saved file
+C                      the size of the save file and of
+C                      the structure
+C
+      INTEGER, PARAMETER :: memory_save_mode=1
+      INTEGER, PARAMETER :: save_mode=2
+      INTEGER, PARAMETER :: restore_mode=3
+      INTEGER, PARAMETER :: restore_ooc_mode=4
+      INTEGER, PARAMETER :: fake_restore_mode=5
diff -pruN 5.6.2-2.1/src/mumps_scotch.c 5.7.1-1/src/mumps_scotch.c
--- 5.6.2-2.1/src/mumps_scotch.c	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_scotch.c	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
@@ -20,6 +20,20 @@
 #include "mumps_scotch.h"
 #if defined(scotch) || defined(ptscotch)
 void MUMPS_CALL
+MUMPS_SCOTCH_WEIGHTUSED( 
+                        MUMPS_INT  * const  weightused         /* out   */
+                       )
+{
+/* weightused(out) = 1 if weight of nodes can be used 
+                   = 0 otherwise
+*/
+#if ((SCOTCH_VERSION == 6) && (SCOTCH_RELEASE >= 1)) || (SCOTCH_VERSION >= 7)
+       *weightused=1;
+#else       
+       *weightused=0;
+#endif
+}
+void MUMPS_CALL
 MUMPS_SCOTCH_ORD( const MUMPS_INT * const  n,  /* NCMP or N */
               const MUMPS_INT * const  iwlen,   /* LIW8 */
                     MUMPS_INT * const  petab,   /* IPE */
@@ -30,8 +44,11 @@ MUMPS_SCOTCH_ORD( const MUMPS_INT * cons
                     MUMPS_INT * const  elentab, /* permutation on output (permtab) */
                     MUMPS_INT * const  lasttab,
                     MUMPS_INT * const  ncmpa,
-                    MUMPS_INT * const  weightused,
-                    MUMPS_INT * const  weightrequested )
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+                    SCOTCH_Context * const contextptr,
+#endif
+                    MUMPS_INT * const  weightused,         /* out   */
+                    MUMPS_INT * const  weightrequested )   /* in   */
 {
 /* weightused(out) = weightrequested since it is always used to build graph 
    FIXME it is not exploited on output and could be suppressed from interface 
@@ -39,23 +56,38 @@ MUMPS_SCOTCH_ORD( const MUMPS_INT * cons
 */
   MUMPS_INT * vendtab ;                    /* Vertex end array */
   SCOTCH_Graph grafdat;                    /* Graph            */
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+  SCOTCH_Graph grafdat_with_context;
+#endif
   SCOTCH_Strat stratdat;
   MUMPS_INT vertnum;
+  int ierr;
   *weightused = *weightrequested;
   vendtab=malloc(*n * sizeof(MUMPS_INT));
   for (vertnum = 0; vertnum < *n; vertnum ++)
     vendtab[vertnum] = petab[vertnum] + lentab[vertnum];
-  SCOTCH_graphInit        (&grafdat);
+  ierr=SCOTCH_graphInit        (&grafdat);
   if ( *weightrequested == 1 )
   {
-    SCOTCH_graphBuild (&grafdat, 1, *n, (SCOTCH_Num *) petab, (SCOTCH_Num *) vendtab, (SCOTCH_Num *) nvtab, NULL, *iwlen, (SCOTCH_Num *) iwtab, NULL); /* Assume Fortran-based indexing */
+    ierr=SCOTCH_graphBuild (&grafdat, 1, *n, (SCOTCH_Num *) petab, (SCOTCH_Num *) vendtab, (SCOTCH_Num *) nvtab, NULL, *iwlen, (SCOTCH_Num *) iwtab, NULL); /* Assume Fortran-based indexing */
   }
   else
   {
-   SCOTCH_graphBuild (&grafdat, 1, *n, (SCOTCH_Num *) petab, (SCOTCH_Num *) vendtab, NULL, NULL, *iwlen, (SCOTCH_Num *) iwtab, NULL); /* Assume Fortran-based indexing */
+    ierr=SCOTCH_graphBuild (&grafdat, 1, *n, (SCOTCH_Num *) petab, (SCOTCH_Num *) vendtab, NULL, NULL, *iwlen, (SCOTCH_Num *) iwtab, NULL); /* Assume Fortran-based indexing */
   }
-  SCOTCH_stratInit(&stratdat);
+  ierr=SCOTCH_stratInit(&stratdat);
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+  /* Initialize and bind grafdat_with_context */
+  ierr=SCOTCH_graphInit        (&grafdat_with_context);
+  ierr=SCOTCH_contextBindGraph(contextptr, &grafdat, &grafdat_with_context);
+  *ncmpa=SCOTCH_graphOrder(&grafdat_with_context, &stratdat, (SCOTCH_Num *) elentab, (SCOTCH_Num *) lasttab, NULL, NULL, NULL);
+#else
+  /* order grafdat without threads context */
   *ncmpa=SCOTCH_graphOrder(&grafdat, &stratdat, (SCOTCH_Num *) elentab, (SCOTCH_Num *) lasttab, NULL, NULL, NULL);
+#endif
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+  SCOTCH_graphExit(&grafdat_with_context);
+#endif
   SCOTCH_stratExit(&stratdat);
   SCOTCH_graphExit(&grafdat);
   free(vendtab);
@@ -71,6 +103,10 @@ MUMPS_SCOTCH( const MUMPS_INT * const  n
                     MUMPS_INT * const  elentab,
                     MUMPS_INT * const  lasttab,
                     MUMPS_INT * const  ncmpa,
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+/* FIXME: see how to pass contextptr to esmumps/esmumpsv */
+                    SCOTCH_Context * const contextptr,
+#endif
                     MUMPS_INT * const  weightused,
                     MUMPS_INT * const  weightrequested )
 {
diff -pruN 5.6.2-2.1/src/mumps_scotch.h 5.7.1-1/src/mumps_scotch.h
--- 5.6.2-2.1/src/mumps_scotch.h	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_scotch.h	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
@@ -28,6 +28,10 @@ MUMPS_INT esmumpsv( const MUMPS_INT n, c
 MUMPS_INT esmumps( const MUMPS_INT n, const MUMPS_INT iwlen, MUMPS_INT * const pe, const MUMPS_INT pfree,
              MUMPS_INT * const len, MUMPS_INT * const iw, MUMPS_INT * const nv, MUMPS_INT * const elen,
              MUMPS_INT * const last);
+#define  MUMPS_SCOTCH_WEIGHTUSED       \
+    F_SYMBOL(scotch_weightused,SCOTCH_WEIGHTUSED)
+void MUMPS_CALL
+MUMPS_SCOTCH_WEIGHTUSED( MUMPS_INT  * const  weightused );
 #define MUMPS_SCOTCH_ORD        \
     F_SYMBOL(scotch_ord,SCOTCH_ORD)
 void MUMPS_CALL
@@ -41,6 +45,9 @@ MUMPS_SCOTCH_ORD( const MUMPS_INT * cons
               MUMPS_INT * const        elentab,
               MUMPS_INT * const        lasttab,
               MUMPS_INT * const        ncmpa, 
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+              SCOTCH_Context * const contextptr,
+#endif
               MUMPS_INT * const        weightused,
               MUMPS_INT * const        weightrequested );
 #define MUMPS_SCOTCH        \
@@ -56,6 +63,9 @@ MUMPS_SCOTCH( const MUMPS_INT * const  n
               MUMPS_INT * const        elentab,
               MUMPS_INT * const        lasttab,
               MUMPS_INT * const        ncmpa, 
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+              SCOTCH_Context * const contextptr,
+#endif
               MUMPS_INT * const        weightused,
               MUMPS_INT * const        weightrequested );
 #define MUMPS_SCOTCH_VERSION        \
diff -pruN 5.6.2-2.1/src/mumps_scotch64.c 5.7.1-1/src/mumps_scotch64.c
--- 5.6.2-2.1/src/mumps_scotch64.c	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_scotch64.c	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
@@ -21,17 +21,20 @@
 #if defined(scotch) || defined(ptscotch)
 void MUMPS_CALL
 MUMPS_SCOTCH_ORD_64( const MUMPS_INT8 * const  n,        /* in    */
-                 const MUMPS_INT8 * const  iwlen,    /* in    */
-                       MUMPS_INT8 * const  petab,    /* inout */
-                 const MUMPS_INT8 * const  pfree,    /* in    */
-                       MUMPS_INT8 * const  lentab,   /* in (modified in ANA_H) */
-                       MUMPS_INT8 * const  iwtab,    /* in (modified in ANA_H) */
-                       MUMPS_INT8 * const  nvtab,    /* out or inout if weight used on entry   */
-                       MUMPS_INT8 * const  elentab,  /* out permutation on output  */
-                       MUMPS_INT8 * const  lasttab,  /* out   */
-                       MUMPS_INT  * const  ncmpa,    /* out   */
-                       MUMPS_INT  * const  weightused,         /* out   */
-                       MUMPS_INT  * const  weightrequested )   /* in   */
+              const MUMPS_INT8 * const  iwlen,    /* in    */
+                    MUMPS_INT8 * const  petab,    /* inout */
+              const MUMPS_INT8 * const  pfree,    /* in    */
+                    MUMPS_INT8 * const  lentab,   /* in (modified in ANA_H) */
+                    MUMPS_INT8 * const  iwtab,    /* in (modified in ANA_H) */
+                    MUMPS_INT8 * const  nvtab,    /* out or inout if weight used on entry   */
+                    MUMPS_INT8 * const  elentab,  /* out permutation on output  */
+                    MUMPS_INT8 * const  lasttab,  /* out   */
+                    MUMPS_INT  * const  ncmpa,    /* out   */
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+                    SCOTCH_Context * const contextptr,
+#endif
+                    MUMPS_INT * const  weightused,         /* out   */
+                    MUMPS_INT * const  weightrequested )   /* in   */
 {
 /* weightused(out) = weightrequested since it is always used to build graph 
    FIXME it is not exploited on output and could be suppressed from interface 
@@ -43,23 +46,38 @@ MUMPS_SCOTCH_ORD_64( const MUMPS_INT8 *
 */
   MUMPS_INT8 * vendtab ;                    /* Vertex end array */
   SCOTCH_Graph grafdat;                    /* Graph            */
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+  SCOTCH_Graph grafdat_with_context;
+#endif
   SCOTCH_Strat stratdat;
   MUMPS_INT8 vertnum;
+  int ierr;
   *weightused = *weightrequested;
-  vendtab=malloc(*n * sizeof(MUMPS_INT));
+  vendtab=malloc(*n * sizeof(MUMPS_INT8));
   for (vertnum = 0; vertnum < *n; vertnum ++)
     vendtab[vertnum] = petab[vertnum] + lentab[vertnum];
-  SCOTCH_graphInit        (&grafdat);
+  ierr=SCOTCH_graphInit        (&grafdat);
   if ( *weightrequested == 1 )
   {
-    SCOTCH_graphBuild (&grafdat, 1, *n, (SCOTCH_Num *) petab, (SCOTCH_Num *) vendtab, (SCOTCH_Num *) nvtab, NULL, *iwlen, (SCOTCH_Num *) iwtab, NULL); /* Assume Fortran-based indexing */
+    ierr=SCOTCH_graphBuild (&grafdat, 1, *n, (SCOTCH_Num *) petab, (SCOTCH_Num *) vendtab, (SCOTCH_Num *) nvtab, NULL, *iwlen, (SCOTCH_Num *) iwtab, NULL); /* Assume Fortran-based indexing */
   }
   else
   {
-   SCOTCH_graphBuild (&grafdat, 1, *n, (SCOTCH_Num *) petab, (SCOTCH_Num *) vendtab, NULL, NULL, *iwlen, (SCOTCH_Num *) iwtab, NULL); /* Assume Fortran-based indexing */
+    ierr=SCOTCH_graphBuild (&grafdat, 1, *n, (SCOTCH_Num *) petab, (SCOTCH_Num *) vendtab, NULL, NULL, *iwlen, (SCOTCH_Num *) iwtab, NULL); /* Assume Fortran-based indexing */
   }
-  SCOTCH_stratInit(&stratdat);
+  ierr=SCOTCH_stratInit(&stratdat);
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+  /* Initialize and bind grafdat_with_context */
+  ierr=SCOTCH_graphInit        (&grafdat_with_context);
+  ierr=SCOTCH_contextBindGraph(contextptr, &grafdat, &grafdat_with_context);
+  *ncmpa=SCOTCH_graphOrder(&grafdat_with_context, &stratdat, (SCOTCH_Num *) elentab, (SCOTCH_Num *) lasttab, NULL, NULL, NULL);
+#else
+  /* order grafdat without threads context */
   *ncmpa=SCOTCH_graphOrder(&grafdat, &stratdat, (SCOTCH_Num *) elentab, (SCOTCH_Num *) lasttab, NULL, NULL, NULL);
+#endif
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+  SCOTCH_graphExit(&grafdat_with_context);
+#endif
   SCOTCH_stratExit(&stratdat);
   SCOTCH_graphExit(&grafdat);
   free(vendtab);
@@ -75,6 +93,10 @@ MUMPS_SCOTCH_64( const MUMPS_INT8 * cons
                        MUMPS_INT8 * const  elentab,  /* out   */
                        MUMPS_INT8 * const  lasttab,  /* out   */
                        MUMPS_INT  * const  ncmpa,    /* out   */
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+/* FIXME: see how to pass contextptr to esmumps/esmumpsv */
+                    SCOTCH_Context * const contextptr,
+#endif
                        MUMPS_INT  * const  weightused,         /* out   */
                        MUMPS_INT  * const  weightrequested )   /* in   */
 {
diff -pruN 5.6.2-2.1/src/mumps_scotch64.h 5.7.1-1/src/mumps_scotch64.h
--- 5.6.2-2.1/src/mumps_scotch64.h	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_scotch64.h	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
@@ -36,13 +36,16 @@ MUMPS_SCOTCH_ORD_64( const MUMPS_INT8 *
                        MUMPS_INT8 * const  petab,
                  const MUMPS_INT8 * const  pfree,
                        MUMPS_INT8 * const  lentab,
-                       MUMPS_INT8 * const  iwtab,
-                       MUMPS_INT8 * const  nvtab,
-                       MUMPS_INT8 * const  elentab,
-                       MUMPS_INT8 * const  lasttab,
-                       MUMPS_INT  * const  ncmpa,
-                       MUMPS_INT  * const  weightused,
-                       MUMPS_INT  * const  weightrequested );
+              MUMPS_INT8 * const  iwtab,
+              MUMPS_INT8 * const  nvtab,
+              MUMPS_INT8 * const  elentab,
+              MUMPS_INT8 * const  lasttab,
+              MUMPS_INT * const   ncmpa, 
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+              SCOTCH_Context * const contextptr,
+#endif
+              MUMPS_INT  * const  weightused,
+              MUMPS_INT  * const  weightrequested );
 #define MUMPS_SCOTCH_64 \
   F_SYMBOL(scotch_64,SCOTCH_64)
 void MUMPS_CALL
@@ -56,6 +59,9 @@ MUMPS_SCOTCH_64( const MUMPS_INT8 * cons
                        MUMPS_INT8 * const  elentab,
                        MUMPS_INT8 * const  lasttab,
                        MUMPS_INT  * const  ncmpa,
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+              SCOTCH_Context * const contextptr,
+#endif
                        MUMPS_INT  * const  weightused,
                        MUMPS_INT  * const  weightrequested );
 #endif
diff -pruN 5.6.2-2.1/src/mumps_scotch_int.c 5.7.1-1/src/mumps_scotch_int.c
--- 5.6.2-2.1/src/mumps_scotch_int.c	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_scotch_int.c	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/mumps_scotch_int.h 5.7.1-1/src/mumps_scotch_int.h
--- 5.6.2-2.1/src/mumps_scotch_int.h	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_scotch_int.h	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/mumps_static_mapping.F 5.7.1-1/src/mumps_static_mapping.F
--- 5.6.2-2.1/src/mumps_static_mapping.F	2023-10-11 09:36:35.000000000 +0000
+++ 5.7.1-1/src/mumps_static_mapping.F	2024-05-02 10:15:13.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -16,7 +16,8 @@ C
       IMPLICIT NONE
       PRIVATE
       PUBLIC :: MUMPS_DISTRIBUTE, MUMPS_RETURN_CANDIDATES,
-     &     MUMPS_INIT_ARCH_PARAMETERS,MUMPS_END_ARCH_CV
+     &     MUMPS_INIT_ARCH_PARAMETERS,MUMPS_END_ARCH_CV,
+     &     MUMPS_SET_K78_83_91
       integer,pointer,dimension(:,:),SAVE::cv_cand
       integer,pointer,dimension(:),SAVE::cv_par2_nodes
       integer,SAVE::cv_slavef,cv_nb_niv2,cv_lp,cv_mp
@@ -339,20 +340,34 @@ C
          DV_RATE=0.2D0
        ENDIF
       endif
-      dpkeep102 = dble(cv_keep(102))
+      IF (cv_keep(102) .NE. -1) THEN
+         dpkeep102 = max(dble(cv_keep(102)),dble(100))
+      ELSE 
+        IF(cv_slavef.LT.48)THEN
+           dpkeep102=dble(150)
+        ELSEIF(cv_slavef.LT.128)THEN
+           dpkeep102=dble(150)
+        ELSEIF(cv_slavef.LT.256)THEN
+           dpkeep102=dble(200)
+        ELSEIF(cv_slavef.LT.512)THEN
+           dpkeep102=dble(300)
+        ELSEIF(cv_slavef.GE.512)THEN
+           dpkeep102=dble(400)
+        ENDIF
+      ENDIF
       IF (cv_keep(198).NE.0) THEN
         IF (cv_slavef.LT.3)THEN
-         dpkeep102 = dble(150)
+         dpkeep102 = max(dble(150), dpkeep102)
         ELSEIF (cv_slavef.LT.5)THEN
-         dpkeep102 = dble(200)
+         dpkeep102 = max(dble(200), dpkeep102)
         ELSEIF (cv_slavef.LT.8)THEN
-         dpkeep102 = dble(250)
+         dpkeep102 = max(dble(250), dpkeep102)
         ELSEIF (cv_slavef.LT.32)THEN
-         dpkeep102 = dble(275)
+         dpkeep102 = max(dble(275), dpkeep102)
         ELSEIF (cv_slavef.LT.512)THEN
-         dpkeep102 = dble(300)
+         dpkeep102 = max(dble(300), dpkeep102)
         ELSEIF (cv_slavef.GE.512)THEN
-         dpkeep102 = dble(400)
+         dpkeep102 = max(dble(400), dpkeep102)
         ENDIF
       ENDIF
       subname='ACCEPT_L0'
@@ -655,9 +670,6 @@ C
      &     (npiv.ge.cv_keep(490)).and.(nfront.ge.cv_keep(491))) then
            WRITE(*,*) " *** Temp internal error in MUMPS_CALCNODECOSTS:"
            CALL MUMPS_ABORT()
-           call MUMPS_CALCNODECOSTS_BLR(npiv, nfront, costw, costm,
-     &              cv_keep(471), cv_keep(472), cv_keep(475), 
-     &              cv_keep(488), cv_keep(50))
          else
            if(cv_keep(50).eq.0) then
              costw= 2.0D0*dble(nfront)*dble(npiv)*dble(nfront-npiv-1)
@@ -677,64 +689,6 @@ C
       endif
       return
       end subroutine MUMPS_CALCNODECOSTS
-      SUBROUTINE MUMPS_CALCNODECOSTS_BLR(NPIV, NFRONT, COSTW, COSTM,
-     &                   K471, K472, K475, K488, SYM)
-        INTEGER, INTENT(IN) :: NPIV, NFRONT, SYM, K471, K472, K475, K488
-        DOUBLE PRECISION, INTENT(OUT) :: COSTW, COSTM
-        INTEGER :: IBCKSZ
-        DOUBLE PRECISION :: B,R,M,N
-        M = DBLE(NPIV)
-        N = DBLE(NFRONT)
-        CALL COMPUTE_BLR_VCS(K472, IBCKSZ, K488, NPIV) 
-        B = DBLE(IBCKSZ)
-        B = MIN(B,M)
-        IF (K471.EQ.0) THEN
-          R = 1.0D0
-        ELSEIF (K471.EQ.1) THEN
-          R = SQRT(DBLE(N))
-       ELSE
-          WRITE(*,*) 'Internal error in MUMPS_CALCNODECOSTS_BLR', K471
-          CALL MUMPS_ABORT()
-        ENDIF
-        R = MIN(R,B/2)
-        IF (SYM.EQ.0) THEN
-          COSTW = M/B * B*(B+1.0D0)*(2.0D0*B+1.0D0)/3.0D0
-          IF (K475.EQ.0) THEN
-            COSTW = COSTW + 2.0D0*M/(B*B)*(N-(M+B)/2.0D0) * B*B*B
-          ELSEIF (K475.EQ.1) THEN
-            COSTW = COSTW + M/(B*B)*(N-(M+B)/2.0D0) * B*B*(R+B)
-          ELSEIF (K475.EQ.2) THEN
-            COSTW = COSTW + M/(B*B)*(2.0D0*N-3.0D0*M-2.0D0*B) * B*B*R
-     &                    + (M/B-1.0D0)*M/B*(M/B-1.0D0)/6.0D0 * B*B*B
-          ELSEIF (K475.EQ.3) THEN
-            COSTW = COSTW + 2.0D0*M/(B*B)*(N-(M+B)/2.0D0) * B*B*R
-          ENDIF
-          COSTW = COSTW + 2.0D0*M/(B*B)*(N-(M+B)/2.0D0) * 2.0D0*B*B*R
-          COSTW = COSTW + (4.0D0*B*R*R + 2.0D0*B*B*R) * (
-     &                  (N-M)*(N-M)*M/(B*B*B) 
-     &                + (N-M)/B*(M/B-1.0D0)*M/B 
-     &                + (M/B-1.0D0)*M/B*(2.0D0*M/B-1.0D0)/6.0D0 
-     &       )     
-          COSTM = M*(2.0D0*N-M)/(B*B) * 2.0D0*B*R
-        ELSE
-          COSTW = M/B * B*(B+1.0D0)*(2.0D0*B+1.0D0)/6.0D0
-          IF (K475.EQ.0.OR.K475.EQ.1) THEN
-            COSTW = COSTW + M/(B*B)*(N-(M+B)/2.0D0) * B*B*B
-          ELSEIF (K475.EQ.2) THEN
-            COSTW = COSTW + (N-M)*M/(B*B) * B*B*R
-     &                    + (M/B-1.0D0)*M/B*(M/B-1.0D0)/6.0D0 * B*B*B
-          ELSEIF (K475.EQ.3) THEN
-            COSTW = COSTW + M/(B*B)*(N-(M+B)/2.0D0) * B*B*R
-          ENDIF
-          COSTW = COSTW + M/(B*B)*(N-(M+B)/2.0D0) * 2.0D0*B*B*R
-          COSTW = COSTW + (4.0D0*B*R*R + 2.0D0*B*B*R) * (
-     &                      (N-M)*(N-M)*M/(B*B*B)/2.0D0 
-     &                    + (N-M)/B*(M/B-1.0D0)*M/B/2.0D0 
-     &                    + (M/B-1.0D0)*M/B*(M/B+1.0D0)/6.0D0 
-     &       )     
-          COSTM = M*N/(B*B) * 2.0D0*B*R
-        ENDIF
-      END SUBROUTINE MUMPS_CALCNODECOSTS_BLR
       SUBROUTINE MUMPS_COSTS_BLR_T2_MASTER(NPIV, NFRONT, 
      &                   COSTW, COSTM, K471, K472, K475, K488, SYM)
         INTEGER, INTENT(IN) :: NPIV, NFRONT, SYM, K471, K472, K475, K488
@@ -743,7 +697,8 @@ C
         DOUBLE PRECISION :: B,R,M,N
         M = DBLE(NPIV)
         N = DBLE(NFRONT)
-        CALL COMPUTE_BLR_VCS(K472, IBCKSZ, K488, NPIV) 
+        CALL COMPUTE_BLR_VCS(K472, IBCKSZ, K488, NPIV, 
+     &                       NFRONT, cv_keep(35)) 
         B = DBLE(IBCKSZ)
         B = MIN(B,M)
         IF (K471.EQ.0) THEN
@@ -804,7 +759,8 @@ C
         M = NROW
         N = DBLE(NFRONT)
         P = DBLE(NPIV)
-        CALL COMPUTE_BLR_VCS(K472, IBCKSZ, K488, NPIV) 
+        CALL COMPUTE_BLR_VCS(K472, IBCKSZ, K488, NPIV, 
+     &                       NFRONT, cv_keep(35)) 
         B = DBLE(IBCKSZ)
         B = MIN(B,M)
         IF (K471.EQ.0) THEN
@@ -1412,7 +1368,7 @@ C
          keep48_loc=3
       endif
       if (cv_keep(48).EQ.5) keep48_loc = 5
-      if(npropmap .gt. cv_keep(83)) then
+      if(npropmap .gt. abs(cv_keep(83))) then
          nslaves_max   = MUMPS_BLOC2_GET_NSLAVESMAX(
      &        cv_slavef, keep48_loc, cv_keep8(21),
      &        cv_keep(50), nfront, 
@@ -1451,7 +1407,13 @@ C
             k1 = max(1,kk-1)
             exit
          endif
-         wk_master2 = wk_master / dble(kk)
+         if (cv_keep(50).eq.0) then
+           wk_master2 = (dble(2)/dble(3))*
+     &          dble(npiv2)*dble(npiv2)*dble(npiv2)+
+     &          dble(npiv2)*dble(npiv2)*dble(nfront2-npiv2)
+         else
+           wk_master2 = dble(npiv2)*dble(npiv2)*dble(npiv2)/dble(3)
+         end if
          if (cv_keep(50).eq.0) then
             wk_slave2  = ( dble(npiv2)*dble(nfront2-npiv2) *
      &           dble(2*nfront2-npiv2) ) / dble(nslaves_estim)
@@ -2023,13 +1985,13 @@ C
      &        'Warning in mumps_static_mapping : splitting is set off'
          cv_keep(82) = 0
       endif
-      if(cv_keep(83) .lt. 0) then
+      if(abs(cv_keep(83)) .lt. 0) then
          write(cv_lp,*)
      &        'warning in mumps_static_mapping : keep(83) reset to 0'
          cv_keep(83) = 0
       endif
       if(slavef.gt.1) then
-         cv_mixed_strat_bound = max(cv_keep(78),1)
+         cv_mixed_strat_bound = max(abs(cv_keep(78)),1)
          cv_maxdepth = slavef
       else
          cv_maxdepth = 0
@@ -2376,7 +2338,7 @@ C
          call MUMPS_BIT_SET(procindex,i,ierr)
          if(ierr.ne.0) then
             if(cv_lp.gt.0)write(cv_lp,*)
-     &           'MUMPS_BIT_SET signalled error to',subname
+     &           'MUMPS_BIT_SET signalled error to ',subname
             istat = ierr
             GOTO 999
          end if
@@ -2397,15 +2359,16 @@ C
             call MUMPS_PROPMAP(i,pctr,ierr)
             if(ierr.ne.0) then
             if(cv_lp.gt.0)write(cv_lp,*)
-     &           'PROPMAP signalled error to',subname
+     &           'PROPMAP signalled error to ',subname
                istat = ierr
                GOTO 999
             endif
-            if((cv_keep(24).eq.16).OR.(cv_keep(24).eq.18)) then
+            if( (cv_keep(24).eq.16.OR.cv_keep(24).eq.18)
+     &          .and.cv_keep(77) .ne.0) then
                call MUMPS_MOD_PROPMAP(i,pctr2,ierr)
                if(ierr.ne.0) then
                   if(cv_lp.gt.0)write(cv_lp,*)
-     &           'MOD_PROPMAP signalled error to',subname
+     &           'MOD_PROPMAP signalled error to ',subname
                   istat = ierr
                   GOTO 999
                endif
@@ -3054,12 +3017,6 @@ C
       son=in 
       do while(in.gt.0)
          nmb_sons_inode = nmb_sons_inode + 1
-         if(cv_tcostw(in).le.0.0D0) then
-            if(cv_lp.gt.0)
-     &           write(cv_lp,*)'Subtree costs for ',in,
-     &                         ' should be positive in ',subname
-            goto 999
-         endif
          if (cv_keep(67) .ne. 1) then
            costs_sons = costs_sons + cv_tcostw(in)
          else
@@ -3248,8 +3205,8 @@ C
       DOUBLE PRECISION :: loc_relax
       INTEGER :: depth
       logical force_cand
-      integer MUMPS_REG_GETKMAX, MUMPS_BLOC2_GET_NSLAVESMIN
-      external MUMPS_REG_GETKMAX, MUMPS_BLOC2_GET_NSLAVESMIN
+      integer MUMPS_BLOC2_GET_NSLAVESMIN
+      external MUMPS_BLOC2_GET_NSLAVESMIN
       DOUBLE PRECISION Y
       integer nmb_propmap_strict,share2,procsrest,current2
       integer k69onid,nb_free_procs,local_son_indice,nb_procs_for_sons,
@@ -3303,12 +3260,6 @@ C
       son=in 
       do while(in.gt.0)
          nmb_sons_inode = nmb_sons_inode + 1
-         if(cv_tcostw(in).le.0.0D0) then
-            if(cv_lp.gt.0)
-     &           write(cv_lp,*)'Subtree costs for ',in,
-     &                         ' should be positive in ',subname
-            return
-         endif
          if (cv_keep(67) .ne. 1) then
            costs_sons = costs_sons + cv_tcostw(in)
          else
@@ -3406,7 +3357,7 @@ C
             are_sons_treated=.FALSE.
             nb_procs_for_sons=nmb_procs_inode
             nmb_propmap_strict=nmb_procs_inode
-         elseif(nmb_procs_inode .LE. cv_keep(83)) then
+         elseif(nmb_procs_inode .LE. abs(cv_keep(83))) then
             procs4son = cv_prop_map(inode)%ind_proc
             are_sons_treated=.FALSE.
             nb_procs_for_sons=nmb_procs_inode
@@ -3638,7 +3589,7 @@ C
          if( (nmb_sons_inode.ge.nmb_procs_inode).AND.
      &       (nmb_procs_inode.LT.4) ) then
             procs4son = cv_prop_map(inode)%ind_proc
-         elseif(nmb_procs_inode .LE. cv_keep(83)) then
+         elseif(nmb_procs_inode .LE. abs(cv_keep(83))) then
             procs4son = cv_prop_map(inode)%ind_proc
          else
             procs4son = cv_prop_map(in)%ind_proc
@@ -3672,7 +3623,7 @@ C
             else
                min_cand_needed = 0
             endif
-            min_cand_needed = max(min_cand_needed, cv_keep(91))
+            min_cand_needed = max(min_cand_needed, abs(cv_keep(91)))
             if(costs_sons.gt.0.0D0) then
                if (cv_keep(67) .ne.1) then
                  relative_weight=cv_tcostw(in)/costs_sons
@@ -3693,7 +3644,7 @@ C
      &          max(0,nint(relative_weight*(loc_relax-dble(1))*
      &                                   dble(nmb_procs_inode)))
             share2 = max(share2, min_cand_needed -nmb_propmap_strict,
-     &                   (cv_keep(83)/2) - nmb_propmap_strict)
+     &                   (abs(cv_keep(83))/2) - nmb_propmap_strict)
             procsrest=nmb_procs_inode - nmb_propmap_strict
             share2=min(share2,procsrest)
             share2 = 0 
@@ -4334,7 +4285,8 @@ C
       end subroutine MUMPS_RETURN_CANDIDATES
       subroutine MUMPS_INIT_ARCH_PARAMETERS(
      &     total_comm,working_comm,keep69,par,
-     &     nbslaves,mem_distrib,informerr)
+     &     nbslaves,mem_distrib,informerr
+     &)
       implicit none
       include 'mpif.h'
       integer nbslaves
@@ -4402,11 +4354,12 @@ C
             endif
           enddo
         endif
-        if((nb_arch_nodes .eq. 1) .or.
-     &     (nb_arch_nodes .eq. cv_slavef)) then
+      if((nb_arch_nodes .eq. 1) .or.
+     &   (nb_arch_nodes .eq. cv_slavef)
+     &  ) then
          ke69 = 1
-         keep69 = 1
          deallocate(mem_distribtmp)
+         keep69 = 1
          return
       endif
       if (host .eq. 0) then
@@ -4436,6 +4389,32 @@ C
       endif
       return
       end subroutine MUMPS_INIT_ARCH_PARAMETERS
+      subroutine MUMPS_SET_K78_83_91 (NSLAVES, 
+     &                                KEEP78, KEEP83, KEEP91)
+      INTEGER, INTENT(IN)    :: NSLAVES
+      INTEGER, INTENT(INOUT) :: KEEP78, KEEP83, KEEP91
+      IF (KEEP78 .LT. 0) THEN
+        IF (NSLAVES.GT.4) THEN
+          KEEP78=max(
+     &       int(log(real(NSLAVES))/log(real(2))) - 2 
+     &       , 0         )
+          KEEP78 = -KEEP78
+        ELSE
+          KEEP78 = 0   
+        ENDIF
+      ENDIF
+      IF (KEEP83.LT.0) THEN 
+        KEEP83 = min(8,NSLAVES/4)
+        KEEP83 = max(min(4,NSLAVES),max(KEEP83,1))
+        KEEP83 = - KEEP83
+      ENDIF
+      IF (KEEP91.LT.0) THEN 
+        KEEP91  = min(8, NSLAVES)
+        KEEP91  = max(min(4,NSLAVES),min(abs(KEEP83),KEEP91))
+        KEEP91 = - KEEP91
+      ENDIF
+      return
+      end subroutine MUMPS_SET_K78_83_91
       subroutine MUMPS_COMPUTE_NB_ARCH_NODES()
       implicit none
       integer i
@@ -4811,20 +4790,25 @@ C
           KEEP(38) = 0
 #if ! defined(NOSCALAPACK)
         ELSE
-         IROOTTREE=-1
-         SIZEROOT=-1
-         DO I=1,N
-            IF (FRERE(I).EQ.0) THEN
-               NFRONT = ND(I)
-               IF (NFRONT .GT.SIZEROOT) THEN
-                  IROOTTREE = I
-                  SIZEROOT  = NFRONT
-               END IF
-            END IF
-         END DO
-         IF ((IROOTTREE.EQ.-1).OR.(SIZEROOT.EQ.-1)) THEN
-            ISTAT = -1
-            RETURN
+         IF ((KEEP(38).GT.0).AND.(KEEP(38).LE.N)) THEN
+           IROOTTREE = KEEP(38)
+           SIZEROOT  = ND(KEEP(38))
+         ELSE
+           IROOTTREE=-1
+           SIZEROOT=-1
+           DO I=1,N
+              IF (FRERE(I).EQ.0) THEN
+                 NFRONT = ND(I)
+                 IF (NFRONT .GT.SIZEROOT) THEN
+                    IROOTTREE = I
+                    SIZEROOT  = NFRONT
+                 END IF
+              END IF
+           END DO
+           IF ((IROOTTREE.EQ.-1).OR.(SIZEROOT.EQ.-1)) THEN
+              ISTAT = -1
+              RETURN
+           ENDIF
          ENDIF
          IF (SIZEROOT.LE.SLAVEF) THEN
             KEEP(38) = 0
@@ -5129,6 +5113,11 @@ C
           npivsplit(kk) = npiv2
         ENDIF
         if (keep(79) .ge. 1       
+     &    .and. nproc2 .le. 2     
+     &    .and. kk .ne. 1) then   
+          npivsplit(kk)=-npiv2
+          nproc2=nproc 
+        else if (keep(79) .ge. 1       
      &    .and. kk .ne. 1) then   
           if (optimization_strategy .eq. 0) then 
             npivOld = min(npiv - nass,
diff -pruN 5.6.2-2.1/src/mumps_tags.h 5.7.1-1/src/mumps_tags.h
--- 5.6.2-2.1/src/mumps_tags.h	2023-10-11 09:36:35.000000000 +0000
+++ 5.7.1-1/src/mumps_tags.h	2024-05-02 10:15:14.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -99,7 +99,8 @@ C --------------------------------------
      &        ScatterRhsI,
      &        ScatterRhsR,
      &        DistRhsI,
-     &        DistRhsR
+     &        DistRhsR,
+     &        DistSolR
       PARAMETER( RACINE_SOLVE = 14,
      &           ContVec      = 11,
      &           Master2Slave = 12,
@@ -107,7 +108,8 @@ C --------------------------------------
      &           ScatterRhsI  = 54,
      &           ScatterRhsR  = 55,
      &           DistRhsI     = 51,
-     &           DistRhsR     = 52)
+     &           DistRhsR     = 52,
+     &           DistSolR     = 58)
       INTEGER, PARAMETER :: TAG_WAKEUP = 53
       INTEGER, PARAMETER :: DIST_RHS_INT    = 56
       INTEGER, PARAMETER :: DIST_RHS_SCALAR = 57
diff -pruN 5.6.2-2.1/src/mumps_thread.c 5.7.1-1/src/mumps_thread.c
--- 5.6.2-2.1/src/mumps_thread.c	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_thread.c	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/mumps_thread_affinity.c 5.7.1-1/src/mumps_thread_affinity.c
--- 5.6.2-2.1/src/mumps_thread_affinity.c	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_thread_affinity.c	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/mumps_thread_affinity.h 5.7.1-1/src/mumps_thread_affinity.h
--- 5.6.2-2.1/src/mumps_thread_affinity.h	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/mumps_thread_affinity.h	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/mumps_type2_blocking.F 5.7.1-1/src/mumps_type2_blocking.F
--- 5.6.2-2.1/src/mumps_type2_blocking.F	2023-10-11 09:36:34.000000000 +0000
+++ 5.7.1-1/src/mumps_type2_blocking.F	2024-05-02 10:15:13.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -417,10 +417,10 @@ C
       INTEGER NPIV,
      &        NSLAVES_ref, NSLAVES_max
       REAL WK_MASTER, WK_SLAVE
-      INTEGER  MUMPS_REG_GETKMAX, MUMPS_BLOC2_GET_NSLAVESMIN, 
+      INTEGER  MUMPS_BLOC2_GET_NSLAVESMIN, 
      &         MUMPS_BLOC2_GET_NSLAVESMAX
       REAL  MUMPS_BLOC2_COUT
-      EXTERNAL MUMPS_REG_GETKMAX, MUMPS_BLOC2_GET_NSLAVESMIN, 
+      EXTERNAL MUMPS_BLOC2_GET_NSLAVESMIN, 
      &         MUMPS_BLOC2_GET_NSLAVESMAX
       EXTERNAL MUMPS_BLOC2_COUT
       IF (NMB_OF_CAND.LE.0) THEN
diff -pruN 5.6.2-2.1/src/mumps_type_size.F 5.7.1-1/src/mumps_type_size.F
--- 5.6.2-2.1/src/mumps_type_size.F	2023-10-11 09:36:34.000000000 +0000
+++ 5.7.1-1/src/mumps_type_size.F	1970-01-01 00:00:00.000000000 +0000
@@ -1,23 +0,0 @@
-C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
-C
-C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
-C  Mumps Technologies, University of Bordeaux.
-C
-C  This version of MUMPS is provided to you free of charge. It is
-C  released under the CeCILL-C license 
-C  (see doc/CeCILL-C_V1-en.txt, doc/CeCILL-C_V1-fr.txt, and
-C  https://cecill.info/licences/Licence_CeCILL-C_V1-en.html)
-C
-      SUBROUTINE MUMPS_GET_INT_DBL_SIZES( IS, DS )
-      INTEGER IS, DS
-#if defined(t3e)
-      IS = 8
-      DS = 16
-#else
-      IS = 4
-      DS = 8
-#endif
-      END SUBROUTINE MUMPS_GET_INT_DBL_SIZES
diff -pruN 5.6.2-2.1/src/mumps_version.F 5.7.1-1/src/mumps_version.F
--- 5.6.2-2.1/src/mumps_version.F	2023-10-11 09:36:34.000000000 +0000
+++ 5.7.1-1/src/mumps_version.F	2024-05-02 10:15:13.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -15,7 +15,7 @@ C
       IMPLICIT NONE
       CHARACTER(LEN=*) :: VERSION_STR
       CHARACTER(LEN=*) :: V;
-      PARAMETER (V = "5.6.2" )
+      PARAMETER (V = "5.7.1" )
       IF ( len(V) .GT. 30 ) THEN
          WRITE(*,*) "Version string too long ( >30 characters )"
          CALL MUMPS_ABORT()
diff -pruN 5.6.2-2.1/src/omp_tps_common_m.F 5.7.1-1/src/omp_tps_common_m.F
--- 5.6.2-2.1/src/omp_tps_common_m.F	2023-10-11 09:36:35.000000000 +0000
+++ 5.7.1-1/src/omp_tps_common_m.F	2024-05-02 10:15:14.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/sana_LDLT_preprocess.F 5.7.1-1/src/sana_LDLT_preprocess.F
--- 5.6.2-2.1/src/sana_LDLT_preprocess.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/sana_LDLT_preprocess.F	2024-05-02 10:15:25.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/sana_aux.F 5.7.1-1/src/sana_aux.F
--- 5.6.2-2.1/src/sana_aux.F	2023-10-11 09:37:02.000000000 +0000
+++ 5.7.1-1/src/sana_aux.F	2024-05-02 10:15:25.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -50,7 +50,7 @@ C
       INTEGER, INTENT(IN)    :: METIS_OPTIONS(40)
 #endif      
       INTEGER, INTENT(IN), OPTIONAL     :: NORIG_ARG
-      INTEGER, INTENT(IN), OPTIONAL     :: SIZEOFBLOCKS(N)
+      INTEGER, INTENT(IN), TARGET, OPTIONAL  :: SIZEOFBLOCKS(N)
       LOGICAL, INTENT(IN), OPTIONAL     :: GCOMP_PROVIDED_IN
       TYPE(COMPACT_GRAPH_T), OPTIONAL   :: GCOMP
       INTEGER, DIMENSION(:), ALLOCATABLE, TARGET :: IWALLOC
@@ -92,10 +92,9 @@ C
       PARAMETER (MINSYM=50)
       INTEGER(8) :: K79REF
       PARAMETER(K79REF=12000000_8)
-      INTEGER, PARAMETER :: LIDUMMY = 1 
-      INTEGER            :: IDUMMY(1)   
       INTEGER MTRANS, COMPRESS,NCMP,IERROR,J,JPERM,NCST
       INTEGER TOTEL 
+      INTEGER NFR
 #if defined(pord)
       INTEGER TOTW
 #endif
@@ -103,6 +102,8 @@ C
 #if defined(scotch) || defined(ptscotch)
       INTEGER WEIGHTREQUESTED
 #endif
+      INTEGER HOW_TO_SPLIT_ROOT, INODE_Scalapack_CAND, 
+     &        NBSONS_Scalapack_CAND
       LOGICAL SCOTCH_SYMBOLIC
       LOGICAL IDENT,SPLITROOT
       LOGICAL FREE_CENTRALIZED_MATRIX
@@ -110,32 +111,22 @@ C
       LOGICAL INPLACE64_GRAPH_COPY, INPLACE64_RESTORE_GRAPH
       INTEGER(8) :: LIW8, NZG8
       DOUBLE PRECISION TIMEB
+      INTEGER, POINTER, DIMENSION(:) :: SIZEOFBLOCKS_PTR
+      INTEGER, TARGET    :: IDUMMY_ARRAY(1)
+      INTEGER            :: LSIZEOFBLOCKS_PTR
+      LOGICAL            :: SIZEOFBLOCKS_AVAIL
       EXTERNAL MUMPS_ANA_H, SMUMPS_ANA_J, 
      &     SMUMPS_ANA_K, SMUMPS_ANA_GNEW,
      &     SMUMPS_ANA_LNEW, SMUMPS_ANA_M
       EXTERNAL SMUMPS_GNEW_SCHUR
       EXTERNAL SMUMPS_LDLT_COMPRESS, SMUMPS_EXPAND_PERMUTATION,
      &     SMUMPS_SET_CONSTRAINTS
-      IF (LIWALLOC.GT.0_8) THEN
-        ALLOCATE( IWALLOC (LIWALLOC), stat = IERR )
-        IF ( IERR .GT. 0 ) THEN
-         INFO( 1 ) = -7
-         CALL MUMPS_SET_IERROR(LIWALLOC,INFO(2))
-         GOTO 90                
-        ENDIF
-      ENDIF
       ALLOCATE( IWL1 (N), stat = IERR )
       IF ( IERR .GT. 0 ) THEN
          INFO( 1 ) = -7
          INFO( 2 ) = N
          GOTO 90                
       ENDIF
-      ALLOCATE( IPEALLOC(N+1), stat = IERR )
-      IF ( IERR .GT. 0 ) THEN
-         INFO( 1 ) = -7
-         INFO( 2 ) = (N+1)*KEEP(10)
-         GOTO 90                
-      ENDIF
       ALLOCATE( PTRAR (N,3), stat = IERR )
       IF ( IERR .GT. 0 ) THEN
          INFO( 1 ) = -7
@@ -143,6 +134,9 @@ C
          GOTO 90                
       ENDIF
       SCOTCH_SYMBOLIC=(KEEP(270).EQ.0) 
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+      SCOTCH_SYMBOLIC=.FALSE.
+#endif
       symmetry      = INFO(8)
       NBQD          = 0
       GCOMP_PROVIDED=.FALSE.
@@ -160,13 +154,6 @@ C
         INFO(2) = 1
         RETURN
       ENDIF
-      IF ( (LIWALLOC.EQ.0_8).AND.(.not.GCOMP_PROVIDED)) THEN
-        INFO(1) = -900
-        WRITE(6,*) " INTERNAL ERROR in MUMPS(ANA_F) ", 
-     &  "LIWALLOC, GCOMP_PROVIDED=", LIWALLOC, GCOMP_PROVIDED
-        INFO(2) = 2
-        RETURN
-      ENDIF
       IF (GCOMP_PROVIDED) THEN
         NZG8 =  GCOMP%NZG
         LIW8 =  NZG8 + int(GCOMP%NG,8)+1_8
@@ -176,9 +163,30 @@ C
           PTRAR(I,2) = int(IPE(I+1)-IPE(I))
          ENDDO
       ELSE
+        IF (LIWALLOC.GT.0_8) THEN
+          ALLOCATE( IWALLOC (LIWALLOC), stat = IERR )
+          IF ( IERR .GT. 0 ) THEN
+           INFO( 1 ) = -7
+           CALL MUMPS_SET_IERROR(LIWALLOC,INFO(2))
+           GOTO 90                
+          ENDIF
+        ENDIF
+        IF ( LIWALLOC.EQ.0_8 ) THEN
+          INFO(1) = -900
+          WRITE(6,*) " INTERNAL ERROR in MUMPS(ANA_F) ", 
+     &    "LIWALLOC, GCOMP_PROVIDED=", LIWALLOC, GCOMP_PROVIDED
+          INFO(2) = 2
+          RETURN
+        ENDIF
         LIW8 =  LIWALLOC
-        NZG8 = NZ8
+        NZG8 =  NZ8
         IW   => IWALLOC(1:LIW8)
+        ALLOCATE( IPEALLOC(N+1), stat = IERR )
+        IF ( IERR .GT. 0 ) THEN
+          INFO( 1 ) = -7
+          INFO( 2 ) = (N+1)*KEEP(10)
+          GOTO 90                
+        ENDIF
         IPE  => IPEALLOC(1:N+1)
       ENDIF
       LP    = ICNTL(1)
@@ -187,6 +195,16 @@ C
       PROK  = ((MP.GT.0).AND.(ICNTL(4).GE.2))
       LDIAG = ICNTL(4)
       COMPRESS_SCHUR = .FALSE.
+      IF (present(SIZEOFBLOCKS)) THEN
+       SIZEOFBLOCKS_PTR => SIZEOFBLOCKS(1:N)
+       LSIZEOFBLOCKS_PTR = N
+       SIZEOFBLOCKS_AVAIL = .TRUE.
+      ELSE
+       SIZEOFBLOCKS_PTR => IDUMMY_ARRAY
+       SIZEOFBLOCKS_AVAIL = .FALSE.
+       LSIZEOFBLOCKS_PTR = 1
+       IDUMMY_ARRAY(1) = -1
+      ENDIF
       IF (PROK) THEN
         IF (present(GCOMP)) THEN
          WRITE(MP,'(A,I10,A,I13,A)') " Processing a graph of size:", N
@@ -228,7 +246,7 @@ C
           WRITE (MP,99999) N, NZG8, LIW8, INFO(1)
           IF (J8.GT.0_8) WRITE (MP,99998) (IRN(I8),ICN(I8),I8=1_8,J8)
         ENDIF
-         K = min0(10,N)
+         K = min(10,N)
          IF (LDIAG.EQ.4) K = N
          IF (IORD.EQ.1 .AND. K.GT.0) THEN
             WRITE (MP,99997) (IKEEP1(I),I=1,K)
@@ -609,7 +627,7 @@ C
      &              PARENT, IWFR8,
      &              PTRAR(1,2), IW, IWL1, IKEEP1,
      &              IKEEP2, NCMPA, INFO, LP, LPOK, KEEP(10),
-     &              INPLACE64_GRAPH_COPY,
+     &              INPLACE64_GRAPH_COPY, INPLACE64_RESTORE_GRAPH,
      &              WEIGHTUSED, WEIGHTREQUESTED, SCOTCH_SYMBOLIC)
                ELSE
                  WRITE(*,*)
@@ -971,10 +989,10 @@ C
               INFO(1)= -99998
               GOTO 90
            ELSE
-            ALLOCATE( WTEMP ( 2*N ), stat = IERR )
+            ALLOCATE( WTEMP ( 2_8*int(N,8) ), stat = IERR )
             IF ( IERR .GT. 0 ) THEN
                INFO( 1 ) = -7
-               INFO( 2 ) = 2*N
+               CALL MUMPS_SET_IERROR(2_8*int(N,8), INFO(2) )
                GOTO 90          
             ENDIF
             THRESH = -1
@@ -1035,24 +1053,15 @@ C
          INFO( 2 ) = N
          GOTO 90                
       ENDIF
-      IF (present(SIZEOFBLOCKS)) THEN
-       CALL SMUMPS_ANA_LNEW
+      CALL SMUMPS_ANA_LNEW
      &     (N, PARENT, IWL1, IKEEP1(1), IKEEP2(1), IKEEP3(1),
      &     NFSIZ(1), PTRAR, INFO(6), FILS(1), FRERE(1), 
      &     PTRAR(1,3), NEMIN, WTEMP, KEEP(60),
      &     KEEP(20),KEEP(38),PTRAR(1,2),KEEP(104),IW(1),KEEP(50), 
-     &     ICNTL(13), KEEP(37), KEEP(197), NSLAVES, KEEP(250).EQ.1 
-     &     , .TRUE. , SIZEOFBLOCKS, N
+     &     ICNTL(13), KEEP(37), KEEP(197), NSLAVES, KEEP(250).EQ.1,
+     &     SIZEOFBLOCKS_AVAIL, SIZEOFBLOCKS_PTR(1), LSIZEOFBLOCKS_PTR
+     &     , INODE_Scalapack_CAND, NBSONS_Scalapack_CAND, KEEP(11)
      &      )
-      ELSE
-       CALL SMUMPS_ANA_LNEW
-     &     (N, PARENT, IWL1, IKEEP1(1), IKEEP2(1), IKEEP3(1),
-     &     NFSIZ(1), PTRAR, INFO(6), FILS(1), FRERE(1), 
-     &     PTRAR(1,3), NEMIN, WTEMP, KEEP(60),
-     &     KEEP(20),KEEP(38),PTRAR(1,2),KEEP(104),IW(1),KEEP(50), 
-     &     ICNTL(13), KEEP(37), KEEP(197), NSLAVES, KEEP(250).EQ.1 
-     &     , .FALSE., IDUMMY, LIDUMMY )
-      ENDIF
       DEALLOCATE(WTEMP)
       IF (KEEP(60).NE.0)  THEN
          IF (KEEP(60)==1) THEN
@@ -1085,6 +1094,8 @@ C
       IF ( KEEP(53) .NE. 0 ) THEN
          CALL MUMPS_MAKE1ROOT( N, FRERE(1), FILS(1), NFSIZ(1),
      &                         KEEP(20) )
+         INODE_Scalapack_CAND = KEEP(20)
+         NBSONS_Scalapack_CAND = 1
       END IF
       IF (  (KEEP(48) == 4 .AND. KEEP8(21).GT.0_8)
      &     .OR.
@@ -1099,61 +1110,95 @@ C
       IF (KEEP(210).EQ.1.AND.KEEP8(79).LE.0_8) THEN
         KEEP8(79)=K79REF * int(NSLAVES,8)
       ENDIF
-      IF ( (KEEP(79).EQ.0).OR.(KEEP(79).EQ.2).OR.
+      IF (KEEP(11).EQ.0) THEN
+       IF ( (KEEP(79).EQ.0).OR.(KEEP(79).EQ.2).OR.
      &     (KEEP(79).EQ.3).OR.(KEEP(79).EQ.5).OR.
      &     (KEEP(79).EQ.6)
      &   )  THEN
-       IF (KEEP(210).EQ.1) THEN
-        SPLITROOT = .FALSE. 
-        IF ( KEEP(62).GE.1) THEN
-          IWL1(1) = -1
-          IF (present(SIZEOFBLOCKS)) THEN
-            DO I= 1, N
-               IWL1(I) = SIZEOFBLOCKS(I)
-            ENDDO
-          ENDIF
-          CALL SMUMPS_CUTNODES(N, FRERE(1), FILS(1), NFSIZ(1), 
-     &                       IWL1(1), N, INFO(6),
-     &                       NSLAVES, KEEP,KEEP8, SPLITROOT,
-     &                       MP, LDIAG, INFO(1), INFO(2))
-          IF (INFO(1).LT.0) GOTO 90 
-          IF (PROK) THEN
+        IF (KEEP(210).EQ.1) THEN
+         SPLITROOT = .FALSE. 
+         IF ( KEEP(62).GE.1) THEN
+           CALL SMUMPS_CUTNODES(N, FRERE(1), FILS(1), NFSIZ(1), 
+     &         SIZEOFBLOCKS_PTR(1), LSIZEOFBLOCKS_PTR, INFO(6),
+     &         NSLAVES, KEEP,KEEP8, SPLITROOT,
+     &         MP, LDIAG, INFO(1), INFO(2))
+           IF (INFO(1).LT.0) GOTO 90 
+           IF (PROK) THEN
                WRITE(MP,*) " Number of split nodes in pre-splitting=",
      &         KEEP(61)
-          ENDIF
+           ENDIF
+         ENDIF
         ENDIF
        ENDIF
       ENDIF
+      HOW_TO_SPLIT_ROOT = 0 
       SPLITROOT = ICNTL(13) .EQ. -1
+      IF (KEEP(11).GT.1) THEN
+       NFR = NFSIZ(INODE_Scalapack_CAND)
+#if defined(NOSCALAPACK)
+        SPLITROOT = SPLITROOT .OR. 
+     & ( NSLAVES.GT.0.AND. 
+     &   ( REAL(NFR) - REAL(NFR)/REAL(max(2,NSLAVES))
+     &    .GT. REAL(KEEP(9)) )
+     & )
+#else
+        SPLITROOT = SPLITROOT .OR.
+     &  ( ICNTL(13).GT.0 .AND. NSLAVES .GT. ICNTL(13). AND.
+     &    ( REAL(NFR) - REAL(NFR)/REAL(max(2,NSLAVES)) 
+     &     .GT. REAL(KEEP(9)) )
+     &  )
+#endif
+      ELSE
 #if defined(NOSCALAPACK)
-      SPLITROOT = SPLITROOT .OR. NSLAVES.GT.0
+        SPLITROOT = SPLITROOT .OR. NSLAVES.GT.0
 #else
-      SPLITROOT = SPLITROOT .OR.
-     &            (ICNTL(13).GT.0 .AND. NSLAVES .GT. ICNTL(13))
+        SPLITROOT = SPLITROOT .OR.
+     &            (ICNTL(13).GT.0 .AND. NSLAVES .GT. ICNTL(13)
+     &            )
 #endif
+      ENDIF
+      IF (SPLITROOT.AND.KEEP(11).GT.0) HOW_TO_SPLIT_ROOT =1 
       IF (KEEP(53) .NE. 0) THEN
-         SPLITROOT = .TRUE.
+         SPLITROOT         = .TRUE.
+         IF (KEEP(11).GT.0) HOW_TO_SPLIT_ROOT = 2
+      ENDIF
+#if defined(NOSCALAPACK)
+#else
+      IF ( KEEP(11).GT.0) THEN 
+        IF (.NOT.SPLITROOT .AND. 
+     &    (KEEP(60).EQ.0).AND.   
+     &    ( (NFSIZ(INODE_Scalapack_CAND).GT.KEEP(37))
+     &     .AND.(ICNTL(13).LE.0) )
+     &    .AND.
+     &    (NBSONS_Scalapack_CAND.GT.KEEP(11)) 
+     &    ) THEN
+          HOW_TO_SPLIT_ROOT = 3
+          SPLITROOT=.TRUE.
+        ENDIF
       ENDIF
+#endif
       SPLITROOT = (SPLITROOT.AND.( (KEEP(60).EQ.0) ))
       IF (SPLITROOT) THEN
-         IWL1(1) = -1
-         IF (present(SIZEOFBLOCKS)) THEN
-            DO I= 1, N
-               IWL1(I) = SIZEOFBLOCKS(I)
-            ENDDO
-         ENDIF
-         CALL SMUMPS_CUTNODES(N, FRERE(1), FILS(1), NFSIZ(1), 
-     &                    IWL1(1), N, INFO(6),
-     &                    NSLAVES, KEEP,KEEP8, SPLITROOT,
-     &                    MP, LDIAG, INFO(1), INFO(2))
-         IF (INFO(1).LT.0) GOTO 90 
-         IF ( KEEP(53) .NE. 0 ) THEN
-          CALL MUMPS_MAKE1ROOT( N, FRERE(1), FILS(1), NFSIZ(1),
-     &                          KEEP(20) )
-         ENDIF
+        IF (KEEP(11).EQ.0) THEN
+          CALL SMUMPS_CUTNODES(N, FRERE(1), FILS(1), NFSIZ(1), 
+     &              SIZEOFBLOCKS_PTR(1), LSIZEOFBLOCKS_PTR, INFO(6),
+     &              NSLAVES, KEEP,KEEP8, SPLITROOT,
+     &              MP, LDIAG, INFO(1), INFO(2))
+          IF (INFO(1).LT.0) GOTO 90 
+          IF ( KEEP(53) .NE. 0 ) THEN
+           CALL MUMPS_MAKE1ROOT( N, FRERE(1), FILS(1), NFSIZ(1),
+     &                           KEEP(20) )
+          ENDIF
+        ELSE
+         CALL SMUMPS_SPLIT_ROOT( NSLAVES, 
+     &            HOW_TO_SPLIT_ROOT, INODE_Scalapack_CAND,
+     &            N, FRERE(1), FILS(1), NFSIZ(1), 
+     &            KEEP(1), KEEP8(1),
+     &            SIZEOFBLOCKS_PTR(1), LSIZEOFBLOCKS_PTR, INFO(6))
+        ENDIF
       ENDIF
       IF (LDIAG.GT.2 .AND. MP.GT.0) THEN
-         K = min0(10,N)
+         K = min(10,N)
          IF (LDIAG.EQ.4) K = N
          IF (K.GT.0) WRITE (MP,99987) (NFSIZ(I),I=1,K)
          IF (K.GT.0) WRITE (MP,99989) (FILS(I),I=1,K)
@@ -1250,9 +1295,9 @@ C
  70      CONTINUE
       END IF
       IF (id%KEEP(54) .EQ. 3) THEN
-         CALL MPI_ALLREDUCE(IWORK1(1), NBINCOL(1), id%N,
+         CALL MUMPS_BIGALLREDUCE(.FALSE., IWORK1(1), NBINCOL(1), id%N,
      &        MPI_INTEGER, MPI_SUM, id%COMM, IERR )
-         CALL MPI_ALLREDUCE(IWORK2(1), NBINROW(1), id%N,
+         CALL MUMPS_BIGALLREDUCE(.FALSE., IWORK2(1), NBINROW(1), id%N,
      &        MPI_INTEGER, MPI_SUM, id%COMM, IERR )
          deallocate(IWORK2)
       ELSE
@@ -1263,7 +1308,8 @@ C
       END IF
       RETURN
       END SUBROUTINE SMUMPS_ANA_N_DIST
-      SUBROUTINE SMUMPS_ANA_O( N, NZ, MTRANS, PERM, IKEEPALLOC,
+      SUBROUTINE SMUMPS_ANA_O( N, NZ, MTRANS, PERM,
+     &     IKEEPALLOC, LIKEEPALLOC,
      &     idIRN, idJCN, idA, idROWSCA, idCOLSCA, WORK2, KEEP,
      &     ICNTL, INFO, INFOG )
       IMPLICIT NONE
@@ -1273,7 +1319,8 @@ C
       INTEGER, POINTER, DIMENSION(:) :: idIRN, idJCN
       REAL, POINTER, DIMENSION(:) :: idA
       REAL, POINTER, DIMENSION(:) :: idROWSCA, idCOLSCA
-      INTEGER, TARGET        :: IKEEPALLOC(3*N)
+      INTEGER(8), INTENT(IN) :: LIKEEPALLOC
+      INTEGER, TARGET        :: IKEEPALLOC(LIKEEPALLOC)
       INTEGER, INTENT(INOUT) :: MTRANS
       INTEGER                :: KEEP(500)
       INTEGER, INTENT(IN)    :: ICNTL(60)
@@ -1398,7 +1445,7 @@ C
          NZTOT = NZ
       ENDIF
       ZERODIAG => IKEEPALLOC(1:N) 
-      STR_KER => IKEEPALLOC(N+1:2*N)
+      STR_KER  => IKEEPALLOC(int(N+1,8):2_8*int(N,8))
       CALL SMUMPS_MTRANSI(ICNTL64,CNTL64)
       ICNTL64(1) = ICNTL(1)
       ICNTL64(2) = ICNTL(2)
@@ -1446,7 +1493,8 @@ C
       ALLOCATE( IPQ8(N), IPE(N+1), stat = allocok )
       IF ( allocok .GT. 0 ) THEN
          INFO( 1 ) = -7
-         INFO( 2 ) = (2*N+1)*KEEP(10)
+         CALL MUMPS_SET_IERROR( (2_8*int(N,8)+1_8) * int(KEEP(10),8),
+     &                         INFO(2) )
          GOTO 500               
       ENDIF
       IF (MTRANSLOC.EQ.1) THEN
@@ -1456,8 +1504,8 @@ C
       IF (MTRANSLOC.EQ.3) LDWMIN = max( NZTOT+1_8 , N8+3_8 )
       IF (MTRANSLOC.EQ.4) LDWMIN = 2_8 * N8 + 
      &                             max( NZTOT , N8+3_8 )
-      IF (MTRANSLOC.EQ.5) LDWMIN = 3_8*N8 + NZTOT
-      IF (MTRANSLOC.EQ.6) LDWMIN = 4_8*N8 + NZTOT
+      IF (MTRANSLOC.EQ.5) LDWMIN = 3_8 * N8 + NZTOT
+      IF (MTRANSLOC.EQ.6) LDWMIN = 4_8 * N8 + NZTOT
       LDW   = LDWMIN
       ALLOCATE(S2(LDW), stat=allocok)
       IF (allocok .GT. 0 ) THEN
@@ -1626,7 +1674,7 @@ C
       ENDIF
       DUPPLI = .FALSE.
       NZsave = NZREAL
-      FLAG => IKEEPALLOC(2*N+1:3*N)
+      FLAG => IKEEPALLOC(2_8*int(N,8)+1:3_8*int(N,8))
       IF(MTRANSLOC.NE.1) THEN
          CALL SMUMPS_SUPPRESS_DUPPLI_VAL(N,NZREAL,IPE(1),IW(IRNW),S2,
      &        PERM(1),IPQ8(1))
@@ -1853,8 +1901,8 @@ C
             ICNTL_SYM_MWM(1) = 0
             ICNTL_SYM_MWM(2) = 1
          ENDIF
-         MARKED => IKEEPALLOC(N+1:2*N)
-         FLAG => IKEEPALLOC(2*N+1:3*N)
+         MARKED  => IKEEPALLOC(    int(N,8)+1_8 : 2_8*int(N,8))
+         FLAG    => IKEEPALLOC(2_8*int(N,8)+1_8 : 3_8*int(N,8))
          PIV_OUT => WORK2(1:N)
          IF(MTRANSLOC .LT. 4) THEN
             LSC = 1
@@ -1976,7 +2024,7 @@ C
    30       IP = LWFR
             JP = IPE(IE)
    40       IW(IWFR) = JS
-            MINJS = min0(MINJS,IPS(JS)+0)
+            MINJS = min(MINJS,IPS(JS)+0)
             IWFR = IWFR + 1_8
    50     CONTINUE
    60     IPE(IE) = int(-ME,8)
@@ -2073,7 +2121,7 @@ C
       LBIG = 0
       DO 100 I=1,N
         L1 = IQ(I)
-        LBIG = max0(L1,LBIG)
+        LBIG = max(L1,LBIG)
         IWFR = IWFR + int(L1,8)
         IPE(I) = IWFR - 1_8
   100 CONTINUE
@@ -2191,6 +2239,8 @@ C
      &               CUMUL,KEEP50, ICNTL13, KEEP37, KEEP197, NSLAVES,
      &               ALLOW_AMALG_TINY_NODES 
      &               , BLKON, SIZEOFBLOCKS, LSIZEOFBLOCKS
+     &               , INODE_Scalapack_CAND, NBSONS_Scalapack_CAND
+     &               , KEEP11
      &               )
       IMPLICIT NONE
       INTEGER  N, NSTEPS, KEEP60, KEEP20, KEEP38, KEEP50
@@ -2208,6 +2258,9 @@ C
       LOGICAL, INTENT(IN) :: BLKON
       INTEGER, INTENT(IN) :: LSIZEOFBLOCKS
       INTEGER, INTENT(IN) :: SIZEOFBLOCKS(LSIZEOFBLOCKS) 
+      INTEGER, INTENT(OUT):: INODE_Scalapack_CAND, 
+     &                       NBSONS_Scalapack_CAND
+      INTEGER, INTENT(IN) :: KEEP11
 #if  defined(NOAMALGTOFATHER)
 #else
 #endif
@@ -2216,6 +2269,8 @@ C
       INTEGER INOS,IB,IL
       INTEGER IPERM
       INTEGER MAXNODE
+      INTEGER SIZE_Scalapack_CAND, NBSONS_current_root
+      LOGICAL ROOT_WITH_FEW_SONS
 #if defined(NOAMALGTOFATHER)
       INTEGER INB,INF,INFS,INL,INSW,INT1,NR1
 #else
@@ -2223,6 +2278,10 @@ C
 #endif
       LOGICAL AMALG_TO_father_OK
       AMALG_COUNT = 0
+      INODE_Scalapack_CAND  = -1
+      NBSONS_Scalapack_CAND = -1
+      SIZE_Scalapack_CAND   = -1
+      NBSONS_current_root   = 0
       DO 10 I=1,N
         CUMUL(I)= 0
         IPS(I)  = 0
@@ -2332,6 +2391,16 @@ C
          NR = NR + 1
          IL = N
          NA(N) = 0
+         NBSONS_current_root =0
+         IF (IPS(I).LT.0) THEN
+          IB = -IPS(I)
+          NBSONS_current_root = NBSONS_current_root + 1
+  69      IB =FRERE(IB)
+          IF (IB.GT.0) THEN
+             NBSONS_current_root = NBSONS_current_root + 1
+             GOTO 69
+          ENDIF
+         ENDIF
         ENDIF
         DO 70 L=1,N
           IF (IPS(I).GE.0) EXIT
@@ -2341,8 +2410,14 @@ C
           IL = IL - 1
           NA(IL) = 0
    70   CONTINUE
-#if ! defined(NOAMALGTOFATHER)
         DADI = -IPE(I)  
+        IF (DADI.EQ.0) THEN
+         IF (NV(I) .GT. SIZE_Scalapack_CAND) THEN
+           INODE_Scalapack_CAND = I
+           SIZE_Scalapack_CAND  = NV(I)
+         ENDIF
+        ENDIF
+#if ! defined(NOAMALGTOFATHER)
         IF ( (DADI.NE.0) .AND.
      &      (
      &       (KEEP60.EQ.0).OR.
@@ -2387,9 +2462,25 @@ C
                  AMALG_TO_father_OK = .FALSE.
               ENDIF
            ENDIF
+           ROOT_WITH_FEW_SONS =.TRUE.
+           IF (KEEP11.GT.0) THEN
+             IF (IPE(DADI).EQ.0) THEN
+                IF 
+     &          (NA(IL)+max(NA(IL+1),NBSONS_current_root)
+     &                    .GT.KEEP11)
+     &          ROOT_WITH_FEW_SONS= .FALSE.
+             ELSE
+                IF 
+     &          (NA(IL)+NA(IL+1)+max(NA(N),NBSONS_current_root)
+     &                    .GT.KEEP11)
+     &          ROOT_WITH_FEW_SONS= .FALSE.
+             ENDIF
+           ENDIF
            IF ( (NV(I).GT. 50*NV(DADI)).AND. (NSLAVES.GT.1) 
      &          .AND. (ICNTL13.LE.0)
-     &          .AND. (NV(I).GT. KEEP37) )  THEN
+     &          .AND. (NV(I).GT. KEEP37) 
+     &          .AND. ROOT_WITH_FEW_SONS
+     &        )  THEN
              IF ( ( ACCU / SIZE_DADI_AMALGAMATED ) .LT. 0.2 ) THEN
                AMALG_TO_father_OK = .TRUE.
              ENDIF
@@ -2536,6 +2627,17 @@ C
         ENDIF
   160 CONTINUE
       NSTEPS = IS - 1
+        I = INODE_Scalapack_CAND
+        INOS = -FILS(I)  
+        NBSONS_Scalapack_CAND = 0
+        IF (INOS.GT.0) THEN
+          NBSONS_Scalapack_CAND = NBSONS_Scalapack_CAND+1
+          INO = FRERE(INOS)
+          DO WHILE (INO.GT.0 .AND. INO.LE.N) 
+           NBSONS_Scalapack_CAND = NBSONS_Scalapack_CAND+1
+           INO = FRERE(INO)
+          ENDDO
+        ENDIF
       DO I=1, N
         IF (NV(I).EQ.0) THEN
           FRERE(I) = N+1
@@ -2647,7 +2749,7 @@ C
       REAL, INTENT(IN)       :: RINFO(40), RINFOG(40)
       INCLUDE 'mpif.h'
       INTEGER MASTER, MPG
-      INTEGER ITMP
+      INTEGER ITMP, ICNTL48_EFF
       PARAMETER( MASTER = 0 )
       MPG = ICNTL(3)
       IF ( MYID.eq.MASTER.and.MPG.GT.0.AND.ICNTL(4).GE.2) THEN
@@ -2655,12 +2757,17 @@ C
        IF (ICNTL(15).EQ.0) THEN
           ITMP = 0
        ENDIF
+       IF (KEEP(400).GT.0) THEN 
+          ICNTL48_EFF=1
+       ELSE
+          ICNTL48_EFF=0
+       ENDIF
        WRITE(MPG, 99992) INFO(1), INFO(2),
      &  KEEP8(109), KEEP8(111), INFOG(4),
      &  INFOG(5), KEEP(28), INFOG(32), INFOG(7), KEEP(23), 
-     &  ICNTL(7), ICNTL(13), KEEP(12), 
+     &  ICNTL(7), KEEP(95), ICNTL(13), KEEP(12), 
      &  ITMP,
-     &  ICNTL(18),
+     &  ICNTL(18), KEEP(252), KEEP(494), ICNTL48_EFF,
      &  KEEP(106),
      &  KEEP(56), KEEP(61), RINFOG(1)
        IF (KEEP(95).GT.1)             
@@ -2683,10 +2790,14 @@ C
      &       ' --  (7) Ordering option effectively used       =',I16/
      &       ' ICNTL (6) Maximum transversal option           =',I16/
      &       ' ICNTL (7) Pivot order option                   =',I16/
+     &       ' ICNTL(12) Ordering symmetric indef. matrices   =',I16/
      &       ' ICNTL(13) Parallelism/splitting of root node   =',I16/
      &       ' ICNTL(14) Percentage of memory relaxation      =',I16/
      &       ' ICNTL(15) Analysis by block effectively used   =',I16/
      &       ' ICNTL(18) Distributed input matrix (on if >0)  =',I16/
+     &       ' ICNTL(32) Forward elimination during facto.    =',I16/
+     &       ' ICNTL(35) BLR activation                       =',I16/
+     &       ' ICNTL(48) Tree based multithreading (effective)=',I16/
      &       ' ICNTL(58) Symbolic factorization option        =',I16/
      &       ' Number of level 2 nodes                        =',I16/
      &       ' Number of split nodes                          =',I16/
@@ -3004,6 +3115,138 @@ C
       ENDIF
       RETURN
       END SUBROUTINE SMUMPS_SPLIT_1NODE
+      SUBROUTINE SMUMPS_SPLIT_ROOT
+     & ( NSLAVES, HOW, INODE, N, FRERE, FILS, NFSIZ, KEEP, KEEP8,
+     &   SIZEOFBLOCKS, LSIZEOFBLOCKS, NSTEPS)
+      IMPLICIT NONE
+      INTEGER, INTENT(in)    :: NSLAVES, HOW
+      INTEGER, INTENT(in)    :: INODE, N
+      INTEGER(8), INTENT(in) :: KEEP8(150)
+      INTEGER, INTENT(inout) :: NSTEPS
+      INTEGER, INTENT(inout) :: KEEP(500)
+      INTEGER, INTENT(inout) :: FRERE( N ), FILS( N ), NFSIZ( N )
+      INTEGER, INTENT(IN)    :: LSIZEOFBLOCKS
+      INTEGER, INTENT(IN)    :: SIZEOFBLOCKS(LSIZEOFBLOCKS)
+      LOGICAL    :: BLKON
+      INTEGER(8) :: K79
+      INTEGER I, IN, NPIV, NFRONT
+      INTEGER INODE_SON, INODE_FATH, IN_SON, IN_FATH, IN_GRANDFATH
+      INTEGER NPIV_COMPG, NPIV_SON_COMPG, NPIV_FATH_COMPG
+      INTEGER NPIV_SON, NPIV_FATH, NPIV_TEMP
+      INTEGER, PARAMETER :: K_HOW1 = 4000
+      IF (FRERE(INODE).NE.0) RETURN
+      BLKON = .NOT.(SIZEOFBLOCKS(1).EQ.-1) 
+      K79 = max(KEEP8(79), 4_8)
+      K79 = min(20000_8*20000_8,K79) 
+      IF (KEEP(72).EQ.1) THEN
+          K79 = min(3_8*3_8,K79)
+      ENDIF
+      IF ((HOW.LT.1) .OR. (HOW.GT.3)) THEN
+       RETURN 
+      ENDIF
+      IF (HOW.EQ.2) THEN
+       K79 = min(K79, 121_8*121_8)
+      ENDIF
+      NFRONT = NFSIZ (INODE)
+      NPIV = NFRONT
+      IF (NPIV .LE. 1 ) RETURN
+      IF (BLKON) THEN
+       IN = INODE
+       NPIV_COMPG = 0 
+       DO WHILE( IN > 0 )
+         NPIV_COMPG = NPIV_COMPG + 1
+         IN = FILS( IN )
+       ENDDO
+      ELSE 
+        NPIV_COMPG = NPIV
+      ENDIF
+      IF (HOW.EQ.1) THEN
+        IF ( (NFRONT/2) .LT. K_HOW1 ) RETURN
+        NPIV_FATH = max(NFRONT/max(NSLAVES,2), 1)
+        NPIV_FATH = max(NPIV_FATH, K_HOW1/2)
+        NPIV_FATH = min(NPIV_FATH, max(NFRONT/2,1))
+        NPIV_FATH = min(int(sqrt(real(K79))), NPIV_FATH)
+        NPIV_SON  = NPIV - NPIV_FATH
+      ELSE IF (HOW.EQ.2) THEN
+        NPIV_FATH = min(int(sqrt(real(K79))), int(NPIV/2))
+        NPIV_SON  = NPIV - NPIV_FATH
+      ELSE  
+        NPIV_FATH = max(NFRONT - 3*KEEP(6),1) 
+        NPIV_SON  = NPIV - NPIV_FATH
+      ENDIF
+       INODE_SON = INODE
+       IF (BLKON) THEN
+         NPIV_TEMP       = 0
+         NPIV_SON_COMPG  = 0
+         IN_SON = INODE
+         DO WHILE (IN_SON > 0) 
+           NPIV_TEMP = NPIV_TEMP + SIZEOFBLOCKS(IN_SON)
+           NPIV_SON_COMPG  = NPIV_SON_COMPG +1
+           IF (NPIV_TEMP.GE.NPIV_SON) EXIT
+           IN_SON = FILS( IN_SON )
+         END DO
+         NPIV_FATH_COMPG = NPIV_COMPG - NPIV_SON_COMPG
+         NPIV_SON        = NPIV_TEMP
+         NPIV_FATH       = NPIV - NPIV_SON 
+       ELSE
+         NPIV_SON_COMPG  = NPIV_SON
+         NPIV_FATH_COMPG = NPIV_FATH
+         IN_SON = INODE
+         DO I = 1, NPIV_SON_COMPG - 1
+           IN_SON = FILS( IN_SON )
+         END DO
+       ENDIF
+       IF (NPIV_FATH_COMPG.EQ.0)  RETURN
+       INODE_FATH = FILS( IN_SON )
+       IF ( INODE_FATH .LT. 0 ) THEN
+       write(*,*) 'Error: INODE_FATH < 0 ', INODE_FATH
+       END IF
+       IN_FATH = INODE_FATH
+       DO WHILE ( FILS( IN_FATH ) > 0 )
+         IN_FATH = FILS( IN_FATH )
+       END DO
+       FRERE( INODE_FATH ) = FRERE( INODE_SON )
+       FRERE( INODE_SON  ) = - INODE_FATH
+       FILS ( IN_SON     ) = FILS( IN_FATH )
+       FILS ( IN_FATH    ) = - INODE_SON
+       IN = FRERE( INODE_FATH )
+       DO WHILE ( IN > 0 )
+           IN = FRERE( IN )
+       END DO
+       IF ( IN .eq. 0 )  GO TO 10
+       IN = -IN
+       DO WHILE ( FILS( IN ) > 0 )
+           IN = FILS( IN )
+       END DO
+       IN_GRANDFATH = IN
+       IF ( FILS( IN_GRANDFATH ) .eq. - INODE_SON ) THEN
+           FILS( IN_GRANDFATH ) = -INODE_FATH
+       ELSE
+           IN = IN_GRANDFATH
+           IN = - FILS ( IN )
+           DO WHILE ( FRERE( IN ) > 0 )
+             IF ( FRERE( IN ) .eq. INODE_SON ) THEN
+               FRERE( IN ) = INODE_FATH
+               GOTO 10
+             END IF
+             IN = FRERE( IN )
+           END DO
+           WRITE(*,*) 'ERROR 2 in SPLIT NODE',
+     &          IN_GRANDFATH, IN, FRERE(IN)
+       END IF
+ 10    CONTINUE
+       NFSIZ(INODE_SON) = NFRONT
+       NFSIZ(INODE_FATH) = NFRONT - NPIV_SON
+       KEEP(2) = max( KEEP(2), NFRONT - NPIV_SON )
+       NSTEPS  = NSTEPS + 1
+       IF ( (KEEP(53).EQ.0) .AND. NSLAVES.GT.1) THEN
+         KEEP(38) = INODE_FATH
+       ENDIF
+       IF ( KEEP(53).NE.0 ) THEN
+         KEEP(20) = INODE_FATH
+       ENDIF
+      RETURN
+      END SUBROUTINE SMUMPS_SPLIT_ROOT
       SUBROUTINE SMUMPS_ANA_GNEW
      & (N, NZ, IRN, ICN, IW, LW, IPE, LEN,
      & IQ, FLAG, IWFR,
@@ -3415,7 +3658,7 @@ C
      &         SMUMPS_MTRANSS,SMUMPS_MTRANSW
       INTRINSIC abs,log
       RINF = CNTL(2)
-      RINF2 = huge(RINF2)/real(2*N)
+      RINF2 = huge(RINF2)/real(int(2,8)*int(N,8))
       RINF3 = 0.0E0
       WARN1 = 0
       WARN2 = 0
@@ -3444,12 +3687,12 @@ C
          IF (ICNTL(1).GE.0) WRITE(ICNTL(1),9001) INFO(1),'NE',NE
          GO TO 99
       ENDIF
-      IF (JOB.EQ.1) K = int(4*N +   M,8)
-      IF (JOB.EQ.2) K = int(N + 2*M,8)
-      IF (JOB.EQ.3) K = int(8*N + 2*M + NE,8)
-      IF (JOB.EQ.4) K = int(N + M,8)
-      IF (JOB.EQ.5) K = int(3*N + 2*M,8)
-      IF (JOB.EQ.6) K = int(3*N + 2*M + NE,8)
+      IF (JOB.EQ.1) K = 4_8*int(N,8)+int(M,8)
+      IF (JOB.EQ.2) K = int(N,8) + 2_8*int(M,8)
+      IF (JOB.EQ.3) K = 8_8*int(N,8) + 2*int(M,8) + NE
+      IF (JOB.EQ.4) K = int(N,8) + int(M,8)
+      IF (JOB.EQ.5) K = 3_8*int(N,8) + 2_8*int(M,8)
+      IF (JOB.EQ.6) K = 3_8*int(N,8) + 2_8*int(M,8) + NE
       IF (LIW.LT.K) THEN
          INFO(1) = -4
          CALL MUMPS_SET_IERROR(K,INFO(2))
@@ -3457,11 +3700,11 @@ C
          GO TO 99
       ENDIF
       IF (JOB.GT.1) THEN
-         IF (JOB.EQ.2) K = int(      M,8)
+         IF (JOB.EQ.2) K = int(M,8)
          IF (JOB.EQ.3) K = int(1,8)
-         IF (JOB.EQ.4) K = int(    2*M,8)
-         IF (JOB.EQ.5) K = int(N + 2*M,8)
-         IF (JOB.EQ.6) K = int(N + 3*M,8)
+         IF (JOB.EQ.4) K = 2_8*int(M,8)
+         IF (JOB.EQ.5) K = int(N,8) + 2_8*int(M,8)
+         IF (JOB.EQ.6) K = int(N,8) + 3_8*int(M,8)
          IF (LDW .LT. K) THEN
             INFO(1) = -5
             CALL MUMPS_SET_IERROR(K,INFO(2))
@@ -3518,13 +3761,18 @@ C
             IW(J) = int(IP(J+1) - IP(J))
  10      CONTINUE
          CALL SMUMPS_MTRANSZ(M,N,IRN,NE,IP,IW(1),PERM,NUM,
-     &        IW(N+1),IW(2*N+1),IW(3*N+1),IW(3*N+M+1))
+     &        IW(    int(N,8)+1_8),
+     &        IW(2_8*int(N,8)+1_8),
+     &        IW(3_8*int(N,8)+1_8),
+     &        IW(3_8*int(N,8)+int(M,8)+1_8))
          GO TO 90
       ENDIF
       IF (JOB.EQ.2) THEN
          DW(1) = max(ZERO,CNTL(1))
          CALL SMUMPS_MTRANSB(M,N,NE,IP,IRN,A,PERM,NUM,
-     &        IW(1),IPQ8,IW(N+1),IW(N+M+1),DW,RINF2)
+     &        IW(1),IPQ8,IW(int(N,8)+1_8),
+     &        IW(int(N,8)+int(M,8)+1_8),
+     &        DW,RINF2)
          GO TO 90
       ENDIF
       IF (JOB.EQ.3) THEN
@@ -3533,16 +3781,21 @@ C
  20      CONTINUE
          CALL SMUMPS_MTRANSR(N,NE,IP,IW,A)
          FACT = max(ZERO,CNTL(1))
-         CALL SMUMPS_MTRANSS(M,N,NE,IP,IW(1),A,PERM,NUM,IW(NE+1),
-     &        IW(NE+N+1),IW(NE+2*N+1),IW(NE+3*N+1),IW(NE+4*N+1),
-     &        IW(NE+5*N+1),IW(NE+5*N+M+1),FACT,RINF2)
+         CALL SMUMPS_MTRANSS(M,N,NE,IP,IW(1),A,PERM,NUM,IW(NE+1_8),
+     &        IW(NE+int(N,8)+1_8),IW(NE+2_8*int(N,8)+1_8),
+     &        IW(NE+3_8*int(N,8)+1_8),
+     &        IW(NE+4_8*int(N,8)+1_8),
+     &        IW(NE+5_8*int(N,8)+1_8),
+     &        IW(NE+5_8*int(N,8)+int(M,8)+1_8),
+     &        FACT,RINF2)
          GO TO 90
       ENDIF
       IF ((JOB.EQ.4).OR.(JOB.EQ.5).or.(JOB.EQ.6)) THEN
-           ALLOCATE(IWtemp8(M+N+N), stat=allocok)
+           ALLOCATE(IWtemp8(int(M,8)+int(N,8)+int(N,8)), stat=allocok)
            IF (allocok.GT.0) THEN
              INFOMUMPS(1) = -7
-             INFOMUMPS(2) = M+N+N
+             CALL MUMPS_SET_IERROR( int(M,8)+int(N,8)+int(N,8),
+     &                               INFOMUMPS(2) )
              GOTO 90
            ENDIF
       ENDIF
@@ -3561,9 +3814,10 @@ C
          DW(2)      = RINF3
          IWtemp8(1) = int(JOB,8)
          CALL SMUMPS_MTRANSW(M,N,NE,IP,IRN,A,PERM,NUM,
-     &        IWtemp8(1),IW(1),IWtemp8(N+1),IPQ8,IW(N+1),
-     &        IWtemp8(2*N+1),
-     &        DW(1),DW(M+1),RINF2)
+     &        IWtemp8(1),IW(1),IWtemp8(int(N,8)+1_8),IPQ8,
+     &        IW(int(N,8)+1_8),
+     &        IWtemp8(2_8*int(N,8)+1_8),
+     &        DW(1),DW(int(M,8)+1_8),RINF2)
          DEALLOCATE(IWtemp8)  
          GO TO 90
       ENDIF
@@ -3575,7 +3829,7 @@ C
                DO 60 K = IP(J),IP(J+1)-1_8
                   IF (A(K).GT.FACT) FACT = A(K)
  60            CONTINUE
-               DW(2*M+J) = FACT
+               DW(2_8*int(M,8)+int(J,8)) = FACT
                IF (FACT.NE.ZERO) THEN
                   FACT = log(FACT)
                   IF(FACT .GT. RINF3) RINF3=FACT
@@ -3596,38 +3850,40 @@ C
          ENDIF
          IF (JOB.EQ.6) THEN
             DO 175 K = 1,NE
-               IW(3*N+2*M+K) = IRN(K)
+               IW(3_8*int(N,8)+2_8*int(M,8)+int(K,8)) = IRN(K)
  175        CONTINUE
             DO 61 I = 1,M
-               DW(2*M+N+I) = ZERO
+               DW(2_8*int(M,8)+int(N,8)+int(I,8)) = ZERO
  61         CONTINUE
             DO 63 J = 1,N
                DO 62 K = IP(J),IP(J+1)-1_8
                   I = IRN(K)
-                  IF (A(K).GT.DW(2*M+N+I)) THEN
-                     DW(2*M+N+I) = A(K)
+                  IF (A(K).GT.DW(2_8*int(M,8)+int(N,8)+int(I,8))) THEN
+                     DW(2_8*int(M,8)+int(N,8)+int(I,8)) = A(K)
                   ENDIF
  62            CONTINUE
  63         CONTINUE
             DO 64 I = 1,M
-               IF (DW(2*M+N+I).NE.ZERO) THEN
-                  DW(2*M+N+I) = 1.0E0/DW(2*M+N+I)
+               IF (DW(2_8*int(M,8)+int(N,8)+int(I,8)).NE.ZERO) THEN
+                   DW(2_8*int(M,8)+int(N,8)+int(I,8)) =
+     &                      1.0E0/DW(2_8*int(M,8)+int(N,8)+int(I,8))
                ENDIF
  64         CONTINUE
             DO 66 J = 1,N
                DO 65 K = IP(J),IP(J+1)-1
                   I = IRN(K)
-                  A(K) = DW(2*M+N+I) * A(K)
+                  A(K) = DW(2_8*int(M,8)+int(N,8)+int(I,8)) * A(K)
  65            CONTINUE
  66         CONTINUE
-            CALL SMUMPS_MTRANSR(N,NE,IP,IW(3*N+2*M+1),A)
+            CALL SMUMPS_MTRANSR(N,NE,IP,
+     &           IW(3_8*int(N,8)+2_8*int(M,8)+1_8),A)
             DO 176 J = 1,N
                IF (IP(J).NE.IP(J+1)) THEN
                   FACT = A(IP(J))
                ELSE
                   FACT = ZERO
                ENDIF
-               DW(2*M+J) = FACT
+               DW(2_8*int(M,8)+int(J,8)) = FACT
                IF (FACT.NE.ZERO) THEN
                   FACT = log(FACT)
                   DO 170 K = IP(J),IP(J+1)-1_8
@@ -3651,34 +3907,38 @@ C
          IWtemp8(1) = int(JOB,8)
           IF (JOB.EQ.5) THEN
          CALL SMUMPS_MTRANSW(M,N,NE,IP,IRN,A,PERM,NUM,
-     &        IWtemp8(1),IW(1),IWtemp8(N+1),IPQ8,IW(N+1),
-     &        IWtemp8(2*N+1),
-     &        DW(1),DW(M+1),RINF2)
+     &        IWtemp8(1),IW(1),IWtemp8(int(N,8)+1_8),IPQ8,
+     &        IW(int(N,8)+1_8),
+     &        IWtemp8(2_8*int(N,8)+1_8),
+     &        DW(1),DW(int(M,8)+1_8),RINF2)
          ENDIF
          IF (JOB.EQ.6) THEN
-         CALL SMUMPS_MTRANSW(M,N,NE,IP,IW(3*N+2*M+1),A,PERM,NUM,
-     &        IWtemp8(1),IW(1),IWtemp8(N+1),IPQ8,IW(N+1),
-     &        IWtemp8(2*N+1),
-     &        DW(1),DW(M+1),RINF2)
+         CALL SMUMPS_MTRANSW(M,N,NE,IP,
+     &        IW(3_8*int(N,8)+2_8*int(M,8)+1_8),A,PERM,NUM,
+     &        IWtemp8(1),IW(1),IWtemp8(int(N,8)+1_8),IPQ8,
+     &        IW(int(N,8)+1_8),
+     &        IWtemp8(2_8*int(N,8)+1_8),
+     &        DW(1),DW(int(M,8)+1_8),RINF2)
          ENDIF
          IF ((JOB.EQ.5).or.(JOB.EQ.6)) THEN
           DEALLOCATE(IWtemp8)
          ENDIF
          IF (JOB.EQ.6) THEN
-            DO 79 I = 1,M
-               IF (DW(2*M+N+I).NE.0.0E0) THEN
-                  DW(I) = DW(I) + log(DW(2*M+N+I))
-               ENDIF
- 79         CONTINUE
+           DO 79 I = 1,M
+             IF (DW(2_8*int(M,8)+int(N,8)+int(I,8)).NE.0.0E0) THEN
+               DW(I) = DW(I) + log(DW(2_8*int(M,8)+int(N,8)+int(I,8)))
+             ENDIF
+ 79        CONTINUE
          ENDIF
          IF (NUM.EQ.N) THEN
-            DO 80 J = 1,N
-               IF (DW(2*M+J).NE.ZERO) THEN
-                  DW(M+J) = DW(M+J) - log(DW(2*M+J))
-               ELSE
-                  DW(M+J) = ZERO
-               ENDIF
- 80         CONTINUE
+           DO 80 J = 1,N
+             IF (DW(2_8*int(M,8)+int(J,8)).NE.ZERO) THEN
+               DW(int(M,8)+int(J,8)) = DW(int(M,8)+int(J,8)) -
+     &                                 log(DW(2_8*int(M,8)+int(J,8)))
+             ELSE
+               DW(int(M,8)+int(J,8)) = ZERO
+             ENDIF
+ 80        CONTINUE
          ENDIF
          FACT = 0.5E0*log(RINF2)
          DO 86 I = 1,M
@@ -3714,13 +3974,15 @@ C
                WRITE(ICNTL(3),9032) (PERM(J),J=1,min(10,M))
                IF (JOB.EQ.5 .OR. JOB.EQ.6) THEN
                   WRITE(ICNTL(3),9033) (DW(J),J=1,min(10,M))
-                  WRITE(ICNTL(3),9034) (DW(M+J),J=1,min(10,N))
+                  WRITE(ICNTL(3),9034) (DW(int(M,8)+int(J,8)),
+     &                                  J=1,min(10,N))
                ENDIF
             ELSEIF (ICNTL(4).EQ.1) THEN
                WRITE(ICNTL(3),9032) (PERM(J),J=1,M)
                IF (JOB.EQ.5 .OR. JOB.EQ.6) THEN
                   WRITE(ICNTL(3),9033) (DW(J),J=1,M)
-                  WRITE(ICNTL(3),9034) (DW(M+J),J=1,N)
+                  WRITE(ICNTL(3),9034) (DW(int(M,8)+int(J,8)),
+     &                                  J=1,N)
                ENDIF
             ENDIF
          ENDIF
@@ -4003,6 +4265,7 @@ C
       REAL PEAK
       INTEGER, intent(IN) :: LSIZEOFBLOCKS
       INTEGER, intent(IN) :: SIZEOFBLOCKS(LSIZEOFBLOCKS)
+      CALL MUMPS_SET_K78_83_91 (NSLAVES,KEEP(78),KEEP(83),KEEP(91))
       CALL MUMPS_DISTRIBUTE(N,NSLAVES,
      &     ICNTL,INFOG, NE, NFSIZ,
      &     FRERE, FILS,
diff -pruN 5.6.2-2.1/src/sana_aux_ELT.F 5.7.1-1/src/sana_aux_ELT.F
--- 5.6.2-2.1/src/sana_aux_ELT.F	2023-10-11 09:37:02.000000000 +0000
+++ 5.7.1-1/src/sana_aux_ELT.F	2024-05-02 10:15:25.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -24,7 +24,8 @@ C
      &            )
       USE MUMPS_ANA_ORD_WRAPPERS
       IMPLICIT NONE
-      INTEGER, INTENT(IN)    :: N,  NELT, SIZE_SCHUR, NSLAVES, LIW
+      INTEGER, INTENT(IN)    :: N,  NELT, SIZE_SCHUR, NSLAVES
+      INTEGER(8), INTENT(IN) :: LIW
       INTEGER, INTENT(IN)    :: ELTPTR(NELT+1) 
       INTEGER, INTENT(IN)    :: ELTVAR(ELTPTR(NELT+1)-1)
       INTEGER, INTENT(IN)    :: LISTVAR_SCHUR(SIZE_SCHUR)
@@ -38,7 +39,8 @@ C
 #if defined(metis) || defined(parmetis) || defined(metis4) || defined(parmetis3)      
       INTEGER, INTENT(IN)    :: METIS_OPTIONS(40)
 #endif
-      INTEGER K,I,L1,L2,NCMPA,IFSON,IN
+      INTEGER K,I,NCMPA,IFSON,IN
+      INTEGER(8) :: L1, L2
       INTEGER NEMIN, MPRINT, LP, MP, LDIAG
       INTEGER(8)  :: NZ8, LLIW8, IWFR8
       INTEGER allocok, ITEMP
@@ -46,6 +48,8 @@ C
       INTEGER(8) :: K79REF
       PARAMETER(K79REF=12000000_8)
       LOGICAL SPLITROOT
+      INTEGER HOW_TO_SPLIT_ROOT, INODE_Scalapack_CAND, 
+     &        NBSONS_Scalapack_CAND
       INTEGER, PARAMETER :: LIDUMMY = 1
       INTEGER :: IDUMMY(1) 
       INTEGER, DIMENSION(:), ALLOCATABLE :: IW
@@ -73,7 +77,7 @@ C
         ALLOCATE( IW ( LIW ), stat = allocok )
         IF ( allocok .GT. 0 ) THEN
           INFO( 1 ) = -7
-          INFO( 2 ) = LIW
+          CALL MUMPS_SET_IERROR(LIW, INFO( 2 ))
           GOTO 90 
         ENDIF
         ALLOCATE( IPE8 ( N + 1 ), stat = allocok )
@@ -85,7 +89,7 @@ C
         ALLOCATE( PARENT(N), IWtemp ( N, 3 ), stat = allocok )
         IF ( allocok .GT. 0 ) THEN
           INFO( 1 ) = -7
-          INFO( 2 ) = 4*N
+          CALL MUMPS_SET_IERROR(4_8*int(N,8), INFO( 2 ))
           GOTO 90 
         ENDIF
       MPRINT= ICNTL(3)
@@ -118,42 +122,42 @@ C
       NEMIN = KEEP(1)
       IF (LDIAG.LE.2 .OR. MP.LE.0) GO TO 10
       WRITE (MP,99999) N, NELT, LIW, INFO(1)
-      K = min0(10,NELT+1)
+      K = min(10,NELT+1)
       IF (LDIAG.EQ.4) K = NELT+1
       IF (K.GT.0) WRITE (MP,99998) (ELTPTR(I),I=1,K)
-      K = min0(10,ELTPTR(NELT+1)-1)
+      K = min(10,ELTPTR(NELT+1)-1)
       IF (LDIAG.EQ.4) K = ELTPTR(NELT+1)-1
       IF (K.GT.0) WRITE (MP,99995) (ELTVAR(I),I=1,K)
-      K = min0(10,N)
+      K = min(10,N)
       IF (LDIAG.EQ.4) K = N
       IF (IORD.EQ.1 .AND. K.GT.0) THEN
         WRITE (MP,99997) (IKEEP(I,1),I=1,K)
       ENDIF
-   10 L1 = 1
-      L2 = L1 + N
-      IF (LIW .LT. 3*N) THEN
+   10 L1 = 1_8
+      L2 = L1 + int(N,8)
+      IF (LIW .LT. 3_8*int(N,8)) THEN
           INFO(1) = -2002
-          INFO(2) = LIW
+          CALL MUMPS_SET_IERROR( LIW, INFO(2) )
       ENDIF
 #if defined(metis) || defined(parmetis) || defined(metis4) || defined(parmetis3)
       IF ( IORD == 5 ) THEN
-        IF (LIW .LT. N+N+1) THEN
+        IF (LIW .LT. int(N,8)+int(N,8)+1_8) THEN
           INFO(1)= -2002
-          INFO(2) = LIW
+          CALL MUMPS_SET_IERROR( LIW, INFO(2) )
           GOTO 90 
         ENDIF
       ELSE
 #endif
       IF (NOSUPERVAR) THEN
-        IF ( LIW .LT. 2*N ) THEN
+        IF ( LIW .LT. 2_8*int(N,8) ) THEN
           INFO(1)= -2002
-          INFO(2) = LIW
+          CALL MUMPS_SET_IERROR( LIW, INFO(2) )
           GOTO 90 
         END IF
       ELSE
-        IF ( LIW .LT.  4*N+4 ) THEN
+        IF ( LIW .LT.  4_8*int(N,8)+4_8 ) THEN
           INFO(1)= -2002
-          INFO(2) = LIW
+          CALL MUMPS_SET_IERROR( LIW, INFO(2) )
           GOTO 90 
         END IF
       ENDIF
@@ -170,9 +174,9 @@ C
      &              ELTPTR, ELTVAR, XNODEL, NODEL,
      &              IWtemp(1,2), IW(L1))
         ELSE
-         CALL SMUMPS_ANA_G11_ELT(N, NZ8, NELT, ELTPTR(NELT+1)-1, 
+          CALL SMUMPS_ANA_G11_ELT(N, NZ8, NELT, ELTPTR(NELT+1)-1, 
      &              ELTPTR, ELTVAR, XNODEL, NODEL,
-     &              IWtemp(1,2), 4*N+4, IW(L1))
+     &              IWtemp(1,2), 4_8*int(N,8)+4_8, IW(L1))
         ENDIF
         LLIW8 = max(NZ8,int(N,8))
         ALLOCATE( IW2(LLIW8), stat = allocok )
@@ -288,15 +292,15 @@ C
         ENDIF
 #endif
        DO K=1,N
-         IW(L1+K) = 0
+         IW(L1+int(K,8)) = 0
        ENDDO
        DO K=1,N
          IF ((IKEEP(K,1).LE.0).OR.(IKEEP(K,1).GT.N)) 
      &    GO TO 40
-         IF (IW(L1+IKEEP(K,1)).EQ.1) THEN
+         IF (IW(L1+int(IKEEP(K,1),8)).EQ.1) THEN
           GOTO 40
          ELSE
-          IW(L1+IKEEP(K,1)) = 1
+          IW(L1+int(IKEEP(K,1),8)) = 1
          ENDIF
        ENDDO
        CALL SMUMPS_ANA_J1_ELT(N, NZ8, NELT, ELTPTR(NELT+1)-1,
@@ -335,9 +339,10 @@ C
      &     NFSIZ, IWtemp(1,2), 
      &     INFO(6), FILS, FRERE, IWtemp(1,3), NEMIN, 
      &     IW(L2),  KEEP(60), KEEP(20), KEEP(38),
-     &     IW2,KEEP(104),IW(L2+N),KEEP(50),
+     &     IW2,KEEP(104),IW(L2+int(N,8)),KEEP(50),
      &     ICNTL(13), KEEP(37), KEEP(197), NSLAVES, KEEP(250).EQ.1,
-     &     .FALSE., IDUMMY, LIDUMMY)
+     &     .FALSE., IDUMMY, LIDUMMY, 
+     &     INODE_Scalapack_CAND, NBSONS_Scalapack_CAND, KEEP(11) )
       DEALLOCATE(IW2)
       IF (KEEP(60).NE.0) THEN
          IF (KEEP(60)==1) THEN
@@ -368,6 +373,8 @@ C
      &  KEEP(6), KEEP(226), KEEP(253))
       IF ( KEEP(53) .NE. 0 ) THEN
         CALL MUMPS_MAKE1ROOT( N, FRERE, FILS, NFSIZ, KEEP(20) )
+        INODE_Scalapack_CAND  = KEEP(20)
+        NBSONS_Scalapack_CAND = 1
       END IF
       IF ( KEEP(48) == 4 .OR.
      &   ( (KEEP(24).NE.0).AND.(KEEP8(21).GT.0_8) ) ) THEN
@@ -379,23 +386,26 @@ C
       IF (KEEP(210).EQ.1.AND.KEEP8(79).LE.0_8) THEN
         KEEP8(79)=K79REF * int(NSLAVES,8)
       ENDIF
-      IF (KEEP(79).EQ.0) THEN
-       IF (KEEP(210).EQ.1) THEN
-        SPLITROOT = .FALSE. 
-        IF ( KEEP(62).GE.1) THEN
-          IDUMMY(1)= -1
-          CALL SMUMPS_CUTNODES(N, FRERE, FILS, NFSIZ,
-     &                       IDUMMY, LIDUMMY, INFO(6),
-     &                       NSLAVES, KEEP,KEEP8, SPLITROOT,
-     &                       MP, LDIAG, INFO(1), INFO(2))
-          IF (INFO(1).LT.0) GOTO 90 
-          IF (PROK) THEN
-               WRITE(MP,*) " Number of split nodes in pre-splitting=",
-     &         KEEP(61)
+      IF (KEEP(11).EQ.0) THEN
+        IF (KEEP(79).EQ.0) THEN
+         IF (KEEP(210).EQ.1) THEN
+          SPLITROOT = .FALSE. 
+          IF ( KEEP(62).GE.1) THEN
+            IDUMMY(1)= -1
+            CALL SMUMPS_CUTNODES(N, FRERE, FILS, NFSIZ,
+     &                         IDUMMY, LIDUMMY, INFO(6),
+     &                         NSLAVES, KEEP,KEEP8, SPLITROOT,
+     &                         MP, LDIAG, INFO(1), INFO(2))
+            IF (INFO(1).LT.0) GOTO 90 
+            IF (PROK) THEN
+                 WRITE(MP,*) " Number of split nodes in pre-splitting=",
+     &           KEEP(61)
+            ENDIF
           ENDIF
+         ENDIF
         ENDIF
-       ENDIF
       ENDIF
+      HOW_TO_SPLIT_ROOT = 0 
       SPLITROOT = ICNTL(13) .EQ. -1
 #if defined(NOSCALAPACK)
       SPLITROOT = SPLITROOT .OR. NSLAVES.GT.0
@@ -403,23 +413,50 @@ C
       SPLITROOT = SPLITROOT .OR.
      &            (ICNTL(13).GT.0 .AND. NSLAVES .GT. ICNTL(13))
 #endif
+      HOW_TO_SPLIT_ROOT = 0 
+      IF (SPLITROOT.AND.KEEP(11).GT.0) HOW_TO_SPLIT_ROOT =1 
       IF (KEEP(53) .NE. 0) THEN
-         SPLITROOT = .TRUE.
+         SPLITROOT         = .TRUE.
+         IF (KEEP(11).GT.0) HOW_TO_SPLIT_ROOT = 2
       ENDIF
       SPLITROOT = (SPLITROOT.AND.( (KEEP(60).EQ.0) ))
+#if defined(NOSCALAPACK)
+#else
+      IF ( KEEP(11).GT.0) THEN 
+        IF (.NOT.SPLITROOT .AND. 
+     &    (KEEP(60).EQ.0).AND.   
+     &    ( (NFSIZ(INODE_Scalapack_CAND).GT.KEEP(37))
+     &      .AND.(ICNTL(13).LE.0) )
+     &    .AND.
+     &    (NBSONS_Scalapack_CAND.GT.KEEP(11)) 
+     &    ) THEN
+          HOW_TO_SPLIT_ROOT = 3
+          SPLITROOT=.TRUE.
+        ENDIF
+      ENDIF
+#endif
       IF (SPLITROOT) THEN
-         IDUMMY(1) = -1
-         CALL SMUMPS_CUTNODES(N, FRERE, FILS, NFSIZ,
-     &                    IDUMMY, LIDUMMY, INFO(6),
-     &                    NSLAVES, KEEP,KEEP8, SPLITROOT,
-     &                    MP, LDIAG, INFO(1), INFO(2))
-         IF (INFO(1).LT.0) GOTO 90 
-         IF ( KEEP(53) .NE. 0 ) THEN
-          CALL MUMPS_MAKE1ROOT( N, FRERE, FILS, NFSIZ, KEEP(20) )
-         ENDIF
+        IDUMMY(1) = -1
+        IF (KEEP(11).EQ.0) THEN
+          CALL SMUMPS_CUTNODES(N, FRERE(1), FILS(1), NFSIZ(1), 
+     &                     IDUMMY, LIDUMMY, INFO(6),
+     &                     NSLAVES, KEEP,KEEP8, SPLITROOT,
+     &                     MP, LDIAG, INFO(1), INFO(2))
+          IF (INFO(1).LT.0) GOTO 90 
+          IF ( KEEP(53) .NE. 0 ) THEN
+           CALL MUMPS_MAKE1ROOT( N, FRERE(1), FILS(1), NFSIZ(1),
+     &                           KEEP(20) )
+          ENDIF
+        ELSE
+         CALL SMUMPS_SPLIT_ROOT( NSLAVES,
+     &               HOW_TO_SPLIT_ROOT, INODE_Scalapack_CAND,
+     &               N, FRERE(1), FILS(1), NFSIZ(1), 
+     &               KEEP, KEEP8,
+     &               IDUMMY, LIDUMMY, INFO(6))
+        ENDIF
       ENDIF
       IF (LDIAG.GT.2 .AND. MP.GT.0) THEN
-         K = min0(10,N)
+         K = min(10,N)
          IF (LDIAG.EQ.4) K = N
          IF (K.GT.0) WRITE (MP,99997) (IKEEP(I,1),I=1,K)
          IF (K.GT.0) WRITE (MP,99991) (IKEEP(I,2),I=1,K)
@@ -955,7 +992,8 @@ C
      &  XELNOD, ELNOD, XNODEL, NODEL, 
      &  LEN, LW, IW)
       IMPLICIT NONE
-      INTEGER N,NELT,NELNOD,LW
+      INTEGER N,NELT,NELNOD
+      INTEGER(8) :: LW
       INTEGER(8), INTENT(OUT) :: NZ
       INTEGER XELNOD(NELT+1), ELNOD(NELNOD)
       INTEGER LEN(N)
@@ -966,7 +1004,8 @@ C
       EXTERNAL SMUMPS_SUPVAR
       LP = 6
       CALL SMUMPS_SUPVAR(N,NELT,XELNOD(NELT+1)-1,ELNOD,XELNOD,
-     &           NSUP,IW(3*N+3+1),3*N+3,IW,LP,INFO44)
+     &           NSUP,IW(3_8*int(N,8)+3_8+1_8),
+     &           3_8*int(N,8)+3_8,IW,LP,INFO44)
       IF (INFO44(1) .LT. 0) THEN
         IF (LP.GE.0) WRITE(LP,*) 
      &     'Error return from SMUMPS_SUPVAR. INFO(1) = ',INFO44(1) 
@@ -974,7 +1013,7 @@ C
       IW(1:NSUP) = 0
       LEN(1:N) = 0
       DO I = 1,N
-        SUPVAR = IW(3*N+3+1+I)
+        SUPVAR = IW(3_8*int(N,8)+3_8+1_8+int(I,8))
         IF (SUPVAR .EQ. 0) CYCLE
         IF (IW(SUPVAR).NE.0) THEN
           LEN(I) = -IW(SUPVAR)
@@ -982,7 +1021,7 @@ C
           IW(SUPVAR) = I
         ENDIF
       ENDDO
-      IW(N+1:2*N) = 0
+      IW(int(N+1,8):2_8*int(N,8)) = 0
       NZ = 0_8
       DO SUPVAR = 1,NSUP
         I = IW(SUPVAR)
@@ -992,8 +1031,8 @@ C
             J = ELNOD(K3)
             IF ((J.GE.1) .AND. (J.LE.N)) THEN
               IF (LEN(J).GE.0) THEN
-                IF ((I.NE.J) .AND. (IW(N+J).NE.I)) THEN
-                  IW(N+J) = I
+                IF ((I.NE.J) .AND. (IW(int(N,8)+int(J,8)).NE.I)) THEN
+                  IW(int(N,8)+int(J,8)) = I
                   LEN(I) = LEN(I) + 1
                 ENDIF
               ENDIF
@@ -1049,12 +1088,12 @@ C
       END SUBROUTINE SMUMPS_ANA_G12_ELT
       SUBROUTINE SMUMPS_SUPVAR(N,NELT,NZ,ELTVAR,ELTPTR,NSUP,SVAR,
      &                 LIW,IW,LP,INFO)
-      INTEGER LIW,LP,N,NELT,NSUP,NZ
+      INTEGER LP,N,NELT,NSUP,NZ
+      INTEGER(8)::LIW
       INTEGER INFO(6)
       INTEGER ELTPTR(NELT+1),ELTVAR(NZ)
       INTEGER IW(LIW),SVAR(0:N)
-      INTEGER FLAG,NEW,VARS
-      EXTERNAL SMUMPS_SUPVARB
+      INTEGER(8) :: FLAG,NEW,VARS
       INFO(1) = 0
       INFO(2) = 0
       INFO(3) = 0
@@ -1063,19 +1102,20 @@ C
       IF (NELT.LT.1) GO TO 20
       IF (NZ.LT.ELTPTR(NELT+1)-1) GO TO 30
       IF (LIW.LT.6) THEN
-         INFO(4) = 3*N + 3
+         INFO(4) = N + 1
          GO TO 40
       END IF
-      NEW = 1
-      VARS = NEW + LIW/3
-      FLAG = VARS + LIW/3
-      CALL SMUMPS_SUPVARB(N,NELT,ELTPTR,NZ,ELTVAR,SVAR,NSUP,LIW/3-1,
+      NEW = 1_8
+      VARS = NEW + LIW/3_8
+      FLAG = VARS + LIW/3_8
+      CALL SMUMPS_SUPVARB(N,NELT,ELTPTR,NZ,ELTVAR,SVAR,NSUP,
+     &           int(min(int(huge(NSUP)-1,8),LIW/3_8-1_8)),
      &           IW(NEW),IW(VARS),IW(FLAG),INFO)
       IF (INFO(1).EQ.-4) THEN
-         INFO(4) = 3*N + 3
+         INFO(4) = N + 1
          GO TO 40
       ELSE
-         INFO(4) = 3*NSUP + 3
+         INFO(4) = NSUP + 1
       END IF
       GO TO 50
    10 INFO(1) = -1
@@ -1090,12 +1130,12 @@ C
    40 INFO(1) = -4
       IF (LP.GT.0) THEN
          WRITE (LP,FMT=9000) INFO(1)
-         WRITE (LP,FMT=9010) INFO(4)
+         WRITE (LP,FMT=9010) 3_8*int(INFO(4),8)
       END IF
    50 RETURN
  9000 FORMAT (/3X,'Error message from SMUMPS_SUPVAR: INFO(1) = ',I2)
  9010 FORMAT (3X,'LIW is insufficient. Upper bound on required work',
-     &       'space is ',I8)
+     &       'space is ',I12)
       END SUBROUTINE SMUMPS_SUPVAR
       SUBROUTINE SMUMPS_SUPVARB( N, NELT, ELTPTR, NZ, ELTVAR,
      &           SVAR, NSUP, MAXSUP, NEW, VARS, FLAG, INFO )
diff -pruN 5.6.2-2.1/src/sana_aux_par.F 5.7.1-1/src/sana_aux_par.F
--- 5.6.2-2.1/src/sana_aux_par.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/sana_aux_par.F	2024-05-02 10:15:25.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -53,19 +53,25 @@ C
       LOGICAL    :: PROK, PROKG, LPOK
       INTEGER N, NORIG
       CONTAINS
-      SUBROUTINE SMUMPS_ANA_F_PAR(id, WORK1, WORK2, NFSIZ, FILS,
+      SUBROUTINE SMUMPS_ANA_F_PAR(id, WORK1, WORK2, LWORK1, LWORK2,
+     &     NFSIZ, FILS,
      &     FRERE, COMM_PARASYMB, LUMAT, SIZEOFBLOCKS, 
      &     COMM_PARAORD, NPROCS_PARAORD, 
      &     RKinSYMB_PROC0ORD)
       USE SMUMPS_STRUC_DEF
       IMPLICIT NONE
       TYPE(SMUMPS_STRUC)   :: id
-      INTEGER, TARGET     :: WORK1(:), WORK2(:)
-      INTEGER, ALLOCATABLE :: FILS(:)
-      INTEGER, POINTER    :: NFSIZ(:), FRERE(:)
-      INTEGER, INTENT(IN) :: COMM_PARASYMB
+      INTEGER, TARGET        :: WORK1(:), WORK2(:)
+      INTEGER(8), INTENT(IN) :: LWORK1, LWORK2
+#if defined(MUMPS_NOF2003)
+      INTEGER, POINTER       :: FILS(:)
+#else
+      INTEGER, ALLOCATABLE   :: FILS(:)
+#endif
+      INTEGER, POINTER       :: NFSIZ(:), FRERE(:)
+      INTEGER, INTENT(IN)    :: COMM_PARASYMB
       TYPE(LMATRIX_T), OPTIONAL       :: LUMAT
-      INTEGER, INTENT(IN), OPTIONAL   :: SIZEOFBLOCKS(id%NBLK)
+      INTEGER, INTENT(IN), TARGET, OPTIONAL   :: SIZEOFBLOCKS(id%NBLK)
       INTEGER, INTENT(IN), OPTIONAL   :: COMM_PARAORD, 
      &                                   NPROCS_PARAORD, 
      &                                   RKinSYMB_PROC0ORD
@@ -78,9 +84,13 @@ C
       INTEGER              :: MYID, NPROCS, IERR, NEMIN, LDIAG
       LOGICAL              :: SPLITROOT
       INTEGER(8), PARAMETER :: K79REF=12000000_8
-      INTEGER, PARAMETER :: LIDUMMY = 1
-      INTEGER :: IDUMMY(1) 
       DOUBLE PRECISION      :: TIMEB
+      INTEGER HOW_TO_SPLIT_ROOT, INODE_Scalapack_CAND, 
+     &        NBSONS_Scalapack_CAND
+      INTEGER, POINTER, DIMENSION(:) :: SIZEOFBLOCKS_PTR
+      INTEGER, TARGET    :: IDUMMY_ARRAY(1)
+      INTEGER            :: LSIZEOFBLOCKS_PTR
+      LOGICAL            :: SIZEOFBLOCKS_AVAIL
       nullify(IPE, NV, NE, NA, NODE, ND, SUBORD, NAMALG, IPS,
      &     CUMUL, SAVEIRN, SAVEJCN)
       CALL MPI_COMM_RANK (COMM_PARASYMB, MYID, IERR)
@@ -99,6 +109,16 @@ C
       PROKG = (MPG.GT.0) .AND. (MYID .EQ. 0)
       LPOK  = (LP.GT.0) .AND. (id%ICNTL(4).GE.1)
       LDIAG = id%ICNTL(4)
+      IF (present(SIZEOFBLOCKS)) THEN
+       SIZEOFBLOCKS_PTR => SIZEOFBLOCKS(1:N)
+       LSIZEOFBLOCKS_PTR = N
+       SIZEOFBLOCKS_AVAIL = .TRUE.
+      ELSE
+       SIZEOFBLOCKS_PTR => IDUMMY_ARRAY
+       SIZEOFBLOCKS_AVAIL = .FALSE.
+       LSIZEOFBLOCKS_PTR = 1
+       IDUMMY_ARRAY(1) = -1
+      ENDIF
       IF (PROKG) THEN
          WRITE(MPG,'(A,I10)') 
      &   " Parallel analysis, processing a graph of size:", N
@@ -121,12 +141,17 @@ C
       CALL SMUMPS_SET_PAR_ORD(id, COMM_PARASYMB, MYID, NPROCS, 
      &     ord, COMM_PARAORD, NPROCS_PARAORD,
      &     RKinSYMB_PROC0ORD)
-      IF (ord%COMM.NE.MPI_COMM_NULL) THEN
-       ord%PERMTAB => WORK1(1        : N)
-       ord%PERITAB => WORK1(N+1   : 2*N)
-       ord%TREETAB => WORK1(2*N+1 : 3*N)
+      IF ( LWORK1 .LT. 3_8 *int(N,8) ) THEN
+         WRITE(LP,*)
+     &      'Insufficient workspace in SMUMPS_ANA_F_PAR' 
+         CALL MUMPS_ABORT()
       ENDIF
-      IF(id%KEEP(54) .NE. 3) THEN
+      IF ( ord%COMM .NE. MPI_COMM_NULL ) THEN
+        ord%PERMTAB => WORK1(         1       : N)
+        ord%PERITAB => WORK1(    int(N,8)+1_8 : 2_8*int(N,8))
+        ord%TREETAB => WORK1(2_8*int(N,8)+1_8 : 3_8*int(N,8))
+      ENDIF
+      IF ( id%KEEP(54) .NE. 3 ) THEN
          IF(MYID.EQ.0) THEN
             SAVEIRN    => id%IRN_loc
             SAVEJCN    => id%JCN_loc
@@ -143,10 +168,10 @@ C
       IF (PROKG) CALL MUMPS_SECDEB( TIMEB )
       IF (id%KEEP(339).GT.0) THEN
         CALL SMUMPS_DO_PAR_ORD(id, MYID, NPROCS, 
-     &                       ord, WORK2, LUMAT, SIZEOFBLOCKS)
+     &       ord, WORK2, LWORK2, LUMAT, SIZEOFBLOCKS)
       ELSE
         CALL SMUMPS_DO_PAR_ORD(id, MYID, NPROCS, 
-     &                       ord, WORK2)
+     &       ord, WORK2, LWORK2)
       ENDIF
       IF (PROKG) THEN
        CALL MUMPS_SECFIN( TIMEB )
@@ -167,11 +192,12 @@ C
       END IF
       ord%SUBSTRAT = 0
       ord%TOPSTRAT = 0
-      IF (id%KEEP(339).GT.1) THEN
-        CALL SMUMPS_PARSYMFACT_LUMAT(id, ord, IPE, NV, WORK2, LUMAT,
+      IF (id%KEEP(339).NE.0) THEN
+        CALL SMUMPS_PARSYMFACT_LUMAT(id, ord, IPE, NV,
+     &                               WORK2, LWORK2, LUMAT,
      &                               SIZEOFBLOCKS)
       ELSE
-        CALL SMUMPS_PARSYMFACT(id, ord, IPE, NV, WORK2)
+        CALL SMUMPS_PARSYMFACT(id, ord, IPE, NV, WORK2, LWORK2)
       ENDIF
       IF(id%KEEP(54) .NE. 3) THEN
          IF(ord%MYID.EQ.0) THEN
@@ -188,32 +214,25 @@ C
       CALL MUMPS_IDEALLOC(ord%FIRST, ord%LAST, MEMCNT=MEMCNT)
       IF (MYID .EQ. 0) THEN
          IPS => WORK1(1:N)
-         NE     => WORK1(N+1   : 2*N)
-         NA     => WORK1(2*N+1 : 3*N)
-         NODE   => WORK2(1        : N  )
-         ND     => WORK2(N+1   : 2*N)
-         SUBORD => WORK2(2*N+1 : 3*N)
-         NAMALG => WORK2(3*N+1 : 4*N)
+         NE     => WORK1(    int(N,8)+1_8 : 2_8*int(N,8))
+         NA     => WORK1(2_8*int(N,8)+1_8 : 3_8*int(N,8))
+         NODE   => WORK2(             1   : N  )
+         ND     => WORK2(    int(N,8)+1_8 : 2_8*int(N,8))
+         SUBORD => WORK2(2_8*int(N,8)+1_8 : 3_8*int(N,8))
+         NAMALG => WORK2(3_8*int(N,8)+1_8 : 4_8*int(N,8))
          CALL MUMPS_REALLOC(CUMUL, N, id%INFO, LP,
      &        STRING='CUMUL', MEMCNT=MEMCNT, ERRCODE=-7)
          IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
          NEMIN  = id%KEEP(1)
-         IF (N.LT.NORIG) THEN
-          CALL SMUMPS_ANA_LNEW(N, IPE(1), NV(1), IPS(1), NE(1),
-     &        NA(1), NFSIZ(1), NODE(1), id%INFOG(6), FILS(1), FRERE(1),
-     &        ND(1), NEMIN, SUBORD(1), id%KEEP(60), id%KEEP(20),
-     &        id%KEEP(38), NAMALG(1), id%KEEP(104), CUMUL(1),
-     &        id%KEEP(50), id%ICNTL(13), id%KEEP(37), id%KEEP(197),
-     &        id%NSLAVES, id%KEEP(250).EQ.1, .TRUE., 
-     &        SIZEOFBLOCKS, N)
-         ELSE
-          CALL SMUMPS_ANA_LNEW(N, IPE(1), NV(1), IPS(1), NE(1),
-     &        NA(1), NFSIZ(1), NODE(1), id%INFOG(6), FILS(1), FRERE(1),
-     &        ND(1), NEMIN, SUBORD(1), id%KEEP(60), id%KEEP(20),
-     &        id%KEEP(38), NAMALG(1), id%KEEP(104), CUMUL(1),
-     &        id%KEEP(50), id%ICNTL(13), id%KEEP(37), id%KEEP(197),
-     &        id%NSLAVES, id%KEEP(250).EQ.1, .FALSE., IDUMMY, LIDUMMY)
-         ENDIF
+         CALL SMUMPS_ANA_LNEW(N, IPE(1), NV(1), IPS(1), NE(1),
+     &       NA(1), NFSIZ(1), NODE(1), id%INFOG(6), FILS(1), FRERE(1),
+     &       ND(1), NEMIN, SUBORD(1), id%KEEP(60), id%KEEP(20),
+     &       id%KEEP(38), NAMALG(1), id%KEEP(104), CUMUL(1),
+     &       id%KEEP(50), id%ICNTL(13), id%KEEP(37), id%KEEP(197),
+     &       id%NSLAVES, id%KEEP(250).EQ.1, SIZEOFBLOCKS_AVAIL, 
+     &       SIZEOFBLOCKS_PTR(1), LSIZEOFBLOCKS_PTR,
+     &       INODE_Scalapack_CAND, NBSONS_Scalapack_CAND, 
+     &       id%KEEP(11))
          CALL MUMPS_DEALLOC(CUMUL, NV, IPE, MEMCNT=MEMCNT)
          CALL SMUMPS_ANA_M(NE(1), ND(1), id%INFOG(6), id%INFOG(5),
      &        id%KEEP(2), id%KEEP(50), id%KEEP8(101), id%KEEP(108),
@@ -221,6 +240,8 @@ C
          IF ( id%KEEP(53) .NE. 0 ) THEN
             CALL MUMPS_MAKE1ROOT(N, FRERE(1), FILS(1), NFSIZ(1),
      &           id%KEEP(20))
+            INODE_Scalapack_CAND  = id%KEEP(20)
+            NBSONS_Scalapack_CAND = 1
          END IF
          IF (  (id%KEEP(48) == 4 .AND. id%KEEP8(21).GT.0_8)
      &        .OR.
@@ -230,56 +251,84 @@ C
             CALL SMUMPS_SET_K821_SURFACE(id%KEEP8(21), id%KEEP(2),
      &           id%KEEP(48), id%KEEP(50), id%NSLAVES)
          END IF
-      IF (id%KEEP(210).LT.1.OR.id%KEEP(210).GT.2) id%KEEP(210)=2
-      IF (id%KEEP(210).EQ.2) id%KEEP8(79)=huge(id%KEEP8(79))
-      IF (id%KEEP(210).EQ.1.AND.id%KEEP8(79).LE.0_8) THEN
-       id%KEEP8(79)=K79REF * int(id%NSLAVES,8)
-      ENDIF
-         IF ( (id%KEEP(79).EQ.0).OR.(id%KEEP(79).EQ.2).OR.
-     &        (id%KEEP(79).EQ.3).OR.(id%KEEP(79).EQ.5).OR.
-     &        (id%KEEP(79).EQ.6)
-     &   )  THEN
-          IF (id%KEEP(210).EQ.1) THEN
+         IF (id%KEEP(210).LT.1.OR.id%KEEP(210).GT.2) id%KEEP(210)=2
+         IF (id%KEEP(210).EQ.2) id%KEEP8(79)=huge(id%KEEP8(79))
+         IF (id%KEEP(210).EQ.1.AND.id%KEEP8(79).LE.0_8) THEN
+          id%KEEP8(79)=K79REF * int(id%NSLAVES,8)
+         ENDIF
+         IF (id%KEEP(11).EQ.0) THEN
+          IF ( (id%KEEP(79).EQ.0).OR.(id%KEEP(79).EQ.2).OR.
+     &         (id%KEEP(79).EQ.3).OR.(id%KEEP(79).EQ.5).OR.
+     &         (id%KEEP(79).EQ.6)
+     &    )  THEN
+           IF (id%KEEP(210).EQ.1) THEN
             SPLITROOT = .FALSE. 
             IF ( id%KEEP(62).GE.1) THEN
-               IDUMMY(1) = -1
                CALL SMUMPS_CUTNODES(N, FRERE(1), FILS(1),
-     &              NFSIZ(1), IDUMMY, LIDUMMY, id%INFOG(6),
-     &              id%NSLAVES, id%KEEP(1), id%KEEP8(1), SPLITROOT,
-     &              MP, LDIAG, id%INFOG(1), id%INFOG(2))
+     &           NFSIZ(1), 
+     &           SIZEOFBLOCKS_PTR(1), LSIZEOFBLOCKS_PTR, id%INFOG(6), 
+     &           id%NSLAVES, id%KEEP(1), id%KEEP8(1), SPLITROOT,
+     &           MP, LDIAG, id%INFOG(1), id%INFOG(2))
                IF (id%INFOG(1).LT.0) RETURN
             ENDIF
+           ENDIF
           ENDIF
          ENDIF
-      SPLITROOT = id%ICNTL(13) .EQ. -1
+         HOW_TO_SPLIT_ROOT = 0 
+         SPLITROOT = id%ICNTL(13) .EQ. -1
 #if defined(NOSCALAPACK)
-      SPLITROOT = SPLITROOT .OR. id%NSLAVES.GT.0
+         SPLITROOT = SPLITROOT .OR. id%NSLAVES.GT.0
 #else
-      SPLITROOT = SPLITROOT .OR.
+         SPLITROOT = SPLITROOT .OR.
      &            (id%ICNTL(13).GT.0 .AND. id%NSLAVES.GT.id%ICNTL(13))
 #endif
-      IF (id%KEEP(53) .NE. 0) THEN
-         SPLITROOT = .TRUE.
-      ENDIF
+         IF (SPLITROOT.AND.id%KEEP(11).GT.0) HOW_TO_SPLIT_ROOT =1 
+         IF (id%KEEP(53) .NE. 0) THEN
+           SPLITROOT = .TRUE.
+           IF (id%KEEP(11).GT.0) HOW_TO_SPLIT_ROOT = 2
+         ENDIF
+#if defined(NOSCALAPACK)
+#else
+         IF ( id%KEEP(11).GT.0 .AND. (id%KEEP(339).NE.0) ) THEN 
+           IF (.NOT.SPLITROOT .AND. 
+     &       (id%KEEP(60).EQ.0).AND.   
+     &       ( (NFSIZ(INODE_Scalapack_CAND).GT.id%KEEP(37))
+     &        .AND.(id%ICNTL(13).LE.0) )
+     &       .AND.
+     &       (NBSONS_Scalapack_CAND.GT.id%KEEP(11)) 
+     &       ) THEN
+             HOW_TO_SPLIT_ROOT = 3
+             SPLITROOT=.TRUE.
+           ENDIF
+         ENDIF
+#endif
          SPLITROOT = (SPLITROOT.AND.( (id%KEEP(60).EQ.0) ))
          IF (SPLITROOT) THEN
            IF (id%KEEP(339).EQ.0) THEN
-            IDUMMY(1) = -1
             CALL SMUMPS_CUTNODES(N, FRERE(1), FILS(1), NFSIZ(1),
-     &           IDUMMY, LIDUMMY, id%INFOG(6), 
+     &           SIZEOFBLOCKS_PTR(1), LSIZEOFBLOCKS_PTR, id%INFOG(6), 
      &           id%NSLAVES, id%KEEP(1), id%KEEP8(1),
      &           SPLITROOT, MP, LDIAG, id%INFOG(1), id%INFOG(2))
            ELSE
-            CALL SMUMPS_CUTNODES(N, FRERE(1), FILS(1), NFSIZ(1),
-     &           SIZEOFBLOCKS, id%NBLK, id%INFOG(6), 
+            IF (id%KEEP(11).EQ.0) THEN
+              CALL SMUMPS_CUTNODES(N, FRERE(1), FILS(1), NFSIZ(1),
+     &           SIZEOFBLOCKS_PTR(1), LSIZEOFBLOCKS_PTR, id%INFOG(6), 
      &           id%NSLAVES, id%KEEP(1), id%KEEP8(1),
      &           SPLITROOT, MP, LDIAG, id%INFOG(1), id%INFOG(2))
-           ENDIF
-            IF (id%INFOG(1).LT.0) RETURN
-            IF ( id%KEEP(53) .NE. 0 ) THEN
-              CALL MUMPS_MAKE1ROOT(N, FRERE(1), FILS(1), NFSIZ(1),
-     &           id%KEEP(20))
+              IF (id%INFOG(1).LT.0) RETURN
+              IF ( id%KEEP(53) .NE. 0 ) THEN
+                CALL MUMPS_MAKE1ROOT(N, FRERE(1), FILS(1), NFSIZ(1),
+     &             id%KEEP(20))
+              END IF
+            ELSE
+              CALL SMUMPS_SPLIT_ROOT( id%NSLAVES,
+     &                    HOW_TO_SPLIT_ROOT, INODE_Scalapack_CAND,
+     &                    N, FRERE(1), FILS(1), NFSIZ(1), 
+     &                    id%KEEP(1), id%KEEP8(1),
+     &                    SIZEOFBLOCKS_PTR(1), LSIZEOFBLOCKS_PTR,
+     &                    id%INFOG(6))
             END IF
+           END IF
          ENDIF
       END IF
       RETURN
@@ -415,13 +464,15 @@ C
        END IF
       ENDIF
       END SUBROUTINE SMUMPS_SET_PAR_ORD
-      SUBROUTINE SMUMPS_DO_PAR_ORD(id, MYID, NPROCS, ord, WORK, LUMAT, 
+      SUBROUTINE SMUMPS_DO_PAR_ORD(id, MYID, NPROCS, ord,
+     &                             WORK, LWORK, LUMAT, 
      &                             SIZEOFBLOCKS)
       IMPLICIT NONE
       TYPE(SMUMPS_STRUC)       :: id
       INTEGER, INTENT(IN)      :: MYID, NPROCS
       TYPE(ORD_TYPE)           :: ord
       INTEGER                  :: WORK(:)
+      INTEGER(8), INTENT(IN)   :: LWORK
       TYPE(LMATRIX_T), OPTIONAL       :: LUMAT
       INTEGER, INTENT(IN), OPTIONAL   :: SIZEOFBLOCKS(N)
 #if defined(parmetis) || defined(parmetis3)
@@ -440,10 +491,11 @@ C
       IF (ord%ORDTOOL .EQ. 1) THEN
 #if defined(ptscotch)
         IF (id%KEEP(339).NE.0) THEN
-         CALL SMUMPS_PTSCOTCH_ORD(id, ord, WORK, GCOMP_DIST,
+         CALL SMUMPS_PTSCOTCH_ORD(id, ord, WORK, LWORK,
+     &                     GCOMP_DIST,
      &                     SIZEOFBLOCKS )
         ELSE
-         CALL SMUMPS_PTSCOTCH_ORD(id, ord, WORK)
+         CALL SMUMPS_PTSCOTCH_ORD(id, ord, WORK, LWORK)
         ENDIF
 #else
          id%INFOG(1) = -38
@@ -454,10 +506,11 @@ C
       ELSE IF (ord%ORDTOOL .EQ. 2) THEN
 #if defined(parmetis) || defined(parmetis3)
          IF (id%KEEP(339).GT.0) THEN
-         CALL SMUMPS_PARMETIS_ORD_LUMAT (id, ord, WORK, GCOMP_DIST,
+         CALL SMUMPS_PARMETIS_ORD_LUMAT (id, ord, WORK, LWORK,
+     &                            GCOMP_DIST,
      &                            SIZEOFBLOCKS)
          ELSE
-           CALL SMUMPS_PARMETIS_ORD(id, ord, WORK)
+           CALL SMUMPS_PARMETIS_ORD(id, ord, WORK, LWORK)
          ENDIF
          IF (id%KEEP(339).EQ.0) THEN
           if(ord%IDO) CALL MPI_COMM_FREE(ord%COMM_PARAORD, IERR)
@@ -475,14 +528,14 @@ C
       RETURN
       END SUBROUTINE SMUMPS_DO_PAR_ORD
 #if defined(parmetis) || defined(parmetis3)
-      SUBROUTINE SMUMPS_PARMETIS_ORD(id, ord, WORK) 
+      SUBROUTINE SMUMPS_PARMETIS_ORD(id, ord, WORK, LWORK) 
       IMPLICIT NONE
-      TYPE(SMUMPS_STRUC)  :: id
-      TYPE(ORD_TYPE)      :: ord
-      INTEGER, TARGET    :: WORK(:)
+      TYPE(SMUMPS_STRUC)      :: id
+      TYPE(ORD_TYPE)          :: ord
+      INTEGER, TARGET         :: WORK(:)
+      INTEGER(8), INTENT (IN) :: LWORK
       INTEGER             :: I, MYID, NPROCS, IERR, BASE, METIS_IDX_SIZE
-      INTEGER, POINTER    :: FIRST(:),
-     &     LAST(:), SWORK(:)
+      INTEGER, POINTER    :: FIRST(:), LAST(:), SWORK(:)
       INTEGER             :: BASEVAL, VERTLOCNBR,
      &     OPTIONS(10)
       INTEGER(8), POINTER :: VERTLOCTAB(:)
@@ -497,7 +550,7 @@ C
       NPROCS          = ord%NPROCS
       IERR            = 0
       SIZE_IDUMMY_PTR = 0
-      IF(size(WORK) .LT. N*3 .OR.size(WORK).LT.NPROCS+1) THEN
+      IF( LWORK.LT. int(N,8)*3_8 .OR. LWORK .LT. int(NPROCS+1,8)) THEN
          WRITE(LP,
      &        '("Insufficient workspace inside SMUMPS_PARMETIS_ORD")')
          CALL MUMPS_ABORT()
@@ -510,14 +563,15 @@ C
       IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
       BASE    = id%NPROCS-id%NSLAVES
       CALL SMUMPS_GRAPH_DIST(id, ord, FIRST,
-     &     LAST, BASE, NPROCS, WORK(1: 2*N), TYPE=2)
+     &     LAST, BASE, NPROCS, WORK(1_8: 2_8*int(N,8)),
+     &     2_8*int(N,8), TYPE=2)
       VERTLOCNBR = LAST(MYID+1)-FIRST(MYID+1) + 1
       CALL MUMPS_I8REALLOC(VERTLOCTAB, VERTLOCNBR+1, id%INFO,
      &        LP, STRING='VERTLOCTAB', MEMCNT=MEMCNT, ERRCODE=-7)
       IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
-      SWORK => WORK(N+1:3*N)
+      SWORK => WORK(int(N+1,8):3_8*int(N,8))
       CALL SMUMPS_BUILD_DIST_GRAPH(id, ord, FIRST, LAST, VERTLOCTAB,
-     &     EDGELOCTAB, SWORK)
+     &     EDGELOCTAB, SWORK, 2_8 * int(N,8))
       CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &     ord%COMM, ord%MYID )
       IF(id%INFO(1).LT.0) GOTO 20
@@ -608,19 +662,20 @@ C
       CALL MUMPS_DEALLOC(ord%RANGTAB, MEMCNT=MEMCNT)
       RETURN
       END SUBROUTINE SMUMPS_PARMETIS_ORD
-      SUBROUTINE SMUMPS_PARMETIS_ORD_LUMAT (id, ord, WORK, GCOMP_DIST,
+      SUBROUTINE SMUMPS_PARMETIS_ORD_LUMAT (id, ord, WORK, LWORK,
+     &                              GCOMP_DIST,
      &                              SIZEOFBLOCKS )
       IMPLICIT NONE
-      TYPE(SMUMPS_STRUC)  :: id
-      TYPE(ORD_TYPE)      :: ord
-      INTEGER, TARGET    :: WORK(:)
+      TYPE(SMUMPS_STRUC)     :: id
+      TYPE(ORD_TYPE)         :: ord
+      INTEGER, TARGET        :: WORK(:)
+      INTEGER(8), INTENT(IN) :: LWORK
       TYPE(COMPACT_GRAPH_T), OPTIONAL       :: GCOMP_DIST
       INTEGER, INTENT(IN), OPTIONAL, TARGET :: SIZEOFBLOCKS(N)
       INTEGER             :: I, MYID, NPROCS, IERR, BASE, METIS_IDX_SIZE
       INTEGER             :: MASTER
       PARAMETER     (MASTER=0)
-      INTEGER, POINTER    :: FIRST(:),
-     &     LAST(:), SWORK(:)
+      INTEGER, POINTER    :: FIRST(:), LAST(:), SWORK(:)
       INTEGER             :: BASEVAL, VERTLOCNBR,
      &     OPTIONS(10)
       INTEGER(8), POINTER :: VERTLOCTAB(:)
@@ -637,7 +692,7 @@ C
       NPROCS          = ord%NPROCS
       IERR            = 0
       SIZE_VELOLOCTAB = 0
-      IF(size(WORK) .LT. N*3 .OR.size(WORK).LT.NPROCS+1) THEN
+      IF( LWORK.LT. int(N,8)*3_8 .OR. LWORK .LT. int(NPROCS+1,8)) THEN
          WRITE(LP,
      &        '("Insufficient workspace inside SMUMPS_PARMETIS_ORD")')
          CALL MUMPS_ABORT()
@@ -661,7 +716,7 @@ C
          EDGELOCNBR = GCOMP_DIST%NZG
          VERTLOCTAB => GCOMP_DIST%IPE
          EDGELOCTAB => GCOMP_DIST%ADJ
-         IF (id%KEEP(339).GE.6) THEN
+         IF (id%KEEP(339).NE.0) THEN
           VELOLOCTAB=>SIZEOFBLOCKS(GCOMP_DIST%FIRST:GCOMP_DIST%LAST)
           SIZE_VELOLOCTAB = VERTLOCNBR
          ENDIF
@@ -788,14 +843,14 @@ C
       END SUBROUTINE SMUMPS_PARMETIS_ORD_LUMAT
 #endif
 #if defined(ptscotch)
-      SUBROUTINE SMUMPS_PTSCOTCH_ORD(id, ord, WORK, GCOMP_DIST,
+      SUBROUTINE SMUMPS_PTSCOTCH_ORD(id, ord, WORK, LWORK, GCOMP_DIST,
      &                               SIZEOFBLOCKS)
 !$    USE OMP_LIB
       IMPLICIT NONE
-      INCLUDE 'ptscotchf.h'
       TYPE(SMUMPS_STRUC)                :: id
       TYPE(ORD_TYPE)                    :: ord
       INTEGER, TARGET                   :: WORK(:)
+      INTEGER(8), INTENT(IN)            :: LWORK
       TYPE(COMPACT_GRAPH_T), OPTIONAL   :: GCOMP_DIST
       INTEGER, INTENT(IN), OPTIONAL, TARGET:: SIZEOFBLOCKS(N)
       INTEGER                       :: MYID, NPROCS, IERR
@@ -809,7 +864,14 @@ C
       INTEGER, POINTER              :: VELOLOCTAB(:)
       INTEGER                       :: SIZE_VELOLOCTAB
       INTEGER, TARGET               :: IDUMMY(1)
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+      INCLUDE 'scotchf.h' 
+      INTEGER          :: IOMP, NOMP
+      DOUBLE PRECISION :: CONTDAT(SCOTCH_CONTEXTDIM)
+      INTEGER(4)       :: IERR_SCOTCH
+#else
       INTEGER :: PTHREAD_NUMBER, NOMP
+#endif
       nullify(FIRST, LAST, SWORK, VERTLOCTAB, EDGELOCTAB)
       VELOLOCTAB => IDUMMY 
       CALL MPI_BARRIER(ord%COMM, IERR)
@@ -822,12 +884,12 @@ C
         EDGELOCNBR = GCOMP_DIST%NZG
         VERTLOCTAB => GCOMP_DIST%IPE
         EDGELOCTAB => GCOMP_DIST%ADJ
-        IF (id%KEEP(339).GE.6) THEN
+        IF (id%KEEP(339).NE.0) THEN
          VELOLOCTAB => SIZEOFBLOCKS(GCOMP_DIST%FIRST:GCOMP_DIST%LAST)
          SIZE_VELOLOCTAB = VERTLOCNBR
         ENDIF
       ELSE
-        IF (size(WORK) .LT. N*3) THEN
+        IF (LWORK .LT. int(N,8)*3_8) THEN
             WRITE(LP,
      &      '("Insufficient workspace inside SMUMPS_PTSCOTCH_ORD")')
             CALL MUMPS_ABORT()
@@ -839,14 +901,15 @@ C
      &     MEMCNT=MEMCNT, ERRCODE=-7)
         IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
         CALL SMUMPS_GRAPH_DIST(id, ord, FIRST,
-     &     LAST, BASE, NPROCS, WORK(1: 2*N), TYPE=2)
+     &     LAST, BASE, NPROCS, WORK(1: 2_8*int(N,8)),
+     &     2_8*int(N,8), TYPE=2)
         VERTLOCNBR = LAST(MYID+1)-FIRST(MYID+1) + 1
         CALL MUMPS_I8REALLOC(VERTLOCTAB, VERTLOCNBR+1, id%INFO,
      &        LP, STRING='VERTLOCTAB', MEMCNT=MEMCNT, ERRCODE=-7)
         IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
-        SWORK => WORK(N+1:3*N)
+        SWORK => WORK(int(N+1,8):3_8*int(N,8))
         CALL SMUMPS_BUILD_DIST_GRAPH(id, ord, FIRST, LAST, VERTLOCTAB,
-     &     EDGELOCTAB, SWORK)
+     &     EDGELOCTAB, SWORK, 2_8*int(N,8))
         CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &     ord%COMM, ord%MYID )
         IF ( id%INFO(1) .LT. 0 ) GOTO 11
@@ -863,35 +926,65 @@ C
       IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
       IF(ord%IDO) THEN
          CALL MUMPS_SCOTCH_INTSIZE(SCOTCH_INT_SIZE)
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+!$OMP PARALLEL PRIVATE(IOMP, IERR_SCOTCH)
+!$OMP SINGLE
+         NOMP=omp_get_num_threads()
+!$OMP END SINGLE
+         IOMP=omp_get_thread_num()
+         IF (IOMP.EQ.0) THEN
+           CALL SCOTCHFCONTEXTINIT(CONTDAT, IERR_SCOTCH)
+           CALL SCOTCHFCONTEXTRANDOMCLONE(CONTDAT, IERR_SCOTCH)
+           CALL SCOTCHFCONTEXTTHREADIMPORT1(CONTDAT, NOMP, IERR_SCOTCH)
+         ENDIF
+!$OMP BARRIER
+         CALL SCOTCHFCONTEXTTHREADIMPORT2(CONTDAT, IOMP, IERR_SCOTCH)
+#else
          NOMP=0
 !$       NOMP=omp_get_max_threads()
          IF (NOMP .GT. 0) THEN
            CALL MUMPS_SCOTCH_GET_PTHREAD_NUMBER (PTHREAD_NUMBER)
            CALL MUMPS_SCOTCH_SET_PTHREAD_NUMBER (NOMP)
          ENDIF
-         IF(SCOTCH_INT_SIZE.EQ.32) THEN
-           IF (id%KEEP(10).EQ.1) THEN
-            id%INFO(1) = -52
-            id%INFO(2) = 2
+#endif
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+         IF (IOMP.EQ.0) THEN
+#endif
+           IF(SCOTCH_INT_SIZE.EQ.32) THEN
+             IF (id%KEEP(10).EQ.1) THEN
+              id%INFO(1) = -52
+              id%INFO(2) = 2
+             ELSE
+              CALL MUMPS_PTSCOTCH_MIXEDto32(id, ord,
+     &             BASEVAL, 
+     &             VERTLOCNBR, VERTLOCTAB,
+     &             EDGELOCNBR, EDGELOCTAB,
+     &             VELOLOCTAB, SIZE_VELOLOCTAB,
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+     &             CONTDAT, SCOTCH_CONTEXTDIM,
+#endif
+     &             IERR)
+            ENDIF
            ELSE
-            CALL MUMPS_PTSCOTCH_MIXEDto32(id, ord,
-     &           BASEVAL, 
-     &           VERTLOCNBR, VERTLOCTAB,
-     &           EDGELOCNBR, EDGELOCTAB,
-     &           VELOLOCTAB, SIZE_VELOLOCTAB,
-     &           IERR)
-          ENDIF
-         ELSE
-            CALL MUMPS_PTSCOTCH_MIXEDto64(id, ord,
-     &           BASEVAL, 
-     &           VERTLOCNBR, VERTLOCTAB,
-     &           EDGELOCNBR, EDGELOCTAB,
-     &           VELOLOCTAB, SIZE_VELOLOCTAB,
-     &           IERR)
-         END IF
+              CALL MUMPS_PTSCOTCH_MIXEDto64(id, ord,
+     &             BASEVAL, 
+     &             VERTLOCNBR, VERTLOCTAB,
+     &             EDGELOCNBR, EDGELOCTAB,
+     &             VELOLOCTAB, SIZE_VELOLOCTAB,
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+     &             CONTDAT, SCOTCH_CONTEXTDIM,
+#endif
+     &             IERR)
+           END IF
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+           CALL SCOTCHFCONTEXTEXIT(CONTDAT)
+         ENDIF 
+!$OMP END PARALLEL
+#else
          IF (NOMP .GT. 0) THEN
            CALL MUMPS_SCOTCH_SET_PTHREAD_NUMBER (PTHREAD_NUMBER)
          ENDIF
+#endif
       END IF
       IF(IERR.NE.0) THEN
          id%INFO(1:2) = -50
@@ -996,7 +1089,7 @@ C
       HOSTMEM = 12*N 
       NZ4=int(id%KEEP8(28))
       NZ_ROW = 2*(NZ4/N) 
-      IF (id%KEEP(339).GT.2) THEN
+      IF (id%KEEP(339).NE.0) THEN
          NRL = 0
       ELSE
         IF(id%KEEP(46) .EQ. 0) THEN
@@ -1152,7 +1245,7 @@ C
       CALL SMUMPS_MERGESORT(ANODE, AWEIGHTS(1:ANODE), WORK(0:ANODE+1))
       CALL SMUMPS_MERGESWAP(ANODE, WORK(0:ANODE+1), AWEIGHTS(1:ANODE), 
      &     ALIST(1:ANODE))
-      IF (id%KEEP(339).GE.4) THEN
+      IF (id%KEEP(339).NE.0) THEN
        Iprocdeb = ord%NPROCS-ANODE+1
        IF (Iprocdeb.GT.1) THEN
          DO I=1, Iprocdeb-1
@@ -1216,28 +1309,26 @@ C
  90   continue
       RETURN
       END SUBROUTINE SMUMPS_GET_SUBTREES
-      SUBROUTINE SMUMPS_PARSYMFACT(id, ord, GPE, GNV, WORK)  
+      SUBROUTINE SMUMPS_PARSYMFACT(id, ord, GPE, GNV, WORK, LWORK)  
       IMPLICIT NONE
-      TYPE(SMUMPS_STRUC)   :: id
-      TYPE(ORD_TYPE)       :: ord
-      INTEGER, POINTER     :: GPE(:), GNV(:)
-      INTEGER, TARGET      :: WORK(:)
-      TYPE(GRAPH_TYPE)     :: top_graph
-      INTEGER(8), POINTER  :: IPE(:), IPET(:),
-     &     BUF_PE1(:), BUF_PE2(:), TMP1(:)
-      INTEGER, POINTER     :: PE(:),
-     &     LENG(:), I_HALO_MAP(:)
-      INTEGER, POINTER     :: NDENSE(:), LAST(:),
-     &     DEGREE(:), W(:), PERM(:),
-     &     LISTVAR_SCHUR(:), NEXT(:),
-     &     HEAD(:), NV(:), ELEN(:),
-     &     LSTVAR(:)
-      INTEGER, POINTER     :: MYLIST(:),
-     &     LPERM(:),
-     &     LIPERM(:),
-     &     NVT(:), BUF_NV1(:),
-     &     BUF_NV2(:), ROOTPERM(:),
-     &     TMP2(:), BWORK(:), NCLIQUES(:)
+      TYPE(SMUMPS_STRUC)     :: id
+      TYPE(ORD_TYPE)         :: ord
+      INTEGER, POINTER       :: GPE(:), GNV(:)
+      INTEGER, TARGET        :: WORK(:)
+      INTEGER(8), INTENT(IN) :: LWORK
+      TYPE(GRAPH_TYPE)       :: top_graph
+      INTEGER(8), POINTER    :: IPE(:), IPET(:),
+     &                          BUF_PE1(:), BUF_PE2(:), TMP1(:)
+      INTEGER, POINTER       :: PE(:), LENG(:), I_HALO_MAP(:)
+      INTEGER, POINTER       :: NDENSE(:), LAST(:),
+     &                          DEGREE(:), W(:), PERM(:),
+     &                          LISTVAR_SCHUR(:), NEXT(:),
+     &                          HEAD(:), NV(:), ELEN(:),
+     &                          LSTVAR(:)
+      INTEGER, POINTER       :: MYLIST(:), LPERM(:), LIPERM(:),
+     &                          NVT(:), BUF_NV1(:),
+     &                          BUF_NV2(:), ROOTPERM(:),
+     &                          TMP2(:), BWORK(:), NCLIQUES(:)
       INTEGER              :: MYNCLIQUES, MYMAXVARS, ICLIQUES,
      &     TOTNCLIQUES
       INTEGER(8)           :: MYNVARS, TOTNVARS
@@ -1262,14 +1353,14 @@ C
      &     BUF_NV1, BUF_NV2, ROOTPERM, TMP1, TMP2, BWORK)
       MYID   = ord%MYID
       NPROCS = ord%NPROCS
-      IF(size(WORK) .LT. 4*N) THEN
+      IF(LWORK .LT. 4_8*int(N,8)) THEN
          WRITE(LP,*)'Insufficient workspace in SMUMPS_PARSYMFACT'
          CALL MUMPS_ABORT()
       ELSE
-         HEAD => WORK(       1 :   N)
-         ELEN => WORK(  N+1 : 2*N)
-         LENG => WORK(2*N+1 : 3*N)
-         PERM => WORK(3*N+1 : 4*N)
+         HEAD => WORK(              1 :         N    )
+         ELEN => WORK(     int(N,8)+1 : 2_8*int(N,8) )
+         LENG => WORK( 2_8*int(N,8)+1 : 3_8*int(N,8) )
+         PERM => WORK( 3_8*int(N,8)+1 : 4_8*int(N,8) )
       END IF
       CALL SMUMPS_GET_SUBTREES(ord, id)
       CALL MUMPS_IDEALLOC(ord%SON, ord%BROTHER, ord%NW,
@@ -1277,9 +1368,9 @@ C
       NROWS_LOC = ord%LAST(MYID+1)-ord%FIRST(MYID+1)+1
       NRL = NROWS_LOC
       TOPROWS = ord%TOPNODES(2)
-      BWORK => WORK(1 : 2*N)
+      BWORK => WORK(1_8 : 2_8*int(N,8))
       CALL SMUMPS_BUILD_LOC_GRAPH(id, ord, HIDX, IPE, PE, LENG,
-     &     I_HALO_MAP, top_graph, BWORK)
+     &     I_HALO_MAP, top_graph, BWORK, 2_8*int(N,8))
       CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &     ord%COMM, ord%MYID )
       IF(id%INFO(1).lt.0) RETURN
@@ -1377,7 +1468,7 @@ C
      &              PROC, ITAG, ord%COMM, STATUSCLIQUES, IERR)
             END DO
          END DO
-         LPERM => WORK(3*N+1 : 4*N)
+         LPERM => WORK(3_8*int(N,8)+1_8 : 4_8*int(N,8))
          NTVAR   = ord%TOPNODES(2)
          CALL SMUMPS_MAKE_LOC_IDX(id, ord%TOPNODES, LPERM, LIPERM, ord)
          CALL SMUMPS_ASSEMBLE_TOP_GRAPH(id, ord%TOPNODES(2), LPERM,
@@ -1563,7 +1654,7 @@ C
       NULLIFY(HEAD, ELEN, LENG, PERM)
       RETURN
       END SUBROUTINE SMUMPS_PARSYMFACT
-      SUBROUTINE SMUMPS_PARSYMFACT_LUMAT(id, ord, GPE, GNV, WORK, 
+      SUBROUTINE SMUMPS_PARSYMFACT_LUMAT(id, ord, GPE, GNV, WORK, LWORK,
      &                                   LUMAT, SIZEOFBLOCKS)  
       IMPLICIT NONE
       TYPE(SMUMPS_STRUC)   :: id
@@ -1590,7 +1681,7 @@ C
      &     TMP2(:), BWORK(:), NCLIQUES(:), MAPTAB(:)
       INTEGER              :: MYNCLIQUES, MYMAXVARS, ICLIQUES,
      &     TOTNCLIQUES
-      INTEGER(8)           :: MYNVARS, TOTNVARS
+      INTEGER(8)           :: MYNVARS, TOTNVARS, LWORK
       INTEGER(8), POINTER  :: LVARPT(:)
       INTEGER              :: HIDX, TOTEL, 
      &     NCMPA, I, J, SIZE_SCHUR, MYID,
@@ -1612,26 +1703,25 @@ C
      &     BUF_NV1, BUF_NV2, ROOTPERM, TMP1, TMP2, BWORK, MAPTAB)
       MYID   = ord%MYID
       NPROCS = ord%NPROCS
-      IF(size(WORK) .LT. 4*N) THEN
+      IF( LWORK .LT. 4_8*int(N,8) ) THEN
          WRITE(LP,*)
      &      'Insufficient workspace in SMUMPS_PARSYMFACT_LUMAT'
          CALL MUMPS_ABORT()
-      ELSE
-         HEAD => WORK(       1 :   N)
-         ELEN => WORK(  N+1 : 2*N)
-         LENG => WORK(2*N+1 : 3*N)
-         PERM => WORK(3*N+1 : 4*N)
-      END IF
+      ENDIF
+      HEAD => WORK(              1   :         N    )
+      ELEN => WORK(     int(N,8)+1_8 : 2_8*int(N,8) )
+      LENG => WORK( 2_8*int(N,8)+1_8 : 3_8*int(N,8) )
+      PERM => WORK( 3_8*int(N,8)+1_8 : 4_8*int(N,8) )
       CALL SMUMPS_GET_SUBTREES(ord, id)
       CALL MUMPS_IDEALLOC(ord%SON, ord%BROTHER, ord%NW,
      &     ord%RANGTAB, MEMCNT=MEMCNT)
       NROWS_LOC = ord%LAST(MYID+1)-ord%FIRST(MYID+1)+1
       NRL = NROWS_LOC
       TOPROWS = ord%TOPNODES(2)
-      BWORK  => WORK(1 : 2*N)
+      BWORK  => WORK(1_8 : 2_8*int(N,8))
        CALL SMUMPS_LUMAT_TO_LOC_GRAPH(
      &     LUMAT, id, ord, HIDX, IPE, PE, LENG,
-     &     I_HALO_MAP, BWORK)
+     &     I_HALO_MAP, BWORK, 2_8*int(N,8))
       CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &     ord%COMM, ord%MYID )
       IF(id%INFO(1).lt.0) RETURN
@@ -1680,7 +1770,7 @@ C
          IF(HIDX .GT.0) THEN
            NV(1) = -1 
            TOTEL = HIDX
-           IF ((N.LT.NORIG).OR.(id%KEEP(339).GE.4)) THEN
+           IF ((N.LT.NORIG).OR.(id%KEEP(339).NE.0)) THEN
              TOTEL = 0
              DO I=1,NROWS_LOC
                NV(I) = SIZEOFBLOCKS (
@@ -1759,13 +1849,13 @@ C
          END DO
       END IF
       CALL MUMPS_DEALLOC(PE, MEMCNT=MEMCNT) 
-      IF (id%KEEP(339).GT.2) THEN
+      IF (id%KEEP(339).NE.0) THEN
           MAPTAB => WORK(1:N)
           CALL MUMPS_BUILD_TOP_GRAPH (LUMAT, id, ord, top_graph, MAPTAB)
       ENDIF
       IF (MYID.EQ.0) THEN
-        LPERM => WORK(3*N+1 : 4*N)
-        NTVAR   = ord%TOPNODES(2)
+        LPERM => WORK( 3_8*int(N,8)+1_8 : 4_8*int(N,8) )
+        NTVAR = ord%TOPNODES(2)
         CALL SMUMPS_MAKE_LOC_IDX(id, ord%TOPNODES, LPERM, LIPERM, ord)
         CALL SMUMPS_ASSEMBLE_TOP_GRAPH(id, ord%TOPNODES(2), LPERM,
      &        top_graph, TOTNCLIQUES, LSTVAR, LVARPT, IPET, PE,
@@ -1813,7 +1903,7 @@ C
             IF(TGSIZE.GT.0) THEN 
               NVT(1) = -1 
               TOTEL = TGSIZE
-              IF ((N.LT.NORIG).OR.(id%KEEP(339).GE.4)) THEN
+              IF ((N.LT.NORIG).OR.(id%KEEP(339).NE.0)) THEN
                 TOTEL = TOTNCLIQUES
                 DO I=1,NTVAR
                   NVT(I) = SIZEOFBLOCKS( LIPERM(I) )
@@ -1939,7 +2029,7 @@ C
      &     MEMCNT=MEMCNT)
       CALL MUMPS_DEALLOC(LPERM, LIPERM, NVT, MEMCNT=MEMCNT)
       CALL MUMPS_DEALLOC(ROOTPERM, TMP2, MEMCNT=MEMCNT)
-      NULLIFY(HEAD, ELEN, LENG, PERM)
+      NULLIFY(HEAD, ELEN, LENG, PERM, BWORK, MAPTAB, LPERM)
       RETURN
       END SUBROUTINE SMUMPS_PARSYMFACT_LUMAT
       SUBROUTINE SMUMPS_MAKE_LOC_IDX(id, TOPNODES, LPERM, LIPERM, ord)
@@ -2115,13 +2205,14 @@ C
 #endif
 #if defined(ptscotch) || defined(parmetis) || defined(parmetis3)
       SUBROUTINE SMUMPS_BUILD_DIST_GRAPH(id, ord, FIRST, LAST, IPE,
-     &     PE, WORK)
+     &     PE, WORK, LWORK)
       IMPLICIT NONE
       TYPE(SMUMPS_STRUC)      :: id
       TYPE(ORD_TYPE)          :: ord
       INTEGER(8), POINTER     :: IPE(:)
       INTEGER, POINTER        :: FIRST(:), LAST(:), PE(:),
      &     WORK(:)
+      INTEGER(8), INTENT(IN)  :: LWORK
       INTEGER                 :: IERR, MYID, NPROCS
       INTEGER                 :: I, PROC, J, LOC_ROW
       INTEGER(8)              :: LOCNNZ, INNZ, NEW_LOCNNZ, OFFDIAG,
@@ -2148,7 +2239,7 @@ C
       nullify(TSENDI, TSENDJ, RCVBUF, APNT)
       MYID   = ord%MYID
       NPROCS = ord%NPROCS
-      IF(MUMPS_GETSIZE(WORK) .LT. N*2) THEN
+      IF(LWORK .LT. int(N,8)*2_8) THEN
          WRITE(LP,
      &        '("Insufficient workspace inside BUILD_SCOTCH_GRAPH")')
          CALL MUMPS_ABORT()
@@ -2174,8 +2265,8 @@ C
       BUFSIZE = id%KEEP(39)
       LOCNNZ = id%KEEP8(29)
       NROWS_LOC = LAST(MYID+1)-FIRST(MYID+1)+1
-      MAPTAB => WORK(     1 :   N)
-      LENG   => WORK(N+1 : 2*N)
+      MAPTAB => WORK(       1    :         N )
+      LENG   => WORK( int(N+1,8) : 2_8*int(N,8) )
       MAXS = 0
       DO I=1, NPROCS
          IF((LAST(I)-FIRST(I)+1) .GT. MAXS) THEN
@@ -2321,7 +2412,7 @@ C
       END SUBROUTINE SMUMPS_BUILD_DIST_GRAPH
 #endif      
       SUBROUTINE SMUMPS_BUILD_LOC_GRAPH(id, ord, GSIZE, IPE, PE, LENG,
-     &     I_HALO_MAP, top_graph, WORK)
+     &     I_HALO_MAP, top_graph, WORK, LWORK)
       IMPLICIT NONE
       TYPE(SMUMPS_STRUC)   :: id
       TYPE(ORD_TYPE)       :: ord
@@ -2329,6 +2420,7 @@ C
       INTEGER(8), POINTER  :: IPE(:)
       INTEGER, POINTER     :: PE(:), LENG(:),
      &     I_HALO_MAP(:), WORK(:)
+      INTEGER(8), INTENT(in) :: LWORK
       INTEGER              :: GSIZE
       INTEGER                :: IERR, MYID, NPROCS
       INTEGER                :: I, PROC, J, LOC_ROW
@@ -2355,13 +2447,13 @@ C
       nullify(TSENDI, TSENDJ, RCVBUF, APNT)
       MYID   = ord%MYID
       NPROCS = ord%NPROCS
-      IF(MUMPS_GETSIZE(WORK) .LT. N*2) THEN
+      IF( LWORK .LT. int(N,8)*2_8 ) THEN
          WRITE(LP,
      &        '("Insufficient workspace inside BUILD_LOC_GRAPH")')
          CALL MUMPS_ABORT()
       END IF
-      MAPTAB   => WORK(     1 :   N)
-      HALO_MAP => WORK(N+1 : 2*N)
+      MAPTAB   => WORK(      1    :         N   )
+      HALO_MAP => WORK(int(N+1,8) : 2_8*int(N,8))
       CALL MUMPS_I8REALLOC(SNDCNT, NPROCS, id%INFO, LP,
      &     MEMCNT=MEMCNT, ERRCODE=-7)
       CALL MUMPS_I8REALLOC(RCVCNT, NPROCS, id%INFO, LP,
@@ -2643,7 +2735,7 @@ C
       END SUBROUTINE SMUMPS_BUILD_LOC_GRAPH
       SUBROUTINE SMUMPS_LUMAT_TO_LOC_GRAPH 
      &     (LUMAT, id, ord, GSIZE, IPE, PE, LENG,
-     &     I_HALO_MAP, WORK)
+     &     I_HALO_MAP, WORK, LWORK)
       IMPLICIT NONE
       TYPE(LMATRIX_T), INTENT(IN) :: LUMAT
       TYPE(SMUMPS_STRUC)   :: id
@@ -2651,6 +2743,7 @@ C
       INTEGER(8), POINTER  :: IPE(:)
       INTEGER, POINTER     :: PE(:), LENG(:),
      &     I_HALO_MAP(:), WORK(:)
+      INTEGER(8), INTENT(IN) :: LWORK
       INTEGER              :: GSIZE
       INTEGER                :: IERR, MYID, NPROCS
       INTEGER                :: I, PROC, J, LOC_ROW 
@@ -2674,13 +2767,13 @@ C
       nullify( RCVBUF, APNT)
       MYID   = ord%MYID
       NPROCS = ord%NPROCS
-      IF(MUMPS_GETSIZE(WORK) .LT. N) THEN
+      IF ( LWORK .LT.2_8 * int(N,8) ) THEN
          WRITE(LP,
      &   '("Insufficient workspace inside SMUMPS_LUMAT_TO_LOC_GRAPH")')
          CALL MUMPS_ABORT()
       END IF
-      MAPTAB   => WORK(     1 :   N)
-      HALO_MAP => WORK(N+1 : 2*N)
+      MAPTAB   => WORK(       1    :         N   )
+      HALO_MAP => WORK( int(N+1,8) : 2_8*int(N,8))
       CALL MUMPS_I8REALLOC(SNDCNT, NPROCS, id%INFO, LP,
      &     MEMCNT=MEMCNT, ERRCODE=-7)
       CALL MUMPS_I8REALLOC(RCVCNT, NPROCS, id%INFO, LP,
@@ -3139,15 +3232,16 @@ C
       RETURN
       END SUBROUTINE SMUMPS_BUILD_TREE
       SUBROUTINE SMUMPS_GRAPH_DIST(id, ord, FIRST,
-     &     LAST, BASE, NPROCS, WORK, TYPE)
+     &     LAST, BASE, NPROCS, WORK, LWORK, TYPE)
       IMPLICIT NONE
-      TYPE(SMUMPS_STRUC)   :: id
-      TYPE(ORD_TYPE)       :: ord
-      INTEGER              :: FIRST(:), LAST(:), BASE, NPROCS, TYPE
-      INTEGER, TARGET      :: WORK(:)
-      INTEGER, POINTER     :: TMP(:), NZ_ROW(:)
-      INTEGER              :: I, IERR, P, F, J
-      INTEGER(8)           :: LOCNNZ, INNZ, LOCOFFDIAG,
+      TYPE(SMUMPS_STRUC)     :: id
+      TYPE(ORD_TYPE)         :: ord
+      INTEGER                :: FIRST(:), LAST(:), BASE, NPROCS, TYPE
+      INTEGER, TARGET        :: WORK(:)
+      INTEGER(8), INTENT(IN) :: LWORK
+      INTEGER, POINTER       :: TMP(:), NZ_ROW(:)
+      INTEGER                :: I, IERR, P, F, J
+      INTEGER(8)             :: LOCNNZ, INNZ, LOCOFFDIAG,
      &     OFFDIAG, T, SHARE
       DO I=0, BASE-1
          FIRST(I+1) = 0
@@ -3166,8 +3260,12 @@ C
             LAST (BASE+I) = N
          END DO
       ELSE IF (TYPE.EQ.2) THEN
+         IF (LWORK .LT. 2_8*int(N,8)) THEN
+           WRITE(*,*) "Insufficient workspace in SMUMPS_GRAPH_DIST"
+           CALL MUMPS_ABORT()
+         ENDIF
          TMP    => WORK(1:N)
-         NZ_ROW => WORK(N+1:2*N)
+         NZ_ROW => WORK(int(N+1,8):2-8*int(N,8))
          TMP = 0
          LOCOFFDIAG = 0_8
          LOCNNZ = id%KEEP8(29)
@@ -3181,7 +3279,7 @@ C
                END IF
             END IF
          END DO
-         CALL MPI_ALLREDUCE(TMP(1), NZ_ROW(1), N,
+         CALL MUMPS_BIGALLREDUCE(.FALSE., TMP(1), NZ_ROW(1), N,
      &        MPI_INTEGER, MPI_SUM, ord%COMM, IERR)
          CALL MPI_ALLREDUCE(LOCOFFDIAG, OFFDIAG, 1,
      &        MPI_INTEGER8, MPI_SUM, ord%COMM, IERR)
@@ -3284,7 +3382,7 @@ C
       IF (L(N+1) == 0) THEN
          RETURN 
       ELSE
-         L(N+1) = iabs(L(N+1))
+         L(N+1) = abs(L(N+1))
       END IF
  200  CONTINUE
       S = 0
@@ -3371,7 +3469,7 @@ C
       IF (SIZE_VELOLOCTAB.EQ.VERTLOCNBR) THEN
        CALL MUMPS_PARMETIS_VWGT(FIRST(1+BASE), VERTLOCTAB_I4(1),
      &     EDGELOCTAB(1), BASEVAL, OPTIONS(1), ORDER(1),
-     &     SIZES(1), COMM, VELOLOCTAB, IERR)
+     &     SIZES(1), COMM, VELOLOCTAB(1), IERR)
       ELSE
        CALL MUMPS_PARMETIS(FIRST(1+BASE), VERTLOCTAB_I4(1),
      &     EDGELOCTAB(1), BASEVAL, OPTIONS(1), ORDER(1),
@@ -3421,7 +3519,7 @@ C
      &     EDGELOCTAB(1),
      &     BASEVAL, OPTIONS(1),
      &     ORDER(1),
-     &     SIZES(1), COMM, VELOLOCTAB, IERR)
+     &     SIZES(1), COMM, VELOLOCTAB(1), IERR)
        ELSE
         CALL MUMPS_PARMETIS_64(FIRST(1+BASE), VERTLOCTAB(1),
      &     EDGELOCTAB(1),
@@ -3469,7 +3567,7 @@ C
      &     BASEVAL_I8, OPTIONS_I8(1),
 #endif
      &     ORDER_I8(1),
-     &     SIZES_I8(1), COMM, VELOLOCTAB_I8,
+     &     SIZES_I8(1), COMM, VELOLOCTAB_I8(1),
      &     IERR)
        ELSE
         CALL MUMPS_PARMETIS_64(FIRST_I8(1+BASE), VERTLOCTAB(1),
@@ -3514,6 +3612,9 @@ C
      &     VERTLOCNBR, VERTLOCTAB,
      &     EDGELOCNBR, EDGELOCTAB, 
      &     VELOLOCTAB, SIZE_VELOLOCTAB,
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+     &             CONTDAT, LCONTDAT,
+#endif
      &     IERR)
       IMPLICIT NONE
       INCLUDE 'ptscotchf.h'
@@ -3532,6 +3633,11 @@ C
      &     ORDEDAT(SCOTCH_DORDERDIM), STRADAT(SCOTCH_STRATDIM),
      &     CORDEDAT(SCOTCH_ORDERDIM)
       CHARACTER  STRSTRING*1024
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+      INTEGER             :: LCONTDAT
+      DOUBLE PRECISION    :: CONTDAT(LCONTDAT)
+      DOUBLE PRECISION    :: GRAPHDAT_BEFORE_CONTEXT(SCOTCH_DGRAPHDIM)
+#endif
       IF (.NOT.ord%IDO) RETURN
       nullify(VERTLOCTAB_I4)
       CALL MUMPS_REALLOC(VERTLOCTAB_I4, VERTLOCNBR+1, id%INFO, LP,
@@ -3554,7 +3660,14 @@ C
       ELSE
          MYWORKID = -1
       END IF
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+      CALL MUMPS_DGRAPHINIT(GRAPHDAT_BEFORE_CONTEXT, ord%COMM_PARAORD,
+     &                      IERR)
+      CALL SCOTCHFCONTEXTBINDDGRAPH(CONTDAT, GRAPHDAT_BEFORE_CONTEXT,
+     &                              GRAPHDAT, IERR)
+#else
       CALL MUMPS_DGRAPHINIT(GRAPHDAT, ord%COMM_PARAORD, IERR)
+#endif
       IF(IERR.NE.0) THEN
          id%INFO(1:2) = -50
       END IF
@@ -3641,8 +3754,11 @@ C
       IF(MYWORKID .EQ. 0) 
      &     CALL SCOTCHFDGRAPHCORDEREXIT(GRAPHDAT, CORDEDAT)
       CALL SCOTCHFDGRAPHORDEREXIT(GRAPHDAT, ORDEDAT)
-      CALL SCOTCHFSTRATEXIT(STRADAT) 
+      CALL SCOTCHFSTRATEXIT(STRADAT)
       CALL SCOTCHFDGRAPHEXIT(GRAPHDAT)
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+      CALL SCOTCHFDGRAPHEXIT(GRAPHDAT_BEFORE_CONTEXT)
+#endif
  10   CONTINUE
       CALL MUMPS_DEALLOC(VERTLOCTAB_I4, MEMCNT=MEMCNT)
       RETURN
@@ -3652,6 +3768,9 @@ C
      &     VERTLOCNBR, VERTLOCTAB,
      &     EDGELOCNBR, EDGELOCTAB,
      &     VELOLOCTAB, SIZE_VELOLOCTAB,
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+     &             CONTDAT, LCONTDAT,
+#endif
      &     IERR)
       IMPLICIT NONE
       INCLUDE 'ptscotchf.h'
@@ -3669,6 +3788,11 @@ C
      &     ORDEDAT(SCOTCH_DORDERDIM), STRADAT(SCOTCH_STRATDIM),
      &     CORDEDAT(SCOTCH_ORDERDIM)
       CHARACTER  STRSTRING*1024
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+      INTEGER             :: LCONTDAT
+      DOUBLE PRECISION    :: CONTDAT(LCONTDAT)
+      DOUBLE PRECISION    :: GRAPHDAT_BEFORE_CONTEXT(SCOTCH_DGRAPHDIM)
+#endif
       INTEGER(8), POINTER :: EDGELOCTAB_I8(:), PERMTAB_I8(:),
      &     PERITAB_I8(:), RANGTAB_I8(:), TREETAB_I8(:), VELOLOCTAB_I8(:)
       INTEGER(8)          :: CBLKNBR_I8, VERTLOCNBR_I8, BASEVAL_I8
@@ -3722,7 +3846,14 @@ C
        ENDIF
        BASEVAL_I8    = int(BASEVAL,8)
       ENDIF
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+      CALL MUMPS_DGRAPHINIT(GRAPHDAT_BEFORE_CONTEXT, ord%COMM_PARAORD,
+     &                      IERR)
+      CALL SCOTCHFCONTEXTBINDDGRAPH(CONTDAT, GRAPHDAT_BEFORE_CONTEXT,
+     &                              GRAPHDAT, IERR)
+#else
       CALL MUMPS_DGRAPHINIT(GRAPHDAT, ord%COMM_PARAORD, IERR)
+#endif
       IF(IERR.NE.0) THEN
          id%INFO(1:2) = -50
       END IF
@@ -3828,16 +3959,20 @@ C
       CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &     ord%COMM_PARAORD, ord%MYID_PARAORD )
       IF ( id%INFO(1) .LT. 0 ) GOTO 10
+      IF(MYWORKID .EQ. 0) 
+     &     CALL SCOTCHFDGRAPHCORDEREXIT(GRAPHDAT, CORDEDAT)
       CALL SCOTCHFDGRAPHORDEREXIT(GRAPHDAT, ORDEDAT)
       CALL SCOTCHFSTRATEXIT(STRADAT) 
       CALL SCOTCHFDGRAPHEXIT(GRAPHDAT)
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+      CALL SCOTCHFDGRAPHEXIT(GRAPHDAT_BEFORE_CONTEXT)
+#endif
  10   CONTINUE
       IF (id%KEEP(10).NE.1) THEN
        CALL MUMPS_I8DEALLOC(EDGELOCTAB_I8, MEMCNT=MEMCNT)
        IF (SIZE_VELOLOCTAB.GT.0)
      & CALL MUMPS_I8DEALLOC(VELOLOCTAB_I8, MEMCNT=MEMCNT)
        IF(MYWORKID .EQ. 0) THEN
-         CALL SCOTCHFDGRAPHCORDEREXIT(GRAPHDAT, CORDEDAT)
          CALL MUMPS_ICOPY_64TO32(PERMTAB_I8(1),
      &        size(ord%PERMTAB), ord%PERMTAB(1))
          CALL MUMPS_ICOPY_64TO32(PERITAB_I8(1),
diff -pruN 5.6.2-2.1/src/sana_dist_m.F 5.7.1-1/src/sana_dist_m.F
--- 5.6.2-2.1/src/sana_dist_m.F	2023-10-11 09:37:02.000000000 +0000
+++ 5.7.1-1/src/sana_dist_m.F	2024-05-02 10:15:25.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -80,6 +80,8 @@ C
       INTEGER  ISTEP_TO_INIV2( KEEP(71) )
       LOGICAL  I_AM_CAND(NMB_PAR2)
       INTEGER  CANDIDATES( SLAVEF+1, NMB_PAR2 )
+      INTEGER  PHASE
+      PARAMETER (PHASE=0)
       REAL OPSA
       DOUBLE PRECISION OPSA_LOC 
       INTEGER(8) MAX_SIZE_FACTOR
@@ -144,10 +146,15 @@ C
       INTEGER :: FLAG_L0OMP
       PARAMETER (FLAG_L0OMP=-2014)
       INCLUDE 'mumps_headers.h'
+      LOGICAL ROOT_OWNER
+      INTEGER(8) LWK_RR
+      INTEGER LIWK_RR
+      INTEGER IROOT, SIZE_ROOT
       INTEGER WHAT
       INTEGER(4) :: I4
       INTEGER(8) IDUMMY8
-      INTRINSIC min, int, real
+      INTRINSIC min, int
+      INTRINSIC real
       INTEGER SMUMPS_OOC_GET_PANEL_SIZE
       EXTERNAL SMUMPS_OOC_GET_PANEL_SIZE
       INTEGER MUMPS_PROCNODE, MUMPS_TYPENODE
@@ -410,7 +417,7 @@ C
      &                KEEP(494), 1, KEEP(490),
      &                KEEP(491), KEEP(492),
      &                KEEP(20), KEEP(60), DAD(STEP(INODE)), KEEP(38),
-     &                LRSTATUS, IDUMMY)
+     &                KEEP(123), LRSTATUS, IDUMMY)
       COMPRESS_PANEL = (LRSTATUS.GE.2)
       COMPRESS_CB    = ((LRSTATUS.EQ.1).OR.(LRSTATUS.EQ.3))
       IF (COMPRESS_PANEL.OR.COMPRESS_CB) NBNODES_BLR = NBNODES_BLR+1
@@ -720,9 +727,9 @@ C
              ENDIF
             ENDIF
          ENDIF
-         NIRNEC = max0(NIRNEC,
+         NIRNEC = max(NIRNEC,
      &             NIRADU+ISTKI+SIZECBI+MAXITEMPCB)
-         NIRNEC_OOC = max0(NIRNEC_OOC,
+         NIRNEC_OOC = max(NIRNEC_OOC,
      &             NIRADU_OOC+ISTKI_OOC+SIZECBI+MAXITEMPCB +
      &             (XSIZE_OOC-XSIZE_IC) ) 
          CURRENT_ACTIVE_MEM = ISTKR+SIZECBINFR
@@ -852,7 +859,7 @@ C
      &                KEEP(494), 1, KEEP(490),
      &                KEEP(491), KEEP(492),
      &                KEEP(20), KEEP(60), DAD(STEP(IFSON)), KEEP(38),
-     &                LRSTATUSS, IDUMMY)
+     &                KEEP(123), LRSTATUSS, IDUMMY)
                COMPRESS_CBS   = ((LRSTATUSS.EQ.1).OR.(LRSTATUSS.EQ.3))
                IF (COMPRESS_CBS) THEN
                  K465_8    = int(KEEP(465),8)
@@ -1448,8 +1455,8 @@ C
            LSTKR(ITOP) = SIZECB
            ISTKR = ISTKR + LSTKR(ITOP)
            NRLNEC = max(NRLNEC,NRLADU+ISTKR+MAXTEMPCB)
-           NIRNEC = max0(NIRNEC,NIRADU+ISTKI+MAXITEMPCB)
-           NIRNEC_OOC = max0(NIRNEC_OOC,NIRADU_OOC+ISTKI_OOC+
+           NIRNEC = max(NIRNEC,NIRADU+ISTKI+MAXITEMPCB)
+           NIRNEC_OOC = max(NIRNEC_OOC,NIRADU_OOC+ISTKI_OOC+
      &          MAXITEMPCB + 
      &          (XSIZE_OOC-XSIZE_IC) ) 
            NRLNEC_if_LR_LU    =  max(NRLNEC_if_LR_LU,
@@ -1482,6 +1489,73 @@ C
          ENDIF
       ENDIF 
  115  CONTINUE
+      IF ( KEEP(53) .NE. 0 ) THEN
+        IF ( KEEP(38) .ne. 0 ) THEN
+          IROOT = KEEP( 38 )
+        ELSE
+          IROOT = KEEP( 20 )
+        END IF
+        ROOT_OWNER = ( MYID .eq.
+     &  MUMPS_PROCNODE( PROCNODE(STEP(IROOT)), KEEP(199) ) )
+        SIZE_ROOT = ND(STEP(IROOT))+KEEP(253)
+        CALL SMUMPS_SVD_QR_ESTIM_WK( PHASE, 
+     &       KEEP(51), KEEP(51), SIZE_ROOT,
+     &       LOCAL_M, LOCAL_N, ROOT_OWNER, KEEP,KEEP8,
+     &       LIWK_RR, LWK_RR )
+        IF ( NRLNEC-NRLADU .LT. LWK_RR ) THEN
+          NRLNEC = NRLADU + LWK_RR
+          NRLNEC_if_LR_LU   = NRLNEC_if_LR_LU + LWK_RR
+          NRLNEC_if_LR_CB   = NRLNEC_if_LR_CB + LWK_RR
+          NRLNEC_if_LR_LUCB = NRLNEC_if_LR_LUCB + LWK_RR
+          NRLNEC_ACTIVE     = NRLNEC_ACTIVE     + LWK_RR
+          NRLNECOOC_if_LR_LUCB = NRLNECOOC_if_LR_LUCB  + LWK_RR
+          PEAK_LRLU_UD = 
+     &             max(PEAK_LRLU_UD,
+     &             NRLNEC_if_LR_LU + NRLADULR_UD)
+          PEAK_OOC_LRLU_UD = 
+     &             max(PEAK_OOC_LRLU_UD,
+     &             NRLNEC_ACTIVE + NRLADULR_UD)
+          PEAK_OOC_LRLU_WC = 
+     &             max(PEAK_OOC_LRLU_WC,
+     &             NRLNEC_ACTIVE + NRLADULR_WC)
+          PEAK_LRLUCB_UD = 
+     &             max(PEAK_LRLUCB_UD,
+     &             NRLNEC_if_LR_LUCB + NRLNECLR_LUCB_UD)
+          PEAK_LRLUCB_WC = 
+     &             max(PEAK_LRLUCB_WC,
+     &             NRLNEC_if_LR_LUCB + NRLNECLR_LUCB_WC)
+          PEAK_OOC_LRLUCB_UD = 
+     &             max(PEAK_OOC_LRLUCB_UD,
+     &             NRLNECOOC_if_LR_LUCB + NRLNECLR_LUCB_UD)
+          PEAK_OOC_LRLUCB_WC = 
+     &             max(PEAK_OOC_LRLUCB_WC,
+     &             NRLNECOOC_if_LR_LUCB + NRLNECLR_LUCB_WC)
+          PEAK_LRCB_UD =
+     &             max(PEAK_LRCB_UD,
+     &             NRLNEC_if_LR_CB + NRLNECLR_CB_UD)
+          PEAK_OOC_LRCB_UD =
+     &             max(PEAK_OOC_LRCB_UD,
+     &             NRLNECOOC_if_LR_LUCB + NRLNECLR_CB_UD)
+          IF (ABOVE_L0) THEN
+           PEAK_DYN_LRLU_UD   = max( PEAK_DYN_LRLU_UD,
+     &          SIZECB_UNDER_L0 + NRLADULR_UD )
+           PEAK_DYN_LRCB_UD   = max( PEAK_DYN_LRCB_UD,
+     &          SIZECB_UNDER_L0_IF_LRCB + ISTKR_if_LRCB)
+           PEAK_DYN_LRLUCB_UD = max( PEAK_DYN_LRLUCB_UD,
+     &      SIZECB_UNDER_L0_IF_LRCB + ISTKR_if_LRCB + NRLADULR_UD)
+           PEAK_DYN_LRLU_WC   = max( PEAK_DYN_LRLU_WC,
+     &          SIZECB_UNDER_L0 + NRLADULR_WC)
+           PEAK_DYN_LRLUCB_WC = max( PEAK_DYN_LRLUCB_WC,
+     &          SIZECB_UNDER_L0 + ISTKRLR_CB_WC + NRLADULR_WC)
+          ENDIF
+        END IF
+        IF ( NIRNEC-NIRADU .LT. LIWK_RR ) THEN
+          NIRNEC = NIRADU + LIWK_RR
+        END IF
+        IF ( NIRNEC_OOC-NIRADU_OOC .LT. LIWK_RR ) THEN
+          NIRNEC_OOC = NIRADU_OOC + LIWK_RR
+        END IF
+      END IF
       NRLNEC = max(NRLNEC, NRLADU+int(KEEP(30),8))
       NRLNEC_ACTIVE = max(NRLNEC_ACTIVE, MAX_SIZE_FACTOR+
      &                    int(KEEP(30),8))
@@ -1938,7 +2012,7 @@ C
      &                KEEP(494), 1, KEEP(490),
      &                KEEP(491), KEEP(492),
      &                KEEP(20), KEEP(60), DAD(STEP(INODE)), KEEP(38),
-     &                LRSTATUS, IDUMMY)
+     &                KEEP(123), LRSTATUS, IDUMMY)
       COMPRESS_PANEL = (LRSTATUS.GE.2)
       COMPRESS_CB    = ((LRSTATUS.EQ.1).OR.(LRSTATUS.EQ.3))
       IF (COMPRESS_PANEL.OR.COMPRESS_CB) NBNODES_BLR = NBNODES_BLR+1
@@ -2010,9 +2084,9 @@ C
                NRLADU_if_LR_LU = NRLADU_if_LR_LU + NRLADU_CURRENT
       ENDIF
       SIZECBI        = 2* NCB  + SIZEHEADER
-      NIRNEC = max0(NIRNEC,
+      NIRNEC = max(NIRNEC,
      &             NIRADU+ISTKI+SIZECBI+MAXITEMPCB)
-      NIRNEC_OOC = max0(NIRNEC_OOC,
+      NIRNEC_OOC = max(NIRNEC_OOC,
      &             NIRADU_OOC+ISTKI_OOC+SIZECBI+MAXITEMPCB +
      &             (XSIZE_OOC-XSIZE_IC) ) 
       CURRENT_ACTIVE_MEM = ISTKR+SIZECBINFR
@@ -2243,8 +2317,8 @@ C
            LSTKR(ITOP) = SIZECB
            ISTKR = ISTKR + LSTKR(ITOP)
            NRLNEC = max(NRLNEC,NRLADU+ISTKR)
-           NIRNEC = max0(NIRNEC,NIRADU+ISTKI)
-           NIRNEC_OOC = max0(NIRNEC_OOC,NIRADU_OOC+ISTKI_OOC)
+           NIRNEC = max(NIRNEC,NIRADU+ISTKI)
+           NIRNEC_OOC = max(NIRNEC_OOC,NIRADU_OOC+ISTKI_OOC)
            NRLNEC_if_LR_LU  =  max(NRLNEC_if_LR_LU,
      &                             NRLADU_if_LR_LU+ISTKR)
            LSTKR_if_LRCB(ITOP) = SIZECB_if_LRCB
diff -pruN 5.6.2-2.1/src/sana_driver.F 5.7.1-1/src/sana_driver.F
--- 5.6.2-2.1/src/sana_driver.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/sana_driver.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -48,15 +48,14 @@ C     Local variables
 C     ===============
 C     
 C     
-C     Pointers inside integer array, various data
-      INTEGER IKEEP, NE, NA
+C     Pointers inside integer array IKEEPALLOC, various data
+      INTEGER(8) IKEEP, NE, NA
       INTEGER I, allocok
 C     Other locals
       INTEGER NB_NIV2, IDEST
       INTEGER :: STATUS(MPI_STATUS_SIZE)
       INTEGER LOCAL_M, LOCAL_N
-      INTEGER numroc
-      EXTERNAL numroc
+      INTEGER, EXTERNAL :: MUMPS_NUMROC
       INTEGER IRANK
       INTEGER MP, LP, MPG
       LOGICAL PROK, PROKG, LISTVAR_SCHUR_2BE_FREED, LPOK
@@ -148,7 +147,7 @@ C     Element matrix entry
       INTEGER :: OOC_STRAT, BLR_STRAT
       INTEGER :: IDUMMY
       INTEGER, TARGET    :: IDUMMY_ARRAY(1)
-      INTEGER(8)                     :: NNZ_loc
+      INTEGER(8)                     :: NNZ_loc, NNZ_TMP
       INTEGER, POINTER, DIMENSION(:) :: IRN_loc_PTR
       INTEGER, POINTER, DIMENSION(:) :: JCN_loc_PTR
       INTEGER, POINTER, DIMENSION(:) :: IRN_PTR
@@ -158,6 +157,7 @@ C     Element matrix entry
       LOGICAL :: BDUMMY
       INTEGER(8) :: K8_33relaxed, K8_34relaxed, K8_35relaxed,
      &              K8_50relaxed
+!$    INTEGER :: NOMP, NOMPMAX, NOMPMIN
       LOGICAL :: SUM_OF_PEAKS
       INTEGER MUMPS_TYPENODE, MUMPS_PROCNODE
       EXTERNAL MUMPS_TYPENODE, MUMPS_PROCNODE
@@ -219,11 +219,16 @@ C
      &     NFSIZPTR,
      &     FREREPTR, NE_STEPSPTR,
      &     IKEEP1, IKEEP2, IKEEP3
-      INTEGER, ALLOCATABLE, DIMENSION(:) :: FILS_TMP, STEP_TMP, 
+#if defined(MUMPS_NOF2003)
+      INTEGER, POINTER, DIMENSION(:) ::  FILS_TMPPTR
+#endif
+      INTEGER, ALLOCATABLE, DIMENSION(:), TARGET :: FILS_TMP
+      INTEGER, ALLOCATABLE, DIMENSION(:) :: STEP_TMP,
      &                                      LRGROUPS_TMP
       INTEGER, ALLOCATABLE, DIMENSION(:), TARGET :: IKEEPALLOC
       INTEGER, ALLOCATABLE, DIMENSION(:) :: WORK2ALLOC
-      INTEGER :: SIZEIKEEPALLOC, SIZELRGROUPS_TMP
+      INTEGER :: SIZELRGROUPS_TMP
+      INTEGER(8) :: SIZEIKEEPALLOC, SIZEWORK2ALLOC
 C     NBINROW_TMP, NBINCOL_TMP are computed in SMUMPS_ANA_DIST_N
 C     and used in SMUMPS_ANA_DIST_ARROWHEADS
       INTEGER, ALLOCATABLE, DIMENSION(:) :: NBINROW_TMP, NBINCOL_TMP
@@ -233,7 +238,7 @@ C     and used in SMUMPS_ANA_DIST_ARROWH
       INTEGER(kind=8) :: NZ8, LIW8
 C     NBLK : id%N or order of blocked matrix
       INTEGER :: NBLK, idNBLKSAVE
-      INTEGER :: LIW_ELT
+      INTEGER(8) :: LIW8_ELT
 C     GATHER_MATRIX_ALLOCATED: 
 C     To be sure that id%IRN and id%JCN are
 C     deallocated only when SMUMPS_GATHER_MATRIX was called
@@ -407,8 +412,25 @@ C     Broadcast KEEP(251,252,253) define
       CALL MPI_BCAST( KEEP(251), 3, MPI_INTEGER,MASTER,id%COMM,IERR)
 C
       CALL MPI_BCAST( KEEP(400), 1, MPI_INTEGER,MASTER,id%COMM,IERR)
+!$    IF (id%KEEP(400).GT.0) THEN
+!$       NOMP = OMP_GET_MAX_THREADS()
+!$       CALL MPI_ALLREDUCE(NOMP,NOMPMIN,1,MPI_INTEGER,MPI_MIN,
+!$   &                      id%COMM,IERR)
+!$       CALL MPI_ALLREDUCE(NOMP,NOMPMAX,1,MPI_INTEGER,MPI_MAX,
+!$   &                      id%COMM,IERR)
+!$       IF ( NOMPMIN .NE. NOMPMAX ) THEN
+!$          IF (PROKG) THEN
+!$             WRITE(MPG, '(A,A,I4,A,I4,A)')
+!$   &  '      WARNING tree parallelism (ICNTL(48)) switched off', 
+!$   &  ' because of different number of threads per MPI proc (max ',
+!$   &         NOMPMAX, ', min ', NOMPMIN, ')'
+!$          ENDIF
+!$          KEEP(400) = 0
+!$       END IF
+!$      ENDIF 
       CALL MPI_BCAST( id%KEEP(490), 5, MPI_INTEGER, MASTER,
      &     id%COMM, IERR )
+      CALL MPI_BCAST( KEEP(123),1,MPI_INTEGER,MASTER,id%COMM,IERR)
 C     ----------------------------------------------
 C     Broadcast N 
 C     ----------------------------------------------
@@ -472,7 +494,7 @@ C     test IRN_loc and JCN_loc allocated
       id%MEM_DIST(0:id%NSLAVES-1) = 0
       CALL MUMPS_INIT_ARCH_PARAMETERS(
      &     id%COMM,id%COMM_NODES,KEEP(69),KEEP(46),
-     &     id%NSLAVES,id%MEM_DIST,INFO)
+     &     id%NSLAVES,id%MEM_DIST,INFO )
 C     ========================
 C     Write problem to a file,
 C     if requested by the user
@@ -708,23 +730,38 @@ C         ===================
 C{        Sequential analysis
 C         ===================
 C         =======================
-          IF (KEEP(54).NE.3) THEN
+          IF (KEEP(54).NE.3.OR.id%NPROCS.EQ.1) THEN
 C         =======================
 C{        Matrix structure available on host
+C         also case of distributed input matrix format 
+C         with one mpi proc
 C         ---------------------
            KEEP(14) = 0 
            IF (id%MYID.EQ.MASTER) THEN
 C            Store input matrix (IRN/JCN) as a cleaned blocked Lmatrix 
 C            of nodes (indices \in [1,NBLK])
-             IF (id%KEEP8(28) .EQ. 0_8) THEN
-               IRN_PTR => IDUMMY_ARRAY
-               JCN_PTR => IDUMMY_ARRAY
+             IF (KEEP(54).NE.3) THEN
+               IF (id%KEEP8(28) .EQ. 0_8) THEN
+                 IRN_PTR => IDUMMY_ARRAY
+                 JCN_PTR => IDUMMY_ARRAY
+               ELSE
+                 IRN_PTR => id%IRN
+                 JCN_PTR => id%JCN
+               ENDIF
+               NNZ_TMP = id%KEEP8(28) 
              ELSE
-               IRN_PTR => id%IRN
-               JCN_PTR => id%JCN
-             ENDIF
+               IF (id%KEEP8(29) .EQ. 0_8) THEN ! NNZ_loc or NZ_loc
+                 IRN_PTR => IDUMMY_ARRAY
+                 JCN_PTR => IDUMMY_ARRAY
+                 id%KEEP8(29) = 0_8
+               ELSE
+                 IRN_PTR => id%IRN_loc
+                 JCN_PTR => id%JCN_loc
+               ENDIF
+               NNZ_TMP = id%KEEP8(29) 
+             ENDIF 
              CALL MUMPS_AB_COORD_TO_LMAT ( id%MYID,
-     &             NBLK, id%N, id%KEEP8(28), IRN_PTR(1), JCN_PTR(1),
+     &             NBLK, id%N, NNZ_TMP, IRN_PTR(1), JCN_PTR(1),
      &             DOF2BLOCK, 
      &             INFO(1), INFO(2), LP, LPOK, 
      &             LMAT_BLOCK, IDUMMY8, KEEP(1) )
@@ -742,7 +779,7 @@ C            symmetrizing the Lmatrix
      &            INFO(1), ICNTL(1), MEMCNT)
              GCOMP_PROVIDED = .TRUE.
              IF (KEEP(494).EQ.0.OR.KEEP(487).NE.1) THEN
-               CALL MUMPS_AB_FREE_LMAT(LMAT_BLOCK)
+               CALL MUMPS_AB_FREE_LMAT(LMAT_BLOCK, KEEP(147))
                LMAT_BLOCK_AVAIL_I = 0
              ELSE
                LMAT_BLOCK_AVAIL_I = 1
@@ -801,7 +838,7 @@ C             Build GCOMP, the centraliz
      &             LUMAT, LUMAT_AVAIL, GCOMP_DIST, READY_FOR_ANA_F)
             ENDIF
             IF (LUMAT_AVAIL.AND.KEEP(487).NE.1) THEN
-               CALL MUMPS_AB_FREE_LMAT(LUMAT)
+               CALL MUMPS_AB_FREE_LMAT(LUMAT, KEEP(147))
                LUMAT_AVAIL = .FALSE.
             ENDIF
 C        
@@ -839,6 +876,8 @@ C     Collect on the host -- if matrix i
 C     at analysis -- all integer information needed
 C     to perform ordering
 C     -----------------------------------------------
+C FIXME: one should test instead if GCOMP_DIST available 
+C        instead of retestinf KEEP(13) and NPROCS.NE.1
           IF (KEEP(13).NE.0) THEN
            IF (id%NPROCS.NE.1) THEN
              CALL MUMPS_AB_GATHER_GRAPH(
@@ -914,14 +953,15 @@ C                Maximum transversal is
 C                entry format
 C              UNS_PERM that might be set to
 C              to permutation computed during Max transversal
-               ALLOCATE(id%UNS_PERM(id%N),IKEEPALLOC(3*id%N),
+               ALLOCATE(id%UNS_PERM(id%N),IKEEPALLOC(3_8*int(id%N,8)),
      &                  WORK2ALLOC(id%N), stat=IERR)
                IF (IERR.GT.0) THEN
                 INFO(1)=-7
-                INFO(2)=5*id%N
+                CALL MUMPS_SET_IERROR( 5_8 * int(id%N,8), INFO(2) )
                ELSE
                 CALL SMUMPS_ANA_O(id%N, id%KEEP8(28), KEEP(23),
-     &              id%UNS_PERM, IKEEPALLOC, id%IRN, id%JCN, id%A,
+     &              id%UNS_PERM, IKEEPALLOC, 3_8*int(id%N,8),
+     &              id%IRN, id%JCN, id%A,
      &              id%ROWSCA, id%COLSCA,
      &              WORK2ALLOC, id%KEEP, id%ICNTL, id%INFO, id%INFOG)
                 IF (allocated(WORK2ALLOC)) DEALLOCATE(WORK2ALLOC)
@@ -966,15 +1006,16 @@ C          be given to ANA_F.
      &               NFSIZPTR(NBLK), stat=IERR)
              IF (IERR.GT.0) THEN
               INFO(1)=-7
-              INFO(2)=3*NBLK
+              CALL MUMPS_SET_IERROR(int(NBLK,8)*3_8, INFO(2))
              ENDIF
            ELSE
-             ALLOCATE(IKEEPALLOC(NBLK+2*id%N), 
+             ALLOCATE(IKEEPALLOC(int(NBLK,8)+2_8*int(id%N,8)), 
      &               FILS_TMP(NBLK), FREREPTR(NBLK),
      &               NFSIZPTR(NBLK), stat=IERR)
             IF (IERR.GT.0) THEN
              INFO(1)=-7
-             INFO(2)=4*NBLK+2*id%N
+             CALL MUMPS_SET_IERROR(int(NBLK,8)*4_8+2_8*int(id%N,8),
+     &            INFO(2))
             ENDIF
            ENDIF
          ENDIF
@@ -1038,19 +1079,20 @@ C
 C                 we suppress supervariable detection when Schur
 C                 is active or when METIS is applied
 C                 Workspaces for FLAG(N), and either LEN(N) or some pointers(N+1)
-                  LIW_ELT = id%N + id%N + 1
+                  LIW8_ELT = int(id%N,8) + int(id%N,8) + 1_8
                ELSE
 C                 Spaces FLAG(N), LEN(N), N+3, SVAR(0:N),
-                  LIW_ELT =  id%N + id%N + id%N + 3 + id%N + 1
+                  LIW8_ELT =  int(id%N,8) + int(id%N,8) +
+     &                       int(id%N,8)+3_8 + int(id%N,8)+1_8
                ENDIF
 C     
             ENDIF
 C           We must ensure that an array of order
 C           3*N is available for SMUMPS_ANA_LNEW
             IF (KEEP(55) .EQ. 0) THEN
-              IF (LIW8.LT.3_8*int(NBLK,8)) LIW8 = 3_8*int(NBLK,8)
+              IF (LIW8.LT.3_8*int(NBLK,8)) LIW8=3_8*int(NBLK,8)
             ELSE
-              IF (LIW_ELT.LT.3*id%N) LIW_ELT = 3*id%N
+              IF (LIW8_ELT.LT.3_8*int(id%N,8)) LIW8_ELT=3_8*int(id%N,8)
             ENDIF
 C
             IF ( KEEP(256) .EQ. 1 ) THEN
@@ -1058,7 +1100,7 @@ C            It has been checked that id
 C            values of pivot order will be checked later and
 C            should be checked here too
 C            PERM_IN( I ) = position of I in the pivot order
-             IKEEP2 => IKEEPALLOC(NBLK+1:NBLK+id%N)
+             IKEEP2 => IKEEPALLOC(int(NBLK+1,8):int(NBLK,8)+int(id%N,8))
 C            Build inverse permutation and check PERM_IN 
              DO I = 1, id%N
                 IKEEP2(I) = 0
@@ -1100,6 +1142,11 @@ C             IKEEP2 holds inverse permu
                   I       = IKEEP2(IPOS)
                   IB      = DOF2BLOCK(I)
                   IF (IB.NE.IBcurrent) THEN
+                   IF (PROKG) THEN
+                    WRITE(MPG,'(A,A)') 
+     &               " ERROR: given permutation (ICNTL(7)=1)",
+     &               " incompatible with block format"
+                   ENDIF
                    INFO(1)= -4
                    INFO(2)= I
                    GOTO 10
@@ -1111,6 +1158,11 @@ C             IKEEP2 holds inverse permu
 C             IF PERM_IN is correct then
 C             on exit last position should be NBLK
               IF (IPOSB.NE.NBLK) THEN
+                   IF (PROKG) THEN
+                    WRITE(MPG,'(A,A)') 
+     &               " ERROR: given permutation (ICNTL(7)=1)",
+     &               " incompatible with block format"
+                   ENDIF
                    INFO(1)= -4
 C                  N+1 to indicate "global" error
                    INFO(2)= id%N+1
@@ -1129,8 +1181,10 @@ C           Initialize structural symmet
             INFOG(8) = -1
             IF (KEEP(55) .EQ. 0) THEN
                IKEEP1 => IKEEPALLOC(1:NBLK)
-               IKEEP2 => IKEEPALLOC(NBLK+1:NBLK+id%N)
-               IKEEP3 => IKEEPALLOC(NBLK+id%N+1:NBLK+2*id%N)
+               IKEEP2 => IKEEPALLOC(int(NBLK+1,8):
+     &                              int(NBLK,8)+int(id%N,8))
+               IKEEP3 => IKEEPALLOC(int(NBLK,8)+int(id%N+1,8):
+     &                              int(NBLK,8)+2_8*int(id%N,8))
 C              id%UNS_PERM corresponds to argument PIV
 C              in SMUMPS_ANA_F, it should be an assumed-shape
 C              array rather than a possibly null pointer:
@@ -1144,7 +1198,8 @@ C              array rather than a possi
      &              id%IRN, id%JCN,
      &              LIW8, IKEEP1, IKEEP2, IKEEP3,
      &              KEEP(256), NFSIZPTR,
-     &              FILS_TMP, FREREPTR,
+     &              FILS_TMP,
+     &              FREREPTR,
      &              id%LISTVAR_SCHUR, SIZE_SCHUR_PASSED,
      &              id%ICNTL, id%INFOG, id%KEEP,id%KEEP8,id%NSLAVES, 
      &              UNS_PERM_PTR,
@@ -1204,7 +1259,7 @@ C     -- internal error
                   GOTO 10
                ENDIF
                CALL SMUMPS_ANA_F_ELT(id%N, NELT,
-     &              id%ELTPTR(1), id%ELTVAR(1), LIW_ELT,
+     &              id%ELTPTR(1), id%ELTVAR(1), LIW8_ELT,
      &              IKEEPALLOC(1),
      &              KEEP(256), NFSIZPTR(1), FILS_TMP(1),
      &              FREREPTR(1), id%LISTVAR_SCHUR(1),
@@ -1238,9 +1293,9 @@ C           ----------------------------
             INFO(2)=INFOG(2)
 C           save statistics in KEEP array.
             KEEP(28) = INFOG(6)
-            IKEEP = 1
-            NA      = IKEEP +     id%N
-            NE      = IKEEP + 2 * id%N
+            IKEEP = 1_8
+            NA      = IKEEP +       int(id%N,8)
+            NE      = IKEEP + 2_8 * int(id%N,8)
 C       -- if (id%myid.eq.master)
         ENDIF
 C       -- if sequential analysis
@@ -1302,24 +1357,34 @@ C{    Parallel analysis
 C             KEEPALLOC reuse later 
 C             FIXME allocate of size 2*NBLK and 
 C                   allocate of size 3*id%N after call ana_aux_par
-              SIZEIKEEPALLOC = 3*id%N
+              SIZEIKEEPALLOC = 3_8*int(id%N,8)
+              SIZEWORK2ALLOC = max(4_8*int(NBLK,8), int(id%NPROCS+1,8))
             ALLOCATE( IKEEPALLOC(SIZEIKEEPALLOC), 
-     &                WORK2ALLOC(max(4*NBLK,id%NPROCS+1)), 
+     &                WORK2ALLOC(SIZEWORK2ALLOC),
      &                FILS_TMP(NBLK), FREREPTR(NBLK), NFSIZPTR(NBLK),
      &      stat=IERR)
          ELSE IF (COMM_PARASYMB.NE.MPI_COMM_NULL) THEN
 C           Allocate only on procs concerned by parallel analysis
-            ALLOCATE(IKEEPALLOC(3*NBLK),WORK2ALLOC(4*NBLK), stat=IERR )
+            SIZEIKEEPALLOC = 3_8*int(NBLK,8)
+            SIZEWORK2ALLOC = 4_8*int(NBLK,8)
+            ALLOCATE(IKEEPALLOC(SIZEIKEEPALLOC),
+     &               WORK2ALLOC(SIZEWORK2ALLOC), stat=IERR )
          ELSE
 C           Not concerned by SMUMPS_ANA_F_PAR
             IERR = 0
+            SIZEIKEEPALLOC = 0_8
+            SIZEWORK2ALLOC = 0_8
          ENDIF
          IF (IERR.GT.0) THEN
            INFO(1) = -7
            IF (id%MYID .EQ. MASTER) THEN
-             INFO( 2 ) = SIZEIKEEPALLOC+7*NBLK
+             CALL MUMPS_SET_IERROR(
+     &            SIZEIKEEPALLOC+SIZEWORK2ALLOC+3_8*int(NBLK,8),
+     &            INFO(2) )
            ELSE
-             INFO( 2 ) = 7*NBLK
+             CALL MUMPS_SET_IERROR(
+     &            SIZEIKEEPALLOC+SIZEWORK2ALLOC,
+     &            INFO(2) )
            ENDIF
          ENDIF
          CALL MUMPS_PROPINFO( ICNTL(1), INFO(1), id%COMM, id%MYID )
@@ -1327,6 +1392,16 @@ C           Not concerned by SMUMPS_ANA_
 C        save value provided by user
          idNBLKSAVE= id%NBLK
 C
+#if defined(MUMPS_NOF2003)
+C        Allocatable not allowed in SMUMPS_ANA_F_PAR,
+C        use a pointer instead. FILS_TMP is typically
+C        allocated only on MPI rank 0.
+         IF (allocated(FILS_TMP)) THEN
+           FILS_TMPPTR => FILS_TMP
+         ELSE
+           FILS_TMPPTR => IDUMMY_ARRAY
+         ENDIF
+#endif
          IF (LUMAT_AVAIL) THEN
 C{
 C             
@@ -1336,18 +1411,24 @@ C
             CALL SMUMPS_ANA_F_PAR(id,
      &        IKEEPALLOC,
      &        WORK2ALLOC,
+     &        SIZEIKEEPALLOC,
+     &        SIZEWORK2ALLOC,
      &        NFSIZPTR,
+#if defined(MUMPS_NOF2003)
+     &        FILS_TMPPTR,
+#else
      &        FILS_TMP,
+#endif
      &        FREREPTR,
      &        COMM_PARASYMB
-!    optionnal:
+!    optional:
      &        , LUMAT, SIZEOFBLOCKS
      &        , COMM_PARAORD, NPROCS_PARAORD
      &        , RKinSYMB_PROC0ORD
      & )
            ENDIF
            IF (KEEP(494).EQ.0.OR.KEEP(487).NE.1) THEN
-            CALL MUMPS_AB_FREE_LMAT(LUMAT)
+            CALL MUMPS_AB_FREE_LMAT(LUMAT,KEEP(147))
             LUMAT_AVAIL = .FALSE.
            ELSE
             LUMAT_AVAIL = .TRUE.
@@ -1360,8 +1441,14 @@ C{         LUMAT not available and COMM_
            CALL SMUMPS_ANA_F_PAR(id,
      &        IKEEPALLOC,
      &        WORK2ALLOC,
+     &        SIZEIKEEPALLOC,
+     &        SIZEWORK2ALLOC,
      &        NFSIZPTR,
+#if defined(MUMPS_NOF2003)
+     &        FILS_TMPPTR,
+#else
      &        FILS_TMP,
+#endif
      &        FREREPTR,
      &        id%COMM
      & )
@@ -1392,9 +1479,9 @@ C        Check error after freeing commu
          IF ( INFO(1) < 0 ) GOTO 500
 C
          IF (id%MYID.EQ.MASTER) THEN
-           IKEEP   = 1
-           NA      = IKEEP +     id%N
-           NE      = IKEEP + 2 * id%N 
+           IKEEP   = 1_8
+           NA      = IKEEP +       int(id%N,8)
+           NE      = IKEEP + 2_8 * int(id%N,8)
          ENDIF
 C        ---------------------------------------------------------
 C        Check whether FILS_TMP, FREREPTR, NFSIZPTR
@@ -1413,7 +1500,7 @@ C              allways copied back in st
           IF (IERR.GT.0) THEN
            INFO(1) = -7
            IF (id%MYID .EQ. MASTER) THEN
-             INFO( 2 ) = 3*id%N
+             CALL MUMPS_SET_IERROR(3_8*int(id%N,8), INFO(2))
            ENDIF
          ENDIF
          CALL MUMPS_PROPINFO( ICNTL(1), INFO(1), id%COMM, id%MYID )
@@ -1530,7 +1617,7 @@ C      peak is set by default to 1 large
      &        real(id%KEEP(2))*real(id%KEEP(2))     ! cb bloc
 C     IKEEP(1:N,1) can be used as a work space since it is set
 C     to its final state by the SORT_PERM subroutine below.
-            SSARBR => IKEEPALLOC(IKEEP:IKEEP+NBLK-1)
+            SSARBR => IKEEPALLOC(IKEEP:IKEEP+int(NBLK-1,8))
 C     ======================================================
 C     Map nodes and assign candidates for dynamic scheduling
 C     ======================================================
@@ -1864,15 +1951,15 @@ C     (the two useful informations for f
          IF (NBLK.eq.1) THEN
             NBROOT = 1
             NBLEAF = 1
-         ELSE IF (IKEEPALLOC(NA+NBLK-1) .LT.0) THEN
+         ELSE IF (IKEEPALLOC(NA+int(NBLK-1,8)) .LT.0) THEN
             NBLEAF= NBLK
             NBROOT= NBLK
-         ELSE IF (IKEEPALLOC(NA+NBLK-2) .LT.0) THEN
+         ELSE IF (IKEEPALLOC(NA+int(NBLK-2,8)) .LT.0) THEN
             NBLEAF = NBLK-1
-            NBROOT = IKEEPALLOC(NA+NBLK-1)
+            NBROOT = IKEEPALLOC(NA+int(NBLK-1,8))
          ELSE
-            NBLEAF = IKEEPALLOC(NA+NBLK-2)
-            NBROOT = IKEEPALLOC(NA+NBLK-1)
+            NBLEAF = IKEEPALLOC(NA+int(NBLK-2,8))
+            NBROOT = IKEEPALLOC(NA+int(NBLK-1,8))
          ENDIF
          id%LNA = 2+NBLEAF+NBROOT
       ENDIF
@@ -1897,26 +1984,26 @@ C        Initialize NA with the leaves a
          IF ( NBLK == 1 ) THEN
             id%NA(LEAF) = 1
             LEAF = LEAF + 1
-         ELSE IF (IKEEPALLOC(NA+NBLK-1) < 0) THEN
-            id%NA(LEAF) = - IKEEPALLOC(NA+NBLK-1)-1
+         ELSE IF (IKEEPALLOC(NA+int(NBLK-1,8)) < 0) THEN
+            id%NA(LEAF) = - IKEEPALLOC(NA+int(NBLK-1,8))-1
             LEAF = LEAF + 1
             DO I = 1, NBLEAF - 1
-               id%NA(LEAF) = IKEEPALLOC(NA+I-1)
+               id%NA(LEAF) = IKEEPALLOC(NA+int(I-1,8))
                LEAF = LEAF + 1
             ENDDO
-         ELSE IF (IKEEPALLOC(NA+NBLK-2) < 0 ) THEN
-            INODE = - IKEEPALLOC(NA+NBLK-2) - 1
+         ELSE IF (IKEEPALLOC(NA+int(NBLK-2,8)) < 0 ) THEN
+            INODE = - IKEEPALLOC(NA+int(NBLK-2,8)) - 1
             id%NA(LEAF) = INODE
             LEAF =LEAF + 1
             IF ( NBLEAF > 1 ) THEN
                DO I = 1, NBLEAF - 1
-                  id%NA(LEAF) = IKEEPALLOC(NA+I-1)
+                  id%NA(LEAF) = IKEEPALLOC(NA+int(I-1,8))
                   LEAF = LEAF + 1
                ENDDO
             ENDIF
          ELSE
             DO I = 1, NBLEAF
-               id%NA(LEAF) = IKEEPALLOC(NA+I-1)
+               id%NA(LEAF) = IKEEPALLOC(NA+int(I-1,8))
                LEAF = LEAF + 1
             ENDDO
          END IF
@@ -1963,8 +2050,8 @@ C        copies to NSTEP array should be
             IF (FREREPTR(I) .NE. NBLK+1) THEN
                id%PROCNODE_STEPS(STEP_TMP(I)) = PROCNODE( I )
                id%FRERE_STEPS(STEP_TMP(I))    = FREREPTR(I)
-               id%NE_STEPS(STEP_TMP(I))    = IKEEPALLOC(NE+I-1)
-               id%ND_STEPS(STEP_TMP(I))    = NFSIZPTR(I)
+               id%NE_STEPS(STEP_TMP(I)) = IKEEPALLOC(NE+int(I-1,8))
+               id%ND_STEPS(STEP_TMP(I)) = NFSIZPTR(I)
             ENDIF
          ENDDO
 C        ===============================
@@ -2039,6 +2126,7 @@ C         Broadcast errors
 C
           CALL MUMPS_INIALIZE_REDIST_LUMAT ( 
      &     id%INFO, id%ICNTL, id%KEEP, id%COMM, id%MYID, NBLK,
+     &     id%NPROCS,
      &     LUMAT, id%PROCNODE_STEPS(1), id%KEEP(28), MAPCOL, 
      &     LUMAT_REMAP, NBRECORDS, STEP_TMP(1))
 C         INFO(1) has been broadcasted already in routine
@@ -2053,7 +2141,7 @@ C         -- Redistribute LUMAT into LU_
      &      LUMAT_REMAP, NBRECORDS, NSEND8, NLOCAL8
      &     )
            LUMAT_REMAP_DIST_AVAIL = .TRUE.
-          CALL MUMPS_AB_FREE_LMAT(LUMAT)
+          CALL MUMPS_AB_FREE_LMAT(LUMAT,KEEP(147))
 C         Distribute SIZEOFBLOCKS that was defined only on master
           CALL MPI_BCAST( SIZEOFBLOCKS, NBLK, MPI_INTEGER, MASTER, 
      &     id%COMM, IERR )
@@ -2062,12 +2150,14 @@ C}
 C{        Centralized matrix and clean LMAT_BLOCK available
 C        
           IF (id%MYID.EQ.MASTER) THEN
+C
            CALL MUMPS_AB_CLEANLMAT_TO_LUMAT ( 
-     &              LMAT_BLOCK, LUMAT_REMAP,
+     &              LMAT_BLOCK, LUMAT_REMAP, KEEP(147),
      &              INFO(1), ICNTL(1))
            LUMAT_REMAP_CENT_AVAIL=.TRUE.
 C            --- LMAT_BLOCK not needed anymore
-           CALL MUMPS_AB_FREE_LMAT(LMAT_BLOCK)
+           CALL MUMPS_AB_FREE_LMAT(LMAT_BLOCK,KEEP(147))
+C
           ENDIF
 C         Broadcast errors
           CALL MUMPS_PROPINFO( ICNTL(1), INFO(1),
@@ -2170,6 +2260,8 @@ C         Broadcast errors
           CALL MUMPS_PROPINFO( ICNTL(1), INFO(1),
      &      id%COMM, id%MYID )
           IF ( INFO(1).LT.0 ) GOTO 500
+          CALL MPI_BCAST( id%ND_STEPS(1), KEEP(28), MPI_INTEGER,
+     &    MASTER, id%COMM, IERR )
           CALL SMUMPS_AB_LR_MPI_GROUPING(NBLK, 
      &           MAPCOL, id%KEEP(28), 
      &           id%KEEP(28), LUMAT_REMAP, FILS_TMP(1), 
@@ -2182,7 +2274,8 @@ C         Broadcast errors
      &           id%KEEP(264), id%KEEP(265), id%KEEP(482), id%KEEP(472),
      &           id%KEEP(127), id%KEEP(469), id%KEEP(10), 
      &           id%KEEP(54), id%KEEP(142), 
-     &           LPOK, LP, id%COMM, id%MYID, id%NPROCS)
+     &           LPOK, LP, id%COMM, id%MYID, id%NPROCS,
+     &           id%KEEP(1), id%ND_STEPS)
           IF (allocated(MAPCOL)) DEALLOCATE(MAPCOL)
           IF (id%MYID.NE.MASTER) DEALLOCATE(FILS_TMP)
 C}
@@ -2204,7 +2297,8 @@ C
      &           id%KEEP(264), id%KEEP(265), id%KEEP(482), id%KEEP(472),
      &           id%KEEP(127), id%KEEP(469), id%KEEP(10), 
      &           id%KEEP(54), id%KEEP(142), 
-     &           LPOK, LP, id%COMM, id%MYID, id%NPROCS)
+     &           LPOK, LP, id%COMM, id%MYID, id%NPROCS,
+     &           id%KEEP(1), id%ND_STEPS)
 C}
             ELSE
 C{           grouping based on centralized matrix
@@ -2221,7 +2315,8 @@ C{           grouping based on centraliz
      &           id%KEEP(264), id%KEEP(265), id%KEEP(482), id%KEEP(472),
      &           id%KEEP(127), id%KEEP(10), 
      &           id%KEEP(54), id%KEEP(142), 
-     &           LPOK, LP, GATHER_MATRIX_ALLOCATED)
+     &           LPOK, LP, GATHER_MATRIX_ALLOCATED, 
+     &           id%KEEP(1), id%ND_STEPS)
              ELSE
                CALL SMUMPS_LR_GROUPING_NEW(id%N, id%KEEP8(28), 
      &           id%KEEP(28), id%IRN,
@@ -2234,7 +2329,8 @@ C{           grouping based on centraliz
      &           id%KEEP(264), id%KEEP(265), id%KEEP(482), id%KEEP(472),
      &           id%KEEP(127), id%KEEP(469), id%KEEP(10), 
      &           id%KEEP(54), id%KEEP(142), 
-     &           LPOK, LP, GATHER_MATRIX_ALLOCATED)
+     &           LPOK, LP, GATHER_MATRIX_ALLOCATED,
+     &           id%KEEP(1), id%ND_STEPS)
              ENDIF
 C}
             ENDIF
@@ -2251,7 +2347,7 @@ C     III/ CLEANUP
 C     ============
 C       Free LUMAT_REMAP if allocated
         IF (LUMAT_REMAP_DIST_AVAIL.OR.LUMAT_REMAP_CENT_AVAIL)
-     &      CALL MUMPS_AB_FREE_LMAT(LUMAT_REMAP)
+     &      CALL MUMPS_AB_FREE_LMAT(LUMAT_REMAP,KEEP(147))
         IF (allocated(MAPCOL)) DEALLOCATE(MAPCOL)
         IF (allocated(SIZEOFBLOCKS)) DEALLOCATE(SIZEOFBLOCKS)
         IF ( (KEEP(54).EQ.3) .AND. (KEEP(244).EQ.2).AND.
@@ -2343,7 +2439,7 @@ C           and update arrays of size NS
      &           ) 
             NULLIFY(PAR2_NODESPTR)
 C
-C
+C         }
           ELSE
 C{           NBLK=N
 C            perform local copies
@@ -2376,6 +2472,17 @@ C          and not used/initialized
           ENDIF
 C}
         ENDIF
+C
+C       -------------------------------------------
+C       Adjust LR_GROUPING to bound size of groups 
+C       and update KEEP(142): maximum group size
+C       -------------------------------------------
+        IF (id%N.GT.NBLK.AND.KEEP(494).NE.0) THEN
+          CALL MUMPS_ADJUST_SIZE_LRGROUPS ( 
+     &     id%STEP(1), id%FILS(1), id%N, 
+     &     id%ND_STEPS(1), id%KEEP(28), id%KEEP(1), 
+     &     id%LRGROUPS(1), INFO(1), INFO(2))
+         ENDIF
 C}
       ENDIF
 C
@@ -2385,6 +2492,7 @@ C
       IF (allocated(LRGROUPS_TMP)) DEALLOCATE(LRGROUPS_TMP)
       IF (allocated(FILS_TMP)) DEALLOCATE(FILS_TMP)
 C
+C
         CALL MUMPS_REALLOC(id%SYM_PERM, id%N, id%INFO, LP, 
      &  FORCE=.TRUE.,
      &  STRING='id%SYM_PERM (Analysis)', ERRCODE=-7)
@@ -3245,11 +3353,11 @@ C           and allocate CANDIDATES
 C           ===================================================
 C     
             IF ( id%root%yes ) THEN
-              LOCAL_M = numroc( id%ND_STEPS(id%STEP(KEEP(38))),
+              LOCAL_M = MUMPS_NUMROC( id%ND_STEPS(id%STEP(KEEP(38))),
      &              id%root%MBLOCK, id%root%MYROW, 0,
      &              id%root%NPROW )
               LOCAL_M = max(1, LOCAL_M)
-              LOCAL_N = numroc( id%ND_STEPS(id%STEP(KEEP(38))),
+              LOCAL_N = MUMPS_NUMROC( id%ND_STEPS(id%STEP(KEEP(38))),
      &              id%root%NBLOCK, id%root%MYCOL, 0,
      &              id%root%NPCOL )
             ELSE
@@ -3627,7 +3735,7 @@ C            Note that RECV buffer shoul
 C            to both PEAK_UNDER_L0 and PEAK_ABOVE_L0
              PEAK_UNDER_L0 = SUM_NRLNEC + MIN_NRLNEC + 
      &        int(
-     &        (REAL(id%N*KEEP(400))*REAL(KEEP(34)))/REAL(KEEP(35)),
+     &        (real(id%N*KEEP(400))*real(KEEP(34)))/real(KEEP(35)),
      &               8)
 C            Estimate send buffer size 
 C            and convert it in nb of reals
@@ -3636,12 +3744,10 @@ C
 C            Convert SUM_NIRNEC SUM_NIRNEC_OOC into nb of reals 
              PEAK_ABOVE_L0 =  KEEP8(53)+ SUM_NRLADU + 
      &            ! SEND buffer
-     &              max ( int( 
-     &              (REAL(SBUF_SEND_FR)*REAL(KEEP(34)))/REAL(KEEP(35))
-     &                     , 8), 100000_8 ) +
+     &            max( int(SBUF_SEND_FR,8),  100000_8) +
      &            ! MAXIS_above :
      &             int( 
-     &              (REAL(KEEP(15))*REAL(KEEP(34)))/REAL(KEEP(35)),
+     &              (real(KEEP(15))*real(KEEP(34)))/real(KEEP(35)),
      &               8)
 C            ===============================================
 C            Update memory peaks:
@@ -3672,7 +3778,7 @@ C            SUM_NIRNEC_OOC under L0 OMP
 C           DKEEP(15) is used for dynamic load balancing only
 C           it corresponds to the number of local operations
 C           (in Millions)
-            id%DKEEP(15)    = RINFO(1)/1000000.0
+            id%DKEEP(15)    = RINFO(1)/1000000.0E0
             IF(ASSOCIATED(locI_AM_CAND)) NULLIFY(locI_AM_CAND)
             id%MAX_SURF_MASTER = KEEP8(15)
 C
@@ -3737,7 +3843,10 @@ C
          UPDATE_BUFFER = .TRUE.
 C
          MIN_BUF_SIZE8 = KEEP8(22) / int(KEEP(238),8)
-         MIN_BUF_SIZE8 = min(MIN_BUF_SIZE8,int(huge(I4),8))
+C        MIN_BUF_SIZE8 is in number of entries of size (KEEP(35) bytes)
+C        and max buffer size in bytes is an integer*4
+         MIN_BUF_SIZE8 = min(MIN_BUF_SIZE8,
+     &                       int(huge(I4),8)/int(KEEP(35),8) )
          MIN_BUF_SIZE  = int( MIN_BUF_SIZE8 )
          IF (UPDATE_BUFFER) THEN
 C          Send buffer 
@@ -3893,7 +4002,7 @@ C     Per compute node factor real space
       CALL MPI_REDUCE( SUM_KEEP811_THIS_NODE, MAX_SUM_KEEP811_THIS_NODE,
      &                 1, MPI_INTEGER8, MPI_MAX, 0, id%COMM, IERR )
       IF (PROKG .AND. PRINT_NODEINFO) THEN
-        WRITE(MPG,'(A,I12)')
+        WRITE(MPG,'(A,I16)')
      &  '    Max. estimated space for factors per compute node       :',
      &  MAX_SUM_KEEP811_THIS_NODE ! * KEEP(35)/1000000_8
       ENDIF
@@ -3956,7 +4065,7 @@ C
            TOTAL_BYTES  = max (TOTAL_BYTES, TOTAL_BYTES_UNDER_L0)
          ENDIF
          IF ( PROK ) THEN
-            WRITE(MP,'(A,I12) ')
+            WRITE(MP,'(A,I16) ')
      & ' Estimated space in MBytes for IC factorization   (INFO(15)):',
      &           TOTAL_MBYTES
          END IF
@@ -3974,11 +4083,11 @@ C
      &     id%INFO(15), id%INFOG(16), IRANK )
       IF ( PROKG ) THEN
        IF (PRINT_MAXAVG) THEN
-         WRITE( MPG,'(A,I12) ')
+         WRITE( MPG,'(A,I16) ')
      & '    Maximum estim. space in Mbytes, IC facto.    (INFOG(16)):',
      &        id%INFOG(16)
        ENDIF
-       WRITE(MPG,'(A,I12) ')
+       WRITE(MPG,'(A,I16) ')
      & '    Total space in MBytes, IC factorization      (INFOG(17)):'
      &        ,id%INFOG(17)
       END IF
@@ -3989,7 +4098,7 @@ C     Per compute node memory informatio
       CALL MPI_REDUCE( SUM_INFO15_THIS_NODE, MAX_SUM_INFO15_THIS_NODE,
      &                 1, MPI_INTEGER, MPI_MAX, 0, id%COMM, IERR )
       IF ( PROKG .AND. PRINT_NODEINFO ) THEN
-        WRITE(MPG,'(A,I12)')
+        WRITE(MPG,'(A,I16)')
      &  '    Max. estim. space per compute node, in MBytes, IC fact  :',
      &  MAX_SUM_INFO15_THIS_NODE
       ENDIF
@@ -4066,11 +4175,11 @@ C
      &     id%INFO(17), id%INFOG(26), IRANK )
       IF ( PROKG  ) THEN
        IF (PRINT_MAXAVG) THEN
-         WRITE( MPG,'(A,I12) ')
+         WRITE( MPG,'(A,I16) ')
      & '    Maximum estim. space in Mbytes, OOC facto.   (INFOG(26)):',
      &        id%INFOG(26)
        ENDIF
-       WRITE(MPG,'(A,I12) ')
+       WRITE(MPG,'(A,I16) ')
      & '    Total space in MBytes,  OOC factorization    (INFOG(27)):'
      &        ,id%INFOG(27)
       END IF
@@ -4080,7 +4189,7 @@ C
       CALL MPI_REDUCE( SUM_INFO17_THIS_NODE, MAX_SUM_INFO17_THIS_NODE,
      &                 1, MPI_INTEGER, MPI_MAX, 0, id%COMM, IERR )
       IF (PROKG .AND. PRINT_NODEINFO) THEN
-        WRITE(MPG,'(A,I12)')
+        WRITE(MPG,'(A,I16)')
      &  '    Max. estim. space per compute node, in MBytes, OOC fact :',
      &  MAX_SUM_INFO17_THIS_NODE
       ENDIF
@@ -4181,9 +4290,9 @@ C     Deallocate allocated working space
       IF (allocated(FLAGGED_LEAVES)) DEALLOCATE(FLAGGED_LEAVES)
       IF (allocated(SIZEOFBLOCKS)) DEALLOCATE(SIZEOFBLOCKS)
       IF (allocated(DOF2BLOCK)) DEALLOCATE(DOF2BLOCK)
-      CALL MUMPS_AB_FREE_LMAT(LMAT_BLOCK)
-      CALL MUMPS_AB_FREE_LMAT(LUMAT)
-      CALL MUMPS_AB_FREE_LMAT(LUMAT_REMAP)
+      CALL MUMPS_AB_FREE_LMAT(LMAT_BLOCK,KEEP(147))
+      CALL MUMPS_AB_FREE_LMAT(LUMAT,KEEP(147))
+      CALL MUMPS_AB_FREE_LMAT(LUMAT_REMAP,KEEP(147))
       CALL MUMPS_AB_FREE_GCOMP(GCOMP, MEMCNT)
       CALL MUMPS_AB_FREE_GCOMP(GCOMP_DIST, MEMCNT)
       IF (INFO(1) .LT. 0) THEN
@@ -4266,7 +4375,11 @@ C     to stat that are incremented such
 C     the number of split nodes:
       id%KEEP(61)=0
       IF (id%MYID.eq.MASTER) THEN
+        id%KEEP(38) = 0 
+        id%KEEP(20) = 0 
+        id%KEEP(401) = 0
         id%KEEP(400) = 0
+        IF (id%ICNTL(48).EQ.1) id%KEEP(401)=1
         IF (id%KEEP(401) .GT. 0) THEN
 !$        id%KEEP(400)=omp_get_max_threads()
           IF ( id%KEEP(400) .EQ. 0 ) THEN
@@ -4274,14 +4387,14 @@ C           Compilation without OMP!
             id%INFO(1)=-58
             id%INFO(2)=0
             IF (LPOK) WRITE(LP,'(A)')
-     &      " FAILURE DETECTED IN ANALYSIS: KEEP(401) requires OpenMP"
+     &      " FAILURE DETECTED IN ANALYSIS: ICNTL(48) requires OpenMP"
             RETURN
           ELSE
-            IF ( PROKG ) THEN
-              WRITE(MPG, '(A,I8,A)')
-     &       'KEEP(401) config at analysis:', id%KEEP(400),
-     &       ' threads expected for multithreaded tree parallelism'
-            END IF
+C            IF ( PROKG ) THEN
+C              WRITE(MPG, '(A,I8,A)')
+C     &       'ICNTL(48) config at analysis:', id%KEEP(400),
+C     &       ' threads expected for multithreaded tree parallelism'
+C            END IF
 C           L0OMP feature is on (possibly with a single thread!)
             IF (id%KEEP(400).EQ.1
      &       ) THEN
@@ -4846,7 +4959,18 @@ C     Save ICNTL(56) (QR) in KEEP(53)
 C     Will be broadcasted to all other
 C     nodes in routine SMUMPS_BDCAST
 C     --------------------------------
-         id%KEEP(53)=0
+         id%KEEP(53) = id%ICNTL(56)
+C     ---------------------------
+C     Possible values are 0..2 
+C     Other values are treated as 0
+C     ------------------------------
+         IF ( id%KEEP(53) .LT. 0 .OR.
+     &        id%KEEP(53) .GE. 2 
+     &      ) THEN
+            id%KEEP(53) = 0
+            IF (PROKG) WRITE(MPG,'(A)')
+     &    ' WARNING: ICNTL(56) treated as if set to 0 '
+         END IF
          IF(id%KEEP(86).EQ.1)THEN
 C     Force the exchange of both the memory and flops information during 
 C     the factorization
@@ -5430,11 +5554,16 @@ C
       INTEGER, TARGET                :: IRN_DUMMY(1), JCN_DUMMY(1)
       INTEGER, POINTER, DIMENSION(:) :: IRN_PASSED, JCN_PASSED
       REAL, POINTER, DIMENSION(:) :: A_PASSED
+      INTEGER              :: MPG
+      LOGICAL              :: PROKG
       PARAMETER( MASTER = 0 )
       I_AM_SLAVE = ( id%MYID .NE. MASTER  .OR.
      &     ( id%MYID .EQ. MASTER .AND.
      &     id%KEEP(46) .EQ. 1 ) )
       I_AM_MASTER = (id%MYID.EQ.MASTER)
+      MPG = id%ICNTL( 3 )
+      PROKG = ( MPG .GT. 0 .and. id%MYID .eq. MASTER )
+      PROKG = (PROKG.AND.(id%ICNTL(4).GE.2))
       NAME_INITIALIZED = id%WRITE_PROBLEM(1:20)
      &     .NE. "NAME_NOT_INITIALIZED"
       BINARY_FORMAT = .FALSE.
@@ -5450,6 +5579,11 @@ C
           BINARY_FORMAT = .TRUE.
         ENDIF
       ENDIF
+      IF (NAME_INITIALIZED.AND.PROKG) THEN
+        WRITE(MPG,'(/A,A/)') 
+     &    " Write input matrix to file, WRITE_PROBLEM= ", 
+     &    id%WRITE_PROBLEM(1:L)
+      ENDIF
 C     Check if RHS should also be dumped
       DUMP_RHS = id%MYID.EQ.MASTER .AND.
      &     associated(id%RHS) .AND. NAME_INITIALIZED
@@ -5740,14 +5874,14 @@ C     then describe binary file content
      &  '%    N,IRN(i),JCN(i): 32 bits',
      &  '%    NNZ: 64 bits'
       ENDIF
-      WRITE(IUNIT,FMT='(A,I12)') '% Matrix order: N=',N
-      WRITE(IUNIT,FMT='(A,I12)') '% Matrix nonzeros: NNZ=',NNZTOT
+      WRITE(IUNIT,FMT='(A,I16)') '% Matrix order: N=',N
+      WRITE(IUNIT,FMT='(A,I16)') '% Matrix nonzeros: NNZ=',NNZTOT
       IF (DUMP_RHS) THEN
         WRITE(IUNIT,FMT='(A)') '%'
         WRITE(IUNIT,FMT='(A,/,A,I10,A,I5)')
      &  '% A RHS was also written to disk by columns in binary form.',
      &  '%    Size: N rows x NRHS columns with N=',N,'  NRHS=',NRHS
-        WRITE(IUNIT,FMT='(A,I12,A)')
+        WRITE(IUNIT,FMT='(A,I16,A)')
      &  '%    Total:',int(N,8)*int(NRHS,8),' scalar values.'
         WRITE(IUNIT,'(A)') '%    Single precision storage'
       ENDIF
diff -pruN 5.6.2-2.1/src/sana_lr.F 5.7.1-1/src/sana_lr.F
--- 5.6.2-2.1/src/sana_lr.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/sana_lr.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -65,10 +65,12 @@ C
       ENDIF 
       if(allocated(BIG_CUT)) DEALLOCATE(BIG_CUT)
       END SUBROUTINE GET_CUT
-      SUBROUTINE SEP_GROUPING(NV, VLIST, N, NZ, LRGROUPS, NBGROUPS, IW, 
+      SUBROUTINE SEP_GROUPING( NFRONT, KEEP,
+     &   NV, VLIST, N, NZ, LRGROUPS, NBGROUPS, IW, 
      &   LW, IPE, LEN, GROUP_SIZE, HALO_DEPTH, TRACE, WORKH, NODE,
      &   GEN2HALO, K482, K472, K469, SEP_SIZE, MAXSIZE_PARTS,
      &   KEEP10, LP, LPOK, IFLAG, IERROR)
+        INTEGER, INTENT(IN)    :: NFRONT, KEEP(500)
         INTEGER(8), INTENT(IN) :: NZ, LW
         INTEGER, INTENT(IN)    :: NV, N, GROUP_SIZE, HALO_DEPTH
         INTEGER, INTENT(IN)    :: IW(LW), LEN(N), NODE, K482
@@ -84,7 +86,7 @@ C
         INTEGER(8), ALLOCATABLE, DIMENSION(:) :: IPTRHALO
         INTEGER,    ALLOCATABLE, DIMENSION(:) :: PARTS, JCNHALO
         INTEGER(8) :: HALOEDGENBR
-        INTEGER    :: NHALO,
+        INTEGER    :: NHALO, NBG_CAPT,
      &       NBGROUPS_KWAY, I, GROUP_SIZE2, LRGROUPS_SIGN, IERR
         INTEGER    :: MAXSIZE_PARTS_LOC
 #if defined (metis) || defined (parmetis) || defined (metis4) || defined (parmetis3)
@@ -93,7 +95,8 @@ C
 #if defined (scotch) || defined (ptscotch)
         INTEGER :: SCOTCH_IDX_SIZE
 #endif
-        CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NV)
+        CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NV, 
+     &                       NFRONT, KEEP(35))
         NBGROUPS_KWAY = MAX(
      &                INT(real(NV+GROUP_SIZE2-1)/real(GROUP_SIZE2))
      &                ,1)
@@ -187,7 +190,7 @@ C
                WRITE(LP,*) " Internal error in SCOTCH during ",
      &                     " Kway partitioning, SCOTCHFGRAPHPART, " 
                WRITE(LP,*) 
-     &         " also provide METIS package to MUMPS "
+     &         " please also provide METIS package to MUMPS "
              ENDIF
 #endif
           ELSE
@@ -197,16 +200,17 @@ C
           IF (IFLAG.LT.0) GOTO 500
           CALL GET_GLOBAL_GROUPS(PARTS, VLIST, NV, 
      &     NBGROUPS_KWAY, LRGROUPS, N, NBGROUPS, LRGROUPS_SIGN,
-     &     MAXSIZE_PARTS_LOC)
+     &     MAXSIZE_PARTS_LOC, .FALSE., GROUP_SIZE2)
            MAXSIZE_PARTS = max(MAXSIZE_PARTS, MAXSIZE_PARTS_LOC)
         ELSE 
           MAXSIZE_PARTS = max(MAXSIZE_PARTS,NV)
-!$OMP CRITICAL(lrgrouping_cri)
+!$OMP ATOMIC CAPTURE
+          NBG_CAPT = NBGROUPS
+          NBGROUPS = NBGROUPS + 1
+!$OMP END ATOMIC 
           DO I=1,NV
-            LRGROUPS(VLIST(I)) = LRGROUPS_SIGN*(NBGROUPS + 1)
+            LRGROUPS(VLIST(I)) = LRGROUPS_SIGN*(NBG_CAPT + 1)
           END DO
-            NBGROUPS = NBGROUPS + 1
-!$OMP END CRITICAL(lrgrouping_cri)
         END IF
   500   IF (allocated(IPTRHALO)) then
            DEALLOCATE(IPTRHALO)
@@ -219,11 +223,13 @@ C
         ENDIF
         RETURN
       END SUBROUTINE SEP_GROUPING
-      SUBROUTINE SEP_GROUPING_AB (NV, NVEXPANDED, 
+      SUBROUTINE SEP_GROUPING_AB ( NFRONT, KEEP,
+     &   NV, NVEXPANDED, 
      &   VLIST, N, LRGROUPS, NBGROUPS, LUMAT, SIZEOFBLOCKS,
      &   GROUP_SIZE, HALO_DEPTH, TRACE, WORKH, NODE,
      &   GEN2HALO, K482, K472, K469, SEP_SIZE, MAXSIZE_PARTS,
      &   KEEP10, LP, LPOK, IFLAG, IERROR)
+        INTEGER, INTENT(IN)    :: NFRONT, KEEP(500)
         TYPE(LMATRIX_T)        :: LUMAT
         INTEGER, INTENT(IN)    :: NV, NVEXPANDED, 
      &                            N, GROUP_SIZE, HALO_DEPTH
@@ -241,17 +247,20 @@ C
         INTEGER,    ALLOCATABLE, DIMENSION(:) :: PARTS, JCNHALO
         INTEGER,    ALLOCATABLE, DIMENSION(:) :: VWGT
         INTEGER(8) :: HALOEDGENBR
-        INTEGER    :: NHALO,
+        INTEGER    :: NHALO, NBG_CAPT,
      &       NBGROUPS_KWAY, I, GROUP_SIZE2, LRGROUPS_SIGN, IERR
         INTEGER    :: MAXSIZE_PARTS_LOC
         REAL       :: COMPRESS_RATIO
+        LOGICAL    :: AB_ACTIVE
 #if defined (metis) || defined (parmetis) || defined (metis4) || defined (parmetis3)
         INTEGER :: METIS_IDX_SIZE
 #endif
 #if defined (scotch) || defined (ptscotch)
         INTEGER :: SCOTCH_IDX_SIZE
 #endif
-        CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NVEXPANDED)
+       AB_ACTIVE = (NVEXPANDED.GT.NV)
+        CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NVEXPANDED,
+     &                       NFRONT, KEEP(35))
         COMPRESS_RATIO= real(NVEXPANDED)/real(NV)
         NBGROUPS_KWAY = MAX(
      &          INT(real(NVEXPANDED+GROUP_SIZE2-1)/real(GROUP_SIZE2))
@@ -365,17 +374,18 @@ C
           IF (IFLAG.LT.0) GOTO 500
           CALL GET_GLOBAL_GROUPS(PARTS,VLIST, NV, 
      &     NBGROUPS_KWAY, LRGROUPS, N, NBGROUPS, LRGROUPS_SIGN,
-     &     MAXSIZE_PARTS_LOC)
+     &     MAXSIZE_PARTS_LOC, AB_ACTIVE, GROUP_SIZE2)
            MAXSIZE_PARTS = max( MAXSIZE_PARTS, 
      &                   int(real(MAXSIZE_PARTS_LOC*COMPRESS_RATIO))  )
         ELSE 
           MAXSIZE_PARTS = max(MAXSIZE_PARTS,NV)
-!$OMP CRITICAL(lrgrouping_cri)
+!$OMP ATOMIC CAPTURE
+          NBG_CAPT = NBGROUPS
+          NBGROUPS = NBGROUPS + 1
+!$OMP END ATOMIC 
           DO I=1,NV
-            LRGROUPS(VLIST(I)) = LRGROUPS_SIGN*(NBGROUPS + 1)
+            LRGROUPS(VLIST(I)) = LRGROUPS_SIGN*(NBG_CAPT + 1)
           END DO
-            NBGROUPS = NBGROUPS + 1
-!$OMP END CRITICAL(lrgrouping_cri)
         END IF
   500   IF (allocated(IPTRHALO)) then
            DEALLOCATE(IPTRHALO)
@@ -495,9 +505,10 @@ C
       END SUBROUTINE GETHALOGRAPH_AB
       SUBROUTINE GET_GLOBAL_GROUPS(PARTS, SEP, NSEP, NPARTS, 
      &                    LRGROUPS, N, NBGROUPS, LRGROUPS_SIGN,
-     &                    MAXSIZE_PARTS_LOC)
-      INTEGER,INTENT(IN) :: NSEP, N, LRGROUPS_SIGN
+     &                    MAXSIZE_PARTS_LOC, AB_ACTIVE, GROUP_SIZE2)
+      INTEGER,INTENT(IN) :: NSEP, N, LRGROUPS_SIGN, GROUP_SIZE2
       INTEGER :: PARTS(:)
+      LOGICAL :: AB_ACTIVE
       INTEGER,DIMENSION(:),INTENT(INOUT) :: SEP 
       INTEGER, INTENT(INOUT) :: NPARTS 
       INTEGER, INTENT(INOUT) :: NBGROUPS
@@ -506,7 +517,7 @@ C
       INTRINSIC maxval
       INTEGER:: I,CNT,NB_PARTS_WITHOUT_SEP_NODE,allocok
       INTEGER:: TARGET_SIZE_KWAY
-      INTEGER:: MAXSIZE_PARTS_LOC_NEW
+      INTEGER:: MAXSIZE_PARTS_LOC_NEW, NBG_CAPT
       INTEGER,DIMENSION(:),ALLOCATABLE::SIZES, RIGHTPART
       INTEGER,DIMENSION(:),ALLOCATABLE::PARTPTR
 #if ! defined(NO_SPLIT_IN_BLRGROUPING)
@@ -522,8 +533,9 @@ C
          write(*,*) "Allocation error in GET_GLOBAL_GROUPS"
          CALL MUMPS_ABORT()
       ENDIF
-      TARGET_SIZE_KWAY  = (NSEP+NPARTS-1) / NPARTS
-      TARGET_SIZE_SPLIT = 2*TARGET_SIZE_KWAY
+      TARGET_SIZE_KWAY  = GROUP_SIZE2
+      TARGET_SIZE_SPLIT = TARGET_SIZE_KWAY
+      IF (AB_ACTIVE) TARGET_SIZE_SPLIT =huge(TARGET_SIZE_SPLIT)
       NB_PARTS_WITHOUT_SEP_NODE = 0
       RIGHTPART     = 0
       SIZES = 0
@@ -549,16 +561,17 @@ C
 #if ! defined(NO_SPLIT_IN_BLRGROUPING)
        IF (MAXSIZE_PARTS_LOC.LT.TARGET_SIZE_SPLIT) THEN
 #endif
-!$OMP    CRITICAL(lrgrouping_cri)
+!$OMP ATOMIC CAPTURE
+         NBG_CAPT = NBGROUPS
+         NBGROUPS = NBGROUPS + NPARTS
+!$OMP END ATOMIC 
          DO I=1,NSEP
           NEWSEP(PARTPTR(PARTS(I))) = SEP(I)  
           LRGROUPS(SEP(I)) = LRGROUPS_SIGN*(RIGHTPART(PARTS(I)) 
-     &      + NBGROUPS)
+     &      + NBG_CAPT)
           PARTPTR(PARTS(I)) = 
      &      PARTPTR(PARTS(I)) + 1
          END DO
-         NBGROUPS = NBGROUPS + NPARTS
-!$OMP    END CRITICAL(lrgrouping_cri)
          SEP = NEWSEP
 #if ! defined(NO_SPLIT_IN_BLRGROUPING)
       ELSE
@@ -572,9 +585,23 @@ C
          DO I=2,NPARTS+1
            PARTPTR(I) = PARTPTR(I-1) + SIZES(I-1)
          ENDDO
-         NB_PARTS_WITH_SPLIT = 0
+         NB_PARTS_WITH_SPLIT   = 0
          MAXSIZE_PARTS_LOC_NEW = 0
-!$OMP    CRITICAL(lrgrouping_cri)
+         DO IP =1, NPARTS
+           NB_SPLIT =   (SIZES(IP) + TARGET_SIZE_SPLIT-1) 
+     &                    / TARGET_SIZE_SPLIT
+           SZ_FINAL     = (SIZES(IP) + NB_SPLIT-1) / NB_SPLIT 
+           NB_PARTS_WITH_SPLIT = NB_PARTS_WITH_SPLIT +
+     &      ( 
+     &         ( (PARTPTR(IP+1) - PARTPTR(IP))+ SZ_FINAL-1 ) /
+     &          SZ_FINAL
+     &      )
+         ENDDO
+!$OMP ATOMIC CAPTURE
+         NBG_CAPT = NBGROUPS
+         NBGROUPS = NBGROUPS + NB_PARTS_WITH_SPLIT
+!$OMP END ATOMIC 
+         NB_PARTS_WITH_SPLIT = 0
          DO IP=1,NPARTS
            NB_SPLIT =   (SIZES(IP) + TARGET_SIZE_SPLIT-1) 
      &                    / TARGET_SIZE_SPLIT
@@ -585,12 +612,10 @@ C
              NB_PARTS_WITH_SPLIT = NB_PARTS_WITH_SPLIT +1
              DO II=I, min(I+SZ_FINAL-1,PARTPTR(IP+1)-1)
                LRGROUPS(SEP(II)) = LRGROUPS_SIGN*(NB_PARTS_WITH_SPLIT
-     &                           + NBGROUPS)
+     &                           + NBG_CAPT)
              ENDDO
            ENDDO
          ENDDO
-         NBGROUPS = NBGROUPS + NB_PARTS_WITH_SPLIT
-!$OMP    END CRITICAL(lrgrouping_cri)
          NPARTS = NB_PARTS_WITH_SPLIT
          MAXSIZE_PARTS_LOC = MAXSIZE_PARTS_LOC_NEW
       ENDIF
@@ -787,7 +812,8 @@ C
      &     LRGROUPS, SYM, ICNTL, HALO_DEPTH, GROUP_SIZE, SEP_SIZE,
      &     K38, K20, K60,
      &     IFLAG, IERROR, K264, K265, K482, K472, MAXFRONT, K10, 
-     &     K54, K142, LPOK, LP, GATHER_MATRIX_ALLOCATED)
+     &     K54, K142, LPOK, LP, GATHER_MATRIX_ALLOCATED,
+     &     KEEP, ND_STEPS)
       IMPLICIT NONE
       INTEGER, INTENT(IN)    :: N, NSTEPS, LNA, SYM,
      &     HALO_DEPTH, SEP_SIZE, GROUP_SIZE
@@ -804,6 +830,7 @@ C
       INTEGER             :: FILS(N), STEP(N), LRGROUPS(N)
       INTEGER, INTENT(IN)    :: K472, MAXFRONT
       LOGICAL, INTENT(INOUT) :: GATHER_MATRIX_ALLOCATED
+      INTEGER, INTENT(IN) :: KEEP(500), ND_STEPS(:)
       INTEGER :: K482_LOC, K38ou20
       INTEGER :: I, F, PV, NV, NLEAVES, NROOTS, PP, C, NF, NODE,
      &     SYMTRY, NBQD, AD
@@ -914,7 +941,8 @@ C
             WORK(NV) = F
             F = FILS(F)
          END DO
-         CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NV)
+         CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NV,
+     &                        ND_STEPS(NODE), KEEP(35))
          IF (NV .GE. GROUP_SIZE2)  THEN
            IF ( (K482_LOC.EQ.3)
      &           .OR.
@@ -926,7 +954,8 @@ C
                END DO
                NBGROUPS = NBGROUPS + (NV-1)/GROUP_SIZE2 + 1
             ELSE
-              CALL SEP_GROUPING(NV, WORK(1), N, NZ8,
+              CALL SEP_GROUPING( ND_STEPS(NODE), KEEP, 
+     &              NV, WORK(1), N, NZ8,
      &              LRGROUPS, NBGROUPS, IW(1), LW, IPE(1), LEN(1),
      &              GROUP_SIZE, HALO_DEPTH, TRACE(1), WORKH(1), NODE,
      &              GEN2HALO(1), K482_LOC, K472, 0, SEP_SIZE, K142,
@@ -986,7 +1015,8 @@ C
      &     FRERE_STEPS, DAD_STEPS, STEP, NA, LNA, LRGROUPS, 
      &     SYM, ICNTL, HALO_DEPTH, GROUP_SIZE, SEP_SIZE, K38, K20,
      &     K60, IFLAG, IERROR, K264, K265, K482, K472, MAXFRONT, K469, 
-     &     K10, K54, K142, LPOK, LP, GATHER_MATRIX_ALLOCATED)
+     &     K10, K54, K142, LPOK, LP, GATHER_MATRIX_ALLOCATED,
+     &     KEEP, ND_STEPS)
       IMPLICIT NONE
       INTEGER, INTENT(IN)    :: N, NSTEPS, LNA, SYM,
      &     HALO_DEPTH, SEP_SIZE, GROUP_SIZE
@@ -1003,12 +1033,13 @@ C
       INTEGER, INTENT(IN) :: K472, K469
       LOGICAL, INTENT(INOUT) :: GATHER_MATRIX_ALLOCATED
       INTEGER, INTENT(OUT)   :: K142
+      INTEGER, INTENT(IN) :: KEEP(500), ND_STEPS(:)
       INTEGER :: K482_LOC,  K469_LOC, K38ou20
       INTEGER :: I, F, PV, NV, NODE,
      &     SYMTRY, NBQD, AD
       LOGICAL :: PVSCHANGED
       INTEGER(8) :: LW, IWFR, NRORM, NIORM
-      INTEGER :: NBGROUPS, NBGROUPS_local
+      INTEGER :: NBGROUPS, NBGROUPS_local, NBG_CAPT
       INTEGER, ALLOCATABLE, DIMENSION (:) :: PVS, WORK
       INTEGER, ALLOCATABLE, DIMENSION (:) :: LEN, IW
       INTEGER(8), ALLOCATABLE, DIMENSION (:) :: IPE, IQ
@@ -1125,7 +1156,7 @@ C
       PVSCHANGED = .FALSE.
       OMP_NUM = 1
 !$    OMP_NUM = omp_get_max_threads()
-      OMP_NUM = min(OMP_NUM,8)
+      OMP_NUM = min(OMP_NUM,5)
 !$OMP PARALLEL PRIVATE(I, NODE, PV, NV, F, GROUP_SIZE2, WORK, IERR_PRIV,
 !$OMP&         WORKH_PRV, TRACE_PRV, GEN2HALO_PRV, NBGROUPS_local
 !$OMP&         )
@@ -1183,28 +1214,34 @@ C
           WORK(NV) = F
           F = FILS(F)
         END DO
-        CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NV)
-        IF (NV .GE. GROUP_SIZE2)  THEN
+        CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NV,
+     &                        ND_STEPS(NODE), KEEP(35))
+        IF (NV .GE. GROUP_SIZE2
+     &     .AND. NV.GE.int(dble(SEP_SIZE)*dble(1.5))
+     &      )  THEN
           IF ( (K482_LOC.EQ.3)
      &           .OR.
      &         ( (K60.NE.0).AND.(WORK(1).EQ.K38ou20) )
      &        ) 
      &    THEN
-!$OMP CRITICAL(lrgrouping_cri)
+!$OMP ATOMIC CAPTURE
+            NBG_CAPT = NBGROUPS
+            NBGROUPS = NBGROUPS + (NV-1)/GROUP_SIZE2 + 1
+!$OMP END ATOMIC 
             DO I=1,NV
-              LRGROUPS(WORK(I))=NBGROUPS+1+(I-1)/GROUP_SIZE2
+              LRGROUPS(WORK(I))=NBG_CAPT+1+(I-1)/GROUP_SIZE2
             END DO
-            NBGROUPS = NBGROUPS + (NV-1)/GROUP_SIZE2 + 1
-!$OMP END CRITICAL(lrgrouping_cri)
           ELSE
             IF (K469_LOC .EQ. 2) THEN
-              CALL SEP_GROUPING(NV, WORK(1), N, NZ8,
+              CALL SEP_GROUPING( ND_STEPS(NODE), KEEP,
+     &              NV, WORK(1), N, NZ8,
      &              LRGROUPS, NBGROUPS, IW(1), LW, IPE(1), LEN(1),
      &              GROUP_SIZE, HALO_DEPTH, TRACE_PRV, WORKH_PRV, 
      &              NODE, GEN2HALO_PRV, K482_LOC, K472, K469_LOC, 
      &              SEP_SIZE, K142, K10, LP, LPOK, IFLAG, IERROR)
             ELSE
-              CALL SEP_GROUPING(NV, WORK(1), N, NZ8,
+              CALL SEP_GROUPING( ND_STEPS(NODE), KEEP,
+     &              NV, WORK(1), N, NZ8,
      &              LRGROUPS, NBGROUPS, IW(1), LW, IPE(1), LEN(1),
      &              GROUP_SIZE, HALO_DEPTH, TRACE, WORKH, 
      &              NODE, GEN2HALO, K482_LOC, K472, K469_LOC, 
@@ -1232,10 +1269,10 @@ C
             ENDDO
           ENDIF
         ELSE
-!$OMP CRITICAL(lrgrouping_cri)
+!$OMP ATOMIC CAPTURE
           NBGROUPS = NBGROUPS + 1
           NBGROUPS_local = NBGROUPS
-!$OMP END CRITICAL(lrgrouping_cri)
+!$OMP END ATOMIC 
           IF (NV .GE. SEP_SIZE) THEN
             DO I = 1, NV
               LRGROUPS( WORK(I) ) = NBGROUPS_local
@@ -1306,7 +1343,8 @@ C
      &     SEP_SIZE, K38, K20,
      &     K60, IFLAG, IERROR, K264, K265, K482, K472, MAXFRONT, K469, 
      &     K10, K54, K142, LPOK, LP, 
-     &     COMM, MYID, NPROCS_ARG
+     &     COMM, MYID, NPROCS_ARG,
+     &     KEEP, ND_STEPS
      &     )
       IMPLICIT NONE
       INCLUDE 'mpif.h'
@@ -1331,13 +1369,14 @@ C
       INTEGER             :: FILS(N), STEP(N), LRGROUPS(N)
       INTEGER, INTENT(IN) :: SIZEOFBLOCKS(N)
       INTEGER, INTENT(IN) :: K472, K469
+      INTEGER, INTENT(IN) :: KEEP(500), ND_STEPS(:)
       INTEGER :: NPROCS
       INTEGER :: K482_LOC,  K469_LOC, K38ou20, K142_GLOB
       INTEGER :: I, F, PV, NV, NVEXPANDED, NODE
       REAL    :: COMPRESS_RATIO
       LOGICAL :: PVSCHANGED
       INTEGER :: PVSCHANGED_INT, PVSCHANGED_INT_GLOB, IPROC
-      INTEGER :: NBGROUPS, NBGROUPS_local 
+      INTEGER :: NBGROUPS, NBGROUPS_local, NBG_CAPT
       INTEGER, ALLOCATABLE, DIMENSION (:) :: PVS, WORK
       INTEGER :: NBGROUPS_sent
       INTEGER :: NBNODES_LOC, SIZE_SENT, ISHIFT, 
@@ -1347,7 +1386,7 @@ C
       INTEGER, ALLOCATABLE, DIMENSION (:) :: TRACE_PRV, WORKH_PRV, 
      &                                   GEN2HALO_PRV
       INTEGER :: STEP_SCALAPACK_ROOT
-      INTEGER :: GROUP_SIZE2, IERR, OMP_NUM
+      INTEGER :: GROUP_SIZE2, GROUP_SIZE2_TMP, IERR, OMP_NUM
       INTEGER :: IERR_PRIV 
       LOGICAL :: MAPCOL_PROVIDED
 #if defined(ptscotch) || defined(scotch)     
@@ -1453,10 +1492,10 @@ C
       PVSCHANGED = .FALSE.
       OMP_NUM = 1
 !$    OMP_NUM = omp_get_max_threads()
-      OMP_NUM = min(OMP_NUM,8)
+      OMP_NUM = min(OMP_NUM,5)
 !$OMP PARALLEL PRIVATE(I, NODE, PV, NV, F, GROUP_SIZE2, WORK, IERR_PRIV,
 !$OMP&         WORKH_PRV, TRACE_PRV, GEN2HALO_PRV, NBGROUPS_local,
-!$OMP&         NVEXPANDED, COMPRESS_RATIO, IPROC
+!$OMP&         NVEXPANDED, COMPRESS_RATIO, IPROC, GROUP_SIZE2_TMP
 !$OMP&         )
 !$OMP&         REDUCTION( max : K142)
 !$OMP&         IF (K469_LOC.GT.1) NUM_THREADS(OMP_NUM)
@@ -1522,29 +1561,37 @@ C
           F = FILS(F)
         END DO
         COMPRESS_RATIO = real(NVEXPANDED)/real(NV)
-        CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NVEXPANDED)
-        IF (NVEXPANDED .GE. GROUP_SIZE2)  THEN
+        CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NVEXPANDED,
+     &                        ND_STEPS(NODE), KEEP(35))
+        IF (NVEXPANDED .GE. GROUP_SIZE2
+     &     .AND. NVEXPANDED.GE.int(dble(SEP_SIZE)*dble(1.5))
+     &     )  THEN
           IF ( (K482_LOC.EQ.3)
      &           .OR.
      &         ( (K60.NE.0).AND.(WORK(1).EQ.K38ou20) )
      &        ) 
      &    THEN
-            GROUP_SIZE2 = max(int(real(GROUP_SIZE2)/COMPRESS_RATIO), 1)
-!$OMP CRITICAL(lrgrouping_cri)
+            GROUP_SIZE2_TMP = GROUP_SIZE2
+            GROUP_SIZE2_TMP = max( int(real(GROUP_SIZE2_TMP)
+     &                             /COMPRESS_RATIO), 1)
+!$OMP ATOMIC CAPTURE
+          NBG_CAPT = NBGROUPS
+          NBGROUPS = NBGROUPS + (NV-1)/GROUP_SIZE2_TMP + 1
+!$OMP END ATOMIC 
             DO I=1,NV
-              LRGROUPS(WORK(I))=NBGROUPS+1+(I-1)/GROUP_SIZE2
+              LRGROUPS(WORK(I))=NBG_CAPT+1+(I-1)/GROUP_SIZE2_TMP
             END DO
-            NBGROUPS = NBGROUPS + (NV-1)/GROUP_SIZE2 + 1
-!$OMP END CRITICAL(lrgrouping_cri)
           ELSE
             IF (K469_LOC .EQ. 2) THEN
-              CALL SEP_GROUPING_AB(NV, NVEXPANDED, WORK(1), N, 
+              CALL SEP_GROUPING_AB(  ND_STEPS(NODE), KEEP,
+     &              NV, NVEXPANDED, WORK(1), N, 
      &              LRGROUPS, NBGROUPS, LUMAT, SIZEOFBLOCKS,
      &              GROUP_SIZE, HALO_DEPTH, TRACE_PRV, WORKH_PRV, 
      &              NODE, GEN2HALO_PRV, K482_LOC, K472, K469_LOC, 
      &              SEP_SIZE, K142, K10, LP, LPOK, IFLAG, IERROR)
             ELSE
-              CALL SEP_GROUPING_AB(NV, NVEXPANDED, WORK(1), N, 
+              CALL SEP_GROUPING_AB(  ND_STEPS(NODE), KEEP,
+     &              NV, NVEXPANDED, WORK(1), N, 
      &              LRGROUPS, NBGROUPS, LUMAT, SIZEOFBLOCKS,
      &              GROUP_SIZE, HALO_DEPTH, TRACE, WORKH, 
      &              NODE, GEN2HALO, K482_LOC, K472, K469_LOC, 
diff -pruN 5.6.2-2.1/src/sana_mtrans.F 5.7.1-1/src/sana_mtrans.F
--- 5.6.2-2.1/src/sana_mtrans.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/sana_mtrans.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/sana_reordertree.F 5.7.1-1/src/sana_reordertree.F
--- 5.6.2-2.1/src/sana_reordertree.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/sana_reordertree.F	2024-05-02 10:15:25.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -26,8 +26,6 @@ C
       INTEGER INFO(80)
       INTEGER SLAVEF,PROCNODE(NSTEPS)
       INTEGER :: SBTR_WHICH_M
-      EXTERNAL MUMPS_PROCNODE
-      INTEGER MUMPS_PROCNODE
       REAL PEAK
       REAL, DIMENSION(:), ALLOCATABLE :: COST_TRAV
       INTEGER, DIMENSION (:), ALLOCATABLE :: DEPTH
diff -pruN 5.6.2-2.1/src/sarrowheads.F 5.7.1-1/src/sarrowheads.F
--- 5.6.2-2.1/src/sarrowheads.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/sarrowheads.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -185,10 +185,8 @@ C
       INTEGER    :: INTARR( LINTARR )
       REAL    :: DBLARR( LDBLARR )
       REAL    :: A( LA )
-      INTEGER MUMPS_PROCNODE, MUMPS_TYPENODE, numroc, 
-     &        MUMPS_TYPESPLIT
-      EXTERNAL MUMPS_PROCNODE, MUMPS_TYPENODE, numroc, 
-     &        MUMPS_TYPESPLIT
+      INTEGER MUMPS_TYPESPLIT
+      EXTERNAL MUMPS_TYPESPLIT
       INTEGER LP
       LOGICAL LPOK
       REAL VAL, VAL_SHR
@@ -767,8 +765,6 @@ C
       PARAMETER(MASTER=0)
       INTEGER :: IERR
       INTEGER :: STATUS(MPI_STATUS_SIZE)
-      INTEGER numroc
-      EXTERNAL numroc
       TYPE_PARALL = KEEP(46)
       LP = ICNTL(1)
       LPOK = ( LP .GT. 0 .AND. ICNTL(4) .GE. 1 )
@@ -995,11 +991,11 @@ C
       INTEGER,    INTENT(OUT) :: LOCAL_M, LOCAL_N
       INTEGER(8), INTENT(OUT) :: PTR_ROOT
       INTEGER(8), INTENT(IN)  :: LA
-      INTEGER, EXTERNAL :: numroc
-      LOCAL_M = numroc( root%ROOT_SIZE, root%MBLOCK,
+      INTEGER, EXTERNAL :: MUMPS_NUMROC
+      LOCAL_M = MUMPS_NUMROC( root%ROOT_SIZE, root%MBLOCK,
      &         root%MYROW, 0, root%NPROW )
       LOCAL_M = max( 1, LOCAL_M )
-      LOCAL_N = numroc( root%ROOT_SIZE, root%NBLOCK,
+      LOCAL_N = MUMPS_NUMROC( root%ROOT_SIZE, root%NBLOCK,
      &         root%MYCOL, 0, root%NPCOL )
       PTR_ROOT = LA - int(LOCAL_M,8) * int(LOCAL_N,8) + 1_8
       RETURN
diff -pruN 5.6.2-2.1/src/sbcast_int.F 5.7.1-1/src/sbcast_int.F
--- 5.6.2-2.1/src/sbcast_int.F	2023-10-11 09:37:02.000000000 +0000
+++ 5.7.1-1/src/sbcast_int.F	2024-05-02 10:15:25.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/send_driver.F 5.7.1-1/src/send_driver.F
--- 5.6.2-2.1/src/send_driver.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/send_driver.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -323,9 +323,9 @@ C     Allocated at analysis:
         ENDIF
 !     ENDIF
 C     Allocated at analysis:
-      IF (associated(id%MPITOOMP_PROCS_MAP)) THEN
-        DEALLOCATE(id%MPITOOMP_PROCS_MAP)
-        NULLIFY(id%MPITOOMP_PROCS_MAP)
+      IF (associated(id%MTKO_PROCS_MAP)) THEN
+        DEALLOCATE(id%MTKO_PROCS_MAP)
+        NULLIFY(id%MTKO_PROCS_MAP)
       ENDIF
 C     Allocated at analysis:
       IF (associated(id%IPOOL_B_L0_OMP)) THEN
@@ -514,6 +514,16 @@ C     (this includes suppression of OOC
         DEALLOCATE(id%PIVNUL_LIST)
         NULLIFY(id%PIVNUL_LIST)
       ENDIF
+      IF (associated(id%ROWSCA_loc)) THEN
+        DEALLOCATE(id%ROWSCA_loc)
+        NULLIFY(id%ROWSCA_loc)
+      ENDIF
+      IF (id%KEEP(50) .EQ. 0) THEN
+        IF (associated(id%COLSCA_loc)) THEN
+          DEALLOCATE(id%COLSCA_loc)
+        ENDIF
+      ENDIF
+      NULLIFY(id%COLSCA_loc)
 C     IPIV is used both for ScaLAPACK and RR
 C     Keep it outside SMUMPS_RR_FREE_POINTERS
       IF (associated(id%root%IPIV))    THEN
@@ -572,19 +582,19 @@ C     Data allocated during solve
 C     ---------------------------
 C
 C     (or for some of it, factorization -- forward during factorization)
-      IF (associated(id%RHSCOMP)) THEN
-        DEALLOCATE(id%RHSCOMP)
-        NULLIFY(id%RHSCOMP)
+      IF (associated(id%RHSINTR)) THEN
+        DEALLOCATE(id%RHSINTR)
+        NULLIFY(id%RHSINTR)
         id%KEEP8(25)=0_8
       ENDIF
-      IF (associated(id%POSINRHSCOMP_ROW)) THEN
-        DEALLOCATE(id%POSINRHSCOMP_ROW)
-        NULLIFY(id%POSINRHSCOMP_ROW)
-      ENDIF
-      IF (id%POSINRHSCOMP_COL_ALLOC) THEN
-        DEALLOCATE(id%POSINRHSCOMP_COL)
-        NULLIFY(id%POSINRHSCOMP_COL)
-        id%POSINRHSCOMP_COL_ALLOC = .FALSE.
+      IF (associated(id%GLOB2LOC_RHS)) THEN
+        DEALLOCATE(id%GLOB2LOC_RHS)
+        NULLIFY(id%GLOB2LOC_RHS)
+      ENDIF
+      IF (id%GLOB2LOC_SOL_ALLOC) THEN
+        DEALLOCATE(id%GLOB2LOC_SOL)
+        NULLIFY(id%GLOB2LOC_SOL)
+        id%GLOB2LOC_SOL_ALLOC = .FALSE.
       ENDIF
 C     Allocated during solve:
 C     (even in case of fwd in facto)
@@ -598,3 +608,39 @@ C     (even in case of fwd in facto)
       END IF
       RETURN
       END SUBROUTINE SMUMPS_FREE_DATA_FACTO
+      SUBROUTINE SMUMPS_FREE_DATA_RHSINTR(id)
+C
+C     Purpose:
+C     -------
+C       Free RHSINTR related data that might 
+C       have been generated after a forward only step (ICNTL(26)=1)
+C     Module depencies
+C     ----------------
+      USE SMUMPS_STRUC_DEF
+      IMPLICIT NONE
+C
+C     Argument:
+C     --------
+C
+C     id is the main MUMPS structure, giving access to all internal
+C     objects allocated by the package.
+C
+      TYPE( SMUMPS_STRUC) :: id
+C
+      IF (associated(id%RHSINTR)) THEN
+        DEALLOCATE(id%RHSINTR)
+        NULLIFY(id%RHSINTR)
+        id%KEEP8(25)=0_8
+        id%LD_RHSINTR = 0
+      ENDIF
+      IF (associated(id%GLOB2LOC_RHS)) THEN
+        DEALLOCATE(id%GLOB2LOC_RHS)
+        NULLIFY(id%GLOB2LOC_RHS)
+      ENDIF
+      IF (id%GLOB2LOC_SOL_ALLOC) THEN
+        DEALLOCATE(id%GLOB2LOC_SOL)
+        NULLIFY(id%GLOB2LOC_SOL)
+        id%GLOB2LOC_SOL_ALLOC = .FALSE.
+      ENDIF
+      RETURN
+      END SUBROUTINE SMUMPS_FREE_DATA_RHSINTR
diff -pruN 5.6.2-2.1/src/sfac_asm.F 5.7.1-1/src/sfac_asm.F
--- 5.6.2-2.1/src/sfac_asm.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/sfac_asm.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -41,7 +41,7 @@ C
       IOLDPS = PTLUST_S(STEP(INODE))
       POSELT = PTRAST(STEP(INODE))
       NFRONT = IW(IOLDPS+KEEP(IXSZ))
-      NASS1  = iabs(IW(IOLDPS + 2+KEEP(IXSZ)))
+      NASS1  = abs(IW(IOLDPS + 2+KEEP(IXSZ)))
       NSLAVES= IW(IOLDPS+5+KEEP(IXSZ))
       IF (KEEP(50).EQ.0) THEN
         LDAFS_PERE = NFRONT
@@ -145,7 +145,7 @@ C
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
       INTEGER, INTENT(IN) :: NINROWARR(KEEP(195))
       INTEGER, INTENT(IN) :: PTRDEBARR(KEEP(196))
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       REAL :: A(LA)
       INTEGER :: INTARR(KEEP8(27))
       REAL :: DBLARR(KEEP8(26))
@@ -202,7 +202,7 @@ C
       INTEGER NBROWS
       INTEGER IW(LIW), ITLOC(N+KEEP(253)), STEP(N),
      &        PTRIST(KEEP(28))
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INCLUDE 'mumps_headers.h'
       INTEGER IOLDPS, NBCOLF, NBROWF, NSLAVES, HF,
      &        K1,K2,K,J
@@ -238,7 +238,7 @@ C
       INTEGER ROWLIST(NBROWS), COLLIST(NBCOLS)
       INTEGER IW(LIW), ITLOC(N+KEEP(253)), STEP(N),
      &        PTRIST(KEEP(28)), FILS(N)
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INTEGER(8) :: PTRAST(KEEP(28))
       REAL A(LA), VALSON(LDA_VALSON,NBROWS)
       DOUBLE PRECISION OPASSW, OPELIW
@@ -609,7 +609,7 @@ C
       INTRINSIC real
       IOLDPS = PTLUST_S(STEP(INODE))
       POSELT = PTRAST(STEP(INODE))
-      NASS1  = iabs(IW(IOLDPS + 2 + KEEP(IXSZ)))
+      NASS1  = abs(IW(IOLDPS + 2 + KEEP(IXSZ)))
       NSLAVES= IW(IOLDPS+5 + KEEP(IXSZ))
       HF      = 6 + NSLAVES + KEEP(IXSZ)
       ISTCHK = PIMASTER(STEP(ISON))
@@ -655,7 +655,7 @@ C
       INTEGER(8), intent(in) :: KEEP8(150)
       INTEGER, intent(inout) :: ITLOC(N+KEEP(253))
       REAL, intent(inout) :: A(LA)
-      REAL, intent(in)    :: RHS_MUMPS(KEEP(255))
+      REAL, intent(in)    :: RHS_MUMPS(KEEP8(85))
       REAL, intent(in)    :: DBLARR(LDBLARR)
       INTEGER, intent(in)    :: INTARR(LINTARR)
       INTEGER, intent(in)    :: FILS(N)
@@ -709,8 +709,9 @@ C
           NB_BLR_LS = NPARTSCB
           call MAX_CLUSTER(BEGS_BLR_LS,NB_BLR_LS+1,MAXI_CLUSTER)
           DEALLOCATE(BEGS_BLR_LS)
-          CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS)
-          MINSIZE = int(IBCKSZ2 / 2)
+          CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS, 
+     &                         NBCOLF, KEEP(35))
+          MINSIZE = int(IBCKSZ2 / 3)
           TOPDIAG = max(2*MINSIZE + MAXI_CLUSTER-1, TOPDIAG)
         ENDIF
 !$      CHUNK = max( KEEP(360)/2,
diff -pruN 5.6.2-2.1/src/sfac_asm_ELT.F 5.7.1-1/src/sfac_asm_ELT.F
--- 5.6.2-2.1/src/sfac_asm_ELT.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/sfac_asm_ELT.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -31,7 +31,7 @@ C
       INTEGER IW(LIW), ITLOC(N+KEEP(253)), STEP(N),
      &        PTRIST(KEEP(28)), FILS(N)
       INTEGER(8), INTENT(IN) :: PTRARW(NELT+1), PTRAIW(NELT+1)
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INTEGER INTARR(KEEP8(27))
       INTEGER FRT_PTR(N+1), FRT_ELT(NELT)
       REAL :: A(LA)
@@ -92,7 +92,7 @@ C
       INTEGER(8), intent(in) :: KEEP8(150)
       INTEGER, intent(inout) :: ITLOC(N+KEEP(253))
       REAL, intent(inout) :: A(LA)
-      REAL, intent(in)    :: RHS_MUMPS(KEEP(255))
+      REAL, intent(in)    :: RHS_MUMPS(KEEP8(85))
       INTEGER, intent(in)    :: INTARR(LINTARR)
       REAL, intent(in)    :: DBLARR(LDBLARR)
       INTEGER, intent(in)    :: FRT_PTR(N+1), FRT_ELT(NELT)
@@ -148,8 +148,9 @@ C
           NB_BLR_LS = NPARTSCB
           call MAX_CLUSTER(BEGS_BLR_LS,NB_BLR_LS+1,MAXI_CLUSTER)
           DEALLOCATE(BEGS_BLR_LS)
-          CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS)
-          MINSIZE = int(IBCKSZ2 / 2)
+          CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS,
+     &                         NBCOLF, KEEP(35))
+          MINSIZE = int(IBCKSZ2 / 3)
           TOPDIAG = max(2*MINSIZE + MAXI_CLUSTER-1, TOPDIAG)
         ENDIF
 !$      CHUNK = max( KEEP(360)/2,
diff -pruN 5.6.2-2.1/src/sfac_asm_master_ELT_m.F 5.7.1-1/src/sfac_asm_master_ELT_m.F
--- 5.6.2-2.1/src/sfac_asm_master_ELT_m.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/sfac_asm_master_ELT_m.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -78,7 +78,7 @@ C
      &        FILS(N), FRERE(KEEP(28)), DAD(KEEP(28)),
      &        PTRIST(KEEP(28)), PTLUST(KEEP(28)),
      &        STEP(N), PIMASTER(KEEP(28))
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INTEGER(8) :: PTRFAC(KEEP(28)), PTRAST(KEEP(28)),
      &              PAMASTER(KEEP(28))
       INTEGER COMM, NBFIN, SLAVEF, MYID
@@ -224,7 +224,7 @@ C
      &       NUMORG, KEEP(486),
      &       KEEP(489), KEEP(490), KEEP(491), KEEP(492), 
      &       KEEP(20), KEEP(60), DAD(STEP(INODE)), KEEP(38),
-     &       LRSTATUS, KEEP(280), LRGROUPS)
+     &       KEEP(123), LRSTATUS, KEEP(280), LRGROUPS)
       IF (DAD(STEP(INODE)).NE.0) THEN
         IF ( MUMPS_PROCNODE(PROCNODE_STEPS(STEP(DAD(STEP(INODE)))),
      &                                     KEEP(199) )
@@ -338,7 +338,7 @@ C
      &       IOLDPS + HF + 2 * NFRONT, IW, LIW)
       ENDIF
       NCB   = NFRONT - NASS1
-      MAXFRW = max0(MAXFRW, NFRONT)
+      MAXFRW = max(MAXFRW, NFRONT)
       ICT11 = IOLDPS + HF - 1 + NFRONT
       CALL SMUMPS_SET_PARPIVT1 ( INODE, NFRONT, NASS1, KEEP, 
      &                           LR_ACTIVATED, PARPIV_T1) 
@@ -413,8 +413,9 @@ C
             NB_BLR = NPARTSASS + NPARTSCB
          CALL MAX_CLUSTER(BEGS_BLR,NB_BLR,MAXI_CLUSTER)
          DEALLOCATE(BEGS_BLR)
-         CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS1)
-         MINSIZE = int(IBCKSZ2 / 2)
+         CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS1,
+     &                        NFRONT, KEEP(35))
+         MINSIZE = int(IBCKSZ2 / 3)
          TOPDIAG = max(2*MINSIZE + MAXI_CLUSTER-1,TOPDIAG)
         ENDIF
         NUMROWS = NFRONT8
@@ -926,7 +927,7 @@ C
      &        STEP(N),
      & PIMASTER(KEEP(28)),
      &        NSTK_S(KEEP(28)), PERM(N)
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INTEGER   CAND(SLAVEF+1, max(1,KEEP(56)))
       INTEGER   ISTEP_TO_INIV2(KEEP(71)), 
      &          TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
@@ -1059,7 +1060,7 @@ C
       CALL IS_FRONT_BLR_CANDIDATE(INODE, 2, NFRONT, NASS1, KEEP(486),
      &       KEEP(489), KEEP(490), KEEP(491), KEEP(492), 
      &       KEEP(20), KEEP(60), DAD(STEP(INODE)), KEEP(38),
-     &       LRSTATUS, KEEP(280), LRGROUPS)
+     &       KEEP(123), LRSTATUS, KEEP(280), LRGROUPS)
       COMPRESS_PANEL = (LRSTATUS.GE.2)
       COMPRESS_CB    = ((LRSTATUS.EQ.1).OR.
      &                  (LRSTATUS.EQ.3))
@@ -1311,7 +1312,7 @@ C
      &       NBPANELS_L, NBPANELS_U, NASS1, 
      &       IOLDPS + HF + 2 * NFRONT, IW, LIW)
       ENDIF
-      MAXFRW = max0(MAXFRW, NFRONT)
+      MAXFRW = max(MAXFRW, NFRONT)
       PTLUST(STEP(INODE)) = IOLDPS
       IW(IOLDPS+KEEP(IXSZ))     = NFRONT
       IW(IOLDPS + 1+KEEP(IXSZ)) = 0
@@ -1432,8 +1433,9 @@ C
          NB_BLR = NPARTSASS + NPARTSCB
          CALL MAX_CLUSTER(BEGS_BLR,NB_BLR,MAXI_CLUSTER)
          DEALLOCATE(BEGS_BLR)
-         CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS1)
-         MINSIZE = int(IBCKSZ2 / 2)
+         CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS1,
+     &                        NFRONT, KEEP(35))
+         MINSIZE = int(IBCKSZ2 / 3)
          TOPDIAG = max(2*MINSIZE + MAXI_CLUSTER-1, TOPDIAG)
         ENDIF
 !$      CHUNK = max(KEEP(360)/2,
diff -pruN 5.6.2-2.1/src/sfac_asm_master_m.F 5.7.1-1/src/sfac_asm_master_m.F
--- 5.6.2-2.1/src/sfac_asm_master_m.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/sfac_asm_master_m.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -76,7 +76,7 @@ C
      &        FILS(N), FRERE(KEEP(28)), DAD(KEEP(28)),
      &        PTRIST(KEEP(28)), PTLUST(KEEP(28)),
      &        STEP(N), PIMASTER(KEEP(28))
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INTEGER(8) :: PTRFAC(KEEP(28)), PTRAST(KEEP(28)),
      &              PAMASTER(KEEP(28))
       INTEGER COMM, NBFIN, SLAVEF, MYID
@@ -193,7 +193,7 @@ C
         ETATASS= 2 
         IOLDPS = PTLUST(STEP(INODE)) 
         NFRONT = IW(IOLDPS + KEEP(IXSZ)) 
-        NASS1  = iabs(IW(IOLDPS + 2 + KEEP(IXSZ)))
+        NASS1  = abs(IW(IOLDPS + 2 + KEEP(IXSZ)))
         ICT11 = IOLDPS + HF - 1 + NFRONT
         SSARBR=MUMPS_INSSARBR(PROCNODE_STEPS(STEP(INODE)),
      &                        KEEP(199))
@@ -246,7 +246,7 @@ C
      &       NUMORG, KEEP(486),
      &       KEEP(489), KEEP(490), KEEP(491), KEEP(492), 
      &       KEEP(20), KEEP(60), DAD(STEP(INODE)), KEEP(38),
-     &       LRSTATUS, KEEP(280), LRGROUPS)
+     &       KEEP(123), LRSTATUS, KEEP(280), LRGROUPS)
       IF (DAD(STEP(INODE)).NE.0) THEN
         IF ( MUMPS_PROCNODE(PROCNODE_STEPS(STEP(DAD(STEP(INODE)))),
      &                                     KEEP(199) )
@@ -384,7 +384,7 @@ C
      &       IOLDPS + HF + 2 * NFRONT, IW, LIW)
       ENDIF
       NCB   = NFRONT - NASS1
-      MAXFRW = max0(MAXFRW, NFRONT)
+      MAXFRW = max(MAXFRW, NFRONT)
       ICT11 = IOLDPS + HF - 1 + NFRONT
       CALL SMUMPS_SET_PARPIVT1 ( INODE, NFRONT, NASS1, KEEP, 
      &                           LR_ACTIVATED, PARPIV_T1) 
@@ -465,8 +465,9 @@ C
             NB_BLR = NPARTSASS + NPARTSCB
          CALL MAX_CLUSTER(BEGS_BLR,NB_BLR,MAXI_CLUSTER)
          DEALLOCATE(BEGS_BLR)
-         CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS1)
-         MINSIZE = int(IBCKSZ2 / 2)
+         CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS1,
+     &                        NFRONT, KEEP(35))
+         MINSIZE = int(IBCKSZ2 / 3)
          TOPDIAG = max(2*MINSIZE + MAXI_CLUSTER-1,TOPDIAG)
         ENDIF
         IF (ETATASS.EQ.1) THEN
@@ -654,14 +655,6 @@ C
           ELSE
             IACHK = PAMASTER(STEP(ISON))
           ENDIF
-          IF (IS_CB_LR .AND. LEVEL1) THEN
-            POSEL1 = PTRAST(STEP(INODE))
-            CALL SMUMPS_BLR_ASM_NIV1 (A, LA,
-     &           POSEL1, NFRONT, NASS1, SON_IW(ISTCHK+XXF),
-     &           SON_IW, SON_LIW,
-     &           LSTK, NELIM, K1, K1+LSTK-1, KEEP(50),
-     &           KEEP, KEEP8, OPASSW)
-          ENDIF
           IF ( KEEP(50) .eq. 0 ) THEN
             POSEL1 = PTRAST(STEP(INODE)) - NFRONT8
             IF (NFRONT .EQ. LSTK.AND. ISON.EQ.ISON_IN_PLACE
@@ -750,6 +743,14 @@ C
               ENDIF
             ENDIF 
           ENDIF
+          IF (IS_CB_LR .AND. LEVEL1) THEN
+            POSEL1 = PTRAST(STEP(INODE))
+            CALL SMUMPS_BLR_ASM_NIV1 (A, LA,
+     &           POSEL1, NFRONT, NASS1, SON_IW(ISTCHK+XXF),
+     &           SON_IW, SON_LIW,
+     &           LSTK, NELIM, K1, K1+LSTK-1, KEEP(50),
+     &           KEEP, KEEP8, OPASSW)
+          ENDIF
   205     IF (LEVEL1) THEN 
            IF (SAME_PROC) ISTCHK = PTRIST(STEP(ISON))
            IF ((SAME_PROC).AND.ETATASS.NE.1) THEN
@@ -1077,7 +1078,7 @@ C
      &        STEP(N),
      & PIMASTER(KEEP(28)),
      &        NSTK_S(KEEP(28)), PERM(N)
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INTEGER   CAND(SLAVEF+1, max(1,KEEP(56)))
       INTEGER   ISTEP_TO_INIV2(KEEP(71)), 
      &          TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
@@ -1202,7 +1203,7 @@ C
       CALL IS_FRONT_BLR_CANDIDATE(INODE, 2, NFRONT, NASS1, KEEP(486),
      &       KEEP(489), KEEP(490), KEEP(491), KEEP(492), 
      &       KEEP(20), KEEP(60), DAD(STEP(INODE)), KEEP(38),
-     &       LRSTATUS, KEEP(280), LRGROUPS)
+     &       KEEP(123), LRSTATUS, KEEP(280), LRGROUPS)
       COMPRESS_PANEL = (LRSTATUS.GE.2)
       COMPRESS_CB    = ((LRSTATUS.EQ.1).OR.
      &                  (LRSTATUS.EQ.3))
@@ -1452,7 +1453,7 @@ C
      &       NBPANELS_L, NBPANELS_U, NASS1, 
      &       IOLDPS + HF + 2 * NFRONT, IW, LIW)
       ENDIF
-      MAXFRW = max0(MAXFRW, NFRONT)
+      MAXFRW = max(MAXFRW, NFRONT)
       PTLUST(STEP(INODE)) = IOLDPS
       IW(IOLDPS+KEEP(IXSZ))     = NFRONT
       IW(IOLDPS + 1+KEEP(IXSZ)) = 0
@@ -1571,8 +1572,9 @@ C
          NB_BLR = NPARTSASS + NPARTSCB
          CALL MAX_CLUSTER(BEGS_BLR,NB_BLR,MAXI_CLUSTER)
          DEALLOCATE(BEGS_BLR)
-         CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS1)
-         MINSIZE = int(IBCKSZ2 / 2)
+         CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS1,
+     &                        NFRONT, KEEP(35))
+         MINSIZE = int(IBCKSZ2 / 3)
          TOPDIAG = max(2*MINSIZE + MAXI_CLUSTER-1, TOPDIAG)
         ENDIF
 !$      CHUNK = max(KEEP(360)/2,
diff -pruN 5.6.2-2.1/src/sfac_b.F 5.7.1-1/src/sfac_b.F
--- 5.6.2-2.1/src/sfac_b.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/sfac_b.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -71,7 +71,7 @@ C
       INTEGER(8) :: PTRFAC(KEEP(28))
       INTEGER   PTRIST(KEEP(28)), PTLUST_S(KEEP(28))
       INTEGER   IW1(2*KEEP(28)), ITLOC(N+KEEP(253)), POOL(LPOOL)
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INTEGER(8) :: IW2(2*KEEP(28))
       INTEGER   PROCNODE_STEPS(KEEP(28))
       INTEGER   COMM_LOAD, ASS_IRECV
@@ -96,8 +96,8 @@ C
       INTEGER, INTENT (IN) :: LL0_OMP_MAPPING
       INTEGER, INTENT (OUT):: L0_OMP_MAPPING( LL0_OMP_MAPPING )
       INTEGER, INTENT (IN) :: LL0_OMP_FACTORS
-      TYPE(SMUMPS_L0OMPFAC_T), INTENT (OUT) :: L0_OMP_FACTORS(
-     &                                         LL0_OMP_FACTORS )
+      TYPE(SMUMPS_L0OMPFAC_T), INTENT (INOUT) :: L0_OMP_FACTORS(
+     &                                           LL0_OMP_FACTORS )
       INTEGER, INTENT (IN) :: NBSTATS_I4, NBSTATS_I8
       INTEGER, INTENT (IN) :: NBCOLS_I4, NBCOLS_I8
       INTEGER, INTENT (IN) :: I4_L0_OMP(NBSTATS_I4, NBCOLS_I4)
@@ -556,7 +556,7 @@ C
       INTEGER LPOOL
       INTEGER PROCNODE_STEPS(KEEP(28))
       INTEGER ITLOC(N+KEEP(253))
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INTEGER IW(LIW), NSTK_STEPS(KEEP(28))
       INTEGER(8), INTENT(IN) :: PTRARW(LPTRAR), PTRAIW(LPTRAR)
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
diff -pruN 5.6.2-2.1/src/sfac_determinant.F 5.7.1-1/src/sfac_determinant.F
--- 5.6.2-2.1/src/sfac_determinant.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/sfac_determinant.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -152,25 +152,24 @@ C
       NEXP=-NEXP
       RETURN
       END SUBROUTINE SMUMPS_DETER_SCALING_INVERSE
-      SUBROUTINE SMUMPS_DETER_SIGN_PERM(DETER, N, VISITED, PERM)
+      SUBROUTINE SMUMPS_DETER_SIGN_PERM(DETER, N, PERM)
       IMPLICIT NONE
       REAL, intent(inout) :: DETER
       INTEGER, intent(in)    :: N
-      INTEGER, intent(inout) :: VISITED(N)
-      INTEGER, intent(in)    :: PERM(N)
+      INTEGER, intent(inout) :: PERM(N)
       INTEGER I, J, K
       K = 0
       DO I = 1, N
-        IF (VISITED(I) .GT. N) THEN
-          VISITED(I)=VISITED(I)-N-N-1
-          CYCLE
+        IF (PERM(I) .LT. 0) THEN
+          PERM(I)=-PERM(I)
+        ELSE 
+          J = PERM(I)
+          DO WHILE (J.NE.I)
+            PERM(J)=-PERM(J)
+            K = K + 1
+            J = -PERM(J) 
+          ENDDO
         ENDIF
-        J = PERM(I)
-        DO WHILE (J.NE.I)
-          VISITED(J) = VISITED(J) + N + N + 1
-          K = K + 1
-          J = PERM(J)
-        ENDDO
       ENDDO
       IF (mod(K,2).EQ.1) THEN
         DETER = -DETER
diff -pruN 5.6.2-2.1/src/sfac_diag.F 5.7.1-1/src/sfac_diag.F
--- 5.6.2-2.1/src/sfac_diag.F	1970-01-01 00:00:00.000000000 +0000
+++ 5.7.1-1/src/sfac_diag.F	2024-05-02 10:15:28.000000000 +0000
@@ -0,0 +1,20 @@
+C
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
+C
+C
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Mumps Technologies, University of Bordeaux.
+C
+C  This version of MUMPS is provided to you free of charge. It is
+C  released under the CeCILL-C license 
+C  (see doc/CeCILL-C_V1-en.txt, doc/CeCILL-C_V1-fr.txt, and
+C  https://cecill.info/licences/Licence_CeCILL-C_V1-en.html)
+C
+      SUBROUTINE SMUMPS_GETSETDIAGRETURN()
+C
+C     This file contain code to access/return the
+C     diagonal of a factorized matrix in the future.
+C
+      RETURN
+      END SUBROUTINE SMUMPS_GETSETDIAGRETURN
diff -pruN 5.6.2-2.1/src/sfac_dist_arrowheads_omp.F 5.7.1-1/src/sfac_dist_arrowheads_omp.F
--- 5.6.2-2.1/src/sfac_dist_arrowheads_omp.F	1970-01-01 00:00:00.000000000 +0000
+++ 5.7.1-1/src/sfac_dist_arrowheads_omp.F	2024-05-02 10:15:26.000000000 +0000
@@ -0,0 +1,1350 @@
+C
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
+C
+C
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Mumps Technologies, University of Bordeaux.
+C
+C  This version of MUMPS is provided to you free of charge. It is
+C  released under the CeCILL-C license 
+C  (see doc/CeCILL-C_V1-en.txt, doc/CeCILL-C_V1-fr.txt, and
+C  https://cecill.info/licences/Licence_CeCILL-C_V1-en.html)
+C
+#if ! defined(PCPRET)
+      SUBROUTINE SMUMPS_FAC_DIST_ARROWHEADS_OMP  (      
+     & N, NZ_loc8, 
+     &    A_loc, IRN_loc, JCN_loc, 
+     &    SIZESCAL, LSCAL, COLSCA, ROWSCA, 
+     & DBLARR, LDBLARR, INTARR, LINTARR,
+     & PTR8ARR, NINCOLARR, NINROWARR, PTRDEBARR,
+     & FILS, KEEP,KEEP8, MYID, COMM, NBRECORDS,
+     &
+     & S, LA, root, PROCNODE_STEPS, NPROCS, SLAVEF, PERM, STEP,
+     & ICNTL, INFO, NSEND8, NLOCAL8,
+     & ISTEP_TO_INIV2, CANDIDATES
+     & )
+!$    USE OMP_LIB
+      USE SMUMPS_STRUC_DEF
+      IMPLICIT NONE
+      INTEGER, INTENT(IN)    :: N, SIZESCAL
+      LOGICAL, INTENT(IN)    :: LSCAL
+      INTEGER(8), INTENT(IN) :: NZ_loc8
+      INTEGER, INTENT(IN)    :: IRN_LOC(max(1_8,NZ_loc8)), 
+     &                          JCN_LOC(max(1_8,NZ_loc8))
+      REAL, INTENT(IN)    :: A_loc(max(1_8,NZ_loc8))
+      REAL, INTENT(IN)       :: ROWSCA(SIZESCAL),
+     &                          COLSCA(SIZESCAL)
+      INTEGER(8), INTENT(IN) :: LDBLARR, LINTARR
+      REAL, INTENT(OUT)   :: DBLARR( LDBLARR )
+      INTEGER, INTENT(OUT)   :: INTARR( LINTARR )
+      INTEGER, INTENT(INOUT) :: KEEP(500)   
+      INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
+      INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
+      INTEGER, INTENT(IN) :: NINROWARR(KEEP(195))
+      INTEGER, INTENT(IN) :: PTRDEBARR(KEEP(196))
+      INTEGER(8), INTENT(INOUT):: KEEP8(150) 
+      INTEGER, INTENT(IN)    :: FILS( N )
+      INTEGER, INTENT(IN)    :: MYID, COMM, NBRECORDS
+      INTEGER(8), INTENT(IN) :: LA
+      INTEGER, INTENT(IN)    :: NPROCS, SLAVEF
+      INTEGER(8), INTENT(OUT):: NSEND8, NLOCAL8
+      INTEGER, INTENT(IN)    :: ISTEP_TO_INIV2(KEEP(71))
+      INTEGER, INTENT(IN)    :: CANDIDATES(SLAVEF+1, max(1,KEEP(56)))
+      REAL, INTENT(INOUT) :: S( LA )
+      TYPE (SMUMPS_ROOT_STRUC), INTENT(INOUT) :: root
+      INTEGER, INTENT(IN)    :: PROCNODE_STEPS(KEEP(28)), 
+     &                         PERM( N ), STEP( N )
+      INTEGER, INTENT(INOUT) :: INFO( 80 ) 
+      INTEGER, INTENT(IN)    :: ICNTL(60)
+      INCLUDE 'mumps_tags.h'
+      INCLUDE 'mpif.h'
+      REAL ZERO
+      PARAMETER( ZERO = 0.0E0 )
+      INTEGER, ALLOCATABLE, DIMENSION(:,:)  :: IW4
+      INTEGER(8), ALLOCATABLE, DIMENSION(:) :: PTRAW
+      INTEGER, ALLOCATABLE, DIMENSION(:,:,:) :: BUFSENDI
+      REAL, ALLOCATABLE, DIMENSION(:,:,:) :: BUFSENDR
+      INTEGER, ALLOCATABLE, DIMENSION(:,:)   :: BUFSEND_POSRESERVED
+      INTEGER, ALLOCATABLE, DIMENSION(:,:) :: BUFRECVI
+      REAL, ALLOCATABLE, DIMENSION(:,:) :: BUFRECVR
+      INTEGER, ALLOCATABLE, DIMENSION(:) :: IACT, ISENDREQI, ISENDREQR
+      LOGICAL, ALLOCATABLE, DIMENSION(:) :: SEND_ACTIVE
+      INTEGER, ALLOCATABLE, DIMENSION(:) :: IRECVREQI, IRECVREQR
+      INTEGER, ALLOCATABLE, DIMENSION(:):: RECV_BUF_STATUS
+         INTEGER, PARAMETER :: Processed_IrecNeeded          = 1
+         INTEGER, PARAMETER :: IrecPosted                    = 2
+         INTEGER, PARAMETER :: Received_NotProcessed         = 3
+         INTEGER, PARAMETER :: Processed_IrecNotneeded       = 4
+         INTEGER, PARAMETER :: Treating                      = 5
+         INTEGER, PARAMETER :: BeingTreatednotbyme           = 6 
+      INTEGER(8) :: ILOC8
+      INTEGER :: EndNZloc, NB_END_MSG_2_RECV
+      LOGICAL :: MPI_End_Send, End_TreatRecvBuf, MPI_InvolvedinSend, 
+     &           MPI_InvolvedinRecv, TH_InvolvedinComm, 
+     &           NO_ATOMIC_Wsendbuf, NO_ATOMIC_Warrow, FINISHED,
+     &           TH_InvolvedinArrange, TH_InvolvedinTreatRecv
+      INTEGER(8) :: PTR_ROOT
+      INTEGER    :: LOCAL_M, LOCAL_N, ARROW_ROOT
+      LOGICAL :: EARLYT3ROOTINS
+      LOGICAL :: I_AM_SLAVE, OneMPI
+      INTEGER :: IARR1, IORG, NOMP, NOMP_MAX
+      INTEGER :: ISTEP, ISLAVE_MAIN, IMAIN, JMAIN
+      INTEGER :: allocok 
+      LOGICAL :: OMP_FLAG
+      INTEGER(8) :: IS8MAIN
+      INTEGER :: TYPE_NODE_P, MASTER_NODE_P, NBJ_P
+      INTEGER(8) :: IS8_P
+      INTEGER :: LP, MP
+      LOGICAL :: LPOK, PROK
+      INTEGER(8) :: NB_RANGE_8
+      INTEGER :: SHIFT_PID
+      INTEGER :: NOMP_SHARED
+      LOGICAL    :: NOTHINGTOARRANGE_P
+      INTEGER    :: IOMP, NB_RANGE_P, EndNZloc_P
+      LOGICAL    :: ThWorking
+      INTEGER(8) :: ILOC8_P
+      INTEGER, PARAMETER :: MPI_MASTER = 0  
+      NSEND8  = 0_8
+      NLOCAL8 = 0_8
+      LP = ICNTL(1)
+      MP = ICNTL(2)
+      LPOK    = ((LP.GT.0).AND.(ICNTL(4).GE.1))
+      PROK    = ((MP.GT.0).AND.(ICNTL(4).GE.2))
+      NB_RANGE_8        = int(max(NBRECORDS/10, 1), 8)
+      IF (KEEP(46).EQ.0) THEN
+       SHIFT_PID = 1
+      ELSE
+       SHIFT_PID = 0
+      ENDIF
+      I_AM_SLAVE = (MYID.NE.0.OR.KEEP(46).EQ.1)
+      OneMPI     = NPROCS.EQ.1 
+      IF ( OneMPI.OR. 
+     &     (KEEP(54).EQ.0.AND.(MYID.NE.MPI_MASTER)) 
+     &   ) THEN
+        MPI_InvolvedinSend = .FALSE.  
+        MPI_End_Send       = .TRUE.
+      ELSE
+        MPI_InvolvedinSend = .TRUE.   
+        MPI_End_Send       = .FALSE.
+      ENDIF
+      IF (.NOT.OneMPI) THEN
+        ALLOCATE( 
+     &    BUFSENDI(NBRECORDS * 2 + 1, 2, NPROCS),  
+     &    BUFSENDR(NBRECORDS, 2, NPROCS),
+     &    IACT(NPROCS), SEND_ACTIVE(NPROCS), 
+     &    ISENDREQI(NPROCS), ISENDREQR(NPROCS),
+     &    BUFSEND_POSRESERVED(2, NPROCS),
+     &    stat=allocok)
+        IF ( allocok .GT. 0 ) THEN
+          IF ( LPOK ) THEN
+            WRITE(LP,*)
+     &     '** Error allocating SEND buffers for matrix distribution'
+          END IF
+          INFO(1) = -13
+          INFO(2) =  ( NBRECORDS * 2 + 1 ) * NPROCS * 2 +
+     &             NBRECORDS * NPROCS * 2 + 
+     &             NPROCS*6
+          GOTO 20
+        END IF
+        DO ISLAVE_MAIN=1, NPROCS
+          IACT (ISLAVE_MAIN)         = 1
+          ISENDREQI(ISLAVE_MAIN) = MPI_REQUEST_NULL
+          ISENDREQR(ISLAVE_MAIN) = MPI_REQUEST_NULL
+          BUFSENDI(1, 1, ISLAVE_MAIN)       = 0
+          BUFSEND_POSRESERVED(1,ISLAVE_MAIN)= 0
+          BUFSENDI(1, 2, ISLAVE_MAIN)       = NBRECORDS  
+          BUFSEND_POSRESERVED(2,ISLAVE_MAIN)= NBRECORDS
+          SEND_ACTIVE(ISLAVE_MAIN)   =  .FALSE.
+        ENDDO
+      ENDIF
+      IF (OneMPI.OR. 
+     &    (KEEP(54).EQ.0.AND.(MYID.EQ.MPI_MASTER))
+     &   ) THEN
+        NB_END_MSG_2_RECV  = 0
+        MPI_InvolvedinRecv = .FALSE. 
+        End_TreatRecvBuf   = .TRUE.
+      ELSE IF (KEEP(54).EQ.0.AND.MYID.NE.MPI_MASTER) THEN
+        NB_END_MSG_2_RECV  =  1
+        MPI_InvolvedinRecv = .TRUE.  
+        End_TreatRecvBuf   = .FALSE.
+      ELSE
+        NB_END_MSG_2_RECV  = NPROCS-1
+        MPI_InvolvedinRecv = .TRUE.  
+        End_TreatRecvBuf   = .FALSE.
+      ENDIF
+      IF (.NOT.OneMPI) THEN
+        ALLOCATE( 
+     &  BUFRECVI(NBRECORDS * 2 + 1, NPROCS),
+     &  BUFRECVR(NBRECORDS, NPROCS),
+     &  IRECVREQI(NPROCS), IRECVREQR(NPROCS), 
+     &  RECV_BUF_STATUS(NPROCS),
+     &            stat=allocok)
+        IF ( allocok .GT. 0 ) THEN
+           IF ( LPOK ) THEN
+             WRITE(LP,*)
+     &      '** Error allocating RECV buffers for matrix distribution'
+           END IF
+           INFO(1) = -13
+           INFO(2) =  ( NBRECORDS * 2 + 1 ) * NPROCS +
+     &              NBRECORDS * NPROCS  +      
+     &              NPROCS*3
+           GOTO 20
+        ENDIF
+        BUFRECVI(1, 1:NPROCS) = 0
+        IRECVREQI(1:NPROCS)   = MPI_REQUEST_NULL
+        IRECVREQR(1:NPROCS)   = MPI_REQUEST_NULL
+        RECV_BUF_STATUS (1:NPROCS)= Processed_IrecNeeded
+        RECV_BUF_STATUS (MYID+1)  = Processed_IrecNotneeded
+        IF (KEEP(54).EQ.0) THEN
+         DO ISLAVE_MAIN=1, NPROCS
+           RECV_BUF_STATUS (ISLAVE_MAIN)= Processed_IrecNotneeded
+         ENDDO
+         IF (MYID.NE.MPI_MASTER) THEN
+           RECV_BUF_STATUS(MPI_MASTER+1)  = Processed_IrecNeeded
+         ENDIF
+        ENDIF
+      ENDIF
+      ALLOCATE( IW4( N, 2 ), stat = allocok )
+      IF ( allocok .GT. 0 ) THEN
+        WRITE(LP,*) '** Error allocating IW4 for matrix distribution'
+        INFO(1) = -13
+        CALL MUMPS_SET_IERROR( int(N,8) * 2_8, INFO(2) )
+        GOTO 20
+      END IF
+      ALLOCATE( PTRAW( N ), stat = allocok )
+      IF ( allocok .GT. 0 ) THEN
+        WRITE(LP,*) '** Error allocating IW4 for matrix distribution'
+        INFO(1) = -13
+        CALL MUMPS_SET_IERROR( int(N,8) * KEEP(10), INFO(2) )
+        GOTO 20
+      END IF
+ 20   CONTINUE
+      CALL MUMPS_PROPINFO( ICNTL, INFO, COMM, MYID )
+      IF ( INFO(1) .LT. 0 ) GOTO 100
+      ARROW_ROOT = 0
+      EARLYT3ROOTINS = KEEP(200) .EQ.0
+     &        .OR.  ( KEEP(200) .LT. 0 .AND. KEEP(400) .EQ. 0 )
+      IF (I_AM_SLAVE) THEN
+       DO JMAIN = 1, N
+        ISTEP=STEP(JMAIN)
+        IF (ISTEP .GT. 0) THEN
+          IARR1 = PTRDEBARR( ISTEP )
+          IF ( IARR1 .GT. 0 ) THEN
+            IMAIN = JMAIN
+            IORG = 0
+            DO WHILE ( IMAIN .GT. 0 )
+              IORG = IORG + 1
+              IW4(IMAIN, 1)  = NINCOLARR( IARR1 + IORG - 1 )
+              IW4(IMAIN, 2)  = NINROWARR( IARR1 + IORG - 1 ) +
+     &                     NINCOLARR( IARR1 + IORG - 1 )
+              IS8MAIN        = PTR8ARR( IARR1 + IORG - 1 )
+              PTRAW( IMAIN ) = IS8MAIN
+              INTARR( IS8MAIN ) = IMAIN
+              DBLARR( IS8MAIN ) = ZERO
+              IMAIN = FILS(IMAIN)
+            ENDDO
+          ENDIF
+        ENDIF
+       ENDDO
+       IF ( KEEP(38) .NE. 0 .AND. EARLYT3ROOTINS ) THEN
+         CALL SMUMPS_GET_ROOT_INFO(root,LOCAL_M, LOCAL_N, PTR_ROOT, LA)
+         CALL SMUMPS_SET_ROOT_TO_ZERO(root, KEEP, S, LA)
+       ELSE
+         LOCAL_M = -19999; LOCAL_N = -29999; PTR_ROOT = -99999_8
+       END IF
+      ELSE 
+         LOCAL_M = -19999; LOCAL_N = -29999; PTR_ROOT = -99999_8
+      ENDIF
+      NOMP=1
+!$    NOMP=omp_get_max_threads()
+      NOMP_MAX = NOMP
+      IF (NOMP_MAX.GT.2.AND.KEEP(399).EQ.2) THEN
+       IF (.NOT.OneMPI) THEN
+        NOMP_MAX = 2
+       ENDIF
+      ENDIF
+      IF (NOMP_MAX.GT.3.AND.KEEP(399).EQ.3) THEN
+       IF (.NOT.OneMPI) THEN
+        NOMP_MAX = 3
+       ENDIF
+      ENDIF
+      ILOC8      = 1_8  
+      OMP_FLAG   = ((NOMP .GE.2).AND.(KEEP(399).NE.99))
+      FINISHED = .FALSE.
+      NOMP_SHARED = 1
+!$OMP PARALLEL 
+!$OMP&  NUM_THREADS(NOMP_MAX)
+!$OMP&    PRIVATE(
+!$OMP&         IOMP, ThWorking, ILOC8_P, NB_RANGE_P,
+!$OMP&         NOTHINGTOARRANGE_P, EndNZloc_P, TH_InvolvedinComm,
+!$OMP&         TH_InvolvedinTreatRecv,  TH_InvolvedinArrange )
+!$OMP& REDUCTION(+:NSEND8, NLOCAL8, ARROW_ROOT) 
+!$OMP& IF (OMP_FLAG)
+      IOMP        = 0
+!$    IOMP=omp_get_thread_num()
+!$OMP SINGLE
+!$      NOMP_SHARED= omp_get_num_threads()  
+        IF (OneMPI) THEN
+         EndNZloc = NOMP_SHARED
+        ELSE
+         EndNZloc = max(1,NOMP_SHARED -1)
+         IF ( KEEP(399).EQ.2.OR.KEEP(399).EQ.3 ) THEN
+          EndNZloc = min(EndNZloc,1)
+         ENDIF
+        ENDIF
+        IF (NZ_loc8.EQ.0_8) EndNZloc = 0  
+        IF (.NOT.MPI_InvolvedinSend.AND.(EndNZloc.EQ.0)) EndNZloc=-1
+        NO_ATOMIC_Wsendbuf = ( NOMP_SHARED.EQ.1 )
+        NO_ATOMIC_Warrow   = ( NOMP_SHARED.EQ.1 )
+        IF (NPROCS.GT.1) THEN
+          NO_ATOMIC_Warrow = (NOMP_SHARED.LE.2)
+          IF ( KEEP(399).EQ.2 .OR. KEEP(399).EQ.3) THEN
+           NO_ATOMIC_Wsendbuf =  .TRUE.
+           IF (.NOT.MPI_InvolvedinSend) NO_ATOMIC_Warrow=.TRUE.
+           IF (.NOT.MPI_InvolvedinRecv) NO_ATOMIC_Warrow=.TRUE.
+          ENDIF
+        ENDIF
+!$OMP END SINGLE
+      ThWorking          =  OneMPI.OR.
+     &                     (NOMP_SHARED.EQ.1) .OR. (IOMP.NE.0)
+      TH_InvolvedinTreatRecv = (MPI_InvolvedinRecv.AND.ThWorking)
+      IF ( TH_InvolvedinTreatRecv.AND.
+     &     (NOMP_SHARED.EQ.3).AND.(KEEP(399).EQ.3) ) THEN
+          IF (IOMP.NE.2) TH_InvolvedinTreatRecv = .FALSE.
+      ENDIF
+      TH_InvolvedinArrange = ThWorking
+      IF (.NOT.OneMPI.AND.ThWorking) THEN
+        IF (KEEP(399).EQ.2.OR.KEEP(399).EQ.3) 
+     &    THEN
+          IF ((NOMP_SHARED.NE.1).AND.(IOMP.NE.1)) 
+     &       TH_InvolvedinArrange = .FALSE.
+        ENDIF
+      ENDIF
+      TH_InvolvedinComm  = ((.NOT.OneMPI).AND.(IOMP.EQ.0))
+      NOTHINGTOARRANGE_P = (NZ_loc8.EQ.0_8)
+      ILOC8_P            = 0_8
+       DO WHILE ( .NOT.FINISHED )
+          IF (TH_InvolvedinComm) THEN
+            CALL SMUMPS_ARROW_TRY_PROGRESS_COMM ( IOMP, MYID,
+     &       NPROCS, NBRECORDS, MPI_InvolvedinSend, MPI_InvolvedinRecv, 
+     &       COMM, ISENDREQI, ISENDREQR, BUFSENDI, BUFSENDR, 
+     &       IACT, SEND_ACTIVE, BUFSEND_POSRESERVED, 
+     &       IRECVREQI, IRECVREQR, BUFRECVI, BUFRECVR,
+     &       RECV_BUF_STATUS, NB_END_MSG_2_RECV, 
+     &       EndNZloc, MPI_End_Send, End_TreatRecvBuf
+     &        )
+          ENDIF
+          IF (.NOT.ThWorking) THEN
+            CALL MUMPS_USLEEP(20)
+            GOTO  50
+          ENDIF
+          IF (TH_InvolvedinTreatRecv) THEN
+            CALL SMUMPS_ARROW_TRY_TREAT_RECV_BUF ( IOMP,
+     &             BUFRECVI, BUFRECVR, RECV_BUF_STATUS, 
+     &             NPROCS, NBRECORDS, N, IW4,
+     &             KEEP, LOCAL_M, LOCAL_N, root, PTR_ROOT, S, LA,
+     &             NB_END_MSG_2_RECV, MYID, PROCNODE_STEPS,
+     &             SLAVEF,
+     &             PTRAW, 
+     &             PTR8ARR, NINCOLARR, NINROWARR, PTRDEBARR,
+     &             PERM, STEP,
+     &             INTARR, LINTARR, DBLARR, LDBLARR, 
+     &             NOMP_SHARED, EARLYT3ROOTINS, NO_ATOMIC_Warrow )
+            IF (NOMP_SHARED.EQ.1) THEN
+              CALL SMUMPS_ARROW_TRY_PROGRESS_COMM ( IOMP, MYID,
+     &        NPROCS, NBRECORDS, 
+     &        MPI_InvolvedinSend, MPI_InvolvedinRecv,
+     &        COMM, ISENDREQI, ISENDREQR, BUFSENDI, BUFSENDR, 
+     &        IACT, SEND_ACTIVE, BUFSEND_POSRESERVED, 
+     &        IRECVREQI, IRECVREQR, BUFRECVI, BUFRECVR,
+     &        RECV_BUF_STATUS, NB_END_MSG_2_RECV, 
+     &        EndNZloc, MPI_End_Send, End_TreatRecvBuf
+     &        )
+            ENDIF
+          ENDIF
+          IF (.NOT. NOTHINGTOARRANGE_P.AND.TH_InvolvedinArrange) THEN
+!$OMP ATOMIC CAPTURE
+            ILOC8_P = ILOC8
+            ILOC8   = ILOC8 + NB_RANGE_8
+!$OMP END ATOMIC 
+            IF (ILOC8_P.LE.NZ_loc8) THEN
+              NB_RANGE_P = int(min(NB_RANGE_8, NZ_loc8-ILOC8_P+1))
+              CALL SMUMPS_FAC_ARROW_ARRANGE ( MYID, IOMP, N, SHIFT_PID,
+     &   SLAVEF, LSCAL, NSEND8, NLOCAL8, ILOC8_P, NB_RANGE_P, 
+     &   NZ_loc8, IRN_LOC, JCN_LOC, A_loc, SIZESCAL, ROWSCA, COLSCA,
+     &   ISTEP_TO_INIV2, CANDIDATES, KEEP, MPI_MASTER, NO_ATOMIC_Warrow,
+     &   NO_ATOMIC_Wsendbuf, TH_InvolvedinTreatRecv,
+     &   NPROCS, NBRECORDS, MPI_InvolvedinSend, MPI_InvolvedinRecv, 
+     &   COMM, ISENDREQI, ISENDREQR, BUFSENDI, BUFSENDR, IACT,
+     &   SEND_ACTIVE, BUFSEND_POSRESERVED, IRECVREQI, IRECVREQR,
+     &   BUFRECVI, BUFRECVR, RECV_BUF_STATUS, EndNZloc, MPI_End_Send,
+     &   End_TreatRecvBuf,
+     &   root, PTR_ROOT, ARROW_ROOT, EARLYT3ROOTINS, LOCAL_M, LOCAL_N,
+     &   S, LA, NB_END_MSG_2_RECV, PROCNODE_STEPS, IW4, PTRAW, PTR8ARR,
+     &   NINCOLARR, NINROWARR, PTRDEBARR, PERM, STEP, INTARR, LINTARR,
+     &   DBLARR, LDBLARR, NOMP_SHARED )
+            ENDIF
+            IF (ILOC8_P+NB_RANGE_8.GT.NZ_loc8) THEN
+              IF (.NOT. NOTHINGTOARRANGE_P) THEN
+               NOTHINGTOARRANGE_P=.TRUE. 
+!$OMP          ATOMIC CAPTURE
+               EndNZloc   = EndNZloc-1
+               EndNZloc_P = EndNZloc
+!$OMP          END ATOMIC
+               IF (MPI_End_Send.AND.EndNZloc_P.EQ.0) THEN
+!$OMP           ATOMIC WRITE
+                EndNZloc=-1
+!$OMP           END ATOMIC
+               ENDIF
+              ENDIF
+            ENDIF
+          ENDIF
+  50      CONTINUE  
+!$OMP     MASTER
+!$OMP     ATOMIC WRITE
+          FINISHED = ( (EndNZloc.EQ.-1) 
+     &            .AND.(MPI_End_Send.OR.(.not.MPI_InvolvedinSend))
+     &            .AND. End_TreatRecvBuf
+     &               )
+!$OMP     END ATOMIC
+!$OMP     END MASTER
+       ENDDO
+!$OMP END PARALLEL
+!$OMP PARALLEL DO SCHEDULE(DYNAMIC,1)
+!$OMP&         PRIVATE(ISTEP, TYPE_NODE_P, MASTER_NODE_P, NBJ_P, 
+!$OMP&                 IARR1, IS8_P  )
+!$OMP&        IF (OMP_FLAG)
+      DO ISTEP=1, KEEP(28)
+        CALL MUMPS_TYPEANDPROCNODE( TYPE_NODE_P, MASTER_NODE_P,
+     &    PROCNODE_STEPS(ISTEP), KEEP(199) )
+        MASTER_NODE_P = MASTER_NODE_P + SHIFT_PID
+        IF ( MASTER_NODE_P.NE.MYID.OR.
+     &      (  (TYPE_NODE_P.NE.1) .AND. (TYPE_NODE_P.NE.2) )
+     &     ) CYCLE
+        IARR1  = PTRDEBARR( ISTEP )
+        NBJ_P  = NINCOLARR( IARR1)
+        IF (NBJ_P.LE.0) CYCLE
+        IS8_P  = PTR8ARR( IARR1) + 1_8
+        CALL SMUMPS_QUICK_SORT_ARROWHEADS( N, PERM,
+     &              INTARR( IS8_P ),
+     &              DBLARR( IS8_P ),
+     &              NBJ_P, 1, NBJ_P )
+      ENDDO
+!$OMP END PARALLEL DO
+ 100  CONTINUE
+      IF (ALLOCATED(IW4))         DEALLOCATE( IW4 )
+      IF (ALLOCATED(PTRAW))       DEALLOCATE( PTRAW )
+      IF (ALLOCATED(BUFSENDI))    DEALLOCATE( BUFSENDI )
+      IF (ALLOCATED(BUFSENDR))    DEALLOCATE( BUFSENDR )
+      IF (ALLOCATED(BUFRECVI))    DEALLOCATE( BUFRECVI )
+      IF (ALLOCATED(BUFRECVR))    DEALLOCATE( BUFRECVR )
+      IF (ALLOCATED(IACT))        DEALLOCATE( IACT )
+      IF (ALLOCATED(ISENDREQI))   DEALLOCATE( ISENDREQI )
+      IF (ALLOCATED(ISENDREQR))   DEALLOCATE( ISENDREQR )
+      IF (ALLOCATED(IRECVREQI))   DEALLOCATE( IRECVREQI )
+      IF (ALLOCATED(IRECVREQR))   DEALLOCATE( IRECVREQR )
+      IF (ALLOCATED(SEND_ACTIVE)) DEALLOCATE( SEND_ACTIVE )
+      IF (ALLOCATED(BUFSEND_POSRESERVED))   
+     &                      DEALLOCATE( BUFSEND_POSRESERVED )
+      IF (ALLOCATED(RECV_BUF_STATUS)) DEALLOCATE( RECV_BUF_STATUS )
+      RETURN
+      END SUBROUTINE SMUMPS_FAC_DIST_ARROWHEADS_OMP 
+      SUBROUTINE SMUMPS_ARROW_TRY_PROGRESS_COMM ( IOMP, MYID,
+     &     NPROCS, NBRECORDS, MPI_InvolvedinSend, MPI_InvolvedinRecv,
+     &     COMM, ISENDREQI, ISENDREQR, BUFSENDI, BUFSENDR, 
+     &     IACT, SEND_ACTIVE, BUFSEND_POSRESERVED, 
+     &     IRECVREQI, IRECVREQR, BUFRECVI, BUFRECVR,
+     &     RECV_BUF_STATUS, NB_END_MSG_2_RECV, 
+     &     EndNZloc, MPI_End_Send, End_TreatRecvBuf
+     &        )
+      IMPLICIT NONE
+      INTEGER, INTENT(IN) :: IOMP, MYID, NPROCS, NBRECORDS, COMM
+      LOGICAL, INTENT(IN) :: MPI_InvolvedinSend, MPI_InvolvedinRecv
+      INTEGER, INTENT(IN) :: NB_END_MSG_2_RECV
+      INTEGER, INTENT(INOUT) :: EndNZloc
+      LOGICAL, INTENT(INOUT) :: MPI_End_Send, End_TreatRecvBuf
+      INTEGER, INTENT(INOUT) :: 
+     &     ISENDREQI(NPROCS), ISENDREQR(NPROCS), 
+     &     BUFSENDI(NBRECORDS * 2 + 1, 2, NPROCS), 
+     &     IACT(NPROCS), BUFSEND_POSRESERVED(2,NPROCS)
+      REAL, INTENT(INOUT) :: BUFSENDR(NBRECORDS, 2, NPROCS)
+      LOGICAL, INTENT(INOUT) :: SEND_ACTIVE(NPROCS)
+      INTEGER, INTENT(INOUT) :: 
+     &     IRECVREQI(NPROCS), IRECVREQR(NPROCS), 
+     &     BUFRECVI(NBRECORDS * 2 + 1, NPROCS),
+     &     RECV_BUF_STATUS(NPROCS)
+      REAL, INTENT(INOUT) ::  BUFRECVR(NBRECORDS, NPROCS)
+         INTEGER, PARAMETER :: Processed_IrecNeeded          = 1
+         INTEGER, PARAMETER :: IrecPosted                    = 2
+         INTEGER, PARAMETER :: Received_NotProcessed         = 3
+         INTEGER, PARAMETER :: Processed_IrecNotneeded       = 4
+         INTEGER, PARAMETER :: Treating                      = 5
+      INCLUDE 'mumps_tags.h'
+      INCLUDE 'mpif.h'
+      INTEGER :: EndNZloc_copy, ISLAVE, NBREC, STATE, 
+     &           NB_END_MSG_2_RECV_COPY, ISLAVE_RECV 
+      INTEGER :: IERR, IACT_P, NEXT_IACT
+      INTEGER :: TAILLE_SEND_I, TAILLE_SEND_R
+      LOGICAL :: FLAG, FLAGRECV, ALL_LAST_MESS_SENT
+      INTEGER :: STATUS(MPI_STATUS_SIZE)
+      IF (MPI_InvolvedinSend.and.(.NOT.MPI_End_Send)) THEN
+        DO ISLAVE = 1, NPROCS
+          IF (ISLAVE-1.EQ.MYID) CYCLE
+          IF (SEND_ACTIVE( ISLAVE )) THEN
+              CALL MPI_TEST( ISENDREQR( ISLAVE ), FLAG, STATUS, IERR )
+              IF (FLAG) THEN
+                CALL MPI_WAIT( ISENDREQI( ISLAVE ), STATUS, IERR )
+                SEND_ACTIVE( ISLAVE ) = .FALSE.
+              ENDIF
+          ENDIF
+        ENDDO
+!$OMP   ATOMIC READ
+        EndNZloc_copy = EndNZloc
+!$OMP   END ATOMIC 
+        ALL_LAST_MESS_SENT = (EndNZloc_copy.EQ.0)
+        IF (EndNZloc_copy.NE.-1) THEN
+          DO ISLAVE=1, NPROCS
+            IF (ISLAVE-1.EQ.MYID) CYCLE
+            IF (EndNZloc_copy .EQ. 0) THEN
+             NBREC = 
+     &         min(BUFSEND_POSRESERVED(IACT(ISLAVE),ISLAVE),NBRECORDS)
+             IF (NBREC.EQ.-99) CYCLE
+             BUFSENDI(1,IACT(ISLAVE),ISLAVE) = - NBREC
+            ELSE
+!$OMP         ATOMIC READ
+              NBREC = BUFSENDI(1,IACT(ISLAVE),ISLAVE)
+!$OMP         END ATOMIC
+            ENDIF
+            IF ((EndNZloc_copy.EQ.0).OR.(NBREC.EQ.NBRECORDS)) THEN
+              IF (.NOT.SEND_ACTIVE(ISLAVE)) THEN
+                TAILLE_SEND_I = NBREC * 2 + 1
+                TAILLE_SEND_R = NBREC
+                IACT_P = IACT(ISLAVE)
+                CALL MPI_ISEND( BUFSENDI(1, IACT_P, ISLAVE ),
+     &              TAILLE_SEND_I,
+     &              MPI_INTEGER, ISLAVE - 1, 
+     &              ARR_INT, COMM,
+     &              ISENDREQI( ISLAVE ), IERR )
+                CALL MPI_ISEND( BUFSENDR(1, IACT_P, ISLAVE ),
+     &              TAILLE_SEND_R,
+     &              MPI_REAL, ISLAVE - 1, 
+     &              ARR_REAL, COMM,
+     &              ISENDREQR( ISLAVE ), IERR )
+                SEND_ACTIVE( ISLAVE ) = .TRUE.
+                IF (EndNZloc_copy.NE.0) THEN
+                  NEXT_IACT = 3-IACT_P
+!$OMP             ATOMIC WRITE
+                  BUFSEND_POSRESERVED(NEXT_IACT,ISLAVE) = 0
+!$OMP             END ATOMIC
+!$OMP             ATOMIC WRITE
+                  BUFSENDI(1,NEXT_IACT,ISLAVE) = 0
+!$OMP             END ATOMIC
+!$OMP             ATOMIC WRITE
+                  IACT( ISLAVE ) = NEXT_IACT
+!$OMP             END ATOMIC
+                ELSE
+                  BUFSEND_POSRESERVED(IACT_P,ISLAVE) = -99
+                ENDIF
+              ELSE
+                ALL_LAST_MESS_SENT=.FALSE.
+              ENDIF
+            ENDIF
+          ENDDO
+        ENDIF
+        IF (EndNZloc_copy.EQ.0.AND.ALL_LAST_MESS_SENT) THEN 
+            EndNZloc      = -1  
+            EndNZloc_copy = -1  
+        ENDIF
+        IF (.NOT.MPI_End_Send) THEN
+          IF ( (EndNZloc_copy.EQ.-1) )  THEN
+            MPI_End_Send = .TRUE.
+            DO ISLAVE = 1, NPROCS
+               IF (ISLAVE-1.EQ.MYID) CYCLE
+               IF (SEND_ACTIVE( ISLAVE )) THEN 
+                 MPI_End_Send=.FALSE.
+                 EXIT
+               ENDIF
+            ENDDO
+          ENDIF
+        ENDIF
+      ENDIF
+      IF (MPI_InvolvedinRecv.AND.(.NOT.End_TreatRecvBuf)) THEN
+        CALL MPI_TESTANY(NPROCS, IRECVREQR, ISLAVE_RECV, 
+     &                   FLAGRECV, STATUS,IERR)
+        IF (FLAGRECV.AND.(ISLAVE_RECV.NE.MPI_UNDEFINED)) 
+     &            THEN
+            CALL MPI_WAIT(IRECVREQI(ISLAVE_RECV),STATUS,IERR)
+!$OMP       ATOMIC WRITE
+            RECV_BUF_STATUS(ISLAVE_RECV)=Received_NotProcessed
+!$OMP       END ATOMIC
+        ENDIF
+        DO  ISLAVE = 1, NPROCS
+          IF (ISLAVE - 1 .EQ. MYID) CYCLE
+!$OMP     ATOMIC READ
+          STATE = RECV_BUF_STATUS(ISLAVE)
+!$OMP     END ATOMIC
+          IF (STATE.EQ.Processed_IrecNeeded) THEN
+            CALL MPI_IRECV ( BUFRECVI(1,ISLAVE), NBRECORDS * 2 + 1,  
+     &              MPI_INTEGER, ISLAVE-1, ARR_INT, COMM, 
+     &              IRECVREQI(ISLAVE), IERR)
+            CALL MPI_IRECV ( BUFRECVR(1,ISLAVE), NBRECORDS,
+     &              MPI_REAL, ISLAVE-1, 
+     &              ARR_REAL, COMM,
+     &              IRECVREQR(ISLAVE), IERR)
+!$OMP       ATOMIC WRITE
+            RECV_BUF_STATUS(ISLAVE) = IrecPosted
+!$OMP       END ATOMIC
+          ENDIF
+        ENDDO
+!$OMP   ATOMIC READ
+        NB_END_MSG_2_RECV_COPY = NB_END_MSG_2_RECV
+!$OMP   END ATOMIC
+        IF (NB_END_MSG_2_RECV_COPY.EQ.0) THEN
+          End_TreatRecvBuf = .TRUE.
+          DO ISLAVE = 1, NPROCS
+            IF (ISLAVE - 1 .EQ. MYID) CYCLE
+            IF (RECV_BUF_STATUS(ISLAVE).NE.Processed_IrecNotneeded) THEN
+               End_TreatRecvBuf = .FALSE.
+               EXIT
+            ENDIF
+          ENDDO
+        ENDIF
+      ENDIF
+      RETURN
+      END SUBROUTINE SMUMPS_ARROW_TRY_PROGRESS_COMM 
+      SUBROUTINE SMUMPS_ARROW_TRY_TREAT_RECV_BUF (IOMP,
+     &             BUFRECVI, BUFRECVR, RECV_BUF_STATUS, 
+     &             NPROCS, NBRECORDS, N, IW4,
+     &             KEEP, LOCAL_M, LOCAL_N, root, PTR_ROOT, S, LA,
+     &             NB_END_MSG_2_RECV, MYID, PROCNODE_STEPS,
+     &             SLAVEF,
+     &             PTRAW, 
+     &             PTR8ARR, NINCOLARR, NINROWARR, PTRDEBARR,
+     &             PERM, STEP,
+     &             INTARR, LINTARR, DBLARR, LDBLARR, 
+     &             NOMP_SHARED, EARLYT3ROOTINS, NO_ATOMIC_Warrow )
+      USE SMUMPS_STRUC_DEF, ONLY : SMUMPS_ROOT_STRUC
+      IMPLICIT NONE
+      TYPE (SMUMPS_ROOT_STRUC) :: root
+      INTEGER, INTENT(IN):: IOMP, NPROCS, NBRECORDS, N, MYID, SLAVEF,
+     &                      NOMP_SHARED
+      LOGICAL, INTENT(IN):: EARLYT3ROOTINS
+      INTEGER, INTENT(IN):: BUFRECVI( NBRECORDS * 2 + 1, NPROCS )
+      REAL, INTENT(IN):: BUFRECVR( NBRECORDS, NPROCS )
+      INTEGER, INTENT(INOUT) :: RECV_BUF_STATUS(NPROCS)
+      INTEGER, INTENT(INOUT):: IW4( N, 2 )
+      INTEGER, INTENT(IN):: KEEP(500)
+      INTEGER, INTENT(INOUT):: NB_END_MSG_2_RECV
+      INTEGER(8), INTENT(IN) :: PTRAW( N )
+      INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
+      INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
+      INTEGER, INTENT(IN) :: NINROWARR(KEEP(195))
+      INTEGER, INTENT(IN) :: PTRDEBARR(KEEP(196))
+      INTEGER, INTENT(IN) :: PERM( N ), STEP( N )
+      INTEGER, INTENT(IN) :: PROCNODE_STEPS( KEEP(28) )
+      INTEGER(8), INTENT(IN) :: LINTARR, LDBLARR
+      INTEGER, INTENT(INOUT) ::  INTARR( LINTARR )
+      INTEGER, INTENT(IN)::  LOCAL_M, LOCAL_N
+      INTEGER(8), INTENT(IN) :: PTR_ROOT, LA
+      REAL, INTENT(INOUT) :: S( LA ), DBLARR( LDBLARR )
+      LOGICAL, INTENT(IN)    :: NO_ATOMIC_Warrow
+         INTEGER, PARAMETER :: Processed_IrecNeeded          = 1
+         INTEGER, PARAMETER :: IrecPosted                    = 2
+         INTEGER, PARAMETER :: Received_NotProcessed         = 3
+         INTEGER, PARAMETER :: Processed_IrecNotneeded       = 4
+         INTEGER, PARAMETER :: Treating                      = 5
+         INTEGER, PARAMETER :: BeingTreatednotbyme           = 6
+      INTEGER MUMPS_TYPENODE
+      EXTERNAL MUMPS_TYPENODE
+      INTEGER STATE, ISLAVE
+      DO ISLAVE =1, NPROCS
+         IF (MYID.EQ.ISLAVE-1) CYCLE
+!$OMP    ATOMIC READ
+         STATE = RECV_BUF_STATUS(ISLAVE)
+!$OMP    END ATOMIC
+         IF (STATE.EQ.Treating) CYCLE
+         IF (STATE.EQ.Received_NotProcessed) THEN
+          IF (NOMP_SHARED.EQ.1) THEN
+            RECV_BUF_STATUS(ISLAVE) = Treating
+            STATE                   = Treating
+          ELSE IF (KEEP(399).LE.3) THEN
+!$OMP       ATOMIC WRITE
+            RECV_BUF_STATUS(ISLAVE) = Treating
+!$OMP       END ATOMIC
+            STATE                   = Treating
+          ELSE
+!$OMP      CRITICAL(ARROW_RECV_BUF_STATUS)
+!$OMP        ATOMIC READ
+             STATE = RECV_BUF_STATUS(ISLAVE)
+!$OMP        END ATOMIC
+             IF (STATE.EQ.Received_NotProcessed) THEN
+!$OMP          ATOMIC WRITE
+               RECV_BUF_STATUS(ISLAVE) = Treating
+!$OMP          END ATOMIC 
+               STATE                   = Treating
+             ELSE
+               STATE                   = BeingTreatednotbyme
+             ENDIF
+!$OMP      END CRITICAL(ARROW_ RECV_BUF_STATUS)
+          ENDIF
+         ENDIF
+        IF (STATE.NE.Treating) CYCLE
+        IF (NO_ATOMIC_Warrow) THEN
+          CALL SMUMPS_ARROW_TREAT_RECV_BUF_1TH()
+        ELSE
+          CALL SMUMPS_ARROW_TREAT_RECV_BUF()
+        ENDIF
+      ENDDO 
+      RETURN
+      CONTAINS
+      SUBROUTINE  SMUMPS_ARROW_TREAT_RECV_BUF()
+      INTEGER :: IREC, NB_REC, TYPE_NODE
+      INTEGER :: IPOSROOT, JPOSROOT, ILOCROOT, JLOCROOT
+      INTEGER(8) :: IS8
+      INTEGER    :: IARR, JARR, IW4_CAPTURED
+      INTEGER    :: NB_END_MSG_2_RECV_COPY
+      REAL    :: VAL
+      LOGICAL    :: LAST_MESSAGE
+      LAST_MESSAGE = .FALSE.
+      NB_REC = BUFRECVI( 1, ISLAVE )
+      TYPE_NODE = -998
+      IF ( NB_REC .LE. 0 ) THEN
+        LAST_MESSAGE = .TRUE.
+!$OMP ATOMIC CAPTURE
+        NB_END_MSG_2_RECV_COPY = NB_END_MSG_2_RECV
+        NB_END_MSG_2_RECV      = NB_END_MSG_2_RECV - 1   
+!$OMP END ATOMIC
+        NB_REC = - NB_REC
+      END IF
+      IF ( NB_REC .eq. 0 ) GOTO 100
+      DO IREC = 1, NB_REC
+        IARR = BUFRECVI( IREC * 2, ISLAVE )
+        JARR = BUFRECVI( IREC * 2 + 1, ISLAVE )
+        VAL  = BUFRECVR( IREC, ISLAVE )
+        IF (EARLYT3ROOTINS) THEN
+          TYPE_NODE = MUMPS_TYPENODE( 
+     &              PROCNODE_STEPS(abs(STEP(abs( IARR )))),
+     &              KEEP(199) )
+        ENDIF
+        IF ( TYPE_NODE .eq. 3 .AND. EARLYT3ROOTINS ) THEN
+          IF ( IARR .GT. 0 ) THEN
+            IPOSROOT = root%RG2L( IARR )
+            JPOSROOT = root%RG2L( JARR )
+          ELSE
+            IPOSROOT = root%RG2L( JARR )
+            JPOSROOT = root%RG2L( -IARR )
+          END IF
+          ILOCROOT = root%MBLOCK * ( ( IPOSROOT - 1 ) /
+     &                 ( root%MBLOCK * root%NPROW ) )
+     &               + mod( IPOSROOT - 1, root%MBLOCK ) + 1
+          JLOCROOT = root%NBLOCK * ( ( JPOSROOT - 1 ) /
+     &                 ( root%NBLOCK * root%NPCOL ) )
+     &               + mod( JPOSROOT - 1, root%NBLOCK ) + 1
+          IF (KEEP(60)==0) THEN
+!$OMP ATOMIC UPDATE
+            S( PTR_ROOT + int(JLOCROOT-1,8) * int(LOCAL_M,8)
+     &        + int(ILOCROOT-1,8)) =  S( PTR_ROOT
+     &        + int(JLOCROOT - 1,8) * int(LOCAL_M,8)
+     &        + int(ILOCROOT - 1,8) )
+     &      + VAL
+!$OMP END ATOMIC
+          ELSE
+!$OMP ATOMIC UPDATE
+            root%SCHUR_POINTER( int(JLOCROOT-1,8)
+     &                      * int(root%SCHUR_LLD,8)
+     &                      + int(ILOCROOT,8) )
+     &      = root%SCHUR_POINTER( int(JLOCROOT - 1,8)
+     &                      * int(root%SCHUR_LLD,8)
+     &                      + int(ILOCROOT,8))
+     &      + VAL
+!$OMP END ATOMIC
+          ENDIF
+        ELSE IF (IARR.GE.0) THEN
+          IF (IARR.EQ.JARR) THEN
+            IS8 = PTRAW(IARR)
+!$OMP ATOMIC UPDATE
+            DBLARR(IS8) = DBLARR(IS8) + VAL
+!$OMP END ATOMIC
+          ELSE
+!$OMP ATOMIC CAPTURE
+            IW4_CAPTURED= IW4(IARR,2)
+            IW4(IARR,2) = IW4(IARR,2) - 1
+!$OMP END ATOMIC
+            IS8         = PTRAW(IARR)+int(IW4_CAPTURED,8)
+            INTARR(IS8) = JARR
+            DBLARR(IS8) = VAL
+          ENDIF
+        ELSE
+          IARR         = -IARR
+!$OMP ATOMIC CAPTURE
+          IW4_CAPTURED   = IW4(IARR,1)
+          IW4(IARR,1)    = IW4(IARR,1) - 1
+!$OMP END ATOMIC
+          IS8          = PTRAW(IARR) + int(IW4_CAPTURED,8)
+          INTARR(IS8)  = JARR
+          DBLARR(IS8)  = VAL
+        ENDIF
+      ENDDO
+ 100  CONTINUE
+      IF (LAST_MESSAGE) THEN
+!$OMP ATOMIC WRITE
+         RECV_BUF_STATUS(ISLAVE) = Processed_IrecNotneeded
+!$OMP END ATOMIC
+      ELSE
+!$OMP ATOMIC WRITE
+         RECV_BUF_STATUS(ISLAVE) = Processed_IrecNeeded
+!$OMP END ATOMIC
+      ENDIF
+      RETURN
+      END SUBROUTINE  SMUMPS_ARROW_TREAT_RECV_BUF
+      SUBROUTINE  SMUMPS_ARROW_TREAT_RECV_BUF_1TH()
+      INTEGER :: IREC, NB_REC, TYPE_NODE
+      INTEGER :: IPOSROOT, JPOSROOT, ILOCROOT, JLOCROOT
+      INTEGER(8) :: IS8
+      INTEGER    :: IARR, JARR
+      INTEGER    :: NB_END_MSG_2_RECV_COPY
+      REAL    :: VAL
+      LOGICAL    :: LAST_MESSAGE
+      LAST_MESSAGE = .FALSE.
+      NB_REC = BUFRECVI( 1, ISLAVE )
+      IF ( NB_REC .LE. 0 ) THEN
+        LAST_MESSAGE = .TRUE.
+!$OMP ATOMIC CAPTURE
+        NB_END_MSG_2_RECV_COPY = NB_END_MSG_2_RECV
+        NB_END_MSG_2_RECV      = NB_END_MSG_2_RECV - 1   
+!$OMP END ATOMIC
+        NB_REC = - NB_REC
+      END IF 
+      IF ( NB_REC .eq. 0 ) GOTO 100
+      DO IREC = 1, NB_REC
+        IARR = BUFRECVI( IREC * 2, ISLAVE )
+        JARR = BUFRECVI( IREC * 2 + 1, ISLAVE )
+        VAL  = BUFRECVR( IREC, ISLAVE )
+        IF (EARLYT3ROOTINS) THEN
+          TYPE_NODE = MUMPS_TYPENODE( 
+     &              PROCNODE_STEPS(abs(STEP(abs( IARR )))),
+     &              KEEP(199) )
+        ENDIF
+        IF ( TYPE_NODE .eq. 3 .AND. EARLYT3ROOTINS ) THEN
+          IF ( IARR .GT. 0 ) THEN
+            IPOSROOT = root%RG2L( IARR )
+            JPOSROOT = root%RG2L( JARR )
+          ELSE
+            IPOSROOT = root%RG2L( JARR )
+            JPOSROOT = root%RG2L( -IARR )
+          END IF
+          ILOCROOT = root%MBLOCK * ( ( IPOSROOT - 1 ) /
+     &                 ( root%MBLOCK * root%NPROW ) )
+     &               + mod( IPOSROOT - 1, root%MBLOCK ) + 1
+          JLOCROOT = root%NBLOCK * ( ( JPOSROOT - 1 ) /
+     &                 ( root%NBLOCK * root%NPCOL ) )
+     &               + mod( JPOSROOT - 1, root%NBLOCK ) + 1
+          IF (KEEP(60)==0) THEN
+            S( PTR_ROOT + int(JLOCROOT-1,8) * int(LOCAL_M,8)
+     &        + int(ILOCROOT-1,8)) =  S( PTR_ROOT
+     &        + int(JLOCROOT - 1,8) * int(LOCAL_M,8)
+     &        + int(ILOCROOT - 1,8) )
+     &      + VAL
+          ELSE
+            root%SCHUR_POINTER( int(JLOCROOT-1,8)
+     &                      * int(root%SCHUR_LLD,8)
+     &                      + int(ILOCROOT,8) )
+     &      = root%SCHUR_POINTER( int(JLOCROOT - 1,8)
+     &                      * int(root%SCHUR_LLD,8)
+     &                      + int(ILOCROOT,8))
+     &      + VAL
+          ENDIF
+        ELSE IF (IARR.GE.0) THEN
+          IF (IARR.EQ.JARR) THEN
+            IS8 = PTRAW(IARR)
+            DBLARR(IS8) = DBLARR(IS8) + VAL
+          ELSE
+            IS8         = PTRAW(IARR)+IW4(IARR,2)
+            IW4(IARR,2) = IW4(IARR,2) - 1
+            INTARR(IS8) = JARR
+            DBLARR(IS8) = VAL
+          ENDIF
+        ELSE
+          IARR         = -IARR
+          IS8          = PTRAW(IARR)+IW4(IARR,1)
+          IW4(IARR,1)  = IW4(IARR,1) - 1
+          INTARR(IS8)  = JARR
+          DBLARR(IS8)  = VAL
+        ENDIF
+      ENDDO
+ 100  CONTINUE
+      IF (LAST_MESSAGE) THEN
+!$OMP ATOMIC WRITE
+         RECV_BUF_STATUS(ISLAVE) = Processed_IrecNotneeded
+!$OMP END ATOMIC
+      ELSE
+!$OMP ATOMIC WRITE
+         RECV_BUF_STATUS(ISLAVE) = Processed_IrecNeeded
+!$OMP END ATOMIC
+      ENDIF
+      RETURN
+      END SUBROUTINE  SMUMPS_ARROW_TREAT_RECV_BUF_1TH
+      END SUBROUTINE SMUMPS_ARROW_TRY_TREAT_RECV_BUF 
+      SUBROUTINE SMUMPS_FAC_ARROW_ARRANGE ( 
+     &  MYID, IOMP, N, SHIFT_PID, SLAVEF, LSCAL, NSEND8, NLOCAL8,
+     &  ILOC8_P, NB_RANGE_P, NZ_loc8, IRN_LOC, JCN_LOC, A_loc, SIZESCAL,
+     &  ROWSCA, COLSCA, ISTEP_TO_INIV2, CANDIDATES, KEEP, MPI_MASTER, 
+     &  NO_ATOMIC_Warrow, NO_ATOMIC_Wsendbuf, TH_InvolvedinTreatRecv,
+     &  NPROCS, NBRECORDS, MPI_InvolvedinSend, MPI_InvolvedinRecv,
+     &  COMM, ISENDREQI, ISENDREQR, BUFSENDI, BUFSENDR, IACT,
+     &  SEND_ACTIVE, BUFSEND_POSRESERVED, IRECVREQI, IRECVREQR,
+     &  BUFRECVI, BUFRECVR, RECV_BUF_STATUS, EndNZloc, MPI_End_Send,
+     &  End_TreatRecvBuf,
+     &  root, PTR_ROOT, ARROW_ROOT, EARLYT3ROOTINS, LOCAL_M, LOCAL_N,
+     &  S, LA, NB_END_MSG_2_RECV, PROCNODE_STEPS, IW4, PTRAW, 
+     &  PTR8ARR, NINCOLARR, NINROWARR, PTRDEBARR,
+     &  PERM, STEP, INTARR, LINTARR, DBLARR, LDBLARR, NOMP_SHARED )
+!$    USE OMP_LIB
+      USE SMUMPS_STRUC_DEF, ONLY : SMUMPS_ROOT_STRUC
+      IMPLICIT NONE
+      INTEGER, INTENT(IN)      :: MYID, IOMP, N, SHIFT_PID, 
+     &                            SLAVEF, SIZESCAL, MPI_MASTER
+      INTEGER, INTENT(IN)      :: NB_RANGE_P, KEEP(500)
+      INTEGER(8), INTENT(IN)   :: NZ_loc8, ILOC8_P
+      INTEGER(8), INTENT(INOUT):: NSEND8, NLOCAL8
+      INTEGER, INTENT(IN)      :: IRN_LOC(max(1_8,NZ_loc8)), 
+     &                            JCN_LOC(max(1_8,NZ_loc8))
+      INTEGER, INTENT(IN):: ISTEP_TO_INIV2(KEEP(71))
+      INTEGER, INTENT(IN):: CANDIDATES(SLAVEF+1, max(1,KEEP(56)))
+      REAL, INTENT(IN):: A_loc(max(1_8,NZ_loc8))
+      REAL, INTENT(IN)   :: ROWSCA(SIZESCAL),
+     &                      COLSCA(SIZESCAL)
+      LOGICAL, INTENT(IN):: NO_ATOMIC_Warrow, NO_ATOMIC_Wsendbuf, 
+     &                      TH_InvolvedinTreatRecv
+      INTEGER, INTENT(IN) :: NPROCS, NBRECORDS, COMM, NOMP_SHARED
+      LOGICAL, INTENT(IN) :: MPI_InvolvedinSend, MPI_InvolvedinRecv, 
+     &                       LSCAL
+      INTEGER, INTENT(INOUT) :: EndNZloc
+      LOGICAL, INTENT(INOUT) :: MPI_End_Send, End_TreatRecvBuf
+      INTEGER, INTENT(INOUT) :: ISENDREQI(NPROCS), ISENDREQR(NPROCS), 
+     &     BUFSENDI(NBRECORDS * 2 + 1, 2, NPROCS), 
+     &     IACT(NPROCS), BUFSEND_POSRESERVED(2,NPROCS)
+      REAL, INTENT(INOUT) :: BUFSENDR(NBRECORDS, 2, NPROCS)
+      LOGICAL, INTENT(INOUT) :: SEND_ACTIVE(NPROCS)
+      INTEGER, INTENT(INOUT) :: IRECVREQI(NPROCS), IRECVREQR(NPROCS), 
+     &     BUFRECVI(NBRECORDS * 2 + 1, NPROCS),
+     &     RECV_BUF_STATUS(NPROCS)
+      REAL, INTENT(INOUT) :: BUFRECVR(NBRECORDS, NPROCS)
+         INTEGER, PARAMETER :: Processed_IrecNeeded          = 1
+         INTEGER, PARAMETER :: IrecPosted                    = 2
+         INTEGER, PARAMETER :: Received_NotProcessed         = 3
+         INTEGER, PARAMETER :: Processed_IrecNotneeded       = 4
+         INTEGER, PARAMETER :: Treating                      = 5
+      TYPE (SMUMPS_ROOT_STRUC) :: root
+      INTEGER, INTENT(IN)      :: LOCAL_M, LOCAL_N
+      LOGICAL, INTENT(IN)      :: EARLYT3ROOTINS
+      INTEGER, INTENT(INOUT)   :: ARROW_ROOT
+      INTEGER, INTENT(INOUT):: IW4( N, 2 )
+      INTEGER, INTENT(INOUT):: NB_END_MSG_2_RECV
+      INTEGER(8), INTENT(IN) :: PTRAW( N )
+      INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
+      INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
+      INTEGER, INTENT(IN) :: NINROWARR(KEEP(195))
+      INTEGER, INTENT(IN) :: PTRDEBARR(KEEP(196))
+      INTEGER, INTENT(IN) :: PERM( N ), STEP( N )
+      INTEGER, INTENT(IN) :: PROCNODE_STEPS( KEEP(28) )
+      INTEGER(8), INTENT(IN) :: LINTARR, LDBLARR
+      INTEGER, INTENT(INOUT) ::  INTARR( LINTARR )
+      INTEGER(8), INTENT(IN) :: PTR_ROOT, LA
+      REAL, INTENT(INOUT) ::  S( LA ), DBLARR( LDBLARR )
+      INTEGER MUMPS_TYPESPLIT
+      EXTERNAL MUMPS_TYPESPLIT
+      INTEGER     :: DEST, JSEND, ISEND , DEST_SAVE
+      INTEGER     :: I, INIV2, NCAND, T4MASTER
+      INTEGER     :: IOLD, JOLD, IARR, TYPESPLIT
+      INTEGER(8)  :: IS8, IZ8, LAST8
+      LOGICAL     :: T4_MASTER_CONCERNED
+      INTEGER     :: MASTER_NODE, TYPE_NODE, ISTEP_P
+      INTEGER     :: IPOSROOT, JPOSROOT, ILOCROOT, JLOCROOT
+      INTEGER     :: IROW_GRID, JCOL_GRID, IW4_CAPTURED
+      LOGICAL     :: LOCAL_ASSEMBLY, LOCAL
+      REAL     :: VAL
+      INTEGER     :: ISTEP_T3_1PROC
+      LAST8 = ILOC8_P + int(NB_RANGE_P-1,8)
+      LOCAL_ASSEMBLY  =  (NPROCS.EQ.1)
+      IF (NPROCS.EQ.1 .AND. KEEP(38).EQ.0) THEN
+        TYPE_NODE = 1
+        ISTEP_T3_1PROC  = -9999
+      ELSE IF (NPROCS.EQ.1 .AND. KEEP(38).NE.0) THEN
+        ISTEP_T3_1PROC = STEP(KEEP(38))
+      ELSE
+        ISTEP_T3_1PROC = -99999
+      ENDIF
+      DO IZ8=ILOC8_P, LAST8
+          IOLD = IRN_loc(IZ8)
+          JOLD = JCN_loc(IZ8)
+          IF ( (IOLD.GT.N).OR.(JOLD.GT.N).OR.(IOLD.LT.1)
+     &                 .OR.(JOLD.LT.1) ) THEN
+            CYCLE
+          ENDIF
+          IF (IOLD.EQ.JOLD) THEN
+            ISEND = IOLD
+            JSEND = IOLD
+            IARR  = IOLD
+          ELSE IF (PERM(IOLD).LT.PERM(JOLD)) THEN
+            IARR  = IOLD
+            IF ( KEEP(50) .NE. 0 ) THEN
+              ISEND = -IOLD
+            ELSE
+              ISEND = IOLD
+            ENDIF
+            JSEND = JOLD
+          ELSE
+            IARR  = JOLD
+            ISEND = -JOLD
+            JSEND = IOLD
+          ENDIF
+          VAL = A_loc(IZ8)
+          IF (LSCAL) THEN
+            VAL = VAL * ROWSCA(IOLD)*COLSCA(JOLD)
+          ENDIF
+          IF (NPROCS.GT.1 .OR. KEEP(38).NE.0) THEN
+            ISTEP_P = abs(STEP(IARR))
+            IF ( NPROCS.EQ.1 .AND. ISTEP_P.NE.ISTEP_T3_1PROC ) THEN
+              TYPE_NODE=1
+            ELSE IF (NPROCS.EQ.1) THEN
+              TYPE_NODE=3
+              IF (EARLYT3ROOTINS) THEN
+                IF ( ISEND < 0 ) THEN
+                  IPOSROOT = root%RG2L(JSEND)
+                  JPOSROOT = root%RG2L(IARR )
+                ELSE
+                  IPOSROOT = root%RG2L(IARR )
+                  JPOSROOT = root%RG2L(JSEND)
+                END IF
+              END IF
+            ELSE
+            ISTEP_P = abs(STEP(IARR))
+            CALL MUMPS_TYPEANDPROCNODE( TYPE_NODE, MASTER_NODE,
+     &      PROCNODE_STEPS(ISTEP_P), KEEP(199) )
+            MASTER_NODE = MASTER_NODE + SHIFT_PID
+            T4_MASTER_CONCERNED = .FALSE.
+            T4MASTER            = -9999
+            IF ( TYPE_NODE .eq. 1 ) THEN
+              DEST = MASTER_NODE
+            ELSE IF ( TYPE_NODE .eq. 2 ) THEN
+              IF ( ISEND .LT. 0 ) THEN
+                DEST = -1
+              ELSE
+                DEST = MASTER_NODE
+              END IF
+              INIV2         = ISTEP_TO_INIV2(ISTEP_P)
+              IF ( KEEP(79) .GT. 0) THEN
+                TYPESPLIT  = MUMPS_TYPESPLIT( PROCNODE_STEPS(ISTEP_P),
+     &                                        KEEP(199) )
+                IF ( (TYPESPLIT.EQ.5).OR.(TYPESPLIT.EQ.6)) THEN
+                  T4_MASTER_CONCERNED = .TRUE.
+                  T4MASTER=
+     &                   CANDIDATES(CANDIDATES(SLAVEF+1,INIV2)+1,INIV2)
+     &                 + SHIFT_PID
+                ENDIF
+              ENDIF
+            ELSE 
+              ARROW_ROOT = ARROW_ROOT + 1
+              IF (EARLYT3ROOTINS) THEN
+                IF ( ISEND < 0 ) THEN
+                  IPOSROOT = root%RG2L(JSEND)
+                  JPOSROOT = root%RG2L(IARR )
+                ELSE
+                  IPOSROOT = root%RG2L(IARR )
+                  JPOSROOT = root%RG2L(JSEND)
+                END IF
+                IROW_GRID = mod( ( IPOSROOT-1 )/root%MBLOCK, root%NPROW)
+                JCOL_GRID = mod( ( JPOSROOT-1 )/root%NBLOCK, root%NPCOL)
+                DEST = IROW_GRID * root%NPCOL + JCOL_GRID + SHIFT_PID
+              ELSE
+                DEST = -2
+              ENDIF
+            ENDIF
+            IF (DEST .eq. -1) THEN
+              NLOCAL8 = NLOCAL8 + 1_8
+              NSEND8  = NSEND8 + int(SLAVEF -1,8)
+            ELSE IF (DEST .EQ. -2) THEN
+              NLOCAL8 = NLOCAL8 + 1_8
+              NSEND8  = NSEND8 + int(SLAVEF -1,8)
+            ELSE
+              IF (DEST .eq.MYID ) THEN
+                NLOCAL8 = NLOCAL8 + 1_8
+              ELSE
+                NSEND8 = NSEND8 + 1_8
+              ENDIF
+            ENDIF
+            LOCAL_ASSEMBLY = .FALSE.
+            IF ( DEST.EQ.-1) THEN
+              INIV2 = ISTEP_TO_INIV2(ISTEP_P)
+              NCAND = CANDIDATES(SLAVEF+1,INIV2)
+              IF (KEEP(79) .GT. 0) THEN
+                DO I=1, SLAVEF
+                  DEST=CANDIDATES(I,INIV2) + SHIFT_PID
+                  IF (DEST.LT.0) EXIT 
+                  LOCAL = (DEST.EQ.MYID)
+                  IF (LOCAL) LOCAL_ASSEMBLY = .TRUE.
+                  IF (LOCAL) CYCLE
+                  IF (I.EQ.NCAND+1) CYCLE
+                  CALL SMUMPS_DIST_FILL_SEND_BUFFER()
+                ENDDO
+              ELSE
+                DO I=1, NCAND
+                  DEST=CANDIDATES(I,INIV2) + SHIFT_PID
+                  LOCAL = (DEST.EQ.MYID)
+                  IF (LOCAL) LOCAL_ASSEMBLY = .TRUE.
+                  IF (LOCAL) CYCLE
+                  CALL SMUMPS_DIST_FILL_SEND_BUFFER()
+                ENDDO
+              ENDIF
+              IF ( LOCAL_ASSEMBLY ) THEN
+                DEST_SAVE = DEST
+                DEST      = MASTER_NODE
+                IF (DEST.NE.MYID)
+     &           CALL SMUMPS_DIST_FILL_SEND_BUFFER()
+                IF (T4_MASTER_CONCERNED) THEN
+                  DEST   = T4MASTER
+                  IF (DEST.NE.MYID)
+     &             CALL SMUMPS_DIST_FILL_SEND_BUFFER()
+                ENDIF
+                DEST = DEST_SAVE
+              ELSE
+                DEST=MASTER_NODE
+                LOCAL_ASSEMBLY = (DEST.EQ.MYID)
+                IF (.NOT.LOCAL_ASSEMBLY) 
+     &           CALL SMUMPS_DIST_FILL_SEND_BUFFER()
+                IF (T4_MASTER_CONCERNED) THEN
+                  DEST = T4MASTER
+                  LOCAL_ASSEMBLY = (DEST.EQ.MYID)
+                  IF (.NOT.LOCAL_ASSEMBLY) 
+     &             CALL SMUMPS_DIST_FILL_SEND_BUFFER()
+                ENDIF
+              ENDIF
+            ELSE IF (DEST .GE. 0) THEN
+              LOCAL_ASSEMBLY = (DEST.EQ.MYID)
+              IF (.NOT.LOCAL_ASSEMBLY) 
+     &             CALL SMUMPS_DIST_FILL_SEND_BUFFER()
+              IF (T4_MASTER_CONCERNED) THEN
+                DEST = T4MASTER
+                LOCAL_ASSEMBLY = (DEST.EQ.MYID)
+                IF (.NOT.LOCAL_ASSEMBLY) 
+     &             CALL SMUMPS_DIST_FILL_SEND_BUFFER()
+              ENDIF
+            ELSE IF (DEST .EQ. -2) THEN
+              DO I = 0, SLAVEF-1
+                DEST=I + SHIFT_PID
+                IF (DEST.NE.MYID) 
+     &             CALL SMUMPS_DIST_FILL_SEND_BUFFER()
+              ENDDO
+              IF (SHIFT_PID.EQ.1.AND.MYID.EQ.MPI_MASTER) THEN
+                LOCAL_ASSEMBLY=.FALSE.
+              ELSE
+                LOCAL_ASSEMBLY=.TRUE. 
+              ENDIF
+            ENDIF
+          ENDIF
+          ENDIF
+          IF (LOCAL_ASSEMBLY) THEN
+            IF ( TYPE_NODE .eq. 3 .AND. EARLYT3ROOTINS ) THEN
+              ILOCROOT = root%MBLOCK * ( ( IPOSROOT - 1 ) /
+     &                     ( root%MBLOCK * root%NPROW ) )
+     &                   + mod( IPOSROOT - 1, root%MBLOCK ) + 1
+              JLOCROOT = root%NBLOCK * ( ( JPOSROOT - 1 ) /
+     &                     ( root%NBLOCK * root%NPCOL ) )
+     &                   + mod( JPOSROOT - 1, root%NBLOCK ) + 1
+              IF (KEEP(60)==0) THEN
+!$OMP ATOMIC UPDATE
+                S( PTR_ROOT + int(JLOCROOT-1,8) * int(LOCAL_M,8)
+     &            + int(ILOCROOT-1,8)) =  S( PTR_ROOT
+     &            + int(JLOCROOT - 1,8) * int(LOCAL_M,8)
+     &            + int(ILOCROOT - 1,8) )
+     &          + VAL
+!$OMP END ATOMIC
+              ELSE
+!$OMP ATOMIC UPDATE
+                root%SCHUR_POINTER( int(JLOCROOT-1,8)
+     &                          * int(root%SCHUR_LLD,8)
+     &                          + int(ILOCROOT,8) )
+     &          = root%SCHUR_POINTER( int(JLOCROOT - 1,8)
+     &                          * int(root%SCHUR_LLD,8)
+     &                          + int(ILOCROOT,8))
+     &          + VAL
+!$OMP END ATOMIC
+              ENDIF
+            ELSE
+      IF (NO_ATOMIC_Warrow) THEN
+             IF (ISEND.EQ.JSEND) THEN
+               IS8         = PTRAW(ISEND)
+               DBLARR(IS8) = DBLARR(IS8) + VAL
+             ELSE IF (ISEND.GE.0) THEN 
+               IS8         = PTRAW(IARR)+IW4(IARR,2)
+               IW4(IARR,2) = IW4(IARR,2) - 1
+               INTARR(IS8) = JSEND
+               DBLARR(IS8) = VAL
+             ELSE 
+               IS8         = PTRAW(IARR)+IW4(IARR,1)
+               IW4(IARR,1) = IW4(IARR,1) - 1
+               INTARR(IS8) = JSEND
+               DBLARR(IS8) = VAL
+             ENDIF
+      ELSE
+             IF (ISEND.EQ.JSEND) THEN
+               IS8         = PTRAW(ISEND)
+!$OMP ATOMIC UPDATE
+               DBLARR(IS8) = DBLARR(IS8) + VAL
+!$OMP END ATOMIC
+             ELSE IF (ISEND.GE.0) THEN 
+!$OMP ATOMIC CAPTURE
+               IW4_CAPTURED = IW4(IARR,2)
+               IW4(IARR,2)  = IW4(IARR,2) - 1
+!$OMP END ATOMIC
+               IS8         = PTRAW(IARR) + int(IW4_CAPTURED,8)
+               INTARR(IS8) = JSEND
+               DBLARR(IS8) = VAL
+             ELSE 
+!$OMP ATOMIC CAPTURE
+               IW4_CAPTURED = IW4(IARR,1)
+               IW4(IARR,1)  = IW4(IARR,1) - 1
+!$OMP END ATOMIC
+               IS8         = PTRAW(IARR) + int(IW4_CAPTURED,8)
+               INTARR(IS8) = JSEND
+               DBLARR(IS8) = VAL
+             ENDIF
+      ENDIF
+            ENDIF
+          ENDIF
+      ENDDO
+      RETURN
+      CONTAINS
+      SUBROUTINE SMUMPS_DIST_FILL_SEND_BUFFER( )
+      INTEGER IREQ, IACT_P, ISLAVE
+      ISLAVE = DEST+1
+ 100  CONTINUE
+!$OMP ATOMIC READ
+      IACT_P = IACT(ISLAVE)
+!$OMP END ATOMIC
+      IF (NO_ATOMIC_Wsendbuf) THEN
+        BUFSEND_POSRESERVED(IACT_P,ISLAVE) = 
+     &         BUFSEND_POSRESERVED(IACT_P, ISLAVE) + 1
+        IREQ = BUFSEND_POSRESERVED(IACT_P, ISLAVE)
+       IF (IREQ > NBRECORDS ) THEN
+         IF (IREQ > huge(NBRECORDS)-1000 - NOMP_SHARED-2) THEN
+          BUFSEND_POSRESERVED(IACT_P, ISLAVE) =  min(NBRECORDS+1, 
+     &                     BUFSEND_POSRESERVED(IACT_P, ISLAVE) )
+         ENDIF
+           IF (NOMP_SHARED.EQ.1)
+     &      CALL SMUMPS_ARROW_TRY_PROGRESS_COMM (IOMP,
+     &       MYID, NPROCS, NBRECORDS, 
+     &       MPI_InvolvedinSend, MPI_InvolvedinRecv, 
+     &       COMM, ISENDREQI, ISENDREQR, BUFSENDI, BUFSENDR, 
+     &       IACT, SEND_ACTIVE, BUFSEND_POSRESERVED, 
+     &       IRECVREQI, IRECVREQR, BUFRECVI, BUFRECVR,
+     &       RECV_BUF_STATUS, NB_END_MSG_2_RECV, 
+     &       EndNZloc, MPI_End_Send, End_TreatRecvBuf
+     &       )
+          IF (TH_InvolvedinTreatRecv) 
+     &    CALL SMUMPS_ARROW_TRY_TREAT_RECV_BUF (IOMP,
+     &             BUFRECVI, BUFRECVR, RECV_BUF_STATUS, 
+     &             NPROCS, NBRECORDS, N, IW4,
+     &             KEEP, LOCAL_M, LOCAL_N, root, PTR_ROOT, S, LA,
+     &             NB_END_MSG_2_RECV, MYID, PROCNODE_STEPS,
+     &             SLAVEF,
+     &             PTRAW, 
+     &             PTR8ARR, NINCOLARR, NINROWARR, PTRDEBARR,
+     &             PERM, STEP,
+     &             INTARR, LINTARR, DBLARR, LDBLARR, 
+     &             NOMP_SHARED, EARLYT3ROOTINS, NO_ATOMIC_Warrow)
+           IF (NOMP_SHARED.EQ.1) THEN
+             CALL SMUMPS_ARROW_TRY_PROGRESS_COMM (IOMP,
+     &        MYID, NPROCS, NBRECORDS, 
+     &        MPI_InvolvedinSend, MPI_InvolvedinRecv, 
+     &        COMM, ISENDREQI, ISENDREQR, BUFSENDI, BUFSENDR, 
+     &        IACT, SEND_ACTIVE, BUFSEND_POSRESERVED, 
+     &        IRECVREQI, IRECVREQR, BUFRECVI, BUFRECVR,
+     &        RECV_BUF_STATUS, NB_END_MSG_2_RECV, 
+     &        EndNZloc, MPI_End_Send, End_TreatRecvBuf
+     &        )
+           ELSE
+              IF (.NOT.TH_InvolvedinTreatRecv) THEN
+               CALL MUMPS_USLEEP(200)
+              ELSE
+               CALL MUMPS_USLEEP(20)
+              ENDIF
+           ENDIF
+         GOTO 100
+       ENDIF
+       BUFSENDI(IREQ*2,IACT_P,ISLAVE)   = ISEND
+       BUFSENDI(IREQ*2+1,IACT_P,ISLAVE) = JSEND
+       BUFSENDR(IREQ,IACT_P,ISLAVE )    = VAL
+       IF (IREQ.EQ.NBRECORDS) THEN
+!$OMP    ATOMIC WRITE
+            BUFSENDI(1,IACT_P,ISLAVE) = NBRECORDS
+!$OMP    END ATOMIC 
+       ENDIF
+      ELSE
+!$OMP  ATOMIC CAPTURE
+       BUFSEND_POSRESERVED(IACT_P,ISLAVE) = 
+     &         BUFSEND_POSRESERVED(IACT_P, ISLAVE) + 1
+       IREQ = BUFSEND_POSRESERVED(IACT_P, ISLAVE)
+!$OMP  END ATOMIC
+       IF (IREQ > huge(NBRECORDS)-NOMP_SHARED-2) THEN
+!$OMP   ATOMIC UPDATE
+        BUFSEND_POSRESERVED(IACT_P, ISLAVE) =  min(NBRECORDS+1, 
+     &                     BUFSEND_POSRESERVED(IACT_P, ISLAVE) )
+!$OMP   END ATOMIC
+       ENDIF
+       IF (IREQ > NBRECORDS ) THEN
+          IF (NOMP_SHARED.EQ.1) THEN
+            CALL SMUMPS_ARROW_TRY_PROGRESS_COMM (IOMP,
+     &       MYID, NPROCS, NBRECORDS, 
+     &       MPI_InvolvedinSend, MPI_InvolvedinRecv, 
+     &       COMM, ISENDREQI, ISENDREQR, BUFSENDI, BUFSENDR, 
+     &       IACT, SEND_ACTIVE, BUFSEND_POSRESERVED, 
+     &       IRECVREQI, IRECVREQR, BUFRECVI, BUFRECVR,
+     &       RECV_BUF_STATUS, NB_END_MSG_2_RECV, 
+     &       EndNZloc, MPI_End_Send, End_TreatRecvBuf
+     &       )
+          ENDIF
+          IF (TH_InvolvedinTreatRecv) 
+     &    CALL SMUMPS_ARROW_TRY_TREAT_RECV_BUF (IOMP,
+     &             BUFRECVI, BUFRECVR, RECV_BUF_STATUS, 
+     &             NPROCS, NBRECORDS, N, IW4,
+     &             KEEP, LOCAL_M, LOCAL_N, root, PTR_ROOT, S, LA,
+     &             NB_END_MSG_2_RECV, MYID, PROCNODE_STEPS,
+     &             SLAVEF,
+     &             PTRAW, 
+     &             PTR8ARR, NINCOLARR, NINROWARR, PTRDEBARR,
+     &             PERM, STEP,
+     &             INTARR, LINTARR, DBLARR, LDBLARR, 
+     &             NOMP_SHARED, EARLYT3ROOTINS, NO_ATOMIC_Warrow)
+          IF (NOMP_SHARED.EQ.1) THEN
+             CALL SMUMPS_ARROW_TRY_PROGRESS_COMM (IOMP,
+     &        MYID, NPROCS, NBRECORDS, 
+     &        MPI_InvolvedinSend, MPI_InvolvedinRecv, 
+     &        COMM, ISENDREQI, ISENDREQR, BUFSENDI, BUFSENDR, 
+     &        IACT, SEND_ACTIVE, BUFSEND_POSRESERVED, 
+     &        IRECVREQI, IRECVREQR, BUFRECVI, BUFRECVR,
+     &        RECV_BUF_STATUS, NB_END_MSG_2_RECV, 
+     &        EndNZloc, MPI_End_Send, End_TreatRecvBuf
+     &        )
+          ELSE 
+            IF (.NOT.TH_InvolvedinTreatRecv) THEN
+             CALL MUMPS_USLEEP(200)
+            ELSE
+             CALL MUMPS_USLEEP(20)
+            ENDIF
+          ENDIF
+         GOTO 100
+         ENDIF
+         BUFSENDI(IREQ*2,IACT_P,ISLAVE)   = ISEND
+         BUFSENDI(IREQ*2+1,IACT_P,ISLAVE) = JSEND
+         BUFSENDR(IREQ,IACT_P,ISLAVE )    = VAL
+!$OMP    ATOMIC UPDATE
+         BUFSENDI(1,IACT_P,ISLAVE) = BUFSENDI(1,IACT_P,ISLAVE) + 1
+!$OMP    END ATOMIC 
+      ENDIF
+      RETURN
+      END SUBROUTINE SMUMPS_DIST_FILL_SEND_BUFFER
+      END SUBROUTINE SMUMPS_FAC_ARROW_ARRANGE
+#endif
diff -pruN 5.6.2-2.1/src/sfac_distrib_ELT.F 5.7.1-1/src/sfac_distrib_ELT.F
--- 5.6.2-2.1/src/sfac_distrib_ELT.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/sfac_distrib_ELT.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -38,8 +38,6 @@ C
       REAL A( LA )
       TYPE(SMUMPS_STRUC)     :: id
       TYPE(SMUMPS_ROOT_STRUC) :: root
-      INTEGER numroc
-      EXTERNAL numroc
       INCLUDE 'mpif.h'
       INCLUDE 'mumps_tags.h'
       INTEGER :: IERR_MPI
diff -pruN 5.6.2-2.1/src/sfac_distrib_distentry.F 5.7.1-1/src/sfac_distrib_distentry.F
--- 5.6.2-2.1/src/sfac_distrib_distentry.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/sfac_distrib_distentry.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -126,10 +126,8 @@ C
       TYPE (SMUMPS_ROOT_STRUC) :: root
       INTEGER PROCNODE_STEPS(KEEP(28)), PERM( N ), STEP( N )
       INTEGER INFO( 80 ), ICNTL(60)
-      INTEGER MUMPS_PROCNODE, MUMPS_TYPENODE, numroc, 
-     &        MUMPS_TYPESPLIT
-      EXTERNAL MUMPS_PROCNODE, MUMPS_TYPENODE, numroc, 
-     &        MUMPS_TYPESPLIT
+      INTEGER MUMPS_TYPESPLIT
+      EXTERNAL MUMPS_TYPESPLIT
       INCLUDE 'mumps_tags.h'
       INCLUDE 'mpif.h'
       INTEGER :: IERR, MSGSOU
@@ -626,6 +624,7 @@ C
       KEEP(49) = ARROW_ROOT
  100  CONTINUE
       IF (ALLOCATED(IW4))     DEALLOCATE( IW4 )
+      IF (ALLOCATED(PTRAW))   DEALLOCATE( PTRAW )
       IF (ALLOCATED(BUFI))    DEALLOCATE( BUFI )
       IF (ALLOCATED(BUFR))    DEALLOCATE( BUFR )
       IF (ALLOCATED(BUFRECI)) DEALLOCATE( BUFRECI )
diff -pruN 5.6.2-2.1/src/sfac_driver.F 5.7.1-1/src/sfac_driver.F
--- 5.6.2-2.1/src/sfac_driver.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/sfac_driver.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -137,8 +137,9 @@ C     (pointer to point on used-data in
       LOGICAL, PARAMETER :: BDUMMY =.FALSE.
       INTEGER, PARAMETER :: PANEL_TABSIZE = 20
       INTEGER COLOUR, COMM_FOR_SCALING ! For Simultaneous scaling
-      INTEGER LIWK, LWK_REAL
-      INTEGER(8) :: LWK
+      INTEGER(8) :: LIWK
+      INTEGER(8) :: LWK, LWK_REAL, LWRKR_TH, LWRKC_TH
+      INTEGER    :: NOMP_MAX
 C     I_AM_SLAVE: used to determine if proc has the role of a slave
 C     WK_USER_PROVIDED is set to true when WK_USER is provided by user
       LOGICAL I_AM_SLAVE, PERLU_ON, WK_USER_PROVIDED, EARLYT3ROOTINS
@@ -154,6 +155,7 @@ C     WK_USER_PROVIDED is set to true wh
 C temporary variables for collecting stats from all processors
       DOUBLE PRECISION :: TMP_MRY_LU_FR
       DOUBLE PRECISION :: TMP_MRY_LU_LRGAIN
+      INTEGER :: KEEP399_SAVE
       DOUBLE PRECISION :: TMP_MRY_CB_FR
       DOUBLE PRECISION :: TMP_MRY_CB_LRGAIN
       DOUBLE PRECISION :: TMP_FLOP_LRGAIN
@@ -203,18 +205,21 @@ C temporary variables for collecting sta
       DOUBLE PRECISION :: TMP_TIME_FRASM_MAPLIG1
       DOUBLE PRECISION :: TMP_TIME_FRASM_CONTRIB2
 C
-C  Workspace.
+C  Workspace
 C
       INTEGER, DIMENSION(:), ALLOCATABLE :: IWK
       REAL, DIMENSION(:), ALLOCATABLE :: WK
-      REAL, DIMENSION(:), ALLOCATABLE :: WK_REAL
+      REAL, DIMENSION(:), ALLOCATABLE    :: WK_REAL
+      REAL, DIMENSION(:,:), ALLOCATABLE:: WRKR_TH, 
+     &                                    WRKC_TH
       INTEGER(8), DIMENSION(:), ALLOCATABLE :: IWK8
       INTEGER, DIMENSION(:), ALLOCATABLE :: BURP
       INTEGER, DIMENSION(:), ALLOCATABLE :: BUCP
       INTEGER, DIMENSION(:), ALLOCATABLE :: BURS
       INTEGER, DIMENSION(:), ALLOCATABLE :: BUCS
-      INTEGER BUREGISTRE(12)
-      INTEGER BUINTSZ, BURESZ, BUJOB
+      INTEGER(8) :: BUREGISTRE(12)
+      INTEGER(8) :: BUINTSZ, BURESZ, NZ_loc8
+      INTEGER    :: BUJOB
       INTEGER BUMAXMN, M, SCMYID, SCNPROCS
       REAL    SCONEERR, SCINFERR
 C
@@ -224,21 +229,23 @@ C
 *     Control parameters: see description in SMUMPSID
       REAL,DIMENSION(:),POINTER::RINFO, RINFOG
       REAL,DIMENSION(:),POINTER::    CNTL
-      INTEGER,DIMENSION(:),POINTER:: INFOG, KEEP
-      INTEGER, DIMENSION(:), POINTER :: MYIRN_loc, MYJCN_loc
-      REAL, DIMENSION(:), POINTER :: MYA_loc
+      INTEGER,DIMENSION(:),POINTER   :: INFOG, KEEP
+      INTEGER, DIMENSION(:), POINTER :: IRN_loc_PTR, JCN_loc_PTR
+      REAL, DIMENSION(:), POINTER   :: COLSCA_PTR, 
+     &                                 ROWSCA_PTR
+      REAL, DIMENSION(:), POINTER:: A_loc_PTR
       INTEGER, TARGET :: DUMMYIRN_loc(1), DUMMYJCN_loc(1)
+      REAL, TARGET    :: DUMMYSCA(1)
       REAL, TARGET :: DUMMYA_loc(1)
       INTEGER,DIMENSION(:),POINTER::ICNTL
       EXTERNAL MUMPS_GET_POOL_LENGTH
-      INTEGER MUMPS_GET_POOL_LENGTH
+      INTEGER MUMPS_GET_POOL_LENGTH, SIZESCAL
       INTEGER(8) :: TOTAL_BYTES
       INTEGER(8) :: I8TMP, LWK_USER_SUM8
 C
 C  External references
 C  ===================
-      INTEGER numroc
-      EXTERNAL numroc
+      INTEGER, EXTERNAL :: MUMPS_NUMROC
       INTEGER:: NWORKING
       LOGICAL:: MEM_EFF_ALLOCATED
       INTEGER   :: TOTAL_MBYTES_UNDER_L0
@@ -260,13 +267,13 @@ C     --------------------------
       KEEP=>id%KEEP
       ICNTL=>id%ICNTL
       IF (id%KEEP8(29) .NE. 0) THEN
-        MYIRN_loc=>id%IRN_loc
-        MYJCN_loc=>id%JCN_loc
-        MYA_loc=>id%A_loc
+        IRN_loc_PTR=>id%IRN_loc
+        JCN_loc_PTR=>id%JCN_loc
+        A_loc_PTR=>id%A_loc
       ELSE
-        MYIRN_loc=>DUMMYIRN_loc
-        MYJCN_loc=>DUMMYJCN_loc
-        MYA_loc=>DUMMYA_loc
+        IRN_loc_PTR=>DUMMYIRN_loc
+        JCN_loc_PTR=>DUMMYJCN_loc
+        A_loc_PTR=>DUMMYA_loc
       ENDIF
       NOMP = 1 
       N = id%N
@@ -295,13 +302,6 @@ C     Number of symmetric swaps
       id%KEEP8(80)=0_8
 C     Largest increase of internal panel size
       id%KEEP(425) =0
-C     and KEEP8(83) to the ddress of ICNTL(50)
-C     Set KEEP8(84) to the address of RINFO(3)
-      IF (id%KEEP(500) .EQ. 0 ) THEN ! MUMPS called from Fortran
-        CALL MUMPS_ADDR_C( ICNTL(50), id%KEEP8(83) )
-        CALL MUMPS_ADDR_C( RINFO (3), id%KEEP8(84) )
-      ENDIF
-C
       PRINT_MAXAVG = .NOT.(id%NSLAVES.EQ.1 .AND. KEEP(46).EQ.1)
 C     Print per node informtation only in case ther are several
 C     compute nodes (id%KEEP(412): #MPI procs on comupte node)
@@ -451,15 +451,19 @@ C       For symmetric (non general) matr
 C       set (directly) CNTL1 = 0.0
 C       ---------------------------------------
         KEEP(17)=0
-        IF ( KEEP(50) .eq. 1 ) THEN
-          IF (CNTL1 .ne. ZERO ) THEN
-            IF ( PROKG ) THEN
-              WRITE(MPG,'(A)')
-     & '** Warning : SPD solver called, resetting CNTL(1) to 0.0E0'
-            END IF
-          END IF
-          CNTL1 = ZERO
-        END IF
+C       Automatic choice if CNTL(1)<0
+C       For rank-revealing (KEEP(19).GT.0) then
+C       set CNTL1=0.1 even if SYM=1 
+        IF (CNTL1.LT.ZERO) THEN
+C        automatic choice
+         IF (KEEP(19).GT.0) THEN
+          CNTL1=0.1E0
+         ELSE IF (KEEP(50).EQ.1) THEN
+          CNTL1=ZERO
+         ELSE
+          CNTL1=0.01E0
+         ENDIF
+        ENDIF
 C       CNTL1 threshold value must be between 
 C       0.0 and 1.0 (for SYM=0) and 0.5 (for SYM=1,2)
         IF (CNTL1.GT.ONE)   CNTL1=ONE
@@ -482,7 +486,7 @@ C        out of range values
          PARPIV_T1 =0
         ENDIF
 C       note that KEEP(50).EQ.1 => CNTL1=0.0
-        IF (CNTL1.EQ.0.0.OR.(KEEP(50).eq.1)) PARPIV_T1 = 0 
+        IF (CNTL1.EQ.0.0E0.OR.(KEEP(50).eq.1)) PARPIV_T1 = 0 
 C
         IF (PARPIV_T1.EQ.-2) THEN
          IF (KEEP(19).NE.0) THEN
@@ -498,6 +502,22 @@ C         but do NOT switch off PARPIV_1
         CALL MPI_BCAST( KEEP(269), 1, MPI_INTEGER,
      &                  MASTER, id%COMM, IERR )
         IF (id%MYID.EQ.MASTER) THEN
+C{
+C         OMP parallelization of arrowheads
+C         out of range are treated as zero
+          IF (KEEP(399).LT.-1) KEEP(399)=-1
+          KEEP399_SAVE = KEEP(399)
+          IF (KEEP(399).EQ.-1) THEN
+            IF ((KEEP(54).EQ.0).AND.(id%NPROCS.GT.1)) THEN
+              KEEP(399) = 1
+            ELSE
+              KEEP(399) = 3
+            ENDIF
+          ENDIF
+#if defined(PCPRET)
+C         new multithreaded >=2 algo does not compile on PCPRET
+          KEEP(399) = 1
+#endif
 C         -----------------------------------------------------
 C         Decoding of ICNTL(35) for factorization: same as
 C         at analysis except that we store a copy of ICNTL(35)
@@ -628,11 +648,16 @@ C             Reset to 3 if 5 or to 4 if
             ENDIF
           ENDIF
  105    CONTINUE
+C}
         ENDIF  ! id%MYID .EQ. MASTER
         CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                        id%COMM, id%MYID )
 C
         IF (id%INFO(1).LT.0) GOTO 530
+        CALL MPI_BCAST( KEEP(281), 1, MPI_INTEGER,
+     &                  MASTER, id%COMM, IERR )
+        CALL MPI_BCAST( KEEP(399), 1, MPI_INTEGER,
+     &                  MASTER, id%COMM, IERR )
         CALL MPI_BCAST( KEEP(473), 14, MPI_INTEGER,
      &                  MASTER, id%COMM, IERR )
         IF (KEEP(486).NE.0) THEN
@@ -669,6 +694,8 @@ C         -- Low Level I/O strategy
      &                  MASTER, id%COMM, IERR )
           CALL MPI_BCAST( KEEP(211), 1, MPI_INTEGER,
      &                  MASTER, id%COMM, IERR )
+          CALL MPI_BCAST( KEEP(255), 1, MPI_INTEGER,
+     &                  MASTER, id%COMM, IERR )
         ENDIF
 C     Fwd in facto: explicitly forbid
 C     sparse RHS and A-1 computation
@@ -832,7 +859,7 @@ C       -- More expensive setting of SIM
 C
         IF ( ((KEEP(52).EQ.7).OR.(KEEP(52).EQ.8)) .AND. 
      &       KEEP(54).NE.0 ) THEN
-C         ------------------------------
+C{        ------------------------------
 C         Scaling for distributed matrix
 C         We need to allocate scaling
 C         arrays on all processors, not
@@ -857,13 +884,14 @@ C         ------------------------------
          M = N
          BUMAXMN=M
          IF(N > BUMAXMN) BUMAXMN = N
-         LIWK = 4*BUMAXMN
-         ALLOCATE (IWK(LIWK),BURP(M),BUCP(N),
-     &            BURS(2* (id%NPROCS)),BUCS(2* (id%NPROCS)),
+         LIWK = 4_8*int(BUMAXMN,8)
+         ALLOCATE (IWK(LIWK), BURP(M), BUCP(N),
+     &            BURS(2* id%NPROCS), BUCS(2* id%NPROCS),
      &            stat=allocok)
          IF (allocok > 0) THEN
             id%INFO(1)=-13
-            id%INFO(2)=LIWK+M+N+4* (id%NPROCS)
+            CALL MUMPS_SET_IERROR(LIWK+int(M,8)+int(N,8)+
+     &      4_8*int(id%NPROCS,8) , id%INFO(2))
          ENDIF
 C        --- Propagate enventual error
          CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
@@ -872,27 +900,38 @@ C        --- Propagate enventual error
 C        -- estimation of memory and construction of partvecs
          BUJOB = 1
 C        -- LWK not used
-         LWK_REAL   = 1
+         LWK_REAL = 1_8
+         LWRKR_TH = 1_8
+         LWRKC_TH = 1_8
+         NOMP_MAX   = 1
          ALLOCATE(WK_REAL(LWK_REAL),
+     &            WRKR_TH(LWRKR_TH,NOMP_MAX),
+     &            WRKC_TH(LWRKC_TH,NOMP_MAX),
      &            stat=allocok)
          IF (allocok > 0) THEN
             id%INFO(1)=-13
-            id%INFO(2)=LWK_REAL
+            CALL MUMPS_SET_IERROR(
+     &             LWK_REAL+ 
+     &             LWRKR_TH*int(NOMP_MAX,8)+
+     &             LWRKC_TH*int(NOMP_MAX,8),
+     &             id%INFO(2))
          ENDIF
 C        --- Propagate enventual error
          CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
      &        id%COMM, id%MYID )
          IF (id%INFO(1).LT.0) GOTO 517
          CALL SMUMPS_SIMSCALEABS(
-     &        MYIRN_loc(1), MYJCN_loc(1), MYA_loc(1),
+     &        IRN_loc_PTR(1), JCN_loc_PTR(1), A_loc_PTR(1),
      &        id%KEEP8(29),
      &        M, N,  id%NPROCS, id%MYID, id%COMM,
      &        BURP, BUCP,
      &        BURS, BUCS, BUREGISTRE,
      &        IWK, LIWK,
      &        BUINTSZ, BURESZ, BUJOB,
-     &        id%ROWSCA(1), id%COLSCA(1), WK_REAL, LWK_REAL,
-     &        id%KEEP(50),
+     &        id%ROWSCA(1), id%COLSCA(1), WK_REAL, LWK_REAL, 
+     &        WRKR_TH, LWRKR_TH, 
+     &        WRKC_TH, LWRKC_TH,
+     &        NOMP_MAX, id%KEEP(50),
      &        K231, K232, K233, 
      &        id%DKEEP(3),
      &        SCONEERR, SCINFERR)
@@ -902,15 +941,40 @@ C        --- Propagate enventual error
             ALLOCATE(IWK(LIWK), stat=allocok)
             IF (allocok > 0) THEN
                id%INFO(1)=-13
-               id%INFO(2)=LIWK
+               CALL MUMPS_SET_IERROR(LIWK,id%INFO(2))
             ENDIF
          ENDIF
-         LWK_REAL = BURESZ
-         DEALLOCATE(WK_REAL)
-         ALLOCATE (WK_REAL(LWK_REAL), stat=allocok)
+         DEALLOCATE(WK_REAL, WRKR_TH, WRKC_TH)
+         LWK_REAL     = BURESZ
+C
+C        -- Set NOMP_MAX from KEEP(281)
+         CALL SMUMPS_SET_NOMP_MAX(id%KEEP(281), id%KEEP(361), 
+     &                            N, NOMP_MAX)
+C
+         IF (NOMP_MAX.LE.1) THEN
+C          temp array per thread not used
+           LWRKR_TH = 1
+           LWRKC_TH = 1
+         ELSE
+           LWRKR_TH = N
+           IF (id%KEEP(50).NE.0) THEN
+C            WRKC_TH not used on symmetric matrices
+             LWRKC_TH = 1
+           ELSE
+             LWRKC_TH = N
+           ENDIF
+         ENDIF
+         ALLOCATE(WK_REAL(LWK_REAL),
+     &            WRKR_TH(LWRKR_TH,max(NOMP_MAX,1)),
+     &            WRKC_TH(LWRKC_TH,max(NOMP_MAX,1)),
+     &            stat=allocok)
          IF (allocok > 0) THEN
             id%INFO(1)=-13
-            id%INFO(2)=LWK_REAL
+            CALL MUMPS_SET_IERROR(
+     &             LWK_REAL+ 
+     &             LWRKR_TH*int(max(NOMP_MAX,1),8)+
+     &             LWRKC_TH*int(max(NOMP_MAX,1),8),
+     &             id%INFO(2))
          ENDIF
 C        --- Propagate enventual error
          CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
@@ -919,7 +983,7 @@ C        --- Propagate enventual error
 C        -- estimation of memory and construction of partvecs
          BUJOB = 2
          CALL SMUMPS_SIMSCALEABS(
-     &        MYIRN_loc(1), MYJCN_loc(1), MYA_loc(1),
+     &        IRN_loc_PTR(1), JCN_loc_PTR(1), A_loc_PTR(1),
      &        id%KEEP8(29),
      &        M, N,  id%NPROCS, id%MYID, id%COMM,
      &        BURP, BUCP,
@@ -927,16 +991,20 @@ C        -- estimation of memory and con
      &        IWK, LIWK,
      &        BUINTSZ, BURESZ, BUJOB,
      &        id%ROWSCA(1), id%COLSCA(1), WK_REAL, LWK_REAL,
-     &        id%KEEP(50),
+     &        WRKR_TH, LWRKR_TH, 
+     &        WRKC_TH, LWRKC_TH,
+     &        NOMP_MAX, id%KEEP(50),
      &        K231, K232, K233, 
      &        id%DKEEP(3),
      &        SCONEERR, SCINFERR)
          id%DKEEP(4) = SCONEERR
          id%DKEEP(5) = SCINFERR
 CXXXX 
-         DEALLOCATE(IWK, WK_REAL,BURP,BUCP,BURS, BUCS)
+         DEALLOCATE(IWK, BURP,BUCP,BURS, BUCS)
+         DEALLOCATE(WK_REAL, WRKR_TH, WRKC_TH)
+C}
         ELSE IF ( KEEP(54) .EQ. 0 ) THEN
-C         ------------------
+C{        ------------------
 C         Centralized matrix
 C         ------------------
           IF ((KEEP(52).EQ.7).OR.(KEEP(52).EQ.8))  THEN
@@ -954,21 +1022,45 @@ C             --------------------------
                  M = N
                  BUMAXMN=N
                  IF(N > BUMAXMN) BUMAXMN = N
-                 LIWK = 1
-                 ALLOCATE(IWK(LIWK),BURP(1),BUCP(1),
-     &                BURS(1),BUCS(1),
+                 LIWK = 1_8
+                 ALLOCATE(IWK(LIWK), BURP(1), BUCP(1),
+     &                BURS(1), BUCS(1),
      &                stat=allocok)
                  IF (allocok > 0) THEN
                     id%INFO(1)=-13
-                    id%INFO(2)=LIWK+1+1+1+1
+                    CALL MUMPS_SET_IERROR( LIWK+4_8, id%INFO(2) )
                     GOTO 400
                  ENDIF
-                 LWK_REAL = M + N  
-                 ALLOCATE (WK_REAL(LWK_REAL), stat=allocok)
+                 LWK_REAL = int(M,8) + int(N,8)  
+C
+C                -- Set NOMP_MAX from KEEP(281)
+                 CALL SMUMPS_SET_NOMP_MAX(id%KEEP(281), id%KEEP(361), 
+     &                                    N, NOMP_MAX)
+C
+                 IF (NOMP_MAX.LE.1) THEN
+C                  temp array per thread not used
+                   LWRKR_TH = 1
+                   LWRKC_TH = 1
+                 ELSE
+                   LWRKR_TH = N
+                   IF (id%KEEP(50).NE.0) THEN
+C                    WRKC_TH not used on symmetric matrices
+                     LWRKC_TH = 1
+                   ELSE
+                     LWRKC_TH = N
+                   ENDIF
+                 ENDIF
+                 ALLOCATE(WK_REAL(LWK_REAL),
+     &                    WRKR_TH(LWRKR_TH,max(NOMP_MAX,1)),
+     &                    WRKC_TH(LWRKC_TH,max(NOMP_MAX,1)),
+     &                    stat=allocok)
                  IF (allocok > 0) THEN
                     id%INFO(1)=-13
-                    id%INFO(2)=LWK_REAL
-                    GOTO 400
+                    CALL MUMPS_SET_IERROR(
+     &                     LWK_REAL+ 
+     &                     LWRKR_TH*int(max(NOMP_MAX,1),8)+
+     &                     LWRKC_TH*int(max(NOMP_MAX,1),8),
+     &                     id%INFO(2))
                  ENDIF
                  CALL MPI_COMM_RANK(COMM_FOR_SCALING, SCMYID, IERR)
                  CALL MPI_COMM_SIZE(COMM_FOR_SCALING, SCNPROCS, IERR)
@@ -982,7 +1074,9 @@ C             --------------------------
      &                IWK, LIWK,
      &                BUINTSZ, BURESZ, BUJOB,
      &                id%ROWSCA(1), id%COLSCA(1), WK_REAL, LWK_REAL,
-     &                id%KEEP(50),
+     &                WRKR_TH, LWRKR_TH, 
+     &                WRKC_TH, LWRKC_TH,
+     &                NOMP_MAX, id%KEEP(50),
      &                K231, K232, K233, 
      &                id%DKEEP(3),
      &                SCONEERR, SCINFERR)
@@ -1000,7 +1094,9 @@ C             --------------------------
      &                IWK, LIWK,
      &                BUINTSZ, BURESZ, BUJOB,
      &                id%ROWSCA(1), id%COLSCA(1), WK_REAL, LWK_REAL,
-     &                id%KEEP(50),
+     &                WRKR_TH, LWRKR_TH, 
+     &                WRKC_TH, LWRKC_TH,
+     &                NOMP_MAX, id%KEEP(50),
      &                K231, K232, K233, 
      &                id%DKEEP(3),
      &                SCONEERR, SCINFERR)
@@ -1008,6 +1104,8 @@ C             --------------------------
                  id%DKEEP(5) = SCINFERR
  400             CONTINUE
                  IF (allocated(WK_REAL)) DEALLOCATE(WK_REAL)
+                 IF (allocated(WRKR_TH)) DEALLOCATE(WRKR_TH)
+                 IF (allocated(WRKC_TH)) DEALLOCATE(WRKC_TH)
                  IF (allocated(IWK))     DEALLOCATE(IWK)
                  IF (allocated(BURP))    DEALLOCATE(BURP)
                  IF (allocated(BUCP))    DEALLOCATE(BUCP)
@@ -1026,31 +1124,34 @@ C               freed on the master proc
      &             id%COMM, id%MYID)
               IF (id%INFO(1).LT.0) GOTO 517
           ELSE IF (id%MYID.EQ.MASTER) THEN
-C           ----------------------------------
-C           Centralized scaling, options 1 to 6
-C           ----------------------------------
+C           -------------------
+C           Centralized scaling
+C           -------------------
             IF (KEEP(52).GT.0 .AND. KEEP(52).LE.6) THEN
 C             ---------------------
 C             Allocate temporary
 C             workspace for scaling
 C             ---------------------
-              IF ( KEEP(52) .eq. 5 .or. 
-     &          KEEP(52) .eq. 6 ) THEN
-C               We have an explicit copy of the original
-C               matrix in complex format which should probably
-C               be avoided (but do we want to keep all
-C               those old scaling options ?)
-                LWK = id%KEEP8(28)
-              ELSE
+              IF (KEEP(52) .eq. 1 ) THEN
+C               No workspace indeed needed
                 LWK = 1_8
+                LWK_REAL = 1_8
+              ELSE IF ( KEEP(52) .eq. 3 ) THEN 
+                LWK = 1_8
+                LWK_REAL = int(N,8)
+              ELSE IF ( KEEP(52) .eq. 4 ) THEN
+C               Options 3 or 4
+                LWK = 1_8
+                LWK_REAL = 2_8*int(N,8)
               END IF
-              LWK_REAL = 5 * N
+C             Real workarray
               ALLOCATE( WK_REAL( LWK_REAL ), stat = IERR )
               IF ( IERR .GT. 0 ) THEN
                 id%INFO(1) = -13
-                id%INFO(2) = LWK_REAL
+                CALL MUMPS_SET_IERROR( LWK_REAL, id%INFO(2) )
                 GOTO 137
               END IF
+C             Real/complex workarray
               ALLOCATE( WK( LWK ), stat = IERR )
               IF ( IERR .GT. 0 ) THEN
                 id%INFO(1) = -13
@@ -1065,11 +1166,12 @@ C               those old scaling option
               DEALLOCATE( WK )
             ENDIF
           ENDIF
+C}
         ENDIF ! Scaling distributed matrices or centralized
         IF (KEEP(125).NE.0) THEN
 C         ------------------------
 C           If we enable the scaling of the |A11 A12| block
-C           we et to 1 the scaling corresponding to the Schur
+C           we set to 1 the scaling corresponding to the Schur
 C           complement matrix A22
 C         ------------------------
             IF ((KEEP(60).GT.0) .and. (KEEP(116).GT.0)) THEN
@@ -1097,6 +1199,7 @@ C             Scaling available on maste
         IF (id%MYID.EQ.MASTER) THEN
             CALL MUMPS_SECFIN(TIMEET)
             id%DKEEP(92)=real(TIMEET)
+          IF (PROKG) WRITE( MPG, 140 ) TIMEET
 C         Print inf-norm after last KEEP(233) iterations of
 C         scaling option KEEP(52)=7 or 8 (SimScale)
 C
@@ -1146,6 +1249,9 @@ C       of the original matrix.
 C       ********************
 C
  137  CONTINUE
+      CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
+     &     id%COMM, id%MYID )
+      IF (id%INFO(1).LT.0) GOTO 517
 C     Fwd in facto: in case of repeated factorizations
 C     with different Schur options we prefer to free
 C     systematically this array now than waiting for
@@ -1171,11 +1277,11 @@ C     to make it available on all proces
       IF (id%KEEP(252) .EQ. 1) THEN
           IF ( id%MYID.NE.MASTER ) THEN
             id%KEEP(254) = N              ! Leading dimension
-            id%KEEP(255) = N*id%KEEP(253) ! Tot size
-            ALLOCATE(RHS_MUMPS(id%KEEP(255)),stat=IERR)
+            id%KEEP8(85) = int(N,8)*int(id%KEEP(253),8) ! Tot size
+            ALLOCATE(RHS_MUMPS(id%KEEP8(85)),stat=IERR)
             IF (IERR > 0) THEN
                id%INFO(1)=-13
-               id%INFO(2)=id%KEEP(255)
+               CALL MUMPS_SET_IERROR(id%KEEP8(85), id%INFO(2))
                IF (LPOK)
      &         WRITE(LP,*) 'ERROR while allocating RHS on a slave'
                NULLIFY(RHS_MUMPS)
@@ -1184,7 +1290,8 @@ C     to make it available on all proces
           ELSE 
 C           Case of non working master
             id%KEEP(254)=id%LRHS              ! Leading dimension
-            id%KEEP(255)=id%LRHS*(id%KEEP(253)-1)+id%N ! Tot size
+            id%KEEP8(85)=int(id%LRHS,8)*int(id%KEEP(253)-1,8)+
+     &                   int(id%N,8) ! Tot size
             RHS_MUMPS=>id%RHS
             RHS_MUMPS_ALLOCATED = .FALSE.
             IF (LSCAL) THEN
@@ -1201,7 +1308,7 @@ C             transpose).
             ENDIF
           ENDIF
       ELSE
-          id%KEEP(255)=1
+          id%KEEP8(85)=1_8
           ALLOCATE(RHS_MUMPS(1),stat=IERR)
           IF (IERR > 0) THEN
              id%INFO(1)=-13
@@ -1214,7 +1321,7 @@ C             transpose).
       ENDIF
       CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
      &                    id%COMM, id%MYID )
-      IF ( id%INFO(1).lt.0 ) GOTO 517
+      IF ( id%INFO(1).lt.0 ) GOTO 516
       IF (KEEP(252) .EQ. 1) THEN
 C
 C         Broadcast the columns of the right-hand side
@@ -1235,7 +1342,7 @@ C       KEEP(110) defaults to 0 for out
       ENDIF
       CALL MPI_BCAST(KEEP(110), 1, MPI_INTEGER,
      &               MASTER, id%COMM, IERR)
-      IF (KEEP(219).NE.0) THEN
+      IF ((KEEP(50).EQ.2).AND.(KEEP(219).NE.0)) THEN
        CALL SMUMPS_BUF_MAX_ARRAY_MINSIZE(max(KEEP(108),1),IERR)
        IF (IERR .NE. 0) THEN
 C      ------------------------
@@ -1253,6 +1360,7 @@ C               ( A row is considered as
 C         CNTL(5) is then used to define if a large 
 C                 value is set on the diagonal or if a 1 is set
 C                 and other values in the row are reset to zeros.
+C       -rank revealing on the Schur (ICNTL(56)/KEEP(19))
 C         SEUIL* corresponds to the minimum required 
 C                absolute value of pivot.
 C         SEUIL_LDLT_NIV2 is used only in the 
@@ -1337,6 +1445,10 @@ C      sing val.
          ELSE IF  (CNTL3 .GT. ZERO) THEN
            id%DKEEP(9) = CNTL3*ANORMINF
          ELSE  !  (CNTL(3) .EQ. ZERO) THEN
+           CALL MUMPS_NPIV_CRITICAL_PATH(
+     &     N, KEEP(28), id%STEP(1), id%FRERE_STEPS(1), id%FILS(1),
+     &     id%NA(1), id%LNA, id%NE_STEPS(1), NPIV_CRITICAL_PATH )
+           id%DKEEP(9) = sqrt(REAL(NPIV_CRITICAL_PATH))*EPS*ANORMINF  
          ENDIF
          IF (PROKG) THEN 
            WRITE(MPG, '(A,I16)')
@@ -1429,6 +1541,7 @@ C     Find id of root node if RR is on
       ENDIF
 C Second pass:  set parameters for null pivot detection
 C Allocate PIVNUL_LIST_STRUCT in case of null pivot detection
+C and in case of rank revealing
       KEEP(109) = 0
       LPN_LIST  = 0
       IF(KEEP(110) .EQ. 1) THEN
@@ -1450,7 +1563,7 @@ C Allocate PIVNUL_LIST_STRUCT in case of
 C end set parameter for null pivot detection
       CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
      &                    id%COMM, id%MYID )
-      IF ( id%INFO(1).lt.0 ) GOTO 517
+      IF ( id%INFO(1).lt.0 ) GOTO 516
 C   --------------------------------------------------------------
 C   STATIC PIVOTING
 C     -- Static pivoting only when RR and Null pivot detection OFF
@@ -1514,7 +1627,7 @@ C       -- Set MAXS to size of WK_USER_
       CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
      &                    id%COMM, id%MYID )
       IF (id%INFO(1) .LT. 0) THEN
-        GOTO 517
+        GOTO 516
       ENDIF
 C
       id%KEEP8(75) = huge(id%KEEP8(75))
@@ -1603,7 +1716,7 @@ C
       CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
      &                    id%COMM, id%MYID )
       IF (id%INFO(1) .LT. 0) THEN
-        GOTO 517
+        GOTO 516
       ENDIF
       CALL MUMPS_SETI8TOI4(MAXS, id%INFO(39))
       CALL SMUMPS_AVGMAX_STAT8(PROKG, MPG, MAXS, id%NSLAVES,
@@ -1995,11 +2108,11 @@ C     id%S will be checked later)
 C     ---------------------------------------------
       IF (EARLYT3ROOTINS .AND. KEEP(38).NE.0 .AND.
      &    KEEP(60) .EQ.0 .AND. I_AM_SLAVE) THEN
-        LWK = int(numroc( id%root%ROOT_SIZE, id%root%MBLOCK,
+        LWK = int(MUMPS_NUMROC( id%root%ROOT_SIZE, id%root%MBLOCK,
      &             id%root%MYROW, 0, id%root%NPROW ),8)
         LWK = max( 1_8, LWK )
         LWK = LWK*
-     &        int(numroc( id%root%ROOT_SIZE, id%root%NBLOCK,
+     &        int(MUMPS_NUMROC( id%root%ROOT_SIZE, id%root%NBLOCK,
      &        id%root%MYCOL, 0, id%root%NPCOL ),8)
         LWK = max( 1_8, LWK )
       ELSE
@@ -2016,6 +2129,122 @@ C     arrowheads of root.
      &                        id%COMM, id%MYID )
       IF ( id%INFO(1).LT.0 ) GOTO 500
 C
+C     =====================================================
+      IF (KEEP(399).GE.2) THEN
+C{    Multihtreaded algorithm taking into account all cases
+C     =====================================================
+C
+C        Timing on master.
+         IF (id%MYID.EQ.MASTER) THEN
+           CALL MUMPS_SECDEB(TIME)
+         END IF
+C
+         NZ_loc8   = 0_8
+         NBRECORDS = KEEP(39)
+         SIZESCAL = id%N
+C        Set  NZ_loc8, A_loc_PTR, IRN_loc_PTR, JCN_loc_PTR
+C        and update NBRECORDS
+         IF (KEEP(54).EQ.0) THEN
+C         centralized matrix
+          IF (id%KEEP8(28) .LT. int(NBRECORDS,8)) THEN
+              NBRECORDS = int(id%KEEP8(28))
+          ENDIF
+          IF (id%MYID.EQ.MASTER) THEN
+           NZ_loc8 = id%KEEP8(28)
+           A_loc_PTR   => id%A
+           IRN_loc_PTR => id%IRN
+           JCN_loc_PTR => id%JCN
+           IF (LSCAL) THEN
+             COLSCA_PTR => id%COLSCA
+             ROWSCA_PTR => id%ROWSCA
+           ELSE
+             COLSCA_PTR  => DUMMYSCA
+             ROWSCA_PTR  => DUMMYSCA
+             SIZESCAL  = 1
+           ENDIF
+          ELSE
+           A_loc_PTR   => DUMMYA_loc
+           IRN_loc_PTR => DUMMYIRN_loc
+           JCN_loc_PTR => DUMMYJCN_loc
+           COLSCA_PTR  => DUMMYSCA
+           ROWSCA_PTR  => DUMMYSCA
+           SIZESCAL  = 1
+          ENDIF
+         ELSE
+C         distributed matrix
+C         ---------------------------------------------------
+C         In order to have possibly IRN_loc/JCN_loc/A_loc
+C         of size 0, avoid to pass them inside REDISTRIBUTION
+C         and pass id instead
+C         NZ_locMAX8 gives as a maximum buffer size (send/recv) used
+C          an upper bound to limit buffers on small matrices
+C         ---------------------------------------------------
+          CALL MPI_ALLREDUCE(id%KEEP8(29), NZ_locMAX8, 1, 
+     &              MPI_INTEGER8, MPI_MAX, id%COMM, IERR)
+          IF (NZ_locMAX8 .LT. int(NBRECORDS,8)) THEN
+              NBRECORDS = int(NZ_locMAX8)
+          ENDIF
+          NZ_loc8 = id%KEEP8(29)
+          LSCAL   = (KEEP(52).EQ.7).OR.(KEEP(52).EQ.8)
+C         available on all MPI
+          IF (LSCAL) THEN
+            COLSCA_PTR => id%COLSCA
+            ROWSCA_PTR => id%ROWSCA
+          ELSE
+           COLSCA_PTR  => DUMMYSCA
+           ROWSCA_PTR  => DUMMYSCA
+           SIZESCAL  = 1
+          ENDIF
+         ENDIF
+#if ! defined(PCPRET)
+          IF (id%KEEP(72).EQ.1) THEN
+           NBRECORDS = max(3,NBRECORDS/10)
+          ENDIF
+         CALL SMUMPS_FAC_DIST_ARROWHEADS_OMP ( id%N,
+     &     NZ_loc8, 
+C          replace id by:
+     &        A_loc_PTR(1), IRN_loc_PTR(1), JCN_loc_PTR(1),
+     &        SIZESCAL, LSCAL, COLSCA_PTR(1), ROWSCA_PTR(1), 
+     &     DBLARR(1), id%KEEP8(26), INTARR(1),
+     &     id%KEEP8(27),
+     &     id%PTR8ARR(1), id%NINCOLARR(1),
+     &     id%NINROWARR(1), id%PTRDEBARR(1),
+     &     id%FILS(1),
+     &     KEEP(1), id%KEEP8(1), id%MYID, id%COMM, NBRECORDS,
+     &     S_PTR_ARG(1), MAXS_ARG, id%root, id%PROCNODE_STEPS(1),
+     &     id%NPROCS, id%NSLAVES, id%SYM_PERM(1), id%STEP(1),
+     &     id%ICNTL(1), id%INFO(1), NSEND8, NLOCAL8,
+     &     id%ISTEP_TO_INIV2(1),
+     &     id%CANDIDATES(1,1) 
+     &     )
+         CALL MPI_BARRIER(id%COMM, IERR)
+#else 
+#endif
+C     
+         IF ( KEEP(46) .eq. 0 .AND. id%MYID.eq.MASTER ) THEN
+C          ------------------------------
+C          The host is not working -> had
+C          no data from initial matrix
+C          ------------------------------
+           NSEND8  = 0_8
+           NLOCAL8 = 0_8
+         END IF
+C        -------------------------
+C        Check for possible errors
+C        -------------------------
+         CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
+     &                    id%COMM, id%MYID )
+         IF ( id%INFO( 1 ) .LT. 0 ) GOTO 500
+         CALL MPI_REDUCE( NSEND8, NSEND_TOT8, 1, MPI_INTEGER8,
+     &                 MPI_SUM, MASTER, id%COMM, IERR )
+         CALL MPI_REDUCE( NLOCAL8, NLOCAL_TOT8, 1, MPI_INTEGER8,
+     &                 MPI_SUM, MASTER, id%COMM, IERR )
+         IF ( PROKG ) THEN
+           WRITE(MPG,125) NLOCAL_TOT8, NSEND_TOT8
+         END IF
+C}        
+      ELSE
+C{   =======================================================
       IF ( KEEP(54) .eq. 0 ) THEN
 C     {
 C       ================================================
@@ -2242,6 +2471,8 @@ C     --------------------------
 C     }
       ENDIF ! distributed matrix
 C     }
+      ENDIF !  "old" multithreaded algorithm 
+C     }
       ELSE
 C     {
 C       -------------------
@@ -2305,8 +2536,9 @@ C       We check the number of threads.
             id%INFO(1)=-58
             id%INFO(2)=KEEP(400)
             IF (LPOK) WRITE(LP,'(A,A,I5,A,I5)')
-     &" FAILURE DETECTED IN FACTORIZATION: #threads for KEEP(401)",
-     &" changed from",KEEP(400)," at analysis to", NOMP
+     &" FAILURE DETECTED IN FACTORIZATION: #threads for multithreaded",
+     &" tree parallelism changed from",KEEP(400)," at analysis to", 
+     &  NOMP
           ENDIF
 C       error check
         CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
@@ -2393,6 +2625,13 @@ C
         SMUMPS_LBUFR_BYTES8 = min(SMUMPS_LBUFR_BYTES8,
      &                            int(huge(I4)-100,8))
         SMUMPS_LBUFR_BYTES  = int( SMUMPS_LBUFR_BYTES8 )
+C       SMUMPS_LBUFR is the size of the buffer as a number of integers,
+C       we round SMUMPS_LBUFR (size in #integers) above to have at least
+C       SMUMPS_LBUFR_BYTES available in the buffer.
+        SMUMPS_LBUFR = (SMUMPS_LBUFR_BYTES+KEEP(34)-1)/KEEP(34)
+C       Finally, make SMUMPS_LBUFR_BYTES a multiple of KEEP(34) by setting
+C       SMUMPS_LBUFR_BYTES to the number of bytes that will be allocated
+        SMUMPS_LBUFR_BYTES = SMUMPS_LBUFR*KEEP(34)
         IF (KEEP(48)==5) THEN
 C          Since the buffer is going to be allocated, use
 C          it as the constraint for memory/granularity
@@ -2463,12 +2702,17 @@ C       are in numbers of bytes).
         IF ( PROK ) THEN
           WRITE( MP, 9999 ) SMUMPS_LBUFR_BYTES,
      &                      SMUMPS_LBUF, SMUMPS_LBUF_INT
+        ELSE 
+         IF (PROKG) THEN
+          WRITE( MPG, 9999 ) SMUMPS_LBUFR_BYTES,
+     &                      SMUMPS_LBUF, SMUMPS_LBUF_INT
+         ENDIF
         END IF
  9999   FORMAT( /,' Allocated buffers',/,' ------------------',/,
-     &  ' Size of reception buffer in bytes ...... = ', I10,
+     &  ' Size of reception buffer in bytes ...... = ', I12,
      &  /,
-     &  ' Size of async. emission buffer (bytes).. = ', I10,/,
-     &  ' Small emission buffer (bytes) .......... = ', I10)
+     &  ' Size of async. emission buffer (bytes).. = ', I12,/,
+     &  ' Small emission buffer (bytes) .......... = ', I12)
 C       --------------------------
 C       Allocate small send buffer
 C       required for SMUMPS_FAC_B
@@ -2490,7 +2734,6 @@ C       --------------------------------
 C       Allocate reception buffer on all procs
 C       This is done now.
 C       --------------------------------------
-        SMUMPS_LBUFR = (SMUMPS_LBUFR_BYTES+KEEP(34)-1)/KEEP(34)
         ALLOCATE( BUFR( SMUMPS_LBUFR ),stat=IERR )
         IF ( IERR .NE. 0 ) THEN
           id%INFO(1) = -13
@@ -2820,7 +3063,7 @@ C     --------------------------------
       IF (allocated(BUFR)) DEALLOCATE(BUFR)
       CALL SMUMPS_BUF_DEALL_SMALL_BUF( IERR )
 C//PIV
-      IF (KEEP(219).NE.0) THEN
+      IF ((KEEP(50).EQ.2).AND.(KEEP(219).NE.0)) THEN
       CALL SMUMPS_BUF_DEALL_MAX_ARRAY()
       ENDIF
 C
@@ -2832,6 +3075,10 @@ C     not be necessary.
      &                    id%COMM, id%MYID )
 C
       CALL SMUMPS_EXTRACT_SCHUR_REDRHS(id)
+C     return to user singular values
+      IF (id%KEEP(19) .NE.0) THEN
+       CALL SMUMPS_EXTRACT_SINGULAR_VALUES(id)
+      ENDIF
       IF (KEEP(201) .GT. 0) THEN
          IF ((KEEP(201).EQ.1) .OR. (KEEP(201).EQ.2)) THEN
             IF ( I_AM_SLAVE ) THEN
@@ -3404,6 +3651,9 @@ C           flops when BLR activated
           ELSE
             RINFOG(14) = 0.0E00
           ENDIF
+        IF (id%MYID .eq. MASTER) THEN
+          KEEP(399) = KEEP399_SAVE
+        ENDIF
       ENDIF
 C     ==============================
 C     NULL PIVOTS AND RANK-REVEALING
@@ -3445,7 +3695,7 @@ C      (do not allocate)
         ENDIF
        ELSE
 C       id%PIVNUL_LIST(1:KEEP(109)) used during sol_driver on slaves 
-C       to initialize id%RHSCOMP
+C       to initialize id%RHSINTR
         IF (KEEP(109).GT.0) THEN
           ALLOCATE(id%PIVNUL_LIST(KEEP(109)), stat=IERR)
           IF ( IERR .GT. 0 ) THEN
@@ -3459,6 +3709,34 @@ C}
       CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
      &                    id%COMM, id%MYID )
       IF ( id%INFO(1).lt.0 ) GOTO 490
+      IF ( (KEEP(19).NE.0) .AND. (KEEP(143) .NE. KEEP(17)) ) THEN
+C
+C         Raise a warning (on all MPI processes) since determinant or
+C         inertia or null pivot list is not consistent with deficiency
+C         computed with ICNTL(46)=1.
+C
+        id%INFO(1) = id%INFO(1)+16
+        id%INFO(2) = KEEP(112)+KEEP(143)
+        IF (KEEP(118) .GE. 40) THEN
+          IF ( PROKG ) THEN
+            WRITE(MPG,'(/A,A/,A,A,I8/,A,A,I8/)')
+     &      " WARNING: in the context of rank-revealing,",
+     &      " the inertia, determinant and pivnul list",  
+     &      " are computed with RR (rank-revealing)-LU,", 
+     &      " but the deficiency found by RR-LU: ", 
+     &      id%INFO(2),
+     &      " is different from the deficiency computed",
+     &      " with ICNTL(56)>0: ",  KEEP(112)+KEEP(17)
+          ENDIF
+        ELSE
+          IF ( LP .GT. 0 ) THEN
+            WRITE(LP,'(/A,A/,A/)')
+     &      " ERROR : in the context of rank-revealing,",
+     &      " the inertia, determinant and pivnul list",  
+     &      " are not correct because RR LU not called "
+          ENDIF
+        ENDIF
+      ENDIF
 C     ========================================
 C     We now provide to the host the part of
 C     PIVNUL_LIST resulting from the processing
@@ -3619,9 +3897,6 @@ C         of max-weighted matching)
           IF (id%KEEP(23).NE.0) THEN
             CALL SMUMPS_DETER_SIGN_PERM(
      &           RINFOG(12), id%N,
-C           id%STEP: used as workspace of size N still
-C                    allocated on master; restored on exit
-     &           id%STEP(1),
      &           id%UNS_PERM(1) )
 C           Remark that RINFOG(12/13) are modified only
 C           on the host but will be broadcast on exit
@@ -3703,6 +3978,14 @@ c         IF ( KEEP(17) .ne. 0 )
               WRITE(MPG, 99997) INFOG(50)
             ENDIF
           ENDIF
+          !Smallest pivot with also null pivots in abs value
+          WRITE(MPG, 99995) RINFOG(19)
+          !Smallest pivot in abs value
+          WRITE(MPG, 99993) RINFOG(20)
+          !Largest pivot in abs value
+          WRITE(MPG, 99994) RINFOG(21)
+          !value of ICNTL(12) that was effectively used.
+          WRITE(MPG, 99996) INFOG(24)
           ! Memory compress
           WRITE(MPG, 99981) INFOG(14)
           ! Extra copies due to ip stack in unsym case
@@ -3919,7 +4202,7 @@ C     at the end of a phase S is always
       END IF
 C
 C     Goto 513 is done in case of error where LOAD_INIT was
-C     called but not OOC_INIT_FACTO.
+C     called but not the scaling nor OOC_INIT_FACTO.
  513  CONTINUE
       IF ( I_AM_SLAVE ) THEN
          CALL SMUMPS_LOAD_END( id%INFO(1), id%NSLAVES, IERR )
@@ -3928,9 +4211,37 @@ C     called but not OOC_INIT_FACTO.
       CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
      &     id%COMM, id%MYID )
 C
-C     Goto 517 is done when an error occurs when GPU initialization
-C     has been performed but not LOAD_INIT or OOC_INIT_FACTO
+C     Goto 516 is done in case of error when GPU initialiwqtion
+C     has been performed and scaling was optionally computed but
+C     not LOAD_INIT nor OOC_INIT_FACTO. We can then extract
+C     scaling arrays in case of error.
+ 516  CONTINUE
+C     --------------------------------------------
+C     We now build id%ROWSCA_loc and id%COLSCA_loc
+C     in case of successful factorization, in the
+C     numbering associated to the fully summed
+C     variables of the frontal matrices.
+C     This requires the factorization to be
+C     successful because otherwise we do not have
+C     the final lists of pivots associated to
+C     the fronts, including delayed pivots and
+C     symmetric/unsymmetric permutations done
+C     during the factorization process.
+C     --------------------------------------------
+      IF (LSCAL .AND. id%INFO(1).GE.0) THEN
+        CALL SMUMPS_EXTRACT_SCALING(id)
+C       occurs during scaling extraction, keep the error.
+        IF ( id%INFO(1) .LT. 0 ) THEN
+          IF (LPOK) THEN
+            WRITE(LP,*) "Facto OK but error during EXTRACT_SCALING",
+     &      id%INFO(1:2)
+          ENDIF
+        ENDIF
+      ENDIF
 C
+C     Goto 517 is done when an error occurs when GPU initialization
+C     has been performed but not LOAD_INIT or OOC_INIT_FACTO, e.g.
+C     when an error occurred during the scaling.
  517  CONTINUE
       IF (associated( PIVNUL_LIST_STRUCT%PIVNUL_LIST)) THEN
         DEALLOCATE(PIVNUL_LIST_STRUCT%PIVNUL_LIST)
@@ -3951,10 +4262,12 @@ C
  120  FORMAT(/' Local redistrib: data local/sent           =',I16,I16)
  125  FORMAT(/' Redistrib: total data local/sent           =',I16,I16)
  130  FORMAT(//'****** FACTORIZATION STEP ********'/)
+ 140  FORMAT(/' Statistics on the scaling phase'
+     & /' Elapsed time for scaling                   =',F12.4)
  160  FORMAT(
-     & /' Elapsed time to reformat/distribute matrix =',F12.4)
+     & ' Elapsed time to reformat/distribute matrix =',F12.4/)
  166  FORMAT(' Max difference from 1 after scaling the entries',
-     &       ' for ONE-NORM (option 7/8)   =',D9.2)
+     &       ' for ONE-NORM (option 7/8)   =',D9.2/)
  170  FORMAT(' STATISTICS PRIOR NUMERICAL FACTORIZATION ...'/
      &        ' Size of internal working array S           =',I16/
      &        ' Size of internal working array IS          =',I16/
@@ -4012,6 +4325,14 @@ C
      &      I16)
 99997 FORMAT( ' INFOG (50) Number of negative AND null pivots      =',
      &      I16)
+99995 FORMAT( ' RINFOG(19) Smallest pivot WITH perturbed pivots    =',
+     &     1PD10.3)
+99993 FORMAT( ' RINFOG(20) Smallest pivot WITHOUT perturbed pivots =',
+     &     1PD10.3)
+99994 FORMAT( ' RINFOG(21) Largest pivot in absolute value         =',
+     &     1PD10.3)
+99996 FORMAT( ' INFOG (24) Effective value of ICNTL(12)            =',
+     &     I16)
 99984 FORMAT(/'Leaving factorization with ...'/
      &        ' RINFOG (2) Operations in node assembly             =',
      &          1PD10.3/                                   
@@ -4100,6 +4421,186 @@ C
  110  FORMAT(A48,I18)
       END SUBROUTINE SMUMPS_AVGMAX_STAT8
 C
+C
+C     ==================================================================
+C
+      SUBROUTINE SMUMPS_EXTRACT_SCALING(id)
+      USE SMUMPS_STRUC_DEF
+      IMPLICIT NONE
+C
+C     Purpose:
+C     =======
+C
+C     Extract distributed scaling arrays from SMUMPS_EXTRACT_SCALING
+C     In case of unsymmetric permutation, ROWSCA and COLSCA correspond
+C     to Dr and Dc, in the expression Dr A Q Dc. In other terms, Dc
+C     is compatbile with the front column indices, it does not
+C     correspond to the column indices of A, meaning that Q is not
+C     needed to just extract the scaling values.
+C
+C
+      TYPE(SMUMPS_STRUC) :: id
+      INTEGER, EXTERNAL  :: MUMPS_PROCNODE
+C
+C     MPI
+C     ===
+C
+      INCLUDE 'mpif.h'
+C
+C     Local declarations
+C     ==================
+C
+      REAL, DIMENSION(:), POINTER :: COLSCA
+      REAL, DIMENSION(:), POINTER :: ROWSCA
+      INTEGER, PARAMETER :: MASTER = 0
+C
+      INTEGER    :: ISTEP, NPIV, LIELL
+      INTEGER    :: IERR_MPI, allocok
+      INTEGER    :: ISCA
+      INTEGER    :: JROW, JCOL, IPOS, JJ ! access to IS
+      INTEGER    :: LIW_PASSED
+      INTEGER(8) :: LALLOC
+C
+C     Free and reallocate distributed scaling arrays :
+C     - in symmetric, COLSCA_loc points on ROWSCA_loc.
+C     - not allocated if KEEP(89)=0
+C
+      NULLIFY(ROWSCA)
+      NULLIFY(COLSCA)
+      IF (associated(id%ROWSCA_loc)) THEN
+        DEALLOCATE(id%ROWSCA_loc)
+        NULLIFY(id%ROWSCA_loc)
+      ENDIF
+      IF (associated(id%COLSCA_loc)) THEN
+        IF (id%KEEP(50) .EQ. 0) THEN
+          DEALLOCATE(id%COLSCA_loc)
+        ENDIF
+        NULLIFY(id%COLSCA_loc)
+      ENDIF
+C     id%ROWSCA and id%COLSCA are available on master,
+C     allocate ROWSCA and COLSCA of order N on other procs
+      IF ( id%MYID .EQ. MASTER ) THEN
+        ROWSCA => id%ROWSCA
+        COLSCA => id%COLSCA
+        IF (.NOT. associated(ROWSCA)) THEN
+          WRITE(*,*) "Internal error 1 in SMUMPS_EXTRACT_SCALING"
+          CALL MUMPS_ABORT()
+        ENDIF
+        IF (.NOT. associated(COLSCA)) THEN
+          WRITE(*,*) "Internal error 2 in SMUMPS_EXTRACT_SCALING"
+          CALL MUMPS_ABORT()
+        ENDIF
+      ELSE
+        IF (id%KEEP(50).EQ.0) THEN
+          ALLOCATE(ROWSCA(id%N),COLSCA(id%N),stat=allocok)
+          LALLOC = int(id%N+id%N,8)
+        ELSE
+          ALLOCATE(ROWSCA(id%N),stat=allocok)
+          COLSCA => ROWSCA
+          LALLOC = int(id%N,8)
+        ENDIF
+        IF (allocok .GT. 0) THEN
+          id%INFO(1)=-13
+          CALL MUMPS_SET_IERROR(LALLOC,id%INFO(2))
+        ENDIF
+      ENDIF
+      CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                        id%COMM, id%MYID )
+C     Jump to 110 in case of error on ROWSCA or COLSCA
+C     on one of the MPI processes.
+      IF (id%INFO(1) .LT. 0) GOTO 110
+C
+      IF ( id%KEEP(89) .GT. 0) THEN
+        IF (id%KEEP(50).EQ.0) THEN
+          ALLOCATE(id%ROWSCA_loc(id%KEEP(89)),
+     &             id%COLSCA_loc(id%KEEP(89)),stat=allocok)
+          LALLOC = int(id%KEEP(89),8)*2_8
+        ELSE
+          ALLOCATE(id%ROWSCA_loc(id%KEEP(89)),stat=allocok)
+          id%COLSCA_loc => id%ROWSCA_loc
+          LALLOC = int(id%KEEP(89),8)
+        ENDIF
+        IF (allocok .GT. 0) THEN
+          id%INFO(1)=-13
+          CALL MUMPS_SET_IERROR(LALLOC,id%INFO(2))
+        ENDIF
+      ENDIF
+      CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                        id%COMM, id%MYID )
+C     Jump to 100 in case of error (we free everything)
+      IF (id%INFO(1) .LT. 0) GOTO 100
+      CALL MPI_BCAST(ROWSCA(1), id%N, MPI_REAL,
+     &               MASTER, id%COMM, IERR_MPI)
+      IF (id%KEEP(50) .EQ. 0) THEN
+        CALL MPI_BCAST(COLSCA(1), id%N, MPI_REAL,
+     &                 MASTER, id%COMM, IERR_MPI)
+      ENDIF
+      LIW_PASSED = max(id%KEEP(32),1)
+      ISCA = 1
+      IF ( id%MYID .ne. MASTER .OR.
+     &     id%KEEP(46) .eq. 1 ) THEN ! I_AM_SLAVE
+        DO ISTEP = 1, id%KEEP(28)
+          IF ( id%MYID_NODES.EQ. MUMPS_PROCNODE(
+     &         id%PROCNODE_STEPS(ISTEP),
+     &         id%KEEP(199) ) ) THEN
+              CALL MUMPS_SOL_GET_NPIV_LIELL_IPOS( ISTEP, id%KEEP,
+     &        NPIV, LIELL, IPOS,
+     &        id%IS(1), LIW_PASSED, id%PTLUST_S(1), id%STEP(1), id%N)
+            IF ( id%KEEP(50) .EQ. 0 ) THEN
+C             Row indices:
+              JROW = IPOS + 1
+C             Column indices:
+              JCOL = IPOS + 1 + LIELL
+            ELSE
+C             Use row indices because column indices may have
+C             been set to negative to flag 2x2 pivots
+              JROW = IPOS + 1
+            ENDIF
+            IF (id%KEEP(50).EQ.0) THEN
+              DO JJ = 1, NPIV
+                id%ROWSCA_loc(ISCA+JJ-1) = ROWSCA(id%IS(JROW+JJ-1))
+                id%COLSCA_loc(ISCA+JJ-1) = COLSCA(id%IS(JCOL+JJ-1))
+              ENDDO
+            ELSE
+              DO JJ = 1, NPIV
+                id%ROWSCA_loc(ISCA+JJ-1) = ROWSCA(id%IS(JROW+JJ-1))
+              ENDDO
+            ENDIF
+            ISCA = ISCA + NPIV
+          ENDIF
+        ENDDO
+      ENDIF
+C     End of EXTRACT_SCALING, we keep id%ROWSCA_loc and id%COLSCA_loc
+C     but free ROWSCA and COLSCA
+      GOTO 110
+      RETURN
+ 100  CONTINUE
+C     Exit with error, free what was allocated
+      IF (associated(id%ROWSCA_loc)) THEN
+        DEALLOCATE(id%ROWSCA_loc)
+        NULLIFY(id%ROWSCA_loc)
+      ENDIF
+      IF (associated(id%COLSCA_loc)) THEN
+        IF (id%KEEP(50) .EQ. 0) THEN
+          DEALLOCATE(id%COLSCA_loc)
+        ENDIF
+        NULLIFY(id%COLSCA_loc)
+      ENDIF
+ 110  CONTINUE
+C     Free local ROWSCA and COLSCA arrays
+      IF ( id%MYID .NE. 0) THEN
+        IF (associated(ROWSCA)) DEALLOCATE(ROWSCA)
+        IF ( id%KEEP(50) .EQ. 0 ) THEN
+          IF (associated(COLSCA)) DEALLOCATE(COLSCA)
+        ENDIF
+      ENDIF
+      NULLIFY(ROWSCA)
+      NULLIFY(COLSCA)
+      RETURN
+      END SUBROUTINE SMUMPS_EXTRACT_SCALING
+C
+C     ==================================================================
+C
       SUBROUTINE SMUMPS_EXTRACT_SCHUR_REDRHS(id)
       USE SMUMPS_STRUC_DEF
       IMPLICIT NONE
@@ -4340,3 +4841,145 @@ C                 of size SIZE_SCHUR.
       ENDIF
       RETURN
       END SUBROUTINE SMUMPS_EXTRACT_SCHUR_REDRHS
+      SUBROUTINE SMUMPS_EXTRACT_SINGULAR_VALUES(id)
+      USE SMUMPS_STRUC_DEF
+      IMPLICIT NONE
+C
+C  Purpose
+C  =======
+C
+C     
+      TYPE(SMUMPS_STRUC) :: id
+C
+C  Local variables
+C  ===============
+C
+      INCLUDE 'mpif.h'
+      INCLUDE 'mumps_tags.h'
+      INCLUDE 'mumps_headers.h'
+      INTEGER :: STATUS(MPI_STATUS_SIZE)
+      INTEGER :: IERR
+      INTEGER, PARAMETER :: MASTER = 0
+      INTEGER :: ID_ROOT, ALLOCOK
+C
+C  External functions
+C  ==================
+C
+      INTEGER MUMPS_PROCNODE
+      EXTERNAL MUMPS_PROCNODE
+C     Quick return in case factorization did not terminate correctly
+      IF (id%INFO(1) .LT. 0) RETURN
+C     Quick return if Postponing + rank revealing option off
+      IF (id%KEEP(19) .EQ. 0) RETURN
+C     Get Root id
+      ID_ROOT =MUMPS_PROCNODE(
+     &    id%PROCNODE_STEPS(id%STEP(id%KEEP(20))),
+     &    id%KEEP(199))
+      IF ( id%KEEP( 46 )  .NE. 1 ) THEN
+        ID_ROOT = ID_ROOT + 1
+      END IF  
+C     =================================
+C     Singular values are stored in 
+C     root%SINGULAR_VALUES
+C     We copy it to id%SINGULAR_VALUES
+C     =================================
+      IF ((ID_ROOT.EQ.id%MYID).AND.(id%MYID.EQ.MASTER)) THEN
+C        write(6,*) " singular_values already on host"
+         IF (associated(id%SINGULAR_VALUES))
+     &        DEALLOCATE(id%SINGULAR_VALUES)
+         NULLIFY(id%SINGULAR_VALUES)
+         id%NB_SINGULAR_VALUES=id%root%NB_SINGULAR_VALUES
+         ALLOCATE(id%SINGULAR_VALUES(id%NB_SINGULAR_VALUES)
+     &        , stat=ALLOCOK)
+         IF (ALLOCOK.GT.0) THEN
+            id%INFO(1)=-13
+            id%INFO(2)= id%NB_SINGULAR_VALUES
+            RETURN
+         END IF
+         CALL scopy(id%NB_SINGULAR_VALUES,
+     &        id%root%SINGULAR_VALUES(1), 1,
+     &        id%SINGULAR_VALUES(1), 1)
+      ELSE
+         IF (id%MYID.EQ.ID_ROOT) THEN
+C     Send
+C           write(6,*) " id%MYID sends singular_values "
+            CALL MPI_SEND(
+     &           id%root%NB_SINGULAR_VALUES,
+     &           1,
+     &           MPI_INTEGER,
+     &           MASTER, TAG_ROOT1,
+     &           id%COMM, IERR )
+            CALL MPI_SEND(
+     &           id%root%SINGULAR_VALUES(1),
+     &           id%root%NB_SINGULAR_VALUES,
+     &           MPI_REAL,
+     &           MASTER, TAG_ROOT2,
+     &           id%COMM, IERR )
+         ELSEIF (id%MYID.EQ.MASTER) THEN
+C     Receive
+            CALL MPI_RECV( id%NB_SINGULAR_VALUES,
+     &           1,
+     &           MPI_INTEGER, ID_ROOT, TAG_ROOT1,
+     &           id%COMM, STATUS, IERR )
+            IF (associated(id%SINGULAR_VALUES))
+     &           DEALLOCATE(id%SINGULAR_VALUES)
+            NULLIFY(id%SINGULAR_VALUES)
+            ALLOCATE(id%SINGULAR_VALUES(id%NB_SINGULAR_VALUES)
+     &           , stat=ALLOCOK)
+            IF (ALLOCOK.GT.0) THEN
+               id%INFO(1)=-13
+               id%INFO(2)= id%NB_SINGULAR_VALUES
+               RETURN
+            END IF
+            CALL MPI_RECV( id%SINGULAR_VALUES(1),
+     &           id%NB_SINGULAR_VALUES,
+     &           MPI_REAL, ID_ROOT, TAG_ROOT2,
+     &           id%COMM, STATUS, IERR )
+         ENDIF
+      ENDIF
+      RETURN
+      END SUBROUTINE SMUMPS_EXTRACT_SINGULAR_VALUES
+      SUBROUTINE SMUMPS_SET_NOMP_MAX(KEEP281, KEEP361,
+     &                               N, NOMP_MAX)
+!$    USE OMP_LIB
+C
+C  Purpose
+C  =======
+C     set NOMP_MAX from KEEP(281)
+C     on output NOMP_MAX >=0
+C
+C  Parameters
+C  ==========
+C
+      INTEGER, INTENT(IN)    :: KEEP281, KEEP361, N
+      INTEGER, INTENT(OUT)   :: NOMP_MAX
+C     
+C     Local variables
+C   
+      INTEGER :: NOMP
+C
+C     out-of-range entries treated as -1
+      NOMP_MAX= max(-1, KEEP281)
+      NOMP    = 1
+!$    NOMP = omp_get_max_threads()
+      IF (NOMP_MAX.EQ.-1) THEN
+C     automatic setting
+       IF (N.LE.KEEP361) THEN
+         NOMP_MAX = 0
+         RETURN
+       ENDIF
+       IF (NOMP.GT.1) THEN
+C       conservative because of memory allocation
+        NOMP_MAX = min(NOMP, 10)
+       ELSE
+C       no multithreading and all parallel do suppressed
+        NOMP_MAX = 0
+       ENDIF
+      ELSE
+C     NOMP_MAX >=0
+C     use provided value
+       NOMP_MAX = min(NOMP_MAX, NOMP)
+      ENDIF
+C
+      RETURN
+      END SUBROUTINE SMUMPS_SET_NOMP_MAX
diff -pruN 5.6.2-2.1/src/sfac_front_LDLT_type1.F 5.7.1-1/src/sfac_front_LDLT_type1.F
--- 5.6.2-2.1/src/sfac_front_LDLT_type1.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/sfac_front_LDLT_type1.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -136,7 +136,7 @@ C
       XSIZE  = KEEP(IXSZ)
       NFRONT = IW(IOLDPS+XSIZE)
       LDA    = NFRONT
-      NASS   = iabs(IW(IOLDPS+2+XSIZE))
+      NASS   = abs(IW(IOLDPS+2+XSIZE))
       IW(IOLDPS+3+XSIZE) =  -99999
       LR_ACTIVATED= .FALSE.        
       COMPRESS_PANEL = .FALSE.
@@ -251,7 +251,8 @@ C
      &        NFRONT-NASS, LRGROUPS, NPARTSCB, 
      &        NPARTSASS, BEGS_BLR)
          CALL REGROUPING2(BEGS_BLR, NPARTSASS, NASS, NPARTSCB,
-     &        NFRONT-NASS, KEEP(488), .FALSE., KEEP(472))     
+     &        NFRONT-NASS, KEEP(488), .FALSE., KEEP(472), 
+     &        NFRONT, KEEP(1))     
          NB_BLR = NPARTSASS + NPARTSCB
          call MAX_CLUSTER(BEGS_BLR,NB_BLR,MAXI_CLUSTER)
          MAXI_RANK = KEEP(479)*MAXI_CLUSTER
diff -pruN 5.6.2-2.1/src/sfac_front_LDLT_type2.F 5.7.1-1/src/sfac_front_LDLT_type2.F
--- 5.6.2-2.1/src/sfac_front_LDLT_type2.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/sfac_front_LDLT_type2.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -74,7 +74,7 @@ C
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
       INTEGER, INTENT(IN) :: NINROWARR(KEEP(195))
       INTEGER, INTENT(IN) :: PTRDEBARR(KEEP(196))
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INTEGER(8) :: PTRAST(KEEP(28))
       INTEGER(8) :: PTRFAC(KEEP(28))
       INTEGER(8) :: PAMASTER(KEEP(28))
@@ -187,7 +187,7 @@ C
       IOLDPS = PTLUST_S(STEP( INODE ))
       POSELT = PTRAST(STEP( INODE ))
       NFRONT = IW(IOLDPS+XSIZE)
-      NASS   = iabs(IW(IOLDPS+2+XSIZE))
+      NASS   = abs(IW(IOLDPS+2+XSIZE))
       LDAFS  = NASS
       IF ((KEEP(219).EQ.1).AND.(KEEP(207).EQ.1).AND.(KEEP(50).EQ.2)
      &   ) THEN
@@ -299,7 +299,8 @@ C
      &        0, LRGROUPS, NPARTSCB, 
      &        NPARTSASS, BEGS_BLR)
          CALL REGROUPING2(BEGS_BLR, NPARTSASS, NASS, NPARTSCB,
-     &        0, KEEP(488), .FALSE., KEEP(472))     
+     &        0, KEEP(488), .FALSE., KEEP(472), 
+     &        NFRONT, KEEP(1))     
          NB_BLR = NPARTSASS + NPARTSCB
          call MAX_CLUSTER(BEGS_BLR,NB_BLR,MAXI_CLUSTER)
          MAXI_RANK = KEEP(479)*MAXI_CLUSTER
diff -pruN 5.6.2-2.1/src/sfac_front_LU_type1.F 5.7.1-1/src/sfac_front_LU_type1.F
--- 5.6.2-2.1/src/sfac_front_LU_type1.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/sfac_front_LU_type1.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -143,7 +143,7 @@ C
       LAFAC  = -9999_8  
       XSIZE      = KEEP(IXSZ)
       NFRONT     = IW(IOLDPS+XSIZE)
-      NASS       = iabs(IW(IOLDPS+2+XSIZE))
+      NASS       = abs(IW(IOLDPS+2+XSIZE))
       IW(IOLDPS+3+XSIZE) =  -99999
       LR_ACTIVATED = .FALSE.        
       COMPRESS_PANEL = .FALSE.
@@ -257,7 +257,8 @@ C
      &        NFRONT-NASS, LRGROUPS, NPARTSCB, 
      &        NPARTSASS, BEGS_BLR)
          CALL REGROUPING2(BEGS_BLR, NPARTSASS, NASS, NPARTSCB,
-     &        NFRONT-NASS, KEEP(488), .FALSE., KEEP(472))     
+     &        NFRONT-NASS, KEEP(488), .FALSE., KEEP(472), 
+     &        NFRONT, KEEP(1))     
          NB_BLR = NPARTSASS + NPARTSCB
          call MAX_CLUSTER(BEGS_BLR,NB_BLR,MAXI_CLUSTER)
          MAXI_RANK = KEEP(479)*MAXI_CLUSTER
diff -pruN 5.6.2-2.1/src/sfac_front_LU_type2.F 5.7.1-1/src/sfac_front_LU_type2.F
--- 5.6.2-2.1/src/sfac_front_LU_type2.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/sfac_front_LU_type2.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -75,7 +75,7 @@ C
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
       INTEGER, INTENT(IN) :: NINROWARR(KEEP(195))
       INTEGER, INTENT(IN) :: PTRDEBARR(KEEP(196))
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INTEGER(8) :: PTRAST(KEEP(28))
       INTEGER(8) :: PTRFAC(KEEP(28))
       INTEGER(8) :: PAMASTER(KEEP(28))
@@ -166,7 +166,7 @@ C
       POSELT = PTRAST(STEP( INODE ))
       XSIZE  = KEEP(IXSZ)
       NFRONT = IW(IOLDPS+XSIZE)
-      NASS   = iabs(IW(IOLDPS+2+XSIZE))
+      NASS   = abs(IW(IOLDPS+2+XSIZE))
       IW(IOLDPS+3+XSIZE) =  -99999
       LR_ACTIVATED   = (IW(IOLDPS+XXLR).GT.0)
       COMPRESS_PANEL = (IW(IOLDPS+XXLR).GE.2)
@@ -286,7 +286,8 @@ C
      &        NFRONT-NASS, LRGROUPS, NPARTSCB, 
      &        NPARTSASS, BEGS_BLR)
          CALL REGROUPING2(BEGS_BLR, NPARTSASS, NASS, NPARTSCB,
-     &        NFRONT-NASS, KEEP(488), .FALSE., KEEP(472))     
+     &        NFRONT-NASS, KEEP(488), .FALSE., KEEP(472), 
+     &        NFRONT, KEEP(1))     
          NB_BLR = NPARTSASS + NPARTSCB
          call MAX_CLUSTER(BEGS_BLR,NB_BLR,MAXI_CLUSTER)
          MAXI_RANK = KEEP(479)*MAXI_CLUSTER
diff -pruN 5.6.2-2.1/src/sfac_front_aux.F 5.7.1-1/src/sfac_front_aux.F
--- 5.6.2-2.1/src/sfac_front_aux.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/sfac_front_aux.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -129,7 +129,7 @@ C
             ELSE
               IF (J3.EQ.0) GOTO 370
 #if defined(_OPENMP)
-              IF (KEEP(351).EQ.1 .AND. J3.GE.KEEP(360)) THEN
+              IF (J3.GE.KEEP(360)) THEN
                 J1_ini = J1
                 CHUNK = max(KEEP(360)/2,(J3+NOMP-1)/NOMP)
 !$OMP  PARALLEL DO schedule(static, CHUNK)
@@ -289,7 +289,7 @@ C
           ENDIF
         ENDIF
 #endif
-        IF (KEEP(351).EQ.2) THEN
+        IF (KEEP(351).EQ.1) THEN
           MAXFROMN = 0.0E0
           IF (NEL2 > 0) THEN
             IS_MAXFROMN_AVAIL = .TRUE.
@@ -677,6 +677,9 @@ C
         NPIV   = IW(IOLDPS+1+XSIZE)
         IBEG_BLOCK = NPIV
         IF (NASS.EQ.NPIV) GOTO 500
+        IF (KEEP(19).GT.0) THEN
+         GOTO 500
+        ENDIF
         IS_MAXFROMN_AVAIL = .FALSE.
  120    CALL SMUMPS_FAC_H(NFRONT,NASS,IW,LIW,A,LA,
      &     INOPV, NOFFW,
@@ -762,6 +765,7 @@ C
       REAL ZERO
       PARAMETER( ZERO = 0.0E0 )
       REAL RZERO, RMAX, AMROW, MAX_PREV_in_PARPIV
+      REAL RCMAX
       INTEGER(8) :: APOSMAX, APOSROW
       REAL       :: RMAX_NORELAX
       REAL PIVNUL, ABS_PIVOT
@@ -1006,11 +1010,45 @@ C
             RMAX         = max(RMAX,abs(RMAX_NORELAX))
             IF (ABS_PIVOT .GE. UU*RMAX .AND.
      &          ABS_PIVOT .GT. max(SEUIL,tiny(RMAX))) THEN
+               IF (KEEP(19).GT.0) THEN
+                 IF (LAST_ROW.EQ.NFRONT) THEN
+                   LRLOC = LAST_ROW -KEEP(253)-NVSCHUR
+                 ELSE
+                   LRLOC = LAST_ROW
+                 ENDIF
+                 J1=POSELT+int(IPIV-1,8)+int(NPIV,8)*NFRONT8
+                 J2=POSELT+int(IPIV-1,8)+int(LRLOC-1,8)*NFRONT8
+                 RCMAX = RZERO
+                 DO JJ=J1, J2, NFRONT8
+                   RCMAX = max(abs(A(JJ)),RCMAX)
+                 ENDDO
+                 IF (ABS_PIVOT .GE. UU*RCMAX) THEN
+                   JMAX = IPIV - NPIV
+                   GO TO 380
+                 ENDIF
+               ELSE
                 JMAX = IPIV - NPIV
                 GO TO 380
+               ENDIF
             ENDIF
             IF ( .NOT. (AMROW .GE. UU*RMAX .AND.
      &                  AMROW .GT. max(SEUIL,tiny(RMAX))) ) GO TO 460
+            IF (KEEP(19).GT.0) THEN
+              IF (LAST_ROW.EQ.NFRONT) THEN
+                LRLOC = LAST_ROW -KEEP(253)-NVSCHUR
+              ELSE
+                LRLOC = LAST_ROW
+              ENDIF
+              J1=POSELT+int(NPIV+JMAX-1,8)+int(NPIV,8)*NFRONT8
+              J2=POSELT+int(NPIV+JMAX-1,8)+int(LRLOC-1,8)*NFRONT8
+              RCMAX = RZERO
+              DO JJ=J1, J2, NFRONT8
+                RCMAX = max(abs(A(JJ)),RCMAX)
+              ENDDO
+              IF (.NOT.(AMROW .GE. UU*RCMAX) ) THEN 
+                GO TO 460
+              ENDIF
+            ENDIF 
             NOFFW = NOFFW + 1
   380       CONTINUE
           IF (K206.GE.1) THEN
@@ -1855,10 +1893,6 @@ C
          LPOS1   = POSPV2 + LDA8 - 1_8
          LPOS2   = LPOS1 + 1_8
 #if defined(__ve__)
-#if defined(check)
-         IF (LDA8.NE.NFRONT8) CALL MUMPS_ABORT()
-         IF (NEL2 + NCB1.NE.LAST_ROW-NPIV_NEW) CALL MUMPS_ABORT()
-#endif
          CALL scopy(LAST_ROW-NPIV_NEW, A(LPOS1), LDA, A(POSPV1+2_8), 1)
          CALL scopy(LAST_ROW-NPIV_NEW, A(LPOS2), LDA, A(POSPV2+1_8), 1)
 !$       OMP_FLAG = (NEL2+NCB1 > 300)
@@ -2025,21 +2059,6 @@ C
            BLSIZE = LAST_COL_GEMM - IEND_BLOCK
           END IF
           IF ( LAST_COL_GEMM - IEND_BLOCK .GT. 0 ) THEN
-#if defined(SAK_BYROW)
-           DO IROW = IEND_BLOCK+1, LAST_COL_GEMM, BLSIZE
-            Block = min( BLSIZE, LAST_COL_GEMM - IROW + 1 )
-            LPOS = POSELT + int(IROW  - 1,8) * LDA8 +
-     &                      int(IBEG_BLOCK - 1,8)
-            UPOS = POSELT + int(IBEG_BLOCK - 1,8) * LDA8 +
-     &                      int(IROW - 1,8)
-            APOS = POSELT + int(IROW  - 1,8) * LDA8 + 
-     &             int(IEND_BLOCK,8)
-            CALL sgemm( 'N','N', IROW + Block - IEND_BLOCK - 1, 
-     &             Block, NPIV_BLOCK,
-     &                 ALPHA, A( UPOS ), LDA,
-     &                 A( LPOS ), LDA, ONE, A( APOS ), LDA )
-           ENDDO
-#else
            DO IROW = IEND_BLOCK+1, LAST_COL_GEMM, BLSIZE
             Block = min( BLSIZE, LAST_COL_GEMM - IROW + 1 )
             LPOS = POSELT + int( IROW - 1,8) * LDA8 +
@@ -2051,7 +2070,6 @@ C
      &                 NPIV_BLOCK, ALPHA, A( UPOS ), LDA,
      &                 A( LPOS ), LDA, ONE, A( APOS ), LDA )
            END DO
-#endif
           END IF
 #if defined(GEMMT_AVAILABLE)
          END IF 
diff -pruN 5.6.2-2.1/src/sfac_front_type2_aux.F 5.7.1-1/src/sfac_front_type2_aux.F
--- 5.6.2-2.1/src/sfac_front_type2_aux.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/sfac_front_type2_aux.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -738,7 +738,7 @@ C
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
       INTEGER, INTENT(IN) :: NINROWARR(KEEP(195))
       INTEGER, INTENT(IN) :: PTRDEBARR(KEEP(196))
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INTEGER(8) :: PTRAST  (KEEP(28))
       INTEGER(8) :: PTRFAC  (KEEP(28))
       INTEGER(8) :: PAMASTER(KEEP(28))
@@ -808,7 +808,7 @@ C
      &               NSLAVES, WIDTH, COMM,
      &               NELIM, NPARTSASS, CURRENT_BLR_PANEL,
      &               LR_ACTIVATED, BLR_LorU, 
-     &        IERR )
+     &               ICNTL, IERR )
           IF (IERR.EQ.-1) THEN
             BLOCKING  = .FALSE.
             SET_IRECV = .TRUE.
diff -pruN 5.6.2-2.1/src/sfac_lastrtnelind.F 5.7.1-1/src/sfac_lastrtnelind.F
--- 5.6.2-2.1/src/sfac_lastrtnelind.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/sfac_lastrtnelind.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -68,7 +68,7 @@ C
      &        TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
       DOUBLE PRECISION OPASSW, OPELIW
       INTEGER ITLOC( N+KEEP(253) ), FILS( N ), DAD( KEEP(28) )
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
diff -pruN 5.6.2-2.1/src/sfac_lr.F 5.7.1-1/src/sfac_lr.F
--- 5.6.2-2.1/src/sfac_lr.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/sfac_lr.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/sfac_mem_alloc_cb.F 5.7.1-1/src/sfac_mem_alloc_cb.F
--- 5.6.2-2.1/src/sfac_mem_alloc_cb.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/sfac_mem_alloc_cb.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/sfac_mem_compress_cb.F 5.7.1-1/src/sfac_mem_compress_cb.F
--- 5.6.2-2.1/src/sfac_mem_compress_cb.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/sfac_mem_compress_cb.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -148,9 +148,6 @@ C
       INTEGER(8) :: RCURRENT_SIZE, DYN_SIZE
       LOGICAL :: RECORD_CAN_BE_COMPRESSED
       INTEGER IXXP
-      INTEGER, EXTERNAL :: MUMPS_TYPENODE
-      INTEGER, EXTERNAL :: MUMPS_PROCNODE
-      LOGICAL, EXTERNAL :: SMUMPS_ISBAND
       EXTERNAL MPI_WTIME
       DOUBLE PRECISION MPI_WTIME
       DOUBLE PRECISION TIME_STRT
diff -pruN 5.6.2-2.1/src/sfac_mem_dynamic.F 5.7.1-1/src/sfac_mem_dynamic.F
--- 5.6.2-2.1/src/sfac_mem_dynamic.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/sfac_mem_dynamic.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -251,7 +251,7 @@ C
             ENDIF
           ENDIF
           IF ( MOVE2DYNAMIC ) THEN
-#if defined(MUMPS_ALLOC_FROM_C)
+#if defined(MUMPS_ALLOC_FROM_C) || defined(_CRAYFTN)
             CALL MUMPS_MALLOC_C( TMP_ADDRESS,
      &      RCURRENT_SIZE * KEEP(35) )
             IF (TMP_ADDRESS .EQ. 0_8) THEN
@@ -279,7 +279,7 @@ C
      &        LIW-ICURRENT+1, SIZEHOLE, KEEP(IXSZ))
             ENDIF
             CALL MUMPS_STOREI8(RCURRENT_SIZE,IW(ICURRENT+XXD))
-#if defined(MUMPS_ALLOC_FROM_C)
+#if defined(MUMPS_ALLOC_FROM_C) || defined(_CRAYFTN)
             CALL SMUMPS_DM_SET_PTR( TMP_ADDRESS, RCURRENT_SIZE,
      &                              DYNAMIC_CB )
 #else
@@ -438,7 +438,7 @@ C
       LOGICAL, INTENT(IN) :: ATOMIC_UPDATES
       INTEGER(8) :: KEEP8(150)
       INTEGER IDUMMY
-#if defined(MUMPS_ALLOC_FROM_C)
+#if defined(MUMPS_ALLOC_FROM_C) || defined(_CRAYFTN)
       CALL MUMPS_FREE_C(DYNPTR(1))
 #else
       DEALLOCATE(DYNPTR)
diff -pruN 5.6.2-2.1/src/sfac_mem_free_block_cb.F 5.7.1-1/src/sfac_mem_free_block_cb.F
--- 5.6.2-2.1/src/sfac_mem_free_block_cb.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/sfac_mem_free_block_cb.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/sfac_mem_stack.F 5.7.1-1/src/sfac_mem_stack.F
--- 5.6.2-2.1/src/sfac_mem_stack.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/sfac_mem_stack.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -58,7 +58,7 @@ C
       INTEGER INTARR(KEEP8(27)) 
       INTEGER ITLOC( N + KEEP(253) ), FILS( N ), DAD( KEEP(28) ),
      &        ND( KEEP(28) ), FRERE( KEEP(28) )
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INTEGER ISTEP_TO_INIV2(KEEP(71)), 
      &        TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
       INTEGER NELT, LPTRAR
@@ -111,9 +111,8 @@ C
       DOUBLE PRECISION FLOP1, FLOP1_EFFECTIVE
       LOGICAL BLOCKING, SET_IRECV, MESSAGE_RECEIVED
       LOGICAL SSARBR, SSARBR_ROOT, MUMPS_INSSARBR,
-     & MUMPS_IN_OR_ROOT_SSARBR, MUMPS_ROOTSSARBR
-      EXTERNAL MUMPS_INSSARBR, MUMPS_IN_OR_ROOT_SSARBR,
-     & MUMPS_ROOTSSARBR
+     & MUMPS_IN_OR_ROOT_SSARBR
+      EXTERNAL MUMPS_INSSARBR, MUMPS_IN_OR_ROOT_SSARBR
       LP = ICNTL(1)
       IF (ICNTL(4) .LE. 0) LP = -1
       INPLACE = .FALSE.
@@ -123,7 +122,7 @@ C
       NFRONT = IW(IOLDPS+KEEP(IXSZ))
       NPIV   = IW(IOLDPS + 1+KEEP(IXSZ))       
       NMAXNPIV = max(NPIV, NMAXNPIV)
-      NASS   = iabs(IW(IOLDPS + 2+KEEP(IXSZ))) 
+      NASS   = abs(IW(IOLDPS + 2+KEEP(IXSZ))) 
       NSLAVES=  IW(IOLDPS+5+KEEP(IXSZ))
       H_INODE= 6 + NSLAVES + KEEP(IXSZ)
       LCONT = NFRONT - NPIV
diff -pruN 5.6.2-2.1/src/sfac_mem_stack_aux.F 5.7.1-1/src/sfac_mem_stack_aux.F
--- 5.6.2-2.1/src/sfac_mem_stack_aux.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/sfac_mem_stack_aux.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/sfac_omp_m.F 5.7.1-1/src/sfac_omp_m.F
--- 5.6.2-2.1/src/sfac_omp_m.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/sfac_omp_m.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -64,7 +64,7 @@ C
       INTEGER(8), INTENT(IN) :: THREAD_LA
       INTEGER PROCNODE_STEPS(KEEP(28))
       INTEGER ITLOC(N+KEEP(253))
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INTEGER NSTK_STEPS(KEEP(28))
       INTEGER(8), INTENT(IN) :: PTRARW(LPTRAR), PTRAIW(LPTRAR)
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
@@ -118,14 +118,8 @@ C
       INTEGER, INTENT (IN)    :: NBCOLS_I4, NBCOLS_I8
       INTEGER, INTENT (IN)    :: I4_L0_OMP(NBSTATS_I4, NBCOLS_I4)
       INTEGER(8), INTENT (IN) :: I8_L0_OMP(NBSTATS_I8, NBCOLS_I8)
-      EXTERNAL MUMPS_TYPENODE, MUMPS_PROCNODE
-      INTEGER MUMPS_TYPENODE, MUMPS_PROCNODE
-      LOGICAL MUMPS_INSSARBR,MUMPS_ROOTSSARBR
-      EXTERNAL MUMPS_INSSARBR,MUMPS_ROOTSSARBR
       LOGICAL SMUMPS_POOL_EMPTY
       EXTERNAL SMUMPS_POOL_EMPTY, SMUMPS_EXTRACT_POOL
-      INTEGER numroc
-      EXTERNAL numroc
       INTEGER :: MYTHREAD_ID, ITH  
       INTEGER :: THREAD_ID_P       
       DOUBLE PRECISION, PARAMETER :: DZERO = 0.0D0, DONE = 1.0D0
@@ -1216,7 +1210,7 @@ C
       INTEGER ITLOC( N + KEEP(253) ), FILS( N ),
      &        ND( KEEP(28) ), FRERE( KEEP(28) )
       INTEGER DAD( KEEP(28) )
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INTEGER ISTEP_TO_INIV2(KEEP(71)), 
      &        TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
       INTEGER NELT, LPTRAR
diff -pruN 5.6.2-2.1/src/sfac_par_m.F 5.7.1-1/src/sfac_par_m.F
--- 5.6.2-2.1/src/sfac_par_m.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/sfac_par_m.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -32,6 +32,7 @@ C
 !$    USE OMP_LIB
       USE SMUMPS_DYNAMIC_MEMORY_M, ONLY : 
      &                                    SMUMPS_DM_FREEALLDYNAMICCB
+      USE SMUMPS_BUF, ONLY : SMUMPS_BUF_TEST
       USE SMUMPS_LOAD
       USE SMUMPS_OOC
       USE SMUMPS_FAC_ASM_MASTER_M
@@ -64,7 +65,7 @@ C
       INTEGER LPOOL
       INTEGER PROCNODE_STEPS(KEEP(28))
       INTEGER ITLOC(N+KEEP(253))
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INTEGER IW(LIW), NSTK_STEPS(KEEP(28))
       INTEGER(8), INTENT(IN) :: PTRARW(LPTRAR), PTRAIW(LPTRAR)
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
@@ -132,15 +133,31 @@ C
       INTEGER LOCAL_M, LOCAL_N
       INTEGER LRHS_CNTR_MASTER_ROOT, FWD_LOCAL_N_RHS
       LOGICAL ROOT_OWNER
+!$    INTEGER :: NOMP
+!$    INTEGER(8) :: CHUNK8  
+      INTEGER  LIWK_RR, PHASE, MBLOCK, NBLOCK
+      INTEGER(8) :: LWK_RR
+      INTEGER(8) :: I8
+      INTEGER  I, K, KEEP17_LU
+      INTEGER  NOFFNEGPV_ROOT, NTOTPV_ROOT, NB22T1_ROOT, NBTINY_ROOT,
+     &         NULLNEGPV_ROOT,
+     &         DET_EXP_ROOT, DET_SIGN_ROOT, 
+     &         LRecord, Header_ROOT(5)
+      REAL  DET_MANT_ROOT  
+      REAL DKEEP_SAVE(230)
+      REAL, DIMENSION(:), POINTER     :: A_ROOT_SAVE
+      LOGICAL                            :: IS_A_ROOT_SAVE_ALLOCATED
+      INTEGER, DIMENSION(:), ALLOCATABLE :: RECORD_ROOT
+      INTEGER KEEP_SAVE(500)             
+      INTEGER(8) KEEP8_SAVE(150)
       EXTERNAL MUMPS_TYPENODE, MUMPS_PROCNODE
       INTEGER MUMPS_TYPENODE, MUMPS_PROCNODE
-      LOGICAL MUMPS_INSSARBR,MUMPS_ROOTSSARBR
-      EXTERNAL MUMPS_INSSARBR,MUMPS_ROOTSSARBR
+      LOGICAL MUMPS_INSSARBR
+      EXTERNAL MUMPS_INSSARBR
       LOGICAL SMUMPS_POOL_EMPTY
       EXTERNAL SMUMPS_POOL_EMPTY, SMUMPS_EXTRACT_POOL
       LOGICAL STACK_RIGHT_AUTHORIZED
-      INTEGER numroc
-      EXTERNAL numroc
+      INTEGER, EXTERNAL :: MUMPS_NUMROC
       INTEGER JOBASS, ETATASS
       INTEGER(8) :: LAFAC
       INTEGER LIWFAC, STRAT, TYPEFile, NextPiv2beWritten,
@@ -153,13 +170,6 @@ C
       DOUBLE PRECISION :: ROOTTIME
       INTEGER:: ITH
       DOUBLE PRECISION :: DUMMY_FLOP_ESTIM_ACC
-#if defined(multicore_profiling)
-      DOUBLE PRECISION :: LATIME, LFTIME, LSTIME
-      DOUBLE PRECISION :: GATIME, GFTIME, GSTIME
-      GATIME = 0
-      GFTIME = 0
-      GSTIME = 0
-#endif
       DUMMY_FLOP_ESTIM_ACC = 0.0d0
       ITLOC(1:N+KEEP(253)) =0
       ASS_IRECV = MPI_REQUEST_NULL
@@ -169,6 +179,9 @@ C
       NULLIFY(BUFRX)
       IS_BUFRX_ALLOCATED = .FALSE.
       KEEP(143) = -1
+      KEEP17_LU = -1
+      NULLIFY(A_ROOT_SAVE)
+      IS_A_ROOT_SAVE_ALLOCATED = .FALSE.
       IF ( INFO(1) .LT. 0 ) THEN
         GOTO 640
       ENDIF
@@ -301,6 +314,8 @@ C
      &         MYID_NODES,KEEP,KEEP8,N)
             END IF
             GOTO 30
+          ELSE
+            CALL SMUMPS_BUF_TEST()
           ENDIF
       ENDIF
       GO TO 20
@@ -532,8 +547,26 @@ C
           WRITE(*,*) "ERROR 2 in SMUMPS_FAC_PAR", POSELT
           GOTO 635
         ENDIF
+        IF (KEEP(118).GE.40) THEN
+          IOLDPS = PTLUST(STEP(INODE))
+          LRecord = IW(IOLDPS+XXI)
+          IF (allocated(RECORD_ROOT)) DEALLOCATE(RECORD_ROOT)
+          ALLOCATE(RECORD_ROOT(LRecord), stat=IERR)
+          IF (IERR.GT.0) THEN
+            INFO(1)= -13
+            INFO(2)= LRecord
+            IF (LP > 0)
+     &      write(LP,*) "ERROR allocate RECORD_ROOT"
+            GOTO 635
+          ENDIF
+          RECORD_ROOT(1:LRecord) = IW(IOLDPS:IOLDPS+LRecord-1)
+        ENDIF
         CALL SMUMPS_CHANGE_HEADER
      &       ( IW(PTLUST(STEP(INODE))+KEEP(IXSZ)), KEEP(253) )
+        IF (KEEP(118).GE.40) THEN
+          Header_ROOT(1:5) = IW(PTLUST(STEP(INODE))+KEEP(IXSZ):
+     &                        PTLUST(STEP(INODE))+KEEP(IXSZ)+4)
+        ENDIF
         GOTO 200
       END IF
       POSELT = PTRAST(STEP(INODE))
@@ -554,11 +587,6 @@ C
      &           , PERM
      &           )
            IF (INFO(1).LT.0) GOTO 635
-#if defined(multicore_profiling)
-         LFTIME = MPI_WTIME() - LFTIME
-         GFTIME = GFTIME + LFTIME
-         WRITE(*,*)'FAC ',LFTIME
-#endif
       ELSE  
             IW( IOLDPS+4+KEEP(IXSZ) ) = 1
               CALL SMUMPS_FAC1_LDLT( N, INODE,
@@ -577,9 +605,6 @@ C
           ENDIF 
           JOBASS = ETATASS          
           IF (JOBASS.EQ.1) THEN
-#if defined(multicore_profiling)
-              LATIME = MPI_WTIME()
-#endif
               CALL SMUMPS_FAC_ASM_NIV1(COMM_LOAD, ASS_IRECV,
      &        N,INODE,IW,LIW,A,LA,
      &        INFO(1),ND,
@@ -598,11 +623,6 @@ C
      &        JOBASS,ETATASS
      &               , LRGROUPS
      &         )
-#if defined(multicore_profiling)
-         LATIME = MPI_WTIME() - LATIME
-         GATIME = GATIME + LATIME
-         WRITE(*,*)'ASS ',LATIME
-#endif
           ENDIF
           IF (MPA.GT.0)
      &    CALL MUMPS_PRINT_STILL_ACTIVE (MYID_NODES, KEEP, 
@@ -617,9 +637,6 @@ C
       ELSE
         TYPEF = -9999
       END IF
-#if defined(multicore_profiling)
-         LSTIME = MPI_WTIME()
-#endif
       CALL SMUMPS_FAC_STACK( COMM_LOAD, ASS_IRECV,
      &       N,INODE,TYPE,TYPEF,LA,IW,LIW,A,
      &       INFO(1),INFO(2),OPELI,NELVA,NMAXNPIV,
@@ -638,11 +655,6 @@ C
      &               , LRGROUPS
      &       ,DUMMY_FLOP_ESTIM_ACC
      &       )
-#if defined(multicore_profiling)
-         LSTIME = MPI_WTIME() - LSTIME
-         GSTIME = GSTIME + LSTIME
-         WRITE(*,*)'STK ',LSTIME
-#endif
       IF (MPA.GT.0)
      &   CALL MUMPS_PRINT_STILL_ACTIVE (MYID_NODES, KEEP, 
      &                        dble(DKEEP(17)), 
@@ -712,6 +724,7 @@ C
       ENDIF
       GO TO 20
  635  CONTINUE
+      IF (allocated(RECORD_ROOT)) DEALLOCATE(RECORD_ROOT)
       CALL SMUMPS_BDC_ERROR( MYID_NODES, SLAVEF, COMM_NODES, KEEP )
  640  CONTINUE
         CALL SMUMPS_CANCEL_IRECV( INFO(1),
@@ -914,8 +927,8 @@ C
                   CALL MUMPS_PROPINFO( ICNTL, INFO, COMM_NODES,
      &            MYID_NODES)
                   IF (root%yes .AND. INFO(1).GE.0) THEN
-                    FWD_LOCAL_N_RHS = numroc(KEEP(253), root%NBLOCK,
-     &              root%MYCOL, 0, root%NPCOL)
+                    FWD_LOCAL_N_RHS = MUMPS_NUMROC(KEEP(253),
+     &              root%NBLOCK, root%MYCOL, 0, root%NPCOL)
                     FWD_LOCAL_N_RHS = max(1,FWD_LOCAL_N_RHS)
                     CALL SMUMPS_GATHER_ROOT( MYID_NODES,
      &              root%TOT_ROOT_SIZE, KEEP(253),
@@ -941,6 +954,279 @@ C
                    NTOTPV = NTOTPV + NFRONT 
                    NMAXNPIV = max(NMAXNPIV,NFRONT)
                 END IF
+                IF ( KEEP(60) .EQ. 0 ) THEN
+                 IF ( ROOT_OWNER ) THEN
+                  IF (KEEP(118).GE.40) THEN
+                   NOFFNEGPV_ROOT = 0        
+                   NULLNEGPV_ROOT = 0        
+                   NTOTPV_ROOT = 0
+                   NB22T1_ROOT = 0
+                   NBTINY_ROOT = 0
+                   DET_SIGN_ROOT = 1
+                   DET_EXP_ROOT = 0
+                   DET_MANT_ROOT = 1.0E0
+                   DKEEP_SAVE(:) = DKEEP(:)
+                   KEEP_SAVE(:)  = KEEP(:)
+                   KEEP8_SAVE(:) = KEEP8(:)
+                   KEEP_SAVE(201) = 0
+                   IF (KEEP(110).EQ.0) THEN
+                     KEEP_SAVE(110)= 1        
+                     IF (KEEP(118).EQ.40) THEN
+                      IF ((DKEEP(10).LE.0).OR.(DKEEP(10).GT.1)) THEN
+                             DKEEP_SAVE(1) = DKEEP(9)*1E-1
+                      ELSE
+                             DKEEP_SAVE(1) = DKEEP(9)*DKEEP(10) 
+                      ENDIF    
+                     ELSE IF (KEEP(118).EQ.41) THEN
+                        DKEEP_SAVE(1) = DKEEP(9)
+                     ELSE IF (KEEP(118).EQ.42) THEN
+                      IF (DKEEP(13).LT.1)  THEN
+                          DKEEP_SAVE(1) = DKEEP(9)*10 
+                      ELSE
+                         DKEEP_SAVE(1) = DKEEP(9)*DKEEP(13)       
+                      ENDIF
+                     ENDIF  
+                   ELSE 
+                     DKEEP_SAVE(1) = DKEEP(9)
+                   ENDIF 
+                   IS_A_ROOT_SAVE_ALLOCATED = .FALSE.
+                   IF (LRLU.GT.NFRONT8*NFRONT8) THEN
+                     A_ROOT_SAVE  => A(POSFAC:POSFAC+LRLU-1_8)
+                   ELSE
+                    IF (associated(A_ROOT_SAVE)) 
+     &                               DEALLOCATE(A_ROOT_SAVE)
+                    ALLOCATE(A_ROOT_SAVE(NFRONT8*NFRONT8),stat=IERR)
+                    IF (IERR.GT.0) THEN
+                     INFO(1) = -13
+                     CALL MUMPS_SET_IERROR(NFRONT8*NFRONT8, INFO(2) )
+                     IF (LP > 0 )
+     &                 write(LP,*) "ERROR allocating A_ROOT_SAVE ",
+     &                 " of size ", NFRONT*NFRONT
+                     GOTO 735
+                    ENDIF
+                    IS_A_ROOT_SAVE_ALLOCATED = .TRUE.
+                   ENDIF
+!$        NOMP = OMP_GET_MAX_THREADS()
+!$        CHUNK8=int(KEEP(361),8)
+!$OMP     PARALLEL DO PRIVATE(I8) SCHEDULE(STATIC, CHUNK8)
+!$OMP&    IF ( NFRONT8*NFRONT8 > int(KEEP(361),8) .AND. NOMP .GT. 1)
+                   DO I8 =1_8, NFRONT8*NFRONT8
+                       A_ROOT_SAVE(I8) = 
+     &                   A(PTRAST(STEP(KEEP(20)))+I8-1_8)
+                   ENDDO
+                   IW(PTLUST(STEP(INODE))+KEEP(IXSZ): 
+     &                    PTLUST(STEP(INODE))+KEEP(IXSZ)+4)
+     &                 = RECORD_ROOT(KEEP(IXSZ)+1:KEEP(IXSZ)+5)
+                   IW(PTLUST(STEP(INODE))+XXLR) = 0
+                   IF (KEEP(50).EQ.0) THEN
+                    CALL SMUMPS_FAC1_LU_I ( 
+     &               N, INODE, IW, LIW, A_ROOT_SAVE(1),
+     &               NFRONT8*NFRONT8, IPOSROOT, 1_8,
+     &               INFO(1), INFO(2), UU, NOFFNEGPV_ROOT, NTOTPV_ROOT,
+     &               NBTINY_ROOT,
+     &               DET_EXP_ROOT, DET_MANT_ROOT, DET_SIGN_ROOT,
+     &               KEEP_SAVE,KEEP8_SAVE,
+     &               STEP, PROCNODE_STEPS, MYID_NODES, SLAVEF,
+     &               SEUIL, AVOID_DELAYED, ETATASS,
+     &               DKEEP_SAVE(1), PIVNUL_LIST_STRUCT, IWPOS 
+     &               , LRGROUPS
+     &               , PERM
+     &               )
+                    IF (INFO(1).LT.0) THEN
+                     IF (LP.GT.0) 
+     &               write(LP,*) "ERROR after SMUMPS_FAC1_LU ",
+     &               "on the root INFO(1)= ", INFO(1)
+                     GOTO 735
+                    ENDIF 
+                   ELSE
+                    CALL SMUMPS_FAC1_LDLT_I (N,KEEP_SAVE(20),
+     &               IW, LIW, A_ROOT_SAVE(1), NFRONT8*NFRONT8,
+     &               IPOSROOT, 1_8,
+     &               INFO(1), INFO(2), UU,
+     &               NOFFNEGPV_ROOT, NULLNEGPV_ROOT, NTOTPV_ROOT,
+     &               NB22T1_ROOT, NBTINY_ROOT, 
+     &               DET_EXP_ROOT, DET_MANT_ROOT, DET_SIGN_ROOT,
+     &               KEEP_SAVE,KEEP8_SAVE, MYID_NODES, SEUIL, 
+     &               AVOID_DELAYED, ETATASS, DKEEP_SAVE(1),
+     &               PIVNUL_LIST_STRUCT, IWPOS
+     &               , LRGROUPS
+     &               , PERM
+     &               )
+                     IF (INFO(1).LT.0) THEN
+                      IF (LP.GT.0) 
+     &                write(LP,*) "ERROR after SMUMPS_FAC1_LDLT ",
+     &                "on the root INFO(1)= ", INFO(1)
+                      GOTO 735
+                     ENDIF 
+                   ENDIF 
+                   LRecord = IW(IOLDPS+XXI)
+                   IW(PTLUST(STEP(INODE)):
+     &                PTLUST(STEP(INODE))+LRecord-1) = 
+     &                                    RECORD_ROOT(1:LRecord) 
+                   IW(PTLUST(STEP(INODE))+KEEP(IXSZ): 
+     &                PTLUST(STEP(INODE))+KEEP(IXSZ)+4) =
+     &                                          Header_ROOT(1:5)
+                   KEEP17_LU = KEEP_SAVE(109)-KEEP(109)
+                   IF (KEEP_SAVE(109).GT.KEEP(109)) THEN
+                     K = 1
+                     DO I = KEEP(109)+1, KEEP(109)+KEEP17_LU
+                        RECORD_ROOT(K) = 
+     &                          PIVNUL_LIST_STRUCT%PIVNUL_LIST(I)
+                        K = K+1
+                     ENDDO
+                   ENDIF
+                   IF (IS_A_ROOT_SAVE_ALLOCATED) DEALLOCATE(A_ROOT_SAVE)
+                   NULLIFY(A_ROOT_SAVE)
+                   IS_A_ROOT_SAVE_ALLOCATED = .FALSE.
+                   DET_SIGN = DET_SIGN * DET_SIGN_ROOT
+                   DET_EXP  = DET_EXP + DET_EXP_ROOT
+                   CALL SMUMPS_UPDATEDETER ( DET_MANT_ROOT, 
+     &                                       DET_MANT, DET_EXP)
+                   NOFFNEGPV = NOFFNEGPV + NOFFNEGPV_ROOT
+                   NULLNEGPV = NULLNEGPV + NULLNEGPV_ROOT
+                  ENDIF 
+                  LOCAL_M = 0
+                  LOCAL_N = 0
+                  MBLOCK  = 0
+                  NBLOCK  = 0
+                  PHASE   = 1  
+                  CALL SMUMPS_SVD_QR_ESTIM_WK( PHASE,
+     &             MBLOCK, NBLOCK, NFRONT, LOCAL_M, LOCAL_N,
+     &             ROOT_OWNER, KEEP,KEEP8,
+     &             LIWK_RR, LWK_RR )    
+                  LBUFRX             = LWK_RR
+                  IS_BUFRX_ALLOCATED = .FALSE.
+                  IF ( LRLU .GT. LBUFRX ) THEN
+                      BUFRX => A(POSFAC:POSFAC+LBUFRX-1_8)
+                  ELSE
+                      ALLOCATE( BUFRX( LBUFRX ), stat = IERR )
+                      IF (IERR.gt.0) THEN
+                        INFO(1) = -13
+                        CALL MUMPS_SET_IERROR(LBUFRX, INFO(2))
+                        IF (LP.GT.0)
+     &                  write(LP,*) ' Error allocating, real
+     &                        array ','of size ', LBUFRX,
+     &                        ' before SMUMPS_SEQ_FACTO_ROOT_SVD_QR'
+                        GOTO 735
+                      ENDIF
+                      IS_BUFRX_ALLOCATED = .TRUE.
+                  ENDIF
+                 IF (PIVNUL_LIST_STRUCT%SIZE_PIVNUL_LIST .LT. 
+     &               KEEP(109)+NFRONT) THEN
+                  CALL MUMPS_RESIZE_PIVNUL(KEEP, N, PIVNUL_LIST_STRUCT, 
+     &                             KEEP(109)+NFRONT, INFO(1), INFO(2) ) 
+                  IF (INFO(1).LT.0) GOTO 735
+                 ENDIF
+                  CALL SMUMPS_SEQ_FACTO_ROOT_SVD_QR(
+     &                 NFRONT,A(PTRAST(STEP(KEEP(20)))),
+     &                 root,
+     &                 BUFRX(1), int(LBUFRX),
+     &                 KEEP,KEEP8, INFO, LP, DKEEP,
+     &                 GLOBK109, OPELI,
+     &                 PIVNUL_LIST_STRUCT%PIVNUL_LIST(KEEP(109)+1),
+     &                 PIVNUL_LIST_STRUCT%SIZE_PIVNUL_LIST- KEEP(109), 
+     &                 IW(IPOSROOTROWINDICES))
+                  IF (IS_BUFRX_ALLOCATED) DEALLOCATE ( BUFRX )
+                  NULLIFY(BUFRX)
+                  IS_BUFRX_ALLOCATED = .FALSE.
+                  IF (INFO(1).LT.0) GOTO 735
+                  IF (MPA.GT.0)
+     &            CALL MUMPS_PRINT_STILL_ACTIVE (MYID_NODES, KEEP, 
+     &                     dble(DKEEP(17)), 
+     &                     OPELI,
+     &                     OPLAST_PRINTED, MPA)
+                  CALL SMUMPS_UPDATE_PROGRESS( OPELI, KEEP8 )
+                  KEEP(143) = KEEP17_LU
+                  IF (KEEP(118).GE.40) THEN
+                    K = 1 
+                    IF (KEEP(17).GT.0) THEN
+                     DO I = KEEP(109)+1, KEEP(109)+KEEP(17)
+                      IF ( K .GT. KEEP17_LU ) THEN
+                        PIVNUL_LIST_STRUCT%PIVNUL_LIST(I) = -1
+                      ELSE
+                        PIVNUL_LIST_STRUCT%PIVNUL_LIST(I) = 
+     &                                 RECORD_ROOT(K)
+                      ENDIF
+                      K = K+1
+                     ENDDO
+                    ENDIF
+                  ENDIF
+                  IF (allocated(RECORD_ROOT)) DEALLOCATE(RECORD_ROOT)
+                      IF (KEEP(201).EQ.1) THEN 
+                        CALL MUMPS_GETI8(LAFAC, IW(IPOSROOT+XXR))
+                        LIWFAC    = IW(IPOSROOT+XXI)
+                        TYPEFile  = TYPEF_L
+                        NextPiv2beWritten = 1 
+                        MonBloc%INODE    = KEEP(20)   
+                        MonBloc%MASTER   = .TRUE.
+                        MonBloc%Typenode = 3
+                        MonBloc%NCOL     = NFRONT
+                        MonBloc%NROW     = NFRONT
+                        MonBloc%NFS      = NFRONT
+                        MonBloc%Last     = .TRUE.   
+                        MonBloc%LastPiv  = MonBloc%NCOL
+                        MonBloc%LastPanelWritten_L=-9999 
+                        MonBloc%LastPanelWritten_U=-9999 
+                        NULLIFY(MonBloc%INDICES)
+                        STRAT        = STRAT_WRITE_MAX
+                        MonBloc%Last = .TRUE.
+                        LAST_CALL    = .TRUE.
+                        CALL SMUMPS_OOC_IO_LU_PANEL
+     &                                 ( STRAT, TYPEFile,
+     &                                  A(PTRAST(STEP(KEEP(20)))),
+     &                                  LAFAC, MonBloc,
+     &                                  NextPiv2beWritten, IDUMMY,
+     &                                  IW(IPOSROOT), LIWFAC,
+     &                              MYID, KEEP8(31), IERR, LAST_CALL)
+                        IF(IERR.LT.0)THEN
+                        IF (LP > 0)
+     &                  WRITE(LP,*)MYID,
+     &                  ': Error raised in SMUMPS_OOC_IO_LU_PANEL',
+     &                  IERR
+                        INFO(1)=IERR
+                        ENDIF
+                      ELSE IF (KEEP(201).EQ.2) THEN 
+                        KEEP8(31)=KEEP8(31)+NFRONT8*NFRONT8
+                        CALL SMUMPS_NEW_FACTOR(KEEP(20),PTRFAC,
+     &                  KEEP,KEEP8,A,LA, NFRONT8*NFRONT8, IERR)
+                        IF(IERR.LT.0)THEN
+                        WRITE(*,*)MYID,
+     &                  ': Internal error in SMUMPS_NEW_FACTOR',
+     &                  IERR
+                        GOTO 735
+                        ENDIF
+                      ENDIF
+                      ITMP8  =  NFRONT8*NFRONT8
+                      IF(KEEP(201).NE.0)THEN 
+                        IF (PTRFAC(STEP(KEEP(20))).EQ.
+     &                      POSFAC-ITMP8) THEN
+                          POSFAC = POSFAC  - ITMP8
+                          LRLU   = LRLU    + ITMP8
+                          LRLUS  = LRLUS   + ITMP8
+                          KEEP8(69) = KEEP8(69) - ITMP8
+                        ELSE
+                          IF (LP.GT.0) 
+     &                    WRITE(LP,*) "Internal error",
+     &                    POSFAC,NFRONT8,
+     &                    "root KEEP(20) not on top in OOC"
+                          GOTO 735
+                         ENDIF
+                      ENDIF
+                      CALL SMUMPS_LOAD_MEM_UPDATE(.FALSE.,.FALSE.,
+     &                LA-LRLUS,ITMP8,0_8,KEEP,KEEP8,LRLUS)
+                ENDIF
+ 735         CONTINUE
+             CALL MUMPS_PROPINFO( ICNTL, INFO, COMM_NODES, MYID_NODES )
+             IF (INFO(1).LT.0) GOTO 745
+                 CALL MPI_BCAST( KEEP(17), 1, MPI_INTEGER,
+     &                MUMPS_PROCNODE(PROCNODE_STEPS(STEP(KEEP(20))),
+     &                               KEEP(199)),
+     &                COMM_NODES, IERR )
+                 CALL MPI_BCAST( KEEP(143), 1, MPI_INTEGER,
+     &                MUMPS_PROCNODE(PROCNODE_STEPS(STEP(KEEP(20))),
+     &                               KEEP(199)),
+     &                COMM_NODES, IERR )
+                END IF
                 IF (ROOT_OWNER.AND.KEEP(60).NE.0) THEN 
                   ITMP8 = NFRONT8*NFRONT8
                   IF ( PTRFAC(STEP(KEEP(20))) .EQ. POSFAC -
@@ -954,6 +1240,12 @@ C
                   ENDIF
                 ENDIF
             END IF
+            GOTO 750
+ 745  CONTINUE
+            IF (allocated(RECORD_ROOT)) DEALLOCATE(RECORD_ROOT)
+            IF (IS_A_ROOT_SAVE_ALLOCATED) DEALLOCATE(A_ROOT_SAVE)
+            NULLIFY(A_ROOT_SAVE)
+ 750  CONTINUE
             IF (INFO(1).LT.0) GOTO 500
             CALL MUMPS_SECFIN(ROOTTIME)
             DKEEP(99)=real(ROOTTIME)
diff -pruN 5.6.2-2.1/src/sfac_process_band.F 5.7.1-1/src/sfac_process_band.F
--- 5.6.2-2.1/src/sfac_process_band.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/sfac_process_band.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -46,7 +46,7 @@ C
       INTEGER PTRIST(KEEP(28)), STEP(N), 
      & PIMASTER(KEEP(28)), 
      & ITLOC( N + KEEP(253) )
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INTEGER :: ISTEP_TO_INIV2(KEEP(71))
 #if ! defined(NO_FDM_DESCBAND)
       INTEGER IWHANDLER_IN
@@ -124,7 +124,7 @@ C
      &       COMP, LRLUS, KEEP8(67), IFLAG, IERROR
      &     )
         IF ( IFLAG .LT. 0 ) RETURN
-#if defined(MUMPS_ALLOC_FROM_C)
+#if defined(MUMPS_ALLOC_FROM_C) || defined(_CRAYFTN)
         CALL MUMPS_MALLOC_C( TMP_ADDRESS,
      &      LREQCB * int(KEEP(35),8) )
         IF (TMP_ADDRESS .EQ. 0_8) THEN
@@ -145,7 +145,7 @@ C
      &    KEEP8, IFLAG, IERROR,
      &    .TRUE., 
      &    .FALSE. ) 
-#if ! defined(MUMPS_ALLOC_FROM_C)
+#if ! defined(MUMPS_ALLOC_FROM_C) && ! defined(_CRAYFTN)
           CALL MUMPS_ADDR_C( DYNAMIC_CB(1), TMP_ADDRESS )
 #endif
           CALL MUMPS_STOREI8(LREQCB, IW(IWPOSCB+1+XXD))
@@ -289,7 +289,7 @@ C
       INTEGER NELT, LPTRAR
       INTEGER FRTPTR( N+1 ), FRTELT( NELT )
       INTEGER ITLOC( N + KEEP(253) ), FILS( N ), DAD( KEEP(28) )
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
diff -pruN 5.6.2-2.1/src/sfac_process_bf.F 5.7.1-1/src/sfac_process_bf.F
--- 5.6.2-2.1/src/sfac_process_bf.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/sfac_process_bf.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/sfac_process_blfac_slave.F 5.7.1-1/src/sfac_process_blfac_slave.F
--- 5.6.2-2.1/src/sfac_process_blfac_slave.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/sfac_process_blfac_slave.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -75,7 +75,7 @@ C
       INTEGER COMM, MYID
       INTEGER PTLUST_S(KEEP(28))
       INTEGER ITLOC( N + KEEP(253)), FILS( N ), DAD( KEEP(28) )
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INTEGER ND( KEEP(28) ), FRERE_STEPS( KEEP(28) )
       DOUBLE PRECISION OPASSW, OPELIW
       DOUBLE PRECISION FLOP1
diff -pruN 5.6.2-2.1/src/sfac_process_blocfacto.F 5.7.1-1/src/sfac_process_blocfacto.F
--- 5.6.2-2.1/src/sfac_process_blocfacto.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/sfac_process_blocfacto.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -71,7 +71,7 @@ C
       INTEGER FRTPTR( N+1 ), FRTELT( NELT )
       INTEGER PTLUST_S(KEEP(28)),
      &        ITLOC(N+KEEP(253)), FILS(N), DAD(KEEP(28)), ND(KEEP(28))
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) :: PTRAIW( LPTRAR ), PTRARW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
@@ -132,8 +132,6 @@ C
       INTEGER NPARTSASS, NPARTSCB, MAXI_CLUSTER, LWORK,
      &        MAXI_CLUSTER_L, MAXI_CLUSTER_U, MAXI_CLUSTER_COL
       INTEGER  :: allocok
-      INTEGER MUMPS_PROCNODE
-      EXTERNAL MUMPS_PROCNODE
       KEEP_BEGS_BLR_L = .FALSE.
       nullify(BEGS_BLR_L)
       NB_BLR_U = -7654321
@@ -384,8 +382,9 @@ C
           CALL GET_CUT(IW(IOLDPS+HS:IOLDPS+HS+NROW1-1), 0,
      &                    NROW1, LRGROUPS, NPARTSCB, 
      &                    NPARTSASS, BEGS_BLR_L)
-          CALL REGROUPING2(BEGS_BLR_L, NPARTSASS, 0, NPARTSCB,
-     &                        NROW1-0, KEEP(488), .TRUE., KEEP(472))
+          CALL REGROUPING2(BEGS_BLR_L, NPARTSASS, NASS1, NPARTSCB,
+     &                        NROW1-0, KEEP(488), .TRUE., KEEP(472),
+     &                        NCOL1, KEEP(1))
           NB_BLR_L =  NPARTSCB
           IF (IPANEL.EQ.1) THEN
            BEGS_BLR_COL=>BEGS_BLR_U
diff -pruN 5.6.2-2.1/src/sfac_process_blocfacto_LDLT.F 5.7.1-1/src/sfac_process_blocfacto_LDLT.F
--- 5.6.2-2.1/src/sfac_process_blocfacto_LDLT.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/sfac_process_blocfacto_LDLT.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -70,7 +70,7 @@ C
       INTEGER COMM, MYID
       INTEGER PTLUST_S(KEEP(28)),
      &        ITLOC(N+KEEP(253)), FILS(N), DAD(KEEP(28)), ND(KEEP(28))
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) :: PTRAIW( LPTRAR ), PTRARW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
@@ -564,8 +564,9 @@ C
           CALL GET_CUT(IW(IOLDPS+HS:IOLDPS+HS+NROW1-1), 0,
      &                    NROW1, LRGROUPS, NPARTSCB, 
      &                    NPARTSASS, BEGS_BLR_LS)
-              CALL REGROUPING2(BEGS_BLR_LS, NPARTSASS, 0, NPARTSCB,
-     &                        NROW1-0, KEEP(488), .TRUE., KEEP(472))
+              CALL REGROUPING2(BEGS_BLR_LS, NPARTSASS, NASS1, NPARTSCB,
+     &                        NROW1-0, KEEP(488), .TRUE., KEEP(472),
+     &                        NCOL1, KEEP(1))
              NB_BLR_LS = NPARTSCB
         ENDIF
         call MAX_CLUSTER(BEGS_BLR_LM,NB_BLR_LM+1,MAXI_CLUSTER_LM)
@@ -579,7 +580,8 @@ C
      &                    NPARTSASS_COL, BEGS_BLR_COL)
           CALL REGROUPING2(BEGS_BLR_COL, NPARTSASS_COL, NASS1, 
      &                     NPARTSCB_COL,
-     &                     NCOL1-NASS1, KEEP(488), .FALSE., KEEP(472))
+     &                     NCOL1-NASS1, KEEP(488), .FALSE., KEEP(472),
+     &                     NCOL1, KEEP(1))
           NB_BLR_COL = NPARTSCB_COL + NPARTSASS_COL
           IF (NPARTSASS_MASTER.NE.NPARTSASS_COL) THEN
              ALLOCATE(BEGS_BLR_COL_TMP(
diff -pruN 5.6.2-2.1/src/sfac_process_contrib_type1.F 5.7.1-1/src/sfac_process_contrib_type1.F
--- 5.6.2-2.1/src/sfac_process_contrib_type1.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/sfac_process_contrib_type1.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -42,7 +42,7 @@ C
       INTEGER COMP, FPERE
       LOGICAL FLAG
       INTEGER NSTK_S( KEEP(28) ), ITLOC( N + KEEP(253) )
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INTEGER IFLAG, IERROR, COMM
       INTEGER POSITION, FINODE, FLCONT, LREQ
       INTEGER(8) :: LREQCB
diff -pruN 5.6.2-2.1/src/sfac_process_contrib_type2.F 5.7.1-1/src/sfac_process_contrib_type2.F
--- 5.6.2-2.1/src/sfac_process_contrib_type2.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/sfac_process_contrib_type2.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -58,7 +58,7 @@ C
       INTEGER, intent(in) :: LRGROUPS(KEEP(280))
       INTEGER ITLOC( N + KEEP(253)), NSTK_S( KEEP(28) )
       INTEGER :: FILS( N ), DAD(KEEP(28))
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INTEGER ND(KEEP(28)), FRERE_STEPS( KEEP(28) )
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
@@ -449,7 +449,7 @@ C
              NSLAVES= IW(IOLDPS+5+KEEP(IXSZ))
              IF (NSLAVES.EQ.0) THEN 
                NFRONT = IW(IOLDPS+KEEP(IXSZ))
-               NASS1  = iabs(IW(IOLDPS + 2+KEEP(IXSZ)))
+               NASS1  = abs(IW(IOLDPS + 2+KEEP(IXSZ)))
                POSELT = PTRAST(STEP(INODE))
                PARPIV_T1 = -999 
                LR_ACTIVATED = (IW(IOLDPS+XXLR).GT.0)
diff -pruN 5.6.2-2.1/src/sfac_process_contrib_type3.F 5.7.1-1/src/sfac_process_contrib_type3.F
--- 5.6.2-2.1/src/sfac_process_contrib_type3.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/sfac_process_contrib_type3.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -45,7 +45,7 @@ C
       INTEGER PTRIST(KEEP(28))
       INTEGER PTLUST(KEEP(28))
       INTEGER STEP(N), PIMASTER(KEEP(28)), ITLOC( N+KEEP(253) )
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INTEGER BUFR( LBUFR_BYTES )
       INTEGER IW( LIW )
       INTEGER ND(KEEP(28)), PROCNODE_STEPS(KEEP(28))
@@ -65,8 +65,6 @@ C
       DOUBLE PRECISION OPASSW
         INCLUDE 'mpif.h'
         INTEGER IERR
-        EXTERNAL MUMPS_PROCNODE
-        INTEGER MUMPS_PROCNODE
         INTEGER POSITION, LOCAL_M, LOCAL_N, LREQI
         INTEGER(8) :: LREQA, POS_ROOT
         INTEGER NSUBSET_ROW, NSUBSET_COL, IROOT, ISON, NSUBSET_COL_EFF
diff -pruN 5.6.2-2.1/src/sfac_process_end_facto_slave.F 5.7.1-1/src/sfac_process_end_facto_slave.F
--- 5.6.2-2.1/src/sfac_process_end_facto_slave.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/sfac_process_end_facto_slave.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -71,7 +71,7 @@ C
       INTEGER NBFIN, SLAVEF
       DOUBLE PRECISION OPASSW, OPELIW
       INTEGER ITLOC( N + KEEP(253) ), FILS( N ), DAD( KEEP(28) )
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INTEGER ND( KEEP(28) )
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
diff -pruN 5.6.2-2.1/src/sfac_process_maprow.F 5.7.1-1/src/sfac_process_maprow.F
--- 5.6.2-2.1/src/sfac_process_maprow.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/sfac_process_maprow.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -84,7 +84,7 @@ C
       INTEGER LPTRAR, NELT
       INTEGER FRTPTR( N+1 ), FRTELT( NELT )
       INTEGER ITLOC( N+KEEP(253) ), FILS( N ), DAD( KEEP(28) )
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) ::  PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
@@ -573,6 +573,9 @@ C
                    IS_ERROR_BROADCASTED=.TRUE.
                    GOTO 600
                  ENDIF
+                 IF (.NOT. MESSAGE_RECEIVED) THEN
+                   CALL MUMPS_USLEEP(1000)
+                 ENDIF
                END IF
              END IF 
            ENDDO
@@ -708,7 +711,7 @@ C
       INTEGER PROCNODE_STEPS( KEEP(28) )
       INTEGER FRTPTR( N+1 ), FRTELT( NELT )
       INTEGER ITLOC( N+KEEP(253) ), FILS( N ), DAD( KEEP(28) )
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
@@ -1350,7 +1353,7 @@ C
       INTEGER, intent(inout) :: ITLOC(N)
       INTEGER, intent(in) :: FRTPTR( N+1 ), FRTELT( NELT )
       DOUBLE PRECISION, intent(inout) :: OPASSW, OPELIW
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INTEGER, intent(in) :: KEEP253_LOC, NVSCHUR
       INTEGER, intent(in) :: FILS(N), DAD( KEEP(28) )
       INTEGER(8), intent(in) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
diff -pruN 5.6.2-2.1/src/sfac_process_master2.F 5.7.1-1/src/sfac_process_master2.F
--- 5.6.2-2.1/src/sfac_process_master2.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/sfac_process_master2.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -43,7 +43,7 @@ C
       INTEGER(8) :: PAMASTER(KEEP(28))
       INTEGER PTRIST(KEEP(28)), STEP(N), PIMASTER(KEEP(28))
       INTEGER PROCNODE_STEPS( KEEP(28) ), ITLOC( N +KEEP(253) )
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INTEGER COMP
       INTEGER NSTK_S( KEEP(28) )
       INTEGER IFLAG, IERROR, COMM, COMM_LOAD
diff -pruN 5.6.2-2.1/src/sfac_process_message.F 5.7.1-1/src/sfac_process_message.F
--- 5.6.2-2.1/src/sfac_process_message.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/sfac_process_message.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -65,7 +65,7 @@ C
       INTEGER NELT, LPTRAR
       INTEGER FRTPTR( N+1), FRTELT( NELT )
       INTEGER ITLOC( N+KEEP(253) ), FILS( N ), DAD(KEEP(28))
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
@@ -515,7 +515,7 @@ C
       INTEGER NELT, LPTRAR
       INTEGER FRTPTR( N+1 ), FRTELT( NELT )
       INTEGER ITLOC( N+KEEP(253) ), FILS( N ), DAD( KEEP(28) )
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
@@ -623,7 +623,7 @@ C
       INTEGER NELT, LPTRAR
       INTEGER FRTPTR( N+1 ), FRTELT( NELT )
       INTEGER ITLOC( N + KEEP(253) ), FILS( N ), DAD( KEEP(28) )
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
@@ -749,7 +749,7 @@ C
                   IF ( IFLAG .LT. 0 ) RETURN
             ENDIF
           ENDIF
-       ENDIF
+       ENDIF 
       ELSE
         IF (BLOCKING) THEN
            CALL MPI_PROBE(MSGSOU,MSGTAG,
diff -pruN 5.6.2-2.1/src/sfac_process_root2slave.F 5.7.1-1/src/sfac_process_root2slave.F
--- 5.6.2-2.1/src/sfac_process_root2slave.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/sfac_process_root2slave.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -65,7 +65,7 @@ C
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
       INTEGER, INTENT(IN) :: NINROWARR(KEEP(195))
       INTEGER, INTENT(IN) :: PTRDEBARR(KEEP(196))
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INTEGER INTARR(KEEP8(27))
       REAL DBLARR(KEEP8(26))
       INTEGER ::  allocok
@@ -80,17 +80,17 @@ C
       REAL ZERO
       PARAMETER( ZERO = 0.0E0 )
       INCLUDE 'mumps_headers.h'
-      INTEGER numroc, MUMPS_PROCNODE
-      EXTERNAL numroc, MUMPS_PROCNODE
+      INTEGER MUMPS_NUMROC, MUMPS_PROCNODE
+      EXTERNAL MUMPS_NUMROC, MUMPS_PROCNODE
       IROOT = KEEP( 38 )
       root%TOT_ROOT_SIZE = TOT_ROOT_SIZE
       MASTER_OF_ROOT = ( MYID .EQ. 
      &                   MUMPS_PROCNODE( PROCNODE_STEPS(STEP(IROOT)),
      &                   KEEP(199) ) )
-      NEW_LOCAL_M  = numroc( TOT_ROOT_SIZE, root%MBLOCK,
+      NEW_LOCAL_M  = MUMPS_NUMROC( TOT_ROOT_SIZE, root%MBLOCK,
      &               root%MYROW, 0, root%NPROW )
       NEW_LOCAL_M  = max( 1, NEW_LOCAL_M )
-      NEW_LOCAL_N  = numroc( TOT_ROOT_SIZE, root%NBLOCK,
+      NEW_LOCAL_N  = MUMPS_NUMROC( TOT_ROOT_SIZE, root%NBLOCK,
      &               root%MYCOL, 0, root%NPCOL )
       IF ( PTRIST(STEP( IROOT )).GT.0) THEN
         OLD_LOCAL_N = -IW( PTRIST(STEP( IROOT )) + KEEP(IXSZ) )
@@ -275,7 +275,7 @@ C
       ENDIF 
       IF ( NO_OLD_ROOT ) THEN
           IF (KEEP(253) .GT.0) THEN
-            root%RHS_NLOC = numroc( KEEP(253), root%NBLOCK,
+            root%RHS_NLOC = MUMPS_NUMROC( KEEP(253), root%NBLOCK,
      &                      root%MYCOL, 0, root%NPCOL )
             root%RHS_NLOC = max( root%RHS_NLOC, 1 )
           ELSE
@@ -291,8 +291,8 @@ C
           ENDIF
           IF (KEEP(253) .NE. 0) THEN
             root%RHS_ROOT=ZERO
-            CALL SMUMPS_ASM_RHS_ROOT( N, FILS, root, KEEP, RHS_MUMPS,
-     &      IFLAG, IERROR )
+            CALL SMUMPS_ASM_RHS_ROOT( N, FILS, root, KEEP, KEEP8,
+     &      RHS_MUMPS, IFLAG, IERROR )
           ENDIF
       ELSE IF (NEW_LOCAL_M.GT.OLD_LOCAL_M .AND. KEEP(253) .GT.0) THEN
           TMP => root%RHS_ROOT
diff -pruN 5.6.2-2.1/src/sfac_process_root2son.F 5.7.1-1/src/sfac_process_root2son.F
--- 5.6.2-2.1/src/sfac_process_root2son.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/sfac_process_root2son.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -64,7 +64,7 @@ C
       INTEGER MYID, SLAVEF, NBFIN
       DOUBLE PRECISION OPASSW, OPELIW
       INTEGER ITLOC( N + KEEP(253) ), FILS( N ), DAD(KEEP(28))
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
@@ -97,7 +97,7 @@ C
        IOLDPS   = PTLUST_S(STEP(INODE))
        NFRONT   = IW(IOLDPS+KEEP(IXSZ))
        NPIV     = IW(IOLDPS+1+KEEP(IXSZ))
-       NASS     = iabs(IW(IOLDPS + 2+KEEP(IXSZ)))
+       NASS     = abs(IW(IOLDPS + 2+KEEP(IXSZ)))
        NSLAVES  =  IW(IOLDPS+5+KEEP(IXSZ))
        H_INODE  = 6 + NSLAVES + KEEP(IXSZ)
        NELIM    = NASS - NPIV
diff -pruN 5.6.2-2.1/src/sfac_process_rtnelind.F 5.7.1-1/src/sfac_process_rtnelind.F
--- 5.6.2-2.1/src/sfac_process_rtnelind.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/sfac_process_rtnelind.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -46,7 +46,7 @@ C
       INTEGER STEP(N), PIMASTER(KEEP(28))
       INTEGER COMP
       INTEGER NSTK_S(KEEP(28)), ITLOC( N + KEEP(253) )
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INTEGER PROCNODE_STEPS( KEEP(28) )
       INTEGER IFLAG, IERROR
       INTEGER LPOOL, LEAF
diff -pruN 5.6.2-2.1/src/sfac_root_parallel.F 5.7.1-1/src/sfac_root_parallel.F
--- 5.6.2-2.1/src/sfac_root_parallel.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/sfac_root_parallel.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -51,8 +51,7 @@ C
       INTEGER FWD_LOCAL_N_RHS, FWD_MTYPE 
 #endif
       INCLUDE 'mumps_headers.h'
-      EXTERNAL numroc
-      INTEGER numroc
+      INTEGER, EXTERNAL :: MUMPS_NUMROC
         IF ( .NOT. root%yes ) RETURN
         IF ( KEEP(60) .NE. 0 ) THEN
           IF ((LDLT == 1 .OR. LDLT == 2) .AND. KEEP(60) == 3 ) THEN
@@ -181,7 +180,7 @@ C
      &         LDLT)
         ENDIF
         IF (KEEP(252) .NE. 0) THEN
-          FWD_LOCAL_N_RHS = numroc(KEEP(253), root%NBLOCK,
+          FWD_LOCAL_N_RHS = MUMPS_NUMROC(KEEP(253), root%NBLOCK,
      &                      root%MYCOL, 0, root%NPCOL)
           FWD_LOCAL_N_RHS = max(1,FWD_LOCAL_N_RHS)
           FWD_MTYPE       = 1 
diff -pruN 5.6.2-2.1/src/sfac_scalings.F 5.7.1-1/src/sfac_scalings.F
--- 5.6.2-2.1/src/sfac_scalings.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/sfac_scalings.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -22,54 +22,61 @@ C
       REAL, INTENT(IN) :: ASPK(NZ8)
       REAL COLSCA(*), ROWSCA(*)
       INTEGER(8), INTENT(IN) :: LWK8
-      INTEGER LWK_REAL
+      INTEGER(8), INTENT(IN) :: LWK_REAL
       REAL    WK(LWK8)
       REAL WK_REAL(LWK_REAL)
       INTEGER MPG,LP
-      INTEGER IWNOR
       INTEGER I
-      LOGICAL PROK
+      LOGICAL PROKG
       REAL ONE
       PARAMETER( ONE = 1.0E0 )
       LP      = ICNTL(1)
       MPG     = ICNTL(2)
       MPG    = ICNTL(3)
-      PROK   = ((MPG.GT.0).AND.(ICNTL(4).GE.2))
-      IF (PROK) THEN
+      PROKG  = ((MPG.GT.0).AND.(ICNTL(4).GE.2))
+      IF (PROKG) THEN
         WRITE(MPG,101)
       ELSE
         MPG = 0
       ENDIF
- 101    FORMAT(/' ****** SCALING OF ORIGINAL MATRIX '/)
-        IF (NSCA.EQ.1) THEN
-         IF (PROK)
-     &    WRITE (MPG,*) ' DIAGONAL SCALING '
-        ELSEIF (NSCA.EQ.3) THEN
-         IF (PROK)
+ 101  FORMAT(/' ****** SCALING OF ORIGINAL MATRIX '/)
+      IF (NSCA.EQ.1) THEN
+        IF (PROKG) WRITE (MPG,*) ' DIAGONAL SCALING '
+      ELSEIF (NSCA.EQ.3) THEN
+         IF (PROKG)
      &   WRITE (MPG,*) ' COLUMN SCALING'
-        ELSEIF (NSCA.EQ.4) THEN
-         IF (PROK)
+      ELSEIF (NSCA.EQ.4) THEN
+         IF (PROKG)
      &   WRITE (MPG,*) ' ROW AND COLUMN SCALING (1 Pass)'
-       ENDIF
-        DO 10 I=1,N
-            COLSCA(I) = ONE
-            ROWSCA(I) = ONE
- 10     CONTINUE
-        IF (5*N.GT.LWK_REAL) GOTO 410
-        IWNOR = 1
-          IF (NSCA.EQ.1) THEN
+      ENDIF
+      DO 10 I=1,N
+        COLSCA(I) = ONE
+        ROWSCA(I) = ONE
+ 10   CONTINUE
+      IF (NSCA.EQ.1) THEN
             CALL SMUMPS_FAC_V(N,NZ8,ASPK,IRN,ICN,
-     &        COLSCA,ROWSCA,MPG)
-          ELSEIF (NSCA.EQ.3) THEN
-            CALL SMUMPS_FAC_Y(N,NZ8,ASPK,IRN,ICN,WK_REAL(IWNOR),
+     &      COLSCA,ROWSCA,MPG)
+      ELSEIF (NSCA.EQ.3) THEN
+            IF ( LWK_REAL .LT. int(N,8) ) THEN
+              GOTO 420
+            ENDIF
+            CALL SMUMPS_FAC_Y(N,NZ8,ASPK,IRN,ICN,WK_REAL(1),
      &      COLSCA, MPG)
-          ELSEIF (NSCA.EQ.4) THEN
+      ELSEIF (NSCA.EQ.4) THEN
+            IF ( LWK_REAL .LT. 2_8*int(N,8) ) THEN
+              GOTO 430
+            ENDIF
             CALL SMUMPS_ROWCOL(N,NZ8,IRN,ICN,ASPK,
-     &      WK_REAL(IWNOR),WK_REAL(IWNOR+N),COLSCA,ROWSCA,MPG)
-          ENDIF
+     &      WK_REAL(1),WK_REAL(1+N),COLSCA,ROWSCA,MPG)
+      ENDIF
+      GOTO 500
+ 420  INFO(1) = -5
+      CALL MUMPS_SET_IERROR(int(N,8)-LWK_REAL, INFO(2))
+      IF ((LP.GT.0).AND.(ICNTL(4).GE.1))
+     & WRITE(LP,*) '*** ERROR: Not enough space to scale matrix'
       GOTO 500
- 410  INFO(1) = -5
-      INFO(2) = 5*N-LWK_REAL
+ 430  INFO(1) = -5
+      CALL MUMPS_SET_IERROR(2_8*int(N,8)-LWK_REAL, INFO(2))
       IF ((LP.GT.0).AND.(ICNTL(4).GE.1))
      & WRITE(LP,*) '*** ERROR: Not enough space to scale matrix'
       GOTO 500
diff -pruN 5.6.2-2.1/src/sfac_scalings_simScaleAbs.F 5.7.1-1/src/sfac_scalings_simScaleAbs.F
--- 5.6.2-2.1/src/sfac_scalings_simScaleAbs.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/sfac_scalings_simScaleAbs.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -18,7 +18,9 @@ C
      &     IWRK, IWRKSZ,
      &     INTSZ, RESZ, OP,
      &     ROWSCA, COLSCA, WRKRC, ISZWRKRC,
-     &     SYM, NB1, NB2, NB3, EPS,
+     &     WRKR_TH, LWRKR_TH,
+     &     WRKC_TH, LWRKC_TH,
+     &     NOMP_MAX, SYM, NB1, NB2, NB3, EPS,
      &     ONENORMERR,INFNORMERR)
 C----------------------------------------------------------------------
 C    IF SYM=0 CALLs unsymmetric variant SMUMPS_SIMSCALEABSUNS.
@@ -29,13 +31,16 @@ C    For details, see the two subroutine
 C         SMUMPS_SIMSCALEABSUNS and SMUMPS_SIMSCALEABSSYM
 C ---------------------------------------------------------------------
 C
+!$    USE OMP_LIB
       IMPLICIT NONE
       INCLUDE 'mpif.h'
       INTEGER(8) NZ_loc
-      INTEGER IWRKSZ, ISZWRKRC
+      INTEGER(8) :: IWRKSZ
+      INTEGER(8) :: ISZWRKRC, LWRKR_TH, LWRKC_TH
+      INTEGER    :: NOMP_MAX
       INTEGER M, N, OP
       INTEGER NUMPROCS, MYID, COMM
-      INTEGER INTSZ, RESZ
+      INTEGER(8) :: INTSZ, RESZ
       INTEGER IRN_loc(NZ_loc)
       INTEGER JCN_loc(NZ_loc)
       REAL A_loc(NZ_loc)
@@ -44,21 +49,29 @@ C
       INTEGER CPARTVEC(N) 
       INTEGER CSNDRCVSZ(2*NUMPROCS)
       INTEGER IWRK(IWRKSZ)
-      INTEGER REGISTRE(12)
+      INTEGER(8) :: REGISTRE(12)
       REAL ROWSCA(M)
       REAL COLSCA(N)
       REAL WRKRC(ISZWRKRC)
+      REAL WRKR_TH(LWRKR_TH,max(NOMP_MAX,1))
+      REAL WRKC_TH(LWRKC_TH,max(NOMP_MAX,1))
       REAL ONENORMERR,INFNORMERR
 C     LOCALS
-C IMPORTANT POINTERS
 C     FOR the scaling phase
       INTEGER SYM, NB1, NB2, NB3
       REAL EPS
 C     EXTERNALS
       EXTERNAL SMUMPS_SIMSCALEABSUNS,SMUMPS_SIMSCALEABSSYM, 
-     &     SMUMPS_INITREAL
+     &         SMUMPS_INITREAL
 C     MUST HAVE IT
       INTEGER I
+      INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER    :: NOMP 
+!$    INTEGER    :: CHUNK
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP  = omp_get_max_threads()
+!$     CHUNK= max(K361/2, (N+NOMP-1) / NOMP )
+!$    ENDIF
       IF(SYM.EQ.0) THEN
          CALL SMUMPS_SIMSCALEABSUNS(IRN_loc, JCN_loc, A_loc, 
      &        NZ_loc,
@@ -67,7 +80,9 @@ C     MUST HAVE IT
      &        RSNDRCVSZ, CSNDRCVSZ, REGISTRE,
      &        IWRK, IWRKSZ,
      &        INTSZ, RESZ, OP,
-     &        ROWSCA, COLSCA, WRKRC, ISZWRKRC,
+     &        ROWSCA, COLSCA, WRKRC, ISZWRKRC, 
+     &        WRKR_TH, LWRKR_TH,
+     &        WRKC_TH, LWRKC_TH, NOMP_MAX,
      &        NB1, NB2, NB3, EPS,
      &        ONENORMERR, INFNORMERR)  
       ELSE
@@ -78,12 +93,24 @@ C     MUST HAVE IT
      &        RSNDRCVSZ, REGISTRE,
      &        IWRK, IWRKSZ,
      &        INTSZ, RESZ, OP,
-     &        ROWSCA, WRKRC, ISZWRKRC,
+     &        ROWSCA, WRKRC, ISZWRKRC,  
+     &        WRKR_TH, LWRKR_TH, NOMP_MAX,
      &        NB1, NB2, NB3, EPS,
      &        ONENORMERR, INFNORMERR)  
-         DO I=1,N
-            COLSCA(I) = ROWSCA(I)
-         ENDDO
+         IF (OP.EQ.2) THEN
+          IF (NOMP_MAX.LE.0) THEN
+            DO I=1,N
+             COLSCA(I) = ROWSCA(I)
+            ENDDO
+          ELSE 
+!$OMP      PARALLEL DO PRIVATE(I)
+!$OMP&     SCHEDULE(STATIC,CHUNK)
+!$OMP&     IF ( N > K361 .AND. NOMP .GT. 1)
+            DO I=1,N
+             COLSCA(I) = ROWSCA(I)
+            ENDDO
+          ENDIF
+         ENDIF
       ENDIF
       RETURN
       END SUBROUTINE SMUMPS_SIMSCALEABS
@@ -93,7 +120,9 @@ C     MUST HAVE IT
      &     RSNDRCVSZ, CSNDRCVSZ, REGISTRE,
      &     IWRK, IWRKSZ,
      &     INTSZ, RESZ, OP,
-     &     ROWSCA, COLSCA, WRKRC, ISZWRKRC,
+     &     ROWSCA, COLSCA, WRKRC, ISZWRKRC, 
+     &     WRKR_TH, LWRKR_TH,
+     &     WRKC_TH, LWRKC_TH, NOMP_MAX,
      &     NB1, NB2, NB3, EPS,
      &     ONENORMERR, INFNORMERR)    
 C----------------------------------------------------------------------
@@ -191,13 +220,15 @@ C         In proceedings of VECPAR'08-In
 C         Performance Computing for Computational Science, Jan'08.
 C     and was supported by ANR-SOLSTICE project (ANR-06-CIS6-010)
 C ---------------------------------------------------------------------
+!$    USE OMP_LIB
       IMPLICIT NONE
       INCLUDE 'mpif.h'
-      INTEGER(8) NZ_loc
-      INTEGER IWRKSZ, INTSZ, ISZWRKRC
-      INTEGER M, N, OP
-      INTEGER NUMPROCS, MYID, COMM
-      INTEGER RESZ
+      INTEGER(8) :: NZ_loc
+      INTEGER(8) :: IWRKSZ, INTSZ
+      INTEGER(8) :: ISZWRKRC, LWRKR_TH, LWRKC_TH
+      INTEGER    :: M, N, OP
+      INTEGER    :: NUMPROCS, MYID, COMM, NOMP_MAX
+      INTEGER(8) :: RESZ
       INTEGER IRN_loc(NZ_loc)
       INTEGER JCN_loc(NZ_loc)
       REAL A_loc(NZ_loc)
@@ -205,11 +236,13 @@ C --------------------------------------
       INTEGER CPARTVEC(N) 
       INTEGER RSNDRCVSZ(2*NUMPROCS)
       INTEGER CSNDRCVSZ(2*NUMPROCS)
-      INTEGER REGISTRE(12)
+      INTEGER(8) :: REGISTRE(12)
       INTEGER IWRK(IWRKSZ)
       REAL ROWSCA(M)
       REAL COLSCA(N)
-      REAL WRKRC(ISZWRKRC)  
+      REAL WRKRC(ISZWRKRC)
+      REAL WRKR_TH(LWRKR_TH,max(NOMP_MAX,1))
+      REAL WRKC_TH(LWRKC_TH,max(NOMP_MAX,1))
       REAL ONENORMERR,INFNORMERR
 C     LOCALS
       INTEGER IRSNDRCVNUM, ORSNDRCVNUM
@@ -218,14 +251,14 @@ C     LOCALS
       INTEGER ICSNDRCVVOL, OCSNDRCVVOL
       INTEGER  INUMMYR, INUMMYC
 C IMPORTANT POINTERS
-      INTEGER IMYRPTR,IMYCPTR 
-      INTEGER IRNGHBPRCS, IRSNDRCVIA,IRSNDRCVJA
-      INTEGER ORNGHBPRCS, ORSNDRCVIA,ORSNDRCVJA
-      INTEGER ICNGHBPRCS, ICSNDRCVIA,ICSNDRCVJA
-      INTEGER OCNGHBPRCS, OCSNDRCVIA,OCSNDRCVJA
-      INTEGER ISTATUS, REQUESTS, TMPWORK
-      INTEGER ITDRPTR, ITDCPTR, ISRRPTR
-      INTEGER OSRRPTR, ISRCPTR, OSRCPTR
+      INTEGER(8) :: IMYRPTR,IMYCPTR 
+      INTEGER(8) :: IRNGHBPRCS, IRSNDRCVIA,IRSNDRCVJA
+      INTEGER(8) :: ORNGHBPRCS, ORSNDRCVIA,ORSNDRCVJA
+      INTEGER(8) :: ICNGHBPRCS, ICSNDRCVIA,ICSNDRCVJA
+      INTEGER(8) :: OCNGHBPRCS, OCSNDRCVIA,OCSNDRCVJA
+      INTEGER(8) :: ISTATUS, REQUESTS, TMPWORK
+      INTEGER(8) :: ITDRPTR, ITDCPTR, ISRRPTR
+      INTEGER(8) :: OSRRPTR, ISRCPTR, OSRCPTR
 C     FOR the scaling phase
       INTEGER NB1, NB2, NB3
       REAL EPS
@@ -244,32 +277,39 @@ C     FUNCTIONS
       EXTERNAL SMUMPS_CREATEPARTVEC,
      &     SMUMPS_NUMVOLSNDRCV, 
      &     SMUMPS_SETUPCOMMS,
-     &     SMUMPS_FINDNUMMYROWCOL, 
-     &     SMUMPS_CHKCONVGLO,
-     &     SMUMPS_CHK1CONV,
      &     SMUMPS_FILLMYROWCOLINDICES,
      &     SMUMPS_INITREAL,
      &     SMUMPS_INITREALLST,
      &     SMUMPS_DOCOMMINF,
      &     SMUMPS_DOCOMM1N
-      INTEGER SMUMPS_CHKCONVGLO 
-      INTEGER SMUMPS_CHK1CONV
       REAL SMUMPS_ERRSCALOC
       REAL SMUMPS_ERRSCA1
       INTRINSIC abs
       REAL RONE, RZERO
       PARAMETER(RONE=1.0E0,RZERO=0.0E0)
 C     TMP VARS
-      INTEGER RESZR, RESZC
-      INTEGER INTSZR, INTSZC
+      INTEGER(8) :: RESZR, RESZC
+      INTEGER(8) :: INTSZR, INTSZC
       INTEGER MAXMN
-      INTEGER I, IERROR
+      INTEGER I, IERROR, IOMP
       REAL ONEERRROW, ONEERRCOL, ONEERRL, ONEERRG
       REAL INFERRROW, INFERRCOL, INFERRL, INFERRG
-      INTEGER OORANGEIND
+      LOGICAL OORANGEIND
+      INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER    :: NOMP
+!$    INTEGER    :: CHUNK, CHUNK_NZ
+!$    ! Too large => pb with cache L3 ?
+!$    ! INTEGER(8) :: CHUNK8 
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP     = omp_get_max_threads()
+!$     CHUNK    = max(K361/2, (N+NOMP-1) / NOMP )
+!$    ! CHUNK8= (NZ_loc+int(NOMP-1,8) / int(NOMP,8) ) )
+!$     CHUNK_NZ = max(K361/2, (N+NOMP_MAX-1) / NOMP_MAX )
+!$    ENDIF
+C
+      OORANGEIND = .FALSE.
       INFERRG = -RONE
       ONEERRG = -RONE
-      OORANGEIND = 0
       MAXMN = M
       IF(MAXMN < N) MAXMN = N
 C     Create row partvec and col partvec
@@ -280,11 +320,11 @@ C     IF(IWRKSZ.LT.4*MAXMN) THEN   ERROR
             CALL SMUMPS_CREATEPARTVEC(MYID, NUMPROCS, COMM,
      &           IRN_loc, JCN_loc, NZ_loc,
      &           RPARTVEC, M, N,
-     &           IWRK, IWRKSZ)
+     &           IWRK, IWRKSZ, INUMMYR, NOMP_MAX)
             CALL SMUMPS_CREATEPARTVEC(MYID, NUMPROCS, COMM,
      &           JCN_loc, IRN_loc,  NZ_loc,
      &           CPARTVEC, N, M,
-     &           IWRK, IWRKSZ)         
+     &           IWRK, IWRKSZ, INUMMYC, NOMP_MAX)
 C     Compute sndrcv sizes, store them for later use           
             CALL SMUMPS_NUMVOLSNDRCV(MYID, NUMPROCS, M, RPARTVEC,
      &           NZ_loc, IRN_loc, N, JCN_loc,
@@ -298,20 +338,14 @@ C     Compute sndrcv sizes, store them f
      &           OCSNDRCVNUM,OCSNDRCVVOL,
      &           IWRK,IWRKSZ, 
      &           CSNDRCVSZ(1), CSNDRCVSZ(1+NUMPROCS), COMM)         
-            CALL SMUMPS_FINDNUMMYROWCOL(MYID, NUMPROCS, COMM,
-     &           IRN_loc, JCN_loc, NZ_loc,
-     &           RPARTVEC, CPARTVEC, M, N,
-     &           INUMMYR,
-     &           INUMMYC,     
-     &           IWRK, IWRKSZ)
-            INTSZR =  IRSNDRCVNUM + ORSNDRCVNUM + 
-     &           IRSNDRCVVOL + ORSNDRCVVOL +
-     &           2*(NUMPROCS+1) + INUMMYR
-            INTSZC = ICSNDRCVNUM + OCSNDRCVNUM + 
-     &           ICSNDRCVVOL + OCSNDRCVVOL +
-     &           2*(NUMPROCS+1) + INUMMYC
-            INTSZ = INTSZR + INTSZC + MAXMN + 
-     &           (MPI_STATUS_SIZE +1) *  NUMPROCS
+            INTSZR =  int(IRSNDRCVNUM,8) + int(ORSNDRCVNUM,8) + 
+     &           int(IRSNDRCVVOL,8) + int(ORSNDRCVVOL,8) +
+     &           2_8*int(NUMPROCS+1,8) + int(INUMMYR,8)
+            INTSZC = int(ICSNDRCVNUM,8) + int(OCSNDRCVNUM,8) + 
+     &           int(ICSNDRCVVOL,8) + int(OCSNDRCVVOL,8) +
+     &           2_8*int(NUMPROCS+1,8) + int(INUMMYC,8)
+            INTSZ = INTSZR + INTSZC + int(MAXMN,8) + 
+     &           int(MPI_STATUS_SIZE +1,8) * int(NUMPROCS,8)
          ELSE
 C     NUMPROCS IS 1
              IRSNDRCVNUM = 0
@@ -324,39 +358,39 @@ C     NUMPROCS IS 1
              ICSNDRCVVOL = 0
              OCSNDRCVVOL  = 0
              INUMMYC = 0
-             INTSZ = 0
+             INTSZ = 0_8
           ENDIF
 C     CALCULATE NECESSARY REAL SPACE
-          RESZR = M + IRSNDRCVVOL + ORSNDRCVVOL
-          RESZC = N + ICSNDRCVVOL + OCSNDRCVVOL
+          RESZR = int(M,8) + int(IRSNDRCVVOL,8) + int(ORSNDRCVVOL,8)
+          RESZC = int(N,8) + int(ICSNDRCVVOL,8) + int(OCSNDRCVVOL,8)
           RESZ = RESZR  + RESZC  
 C     CALCULATE NECESSARY INT SPACE
 C     The last maxmn is tmpwork for setup comm and fillmyrowcol
-          REGISTRE(1) = IRSNDRCVNUM 
-          REGISTRE(2) = ORSNDRCVNUM
-          REGISTRE(3) = IRSNDRCVVOL 
-          REGISTRE(4) = ORSNDRCVVOL
-          REGISTRE(5) = ICSNDRCVNUM 
-          REGISTRE(6) = OCSNDRCVNUM
-          REGISTRE(7) = ICSNDRCVVOL
-          REGISTRE(8) = OCSNDRCVVOL
-          REGISTRE(9) = INUMMYR
-          REGISTRE(10) = INUMMYC
+          REGISTRE(1)  = int(IRSNDRCVNUM,8)
+          REGISTRE(2)  = int(ORSNDRCVNUM,8)
+          REGISTRE(3)  = int(IRSNDRCVVOL,8)
+          REGISTRE(4)  = int(ORSNDRCVVOL,8)
+          REGISTRE(5)  = int(ICSNDRCVNUM,8)
+          REGISTRE(6)  = int(OCSNDRCVNUM,8)
+          REGISTRE(7)  = int(ICSNDRCVVOL,8)
+          REGISTRE(8)  = int(OCSNDRCVVOL,8)
+          REGISTRE(9)  = int(INUMMYR,8)
+          REGISTRE(10) = int(INUMMYC,8)
           REGISTRE(11) = INTSZ
           REGISTRE(12) = RESZ
        ELSE
 C     else of op=1. That is op=2 now.
 C     restore the numbers
-          IRSNDRCVNUM = REGISTRE(1) 
-          ORSNDRCVNUM = REGISTRE(2) 
-          IRSNDRCVVOL = REGISTRE(3)
-          ORSNDRCVVOL = REGISTRE(4) 
-          ICSNDRCVNUM = REGISTRE(5) 
-          OCSNDRCVNUM = REGISTRE(6) 
-          ICSNDRCVVOL = REGISTRE(7) 
-          OCSNDRCVVOL = REGISTRE(8) 
-          INUMMYR = REGISTRE(9) 
-          INUMMYC = REGISTRE(10)
+          IRSNDRCVNUM = int(REGISTRE(1))
+          ORSNDRCVNUM = int(REGISTRE(2))
+          IRSNDRCVVOL = int(REGISTRE(3))
+          ORSNDRCVVOL = int(REGISTRE(4))
+          ICSNDRCVNUM = int(REGISTRE(5))
+          OCSNDRCVNUM = int(REGISTRE(6))
+          ICSNDRCVVOL = int(REGISTRE(7))
+          OCSNDRCVVOL = int(REGISTRE(8))
+          INUMMYR     = int(REGISTRE(9))
+          INUMMYC     = int(REGISTRE(10))
           IF(NUMPROCS > 1) THEN
 C     Check done outsize
 C             IF(INTSZ < REGISTRE(11)) THEN ERROR
@@ -365,35 +399,36 @@ C     Fill up myrows and my colsX
              CALL SMUMPS_FILLMYROWCOLINDICES(MYID, NUMPROCS,COMM,    
      &            IRN_loc, JCN_loc, NZ_loc,
      &            RPARTVEC, CPARTVEC, M, N,
-     &            IWRK(1), INUMMYR,
-     &            IWRK(1+INUMMYR), INUMMYC,     
-     &            IWRK(1+INUMMYR+INUMMYC), IWRKSZ-INUMMYR-INUMMYC )
-             IMYRPTR = 1
-             IMYCPTR = IMYRPTR + INUMMYR
+     &            IWRK(1_8), INUMMYR,
+     &            IWRK(1_8+int(INUMMYR,8)), INUMMYC,     
+     &            IWRK(1_8+int(INUMMYR,8)+int(INUMMYC,8)),
+     &            IWRKSZ-int(INUMMYR,8)-int(INUMMYC,8), NOMP_MAX )
+             IMYRPTR = 1_8
+             IMYCPTR = IMYRPTR + int(INUMMYR,8)
 C     Set up comm and run.
 C     set pointers in iwrk (4 parts)
 C     
 C     ROWS    [---------------------------------------------]
-             IRNGHBPRCS = IMYCPTR+ INUMMYC
-             IRSNDRCVIA = IRNGHBPRCS+IRSNDRCVNUM
-             IRSNDRCVJA = IRSNDRCVIA + NUMPROCS+1
-             ORNGHBPRCS = IRSNDRCVJA + IRSNDRCVVOL
-             ORSNDRCVIA = ORNGHBPRCS + ORSNDRCVNUM
-             ORSNDRCVJA = ORSNDRCVIA + NUMPROCS + 1
+             IRNGHBPRCS = IMYCPTR    + int(INUMMYC    ,8)
+             IRSNDRCVIA = IRNGHBPRCS + int(IRSNDRCVNUM,8)
+             IRSNDRCVJA = IRSNDRCVIA + int(NUMPROCS+1 ,8)
+             ORNGHBPRCS = IRSNDRCVJA + int(IRSNDRCVVOL,8)
+             ORSNDRCVIA = ORNGHBPRCS + int(ORSNDRCVNUM,8)
+             ORSNDRCVJA = ORSNDRCVIA + int(NUMPROCS+1 ,8)
 C     COLS    [---------------------------------------------]
-             ICNGHBPRCS = ORSNDRCVJA + ORSNDRCVVOL
-             ICSNDRCVIA = ICNGHBPRCS + ICSNDRCVNUM
-             ICSNDRCVJA = ICSNDRCVIA + NUMPROCS+1
-             OCNGHBPRCS = ICSNDRCVJA + ICSNDRCVVOL
-             OCSNDRCVIA = OCNGHBPRCS + OCSNDRCVNUM
-             OCSNDRCVJA = OCSNDRCVIA +  NUMPROCS + 1
+             ICNGHBPRCS = ORSNDRCVJA + int(ORSNDRCVVOL,8)
+             ICSNDRCVIA = ICNGHBPRCS + int(ICSNDRCVNUM,8)
+             ICSNDRCVJA = ICSNDRCVIA + int(NUMPROCS+1 ,8)
+             OCNGHBPRCS = ICSNDRCVJA + int(ICSNDRCVVOL,8)
+             OCSNDRCVIA = OCNGHBPRCS + int(OCSNDRCVNUM,8)
+             OCSNDRCVJA = OCSNDRCVIA + int(NUMPROCS+1 ,8)
 C     
 C     MPI     [-----------------]
-             REQUESTS = OCSNDRCVJA + OCSNDRCVVOL
-             ISTATUS = REQUESTS + NUMPROCS
+             REQUESTS = OCSNDRCVJA + int(OCSNDRCVVOL,8)
+             ISTATUS = REQUESTS + int(NUMPROCS,8)
 C     
 C     TMPWRK  [-----------------]
-             TMPWORK = ISTATUS + MPI_STATUS_SIZE *  NUMPROCS
+             TMPWORK = ISTATUS + int(MPI_STATUS_SIZE,8)*int(NUMPROCS,8)
              CALL SMUMPS_SETUPCOMMS(MYID, NUMPROCS, M, RPARTVEC,
      &            NZ_loc, IRN_loc,N, JCN_loc,
      &            IRSNDRCVNUM, IRSNDRCVVOL, 
@@ -416,80 +451,165 @@ C     TMPWRK  [-----------------]
      &            IWRK(TMPWORK), 
      &            IWRK(ISTATUS),  IWRK(REQUESTS),
      &            TAG_COMM_COL, COMM)
-             CALL SMUMPS_INITREAL(ROWSCA, M, RZERO)
-             CALL SMUMPS_INITREAL(COLSCA, N, RZERO)
+             CALL SMUMPS_INITREAL(ROWSCA, M, RZERO, NOMP_MAX)
+             CALL SMUMPS_INITREAL(COLSCA, N, RZERO, NOMP_MAX)
              CALL SMUMPS_INITREALLST(ROWSCA, M, 
-     &            IWRK(IMYRPTR),INUMMYR, RONE)
+     &            IWRK(IMYRPTR),INUMMYR, RONE, NOMP_MAX)
              CALL SMUMPS_INITREALLST(COLSCA, N, 
-     &            IWRK(IMYCPTR),INUMMYC, RONE)   
+     &            IWRK(IMYCPTR),INUMMYC, RONE, NOMP_MAX)   
           ELSE
-             CALL SMUMPS_INITREAL(ROWSCA, M, RONE)
-             CALL SMUMPS_INITREAL(COLSCA, N, RONE)            
+             CALL SMUMPS_INITREAL(ROWSCA, M, RONE, NOMP_MAX)
+             CALL SMUMPS_INITREAL(COLSCA, N, RONE, NOMP_MAX)            
           ENDIF
-          ITDRPTR = 1
-          ITDCPTR = ITDRPTR + M
+          ITDRPTR = 1_8
+          ITDCPTR = ITDRPTR + int(M,8)
 C     
-          ISRRPTR = ITDCPTR + N
-          OSRRPTR = ISRRPTR + IRSNDRCVVOL
+          ISRRPTR = ITDCPTR + int(N,8)
+          OSRRPTR = ISRRPTR + int(IRSNDRCVVOL,8)
 C     
-          ISRCPTR = OSRRPTR + ORSNDRCVVOL
-          OSRCPTR = ISRCPTR + ICSNDRCVVOL
+          ISRCPTR = OSRRPTR + int(ORSNDRCVVOL,8)
+          OSRCPTR = ISRCPTR + int(ICSNDRCVVOL,8)
 C     To avoid bound check errors...
           IF(NUMPROCS == 1)THEN
-             OSRCPTR = OSRCPTR - 1
-             ISRCPTR = ISRCPTR - 1
-             OSRRPTR = OSRRPTR - 1
-             ISRRPTR = ISRRPTR - 1
+             OSRCPTR = OSRCPTR - 1_8
+             ISRCPTR = ISRCPTR - 1_8
+             OSRRPTR = OSRRPTR - 1_8
+             ISRRPTR = ISRRPTR - 1_8
           ELSE
-             IF(IRSNDRCVVOL == 0) ISRRPTR = ISRRPTR - 1
-             IF(ORSNDRCVVOL == 0) OSRRPTR = OSRRPTR - 1
-             IF(ICSNDRCVVOL == 0) ISRCPTR = ISRCPTR - 1
-             IF(OCSNDRCVVOL == 0) OSRCPTR = OSRCPTR - 1
+             IF(IRSNDRCVVOL == 0) ISRRPTR = ISRRPTR - 1_8
+             IF(ORSNDRCVVOL == 0) OSRRPTR = OSRRPTR - 1_8
+             IF(ICSNDRCVVOL == 0) ISRCPTR = ISRCPTR - 1_8
+             IF(OCSNDRCVVOL == 0) OSRCPTR = OSRCPTR - 1_8
           ENDIF
           ITER = 1
           DO WHILE (ITER.LE.NB1+NB2+NB3)
-C     CLEAR temporary Dr and Dc
-             IF(NUMPROCS > 1) THEN
-                CALL SMUMPS_ZEROOUT(WRKRC(ITDRPTR),M,
-     &               IWRK(IMYRPTR),INUMMYR)
-                CALL SMUMPS_ZEROOUT(WRKRC(ITDCPTR),N,
-     &               IWRK(IMYCPTR),INUMMYC)
-             ELSE
-                CALL SMUMPS_INITREAL(WRKRC(ITDRPTR),M, RZERO)
-                CALL SMUMPS_INITREAL(WRKRC(ITDCPTR),N, RZERO)
+C{
+C           -------------------------
+C           CLEAR temporary Dr and Dc
+C           -------------------------
+            IF (NOMP_MAX.GT.1 .AND. 
+     &        (ITER.GT.NB1 .AND.ITER.LE.NB1+NB2)
+     &      ) THEN
+C{
+!$OMP         PARALLEL
+!$OMP&         PRIVATE(IOMP)
+!$OMP&         NUM_THREADS(NOMP_MAX)
+               IOMP  = 1
+!$             IOMP = OMP_GET_THREAD_NUM() + 1
+               IF(NUMPROCS > 1) THEN
+                 CALL SMUMPS_ZEROOUT(WRKR_TH(1,IOMP),N,
+     &                 IWRK(IMYRPTR),INUMMYR, 0)
+                 CALL SMUMPS_ZEROOUT(WRKC_TH(1,IOMP),N,
+     &                 IWRK(IMYCPTR),INUMMYC, 0)
+               ELSE
+                 CALL SMUMPS_INITREAL(WRKR_TH(1,IOMP),N, RZERO, 
+     &                                0)
+                 CALL SMUMPS_INITREAL(WRKC_TH(1,IOMP),N, RZERO, 
+     &                                0)
+               ENDIF
+!$OMP         END PARALLEL
+C}
+            ELSE
+C{
+               IF(NUMPROCS > 1) THEN
+                  CALL SMUMPS_ZEROOUT(WRKRC(ITDRPTR),M,
+     &                 IWRK(IMYRPTR),INUMMYR, NOMP_MAX)
+                  CALL SMUMPS_ZEROOUT(WRKRC(ITDCPTR),N,
+     &                 IWRK(IMYCPTR),INUMMYC, NOMP_MAX)
+               ELSE
+                  CALL SMUMPS_INITREAL(WRKRC(ITDRPTR),M, RZERO, 
+     &                                NOMP_MAX)
+                  CALL SMUMPS_INITREAL(WRKRC(ITDCPTR),N, RZERO, 
+     &                                NOMP_MAX)
+               ENDIF
+C}
              ENDIF
              IF((ITER.LE.NB1).OR.(ITER > NB1+NB2)) THEN
+C     ------------------
 C     INF-NORM ITERATION
-                IF((ITER.EQ.1).OR.(OORANGEIND.EQ.1)) THEN
+C     ------------------
+               IF (NOMP_MAX.LE.0) THEN
+                IF((ITER.EQ.1).OR.(OORANGEIND)) THEN
                    DO NZIND=1_8,NZ_loc
                       IR = IRN_loc(NZIND)
                       IC = JCN_loc(NZIND)
                       IF((IR.GE.1).AND.(IR.LE.M).AND.
      &                     (IC.GE.1).AND.(IC.LE.N)) THEN
                          ELM = abs(A_loc(NZIND))*ROWSCA(IR)*COLSCA(IC)
-                         IF(WRKRC(ITDRPTR-1+IR)<ELM) THEN
-                            WRKRC(ITDRPTR-1+IR)= ELM
-                         ENDIF
-                         IF(WRKRC(ITDCPTR-1+IC)<ELM) THEN
-                            WRKRC(ITDCPTR-1+IC)= ELM
-                         ENDIF
+                         IF(WRKRC(IR)<ELM) WRKRC(IR)= ELM
+                         IF(WRKRC(ITDCPTR-1_8+int(IC,8))<ELM) 
+     &                      WRKRC(ITDCPTR-1_8+int(IC,8))= ELM
                       ELSE
-                         OORANGEIND = 1
+                         OORANGEIND = .TRUE.
                       ENDIF
                    ENDDO
-                ELSEIF(OORANGEIND.EQ.0) THEN
+                ELSEIF(.NOT.OORANGEIND) THEN
                    DO NZIND=1,NZ_loc
                       IR = IRN_loc(NZIND)
                       IC = JCN_loc(NZIND)
                       ELM = abs(A_loc(NZIND))*ROWSCA(IR)*COLSCA(IC)
-                      IF(WRKRC(ITDRPTR-1+IR)<ELM) THEN
-                         WRKRC(ITDRPTR-1+IR)= ELM
-                      ENDIF
-                      IF(WRKRC(ITDCPTR-1+IC)<ELM) THEN
-                         WRKRC(ITDCPTR-1+IC)= ELM
+                      IF(WRKRC(IR)<ELM) WRKRC(IR)= ELM
+                      IF(WRKRC(ITDCPTR-1_8+int(IC,8))<ELM) 
+     &                   WRKRC(ITDCPTR-1_8+int(IC,8))= ELM
+                   ENDDO
+                ENDIF
+               ELSE
+                IF((ITER.EQ.1).OR.(OORANGEIND)) THEN
+!$OMP   PARALLEL DO PRIVATE(NZIND,IR,IC,ELM) 
+!$OMP&  SCHEDULE(STATIC,CHUNK_NZ)
+!$OMP&  IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
+!$OMP&  REDUCTION(.OR.:OORANGEIND)
+                   DO NZIND=1_8,NZ_loc
+                      IR = IRN_loc(NZIND)
+                      IC = JCN_loc(NZIND)
+                      IF((IR.GE.1).AND.(IR.LE.M).AND.
+     &                     (IC.GE.1).AND.(IC.LE.N)) THEN
+                         ELM = abs(A_loc(NZIND))*ROWSCA(IR)*COLSCA(IC)
+!$OMP                    ATOMIC UPDATE
+                         WRKRC(IR)= max (ELM, WRKRC(IR))
+!$OMP                    END ATOMIC
+C                         IF(WRKRC(ITDRPTR-1_8+int(IR,8))<ELM) THEN
+C                            WRKRC(ITDRPTR-1_8+int(IR,8))= ELM
+C                         ENDIF
+C                        IF(WRKRC(ITDCPTR-1_8+int(IC,8))<ELM) THEN
+C                           WRKRC(ITDCPTR-1_8+int(IC,8))= ELM
+C                         ENDIF
+C                        ITDCPTR+IC might be > int4
+!$OMP                    ATOMIC UPDATE
+                         WRKRC(ITDCPTR-1_8+int(IC,8)) = 
+     &                   max (ELM,WRKRC(ITDCPTR-1_8+int(IC,8)))
+!$OMP                    END ATOMIC
+                      ELSE
+                         OORANGEIND = .TRUE.
                       ENDIF
                    ENDDO
+!$OMP   END PARALLEL DO
+                ELSEIF(.NOT.OORANGEIND) THEN
+!$OMP   PARALLEL DO PRIVATE(NZIND,IR,IC,ELM) 
+!$OMP&  SCHEDULE(STATIC,CHUNK_NZ)
+!$OMP&  IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
+                   DO NZIND=1,NZ_loc
+                      IR = IRN_loc(NZIND)
+                      IC = JCN_loc(NZIND)
+                      ELM = abs(A_loc(NZIND))*ROWSCA(IR)*COLSCA(IC)
+C                      IF(WRKRC(ITDRPTR-1_8+int(IR,8))<ELM) THEN
+C                         WRKRC(ITDRPTR-1_8+int(IR,8))= ELM
+C                      ENDIF
+!$OMP                 ATOMIC UPDATE
+                      WRKRC(IR)= max (ELM, WRKRC(IR))
+!$OMP                 END ATOMIC
+C                      IF(WRKRC(ITDCPTR-1_8+int(IC,8))<ELM) THEN
+C                         WRKRC(ITDCPTR-1_8+int(IC,8))= ELM
+C                      ENDIF
+!$OMP                 ATOMIC UPDATE
+                      WRKRC(ITDCPTR-1_8+int(IC,8)) = 
+     &                   max (ELM,WRKRC(ITDCPTR-1_8+int(IC,8)))
+!$OMP                 END ATOMIC
+                   ENDDO
+!$OMP   END PARALLEL DO
                 ENDIF
+C}
+               ENDIF
                 IF(NUMPROCS > 1) THEN
                    CALL SMUMPS_DOCOMMINF(MYID, NUMPROCS,
      &                  WRKRC(ITDCPTR), N, TAG_ITERS+ITER, 
@@ -518,11 +638,11 @@ C
      &                 (NB1+NB3.GT.0))) THEN
                      INFERRROW = SMUMPS_ERRSCALOC(ROWSCA, 
      &                    WRKRC(ITDRPTR), M,
-     &                    IWRK(IMYRPTR),INUMMYR)
+     &                    IWRK(IMYRPTR),INUMMYR, NOMP_MAX)
 C     find error for the cols
                      INFERRCOL = SMUMPS_ERRSCALOC(COLSCA,  
      &                    WRKRC(ITDCPTR), N,
-     &                    IWRK(IMYCPTR),INUMMYC)
+     &                    IWRK(IMYCPTR),INUMMYC, NOMP_MAX)
 C     get max of those two errors
                      INFERRL = INFERRCOL
                      IF(INFERRROW > INFERRL ) THEN
@@ -535,10 +655,10 @@ C
                      IF(INFERRG.LE.EPS) THEN
                         CALL SMUMPS_UPDATESCALE(COLSCA,  
      &                       WRKRC(ITDCPTR),N,
-     &                       IWRK(IMYCPTR),INUMMYC)
+     &                       IWRK(IMYCPTR),INUMMYC, NOMP_MAX)
                         CALL SMUMPS_UPDATESCALE(ROWSCA,  
      &                       WRKRC(ITDRPTR),M,
-     &                       IWRK(IMYRPTR),INUMMYR)         
+     &                       IWRK(IMYRPTR),INUMMYR, NOMP_MAX)         
                         IF(ITER .LE. NB1) THEN
                            ITER = NB1+1
                            CYCLE
@@ -554,10 +674,10 @@ C     SINGLE PROCESSOR CASE: INF-NORM ER
      &                 ((ITER.EQ.NB1+NB2+NB3).AND.
      &                 (NB1+NB3.GT.0))) THEN
                      INFERRROW = SMUMPS_ERRSCA1(ROWSCA, 
-     &                    WRKRC(ITDRPTR), M)
+     &                    WRKRC(ITDRPTR), M, NOMP_MAX)
 C     find error for the cols
                      INFERRCOL = SMUMPS_ERRSCA1(COLSCA,  
-     &                    WRKRC(ITDCPTR), N)
+     &                    WRKRC(ITDCPTR), N, NOMP_MAX)
 C     get max of those two errors
                      INFERRL = INFERRCOL
                      IF(INFERRROW > INFERRL) THEN
@@ -565,8 +685,10 @@ C     get max of those two errors
                      ENDIF                     
                      INFERRG = INFERRL
                      IF(INFERRG.LE.EPS) THEN
-                        CALL SMUMPS_UPSCALE1(COLSCA,  WRKRC(ITDCPTR), N)
-                        CALL SMUMPS_UPSCALE1(ROWSCA,  WRKRC(ITDRPTR), M)
+                        CALL SMUMPS_UPSCALE1(COLSCA, WRKRC(ITDCPTR), N, 
+     &                                       NOMP_MAX)
+                        CALL SMUMPS_UPSCALE1(ROWSCA, WRKRC(ITDRPTR), M, 
+     &                                       NOMP_MAX)
                         IF(ITER .LE. NB1) THEN
                            ITER = NB1+1
                            CYCLE
@@ -577,30 +699,102 @@ C     get max of those two errors
                   ENDIF
                ENDIF
             ELSE
+C     ----------------------------------------
 C     WE HAVE ITER.GT.NB1 AND ITER.LE.NB1+NB2. 
 C     ONE-NORM ITERATION
-               IF((ITER .EQ.1).OR.(OORANGEIND.EQ.1))THEN
+C     ----------------------------------------
+             IF (NOMP_MAX.LE.1) THEN
+               IF((ITER .EQ.1).OR.(OORANGEIND))THEN
+                  DO NZIND=1_8,NZ_loc
+                     IR = IRN_loc(NZIND)
+                     IC = JCN_loc(NZIND)
+                     IF((IR.GE.1).AND.(IR.LE.M).AND.
+     &                    (IC.GE.1).AND.(IC.LE.N)) THEN
+                        ELM = abs(A_loc(NZIND))*ROWSCA(IR)*COLSCA(IC)
+C                       WRKRC(ITDRPTR-1_8+int(IR,8)) =
+C     &                 WRKRC(ITDRPTR-1_8+int(IR,8)) + ELM
+                        WRKRC(IR) =  WRKRC(IR) + ELM
+                        WRKRC(ITDCPTR-1_8+int(IC,8)) =
+     &                  WRKRC(ITDCPTR-1_8+int(IC,8)) + ELM
+                     ELSE
+                        OORANGEIND = .TRUE.
+                     ENDIF
+                  ENDDO
+               ELSEIF(.NOT.OORANGEIND) THEN
+                  DO NZIND=1,NZ_loc
+                     IR = IRN_loc(NZIND)
+                     IC = JCN_loc(NZIND)
+                     ELM = abs(A_loc(NZIND))*ROWSCA(IR)*COLSCA(IC)
+C                    WRKRC(ITDRPTR-1_8+int(IR,8)) =
+C     &              WRKRC(ITDRPTR-1_8+int(IR,8)) + ELM
+                     WRKRC(IR) =  WRKRC(IR) + ELM
+                     WRKRC(ITDCPTR-1_8+int(IC,8)) =
+     &               WRKRC(ITDCPTR-1_8+int(IC,8)) + ELM
+                  ENDDO
+               ENDIF
+C}
+             ELSE  ! NOMP_MAX>1
+               IF((ITER .EQ.1).OR.(OORANGEIND))THEN
+!$OMP   PARALLEL PRIVATE(IOMP)
+!$OMP&  NUM_THREADS(NOMP_MAX)
+!$OMP&    IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
+                    IOMP  = 1
+!$                  IOMP = OMP_GET_THREAD_NUM() + 1
+!$OMP     DO PRIVATE(NZIND,IR,IC,ELM)
+!$OMP&    SCHEDULE(STATIC,CHUNK_NZ)
+!$OMP&    REDUCTION(.OR.:OORANGEIND)
                   DO NZIND=1_8,NZ_loc
                      IR = IRN_loc(NZIND)
                      IC = JCN_loc(NZIND)
                      IF((IR.GE.1).AND.(IR.LE.M).AND.
      &                    (IC.GE.1).AND.(IC.LE.N)) THEN
                         ELM = abs(A_loc(NZIND))*ROWSCA(IR)*COLSCA(IC)
-                        WRKRC(ITDRPTR-1+IR) = WRKRC(ITDRPTR-1+IR) + ELM
-                        WRKRC(ITDCPTR-1+IC) = WRKRC(ITDCPTR-1+IC) + ELM
+                        WRKR_TH(IR,IOMP) = WRKR_TH(IR,IOMP) + ELM
+                        IF (IR.NE.IC)
+     &                  WRKC_TH(IC,IOMP) = WRKC_TH(IC,IOMP) + ELM
                      ELSE
-                        OORANGEIND = 1
+                        OORANGEIND = .TRUE.
                      ENDIF
                   ENDDO
-               ELSEIF(OORANGEIND.EQ.0) THEN
+!$OMP     END DO
+!$OMP   END PARALLEL
+               ELSEIF(.NOT.OORANGEIND) THEN
+!$OMP   PARALLEL PRIVATE(IOMP)
+!$OMP&  NUM_THREADS(NOMP_MAX)
+!$OMP&    IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
+                    IOMP  = 1
+!$                  IOMP = OMP_GET_THREAD_NUM() + 1
+!$OMP     DO PRIVATE(NZIND,IR,IC,ELM)
+!$OMP&    SCHEDULE(STATIC,CHUNK_NZ)
                   DO NZIND=1,NZ_loc
                      IR = IRN_loc(NZIND)
                      IC = JCN_loc(NZIND)
                      ELM = abs(A_loc(NZIND))*ROWSCA(IR)*COLSCA(IC)
-                     WRKRC(ITDRPTR-1+IR) = WRKRC(ITDRPTR-1+IR) + ELM
-                     WRKRC(ITDCPTR-1+IC) = WRKRC(ITDCPTR-1+IC) + ELM
+                     WRKR_TH(IR,IOMP) = WRKR_TH(IR,IOMP) + ELM
+                     IF (IR.NE.IC)
+     &               WRKC_TH(IC,IOMP) = WRKC_TH(IC,IOMP) + ELM
                   ENDDO
+!$OMP     END DO
+!$OMP   END PARALLEL
+               ENDIF
+C
+C              For all i on MYID:
+C              Build WRKRC(i) = Sum       (WRKR_TH(i,IOMP)
+C                              IOMP \in [1:NOMP_MAX]
+               IF(NUMPROCS > 1) THEN
+                 CALL SMUMPS_REDUCE_WRK_MPI (WRKRC, N, WRKR_TH, 
+     &                 NOMP_MAX, 
+     &                 IWRK(IMYRPTR),INUMMYR)
+                 CALL SMUMPS_REDUCE_WRK_MPI (WRKRC(ITDCPTR), 
+     &                 N, WRKC_TH, NOMP_MAX, 
+     &                 IWRK(IMYCPTR),INUMMYC)
+               ELSE
+                 CALL SMUMPS_REDUCE_WRK (WRKRC, N, WRKR_TH, NOMP_MAX)
+                 CALL SMUMPS_REDUCE_WRK (WRKRC(ITDCPTR), 
+     &                 N, WRKC_TH, NOMP_MAX)
                ENDIF
+C}
+             ENDIF
                IF(NUMPROCS > 1) THEN                 
                   CALL SMUMPS_DOCOMM1N(MYID, NUMPROCS,
      &                 WRKRC(ITDCPTR), N, TAG_ITERS+ITER, 
@@ -628,11 +822,11 @@ C
      &                 (NB2.GT.0))) THEN
                      ONEERRROW = SMUMPS_ERRSCALOC(ROWSCA, 
      &                    WRKRC(ITDRPTR), M,
-     &                    IWRK(IMYRPTR),INUMMYR)
+     &                    IWRK(IMYRPTR),INUMMYR, NOMP_MAX)
 C     find error for the cols
                      ONEERRCOL = SMUMPS_ERRSCALOC(COLSCA,  
      &                    WRKRC(ITDCPTR), N,
-     &                    IWRK(IMYCPTR),INUMMYC)
+     &                    IWRK(IMYCPTR),INUMMYC, NOMP_MAX)
 C     get max of those two errors
                      ONEERRL = ONEERRCOL
                      IF(ONEERRROW > ONEERRL ) THEN
@@ -645,10 +839,10 @@ C
                      IF(ONEERRG.LE.EPS) THEN
                         CALL SMUMPS_UPDATESCALE(COLSCA,
      &                       WRKRC(ITDCPTR),N,
-     &                       IWRK(IMYCPTR),INUMMYC)
+     &                       IWRK(IMYCPTR),INUMMYC, NOMP_MAX)
                         CALL SMUMPS_UPDATESCALE(ROWSCA,
      &                       WRKRC(ITDRPTR),M,
-     &                       IWRK(IMYRPTR),INUMMYR)          
+     &                       IWRK(IMYRPTR),INUMMYR, NOMP_MAX)
                         ITER = NB1+NB2+1
                         CYCLE
                      ENDIF
@@ -659,10 +853,10 @@ C     SINGLE-PROCESSOR CASE: ONE-NORM ER
      &                 ((ITER.EQ.NB1+NB2).AND.
      &                 (NB2.GT.0))) THEN
                      ONEERRROW = SMUMPS_ERRSCA1(ROWSCA, 
-     &                    WRKRC(ITDRPTR), M)
+     &                    WRKRC(ITDRPTR), M, NOMP_MAX)
 C     find error for the cols
                      ONEERRCOL = SMUMPS_ERRSCA1(COLSCA,  
-     &                    WRKRC(ITDCPTR), N)
+     &                    WRKRC(ITDCPTR), N, NOMP_MAX)
 C     get max of those two errors
                      ONEERRL = ONEERRCOL
                      IF(ONEERRROW > ONEERRL) THEN
@@ -670,30 +864,36 @@ C     get max of those two errors
                      ENDIF                     
                      ONEERRG = ONEERRL
                      IF(ONEERRG.LE.EPS) THEN
-                        CALL SMUMPS_UPSCALE1(COLSCA,  WRKRC(ITDCPTR), N)
-                        CALL SMUMPS_UPSCALE1(ROWSCA,  WRKRC(ITDRPTR), M)
-                        ITER = NB1+NB2+1                        
-                        CYCLE
+                       CALL SMUMPS_UPSCALE1(COLSCA, WRKRC(ITDCPTR), N, 
+     &                                      NOMP_MAX)
+                       CALL SMUMPS_UPSCALE1(ROWSCA, WRKRC(ITDRPTR), M, 
+     &                                      NOMP_MAX)
+                       ITER = NB1+NB2+1                        
+                       CYCLE
                      ENDIF
                   ENDIF                  
                ENDIF 
             ENDIF
             IF(NUMPROCS > 1) THEN               
                CALL SMUMPS_UPDATESCALE(COLSCA,  WRKRC(ITDCPTR), N,
-     &              IWRK(IMYCPTR),INUMMYC)
+     &              IWRK(IMYCPTR),INUMMYC, NOMP_MAX)
                CALL SMUMPS_UPDATESCALE(ROWSCA,  WRKRC(ITDRPTR), M,
-     &              IWRK(IMYRPTR),INUMMYR)               
+     &              IWRK(IMYRPTR),INUMMYR, NOMP_MAX)               
 C   
             ELSE
 C     SINGLE PROCESSOR CASE: Conv check and update of sca arrays
-               CALL SMUMPS_UPSCALE1(COLSCA,  WRKRC(ITDCPTR), N)
-               CALL SMUMPS_UPSCALE1(ROWSCA,  WRKRC(ITDRPTR), M)
+               CALL SMUMPS_UPSCALE1(COLSCA, WRKRC(ITDCPTR), N, 
+     &                              NOMP_MAX)
+               CALL SMUMPS_UPSCALE1(ROWSCA, WRKRC(ITDRPTR), M, 
+     &                              NOMP_MAX)
             ENDIF
             ITER = ITER + 1
+C}
          ENDDO
          ONENORMERR = ONEERRG 
          INFNORMERR = INFERRG 
          IF(NUMPROCS > 1) THEN
+C{
             CALL MPI_REDUCE(ROWSCA, WRKRC(1), M, MPI_REAL,
      &           MPI_MAX, 0, 
      &           COMM, IERROR)
@@ -707,14 +907,28 @@ C     WRITE (6,*) MYID, 'ROWSCA=',ROWSCA
 C     WRITE (6,*) MYID, 'COLSCA=',COLSCA
 C     CALL FLUSH(6)
 c     REduce the whole scaling factors to processor 0 of COMM
-            CALL MPI_REDUCE(COLSCA, WRKRC(1+M), N, MPI_REAL,
+            CALL MPI_REDUCE(COLSCA, WRKRC(1_8+int(M,8)), N, 
+     &           MPI_REAL,
      &           MPI_MAX, 0, 
      &           COMM, IERROR)
-            If(MYID.EQ.0) THEN
+            IF(MYID.EQ.0) THEN
+C{
+              IF (NOMP_MAX.LE.0) THEN
                DO I=1, N
-                  COLSCA(I) = WRKRC(I+M)
+                  COLSCA(I) = WRKRC(int(I,8)+int(M,8))
                ENDDO
+              ELSE
+!$OMP       PARALLEL DO PRIVATE(I)
+!$OMP&      SCHEDULE(STATIC,CHUNK)
+!$OMP&      IF ( N > K361 .AND. NOMP .GT. 1)
+               DO I=1, N
+                  COLSCA(I) = WRKRC(int(I,8)+int(M,8))
+               ENDDO
+!$OMP       END PARALLEL DO
+              ENDIF
+C}
             ENDIF         
+C}
          ENDIF
       ENDIF
       RETURN
@@ -732,6 +946,7 @@ C
      &     IWRK, IWRKSZ,
      &     INTSZ, RESZ, OP,
      &     SCA, WRKRC, ISZWRKRC,
+     &     WRKR_TH, LWRKR_TH, NOMP_MAX,
      &     NB1, NB2, NB3, EPS,
      &     ONENORMERR, INFNORMERR)    
 C----------------------------------------------------------------------
@@ -821,31 +1036,34 @@ C         In proceedings of VECPAR'08-In
 C         Performance Computing for Computational Science, Jan'08.
 C     and was supported by ANR-SOLSTICE project (ANR-06-CIS6-010)
 C ---------------------------------------------------------------------
+!$    USE OMP_LIB
       IMPLICIT NONE
       INCLUDE 'mpif.h'
       INTEGER(8) :: NZ_loc 
-      INTEGER N, IWRKSZ, OP
-      INTEGER NUMPROCS, MYID, COMM
-      INTEGER INTSZ, RESZ
+      INTEGER N, OP
+      INTEGER(8) :: IWRKSZ, LWRKR_TH
+      INTEGER NUMPROCS, MYID, COMM, NOMP_MAX
+      INTEGER(8) :: INTSZ, RESZ
       INTEGER IRN_loc(NZ_loc)
       INTEGER JCN_loc(NZ_loc)
       REAL A_loc(NZ_loc)
       INTEGER PARTVEC(N), RSNDRCVSZ(2*NUMPROCS)
       INTEGER IWRK(IWRKSZ)
-      INTEGER REGISTRE(12)
+      INTEGER(8) :: REGISTRE(12)
       REAL SCA(N)
-      INTEGER ISZWRKRC
-      REAL WRKRC(ISZWRKRC)
+      INTEGER(8) :: ISZWRKRC
+      REAL WRKRC(ISZWRKRC), 
+     &     WRKR_TH(LWRKR_TH, max(NOMP_MAX,1))
 C     LOCALS
       INTEGER IRSNDRCVNUM, ORSNDRCVNUM
       INTEGER IRSNDRCVVOL, ORSNDRCVVOL
       INTEGER  INUMMYR
 C IMPORTANT POINTERS
-      INTEGER IMYRPTR,IMYCPTR 
-      INTEGER IRNGHBPRCS, IRSNDRCVIA,IRSNDRCVJA
-      INTEGER ORNGHBPRCS, ORSNDRCVIA,ORSNDRCVJA
-      INTEGER ISTATUS, REQUESTS, TMPWORK
-      INTEGER ITDRPTR, ISRRPTR, OSRRPTR
+      INTEGER(8) :: IMYRPTR,IMYCPTR 
+      INTEGER(8) :: IRNGHBPRCS, IRSNDRCVIA,IRSNDRCVJA
+      INTEGER(8) :: ORNGHBPRCS, ORSNDRCVIA,ORSNDRCVJA
+      INTEGER(8) :: ISTATUS, REQUESTS, TMPWORK
+      INTEGER(8) :: ITDRPTR, ISRRPTR, OSRRPTR
       REAL ONENORMERR,INFNORMERR
 C     FOR the scaling phase  
       INTEGER NB1, NB2, NB3
@@ -863,58 +1081,65 @@ C     FUNCTIONS
       EXTERNAL SMUMPS_CREATEPARTVECSYM,
      &     SMUMPS_NUMVOLSNDRCVSYM, 
      &     SMUMPS_SETUPCOMMSSYM,
-     &     SMUMPS_FINDNUMMYROWCOLSYM, 
-     &     SMUMPS_CHKCONVGLOSYM,
-     &     SMUMPS_CHK1CONV,
      &     SMUMPS_FILLMYROWCOLINDICESSYM,
      &     SMUMPS_DOCOMMINF,
      &     SMUMPS_DOCOMM1N,
      &     SMUMPS_INITREAL,
      &     SMUMPS_INITREALLST
-      INTEGER SMUMPS_CHKCONVGLOSYM 
-      INTEGER SMUMPS_CHK1CONV
       REAL SMUMPS_ERRSCALOC
       REAL SMUMPS_ERRSCA1
       INTRINSIC abs
       REAL RONE, RZERO
       PARAMETER(RONE=1.0E0,RZERO=0.0E0)
 C     TMP VARS
-      INTEGER INTSZR
+      INTEGER(8) :: INTSZR
       INTEGER MAXMN
       INTEGER I, IERROR
       REAL ONEERRL, ONEERRG
       REAL INFERRL, INFERRG
-      INTEGER OORANGEIND
-      OORANGEIND = 0
+      LOGICAL OORANGEIND
+      INTEGER, PARAMETER :: K361 = 2048
+      INTEGER            :: IOMP
+!$    INTEGER    :: NOMP
+!$    INTEGER    :: CHUNK, CHUNK_NZ
+!$    ! Too large => pb with cache L3 ?
+!$    ! INTEGER(8) :: CHUNK8 
+!$    ! CHUNK8= max(int(K361/2,8), 
+!$    !  &   (NZ_loc+int(NOMP-1,8) / int(NOMP,8) ) )
+!$    ! CHUNK8   = min(CHUNK8, huge(CHUNK)-1_8)
+!$    NOMP  = omp_get_max_threads()
+!$    CHUNK= max(K361/2, (N+NOMP-1) / NOMP )
+!$    IF (NOMP_MAX.GT.0) THEN
+!$      CHUNK_NZ = max(K361/2, (N+NOMP_MAX-1) / NOMP_MAX )
+!$    ENDIF
+C
+      OORANGEIND = .FALSE.
       INFERRG = -RONE
       ONEERRG = -RONE
       MAXMN = N
       IF(OP == 1) THEN
+C{
          IF(NUMPROCS > 1) THEN
 C     Check done outside
 C     IF(IWRKSZ.LT.2*MAXMN) THEN   ERROR.... 
             CALL SMUMPS_CREATEPARTVECSYM(MYID, NUMPROCS, COMM,
      &           IRN_loc, JCN_loc, NZ_loc,
      &           PARTVEC, N,
-     &           IWRK, IWRKSZ)
-C     
+     &           IWRK, IWRKSZ, INUMMYR )
+C
+C     Check done outside
             CALL SMUMPS_NUMVOLSNDRCVSYM(MYID, NUMPROCS, N, PARTVEC,
      &           NZ_loc, IRN_loc, JCN_loc, IRSNDRCVNUM,IRSNDRCVVOL,
      &           ORSNDRCVNUM, ORSNDRCVVOL,
      &           IWRK,IWRKSZ, 
      &           RSNDRCVSZ(1), RSNDRCVSZ(1+NUMPROCS), COMM)
 C     
-            CALL SMUMPS_FINDNUMMYROWCOLSYM(MYID, NUMPROCS, COMM,
-     &           IRN_loc, JCN_loc, NZ_loc,
-     &           PARTVEC, N,
-     &           INUMMYR,
-     &           IWRK, IWRKSZ)
 C     
-            INTSZR =  IRSNDRCVNUM + ORSNDRCVNUM + 
-     &           IRSNDRCVVOL + ORSNDRCVVOL +
-     &           2*(NUMPROCS+1) + INUMMYR
-            INTSZ = INTSZR + N + 
-     &           (MPI_STATUS_SIZE +1) *  NUMPROCS
+            INTSZR =  int(IRSNDRCVNUM,8) + int(ORSNDRCVNUM,8) + 
+     &           int(IRSNDRCVVOL,8) + int(ORSNDRCVVOL,8) +
+     &           2_8*int(NUMPROCS+1,8) + int(INUMMYR,8)
+            INTSZ = INTSZR + int(N,8) + 
+     &           int(MPI_STATUS_SIZE +1,8) * int(NUMPROCS,8)
          ELSE
 C     NUMPROCS IS 1
             IRSNDRCVNUM = 0
@@ -922,25 +1147,27 @@ C     NUMPROCS IS 1
             IRSNDRCVVOL = 0 
             ORSNDRCVVOL = 0
             INUMMYR = 0
-            INTSZ = 0
+            INTSZ = 0_8
          ENDIF
 C     CALCULATE NECESSARY REAL SPACE
-         RESZ = N + IRSNDRCVVOL + ORSNDRCVVOL
-         REGISTRE(1) = IRSNDRCVNUM 
-         REGISTRE(2) = ORSNDRCVNUM
-         REGISTRE(3) = IRSNDRCVVOL 
-         REGISTRE(4) = ORSNDRCVVOL
-         REGISTRE(9) = INUMMYR
+         RESZ = int(N,8) + int(IRSNDRCVVOL,8) + int(ORSNDRCVVOL,8)
+         REGISTRE(1)  = int(IRSNDRCVNUM,8)
+         REGISTRE(2)  = int(ORSNDRCVNUM,8)
+         REGISTRE(3)  = int(IRSNDRCVVOL,8)
+         REGISTRE(4)  = int(ORSNDRCVVOL,8)
+         REGISTRE(9)  = int(INUMMYR,8)
          REGISTRE(11) = INTSZ
          REGISTRE(12) = RESZ
+C}
       ELSE
+C{
 C     else of op=1. That is op=2 now.
 C     restore the numbers
-         IRSNDRCVNUM = REGISTRE(1) 
-         ORSNDRCVNUM = REGISTRE(2) 
-         IRSNDRCVVOL = REGISTRE(3)
-         ORSNDRCVVOL = REGISTRE(4) 
-         INUMMYR = REGISTRE(9) 
+         IRSNDRCVNUM = int(REGISTRE(1))
+         ORSNDRCVNUM = int(REGISTRE(2))
+         IRSNDRCVVOL = int(REGISTRE(3))
+         ORSNDRCVVOL = int(REGISTRE(4))
+         INUMMYR     = int(REGISTRE(9))
           IF(NUMPROCS > 1) THEN
 C     Check done outsize
 C             IF(INTSZ < REGISTRE(11)) THEN ERROR
@@ -950,24 +1177,24 @@ C     Fill up myrows and my colsX
      &            IRN_loc, JCN_loc, NZ_loc,
      &            PARTVEC, N,
      &            IWRK(1), INUMMYR,
-     &            IWRK(1+INUMMYR), IWRKSZ-INUMMYR)
-             IMYRPTR = 1
-             IMYCPTR = IMYRPTR + INUMMYR
+     &            IWRK(1+INUMMYR), IWRKSZ-int(INUMMYR,8), NOMP_MAX)
+             IMYRPTR = 1_8
+             IMYCPTR = IMYRPTR + int(INUMMYR,8)
 C     Set up comm and run.
 C     set pointers in iwrk (3 parts)
 C     
 C     ROWS    [---------------------------------------------]
              IRNGHBPRCS = IMYCPTR 
-             IRSNDRCVIA = IRNGHBPRCS+IRSNDRCVNUM
-             IRSNDRCVJA = IRSNDRCVIA + NUMPROCS+1
-             ORNGHBPRCS = IRSNDRCVJA + IRSNDRCVVOL
-             ORSNDRCVIA = ORNGHBPRCS + ORSNDRCVNUM
-             ORSNDRCVJA = ORSNDRCVIA + NUMPROCS + 1
+             IRSNDRCVIA = IRNGHBPRCS + int(IRSNDRCVNUM,8)
+             IRSNDRCVJA = IRSNDRCVIA + int(NUMPROCS+1,8)
+             ORNGHBPRCS = IRSNDRCVJA + int(IRSNDRCVVOL,8)
+             ORSNDRCVIA = ORNGHBPRCS + int(ORSNDRCVNUM,8)
+             ORSNDRCVJA = ORSNDRCVIA + int(NUMPROCS + 1,8)
 C     MPI     [-----------------]
-             REQUESTS = ORSNDRCVJA + ORSNDRCVVOL 
-             ISTATUS = REQUESTS + NUMPROCS
+             REQUESTS = ORSNDRCVJA + int(ORSNDRCVVOL,8)
+             ISTATUS = REQUESTS + int(NUMPROCS,8)
 C     TMPWRK  [-----------------]
-             TMPWORK = ISTATUS + MPI_STATUS_SIZE *  NUMPROCS
+             TMPWORK = ISTATUS + int(MPI_STATUS_SIZE,8)*int(NUMPROCS,8)
              CALL SMUMPS_SETUPCOMMSSYM(MYID, NUMPROCS, N, PARTVEC,
      &            NZ_loc, IRN_loc, JCN_loc,
      &            IRSNDRCVNUM, IRSNDRCVVOL, 
@@ -978,15 +1205,15 @@ C     TMPWRK  [-----------------]
      &            IWRK(TMPWORK), 
      &            IWRK(ISTATUS), IWRK(REQUESTS),
      &            TAG_COMM_ROW, COMM)
-             CALL SMUMPS_INITREAL(SCA, N, RZERO)
+             CALL SMUMPS_INITREAL(SCA, N, RZERO, NOMP_MAX)
              CALL SMUMPS_INITREALLST(SCA, N, 
-     &            IWRK(IMYRPTR),INUMMYR, RONE)
+     &            IWRK(IMYRPTR),INUMMYR, RONE, NOMP_MAX)
           ELSE
-             CALL SMUMPS_INITREAL(SCA, N, RONE)
+             CALL SMUMPS_INITREAL(SCA, N, RONE, NOMP_MAX)
           ENDIF
-          ITDRPTR = 1
-          ISRRPTR = ITDRPTR + N
-          OSRRPTR = ISRRPTR + IRSNDRCVVOL
+          ITDRPTR = 1_8
+          ISRRPTR = ITDRPTR + int(N,8)
+          OSRRPTR = ISRRPTR + int(IRSNDRCVVOL,8)
 C     
 C     To avoid bound check errors...
           IF(NUMPROCS == 1)THEN
@@ -999,46 +1226,123 @@ C     To avoid bound check errors...
 C     computation starts
           ITER = 1
           DO WHILE(ITER.LE.NB1+NB2+NB3)
-C     CLEAR temporary Dr and Dc
-             IF(NUMPROCS > 1) THEN
-                CALL SMUMPS_ZEROOUT(WRKRC(ITDRPTR),N,
-     &               IWRK(IMYRPTR),INUMMYR)
+C{
+C            -------------------------
+C            CLEAR temporary Dr and Dc 
+C            -------------------------
+             IF (NOMP_MAX.GT.1 .AND. 
+     &         (ITER.GT.NB1 .AND.ITER.LE.NB1+NB2)
+     &       ) THEN
+C             if one norm iteration and multithreading activated
+C             WRKR_TH need be initialized and 
+C             WRKRC will be set by reduction of WRKR_TH
+!$OMP         PARALLEL
+!$OMP&         PRIVATE(IOMP)
+!$OMP&         NUM_THREADS(NOMP_MAX)
+               IOMP  = 1
+!$             IOMP = OMP_GET_THREAD_NUM() + 1
+               IF(NUMPROCS > 1) THEN
+                 CALL SMUMPS_ZEROOUT(WRKR_TH(1,IOMP),N,
+     &                 IWRK(IMYRPTR),INUMMYR, 0)
+               ELSE
+                 CALL SMUMPS_INITREAL(WRKR_TH(1,IOMP),N, RZERO, 
+     &                                0)
+               ENDIF
+!$OMP         END PARALLEL
              ELSE
-                CALL SMUMPS_INITREAL(WRKRC(ITDRPTR),N, RZERO)
+              IF(NUMPROCS > 1) THEN
+CFIXME         Size N should be adjusted to effective size
+                 CALL SMUMPS_ZEROOUT(WRKRC(ITDRPTR),N,
+     &                IWRK(IMYRPTR),INUMMYR, NOMP_MAX)
+              ELSE
+                 CALL SMUMPS_INITREAL(WRKRC(ITDRPTR),N, RZERO,
+     &                                NOMP_MAX)
+              ENDIF
              ENDIF
+C
              IF((ITER.LE.NB1).OR.(ITER > NB1+NB2)) THEN
-C     INF-NORM ITERATION
-                IF((ITER.EQ.1).OR.(OORANGEIND.EQ.1)) THEN
+C            ------------------
+C{           INF-NORM ITERATION
+C            ------------------
+               IF (NOMP_MAX.LE.0) THEN
+                 IF((ITER .EQ.1).OR.(OORANGEIND))THEN
                    DO NZIND=1_8,NZ_loc
                       IR = IRN_loc(NZIND)
                       IC = JCN_loc(NZIND)
                       IF((IR.GE.1).AND.(IR.LE.N).AND.
      &                     (IC.GE.1).AND.(IC.LE.N)) THEN
                          ELM = abs(A_loc(NZIND))*SCA(IR)*SCA(IC)
-                         IF(WRKRC(ITDRPTR-1+IR)<ELM) THEN
-                            WRKRC(ITDRPTR-1+IR)= ELM
-                         ENDIF
-                         IF(WRKRC(ITDRPTR-1+IC)<ELM) THEN
-                            WRKRC(ITDRPTR-1+IC)= ELM
-                         ENDIF
+                         IF (WRKRC(IR)<ELM) WRKRC(IR)= ELM
+                         IF (WRKRC(IC)<ELM) WRKRC(IC)= ELM
                       ELSE
-                         OORANGEIND = 1
+                         OORANGEIND = .TRUE.
                       ENDIF
                    ENDDO
-                ELSEIF(OORANGEIND.EQ.0) THEN
+                 ELSEIF(.NOT.OORANGEIND) THEN
                    DO NZIND=1_8,NZ_loc
                       IR = IRN_loc(NZIND)
                       IC = JCN_loc(NZIND)
                       ELM = abs(A_loc(NZIND))*SCA(IR)*SCA(IC)
-                      IF(WRKRC(ITDRPTR-1+IR)<ELM) THEN
-                         WRKRC(ITDRPTR-1+IR)= ELM
-                      ENDIF
-                      IF(WRKRC(ITDRPTR-1+IC)<ELM) THEN
-                         WRKRC(ITDRPTR-1+IC)= ELM
+                      IF (WRKRC(IR)<ELM) WRKRC(IR)= ELM
+                      IF (WRKRC(IC)<ELM) WRKRC(IC)= ELM
+                   ENDDO
+                 ENDIF                      
+               ELSE
+                IF((ITER.EQ.1).OR.(OORANGEIND)) THEN
+!$OMP   PARALLEL DO PRIVATE(NZIND,IR,IC,ELM) 
+!$OMP&  SCHEDULE(STATIC,CHUNK_NZ)
+!$OMP&  IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
+!$OMP&  REDUCTION(.OR.:OORANGEIND)
+                   DO NZIND=1_8,NZ_loc
+                      IR = IRN_loc(NZIND)
+                      IC = JCN_loc(NZIND)
+                      IF((IR.GE.1).AND.(IR.LE.N).AND.
+     &                     (IC.GE.1).AND.(IC.LE.N)) THEN
+                         ELM = abs(A_loc(NZIND))*SCA(IR)*SCA(IC)
+!$OMP                    ATOMIC UPDATE
+                         WRKRC(IR)= max (ELM, WRKRC(IR))
+!$OMP                    END ATOMIC
+C                         IF(WRKRC(ITDRPTR-1_8+int(IR,8))<ELM) THEN
+C                            WRKRC(ITDRPTR-1_8+int(IR,8))= ELM
+C                         ENDIF
+!$OMP                    ATOMIC UPDATE
+                         WRKRC(IC) = max (ELM,WRKRC(IC))
+!$OMP                    END ATOMIC
+C                         IF(WRKRC(ITDRPTR-1_8+int(IC,8))<ELM) THEN
+C                            WRKRC(ITDRPTR-1_8+int(IC,8))= ELM
+C                         ENDIF
+                      ELSE
+                         OORANGEIND = .TRUE.
                       ENDIF
                    ENDDO
+!$OMP   END PARALLEL DO
+                ELSEIF(.NOT.OORANGEIND) THEN
+!$OMP   PARALLEL DO PRIVATE(NZIND,IR,IC,ELM) 
+!$OMP&  SCHEDULE(STATIC,CHUNK_NZ)
+!$OMP&  IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
+                   DO NZIND=1_8,NZ_loc
+                      IR = IRN_loc(NZIND)
+                      IC = JCN_loc(NZIND)
+                      ELM = abs(A_loc(NZIND))*SCA(IR)*SCA(IC)
+!$OMP                 ATOMIC UPDATE
+                      WRKRC(IR)= max (ELM, WRKRC(IR))
+!$OMP                 END ATOMIC
+C                      IF(WRKRC(ITDRPTR-1_8+int(IR,8))<ELM) THEN
+C                         WRKRC(ITDRPTR-1_8+int(IR,8))= ELM
+C                      ENDIF
+!$OMP                 ATOMIC UPDATE
+                      WRKRC(IC) = max (ELM, WRKRC(IC))
+!$OMP                 END ATOMIC
+C                      IF(WRKRC(ITDRPTR-1_8+int(IC,8))<ELM) THEN
+C                         WRKRC(ITDRPTR-1_8+int(IC,8))= ELM
+C                      ENDIF
+                   ENDDO
+!$OMP   END PARALLEL DO
                 ENDIF                      
-                IF(NUMPROCS > 1) THEN
+C}
+               ENDIF
+               IF(NUMPROCS > 1) THEN
+C{
                   CALL SMUMPS_DOCOMMINF(MYID, NUMPROCS,
      &                  WRKRC(ITDRPTR), N, TAG_ITERS+2+ITER, 
      &                  IRSNDRCVNUM,IWRK(IRNGHBPRCS),
@@ -1049,19 +1353,20 @@ C     INF-NORM ITERATION
      &                  WRKRC( OSRRPTR),
      &                  IWRK(ISTATUS),IWRK(REQUESTS),
      &                  COMM)
+CCCC FIXME #if defined(dev_version)
                   IF((EPS .GT. RZERO) .OR. 
      &                 (ITER.EQ.NB1).OR.
      &                 ((ITER.EQ.NB1+NB2+NB3).AND.
      &                 (NB1+NB3.GT.0))) THEN
                      INFERRL = SMUMPS_ERRSCALOC(SCA,  
      &                    WRKRC(ITDRPTR), N,
-     &                    IWRK(IMYRPTR),INUMMYR)                  
+     &                    IWRK(IMYRPTR),INUMMYR, NOMP_MAX) 
                      CALL MPI_ALLREDUCE(INFERRL, INFERRG, 
      &                    1, MPI_REAL,
      &                    MPI_MAX, COMM, IERROR)   
                      IF(INFERRG.LE.EPS) THEN
                         CALL SMUMPS_UPDATESCALE(SCA,  WRKRC(ITDRPTR), N,
-     &                       IWRK(IMYRPTR),INUMMYR)
+     &                       IWRK(IMYRPTR),INUMMYR, NOMP_MAX)
                         IF(ITER .LE. NB1) THEN
                            ITER = NB1+1
                            CYCLE
@@ -1070,17 +1375,20 @@ C     INF-NORM ITERATION
                         ENDIF
                      ENDIF
                   ENDIF
+CCC #endif
+C}
                ELSE
-C     SINGLE PROCESSOR CASE: INF-NORM ERROR COMPUTATION
+C{             SINGLE PROCESSOR CASE: INF-NORM ERROR COMPUTATION
                   IF((EPS .GT. RZERO) .OR. 
      &                 (ITER.EQ.NB1).OR.
      &                 ((ITER.EQ.NB1+NB2+NB3).AND.
      &                 (NB1+NB3.GT.0))) THEN
                      INFERRL = SMUMPS_ERRSCA1(SCA, 
-     &                    WRKRC(ITDRPTR), N)
+     &                    WRKRC(ITDRPTR), N, NOMP_MAX)
                      INFERRG = INFERRL
                      IF(INFERRG.LE.EPS) THEN
-                        CALL SMUMPS_UPSCALE1(SCA,  WRKRC(ITDRPTR), N)
+                        CALL SMUMPS_UPSCALE1(SCA, WRKRC(ITDRPTR), N,
+     &                                       NOMP_MAX)
                         IF(ITER .LE. NB1) THEN
                            ITER = NB1+1
                            CYCLE
@@ -1089,38 +1397,102 @@ C     SINGLE PROCESSOR CASE: INF-NORM ER
                         ENDIF
                      ENDIF 
                   ENDIF
+C}
                ENDIF
+C}
             ELSE
-C     WE HAVE ITER.GT.NB1 AND ITER.LE.NB1+NB2. 
-C     ONE-NORM ITERATION
-               IF((ITER.EQ.1).OR.(OORANGEIND.EQ.1))THEN
+C           ----------------------------------------
+C{          WE HAVE ITER.GT.NB1 AND ITER.LE.NB1+NB2. 
+C           ONE-NORM ITERATION
+C           ----------------------------------------
+             IF (NOMP_MAX.LE.1) THEN
+               IF((ITER.EQ.1).OR.(OORANGEIND))THEN
+                  DO NZIND=1_8,NZ_loc
+                     IR = IRN_loc(NZIND)
+                     IC = JCN_loc(NZIND)
+                     IF((IR.GE.1).AND.(IR.LE.N).AND.
+     &                    (IC.GE.1).AND.(IC.LE.N)) THEN
+                        ELM = abs(A_loc(NZIND))*SCA(IR)*SCA(IC)
+                        WRKRC(IR) = WRKRC(IR) + ELM
+                        IF(IR.NE.IC) THEN
+                           WRKRC(IC) = WRKRC(IC) + ELM
+                        ENDIF
+                     ELSE
+                        OORANGEIND = .TRUE.
+                     ENDIF
+                  ENDDO
+               ELSEIF(.NOT.OORANGEIND)THEN
+                  DO NZIND=1_8,NZ_loc
+                     IR = IRN_loc(NZIND)
+                     IC = JCN_loc(NZIND)
+                     ELM = abs(A_loc(NZIND))*SCA(IR)*SCA(IC)
+                     WRKRC(IR) = WRKRC(IR) + ELM
+                     IF(IR.NE.IC) THEN
+                        WRKRC(IC) = WRKRC(IC) + ELM
+                     ENDIF
+                  ENDDO
+               ENDIF
+             ELSE ! NOMP_MAX>1
+               IF((ITER.EQ.1).OR.(OORANGEIND))THEN
+!$OMP   PARALLEL PRIVATE(IOMP)
+!$OMP&  NUM_THREADS(NOMP_MAX)
+!$OMP&    IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
+                    IOMP  = 1
+!$                  IOMP = OMP_GET_THREAD_NUM() + 1
+!$OMP     DO PRIVATE(NZIND,IR,IC,ELM)
+!$OMP&    SCHEDULE(STATIC,CHUNK_NZ)
+!$OMP&    REDUCTION(.OR.:OORANGEIND)
                   DO NZIND=1_8,NZ_loc
                      IR = IRN_loc(NZIND)
                      IC = JCN_loc(NZIND)
                      IF((IR.GE.1).AND.(IR.LE.N).AND.
      &                    (IC.GE.1).AND.(IC.LE.N)) THEN
                         ELM = abs(A_loc(NZIND))*SCA(IR)*SCA(IC)
-                        WRKRC(ITDRPTR-1+IR) = WRKRC(ITDRPTR-1+IR) + ELM
+                        WRKR_TH(IR,IOMP) = WRKR_TH(IR,IOMP) + ELM
                         IF(IR.NE.IC) THEN
-                           WRKRC(ITDRPTR-1+IC) = 
-     &                          WRKRC(ITDRPTR-1+IC) + ELM
+                          WRKR_TH(IC,IOMP) = WRKR_TH(IC,IOMP) + ELM
                         ENDIF
                      ELSE
-                        OORANGEIND = 1
+                        OORANGEIND = .TRUE.
                      ENDIF
                   ENDDO
-               ELSEIF(OORANGEIND.EQ.0)THEN
+!$OMP     END DO
+!$OMP   END PARALLEL
+               ELSEIF(.NOT.OORANGEIND)THEN
+!$OMP   PARALLEL PRIVATE(IOMP)
+!$OMP&  NUM_THREADS(NOMP_MAX)
+!$OMP&    IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
+                    IOMP  = 1
+!$                  IOMP = OMP_GET_THREAD_NUM() + 1
+!$OMP     DO PRIVATE(NZIND,IR,IC,ELM)
+!$OMP&    SCHEDULE(STATIC,CHUNK_NZ)
                   DO NZIND=1_8,NZ_loc
                      IR = IRN_loc(NZIND)
                      IC = JCN_loc(NZIND)
                      ELM = abs(A_loc(NZIND))*SCA(IR)*SCA(IC)
-                     WRKRC(ITDRPTR-1+IR) = WRKRC(ITDRPTR-1+IR) + ELM
+                     WRKR_TH(IR,IOMP) = WRKR_TH(IR,IOMP) + ELM
                      IF(IR.NE.IC) THEN
-                        WRKRC(ITDRPTR-1+IC) = WRKRC(ITDRPTR-1+IC) + ELM
+                       WRKR_TH(IC,IOMP) = WRKR_TH(IC,IOMP) + ELM
                      ENDIF
                   ENDDO
+!$OMP     END DO
+!$OMP   END PARALLEL
+C}
+               ENDIF
+C
+C              For all i on MYID:
+C              Build WRKRC(i) = Sum       (WRKR_TH(i,IOMP)
+C                              IOMP \in [1:NOMP_MAX]
+               IF(NUMPROCS > 1) THEN
+                 CALL SMUMPS_REDUCE_WRK_MPI (WRKRC, N, WRKR_TH, 
+     &                 NOMP_MAX, 
+     &                 IWRK(IMYRPTR),INUMMYR)
+               ELSE
+                 CALL SMUMPS_REDUCE_WRK (WRKRC, N, WRKR_TH, NOMP_MAX)
                ENDIF
+             ENDIF
                IF(NUMPROCS > 1) THEN
+C{
                   CALL SMUMPS_DOCOMM1N(MYID, NUMPROCS,
      &                 WRKRC(ITDRPTR), N, TAG_ITERS+2+ITER, 
      &                 IRSNDRCVNUM, IWRK(IRNGHBPRCS),
@@ -1136,54 +1508,72 @@ C     ONE-NORM ITERATION
      &                 (NB2.GT.0))) THEN
                      ONEERRL = SMUMPS_ERRSCALOC(SCA,  
      &                    WRKRC(ITDRPTR), N,
-     &                    IWRK(IMYRPTR),INUMMYR) 
+     &                    IWRK(IMYRPTR),INUMMYR, NOMP_MAX) 
 C     mpi allreduce.
                      CALL MPI_ALLREDUCE(ONEERRL, ONEERRG, 
      &                    1, MPI_REAL,
      &                    MPI_MAX, COMM, IERROR)
                      IF(ONEERRG.LE.EPS) THEN
                         CALL SMUMPS_UPDATESCALE(SCA,  WRKRC(ITDRPTR), N,
-     &                       IWRK(IMYRPTR),INUMMYR)
+     &                       IWRK(IMYRPTR),INUMMYR, NOMP_MAX)
                         ITER = NB1+NB2+1
                         CYCLE
                      ENDIF
                   ENDIF
+C}
                ELSE
-C     SINGLE-PROCESSOR CASE: ONE-NORM ERROR COMPUTATION
+C{             SINGLE-PROCESSOR CASE: ONE-NORM ERROR COMPUTATION
                   IF((EPS .GT. RZERO) .OR. 
      &                 ((ITER.EQ.NB1+NB2).AND.
      &                 (NB2.GT.0))) THEN
                      ONEERRL = SMUMPS_ERRSCA1(SCA, 
-     &                    WRKRC(ITDRPTR), N)
+     &                    WRKRC(ITDRPTR), N, NOMP_MAX)
                      ONEERRG = ONEERRL
                      IF(ONEERRG.LE.EPS) THEN
-                        CALL SMUMPS_UPSCALE1(SCA,  WRKRC(ITDRPTR), N)
+                        CALL SMUMPS_UPSCALE1(SCA, WRKRC(ITDRPTR), N,
+     &                                       NOMP_MAX)
                         ITER = NB1+NB2+1
                         CYCLE
                      ENDIF
                   ENDIF
                ENDIF
+C}
             ENDIF
             IF(NUMPROCS > 1) THEN
-               CALL SMUMPS_UPDATESCALE(SCA,  WRKRC(ITDRPTR), N,
-     &              IWRK(IMYRPTR),INUMMYR)
+               CALL SMUMPS_UPDATESCALE(SCA, WRKRC(ITDRPTR), N,
+     &              IWRK(IMYRPTR),INUMMYR, NOMP_MAX)
             ELSE
-               CALL SMUMPS_UPSCALE1(SCA,  WRKRC(ITDRPTR), N)
+               CALL SMUMPS_UPSCALE1(SCA, WRKRC(ITDRPTR), N, 
+     &                              NOMP_MAX)
             ENDIF     
             ITER = ITER + 1
+C}
          ENDDO
          ONENORMERR = ONEERRG 
          INFNORMERR = INFERRG 
          IF(NUMPROCS > 1) THEN
+C{
             CALL MPI_REDUCE(SCA, WRKRC(1), N, MPI_REAL,
      &           MPI_MAX, 0, 
      &           COMM, IERROR)
             IF(MYID.EQ.0) THEN
+              IF (NOMP_MAX.LE.0) THEN
+               DO I=1, N
+                  SCA(I) = WRKRC(I)
+               ENDDO
+              ELSE
+!$OMP       PARALLEL DO PRIVATE(I)
+!$OMP&      SCHEDULE(STATIC,CHUNK)
+!$OMP&      IF ( N > K361 .AND. NOMP .GT. 1)
                DO I=1, N
                   SCA(I) = WRKRC(I)
                ENDDO
+!$OMP       END PARALLEL DO
+              ENDIF
             ENDIF
+C}
          ENDIF
+C}
       ENDIF
       RETURN
       END SUBROUTINE SMUMPS_SIMSCALEABSSYM
diff -pruN 5.6.2-2.1/src/sfac_scalings_simScale_util.F 5.7.1-1/src/sfac_scalings_simScale_util.F
--- 5.6.2-2.1/src/sfac_scalings_simScale_util.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/sfac_scalings_simScale_util.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -14,19 +14,23 @@ C
       SUBROUTINE SMUMPS_CREATEPARTVEC(MYID, NUMPROCS, COMM,
      & IRN_loc, JCN_loc, NZ_loc,
      & IPARTVEC, ISZ, OSZ,
-     & IWRK, IWSZ)
+     & IWRK, IWSZ, INUMMY, NOMP_MAX )
+!$    USE OMP_LIB
 C
       IMPLICIT NONE
       EXTERNAL SMUMPS_BUREDUCE
-      INTEGER, INTENT(IN)    :: MYID, NUMPROCS, COMM
+      INTEGER, INTENT(IN)    :: MYID, NUMPROCS, COMM, NOMP_MAX
       INTEGER(8), INTENT(IN) :: NZ_loc 
-      INTEGER, INTENT(IN)    :: IWSZ
+      INTEGER(8), INTENT(IN) :: IWSZ
       INTEGER, INTENT(IN)    :: ISZ, OSZ
       INTEGER, INTENT(IN)    :: IRN_loc(NZ_loc), JCN_loc(NZ_loc)
 C  OUTPUT
 C     IPARTVEC(I) = proc number with largest number of entries 
 C                in row/col I
+C     INUMMY = number of local rows/columns with
+C              at least one local entry (NUMPROCS .NE. 1 only)
       INTEGER, INTENT(OUT) :: IPARTVEC(ISZ)
+      INTEGER, INTENT(OUT) :: INUMMY
 C
 C  INTERNAL WORKING ARRAY
 C     IWRK (1:2*ISZ) is initialized to couples (MYID, Nb of entries
@@ -46,42 +50,87 @@ C     LOCAL VARS
       INTEGER(8) :: I8
       INTEGER OP, IERROR
       INTEGER IR, IC
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
 C
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP  = omp_get_max_threads()
+!$     CHUNK= max(K361/2, (ISZ+NOMP-1) / NOMP )
+!$    ENDIF
+C
+      INUMMY = 0
       IF(NUMPROCS.NE.1) THEN
 C     CHECK done outsize
 C     IF(IWSZ < 4*ISZ) THEN
 C     CHECK ENDS
          CALL MPI_OP_CREATE(SMUMPS_BUREDUCE, .TRUE., OP, IERROR)
 C     PERFORM THE REDUCTION
-#if defined(WORKAROUNDINTELILP64MPI2INTEGER)
-        CALL SMUMPS_IBUINIT(IWRK, 4*ISZ, int(ISZ,4))
-#else
-        CALL SMUMPS_IBUINIT(IWRK, 4*ISZ, ISZ)
-#endif
 C     WE FIRST ZERO OUT  
+       IF (NOMP_MAX.LE.0) THEN
+         DO I=1,ISZ
+            IWRK(2_8*int(I,8)-1_8) = 0
+            IWRK(2_8*int(I,8))     = MYID
+         ENDDO
+       ELSE
+!$OMP   PARALLEL DO PRIVATE(I) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1.AND.ISZ > K361 )
          DO I=1,ISZ
-            IWRK(2*I-1) = 0
-            IWRK(2*I) = MYID
+            IWRK(2_8*int(I,8)-1_8) = 0
+            IWRK(2_8*int(I,8))     = MYID
          ENDDO
+!$OMP   END PARALLEL DO
+       ENDIF
          DO I8=1_8,NZ_loc
             IR = IRN_loc(I8)
             IC = JCN_loc(I8)
             IF((IR.GE.1).AND.(IR.LE.ISZ).AND.
      &           (IC.GE.1).AND.(IC.LE.OSZ)) THEN
-               IWRK(2*IR-1) = IWRK(2*IR-1) + 1
+               IWRK(2_8*int(IR,8)-1_8) = IWRK(2_8*int(IR,8)-1_8) + 1
             ENDIF
          ENDDO
-         CALL MPI_ALLREDUCE(IWRK(1), IWRK(1+2*ISZ), ISZ,
+         CALL MUMPS_BIGALLREDUCE(.FALSE., IWRK(1),
+     &        IWRK(1_8+2_8*int(ISZ,8)), ISZ,
      &        MPI_2INTEGER, OP, COMM, IERROR)      
-         DO I=1,ISZ
-            IPARTVEC(I) = IWRK(2*I+2*ISZ)
-         ENDDO
+C
+        IF (NOMP_MAX.LE.0) THEN
+          DO I=1,ISZ
+             IPARTVEC(I) = IWRK(2_8*int(I,8)+2_8*int(ISZ,8))
+C            Compute INUMMY directly
+             IF ( IPARTVEC(I) .EQ. MYID. OR.
+     &            IWRK(2_8*int(I,8)-1_8) .GT. 0 ) THEN
+               INUMMY=INUMMY+1
+             ENDIF
+          ENDDO
+        ELSE
+!$OMP   PARALLEL DO PRIVATE(I) SCHEDULE(STATIC,CHUNK)
+!$OMP&  IF ( ISZ > K361 .AND. NOMP .GT. 1)
+!$OMP&  REDUCTION(+:INUMMY)
+          DO I=1,ISZ
+             IPARTVEC(I) = IWRK(2_8*int(I,8)+2_8*int(ISZ,8))
+C            Compute INUMMY directly
+             IF ( IPARTVEC(I) .EQ. MYID. OR.
+     &            IWRK(2_8*int(I,8)-1_8) .GT. 0 ) THEN
+               INUMMY=INUMMY+1
+             ENDIF
+          ENDDO
+!$OMP   END PARALLEL DO
+        ENDIF
 C     FREE THE OPERATOR
          CALL MPI_OP_FREE(OP, IERROR)
       ELSE
-         DO I=1,ISZ
-            IPARTVEC(I) = 0
-         ENDDO
+        IF (NOMP_MAX.LE.0) THEN
+          DO I=1,ISZ
+             IPARTVEC(I) = 0
+          ENDDO
+        ELSE
+!$OMP    PARALLEL DO PRIVATE(I) SCHEDULE(STATIC,CHUNK)
+!$OMP&   IF ( ISZ > K361 .AND. NOMP .GT. 1)
+          DO I=1,ISZ
+             IPARTVEC(I) = 0
+          ENDDO
+!$OMP    END PARALLEL DO
+       ENDIF
       ENDIF
       RETURN
       END SUBROUTINE SMUMPS_CREATEPARTVEC
@@ -89,94 +138,17 @@ C
 C     SEPARATOR: Another function begins
 C
 C 
-      SUBROUTINE SMUMPS_FINDNUMMYROWCOL(MYID, NUMPROCS, COMM,
-     &     IRN_loc, JCN_loc, NZ_loc,
-     &     ROWPARTVEC, COLPARTVEC, M, N,
-     &     INUMMYR,
-     &     INUMMYC,     
-     &     IWRK, IWSZ)
-      IMPLICIT NONE
-      INTEGER(8), INTENT(IN) :: NZ_loc
-      INTEGER, INTENT(IN) :: MYID, NUMPROCS, M, N, IWSZ
-      INTEGER, INTENT(IN) :: IRN_loc(NZ_loc), JCN_loc(NZ_loc)
-C     [ROW/COL]PARTVEC(I) holds proc number with largest number of entries 
-C                in row/col I
-      INTEGER, INTENT(IN) :: ROWPARTVEC(M)
-      INTEGER, INTENT(IN) :: COLPARTVEC(N)
-      INTEGER, INTENT(IN) :: COMM
-C
-C  OUTPUT PARAMETERS
-C     INUMMYR < M and INUMMYC < N  (CPA or <= ??)
-C     INUMMYR holds the number of rows allocated to me 
-C             or non empty on my proc
-C     INUMMYC idem with columns
-      INTEGER INUMMYR, INUMMYC
-C
-C  INTERNAL working array
-      INTEGER IWRK(IWSZ)
-C
-C   Local variables
-      INTEGER I, IR, IC
-      INTEGER(8) ::  I8
-C check done outsize     
-C     IF(IWSZ < M) THEN ERROR
-C     IF(IWSZ < N) THEN ERROR
-      INUMMYR = 0
-      INUMMYC = 0
-C     MARK MY ROWS. FIRST COUNT,
-C          IF DYNAMIC MEMORY ALLOCATIOn WILL USED
-C     INUMMYR first counts number of rows affected to me
-C             (that will be centralized on MYID)
-      DO I=1,M
-         IWRK(I) = 0
-         IF(ROWPARTVEC(I).EQ.MYID) THEN
-            IWRK(I)=1
-            INUMMYR = INUMMYR + 1
-         ENDIF
-      ENDDO
-      DO I8=1_8,NZ_loc
-         IR = IRN_loc(I8)
-         IC = JCN_loc(I8)
-         IF((IR.GE.1).AND.(IR.LE.M).AND.
-     &        ((IC.GE.1).AND.(IC.LE.N)) ) THEN
-            IF(IWRK(IR) .EQ. 0) THEN
-               IWRK(IR)= 1
-               INUMMYR = INUMMYR + 1
-            ENDIF
-         ENDIF
-      ENDDO
-C     DO THE SMAME THING FOR COLS
-      DO I=1,N
-         IWRK(I) = 0
-         IF(COLPARTVEC(I).EQ.MYID) THEN
-            IWRK(I)= 1
-            INUMMYC = INUMMYC + 1
-         ENDIF
-      ENDDO
-      DO I8=1_8,NZ_loc
-         IC = JCN_loc(I8)
-         IR = IRN_loc(I8)
-         IF((IR.GE.1).AND.(IR.LE.M).AND.
-     &        ((IC.GE.1).AND.(IC.LE.N)) ) THEN
-            IF(IWRK(IC) .EQ. 0) THEN
-               IWRK(IC)= 1
-               INUMMYC = INUMMYC + 1
-            ENDIF
-         ENDIF
-      ENDDO
-C
-      RETURN
-      END SUBROUTINE SMUMPS_FINDNUMMYROWCOL
       SUBROUTINE SMUMPS_FILLMYROWCOLINDICES(MYID, NUMPROCS,COMM,    
      &     IRN_loc, JCN_loc, NZ_loc,
      &     ROWPARTVEC, COLPARTVEC, M, N,
      &     MYROWINDICES, INUMMYR,
      &     MYCOLINDICES, INUMMYC,     
-     &     IWRK, IWSZ  )
+     &     IWRK, IWSZ, NOMP_MAX  )
+!$    USE OMP_LIB
       IMPLICIT NONE
-      INTEGER(8) :: NZ_loc
-      INTEGER MYID, NUMPROCS, M, N
-      INTEGER INUMMYR, INUMMYC, IWSZ
+      INTEGER(8) :: NZ_loc, IWSZ
+      INTEGER MYID, NUMPROCS, M, N, NOMP_MAX
+      INTEGER INUMMYR, INUMMYC
       INTEGER IRN_loc(NZ_loc), JCN_loc(NZ_loc)
       INTEGER ROWPARTVEC(M)
       INTEGER COLPARTVEC(N)
@@ -188,11 +160,32 @@ C
       INTEGER I, IR, IC, ITMP
       INTEGER(8) :: I8
 C      
+      INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP=omp_get_max_threads()
+C      note that M=N
+!$     CHUNK= max(K361/2, (M+NOMP-1) / NOMP )
+!$    ENDIF
+C      
 C     MARK MY ROWS. 
-      DO I=1,M
-         IWRK(I) = 0
-         IF(ROWPARTVEC(I).EQ.MYID) IWRK(I)=1
-      ENDDO
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,M
+           IWRK(I) = 0
+           IF(ROWPARTVEC(I).EQ.MYID) IWRK(I)=1
+        ENDDO
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I) 
+!$OMP&  SCHEDULE(STATIC,CHUNK)
+!$OMP&  IF ( M > K361 .AND. NOMP .GT. 1)
+        DO I=1,M
+           IWRK(I) = 0
+           IF(ROWPARTVEC(I).EQ.MYID) IWRK(I)=1
+        ENDDO
+!$OMP END PARALLEL DO
+      ENDIF
+CTEMP !$OMP  PARALLEL DO PRIVATE(I8,IR,IC) SCHEDULE(STATIC,CHUNK)
+CTEMP !$OMP& IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
       DO I8=1,NZ_loc
          IR = IRN_loc(I8)         
          IC = JCN_loc(I8)
@@ -201,6 +194,7 @@ C     MARK MY ROWS.
             IF(IWRK(IR) .EQ. 0) IWRK(IR)= 1
          ENDIF
       ENDDO
+CTEMP !$OMP END PARALLEL DO
 C     PUT MY ROWS INTO MYROWINDICES
       ITMP = 1
       DO I=1,M
@@ -212,10 +206,24 @@ C     PUT MY ROWS INTO MYROWINDICES
 C
 C
 C     DO THE SMAME THING FOR COLS
-      DO I=1,N
-         IWRK(I) = 0
-         IF(COLPARTVEC(I).EQ.MYID) IWRK(I)= 1
-      ENDDO
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,N
+           IWRK(I) = 0
+           IF(COLPARTVEC(I).EQ.MYID) IWRK(I)= 1
+        ENDDO
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I) 
+!$OMP&  SCHEDULE(STATIC,CHUNK)
+!$OMP&  IF ( N > K361 .AND. NOMP .GT. 1)
+        DO I=1,N
+           IWRK(I) = 0
+           IF(COLPARTVEC(I).EQ.MYID) IWRK(I)= 1
+        ENDDO
+!$OMP END PARALLEL DO
+      ENDIF
+C
+CTEMP !$OMP  PARALLEL DO PRIVATE(I8,IR,IC) SCHEDULE(STATIC,CHUNK)
+CTEMP !$OMP& IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
       DO I8=1,NZ_loc
          IR = IRN_loc(I8)         
          IC = JCN_loc(I8)
@@ -224,6 +232,7 @@ C     DO THE SMAME THING FOR COLS
             IF(IWRK(IC) .EQ. 0) IWRK(IC)= 1
          ENDIF
       ENDDO
+CTEMP !$OMP END PARALLEL DO
 C     PUT MY ROWS INTO MYROWINDICES
       ITMP = 1
       DO I=1,N
@@ -305,11 +314,12 @@ C
 C     SEPARATOR: Another function begins
 C
       REAL FUNCTION SMUMPS_ERRSCALOC(D, TMPD, DSZ,
-     &     INDX, INDXSZ)
+     &     INDX, INDXSZ, NOMP_MAX)
+!$    USE OMP_LIB
 C     THE VAR D IS NOT USED IN COMPUTATIONS.
 C     IT IS THERE FOR READIBLITY OF THE *simScaleAbs.F
       IMPLICIT NONE 
-      INTEGER DSZ, INDXSZ
+      INTEGER, INTENT(IN):: DSZ, INDXSZ, NOMP_MAX
       REAL D(DSZ)
       REAL TMPD(DSZ)
       INTEGER INDX(INDXSZ)
@@ -319,19 +329,40 @@ C     LOCAL VARS
       INTEGER I, IIND
       REAL ERRMAX
       INTRINSIC abs
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
       ERRMAX = -RONE
-      DO I=1,INDXSZ
-         IIND = INDX(I)
-         IF(abs(RONE-TMPD(IIND)).GT.ERRMAX) THEN
-            ERRMAX = abs(RONE-TMPD(IIND))
-         ENDIF
-      ENDDO           
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP  = OMP_GET_MAX_THREADS()
+!$     CHUNK= max(K361/2, (INDXSZ+NOMP-1) / NOMP )
+!$    ENDIF
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,INDXSZ
+           IIND = INDX(I)
+           IF(abs(RONE-TMPD(IIND)).GT.ERRMAX) THEN
+              ERRMAX = abs(RONE-TMPD(IIND))
+           ENDIF
+        ENDDO           
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I,IIND) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1 .AND. INDXSZ > K361 )
+!$OMP&  REDUCTION(max:ERRMAX)
+        DO I=1,INDXSZ
+           IIND = INDX(I)
+           IF(abs(RONE-TMPD(IIND)).GT.ERRMAX) THEN
+              ERRMAX = abs(RONE-TMPD(IIND))
+           ENDIF
+        ENDDO           
+!$OMP   END PARALLEL DO
+      ENDIF
       SMUMPS_ERRSCALOC = ERRMAX
       RETURN
       END FUNCTION SMUMPS_ERRSCALOC
-      REAL FUNCTION SMUMPS_ERRSCA1(D, TMPD, DSZ)
+      REAL FUNCTION SMUMPS_ERRSCA1(D, TMPD, DSZ, NOMP_MAX)
+!$    USE OMP_LIB
       IMPLICIT NONE 
-      INTEGER DSZ
+      INTEGER, INTENT(IN):: DSZ, NOMP_MAX
       REAL D(DSZ)
       REAL TMPD(DSZ)
 C     LOCAL VARS
@@ -340,12 +371,31 @@ C     LOCAL VARS
       INTEGER I
       REAL ERRMAX1
       INTRINSIC abs
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
       ERRMAX1 = -RONE
-      DO I=1,DSZ
-         IF(abs(RONE-TMPD(I)).GT.ERRMAX1) THEN
-            ERRMAX1 = abs(RONE-TMPD(I))
-         ENDIF
-      ENDDO
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP  = OMP_GET_MAX_THREADS()
+!$     CHUNK= max(K361/2, (DSZ+NOMP-1) / NOMP )
+!$    ENDIF
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,DSZ
+           IF(abs(RONE-TMPD(I)).GT.ERRMAX1) THEN
+              ERRMAX1 = abs(RONE-TMPD(I))
+           ENDIF
+        ENDDO
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1.AND.DSZ > K361 )
+!$OMP&  REDUCTION(max:ERRMAX1)
+        DO I=1,DSZ
+           IF(abs(RONE-TMPD(I)).GT.ERRMAX1) THEN
+              ERRMAX1 = abs(RONE-TMPD(I))
+           ENDIF
+        ENDDO
+!$OMP   END PARALLEL DO
+      ENDIF
       SMUMPS_ERRSCA1 = ERRMAX1
       RETURN
       END FUNCTION SMUMPS_ERRSCA1
@@ -353,9 +403,10 @@ C
 C     SEPARATOR: Another function begins
 C
       SUBROUTINE SMUMPS_UPDATESCALE(D,  TMPD, DSZ,
-     &        INDX, INDXSZ)
+     &        INDX, INDXSZ, NOMP_MAX)
+!$    USE OMP_LIB
       IMPLICIT NONE
-      INTEGER DSZ, INDXSZ
+      INTEGER, INTENT(in) :: DSZ, INDXSZ, NOMP_MAX
       REAL D(DSZ)
       REAL TMPD(DSZ)
       INTEGER INDX(INDXSZ)
@@ -364,15 +415,34 @@ C     LOCAL VARS
       INTEGER I, IIND
       REAL RZERO
       PARAMETER(RZERO=0.0E0)
-      DO I=1,INDXSZ
-         IIND = INDX(I)
-         IF (TMPD(IIND).NE.RZERO) D(IIND) = D(IIND)/sqrt(TMPD(IIND))
-      ENDDO
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP  = OMP_GET_MAX_THREADS()
+!$     CHUNK= max(K361/2, (INDXSZ+NOMP-1) / NOMP )
+!$    ENDIF
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,INDXSZ
+           IIND = INDX(I)
+           IF (TMPD(IIND).NE.RZERO) D(IIND)=D(IIND)/sqrt(TMPD(IIND))
+        ENDDO
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I,IIND) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1.AND.  INDXSZ> K361 )
+        DO I=1,INDXSZ
+           IIND = INDX(I)
+           IF (TMPD(IIND).NE.RZERO) D(IIND)=D(IIND)/sqrt(TMPD(IIND))
+        ENDDO
+!$OMP   END PARALLEL DO
+      ENDIF
       RETURN
       END SUBROUTINE SMUMPS_UPDATESCALE
-      SUBROUTINE SMUMPS_UPSCALE1(D,  TMPD, DSZ)
+C
+      SUBROUTINE SMUMPS_UPSCALE1(D,  TMPD, DSZ, NOMP_MAX)
+!$    USE OMP_LIB
       IMPLICIT NONE
-      INTEGER DSZ
+      INTEGER, INTENT(IN):: DSZ, NOMP_MAX
       REAL D(DSZ)
       REAL TMPD(DSZ)
       INTRINSIC sqrt
@@ -380,74 +450,186 @@ C     LOCAL VARS
       INTEGER I
       REAL RZERO
       PARAMETER(RZERO=0.0E0)
-      DO I=1,DSZ
-         IF (TMPD(I) .NE. RZERO) D(I) = D(I)/sqrt(TMPD(I))
-      ENDDO
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
+!$    IF (NOMP_MAX.GT.0) THEN
+!$      NOMP  = OMP_GET_MAX_THREADS()
+!$      CHUNK= max(K361/2, (DSZ+NOMP-1) / NOMP )
+!$    ENDIF
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,DSZ
+           IF (TMPD(I) .NE. RZERO) D(I) = D(I)/sqrt(TMPD(I))
+        ENDDO
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1.AND.  DSZ> K361 )
+        DO I=1,DSZ
+           IF (TMPD(I) .NE. RZERO) D(I) = D(I)/sqrt(TMPD(I))
+        ENDDO
+!$OMP   END PARALLEL DO
+      ENDIF
       RETURN
       END SUBROUTINE SMUMPS_UPSCALE1
 C
 C     SEPARATOR: Another function begins
 C
-      SUBROUTINE SMUMPS_INITREALLST(D, DSZ, INDX, INDXSZ, VAL)
+      SUBROUTINE SMUMPS_INITREALLST(D, DSZ, INDX, INDXSZ, VAL,
+     &                              NOMP_MAX)
+!$    USE OMP_LIB
       IMPLICIT NONE
-      INTEGER DSZ, INDXSZ
+      INTEGER, INTENT(IN):: DSZ, INDXSZ, NOMP_MAX
       REAL D(DSZ)
       INTEGER INDX(INDXSZ)
       REAL VAL
 C     LOCAL VARS
       INTEGER I, IIND
-      DO I=1,INDXSZ
-         IIND = INDX(I)
-         D(IIND) = VAL
-      ENDDO
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP  = OMP_GET_MAX_THREADS()
+!$     CHUNK= max(K361/2, (INDXSZ+NOMP-1) / NOMP )
+!$    ENDIF
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,INDXSZ
+           IIND = INDX(I)
+           D(IIND) = VAL
+        ENDDO
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I,IIND) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1.AND.  INDXSZ > K361 )
+        DO I=1,INDXSZ
+           IIND = INDX(I)
+           D(IIND) = VAL
+        ENDDO
+!$OMP   END PARALLEL DO
+      ENDIF
       RETURN
       END SUBROUTINE SMUMPS_INITREALLST
 C
 C     SEPARATOR: Another function begins
 C
-      SUBROUTINE SMUMPS_INVLIST(D, DSZ, INDX, INDXSZ)
-      IMPLICIT NONE
-      INTEGER DSZ, INDXSZ
-      REAL D(DSZ)
-      INTEGER INDX(INDXSZ)
-C     LOCALS
-      INTEGER I, IIND
-      DO I=1,INDXSZ
-         IIND  = INDX(I)
-         D(IIND) = 1.0E0/D(IIND)
-      ENDDO
-      RETURN
-      END SUBROUTINE SMUMPS_INVLIST
 C
 C     SEPARATOR: Another function begins
 C
-      SUBROUTINE SMUMPS_INITREAL(D, DSZ, VAL)
+      SUBROUTINE SMUMPS_INITREAL(D, DSZ, VAL, NOMP_MAX)
+!$    USE OMP_LIB
       IMPLICIT NONE
-      INTEGER DSZ
+      INTEGER, INTENT(IN):: DSZ, NOMP_MAX
       REAL D(DSZ)
       REAL VAL
 C     LOCAL VARS
       INTEGER I
-      DO I=1,DSZ
-         D(I) = VAL
-      ENDDO
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP  = omp_get_max_threads()
+!$     CHUNK= max(K361/2, (DSZ+NOMP-1) / NOMP )
+!$    ENDIF
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,DSZ
+           D(I) = VAL
+        ENDDO
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1.AND.DSZ > K361 )
+        DO I=1,DSZ
+           D(I) = VAL
+        ENDDO
+!$OMP   END PARALLEL DO
+      ENDIF
       RETURN
       END SUBROUTINE SMUMPS_INITREAL
 C
 C     SEPARATOR: Another function begins
 C
-      SUBROUTINE SMUMPS_ZEROOUT(TMPD, TMPSZ, INDX, INDXSZ)
+      SUBROUTINE SMUMPS_REDUCE_WRK(WRK, N, WRK_TH, NOMP_MAX)
+C     Called only when NOMP_MAX>0
+!$    USE OMP_LIB
       IMPLICIT NONE
-      INTEGER TMPSZ,INDXSZ 
-      REAL TMPD(TMPSZ)
+      INTEGER N,NOMP_MAX
+      REAL WRK(N), WRK_TH(N,NOMP_MAX)
+C     LOCAL VAR
+      INTEGER I, IOMP
+      REAL DZERO
+      PARAMETER(DZERO=0.0E0)
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
+!$    NOMP  = OMP_GET_MAX_THREADS()
+!$    CHUNK= max(K361/2, (N+NOMP-1) / NOMP )
+!$OMP   PARALLEL DO PRIVATE(I,IOMP) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1.AND.  N > K361 )
+      DO I=1,N
+         WRK(I) = DZERO
+         DO IOMP=1,NOMP_MAX
+           WRK(I) = WRK_TH(I,IOMP) +  WRK(I)
+         ENDDO
+      ENDDO      
+!$OMP END PARALLEL DO
+      RETURN
+      END SUBROUTINE SMUMPS_REDUCE_WRK
+      SUBROUTINE SMUMPS_REDUCE_WRK_MPI(WRK, N, WRK_TH, NOMP_MAX, 
+     &           INDX, INDXSZ)
+C     Called only when NOMP_MAX>0
+!$    USE OMP_LIB
+      IMPLICIT NONE
+      INTEGER N,NOMP_MAX,INDXSZ 
+      REAL WRK(N), WRK_TH(N,NOMP_MAX)
       INTEGER INDX(INDXSZ)
 C     LOCAL VAR
-      INTEGER I
+      INTEGER I, J, IOMP
       REAL DZERO
       PARAMETER(DZERO=0.0E0)
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
+!$      NOMP  = OMP_GET_MAX_THREADS()
+!$      CHUNK= max(K361/2, (INDXSZ+NOMP-1) / NOMP )
+!$OMP   PARALLEL DO PRIVATE(I,J,IOMP) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1.AND.  INDXSZ > K361 )
       DO I=1,INDXSZ
-         TMPD(INDX(I)) = DZERO
+         J = INDX(I)
+         WRK(J) = DZERO
+         DO IOMP=1,NOMP_MAX
+           WRK(J) = WRK_TH(J,IOMP) + WRK(J)
+         ENDDO
       ENDDO      
+!$OMP END PARALLEL DO
+      RETURN
+      END SUBROUTINE SMUMPS_REDUCE_WRK_MPI
+      SUBROUTINE SMUMPS_ZEROOUT(TMPD, TMPSZ, INDX, INDXSZ, 
+     &                          NOMP_MAX)
+!$    USE OMP_LIB
+      IMPLICIT NONE
+      INTEGER, INTENT(IN):: TMPSZ,INDXSZ, NOMP_MAX
+      REAL TMPD(TMPSZ)
+      INTEGER INDX(INDXSZ)
+C     LOCAL VAR
+      INTEGER I
+      REAL DZERO
+      PARAMETER(DZERO=0.0E0)
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP  = OMP_GET_MAX_THREADS()
+!$     CHUNK= max(K361/2, (INDXSZ+NOMP-1) / NOMP )
+!$    ENDIF
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,INDXSZ
+           TMPD(INDX(I)) = DZERO
+        ENDDO      
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1.AND.  INDXSZ > K361 )
+        DO I=1,INDXSZ
+           TMPD(INDX(I)) = DZERO
+        ENDDO      
+!$OMP END PARALLEL DO
+      ENDIF
       RETURN
       END SUBROUTINE SMUMPS_ZEROOUT
 C
@@ -509,7 +691,7 @@ C     SEPARATOR: Another function begins
 C
       SUBROUTINE SMUMPS_IBUINIT(IW, IWSZ, IVAL)
       IMPLICIT NONE
-      INTEGER IWSZ
+      INTEGER(8) :: IWSZ
 #if defined(WORKAROUNDINTELILP64MPI2INTEGER)
       INTEGER(4) IW(IWSZ)
       INTEGER(4) IVAL
@@ -517,8 +699,8 @@ C
       INTEGER IW(IWSZ)
       INTEGER IVAL
 #endif
-      INTEGER I
-      DO I=1,IWSZ
+      INTEGER(8) :: I
+      DO I=1_8,IWSZ
          IW(I)=IVAL
       ENDDO
       RETURN
@@ -535,10 +717,10 @@ C
      &     IWRK,IWRKSZ, SNDSZ, RCVSZ, COMM)
       IMPLICIT NONE
       INTEGER(8), INTENT(IN) :: NZ_loc
-      INTEGER, INTENT(IN)    :: IWRKSZ
+      INTEGER(8), INTENT(IN) :: IWRKSZ
       INTEGER, INTENT(IN) ::  MYID, NUMPROCS, ISZ, OSZ
       INTEGER, INTENT(IN) ::  COMM
-C     When INDX holds row indices O(ther)INDX hold col indices
+C     When INDX holds row indices O(ther)INDX holds col indices
       INTEGER, INTENT(IN) :: INDX(NZ_loc)
       INTEGER, INTENT(IN) :: OINDX(NZ_loc)
 C     On entry IPARTVEC(I) holds proc number with largest number of entries 
@@ -582,7 +764,7 @@ C      IF(ISZ>IWRKSZ) THEN ERROR
          SNDSZ(I) = 0
          RCVSZ(I) = 0
       ENDDO
-      DO I=1,IWRKSZ
+      DO I=1,max(ISZ,OSZ)
          IWRK(I) = 0
       ENDDO
 C
@@ -595,7 +777,7 @@ C     set SNDSZ
             PIND = IPARTVEC(IIND)
             IF(PIND .NE. MYID) THEN
 C              MYID will send row/col IIND to proc PIND 
-C              (PIND has the largest nb of entries in row/con IIND
+C              (PIND has the largest nb of entries in row/col IIND
                IF(IWRK(IIND).EQ.0) THEN
                   IWRK(IIND) = 1
                   SNDSZ(PIND+1) = SNDSZ(PIND+1)+1
@@ -926,18 +1108,22 @@ C     COMMUNICATE THE UPDATED ONES
       SUBROUTINE SMUMPS_CREATEPARTVECSYM(MYID, NUMPROCS, COMM,
      & IRN_loc, JCN_loc, NZ_loc,
      & IPARTVEC, ISZ,
-     & IWRK, IWSZ)
+     & IWRK, IWSZ, INUMMY)
+!$    USE OMP_LIB
       IMPLICIT NONE
       EXTERNAL SMUMPS_BUREDUCE
       INTEGER, INTENT(IN) :: MYID, NUMPROCS, COMM
-      INTEGER(8)          :: NZ_loc
-      INTEGER, INTENT(IN) :: ISZ, IWSZ
+      INTEGER(8)          :: NZ_loc, IWSZ
+      INTEGER, INTENT(IN) :: ISZ
       INTEGER, INTENT(IN) :: IRN_loc(NZ_loc), JCN_loc(NZ_loc)
 C
 C  OUTPUT
 C     IPARTVEC(I) = proc number with largest number of entries 
 C                in row/col I
+C     INUMMY = number of local rows/columns with
+C              at least one local entry (NUMPROCS .NE. 1 only)
       INTEGER, INTENT(OUT) :: IPARTVEC(ISZ)
+      INTEGER, INTENT(OUT) :: INUMMY
 C
 C  INTERNAL WORKING ARRAY
 C     IWRK (1:2*ISZ) is initialized to couples (MYID, Nb of entries
@@ -957,39 +1143,55 @@ C     LOCAL VARS
       INTEGER(8) :: I8
       INTEGER OP, IERROR
       INTEGER IR, IC
+      INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
 C
+      INUMMY = 0
+!$    NOMP=omp_get_max_threads()
+!$    CHUNK= max(K361/2, (ISZ+NOMP-1) / NOMP )
       IF(NUMPROCS.NE.1) THEN
 C     CHECK done outsize
 C     IF(IWSZ < 2*ISZ) THEN
 C     CHECK ENDS
          CALL MPI_OP_CREATE(SMUMPS_BUREDUCE, .TRUE., OP, IERROR)
 C     PERFORM THE REDUCTION
-#if defined(WORKAROUNDINTELILP64MPI2INTEGER)
-         CALL SMUMPS_IBUINIT(IWRK, 4*ISZ, int(ISZ,4))
-#else
-         CALL SMUMPS_IBUINIT(IWRK, 4*ISZ, ISZ)
-#endif
+!$OMP   PARALLEL DO PRIVATE(I) SCHEDULE(STATIC,CHUNK)
+!$OMP&  IF ( ISZ > K361 .AND. NOMP .GT. 1)
          DO I=1,ISZ
-            IWRK(2*I-1) = 0
-            IWRK(2*I) = MYID
+            IWRK(2_8*int(I,8)-1_8) = 0
+            IWRK(2_8*int(I,8)) = MYID
          ENDDO
+!$OMP   END PARALLEL DO
          DO I8=1_8,NZ_loc
             IR = IRN_loc(I8)
             IC = JCN_loc(I8)
             IF((IR.GE.1).AND.(IR.LE.ISZ).AND.
      &           (IC.GE.1).AND.(IC.LE.ISZ)) THEN
-               IWRK(2*IR-1) = IWRK(2*IR-1) + 1
-               IWRK(2*IC-1) = IWRK(2*IC-1) + 1
+               IWRK(2_8*int(IR,8)-1_8) = IWRK(2_8*int(IR,8)-1_8) + 1
+               IWRK(2_8*int(IC,8)-1_8) = IWRK(2_8*int(IC,8)-1_8) + 1
             ENDIF
          ENDDO
-         CALL MPI_ALLREDUCE(IWRK(1), IWRK(1+2*ISZ), ISZ,
+         CALL MUMPS_BIGALLREDUCE(.FALSE.,
+     &        IWRK(1), IWRK(1_8+2_8*int(ISZ,8)), ISZ,
      &        MPI_2INTEGER, OP, COMM, IERROR)      
+C       CHUNK computed in previous // do
+!$OMP   PARALLEL DO PRIVATE(I) SCHEDULE(STATIC,CHUNK)
+!$OMP&  IF ( ISZ > K361 .AND. NOMP .GT. 1)
+!$OMP&  REDUCTION(+:INUMMY)
          DO I=1,ISZ
-            IPARTVEC(I) = IWRK(2*I+2*ISZ)
+            IPARTVEC(I) = IWRK(2_8*int(I,8)+2_8*int(ISZ,8))
+C           Compute INUMMY directly
+            IF ( IPARTVEC(I) .EQ. MYID. OR.
+     &           IWRK(2_8*int(I,8)-1_8) .GT. 0 ) THEN
+              INUMMY=INUMMY+1
+            ENDIF
          ENDDO
+!$OMP   END PARALLEL DO
 C     FREE THE OPERATOR
          CALL MPI_OP_FREE(OP, IERROR)
       ELSE
+!$OMP   PARALLEL DO PRIVATE(I) SCHEDULE(STATIC,CHUNK)
+!$OMP&  IF ( ISZ > K361 .AND. NOMP .GT. 1)
          DO I=1,ISZ
             IPARTVEC(I) = 0
          ENDDO
@@ -1001,7 +1203,7 @@ C     FREE THE OPERATOR
      & IWRK,IWRKSZ, SNDSZ, RCVSZ, COMM)
       IMPLICIT NONE
       INTEGER(8), INTENT(IN) :: NZ_loc 
-      INTEGER, INTENT(IN)    :: IWRKSZ
+      INTEGER(8), INTENT(IN) :: IWRKSZ
       INTEGER, INTENT(IN)    :: MYID, NUMPROCS, ISZ
       INTEGER, INTENT(IN)    :: INDX(NZ_loc), OINDX(NZ_loc)
       INTEGER, INTENT(IN)    :: IPARTVEC(ISZ)
@@ -1044,7 +1246,7 @@ C      IF(ISZ>IWRKSZ) THEN ERROR
          SNDSZ(I) = 0
          RCVSZ(I) = 0
       ENDDO
-      DO I=1,IWRKSZ
+      DO I=1,ISZ
          IWRK(I) = 0
       ENDDO
 C
@@ -1057,7 +1259,7 @@ C     set SNDSZ
             PIND = IPARTVEC(IIND)
             IF(PIND .NE. MYID) THEN
 C              MYID will send row/col IIND to proc PIND 
-C              (PIND has the largest nb of entries in row/con IIND
+C              (PIND has the largest nb of entries in row/col IIND
                IF(IWRK(IIND).EQ.0) THEN
                   IWRK(IIND) = 1
                   SNDSZ(PIND+1) = SNDSZ(PIND+1)+1
@@ -1092,59 +1294,6 @@ C     number of row/col sent by MYID.
       ENDDO
       RETURN
       END SUBROUTINE SMUMPS_NUMVOLSNDRCVSYM
-      SUBROUTINE SMUMPS_FINDNUMMYROWCOLSYM(MYID, NUMPROCS, COMM,
-     &     IRN_loc, JCN_loc, NZ_loc,
-     &     PARTVEC, N,
-     &     INUMMYR,
-     &     IWRK, IWSZ)
-      IMPLICIT NONE
-      INTEGER MYID, NUMPROCS, N
-      INTEGER(8) :: NZ_loc
-      INTEGER IRN_loc(NZ_loc), JCN_loc(NZ_loc)
-      INTEGER PARTVEC(N)
-      INTEGER INUMMYR
-      INTEGER IWSZ
-      INTEGER IWRK(IWSZ)
-      INTEGER COMM
-C
-      INTEGER I, IR, IC
-      INTEGER(8) :: I8
-C check done outsize     
-C     IF(IWSZ < M) THEN ERROR
-C     IF(IWSZ < N) THEN ERROR
-      INUMMYR = 0
-C     MARK MY ROWS. FIRST COUNT,
-C          IF DYNAMIC MEMORY ALLOCATIOn WILL USED
-      DO I=1,N
-         IWRK(I) = 0
-         IF(PARTVEC(I).EQ.MYID) THEN
-            IWRK(I)=1
-            INUMMYR = INUMMYR + 1
-         ENDIF
-      ENDDO
-      DO I8=1_8,NZ_loc
-         IR = IRN_loc(I8)
-         IC = JCN_loc(I8)
-         IF((IR.GE.1).AND.(IR.LE.N).AND.
-     &        ((IC.GE.1).AND.(IC.LE.N))) THEN
-            IF(IWRK(IR) .EQ. 0) THEN
-               IWRK(IR)= 1
-               INUMMYR = INUMMYR + 1
-            ENDIF
-         ENDIF
-         IF((IR.GE.1).AND.(IR.LE.N).AND.
-     &        ((IC.GE.1).AND.(IC.LE.N))) THEN
-            IF(IWRK(IC).EQ.0) THEN
-               IWRK(IC)= 1
-               INUMMYR = INUMMYR + 1
-            ENDIF
-         ENDIF
-      ENDDO
-C     THE SMAME THING APPLIES FOR COLS
-C     No need to do anything
-C
-      RETURN
-      END SUBROUTINE SMUMPS_FINDNUMMYROWCOLSYM
       INTEGER FUNCTION SMUMPS_CHKCONVGLOSYM(D, N, INDXR, INDXRSZ,
      &     EPS, COMM)
       IMPLICIT NONE
@@ -1169,11 +1318,12 @@ C
      &     IRN_loc, JCN_loc, NZ_loc,
      &     PARTVEC, N,
      &     MYROWINDICES, INUMMYR,
-     &     IWRK, IWSZ  )
+     &     IWRK, IWSZ, NOMP_MAX )
+!$    USE OMP_LIB
       IMPLICIT NONE
-      INTEGER MYID, NUMPROCS, N
-      INTEGER(8) :: NZ_loc
-      INTEGER INUMMYR, IWSZ
+      INTEGER MYID, NUMPROCS, N, NOMP_MAX
+      INTEGER(8) :: NZ_loc, IWSZ
+      INTEGER INUMMYR
       INTEGER IRN_loc(NZ_loc), JCN_loc(NZ_loc)
       INTEGER PARTVEC(N)
       INTEGER MYROWINDICES(INUMMYR)
@@ -1182,21 +1332,36 @@ C
 C
       INTEGER I, IR, IC, ITMP
       INTEGER(8) :: I8
+      INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
+!$    IF (NOMP_MAX.GT.0) THEN
+!$      NOMP=omp_get_max_threads()
+!$      CHUNK= max(K361/2, (N+NOMP-1) / NOMP )
+!$    ENDIF
 C      
 C     MARK MY ROWS. 
-      DO I=1,N
-         IWRK(I) = 0
-         IF(PARTVEC(I).EQ.MYID) IWRK(I)=1
-      ENDDO
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,N
+           IWRK(I) = 0
+           IF(PARTVEC(I).EQ.MYID) IWRK(I)=1
+        ENDDO
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I) 
+!$OMP&  SCHEDULE(STATIC,CHUNK)
+!$OMP&  IF ( N > K361 .AND. NOMP .GT. 1)
+        DO I=1,N
+           IWRK(I) = 0
+           IF(PARTVEC(I).EQ.MYID) IWRK(I)=1
+        ENDDO
+!$OMP END PARALLEL DO
+      ENDIF
+C
       DO I8=1_8,NZ_loc
          IR = IRN_loc(I8)   
          IC = JCN_loc(I8)
          IF((IR.GE.1).AND.(IR.LE.N).AND.
      &        ((IC.GE.1).AND.(IC.LE.N))) THEN
             IF(IWRK(IR) .EQ. 0) IWRK(IR)= 1
-         ENDIF
-         IF((IR.GE.1).AND.(IR.LE.N).AND.
-     &        ((IC.GE.1).AND.(IC.LE.N))) THEN
             IF(IWRK(IC) .EQ.0) IWRK(IC)=1
          ENDIF
       ENDDO
diff -pruN 5.6.2-2.1/src/sfac_sispointers_m.F 5.7.1-1/src/sfac_sispointers_m.F
--- 5.6.2-2.1/src/sfac_sispointers_m.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/sfac_sispointers_m.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/sfac_sol_l0omp_m.F 5.7.1-1/src/sfac_sol_l0omp_m.F
--- 5.6.2-2.1/src/sfac_sol_l0omp_m.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/sfac_sol_l0omp_m.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -15,7 +15,14 @@ C
       PRIVATE
       PUBLIC :: SMUMPS_INIT_L0_OMP_FACTORS
      &        , SMUMPS_FREE_L0_OMP_FACTORS
+#if ! defined(NO_SAVE_RESTORE)
      &        , SMUMPS_SAVE_RESTORE_L0FACARRAY
+#endif
+#if ! defined(NO_SAVE_RESTORE)
+#endif
+#if ! defined(NO_SAVE_RESTORE)
+      INCLUDE 'mumps_save_restore_modes.h'
+#endif
       CONTAINS
       SUBROUTINE SMUMPS_INIT_L0_OMP_FACTORS(id_L0_OMP_FACTORS)
       USE SMUMPS_STRUC_DEF, ONLY : SMUMPS_L0OMPFAC_T
@@ -48,6 +55,7 @@ C
       ENDIF
       RETURN
       END SUBROUTINE SMUMPS_FREE_L0_OMP_FACTORS
+#if ! defined(NO_SAVE_RESTORE)
       SUBROUTINE SMUMPS_SAVE_RESTORE_L0FACARRAY(L0_OMP_FACTORS
      &                 ,unit,MYID,mode
      &                 ,SIZE_GEST,SIZE_VARIABLES
@@ -59,7 +67,7 @@ C
       IMPLICIT NONE
       TYPE (SMUMPS_L0OMPFAC_T), DIMENSION(:), POINTER :: L0_OMP_FACTORS
       INTEGER,intent(IN)::unit,MYID
-      CHARACTER(len=*),intent(IN) :: mode
+      INTEGER,intent(IN) :: mode
       INTEGER,INTENT(OUT) :: SIZE_GEST
       INTEGER(8),intent(OUT) :: SIZE_VARIABLES
       INTEGER,intent(INOUT):: INFO(2)
@@ -79,7 +87,7 @@ C
       SIZE_GEST_L0FAC_ARRAY_j1=0
       SIZE_VARIABLES_L0FAC_ARRAY_j1=0
       NbRecords = 0
-      IF (trim(mode).EQ."memory_save") THEN
+      IF (mode.EQ.memory_save_mode) THEN
         IF (associated(L0_OMP_FACTORS)) THEN
           NbRecords      = 1 
           SIZE_GEST      = SIZE_INT 
@@ -87,7 +95,7 @@ C
           DO j1=1,size(L0_OMP_FACTORS)
             CALL SMUMPS_SAVE_RESTORE_L0FAC(
      &           L0_OMP_FACTORS(j1)
-     &           ,unit,MYID,"memory_save"
+     &           ,unit,MYID,memory_save_mode
      &           ,SIZE_GEST_L0FAC_ARRAY_j1
      &           ,SIZE_VARIABLES_L0FAC_ARRAY_J1
      &           ,SIZE_INT,SIZE_INT8,SIZE_ARITH_DEP
@@ -105,7 +113,7 @@ C
           SIZE_GEST      = 2*SIZE_INT
           SIZE_VARIABLES = 0
         ENDIF
-      ELSEIF (trim(mode).EQ."save") THEN
+      ELSEIF (mode.EQ.save_mode) THEN
         IF (associated(L0_OMP_FACTORS)) THEN
           NbRecords      = 1 
           SIZE_GEST      = SIZE_INT
@@ -120,7 +128,7 @@ C
           DO j1=1,size(L0_OMP_FACTORS)
             CALL SMUMPS_SAVE_RESTORE_L0FAC(
      &           L0_OMP_FACTORS(j1)
-     &           ,unit,MYID,"save"
+     &           ,unit,MYID,save_mode
      &           ,SIZE_GEST_L0FAC_ARRAY_J1
      &           ,SIZE_VARIABLES_L0FAC_ARRAY_J1
      &           ,SIZE_INT,SIZE_INT8,SIZE_ARITH_DEP
@@ -147,7 +155,7 @@ C
             endif
             IF ( INFO(1) .LT. 0 ) GOTO 100
         ENDIF
-      ELSE IF (trim(mode).EQ."restore") THEN
+      ELSE IF (mode.EQ.restore_mode) THEN
         NULLIFY(L0_OMP_FACTORS)
          read(unit,iostat=err) size_array1
          if(err.ne.0) THEN
@@ -181,7 +189,7 @@ C
            DO j1=1,size(L0_OMP_FACTORS)
              CALL SMUMPS_SAVE_RESTORE_L0FAC(
      &            L0_OMP_FACTORS(j1)
-     &            ,unit,MYID,"restore"
+     &            ,unit,MYID,restore_mode
      &            ,SIZE_GEST_L0FAC_ARRAY_J1
      &            ,SIZE_VARIABLES_L0FAC_ARRAY_J1
      &            ,SIZE_INT, SIZE_INT8, SIZE_ARITH_DEP
@@ -196,19 +204,19 @@ C
            ENDDO
          endif
       ENDIF
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          NbSubRecords=int(SIZE_VARIABLES/huge(I4))
          IF(NbSubRecords.GT.0) then
             NbRecords=NbRecords+NbSubRecords
          ENDIF
-      elseif(trim(mode).EQ."save") then
+      elseif(mode.EQ.save_mode) then
          size_written=size_written+SIZE_VARIABLES
      &        +int(SIZE_GEST,kind=8)
 #if defined(MUMPS_NOF2003)
          size_written=size_written
      &        +int(2*SIZE_INT*NbRecords,kind=8)
 #endif
-      elseif(trim(mode).EQ."restore") then
+      elseif(mode.EQ.restore_mode) then
          size_allocated=size_allocated+SIZE_VARIABLES
          size_read=size_read+SIZE_VARIABLES
      &        +int(SIZE_GEST,kind=8)
@@ -217,7 +225,7 @@ C
      &        +int(2*SIZE_INT*NbRecords,kind=8)
 #endif
       endif
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          SIZE_VARIABLES=SIZE_VARIABLES+SIZE_VARIABLES_L0FAC_ARRAY
          SIZE_GEST=SIZE_GEST+SIZE_GEST_L0FAC_ARRAY
 #if defined(MUMPS_NOF2003)
@@ -239,7 +247,7 @@ C
       IMPLICIT NONE
       TYPE (SMUMPS_L0OMPFAC_T) :: L0_OMP_FACTORS_1THREAD
       INTEGER,intent(IN)::unit,MYID
-      CHARACTER(len=*),intent(IN) :: mode
+      INTEGER,intent(IN) :: mode
       INTEGER,INTENT(OUT) :: Local_SIZE_GEST
       INTEGER(8),intent(OUT) :: Local_SIZE_VARIABLES
       INTEGER,intent(INOUT):: INFO(2)
@@ -252,9 +260,9 @@ C
       Local_SIZE_GEST = 0
       Local_SIZE_VARIABLES = 0_8
       Local_NbRecords = Local_NbRecords+1
-      IF (trim(mode) .EQ. "memory_save") THEN
+      IF (mode .EQ. memory_save_mode) THEN
         Local_SIZE_VARIABLES = Local_SIZE_VARIABLES + SIZE_INT8
-      ELSE IF (trim(mode) .EQ. "save") THEN
+      ELSE IF (mode .EQ. save_mode) THEN
         Local_SIZE_VARIABLES = Local_SIZE_VARIABLES + SIZE_INT8
         WRITE(unit,iostat=err) L0_OMP_FACTORS_1THREAD%LA
         IF (err .NE. 0) THEN
@@ -264,7 +272,7 @@ C
           GOTO 100
         ENDIF
         size_written=size_written+SIZE_INT8
-      ELSE IF (trim(mode) .EQ. "restore") THEN
+      ELSE IF (mode .EQ. restore_mode) THEN
         Local_SIZE_VARIABLES = Local_SIZE_VARIABLES + SIZE_INT8
         READ(unit,iostat=err) L0_OMP_FACTORS_1THREAD%LA
         IF (err .NE. 0) THEN
@@ -275,7 +283,7 @@ C
         ENDIF
         size_read=size_read+SIZE_INT8
       ENDIF
-      IF (trim(mode).EQ."memory_save") THEN
+      IF (mode.EQ.memory_save_mode) THEN
         IF (associated(L0_OMP_FACTORS_1THREAD%A)) THEN
           Local_NbRecords = Local_NbRecords + 2
           Local_SIZE_GEST = Local_SIZE_GEST + SIZE_INT8
@@ -286,7 +294,7 @@ C
           Local_SIZE_GEST = Local_SIZE_GEST + SIZE_INT8
           Local_SIZE_VARIABLES = Local_SIZE_VARIABLES + 0
         ENDIF
-      ELSEIF (trim(mode).EQ."save") THEN
+      ELSEIF (mode.EQ.save_mode) THEN
         IF (associated(L0_OMP_FACTORS_1THREAD%A)) THEN
           Local_NbRecords = Local_NbRecords + 2
           write(unit,iostat=err) int(0,8) 
@@ -317,7 +325,7 @@ C
           endif
           size_written=size_written+SIZE_INT8
         ENDIF
-      ELSEIF (trim(mode).EQ."restore") THEN
+      ELSEIF (mode.EQ.restore_mode) THEN
         NULLIFY(L0_OMP_FACTORS_1THREAD%A)
         READ(unit,iostat=err) itmp
         if(err.ne.0) THEN
@@ -356,15 +364,16 @@ C
         ENDIF
       ENDIF
 #if defined(MUMPS_NOF2003)
-      IF (trim(mode).EQ."memory_save") THEN
+      IF (mode.EQ.memory_save_mode) THEN
         Local_SIZE_GEST = Local_SIZE_GEST+2*SIZE_INT*Local_NbRecords
-      ELSE IF (trim(mode).EQ."save") THEN
+      ELSE IF (mode.EQ.save_mode) THEN
         size_written = size_written+2*SIZE_INT*Local_NbRecords
-      ELSE IF (trim(mode).EQ."restore") THEN
+      ELSE IF (mode.EQ.restore_mode) THEN
         size_read = size_read+2*SIZE_INT*Local_NbRecords
       ENDIF
 #endif
   100 CONTINUE
       RETURN
       END SUBROUTINE SMUMPS_SAVE_RESTORE_L0FAC
+#endif
       END MODULE SMUMPS_FACSOL_L0OMP_M
diff -pruN 5.6.2-2.1/src/sfac_sol_pool.F 5.7.1-1/src/sfac_sol_pool.F
--- 5.6.2-2.1/src/sfac_sol_pool.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/sfac_sol_pool.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -177,8 +177,6 @@ C
      &        ND(KEEP(28))
       EXTERNAL MUMPS_INSSARBR, MUMPS_ROOTSSARBR, SMUMPS_POOL_EMPTY
       LOGICAL MUMPS_INSSARBR, MUMPS_ROOTSSARBR, SMUMPS_POOL_EMPTY
-      EXTERNAL MUMPS_PROCNODE
-      INTEGER MUMPS_PROCNODE
       INTEGER NBINSUBTREE, NBTOP, INSUBTREE, INODE_EFF, MYID
       LOGICAL LEFT, ATOMIC_SUBTREE,UPPER,FLAG_MEM,SBTR_FLAG,PROC_FLAG
       LOGICAL FORCE_EXTRACT_TOP_SBTR
@@ -386,8 +384,6 @@ C
       INTEGER INODE,LPOOL,N,MYID,SLAVEF,PROC,MIN_PROC
       INTEGER POOL(LPOOL),KEEP(500),STEP(N),PROCNODE(KEEP(28))
       INTEGER(8) KEEP8(150)
-      INTEGER MUMPS_PROCNODE
-      EXTERNAL MUMPS_PROCNODE
       LOGICAL SBTR,FLAG_SAME_PROC
       INTEGER POS_TO_EXTRACT,NODE_TO_EXTRACT,NBTOP,I,INSUBTREE,
      &     NBINSUBTREE
diff -pruN 5.6.2-2.1/src/sfac_type3_symmetrize.F 5.7.1-1/src/sfac_type3_symmetrize.F
--- 5.6.2-2.1/src/sfac_type3_symmetrize.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/sfac_type3_symmetrize.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/sini_defaults.F 5.7.1-1/src/sini_defaults.F
--- 5.6.2-2.1/src/sini_defaults.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/sini_defaults.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -107,8 +107,9 @@ C     are set by SMUMPSID.  The elements
 C     and INFO provide information on the action of SMUMPS.
 C  
 C  CNTL(1) threshold for partial pivoting
-C     has default value 0.0 when SYM=1 and 0.01 otherwise
-C     Values and less than zero as treated as zero.
+C     has default -1.0 (automatic choice):
+C      0.1 in case of rank-revealing (ICNTL(56)=1,2)
+C      otherwise  0.0 when SYM=1 and 0.01 otherwise.
 C     Values greater than 1.0 are treated as 1.0 for
 C     SYM=1 and as 0.5 for SYM=2
 C     In general, a larger value of CNTL(1) leads to 
@@ -126,6 +127,7 @@ C     Default value is sqrt(macheps).
 C     Values less than zero are treated as sqrt(macheps).
 C
 C  CNTL(3) is used with null pivot row detection (ICNTL(24) .eq. 1)
+C     and/or with Rank-Revealing (RR) option (ICNTL(56)).
 C     Default value is 0.0. 
 C     Let A_{preproc} be the preprocessed matrix to be factored (see
 C       equation in the user's guide).
@@ -134,6 +136,35 @@ C     row/column is smaller than a thres
 C     machine precision and ||.|| be the infinite norm.
 C     The absolute value to detect a null pivot row (when ICNTL(24) .EQ.1) 
 C     is stored in DKEEP(1).
+C     In case of RR, CNTL(3) will define the thresholds for :
+C      
+C       - Postponing pseudo singularities (SEUIL):
+C         The computed threshold value for postponing pivots
+C         is stored in "SEUIL" and then "SEUIL_LDLT_NIV2"
+C         which are identical in current version.
+C
+C       - Defining singularities on root (DKEEP(9))
+C
+C       - Defining null pivot rows if ICNTL(24).EQ.1 (DKEEP(1)) 
+C         in this case DKEEP(1) must be smaller than DKEEP(9)
+C
+C     IF (ICNTL(56).NE.0) THEN 
+C      RR on root is active 
+C      IF  (CNTL3 .LT. ZERO) THEN
+C          DKEEP(9) = abs(CNTL(3))
+C      ELSE IF  (CNTL3 .GT. ZERO) THEN
+C          DKEEP(9) = CNTL3*||A_{preproc}||
+C      ELSE  !  (CNTL(3) .EQ. ZERO) THEN
+C          DKEEP(9) = sqrt(N_h)*MACHEPS*||A_{preproc}||  
+C          where Nh is the number of pivots on the deepest branch
+C          of the elimination tree.
+C      ENDIF
+C      IF (ICNTL(24).EQ.1) THEN
+C       null pivot detection
+C         DKEEP(1) = DKEEP(9)*DKEEP(10)
+C      ENDIF
+C
+C     ELSE (ONLY NULL PIVOT detection is active) 
 C      IF CNTL(3)  > 0 THEN
 C          DKEEP(1) = CNTL(3)  ||A_{preproc}|| 
 C      ELSE IF CNTL(3)  = 0.0 THEN 
@@ -142,6 +173,7 @@ C      ELSE IF CNTL(3)  < 0 THEN
 C          DKEEP(1) = abs(CNTL(3))! this was added for EDF 
 C                                 ! in the context of SOLSTICE project
 C      ENDIF
+C     ENDIF
 C
 C  CNTL(4) must be set to value for static pivoting.
 C     Default value is -1.0
@@ -386,6 +418,9 @@ C               The order of the root no
 C            ENDIF
 C            If ICNTL(13) .EQ. -1 then splitting of the root
 C            is done whatever the nb of procs is. 
+C            Authorizing extra root spliting during analysis might be
+C            interesting to further split the root node (combined for 
+C            example with null pivot detection option ICNTL(24)=1 OR ICNTL(56))
 C             
 C            To summarize:
 C               -1         : root splitting and scalapack on
@@ -646,12 +681,14 @@ C            For all other values, the d
 C            null pivots and static pivots are excluded from the
 C            computation of the determinant.
 C
+#if ! defined(NO_SAVE_RESTORE)
 C   ICNTL(34) Must be set before a call to MUMPS with JOB=-3 in case
 C             the save/restore feature was used and user wants to clean
 C             save/restore files (and possibly OOC files). 
 C             ICTNL(34)=0 => user wants to be able to restore instance later
 C             ICTNL(34)=1 => user will not restore the instance again (clean
 C                            to be done)
+#endif
 C
 C    ICNTL(35) : Block Low-Rank (BLR) functionality, 
 C                need be set before analysis
@@ -696,6 +733,25 @@ C                Between 0 and 1000; oth
 C                corresponds to an estimated compression rate of
 C                ICNTL(39)/1000%.
 C                Default value: 500 (50.0% compression rate).
+C
+C  ICNTL(56) has default value 0 and is only accessed by the host.
+C      During the analysis phase, a positive value prepares the data for
+C       later use of null space functionalities (saved in KEEP(53)).
+C       (the tree is modified to have only one root in analysis)
+C       If ICNTL(56) is negative or zero, null space feature will
+C       be forbidden during the factorization phase.
+C      During the factorization phase, if ICNTL(56) was positive 
+C      (KEEP(53)>0) for analysis, then the values of ICNTL(56) (saved
+C      in KEEP(19)) have the following meaning.
+C          0: No null space analysis,
+C          1: Null space analysis on last root node using SVD,
+C          2: Null space analysis on last root node using QR,
+C
+C       The singular values (ICNTL(56)=1) or the diagonal entries of R
+C       (ICNTL(56)=2) are available in root%SINGULAR_VALUES
+C
+C
+C
 C 
 C   ICNTL(58): strategy for symbolic factorization used
 C              with centralized ordering based on METIS (ICNTL(7)=5)
@@ -781,6 +837,10 @@ C  INFO(18)  On exit to factorization:
 C              Local number of null pivots (ICNTL(24)=1) 
 C              on the local processor even on master. 
 C              (local size of array PIVNUL_LIST).
+C              Note that it also includes null pivots 
+C              that might have been further detected on 
+C              the root if ICNTL(56).NE.0. and root 
+C              processed by MYID
 C
 C  INFO(19) - after analysis: 
 C           Estimated size of the main internal integer workarray IS
@@ -857,7 +917,7 @@ C     for the elimination process on the
 C
 C  RINFOG(3)  Number of floating-point operations
 C     for the elimination process on all processors.
-C
+C  
 C----------------------------------------------------
 C Statistics produced after solve with error analysis
 C----------------------------------------------------
@@ -918,6 +978,25 @@ C
 C  RINFOG(21) -  after factorization: largest pivot in absolute 
 C             value selected during factorization of the preprocessed
 C             matrix A_pre.
+C  
+C  RINFOG(22) - after factorization: 
+C             total number of floating-point operations offloaded to 
+C             the accelerator(s) by all MPI processes (see RINFO(9))
+C
+C  RINFOG(23) - after factorization: average (over all MPI processes) 
+C            time spent in operations offloaded to the accelerators
+C            including communication (see RINFO(10)).
+C
+C  Computed when solve involves exploit sparsity (fwd and/or bwd)
+C  here we only report off diagonal flops)
+C
+#if defined(STAT_ES_SOLVE)
+C  RINFOG(24) - FR FLOPS (off diagonal flops)
+C  RINFOG(25) - FR FLOPS (off diag) with Exploit sparsity 
+C               (possibly with nb_sparse algo used)
+#endif
+C
+C
 C===========================
 C DESCRIPTION OF KEEP8 ARRAY
 C===========================
@@ -925,6 +1004,8 @@ C
 C   KEEP8 is a 64-bit integer array of length 150 that need not
 C   be set by the user
 C
+#if ! defined(NO_SAVE_RESTORE)
+#endif
 C===========================
 C DESCRIPTION OF KEEP ARRAY
 C===========================
@@ -962,11 +1043,8 @@ C     Only options 0, 1, or 2 are availa
 C     -------------------------------------
       IF ( KEEP(50).NE.1 .and. KEEP(50).NE.2 ) KEEP( 50 ) = 0
 C     threshold value for pivoting
-      IF ( KEEP(50) .NE. 1 ) THEN
-        CNTL(1)   = 0.01E0
-      ELSE
-        CNTL(1)   = 0.0E0
-      END IF
+C     Automatic choice depending on (SYM and ICNTL(56))
+      CNTL(1) = -1.0E0
       CNTL(2) = sqrt(epsilon(0.0E0))
       CNTL(3) = 0.0E0
       CNTL(4) = -1.0E0
@@ -1057,6 +1135,14 @@ C     Default BLR compression rate of fa
       ICNTL(38) = 600
 C     Default BLR compression rate of factors (50%)
       ICNTL(39) = 500
+C     L0-thread feature
+#if defined(_OPENMP)
+C     Activate L0OMP
+      ICNTL(48) = 1
+#else
+C     Do not activate L0OMP
+      ICNTL(48) = 0
+#endif
       ICNTL(55) = 0
       ICNTL(56) = 0
       ICNTL(57) = 0
@@ -1082,7 +1168,7 @@ C===================================
         KEEP(6)  = 32
         KEEP(9)  = 700
         KEEP(85) =  300
-        KEEP(62) =  50
+        KEEP(62) =  10
       ELSE
         KEEP(4)  = 24
         KEEP(3)  = 96
@@ -1090,8 +1176,9 @@ C===================================
         KEEP(6)  = 32
         KEEP(9)  = 400
         KEEP(85) = 100
-        KEEP(62) = 50
+        KEEP(62) = 10
       END IF
+        KEEP(11)=200
       KEEP(63) = 60
       KEEP(48) = 5
       CALL SMUMPS_SET_TYPE_SIZES( KEEP(34), KEEP(35),
@@ -1120,36 +1207,24 @@ C     Forcing proportional is ok with st
       KEEP(75) = 1
       KEEP(76) = 2
       KEEP(77) = 30
+      KEEP(78)= -1
       KEEP(79) = 0  ! old splitting
-      IF (NSLAVES.GT.4) THEN
-          KEEP(78)=max(
-     &       int(log(real(NSLAVES))/log(real(2))) - 2 
-     &       , 0         )
-      ENDIF
       KEEP(210) = 2 
       KEEP8(79) = -10_8
       KEEP(80) = 1
       KEEP(81) = 0
-      KEEP(82) = 30
-      KEEP(83) = min(8,NSLAVES/4)
-      KEEP(83) = max(min(4,NSLAVES),max(KEEP(83),1))
+      IF (SYM.EQ.0) THEN
+       KEEP(82)= 15
+      ELSE
+       KEEP(82) = 10
+      ENDIF
+      KEEP(83) = -1
       KEEP(86)=1
       KEEP(87)=0
       KEEP(88)=0
       KEEP(90)=1
-      KEEP(91)=min(8, NSLAVES)
-      KEEP(91) = max(min(4,NSLAVES),min(KEEP(83),KEEP(91)))
-      IF(NSLAVES.LT.48)THEN
-         KEEP(102)=150
-      ELSEIF(NSLAVES.LT.128)THEN
-         KEEP(102)=150
-      ELSEIF(NSLAVES.LT.256)THEN
-         KEEP(102)=200
-      ELSEIF(NSLAVES.LT.512)THEN
-         KEEP(102)=300
-      ELSEIF(NSLAVES.GE.512)THEN
-         KEEP(102)=400
-      ENDIF
+      KEEP(91)= -1
+      KEEP(102)= -1
 #if defined(OLD_OOC_NOPANEL)
       KEEP(99)=0  ! no panel -> synchronous / no buffer
 #else
@@ -1164,6 +1239,8 @@ C     strategy for MUMPS_BLOC2_GET_NSLAV
       KEEP(119)=0
 C     Scaling is enabled by default with the Schur complement option
       KEEP(125)=1
+C     Columns of LMAT handled by block of size KEEP(147)
+      KEEP(147)=20000
 C     More amalgamation of tiny fronts
       KEEP(197)=1
 C     KEEP(199) for MUMPS_PROCNODE, MUMPS_TYPENODE, etc
@@ -1180,6 +1257,9 @@ C     allocate id%S later otherwise.
       KEEP(107)=0
       KEEP(121)=-999999
       KEEP(122)=15
+C     Size of CB for which we want to force BLR compressCB
+C     even if NASS is small.
+      KEEP(123)=10000
        KEEP(141)=1 ! min needed
       KEEP(206)=1 
       KEEP(207) = 1
@@ -1193,7 +1273,11 @@ C     allocate id%S later otherwise.
       KEEP(215)=0
       KEEP(216)=1
       KEEP(218)=250
-      KEEP(219)=1
+      IF (SYM.EQ.2) THEN
+       KEEP(219)=1
+      ELSE
+       KEEP(219)=0
+      ENDIF
       IF (KEEP(50).EQ.2) THEN
         KEEP(227)= max(2,32)
       ELSE
@@ -1211,7 +1295,7 @@ C     allocate id%S later otherwise.
                         ! (default value is 10 set in fac_driver.F)
       DKEEP(24) = 1000.0E0 ! gap should be larger than dkeep(14)
       DKEEP(25) = 10.0E0 ! gap precision
-      DKEEP(22) = 0.2E0 ! to check for slow convergence
+      DKEEP(22) = 0.5E0 ! to check for slow convergence
       KEEP(238)=18
       KEEP(234)= 1
       KEEP(235)=-1
@@ -1219,9 +1303,11 @@ C     allocate id%S later otherwise.
       DKEEP(18)= 1.0E12
       KEEP(242) = -9
       KEEP(243) = -1
+      KEEP(255)=100
+      KEEP(281) = 0
 C     Parallel analysis compatible with analysis by blocks
 C                       and detection out-of-range 
-      KEEP(339)= 6
+      KEEP(339)= 1
       KEEP(249)=1
 !$    KEEP(249) = OMP_GET_MAX_THREADS()
       KEEP(250) = 1
@@ -1239,17 +1325,20 @@ C                       and detection ou
       KEEP(363) = 512
       KEEP(364) = 32768
       KEEP(378) = 1
-C     OMP parallelization of arrowheads
       KEEP(399) = 1
       KEEP(397) = -1
-#if defined(__ve__)
-      KEEP(401) = 1
-#else
-      KEEP(401) = 0
-#endif
       KEEP(402) = 1
       KEEP(405) = 0 ! 1 under L0OMP
       KEEP(406) = 2 
+#if defined(__PGLLVM__)
+C     With aocc version of Classic flang, we want to
+C     avoid an OpenMP bug during L0thread copies by
+C     switching to simpler copy algorithm.
+C     Since we cannot test __aocc__ in Fortran, we rely on the
+C     slower algorithm as soon as __PGLLVM__ is detected, even
+C     if this is "too careful".
+      KEEP(406)=0
+#endif
 C     0.9 equilibration
       KEEP(408) = 90
       KEEP(420) =  4*KEEP(6)   ! if KEEP(6)=32 then 128
@@ -1296,11 +1385,10 @@ C     probably a cache miss on the pivot
       KEEP(490) = 128
       KEEP(491) = 1000
 #if defined(__ve__)
-      KEEP(491)=512
+      KEEP(490)=512
       KEEP(491)=8000
 #endif
       KEEP(492) = 1
-      KEEP(82) = 30
       KEEP(493) = 0
       KEEP(496) = 1
       KEEP(495) = -1
@@ -1320,6 +1408,8 @@ C
          id%KEEP(5)=1
          id%KEEP(6)=2
          id%KEEP(9)=3
+C        KEEP(11) not too small either
+         id%KEEP(11)=3
          id%KEEP(39)=300
          id%KEEP(7) = 3
          id%KEEP(8) = 2
@@ -1332,6 +1422,8 @@ C
          id%KEEP(85)=-4
          id%KEEP(62) = 2  
          id%KEEP(1)  = 1   
+         id%KEEP(123) = 6
+         id%KEEP(147) = 3
          id%KEEP(197)  = 0
          id%KEEP(51) = 2
 !$       id%KEEP(360) = 2
@@ -1346,15 +1438,9 @@ C
          id%ICNTL(27)=-3
          id%KEEP(227)=3
          id%KEEP(30) = 1000
-#if defined(_OPENMP)
-C        Activate L0OMP with test_mumps in case KEEP(72)=1,
-C        but only if compiilation is with OpenMP
-         id%KEEP(401) = 1
-#endif
       ELSE IF (id%KEEP(72)==2) THEN
          id%KEEP(85)=2            ! default is 
          id%KEEP(85)=-10000         ! default is 160 
-         id%KEEP(62) = 10       ! default is 50
          id%KEEP(210) = 1       ! defaults is 0 (automatic)
          id%KEEP8(79) = 160000_8   
          id%KEEP(1) = 2  ! default is 8
diff -pruN 5.6.2-2.1/src/sini_driver.F 5.7.1-1/src/sini_driver.F
--- 5.6.2-2.1/src/sini_driver.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/sini_driver.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -31,6 +31,10 @@ C
       INTEGER MASTER, IERR,PAR_loc,SYM_loc
       PARAMETER( MASTER = 0 )
       INTEGER color
+#if defined(metis) || defined(parmetis)
+      INTEGER I
+#endif
+      INTEGER(8) :: I8
 C     -----------------------------
 C     Initialize MPI related data
 C     -----------------------------
@@ -88,8 +92,10 @@ C     ----------------------------------
       CALL MUMPS_SET_VERSION( id%VERSION_NUMBER )
       id%OOC_TMPDIR="NAME_NOT_INITIALIZED"
       id%OOC_PREFIX="NAME_NOT_INITIALIZED"
+#if ! defined(NO_SAVE_RESTORE)
       id%SAVE_DIR="NAME_NOT_INITIALIZED"
       id%SAVE_PREFIX="NAME_NOT_INITIALIZED"
+#endif
 C     Default value for NRHS is 1
       id%NRHS = 1
 C     Leading dimension will be reset to id%N is SMUMPS_SOL_DRIVER
@@ -118,13 +124,11 @@ C     set to default options
 C     Useful size is 40  
 C     This sets the default values
       CALL METIS_SETDEFAULTOPTIONS(id%METIS_OPTIONS)
-C     This number, 18, corresponds to METIS_OPTIONS_NUMBERING which
-C     tells METIS to use fortran numbering and is found in metis.h
-C     In Metis 5.0.3 and Parmetis 4.0.2, METIS_OPTIONS_NUMBERING 
-C     was METIS_OPTIONS(17). MUMPS doesnot support those versions anymore.
-C     To use them, just change METIS_OPTIONS(18) into METIS_OPTIONS(17)
-C     like that: METIS_OPTIONS(17) = 1
-      id%METIS_OPTIONS(18) = 1
+      CALL MUMPS_METIS_OPTION_NUMBERING(I)
+C     The value of I corresponds to "METIS_OPTION_NUMBERING", which tells
+C     METIS to use Fortran numbering. METIS_OPTION_NUMBERING is defined
+C     in metis.h and accessed through a C wrapper.
+      id%METIS_OPTIONS(I+1) = 1 ! +1 for Fortran indexing
 #endif
 #endif      
 C
@@ -154,6 +158,8 @@ C
       NULLIFY(id%RHS_loc)
       NULLIFY(id%COLSCA)
       NULLIFY(id%ROWSCA)
+      NULLIFY(id%ROWSCA_loc)
+      NULLIFY(id%COLSCA_loc)
       NULLIFY(id%PERM_IN)
       NULLIFY(id%IS)
       NULLIFY(id%STEP)
@@ -198,10 +204,11 @@ C     Info for pruning tree
       NULLIFY(id%MY_FIRST_LEAF)
       NULLIFY(id%MY_NB_LEAF)
       NULLIFY(id%COST_TRAV)
-      NULLIFY(id%RHSCOMP)
-      NULLIFY(id%POSINRHSCOMP_ROW)
-      NULLIFY(id%POSINRHSCOMP_COL)
-      id%POSINRHSCOMP_COL_ALLOC = .FALSE.
+      NULLIFY(id%RHSINTR)
+      id%LD_RHSINTR = 0
+      NULLIFY(id%GLOB2LOC_RHS)
+      NULLIFY(id%GLOB2LOC_SOL)
+      id%GLOB2LOC_SOL_ALLOC = .FALSE.
 C
 C     Out of Core management related data
 C
@@ -215,7 +222,7 @@ C
       NULLIFY(id%LRGROUPS)
       NULLIFY(id%FDM_F_ENCODING)
       NULLIFY(id%BLRARRAY_ENCODING)
-      NULLIFY(id%MPITOOMP_PROCS_MAP)
+      NULLIFY(id%MTKO_PROCS_MAP)
 C     Must be nullified because of routine
 C     SMUMPS_SIZE_IN_STRUCT
       NULLIFY(id%CB_SON_SIZE)
@@ -286,6 +293,14 @@ C
 C
 C     Initializations for Rank detection/null space
 C
+C         -----------------------------
+C         RCOND is a threshold such that:
+C                   A * P = Q * [ R11 R12 ]
+C                               [  0  R22 ]
+C         with R11 defined as the largest leading submatrix whose estimated
+C         condition number is less than 1/RCOND.
+C         -------------------------------------------
+      id%ROOT%QR_RCOND = 1.0E-06
       NULLIFY(id%SINGULAR_VALUES)
       CALL SMUMPS_RR_INIT_POINTERS(id)
 C     Architecture data
@@ -313,5 +328,21 @@ C     ----------------------------------
       ELSE
           id%MYID_NODES = -464646
       ENDIF
+C
+C     Check that KEEP(34), the size of a Fortran INTEGER,
+C     as initialized above during SMUMPSID
+C     matches the size of an integer in C. If not,
+C     raise an error immediately.
+C
+      CALL MUMPS_INT_SIZE_C(I8)
+      IF (int(I8) .NE. id%KEEP(34)) THEN
+        id%INFO(1)=-69
+        id%INFO(2)=int(I8) ! size of MUMPS_INT
+C       Installation problem!
+C       WRITE on unit 6 since ICNTL(1:4) are not set by the user yet
+        IF (id%MYID .EQ. 0) WRITE(6,995) int(I8)
+ 995    FORMAT(' Installation error -69: ',
+     &' MUMPS_INT size (',I4,') incompatible with INTEGER size')
+      ENDIF
       RETURN
       END SUBROUTINE SMUMPS_INI_DRIVER
diff -pruN 5.6.2-2.1/src/slr_core.F 5.7.1-1/src/slr_core.F
--- 5.6.2-2.1/src/slr_core.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/slr_core.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -41,8 +41,9 @@ C
       SUBROUTINE IS_FRONT_BLR_CANDIDATE(INODE, NIV, NFRONT, NASS, 
      &                    BLRON, K489,
      &                    K490, K491, K492, K20, K60, IDAD, K38,
-     &                    LRSTATUS, K280, LRGROUPS)
-        INTEGER,INTENT(IN) :: INODE, NFRONT, NASS, BLRON, K489, K490,
+     &                    K123, LRSTATUS, K280, LRGROUPS)
+        INTEGER,INTENT(IN) :: INODE, NFRONT, NASS, BLRON, K123,
+     &                        K489, K490,
      &                        K491, K492, NIV, K20, K60, IDAD, K38
         INTEGER,INTENT(OUT):: LRSTATUS 
         INTEGER, INTENT(IN):: K280
@@ -180,8 +181,9 @@ C
         ENDIF
       END SUBROUTINE ALLOC_LRB_FROM_ACC
       SUBROUTINE REGROUPING2(CUT, NPARTSASS, NASS,
-     &                   NPARTSCB, NCB, IBCKSZ, ONLYCB, K472)
-        INTEGER, INTENT(IN) :: IBCKSZ, NASS, NCB
+     &                   NPARTSCB, NCB, IBCKSZ, ONLYCB, K472, 
+     &                   NFRONT, KEEP)
+        INTEGER, INTENT(IN) :: IBCKSZ, NASS, NCB, NFRONT, KEEP(500)
         INTEGER, INTENT(INOUT) :: NPARTSCB, NPARTSASS
         INTEGER, POINTER, DIMENSION(:) :: CUT
         INTEGER, POINTER, DIMENSION(:) :: NEW_CUT
@@ -197,8 +199,9 @@ C
      &          ' not enough memory? memory requested = ' , IERROR
            RETURN
         ENDIF
-        CALL COMPUTE_BLR_VCS(K472, IBCKSZ2, IBCKSZ, NASS)
-        MINSIZE = int(IBCKSZ2 / 2)
+        CALL COMPUTE_BLR_VCS(K472, IBCKSZ2, IBCKSZ, NASS, 
+     &                       NFRONT, KEEP(35))
+        MINSIZE = int(IBCKSZ2 / 3)
         NEW_NPARTSASS = max(NPARTSASS,1)
         IF (.NOT. ONLYCB) THEN
            NEW_CUT(1) = 1
@@ -435,7 +438,6 @@ CC
      &                          Y_RRQR(:,:)
         INTEGER, ALLOCATABLE :: JPVT_RRQR(:)
         INTEGER :: allocok, MREQ
-        REAL, EXTERNAL ::snrm2
         REAL :: ONE, MONE, ZERO
         PARAMETER (ONE = 1.0E0, MONE=-1.0E0)
         PARAMETER (ZERO=0.0E0)
@@ -875,10 +877,10 @@ C     Alloc NOT ok!!
         INTEGER(8), INTENT(IN) :: POSELTT
         INTEGER,intent(in) :: MIDBLK_COMPRESS, KPERCENT_RMB
         REAL, intent(in) :: TOLEPS
-        REAL,    ALLOCATABLE :: RWORK_RRQR(:)
-        REAL, ALLOCATABLE :: WORK_RRQR(:), TAU_RRQR(:)
-        REAL, ALLOCATABLE, DIMENSION(:,:), TARGET :: Q1, R1, 
-     &                                                  Q2, R2
+        REAL,    ALLOCATABLE:: RWORK_RRQR(:)
+        REAL, ALLOCATABLE:: WORK_RRQR(:), TAU_RRQR(:)
+        REAL, ALLOCATABLE, DIMENSION(:,:),TARGET:: Q1, R1,
+     &                                                Q2, R2
         INTEGER, ALLOCATABLE :: JPVT_RRQR(:)
         TYPE(LRB_TYPE)       :: LRB1, LRB2
         INTEGER :: INFO, RANK1, RANK2, RANK, MAXRANK, LWORK
diff -pruN 5.6.2-2.1/src/slr_stats.F 5.7.1-1/src/slr_stats.F
--- 5.6.2-2.1/src/slr_stats.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/slr_stats.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/slr_type.F 5.7.1-1/src/slr_type.F
--- 5.6.2-2.1/src/slr_type.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/slr_type.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/smumps_comm_buffer.F 5.7.1-1/src/smumps_comm_buffer.F
--- 5.6.2-2.1/src/smumps_comm_buffer.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/smumps_comm_buffer.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -13,7 +13,7 @@ C  https://cecill.info/licences/Licence_
 C
         MODULE SMUMPS_BUF
         PRIVATE
-        PUBLIC :: SMUMPS_BUF_TRY_FREE_CB, SMUMPS_BUF_INIT,
+        PUBLIC :: SMUMPS_BUF_INIT,
      &   SMUMPS_BUF_INI_MYID,
      &   SMUMPS_BUF_ALLOC_CB ,       SMUMPS_BUF_DEALL_CB ,
      &   SMUMPS_BUF_ALLOC_SMALL_BUF, SMUMPS_BUF_DEALL_SMALL_BUF,
@@ -52,34 +52,6 @@ C
      &       , SAVE, TARGET :: BUF_MAX_ARRAY
         PUBLIC :: BUF_LMAX_ARRAY, BUF_MAX_ARRAY
       CONTAINS
-        SUBROUTINE SMUMPS_BUF_TRY_FREE_CB()
-        CALL SMUMPS_BUF_TRY_FREE(BUF_CB)
-        RETURN
-        END SUBROUTINE SMUMPS_BUF_TRY_FREE_CB
-        SUBROUTINE SMUMPS_BUF_TRY_FREE(B)
-        IMPLICIT NONE
-        TYPE ( SMUMPS_COMM_BUFFER_TYPE ) :: B
-        INCLUDE 'mpif.h'
-        LOGICAL :: FLAG
-        INTEGER :: IERR_MPI
-        INTEGER :: STATUS(MPI_STATUS_SIZE)
-        IF ( B%HEAD .NE. B%TAIL ) THEN
- 10       CONTINUE
-          CALL MPI_TEST( B%CONTENT( B%HEAD + REQ ), FLAG,
-     &                   STATUS, IERR_MPI )
-          IF ( FLAG ) THEN
-            B%HEAD = B%CONTENT( B%HEAD + NEXT )
-            IF ( B%HEAD .EQ. 0 ) B%HEAD = B%TAIL
-            IF ( B%HEAD .NE. B%TAIL ) GOTO 10
-          END IF
-        END IF
-        IF ( B%HEAD .EQ. B%TAIL ) THEN
-          B%HEAD = 1
-          B%TAIL = 1
-          B%ILASTMSG = 1
-        END iF
-        RETURN
-        END SUBROUTINE SMUMPS_BUF_TRY_FREE
         SUBROUTINE SMUMPS_BUF_INI_MYID( MYID )
         IMPLICIT NONE
         INTEGER MYID
@@ -319,7 +291,7 @@ C
           ENDIF
         ENDIF
         IF (NBROWS_PACKET + NBROWS_ALREADY_SENT.NE.LCONT .AND.
-     &     SIZE_PACK  .LT. SIZE_RBUF_BYTES / 4
+     &     SIZE_PACK  .LT. SIZE_RBUF_BYTES / 10
      &    .AND. 
      &    .NOT. RECV_BUF_SMALLER_THAN_SEND)
      &       THEN
@@ -499,16 +471,16 @@ C
         SUBROUTINE SMUMPS_BUF_SEND_VCB( NRHS_B, NODE1, NODE2, NCB, LDW,
      &             LONG,
      &             IW, W, JBDEB, JBFIN,
-     &             RHSCOMP, NRHS, LRHSCOMP, IPOSINRHSCOMP, NPIV,
+     &             RHSINTR, NRHS, LRHSINTR, IPOSINRHSINTR, NPIV,
      &             KEEP,
      &             DEST, TAG, COMM, IERR )
         IMPLICIT NONE
         INTEGER LDW, DEST, TAG, COMM, IERR
         INTEGER NRHS_B, NODE1, NODE2, NCB, LONG, JBDEB, JBFIN
         INTEGER IW( max( 1, LONG ) )
-        INTEGER, INTENT(IN) :: LRHSCOMP, NRHS, IPOSINRHSCOMP, NPIV
+        INTEGER, INTENT(IN) :: LRHSINTR, NRHS, IPOSINRHSINTR, NPIV
         REAL W( max( 1, LDW * NRHS_B ) )
-        REAL RHSCOMP(LRHSCOMP,NRHS)
+        REAL RHSINTR(LRHSINTR,NRHS)
         INTEGER, INTENT(INOUT) :: KEEP(500)
         INCLUDE 'mpif.h'
         INTEGER :: IERR_MPI
@@ -566,7 +538,7 @@ C
           IF (NODE2.EQ.0) THEN
             DO K=1, NRHS_B
               IF (NPIV.GT.0) THEN
-              CALL MPI_PACK( RHSCOMP(IPOSINRHSCOMP,JBDEB+K-1), NPIV,
+              CALL MPI_PACK( RHSINTR(IPOSINRHSINTR,JBDEB+K-1), NPIV,
      &                          MPI_REAL,
      &                          BUF_CB%CONTENT( IPOS ), SIZE,
      &                          POSITION, COMM, IERR_MPI )
@@ -653,14 +625,13 @@ C
         FLAG = ( B%HEAD == B%TAIL )
         RETURN
         END SUBROUTINE SMUMPS_BUF_EMPTY
-        SUBROUTINE SMUMPS_BUF_SIZE_AVAILABLE( B, SIZE_AV )
+        SUBROUTINE SMUMPS_BUF_FREEREQUESTS( B )
         IMPLICIT NONE
         TYPE ( SMUMPS_COMM_BUFFER_TYPE ) :: B
-        INTEGER SIZE_AV
         INCLUDE 'mpif.h'
-        INTEGER :: IERR_MPI
+        INTEGER :: IERR_MPI, CURRENT, LAST_NOT_FREE, LAST_NOT_FREE_TAIL
         INTEGER :: STATUS(MPI_STATUS_SIZE)
-        LOGICAL :: FLAG
+        LOGICAL :: FLAG, BROADCAST_NOT_FREE
         IF ( B%HEAD .NE. B%TAIL ) THEN
  10       CONTINUE
           CALL MPI_TEST( B%CONTENT( B%HEAD + REQ ), FLAG, STATUS,
@@ -669,6 +640,41 @@ C
             B%HEAD = B%CONTENT( B%HEAD + NEXT )
             IF ( B%HEAD .EQ. 0 ) B%HEAD = B%TAIL
             IF ( B%HEAD .NE. B%TAIL ) GOTO 10
+          ELSE
+            LAST_NOT_FREE = B%HEAD
+            CURRENT = B%CONTENT( LAST_NOT_FREE + NEXT )
+            LAST_NOT_FREE_TAIL = CURRENT
+            BROADCAST_NOT_FREE = B%CONTENT(LAST_NOT_FREE+NEXT).EQ.
+     &                              LAST_NOT_FREE+OVHSIZE 
+            DO WHILE ( CURRENT .NE. 0 )
+              IF (BROADCAST_NOT_FREE) THEN
+                FLAG = .FALSE.
+              ELSE
+                CALL MPI_TEST( B%CONTENT( CURRENT + REQ ), FLAG, STATUS,
+     &                       IERR_MPI )
+              ENDIF
+              IF (FLAG) THEN
+                CURRENT = B%CONTENT( CURRENT + NEXT )
+                B%CONTENT( LAST_NOT_FREE + NEXT ) = CURRENT
+              ELSE
+                LAST_NOT_FREE = CURRENT
+                CURRENT = B%CONTENT( CURRENT + NEXT )
+                IF ( CURRENT .NE. 0 ) THEN
+                  LAST_NOT_FREE_TAIL = CURRENT
+                ELSE
+                  LAST_NOT_FREE_TAIL = B%TAIL
+                ENDIF
+                BROADCAST_NOT_FREE = B%CONTENT(LAST_NOT_FREE+NEXT).EQ.
+     &                               LAST_NOT_FREE+OVHSIZE 
+              ENDIF
+            ENDDO
+            IF ( LAST_NOT_FREE_TAIL .NE. 0 ) THEN
+              B%TAIL = LAST_NOT_FREE_TAIL
+              B%ILASTMSG = LAST_NOT_FREE
+            ELSE IF (B%ILASTMSG .NE. LAST_NOT_FREE) THEN
+              WRITE(*,*) "ABORT", B%ILASTMSG, LAST_NOT_FREE
+              CALL MUMPS_ABORT()
+            ENDIF
           END IF
         END IF
         IF ( B%HEAD .EQ. B%TAIL ) THEN
@@ -676,86 +682,78 @@ C
           B%TAIL = 1
           B%ILASTMSG = 1
         END IF
+        RETURN
+        END SUBROUTINE SMUMPS_BUF_FREEREQUESTS
+        SUBROUTINE SMUMPS_BUF_SIZE_AVAILABLE( B, SIZE_AV, SIZE_AV2 )
+        IMPLICIT NONE
+        TYPE ( SMUMPS_COMM_BUFFER_TYPE ) :: B
+        INTEGER, INTENT(OUT) :: SIZE_AV
+        INTEGER, OPTIONAL, INTENT(OUT) :: SIZE_AV2
+        CALL SMUMPS_BUF_FREEREQUESTS( B )
         IF ( B%HEAD .LE. B%TAIL ) THEN
-           SIZE_AV = max( B%LBUF_INT - B%TAIL, B%HEAD - 2 )
+          SIZE_AV = max( B%LBUF_INT - B%TAIL, B%HEAD - 2 )
+          IF ( B%LBUF_INT - B%TAIL .GT. B%HEAD - 2 ) THEN
+            SIZE_AV  = B%LBUF_INT - B%TAIL
+            IF (present(SIZE_AV2)) SIZE_AV2 = 0
+          ELSE
+            SIZE_AV = B%HEAD - 2
+            IF (present(SIZE_AV2)) SIZE_AV2 = B%LBUF_INT - B%TAIL
+          ENDIF
         ELSE
-           SIZE_AV = B%HEAD - B%TAIL - 1
+          SIZE_AV  = B%HEAD - B%TAIL - 1
+          IF (present(SIZE_AV2)) SIZE_AV2 = 0
         END IF
-        SIZE_AV = min(SIZE_AV - OVHSIZE, SIZE_AV)
+        SIZE_AV = max(0,SIZE_AV - OVHSIZE)
         SIZE_AV = SIZE_AV * SIZEofINT
+        IF (present(SIZE_AV2)) THEN
+          IF (SIZE_AV2 .NE. 0) THEN
+            SIZE_AV = max(0,SIZE_AV2 - OVHSIZE)
+            SIZE_AV2 = SIZE_AV2 * SIZEofINT
+          ENDIF
+        ENDIF
         RETURN
         END SUBROUTINE SMUMPS_BUF_SIZE_AVAILABLE
         SUBROUTINE SMUMPS_BUF_TEST()
-        INTEGER :: IPOS, IREQ, IERR
-        INTEGER, PARAMETER :: IONE=1
-        INTEGER :: MSG_SIZE
-        INTEGER :: DEST2(1)
-        DEST2=-10
-        MSG_SIZE=1
-        CALL BUF_LOOK( BUF_CB, IPOS, IREQ, MSG_SIZE, IERR, 
-     &                 IONE , DEST2,.TRUE.)
+        CALL SMUMPS_BUF_FREEREQUESTS(BUF_CB)
         RETURN
         END SUBROUTINE SMUMPS_BUF_TEST
         SUBROUTINE BUF_LOOK( B, IPOS, IREQ, MSG_SIZE, IERR, 
-     &    NDEST , PDEST, TEST_ONLY)
+     &    NDEST , PDEST )
         IMPLICIT NONE
         TYPE ( SMUMPS_COMM_BUFFER_TYPE ) :: B
         INTEGER, INTENT(IN)        :: MSG_SIZE
         INTEGER, INTENT(OUT)       :: IPOS, IREQ, IERR
-        LOGICAL, INTENT(IN), OPTIONAL :: TEST_ONLY
         INTEGER NDEST
         INTEGER, INTENT(IN)        :: PDEST(max(1,NDEST))
         INCLUDE 'mpif.h'
-        INTEGER :: IERR_MPI
         INTEGER :: MSG_SIZE_INT
         INTEGER :: IBUF
-        LOGICAL :: FLAG
-        INTEGER :: STATUS(MPI_STATUS_SIZE)
         IERR = 0
-        IF ( B%HEAD .NE. B%TAIL ) THEN
- 10       CONTINUE
-          CALL MPI_TEST( B%CONTENT( B%HEAD + REQ ), FLAG, STATUS,
-     &                   IERR_MPI )
-          IF ( FLAG ) THEN
-            B%HEAD = B%CONTENT( B%HEAD + NEXT )
-            IF ( B%HEAD .EQ. 0 ) B%HEAD = B%TAIL
-            IF ( B%HEAD .NE. B%TAIL ) GOTO 10
-          END IF
-        END IF
-        IF ( B%HEAD .EQ. B%TAIL ) THEN
-          B%HEAD = 1
-          B%TAIL = 1
-          B%ILASTMSG = 1
-        END iF
+        CALL SMUMPS_BUF_FREEREQUESTS( B )
         MSG_SIZE_INT = ( MSG_SIZE + ( SIZEofINT - 1 ) ) / SIZEofINT
         MSG_SIZE_INT = MSG_SIZE_INT + OVHSIZE
-        IF (present(TEST_ONLY)) RETURN
-        FLAG = (     ( B%HEAD .LE. B%TAIL )
-     &               .AND. (
-     &                 ( MSG_SIZE_INT .LE. B%LBUF_INT - B%TAIL )
-     &                 .OR. ( MSG_SIZE_INT .LE. B%HEAD - 2 ) ) )
-     &         .OR.
-     &               ( ( B%HEAD .GT. B%TAIL )
-     &               .AND. ( MSG_SIZE_INT .LE. B%HEAD - B%TAIL - 1 ) )
-        IF ( .NOT. FLAG
-     &       ) THEN
-        IERR = -1
         IF ( MSG_SIZE_INT .GT. B%LBUF_INT - 1 ) THEN
-           IERR = -2
-        ENDIF
-        IPOS = -1
-        IREQ = -1
-        RETURN
-      END IF
+          IERR = -2
+          IPOS = -1
+          IREQ = -1
+          RETURN
+        END IF
         IF ( B%HEAD .LE. B%TAIL ) THEN
-          IF ( MSG_SIZE_INT .LE. B%LBUF_INT - B%TAIL + 1 ) THEN
+          IF ( MSG_SIZE_INT .LE. B%LBUF_INT - B%TAIL ) THEN
             IBUF = B%TAIL
-          ELSE IF ( MSG_SIZE_INT .LE. B%HEAD - 1 ) THEN
+          ELSE IF ( MSG_SIZE_INT .LE. B%HEAD - 2 ) THEN
             IBUF = 1
+          ELSE
+            IERR = -1
           END IF
         ELSE
-          IBUF = B%TAIL
+          IF ( MSG_SIZE_INT .LE . B%HEAD - B%TAIL - 1) THEN
+            IBUF = B%TAIL
+          ELSE
+            IERR = -1
+          ENDIF
         END IF
+        IF (IERR .LT. 0) RETURN
         B%CONTENT( B%ILASTMSG + NEXT ) = IBUF
         B%ILASTMSG = IBUF
         B%TAIL = IBUF + MSG_SIZE_INT
@@ -955,7 +953,7 @@ C
           ENDIF
         ENDIF
        IF (NBROWS_PACKET + NBROWS_ALREADY_SENT.NE.NROW .AND.
-     &   SIZE_PACK - SIZE1  .LT. ( SIZE_RBUF_BYTES - SIZE1 ) / 2
+     &   SIZE_PACK - SIZE1  .LT. ( SIZE_RBUF_BYTES - SIZE1 ) / 10
      &  .AND. 
      &   .NOT. RECV_BUF_SMALLER_THAN_SEND)
      &       THEN
@@ -1239,17 +1237,14 @@ C
                SIZE1 = SIZE1+SIZE0
           ENDIF
       ENDIF
-      IF (KEEP(50) .EQ. 0) THEN
-        ONEorTWO = 1
-      ELSE
-        ONEorTWO = 2
-      ENDIF
+      ONEorTWO = 1
       IF (PDEST .EQ.PDEST_MASTER) THEN
         L = 0
       ELSE IF (KEEP(50) .EQ. 0) THEN
         L = LROW
       ELSE
         L = LROW + PERM(1) - LMAP + NBROWS_ALREADY_SENT - 1
+        ONEorTWO=ONEorTWO+1
       ENDIF
       NBINT = 6 + L + 1 
       IF (CB_IS_LR.AND.NBROW.GT.0) THEN
@@ -1269,7 +1264,8 @@ C
      &       SIZE_AV / ( ONEorTWO*SIZEofINT+LROW*SIZEofREAL)
         ELSE
           B = 2 * ONEorTWO + 
-     &      ( 1 + 2 *  LROW + 2 * PERM(1) + 2 * NBROWS_ALREADY_SENT )
+     &      ( -1 + 2 *  LROW + 2 * PERM(1) -2*LMAP
+     &                                  + 2 * NBROWS_ALREADY_SENT )
      &      * SIZEofREAL / SIZEofINT
           NBROWS_PACKET=int((dble(-B)+sqrt((dble(B)*dble(B))+
      &        dble(4)*dble(2)*dble(SIZE_AV)/dble(SIZEofINT) *
@@ -1318,9 +1314,9 @@ C
           MAX_ROW_LENGTH = -99999
           SIZE_REALS = NBROWS_PACKET * LROW
         ELSE
-          SIZE_REALS = (  LROW + PERM(1) + NBROWS_ALREADY_SENT ) *
+          SIZE_REALS = ( LROW + PERM(1) - LMAP + NBROWS_ALREADY_SENT ) *
      &      NBROWS_PACKET + ( NBROWS_PACKET *
-     &     ( NBROWS_PACKET + 1) ) / 2
+     &     ( NBROWS_PACKET - 1) ) / 2
           MAX_ROW_LENGTH = LROW+PERM(1)-LMAP+NBROWS_ALREADY_SENT
      &                 + NBROWS_PACKET-1
         ENDIF
@@ -1346,7 +1342,7 @@ C
       ENDIF
         SIZE_PACK = SIZE1 + SIZE2 + SIZE3
         IF (NBROWS_PACKET + NBROWS_ALREADY_SENT.NE.NBROW .AND.
-     &       SIZE_PACK  .LT. SIZE_RBUF_BYTES / 4 .AND.
+     &       SIZE_PACK  .LT. SIZE_RBUF_BYTES / 10 .AND.
      &    .NOT. RECV_BUF_SMALLER_THAN_SEND .AND.
      &    .NOT. CB_IS_LR)
      &       THEN
@@ -1804,7 +1800,7 @@ C
      &             WIDTH, COMM,
      &             NELIM, NPARTSASS, CURRENT_BLR_PANEL, 
      &             LR_ACTIVATED, BLR_LorU,
-     &
+     &             ICNTL,
      &             IERR )
       USE SMUMPS_LR_TYPE
       IMPLICIT NONE
@@ -1820,19 +1816,28 @@ C
         LOGICAL, intent(in) :: LR_ACTIVATED
         INTEGER, intent(in) :: NELIM, NPARTSASS, CURRENT_BLR_PANEL
         TYPE (LRB_TYPE), DIMENSION(:), intent(in) :: BLR_LorU
+        INTEGER, intent(in) :: ICNTL(60)
         INTEGER, intent(inout) :: IERR
         INCLUDE 'mpif.h'
         INCLUDE 'mumps_tags.h'
         INTEGER :: IERR_MPI
-        INTEGER POSITION, IREQ, IPOS, SIZE1, SIZE2, SIZE3, SIZET,
+        INTEGER POSITION, IREQ, IPOS, SIZE1, SIZE3, SIZET,
      &          IDEST, IPOSMSG, I
+        LOGICAL OVERFLOW
+        INTEGER(8) :: SIZE2_8, SIZE3_8, SIZET_8, SIZE_OVERFLOW
         INTEGER NPIVSENT
         INTEGER SSS
         INTEGER  :: NBMSGS
+        INTEGER :: LP
+        LOGICAL :: LPOK
         INTEGER :: LRELAY_INFO, DEST_BLOCFACTO, TAG_BLOCFACTO
         INTEGER :: LR_ACTIVATED_INT
+        LP  = ICNTL( 1 )
+        LPOK    = ( LP.GT.0 .AND. ICNTL(4).GE.1 )
         IERR = 0
         LRELAY_INFO = 0
+        OVERFLOW = .FALSE.
+        SIZE_OVERFLOW = 0_8
         NBMSGS = NDEST
         IF ( LASTBL ) THEN
           IF ( KEEP(50) .eq. 0 ) THEN
@@ -1855,28 +1860,56 @@ C
      &                          MPI_INTEGER, COMM, SIZE1, IERR_MPI )
           END IF
         END IF
-        SIZE2 = 0
+        SIZE2_8 = 0_8
         CALL MPI_PACK_SIZE( 4, MPI_INTEGER, COMM, SIZE3, IERR_MPI )
-        SIZE2=SIZE2+SIZE3
+        SIZE2_8=SIZE2_8+SIZE3
         IF ( KEEP(50).NE.0 ) THEN
           CALL MPI_PACK_SIZE( 1, MPI_INTEGER, COMM, SIZE3, IERR_MPI )
-          SIZE2=SIZE2+SIZE3
+          SIZE2_8=SIZE2_8+SIZE3
         ENDIF
         IF ((NPIV.GT.0)
      &     ) THEN
           IF (.NOT. LR_ACTIVATED) THEN
-            CALL MPI_PACK_SIZE( NPIV*NCOL, MPI_REAL,
+            SIZE3_8 = int(NPIV,8)*int(NCOL,8)*int(KEEP(35),8)
+            IF (SIZE3_8 .GT. int(huge(SIZE3),8))  THEN
+              OVERFLOW      = .TRUE.
+              SIZE_OVERFLOW = SIZE3_8
+            ELSE
+              CALL MPI_PACK_SIZE( NPIV*NCOL, 
+     &                      MPI_REAL,
      &                      COMM, SIZE3, IERR_MPI )
-            SIZE2 = SIZE2+SIZE3
+              SIZE2_8 = SIZE2_8 + int(SIZE3,8)
+            ENDIF
           ELSE
-            CALL MPI_PACK_SIZE( NPIV*(NPIV+NELIM), MPI_REAL,
+            SIZE3_8 = int(NPIV,8)*int(NPIV+NELIM,8)*int(KEEP(35),8)
+            IF (SIZE3_8 .GT. int(huge(SIZE3),8)) THEN
+              OVERFLOW = .TRUE.
+              SIZE_OVERFLOW = SIZE3_8
+            ELSE
+              CALL MPI_PACK_SIZE( NPIV*(NPIV+NELIM), 
+     &                      MPI_REAL,
      &                      COMM, SIZE3, IERR_MPI )
-            SIZE2 = SIZE2+SIZE3
-              CALL MUMPS_MPI_PACK_SIZE_LR( BLR_LorU, SIZE3, COMM, IERR )
-            SIZE2 = SIZE2+SIZE3
-          ENDIF
+              SIZE2_8 = SIZE2_8+SIZE3
+            ENDIF
+              CALL MUMPS_MPI_PACK_SIZE_LR( BLR_LorU, SIZE3_8, 
+     &                                     COMM, IERR )
+            SIZE2_8 = SIZE2_8+SIZE3_8
+          ENDIF
+        ENDIF
+        SIZET_8 = int(SIZE1,8) + SIZE2_8
+        IF (SIZET_8 .GT. int(huge(SIZE3),8)) THEN
+              OVERFLOW      = .TRUE.
+              SIZE_OVERFLOW = SIZET_8
+        ENDIF
+        IF (OVERFLOW) THEN
+          IERR=-3
+          IF (LPOK) WRITE(LP,*)
+     & "Integer overflow message inSMUMPS_BUF_SEND_BLOCFACTO",
+     & "SIZE_OVERFLOW,NPIV,NFRONT,NELIM=",
+     &  SIZE_OVERFLOW, NPIV, NFRONT, NELIM
+          RETURN
         ENDIF
-        SIZET = SIZE1 + SIZE2 
+        SIZET = int(SIZET_8)
         IF (SIZET.GT.SIZE_RBUF_BYTES) THEN
           SSS = 0 
           IF ( LASTBL ) THEN
@@ -1896,7 +1929,7 @@ C
      &                        MPI_INTEGER, COMM, SSS, IERR_MPI )
            END IF
           END IF
-          SSS = SSS + SIZE2  
+          SSS = SSS + int(SIZE2_8)  
           IF (SSS.GT.SIZE_RBUF_BYTES) THEN
            IERR = -3 
             RETURN
@@ -2043,30 +2076,50 @@ C
         INCLUDE 'mumps_tags.h'
         INTEGER :: IERR_MPI
         INTEGER LR_ACTIVATED_INT
-        INTEGER POSITION, IREQ, IPOS, SIZE1, SIZE2, SIZET,
+        INTEGER POSITION, IREQ, IPOS, SIZE1, SIZET,
      &          IDEST, IPOSMSG, SSS, SSLR
-        IERR = 0
+        INTEGER(8) :: SIZE2_8, SSLR_8, SIZET_8, SIZE_OVERFLOW
+        LOGICAL    :: OVERFLOW
+        IERR          = 0
+        OVERFLOW      = .FALSE.
+        SIZE_OVERFLOW = 0_8
         CALL MPI_PACK_SIZE( 6 + ( NDEST - 1 ) * OVHSIZE,
      &                      MPI_INTEGER, COMM, SIZE1, IERR_MPI )
-        SIZE2  = 0
+        SIZE2_8  = 0_8
         CALL MPI_PACK_SIZE(2, MPI_INTEGER, COMM, SSLR, IERR_MPI )
-        SIZE2=SIZE2+SSLR
+        SIZE2_8 = SIZE2_8 + SSLR
         IF (.NOT. LR_ACTIVATED) THEN
-        CALL MPI_PACK_SIZE( abs(NPIV)*NCOLU, MPI_REAL,
+          SSLR_8 = int(abs(NPIV),8)*int(NCOLU,8)
+          IF (SSLR_8 .GT. int(huge(SSLR),8))  THEN
+              OVERFLOW      = .TRUE.
+              SIZE_OVERFLOW = SSLR_8
+          ELSE
+           CALL MPI_PACK_SIZE( abs(NPIV)*NCOLU, 
+     &                      MPI_REAL,
      &                      COMM, SSLR, IERR_MPI )
-         SIZE2=SIZE2+SSLR
+           SIZE2_8=SIZE2_8 + int(SSLR,8)
+          ENDIF
         ELSE
-          CALL MUMPS_MPI_PACK_SIZE_LR( BLR_LS, SSLR, COMM, IERR )
-          SIZE2=SIZE2+SSLR
+          CALL MUMPS_MPI_PACK_SIZE_LR( BLR_LS, SSLR_8, COMM, IERR )
+          SIZE2_8=SIZE2_8 + SSLR_8
+        ENDIF
+        SIZET_8 = int(SIZE1,8) + SIZE2_8
+        IF (SIZET_8 .GT. int(huge(SSLR),8)) THEN
+              OVERFLOW      = .TRUE.
+              SIZE_OVERFLOW = SIZET_8
         ENDIF
-        SIZET = SIZE1 + SIZE2
+        IF (OVERFLOW) THEN
+          IERR=-3
+          RETURN
+        ENDIF
+        SIZET = int(SIZET_8)
         IF (SIZET.GT.SIZE_RBUF_BYTES) THEN
          CALL MPI_PACK_SIZE( 6 ,
      &                      MPI_INTEGER, COMM, SSS, IERR_MPI )
-         SSS = SSS+SIZE2
-         IF (SSS.GT.SIZE_RBUF_BYTES) THEN
+         SIZE2_8 = int(SSS,8)+SIZE2_8
+         IF (int(SIZE2_8).GT.SIZE_RBUF_BYTES) THEN
            IERR = -2
-      RETURN
+           RETURN
          ENDIF
         END IF
         CALL BUF_LOOK( BUF_CB, IPOS, IREQ, SIZET, IERR, 
@@ -2254,7 +2307,7 @@ C
           ENDIF
           IF (N_PACKET + N_ALREADY_SENT .NE. NSUBSET_ROW - NSUPROW
      &         .AND.
-     &         SIZE_PACK .LT. SIZE_RBUF_BYTES / 4
+     &         SIZE_PACK .LT. SIZE_RBUF_BYTES / 10
      &         .AND. .NOT. RECV_BUF_SMALLER_THAN_SEND)
      &         THEN
              IERR = -1
@@ -2797,11 +2850,11 @@ C
      &             ( WHAT, COMM, NPROCS, 
      &               FUTURE_NIV2,
      &               LOAD, UPD_LOAD,
-     &               MYID, KEEP, IERR)
+     &               MYID, KEEP267, IERR)
         IMPLICIT NONE
         INTEGER COMM, NPROCS, MYID, IERR, WHAT
         DOUBLE PRECISION LOAD,UPD_LOAD
-        INTEGER, INTENT(INOUT) :: KEEP(500)
+        INTEGER, INTENT(INOUT) :: KEEP267
         INCLUDE 'mpif.h'
         INCLUDE 'mumps_tags.h'
         INTEGER :: IERR_MPI
@@ -2870,7 +2923,7 @@ C
         DO I = 0, NPROCS - 1
           IF ( I .NE. MYID .AND. FUTURE_NIV2(I+1) .NE. 0) THEN
             IDEST = IDEST + 1
-            KEEP(267)=KEEP(267)+1
+            KEEP267 = KEEP267 + 1
             CALL MPI_ISEND( BUF_LOAD%CONTENT( IPOSMSG ),
      &                      POSITION, MPI_PACKED, I,
      &                      UPDATE_LOAD, COMM,
@@ -2913,7 +2966,7 @@ C
      &          MPI_INTEGER, COMM,
      &          SIZE, IERR_MPI )
         ELSE
-           CALL MPI_PACK_SIZE( 2 + OVHSIZE, 
+           CALL MPI_PACK_SIZE( 2, 
      &          MPI_INTEGER, COMM,
      &          SIZE, IERR_MPI )
         ENDIF
@@ -3153,22 +3206,23 @@ C
         SIZE_RBUF_BYTES = SMUMPS_LBUFR_BYTES
         RETURN
       END SUBROUTINE SMUMPS_BUF_DIST_IRECV_SIZE
-      SUBROUTINE MUMPS_MPI_PACK_SIZE_LR( BLR_LorU, SIZE_OUT, COMM,
+      SUBROUTINE MUMPS_MPI_PACK_SIZE_LR( BLR_LorU, SIZE_OUT8, COMM,
      &                                   IERR )
       USE SMUMPS_LR_TYPE
-      INTEGER, intent(out) :: SIZE_OUT, IERR
+      INTEGER, intent(out)     :: IERR
+      INTEGER(8), intent(out)  :: SIZE_OUT8
       INTEGER, intent(in)  :: COMM
       TYPE (LRB_TYPE), DIMENSION(:), intent(in) :: BLR_LorU
-      INTEGER :: I, SIZE_LOC, IERR_MPI
+      INTEGER     :: I, SIZE_LOC, IERR_MPI
       INCLUDE 'mpif.h'
-        IERR = 0
-        SIZE_OUT = 0
+        IERR      = 0
+        SIZE_OUT8 = 0_8
         CALL MPI_PACK_SIZE( 1, MPI_INTEGER, COMM, SIZE_LOC,  IERR_MPI )
-        SIZE_OUT = SIZE_OUT + SIZE_LOC
+        SIZE_OUT8 = SIZE_OUT8 + SIZE_LOC
         DO I = 1, size(BLR_LorU)
           CALL MUMPS_MPI_PACK_SIZE_LRB(BLR_LorU(I), SIZE_LOC, COMM, 
      &                                 IERR )
-          SIZE_OUT = SIZE_OUT + SIZE_LOC
+          SIZE_OUT8 = SIZE_OUT8 + SIZE_LOC
         ENDDO
         RETURN
       END SUBROUTINE MUMPS_MPI_PACK_SIZE_LR
diff -pruN 5.6.2-2.1/src/smumps_config_file.F 5.7.1-1/src/smumps_config_file.F
--- 5.6.2-2.1/src/smumps_config_file.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/smumps_config_file.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/smumps_driver.F 5.7.1-1/src/smumps_driver.F
--- 5.6.2-2.1/src/smumps_driver.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/smumps_driver.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -21,7 +21,9 @@ C
       USE MUMPS_MEMORY_MOD
       USE SMUMPS_STRUC_DEF
       USE SMUMPS_STATIC_PTR_M ! For Schur pointer
+#if ! defined(NO_SAVE_RESTORE)
       USE SMUMPS_SAVE_RESTORE
+#endif
 C      
 !$    USE OMP_LIB
 C
@@ -345,6 +347,14 @@ C
 * Values 4, 5, 6 for the parameter JOB can invoke combinations
 * of the three basic operations corresponding to JOB=1, 2 or 3.
 * 
+* JOB = -4 : frees all data structures from the factorization
+* while keeping data structures from the analysis. Can be
+* followed by a JOB = 2 call.
+*
+#if ! defined(NO_SAVE_RESTORE)
+* JOB = -3, 7, 8 : save and restore feature, see userguide
+#endif
+* JOB = 9 : provide suggested data distribution for IRHS_LOC
 C
 *********
 C     --------------------------------------
@@ -584,7 +594,7 @@ C
 !$    INTEGER NOMP, NOMPMIN, NOMPMAX
       INTEGER I, J, MP, LP, MPG, KEEP235SAVE, KEEP242SAVE,
      &        KEEP243SAVE, KEEP495SAVE, KEEP497SAVE,
-     &        KEEP77SAVE, KEEP83SAVE, KEEP91SAVE
+     &        KEEP77SAVE, KEEP78SAVE, KEEP83SAVE, KEEP91SAVE
       INTEGER(8) :: I8
       LOGICAL LANA, LFACTO, LSOLVE, PROK, LPOK, FLAG, PROKG
       LOGICAL NOERRORBEFOREPERM
@@ -599,7 +609,9 @@ C     Local copy of JOB
       INTEGER, DIMENSION(:), ALLOCATABLE :: UNS_PERM_INV
 C     TIMINGS
       DOUBLE PRECISION TIMEG, TIMETOTAL
+#if ! defined(NO_SAVE_RESTORE)
       INTEGER(8) :: FILE_SIZE,STRUC_SIZE
+#endif
       INTEGER:: ICNTL16_LOC
 !$    INTEGER:: PREVIOUS_OMP_THREADS_NUM
       IF (id%JOB .EQ. -200) THEN
@@ -613,12 +625,14 @@ C       JOB=-200 to just suppress the ex
 C       before terminating the application and killing all
 C       processes. No checks are performed in this case,
 C       data is not freed and MPI should not be called
-C       (since MPI might no longer work)
+C       (since MPI might no longer work). In particular, there is
+C       no check that the value of JOB is the same on all the
+C       calling MPI processes.
         CALL SMUMPS_OOC_CLEAN_FILES(id,IERR)
         RETURN
       ENDIF
       NOERRORBEFOREPERM = .FALSE.
-      UNS_PERM_DONE = .FALSE.
+      UNS_PERM_DONE     = .FALSE.
       LANA  = .FALSE.
       LFACTO = .FALSE.
       LSOLVE = .FALSE.
@@ -627,6 +641,14 @@ C
 C     Initialize error return codes to 0.
       id%INFO(1) = 0
       id%INFO(2) = 0
+C
+C     Default setting for printing, before ICNTL(1:4) are initialized
+      LP = 6
+      MP = 0
+      MPG = 0
+      LPOK  = .TRUE.
+      PROK  = .FALSE.
+      PROKG = .FALSE.
 C     -----------------------------------
 C     Check that MPI has been initialized
 C     -----------------------------------
@@ -636,7 +658,9 @@ C     ----------------------------------
         id%INFO(2) =   0
         id%INFOG(1) = -23
         id%INFOG(2) =   0
-        WRITE(6,990)
+C       JOB=-1: LPOK is true and LP=6 (see
+C       above) because not set yet by the user
+        IF (LPOK) WRITE(LP,990)
  990  FORMAT(' Unrecoverable Error in SMUMPS initialization: ',
      &       ' MPI is not running.')
         RETURN               
@@ -646,16 +670,8 @@ C     Duplicate user communicator
 C     to avoid communications not
 C     related to SMUMPS
 C     ---------------------------
-       COMM_SAVE = id%COMM
-       CALL MPI_COMM_DUP( COMM_SAVE, id%COMM, IERR )
-C
-C     Default setting for printing
-      LP = 6
-      MP = 0
-      MPG = 0
-      LPOK  = .TRUE.
-      PROK  = .FALSE.
-      PROKG = .FALSE.
+      COMM_SAVE = id%COMM
+      CALL MPI_COMM_DUP( COMM_SAVE, id%COMM, IERR )
       ICNTL16_LOC = 0
 C     -------------------------
 C     Check if value of JOB is
@@ -673,7 +689,11 @@ C     -------------------------
 C   
 C     Check value of JOB and previous value of JOB
 C
+#if ! defined(NO_SAVE_RESTORE)
       IF ((JOB.LT.-3.OR.JOB.EQ.0.OR.JOB.GT.8)
+#else
+      IF ((JOB.LT.-2.OR.JOB.EQ.0.OR.JOB.GT.6) 
+#endif
      &    .AND. JOB.NE.9
      &    .AND. JOB.NE.-4
      &  ) THEN
@@ -695,6 +715,7 @@ C      Warning: non initialized value
         GOTO 499
        END IF
       END IF
+#if ! defined(NO_SAVE_RESTORE)
       IF(JOB.NE.-1) THEN
 C     Always allow JOB=-1
          IF((JOB.GT.-2).AND.(id%KEEP(140).EQ.1)) then
@@ -705,6 +726,7 @@ C     are -2 or -3
             GOTO 499
          END IF
       ENDIF
+#endif
 C     ----------------------------------
 C     Initialize, LANA, LFACTO, LSOLVE
 C     LANA indicates if analysis must be performed
@@ -730,6 +752,7 @@ C       Value defined on MASTER is the r
      &         IERR )
         IF (LANA) THEN
            KEEP77SAVE = id%KEEP(77)
+           KEEP78SAVE = id%KEEP(78)
            KEEP83SAVE = id%KEEP(83)
            KEEP91SAVE = id%KEEP(91)
            id%KEEP(198) = 0
@@ -786,9 +809,11 @@ C       and factorization:
       ENDIF
 C
       IF (JOB.EQ.-2.OR.JOB.EQ.1.OR.JOB.EQ.2.OR.JOB.EQ.3.OR.
-     &    JOB.EQ.4.OR.JOB.EQ.5.OR.JOB.EQ.6
+     &    JOB.EQ.4.OR.JOB.EQ.5.OR.JOB.EQ.6.OR.JOB.EQ.-4
+#if ! defined(NO_SAVE_RESTORE)
      &     .OR.JOB.EQ.7.OR.JOB.EQ.8.OR.JOB.EQ.-3
-     *     .OR. JOB.EQ.9 ! LATER .OR.JOB.EQ.10
+#endif
+     &     .OR. JOB.EQ.9 
      &     ) THEN
 C       Value of JOB is correct and differnet from -1
 C       ICNTL should have been initialized and can be used
@@ -803,6 +828,10 @@ C       ICNTL should have been initializ
           FROM_C_INTERFACE_STRING=" from C interface"
         ELSE
           FROM_C_INTERFACE_STRING=" "
+C         and KEEP8(83) to the ddress of ICNTL(50)
+C         Set KEEP8(84) to the address of RINFO(3)
+          CALL MUMPS_ADDR_C( id%ICNTL(50), id%KEEP8(83) )
+          CALL MUMPS_ADDR_C( id%RINFO (3), id%KEEP8(84) )
         ENDIF
 C       -----------------------------
 C       Set the number of threads if required.
@@ -832,10 +861,14 @@ C       -----------------------------
         IF (PROKG) THEN
 C          Print basic information on MUMPS call
            IF (JOB .EQ. -2
+#            if ! defined(NO_SAVE_RESTORE)
      &       .OR. JOB .EQ. 8
+#            endif
      &       ) THEN
 C            N, NELT, NNZ not meaningful
+#            if ! defined(NO_SAVE_RESTORE)
 C            or not defined yet (JOB=8).
+#            endif
              WRITE(MPG,'(/A,A,A,A,I4)') 
      &               'Entering SMUMPS ',
      &               trim(adjustl(id%VERSION_NUMBER)),
@@ -885,11 +918,6 @@ C          MPI and OpenMP information
 99996       FORMAT(/'Advanced settings:'/
      &       '   KEEP(370) Static mapping              =',I10/
      &       '   KEEP(371) Advanced optimizations      =',I10)
-            IF (id%KEEP(401) .GE. 1) THEN
-              WRITE(MPG, 99997) id%KEEP(401)
-            ENDIF
-99997       FORMAT('L0 thread based multithreading setting:'/
-     &       '   KEEP(401) (>=1 : ON)                  =',I10)
             WRITE(MPG, '(A)')
           ENDIF
         ENDIF
@@ -908,18 +936,18 @@ C
 C       ------------------------------------------
 C       Check that we have called (JOB=-2), ie
 C       that the previous JOB is not 1 2 or 3,
+C       or even -1
 C       before calling the initialization routine.
 C       --------------------------------------------
         id%INFO(1)=0
         id%INFO(2)=0
         OLDJOB = id%KEEP( 40 ) + 456789
-        IF ( OLDJOB .EQ. 1 .OR.
+        IF ( OLDJOB .EQ. -1 .OR.
+     &       OLDJOB .EQ. 1 .OR.
      &       OLDJOB .EQ. 2 .OR.
      &       OLDJOB .EQ. 3  ) THEN
-          IF ( id%N > 0 ) THEN
            id%INFO(1)=-3
            id%INFO(2)=JOB
-          ENDIF
         ENDIF
 C       Initialize id%MYID now because it is
 C       required by MUMPS_PROPINFO. id%MYID
@@ -976,6 +1004,7 @@ C
         id%DKEEP(70)=0.0E0
         CALL MUMPS_SECDEB(TIMETOTAL)
       ENDIF
+#if ! defined(NO_SAVE_RESTORE)
 C
 C----------------------------------------------------------------
 C
@@ -1046,6 +1075,7 @@ C
         IF ( id%INFO(1) .LT. 0 ) GOTO 499
         GOTO 500
       ENDIF
+#endif
 C----------------------------------------------------------------
 C
 C     JOB =  9 : fill IRHS_loc
@@ -1076,11 +1106,13 @@ C       Allowed if last factorization fa
           CALL SMUMPS_FREE_DATA_FACTO(id)
 C         Reset last successful phase
           OLDJOB=min(OLDJOB, 1)
+          id%KEEP(40) = OLDJOB - 456789
         ENDIF
         IF ( id%INFO(1) .LT .0 ) GOTO 499
         GOTO 500
       ENDIF
 C
+C
 C----------------------------------------------------------------
 C
 C     MAIN DRIVER
@@ -1168,7 +1200,6 @@ C      refinement and error analysis)
 C     ------------------------------------------
 #if ! defined (LARGEMATRICES)
       NOERRORBEFOREPERM =.TRUE.
-      UNS_PERM_DONE=.FALSE.
       IF (id%MYID .eq. MASTER .AND. id%KEEP(23) .NE. 0) THEN
         IF ( id%JOB .EQ. 2 .OR. id%JOB .EQ. 5 .OR.
      &       (id%JOB .EQ. 3 .AND. (id%ICNTL(10) .NE.0 .OR.
@@ -1238,10 +1269,10 @@ C       ----------------------------
 C
         IF (id%MYID.EQ.MASTER) THEN
 C         Check N, [N]NZ, NELT
-          IF ((id%N.LE.0).OR.((id%N+id%N+id%N)/3.NE.id%N)) THEN
-             id%INFO(1) = -16
-             id%INFO(2) = id%N
-             GOTO 100
+          IF (id%N.LE.0) THEN
+            id%INFO(1) = -16
+            id%INFO(2) = id%N
+            GOTO 100
           END IF
           IF (id%ICNTL(5).NE.1) THEN
 C           Assembled input
@@ -1419,8 +1450,27 @@ C       ANALYSIS PHASE:
         CALL SMUMPS_ANA_DRIVER( id )
 C       restore values
         id%KEEP(77) =  KEEP77SAVE 
+        id%KEEP(78) =  KEEP78SAVE 
         id%KEEP(83) =  KEEP83SAVE
         id%KEEP(91) =  KEEP91SAVE
+#if ! defined(LARGEMATRICES)
+        IF (id%MYID .eq. MASTER .AND. id%KEEP(23) .NE. 0) THEN
+         IF (.not.associated(id%UNS_PERM)) THEN
+C         I may happen 
+C           (for ex in case of error -7 during analysis:
+C           UNS_PERM can be not associated, 
+C           KEEP(23) was set to to automatic choice(=7) and
+C           an error of memory allocation occurs during analysis
+C           before having decided value of KEEP(23))
+C         UNS_PERM not associated and KEEP(23).NE.0
+C         Permuting JCN back does not make sense and KEEP(23) 
+C         should be reset to zero
+          id%KEEP(23) = 0
+         ELSE
+          UNS_PERM_DONE = .TRUE.
+         ENDIF
+        ENDIF
+#endif
 C
 C Check and save scaling option in INFOG(33)
         IF (id%MYID .eq. MASTER) THEN
@@ -1482,6 +1532,7 @@ C
 C-
 C-------------------------------------------------------
       IF ( LFACTO ) THEN
+C{
          IF (id%MYID .eq. MASTER) THEN
             id%DKEEP(91)=0.0E0
             CALL MUMPS_SECDEB(TIMEG)
@@ -1794,14 +1845,19 @@ C
              CALL SMUMPS_CHECK_DENSE_RHS
      &       (id%RHS,id%INFO,id%N,id%NRHS,id%LRHS)
 C            Sets KEEP(221) and do some checks
-             CALL SMUMPS_SET_K221(id)
-             CALL SMUMPS_CHECK_REDRHS(id)
+C            in case of Schur check if reduced RHS 
+C            requested
+              CALL SMUMPS_SET_K221(id,.FALSE.)
+             CALL SMUMPS_CHECK_K221andREDRHS(id)
           ENDIF
  200      CONTINUE
         END IF        ! End of IF (MYID .eq. MASTER)
 C       KEEP(221) was set in SMUMPS_SET_K221 but not broadcast
         CALL MPI_BCAST( id%KEEP(221), 1, MPI_INTEGER, MASTER, id%COMM,
      &       IERR )
+C       broadcast RR option 
+        CALL MPI_BCAST( id%KEEP(19), 1, MPI_INTEGER, MASTER, id%COMM,
+     &       IERR )
 C
 C       Check distributed matrices on all processors.
         I_AM_SLAVE = ( id%MYID .ne. MASTER  .OR.
@@ -1969,6 +2025,7 @@ C
 C       Update last successful step
 C
         id%KEEP(40) = 2 - 456789
+C}
       END IF
 C-------------------------------------------------------
 C-
@@ -2082,26 +2139,13 @@ C       done (no iterative refinement/
 C       error analysis), then we do not
 C       permute JCN back.
 C       -------------------------------
-        IF (id%JOB .NE. 3 .OR. UNS_PERM_DONE) THEN
-         IF (.not.associated(id%UNS_PERM)) THEN
-C         I may happen 
-C           (for ex in case of error -7 during analysis:
-C           UNS_PERM can be not associated, 
-C           KEEP(23) was set to to automatic choice(=7) and
-C           an error of memory allocation occurs during analysis
-C           before having decided value of KEEP(23))
-C         UNS_PERM not associated and KEEP(23).NE.0
-C         Permuting JCN back does not make sense and KEEP(23) 
-C         should be reset to zero
-          id%KEEP(23) = 0
-         ELSE
+        IF (UNS_PERM_DONE) THEN
            DO I8 = 1_8, id%KEEP8(28)
             J=id%JCN(I8)
 C           -- skip out-of range (that are ignored in ANA_O)
             IF (J.LE.0.OR.J.GT.id%N) CYCLE
             id%JCN(I8)=id%UNS_PERM(J)
            END DO
-          ENDIF
         END IF
       END IF
 #endif
@@ -2131,6 +2175,7 @@ C     the next time MUMPS is entered thr
 C     ------------------------------------------------------------
       NULLIFY(id%SCHUR_CINTERFACE)
 C
+#if ! defined(NO_SAVE_RESTORE)
 *=======================
 * Compute space for save
 *=======================
@@ -2147,6 +2192,7 @@ C
          id%RINFOG(17)=REAL(id%KEEP8(57))/1E6
          id%RINFOG(18)=REAL(id%KEEP8(58))/1E6
       ENDIF
+#endif
 !$    IF (ICNTL16_LOC .GT. 0) THEN
 #if defined(WORKAROUNDINTELILP64OPENMPLIMITATION)
 !$      CALL omp_set_num_threads(int(PREVIOUS_OMP_THREADS_NUM,4))
@@ -2168,8 +2214,8 @@ C
 C     -------------------------
 C     Restore user communicator
 C     -------------------------
-       CALL MPI_COMM_FREE( id%COMM, IERR )
-       id%COMM = COMM_SAVE
+      CALL MPI_COMM_FREE( id%COMM, IERR )
+      id%COMM = COMM_SAVE
       RETURN
 *
 99995 FORMAT (' ** ERROR RETURN ** FROM SMUMPS INFO(1)=', I5)
@@ -2242,7 +2288,7 @@ C        INFOG(2) = MYID
         CALL MPI_BCAST( INFOG(2), 1, MPI_INTEGER, ROOT, COMM, IERR )
       END IF
 C
-C    Make INFOG available on all procs:
+C     Make INFOG available on all procs:
 C
       CALL MPI_BCAST(INFOG(3), SIZE_INFOG-2, MPI_INTEGER,
      &               MASTER, COMM, IERR )
@@ -2279,12 +2325,12 @@ C---------------------------------------
             WRITE (LP,991) ICNTL(5),ICNTL(6),ICNTL(7),ICNTL(12),
      &          ICNTL(13),
      &          ICNTL(15),
-     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(58)
+     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(48),ICNTL(58)
            ELSE
             WRITE (LP,891) ICNTL(5),ICNTL(6),ICNTL(7),
      &          ICNTL(13),
      &          ICNTL(15),
-     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(58)
+     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(48),ICNTL(58)
            ENDIF
            IF ((ICNTL(6).EQ.5).OR.(ICNTL(6).EQ.6).OR.
      &          (ICNTL(12).NE.1) )  THEN
@@ -2293,6 +2339,7 @@ C---------------------------------------
            IF (id%ICNTL(19).NE.0)
      &      WRITE(LP,998) id%SIZE_SCHUR
            WRITE (LP,993) ICNTL(14)
+           WRITE (LP,996) ICNTL(56)
          CASE(2);
            WRITE (LP,980) 
            WRITE (LP,981) CNTL(1), CNTL(3), CNTL(4), CNTL(5), CNTL(7)
@@ -2301,21 +2348,34 @@ C---------------------------------------
            WRITE (LP,993) ICNTL(14) 
            WRITE (LP,923) ICNTL(24), ICNTL(31), ICNTL(32), ICNTL(33),
      &                    ICNTL(35), ICNTL(36), ICNTL(49)
+           WRITE (LP,996) ICNTL(56)
          CASE(3);
            WRITE (LP,980)
            WRITE (LP,990) ICNTL(1),ICNTL(2),ICNTL(3),ICNTL(4)
            WRITE (LP,995)
-     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21)
+     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21),ICNTL(26)
          CASE(4);
            WRITE (LP,980) 
            WRITE (LP,981) CNTL(1), CNTL(3), CNTL(4), CNTL(5), CNTL(7)
            WRITE (LP,990) ICNTL(1),ICNTL(2),ICNTL(3),ICNTL(4)
+           IF (id%SYM.EQ.2) THEN
+            WRITE (LP,991) ICNTL(5),ICNTL(6),ICNTL(7),ICNTL(12),
+     &          ICNTL(13),
+     &          ICNTL(15),
+     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(48),ICNTL(58)
+           ELSE
+            WRITE (LP,891) ICNTL(5),ICNTL(6),ICNTL(7),
+     &          ICNTL(13),
+     &          ICNTL(15),
+     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(48),ICNTL(58)
+           ENDIF
            WRITE (LP,992) ICNTL(8)
            IF (id%ICNTL(19).NE.0)
      &      WRITE(LP,998) id%SIZE_SCHUR
            WRITE (LP,993) ICNTL(14)
            WRITE (LP,923) ICNTL(24), ICNTL(31), ICNTL(32), ICNTL(33),
      &                    ICNTL(35), ICNTL(36), ICNTL(49)
+           WRITE (LP,996) ICNTL(56)
          CASE(5);
            WRITE (LP,980) 
            WRITE (LP,981) CNTL(1), CNTL(3), CNTL(4), CNTL(5), CNTL(7)
@@ -2324,19 +2384,20 @@ C---------------------------------------
             WRITE (LP,991) ICNTL(5),ICNTL(6),ICNTL(7),ICNTL(12),
      &          ICNTL(13),
      &          ICNTL(15),
-     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(58)
+     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(48),ICNTL(58)
            ELSE
             WRITE (LP,891) ICNTL(5),ICNTL(6),ICNTL(7),
      &          ICNTL(13),
      &          ICNTL(15),
-     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(58)
+     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(48),ICNTL(58)
            ENDIF
            WRITE (LP,992) ICNTL(8)
            WRITE (LP,993) ICNTL(14)
            WRITE (LP,995)
-     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21)
+     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21),ICNTL(26)
            WRITE (LP,923) ICNTL(24), ICNTL(31), ICNTL(32), ICNTL(33),
      &                    ICNTL(35), ICNTL(36), ICNTL(49)
+           WRITE (LP,996) ICNTL(56)
          CASE(6);
            WRITE (LP,980)
            WRITE (LP,981) CNTL(1), CNTL(3), CNTL(4), CNTL(5), CNTL(7)
@@ -2345,27 +2406,28 @@ C---------------------------------------
             WRITE (LP,991) ICNTL(5),ICNTL(6),ICNTL(7),ICNTL(12),
      &          ICNTL(13),
      &          ICNTL(15),
-     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(58)
+     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(48),ICNTL(58)
            ELSE
             WRITE (LP,891) ICNTL(5),ICNTL(6),ICNTL(7),
      &          ICNTL(13),
      &          ICNTL(15),
-     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(58)
+     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(48),ICNTL(58)
            ENDIF
            IF (id%ICNTL(19).NE.0)
      &      WRITE(LP,998) id%SIZE_SCHUR
            WRITE (LP,992) ICNTL(8)
            WRITE (LP,995)
-     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21)
+     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21), ICNTL(26)
            WRITE (LP,993) ICNTL(14)
            WRITE (LP,923) ICNTL(24), ICNTL(31), ICNTL(32), ICNTL(33),
      &                    ICNTL(35), ICNTL(36), ICNTL(49)
+           WRITE (LP,996) ICNTL(56)
         END SELECT
       ENDIF
  980  FORMAT (/'***********CONTROL PARAMETERS (ICNTL)**************'/)
  981  FORMAT (
      &     ' CNTL(1)   Threshold for numerical pivoting        =',D16.4/
-     &     ' CNTL(3)   Null pivot detection threshold          =',D16.4/
+     &     ' CNTL(3)   Threshold to detect singularities       =',D16.4/
      &     ' CNTL(4)   Threshold for static pivoting           =',D16.4/
      &     ' CNTL(5)   Fixation for null pivots                =',D16.4/
      &     ' CNTL(7)   Dropping threshold for BLR compression  =',D16.4)
@@ -2375,25 +2437,27 @@ C---------------------------------------
      &     'ICNTL(3)   Output stream for global information    =',I10/
      &     'ICNTL(4)   Level of printing                       =',I10)
  991  FORMAT (
-     &     'ICNTL(5)   Matrix format  ( keep(55) )             =',I10/
-     &     'ICNTL(6)   Maximum transversal  ( keep(23) )       =',I10/
+     &     'ICNTL(5)   Matrix format                           =',I10/
+     &     'ICNTL(6)   Maximum transversal                     =',I10/
      &     'ICNTL(7)   Ordering                                =',I10/
-     &     'ICNTL(12)  LDLT ordering strat ( keep(95) )        =',I10/
+     &     'ICNTL(12)  LDLT ordering strat                     =',I10/
      &     'ICNTL(13)  Parallel root (0=on, 1=off)             =',I10/
      &     'ICNTL(15)  Analysis by block                       =',I10/
-     &     'ICNTL(18)  Distributed matrix  ( keep(54) )        =',I10/
+     &     'ICNTL(18)  Distributed matrix                      =',I10/
      &     'ICNTL(19)  Schur option ( keep(60) 0=off,else=on ) =',I10/
      &     'ICNTL(22)  Out-of-core option (1=on, off otherwise)=',I10/
+     &     'ICNTL(48)  Tree based multithreading               =',I10/
      &     'ICNTL(58)  Symbolic factorization option           =',I10)
  891  FORMAT (
-     &     'ICNTL(5)   Matrix format  ( keep(55) )             =',I10/
-     &     'ICNTL(6)   Maximum transversal  ( keep(23) )       =',I10/
+     &     'ICNTL(5)   Matrix format                           =',I10/
+     &     'ICNTL(6)   Maximum transversal                     =',I10/
      &     'ICNTL(7)   Ordering                                =',I10/
      &     'ICNTL(13)  Parallel root (0=on, 1=off)             =',I10/
      &     'ICNTL(15)  Analysis by block                       =',I10/
-     &     'ICNTL(18)  Distributed matrix  ( keep(54) )        =',I10/
-     &     'ICNTL(19)  Schur option ( keep(60) 0=off,else=on ) =',I10/
+     &     'ICNTL(18)  Distributed matrix                      =',I10/
+     &     'ICNTL(19)  Schur option ( 0=off,else=on )          =',I10/
      &     'ICNTL(22)  Out-of-core option (1=on, off otherwise)=',I10/
+     &     'ICNTL(48)  Tree based multithreading               =',I10/
      &     'ICNTL(58)  Symbolic factorization option           =',I10)
  992  FORMAT (
      &     'ICNTL(8)   Scaling strategy                        =',I10)
@@ -2407,12 +2471,15 @@ C---------------------------------------
      &     'ICNTL(49)  Compact workarray S (end of facto.)     =',I10)
  993  FORMAT (
      &     'ICNTL(14)  Percent of memory increase              =',I10)
+ 996  FORMAT (
+     &     'ICNTL(56)  Null space functionality                =',I10) 
  995  FORMAT (
      &     'ICNTL(9)   Solve A x=b (1) or A''x = b (else)       =',I10/
      &     'ICNTL(10)  Max steps iterative refinement          =',I10/
      &     'ICNTL(11)  Error analysis (1=all,2=some,else=off)  =',I10/
      &     'ICNTL(20)  Den.(0)/sparse(1,2,3)/dist.(10,11) RHS  =',I10/
-     &     'ICNTL(21)  Gathered (0) or distributed(1) solution =',I10)
+     &     'ICNTL(21)  Gathered (0) or distributed(1) solution =',I10/
+     &     'ICNTL(26)  Solution step                           =',I10)
  998  FORMAT (
      &     '           Size of SCHUR matrix (SIZE_SCHUR)       =',I10)
       END SUBROUTINE SMUMPS_PRINT_ICNTL
@@ -2452,11 +2519,13 @@ C---------------------------------------
               WRITE (LP,992) KEEP(52)
            ENDIF   
            WRITE (LP,993) KEEP(12)
+           WRITE (LP,996) KEEP(19), KEEP(118)
+           WRITE (LP,994) KEEP(21)
          CASE(3);
            WRITE (LP,980)
            WRITE (LP,990) ICNTL(1),ICNTL(2),ICNTL(3),ICNTL(4) 
            WRITE (LP,995)
-     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21)
+     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21), ICNTL(26)
          CASE(4);
            WRITE (LP,980) 
            WRITE (LP,990) ICNTL(1),ICNTL(2),ICNTL(3),ICNTL(4)
@@ -2466,8 +2535,11 @@ C---------------------------------------
            WRITE (LP,991) KEEP(55),KEEP(23),ICNTL(7),KEEP(95),
      &          ICNTL(13),KEEP(54),KEEP(60),ICNTL(22)
            WRITE (LP,995)
-     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21)
+     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21), ICNTL(26)
            WRITE (LP,993) KEEP(12)
+           WRITE (LP,997) KEEP(53)
+           WRITE (LP,996) KEEP(19), KEEP(118)
+           WRITE (LP,994) KEEP(21)
          CASE(5);
            WRITE (LP,980) 
            WRITE (LP,990) ICNTL(1),ICNTL(2),ICNTL(3),ICNTL(4)
@@ -2481,6 +2553,8 @@ C---------------------------------------
               WRITE (LP,992) KEEP(52)
            ENDIF   
            WRITE (LP,993) KEEP(12)
+           WRITE (LP,996) KEEP(19), KEEP(118)
+           WRITE (LP,994) KEEP(21)
          CASE(6);
            WRITE (LP,980)
            WRITE (LP,990) ICNTL(1),ICNTL(2),ICNTL(3),ICNTL(4)
@@ -2494,8 +2568,11 @@ C---------------------------------------
               WRITE (LP,992) KEEP(52)
            ENDIF   
            WRITE (LP,995)
-     &     ICNTL(9),ICNTL(10),ICNTL(11),KEEP(248),ICNTL(21)
+     &     ICNTL(9),ICNTL(10),ICNTL(11),KEEP(248),ICNTL(21), ICNTL(26)
            WRITE (LP,993) KEEP(12)
+           WRITE (LP,997) KEEP(53)
+           WRITE (LP,996) KEEP(19), KEEP(118)
+           WRITE (LP,994) KEEP(21)
         END SELECT
       ENDIF
  980  FORMAT (/'******INTERNAL VALUE OF PARAMETERS (ICNTL/KEEP)****'/)
@@ -2522,7 +2599,15 @@ C---------------------------------------
      &     'ICNTL(10)  Max steps iterative refinement          =',I10/
      &     'ICNTL(11)  Error analysis ( 0= off, else=on)       =',I10/
      &     'ICNTL(20)  Den.(0)/sparse(1,2,3)/dist.(10,11) RHS  =',I10/
-     &     'ICNTL(21)  Gathered (0) or distributed(1) solution =',I10)
+     &     'ICNTL(21)  Gathered (0) or distributed(1) solution =',I10/
+     &     'ICNTL(26)  Solution step                           =',I10)
+ 997  FORMAT (
+     &     'ICNTL(56)  Null space-analysis      ( keep(53) )   =',I10) 
+ 996  FORMAT (
+     &     'ICNTL(56)  Null space-factorisation ( keep(19) )   =',I10/ 
+     &     'KEEP(118)  Algorithm used for null space           =',I10) 
+ 994  FORMAT (
+     &     'ICNTL(57)  Estimate of null space size ( keep(21) )=',I10)
       END SUBROUTINE SMUMPS_PRINT_KEEP
       SUBROUTINE SMUMPS_CHECK_DENSE_RHS
      &       (idRHS, idINFO, idN, idNRHS, idLRHS)
@@ -2581,7 +2666,7 @@ C           perform the check if minimal
       RETURN
       END SUBROUTINE SMUMPS_CHECK_DENSE_RHS
 C
-      SUBROUTINE SMUMPS_SET_K221(id)
+      SUBROUTINE SMUMPS_SET_K221(id,ATSOLVE)
       USE SMUMPS_STRUC_DEF
       IMPLICIT NONE
 C
@@ -2589,21 +2674,30 @@ C     Purpose:
 C     =======
 C
 C     Sets KEEP(221) on master.
-C     Constraint: must be called before SMUMPS_CHECK_REDRHS.
-C     Can be called at factorization or solve phase
+C     [Schur only] must be called before SMUMPS_CHECK_REDRHS 
+C       
+C     Can be called at factorization 
+C     (in case of fwd in facto) or at solve phase
+C     ATSOLVE=.TRUE. if called during solve phase
 C
       TYPE (SMUMPS_STRUC) :: id
+      LOGICAL, INTENT(IN) :: ATSOLVE 
+      LOGICAL :: PROKG
+      INTEGER :: MPG
       INTEGER MASTER
       PARAMETER( MASTER = 0 )
+      MPG = id%ICNTL( 3 )
+      PROKG = ( MPG .GT. 0 .and. id%MYID .eq. MASTER )
+      PROKG = (PROKG.AND.(id%ICNTL(4).GE.2))
       IF (id%MYID.EQ.MASTER) THEN
         id%KEEP(221)=id%ICNTL(26)
-        IF (id%KEEP(221).ne.0 .and. id%KEEP(221) .NE.1
-     &      .AND.id%KEEP(221).ne.2) id%KEEP(221)=0
+        IF (id%KEEP(221).NE.0 .AND. id%KEEP(221) .NE.1
+     &      .AND.id%KEEP(221).NE.2) id%KEEP(221)=0
       ENDIF
       RETURN
       END SUBROUTINE SMUMPS_SET_K221
 C
-      SUBROUTINE SMUMPS_CHECK_REDRHS(id)
+      SUBROUTINE SMUMPS_CHECK_K221andREDRHS(id)
       USE SMUMPS_STRUC_DEF
       IMPLICIT NONE
 C
@@ -2616,17 +2710,22 @@ C  * Constraints:
 C    - Must be called after solve phase.
 C    - KEEP(60) must have been set (ok to check
 C    since KEEP(60) was set during analysis phase)
-C  * Remark that during solve phase, ICNTL(26)=1 is
+C  * Remark that during solve phase, ICNTL(26)#0 is
 C    forbidden in case of fwd in facto.
 C
       TYPE (SMUMPS_STRUC) :: id
       INTEGER MASTER
       PARAMETER( MASTER = 0 )
+C     write(6,*) " Entering SMUMPS_CHECK_K221andREDRHS with : ", 
+C    & " id%JOB, id%KEEP(221), id%KEEP(60), id%SIZE_SCHUR= ", 
+C    & id%JOB, id%KEEP(221), id%KEEP(60), id%SIZE_SCHUR
       IF (id%MYID .EQ. MASTER) THEN
           IF ( id%KEEP(221) == 1 .or. id%KEEP(221) == 2 ) THEN
-            IF (id%KEEP(221) == 2 .and. id%JOB == 2) THEN
-              id%INFO(1)=-35
-              id%INFO(2)=id%KEEP(221)
+            IF (id%KEEP(221) == 2 .and. 
+     &                ( id%JOB .NE.3 )
+     &         ) THEN
+              id%INFO(1)=-33
+              id%INFO(2)=id%JOB
               GOTO 333
             ENDIF
             IF (id%KEEP(221) == 1 .and. id%KEEP(252) == 1
@@ -2637,29 +2736,39 @@ C
             IF ( id%KEEP(60).eq. 0 .or. id%SIZE_SCHUR.EQ.0 ) THEN
               id%INFO(1)=-33
               id%INFO(2)=id%KEEP(221)
+C              write(6,*) " id%KEEP(60), id%SIZE_SCHUR=", 
+C     &            id%KEEP(60), id%SIZE_SCHUR
               GOTO 333
             ENDIF
-            IF ( .NOT. associated( id%REDRHS)) THEN
-              id%INFO(1)=-22
-              id%INFO(2)=15
-              GOTO 333
-            ELSE IF (id%NRHS.EQ.1) THEN
-              IF (size(id%REDRHS) < id%SIZE_SCHUR ) THEN
+            IF ( id%KEEP(60).NE.0 ) THEN
+C           Schur feature
+              IF ( id%SIZE_SCHUR.EQ.0 ) THEN
+                id%INFO(1)=-33
+                id%INFO(2)=id%KEEP(221)
+                GOTO 333
+              ENDIF
+              IF ( .NOT. associated( id%REDRHS)) THEN
+                id%INFO(1)=-22
+                id%INFO(2)=15
+                GOTO 333
+              ELSE IF (id%NRHS.EQ.1) THEN
+                IF (size(id%REDRHS) < id%SIZE_SCHUR ) THEN
+                  id%INFO(1)=-22
+                  id%INFO(2)=15
+                  GOTO 333
+                ENDIF
+              ELSE IF (id%LREDRHS < id%SIZE_SCHUR) THEN
+                id%INFO(1)=-34
+                id%INFO(2)=id%LREDRHS
+                GOTO 333
+              ELSE IF
+     &        (size(id%REDRHS)<
+     &           id%NRHS*id%LREDRHS-id%LREDRHS+id%SIZE_SCHUR)
+     &        THEN
                 id%INFO(1)=-22
                 id%INFO(2)=15
                 GOTO 333
               ENDIF
-            ELSE IF (id%LREDRHS < id%SIZE_SCHUR) THEN
-              id%INFO(1)=-34
-              id%INFO(2)=id%LREDRHS
-              GOTO 333
-            ELSE IF
-     &      (size(id%REDRHS)<
-     &         id%NRHS*id%LREDRHS-id%LREDRHS+id%SIZE_SCHUR)
-     &      THEN
-              id%INFO(1)=-22
-              id%INFO(2)=15
-              GOTO 333
             ENDIF
           ENDIF
       ENDIF
@@ -2668,4 +2777,4 @@ C     Error is not propagated. It should
 C     The reason to propagate it outside is that there can be
 C     one call to PROPINFO instead of several ones.
       RETURN
-      END SUBROUTINE SMUMPS_CHECK_REDRHS
+      END SUBROUTINE SMUMPS_CHECK_K221andREDRHS
diff -pruN 5.6.2-2.1/src/smumps_f77.F 5.7.1-1/src/smumps_f77.F
--- 5.6.2-2.1/src/smumps_f77.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/smumps_f77.F	2024-05-02 10:15:25.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -16,8 +16,9 @@ C
      &     JCNhere, A, Ahere, NZ_loc, NNZ_loc, IRN_loc, IRN_lochere,
      &     JCN_loc, JCN_lochere, A_loc, A_lochere, NELT, ELTPTR,
      &     ELTPTRhere,  ELTVAR, ELTVARhere, A_ELT, A_ELThere,
-     &     BLKPTR, BLKPTRhere, BLKVAR, BLKVARhere,
-     &     PERM_IN, PERM_INhere, RHS, RHShere, REDRHS, REDRHShere,
+     &     BLKPTR, BLKPTRhere, BLKVAR, BLKVARhere, PERM_IN, PERM_INhere,
+     &     ROWIND, ROWINDhere, COLIND, COLINDhere, PIVOTS, PIVOTShere,
+     &     RHS, RHShere, REDRHS, REDRHShere,
      &     INFO, RINFO, INFOG, RINFOG, DEFICIENCY, LWK_USER,
      &     SIZE_SCHUR, LISTVAR_SCHUR, LISTVAR_SCHURhere, SCHUR,
      &     SCHURhere, WK_USER, WK_USERhere, COLSCA, COLSCAhere,
@@ -26,31 +27,38 @@ C
      &     RHS_loc, RHS_lochere,
      &     IRHS_SPARSE, IRHS_SPARSEhere, IRHS_PTR, IRHS_PTRhere,
      &     ISOL_loc, ISOL_lochere, IRHS_loc, IRHS_lochere, NZ_RHS,
-     &     LSOL_loc, LRHS_loc, Nloc_RHS,
+     &     LSOL_loc, LRHS_loc, NSOL_loc, Nloc_RHS,
      &     SCHUR_MLOC, SCHUR_NLOC, SCHUR_LLD,
-     &     MBLOCK, NBLOCK, NPROW, NPCOL,  
+     &     MBLOCK, NBLOCK, NPROW, NPCOL, LD_RHSINTR,
      &     OOC_TMPDIR, OOC_PREFIX, WRITE_PROBLEM,
+#if ! defined(NO_SAVE_RESTORE)
      &     SAVE_DIR, SAVE_PREFIX,
+#endif
      &     TMPDIRLEN, PREFIXLEN, WRITE_PROBLEMLEN,
+#if ! defined(NO_SAVE_RESTORE)
      &     SAVE_DIRLEN, SAVE_PREFIXLEN,
+#endif
      &     METIS_OPTIONS
      &     )
       USE SMUMPS_STRUC_DEF
       IMPLICIT NONE
       INTEGER OOC_PREFIX_MAX_LENGTH, OOC_TMPDIR_MAX_LENGTH
       INTEGER PB_MAX_LENGTH
-      PARAMETER(OOC_PREFIX_MAX_LENGTH=63, OOC_TMPDIR_MAX_LENGTH=255)
-      PARAMETER(PB_MAX_LENGTH=255)
-      INTEGER, PARAMETER :: SAVE_DIR_MAX_LENGTH    = 255
+      PARAMETER(OOC_PREFIX_MAX_LENGTH=255, OOC_TMPDIR_MAX_LENGTH=1023)
+      PARAMETER(PB_MAX_LENGTH=1023)
+#if ! defined(NO_SAVE_RESTORE)
+      INTEGER, PARAMETER :: SAVE_DIR_MAX_LENGTH    = 1023
       INTEGER, PARAMETER :: SAVE_PREFIX_MAX_LENGTH = 255
+#endif
       INTEGER JOB, SYM, PAR, COMM_F77, N, NBLK, NZ, NZ_loc, NELT,
      &        DEFICIENCY, LWK_USER, SIZE_SCHUR, INSTANCE_NUMBER,
      &        NRHS, LRHS,
-     &        NZ_RHS, LSOL_loc,Nloc_RHS, LRHS_loc, LREDRHS
+     &        NZ_RHS, LSOL_loc,Nloc_RHS, LRHS_loc, NSOL_loc, LREDRHS
       INTEGER(8) :: NNZ, NNZ_loc
       INTEGER ICNTL(60), INFO(80), INFOG(80), KEEP(500)
       INTEGER SCHUR_MLOC, SCHUR_NLOC, SCHUR_LLD
       INTEGER MBLOCK, NBLOCK, NPROW, NPCOL
+      INTEGER LD_RHSINTR
       INTEGER TMPDIRLEN, PREFIXLEN, WRITE_PROBLEMLEN
       REAL CNTL(15), RINFO(40), RINFOG(40), DKEEP(230)
       INTEGER(8) KEEP8(150)
@@ -61,6 +69,8 @@ C
       INTEGER, TARGET :: ISOL_loc(*), IRHS_loc(*)
       INTEGER, TARGET :: BLKPTR(*), BLKVAR(*)
       REAL, TARGET :: A(*), A_ELT(*), A_loc(*), RHS(*)
+      INTEGER, TARGET :: ROWIND(*), COLIND(*)
+      REAL, TARGET :: PIVOTS(*)
       REAL, TARGET :: WK_USER(*)
       REAL, TARGET :: REDRHS(*)
       REAL, TARGET :: ROWSCA(*), COLSCA(*)
@@ -69,13 +79,15 @@ C
       INTEGER, INTENT(inout) :: OOC_TMPDIR(OOC_TMPDIR_MAX_LENGTH)
       INTEGER, INTENT(inout) :: OOC_PREFIX(OOC_PREFIX_MAX_LENGTH)
       INTEGER, INTENT(in) :: WRITE_PROBLEM(PB_MAX_LENGTH)
+#if ! defined(NO_SAVE_RESTORE)
       INTEGER SAVE_DIRLEN, SAVE_PREFIXLEN
       INTEGER, INTENT(in) :: SAVE_DIR(SAVE_DIR_MAX_LENGTH)
       INTEGER, INTENT(in) :: SAVE_PREFIX(SAVE_PREFIX_MAX_LENGTH)
+#endif
       INTEGER METIS_OPTIONS(40)
       INTEGER IRNhere, JCNhere, Ahere, ELTPTRhere, ELTVARhere,
      &        A_ELThere, BLKPTRhere, BLKVARhere, PERM_INhere,
-     &        WK_USERhere,
+     &        WK_USERhere, ROWINDhere, COLINDhere, PIVOTShere,
      &        RHShere, REDRHShere, IRN_lochere,
      &        JCN_lochere, A_lochere, LISTVAR_SCHURhere,
      &        SCHURhere, COLSCAhere, ROWSCAhere, RHS_SPARSEhere,
@@ -99,9 +111,27 @@ C
       EXTERNAL MUMPS_ASSIGN_MAPPING,
      &         MUMPS_ASSIGN_PIVNUL_LIST,
      &         MUMPS_ASSIGN_SYM_PERM,
-     &         MUMPS_ASSIGN_UNS_PERM
+     &         MUMPS_ASSIGN_UNS_PERM,
+     &         MUMPS_ASSIGN_GLOB2LOC_RHS,
+     &         MUMPS_ASSIGN_GLOB2LOC_SOL
+      EXTERNAL MUMPS_NULLIFY_C_MAPPING,
+     &         MUMPS_NULLIFY_C_PIVNUL_LIST,
+     &         MUMPS_NULLIFY_C_SYM_PERM,
+     &         MUMPS_NULLIFY_C_UNS_PERM,
+     &         MUMPS_NULLIFY_C_GLOB2LOC_RHS,
+     &         MUMPS_NULLIFY_C_GLOB2LOC_SOL
       EXTERNAL SMUMPS_ASSIGN_COLSCA,
-     &         SMUMPS_ASSIGN_ROWSCA
+     &         SMUMPS_ASSIGN_ROWSCA,
+     &         SMUMPS_ASSIGN_ROWSCA_LOC,
+     &         SMUMPS_ASSIGN_COLSCA_LOC,
+     &         SMUMPS_ASSIGN_RHSINTR,
+     &         SMUMPS_ASSIGN_SINGULAR_VALUES
+      EXTERNAL SMUMPS_NULLIFY_C_COLSCA,
+     &         SMUMPS_NULLIFY_C_ROWSCA,
+     &         SMUMPS_NULLIFY_C_ROWSCA_LOC,
+     &         SMUMPS_NULLIFY_C_COLSCA_LOC,
+     &         SMUMPS_NULLIFY_C_RHSINTR,
+     &         SMUMPS_NULLIFY_C_SING_VALUES
       IF (JOB == -1) THEN
         DO I = 1, SMUMPS_STRUC_ARRAY_SIZE
           IF ( .NOT. associated(mumps_par_array(I)%PTR) ) GOTO 10
@@ -175,20 +205,22 @@ C
       CALL MUMPS_ADDR_C( ICNTL(50), mumps_par%KEEP8(83) )
       CALL MUMPS_ADDR_C( RINFO(3), mumps_par%KEEP8(84) )
       mumps_par%METIS_OPTIONS(1:40)=METIS_OPTIONS(1:40)
-      mumps_par%NRHS  = NRHS
-      mumps_par%LRHS  = LRHS
-      mumps_par%LREDRHS = LREDRHS
-      mumps_par%NZ_RHS   = NZ_RHS
-      mumps_par%LSOL_loc = LSOL_loc
-      mumps_par%Nloc_RHS = Nloc_RHS
-      mumps_par%LRHS_loc = LRHS_loc
+      mumps_par%NRHS         = NRHS
+      mumps_par%LRHS         = LRHS
+      mumps_par%LREDRHS      = LREDRHS
+      mumps_par%NZ_RHS       = NZ_RHS
+      mumps_par%LSOL_loc     = LSOL_loc
+      mumps_par%Nloc_RHS     = Nloc_RHS
+      mumps_par%LRHS_loc     = LRHS_loc
+      mumps_par%NSOL_loc     = NSOL_loc
       mumps_par%SCHUR_MLOC   = SCHUR_MLOC
       mumps_par%SCHUR_NLOC   = SCHUR_NLOC
       mumps_par%SCHUR_LLD    = SCHUR_LLD
-      mumps_par%MBLOCK = MBLOCK
-      mumps_par%NBLOCK = NBLOCK
-      mumps_par%NPROW  = NPROW
-      mumps_par%NPCOL  = NPCOL
+      mumps_par%MBLOCK       = MBLOCK
+      mumps_par%NBLOCK       = NBLOCK
+      mumps_par%NPROW        = NPROW
+      mumps_par%NPCOL        = NPCOL
+      mumps_par%LD_RHSINTR   = LD_RHSINTR
       IF ( COMM_F77 .NE. -987654 ) THEN
         mumps_par%COMM = COMM_F77
       ELSE
@@ -226,6 +258,20 @@ C
       IF ( SCHURhere /= 0 ) THEN
         mumps_par%SCHUR_CINTERFACE=>SCHUR(1:1)
       ENDIF
+      IF (ROWINDhere /= 0) THEN
+        mumps_par%ROWIND => ROWIND(1:KEEP(89))
+      ENDIF
+      IF (COLINDhere /= 0) THEN
+        mumps_par%COLIND => COLIND(1:KEEP(89))
+      ENDIF
+      IF (PIVOTShere /= 0) THEN
+        IF (KEEP(50) .EQ.0 .OR.KEEP(50).EQ.1) THEN
+          mumps_par%PIVOTS => PIVOTS(1:KEEP(89))
+        ELSE
+          mumps_par%PIVOTS => PIVOTS(1_8:
+     &                        int(KEEP(89),8)+int(KEEP(89),8))
+        ENDIF
+      ENDIF
       IF (NRHS .NE. 1) THEN
         IF ( RHShere /= 0 ) mumps_par%RHS =>
      &                      RHS(1_8:int(NRHS,8)*int(LRHS,8))
@@ -276,6 +322,7 @@ C
       DO I=WRITE_PROBLEMLEN+1,PB_MAX_LENGTH
         mumps_par%WRITE_PROBLEM(I:I)=' '
       ENDDO
+#if ! defined(NO_SAVE_RESTORE)
       DO I=1,SAVE_DIRLEN
         mumps_par%SAVE_DIR(I:I)=char(SAVE_DIR(I))
       ENDDO
@@ -288,6 +335,7 @@ C
       DO I=SAVE_PREFIXLEN+1,SAVE_PREFIX_MAX_LENGTH
         mumps_par%SAVE_PREFIX(I:I)=' '
       ENDDO
+#endif
       CALL SMUMPS( mumps_par )
       INFO(1:80)=mumps_par%INFO(1:80)
       INFOG(1:80)=mumps_par%INFOG(1:80)
@@ -315,6 +363,7 @@ C
       LSOL_loc   = mumps_par%LSOL_loc
       Nloc_RHS   = mumps_par%Nloc_RHS
       LRHS_loc   = mumps_par%LRHS_loc
+      NSOL_loc   = mumps_par%NSOL_loc
       SIZE_SCHUR = mumps_par%SIZE_SCHUR
       LWK_USER   = mumps_par%LWK_USER
       NELT       = mumps_par%NELT
@@ -326,6 +375,7 @@ C
       NBLOCK     = mumps_par%NBLOCK
       NPROW      = mumps_par%NPROW
       NPCOL      = mumps_par%NPCOL
+      LD_RHSINTR = mumps_par%LD_RHSINTR
       IF ( associated (mumps_par%MAPPING) ) THEN
          CALL MUMPS_ASSIGN_MAPPING(mumps_par%MAPPING(1))
       ELSE
@@ -336,6 +386,12 @@ C
       ELSE
          CALL MUMPS_NULLIFY_C_PIVNUL_LIST()
       ENDIF
+      IF ( associated (mumps_par%SINGULAR_VALUES) ) THEN
+         CALL SMUMPS_ASSIGN_SINGULAR_VALUES(
+     &                  mumps_par%SINGULAR_VALUES(1))
+      ELSE
+         CALL SMUMPS_NULLIFY_C_SING_VALUES()
+      ENDIF
       IF ( associated (mumps_par%SYM_PERM) ) THEN
          CALL MUMPS_ASSIGN_SYM_PERM(mumps_par%SYM_PERM(1))
       ELSE
@@ -346,22 +402,47 @@ C
       ELSE
          CALL MUMPS_NULLIFY_C_UNS_PERM()
       ENDIF
-      IF (associated( mumps_par%COLSCA)) THEN
+      IF ( associated (mumps_par%COLSCA_loc) ) THEN
+         CALL SMUMPS_ASSIGN_COLSCA_LOC(1)
+      ELSE
+         CALL SMUMPS_NULLIFY_C_COLSCA_LOC()
+      ENDIF
+      IF ( associated (mumps_par%ROWSCA_loc) ) THEN
+         CALL SMUMPS_ASSIGN_ROWSCA_LOC(1)
+      ELSE
+         CALL SMUMPS_NULLIFY_C_ROWSCA_LOC()
+      ENDIF
+      IF (associated( mumps_par%COLSCA )) THEN
           CALL SMUMPS_ASSIGN_COLSCA(mumps_par%COLSCA(1))
       ELSE
           CALL SMUMPS_NULLIFY_C_COLSCA()
       ENDIF
-      IF (associated( mumps_par%ROWSCA)) THEN
+      IF (associated( mumps_par%ROWSCA )) THEN
           CALL SMUMPS_ASSIGN_ROWSCA(mumps_par%ROWSCA(1))
       ELSE
           CALL SMUMPS_NULLIFY_C_ROWSCA()
       ENDIF
+      IF (associated( mumps_par%RHSINTR )) THEN
+          CALL SMUMPS_ASSIGN_RHSINTR(mumps_par%RHSINTR(1))
+      ELSE
+          CALL SMUMPS_NULLIFY_C_RHSINTR()
+      ENDIF
+      IF (associated(mumps_par%GLOB2LOC_RHS)) THEN
+          CALL MUMPS_ASSIGN_GLOB2LOC_RHS(mumps_par%GLOB2LOC_RHS(1))
+      ELSE
+          CALL MUMPS_NULLIFY_C_GLOB2LOC_RHS()
+      ENDIF
+      IF (associated(mumps_par%GLOB2LOC_SOL)) THEN
+          CALL MUMPS_ASSIGN_GLOB2LOC_SOL(mumps_par%GLOB2LOC_SOL(1))
+      ELSE
+          CALL MUMPS_NULLIFY_C_GLOB2LOC_SOL()
+      ENDIF
       TMPDIRLEN=len_trim(mumps_par%OOC_TMPDIR)
-      DO I=1,OOC_TMPDIR_MAX_LENGTH
+      DO I=1,TMPDIRLEN
          OOC_TMPDIR(I)=ichar(mumps_par%OOC_TMPDIR(I:I))
       ENDDO
       PREFIXLEN=len_trim(mumps_par%OOC_PREFIX)
-      DO I=1,OOC_PREFIX_MAX_LENGTH
+      DO I=1,PREFIXLEN
          OOC_PREFIX(I)=ichar(mumps_par%OOC_PREFIX(I:I))
       ENDDO
       IF ( JOB == -2 ) THEN
diff -pruN 5.6.2-2.1/src/smumps_gpu.c 5.7.1-1/src/smumps_gpu.c
--- 5.6.2-2.1/src/smumps_gpu.c	2023-10-11 09:36:33.000000000 +0000
+++ 5.7.1-1/src/smumps_gpu.c	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/smumps_gpu.h 5.7.1-1/src/smumps_gpu.h
--- 5.6.2-2.1/src/smumps_gpu.h	2023-10-11 09:36:34.000000000 +0000
+++ 5.7.1-1/src/smumps_gpu.h	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/smumps_iXamax.F 5.7.1-1/src/smumps_iXamax.F
--- 5.6.2-2.1/src/smumps_iXamax.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/smumps_iXamax.F	2024-05-02 10:15:25.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/smumps_load.F 5.7.1-1/src/smumps_load.F
--- 5.6.2-2.1/src/smumps_load.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/smumps_load.F	2024-05-02 10:15:25.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -793,7 +793,7 @@ C
          CALL SMUMPS_BUF_BROADCAST( WHAT,
      &        COMM_LD, NPROCS,
      &        FUTURE_NIV2,
-     &        dble(MEMORY_MD),dble(0) ,MYID, id%KEEP, IERR  )
+     &        dble(MEMORY_MD),dble(0) ,MYID, id%KEEP(267), IERR )
          WHAT=9
          MEMORY_SENT = dble(LA-MAX_SURF_MASTER)-MAX_SBTR
      &      - max( dble(LA) * dble(3) / dble(100),
@@ -811,7 +811,7 @@ C
      &        COMM_LD, NPROCS,
      &        FUTURE_NIV2,
      &        MEMORY_SENT,
-     &        dble(0),MYID, id%KEEP, IERR  )
+     &        dble(0),MYID, id%KEEP(267), IERR  )
       ENDIF
       RETURN
       END SUBROUTINE SMUMPS_LOAD_INIT
@@ -1907,7 +1907,7 @@ C
         CALL SMUMPS_BUF_BROADCAST( WHAT,
      &         COMM, SLAVEF,
      &               FUTURE_NIV2,
-     &         COST, dble(0), MYID, KEEP, IERR  )
+     &         COST, dble(0), MYID, KEEP(267), IERR  )
         POOL_LAST_COST_SENT = COST
         POOL_MEM(MYID)=COST
         IF ( IERR == -1 )THEN
@@ -1970,7 +1970,7 @@ C
      &           WHAT, COMM, SLAVEF,
      &           FUTURE_NIV2,
      &           dble(MEM_SUBTREE(INDICE_SBTR)), dble(0),
-     &           MYID, KEEP, IERR  )
+     &           MYID, KEEP(267), IERR  )
             IF ( IERR == -1 )THEN
                CALL SMUMPS_LOAD_RECV_MSGS(COMM_LD)
                CALL MUMPS_CHECK_COMM_NODES(COMM_NODES, EXIT_FLAG)
@@ -2000,7 +2000,7 @@ C
                CALL SMUMPS_BUF_BROADCAST(
      &              WHAT, COMM, SLAVEF,
      &              FUTURE_NIV2,
-     &              COST, dble(0), MYID, KEEP, IERR  )
+     &              COST, dble(0), MYID, KEEP(267), IERR  )
                IF ( IERR == -1 )THEN
                   CALL SMUMPS_LOAD_RECV_MSGS(COMM_LD)
                   CALL MUMPS_CHECK_COMM_NODES(COMM_NODES, EXIT_FLAG)
@@ -4648,10 +4648,8 @@ C
       INTEGER J
       DOUBLE PRECISION MEM_COST
       INTEGER NBINSUBTREE,i,NBTOP
-      EXTERNAL SMUMPS_POOL_EMPTY,
-     & MUMPS_IN_OR_ROOT_SSARBR
-      LOGICAL SMUMPS_POOL_EMPTY,
-     & MUMPS_IN_OR_ROOT_SSARBR
+      EXTERNAL MUMPS_IN_OR_ROOT_SSARBR
+      LOGICAL MUMPS_IN_OR_ROOT_SSARBR
       NBINSUBTREE = POOL(LPOOL)
       NBTOP       = POOL(LPOOL - 1)
       IF(KEEP(47).LT.2)THEN
@@ -4755,8 +4753,6 @@ C
       LOGICAL FLAG, EXIT_FLAG
       DOUBLE PRECISION COST
       DOUBLE PRECISION TO_BE_SENT
-      EXTERNAL MUMPS_TYPENODE
-      INTEGER MUMPS_TYPENODE
       IF(FLAG)THEN
          WHAT=17 
          IF(BDC_M2_FLOPS)THEN
@@ -4783,7 +4779,7 @@ C
      &               FUTURE_NIV2,
      &         COST, 
      &         TO_BE_SENT, 
-     &         MYID, KEEP_LOAD, IERR  )
+     &         MYID, KEEP_LOAD(267), IERR  )
       IF ( IERR == -1 )THEN
          CALL SMUMPS_LOAD_RECV_MSGS(COMM_LD)
          CALL MUMPS_CHECK_COMM_NODES(COMM_NODES, EXIT_FLAG)
@@ -4946,8 +4942,6 @@ C
       RECURSIVE SUBROUTINE SMUMPS_PROCESS_NIV2_MEM_MSG(INODE)
       IMPLICIT NONE
       INTEGER INODE
-      EXTERNAL MUMPS_TYPENODE
-      INTEGER MUMPS_TYPENODE
       IF((INODE.EQ.KEEP_LOAD(20)).OR.
      &     (INODE.EQ.KEEP_LOAD(38)))THEN
          RETURN
@@ -4985,8 +4979,6 @@ C
       RECURSIVE SUBROUTINE SMUMPS_PROCESS_NIV2_FLOPS_MSG(INODE)
       IMPLICIT NONE
       INTEGER INODE
-      EXTERNAL MUMPS_TYPENODE
-      INTEGER MUMPS_TYPENODE
       IF((INODE.EQ.KEEP_LOAD(20)).OR.
      &     (INODE.EQ.KEEP_LOAD(38)))THEN
          RETURN
diff -pruN 5.6.2-2.1/src/smumps_lr_data_m.F 5.7.1-1/src/smumps_lr_data_m.F
--- 5.6.2-2.1/src/smumps_lr_data_m.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/smumps_lr_data_m.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -35,7 +35,9 @@ C
      &  , BLR_STRUC_T, blr_panel_type, diag_block_type
 #endif
      &  , SMUMPS_BLR_SAVE_DIAG_BLOCK, SMUMPS_BLR_RETRIEVE_DIAG_BLOCK
+#if ! defined(NO_SAVE_RESTORE)
      &  , SMUMPS_SAVE_RESTORE_BLR
+#endif      
       TYPE blr_panel_type
          integer                 :: NB_ACCESSES_LEFT
          type(LRB_TYPE), pointer :: LRB_PANEL(:)
@@ -68,6 +70,9 @@ C
      &           PANELS_NOTUSED=-1111, PANELS_FREED=-2222, 
      &           NB_PANELS_NOTINIT=-3333, 
      &           NFS4FATHER_NOTINIT=-4444 )
+#if ! defined(NO_SAVE_RESTORE)
+      INCLUDE 'mumps_save_restore_modes.h'
+#endif
       CONTAINS
       SUBROUTINE SMUMPS_BLR_INIT_MODULE(INITIAL_SIZE, INFO)
        INTEGER, INTENT(IN) :: INITIAL_SIZE
@@ -1062,6 +1067,7 @@ C
        ENDIF
        RETURN
        END SUBROUTINE SMUMPS_BLR_FREE_ALL_PANELS
+#if ! defined(NO_SAVE_RESTORE)
       SUBROUTINE SMUMPS_SAVE_RESTORE_BLR(id_BLRARRAY_ENCODING
      &                 ,unit,MYID,mode
      &                 ,SIZE_GEST,SIZE_VARIABLES
@@ -1072,7 +1078,7 @@ C
       INCLUDE 'mpif.h'
       CHARACTER, DIMENSION(:), POINTER :: id_BLRARRAY_ENCODING
       INTEGER,intent(IN)::unit,MYID
-      CHARACTER(len=*),intent(IN) :: mode
+      INTEGER,intent(IN) :: mode
       INTEGER,INTENT(OUT) :: SIZE_GEST
       INTEGER(8),intent(OUT) :: SIZE_VARIABLES
       INTEGER(8),intent(IN) :: TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
@@ -1090,10 +1096,10 @@ C
       SIZE_VARIABLES_BLR_ARRAY_j1=0_8
       SIZE_GEST=0
       SIZE_VARIABLES=0_8
-      if((trim(mode).EQ."memory_save").OR.(trim(mode).EQ."save")) then
+      if(mode.EQ.memory_save_mode.OR.mode.EQ.save_mode) then
          call SMUMPS_BLR_STRUC_TO_MOD(id_BLRARRAY_ENCODING)
       endif
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          IF(associated(BLR_ARRAY)) THEN
             NbRecords=1
             SIZE_GEST=SIZE_INT
@@ -1101,7 +1107,7 @@ C
             DO j1=1,size(BLR_ARRAY,1)
                CALL SMUMPS_SAVE_RESTORE_BLR_STRUC(
      &              BLR_ARRAY(j1)
-     &              ,unit,MYID,"memory_save"
+     &              ,unit,MYID,memory_save_mode
      &              ,SIZE_GEST_BLR_ARRAY_j1
      &              ,SIZE_VARIABLES_BLR_ARRAY_j1
      &              ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -1118,7 +1124,7 @@ C
             SIZE_GEST=SIZE_INT*2
             SIZE_VARIABLES=0
          ENDIF
-      elseif(trim(mode).EQ."save") then
+      elseif(mode.EQ.save_mode) then
          IF(associated(BLR_ARRAY)) THEN
             NbRecords=1
             SIZE_GEST=SIZE_INT
@@ -1133,7 +1139,7 @@ C
             DO j1=1,size(BLR_ARRAY,1)
                CALL SMUMPS_SAVE_RESTORE_BLR_STRUC(
      &              BLR_ARRAY(j1)
-     &              ,unit,MYID,"save"
+     &              ,unit,MYID,save_mode
      &              ,SIZE_GEST_BLR_ARRAY_j1
      &              ,SIZE_VARIABLES_BLR_ARRAY_j1
      &              ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -1161,7 +1167,7 @@ C
             endif
             IF ( INFO(1) .LT. 0 ) GOTO 100
          ENDIF 
-      elseif(trim(mode).EQ."restore") then
+      elseif(mode.EQ.restore_mode) then
          nullify(BLR_ARRAY)
          read(unit,iostat=err) size_array1
          if(err.ne.0) THEN
@@ -1195,7 +1201,7 @@ C
             DO j1=1,size_array1
                CALL SMUMPS_SAVE_RESTORE_BLR_STRUC(
      &              BLR_ARRAY(j1)
-     &              ,unit,MYID,"restore"
+     &              ,unit,MYID,restore_mode
      &              ,SIZE_GEST_BLR_ARRAY_j1
      &              ,SIZE_VARIABLES_BLR_ARRAY_j1
      &              ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -1209,19 +1215,19 @@ C
             ENDDO
          endif
       endif
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          NbSubRecords=int(SIZE_VARIABLES/huge(I4))
          IF(NbSubRecords.GT.0) then
             NbRecords=NbRecords+NbSubRecords
          ENDIF
-      elseif(trim(mode).EQ."save") then
+      elseif(mode.EQ.save_mode) then
          size_written=size_written+SIZE_VARIABLES
      &        +int(SIZE_GEST,kind=8)
 #if defined(MUMPS_NOF2003)
          size_written=size_written
      &        +int(2*SIZE_INT*NbRecords,kind=8)
 #endif
-      elseif(trim(mode).EQ."restore") then
+      elseif(mode.EQ.restore_mode) then
          size_allocated=size_allocated+SIZE_VARIABLES
          size_read=size_read+SIZE_VARIABLES
      &        +int(SIZE_GEST,kind=8)
@@ -1230,7 +1236,7 @@ C
      &        +int(2*SIZE_INT*NbRecords,kind=8)
 #endif
       endif
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          SIZE_VARIABLES=SIZE_VARIABLES+SIZE_VARIABLES_BLR_ARRAY
          SIZE_GEST=SIZE_GEST+SIZE_GEST_BLR_ARRAY
 #if defined(MUMPS_NOF2003)
@@ -1251,18 +1257,29 @@ C
       INCLUDE 'mpif.h'
       TYPE(BLR_STRUC_T) :: BLR_STRUC
       INTEGER,intent(IN)::unit,MYID
-      CHARACTER(len=*),intent(IN) :: mode
+      INTEGER,intent(IN) :: mode
       INTEGER,INTENT(OUT) :: Local_SIZE_GEST
       INTEGER(8),intent(OUT) :: Local_SIZE_VARIABLES
       INTEGER,intent(INOUT):: INFO(2)
       INTEGER,intent(IN):: SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
       INTEGER(8),intent(IN) :: TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
       INTEGER(8),intent(INOUT):: size_read,size_allocated,size_written
-      INTEGER :: NBVARIABLES_BLR_STRUC_T
-      PARAMETER (NBVARIABLES_BLR_STRUC_T = 15)
-      CHARACTER(len=30), dimension(NBVARIABLES_BLR_STRUC_T)::
-     &     VARIABLES_BLR_STRUC_T
-      CHARACTER(len=30) :: TMP_STRING
+      INTEGER, PARAMETER :: NBVARIABLES_BLR_STRUC_T = 15
+      INTEGER, PARAMETER :: B_IsSYM=1
+      INTEGER, PARAMETER :: B_IsT2=2
+      INTEGER, PARAMETER :: B_IsSLAVE=3
+      INTEGER, PARAMETER :: B_PANELS_L=4
+      INTEGER, PARAMETER :: B_PANELS_U=5
+      INTEGER, PARAMETER :: B_CB_LRB=6
+      INTEGER, PARAMETER :: B_DIAG_BLOCKS=7
+      INTEGER, PARAMETER :: B_BEGS_BLR_STATIC=8
+      INTEGER, PARAMETER :: B_BEGS_BLR_DYNAMIC=9
+      INTEGER, PARAMETER :: B_BEGS_BLR_L=10
+      INTEGER, PARAMETER :: B_BEGS_BLR_COL=11
+      INTEGER, PARAMETER :: B_NB_ACCESSES_INIT=12
+      INTEGER, PARAMETER :: B_NB_PANELS=13
+      INTEGER, PARAMETER :: B_NFS4FATHER=14
+      INTEGER, PARAMETER :: B_M_ARRAY=15
       INTEGER(8),dimension(NBVARIABLES_BLR_STRUC_T)::
      &     SIZE_VARIABLES_BLR_STRUC_T
       INTEGER,dimension(NBVARIABLES_BLR_STRUC_T)::SIZE_GEST_BLR_STRUC_T
@@ -1282,21 +1299,6 @@ C
       INTEGER(8)::SIZE_VARIABLES_DIAG_BLOCKS
       INTEGER(8)::SIZE_VARIABLES_DIAG_BLOCKS_j1
       INTEGER(4)::I4
-      VARIABLES_BLR_STRUC_T(1)="IsSYM"
-      VARIABLES_BLR_STRUC_T(2)="IsT2"
-      VARIABLES_BLR_STRUC_T(3)="IsSLAVE"
-      VARIABLES_BLR_STRUC_T(4)="PANELS_L"
-      VARIABLES_BLR_STRUC_T(5)="PANELS_U"
-      VARIABLES_BLR_STRUC_T(6)="CB_LRB"
-      VARIABLES_BLR_STRUC_T(7)="BEGS_BLR_STATIC"
-      VARIABLES_BLR_STRUC_T(8)="BEGS_BLR_DYNAMIC"
-      VARIABLES_BLR_STRUC_T(9)="BEGS_BLR_L"
-      VARIABLES_BLR_STRUC_T(10)="BEGS_BLR_COL"
-      VARIABLES_BLR_STRUC_T(11)="NB_ACCESSES_INIT"
-      VARIABLES_BLR_STRUC_T(12)="NB_PANELS"
-      VARIABLES_BLR_STRUC_T(13)="DIAG_BLOCKS"
-      VARIABLES_BLR_STRUC_T(14)="NFS4FATHER"
-      VARIABLES_BLR_STRUC_T(15)="M_ARRAY"
       SIZE_VARIABLES_BLR_STRUC_T(:)=0_8
       SIZE_GEST_BLR_STRUC_T(:)=0
       NbRecords_BLR_STRUC_T(:)=0
@@ -1317,13 +1319,12 @@ C
       SIZE_VARIABLES_DIAG_BLOCKS=0_8
       SIZE_VARIABLES_DIAG_BLOCKS_j1=0_8
       DO i1=1,NBVARIABLES_BLR_STRUC_T 
-         TMP_STRING = VARIABLES_BLR_STRUC_T(i1)
-         SELECT CASE(TMP_STRING)
-         CASE("IsSYM")
+         SELECT CASE(i1)
+         CASE(B_IsSYM)
             NbRecords_BLR_STRUC_T(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_LOGICAL
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_LOGICAL
                write(unit,iostat=err) BLR_STRUC%IsSYM
                if(err.ne.0) then
@@ -1332,7 +1333,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_LOGICAL
                read(unit,iostat=err) BLR_STRUC%IsSYM
                if(err.ne.0) THEN
@@ -1342,11 +1343,11 @@ C
                endif 
                IF (INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("IsT2")
+         CASE(B_IsT2)
             NbRecords_BLR_STRUC_T(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_LOGICAL
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_LOGICAL
                write(unit,iostat=err) BLR_STRUC%IsT2
                if(err.ne.0) then
@@ -1355,7 +1356,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_LOGICAL
                read(unit,iostat=err) BLR_STRUC%IsT2
                if(err.ne.0) THEN
@@ -1365,11 +1366,11 @@ C
                endif 
                IF (INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("IsSLAVE")
+         CASE(B_IsSLAVE)
             NbRecords_BLR_STRUC_T(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_LOGICAL
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_LOGICAL
                write(unit,iostat=err) BLR_STRUC%IsSLAVE
                if(err.ne.0) then
@@ -1378,7 +1379,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_LOGICAL
                read(unit,iostat=err) BLR_STRUC%IsSLAVE
                if(err.ne.0) THEN
@@ -1388,9 +1389,9 @@ C
                endif 
                IF (INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("BEGS_BLR_STATIC")
+         CASE(B_BEGS_BLR_STATIC)
             NbRecords_BLR_STRUC_T(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(BLR_STRUC%BEGS_BLR_STATIC)) THEN
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=
@@ -1399,7 +1400,7 @@ C
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*2
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(BLR_STRUC%BEGS_BLR_STATIC)) THEN
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=
@@ -1431,7 +1432,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(BLR_STRUC%BEGS_BLR_STATIC)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -1465,9 +1466,9 @@ C
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("BEGS_BLR_DYNAMIC")
+         CASE(B_BEGS_BLR_DYNAMIC)
             NbRecords_BLR_STRUC_T(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(BLR_STRUC%BEGS_BLR_DYNAMIC)) THEN
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=
@@ -1476,7 +1477,7 @@ C
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*2
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(BLR_STRUC%BEGS_BLR_DYNAMIC)) THEN
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=
@@ -1508,7 +1509,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(BLR_STRUC%BEGS_BLR_DYNAMIC)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -1542,9 +1543,9 @@ C
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("BEGS_BLR_L")
+         CASE(B_BEGS_BLR_L)
             NbRecords_BLR_STRUC_T(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(BLR_STRUC%BEGS_BLR_L)) THEN
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=
@@ -1553,7 +1554,7 @@ C
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*2
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(BLR_STRUC%BEGS_BLR_L)) THEN
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=
@@ -1585,7 +1586,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(BLR_STRUC%BEGS_BLR_L)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -1619,9 +1620,9 @@ C
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("BEGS_BLR_COL")
+         CASE(B_BEGS_BLR_COL)
             NbRecords_BLR_STRUC_T(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(BLR_STRUC%BEGS_BLR_COL)) THEN
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=
@@ -1630,7 +1631,7 @@ C
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*2
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(BLR_STRUC%BEGS_BLR_COL)) THEN
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=
@@ -1662,7 +1663,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(BLR_STRUC%BEGS_BLR_COL)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -1696,11 +1697,11 @@ C
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("NB_ACCESSES_INIT")
+         CASE(B_NB_ACCESSES_INIT)
             NbRecords_BLR_STRUC_T(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_INT
                write(unit,iostat=err) BLR_STRUC%NB_ACCESSES_INIT
                if(err.ne.0) then
@@ -1709,7 +1710,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_INT
                read(unit,iostat=err) BLR_STRUC%NB_ACCESSES_INIT
                if(err.ne.0) THEN
@@ -1719,11 +1720,11 @@ C
                endif 
                IF (INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("NB_PANELS")
+         CASE(B_NB_PANELS)
             NbRecords_BLR_STRUC_T(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_INT
                write(unit,iostat=err) BLR_STRUC%NB_PANELS
                if(err.ne.0) then
@@ -1732,7 +1733,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_INT
                read(unit,iostat=err) BLR_STRUC%NB_PANELS
                if(err.ne.0) THEN
@@ -1742,8 +1743,8 @@ C
                endif 
                IF (INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PANELS_L")
-            if(trim(mode).EQ."memory_save") then
+         CASE(B_PANELS_L)
+            if(mode.EQ.memory_save_mode) then
                IF(associated(BLR_STRUC%PANELS_L)) THEN
                   NbRecords_BLR_STRUC_T(i1)=1
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
@@ -1751,7 +1752,7 @@ C
                   DO j1=1,size(BLR_STRUC%PANELS_L,1)
                      CALL SMUMPS_SAVE_RESTORE_BLR_PANEL(
      &                    BLR_STRUC%PANELS_L(j1)
-     &                    ,unit,MYID,"memory_save"
+     &                    ,unit,MYID,memory_save_mode
      &                    ,SIZE_GEST_PANELS_L_j1
      &                    ,SIZE_VARIABLES_PANELS_L_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -1768,7 +1769,7 @@ C
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*2
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(BLR_STRUC%PANELS_L)) THEN
                   NbRecords_BLR_STRUC_T(i1)=1
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
@@ -1783,7 +1784,7 @@ C
                   DO j1=1,size(BLR_STRUC%PANELS_L,1)
                      CALL SMUMPS_SAVE_RESTORE_BLR_PANEL(
      &                    BLR_STRUC%PANELS_L(j1)
-     &                    ,unit,MYID,"save"
+     &                    ,unit,MYID,save_mode
      &                    ,SIZE_GEST_PANELS_L_j1
      &                    ,SIZE_VARIABLES_PANELS_L_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -1811,7 +1812,7 @@ C
                   endif
                   IF ( INFO(1) .LT. 0 ) GOTO 100
                ENDIF 
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(BLR_STRUC%PANELS_L)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -1846,7 +1847,7 @@ C
                   DO j1=1,size_array1
                      CALL SMUMPS_SAVE_RESTORE_BLR_PANEL(
      &                    BLR_STRUC%PANELS_L(j1)
-     &                    ,unit,MYID,"restore"
+     &                    ,unit,MYID,restore_mode
      &                    ,SIZE_GEST_PANELS_L_j1
      &                    ,SIZE_VARIABLES_PANELS_L_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -1860,8 +1861,8 @@ C
                   ENDDO
                endif
             endif
-            CASE("PANELS_U")
-            if(trim(mode).EQ."memory_save") then
+            CASE(B_PANELS_U)
+            if(mode.EQ.memory_save_mode) then
                IF(associated(BLR_STRUC%PANELS_U)) THEN
                   NbRecords_BLR_STRUC_T(i1)=1
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
@@ -1869,7 +1870,7 @@ C
                   DO j1=1,size(BLR_STRUC%PANELS_U,1)
                      CALL SMUMPS_SAVE_RESTORE_BLR_PANEL(
      &                    BLR_STRUC%PANELS_U(j1)
-     &                    ,unit,MYID,"memory_save"
+     &                    ,unit,MYID,memory_save_mode
      &                    ,SIZE_GEST_PANELS_U_j1
      &                    ,SIZE_VARIABLES_PANELS_U_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -1886,7 +1887,7 @@ C
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*2
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(BLR_STRUC%PANELS_U)) THEN
                   NbRecords_BLR_STRUC_T(i1)=1
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
@@ -1901,7 +1902,7 @@ C
                   DO j1=1,size(BLR_STRUC%PANELS_U,1)
                      CALL SMUMPS_SAVE_RESTORE_BLR_PANEL(
      &                    BLR_STRUC%PANELS_U(j1)
-     &                    ,unit,MYID,"save"
+     &                    ,unit,MYID,save_mode
      &                    ,SIZE_GEST_PANELS_U_j1
      &                    ,SIZE_VARIABLES_PANELS_U_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -1929,7 +1930,7 @@ C
                   endif
                   IF ( INFO(1) .LT. 0 ) GOTO 100
                ENDIF 
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(BLR_STRUC%PANELS_U)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -1964,7 +1965,7 @@ C
                   DO j1=1,size_array1
                      CALL SMUMPS_SAVE_RESTORE_BLR_PANEL(
      &                    BLR_STRUC%PANELS_U(j1)
-     &                    ,unit,MYID,"restore"
+     &                    ,unit,MYID,restore_mode
      &                    ,SIZE_GEST_PANELS_U_j1
      &                    ,SIZE_VARIABLES_PANELS_U_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -1978,8 +1979,8 @@ C
                   ENDDO
                endif
             endif
-         CASE("CB_LRB")
-            if(trim(mode).EQ."memory_save") then
+         CASE(B_CB_LRB)
+            if(mode.EQ.memory_save_mode) then
                IF(associated(BLR_STRUC%CB_LRB)) THEN
                   NbRecords_BLR_STRUC_T(i1)=1
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*2
@@ -1988,7 +1989,7 @@ C
                      DO j2=1,size(BLR_STRUC%CB_LRB,2)
                         CALL SMUMPS_SAVE_RESTORE_LRB(
      &                       BLR_STRUC%CB_LRB(j1,j2)
-     &                       ,unit,MYID,"memory_save"
+     &                       ,unit,MYID,memory_save_mode
      &                       ,SIZE_GEST_CB_LRB_j1j2
      &                       ,SIZE_VARIABLES_CB_LRB_j1j2
      &                       ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -2006,7 +2007,7 @@ C
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*3
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(BLR_STRUC%CB_LRB)) THEN
                   NbRecords_BLR_STRUC_T(i1)=1
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*2
@@ -2022,7 +2023,7 @@ C
                      DO j2=1,size(BLR_STRUC%CB_LRB,2)
                         CALL SMUMPS_SAVE_RESTORE_LRB(
      &                       BLR_STRUC%CB_LRB(j1,j2)
-     &                       ,unit,MYID,"save"
+     &                       ,unit,MYID,save_mode
      &                       ,SIZE_GEST_CB_LRB_j1j2
      &                       ,SIZE_VARIABLES_CB_LRB_j1j2
      &                       ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -2051,7 +2052,7 @@ C
                   endif
                   IF ( INFO(1) .LT. 0 ) GOTO 100
                ENDIF 
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(BLR_STRUC%CB_LRB)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -2087,7 +2088,7 @@ C
                      DO j2=1,size_array2
                         CALL SMUMPS_SAVE_RESTORE_LRB(
      &                       BLR_STRUC%CB_LRB(j1,j2)
-     &                       ,unit,MYID,"restore"
+     &                       ,unit,MYID,restore_mode
      &                       ,SIZE_GEST_CB_LRB_j1j2
      &                       ,SIZE_VARIABLES_CB_LRB_j1j2
      &                       ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -2102,8 +2103,8 @@ C
                   ENDDO
                endif
             endif
-         CASE("DIAG_BLOCKS")
-            if(trim(mode).EQ."memory_save") then
+         CASE(B_DIAG_BLOCKS)
+            if(mode.EQ.memory_save_mode) then
                IF(associated(BLR_STRUC%DIAG_BLOCKS)) THEN
                   NbRecords_BLR_STRUC_T(i1)=1
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
@@ -2111,7 +2112,7 @@ C
                   DO j1=1,size(BLR_STRUC%DIAG_BLOCKS,1)
                      CALL SMUMPS_SAVE_RESTORE_DIAG_BLOCK(
      &                    BLR_STRUC%DIAG_BLOCKS(j1)
-     &                    ,unit,MYID,"memory_save"
+     &                    ,unit,MYID,memory_save_mode
      &                    ,SIZE_GEST_DIAG_BLOCKS_j1
      &                    ,SIZE_VARIABLES_DIAG_BLOCKS_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP
@@ -2129,7 +2130,7 @@ C
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*2
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(BLR_STRUC%DIAG_BLOCKS)) THEN
                   NbRecords_BLR_STRUC_T(i1)=1
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
@@ -2144,7 +2145,7 @@ C
                   DO j1=1,size(BLR_STRUC%DIAG_BLOCKS,1)
                      CALL SMUMPS_SAVE_RESTORE_DIAG_BLOCK(
      &                    BLR_STRUC%DIAG_BLOCKS(j1)
-     &                    ,unit,MYID,"save"
+     &                    ,unit,MYID,save_mode
      &                    ,SIZE_GEST_DIAG_BLOCKS_j1
      &                    ,SIZE_VARIABLES_DIAG_BLOCKS_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP
@@ -2172,7 +2173,7 @@ C
                   endif
                   IF ( INFO(1) .LT. 0 ) GOTO 100
                ENDIF 
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(BLR_STRUC%DIAG_BLOCKS)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -2207,7 +2208,7 @@ C
                   DO j1=1,size_array1
                      CALL SMUMPS_SAVE_RESTORE_DIAG_BLOCK(
      &                    BLR_STRUC%DIAG_BLOCKS(j1)
-     &                    ,unit,MYID,"restore"
+     &                    ,unit,MYID,restore_mode
      &                    ,SIZE_GEST_DIAG_BLOCKS_j1
      &                    ,SIZE_VARIABLES_DIAG_BLOCKS_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP
@@ -2222,11 +2223,11 @@ C
                   ENDDO
                endif
             endif
-         CASE("NFS4FATHER")
+         CASE(B_NFS4FATHER)
             NbRecords_BLR_STRUC_T(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_INT
                write(unit,iostat=err) BLR_STRUC%NFS4FATHER
                if(err.ne.0) then
@@ -2235,7 +2236,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_INT
                read(unit,iostat=err) BLR_STRUC%NFS4FATHER
                if(err.ne.0) THEN
@@ -2245,26 +2246,26 @@ C
                endif 
                IF (INFO(1) .LT. 0 ) GOTO 100
             endif
-            CASE("M_ARRAY")
-               if(trim(mode).EQ."restore") then
+            CASE(B_M_ARRAY)
+               if(mode.EQ.restore_mode) then
                   nullify(BLR_STRUC%M_ARRAY)
                endif
          CASE DEFAULT
          END SELECT
-         if(trim(mode).EQ."memory_save") then
+         if(mode.EQ.memory_save_mode) then
             NbSubRecords=int(SIZE_VARIABLES_BLR_STRUC_T(i1)/huge(I4))
             IF(NbSubRecords.GT.0) then
                NbRecords_BLR_STRUC_T(i1)=NbRecords_BLR_STRUC_T(i1)
      &              +NbSubRecords
             ENDIF
-         elseif(trim(mode).EQ."save") then
+         elseif(mode.EQ.save_mode) then
             size_written=size_written+SIZE_VARIABLES_BLR_STRUC_T(i1)
      &           +int(SIZE_GEST_BLR_STRUC_T(i1),kind=8)
 #if defined(MUMPS_NOF2003)
             size_written=size_written
      &           +int(2*SIZE_INT*NbRecords_BLR_STRUC_T(i1),kind=8)
 #endif
-         elseif(trim(mode).EQ."restore") then
+         elseif(mode.EQ.restore_mode) then
             size_allocated=size_allocated+
      &           SIZE_VARIABLES_BLR_STRUC_T(i1)
             size_read=size_read+SIZE_VARIABLES_BLR_STRUC_T(i1)
@@ -2275,7 +2276,7 @@ C
 #endif
          endif
       ENDDO
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          Local_SIZE_VARIABLES=sum(SIZE_VARIABLES_BLR_STRUC_T)
      &        +SIZE_VARIABLES_PANELS_L
      &        +SIZE_VARIABLES_PANELS_U
@@ -2304,18 +2305,20 @@ C
       INCLUDE 'mpif.h'
       TYPE(LRB_TYPE) :: LRB_T
       INTEGER,intent(IN)::unit,MYID
-      CHARACTER(len=*),intent(IN) :: mode
+      INTEGER,intent(IN) :: mode
       INTEGER,INTENT(OUT) :: Local_SIZE_GEST
       INTEGER(8),intent(OUT) :: Local_SIZE_VARIABLES
       INTEGER,intent(INOUT):: INFO(2)
       INTEGER,intent(IN):: SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
       INTEGER(8),intent(IN) :: TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
       INTEGER(8),intent(INOUT):: size_read,size_allocated,size_written
-      INTEGER :: NBVARIABLES_LRB_TYPE
-      PARAMETER (NBVARIABLES_LRB_TYPE = 6)
-      CHARACTER(len=30), dimension(NBVARIABLES_LRB_TYPE)::
-     &     VARIABLES_LRB_TYPE
-      CHARACTER(len=30) :: TMP_STRING
+      INTEGER, PARAMETER :: LRB_Q=1
+      INTEGER, PARAMETER :: LRB_R=2
+      INTEGER, PARAMETER :: LRB_K=3
+      INTEGER, PARAMETER :: LRB_M=4
+      INTEGER, PARAMETER :: LRB_N=5
+      INTEGER, PARAMETER :: LRB_ISLR=6
+      INTEGER, PARAMETER :: NBVARIABLES_LRB_TYPE=6
       INTEGER(8),dimension(NBVARIABLES_LRB_TYPE)::
      &     SIZE_VARIABLES_LRB_TYPE
       INTEGER,dimension(NBVARIABLES_LRB_TYPE)::
@@ -2328,21 +2331,14 @@ C
       INTEGER:: Local_NbRecords
 #endif
       INTEGER(4) ::I4
-      VARIABLES_LRB_TYPE(1)="Q"
-      VARIABLES_LRB_TYPE(2)="R"
-      VARIABLES_LRB_TYPE(3)="K"
-      VARIABLES_LRB_TYPE(4)="M"
-      VARIABLES_LRB_TYPE(5)="N"
-      VARIABLES_LRB_TYPE(6)="ISLR"
       SIZE_VARIABLES_LRB_TYPE(:)=0_8
       SIZE_GEST_LRB_TYPE(:)=0
       NbRecords_LRB_TYPE(:)=0
       DO i1=1,NBVARIABLES_LRB_TYPE
-         TMP_STRING = VARIABLES_LRB_TYPE(i1)
-         SELECT CASE(TMP_STRING)
-         CASE("Q")
+         SELECT CASE(i1)
+         CASE(LRB_Q)
             NbRecords_LRB_TYPE(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(LRB_T%Q)) THEN
                   SIZE_GEST_LRB_TYPE(i1)=SIZE_INT*2
                   SIZE_VARIABLES_LRB_TYPE(i1)=
@@ -2352,7 +2348,7 @@ C
                   SIZE_GEST_LRB_TYPE(i1)=SIZE_INT*3
                   SIZE_VARIABLES_LRB_TYPE(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(LRB_T%Q)) THEN
                   SIZE_GEST_LRB_TYPE(i1)=SIZE_INT*2
                   SIZE_VARIABLES_LRB_TYPE(i1)=
@@ -2384,7 +2380,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 300
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(LRB_T%Q)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -2419,9 +2415,9 @@ C
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 300
             endif
-         CASE("R")
+         CASE(LRB_R)
             NbRecords_LRB_TYPE(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(LRB_T%R)) THEN
                   SIZE_GEST_LRB_TYPE(i1)=SIZE_INT*2
                   SIZE_VARIABLES_LRB_TYPE(i1)=
@@ -2431,7 +2427,7 @@ C
                   SIZE_GEST_LRB_TYPE(i1)=SIZE_INT*3
                   SIZE_VARIABLES_LRB_TYPE(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(LRB_T%R)) THEN
                   SIZE_GEST_LRB_TYPE(i1)=SIZE_INT*2
                   SIZE_VARIABLES_LRB_TYPE(i1)=
@@ -2463,7 +2459,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 300
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(LRB_T%R)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -2498,11 +2494,11 @@ C
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 300
             endif
-         CASE("K")
+         CASE(LRB_K)
             NbRecords_LRB_TYPE(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_INT
                write(unit,iostat=err) LRB_T%K
                if(err.ne.0) then
@@ -2511,7 +2507,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 300
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_INT
                read(unit,iostat=err) LRB_T%K
                if(err.ne.0) THEN
@@ -2521,11 +2517,11 @@ C
                endif 
                IF ( INFO(1) .LT. 0 ) GOTO 300
             endif
-         CASE("M")
+         CASE(LRB_M)
             NbRecords_LRB_TYPE(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_INT
                write(unit,iostat=err) LRB_T%M
                if(err.ne.0) then
@@ -2534,7 +2530,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 300
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_INT
                read(unit,iostat=err) LRB_T%M
                if(err.ne.0) THEN
@@ -2544,11 +2540,11 @@ C
                endif 
                IF ( INFO(1) .LT. 0 ) GOTO 300
             endif
-         CASE("N")
+         CASE(LRB_N)
             NbRecords_LRB_TYPE(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_INT
                write(unit,iostat=err) LRB_T%N
                if(err.ne.0) then
@@ -2557,7 +2553,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 300
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_INT
                read(unit,iostat=err) LRB_T%N
                if(err.ne.0) THEN
@@ -2567,11 +2563,11 @@ C
                endif 
                IF ( INFO(1) .LT. 0 ) GOTO 300
             endif
-         CASE("ISLR")
+         CASE(LRB_ISLR)
             NbRecords_LRB_TYPE(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_LOGICAL
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_LOGICAL
                write(unit,iostat=err) LRB_T%ISLR
                if(err.ne.0) then
@@ -2580,7 +2576,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 300
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_LOGICAL
                read(unit,iostat=err) LRB_T%ISLR
                if(err.ne.0) THEN
@@ -2592,21 +2588,21 @@ C
             endif   
          CASE DEFAULT
          END SELECT
-         if(trim(mode).EQ."memory_save") then
+         if(mode.EQ.memory_save_mode) then
             NbSubRecords=int(SIZE_VARIABLES_LRB_TYPE(i1)/huge(I4))
             IF(NbSubRecords.GT.0) then
                NbRecords_LRB_TYPE(i1)=
      &              NbRecords_LRB_TYPE(i1)
      &              +NbSubRecords
             ENDIF
-         elseif(trim(mode).EQ."save") then
+         elseif(mode.EQ.save_mode) then
             size_written=size_written+SIZE_VARIABLES_LRB_TYPE(i1)
      &           +int(SIZE_GEST_LRB_TYPE(i1),kind=8)
 #if defined(MUMPS_NOF2003)
             size_written=size_written
      &           +int(2*SIZE_INT*NbRecords_LRB_TYPE(i1),kind=8)
 #endif
-         elseif(trim(mode).EQ."restore") then
+         elseif(mode.EQ.restore_mode) then
             size_allocated=size_allocated+
      &           SIZE_VARIABLES_LRB_TYPE(i1)
             size_read=size_read+SIZE_VARIABLES_LRB_TYPE(i1)
@@ -2617,7 +2613,7 @@ C
 #endif
          endif
       ENDDO
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          Local_SIZE_VARIABLES=sum(SIZE_VARIABLES_LRB_TYPE)
          Local_SIZE_GEST=sum(SIZE_GEST_LRB_TYPE)
 #if defined(MUMPS_NOF2003)
@@ -2638,18 +2634,16 @@ C
       INCLUDE 'mpif.h'
       TYPE(blr_panel_type) :: BLR_PANEL_T
       INTEGER,intent(IN)::unit,MYID
-      CHARACTER(len=*),intent(IN) :: mode
+      INTEGER,intent(IN) :: mode
       INTEGER,INTENT(OUT) :: Local_SIZE_GEST
       INTEGER(8),intent(OUT) :: Local_SIZE_VARIABLES
       INTEGER,intent(INOUT):: INFO(2)
       INTEGER,intent(IN):: SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
       INTEGER(8),intent(IN) :: TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
       INTEGER(8),intent(INOUT):: size_read,size_allocated,size_written
-      INTEGER :: NBVARIABLES_BLR_PANEL_TYPE
-      PARAMETER (NBVARIABLES_BLR_PANEL_TYPE = 2)
-      CHARACTER(len=30), dimension(NBVARIABLES_BLR_PANEL_TYPE)::
-     &     VARIABLES_BLR_PANEL_TYPE
-      CHARACTER(len=30) :: TMP_STRING
+      INTEGER, PARAMETER :: P_NB_ACCESSES_LEFT=1
+      INTEGER, PARAMETER :: P_LRB_PANEL=2
+      INTEGER, PARAMETER :: NBVARIABLES_BLR_PANEL_TYPE = 2
       INTEGER(8),dimension(NBVARIABLES_BLR_PANEL_TYPE)::
      &     SIZE_VARIABLES_BLR_PANEL_TYPE
       INTEGER,dimension(NBVARIABLES_BLR_PANEL_TYPE)::
@@ -2664,8 +2658,6 @@ C
       INTEGER:: SIZE_GEST_LRB_PANEL_j1,SIZE_GEST_LRB_PANEL
       INTEGER(8)::SIZE_VARIABLES_LRB_PANEL_j1,SIZE_VARIABLES_LRB_PANEL
       INTEGER(4)::I4
-      VARIABLES_BLR_PANEL_TYPE(1)="NB_ACCESSES_LEFT"
-      VARIABLES_BLR_PANEL_TYPE(2)="LRB_PANEL"
       SIZE_VARIABLES_BLR_PANEL_TYPE(:)=0_8
       SIZE_GEST_BLR_PANEL_TYPE(:)=0
       NbRecords_BLR_PANEL_TYPE(:)=0
@@ -2674,13 +2666,12 @@ C
       SIZE_VARIABLES_LRB_PANEL_j1=0_8
       SIZE_VARIABLES_LRB_PANEL=0_8
       DO i1=1,NBVARIABLES_BLR_PANEL_TYPE
-         TMP_STRING = VARIABLES_BLR_PANEL_TYPE(i1)
-         SELECT CASE(TMP_STRING)
-         CASE("NB_ACCESSES_LEFT")
+         SELECT CASE(i1)
+         CASE(P_NB_ACCESSES_LEFT)
             NbRecords_BLR_PANEL_TYPE(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_BLR_PANEL_TYPE(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_BLR_PANEL_TYPE(i1)=SIZE_INT
                write(unit,iostat=err) BLR_PANEL_T%NB_ACCESSES_LEFT
                if(err.ne.0) then
@@ -2689,7 +2680,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 400
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_BLR_PANEL_TYPE(i1)=SIZE_INT
                read(unit,iostat=err) BLR_PANEL_T%NB_ACCESSES_LEFT
                if(err.ne.0) THEN
@@ -2699,8 +2690,8 @@ C
                endif 
                IF ( INFO(1) .LT. 0 ) GOTO 400
             endif
-         CASE("LRB_PANEL")
-            if(trim(mode).EQ."memory_save") then
+         CASE(P_LRB_PANEL)
+            if(mode.EQ.memory_save_mode) then
                IF(associated(BLR_PANEL_T%LRB_PANEL)) THEN
                   NbRecords_BLR_PANEL_TYPE(i1)=1
                   SIZE_GEST_BLR_PANEL_TYPE(i1)=SIZE_INT
@@ -2708,7 +2699,7 @@ C
                   DO j1=1,size(BLR_PANEL_T%LRB_PANEL,1)
                      CALL SMUMPS_SAVE_RESTORE_LRB(
      &                    BLR_PANEL_T%LRB_PANEL(j1)
-     &                    ,unit,MYID,"memory_save"
+     &                    ,unit,MYID,memory_save_mode
      &                    ,SIZE_GEST_LRB_PANEL_j1
      &                    ,SIZE_VARIABLES_LRB_PANEL_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -2725,7 +2716,7 @@ C
                   SIZE_GEST_BLR_PANEL_TYPE(i1)=SIZE_INT*2
                   SIZE_VARIABLES_BLR_PANEL_TYPE(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(BLR_PANEL_T%LRB_PANEL)) THEN
                   NbRecords_BLR_PANEL_TYPE(i1)=1
                   SIZE_GEST_BLR_PANEL_TYPE(i1)=SIZE_INT
@@ -2740,7 +2731,7 @@ C
                   DO j1=1,size(BLR_PANEL_T%LRB_PANEL,1)
                      CALL SMUMPS_SAVE_RESTORE_LRB(
      &                    BLR_PANEL_T%LRB_PANEL(j1)
-     &                    ,unit,MYID,"save"
+     &                    ,unit,MYID,save_mode
      &                    ,SIZE_GEST_LRB_PANEL_j1
      &                    ,SIZE_VARIABLES_LRB_PANEL_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -2768,7 +2759,7 @@ C
                   endif
                   IF ( INFO(1) .LT. 0 ) GOTO 400
                ENDIF 
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(BLR_PANEL_T%LRB_PANEL)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -2803,7 +2794,7 @@ C
                   DO j1=1,size_array1
                      CALL SMUMPS_SAVE_RESTORE_LRB(
      &                    BLR_PANEL_T%LRB_PANEL(j1)
-     &                    ,unit,MYID,"restore"
+     &                    ,unit,MYID,restore_mode
      &                    ,SIZE_GEST_LRB_PANEL_j1
      &                    ,SIZE_VARIABLES_LRB_PANEL_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -2819,21 +2810,21 @@ C
             endif
          CASE DEFAULT
          END SELECT
-         if(trim(mode).EQ."memory_save") then
+         if(mode.EQ.memory_save_mode) then
             NbSubRecords=int(SIZE_VARIABLES_BLR_PANEL_TYPE(i1)/huge(I4))
             IF(NbSubRecords.GT.0) then
                NbRecords_BLR_PANEL_TYPE(i1)=
      &              NbRecords_BLR_PANEL_TYPE(i1)
      &              +NbSubRecords
             ENDIF
-         elseif(trim(mode).EQ."save") then
+         elseif(mode.EQ.save_mode) then
             size_written=size_written+SIZE_VARIABLES_BLR_PANEL_TYPE(i1)
      &           +int(SIZE_GEST_BLR_PANEL_TYPE(i1),kind=8)
 #if defined(MUMPS_NOF2003)
             size_written=size_written
      &           +int(2*SIZE_INT*NbRecords_BLR_PANEL_TYPE(i1),kind=8)
 #endif
-         elseif(trim(mode).EQ."restore") then
+         elseif(mode.EQ.restore_mode) then
             size_allocated=size_allocated+
      &           SIZE_VARIABLES_BLR_PANEL_TYPE(i1)
             size_read=size_read+SIZE_VARIABLES_BLR_PANEL_TYPE(i1)
@@ -2844,7 +2835,7 @@ C
 #endif
          endif
       ENDDO
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          Local_SIZE_VARIABLES=sum(SIZE_VARIABLES_BLR_PANEL_TYPE)+
      &        SIZE_VARIABLES_LRB_PANEL
          Local_SIZE_GEST=sum(SIZE_GEST_BLR_PANEL_TYPE)+
@@ -2867,18 +2858,15 @@ C
       INCLUDE 'mpif.h'
       TYPE(diag_block_type) :: DIAG_BLOCK_T
       INTEGER,intent(IN)::unit,MYID
-      CHARACTER(len=*),intent(IN) :: mode
+      INTEGER,intent(IN) :: mode
       INTEGER,INTENT(OUT) :: Local_SIZE_GEST
       INTEGER(8),intent(OUT) :: Local_SIZE_VARIABLES
       INTEGER,intent(INOUT):: INFO(2)
       INTEGER,intent(IN):: SIZE_INT, SIZE_ARITH_DEP
       INTEGER(8),intent(IN) :: TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
       INTEGER(8),intent(INOUT):: size_read,size_allocated,size_written
-      INTEGER :: NBVARIABLES_DIAG_BLOCK_TYPE
-      PARAMETER (NBVARIABLES_DIAG_BLOCK_TYPE = 1)
-      CHARACTER(len=30), dimension(NBVARIABLES_DIAG_BLOCK_TYPE)::
-     &     VARIABLES_DIAG_BLOCK_TYPE
-      CHARACTER(len=30) :: TMP_STRING
+      INTEGER, PARAMETER :: D_DIAG_BLOCK=1
+      INTEGER, PARAMETER :: NBVARIABLES_DIAG_BLOCK_TYPE = 1
       INTEGER(8),dimension(NBVARIABLES_DIAG_BLOCK_TYPE)::
      &     SIZE_VARIABLES_DIAG_BLOCK_TYPE
       INTEGER,dimension(NBVARIABLES_DIAG_BLOCK_TYPE)::
@@ -2891,16 +2879,14 @@ C
       INTEGER:: Local_NbRecords
 #endif
       INTEGER(4) :: I4
-      VARIABLES_DIAG_BLOCK_TYPE(1)="DIAG_BLOCK"
       SIZE_VARIABLES_DIAG_BLOCK_TYPE(:)=0_8
       SIZE_GEST_DIAG_BLOCK_TYPE(:)=0
       NbRecords_DIAG_BLOCK_TYPE(:)=0
       DO i1=1,NBVARIABLES_DIAG_BLOCK_TYPE
-         TMP_STRING = VARIABLES_DIAG_BLOCK_TYPE(i1)
-         SELECT CASE(TMP_STRING)
-         CASE("DIAG_BLOCK")
+         SELECT CASE(i1)
+         CASE(D_DIAG_BLOCK)
             NbRecords_DIAG_BLOCK_TYPE(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(DIAG_BLOCK_T%DIAG_BLOCK)) THEN
                   SIZE_GEST_DIAG_BLOCK_TYPE(i1)=SIZE_INT
                   SIZE_VARIABLES_DIAG_BLOCK_TYPE(i1)=
@@ -2910,7 +2896,7 @@ C
                   SIZE_GEST_DIAG_BLOCK_TYPE(i1)=SIZE_INT*2
                   SIZE_VARIABLES_DIAG_BLOCK_TYPE(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(DIAG_BLOCK_T%DIAG_BLOCK)) THEN
                   SIZE_GEST_DIAG_BLOCK_TYPE(i1)=SIZE_INT
                   SIZE_VARIABLES_DIAG_BLOCK_TYPE(i1)=
@@ -2942,7 +2928,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 200
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(DIAG_BLOCK_T%DIAG_BLOCK)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -2979,7 +2965,7 @@ C
             endif
          CASE DEFAULT
          END SELECT
-         if(trim(mode).EQ."memory_save") then
+         if(mode.EQ.memory_save_mode) then
             NbSubRecords=int(SIZE_VARIABLES_DIAG_BLOCK_TYPE(i1)/
      &      huge(I4))
             IF(NbSubRecords.GT.0) then
@@ -2987,14 +2973,14 @@ C
      &              NbRecords_DIAG_BLOCK_TYPE(i1)
      &              +NbSubRecords
             ENDIF
-         elseif(trim(mode).EQ."save") then
+         elseif(mode.EQ.save_mode) then
             size_written=size_written+SIZE_VARIABLES_DIAG_BLOCK_TYPE(i1)
      &           +int(SIZE_GEST_DIAG_BLOCK_TYPE(i1),kind=8)
 #if defined(MUMPS_NOF2003)
             size_written=size_written
      &           +int(2*SIZE_INT*NbRecords_DIAG_BLOCK_TYPE(i1),kind=8)
 #endif
-         elseif(trim(mode).EQ."restore") then
+         elseif(mode.EQ.restore_mode) then
             size_allocated=size_allocated+
      &           SIZE_VARIABLES_DIAG_BLOCK_TYPE(i1)
             size_read=size_read+SIZE_VARIABLES_DIAG_BLOCK_TYPE(i1)
@@ -3005,7 +2991,7 @@ C
 #endif
          endif
       ENDDO
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          Local_SIZE_VARIABLES=sum(SIZE_VARIABLES_DIAG_BLOCK_TYPE)
          Local_SIZE_GEST=sum(SIZE_GEST_DIAG_BLOCK_TYPE)
 #if defined(MUMPS_NOF2003)
@@ -3016,4 +3002,5 @@ C
  200  continue
       RETURN
       END SUBROUTINE SMUMPS_SAVE_RESTORE_DIAG_BLOCK
+#endif
       END MODULE SMUMPS_LR_DATA_M
diff -pruN 5.6.2-2.1/src/smumps_mpi3_mod.F 5.7.1-1/src/smumps_mpi3_mod.F
--- 5.6.2-2.1/src/smumps_mpi3_mod.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/smumps_mpi3_mod.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/smumps_ooc.F 5.7.1-1/src/smumps_ooc.F
--- 5.6.2-2.1/src/smumps_ooc.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/smumps_ooc.F	2024-05-02 10:15:25.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -17,6 +17,7 @@ C
 !$   &                    OMP_INIT_LOCK, OMP_DESTROY_LOCK, OMP_TEST_LOCK
       IMPLICIT NONE
 !$     INTEGER(KIND=OMP_LOCK_KIND) :: LOCK_FOR_L0OMP
+      INTEGER, PARAMETER :: FILENAMELENGTH=1300
       INTEGER NOT_IN_MEM,BEING_READ,NOT_USED,PERMUTED,USED,
      &     USED_NOT_PERMUTED,ALREADY_USED
       PARAMETER (NOT_IN_MEM=0,BEING_READ=-1,NOT_USED=-2,
@@ -44,7 +45,6 @@ C
      &     ,NB_CALLED,REQ_ACT,NB_CALL
       INTEGER(8), SAVE :: OOC_VADDR_PTR
       INTEGER(8), SAVE :: SIZE_ZONE_REQ
-      DOUBLE PRECISION,SAVE :: MAX_OOC_FILE_SIZE
       INTEGER(8), DIMENSION(:), ALLOCATABLE :: SIZE_OF_READ, READ_DEST
       INTEGER,DIMENSION(:),ALLOCATABLE :: FIRST_POS_IN_READ,
      &     READ_MNG,REQ_TO_ZONE,POS_HOLE_T,
@@ -114,18 +114,16 @@ C
       USE SMUMPS_STRUC_DEF
       USE SMUMPS_OOC_BUFFER
       IMPLICIT NONE
-      INTEGER TMPDIR_MAX_LENGTH, PREFIX_MAX_LENGTH
-      PARAMETER (TMPDIR_MAX_LENGTH=255, PREFIX_MAX_LENGTH=63)
+      INTEGER OOC_TMPDIR_MAX_LENGTH, OOC_PREFIX_MAX_LENGTH
+      PARAMETER (OOC_TMPDIR_MAX_LENGTH=1023, OOC_PREFIX_MAX_LENGTH=255)
       INTEGER(8), intent(in) :: MAXS  
       TYPE(SMUMPS_STRUC), TARGET :: id
       INTEGER IERR
       INTEGER allocok
-      CHARACTER(len=1):: TMP_DIR(TMPDIR_MAX_LENGTH),
-     &            TMP_PREFIX(PREFIX_MAX_LENGTH)
-      INTEGER DIM_DIR,DIM_PREFIX
+      INTEGER DIM_TMPDIR,DIM_PREFIX
       INTEGER, DIMENSION(:), ALLOCATABLE :: FILE_FLAG_TAB
       INTEGER TMP
-      INTEGER K211_LOC
+      INTEGER KEEP211_LOC
       ICNTL1=id%ICNTL(1)
       MAX_SIZE_FACTOR_OOC=0_8
       N_OOC=id%N
@@ -234,14 +232,10 @@ C
       ENDIF
       DIM_ERR_STR_OOC = ERR_STR_OOC_MAX_LEN
       CALL MUMPS_LOW_LEVEL_INIT_ERR_STR(DIM_ERR_STR_OOC,ERR_STR_OOC)
-      DIM_DIR=len(trim(id%OOC_TMPDIR))
+      DIM_TMPDIR=len(trim(id%OOC_TMPDIR))
       DIM_PREFIX=len(trim(id%OOC_PREFIX))
-      CALL SMUMPS_CONVERT_STR_TO_CHR_ARRAY(TMP_DIR(1),
-     &     id%OOC_TMPDIR, TMPDIR_MAX_LENGTH, DIM_DIR )
-      CALL SMUMPS_CONVERT_STR_TO_CHR_ARRAY(TMP_PREFIX(1),
-     &     id%OOC_PREFIX, PREFIX_MAX_LENGTH, DIM_PREFIX)
-      CALL MUMPS_LOW_LEVEL_INIT_PREFIX(DIM_PREFIX, TMP_PREFIX)
-      CALL MUMPS_LOW_LEVEL_INIT_TMPDIR(DIM_DIR, TMP_DIR)
+      CALL MUMPS_LOW_LEVEL_INIT_PREFIX(DIM_PREFIX, id%OOC_PREFIX)
+      CALL MUMPS_LOW_LEVEL_INIT_TMPDIR(DIM_TMPDIR, id%OOC_TMPDIR)
       ALLOCATE(FILE_FLAG_TAB(OOC_NB_FILE_TYPE),
      &     stat=allocok)
       IF (allocok .GT. 0) THEN
@@ -260,8 +254,8 @@ C
          TMP=max(1,TMP/2)
       ENDIF
       CALL MUMPS_LOW_LEVEL_INIT_OOC_C(MYID_OOC,TMP,
-     &     id%KEEP(35),LOW_LEVEL_STRAT_IO,K211_LOC,OOC_NB_FILE_TYPE,
-     &     FILE_FLAG_TAB,IERR)
+     &     id%KEEP(35),LOW_LEVEL_STRAT_IO,KEEP211_LOC,OOC_NB_FILE_TYPE,
+     &     FILE_FLAG_TAB,id%KEEP(255),IERR)
       IF(IERR.LT.0)THEN
          IF (ICNTL1 .GT. 0 ) THEN
            WRITE(ICNTL1,*)MYID_OOC,': PB in MUMPS_LOW_LEVEL_INIT_OOC_C'
@@ -271,7 +265,6 @@ C
          id%INFO(2) = 0
          RETURN
       ENDIF
-      CALL MUMPS_GET_MAX_FILE_SIZE_C(MAX_OOC_FILE_SIZE)
       DEALLOCATE(FILE_FLAG_TAB)
       RETURN
       END SUBROUTINE SMUMPS_OOC_INIT_FACTO
@@ -506,7 +499,7 @@ C
       TYPE(SMUMPS_STRUC), TARGET :: id
       INTEGER IERR
       INTEGER I,J,I1,K
-      CHARACTER(len=1):: TMP_NAME(350)
+      CHARACTER(len=1):: TMP_NAME(FILENAMELENGTH)
       IERR=0
       K=1
       IF(.NOT. id%ASSOCIATED_OOC_FILES) THEN
@@ -1367,7 +1360,9 @@ C
       IMPLICIT NONE
       INTEGER INODE
       IF ( (KEEP_OOC(237).EQ.0)
-     &     .AND. (KEEP_OOC(235).EQ.0) ) THEN
+     &     .AND. (KEEP_OOC(235).EQ.0) 
+     &     .AND. (KEEP_OOC(212).EQ.0)
+     &   ) THEN
       IF(OOC_STATE_NODE(STEP_OOC(INODE)).NE.NOT_USED)THEN
          WRITE(*,*)MYID_OOC,': INTERNAL ERROR (51) in OOC',INODE,
      &        OOC_STATE_NODE(STEP_OOC(INODE))
@@ -2618,7 +2613,8 @@ C
                  SET_POS_SEQUENCE = .FALSE.
                  CUR_POS_SEQUENCE = I
                ENDIF
-               IF (KEEP_OOC(237).EQ.0 .AND. KEEP_OOC(235).EQ.0) THEN
+               IF (KEEP_OOC(237).EQ.0 .AND. KEEP_OOC(235).EQ.0
+     &              .AND. KEEP_OOC(212).EQ.0 ) THEN
                  OOC_STATE_NODE(STEP_OOC(J)) = NOT_IN_MEM
                ENDIF
                CYCLE
@@ -2638,7 +2634,8 @@ C
                         CALL MUMPS_ABORT()
                      ENDIF                     
                   ENDIF
-                 IF (KEEP_OOC(237).NE.0 .OR. KEEP_OOC(235).NE.0) 
+                 IF (KEEP_OOC(237).NE.0 .OR. KEEP_OOC(235).NE.0
+     &               .OR.  KEEP_OOC(212).NE.0 ) 
      &              THEN
                   IF (OOC_STATE_NODE(STEP_OOC(J)).EQ.NOT_IN_MEM) THEN
                      OOC_STATE_NODE(STEP_OOC(J)) = USED
@@ -2657,13 +2654,15 @@ C
                     CALL MUMPS_ABORT()
                   ENDIF
                  ENDIF
-                 IF (KEEP_OOC(237).EQ.0 .AND. KEEP_OOC(235).EQ.0) THEN
+                 IF (KEEP_OOC(237).EQ.0 .AND. KEEP_OOC(235).EQ.0
+     &               .AND. KEEP_OOC(212).EQ.0 ) THEN
                     CALL SMUMPS_SOLVE_UPD_NODE_INFO(J,PTRFAC,NSTEPS)
                  ENDIF
                ENDIF
             ENDIF 
       ENDDO
-         IF (KEEP_OOC(237).NE.0 .OR. KEEP_OOC(235).NE.0) 
+         IF (KEEP_OOC(237).NE.0 .OR. KEEP_OOC(235).NE.0 .OR.
+     &       KEEP_OOC(212).NE.0 ) 
      &      THEN
            IF (COMPRESS_TO_BE_DONE) THEN 
              DO ZONE=1,NB_Z-1
@@ -2789,7 +2788,7 @@ C
       TYPE(SMUMPS_STRUC), TARGET :: id
       INTEGER, intent(out) :: IERR
       INTEGER I,DIM,J,TMP,SIZE,K,I1
-      CHARACTER(len=1):: TMP_NAME(350)
+      CHARACTER(len=1):: TMP_NAME(FILENAMELENGTH)
       EXTERNAL MUMPS_OOC_GET_NB_FILES_C, MUMPS_OOC_GET_FILE_NAME_C
       IERR=0
       SIZE=0
@@ -2803,7 +2802,7 @@ C
          DEALLOCATE(id%OOC_FILE_NAMES)
          NULLIFY(id%OOC_FILE_NAMES)
       ENDIF
-      ALLOCATE(id%OOC_FILE_NAMES(SIZE,350),stat=IERR)
+      ALLOCATE(id%OOC_FILE_NAMES(SIZE,FILENAMELENGTH),stat=IERR)
       IF (IERR .GT. 0) THEN
          IF (ICNTL1.GT.0) THEN
             WRITE(ICNTL1,*) 'PB allocation in ',
@@ -2812,7 +2811,7 @@ C
          IERR=-1
          IF(id%INFO(1).GE.0)THEN
             id%INFO(1) = -13
-            id%INFO(2) = SIZE*350
+            id%INFO(2) = SIZE*FILENAMELENGTH
             RETURN
          ENDIF
       ENDIF
@@ -2850,10 +2849,9 @@ C
       USE SMUMPS_STRUC_DEF
       IMPLICIT NONE
       TYPE(SMUMPS_STRUC), TARGET :: id
-      CHARACTER(len=1):: TMP_NAME(350)
+      CHARACTER(len=1):: TMP_NAME(FILENAMELENGTH)
       INTEGER I,I1,TMP,J,K,L,DIM,IERR
       INTEGER, DIMENSION(:),ALLOCATABLE :: NB_FILES
-      INTEGER K211
       ALLOCATE(NB_FILES(OOC_NB_FILE_TYPE),stat=IERR)
       IF (IERR .GT. 0) THEN
          IERR=-1
@@ -2872,7 +2870,6 @@ C
       I=id%MYID
       K=id%KEEP(35)
       L=mod(id%KEEP(204),3)
-      K211=id%KEEP(211)
       CALL MUMPS_OOC_ALLOC_POINTERS_C(OOC_NB_FILE_TYPE,NB_FILES,IERR)
       IF(IERR.LT.0)THEN
          IF (ICNTL1.GT.0)
@@ -2880,7 +2877,7 @@ C
          id%INFO(1)=IERR
          RETURN
       ENDIF
-      CALL MUMPS_OOC_INIT_VARS_C(I,K,L,K211,IERR)
+      CALL MUMPS_OOC_INIT_VARS_C(I,K,L,id%KEEP(211),id%KEEP(255),IERR)
       IF(IERR.LT.0)THEN
          IF (ICNTL1.GT.0)
      &   WRITE(ICNTL1,*)MYID_OOC,': ',ERR_STR_OOC(1:DIM_ERR_STR_OOC)
@@ -2916,16 +2913,6 @@ C
       DEALLOCATE(NB_FILES)
       RETURN
       END SUBROUTINE SMUMPS_OOC_OPEN_FILES_FOR_SOLVE      
-      SUBROUTINE SMUMPS_CONVERT_STR_TO_CHR_ARRAY(DEST,SRC,NB,NB_EFF)
-      IMPLICIT NONE
-      INTEGER NB, NB_EFF
-      CHARACTER(LEN=NB):: SRC
-      CHARACTER(len=1):: DEST(NB)
-      INTEGER I
-      DO I=1,NB_EFF
-         DEST(I)=SRC(I:I)
-      ENDDO
-      END SUBROUTINE SMUMPS_CONVERT_STR_TO_CHR_ARRAY
       SUBROUTINE SMUMPS_FORCE_WRITE_BUF(IERR)
       USE SMUMPS_OOC_BUFFER
       IMPLICIT NONE
diff -pruN 5.6.2-2.1/src/smumps_ooc_buffer.F 5.7.1-1/src/smumps_ooc_buffer.F
--- 5.6.2-2.1/src/smumps_ooc_buffer.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/smumps_ooc_buffer.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/smumps_save_restore.F 5.7.1-1/src/smumps_save_restore.F
--- 5.6.2-2.1/src/smumps_save_restore.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/smumps_save_restore.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -11,15 +11,18 @@ C  released under the CeCILL-C license
 C  (see doc/CeCILL-C_V1-en.txt, doc/CeCILL-C_V1-fr.txt, and
 C  https://cecill.info/licences/Licence_CeCILL-C_V1-en.html)
 C
+#if ! defined(NO_SAVE_RESTORE)
       MODULE SMUMPS_SAVE_RESTORE
       USE SMUMPS_STRUC_DEF
       USE SMUMPS_SAVE_RESTORE_FILES
       USE SMUMPS_LR_DATA_M
       USE MUMPS_FRONT_DATA_MGT_M
       IMPLICIT NONE
+      INCLUDE 'mumps_save_restore_modes.h'
       CONTAINS
       SUBROUTINE SMUMPS_REMOVE_SAVED(id)
-      USE SMUMPS_OOC
+      USE SMUMPS_OOC 
+      IMPLICIT NONE
       INCLUDE 'mpif.h'
       INTEGER MASTER
       PARAMETER ( MASTER = 0 )
@@ -151,6 +154,7 @@ C
       RETURN
       END SUBROUTINE SMUMPS_REMOVE_SAVED
       SUBROUTINE SMUMPS_RESTORE_OOC(localid)
+      IMPLICIT NONE
       INCLUDE 'mpif.h'
       INTEGER::ierr,IN,NBVARIABLES,NBVARIABLES_ROOT
       CHARACTER(len=LEN_SAVE_FILE):: restore_file_ooc,INFO_FILE
@@ -161,7 +165,7 @@ C
       INTEGER:: INFO1,INFO2,INFOG1,INFOG2,allocok
       INTEGER(8) :: TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
       TYPE (SMUMPS_STRUC) :: localid
-      NBVARIABLES=188
+      NBVARIABLES=194
       NBVARIABLES_ROOT=33
       allocate(SIZE_VARIABLES(NBVARIABLES),  stat=allocok)
       if (allocok .GT. 0) THEN
@@ -227,7 +231,7 @@ C
       CALL MUMPS_PROPINFO( localid%ICNTL(1), localid%INFO(1),
      &     localid%COMM, localid%MYID )
       IF ( localid%INFO(1) .LT. 0 ) RETURN
-      CALL SMUMPS_SAVE_RESTORE_STRUCTURE(localid,IN,"restore_ooc"
+      CALL SMUMPS_SAVE_RESTORE_STRUCTURE(localid,IN,restore_ooc_mode
      &     ,NBVARIABLES,SIZE_VARIABLES,SIZE_GEST
      &     ,NBVARIABLES_ROOT,SIZE_VARIABLES_ROOT,SIZE_GEST_ROOT
      &     ,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
@@ -239,6 +243,7 @@ C
       END SUBROUTINE SMUMPS_RESTORE_OOC
       SUBROUTINE SMUMPS_COMPUTE_MEMORY_SAVE(id,
      &     TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE)
+      IMPLICIT NONE
       INCLUDE 'mpif.h'
       INTEGER::NBVARIABLES,NBVARIABLES_ROOT
       INTEGER(8),allocatable, dimension(:)::SIZE_VARIABLES
@@ -248,7 +253,7 @@ C
       INTEGER :: INFO1,INFO2,INFOG1,INFOG2,allocok
       INTEGER(8) :: TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
       TYPE (SMUMPS_STRUC) :: id
-      NBVARIABLES=188
+      NBVARIABLES=194
       NBVARIABLES_ROOT=33
       allocate(SIZE_VARIABLES(NBVARIABLES),  stat=allocok)
       if (allocok .GT. 0) THEN
@@ -292,7 +297,7 @@ C
       INFO2 = -999
       INFOG1 = -999
       INFOG2 = -999
-      CALL SMUMPS_SAVE_RESTORE_STRUCTURE(id,0,"memory_save"
+      CALL SMUMPS_SAVE_RESTORE_STRUCTURE(id,0,memory_save_mode
      &     ,NBVARIABLES,SIZE_VARIABLES,SIZE_GEST
      &     ,NBVARIABLES_ROOT,SIZE_VARIABLES_ROOT,SIZE_GEST_ROOT
      &     ,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
@@ -302,6 +307,7 @@ C
       RETURN
       END SUBROUTINE SMUMPS_COMPUTE_MEMORY_SAVE
       SUBROUTINE SMUMPS_SAVE(id)
+      IMPLICIT NONE
       INCLUDE 'mpif.h'
       INTEGER::ierr,OUT,NBVARIABLES,NBVARIABLES_ROOT,OUTINFO
       CHARACTER(len=LEN_SAVE_FILE):: SAVE_FILE,INFO_FILE
@@ -326,7 +332,7 @@ C
       id%INFOG(2)=0
       MPG= id%ICNTL(3)
       PROKG   = ( MPG .GT. 0 .and. id%MYID .eq. 0 )
-      NBVARIABLES=188
+      NBVARIABLES=194
       NBVARIABLES_ROOT=33
       allocate(SIZE_VARIABLES(NBVARIABLES),  stat=allocok)
       if (allocok .GT. 0) THEN
@@ -367,7 +373,7 @@ C
       TOTAL_FILE_SIZE=0_8
       TOTAL_STRUC_SIZE=0_8
       TMP_OOC_NAMES(:)="?"
-      CALL SMUMPS_SAVE_RESTORE_STRUCTURE(id,0,"memory_save"
+      CALL SMUMPS_SAVE_RESTORE_STRUCTURE(id,0,memory_save_mode
      &     ,NBVARIABLES,SIZE_VARIABLES,SIZE_GEST
      &     ,NBVARIABLES_ROOT,SIZE_VARIABLES_ROOT,SIZE_GEST_ROOT
      &     ,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
@@ -426,7 +432,7 @@ C
       CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &     id%COMM, id%MYID )
       IF ( id%INFO(1) .LT. 0 ) RETURN
-      CALL SMUMPS_SAVE_RESTORE_STRUCTURE(id,OUT,"save"
+      CALL SMUMPS_SAVE_RESTORE_STRUCTURE(id,OUT,save_mode
      &     ,NBVARIABLES,SIZE_VARIABLES,SIZE_GEST
      &     ,NBVARIABLES_ROOT,SIZE_VARIABLES_ROOT,SIZE_GEST_ROOT
      &     ,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
@@ -513,6 +519,7 @@ C
       RETURN
       END SUBROUTINE SMUMPS_SAVE
       SUBROUTINE SMUMPS_RESTORE(id)
+      IMPLICIT NONE
       INCLUDE 'mpif.h'
       INTEGER::ierr,IN,NBVARIABLES,NBVARIABLES_ROOT
       CHARACTER(len=LEN_SAVE_FILE):: restore_file,INFO_FILE
@@ -526,7 +533,7 @@ C
       INTEGER :: I,J,K,H,allocok
       CHARACTER(len=1) :: TMP_OOC_NAMES(350)
       TYPE (SMUMPS_STRUC) :: id
-      NBVARIABLES=188
+      NBVARIABLES=194
       NBVARIABLES_ROOT=33
       allocate(SIZE_VARIABLES(NBVARIABLES),  stat=allocok)
       if (allocok .GT. 0) THEN
@@ -595,7 +602,7 @@ C
       IF ( id%INFO(1) .LT. 0 ) RETURN
       MP= id%ICNTL(2)
       MPG= id%ICNTL(3)
-      CALL SMUMPS_SAVE_RESTORE_STRUCTURE(id,IN,"restore"
+      CALL SMUMPS_SAVE_RESTORE_STRUCTURE(id,IN,restore_mode
      &     ,NBVARIABLES,SIZE_VARIABLES,SIZE_GEST
      &     ,NBVARIABLES_ROOT,SIZE_VARIABLES_ROOT,SIZE_GEST_ROOT
      &     ,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
@@ -660,8 +667,8 @@ C
       USE SMUMPS_FACSOL_L0OMP_M, ONLY : SMUMPS_SAVE_RESTORE_L0FACARRAY
       IMPLICIT NONE
       INCLUDE 'mpif.h'
-      INTEGER,intent(in)::unit,NBVARIABLES,NBVARIABLES_ROOT
-      CHARACTER(len=*),intent(in) :: mode
+      INTEGER, intent(in) ::unit,NBVARIABLES,NBVARIABLES_ROOT
+      INTEGER, intent(in) :: mode
       INTEGER(8),dimension(NBVARIABLES)::SIZE_VARIABLES
       INTEGER(8),dimension(NBVARIABLES_ROOT)::SIZE_VARIABLES_ROOT
       INTEGER,dimension(NBVARIABLES)::SIZE_GEST
@@ -669,9 +676,6 @@ C
       INTEGER(8) :: TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
       INTEGER:: INFO1,INFO2,INFOG1,INFOG2
       INTEGER:: j,i1,i2,err,ierr
-      CHARACTER(len=30), allocatable, dimension(:)::VARIABLES
-      CHARACTER(len=30), allocatable, dimension(:)::VARIABLES_ROOT
-      CHARACTER(len=30) :: TMP_STRING1, TMP_STRING2
       CHARACTER :: ARITH,READ_ARITH
       INTEGER(8) :: size_written,gest_size,WRITTEN_STRUC_SIZE
       INTEGER:: SIZE_INT, SIZE_INT8, SIZE_RL_OR_DBL, SIZE_ARITH_DEP
@@ -701,246 +705,237 @@ C
      &            SIZE_VARIABLES_L0FAC
       INTEGER::SIZE_GEST_BLR,SIZE_GEST_FRONT_DATA,SIZE_GEST_L0FAC
       INTEGER :: KEEP410_SAVE, KEEP411_SAVE 
+      INTEGER(8) :: KEEP883_SAVE, KEEP884_SAVE 
       INTEGER(4) :: I4
       TYPE (SMUMPS_STRUC) :: id
-      allocate(VARIABLES(NBVARIABLES),  stat=allocok)
-      if (allocok .GT. 0) THEN
-       id%INFO(1)  =-13
-       id%INFO(2) = NBVARIABLES
-      endif
-      CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &     id%COMM, id%MYID )
-      IF ( id%INFO(1) .LT. 0 ) GOTO 100
-      VARIABLES(188)="ASSOCIATED_OOC_FILES"
-      VARIABLES(187)="pad16"
-      VARIABLES(186)="Deficiency"
-      VARIABLES(185)="NB_SINGULAR_VALUES"
-      VARIABLES(184)="SINGULAR_VALUES"
-      VARIABLES(183)="MPITOOMP_PROCS_MAP"
-      VARIABLES(182)="L0_OMP_MAPPING"
-      VARIABLES(181)="PTR_LEAFS_L0_OMP"
-      VARIABLES(180)="PERM_L0_OMP"
-      VARIABLES(179)="VIRT_L0_OMP_MAPPING"
-      VARIABLES(178)="VIRT_L0_OMP"
-      VARIABLES(177)="PHYS_L0_OMP"
-      VARIABLES(176)="IPOOL_A_L0_OMP"
-      VARIABLES(175)="IPOOL_B_L0_OMP"
-      VARIABLES(174)="I8_L0_OMP"
-      VARIABLES(173)="I4_L0_OMP"
-      VARIABLES(172)="THREAD_LA"
-      VARIABLES(171)="LL0_OMP_FACTORS"
-      VARIABLES(170)="LL0_OMP_MAPPING"
-      VARIABLES(169)="L_VIRT_L0_OMP"
-      VARIABLES(168)="L_PHYS_L0_OMP"
-      VARIABLES(167)="LPOOL_B_L0_OMP"
-      VARIABLES(166)="LPOOL_A_L0_OMP"
-      VARIABLES(165)="L0_OMP_FACTORS"
-      VARIABLES(164)="BLRARRAY_ENCODING"
-      VARIABLES(163)="FDM_F_ENCODING"
-      VARIABLES(162)="pad13"
-      VARIABLES(161)="NBGRP"
-      VARIABLES(160)="LRGROUPS"
-      VARIABLES(159)="root"
-      VARIABLES(158)="WORKING"
-      VARIABLES(157)="IPTR_WORKING"
-      VARIABLES(156)="pad14"
-      VARIABLES(155)="SUP_PROC"
-      VARIABLES(154)="PIVNUL_LIST"
-      VARIABLES(153)="OOC_FILE_NAMES"
-      VARIABLES(152)="OOC_FILE_NAME_LENGTH"
-      VARIABLES(151)="pad12"
-      VARIABLES(150)="OOC_NB_FILE_TYPE"
-      VARIABLES(149)="OOC_NB_FILES"
-      VARIABLES(148)="OOC_TOTAL_NB_NODES"
-      VARIABLES(147)="OOC_VADDR"
-      VARIABLES(146)="OOC_SIZE_OF_BLOCK"
-      VARIABLES(145)="OOC_INODE_SEQUENCE"
-      VARIABLES(144)="OOC_MAX_NB_NODES_FOR_ZONE"
-      VARIABLES(143)="INSTANCE_NUMBER"
-      VARIABLES(142)="CB_SON_SIZE"
-      VARIABLES(141)="DKEEP"
-      VARIABLES(140)="LWK_USER"
-      VARIABLES(139)="NBSA_LOCAL"
-      VARIABLES(138)="WK_USER"
-      VARIABLES(137)="CROIX_MANU"
-      VARIABLES(136)="SCHED_SBTR"
-      VARIABLES(135)="SCHED_GRP"
-      VARIABLES(134)="SCHED_DEP"
-      VARIABLES(133)="SBTR_ID"
-      VARIABLES(132)="DEPTH_FIRST_SEQ"
-      VARIABLES(131)="DEPTH_FIRST"
-      VARIABLES(130)="MY_NB_LEAF"
-      VARIABLES(129)="MY_FIRST_LEAF"
-      VARIABLES(128)="MY_ROOT_SBTR"
-      VARIABLES(127)="COST_TRAV"
-      VARIABLES(126)="MEM_SUBTREE"
-      VARIABLES(125)="RHSCOMP"
-      VARIABLES(124)="POSINRHSCOMP_COL"
-      VARIABLES(123)="pad11"
-      VARIABLES(122)="POSINRHSCOMP_COL_ALLOC"
-      VARIABLES(121)="POSINRHSCOMP_ROW"
-      VARIABLES(120)="MEM_DIST"
-      VARIABLES(119)="I_AM_CAND"
-      VARIABLES(118)="TAB_POS_IN_PERE"
-      VARIABLES(117)="FUTURE_NIV2"
-      VARIABLES(116)="ISTEP_TO_INIV2"
-      VARIABLES(115)="CANDIDATES"
-      VARIABLES(114)="ELTPROC"
-      VARIABLES(113)="LELTVAR"
-      VARIABLES(112)="NELT_loc"
-      VARIABLES(111)="PROCNODE"
-      VARIABLES(110)="S"
-      VARIABLES(109)="PTRFAC"
-      VARIABLES(108)="PTLUST_S"
-      VARIABLES(107)="Step2node"
-      VARIABLES(106)="PROCNODE_STEPS"
-      VARIABLES(105)="NA"
-      VARIABLES(104)="PTRDEBARR"
-      VARIABLES(103)="NINROWARR"
-      VARIABLES(102)="NINCOLARR"
-      VARIABLES(101)="PTR8ARR"
-      VARIABLES(100)="PTRAR"
-      VARIABLES(99)="FRTELT"
-      VARIABLES(98)="FRTPTR"
-      VARIABLES(97)="FILS"
-      VARIABLES(96)="DAD_STEPS"
-      VARIABLES(95)="FRERE_STEPS"
-      VARIABLES(94)="ND_STEPS"
-      VARIABLES(93)="NE_STEPS"
-      VARIABLES(92)="STEP"
-      VARIABLES(91)="NBSA"
-      VARIABLES(90)="LNA"
-      VARIABLES(89)="KEEP"
-      VARIABLES(88)="IS"
-      VARIABLES(87)="ASS_IRECV"
-      VARIABLES(86)="NSLAVES"
-      VARIABLES(85)="NPROCS"
-      VARIABLES(84)="MYID"
-      VARIABLES(83)="COMM_LOAD"
-      VARIABLES(82)="MYID_NODES"
-      VARIABLES(81)="COMM_NODES"
-      VARIABLES(80)="INST_Number"
-      VARIABLES(79)="MAX_SURF_MASTER"
-      VARIABLES(78)="KEEP8"
-      VARIABLES(77)="pad7"
-      VARIABLES(76)="SAVE_PREFIX"
-      VARIABLES(75)="SAVE_DIR"
-      VARIABLES(74)="WRITE_PROBLEM"
-      VARIABLES(73)="OOC_PREFIX"
-      VARIABLES(72)="OOC_TMPDIR"
-      VARIABLES(71)="VERSION_NUMBER"
-      VARIABLES(70)="MAPPING"
-      VARIABLES(69)="LISTVAR_SCHUR"
-      VARIABLES(68)="SCHUR_CINTERFACE"
-      VARIABLES(67)="SCHUR"
-      VARIABLES(66)="SIZE_SCHUR"
-      VARIABLES(65)="SCHUR_LLD"
-      VARIABLES(64)="SCHUR_NLOC"
-      VARIABLES(63)="SCHUR_MLOC"
-      VARIABLES(62)="NBLOCK"
-      VARIABLES(61)="MBLOCK"
-      VARIABLES(60)="NPCOL"
-      VARIABLES(59)="NPROW"
-      VARIABLES(58)="UNS_PERM"
-      VARIABLES(57)="SYM_PERM"
-      VARIABLES(56)="METIS_OPTIONS"
-      VARIABLES(55)="RINFOG"
-      VARIABLES(54)="RINFO"
-      VARIABLES(53)="CNTL"
-      VARIABLES(52)="COST_SUBTREES"
-      VARIABLES(51)="INFOG"
-      VARIABLES(50)="INFO"
-      VARIABLES(49)="ICNTL"
-      VARIABLES(48)="pad6"
-      VARIABLES(47)="LSOL_loc"
-      VARIABLES(46)="LREDRHS"
-      VARIABLES(45)="LRHS_loc"
-      VARIABLES(44)="Nloc_RHS"
-      VARIABLES(43)="NZ_RHS"
-      VARIABLES(42)="NRHS"
-      VARIABLES(41)="LRHS"
-      VARIABLES(40)="IRHS_loc"
-      VARIABLES(39)="ISOL_loc"
-      VARIABLES(38)="IRHS_PTR"
-      VARIABLES(37)="IRHS_SPARSE"
-      VARIABLES(36)="RHS_loc"
-      VARIABLES(35)="SOL_loc"
-      VARIABLES(34)="RHS_SPARSE"
-      VARIABLES(33)="REDRHS"
-      VARIABLES(32)="RHS"
-      VARIABLES(31)="BLKVAR"
-      VARIABLES(30)="BLKPTR"
-      VARIABLES(29)="pad5"
-      VARIABLES(28)="NBLK"
-      VARIABLES(27)="PERM_IN"
-      VARIABLES(26)="pad4"
-      VARIABLES(25)="A_ELT"
-      VARIABLES(24)="ELTVAR"
-      VARIABLES(23)="ELTPTR"
-      VARIABLES(22)="pad3"
-      VARIABLES(21)="NELT"
-      VARIABLES(20)="pad2"
-      VARIABLES(19)="A_loc"
-      VARIABLES(18)="JCN_loc"
-      VARIABLES(17)="IRN_loc"
-      VARIABLES(16)="NNZ_loc"
-      VARIABLES(15)="pad1"
-      VARIABLES(14)="NZ_loc"
-      VARIABLES(13)="pad0"
-      VARIABLES(12)="ROWSCA"
-      VARIABLES(11)="COLSCA"
-      VARIABLES(10)="JCN"
-      VARIABLES(9)="IRN"
-      VARIABLES(8)="A"
-      VARIABLES(7)="NNZ"
-      VARIABLES(6)="NZ"
-      VARIABLES(5)="N"
-      VARIABLES(4)="JOB"
-      VARIABLES(3)="PAR"
-      VARIABLES(2)="SYM"
-      VARIABLES(1)="COMM"
-      allocate(VARIABLES_ROOT(NBVARIABLES_ROOT),  stat=allocok)
-      if (allocok .GT. 0) THEN
-       id%INFO(1)  =-13
-       id%INFO(2) = NBVARIABLES_ROOT
-      endif
-      CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &        id%COMM, id%MYID )
-      IF ( id%INFO(1) .LT. 0 ) GOTO 100
-      VARIABLES_ROOT(33)="rootpad4"
-      VARIABLES_ROOT(32)="NB_SINGULAR_VALUES"
-      VARIABLES_ROOT(31)="SINGULAR_VALUES"
-      VARIABLES_ROOT(30)="SVD_VT"
-      VARIABLES_ROOT(29)="SVD_U"
-      VARIABLES_ROOT(28)="gridinit_done"
-      VARIABLES_ROOT(27)="yes"
-      VARIABLES_ROOT(26)="rootpad3"
-      VARIABLES_ROOT(25)="QR_RCOND"
-      VARIABLES_ROOT(24)="rootpad2"
-      VARIABLES_ROOT(23)="RHS_ROOT"
-      VARIABLES_ROOT(22)="rootpad1"
-      VARIABLES_ROOT(21)="QR_TAU"
-      VARIABLES_ROOT(20)="SCHUR_POINTER"
-      VARIABLES_ROOT(19)="RHS_CNTR_MASTER_ROOT"
-      VARIABLES_ROOT(18)="IPIV"
-      VARIABLES_ROOT(17)="RG2L"
-      VARIABLES_ROOT(16)="rootpad0"
-      VARIABLES_ROOT(15)="LPIV"
-      VARIABLES_ROOT(14)="CNTXT_BLACS"
-      VARIABLES_ROOT(13)="DESCRIPTOR"
-      VARIABLES_ROOT(12)="TOT_ROOT_SIZE"
-      VARIABLES_ROOT(11)="ROOT_SIZE"
-      VARIABLES_ROOT(10)="RHS_NLOC"
-      VARIABLES_ROOT(9)="SCHUR_LLD"
-      VARIABLES_ROOT(8)="SCHUR_NLOC"
-      VARIABLES_ROOT(7)="SCHUR_MLOC"
-      VARIABLES_ROOT(6)="MYCOL"
-      VARIABLES_ROOT(5)="MYROW"
-      VARIABLES_ROOT(4)="NPCOL"
-      VARIABLES_ROOT(3)="NPROW"
-      VARIABLES_ROOT(2)="NBLOCK"
-      VARIABLES_ROOT(1)="MBLOCK"
-      OOC_INDICES=(/149,150,152,153/)
+      INTEGER, PARAMETER :: S_ASSOCIATED_OOC_FILES=194
+      INTEGER, PARAMETER :: S_pad16=193
+      INTEGER, PARAMETER :: S_Deficiency=192
+      INTEGER, PARAMETER :: S_NB_SINGULAR_VALUES=191
+      INTEGER, PARAMETER :: S_SINGULAR_VALUES=190
+      INTEGER, PARAMETER :: S_MTKO_PROCS_MAP=189
+      INTEGER, PARAMETER :: S_L0_OMP_MAPPING=188
+      INTEGER, PARAMETER :: S_PTR_LEAFS_L0_OMP=187
+      INTEGER, PARAMETER :: S_PERM_L0_OMP=186
+      INTEGER, PARAMETER :: S_VIRT_L0_OMP_MAPPING=185
+      INTEGER, PARAMETER :: S_VIRT_L0_OMP=184
+      INTEGER, PARAMETER :: S_PHYS_L0_OMP=183
+      INTEGER, PARAMETER :: S_IPOOL_A_L0_OMP=182
+      INTEGER, PARAMETER :: S_IPOOL_B_L0_OMP=181
+      INTEGER, PARAMETER :: S_I8_L0_OMP=180
+      INTEGER, PARAMETER :: S_I4_L0_OMP=179
+      INTEGER, PARAMETER :: S_THREAD_LA=178
+      INTEGER, PARAMETER :: S_LL0_OMP_FACTORS=177
+      INTEGER, PARAMETER :: S_LL0_OMP_MAPPING=176
+      INTEGER, PARAMETER :: S_L_VIRT_L0_OMP=175
+      INTEGER, PARAMETER :: S_L_PHYS_L0_OMP=174
+      INTEGER, PARAMETER :: S_LPOOL_B_L0_OMP=173
+      INTEGER, PARAMETER :: S_LPOOL_A_L0_OMP=172
+      INTEGER, PARAMETER :: S_L0_OMP_FACTORS=171
+      INTEGER, PARAMETER :: S_BLRARRAY_ENCODING=170
+      INTEGER, PARAMETER :: S_FDM_F_ENCODING=169
+      INTEGER, PARAMETER :: S_pad13=168
+      INTEGER, PARAMETER :: S_NBGRP=167
+      INTEGER, PARAMETER :: S_LRGROUPS=166
+      INTEGER, PARAMETER :: S_root=165
+      INTEGER, PARAMETER :: S_WORKING=164
+      INTEGER, PARAMETER :: S_IPTR_WORKING=163
+      INTEGER, PARAMETER :: S_pad14=162
+      INTEGER, PARAMETER :: S_SUP_PROC=161
+      INTEGER, PARAMETER :: S_PIVNUL_LIST=160
+      INTEGER, PARAMETER :: S_OOC_FILE_NAMES=159
+      INTEGER, PARAMETER :: S_OOC_FILE_NAME_LENGTH=158
+      INTEGER, PARAMETER :: S_pad12=157
+      INTEGER, PARAMETER :: S_OOC_NB_FILE_TYPE=156
+      INTEGER, PARAMETER :: S_OOC_NB_FILES=155
+      INTEGER, PARAMETER :: S_OOC_TOTAL_NB_NODES=154
+      INTEGER, PARAMETER :: S_OOC_VADDR=153
+      INTEGER, PARAMETER :: S_OOC_SIZE_OF_BLOCK=152
+      INTEGER, PARAMETER :: S_OOC_INODE_SEQUENCE=151
+      INTEGER, PARAMETER :: S_OOC_MAX_NB_NODES_FOR_ZONE=150
+      INTEGER, PARAMETER :: S_INSTANCE_NUMBER=149
+      INTEGER, PARAMETER :: S_CB_SON_SIZE=148
+      INTEGER, PARAMETER :: S_DKEEP=147
+      INTEGER, PARAMETER :: S_LWK_USER=146
+      INTEGER, PARAMETER :: S_NBSA_LOCAL=145
+      INTEGER, PARAMETER :: S_WK_USER=144
+      INTEGER, PARAMETER :: S_CROIX_MANU=143
+      INTEGER, PARAMETER :: S_SCHED_SBTR=142
+      INTEGER, PARAMETER :: S_SCHED_GRP=141
+      INTEGER, PARAMETER :: S_SCHED_DEP=140
+      INTEGER, PARAMETER :: S_SBTR_ID=139
+      INTEGER, PARAMETER :: S_DEPTH_FIRST_SEQ=138
+      INTEGER, PARAMETER :: S_DEPTH_FIRST=137
+      INTEGER, PARAMETER :: S_MY_NB_LEAF=136
+      INTEGER, PARAMETER :: S_MY_FIRST_LEAF=135
+      INTEGER, PARAMETER :: S_MY_ROOT_SBTR=134
+      INTEGER, PARAMETER :: S_COST_TRAV=133
+      INTEGER, PARAMETER :: S_MEM_SUBTREE=132
+      INTEGER, PARAMETER :: S_RHSINTR=131
+      INTEGER, PARAMETER :: S_GLOB2LOC_SOL=130
+      INTEGER, PARAMETER :: S_pad11=129
+      INTEGER, PARAMETER :: S_GLOB2LOC_SOL_ALLOC=128
+      INTEGER, PARAMETER :: S_GLOB2LOC_RHS=127
+      INTEGER, PARAMETER :: S_MEM_DIST=126
+      INTEGER, PARAMETER :: S_I_AM_CAND=125
+      INTEGER, PARAMETER :: S_TAB_POS_IN_PERE=124
+      INTEGER, PARAMETER :: S_FUTURE_NIV2=123
+      INTEGER, PARAMETER :: S_ISTEP_TO_INIV2=122
+      INTEGER, PARAMETER :: S_CANDIDATES=121
+      INTEGER, PARAMETER :: S_ELTPROC=120
+      INTEGER, PARAMETER :: S_LELTVAR=119
+      INTEGER, PARAMETER :: S_NELT_loc=118
+      INTEGER, PARAMETER :: S_PROCNODE=117
+      INTEGER, PARAMETER :: S_S=116
+      INTEGER, PARAMETER :: S_PTRFAC=115
+      INTEGER, PARAMETER :: S_PTLUST_S=114
+      INTEGER, PARAMETER :: S_Step2node=113
+      INTEGER, PARAMETER :: S_PROCNODE_STEPS=112
+      INTEGER, PARAMETER :: S_NA=111
+      INTEGER, PARAMETER :: S_PTRDEBARR=110
+      INTEGER, PARAMETER :: S_NINROWARR=109
+      INTEGER, PARAMETER :: S_NINCOLARR=108
+      INTEGER, PARAMETER :: S_PTR8ARR=107
+      INTEGER, PARAMETER :: S_PTRAR=106
+      INTEGER, PARAMETER :: S_FRTELT=105
+      INTEGER, PARAMETER :: S_FRTPTR=104
+      INTEGER, PARAMETER :: S_FILS=103
+      INTEGER, PARAMETER :: S_DAD_STEPS=102
+      INTEGER, PARAMETER :: S_FRERE_STEPS=101
+      INTEGER, PARAMETER :: S_ND_STEPS=100
+      INTEGER, PARAMETER :: S_NE_STEPS=99
+      INTEGER, PARAMETER :: S_STEP=98
+      INTEGER, PARAMETER :: S_NBSA=97
+      INTEGER, PARAMETER :: S_LNA=96
+      INTEGER, PARAMETER :: S_KEEP=95
+      INTEGER, PARAMETER :: S_IS=94
+      INTEGER, PARAMETER :: S_ASS_IRECV=93
+      INTEGER, PARAMETER :: S_NSLAVES=92
+      INTEGER, PARAMETER :: S_NPROCS=91
+      INTEGER, PARAMETER :: S_MYID=90
+      INTEGER, PARAMETER :: S_COMM_LOAD=89
+      INTEGER, PARAMETER :: S_MYID_NODES=88
+      INTEGER, PARAMETER :: S_COMM_NODES=87
+      INTEGER, PARAMETER :: S_INST_Number=86
+      INTEGER, PARAMETER :: S_MAX_SURF_MASTER=85
+      INTEGER, PARAMETER :: S_KEEP8=84
+      INTEGER, PARAMETER :: S_pad7=83
+      INTEGER, PARAMETER :: S_SAVE_PREFIX=82
+      INTEGER, PARAMETER :: S_SAVE_DIR=81
+      INTEGER, PARAMETER :: S_WRITE_PROBLEM=80
+      INTEGER, PARAMETER :: S_OOC_PREFIX=79
+      INTEGER, PARAMETER :: S_OOC_TMPDIR=78
+      INTEGER, PARAMETER :: S_VERSION_NUMBER=77
+      INTEGER, PARAMETER :: S_MAPPING=76
+      INTEGER, PARAMETER :: S_LISTVAR_SCHUR=75
+      INTEGER, PARAMETER :: S_SCHUR_CINTERFACE=74
+      INTEGER, PARAMETER :: S_SCHUR=73
+      INTEGER, PARAMETER :: S_SIZE_SCHUR=72
+      INTEGER, PARAMETER :: S_SCHUR_LLD=71
+      INTEGER, PARAMETER :: S_SCHUR_NLOC=70
+      INTEGER, PARAMETER :: S_SCHUR_MLOC=69
+      INTEGER, PARAMETER :: S_NBLOCK=68
+      INTEGER, PARAMETER :: S_MBLOCK=67
+      INTEGER, PARAMETER :: S_NPCOL=66
+      INTEGER, PARAMETER :: S_NPROW=65
+      INTEGER, PARAMETER :: S_UNS_PERM=64
+      INTEGER, PARAMETER :: S_SYM_PERM=63
+      INTEGER, PARAMETER :: S_METIS_OPTIONS=62
+      INTEGER, PARAMETER :: S_RINFOG=61
+      INTEGER, PARAMETER :: S_RINFO=60
+      INTEGER, PARAMETER :: S_CNTL=59
+      INTEGER, PARAMETER :: S_COST_SUBTREES=58
+      INTEGER, PARAMETER :: S_INFOG=57
+      INTEGER, PARAMETER :: S_INFO=56
+      INTEGER, PARAMETER :: S_ICNTL=55
+      INTEGER, PARAMETER :: S_pad6=54
+      INTEGER, PARAMETER :: S_LD_RHSINTR=53
+      INTEGER, PARAMETER :: S_NSOL_loc=52
+      INTEGER, PARAMETER :: S_LSOL_loc=51
+      INTEGER, PARAMETER :: S_LREDRHS=50
+      INTEGER, PARAMETER :: S_LRHS_loc=49
+      INTEGER, PARAMETER :: S_Nloc_RHS=48
+      INTEGER, PARAMETER :: S_NZ_RHS=47
+      INTEGER, PARAMETER :: S_NRHS=46
+      INTEGER, PARAMETER :: S_LRHS=45
+      INTEGER, PARAMETER :: S_IRHS_loc=44
+      INTEGER, PARAMETER :: S_ISOL_loc=43
+      INTEGER, PARAMETER :: S_IRHS_PTR=42
+      INTEGER, PARAMETER :: S_IRHS_SPARSE=41
+      INTEGER, PARAMETER :: S_RHS_loc=40
+      INTEGER, PARAMETER :: S_SOL_loc=39
+      INTEGER, PARAMETER :: S_RHS_SPARSE=38
+      INTEGER, PARAMETER :: S_REDRHS=37
+      INTEGER, PARAMETER :: S_RHS=36
+      INTEGER, PARAMETER :: S_BLKVAR=35
+      INTEGER, PARAMETER :: S_BLKPTR=34
+      INTEGER, PARAMETER :: S_pad5=33
+      INTEGER, PARAMETER :: S_NBLK=32
+      INTEGER, PARAMETER :: S_PERM_IN=31
+      INTEGER, PARAMETER :: S_pad4=30
+      INTEGER, PARAMETER :: S_A_ELT=29
+      INTEGER, PARAMETER :: S_ELTVAR=28
+      INTEGER, PARAMETER :: S_ELTPTR=27
+      INTEGER, PARAMETER :: S_pad3=26
+      INTEGER, PARAMETER :: S_NELT=25
+      INTEGER, PARAMETER :: S_pad2=24
+      INTEGER, PARAMETER :: S_A_loc=23
+      INTEGER, PARAMETER :: S_JCN_loc=22
+      INTEGER, PARAMETER :: S_IRN_loc=21
+      INTEGER, PARAMETER :: S_NNZ_loc=20
+      INTEGER, PARAMETER :: S_pad1=19
+      INTEGER, PARAMETER :: S_NZ_loc=18
+      INTEGER, PARAMETER :: S_PIVOTS=17
+      INTEGER, PARAMETER :: S_COLIND=16
+      INTEGER, PARAMETER :: S_ROWIND=15
+      INTEGER, PARAMETER :: S_ROWSCA_loc=14
+      INTEGER, PARAMETER :: S_COLSCA_loc=13
+      INTEGER, PARAMETER :: S_ROWSCA=12
+      INTEGER, PARAMETER :: S_COLSCA=11
+      INTEGER, PARAMETER :: S_JCN=10
+      INTEGER, PARAMETER :: S_IRN=9
+      INTEGER, PARAMETER :: S_A=8
+      INTEGER, PARAMETER :: S_NNZ=7
+      INTEGER, PARAMETER :: S_NZ=6
+      INTEGER, PARAMETER :: S_N=5
+      INTEGER, PARAMETER :: S_JOB=4
+      INTEGER, PARAMETER :: S_PAR=3
+      INTEGER, PARAMETER :: S_SYM=2
+      INTEGER, PARAMETER :: S_COMM=1
+      INTEGER,  PARAMETER :: R_rootpad4=33
+      INTEGER,  PARAMETER :: R_NB_SINGULAR_VALUES=32
+      INTEGER,  PARAMETER :: R_SINGULAR_VALUES=31
+      INTEGER,  PARAMETER :: R_SVD_VT=30
+      INTEGER,  PARAMETER :: R_SVD_U=29
+      INTEGER,  PARAMETER :: R_gridinit_done=28
+      INTEGER,  PARAMETER :: R_yes=27
+      INTEGER,  PARAMETER :: R_rootpad3=26
+      INTEGER,  PARAMETER :: R_QR_RCOND=25
+      INTEGER,  PARAMETER :: R_rootpad2=24
+      INTEGER,  PARAMETER :: R_RHS_ROOT=23
+      INTEGER,  PARAMETER :: R_rootpad1=22
+      INTEGER,  PARAMETER :: R_QR_TAU=21
+      INTEGER,  PARAMETER :: R_SCHUR_POINTER=20
+      INTEGER,  PARAMETER :: R_RHS_CNTR_MASTER_ROOT=19
+      INTEGER,  PARAMETER :: R_IPIV=18
+      INTEGER,  PARAMETER :: R_RG2L=17
+      INTEGER,  PARAMETER :: R_rootpad0=16
+      INTEGER,  PARAMETER :: R_LPIV=15
+      INTEGER,  PARAMETER :: R_CNTXT_BLACS=14
+      INTEGER,  PARAMETER :: R_DESCRIPTOR=13
+      INTEGER,  PARAMETER :: R_TOT_ROOT_SIZE=12
+      INTEGER,  PARAMETER :: R_ROOT_SIZE=11
+      INTEGER,  PARAMETER :: R_RHS_NLOC=10
+      INTEGER,  PARAMETER :: R_SCHUR_LLD=9
+      INTEGER,  PARAMETER :: R_SCHUR_NLOC=8
+      INTEGER,  PARAMETER :: R_SCHUR_MLOC=7
+      INTEGER,  PARAMETER :: R_MYCOL=6
+      INTEGER,  PARAMETER :: R_MYROW=5
+      INTEGER,  PARAMETER :: R_NPCOL=4
+      INTEGER,  PARAMETER :: R_NPROW=3
+      INTEGER,  PARAMETER :: R_NBLOCK=2
+      INTEGER,  PARAMETER :: R_MBLOCK=1
+      OOC_INDICES=(/155,156,158,159/)
       SIZE_INT = id%KEEP(34)
       SIZE_INT8 = id%KEEP(34)*id%KEEP(10)
       SIZE_RL_OR_DBL = id%KEEP(16)
@@ -964,8 +959,8 @@ C
       SIZE_GEST_FRONT_DATA=0
       SIZE_VARIABLES_L0FAC=0
       SIZE_GEST_L0FAC=0
-      if(trim(mode).EQ."memory_save") then
-      elseif(trim(mode).EQ."save") then
+      if(mode.EQ.memory_save_mode) then
+      elseif(mode.EQ.save_mode) then
          write(unit,iostat=err) "MUMPS"
          if(err.ne.0) THEN
             id%INFO(1) = -72
@@ -1125,8 +1120,8 @@ C
      &           +int(2*id%KEEP(34)*1,kind=8)
 #endif
          ENDIF
-      elseif((trim(mode).EQ."restore").OR.
-     &        (trim(mode).EQ."restore_ooc")) then
+      elseif((mode.EQ.restore_mode).OR.
+     &        (mode.EQ.restore_ooc_mode)) then
         CALL MUMPS_READ_HEADER(unit,err,size_read,SIZE_INT,SIZE_INT8,
      &       TOTAL_FILE_SIZE, TOTAL_STRUC_SIZE, READ_ARITH,
      &       READ_INT_TYPE_64, READ_OOC_FILE_NAME_LENGTH,
@@ -1144,14 +1139,14 @@ C
      &        id%COMM, id%MYID )
          IF ( id%INFO(1) .LT. 0 ) GOTO 100
          BASIC_CHECK = .false.
-         IF (trim(mode).EQ."restore_ooc") THEN
+         IF (mode.EQ.restore_ooc_mode) THEN
            BASIC_CHECK = .true.
          ENDIF
          CALL SMUMPS_CHECK_HEADER(id,BASIC_CHECK,READ_INT_TYPE_64,
      &              READ_HASH, READ_NPROCS,
      &              READ_ARITH, READ_SYM, READ_PAR)
          IF (id%INFO(1) .LT. 0) GOTO 100
-      elseif(trim(mode).EQ."fake_restore") then
+      elseif(mode.EQ.fake_restore_mode) then
          read(unit,iostat=err) READ_HASH
          if(err.ne.0) GOTO 100
          read(unit,iostat=err) TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
@@ -1163,11 +1158,10 @@ C
       endif
       DO j=1,size(OOC_INDICES)
          i1=OOC_INDICES(j)
-         TMP_STRING1 = VARIABLES(i1)
-         SELECT CASE(TMP_STRING1)
-         CASE("OOC_NB_FILES")
+         SELECT CASE(i1)
+         CASE(S_OOC_NB_FILES)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%OOC_NB_FILES)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%OOC_NB_FILES,1)*SIZE_INT
@@ -1175,7 +1169,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%OOC_NB_FILES)) THEN
                   write(unit,iostat=err) size(id%OOC_NB_FILES,1)
                   if(err.ne.0) then
@@ -1207,8 +1201,8 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif((trim(mode).EQ."restore").OR.
-     &             (trim(mode).EQ."restore_ooc")) then
+            elseif((mode.EQ.restore_mode).OR.
+     &             (mode.EQ.restore_ooc_mode)) then
                nullify(id%OOC_NB_FILES)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -1247,11 +1241,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("OOC_NB_FILE_TYPE")
+         CASE(S_OOC_NB_FILE_TYPE)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%OOC_NB_FILE_TYPE
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1261,8 +1255,8 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif((trim(mode).EQ."restore").OR.
-     &             (trim(mode).EQ."restore_ooc")) then
+            elseif((mode.EQ.restore_mode).OR.
+     &             (mode.EQ.restore_ooc_mode)) then
                SIZE_VARIABLES(i1)=SIZE_INT
                read(unit,iostat=err) id%OOC_NB_FILE_TYPE
                if(err.ne.0) THEN
@@ -1274,9 +1268,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("OOC_FILE_NAMES")
+         CASE(S_OOC_FILE_NAMES)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%OOC_FILE_NAMES)) THEN
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=size(id%OOC_FILE_NAMES,1)
@@ -1285,7 +1279,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*3
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%OOC_FILE_NAMES)) THEN
                   write(unit,iostat=err) size(id%OOC_FILE_NAMES,1)
      &                 ,size(id%OOC_FILE_NAMES,2)
@@ -1318,8 +1312,8 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif((trim(mode).EQ."restore").OR.
-     &             (trim(mode).EQ."restore_ooc")) then
+            elseif((mode.EQ.restore_mode).OR.
+     &             (mode.EQ.restore_ooc_mode)) then
                nullify(id%OOC_FILE_NAMES)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -1360,9 +1354,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("OOC_FILE_NAME_LENGTH")
+         CASE(S_OOC_FILE_NAME_LENGTH)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%OOC_FILE_NAME_LENGTH)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
@@ -1371,7 +1365,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%OOC_FILE_NAME_LENGTH)) THEN
                   write(unit,iostat=err) size(id%OOC_FILE_NAME_LENGTH,1)
                   if(err.ne.0) then
@@ -1403,8 +1397,8 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif((trim(mode).EQ."restore").OR.
-     &             (trim(mode).EQ."restore_ooc")) then
+            elseif((mode.EQ.restore_mode).OR.
+     &             (mode.EQ.restore_ooc_mode)) then
                nullify(id%OOC_FILE_NAME_LENGTH)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -1447,111 +1441,41 @@ C
          CASE DEFAULT
          END SELECT
       ENDDO
-      if(trim(mode).EQ."restore_ooc") then
+      if(mode.EQ.restore_ooc_mode) then
          goto 200
       endif
       DO i1=1,NBVARIABLES 
-         TMP_STRING1 = VARIABLES(i1)
-         SELECT CASE(TMP_STRING1)
-         CASE("COMM")
-            if(trim(mode).EQ."memory_save") then
+         SELECT CASE(i1)
+         CASE(S_COMM)
+            if(mode.EQ.memory_save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
             endif
-         CASE("SYM")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%SYM
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%SYM
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read,
-     &                 id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("PAR")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%PAR
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%PAR
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("JOB")
-            if(trim(mode).EQ."memory_save") then
+         CASE(S_SYM)
+           CALL MUMPS_SAVE_INT(id%SYM)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_PAR)
+           CALL MUMPS_SAVE_INT(id%PAR)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_JOB)
+            if(mode.EQ.memory_save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
             endif
-         CASE("N")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%N
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%N
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("ICNTL")
+         CASE(S_N)
+           CALL MUMPS_SAVE_INT(id%N)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_ICNTL)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%ICNTL,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%ICNTL
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1561,7 +1485,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%ICNTL,1)
                read(unit,iostat=err) id%ICNTL
                if(err.ne.0) THEN
@@ -1573,11 +1497,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("INFO")
+         CASE(S_INFO)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%INFO,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) INFO1,INFO2
      &              ,id%INFO(3:size(id%INFO,1))
                if(err.ne.0) then
@@ -1588,7 +1512,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%INFO,1)
                read(unit,iostat=err) INFO1,INFO2
      &              ,id%INFO(3:size(id%INFO,1))
@@ -1601,11 +1525,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("INFOG")
+         CASE(S_INFOG)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%INFOG,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) INFOG1,INFOG2
      &              ,id%INFOG(3:size(id%INFOG,1))
                if(err.ne.0) then
@@ -1616,7 +1540,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%INFOG,1)
                read(unit,iostat=err) INFOG1,INFOG2
      &              ,id%INFOG(3:size(id%INFOG,1))
@@ -1629,11 +1553,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("COST_SUBTREES")
+         CASE(S_COST_SUBTREES)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%COST_SUBTREES
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1643,7 +1567,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL
                read(unit,iostat=err) id%COST_SUBTREES
                if(err.ne.0) THEN
@@ -1655,11 +1579,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("CNTL")
+         CASE(S_CNTL)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL*size(id%CNTL,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%CNTL
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1669,7 +1593,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL*size(id%CNTL,1)
                read(unit,iostat=err) id%CNTL
                if(err.ne.0) THEN
@@ -1681,11 +1605,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("RINFO")
+         CASE(S_RINFO)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL*size(id%RINFO,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%RINFO
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1695,7 +1619,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL*size(id%RINFO,1)
                read(unit,iostat=err) id%RINFO
                if(err.ne.0) THEN
@@ -1707,11 +1631,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("RINFOG")
+         CASE(S_RINFOG)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL*size(id%RINFOG,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%RINFOG
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1721,7 +1645,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL*size(id%RINFOG,1)
                read(unit,iostat=err) id%RINFOG
                if(err.ne.0) THEN
@@ -1733,11 +1657,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("KEEP8")
+         CASE(S_KEEP8)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8*size(id%KEEP8,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%KEEP8
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1747,9 +1671,13 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8*size(id%KEEP8,1)
+               KEEP883_SAVE=id%KEEP8(83)
+               KEEP884_SAVE=id%KEEP8(84)
                read(unit,iostat=err) id%KEEP8
+               id%KEEP8(83)=KEEP883_SAVE
+               id%KEEP8(84)=KEEP884_SAVE
                if(err.ne.0) THEN
                   id%INFO(1) = -75
                   CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
@@ -1759,11 +1687,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("KEEP")
+         CASE(S_KEEP)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%KEEP,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%KEEP
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1773,7 +1701,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%KEEP,1)
                KEEP410_SAVE = id%KEEP(410)
                KEEP411_SAVE = id%KEEP(411)
@@ -1789,11 +1717,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("DKEEP")
+         CASE(S_DKEEP)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL*size(id%DKEEP,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%DKEEP
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1803,7 +1731,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL*size(id%DKEEP,1)
                read(unit,iostat=err) id%DKEEP
                if(err.ne.0) THEN
@@ -1815,37 +1743,14 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("NZ")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NZ
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NZ
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("NNZ")
+         CASE(S_NZ)
+           CALL MUMPS_SAVE_INT(id%NZ)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NNZ)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%NNZ
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1855,7 +1760,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8
                read(unit,iostat=err) id%NNZ
                if(err.ne.0) THEN
@@ -1867,174 +1772,32 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif  
-         CASE("A")
-         CASE("IRN")
-         CASE("JCN")
-         CASE("COLSCA")
+         CASE(S_A)
+         CASE(S_IRN)
+         CASE(S_JCN)
+         CASE(S_COLSCA)
             IF(id%KEEP(52).NE.-1) THEN
-               NbRecords(i1)=2
-               if(trim(mode).EQ."memory_save") then
-                  IF(associated(id%COLSCA)) THEN
-                     SIZE_GEST(i1)=SIZE_INT
-                     SIZE_VARIABLES(i1)=size(id%COLSCA,1)*SIZE_RL_OR_DBL
-                  ELSE
-                     SIZE_GEST(i1)=SIZE_INT*2
-                     SIZE_VARIABLES(i1)=0_8
-                  ENDIF
-               elseif(trim(mode).EQ."save") then
-                  IF(associated(id%COLSCA)) THEN
-                     write(unit,iostat=err) size(id%COLSCA,1)
-                     if(err.ne.0) then
-                        id%INFO(1) = -72
-                        CALL MUMPS_SETI8TOI4(
-     &                       TOTAL_FILE_SIZE-size_written,
-     &                       id%INFO(2))
-                     endif
-                     write(unit,iostat=err) id%COLSCA
-                  ELSE
-                     write(unit,iostat=err) -999
-                     if(err.ne.0) then
-                        id%INFO(1) = -72
-                        CALL MUMPS_SETI8TOI4(
-     &                       TOTAL_FILE_SIZE-size_written,
-     &                       id%INFO(2))
-                     endif
-                     write(unit,iostat=err) -999
-                  ENDIF 
-                  if(err.ne.0) then
-                     id%INFO(1) = -72
-                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-                  endif
-                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &                 id%COMM, id%MYID )
-                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
-                  nullify(id%COLSCA)
-                  read(unit,iostat=err) size_array1
-                  if(err.ne.0) THEN
-                     id%INFO(1) = -75
-                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                    ,id%INFO(2))
-                  endif
-                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &                 id%COMM, id%MYID )
-                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
-                  if(size_array1.EQ.-999) then
-                     SIZE_GEST(i1)=SIZE_INT*2
-                     SIZE_VARIABLES(i1)=0_8
-                     read(unit,iostat=err) dummy
-                  else
-                     SIZE_GEST(i1)=SIZE_INT
-                     SIZE_VARIABLES(i1)=size_array1*SIZE_RL_OR_DBL
-                     allocate(id%COLSCA(size_array1), stat=allocok)
-                     if (allocok .GT. 0) THEN
-                        id%INFO(1) = -78
-                        CALL MUMPS_SETI8TOI4(
-     &                       TOTAL_STRUC_SIZE-size_allocated
-     &                       ,id%INFO(2))
-                     endif
-                     read(unit,iostat=err) id%COLSCA
-                  endif
-                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &                 id%COMM, id%MYID )
-                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
-                  if(err.ne.0) THEN
-                     id%INFO(1) = -75
-                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                    ,id%INFO(2))
-                  endif
-                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &                 id%COMM, id%MYID )
-                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               endif
+              CALL MUMPS_SAVERSTR_REALARRAY(id%COLSCA)
             ELSE
             ENDIF
-         CASE("ROWSCA")
+            IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_ROWSCA)
             IF(id%KEEP(52).NE.-1) THEN
-               NbRecords(i1)=2
-               if(trim(mode).EQ."memory_save") then
-                  IF(associated(id%ROWSCA)) THEN
-                     SIZE_GEST(i1)=SIZE_INT
-                     SIZE_VARIABLES(i1)=size(id%ROWSCA,1)*SIZE_RL_OR_DBL
-                  ELSE
-                     SIZE_GEST(i1)=SIZE_INT*2
-                     SIZE_VARIABLES(i1)=0_8
-                  ENDIF
-               elseif(trim(mode).EQ."save") then
-                  IF(associated(id%ROWSCA)) THEN
-                     write(unit,iostat=err) size(id%ROWSCA,1)
-                     if(err.ne.0) then
-                        id%INFO(1) = -72
-                        CALL MUMPS_SETI8TOI4(
-     &                       TOTAL_FILE_SIZE-size_written,
-     &                       id%INFO(2))
-                     endif
-                     write(unit,iostat=err) id%ROWSCA
-                  ELSE
-                     write(unit,iostat=err) -999
-                     if(err.ne.0) then
-                        id%INFO(1) = -72
-                        CALL MUMPS_SETI8TOI4(
-     &                       TOTAL_FILE_SIZE-size_written,
-     &                       id%INFO(2))
-                     endif
-                     write(unit,iostat=err) -999
-                  ENDIF 
-                  if(err.ne.0) then
-                     id%INFO(1) = -72
-                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-                  endif
-                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &                 id%COMM, id%MYID )
-                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
-                  nullify(id%ROWSCA)
-                  read(unit,iostat=err) size_array1
-                  if(err.ne.0) THEN
-                     id%INFO(1) = -75
-                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                    ,id%INFO(2))
-                  endif
-                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &                 id%COMM, id%MYID )
-                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
-                  if(size_array1.EQ.-999) then
-                     SIZE_GEST(i1)=SIZE_INT*2
-                     SIZE_VARIABLES(i1)=0_8
-                     read(unit,iostat=err) dummy
-                  else
-                     SIZE_GEST(i1)=SIZE_INT
-                     SIZE_VARIABLES(i1)=size_array1*SIZE_RL_OR_DBL
-                     allocate(id%ROWSCA(size_array1), stat=allocok)
-                     if (allocok .GT. 0) THEN
-                        id%INFO(1) = -78
-                        CALL MUMPS_SETI8TOI4(
-     &                       TOTAL_STRUC_SIZE-size_allocated
-     &                       ,id%INFO(2))
-                     endif
-                     read(unit,iostat=err) id%ROWSCA
-                  endif
-                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &                 id%COMM, id%MYID )
-                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
-                  if(err.ne.0) THEN
-                     id%INFO(1) = -75
-                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                    ,id%INFO(2))
-                  endif 
-                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &                 id%COMM, id%MYID )
-                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               endif
+              CALL MUMPS_SAVERSTR_REALARRAY(id%ROWSCA)
             ELSE
             ENDIF
-         CASE("NZ_loc")
+            IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_COLSCA_loc)
+            CALL MUMPS_SAVERSTR_REALARRAY(id%COLSCA_loc)
+            IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_ROWSCA_loc)
+            CALL MUMPS_SAVERSTR_REALARRAY(id%ROWSCA_loc)
+            IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NZ_loc)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%NZ_loc
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -2044,7 +1807,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT
                read(unit,iostat=err) id%NZ_loc
                if(err.ne.0) THEN
@@ -2056,11 +1819,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("NNZ_loc")
+         CASE(S_NNZ_loc)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%NNZ_loc
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -2070,7 +1833,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8
                read(unit,iostat=err) id%NNZ_loc
                if(err.ne.0) THEN
@@ -2082,215 +1845,67 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("IRN_loc")
-         CASE("JCN_loc")
-         CASE("A_loc")
-         CASE("NELT")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NELT
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NELT
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("NBLK")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NBLK
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NBLK
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("ELTPTR")
-         CASE("ELTVAR")
-         CASE("A_ELT")
-         CASE("PERM_IN")
-         CASE("BLKPTR")
-         CASE("BLKVAR")
-         CASE("RHS")
-         CASE("REDRHS")
-         CASE("RHS_SPARSE")
-         CASE("SOL_loc")
-         CASE("RHS_loc")
-         CASE("IRHS_SPARSE")
-         CASE("IRHS_PTR")
-         CASE("ISOL_loc")
-         CASE("IRHS_loc")
-         CASE("LRHS")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%LRHS
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%LRHS
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("NRHS")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NRHS
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NRHS
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("NZ_RHS")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NZ_RHS
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NZ_RHS
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("LRHS_loc")
-         CASE("Nloc_RHS")
-         CASE("LSOL_loc")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%LSOL_loc
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%LSOL_loc
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("LREDRHS")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%LREDRHS
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%LREDRHS
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("SYM_PERM")
+         CASE(S_IRN_loc)
+         CASE(S_JCN_loc)
+         CASE(S_A_loc)
+         CASE(S_NELT)
+           CALL MUMPS_SAVE_INT(id%NELT)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NBLK)
+           CALL MUMPS_SAVE_INT(id%NBLK)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_ELTPTR)
+         CASE(S_ELTVAR)
+         CASE(S_A_ELT)
+         CASE(S_PERM_IN)
+         CASE(S_BLKPTR)
+         CASE(S_BLKVAR)
+         CASE(S_COLIND)
+         CASE(S_PIVOTS)
+         CASE(S_RHS)
+         CASE(S_REDRHS)
+         CASE(S_ROWIND)
+         CASE(S_RHS_SPARSE)
+         CASE(S_SOL_loc)
+         CASE(S_RHS_loc)
+         CASE(S_IRHS_SPARSE)
+         CASE(S_IRHS_PTR)
+         CASE(S_ISOL_loc)
+         CASE(S_IRHS_loc)
+         CASE(S_LRHS)
+         CALL MUMPS_SAVE_INT(id%LRHS)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NRHS)
+         CALL MUMPS_SAVE_INT(id%NRHS)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NZ_RHS)
+         CALL MUMPS_SAVE_INT(id%NZ_RHS)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_LRHS_loc)
+         CALL MUMPS_SAVE_INT(id%LRHS_loc)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_Nloc_RHS)
+         CALL MUMPS_SAVE_INT(id%Nloc_RHS)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_LD_RHSINTR)
+         CALL MUMPS_SAVE_INT(id%LD_RHSINTR)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NSOL_loc)
+         CALL MUMPS_SAVE_INT(id%NSOL_loc)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_LSOL_loc)
+         CALL MUMPS_SAVE_INT(id%LSOL_loc)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_LREDRHS)
+         CALL MUMPS_SAVE_INT(id%LREDRHS)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_SYM_PERM)
             CALL SMUMPS_SAVE_INT_SHPTR_ARRAY(id%SYM_PERM
      &           ) 
             IF (id%INFO(1) .LT. 0 ) GOTO 100
-         CASE("UNS_PERM")
+         CASE(S_UNS_PERM)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%UNS_PERM)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%UNS_PERM,1)*SIZE_INT
@@ -2298,7 +1913,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%UNS_PERM)) THEN
                   write(unit,iostat=err) size(id%UNS_PERM,1)
                   if(err.ne.0) then
@@ -2330,7 +1945,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%UNS_PERM)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -2369,222 +1984,36 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("NPROW")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NPROW
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NPROW
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("NPCOL")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NPCOL
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               NbRecords(i1)=1
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NPCOL
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("MBLOCK")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%MBLOCK
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%MBLOCK
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("NBLOCK")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NBLOCK
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NBLOCK
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("SCHUR_MLOC")
-             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%SCHUR_MLOC
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%SCHUR_MLOC
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("SCHUR_NLOC")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%SCHUR_NLOC
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%SCHUR_NLOC
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("SCHUR_LLD")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%SCHUR_LLD
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%SCHUR_LLD
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("SIZE_SCHUR")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%SIZE_SCHUR
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               NbRecords(i1)=1
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%SIZE_SCHUR
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("SCHUR")
-         CASE("SCHUR_CINTERFACE")
-          CASE("LISTVAR_SCHUR")
-         CASE("MAPPING")
+         CASE(S_NPROW)
+         CALL MUMPS_SAVE_INT(id%NPROW)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NPCOL)
+         CALL MUMPS_SAVE_INT(id%NPCOL)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_MBLOCK)
+         CALL MUMPS_SAVE_INT(id%MBLOCK)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NBLOCK)
+         CALL MUMPS_SAVE_INT(id%NBLOCK)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_SCHUR_MLOC)
+         CALL MUMPS_SAVE_INT(id%SCHUR_MLOC)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_SCHUR_NLOC)
+         CALL MUMPS_SAVE_INT(id%SCHUR_NLOC)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_SCHUR_LLD)
+         CALL MUMPS_SAVE_INT(id%SCHUR_LLD)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_SIZE_SCHUR)
+         CALL MUMPS_SAVE_INT(id%SIZE_SCHUR)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_SCHUR)
+         CASE(S_SCHUR_CINTERFACE)
+          CASE(S_LISTVAR_SCHUR)
+         CASE(S_MAPPING)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%MAPPING)) THEN
                   SIZE_GEST(i1)=SIZE_INT8
                   SIZE_VARIABLES(i1)=id%KEEP8(28)*SIZE_INT
@@ -2592,7 +2021,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT8+SIZE_INT
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%MAPPING)) THEN
                   write(unit,iostat=err) id%KEEP8(28)
                   if(err.ne.0) then
@@ -2624,7 +2053,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%MAPPING)
                read(unit,iostat=err) size_array_INT8_1
                if(err.ne.0) THEN
@@ -2663,12 +2092,12 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("VERSION_NUMBER")
+         CASE(S_VERSION_NUMBER)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=len(id%VERSION_NUMBER)
      &              *SIZE_CHARACTER
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%VERSION_NUMBER
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -2678,7 +2107,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=len(id%VERSION_NUMBER)
      &              *SIZE_CHARACTER
                read(unit,iostat=err) id%VERSION_NUMBER
@@ -2691,12 +2120,12 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("OOC_TMPDIR")
+         CASE(S_OOC_TMPDIR)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=len(id%OOC_TMPDIR)
      &              *SIZE_CHARACTER
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%OOC_TMPDIR
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -2706,7 +2135,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=len(id%OOC_TMPDIR)
      &              *SIZE_CHARACTER
                read(unit,iostat=err) id%OOC_TMPDIR
@@ -2719,12 +2148,12 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("OOC_PREFIX")
+         CASE(S_OOC_PREFIX)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=len(id%OOC_PREFIX)
      &              *SIZE_CHARACTER
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%OOC_PREFIX
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -2735,7 +2164,7 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
                NbRecords(i1)=1
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=len(id%OOC_PREFIX)
      &              *SIZE_CHARACTER
                read(unit,iostat=err) id%OOC_PREFIX
@@ -2748,12 +2177,12 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("WRITE_PROBLEM")
+         CASE(S_WRITE_PROBLEM)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=len(id%WRITE_PROBLEM)
      &              *SIZE_CHARACTER
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%WRITE_PROBLEM
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -2763,7 +2192,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=len(id%WRITE_PROBLEM)
      &              *SIZE_CHARACTER
                read(unit,iostat=err) id%WRITE_PROBLEM
@@ -2776,11 +2205,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("MAX_SURF_MASTER")
+         CASE(S_MAX_SURF_MASTER)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%MAX_SURF_MASTER
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -2790,7 +2219,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8
                read(unit,iostat=err) id%MAX_SURF_MASTER
                if(err.ne.0) THEN
@@ -2802,181 +2231,43 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("INST_Number")
-               NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%INST_Number
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%INST_Number
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("COMM_NODES")
-            if(trim(mode).EQ."memory_save") then
+         CASE(S_INST_Number)
+           CALL MUMPS_SAVE_INT(id%INST_Number)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_COMM_NODES)
+            if(mode.EQ.memory_save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
             endif
-         CASE("MYID_NODES")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%MYID_NODES
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%MYID_NODES
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("COMM_LOAD")
-            if(trim(mode).EQ."memory_save") then
+         CASE(S_MYID_NODES)
+           CALL MUMPS_SAVE_INT(id%MYID_NODES)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_COMM_LOAD)
+            if(mode.EQ.memory_save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
             endif
-         CASE("MYID")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%MYID
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%MYID
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("NPROCS")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NPROCS
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NPROCS
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("NSLAVES")
-             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NSLAVES
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NSLAVES
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("ASS_IRECV")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%ASS_IRECV
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%ASS_IRECV
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif  
-         CASE("IS")
+         CASE(S_MYID)
+           CALL MUMPS_SAVE_INT(id%MYID)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NPROCS)
+           CALL MUMPS_SAVE_INT(id%NPROCS)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NSLAVES)
+           CALL MUMPS_SAVE_INT(id%NSLAVES)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_ASS_IRECV)
+           CALL MUMPS_SAVE_INT(id%ASS_IRECV)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_IS)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%IS)) THEN
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=id%KEEP(32)*SIZE_INT
@@ -2986,7 +2277,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*3
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%IS)) THEN
                   write(unit,iostat=err) size(id%IS,1),id%KEEP(32)
                   if(err.ne.0) then
@@ -3020,7 +2311,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%IS)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -3061,91 +2352,22 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("Deficiency")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%Deficiency
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%Deficiency
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("LNA")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%LNA
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%LNA
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("NBSA")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NBSA
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NBSA
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("STEP")
+         CASE(S_Deficiency)
+           CALL MUMPS_SAVE_INT(id%Deficiency)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_LNA)
+           CALL MUMPS_SAVE_INT(id%LNA)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NBSA)
+           CALL MUMPS_SAVE_INT(id%NBSA)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_STEP)
             CALL SMUMPS_SAVE_INT_SHPTR_ARRAY(id%STEP
      &           ) 
             IF (id%INFO(1) .LT. 0 ) GOTO 100
-         CASE("NE_STEPS")
+         CASE(S_NE_STEPS)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%NE_STEPS)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%NE_STEPS,1)*SIZE_INT
@@ -3153,7 +2375,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%NE_STEPS)) THEN
                   write(unit,iostat=err) size(id%NE_STEPS,1)
                   if(err.ne.0) then
@@ -3185,7 +2407,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%NE_STEPS)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3224,9 +2446,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("ND_STEPS")
+         CASE(S_ND_STEPS)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%ND_STEPS)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%ND_STEPS,1)*SIZE_INT
@@ -3234,7 +2456,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%ND_STEPS)) THEN
                   write(unit,iostat=err) size(id%ND_STEPS,1)
                   if(err.ne.0) then
@@ -3266,7 +2488,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%ND_STEPS)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3305,9 +2527,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("Step2node")
+         CASE(S_Step2node)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%Step2node)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%Step2node,1)*SIZE_INT
@@ -3315,7 +2537,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%Step2node)) THEN
                   write(unit,iostat=err) size(id%Step2node,1)
                   if(err.ne.0) then
@@ -3347,7 +2569,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%Step2node)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3386,9 +2608,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("FRERE_STEPS")
+         CASE(S_FRERE_STEPS)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%FRERE_STEPS)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%FRERE_STEPS,1)*SIZE_INT
@@ -3396,7 +2618,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%FRERE_STEPS)) THEN
                   write(unit,iostat=err) size(id%FRERE_STEPS,1)
                   if(err.ne.0) then
@@ -3428,7 +2650,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%FRERE_STEPS)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3467,9 +2689,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("DAD_STEPS")
+         CASE(S_DAD_STEPS)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%DAD_STEPS)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%DAD_STEPS,1)*SIZE_INT
@@ -3477,7 +2699,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%DAD_STEPS)) THEN
                   write(unit,iostat=err) size(id%DAD_STEPS,1)
                   if(err.ne.0) then
@@ -3509,7 +2731,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%DAD_STEPS)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3548,13 +2770,13 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("FILS")
+         CASE(S_FILS)
             CALL SMUMPS_SAVE_INT_SHPTR_ARRAY(id%FILS
      &           ) 
             IF ( id%INFO(1) .LT. 0 ) GOTO 100
-         CASE("PTR8ARR")
+         CASE(S_PTR8ARR)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%PTR8ARR)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%PTR8ARR,1)*SIZE_INT8
@@ -3562,7 +2784,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PTR8ARR)) THEN
                   write(unit,iostat=err) size(id%PTR8ARR,1)
                   if(err.ne.0) then
@@ -3595,7 +2817,7 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
                NbRecords(i1)=2
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PTR8ARR)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3634,9 +2856,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("NINCOLARR")
+         CASE(S_NINCOLARR)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                NbRecords(i1)=2
                IF(associated(id%NINCOLARR)) THEN
                   SIZE_GEST(i1)=SIZE_INT
@@ -3645,7 +2867,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%NINCOLARR)) THEN
                   write(unit,iostat=err) size(id%NINCOLARR,1)
                   if(err.ne.0) then
@@ -3677,7 +2899,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%NINCOLARR)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3716,9 +2938,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("NINROWARR")
+         CASE(S_NINROWARR)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                NbRecords(i1)=2
                IF(associated(id%NINROWARR)) THEN
                   SIZE_GEST(i1)=SIZE_INT
@@ -3727,7 +2949,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%NINROWARR)) THEN
                   write(unit,iostat=err) size(id%NINROWARR,1)
                   if(err.ne.0) then
@@ -3759,7 +2981,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%NINROWARR)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3798,9 +3020,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PTRDEBARR")
+         CASE(S_PTRDEBARR)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                NbRecords(i1)=2
                IF(associated(id%PTRDEBARR)) THEN
                   SIZE_GEST(i1)=SIZE_INT
@@ -3809,7 +3031,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PTRDEBARR)) THEN
                   write(unit,iostat=err) size(id%PTRDEBARR,1)
                   if(err.ne.0) then
@@ -3841,7 +3063,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PTRDEBARR)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3880,9 +3102,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PTRAR")
+         CASE(S_PTRAR)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%PTRAR)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%PTRAR,1)*SIZE_INT8
@@ -3890,7 +3112,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PTRAR)) THEN
                   write(unit,iostat=err) size(id%PTRAR,1)
                   if(err.ne.0) then
@@ -3923,7 +3145,7 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
                NbRecords(i1)=2
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PTRAR)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3962,9 +3184,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("FRTPTR")
+         CASE(S_FRTPTR)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%FRTPTR)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%FRTPTR,1)*SIZE_INT
@@ -3972,7 +3194,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%FRTPTR)) THEN
                   write(unit,iostat=err) size(id%FRTPTR,1)
                   if(err.ne.0) then
@@ -4004,7 +3226,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%FRTPTR)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -4042,9 +3264,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("FRTELT")
+         CASE(S_FRTELT)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%FRTELT)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%FRTELT,1)*SIZE_INT
@@ -4052,7 +3274,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%FRTELT)) THEN
                   write(unit,iostat=err) size(id%FRTELT,1)
                   if(err.ne.0) then
@@ -4078,7 +3300,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%FRTELT)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -4117,9 +3339,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("NA")
+         CASE(S_NA)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%NA)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%NA,1)*SIZE_INT
@@ -4127,7 +3349,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%NA)) THEN
                   write(unit,iostat=err) size(id%NA,1)
                   if(err.ne.0) then
@@ -4153,7 +3375,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%NA)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -4192,9 +3414,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PROCNODE_STEPS")
+         CASE(S_PROCNODE_STEPS)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                NbRecords(i1)=2
                IF(associated(id%PROCNODE_STEPS)) THEN
                   SIZE_GEST(i1)=SIZE_INT
@@ -4203,7 +3425,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PROCNODE_STEPS)) THEN
                   write(unit,iostat=err) size(id%PROCNODE_STEPS,1)
                   if(err.ne.0) then
@@ -4235,7 +3457,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PROCNODE_STEPS)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -4274,9 +3496,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PTLUST_S")
+         CASE(S_PTLUST_S)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%PTLUST_S)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%PTLUST_S,1)*SIZE_INT
@@ -4284,7 +3506,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PTLUST_S)) THEN
                   write(unit,iostat=err) size(id%PTLUST_S,1)
                   if(err.ne.0) then
@@ -4316,7 +3538,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PTLUST_S)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -4355,9 +3577,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PTRFAC")
+         CASE(S_PTRFAC)
             NbRecords(i1)=2  
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%PTRFAC)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%PTRFAC,1)*SIZE_INT8
@@ -4365,7 +3587,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PTRFAC)) THEN
                   write(unit,iostat=err) size(id%PTRFAC,1)
                   if(err.ne.0) then
@@ -4396,7 +3618,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PTRFAC)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -4435,9 +3657,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("S")
+         CASE(S_S)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%S)) THEN
                   SIZE_GEST(i1)=SIZE_INT8*2
                   SIZE_VARIABLES(i1)=id%KEEP8(31)*SIZE_ARITH_DEP
@@ -4447,7 +3669,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT8*2+SIZE_INT
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%S)) THEN
                   write(unit,iostat=err) id%KEEP8(23),id%KEEP8(31)
                   if(err.ne.0) then
@@ -4482,7 +3704,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%S)
                read(unit,iostat=err) size_array_INT8_1,size_array_INT8_2
                if(err.ne.0) THEN
@@ -4524,62 +3746,16 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PROCNODE")
-         CASE("NELT_loc")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NELT_loc
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NELT_loc
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("LELTVAR")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%LELTVAR
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%LELTVAR
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("ELTPROC")
+         CASE(S_PROCNODE)
+         CASE(S_NELT_loc)
+           CALL MUMPS_SAVE_INT(id%NELT_loc)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_LELTVAR)
+           CALL MUMPS_SAVE_INT(id%LELTVAR)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_ELTPROC)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%ELTPROC)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%ELTPROC,1)*SIZE_INT
@@ -4587,7 +3763,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%ELTPROC)) THEN
                   write(unit,iostat=err) size(id%ELTPROC,1)
                   if(err.ne.0) then
@@ -4619,7 +3795,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%ELTPROC)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -4658,9 +3834,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("I4_L0_OMP")
+         CASE(S_I4_L0_OMP)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%I4_L0_OMP)) THEN
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=size(id%I4_L0_OMP,1)
@@ -4669,7 +3845,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*3
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%I4_L0_OMP)) THEN
                   write(unit,iostat=err) size(id%I4_L0_OMP,1)
      &                 ,size(id%I4_L0_OMP,2)
@@ -4702,7 +3878,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%I4_L0_OMP)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -4742,9 +3918,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("I8_L0_OMP")
+         CASE(S_I8_L0_OMP)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%I8_L0_OMP)) THEN
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=size(id%I8_L0_OMP,1)
@@ -4753,7 +3929,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*3
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%I8_L0_OMP)) THEN
                   write(unit,iostat=err) size(id%I8_L0_OMP,1)
      &                 ,size(id%I8_L0_OMP,2)
@@ -4786,7 +3962,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%I8_L0_OMP)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -4826,9 +4002,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("CANDIDATES")
+         CASE(S_CANDIDATES)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%CANDIDATES)) THEN
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=size(id%CANDIDATES,1)
@@ -4837,7 +4013,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*3
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%CANDIDATES)) THEN
                   write(unit,iostat=err) size(id%CANDIDATES,1)
      &                 ,size(id%CANDIDATES,2)
@@ -4870,7 +4046,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%CANDIDATES)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -4910,9 +4086,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("ISTEP_TO_INIV2")
+         CASE(S_ISTEP_TO_INIV2)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%ISTEP_TO_INIV2)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%ISTEP_TO_INIV2,1)*SIZE_INT
@@ -4920,7 +4096,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%ISTEP_TO_INIV2)) THEN
                   write(unit,iostat=err) size(id%ISTEP_TO_INIV2,1)
                   if(err.ne.0) then
@@ -4952,7 +4128,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%ISTEP_TO_INIV2)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -4991,9 +4167,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("FUTURE_NIV2")
+         CASE(S_FUTURE_NIV2)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%FUTURE_NIV2)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%FUTURE_NIV2,1)*SIZE_INT
@@ -5001,7 +4177,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%FUTURE_NIV2)) THEN
                   write(unit,iostat=err) size(id%FUTURE_NIV2,1)
                   if(err.ne.0) then
@@ -5033,7 +4209,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%FUTURE_NIV2)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -5072,9 +4248,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("TAB_POS_IN_PERE")
+         CASE(S_TAB_POS_IN_PERE)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%TAB_POS_IN_PERE)) THEN
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=size(id%TAB_POS_IN_PERE,1)
@@ -5083,7 +4259,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*3
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%TAB_POS_IN_PERE)) THEN
                   write(unit,iostat=err) size(id%TAB_POS_IN_PERE,1)
      &                 ,size(id%TAB_POS_IN_PERE,2)
@@ -5116,7 +4292,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%TAB_POS_IN_PERE)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -5156,9 +4332,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("I_AM_CAND")
+         CASE(S_I_AM_CAND)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%I_AM_CAND)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%I_AM_CAND,1)*SIZE_LOGICAL
@@ -5166,7 +4342,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%I_AM_CAND)) THEN
                   write(unit,iostat=err) size(id%I_AM_CAND,1)
                   if(err.ne.0) then
@@ -5198,7 +4374,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%I_AM_CAND)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -5237,9 +4413,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("MEM_DIST")
+         CASE(S_MEM_DIST)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%MEM_DIST)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%MEM_DIST,1)*SIZE_INT
@@ -5247,7 +4423,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%MEM_DIST)) THEN
                   write(unit,iostat=err) size(id%MEM_DIST,1)
                   if(err.ne.0) then
@@ -5277,7 +4453,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%MEM_DIST)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -5316,20 +4492,20 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("POSINRHSCOMP_ROW")
+         CASE(S_GLOB2LOC_RHS)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
-               IF(associated(id%POSINRHSCOMP_ROW)) THEN
+            if(mode.EQ.memory_save_mode) then
+               IF(associated(id%GLOB2LOC_RHS)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
-     &                 size(id%POSINRHSCOMP_ROW,1)*SIZE_INT
+     &                 size(id%GLOB2LOC_RHS,1)*SIZE_INT
                ELSE
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
-               IF(associated(id%POSINRHSCOMP_ROW)) THEN
-                  write(unit,iostat=err) size(id%POSINRHSCOMP_ROW,1)
+            elseif(mode.EQ.save_mode) then
+               IF(associated(id%GLOB2LOC_RHS)) THEN
+                  write(unit,iostat=err) size(id%GLOB2LOC_RHS,1)
                   if(err.ne.0) then
                      id%INFO(1) = -72
                      CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
@@ -5338,7 +4514,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-                  write(unit,iostat=err) id%POSINRHSCOMP_ROW
+                  write(unit,iostat=err) id%GLOB2LOC_RHS
                ELSE
                   write(unit,iostat=err) -999
                   if(err.ne.0) then
@@ -5359,8 +4535,8 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               nullify(id%POSINRHSCOMP_ROW)
+            elseif(mode.EQ.restore_mode) then
+               nullify(id%GLOB2LOC_RHS)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
                   id%INFO(1) = -75
@@ -5377,7 +4553,7 @@ C
                else
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size_array1*SIZE_INT
-                  allocate(id%POSINRHSCOMP_ROW(size_array1), 
+                  allocate(id%GLOB2LOC_RHS(size_array1), 
      &                 stat=allocok)
                   if (allocok .GT. 0) THEN
                      id%INFO(1) = -78
@@ -5385,7 +4561,7 @@ C
      &                    TOTAL_STRUC_SIZE-size_allocated
      &                    ,id%INFO(2))
                   endif
-                  read(unit,iostat=err) id%POSINRHSCOMP_ROW
+                  read(unit,iostat=err) id%GLOB2LOC_RHS
                endif
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
@@ -5399,12 +4575,12 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("POSINRHSCOMP_COL_ALLOC")
+         CASE(S_GLOB2LOC_SOL_ALLOC)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_LOGICAL
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%POSINRHSCOMP_COL_ALLOC
+            elseif(mode.EQ.save_mode) then
+               write(unit,iostat=err) id%GLOB2LOC_SOL_ALLOC
                if(err.ne.0) then
                   id%INFO(1) = -72
                   CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
@@ -5413,9 +4589,9 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_LOGICAL
-               read(unit,iostat=err) id%POSINRHSCOMP_COL_ALLOC
+               read(unit,iostat=err) id%GLOB2LOC_SOL_ALLOC
                if(err.ne.0) THEN
                   id%INFO(1) = -75
                   CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
@@ -5425,14 +4601,14 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("POSINRHSCOMP_COL")
+         CASE(S_GLOB2LOC_SOL)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
-               IF(associated(id%POSINRHSCOMP_COL)) THEN
-                  IF(id%POSINRHSCOMP_COL_ALLOC) THEN
+            if(mode.EQ.memory_save_mode) then
+               IF(associated(id%GLOB2LOC_SOL)) THEN
+                  IF(id%GLOB2LOC_SOL_ALLOC) THEN
                      SIZE_GEST(i1)=SIZE_INT
                      SIZE_VARIABLES(i1)=
-     &                    size(id%POSINRHSCOMP_COL,1)*SIZE_INT
+     &                    size(id%GLOB2LOC_SOL,1)*SIZE_INT
                   ELSE
                      SIZE_GEST(i1)=SIZE_INT*2
                      SIZE_VARIABLES(i1)=0_8
@@ -5441,10 +4617,10 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
-               IF(associated(id%POSINRHSCOMP_COL)) THEN
-                  IF(id%POSINRHSCOMP_COL_ALLOC) THEN
-                     write(unit,iostat=err) size(id%POSINRHSCOMP_COL,1)
+            elseif(mode.EQ.save_mode) then
+               IF(associated(id%GLOB2LOC_SOL)) THEN
+                  IF(id%GLOB2LOC_SOL_ALLOC) THEN
+                     write(unit,iostat=err) size(id%GLOB2LOC_SOL,1)
                      if(err.ne.0) then
                         id%INFO(1) = -72
                         CALL MUMPS_SETI8TOI4(
@@ -5454,9 +4630,9 @@ C
                      CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                    id%COMM, id%MYID )
                      IF ( id%INFO(1) .LT. 0 ) GOTO 100
-                     write(unit,iostat=err) id%POSINRHSCOMP_COL
+                     write(unit,iostat=err) id%GLOB2LOC_SOL
                   ELSE
-                     write(unit,iostat=err) size(id%POSINRHSCOMP_COL,1)
+                     write(unit,iostat=err) size(id%GLOB2LOC_SOL,1)
                      if(err.ne.0) then
                         id%INFO(1) = -72
                         CALL MUMPS_SETI8TOI4(
@@ -5488,8 +4664,8 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               nullify(id%POSINRHSCOMP_COL)
+            elseif(mode.EQ.restore_mode) then
+               nullify(id%GLOB2LOC_SOL)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
                   id%INFO(1) = -75
@@ -5504,10 +4680,10 @@ C
                   SIZE_VARIABLES(i1)=0_8
                   read(unit,iostat=err) dummy
                else
-                  if(id%POSINRHSCOMP_COL_ALLOC) then
+                  if(id%GLOB2LOC_SOL_ALLOC) then
                      SIZE_GEST(i1)=SIZE_INT
                      SIZE_VARIABLES(i1)=size_array1*SIZE_INT
-                     allocate(id%POSINRHSCOMP_COL(size_array1), 
+                     allocate(id%GLOB2LOC_SOL(size_array1), 
      &                    stat=allocok)
                      if (allocok .GT. 0) THEN
                         id%INFO(1) = -78
@@ -5515,12 +4691,12 @@ C
      &                       TOTAL_STRUC_SIZE-size_allocated
      &                       ,id%INFO(2))
                      endif
-                     read(unit,iostat=err) id%POSINRHSCOMP_COL
+                     read(unit,iostat=err) id%GLOB2LOC_SOL
                   else
                      SIZE_GEST(i1)=SIZE_INT*2
                      SIZE_VARIABLES(i1)=0_8
                      read(unit,iostat=err) dummy
-                     id%POSINRHSCOMP_COL=>id%POSINRHSCOMP_ROW
+                     id%GLOB2LOC_SOL=>id%GLOB2LOC_RHS
                   endif
                endif
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
@@ -5535,18 +4711,18 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("RHSCOMP")
+         CASE(S_RHSINTR)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
-               IF(associated(id%RHSCOMP)) THEN
+            if(mode.EQ.memory_save_mode) then
+               IF(associated(id%RHSINTR)) THEN
                   SIZE_GEST(i1)=SIZE_INT8
                   SIZE_VARIABLES(i1)=id%KEEP8(25)*SIZE_ARITH_DEP
                ELSE
                   SIZE_GEST(i1)=SIZE_INT8+SIZE_INT
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
-               IF(associated(id%RHSCOMP)) THEN
+            elseif(mode.EQ.save_mode) then
+               IF(associated(id%RHSINTR)) THEN
                   write(unit,iostat=err) id%KEEP8(25)
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -5556,7 +4732,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-                  write(unit,iostat=err) id%RHSCOMP
+                  write(unit,iostat=err) id%RHSINTR
                ELSE
                   write(unit,iostat=err) int(-999,8)
                   if(err.ne.0) then
@@ -5577,8 +4753,8 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               nullify(id%RHSCOMP)
+            elseif(mode.EQ.restore_mode) then
+               nullify(id%RHSINTR)
                read(unit,iostat=err) size_array_INT8_1
                if(err.ne.0) THEN
                   id%INFO(1) = -75
@@ -5595,14 +4771,14 @@ C
                else
                   SIZE_GEST(i1)=SIZE_INT8
                   SIZE_VARIABLES(i1)=size_array_INT8_1*SIZE_ARITH_DEP
-                  allocate(id%RHSCOMP(size_array_INT8_1), stat=allocok)
+                  allocate(id%RHSINTR(size_array_INT8_1), stat=allocok)
                   if (allocok .GT. 0) THEN
                      id%INFO(1) = -78
                      CALL MUMPS_SETI8TOI4(
      &                    TOTAL_STRUC_SIZE-size_allocated
      &                    ,id%INFO(2))
                   endif
-                  read(unit,iostat=err) id%RHSCOMP
+                  read(unit,iostat=err) id%RHSINTR
                endif
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
@@ -5616,9 +4792,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("MEM_SUBTREE")
+         CASE(S_MEM_SUBTREE)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%MEM_SUBTREE)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
@@ -5627,7 +4803,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%MEM_SUBTREE)) THEN
                   write(unit,iostat=err) size(id%MEM_SUBTREE,1)
                   if(err.ne.0) then
@@ -5659,7 +4835,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%MEM_SUBTREE)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -5698,9 +4874,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("COST_TRAV")
+         CASE(S_COST_TRAV)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%COST_TRAV)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
@@ -5709,7 +4885,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%COST_TRAV)) THEN
                   write(unit,iostat=err) size(id%COST_TRAV,1)
                   if(err.ne.0) then
@@ -5741,7 +4917,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%COST_TRAV)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -5780,9 +4956,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("MY_ROOT_SBTR")
+         CASE(S_MY_ROOT_SBTR)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%MY_ROOT_SBTR)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%MY_ROOT_SBTR,1)*SIZE_INT
@@ -5790,7 +4966,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%MY_ROOT_SBTR)) THEN
                   write(unit,iostat=err) size(id%MY_ROOT_SBTR,1)
                   if(err.ne.0) then
@@ -5822,7 +4998,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%MY_ROOT_SBTR)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -5861,9 +5037,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("MY_FIRST_LEAF")
+         CASE(S_MY_FIRST_LEAF)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%MY_FIRST_LEAF)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%MY_FIRST_LEAF,1)*SIZE_INT
@@ -5871,7 +5047,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%MY_FIRST_LEAF)) THEN
                   write(unit,iostat=err) size(id%MY_FIRST_LEAF,1)
                   if(err.ne.0) then
@@ -5903,7 +5079,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%MY_FIRST_LEAF)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -5942,9 +5118,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("MY_NB_LEAF")
+         CASE(S_MY_NB_LEAF)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%MY_NB_LEAF)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%MY_NB_LEAF,1)*SIZE_INT
@@ -5952,7 +5128,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%MY_NB_LEAF)) THEN
                   write(unit,iostat=err) size(id%MY_NB_LEAF,1)
                   if(err.ne.0) then
@@ -5984,7 +5160,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%MY_NB_LEAF)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -6023,9 +5199,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("DEPTH_FIRST")
+         CASE(S_DEPTH_FIRST)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%DEPTH_FIRST)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%DEPTH_FIRST,1)*SIZE_INT
@@ -6033,7 +5209,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%DEPTH_FIRST)) THEN
                   write(unit,iostat=err) size(id%DEPTH_FIRST,1)
                   if(err.ne.0) then
@@ -6065,7 +5241,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%DEPTH_FIRST)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -6104,9 +5280,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("DEPTH_FIRST_SEQ")
+         CASE(S_DEPTH_FIRST_SEQ)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%DEPTH_FIRST_SEQ)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%DEPTH_FIRST_SEQ,1)*SIZE_INT
@@ -6114,7 +5290,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%DEPTH_FIRST_SEQ)) THEN
                   write(unit,iostat=err) size(id%DEPTH_FIRST_SEQ,1)
                   if(err.ne.0) then
@@ -6146,7 +5322,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%DEPTH_FIRST_SEQ)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -6186,9 +5362,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("SBTR_ID")
+         CASE(S_SBTR_ID)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%SBTR_ID)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%SBTR_ID,1)*SIZE_INT
@@ -6196,7 +5372,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%SBTR_ID)) THEN
                   write(unit,iostat=err) size(id%SBTR_ID,1)
                   if(err.ne.0) then
@@ -6228,7 +5404,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%SBTR_ID)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -6267,100 +5443,31 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("SCHED_DEP")
-         CASE("SCHED_GRP")
-         CASE("CROIX_MANU")
-         CASE("WK_USER")
-         CASE("NBSA_LOCAL")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NBSA_LOCAL
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NBSA_LOCAL
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("LWK_USER")
-            if(trim(mode).EQ."memory_save") then
+         CASE(S_SCHED_DEP)
+         CASE(S_SCHED_GRP)
+         CASE(S_CROIX_MANU)
+         CASE(S_WK_USER)
+         CASE(S_NBSA_LOCAL)
+           CALL MUMPS_SAVE_INT(id%NBSA_LOCAL)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_LWK_USER)
+            if(mode.EQ.memory_save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
             endif
-         CASE("CB_SON_SIZE")
-         CASE("INSTANCE_NUMBER")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%INSTANCE_NUMBER
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%INSTANCE_NUMBER
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("OOC_MAX_NB_NODES_FOR_ZONE")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%OOC_MAX_NB_NODES_FOR_ZONE
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%OOC_MAX_NB_NODES_FOR_ZONE
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("OOC_INODE_SEQUENCE")
+         CASE(S_CB_SON_SIZE)
+         CASE(S_INSTANCE_NUMBER)
+           CALL MUMPS_SAVE_INT(id%INSTANCE_NUMBER)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_OOC_MAX_NB_NODES_FOR_ZONE)
+           CALL MUMPS_SAVE_INT(id%OOC_MAX_NB_NODES_FOR_ZONE)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_OOC_INODE_SEQUENCE)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%OOC_INODE_SEQUENCE)) THEN
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=size(id%OOC_INODE_SEQUENCE,1)
@@ -6369,7 +5476,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*3
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%OOC_INODE_SEQUENCE)) THEN
                   write(unit,iostat=err) size(id%OOC_INODE_SEQUENCE,1)
      &                 ,size(id%OOC_INODE_SEQUENCE,2)
@@ -6402,7 +5509,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%OOC_INODE_SEQUENCE)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -6442,9 +5549,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("OOC_SIZE_OF_BLOCK")
+         CASE(S_OOC_SIZE_OF_BLOCK)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%OOC_SIZE_OF_BLOCK)) THEN
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=size(id%OOC_SIZE_OF_BLOCK,1)
@@ -6453,7 +5560,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*3
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%OOC_SIZE_OF_BLOCK)) THEN
                   write(unit,iostat=err) size(id%OOC_SIZE_OF_BLOCK,1)
      &                 ,size(id%OOC_SIZE_OF_BLOCK,2)
@@ -6486,7 +5593,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%OOC_SIZE_OF_BLOCK)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -6526,9 +5633,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("OOC_VADDR")
+         CASE(S_OOC_VADDR)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%OOC_VADDR)) THEN
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=size(id%OOC_VADDR,1)
@@ -6537,7 +5644,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*3
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%OOC_VADDR)) THEN
                   write(unit,iostat=err) size(id%OOC_VADDR,1)
      &                 ,size(id%OOC_VADDR,2)
@@ -6570,7 +5677,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%OOC_VADDR)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -6610,9 +5717,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("OOC_TOTAL_NB_NODES")
+         CASE(S_OOC_TOTAL_NB_NODES)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%OOC_TOTAL_NB_NODES)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
@@ -6621,7 +5728,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%OOC_TOTAL_NB_NODES)) THEN
                   write(unit,iostat=err) size(id%OOC_TOTAL_NB_NODES,1)
                   if(err.ne.0) then
@@ -6653,7 +5760,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%OOC_TOTAL_NB_NODES)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -6693,13 +5800,13 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("OOC_NB_FILES")
-         CASE("OOC_NB_FILE_TYPE")
-         CASE("OOC_FILE_NAMES")
-         CASE("OOC_FILE_NAME_LENGTH")
-         CASE("PIVNUL_LIST")
+         CASE(S_OOC_NB_FILES)
+         CASE(S_OOC_NB_FILE_TYPE)
+         CASE(S_OOC_FILE_NAMES)
+         CASE(S_OOC_FILE_NAME_LENGTH)
+         CASE(S_PIVNUL_LIST)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%PIVNUL_LIST)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%PIVNUL_LIST,1)*SIZE_INT
@@ -6707,7 +5814,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PIVNUL_LIST)) THEN
                   write(unit,iostat=err) size(id%PIVNUL_LIST,1)
                   if(err.ne.0) then
@@ -6739,7 +5846,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PIVNUL_LIST)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -6778,10 +5885,10 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("SUP_PROC")
-         CASE("IPTR_WORKING")
+         CASE(S_SUP_PROC)
+         CASE(S_IPTR_WORKING)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%IPTR_WORKING)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%IPTR_WORKING,1)*SIZE_INT
@@ -6789,7 +5896,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%IPTR_WORKING)) THEN
                   write(unit,iostat=err) size(id%IPTR_WORKING,1)
                   if(err.ne.0) then
@@ -6821,7 +5928,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%IPTR_WORKING)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -6860,9 +5967,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("WORKING")
+         CASE(S_WORKING)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%WORKING)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%WORKING,1)*SIZE_INT
@@ -6870,7 +5977,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%WORKING)) THEN
                   write(unit,iostat=err) size(id%WORKING,1)
                   if(err.ne.0) then
@@ -6902,7 +6009,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%WORKING)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -6941,15 +6048,14 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("root")
+         CASE(S_root)
             DO i2=1,NBVARIABLES_ROOT
-            TMP_STRING2 = VARIABLES_ROOT(i2)
-            SELECT CASE(TMP_STRING2)
-            CASE("MBLOCK")
+            SELECT CASE(i2)
+            CASE(R_MBLOCK)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%MBLOCK
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -6959,7 +6065,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%MBLOCK
                   if(err.ne.0) THEN
@@ -6971,11 +6077,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("NBLOCK")
+            CASE(R_NBLOCK)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%NBLOCK
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -6985,7 +6091,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100        
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%NBLOCK
                   if(err.ne.0) THEN
@@ -6997,11 +6103,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-            CASE("NPROW")
+            CASE(R_NPROW)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%NPROW
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7011,7 +6117,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100                 
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%NPROW
                   if(err.ne.0) THEN
@@ -7023,11 +6129,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("NPCOL")
+            CASE(R_NPCOL)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%NPCOL
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7037,7 +6143,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100                
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%NPCOL
                   if(err.ne.0) THEN
@@ -7049,12 +6155,12 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("MYROW")
+            CASE(R_MYROW)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   NbRecords_ROOT(i2)=1
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%MYROW
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7064,7 +6170,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%MYROW
                   if(err.ne.0) THEN
@@ -7076,11 +6182,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("MYCOL")
+            CASE(R_MYCOL)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%MYCOL
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7090,7 +6196,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%MYCOL
                   if(err.ne.0) THEN
@@ -7102,11 +6208,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("SCHUR_MLOC")
+            CASE(R_SCHUR_MLOC)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%SCHUR_MLOC
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7116,7 +6222,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%SCHUR_MLOC
                   if(err.ne.0) THEN
@@ -7128,11 +6234,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("SCHUR_NLOC")
+            CASE(R_SCHUR_NLOC)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%SCHUR_NLOC
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7142,7 +6248,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%SCHUR_NLOC
                   if(err.ne.0) THEN
@@ -7154,11 +6260,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("SCHUR_LLD")
+            CASE(R_SCHUR_LLD)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%SCHUR_LLD
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7168,7 +6274,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%SCHUR_LLD
                   if(err.ne.0) THEN
@@ -7180,11 +6286,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("RHS_NLOC")
+            CASE(R_RHS_NLOC)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%RHS_NLOC
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7194,7 +6300,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%RHS_NLOC
                   if(err.ne.0) THEN
@@ -7206,11 +6312,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("ROOT_SIZE")
+            CASE(R_ROOT_SIZE)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%ROOT_SIZE
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7220,7 +6326,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%ROOT_SIZE
                   if(err.ne.0) THEN
@@ -7232,11 +6338,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("TOT_ROOT_SIZE")
+            CASE(R_TOT_ROOT_SIZE)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%TOT_ROOT_SIZE
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7246,7 +6352,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%TOT_ROOT_SIZE
                   if(err.ne.0) THEN
@@ -7258,12 +6364,12 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("DESCRIPTOR")
+            CASE(R_DESCRIPTOR)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=size(id%root%DESCRIPTOR,1)
      &                 *SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%DESCRIPTOR
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7273,7 +6379,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT*
      &                 size(id%root%DESCRIPTOR,1)
                   read(unit,iostat=err) id%root%DESCRIPTOR
@@ -7286,11 +6392,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("CNTXT_BLACS")
+            CASE(R_CNTXT_BLACS)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%CNTXT_BLACS
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7300,7 +6406,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%CNTXT_BLACS
                   if(err.ne.0) THEN
@@ -7312,11 +6418,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("LPIV")
+            CASE(R_LPIV)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%LPIV
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7326,7 +6432,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%LPIV
                   if(err.ne.0) THEN
@@ -7338,10 +6444,10 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("RG2L")
-            CASE("IPIV")
+            CASE(R_RG2L)
+            CASE(R_IPIV)
                NbRecords_ROOT(i2)=2
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   IF(associated(id%root%IPIV)) THEN
                      SIZE_GEST_ROOT(i2)=SIZE_INT
                      SIZE_VARIABLES_ROOT(i2)=
@@ -7350,7 +6456,7 @@ C
                      SIZE_GEST_ROOT(i2)=SIZE_INT*2
                      SIZE_VARIABLES_ROOT(i2)=0_8
                   ENDIF
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   IF(associated(id%root%IPIV)) THEN
                      write(unit,iostat=err) size(id%root%IPIV,1)
                      if(err.ne.0) then
@@ -7384,7 +6490,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   nullify(id%root%IPIV)
                   read(unit,iostat=err) size_array1
                   if(err.ne.0) THEN
@@ -7423,9 +6529,9 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("RHS_CNTR_MASTER_ROOT")
+            CASE(R_RHS_CNTR_MASTER_ROOT)
                NbRecords_ROOT(i2)=2
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   IF(associated(id%root%RHS_CNTR_MASTER_ROOT)) THEN
                      SIZE_GEST_ROOT(i2)=SIZE_INT
                      SIZE_VARIABLES_ROOT(i2)=
@@ -7435,7 +6541,7 @@ C
                      SIZE_GEST_ROOT(i2)=SIZE_INT*2
                      SIZE_VARIABLES_ROOT(i2)=0_8
                   ENDIF
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   IF(associated(id%root%RHS_CNTR_MASTER_ROOT)) THEN
                      write(unit,iostat=err) 
      &                    size(id%root%RHS_CNTR_MASTER_ROOT,1)
@@ -7470,7 +6576,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   nullify(id%root%RHS_CNTR_MASTER_ROOT)
                   read(unit,iostat=err) size_array1
                   if(err.ne.0) THEN
@@ -7510,11 +6616,94 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("SCHUR_POINTER")
-            CASE("QR_TAU")
-            CASE("RHS_ROOT")
+            CASE(R_SCHUR_POINTER)
+            CASE(R_QR_TAU)
                NbRecords_ROOT(i2)=2
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
+                  IF(associated(id%root%QR_TAU)) THEN
+                     SIZE_GEST_ROOT(i2)=SIZE_INT
+                     SIZE_VARIABLES_ROOT(i2)=
+     &                    size(id%root%QR_TAU,1)*SIZE_ARITH_DEP
+                  ELSE
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*2
+                     SIZE_VARIABLES_ROOT(i2)=0_8
+                  ENDIF
+               elseif(mode.EQ.save_mode) then
+                  IF(associated(id%root%QR_TAU)) THEN
+                     write(unit,iostat=err) size(id%root%QR_TAU,1)
+                     if(err.ne.0) then
+                        id%INFO(1) = -72
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_FILE_SIZE-size_written
+     &                       ,id%INFO(2))
+                     endif
+                     CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                    id%COMM, id%MYID )
+                     IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                     write(unit,iostat=err) id%root%QR_TAU
+                  ELSE
+                     write(unit,iostat=err) -999
+                     if(err.ne.0) then
+                        id%INFO(1) = -72
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_FILE_SIZE-size_written
+     &                       ,id%INFO(2))
+                     endif
+                     CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                    id%COMM, id%MYID )
+                     IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                     write(unit,iostat=err) -999
+                  ENDIF 
+                  if(err.ne.0) then
+                     id%INFO(1) = -72
+                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written
+     &                    ,id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               elseif(mode.EQ.restore_mode) then
+                  nullify(id%root%QR_TAU)
+                  read(unit,iostat=err) size_array1
+                  if(err.ne.0) THEN
+                     id%INFO(1) = -75
+                     CALL MUMPS_SETI8TOI4(SIZE_VARIABLES_ROOT(i2),
+     &                    id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                  if(size_array1.EQ.-999) then
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*2
+                     SIZE_VARIABLES_ROOT(i2)=0_8
+                     read(unit,iostat=err) dummy
+                  else
+                     SIZE_GEST_ROOT(i2)=SIZE_INT
+                     SIZE_VARIABLES_ROOT(i2)=size_array1*SIZE_ARITH_DEP
+                     allocate(id%root%QR_TAU(size_array1), stat=allocok)
+                     if (allocok .GT. 0) THEN
+                        id%INFO(1) = -78
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_STRUC_SIZE-size_allocated
+     &                       ,id%INFO(2))
+                     endif
+                     read(unit,iostat=err) id%root%QR_TAU
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                  if(err.ne.0) THEN
+                     id%INFO(1) = -75
+                     CALL MUMPS_SETI8TOI4(SIZE_VARIABLES_ROOT(i2),
+     &                    id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               endif
+            CASE(R_RHS_ROOT)
+               NbRecords_ROOT(i2)=2
+               if(mode.EQ.memory_save_mode) then
                   IF(associated(id%root%RHS_ROOT)) THEN
                      SIZE_GEST_ROOT(i2)=SIZE_INT*2
                      SIZE_VARIABLES_ROOT(i2)=size(id%root%RHS_ROOT,1)
@@ -7523,7 +6712,7 @@ C
                      SIZE_GEST_ROOT(i2)=SIZE_INT*3
                      SIZE_VARIABLES_ROOT(i2)=0_8
                   ENDIF
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   IF(associated(id%root%RHS_ROOT)) THEN
                      write(unit,iostat=err) size(id%root%RHS_ROOT,1)
      &                    ,size(id%root%RHS_ROOT,2)
@@ -7558,7 +6747,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   nullify(id%root%RHS_ROOT)
                   read(unit,iostat=err) size_array1,size_array2
                   if(err.ne.0) THEN
@@ -7599,11 +6788,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("QR_RCOND")
+            CASE(R_QR_RCOND)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_RL_OR_DBL
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%QR_RCOND
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7613,7 +6802,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_RL_OR_DBL
                   read(unit,iostat=err) id%root%QR_RCOND
                   if(err.ne.0) THEN
@@ -7625,11 +6814,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("yes")
+            CASE(R_yes)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_LOGICAL
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%yes
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7639,7 +6828,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_LOGICAL
                   read(unit,iostat=err) id%root%yes
                   if(err.ne.0) THEN
@@ -7651,11 +6840,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("gridinit_done")
+            CASE(R_gridinit_done)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_LOGICAL
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%gridinit_done
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7665,7 +6854,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_LOGICAL
                   read(unit,iostat=err) id%root%gridinit_done
                   if(err.ne.0) THEN
@@ -7677,14 +6866,272 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("SVD_U")
-            CASE("SVD_VT")
-            CASE("SINGULAR_VALUES")
-            CASE("NB_SINGULAR_VALUES")
+            CASE(R_SVD_U)
+               NbRecords_ROOT(i2)=2
+               if(mode.EQ.memory_save_mode) then
+                  IF(associated(id%root%SVD_U)) THEN
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*2
+                     SIZE_VARIABLES_ROOT(i2)=size(id%root%SVD_U,1)
+     &                    *size(id%root%SVD_U,2)*SIZE_ARITH_DEP
+                  ELSE
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*3
+                     SIZE_VARIABLES_ROOT(i2)=0_8
+                  ENDIF
+               elseif(mode.EQ.save_mode) then
+                  IF(associated(id%root%SVD_U)) THEN
+                     write(unit,iostat=err) size(id%root%SVD_U,1)
+     &                    ,size(id%root%SVD_U,2)
+                     if(err.ne.0) then
+                        id%INFO(1) = -72
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_FILE_SIZE-size_written
+     &                       ,id%INFO(2))
+                     endif
+                     CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                    id%COMM, id%MYID )
+                     IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                     write(unit,iostat=err) id%root%SVD_U
+                  ELSE
+                     write(unit,iostat=err) -999,-998
+                     if(err.ne.0) then
+                        id%INFO(1) = -72
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_FILE_SIZE-size_written
+     &                       ,id%INFO(2))
+                     endif
+                     CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                    id%COMM, id%MYID )
+                     IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                     write(unit,iostat=err) -999
+                  ENDIF 
+                  if(err.ne.0) then
+                     id%INFO(1) = -72
+                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written
+     &                    ,id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               elseif(mode.EQ.restore_mode) then
+                  nullify(id%root%SVD_U)
+                  read(unit,iostat=err) size_array1,size_array2
+                  if(err.ne.0) THEN
+                     id%INFO(1) = -75
+                     CALL MUMPS_SETI8TOI4(SIZE_VARIABLES_ROOT(i2),
+     &                    id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                  if(size_array1.EQ.-999) then
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*3
+                     SIZE_VARIABLES_ROOT(i2)=0_8
+                     read(unit,iostat=err) dummy
+                  else
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*2
+                     SIZE_VARIABLES_ROOT(i2)=size_array1*size_array2
+     &                    *SIZE_ARITH_DEP
+                     allocate(id%root%SVD_U(size_array1,size_array2),
+     &                    stat=allocok)
+                     if (allocok .GT. 0) THEN
+                        id%INFO(1) = -78
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_STRUC_SIZE-size_allocated
+     &                       ,id%INFO(2))
+                     endif
+                     read(unit,iostat=err) id%root%SVD_U
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                  if(err.ne.0) THEN
+                     id%INFO(1) = -75
+                     CALL MUMPS_SETI8TOI4(SIZE_VARIABLES_ROOT(i2),
+     &                    id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               endif
+            CASE(R_SVD_VT)
+               NbRecords_ROOT(i2)=2
+               if(mode.EQ.memory_save_mode) then
+                  IF(associated(id%root%SVD_VT)) THEN
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*2
+                     SIZE_VARIABLES_ROOT(i2)=size(id%root%SVD_VT,1)
+     &                    *size(id%root%SVD_VT,2)*SIZE_ARITH_DEP
+                  ELSE
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*3
+                     SIZE_VARIABLES_ROOT(i2)=0_8
+                  ENDIF
+               elseif(mode.EQ.save_mode) then
+                  IF(associated(id%root%SVD_VT)) THEN
+                     write(unit,iostat=err) size(id%root%SVD_VT,1)
+     &                    ,size(id%root%SVD_VT,2)
+                     if(err.ne.0) then
+                        id%INFO(1) = -72
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_FILE_SIZE-size_written
+     &                       ,id%INFO(2))
+                     endif
+                     CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                    id%COMM, id%MYID )
+                     IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                     write(unit,iostat=err) id%root%SVD_VT
+                  ELSE
+                     write(unit,iostat=err) -999,-998
+                     if(err.ne.0) then
+                        id%INFO(1) = -72
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_FILE_SIZE-size_written
+     &                       ,id%INFO(2))
+                     endif
+                     CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                    id%COMM, id%MYID )
+                     IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                     write(unit,iostat=err) -999
+                  ENDIF 
+                  if(err.ne.0) then
+                     id%INFO(1) = -72
+                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written
+     &                    ,id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               elseif(mode.EQ.restore_mode) then
+                  nullify(id%root%SVD_VT)
+                  read(unit,iostat=err) size_array1,size_array2
+                  if(err.ne.0) THEN
+                     id%INFO(1) = -75
+                     CALL MUMPS_SETI8TOI4(SIZE_VARIABLES_ROOT(i2),
+     &                    id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                  if(size_array1.EQ.-999) then
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*3
+                     SIZE_VARIABLES_ROOT(i2)=0_8
+                     read(unit,iostat=err) dummy
+                  else
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*2
+                     SIZE_VARIABLES_ROOT(i2)=size_array1*size_array2
+     &                    *SIZE_ARITH_DEP
+                     allocate(id%root%SVD_VT(size_array1,size_array2),
+     &                    stat=allocok)
+                     if (allocok .GT. 0) THEN
+                        id%INFO(1) = -78
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_STRUC_SIZE-size_allocated
+     &                       ,id%INFO(2))
+                     endif
+                     read(unit,iostat=err) id%root%SVD_VT
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                  if(err.ne.0) THEN
+                     id%INFO(1) = -75
+                     CALL MUMPS_SETI8TOI4(SIZE_VARIABLES_ROOT(i2),
+     &                    id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               endif
+            CASE(R_SINGULAR_VALUES)
+               NbRecords_ROOT(i2)=2
+               if(mode.EQ.memory_save_mode) then
+                  IF(associated(id%root%SINGULAR_VALUES)) THEN
+                     SIZE_GEST_ROOT(i2)=SIZE_INT
+                     SIZE_VARIABLES_ROOT(i2)=
+     &                    size(id%root%SINGULAR_VALUES,1)
+     &                    *SIZE_RL_OR_DBL
+                  ELSE
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*2
+                     SIZE_VARIABLES_ROOT(i2)=0_8
+                  ENDIF
+               elseif(mode.EQ.save_mode) then
+                  IF(associated(id%root%SINGULAR_VALUES)) THEN
+                     write(unit,iostat=err) 
+     &                    size(id%root%SINGULAR_VALUES,1)
+                     if(err.ne.0) then
+                        id%INFO(1) = -72
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_FILE_SIZE-size_written
+     &                       ,id%INFO(2))
+                     endif
+                     CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                    id%COMM, id%MYID )
+                     IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                     write(unit,iostat=err) id%root%SINGULAR_VALUES
+                  ELSE
+                     write(unit,iostat=err) -999
+                     if(err.ne.0) then
+                        id%INFO(1) = -72
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_FILE_SIZE-size_written
+     &                       ,id%INFO(2))
+                     endif
+                     CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                    id%COMM, id%MYID )
+                     IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                     write(unit,iostat=err) -999
+                  ENDIF 
+                  if(err.ne.0) then
+                     id%INFO(1) = -72
+                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written
+     &                    ,id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               elseif(mode.EQ.restore_mode) then
+                  nullify(id%root%SINGULAR_VALUES)
+                  read(unit,iostat=err) size_array1
+                  if(err.ne.0) THEN
+                     id%INFO(1) = -75
+                     CALL MUMPS_SETI8TOI4(SIZE_VARIABLES_ROOT(i2)
+     &                    ,id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                  if(size_array1.EQ.-999) then
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*2
+                     SIZE_VARIABLES_ROOT(i2)=0_8
+                     read(unit,iostat=err) dummy
+                  else
+                     SIZE_GEST_ROOT(i2)=SIZE_INT
+                     SIZE_VARIABLES_ROOT(i2)=size_array1*SIZE_RL_OR_DBL
+                     allocate(id%root%SINGULAR_VALUES(size_array1),
+     &                    stat=allocok)
+                     if (allocok .GT. 0) THEN
+                        id%INFO(1) = -78
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_STRUC_SIZE-size_allocated
+     &                       ,id%INFO(2))
+                     endif
+                     read(unit,iostat=err) id%root%SINGULAR_VALUES
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                  if(err.ne.0) THEN
+                     id%INFO(1) = -75
+                     CALL MUMPS_SETI8TOI4(SIZE_VARIABLES_ROOT(i2)
+     &                    ,id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               endif
+            CASE(R_NB_SINGULAR_VALUES)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%NB_SINGULAR_VALUES
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7694,7 +7141,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%NB_SINGULAR_VALUES
                   if(err.ne.0) THEN
@@ -7706,23 +7153,23 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("rootpad0","rootpad1","rootpad2","rootpad",
-     &              "rootpad3","rootpad4")
+            CASE(R_rootpad0,R_rootpad1,R_rootpad2,
+     &           R_rootpad3,R_rootpad4)
             CASE DEFAULT
             END SELECT
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                NbSubRecords=int(SIZE_VARIABLES_ROOT(i2)/huge(I4))
                IF(NbSubRecords.GT.0) then
                   NbRecords_ROOT(i2)=NbRecords_ROOT(i2)+NbSubRecords
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                size_written=size_written+SIZE_VARIABLES_ROOT(i2)
      &              +SIZE_GEST_ROOT(i2)
 #if defined(MUMPS_NOF2003)
                size_written=size_written
      &              +int(2*id%KEEP(34)*NbRecords_ROOT(i2),kind=8)
 #endif
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                size_allocated=size_allocated+SIZE_VARIABLES_ROOT(i2)+
      &              DIFF_SIZE_ALLOC_READ_ROOT(i2)
                size_read=size_read+SIZE_VARIABLES_ROOT(i2)
@@ -7731,53 +7178,30 @@ C
                size_read=size_read
      &              +int(2*id%KEEP(34)*NbRecords_ROOT(i2),kind=8)
 #endif
-            elseif(trim(mode).EQ."fake_restore") then
+            elseif(mode.EQ.fake_restore_mode) then
             endif
          ENDDO
-         CASE("NBGRP")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NBGRP
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NBGRP
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-        CASE("LRGROUPS")
+         CASE(S_NBGRP)
+           CALL MUMPS_SAVE_INT(id%NBGRP)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_LRGROUPS)
             CALL SMUMPS_SAVE_INT_SHPTR_ARRAY(id%LRGROUPS
      &           ) 
             IF (id%INFO(1) .LT. 0 ) GOTO 100
-         CASE("FDM_F_ENCODING")
+         CASE(S_FDM_F_ENCODING)
             NbRecords(i1)=1
             SIZE_GEST(i1)=SIZE_INT
             SIZE_VARIABLES(i1)=0_8
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%FDM_F_ENCODING)) THEN
                   CALL MUMPS_SAVE_RESTORE_FRONT_DATA(id%FDM_F_ENCODING
-     &                 ,unit,id%MYID,"memory_save"
+     &                 ,unit,id%MYID,memory_save_mode
      &                 ,SIZE_GEST_FRONT_DATA,SIZE_VARIABLES_FRONT_DATA
      &                 ,SIZE_INT,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
      &                 ,size_read,size_allocated,size_written
      &                 ,id%INFO(1))                 
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%FDM_F_ENCODING)) THEN
                   write(unit,iostat=err) size(id%FDM_F_ENCODING,1)
                   if(err.ne.0) then
@@ -7789,7 +7213,7 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                   CALL MUMPS_SAVE_RESTORE_FRONT_DATA(id%FDM_F_ENCODING
-     &                 ,unit,id%MYID,"save"
+     &                 ,unit,id%MYID,save_mode
      &                 ,SIZE_GEST_FRONT_DATA,SIZE_VARIABLES_FRONT_DATA
      &                 ,SIZE_INT,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
      &                 ,size_read,size_allocated,size_written
@@ -7813,7 +7237,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%FDM_F_ENCODING)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -7826,7 +7250,7 @@ C
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
                if(size_array1.NE.-999) then
                   CALL MUMPS_SAVE_RESTORE_FRONT_DATA(id%FDM_F_ENCODING
-     &                 ,unit,id%MYID,"restore"
+     &                 ,unit,id%MYID,restore_mode
      &                 ,SIZE_GEST_FRONT_DATA,SIZE_VARIABLES_FRONT_DATA
      &                 ,SIZE_INT,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
      &                 ,size_read,size_allocated,size_written
@@ -7844,21 +7268,21 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("BLRARRAY_ENCODING")            
+         CASE(S_BLRARRAY_ENCODING)            
             NbRecords(i1)=1
             SIZE_GEST(i1)=SIZE_INT
             SIZE_VARIABLES(i1)=0_8
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%BLRARRAY_ENCODING)) THEN
                   CALL SMUMPS_SAVE_RESTORE_BLR(id%BLRARRAY_ENCODING
-     &                 ,unit,id%MYID,"memory_save"
+     &                 ,unit,id%MYID,memory_save_mode
      &                 ,SIZE_GEST_BLR,SIZE_VARIABLES_BLR
      &                 ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
      &                 ,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
      &                 ,size_read,size_allocated,size_written
      &                 ,id%INFO(1))                 
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%BLRARRAY_ENCODING)) THEN
                   write(unit,iostat=err) size(id%BLRARRAY_ENCODING,1)
                   if(err.ne.0) then
@@ -7870,7 +7294,7 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                   CALL SMUMPS_SAVE_RESTORE_BLR(id%BLRARRAY_ENCODING
-     &                 ,unit,id%MYID,"save"
+     &                 ,unit,id%MYID,save_mode
      &                 ,SIZE_GEST_BLR,SIZE_VARIABLES_BLR
      &                 ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
      &                 ,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
@@ -7895,7 +7319,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%BLRARRAY_ENCODING)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -7908,7 +7332,7 @@ C
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
                if(size_array1.NE.-999) then
                   CALL SMUMPS_SAVE_RESTORE_BLR(id%BLRARRAY_ENCODING
-     &                 ,unit,id%MYID,"restore"
+     &                 ,unit,id%MYID,restore_mode
      &                 ,SIZE_GEST_BLR,SIZE_VARIABLES_BLR
      &                 ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
      &                 ,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
@@ -7927,179 +7351,41 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("L0_OMP_FACTORS")
+         CASE(S_L0_OMP_FACTORS)
             NbRecords(i1)     =0   
             SIZE_GEST(i1)     =0   
             SIZE_VARIABLES(i1)=0_8 
             CALL SMUMPS_SAVE_RESTORE_L0FACARRAY(id%L0_OMP_FACTORS
-     &                 ,unit,id%MYID,trim(mode)
+     &                 ,unit,id%MYID,mode
      &                 ,SIZE_GEST_L0FAC,SIZE_VARIABLES_L0FAC
      &                 ,SIZE_INT, SIZE_INT8, SIZE_ARITH_DEP
      &                 ,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
      &                 ,size_read,size_allocated,size_written
      &                 ,id%INFO(1))                 
-         CASE("SCHED_SBTR")
-         CASE("LPOOL_A_L0_OMP")
+         CASE(S_SCHED_SBTR)
+         CASE(S_LPOOL_A_L0_OMP)
+           CALL MUMPS_SAVE_INT(id%LPOOL_A_L0_OMP)
+           IF ( id%INFO(1) .LT. 0 ) GOTO 100
+         CASE(S_LPOOL_B_L0_OMP)
+           CALL MUMPS_SAVE_INT(id%LPOOL_B_L0_OMP)
+           IF ( id%INFO(1) .LT. 0 ) GOTO 100
+         CASE(S_L_PHYS_L0_OMP)
+           CALL MUMPS_SAVE_INT(id%L_PHYS_L0_OMP)
+           IF ( id%INFO(1) .LT. 0 ) GOTO 100
+         CASE(S_L_VIRT_L0_OMP)     
+           CALL MUMPS_SAVE_INT(id%L_VIRT_L0_OMP)
+           IF ( id%INFO(1) .LT. 0 ) GOTO 100
+         CASE(S_LL0_OMP_MAPPING)
+           CALL MUMPS_SAVE_INT(id%LL0_OMP_MAPPING)
+           IF ( id%INFO(1) .LT. 0 ) GOTO 100
+         CASE(S_LL0_OMP_FACTORS)
+           CALL MUMPS_SAVE_INT(id%LL0_OMP_FACTORS)
+           IF ( id%INFO(1) .LT. 0 ) GOTO 100
+         CASE(S_THREAD_LA)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%LPOOL_A_L0_OMP
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%LPOOL_A_L0_OMP
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("LPOOL_B_L0_OMP")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%LPOOL_B_L0_OMP
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%LPOOL_B_L0_OMP
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("L_PHYS_L0_OMP")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%L_PHYS_L0_OMP
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%L_PHYS_L0_OMP
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("L_VIRT_L0_OMP")     
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%L_VIRT_L0_OMP
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%L_VIRT_L0_OMP
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("LL0_OMP_MAPPING")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%LL0_OMP_MAPPING
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%LL0_OMP_MAPPING
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("LL0_OMP_FACTORS")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%LL0_OMP_FACTORS
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%LL0_OMP_FACTORS
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("THREAD_LA")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%THREAD_LA
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -8109,7 +7395,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8
                read(unit,iostat=err) id%THREAD_LA
                if(err.ne.0) THEN
@@ -8121,9 +7407,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("IPOOL_A_L0_OMP")
+         CASE(S_IPOOL_A_L0_OMP)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%IPOOL_A_L0_OMP)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
@@ -8132,7 +7418,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%IPOOL_A_L0_OMP)) THEN
                   write(unit,iostat=err) size(id%IPOOL_A_L0_OMP,1)
                   if(err.ne.0) then
@@ -8164,7 +7450,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%IPOOL_A_L0_OMP)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -8204,9 +7490,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("IPOOL_B_L0_OMP")
+         CASE(S_IPOOL_B_L0_OMP)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%IPOOL_B_L0_OMP)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
@@ -8215,7 +7501,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%IPOOL_B_L0_OMP)) THEN
                   write(unit,iostat=err) size(id%IPOOL_B_L0_OMP,1)
                   if(err.ne.0) then
@@ -8247,7 +7533,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%IPOOL_B_L0_OMP)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -8287,9 +7573,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PHYS_L0_OMP")
+         CASE(S_PHYS_L0_OMP)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%PHYS_L0_OMP)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
@@ -8298,7 +7584,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PHYS_L0_OMP)) THEN
                   write(unit,iostat=err) size(id%PHYS_L0_OMP,1)
                   if(err.ne.0) then
@@ -8330,7 +7616,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PHYS_L0_OMP)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -8369,9 +7655,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("VIRT_L0_OMP")
+         CASE(S_VIRT_L0_OMP)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%VIRT_L0_OMP)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%VIRT_L0_OMP,1)*SIZE_INT
@@ -8379,7 +7665,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%VIRT_L0_OMP)) THEN
                   write(unit,iostat=err) size(id%VIRT_L0_OMP,1)
                   if(err.ne.0) then
@@ -8411,7 +7697,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%VIRT_L0_OMP)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -8450,9 +7736,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("VIRT_L0_OMP_MAPPING")
+         CASE(S_VIRT_L0_OMP_MAPPING)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%VIRT_L0_OMP_MAPPING)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%VIRT_L0_OMP_MAPPING,1)
@@ -8461,7 +7747,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%VIRT_L0_OMP_MAPPING)) THEN
                   write(unit,iostat=err) size(id%VIRT_L0_OMP_MAPPING,1)
                   if(err.ne.0) then
@@ -8493,7 +7779,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%VIRT_L0_OMP_MAPPING)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -8533,9 +7819,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PERM_L0_OMP")
+         CASE(S_PERM_L0_OMP)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%PERM_L0_OMP)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%PERM_L0_OMP,1)*SIZE_INT
@@ -8543,7 +7829,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PERM_L0_OMP)) THEN
                   write(unit,iostat=err) size(id%PERM_L0_OMP,1)
                   if(err.ne.0) then
@@ -8575,7 +7861,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PERM_L0_OMP)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -8614,9 +7900,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PTR_LEAFS_L0_OMP")
+         CASE(S_PTR_LEAFS_L0_OMP)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%PTR_LEAFS_L0_OMP)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
@@ -8625,7 +7911,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PTR_LEAFS_L0_OMP)) THEN
                   write(unit,iostat=err) size(id%PTR_LEAFS_L0_OMP,1)
                   if(err.ne.0) then
@@ -8657,7 +7943,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PTR_LEAFS_L0_OMP)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -8697,9 +7983,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("L0_OMP_MAPPING")
+         CASE(S_L0_OMP_MAPPING)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%L0_OMP_MAPPING)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
@@ -8708,7 +7994,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%L0_OMP_MAPPING)) THEN
                   write(unit,iostat=err) size(id%L0_OMP_MAPPING,1)
                   if(err.ne.0) then
@@ -8740,7 +8026,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%L0_OMP_MAPPING)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -8779,46 +8065,102 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("SINGULAR_VALUES")
-        CASE("NB_SINGULAR_VALUES")
-           NbRecords(i1)=1
-           if(trim(mode).EQ."memory_save") then
-              SIZE_VARIABLES(i1)=SIZE_INT
-           elseif(trim(mode).EQ."save") then
-              write(unit,iostat=err) id%NB_SINGULAR_VALUES
+         CASE(S_SINGULAR_VALUES)
+            NbRecords(i1)=2
+            if(mode.EQ.memory_save_mode) then
+               IF(associated(id%SINGULAR_VALUES)) THEN
+                  SIZE_GEST(i1)=SIZE_INT
+                  SIZE_VARIABLES(i1)=
+     &                 size(id%SINGULAR_VALUES,1)*SIZE_RL_OR_DBL
+              ELSE
+                 SIZE_GEST(i1)=SIZE_INT*2
+                 SIZE_VARIABLES(i1)=0_8
+              ENDIF
+           elseif(mode.EQ.save_mode) then
+              IF(associated(id%SINGULAR_VALUES)) THEN
+                 write(unit,iostat=err) size(id%SINGULAR_VALUES,1)
+                 if(err.ne.0) then
+                    id%INFO(1) = -72
+                    CALL MUMPS_SETI8TOI4(size_written,id%INFO(2))
+                 endif
+                 CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                id%COMM, id%MYID )
+                 IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                 write(unit,iostat=err) id%SINGULAR_VALUES
+              ELSE
+                 write(unit,iostat=err) -999
+                 if(err.ne.0) then
+                    id%INFO(1) = -72
+                    CALL MUMPS_SETI8TOI4(size_written,id%INFO(2))
+                 endif
+                 CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                id%COMM, id%MYID )
+                 IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                 write(unit,iostat=err) -999
+              ENDIF 
               if(err.ne.0) then
                  id%INFO(1) = -72
-                 CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                id%INFO(2))
+                 CALL MUMPS_SETI8TOI4(size_written,id%INFO(2))
               endif
               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &             id%COMM, id%MYID )
               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-           elseif(trim(mode).EQ."restore") then
-              SIZE_VARIABLES(i1)=SIZE_INT
-              read(unit,iostat=err) id%NB_SINGULAR_VALUES
-              if(err.ne.0) THEN
-                 id%INFO(1) = -75
-                 CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                ,id%INFO(2))
-              endif 
-              CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &             id%COMM, id%MYID )
-              IF ( id%INFO(1) .LT. 0 ) GOTO 100
+           elseif(mode.EQ.restore_mode) then
+              nullify(id%SINGULAR_VALUES)
+               read(unit,iostat=err) size_array1
+               if(err.ne.0) THEN
+                  id%INFO(1) = -75
+                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
+     &                 ,id%INFO(2))
+               endif
+               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &              id%COMM, id%MYID )
+               IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               if(size_array1.EQ.-999) then
+                  SIZE_GEST(i1)=SIZE_INT*2
+                  SIZE_VARIABLES(i1)=0_8
+                  read(unit,iostat=err) dummy
+               else
+                  SIZE_GEST(i1)=SIZE_INT
+                  SIZE_VARIABLES(i1)=size_array1*SIZE_RL_OR_DBL
+                  allocate(id%SINGULAR_VALUES(size_array1),
+     &                 stat=allocok)
+                  if (allocok .GT. 0) THEN
+                     id%INFO(1) = -78
+                     CALL MUMPS_SETI8TOI4(
+     &                    TOTAL_STRUC_SIZE-size_allocated
+     &                    ,id%INFO(2))
+                  endif
+                  read(unit,iostat=err) id%SINGULAR_VALUES
+               endif
+               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &              id%COMM, id%MYID )
+               IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               if(err.ne.0) THEN
+                  id%INFO(1) = -75
+                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
+     &                 ,id%INFO(2))
+               endif
+               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &              id%COMM, id%MYID )
+               IF ( id%INFO(1) .LT. 0 ) GOTO 100
            endif
-        CASE("ASSOCIATED_OOC_FILES")
-            if(trim(mode).EQ."memory_save") then
+        CASE(S_NB_SINGULAR_VALUES)
+           CALL MUMPS_SAVE_INT(id%NB_SINGULAR_VALUES)
+           IF ( id%INFO(1) .LT. 0 ) GOTO 100
+        CASE(S_ASSOCIATED_OOC_FILES)
+            if(mode.EQ.memory_save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_LOGICAL
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_LOGICAL
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_LOGICAL
             endif
-        CASE("SAVE_DIR")
+        CASE(S_SAVE_DIR)
            NbRecords(i1)=1
-           if(trim(mode).EQ."memory_save") then
+           if(mode.EQ.memory_save_mode) then
               SIZE_VARIABLES(i1)=len(id%SAVE_DIR)*SIZE_CHARACTER
-           elseif(trim(mode).EQ."save") then
+           elseif(mode.EQ.save_mode) then
               write(unit,iostat=err) id%SAVE_DIR
               if(err.ne.0) then
                  id%INFO(1) = -72
@@ -8828,7 +8170,7 @@ C
               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &             id%COMM, id%MYID )
               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-           elseif(trim(mode).EQ."restore") then
+           elseif(mode.EQ.restore_mode) then
               SIZE_VARIABLES(i1)=len(id%SAVE_DIR)*SIZE_CHARACTER
               read(unit,iostat=err) id%SAVE_DIR
               if(err.ne.0) THEN
@@ -8840,11 +8182,11 @@ C
      &             id%COMM, id%MYID )
               IF ( id%INFO(1) .LT. 0 ) GOTO 100
            endif
-        CASE("SAVE_PREFIX")
+        CASE(S_SAVE_PREFIX)
            NbRecords(i1)=1
-           if(trim(mode).EQ."memory_save") then
+           if(mode.EQ.memory_save_mode) then
               SIZE_VARIABLES(i1)=len(id%SAVE_PREFIX)*SIZE_CHARACTER
-           elseif(trim(mode).EQ."save") then
+           elseif(mode.EQ.save_mode) then
               write(unit,iostat=err) id%SAVE_PREFIX
               if(err.ne.0) then
                  id%INFO(1) = -72
@@ -8854,7 +8196,7 @@ C
               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &             id%COMM, id%MYID )
               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-           elseif(trim(mode).EQ."restore") then
+           elseif(mode.EQ.restore_mode) then
               SIZE_VARIABLES(i1)=len(id%SAVE_PREFIX)*SIZE_CHARACTER
               read(unit,iostat=err) id%SAVE_PREFIX
               if(err.ne.0) THEN
@@ -8866,20 +8208,20 @@ C
      &             id%COMM, id%MYID )
               IF ( id%INFO(1) .LT. 0 ) GOTO 100
            endif
-        CASE("MPITOOMP_PROCS_MAP")
+        CASE(S_MTKO_PROCS_MAP)
            NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
-               IF(associated(id%MPITOOMP_PROCS_MAP)) THEN
+            if(mode.EQ.memory_save_mode) then
+               IF(associated(id%MTKO_PROCS_MAP)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
-     &                 size(id%MPITOOMP_PROCS_MAP,1)*SIZE_INT
+     &                 size(id%MTKO_PROCS_MAP,1)*SIZE_INT
                ELSE
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
-               IF(associated(id%MPITOOMP_PROCS_MAP)) THEN
-                  write(unit,iostat=err) size(id%MPITOOMP_PROCS_MAP,1)
+            elseif(mode.EQ.save_mode) then
+               IF(associated(id%MTKO_PROCS_MAP)) THEN
+                  write(unit,iostat=err) size(id%MTKO_PROCS_MAP,1)
                   if(err.ne.0) then
                      id%INFO(1) = -72
                      CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
@@ -8888,7 +8230,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-                  write(unit,iostat=err) id%MPITOOMP_PROCS_MAP
+                  write(unit,iostat=err) id%MTKO_PROCS_MAP
                ELSE
                   write(unit,iostat=err) -999
                   if(err.ne.0) then
@@ -8909,8 +8251,8 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               nullify(id%MPITOOMP_PROCS_MAP)
+            elseif(mode.EQ.restore_mode) then
+               nullify(id%MTKO_PROCS_MAP)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
                   id%INFO(1) = -75
@@ -8927,7 +8269,7 @@ C
                else
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size_array1*SIZE_INT
-                  allocate(id%MPITOOMP_PROCS_MAP(size_array1),
+                  allocate(id%MTKO_PROCS_MAP(0:size_array1-1),
      &                 stat=allocok)
                   if (allocok .GT. 0) THEN
                      id%INFO(1) = -78
@@ -8935,7 +8277,7 @@ C
      &                    TOTAL_STRUC_SIZE-size_allocated
      &                    ,id%INFO(2))
                   endif
-                  read(unit,iostat=err) id%MPITOOMP_PROCS_MAP
+                  read(unit,iostat=err) id%MTKO_PROCS_MAP
                endif
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
@@ -8949,11 +8291,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("METIS_OPTIONS")
+         CASE(S_METIS_OPTIONS)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%METIS_OPTIONS,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%METIS_OPTIONS
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -8963,7 +8305,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%METIS_OPTIONS,1)
                read(unit,iostat=err) id%METIS_OPTIONS
                if(err.ne.0) THEN
@@ -8975,23 +8317,23 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif      
-      CASE("pad0","pad1","pad2","pad3","pad4","pad5","pad6","pad7",
-     &     "pad11","pad111", "pad12","pad13","pad14","pad15","pad16")
+      CASE(S_pad1,S_pad2,S_pad3,S_pad4,S_pad5,S_pad6,S_pad7,
+     &     S_pad11,S_pad12,S_pad13,S_pad14,S_pad16)
       CASE DEFAULT
       END SELECT
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          NbSubRecords=int(SIZE_VARIABLES(i1)/huge(I4))
          IF(NbSubRecords.GT.0) then
             NbRecords(i1)=NbRecords(i1)+NbSubRecords
          ENDIF
-      elseif(trim(mode).EQ."save") then
+      elseif(mode.EQ.save_mode) then
          size_written=size_written+SIZE_VARIABLES(i1)
      &        +int(SIZE_GEST(i1),kind=8)
 #if defined(MUMPS_NOF2003)
          size_written=size_written
      &        +int(2*id%KEEP(34)*NbRecords(i1),kind=8)
 #endif
-      elseif(trim(mode).EQ."restore") then
+      elseif(mode.EQ.restore_mode) then
          size_allocated=size_allocated+SIZE_VARIABLES(i1)+
      &        DIFF_SIZE_ALLOC_READ(i1)
          size_read=size_read+SIZE_VARIABLES(i1)
@@ -9000,11 +8342,11 @@ C
          size_read=size_read
      &        +int(2*id%KEEP(34)*NbRecords(i1),kind=8)
 #endif
-      elseif(trim(mode).EQ."fake_restore") then
+      elseif(mode.EQ.fake_restore_mode) then
       endif
       ENDDO
  200  continue
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          WRITTEN_STRUC_SIZE=sum(SIZE_VARIABLES)+sum(SIZE_VARIABLES_ROOT)
      &        +SIZE_VARIABLES_BLR+SIZE_VARIABLES_FRONT_DATA+
      &         SIZE_VARIABLES_L0FAC
@@ -9031,8 +8373,8 @@ C
          gest_size=gest_size+int(2*id%KEEP(34)*tot_NbRecords,kind=8)
 #endif
          TOTAL_FILE_SIZE=WRITTEN_STRUC_SIZE+gest_size
-      elseif(trim(mode).EQ."save") then
-      elseif(trim(mode).EQ."restore") then
+      elseif(mode.EQ.save_mode) then
+      elseif(mode.EQ.restore_mode) then
 #if ! defined(NOSCALAPACK)
          if(id%root%gridinit_done) then
             id%root%CNTXT_BLACS = id%COMM_NODES
@@ -9042,18 +8384,131 @@ C
             id%root%DESCRIPTOR(2) = id%root%CNTXT_BLACS
          endif
 #endif
-      elseif(trim(mode).EQ."fake_restore") then
-      elseif(trim(mode).EQ."restore_ooc") then
+      elseif(mode.EQ.fake_restore_mode) then
+      elseif(mode.EQ.restore_ooc_mode) then
       endif
  100  continue
-      deallocate(VARIABLES, VARIABLES_ROOT)
       RETURN
       CONTAINS
+      SUBROUTINE MUMPS_SAVERSTR_REALARRAY(idREAL)
+      IMPLICIT NONE
+      REAL, DIMENSION(:), POINTER :: idREAL
+      NbRecords(i1)=2
+      if(mode.EQ.memory_save_mode) then
+         IF(associated(idREAL)) THEN
+            SIZE_GEST(i1)=SIZE_INT
+            SIZE_VARIABLES(i1)=size(idREAL,1)*SIZE_RL_OR_DBL
+         ELSE
+            SIZE_GEST(i1)=SIZE_INT*2
+            SIZE_VARIABLES(i1)=0_8
+         ENDIF
+      elseif(mode.EQ.save_mode) then
+         IF(associated(idREAL)) THEN
+            write(unit,iostat=err) size(idreal,1)
+            if(err.ne.0) then
+               id%INFO(1) = -72
+               CALL MUMPS_SETI8TOI4(
+     &              TOTAL_FILE_SIZE-size_written,
+     &              id%INFO(2))
+            endif
+            write(unit,iostat=err) idREAL
+         ELSE
+            write(unit,iostat=err) -999
+            if(err.ne.0) then
+               id%INFO(1) = -72
+               CALL MUMPS_SETI8TOI4(
+     &         TOTAL_FILE_SIZE-size_written,
+     &         id%INFO(2))
+            endif
+            write(unit,iostat=err) -999
+         ENDIF 
+         if(err.ne.0) then
+               id%INFO(1) = -72
+               CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
+     &         id%INFO(2))
+         endif
+         CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+         IF ( id%INFO(1) .LT. 0 ) GOTO 100
+      elseif(mode.EQ.restore_mode) then
+         nullify(idREAL)
+         read(unit,iostat=err) size_array1
+         if (err.ne.0) THEN
+           id%INFO(1) = -75
+           CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
+     &                    ,id%INFO(2))
+         endif
+         CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+         IF ( id%INFO(1) .LT. 0 ) GOTO 100
+           if (size_array1.EQ.-999) then
+                     SIZE_GEST(i1)=SIZE_INT*2
+                     SIZE_VARIABLES(i1)=0_8
+                     read(unit,iostat=err) dummy
+           else
+                     SIZE_GEST(i1)=SIZE_INT
+                     SIZE_VARIABLES(i1)=size_array1*SIZE_RL_OR_DBL
+                     allocate(idREAL(size_array1), stat=allocok)
+                     if (allocok .GT. 0) THEN
+                        id%INFO(1) = -78
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_STRUC_SIZE-size_allocated
+     &                       ,id%INFO(2))
+                     endif
+                     read(unit,iostat=err) idREAL
+           endif
+           CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                          id%COMM, id%MYID )
+           IF ( id%INFO(1) .LT. 0 ) GOTO 100
+           if (err.ne.0) THEN
+               id%INFO(1) = -75
+               CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
+     &                    ,id%INFO(2))
+           endif 
+           CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                          id%COMM, id%MYID )
+           IF ( id%INFO(1) .LT. 0 ) GOTO 100
+      endif
+ 100  CONTINUE
+      RETURN
+      END SUBROUTINE MUMPS_SAVERSTR_REALARRAY
+      SUBROUTINE MUMPS_SAVE_INT(idINT)
+      IMPLICIT NONE
+      INTEGER, INTENT(INOUT) :: idINT
+      NbRecords(i1)=1
+      if(mode.EQ.memory_save_mode) then
+         SIZE_VARIABLES(i1)=SIZE_INT
+      elseif(mode.EQ.save_mode) then
+         write(unit,iostat=err) idINT
+         if(err.ne.0) then
+           id%INFO(1) = -72
+           CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
+     &          id%INFO(2))
+         endif
+         CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &        id%COMM, id%MYID )
+         IF ( id%INFO(1) .LT. 0 ) GOTO 100
+      elseif(mode.EQ.restore_mode) then
+         SIZE_VARIABLES(i1)=SIZE_INT
+         read(unit,iostat=err) idINT
+         if(err.ne.0) THEN
+            id%INFO(1) = -75
+            CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
+     &           ,id%INFO(2))
+         endif 
+         CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &        id%COMM, id%MYID )
+         IF ( id%INFO(1) .LT. 0 ) GOTO 100
+      endif
+ 100  CONTINUE
+      RETURN
+      END SUBROUTINE MUMPS_SAVE_INT
       SUBROUTINE SMUMPS_SAVE_INT_SHPTR_ARRAY(id_INTPTR
      &  )
+      IMPLICIT NONE
       INTEGER, POINTER, DIMENSION(:) :: id_INTPTR
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id_INTPTR)
      &            ) THEN
                   SIZE_GEST(i1)=SIZE_INT
@@ -9062,7 +8517,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id_INTPTR)
      &            ) THEN
                   write(unit,iostat=err) size(id_INTPTR,1)
@@ -9095,7 +8550,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id_INTPTR)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -9142,3 +8597,8 @@ C
       END SUBROUTINE SMUMPS_SAVE_INT_SHPTR_ARRAY
       END SUBROUTINE SMUMPS_SAVE_RESTORE_STRUCTURE
       END MODULE SMUMPS_SAVE_RESTORE
+#else
+      SUBROUTINE SMUMPS_SAVE_RESTORE_RETURN()
+      RETURN
+      END SUBROUTINE SMUMPS_SAVE_RESTORE_RETURN
+#endif
diff -pruN 5.6.2-2.1/src/smumps_save_restore_files.F 5.7.1-1/src/smumps_save_restore_files.F
--- 5.6.2-2.1/src/smumps_save_restore_files.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/smumps_save_restore_files.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -11,11 +11,11 @@ C  released under the CeCILL-C license
 C  (see doc/CeCILL-C_V1-en.txt, doc/CeCILL-C_V1-fr.txt, and
 C  https://cecill.info/licences/Licence_CeCILL-C_V1-en.html)
 C
+#if ! defined(NO_SAVE_RESTORE)
       MODULE SMUMPS_SAVE_RESTORE_FILES
       USE SMUMPS_STRUC_DEF
       IMPLICIT NONE
-      INTEGER :: LEN_SAVE_FILE
-      PARAMETER( LEN_SAVE_FILE = 550)
+      INTEGER, PARAMETER :: LEN_SAVE_FILE = 1318
       CONTAINS
       SUBROUTINE MUMPS_READ_HEADER(fileunit, ierr, size_read, SIZE_INT
      &     ,SIZE_INT8, TOTAL_FILE_SIZE, TOTAL_STRUC_SIZE
@@ -113,10 +113,6 @@ C
         size_read=size_read
      &           +int(2*SIZE_INT*1,kind=8)
 #endif
-#if defined(OOC_VERBOSE)
-        write(*,*) 'First ooc file: ',
-     &   READ_OOC_FIRST_FILE_NAME(1:READ_OOC_FILE_NAME_LENGTH-2)
-#endif
       ENDIF
  100  continue
       RETURN
@@ -237,60 +233,76 @@ C
       TYPE (SMUMPS_STRUC),intent(inout) :: id
       CHARACTER(len=LEN_SAVE_FILE),intent(out):: SAVE_FILE, INFO_FILE
       INTEGER::len_save_dir,len_save_prefix
-      CHARACTER(len=255):: tmp_savedir,savedir
-      CHARACTER(len=255):: tmp_saveprefix,saveprefix
+      INTEGER, PARAMETER :: SAVE_PREFIX_MAX_LENGTH =  255
+      INTEGER, PARAMETER :: SAVE_DIR_MAX_LENGTH    = 1023
+      CHARACTER(len=SAVE_DIR_MAX_LENGTH)    :: tmp_save_dir
+      CHARACTER(len=SAVE_DIR_MAX_LENGTH)    :: save_dir
+      CHARACTER(len=SAVE_PREFIX_MAX_LENGTH) :: save_prefix
+      CHARACTER(len=SAVE_PREFIX_MAX_LENGTH) :: tmp_save_prefix
       CHARACTER(len=10):: STRING_MYID
       CHARACTER:: LAST_CHAR_DIR
       INFO_FILE=''
       SAVE_FILE=''
-      tmp_savedir=''
-      tmp_saveprefix=''
+      tmp_save_dir=''
+      tmp_save_prefix=''
       IF(id%SAVE_DIR.EQ."NAME_NOT_INITIALIZED") THEN
-         call mumps_get_save_dir_C(len_save_dir,tmp_savedir)
-         if(tmp_savedir(1:len_save_dir).EQ."NAME_NOT_INITIALIZED") then
-            id%INFO(1) = -77
-            id%INFO(2) = 0 
+         call MUMPS_GET_SAVE_DIR_C(len_save_dir,tmp_save_dir)
+         len_save_dir=min(SAVE_DIR_MAX_LENGTH,len_save_dir)
+         if (len_save_dir > SAVE_DIR_MAX_LENGTH) then
+           id%INFO(1) = -77
+           id%INFO(2) = SAVE_DIR_MAX_LENGTH
+         else if(tmp_save_dir(1:len_save_dir).EQ."NAME_NOT_INITIALIZED")
+     &     then
+           id%INFO(1) = -77
+           id%INFO(2) = 0 
          else
-            savedir=trim(adjustl(tmp_savedir(1:len_save_dir)))
-            len_save_dir=len_trim(savedir(1:len_save_dir))
+           save_dir=trim(adjustl(tmp_save_dir(1:len_save_dir)))
+           len_save_dir=len_trim(save_dir(1:len_save_dir))
          endif
       ELSE
-         savedir=trim(adjustl(id%SAVE_DIR))
-         len_save_dir=len_trim(savedir)
+         save_dir=trim(adjustl(id%SAVE_DIR))
+         len_save_dir=len_trim(save_dir)
       ENDIF
       CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &     id%COMM, id%MYID )
       IF ( id%INFO(1) .LT. 0 ) GOTO 100
       IF(id%SAVE_PREFIX.EQ."NAME_NOT_INITIALIZED") THEN
-         call mumps_get_save_prefix_C(len_save_prefix,tmp_saveprefix)
-         if(tmp_saveprefix(1:len_save_prefix).EQ."NAME_NOT_INITIALIZED")
-     &        then
-            saveprefix="save"
-            len_save_prefix=len_trim(saveprefix)
-         else
-            saveprefix=
-     &           trim(adjustl(tmp_saveprefix(1:len_save_prefix)))
-            len_save_prefix=len_trim(saveprefix(1:len_save_prefix))
-         endif
+        call MUMPS_GET_SAVE_PREFIX_C(len_save_prefix,tmp_save_prefix)
+        len_save_prefix=min(SAVE_PREFIX_MAX_LENGTH,len_save_prefix)
+        if(len_save_prefix.GT.SAVE_PREFIX_MAX_LENGTH) then
+          id%INFO(1)=-77
+          id%INFO(2)=-SAVE_PREFIX_MAX_LENGTH
+        else if(tmp_save_prefix(1:len_save_prefix).EQ.
+     &  "NAME_NOT_INITIALIZED") then
+           save_prefix="save"
+           len_save_prefix=len_trim(save_prefix)
+        else
+           save_prefix=
+     &          trim(adjustl(tmp_save_prefix(1:len_save_prefix)))
+           len_save_prefix=len_trim(save_prefix(1:len_save_prefix))
+        endif
       ELSE
-         saveprefix=trim(adjustl(id%SAVE_PREFIX))
-         len_save_prefix=len_trim(saveprefix)
+        save_prefix=trim(adjustl(id%SAVE_PREFIX))
+        len_save_prefix=len_trim(save_prefix)
       ENDIF
+      CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &     id%COMM, id%MYID )
+      IF ( id%INFO(1) .LT. 0 ) GOTO 100
       write(STRING_MYID,'(I10)') id%MYID
-      LAST_CHAR_DIR=savedir(len_save_dir:len_save_dir)
+      LAST_CHAR_DIR=save_dir(len_save_dir:len_save_dir)
       if(LAST_CHAR_DIR.NE."/") then
-         SAVE_FILE=trim(adjustl(savedir))//"/"
+         SAVE_FILE=trim(adjustl(save_dir))//"/"
       else
-         SAVE_FILE=trim(adjustl(savedir))
+         SAVE_FILE=trim(adjustl(save_dir))
       endif
       INFO_FILE=trim(adjustl(SAVE_FILE))
       SAVE_FILE=trim(adjustl(SAVE_FILE))
-     &     //trim(adjustl(saveprefix))
+     &     //trim(adjustl(save_prefix))
      &     //"_"
      &     //trim(adjustl(STRING_MYID))
      &     //".mumps"
       INFO_FILE=trim(adjustl(INFO_FILE))
-     &        //trim(adjustl(saveprefix))
+     &        //trim(adjustl(save_prefix))
      &        //"_"
      &        //trim(adjustl(STRING_MYID))
      &        //".info"
@@ -323,3 +335,8 @@ C
       ENDIF
       END SUBROUTINE SMUMPS_CHECK_FILE_NAME      
       END MODULE SMUMPS_SAVE_RESTORE_FILES
+#else
+      SUBROUTINE SMUMPS_SAVE_FILES_RETURN()
+      RETURN
+      END SUBROUTINE SMUMPS_SAVE_FILES_RETURN
+#endif
diff -pruN 5.6.2-2.1/src/smumps_sol_es.F 5.7.1-1/src/smumps_sol_es.F
--- 5.6.2-2.1/src/smumps_sol_es.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/smumps_sol_es.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -13,16 +13,24 @@ C  https://cecill.info/licences/Licence_
 C
       MODULE SMUMPS_SOL_ES
       PRIVATE
-      PUBLIC:: PRUNED_SIZE_LOADED
       PUBLIC:: SMUMPS_CHAIN_PRUN_NODES
       PUBLIC:: SMUMPS_CHAIN_PRUN_NODES_STATS
       PUBLIC:: SMUMPS_INITIALIZE_RHS_BOUNDS
       PUBLIC:: SMUMPS_PROPAGATE_RHS_BOUNDS
       PUBLIC:: SMUMPS_TREE_PRUN_NODES
-      PUBLIC:: SMUMPS_TREE_PRUN_NODES_STATS
       PUBLIC:: SMUMPS_SOL_ES_INIT
+#     if defined(STAT_ES_SOLVE)
+      PUBLIC:: SMUMPS_SOL_ES_PRINT_STATS
+#     endif
+      PUBLIC:: SMUMPS_ES_GET_SUM_Nloc
+      PUBLIC:: SMUMPS_ES_NODES_SIZE_AND_FILL
       INTEGER(8), POINTER, DIMENSION(:,:) :: SIZE_OF_BLOCK
-      INTEGER(8) :: PRUNED_SIZE_LOADED
+#     if defined(STAT_ES_SOLVE)
+      DOUBLE PRECISION :: nb_flops,
+     &                    nb_sparse_flops,
+     &                    total_efficiency
+      INTEGER :: total_procs, total_blocks
+#endif
       INCLUDE 'mumps_headers.h'
       CONTAINS
       SUBROUTINE SMUMPS_SOL_ES_INIT(SIZE_OF_BLOCK_ARG, KEEP201)
@@ -34,6 +42,13 @@ C
       ELSE
         NULLIFY(SIZE_OF_BLOCK)
       ENDIF
+#if defined(STAT_ES_SOLVE)
+      nb_flops=0.0d0
+      nb_sparse_flops=0.0d0
+      total_efficiency=0.0d0
+      total_procs=0
+      total_blocks=0
+#endif
       RETURN
       END SUBROUTINE SMUMPS_SOL_ES_INIT
       SUBROUTINE SMUMPS_TREE_PRUN_NODES( 
@@ -50,7 +65,7 @@ C
       INTEGER, INTENT(IN) :: N, KEEP28
       INTEGER, INTENT(IN) :: DAD(KEEP28),NE_STEPS(KEEP28),FRERE(KEEP28)
       INTEGER, INTENT(IN) :: FILS(N), STEP(N)
-      INTEGER, INTENT(IN) :: nodes_RHS(KEEP28),  nb_nodes_RHS
+      INTEGER, INTENT(IN) :: nodes_RHS(:),  nb_nodes_RHS
       INTEGER :: nb_prun_nodes
       INTEGER, OPTIONAL, INTENT(INOUT):: Pruned_List(nb_prun_nodes)
       INTEGER :: nb_prun_roots
@@ -143,15 +158,15 @@ C
       INTEGER, INTENT(IN) :: KEEP28
       INTEGER, INTENT(IN) :: DAD(KEEP28)
       INTEGER, INTENT(IN) :: nb_nodes_RHS
-      INTEGER, INTENT(IN) :: nodes_RHS(nb_nodes_RHS)
-      INTEGER :: nb_prun_nodes
+      INTEGER, INTENT(IN) :: nodes_RHS(max(nb_nodes_RHS,1))
+      INTEGER, INTENT(INOUT) :: nb_prun_nodes
       INTEGER, OPTIONAL, INTENT(INOUT):: Pruned_List(nb_prun_nodes)
-      INTEGER :: nb_prun_roots
+      INTEGER, INTENT(INOUT) :: nb_prun_roots
       INTEGER, OPTIONAL, INTENT(INOUT):: Pruned_Roots(nb_prun_roots)
-      INTEGER :: nb_prun_leaves
+      INTEGER, INTENT(INOUT) :: nb_prun_leaves
       INTEGER, OPTIONAL, INTENT(INOUT):: Pruned_Leaves(nb_prun_leaves)
-      INTEGER :: Pruned_SONS(KEEP28)
-      LOGICAL :: TO_PROCESS(KEEP28)
+      INTEGER, INTENT(OUT) :: Pruned_SONS(KEEP28)
+      LOGICAL, INTENT(OUT) :: TO_PROCESS(KEEP28)
       INTEGER :: IN, I, ISTEP, TMP
       nb_prun_nodes = 0
       nb_prun_roots = 0
@@ -265,6 +280,10 @@ C
      & STEP, N, Pruned_SONS,
      & DAD, RHS_BOUNDS, NSTEPS,
      & MYID, COMM, KEEP485,
+#if defined(STAT_ES_SOLVE)
+     & KEEP46,
+     & IPTR_WORKING, SIZE_IPTR_WORKING, WORKING, SIZE_WORKING,
+#endif
      & IW, LIW, PTRIST, KIXSZ,OOC_FCT_LOC, PHASE, LDLT, K38)
       IMPLICIT NONE
       INCLUDE 'mpif.h'
@@ -275,10 +294,26 @@ C
       INTEGER, INTENT(IN) :: pruned_leaves(nb_pruned_leaves)
       INTEGER, INTENT(IN) :: LIW, IW(LIW), PTRIST(NSTEPS)
       INTEGER, INTENT(IN) :: KIXSZ, OOC_FCT_LOC, PHASE, LDLT, K38
+#     if defined(STAT_ES_SOLVE)
+      INTEGER, INTENT(IN) :: KEEP46 
+      INTEGER, INTENT(IN) :: SIZE_IPTR_WORKING, SIZE_WORKING, 
+     &                       IPTR_WORKING(SIZE_IPTR_WORKING),
+     &                       WORKING(SIZE_WORKING)
+#endif
       INTEGER, INTENT(INOUT):: RHS_BOUNDS(2*NSTEPS)
       INTEGER :: I, node, father, size_pool, next_size_pool
       INTEGER :: IERR
       INTEGER, ALLOCATABLE, DIMENSION(:) :: POOL, NBSONS
+#if defined(STAT_ES_SOLVE)
+      LOGICAL, ALLOCATABLE, DIMENSION(:) :: isleaf
+      INTEGER :: J, NPROCS, proc, allocok
+      LOGICAL :: found
+      DOUBLE PRECISION :: avg_load, efficiency, max_load, effmax
+      DOUBLE PRECISION, ALLOCATABLE, DIMENSION(:) :: proc_flops_buf
+      DOUBLE PRECISION :: proc_block_flops, block_flops
+      INTEGER :: SK38  
+      INTEGER, PARAMETER :: MASTER  = 0
+#endif
       ALLOCATE(POOL(nb_pruned_leaves),
      &         NBSONS(NSTEPS),
      &         STAT=IERR)
@@ -289,6 +324,37 @@ C
       size_pool = nb_pruned_leaves
       POOL = pruned_leaves
       NBSONS = Pruned_SONS
+#     if defined(STAT_ES_SOLVE)
+      NPROCS = SIZE_IPTR_WORKING-1
+      IF((MYID.EQ.MASTER).AND.(KEEP46.EQ.1)) THEN
+        ALLOCATE(isleaf(NSTEPS), STAT=IERR)
+        IF (IERR.NE.0) THEN
+          WRITE(6,*)'Allocation problem in SMUMPS_PROPAGATE_RHS_BOUNDS'
+          CALL MUMPS_ABORT()
+        END IF
+        isleaf = .FALSE.
+        DO I=1,nb_pruned_leaves
+          isleaf(abs(STEP(pruned_leaves(I)))) = .true.
+        END DO
+        proc = 0
+        DO I=1,NPROCS
+          found = .FALSE.
+          J = IPTR_WORKING(I)
+          DO WHILE((J.LE.IPTR_WORKING(I+1)-1).AND.(.NOT.found))
+            IF (isleaf(WORKING(J)))THEN
+              found = .TRUE.            
+            END IF
+            J = J + 1
+          END DO
+          IF(found) THEN
+            proc = proc + 1
+          END IF
+        END DO
+        total_procs = total_procs + proc
+        total_blocks = total_blocks + 1
+        DEALLOCATE(isleaf)
+      END IF
+#     endif
       DO WHILE (size_pool.ne.0)
         next_size_pool =0 
         DO I=1, size_pool 
@@ -314,6 +380,76 @@ C
         size_pool = next_size_pool 
       END DO
       DEALLOCATE(POOL, NBSONS)
+#     if defined(STAT_ES_SOLVE)
+      IF (KEEP46.EQ.1) THEN
+       IF(MYID.EQ.MASTER) THEN
+        block_flops = 0D0
+       END IF
+       proc_block_flops = 0D0
+       IF (K38 .GT. 0) THEN
+        SK38 = STEP(K38)
+       ELSE
+        SK38 = 0
+       END IF
+       DO I=1,NSTEPS
+        IF (RHS_BOUNDS(2*I).NE.0) THEN 
+          IF(PTRIST(I).GT.0) THEN
+            proc_block_flops = proc_block_flops
+     &           + dble(2*(RHS_BOUNDS(2*I) - RHS_BOUNDS(2*I-1) +1))
+     &           * dble(SMUMPS_LOCAL_FACTOR_SIZE(IW, LIW,
+     &             PTRIST(I)+KIXSZ, 
+     &             PHASE,LDLT,I.EQ.SK38))
+          END IF
+        END IF
+       END DO
+       IF(MYID.EQ.MASTER) THEN
+          ALLOCATE(proc_flops_buf(SIZE_IPTR_WORKING-1),stat=allocok)
+          IF(allocok.GT.0) THEN
+             WRITE(6,*)'Allocation problem of proc_flops_buf'
+     &            ,' in SMUMPS_PROPAGATE_RHS_BOUNDS'
+             CALL MUMPS_ABORT()
+          ENDIF
+          proc_flops_buf=0.0d0
+       ELSE 
+          ALLOCATE(proc_flops_buf(1),stat=allocok)
+          IF(allocok.GT.0) THEN
+             WRITE(6,*)'Allocation problem of proc_flops_buf'
+     &            ,' in SMUMPS_PROPAGATE_RHS_BOUNDS'
+             CALL MUMPS_ABORT()
+          ENDIF
+          proc_flops_buf=0.0d0
+       END IF
+       CALL MPI_GATHER(proc_block_flops, 1, MPI_DOUBLE_PRECISION,
+     &       proc_flops_buf, 1, MPI_DOUBLE_PRECISION,
+     &       0, COMM, IERR)
+       CALL MPI_REDUCE(proc_block_flops, block_flops, 1,
+     &  MPI_DOUBLE_PRECISION, MPI_SUM, 0, COMM, IERR)  
+       IF(MYID.EQ.MASTER) THEN                         
+        nb_sparse_flops = nb_sparse_flops+block_flops
+        avg_load = sum(proc_flops_buf)/dble(NPROCS)
+        max_load = maxval(proc_flops_buf)
+        efficiency = 0D0
+        effmax = 0D0
+        DO I=1,NPROCS
+          efficiency= efficiency + (proc_flops_buf(I)-avg_load)**2
+          IF (proc_flops_buf(I)-avg_load.GT.0.0D0) THEN
+            effmax = effmax + (max_load-avg_load)**2
+          ELSE IF (proc_flops_buf(I)-avg_load.LT.0.0D0) THEN
+            effmax = effmax + avg_load**2
+          END IF
+        END DO
+        efficiency = sqrt(efficiency/dble(NPROCS))
+        effmax = sqrt(effmax/dble(NPROCS))
+        IF(effmax.ne.0.0d0) efficiency = efficiency / effmax
+        efficiency = 1.0d0 - efficiency
+        efficiency = efficiency * block_flops 
+        total_efficiency = total_efficiency + efficiency
+        DEALLOCATE(proc_flops_buf)
+       ELSE
+        DEALLOCATE(proc_flops_buf)
+       END IF
+      END IF
+#endif
       RETURN
       END SUBROUTINE SMUMPS_PROPAGATE_RHS_BOUNDS
       INTEGER(8) FUNCTION SMUMPS_LOCAL_FACTOR_SIZE(IW,LIW,PTR,
@@ -340,7 +476,7 @@ C
      &            NPIV*(NPIV-1_8)/2_8 + (NROW-NPIV)*NPIV
           ELSE
             SMUMPS_LOCAL_FACTOR_SIZE =
-     &      NPIV*(NPIV+1_8)/2_8 + (LIELL-NPIV)*NPIV
+     &      NPIV*(NPIV-1_8)/2_8 + (LIELL-NPIV)*NPIV
           ENDIF
         ELSE
           SMUMPS_LOCAL_FACTOR_SIZE =
@@ -348,90 +484,13 @@ C
         END IF
       RETURN
       END FUNCTION SMUMPS_LOCAL_FACTOR_SIZE
-      INTEGER(8) FUNCTION SMUMPS_LOCAL_FACTOR_SIZE_BLR(IW,LIW,PTR,
-     &                                LRSTATUS, IWHANDLER,
-     &                                PHASE, LDLT, IS_ROOT)
-      USE SMUMPS_LR_DATA_M
-      USE SMUMPS_LR_TYPE
-        INTEGER, INTENT(IN) :: LIW, PTR, PHASE, LDLT
-        INTEGER, INTENT(IN) :: LRSTATUS, IWHANDLER
-        INTEGER, INTENT(IN) :: IW(LIW)
-        LOGICAL, INTENT(IN) :: IS_ROOT
-        INTEGER(8) :: NPIV, NROW, FACTOR_SIZE
-        INTEGER :: NB_PANELS, IPANEL, LorU, IBLOCK
-        LOGICAL :: LR_ACTIVATED
-        TYPE(LRB_TYPE), POINTER, DIMENSION(:) :: LRB_PANEL
-        NROW  = int(IW(PTR+2),8)
-        NPIV  = int(IW(PTR+3),8)
-        LR_ACTIVATED=(LRSTATUS.GE.2)
-        IF (LR_ACTIVATED) THEN
-          FACTOR_SIZE = 0_8
-          CALL SMUMPS_BLR_RETRIEVE_NB_PANELS(IWHANDLER, NB_PANELS)
-          IF (LDLT.EQ.0) THEN 
-            LorU = PHASE
-          ELSE
-            LorU = 0
-          ENDIF
-          DO IPANEL=1,NB_PANELS
-            IF (IS_ROOT.AND.IPANEL.EQ.NB_PANELS) THEN
-              CYCLE
-            ENDIF
-            IF (SMUMPS_BLR_EMPTY_PANEL_LORU(IWHANDLER, LorU, IPANEL))
-     &        THEN
-              CYCLE
-            ENDIF
-             CALL SMUMPS_BLR_RETRIEVE_PANEL_LORU(IWHANDLER, LorU,
-     &                       IPANEL, LRB_PANEL)
-            IF (size(LRB_PANEL).GT.0) THEN
-              IF (PHASE.EQ.0) THEN
-                FACTOR_SIZE = FACTOR_SIZE + 
-     &            int(LRB_PANEL(1)%N,8)*(int(LRB_PANEL(1)%N,8)-1_8)/2_8
-              ELSE
-                FACTOR_SIZE = FACTOR_SIZE + 
-     &           int(LRB_PANEL(1)%N,8)*(int(LRB_PANEL(1)%N,8)+1_8)/2_8
-              ENDIF
-            ENDIF
-            DO IBLOCK=1,size(LRB_PANEL)
-              IF (LRB_PANEL(IBLOCK)%ISLR) THEN
-                FACTOR_SIZE = FACTOR_SIZE + int(LRB_PANEL(IBLOCK)%K,8)*
-     &            int(LRB_PANEL(IBLOCK)%M+LRB_PANEL(IBLOCK)%M,8)
-              ELSE
-                FACTOR_SIZE = FACTOR_SIZE +
-     &             int(LRB_PANEL(IBLOCK)%M*LRB_PANEL(IBLOCK)%N,8)
-              ENDIF
-            ENDDO
-          ENDDO
-          SMUMPS_LOCAL_FACTOR_SIZE_BLR = FACTOR_SIZE
-        ELSE
-          SMUMPS_LOCAL_FACTOR_SIZE_BLR = 
-     &      SMUMPS_LOCAL_FACTOR_SIZE(IW, LIW, PTR, PHASE, LDLT, IS_ROOT)
-        ENDIF
-      RETURN
-      END FUNCTION SMUMPS_LOCAL_FACTOR_SIZE_BLR
-      SUBROUTINE SMUMPS_TREE_PRUN_NODES_STATS(MYID, N, KEEP28, KEEP201,
-     &           FR_FACT,
-     &           STEP, Pruned_List, nb_prun_nodes, OOC_FCT_TYPE_LOC)
-      INTEGER, intent(in) :: KEEP28, KEEP201, OOC_FCT_TYPE_LOC, MYID, N
-      INTEGER(8), intent(in) :: FR_FACT
-      INTEGER, intent(in) :: nb_prun_nodes
-      INTEGER, intent(in) :: Pruned_List(nb_prun_nodes)
-      INTEGER, intent(in) :: STEP(N)
-      INTEGER I, ISTEP
-      INTEGER(8) :: Pruned_Size
-      IF (KEEP201 .GT. 0) THEN
-        Pruned_Size = 0_8
-        DO I = 1, nb_prun_nodes
-          ISTEP = STEP(Pruned_List(I))
-          Pruned_Size = Pruned_Size + SIZE_OF_BLOCK
-     &                  (ISTEP, OOC_FCT_TYPE_LOC)
-        ENDDO
-        PRUNED_SIZE_LOADED = PRUNED_SIZE_LOADED +Pruned_Size
-      ENDIF
-      RETURN
-      END SUBROUTINE SMUMPS_TREE_PRUN_NODES_STATS
       SUBROUTINE SMUMPS_CHAIN_PRUN_NODES_STATS
      &                (MYID, N, KEEP28, KEEP201, KEEP485, FR_FACT,
      &                STEP, Pruned_List, nb_prun_nodes, OOC_FCT_TYPE_LOC
+#     if defined(STAT_ES_SOLVE)
+     &                , NRHS, COMM, IW, LIW, PTRIST, KIXSZ, PHASE,
+     &                  LDLT, K38
+#endif     
      & )
       IMPLICIT NONE
       INTEGER, intent(in) :: KEEP28, KEEP201, OOC_FCT_TYPE_LOC, N,
@@ -440,24 +499,203 @@ C
       INTEGER, intent(in) :: nb_prun_nodes, MYID
       INTEGER, intent(in) :: Pruned_List(nb_prun_nodes)
       INTEGER, intent(in) :: STEP(N)
+#if defined(STAT_ES_SOLVE)
+      INTEGER, INTENT(IN):: LIW, COMM, NRHS, LDLT, K38
+      INTEGER, INTENT(IN):: IW(LIW), PTRIST(KEEP28), KIXSZ, PHASE  
+      DOUBLE PRECISION :: proc_block_flops, block_flops
+      INTEGER(8) :: Pruned_Size_ic 
+      INTEGER :: IERR
+      INTEGER :: SK38 
+#endif
       INCLUDE 'mpif.h'
       INTEGER I, ISTEP
       INTEGER(8) :: Pruned_Size
+#if defined(STAT_ES_SOLVE)
+      Pruned_Size_ic = 0_8
+#endif
       Pruned_Size = 0_8
+#if defined(STAT_ES_SOLVE)
+      IF (K38 .GT. 0) THEN
+        SK38 = STEP(K38)
+      ELSE
+        SK38 = 0
+      END IF
+#endif
       DO I = 1, nb_prun_nodes
         ISTEP = STEP(Pruned_List(I))
         IF (KEEP201 .GT. 0) THEN
             Pruned_Size = Pruned_Size + SIZE_OF_BLOCK
      &                    (ISTEP, OOC_FCT_TYPE_LOC)
         ENDIF
+#if       defined(STAT_ES_SOLVE)
+          IF (PTRIST(ISTEP) .GT. 0) THEN
+            Pruned_Size_ic = Pruned_Size_ic + 
+     &               SMUMPS_LOCAL_FACTOR_SIZE(IW, LIW,
+     &               PTRIST(ISTEP)+KIXSZ, 
+     &               PHASE, LDLT,
+     &               ISTEP.EQ.SK38)
+          ENDIF
+#         endif
       ENDDO
-      IF (KEEP201.GT.0) THEN
-        IF (FR_FACT .NE. 0_8) THEN
-          PRUNED_SIZE_LOADED = PRUNED_SIZE_LOADED +Pruned_Size
-        ENDIF
-      ENDIF
+#if defined(STAT_ES_SOLVE)
+      proc_block_flops = dble(2_8*Pruned_Size_ic)*dble(NRHS)
+      CALL MPI_REDUCE(proc_block_flops, block_flops, 1,
+     & MPI_DOUBLE_PRECISION, MPI_SUM, 0, COMM, IERR)
+      IF(MYID.EQ.0) nb_flops = nb_flops + block_flops
+#endif
       RETURN
       END SUBROUTINE SMUMPS_CHAIN_PRUN_NODES_STATS
+#if   defined(STAT_ES_SOLVE)
+      SUBROUTINE SMUMPS_SOL_ES_PRINT_STATS(
+     &                  K212, K235, K237, K485, K497, NZLU8,
+     &                  NRHS, ICNTL27, N, K50, DKEEPS, RINFOGS, MPG)
+      IMPLICIT NONE
+      INTEGER, intent(in)    ::  K212, K235, K237, K485, K497, 
+     &                           NRHS, MPG, ICNTL27, N, K50
+      INTEGER(8), intent(in) :: NZLU8
+      REAL, intent(out)    :: DKEEPS(5), RINFOGS(5)
+      LOGICAL              :: AM1, ES_FWD, ES_BWD, DO_NBSPARSE
+      IF (MPG.LE.0) RETURN
+      AM1         = (K237 .NE. 0)
+      ES_FWD      = (K235 .NE. 0) .AND. (.NOT. AM1)
+      ES_BWD      = (K212 .NE. 0) .AND. (.NOT. AM1)
+      DO_NBSPARSE = (K497.NE.0).AND.(NRHS.GT.1).AND.(ICNTL27.GT.1)
+      IF (AM1) 
+     & WRITE(MPG,'(/A)') ' ** FLOPS SUMMARY during SOLVE AM1 ** '
+      IF ((ES_FWD).AND. (.NOT.ES_BWD)) 
+     & WRITE(MPG,'(/A,A)') ' ** FLOPS SUMMARY during fwd step',
+     &                  ' (exploit RHS sparsity) ** '
+      IF ((.NOT.ES_FWD).AND. (ES_BWD))
+     & WRITE(MPG,'(/A,A)') ' ** FLOPS SUMMARY during bwd step',
+     &                  ' (selected entries in solution) ** '
+      IF ((ES_FWD).AND. (ES_BWD)) 
+     & WRITE(MPG,'(/A,/A)') 
+     & ' ** FLOPS SUMMARY during SOLVE (fwd+bwd steps)',
+     & '    (sparse RHS and selected entries in solution) **'
+      IF (
+     &     (ES_FWD) .AND. (.NOT.ES_BWD)
+     &    .OR.
+     &     (.NOT.ES_FWD) .AND. (ES_BWD)
+     &   ) THEN
+       IF (K50.NE.0) THEN
+         DKEEPS(1)=(real(NZLU8)-real(N))*real(2*NRHS)
+       ELSE
+         DKEEPS(1)=(real(NZLU8)-real(N))*real(NRHS)
+       ENDIF
+      ELSE IF ((ES_FWD).AND.(ES_BWD)) THEN
+       IF (K50.NE.0) THEN
+         DKEEPS(1) = (real(NZLU8)-real(N))*real(4*NRHS)
+       ELSE
+         DKEEPS(1)=(real(NZLU8)-real(N))*real(2*NRHS)
+       ENDIF
+      ENDIF
+      RINFOGS(1) = DKEEPS(1)
+      IF (.NOT.AM1) THEN
+       WRITE(MPG,'(A,F25.1)') 
+     & ' RINFOG(24) FLOPS with dense full rank format  =', DKEEPS(1)
+      ENDIF
+      DKEEPS(2)=real(nb_flops) 
+      IF (DO_NBSPARSE) DKEEPS(4)=real(nb_sparse_flops)
+      IF (DO_NBSPARSE) THEN
+       RINFOGS(2)= DKEEPS(4)
+      ELSE
+       RINFOGS(2)= DKEEPS(2)
+      ENDIF
+      WRITE(MPG,'(A,F25.1)') 
+     & ' RINFOG(25) FLOPS with exploit sparsity (ES)   =', RINFOGS(2)
+      RETURN
+      END SUBROUTINE SMUMPS_SOL_ES_PRINT_STATS
+#endif
+      SUBROUTINE SMUMPS_ES_GET_SUM_Nloc (
+     &           N, Nloc_ITAB, ITAB_loc, COMM,
+     &           SUM_idNloc_8 )
+      IMPLICIT NONE
+      INTEGER, INTENT(IN)  :: N
+#if defined(MUMPS_NOF2003)
+        INTEGER, POINTER :: ITAB_loc (:)
+#else
+        INTEGER, INTENT( IN ), POINTER :: ITAB_loc (:)
+#endif
+      INTEGER, INTENT(IN)  :: Nloc_ITAB
+      INTEGER, INTENT(IN)  :: COMM
+      INTEGER(8)   :: SUM_idNloc_8
+      INCLUDE 'mpif.h'
+      INTEGER I, II, IERR_MPI 
+      INTEGER(8) :: idNloc_8
+      idNloc_8 = 0_8
+      DO I= 1, Nloc_ITAB
+          II = ITAB_loc(I)
+          IF (II.GE.1 .and. II.LE.N) 
+     &    idNloc_8 = idNloc_8 + 1_8
+      ENDDO
+      CALL MPI_ALLREDUCE (idNloc_8, SUM_idNloc_8, 1, 
+     &                  MPI_INTEGER8,
+     &                  MPI_SUM, COMM, IERR_MPI )
+      RETURN
+      END SUBROUTINE SMUMPS_ES_GET_SUM_Nloc
+      SUBROUTINE SMUMPS_ES_NODES_SIZE_AND_FILL (
+     &           fill, 
+     &           N, NSTEPS, KEEP, STEP, Step2node,
+     &           ITAB_loc, Nloc_ITAB, 
+     &           MYID, COMM,
+     &           Pruned_Sons, Lnodes_ITAB
+#if defined(AVOID_MPI_IN_PLACE)
+     &           , TMP_INT_ARRAY
+#endif
+     &           , nodes_ITAB
+     &           )
+      IMPLICIT NONE
+      LOGICAL, INTENT(IN)  :: fill
+      INTEGER, INTENT(IN)  :: N, NSTEPS, KEEP(500) 
+      INTEGER, INTENT(IN)  :: Nloc_ITAB
+      INTEGER, INTENT(IN)  :: STEP(N), Step2node(NSTEPS), 
+     &                        ITAB_loc(max(1,Nloc_ITAB))
+      INTEGER, INTENT(IN)  :: MYID, COMM
+#if defined(AVOID_MPI_IN_PLACE)
+      INTEGER              :: TMP_INT_ARRAY(NSTEPS) 
+#endif
+      INTEGER, INTENT(INOUT) :: Pruned_Sons(NSTEPS), Lnodes_ITAB
+      INTEGER, OPTIONAL, INTENT(OUT) :: nodes_ITAB(max(1,Lnodes_ITAB))
+      INCLUDE 'mpif.h'
+      INTEGER I, II, ISTEP, IERR_MPI, Lnodes_ITAB_loc, INODE_PRINC
+      IF (.NOT.fill) THEN
+        Pruned_SONS = 0
+        DO I= 1, Nloc_ITAB
+          II = ITAB_loc(I)
+          IF (II.GE.1 .and. II.LE.N) THEN
+            ISTEP = abs(STEP(II))
+            IF ( Pruned_SONS(ISTEP) .eq. 0 ) THEN
+              Pruned_SONS(ISTEP) = 1
+            ENDIF
+           ENDIF
+        ENDDO
+#if defined(AVOID_MPI_IN_PLACE)
+        TMP_INT_ARRAY = Pruned_Sons
+#endif
+        CALL MPI_ALLREDUCE(
+#if defined(AVOID_MPI_IN_PLACE)
+     &         TMP_INT_ARRAY, 
+#else
+     &         MPI_IN_PLACE,
+#endif
+     &         Pruned_Sons, NSTEPS, 
+     &         MPI_INTEGER, MPI_SUM, COMM, IERR_MPI)
+        Lnodes_ITAB = 0
+        DO ISTEP=1,NSTEPS
+          if (Pruned_SONS(ISTEP) .NE.0) Lnodes_ITAB=Lnodes_ITAB+1
+        ENDDO
+      ELSE IF (Lnodes_ITAB.GT.0) THEN
+        Lnodes_ITAB_loc = 0
+        DO ISTEP=1,NSTEPS
+          if (Pruned_SONS(ISTEP) .GT. 0) then
+            Lnodes_ITAB_loc=Lnodes_ITAB_loc+1
+            INODE_PRINC = Step2node( ISTEP )
+            nodes_ITAB(Lnodes_ITAB_loc)  = INODE_PRINC
+          endif
+        ENDDO
+      ENDIF
+      RETURN
+      END SUBROUTINE SMUMPS_ES_NODES_SIZE_AND_FILL
       END MODULE SMUMPS_SOL_ES
       SUBROUTINE SMUMPS_PERMUTE_RHS_GS
      &          (LP, LPOK, PROKG, MPG, PERM_STRAT, 
diff -pruN 5.6.2-2.1/src/smumps_struc_def.F 5.7.1-1/src/smumps_struc_def.F
--- 5.6.2-2.1/src/smumps_struc_def.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/smumps_struc_def.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/sol_common.F 5.7.1-1/src/sol_common.F
--- 5.6.2-2.1/src/sol_common.F	2023-10-11 09:36:34.000000000 +0000
+++ 5.7.1-1/src/sol_common.F	2024-05-02 10:15:13.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -49,9 +49,9 @@ C
       ENDIF
       RETURN
       END SUBROUTINE MUMPS_SOL_GET_NPIV_LIELL_IPOS
-      SUBROUTINE MUMPS_BUILD_IRHS_loc(MYID_NODES, NSLAVES, N,
+      SUBROUTINE MUMPS_GET_INDICES(MYID_NODES, NSLAVES, N,
      &           PTRIST, KEEP,KEEP8, IW, LIW, STEP, PROCNODE_STEPS,
-     &           IRHS_loc, ROW_OR_COL_INDICES)
+     &           INDICES, ROW_OR_COL_INDICES)
       IMPLICIT NONE
       INTEGER, INTENT(IN)    :: KEEP(500)
       INTEGER(8), INTENT(IN) :: KEEP8(150)
@@ -59,48 +59,48 @@ C
       INTEGER, INTENT(IN)    :: PTRIST(KEEP(28))
       INTEGER, INTENT(IN)    :: IW(LIW), STEP(N)
       INTEGER, INTENT(IN)    :: PROCNODE_STEPS(KEEP(28))
-      INTEGER, INTENT(OUT)   :: IRHS_loc(KEEP(89))
+      INTEGER, INTENT(OUT)   :: INDICES(KEEP(89))
       INTEGER, INTENT(IN)    :: ROW_OR_COL_INDICES
       INTEGER :: ISTEP
       INTEGER :: NPIV, LIELL, IPOS
-      INTEGER :: IIRHS_loc 
+      INTEGER :: IINDICES 
       INTEGER :: J1 
       INCLUDE 'mumps_headers.h'
       INTEGER, EXTERNAL :: MUMPS_PROCNODE
-      IIRHS_loc = 0
+      IINDICES = 0
       DO ISTEP = 1, KEEP(28)
         IF (MYID_NODES == MUMPS_PROCNODE(PROCNODE_STEPS(ISTEP),
      &                                   KEEP(199))) THEN
           CALL MUMPS_SOL_GET_NPIV_LIELL_IPOS ( ISTEP, KEEP,
      &           NPIV, LIELL, IPOS, IW, LIW, PTRIST, STEP, N )
-          IF ( ROW_OR_COL_INDICES .EQ. 0 .OR. KEEP(50).NE.0 ) THEN
+          IF ( ROW_OR_COL_INDICES .EQ. 0 ) THEN
             J1 = IPOS + 1
           ELSE IF (ROW_OR_COL_INDICES .EQ. 1 ) THEN
             J1 = IPOS + LIELL + 1
           ELSE
-            WRITE(*,*) "Internal error 1 in MUMPS_BUILD_IRHS_loc",
+            WRITE(*,*) "Internal error 1 in MUMPS_GET_INDICES",
      &      ROW_OR_COL_INDICES
             CALL MUMPS_ABORT()
           ENDIF
-          IF (IIRHS_loc+NPIV .GT. KEEP(89)) THEN
-            WRITE(*,*) "Internal error 2 in MUMPS_BUILD_IRHS_loc",
-     &      IIRHS_loc, KEEP(89)
+          IF (IINDICES+NPIV .GT. KEEP(89)) THEN
+            WRITE(*,*) "Internal error 2 in MUMPS_GET_INDICES",
+     &      IINDICES, KEEP(89)
             CALL MUMPS_ABORT()
           ENDIF
-          IRHS_loc(IIRHS_loc+1:IIRHS_loc+NPIV)=IW(J1:J1+NPIV-1)
-          IIRHS_loc=IIRHS_loc+NPIV
+          INDICES(IINDICES+1:IINDICES+NPIV)=IW(J1:J1+NPIV-1)
+          IINDICES=IINDICES+NPIV
         ENDIF
       ENDDO
-      IF (IIRHS_loc .NE. KEEP(89)) THEN
-        WRITE(*,*) "Internal error 3 in MUMPS_BUILD_IRHS_loc",
-     &  IIRHS_loc, KEEP(89)
+      IF (IINDICES .NE. KEEP(89)) THEN
+        WRITE(*,*) "Internal error 3 in MUMPS_GET_INDICES",
+     &  IINDICES, KEEP(89)
         CALL MUMPS_ABORT()
       ENDIF
       RETURN
-      END SUBROUTINE MUMPS_BUILD_IRHS_loc
+      END SUBROUTINE MUMPS_GET_INDICES
       SUBROUTINE MUMPS_SOL_RHSMAPINFO( N, Nloc_RHS, INFO23,
      &                           IRHS_loc, MAP_RHS_loc,
-     &                           POSINRHSCOMP_FWD,
+     &                           POSINRHSINTR_FWD,
      &                           NSLAVES, MYID_NODES, COMM_NODES,
      &                           ICNTL, INFO )
       IMPLICIT NONE
@@ -108,7 +108,7 @@ C
       INTEGER, INTENT(IN)    :: INFO23
       INTEGER, INTENT(IN)    :: IRHS_loc   (max(1,Nloc_RHS))     
       INTEGER, INTENT(OUT)   :: MAP_RHS_loc(max(1,Nloc_RHS)) 
-      INTEGER, INTENT(IN)    :: POSINRHSCOMP_FWD (N)
+      INTEGER, INTENT(IN)    :: POSINRHSINTR_FWD (N)
       INTEGER, INTENT(IN)    :: NSLAVES, MYID_NODES, COMM_NODES
       INTEGER, INTENT(INOUT) :: INFO(80)
       INTEGER, INTENT(IN)    :: ICNTL(60)
@@ -143,34 +143,26 @@ C
       NFS_LOC = 0
       NFS_TOT = 0
       DO I = 1, N
-        IF (POSINRHSCOMP_FWD(I) .LE. 0) THEN
+        IF (POSINRHSINTR_FWD(I) .LE. 0) THEN
           GLOBAL_MAPPING(I) = 0
         ELSE
           GLOBAL_MAPPING(I) = MYID_NODES
           NFS_LOC = NFS_LOC + 1
         ENDIF
       ENDDO
-      IF (NFS_LOC .NE. INFO23) THEN
-        WRITE(*,*) "Internal error 1 in MUMPS_SOL_RHSMAPINFO",
-     &  NFS_LOC, INFO23
-        CALL MUMPS_ABORT()
-      ENDIF
       CALL MPI_ALLREDUCE(NFS_LOC, NFS_TOT, 1, MPI_INTEGER,
      &                   MPI_SUM, COMM_NODES, IERR_MPI)
-      IF (NFS_tot .NE. N) THEN
-        WRITE(*,*) "Internal error 1 in MUMPS_SOL_RHSMAPINFO",
-     &  NFS_LOC, NFS_TOT, N
-        CALL MUMPS_ABORT()
-      ENDIF
 #if defined(AVOID_MPI_IN_PLACE)
       DO I = 1, N
         GLOBAL_MAPPING(int(N,8)+int(I,8)) = GLOBAL_MAPPING(I)
       ENDDO
-      CALL MPI_ALLREDUCE( GLOBAL_MAPPING(N+1), GLOBAL_MAPPING,
+      CALL MUMPS_BIGALLREDUCE( .FALSE.,
+     &                    GLOBAL_MAPPING(N+1), GLOBAL_MAPPING,
      &                    N, MPI_INTEGER,
      &                    MPI_SUM, COMM_NODES, IERR_MPI )
 #else
-      CALL MPI_ALLREDUCE( MPI_IN_PLACE, GLOBAL_MAPPING, N, MPI_INTEGER,
+      CALL MUMPS_BIGALLREDUCE( .TRUE.,
+     &                    MPI_IN_PLACE, GLOBAL_MAPPING, N, MPI_INTEGER,
      &                    MPI_SUM, COMM_NODES, IERR_MPI )
 #endif
       DO I = 1, Nloc_RHS
diff -pruN 5.6.2-2.1/src/sol_ds_common_m.F 5.7.1-1/src/sol_ds_common_m.F
--- 5.6.2-2.1/src/sol_ds_common_m.F	1970-01-01 00:00:00.000000000 +0000
+++ 5.7.1-1/src/sol_ds_common_m.F	2024-05-02 10:15:14.000000000 +0000
@@ -0,0 +1,16 @@
+C
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
+C
+C
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Mumps Technologies, University of Bordeaux.
+C
+C  This version of MUMPS is provided to you free of charge. It is
+C  released under the CeCILL-C license 
+C  (see doc/CeCILL-C_V1-en.txt, doc/CeCILL-C_V1-fr.txt, and
+C  https://cecill.info/licences/Licence_CeCILL-C_V1-en.html)
+C
+      SUBROUTINE MUMPS_SOL_DS_RETURN()
+      RETURN
+      END SUBROUTINE MUMPS_SOL_DS_RETURN
diff -pruN 5.6.2-2.1/src/somp_tps_m.F 5.7.1-1/src/somp_tps_m.F
--- 5.6.2-2.1/src/somp_tps_m.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/somp_tps_m.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/sooc_panel_piv.F 5.7.1-1/src/sooc_panel_piv.F
--- 5.6.2-2.1/src/sooc_panel_piv.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/sooc_panel_piv.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/srank_revealing.F 5.7.1-1/src/srank_revealing.F
--- 5.6.2-2.1/src/srank_revealing.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/srank_revealing.F	2024-05-02 10:15:25.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -15,6 +15,25 @@ C
       IMPLICIT NONE
           INTEGER N, KEEP(500), ICNTL(60), MPG
           KEEP(19)=0
+          KEEP(19)=ICNTL(56)
+          IF ((KEEP(19).LT.1).OR.(KEEP(19).GE.2)) KEEP(19)=0
+          IF ( KEEP(53) .LE. 0 .and.
+     &         KEEP(19) .NE. 0 ) THEN
+             KEEP(19) = 0
+             IF ( MPG .GT. 0 ) THEN
+      WRITE( MPG,'(A)') '** Warning:  ICNTL(56) null space option'
+      WRITE( MPG,'(A)') '** disabled (incompatibility with analysis)'
+             END IF
+          END IF
+          KEEP(21) = min(ICNTL(57),N)
+          KEEP(22) = max(ICNTL(55),0)
+          IF ( KEEP(19) .ne. 0 .and. KEEP(60) .ne. 0 ) THEN
+             IF ( MPG .GT. 0 ) THEN
+      WRITE( MPG,'(A)') '** Warning: ICNTL(56)  null space option'
+      WRITE( MPG,'(A)') '** disabled (incompatibility with Schur)'
+             END IF
+            KEEP(19) = 0
+          END IF
           RETURN
       END SUBROUTINE SMUMPS_GET_NS_OPTIONS_FACTO
       SUBROUTINE SMUMPS_GET_NS_OPTIONS_SOLVE(ICNTL, KEEP, 
@@ -144,3 +163,496 @@ C
       ENDIF
       RETURN
       END SUBROUTINE SMUMPS_RR_FREE_POINTERS
+      SUBROUTINE SMUMPS_SEQ_SYMMETRIZE(N,A)
+      INTEGER N
+      REAL A( N, N )
+      INTEGER I,J
+      DO I = 2, N
+        DO J = 1, I - 1
+          A( I, J ) = A( J, I )
+        END DO
+      END DO
+      RETURN
+      END SUBROUTINE SMUMPS_SEQ_SYMMETRIZE
+      SUBROUTINE SMUMPS_UXVSBP(N,PERM,X,RN01)
+      INTEGER N,PERM(N),I
+      REAL RN01(N),X(N)
+      DO I=1,N
+        RN01(PERM(I))=X(I)
+      ENDDO
+      DO I=1,N
+        X(I)=RN01(I)
+      ENDDO
+      RETURN
+      END SUBROUTINE SMUMPS_UXVSBP
+      SUBROUTINE SMUMPS_UXVSFP(N,PERM,X,RN01)
+      INTEGER N,PERM(N),I
+      REAL RN01(N),X(N)
+      DO I=1,N
+        RN01(I)=X(PERM(I))
+      ENDDO
+      DO I=1,N
+        X(I)=RN01(I)
+      ENDDO
+      RETURN
+      END SUBROUTINE SMUMPS_UXVSFP
+      SUBROUTINE SMUMPS_SVD_QR_ESTIM_WK( PHASE, MBLOCK, NBLOCK, 
+     &           SIZE_ROOT_ARG,
+     &           LOCAL_M, LOCAL_N, ROOT_OWNER, KEEP,KEEP8,
+     &           LIWK_RR, LWK_RR )
+      IMPLICIT NONE
+      INTEGER, INTENT(IN) :: PHASE, SIZE_ROOT_ARG
+      INTEGER, INTENT(IN) :: MBLOCK, NBLOCK, LOCAL_M, LOCAL_N
+      LOGICAL, INTENT(IN) :: ROOT_OWNER
+      INTEGER, INTENT(IN) :: KEEP(500)
+      INTEGER(8), INTENT(IN) :: KEEP8(150)
+      INTEGER, INTENT(OUT):: LIWK_RR
+      INTEGER(8), INTENT(OUT):: LWK_RR
+      INTEGER SIZE_ROOT
+      INTEGER NBPOSPONED_ESTIM
+      PARAMETER (NBPOSPONED_ESTIM=2000)
+      INTEGER SVD_QR,PAR_ROOT
+      SVD_QR = KEEP(19)
+      PAR_ROOT = KEEP(38)
+      LIWK_RR = 0
+      LWK_RR = 0_8
+      IF (PAR_ROOT.EQ.0) THEN
+         IF(ROOT_OWNER) THEN
+           IF (PHASE.EQ.0) THEN
+                  SIZE_ROOT=SIZE_ROOT_ARG+NBPOSPONED_ESTIM
+           ELSE
+                  SIZE_ROOT=SIZE_ROOT_ARG
+           ENDIF
+           IF(SVD_QR.EQ.1) THEN
+              LWK_RR=int(5*SIZE_ROOT+1,8)
+           ELSEIF(SVD_QR.EQ.2) THEN
+              LWK_RR=int(3*SIZE_ROOT+1,8)
+           END IF
+         END IF
+      ENDIF
+      RETURN
+      END SUBROUTINE SMUMPS_SVD_QR_ESTIM_WK
+      SUBROUTINE SMUMPS_SEQ_FACTO_ROOT_SVD_QR
+     &(NN,A,ROOT,WR03,LWR03,KEEP,KEEP8,INFO,LP,DKEEP,
+     & GLOBK109,OPELIW,PIVNUL_LIST,LPIVNUL_LIST,
+     & ROW_INDICES)
+      USE SMUMPS_STRUC_DEF, ONLY : SMUMPS_ROOT_STRUC
+      IMPLICIT NONE
+      TYPE ( SMUMPS_ROOT_STRUC ) :: ROOT
+      INTEGER :: NN,LP,LWR03,LWR03_MINSIZE
+      REAL :: A(NN*NN)
+      INTEGER :: INFO(2),KEEP(500)
+      INTEGER(8) :: KEEP8(150)
+      REAL :: DKEEP(230)
+      DOUBLE PRECISION :: OPELIW
+      INTEGER :: GLOBK109
+      INTEGER :: LPIVNUL_LIST
+      INTEGER :: PIVNUL_LIST(LPIVNUL_LIST)
+      INTEGER :: ROW_INDICES(NN)
+      REAL :: WR03(LWR03)
+      INTEGER LDLT,DEFICIENCY
+      REAL, DIMENSION(:), ALLOCATABLE :: RWORK
+      INTEGER :: I,LDA,LDU,LDVT,J
+      INTEGER :: IERR, LAST_BEFORE_GAP_IND
+      INTEGER :: LAST_BEFORE_GAPLIMIT_IND, FIRST_AFTER_MinPiv, 
+     &           FIRST_AFTER_GAPLIMIT, START_POINT, END_POINT 
+      INTEGER :: ALLOCOK,MAXDEF,MINDEF
+      REAL :: EPS, ZERO, GAPLIMIT, MaxGap, MaxGap1,
+     &        MinPiv, Tol_MaxGap
+      PARAMETER(ZERO=0.0E0)
+      EPS = epsilon(ZERO)
+      LDLT=KEEP(50)
+      IF ((KEEP(19) .NE. 1).AND.(KEEP(19) .NE. 2)) THEN
+        INFO(1)=-107
+        INFO(2)= KEEP(19)
+        IF ( LP .GT. 0 ) THEN
+            WRITE(LP,*) " *** Option ",KEEP(19),
+     &           " for null space no more available."
+        ENDIF  
+        GOTO 100
+      ENDIF
+      IF(KEEP(19).EQ.1) THEN
+              LWR03_MINSIZE=5*NN+1
+      ELSEIF(KEEP(19).EQ.2) THEN
+              LWR03_MINSIZE=3*NN+1
+      END IF
+      MAXDEF=KEEP(21)
+      IF ( MAXDEF .LE. 0 ) THEN
+        MAXDEF = NN
+      ELSE
+        MAXDEF = max(MAXDEF - GLOBK109,0)
+      ENDIF
+      MINDEF = max(KEEP(22) - GLOBK109,0)
+      MINDEF = min(MINDEF,NN)
+      MAXDEF = min(MAXDEF,NN)
+      IF(KEEP(19).EQ.1) THEN
+         OPELIW = OPELIW + dble(26)*dble(NN)*dble(NN)*dble(NN)
+      ELSEIF(KEEP(19).EQ.2) THEN
+         OPELIW = OPELIW +  dble(4)*dble(NN)*dble(NN)*dble(NN)/dble(3)
+      ENDIF
+      IF (associated(ROOT%SINGULAR_VALUES)) 
+     &     DEALLOCATE(ROOT%SINGULAR_VALUES)
+      NULLIFY(ROOT%SINGULAR_VALUES)
+      ROOT%NB_SINGULAR_VALUES=NN
+      ALLOCATE(ROOT%SINGULAR_VALUES(NN), stat=ALLOCOK)
+      IF (ALLOCOK.GT.0) THEN
+         INFO(1)=-13
+         INFO(2)=NN
+         IF ( LP .GT. 0 )
+     &        WRITE(LP,*) 'SMUMPS_SEQ_FACTO_ROOT_SVD_QR: Problem '
+     &        //'allocating SINGULAR_VALUES'
+         GOTO 100
+      END IF
+      IF(KEEP(19).EQ.1) THEN     
+         IF(associated(ROOT%SVD_U)) DEALLOCATE(ROOT%SVD_U)
+         NULLIFY(ROOT%SVD_U)
+         ALLOCATE(ROOT%SVD_U(NN,NN),stat=ALLOCOK )
+         IF(ALLOCOK.GT.0) THEN
+            INFO(1)=-13
+            INFO(2)=NN*NN
+            IF ( LP .GT. 0 )
+     &           WRITE(LP,*) 'SMUMPS_SEQ_FACTO_ROOT_SVD_QR: Problem '
+     &           //'allocating SVD_U'
+            GOTO 100
+         END IF
+         IF (associated(ROOT%SVD_VT)) DEALLOCATE(ROOT%SVD_VT)
+         NULLIFY(ROOT%SVD_VT)
+         ALLOCATE(ROOT%SVD_VT(NN,NN), stat=ALLOCOK)
+         IF (ALLOCOK.GT.0) THEN
+            INFO(1)=-13
+            INFO(2)=NN*NN
+            IF ( LP .GT. 0 )
+     &           WRITE(LP,*) 'SMUMPS_SEQ_FACTO_ROOT_SVD_QR: Problem '
+     &           //'allocating SVD_VT'
+            GOTO 100
+         END IF
+         IF (allocated(RWORK)) DEALLOCATE(RWORK)
+         ALLOCATE(RWORK(1), stat=ALLOCOK)
+         IF (ALLOCOK.GT.0) THEN
+            INFO(1)=-13
+            INFO(2)=1
+            IF ( LP .GT. 0 )
+     &           WRITE(LP,*) 
+     &           'SMUMPS_SEQ_FACTO_ROOT_SVD_QR: Problem '
+     &           //'allocating RWORK'
+            GOTO 100
+         END IF
+      ELSEIF(KEEP(19).EQ.2) THEN
+         IF (associated(ROOT%QR_TAU)) DEALLOCATE(ROOT%QR_TAU)
+         NULLIFY(ROOT%QR_TAU)
+         ALLOCATE(ROOT%QR_TAU(NN), stat=ALLOCOK)
+         IF (ALLOCOK.GT.0) THEN
+            INFO(1)=-13
+            INFO(2)=NN
+            IF ( LP .GT. 0 )
+     &           WRITE(LP,*) 
+     &           'SMUMPS_SEQ_FACTO_ROOT_SVD_QR: Problem '
+     &           //'allocating QR_TAU'
+            GOTO 100
+         END IF
+         IF (associated(ROOT%IPIV)) DEALLOCATE(ROOT%IPIV)
+         NULLIFY(ROOT%IPIV)
+         ALLOCATE(ROOT%IPIV(NN), stat=ALLOCOK)
+         IF (ALLOCOK.GT.0) THEN
+            INFO(1)=-13
+            INFO(2)=NN
+            IF ( LP .GT. 0 )
+     &           WRITE(LP,*) 
+     &           'SMUMPS_SEQ_FACTO_ROOT_SVD_QR: Problem '
+     &           //'allocating IPIV'
+            GOTO 100
+         END IF
+         IF (allocated(RWORK)) DEALLOCATE(RWORK)
+         ALLOCATE(RWORK(1), stat=ALLOCOK)
+         IF (ALLOCOK.GT.0) THEN
+            INFO(1)=-13
+            INFO(2)=1
+            IF ( LP .GT. 0 )
+     &           WRITE(LP,*) 
+     &           'SMUMPS_SEQ_FACTO_ROOT_SVD_QR: Problem '
+     &           //'allocating RWORK'
+            GOTO 100
+         END IF
+      ENDIF
+      IF (LDLT.NE.0) THEN
+         CALL SMUMPS_SEQ_SYMMETRIZE(NN,A)
+      END IF
+      LDA=NN
+      LDU=NN
+      LDVT=NN
+      IERR = 0
+      IF(KEEP(19).EQ.1) THEN
+         CALL sgesvd('A','A',NN,NN,A,LDA,ROOT%SINGULAR_VALUES(1)
+     &        ,ROOT%SVD_U(1,1)
+     &        ,LDU,ROOT%SVD_VT(1,1),LDVT,WR03,LWR03,IERR)
+      ENDIF
+      IF(IERR.NE.0) THEN
+         INFO(1)=-107
+         INFO(2)=IERR
+         IF (LP.GT.0) THEN
+            IF(KEEP(19).EQ.1) THEN
+               WRITE(LP,*) ' Problem in sgesvd : IERR = ', IERR
+            ELSEIF(KEEP(19).EQ.2) THEN
+               WRITE(LP,*) ' Problem in sgeqpf : IERR = ', IERR
+            ENDIF
+           GOTO 100
+         END IF
+      ENDIF
+      IF(KEEP(19).EQ.2) THEN
+         DO I=1,NN
+            ROOT%SINGULAR_VALUES(I)=abs(A(I+NN*(I-1)))
+         ENDDO
+      ENDIF
+      DEFICIENCY=0
+      MinPiv = DKEEP(20)
+      GAPLIMIT = DKEEP(9)
+      IF (ROOT%SINGULAR_VALUES(NN).GT.MinPiv) THEN
+              DEFICIENCY = 0
+              GOTO 170
+      ENDIF
+      IF (ROOT%SINGULAR_VALUES(1).LE.GAPLIMIT) THEN
+           DEFICIENCY = NN
+           GOTO 170
+      ENDIF
+      LAST_BEFORE_GAPLIMIT_IND = 0
+      LAST_BEFORE_GAP_IND  = 0
+      FIRST_AFTER_MinPiv   = 0
+      FIRST_AFTER_GAPLIMIT = 0
+      MaxGap  = 0
+      MaxGap1 = 0
+      Tol_MaxGap = DKEEP(24)
+      DO I=NN,1,-1
+              IF (FIRST_AFTER_MinPiv.GT.0)  exit   
+         IF(ROOT%SINGULAR_VALUES(I).LE.GAPLIMIT) THEN
+                  LAST_BEFORE_GAPLIMIT_IND = I
+         ELSE IF  ((FIRST_AFTER_GAPLIMIT.EQ.0).AND.
+     &               (ROOT%SINGULAR_VALUES(I).LE.MinPiv)) THEN
+                 FIRST_AFTER_GAPLIMIT = I
+         ELSE IF (ROOT%SINGULAR_VALUES(I).GT.MinPiv) THEN
+                 FIRST_AFTER_MinPiv = I
+                 IF (FIRST_AFTER_GAPLIMIT.EQ.0) FIRST_AFTER_GAPLIMIT = I
+         ENDIF
+      ENDDO
+      START_POINT = LAST_BEFORE_GAPLIMIT_IND
+      IF ((LAST_BEFORE_GAPLIMIT_IND.EQ.0).AND.
+     &    (FIRST_AFTER_GAPLIMIT.GT. FIRST_AFTER_MinPiv)) 
+     &               START_POINT = FIRST_AFTER_GAPLIMIT
+      END_POINT = FIRST_AFTER_MinPiv
+      IF (FIRST_AFTER_MinPiv.EQ.0) END_POINT = 1
+      DO I=START_POINT,END_POINT+1,-1
+          IF (ROOT%SINGULAR_VALUES(I).EQ.0) THEN
+             LAST_BEFORE_GAP_IND = I
+          ELSE
+              MaxGap1 = ROOT%SINGULAR_VALUES(I-1)*
+     &                                    (1/ROOT%SINGULAR_VALUES(I))
+             IF (MaxGap1.GE. Tol_MaxGap) THEN
+                  IF (MaxGap1.GE. DKEEP(25)*MaxGap ) THEN 
+                     LAST_BEFORE_GAP_IND = I
+                     MaxGap =  MaxGap1
+                  ENDIF  
+             ENDIF  
+          ENDIF
+      ENDDO
+      IF (MaxGap.EQ.ZERO) THEN        
+          IF (LAST_BEFORE_GAPLIMIT_IND.EQ.0) THEN
+               DEFICIENCY = 0
+          ELSE
+               DEFICIENCY = NN - LAST_BEFORE_GAPLIMIT_IND +1  
+          ENDIF
+      ELSE
+          DEFICIENCY = NN - LAST_BEFORE_GAP_IND +1  
+      ENDIF 
+ 170  CONTINUE
+      DEFICIENCY=min(DEFICIENCY,MAXDEF)
+      DEFICIENCY=max(DEFICIENCY,MINDEF)      
+      KEEP(17)=DEFICIENCY
+      IF(KEEP(19).EQ.2) THEN
+         IF(DEFICIENCY.GT.0) THEN
+            CALL strtrs('U','N','N',NN-DEFICIENCY,DEFICIENCY,
+     &           A,LDA,A(LDA*(NN-DEFICIENCY)+1),LDA,IERR)
+            IF ( IERR .NE. 0 ) THEN
+               IF (LP.GT.0) 
+     &         WRITE(LP,*) ' Internal error in strtrs: IERR = ',IERR
+               CALL MUMPS_ABORT()
+            END IF
+         END IF
+      ENDIF
+      DO J=NN-DEFICIENCY+1, NN
+         IF(KEEP(19).EQ.1) THEN
+            PIVNUL_LIST(J-NN+DEFICIENCY) = ROW_INDICES(J)
+         ELSEIF(KEEP(19).EQ.2) THEN
+            PIVNUL_LIST(J-NN+DEFICIENCY) = ROW_INDICES(ROOT%IPIV(J))
+         ENDIF
+      ENDDO
+ 100  CONTINUE     
+      IF (allocated(RWORK)) DEALLOCATE(RWORK)
+      RETURN
+      END SUBROUTINE SMUMPS_SEQ_FACTO_ROOT_SVD_QR
+      SUBROUTINE SMUMPS_SEQ_SOLVE_ROOT_SVD_QR
+     &  (NRHS,NN,A,ROOT,
+     &   IBEG_ROOT_DEF, IEND_ROOT_DEF,
+     &   RHS,KEEP,KEEP8,MTYPE,INFO,LWK8,WK, LP)
+      USE SMUMPS_STRUC_DEF, ONLY : SMUMPS_ROOT_STRUC
+      IMPLICIT NONE
+      INTEGER NN, NRHS
+      INTEGER(8), INTENT(IN) :: LWK8
+      TYPE ( SMUMPS_ROOT_STRUC ) :: root
+      REAL A(NN*NN)
+      INTEGER IBEG_ROOT_DEF, IEND_ROOT_DEF, MTYPE
+      INTEGER INFO(2),KEEP(500)
+      INTEGER(8) KEEP8(150)
+      REAL RHS(NN,NRHS), WK(LWK8)
+      INTEGER LP
+      INTEGER :: LWK
+      REAL,DIMENSION(:,:), allocatable :: TEMP_RHS
+      INTEGER :: I,IERR,K
+      INTEGER :: LDLT,RRSTRAT,DEFICIENCY,LDA,LDRHS
+      INTEGER :: ALLOCOK
+      REAL, PARAMETER    :: RONE=1.0E+0
+      REAL ZERO, ONE, MINUSONE
+      PARAMETER( ZERO = 0.0E0, ONE = 1.0E0, MINUSONE=-1.0E0 )
+      LDLT      = KEEP(50)
+      RRSTRAT   = KEEP(19)
+      DEFICIENCY = KEEP(17)
+      LDA = NN
+      LDRHS = NN
+      LWK = int(min(int(huge(LWK),8),LWK8))
+      IERR = 0
+      IF ((RRSTRAT .NE. 1).AND.(RRSTRAT .NE. 2)) THEN
+         WRITE(*,*) " *** Internal error ption ",RRSTRAT,
+     &        " for null space no more available."
+         CALL MUMPS_ABORT()
+      ENDIF
+      IF (KEEP(111).EQ.0) THEN
+         IF(KEEP(19).EQ.1) THEN
+           IF ((MTYPE.EQ.0).OR.(LDLT.GT.0)) THEN
+               allocate(TEMP_RHS(NN,NRHS), stat=ALLOCOK)
+               IF (ALLOCOK.GT.0) THEN
+                 INFO(1)=-13
+                 INFO(2)=NN*NRHS
+                 IF ( LP .GT. 0 )
+     &              WRITE(LP,*) 
+     &              'SMUMPS_SEQ_SOLVE_ROOT_SVD_QR: Problem '
+     &              //'allocating TEMP_RHS'
+                 RETURN
+               END IF
+               CALL sgemm('Transpose','N',NN,NRHS,NN,ONE,
+     &              root%SVD_U(1,1),NN,RHS,
+     &              NN,ZERO,TEMP_RHS,NN)
+               DO I=1,NN-DEFICIENCY
+                  TEMP_RHS( I, 1:NRHS ) = (ONE/root%SINGULAR_VALUES(I))*
+     &                          TEMP_RHS( I, 1:NRHS )
+               ENDDO
+               DO I=NN-DEFICIENCY +1, NN
+                  TEMP_RHS(I, 1:NRHS) = ZERO 
+               ENDDO
+               CALL sgemm('Transpose','N',NN,NRHS,NN,ONE,
+     &               root%SVD_VT(1,1),NN,
+     &              TEMP_RHS, NN,ZERO,RHS,NN)
+               DEALLOCATE(TEMP_RHS)
+           ELSEIF(MTYPE.EQ.1) THEN
+               allocate(TEMP_RHS(NN,NRHS), stat=ALLOCOK)
+               IF (ALLOCOK.GT.0) THEN
+                  INFO(1)=-13
+                  INFO(2)=NN*NRHS
+                  IF ( LP .GT. 0 )
+     &              WRITE(LP,*) 
+     &              'SMUMPS_SEQ_SOLVE_ROOT_SVD_QR: Problem '
+     &              //'allocating TEMP_RHS'
+                  RETURN
+               END IF
+               CALL sgemm('N','N',NN,NRHS,NN,ONE,root%SVD_VT(1,1),NN,
+     &              RHS, NN,ZERO,TEMP_RHS,NN)
+               DO I=1,NN-DEFICIENCY
+                  TEMP_RHS( I, 1:NRHS ) = (ONE/root%SINGULAR_VALUES(I))*
+     &                          TEMP_RHS( I, 1:NRHS )
+               ENDDO
+               DO I=NN-DEFICIENCY +1, NN
+                  TEMP_RHS(I, 1:NRHS) = ZERO 
+               ENDDO
+               CALL sgemm('N','N',NN,NRHS,NN,ONE,root%SVD_U(1,1),NN,
+     &             TEMP_RHS,NN,ZERO,RHS,NN)
+               DEALLOCATE(TEMP_RHS)
+            ENDIF
+         ELSEIF(KEEP(19).EQ.2) THEN
+            IF ((MTYPE.EQ.0).OR.(LDLT.GT.0)) THEN
+               CALL sormqr('L','Transpose',NN,NRHS,NN,
+     &              A,LDA,root%QR_TAU(1),
+     &              RHS,LDRHS,WK(1),LWK,IERR)
+               IF(IERR.LT.0) THEN
+                  WRITE(*,*) 
+     &         'Error return from sormqr in root solve: IERR=', IERR
+                  RETURN
+               END IF
+               CALL strtrs('U','N','N',NN-DEFICIENCY,NRHS,A,LDA,
+     &              RHS,LDRHS,IERR)
+               IF ( IERR .LT. 0 ) THEN
+                  WRITE(*,*) 
+     &         'Error return from strtrs in roor solve: IERR =',IERR
+                  RETURN
+               END IF
+               DO I=1,NRHS
+                  RHS( NN - DEFICIENCY + 1: NN, I ) = ZERO  
+               ENDDO
+               DO I=1,NRHS
+                  CALL SMUMPS_UXVSBP(NN,root%IPIV(1),RHS(1,I),WK)
+               ENDDO
+           ELSEIF(MTYPE.EQ.1) THEN
+               DO I=1,NRHS
+                 CALL SMUMPS_UXVSFP(NN,root%IPIV(1),RHS(1,I),WK)
+               ENDDO
+               CALL strtrs('U','T','N',NN-DEFICIENCY,NRHS,
+     &              A,LDA,RHS,LDRHS,IERR)
+               IF(IERR.NE.0) THEN
+                  WRITE(*,*) 'Error return from trtrs: IERR=', IERR
+                  STOP    
+               END IF
+               DO I=1,NRHS
+                  RHS( NN - DEFICIENCY + 1: NN, I ) = ZERO  
+               ENDDO
+               CALL sormqr( 'L','N',NN,NRHS,NN,A,LDA,root%QR_TAU(1),
+     &              RHS,LDRHS,WK,LWK,IERR)
+               IF(IERR.LT.0) THEN
+                  WRITE(*,*) 'Error return from sormqr: IERR=', IERR
+                  RETURN
+               END IF
+            ENDIF
+         ENDIF
+      ELSE
+         IF(KEEP(19).EQ.1) THEN
+           IF ((MTYPE.EQ.0).OR.(LDLT.GT.0)) THEN
+               DO I=IBEG_ROOT_DEF,IEND_ROOT_DEF
+                  RHS(:,I+1-IBEG_ROOT_DEF) = 
+     &                 root%SVD_VT(NN-DEFICIENCY+I,:)
+               ENDDO
+           ELSEIF(MTYPE.EQ.1) THEN
+               DO I=IBEG_ROOT_DEF,IEND_ROOT_DEF
+                  RHS(:,I+1-IBEG_ROOT_DEF) = 
+     &                 root%SVD_U(:,NN-DEFICIENCY+I)
+               ENDDO
+            ENDIF
+         ELSEIF(KEEP(19).EQ.2) THEN
+           IF((MTYPE.EQ.0).OR.(LDLT.GT.0)) THEN        
+               DO I=IBEG_ROOT_DEF,IEND_ROOT_DEF
+                  RHS(NN-DEFICIENCY+I,I-IBEG_ROOT_DEF+1) = MINUSONE
+                  DO K=1,NN-DEFICIENCY
+                     RHS(K,I-IBEG_ROOT_DEF+1)=
+     &                    A(K + LDA*(NN-DEFICIENCY+I-1))
+                  ENDDO
+               ENDDO
+               DO I=1,IEND_ROOT_DEF-IBEG_ROOT_DEF+1
+                  CALL SMUMPS_UXVSBP(NN,root%IPIV(1),RHS(1,I),WK)
+               ENDDO 
+           ELSEIF(MTYPE.EQ.1) THEN
+               WRITE(*,*) 'Computation of a null space basis'
+     &              // ' of A is unavailable for unsymetric matrices'
+            DO I=IBEG_ROOT_DEF,IEND_ROOT_DEF
+               RHS(NN-DEFICIENCY+I,I-IBEG_ROOT_DEF+1) = ONE
+            ENDDO
+            CALL sormqr('L','N',NN,NRHS,NN, A,LDA,root%QR_TAU(1),
+     &              RHS,LDRHS,WK(1),LWK,IERR)
+            ENDIF
+         ENDIf
+      ENDIF
+      RETURN
+      END SUBROUTINE SMUMPS_SEQ_SOLVE_ROOT_SVD_QR
diff -pruN 5.6.2-2.1/src/ssol_aux.F 5.7.1-1/src/ssol_aux.F
--- 5.6.2-2.1/src/ssol_aux.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/ssol_aux.F	2024-05-02 10:15:25.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -307,7 +307,8 @@ C
       REAL W(N), X(N)
       REAL, intent(inout)    :: EST
       INTEGER, intent(in)    :: GRAIN
-      INTRINSIC abs, nint, real, sign
+      INTRINSIC abs, nint, sign
+      INTRINSIC real
       INTEGER SMUMPS_IXAMAX
       EXTERNAL SMUMPS_IXAMAX
       INTEGER ITMAX
@@ -407,7 +408,7 @@ C
       DO 170 I = 1, N
         TEMP = TEMP + abs(X(I))
   170 CONTINUE
-      TEMP = 2.0E0 * TEMP / real(3 * N)
+      TEMP = 2.0E0/3.0E0 * TEMP / real(N)
       IF (TEMP .GT. EST) THEN
         DO 180 I = 1, N
           W(I) = X(I)
@@ -953,7 +954,7 @@ C
       REAL, PARAMETER :: ZERO = 0.0E0
       REAL, PARAMETER :: ONE  = 1.0E0
       INTEGER SMUMPS_IXAMAX
-      INTRINSIC     abs, max
+      INTRINSIC     abs
       SAVE LCOND1, LCOND2, JUMP,  DXIMAX, DXMAX
       IF (KASE .EQ. 0) THEN
         LCOND1 = .FALSE.
@@ -1033,14 +1034,14 @@ C
   170 CONTINUE
       RETURN
       END SUBROUTINE SMUMPS_SOL_LCOND
-      SUBROUTINE SMUMPS_SOL_CPY_FS2RHSCOMP( JBDEB, JBFIN, NBROWS,
-     &   KEEP, RHSCOMP, NRHS, LRHSCOMP, FIRST_ROW_RHSCOMP, W, LD_W,
+      SUBROUTINE SMUMPS_SOL_CPY_FS2RHSINTR( JBDEB, JBFIN, NBROWS,
+     &   KEEP, RHSINTR, NRHS, LRHSINTR, FIRST_ROW_RHSINTR, W, LD_W,
      &   FIRST_ROW_W )
          INTEGER :: JBDEB, JBFIN, NBROWS
-         INTEGER :: NRHS, LRHSCOMP
-         INTEGER :: FIRST_ROW_RHSCOMP
+         INTEGER :: NRHS, LRHSINTR
+         INTEGER :: FIRST_ROW_RHSINTR
          INTEGER, INTENT(IN) :: KEEP(500)
-         REAL, INTENT(INOUT) :: RHSCOMP(LRHSCOMP,NRHS)
+         REAL, INTENT(INOUT) :: RHSINTR(LRHSINTR,NRHS)
          INTEGER :: LD_W, FIRST_ROW_W
          REAL :: W(LD_W*(JBFIN-JBDEB+1))
          INTEGER :: JJ, K, ISHIFT
@@ -1050,33 +1051,33 @@ C
          DO K = JBDEB, JBFIN
            ISHIFT = FIRST_ROW_W + LD_W * (K-JBDEB)
            DO JJ = 0, NBROWS-1
-              RHSCOMP(FIRST_ROW_RHSCOMP+JJ,K) = W(ISHIFT+JJ)
+              RHSINTR(FIRST_ROW_RHSINTR+JJ,K) = W(ISHIFT+JJ)
            END DO
          END DO
 !$OMP    END PARALLEL DO
       RETURN
-      END SUBROUTINE SMUMPS_SOL_CPY_FS2RHSCOMP
+      END SUBROUTINE SMUMPS_SOL_CPY_FS2RHSINTR
       SUBROUTINE SMUMPS_SOL_BWD_GTHR( JBDEB, JBFIN, J1, J2,
-     &   RHSCOMP, NRHS, LRHSCOMP, W, LD_W, FIRST_ROW_W,
-     &   IW, LIW, KEEP, N, POSINRHSCOMP_BWD )
+     &   RHSINTR, NRHS, LRHSINTR, W, LD_W, FIRST_ROW_W,
+     &   IW, LIW, KEEP, N, POSINRHSINTR_BWD )
       INTEGER, INTENT(IN) :: JBDEB, JBFIN, J1, J2
-      INTEGER, INTENT(IN) :: NRHS, LRHSCOMP
+      INTEGER, INTENT(IN) :: NRHS, LRHSINTR
       INTEGER, INTENT(IN) :: FIRST_ROW_W, LD_W, LIW
       INTEGER, INTENT(IN) :: IW(LIW)
       INTEGER, INTENT(IN) :: KEEP(500)
-      REAL, INTENT(INOUT) :: RHSCOMP(LRHSCOMP,NRHS)
+      REAL, INTENT(INOUT) :: RHSINTR(LRHSINTR,NRHS)
       REAL :: W(LD_W*(JBFIN-JBDEB+1))
       INTEGER, INTENT(IN) :: N
-      INTEGER, INTENT(IN) :: POSINRHSCOMP_BWD(N)
-      INTEGER :: ISHIFT, JJ, K, IPOSINRHSCOMP
-!$OMP PARALLEL DO PRIVATE(JJ,ISHIFT,IPOSINRHSCOMP), IF
+      INTEGER, INTENT(IN) :: POSINRHSINTR_BWD(N)
+      INTEGER :: ISHIFT, JJ, K, IPOSINRHSINTR
+!$OMP PARALLEL DO PRIVATE(JJ,ISHIFT,IPOSINRHSINTR), IF
 !$OMP& ((JBFIN-JBDEB+1 > 2*KEEP(362) .AND.
 !$OMP& (JBFIN-JBDEB+1)*(J2-KEEP(253)-J1+1)>2*KEEP(363)))
              DO K=JBDEB, JBFIN
                ISHIFT = FIRST_ROW_W+(K-JBDEB)*LD_W
                DO JJ = J1, J2-KEEP(253)   
-                 IPOSINRHSCOMP =  abs(POSINRHSCOMP_BWD(IW(JJ)))
-                 W(ISHIFT+JJ-J1)= RHSCOMP(IPOSINRHSCOMP,K)
+                 IPOSINRHSINTR =  abs(POSINRHSINTR_BWD(IW(JJ)))
+                 W(ISHIFT+JJ-J1)= RHSINTR(IPOSINRHSINTR,K)
                ENDDO
              ENDDO
 !$OMP END PARALLEL DO
@@ -1134,11 +1135,11 @@ C
       RESL2 = sqrt(RESL2)
       IF (PROK) WRITE( MPRINT, 90 ) RESMAX, RESL2, ANORM, XNORM, 
      &      SCLNRM
-   90  FORMAT (/' RESIDUAL IS ............ (MAX-NORM)        =',1PD9.2/
+   90  FORMAT (/' RESIDUAL IS ............ (INF-NORM)        =',1PD9.2/
      &       '                       .. (2-NORM)          =',1PD9.2/
-     &       ' RINFOG(4):NORM OF input  Matrix  (MAX-NORM)=',1PD9.2/
-     &       ' RINFOG(5):NORM OF Computed SOLUT (MAX-NORM)=',1PD9.2/
-     &       ' RINFOG(6):SCALED RESIDUAL ...... (MAX-NORM)=',1PD9.2)
+     &       ' RINFOG(4):NORM OF input  Matrix  (INF-NORM)=',1PD9.2/
+     &       ' RINFOG(5):NORM OF Computed SOLUT (INF-NORM)=',1PD9.2/
+     &       ' RINFOG(6):SCALED RESIDUAL ...... (INF-NORM)=',1PD9.2)
       RETURN
       END SUBROUTINE SMUMPS_SOL_Q
       SUBROUTINE SMUMPS_SOLVE_FWD_TRSOLVE (A, LA, APOS, NPIV, LDADIAG, 
@@ -1370,8 +1371,8 @@ C
      &  IW, IPOS, LIW, 
      &  A, LA, APOS,
      &  WCB, LWCB, LD_WCBPIV, 
-     &  RHSCOMP, LRHSCOMP, NRHS, 
-     &  POSINRHSCOMP_FWD, JBDEB, JBFIN, 
+     &  RHSINTR, LRHSINTR, NRHS, 
+     &  POSINRHSINTR_FWD, JBDEB, JBFIN, 
      &  MTYPE, KEEP, OOCWRITE_COMPATIBLE_WITH_BLR,
      &  IGNORE_K459
      &  )
@@ -1379,18 +1380,18 @@ C
       IMPLICIT NONE
       INTEGER, INTENT(IN) :: MTYPE, INODE, N, NPIV, LIELL,
      &                       NELIM, NSLAVES
-      INTEGER, INTENT(IN) :: LRHSCOMP, NRHS, LIW, JBDEB, JBFIN
-      INTEGER, INTENT(IN) :: IW(LIW), IPOS, POSINRHSCOMP_FWD(N)
+      INTEGER, INTENT(IN) :: LRHSINTR, NRHS, LIW, JBDEB, JBFIN
+      INTEGER, INTENT(IN) :: IW(LIW), IPOS, POSINRHSINTR_FWD(N)
       INTEGER(8), INTENT(IN) :: LWCB, APOS, LA, PPIV_COURANT
       INTEGER, INTENT(IN) :: LD_WCBPIV
       INTEGER, INTENT(IN) :: KEEP(500)
       REAL, INTENT(IN) ::  WCB( LWCB )
       REAL, INTENT(IN) :: A( LA )
-      REAL, INTENT(INOUT) :: RHSCOMP(LRHSCOMP, NRHS)
+      REAL, INTENT(INOUT) :: RHSINTR(LRHSINTR, NRHS)
       LOGICAL, INTENT(IN) :: OOCWRITE_COMPATIBLE_WITH_BLR
       LOGICAL, INTENT(IN) :: IGNORE_K459
       INTEGER    :: J1, J3
-      INTEGER    :: IPOSINRHSCOMP, JJ, K,
+      INTEGER    :: IPOSINRHSINTR, JJ, K,
      &              LDAJ, NRHS_B
       INTEGER(8) :: IFR8 , APOS1, APOS2, APOSOFF, IFR_ini8, 
      &              POSWCB1, POSWCB2
@@ -1412,7 +1413,7 @@ C
          J1 = IPOS + LIELL + 1
          J3 = IPOS + LIELL + NPIV
       END IF
-      IPOSINRHSCOMP =  POSINRHSCOMP_FWD(IW(J1)) 
+      IPOSINRHSINTR =  POSINRHSINTR_FWD(IW(J1)) 
       IF ( KEEP(50) .eq. 0 ) THEN
          OMP_FLAG = .FALSE.
 !$       OMP_FLAG=(int(NRHS_B,8)*int(NPIV,8).GE.int(KEEP(363),8))
@@ -1420,7 +1421,7 @@ C
 !$OMP PARALLEL DO PRIVATE(IFR8) COLLAPSE(2)
            DO K = JBDEB, JBFIN
              DO IFR8 = 0_8, int(NPIV-1,8)
-               RHSCOMP(IPOSINRHSCOMP+IFR8, K) =
+               RHSINTR(IPOSINRHSINTR+IFR8, K) =
      &            WCB(PPIV_COURANT+(K-JBDEB)*LD_WCBPIV+IFR8)
              ENDDO
            ENDDO
@@ -1428,7 +1429,7 @@ C
          ELSE
            DO K = JBDEB, JBFIN
              DO IFR8 = 0_8, int(NPIV-1,8)
-               RHSCOMP(IPOSINRHSCOMP+IFR8, K) =
+               RHSINTR(IPOSINRHSINTR+IFR8, K) =
      &            WCB(PPIV_COURANT+(K-JBDEB)*LD_WCBPIV+IFR8)
              ENDDO
            ENDDO
@@ -1448,7 +1449,7 @@ C
             DO JJ = J1, J3
               IPANEL = (JJ-J1)/NB_TARGET + 1
               IF ( JJ-J1+1 .LT. PANEL_COL(IPANEL) ) IPANEL = IPANEL -1
-              ICOL = JJ-J1+1 - PANEL_COL(IPANEL) + 1
+              ICOL = JJ-J1+1 - PANEL_COL(IPANEL) + 1 
               LDAJ = PANEL_COL(IPANEL+1) - PANEL_COL(IPANEL)
               APOS1 = APOS-1_8+PANEL_POS( IPANEL ) + int(ICOL-1,8) *
      &                int(LDAJ+1,8)
@@ -1466,7 +1467,7 @@ C
               IF (SKIP_IT) THEN
               ELSE IF ( IW(JJ+LIELL) .GT. 0 ) THEN
                 VALPIV  = ONE/A( APOS1 )
-                RHSCOMP(IPOSINRHSCOMP+JJ-J1 , K ) = 
+                RHSINTR(IPOSINRHSINTR+JJ-J1 , K ) = 
      &                 WCB( IFR8 ) * VALPIV
                 APOS1 = APOS1 + int(LDAJ + 1,8)
               ELSE
@@ -1481,10 +1482,10 @@ C
                 A12 = -A12/DETPIV
                 POSWCB1 = IFR8
                 POSWCB2 = POSWCB1+1_8
-                RHSCOMP(IPOSINRHSCOMP+JJ-J1,K) =
+                RHSINTR(IPOSINRHSINTR+JJ-J1,K) =
      &                 WCB(POSWCB1)*A11
      &                 + WCB(POSWCB2)*A12
-                RHSCOMP(IPOSINRHSCOMP+JJ-J1+1,K) = 
+                RHSINTR(IPOSINRHSINTR+JJ-J1+1,K) = 
      &                   WCB(POSWCB1)*A12
      &                   + WCB(POSWCB2)*A22
               ENDIF  
@@ -1500,26 +1501,26 @@ C
      &  IW, IPOS, LIW, 
      &  A, LA, APOS,
      &  WCB, LWCB, LD_WCBPIV, 
-     &  RHSCOMP, LRHSCOMP, NRHS, 
-     &  POSINRHSCOMP_FWD, JBDEB, JBFIN, 
+     &  RHSINTR, LRHSINTR, NRHS, 
+     &  POSINRHSINTR_FWD, JBDEB, JBFIN, 
      &  MTYPE, KEEP, OOCWRITE_COMPATIBLE_WITH_BLR,
      &  IGNORE_K459
      &  )
       USE SMUMPS_OOC 
       INTEGER, INTENT(IN) :: MTYPE, INODE, N, NPIV, LIELL,
      &                       NELIM, NSLAVES
-      INTEGER, INTENT(IN) :: LRHSCOMP, NRHS, LIW, JBDEB, JBFIN
-      INTEGER, INTENT(IN) :: IW(LIW), IPOS, POSINRHSCOMP_FWD(N)
+      INTEGER, INTENT(IN) :: LRHSINTR, NRHS, LIW, JBDEB, JBFIN
+      INTEGER, INTENT(IN) :: IW(LIW), IPOS, POSINRHSINTR_FWD(N)
       INTEGER(8), INTENT(IN) :: LWCB, APOS, LA, PPIV_COURANT
       INTEGER, INTENT(IN) :: LD_WCBPIV
       INTEGER, INTENT(IN) :: KEEP(500)
       REAL, INTENT(IN) ::  WCB( LWCB )
       REAL, INTENT(IN) :: A( LA )
-      REAL, INTENT(INOUT) :: RHSCOMP(LRHSCOMP, NRHS)
+      REAL, INTENT(INOUT) :: RHSINTR(LRHSINTR, NRHS)
       LOGICAL, INTENT(IN) :: OOCWRITE_COMPATIBLE_WITH_BLR
       LOGICAL, INTENT(IN) :: IGNORE_K459
       INTEGER    :: TempNROW, J1, J3, PANEL_SIZE
-      INTEGER    :: IPOSINRHSCOMP, JJ, K, NBK, LDAJ, 
+      INTEGER    :: IPOSINRHSINTR, JJ, K, NBK, LDAJ, 
      &              LDAJ_ini, NBK_ini, LDAJ_FIRST_PANEL, NRHS_B
       INTEGER(8) :: IFR8 , APOS1, APOS2, APOSOFF, IFR_ini8, 
      &              POSWCB1, POSWCB2
@@ -1535,13 +1536,13 @@ C
          J1 = IPOS + LIELL + 1
          J3 = IPOS + LIELL + NPIV
       END IF
-      IPOSINRHSCOMP =  POSINRHSCOMP_FWD(IW(J1)) 
+      IPOSINRHSINTR =  POSINRHSINTR_FWD(IW(J1)) 
       IF ( KEEP(50) .eq. 0 ) THEN
 !$         OMP_FLAG=(NRHS_B.GE.KEEP(362).AND.NRHS_B*NPIV.GE.KEEP(363))
 !$OMP PARALLEL DO PRIVATE(IFR8) IF (OMP_FLAG)
            DO K=JBDEB,JBFIN
              IFR8 =  PPIV_COURANT + (K-JBDEB)*LD_WCBPIV
-             RHSCOMP(IPOSINRHSCOMP:IPOSINRHSCOMP+NPIV-1, K) =
+             RHSINTR(IPOSINRHSINTR:IPOSINRHSINTR+NPIV-1, K) =
      &            WCB(IFR8:IFR8+int(NPIV-1,8))
            ENDDO
 !$OMP END PARALLEL DO
@@ -1594,7 +1595,7 @@ C
             IFR8  = IFR8 + 1_8
             IF (IW(JJ+LIELL) .GT. 0) THEN
                VALPIV  = ONE/A( APOS1 )
-               RHSCOMP(IPOSINRHSCOMP+JJ-J1 , K ) = 
+               RHSINTR(IPOSINRHSINTR+JJ-J1 , K ) = 
      &                 WCB( IFR8 ) * VALPIV
               IF (KEEP(201).EQ.1.AND.OOCWRITE_COMPATIBLE_WITH_BLR)
      &        THEN
@@ -1627,10 +1628,10 @@ C
               A12 = -A12/DETPIV
               POSWCB1 = IFR8
               POSWCB2 = POSWCB1+1_8
-              RHSCOMP(IPOSINRHSCOMP+JJ-J1,K) =
+              RHSINTR(IPOSINRHSINTR+JJ-J1,K) =
      &               WCB(POSWCB1)*A11
      &               + WCB(POSWCB2)*A12
-              RHSCOMP(IPOSINRHSCOMP+JJ-J1+1,K) = 
+              RHSINTR(IPOSINRHSINTR+JJ-J1+1,K) = 
      &                 WCB(POSWCB1)*A12
      &                 + WCB(POSWCB2)*A22
               IF (KEEP(201).EQ.1.AND.OOCWRITE_COMPATIBLE_WITH_BLR)
@@ -1659,6 +1660,7 @@ C
         SEQUENCE
         REAL, dimension(:), pointer :: SCALING
         REAL, dimension(:), pointer :: SCALING_LOC
+        INTEGER, dimension(:), pointer :: SCALING_IND
       end type scaling_data_t
       type (scaling_data_t), INTENT(INOUT) :: scaling_data
       INTEGER, INTENT(IN) :: N, LILOC, COMM, MYID, MASTER, LP
diff -pruN 5.6.2-2.1/src/ssol_bwd.F 5.7.1-1/src/ssol_bwd.F
--- 5.6.2-2.1/src/ssol_bwd.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/ssol_bwd.F	2024-05-02 10:15:25.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -13,7 +13,7 @@ C  https://cecill.info/licences/Licence_
 C
       SUBROUTINE SMUMPS_SOL_S(N, A, LA, IW, LIW, W, LWC,
      &    NRHS, 
-     &    RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &    RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &    PTRICB, PTRACB, IWCB, LIWW, W2, 
      &    NE_STEPS, STEP,
      &    FRERE, DAD, FILS, IPOOL, LPOOL, PTRIST, PTRFAC, 
@@ -59,8 +59,8 @@ C
       INTEGER BUFR(LBUFR)
       INTEGER ISTEP_TO_INIV2(KEEP(71)), 
      &        TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
-      INTEGER LRHSCOMP, POSINRHSCOMP_BWD(N)
-      REAL RHSCOMP(LRHSCOMP,NRHS)
+      INTEGER LRHSINTR, POSINRHSINTR_BWD(N)
+      REAL RHSINTR(LRHSINTR,NRHS)
       INTEGER(8), intent(in) :: LRHS_ROOT
       REAL RHS_ROOT( LRHS_ROOT )
       LOGICAL, INTENT(in) :: PRUN_BELOW
@@ -124,22 +124,26 @@ C
       ERROR_WAS_BROADCASTED = .FALSE.
       DO_MCAST2_TERMBWD = .FALSE.
       DO WHILE ( NBFINF .NE. 0 .OR. MYLEAF_LEFT .NE. 0 )
-        BLOQ = (  III .EQ. IIPOOL  )
-        CALL SMUMPS_BACKSLV_RECV_AND_TREAT( BLOQ, FLAG, BUFR, LBUFR,
-     &     LBUFR_BYTES, MYID, SLAVEF, COMM,
-     &     N, IWCB, LIWW, POSIWCB,
-     &     W, LWC, POSWCB,
-     &     IIPOOL, NBFINF, PTRICB, PTRACB, INFO,
-     &     IPOOL, LPOOL, PANEL_POS, LPANEL_POS,
-     &     STEP,  FRERE, FILS, PROCNODE_STEPS,
-     &     PLEFTW, KEEP,KEEP8, DKEEP,
-     &     PTRIST, PTRFAC, IW, LIW, A, LA, W2, MYLEAF_LEFT, 
-     &     NRHS, MTYPE, 
-     &     RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD
-     &     , PRUN_BELOW, TO_PROCESS, SIZE_TO_PROCESS
-     &     , FROM_PP
+        IF ( SLAVEF.EQ.1 ) THEN
+          FLAG = .FALSE.
+        ELSE
+          BLOQ = (  III .EQ. IIPOOL  )
+          CALL SMUMPS_BACKSLV_RECV_AND_TREAT( BLOQ, FLAG, BUFR, LBUFR,
+     &       LBUFR_BYTES, MYID, SLAVEF, COMM,
+     &       N, IWCB, LIWW, POSIWCB,
+     &       W, LWC, POSWCB,
+     &       IIPOOL, NBFINF, PTRICB, PTRACB, INFO,
+     &       IPOOL, LPOOL, PANEL_POS, LPANEL_POS,
+     &       STEP,  FRERE, FILS, PROCNODE_STEPS,
+     &       PLEFTW, KEEP,KEEP8, DKEEP,
+     &       PTRIST, PTRFAC, IW, LIW, A, LA, W2, MYLEAF_LEFT, 
+     &       NRHS, MTYPE, 
+     &       RHSINTR, LRHSINTR, POSINRHSINTR_BWD
+     &       , PRUN_BELOW, TO_PROCESS, SIZE_TO_PROCESS
+     &       , FROM_PP
      &     )
-        IF ( INFO(1) .LT. 0 ) GOTO 340 
+          IF ( INFO(1) .LT. 0 ) GOTO 340 
+        ENDIF
         IF ( .NOT. FLAG ) THEN
           IF (III .NE. IIPOOL) THEN
             INODE = IPOOL(IIPOOL-1)
@@ -161,7 +165,7 @@ C
      &        N, IPOOL, LPOOL, IIPOOL, NBFINF,
      &        A_PTR(1), LA_PTR, IW, LIW, W, LWC, NRHS,
      &        POSWCB, PLEFTW, POSIWCB,
-     &        RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &        RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &        PTRICB, PTRACB, IWCB, LIWW, W2, 
      &        NE_STEPS, STEP,
      &        FRERE, FILS, PTRIST, PTRFAC,
diff -pruN 5.6.2-2.1/src/ssol_bwd_aux.F 5.7.1-1/src/ssol_bwd_aux.F
--- 5.6.2-2.1/src/ssol_bwd_aux.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/ssol_bwd_aux.F	2024-05-02 10:15:25.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -15,7 +15,7 @@ C
      &       N, IPOOL, LPOOL, IIPOOL, NBFINF,
      &       A, LA, IW, LIW, W, LWC, NRHS, 
      &       POSWCB, PLEFTW, POSIWCB,
-     &    RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &    RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &    PTRICB, PTRACB, IWCB, LIWW, W2, 
      &    NE_STEPS, STEP,
      &    FRERE, FILS, PTRIST, PTRFAC, 
@@ -62,8 +62,8 @@ C
       INTEGER BUFR(LBUFR)
       INTEGER ISTEP_TO_INIV2(KEEP(71)), 
      &        TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
-      INTEGER LRHSCOMP, POSINRHSCOMP_BWD(N)
-      REAL RHSCOMP(LRHSCOMP,NRHS)
+      INTEGER LRHSINTR, POSINRHSINTR_BWD(N)
+      REAL RHSINTR(LRHSINTR,NRHS)
       INTEGER(8), intent(in) :: LRHS_ROOT
       REAL RHS_ROOT( LRHS_ROOT )
       LOGICAL, INTENT( IN ) :: PRUN_BELOW
@@ -99,7 +99,7 @@ C
       INTEGER :: PROCDEST, DEST
       INTEGER(8) :: PTWCB, PPIV_COURANT
       INTEGER :: Offset, EffectiveSize, ISLAVE, FirstIndex
-      INTEGER :: POSINDICES, IPOSINRHSCOMP, IPOSINRHSCOMP_PANEL
+      INTEGER :: POSINDICES, IPOSINRHSINTR, IPOSINRHSINTR_PANEL
       INTEGER(8) :: APOS, IST
       INTEGER(8) :: IFR8
       INTEGER(8) :: APOSDEB, NBENTRIES_ALLPANELS
@@ -139,9 +139,9 @@ C
             J2   = IPOS + NPIV
          END IF
          IFR8  = 0_8
-         IPOSINRHSCOMP = POSINRHSCOMP_BWD(IW(J1))  
-         CALL SMUMPS_SOL_CPY_FS2RHSCOMP(JBDEB, JBFIN, J2-J1+1,
-     &          KEEP, RHSCOMP, NRHS, LRHSCOMP, IPOSINRHSCOMP,
+         IPOSINRHSINTR = POSINRHSINTR_BWD(IW(J1))  
+         CALL SMUMPS_SOL_CPY_FS2RHSINTR(JBDEB, JBFIN, J2-J1+1,
+     &          KEEP, RHSINTR, NRHS, LRHSINTR, IPOSINRHSINTR,
      &          RHS_ROOT(1+NPIV*(JBDEB-1)), NPIV, 1)
         IN = INODE
  270    IN = FILS(IN)
@@ -208,8 +208,8 @@ C
      &                 LONG, LONG, IW( J1 ),
      &                 RHS_ROOT( 1+NPIV*(JBDEB-1) ), 
      &                 JBDEB, JBFIN,
-     &                 RHSCOMP(1, 1), NRHS, LRHSCOMP,
-     &                 IPOSINRHSCOMP, NPIV,
+     &                 RHSINTR(1, 1), NRHS, LRHSINTR,
+     &                 IPOSINRHSINTR, NPIV,
      &                 KEEP, PROCDEST,
      &                 NOEUD, COMM, IERR )
                 IF ( IERR .EQ. -1 ) THEN
@@ -226,7 +226,7 @@ C
      &                  PTRIST, PTRFAC, IW, LIW, A, LA, W2,
      &                  MYLEAF_LEFT, 
      &                  NRHS, MTYPE,
-     &                  RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &                  RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &                  PRUN_BELOW, TO_PROCESS, SIZE_TO_PROCESS
      &                  , FROM_PP
      &                  )
@@ -347,9 +347,9 @@ C
            END IF
            IFR8 = PTRACB(STEP( INODE )) - 1_8
           CALL SMUMPS_SOL_BWD_GTHR( JBDEB, JBFIN, J1, J2,
-     &       RHSCOMP, NRHS, LRHSCOMP,
+     &       RHSINTR, NRHS, LRHSINTR,
      &       W(PTRACB(STEP(INODE))), NCB, 1,
-     &       IW, LIW, KEEP, N, POSINRHSCOMP_BWD )
+     &       IW, LIW, KEEP, N, POSINRHSINTR_BWD )
              IFR8 = IFR8 + int(J2-KEEP(253)-J1+1,8)
            IF (KEEP(252).NE.0) THEN
              DO JJ = J2-KEEP(253)+1, J2
@@ -392,7 +392,7 @@ C
      &              PROCNODE_STEPS, PLEFTW, KEEP,KEEP8, DKEEP,
      &              PTRIST, PTRFAC, IW, LIW, A, LA, W2, MYLEAF_LEFT,
      &              NRHS, MTYPE,
-     &              RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &              RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &              PRUN_BELOW , TO_PROCESS, SIZE_TO_PROCESS
      &               , FROM_PP
      &               )
@@ -516,15 +516,15 @@ C
         PTWCB = PTRACB(STEP( INODE ))
       ENDIF
       IF (J2.GE.J1) THEN
-        IPOSINRHSCOMP = POSINRHSCOMP_BWD(IW(J1)) 
+        IPOSINRHSINTR = POSINRHSINTR_BWD(IW(J1)) 
       ELSE
-        IPOSINRHSCOMP = -99999
+        IPOSINRHSINTR = -99999
       ENDIF
       IF (J2.GE.J1) THEN
         DO K=JBDEB, JBFIN
             IF (KEEP(252).NE.0) THEN
               DO JJ = J1, J2
-                RHSCOMP(IPOSINRHSCOMP+JJ-J1,K) = ZERO
+                RHSINTR(IPOSINRHSINTR+JJ-J1,K) = ZERO
               ENDDO
             ENDIF
         END DO
@@ -539,9 +539,9 @@ C
           J2 = IPOS + LIELL
         END IF
         CALL SMUMPS_SOL_BWD_GTHR( JBDEB, JBFIN, J1, J2,
-     &       RHSCOMP, NRHS, LRHSCOMP,
+     &       RHSINTR, NRHS, LRHSINTR,
      &       W(PTWCB), LIELL, NPIV+1,
-     &       IW, LIW, KEEP, N, POSINRHSCOMP_BWD )
+     &       IW, LIW, KEEP, N, POSINRHSINTR_BWD )
           IFR8 = IFR8 + int(J2-KEEP(253)-J1+1,8)
         IF (KEEP(252).NE.0) THEN
           DO JJ = J2-KEEP(253)+1, J2
@@ -601,7 +601,7 @@ C
             ENDIF
             LDAJ    = LIELL-BEG_PANEL+1 
             APOSDEB = APOSDEB - int(NBJ,8)*int(LDAJ,8)
-            IPOSINRHSCOMP_PANEL = IPOSINRHSCOMP + BEG_PANEL - 1
+            IPOSINRHSINTR_PANEL = IPOSINRHSINTR + BEG_PANEL - 1
             NCB_PANEL   = LDAJ - NBJ
             IF (KEEP(50).NE.1.AND.MUST_BE_PERMUTED) THEN
               CALL SMUMPS_GET_OOC_PERM_PTR(TYPEF, TMP_NBPANELS,
@@ -623,24 +623,24 @@ C
                   IF (NCB_PANEL - NCB.NE. 0) THEN
                     CALL sgemv( 'T', NCB_PANEL-NCB, NBJ, ALPHA, 
      &              A( APOSDEB + int(NBJ,8) ), LDAJ,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL+NBJ,JBDEB),
+     &              RHSINTR(IPOSINRHSINTR_PANEL+NBJ,JBDEB),
      &              1, ONE,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), 1 )
+     &              RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), 1 )
                   ENDIF
                   IF (NCB .NE. 0) THEN
                     CALL sgemv( 'T', NCB, NBJ, ALPHA,
      &              A( APOSDEB + int(LDAJ-NCB,8) ), LDAJ,
      &              W( PTWCB  + int(NPIV,8) ),
      &              1, ONE,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), 1 )
+     &              RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), 1 )
                   ENDIF
               ENDIF
               IF (MTYPE.NE.1) THEN
                 CALL strsv('L','T','U', NBJ, A(APOSDEB), LDAJ,
-     &            RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), 1)
+     &            RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), 1)
               ELSE
                 CALL strsv('L','T','N', NBJ, A(APOSDEB), LDAJ,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), 1)
+     &              RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), 1)
               ENDIF
             ELSE
 #endif
@@ -649,24 +649,24 @@ C
                   CALL sgemm( 'T', 'N', NBJ, NRHS_B,
      &                                         NCB_PANEL-NCB, ALPHA,
      &              A(APOSDEB +int(NBJ,8)), LDAJ,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL+NBJ,JBDEB), LRHSCOMP,
-     &              ONE, RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), LRHSCOMP)
+     &              RHSINTR(IPOSINRHSINTR_PANEL+NBJ,JBDEB), LRHSINTR,
+     &              ONE, RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), LRHSINTR)
                   ENDIF
                   IF (NCB .NE. 0) THEN
                   CALL sgemm( 'T', 'N', NBJ, NRHS_B, NCB, ALPHA,
      &              A(APOSDEB +int(LDAJ-NCB,8)), LDAJ,
      &              W( PTWCB+int(NPIV,8) ), LIELL,
-     &              ONE, RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB),LRHSCOMP)
+     &              ONE, RHSINTR(IPOSINRHSINTR_PANEL,JBDEB),LRHSINTR)
                   ENDIF
               ENDIF
               IF (MTYPE.NE.1) THEN
                 CALL strsm('L','L','T','U',NBJ, NRHS_B, ONE,
      &          A(APOSDEB), 
-     &          LDAJ, RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), LRHSCOMP)
+     &          LDAJ, RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), LRHSINTR)
               ELSE
                 CALL strsm('L','L','T','N',NBJ, NRHS_B, ONE,
      &          A(APOSDEB),
-     &          LDAJ, RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), LRHSCOMP)
+     &          LDAJ, RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), LRHSINTR)
               ENDIF
 #if defined(MUMPS_USE_BLAS2)
             ENDIF
@@ -680,8 +680,8 @@ C
           CALL SMUMPS_SOL_BWD_LR_SU (
      &           INODE, IWHDLR, NPIV, NSLAVES, 
      &           LIELL, W, LWC, NRHS_B, PTWCB,
-     &           RHSCOMP, LRHSCOMP, NRHS,
-     &           IPOSINRHSCOMP, JBDEB, 
+     &           RHSINTR, LRHSINTR, NRHS,
+     &           IPOSINRHSINTR, JBDEB, 
      &           MTYPE, KEEP, KEEP8,
      &           INFO(1), INFO(2) )
           IF (INFO(1).LT.0) THEN
@@ -697,13 +697,13 @@ C
                 CALL sgemv( 'T', NCB, NPIV, ALPHA, A(IST), LIELL,
      &                 W(PTWCB+int(NPIV,8)), 1,
      &                 ONE,
-     &                 RHSCOMP(IPOSINRHSCOMP,JBDEB), 1 )
+     &                 RHSINTR(IPOSINRHSINTR,JBDEB), 1 )
               ELSE
 #endif
                 CALL sgemm('T','N', NPIV, NRHS_B, NCB, ALPHA,
      &                 A(IST),
      &                 LIELL, W(PTWCB+int(NPIV,8)), LIELL, ONE,
-     &                 RHSCOMP(IPOSINRHSCOMP,JBDEB), LRHSCOMP)
+     &                 RHSINTR(IPOSINRHSINTR,JBDEB), LRHSINTR)
 #if defined(MUMPS_USE_BLAS2)
               ENDIF
 #endif
@@ -723,13 +723,13 @@ C
                  CALL sgemv( 'N', NPIV, NCB, ALPHA, A( IST ), NPIV,
      &                W( PTWCB + int(NPIV,8) ),
      &                1, ONE,
-     &                RHSCOMP(IPOSINRHSCOMP,JBDEB), 1 )
+     &                RHSINTR(IPOSINRHSINTR,JBDEB), 1 )
               ELSE
 #endif
                  CALL sgemm( 'N', 'N', NPIV, NRHS_B, NCB, ALPHA,
      &                A(IST),
      &                NPIV, W(PTWCB+int(NPIV,8)), LIELL,
-     &                ONE, RHSCOMP(IPOSINRHSCOMP,JBDEB), LRHSCOMP)
+     &                ONE, RHSINTR(IPOSINRHSINTR,JBDEB), LRHSINTR)
 #if defined(MUMPS_USE_BLAS2)
               END IF
 #endif
@@ -748,17 +748,17 @@ C
               ENDIF
             ENDIF
           END IF 
-          PPIV_COURANT = int(JBDEB-1,8)*int(LRHSCOMP,8)
-     &                 + int(IPOSINRHSCOMP,8)
+          PPIV_COURANT = int(JBDEB-1,8)*int(LRHSINTR,8)
+     &                 + int(IPOSINRHSINTR,8)
           IF (KEEP(459).GT.1 .AND. KEEP(50).NE.0) THEN
           CALL SMUMPS_SOLVE_BWD_PANELS( A, LA, APOS,
      &      NPIV, IW(IPOS+1+LIELL),
-     &      NRHS_B, RHSCOMP(1,1), KEEP8(25), LRHSCOMP, PPIV_COURANT, 
+     &      NRHS_B, RHSINTR(1,1), KEEP8(25), LRHSINTR, PPIV_COURANT, 
      &      MTYPE, KEEP )
           ELSE
           CALL SMUMPS_SOLVE_BWD_TRSOLVE( A, LA, APOS,
      &      NPIV, LDAJ,
-     &      NRHS_B, RHSCOMP(1,1), KEEP8(25), LRHSCOMP, PPIV_COURANT, 
+     &      NRHS_B, RHSINTR(1,1), KEEP8(25), LRHSINTR, PPIV_COURANT, 
      &      MTYPE, KEEP )
           ENDIF
         ENDIF  
@@ -768,7 +768,7 @@ C
       ELSE
         J1 = IPOS + 1
       END IF
-      IPOSINRHSCOMP =  POSINRHSCOMP_BWD(IW(J1)) 
+      IPOSINRHSINTR =  POSINRHSINTR_BWD(IW(J1)) 
   160 CONTINUE
       IF (KEEP(201).GT.0.AND.OOCWRITE_COMPATIBLE_WITH_BLR) THEN
          CALL SMUMPS_FREE_FACTORS_FOR_SOLVE(INODE,PTRFAC,KEEP(28),
@@ -874,8 +874,8 @@ C
      &          LIELL, LIELL - KEEP(253),
      &          IW( POSINDICES ),
      &          W( PTRACB(STEP(INODE)) ), JBDEB, JBFIN,
-     &          RHSCOMP(1, 1), NRHS, LRHSCOMP,
-     &          IPOSINRHSCOMP, NPIV,
+     &          RHSINTR(1, 1), NRHS, LRHSINTR,
+     &          IPOSINRHSINTR, NPIV,
      &          KEEP, PROCDEST, NOEUD, COMM, IERR )
               IF ( IERR .EQ. -1 ) THEN
                 CALL SMUMPS_BACKSLV_RECV_AND_TREAT(
@@ -890,7 +890,7 @@ C
      &          PLEFTW, KEEP, KEEP8, DKEEP,
      &          PTRIST, PTRFAC, IW, LIW, A, LA, W2, MYLEAF_LEFT,
      &          NRHS, MTYPE, 
-     &          RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &          RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &          PRUN_BELOW, TO_PROCESS, SIZE_TO_PROCESS
      &            , FROM_PP
      &            )
@@ -958,7 +958,7 @@ C
      &     PLEFTW, KEEP, KEEP8, DKEEP,
      &     PTRIST, PTRFAC, IW, LIW, A, LA, W2, MYLEAF_LEFT, 
      &     NRHS, MTYPE,
-     &     RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &     RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &     PRUN_BELOW, TO_PROCESS, SIZE_TO_PROCESS
      &     , FROM_PP
      &    )
@@ -990,8 +990,8 @@ C
       REAL A( LA ), W2( KEEP(133) )
       INTEGER NRHS
       INTEGER MYLEAF_LEFT, MTYPE
-      INTEGER LRHSCOMP, POSINRHSCOMP_BWD(N)
-      REAL RHSCOMP(LRHSCOMP,NRHS)
+      INTEGER LRHSINTR, POSINRHSINTR_BWD(N)
+      REAL RHSINTR(LRHSINTR,NRHS)
       LOGICAL, INTENT(IN) :: PRUN_BELOW
       INTEGER SIZE_TO_PROCESS
       LOGICAL TO_PROCESS(SIZE_TO_PROCESS)
@@ -1035,7 +1035,7 @@ C
      &                KEEP, KEEP8, DKEEP,
      &                PTRIST, PTRFAC, IW, LIW, A, LA, W2, MYLEAF_LEFT, 
      &                NRHS, MTYPE, 
-     &                RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &                RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &               PRUN_BELOW, TO_PROCESS, SIZE_TO_PROCESS
      &               , FROM_PP
      &          )
@@ -1055,7 +1055,7 @@ C
      &                KEEP, KEEP8, DKEEP,
      &                PTRIST, PTRFAC, IW, LIW, A, LA, W2, MYLEAF_LEFT, 
      &                NRHS, MTYPE, 
-     &                RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &                RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &                PRUN_BELOW, TO_PROCESS, SIZE_TO_PROCESS
      &               , FROM_PP
      &           )
@@ -1091,8 +1091,8 @@ C
       REAL A( LA ), W2( KEEP(133) )
       INTEGER NRHS
       INTEGER MYLEAF_LEFT, MTYPE
-      INTEGER LRHSCOMP, POSINRHSCOMP_BWD(N)
-      REAL RHSCOMP(LRHSCOMP,NRHS)
+      INTEGER LRHSINTR, POSINRHSINTR_BWD(N)
+      REAL RHSINTR(LRHSINTR,NRHS)
       LOGICAL, INTENT(IN) :: PRUN_BELOW
       INTEGER  SIZE_TO_PROCESS
       LOGICAL TO_PROCESS(SIZE_TO_PROCESS), NO_CHILDREN
@@ -1106,7 +1106,7 @@ C
       INTEGER(8) :: IFR8
       INTEGER I, JJ, IN, PROCDEST, J1, J2, LDA
       INTEGER NSLAVES, NELIM, J, POSINDICES, INODEPOS,
-     &     IPOSINRHSCOMP, IPOSINRHSCOMP_PANEL
+     &     IPOSINRHSINTR, IPOSINRHSINTR_PANEL
       INTEGER JBDEB, JBFIN, NRHS_B, allocok
       INTEGER(8) :: P_UPDATE, P_SOL_MAS         
       INTEGER :: IWHDLR, MTYPE_SLAVE, LDA_SLAVE 
@@ -1186,11 +1186,11 @@ C
      &           W(POSWCB + 1), LONG, 
      &           MPI_REAL, COMM, IERR)
               DO JJ=0, LONG-1
-                IPOSINRHSCOMP = abs( POSINRHSCOMP_BWD( IWCB(
+                IPOSINRHSINTR = abs( POSINRHSINTR_BWD( IWCB(
      &                                    POSIWCB+1+JJ ) ) )
-                IF ( (IPOSINRHSCOMP.EQ.0) .OR.
-     &            ( IPOSINRHSCOMP.GT.N ) ) CYCLE  
-                RHSCOMP(IPOSINRHSCOMP,K) = W(POSWCB+1+JJ)
+                IF ( (IPOSINRHSINTR.EQ.0) .OR.
+     &            ( IPOSINRHSINTR.GT.N ) ) CYCLE  
+                RHSINTR(IPOSINRHSINTR,K) = W(POSWCB+1+JJ)
               ENDDO
             ENDDO
             POSIWCB = POSIWCB + LONG
@@ -1342,7 +1342,7 @@ C
      &     KEEP, KEEP8, DKEEP,
      &     PTRIST, PTRFAC, IW, LIW, A, LA, W2, MYLEAF_LEFT,
      &     NRHS, MTYPE,
-     &     RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &     RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &     PRUN_BELOW, TO_PROCESS, SIZE_TO_PROCESS
      &      , FROM_PP
      &      )
@@ -1396,7 +1396,7 @@ C
         J1 = IPOS + 1
         J2 = IPOS + NPIV
       ENDIF
-        IPOSINRHSCOMP =  POSINRHSCOMP_BWD(IW(J1)) 
+        IPOSINRHSINTR =  POSINRHSINTR_BWD(IW(J1)) 
         DO K=JBDEB, JBFIN
           CALL MPI_UNPACK( BUFR, LBUFR_BYTES, POSITION,
      &                     W2, NPIV, MPI_REAL,
@@ -1406,13 +1406,13 @@ C
      &         (IW(PTRIST(STEP(INODE))+XXS).EQ.C_FINI+NSLAVES) 
      &       ) THEN
           DO JJ = J1,J2   
-            RHSCOMP(IPOSINRHSCOMP+JJ-J1,K) = W2(I)
+            RHSINTR(IPOSINRHSINTR+JJ-J1,K) = W2(I)
             I = I+1
           ENDDO
          ELSE
           DO JJ = J1,J2   
-            RHSCOMP(IPOSINRHSCOMP+JJ-J1,K) = 
-     &      RHSCOMP(IPOSINRHSCOMP+JJ-J1,K) + W2(I)
+            RHSINTR(IPOSINRHSINTR+JJ-J1,K) = 
+     &      RHSINTR(IPOSINRHSINTR+JJ-J1,K) + W2(I)
             I = I+1
           ENDDO
          ENDIF
@@ -1478,7 +1478,7 @@ C
            POSINDICES = IPOS + 1
         END IF
         PTWCB = PTRACB(STEP( INODE ))
-        IPOSINRHSCOMP =  POSINRHSCOMP_BWD(IW(J1)) 
+        IPOSINRHSINTR =  POSINRHSINTR_BWD(IW(J1)) 
         IFR8 = PTRACB(STEP( INODE ))
       IFR8   = PTWCB + int(NPIV - 1,8)
         IF ( MTYPE .EQ. 1 .AND. KEEP(50).EQ.0 ) THEN
@@ -1489,9 +1489,9 @@ C
           J2 = IPOS + LIELL
         END IF
         CALL SMUMPS_SOL_BWD_GTHR( JBDEB, JBFIN, J1, J2,
-     &       RHSCOMP, NRHS, LRHSCOMP,
+     &       RHSINTR, NRHS, LRHSINTR,
      &       W(PTWCB), LIELL, NPIV+1,
-     &       IW, LIW, KEEP, N, POSINRHSCOMP_BWD )
+     &       IW, LIW, KEEP, N, POSINRHSINTR_BWD )
           IFR8 = IFR8 + int(J2-KEEP(253)-J1+1,8)
       IF ( KEEP(201).EQ.1 .AND. OOCWRITE_COMPATIBLE_WITH_BLR .AND.
      &    (( NELIM .GT. 0 ).OR. (MTYPE.NE.1 )))  THEN
@@ -1536,7 +1536,7 @@ C
             LDAJ    = NROW_L-BEG_PANEL+1 
             APOSDEB = APOSDEB - int(NBJ,8)*int(LDAJ,8)
             PTWCB   = PTRACB(STEP(INODE))
-            IPOSINRHSCOMP_PANEL = IPOSINRHSCOMP + BEG_PANEL - 1
+            IPOSINRHSINTR_PANEL = IPOSINRHSINTR + BEG_PANEL - 1
             NCB_PANEL   = LDAJ - NBJ
             NCB     = NROW_L - NPIV
             IF (KEEP(50).NE.1 .AND.MUST_BE_PERMUTED) THEN
@@ -1555,24 +1555,24 @@ C
                   IF (NCB_PANEL - NCB.NE. 0) THEN
                     CALL sgemv( 'T', NCB_PANEL-NCB, NBJ, ALPHA, 
      &              A( APOSDEB + int(NBJ,8) ), LDAJ,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL+NBJ,JBDEB),
+     &              RHSINTR(IPOSINRHSINTR_PANEL+NBJ,JBDEB),
      &              1, ONE,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), 1 )
+     &              RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), 1 )
                   ENDIF
                   IF (NCB .NE. 0) THEN
                     CALL sgemv( 'T', NCB, NBJ, ALPHA,
      &              A( APOSDEB + int(LDAJ-NCB,8) ), LDAJ,
      &              W( PTWCB  + int(NPIV,8) ),
      &              1, ONE,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), 1 )
+     &              RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), 1 )
                   ENDIF
               ENDIF
               IF (MTYPE.NE.1) THEN
                 CALL strsv('L','T','U', NBJ, A(APOSDEB), LDAJ,
-     &            RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), 1)
+     &            RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), 1)
               ELSE
                 CALL strsv('L','T','N', NBJ, A(APOSDEB), LDAJ,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), 1)
+     &              RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), 1)
               ENDIF
             ELSE
 #endif
@@ -1581,24 +1581,24 @@ C
                   CALL sgemm( 'T', 'N', NBJ, NRHS_B,
      &                                         NCB_PANEL-NCB, ALPHA,
      &              A(APOSDEB +int(NBJ,8)), LDAJ,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL+NBJ,JBDEB), LRHSCOMP,
-     &              ONE, RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), LRHSCOMP)
+     &              RHSINTR(IPOSINRHSINTR_PANEL+NBJ,JBDEB), LRHSINTR,
+     &              ONE, RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), LRHSINTR)
                   ENDIF
                   IF (NCB .NE. 0) THEN
                   CALL sgemm( 'T', 'N', NBJ, NRHS_B, NCB, ALPHA,
      &              A(APOSDEB +int(LDAJ-NCB,8)), LDAJ,
      &              W( PTWCB+int(NPIV,8) ), LIELL,
-     &              ONE, RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB),LRHSCOMP)
+     &              ONE, RHSINTR(IPOSINRHSINTR_PANEL,JBDEB),LRHSINTR)
                   ENDIF
               ENDIF
               IF (MTYPE.NE.1) THEN
                 CALL strsm('L','L','T','U',NBJ, NRHS_B, ONE,
      &          A(APOSDEB), 
-     &          LDAJ, RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), LRHSCOMP)
+     &          LDAJ, RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), LRHSINTR)
               ELSE
                 CALL strsm('L','L','T','N',NBJ, NRHS_B, ONE,
      &          A(APOSDEB),
-     &          LDAJ, RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), LRHSCOMP)
+     &          LDAJ, RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), LRHSINTR)
               ENDIF
 #if defined(MUMPS_USE_BLAS2)
             ENDIF
@@ -1613,8 +1613,8 @@ C
           CALL SMUMPS_SOL_BWD_LR_SU (
      &           INODE, IWHDLR, NPIV, NSLAVES,
      &           LIELL, W, LWC, NRHS_B, PTRACB(STEP(INODE)), 
-     &           RHSCOMP, LRHSCOMP, NRHS,
-     &           IPOSINRHSCOMP, JBDEB, 
+     &           RHSINTR, LRHSINTR, NRHS,
+     &           IPOSINRHSINTR, JBDEB, 
      &           MTYPE, KEEP, KEEP8,
      &           INFO(1), INFO(2) )
         ELSE
@@ -1634,27 +1634,27 @@ C
                  CALL sgemv( 'N', NPIV, NELIM, ALPHA, A( IST ), NPIV,
      &                 W( NPIV + PTRACB(STEP(INODE)) ),
      &                 1, ONE,
-     &                 RHSCOMP(IPOSINRHSCOMP,JBDEB), 1 )
+     &                 RHSINTR(IPOSINRHSINTR,JBDEB), 1 )
               ELSE
 #endif
                  CALL sgemm( 'N', 'N', NPIV, NRHS_B, NELIM, ALPHA,
      &                A(IST), NPIV, W(NPIV+PTRACB(STEP(INODE))), LIELL,
-     &                ONE, RHSCOMP(IPOSINRHSCOMP,JBDEB), LRHSCOMP)
+     &                ONE, RHSINTR(IPOSINRHSINTR,JBDEB), LRHSINTR)
 #if defined(MUMPS_USE_BLAS2)
               END IF
 #endif
           ENDIF 
-          PPIV_COURANT = int(JBDEB-1,8)*int(LRHSCOMP,8)
-     &                 + int(IPOSINRHSCOMP,8)
+          PPIV_COURANT = int(JBDEB-1,8)*int(LRHSINTR,8)
+     &                 + int(IPOSINRHSINTR,8)
           IF (KEEP(459).GT.1 .AND. KEEP(50).NE.0) THEN
           CALL SMUMPS_SOLVE_BWD_PANELS( A, LA, APOS,
      &      NPIV, IW(IPOS+1+LIELL),
-     &      NRHS_B, RHSCOMP(1,1), KEEP8(25), LRHSCOMP, PPIV_COURANT, 
+     &      NRHS_B, RHSINTR(1,1), KEEP8(25), LRHSINTR, PPIV_COURANT, 
      &      MTYPE, KEEP )
           ELSE
           CALL SMUMPS_SOLVE_BWD_TRSOLVE( A, LA, APOS,
      &      NPIV, LDA,
-     &      NRHS_B, RHSCOMP(1,1), KEEP8(25), LRHSCOMP, PPIV_COURANT, 
+     &      NRHS_B, RHSINTR(1,1), KEEP8(25), LRHSINTR, PPIV_COURANT, 
      &      MTYPE, KEEP )
           ENDIF
        ENDIF
@@ -1669,7 +1669,7 @@ C
            ENDIF
           ENDIF
           IPOS =   PTRIST(STEP(INODE)) +  KEEP(IXSZ) + 6 + NSLAVES
-          IPOSINRHSCOMP     = POSINRHSCOMP_BWD(IW(IPOS))
+          IPOSINRHSINTR     = POSINRHSINTR_BWD(IW(IPOS))
           IN = INODE
   170     IN = FILS(IN)
           IF (IN .GT. 0) GOTO 170
@@ -1730,8 +1730,8 @@ C
      &          LIELL, LIELL - KEEP(253),
      &          IW( POSINDICES ),
      &          W( PTRACB(STEP(INODE)) ), JBDEB, JBFIN,
-     &          RHSCOMP(1, 1), NRHS, LRHSCOMP,
-     &          IPOSINRHSCOMP, NPIV,
+     &          RHSINTR(1, 1), NRHS, LRHSINTR,
+     &          IPOSINRHSINTR, NPIV,
      &          KEEP, PROCDEST, NOEUD, COMM, IERR )
               IF ( IERR .EQ. -1 ) THEN
                 CALL SMUMPS_BACKSLV_RECV_AND_TREAT(
@@ -1746,7 +1746,7 @@ C
      &          PLEFTW, KEEP, KEEP8, DKEEP,
      &          PTRIST, PTRFAC, IW, LIW, A, LA, W2, MYLEAF_LEFT,
      &          NRHS, MTYPE, 
-     &          RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &          RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &          PRUN_BELOW, TO_PROCESS, SIZE_TO_PROCESS
      &            , FROM_PP
      &            )
diff -pruN 5.6.2-2.1/src/ssol_c.F 5.7.1-1/src/ssol_c.F
--- 5.6.2-2.1/src/ssol_c.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/ssol_c.F	2024-05-02 10:15:25.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -18,11 +18,16 @@ C
      & COMM_NODES, MYID, MYID_NODES, BUFR, LBUFR, LBUFR_BYTES,
      & ISTEP_TO_INIV2, TAB_POS_IN_PERE, IBEG_ROOT_DEF, IEND_ROOT_DEF,
      & IROOT_DEF_RHS_COL1, RHS_ROOT, LRHS_ROOT, SIZE_ROOT, MASTER_ROOT,
-     & RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD, POSINRHSCOMP_BWD,
+     & RHSINTR, LRHSINTR, POSINRHSINTR_FWD, POSINRHSINTR_BWD,
+     &           Lnodes_FWD, Lnodes_BWD,
+     &           nodes_FWD, nodes_BWD,
      & NZ_RHS, NBCOL_INBLOC, NRHS_ORIG, JBEG_RHS, Step2node, LStep2node,
      & IRHS_SPARSE, IRHS_PTR, SIZE_PERM_RHS, PERM_RHS,
-     & SIZE_UNS_PERM_INV, UNS_PERM_INV, NB_FS_IN_RHSCOMP_F,
-     & NB_FS_IN_RHSCOMP_TOT, DO_NBSPARSE , RHS_BOUNDS, LRHS_BOUNDS
+     & SIZE_UNS_PERM_INV, UNS_PERM_INV, NB_FS_IN_RHSINTR_F,
+     & NB_FS_IN_RHSINTR_TOT, DO_NBSPARSE , RHS_BOUNDS, LRHS_BOUNDS
+#if defined(STAT_ES_SOLVE)
+     & , IPTR_WORKING, SIZE_IPTR_WORKING, WORKING, SIZE_WORKING
+#endif
      &  ,IPOOL_B_L0_OMP, LPOOL_B_L0_OMP, IPOOL_A_L0_OMP, LPOOL_A_L0_OMP,
      &  L_VIRT_L0_OMP, VIRT_L0_OMP, L_PHYS_L0_OMP, PHYS_L0_OMP,
      &  PERM_L0_OMP, PTR_LEAFS_L0_OMP, L0_OMP_MAPPING, LL0_OMP_MAPPING,
@@ -51,22 +56,26 @@ C
       INTEGER(8) ::  PTRFAC(KEEP(28))
       INTEGER    ::  LIWK_PTRACB
       INTEGER(8) ::  PTRACB(LIWK_PTRACB)
-      INTEGER NRHS, LRHSCOMP, NB_FS_IN_RHSCOMP_F, NB_FS_IN_RHSCOMP_TOT
+      INTEGER NRHS, LRHSINTR, NB_FS_IN_RHSINTR_F, NB_FS_IN_RHSINTR_TOT
       REAL    A(LA), W(LWC), 
      &        W2(KEEP(133))
-      REAL ::  RHSCOMP(LRHSCOMP,NRHS)
+      REAL ::  RHSINTR(LRHSINTR,NRHS)
       INTEGER SLAVEF, COMM_NODES, MYID, MYID_NODES
-      INTEGER PROCNODE_STEPS(KEEP(28)), POSINRHSCOMP_FWD(N), 
-     &        POSINRHSCOMP_BWD(N)
+      INTEGER PROCNODE_STEPS(KEEP(28)), POSINRHSINTR_FWD(N), 
+     &        POSINRHSINTR_BWD(N)
       INTEGER LBUFR, LBUFR_BYTES
       INTEGER BUFR(LBUFR)
       INTEGER ISTEP_TO_INIV2(KEEP(71)), 
      &        TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
       INTEGER IBEG_ROOT_DEF, IEND_ROOT_DEF, IROOT_DEF_RHS_COL1
+      INTEGER NRHS_LOC
       INTEGER SIZE_ROOT, MASTER_ROOT
       INTEGER(8) :: LRHS_ROOT
       REAL RHS_ROOT(LRHS_ROOT)
       LOGICAL, intent(in) :: FROM_PP 
+      INTEGER, intent(in) :: Lnodes_FWD, Lnodes_BWD
+      INTEGER, intent(in) :: nodes_FWD(max(1,Lnodes_FWD)), 
+     &                       nodes_BWD(max(1,Lnodes_BWD))
       INTEGER, intent(in)      :: NZ_RHS, NBCOL_INBLOC, NRHS_ORIG
       INTEGER, intent(in)      :: SIZE_UNS_PERM_INV 
       INTEGER, intent(in)      :: SIZE_PERM_RHS 
@@ -80,6 +89,11 @@ C
       LOGICAL, intent(in)  :: DO_NBSPARSE  
       INTEGER, intent(in)     :: LRHS_BOUNDS
       INTEGER, intent(inout)  :: RHS_BOUNDS (LRHS_BOUNDS) 
+#if defined(STAT_ES_SOLVE)
+       INTEGER, INTENT(IN) :: SIZE_WORKING, SIZE_IPTR_WORKING,
+     &                        IPTR_WORKING(SIZE_IPTR_WORKING),
+     &                        WORKING(SIZE_WORKING)
+#endif
       INTEGER, INTENT (IN) :: LPOOL_B_L0_OMP
       INTEGER, INTENT (IN) :: IPOOL_B_L0_OMP( LPOOL_B_L0_OMP )
       INTEGER, INTENT (IN) :: LPOOL_A_L0_OMP
@@ -103,6 +117,7 @@ C
       INTEGER NSTK_S,IPOOL,IPANEL_POS,PTRICB
       INTEGER MTYPE_LOC
       INTEGER MODE_RHS_BOUNDS 
+      INTEGER IPT_RHS_ROOT_LOC
       INTEGER IERR
       INTEGER(8) :: IAPOS
       INTEGER       IOLDPS,
@@ -116,26 +131,28 @@ C
       LOGICAL I_WORKED_ON_ROOT, SPECIAL_ROOT_REACHED
       INTEGER IROOT
       LOGICAL DOROOT_FWD_OOC, DOROOT_BWD_PANEL
-      LOGICAL SWITCH_OFF_ES
       LOGICAL DUMMY_BOOL
       INTEGER :: IDUMMY
       INTEGER :: NBROOT_UNDER_L0
       REAL, PARAMETER :: ZERO = 0.0E0
       INCLUDE 'mumps_headers.h'
-      INTEGER, DIMENSION(:), ALLOCATABLE ::  nodes_RHS
-      INTEGER nb_nodes_RHS
+      INTEGER, DIMENSION(:), POINTER             ::  nodes_BWD_PTR
+      INTEGER, DIMENSION(:), ALLOCATABLE, TARGET :: Pruned_Roots_FWD
+      INTEGER, DIMENSION(:), ALLOCATABLE, TARGET :: Pruned_Roots_NS
+      INTEGER  :: Lnodes_BWD_PTR, LPruned_Roots_NS
+      INTEGER :: Lnodes_BWD_ROOTS
       INTEGER nb_prun_leaves
       INTEGER, DIMENSION(:), ALLOCATABLE :: Pruned_Leaves
       INTEGER, DIMENSION(:), ALLOCATABLE ::  Pruned_List
       INTEGER  nb_prun_nodes
-      INTEGER nb_prun_roots, JAM1
+      INTEGER INODE_PRINC, nb_prun_roots
       INTEGER, DIMENSION(:), ALLOCATABLE ::  Pruned_SONS, Pruned_Roots
       INTEGER                            :: SIZE_TO_PROCESS
       LOGICAL, DIMENSION(:), ALLOCATABLE :: TO_PROCESS
-      INTEGER ISTEP, INODE_PRINC
+      INTEGER ISTEP
       INTEGER :: INODE, ICHILD
-      LOGICAL AM1, DO_PRUN
-      LOGICAL Exploit_Sparsity
+      LOGICAL AM1, DO_PRUN_FWD, DO_PRUN_BWD
+      LOGICAL Exploit_Sparsity_FWD, Exploit_Sparsity_BWD
       LOGICAL DO_NBSPARSE_BWD, PRUN_BELOW_BWD
       INTEGER :: OOC_FCT_TYPE_TMP
       INTEGER :: MUMPS_OOC_GET_FCT_TYPE
@@ -179,7 +196,6 @@ C
       DOFORWARD = .TRUE.
       DOBACKWARD= .TRUE.
       SPECIAL_ROOT_REACHED = .TRUE.
-      SWITCH_OFF_ES    = .FALSE.
       IF ( KEEP(111).NE.0 .OR. KEEP(252).NE.0 ) THEN
         DOFORWARD = .FALSE.
       ENDIF
@@ -202,23 +218,28 @@ C
      &                     .AND. KEEP(201).EQ.1
       DOROOT_FWD_OOC = DOROOT .AND. .NOT.DOROOT_BWD_PANEL
       AM1              = (KEEP(237) .NE. 0)
-      Exploit_Sparsity = (KEEP(235) .NE. 0) .AND. (.NOT. AM1)
-      DO_PRUN          = (Exploit_Sparsity.OR.AM1)
+      Exploit_Sparsity_FWD  = (KEEP(235) .NE. 0) .AND. (.NOT. AM1)
+      Exploit_Sparsity_BWD  = (KEEP(212) .NE. 0) .AND. (.NOT. AM1)
+      Lnodes_BWD_ROOTS = NA(2)
+      DO_PRUN_FWD          = (Exploit_Sparsity_FWD.OR.AM1)
+      DO_PRUN_BWD          = (Exploit_Sparsity_BWD.OR.AM1)
       IF (FROM_PP) THEN
-        Exploit_Sparsity = .FALSE.
-        DO_PRUN          = .FALSE.
+        Exploit_Sparsity_FWD = .FALSE.
+        DO_PRUN_FWD          = .FALSE.
+        Exploit_Sparsity_BWD = .FALSE.
+        DO_PRUN_BWD          = .FALSE.
            IF ( AM1 ) THEN
           WRITE(*,*) "Internal error 2 in SMUMPS_SOL_C"
           CALL MUMPS_ABORT()
         ENDIF
       ENDIF
-      DO_L0OMP_FWD= ( (KEEP(401).GT.0).AND.(KEEP(400).GT.0)
+      DO_L0OMP_FWD= ( (KEEP(401).EQ.1).AND.(KEEP(400).GT.0)
      &             .AND.DOFORWARD )
       DO_L0OMP_FWD = DO_L0OMP_FWD .AND. KEEP(201).EQ.0
-      DO_L0OMP_BWD = ( (KEEP(401).GT.0).AND.(KEEP(400).GT.0)
+      DO_L0OMP_BWD = ( (KEEP(401).EQ.1).AND.(KEEP(400).GT.0)
      &              .AND.DOBACKWARD )
       DO_L0OMP_BWD = DO_L0OMP_BWD .AND. KEEP(201).EQ.0
-      IF ( DO_PRUN ) THEN
+      IF ( DO_PRUN_FWD.OR.DO_PRUN_BWD ) THEN
          ALLOCATE (Pruned_SONS(KEEP(28)), stat=I)
          IF(I.GT.0) THEN
                INFO(1)=-13
@@ -227,7 +248,7 @@ C
          CALL MUMPS_PROPINFO(ICNTL, INFO, COMM_NODES, MYID )
          IF(INFO(1).LT.0) GOTO 500
       ENDIF
-      IF ( DO_PRUN 
+      IF ( DO_PRUN_FWD.OR.DO_PRUN_BWD
      &     .OR. DO_L0OMP_BWD
      &   ) THEN
          SIZE_TO_PROCESS = KEEP(28)
@@ -241,84 +262,12 @@ C
       END IF
       CALL MUMPS_PROPINFO(ICNTL, INFO, COMM_NODES, MYID )
       IF(INFO(1).LT.0) GOTO 500
-      IF ( DOFORWARD .AND. DO_PRUN ) THEN
-         nb_prun_nodes = 0
-         nb_prun_roots = 0
-         Pruned_SONS(:) = -1
-         IF ( Exploit_Sparsity ) THEN
-            nb_nodes_RHS = 0
-            DO I = 1, NZ_RHS
-               ISTEP       = abs( STEP(IRHS_SPARSE(I)) )
-               INODE_PRINC = Step2node( ISTEP )
-               IF ( Pruned_SONS(ISTEP) .eq. -1) THEN
-                  nb_nodes_RHS = nb_nodes_RHS +1
-                  Pruned_SONS(ISTEP) = 0 
-               ENDIF
-            ENDDO
-            ALLOCATE(nodes_RHS(nb_nodes_RHS), STAT = allocok)
-            IF(allocok.GT.0) THEN
-              INFO(1)=-13
-              INFO(2)=nb_nodes_RHS
-            END IF
-            CALL MUMPS_PROPINFO(ICNTL, INFO, COMM_NODES, MYID )
-            IF(INFO(1).LT.0) GOTO 500
-            nb_nodes_RHS = 0
-            Pruned_SONS = -1
-            DO I = 1, NZ_RHS
-               ISTEP       = abs( STEP(IRHS_SPARSE(I)) )
-               INODE_PRINC = Step2node( ISTEP )
-               IF ( Pruned_SONS(ISTEP) .eq. -1) THEN
-                  nb_nodes_RHS = nb_nodes_RHS +1
-                  nodes_RHS(nb_nodes_RHS)  = INODE_PRINC
-                  Pruned_SONS(ISTEP) = 0 
-               ENDIF
-            ENDDO
-         ELSE IF ( AM1 ) THEN  
-            nb_nodes_RHS = 0
-            DO I = 1, NBCOL_INBLOC
-              IF ( (IRHS_PTR(I+1)-IRHS_PTR(I)).EQ.0) CYCLE
-              IF ( (KEEP(242) .NE. 0 ).OR. (KEEP(243).NE.0) ) THEN
-                   JAM1 = PERM_RHS(JBEG_RHS+I-1)
-              ELSE
-                   JAM1 = JBEG_RHS+I-1
-              ENDIF       
-              ISTEP = abs(STEP(JAM1))
-              INODE_PRINC = Step2node(ISTEP)
-              IF ( Pruned_SONS(ISTEP) .eq. -1) THEN
-                 nb_nodes_RHS = nb_nodes_RHS +1
-                 Pruned_SONS(ISTEP) = 0                 
-              ENDIF
-            ENDDO
-            ALLOCATE(nodes_RHS(nb_nodes_RHS), STAT = allocok)
-            IF(allocok.GT.0) THEN
-               INFO(1)=-13
-               INFO(2)=nb_nodes_RHS
-            END IF
-            CALL MUMPS_PROPINFO(ICNTL, INFO, COMM_NODES, MYID )
-            IF(INFO(1).LT.0) GOTO 500
-            nb_nodes_RHS = 0
-            Pruned_SONS = -1
-            DO I = 1, NBCOL_INBLOC
-              IF ( (IRHS_PTR(I+1)-IRHS_PTR(I)).EQ.0) CYCLE
-              IF ( (KEEP(242) .NE. 0 ).OR. (KEEP(243).NE.0) ) THEN
-                   JAM1 = PERM_RHS(JBEG_RHS+I-1)
-              ELSE
-                   JAM1 = JBEG_RHS+I-1
-              ENDIF
-              ISTEP = abs(STEP(JAM1))
-              INODE_PRINC = Step2node(ISTEP)
-              IF ( Pruned_SONS(ISTEP) .eq. -1) THEN
-                 nb_nodes_RHS = nb_nodes_RHS +1
-                 nodes_RHS(nb_nodes_RHS)  = INODE_PRINC
-                 Pruned_SONS(ISTEP) = 0
-              ENDIF
-            ENDDO            
-         ENDIF                  
+      IF ( DOFORWARD .AND. DO_PRUN_FWD ) THEN
          CALL SMUMPS_CHAIN_PRUN_NODES( 
      &        .FALSE.,
      &        DAD, KEEP(28),
      &        STEP, N,
-     &        nodes_RHS, nb_nodes_RHS,
+     &        nodes_FWD, Lnodes_FWD,
      &        Pruned_SONS, TO_PROCESS,
      &        nb_prun_nodes, nb_prun_roots,
      &        nb_prun_leaves )  
@@ -347,11 +296,10 @@ C
      &        .TRUE.,
      &        DAD, KEEP(28),
      &        STEP, N,
-     &        nodes_RHS, nb_nodes_RHS,
+     &        nodes_FWD, Lnodes_FWD,
      &        Pruned_SONS, TO_PROCESS,
      &        nb_prun_nodes, nb_prun_roots, nb_prun_leaves,
      &        Pruned_List, Pruned_Roots, Pruned_Leaves )
-         IF(allocated(nodes_RHS)) DEALLOCATE(nodes_RHS)
          CALL SMUMPS_OOC_SET_STATES_ES(N,
      &          KEEP(201), Pruned_List, nb_prun_nodes,
      &          STEP)
@@ -365,11 +313,15 @@ C
      &        MYID_NODES, N, KEEP(28), KEEP(201), KEEP(485), 
      &        KEEP8(31)+KEEP8(64), 
      &        STEP, Pruned_List, nb_prun_nodes, OOC_FCT_TYPE_TMP
+#if defined(STAT_ES_SOLVE)
+     &        , NRHS, COMM_NODES, IW, LIW, PTRIST,KEEP(IXSZ),0,
+     &        KEEP(50), KEEP(38)
+#endif
      &   )
          IF (DO_NBSPARSE) THEN
            nb_sparse = max(1,KEEP(497))
            MODE_RHS_BOUNDS = 0 
-           IF (Exploit_Sparsity) MODE_RHS_BOUNDS = 2
+           IF (Exploit_Sparsity_FWD) MODE_RHS_BOUNDS = 2
            CALL SMUMPS_INITIALIZE_RHS_BOUNDS(
      &      STEP, N,
      &      IRHS_PTR, NBCOL_INBLOC, IRHS_SPARSE, NZ_RHS,
@@ -383,6 +335,10 @@ C
      &      STEP, N, Pruned_SONS,
      &      DAD, RHS_BOUNDS, KEEP(28),
      &      MYID_NODES, COMM_NODES, KEEP(485),
+#if defined(STAT_ES_SOLVE)
+     &      KEEP(46), 
+     &      IPTR_WORKING, SIZE_IPTR_WORKING, WORKING, SIZE_WORKING,
+#endif
      &      IW, LIW, PTRIST,KEEP(IXSZ),OOC_FCT_TYPE_TMP,0,
      &      KEEP(50), KEEP(38))
          END IF
@@ -416,7 +372,7 @@ C
 #if defined(V_T)
         CALL VTBEGIN(forw_soln,ierr)
 #endif
-        IF ( .NOT. DO_PRUN ) THEN
+        IF ( .NOT. DO_PRUN_FWD ) THEN
           CALL MUMPS_INIT_NROOT_DIST(N, NBROOT, MYROOT, MYID_NODES,
      &           SLAVEF, NA, LNA, KEEP, STEP, PROCNODE_STEPS)
           DO ISTEP =1, KEEP(28)
@@ -427,12 +383,20 @@ C
      &         nb_prun_roots, Pruned_Roots,
      &         MYROOT, MYID_NODES, SLAVEF, KEEP, STEP,
      &         PROCNODE_STEPS )
-          IF (AM1) THEN 
+          IF ((Exploit_Sparsity_FWD).AND.(nb_prun_roots.NE.NA(2))) THEN
+             Lnodes_BWD_ROOTS = nb_prun_roots
+            ALLOCATE(Pruned_Roots_FWD(Lnodes_BWD_ROOTS), STAT=allocok)
+            IF(allocok.GT.0) THEN
+              WRITE(*,*)'Problem with allocation of nodes_FWD'
+              INFO(1) = -13
+              INFO(2) = Lnodes_BWD_ROOTS
+              CALL MUMPS_ABORT()
+            END IF
+            Pruned_Roots_FWD(1:Lnodes_BWD_ROOTS)=
+     &                        Pruned_Roots(1:Lnodes_BWD_ROOTS)
             DEALLOCATE(Pruned_Roots)
-          END IF
-          IF ((Exploit_Sparsity).AND.(nb_prun_roots.EQ.NA(2))) THEN
+          ELSE
             DEALLOCATE(Pruned_Roots)
-            SWITCH_OFF_ES = .TRUE.   
           ENDIF
           DO ISTEP = 1, KEEP(28)
             IW1(NSTK_S+ISTEP-1) = Pruned_SONS(ISTEP)
@@ -441,7 +405,7 @@ C
         IF ( DO_L0OMP_FWD ) THEN
           KEEP(405)=1
           CALL SMUMPS_SOL_L0OMP_R( N, MTYPE_LOC, NRHS, LIW, IW,
-     &    IW1(PTRICB), RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD,
+     &    IW1(PTRICB), RHSINTR, LRHSINTR, POSINRHSINTR_FWD,
      &    STEP, FRERE, DAD, FILS, IW1(NSTK_S), 
      &    PTRIST, PTRFAC, INFO,
      &    KEEP, KEEP8, DKEEP, PROCNODE_STEPS, SLAVEF,
@@ -458,7 +422,7 @@ C
      &    PERM_L0_OMP, PTR_LEAFS_L0_OMP,
      &    L0_OMP_MAPPING, LL0_OMP_MAPPING,
      &    L0_OMP_FACTORS, LL0_OMP_FACTORS,
-     &    DO_PRUN, TO_PROCESS
+     &    DO_PRUN_FWD, TO_PROCESS
      &    )
           CALL MUMPS_STOP_ON_USER_REQUEST( KEEP, KEEP8, ICNTL,
      &                                    INFO, MYID )
@@ -469,7 +433,7 @@ C
           MYROOT = MYROOT - NBROOT_UNDER_L0
         ENDIF
         IF ( DO_L0OMP_FWD ) THEN
-          IF ( DO_PRUN ) THEN
+          IF ( DO_PRUN_FWD ) THEN
             MYLEAF_NOT_PRUNED = IPOOL_A_L0_OMP(LPOOL_A_L0_OMP)
             DO I=1, MYLEAF_NOT_PRUNED
               IF ( TO_PROCESS( STEP( IPOOL_A_L0_OMP(I) ))) THEN
@@ -513,7 +477,7 @@ C
             ENDDO
           ENDIF
         ELSE
-          IF ( DO_PRUN ) THEN
+          IF ( DO_PRUN_FWD ) THEN
             CALL MUMPS_INIT_POOL_DIST_NONA( N, MYLEAF, MYID_NODES,
      &            nb_prun_leaves, Pruned_Leaves, KEEP, KEEP8,
      &            STEP, PROCNODE_STEPS, IW1(IPOOL), LPOOL )
@@ -529,7 +493,7 @@ C
         CALL SMUMPS_SOL_R(N, A(1), LA, IW(1), LIW, W(1),
      &       LWC, NRHS,
      &       IW1(PTRICB), IWCB, LIWW,
-     &       RHSCOMP,LRHSCOMP,POSINRHSCOMP_FWD,
+     &       RHSINTR,LRHSINTR,POSINRHSINTR_FWD,
      &       STEP, FRERE,DAD,FILS,
      &       IW1(NSTK_S),IW1(IPOOL),LPOOL,PTRIST,PTRFAC,
      &       MYLEAF, MYROOT, INFO,
@@ -543,7 +507,7 @@ C
      &          , L0_OMP_MAPPING, LL0_OMP_MAPPING,
      &            L0_OMP_FACTORS, LL0_OMP_FACTORS
      &       )
-        IF (DO_PRUN) THEN
+        IF (DO_PRUN_FWD) THEN
           MYLEAF = -1
         ENDIF
 #if defined(V_T)
@@ -567,9 +531,11 @@ C
          CALL MUMPS_SECFIN(TIME_FWD)
          DKEEP(117)=real(TIME_FWD) + DKEEP(117)
       ENDIF
-      IF (DO_PRUN.AND.SWITCH_OFF_ES) THEN
-         DO_PRUN          = .FALSE.
-         Exploit_Sparsity = .FALSE.
+      IF ( .NOT.( 
+     &       DOBACKWARD.AND.
+     &      (DO_PRUN_BWD.OR.(Lnodes_BWD_ROOTS.NE.NA(2)))
+     &          )
+     &   ) THEN
          IF (.NOT. DO_L0OMP_BWD ) THEN
            IF ( allocated(TO_PROCESS) .AND. SIZE_TO_PROCESS.NE.1 ) THEN
              DEALLOCATE (TO_PROCESS)
@@ -578,58 +544,60 @@ C
            ENDIF
          ENDIF
       ENDIF
-      IF ( DOBACKWARD .AND. DO_PRUN )  THEN
-         nb_prun_leaves = 0
-        IF ( Exploit_Sparsity .AND. (KEEP(111).EQ.0) ) THEN
-          nb_nodes_RHS = nb_prun_roots
-          ALLOCATE(nodes_RHS(nb_nodes_RHS), STAT = allocok)
-          IF(allocok.GT.0) THEN
-            WRITE(*,*)'Problem with allocation of nodes_RHS'
-            INFO(1) = -13
-            INFO(2) = nb_nodes_RHS
-            CALL MUMPS_ABORT()
-          END IF
-          nodes_RHS(1:nb_prun_roots)=Pruned_Roots(1:nb_prun_roots)
-          DEALLOCATE(Pruned_Roots)
-        ELSE
-         nb_nodes_RHS = 0
-         Pruned_SONS(:) = -1 
-         DO II = 1, NZ_RHS
+      IF ( (KEEP(111).NE.0).AND.DOBACKWARD.AND.
+     &     (
+     &      DO_PRUN_BWD
+     &     )
+     &   )   THEN
+        nb_prun_leaves = 0
+        IF ( Lnodes_BWD_ROOTS.NE.NA(2) ) THEN
+          nodes_BWD_PTR => Pruned_Roots_FWD
+          Lnodes_BWD_PTR = Lnodes_BWD_ROOTS
+        ELSE IF ( (Exploit_Sparsity_BWD.AND.KEEP(111).NE.0) 
+     &          ) THEN
+          LPruned_Roots_NS = 0
+          Pruned_SONS(:)   = -1 
+          DO II = 1, NZ_RHS
             I = IRHS_SPARSE(II)
             IF (KEEP(23).NE.0) I = UNS_PERM_INV(I)          
             ISTEP = abs(STEP(I))
             IF ( Pruned_SONS(ISTEP) .eq. -1) THEN
-               nb_nodes_RHS = nb_nodes_RHS +1
+               LPruned_Roots_NS   = LPruned_Roots_NS +1
                Pruned_SONS(ISTEP) = 0
             ENDIF
-         ENDDO
-         ALLOCATE(nodes_RHS(nb_nodes_RHS), STAT = allocok)           
-         IF(allocok.GT.0) THEN
-           WRITE(*,*)'Problem with allocation of nodes_RHS'
+          ENDDO
+          ALLOCATE(Pruned_Roots_NS(LPruned_Roots_NS), STAT = allocok) 
+          IF(allocok.GT.0) THEN
+           WRITE(*,*)'Problem with allocation of nodes_BWD'
            INFO(1) = -13
-           INFO(2) = nb_nodes_RHS
+           INFO(2) = LPruned_Roots_NS
            CALL MUMPS_ABORT()
-         END IF
-         nb_nodes_RHS = 0         
-         Pruned_SONS(:) = -1  
-         DO II = 1, NZ_RHS
+          END IF
+          LPruned_Roots_NS = 0         
+          Pruned_SONS(:) = -1  
+          DO II = 1, NZ_RHS
             I = IRHS_SPARSE(II)
             IF (KEEP(23).NE.0) I = UNS_PERM_INV(I)
             ISTEP = abs(STEP(I))
             INODE_PRINC = Step2node(ISTEP)
             IF ( Pruned_SONS(ISTEP) .eq. -1) THEN
-               nb_nodes_RHS = nb_nodes_RHS +1
-               nodes_RHS(nb_nodes_RHS)  = INODE_PRINC
+               LPruned_Roots_NS = LPruned_Roots_NS +1
+               Pruned_Roots_NS(LPruned_Roots_NS)  = INODE_PRINC
                Pruned_SONS(ISTEP) = 0
             ENDIF
-         ENDDO
+          ENDDO
+          nodes_BWD_PTR => Pruned_Roots_NS
+          Lnodes_BWD_PTR = LPruned_Roots_NS
         ENDIF
-        IF ( Exploit_Sparsity ) THEN
+        IF ( 
+     &       (Exploit_Sparsity_BWD.AND.KEEP(111).NE.0) .OR.
+     &       (Lnodes_BWD_ROOTS.NE.NA(2))
+     &     ) THEN
            CALL SMUMPS_TREE_PRUN_NODES( 
      &     .FALSE.,
      &     DAD, NE_STEPS, FRERE, KEEP(28),
      &     FILS, STEP, N,
-     &     nodes_RHS, nb_nodes_RHS,
+     &     nodes_BWD_PTR, Lnodes_BWD_PTR,
      &     TO_PROCESS,
      &     nb_prun_nodes, nb_prun_roots, nb_prun_leaves
      &     )
@@ -658,27 +626,22 @@ C
      &     .TRUE.,
      &     DAD, NE_STEPS, FRERE, KEEP(28),
      &     FILS, STEP, N,
-     &     nodes_RHS, nb_nodes_RHS,
+     &     nodes_BWD_PTR, Lnodes_BWD_PTR,
      &     TO_PROCESS,
      &     nb_prun_nodes, nb_prun_roots, nb_prun_leaves,
      &     Pruned_List, Pruned_Roots, Pruned_Leaves
      &     )
+           IF(allocated(Pruned_Roots_NS)) DEALLOCATE(Pruned_Roots_NS)
+           IF(allocated(Pruned_Roots_FWD)) DEALLOCATE(Pruned_Roots_FWD)
            CALL SMUMPS_OOC_SET_STATES_ES(N,
      &          KEEP(201), Pruned_List, nb_prun_nodes,
      &          STEP)
-           IF(allocated(nodes_RHS)) DEALLOCATE(nodes_RHS)
            IF (KEEP(201).GT.0) THEN
              OOC_FCT_TYPE_TMP=MUMPS_OOC_GET_FCT_TYPE
      &                    ('B',MTYPE,KEEP(201),KEEP(50))
            ELSE
              OOC_FCT_TYPE_TMP = -5959 
            ENDIF
-           CALL SMUMPS_TREE_PRUN_NODES_STATS(
-     &          MYID_NODES, N, KEEP(28), KEEP(201),
-     &        KEEP8(31)+KEEP8(64), 
-     &          STEP,
-     &          Pruned_List,
-     &          nb_prun_nodes, OOC_FCT_TYPE_TMP)
         ENDIF
       ENDIF
       IF(KEEP(201).EQ.1.AND.DOROOT_BWD_PANEL) THEN
@@ -705,7 +668,7 @@ C
         IF ( KEEP(60) .EQ. 0 .AND. KEEP(252) .EQ. 0 ) THEN
           IF ( root%yes ) THEN
             IF (KEEP(201).GT.0) THEN
-              IF ( (Exploit_Sparsity.AND.(KEEP(111).NE.0)) .and.
+              IF ( (Exploit_Sparsity_FWD.AND.(KEEP(111).NE.0)) .and.
      &            (OOC_STATE_NODE(STEP(KEEP(38))).eq.-6) ) THEN
                   GOTO 1010
               ENDIF
@@ -756,6 +719,49 @@ C
         ENDIF
       ELSE IF ( ( KEEP(20) .NE. 0) .AND. SPECIAL_ROOT_REACHED ) THEN
         IF ( MYID_NODES .eq.  MASTER_ROOT ) THEN
+          IF ( KEEP(60) .eq. 0 ) THEN
+            IF (KEEP(201).GT.0) THEN
+              CALL SMUMPS_SOLVE_GET_OOC_NODE(
+     &              KEEP(20),PTRFAC,KEEP,A,LA,
+     &              STEP,KEEP8,N,DUMMY_BOOL,IERR)
+              IF(IERR.LT.0)THEN
+                INFO(1)=IERR
+                INFO(2)=0
+                WRITE(*,*) '** ERROR after SMUMPS_SOLVE_GET_OOC_NODE', 
+     &          INFO(1)
+                call MUMPS_ABORT()
+              ENDIF
+            END IF
+            NRHS_LOC         = NRHS
+            IPT_RHS_ROOT_LOC = 1
+            IF ( KEEP(111).NE.0 ) THEN
+              RHS_ROOT( 1: NRHS*SIZE_ROOT) = ZERO
+              NRHS_LOC = IEND_ROOT_DEF - IBEG_ROOT_DEF + 1
+              IPT_RHS_ROOT_LOC = IPT_RHS_ROOT_LOC +
+     &                           (IROOT_DEF_RHS_COL1-1)*SIZE_ROOT
+           ENDIF
+           IF (NRHS_LOC .GT. 0) THEN
+              CALL SMUMPS_SEQ_SOLVE_ROOT_SVD_QR(NRHS_LOC,
+     &             SIZE_ROOT,A( PTRFAC(
+     &             IW( PTRIST(STEP(KEEP(20)))+4+KEEP(IXSZ)))),
+     &             root, IBEG_ROOT_DEF, IEND_ROOT_DEF,
+     &             RHS_ROOT( IPT_RHS_ROOT_LOC ),
+     &             KEEP,KEEP8,
+     &             MTYPE,INFO,LWC,W(1), LP)
+        ENDIF
+            IF(KEEP(201).GT.0)THEN
+              CALL SMUMPS_FREE_FACTORS_FOR_SOLVE(KEEP(20),
+     &             PTRFAC,KEEP(28),A,LA,.FALSE.,IERR)
+              IF(IERR.LT.0)THEN
+                 INFO(1)=IERR
+                 INFO(2)=0
+                 WRITE(*,*)
+     &           '** ERROR after SMUMPS_FREE_FACTORS_FOR_SOLVE ', 
+     &           INFO(1)
+                 call MUMPS_ABORT()
+              ENDIF
+            ENDIF
+          ENDIF
         END IF 
       END IF 
       IF (.NOT.FROM_PP) THEN
@@ -773,13 +779,13 @@ C
      &    THEN
           I_WORKED_ON_ROOT = DOROOT
           IF (KEEP(38).gt.0 ) THEN
-             IF ( ( Exploit_Sparsity.AND.(KEEP(111).EQ.0) )
+             IF ( ( Exploit_Sparsity_FWD.AND.(KEEP(111).EQ.0) )
      &            .OR. AM1 ) THEN
                 IF (OOC_STATE_NODE(STEP(KEEP(38))).eq.-6) THEN
                    OOC_STATE_NODE(STEP(KEEP(38)))=-4
                 ENDIF
              ENDIF
-             IF (Exploit_Sparsity.AND.(KEEP(111).NE.0)) THEN
+             IF (Exploit_Sparsity_FWD.AND.(KEEP(111).NE.0)) THEN
                 IF (OOC_STATE_NODE(STEP(KEEP(38))).eq.-6) THEN
                    I_WORKED_ON_ROOT = .FALSE.
                 ENDIF
@@ -791,14 +797,14 @@ C
         ELSE
           DO_NBSPARSE_BWD = DO_NBSPARSE
         ENDIF
-        PRUN_BELOW_BWD = AM1
+        PRUN_BELOW_BWD = DO_PRUN_BWD .AND. KEEP(111).EQ.0
         PRUN_BELOW_BWD = PRUN_BELOW_BWD .OR. DO_L0OMP_BWD
-        IF ( AM1 ) THEN
+        IF ( DO_PRUN_BWD )  THEN
           CALL SMUMPS_CHAIN_PRUN_NODES( 
      &        .FALSE.,
      &        DAD, KEEP(28),
      &        STEP, N,
-     &        nodes_RHS, nb_nodes_RHS,
+     &        nodes_BWD, Lnodes_BWD,
      &        Pruned_SONS, TO_PROCESS,
      &        nb_prun_nodes, nb_prun_roots,
      &        nb_prun_leaves)  
@@ -823,11 +829,11 @@ C
           END IF
           CALL MUMPS_PROPINFO(ICNTL, INFO, COMM_NODES, MYID )
           IF(INFO(1).LT.0) GOTO 500
-          CALL SMUMPS_CHAIN_PRUN_NODES( 
+          CALL SMUMPS_CHAIN_PRUN_NODES(
      &        .TRUE.,
      &        DAD, KEEP(28),
      &        STEP, N,
-     &        nodes_RHS, nb_nodes_RHS,
+     &        nodes_BWD, Lnodes_BWD,
      &        Pruned_SONS, TO_PROCESS,
      &        nb_prun_nodes, nb_prun_roots, nb_prun_leaves,
      &        Pruned_List, Pruned_Roots, Pruned_Leaves )
@@ -843,6 +849,10 @@ C
           CALL SMUMPS_CHAIN_PRUN_NODES_STATS(
      &    MYID_NODES, N, KEEP(28), KEEP(201), KEEP(485), KEEP8(31),
      &    STEP, Pruned_List, nb_prun_nodes, OOC_FCT_TYPE_TMP
+#if defined(STAT_ES_SOLVE)
+     &          , NRHS, COMM_NODES, IW, LIW, PTRIST,KEEP(IXSZ),1,
+     &          KEEP(50), KEEP(38)
+#endif
      &    )
           IF (DO_NBSPARSE_BWD) THEN
             nb_sparse = max(1,KEEP(497))
@@ -859,6 +869,10 @@ C
      &       STEP, N, Pruned_SONS,
      &       DAD, RHS_BOUNDS, KEEP(28),
      &       MYID_NODES, COMM_NODES, KEEP(485),
+#if defined(STAT_ES_SOLVE)
+     &       KEEP(46), 
+     &       IPTR_WORKING, SIZE_IPTR_WORKING, WORKING, SIZE_WORKING,
+#endif     
      &       IW, LIW, PTRIST,KEEP(IXSZ),OOC_FCT_TYPE_TMP,1,
      &       KEEP(50), KEEP(38))
          END IF
@@ -882,17 +896,17 @@ C
         IF ( .NOT.SPECIAL_ROOT_REACHED ) THEN
           RHS_ROOT(1:NRHS*SIZE_ROOT) = ZERO
         ENDIF
-        IF (AM1.AND.(NB_FS_IN_RHSCOMP_F.NE.NB_FS_IN_RHSCOMP_TOT)) THEN
+        IF (AM1.AND.(NB_FS_IN_RHSINTR_F.NE.NB_FS_IN_RHSINTR_TOT)) THEN
          DO I =1, N
-           II = POSINRHSCOMP_BWD(I)
-           IF ((II.GT.0).AND.(II.GT.NB_FS_IN_RHSCOMP_F)) THEN
+           II = POSINRHSINTR_BWD(I)
+           IF ((II.GT.0).AND.(II.GT.NB_FS_IN_RHSINTR_F)) THEN
             DO K=1,NRHS
-             RHSCOMP(II, K) = ZERO
+             RHSINTR(II, K) = ZERO
             ENDDO
            ENDIF
          ENDDO
         ENDIF
-        IF ( .NOT. DO_PRUN ) THEN
+        IF ( .NOT. DO_PRUN_BWD ) THEN
            IF ( .NOT. DO_L0OMP_BWD ) THEN
              IF (DO_L0OMP_FWD) THEN
                MYLEAF = -1
@@ -988,7 +1002,7 @@ C
               IF ( .NOT. MUMPS_IN_OR_ROOT_SSARBR(PROCNODE_STEPS(I),
      &        KEEP(199)) ) THEN
                 IF ( L0_OMP_MAPPING(I) .EQ. 0 ) THEN
-                  IF ( DO_PRUN
+                  IF ( DO_PRUN_BWD
      &                 .OR. DO_L0OMP_BWD 
      &               ) THEN
                     IF ( TO_PROCESS(I) ) THEN
@@ -1007,7 +1021,7 @@ C
       IF(INFO(1).LT.0) GOTO 500
         CALL SMUMPS_SOL_S( N, A, LA, IW, LIW, W(1), LWC,
      &          NRHS,
-     &          RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &          RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &          IW1(PTRICB),PTRACB,IWCB,LIWW, W2,
      &          NE_STEPS,
      &          STEP, FRERE,DAD,FILS,
@@ -1023,7 +1037,7 @@ C
      &          , L0_OMP_MAPPING, LL0_OMP_MAPPING,
      &            L0_OMP_FACTORS, LL0_OMP_FACTORS
      &          )
-        IF ( DO_L0OMP_BWD .AND. DO_PRUN ) THEN
+        IF ( DO_L0OMP_BWD .AND. DO_PRUN_BWD ) THEN
           DO I = 1, L_PHYS_L0_OMP
             IF ( PHYS_L0_OMP( I ) .LT. 0 ) THEN
               PHYS_L0_OMP( I ) = -PHYS_L0_OMP( I )
@@ -1034,10 +1048,10 @@ C
         CALL MUMPS_STOP_ON_USER_REQUEST(KEEP, KEEP8, ICNTL, INFO, MYID)
         IF (DO_L0OMP_BWD .AND. INFO(1) .GE. 0) THEN
           KEEP(31) = 0
-          PRUN_BELOW_BWD = AM1
+          PRUN_BELOW_BWD = DO_PRUN_BWD .AND. KEEP(111).EQ.0
           KEEP(405)=1
           CALL SMUMPS_SOL_L0OMP_S(N, MTYPE_LOC, NRHS, LIW, IW,
-     &      IW1(PTRICB), PTRACB, RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &      IW1(PTRICB), PTRACB, RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &      STEP, FRERE, FILS, NE_STEPS, PTRIST, PTRFAC, INFO,
      &      KEEP, KEEP8, DKEEP, PROCNODE_STEPS, SLAVEF,
      &      COMM_NODES, MYID_NODES, BUFR, LBUFR, LBUFR_BYTES, 
@@ -1070,21 +1084,24 @@ C
       ENDIF
       IF (LDIAG.GT.2 .AND. MP.GT.0) THEN
         IF (DOFORWARD) THEN
-        K = min0(10,size(RHSCOMP,1))
-        IF (LDIAG.EQ.4) K = size(RHSCOMP,1)
+        K = min(10,size(RHSINTR,1))
+        IF (LDIAG.EQ.4) K = size(RHSINTR,1)
         IF ( .NOT. FROM_PP) THEN
           WRITE (MP,99992)
-          IF (size(RHSCOMP,1).GT.0) 
-     &    WRITE (MP,99993) (RHSCOMP(I,1),I=1,K)
-          IF (size(RHSCOMP,1).GT.0.and.NRHS>1) 
-     &              WRITE (MP,99994) (RHSCOMP(I,2),I=1,K)
+          IF (size(RHSINTR,1).GT.0) 
+     &    WRITE (MP,99993) (RHSINTR(I,1),I=1,K)
+          IF (size(RHSINTR,1).GT.0.and.NRHS>1) 
+     &              WRITE (MP,99994) (RHSINTR(I,2),I=1,K)
           ENDIF
         ENDIF
       ENDIF
 500   CONTINUE
       IF ( allocated(TO_PROCESS)) DEALLOCATE (TO_PROCESS)
-      IF (Exploit_Sparsity.OR.AM1.OR.SWITCH_OFF_ES) THEN
-         IF ( allocated(nodes_RHS)) DEALLOCATE (nodes_RHS)
+      IF (DO_PRUN_FWD.OR.DO_PRUN_BWD) THEN
+         IF ( allocated(Pruned_Roots_FWD)) 
+     &        DEALLOCATE (Pruned_Roots_FWD)
+         IF ( allocated(Pruned_Roots_NS)) 
+     &        DEALLOCATE (Pruned_Roots_NS)
          IF ( allocated(Pruned_SONS)) DEALLOCATE (Pruned_SONS)
          IF ( allocated(Pruned_Roots)) DEALLOCATE (Pruned_Roots)
          IF ( allocated(Pruned_List)) DEALLOCATE (Pruned_List)
@@ -1095,20 +1112,81 @@ C
 99994 FORMAT (' RHS (internal, 2 nd  column)'/(1X,1P,5E14.6))
 99992 FORMAT (//' LEAVING SOLVE (SMUMPS_SOL_C) WITH')
       END SUBROUTINE SMUMPS_SOL_C
+      SUBROUTINE SMUMPS_SET_POSTPros (KEEP, ICNTL, NBRHS, MPG, PROKG, 
+     &                               ICNTL10, ICNTL11, POSTPros)
+      IMPLICIT NONE
+      INTEGER, INTENT(IN)  :: KEEP(500), ICNTL(60), NBRHS, MPG
+      LOGICAL, INTENT(IN)  :: PROKG
+      INTEGER, INTENT(OUT) :: ICNTL10, ICNTL11
+      LOGICAL, INTENT(OUT) :: POSTPros
+      POSTPros = .FALSE.
+      IF (ICNTL11.NE.0 .OR. ICNTL10.NE.0) THEN
+        POSTPros = .TRUE.
+        IF (KEEP(111).NE.0) THEN
+            IF (PROKG) WRITE(MPG,'(A,A)')
+     &     ' WARNING: Incompatible features: null space basis',
+     &              ' and Iter. Ref and/or Err. Anal.'
+            POSTPros = .FALSE.
+        ELSE IF ( KEEP(237) .NE.0 ) THEN
+            IF (PROKG) WRITE(MPG,'(A,A)')
+     &     ' WARNING: Incompatible features: AM1',
+     &              ' and Iter. Ref and/or Err. Anal.'
+            POSTPros = .FALSE.
+        ELSE IF ( KEEP(252) .NE.0 ) THEN
+            IF (PROKG) WRITE(MPG,'(A,A)')
+     &     ' WARNING: Incompatible features: Fwd in facto ',
+     &              ' and Iter. Ref and/or Err. Anal.'
+            POSTPros = .FALSE.
+        ELSE IF (KEEP(221).NE.0) THEN
+            IF (PROKG) WRITE(MPG,'(A,A)')
+     &     ' WARNING: Incompatible features: reduced RHS',
+     &     ' and Iter. Ref and/or Err. Anal.'
+            POSTPros = .FALSE.
+        ELSE IF  (NBRHS.GT. 1 .OR. ICNTL(21) .GT. 0) THEN
+            IF (PROKG) WRITE(MPG,'(A,A)')
+     &     ' WARNING:  Incompatible features: nrhs>1 or distrib sol',
+     &     ' and Iter. Ref and/or Err. Anal.'
+            POSTPros = .FALSE.
+        ELSE IF ( KEEP(248) .EQ. -1 ) THEN
+            IF (PROKG) WRITE(MPG,'(A,A)')
+     &     ' WARNING:  Incompatible features: distrib rhs',
+     &     ' and Iter. Ref and/or Err. Anal.'
+            POSTPros = .FALSE.
+        ENDIF  
+        IF (.NOT.POSTPros) THEN
+          ICNTL11 = 0
+          ICNTL10 = 0
+        ENDIF
+      ENDIF
+      IF ((ICNTL(10) .NE. 0) .AND. (ICNTL10 .EQ. 0)) THEN
+          IF (PROKG) WRITE(MPG,'(A)')
+     &  ' WARNING: ICNTL(10) treated as if set to 0 '
+      ENDIF
+      IF ((ICNTL(11) .NE. 0)
+     &      .AND.(ICNTL11 .EQ. 0)) THEN
+          IF (PROKG) WRITE(MPG,'(A)')
+     &  ' WARNING: ICNTL(11) treated as if set to 0 '
+      ENDIF
+      RETURN
+      END SUBROUTINE SMUMPS_SET_POSTPros
       SUBROUTINE SMUMPS_GATHER_SOLUTION( NSLAVES, N, MYID, COMM,
      &           NRHS,
      &           MTYPE, RHS, LRHS, NCOL_RHS, JBEG_RHS, PTRIST,
      &           KEEP,KEEP8, PROCNODE_STEPS, IW, LIW, STEP, BUFFER,
      &           SIZE_BUF, SIZE_BUF_BYTES, CWORK, LCWORK,
+#if defined(USE_OLD_SCALING)
      &           LSCAL, SCALING, LSCALING, 
-     &           RHSCOMP, LRHSCOMP, NCOL_RHSCOMP, 
-     &           POSINRHSCOMP, LPOS_N, PERM_RHS, SIZE_PERM_RHS )
+#else
+     &           LSCAL, SCALING_LOC_BWD, LSCALING_LOC_BWD, 
+#endif
+     &           RHSINTR, LRHSINTR, NCOL_RHSINTR, 
+     &           POSINRHSINTR, LPOS_N, PERM_RHS, SIZE_PERM_RHS )
 !$    USE OMP_LIB
       IMPLICIT NONE
       INCLUDE 'mpif.h'
       INCLUDE 'mumps_tags.h'
       INTEGER NSLAVES, N, MYID, COMM, LIW, MTYPE, NCOL_RHS
-      INTEGER NRHS, LRHS, LCWORK, LPOS_N, NCOL_RHSCOMP
+      INTEGER NRHS, LRHS, LCWORK, LPOS_N, NCOL_RHSINTR
       REAL RHS   (LRHS, NCOL_RHS)
       INTEGER, INTENT(in) :: JBEG_RHS
       INTEGER KEEP(500)
@@ -1118,11 +1196,17 @@ C
       INTEGER IW(LIW), STEP(N)
       INTEGER SIZE_BUF, SIZE_BUF_BYTES
       INTEGER BUFFER(SIZE_BUF)
-      INTEGER LRHSCOMP, POSINRHSCOMP(LPOS_N) 
-      REAL, intent(in) :: RHSCOMP(LRHSCOMP, NCOL_RHSCOMP)
-      LOGICAL, intent(in) :: LSCAL
+      INTEGER LRHSINTR, POSINRHSINTR(LPOS_N) 
+#if defined(USE_OLD_SCALING)
+      REAL, intent(in) :: RHSINTR(LRHSINTR, NCOL_RHSINTR)
       INTEGER, intent(in) :: LSCALING
       REAL, intent(in)    :: SCALING(LSCALING)
+#else
+      REAL, intent(inout) :: RHSINTR(LRHSINTR, NCOL_RHSINTR)
+      INTEGER, intent(in) :: LSCALING_LOC_BWD
+      REAL, intent(in) :: SCALING_LOC_BWD(LSCALING_LOC_BWD)
+#endif
+      LOGICAL, intent(in) :: LSCAL
       INTEGER, INTENT(in) :: SIZE_PERM_RHS
       INTEGER, INTENT(in) :: PERM_RHS(SIZE_PERM_RHS)
       INTEGER I, II, J, J1, ISTEP, MASTER,
@@ -1133,7 +1217,7 @@ C
       PARAMETER(MASTER=0)
       LOGICAL I_AM_SLAVE
       INTEGER RECORD_SIZE_P_1, SIZE1, SIZE2
-      INTEGER POS_BUF, N2SEND, IPOSINRHSCOMP
+      INTEGER POS_BUF, N2SEND, IPOSINRHSINTR
       INTEGER :: JCOL_RHS
       INTEGER :: K242
       LOGICAL :: OMP_FLAG
@@ -1167,7 +1251,7 @@ C
              ENDIF
              IF (OMP_FLAG) THEN
 !$OMP PARALLEL FIRSTPRIVATE(JBEG_RHS,N,K242)
-!$OMP&  PRIVATE(J,IPOSINRHSCOMP,I,JCOL_RHS)
+!$OMP&  PRIVATE(J,IPOSINRHSINTR,I,JCOL_RHS)
                DO J=1, NRHS
                  IF (K242.EQ.0) THEN
                    JCOL_RHS = J+JBEG_RHS-1
@@ -1176,10 +1260,14 @@ C
                  ENDIF
 !$OMP DO SCHEDULE(DYNAMIC,CHUNK)
                  DO I=1, N
-                   IPOSINRHSCOMP = POSINRHSCOMP(I)
-                   IF (IPOSINRHSCOMP.GT.0) THEN 
-                     RHS(I,JCOL_RHS) =
-     &                   RHSCOMP(IPOSINRHSCOMP,J)*SCALING(I)
+                   IPOSINRHSINTR = POSINRHSINTR(I)
+                   IF (IPOSINRHSINTR.GT.0) THEN 
+                     RHS(I,JCOL_RHS) = RHSINTR(IPOSINRHSINTR,J)*
+#if defined(USE_OLD_SCALING)
+     &               SCALING(I)
+#else
+     &               SCALING_LOC_BWD(IPOSINRHSINTR)
+#endif
                    ELSE
                     RHS(I,JCOL_RHS) = ZERO
                   ENDIF
@@ -1195,10 +1283,14 @@ C
                    JCOL_RHS = PERM_RHS(J+JBEG_RHS-1)
                  ENDIF
                  DO I=1, N
-                   IPOSINRHSCOMP = POSINRHSCOMP(I)
-                   IF (IPOSINRHSCOMP.GT.0) THEN 
-                     RHS(I,JCOL_RHS) =
-     &                   RHSCOMP(IPOSINRHSCOMP,J)*SCALING(I)
+                   IPOSINRHSINTR = POSINRHSINTR(I)
+                   IF (IPOSINRHSINTR.GT.0) THEN 
+                     RHS(I,JCOL_RHS) = RHSINTR(IPOSINRHSINTR,J)*
+#if defined(USE_OLD_SCALING)
+     &               SCALING(I)
+#else
+     &               SCALING_LOC_BWD(IPOSINRHSINTR)
+#endif
                    ELSE
                      RHS(I,JCOL_RHS) = ZERO
                    ENDIF
@@ -1221,7 +1313,7 @@ C
              ENDIF
              IF (OMP_FLAG) THEN
 !$OMP PARALLEL FIRSTPRIVATE(JBEG_RHS,N,K242)
-!$OMP&  PRIVATE(IPOSINRHSCOMP,I,JCOL_RHS) IF (OMP_FLAG)
+!$OMP&  PRIVATE(IPOSINRHSINTR,I,JCOL_RHS) IF (OMP_FLAG)
                DO J=1, NRHS
                  IF (K242.EQ.0) THEN
                    JCOL_RHS = J+JBEG_RHS-1
@@ -1230,9 +1322,9 @@ C
                  ENDIF
 !$OMP DO SCHEDULE(DYNAMIC,CHUNK)
                  DO I=1, N
-                   IPOSINRHSCOMP = POSINRHSCOMP(I)
-                   IF (IPOSINRHSCOMP.GT.0) THEN
-                     RHS(I,JCOL_RHS) = RHSCOMP(IPOSINRHSCOMP,J)
+                   IPOSINRHSINTR = POSINRHSINTR(I)
+                   IF (IPOSINRHSINTR.GT.0) THEN
+                     RHS(I,JCOL_RHS) = RHSINTR(IPOSINRHSINTR,J)
                    ELSE
                      RHS(I,JCOL_RHS) = ZERO
                    ENDIF
@@ -1248,9 +1340,9 @@ C
                    JCOL_RHS = PERM_RHS(J+JBEG_RHS-1)
                  ENDIF
                  DO I=1, N
-                   IPOSINRHSCOMP = POSINRHSCOMP(I)
-                   IF (IPOSINRHSCOMP.GT.0) THEN
-                     RHS(I,JCOL_RHS) = RHSCOMP(IPOSINRHSCOMP,J)
+                   IPOSINRHSINTR = POSINRHSINTR(I)
+                   IF (IPOSINRHSINTR.GT.0) THEN
+                     RHS(I,JCOL_RHS) = RHSINTR(IPOSINRHSINTR,J)
                    ELSE
                      RHS(I,JCOL_RHS) = ZERO
                    ENDIF
@@ -1339,15 +1431,20 @@ C
             CALL MPI_UNPACK(BUFFER, SIZE_BUF_BYTES, POS_BUF,
      &                 CWORK, NPIV, MPI_REAL,
      &                 COMM, IERR)
+#if defined(USE_OLD_SCALING)
             IF (LSCAL) THEN
               DO I=1,NPIV
                 RHS(IROWlist(I),JCOL_RHS)=CWORK(I)*SCALING(IROWlist(I))
               ENDDO
             ELSE
+#else
+#endif
               DO I=1,NPIV
                 RHS(IROWlist(I),JCOL_RHS)=CWORK(I)
               ENDDO
+#if defined(USE_OLD_SCALING)
             ENDIF
+#endif
           ENDDO
           N2RECV=N2RECV-NPIV
           CALL MPI_UNPACK( BUFFER, SIZE_BUF_BYTES, POS_BUF,
@@ -1361,11 +1458,11 @@ C
         SUBROUTINE SMUMPS_NPIV_BLOCK_ADD ( ON_MASTER )
         LOGICAL, intent(in) ::  ON_MASTER     
         INTEGER :: JPOS, K242
-        LOGICAL :: LOCAL_LSCAL
+        LOGICAL :: PRIV_LSCAL
         IF (ON_MASTER) THEN
         IF (KEEP(350).EQ.2
      &  .AND. (NRHS.EQ.1.OR.((NPIV*NRHS*2*KEEP(16)).GE.KEEP(364)))) THEN
-          LOCAL_LSCAL = LSCAL
+          PRIV_LSCAL = LSCAL
           K242 = KEEP(242)
           DO J=1, NRHS
             IF (K242.EQ.0) THEN
@@ -1375,53 +1472,67 @@ C
             ENDIF
             DO II=1,NPIV
               I=IW(J1+II-1)
-              IPOSINRHSCOMP= POSINRHSCOMP(I) 
-              IF (LOCAL_LSCAL) THEN
-                RHS(I,JPOS) = RHSCOMP(IPOSINRHSCOMP,J)*SCALING(I)
+              IPOSINRHSINTR= POSINRHSINTR(I) 
+              IF (PRIV_LSCAL) THEN
+                RHS(I,JPOS) = RHSINTR(IPOSINRHSINTR,J)*
+#if defined(USE_OLD_SCALING)
+     &          SCALING(I)
+#else
+     &          SCALING_LOC_BWD(IPOSINRHSINTR)
+#endif
               ELSE
-                RHS(I,JPOS) = RHSCOMP(IPOSINRHSCOMP,J)
+                RHS(I,JPOS) = RHSINTR(IPOSINRHSINTR,J)
               ENDIF
             ENDDO
           ENDDO
         ELSE
          IF (KEEP(242).EQ.0) THEN
            IF (LSCAL) THEN
-            DO II=1,NPIV
+             DO II=1,NPIV
                 I=IW(J1+II-1)
-                IPOSINRHSCOMP= POSINRHSCOMP(I) 
+                IPOSINRHSINTR= POSINRHSINTR(I) 
                 DO J=1, NRHS
-                  RHS(I,J+JBEG_RHS-1) =
-     &               RHSCOMP(IPOSINRHSCOMP,J)*SCALING(I)
+                  RHS(I,J+JBEG_RHS-1) = RHSINTR(IPOSINRHSINTR,J)*
+#if defined(USE_OLD_SCALING)
+     &            SCALING(I)
+#else
+     &            SCALING_LOC_BWD(IPOSINRHSINTR)
+#endif
                 ENDDO
-            ENDDO
+             ENDDO
            ELSE
-            DO II=1,NPIV
+             DO II=1,NPIV
                 I=IW(J1+II-1)
-                IPOSINRHSCOMP= POSINRHSCOMP(I)
+                IPOSINRHSINTR= POSINRHSINTR(I)
                 DO J=1, NRHS
-                  RHS(I,J+JBEG_RHS-1) = RHSCOMP(IPOSINRHSCOMP,J)
+                  RHS(I,J+JBEG_RHS-1) = RHSINTR(IPOSINRHSINTR,J)
                 ENDDO
-            ENDDO
+             ENDDO
            ENDIF
          ELSE
            IF (LSCAL) THEN
               DO II=1,NPIV
                 I=IW(J1+II-1)
-                IPOSINRHSCOMP= POSINRHSCOMP(I)
+                IPOSINRHSINTR= POSINRHSINTR(I)
 !DIR$ NOVECTOR
                 DO J=1, NRHS
                   RHS(I,PERM_RHS(J+JBEG_RHS-1)) =
-     &               RHSCOMP(IPOSINRHSCOMP,J)*SCALING(I)
+     &               RHSINTR(IPOSINRHSINTR,J)*
+#if defined(USE_OLD_SCALING)
+     &               SCALING(I)
+#else
+     &               SCALING_LOC_BWD(IPOSINRHSINTR)
+#endif
                 ENDDO
               ENDDO
            ELSE
               DO II=1,NPIV
                 I=IW(J1+II-1)
-                IPOSINRHSCOMP= POSINRHSCOMP(I)
+                IPOSINRHSINTR= POSINRHSINTR(I)
 !DIR$ NOVECTOR
                 DO J=1, NRHS
                   RHS(I,PERM_RHS(J+JBEG_RHS-1)) =
-     &               RHSCOMP(IPOSINRHSCOMP,J)
+     &               RHSINTR(IPOSINRHSINTR,J)
                 ENDDO
               ENDDO
            ENDIF
@@ -1433,9 +1544,17 @@ C
      &                SIZE_BUF_BYTES, POS_BUF, COMM, IERR )
         CALL MPI_PACK(IW(J1), NPIV, MPI_INTEGER, BUFFER,
      &                SIZE_BUF_BYTES, POS_BUF, COMM, IERR )
-        IPOSINRHSCOMP= POSINRHSCOMP(IW(J1)) 
+        IPOSINRHSINTR= POSINRHSINTR(IW(J1)) 
         DO J=1,NRHS
-          CALL MPI_PACK(RHSCOMP(IPOSINRHSCOMP,J), NPIV,
+#if ! defined(USE_OLD_SCALING)
+          IF (LSCAL) THEN
+            DO II=IPOSINRHSINTR, IPOSINRHSINTR+NPIV-1
+              RHSINTR(II,J)=
+     &        RHSINTR(II,J)*SCALING_LOC_BWD(II)
+            ENDDO
+          ENDIF
+#endif
+          CALL MPI_PACK(RHSINTR(IPOSINRHSINTR,J), NPIV,
      &              MPI_REAL,
      &              BUFFER, SIZE_BUF_BYTES, POS_BUF, COMM,
      &              IERR)
@@ -1459,38 +1578,47 @@ C
         END SUBROUTINE SMUMPS_NPIV_BLOCK_SEND
       END SUBROUTINE SMUMPS_GATHER_SOLUTION
       SUBROUTINE SMUMPS_GATHER_SOLUTION_AM1(NSLAVES, N, MYID, COMM,
-     &           NRHS, RHSCOMP,  LRHSCOMP, NRHSCOMP_COL,
+     &           NRHS, RHSINTR,  LRHSINTR, NRHSINTR_COL,
      &           KEEP, BUFFER,
      &           SIZE_BUF, SIZE_BUF_BYTES, 
+#if defined(USE_OLD_SCALING)
      &           LSCAL, SCALING, LSCALING,
+#else
+     &           LSCAL, SCALING_LOC_BWD, LSCALING_LOC_BWD, 
+#endif
      &          IRHS_PTR_COPY, LIRHS_PTR_COPY, 
      &          IRHS_SPARSE_COPY, LIRHS_SPARSE_COPY,
      &          RHS_SPARSE_COPY, LRHS_SPARSE_COPY,
      &          UNS_PERM_INV, LUNS_PERM_INV,
-     &          POSINRHSCOMP, LPOS_ROW, NB_FS_IN_RHSCOMP )
+     &          POSINRHSINTR, LPOS_ROW, NB_FS_IN_RHSINTR )
       IMPLICIT NONE
       INCLUDE 'mpif.h'
       INCLUDE 'mumps_tags.h'
       INTEGER NSLAVES, N, MYID, COMM
-      INTEGER NRHS, LRHSCOMP, NRHSCOMP_COL 
-      REAL, intent(in) :: RHSCOMP (LRHSCOMP, NRHSCOMP_COL)
+      INTEGER NRHS, LRHSINTR, NRHSINTR_COL 
+      REAL, intent(in) :: RHSINTR (LRHSINTR, NRHSINTR_COL)
       INTEGER KEEP(500)
       INTEGER SIZE_BUF, SIZE_BUF_BYTES, LPOS_ROW
       INTEGER BUFFER(SIZE_BUF)
       INTEGER, intent(in) :: LIRHS_PTR_COPY, LIRHS_SPARSE_COPY, 
      &                       LRHS_SPARSE_COPY, LUNS_PERM_INV, 
-     &                       NB_FS_IN_RHSCOMP
+     &                       NB_FS_IN_RHSINTR
       INTEGER :: IRHS_SPARSE_COPY(LIRHS_SPARSE_COPY), 
      &           IRHS_PTR_COPY(LIRHS_PTR_COPY), 
      &           UNS_PERM_INV(LUNS_PERM_INV), 
-     &           POSINRHSCOMP(LPOS_ROW) 
+     &           POSINRHSINTR(LPOS_ROW) 
       REAL :: RHS_SPARSE_COPY(LRHS_SPARSE_COPY)
-      LOGICAL, intent(in) :: LSCAL
+#if defined(USE_OLD_SCALING)
       INTEGER, intent(in) :: LSCALING
       REAL, intent(in)    :: SCALING(LSCALING)
+#else
+      INTEGER, intent(in) :: LSCALING_LOC_BWD
+      REAL, intent(in) :: SCALING_LOC_BWD(LSCALING_LOC_BWD)
+#endif
+      LOGICAL, intent(in) :: LSCAL
       INTEGER COLSIZE, K, IZ, IPREV, NBCOL_INBLOC
       INTEGER I, II, J, MASTER,
-     &         TYPE_PARAL, N2RECV, IPOSINRHSCOMP
+     &         TYPE_PARAL, N2RECV, IPOSINRHSINTR
       INTEGER :: STATUS(MPI_STATUS_SIZE)
       INTEGER :: IERR
       PARAMETER(MASTER=0)
@@ -1510,15 +1638,20 @@ C
            DO IZ=IRHS_PTR_COPY(J), IRHS_PTR_COPY(J+1)-1
              I = IRHS_SPARSE_COPY(IZ)
              IF (KEEP(23).NE.0) I = UNS_PERM_INV(I)
-             IPOSINRHSCOMP = POSINRHSCOMP(I)
-             IF (IPOSINRHSCOMP.GT.0) THEN 
+             IPOSINRHSINTR = POSINRHSINTR(I)
+             IF (IPOSINRHSINTR.GT.0) THEN 
                 IF (LSCAL) THEN
-                 RHS_SPARSE_COPY(IZ)=
-     &                      RHSCOMP(IPOSINRHSCOMP,K)*SCALING(I)
+                  RHS_SPARSE_COPY(IZ)=
+     &                      RHSINTR(IPOSINRHSINTR,K)
+#if defined(USE_OLD_SCALING)
+     &                      * SCALING(I)
+#else
+     &                      * SCALING_LOC_BWD(IPOSINRHSINTR)
+#endif
                 ELSE
-                 RHS_SPARSE_COPY(IZ)=RHSCOMP(IPOSINRHSCOMP,K)
+                  RHS_SPARSE_COPY(IZ)=RHSINTR(IPOSINRHSINTR,K)
                 ENDIF
-             ENDIF          
+             ENDIF
            ENDDO
            K = K + 1
         ENDDO
@@ -1532,9 +1665,18 @@ C
            DO IZ=IRHS_PTR_COPY(J), IRHS_PTR_COPY(J+1)-1
              I = IRHS_SPARSE_COPY(IZ)
              IF (KEEP(23).NE.0) I = UNS_PERM_INV(I)
-             IPOSINRHSCOMP = POSINRHSCOMP(I)
-             IF (IPOSINRHSCOMP.GT.0) THEN 
-               RHS_SPARSE_COPY(IZ)=RHSCOMP(IPOSINRHSCOMP,K)
+             IPOSINRHSINTR = POSINRHSINTR(I)
+             IF (IPOSINRHSINTR.GT.0) THEN 
+#if ! defined(USE_OLD_SCALING)
+               IF (LSCAL) THEN
+                 RHS_SPARSE_COPY(IZ)=RHSINTR(IPOSINRHSINTR,K)
+     &           * SCALING_LOC_BWD(IPOSINRHSINTR)
+               ELSE
+#endif
+                 RHS_SPARSE_COPY(IZ)=RHSINTR(IPOSINRHSINTR,K)
+#if ! defined(USE_OLD_SCALING)
+               ENDIF
+#endif
              ENDIF          
            ENDDO
            K = K + 1
@@ -1566,19 +1708,25 @@ C
              I = IRHS_SPARSE_COPY(IZ)
              II = I
              IF  (KEEP(23).NE.0) II = UNS_PERM_INV(I)
-             IPOSINRHSCOMP = POSINRHSCOMP(II)
-             IF (IPOSINRHSCOMP.GT.0) THEN
+             IPOSINRHSINTR = POSINRHSINTR(II)
+             IF (IPOSINRHSINTR.GT.0) THEN
                IF (MYID .EQ. MASTER) THEN
                   N2RECV=N2RECV-1
+#if defined(USE_OLD_SCALING)
                   IF (LSCAL) 
      &            CALL SMUMPS_AM1_BLOCK_ADD ( .TRUE. )
+#endif
                   IRHS_SPARSE_COPY( IRHS_PTR_COPY(J) + K) =
      &               I
                   RHS_SPARSE_COPY( IRHS_PTR_COPY(J) + K) =
      &                RHS_SPARSE_COPY(IZ)
                   K = K+1 
                ELSE
-                  CALL SMUMPS_AM1_BLOCK_ADD (  .FALSE. )
+#if defined(USE_OLD_SCALING)
+                  CALL SMUMPS_AM1_BLOCK_ADD ( .FALSE. )
+#else
+                  CALL SMUMPS_AM1_BLOCK_ADD ()
+#endif
                ENDIF
               ENDIF          
             ENDDO
@@ -1603,10 +1751,12 @@ C
           CALL MPI_UNPACK(BUFFER, SIZE_BUF_BYTES, POS_BUF,
      &             RHS_SPARSE_COPY(IZ), 1, MPI_REAL,
      &             COMM, IERR)
+#if defined(USE_OLD_SCALING)
           IF (LSCAL) THEN
               IF (KEEP(23).NE.0) I = UNS_PERM_INV(I)
               RHS_SPARSE_COPY(IZ) = RHS_SPARSE_COPY(IZ)*SCALING(I)    
           ENDIF
+#endif
           N2RECV=N2RECV-1
           IRHS_PTR_COPY(J) = IRHS_PTR_COPY(J) + 1
           CALL MPI_UNPACK( BUFFER, SIZE_BUF_BYTES, POS_BUF,
@@ -1622,10 +1772,21 @@ C
       ENDIF
       RETURN
       CONTAINS
-        SUBROUTINE SMUMPS_AM1_BLOCK_ADD ( SCALE_ONLY )
+        SUBROUTINE SMUMPS_AM1_BLOCK_ADD (
+#if defined(USE_OLD_SCALING)
+     &                                    SCALE_ONLY 
+#endif
+     &                                               )
+#if defined(USE_OLD_SCALING)
         LOGICAL, intent(in) ::  SCALE_ONLY    
+#endif
+#if defined(USE_OLD_SCALING)
         INTEGER III
+#endif
+#if defined(USE_OLD_SCALING)
         IF (SCALE_ONLY) THEN
+          WRITE(*,*) "SMUMPS_AM1_BLOCK_ADD(true) should not be called"
+          CALL MUMPS_ABORT()
          III = I
          IF (KEEP(23).NE.0) III = UNS_PERM_INV(I)
          IF (LSCAL) THEN
@@ -1633,6 +1794,7 @@ C
          ENDIF
          RETURN
         ENDIF
+#endif
         CALL MPI_PACK(J, 1, MPI_INTEGER, BUFFER,
      &                SIZE_BUF_BYTES, POS_BUF, COMM, IERR )
         CALL MPI_PACK(I, 1, MPI_INTEGER, BUFFER,
@@ -1661,8 +1823,11 @@ C
       SUBROUTINE SMUMPS_DISTSOL_INDICES(MTYPE, ISOL_LOC,
      &             PTRIST, KEEP,KEEP8,
      &             IW, LIW_PASSED, MYID_NODES, N, STEP,
-     &             PROCNODE, NSLAVES, scaling_data, LSCAL
-     &             , IRHS_loc_MEANINGFUL, IRHS_loc, Nloc_RHS
+     &             PROCNODE, NSLAVES,
+#if defined(USE_OLD_SCALING)
+     &             scaling_data, LSCAL,
+#endif
+     &             IRHS_loc_MEANINGFUL, IRHS_loc, Nloc_RHS
      &             )
       IMPLICIT NONE
       INTEGER MTYPE, MYID_NODES, N, NSLAVES
@@ -1673,16 +1838,21 @@ C
       INTEGER LIW_PASSED
       INTEGER IW(LIW_PASSED)
       INTEGER STEP(N)
+#if defined(USE_OLD_SCALING)
       LOGICAL LSCAL
+#endif
       LOGICAL :: IRHS_loc_MEANINGFUL
       INTEGER :: Nloc_RHS
       INTEGER :: IRHS_loc(Nloc_RHS)
+#if defined(USE_OLD_SCALING)
       type scaling_data_t
         SEQUENCE
         REAL, dimension(:), pointer :: SCALING
         REAL, dimension(:), pointer :: SCALING_LOC
+        INTEGER, dimension(:), pointer :: SCALING_IND 
       end type scaling_data_t
       type (scaling_data_t) :: scaling_data
+#endif
       INTEGER MUMPS_PROCNODE
       EXTERNAL MUMPS_PROCNODE
       INTEGER ISTEP, K
@@ -1720,49 +1890,103 @@ C
                     ENDIF
                   ENDIF
                   ISOL_LOC(K)=IW(JJ)
+#if defined(USE_OLD_SCALING)
                   IF (LSCAL) THEN
                     scaling_data%SCALING_LOC(K)=
      &              scaling_data%SCALING(IW(JJ))
                   ENDIF
+#endif
               ENDDO
           ENDIF
       ENDDO
       RETURN
       END SUBROUTINE SMUMPS_DISTSOL_INDICES
+#if ! defined(USE_OLD_SCALING)
+      SUBROUTINE SMUMPS_SCALINGRHSINTR(LSCAL, N,
+     &           SCALING_LOC, SCALING_RHSINTR,
+     &           L, POSINRHSINTR, KEEP, ROWORCOL, PTRIST,
+     &           IW, LIW_PASSED, MYID_NODES, STEP,
+     &           PROCNODE, NSLAVES)
+      IMPLICIT NONE
+      INTEGER              :: KEEP(500)
+      LOGICAL, INTENT(IN)  :: LSCAL
+      INTEGER, INTENT(IN)  :: N, L
+      INTEGER, INTENT(IN)  :: POSINRHSINTR(N)
+      REAL   , INTENT(IN)  :: SCALING_LOC(max(KEEP(89),1))
+      REAL   , INTENT(OUT) :: SCALING_RHSINTR(L)
+      INTEGER, INTENT(IN)  :: ROWORCOL, NSLAVES, LIW_PASSED, MYID_NODES
+      INTEGER, INTENT(IN)  :: STEP(KEEP(28)),
+     &                        PROCNODE(KEEP(28)),
+     &                        PTRIST(KEEP(28)),
+     &                        IW(LIW_PASSED)
+      INTEGER :: IPOSINRHSINTR
+      INTEGER, EXTERNAL :: MUMPS_PROCNODE
+      INTEGER :: ISTEP
+      INTEGER :: KLOC, J1, JJ, LIELL, IPOS, NPIV
+      IF (.NOT. LSCAL) THEN
+        WRITE(*,*) "Internal error 1 in SMUMPS_DS_SCALINGRHSINTR"
+        CALL MUMPS_ABORT()
+      ENDIF
+      IF (ROWORCOL .NE. 1 .AND. ROWORCOL.NE.2) THEN
+        WRITE(*,*) "Internal error 2 in SMUMPS_DS_SCALINGRHSINTR",
+     &  ROWORCOL
+      ENDIF
+      IF (KEEP(89).EQ.0) RETURN
+      KLOC = 1
+      DO ISTEP=1, KEEP(28)
+        IF ( MYID_NODES == MUMPS_PROCNODE( PROCNODE(ISTEP),
+     &               KEEP(199))) THEN
+          CALL MUMPS_SOL_GET_NPIV_LIELL_IPOS( ISTEP, KEEP,
+     &    NPIV, LIELL, IPOS, IW, LIW_PASSED, PTRIST, STEP, N)
+          IF (ROWORCOL .EQ. 1) THEN
+               J1=IPOS+1
+          ELSE
+               J1=IPOS+1+LIELL
+          END IF
+          IPOSINRHSINTR = POSINRHSINTR(IW(J1)) 
+          IF ( IPOSINRHSINTR .GT. 0 ) THEN
+            DO JJ=1, NPIV
+             SCALING_RHSINTR(IPOSINRHSINTR+JJ-1) =
+     &       SCALING_LOC(KLOC+JJ-1)
+            ENDDO
+          ENDIF
+          KLOC = KLOC + NPIV
+        ENDIF
+      ENDDO
+      RETURN
+      END SUBROUTINE SMUMPS_SCALINGRHSINTR
+#endif
       SUBROUTINE SMUMPS_DISTRIBUTED_SOLUTION(
      &           SLAVEF, N, MYID_NODES,
-     &           MTYPE, RHSCOMP, LRHSCOMP, NBRHS_EFF,
-     &           POSINRHSCOMP,
+     &           MTYPE, RHSINTR, LRHSINTR, NBRHS_EFF,
+     &           POSINRHSINTR,
      &           ISOL_LOC, 
      &           SOL_LOC, NRHS, BEG_RHS, LSOL_LOC,
      &           PTRIST,
      &           PROCNODE_STEPS, KEEP,KEEP8, IW, LIW, STEP,
-     &           scaling_data, LSCAL, NB_RHSSKIPPED,
+     &           SCALING_LOC_BWD, LSCALING_LOC_BWD,
+     &           LSCAL, NB_RHSSKIPPED,
      &           PERM_RHS, SIZE_PERM_RHS)
       IMPLICIT NONE
       INCLUDE 'mpif.h'
       INCLUDE 'mumps_tags.h'
-      type scaling_data_t
-        SEQUENCE
-        REAL, dimension(:), pointer :: SCALING
-        REAL, dimension(:), pointer :: SCALING_LOC
-      end type scaling_data_t
-      TYPE (scaling_data_t) :: scaling_data
-      LOGICAL LSCAL
-      INTEGER SLAVEF, N, MYID_NODES, LIW, MTYPE, NBRHS_EFF, LRHSCOMP
-      INTEGER POSINRHSCOMP(N), NB_RHSSKIPPED
+      LOGICAL, intent(in) :: LSCAL
+      INTEGER, intent(in) :: LSCALING_LOC_BWD
+      REAL, intent(in) :: SCALING_LOC_BWD(LSCALING_LOC_BWD)
+      INTEGER SLAVEF, N, MYID_NODES, LIW, MTYPE, NBRHS_EFF, LRHSINTR
+      INTEGER POSINRHSINTR(N), NB_RHSSKIPPED
       INTEGER LSOL_LOC, BEG_RHS
       INTEGER ISOL_LOC(LSOL_LOC)
       INTEGER, INTENT(in) :: NRHS 
       REAL SOL_LOC( LSOL_LOC, NRHS )
-      REAL RHSCOMP( LRHSCOMP, NBRHS_EFF )
+      REAL RHSINTR( LRHSINTR, NBRHS_EFF )
       INTEGER KEEP(500)
       INTEGER(8) KEEP8(150)
       INTEGER PTRIST(KEEP(28)), PROCNODE_STEPS(KEEP(28))
       INTEGER IW(LIW), STEP(N)
       INTEGER, INTENT(in) :: SIZE_PERM_RHS
       INTEGER, INTENT(in) :: PERM_RHS( SIZE_PERM_RHS )
-      INTEGER :: JJ, J1, ISTEP, K, KLOC, IPOSINRHSCOMP, JEMPTY
+      INTEGER :: JJ, J1, ISTEP, K, KLOC, IPOSINRHSINTR, JEMPTY
       INTEGER :: JCOL, JCOL_PERM
       INTEGER :: IPOS, LIELL, NPIV, JEND
       LOGICAL :: ROOT
@@ -1814,7 +2038,7 @@ C
             ENDIF
 !$            OMP_FLAG = ( JEND-JEMPTY.GE.KEEP(362) .AND.
 !$   &                     (NPIV*(JEND-JEMPTY) .GE. KEEP(363)/2 ) )
-!$OMP PARALLEL DO PRIVATE(JCOL,JCOL_PERM,KLOC,JJ,IPOSINRHSCOMP) 
+!$OMP PARALLEL DO PRIVATE(JCOL,JCOL_PERM,KLOC,JJ,IPOSINRHSINTR) 
 !$OMP&         IF(OMP_FLAG)
             DO JCOL = JEMPTY+1, JEND
               IF (KEEP(242) .NE. 0) THEN
@@ -1824,14 +2048,13 @@ C
               ENDIF
               DO JJ=J1,J1+NPIV-1
                  KLOC=K + JJ-J1 + 1
-                IPOSINRHSCOMP = POSINRHSCOMP(IW(JJ))
                 IF (LSCAL) THEN
                   SOL_LOC(KLOC,JCOL_PERM) =
-     &            scaling_data%SCALING_LOC(KLOC)*
-     &            RHSCOMP(IPOSINRHSCOMP,JCOL-JEMPTY)
+     &            SCALING_LOC_BWD(KLOC)*
+     &            RHSINTR(KLOC,JCOL-JEMPTY)
                 ELSE
                   SOL_LOC(KLOC,JCOL_PERM) =
-     &            RHSCOMP(IPOSINRHSCOMP,JCOL-JEMPTY)
+     &            RHSINTR(KLOC,JCOL-JEMPTY)
                 ENDIF
               ENDDO
             ENDDO
@@ -1843,9 +2066,10 @@ C
       END SUBROUTINE SMUMPS_DISTRIBUTED_SOLUTION
       SUBROUTINE SMUMPS_SCATTER_RHS
      &           (NSLAVES, N, MYID, COMM,
+     &           LSCAL, SCALING_LOC_FWD,
      &           MTYPE, RHS, LRHS, NCOL_RHS, NRHS,
-     &           RHSCOMP, LRHSCOMP, NCOL_RHSCOMP,
-     &           POSINRHSCOMP_FWD, NB_FS_IN_RHSCOMP_F,
+     &           RHSINTR, LRHSINTR, NCOL_RHSINTR,
+     &           POSINRHSINTR_FWD, NB_FS_IN_RHSINTR_F,
      &           PTRIST,
      &           KEEP,KEEP8, PROCNODE_STEPS, IW, LIW, STEP, 
      &           ICNTL, INFO)
@@ -1854,15 +2078,17 @@ C
       INCLUDE 'mpif.h'
       INCLUDE 'mumps_tags.h'
       INTEGER NSLAVES, N, MYID, COMM, LIW, MTYPE
-      INTEGER NRHS, LRHS, NCOL_RHS,  LRHSCOMP, NCOL_RHSCOMP
+      INTEGER NRHS, LRHS, NCOL_RHS,  LRHSINTR, NCOL_RHSINTR
       INTEGER ICNTL(60), INFO(80)
       REAL, intent(in)  :: RHS (LRHS, NCOL_RHS)
-      REAL, intent(out) :: RHSCOMP(LRHSCOMP, NCOL_RHSCOMP)
-      INTEGER, intent(in)  :: POSINRHSCOMP_FWD(N), NB_FS_IN_RHSCOMP_F
+      REAL, intent(out) :: RHSINTR(LRHSINTR, NCOL_RHSINTR)
+      INTEGER, intent(in)  :: POSINRHSINTR_FWD(N), NB_FS_IN_RHSINTR_F
       INTEGER KEEP(500)
       INTEGER(8) KEEP8(150)
       INTEGER PTRIST(KEEP(28)), PROCNODE_STEPS(KEEP(28))
       INTEGER IW(LIW), STEP(N) 
+      LOGICAL, intent(in) :: LSCAL
+      REAL, intent(in) :: SCALING_LOC_FWD(max(1,KEEP(89)))
       INTEGER BUF_MAXSIZE, BUF_MAXREF
       PARAMETER (BUF_MAXREF=200000)
       INTEGER, ALLOCATABLE, DIMENSION(:) :: BUF_INDX
@@ -1913,10 +2139,10 @@ C
       IF (MYID.EQ.MASTER) THEN
         ENTRIES_2_PROCESS = N - KEEP(89)
         IF (TYPE_PARAL.EQ.1.AND.ENTRIES_2_PROCESS.NE.0) THEN
-         IF (NB_FS_IN_RHSCOMP_F.LT.LRHSCOMP) THEN
-           DO K=1, NCOL_RHSCOMP
-            DO I = NB_FS_IN_RHSCOMP_F +1, LRHSCOMP
-             RHSCOMP (I, K) = ZERO
+         IF (NB_FS_IN_RHSINTR_F.LT.LRHSINTR) THEN
+           DO K=1, NCOL_RHSINTR
+            DO I = NB_FS_IN_RHSINTR_F +1, LRHSINTR
+             RHSINTR (I, K) = ZERO
             ENDDO
            ENDDO
          ENDIF
@@ -1973,10 +2199,10 @@ C
       ENDIF
       IF (I_AM_SLAVE) THEN
         IF (MYID.NE.MASTER) THEN
-         IF (NB_FS_IN_RHSCOMP_F.LT.LRHSCOMP) THEN
-           DO K=1, NCOL_RHSCOMP
-            DO I = NB_FS_IN_RHSCOMP_F +1, LRHSCOMP
-             RHSCOMP (I, K) = ZERO
+         IF (NB_FS_IN_RHSINTR_F.LT.LRHSINTR) THEN
+           DO K=1, NCOL_RHSINTR
+            DO I = NB_FS_IN_RHSINTR_F +1, LRHSINTR
+             RHSINTR (I, K) = ZERO
             ENDDO
            ENDDO
          ENDIF
@@ -1992,7 +2218,7 @@ C
                    J1=IPOS+1+LIELL
               END IF
               IF (MYID.EQ.MASTER) THEN
-                INDX = POSINRHSCOMP_FWD(IW(J1))
+                INDX = POSINRHSINTR_FWD(IW(J1))
                 IF (KEEP(350).EQ.2 .AND.
      &   (NRHS.EQ.1.OR.((NPIV*NRHS*2*KEEP(16)).GE.KEEP(364)))) THEN
 !$                 OMP_FLAG = .FALSE.
@@ -2001,22 +2227,53 @@ C
 !$                   OMP_FLAG = .TRUE.
 !$                   CHUNK = max((NPIV*NRHS+NOMP-1)/NOMP,KEEP(363)/2)
 !$                 ENDIF
+#if ! defined(USE_OLD_SCALING)
+                  IF (LSCAL) THEN
+!$OMP PARALLEL DO COLLAPSE(2) SCHEDULE(STATIC,CHUNK) PRIVATE(J,JJ)
+!$OMP&  FIRSTPRIVATE(INDX) IF (OMP_FLAG)
+                     DO K = 1, NRHS
+                       DO JJ=J1,J1+NPIV-1
+                         J=IW(JJ)
+                         RHSINTR( INDX+JJ-J1, K ) = RHS( J, K ) *
+     &                   SCALING_LOC_FWD( INDX+JJ-J1 )
+                       ENDDO
+                     ENDDO
+!$OMP END PARALLEL DO
+                  ELSE
+#endif
 !$OMP PARALLEL DO COLLAPSE(2) SCHEDULE(STATIC,CHUNK) PRIVATE(J,JJ)
 !$OMP&  FIRSTPRIVATE(INDX) IF (OMP_FLAG)
-                   DO K = 1, NRHS
+                    DO K = 1, NRHS
                       DO JJ=J1,J1+NPIV-1
                          J=IW(JJ)
-                         RHSCOMP( INDX+JJ-J1, K ) = RHS( J, K )
+                         RHSINTR( INDX+JJ-J1, K ) = RHS( J, K )
                       ENDDO
-                   ENDDO
+                    ENDDO
 !$OMP END PARALLEL DO
+#if ! defined(USE_OLD_SCALING)
+                  ENDIF
+#endif
                 ELSE 
+#if ! defined(USE_OLD_SCALING)
+                  IF (LSCAL) THEN
+                   DO JJ=J1,J1+NPIV-1
+                      J=IW(JJ)
+                      DO K = 1, NRHS
+                         RHSINTR( INDX+JJ-J1, K ) = RHS( J, K )
+     &                 * SCALING_LOC_FWD( INDX + JJ - J1 )
+                      ENDDO
+                   ENDDO
+                  ELSE
+#endif
                    DO JJ=J1,J1+NPIV-1
                       J=IW(JJ)
                       DO K = 1, NRHS
-                         RHSCOMP( INDX+JJ-J1, K ) = RHS( J, K )
+                         RHSINTR( INDX+JJ-J1, K ) = RHS( J, K )
                       ENDDO
                    ENDDO
+#if ! defined(USE_OLD_SCALING)
+                  ENDIF
+#endif
                 END IF 
               ELSE
                 DO JJ=J1,J1+NPIV-1
@@ -2053,40 +2310,72 @@ C
 !$                    OMP_FLAG = .TRUE.
 !$              CHUNK = max((BUF_EFFSIZE*NRHS+NOMP-1)/NOMP,KEEP(363)/2)
 !$                  ENDIF
+#if ! defined(USE_OLD_SCALING)
+                    IF (LSCAL) THEN
 !$OMP PARALLEL DO COLLAPSE(2) SCHEDULE(STATIC,CHUNK) PRIVATE(INDX)
 !$OMP&  IF (OMP_FLAG)
-                    DO K = 1, NRHS
+                      DO K = 1, NRHS
                         DO I = 1, BUF_EFFSIZE
-                           INDX = POSINRHSCOMP_FWD(BUF_INDX(I))
-                           RHSCOMP( INDX, K ) =
-     &                              BUF_RHS_2( I+(K-1)*BUF_EFFSIZE)
+                           INDX = POSINRHSINTR_FWD(BUF_INDX(I))
+                          RHSINTR( INDX, K ) =
+     &                           BUF_RHS_2( I+(K-1)*BUF_EFFSIZE) *
+     &                           SCALING_LOC_FWD( INDX )
                         ENDDO
-                     ENDDO
+                      ENDDO
+!$OMP END PARALLEL DO
+                    ELSE
+#endif
+!$OMP PARALLEL DO COLLAPSE(2) SCHEDULE(STATIC,CHUNK) PRIVATE(INDX)
+!$OMP&  IF (OMP_FLAG)
+                      DO K = 1, NRHS
+                        DO I = 1, BUF_EFFSIZE
+                           INDX = POSINRHSINTR_FWD(BUF_INDX(I))
+                          RHSINTR( INDX, K ) =
+     &                           BUF_RHS_2( I+(K-1)*BUF_EFFSIZE)
+                        ENDDO
+                      ENDDO
 !$OMP END PARALLEL DO
+#if ! defined(USE_OLD_SCALING)
+                    ENDIF
+#endif
                    ELSE
                      CALL MPI_RECV(BUF_RHS, BUF_EFFSIZE*NRHS,
      &                 MPI_REAL,
      &                 MASTER,
      &                 ScatterRhsR, COMM, STATUS, IERR )
+#if ! defined(USE_OLD_SCALING)
+                     IF (LSCAL) THEN
+                     DO I = 1, BUF_EFFSIZE
+                        INDX = POSINRHSINTR_FWD(BUF_INDX(I))
+                        DO K = 1, NRHS
+                           RHSINTR( INDX, K ) = BUF_RHS( K, I )
+     &                     * SCALING_LOC_FWD( INDX )
+                        ENDDO
+                     ENDDO
+                     ELSE
+#endif
                      DO I = 1, BUF_EFFSIZE
-                        INDX = POSINRHSCOMP_FWD(BUF_INDX(I))
+                        INDX = POSINRHSINTR_FWD(BUF_INDX(I))
                         DO K = 1, NRHS
-                           RHSCOMP( INDX, K ) = BUF_RHS( K, I )
+                           RHSINTR( INDX, K ) = BUF_RHS( K, I )
                         ENDDO
                      ENDDO
+#if ! defined(USE_OLD_SCALING)
+                     ENDIF
+#endif
                   END IF 
                   BUF_EFFSIZE = 0
                   RETURN
                   END SUBROUTINE SMUMPS_GET_BUF_INDX_RHS
       END SUBROUTINE SMUMPS_SCATTER_RHS
-      SUBROUTINE SMUMPS_BUILD_POSINRHSCOMP
+      SUBROUTINE SMUMPS_BUILD_GLOB2LOC
      &           (NSLAVES, N, MYID_NODES,
      &           PTRIST,
      &           KEEP,KEEP8, PROCNODE_STEPS, IW, LIW, STEP, 
-     &           POSINRHSCOMP_ROW, POSINRHSCOMP_COL,
-     &           POSINRHSCOMP_COL_ALLOC,
+     &           GLOB2LOC_RHS, GLOB2LOC_SOL,
+     &           GLOB2LOC_SOL_ALLOC,
      &           MTYPE,
-     &           NBENT_RHSCOMP, NB_FS_IN_RHSCOMP )
+     &           NBENT_RHSINTR, NB_FS_IN_RHSINTR )
       IMPLICIT NONE
       INCLUDE 'mpif.h'
       INCLUDE 'mumps_tags.h'
@@ -2096,20 +2385,20 @@ C
       INTEGER, intent(in) :: PTRIST(KEEP(28)), PROCNODE_STEPS(KEEP(28))
       INTEGER, intent(in) :: IW(LIW), STEP(N)
       INTEGER, intent(in) :: MTYPE 
-      LOGICAL, intent(in) :: POSINRHSCOMP_COL_ALLOC
-      INTEGER, intent(out):: POSINRHSCOMP_ROW(N),POSINRHSCOMP_COL(N) 
-      INTEGER, intent(out):: NBENT_RHSCOMP, NB_FS_IN_RHSCOMP
+      LOGICAL, intent(in) :: GLOB2LOC_SOL_ALLOC
+      INTEGER, intent(out):: GLOB2LOC_RHS(N), GLOB2LOC_SOL(N) 
+      INTEGER, intent(out):: NBENT_RHSINTR, NB_FS_IN_RHSINTR
       INTEGER ISTEP
       INTEGER NPIV
       INTEGER IPOS, LIELL
       INTEGER JJ, J1, JCOL
-      INTEGER IPOSINRHSCOMP, IPOSINRHSCOMP_COL
+      INTEGER IPOSINRHSINTR, IPOSINRHSINTR_SOL
       INCLUDE 'mumps_headers.h'
       INTEGER MUMPS_PROCNODE
       EXTERNAL MUMPS_PROCNODE
-      POSINRHSCOMP_ROW = 0
-      IF (POSINRHSCOMP_COL_ALLOC) POSINRHSCOMP_COL = 0
-      IPOSINRHSCOMP   = 1     
+      GLOB2LOC_RHS = 0
+      IF (GLOB2LOC_SOL_ALLOC) GLOB2LOC_SOL = 0
+      IPOSINRHSINTR   = 1     
       DO ISTEP = 1, KEEP(28)
         IF (MYID_NODES == MUMPS_PROCNODE(PROCNODE_STEPS(ISTEP),
      &     KEEP(199))) THEN
@@ -2126,19 +2415,19 @@ C
                    JCOL = IPOS+1
            ENDIF
            DO JJ = J1, J1+NPIV-1
-                POSINRHSCOMP_ROW(IW(JJ)) = IPOSINRHSCOMP+JJ-J1
+                GLOB2LOC_RHS(IW(JJ)) = IPOSINRHSINTR+JJ-J1
            ENDDO
-           IF (POSINRHSCOMP_COL_ALLOC) THEN
+           IF (GLOB2LOC_SOL_ALLOC) THEN
              DO JJ = JCOL, JCOL+NPIV-1
-               POSINRHSCOMP_COL(IW(JJ)) = IPOSINRHSCOMP+JJ-JCOL
+               GLOB2LOC_SOL(IW(JJ)) = IPOSINRHSINTR+JJ-JCOL
              ENDDO
            ENDIF
-           IPOSINRHSCOMP       = IPOSINRHSCOMP + NPIV
+           IPOSINRHSINTR       = IPOSINRHSINTR + NPIV
         ENDIF
       ENDDO
-      NB_FS_IN_RHSCOMP = IPOSINRHSCOMP -1
-      IF (POSINRHSCOMP_COL_ALLOC) IPOSINRHSCOMP_COL=IPOSINRHSCOMP
-      IF (IPOSINRHSCOMP.GT.N) GOTO 500 
+      NB_FS_IN_RHSINTR = IPOSINRHSINTR -1
+      IF (GLOB2LOC_SOL_ALLOC) IPOSINRHSINTR_SOL=IPOSINRHSINTR
+      IF (IPOSINRHSINTR.GT.N) GOTO 500 
       DO ISTEP = 1, KEEP(28)
         IF (MYID_NODES == MUMPS_PROCNODE(PROCNODE_STEPS(ISTEP),
      &     KEEP(199))) THEN
@@ -2154,92 +2443,267 @@ C
            ELSE
                    JCOL = IPOS+1
            ENDIF
-           IF (POSINRHSCOMP_COL_ALLOC) THEN
+           IF (GLOB2LOC_SOL_ALLOC) THEN
             DO JJ = NPIV, LIELL-1-KEEP(253)
-              IF (POSINRHSCOMP_ROW(IW(J1+JJ)).EQ.0) THEN
-               POSINRHSCOMP_ROW(IW(J1+JJ)) = - IPOSINRHSCOMP
-               IPOSINRHSCOMP = IPOSINRHSCOMP + 1
-              ENDIF
-              IF (POSINRHSCOMP_COL(IW(JCOL+JJ)).EQ.0) THEN
-               POSINRHSCOMP_COL(IW(JCOL+JJ)) = - IPOSINRHSCOMP_COL
-               IPOSINRHSCOMP_COL = IPOSINRHSCOMP_COL + 1
+              IF (GLOB2LOC_RHS(IW(J1+JJ)).EQ.0) THEN
+               GLOB2LOC_RHS(IW(J1+JJ)) = - IPOSINRHSINTR
+               IPOSINRHSINTR = IPOSINRHSINTR + 1
+              ENDIF
+              IF (GLOB2LOC_SOL(IW(JCOL+JJ)).EQ.0) THEN
+               GLOB2LOC_SOL(IW(JCOL+JJ)) = - IPOSINRHSINTR_SOL
+               IPOSINRHSINTR_SOL = IPOSINRHSINTR_SOL + 1
               ENDIF
              ENDDO
            ELSE
              DO JJ = J1+NPIV, J1+LIELL-1-KEEP(253)
-              IF (POSINRHSCOMP_ROW(IW(JJ)).EQ.0) THEN
-               POSINRHSCOMP_ROW(IW(JJ)) = - IPOSINRHSCOMP
-               IPOSINRHSCOMP = IPOSINRHSCOMP + 1
+              IF (GLOB2LOC_RHS(IW(JJ)).EQ.0) THEN
+               GLOB2LOC_RHS(IW(JJ)) = - IPOSINRHSINTR
+               IPOSINRHSINTR = IPOSINRHSINTR + 1
               ENDIF
              ENDDO
            ENDIF
         ENDIF
       ENDDO
- 500  NBENT_RHSCOMP = IPOSINRHSCOMP - 1
-      IF (POSINRHSCOMP_COL_ALLOC) 
-     &     NBENT_RHSCOMP = max(NBENT_RHSCOMP, IPOSINRHSCOMP_COL-1)
+ 500  NBENT_RHSINTR = IPOSINRHSINTR - 1
+      IF (GLOB2LOC_SOL_ALLOC) 
+     &     NBENT_RHSINTR = max(NBENT_RHSINTR, IPOSINRHSINTR_SOL-1)
       RETURN
-      END SUBROUTINE SMUMPS_BUILD_POSINRHSCOMP
-      SUBROUTINE SMUMPS_BUILD_POSINRHSCOMP_AM1
-     &           (NSLAVES, N, MYID_NODES,
+      END SUBROUTINE SMUMPS_BUILD_GLOB2LOC
+      SUBROUTINE SMUMPS_NODES_FWD_BWD_SIZE_FILL (
+     &           fill, ICNTL,
+     &           N, NSTEPS, KEEP, STEP, Step2node,
+     &           IRHS_loc, Nloc_RHS, 
+     &           IRHS_PTR, NBCOL_INBLOC, IRHS_SPARSE, NZ_RHS,
+     &           PERM_RHS, SIZE_PERM_RHS, JBEG_RHS,
+     &           UNS_PERM_INV, SIZE_UNS_PERM_INV,
+     &           ICNTL21, 
+     &           MYID, COMM,
+     &           INFO, 
+     &           Pruned_Sons_FWD, Pruned_Sons_BWD, 
+     &           Lnodes_FWD, Lnodes_BWD
+     &           , nodes_FWD, nodes_BWD
+     &           , Lnodes_FWD_in, Lnodes_BWD_in
+     &           )
+      USE SMUMPS_SOL_ES, ONLY : SMUMPS_ES_NODES_SIZE_AND_FILL
+      IMPLICIT NONE
+      LOGICAL, INTENT(IN)  :: fill
+      INTEGER, INTENT(IN)  :: ICNTL(60),N, NSTEPS, KEEP(500) 
+      INTEGER, INTENT(IN)  :: STEP(N), Step2node(NSTEPS)
+      INTEGER, INTENT(IN)  :: Nloc_RHS, 
+     &                        IRHS_loc(max(1,Nloc_RHS))
+      INTEGER, intent(in) :: NBCOL_INBLOC, IRHS_PTR(NBCOL_INBLOC+1)
+      INTEGER, intent(in) :: NZ_RHS, IRHS_SPARSE(NZ_RHS)
+      INTEGER, intent(in) :: SIZE_PERM_RHS, PERM_RHS(SIZE_PERM_RHS)
+      INTEGER, intent(in) :: JBEG_RHS, SIZE_UNS_PERM_INV
+      INTEGER, intent(in) :: UNS_PERM_INV(SIZE_UNS_PERM_INV)
+      INTEGER, intent(IN)  :: ICNTL21
+      INTEGER, intent(in)  :: MYID, COMM
+      INTEGER, intent(inout) :: INFO(80)
+      INTEGER, intent(inout) :: Pruned_Sons_FWD(NSTEPS), 
+     &                          Pruned_Sons_BWD(NSTEPS)
+      INTEGER, intent(inout) :: Lnodes_FWD, Lnodes_BWD
+      INTEGER, intent(in) :: Lnodes_FWD_in, Lnodes_BWD_in
+      INTEGER, intent(out) :: nodes_FWD(Lnodes_FWD_in), 
+     &                        nodes_BWD(Lnodes_BWD_in)
+      INCLUDE 'mpif.h'
+      LOGICAL :: DO_PRUN_FWD, AM1, Exploit_Sparsity_FWD, 
+     &           Exploit_Sparsity_BWD
+      INTEGER :: Lnodes_FWD_loc, Lnodes_BWD_loc, ISTEP,
+     &           INODE_PRINC, I, II, JAM1
+#if defined(AVOID_MPI_IN_PLACE)
+      INTEGER, DIMENSION(:), ALLOCATABLE ::  TMP_INT_ARRAY
+#endif
+#if defined(AVOID_MPI_IN_PLACE)
+      ALLOCATE(TMP_INT_ARRAY(KEEP(28)), STAT = allocok)
+      IF(allocok.GT.0) THEN
+        INFO(1)=-13
+        INFO(2)=KEEP(28)
+      END IF
+      CALL MUMPS_PROPINFO(ICNTL, INFO, COMM, MYID )
+      IF(INFO(1).LT.0) GOTO 500
+#endif
+      AM1                  = (KEEP(237) .NE. 0)
+      Exploit_Sparsity_FWD = (KEEP(235) .NE. 0) .AND. (.NOT. AM1)
+      DO_PRUN_FWD          = (Exploit_Sparsity_FWD.OR.AM1)
+      Exploit_Sparsity_BWD = (KEEP(212) .NE. 0) .AND. (.NOT. AM1)
+      IF (.NOT.fill) Lnodes_FWD=-1
+      IF (.NOT.fill) Lnodes_BWD=-1
+      IF (.NOT.fill.AND.KEEP(252).NE.0) THEN
+        Lnodes_FWD = 0
+      ENDIF
+      IF ( KEEP(252).NE.0 ) DO_PRUN_FWD = .FALSE.  
+      IF ( DO_PRUN_FWD ) THEN
+        IF ( Exploit_Sparsity_FWD.AND.KEEP(248).EQ.-1 ) THEN
+         IF (.NOT.fill) THEN
+           CALL SMUMPS_ES_NODES_SIZE_AND_FILL ( fill,
+     &           N, KEEP(28), KEEP, STEP, Step2node,
+     &           IRHS_loc, Nloc_RHS, MYID, COMM,
+     &           Pruned_Sons_FWD, Lnodes_FWD 
+#if defined(AVOID_MPI_IN_PLACE)
+     &           , TMP_INT_ARRAY
+#endif
+     &           )
+         ELSE IF (Lnodes_FWD.GT.0) THEN
+            CALL SMUMPS_ES_NODES_SIZE_AND_FILL ( fill,
+     &           N, KEEP(28), KEEP, STEP, Step2node,
+     &           IRHS_loc, Nloc_RHS, MYID, COMM,
+     &           Pruned_Sons_FWD, Lnodes_FWD, 
+#if defined(AVOID_MPI_IN_PLACE)
+     &            TMP_INT_ARRAY, 
+#endif
+     &           nodes_FWD
+     &           )
+         ENDIF
+        ELSE IF ( Exploit_Sparsity_FWD.AND.KEEP(248).NE.-1 ) THEN
+           IF (.NOT.fill) THEN
+            Lnodes_FWD = 0
+            Pruned_Sons_FWD(:) = -1
+            DO I = 1, NZ_RHS
+               ISTEP       = abs( STEP(IRHS_SPARSE(I)) )
+               IF ( Pruned_Sons_FWD(ISTEP) .eq. -1) THEN
+                  Lnodes_FWD = Lnodes_FWD +1
+                  Pruned_Sons_FWD(ISTEP) = 0 
+               ENDIF
+            ENDDO
+           ELSE IF (Lnodes_FWD.GT.0) THEN
+            Lnodes_FWD_loc = 0
+            Pruned_Sons_FWD(:) = -1
+            DO I = 1, NZ_RHS
+               ISTEP       = abs( STEP(IRHS_SPARSE(I)) )
+               INODE_PRINC = Step2node( ISTEP )
+               IF ( Pruned_Sons_FWD(ISTEP) .eq. -1) THEN
+                  Lnodes_FWD_loc = Lnodes_FWD_loc +1
+                  nodes_FWD(Lnodes_FWD_loc)  = INODE_PRINC
+                  Pruned_Sons_FWD(ISTEP) = 0 
+               ENDIF
+            ENDDO
+           ENDIF
+        ELSE IF ( AM1 ) THEN  
+          IF (.NOT.fill) THEN
+            Lnodes_FWD = 0
+            Pruned_Sons_FWD(:) = -1
+            DO I = 1, NBCOL_INBLOC
+              IF ( (IRHS_PTR(I+1)-IRHS_PTR(I)).EQ.0) CYCLE
+              IF ( (KEEP(242) .NE. 0 ).OR. (KEEP(243).NE.0) ) THEN
+                   JAM1 = PERM_RHS(JBEG_RHS+I-1)
+              ELSE
+                   JAM1 = JBEG_RHS+I-1
+              ENDIF       
+              ISTEP = abs(STEP(JAM1))
+              INODE_PRINC = Step2node(ISTEP)
+              IF ( Pruned_Sons_FWD(ISTEP) .eq. -1) THEN
+                 Lnodes_FWD = Lnodes_FWD +1
+                 Pruned_Sons_FWD(ISTEP) = 0                 
+              ENDIF
+            ENDDO
+          ELSE IF (Lnodes_FWD.GT.0) THEN
+            Lnodes_FWD_loc = 0
+            Pruned_Sons_FWD = -1
+            DO I = 1, NBCOL_INBLOC
+              IF ( (IRHS_PTR(I+1)-IRHS_PTR(I)).EQ.0) CYCLE
+              IF ( (KEEP(242) .NE. 0 ).OR. (KEEP(243).NE.0) ) THEN
+                   JAM1 = PERM_RHS(JBEG_RHS+I-1)
+              ELSE
+                   JAM1 = JBEG_RHS+I-1
+              ENDIF
+              ISTEP = abs(STEP(JAM1))
+              INODE_PRINC = Step2node(ISTEP)
+              IF ( Pruned_Sons_FWD(ISTEP) .eq. -1) THEN
+                 Lnodes_FWD_loc = Lnodes_FWD_loc +1
+                 nodes_FWD(Lnodes_FWD_loc)  = INODE_PRINC
+                 Pruned_Sons_FWD(ISTEP) = 0
+              ENDIF
+            ENDDO            
+          ENDIF
+         ENDIF                  
+      ENDIF
+      IF (AM1) THEN
+        IF (.NOT.fill) THEN
+         Lnodes_BWD = 0
+         Pruned_Sons_BWD(:) = -1 
+         DO II = 1, NZ_RHS
+            I = IRHS_SPARSE(II)
+            IF (KEEP(23).NE.0) I = UNS_PERM_INV(I)          
+            ISTEP = abs(STEP(I))
+            IF ( Pruned_Sons_BWD(ISTEP) .eq. -1) THEN
+               Lnodes_BWD = Lnodes_BWD +1
+               Pruned_Sons_BWD(ISTEP) = 0
+            ENDIF
+         ENDDO
+        ELSE IF (Lnodes_BWD.GT.0) THEN
+         Lnodes_BWD_loc = 0         
+         Pruned_Sons_BWD(:) = -1  
+         DO II = 1, NZ_RHS
+            I = IRHS_SPARSE(II)
+            IF (KEEP(23).NE.0) I = UNS_PERM_INV(I)
+            ISTEP = abs(STEP(I))
+            INODE_PRINC = Step2node(ISTEP)
+            IF ( Pruned_Sons_BWD(ISTEP) .eq. -1) THEN
+               Lnodes_BWD_loc = Lnodes_BWD_loc +1
+               nodes_BWD(Lnodes_BWD_loc)  = INODE_PRINC
+               Pruned_Sons_BWD(ISTEP) = 0
+            ENDIF
+         ENDDO
+        ENDIF
+      ENDIF
+#if defined(AVOID_MPI_IN_PLACE)
+      GOTO 600  
+  500 CONTINUE
+      Lnodes_FWD = -1
+      Lnodes_BWD = -1
+  600 CONTINUE
+#endif
+#if defined(AVOID_MPI_IN_PLACE)
+      IF ( allocated(TMP_INT_ARRAY)) DEALLOCATE(TMP_INT_ARRAY)
+#endif
+      RETURN
+      END SUBROUTINE SMUMPS_NODES_FWD_BWD_SIZE_FILL
+      SUBROUTINE SMUMPS_BUILD_GLOB2LOC_NODES_ES (
+     &           NSLAVES, N, MYID_NODES,
      &           PTRIST, DAD,
      &           KEEP,KEEP8, PROCNODE_STEPS, IW, LIW, STEP,
-     &           POSINRHSCOMP_ROW, POSINRHSCOMP_COL,
-     &           POSINRHSCOMP_COL_ALLOC,
+     &           Lnodes_FWD, Lnodes_BWD,
+     &           nodes_FWD, nodes_BWD,
+     &           GLOB2LOC_RHS, GLOB2LOC_SOL,
+     &           GLOB2LOC_SOL_ALLOC,
      &           MTYPE,
-     &           IRHS_PTR, NBCOL_INBLOC, IRHS_SPARSE, NZ_RHS,
-     &           PERM_RHS, SIZE_PERM_RHS, JBEG_RHS,
-     &           NBENT_RHSCOMP,
-     &           NB_FS_IN_RHSCOMP_FWD, NB_FS_IN_RHSCOMP_TOT,
-     &           UNS_PERM_INV, SIZE_UNS_PERM_INV
+     &           NBENT_RHSINTR,
+     &           NB_FS_IN_RHSINTR_FWD, NB_FS_IN_RHSINTR_TOT
      &            )
       IMPLICIT NONE
       INCLUDE 'mpif.h'
       INCLUDE 'mumps_tags.h'
-      INTEGER, intent(in) :: NSLAVES, N, MYID_NODES, LIW, 
-     &                       SIZE_UNS_PERM_INV
-      INTEGER, intent(in) :: KEEP(500)
+      INTEGER, intent(in)    :: NSLAVES, N, MYID_NODES, LIW
+      INTEGER, intent(in)    :: KEEP(500)
       INTEGER(8), intent(in) :: KEEP8(150)
       INTEGER, intent(in) :: PTRIST(KEEP(28)), PROCNODE_STEPS(KEEP(28))
+      INTEGER, intent(in) :: Lnodes_FWD, Lnodes_BWD
+      INTEGER, intent(in) :: nodes_FWD(max(1,Lnodes_FWD)), 
+     &                       nodes_BWD(max(1,Lnodes_BWD))
       INTEGER, intent(inout) :: DAD(KEEP(28))
       INTEGER, intent(in) :: IW(LIW), STEP(N)
-      INTEGER, intent(in) :: NBCOL_INBLOC, IRHS_PTR(NBCOL_INBLOC+1)
-      INTEGER, intent(in) :: NZ_RHS, IRHS_SPARSE(NZ_RHS)
-      INTEGER, intent(in) :: SIZE_PERM_RHS, PERM_RHS(SIZE_PERM_RHS)
-      INTEGER, intent(in) :: JBEG_RHS
       INTEGER, intent(in) :: MTYPE
-      LOGICAL, intent(in) :: POSINRHSCOMP_COL_ALLOC
-      INTEGER, intent(out):: POSINRHSCOMP_ROW(N),POSINRHSCOMP_COL(N)
-      INTEGER, intent(out):: NBENT_RHSCOMP
-      INTEGER, intent(out):: NB_FS_IN_RHSCOMP_FWD, NB_FS_IN_RHSCOMP_TOT
-      INTEGER, intent(in) :: UNS_PERM_INV(SIZE_UNS_PERM_INV)
-      INTEGER I, JAM1
+      LOGICAL, intent(in) :: GLOB2LOC_SOL_ALLOC
+      INTEGER, intent(out):: GLOB2LOC_RHS(N), GLOB2LOC_SOL(N)
+      INTEGER, intent(out):: NBENT_RHSINTR
+      INTEGER, intent(out):: NB_FS_IN_RHSINTR_FWD, NB_FS_IN_RHSINTR_TOT
+      INTEGER I
       INTEGER ISTEP, OLDISTEP
       INTEGER NPIV
       INTEGER IPOS, LIELL
       INTEGER JJ, J1, JCOL, ABSJCOL
-      INTEGER IPOSINRHSCOMP_ROW, IPOSINRHSCOMP_COL
-      INTEGER NBENT_RHSCOMP_ROW, NBENT_RHSCOMP_COL
+      INTEGER IPOSINRHSINTR_RHS, IPOSINRHSINTR_SOL
+      INTEGER NBENT_RHSINTR_ROW, NBENT_RHSINTR_COL
       LOGICAL GO_UP
       INCLUDE 'mumps_headers.h'
       INTEGER MUMPS_PROCNODE
       EXTERNAL MUMPS_PROCNODE
-      IF(KEEP(237).EQ.0) THEN
-        WRITE(*,*)'BUILD_POSINRHSCOMP_SPARSE available for A-1 only !'
-        CALL MUMPS_ABORT()
-      END IF
-      POSINRHSCOMP_ROW = 0
-      IF (POSINRHSCOMP_COL_ALLOC) POSINRHSCOMP_COL = 0
-      IPOSINRHSCOMP_ROW = 0
-      IPOSINRHSCOMP_COL = 0
-      DO I = 1, NBCOL_INBLOC
-        IF ((IRHS_PTR(I+1)-IRHS_PTR(I)).EQ.0) CYCLE 
-        IF (KEEP(242).NE.0) THEN 
-          JAM1 = PERM_RHS(JBEG_RHS+I-1)
-        ELSE
-          JAM1 = JBEG_RHS+I-1
-        END IF
-        ISTEP = abs(STEP(JAM1))
+      GLOB2LOC_RHS = 0
+      IF (GLOB2LOC_SOL_ALLOC) GLOB2LOC_SOL = 0
+      IPOSINRHSINTR_RHS = 0
+      IPOSINRHSINTR_SOL = 0
+      DO I = 1, Lnodes_FWD
+        ISTEP = STEP(nodes_FWD(I))
         GO_UP = .TRUE.
         DO WHILE(GO_UP) 
           IF(MYID_NODES.EQ.
@@ -2257,18 +2721,18 @@ C
               JCOL = IPOS+1
             ENDIF
             IF(NPIV.GT.0) THEN 
-              IF(POSINRHSCOMP_ROW(IW(J1)).EQ.0) THEN 
+              IF(GLOB2LOC_RHS(IW(J1)).EQ.0) THEN 
                 DO JJ = J1, J1+NPIV-1
-                  POSINRHSCOMP_ROW(IW(JJ))
-     &            = IPOSINRHSCOMP_ROW + JJ - J1 + 1
+                  GLOB2LOC_RHS(IW(JJ))
+     &            = IPOSINRHSINTR_RHS + JJ - J1 + 1
                 ENDDO
-                IPOSINRHSCOMP_ROW = IPOSINRHSCOMP_ROW + NPIV
-                IF (POSINRHSCOMP_COL_ALLOC) THEN
+                IPOSINRHSINTR_RHS = IPOSINRHSINTR_RHS + NPIV
+                IF (GLOB2LOC_SOL_ALLOC) THEN
                   DO JJ = JCOL, JCOL+NPIV-1
-                    POSINRHSCOMP_COL(IW(JJ))
-     &              = - N - (IPOSINRHSCOMP_COL + JJ - JCOL + 1)
+                    GLOB2LOC_SOL(IW(JJ))
+     &              = - (IPOSINRHSINTR_SOL + JJ - JCOL + 1)
                   ENDDO
-                  IPOSINRHSCOMP_COL = IPOSINRHSCOMP_COL + NPIV
+                  IPOSINRHSINTR_SOL = IPOSINRHSINTR_SOL + NPIV
                 ENDIF
               ELSE
                 GO_UP = .FALSE. 
@@ -2282,12 +2746,10 @@ C
           END IF
         END DO 
       END DO 
-      NB_FS_IN_RHSCOMP_FWD = IPOSINRHSCOMP_ROW
-      IF(POSINRHSCOMP_COL_ALLOC) THEN 
-        DO I =1, NZ_RHS
-          JAM1 = IRHS_SPARSE(I)
-          IF (KEEP(23).NE.0) JAM1 = UNS_PERM_INV(JAM1)
-          ISTEP = abs(STEP(JAM1))
+      NB_FS_IN_RHSINTR_FWD = IPOSINRHSINTR_RHS
+      IF(GLOB2LOC_SOL_ALLOC) THEN 
+        DO I=1, Lnodes_BWD
+          ISTEP = STEP(nodes_BWD(I))
           GO_UP = .TRUE.
           DO WHILE(GO_UP) 
             IF(MYID_NODES.EQ.
@@ -2306,21 +2768,17 @@ C
               ENDIF
               ABSJCOL = abs(IW(JCOL))
               IF(NPIV.GT.0) THEN 
-                IF(POSINRHSCOMP_COL(ABSJCOL).EQ.0)  THEN
+                IF(GLOB2LOC_SOL(ABSJCOL).EQ.0)  THEN
                   DO JJ = JCOL, JCOL+NPIV-1
-                    POSINRHSCOMP_COL(abs(IW(JJ))) = 
-     &                     IPOSINRHSCOMP_COL+JJ-JCOL+1
+                    GLOB2LOC_SOL(abs(IW(JJ))) = 
+     &                     IPOSINRHSINTR_SOL+JJ-JCOL+1
                   END DO
-                  IPOSINRHSCOMP_COL = IPOSINRHSCOMP_COL + NPIV
-                ELSE IF (POSINRHSCOMP_COL(ABSJCOL).LT.-N) THEN
+                  IPOSINRHSINTR_SOL = IPOSINRHSINTR_SOL + NPIV
+                ELSE IF (GLOB2LOC_SOL(ABSJCOL).LT.0) THEN
                   DO JJ = JCOL, JCOL+NPIV-1
-                    POSINRHSCOMP_COL(abs(IW(JJ)))=
-     &                -(N+POSINRHSCOMP_COL(abs(IW(JJ))))
+                    GLOB2LOC_SOL(abs(IW(JJ)))=
+     &                -(GLOB2LOC_SOL(abs(IW(JJ))))
                   END DO
-                ELSE IF ((POSINRHSCOMP_COL(ABSJCOL).LT.0).AND.
-     &                 (POSINRHSCOMP_COL(ABSJCOL).GE.-N))THEN
-                  WRITE(*,*)'Internal error 7 in BUILD...SPARSE'
-                  CALL MUMPS_ABORT()
                 ELSE
                   GO_UP = .FALSE.
                 END IF
@@ -2334,16 +2792,10 @@ C
           END DO 
         END DO 
       END IF 
-      NB_FS_IN_RHSCOMP_TOT = IPOSINRHSCOMP_COL
-            IF (NSLAVES.NE.1) THEN
-      DO I = 1, NBCOL_INBLOC
-        IF ((IRHS_PTR(I+1)-IRHS_PTR(I)).EQ.0) CYCLE 
-        IF (KEEP(242).NE.0) THEN 
-          JAM1 = PERM_RHS(JBEG_RHS+I-1)
-        ELSE
-          JAM1 = JBEG_RHS+I-1
-        END IF
-        ISTEP = abs(STEP(JAM1))
+      NB_FS_IN_RHSINTR_TOT = IPOSINRHSINTR_SOL
+      IF (NSLAVES.NE.1) THEN
+      DO I = 1, Lnodes_FWD
+        ISTEP = STEP(nodes_FWD(I))
         GO_UP = .TRUE.
         DO WHILE(GO_UP) 
           IF(MYID_NODES.EQ.
@@ -2361,10 +2813,9 @@ C
               JCOL = IPOS+1
             ENDIF
             DO JJ = NPIV, LIELL-1-KEEP(253)
-              IF(POSINRHSCOMP_ROW(IW(J1+JJ)).EQ.0) THEN 
-                IPOSINRHSCOMP_ROW = IPOSINRHSCOMP_ROW + 1
-                POSINRHSCOMP_ROW(IW(JJ+J1))
-     &          = -IPOSINRHSCOMP_ROW
+              IF(GLOB2LOC_RHS(IW(J1+JJ)).EQ.0) THEN 
+                IPOSINRHSINTR_RHS = IPOSINRHSINTR_RHS + 1
+                GLOB2LOC_RHS(IW(JJ+J1)) = -IPOSINRHSINTR_RHS
               END IF
             END DO
           END IF
@@ -2378,11 +2829,9 @@ C
         END DO 
       END DO 
       DAD=ABS(DAD)
-      IF(POSINRHSCOMP_COL_ALLOC) THEN
-        DO I =1, NZ_RHS
-          JAM1 = IRHS_SPARSE(I)
-          IF (KEEP(23).NE.0) JAM1 = UNS_PERM_INV(JAM1)
-          ISTEP = abs(STEP(JAM1))
+      IF(GLOB2LOC_SOL_ALLOC) THEN
+        DO I=1, Lnodes_BWD
+        ISTEP = STEP(nodes_BWD(I))
           GO_UP = .TRUE.
           DO WHILE(GO_UP) 
             IF(MYID_NODES.EQ.
@@ -2399,16 +2848,10 @@ C
               ELSE
                 JCOL = IPOS+1
               ENDIF
-              IF (KEEP(23).NE.0) JAM1 = UNS_PERM_INV(JAM1)
               DO JJ = NPIV, LIELL-1-KEEP(253)
-                IF(POSINRHSCOMP_COL(IW(JCOL+JJ)).EQ.0) THEN 
-                  IPOSINRHSCOMP_COL = IPOSINRHSCOMP_COL + 1
-                  POSINRHSCOMP_COL(IW(JCOL+JJ))
-     &            = -IPOSINRHSCOMP_COL
-                ELSE IF (POSINRHSCOMP_COL(IW(JCOL+JJ)).LT.-N) THEN
-                  IPOSINRHSCOMP_COL = IPOSINRHSCOMP_COL + 1
-                  POSINRHSCOMP_COL(IW(JCOL+JJ))
-     &            = POSINRHSCOMP_COL(IW(JCOL+JJ)) + N              
+                IF(GLOB2LOC_SOL(IW(JCOL+JJ)).EQ.0) THEN 
+                  IPOSINRHSINTR_SOL = IPOSINRHSINTR_SOL + 1
+                  GLOB2LOC_SOL(IW(JCOL+JJ)) = -IPOSINRHSINTR_SOL
                 END IF
               END DO
             END IF
@@ -2424,8 +2867,8 @@ C
        DAD=ABS(DAD)
       END IF
       ENDIF
-      NBENT_RHSCOMP_ROW = IPOSINRHSCOMP_ROW
-      NBENT_RHSCOMP_COL = IPOSINRHSCOMP_COL
-      NBENT_RHSCOMP = max(NBENT_RHSCOMP_ROW,NBENT_RHSCOMP_COL)
+      NBENT_RHSINTR_ROW = IPOSINRHSINTR_RHS
+      NBENT_RHSINTR_COL = IPOSINRHSINTR_SOL
+      NBENT_RHSINTR = max(NBENT_RHSINTR_ROW,NBENT_RHSINTR_COL)
       RETURN
-      END SUBROUTINE SMUMPS_BUILD_POSINRHSCOMP_AM1
+      END SUBROUTINE SMUMPS_BUILD_GLOB2LOC_NODES_ES
diff -pruN 5.6.2-2.1/src/ssol_distrhs.F 5.7.1-1/src/ssol_distrhs.F
--- 5.6.2-2.1/src/ssol_distrhs.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/ssol_distrhs.F	2024-05-02 10:15:25.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -17,9 +17,14 @@ C
      &           NRHS_COL, NRHS_loc, LRHS_loc,
      &           MAP_RHS_loc,
      &           IRHS_loc, RHS_loc, RHS_loc_size,
-     &           RHSCOMP, LD_RHSCOMP,
-     &           POSINRHSCOMP_FWD, NB_FS_IN_RHSCOMP,
-     &           LSCAL, scaling_data_dr,
+     &           RHSINTR, LD_RHSINTR,
+     &           POSINRHSINTR_FWD, NB_FS_IN_RHSINTR,
+     &           LSCAL,
+#if defined(USE_OLD_SCALING)
+     &           scaling_data_dr,
+#else
+     &           SCALING_RHSINTR_FWD, LSCALING_RHSINTR_FWD,
+#endif
      &           LP, LPOK, KEEP, NB_BYTES_LOC, INFO )
       USE SMUMPS_STRUC_DEF
 !$    USE OMP_LIB
@@ -32,17 +37,23 @@ C
       INTEGER, INTENT(IN)    :: IRHS_loc(NRHS_loc)
       INTEGER(8), INTENT(IN) :: RHS_loc_size
       REAL, INTENT(IN)    :: RHS_loc(RHS_loc_size)
-      INTEGER, INTENT(IN)    :: NB_FS_IN_RHSCOMP, LD_RHSCOMP
-      INTEGER, INTENT(IN)    :: POSINRHSCOMP_FWD(N)
-      REAL, INTENT(OUT)   :: RHSCOMP(LD_RHSCOMP, NRHS_COL)
+      INTEGER, INTENT(IN)    :: NB_FS_IN_RHSINTR, LD_RHSINTR
+      INTEGER, INTENT(IN)    :: POSINRHSINTR_FWD(N)
+      REAL, INTENT(OUT)   :: RHSINTR(LD_RHSINTR, NRHS_COL)
       INTEGER                :: KEEP(500)
       LOGICAL, INTENT(IN)    :: LSCAL
+#if defined(USE_OLD_SCALING)
       type scaling_data_t
         SEQUENCE
-        REAL, dimension(:), pointer :: SCALING
-        REAL, dimension(:), pointer :: SCALING_LOC
+        REAL,    dimension(:), pointer :: SCALING
+        REAL,    dimension(:), pointer :: SCALING_LOC
+        INTEGER, dimension(:), pointer :: SCALING_IND 
       end type scaling_data_t
       type(scaling_data_t), INTENT(IN) :: scaling_data_dr
+#else
+      INTEGER :: LSCALING_RHSINTR_FWD
+      REAL :: SCALING_RHSINTR_FWD( LSCALING_RHSINTR_FWD )
+#endif
       LOGICAL, INTENT(IN)    :: LPOK
       INTEGER, INTENT(IN)    :: LP      
       INTEGER, INTENT(INOUT) :: INFO(2) 
@@ -135,7 +146,7 @@ C
      &         IS_SEND_ACTIVE(MAX_ACTIVE_SENDS),
      &         BUFRECI(MAXRECORDS),                
      &         BUFRECR(MAXRECORDS*NRHS_COL),       
-     &         TOUCHED(NB_FS_IN_RHSCOMP),          
+     &         TOUCHED(NB_FS_IN_RHSINTR),          
      &         stat=allocok)
       IF (allocok .GT. 0) THEN
         IF (LP .GT. 0) WRITE(LP, '(A)')
@@ -143,11 +154,11 @@ C
         INFO(1)=-13
         INFO(2)=NRHS_COL*MAXRECORDS*MAX_ACTIVE_SENDS+
      &          3*MAX_ACTIVE_SENDS+MAXRECORDS*(1+NRHS_COL)
-     &          + NB_FS_IN_RHSCOMP
+     &          + NB_FS_IN_RHSINTR
       ENDIF
       NB_BYTES_LOC=NB_BYTES_LOC +
      &  KEEP(34) * ( int(2*MAX_ACTIVE_SENDS,8) + int(MAXRECORDS,8) ) +
-     &  KEEP(34) * (int(MAX_ACTIVE_SENDS,8) + int(NB_FS_IN_RHSCOMP,8)) +
+     &  KEEP(34) * (int(MAX_ACTIVE_SENDS,8) + int(NB_FS_IN_RHSINTR,8)) +
      &  KEEP(35) * (
      &      int( MAXRECORDS,8)*int(NRHS_COL,8)*int(MAX_ACTIVE_SENDS,8)
      &      + int(MAXRECORDS,8) * int(NRHS_COL,8) )
@@ -160,7 +171,7 @@ C
         IS_SEND_ACTIVE(IREQ) = .FALSE.
       ENDDO
       NB_FS_TOUCHED = 0
-      DO IFS = 1, NB_FS_IN_RHSCOMP
+      DO IFS = 1, NB_FS_IN_RHSINTR
         TOUCHED(IFS) = .FALSE.
       ENDDO
       IPROC_MAX=maxloc(NBROWSTOSEND,DIM=1)-1
@@ -223,7 +234,7 @@ C
         INTEGER, INTENT(INOUT) :: BUFRECI_ARG(NBRECORDS) 
         REAL, INTENT(IN) :: BUFRECR_ARG(NBRECORDS,
      &                                     NRHS_COL)
-        INTEGER :: I, K, IRHSCOMP, IFIRSTNOTTOUCHED, ILASTNOTTOUCHED
+        INTEGER :: I, K, IRHSINTR, IFIRSTNOTTOUCHED, ILASTNOTTOUCHED
         IFIRSTNOTTOUCHED = NBRECORDS+1
         ILASTNOTTOUCHED  = 0
         DO I = 1, NBRECORDS
@@ -232,9 +243,9 @@ C
      &      I, BUFRECI(I), BUFRECI(1)
             CALL MUMPS_ABORT()
           ENDIF
-          IRHSCOMP=POSINRHSCOMP_FWD(BUFRECI(I))
-          BUFRECI_ARG(I)=IRHSCOMP
-          IF ( .NOT. TOUCHED(IRHSCOMP) ) THEN
+          IRHSINTR=POSINRHSINTR_FWD(BUFRECI(I))
+          BUFRECI_ARG(I)=IRHSINTR
+          IF ( .NOT. TOUCHED(IRHSINTR) ) THEN
             IFIRSTNOTTOUCHED=min(IFIRSTNOTTOUCHED,I)
             ILASTNOTTOUCHED=max(ILASTNOTTOUCHED,I)
           ENDIF
@@ -243,41 +254,67 @@ C
 !$      OMP_FLAG = ( NRHS_COL.GE.KEEP(362) .AND.
 !$   &               NRHS_COL*NBRECORDS .GE. KEEP(363)/2)
         IF (OMP_FLAG) THEN
-!$OMP PARALLEL DO PRIVATE(I,IRHSCOMP) IF (OMP_FLAG)
+!$OMP PARALLEL DO PRIVATE(I,IRHSINTR)
         DO K = 1, NRHS_COL
           DO I = IFIRSTNOTTOUCHED, ILASTNOTTOUCHED
-            IRHSCOMP=BUFRECI_ARG(I)
-            IF (.NOT. TOUCHED(IRHSCOMP)) THEN
-              RHSCOMP(IRHSCOMP,K)=ZERO
+            IRHSINTR=BUFRECI_ARG(I)
+            IF (.NOT. TOUCHED(IRHSINTR)) THEN
+              RHSINTR(IRHSINTR,K)=ZERO
             ENDIF
           ENDDO
-          DO I = 1, NBRECORDS
-            IRHSCOMP=BUFRECI_ARG(I)
-            RHSCOMP(IRHSCOMP,K) = RHSCOMP(IRHSCOMP,K) +
+#if ! defined(USE_OLD_SCALING)
+          IF (LSCAL) THEN
+            DO I = 1, NBRECORDS
+              IRHSINTR=BUFRECI_ARG(I)
+              RHSINTR(IRHSINTR,K) = RHSINTR(IRHSINTR,K) +
+     &                            SCALING_RHSINTR_FWD(IRHSINTR) *
      &                            BUFRECR_ARG(I,K)
-          ENDDO
+            ENDDO
+          ELSE
+#endif
+            DO I = 1, NBRECORDS
+              IRHSINTR=BUFRECI_ARG(I)
+              RHSINTR(IRHSINTR,K) = RHSINTR(IRHSINTR,K) +
+     &                            BUFRECR_ARG(I,K)
+            ENDDO
+#if ! defined(USE_OLD_SCALING)
+          ENDIF
+#endif
         ENDDO
 !$OMP END PARALLEL DO
         ELSE
-        DO K = 1, NRHS_COL
-          DO I = IFIRSTNOTTOUCHED, ILASTNOTTOUCHED
-            IRHSCOMP=BUFRECI_ARG(I)
-            IF (.NOT. TOUCHED(IRHSCOMP)) THEN
-              RHSCOMP(IRHSCOMP,K)=ZERO
+          DO K = 1, NRHS_COL
+            DO I = IFIRSTNOTTOUCHED, ILASTNOTTOUCHED
+              IRHSINTR=BUFRECI_ARG(I)
+              IF (.NOT. TOUCHED(IRHSINTR)) THEN
+                RHSINTR(IRHSINTR,K)=ZERO
+              ENDIF
+            ENDDO
+#if ! defined(USE_OLD_SCALING)
+            IF ( LSCAL ) THEN
+              DO I = 1, NBRECORDS
+                IRHSINTR=BUFRECI_ARG(I)
+                RHSINTR(IRHSINTR,K) = RHSINTR(IRHSINTR,K) +
+     &                                SCALING_RHSINTR_FWD(IRHSINTR) *
+     &                                BUFRECR_ARG(I,K)
+              ENDDO
+            ELSE
+#endif
+              DO I = 1, NBRECORDS
+                IRHSINTR=BUFRECI_ARG(I)
+                RHSINTR(IRHSINTR,K) = RHSINTR(IRHSINTR,K) +
+     &                                BUFRECR_ARG(I,K)
+              ENDDO
+#if ! defined(USE_OLD_SCALING)
             ENDIF
+#endif
           ENDDO
-          DO I = 1, NBRECORDS
-            IRHSCOMP=BUFRECI_ARG(I)
-            RHSCOMP(IRHSCOMP,K) = RHSCOMP(IRHSCOMP,K) +
-     &                            BUFRECR_ARG(I,K)
-          ENDDO
-        ENDDO
         ENDIF
         DO I = 1, NBRECORDS
-          IRHSCOMP = BUFRECI_ARG(I)
-          IF (.NOT. TOUCHED(IRHSCOMP)) THEN
+          IRHSINTR = BUFRECI_ARG(I)
+          IF (.NOT. TOUCHED(IRHSINTR)) THEN
             NB_FS_TOUCHED = NB_FS_TOUCHED + 1
-            TOUCHED(IRHSCOMP) = .TRUE.
+            TOUCHED(IRHSINTR) = .TRUE.
           ENDIF
         ENDDO
         NBROWSTORECV = NBROWSTORECV - NBRECORDS
@@ -287,7 +324,7 @@ C
         INTEGER :: NBRECORDS, I, K, IFIRSTNOTTOUCHED
         INTEGER :: Iloc       
         INTEGER :: Iglob      
-        INTEGER :: IRHSCOMP   
+        INTEGER :: IRHSINTR   
         INTEGER(8) :: ISHIFT
         IF ( NBROWSTOSEND(MYID_NODES+1) .EQ. 0) THEN
           WRITE(*,*) "Internal error in SMUMPS_DR_ASSEMBLE_LOCAL"
@@ -296,9 +333,9 @@ C
         NBRECORDS=min(MAXRECORDS, NBROWSTOSEND(MYID_NODES+1))
         IFIRSTNOTTOUCHED=NBRECORDS+1
         DO I = 1, NBRECORDS
-          IRHSCOMP = POSINRHSCOMP_FWD(IRHS_loc(
+          IRHSINTR = POSINRHSINTR_FWD(IRHS_loc(
      &               IRHS_loc_sorted(NEXTROWTOSEND(MYID_NODES+1)+I-1)))
-          IF (.NOT. TOUCHED(IRHSCOMP)) THEN
+          IF (.NOT. TOUCHED(IRHSINTR)) THEN
             IFIRSTNOTTOUCHED=I
             EXIT
           ENDIF
@@ -306,57 +343,61 @@ C
         IF (LSCAL) THEN
 !$        OMP_FLAG = (NRHS_COL.GE.KEEP(362) .AND.
 !$   &                NRHS_COL*NBRECORDS .GE. KEEP(363)/2)
-!$OMP PARALLEL DO PRIVATE(K, ISHIFT, I, IRHSCOMP, Iloc, Iglob)
+!$OMP PARALLEL DO PRIVATE(K, ISHIFT, I, IRHSINTR, Iloc, Iglob)
 !$OMP&  FIRSTPRIVATE(NBRECORDS) IF (OMP_FLAG)
           DO K = 1, NRHS_COL
-            ISHIFT = (K-1) * LRHS_loc
+            ISHIFT = int(K-1,8) * int(LRHS_loc,8)
             DO I = IFIRSTNOTTOUCHED, NBRECORDS
-              IRHSCOMP = POSINRHSCOMP_FWD(IRHS_loc(
+              IRHSINTR = POSINRHSINTR_FWD(IRHS_loc(
      &               IRHS_loc_sorted(NEXTROWTOSEND(MYID_NODES+1)+I-1)))
-               IF (.NOT. TOUCHED(IRHSCOMP)) THEN
-                 RHSCOMP(IRHSCOMP,K)=ZERO
+               IF (.NOT. TOUCHED(IRHSINTR)) THEN
+                 RHSINTR(IRHSINTR,K)=ZERO
                ENDIF
             ENDDO
             DO I = 1, NBRECORDS
               Iloc = IRHS_loc_sorted(NEXTROWTOSEND(MYID_NODES+1)+I-1)
               Iglob = IRHS_loc(Iloc)
-              IRHSCOMP = POSINRHSCOMP_FWD(Iglob)
-              RHSCOMP(IRHSCOMP,K) = RHSCOMP(IRHSCOMP,K)+
+              IRHSINTR = POSINRHSINTR_FWD(Iglob)
+              RHSINTR(IRHSINTR,K) = RHSINTR(IRHSINTR,K)+
      &                              RHS_loc(Iloc+ISHIFT)*
+#if defined(USE_OLD_SCALING)
      &                        scaling_data_dr%SCALING_LOC(Iloc)
+#else
+     &                        SCALING_RHSINTR_FWD(IRHSINTR)
+#endif
             ENDDO
           ENDDO
 !$OMP END PARALLEL DO
         ELSE
 !$        OMP_FLAG = (NRHS_COL.GE.KEEP(362) .AND.
 !$   &                NRHS_COL*NBRECORDS .GE. KEEP(363)/2)
-!$OMP PARALLEL DO PRIVATE(K, ISHIFT, I, IRHSCOMP, Iloc, Iglob)
+!$OMP PARALLEL DO PRIVATE(K, ISHIFT, I, IRHSINTR, Iloc, Iglob)
 !$OMP&  FIRSTPRIVATE(NBRECORDS) IF (OMP_FLAG)
           DO K = 1, NRHS_COL
-            ISHIFT = (K-1) * LRHS_loc
+            ISHIFT = int(K-1,8) * int(LRHS_loc,8)
             DO I = IFIRSTNOTTOUCHED, NBRECORDS
-              IRHSCOMP = POSINRHSCOMP_FWD(IRHS_loc(
+              IRHSINTR = POSINRHSINTR_FWD(IRHS_loc(
      &               IRHS_loc_sorted(NEXTROWTOSEND(MYID_NODES+1)+I-1)))
-               IF (.NOT. TOUCHED(IRHSCOMP)) THEN
-                 RHSCOMP(IRHSCOMP,K)=ZERO
+               IF (.NOT. TOUCHED(IRHSINTR)) THEN
+                 RHSINTR(IRHSINTR,K)=ZERO
                ENDIF
             ENDDO
             DO I = 1, NBRECORDS
               Iloc = IRHS_loc_sorted(NEXTROWTOSEND(MYID_NODES+1)+I-1)
               Iglob = IRHS_loc(Iloc)
-              IRHSCOMP = POSINRHSCOMP_FWD(Iglob)
-              RHSCOMP(IRHSCOMP,K) = RHSCOMP(IRHSCOMP,K)+
+              IRHSINTR = POSINRHSINTR_FWD(Iglob)
+              RHSINTR(IRHSINTR,K) = RHSINTR(IRHSINTR,K) +
      &                              RHS_loc(Iloc+ISHIFT)
             ENDDO
           ENDDO
 !$OMP END PARALLEL DO
         ENDIF
         DO I = 1, NBRECORDS
-          IRHSCOMP = POSINRHSCOMP_FWD(IRHS_loc(
+          IRHSINTR = POSINRHSINTR_FWD(IRHS_loc(
      &               IRHS_loc_sorted(NEXTROWTOSEND(MYID_NODES+1)+I-1)))
-          IF (.NOT. TOUCHED(IRHSCOMP)) THEN
+          IF (.NOT. TOUCHED(IRHSINTR)) THEN
             NB_FS_TOUCHED = NB_FS_TOUCHED + 1
-            TOUCHED(IRHSCOMP) = .TRUE.
+            TOUCHED(IRHSINTR) = .TRUE.
           ENDIF
         ENDDO
         NEXTROWTOSEND(MYID_NODES+1)=NEXTROWTOSEND(MYID_NODES+1)+
@@ -434,8 +475,10 @@ C
                 IPOSRHS = int(K-1,8)*int(LRHS_loc,8)
                 Iloc = IRHS_loc_sorted(NEXTROWTOSEND(IPROC_ARG+1)+I-1)
                 BUFR( IPOSBUF + I, IBUF )
-     &                = RHS_loc( IPOSRHS + Iloc ) *
-     &                  scaling_data_dr%SCALING_LOC(Iloc)
+     &                = RHS_loc( IPOSRHS + Iloc )
+#if defined(USE_OLD_SCALING)
+     &                  * scaling_data_dr%SCALING_LOC(Iloc)
+#endif
               ENDDO
             ENDDO
 !$OMP END PARALLEL DO
@@ -475,24 +518,25 @@ C
         END SUBROUTINE SMUMPS_DR_TRY_SEND
         SUBROUTINE SMUMPS_DR_EMPTY_ROWS()
         INTEGER :: K, IFS
-        IF ( NB_FS_TOUCHED .NE. NB_FS_IN_RHSCOMP ) THEN
+        IF ( NB_FS_TOUCHED .NE. NB_FS_IN_RHSINTR ) THEN
 !$        OMP_FLAG = (NRHS_COL .GE. KEEP(362)) .AND.
-!$   &    (NRHS_COL*NB_FS_IN_RHSCOMP >  KEEP(363)/2)
-!$OMP PARALLEL DO FIRSTPRIVATE(NB_FS_IN_RHSCOMP) IF (OMP_FLAG)
+!$   &    (NRHS_COL*NB_FS_IN_RHSINTR >  KEEP(363)/2)
+!$OMP PARALLEL DO FIRSTPRIVATE(NB_FS_IN_RHSINTR)
+!$OMP&    PRIVATE(IFS) IF (OMP_FLAG)
           DO K = 1, NRHS_COL
-            DO IFS = 1, NB_FS_IN_RHSCOMP
+            DO IFS = 1, NB_FS_IN_RHSINTR
               IF ( .NOT. TOUCHED(IFS) ) THEN
-                RHSCOMP( IFS, K) = ZERO
+                RHSINTR( IFS, K) = ZERO
               ENDIF
             ENDDO
-            DO IFS = NB_FS_IN_RHSCOMP +1, LD_RHSCOMP
-              RHSCOMP (IFS, K) = ZERO
+            DO IFS = NB_FS_IN_RHSINTR +1, LD_RHSINTR
+              RHSINTR (IFS, K) = ZERO
             ENDDO
           ENDDO
 !$OMP END PARALLEL DO
         ELSE
 !$        OMP_FLAG = .FALSE.
-!$        CHUNK8 = int(NRHS_COL,8)*int(LD_RHSCOMP-NB_FS_IN_RHSCOMP,8)
+!$        CHUNK8 = int(NRHS_COL,8)*int(LD_RHSINTR-NB_FS_IN_RHSINTR,8)
 !$        CHUNK8 = max(CHUNK8,1_8)
 !$        IF (CHUNK8 .GE. int(KEEP(363),8)) THEN
 !$          OMP_FLAG = .TRUE.
@@ -501,8 +545,8 @@ C
 !$OMP PARALLEL DO COLLAPSE(2) SCHEDULE(STATIC,CHUNK8)
 !$OMP&  IF (OMP_FLAG)
           DO K = 1, NRHS_COL
-            DO IFS = NB_FS_IN_RHSCOMP +1, LD_RHSCOMP
-             RHSCOMP (IFS, K) = ZERO
+            DO IFS = NB_FS_IN_RHSINTR +1, LD_RHSINTR
+             RHSINTR (IFS, K) = ZERO
             ENDDO
           ENDDO
 !$OMP END PARALLEL DO
@@ -532,15 +576,19 @@ C
      &               ( id%MYID .eq. MASTER .AND.
      &                 id%KEEP(46) .eq. 1 ) )
         IF (id%MYID .EQ. MASTER) THEN
-          IF (id%ICNTL(20).EQ.10) THEN
-            ROW_OR_COL_INDICES = 0 
-          ELSE IF (id%ICNTL(20).EQ.11) THEN
-            ROW_OR_COL_INDICES = 1 
-          ELSE 
-            ROW_OR_COL_INDICES = 0 
-          ENDIF
-          IF (id%ICNTL(9) .NE. 1) THEN
-            ROW_OR_COL_INDICES = 1 - ROW_OR_COL_INDICES
+          IF (id%KEEP(50).NE.0) THEN
+            ROW_OR_COL_INDICES = 0
+          ELSE
+            IF (id%ICNTL(20).EQ.10 .OR. id%KEEP(50).EQ.0) THEN
+              ROW_OR_COL_INDICES = 0 
+            ELSE IF (id%ICNTL(20).EQ.11) THEN
+              ROW_OR_COL_INDICES = 1 
+            ELSE 
+              ROW_OR_COL_INDICES = 0 
+            ENDIF
+            IF (id%ICNTL(9) .NE. 1) THEN
+              ROW_OR_COL_INDICES = 1 - ROW_OR_COL_INDICES
+            ENDIF
           ENDIF
           IF (id%KEEP(23).NE.0 .AND. id%ICNTL(9) .NE.1) THEN
             UNS_PERM_TO_BE_DONE = 1
@@ -577,7 +625,8 @@ C
           ELSE
             idIRHS_loc => IDUMMY
           ENDIF
-          CALL MUMPS_BUILD_IRHS_loc(id%MYID_NODES, id%NSLAVES, id%N,
+          CALL MUMPS_GET_INDICES
+     &    (id%MYID_NODES, id%NSLAVES, id%N,
      &    id%PTLUST_S(1), id%KEEP(1), id%KEEP8(1), id%IS(1),
      &    max(1, id%KEEP(32)),
      &    id%STEP(1), id%PROCNODE_STEPS(1), idIRHS_loc(1),
diff -pruN 5.6.2-2.1/src/ssol_distsol.F 5.7.1-1/src/ssol_distsol.F
--- 5.6.2-2.1/src/ssol_distsol.F	1970-01-01 00:00:00.000000000 +0000
+++ 5.7.1-1/src/ssol_distsol.F	2024-05-02 10:15:25.000000000 +0000
@@ -0,0 +1,16 @@
+C
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
+C
+C
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Mumps Technologies, University of Bordeaux.
+C
+C  This version of MUMPS is provided to you free of charge. It is
+C  released under the CeCILL-C license 
+C  (see doc/CeCILL-C_V1-en.txt, doc/CeCILL-C_V1-fr.txt, and
+C  https://cecill.info/licences/Licence_CeCILL-C_V1-en.html)
+C
+      SUBROUTINE SMUMPS_DS_RETURN()
+      RETURN
+      END SUBROUTINE SMUMPS_DS_RETURN
diff -pruN 5.6.2-2.1/src/ssol_driver.F 5.7.1-1/src/ssol_driver.F
--- 5.6.2-2.1/src/ssol_driver.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/ssol_driver.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -25,7 +25,7 @@ C  Performs solution phase (solve), Iter
 C  and Error analysis.
 C
 C
-C
+c
 C
       USE SMUMPS_BUF
       USE SMUMPS_OOC
@@ -34,7 +34,9 @@ C
      &                           , SMUMPS_BLR_MOD_TO_STRUC
       USE MUMPS_FRONT_DATA_MGT_M, only : MUMPS_FDM_STRUC_TO_MOD,
      &                                   MUMPS_FDM_MOD_TO_STRUC
+#if ! defined(NO_SAVE_RESTORE)
       USE SMUMPS_SAVE_RESTORE
+#endif
 !$    USE OMP_LIB
       IMPLICIT NONE
 C     -------------------
@@ -76,8 +78,11 @@ C
       LOGICAL PROK, PROKG, LPOK
       INTEGER MTYPE, ICNTL21
       LOGICAL LSCAL, POSTPros, GIVSOL
-      INTEGER ICNTL10, ICNTL11
-      INTEGER I,IPERM,K,JPERM, J, II, IZ2
+      INTEGER ICNTL10, ICNTL11, ICNTL48_EFF
+      INTEGER I,K,JPERM, J, II, IZ2
+#if defined(USE_OLD_SCALING)
+      INTEGER IPERM
+#endif
       INTEGER IZ, NZ_THIS_BLOCK, PJ
 C     pointers in IS
       INTEGER LIW
@@ -101,6 +106,7 @@ C
       INTEGER NITREF, NOITER, SOLVET, KASE
 C     Meaningful only with tree pruning and sparse RHS
       LOGICAL INTERLEAVE_PAR, DO_PERMUTE_RHS
+      LOGICAL CALL_NODES_FWD_BWD, FIRST_CALL_NODES_FWD_BWD
 C     true if SMUMPS_SOL_C called during postprocessing
       LOGICAL FROM_PP
 C
@@ -125,17 +131,23 @@ C     ----------------------------------
 C
       INTEGER, DIMENSION(:), ALLOCATABLE :: MAP_RHS_loc
       INTEGER, DIMENSION(:), POINTER :: IRHS_loc_PTR
-      LOGICAL :: IRHS_loc_PTR_allocated
+      LOGICAL :: IRHS_loc_PTR_ALLOCATED
+      INTEGER(8) :: SUM_idNloc_RHS_8
       REAL, DIMENSION(:), POINTER :: idRHS_loc
       INTEGER(8) :: DIFF_SOL_loc_RHS_loc
       INTEGER(8) :: RHS_loc_size, RHS_loc_shift
       INTEGER(8)  :: NBT
       INTEGER     :: NBCOL, COLSIZE, JBEG_RHS, JEND_RHS, JBEG_NEW,
-     &               NBCOL_INBLOC, IPOS, IPOSRHSCOMP
+     &               NBCOL_INBLOC, IPOS, IPOSRHSINTR
+C     Nb of pruned NE_STEPS, useful for FWD step; and list of root nodes
+      LOGICAL    :: fill
+      INTEGER, DIMENSION(:), ALLOCATABLE ::  Pruned_Sons_FWD, 
+     &                                       Pruned_Sons_BWD
       INTEGER, DIMENSION(:), ALLOCATABLE :: PERM_RHS
-      INTEGER, DIMENSION(:), POINTER :: PTR_POSINRHSCOMP_FWD,
-     &                                  PTR_POSINRHSCOMP_BWD
+      INTEGER, DIMENSION(:), POINTER :: PTR_POSINRHSINTR_FWD,
+     &                                  PTR_POSINRHSINTR_BWD
       REAL, DIMENSION(:), POINTER :: PTR_RHS
+      INTEGER, DIMENSION(:), POINTER :: idIPTR_WORKING, idWORKING
       INTEGER :: SIZE_IPTR_WORKING, SIZE_WORKING
 C     NRHS_NONEMPTY: holds
 C         either the original number of RHS (id%NRHS defined on host)
@@ -191,11 +203,12 @@ C     arrays only used for distributed m
 C     (KEEP(54) .NE. 0).
       REAL,    ALLOCATABLE, DIMENSION(:) :: R_LOCWK54
       REAL, ALLOCATABLE, DIMENSION(:) :: C_LOCWK54
-      INTEGER   :: NBENT_RHSCOMP, NB_FS_RHSCOMP_F,
-     &             NB_FS_RHSCOMP_TOT
+      INTEGER   :: NBENT_RHSINTR, NB_FS_RHSINTR_F,
+     &             NB_FS_RHSINTR_TOT
       INTEGER, DIMENSION(:), ALLOCATABLE :: UNS_PERM_INV
       LOGICAL :: UNS_PERM_INV_NEEDED_INMAINLOOP,
-     &           UNS_PERM_INV_NEEDED_BEFMAINLOOP
+     &           UNS_PERM_INV_NEEDED_BEFMAINLOOP,
+     &           UNS_PERM_INV_NEEDED_ONSLAVES
       INTEGER LIWK_SOLVE, LIWCB
       INTEGER, ALLOCATABLE :: IW1(:), IWK_SOLVE(:), IWCB(:)
       INTEGER ::  LIWK_PTRACB
@@ -214,7 +227,7 @@ C     SCALING issues:
 C       When scaling was performed
 C       RHS holds the solution of the scaled system
 C       The unscaled second member (b0) was given
-C       then we have to scale both rhs adn solution:
+C       then we have to scale both rhs and solution:
 C        A(sca) = LU  = D1*A*D2 , with D2 = COLSCA
 C                                      D1 = ROWSCA
 C        --------------
@@ -222,33 +235,65 @@ C        CASE OF A X =B
 C        --------------
 C         (ICNTL(9)=1 or MTYPE=1)
 C           A*x0 = b0
-C           b(sca) = D1 * b0 = ROWSCA*S(ISTW3)
+C           b(sca) = D1 * b0 = ROWSCA*b0
 C           A(sca) [(D2) **(-1)] x0 = b(sca)
-C           so the computed solution by Check y0 of LU *y0 = b(sca)
-C           is : y0 =[(D2) **(-1)] x0 and so x0= D2*y0 is modified
+C           so the computed solution of LU * x(sca) = b(sca)
+C           is : x(sca) =[(D2) **(-1)] x0 and so x0= D2*x(sca)
 C        --------------
 C        CASE OF AT X =B
 C        --------------
 C         (ICNTL(9).NE.1 or MTYPE=0)
 C           A(sca) = LU  = D1*A*D2
-C           AT*x0 = b0 => D2ATD1 D1-1 x0 = D2b0
-C           b(sca) = D2 * b0 = COLSCA*S(ISTW3)
+C           AT*x0 = b0 => D2*AT*D1 * D1-1 x0 = D2 * b0
+C           b(sca) = D2 * b0 = COLSCA*b0
 C           A(sca)T [(D1) **(-1)] x0 = b(sca)
-C           so the computed solution by Check y0 of LU *y0 = b(sca)
-C           is : y0 =[(D1) **(-1)] x0 and so x0= D1*y0 is modified
+C           so the computed solution of (LU)^T * x(sca) = b(sca)
+C           is : x(sca) =[(D1) **(-1)] x0 and so x0= D1*y0 is modified
 C
-C      In case of distributed RHS we need
-C      scaling information on each processor
+C     In case of distributed RHS or distributed solution we need
+C     scaling information on each processor and this information has
+C     been stored in ROWSCA_loc(1:INFO(23)) and COLSCA_loc(1:INFO(23))
+C     such that:
+C
+C     ----------------
+C     CASE OF A X  = B
+C     ----------------
+C
+C     - the scaling factor of row i of A is stored on the
+C     processor for which GLOB2LOC_RHS(i) > 0 at position
+C     ROWSCA_loc(GLOB2LOC_RHS(i))
+C     
+C     - the scaling factor of column j of A is stored on the
+C     processor for which GLOB2LOC_SOL(j) > 0 at position
+C     COLSCA_loc(GLOB2LOC_SOL(j))
+C
+C     ------------------
+C     CASE OF A^T X  = B
+C     ------------------
+C
+C     - the scaling factor of row i of A^T is stored on the
+C     processor for which GLOB2LOC_RHS(i) > 0 at position
+C     COLSCA_loc(GLOB2LOC_RHS(i))
+C     
+C     - the scaling factor of column j of A^T is stored on the
+C     processor for which GLOB2LOC_SOL(j) > 0 at position
+C     ROWSCA_loc(GLOB2LOC_SOL(j))
 C
+#if defined(USE_OLD_SCALING)
           type scaling_data_t
             SEQUENCE
-            REAL, dimension(:), pointer :: SCALING
-            REAL, dimension(:), pointer :: SCALING_LOC
+            REAL   , dimension(:), pointer :: SCALING
+            REAL   , dimension(:), pointer :: SCALING_LOC
+            INTEGER, dimension(:), pointer :: SCALING_IND
           end type scaling_data_t
-          type (scaling_data_t) :: scaling_data_sol, scaling_data_dr
-C      To scale on the fly during GATHER SOLUTION
+          type (scaling_data_t) :: scaling_data_dr
+          type (scaling_data_t) :: scaling_data_sol
+C      To scale on the fly during GATHER SOLUTION:
           REAL, DIMENSION(:), POINTER :: PT_SCALING
           REAL, TARGET                :: Dummy_SCAL(1)
+#else
+          INTEGER :: ROWORCOL
+#endif
 C
 C  ==================== END OF SCALING related data ================
 C
@@ -273,8 +318,8 @@ C     Interval associated to the subbloc
      &        MASTER_ROOT, MASTER_ROOT_IN_COMM
       INTEGER SIZE_ROOT, LD_REDRHS
       INTEGER(8) :: IPT_RHS_ROOT
-      INTEGER(8) :: IBEG, IBEG_RHSCOMP, KDEC, IBEG_loc, IBEG_REDRHS
-      INTEGER LD_RHSCOMP, NCOL_RHS_loc
+      INTEGER(8) :: IBEG, IBEG_RHSINTR, KDEC, IBEG_loc, IBEG_REDRHS
+      INTEGER NCOL_RHS_loc
       INTEGER LD_RHS_loc, JBEG_RHS_loc
       INTEGER NB_K133, IRANK, TSIZE
       INTEGER KMAX_246_247
@@ -292,8 +337,25 @@ C  Vampir
       INTEGER soln_drive_class, glob_comm_ini, perm_scal_ini, soln_dist,
      &        soln_assem, perm_scal_post
 #endif
-      LOGICAL I_AM_SLAVE, BUILD_POSINRHSCOMP
+      LOGICAL I_AM_SLAVE, BUILD_POSINRHSINTR
       LOGICAL :: BUILD_RHSMAPINFO
+      REAL, TARGET :: RDUMMY_TARGET(1)
+      LOGICAL :: ES_RHSINTR
+      INTEGER, DIMENSION(:), POINTER :: nodes_FWD, nodes_BWD
+C     to manage sparsity: compute target nodes for starting chains
+C     Lnodes_FWD/Lnodes_BWD = -1 => all nodes to be processed
+      INTEGER, DIMENSION(:), POINTER :: nodes_FWD_PTR, nodes_BWD_PTR
+      INTEGER :: Lnodes_FWD, Lnodes_BWD, Lnodes_FWD_PTR, Lnodes_BWD_PTR
+      REAL, POINTER, DIMENSION(:) :: SCALING_loc_FWD
+      REAL, POINTER, DIMENSION(:) :: SCALING_loc_BWD
+      REAL, POINTER, DIMENSION(:) :: SCALING_RHSINTR_BWD
+      REAL, POINTER, DIMENSION(:) :: SCALING_RHSINTR_FWD
+      INTEGER :: LSCALING_RHSINTR_BWD, LSCALING_RHSINTR_FWD
+      LOGICAL :: SCALING_RHSINTR_BWD_ALLOCATED,
+     &           SCALING_RHSINTR_FWD_ALLOCATED,
+     &           BUILD_SCALING_RHSINTR
+C    NSOL_loc will be equal to KEEP(89) in case ICNTL(21)=1
+      INTEGER :: NSOL_loc
       LOGICAL WORK_WCB_ALLOCATED, IS_INIT_OOC_DONE
       LOGICAL :: IS_LR_MOD_TO_STRUC_DONE
       INTEGER :: KEEP350_SAVE
@@ -303,7 +365,6 @@ C  Vampir
       INTEGER  MAT_ALLOC_LOC, MAT_ALLOC
       INTEGER MUMPS_PROCNODE
       EXTERNAL MUMPS_PROCNODE
-      INTEGER(8) :: FILE_SIZE,STRUC_SIZE
 C
 C  First executable statement
 C
@@ -318,9 +379,25 @@ C
       CALL VTFUNCDEF( 'perm_scal_post',soln_drive_class,
      &     perm_scal_post,IERR)
 #endif
+C     Depending on the type of parallelism,
+C     the master can have the role of a slave
+      I_AM_SLAVE = ( id%MYID .ne. MASTER  .OR.
+     &             ( id%MYID .eq. MASTER .AND.
+     &               id%KEEP(46) .eq. 1 ) )
 C     -- The following pointers xxCOPY might be allocated but then
 C     -- the associated xxCOPY_ALLOCATED will be set to
 C     -- enable deallocation
+      SCALING_RHSINTR_FWD_ALLOCATED = .FALSE.
+      SCALING_RHSINTR_BWD_ALLOCATED = .FALSE.
+C     Initialize scalings to possilby pass them as arguments
+C     (e.g. to SMUMPS_DS_ALL2ALL) even on non working host
+C     and/or when LSCAL is false
+      SCALING_RHSINTR_FWD => RDUMMY_TARGET
+      SCALING_RHSINTR_BWD => RDUMMY_TARGET
+      LSCALING_RHSINTR_FWD = 1
+      LSCALING_RHSINTR_BWD = 1
+      SCALING_LOC_FWD => RDUMMY_TARGET
+      SCALING_LOC_BWD => RDUMMY_TARGET
       IRHS_PTR_COPY => IDUMMY_TARGET
       IRHS_PTR_COPY_ALLOCATED = .FALSE.
       IRHS_SPARSE_COPY => IDUMMY_TARGET
@@ -329,10 +406,16 @@ C     -- enable deallocation
       RHS_SPARSE_COPY_ALLOCATED=.FALSE.
       NULLIFY(RHS_IR)
       NULLIFY(WORK_WCB)
+#if defined(USE_OLD_SCALING)
       NULLIFY(scaling_data_dr%SCALING)
       NULLIFY(scaling_data_dr%SCALING_LOC)
+      NULLIFY(scaling_data_dr%SCALING_IND)
       NULLIFY(scaling_data_sol%SCALING)
       NULLIFY(scaling_data_sol%SCALING_LOC)
+      NULLIFY(scaling_data_sol%SCALING_IND)
+#endif
+      NULLIFY(nodes_FWD)
+      NULLIFY(nodes_BWD)
       IRHS_loc_PTR_allocated = .FALSE.
       IS_INIT_OOC_DONE   = .FALSE.
       IS_LR_MOD_TO_STRUC_DONE = .FALSE.
@@ -344,9 +427,6 @@ C     -- enable deallocation
       IS   =>id%IS
       ICNTL=>id%ICNTL
       INFO =>id%INFO
-C      ASPK =>id%A
-C      COLSCA =>id%COLSCA
-C      ROWSCA =>id%ROWSCA
       RINFOG =>id%RINFOG
       LP  = ICNTL( 1 )
       MP  = ICNTL( 2 )
@@ -366,7 +446,7 @@ C      ROWSCA =>id%ROWSCA
       K34_8    = int(KEEP(34), 8)
       K35_8    = int(KEEP(35), 8)
       K16_8    = int(KEEP(16), 8)
-      NBENT_RHSCOMP = 0
+      NBENT_RHSINTR = 0
 C     Used by DISTRIBUTED_SOLUTION to skip empty columns
 C     that are skipped (case of sparse RHS)
       NB_RHSSKIPPED = 0
@@ -375,47 +455,48 @@ C     to free space allocated
       LSCAL              = .FALSE.
       WORK_WCB_ALLOCATED = .FALSE.
       ICNTL21  = -99998  ! will be bcasted later to slaves
-      IBEG_RHSCOMP =-152525_8  ! Should not be used
-      BUILD_POSINRHSCOMP = .TRUE.
+      IBEG_RHSINTR =-152525_8  ! Should not be used
+      BUILD_POSINRHSINTR      = .TRUE.
+C     NSOL_loc, KEEP(212) will be set if ICNTL(21).EQ.2
+      NSOL_loc = 0
+      KEEP(212)= 0
+C     SCALING_RHSINTR was initialized to a dummy array of size 1
+C     on the non working host, no need to reset it at each block
+      BUILD_SCALING_RHSINTR = I_AM_SLAVE
       IBEG_GLOB_DEF = -9888  ! unitialized state
       IEND_GLOB_DEF = -9888  ! unitialized state
       IBEG_ROOT_DEF = -9777  ! unitialized state
       IEND_ROOT_DEF = -9777  ! unitialized state
       IROOT_DEF_RHS_COL1 = -9666 ! unitialized state
-C     Not needed anymore (since new version of gather)
-C     LD_RHSCOMP = max(KEEP(89),1)  ! at the nb of pivots eliminated on
-                                    ! that proc
-      LD_RHSCOMP = 1
-      NB_FS_RHSCOMP_TOT = KEEP(89)
+C     ------------------------------
+C     id%LD_RHSINTR will be set each
+C     time RHSINTR is allocated
+C     ------------------------------
+      NB_FS_RHSINTR_TOT = KEEP(89)
 !     number of FS var of the pruned tree
 !     mapped on this proc
-      NB_FS_RHSCOMP_F = NB_FS_RHSCOMP_TOT
+      NB_FS_RHSINTR_F = NB_FS_RHSINTR_TOT
 C     Save value of KEEP(350), in case of LR solve
 C     KEEP(350) may be overwritten and restored
 C     Old unoptimized version before 5.0.2 not available anymore
       IF (KEEP(350).LE.0) KEEP(350)=1
       IF (KEEP(350).GT.2) KEEP(350)=1
       KEEP350_SAVE = KEEP(350)
-C
-C     Depending on the type of parallelism,
-C     the master can have the role of a slave
-      I_AM_SLAVE = ( id%MYID .ne. MASTER  .OR.
-     &             ( id%MYID .eq. MASTER .AND.
-     &               KEEP(46) .eq. 1 ) )
 C     
 C     Compute the number of integers and nb of reals in the structure
       CALL SMUMPS_SIZE_IN_STRUCT (id, NB_INT, NB_CMPLX, NB_CHAR)
       NB_BYTES = NB_BYTES + NB_INT * K34_8 + NB_CMPLX * K35_8 + NB_CHAR
       NB_BYTES_ON_ENTRY = NB_BYTES !used to check alloc/dealloc count ok
-      CALL SMUMPS_COMPUTE_MEMORY_SAVE(id,FILE_SIZE,STRUC_SIZE)
       NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
 C     ======================================
 C     BEGIN CHECK KEEP ENTRIES AND INTERFACE
 C     ======================================
       IF (id%MYID .EQ. MASTER) THEN
 C     {
-c     subroutine only because called at facto and solve
-          CALL SMUMPS_SET_K221(id)
+C         Set ICNTL(26) -> KEEP(221)  (called at facto and solve)
+C         (might be called at facto in case of fwd in facto 
+C          with Schur+reduced RHS requested)
+          CALL SMUMPS_SET_K221(id, .TRUE.)
           id%KEEP(111) = id%ICNTL(25)
 C         For the case of ICNTL(20)=1 one could
 C         switch off exploit sparsity when RHS is too dense.
@@ -430,8 +511,12 @@ C         switch off exploit sparsity wh
           ELSE
             id%KEEP(248) = 0 !dense RHS
           ENDIF
+C
+C         set ICNTL21 and test for out-of range entries
           ICNTL21      = id%ICNTL(21)
-          IF (ICNTL21 .ne.0.and.ICNTL21.ne.1) ICNTL21=0
+          IF ( ICNTL21.NE.0 .AND. ICNTL21.NE.1
+     &       ) ICNTL21 = 0
+C
           IF ( id%ICNTL(30) .NE.0 ) THEN
 C           A-1 is on
             id%KEEP(237) = 1
@@ -445,25 +530,81 @@ C            Force KEEP(248) accordingly
              id%KEEP(248)=1
           ENDIF
           IF ((id%KEEP(221).EQ.2 ).AND.(id%KEEP(248).NE.0) ) THEN
-C          -- input RHS is indeed stored in REDRHS and RHSCOMP
-           id%KEEP(248) = 0
+           IF (KEEP(60).NE.0) THEN
+C            -- input RHS is stored in REDRHS and RHSINTR
+             id%KEEP(248) = 0
+           ENDIF
           ENDIF
+C}
+      ENDIF
+C     =============================================================
+C     KEEP(248) and KEEP(221): need be broadcasted
+C     before continuing other checking/settings
+      CALL MPI_BCAST( id%KEEP(221), 1, MPI_INTEGER, MASTER, id%COMM,
+     &                  IERR )
+      CALL MPI_BCAST( id%KEEP(248), 1, MPI_INTEGER, MASTER, id%COMM,
+     &                  IERR )
+      IF (KEEP(248).EQ.-1
+     &  ) THEN
+C{
+        CALL SMUMPS_CHECK_DISTRHS(
+     &       id%Nloc_RHS,
+     &       id%LRHS_loc,
+     &       id%NRHS,
+     &       id%IRHS_loc,
+     &       id%RHS_loc,
+     &       I_AM_SLAVE,
+     &       id%INFO)
+        CALL MUMPS_PROPINFO( id%ICNTL(1),
+     &                      id%INFO(1),
+     &                      id%COMM, id%MYID )
+        IF ( id%INFO(1) .LT. 0 ) GO TO 90
+C         Compute sum of id%Nloc_RHS (without out-of-range)
+C         and store it in SUM_idNloc_RHS_8
+C         (to be used to decide whether exploit sparsity 
+C         is exploited)
+          CALL SMUMPS_ES_GET_SUM_Nloc ( 
+     &             id%N, id%Nloc_RHS, id%IRHS_loc, id%COMM,
+     &             SUM_idNloc_RHS_8 )
+C}
+      ENDIF
+C     ===========================================================
+      IF (id%MYID .EQ. MASTER) THEN
+C     {
           IF ((id%KEEP(221).EQ.2 ).AND.(id%KEEP(235).NE.0) ) THEN
 C          -- input RHS is in fact effectively
-C          -- stored in REDRHS and RHSCOMP
-           id%KEEP(235) = 0
+C          -- stored in REDRHS and/or RHSINTR
+C          (for both Schur and bwd only)
+            id%KEEP(235) = 0
           ENDIF
           IF ( (id%KEEP(248).EQ.0).AND.(id%KEEP(111).EQ.0) ) THEN
 C           RHS is not sparse and thus exploit sparsity is reset to 0
             id%KEEP(235) = 0
           ENDIF
-          IF (KEEP(248) .EQ. -1) THEN
-C           V0 distributed RHS: no ES
-            id%KEEP(235) = 0
+          IF (id%KEEP(248) .EQ. -1
+     &       ) THEN
+            IF (id%KEEP(126).EQ.0)  THEN
+             id%KEEP(235) = 0
+            ELSE IF (id%KEEP(126).EQ.-1)  THEN
+             id%KEEP(235) = 1
+            ELSE IF (id%KEEP(126).GT.0) THEN
+             IF ( SUM_idNloc_RHS_8 .LE. 
+     &        int( 
+     &          (real(id%KEEP(126))/real(1000))*real(id%N)
+     &          , 8)
+     &          ) THEN
+               id%KEEP(235) = 1
+             ELSE
+               id%KEEP(235) = 0
+             ENDIF
+            ELSE
+             id%KEEP(235) = 0
+            ENDIF
           ENDIF
 C         Case of Automatic setting of exploit sparsity (KEEP(235)=-1)
 C         (in MUMPS_DRIVER original value of KEEP(235) is reset)
           IF(id%KEEP(111).NE.0) id%KEEP(235)=0
+          IF(id%KEEP(111).NE.0) id%KEEP(212)=0
 C
           IF (id%KEEP(235).EQ.-1) THEN
             IF (id%KEEP(237).NE.0) THEN
@@ -476,8 +617,10 @@ C            for A-1
             id%KEEP(235)=1
           ENDIF
 C         Setting of KEEP(242) (permute RHS)
-          IF ((KEEP(111).NE.0)) THEN
-C          In the context of null space, the null pivots
+          IF ((KEEP(111).NE.0).OR.(KEEP(248) .EQ. -1)) THEN
+C          In the context of 
+C          - distributed RHS, all columns share the same structure
+C          - null space, the null pivots
 C          are by default permuted to post-order
 C          However for null space there is in this case no need to
 C          permute null pivots since they are already in correct order.
@@ -520,8 +663,8 @@ C           Automatic setting of permute
             ENDIF
 C           }
           ENDIF
-          IF ( (id%KEEP(221).EQ.1 ).AND.(id%KEEP(235).NE.0) ) THEN
-C          -- Do not permute RHS with REDRHS for the time being
+          IF ( id%KEEP(221).NE.0 ) THEN
+C          -- Do not permute RHS with REDRHS/RHSINTR 
             id%KEEP(242) = 0
           ENDIF
           IF (KEEP(242).EQ.0) KEEP(243)=0 ! interleave off
@@ -575,24 +718,31 @@ C
           ENDIF
 C     }
       ENDIF
+      id%KEEP(401) = 0
+      IF (id%ICNTL(48).EQ.1) id%KEEP(401)=1
 C     Bcast id%KEEP(401) strategy (which
 C     may be switched off or on during solve)
       CALL MPI_BCAST( id%KEEP(401), 1, MPI_INTEGER, MASTER, id%COMM,
      &                  IERR )
+C     define ICNTL48_EFF on master
+      IF (id%MYID.EQ.MASTER) THEN
+        IF ( (id%KEEP(401).EQ.1). AND. (id%KEEP(400).GT.0) ) THEN
+          ICNTL48_EFF = 1
+        ELSE
+          ICNTL48_EFF = 0
+        ENDIF
+      ENDIF
       CALL MPI_BCAST(MTYPE,1,MPI_INTEGER,MASTER,
      &               id%COMM,IERR)
       CALL MPI_BCAST( id%KEEP(111), 1, MPI_INTEGER, MASTER, id%COMM,
      &                  IERR )
-      CALL MPI_BCAST( id%KEEP(221), 1, MPI_INTEGER, MASTER, id%COMM,
-     &                  IERR )
       CALL MPI_BCAST( id%KEEP(235), 1, MPI_INTEGER, MASTER, id%COMM,
      &                  IERR )
       CALL MPI_BCAST( id%KEEP(237), 1, MPI_INTEGER, MASTER, id%COMM,
      &                  IERR )
       CALL MPI_BCAST( id%KEEP(242), 2, MPI_INTEGER, MASTER, id%COMM,
      &                  IERR )
-      CALL MPI_BCAST( id%KEEP(248), 1, MPI_INTEGER, MASTER, id%COMM,
-     &                  IERR )
+C Allready done   CALL MPI_BCAST( id%KEEP(248), ...)
       CALL MPI_BCAST( id%KEEP(350), 1, MPI_INTEGER, MASTER, id%COMM,
      &                  IERR )
       CALL MPI_BCAST( id%KEEP(485), 1, MPI_INTEGER, MASTER, id%COMM,
@@ -700,7 +850,7 @@ C            Fwd in facto is not compati
              INFO(2) = 9
              IF (LPOK) THEN
                 WRITE(LP,'(A)')
-     &               ' ERROR: Transpose system (ICNTL(9).NE.0) not ',
+     &               ' ERROR: Transpose system (ICNTL(9).NE.1) not ',
      &               ' compatible with forward performed during',
      &               ' factorization (ICNTL(32)=1)'
              ENDIF
@@ -773,27 +923,30 @@ C            Sparse RHS may be due to A-
           ENDIF
 C         Entries of A-1 are stored in place of the input sparse RHS
 C         thus no need for RHS to be allocated.
-          IF ( (id%KEEP(237).EQ.0) ) THEN
+          IF (id%KEEP(237).EQ.0)  THEN
              IF ((id%KEEP(248) == 0 .AND.KEEP(221).NE.2)
-     &            .OR. ICNTL21==0) THEN
-C              RHS must be of size N on the master either to
+     &            .OR. 
+     &            (ICNTL21==0.AND.(KEEP(221).NE.1)) 
+     &          )THEN
+C              RHS must be of size N*NRHS on the master either to
 C              store the dense centralized RHS, either to store
 C              the dense centralized solution.
-               CALL SMUMPS_CHECK_DENSE_RHS
-     &         (id%RHS,id%INFO,id%N,id%NRHS,id%LRHS)
-               IF (id%INFO(1) .LT. 0) GOTO 333
+                CALL SMUMPS_CHECK_DENSE_RHS
+     &          (id%RHS,id%INFO,id%N,id%NRHS,id%LRHS)
+                IF (id%INFO(1) .LT. 0) GOTO 333
              ENDIF
           ELSE
-C           Check that the constraint NRHS=N is respected
+C           AM1: check that the constraint NRHS=N is respected
 C           Check for valid sparse RHS structure done
             IF (id%NRHS .NE. id%N) THEN
-              id%INFO(1)=-47
+              id%INFO(1)= -47
               id%INFO(2)=id%NRHS
               GOTO 333
             ENDIF
           ENDIF
-          IF (id%KEEP(248) == 1) THEN
-C           ------------------------------------
+          IF (id%KEEP(248) == 1
+     &       ) THEN
+C{          ------------------------------------
 C           RHS_SPARSE, IRHS_SPARSE and IRHS_PTR
 C           must be allocated of adequate size
 C           ------------------------------------
@@ -866,6 +1019,7 @@ C             Possible in case of duppli
               id%INFO(2)=10
               GOTO 333
             END IF
+C}
           ENDIF
 C         --------------------------------
 C         Set null space options for solve
@@ -879,16 +1033,20 @@ C
 C     --------------------------------------
 C     Check distributed solution vectors
 C     --------------------------------------
-      IF (ICNTL21==1) THEN
-          IF ( I_AM_SLAVE ) THEN
+      IF (ICNTL21 .NE. 0 ) THEN 
+          IF (I_AM_SLAVE) THEN
+            NSOL_loc = id%KEEP(89)
+          ELSE
+            NSOL_loc = 0
+          ENDIF
 C           (I)SOL_loc should be allocated to hold the
 C           distributed solution on exit
-            IF ( id%LSOL_loc < id%KEEP(89) ) THEN
+            IF ( id%LSOL_loc .LT. NSOL_loc ) THEN
               id%INFO(1)= -29
               id%INFO(2)= id%LSOL_loc
               GOTO 333
             ENDIF
-            IF (id%KEEP(89) .NE. 0) THEN
+            IF ( NSOL_loc .GT. 0 ) THEN
               IF ( .not. associated(id%ISOL_loc) )THEN
                 id%INFO(1)=-22
                 id%INFO(2)=13
@@ -899,7 +1057,7 @@ C           distributed solution on exit
                 id%INFO(2)=14
                 GOTO 333
               ENDIF
-              IF (size(id%ISOL_loc) < id%KEEP(89) ) THEN
+              IF (size(id%ISOL_loc) < NSOL_loc ) THEN
                 id%INFO(1)=-22
                 id%INFO(2)=13
                 GOTO 333
@@ -913,7 +1071,7 @@ C             can result in such a situa
 C             suppressed if needed but might be still be ok in case
 C             the right-hand side overflows too.
               IF (size(id%SOL_loc) <
-     &              (id%NRHS-1)*id%LSOL_loc+id%KEEP(89)) THEN
+     &              (id%NRHS-1)*id%LSOL_loc+NSOL_loc) THEN
                 id%INFO(1)=-22
                 id%INFO(2)=14
                 GOTO 333
@@ -921,17 +1079,17 @@ C             the right-hand side overfl
 #             else
               IF (size(id%SOL_loc,kind=8) <
      &              int(id%NRHS-1,8)*int(id%LSOL_loc,8)+
-     &              int(id%KEEP(89),8)) THEN
+     &              int(NSOL_loc,8)) THEN
                 id%INFO(1)=-22
                 id%INFO(2)=14
                 GOTO 333
               END IF
 #             endif
-            ENDIF
-          ENDIF
-      ENDIF
+            ENDIF ! NSOL_loc > 0
+      ENDIF ! ICNTL21 .NE. 0
       IF (id%MYID .NE. MASTER) THEN
-          IF (id%KEEP(248) == 1) THEN
+          IF (id%KEEP(248) == 1
+     &    ) THEN
 C          RHS should NOT be associated
 C          if I am not master since it is
 C          not even used to store the solution
@@ -957,16 +1115,6 @@ C          not even used to store the so
            END IF
           END IF
       ENDIF
-      IF (I_AM_SLAVE .AND. id%KEEP(248).EQ.-1) THEN
-        CALL SMUMPS_CHECK_DISTRHS(
-     &       id%Nloc_RHS,
-     &       id%LRHS_loc,
-     &       id%NRHS,
-     &       id%IRHS_loc,
-     &       id%RHS_loc,
-     &       id%INFO)
-        IF (id%INFO(1) .LT. 0) GOTO 333
-      ENDIF
 C     Prepare pointers to pass POINTERS(1) to
 C     routines with implicit interfaces which
 C     will then assume contiguous information
@@ -993,11 +1141,17 @@ C         so that IRHS_loc_PTR(1) is ok
       ELSE
         idRHS_loc=>CDUMMY_TARGET
       ENDIF
-      IF (I_AM_SLAVE .AND. ICNTL21.EQ.1 .AND.
-     &    KEEP(248) .EQ. -1) THEN  ! Dist RHS and dist solution
+C
+C
+C     Check as soon as solution is distributed
+      IF (I_AM_SLAVE .AND. ICNTL21.NE.0 .AND.
+     &    KEEP(248) .EQ. -1
+     &    ) THEN  ! Dist RHS and dist solution
+C
         IF (associated(id%RHS_loc) .AND.
      &      associated(id%SOL_loc)) THEN
-          IF (id%KEEP(89).GT.0) THEN
+C         NSOL_loc was defined earlier
+          IF (NSOL_loc.GT.0) THEN
 C           ----------------------------------------------------
 C           Check if RHS_loc and SOL_loc point to same object...
 C           id%SOL_loc(1) ok otherwise an error -22/14
@@ -1024,13 +1178,14 @@ C              we raise the error system
      &" ** Error RHS_loc and SOL_loc pointers match but LRHS_loc="
      &,id%LRHS_loc, " and LSOL_loc=", id%LSOL_loc
                ENDIF
+               GOTO 333
             ENDIF
           ENDIF
         ENDIF
       ENDIF
       IF (id%MYID.EQ.MASTER) THEN
-C         Do some checks (REDRHS), depending on KEEP(221)
-          CALL SMUMPS_CHECK_REDRHS(id)
+C         Do some checks on KEEP(221) and REDRHS (in case of Schur)
+          CALL SMUMPS_CHECK_K221andREDRHS(id)
       END IF ! MYID.EQ.MASTER
       IF (id%INFO(1) .LT. 0) GOTO 333
 C     -------------------------
@@ -1044,16 +1199,28 @@ C     -------------------------
 C     ====================================
 C     END CHECK INTERFACE AND KEEP ENTRIES
 C     ====================================
-C     ====================================
-C     Process case of NZ_RHS = 0  with
-C     sparse RHS and General Sparse (NOT A-1)
 C     -----------------------------------
       IF ((id%KEEP(248).EQ.1).AND.(id%KEEP(237).EQ.0)) THEN
-C
        CALL MPI_BCAST(id%NZ_RHS,1,MPI_INTEGER,MASTER,
      &               id%COMM,IERR)
+      ENDIF
 C
-       IF (id%NZ_RHS.EQ.0) THEN
+C     =======================================================
+C     BEGIN Test for empty RHS :
+C     sparse RHS and General Sparse (NOT A-1) and  NZ_RHS = 0
+C     OR
+C     Distributed RHS and sum of id%Nloc_RHS 
+C     (without off out-of-range) equal to 0
+C     =======================================================
+      IF 
+     & (
+     &     ( (id%KEEP(248).EQ.1).AND.(id%KEEP(237).EQ.0)
+     &       .AND. (id%NZ_RHS.EQ.0) ) 
+     &     .OR.
+     &     ( (id%KEEP(248).EQ.-1).AND. (SUM_idNloc_RHS_8.EQ.0_8)
+     &     ) 
+     & )  THEN
+C{      
 C       We reset solution to zero and we return
 C       (first freeing working space at label 90)
         IF ((ICNTL21.EQ.1).AND.(I_AM_SLAVE)) THEN
@@ -1073,38 +1240,46 @@ C         Note that LSOL_loc >= KEEP(89)
      &               id%KEEP(1),id%KEEP8(1),
      &               id%IS(1), LIW_PASSED,id%MYID_NODES,
      &               id%N, id%STEP(1), id%PROCNODE_STEPS(1),
-     &               id%NSLAVES, scaling_data_sol, LSCAL
+     &               id%NSLAVES,
+#if defined(USE_OLD_SCALING)
+     &               scaling_data_sol, .FALSE., ! empty RHS, no scaling
+#endif
 C                    For checking only
-     &               , .FALSE., IDUMMY(1), 1
+     &               .FALSE., IDUMMY(1), 1
      &               )
+          ENDIF
+        ENDIF
+C       Solution is null
+        IF (ICNTL21.NE.0) THEN  ! distributed solution
             DO J=1, id%NRHS
-              DO I=1, KEEP(89)
-                id%SOL_loc((J-1)*id%LSOL_loc + I) =ZERO
+C             (NSOL_loc=KEEP(89) or id%NSOL_loc, and in case
+C              ICNTL21=1, NSOL_loc is 0 on non-working host)
+              DO I=1, NSOL_loc
+                id%SOL_loc(int(J-1,8)*id%LSOL_loc + I) =ZERO
               ENDDO
             ENDDO
-          ENDIF
         ENDIF
-        IF (ICNTL21.NE.1) THEN  ! centralized solution
+        IF (ICNTL21.EQ.0) THEN  ! centralized solution
 C       ----------------------------
 C       RHS reset to zero on master
 C       ----------------------------
-         IF (id%MYID.EQ.MASTER) THEN
+          IF (id%MYID.EQ.MASTER) THEN
             DO J=1, id%NRHS
               DO I=1, id%N
                 id%RHS(int(J-1,8)*int(id%LRHS,8) + int(I,8)) =ZERO
               ENDDO
             ENDDO
-         ENDIF
+          ENDIF
         ENDIF
 C
 C       print solve phase stats if requested
         IF ( PROKG )  THEN
-C          write(6,*) " NZ_RHS is zero "
-           WRITE( MPG, 150 )
+            WRITE( MPG, 150 )
 C             ICNTL(35) should not been accessed during SOLVE thus
 C             print KEEP(486) value set during factorization
      &        id%NRHS, ICNTL(27), ICNTL(9), ICNTL(10), ICNTL(11),
-     &        ICNTL(20), ICNTL(21), ICNTL(30), KEEP(486)
+     &        ICNTL(20), ICNTL(21), ICNTL(30), KEEP(486), 
+     &        ICNTL48_EFF
            IF (KEEP(221).NE.0) THEN
             WRITE (MPG, 152) KEEP(221)
            ENDIF
@@ -1115,16 +1290,28 @@ C             print KEEP(486) value set
 C
 C       --------
         GOTO 90 ! end of solve deallocate what is needed
-C       ====================================
-C       END CHECK INTERFACE AND KEEP ENTRIES
-C       ====================================
-       ENDIF  ! test NZ_RHS.EQ.0
-C      --------
-      ENDIF ! (id%KEEP(248).EQ.1).AND.(id%KEEP(237).EQ.0)
+C}
+      ENDIF  ! test empty RHS (general sparse or Distributed)
+C     =======================================================
+C     END of Test for empty RHS :
+C     =======================================================
+C     ====================================
+C     END CHECK INTERFACE AND KEEP ENTRIES
+C     ====================================
       INTERLEAVE_PAR   =.FALSE.
       DO_PERMUTE_RHS   =.FALSE.
+      CALL_NODES_FWD_BWD       = .FALSE.
+      FIRST_CALL_NODES_FWD_BWD = .FALSE.
+C     Default is no sparsity exploited
+      nodes_FWD_PTR => IDUMMY_TARGET
+      nodes_BWD_PTR => IDUMMY_TARGET
+      Lnodes_FWD = -1
+      Lnodes_BWD = -1
 C
-      IF ((id%KEEP(235).NE.0).or.(id%KEEP(237).NE.0)) THEN
+      IF ((id%KEEP(235).NE.0).or.(id%KEEP(237).NE.0) 
+     &   ) THEN
+         CALL_NODES_FWD_BWD       = .TRUE.
+         FIRST_CALL_NODES_FWD_BWD = .TRUE.
 C        Case of pruned elimination tree or selected entries in A-1
          IF (id%KEEP(237).NE.0.AND.
      &        id%KEEP(248).EQ.0) THEN
@@ -1137,7 +1324,8 @@ C         sparse RHS has been forced to
           ENDIF
           CALL MUMPS_ABORT()
          ENDIF
-C        NBT is inout in MUMPS_REALLOC and should be initialized.
+C        NBT (in Bytes) is inout in MUMPS_REALLOC and 
+C                       should be initialized.
          NBT = 0
 C        -- Allocate Step2node on each proc
          CALL MUMPS_REALLOC(id%Step2node, id%KEEP(28), id%INFO, LP,
@@ -1161,26 +1349,37 @@ C          we reuse Step2node computed i
 C          Step2node is deallocated each time a new analysis is
 C          performed or when job=-2 is called
          ENDIF
-         NB_BYTES = NB_BYTES + NBT*K34_8
+C        --- NBT is the nb of extra bytes allocated
+         NB_BYTES = NB_BYTES + NBT
          NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
-         NB_BYTES_EXTRA = NB_BYTES_EXTRA + NBT * K34_8
+         NB_BYTES_EXTRA = NB_BYTES_EXTRA + NBT 
 C        Mapping information used during solve. In case of several
 C        facto+solve it has to be recomputed.
 C        In case of several solves with the same
 C        facto, it is not recomputed.
-C        It used to compute the interleaving
+C        It is used to compute the interleaving
 C        for A-1, and, in dev_version, passed to sol_c to compute
 C        some stats
          IF((KEEP(235).NE.0).OR.(KEEP(237).NE.0)) THEN
            IF(.NOT.associated(id%IPTR_WORKING)) THEN
              CALL SMUMPS_BUILD_MAPPING_INFO(id)
            END IF
+           idIPTR_WORKING => id%IPTR_WORKING
+           idWORKING => id%WORKING
+         ELSE 
+C           case of selected entries in solution
+C           with no ES during fwd
+            SIZE_WORKING = 1
+            SIZE_IPTR_WORKING = 1
+            idIPTR_WORKING => IDUMMY_TARGET
+            idWORKING => IDUMMY_TARGET
          END IF
       ENDIF
 C
 C     Initialize SIZE_OF_BLOCK from MUMPS_SOL_ES module
-      IF ( I_AM_SLAVE )
-     &  CALL SMUMPS_SOL_ES_INIT(id%OOC_SIZE_OF_BLOCK, id%KEEP(201))
+      IF ( I_AM_SLAVE ) THEN
+        CALL SMUMPS_SOL_ES_INIT(id%OOC_SIZE_OF_BLOCK, id%KEEP(201))
+      ENDIF
       DO_NULL_PIV = .TRUE.
       NBCOL_INBLOC = -9998
       NZ_THIS_BLOCK= -9998
@@ -1188,7 +1387,7 @@ C     Initialize SIZE_OF_BLOCK from MUMP
 c
       IF (id%MYID.EQ.MASTER) THEN ! Compute NRHS_NONEMPTY
 C
-C       -- Sparse RHS does
+C       -- Sparse RHS (general, centralized)
         IF ( KEEP(111)==0 .AND. KEEP(248)==1
      &   ) THEN
 C       -- Note that KEEP(111).NE.0 (null space on)
@@ -1196,8 +1395,9 @@ C       -- and KEEP(248).NE.0 will be ma
 C       -- When computing entries of A-1 (or SparseRHS only)
            NRHS_NONEMPTY = 0
            DO I=1, id%NRHS
-              IF (id%IRHS_PTR(I).LT.id%IRHS_PTR(I+1))
-     &             NRHS_NONEMPTY = NRHS_NONEMPTY+1 !ith col in non empty
+              IF (id%IRHS_PTR(I).LT.id%IRHS_PTR(I+1)) THEN
+                   NRHS_NONEMPTY = NRHS_NONEMPTY+1 !ith col in non empty
+              ENDIF
            ENDDO
            IF (NRHS_NONEMPTY.LE.0) THEN
 C           Internal error: tested before in mumps_driver
@@ -1247,6 +1447,7 @@ C     We work on a maximum of NBRHS at a
 C     The leading dimension of RHS is id%LRHS on the host process
 C     and it is set to N on slave processes.
       IF (id%MYID .eq. MASTER) THEN
+C{
         KEEP(84) = ICNTL(27)
 C     Treating ICNTL(27)=0 as if ICNTL(27)=1
         IF(ICNTL(27).EQ.0) KEEP(84)=1
@@ -1262,11 +1463,12 @@ C     Treating ICNTL(27)=0 as if ICNTL(2
           IF (NBRHS .GT. NRHS_NONEMPTY ) NBRHS = NRHS_NONEMPTY
 C
         ENDIF
+C}
       ENDIF
 #if defined(V_T)
       CALL VTBEGIN(glob_comm_ini,IERR)
 #endif
-C     NRHS_NONEMPTY needed on all procs to allocate RHSCOMP on slaves
+C     NRHS_NONEMPTY needed on all procs to allocate RHSINTR on slaves
       CALL MPI_BCAST(NRHS_NONEMPTY,1,MPI_INTEGER,MASTER,
      &               id%COMM,IERR)
       CALL MPI_BCAST(NBRHS,1,MPI_INTEGER,MASTER,
@@ -1342,7 +1544,11 @@ C
             ENDIF
           END IF
         ENDIF
-        LWCB8_MIN = int(NB_K133,8)*int(KEEP(133),8)*int(NBRHS,8)
+CPA2ALL: int(min(NRHS_NONEMPTY,NBRHS),8) instead of NBRHS
+C       LWCB8_MIN = int(NB_K133,8)*int(KEEP(133),8)*int(NBRHS,8)
+        LWCB8_MIN = int(NB_K133,8)*int(KEEP(133),8)*
+     &        int(min(NRHS_NONEMPTY,NBRHS),8)
+C
 C
 C       ---------------------------------------------------------------
 C       Set WK_USER_PROVIDED to true when workspace WK_USER is provided
@@ -1537,12 +1743,14 @@ C         Access to OOC data in module d
         ENDIF
       ENDIF
       IF (id%MYID.EQ.MASTER) THEN
+C{
         IF ( PROKG )  THEN
           WRITE( MPG, 150 )
 C             ICNTL(35) should not been accessed during SOLVE thus
 C             print KEEP(486) value set during factorization
      &        id%NRHS, NBRHS, ICNTL(9), ICNTL(10), ICNTL(11),
-     &        ICNTL(20), ICNTL(21), ICNTL(30), KEEP(486)
+     &        ICNTL(20), ICNTL(21), ICNTL(30), KEEP(486),
+     &        ICNTL48_EFF
           IF (KEEP(111).NE.0) THEN
             WRITE (MPG, 151) KEEP(111)
           ENDIF
@@ -1553,11 +1761,9 @@ C             print KEEP(486) value set
             WRITE (MPG, 153) KEEP(252)
           ENDIF
         ENDIF
-C
 C     ====================================
 C       Define LSCAL, ICNTL10 and ICNTL11
 C     ====================================
-C
         LSCAL = (((KEEP(52) .GT. 0) .AND. (KEEP(52) .LE. 8)) .OR. (
      &    KEEP(52) .EQ. -1) .OR. KEEP(52) .EQ. -2)
         ICNTL10 = ICNTL(10)
@@ -1568,71 +1774,10 @@ C       Values of ICNTL(11) out of range
            IF (PROKG) WRITE(MPG,'(A)')
      &    ' WARNING: ICNTL(11) out of range'
         ENDIF
-        POSTPros = .FALSE.
-        IF (ICNTL11.NE.0 .OR. ICNTL10.NE.0) THEN
-          POSTPros = .TRUE.
-C       FORBID ERROR ANALYSIS AND ITERATIVE REFINEMENT
-C       if there are options that are not compatible
-          IF (KEEP(111).NE.0) THEN
-C       IF WE RETURN A NULL SPACE BASIS or compute entries in A-1
-C        of Fwd in facto
-C       -When only one columns of A-1 is requested then
-C        we could try to reactivate IR even if
-C          -code need be updated
-C          -accuracy could be # when one or more columns are requested
-              IF (PROKG) WRITE(MPG,'(A,A)')
-     &       ' WARNING: Incompatible features: null space basis ',
-     &                ' and Iter. Ref and/or Err. Anal.'
-              POSTPros = .FALSE.
-           ELSE IF ( KEEP(237) .NE.0 ) THEN
-              IF (PROKG) WRITE(MPG,'(A,A)')
-     &       ' WARNING: Incompatible features: AM1',
-     &                ' and Iter. Ref and/or Err. Anal.'
-              POSTPros = .FALSE.
-           ELSE IF ( KEEP(252) .NE.0 ) THEN
-              IF (PROKG) WRITE(MPG,'(A,A)')
-     &       ' WARNING: Incompatible features: Fwd in facto ',
-     &                ' and Iter. Ref and/or Err. Anal.'
-              POSTPros = .FALSE.
-           ELSE IF (KEEP(221).NE.0) THEN
-C       Forbid error analysis and iterative refinement
-C       in case of reduced rhs/solution
-              IF (PROKG) WRITE(MPG,'(A,A)')
-     &       ' WARNING: Incompatible features: reduced RHS ',
-     &       '          and Iter. Ref and/or Err. Anal.'
-              POSTPros = .FALSE.
-            ELSE IF  (NBRHS.GT. 1 .OR. ICNTL(21) .GT. 0) THEN
-C          Forbid error analysis and iterative refinement if
-C       the solution is distributed or
-C       in the case where nrhs > 1
-              IF (PROKG) WRITE(MPG,'(A,A)')
-     &       ' WARNING:  Incompatible features: nrhs>1 or distrib sol',
-     &       '           and Iter. Ref and/or Err. Anal.'
-              POSTPros = .FALSE.
-            ELSE IF ( KEEP(248) .EQ. -1 ) THEN
-C          Forbid error analysis and iterative refinement
-C          in case of distributed RHS
-              IF (PROKG) WRITE(MPG,'(A,A)')
-     &       ' WARNING:  Incompatible features: distrib rhs',
-     &       '           and Iter. Ref and/or Err. Anal.'
-              POSTPros = .FALSE.
-            ENDIF  
-            IF (.NOT.POSTPros) THEN
-              ICNTL11 = 0
-              ICNTL10 = 0
-            ENDIF
-        ENDIF
-C   Write a warning.
-        IF ((ICNTL(10) .NE. 0) .AND. (ICNTL10 .EQ. 0)) THEN
-            IF (PROKG) WRITE(MPG,'(A)')
-     &    ' WARNING: ICNTL(10) treated as if set to 0 '
-        ENDIF
-        IF ((ICNTL(11) .NE. 0)
-     &        .AND.(ICNTL11 .EQ. 0)) THEN
-            IF (PROKG) WRITE(MPG,'(A)')
-     &    ' WARNING: ICNTL(11) treated as if set to 0 '
-        ENDIF
-C     -- end of test master
+        CALL SMUMPS_SET_POSTPros (
+     &                      KEEP(1), ICNTL(1), NBRHS, MPG, PROKG,
+     &                      ICNTL10, ICNTL11, POSTPros)
+C}    -- end of test master
       END IF
       CALL MPI_BCAST(POSTPros,1,MPI_LOGICAL,MASTER,
      &               id%COMM,IERR)
@@ -1687,28 +1832,29 @@ C        allocated, otherwise MAT_ALLOC_
       CALL MPI_REDUCE( MAT_ALLOC_LOC, MAT_ALLOC, 1,
      &                 MPI_INTEGER,
      &                 MPI_MIN, MASTER, id%COMM, IERR)
-      IF ( id%MYID .eq. MASTER ) THEN
+      IF ( POSTPros.and.(id%MYID .eq. MASTER) ) THEN
+C       if postprocessing requested matrix must be allocated
         IF (MAT_ALLOC.EQ.0) THEN
-            IF (KEEP(54).NE.0) THEN
+           IF (KEEP(54).NE.0) THEN
 C           Write on MPG this time (we wrote on MP before in
 C           case of distributed matrix and wrote on MPG already
 C           in case of centralized matrix)
             IF (PROKG) WRITE(MPG,'(A)')
      &      ' WARNING: original distributed matrix is not allocated'
-             ENDIF
-              POSTPros = .FALSE.
-              ICNTL11 = 0
-              ICNTL10 = 0
+           ENDIF
+           POSTPros = .FALSE.
+           ICNTL11 = 0
+           ICNTL10 = 0
 C   Write a warning.
            IF ((ICNTL(10) .NE. 0) .AND. (ICNTL10 .EQ. 0)) THEN
             IF (PROKG) WRITE(MPG,'(A)')
-     &    ' WARNING: ICNTL(10) treated as if set to 0'
+     &      ' WARNING: ICNTL(10) treated as if set to 0'
            ENDIF
            IF ((ICNTL(11) .EQ. 1).OR.(ICNTL(11) .EQ. 2) 
      &        .AND.(ICNTL11 .EQ. 0)) THEN
             IF (PROKG) WRITE(MPG,'(A)')
-     &    ' WARNING: ICNTL(11) treated as if set to 0 '
-          ENDIF
+     &      ' WARNING: ICNTL(11) treated as if set to 0 '
+           ENDIF
         ENDIF
         IF (POSTPros) THEN
             ALLOCATE(SAVERHS(id%N*NBRHS),stat = allocok)
@@ -1748,14 +1894,44 @@ C     ----------------------------------
      &               id%COMM,IERR)
       CALL MPI_BCAST(ICNTL11,1,MPI_INTEGER,MASTER,
      &               id%COMM,IERR)
-      CALL MPI_BCAST(ICNTL21,1,MPI_INTEGER,MASTER,
-     &               id%COMM,IERR)
       CALL MPI_BCAST(POSTPros,1,MPI_LOGICAL,MASTER,
      &               id%COMM,IERR)
       CALL MPI_BCAST(LSCAL,1,MPI_LOGICAL,MASTER,
      &               id%COMM,IERR)
       CALL MPI_BCAST(KEEP(237),1,MPI_INTEGER,MASTER,
      &               id%COMM,IERR)
+#if ! defined(USE_OLD_SCALING)
+C     ----------------------------------------------
+C     Initialize SCALING_LOC_FWD and SCALING_LOC_BWD
+C     They corespond to all pivots factorized on a
+C     given MPI process and point to a dummy array
+C     of size 1 on the host of if no pivot was
+C     factorized (KEEP(89))=0
+C     ----------------------------------------------
+      IF (LSCAL .AND. id%KEEP(89) .GT. 0) THEN
+          IF (MTYPE .EQ. 1) THEN
+            SCALING_LOC_FWD => id%ROWSCA_loc
+            SCALING_LOC_BWD => id%COLSCA_loc
+          ELSE
+            SCALING_LOC_FWD => id%COLSCA_loc
+            SCALING_LOC_BWD => id%ROWSCA_loc
+          ENDIF
+      ELSE ! includes non working master on which KEEP(89)=0
+          SCALING_LOC_FWD => RDUMMY_TARGET
+          SCALING_LOC_BWD => RDUMMY_TARGET
+      ENDIF
+C     Remarks related to scalings:
+C     * During postprocessing, one performs solves
+C       with alternatively A and A^T, meaning that
+C       SCALING_LOC_FWD and SCALING_LOC_BWD will
+C       be redefined.
+C     * In case of exploit sparsity, RHSINTR may
+C       have less rows than ROWSCA_loc/COLSCA_loc.
+C       SCALING_RHSINTR_FWD and SCALING_RHSINTR_BWD
+C       will then be extracted from
+C       SCALING_LOC_FWD and SCALING_LOC_BWD thanks
+C       to the subroutine SMUMPS_SCALINGRHSINTR
+#endif
 C     KEEP(248)==1 if not_NullSpace (KEEP(111)=0)
 C           and sparse RHS on input (id%ICNTL(20)/KEEP(248)==1)
 C     (KEEP(248)==1 implies KEEP(111) = 0, otherwise error was raised)
@@ -1965,81 +2141,85 @@ c         --- ALLOCATE outside loop RHS_
 C     --------------------------------------------------
       IF ( I_AM_SLAVE ) THEN
         IF ((KEEP(221).EQ.2 .AND. KEEP(252).EQ.0)) THEN
-C          -- RHSCOMP must have been allocated in
+C          -- RHSINTR must have been allocated in
 C          -- previous solve step (with option KEEP(221)=1)
-           IF (.NOT.associated(id%RHSCOMP)) THEN
+           IF (.NOT.associated(id%RHSINTR)) THEN
              INFO(1) = -35
              INFO(2) = 1
              GOTO 111
            ENDIF
 C          IF ((KEEP(248).EQ.0) .OR. (id%NRHS.EQ.1)) THEN
-C          POSINRHSCOMP_ROW/COL are meaningful and could even be reused
-           IF (.NOT.associated(id%POSINRHSCOMP_ROW) ) ! .OR.
-!    &        .NOT.(id%POSINRHSCOMP_COL_ALLOC))
+C          GLOB2LOC_RHS/SOL are meaningful and could even be reused
+           IF (.NOT.associated(id%GLOB2LOC_RHS) ) ! .OR.
+!    &        .NOT.(id%GLOB2LOC_SOL_ALLOC))
      &     THEN
              INFO(1) = -35
              INFO(2) = 2
              GOTO 111
            ENDIF
-           IF (.not.id%POSINRHSCOMP_COL_ALLOC) THEN
-C             POSINRHSCOMP_COL that is kept from
+           IF (.not.id%GLOB2LOC_SOL_ALLOC) THEN
+C             GLOB2LOC_SOL that is kept from
 C             previous call to solve must then (already)
-C             point to id%POSINRHSCOMP_ROW
-              id%POSINRHSCOMP_COL => id%POSINRHSCOMP_ROW
+C             point to id%GLOB2LOC_RHS
+              id%GLOB2LOC_SOL => id%GLOB2LOC_RHS
            ENDIF
         ELSE
 C         ----------------------
-C         Allocate POSINRHSCOMP_ROW/COL
+C         Allocate GLOB2LOC_RHS/SOL
 C         ----------------------
-C         The size of POSINRHSCOMP arrays
+C         The size of POSINRHSINTR arrays
 C         does not depend on the block of RHS
-C         POSINRHSCOMP_ROW/COL are initialized in the loop of RHS
-          IF (associated(id%POSINRHSCOMP_ROW)) THEN
+C         GLOB2LOC_RHS/SOL are initialized in the loop of RHS
+          IF (associated(id%GLOB2LOC_RHS)) THEN
             NB_BYTES = NB_BYTES -
-     &          int(size(id%POSINRHSCOMP_ROW),8)*K34_8
-            DEALLOCATE(id%POSINRHSCOMP_ROW)
+     &          int(size(id%GLOB2LOC_RHS),8)*K34_8
+            DEALLOCATE(id%GLOB2LOC_RHS)
           ENDIF
-          ALLOCATE (id%POSINRHSCOMP_ROW(id%N), stat = allocok)
+          ALLOCATE (id%GLOB2LOC_RHS(id%N), stat = allocok)
           IF ( allocok .GT. 0 ) THEN
              INFO(1)=-13
              INFO(2)=id%N
              GOTO 111
           END IF
           NB_BYTES = NB_BYTES +
-     &          int(size(id%POSINRHSCOMP_ROW),8)*K34_8
+     &          int(size(id%GLOB2LOC_RHS),8)*K34_8
           NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
-          IF (id%POSINRHSCOMP_COL_ALLOC) THEN
+          IF (id%GLOB2LOC_SOL_ALLOC) THEN
             NB_BYTES = NB_BYTES -
-     &          int(size(id%POSINRHSCOMP_COL),8)*K34_8
-            DEALLOCATE(id%POSINRHSCOMP_COL)
-            NULLIFY(id%POSINRHSCOMP_COL)
-            id%POSINRHSCOMP_COL_ALLOC = .FALSE.
+     &          int(size(id%GLOB2LOC_SOL),8)*K34_8
+            DEALLOCATE(id%GLOB2LOC_SOL)
+            NULLIFY(id%GLOB2LOC_SOL)
+            id%GLOB2LOC_SOL_ALLOC = .FALSE.
           ENDIF
 C
-          IF ((KEEP(50).EQ.0).OR.KEEP(237).NE.0) THEN
-           ALLOCATE (id%POSINRHSCOMP_COL(id%N), stat = allocok)
+          IF ( (KEEP(50).EQ.0).OR.(KEEP(237).NE.0).OR.
+     &         (KEEP(212).NE.0)
+     &       ) THEN
+           ALLOCATE (id%GLOB2LOC_SOL(id%N), stat = allocok)
            IF ( allocok .GT. 0 ) THEN
              INFO(1)=-13
              INFO(2)=id%N
              GOTO 111
            END IF
-           id%POSINRHSCOMP_COL_ALLOC = .TRUE.
+           id%GLOB2LOC_SOL_ALLOC = .TRUE.
            NB_BYTES = NB_BYTES +
-     &          int(size(id%POSINRHSCOMP_COL),8)*K34_8
+     &          int(size(id%GLOB2LOC_SOL),8)*K34_8
            NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
           ELSE
-C          Do no allocate POSINRHSCOMP_COL
-           id%POSINRHSCOMP_COL => id%POSINRHSCOMP_ROW
-           id%POSINRHSCOMP_COL_ALLOC = .FALSE.
+C          Do no allocate GLOB2LOC_SOL
+           id%GLOB2LOC_SOL => id%GLOB2LOC_RHS
+           id%GLOB2LOC_SOL_ALLOC = .FALSE.
           ENDIF
           IF (KEEP(221).NE.2) THEN
-C         -- only in the case of bwd after reduced RHS
-C         -- we have to keep "old" RHSCOMP
-            IF (associated(id%RHSCOMP)) THEN
+C         -- only in the case of bwd after 
+C         -- fwd only (with or without Schur)
+C         -- we have to keep "old" RHSINTR
+            IF (associated(id%RHSINTR)) THEN
              NB_BYTES = NB_BYTES - id%KEEP8(25)*K35_8
-             DEALLOCATE(id%RHSCOMP)
-             NULLIFY(id%RHSCOMP)
-             id%KEEP8(25)=0_8
+             DEALLOCATE(id%RHSINTR)
+             NULLIFY(id%RHSINTR)
+             id%KEEP8(25)  = 0_8
+             id%LD_RHSINTR = 0
             ENDIF
           ENDIF
         ENDIF
@@ -2138,16 +2318,22 @@ C          migrated outside the blocking
             UNS_PERM_INV_NEEDED_INMAINLOOP = .TRUE.
       ENDIF
       UNS_PERM_INV_NEEDED_BEFMAINLOOP = .FALSE.
+      IF (KEEP(23) .GT. 0 .AND. MTYPE.EQ.1 .AND. ICNTL21.EQ.2) THEN
+           UNS_PERM_INV_NEEDED_INMAINLOOP = .TRUE.
+      ENDIF
       IF ( KEEP(23) .GT.0 .AND.
      &            MTYPE .NE. 1 .AND. KEEP(248).EQ.-1 ) THEN
 C          Similar to sparse RHS case, we need to modify IRHS_loc
 C          indices in the distributed RHS case. However, we need
-C          UNS_PERM_INV on all processors. But only before theC
+C          UNS_PERM_INV on all processors. But only before the
 C          main loop on the RHS blocks.
            UNS_PERM_INV_NEEDED_BEFMAINLOOP = .TRUE.
       ENDIF
+C
+      UNS_PERM_INV_NEEDED_ONSLAVES = .FALSE.
       IF ( UNS_PERM_INV_NEEDED_INMAINLOOP .OR.
      &     UNS_PERM_INV_NEEDED_BEFMAINLOOP ) THEN
+C          We need UNS_PERM_INV
            ALLOCATE(UNS_PERM_INV(id%N),stat=allocok)
            if (allocok .GT.0 ) THEN
              INFO(1)=-13
@@ -2188,8 +2374,14 @@ C     Propagate errors
 C
 C     UNS_PERM_INV needed on slaves:
       IF ( KEEP(23).NE.0 .AND.
-     &     ( KEEP(237).NE.0 .OR.
-     &     ( MTYPE.NE.1 .AND. KEEP(248).EQ.-1 ) ) ) THEN
+     &     (  KEEP(237).NE.0 .OR.
+     &        ( MTYPE.NE.1 .AND. KEEP(248).EQ.-1 ) .OR.
+     &        ( MTYPE.EQ.1 .AND. ICNTL21.EQ.2)
+     &     ) 
+     &   ) THEN
+        UNS_PERM_INV_NEEDED_ONSLAVES = .TRUE.
+      ENDIF
+      IF (UNS_PERM_INV_NEEDED_ONSLAVES) THEN
 C       Broadcast UNS_PERM_INV
         CALL MPI_BCAST( UNS_PERM_INV,id%N,MPI_INTEGER,MASTER,
      &                  id%COMM,IERR )
@@ -2198,7 +2390,8 @@ C     -------------------------------
 C     BEGIN
 C     Preparation for distributed RHS
 C     -------------------------------
-      IF (I_AM_SLAVE .AND. KEEP(248).EQ.-1) THEN
+      IF (I_AM_SLAVE .AND. KEEP(248).EQ.-1
+     & ) THEN
 C       Distributed RHS case
         ALLOCATE(MAP_RHS_loc(max(id%Nloc_RHS,1)), stat=allocok)
         IF (allocok .GT. 0) THEN
@@ -2208,10 +2401,10 @@ C       Distributed RHS case
         ENDIF
         NB_BYTES = NB_BYTES + max(int(id%Nloc_RHS,8),1_8)*K34_8
       ENDIF
-C     MAP_RHS_loc will be built in the main
-C     loop, when processing the first block.
-C     It requires POSINRHSCOMP to be built.
-      BUILD_RHSMAPINFO = .TRUE.
+C      MAP_RHS_loc will be built in the main
+C      loop, when processing the first block.
+C      It requires POSINRHSINTR to be built.
+       BUILD_RHSMAPINFO = .TRUE.
  20   CONTINUE
       CALL MUMPS_PROPINFO( ICNTL(1), INFO(1),
      &                         id%COMM,id%MYID)
@@ -2221,7 +2414,8 @@ C     transpose system, use MUMPS intern
 C     for IRHS_loc_PTR. Done before scaling since
 C     scaling is on permuted matrix
       IF ( I_AM_SLAVE .AND. KEEP(23).GT.0 .AND. KEEP(248).EQ.-1
-     &     .AND. MTYPE.NE.1 ) THEN
+     &     .AND. MTYPE.NE.1 
+     &   ) THEN
           IF (id%Nloc_RHS .GT. 0) THEN
             ALLOCATE(IRHS_loc_PTR(id%Nloc_RHS),stat=allocok)
             IF (allocok.GT.0) THEN
@@ -2252,7 +2446,9 @@ C     to free memory
         ALLOCATE(UNS_PERM_INV(1))  ! to posibly pass it as an argument
         NB_BYTES = NB_BYTES + K34_8
       ENDIF
-      IF (LSCAL .AND. id%KEEP(248).EQ.-1) THEN
+#if defined(USE_OLD_SCALING)
+      IF (LSCAL .AND. id%KEEP(248).EQ.-1
+     &   ) THEN
 C       Scaling done based on original indices
 C       provided by user
         IF (MTYPE == 1) THEN
@@ -2268,6 +2464,7 @@ C         Transpose
      &       NB_BYTES, NB_BYTES_MAX, K16_8, LP, LPOK,
      &       ICNTL(1), INFO(1) )
       ENDIF
+#endif
 C     -------------------------------
 C     END
 C     Preparation for distributed RHS
@@ -2280,9 +2477,11 @@ C     ----------------------------------
 C     BEGIN
 C     Preparation for distributed solution
 C     -------------------------------------
-      IF ( ICNTL21==1 ) THEN
+      IF ( ICNTL21 .NE. 0 ) THEN
+C{
+#if defined(USE_OLD_SCALING)
         IF (LSCAL) THEN
-C         In case of scaling we will need to scale
+C{        In case of scaling we will need to scale
 C         back the sol. Put the values of the scaling
 C         arrays needed to do that on each processor.
           IF (id%MYID.NE.MASTER) THEN
@@ -2306,17 +2505,20 @@ C         arrays needed to do that on ea
      &                         id%COMM,id%MYID)
           IF (INFO(1) .LT.0 ) GOTO 90
           IF (I_AM_SLAVE) THEN
-            ALLOCATE(scaling_data_sol%SCALING_LOC(id%KEEP(89)),
-     &               stat=allocok)
+              ALLOCATE(scaling_data_sol%SCALING_LOC(max(1,id%KEEP(89))),
+     &                 stat=allocok)
             IF (allocok > 0) THEN
               IF (LPOK) THEN
                 WRITE(LP,*) 'Error allocating local scaling array'
               ENDIF
               INFO(1)=-13
-              INFO(2)=id%KEEP(89)
+              INFO(2)=max(1,id%KEEP(89))
               GOTO 38
             ENDIF
-            NB_BYTES = NB_BYTES + int(id%KEEP(89),8)*K16_8
+            IF (ICNTL21.NE.0) THEN
+C            Real entries for scaling
+             NB_BYTES = NB_BYTES + int(max(1,id%KEEP(89)),8)*K16_8
+            ENDIF
             NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
           ENDIF ! I_AM_SLAVE
  38       CONTINUE
@@ -2336,11 +2538,17 @@ C         arrays needed to do that on ea
      &                       id%COMM,IERR)
               scaling_data_sol%SCALING=>id%ROWSCA
           ENDIF
+C}
         ENDIF ! LSCAL
-        IF ( I_AM_SLAVE ) THEN
-C         ----------------------
+#endif
+        IF ( ICNTL21.EQ.1 .AND. I_AM_SLAVE 
+     &     ) THEN
+C         --------------------------------
 C         Prepare ISOL_loc array
-C         ----------------------
+#if defined(USE_OLD_SCALING)
+C         and on the fly, scaling_data_sol
+#endif
+C         --------------------------------
           LIW_PASSED=max(1,LIW)
 C         Only called if more than 1 pivot
 C         was eliminated by the processor.
@@ -2351,12 +2559,19 @@ C         Note that LSOL_loc >= KEEP(89)
      &               id%KEEP(1),id%KEEP8(1),
      &               id%IS(1), LIW_PASSED,id%MYID_NODES,
      &               id%N, id%STEP(1), id%PROCNODE_STEPS(1),
-     &               id%NSLAVES, scaling_data_sol, LSCAL
+     &               id%NSLAVES,
+#if defined(USE_OLD_SCALING)
+     &               scaling_data_sol, LSCAL,
+#endif
 C                    For checking only
-     &               , (KEEP(248).EQ.-1), IRHS_loc_PTR(1), id%Nloc_RHS
+     &               (KEEP(248).EQ.-1), IRHS_loc_PTR(1), id%Nloc_RHS
      &               )
           ENDIF 
-          IF (id%MYID.NE.MASTER .AND. LSCAL) THEN
+        ENDIF ! I_AM_SLAVE
+#if defined(USE_OLD_SCALING)
+#endif
+#if defined(USE_OLD_SCALING)
+        IF (id%MYID.NE.MASTER .AND. LSCAL) THEN
 C           ---------------------------------
 C           Local (small) scaling arrays have
 C           been built, free temporary copies
@@ -2369,8 +2584,15 @@ C           ----------------------------
               NULLIFY(id%ROWSCA)
             ENDIF
             NB_BYTES = NB_BYTES - int(id%N,8)*K16_8
-          ENDIF
-        ENDIF ! I_AM_SLAVE
+        ENDIF
+#endif
+C}
+      ENDIF ! ICNTL21 .NE. 0
+      IF (ICNTL21 .EQ.1) THEN
+C       ---------------------------------------------------
+C       Take into account unsymmetric permutation to modify
+C       ISOL_loc, in case ISOL_loc is provided by MUMPS
+C       ---------------------------------------------------
         IF (KEEP(23) .NE. 0 .AND. MTYPE==1) THEN
 C         Broadcast the unsymmetric permutation and
 C         permute the indices in ISOL_loc
@@ -2409,11 +2631,14 @@ C     ----------------------------------
 C     Preparation for distributed solution
 C     END
 C     --------------------------------------
-C     ----------------------------
-C     Preparation for reduced RHS
-C     ----------------------------
-      IF ( ( KEEP(221) .EQ. 1 ) .OR.
+C     ---------------------------------------------
+C     In case of Schur, preparation for reduced RHS
+C     ---------------------------------------------
+      IF ( (KEEP(60).NE.0) .AND. 
+     &    (
+     &     ( KEEP(221) .EQ. 1 ) .OR.
      &     ( KEEP(221) .EQ. 2 )
+     &    )
      &   ) THEN
 C       -- First compute MASTER_ROOT_IN_COMM proc number in
 C          COMM_NODES on which is mapped the master of the root.
@@ -2452,7 +2677,8 @@ C          -- other procs not concerned
          ENDIF
       ENDIF
 C
-      IF ( KEEP(248)==1 ) THEN  ! Sparse RHS (A-1 or general sparse)
+      IF ( KEEP(248)==1 
+     &   ) THEN  ! Sparse RHS (A-1 or general sparse)
 !        JBEG_RHS - current starting column within A-1 or sparse rhs
 !                      set in the loop below and used to obtain the
 !                      global index of the column of the sparse RHS
@@ -2539,9 +2765,9 @@ C     Propagate errors
 c --------------------------
 c --------------------------
       IF (id%NSLAVES .EQ. 1) THEN
-c     - In case of NS/A-1 we may want to permute RHS
-c     - for NS thus is to apply permutation to PIVNUL_LIST
-*     - before starting loop of NBRHS
+C{    - In case of NS/A-1 we may want to permute RHS
+C     - for NS thus is to apply permutation to PIVNUL_LIST
+C     - before starting loop of NBRHS
        IF (DO_PERMUTE_RHS .AND. KEEP(111).NE.0 ) THEN
 C     NOTE:
 C        when host not working both master and slaves have
@@ -2551,6 +2777,7 @@ C        in this case the complete list
      &                 ' not available yet '
             CALL MUMPS_ABORT()
        ENDIF                     ! End Permute_RHS
+C}
       ELSE
          IF (DO_PERMUTE_RHS .AND. KEEP(111).NE.0 ) THEN
             WRITE(*,*) id%MYID, ':INTERNAL ERROR 2 : ',
@@ -2558,7 +2785,6 @@ C        in this case the complete list
      &                 ' not available yet '
             CALL MUMPS_ABORT()
 C
-C
          ENDIF                  !  End DO_PERMUTE_RHS
          IF (INTERLEAVE_PAR.AND. (KEEP(111).NE.0)) THEN
             WRITE(*,*) id%MYID, ':INTERNAL ERROR 3 : ',
@@ -2601,15 +2827,15 @@ C          to permute the null column pi
      &            MPI_INTEGER,
      &            MASTER, id%COMM,IERR)
       ENDIF
-C   L0-threads to be activated iff KEEP(401)>0 and KEEP(400)>0
-          IF (KEEP(401) .GT. 0) THEN
+C   L0-threads to be activated iff KEEP(401)=1 and KEEP(400)>0
+          IF (KEEP(401) .EQ. 1) THEN
 C          L0-threads was requested for solve phase
 C          and will be effective only if KEEP(400) >0 
 C          which indicates that L0-threads was 
 C          performed during analysis+factorization
            IF ( KEEP(400) .GT. 0 ) THEN
 C           Check if number of threads is consistent with
-C           the one used during factorization
+C           the one used during factorization for all procs
 C{
             NOMP = 1
 !$          NOMP=omp_get_max_threads()
@@ -2617,17 +2843,23 @@ C{
 C               NOMP should be the one from analysis
                 id%INFO(1) = -58
                 id%INFO(2) = KEEP(400)
-            IF (LPOK) WRITE(LP,'(A,A,I5,A,I5)')
-     &" FAILURE DETECTED IN SOLVE: #threads for KEEP(401)",
-     &" changed from",KEEP(400)," at analysis to", NOMP
+                IF (LPOK) WRITE(LP,'(A,A,I5,A,I5)')
+     &" FAILURE DETECTED IN SOLVE: #threads for multithreaded",
+     &" tree parallelism changed from",KEEP(400)," at analysis to", 
+     &  NOMP
               ENDIF
            ENDIF
+C          error check
+           CALL MUMPS_PROPINFO( ICNTL(1), INFO(1),
+     &                    id%COMM,id%MYID)
+           IF ( id%INFO(1) .LT. 0 ) GO TO 90
 C}
           ENDIF
       IF (KEEP(400) .GT. 0) THEN
         CALL SMUMPS_SOL_L0OMP_LI(KEEP(400))
       ENDIF
 C     ==============================
+C     MAIN LOOP:
 C     BLOCKING ON the number of RHS
 C      We work on  a maximum of NBRHS at a time.
 C      the leading dimension of RHS is id%LRHS on master
@@ -2649,14 +2881,16 @@ C     {
 C       ==========================
 C       -- NBRHS     : Original block size
 C       -- BEG_RHS   : Column index of the first RHS in the list of
-C                      non empty RHS (RHS_LOC) to
+C                      non empty RHS (RHS_loc) to
 C                      be processed during this iteration
 C       -- NBRHS_EFF : Effective block size at current iteration
-C          In case of sparse RHS (KEEP(248)==1) NBRHS_EFF only refers to
-C                  non-empty columns and is used to compute NBCOL_INBLOC
-C          -- NBCOL_INBLOC  : the number of columns of sparse RHS needed
-C                        to get NBRHS_EFF non empty columns columns of
-C                        sparse RHS processed at each step
+C                      that we be set to nb of contiguous non empty 
+C                      columns
+C        In case of sparse RHS (KEEP(248)==1) NBRHS_EFF only refers to
+C                non-empty columns and is used to compute NBCOL_INBLOC
+C        -- NBCOL_INBLOC  : the number of columns of sparse RHS needed
+C                      to get NBRHS_EFF non empty columns columns of
+C                      sparse RHS processed at each step
 C
         NBRHS_EFF    = min(NRHS_NONEMPTY-BEG_RHS+1, NBRHS)
 C
@@ -2690,7 +2924,7 @@ C       id%RHS is accessed). Remark that
 C       overwritten later, in case of general sparse right-hand side
 C       and centralized solution to skip empty columns 
 C       ===========================================================
-        IF (
+        IF  (
 C           slave procs
      &      ( id%MYID .NE. MASTER )
 C       even on master when RHS not allocated
@@ -2734,7 +2968,8 @@ C       ================================
 C       Shift empty columns in case of sparse RHS
 C       ==========================================
         IF ( (id%MYID.EQ.MASTER) .AND.
-     &        KEEP(248)==1  ) THEN
+     &        KEEP(248)==1  
+     &     ) THEN
 C         update position of JBEG_RHS on first non-empty
 C         column of this block
           JBEG_RHS = JEND_RHS + 1
@@ -2743,7 +2978,8 @@ C         column of this block
      &          id%IRHS_PTR(PERM_RHS(JBEG_RHS)+1) )
 C             Empty column
               IF ((KEEP(237).EQ.0).AND.(ICNTL21.EQ.0).AND.
-     &              (KEEP(221).NE.1) ) THEN
+     &              (KEEP(221).NE.1) 
+     &           ) THEN
 C                General sparse RHS (NOT A-1) and centralized solution
 C                Set to zero part of the
 C                solution corresponding to empty columns
@@ -2758,7 +2994,8 @@ C                solution corresponding
             DO WHILE( id%IRHS_PTR(JBEG_RHS) .EQ.
      &        id%IRHS_PTR(JBEG_RHS+1) )
               IF ((KEEP(237).EQ.0).AND.(ICNTL21.EQ.0).AND.
-     &          (KEEP(221).NE.1) ) THEN
+     &             (KEEP(221).NE.1) 
+     &           ) THEN
 C               Case of general sparse RHS (NOT A-1) and
 C               centralized solution: set to zero part of
 C               the solution corresponding to empty columns
@@ -2768,11 +3005,13 @@ C               the solution correspondi
                 ENDDO
               ENDIF
               IF (KEEP(221).EQ.1) THEN
-C               Reduced RHS set to ZERO
-                DO I = 1, id%SIZE_SCHUR
-                  id%REDRHS(int(JBEG_RHS-1,8)*int(LD_REDRHS,8) +
-     &            int(I,8)) =  ZERO
-                ENDDO
+                IF (KEEP(60).NE.0) THEN
+C                 Fwd with Schur: reduced RHS set to ZERO
+                  DO I = 1, id%SIZE_SCHUR
+                    id%REDRHS(int(JBEG_RHS-1,8)*int(LD_REDRHS,8) +
+     &              int(I,8)) =  ZERO
+                  ENDDO
+                ENDIF
               ENDIF
               JBEG_RHS = JBEG_RHS +1
             ENDDO
@@ -2781,7 +3020,7 @@ C         Count nb of RHS columns skippe
 C         * SMUMPS_DISTRIBUTED_SOLUTION to reset those
 C           columns to zero.
 C         * in case of reduced right-hand side, to set
-C           corresponding entries of RHSCOMP to 0 after
+C           corresponding entries of RHSINTR to 0 after
 C           forward phase.
           NB_RHSSKIPPED = JBEG_RHS - (JEND_RHS + 1)
           IF ((KEEP(248).EQ.1).AND.(KEEP(237).EQ.0)
@@ -2798,7 +3037,8 @@ C           forward phase.
 C
 C       Shift on REDRHS in reduced RHS functionality
 C
-        IF (id%MYID.EQ.MASTER .AND. KEEP(221).NE.0) THEN
+        IF (id%MYID.EQ.MASTER .AND. KEEP(221).NE.0 
+     &       .AND. KEEP(60).NE.0 ) THEN
 C         Initialize IBEG_REDRHS
 C         Note that REDRHS always has id%NRHS Colmuns
           IBEG_REDRHS= int(JBEG_RHS-1,8)*int(LD_REDRHS,8) + 1_8
@@ -2814,11 +3054,12 @@ C
         CALL VTBEGIN(perm_scal_ini,IERR)
 #endif
         IF (id%MYID .eq. MASTER) THEN
-C         ======================
-          IF (KEEP(248)==1) THEN
-C         ======================
+C{        ======================
+          IF (KEEP(248)==1
+     &       ) THEN
+C{        ======================
 C
-C         Sparse RHS format ( A-1 or sparse input format)
+C         Sparse RHS format ( A-1 or sparse centralized input format)
 C         is provided as input by the user (IRHS_SPARSE ...)
 C         --------------------------------------------------
 C         Compute NZ_THIS_BLOCK and NBCOL_INBLOC
@@ -2840,7 +3081,10 @@ C         the first non empty column; th
 C         maximum size NBRHS_EFF except if we reach another empty
 C         column. (We are not sure to have a copy allocated
 C         and thus cannot compress on the fly, as done naturally
-C         for A-1).
+C         for A-1)
+C         For A-1 we process NBRHS_EFF non empty columns 
+C         in the bloc that contains NBCOL_INBLOC columns
+C         (empty+non empty)
           STOP_AT_NEXT_EMPTY_COL = .FALSE.
           DO I=JBEG_RHS, id%NRHS
             NBCOL_INBLOC = NBCOL_INBLOC +1
@@ -2861,15 +3105,19 @@ C              --  sparse case (not AM-1
                STOP_AT_NEXT_EMPTY_COL =.TRUE.
             ENDIF
             IF (COLSIZE.GT.0
+C{
      &      ) THEN
               NBCOL = NBCOL+1
               NZ_THIS_BLOCK = NZ_THIS_BLOCK + COLSIZE
+C}
             ELSE IF (STOP_AT_NEXT_EMPTY_COL) THEN
-C We have reached an empty column with already selected non empty 
-C columns: reduce block size to non empty columns reached so far.
+C{ We have reached an empty column with already selected non empty 
+C  columns: reduce block size to non empty columns reached so far.
               NBCOL_INBLOC = NBCOL_INBLOC -1
+C Note that NBRHS_EFF is udated only on master 
               NBRHS_EFF = NBCOL
               EXIT
+C}
             ENDIF
             IF (NBCOL.EQ.NBRHS_EFF) EXIT
           ENDDO
@@ -3000,9 +3248,16 @@ c    *                   (1:NZ_THIS_BLOC
      &          id%IRHS_SPARSE(id%IRHS_PTR(JBEG_RHS):
      &             id%IRHS_PTR(JBEG_RHS)+NZ_THIS_BLOCK-1)
             ENDIF
+#if defined(USE_OLD_SCALING)
+C           Centralized scaling: perform scaling on master
+C           in RHS_SPARSE_COPY
             IF (LSCAL.OR.DO_PERMUTE_RHS.OR.INTERLEAVE_PAR.OR.
      &          (KEEP(237).NE.0)) THEN
-C             if scaling is on or if columns of the RHS are
+#else
+            IF (DO_PERMUTE_RHS.OR.INTERLEAVE_PAR.OR.
+     &          (KEEP(237).NE.0)) THEN
+#endif
+C             if columns of the RHS are
 C             permuted then a copy of RHS_SPARSE is needed.
 C             Also always allocated with A-1,
 c             to enable receiving during mumps_gather_solution
@@ -3034,23 +3289,36 @@ c    *            (1:NZ_THIS_BLOCK)
             IF (DO_PERMUTE_RHS.OR.INTERLEAVE_PAR.OR.
      &          (id%KEEP(237).NE.0)) THEN
               IF (id%KEEP(237).NE.0) THEN
-C               --initialized to one; it might be
-C               modified if scaling is on (one first entry in each col is scaled)
+C               --initialized to one
+#if defined(USE_OLD_SCALING)
+C               it might be modified if scaling is on (one first entry
+C               in each col is scaled)
                 RHS_SPARSE_COPY = ONE
-              ELSE IF (.NOT. LSCAL) THEN
+#else
+C               Local scalings are used: RHSINTR is initialized
+C               directly on the workers and RHS_SPARSE_COPY will
+C               only be used during SMUMPS_GATHER_SOLUTION_AM1.
+#endif
+              ELSE
 C               -- Columns are not contiguous and need be copied one by one
+#if defined(USE_OLD_SCALING)
 C               -- This need not be done if scaling is on because it
 C               -- will done and scaled later.
-                IPOS = 1
-                DO I=JBEG_RHS, JBEG_RHS + NBCOL_INBLOC -1
-                  COLSIZE = id%IRHS_PTR(PERM_RHS(I)+1)
-     &                    - id%IRHS_PTR(PERM_RHS(I))
-                  IF (COLSIZE .EQ. 0) CYCLE
-                  RHS_SPARSE_COPY(IPOS:IPOS+COLSIZE-1) =
-     &            id%RHS_SPARSE(id%IRHS_PTR(PERM_RHS(I)):
-     &            id%IRHS_PTR(PERM_RHS(I)+1) -1)
-                  IPOS = IPOS + COLSIZE
-                ENDDO
+                IF (.NOT. LSCAL) THEN
+#endif
+                  IPOS = 1
+                  DO I=JBEG_RHS, JBEG_RHS + NBCOL_INBLOC -1
+                    COLSIZE = id%IRHS_PTR(PERM_RHS(I)+1)
+     &                      - id%IRHS_PTR(PERM_RHS(I))
+                    IF (COLSIZE .EQ. 0) CYCLE
+                    RHS_SPARSE_COPY(IPOS:IPOS+COLSIZE-1) =
+     &              id%RHS_SPARSE(id%IRHS_PTR(PERM_RHS(I)):
+     &              id%IRHS_PTR(PERM_RHS(I)+1) -1)
+                    IPOS = IPOS + COLSIZE
+                  ENDDO
+#if defined(USE_OLD_SCALING)
+                ENDIF
+#endif
               ENDIF
             ENDIF
 C           =========================
@@ -3085,9 +3353,9 @@ C                 (ii) columns might hav
               ENDIF ! MTYPE.NE.1
             ENDIF ! KEEP(23).NE.0
           ENDIF ! NZ_THIS_BLOCK .NE. 0
-C         -----
+C}        -----
           ENDIF  !  ============ KEEP(248)==1
-C         -----
+C}        -----
         ENDIF   !  (id%MYID .eq. MASTER)
 C
 C =====================  ERROR handling and propagation ================
@@ -3098,16 +3366,29 @@ C =====================  ERROR handling
 C ======================================================================
 C
 C       NBCOL_INBLOC depends on loop
-        IF (KEEP(248)==1) THEN
+        IF (KEEP(248)==1
+     &     ) THEN
             CALL MPI_BCAST( NBCOL_INBLOC,1, MPI_INTEGER,
      &           MASTER, id%COMM,IERR)
         ELSE
           NBCOL_INBLOC = NBRHS_EFF
         ENDIF
         JEND_RHS =JBEG_RHS + NBCOL_INBLOC - 1
+        IF ((KEEP(248).EQ.1).AND.(KEEP(237).EQ.0)) THEN
+C         Only case (in previous block) for which
+C         NBRHS_EFF has been modified only on master
+          ! case of general sparse: in case of empty columns
+          ! modifed version of
+          ! NBRHS_EFF need be broadcasted since it is used
+          ! to update BEG_RHS at the end of the DO WHILE
+            CALL MPI_BCAST( NBRHS_EFF,1, MPI_INTEGER,
+     &           MASTER, id%COMM,IERR)
+            CALL MPI_BCAST(NB_RHSSKIPPED,1,MPI_INTEGER,MASTER,
+     &               id%COMM,IERR)
+        ENDIF
         IF ((KEEP(111).eq.0).AND.(KEEP(252).EQ.0)
      &      .AND.(KEEP(221).NE.2 ).AND.(KEEP(248).EQ.1) ) THEN
-C         ----------------------------
+C{        ----------------------------
 C         -- SPARSE RIGHT-HAND-SIDE
 C         ----------------------------
           CALL MPI_BCAST( NZ_THIS_BLOCK,1, MPI_INTEGER,
@@ -3164,162 +3445,492 @@ C ======================================
      &             MPI_INTEGER,
      &             MASTER, id%COMM,IERR)
           ENDIF
+C}
         ENDIF
 C
 C       =========================================================
-C       INITIALIZE POSINRHSCOMP_ROW/COL, RHSCOMP and related data
-C       For distributed RHS, initialize RHSMAPINFO (at 1st block)
+C       INITIALIZE 
+C       - nodes_FWD and nodes_BWD
 C       =========================================================
-        IF ( I_AM_SLAVE ) THEN
-C         --------------------------------------------------
-C         If I am involved in the solve and if
-C         either
-C           no null space comput (keep(111)=0) and sparse rhs
-C         or
-C             null space computation
-C         then
-C           compute POSINRHSCOMP
-C         endif
+        IF (FIRST_CALL_NODES_FWD_BWD) THEN
+C{         First time SMUMPS_NODES_FWD_BWD_SIZE_FILL 
+C          is called allocated Pruned_Sons_FWD
+           IF (allocated(Pruned_Sons_FWD)) THEN 
+             NB_BYTES = NB_BYTES - size(Pruned_Sons_FWD) * K34_8
+             DEALLOCATE(Pruned_Sons_FWD)
+           ENDIF
+           IF (allocated(Pruned_Sons_BWD)) THEN 
+            NB_BYTES = NB_BYTES - size(Pruned_Sons_BWD) * K34_8
+            DEALLOCATE(Pruned_Sons_BWD)
+           ENDIF
+           ALLOCATE (Pruned_Sons_FWD(KEEP(28)),
+     &             Pruned_Sons_BWD(KEEP(28)), 
+     &             stat=allocok)
+           IF (allocok .GT. 0 ) THEN
+            INFO(1)=-13
+            INFO(2)= 2*KEEP(28)
+           ELSE
+            NB_BYTES = NB_BYTES + 
+     &                int(size(Pruned_Sons_FWD),8)*K34_8 +
+     &                int(size(Pruned_Sons_BWD),8)*K34_8 
+            NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
+           ENDIF
+C}
+        ENDIF
+C =====================  ERROR handling and propagation ==============
+        CALL MUMPS_PROPINFO( ICNTL(1), INFO(1),
+     &                       id%COMM,id%MYID)
+        IF (INFO(1) .LT.0 ) GOTO 90
+C=====================================================================
+C       Reset FIRST_CALL_NODES_FWD_BWD for not allocating
+C       (Pruned_Sons_FWD/BWD within loop)
+        FIRST_CALL_NODES_FWD_BWD = .FALSE.
 C
-C         Fwd in facto: in this case only POSINRHSCOMP need be computed
+        IF (CALL_NODES_FWD_BWD) THEN
+C{
+          fill = .FALSE.
+          nodes_FWD_PTR => IDUMMY_TARGET
+          Lnodes_FWD_PTR = 1
+          nodes_BWD_PTR => IDUMMY_TARGET
+          Lnodes_BWD_PTR = 1
+          CALL SMUMPS_NODES_FWD_BWD_SIZE_FILL (
+     &           fill, id%ICNTL(1), 
+     &           id%N, id%KEEP(28),  id%KEEP(1), 
+     &           id%STEP(1), id%Step2node(1),
+     &           IRHS_loc_PTR(1), id%Nloc_RHS,
+     &           IRHS_PTR_COPY(1), NBCOL_INBLOC, IRHS_SPARSE_COPY(1), 
+     &           NZ_THIS_BLOCK, PERM_RHS, size(PERM_RHS), JBEG_RHS,
+     &           UNS_PERM_INV, size(UNS_PERM_INV), ! size 1 if not used
+     &           ICNTL21, 
+     &           id%MYID, id%COMM,
+     &           id%INFO,
+     &           Pruned_Sons_FWD, Pruned_Sons_BWD,
+     &           Lnodes_FWD, Lnodes_BWD
+     &           , nodes_FWD_PTR(1), nodes_BWD_PTR(1)
+     &           , Lnodes_FWD_PTR, Lnodes_BWD_PTR
+     &           )
+C     
+C        ALLOCATE nodes_FWD and nodes_BWD  if needed
+C
+          IF (Lnodes_FWD.GT.0) THEN
+C           NBT is inout in MUMPS_REALLOC and should be initialized.
+            NBT = 0
+            CALL MUMPS_REALLOC(nodes_FWD, Lnodes_FWD, id%INFO, LP,
+     &         FORCE=.FALSE.,
+     &         STRING='nodes_FWD', MEMCNT=NBT, ERRCODE=-13)
+            IF (INFO(1).LT.0) GOTO 46
+C
+            nodes_FWD_PTR => nodes_FWD
+            Lnodes_FWD_PTR = Lnodes_FWD
+            NB_BYTES = NB_BYTES + NBT
+            NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
+          ELSE
+            nodes_FWD_PTR => IDUMMY_TARGET
+            Lnodes_FWD_PTR = 1
+          ENDIF
+          IF (Lnodes_BWD.GT.0) THEN
+C           NBT is inout in MUMPS_REALLOC and should be initialized.
+            NBT = 0
+            CALL MUMPS_REALLOC(nodes_BWD, Lnodes_BWD, id%INFO, LP,
+     &         FORCE=.FALSE.,
+     &         STRING='nodes_BWD', MEMCNT=NBT, ERRCODE=-13)
+            IF (INFO(1).LT.0) GOTO 46
+C
+            nodes_BWD_PTR => nodes_BWD
+            Lnodes_BWD_PTR = Lnodes_BWD
+            NB_BYTES = NB_BYTES + NBT
+            NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
+          ELSE
+            nodes_BWD_PTR => IDUMMY_TARGET
+            Lnodes_BWD_PTR = 1
+          ENDIF
 C
-C         (POSINRHSCOMP_ROW/COL indirection arrays should
+C =====================  ERROR handling and propagation ==============
+ 46       CONTINUE
+          CALL MUMPS_PROPINFO( ICNTL(1), INFO(1),
+     &                         id%COMM,id%MYID)
+          IF (INFO(1) .LT.0 ) GOTO 90
+C=====================================================================
+          IF (Lnodes_FWD.GT.0 .OR. Lnodes_BWD.GT.0) THEN
+C{
+C          we build nodes_FWD_PTR and/or nodes_BWD_PTR
+C          that will be used to prune flops 
+C          and even if one of the steps FWD/BWD does not
+C          lead to pruning (in this case 
+C          POSTINRHS_COMP will not benefit from pruning).
+           fill = .TRUE.
+           CALL SMUMPS_NODES_FWD_BWD_SIZE_FILL (
+     &           fill, id%ICNTL(1), 
+     &           id%N, id%KEEP(28),  id%KEEP(1), 
+     &           id%STEP(1), id%Step2node(1),
+     &           IRHS_loc_PTR(1), id%Nloc_RHS,
+     &           IRHS_PTR_COPY(1), NBCOL_INBLOC, IRHS_SPARSE_COPY(1), 
+     &           NZ_THIS_BLOCK, PERM_RHS, size(PERM_RHS), JBEG_RHS,
+     &           UNS_PERM_INV, size(UNS_PERM_INV), ! size 1 if not used
+     &           ICNTL21, 
+     &           id%MYID, id%COMM,
+     &           id%INFO, 
+     &           Pruned_Sons_FWD, Pruned_Sons_BWD,
+     &           Lnodes_FWD, Lnodes_BWD
+     &           , nodes_FWD_PTR(1), nodes_BWD_PTR(1)
+     &           , Lnodes_FWD_PTR, Lnodes_BWD_PTR
+     &           )
+C}
+          ENDIF
+C         ------------------------------------------------
+C         Update CALL_NODES_FWD_BWD and free workspace if 
+C         not used again in loop of RHS
+C         ------------------------------------------------
+          IF (
+     &          (KEEP(237) .NE. 0).OR.                   ! AM1
+     &          ((KEEP(235) .NE. 0).AND.KEEP(248).NE.-1) ! GS
+     &       ) THEN
+C           target nodes for chain pruning 
+C           need be updated in case of AM1 or General Sparse
+            CALL_NODES_FWD_BWD = .TRUE.
+          ELSE
+C           all other cases including 
+C           distributed RHS and distributed solution 
+            CALL_NODES_FWD_BWD = .FALSE.
+          ENDIF
+          IF (.NOT. CALL_NODES_FWD_BWD
+     &       ) THEN
+C           Not needed anymore in the loop of RHS
+            IF (allocated(Pruned_Sons_FWD)) THEN 
+             NB_BYTES = NB_BYTES - size(Pruned_Sons_FWD) * K34_8
+             DEALLOCATE(Pruned_Sons_FWD)
+            ENDIF
+            IF (allocated(Pruned_Sons_BWD)) THEN 
+             NB_BYTES = NB_BYTES - size(Pruned_Sons_BWD) * K34_8
+             DEALLOCATE(Pruned_Sons_BWD)
+            ENDIF
+C         ELSE
+C           deallocate later
+          ENDIF
+C}
+        ENDIF
+C       =========================================================
+C       INITIALIZE 
+C       - GLOB2LOC_RHS/SOL, RHSINTR and related data
+C       - For distributed RHS, initialize RHSMAPINFO (at 1st block)
+C       =========================================================
+C         
+C         Fwd in facto: in this case we peronrly peonly POSINRHSINTR need be computed
+C
+C         (GLOB2LOC_RHS/SOL indirection arrays should
 C         have been allocated once outside loop)
-C         Compute size of RHSCOMP since it might depend
+C         Compute size of RHSINTR since it might depend
 C            on the process index and of the sparsity of the RHS
 C            if it is exploited.
-C         Initialize POSINRHSCOMP_ROW/COL
+C         Initialize GLOB2LOC_RHS/SOL
 C
-C         Note that LD_RHSCOMP and id%KEEP8(25)
+C         Note that id%LD_RHSINTR and id%KEEP8(25)
 C         are not set on the host in this routine in
 C         the case of a non-working host.
-C         Note that POSINRHSCOMP is now always computed in SOL_DRIVER
+C         Note that POSINRHSINTR is now always computed in SOL_DRIVER
 C         at least during the first block of RHS when sparsity of RHS
 C         is not exploited.
 C         -------------------------------
-C         INITTIALZE POSINRHSCOMP_ROW/COL
+C         INITTIALZE GLOB2LOC_RHS/SOL
 C         -------------------------------
 C
-          IF ( KEEP(221).EQ.2 .AND. KEEP(252).EQ.0
-     &      .AND.  (KEEP(248).NE.1 .OR. (id%NRHS.EQ.1))
-     &      ) THEN
-C           Reduced RHS was already computed during
-C           a previous forward step AND is valid.
-C           By valid we mean:
-C            -no forward in facto  (KEEP(252)==0) during which
-C             POSINRHSCOMP was not computed
-C           AND
-C            -no exploit sparsity with multiple RHS
-C            because in this case POSINRHSCOMP would
-C            be valid only for the last block processed during fwd.
-C           In those cases since we only perform the backward step, we do not
-C           need to compute POSINRHSCOMP
-            BUILD_POSINRHSCOMP = .FALSE.
-          ENDIF
+C       next block ok for Schur only
+        IF ( KEEP(221).EQ.2 .AND. KEEP(252).EQ.0
+     &    .AND.  (KEEP(248).NE.1 .OR. (id%NRHS.EQ.1))
+     &    ) THEN
+C         Reduced RHS (Schur feature) was already computed during
+C         a previous forward step AND is valid.
+C         By valid we mean:
+C          -no forward in facto  (KEEP(252)==0) during which
+C           POSINRHSINTR was not computed
+C         AND
+C          -no exploit sparsity with multiple RHS
+C          because in this case POSINRHSINTR would
+C          be valid only for the last block processed during fwd.
+C         In those cases since we only perform the backward step, 
+c         we do not need to compute POSINRHSINTR
+          BUILD_POSINRHSINTR = .FALSE.
+        ENDIF
 C         ------------------------
-C         INITIALIZE POSINRHSCOMP
+C         INITIALIZE POSINRHSINTR
 C         ------------------------
-          IF (BUILD_POSINRHSCOMP) THEN
-C           -- we first set MTYPE_LOC and
-C           -- reset BUILD_POSINRHSCOMP for next iteration in loop
-C
-C           general case only POSINRHSCOMP is computed
-            BUILD_POSINRHSCOMP = .FALSE.
-!           POSINRHSCOMP does not change between blocks
-            MTYPE_LOC = MTYPE
+        IF (BUILD_POSINRHSINTR) THEN
+C{        -- we first set MTYPE_LOC and
+C         -- reset BUILD_POSINRHSINTR for next iteration in loop
+C
+C         general case only POSINRHSINTR is computed
+          BUILD_POSINRHSINTR = .FALSE.
+!         POSINRHSINTR does not change between blocks
+          MTYPE_LOC = MTYPE
 C
-            IF ( (KEEP(111).NE.0) .OR. (KEEP(237).NE.0) .OR.
+          IF ( (KEEP(111).NE.0) .OR. (KEEP(237).NE.0) .OR.
      &         (KEEP(252).NE.0) ) THEN
 C
-              IF (KEEP(111).NE.0) THEN
-C               -- in the context of null space, we need to
-C               -- build RHSCOMP to skip SOL_R. Therefore
-C               -- we need to know for each concerned
-C               -- row index its position in
-C               -- RHSCOMP
-C               We use row indices, as these are the ones that
-C               were used to detect zero pivots during factorization.
-C               POSINRHSCOMP_ROW will allow to find the (row) index of a
-C               zero in RHSCOMP before calling SMUMPS_SOL_S. Then
-C               SMUMPS_SOL_S uses column indices to build the solution
-C               (corresponding to null space vectors)
-                MTYPE_LOC = 1
-              ELSE IF  (KEEP(252).NE.0) THEN
-C               -- Fwd in facto: since fwd is skipped we need to build POSINRHSCOMP
-                MTYPE_LOC = 1  ! (no transpose)
-C     BUILD_POSINRHSCOMP = .FALSE.  ! POSINRHSCOMP does not change between blocks
-              ELSE
-C               -- A-1 only
-                MTYPE_LOC = MTYPE
-                BUILD_POSINRHSCOMP = .TRUE.
-              ENDIF
+            IF (KEEP(111).NE.0) THEN
+C             -- in the context of null space, we need to
+C             -- build RHSINTR to skip SOL_R. Therefore
+C             -- we need to know for each concerned
+C             -- row index its position in
+C             -- RHSINTR
+C             We use row indices, as these are the ones that
+C             were used to detect zero pivots during factorization.
+C             GLOB2LOC_RHS will allow to find the (row) index of a
+C             zero in RHSINTR before calling SMUMPS_SOL_S. Then
+C             SMUMPS_SOL_S uses column indices to build the solution
+C             (corresponding to null space vectors)
+              MTYPE_LOC = 1
+            ELSE IF  (KEEP(252).NE.0) THEN
+C             -- Fwd in facto: since fwd is skipped we need to build POSINRHSINTR
+              MTYPE_LOC = 1  ! (no transpose)
+            ELSE
+C             -- A-1 only
+              MTYPE_LOC = MTYPE
+              BUILD_POSINRHSINTR = .TRUE.
             ENDIF
-C           -- compute POSINRHSCOMP
-            LIW_PASSED=max(1,LIW)
-            IF (KEEP(237).EQ.0) THEN
-              CALL SMUMPS_BUILD_POSINRHSCOMP(
+          ENDIF
+C         -- compute POSINRHSINTR
+          LIW_PASSED=max(1,LIW)
+          IF ( 
+C                no sparsity at fwd or bwd:
+     &           (Lnodes_FWD.EQ.-1).OR.(Lnodes_BWD.EQ.-1)
+C              
+     &          ) THEN
+C
+C           RHSINTR is not sparse (in the sense that it has N rows
+C           distributed on the MPI procs) and thus POSINRHSINTR
+C           does not change with loop.
+C           Remarks:
+C             1/ sparsity might still be exploited during 
+C                fwd or bwd to reduce the number of operations.
+C             2/ 
+            BUILD_POSINRHSINTR = .FALSE.
+C
+            IF ( I_AM_SLAVE ) THEN
+C{
+              CALL SMUMPS_BUILD_GLOB2LOC(
      &           id%NSLAVES,id%N,
      &           id%MYID_NODES, id%PTLUST_S(1),
      &           id%KEEP(1),id%KEEP8(1),
      &           id%PROCNODE_STEPS(1), id%IS(1), LIW_PASSED,
      &           id%STEP(1),
-     &           id%POSINRHSCOMP_ROW(1), id%POSINRHSCOMP_COL(1),
-     &           id%POSINRHSCOMP_COL_ALLOC,
+     &           id%GLOB2LOC_RHS(1), id%GLOB2LOC_SOL(1),
+     &           id%GLOB2LOC_SOL_ALLOC,
      &           MTYPE_LOC,
-     &           NBENT_RHSCOMP, NB_FS_RHSCOMP_TOT )
-                NB_FS_RHSCOMP_F = NB_FS_RHSCOMP_TOT
-            ELSE
-              CALL SMUMPS_BUILD_POSINRHSCOMP_AM1(
+     &           NBENT_RHSINTR, NB_FS_RHSINTR_TOT )
+                NB_FS_RHSINTR_F = NB_FS_RHSINTR_TOT
+C}
+            ENDIF
+C
+          ELSE 
+C
+C  Note that POSINRHSINTR* need not be recomputed before IR :
+C  because distributed solution => NO IR.
+C
+C           Exploit sparsity in solution and RHS 
+C           (AM1 or (Sparse RHS and solution) )
+C           Since sparsity is exploited during
+C           both fwd and bwd then we need to recompute 
+C           POSINRHSINTR only  when CALL_NODES_FWD_BWD will
+C           be performed at next iteration.
+            IF (CALL_NODES_FWD_BWD) BUILD_POSINRHSINTR = .TRUE.
+C
+            IF ( I_AM_SLAVE ) THEN
+C{
+              CALL SMUMPS_BUILD_GLOB2LOC_NODES_ES(
      &           id%NSLAVES,id%N,
      &           id%MYID_NODES, id%PTLUST_S(1), id%DAD_STEPS(1),
      &           id%KEEP(1),id%KEEP8(1),
      &           id%PROCNODE_STEPS(1), id%IS(1), LIW,
      &           id%STEP(1),
-     &           id%POSINRHSCOMP_ROW(1), id%POSINRHSCOMP_COL(1),
-     &           id%POSINRHSCOMP_COL_ALLOC,
+C
+     &            Lnodes_FWD, Lnodes_BWD,
+     &            nodes_FWD_PTR(1), nodes_BWD_PTR(1),
+C
+     &           id%GLOB2LOC_RHS(1), id%GLOB2LOC_SOL(1),
+     &           id%GLOB2LOC_SOL_ALLOC,
      &           MTYPE_LOC,
-     &           IRHS_PTR_COPY(1), NBCOL_INBLOC, IRHS_SPARSE_COPY(1),
-     &           NZ_THIS_BLOCK,PERM_RHS, size(PERM_RHS) , JBEG_RHS,
-     &           NBENT_RHSCOMP,
-     &           NB_FS_RHSCOMP_F, NB_FS_RHSCOMP_TOT,
-     &            UNS_PERM_INV, size(UNS_PERM_INV) ! size 1 if not used
-     &            )
+     &           NBENT_RHSINTR,
+     &           NB_FS_RHSINTR_F, NB_FS_RHSINTR_TOT
+     &           )
+C}
             ENDIF
-          ENDIF   ! BUILD_POSINRHSCOMP=.TRUE.
-          IF (BUILD_RHSMAPINFO .AND. KEEP(248).EQ.-1) THEN
+          ENDIF
+C}
+        ENDIF   ! BUILD_POSINRHSINTR=.TRUE.
+        IF (BUILD_RHSMAPINFO .AND. KEEP(248).EQ.-1
+     &        ) THEN
 C
 C           Prepare symbolic data for sends.
-C           For the moment: MAP_RHS_loc
+C           For the moment: only MAP_RHS_loc
 C
+C           id%GLOB2LOC_RHS is always associated to the
+C           forward step (with or without transposed system)
+          IF ( I_AM_SLAVE ) THEN
+C{
             CALL MUMPS_SOL_RHSMAPINFO( id%N, id%Nloc_RHS, id%KEEP(89),
-     &            IRHS_loc_PTR(1), MAP_RHS_loc, id%POSINRHSCOMP_ROW(1),
+     &            IRHS_loc_PTR(1), MAP_RHS_loc, id%GLOB2LOC_RHS(1),
      &            id%NSLAVES, id%MYID_NODES,
      &            id%COMM_NODES, id%ICNTL(1), id%INFO(1) )
             BUILD_RHSMAPINFO = .FALSE.
 C           MUMPS_SOL_RHSMAPINFO does not propagate errors
-          ENDIF
+C}
+          ENDIF ! I_AM_SLAVE
         ENDIF
         CALL MUMPS_PROPINFO( ICNTL(1), INFO(1),
      &                   id%COMM,id%MYID)
         IF (INFO(1) .LT.0 ) GOTO 90
+        IF ( BUILD_SCALING_RHSINTR ) THEN
+C{
+          IF (SCALING_RHSINTR_BWD_ALLOCATED) THEN
+            NB_BYTES = NB_BYTES - LSCALING_RHSINTR_BWD * K16_8
+            DEALLOCATE(SCALING_RHSINTR_BWD)
+          ENDIF
+          IF (SCALING_RHSINTR_FWD_ALLOCATED) THEN
+            NB_BYTES = NB_BYTES - LSCALING_RHSINTR_FWD * K16_8
+            DEALLOCATE(SCALING_RHSINTR_FWD)
+          ENDIF
+          NULLIFY(SCALING_RHSINTR_BWD)
+          NULLIFY(SCALING_RHSINTR_FWD)
+          SCALING_RHSINTR_BWD_ALLOCATED = .FALSE.
+          SCALING_RHSINTR_FWD_ALLOCATED = .FALSE.
+          SCALING_RHSINTR_BWD => RDUMMY_TARGET
+          SCALING_RHSINTR_FWD => RDUMMY_TARGET
+          LSCALING_RHSINTR_BWD = 1
+          LSCALING_RHSINTR_FWD = 1
+C         Define or allocate SCALING_RHSINTR if needed:
+          IF (LSCAL .AND. I_AM_SLAVE ) THEN
+            IF (KEEP(221).EQ.2) THEN
+C             In case of sparsity during bwd, we cannot
+C             rely on the value of Lnodes_FWD to know
+C             whether the scaling will match SCALING_LOC
+C             and should thus consider that (Lnodes_FWD.NE.-1)
+              ES_RHSINTR = (Lnodes_BWD.NE.-1)
+            ELSE
+C             sparsity at fwd and at bwd:
+              ES_RHSINTR = (Lnodes_FWD.NE.-1).AND.(Lnodes_BWD.NE.-1)
+            ENDIF
+C           Scaling allocations performed only if needed
+C             Forward or normal solve:
+              IF ( ES_RHSINTR ) THEN
+                LSCALING_RHSINTR_FWD = max(1, NB_FS_RHSINTR_F )
+                ALLOCATE(SCALING_RHSINTR_FWD(LSCALING_RHSINTR_FWD),
+     &                   stat=allocok)
+                IF (allocok .GT. 0) THEN
+                  INFO(1)=-13
+                  INFO(2)=LSCALING_RHSINTR_FWD
+                ELSE
+                  SCALING_RHSINTR_FWD_ALLOCATED = .TRUE.
+                  NB_BYTES = NB_BYTES + LSCALING_RHSINTR_FWD * K16_8
+                ENDIF
+              ELSE
+C               RHSINTR matches SCALING_loc, no need to
+C               allocate and compute a different scaling
+                LSCALING_RHSINTR_FWD = max(1,KEEP(89))
+#if defined(USE_OLD_SCALING)
+#else
+                SCALING_RHSINTR_FWD => SCALING_LOC_FWD
+#endif
+              ENDIF
+              IF (ES_RHSINTR) THEN
+                  LSCALING_RHSINTR_BWD = max(1, NB_FS_RHSINTR_TOT )
+                ALLOCATE(SCALING_RHSINTR_BWD(LSCALING_RHSINTR_BWD),
+     &                   stat=allocok)
+                IF (allocok .GT. 0) THEN
+                  INFO(1)=-13
+                  INFO(2)=LSCALING_RHSINTR_BWD
+                ELSE
+                  SCALING_RHSINTR_BWD_ALLOCATED = .TRUE.
+                  NB_BYTES = NB_BYTES + LSCALING_RHSINTR_BWD * K16_8
+                ENDIF
+              ELSE
+C               RHSINTR matches SCALING_loc, no need to
+C               allocate and compute a different scaling
+                LSCALING_RHSINTR_BWD = max(1,KEEP(89))
+#if defined(USE_OLD_SCALING)
+                SCALING_RHSINTR_BWD => scaling_data_sol%SCALING_LOC
+#else
+                SCALING_RHSINTR_BWD => SCALING_LOC_BWD
+                SCALING_RHSINTR_FWD => SCALING_LOC_FWD
+#endif
+              ENDIF
+          ENDIF
+C}
+        ENDIF
+        CALL MUMPS_PROPINFO( id%ICNTL, id%INFO, id%COMM,id%MYID)
+        IF (id%INFO(1) .LT.0 ) GOTO 90
+        IF (BUILD_SCALING_RHSINTR) THEN
+C{
+          IF ( LSCAL .AND. I_AM_SLAVE. AND. ES_RHSINTR ) THEN
+#if ! defined(USE_OLD_SCALING)
+C             SCALING_RHSINTR_FWD has been allocated and should
+C             now be filled. It is a compressed version of the
+C             local scaling array SCALING_LOC_FWD:
+              IF (MTYPE.eq.0 .AND. KEEP(50).EQ.0) THEN ! tranpose
+                ROWORCOL = 2 ! access 2nd list -- col indices
+              ELSE
+                ROWORCOL = 1 ! access 1st list -- row indices
+              ENDIF
+              CALL SMUMPS_SCALINGRHSINTR(LSCAL, id%N,
+     &             SCALING_LOC_FWD(1),
+     &             SCALING_RHSINTR_FWD(1),
+     &             LSCALING_RHSINTR_FWD, id%GLOB2LOC_RHS(1),
+     &             id%KEEP, ROWORCOL, id%PTLUST_S(1),
+     &             id%IS(1), max(1,LIW),
+     &             id%MYID_NODES, id%STEP(1), id%PROCNODE_STEPS(1),
+     &             id%NSLAVES)
+C             SCALING_RHSINTR_BWD has been allocated and should
+C             now be filled. It is a compressed version of the
+C             local scaling array SCALING_LOC_BWD:
+              IF (MTYPE.eq.1 .AND. KEEP(50).EQ.0) THEN ! no tranpose
+C               access 2nd list corresponding to col indices
+                ROWORCOL = 2 
+              ELSE
+C               access 1st list corresponding to row indices
+                ROWORCOL = 1 
+              ENDIF
+              CALL SMUMPS_SCALINGRHSINTR(LSCAL, id%N,
+     &             SCALING_LOC_BWD(1),
+     &             SCALING_RHSINTR_BWD(1),
+     &             LSCALING_RHSINTR_BWD, id%GLOB2LOC_SOL(1),
+     &             id%KEEP, ROWORCOL, id%PTLUST_S(1),
+     &             id%IS(1), max(1,LIW),
+     &             id%MYID_NODES, id%STEP(1), id%PROCNODE_STEPS(1),
+     &             id%NSLAVES)
+#endif
+#if defined(USE_OLD_SCALING)
+#endif
+          ENDIF
+C         Rebuild SCALING_RHSINTR* next time
+C         only if POSINRHSINTR has to be built
+C         again next time:
+          BUILD_SCALING_RHSINTR= BUILD_POSINRHSINTR
+C}
+        ENDIF
         IF (I_AM_SLAVE) THEN
-          IF (KEEP(221).EQ.1) THEN
-C           we need to save the reduced RHS for all RHS to perform
-C           later the backward phase with an updated reduced RHS
-C           thus we allocate NRHS_NONEMPTY columns in one shot.
-C           Note that RHSCOMP might have been allocated in previous block
-C           and RHSCOMP has been deallocated previous to entering loop on RHS
-            IF (.not. associated(id%RHSCOMP)) THEN
+          IF ((KEEP(221).EQ.1).OR.KEEP(221).EQ.-1) THEN
+C         For the following cases:
+C          -[Schur] we need to save the reduced RHS for all RHS 
+C                 to perform later the backward phase with an
+C                 updated reduced RHS
+C          -[Fwd only] return RHSINTR to user
+C          -KEEP(221)=-1, allocate RHSINTR to enable bwd only step
+C         We need to allocate NRHS_NONEMPTY columns in one shot.
+C         Note that 
+C            -RHSINTR might have been allocated in previous block
+C            -RHSINTR has been deallocated previous to entering 
+C             loop on RHS
+            IF (.not. associated(id%RHSINTR)) THEN
 C             So far we cannot combine this to exploit sparsity
-C             so that NBENT_RHSCOMP will not change in the loop
-C             and can be used to dimension RHSCOMP
+C             so that NBENT_RHSINTR will not change in the loop
+C             and can be used to dimension RHSINTR
+C
 C             Furthermore, during bwd phase the REDRHS provided
 C             by the user might also have a different non empty
 C             column pattern than the sparse RHS provided on input to
 C             this phase: thus we need to allocate id%NRHS columns too.
-              LD_RHSCOMP = max(NBENT_RHSCOMP,1)
-              id%KEEP8(25) = int(LD_RHSCOMP,8)*int(id%NRHS,8)
-              ALLOCATE (id%RHSCOMP(id%KEEP8(25)),  stat = allocok)
+              id%LD_RHSINTR = max(NBENT_RHSINTR,1)
+              id%KEEP8(25) = int(id%LD_RHSINTR,8)*int(id%NRHS,8)
+              ALLOCATE (id%RHSINTR(id%KEEP8(25)),  stat = allocok)
               IF ( allocok .GT. 0 ) THEN
                  INFO(1)=-13
                  CALL MUMPS_SET_IERROR(id%KEEP8(25),INFO(2))
@@ -3330,34 +3941,35 @@ C             this phase: thus we need t
               NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
             ENDIF
           ENDIF
-          IF ((KEEP(221).NE.1).AND.
+C 
+C
+          IF ((KEEP(221).NE.1).AND. 
      &        ((KEEP(221).NE.2).OR.(KEEP(252).NE.0))
      &       ) THEN
 C           ------------------
-C           Allocate RHSCOMP (case of RHSCOMP allocated at each block of RHS)
+C           Allocate RHSINTR
+C           (case of RHSINTR allocated at each block of RHS)
 C           ------------------
-C           RHSCOMP allocated per block of maximum size NBRHS
-            LD_RHSCOMP = max(NBENT_RHSCOMP, LD_RHSCOMP)
+C           RHSINTR allocated per block of maximum size NBRHS
 C           NBRHS_EFF could be used instead on NBRHS
-            IF (associated(id%RHSCOMP)) THEN
-              IF ( (id%KEEP8(25).LT.int(LD_RHSCOMP,8)*int(NBRHS,8))
-     &          .OR. (KEEP(235).NE.0).OR.(KEEP(237).NE.0) ) THEN
-                ! deallocate and reallocate if:
-                ! _larger array needed
-                ! OR 
-                ! _exploit sparsity/A-1: since size of RHSCOMP 
-                ! is expected to vary much in these cases
-                ! this should improve locality
+            IF (associated(id%RHSINTR)) THEN
+C             RHSINTR already associated for previous
+C             block, check if we can reuse it.
+              id%LD_RHSINTR = max(NBENT_RHSINTR, 1)
+              IF (id%KEEP8(25).LT.int(id%LD_RHSINTR,8)*int(NBRHS,8))
+     &        THEN
+                ! deallocate and reallocate since larger array is needed
                  NB_BYTES = NB_BYTES - id%KEEP8(25)*K35_8
-                 DEALLOCATE(id%RHSCOMP)
-                 NULLIFY(id%RHSCOMP)
-                 id%KEEP8(25)=0_8
+                 DEALLOCATE(id%RHSINTR)
+                 NULLIFY(id%RHSINTR)
+                 id%KEEP8(25)  = 0_8
+                 id%LD_RHSINTR = 0
               ENDIF
             ENDIF
-            IF (.not. associated(id%RHSCOMP)) THEN
-              LD_RHSCOMP = max(NBENT_RHSCOMP, 1)
-              id%KEEP8(25) = int(LD_RHSCOMP,8)*int(NBRHS,8)
-              ALLOCATE (id%RHSCOMP(id%KEEP8(25)),  stat = allocok )
+            IF (.not. associated(id%RHSINTR)) THEN
+              id%LD_RHSINTR = max(NBENT_RHSINTR, 1)
+              id%KEEP8(25) = int(id%LD_RHSINTR,8)*int(NBRHS,8)
+              ALLOCATE (id%RHSINTR(id%KEEP8(25)),  stat = allocok )
               IF ( allocok .GT. 0 ) THEN
                INFO(1)=-13
                CALL MUMPS_SET_IERROR(id%KEEP8(25),INFO(2))
@@ -3367,22 +3979,16 @@ C           NBRHS_EFF could be used inst
               NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
             ENDIF
           ENDIF
-          IF (KEEP(221).EQ.2) THEN
-C           RHSCOMP has been allocated (call with KEEP(221).EQ.1)
-C           even in the case fwd in facto
-            ! Not correct: LD_RHSCOMP = LENRHSCOMP/id%NRHS_NONEMPTY
-            LD_RHSCOMP = int(id%KEEP8(25)/int(id%NRHS,8))
-          ENDIF
 C
-C         Shift on RHSCOMP
+C         Shift on RHSINTR
 C
           IF ( KEEP(221).EQ.0 ) THEN
-C            -- RHSCOMP reused in the loop
-             IBEG_RHSCOMP= 1_8
+C            -- RHSINTR reused in the loop
+             IBEG_RHSINTR= 1_8
           ELSE
-C            Initialize IBEG_RHSCOMP
+C            Initialize IBEG_RHSINTR
 C
-             IBEG_RHSCOMP= int(JBEG_RHS-1,8)*int(LD_RHSCOMP,8) + 1_8
+            IBEG_RHSINTR= int(JBEG_RHS-1,8)*int(id%LD_RHSINTR,8)+1_8
           ENDIF
         ENDIF   ! I_AM_SLAVE
 C =====================  ERROR handling and propagation ================
@@ -3396,7 +4002,8 @@ C       ---------------------------
 C       Prepare RHS on master (case
 C       of dense and sparse RHS)
 C       ---------------------------
-        IF (id%MYID .eq. MASTER) THEN
+        IF (id%MYID .eq. MASTER
+     &     ) THEN
 C         =========================
           IF (KEEP(23) .NE. 0) THEN
 C         =========================
@@ -3459,8 +4066,10 @@ C
               ENDDO
             ENDIF
           ENDIF
+#if defined(USE_OLD_SCALING)
 C
 C         RHS is set to scaled right hand side
+C         (case of centralized scaling only)
 C
           IF (LSCAL) THEN
 C           scaling was performed
@@ -3571,6 +4180,7 @@ C                     Original IRHS_PTR
               ENDIF
             ENDIF  ! KEEP(248)==1
           ENDIF  ! LSCAL
+#endif
         ENDIF  ! id%MYID.EQ.MASTER
 #if defined(V_T)
         CALL VTEND(perm_scal_ini,IERR)
@@ -3579,16 +4189,6 @@ C
 C       Prepare RHS on master
 C       END
 C       =====================
-        IF ((KEEP(248).EQ.1).AND.(KEEP(237).EQ.0)) THEN
-          ! case of general sparse: in case of empty columns
-          ! modifed version of
-          ! NBRHS_EFF need be broadcasted since it is used
-          ! to update BEG_RHS at the end of the DO WHILE
-            CALL MPI_BCAST( NBRHS_EFF,1, MPI_INTEGER,
-     &           MASTER, id%COMM,IERR)
-            CALL MPI_BCAST(NB_RHSSKIPPED,1,MPI_INTEGER,MASTER,
-     &               id%COMM,IERR)
-        ENDIF
 C       -----------------------------------
 C       Two main cases depending on option
 C       for null space computation:
@@ -3605,7 +4205,7 @@ C       --------------------------------
         TIMESCATTER1=MPI_WTIME()
         IF ((KEEP(111).eq.0).AND.(KEEP(252).EQ.0)
      &        .AND.(KEEP(221).NE.2 )) THEN
-C           ------------------------
+C{          ------------------------
 C           Use RHS provided by user
 C           when not null space and not Fwd in facto
 C           ------------------------
@@ -3616,7 +4216,7 @@ C             --------------------------
               IF ( .NOT.I_AM_SLAVE ) THEN
 C               -- Master not working
                 CALL SMUMPS_SCATTER_RHS(id%NSLAVES,id%N, id%MYID,
-     &          id%COMM,
+     &          id%COMM, LSCAL, SCALING_LOC_FWD(1),
      &          MTYPE, id%RHS(IBEG), LD_RHS, NBRHS_EFF,
      &          NBRHS_EFF,
      &          C_DUMMY, 1, 1,
@@ -3639,11 +4239,11 @@ C               -- Master not working
                 ENDIF
                 LIW_PASSED = max( LIW, 1 )
                 CALL SMUMPS_SCATTER_RHS(id%NSLAVES,id%N, id%MYID,
-     &          id%COMM,
+     &          id%COMM, LSCAL, SCALING_LOC_FWD(1),
      &          MTYPE, PTR_RHS(IBEG_loc),LD_RHS_loc,NCOL_RHS_loc,
      &          NBRHS_EFF,
-     &          id%RHSCOMP(IBEG_RHSCOMP), LD_RHSCOMP, NBRHS_EFF,
-     &          id%POSINRHSCOMP_ROW(1), NB_FS_RHSCOMP_F,
+     &          id%RHSINTR(IBEG_RHSINTR), id%LD_RHSINTR, NBRHS_EFF,
+     &          id%GLOB2LOC_RHS(1), NB_FS_RHSINTR_F,
 C
      &          id%PTLUST_S(1), id%KEEP(1), id%KEEP8(1),
      &          id%PROCNODE_STEPS(1),
@@ -3671,9 +4271,14 @@ C
      &          IRHS_loc_PTR(1),
      &          idRHS_loc(RHS_loc_shift),
      &          RHS_loc_size,
-     &          id%RHSCOMP(IBEG_RHSCOMP), LD_RHSCOMP,
-     &          id%POSINRHSCOMP_ROW(1), NB_FS_RHSCOMP_F,
-     &          LSCAL, scaling_data_dr,
+     &          id%RHSINTR(IBEG_RHSINTR), id%LD_RHSINTR,
+     &          id%GLOB2LOC_RHS(1), NB_FS_RHSINTR_F,
+     &          LSCAL,
+#if defined(USE_OLD_SCALING)
+     &          scaling_data_dr,
+#else
+     &          SCALING_RHSINTR_FWD(1), LSCALING_RHSINTR_FWD,
+#endif
      &          LP, LPOK, KEEP(1), NB_BYTES_LOC, INFO(1))
 C               NB_BYTES_LOC were allocated and freed above
                 NB_BYTES_MAX = max(NB_BYTES_MAX,
@@ -3686,14 +4291,20 @@ C               NB_BYTES_LOC were alloca
 C             ===  KEEP(248)==1 =========
 C             -- SPARSE RIGHT-HAND-SIDE
 C             ----------------------------
-              IF (NZ_THIS_BLOCK > 0) THEN
+              IF (NZ_THIS_BLOCK > 0
+#if ! defined(USE_OLD_SCALING)
+C               For AM1, no need to broadcast RHS_SPARSE
+C               when using local scalings. RHSINTR will
+C               be initialized directly and RHS_SPARSE
+C               is used during SMUMPS_GATHER_SOLUTION_AM1
+     &            .AND. id%KEEP(237) .EQ.0
+#endif
+     &        ) THEN
                 CALL MPI_BCAST(RHS_SPARSE_COPY(1),
      &                     NZ_THIS_BLOCK,
      &                     MPI_REAL,
      &                     MASTER, id%COMM, IERR)
               ENDIF
-C             -- At this point each process has a copy of the
-C             -- sparse RHS. We need to store it into RHSCOMP.
 C
               IF (KEEP(237).NE.0)  THEN
                 IF ( I_AM_SLAVE ) THEN
@@ -3701,37 +4312,43 @@ C                 -----
 C                 case of A-1
 C                 -----
 C                 - Take columns with non-zero entry, say j,
-C                 - to build Ej and store it in RHSCOMP
-                  K=1              ! Column index in RHSCOMP
-                  id%RHSCOMP(1_8:int(NBRHS_EFF,8)*int(LD_RHSCOMP,8))
+C                 - to build Ej and store it in RHSINTR
+                  K=1              ! Column index in RHSINTR
+                  id%RHSINTR(1_8:int(NBRHS_EFF,8)*int(id%LD_RHSINTR,8))
      &            = ZERO
                   IPOS = 1
                   DO I = 1, NBCOL_INBLOC
                     COLSIZE = IRHS_PTR_COPY(I+1) - IRHS_PTR_COPY(I)
                     IF (COLSIZE.GT.0) THEN
                       ! Find global column index J and set
-                      ! column K of RHSCOMP to ej (here IBEG is one)
+                      ! column K of RHSINTR to ej (here IBEG is one)
                       J = I - 1 + JBEG_RHS
                       IF (DO_PERMUTE_RHS.OR.INTERLEAVE_PAR) THEN
                         J = PERM_RHS(J)
                       ENDIF
-                      IPOSRHSCOMP = id%POSINRHSCOMP_ROW(J)
-C                     IF ( (IPOSRHSCOMP.LE.NB_FS_RHSCOMP_F)
-C     &               .AND.(IPOSRHSCOMP.GT.0) ) THEN
-                      IF (IPOSRHSCOMP.GT.0)  THEN
+                      IPOSRHSINTR = id%GLOB2LOC_RHS(J)
+C                     IF ( (IPOSRHSINTR.LE.NB_FS_RHSINTR_F)
+C     &               .AND.(IPOSRHSINTR.GT.0) ) THEN
+                      IF (IPOSRHSINTR.GT.0)  THEN
 C                       Columns J corresponds to ej and thus to variable j
-C                       that is on my proc
-C                       Note that :
-C                       In first entry in column
-C                       we have and MUST have already scaled value of diagonal.
-C                       This need have been done on master because we do not
-C                       have scaling arrays available on slaves.
-C                       Furthermore we know that only one entry is
-C                       needed the diagonal entry (for the forward with A-1).
-C
-                        id%RHSCOMP(int(K-1,8)*int(LD_RHSCOMP,8)+
-     &                       int(IPOSRHSCOMP,8)) =
+C                       that is on my proc.
+C                       We know that only one entry is needed,
+C                       the diagonal entry (for the forward with A-1).
+C
+#if defined(USE_OLD_SCALING)
+                        id%RHSINTR(int(K-1,8)*int(id%LD_RHSINTR,8)+
+     &                       int(IPOSRHSINTR,8)) =
      &                       RHS_SPARSE_COPY(IPOS)
+#else
+                        IF (LSCAL) THEN
+                          id%RHSINTR(int(K-1,8)*int(id%LD_RHSINTR,8)+
+     &                    int(IPOSRHSINTR,8)) =
+     &                    SCALING_RHSINTR_FWD(IPOSRHSINTR)
+                        ELSE
+                          id%RHSINTR(int(K-1,8)*int(id%LD_RHSINTR,8)+
+     &                    int(IPOSRHSINTR,8)) = ONE
+                        ENDIF
+#endif
                       ENDIF               ! End of J on my proc
                       K = K + 1
                       IPOS = IPOS + COLSIZE  ! go to next column
@@ -3750,12 +4367,14 @@ C               -------
 C               --------------
 C               General sparse
 C               --------------
-C               -- reset to zero RHSCOMP for skipped columns (if any)
+C               -- At this point each process has a copy of the
+C               -- sparse RHS. We need to store it into RHSINTR.
+C               -- reset to zero RHSINTR for skipped columns (if any)
                 IF ((KEEP(221).EQ.1).AND.(NB_RHSSKIPPED.GT.0)
      &            .AND.I_AM_SLAVE) THEN
                   DO K = JBEG_RHS-NB_RHSSKIPPED, JBEG_RHS-1
-                    DO I = 1,  LD_RHSCOMP
-                      id%RHSCOMP(int(K-1,8)*int(LD_RHSCOMP,8)
+                    DO I = 1,  id%LD_RHSINTR
+                      id%RHSINTR(int(K-1,8)*int(id%LD_RHSINTR,8)
      &                           + int(I,8)) =  ZERO
                     ENDDO
                   ENDDO
@@ -3763,36 +4382,62 @@ C               -- reset to zero RHSCOMP
                 IF (I_AM_SLAVE) THEN
                   DO K = 1, NBCOL_INBLOC
 !                   it is equal to NBRHS_EFF in this case
-                    KDEC = int(K-1,8) * int(LD_RHSCOMP,8) +
-     &                     IBEG_RHSCOMP - 1_8
-                    id%RHSCOMP(KDEC+1_8:KDEC+NBENT_RHSCOMP) = ZERO
-                    DO IZ=IRHS_PTR_COPY(K), IRHS_PTR_COPY(K+1)-1
-                      I=IRHS_SPARSE_COPY(IZ)
-                      IPOSRHSCOMP = id%POSINRHSCOMP_ROW(I)
-C                     Since all fully summed variables mapped
-C                     on each proc are stored at the beginning
-C                     of RHSCOMP, we can compare to KEEP(89)
-C                     to know if RHSCOMP should be initialized
-C                     So far the tree has not been pruned to exploit
-C                     sparsity to compress RHSCOMP so we compare to
-C                     NB_FS_RHSCOMP_TOT
-                      IF ( (IPOSRHSCOMP.LE.NB_FS_RHSCOMP_TOT)
-     &                .AND.(IPOSRHSCOMP.GT.0) ) THEN
-C                        ! I is fully summed var mapped on my proc
-                        id%RHSCOMP(KDEC+IPOSRHSCOMP)=
-     &                  id%RHSCOMP(KDEC+IPOSRHSCOMP) +
-     &                  RHS_SPARSE_COPY(IZ)
-                      ENDIF
-                    ENDDO
+                    KDEC = int(K-1,8) * int(id%LD_RHSINTR,8) +
+     &                     IBEG_RHSINTR - 1_8
+                    id%RHSINTR(KDEC+1_8:KDEC+NBENT_RHSINTR) = ZERO
+#if ! defined(USE_OLD_SCALING)
+                    IF (LSCAL) THEN
+                      DO IZ=IRHS_PTR_COPY(K), IRHS_PTR_COPY(K+1)-1
+                        I=IRHS_SPARSE_COPY(IZ)
+                        IPOSRHSINTR = id%GLOB2LOC_RHS(I)
+C                       Since all fully summed variables mapped
+C                       on each proc are stored at the beginning
+C                       of RHSINTR, we can compare to KEEP(89)
+C                       to know if RHSINTR should be initialized
+C                       So far the tree has not been pruned to exploit
+C                       sparsity to compress RHSINTR so we compare to
+C                       NB_FS_RHSINTR_TOT
+                        IF ( (IPOSRHSINTR.LE.NB_FS_RHSINTR_TOT)
+     &                  .AND.(IPOSRHSINTR.GT.0) ) THEN
+C                          ! I is fully summed var mapped on my proc
+                          id%RHSINTR(KDEC+IPOSRHSINTR)=
+     &                    id%RHSINTR(KDEC+IPOSRHSINTR) +
+     &                    RHS_SPARSE_COPY(IZ)
+     &                    * SCALING_RHSINTR_FWD(IPOSRHSINTR)
+                        ENDIF
+                      ENDDO
+                    ELSE
+#endif
+                      DO IZ=IRHS_PTR_COPY(K), IRHS_PTR_COPY(K+1)-1
+                        I=IRHS_SPARSE_COPY(IZ)
+                        IPOSRHSINTR = id%GLOB2LOC_RHS(I)
+C                       Since all fully summed variables mapped
+C                       on each proc are stored at the beginning
+C                       of RHSINTR, we can compare to KEEP(89)
+C                       to know if RHSINTR should be initialized
+C                       So far the tree has not been pruned to exploit
+C                       sparsity to compress RHSINTR so we compare to
+C                       NB_FS_RHSINTR_TOT
+                        IF ( (IPOSRHSINTR.LE.NB_FS_RHSINTR_TOT)
+     &                  .AND.(IPOSRHSINTR.GT.0) ) THEN
+C                          ! I is fully summed var mapped on my proc
+                          id%RHSINTR(KDEC+IPOSRHSINTR)=
+     &                    id%RHSINTR(KDEC+IPOSRHSINTR) +
+     &                    RHS_SPARSE_COPY(IZ)
+                        ENDIF
+                      ENDDO
+#if ! defined(USE_OLD_SCALING)
+                    ENDIF
+#endif
                   ENDDO
                 END IF ! I_AM_SLAVE
               ENDIF ! KEEP(237)
             ENDIF  ! ==== KEEP(248)==1 =====
-C
+C}
         ELSE IF (I_AM_SLAVE) THEN
             ! I_AM_SLAVE AND (null space or Fwd in facto)
             IF (KEEP(111).NE.0) THEN
-C             -----------------------
+C{            -----------------------
 C             Null space computations
 C             -----------------------
 C
@@ -3889,10 +4534,10 @@ C ======================================
 C               End IF Exploit Sparsity
               ENDIF
 c
-C             Initialize RHSCOMP to 0  ! to be suppressed
+C             Initialize RHSINTR to 0  ! to be suppressed
               DO K=1, NBRHS_EFF
-                KDEC = int(K-1,8) * int(LD_RHSCOMP,8)
-                id%RHSCOMP(KDEC+1_8:KDEC+int(LD_RHSCOMP,8))=ZERO
+                KDEC = int(K-1,8) * int(id%LD_RHSINTR,8)
+                id%RHSINTR(KDEC+1_8:KDEC+int(id%LD_RHSINTR,8))=ZERO
               END DO
 C             Loop over the columns.
 C             Note that if ( KEEP(220)+KEEP(109)-1 < IBEG_GLOB_DEF
@@ -3907,18 +4552,18 @@ C               step incompatible, do on
      &               min(IEND_GLOB_DEF,KEEP(220)+KEEP(109)-1)
 C                 Local processor is concerned by I-th column of
 C                 global right-hand side.
-                  JJ= id%POSINRHSCOMP_ROW(id%PIVNUL_LIST(I-KEEP(220)+1))
+                  JJ= id%GLOB2LOC_RHS(id%PIVNUL_LIST(I-KEEP(220)+1))
                   IF (JJ.GT.0) THEN
                     IF (KEEP(50).EQ.0) THEN
                       ! unsymmetric : always set to fixation
-                      id%RHSCOMP( IBEG_RHSCOMP+
-     &                    int(I-IBEG_GLOB_DEF,8)*int(LD_RHSCOMP,8) +
+                      id%RHSINTR( IBEG_RHSINTR+
+     &                    int(I-IBEG_GLOB_DEF,8)*int(id%LD_RHSINTR,8)+
      &                    int(JJ-1,8) ) =
      &                    id%DKEEP(2)
                     ELSE
                       ! Symmetric: always set to one
-                      id%RHSCOMP( IBEG_RHSCOMP+
-     &                int(I-IBEG_GLOB_DEF,8)*int(LD_RHSCOMP,8)+
+                      id%RHSINTR( IBEG_RHSINTR+
+     &                int(I-IBEG_GLOB_DEF,8)*int(id%LD_RHSINTR,8)+
      &                int(JJ-1,8) )=
      &                ONE
                     ENDIF
@@ -3949,9 +4594,10 @@ C               for this set of right-ha
                 IEND_ROOT_DEF = -95999
                 IROOT_DEF_RHS_COL1= 1
               ENDIF
+C}
             ELSE  ! End of null space (test on KEEP(111))
 C             case of Fwd in facto
-C             id%RHSCOMP need not be initialized. It will be set on the fly
+C             id%RHSINTR need not be initialized. It will be set on the fly
 C             to zero for normal fully summed variables of the fronts and
 C             to -1 on the roots for the id%N+KEEP(253) variables added
 C             to the roots.
@@ -3990,7 +4636,7 @@ C             Otherwise, we use workspac
             LWCB8_SOL_C = LWCB8_SOL_C - LPTR_RHS_ROOT
           ENDIF
         ENDIF
-        IF (KEEP(221) .EQ. 2 ) THEN
+        IF (KEEP(221) .EQ. 2 .AND. KEEP(60).NE.0 ) THEN
 C         Copy/send REDRHS in PTR_RHS_ROOT
 C         (column by column if leading dimension LD_REDRHS
 C         of REDRHS is not equal to SIZE_ROOT).
@@ -4053,13 +4699,13 @@ C         -- other procs are not concern
           LIW_PASSED = max( LIW, 1 )
           LA_PASSED  = max( LA, 1_8 )
 C
-          IF ((id%KEEP(235).EQ.0).and.(id%KEEP(237).EQ.0) ) THEN
+          IF (Lnodes_FWD.EQ.-1 .AND. Lnodes_BWD.EQ.-1) THEN
 C
-C         --- Normal case : we do not exploit sparsity of the RHS
+C         --- Normal case : we do not exploit sparsity during
+C             foward and backward steps
 C
             FROM_PP = .FALSE.
             NBSPARSE_LOC = (DO_NBSPARSE.AND.NBRHS_EFF.GT.1)
-            PRUNED_SIZE_LOADED = 0_8  ! From SMUMPS_SOL_ES module
             CALL SMUMPS_SOL_C(id%root, id%N, id%S(1), LA_PASSED, IS(1),
      & LIW_PASSED, WORK_WCB(1), LWCB8_SOL_C, IWCB, LIWCB, NBRHS_EFF,
      & id%NA(1),id%LNA,id%NE_STEPS(1), SRW3, MTYPE, ICNTL(1), FROM_PP,
@@ -4070,10 +4716,15 @@ C
      & BUFR(1), LBUFR, LBUFR_BYTES, id%ISTEP_TO_INIV2(1),
      & id%TAB_POS_IN_PERE(1,1), IBEG_ROOT_DEF, IEND_ROOT_DEF,
      & IROOT_DEF_RHS_COL1, PTR_RHS_ROOT(1), LPTR_RHS_ROOT, SIZE_ROOT,
-     & MASTER_ROOT, id%RHSCOMP(IBEG_RHSCOMP), LD_RHSCOMP,
-     & id%POSINRHSCOMP_ROW(1), id%POSINRHSCOMP_COL(1)
+     & MASTER_ROOT, id%RHSINTR(IBEG_RHSINTR), id%LD_RHSINTR,
+     & id%GLOB2LOC_RHS(1), id%GLOB2LOC_SOL(1)
+     &  , -1, -1,
+     &  IDUMMY(1), IDUMMY(1)
      & , 1, 1, 1, 1, IDUMMY, 1, JDUMMY, KDUMMY, 1, LDUMMY, 1, MDUMMY
      & , 1, 1, NBSPARSE_LOC, PTR_RHS_BOUNDS(1), LPTR_RHS_BOUNDS
+#if defined(STAT_ES_SOLVE)
+     & , IDUMMY, 1, JDUMMY, 1
+#endif
      & , id%IPOOL_B_L0_OMP(1), id%LPOOL_B_L0_OMP, id%IPOOL_A_L0_OMP(1),
      & id%LPOOL_A_L0_OMP, id%L_VIRT_L0_OMP, id%VIRT_L0_OMP(1),
      & id%L_PHYS_L0_OMP, id%PHYS_L0_OMP(1), id%PERM_L0_OMP(1),
@@ -4095,12 +4746,18 @@ C
      & id%DKEEP(1),id%COMM_NODES,id%MYID,id%MYID_NODES,BUFR(1),LBUFR,
      & LBUFR_BYTES, id%ISTEP_TO_INIV2(1), id%TAB_POS_IN_PERE(1,1),
      & IBEG_ROOT_DEF,IEND_ROOT_DEF,IROOT_DEF_RHS_COL1,PTR_RHS_ROOT(1),
-     & LPTR_RHS_ROOT, SIZE_ROOT, MASTER_ROOT, id%RHSCOMP(IBEG_RHSCOMP),
-     & LD_RHSCOMP, id%POSINRHSCOMP_ROW(1), id%POSINRHSCOMP_COL(1),
+     & LPTR_RHS_ROOT, SIZE_ROOT, MASTER_ROOT, id%RHSINTR(IBEG_RHSINTR),
+     & id%LD_RHSINTR, id%GLOB2LOC_RHS(1), id%GLOB2LOC_SOL(1),
+     &  Lnodes_FWD, Lnodes_BWD,
+     &  nodes_FWD_PTR(1), nodes_BWD_PTR(1),
      & NZ_THIS_BLOCK, NBCOL_INBLOC, id%NRHS, JBEG_RHS, id%Step2node(1),
      & id%KEEP(28),IRHS_SPARSE_COPY(1),IRHS_PTR_COPY(1), size(PERM_RHS),
-     & PERM_RHS, size(UNS_PERM_INV), UNS_PERM_INV, NB_FS_RHSCOMP_F,
-     & NB_FS_RHSCOMP_TOT,NBSPARSE_LOC,PTR_RHS_BOUNDS(1),LPTR_RHS_BOUNDS
+     & PERM_RHS, size(UNS_PERM_INV), UNS_PERM_INV, NB_FS_RHSINTR_F,
+     & NB_FS_RHSINTR_TOT,NBSPARSE_LOC,PTR_RHS_BOUNDS(1),LPTR_RHS_BOUNDS
+#if defined(STAT_ES_SOLVE)
+     & ,idIPTR_WORKING(1),SIZE_IPTR_WORKING,idWORKING(1),SIZE_WORKING
+C     & ,id%IPTR_WORKING(1),SIZE_IPTR_WORKING,id%WORKING(1),SIZE_WORKING
+#endif
      & ,id%IPOOL_B_L0_OMP(1),id%LPOOL_B_L0_OMP,id%IPOOL_A_L0_OMP(1),
      & id%LPOOL_A_L0_OMP,id%L_VIRT_L0_OMP,id%VIRT_L0_OMP(1),
      & id%L_PHYS_L0_OMP, id%PHYS_L0_OMP(1), id%PERM_L0_OMP(1),
@@ -4139,7 +4796,8 @@ C       ================================
 C       ONLY FORWARD was performed (case of reduced RHS with Schur
 C                               option during factorisation)
 C       ======================================================
-        IF ( KEEP(221) .EQ. 1 ) THEN ! === Begin OF REDUCED RHS ======
+        IF ( (KEEP(60).NE.0) .AND. 
+     &       KEEP(221) .EQ. 1 ) THEN ! === Begin OF REDUCED RHS ======
 C         --------------------------------------
 C         Send (or copy) reduced RHS from PTR_RHS_ROOT located on
 C         MASTER_ROOT_IN_COMM to REDRHS located on MASTER (host node).
@@ -4199,14 +4857,14 @@ C               -- send all in on shot
             ENDIF
 C         -- other procs are not concerned
           ENDIF
-        ENDIF ! ====== END OF REDUCED RHS (Fwd only performed) ======
+        ENDIF ! ===== END OF REDUCED RHS (Schur+Fwd only performed) ==
 C       =======================================================
 C       BACKWARD was PERFORMED
 C       Postprocess solution that is distributed
         IF ( KEEP(221) .NE. 1 ) THEN  ! BACKWARD was PERFORMED
 C       -- KEEP(221).NE.1 => we are sure that backward has been performed
           IF (ICNTL21 == 0) THEN ! CENTRALIZED SOLUTION
-C           ========================================================
+C{          ========================================================
 C           GATHER SOLUTION computed during bwd
 C           Each proc holds the pieces of solution corresponding
 C           to all fully summed variables mapped on that processor
@@ -4250,8 +4908,9 @@ C           Propagate errors
      &                       id%COMM,id%MYID)
 C           Return in case of error.
             IF (INFO(1).LT.0) GO TO 90
+#if defined(USE_OLD_SCALING)
             IF ((id%MYID.NE.MASTER).OR. .NOT.LSCAL) THEN
-             PT_SCALING => Dummy_SCAL
+              PT_SCALING => Dummy_SCAL
             ELSE
               IF (MTYPE.EQ.1) THEN
                 PT_SCALING => id%COLSCA
@@ -4259,11 +4918,12 @@ C           Return in case of error.
                 PT_SCALING => id%ROWSCA
               ENDIF
             ENDIF
+#endif
             LIW_PASSED = max( LIW, 1 )
             TIMEGATHER1=MPI_WTIME()
             IF ( .NOT.I_AM_SLAVE ) THEN
 C             I did not participate to computing part of the solution
-C             (id%RHSCOMP not set/allocate) : receive solution, store
+C             (id%RHSINTR not set/allocate) : receive solution, store
 C             it and scale it.
               IF (KEEP(237).EQ.0) THEN
 C               We need a workspace of minimal size KEEP(247)
@@ -4274,8 +4934,12 @@ C               in order to unpack piece
      &              JDUMMY, id%KEEP(1), id%KEEP8(1),
      &              id%PROCNODE_STEPS(1), IDUMMY, 1,
      &              id%STEP(1), BUFR(1), LBUFR, LBUFR_BYTES,
-     &              CWORK(1), LCWORK,
-     &              LSCAL, PT_SCALING(1), size(PT_SCALING),
+     &              CWORK(1), LCWORK, LSCAL,
+#if defined(USE_OLD_SCALING)
+     &              PT_SCALING(1), size(PT_SCALING),
+#else
+     &              SCALING_LOC_BWD(1), size(SCALING_LOC_BWD),
+#endif
      &              C_DUMMY, 1 , 1, IDUMMY, 1,
      &              PERM_RHS, size(PERM_RHS) ! for sparse permuted RHS
      &              )
@@ -4285,7 +4949,12 @@ C               only gather target entri
      &              id%MYID, id%COMM, NBRHS_EFF,
      &              C_DUMMY, 1, 1,
      &              id%KEEP(1), BUFR(1), LBUFR, LBUFR_BYTES,
+#if defined(USE_OLD_SCALING)
      &              LSCAL, PT_SCALING(1), size(PT_SCALING)
+#else
+     &              LSCAL, SCALING_RHSINTR_BWD(1),
+     &              size(SCALING_RHSINTR_BWD)
+#endif
 C                   --- A-1 related entries
      &             ,IRHS_PTR_COPY(1), size(IRHS_PTR_COPY),
      &              IRHS_SPARSE_COPY(1), size(IRHS_SPARSE_COPY),
@@ -4316,23 +4985,31 @@ C             compilers would do otherwi
      &          id%PROCNODE_STEPS(1), IS(1), LIW_PASSED,
      &          id%STEP(1), BUFR(1), LBUFR, LBUFR_BYTES,
      &          CWORK(1), LCWORK,
+#if defined(USE_OLD_SCALING)
      &          LSCAL, PT_SCALING(1), size(PT_SCALING),
-     &          id%RHSCOMP(IBEG_RHSCOMP), LD_RHSCOMP, NBRHS_EFF,
-     &          id%POSINRHSCOMP_COL(1), id%N,
+#else
+     &          LSCAL, SCALING_LOC_BWD(1), size(SCALING_LOC_BWD),
+#endif
+     &          id%RHSINTR(IBEG_RHSINTR), id%LD_RHSINTR, NBRHS_EFF,
+     &          id%GLOB2LOC_SOL(1), id%N,
      &          PERM_RHS, size(PERM_RHS) ! For sparse permuted RHS
      &          )
               ELSE ! only gather target entries of A-1
                 CALL SMUMPS_GATHER_SOLUTION_AM1(id%NSLAVES,id%N,
      &          id%MYID, id%COMM, NBRHS_EFF,
-     &          id%RHSCOMP(IBEG_RHSCOMP), LD_RHSCOMP, NBRHS_EFF,
+     &          id%RHSINTR(IBEG_RHSINTR), id%LD_RHSINTR, NBRHS_EFF,
      &          id%KEEP(1), BUFR(1), LBUFR, LBUFR_BYTES,
+#if defined(USE_OLD_SCALING)
      &          LSCAL, PT_SCALING(1), size(PT_SCALING)
+#else
+     &          LSCAL, SCALING_RHSINTR_BWD(1), size(SCALING_RHSINTR_BWD)
+#endif
 C               --- A-1 related entries
      &          , IRHS_PTR_COPY(1), size(IRHS_PTR_COPY),
      &          IRHS_SPARSE_COPY(1), size(IRHS_SPARSE_COPY),
      &          RHS_SPARSE_COPY(1), size(RHS_SPARSE_COPY),
      &          UNS_PERM_INV, size(UNS_PERM_INV),
-     &          id%POSINRHSCOMP_COL(1), id%N, NB_FS_RHSCOMP_TOT
+     &          id%GLOB2LOC_SOL(1), id%N, NB_FS_RHSINTR_TOT
      &          )
               ENDIF
             ENDIF
@@ -4379,32 +5056,46 @@ C                 IZ - Column index in S
               ENDIF
             ENDIF             ! end A-1 on master
 C
-C         -- END of backward was performed with centralized solution
+C}        -- END of backward was performed with centralized solution
           ELSE   ! (KEEP(221).NE.1) .AND.(ICNTL21.NE.0))
 C
 C           BEGIN of backward performed with distributed solution
 C           time local copy + scaling
             TIMECOPYSCALE1=MPI_WTIME()
-C           The non working host should not do this:
-            IF ( I_AM_SLAVE ) THEN
-              LIW_PASSED = max( LIW, 1 )
-C             Only called if more than 1 pivot
-C             was eliminated by the processor.
-C             Note that LSOL_loc >= KEEP(89)
-              IF ( KEEP(89) .GT. 0 ) THEN
-                CALL SMUMPS_DISTRIBUTED_SOLUTION(id%NSLAVES,
-     &          id%N,id%MYID_NODES,
-     &          MTYPE, id%RHSCOMP(IBEG_RHSCOMP), LD_RHSCOMP,
-     &          NBRHS_EFF, id%POSINRHSCOMP_COL(1),
-     &          id%ISOL_loc(1), id%SOL_loc(1), id%NRHS,
-     &          JBEG_RHS-NB_RHSSKIPPED, id%LSOL_loc,
-     &          id%PTLUST_S(1), id%PROCNODE_STEPS(1),
-     &          id%KEEP(1),id%KEEP8(1),
-     &          IS(1), LIW_PASSED,
-     &          id%STEP(1), scaling_data_sol, LSCAL, NB_RHSSKIPPED,
-     &          PERM_RHS, size(PERM_RHS) ) ! For permuted sparse RHS
+C             The non working host should not do this:
+              IF ( I_AM_SLAVE ) THEN
+                LIW_PASSED = max( LIW, 1 )
+C               Only called if more than 1 pivot
+C               was eliminated by the processor.
+C               Note that LSOL_loc >= KEEP(89)
+                IF ( KEEP(89) .GT. 0 ) THEN
+            IF ( LSCAL .AND. id%KEEP(89).GT.0) THEN
+#if defined(USE_OLD_SCALING)
+              SCALING_LOC_BWD => scaling_data_sol%SCALING_LOC
+#else
+              IF (MTYPE.EQ.1) THEN
+                SCALING_LOC_BWD => id%COLSCA_loc
+              ELSE
+                SCALING_LOC_BWD => id%ROWSCA_loc
               ENDIF
+#endif
+            ELSE
+              SCALING_LOC_BWD => RDUMMY_TARGET
             ENDIF
+                  CALL SMUMPS_DISTRIBUTED_SOLUTION(id%NSLAVES,
+     &            id%N,id%MYID_NODES,
+     &            MTYPE, id%RHSINTR(IBEG_RHSINTR), id%LD_RHSINTR,
+     &            NBRHS_EFF, id%GLOB2LOC_SOL(1),
+     &            id%ISOL_loc(1), id%SOL_loc(1), id%NRHS,
+     &            JBEG_RHS-NB_RHSSKIPPED, id%LSOL_loc,
+     &            id%PTLUST_S(1), id%PROCNODE_STEPS(1),
+     &            id%KEEP(1),id%KEEP8(1),
+     &            IS(1), LIW_PASSED, id%STEP(1),
+     &            SCALING_LOC_BWD(1), size(SCALING_LOC_BWD),
+     &            LSCAL, NB_RHSSKIPPED,
+     &            PERM_RHS, size(PERM_RHS) ) ! For permuted sparse RHS
+                ENDIF
+              ENDIF
             TIMECOPYSCALE2=MPI_WTIME()-TIMECOPYSCALE1+TIMECOPYSCALE2
           ENDIF
 C         === BACKWARD was PERFORMED WITH DISTRIBUTED SOLUTION ===
@@ -4425,7 +5116,7 @@ C         Multiple RHS: apply a fixed nu
 C         of iterative refinement steps
 C         ----------------------------------
 C         DO I = 1, ICNTL10
-            write(6,*) ' Internal ERROR 15 in sol_driver '
+            write(6,*) ' Internal error 15 in sol_driver '
 C           Compute residual:  Y <- SAVERHS - A * RHS
 C           Solve RHS <- A^-1 Y, Y modified
 C           Assemble in RHS(REDUCE)
@@ -4433,7 +5124,7 @@ C           RHS <- RHS + Y
 C         END DO
         END IF
         IF (POSTPros) THEN
-C
+C{
 C         SAVERHS holds the original right hand side
 C         Sparse rhs are saved in SAVERHS as dense rhs
 C
@@ -5097,7 +5788,7 @@ C             We have used D only for LC
           DEALLOCATE(C_Y)
           DEALLOCATE(R_LOCWK54)
           DEALLOCATE(C_LOCWK54)
-C End POSTPros
+C} End POSTPros
         END IF
 C============================================
 C
@@ -5164,9 +5855,9 @@ C  ========================
 *         print out the solution
           IF ( INFO(1) .GE. 0 .AND. ICNTL(4).GE.3 .AND. ICNTL(3).GT.0)
      &    THEN
-            K = min0(10, id%N)
+            K = min(10, id%N)
             IF (ICNTL(4) .eq. 4 ) K = id%N
-            J = min0(10,NBRHS_EFF)
+            J = min(10,NBRHS_EFF)
             IF (ICNTL(4) .eq. 4 ) J = NBRHS_EFF
             DO II=1, J
               WRITE(ICNTL(3),110) BEG_RHS+II-1
@@ -5190,9 +5881,6 @@ C     }
       ENDDO
 C     END DO WHILE (BEG_RHS.LE.id%NRHS)
 C     =================================
-      IF (KEEP(400) .GT. 0) THEN
-        CALL SMUMPS_SOL_L0OMP_LD(KEEP(400))
-      ENDIF
 C
 C     ========================================================
 C     Reset RHS to zero for all remaining columns that
@@ -5226,14 +5914,14 @@ C     ==================================
       ENDIF
 C     ========================================================
 C     Reset id%SOL_loc to zero for all remaining columns that
-C     have not been processed because they were emtpy
+C     have not been processed because they were empty
 C     ========================================================
       IF ( I_AM_SLAVE .AND. (ICNTL21.NE.0) .AND.
      &      ( JEND_RHS .LT. id%NRHS ) .AND. KEEP(221).NE.1 ) THEN
         JBEG_NEW = JEND_RHS + 1
         IF (DO_PERMUTE_RHS.OR.INTERLEAVE_PAR) THEN
            DO WHILE ( JBEG_NEW.LE. id%NRHS)
-              DO I=1, KEEP(89)
+              DO I=1, NSOL_loc
                  id%SOL_loc(int(PERM_RHS(JBEG_NEW) -1,8)*
      &                      int(id%LSOL_loc,8)+int(I,8)) = ZERO
               ENDDO
@@ -5242,7 +5930,7 @@ C     ==================================
         ELSE
 C
            DO WHILE ( JBEG_NEW.LE. id%NRHS)
-            DO I=1, KEEP(89)
+            DO I=1, NSOL_loc
                 id%SOL_loc((JBEG_NEW -1)*id%LSOL_loc + I) = ZERO
             ENDDO
             JBEG_NEW = JBEG_NEW +1
@@ -5251,7 +5939,7 @@ C
       ENDIF
 C
 C     ================================================================
-C     Reset id%RHSCOMP and id%REDRHS to zero for all remaining columns
+C     Reset id%RHSINTR and id%REDRHS to zero for all remaining columns
 C     that have not been processed because they were emtpy
 C     ================================================================
       IF ((KEEP(221).EQ.1) .AND.
@@ -5269,8 +5957,8 @@ C     ==================================
        IF (I_AM_SLAVE) THEN
            JBEG_NEW = JEND_RHS + 1
            DO WHILE ( JBEG_NEW.LE. id%NRHS)
-            DO I=1,NBENT_RHSCOMP
-              id%RHSCOMP(int(JBEG_NEW -1,8)*int(LD_RHSCOMP,8) +
+            DO I=1,NBENT_RHSINTR
+              id%RHSINTR(int(JBEG_NEW -1,8)*int(id%LD_RHSINTR,8) +
      &                   int(I,8)) =  ZERO
             ENDDO
             JBEG_NEW = JBEG_NEW +1
@@ -5362,9 +6050,43 @@ C
         WRITE( MP, 431 ) id%DKEEP(122)
       END IF
  90   CONTINUE
+      IF (KEEP(400) .GT. 0) THEN
+        CALL SMUMPS_SOL_L0OMP_LD(KEEP(400))
+      ENDIF
       IF (INFO(1) .LT.0 ) THEN
          IF (INFO(1) .EQ. -80) INFO(1) = -81
       ENDIF
+C     -- related to exploit sparsity
+       IF (associated(nodes_FWD)) THEN 
+        NB_BYTES = NB_BYTES - size(nodes_FWD) * K34_8
+        DEALLOCATE(nodes_FWD)
+        NULLIFY(nodes_FWD)
+       ENDIF
+       IF (associated(nodes_BWD)) THEN 
+        NB_BYTES = NB_BYTES - size(nodes_BWD) * K34_8
+        DEALLOCATE(nodes_BWD)
+        NULLIFY(nodes_BWD)
+       ENDIF
+       IF (allocated(Pruned_Sons_FWD)) THEN 
+        NB_BYTES = NB_BYTES - size(Pruned_Sons_FWD) * K34_8
+        DEALLOCATE(Pruned_Sons_FWD)
+       ENDIF
+       IF (allocated(Pruned_Sons_BWD)) THEN 
+        NB_BYTES = NB_BYTES - size(Pruned_Sons_BWD) * K34_8
+        DEALLOCATE(Pruned_Sons_BWD)
+       ENDIF
+      IF (SCALING_RHSINTR_FWD_ALLOCATED) THEN
+        NB_BYTES = NB_BYTES - LSCALING_RHSINTR_FWD * K16_8
+        DEALLOCATE(SCALING_RHSINTR_FWD)
+      ENDIF
+      SCALING_RHSINTR_FWD_ALLOCATED = .FALSE.
+      NULLIFY(SCALING_RHSINTR_FWD)
+      IF (SCALING_RHSINTR_BWD_ALLOCATED) THEN
+        NB_BYTES = NB_BYTES - LSCALING_RHSINTR_BWD * K16_8
+        DEALLOCATE(SCALING_RHSINTR_BWD)
+      ENDIF
+      SCALING_RHSINTR_BWD_ALLOCATED = .FALSE.
+      NULLIFY(SCALING_RHSINTR_BWD)
       IF (KEEP(485) .EQ. 1) THEN
         KEEP(350) = KEEP350_SAVE
         IF (IS_LR_MOD_TO_STRUC_DONE) THEN
@@ -5421,12 +6143,16 @@ C       Free space and reset pointers if
          NULLIFY(IRHS_loc_PTR)
          IRHS_loc_PTR_ALLOCATED = .FALSE.
        ENDIF
+#if defined(USE_OLD_SCALING)
        IF (I_AM_SLAVE.AND.LSCAL.AND.KEEP(248).EQ.-1) THEN
-         NB_BYTES = NB_BYTES -
-     &   int(size(scaling_data_dr%SCALING_LOC),8)*K16_8
-         DEALLOCATE(scaling_data_dr%SCALING_LOC)
-         NULLIFY   (scaling_data_dr%SCALING_LOC)
+         IF (associated(scaling_data_dr%SCALING_LOC)) THEN
+           NB_BYTES = NB_BYTES -
+     &     int(size(scaling_data_dr%SCALING_LOC),8)*K16_8
+           DEALLOCATE(scaling_data_dr%SCALING_LOC)
+           NULLIFY   (scaling_data_dr%SCALING_LOC)
+         ENDIF
        ENDIF
+#endif
       IF (allocated(PERM_RHS)) THEN
         NB_BYTES = NB_BYTES - int(size(PERM_RHS),8)*K34_8
         DEALLOCATE(PERM_RHS)
@@ -5498,13 +6224,19 @@ C       Deallocate temporary workspace S
           NB_BYTES = NB_BYTES - int(size(SRW3),8)*K35_8
           DEALLOCATE(SRW3)
         ENDIF
-        IF (LSCAL .AND. ICNTL21==1) THEN
-C         Free local scaling arrays
-          NB_BYTES = NB_BYTES -
-     &              int(size(scaling_data_sol%SCALING_LOC),8)*K16_8
-          DEALLOCATE(scaling_data_sol%SCALING_LOC)
-          NULLIFY(scaling_data_sol%SCALING_LOC)
+#if defined(USE_OLD_SCALING)
+C       Free local scaling arrays
+        IF (LSCAL .AND. ICNTL21 .NE. 0) THEN
+          IF (associated(scaling_data_sol%SCALING_LOC)) THEN
+            NB_BYTES = NB_BYTES -
+     &                 int(size(scaling_data_sol%SCALING_LOC),8)*K16_8
+            DEALLOCATE(scaling_data_sol%SCALING_LOC)
+            NULLIFY(scaling_data_sol%SCALING_LOC)
+          ENDIF
         ENDIF
+#endif
+#if defined(USE_OLD_SCALING)
+#endif
 C       Free memory until next call to SMUMPS
         IF (WK_USER_PROVIDED) THEN
 C         S points to WK_USER provided by user
@@ -5528,28 +6260,30 @@ C         at the beginning of the solve,
           NB_BYTES  = NB_BYTES - KEEP8(23) * K35_8
           KEEP8(23) = 0_8
         ENDIF
-        IF (KEEP(221).NE.1) THEN
+        IF (KEEP(221).NE.1
+     &     ) THEN
 C       -- After reduction of RHS to Schur variables
 C       -- keep compressed RHS generated during FWD step
 C       -- to be used for future expansion
-         IF (associated(id%RHSCOMP)) THEN
+         IF (associated(id%RHSINTR)) THEN
             NB_BYTES = NB_BYTES - id%KEEP8(25)*K35_8
-            DEALLOCATE(id%RHSCOMP)
-            NULLIFY(id%RHSCOMP)
-            id%KEEP8(25)=0_8
+            DEALLOCATE(id%RHSINTR)
+            NULLIFY(id%RHSINTR)
+            id%KEEP8(25)  = 0_8
+            id%LD_RHSINTR = 0
          ENDIF
-         IF (associated(id%POSINRHSCOMP_ROW)) THEN
+         IF (associated(id%GLOB2LOC_RHS)) THEN
             NB_BYTES = NB_BYTES -
-     &                 int(size(id%POSINRHSCOMP_ROW),8)*K34_8
-            DEALLOCATE(id%POSINRHSCOMP_ROW)
-            NULLIFY(id%POSINRHSCOMP_ROW)
+     &                 int(size(id%GLOB2LOC_RHS),8)*K34_8
+            DEALLOCATE(id%GLOB2LOC_RHS)
+            NULLIFY(id%GLOB2LOC_RHS)
          ENDIF
-         IF (id%POSINRHSCOMP_COL_ALLOC) THEN
+         IF (id%GLOB2LOC_SOL_ALLOC) THEN
             NB_BYTES = NB_BYTES -
-     &                 int(size(id%POSINRHSCOMP_COL),8)*K34_8
-            DEALLOCATE(id%POSINRHSCOMP_COL)
-            NULLIFY(id%POSINRHSCOMP_COL)
-            id%POSINRHSCOMP_COL_ALLOC = .FALSE.
+     &                 int(size(id%GLOB2LOC_SOL),8)*K34_8
+            DEALLOCATE(id%GLOB2LOC_SOL)
+            NULLIFY(id%GLOB2LOC_SOL)
+            id%GLOB2LOC_SOL_ALLOC = .FALSE.
          ENDIF
         ENDIF
         IF ( WORK_WCB_ALLOCATED ) THEN
@@ -5560,6 +6294,23 @@ C       Otherwise, WORK_WCB may point to
 C       position inside id%S, nullify it
         NULLIFY( WORK_WCB )
       ENDIF
+#if defined(STAT_ES_SOLVE)
+      IF (
+     & (id%MYID.EQ.MASTER).AND.
+     & ( (id%KEEP(235).NE.0).OR.(id%KEEP(212).NE.0) )
+     &   )
+     & THEN
+C       If exploit sparsity then
+C       stats saved in DKEEP(200:204) and
+C       set RINFOG(24), RINFOG(25), RINFOG(26)
+        CALL SMUMPS_SOL_ES_PRINT_STATS( 
+     &      id%KEEP(212), id%KEEP(235), id%KEEP(237),
+     &      id%KEEP(485), id%KEEP(497), 
+     &      id%KEEP8(110),id%NRHS, id%ICNTL(27), id%N, 
+     &      id%KEEP(50), id%DKEEP(200:204),
+     &      id%RINFOG(24:28), MPG)
+      END IF
+#endif
  500  CONTINUE
       RETURN
  55   FORMAT (//' ERROR ANALYSIS BEFORE ITERATIVE REFINEMENT')
@@ -5572,7 +6323,7 @@ C       position inside id%S, nullify it
  437  FORMAT('  .. Time in ScaLAPACK root       =   ',F15.6)
  436  FORMAT('  .. Time in backward (bwd) step  =   ',F15.6)
  433  FORMAT(' Time to gather solution(cent.sol)=',F15.6)
- 431  FORMAT(' Time to copy/scale dist. solution=',F15.6)
+ 431  FORMAT(' Time for distributed solution    =',F15.6)
  150  FORMAT(' GLOBAL STATISTICS PRIOR SOLVE PHASE ...........'/
      &        ' Number of right-hand-sides                    =',I12/
      &        ' Blocking factor for multiple rhs              =',I12/
@@ -5582,7 +6333,8 @@ C       position inside id%S, nullify it
      &        '  --- (20)                                     =',I12/
      &        '  --- (21)                                     =',I12/
      &        '  --- (30)                                     =',I12/
-     &        '  --- (35)                                     =',I12
+     &        '  --- (35)                                     =',I12/
+     &        '  --- (48) (effective)                         =',I12
      &        )
  151  FORMAT ('  --- (25)                                     =',I12)
  152  FORMAT ('  --- (26)                                     =',I12)
@@ -5601,6 +6353,7 @@ C       position inside id%S, nullify it
      &       NRHS,
      &       idIRHS_loc,
      &       idRHS_loc,
+     &       I_AM_SLAVE,
      &       INFO)
 C
 C  Purpose:
@@ -5619,6 +6372,7 @@ C
         INTEGER, INTENT( IN ) :: idNloc_RHS
         INTEGER, INTENT( IN ) :: idLRHS_loc
         INTEGER, INTENT( IN ) :: NRHS
+        LOGICAL, INTENT( IN ) :: I_AM_SLAVE
 #if defined(MUMPS_NOF2003)
         INTEGER, POINTER :: idIRHS_loc (:)
         REAL, POINTER :: idRHS_loc  (:)
@@ -5638,6 +6392,14 @@ C  =====================
 C
 C       Quick return if nothing on this proc
         IF (idNloc_RHS .LE. 0) RETURN
+        IF (idNloc_RHS .GT. 0 .AND. .NOT. I_AM_SLAVE) THEN
+C         Nloc_RHS should not be greater than 0
+C         on a non working host because the distribution
+C         of the RHS does not include the non working host.
+          INFO(1)=-55
+          INFO(2)=-idLRHS_loc
+          RETURN
+        ENDIF
 C       Check for leading dimension
         IF (NRHS.NE.1) THEN
           IF ( idLRHS_loc .LT. idNloc_RHS) THEN
@@ -5716,6 +6478,7 @@ C         We force SOLVET to have value
 C         to be able to test both values, and also, be able to
 C         test whether SOLVET = MTYPE or not.
           IF ( SOLVET.EQ.2 ) SOLVET = 0
+#if defined(USE_OLD_SCALING)
           IF ( LSCAL ) THEN
             IF ( SOLVET .EQ. 1 ) THEN
 C             Apply rowscaling
@@ -5729,19 +6492,31 @@ C             Apply column scaling
               END DO
             END IF
           END IF
+#endif
         END IF ! MYID.EQ.MASTER
 C       ------------------------------
 C       Broadcast SOLVET to the slaves
 C       ------------------------------
         CALL MPI_BCAST( SOLVET, 1, MPI_INTEGER, MASTER,
      &                  id%COMM, IERR)
+#if ! defined(USE_OLD_SCALING)
+        IF (LSCAL .AND. id%KEEP(89) .GT. 0) THEN
+          IF (SOLVET .EQ. 1) THEN
+            SCALING_LOC_FWD => id%ROWSCA_LOC
+          ELSE
+            SCALING_LOC_FWD => id%COLSCA_LOC
+          ENDIF
+        ELSE
+            SCALING_LOC_FWD => RDUMMY_TARGET
+        ENDIF
+#endif
 C       --------------------------------------------
 C       Scatter the right hand side C_Y on all procs
 C       --------------------------------------------
         IF ( .NOT.I_AM_SLAVE ) THEN
 C         -- Master not working
           CALL SMUMPS_SCATTER_RHS(id%NSLAVES,id%N, id%MYID,
-     &      id%COMM,
+     &      id%COMM, LSCAL, SCALING_LOC_FWD(1),
      &      SOLVET, C_Y(1), id%N, 1,
      &      1,
      &      C_DUMMY, 1, 1,
@@ -5752,21 +6527,21 @@ C         -- Master not working
      &      id%ICNTL(1),id%INFO(1))
         ELSE
           IF (SOLVET.EQ.MTYPE) THEN
-C           POSINRHSCOMP_ROW is with respect to the
+C           GLOB2LOC_RHS is with respect to the
 C           original linear system (transposed or not)
-            PTR_POSINRHSCOMP_FWD => id%POSINRHSCOMP_ROW
+            PTR_POSINRHSINTR_FWD => id%GLOB2LOC_RHS
           ELSE
 C           Transposed, use column indices of original
 C           system (ie, col indices of A or A^T)
-            PTR_POSINRHSCOMP_FWD => id%POSINRHSCOMP_COL
+            PTR_POSINRHSINTR_FWD => id%GLOB2LOC_SOL
           ENDIF
           LIW_PASSED = max( LIW, 1 )
           CALL SMUMPS_SCATTER_RHS(id%NSLAVES,id%N, id%MYID,
-     &      id%COMM,
+     &      id%COMM, LSCAL, SCALING_LOC_FWD(1),
      &      SOLVET,  C_Y(1), id%N, 1,
      &      1,
-     &      id%RHSCOMP(IBEG_RHSCOMP), LD_RHSCOMP, 1,
-     &      PTR_POSINRHSCOMP_FWD(1), NB_FS_RHSCOMP_F,
+     &      id%RHSINTR(IBEG_RHSINTR), id%LD_RHSINTR, 1,
+     &      PTR_POSINRHSINTR_FWD(1), NB_FS_RHSINTR_F,
 C
      &      id%PTLUST_S(1), id%KEEP(1), id%KEEP8(1),
      &      id%PROCNODE_STEPS(1),
@@ -5782,11 +6557,11 @@ C
           LIW_PASSED = max( LIW, 1 )
           LA_PASSED = max( LA, 1_8 )
           IF (SOLVET.EQ.MTYPE) THEN
-            PTR_POSINRHSCOMP_FWD => id%POSINRHSCOMP_ROW
-            PTR_POSINRHSCOMP_BWD => id%POSINRHSCOMP_COL
+            PTR_POSINRHSINTR_FWD => id%GLOB2LOC_RHS
+            PTR_POSINRHSINTR_BWD => id%GLOB2LOC_SOL
           ELSE
-            PTR_POSINRHSCOMP_FWD => id%POSINRHSCOMP_COL
-            PTR_POSINRHSCOMP_BWD => id%POSINRHSCOMP_ROW
+            PTR_POSINRHSINTR_FWD => id%GLOB2LOC_SOL
+            PTR_POSINRHSINTR_BWD => id%GLOB2LOC_RHS
           ENDIF
           FROM_PP=.TRUE.
           NBSPARSE_LOC = .FALSE.
@@ -5800,10 +6575,15 @@ C
      & LBUFR_BYTES, id%ISTEP_TO_INIV2(1), id%TAB_POS_IN_PERE(1,1),
 C      Next 3 arguments are not used in this call
      & IBEG_ROOT_DEF,IEND_ROOT_DEF,IROOT_DEF_RHS_COL1, PTR_RHS_ROOT(1),
-     & LPTR_RHS_ROOT, SIZE_ROOT, MASTER_ROOT, id%RHSCOMP(IBEG_RHSCOMP),
-     & LD_RHSCOMP,PTR_POSINRHSCOMP_FWD(1),PTR_POSINRHSCOMP_BWD(1),
+     & LPTR_RHS_ROOT, SIZE_ROOT, MASTER_ROOT, id%RHSINTR(IBEG_RHSINTR),
+     & id%LD_RHSINTR,PTR_POSINRHSINTR_FWD(1),PTR_POSINRHSINTR_BWD(1),
+     & -1, -1,
+     & IDUMMY(1), IDUMMY(1),
      & 1,1,1,1, IDUMMY, 1, JDUMMY, KDUMMY, 1, LDUMMY, 1, MDUMMY, 1,1,
      & NBSPARSE_LOC, PTR_RHS_BOUNDS(1), LPTR_RHS_BOUNDS
+#if defined(STAT_ES_SOLVE)
+     & , IDUMMY, 1, JDUMMY, 1
+#endif
      & , id%IPOOL_B_L0_OMP(1), id%LPOOL_B_L0_OMP, id%IPOOL_A_L0_OMP(1),
      & id%LPOOL_A_L0_OMP, id%L_VIRT_L0_OMP, id%VIRT_L0_OMP(1),
      & id%L_PHYS_L0_OMP, id%PHYS_L0_OMP(1), id%PERM_L0_OMP(1),
@@ -5847,6 +6627,7 @@ C       then necessarily NBRHS_EFF = 1)
 C
 C       === GATHER and SCALE solution ==============
 C
+#if defined(USE_OLD_SCALING)
         IF ((id%MYID.NE.MASTER).OR. .NOT.LSCAL) THEN
           PT_SCALING => Dummy_SCAL
         ELSE
@@ -5856,12 +6637,23 @@ C
             PT_SCALING => id%ROWSCA
           ENDIF
         ENDIF
+#else
+        IF (id%KEEP(89) .EQ. 0 .OR. .NOT. LSCAL) THEN
+          SCALING_LOC_BWD => RDUMMY_TARGET
+        ELSE
+          IF (SOLVET.EQ.1) THEN
+            SCALING_LOC_BWD => id%COLSCA_loc
+          ELSE
+            SCALING_LOC_BWD => id%ROWSCA_loc
+          ENDIF
+        ENDIF
+#endif
         LIW_PASSED = max( LIW, 1 )
 C       Solution computed during SMUMPS_SOL_C has been stored
-C       in id%RHSCOMP and is gathered on the master in C_Y
+C       in id%RHSINTR and is gathered on the master in C_Y
         IF ( .NOT. I_AM_SLAVE ) THEN
 C         I did not participate to computing part of the solution
-C         (id%RHSCOMP not set/allocate) : receive solution, store
+C         (id%RHSINTR not set/allocate) : receive solution, store
 C         it and scale it.
           CALL SMUMPS_GATHER_SOLUTION(id%NSLAVES,id%N,
      &      id%MYID, id%COMM, NBRHS_EFF,
@@ -5870,8 +6662,12 @@ C         it and scale it.
      &      IDUMMY, 1,
      &      id%STEP(1), BUFR(1), LBUFR, LBUFR_BYTES,
      &      CWORK(1), size(CWORK),
+#if defined(USE_OLD_SCALING)
      &      LSCAL, PT_SCALING(1), size(PT_SCALING),
-!     RHSCOMP not on non-working master
+#else
+     &      LSCAL, SCALING_LOC_BWD(1), size(SCALING_LOC_BWD),
+#endif
+!     RHSINTR not on non-working master
      &      C_DUMMY, 1 , 1, IDUMMY, 1,
 !     for sparse permuted RHS on host
      &      PERM_RHS, size(PERM_RHS)
@@ -5885,9 +6681,13 @@ C         it and scale it.
      &      IS(1), LIW_PASSED,
      &      id%STEP(1), BUFR(1), LBUFR, LBUFR_BYTES,
      &      CWORK(1), size(CWORK),
+#if defined(USE_OLD_SCALING)
      &      LSCAL, PT_SCALING(1), size(PT_SCALING),
-     &      id%RHSCOMP(IBEG_RHSCOMP), LD_RHSCOMP, NBRHS_EFF,
-     &      PTR_POSINRHSCOMP_BWD(1), id%N,
+#else
+     &      LSCAL, SCALING_LOC_BWD(1), size(SCALING_LOC_BWD),
+#endif
+     &      id%RHSINTR(IBEG_RHSINTR), id%LD_RHSINTR, NBRHS_EFF,
+     &      PTR_POSINRHSINTR_BWD(1), id%N,
      &      PERM_RHS, size(PERM_RHS)) ! for sparse permuted RHS on host
         ENDIF
         DEALLOCATE( CWORK )
diff -pruN 5.6.2-2.1/src/ssol_fwd.F 5.7.1-1/src/ssol_fwd.F
--- 5.6.2-2.1/src/ssol_fwd.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/ssol_fwd.F	2024-05-02 10:15:25.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -14,7 +14,7 @@ C
       SUBROUTINE SMUMPS_SOL_R(N, A, LA, IW, LIW, WCB, LWCB,
      &    NRHS,
      &    PTRICB, IWCB, LIWCB, 
-     &    RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD, 
+     &    RHSINTR, LRHSINTR, POSINRHSINTR_FWD, 
      &    STEP,
      &    FRERE, DAD, FILS,
      &    NSTK, IPOOL, LPOOL, PTRIST, PTRFAC, MYLEAF, MYROOT,
@@ -59,8 +59,8 @@ C
       INTEGER IW( LIW ), IWCB( LIWCB )
       INTEGER ISTEP_TO_INIV2(KEEP(71)), 
      &        TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
-      INTEGER, intent(in) ::  POSINRHSCOMP_FWD(N), LRHSCOMP 
-      REAL, intent(inout) :: RHSCOMP(LRHSCOMP,NRHS)
+      INTEGER, intent(in) ::  POSINRHSINTR_FWD(N), LRHSINTR 
+      REAL, intent(inout) :: RHSINTR(LRHSINTR,NRHS)
       LOGICAL, intent(in) :: FROM_PP
       INTEGER, INTENT( in ) :: LL0_OMP_MAPPING, LL0_OMP_FACTORS
       INTEGER, INTENT( in ) :: L0_OMP_MAPPING( LL0_OMP_MAPPING )
@@ -108,21 +108,25 @@ C
      &          KEEP(208) )
         GOTO 60
       ENDIF
-      BLOQ = ( ( III .EQ. LEAF )
+      IF (SLAVEF .EQ. 1) THEN
+        FLAG = .FALSE.
+      ELSE
+        BLOQ = ( ( III .EQ. LEAF )
      &     )
-      CALL SMUMPS_SOLVE_RECV_AND_TREAT( BLOQ, FLAG,
-     &     BUFR, LBUFR, LBUFR_BYTES,
-     &     MYID, SLAVEF, COMM,
-     &     N, NRHS, IPOOL, LPOOL, LEAF,
-     &     NBFIN, NSTK, IW, LIW, A, LA, PTRIST, PTRFAC,
-     &     IWCB, LIWCB,
-     &     WCB, LWCB, POSWCB,
-     &     PLEFTWCB, POSIWCB,
-     &     PTRICB, INFO, KEEP,KEEP8, DKEEP, STEP,
-     &     PROCNODE_STEPS,
-     &     RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD
-     &     , FROM_PP
-     &    )
+        CALL SMUMPS_SOLVE_RECV_AND_TREAT( BLOQ, FLAG,
+     &       BUFR, LBUFR, LBUFR_BYTES,
+     &       MYID, SLAVEF, COMM,
+     &       N, NRHS, IPOOL, LPOOL, LEAF,
+     &       NBFIN, NSTK, IW, LIW, A, LA, PTRIST, PTRFAC,
+     &       IWCB, LIWCB,
+     &       WCB, LWCB, POSWCB,
+     &       PLEFTWCB, POSIWCB,
+     &       PTRICB, INFO, KEEP,KEEP8, DKEEP, STEP,
+     &       PROCNODE_STEPS,
+     &       RHSINTR, LRHSINTR, POSINRHSINTR_FWD
+     &       , FROM_PP
+     &      )
+      ENDIF
       IF ( INFO( 1 ) .LT. 0 .OR. NBFIN .EQ. 0 ) GOTO 260
       IF (.not. FLAG) THEN
          IF (III .NE. LEAF) THEN
@@ -158,7 +162,7 @@ C
      &        PTRICB, PTRIST, PTRFAC, PROCNODE_STEPS,
      &        FILS, STEP, FRERE, DAD,
      &        INFO, KEEP,KEEP8, DKEEP, RHS_ROOT, LRHS_ROOT, MTYPE,
-     &        RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD,
+     &        RHSINTR, LRHSINTR, POSINRHSINTR_FWD,
      &        ISTEP_TO_INIV2, TAB_POS_IN_PERE
      &        , RHS_BOUNDS, LRHS_BOUNDS, DO_NBSPARSE 
      &        , FROM_PP
diff -pruN 5.6.2-2.1/src/ssol_fwd_aux.F 5.7.1-1/src/ssol_fwd_aux.F
--- 5.6.2-2.1/src/ssol_fwd_aux.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/ssol_fwd_aux.F	2024-05-02 10:15:25.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -21,7 +21,7 @@ C
      &     PLEFTWCB, POSIWCB,
      &     PTRICB,
      &     INFO, KEEP, KEEP8, DKEEP, STEP, PROCNODE_STEPS, 
-     &     RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD
+     &     RHSINTR, LRHSINTR, POSINRHSINTR_FWD
      &     , FROM_PP
      &    )
       USE SMUMPS_OOC 
@@ -32,7 +32,7 @@ C
       INTEGER MSGTAG, MSGSOU, MYID, SLAVEF, COMM
       INTEGER LIW
       INTEGER(8), INTENT(IN) :: LA, LWCB
-      INTEGER N, NRHS, LPOOL, LEAF, NBFIN, LRHSCOMP
+      INTEGER N, NRHS, LPOOL, LEAF, NBFIN, LRHSINTR
       INTEGER LIWCB, POSIWCB
       INTEGER(8) :: POSWCB, PLEFTWCB
       INTEGER INFO( 80 ), KEEP( 500)
@@ -47,8 +47,8 @@ C
       INTEGER STEP(N)
       INTEGER PROCNODE_STEPS(KEEP(28))
       REAL WCB( LWCB ), A( LA )
-      REAL RHSCOMP( LRHSCOMP, NRHS )
-      INTEGER, intent(in) :: POSINRHSCOMP_FWD(N)
+      REAL RHSINTR( LRHSINTR, NRHS )
+      INTEGER, intent(in) :: POSINRHSINTR_FWD(N)
       LOGICAL, intent(in) :: FROM_PP
       INCLUDE 'mpif.h'
       INCLUDE 'mumps_tags.h'
@@ -57,7 +57,7 @@ C
       INTEGER :: IWHDLR, LDA_SLAVE
       INTEGER :: MTYPE_SLAVE 
       INTEGER FINODE, FPERE, LONG, NCB, POSITION, NCV, NPIV
-      INTEGER PDEST, I, IPOSINRHSCOMP
+      INTEGER PDEST, I, IPOSINRHSINTR
       INTEGER J1
       INTEGER(8) :: APOS
       LOGICAL DUMMY
@@ -119,9 +119,9 @@ C
 !NEC$ IVDEP
 #endif
                  DO I = 1, LONG
-                   IPOSINRHSCOMP= abs(POSINRHSCOMP_FWD(IWCB(I)))
-                   RHSCOMP(IPOSINRHSCOMP,JBDEB+K-1) = 
-     &             RHSCOMP(IPOSINRHSCOMP,JBDEB+K-1) + 
+                   IPOSINRHSINTR= abs(POSINRHSINTR_FWD(IWCB(I)))
+                   RHSINTR(IPOSINRHSINTR,JBDEB+K-1) = 
+     &             RHSINTR(IPOSINRHSINTR,JBDEB+K-1) + 
      &                 WCB(PLEFTWCB+I-1)
                  ENDDO
               END DO
@@ -246,7 +246,7 @@ C
 !$           OMP_FLAG = ( JBFIN-JBDEB+1.GE.KEEP(362) .AND.
 !$   &                     (NCV*(JBFIN-JBDEB+1) .GE. KEEP(363) ) )
              IF (OMP_FLAG) THEN
-!$OMP PARALLEL DO PRIVATE(I,JJ,IFR8,IPOSINRHSCOMP)
+!$OMP PARALLEL DO PRIVATE(I,JJ,IFR8,IPOSINRHSINTR)
                DO K=1, NRHS_B
                   IFR8 = PTRY+int(K-1,8)*int(NCV,8)
 #if defined(__ve__)
@@ -254,9 +254,9 @@ C
 #endif
                   DO I = 1,NCV
                     JJ = IW(J1+I)
-                    IPOSINRHSCOMP= abs(POSINRHSCOMP_FWD(JJ))
-                    RHSCOMP(IPOSINRHSCOMP,JBDEB+K-1)= 
-     &                RHSCOMP(IPOSINRHSCOMP,JBDEB+K-1)
+                    IPOSINRHSINTR= abs(POSINRHSINTR_FWD(JJ))
+                    RHSINTR(IPOSINRHSINTR,JBDEB+K-1)= 
+     &                RHSINTR(IPOSINRHSINTR,JBDEB+K-1)
      &                + WCB(IFR8+int(I-1,8))
                   ENDDO
                ENDDO
@@ -269,9 +269,9 @@ C
 #endif
                   DO I = 1,NCV
                     JJ = IW(J1+I)
-                    IPOSINRHSCOMP= abs(POSINRHSCOMP_FWD(JJ))
-                    RHSCOMP(IPOSINRHSCOMP,JBDEB+K-1)= 
-     &                RHSCOMP(IPOSINRHSCOMP,JBDEB+K-1)
+                    IPOSINRHSINTR= abs(POSINRHSINTR_FWD(JJ))
+                    RHSINTR(IPOSINRHSINTR,JBDEB+K-1)= 
+     &                RHSINTR(IPOSINRHSINTR,JBDEB+K-1)
      &                + WCB(IFR8+int(I-1,8))
                   ENDDO
                ENDDO
@@ -297,7 +297,7 @@ C
      &            IW(PTRIST(STEP( FINODE )) + 2 + KEEP(IXSZ) ), NCV,NCV,
      &            IW(PTRIST(STEP(FINODE))+4+ KEEP(IXSZ) ),
      &            WCB( PTRY ), JBDEB, JBFIN,
-     &            RHSCOMP, 1, 1, -9999, -9999,
+     &            RHSINTR, 1, 1, -9999, -9999,
      &            KEEP, PDEST, ContVec, COMM, IERR )
             IF ( IERR .EQ. -1 ) THEN
               CALL SMUMPS_SOLVE_RECV_AND_TREAT( .FALSE., FLAG,
@@ -309,7 +309,7 @@ C
      &              WCB, LWCB, POSWCB, PLEFTWCB, POSIWCB,
      &              PTRICB, INFO, KEEP,KEEP8, DKEEP, STEP,
      &              PROCNODE_STEPS, 
-     &              RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD
+     &              RHSINTR, LRHSINTR, POSINRHSINTR_FWD
      &              , FROM_PP
      &              )
               IF ( INFO( 1 )  .LT. 0 )  GOTO 270
@@ -356,7 +356,7 @@ C
      &     PTRICB, PTRIST, PTRFAC, PROCNODE_STEPS,
      &     FILS, STEP, FRERE, DAD,
      &     INFO, KEEP,KEEP8, DKEEP, RHS_ROOT, LRHS_ROOT, MTYPE,
-     &     RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD,
+     &     RHSINTR, LRHSINTR, POSINRHSINTR_FWD,
      &     
      &     ISTEP_TO_INIV2, TAB_POS_IN_PERE
      &    , RHS_BOUNDS, LRHS_BOUNDS, DO_NBSPARSE, FROM_PP
@@ -393,8 +393,8 @@ C
       INTEGER FILS( N ), STEP( N ), FRERE(KEEP(28)), DAD(KEEP(28))
       INTEGER ISTEP_TO_INIV2(KEEP(71)), 
      &     TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
-      INTEGER POSINRHSCOMP_FWD(N), LRHSCOMP
-      REAL RHSCOMP(LRHSCOMP, NRHS)
+      INTEGER POSINRHSINTR_FWD(N), LRHSINTR
+      REAL RHSINTR(LRHSINTR, NRHS)
       LOGICAL, intent(in) :: DO_NBSPARSE
       INTEGER, intent(in) :: LRHS_BOUNDS
       INTEGER, intent(in) :: RHS_BOUNDS(LRHS_BOUNDS)
@@ -411,10 +411,10 @@ C
       INTEGER I, J, K, IPOS, NSLAVES, J1, J2, J3, FPERE, FPERE_MAPPING,
      &     NPIV, NCB, LIELL, JJ, NELIM, IERR
       INTEGER(8) :: PCB_COURANT, PPIV_COURANT, PPIV_PANEL, PCB_PANEL
-      INTEGER IPOSINRHSCOMP_TMP
+      INTEGER IPOSINRHSINTR_TMP
       INTEGER Effective_CB_Size, NUPDATE, ISLAVE, PDEST, FirstIndex
       LOGICAL FLAG
-      INTEGER :: NUPDATE_NONCRITICAL, IPOSINRHSCOMPLASTFSDYN 
+      INTEGER :: NUPDATE_NONCRITICAL, IPOSINRHSINTRLASTFSDYN 
       LOGICAL :: OMP_FLAG
       INCLUDE 'mumps_headers.h'
       INTEGER(8) :: APOSDEB
@@ -517,27 +517,27 @@ C
       ENDIF
       IF ( INODE .eq. KEEP( 38 ) .OR. INODE .eq. KEEP(20) ) THEN
         IFR8 = 0_8
-        IPOSINRHSCOMP_TMP = POSINRHSCOMP_FWD(IW(J1)) 
+        IPOSINRHSINTR_TMP = POSINRHSINTR_FWD(IW(J1)) 
         IFR_ini8 = IFR8
         OMP_FLAG = .FALSE.
 !$      OMP_FLAG = ( JBFIN-JBDEB+1.GE.KEEP(362) .AND.
 !$   &                     (J3-J1+1)*(JBFIN-JBDEB+1) .GE. KEEP(363) )
         IF (OMP_FLAG) THEN
 !$OMP PARALLEL DO PRIVATE(IFR8,JJ)
-          DO K=JBDEB,JBFIN
+          DO K=1,NRHS
              IFR8 = IFR_ini8 + int(K-1,8)*int(NPIV,8)
              DO JJ = J1, J3
                RHS_ROOT(IFR8+int(JJ-J1+1,8)) = 
-     &                 RHSCOMP(IPOSINRHSCOMP_TMP+JJ-J1,K)
+     &                 RHSINTR(IPOSINRHSINTR_TMP+JJ-J1,K)
              ENDDO
           ENDDO
 !$OMP END PARALLEL DO
         ELSE
-          DO K=JBDEB,JBFIN
+          DO K=1,NRHS
              IFR8 = IFR_ini8 + int(K-1,8)*int(NPIV,8)
              DO JJ = J1, J3
                RHS_ROOT(IFR8+int(JJ-J1+1,8)) = 
-     &                 RHSCOMP(IPOSINRHSCOMP_TMP+JJ-J1,K)
+     &                 RHSINTR(IPOSINRHSINTR_TMP+JJ-J1,K)
              ENDDO
           ENDDO
         ENDIF
@@ -602,10 +602,10 @@ C
       ELSE
         CBINITZERO = .FALSE. 
       ENDIF
-      CALL SMUMPS_RHSCOMP_TO_WCB(
+      CALL SMUMPS_RHSINTR_TO_WCB(
      &     NPIV, NCB, LIELL, CBINITZERO, LDEQLIELLPANEL,
-     &     RHSCOMP(1, JBDEB), LRHSCOMP, NRHS_B,
-     &     POSINRHSCOMP_FWD, N,
+     &     RHSINTR(1, JBDEB), LRHSINTR, NRHS_B,
+     &     POSINRHSINTR_FWD, N,
      &     WCB(PPIV_COURANT),
      &     IW, LIW, J1, J3, J2, KEEP, DKEEP)
       IF ( NPIV .NE. 0 ) THEN
@@ -702,8 +702,8 @@ C
      &           LIELL, WCB, LWCB, 
      &           LD_WCBPIV, LD_WCBCB,
      &           PPIV_COURANT, PCB_COURANT, 
-     &           RHSCOMP, LRHSCOMP, NRHS, 
-     &           POSINRHSCOMP_FWD, JBDEB, JBFIN,
+     &           RHSINTR, LRHSINTR, NRHS, 
+     &           POSINRHSINTR_FWD, JBDEB, JBFIN,
      &           MTYPE, KEEP, KEEP8, OOCWRITE_COMPATIBLE_WITH_BLR,
      &           INFO(1), INFO(2) )
             IF (INFO(1).LT.0) THEN
@@ -767,8 +767,8 @@ C
      &    IW, IPOS, LIW, 
      &    A, LA, APOS,
      &    WCB, LWCB, LD_WCBPIV, 
-     &    RHSCOMP, LRHSCOMP, NRHS, 
-     &    POSINRHSCOMP_FWD, JBDEB, JBFIN, 
+     &    RHSINTR, LRHSINTR, NRHS, 
+     &    POSINRHSINTR_FWD, JBDEB, JBFIN, 
      &    MTYPE, KEEP, OOCWRITE_COMPATIBLE_WITH_BLR,
      &    .FALSE.
      &    )
@@ -779,8 +779,8 @@ C
      &    IW, IPOS, LIW, 
      &    A, LA, APOS,
      &    WCB, LWCB, LD_WCBPIV, 
-     &    RHSCOMP, LRHSCOMP, NRHS, 
-     &    POSINRHSCOMP_FWD, JBDEB, JBFIN, 
+     &    RHSINTR, LRHSINTR, NRHS, 
+     &    POSINRHSINTR_FWD, JBDEB, JBFIN, 
      &    MTYPE, KEEP, OOCWRITE_COMPATIBLE_WITH_BLR,
      &    .FALSE.
      &    )
@@ -809,14 +809,14 @@ C
             NUPDATE_NONCRITICAL = NUPDATE
             IF (LASTFSL0DYN .LE. N) THEN
               IF ( LASTFSL0DYN .EQ. 0 ) THEN
-                IPOSINRHSCOMPLASTFSDYN = 0
+                IPOSINRHSINTRLASTFSDYN = 0
               ELSE
-                IPOSINRHSCOMPLASTFSDYN =
-     &                          abs(POSINRHSCOMP_FWD(LASTFSL0DYN))
+                IPOSINRHSINTRLASTFSDYN =
+     &                          abs(POSINRHSINTR_FWD(LASTFSL0DYN))
               ENDIF
               DO I = 1, NUPDATE
-                IF ( abs(POSINRHSCOMP_FWD( IW(J3+I) )) .GT. 
-     &               IPOSINRHSCOMPLASTFSDYN ) THEN
+                IF ( abs(POSINRHSINTR_FWD( IW(J3+I) )) .GT. 
+     &               IPOSINRHSINTRLASTFSDYN ) THEN
                   IF (abs(STEP(IW(J3+I))) .GT.
      &                abs(STEP( LASTFSL0STA))
      &                .OR. KEEP(261) .NE. 1) THEN
@@ -830,17 +830,17 @@ C
 !$          OMP_FLAG = ( NRHS_B.GE.KEEP(362) .AND.
 !$   &                  (NUPDATE*NRHS_B .GE. KEEP(363)) )
             IF (OMP_FLAG) THEN
-!$OMP PARALLEL DO PRIVATE(I,IFR8,IPOSINRHSCOMP_TMP)
+!$OMP PARALLEL DO PRIVATE(I,IFR8,IPOSINRHSINTR_TMP)
               DO K = JBDEB, JBFIN
                 IFR8 = PCB_COURANT + int(K-JBDEB,8)*int(LD_WCBCB,8)
 #if defined(__ve__)
 !NEC$ IVDEP
 #endif
                 DO I = 1, NUPDATE_NONCRITICAL
-                  IPOSINRHSCOMP_TMP = 
-     &            abs(POSINRHSCOMP_FWD(IW(J3 + I)))
-                  RHSCOMP( IPOSINRHSCOMP_TMP, K ) = 
-     &            RHSCOMP( IPOSINRHSCOMP_TMP, K )
+                  IPOSINRHSINTR_TMP = 
+     &            abs(POSINRHSINTR_FWD(IW(J3 + I)))
+                  RHSINTR( IPOSINRHSINTR_TMP, K ) = 
+     &            RHSINTR( IPOSINRHSINTR_TMP, K )
      &            + WCB(IFR8 + int(I-1,8))
                 ENDDO
               ENDDO
@@ -852,10 +852,10 @@ C
 !NEC$ IVDEP
 #endif
                 DO I = 1, NUPDATE_NONCRITICAL
-                  IPOSINRHSCOMP_TMP = 
-     &            abs(POSINRHSCOMP_FWD(IW(J3 + I)))
-                  RHSCOMP( IPOSINRHSCOMP_TMP, K ) = 
-     &            RHSCOMP( IPOSINRHSCOMP_TMP, K )
+                  IPOSINRHSINTR_TMP = 
+     &            abs(POSINRHSINTR_FWD(IW(J3 + I)))
+                  RHSINTR( IPOSINRHSINTR_TMP, K ) = 
+     &            RHSINTR( IPOSINRHSINTR_TMP, K )
      &            + WCB(IFR8 + int(I-1,8))
                 ENDDO
               ENDDO
@@ -878,10 +878,10 @@ C
 !NEC$ IVDEP
 #endif
                     DO I = NUPDATE_NONCRITICAL+1, NUPDATE
-                      IPOSINRHSCOMP_TMP = 
-     &                  abs(POSINRHSCOMP_FWD(IW(J3 + I)))
-                      RHSCOMP( IPOSINRHSCOMP_TMP, K ) = 
-     &                   RHSCOMP( IPOSINRHSCOMP_TMP, K )
+                      IPOSINRHSINTR_TMP = 
+     &                  abs(POSINRHSINTR_FWD(IW(J3 + I)))
+                      RHSINTR( IPOSINRHSINTR_TMP, K ) = 
+     &                   RHSINTR( IPOSINRHSINTR_TMP, K )
      &                   + WCB(IFR8 + int(I-1,8))
                     ENDDO
                   ENDDO
@@ -899,7 +899,7 @@ C
      &          NCB, LD_WCBCB,
      &          NUPDATE,
      &          IW( J3 + 1 ), WCB( PCB_COURANT ), JBDEB, JBFIN,
-     &          RHSCOMP, 1, 1, -9999, -9999,
+     &          RHSINTR, 1, 1, -9999, -9999,
      &          KEEP,
      &          MUMPS_PROCNODE(PROCNODE_STEPS(STEP(FPERE)), KEEP(199)),
      &          ContVec,
@@ -914,7 +914,7 @@ C
      &            WCB, LWCB, POSWCB, PLEFTWCB, POSIWCB,
      &            PTRICB, INFO, KEEP,KEEP8, DKEEP, STEP,
      &            PROCNODE_STEPS,
-     &            RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD
+     &            RHSINTR, LRHSINTR, POSINRHSINTR_FWD
      &            , FROM_PP
      &            )
             IF ( INFO( 1 )  .LT. 0 )  THEN
@@ -965,7 +965,7 @@ C
      &              WCB, LWCB, POSWCB, PLEFTWCB, POSIWCB,
      &              PTRICB, INFO, KEEP,KEEP8, DKEEP, STEP,
      &              PROCNODE_STEPS,
-     &              RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD
+     &              RHSINTR, LRHSINTR, POSINRHSINTR_FWD
      &              , FROM_PP
      &              )
                IF ( INFO( 1 )  .LT. 0 ) THEN
@@ -1001,7 +1001,7 @@ C
      &           WCB, LWCB, POSWCB,
      &           PLEFTWCB, POSIWCB,
      &           PTRICB, INFO, KEEP,KEEP8, DKEEP, STEP, PROCNODE_STEPS,
-     &           RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD
+     &           RHSINTR, LRHSINTR, POSINRHSINTR_FWD
      &            , FROM_PP
      &            )
       IMPLICIT NONE
@@ -1026,8 +1026,8 @@ C
       INTEGER STEP(N)
       INTEGER PROCNODE_STEPS(KEEP(28))
       LOGICAL FLAG
-      INTEGER LRHSCOMP, POSINRHSCOMP_FWD(N)
-      REAL RHSCOMP(LRHSCOMP,NRHS)
+      INTEGER LRHSINTR, POSINRHSINTR_FWD(N)
+      REAL RHSINTR(LRHSINTR,NRHS)
       LOGICAL, intent(in) :: FROM_PP
       INCLUDE 'mpif.h'
       INCLUDE 'mumps_tags.h'
@@ -1065,27 +1065,27 @@ C
      &          PLEFTWCB, POSIWCB,
      &          PTRICB, INFO, KEEP,KEEP8, DKEEP, STEP,
      &          PROCNODE_STEPS, 
-     &          RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD
+     &          RHSINTR, LRHSINTR, POSINRHSINTR_FWD
      &          , FROM_PP
      &          )
          END IF
       END IF
       RETURN
       END SUBROUTINE SMUMPS_SOLVE_RECV_AND_TREAT
-      SUBROUTINE SMUMPS_RHSCOMP_TO_WCB(
+      SUBROUTINE SMUMPS_RHSINTR_TO_WCB(
      &      NPIV, NCB, LIELL, CBINITZERO, LDEQLIELLPANEL,
-     &      RHSCOMP, LRHSCOMP, NRHS_B,
-     &      POSINRHSCOMP_FWD, N,
+     &      RHSINTR, LRHSINTR, NRHS_B,
+     &      POSINRHSINTR_FWD, N,
      &      WCB,
      &      IW, LIW, J1, J3, J2, KEEP, DKEEP)
       IMPLICIT NONE
       INTEGER, INTENT( IN )    :: NPIV, NCB, LIELL, N,
-     &                            LRHSCOMP, NRHS_B,
+     &                            LRHSINTR, NRHS_B,
      &                            LIW, J1, J2, J3
       LOGICAL, INTENT( IN )    :: LDEQLIELLPANEL
       LOGICAL, INTENT( IN )    :: CBINITZERO
-      INTEGER, INTENT( IN )    :: POSINRHSCOMP_FWD( N ), IW( LIW )
-      REAL, INTENT( INOUT ) :: RHSCOMP( LRHSCOMP, NRHS_B )
+      INTEGER, INTENT( IN )    :: POSINRHSINTR_FWD( N ), IW( LIW )
+      REAL, INTENT( INOUT ) :: RHSINTR( LRHSINTR, NRHS_B )
       REAL, INTENT( OUT )   :: WCB( int(LIELL,8)*
      &                                 int(NRHS_B,8) )
       INTEGER                  :: KEEP(500)
@@ -1093,7 +1093,7 @@ C
       INTEGER, PARAMETER :: ZERO = 0.0E0
       INTEGER(8), PARAMETER :: PPIV_COURANT = 1_8
       INTEGER(8) :: PCB_COURANT
-      INTEGER :: LD_WCBCB, LD_WCBPIV, J, JJ, K, IPOSINRHSCOMP
+      INTEGER :: LD_WCBCB, LD_WCBPIV, J, JJ, K, IPOSINRHSINTR
       INTEGER(8) :: IFR8, IFR_ini8 
       INCLUDE 'mpif.h' 
       LOGICAL :: OMP_FLAG
@@ -1109,11 +1109,11 @@ C
       IF ( LDEQLIELLPANEL ) THEN  
         DO K=1, NRHS_B
            IFR8 = PPIV_COURANT+int(K-1,8)*int(LD_WCBPIV,8)-1_8
-           IPOSINRHSCOMP = POSINRHSCOMP_FWD(IW(J1)) 
+           IPOSINRHSINTR = POSINRHSINTR_FWD(IW(J1)) 
            DO JJ = J1, J3
               IFR8 = IFR8 + 1_8
-              WCB(IFR8) = RHSCOMP(IPOSINRHSCOMP,K) 
-              IPOSINRHSCOMP = IPOSINRHSCOMP + 1
+              WCB(IFR8) = RHSINTR(IPOSINRHSINTR,K) 
+              IPOSINRHSINTR = IPOSINRHSINTR + 1
            ENDDO
            IF (NCB.GT.0 .AND. .NOT. CBINITZERO) THEN
 #if defined(__ve__)
@@ -1122,9 +1122,9 @@ C
               DO JJ = J3+1, J2
                  J = IW(JJ)
                  IFR8 = IFR8 + 1_8
-                 IPOSINRHSCOMP = abs(POSINRHSCOMP_FWD(J))
-                 WCB(IFR8) = RHSCOMP(IPOSINRHSCOMP,K) 
-                 RHSCOMP (IPOSINRHSCOMP,K) = ZERO
+                 IPOSINRHSINTR = abs(POSINRHSINTR_FWD(J))
+                 WCB(IFR8) = RHSINTR(IPOSINRHSINTR,K) 
+                 RHSINTR (IPOSINRHSINTR,K) = ZERO
               ENDDO
            ENDIF
         ENDDO
@@ -1132,7 +1132,7 @@ C
         PCB_COURANT = PPIV_COURANT + LD_WCBPIV*NRHS_B
         IFR8 = PPIV_COURANT - 1_8
         IFR_ini8 = IFR8
-        IPOSINRHSCOMP = POSINRHSCOMP_FWD(IW(J1)) 
+        IPOSINRHSINTR = POSINRHSINTR_FWD(IW(J1)) 
         OMP_FLAG = .FALSE.
 !$      OMP_FLAG = ( NRHS_B .GE. KEEP(362) .AND.
 !$   &               int(NCB,8)*int(NRHS_B,8) .GE. KEEP(363) )
@@ -1142,7 +1142,7 @@ C
             IFR8 = IFR_ini8 + int(K-1,8)*int(NPIV,8)
             DO  JJ = J1, J3
              WCB(IFR8+int(JJ-J1+1,8)) = 
-     &            RHSCOMP(IPOSINRHSCOMP+JJ-J1,K)
+     &            RHSINTR(IPOSINRHSINTR+JJ-J1,K)
             ENDDO
           ENDDO
 !$OMP END PARALLEL DO
@@ -1151,7 +1151,7 @@ C
             IFR8 = IFR_ini8 + int(K-1,8)*int(NPIV,8)
             DO  JJ = J1, J3
              WCB(IFR8+int(JJ-J1+1,8)) = 
-     &            RHSCOMP(IPOSINRHSCOMP+JJ-J1,K)
+     &            RHSINTR(IPOSINRHSINTR+JJ-J1,K)
             ENDDO
           ENDDO
         ENDIF
@@ -1162,7 +1162,7 @@ C
 !$        OMP_FLAG = ( NRHS_B.GE.KEEP(362) .AND.
 !$   &                 NCB*NRHS_B .GE. KEEP(363) )
           IF (OMP_FLAG) THEN
-!$OMP PARALLEL DO PRIVATE (IFR8, JJ, J, IPOSINRHSCOMP)
+!$OMP PARALLEL DO PRIVATE (IFR8, JJ, J, IPOSINRHSINTR)
             DO K=1, NRHS_B
               IFR8 = IFR_ini8+(K-1)*NCB
 #if defined(__ve__)
@@ -1170,9 +1170,9 @@ C
 #endif
               DO JJ = J3 + 1, J2
                 J = IW(JJ)
-                IPOSINRHSCOMP = abs(POSINRHSCOMP_FWD(J))
-                WCB(IFR8+int(JJ-J3,8)) = RHSCOMP(IPOSINRHSCOMP,K)
-                RHSCOMP(IPOSINRHSCOMP,K)=ZERO
+                IPOSINRHSINTR = abs(POSINRHSINTR_FWD(J))
+                WCB(IFR8+int(JJ-J3,8)) = RHSINTR(IPOSINRHSINTR,K)
+                RHSINTR(IPOSINRHSINTR,K)=ZERO
               ENDDO
             ENDDO
 !$OMP END PARALLEL DO
@@ -1184,9 +1184,9 @@ C
 #endif
               DO JJ = J3 + 1, J2
                 J = IW(JJ)
-                IPOSINRHSCOMP = abs(POSINRHSCOMP_FWD(J))
-                WCB(IFR8+int(JJ-J3,8)) = RHSCOMP(IPOSINRHSCOMP,K)
-                RHSCOMP(IPOSINRHSCOMP,K)=ZERO
+                IPOSINRHSINTR = abs(POSINRHSINTR_FWD(J))
+                WCB(IFR8+int(JJ-J3,8)) = RHSINTR(IPOSINRHSINTR,K)
+                RHSINTR(IPOSINRHSINTR,K)=ZERO
               ENDDO
             ENDDO
           ENDIF
@@ -1212,4 +1212,4 @@ C
         ENDIF
       ENDIF
       RETURN
-      END SUBROUTINE SMUMPS_RHSCOMP_TO_WCB
+      END SUBROUTINE SMUMPS_RHSINTR_TO_WCB
diff -pruN 5.6.2-2.1/src/ssol_lr.F 5.7.1-1/src/ssol_lr.F
--- 5.6.2-2.1/src/ssol_lr.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/ssol_lr.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -24,20 +24,20 @@ C
      &     LIELL, WCB, LWCB, 
      &     LD_WCBPIV, LD_WCBCB,
      &     PPIV_INIT, PCB_INIT, 
-     &     RHSCOMP, LRHSCOMP, NRHS, 
-     &     POSINRHSCOMP_FWD, JBDEB, JBFIN, 
+     &     RHSINTR, LRHSINTR, NRHS, 
+     &     POSINRHSINTR_FWD, JBDEB, JBFIN, 
      &     MTYPE, KEEP, KEEP8, OOCWRITE_COMPATIBLE_WITH_BLR,
      &     IFLAG, IERROR )
        INTEGER, INTENT(IN) :: INODE, N, IWHDLR, NPIV_GLOBAL, NSLAVES
        INTEGER, INTENT(IN) :: MTYPE, LIELL, KEEP(500)
        INTEGER(8), INTENT(IN) :: KEEP8(150)
-       INTEGER, INTENT(IN) :: LIW, IPOS_INIT, LRHSCOMP
-       INTEGER, INTENT(IN) :: IW(LIW), POSINRHSCOMP_FWD(N)
+       INTEGER, INTENT(IN) :: LIW, IPOS_INIT, LRHSINTR
+       INTEGER, INTENT(IN) :: IW(LIW), POSINRHSINTR_FWD(N)
        INTEGER(8), INTENT(IN) :: LWCB, PPIV_INIT, PCB_INIT
        INTEGER, INTENT(IN) :: LD_WCBPIV, LD_WCBCB, NRHS, JBDEB, JBFIN
        REAL, INTENT(INOUT) :: WCB(LWCB)
        INTEGER, INTENT(INOUT) :: IFLAG, IERROR
-       REAL, INTENT(INOUT) :: RHSCOMP(LRHSCOMP, NRHS)
+       REAL, INTENT(INOUT) :: RHSINTR(LRHSINTR, NRHS)
        LOGICAL, INTENT(IN)    :: OOCWRITE_COMPATIBLE_WITH_BLR
         INTEGER :: I, NPARTSASS, NB_BLR , NELIM, LDADIAG,
      &             DIAGSIZ_DYN, DIAGSIZ_STA, IBEG_BLR, IEND_BLR,
@@ -167,8 +167,8 @@ C
      &  IW, IPOS, LIW, 
      &  DIAG(1), int(size(DIAG),8), 1_8, 
      &  WCB, LWCB, LD_WCBPIV, 
-     &  RHSCOMP, LRHSCOMP, NRHS, 
-     &  POSINRHSCOMP_FWD, JBDEB, JBFIN, 
+     &  RHSINTR, LRHSINTR, NRHS, 
+     &  POSINRHSINTR_FWD, JBDEB, JBFIN, 
      &  MTYPE, KEEP, OOCWRITE_COMPATIBLE_WITH_BLR,
      &  .TRUE.  
      &  )
@@ -381,19 +381,19 @@ C
       SUBROUTINE SMUMPS_SOL_BWD_LR_SU 
      &   ( INODE, IWHDLR, NPIV_GLOBAL, NSLAVES,
      &     LIELL, WCB, LWCB, NRHS_B, PTWCB,
-     &     RHSCOMP, LRHSCOMP, NRHS,
-     &     IPOSINRHSCOMP, JBDEB, 
+     &     RHSINTR, LRHSINTR, NRHS,
+     &     IPOSINRHSINTR, JBDEB, 
      &     MTYPE, KEEP, KEEP8,
      &     IFLAG, IERROR )
        INTEGER, INTENT(IN) :: INODE, IWHDLR, NPIV_GLOBAL, NSLAVES
        INTEGER, INTENT(IN) :: MTYPE, LIELL, KEEP(500)
        INTEGER(8), INTENT(IN) :: KEEP8(150)
-       INTEGER, INTENT(IN) :: IPOSINRHSCOMP, JBDEB, LRHSCOMP, NRHS
+       INTEGER, INTENT(IN) :: IPOSINRHSINTR, JBDEB, LRHSINTR, NRHS
        INTEGER(8), INTENT(IN) :: LWCB, PTWCB
        INTEGER, INTENT(IN) ::  NRHS_B
        INTEGER, INTENT(INOUT) :: IFLAG, IERROR
        REAL, INTENT(INOUT) :: WCB(LWCB)
-       REAL RHSCOMP(LRHSCOMP,NRHS)
+       REAL RHSINTR(LRHSINTR,NRHS)
         INTEGER :: I, NPARTSASS, NB_BLR, LAST_BLR, 
      &             NELIM_PANEL, LD_WCB,
      &             DIAGSIZ_DYN, DIAGSIZ_STA, LDADIAG,
@@ -441,15 +441,15 @@ C
         ENDIF 
         IF (DIAGSIZ_DYN.EQ.0) GOTO 1000
         NELIM_PANEL = DIAGSIZ_STA - DIAGSIZ_DYN
-         IPIV_PANEL = IPOSINRHSCOMP + IBEG_BLR -1
+         IPIV_PANEL = IPOSINRHSINTR + IBEG_BLR -1
          IF ( MTYPE .EQ. 1 .AND. KEEP(50).EQ.0) THEN
           BLR_PANEL => BLR_ARRAY(IWHDLR)%PANELS_U(I)%LRB_PANEL
          ELSE
           BLR_PANEL => BLR_ARRAY(IWHDLR)%PANELS_L(I)%LRB_PANEL
          END IF
         CALL SMUMPS_SOL_BWD_BLR_UPDATE ( 
-     &        RHSCOMP, int(LRHSCOMP,8), NRHS, LRHSCOMP, 
-     &        int(IPOSINRHSCOMP,8), JBDEB,
+     &        RHSINTR, int(LRHSINTR,8), NRHS, LRHSINTR, 
+     &        int(IPOSINRHSINTR,8), JBDEB,
      &        WCB, LWCB, LD_WCB, PWCB, 
      &        int(IPIV_PANEL,8), 
      &        NRHS_B, NPIV_GLOBAL,
@@ -465,26 +465,26 @@ C
              IF (IEND_BLR.EQ.NPIV_GLOBAL) THEN
                CALL sgemm('T', 'N', DIAGSIZ_DYN, NRHS_B, NELIM_PANEL, 
      &              MONE, DIAG(1+DIAGSIZ_DYN), DIAGSIZ_STA,  WCB(PWCB),
-     &              LD_WCB, ONE , RHSCOMP(IPIV_PANEL,JBDEB),LRHSCOMP)
+     &              LD_WCB, ONE , RHSINTR(IPIV_PANEL,JBDEB),LRHSINTR)
              ELSE
                IF (IEND_BLR+1.LE.NPIV_GLOBAL .AND.
      &            IEND_BLR+NELIM_PANEL.GT.NPIV_GLOBAL) THEN
                  CALL sgemm('T', 'N', DIAGSIZ_DYN, NRHS_B,
      &              NPIV_GLOBAL-IEND_BLR, 
      &              MONE, DIAG(1+DIAGSIZ_DYN), DIAGSIZ_STA, 
-     &              RHSCOMP(IPIV_PANEL+DIAGSIZ_DYN,JBDEB), LRHSCOMP,
-     &              ONE, RHSCOMP(IPIV_PANEL,JBDEB), LRHSCOMP)
+     &              RHSINTR(IPIV_PANEL+DIAGSIZ_DYN,JBDEB), LRHSINTR,
+     &              ONE, RHSINTR(IPIV_PANEL,JBDEB), LRHSINTR)
                  CALL sgemm('T', 'N', DIAGSIZ_DYN, NRHS_B,
      &              IEND_BLR+NELIM_PANEL-NPIV_GLOBAL, 
      &              MONE, DIAG(1+DIAGSIZ_DYN+NPIV_GLOBAL-IEND_BLR),
      &              DIAGSIZ_STA, 
      &              WCB(PWCB), LD_WCB,
-     &              ONE, RHSCOMP(IPIV_PANEL,JBDEB), LRHSCOMP)
+     &              ONE, RHSINTR(IPIV_PANEL,JBDEB), LRHSINTR)
                ELSE
                  CALL sgemm('T', 'N', DIAGSIZ_DYN, NRHS_B, NELIM_PANEL, 
      &              MONE, DIAG(1+DIAGSIZ_DYN), DIAGSIZ_STA, 
-     &              RHSCOMP(IPIV_PANEL+DIAGSIZ_DYN,JBDEB), LRHSCOMP,
-     &              ONE, RHSCOMP(IPIV_PANEL,JBDEB), LRHSCOMP)
+     &              RHSINTR(IPIV_PANEL+DIAGSIZ_DYN,JBDEB), LRHSINTR,
+     &              ONE, RHSINTR(IPIV_PANEL,JBDEB), LRHSINTR)
                ENDIF
              ENDIF
            ELSE
@@ -492,27 +492,27 @@ C
                CALL sgemm('N', 'N', DIAGSIZ_DYN, NRHS_B, NELIM_PANEL, 
      &              MONE, DIAG(1+DIAGSIZ_DYN*LDADIAG), DIAGSIZ_DYN, 
      &              WCB(PWCB), LD_WCB, ONE, 
-     &              RHSCOMP(IPIV_PANEL,JBDEB), LRHSCOMP)
+     &              RHSINTR(IPIV_PANEL,JBDEB), LRHSINTR)
              ELSE
                IF (IEND_BLR+1.LE.NPIV_GLOBAL .AND.
      &            IEND_BLR+NELIM_PANEL.GT.NPIV_GLOBAL) THEN
                  CALL sgemm('N', 'N', DIAGSIZ_DYN, NRHS_B,
      &              NPIV_GLOBAL-IEND_BLR, 
      &              MONE, DIAG(1+DIAGSIZ_DYN*LDADIAG), DIAGSIZ_DYN, 
-     &              RHSCOMP(IPIV_PANEL+DIAGSIZ_DYN,JBDEB), LRHSCOMP,
-     &              ONE, RHSCOMP(IPIV_PANEL,JBDEB), LRHSCOMP)
+     &              RHSINTR(IPIV_PANEL+DIAGSIZ_DYN,JBDEB), LRHSINTR,
+     &              ONE, RHSINTR(IPIV_PANEL,JBDEB), LRHSINTR)
                  CALL sgemm('N', 'N', DIAGSIZ_DYN, NRHS_B,
      &              IEND_BLR+NELIM_PANEL-NPIV_GLOBAL, 
      &              MONE, DIAG(1+DIAGSIZ_DYN*LDADIAG +
      &                  (NPIV_GLOBAL-IEND_BLR)*DIAGSIZ_DYN),
      &              DIAGSIZ_DYN, 
      &              WCB(PWCB), LD_WCB,
-     &              ONE, RHSCOMP(IPIV_PANEL,JBDEB), LRHSCOMP)
+     &              ONE, RHSINTR(IPIV_PANEL,JBDEB), LRHSINTR)
                ELSE
                  CALL sgemm('N', 'N', DIAGSIZ_DYN, NRHS_B, NELIM_PANEL, 
      &              MONE, DIAG(1+DIAGSIZ_DYN*LDADIAG), DIAGSIZ_DYN, 
-     &              RHSCOMP(IPIV_PANEL+DIAGSIZ_DYN,JBDEB), LRHSCOMP,
-     &              ONE, RHSCOMP(IPIV_PANEL,JBDEB), LRHSCOMP)
+     &              RHSINTR(IPIV_PANEL+DIAGSIZ_DYN,JBDEB), LRHSINTR,
+     &              ONE, RHSINTR(IPIV_PANEL,JBDEB), LRHSINTR)
                ENDIF
              ENDIF
            ENDIF
@@ -521,7 +521,7 @@ C
          CALL SMUMPS_SOLVE_BWD_LR_TRSOLVE  (
      &         DIAG(1), size(DIAG), DIAGSIZ_DYN, NELIM_PANEL, LIELL,
      &         NRHS_B, WCB, LWCB, 
-     &         RHSCOMP, LRHSCOMP, NRHS,
+     &         RHSINTR, LRHSINTR, NRHS,
      &         IPIV_PANEL, JBDEB, 
      &         MTYPE, KEEP )
  1000 CONTINUE         
@@ -697,24 +697,24 @@ C
       SUBROUTINE SMUMPS_SOLVE_BWD_LR_TRSOLVE (
      &           DIAG, LDIAG, NPIV, NELIM, LIELL,
      &           NRHS_B, W, LWC, 
-     &           RHSCOMP, LRHSCOMP, NRHS,
-     &           PPIVINRHSCOMP, JBDEB, 
+     &           RHSINTR, LRHSINTR, NRHS,
+     &           PPIVINRHSINTR, JBDEB, 
      &           MTYPE, KEEP)
        INTEGER, INTENT(IN) :: MTYPE, LIELL, NPIV, NELIM, KEEP(500)
        INTEGER, INTENT(IN) :: NRHS_B, LDIAG
-       INTEGER, INTENT(IN) :: PPIVINRHSCOMP, JBDEB, LRHSCOMP, NRHS
+       INTEGER, INTENT(IN) :: PPIVINRHSINTR, JBDEB, LRHSINTR, NRHS
        INTEGER(8), INTENT(IN) ::  LWC
        REAL, INTENT(IN) :: DIAG(LDIAG)
        REAL, INTENT(INOUT) :: W(LWC)
-       REAL RHSCOMP(LRHSCOMP,NRHS)
+       REAL RHSINTR(LRHSINTR,NRHS)
        INTEGER :: LDAJ
       REAL ONE
       PARAMETER (ONE = 1.0E0)
         IF ( MTYPE .eq. 1 ) THEN
          LDAJ =  NPIV + NELIM
          CALL strsm('L','L','T','N', NPIV, NRHS_B, ONE, DIAG(1),
-     &              LDAJ, RHSCOMP(PPIVINRHSCOMP,JBDEB), 
-     &              LRHSCOMP)
+     &              LDAJ, RHSINTR(PPIVINRHSINTR,JBDEB), 
+     &              LRHSINTR)
         ELSE
          IF ( KEEP(50) .EQ. 0 ) THEN
            LDAJ=NPIV+NELIM
@@ -722,7 +722,7 @@ C
            LDAJ=NPIV
          ENDIF
          CALL strsm('L','U','N','U', NPIV, NRHS_B, ONE, DIAG(1),
-     &            LDAJ, RHSCOMP(PPIVINRHSCOMP,JBDEB), LRHSCOMP)
+     &            LDAJ, RHSINTR(PPIVINRHSINTR,JBDEB), LRHSINTR)
         END IF 
       RETURN
       END SUBROUTINE SMUMPS_SOLVE_BWD_LR_TRSOLVE
diff -pruN 5.6.2-2.1/src/ssol_matvec.F 5.7.1-1/src/ssol_matvec.F
--- 5.6.2-2.1/src/ssol_matvec.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/ssol_matvec.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/ssol_omp_m.F 5.7.1-1/src/ssol_omp_m.F
--- 5.6.2-2.1/src/ssol_omp_m.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/ssol_omp_m.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -35,16 +35,18 @@ C
       IMPLICIT NONE
       INTEGER, INTENT(IN) :: K400
 !$    INTEGER :: I
-!$    IF (K400 .GT. 0) THEN
-!$      DO I = 1, min(NB_LOCK_MAX,K400)
-!$        CALL OMP_DESTROY_LOCK(LOCK_FOR_SCATTER(I))
-!$      ENDDO
-!$      DEALLOCATE(LOCK_FOR_SCATTER)
+!$    IF (allocated(LOCK_FOR_SCATTER)) THEN
+!$      IF (K400 .GT. 0) THEN
+!$        DO I = 1, min(NB_LOCK_MAX,K400)
+!$          CALL OMP_DESTROY_LOCK(LOCK_FOR_SCATTER(I))
+!$        ENDDO
+!$        DEALLOCATE(LOCK_FOR_SCATTER)
+!$      ENDIF
 !$    ENDIF
       RETURN
       END SUBROUTINE SMUMPS_SOL_L0OMP_LD
       SUBROUTINE SMUMPS_SOL_L0OMP_R(N, MTYPE,
-     &  NRHS, LIW, IW, PTRICB, RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD,
+     &  NRHS, LIW, IW, PTRICB, RHSINTR, LRHSINTR, POSINRHSINTR_FWD,
      &  STEP, FRERE, DAD, FILS, NSTK, PTRIST, PTRFAC, INFO,
      &  KEEP, KEEP8, DKEEP, PROCNODE_STEPS, SLAVEF,
      &  COMM, MYID,              
@@ -69,8 +71,8 @@ C
       REAL                  :: DKEEP(230)
       INTEGER, INTENT( in ) :: PROCNODE_STEPS( KEEP(28) )
       INTEGER               :: PTRICB( KEEP(28) ) 
-      INTEGER, INTENT( in ) :: POSINRHSCOMP_FWD(N), LRHSCOMP 
-      REAL, INTENT(inout):: RHSCOMP(LRHSCOMP,NRHS)
+      INTEGER, INTENT( in ) :: POSINRHSINTR_FWD(N), LRHSINTR 
+      REAL, INTENT(inout):: RHSINTR(LRHSINTR,NRHS)
       INTEGER, INTENT( in ) :: STEP(N), FRERE( KEEP(28) ), FILS( N ),
      &                         DAD( KEEP(28) )
       INTEGER, INTENT( inout ) :: NSTK(KEEP(28))
@@ -220,7 +222,7 @@ C
      &        PTRICB, PTRIST, PTRFAC, PROCNODE_STEPS,
      &        FILS, STEP, FRERE, DAD, INFO_P, KEEP, KEEP8, DKEEP,
      &        RHS_ROOT, LRHS_ROOT, MTYPE,
-     &        RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD,
+     &        RHSINTR, LRHSINTR, POSINRHSINTR_FWD,
      &        ISTEP_TO_INIV2, TAB_POS_IN_PERE, 
      &        RHS_BOUNDS, LRHS_BOUNDS, DO_NBSPARSE, FROM_PP
      &        , ERROR_WAS_BROADCASTED_P )
@@ -286,7 +288,7 @@ C
       RETURN
       END SUBROUTINE SMUMPS_SOL_L0OMP_R
       SUBROUTINE SMUMPS_SOL_L0OMP_S(N, MTYPE, NRHS, LIW, IW,
-     &  PTRICB, PTRACB, RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &  PTRICB, PTRACB, RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &  STEP, FRERE, FILS, NE_STEPS, PTRIST, PTRFAC, INFO,
      &  KEEP, KEEP8, DKEEP, PROCNODE_STEPS, SLAVEF,
      &  COMM, MYID, BUFR, LBUFR, LBUFR_BYTES, RHS_ROOT, LRHS_ROOT, 
@@ -307,8 +309,8 @@ C
       INTEGER, INTENT( in ) :: PROCNODE_STEPS( KEEP(28) )
       INTEGER               :: PTRICB( KEEP(28) ) 
       INTEGER(8)            :: PTRACB( KEEP(28) ) 
-      INTEGER, INTENT( in ) :: POSINRHSCOMP_BWD(N), LRHSCOMP 
-      REAL, INTENT(inout):: RHSCOMP(LRHSCOMP,NRHS)
+      INTEGER, INTENT( in ) :: POSINRHSINTR_BWD(N), LRHSINTR 
+      REAL, INTENT(inout):: RHSINTR(LRHSINTR,NRHS)
       INTEGER, INTENT( in ) :: STEP(N), FRERE( KEEP(28) ), FILS( N )
       INTEGER, INTENT( inout ) :: NE_STEPS(KEEP(28))
       INTEGER, INTENT( in )    :: PTRIST(KEEP(28))
@@ -440,7 +442,7 @@ C
      &      IIPOOL_P,  NBFIN_DUMMY, L0_OMP_FACTORS(IL0OMPFAC)%A(1),
      &      L0_OMP_FACTORS(IL0OMPFAC)%LA, IW, LIW, 
      &      WCB_P, LWCB_P, NRHS, POSWCB_P, PLEFTWCB_P, POSIWCB_P,
-     &      RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &      RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &      PTRICB, PTRACB, IWCB_P, LIWCB_P, W2_P, NE_STEPS, STEP,
      &      FRERE, FILS, PTRIST, PTRFAC, MYLEAF_LEFT_HUGE_P, INFO_P, 
      &      PROCNODE_STEPS,
diff -pruN 5.6.2-2.1/src/ssol_root_parallel.F 5.7.1-1/src/ssol_root_parallel.F
--- 5.6.2-2.1/src/ssol_root_parallel.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/ssol_root_parallel.F	2024-05-02 10:15:25.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -29,11 +29,10 @@ C
       INTEGER IERR, NPROW, NPCOL, MYROW, MYCOL
       INTEGER LOCAL_N_RHS
       REAL, ALLOCATABLE, DIMENSION( :,: ) ::RHS_PAR
-      EXTERNAL numroc
-      INTEGER  numroc
+      INTEGER, EXTERNAL :: MUMPS_NUMROC
       INTEGER allocok
       CALL blacs_gridinfo( CNTXT_PAR, NPROW, NPCOL, MYROW, MYCOL )
-      LOCAL_N_RHS = numroc(NRHS, NBLOCK, MYCOL, 0, NPCOL)
+      LOCAL_N_RHS = MUMPS_NUMROC(NRHS, NBLOCK, MYCOL, 0, NPCOL)
       LOCAL_N_RHS = max(1,LOCAL_N_RHS)
       ALLOCATE(RHS_PAR(LOCAL_M, LOCAL_N_RHS),stat=allocok)
       IF (allocok > 0 ) THEN
diff -pruN 5.6.2-2.1/src/sstatic_ptr_m.F 5.7.1-1/src/sstatic_ptr_m.F
--- 5.6.2-2.1/src/sstatic_ptr_m.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/sstatic_ptr_m.F	2024-05-02 10:15:25.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/stools.F 5.7.1-1/src/stools.F
--- 5.6.2-2.1/src/stools.F	2023-10-11 09:37:04.000000000 +0000
+++ 5.7.1-1/src/stools.F	2024-05-02 10:15:26.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -638,14 +638,6 @@ C
      & '    Total space in MBytes, OOC factorization     (INFOG(39)):'
      &        ,INFOG(39)
       END IF
-      IF ( PROKG.AND.SUM_OF_PEAKS) THEN
-       WRITE( MPG,'(A,A)') 
-     & ' Estimations with BLR compression of only',
-     & ' Contribution Blocks (CB):'
-       WRITE( MPG,'(A,I6,A) ')
-     & ' ICNTL(39) Estimated compression rate of CB         =', 
-     &   KEEP(465), '/1000'
-      ENDIF
       IF (SUM_OF_PEAKS) THEN
        OOC_STAT  =  0  
        BLR_STRAT =  3  
@@ -686,16 +678,6 @@ C
           LRCB_UD(3) = LRCB_UD(2)/NSLAVES
         ENDIF
        ENDIF
-       IF ( PROKG.AND.SUM_OF_PEAKS ) THEN
-        IF (COMPUTE_MAXAVG) THEN
-         WRITE( MPG,'(A,I12) ')
-     & '    Maximum estim. space in Mbytes, IC facto.    (INFOG(44)):',
-     &        INFOG(44)
-        ENDIF
-        WRITE(MPG,'(A,I12) ')
-     & '    Total space in MBytes, IC factorization      (INFOG(45)):'
-     &        ,INFOG(45)
-       END IF
        OOC_STAT  =  1  
        BLR_STRAT =  3  
        BLR_CASE  =  1  
@@ -735,16 +717,6 @@ C
           OOC_LRCB_UD(3) = OOC_LRCB_UD(2)/NSLAVES
         ENDIF
        ENDIF
-       IF ( PROKG.AND.SUM_OF_PEAKS  ) THEN
-        IF (COMPUTE_MAXAVG) THEN
-         WRITE( MPG,'(A,I12) ')
-     & '    Maximum estim. space in Mbytes, OOC facto.   (INFOG(46)):',
-     &        INFOG(46)
-        ENDIF
-        WRITE(MPG,'(A,I12) ')
-     & '    Total space in MBytes, OOC factorization     (INFOG(47)):'
-     &        ,INFOG(47)
-       END IF
       END IF
       IF ( PROKG.AND.SUM_OF_PEAKS  ) THEN
        WRITE( MPG,'(A,A)') 
@@ -927,7 +899,7 @@ C
       NB_INT = NB_INT + 5_8 * NSTEPS8
       NB_INT = NB_INT + NSTEPS8 + int(KEEP(56),8)*int(NSLAVES+2,8)
         NB_INT = NB_INT + 3_8*N8 + KEEP(280)
-        IF (KEEP(38) .NE. 0) NB_INT = NB_INT + N8
+        IF (KEEP(38) .NE. 0 .AND.I_AM_SLAVE) NB_INT = NB_INT + N8 
       IF (KEEP(23).ne.0 .and. I_AM_MASTER) NB_INT=NB_INT + N8
       IF (KEEP(55).eq.0) THEN
         NB_INT = NB_INT + KEEP(193)*I8OVERI
@@ -1128,9 +1100,6 @@ C
      &         .and. KEEP(55) .ne. 0 ) ) THEN
         NB_INT  = NB_INT  + KEEP8(27)
       END IF
-      IF ( I_AM_SLAVE .and. KEEP(38) .ne. 0 ) THEN
-        NB_INT = NB_INT + N8
-      END IF
       TEMPI= 0_8
       TEMPR = 0_8
       NBRECORDS = KEEP(39)
@@ -1971,10 +1940,10 @@ C
      &  NB_INT=NB_INT+size(id%I_AM_CAND)
       IF (associated(id%MEM_DIST)) 
      &  NB_INT=NB_INT+size(id%MEM_DIST)
-      IF (associated(id%POSINRHSCOMP_ROW))
-     &     NB_INT=NB_INT+size(id%POSINRHSCOMP_ROW)
-      IF(id%POSINRHSCOMP_COL_ALLOC.AND.associated(id%POSINRHSCOMP_COL))
-     &     NB_INT=NB_INT+size(id%POSINRHSCOMP_COL)
+      IF (associated(id%GLOB2LOC_RHS))
+     &     NB_INT=NB_INT+size(id%GLOB2LOC_RHS)
+      IF(id%GLOB2LOC_SOL_ALLOC.AND.associated(id%GLOB2LOC_SOL))
+     &     NB_INT=NB_INT+size(id%GLOB2LOC_SOL)
       IF       (associated(id%MEM_SUBTREE))
      &  NB_REAL=NB_REAL+size(id%MEM_SUBTREE)*(id%KEEP(35)/id%KEEP(16))
       IF       (associated(id%MY_ROOT_SBTR))
@@ -2055,12 +2024,16 @@ C
      &     NB_CMPLX=NB_CMPLX+size(id%root%SVD_VT)
       IF (associated(id%root%SINGULAR_VALUES))
      &     NB_REAL=NB_REAL+size(id%root%SINGULAR_VALUES)
-      IF (associated(id%RHSCOMP)) NB_CMPLX = NB_CMPLX + id%KEEP8(25)
+      IF (associated(id%RHSINTR)) NB_CMPLX = NB_CMPLX + id%KEEP8(25)
       IF (associated(id%S))       NB_CMPLX=NB_CMPLX+id%KEEP8(23)
       IF (associated(id%COLSCA).AND.(id%KEEP(52).NE.-1))
      &     NB_REAL=NB_REAL+size(id%COLSCA)
       IF (associated(id%ROWSCA).AND.(id%KEEP(52).NE.-1))
      &     NB_REAL=NB_REAL+size(id%ROWSCA)
+      IF (associated(id%ROWSCA_loc)) 
+     &     NB_REAL=NB_REAL+size(id%ROWSCA_loc)
+      IF (associated(id%COLSCA_loc).AND.id%KEEP(50).EQ.0)
+     &     NB_REAL=NB_REAL+size(id%COLSCA_loc)
       NB_REAL=NB_REAL+size(id%CNTL)
       NB_REAL=NB_REAL+size(id%RINFO)
       NB_REAL=NB_REAL+size(id%RINFOG)
@@ -2083,7 +2056,6 @@ C
       INTEGER(8) :: SHIFT8, HUG8
       INTEGER    :: I, I4SIZE
       IF(int(huge(I4SIZE),8) .EQ. int(huge(HUG8),8)) THEN
-         CALL scopy(N8, SRC(1), 1, DEST(1), 1)
          CALL scopy(int(N8), SRC(1), 1, DEST(1), 1)
       ELSE
          HUG8=int(huge(I4SIZE),8)
diff -pruN 5.6.2-2.1/src/stype3_root.F 5.7.1-1/src/stype3_root.F
--- 5.6.2-2.1/src/stype3_root.F	2023-10-11 09:37:03.000000000 +0000
+++ 5.7.1-1/src/stype3_root.F	2024-05-02 10:15:25.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -127,7 +127,7 @@ C
       DOUBLE PRECISION OPASSW, OPELIW
       INTEGER PROCNODE_STEPS( KEEP(28) )
       INTEGER ITLOC( N + KEEP(253) ), FILS( N ), DAD(KEEP(28))
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INTEGER ND( KEEP(28) ), FRERE( KEEP(28) )
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
@@ -161,8 +161,6 @@ C
       INCLUDE 'mumps_headers.h'
       LOGICAL SKIPLAST_RHS_ROWS, BCP_SYM_NONEMPTY
       INTEGER BBPCBP
-      INTEGER MUMPS_PROCNODE
-      EXTERNAL MUMPS_PROCNODE
       BBPCBP  = 0   
       LP = ICNTL(1)
       IF ( ICNTL(4) .LE. 0 ) LP = -1
@@ -1176,7 +1174,7 @@ C
       INTEGER(8) :: PTRAST(KEEP(28)), PAMASTER(KEEP(28))
       INTEGER PIMASTER(KEEP(28))
       INTEGER ITLOC( N + KEEP(253) )
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INTEGER COMP, IFLAG, IERROR
       INCLUDE 'mumps_headers.h'
       INTEGER FILS( N ), DAD(KEEP(28))
@@ -1189,20 +1187,19 @@ C
       INTEGER, INTENT(IN) :: PTRDEBARR(KEEP(196))
       INTEGER INTARR(KEEP8(27))
       REAL DBLARR(KEEP8(26))
-      INTEGER numroc
-      EXTERNAL numroc
+      INTEGER, EXTERNAL :: MUMPS_NUMROC
       REAL ZERO
       PARAMETER( ZERO = 0.0E0 )
       INTEGER(8) :: LREQA_ROOT
       INTEGER LREQI_ROOT, LOCAL_M, LOCAL_N, allocok
       LOGICAL :: EARLYT3ROOTINS
-          LOCAL_M = numroc( root%ROOT_SIZE, root%MBLOCK,
+          LOCAL_M = MUMPS_NUMROC( root%ROOT_SIZE, root%MBLOCK,
      &              root%MYROW, 0, root%NPROW )
           LOCAL_M = max( 1, LOCAL_M )
-          LOCAL_N = numroc( root%ROOT_SIZE, root%NBLOCK,
+          LOCAL_N = MUMPS_NUMROC( root%ROOT_SIZE, root%NBLOCK,
      &              root%MYCOL, 0, root%NPCOL )
           IF (KEEP(253).GT.0) THEN
-            root%RHS_NLOC = numroc( KEEP(253), root%NBLOCK,
+            root%RHS_NLOC = MUMPS_NUMROC( KEEP(253), root%NBLOCK,
      &              root%MYCOL, 0, root%NPCOL )
             root%RHS_NLOC = max(1, root%RHS_NLOC)
           ELSE
@@ -1220,7 +1217,7 @@ C
           IF (KEEP(253).NE.0) THEN
             root%RHS_ROOT = ZERO
             CALL SMUMPS_ASM_RHS_ROOT (  N, FILS, 
-     &           root, KEEP, RHS_MUMPS, 
+     &           root, KEEP, KEEP8, RHS_MUMPS, 
      &           IFLAG, IERROR )
             IF ( IFLAG .LT. 0 ) RETURN
           ENDIF
@@ -1373,14 +1370,15 @@ C
       RETURN
       END SUBROUTINE SMUMPS_ASM_ELT_ROOT
       SUBROUTINE SMUMPS_ASM_RHS_ROOT
-     &           ( N, FILS, root, KEEP, RHS_MUMPS, 
+     &           ( N, FILS, root, KEEP, KEEP8, RHS_MUMPS, 
      &             IFLAG, IERROR )
       USE SMUMPS_STRUC_DEF, ONLY : SMUMPS_ROOT_STRUC
       IMPLICIT NONE
       INTEGER N, KEEP(500), IFLAG, IERROR
+      INTEGER(8) :: KEEP8(150)
       INTEGER FILS(N)
       TYPE (SMUMPS_ROOT_STRUC ) :: root
-      REAL :: RHS_MUMPS(KEEP(255))
+      REAL :: RHS_MUMPS(KEEP8(85))
       INTEGER JCOL, IPOS_ROOT, JPOS_ROOT,
      &        IROW_GRID, JCOL_GRID, ILOCRHS, JLOCRHS,
      &        INODE
diff -pruN 5.6.2-2.1/src/tools_common.F 5.7.1-1/src/tools_common.F
--- 5.6.2-2.1/src/tools_common.F	2023-10-11 09:36:34.000000000 +0000
+++ 5.7.1-1/src/tools_common.F	2024-05-02 10:15:13.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -11,6 +11,100 @@ C  released under the CeCILL-C license
 C  (see doc/CeCILL-C_V1-en.txt, doc/CeCILL-C_V1-fr.txt, and
 C  https://cecill.info/licences/Licence_CeCILL-C_V1-en.html)
 C
+      SUBROUTINE MUMPS_ADJUST_SIZE_LRGROUPS ( STEP, FILS, N, 
+     &           ND_STEPS, NSTEPS, KEEP, 
+     &           LRGROUPS, IFLAG, IERROR)
+!$    USE OMP_LIB
+      USE MUMPS_LR_COMMON,  ONLY : COMPUTE_BLR_VCS
+      IMPLICIT NONE
+      INTEGER, INTENT(IN)    :: N, NSTEPS
+      INTEGER, INTENT(IN)    :: FILS(N), STEP(N), ND_STEPS(NSTEPS)
+      INTEGER, INTENT(INOUT) :: KEEP(500)
+      INTEGER, INTENT(INOUT) :: LRGROUPS(KEEP(280))
+      INTEGER, INTENT(INOUT) :: IFLAG, IERROR
+      INTEGER :: I, NASS, NFRONT, IN, 
+     &           GROUP_SIZE2, NBGROUPS_local, LRGROUPS_SIGN, IG, 
+     &           NBGROUPS, MAXSIZE_GROUPS,
+     &           CurrentGroup, CurrentSize 
+      INTEGER :: OriginalSize, NBSPLIT, SZ_FINAL
+      INTEGER, DIMENSION(:), ALLOCATABLE :: GROUP_SIZE
+      INTEGER  :: allocok
+      IF (KEEP(494).EQ.0) RETURN
+      IF (KEEP(280).NE.N) THEN
+        WRITE(6,*) " Internal error in MUMPS_ADJUST_SIZE_LRGROUPS ",
+     &             "N, KEEP(280) =", N, KEEP(280)
+        RETURN
+      ENDIF
+      NBGROUPS = 0
+      DO I=1, N
+        IN = abs(LRGROUPS(I))
+        IF (IN.GT.NBGROUPS) NBGROUPS=IN
+      END DO
+      ALLOCATE( GROUP_SIZE(NBGROUPS), stat=allocok )
+      IF (allocok > 0) THEN
+        IFLAG  = -7
+        IERROR = NBGROUPS
+        RETURN
+      ENDIF
+      GROUP_SIZE = 0
+      MAXSIZE_GROUPS   = 0
+!$OMP PARALLEL DO SCHEDULE(DYNAMIC,1) 
+!$OMP&         PRIVATE( I, NBGROUPS_local, NASS, IN, NFRONT,
+!$OMP&                  GROUP_SIZE2, CurrentGroup, LRGROUPS_SIGN,
+!$OMP&                  IG, CurrentSize, OriginalSize, NBSPLIT, 
+!$OMP&                  SZ_FINAL
+!$OMP&                )
+!$OMP& REDUCTION(max:MAXSIZE_GROUPS
+!$OMP&                )
+      DO I= 1, N
+        IF (STEP(I).LE.0) CYCLE 
+        NASS = 0
+        IN   = I
+        DO WHILE (IN.GT.0)
+          CurrentGroup = abs(LRGROUPS(IN))
+          GROUP_SIZE(CurrentGroup) = GROUP_SIZE(CurrentGroup) + 1
+          NASS = NASS + 1
+          IN = FILS(IN)
+        ENDDO
+        NFRONT = ND_STEPS(STEP(I))
+        CALL COMPUTE_BLR_VCS(KEEP(472), GROUP_SIZE2, KEEP(488) , 
+     &                       NASS, NFRONT, KEEP(35))
+        IN = I
+        DO WHILE (IN.GT.0)
+          CurrentGroup  = LRGROUPS(IN)
+          OriginalSize  = GROUP_SIZE(abs(CurrentGroup))
+          NBSPLIT = (OriginalSize+GROUP_SIZE2-1)/ GROUP_SIZE2
+          SZ_FINAL = (OriginalSize+NBSPLIT-1)/NBSPLIT
+          MAXSIZE_GROUPS = max(SZ_FINAL, MAXSIZE_GROUPS)
+          IF (CurrentGroup.LT.0) THEN 
+             LRGROUPS_SIGN=-1
+          ELSE
+             LRGROUPS_SIGN=1
+          ENDIF
+          IG             = CurrentGroup 
+          NBGROUPS_local = IG
+          CurrentSize    = 0
+          DO WHILE (IG .eq. CurrentGroup)
+            LRGROUPS(IN) = NBGROUPS_local
+            CurrentSize = CurrentSize + 1
+            IF ( CurrentSize .GT. SZ_FINAL ) THEN
+!$OMP ATOMIC CAPTURE
+              NBGROUPS = NBGROUPS + 1
+              NBGROUPS_local = NBGROUPS
+!$OMP END ATOMIC 
+              NBGROUPS_local = NBGROUPS_local*LRGROUPS_SIGN
+              CurrentSize = 0
+            ENDIF
+            IN = FILS(IN)
+            IF (IN.LE.0) EXIT
+            IG =  LRGROUPS(IN)
+           END DO
+        END DO
+      END DO
+      KEEP(142) = MAXSIZE_GROUPS
+      DEALLOCATE(GROUP_SIZE)
+      RETURN
+      END  SUBROUTINE MUMPS_ADJUST_SIZE_LRGROUPS
       SUBROUTINE MUMPS_STOP_ON_USER_REQUEST( KEEP, KEEP8, ICNTL, INFO,
      &                                       MYID )
       INTEGER    :: INFO(80), KEEP(500), ICNTL(60), MYID
@@ -52,7 +146,7 @@ C
       INTEGER :: WORKERSPERNODE, WORKERSLEFT, WORKERSONMYNODE
       INTEGER, PARAMETER :: MAXNODE_SCOTCH=16, MAXNODE_METIS=64,  
      &                      ROOT=0
-      IF (KEEP(339).GE.5) THEN
+      IF (KEEP(339).NE.0) THEN
         IF (NPROCS.EQ.1) GOTO 100
         IF(N.LE.100) THEN
            WORKERS = 2
@@ -208,7 +302,7 @@ C
       INTEGER  :: IERR
       INTEGER  :: NPROCS
 #if defined(AVOID_MPI_IN_PLACE)
-      INTEGER :: TMP_INT, allocok
+      INTEGER :: TMP_INT
 #endif
 #if defined(AVOID_MPI_IN_PLACE)
       TMP(1:NPROCS_PARAORD)= -1
@@ -579,74 +673,6 @@ C
       END DO
       RETURN
       END SUBROUTINE MUMPS_SORT_DOUBLES_DEC
-#if defined (PESSL)
-      SUBROUTINE DESCINIT( DESC, M, N, MB, NB, IRSRC, ICSRC, ICTXT,
-     &                     LLD, INFO )
-      INTEGER            ICSRC, ICTXT, INFO, IRSRC, LLD, M, MB, N, NB
-      INTEGER            DESC( * )
-      INTEGER            BLOCK_CYCLIC_2D, CSRC_, CTXT_, DLEN_, DTYPE_,
-     &                   LLD_, MB_, M_, NB_, N_, RSRC_
-# if defined(DESC8)
-      PARAMETER          ( DLEN_ = 8, DTYPE_ = 1,
-     &                     CTXT_ = 7, M_ = 1, N_ = 2, MB_ = 3, NB_ = 4,
-     &                     RSRC_ = 5, CSRC_ = 6, LLD_ = 8 )
-# else
-      PARAMETER          ( BLOCK_CYCLIC_2D = 1, DLEN_ = 9, DTYPE_ = 1,
-     &                     CTXT_ = 2, M_ = 3, N_ = 4, MB_ = 5, NB_ = 6,
-     &                     RSRC_ = 7, CSRC_ = 8, LLD_ = 9 )
-# endif
-      INTEGER            MYCOL, MYROW, NPCOL, NPROW
-      EXTERNAL           blacs_gridinfo, PXERBLA
-      INTEGER            NUMROC
-      EXTERNAL           NUMROC
-      INTRINSIC          max, min
-      CALL blacs_gridinfo( ICTXT, NPROW, NPCOL, MYROW, MYCOL )
-      INFO = 0
-      IF( M.LT.0 ) THEN
-         INFO = -2
-      ELSE IF( N.LT.0 ) THEN
-         INFO = -3
-      ELSE IF( MB.LT.1 ) THEN
-         INFO = -4
-      ELSE IF( NB.LT.1 ) THEN
-         INFO = -5
-      ELSE IF( IRSRC.LT.0 .OR. IRSRC.GE.NPROW ) THEN
-         INFO = -6
-      ELSE IF( ICSRC.LT.0 .OR. ICSRC.GE.NPCOL ) THEN
-         INFO = -7
-      ELSE IF( NPROW.EQ.-1 ) THEN
-         INFO = -8
-      ELSE IF( LLD.LT.max( 1, numroc( M, MB, MYROW, IRSRC,
-     &                                NPROW ) ) ) THEN
-         INFO = -9
-      END IF
-      IF( INFO.NE.0 )
-     &   CALL PXERBLA( ICTXT, 'DESCINIT', -INFO )
-# ifndef DESC8
-      DESC( DTYPE_ ) = BLOCK_CYCLIC_2D
-# endif
-      DESC( M_ )  = max( 0, M )
-      DESC( N_ )  = max( 0, N )
-      DESC( MB_ ) = max( 1, MB )
-      DESC( NB_ ) = max( 1, NB )
-      DESC( RSRC_ ) = max( 0, min( IRSRC, NPROW-1 ) )
-      DESC( CSRC_ ) = max( 0, min( ICSRC, NPCOL-1 ) )
-      DESC( CTXT_ ) = ICTXT
-      DESC( LLD_ )  = max( LLD, max( 1, numroc( DESC( M_ ), DESC( MB_ ),
-     &                              MYROW, DESC( RSRC_ ), NPROW ) ) )
-      RETURN
-      END SUBROUTINE DESCINIT
-      SUBROUTINE PXERBLA( ICTXT, SRNAME, INFO )
-      INTEGER            ICTXT, INFO
-      CHARACTER*(*)      SRNAME
-      INTEGER            MYCOL, MYROW, NPCOL, NPROW
-      EXTERNAL           blacs_gridinfo
-      CALL blacs_gridinfo( ICTXT, NPROW, NPCOL, MYROW, MYCOL )
-      WRITE( *, FMT = 9999 ) MYROW, MYCOL, SRNAME, INFO
- 9999 FORMAT( '{', I5, ',', I5, '}:  On entry to ', A,
-     &        ' parameter number', I4, ' had an illegal value' )
-      END SUBROUTINE PXERBLA
-#endif
       SUBROUTINE MUMPS_MEM_CENTRALIZE(MYID, COMM, INFO, INFOG, IRANK)
       IMPLICIT NONE
       INTEGER MYID, COMM, IRANK, INFO, INFOG(2)
@@ -1232,8 +1258,6 @@ C
       INTEGER, DIMENSION (:), ALLOCATABLE :: IPOOL,TNSTK
       INTEGER I,II,allocok
       INTEGER NBLEAF,NBROOT,LEAF,IN,INODE,IFATH
-      EXTERNAL MUMPS_TYPENODE
-      INTEGER MUMPS_TYPENODE
       POSTORDER=1
       NBLEAF = NA(1)
       NBROOT = NA(2)
@@ -1397,6 +1421,7 @@ C
       deallocate(MyNAME_TAB)
       END SUBROUTINE MUMPS_GET_PROC_PER_NODE
       SUBROUTINE MUMPS_ICOPY_32TO64 (INTAB, SIZETAB, OUTTAB8)
+      IMPLICIT NONE
       INTEGER, intent(in)     ::  SIZETAB
       INTEGER, intent(in)     ::  INTAB(SIZETAB)
       INTEGER(8), intent(out) ::  OUTTAB8(SIZETAB)
@@ -1407,6 +1432,7 @@ C
       RETURN
       END SUBROUTINE MUMPS_ICOPY_32TO64
       SUBROUTINE MUMPS_ICOPY_32TO64_64C(INTAB, SIZETAB8, OUTTAB8)
+      IMPLICIT NONE
       INTEGER(8), intent(in)  ::  SIZETAB8
       INTEGER, intent(in)     ::  INTAB(SIZETAB8)
       INTEGER(8), intent(out) ::  OUTTAB8(SIZETAB8)
@@ -1421,20 +1447,23 @@ C
 !$OMP END PARALLEL DO
       RETURN
       END SUBROUTINE MUMPS_ICOPY_32TO64_64C
-      SUBROUTINE MUMPS_ICOPY_32TO64_64C_IP(IN_OUT_TAB48, SIZETAB)
-      INTEGER(8), intent(in) :: SIZETAB
-      INTEGER, intent(inout) :: IN_OUT_TAB48(2*SIZETAB)
-      CALL MUMPS_ICOPY_32TO64_64C_IP_REC(IN_OUT_TAB48, SIZETAB)
+      SUBROUTINE MUMPS_ICOPY_32TO64_64C_IP(IN_OUT_TAB48, SIZETAB,
+     &    SIZETABX2 ) 
+      IMPLICIT NONE
+      INTEGER(8), intent(in) :: SIZETAB, SIZETABX2
+      INTEGER, intent(inout) :: IN_OUT_TAB48(SIZETABX2)
+      CALL MUMPS_ICOPY_32TO64_64C_IP_REC(IN_OUT_TAB48, SIZETAB,
+     &    SIZETABX2)
       RETURN
       END SUBROUTINE MUMPS_ICOPY_32TO64_64C_IP
       RECURSIVE SUBROUTINE MUMPS_ICOPY_32TO64_64C_IP_REC(
-     &                     IN_OUT_TAB48, SIZETAB)
+     &                     IN_OUT_TAB48, SIZETAB, SIZETABX2)
       IMPLICIT NONE
-      INTEGER(8), intent(in) :: SIZETAB
-      INTEGER :: IN_OUT_TAB48(2*SIZETAB)
+      INTEGER(8), intent(in) :: SIZETAB, SIZETABX2
+      INTEGER :: IN_OUT_TAB48(SIZETABX2)
       INTEGER(8) :: IBEG24, IBEG28, SIZE1, SIZE2
       IF (SIZETAB.LE. 1000_8) THEN
-        CALL MUMPS_ICOPY_32TO64_64C_IP_C(IN_OUT_TAB48(1),
+        CALL MUMPS_ICOPY_32TO64_64C_IP_C(IN_OUT_TAB48,
      &       SIZETAB)
       ELSE
         SIZE2  = SIZETAB / 2
@@ -1444,11 +1473,12 @@ C
         CALL MUMPS_ICOPY_32TO64_64C(IN_OUT_TAB48(IBEG24),
      &                           SIZE2, IN_OUT_TAB48(IBEG28))
         CALL MUMPS_ICOPY_32TO64_64C_IP_REC(IN_OUT_TAB48,
-     &                           SIZE1)
+     &                           SIZE1, 2_8*SIZE1)
       ENDIF
       RETURN
       END SUBROUTINE MUMPS_ICOPY_32TO64_64C_IP_REC
       SUBROUTINE MUMPS_ICOPY_64TO32(INTAB8, SIZETAB, OUTTAB)
+      IMPLICIT NONE
       INTEGER, intent(in) ::  SIZETAB
       INTEGER(8), intent(in) ::  INTAB8(SIZETAB)
       INTEGER, intent(out)   ::  OUTTAB(SIZETAB)
@@ -1459,6 +1489,7 @@ C
       RETURN
       END SUBROUTINE MUMPS_ICOPY_64TO32
       SUBROUTINE MUMPS_ICOPY_64TO32_64C (INTAB8, SIZETAB, OUTTAB)
+      IMPLICIT NONE
       INTEGER(8), intent(in)    ::  SIZETAB
       INTEGER(8), intent(in) ::  INTAB8(SIZETAB)
       INTEGER, intent(out)   ::  OUTTAB(SIZETAB)
@@ -1468,20 +1499,23 @@ C
       ENDDO
       RETURN
       END SUBROUTINE MUMPS_ICOPY_64TO32_64C
-      SUBROUTINE MUMPS_ICOPY_64TO32_64C_IP(IN_OUT_TAB48, SIZETAB)
-      INTEGER(8), intent(in) :: SIZETAB
-      INTEGER, intent(inout) :: IN_OUT_TAB48(2*SIZETAB)
-      CALL MUMPS_ICOPY_64TO32_64C_IP_REC(IN_OUT_TAB48, SIZETAB)
+      SUBROUTINE MUMPS_ICOPY_64TO32_64C_IP(IN_OUT_TAB48, SIZETAB,
+     &                                     SIZETABX2)
+      IMPLICIT NONE
+      INTEGER(8), intent(in) :: SIZETAB, SIZETABX2
+      INTEGER, intent(inout) :: IN_OUT_TAB48(SIZETABX2)
+      CALL MUMPS_ICOPY_64TO32_64C_IP_REC(IN_OUT_TAB48, SIZETAB,
+     &                                   SIZETABX2)
       RETURN
       END SUBROUTINE MUMPS_ICOPY_64TO32_64C_IP
       RECURSIVE SUBROUTINE MUMPS_ICOPY_64TO32_64C_IP_REC(
-     &                     IN_OUT_TAB48, SIZETAB)
+     &                     IN_OUT_TAB48, SIZETAB, SIZETABX2)
       IMPLICIT NONE
-      INTEGER(8), intent(in) :: SIZETAB
-      INTEGER :: IN_OUT_TAB48(2*SIZETAB)
+      INTEGER(8), intent(in) :: SIZETAB, SIZETABX2
+      INTEGER :: IN_OUT_TAB48(SIZETABX2)
       INTEGER(8) :: IBEG24, IBEG28, SIZE1, SIZE2
       IF (SIZETAB.LE. 1000_8) THEN
-        CALL MUMPS_ICOPY_64TO32_64C_IP_C(IN_OUT_TAB48(1),
+        CALL MUMPS_ICOPY_64TO32_64C_IP_C(IN_OUT_TAB48,
      &       SIZETAB)
       ELSE
         SIZE2  = SIZETAB / 2
@@ -1489,7 +1523,7 @@ C
         IBEG24 = SIZE1 + 1
         IBEG28 = SIZE1 + SIZE1 + 1_8
         CALL MUMPS_ICOPY_64TO32_64C_IP_REC(IN_OUT_TAB48,
-     &                                        SIZE1)
+     &                                     SIZE1, 2_8*SIZE1)
         CALL MUMPS_ICOPY_64TO32_64C(IN_OUT_TAB48(IBEG28),
      &                           SIZE2, IN_OUT_TAB48(IBEG24))
       ENDIF
@@ -2060,3 +2094,57 @@ C
       TAB_POS(NSLAVES+1)= NCB+1
       NSLAVES_NODE=NSLAVES
       END SUBROUTINE MUMPS_SET_PARTI_REGULAR
+      SUBROUTINE MUMPS_BIGALLREDUCE(IS_IN_PLACE,
+     &           B1, B2, N,
+     &           MPI_TYPE, MPI_OP, COMM, IERR_MPI)
+      IMPLICIT NONE
+      LOGICAL :: IS_IN_PLACE
+      INTEGER :: N, MPI_TYPE, MPI_OP, COMM, IERR_MPI
+      INTEGER :: B1(*), B2(*) 
+      INTEGER, PARAMETER :: CHUNK = 250 000 000
+      INCLUDE 'mpif.h'
+      INTEGER :: I, THISCHUNK
+      INTEGER(8) :: IPOS
+      IF ( MPI_TYPE .NE. MPI_INTEGER .AND. MPI_TYPE .NE. MPI_2INTEGER )
+     &  THEN
+        WRITE(*,*) "Internal error MUMPS_BIGALLREDUCE",MPI_TYPE
+      ENDIF
+      DO I = 1, N, CHUNK
+        THISCHUNK=min(CHUNK, N-I+1)
+        IF ( MPI_TYPE.EQ.MPI_INTEGER) THEN
+                 IPOS = int(I,8)
+        ELSE
+                 IPOS =int(I,8)+int(I,8)-1_8
+        ENDIF
+        IF ( IS_IN_PLACE ) THEN
+          CALL MPI_ALLREDUCE( MPI_IN_PLACE, B2(IPOS), THISCHUNK,
+     &         MPI_TYPE, MPI_OP, COMM, IERR_MPI )
+        ELSE
+          CALL MPI_ALLREDUCE( B1(IPOS), B2(IPOS), THISCHUNK,
+     &         MPI_TYPE, MPI_OP, COMM, IERR_MPI )
+        ENDIF
+      ENDDO
+      RETURN
+      END SUBROUTINE MUMPS_BIGALLREDUCE
+      INTEGER FUNCTION MUMPS_NUMROC(ROOT_SIZE, BLOCK_SIZE,
+     &           MYPROC_ROW, IPROC_ROW1, NPROCS_ROW)
+      IMPLICIT NONE
+      INTEGER :: ROOT_SIZE, BLOCK_SIZE,
+     &           MYPROC_ROW, IPROC_ROW1, NPROCS_ROW
+      INTEGER :: NBLOCKS, EXTRA_FULL_BLOCKS, DIST_IPROC_ROW1, MYNBROWS
+      NBLOCKS = ROOT_SIZE / BLOCK_SIZE
+      MYNBROWS = (NBLOCKS/NPROCS_ROW)*BLOCK_SIZE
+      EXTRA_FULL_BLOCKS = mod(NBLOCKS, NPROCS_ROW)
+      IF (MYPROC_ROW .GE. IPROC_ROW1) THEN
+        DIST_IPROC_ROW1 = MYPROC_ROW - IPROC_ROW1
+      ELSE
+        DIST_IPROC_ROW1 = NPROCS_ROW + MYPROC_ROW - IPROC_ROW1
+      ENDIF
+      IF ( DIST_IPROC_ROW1 .LT. EXTRA_FULL_BLOCKS ) THEN
+        MYNBROWS = MYNBROWS + BLOCK_SIZE
+      ELSE IF ( DIST_IPROC_ROW1 .EQ. EXTRA_FULL_BLOCKS ) THEN
+        MYNBROWS = MYNBROWS + mod(ROOT_SIZE,BLOCK_SIZE)
+      ENDIF
+      MUMPS_NUMROC = MYNBROWS
+      RETURN
+      END FUNCTION MUMPS_NUMROC
diff -pruN 5.6.2-2.1/src/zana_LDLT_preprocess.F 5.7.1-1/src/zana_LDLT_preprocess.F
--- 5.6.2-2.1/src/zana_LDLT_preprocess.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zana_LDLT_preprocess.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/zana_aux.F 5.7.1-1/src/zana_aux.F
--- 5.6.2-2.1/src/zana_aux.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zana_aux.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -50,7 +50,7 @@ C
       INTEGER, INTENT(IN)    :: METIS_OPTIONS(40)
 #endif      
       INTEGER, INTENT(IN), OPTIONAL     :: NORIG_ARG
-      INTEGER, INTENT(IN), OPTIONAL     :: SIZEOFBLOCKS(N)
+      INTEGER, INTENT(IN), TARGET, OPTIONAL  :: SIZEOFBLOCKS(N)
       LOGICAL, INTENT(IN), OPTIONAL     :: GCOMP_PROVIDED_IN
       TYPE(COMPACT_GRAPH_T), OPTIONAL   :: GCOMP
       INTEGER, DIMENSION(:), ALLOCATABLE, TARGET :: IWALLOC
@@ -92,10 +92,9 @@ C
       PARAMETER (MINSYM=50)
       INTEGER(8) :: K79REF
       PARAMETER(K79REF=12000000_8)
-      INTEGER, PARAMETER :: LIDUMMY = 1 
-      INTEGER            :: IDUMMY(1)   
       INTEGER MTRANS, COMPRESS,NCMP,IERROR,J,JPERM,NCST
       INTEGER TOTEL 
+      INTEGER NFR
 #if defined(pord)
       INTEGER TOTW
 #endif
@@ -103,6 +102,8 @@ C
 #if defined(scotch) || defined(ptscotch)
       INTEGER WEIGHTREQUESTED
 #endif
+      INTEGER HOW_TO_SPLIT_ROOT, INODE_Scalapack_CAND, 
+     &        NBSONS_Scalapack_CAND
       LOGICAL SCOTCH_SYMBOLIC
       LOGICAL IDENT,SPLITROOT
       LOGICAL FREE_CENTRALIZED_MATRIX
@@ -110,32 +111,22 @@ C
       LOGICAL INPLACE64_GRAPH_COPY, INPLACE64_RESTORE_GRAPH
       INTEGER(8) :: LIW8, NZG8
       DOUBLE PRECISION TIMEB
+      INTEGER, POINTER, DIMENSION(:) :: SIZEOFBLOCKS_PTR
+      INTEGER, TARGET    :: IDUMMY_ARRAY(1)
+      INTEGER            :: LSIZEOFBLOCKS_PTR
+      LOGICAL            :: SIZEOFBLOCKS_AVAIL
       EXTERNAL MUMPS_ANA_H, ZMUMPS_ANA_J, 
      &     ZMUMPS_ANA_K, ZMUMPS_ANA_GNEW,
      &     ZMUMPS_ANA_LNEW, ZMUMPS_ANA_M
       EXTERNAL ZMUMPS_GNEW_SCHUR
       EXTERNAL ZMUMPS_LDLT_COMPRESS, ZMUMPS_EXPAND_PERMUTATION,
      &     ZMUMPS_SET_CONSTRAINTS
-      IF (LIWALLOC.GT.0_8) THEN
-        ALLOCATE( IWALLOC (LIWALLOC), stat = IERR )
-        IF ( IERR .GT. 0 ) THEN
-         INFO( 1 ) = -7
-         CALL MUMPS_SET_IERROR(LIWALLOC,INFO(2))
-         GOTO 90                
-        ENDIF
-      ENDIF
       ALLOCATE( IWL1 (N), stat = IERR )
       IF ( IERR .GT. 0 ) THEN
          INFO( 1 ) = -7
          INFO( 2 ) = N
          GOTO 90                
       ENDIF
-      ALLOCATE( IPEALLOC(N+1), stat = IERR )
-      IF ( IERR .GT. 0 ) THEN
-         INFO( 1 ) = -7
-         INFO( 2 ) = (N+1)*KEEP(10)
-         GOTO 90                
-      ENDIF
       ALLOCATE( PTRAR (N,3), stat = IERR )
       IF ( IERR .GT. 0 ) THEN
          INFO( 1 ) = -7
@@ -143,6 +134,9 @@ C
          GOTO 90                
       ENDIF
       SCOTCH_SYMBOLIC=(KEEP(270).EQ.0) 
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+      SCOTCH_SYMBOLIC=.FALSE.
+#endif
       symmetry      = INFO(8)
       NBQD          = 0
       GCOMP_PROVIDED=.FALSE.
@@ -160,13 +154,6 @@ C
         INFO(2) = 1
         RETURN
       ENDIF
-      IF ( (LIWALLOC.EQ.0_8).AND.(.not.GCOMP_PROVIDED)) THEN
-        INFO(1) = -900
-        WRITE(6,*) " INTERNAL ERROR in MUMPS(ANA_F) ", 
-     &  "LIWALLOC, GCOMP_PROVIDED=", LIWALLOC, GCOMP_PROVIDED
-        INFO(2) = 2
-        RETURN
-      ENDIF
       IF (GCOMP_PROVIDED) THEN
         NZG8 =  GCOMP%NZG
         LIW8 =  NZG8 + int(GCOMP%NG,8)+1_8
@@ -176,9 +163,30 @@ C
           PTRAR(I,2) = int(IPE(I+1)-IPE(I))
          ENDDO
       ELSE
+        IF (LIWALLOC.GT.0_8) THEN
+          ALLOCATE( IWALLOC (LIWALLOC), stat = IERR )
+          IF ( IERR .GT. 0 ) THEN
+           INFO( 1 ) = -7
+           CALL MUMPS_SET_IERROR(LIWALLOC,INFO(2))
+           GOTO 90                
+          ENDIF
+        ENDIF
+        IF ( LIWALLOC.EQ.0_8 ) THEN
+          INFO(1) = -900
+          WRITE(6,*) " INTERNAL ERROR in MUMPS(ANA_F) ", 
+     &    "LIWALLOC, GCOMP_PROVIDED=", LIWALLOC, GCOMP_PROVIDED
+          INFO(2) = 2
+          RETURN
+        ENDIF
         LIW8 =  LIWALLOC
-        NZG8 = NZ8
+        NZG8 =  NZ8
         IW   => IWALLOC(1:LIW8)
+        ALLOCATE( IPEALLOC(N+1), stat = IERR )
+        IF ( IERR .GT. 0 ) THEN
+          INFO( 1 ) = -7
+          INFO( 2 ) = (N+1)*KEEP(10)
+          GOTO 90                
+        ENDIF
         IPE  => IPEALLOC(1:N+1)
       ENDIF
       LP    = ICNTL(1)
@@ -187,6 +195,16 @@ C
       PROK  = ((MP.GT.0).AND.(ICNTL(4).GE.2))
       LDIAG = ICNTL(4)
       COMPRESS_SCHUR = .FALSE.
+      IF (present(SIZEOFBLOCKS)) THEN
+       SIZEOFBLOCKS_PTR => SIZEOFBLOCKS(1:N)
+       LSIZEOFBLOCKS_PTR = N
+       SIZEOFBLOCKS_AVAIL = .TRUE.
+      ELSE
+       SIZEOFBLOCKS_PTR => IDUMMY_ARRAY
+       SIZEOFBLOCKS_AVAIL = .FALSE.
+       LSIZEOFBLOCKS_PTR = 1
+       IDUMMY_ARRAY(1) = -1
+      ENDIF
       IF (PROK) THEN
         IF (present(GCOMP)) THEN
          WRITE(MP,'(A,I10,A,I13,A)') " Processing a graph of size:", N
@@ -228,7 +246,7 @@ C
           WRITE (MP,99999) N, NZG8, LIW8, INFO(1)
           IF (J8.GT.0_8) WRITE (MP,99998) (IRN(I8),ICN(I8),I8=1_8,J8)
         ENDIF
-         K = min0(10,N)
+         K = min(10,N)
          IF (LDIAG.EQ.4) K = N
          IF (IORD.EQ.1 .AND. K.GT.0) THEN
             WRITE (MP,99997) (IKEEP1(I),I=1,K)
@@ -609,7 +627,7 @@ C
      &              PARENT, IWFR8,
      &              PTRAR(1,2), IW, IWL1, IKEEP1,
      &              IKEEP2, NCMPA, INFO, LP, LPOK, KEEP(10),
-     &              INPLACE64_GRAPH_COPY,
+     &              INPLACE64_GRAPH_COPY, INPLACE64_RESTORE_GRAPH,
      &              WEIGHTUSED, WEIGHTREQUESTED, SCOTCH_SYMBOLIC)
                ELSE
                  WRITE(*,*)
@@ -971,10 +989,10 @@ C
               INFO(1)= -99998
               GOTO 90
            ELSE
-            ALLOCATE( WTEMP ( 2*N ), stat = IERR )
+            ALLOCATE( WTEMP ( 2_8*int(N,8) ), stat = IERR )
             IF ( IERR .GT. 0 ) THEN
                INFO( 1 ) = -7
-               INFO( 2 ) = 2*N
+               CALL MUMPS_SET_IERROR(2_8*int(N,8), INFO(2) )
                GOTO 90          
             ENDIF
             THRESH = -1
@@ -1035,24 +1053,15 @@ C
          INFO( 2 ) = N
          GOTO 90                
       ENDIF
-      IF (present(SIZEOFBLOCKS)) THEN
-       CALL ZMUMPS_ANA_LNEW
+      CALL ZMUMPS_ANA_LNEW
      &     (N, PARENT, IWL1, IKEEP1(1), IKEEP2(1), IKEEP3(1),
      &     NFSIZ(1), PTRAR, INFO(6), FILS(1), FRERE(1), 
      &     PTRAR(1,3), NEMIN, WTEMP, KEEP(60),
      &     KEEP(20),KEEP(38),PTRAR(1,2),KEEP(104),IW(1),KEEP(50), 
-     &     ICNTL(13), KEEP(37), KEEP(197), NSLAVES, KEEP(250).EQ.1 
-     &     , .TRUE. , SIZEOFBLOCKS, N
+     &     ICNTL(13), KEEP(37), KEEP(197), NSLAVES, KEEP(250).EQ.1,
+     &     SIZEOFBLOCKS_AVAIL, SIZEOFBLOCKS_PTR(1), LSIZEOFBLOCKS_PTR
+     &     , INODE_Scalapack_CAND, NBSONS_Scalapack_CAND, KEEP(11)
      &      )
-      ELSE
-       CALL ZMUMPS_ANA_LNEW
-     &     (N, PARENT, IWL1, IKEEP1(1), IKEEP2(1), IKEEP3(1),
-     &     NFSIZ(1), PTRAR, INFO(6), FILS(1), FRERE(1), 
-     &     PTRAR(1,3), NEMIN, WTEMP, KEEP(60),
-     &     KEEP(20),KEEP(38),PTRAR(1,2),KEEP(104),IW(1),KEEP(50), 
-     &     ICNTL(13), KEEP(37), KEEP(197), NSLAVES, KEEP(250).EQ.1 
-     &     , .FALSE., IDUMMY, LIDUMMY )
-      ENDIF
       DEALLOCATE(WTEMP)
       IF (KEEP(60).NE.0)  THEN
          IF (KEEP(60)==1) THEN
@@ -1085,6 +1094,8 @@ C
       IF ( KEEP(53) .NE. 0 ) THEN
          CALL MUMPS_MAKE1ROOT( N, FRERE(1), FILS(1), NFSIZ(1),
      &                         KEEP(20) )
+         INODE_Scalapack_CAND = KEEP(20)
+         NBSONS_Scalapack_CAND = 1
       END IF
       IF (  (KEEP(48) == 4 .AND. KEEP8(21).GT.0_8)
      &     .OR.
@@ -1099,61 +1110,95 @@ C
       IF (KEEP(210).EQ.1.AND.KEEP8(79).LE.0_8) THEN
         KEEP8(79)=K79REF * int(NSLAVES,8)
       ENDIF
-      IF ( (KEEP(79).EQ.0).OR.(KEEP(79).EQ.2).OR.
+      IF (KEEP(11).EQ.0) THEN
+       IF ( (KEEP(79).EQ.0).OR.(KEEP(79).EQ.2).OR.
      &     (KEEP(79).EQ.3).OR.(KEEP(79).EQ.5).OR.
      &     (KEEP(79).EQ.6)
      &   )  THEN
-       IF (KEEP(210).EQ.1) THEN
-        SPLITROOT = .FALSE. 
-        IF ( KEEP(62).GE.1) THEN
-          IWL1(1) = -1
-          IF (present(SIZEOFBLOCKS)) THEN
-            DO I= 1, N
-               IWL1(I) = SIZEOFBLOCKS(I)
-            ENDDO
-          ENDIF
-          CALL ZMUMPS_CUTNODES(N, FRERE(1), FILS(1), NFSIZ(1), 
-     &                       IWL1(1), N, INFO(6),
-     &                       NSLAVES, KEEP,KEEP8, SPLITROOT,
-     &                       MP, LDIAG, INFO(1), INFO(2))
-          IF (INFO(1).LT.0) GOTO 90 
-          IF (PROK) THEN
+        IF (KEEP(210).EQ.1) THEN
+         SPLITROOT = .FALSE. 
+         IF ( KEEP(62).GE.1) THEN
+           CALL ZMUMPS_CUTNODES(N, FRERE(1), FILS(1), NFSIZ(1), 
+     &         SIZEOFBLOCKS_PTR(1), LSIZEOFBLOCKS_PTR, INFO(6),
+     &         NSLAVES, KEEP,KEEP8, SPLITROOT,
+     &         MP, LDIAG, INFO(1), INFO(2))
+           IF (INFO(1).LT.0) GOTO 90 
+           IF (PROK) THEN
                WRITE(MP,*) " Number of split nodes in pre-splitting=",
      &         KEEP(61)
-          ENDIF
+           ENDIF
+         ENDIF
         ENDIF
        ENDIF
       ENDIF
+      HOW_TO_SPLIT_ROOT = 0 
       SPLITROOT = ICNTL(13) .EQ. -1
+      IF (KEEP(11).GT.1) THEN
+       NFR = NFSIZ(INODE_Scalapack_CAND)
+#if defined(NOSCALAPACK)
+        SPLITROOT = SPLITROOT .OR. 
+     & ( NSLAVES.GT.0.AND. 
+     &   ( dble(NFR) - dble(NFR)/dble(max(2,NSLAVES))
+     &    .GT. dble(KEEP(9)) )
+     & )
+#else
+        SPLITROOT = SPLITROOT .OR.
+     &  ( ICNTL(13).GT.0 .AND. NSLAVES .GT. ICNTL(13). AND.
+     &    ( dble(NFR) - dble(NFR)/dble(max(2,NSLAVES)) 
+     &     .GT. dble(KEEP(9)) )
+     &  )
+#endif
+      ELSE
 #if defined(NOSCALAPACK)
-      SPLITROOT = SPLITROOT .OR. NSLAVES.GT.0
+        SPLITROOT = SPLITROOT .OR. NSLAVES.GT.0
 #else
-      SPLITROOT = SPLITROOT .OR.
-     &            (ICNTL(13).GT.0 .AND. NSLAVES .GT. ICNTL(13))
+        SPLITROOT = SPLITROOT .OR.
+     &            (ICNTL(13).GT.0 .AND. NSLAVES .GT. ICNTL(13)
+     &            )
 #endif
+      ENDIF
+      IF (SPLITROOT.AND.KEEP(11).GT.0) HOW_TO_SPLIT_ROOT =1 
       IF (KEEP(53) .NE. 0) THEN
-         SPLITROOT = .TRUE.
+         SPLITROOT         = .TRUE.
+         IF (KEEP(11).GT.0) HOW_TO_SPLIT_ROOT = 2
+      ENDIF
+#if defined(NOSCALAPACK)
+#else
+      IF ( KEEP(11).GT.0) THEN 
+        IF (.NOT.SPLITROOT .AND. 
+     &    (KEEP(60).EQ.0).AND.   
+     &    ( (NFSIZ(INODE_Scalapack_CAND).GT.KEEP(37))
+     &     .AND.(ICNTL(13).LE.0) )
+     &    .AND.
+     &    (NBSONS_Scalapack_CAND.GT.KEEP(11)) 
+     &    ) THEN
+          HOW_TO_SPLIT_ROOT = 3
+          SPLITROOT=.TRUE.
+        ENDIF
       ENDIF
+#endif
       SPLITROOT = (SPLITROOT.AND.( (KEEP(60).EQ.0) ))
       IF (SPLITROOT) THEN
-         IWL1(1) = -1
-         IF (present(SIZEOFBLOCKS)) THEN
-            DO I= 1, N
-               IWL1(I) = SIZEOFBLOCKS(I)
-            ENDDO
-         ENDIF
-         CALL ZMUMPS_CUTNODES(N, FRERE(1), FILS(1), NFSIZ(1), 
-     &                    IWL1(1), N, INFO(6),
-     &                    NSLAVES, KEEP,KEEP8, SPLITROOT,
-     &                    MP, LDIAG, INFO(1), INFO(2))
-         IF (INFO(1).LT.0) GOTO 90 
-         IF ( KEEP(53) .NE. 0 ) THEN
-          CALL MUMPS_MAKE1ROOT( N, FRERE(1), FILS(1), NFSIZ(1),
-     &                          KEEP(20) )
-         ENDIF
+        IF (KEEP(11).EQ.0) THEN
+          CALL ZMUMPS_CUTNODES(N, FRERE(1), FILS(1), NFSIZ(1), 
+     &              SIZEOFBLOCKS_PTR(1), LSIZEOFBLOCKS_PTR, INFO(6),
+     &              NSLAVES, KEEP,KEEP8, SPLITROOT,
+     &              MP, LDIAG, INFO(1), INFO(2))
+          IF (INFO(1).LT.0) GOTO 90 
+          IF ( KEEP(53) .NE. 0 ) THEN
+           CALL MUMPS_MAKE1ROOT( N, FRERE(1), FILS(1), NFSIZ(1),
+     &                           KEEP(20) )
+          ENDIF
+        ELSE
+         CALL ZMUMPS_SPLIT_ROOT( NSLAVES, 
+     &            HOW_TO_SPLIT_ROOT, INODE_Scalapack_CAND,
+     &            N, FRERE(1), FILS(1), NFSIZ(1), 
+     &            KEEP(1), KEEP8(1),
+     &            SIZEOFBLOCKS_PTR(1), LSIZEOFBLOCKS_PTR, INFO(6))
+        ENDIF
       ENDIF
       IF (LDIAG.GT.2 .AND. MP.GT.0) THEN
-         K = min0(10,N)
+         K = min(10,N)
          IF (LDIAG.EQ.4) K = N
          IF (K.GT.0) WRITE (MP,99987) (NFSIZ(I),I=1,K)
          IF (K.GT.0) WRITE (MP,99989) (FILS(I),I=1,K)
@@ -1250,9 +1295,9 @@ C
  70      CONTINUE
       END IF
       IF (id%KEEP(54) .EQ. 3) THEN
-         CALL MPI_ALLREDUCE(IWORK1(1), NBINCOL(1), id%N,
+         CALL MUMPS_BIGALLREDUCE(.FALSE., IWORK1(1), NBINCOL(1), id%N,
      &        MPI_INTEGER, MPI_SUM, id%COMM, IERR )
-         CALL MPI_ALLREDUCE(IWORK2(1), NBINROW(1), id%N,
+         CALL MUMPS_BIGALLREDUCE(.FALSE., IWORK2(1), NBINROW(1), id%N,
      &        MPI_INTEGER, MPI_SUM, id%COMM, IERR )
          deallocate(IWORK2)
       ELSE
@@ -1263,7 +1308,8 @@ C
       END IF
       RETURN
       END SUBROUTINE ZMUMPS_ANA_N_DIST
-      SUBROUTINE ZMUMPS_ANA_O( N, NZ, MTRANS, PERM, IKEEPALLOC,
+      SUBROUTINE ZMUMPS_ANA_O( N, NZ, MTRANS, PERM,
+     &     IKEEPALLOC, LIKEEPALLOC,
      &     idIRN, idJCN, idA, idROWSCA, idCOLSCA, WORK2, KEEP,
      &     ICNTL, INFO, INFOG )
       IMPLICIT NONE
@@ -1273,7 +1319,8 @@ C
       INTEGER, POINTER, DIMENSION(:) :: idIRN, idJCN
       COMPLEX(kind=8), POINTER, DIMENSION(:) :: idA
       DOUBLE PRECISION, POINTER, DIMENSION(:) :: idROWSCA, idCOLSCA
-      INTEGER, TARGET        :: IKEEPALLOC(3*N)
+      INTEGER(8), INTENT(IN) :: LIKEEPALLOC
+      INTEGER, TARGET        :: IKEEPALLOC(LIKEEPALLOC)
       INTEGER, INTENT(INOUT) :: MTRANS
       INTEGER                :: KEEP(500)
       INTEGER, INTENT(IN)    :: ICNTL(60)
@@ -1398,7 +1445,7 @@ C
          NZTOT = NZ
       ENDIF
       ZERODIAG => IKEEPALLOC(1:N) 
-      STR_KER => IKEEPALLOC(N+1:2*N)
+      STR_KER  => IKEEPALLOC(int(N+1,8):2_8*int(N,8))
       CALL ZMUMPS_MTRANSI(ICNTL64,CNTL64)
       ICNTL64(1) = ICNTL(1)
       ICNTL64(2) = ICNTL(2)
@@ -1446,7 +1493,8 @@ C
       ALLOCATE( IPQ8(N), IPE(N+1), stat = allocok )
       IF ( allocok .GT. 0 ) THEN
          INFO( 1 ) = -7
-         INFO( 2 ) = (2*N+1)*KEEP(10)
+         CALL MUMPS_SET_IERROR( (2_8*int(N,8)+1_8) * int(KEEP(10),8),
+     &                         INFO(2) )
          GOTO 500               
       ENDIF
       IF (MTRANSLOC.EQ.1) THEN
@@ -1456,8 +1504,8 @@ C
       IF (MTRANSLOC.EQ.3) LDWMIN = max( NZTOT+1_8 , N8+3_8 )
       IF (MTRANSLOC.EQ.4) LDWMIN = 2_8 * N8 + 
      &                             max( NZTOT , N8+3_8 )
-      IF (MTRANSLOC.EQ.5) LDWMIN = 3_8*N8 + NZTOT
-      IF (MTRANSLOC.EQ.6) LDWMIN = 4_8*N8 + NZTOT
+      IF (MTRANSLOC.EQ.5) LDWMIN = 3_8 * N8 + NZTOT
+      IF (MTRANSLOC.EQ.6) LDWMIN = 4_8 * N8 + NZTOT
       LDW   = LDWMIN
       ALLOCATE(S2(LDW), stat=allocok)
       IF (allocok .GT. 0 ) THEN
@@ -1626,7 +1674,7 @@ C
       ENDIF
       DUPPLI = .FALSE.
       NZsave = NZREAL
-      FLAG => IKEEPALLOC(2*N+1:3*N)
+      FLAG => IKEEPALLOC(2_8*int(N,8)+1:3_8*int(N,8))
       IF(MTRANSLOC.NE.1) THEN
          CALL ZMUMPS_SUPPRESS_DUPPLI_VAL(N,NZREAL,IPE(1),IW(IRNW),S2,
      &        PERM(1),IPQ8(1))
@@ -1853,8 +1901,8 @@ C
             ICNTL_SYM_MWM(1) = 0
             ICNTL_SYM_MWM(2) = 1
          ENDIF
-         MARKED => IKEEPALLOC(N+1:2*N)
-         FLAG => IKEEPALLOC(2*N+1:3*N)
+         MARKED  => IKEEPALLOC(    int(N,8)+1_8 : 2_8*int(N,8))
+         FLAG    => IKEEPALLOC(2_8*int(N,8)+1_8 : 3_8*int(N,8))
          PIV_OUT => WORK2(1:N)
          IF(MTRANSLOC .LT. 4) THEN
             LSC = 1
@@ -1976,7 +2024,7 @@ C
    30       IP = LWFR
             JP = IPE(IE)
    40       IW(IWFR) = JS
-            MINJS = min0(MINJS,IPS(JS)+0)
+            MINJS = min(MINJS,IPS(JS)+0)
             IWFR = IWFR + 1_8
    50     CONTINUE
    60     IPE(IE) = int(-ME,8)
@@ -2073,7 +2121,7 @@ C
       LBIG = 0
       DO 100 I=1,N
         L1 = IQ(I)
-        LBIG = max0(L1,LBIG)
+        LBIG = max(L1,LBIG)
         IWFR = IWFR + int(L1,8)
         IPE(I) = IWFR - 1_8
   100 CONTINUE
@@ -2191,6 +2239,8 @@ C
      &               CUMUL,KEEP50, ICNTL13, KEEP37, KEEP197, NSLAVES,
      &               ALLOW_AMALG_TINY_NODES 
      &               , BLKON, SIZEOFBLOCKS, LSIZEOFBLOCKS
+     &               , INODE_Scalapack_CAND, NBSONS_Scalapack_CAND
+     &               , KEEP11
      &               )
       IMPLICIT NONE
       INTEGER  N, NSTEPS, KEEP60, KEEP20, KEEP38, KEEP50
@@ -2208,6 +2258,9 @@ C
       LOGICAL, INTENT(IN) :: BLKON
       INTEGER, INTENT(IN) :: LSIZEOFBLOCKS
       INTEGER, INTENT(IN) :: SIZEOFBLOCKS(LSIZEOFBLOCKS) 
+      INTEGER, INTENT(OUT):: INODE_Scalapack_CAND, 
+     &                       NBSONS_Scalapack_CAND
+      INTEGER, INTENT(IN) :: KEEP11
 #if  defined(NOAMALGTOFATHER)
 #else
 #endif
@@ -2216,6 +2269,8 @@ C
       INTEGER INOS,IB,IL
       INTEGER IPERM
       INTEGER MAXNODE
+      INTEGER SIZE_Scalapack_CAND, NBSONS_current_root
+      LOGICAL ROOT_WITH_FEW_SONS
 #if defined(NOAMALGTOFATHER)
       INTEGER INB,INF,INFS,INL,INSW,INT1,NR1
 #else
@@ -2223,6 +2278,10 @@ C
 #endif
       LOGICAL AMALG_TO_father_OK
       AMALG_COUNT = 0
+      INODE_Scalapack_CAND  = -1
+      NBSONS_Scalapack_CAND = -1
+      SIZE_Scalapack_CAND   = -1
+      NBSONS_current_root   = 0
       DO 10 I=1,N
         CUMUL(I)= 0
         IPS(I)  = 0
@@ -2332,6 +2391,16 @@ C
          NR = NR + 1
          IL = N
          NA(N) = 0
+         NBSONS_current_root =0
+         IF (IPS(I).LT.0) THEN
+          IB = -IPS(I)
+          NBSONS_current_root = NBSONS_current_root + 1
+  69      IB =FRERE(IB)
+          IF (IB.GT.0) THEN
+             NBSONS_current_root = NBSONS_current_root + 1
+             GOTO 69
+          ENDIF
+         ENDIF
         ENDIF
         DO 70 L=1,N
           IF (IPS(I).GE.0) EXIT
@@ -2341,8 +2410,14 @@ C
           IL = IL - 1
           NA(IL) = 0
    70   CONTINUE
-#if ! defined(NOAMALGTOFATHER)
         DADI = -IPE(I)  
+        IF (DADI.EQ.0) THEN
+         IF (NV(I) .GT. SIZE_Scalapack_CAND) THEN
+           INODE_Scalapack_CAND = I
+           SIZE_Scalapack_CAND  = NV(I)
+         ENDIF
+        ENDIF
+#if ! defined(NOAMALGTOFATHER)
         IF ( (DADI.NE.0) .AND.
      &      (
      &       (KEEP60.EQ.0).OR.
@@ -2387,9 +2462,25 @@ C
                  AMALG_TO_father_OK = .FALSE.
               ENDIF
            ENDIF
+           ROOT_WITH_FEW_SONS =.TRUE.
+           IF (KEEP11.GT.0) THEN
+             IF (IPE(DADI).EQ.0) THEN
+                IF 
+     &          (NA(IL)+max(NA(IL+1),NBSONS_current_root)
+     &                    .GT.KEEP11)
+     &          ROOT_WITH_FEW_SONS= .FALSE.
+             ELSE
+                IF 
+     &          (NA(IL)+NA(IL+1)+max(NA(N),NBSONS_current_root)
+     &                    .GT.KEEP11)
+     &          ROOT_WITH_FEW_SONS= .FALSE.
+             ENDIF
+           ENDIF
            IF ( (NV(I).GT. 50*NV(DADI)).AND. (NSLAVES.GT.1) 
      &          .AND. (ICNTL13.LE.0)
-     &          .AND. (NV(I).GT. KEEP37) )  THEN
+     &          .AND. (NV(I).GT. KEEP37) 
+     &          .AND. ROOT_WITH_FEW_SONS
+     &        )  THEN
              IF ( ( ACCU / SIZE_DADI_AMALGAMATED ) .LT. 0.2 ) THEN
                AMALG_TO_father_OK = .TRUE.
              ENDIF
@@ -2536,6 +2627,17 @@ C
         ENDIF
   160 CONTINUE
       NSTEPS = IS - 1
+        I = INODE_Scalapack_CAND
+        INOS = -FILS(I)  
+        NBSONS_Scalapack_CAND = 0
+        IF (INOS.GT.0) THEN
+          NBSONS_Scalapack_CAND = NBSONS_Scalapack_CAND+1
+          INO = FRERE(INOS)
+          DO WHILE (INO.GT.0 .AND. INO.LE.N) 
+           NBSONS_Scalapack_CAND = NBSONS_Scalapack_CAND+1
+           INO = FRERE(INO)
+          ENDDO
+        ENDIF
       DO I=1, N
         IF (NV(I).EQ.0) THEN
           FRERE(I) = N+1
@@ -2647,7 +2749,7 @@ C
       DOUBLE PRECISION, INTENT(IN)       :: RINFO(40), RINFOG(40)
       INCLUDE 'mpif.h'
       INTEGER MASTER, MPG
-      INTEGER ITMP
+      INTEGER ITMP, ICNTL48_EFF
       PARAMETER( MASTER = 0 )
       MPG = ICNTL(3)
       IF ( MYID.eq.MASTER.and.MPG.GT.0.AND.ICNTL(4).GE.2) THEN
@@ -2655,12 +2757,17 @@ C
        IF (ICNTL(15).EQ.0) THEN
           ITMP = 0
        ENDIF
+       IF (KEEP(400).GT.0) THEN 
+          ICNTL48_EFF=1
+       ELSE
+          ICNTL48_EFF=0
+       ENDIF
        WRITE(MPG, 99992) INFO(1), INFO(2),
      &  KEEP8(109), KEEP8(111), INFOG(4),
      &  INFOG(5), KEEP(28), INFOG(32), INFOG(7), KEEP(23), 
-     &  ICNTL(7), ICNTL(13), KEEP(12), 
+     &  ICNTL(7), KEEP(95), ICNTL(13), KEEP(12), 
      &  ITMP,
-     &  ICNTL(18),
+     &  ICNTL(18), KEEP(252), KEEP(494), ICNTL48_EFF,
      &  KEEP(106),
      &  KEEP(56), KEEP(61), RINFOG(1)
        IF (KEEP(95).GT.1)             
@@ -2683,10 +2790,14 @@ C
      &       ' --  (7) Ordering option effectively used       =',I16/
      &       ' ICNTL (6) Maximum transversal option           =',I16/
      &       ' ICNTL (7) Pivot order option                   =',I16/
+     &       ' ICNTL(12) Ordering symmetric indef. matrices   =',I16/
      &       ' ICNTL(13) Parallelism/splitting of root node   =',I16/
      &       ' ICNTL(14) Percentage of memory relaxation      =',I16/
      &       ' ICNTL(15) Analysis by block effectively used   =',I16/
      &       ' ICNTL(18) Distributed input matrix (on if >0)  =',I16/
+     &       ' ICNTL(32) Forward elimination during facto.    =',I16/
+     &       ' ICNTL(35) BLR activation                       =',I16/
+     &       ' ICNTL(48) Tree based multithreading (effective)=',I16/
      &       ' ICNTL(58) Symbolic factorization option        =',I16/
      &       ' Number of level 2 nodes                        =',I16/
      &       ' Number of split nodes                          =',I16/
@@ -3004,6 +3115,138 @@ C
       ENDIF
       RETURN
       END SUBROUTINE ZMUMPS_SPLIT_1NODE
+      SUBROUTINE ZMUMPS_SPLIT_ROOT
+     & ( NSLAVES, HOW, INODE, N, FRERE, FILS, NFSIZ, KEEP, KEEP8,
+     &   SIZEOFBLOCKS, LSIZEOFBLOCKS, NSTEPS)
+      IMPLICIT NONE
+      INTEGER, INTENT(in)    :: NSLAVES, HOW
+      INTEGER, INTENT(in)    :: INODE, N
+      INTEGER(8), INTENT(in) :: KEEP8(150)
+      INTEGER, INTENT(inout) :: NSTEPS
+      INTEGER, INTENT(inout) :: KEEP(500)
+      INTEGER, INTENT(inout) :: FRERE( N ), FILS( N ), NFSIZ( N )
+      INTEGER, INTENT(IN)    :: LSIZEOFBLOCKS
+      INTEGER, INTENT(IN)    :: SIZEOFBLOCKS(LSIZEOFBLOCKS)
+      LOGICAL    :: BLKON
+      INTEGER(8) :: K79
+      INTEGER I, IN, NPIV, NFRONT
+      INTEGER INODE_SON, INODE_FATH, IN_SON, IN_FATH, IN_GRANDFATH
+      INTEGER NPIV_COMPG, NPIV_SON_COMPG, NPIV_FATH_COMPG
+      INTEGER NPIV_SON, NPIV_FATH, NPIV_TEMP
+      INTEGER, PARAMETER :: K_HOW1 = 4000
+      IF (FRERE(INODE).NE.0) RETURN
+      BLKON = .NOT.(SIZEOFBLOCKS(1).EQ.-1) 
+      K79 = max(KEEP8(79), 4_8)
+      K79 = min(20000_8*20000_8,K79) 
+      IF (KEEP(72).EQ.1) THEN
+          K79 = min(3_8*3_8,K79)
+      ENDIF
+      IF ((HOW.LT.1) .OR. (HOW.GT.3)) THEN
+       RETURN 
+      ENDIF
+      IF (HOW.EQ.2) THEN
+       K79 = min(K79, 121_8*121_8)
+      ENDIF
+      NFRONT = NFSIZ (INODE)
+      NPIV = NFRONT
+      IF (NPIV .LE. 1 ) RETURN
+      IF (BLKON) THEN
+       IN = INODE
+       NPIV_COMPG = 0 
+       DO WHILE( IN > 0 )
+         NPIV_COMPG = NPIV_COMPG + 1
+         IN = FILS( IN )
+       ENDDO
+      ELSE 
+        NPIV_COMPG = NPIV
+      ENDIF
+      IF (HOW.EQ.1) THEN
+        IF ( (NFRONT/2) .LT. K_HOW1 ) RETURN
+        NPIV_FATH = max(NFRONT/max(NSLAVES,2), 1)
+        NPIV_FATH = max(NPIV_FATH, K_HOW1/2)
+        NPIV_FATH = min(NPIV_FATH, max(NFRONT/2,1))
+        NPIV_FATH = min(int(sqrt(dble(K79))), NPIV_FATH)
+        NPIV_SON  = NPIV - NPIV_FATH
+      ELSE IF (HOW.EQ.2) THEN
+        NPIV_FATH = min(int(sqrt(dble(K79))), int(NPIV/2))
+        NPIV_SON  = NPIV - NPIV_FATH
+      ELSE  
+        NPIV_FATH = max(NFRONT - 3*KEEP(6),1) 
+        NPIV_SON  = NPIV - NPIV_FATH
+      ENDIF
+       INODE_SON = INODE
+       IF (BLKON) THEN
+         NPIV_TEMP       = 0
+         NPIV_SON_COMPG  = 0
+         IN_SON = INODE
+         DO WHILE (IN_SON > 0) 
+           NPIV_TEMP = NPIV_TEMP + SIZEOFBLOCKS(IN_SON)
+           NPIV_SON_COMPG  = NPIV_SON_COMPG +1
+           IF (NPIV_TEMP.GE.NPIV_SON) EXIT
+           IN_SON = FILS( IN_SON )
+         END DO
+         NPIV_FATH_COMPG = NPIV_COMPG - NPIV_SON_COMPG
+         NPIV_SON        = NPIV_TEMP
+         NPIV_FATH       = NPIV - NPIV_SON 
+       ELSE
+         NPIV_SON_COMPG  = NPIV_SON
+         NPIV_FATH_COMPG = NPIV_FATH
+         IN_SON = INODE
+         DO I = 1, NPIV_SON_COMPG - 1
+           IN_SON = FILS( IN_SON )
+         END DO
+       ENDIF
+       IF (NPIV_FATH_COMPG.EQ.0)  RETURN
+       INODE_FATH = FILS( IN_SON )
+       IF ( INODE_FATH .LT. 0 ) THEN
+       write(*,*) 'Error: INODE_FATH < 0 ', INODE_FATH
+       END IF
+       IN_FATH = INODE_FATH
+       DO WHILE ( FILS( IN_FATH ) > 0 )
+         IN_FATH = FILS( IN_FATH )
+       END DO
+       FRERE( INODE_FATH ) = FRERE( INODE_SON )
+       FRERE( INODE_SON  ) = - INODE_FATH
+       FILS ( IN_SON     ) = FILS( IN_FATH )
+       FILS ( IN_FATH    ) = - INODE_SON
+       IN = FRERE( INODE_FATH )
+       DO WHILE ( IN > 0 )
+           IN = FRERE( IN )
+       END DO
+       IF ( IN .eq. 0 )  GO TO 10
+       IN = -IN
+       DO WHILE ( FILS( IN ) > 0 )
+           IN = FILS( IN )
+       END DO
+       IN_GRANDFATH = IN
+       IF ( FILS( IN_GRANDFATH ) .eq. - INODE_SON ) THEN
+           FILS( IN_GRANDFATH ) = -INODE_FATH
+       ELSE
+           IN = IN_GRANDFATH
+           IN = - FILS ( IN )
+           DO WHILE ( FRERE( IN ) > 0 )
+             IF ( FRERE( IN ) .eq. INODE_SON ) THEN
+               FRERE( IN ) = INODE_FATH
+               GOTO 10
+             END IF
+             IN = FRERE( IN )
+           END DO
+           WRITE(*,*) 'ERROR 2 in SPLIT NODE',
+     &          IN_GRANDFATH, IN, FRERE(IN)
+       END IF
+ 10    CONTINUE
+       NFSIZ(INODE_SON) = NFRONT
+       NFSIZ(INODE_FATH) = NFRONT - NPIV_SON
+       KEEP(2) = max( KEEP(2), NFRONT - NPIV_SON )
+       NSTEPS  = NSTEPS + 1
+       IF ( (KEEP(53).EQ.0) .AND. NSLAVES.GT.1) THEN
+         KEEP(38) = INODE_FATH
+       ENDIF
+       IF ( KEEP(53).NE.0 ) THEN
+         KEEP(20) = INODE_FATH
+       ENDIF
+      RETURN
+      END SUBROUTINE ZMUMPS_SPLIT_ROOT
       SUBROUTINE ZMUMPS_ANA_GNEW
      & (N, NZ, IRN, ICN, IW, LW, IPE, LEN,
      & IQ, FLAG, IWFR,
@@ -3415,7 +3658,7 @@ C
      &         ZMUMPS_MTRANSS,ZMUMPS_MTRANSW
       INTRINSIC abs,log
       RINF = CNTL(2)
-      RINF2 = huge(RINF2)/dble(2*N)
+      RINF2 = huge(RINF2)/dble(int(2,8)*int(N,8))
       RINF3 = 0.0D0
       WARN1 = 0
       WARN2 = 0
@@ -3444,12 +3687,12 @@ C
          IF (ICNTL(1).GE.0) WRITE(ICNTL(1),9001) INFO(1),'NE',NE
          GO TO 99
       ENDIF
-      IF (JOB.EQ.1) K = int(4*N +   M,8)
-      IF (JOB.EQ.2) K = int(N + 2*M,8)
-      IF (JOB.EQ.3) K = int(8*N + 2*M + NE,8)
-      IF (JOB.EQ.4) K = int(N + M,8)
-      IF (JOB.EQ.5) K = int(3*N + 2*M,8)
-      IF (JOB.EQ.6) K = int(3*N + 2*M + NE,8)
+      IF (JOB.EQ.1) K = 4_8*int(N,8)+int(M,8)
+      IF (JOB.EQ.2) K = int(N,8) + 2_8*int(M,8)
+      IF (JOB.EQ.3) K = 8_8*int(N,8) + 2*int(M,8) + NE
+      IF (JOB.EQ.4) K = int(N,8) + int(M,8)
+      IF (JOB.EQ.5) K = 3_8*int(N,8) + 2_8*int(M,8)
+      IF (JOB.EQ.6) K = 3_8*int(N,8) + 2_8*int(M,8) + NE
       IF (LIW.LT.K) THEN
          INFO(1) = -4
          CALL MUMPS_SET_IERROR(K,INFO(2))
@@ -3457,11 +3700,11 @@ C
          GO TO 99
       ENDIF
       IF (JOB.GT.1) THEN
-         IF (JOB.EQ.2) K = int(      M,8)
+         IF (JOB.EQ.2) K = int(M,8)
          IF (JOB.EQ.3) K = int(1,8)
-         IF (JOB.EQ.4) K = int(    2*M,8)
-         IF (JOB.EQ.5) K = int(N + 2*M,8)
-         IF (JOB.EQ.6) K = int(N + 3*M,8)
+         IF (JOB.EQ.4) K = 2_8*int(M,8)
+         IF (JOB.EQ.5) K = int(N,8) + 2_8*int(M,8)
+         IF (JOB.EQ.6) K = int(N,8) + 3_8*int(M,8)
          IF (LDW .LT. K) THEN
             INFO(1) = -5
             CALL MUMPS_SET_IERROR(K,INFO(2))
@@ -3518,13 +3761,18 @@ C
             IW(J) = int(IP(J+1) - IP(J))
  10      CONTINUE
          CALL ZMUMPS_MTRANSZ(M,N,IRN,NE,IP,IW(1),PERM,NUM,
-     &        IW(N+1),IW(2*N+1),IW(3*N+1),IW(3*N+M+1))
+     &        IW(    int(N,8)+1_8),
+     &        IW(2_8*int(N,8)+1_8),
+     &        IW(3_8*int(N,8)+1_8),
+     &        IW(3_8*int(N,8)+int(M,8)+1_8))
          GO TO 90
       ENDIF
       IF (JOB.EQ.2) THEN
          DW(1) = max(ZERO,CNTL(1))
          CALL ZMUMPS_MTRANSB(M,N,NE,IP,IRN,A,PERM,NUM,
-     &        IW(1),IPQ8,IW(N+1),IW(N+M+1),DW,RINF2)
+     &        IW(1),IPQ8,IW(int(N,8)+1_8),
+     &        IW(int(N,8)+int(M,8)+1_8),
+     &        DW,RINF2)
          GO TO 90
       ENDIF
       IF (JOB.EQ.3) THEN
@@ -3533,16 +3781,21 @@ C
  20      CONTINUE
          CALL ZMUMPS_MTRANSR(N,NE,IP,IW,A)
          FACT = max(ZERO,CNTL(1))
-         CALL ZMUMPS_MTRANSS(M,N,NE,IP,IW(1),A,PERM,NUM,IW(NE+1),
-     &        IW(NE+N+1),IW(NE+2*N+1),IW(NE+3*N+1),IW(NE+4*N+1),
-     &        IW(NE+5*N+1),IW(NE+5*N+M+1),FACT,RINF2)
+         CALL ZMUMPS_MTRANSS(M,N,NE,IP,IW(1),A,PERM,NUM,IW(NE+1_8),
+     &        IW(NE+int(N,8)+1_8),IW(NE+2_8*int(N,8)+1_8),
+     &        IW(NE+3_8*int(N,8)+1_8),
+     &        IW(NE+4_8*int(N,8)+1_8),
+     &        IW(NE+5_8*int(N,8)+1_8),
+     &        IW(NE+5_8*int(N,8)+int(M,8)+1_8),
+     &        FACT,RINF2)
          GO TO 90
       ENDIF
       IF ((JOB.EQ.4).OR.(JOB.EQ.5).or.(JOB.EQ.6)) THEN
-           ALLOCATE(IWtemp8(M+N+N), stat=allocok)
+           ALLOCATE(IWtemp8(int(M,8)+int(N,8)+int(N,8)), stat=allocok)
            IF (allocok.GT.0) THEN
              INFOMUMPS(1) = -7
-             INFOMUMPS(2) = M+N+N
+             CALL MUMPS_SET_IERROR( int(M,8)+int(N,8)+int(N,8),
+     &                               INFOMUMPS(2) )
              GOTO 90
            ENDIF
       ENDIF
@@ -3561,9 +3814,10 @@ C
          DW(2)      = RINF3
          IWtemp8(1) = int(JOB,8)
          CALL ZMUMPS_MTRANSW(M,N,NE,IP,IRN,A,PERM,NUM,
-     &        IWtemp8(1),IW(1),IWtemp8(N+1),IPQ8,IW(N+1),
-     &        IWtemp8(2*N+1),
-     &        DW(1),DW(M+1),RINF2)
+     &        IWtemp8(1),IW(1),IWtemp8(int(N,8)+1_8),IPQ8,
+     &        IW(int(N,8)+1_8),
+     &        IWtemp8(2_8*int(N,8)+1_8),
+     &        DW(1),DW(int(M,8)+1_8),RINF2)
          DEALLOCATE(IWtemp8)  
          GO TO 90
       ENDIF
@@ -3575,7 +3829,7 @@ C
                DO 60 K = IP(J),IP(J+1)-1_8
                   IF (A(K).GT.FACT) FACT = A(K)
  60            CONTINUE
-               DW(2*M+J) = FACT
+               DW(2_8*int(M,8)+int(J,8)) = FACT
                IF (FACT.NE.ZERO) THEN
                   FACT = log(FACT)
                   IF(FACT .GT. RINF3) RINF3=FACT
@@ -3596,38 +3850,40 @@ C
          ENDIF
          IF (JOB.EQ.6) THEN
             DO 175 K = 1,NE
-               IW(3*N+2*M+K) = IRN(K)
+               IW(3_8*int(N,8)+2_8*int(M,8)+int(K,8)) = IRN(K)
  175        CONTINUE
             DO 61 I = 1,M
-               DW(2*M+N+I) = ZERO
+               DW(2_8*int(M,8)+int(N,8)+int(I,8)) = ZERO
  61         CONTINUE
             DO 63 J = 1,N
                DO 62 K = IP(J),IP(J+1)-1_8
                   I = IRN(K)
-                  IF (A(K).GT.DW(2*M+N+I)) THEN
-                     DW(2*M+N+I) = A(K)
+                  IF (A(K).GT.DW(2_8*int(M,8)+int(N,8)+int(I,8))) THEN
+                     DW(2_8*int(M,8)+int(N,8)+int(I,8)) = A(K)
                   ENDIF
  62            CONTINUE
  63         CONTINUE
             DO 64 I = 1,M
-               IF (DW(2*M+N+I).NE.ZERO) THEN
-                  DW(2*M+N+I) = 1.0D0/DW(2*M+N+I)
+               IF (DW(2_8*int(M,8)+int(N,8)+int(I,8)).NE.ZERO) THEN
+                   DW(2_8*int(M,8)+int(N,8)+int(I,8)) =
+     &                      1.0D0/DW(2_8*int(M,8)+int(N,8)+int(I,8))
                ENDIF
  64         CONTINUE
             DO 66 J = 1,N
                DO 65 K = IP(J),IP(J+1)-1
                   I = IRN(K)
-                  A(K) = DW(2*M+N+I) * A(K)
+                  A(K) = DW(2_8*int(M,8)+int(N,8)+int(I,8)) * A(K)
  65            CONTINUE
  66         CONTINUE
-            CALL ZMUMPS_MTRANSR(N,NE,IP,IW(3*N+2*M+1),A)
+            CALL ZMUMPS_MTRANSR(N,NE,IP,
+     &           IW(3_8*int(N,8)+2_8*int(M,8)+1_8),A)
             DO 176 J = 1,N
                IF (IP(J).NE.IP(J+1)) THEN
                   FACT = A(IP(J))
                ELSE
                   FACT = ZERO
                ENDIF
-               DW(2*M+J) = FACT
+               DW(2_8*int(M,8)+int(J,8)) = FACT
                IF (FACT.NE.ZERO) THEN
                   FACT = log(FACT)
                   DO 170 K = IP(J),IP(J+1)-1_8
@@ -3651,34 +3907,38 @@ C
          IWtemp8(1) = int(JOB,8)
           IF (JOB.EQ.5) THEN
          CALL ZMUMPS_MTRANSW(M,N,NE,IP,IRN,A,PERM,NUM,
-     &        IWtemp8(1),IW(1),IWtemp8(N+1),IPQ8,IW(N+1),
-     &        IWtemp8(2*N+1),
-     &        DW(1),DW(M+1),RINF2)
+     &        IWtemp8(1),IW(1),IWtemp8(int(N,8)+1_8),IPQ8,
+     &        IW(int(N,8)+1_8),
+     &        IWtemp8(2_8*int(N,8)+1_8),
+     &        DW(1),DW(int(M,8)+1_8),RINF2)
          ENDIF
          IF (JOB.EQ.6) THEN
-         CALL ZMUMPS_MTRANSW(M,N,NE,IP,IW(3*N+2*M+1),A,PERM,NUM,
-     &        IWtemp8(1),IW(1),IWtemp8(N+1),IPQ8,IW(N+1),
-     &        IWtemp8(2*N+1),
-     &        DW(1),DW(M+1),RINF2)
+         CALL ZMUMPS_MTRANSW(M,N,NE,IP,
+     &        IW(3_8*int(N,8)+2_8*int(M,8)+1_8),A,PERM,NUM,
+     &        IWtemp8(1),IW(1),IWtemp8(int(N,8)+1_8),IPQ8,
+     &        IW(int(N,8)+1_8),
+     &        IWtemp8(2_8*int(N,8)+1_8),
+     &        DW(1),DW(int(M,8)+1_8),RINF2)
          ENDIF
          IF ((JOB.EQ.5).or.(JOB.EQ.6)) THEN
           DEALLOCATE(IWtemp8)
          ENDIF
          IF (JOB.EQ.6) THEN
-            DO 79 I = 1,M
-               IF (DW(2*M+N+I).NE.0.0D0) THEN
-                  DW(I) = DW(I) + log(DW(2*M+N+I))
-               ENDIF
- 79         CONTINUE
+           DO 79 I = 1,M
+             IF (DW(2_8*int(M,8)+int(N,8)+int(I,8)).NE.0.0D0) THEN
+               DW(I) = DW(I) + log(DW(2_8*int(M,8)+int(N,8)+int(I,8)))
+             ENDIF
+ 79        CONTINUE
          ENDIF
          IF (NUM.EQ.N) THEN
-            DO 80 J = 1,N
-               IF (DW(2*M+J).NE.ZERO) THEN
-                  DW(M+J) = DW(M+J) - log(DW(2*M+J))
-               ELSE
-                  DW(M+J) = ZERO
-               ENDIF
- 80         CONTINUE
+           DO 80 J = 1,N
+             IF (DW(2_8*int(M,8)+int(J,8)).NE.ZERO) THEN
+               DW(int(M,8)+int(J,8)) = DW(int(M,8)+int(J,8)) -
+     &                                 log(DW(2_8*int(M,8)+int(J,8)))
+             ELSE
+               DW(int(M,8)+int(J,8)) = ZERO
+             ENDIF
+ 80        CONTINUE
          ENDIF
          FACT = 0.5D0*log(RINF2)
          DO 86 I = 1,M
@@ -3714,13 +3974,15 @@ C
                WRITE(ICNTL(3),9032) (PERM(J),J=1,min(10,M))
                IF (JOB.EQ.5 .OR. JOB.EQ.6) THEN
                   WRITE(ICNTL(3),9033) (DW(J),J=1,min(10,M))
-                  WRITE(ICNTL(3),9034) (DW(M+J),J=1,min(10,N))
+                  WRITE(ICNTL(3),9034) (DW(int(M,8)+int(J,8)),
+     &                                  J=1,min(10,N))
                ENDIF
             ELSEIF (ICNTL(4).EQ.1) THEN
                WRITE(ICNTL(3),9032) (PERM(J),J=1,M)
                IF (JOB.EQ.5 .OR. JOB.EQ.6) THEN
                   WRITE(ICNTL(3),9033) (DW(J),J=1,M)
-                  WRITE(ICNTL(3),9034) (DW(M+J),J=1,N)
+                  WRITE(ICNTL(3),9034) (DW(int(M,8)+int(J,8)),
+     &                                  J=1,N)
                ENDIF
             ENDIF
          ENDIF
@@ -4003,6 +4265,7 @@ C
       DOUBLE PRECISION PEAK
       INTEGER, intent(IN) :: LSIZEOFBLOCKS
       INTEGER, intent(IN) :: SIZEOFBLOCKS(LSIZEOFBLOCKS)
+      CALL MUMPS_SET_K78_83_91 (NSLAVES,KEEP(78),KEEP(83),KEEP(91))
       CALL MUMPS_DISTRIBUTE(N,NSLAVES,
      &     ICNTL,INFOG, NE, NFSIZ,
      &     FRERE, FILS,
diff -pruN 5.6.2-2.1/src/zana_aux_ELT.F 5.7.1-1/src/zana_aux_ELT.F
--- 5.6.2-2.1/src/zana_aux_ELT.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/zana_aux_ELT.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -24,7 +24,8 @@ C
      &            )
       USE MUMPS_ANA_ORD_WRAPPERS
       IMPLICIT NONE
-      INTEGER, INTENT(IN)    :: N,  NELT, SIZE_SCHUR, NSLAVES, LIW
+      INTEGER, INTENT(IN)    :: N,  NELT, SIZE_SCHUR, NSLAVES
+      INTEGER(8), INTENT(IN) :: LIW
       INTEGER, INTENT(IN)    :: ELTPTR(NELT+1) 
       INTEGER, INTENT(IN)    :: ELTVAR(ELTPTR(NELT+1)-1)
       INTEGER, INTENT(IN)    :: LISTVAR_SCHUR(SIZE_SCHUR)
@@ -38,7 +39,8 @@ C
 #if defined(metis) || defined(parmetis) || defined(metis4) || defined(parmetis3)      
       INTEGER, INTENT(IN)    :: METIS_OPTIONS(40)
 #endif
-      INTEGER K,I,L1,L2,NCMPA,IFSON,IN
+      INTEGER K,I,NCMPA,IFSON,IN
+      INTEGER(8) :: L1, L2
       INTEGER NEMIN, MPRINT, LP, MP, LDIAG
       INTEGER(8)  :: NZ8, LLIW8, IWFR8
       INTEGER allocok, ITEMP
@@ -46,6 +48,8 @@ C
       INTEGER(8) :: K79REF
       PARAMETER(K79REF=12000000_8)
       LOGICAL SPLITROOT
+      INTEGER HOW_TO_SPLIT_ROOT, INODE_Scalapack_CAND, 
+     &        NBSONS_Scalapack_CAND
       INTEGER, PARAMETER :: LIDUMMY = 1
       INTEGER :: IDUMMY(1) 
       INTEGER, DIMENSION(:), ALLOCATABLE :: IW
@@ -73,7 +77,7 @@ C
         ALLOCATE( IW ( LIW ), stat = allocok )
         IF ( allocok .GT. 0 ) THEN
           INFO( 1 ) = -7
-          INFO( 2 ) = LIW
+          CALL MUMPS_SET_IERROR(LIW, INFO( 2 ))
           GOTO 90 
         ENDIF
         ALLOCATE( IPE8 ( N + 1 ), stat = allocok )
@@ -85,7 +89,7 @@ C
         ALLOCATE( PARENT(N), IWtemp ( N, 3 ), stat = allocok )
         IF ( allocok .GT. 0 ) THEN
           INFO( 1 ) = -7
-          INFO( 2 ) = 4*N
+          CALL MUMPS_SET_IERROR(4_8*int(N,8), INFO( 2 ))
           GOTO 90 
         ENDIF
       MPRINT= ICNTL(3)
@@ -118,42 +122,42 @@ C
       NEMIN = KEEP(1)
       IF (LDIAG.LE.2 .OR. MP.LE.0) GO TO 10
       WRITE (MP,99999) N, NELT, LIW, INFO(1)
-      K = min0(10,NELT+1)
+      K = min(10,NELT+1)
       IF (LDIAG.EQ.4) K = NELT+1
       IF (K.GT.0) WRITE (MP,99998) (ELTPTR(I),I=1,K)
-      K = min0(10,ELTPTR(NELT+1)-1)
+      K = min(10,ELTPTR(NELT+1)-1)
       IF (LDIAG.EQ.4) K = ELTPTR(NELT+1)-1
       IF (K.GT.0) WRITE (MP,99995) (ELTVAR(I),I=1,K)
-      K = min0(10,N)
+      K = min(10,N)
       IF (LDIAG.EQ.4) K = N
       IF (IORD.EQ.1 .AND. K.GT.0) THEN
         WRITE (MP,99997) (IKEEP(I,1),I=1,K)
       ENDIF
-   10 L1 = 1
-      L2 = L1 + N
-      IF (LIW .LT. 3*N) THEN
+   10 L1 = 1_8
+      L2 = L1 + int(N,8)
+      IF (LIW .LT. 3_8*int(N,8)) THEN
           INFO(1) = -2002
-          INFO(2) = LIW
+          CALL MUMPS_SET_IERROR( LIW, INFO(2) )
       ENDIF
 #if defined(metis) || defined(parmetis) || defined(metis4) || defined(parmetis3)
       IF ( IORD == 5 ) THEN
-        IF (LIW .LT. N+N+1) THEN
+        IF (LIW .LT. int(N,8)+int(N,8)+1_8) THEN
           INFO(1)= -2002
-          INFO(2) = LIW
+          CALL MUMPS_SET_IERROR( LIW, INFO(2) )
           GOTO 90 
         ENDIF
       ELSE
 #endif
       IF (NOSUPERVAR) THEN
-        IF ( LIW .LT. 2*N ) THEN
+        IF ( LIW .LT. 2_8*int(N,8) ) THEN
           INFO(1)= -2002
-          INFO(2) = LIW
+          CALL MUMPS_SET_IERROR( LIW, INFO(2) )
           GOTO 90 
         END IF
       ELSE
-        IF ( LIW .LT.  4*N+4 ) THEN
+        IF ( LIW .LT.  4_8*int(N,8)+4_8 ) THEN
           INFO(1)= -2002
-          INFO(2) = LIW
+          CALL MUMPS_SET_IERROR( LIW, INFO(2) )
           GOTO 90 
         END IF
       ENDIF
@@ -170,9 +174,9 @@ C
      &              ELTPTR, ELTVAR, XNODEL, NODEL,
      &              IWtemp(1,2), IW(L1))
         ELSE
-         CALL ZMUMPS_ANA_G11_ELT(N, NZ8, NELT, ELTPTR(NELT+1)-1, 
+          CALL ZMUMPS_ANA_G11_ELT(N, NZ8, NELT, ELTPTR(NELT+1)-1, 
      &              ELTPTR, ELTVAR, XNODEL, NODEL,
-     &              IWtemp(1,2), 4*N+4, IW(L1))
+     &              IWtemp(1,2), 4_8*int(N,8)+4_8, IW(L1))
         ENDIF
         LLIW8 = max(NZ8,int(N,8))
         ALLOCATE( IW2(LLIW8), stat = allocok )
@@ -288,15 +292,15 @@ C
         ENDIF
 #endif
        DO K=1,N
-         IW(L1+K) = 0
+         IW(L1+int(K,8)) = 0
        ENDDO
        DO K=1,N
          IF ((IKEEP(K,1).LE.0).OR.(IKEEP(K,1).GT.N)) 
      &    GO TO 40
-         IF (IW(L1+IKEEP(K,1)).EQ.1) THEN
+         IF (IW(L1+int(IKEEP(K,1),8)).EQ.1) THEN
           GOTO 40
          ELSE
-          IW(L1+IKEEP(K,1)) = 1
+          IW(L1+int(IKEEP(K,1),8)) = 1
          ENDIF
        ENDDO
        CALL ZMUMPS_ANA_J1_ELT(N, NZ8, NELT, ELTPTR(NELT+1)-1,
@@ -335,9 +339,10 @@ C
      &     NFSIZ, IWtemp(1,2), 
      &     INFO(6), FILS, FRERE, IWtemp(1,3), NEMIN, 
      &     IW(L2),  KEEP(60), KEEP(20), KEEP(38),
-     &     IW2,KEEP(104),IW(L2+N),KEEP(50),
+     &     IW2,KEEP(104),IW(L2+int(N,8)),KEEP(50),
      &     ICNTL(13), KEEP(37), KEEP(197), NSLAVES, KEEP(250).EQ.1,
-     &     .FALSE., IDUMMY, LIDUMMY)
+     &     .FALSE., IDUMMY, LIDUMMY, 
+     &     INODE_Scalapack_CAND, NBSONS_Scalapack_CAND, KEEP(11) )
       DEALLOCATE(IW2)
       IF (KEEP(60).NE.0) THEN
          IF (KEEP(60)==1) THEN
@@ -368,6 +373,8 @@ C
      &  KEEP(6), KEEP(226), KEEP(253))
       IF ( KEEP(53) .NE. 0 ) THEN
         CALL MUMPS_MAKE1ROOT( N, FRERE, FILS, NFSIZ, KEEP(20) )
+        INODE_Scalapack_CAND  = KEEP(20)
+        NBSONS_Scalapack_CAND = 1
       END IF
       IF ( KEEP(48) == 4 .OR.
      &   ( (KEEP(24).NE.0).AND.(KEEP8(21).GT.0_8) ) ) THEN
@@ -379,23 +386,26 @@ C
       IF (KEEP(210).EQ.1.AND.KEEP8(79).LE.0_8) THEN
         KEEP8(79)=K79REF * int(NSLAVES,8)
       ENDIF
-      IF (KEEP(79).EQ.0) THEN
-       IF (KEEP(210).EQ.1) THEN
-        SPLITROOT = .FALSE. 
-        IF ( KEEP(62).GE.1) THEN
-          IDUMMY(1)= -1
-          CALL ZMUMPS_CUTNODES(N, FRERE, FILS, NFSIZ,
-     &                       IDUMMY, LIDUMMY, INFO(6),
-     &                       NSLAVES, KEEP,KEEP8, SPLITROOT,
-     &                       MP, LDIAG, INFO(1), INFO(2))
-          IF (INFO(1).LT.0) GOTO 90 
-          IF (PROK) THEN
-               WRITE(MP,*) " Number of split nodes in pre-splitting=",
-     &         KEEP(61)
+      IF (KEEP(11).EQ.0) THEN
+        IF (KEEP(79).EQ.0) THEN
+         IF (KEEP(210).EQ.1) THEN
+          SPLITROOT = .FALSE. 
+          IF ( KEEP(62).GE.1) THEN
+            IDUMMY(1)= -1
+            CALL ZMUMPS_CUTNODES(N, FRERE, FILS, NFSIZ,
+     &                         IDUMMY, LIDUMMY, INFO(6),
+     &                         NSLAVES, KEEP,KEEP8, SPLITROOT,
+     &                         MP, LDIAG, INFO(1), INFO(2))
+            IF (INFO(1).LT.0) GOTO 90 
+            IF (PROK) THEN
+                 WRITE(MP,*) " Number of split nodes in pre-splitting=",
+     &           KEEP(61)
+            ENDIF
           ENDIF
+         ENDIF
         ENDIF
-       ENDIF
       ENDIF
+      HOW_TO_SPLIT_ROOT = 0 
       SPLITROOT = ICNTL(13) .EQ. -1
 #if defined(NOSCALAPACK)
       SPLITROOT = SPLITROOT .OR. NSLAVES.GT.0
@@ -403,23 +413,50 @@ C
       SPLITROOT = SPLITROOT .OR.
      &            (ICNTL(13).GT.0 .AND. NSLAVES .GT. ICNTL(13))
 #endif
+      HOW_TO_SPLIT_ROOT = 0 
+      IF (SPLITROOT.AND.KEEP(11).GT.0) HOW_TO_SPLIT_ROOT =1 
       IF (KEEP(53) .NE. 0) THEN
-         SPLITROOT = .TRUE.
+         SPLITROOT         = .TRUE.
+         IF (KEEP(11).GT.0) HOW_TO_SPLIT_ROOT = 2
       ENDIF
       SPLITROOT = (SPLITROOT.AND.( (KEEP(60).EQ.0) ))
+#if defined(NOSCALAPACK)
+#else
+      IF ( KEEP(11).GT.0) THEN 
+        IF (.NOT.SPLITROOT .AND. 
+     &    (KEEP(60).EQ.0).AND.   
+     &    ( (NFSIZ(INODE_Scalapack_CAND).GT.KEEP(37))
+     &      .AND.(ICNTL(13).LE.0) )
+     &    .AND.
+     &    (NBSONS_Scalapack_CAND.GT.KEEP(11)) 
+     &    ) THEN
+          HOW_TO_SPLIT_ROOT = 3
+          SPLITROOT=.TRUE.
+        ENDIF
+      ENDIF
+#endif
       IF (SPLITROOT) THEN
-         IDUMMY(1) = -1
-         CALL ZMUMPS_CUTNODES(N, FRERE, FILS, NFSIZ,
-     &                    IDUMMY, LIDUMMY, INFO(6),
-     &                    NSLAVES, KEEP,KEEP8, SPLITROOT,
-     &                    MP, LDIAG, INFO(1), INFO(2))
-         IF (INFO(1).LT.0) GOTO 90 
-         IF ( KEEP(53) .NE. 0 ) THEN
-          CALL MUMPS_MAKE1ROOT( N, FRERE, FILS, NFSIZ, KEEP(20) )
-         ENDIF
+        IDUMMY(1) = -1
+        IF (KEEP(11).EQ.0) THEN
+          CALL ZMUMPS_CUTNODES(N, FRERE(1), FILS(1), NFSIZ(1), 
+     &                     IDUMMY, LIDUMMY, INFO(6),
+     &                     NSLAVES, KEEP,KEEP8, SPLITROOT,
+     &                     MP, LDIAG, INFO(1), INFO(2))
+          IF (INFO(1).LT.0) GOTO 90 
+          IF ( KEEP(53) .NE. 0 ) THEN
+           CALL MUMPS_MAKE1ROOT( N, FRERE(1), FILS(1), NFSIZ(1),
+     &                           KEEP(20) )
+          ENDIF
+        ELSE
+         CALL ZMUMPS_SPLIT_ROOT( NSLAVES,
+     &               HOW_TO_SPLIT_ROOT, INODE_Scalapack_CAND,
+     &               N, FRERE(1), FILS(1), NFSIZ(1), 
+     &               KEEP, KEEP8,
+     &               IDUMMY, LIDUMMY, INFO(6))
+        ENDIF
       ENDIF
       IF (LDIAG.GT.2 .AND. MP.GT.0) THEN
-         K = min0(10,N)
+         K = min(10,N)
          IF (LDIAG.EQ.4) K = N
          IF (K.GT.0) WRITE (MP,99997) (IKEEP(I,1),I=1,K)
          IF (K.GT.0) WRITE (MP,99991) (IKEEP(I,2),I=1,K)
@@ -955,7 +992,8 @@ C
      &  XELNOD, ELNOD, XNODEL, NODEL, 
      &  LEN, LW, IW)
       IMPLICIT NONE
-      INTEGER N,NELT,NELNOD,LW
+      INTEGER N,NELT,NELNOD
+      INTEGER(8) :: LW
       INTEGER(8), INTENT(OUT) :: NZ
       INTEGER XELNOD(NELT+1), ELNOD(NELNOD)
       INTEGER LEN(N)
@@ -966,7 +1004,8 @@ C
       EXTERNAL ZMUMPS_SUPVAR
       LP = 6
       CALL ZMUMPS_SUPVAR(N,NELT,XELNOD(NELT+1)-1,ELNOD,XELNOD,
-     &           NSUP,IW(3*N+3+1),3*N+3,IW,LP,INFO44)
+     &           NSUP,IW(3_8*int(N,8)+3_8+1_8),
+     &           3_8*int(N,8)+3_8,IW,LP,INFO44)
       IF (INFO44(1) .LT. 0) THEN
         IF (LP.GE.0) WRITE(LP,*) 
      &     'Error return from ZMUMPS_SUPVAR. INFO(1) = ',INFO44(1) 
@@ -974,7 +1013,7 @@ C
       IW(1:NSUP) = 0
       LEN(1:N) = 0
       DO I = 1,N
-        SUPVAR = IW(3*N+3+1+I)
+        SUPVAR = IW(3_8*int(N,8)+3_8+1_8+int(I,8))
         IF (SUPVAR .EQ. 0) CYCLE
         IF (IW(SUPVAR).NE.0) THEN
           LEN(I) = -IW(SUPVAR)
@@ -982,7 +1021,7 @@ C
           IW(SUPVAR) = I
         ENDIF
       ENDDO
-      IW(N+1:2*N) = 0
+      IW(int(N+1,8):2_8*int(N,8)) = 0
       NZ = 0_8
       DO SUPVAR = 1,NSUP
         I = IW(SUPVAR)
@@ -992,8 +1031,8 @@ C
             J = ELNOD(K3)
             IF ((J.GE.1) .AND. (J.LE.N)) THEN
               IF (LEN(J).GE.0) THEN
-                IF ((I.NE.J) .AND. (IW(N+J).NE.I)) THEN
-                  IW(N+J) = I
+                IF ((I.NE.J) .AND. (IW(int(N,8)+int(J,8)).NE.I)) THEN
+                  IW(int(N,8)+int(J,8)) = I
                   LEN(I) = LEN(I) + 1
                 ENDIF
               ENDIF
@@ -1049,12 +1088,12 @@ C
       END SUBROUTINE ZMUMPS_ANA_G12_ELT
       SUBROUTINE ZMUMPS_SUPVAR(N,NELT,NZ,ELTVAR,ELTPTR,NSUP,SVAR,
      &                 LIW,IW,LP,INFO)
-      INTEGER LIW,LP,N,NELT,NSUP,NZ
+      INTEGER LP,N,NELT,NSUP,NZ
+      INTEGER(8)::LIW
       INTEGER INFO(6)
       INTEGER ELTPTR(NELT+1),ELTVAR(NZ)
       INTEGER IW(LIW),SVAR(0:N)
-      INTEGER FLAG,NEW,VARS
-      EXTERNAL ZMUMPS_SUPVARB
+      INTEGER(8) :: FLAG,NEW,VARS
       INFO(1) = 0
       INFO(2) = 0
       INFO(3) = 0
@@ -1063,19 +1102,20 @@ C
       IF (NELT.LT.1) GO TO 20
       IF (NZ.LT.ELTPTR(NELT+1)-1) GO TO 30
       IF (LIW.LT.6) THEN
-         INFO(4) = 3*N + 3
+         INFO(4) = N + 1
          GO TO 40
       END IF
-      NEW = 1
-      VARS = NEW + LIW/3
-      FLAG = VARS + LIW/3
-      CALL ZMUMPS_SUPVARB(N,NELT,ELTPTR,NZ,ELTVAR,SVAR,NSUP,LIW/3-1,
+      NEW = 1_8
+      VARS = NEW + LIW/3_8
+      FLAG = VARS + LIW/3_8
+      CALL ZMUMPS_SUPVARB(N,NELT,ELTPTR,NZ,ELTVAR,SVAR,NSUP,
+     &           int(min(int(huge(NSUP)-1,8),LIW/3_8-1_8)),
      &           IW(NEW),IW(VARS),IW(FLAG),INFO)
       IF (INFO(1).EQ.-4) THEN
-         INFO(4) = 3*N + 3
+         INFO(4) = N + 1
          GO TO 40
       ELSE
-         INFO(4) = 3*NSUP + 3
+         INFO(4) = NSUP + 1
       END IF
       GO TO 50
    10 INFO(1) = -1
@@ -1090,12 +1130,12 @@ C
    40 INFO(1) = -4
       IF (LP.GT.0) THEN
          WRITE (LP,FMT=9000) INFO(1)
-         WRITE (LP,FMT=9010) INFO(4)
+         WRITE (LP,FMT=9010) 3_8*int(INFO(4),8)
       END IF
    50 RETURN
  9000 FORMAT (/3X,'Error message from ZMUMPS_SUPVAR: INFO(1) = ',I2)
  9010 FORMAT (3X,'LIW is insufficient. Upper bound on required work',
-     &       'space is ',I8)
+     &       'space is ',I12)
       END SUBROUTINE ZMUMPS_SUPVAR
       SUBROUTINE ZMUMPS_SUPVARB( N, NELT, ELTPTR, NZ, ELTVAR,
      &           SVAR, NSUP, MAXSUP, NEW, VARS, FLAG, INFO )
diff -pruN 5.6.2-2.1/src/zana_aux_par.F 5.7.1-1/src/zana_aux_par.F
--- 5.6.2-2.1/src/zana_aux_par.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zana_aux_par.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -53,19 +53,25 @@ C
       LOGICAL    :: PROK, PROKG, LPOK
       INTEGER N, NORIG
       CONTAINS
-      SUBROUTINE ZMUMPS_ANA_F_PAR(id, WORK1, WORK2, NFSIZ, FILS,
+      SUBROUTINE ZMUMPS_ANA_F_PAR(id, WORK1, WORK2, LWORK1, LWORK2,
+     &     NFSIZ, FILS,
      &     FRERE, COMM_PARASYMB, LUMAT, SIZEOFBLOCKS, 
      &     COMM_PARAORD, NPROCS_PARAORD, 
      &     RKinSYMB_PROC0ORD)
       USE ZMUMPS_STRUC_DEF
       IMPLICIT NONE
       TYPE(ZMUMPS_STRUC)   :: id
-      INTEGER, TARGET     :: WORK1(:), WORK2(:)
-      INTEGER, ALLOCATABLE :: FILS(:)
-      INTEGER, POINTER    :: NFSIZ(:), FRERE(:)
-      INTEGER, INTENT(IN) :: COMM_PARASYMB
+      INTEGER, TARGET        :: WORK1(:), WORK2(:)
+      INTEGER(8), INTENT(IN) :: LWORK1, LWORK2
+#if defined(MUMPS_NOF2003)
+      INTEGER, POINTER       :: FILS(:)
+#else
+      INTEGER, ALLOCATABLE   :: FILS(:)
+#endif
+      INTEGER, POINTER       :: NFSIZ(:), FRERE(:)
+      INTEGER, INTENT(IN)    :: COMM_PARASYMB
       TYPE(LMATRIX_T), OPTIONAL       :: LUMAT
-      INTEGER, INTENT(IN), OPTIONAL   :: SIZEOFBLOCKS(id%NBLK)
+      INTEGER, INTENT(IN), TARGET, OPTIONAL   :: SIZEOFBLOCKS(id%NBLK)
       INTEGER, INTENT(IN), OPTIONAL   :: COMM_PARAORD, 
      &                                   NPROCS_PARAORD, 
      &                                   RKinSYMB_PROC0ORD
@@ -78,9 +84,13 @@ C
       INTEGER              :: MYID, NPROCS, IERR, NEMIN, LDIAG
       LOGICAL              :: SPLITROOT
       INTEGER(8), PARAMETER :: K79REF=12000000_8
-      INTEGER, PARAMETER :: LIDUMMY = 1
-      INTEGER :: IDUMMY(1) 
       DOUBLE PRECISION      :: TIMEB
+      INTEGER HOW_TO_SPLIT_ROOT, INODE_Scalapack_CAND, 
+     &        NBSONS_Scalapack_CAND
+      INTEGER, POINTER, DIMENSION(:) :: SIZEOFBLOCKS_PTR
+      INTEGER, TARGET    :: IDUMMY_ARRAY(1)
+      INTEGER            :: LSIZEOFBLOCKS_PTR
+      LOGICAL            :: SIZEOFBLOCKS_AVAIL
       nullify(IPE, NV, NE, NA, NODE, ND, SUBORD, NAMALG, IPS,
      &     CUMUL, SAVEIRN, SAVEJCN)
       CALL MPI_COMM_RANK (COMM_PARASYMB, MYID, IERR)
@@ -99,6 +109,16 @@ C
       PROKG = (MPG.GT.0) .AND. (MYID .EQ. 0)
       LPOK  = (LP.GT.0) .AND. (id%ICNTL(4).GE.1)
       LDIAG = id%ICNTL(4)
+      IF (present(SIZEOFBLOCKS)) THEN
+       SIZEOFBLOCKS_PTR => SIZEOFBLOCKS(1:N)
+       LSIZEOFBLOCKS_PTR = N
+       SIZEOFBLOCKS_AVAIL = .TRUE.
+      ELSE
+       SIZEOFBLOCKS_PTR => IDUMMY_ARRAY
+       SIZEOFBLOCKS_AVAIL = .FALSE.
+       LSIZEOFBLOCKS_PTR = 1
+       IDUMMY_ARRAY(1) = -1
+      ENDIF
       IF (PROKG) THEN
          WRITE(MPG,'(A,I10)') 
      &   " Parallel analysis, processing a graph of size:", N
@@ -121,12 +141,17 @@ C
       CALL ZMUMPS_SET_PAR_ORD(id, COMM_PARASYMB, MYID, NPROCS, 
      &     ord, COMM_PARAORD, NPROCS_PARAORD,
      &     RKinSYMB_PROC0ORD)
-      IF (ord%COMM.NE.MPI_COMM_NULL) THEN
-       ord%PERMTAB => WORK1(1        : N)
-       ord%PERITAB => WORK1(N+1   : 2*N)
-       ord%TREETAB => WORK1(2*N+1 : 3*N)
+      IF ( LWORK1 .LT. 3_8 *int(N,8) ) THEN
+         WRITE(LP,*)
+     &      'Insufficient workspace in ZMUMPS_ANA_F_PAR' 
+         CALL MUMPS_ABORT()
       ENDIF
-      IF(id%KEEP(54) .NE. 3) THEN
+      IF ( ord%COMM .NE. MPI_COMM_NULL ) THEN
+        ord%PERMTAB => WORK1(         1       : N)
+        ord%PERITAB => WORK1(    int(N,8)+1_8 : 2_8*int(N,8))
+        ord%TREETAB => WORK1(2_8*int(N,8)+1_8 : 3_8*int(N,8))
+      ENDIF
+      IF ( id%KEEP(54) .NE. 3 ) THEN
          IF(MYID.EQ.0) THEN
             SAVEIRN    => id%IRN_loc
             SAVEJCN    => id%JCN_loc
@@ -143,10 +168,10 @@ C
       IF (PROKG) CALL MUMPS_SECDEB( TIMEB )
       IF (id%KEEP(339).GT.0) THEN
         CALL ZMUMPS_DO_PAR_ORD(id, MYID, NPROCS, 
-     &                       ord, WORK2, LUMAT, SIZEOFBLOCKS)
+     &       ord, WORK2, LWORK2, LUMAT, SIZEOFBLOCKS)
       ELSE
         CALL ZMUMPS_DO_PAR_ORD(id, MYID, NPROCS, 
-     &                       ord, WORK2)
+     &       ord, WORK2, LWORK2)
       ENDIF
       IF (PROKG) THEN
        CALL MUMPS_SECFIN( TIMEB )
@@ -167,11 +192,12 @@ C
       END IF
       ord%SUBSTRAT = 0
       ord%TOPSTRAT = 0
-      IF (id%KEEP(339).GT.1) THEN
-        CALL ZMUMPS_PARSYMFACT_LUMAT(id, ord, IPE, NV, WORK2, LUMAT,
+      IF (id%KEEP(339).NE.0) THEN
+        CALL ZMUMPS_PARSYMFACT_LUMAT(id, ord, IPE, NV,
+     &                               WORK2, LWORK2, LUMAT,
      &                               SIZEOFBLOCKS)
       ELSE
-        CALL ZMUMPS_PARSYMFACT(id, ord, IPE, NV, WORK2)
+        CALL ZMUMPS_PARSYMFACT(id, ord, IPE, NV, WORK2, LWORK2)
       ENDIF
       IF(id%KEEP(54) .NE. 3) THEN
          IF(ord%MYID.EQ.0) THEN
@@ -188,32 +214,25 @@ C
       CALL MUMPS_IDEALLOC(ord%FIRST, ord%LAST, MEMCNT=MEMCNT)
       IF (MYID .EQ. 0) THEN
          IPS => WORK1(1:N)
-         NE     => WORK1(N+1   : 2*N)
-         NA     => WORK1(2*N+1 : 3*N)
-         NODE   => WORK2(1        : N  )
-         ND     => WORK2(N+1   : 2*N)
-         SUBORD => WORK2(2*N+1 : 3*N)
-         NAMALG => WORK2(3*N+1 : 4*N)
+         NE     => WORK1(    int(N,8)+1_8 : 2_8*int(N,8))
+         NA     => WORK1(2_8*int(N,8)+1_8 : 3_8*int(N,8))
+         NODE   => WORK2(             1   : N  )
+         ND     => WORK2(    int(N,8)+1_8 : 2_8*int(N,8))
+         SUBORD => WORK2(2_8*int(N,8)+1_8 : 3_8*int(N,8))
+         NAMALG => WORK2(3_8*int(N,8)+1_8 : 4_8*int(N,8))
          CALL MUMPS_REALLOC(CUMUL, N, id%INFO, LP,
      &        STRING='CUMUL', MEMCNT=MEMCNT, ERRCODE=-7)
          IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
          NEMIN  = id%KEEP(1)
-         IF (N.LT.NORIG) THEN
-          CALL ZMUMPS_ANA_LNEW(N, IPE(1), NV(1), IPS(1), NE(1),
-     &        NA(1), NFSIZ(1), NODE(1), id%INFOG(6), FILS(1), FRERE(1),
-     &        ND(1), NEMIN, SUBORD(1), id%KEEP(60), id%KEEP(20),
-     &        id%KEEP(38), NAMALG(1), id%KEEP(104), CUMUL(1),
-     &        id%KEEP(50), id%ICNTL(13), id%KEEP(37), id%KEEP(197),
-     &        id%NSLAVES, id%KEEP(250).EQ.1, .TRUE., 
-     &        SIZEOFBLOCKS, N)
-         ELSE
-          CALL ZMUMPS_ANA_LNEW(N, IPE(1), NV(1), IPS(1), NE(1),
-     &        NA(1), NFSIZ(1), NODE(1), id%INFOG(6), FILS(1), FRERE(1),
-     &        ND(1), NEMIN, SUBORD(1), id%KEEP(60), id%KEEP(20),
-     &        id%KEEP(38), NAMALG(1), id%KEEP(104), CUMUL(1),
-     &        id%KEEP(50), id%ICNTL(13), id%KEEP(37), id%KEEP(197),
-     &        id%NSLAVES, id%KEEP(250).EQ.1, .FALSE., IDUMMY, LIDUMMY)
-         ENDIF
+         CALL ZMUMPS_ANA_LNEW(N, IPE(1), NV(1), IPS(1), NE(1),
+     &       NA(1), NFSIZ(1), NODE(1), id%INFOG(6), FILS(1), FRERE(1),
+     &       ND(1), NEMIN, SUBORD(1), id%KEEP(60), id%KEEP(20),
+     &       id%KEEP(38), NAMALG(1), id%KEEP(104), CUMUL(1),
+     &       id%KEEP(50), id%ICNTL(13), id%KEEP(37), id%KEEP(197),
+     &       id%NSLAVES, id%KEEP(250).EQ.1, SIZEOFBLOCKS_AVAIL, 
+     &       SIZEOFBLOCKS_PTR(1), LSIZEOFBLOCKS_PTR,
+     &       INODE_Scalapack_CAND, NBSONS_Scalapack_CAND, 
+     &       id%KEEP(11))
          CALL MUMPS_DEALLOC(CUMUL, NV, IPE, MEMCNT=MEMCNT)
          CALL ZMUMPS_ANA_M(NE(1), ND(1), id%INFOG(6), id%INFOG(5),
      &        id%KEEP(2), id%KEEP(50), id%KEEP8(101), id%KEEP(108),
@@ -221,6 +240,8 @@ C
          IF ( id%KEEP(53) .NE. 0 ) THEN
             CALL MUMPS_MAKE1ROOT(N, FRERE(1), FILS(1), NFSIZ(1),
      &           id%KEEP(20))
+            INODE_Scalapack_CAND  = id%KEEP(20)
+            NBSONS_Scalapack_CAND = 1
          END IF
          IF (  (id%KEEP(48) == 4 .AND. id%KEEP8(21).GT.0_8)
      &        .OR.
@@ -230,56 +251,84 @@ C
             CALL ZMUMPS_SET_K821_SURFACE(id%KEEP8(21), id%KEEP(2),
      &           id%KEEP(48), id%KEEP(50), id%NSLAVES)
          END IF
-      IF (id%KEEP(210).LT.1.OR.id%KEEP(210).GT.2) id%KEEP(210)=2
-      IF (id%KEEP(210).EQ.2) id%KEEP8(79)=huge(id%KEEP8(79))
-      IF (id%KEEP(210).EQ.1.AND.id%KEEP8(79).LE.0_8) THEN
-       id%KEEP8(79)=K79REF * int(id%NSLAVES,8)
-      ENDIF
-         IF ( (id%KEEP(79).EQ.0).OR.(id%KEEP(79).EQ.2).OR.
-     &        (id%KEEP(79).EQ.3).OR.(id%KEEP(79).EQ.5).OR.
-     &        (id%KEEP(79).EQ.6)
-     &   )  THEN
-          IF (id%KEEP(210).EQ.1) THEN
+         IF (id%KEEP(210).LT.1.OR.id%KEEP(210).GT.2) id%KEEP(210)=2
+         IF (id%KEEP(210).EQ.2) id%KEEP8(79)=huge(id%KEEP8(79))
+         IF (id%KEEP(210).EQ.1.AND.id%KEEP8(79).LE.0_8) THEN
+          id%KEEP8(79)=K79REF * int(id%NSLAVES,8)
+         ENDIF
+         IF (id%KEEP(11).EQ.0) THEN
+          IF ( (id%KEEP(79).EQ.0).OR.(id%KEEP(79).EQ.2).OR.
+     &         (id%KEEP(79).EQ.3).OR.(id%KEEP(79).EQ.5).OR.
+     &         (id%KEEP(79).EQ.6)
+     &    )  THEN
+           IF (id%KEEP(210).EQ.1) THEN
             SPLITROOT = .FALSE. 
             IF ( id%KEEP(62).GE.1) THEN
-               IDUMMY(1) = -1
                CALL ZMUMPS_CUTNODES(N, FRERE(1), FILS(1),
-     &              NFSIZ(1), IDUMMY, LIDUMMY, id%INFOG(6),
-     &              id%NSLAVES, id%KEEP(1), id%KEEP8(1), SPLITROOT,
-     &              MP, LDIAG, id%INFOG(1), id%INFOG(2))
+     &           NFSIZ(1), 
+     &           SIZEOFBLOCKS_PTR(1), LSIZEOFBLOCKS_PTR, id%INFOG(6), 
+     &           id%NSLAVES, id%KEEP(1), id%KEEP8(1), SPLITROOT,
+     &           MP, LDIAG, id%INFOG(1), id%INFOG(2))
                IF (id%INFOG(1).LT.0) RETURN
             ENDIF
+           ENDIF
           ENDIF
          ENDIF
-      SPLITROOT = id%ICNTL(13) .EQ. -1
+         HOW_TO_SPLIT_ROOT = 0 
+         SPLITROOT = id%ICNTL(13) .EQ. -1
 #if defined(NOSCALAPACK)
-      SPLITROOT = SPLITROOT .OR. id%NSLAVES.GT.0
+         SPLITROOT = SPLITROOT .OR. id%NSLAVES.GT.0
 #else
-      SPLITROOT = SPLITROOT .OR.
+         SPLITROOT = SPLITROOT .OR.
      &            (id%ICNTL(13).GT.0 .AND. id%NSLAVES.GT.id%ICNTL(13))
 #endif
-      IF (id%KEEP(53) .NE. 0) THEN
-         SPLITROOT = .TRUE.
-      ENDIF
+         IF (SPLITROOT.AND.id%KEEP(11).GT.0) HOW_TO_SPLIT_ROOT =1 
+         IF (id%KEEP(53) .NE. 0) THEN
+           SPLITROOT = .TRUE.
+           IF (id%KEEP(11).GT.0) HOW_TO_SPLIT_ROOT = 2
+         ENDIF
+#if defined(NOSCALAPACK)
+#else
+         IF ( id%KEEP(11).GT.0 .AND. (id%KEEP(339).NE.0) ) THEN 
+           IF (.NOT.SPLITROOT .AND. 
+     &       (id%KEEP(60).EQ.0).AND.   
+     &       ( (NFSIZ(INODE_Scalapack_CAND).GT.id%KEEP(37))
+     &        .AND.(id%ICNTL(13).LE.0) )
+     &       .AND.
+     &       (NBSONS_Scalapack_CAND.GT.id%KEEP(11)) 
+     &       ) THEN
+             HOW_TO_SPLIT_ROOT = 3
+             SPLITROOT=.TRUE.
+           ENDIF
+         ENDIF
+#endif
          SPLITROOT = (SPLITROOT.AND.( (id%KEEP(60).EQ.0) ))
          IF (SPLITROOT) THEN
            IF (id%KEEP(339).EQ.0) THEN
-            IDUMMY(1) = -1
             CALL ZMUMPS_CUTNODES(N, FRERE(1), FILS(1), NFSIZ(1),
-     &           IDUMMY, LIDUMMY, id%INFOG(6), 
+     &           SIZEOFBLOCKS_PTR(1), LSIZEOFBLOCKS_PTR, id%INFOG(6), 
      &           id%NSLAVES, id%KEEP(1), id%KEEP8(1),
      &           SPLITROOT, MP, LDIAG, id%INFOG(1), id%INFOG(2))
            ELSE
-            CALL ZMUMPS_CUTNODES(N, FRERE(1), FILS(1), NFSIZ(1),
-     &           SIZEOFBLOCKS, id%NBLK, id%INFOG(6), 
+            IF (id%KEEP(11).EQ.0) THEN
+              CALL ZMUMPS_CUTNODES(N, FRERE(1), FILS(1), NFSIZ(1),
+     &           SIZEOFBLOCKS_PTR(1), LSIZEOFBLOCKS_PTR, id%INFOG(6), 
      &           id%NSLAVES, id%KEEP(1), id%KEEP8(1),
      &           SPLITROOT, MP, LDIAG, id%INFOG(1), id%INFOG(2))
-           ENDIF
-            IF (id%INFOG(1).LT.0) RETURN
-            IF ( id%KEEP(53) .NE. 0 ) THEN
-              CALL MUMPS_MAKE1ROOT(N, FRERE(1), FILS(1), NFSIZ(1),
-     &           id%KEEP(20))
+              IF (id%INFOG(1).LT.0) RETURN
+              IF ( id%KEEP(53) .NE. 0 ) THEN
+                CALL MUMPS_MAKE1ROOT(N, FRERE(1), FILS(1), NFSIZ(1),
+     &             id%KEEP(20))
+              END IF
+            ELSE
+              CALL ZMUMPS_SPLIT_ROOT( id%NSLAVES,
+     &                    HOW_TO_SPLIT_ROOT, INODE_Scalapack_CAND,
+     &                    N, FRERE(1), FILS(1), NFSIZ(1), 
+     &                    id%KEEP(1), id%KEEP8(1),
+     &                    SIZEOFBLOCKS_PTR(1), LSIZEOFBLOCKS_PTR,
+     &                    id%INFOG(6))
             END IF
+           END IF
          ENDIF
       END IF
       RETURN
@@ -415,13 +464,15 @@ C
        END IF
       ENDIF
       END SUBROUTINE ZMUMPS_SET_PAR_ORD
-      SUBROUTINE ZMUMPS_DO_PAR_ORD(id, MYID, NPROCS, ord, WORK, LUMAT, 
+      SUBROUTINE ZMUMPS_DO_PAR_ORD(id, MYID, NPROCS, ord,
+     &                             WORK, LWORK, LUMAT, 
      &                             SIZEOFBLOCKS)
       IMPLICIT NONE
       TYPE(ZMUMPS_STRUC)       :: id
       INTEGER, INTENT(IN)      :: MYID, NPROCS
       TYPE(ORD_TYPE)           :: ord
       INTEGER                  :: WORK(:)
+      INTEGER(8), INTENT(IN)   :: LWORK
       TYPE(LMATRIX_T), OPTIONAL       :: LUMAT
       INTEGER, INTENT(IN), OPTIONAL   :: SIZEOFBLOCKS(N)
 #if defined(parmetis) || defined(parmetis3)
@@ -440,10 +491,11 @@ C
       IF (ord%ORDTOOL .EQ. 1) THEN
 #if defined(ptscotch)
         IF (id%KEEP(339).NE.0) THEN
-         CALL ZMUMPS_PTSCOTCH_ORD(id, ord, WORK, GCOMP_DIST,
+         CALL ZMUMPS_PTSCOTCH_ORD(id, ord, WORK, LWORK,
+     &                     GCOMP_DIST,
      &                     SIZEOFBLOCKS )
         ELSE
-         CALL ZMUMPS_PTSCOTCH_ORD(id, ord, WORK)
+         CALL ZMUMPS_PTSCOTCH_ORD(id, ord, WORK, LWORK)
         ENDIF
 #else
          id%INFOG(1) = -38
@@ -454,10 +506,11 @@ C
       ELSE IF (ord%ORDTOOL .EQ. 2) THEN
 #if defined(parmetis) || defined(parmetis3)
          IF (id%KEEP(339).GT.0) THEN
-         CALL ZMUMPS_PARMETIS_ORD_LUMAT (id, ord, WORK, GCOMP_DIST,
+         CALL ZMUMPS_PARMETIS_ORD_LUMAT (id, ord, WORK, LWORK,
+     &                            GCOMP_DIST,
      &                            SIZEOFBLOCKS)
          ELSE
-           CALL ZMUMPS_PARMETIS_ORD(id, ord, WORK)
+           CALL ZMUMPS_PARMETIS_ORD(id, ord, WORK, LWORK)
          ENDIF
          IF (id%KEEP(339).EQ.0) THEN
           if(ord%IDO) CALL MPI_COMM_FREE(ord%COMM_PARAORD, IERR)
@@ -475,14 +528,14 @@ C
       RETURN
       END SUBROUTINE ZMUMPS_DO_PAR_ORD
 #if defined(parmetis) || defined(parmetis3)
-      SUBROUTINE ZMUMPS_PARMETIS_ORD(id, ord, WORK) 
+      SUBROUTINE ZMUMPS_PARMETIS_ORD(id, ord, WORK, LWORK) 
       IMPLICIT NONE
-      TYPE(ZMUMPS_STRUC)  :: id
-      TYPE(ORD_TYPE)      :: ord
-      INTEGER, TARGET    :: WORK(:)
+      TYPE(ZMUMPS_STRUC)      :: id
+      TYPE(ORD_TYPE)          :: ord
+      INTEGER, TARGET         :: WORK(:)
+      INTEGER(8), INTENT (IN) :: LWORK
       INTEGER             :: I, MYID, NPROCS, IERR, BASE, METIS_IDX_SIZE
-      INTEGER, POINTER    :: FIRST(:),
-     &     LAST(:), SWORK(:)
+      INTEGER, POINTER    :: FIRST(:), LAST(:), SWORK(:)
       INTEGER             :: BASEVAL, VERTLOCNBR,
      &     OPTIONS(10)
       INTEGER(8), POINTER :: VERTLOCTAB(:)
@@ -497,7 +550,7 @@ C
       NPROCS          = ord%NPROCS
       IERR            = 0
       SIZE_IDUMMY_PTR = 0
-      IF(size(WORK) .LT. N*3 .OR.size(WORK).LT.NPROCS+1) THEN
+      IF( LWORK.LT. int(N,8)*3_8 .OR. LWORK .LT. int(NPROCS+1,8)) THEN
          WRITE(LP,
      &        '("Insufficient workspace inside ZMUMPS_PARMETIS_ORD")')
          CALL MUMPS_ABORT()
@@ -510,14 +563,15 @@ C
       IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
       BASE    = id%NPROCS-id%NSLAVES
       CALL ZMUMPS_GRAPH_DIST(id, ord, FIRST,
-     &     LAST, BASE, NPROCS, WORK(1: 2*N), TYPE=2)
+     &     LAST, BASE, NPROCS, WORK(1_8: 2_8*int(N,8)),
+     &     2_8*int(N,8), TYPE=2)
       VERTLOCNBR = LAST(MYID+1)-FIRST(MYID+1) + 1
       CALL MUMPS_I8REALLOC(VERTLOCTAB, VERTLOCNBR+1, id%INFO,
      &        LP, STRING='VERTLOCTAB', MEMCNT=MEMCNT, ERRCODE=-7)
       IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
-      SWORK => WORK(N+1:3*N)
+      SWORK => WORK(int(N+1,8):3_8*int(N,8))
       CALL ZMUMPS_BUILD_DIST_GRAPH(id, ord, FIRST, LAST, VERTLOCTAB,
-     &     EDGELOCTAB, SWORK)
+     &     EDGELOCTAB, SWORK, 2_8 * int(N,8))
       CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &     ord%COMM, ord%MYID )
       IF(id%INFO(1).LT.0) GOTO 20
@@ -608,19 +662,20 @@ C
       CALL MUMPS_DEALLOC(ord%RANGTAB, MEMCNT=MEMCNT)
       RETURN
       END SUBROUTINE ZMUMPS_PARMETIS_ORD
-      SUBROUTINE ZMUMPS_PARMETIS_ORD_LUMAT (id, ord, WORK, GCOMP_DIST,
+      SUBROUTINE ZMUMPS_PARMETIS_ORD_LUMAT (id, ord, WORK, LWORK,
+     &                              GCOMP_DIST,
      &                              SIZEOFBLOCKS )
       IMPLICIT NONE
-      TYPE(ZMUMPS_STRUC)  :: id
-      TYPE(ORD_TYPE)      :: ord
-      INTEGER, TARGET    :: WORK(:)
+      TYPE(ZMUMPS_STRUC)     :: id
+      TYPE(ORD_TYPE)         :: ord
+      INTEGER, TARGET        :: WORK(:)
+      INTEGER(8), INTENT(IN) :: LWORK
       TYPE(COMPACT_GRAPH_T), OPTIONAL       :: GCOMP_DIST
       INTEGER, INTENT(IN), OPTIONAL, TARGET :: SIZEOFBLOCKS(N)
       INTEGER             :: I, MYID, NPROCS, IERR, BASE, METIS_IDX_SIZE
       INTEGER             :: MASTER
       PARAMETER     (MASTER=0)
-      INTEGER, POINTER    :: FIRST(:),
-     &     LAST(:), SWORK(:)
+      INTEGER, POINTER    :: FIRST(:), LAST(:), SWORK(:)
       INTEGER             :: BASEVAL, VERTLOCNBR,
      &     OPTIONS(10)
       INTEGER(8), POINTER :: VERTLOCTAB(:)
@@ -637,7 +692,7 @@ C
       NPROCS          = ord%NPROCS
       IERR            = 0
       SIZE_VELOLOCTAB = 0
-      IF(size(WORK) .LT. N*3 .OR.size(WORK).LT.NPROCS+1) THEN
+      IF( LWORK.LT. int(N,8)*3_8 .OR. LWORK .LT. int(NPROCS+1,8)) THEN
          WRITE(LP,
      &        '("Insufficient workspace inside ZMUMPS_PARMETIS_ORD")')
          CALL MUMPS_ABORT()
@@ -661,7 +716,7 @@ C
          EDGELOCNBR = GCOMP_DIST%NZG
          VERTLOCTAB => GCOMP_DIST%IPE
          EDGELOCTAB => GCOMP_DIST%ADJ
-         IF (id%KEEP(339).GE.6) THEN
+         IF (id%KEEP(339).NE.0) THEN
           VELOLOCTAB=>SIZEOFBLOCKS(GCOMP_DIST%FIRST:GCOMP_DIST%LAST)
           SIZE_VELOLOCTAB = VERTLOCNBR
          ENDIF
@@ -788,14 +843,14 @@ C
       END SUBROUTINE ZMUMPS_PARMETIS_ORD_LUMAT
 #endif
 #if defined(ptscotch)
-      SUBROUTINE ZMUMPS_PTSCOTCH_ORD(id, ord, WORK, GCOMP_DIST,
+      SUBROUTINE ZMUMPS_PTSCOTCH_ORD(id, ord, WORK, LWORK, GCOMP_DIST,
      &                               SIZEOFBLOCKS)
 !$    USE OMP_LIB
       IMPLICIT NONE
-      INCLUDE 'ptscotchf.h'
       TYPE(ZMUMPS_STRUC)                :: id
       TYPE(ORD_TYPE)                    :: ord
       INTEGER, TARGET                   :: WORK(:)
+      INTEGER(8), INTENT(IN)            :: LWORK
       TYPE(COMPACT_GRAPH_T), OPTIONAL   :: GCOMP_DIST
       INTEGER, INTENT(IN), OPTIONAL, TARGET:: SIZEOFBLOCKS(N)
       INTEGER                       :: MYID, NPROCS, IERR
@@ -809,7 +864,14 @@ C
       INTEGER, POINTER              :: VELOLOCTAB(:)
       INTEGER                       :: SIZE_VELOLOCTAB
       INTEGER, TARGET               :: IDUMMY(1)
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+      INCLUDE 'scotchf.h' 
+      INTEGER          :: IOMP, NOMP
+      DOUBLE PRECISION :: CONTDAT(SCOTCH_CONTEXTDIM)
+      INTEGER(4)       :: IERR_SCOTCH
+#else
       INTEGER :: PTHREAD_NUMBER, NOMP
+#endif
       nullify(FIRST, LAST, SWORK, VERTLOCTAB, EDGELOCTAB)
       VELOLOCTAB => IDUMMY 
       CALL MPI_BARRIER(ord%COMM, IERR)
@@ -822,12 +884,12 @@ C
         EDGELOCNBR = GCOMP_DIST%NZG
         VERTLOCTAB => GCOMP_DIST%IPE
         EDGELOCTAB => GCOMP_DIST%ADJ
-        IF (id%KEEP(339).GE.6) THEN
+        IF (id%KEEP(339).NE.0) THEN
          VELOLOCTAB => SIZEOFBLOCKS(GCOMP_DIST%FIRST:GCOMP_DIST%LAST)
          SIZE_VELOLOCTAB = VERTLOCNBR
         ENDIF
       ELSE
-        IF (size(WORK) .LT. N*3) THEN
+        IF (LWORK .LT. int(N,8)*3_8) THEN
             WRITE(LP,
      &      '("Insufficient workspace inside ZMUMPS_PTSCOTCH_ORD")')
             CALL MUMPS_ABORT()
@@ -839,14 +901,15 @@ C
      &     MEMCNT=MEMCNT, ERRCODE=-7)
         IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
         CALL ZMUMPS_GRAPH_DIST(id, ord, FIRST,
-     &     LAST, BASE, NPROCS, WORK(1: 2*N), TYPE=2)
+     &     LAST, BASE, NPROCS, WORK(1: 2_8*int(N,8)),
+     &     2_8*int(N,8), TYPE=2)
         VERTLOCNBR = LAST(MYID+1)-FIRST(MYID+1) + 1
         CALL MUMPS_I8REALLOC(VERTLOCTAB, VERTLOCNBR+1, id%INFO,
      &        LP, STRING='VERTLOCTAB', MEMCNT=MEMCNT, ERRCODE=-7)
         IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
-        SWORK => WORK(N+1:3*N)
+        SWORK => WORK(int(N+1,8):3_8*int(N,8))
         CALL ZMUMPS_BUILD_DIST_GRAPH(id, ord, FIRST, LAST, VERTLOCTAB,
-     &     EDGELOCTAB, SWORK)
+     &     EDGELOCTAB, SWORK, 2_8*int(N,8))
         CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &     ord%COMM, ord%MYID )
         IF ( id%INFO(1) .LT. 0 ) GOTO 11
@@ -863,35 +926,65 @@ C
       IF(MEMCNT .GT. MAXMEM) MAXMEM=MEMCNT
       IF(ord%IDO) THEN
          CALL MUMPS_SCOTCH_INTSIZE(SCOTCH_INT_SIZE)
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+!$OMP PARALLEL PRIVATE(IOMP, IERR_SCOTCH)
+!$OMP SINGLE
+         NOMP=omp_get_num_threads()
+!$OMP END SINGLE
+         IOMP=omp_get_thread_num()
+         IF (IOMP.EQ.0) THEN
+           CALL SCOTCHFCONTEXTINIT(CONTDAT, IERR_SCOTCH)
+           CALL SCOTCHFCONTEXTRANDOMCLONE(CONTDAT, IERR_SCOTCH)
+           CALL SCOTCHFCONTEXTTHREADIMPORT1(CONTDAT, NOMP, IERR_SCOTCH)
+         ENDIF
+!$OMP BARRIER
+         CALL SCOTCHFCONTEXTTHREADIMPORT2(CONTDAT, IOMP, IERR_SCOTCH)
+#else
          NOMP=0
 !$       NOMP=omp_get_max_threads()
          IF (NOMP .GT. 0) THEN
            CALL MUMPS_SCOTCH_GET_PTHREAD_NUMBER (PTHREAD_NUMBER)
            CALL MUMPS_SCOTCH_SET_PTHREAD_NUMBER (NOMP)
          ENDIF
-         IF(SCOTCH_INT_SIZE.EQ.32) THEN
-           IF (id%KEEP(10).EQ.1) THEN
-            id%INFO(1) = -52
-            id%INFO(2) = 2
+#endif
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+         IF (IOMP.EQ.0) THEN
+#endif
+           IF(SCOTCH_INT_SIZE.EQ.32) THEN
+             IF (id%KEEP(10).EQ.1) THEN
+              id%INFO(1) = -52
+              id%INFO(2) = 2
+             ELSE
+              CALL MUMPS_PTSCOTCH_MIXEDto32(id, ord,
+     &             BASEVAL, 
+     &             VERTLOCNBR, VERTLOCTAB,
+     &             EDGELOCNBR, EDGELOCTAB,
+     &             VELOLOCTAB, SIZE_VELOLOCTAB,
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+     &             CONTDAT, SCOTCH_CONTEXTDIM,
+#endif
+     &             IERR)
+            ENDIF
            ELSE
-            CALL MUMPS_PTSCOTCH_MIXEDto32(id, ord,
-     &           BASEVAL, 
-     &           VERTLOCNBR, VERTLOCTAB,
-     &           EDGELOCNBR, EDGELOCTAB,
-     &           VELOLOCTAB, SIZE_VELOLOCTAB,
-     &           IERR)
-          ENDIF
-         ELSE
-            CALL MUMPS_PTSCOTCH_MIXEDto64(id, ord,
-     &           BASEVAL, 
-     &           VERTLOCNBR, VERTLOCTAB,
-     &           EDGELOCNBR, EDGELOCTAB,
-     &           VELOLOCTAB, SIZE_VELOLOCTAB,
-     &           IERR)
-         END IF
+              CALL MUMPS_PTSCOTCH_MIXEDto64(id, ord,
+     &             BASEVAL, 
+     &             VERTLOCNBR, VERTLOCTAB,
+     &             EDGELOCNBR, EDGELOCTAB,
+     &             VELOLOCTAB, SIZE_VELOLOCTAB,
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+     &             CONTDAT, SCOTCH_CONTEXTDIM,
+#endif
+     &             IERR)
+           END IF
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+           CALL SCOTCHFCONTEXTEXIT(CONTDAT)
+         ENDIF 
+!$OMP END PARALLEL
+#else
          IF (NOMP .GT. 0) THEN
            CALL MUMPS_SCOTCH_SET_PTHREAD_NUMBER (PTHREAD_NUMBER)
          ENDIF
+#endif
       END IF
       IF(IERR.NE.0) THEN
          id%INFO(1:2) = -50
@@ -996,7 +1089,7 @@ C
       HOSTMEM = 12*N 
       NZ4=int(id%KEEP8(28))
       NZ_ROW = 2*(NZ4/N) 
-      IF (id%KEEP(339).GT.2) THEN
+      IF (id%KEEP(339).NE.0) THEN
          NRL = 0
       ELSE
         IF(id%KEEP(46) .EQ. 0) THEN
@@ -1152,7 +1245,7 @@ C
       CALL ZMUMPS_MERGESORT(ANODE, AWEIGHTS(1:ANODE), WORK(0:ANODE+1))
       CALL ZMUMPS_MERGESWAP(ANODE, WORK(0:ANODE+1), AWEIGHTS(1:ANODE), 
      &     ALIST(1:ANODE))
-      IF (id%KEEP(339).GE.4) THEN
+      IF (id%KEEP(339).NE.0) THEN
        Iprocdeb = ord%NPROCS-ANODE+1
        IF (Iprocdeb.GT.1) THEN
          DO I=1, Iprocdeb-1
@@ -1216,28 +1309,26 @@ C
  90   continue
       RETURN
       END SUBROUTINE ZMUMPS_GET_SUBTREES
-      SUBROUTINE ZMUMPS_PARSYMFACT(id, ord, GPE, GNV, WORK)  
+      SUBROUTINE ZMUMPS_PARSYMFACT(id, ord, GPE, GNV, WORK, LWORK)  
       IMPLICIT NONE
-      TYPE(ZMUMPS_STRUC)   :: id
-      TYPE(ORD_TYPE)       :: ord
-      INTEGER, POINTER     :: GPE(:), GNV(:)
-      INTEGER, TARGET      :: WORK(:)
-      TYPE(GRAPH_TYPE)     :: top_graph
-      INTEGER(8), POINTER  :: IPE(:), IPET(:),
-     &     BUF_PE1(:), BUF_PE2(:), TMP1(:)
-      INTEGER, POINTER     :: PE(:),
-     &     LENG(:), I_HALO_MAP(:)
-      INTEGER, POINTER     :: NDENSE(:), LAST(:),
-     &     DEGREE(:), W(:), PERM(:),
-     &     LISTVAR_SCHUR(:), NEXT(:),
-     &     HEAD(:), NV(:), ELEN(:),
-     &     LSTVAR(:)
-      INTEGER, POINTER     :: MYLIST(:),
-     &     LPERM(:),
-     &     LIPERM(:),
-     &     NVT(:), BUF_NV1(:),
-     &     BUF_NV2(:), ROOTPERM(:),
-     &     TMP2(:), BWORK(:), NCLIQUES(:)
+      TYPE(ZMUMPS_STRUC)     :: id
+      TYPE(ORD_TYPE)         :: ord
+      INTEGER, POINTER       :: GPE(:), GNV(:)
+      INTEGER, TARGET        :: WORK(:)
+      INTEGER(8), INTENT(IN) :: LWORK
+      TYPE(GRAPH_TYPE)       :: top_graph
+      INTEGER(8), POINTER    :: IPE(:), IPET(:),
+     &                          BUF_PE1(:), BUF_PE2(:), TMP1(:)
+      INTEGER, POINTER       :: PE(:), LENG(:), I_HALO_MAP(:)
+      INTEGER, POINTER       :: NDENSE(:), LAST(:),
+     &                          DEGREE(:), W(:), PERM(:),
+     &                          LISTVAR_SCHUR(:), NEXT(:),
+     &                          HEAD(:), NV(:), ELEN(:),
+     &                          LSTVAR(:)
+      INTEGER, POINTER       :: MYLIST(:), LPERM(:), LIPERM(:),
+     &                          NVT(:), BUF_NV1(:),
+     &                          BUF_NV2(:), ROOTPERM(:),
+     &                          TMP2(:), BWORK(:), NCLIQUES(:)
       INTEGER              :: MYNCLIQUES, MYMAXVARS, ICLIQUES,
      &     TOTNCLIQUES
       INTEGER(8)           :: MYNVARS, TOTNVARS
@@ -1262,14 +1353,14 @@ C
      &     BUF_NV1, BUF_NV2, ROOTPERM, TMP1, TMP2, BWORK)
       MYID   = ord%MYID
       NPROCS = ord%NPROCS
-      IF(size(WORK) .LT. 4*N) THEN
+      IF(LWORK .LT. 4_8*int(N,8)) THEN
          WRITE(LP,*)'Insufficient workspace in ZMUMPS_PARSYMFACT'
          CALL MUMPS_ABORT()
       ELSE
-         HEAD => WORK(       1 :   N)
-         ELEN => WORK(  N+1 : 2*N)
-         LENG => WORK(2*N+1 : 3*N)
-         PERM => WORK(3*N+1 : 4*N)
+         HEAD => WORK(              1 :         N    )
+         ELEN => WORK(     int(N,8)+1 : 2_8*int(N,8) )
+         LENG => WORK( 2_8*int(N,8)+1 : 3_8*int(N,8) )
+         PERM => WORK( 3_8*int(N,8)+1 : 4_8*int(N,8) )
       END IF
       CALL ZMUMPS_GET_SUBTREES(ord, id)
       CALL MUMPS_IDEALLOC(ord%SON, ord%BROTHER, ord%NW,
@@ -1277,9 +1368,9 @@ C
       NROWS_LOC = ord%LAST(MYID+1)-ord%FIRST(MYID+1)+1
       NRL = NROWS_LOC
       TOPROWS = ord%TOPNODES(2)
-      BWORK => WORK(1 : 2*N)
+      BWORK => WORK(1_8 : 2_8*int(N,8))
       CALL ZMUMPS_BUILD_LOC_GRAPH(id, ord, HIDX, IPE, PE, LENG,
-     &     I_HALO_MAP, top_graph, BWORK)
+     &     I_HALO_MAP, top_graph, BWORK, 2_8*int(N,8))
       CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &     ord%COMM, ord%MYID )
       IF(id%INFO(1).lt.0) RETURN
@@ -1377,7 +1468,7 @@ C
      &              PROC, ITAG, ord%COMM, STATUSCLIQUES, IERR)
             END DO
          END DO
-         LPERM => WORK(3*N+1 : 4*N)
+         LPERM => WORK(3_8*int(N,8)+1_8 : 4_8*int(N,8))
          NTVAR   = ord%TOPNODES(2)
          CALL ZMUMPS_MAKE_LOC_IDX(id, ord%TOPNODES, LPERM, LIPERM, ord)
          CALL ZMUMPS_ASSEMBLE_TOP_GRAPH(id, ord%TOPNODES(2), LPERM,
@@ -1563,7 +1654,7 @@ C
       NULLIFY(HEAD, ELEN, LENG, PERM)
       RETURN
       END SUBROUTINE ZMUMPS_PARSYMFACT
-      SUBROUTINE ZMUMPS_PARSYMFACT_LUMAT(id, ord, GPE, GNV, WORK, 
+      SUBROUTINE ZMUMPS_PARSYMFACT_LUMAT(id, ord, GPE, GNV, WORK, LWORK,
      &                                   LUMAT, SIZEOFBLOCKS)  
       IMPLICIT NONE
       TYPE(ZMUMPS_STRUC)   :: id
@@ -1590,7 +1681,7 @@ C
      &     TMP2(:), BWORK(:), NCLIQUES(:), MAPTAB(:)
       INTEGER              :: MYNCLIQUES, MYMAXVARS, ICLIQUES,
      &     TOTNCLIQUES
-      INTEGER(8)           :: MYNVARS, TOTNVARS
+      INTEGER(8)           :: MYNVARS, TOTNVARS, LWORK
       INTEGER(8), POINTER  :: LVARPT(:)
       INTEGER              :: HIDX, TOTEL, 
      &     NCMPA, I, J, SIZE_SCHUR, MYID,
@@ -1612,26 +1703,25 @@ C
      &     BUF_NV1, BUF_NV2, ROOTPERM, TMP1, TMP2, BWORK, MAPTAB)
       MYID   = ord%MYID
       NPROCS = ord%NPROCS
-      IF(size(WORK) .LT. 4*N) THEN
+      IF( LWORK .LT. 4_8*int(N,8) ) THEN
          WRITE(LP,*)
      &      'Insufficient workspace in ZMUMPS_PARSYMFACT_LUMAT'
          CALL MUMPS_ABORT()
-      ELSE
-         HEAD => WORK(       1 :   N)
-         ELEN => WORK(  N+1 : 2*N)
-         LENG => WORK(2*N+1 : 3*N)
-         PERM => WORK(3*N+1 : 4*N)
-      END IF
+      ENDIF
+      HEAD => WORK(              1   :         N    )
+      ELEN => WORK(     int(N,8)+1_8 : 2_8*int(N,8) )
+      LENG => WORK( 2_8*int(N,8)+1_8 : 3_8*int(N,8) )
+      PERM => WORK( 3_8*int(N,8)+1_8 : 4_8*int(N,8) )
       CALL ZMUMPS_GET_SUBTREES(ord, id)
       CALL MUMPS_IDEALLOC(ord%SON, ord%BROTHER, ord%NW,
      &     ord%RANGTAB, MEMCNT=MEMCNT)
       NROWS_LOC = ord%LAST(MYID+1)-ord%FIRST(MYID+1)+1
       NRL = NROWS_LOC
       TOPROWS = ord%TOPNODES(2)
-      BWORK  => WORK(1 : 2*N)
+      BWORK  => WORK(1_8 : 2_8*int(N,8))
        CALL ZMUMPS_LUMAT_TO_LOC_GRAPH(
      &     LUMAT, id, ord, HIDX, IPE, PE, LENG,
-     &     I_HALO_MAP, BWORK)
+     &     I_HALO_MAP, BWORK, 2_8*int(N,8))
       CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &     ord%COMM, ord%MYID )
       IF(id%INFO(1).lt.0) RETURN
@@ -1680,7 +1770,7 @@ C
          IF(HIDX .GT.0) THEN
            NV(1) = -1 
            TOTEL = HIDX
-           IF ((N.LT.NORIG).OR.(id%KEEP(339).GE.4)) THEN
+           IF ((N.LT.NORIG).OR.(id%KEEP(339).NE.0)) THEN
              TOTEL = 0
              DO I=1,NROWS_LOC
                NV(I) = SIZEOFBLOCKS (
@@ -1759,13 +1849,13 @@ C
          END DO
       END IF
       CALL MUMPS_DEALLOC(PE, MEMCNT=MEMCNT) 
-      IF (id%KEEP(339).GT.2) THEN
+      IF (id%KEEP(339).NE.0) THEN
           MAPTAB => WORK(1:N)
           CALL MUMPS_BUILD_TOP_GRAPH (LUMAT, id, ord, top_graph, MAPTAB)
       ENDIF
       IF (MYID.EQ.0) THEN
-        LPERM => WORK(3*N+1 : 4*N)
-        NTVAR   = ord%TOPNODES(2)
+        LPERM => WORK( 3_8*int(N,8)+1_8 : 4_8*int(N,8) )
+        NTVAR = ord%TOPNODES(2)
         CALL ZMUMPS_MAKE_LOC_IDX(id, ord%TOPNODES, LPERM, LIPERM, ord)
         CALL ZMUMPS_ASSEMBLE_TOP_GRAPH(id, ord%TOPNODES(2), LPERM,
      &        top_graph, TOTNCLIQUES, LSTVAR, LVARPT, IPET, PE,
@@ -1813,7 +1903,7 @@ C
             IF(TGSIZE.GT.0) THEN 
               NVT(1) = -1 
               TOTEL = TGSIZE
-              IF ((N.LT.NORIG).OR.(id%KEEP(339).GE.4)) THEN
+              IF ((N.LT.NORIG).OR.(id%KEEP(339).NE.0)) THEN
                 TOTEL = TOTNCLIQUES
                 DO I=1,NTVAR
                   NVT(I) = SIZEOFBLOCKS( LIPERM(I) )
@@ -1939,7 +2029,7 @@ C
      &     MEMCNT=MEMCNT)
       CALL MUMPS_DEALLOC(LPERM, LIPERM, NVT, MEMCNT=MEMCNT)
       CALL MUMPS_DEALLOC(ROOTPERM, TMP2, MEMCNT=MEMCNT)
-      NULLIFY(HEAD, ELEN, LENG, PERM)
+      NULLIFY(HEAD, ELEN, LENG, PERM, BWORK, MAPTAB, LPERM)
       RETURN
       END SUBROUTINE ZMUMPS_PARSYMFACT_LUMAT
       SUBROUTINE ZMUMPS_MAKE_LOC_IDX(id, TOPNODES, LPERM, LIPERM, ord)
@@ -2115,13 +2205,14 @@ C
 #endif
 #if defined(ptscotch) || defined(parmetis) || defined(parmetis3)
       SUBROUTINE ZMUMPS_BUILD_DIST_GRAPH(id, ord, FIRST, LAST, IPE,
-     &     PE, WORK)
+     &     PE, WORK, LWORK)
       IMPLICIT NONE
       TYPE(ZMUMPS_STRUC)      :: id
       TYPE(ORD_TYPE)          :: ord
       INTEGER(8), POINTER     :: IPE(:)
       INTEGER, POINTER        :: FIRST(:), LAST(:), PE(:),
      &     WORK(:)
+      INTEGER(8), INTENT(IN)  :: LWORK
       INTEGER                 :: IERR, MYID, NPROCS
       INTEGER                 :: I, PROC, J, LOC_ROW
       INTEGER(8)              :: LOCNNZ, INNZ, NEW_LOCNNZ, OFFDIAG,
@@ -2148,7 +2239,7 @@ C
       nullify(TSENDI, TSENDJ, RCVBUF, APNT)
       MYID   = ord%MYID
       NPROCS = ord%NPROCS
-      IF(MUMPS_GETSIZE(WORK) .LT. N*2) THEN
+      IF(LWORK .LT. int(N,8)*2_8) THEN
          WRITE(LP,
      &        '("Insufficient workspace inside BUILD_SCOTCH_GRAPH")')
          CALL MUMPS_ABORT()
@@ -2174,8 +2265,8 @@ C
       BUFSIZE = id%KEEP(39)
       LOCNNZ = id%KEEP8(29)
       NROWS_LOC = LAST(MYID+1)-FIRST(MYID+1)+1
-      MAPTAB => WORK(     1 :   N)
-      LENG   => WORK(N+1 : 2*N)
+      MAPTAB => WORK(       1    :         N )
+      LENG   => WORK( int(N+1,8) : 2_8*int(N,8) )
       MAXS = 0
       DO I=1, NPROCS
          IF((LAST(I)-FIRST(I)+1) .GT. MAXS) THEN
@@ -2321,7 +2412,7 @@ C
       END SUBROUTINE ZMUMPS_BUILD_DIST_GRAPH
 #endif      
       SUBROUTINE ZMUMPS_BUILD_LOC_GRAPH(id, ord, GSIZE, IPE, PE, LENG,
-     &     I_HALO_MAP, top_graph, WORK)
+     &     I_HALO_MAP, top_graph, WORK, LWORK)
       IMPLICIT NONE
       TYPE(ZMUMPS_STRUC)   :: id
       TYPE(ORD_TYPE)       :: ord
@@ -2329,6 +2420,7 @@ C
       INTEGER(8), POINTER  :: IPE(:)
       INTEGER, POINTER     :: PE(:), LENG(:),
      &     I_HALO_MAP(:), WORK(:)
+      INTEGER(8), INTENT(in) :: LWORK
       INTEGER              :: GSIZE
       INTEGER                :: IERR, MYID, NPROCS
       INTEGER                :: I, PROC, J, LOC_ROW
@@ -2355,13 +2447,13 @@ C
       nullify(TSENDI, TSENDJ, RCVBUF, APNT)
       MYID   = ord%MYID
       NPROCS = ord%NPROCS
-      IF(MUMPS_GETSIZE(WORK) .LT. N*2) THEN
+      IF( LWORK .LT. int(N,8)*2_8 ) THEN
          WRITE(LP,
      &        '("Insufficient workspace inside BUILD_LOC_GRAPH")')
          CALL MUMPS_ABORT()
       END IF
-      MAPTAB   => WORK(     1 :   N)
-      HALO_MAP => WORK(N+1 : 2*N)
+      MAPTAB   => WORK(      1    :         N   )
+      HALO_MAP => WORK(int(N+1,8) : 2_8*int(N,8))
       CALL MUMPS_I8REALLOC(SNDCNT, NPROCS, id%INFO, LP,
      &     MEMCNT=MEMCNT, ERRCODE=-7)
       CALL MUMPS_I8REALLOC(RCVCNT, NPROCS, id%INFO, LP,
@@ -2643,7 +2735,7 @@ C
       END SUBROUTINE ZMUMPS_BUILD_LOC_GRAPH
       SUBROUTINE ZMUMPS_LUMAT_TO_LOC_GRAPH 
      &     (LUMAT, id, ord, GSIZE, IPE, PE, LENG,
-     &     I_HALO_MAP, WORK)
+     &     I_HALO_MAP, WORK, LWORK)
       IMPLICIT NONE
       TYPE(LMATRIX_T), INTENT(IN) :: LUMAT
       TYPE(ZMUMPS_STRUC)   :: id
@@ -2651,6 +2743,7 @@ C
       INTEGER(8), POINTER  :: IPE(:)
       INTEGER, POINTER     :: PE(:), LENG(:),
      &     I_HALO_MAP(:), WORK(:)
+      INTEGER(8), INTENT(IN) :: LWORK
       INTEGER              :: GSIZE
       INTEGER                :: IERR, MYID, NPROCS
       INTEGER                :: I, PROC, J, LOC_ROW 
@@ -2674,13 +2767,13 @@ C
       nullify( RCVBUF, APNT)
       MYID   = ord%MYID
       NPROCS = ord%NPROCS
-      IF(MUMPS_GETSIZE(WORK) .LT. N) THEN
+      IF ( LWORK .LT.2_8 * int(N,8) ) THEN
          WRITE(LP,
      &   '("Insufficient workspace inside ZMUMPS_LUMAT_TO_LOC_GRAPH")')
          CALL MUMPS_ABORT()
       END IF
-      MAPTAB   => WORK(     1 :   N)
-      HALO_MAP => WORK(N+1 : 2*N)
+      MAPTAB   => WORK(       1    :         N   )
+      HALO_MAP => WORK( int(N+1,8) : 2_8*int(N,8))
       CALL MUMPS_I8REALLOC(SNDCNT, NPROCS, id%INFO, LP,
      &     MEMCNT=MEMCNT, ERRCODE=-7)
       CALL MUMPS_I8REALLOC(RCVCNT, NPROCS, id%INFO, LP,
@@ -3139,15 +3232,16 @@ C
       RETURN
       END SUBROUTINE ZMUMPS_BUILD_TREE
       SUBROUTINE ZMUMPS_GRAPH_DIST(id, ord, FIRST,
-     &     LAST, BASE, NPROCS, WORK, TYPE)
+     &     LAST, BASE, NPROCS, WORK, LWORK, TYPE)
       IMPLICIT NONE
-      TYPE(ZMUMPS_STRUC)   :: id
-      TYPE(ORD_TYPE)       :: ord
-      INTEGER              :: FIRST(:), LAST(:), BASE, NPROCS, TYPE
-      INTEGER, TARGET      :: WORK(:)
-      INTEGER, POINTER     :: TMP(:), NZ_ROW(:)
-      INTEGER              :: I, IERR, P, F, J
-      INTEGER(8)           :: LOCNNZ, INNZ, LOCOFFDIAG,
+      TYPE(ZMUMPS_STRUC)     :: id
+      TYPE(ORD_TYPE)         :: ord
+      INTEGER                :: FIRST(:), LAST(:), BASE, NPROCS, TYPE
+      INTEGER, TARGET        :: WORK(:)
+      INTEGER(8), INTENT(IN) :: LWORK
+      INTEGER, POINTER       :: TMP(:), NZ_ROW(:)
+      INTEGER                :: I, IERR, P, F, J
+      INTEGER(8)             :: LOCNNZ, INNZ, LOCOFFDIAG,
      &     OFFDIAG, T, SHARE
       DO I=0, BASE-1
          FIRST(I+1) = 0
@@ -3166,8 +3260,12 @@ C
             LAST (BASE+I) = N
          END DO
       ELSE IF (TYPE.EQ.2) THEN
+         IF (LWORK .LT. 2_8*int(N,8)) THEN
+           WRITE(*,*) "Insufficient workspace in ZMUMPS_GRAPH_DIST"
+           CALL MUMPS_ABORT()
+         ENDIF
          TMP    => WORK(1:N)
-         NZ_ROW => WORK(N+1:2*N)
+         NZ_ROW => WORK(int(N+1,8):2-8*int(N,8))
          TMP = 0
          LOCOFFDIAG = 0_8
          LOCNNZ = id%KEEP8(29)
@@ -3181,7 +3279,7 @@ C
                END IF
             END IF
          END DO
-         CALL MPI_ALLREDUCE(TMP(1), NZ_ROW(1), N,
+         CALL MUMPS_BIGALLREDUCE(.FALSE., TMP(1), NZ_ROW(1), N,
      &        MPI_INTEGER, MPI_SUM, ord%COMM, IERR)
          CALL MPI_ALLREDUCE(LOCOFFDIAG, OFFDIAG, 1,
      &        MPI_INTEGER8, MPI_SUM, ord%COMM, IERR)
@@ -3284,7 +3382,7 @@ C
       IF (L(N+1) == 0) THEN
          RETURN 
       ELSE
-         L(N+1) = iabs(L(N+1))
+         L(N+1) = abs(L(N+1))
       END IF
  200  CONTINUE
       S = 0
@@ -3371,7 +3469,7 @@ C
       IF (SIZE_VELOLOCTAB.EQ.VERTLOCNBR) THEN
        CALL MUMPS_PARMETIS_VWGT(FIRST(1+BASE), VERTLOCTAB_I4(1),
      &     EDGELOCTAB(1), BASEVAL, OPTIONS(1), ORDER(1),
-     &     SIZES(1), COMM, VELOLOCTAB, IERR)
+     &     SIZES(1), COMM, VELOLOCTAB(1), IERR)
       ELSE
        CALL MUMPS_PARMETIS(FIRST(1+BASE), VERTLOCTAB_I4(1),
      &     EDGELOCTAB(1), BASEVAL, OPTIONS(1), ORDER(1),
@@ -3421,7 +3519,7 @@ C
      &     EDGELOCTAB(1),
      &     BASEVAL, OPTIONS(1),
      &     ORDER(1),
-     &     SIZES(1), COMM, VELOLOCTAB, IERR)
+     &     SIZES(1), COMM, VELOLOCTAB(1), IERR)
        ELSE
         CALL MUMPS_PARMETIS_64(FIRST(1+BASE), VERTLOCTAB(1),
      &     EDGELOCTAB(1),
@@ -3469,7 +3567,7 @@ C
      &     BASEVAL_I8, OPTIONS_I8(1),
 #endif
      &     ORDER_I8(1),
-     &     SIZES_I8(1), COMM, VELOLOCTAB_I8,
+     &     SIZES_I8(1), COMM, VELOLOCTAB_I8(1),
      &     IERR)
        ELSE
         CALL MUMPS_PARMETIS_64(FIRST_I8(1+BASE), VERTLOCTAB(1),
@@ -3514,6 +3612,9 @@ C
      &     VERTLOCNBR, VERTLOCTAB,
      &     EDGELOCNBR, EDGELOCTAB, 
      &     VELOLOCTAB, SIZE_VELOLOCTAB,
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+     &             CONTDAT, LCONTDAT,
+#endif
      &     IERR)
       IMPLICIT NONE
       INCLUDE 'ptscotchf.h'
@@ -3532,6 +3633,11 @@ C
      &     ORDEDAT(SCOTCH_DORDERDIM), STRADAT(SCOTCH_STRATDIM),
      &     CORDEDAT(SCOTCH_ORDERDIM)
       CHARACTER  STRSTRING*1024
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+      INTEGER             :: LCONTDAT
+      DOUBLE PRECISION    :: CONTDAT(LCONTDAT)
+      DOUBLE PRECISION    :: GRAPHDAT_BEFORE_CONTEXT(SCOTCH_DGRAPHDIM)
+#endif
       IF (.NOT.ord%IDO) RETURN
       nullify(VERTLOCTAB_I4)
       CALL MUMPS_REALLOC(VERTLOCTAB_I4, VERTLOCNBR+1, id%INFO, LP,
@@ -3554,7 +3660,14 @@ C
       ELSE
          MYWORKID = -1
       END IF
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+      CALL MUMPS_DGRAPHINIT(GRAPHDAT_BEFORE_CONTEXT, ord%COMM_PARAORD,
+     &                      IERR)
+      CALL SCOTCHFCONTEXTBINDDGRAPH(CONTDAT, GRAPHDAT_BEFORE_CONTEXT,
+     &                              GRAPHDAT, IERR)
+#else
       CALL MUMPS_DGRAPHINIT(GRAPHDAT, ord%COMM_PARAORD, IERR)
+#endif
       IF(IERR.NE.0) THEN
          id%INFO(1:2) = -50
       END IF
@@ -3641,8 +3754,11 @@ C
       IF(MYWORKID .EQ. 0) 
      &     CALL SCOTCHFDGRAPHCORDEREXIT(GRAPHDAT, CORDEDAT)
       CALL SCOTCHFDGRAPHORDEREXIT(GRAPHDAT, ORDEDAT)
-      CALL SCOTCHFSTRATEXIT(STRADAT) 
+      CALL SCOTCHFSTRATEXIT(STRADAT)
       CALL SCOTCHFDGRAPHEXIT(GRAPHDAT)
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+      CALL SCOTCHFDGRAPHEXIT(GRAPHDAT_BEFORE_CONTEXT)
+#endif
  10   CONTINUE
       CALL MUMPS_DEALLOC(VERTLOCTAB_I4, MEMCNT=MEMCNT)
       RETURN
@@ -3652,6 +3768,9 @@ C
      &     VERTLOCNBR, VERTLOCTAB,
      &     EDGELOCNBR, EDGELOCTAB,
      &     VELOLOCTAB, SIZE_VELOLOCTAB,
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+     &             CONTDAT, LCONTDAT,
+#endif
      &     IERR)
       IMPLICIT NONE
       INCLUDE 'ptscotchf.h'
@@ -3669,6 +3788,11 @@ C
      &     ORDEDAT(SCOTCH_DORDERDIM), STRADAT(SCOTCH_STRATDIM),
      &     CORDEDAT(SCOTCH_ORDERDIM)
       CHARACTER  STRSTRING*1024
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+      INTEGER             :: LCONTDAT
+      DOUBLE PRECISION    :: CONTDAT(LCONTDAT)
+      DOUBLE PRECISION    :: GRAPHDAT_BEFORE_CONTEXT(SCOTCH_DGRAPHDIM)
+#endif
       INTEGER(8), POINTER :: EDGELOCTAB_I8(:), PERMTAB_I8(:),
      &     PERITAB_I8(:), RANGTAB_I8(:), TREETAB_I8(:), VELOLOCTAB_I8(:)
       INTEGER(8)          :: CBLKNBR_I8, VERTLOCNBR_I8, BASEVAL_I8
@@ -3722,7 +3846,14 @@ C
        ENDIF
        BASEVAL_I8    = int(BASEVAL,8)
       ENDIF
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+      CALL MUMPS_DGRAPHINIT(GRAPHDAT_BEFORE_CONTEXT, ord%COMM_PARAORD,
+     &                      IERR)
+      CALL SCOTCHFCONTEXTBINDDGRAPH(CONTDAT, GRAPHDAT_BEFORE_CONTEXT,
+     &                              GRAPHDAT, IERR)
+#else
       CALL MUMPS_DGRAPHINIT(GRAPHDAT, ord%COMM_PARAORD, IERR)
+#endif
       IF(IERR.NE.0) THEN
          id%INFO(1:2) = -50
       END IF
@@ -3828,16 +3959,20 @@ C
       CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &     ord%COMM_PARAORD, ord%MYID_PARAORD )
       IF ( id%INFO(1) .LT. 0 ) GOTO 10
+      IF(MYWORKID .EQ. 0) 
+     &     CALL SCOTCHFDGRAPHCORDEREXIT(GRAPHDAT, CORDEDAT)
       CALL SCOTCHFDGRAPHORDEREXIT(GRAPHDAT, ORDEDAT)
       CALL SCOTCHFSTRATEXIT(STRADAT) 
       CALL SCOTCHFDGRAPHEXIT(GRAPHDAT)
+#if defined(MUMPS_SCOTCHIMPORTOMPTHREADS)
+      CALL SCOTCHFDGRAPHEXIT(GRAPHDAT_BEFORE_CONTEXT)
+#endif
  10   CONTINUE
       IF (id%KEEP(10).NE.1) THEN
        CALL MUMPS_I8DEALLOC(EDGELOCTAB_I8, MEMCNT=MEMCNT)
        IF (SIZE_VELOLOCTAB.GT.0)
      & CALL MUMPS_I8DEALLOC(VELOLOCTAB_I8, MEMCNT=MEMCNT)
        IF(MYWORKID .EQ. 0) THEN
-         CALL SCOTCHFDGRAPHCORDEREXIT(GRAPHDAT, CORDEDAT)
          CALL MUMPS_ICOPY_64TO32(PERMTAB_I8(1),
      &        size(ord%PERMTAB), ord%PERMTAB(1))
          CALL MUMPS_ICOPY_64TO32(PERITAB_I8(1),
diff -pruN 5.6.2-2.1/src/zana_dist_m.F 5.7.1-1/src/zana_dist_m.F
--- 5.6.2-2.1/src/zana_dist_m.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/zana_dist_m.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -80,6 +80,8 @@ C
       INTEGER  ISTEP_TO_INIV2( KEEP(71) )
       LOGICAL  I_AM_CAND(NMB_PAR2)
       INTEGER  CANDIDATES( SLAVEF+1, NMB_PAR2 )
+      INTEGER  PHASE
+      PARAMETER (PHASE=0)
       DOUBLE PRECISION OPSA
       DOUBLE PRECISION OPSA_LOC 
       INTEGER(8) MAX_SIZE_FACTOR
@@ -144,10 +146,15 @@ C
       INTEGER :: FLAG_L0OMP
       PARAMETER (FLAG_L0OMP=-2014)
       INCLUDE 'mumps_headers.h'
+      LOGICAL ROOT_OWNER
+      INTEGER(8) LWK_RR
+      INTEGER LIWK_RR
+      INTEGER IROOT, SIZE_ROOT
       INTEGER WHAT
       INTEGER(4) :: I4
       INTEGER(8) IDUMMY8
-      INTRINSIC min, int, real
+      INTRINSIC min, int
+      INTRINSIC dble
       INTEGER ZMUMPS_OOC_GET_PANEL_SIZE
       EXTERNAL ZMUMPS_OOC_GET_PANEL_SIZE
       INTEGER MUMPS_PROCNODE, MUMPS_TYPENODE
@@ -410,7 +417,7 @@ C
      &                KEEP(494), 1, KEEP(490),
      &                KEEP(491), KEEP(492),
      &                KEEP(20), KEEP(60), DAD(STEP(INODE)), KEEP(38),
-     &                LRSTATUS, IDUMMY)
+     &                KEEP(123), LRSTATUS, IDUMMY)
       COMPRESS_PANEL = (LRSTATUS.GE.2)
       COMPRESS_CB    = ((LRSTATUS.EQ.1).OR.(LRSTATUS.EQ.3))
       IF (COMPRESS_PANEL.OR.COMPRESS_CB) NBNODES_BLR = NBNODES_BLR+1
@@ -720,9 +727,9 @@ C
              ENDIF
             ENDIF
          ENDIF
-         NIRNEC = max0(NIRNEC,
+         NIRNEC = max(NIRNEC,
      &             NIRADU+ISTKI+SIZECBI+MAXITEMPCB)
-         NIRNEC_OOC = max0(NIRNEC_OOC,
+         NIRNEC_OOC = max(NIRNEC_OOC,
      &             NIRADU_OOC+ISTKI_OOC+SIZECBI+MAXITEMPCB +
      &             (XSIZE_OOC-XSIZE_IC) ) 
          CURRENT_ACTIVE_MEM = ISTKR+SIZECBINFR
@@ -852,7 +859,7 @@ C
      &                KEEP(494), 1, KEEP(490),
      &                KEEP(491), KEEP(492),
      &                KEEP(20), KEEP(60), DAD(STEP(IFSON)), KEEP(38),
-     &                LRSTATUSS, IDUMMY)
+     &                KEEP(123), LRSTATUSS, IDUMMY)
                COMPRESS_CBS   = ((LRSTATUSS.EQ.1).OR.(LRSTATUSS.EQ.3))
                IF (COMPRESS_CBS) THEN
                  K465_8    = int(KEEP(465),8)
@@ -1448,8 +1455,8 @@ C
            LSTKR(ITOP) = SIZECB
            ISTKR = ISTKR + LSTKR(ITOP)
            NRLNEC = max(NRLNEC,NRLADU+ISTKR+MAXTEMPCB)
-           NIRNEC = max0(NIRNEC,NIRADU+ISTKI+MAXITEMPCB)
-           NIRNEC_OOC = max0(NIRNEC_OOC,NIRADU_OOC+ISTKI_OOC+
+           NIRNEC = max(NIRNEC,NIRADU+ISTKI+MAXITEMPCB)
+           NIRNEC_OOC = max(NIRNEC_OOC,NIRADU_OOC+ISTKI_OOC+
      &          MAXITEMPCB + 
      &          (XSIZE_OOC-XSIZE_IC) ) 
            NRLNEC_if_LR_LU    =  max(NRLNEC_if_LR_LU,
@@ -1482,6 +1489,73 @@ C
          ENDIF
       ENDIF 
  115  CONTINUE
+      IF ( KEEP(53) .NE. 0 ) THEN
+        IF ( KEEP(38) .ne. 0 ) THEN
+          IROOT = KEEP( 38 )
+        ELSE
+          IROOT = KEEP( 20 )
+        END IF
+        ROOT_OWNER = ( MYID .eq.
+     &  MUMPS_PROCNODE( PROCNODE(STEP(IROOT)), KEEP(199) ) )
+        SIZE_ROOT = ND(STEP(IROOT))+KEEP(253)
+        CALL ZMUMPS_SVD_QR_ESTIM_WK( PHASE, 
+     &       KEEP(51), KEEP(51), SIZE_ROOT,
+     &       LOCAL_M, LOCAL_N, ROOT_OWNER, KEEP,KEEP8,
+     &       LIWK_RR, LWK_RR )
+        IF ( NRLNEC-NRLADU .LT. LWK_RR ) THEN
+          NRLNEC = NRLADU + LWK_RR
+          NRLNEC_if_LR_LU   = NRLNEC_if_LR_LU + LWK_RR
+          NRLNEC_if_LR_CB   = NRLNEC_if_LR_CB + LWK_RR
+          NRLNEC_if_LR_LUCB = NRLNEC_if_LR_LUCB + LWK_RR
+          NRLNEC_ACTIVE     = NRLNEC_ACTIVE     + LWK_RR
+          NRLNECOOC_if_LR_LUCB = NRLNECOOC_if_LR_LUCB  + LWK_RR
+          PEAK_LRLU_UD = 
+     &             max(PEAK_LRLU_UD,
+     &             NRLNEC_if_LR_LU + NRLADULR_UD)
+          PEAK_OOC_LRLU_UD = 
+     &             max(PEAK_OOC_LRLU_UD,
+     &             NRLNEC_ACTIVE + NRLADULR_UD)
+          PEAK_OOC_LRLU_WC = 
+     &             max(PEAK_OOC_LRLU_WC,
+     &             NRLNEC_ACTIVE + NRLADULR_WC)
+          PEAK_LRLUCB_UD = 
+     &             max(PEAK_LRLUCB_UD,
+     &             NRLNEC_if_LR_LUCB + NRLNECLR_LUCB_UD)
+          PEAK_LRLUCB_WC = 
+     &             max(PEAK_LRLUCB_WC,
+     &             NRLNEC_if_LR_LUCB + NRLNECLR_LUCB_WC)
+          PEAK_OOC_LRLUCB_UD = 
+     &             max(PEAK_OOC_LRLUCB_UD,
+     &             NRLNECOOC_if_LR_LUCB + NRLNECLR_LUCB_UD)
+          PEAK_OOC_LRLUCB_WC = 
+     &             max(PEAK_OOC_LRLUCB_WC,
+     &             NRLNECOOC_if_LR_LUCB + NRLNECLR_LUCB_WC)
+          PEAK_LRCB_UD =
+     &             max(PEAK_LRCB_UD,
+     &             NRLNEC_if_LR_CB + NRLNECLR_CB_UD)
+          PEAK_OOC_LRCB_UD =
+     &             max(PEAK_OOC_LRCB_UD,
+     &             NRLNECOOC_if_LR_LUCB + NRLNECLR_CB_UD)
+          IF (ABOVE_L0) THEN
+           PEAK_DYN_LRLU_UD   = max( PEAK_DYN_LRLU_UD,
+     &          SIZECB_UNDER_L0 + NRLADULR_UD )
+           PEAK_DYN_LRCB_UD   = max( PEAK_DYN_LRCB_UD,
+     &          SIZECB_UNDER_L0_IF_LRCB + ISTKR_if_LRCB)
+           PEAK_DYN_LRLUCB_UD = max( PEAK_DYN_LRLUCB_UD,
+     &      SIZECB_UNDER_L0_IF_LRCB + ISTKR_if_LRCB + NRLADULR_UD)
+           PEAK_DYN_LRLU_WC   = max( PEAK_DYN_LRLU_WC,
+     &          SIZECB_UNDER_L0 + NRLADULR_WC)
+           PEAK_DYN_LRLUCB_WC = max( PEAK_DYN_LRLUCB_WC,
+     &          SIZECB_UNDER_L0 + ISTKRLR_CB_WC + NRLADULR_WC)
+          ENDIF
+        END IF
+        IF ( NIRNEC-NIRADU .LT. LIWK_RR ) THEN
+          NIRNEC = NIRADU + LIWK_RR
+        END IF
+        IF ( NIRNEC_OOC-NIRADU_OOC .LT. LIWK_RR ) THEN
+          NIRNEC_OOC = NIRADU_OOC + LIWK_RR
+        END IF
+      END IF
       NRLNEC = max(NRLNEC, NRLADU+int(KEEP(30),8))
       NRLNEC_ACTIVE = max(NRLNEC_ACTIVE, MAX_SIZE_FACTOR+
      &                    int(KEEP(30),8))
@@ -1938,7 +2012,7 @@ C
      &                KEEP(494), 1, KEEP(490),
      &                KEEP(491), KEEP(492),
      &                KEEP(20), KEEP(60), DAD(STEP(INODE)), KEEP(38),
-     &                LRSTATUS, IDUMMY)
+     &                KEEP(123), LRSTATUS, IDUMMY)
       COMPRESS_PANEL = (LRSTATUS.GE.2)
       COMPRESS_CB    = ((LRSTATUS.EQ.1).OR.(LRSTATUS.EQ.3))
       IF (COMPRESS_PANEL.OR.COMPRESS_CB) NBNODES_BLR = NBNODES_BLR+1
@@ -2010,9 +2084,9 @@ C
                NRLADU_if_LR_LU = NRLADU_if_LR_LU + NRLADU_CURRENT
       ENDIF
       SIZECBI        = 2* NCB  + SIZEHEADER
-      NIRNEC = max0(NIRNEC,
+      NIRNEC = max(NIRNEC,
      &             NIRADU+ISTKI+SIZECBI+MAXITEMPCB)
-      NIRNEC_OOC = max0(NIRNEC_OOC,
+      NIRNEC_OOC = max(NIRNEC_OOC,
      &             NIRADU_OOC+ISTKI_OOC+SIZECBI+MAXITEMPCB +
      &             (XSIZE_OOC-XSIZE_IC) ) 
       CURRENT_ACTIVE_MEM = ISTKR+SIZECBINFR
@@ -2243,8 +2317,8 @@ C
            LSTKR(ITOP) = SIZECB
            ISTKR = ISTKR + LSTKR(ITOP)
            NRLNEC = max(NRLNEC,NRLADU+ISTKR)
-           NIRNEC = max0(NIRNEC,NIRADU+ISTKI)
-           NIRNEC_OOC = max0(NIRNEC_OOC,NIRADU_OOC+ISTKI_OOC)
+           NIRNEC = max(NIRNEC,NIRADU+ISTKI)
+           NIRNEC_OOC = max(NIRNEC_OOC,NIRADU_OOC+ISTKI_OOC)
            NRLNEC_if_LR_LU  =  max(NRLNEC_if_LR_LU,
      &                             NRLADU_if_LR_LU+ISTKR)
            LSTKR_if_LRCB(ITOP) = SIZECB_if_LRCB
diff -pruN 5.6.2-2.1/src/zana_driver.F 5.7.1-1/src/zana_driver.F
--- 5.6.2-2.1/src/zana_driver.F	2023-10-11 09:37:10.000000000 +0000
+++ 5.7.1-1/src/zana_driver.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -48,15 +48,14 @@ C     Local variables
 C     ===============
 C     
 C     
-C     Pointers inside integer array, various data
-      INTEGER IKEEP, NE, NA
+C     Pointers inside integer array IKEEPALLOC, various data
+      INTEGER(8) IKEEP, NE, NA
       INTEGER I, allocok
 C     Other locals
       INTEGER NB_NIV2, IDEST
       INTEGER :: STATUS(MPI_STATUS_SIZE)
       INTEGER LOCAL_M, LOCAL_N
-      INTEGER numroc
-      EXTERNAL numroc
+      INTEGER, EXTERNAL :: MUMPS_NUMROC
       INTEGER IRANK
       INTEGER MP, LP, MPG
       LOGICAL PROK, PROKG, LISTVAR_SCHUR_2BE_FREED, LPOK
@@ -148,7 +147,7 @@ C     Element matrix entry
       INTEGER :: OOC_STRAT, BLR_STRAT
       INTEGER :: IDUMMY
       INTEGER, TARGET    :: IDUMMY_ARRAY(1)
-      INTEGER(8)                     :: NNZ_loc
+      INTEGER(8)                     :: NNZ_loc, NNZ_TMP
       INTEGER, POINTER, DIMENSION(:) :: IRN_loc_PTR
       INTEGER, POINTER, DIMENSION(:) :: JCN_loc_PTR
       INTEGER, POINTER, DIMENSION(:) :: IRN_PTR
@@ -158,6 +157,7 @@ C     Element matrix entry
       LOGICAL :: BDUMMY
       INTEGER(8) :: K8_33relaxed, K8_34relaxed, K8_35relaxed,
      &              K8_50relaxed
+!$    INTEGER :: NOMP, NOMPMAX, NOMPMIN
       LOGICAL :: SUM_OF_PEAKS
       INTEGER MUMPS_TYPENODE, MUMPS_PROCNODE
       EXTERNAL MUMPS_TYPENODE, MUMPS_PROCNODE
@@ -219,11 +219,16 @@ C
      &     NFSIZPTR,
      &     FREREPTR, NE_STEPSPTR,
      &     IKEEP1, IKEEP2, IKEEP3
-      INTEGER, ALLOCATABLE, DIMENSION(:) :: FILS_TMP, STEP_TMP, 
+#if defined(MUMPS_NOF2003)
+      INTEGER, POINTER, DIMENSION(:) ::  FILS_TMPPTR
+#endif
+      INTEGER, ALLOCATABLE, DIMENSION(:), TARGET :: FILS_TMP
+      INTEGER, ALLOCATABLE, DIMENSION(:) :: STEP_TMP,
      &                                      LRGROUPS_TMP
       INTEGER, ALLOCATABLE, DIMENSION(:), TARGET :: IKEEPALLOC
       INTEGER, ALLOCATABLE, DIMENSION(:) :: WORK2ALLOC
-      INTEGER :: SIZEIKEEPALLOC, SIZELRGROUPS_TMP
+      INTEGER :: SIZELRGROUPS_TMP
+      INTEGER(8) :: SIZEIKEEPALLOC, SIZEWORK2ALLOC
 C     NBINROW_TMP, NBINCOL_TMP are computed in ZMUMPS_ANA_DIST_N
 C     and used in ZMUMPS_ANA_DIST_ARROWHEADS
       INTEGER, ALLOCATABLE, DIMENSION(:) :: NBINROW_TMP, NBINCOL_TMP
@@ -233,7 +238,7 @@ C     and used in ZMUMPS_ANA_DIST_ARROWH
       INTEGER(kind=8) :: NZ8, LIW8
 C     NBLK : id%N or order of blocked matrix
       INTEGER :: NBLK, idNBLKSAVE
-      INTEGER :: LIW_ELT
+      INTEGER(8) :: LIW8_ELT
 C     GATHER_MATRIX_ALLOCATED: 
 C     To be sure that id%IRN and id%JCN are
 C     deallocated only when ZMUMPS_GATHER_MATRIX was called
@@ -407,8 +412,25 @@ C     Broadcast KEEP(251,252,253) define
       CALL MPI_BCAST( KEEP(251), 3, MPI_INTEGER,MASTER,id%COMM,IERR)
 C
       CALL MPI_BCAST( KEEP(400), 1, MPI_INTEGER,MASTER,id%COMM,IERR)
+!$    IF (id%KEEP(400).GT.0) THEN
+!$       NOMP = OMP_GET_MAX_THREADS()
+!$       CALL MPI_ALLREDUCE(NOMP,NOMPMIN,1,MPI_INTEGER,MPI_MIN,
+!$   &                      id%COMM,IERR)
+!$       CALL MPI_ALLREDUCE(NOMP,NOMPMAX,1,MPI_INTEGER,MPI_MAX,
+!$   &                      id%COMM,IERR)
+!$       IF ( NOMPMIN .NE. NOMPMAX ) THEN
+!$          IF (PROKG) THEN
+!$             WRITE(MPG, '(A,A,I4,A,I4,A)')
+!$   &  '      WARNING tree parallelism (ICNTL(48)) switched off', 
+!$   &  ' because of different number of threads per MPI proc (max ',
+!$   &         NOMPMAX, ', min ', NOMPMIN, ')'
+!$          ENDIF
+!$          KEEP(400) = 0
+!$       END IF
+!$      ENDIF 
       CALL MPI_BCAST( id%KEEP(490), 5, MPI_INTEGER, MASTER,
      &     id%COMM, IERR )
+      CALL MPI_BCAST( KEEP(123),1,MPI_INTEGER,MASTER,id%COMM,IERR)
 C     ----------------------------------------------
 C     Broadcast N 
 C     ----------------------------------------------
@@ -472,7 +494,7 @@ C     test IRN_loc and JCN_loc allocated
       id%MEM_DIST(0:id%NSLAVES-1) = 0
       CALL MUMPS_INIT_ARCH_PARAMETERS(
      &     id%COMM,id%COMM_NODES,KEEP(69),KEEP(46),
-     &     id%NSLAVES,id%MEM_DIST,INFO)
+     &     id%NSLAVES,id%MEM_DIST,INFO )
 C     ========================
 C     Write problem to a file,
 C     if requested by the user
@@ -708,23 +730,38 @@ C         ===================
 C{        Sequential analysis
 C         ===================
 C         =======================
-          IF (KEEP(54).NE.3) THEN
+          IF (KEEP(54).NE.3.OR.id%NPROCS.EQ.1) THEN
 C         =======================
 C{        Matrix structure available on host
+C         also case of distributed input matrix format 
+C         with one mpi proc
 C         ---------------------
            KEEP(14) = 0 
            IF (id%MYID.EQ.MASTER) THEN
 C            Store input matrix (IRN/JCN) as a cleaned blocked Lmatrix 
 C            of nodes (indices \in [1,NBLK])
-             IF (id%KEEP8(28) .EQ. 0_8) THEN
-               IRN_PTR => IDUMMY_ARRAY
-               JCN_PTR => IDUMMY_ARRAY
+             IF (KEEP(54).NE.3) THEN
+               IF (id%KEEP8(28) .EQ. 0_8) THEN
+                 IRN_PTR => IDUMMY_ARRAY
+                 JCN_PTR => IDUMMY_ARRAY
+               ELSE
+                 IRN_PTR => id%IRN
+                 JCN_PTR => id%JCN
+               ENDIF
+               NNZ_TMP = id%KEEP8(28) 
              ELSE
-               IRN_PTR => id%IRN
-               JCN_PTR => id%JCN
-             ENDIF
+               IF (id%KEEP8(29) .EQ. 0_8) THEN ! NNZ_loc or NZ_loc
+                 IRN_PTR => IDUMMY_ARRAY
+                 JCN_PTR => IDUMMY_ARRAY
+                 id%KEEP8(29) = 0_8
+               ELSE
+                 IRN_PTR => id%IRN_loc
+                 JCN_PTR => id%JCN_loc
+               ENDIF
+               NNZ_TMP = id%KEEP8(29) 
+             ENDIF 
              CALL MUMPS_AB_COORD_TO_LMAT ( id%MYID,
-     &             NBLK, id%N, id%KEEP8(28), IRN_PTR(1), JCN_PTR(1),
+     &             NBLK, id%N, NNZ_TMP, IRN_PTR(1), JCN_PTR(1),
      &             DOF2BLOCK, 
      &             INFO(1), INFO(2), LP, LPOK, 
      &             LMAT_BLOCK, IDUMMY8, KEEP(1) )
@@ -742,7 +779,7 @@ C            symmetrizing the Lmatrix
      &            INFO(1), ICNTL(1), MEMCNT)
              GCOMP_PROVIDED = .TRUE.
              IF (KEEP(494).EQ.0.OR.KEEP(487).NE.1) THEN
-               CALL MUMPS_AB_FREE_LMAT(LMAT_BLOCK)
+               CALL MUMPS_AB_FREE_LMAT(LMAT_BLOCK, KEEP(147))
                LMAT_BLOCK_AVAIL_I = 0
              ELSE
                LMAT_BLOCK_AVAIL_I = 1
@@ -801,7 +838,7 @@ C             Build GCOMP, the centraliz
      &             LUMAT, LUMAT_AVAIL, GCOMP_DIST, READY_FOR_ANA_F)
             ENDIF
             IF (LUMAT_AVAIL.AND.KEEP(487).NE.1) THEN
-               CALL MUMPS_AB_FREE_LMAT(LUMAT)
+               CALL MUMPS_AB_FREE_LMAT(LUMAT, KEEP(147))
                LUMAT_AVAIL = .FALSE.
             ENDIF
 C        
@@ -839,6 +876,8 @@ C     Collect on the host -- if matrix i
 C     at analysis -- all integer information needed
 C     to perform ordering
 C     -----------------------------------------------
+C FIXME: one should test instead if GCOMP_DIST available 
+C        instead of retestinf KEEP(13) and NPROCS.NE.1
           IF (KEEP(13).NE.0) THEN
            IF (id%NPROCS.NE.1) THEN
              CALL MUMPS_AB_GATHER_GRAPH(
@@ -914,14 +953,15 @@ C                Maximum transversal is
 C                entry format
 C              UNS_PERM that might be set to
 C              to permutation computed during Max transversal
-               ALLOCATE(id%UNS_PERM(id%N),IKEEPALLOC(3*id%N),
+               ALLOCATE(id%UNS_PERM(id%N),IKEEPALLOC(3_8*int(id%N,8)),
      &                  WORK2ALLOC(id%N), stat=IERR)
                IF (IERR.GT.0) THEN
                 INFO(1)=-7
-                INFO(2)=5*id%N
+                CALL MUMPS_SET_IERROR( 5_8 * int(id%N,8), INFO(2) )
                ELSE
                 CALL ZMUMPS_ANA_O(id%N, id%KEEP8(28), KEEP(23),
-     &              id%UNS_PERM, IKEEPALLOC, id%IRN, id%JCN, id%A,
+     &              id%UNS_PERM, IKEEPALLOC, 3_8*int(id%N,8),
+     &              id%IRN, id%JCN, id%A,
      &              id%ROWSCA, id%COLSCA,
      &              WORK2ALLOC, id%KEEP, id%ICNTL, id%INFO, id%INFOG)
                 IF (allocated(WORK2ALLOC)) DEALLOCATE(WORK2ALLOC)
@@ -966,15 +1006,16 @@ C          be given to ANA_F.
      &               NFSIZPTR(NBLK), stat=IERR)
              IF (IERR.GT.0) THEN
               INFO(1)=-7
-              INFO(2)=3*NBLK
+              CALL MUMPS_SET_IERROR(int(NBLK,8)*3_8, INFO(2))
              ENDIF
            ELSE
-             ALLOCATE(IKEEPALLOC(NBLK+2*id%N), 
+             ALLOCATE(IKEEPALLOC(int(NBLK,8)+2_8*int(id%N,8)), 
      &               FILS_TMP(NBLK), FREREPTR(NBLK),
      &               NFSIZPTR(NBLK), stat=IERR)
             IF (IERR.GT.0) THEN
              INFO(1)=-7
-             INFO(2)=4*NBLK+2*id%N
+             CALL MUMPS_SET_IERROR(int(NBLK,8)*4_8+2_8*int(id%N,8),
+     &            INFO(2))
             ENDIF
            ENDIF
          ENDIF
@@ -1038,19 +1079,20 @@ C
 C                 we suppress supervariable detection when Schur
 C                 is active or when METIS is applied
 C                 Workspaces for FLAG(N), and either LEN(N) or some pointers(N+1)
-                  LIW_ELT = id%N + id%N + 1
+                  LIW8_ELT = int(id%N,8) + int(id%N,8) + 1_8
                ELSE
 C                 Spaces FLAG(N), LEN(N), N+3, SVAR(0:N),
-                  LIW_ELT =  id%N + id%N + id%N + 3 + id%N + 1
+                  LIW8_ELT =  int(id%N,8) + int(id%N,8) +
+     &                       int(id%N,8)+3_8 + int(id%N,8)+1_8
                ENDIF
 C     
             ENDIF
 C           We must ensure that an array of order
 C           3*N is available for ZMUMPS_ANA_LNEW
             IF (KEEP(55) .EQ. 0) THEN
-              IF (LIW8.LT.3_8*int(NBLK,8)) LIW8 = 3_8*int(NBLK,8)
+              IF (LIW8.LT.3_8*int(NBLK,8)) LIW8=3_8*int(NBLK,8)
             ELSE
-              IF (LIW_ELT.LT.3*id%N) LIW_ELT = 3*id%N
+              IF (LIW8_ELT.LT.3_8*int(id%N,8)) LIW8_ELT=3_8*int(id%N,8)
             ENDIF
 C
             IF ( KEEP(256) .EQ. 1 ) THEN
@@ -1058,7 +1100,7 @@ C            It has been checked that id
 C            values of pivot order will be checked later and
 C            should be checked here too
 C            PERM_IN( I ) = position of I in the pivot order
-             IKEEP2 => IKEEPALLOC(NBLK+1:NBLK+id%N)
+             IKEEP2 => IKEEPALLOC(int(NBLK+1,8):int(NBLK,8)+int(id%N,8))
 C            Build inverse permutation and check PERM_IN 
              DO I = 1, id%N
                 IKEEP2(I) = 0
@@ -1100,6 +1142,11 @@ C             IKEEP2 holds inverse permu
                   I       = IKEEP2(IPOS)
                   IB      = DOF2BLOCK(I)
                   IF (IB.NE.IBcurrent) THEN
+                   IF (PROKG) THEN
+                    WRITE(MPG,'(A,A)') 
+     &               " ERROR: given permutation (ICNTL(7)=1)",
+     &               " incompatible with block format"
+                   ENDIF
                    INFO(1)= -4
                    INFO(2)= I
                    GOTO 10
@@ -1111,6 +1158,11 @@ C             IKEEP2 holds inverse permu
 C             IF PERM_IN is correct then
 C             on exit last position should be NBLK
               IF (IPOSB.NE.NBLK) THEN
+                   IF (PROKG) THEN
+                    WRITE(MPG,'(A,A)') 
+     &               " ERROR: given permutation (ICNTL(7)=1)",
+     &               " incompatible with block format"
+                   ENDIF
                    INFO(1)= -4
 C                  N+1 to indicate "global" error
                    INFO(2)= id%N+1
@@ -1129,8 +1181,10 @@ C           Initialize structural symmet
             INFOG(8) = -1
             IF (KEEP(55) .EQ. 0) THEN
                IKEEP1 => IKEEPALLOC(1:NBLK)
-               IKEEP2 => IKEEPALLOC(NBLK+1:NBLK+id%N)
-               IKEEP3 => IKEEPALLOC(NBLK+id%N+1:NBLK+2*id%N)
+               IKEEP2 => IKEEPALLOC(int(NBLK+1,8):
+     &                              int(NBLK,8)+int(id%N,8))
+               IKEEP3 => IKEEPALLOC(int(NBLK,8)+int(id%N+1,8):
+     &                              int(NBLK,8)+2_8*int(id%N,8))
 C              id%UNS_PERM corresponds to argument PIV
 C              in ZMUMPS_ANA_F, it should be an assumed-shape
 C              array rather than a possibly null pointer:
@@ -1144,7 +1198,8 @@ C              array rather than a possi
      &              id%IRN, id%JCN,
      &              LIW8, IKEEP1, IKEEP2, IKEEP3,
      &              KEEP(256), NFSIZPTR,
-     &              FILS_TMP, FREREPTR,
+     &              FILS_TMP,
+     &              FREREPTR,
      &              id%LISTVAR_SCHUR, SIZE_SCHUR_PASSED,
      &              id%ICNTL, id%INFOG, id%KEEP,id%KEEP8,id%NSLAVES, 
      &              UNS_PERM_PTR,
@@ -1204,7 +1259,7 @@ C     -- internal error
                   GOTO 10
                ENDIF
                CALL ZMUMPS_ANA_F_ELT(id%N, NELT,
-     &              id%ELTPTR(1), id%ELTVAR(1), LIW_ELT,
+     &              id%ELTPTR(1), id%ELTVAR(1), LIW8_ELT,
      &              IKEEPALLOC(1),
      &              KEEP(256), NFSIZPTR(1), FILS_TMP(1),
      &              FREREPTR(1), id%LISTVAR_SCHUR(1),
@@ -1238,9 +1293,9 @@ C           ----------------------------
             INFO(2)=INFOG(2)
 C           save statistics in KEEP array.
             KEEP(28) = INFOG(6)
-            IKEEP = 1
-            NA      = IKEEP +     id%N
-            NE      = IKEEP + 2 * id%N
+            IKEEP = 1_8
+            NA      = IKEEP +       int(id%N,8)
+            NE      = IKEEP + 2_8 * int(id%N,8)
 C       -- if (id%myid.eq.master)
         ENDIF
 C       -- if sequential analysis
@@ -1302,24 +1357,34 @@ C{    Parallel analysis
 C             KEEPALLOC reuse later 
 C             FIXME allocate of size 2*NBLK and 
 C                   allocate of size 3*id%N after call ana_aux_par
-              SIZEIKEEPALLOC = 3*id%N
+              SIZEIKEEPALLOC = 3_8*int(id%N,8)
+              SIZEWORK2ALLOC = max(4_8*int(NBLK,8), int(id%NPROCS+1,8))
             ALLOCATE( IKEEPALLOC(SIZEIKEEPALLOC), 
-     &                WORK2ALLOC(max(4*NBLK,id%NPROCS+1)), 
+     &                WORK2ALLOC(SIZEWORK2ALLOC),
      &                FILS_TMP(NBLK), FREREPTR(NBLK), NFSIZPTR(NBLK),
      &      stat=IERR)
          ELSE IF (COMM_PARASYMB.NE.MPI_COMM_NULL) THEN
 C           Allocate only on procs concerned by parallel analysis
-            ALLOCATE(IKEEPALLOC(3*NBLK),WORK2ALLOC(4*NBLK), stat=IERR )
+            SIZEIKEEPALLOC = 3_8*int(NBLK,8)
+            SIZEWORK2ALLOC = 4_8*int(NBLK,8)
+            ALLOCATE(IKEEPALLOC(SIZEIKEEPALLOC),
+     &               WORK2ALLOC(SIZEWORK2ALLOC), stat=IERR )
          ELSE
 C           Not concerned by ZMUMPS_ANA_F_PAR
             IERR = 0
+            SIZEIKEEPALLOC = 0_8
+            SIZEWORK2ALLOC = 0_8
          ENDIF
          IF (IERR.GT.0) THEN
            INFO(1) = -7
            IF (id%MYID .EQ. MASTER) THEN
-             INFO( 2 ) = SIZEIKEEPALLOC+7*NBLK
+             CALL MUMPS_SET_IERROR(
+     &            SIZEIKEEPALLOC+SIZEWORK2ALLOC+3_8*int(NBLK,8),
+     &            INFO(2) )
            ELSE
-             INFO( 2 ) = 7*NBLK
+             CALL MUMPS_SET_IERROR(
+     &            SIZEIKEEPALLOC+SIZEWORK2ALLOC,
+     &            INFO(2) )
            ENDIF
          ENDIF
          CALL MUMPS_PROPINFO( ICNTL(1), INFO(1), id%COMM, id%MYID )
@@ -1327,6 +1392,16 @@ C           Not concerned by ZMUMPS_ANA_
 C        save value provided by user
          idNBLKSAVE= id%NBLK
 C
+#if defined(MUMPS_NOF2003)
+C        Allocatable not allowed in ZMUMPS_ANA_F_PAR,
+C        use a pointer instead. FILS_TMP is typically
+C        allocated only on MPI rank 0.
+         IF (allocated(FILS_TMP)) THEN
+           FILS_TMPPTR => FILS_TMP
+         ELSE
+           FILS_TMPPTR => IDUMMY_ARRAY
+         ENDIF
+#endif
          IF (LUMAT_AVAIL) THEN
 C{
 C             
@@ -1336,18 +1411,24 @@ C
             CALL ZMUMPS_ANA_F_PAR(id,
      &        IKEEPALLOC,
      &        WORK2ALLOC,
+     &        SIZEIKEEPALLOC,
+     &        SIZEWORK2ALLOC,
      &        NFSIZPTR,
+#if defined(MUMPS_NOF2003)
+     &        FILS_TMPPTR,
+#else
      &        FILS_TMP,
+#endif
      &        FREREPTR,
      &        COMM_PARASYMB
-!    optionnal:
+!    optional:
      &        , LUMAT, SIZEOFBLOCKS
      &        , COMM_PARAORD, NPROCS_PARAORD
      &        , RKinSYMB_PROC0ORD
      & )
            ENDIF
            IF (KEEP(494).EQ.0.OR.KEEP(487).NE.1) THEN
-            CALL MUMPS_AB_FREE_LMAT(LUMAT)
+            CALL MUMPS_AB_FREE_LMAT(LUMAT,KEEP(147))
             LUMAT_AVAIL = .FALSE.
            ELSE
             LUMAT_AVAIL = .TRUE.
@@ -1360,8 +1441,14 @@ C{         LUMAT not available and COMM_
            CALL ZMUMPS_ANA_F_PAR(id,
      &        IKEEPALLOC,
      &        WORK2ALLOC,
+     &        SIZEIKEEPALLOC,
+     &        SIZEWORK2ALLOC,
      &        NFSIZPTR,
+#if defined(MUMPS_NOF2003)
+     &        FILS_TMPPTR,
+#else
      &        FILS_TMP,
+#endif
      &        FREREPTR,
      &        id%COMM
      & )
@@ -1392,9 +1479,9 @@ C        Check error after freeing commu
          IF ( INFO(1) < 0 ) GOTO 500
 C
          IF (id%MYID.EQ.MASTER) THEN
-           IKEEP   = 1
-           NA      = IKEEP +     id%N
-           NE      = IKEEP + 2 * id%N 
+           IKEEP   = 1_8
+           NA      = IKEEP +       int(id%N,8)
+           NE      = IKEEP + 2_8 * int(id%N,8)
          ENDIF
 C        ---------------------------------------------------------
 C        Check whether FILS_TMP, FREREPTR, NFSIZPTR
@@ -1413,7 +1500,7 @@ C              allways copied back in st
           IF (IERR.GT.0) THEN
            INFO(1) = -7
            IF (id%MYID .EQ. MASTER) THEN
-             INFO( 2 ) = 3*id%N
+             CALL MUMPS_SET_IERROR(3_8*int(id%N,8), INFO(2))
            ENDIF
          ENDIF
          CALL MUMPS_PROPINFO( ICNTL(1), INFO(1), id%COMM, id%MYID )
@@ -1530,7 +1617,7 @@ C      peak is set by default to 1 large
      &        dble(id%KEEP(2))*dble(id%KEEP(2))     ! cb bloc
 C     IKEEP(1:N,1) can be used as a work space since it is set
 C     to its final state by the SORT_PERM subroutine below.
-            SSARBR => IKEEPALLOC(IKEEP:IKEEP+NBLK-1)
+            SSARBR => IKEEPALLOC(IKEEP:IKEEP+int(NBLK-1,8))
 C     ======================================================
 C     Map nodes and assign candidates for dynamic scheduling
 C     ======================================================
@@ -1864,15 +1951,15 @@ C     (the two useful informations for f
          IF (NBLK.eq.1) THEN
             NBROOT = 1
             NBLEAF = 1
-         ELSE IF (IKEEPALLOC(NA+NBLK-1) .LT.0) THEN
+         ELSE IF (IKEEPALLOC(NA+int(NBLK-1,8)) .LT.0) THEN
             NBLEAF= NBLK
             NBROOT= NBLK
-         ELSE IF (IKEEPALLOC(NA+NBLK-2) .LT.0) THEN
+         ELSE IF (IKEEPALLOC(NA+int(NBLK-2,8)) .LT.0) THEN
             NBLEAF = NBLK-1
-            NBROOT = IKEEPALLOC(NA+NBLK-1)
+            NBROOT = IKEEPALLOC(NA+int(NBLK-1,8))
          ELSE
-            NBLEAF = IKEEPALLOC(NA+NBLK-2)
-            NBROOT = IKEEPALLOC(NA+NBLK-1)
+            NBLEAF = IKEEPALLOC(NA+int(NBLK-2,8))
+            NBROOT = IKEEPALLOC(NA+int(NBLK-1,8))
          ENDIF
          id%LNA = 2+NBLEAF+NBROOT
       ENDIF
@@ -1897,26 +1984,26 @@ C        Initialize NA with the leaves a
          IF ( NBLK == 1 ) THEN
             id%NA(LEAF) = 1
             LEAF = LEAF + 1
-         ELSE IF (IKEEPALLOC(NA+NBLK-1) < 0) THEN
-            id%NA(LEAF) = - IKEEPALLOC(NA+NBLK-1)-1
+         ELSE IF (IKEEPALLOC(NA+int(NBLK-1,8)) < 0) THEN
+            id%NA(LEAF) = - IKEEPALLOC(NA+int(NBLK-1,8))-1
             LEAF = LEAF + 1
             DO I = 1, NBLEAF - 1
-               id%NA(LEAF) = IKEEPALLOC(NA+I-1)
+               id%NA(LEAF) = IKEEPALLOC(NA+int(I-1,8))
                LEAF = LEAF + 1
             ENDDO
-         ELSE IF (IKEEPALLOC(NA+NBLK-2) < 0 ) THEN
-            INODE = - IKEEPALLOC(NA+NBLK-2) - 1
+         ELSE IF (IKEEPALLOC(NA+int(NBLK-2,8)) < 0 ) THEN
+            INODE = - IKEEPALLOC(NA+int(NBLK-2,8)) - 1
             id%NA(LEAF) = INODE
             LEAF =LEAF + 1
             IF ( NBLEAF > 1 ) THEN
                DO I = 1, NBLEAF - 1
-                  id%NA(LEAF) = IKEEPALLOC(NA+I-1)
+                  id%NA(LEAF) = IKEEPALLOC(NA+int(I-1,8))
                   LEAF = LEAF + 1
                ENDDO
             ENDIF
          ELSE
             DO I = 1, NBLEAF
-               id%NA(LEAF) = IKEEPALLOC(NA+I-1)
+               id%NA(LEAF) = IKEEPALLOC(NA+int(I-1,8))
                LEAF = LEAF + 1
             ENDDO
          END IF
@@ -1963,8 +2050,8 @@ C        copies to NSTEP array should be
             IF (FREREPTR(I) .NE. NBLK+1) THEN
                id%PROCNODE_STEPS(STEP_TMP(I)) = PROCNODE( I )
                id%FRERE_STEPS(STEP_TMP(I))    = FREREPTR(I)
-               id%NE_STEPS(STEP_TMP(I))    = IKEEPALLOC(NE+I-1)
-               id%ND_STEPS(STEP_TMP(I))    = NFSIZPTR(I)
+               id%NE_STEPS(STEP_TMP(I)) = IKEEPALLOC(NE+int(I-1,8))
+               id%ND_STEPS(STEP_TMP(I)) = NFSIZPTR(I)
             ENDIF
          ENDDO
 C        ===============================
@@ -2039,6 +2126,7 @@ C         Broadcast errors
 C
           CALL MUMPS_INIALIZE_REDIST_LUMAT ( 
      &     id%INFO, id%ICNTL, id%KEEP, id%COMM, id%MYID, NBLK,
+     &     id%NPROCS,
      &     LUMAT, id%PROCNODE_STEPS(1), id%KEEP(28), MAPCOL, 
      &     LUMAT_REMAP, NBRECORDS, STEP_TMP(1))
 C         INFO(1) has been broadcasted already in routine
@@ -2053,7 +2141,7 @@ C         -- Redistribute LUMAT into LU_
      &      LUMAT_REMAP, NBRECORDS, NSEND8, NLOCAL8
      &     )
            LUMAT_REMAP_DIST_AVAIL = .TRUE.
-          CALL MUMPS_AB_FREE_LMAT(LUMAT)
+          CALL MUMPS_AB_FREE_LMAT(LUMAT,KEEP(147))
 C         Distribute SIZEOFBLOCKS that was defined only on master
           CALL MPI_BCAST( SIZEOFBLOCKS, NBLK, MPI_INTEGER, MASTER, 
      &     id%COMM, IERR )
@@ -2062,12 +2150,14 @@ C}
 C{        Centralized matrix and clean LMAT_BLOCK available
 C        
           IF (id%MYID.EQ.MASTER) THEN
+C
            CALL MUMPS_AB_CLEANLMAT_TO_LUMAT ( 
-     &              LMAT_BLOCK, LUMAT_REMAP,
+     &              LMAT_BLOCK, LUMAT_REMAP, KEEP(147),
      &              INFO(1), ICNTL(1))
            LUMAT_REMAP_CENT_AVAIL=.TRUE.
 C            --- LMAT_BLOCK not needed anymore
-           CALL MUMPS_AB_FREE_LMAT(LMAT_BLOCK)
+           CALL MUMPS_AB_FREE_LMAT(LMAT_BLOCK,KEEP(147))
+C
           ENDIF
 C         Broadcast errors
           CALL MUMPS_PROPINFO( ICNTL(1), INFO(1),
@@ -2170,6 +2260,8 @@ C         Broadcast errors
           CALL MUMPS_PROPINFO( ICNTL(1), INFO(1),
      &      id%COMM, id%MYID )
           IF ( INFO(1).LT.0 ) GOTO 500
+          CALL MPI_BCAST( id%ND_STEPS(1), KEEP(28), MPI_INTEGER,
+     &    MASTER, id%COMM, IERR )
           CALL ZMUMPS_AB_LR_MPI_GROUPING(NBLK, 
      &           MAPCOL, id%KEEP(28), 
      &           id%KEEP(28), LUMAT_REMAP, FILS_TMP(1), 
@@ -2182,7 +2274,8 @@ C         Broadcast errors
      &           id%KEEP(264), id%KEEP(265), id%KEEP(482), id%KEEP(472),
      &           id%KEEP(127), id%KEEP(469), id%KEEP(10), 
      &           id%KEEP(54), id%KEEP(142), 
-     &           LPOK, LP, id%COMM, id%MYID, id%NPROCS)
+     &           LPOK, LP, id%COMM, id%MYID, id%NPROCS,
+     &           id%KEEP(1), id%ND_STEPS)
           IF (allocated(MAPCOL)) DEALLOCATE(MAPCOL)
           IF (id%MYID.NE.MASTER) DEALLOCATE(FILS_TMP)
 C}
@@ -2204,7 +2297,8 @@ C
      &           id%KEEP(264), id%KEEP(265), id%KEEP(482), id%KEEP(472),
      &           id%KEEP(127), id%KEEP(469), id%KEEP(10), 
      &           id%KEEP(54), id%KEEP(142), 
-     &           LPOK, LP, id%COMM, id%MYID, id%NPROCS)
+     &           LPOK, LP, id%COMM, id%MYID, id%NPROCS,
+     &           id%KEEP(1), id%ND_STEPS)
 C}
             ELSE
 C{           grouping based on centralized matrix
@@ -2221,7 +2315,8 @@ C{           grouping based on centraliz
      &           id%KEEP(264), id%KEEP(265), id%KEEP(482), id%KEEP(472),
      &           id%KEEP(127), id%KEEP(10), 
      &           id%KEEP(54), id%KEEP(142), 
-     &           LPOK, LP, GATHER_MATRIX_ALLOCATED)
+     &           LPOK, LP, GATHER_MATRIX_ALLOCATED, 
+     &           id%KEEP(1), id%ND_STEPS)
              ELSE
                CALL ZMUMPS_LR_GROUPING_NEW(id%N, id%KEEP8(28), 
      &           id%KEEP(28), id%IRN,
@@ -2234,7 +2329,8 @@ C{           grouping based on centraliz
      &           id%KEEP(264), id%KEEP(265), id%KEEP(482), id%KEEP(472),
      &           id%KEEP(127), id%KEEP(469), id%KEEP(10), 
      &           id%KEEP(54), id%KEEP(142), 
-     &           LPOK, LP, GATHER_MATRIX_ALLOCATED)
+     &           LPOK, LP, GATHER_MATRIX_ALLOCATED,
+     &           id%KEEP(1), id%ND_STEPS)
              ENDIF
 C}
             ENDIF
@@ -2251,7 +2347,7 @@ C     III/ CLEANUP
 C     ============
 C       Free LUMAT_REMAP if allocated
         IF (LUMAT_REMAP_DIST_AVAIL.OR.LUMAT_REMAP_CENT_AVAIL)
-     &      CALL MUMPS_AB_FREE_LMAT(LUMAT_REMAP)
+     &      CALL MUMPS_AB_FREE_LMAT(LUMAT_REMAP,KEEP(147))
         IF (allocated(MAPCOL)) DEALLOCATE(MAPCOL)
         IF (allocated(SIZEOFBLOCKS)) DEALLOCATE(SIZEOFBLOCKS)
         IF ( (KEEP(54).EQ.3) .AND. (KEEP(244).EQ.2).AND.
@@ -2343,7 +2439,7 @@ C           and update arrays of size NS
      &           ) 
             NULLIFY(PAR2_NODESPTR)
 C
-C
+C         }
           ELSE
 C{           NBLK=N
 C            perform local copies
@@ -2376,6 +2472,17 @@ C          and not used/initialized
           ENDIF
 C}
         ENDIF
+C
+C       -------------------------------------------
+C       Adjust LR_GROUPING to bound size of groups 
+C       and update KEEP(142): maximum group size
+C       -------------------------------------------
+        IF (id%N.GT.NBLK.AND.KEEP(494).NE.0) THEN
+          CALL MUMPS_ADJUST_SIZE_LRGROUPS ( 
+     &     id%STEP(1), id%FILS(1), id%N, 
+     &     id%ND_STEPS(1), id%KEEP(28), id%KEEP(1), 
+     &     id%LRGROUPS(1), INFO(1), INFO(2))
+         ENDIF
 C}
       ENDIF
 C
@@ -2385,6 +2492,7 @@ C
       IF (allocated(LRGROUPS_TMP)) DEALLOCATE(LRGROUPS_TMP)
       IF (allocated(FILS_TMP)) DEALLOCATE(FILS_TMP)
 C
+C
         CALL MUMPS_REALLOC(id%SYM_PERM, id%N, id%INFO, LP, 
      &  FORCE=.TRUE.,
      &  STRING='id%SYM_PERM (Analysis)', ERRCODE=-7)
@@ -3245,11 +3353,11 @@ C           and allocate CANDIDATES
 C           ===================================================
 C     
             IF ( id%root%yes ) THEN
-              LOCAL_M = numroc( id%ND_STEPS(id%STEP(KEEP(38))),
+              LOCAL_M = MUMPS_NUMROC( id%ND_STEPS(id%STEP(KEEP(38))),
      &              id%root%MBLOCK, id%root%MYROW, 0,
      &              id%root%NPROW )
               LOCAL_M = max(1, LOCAL_M)
-              LOCAL_N = numroc( id%ND_STEPS(id%STEP(KEEP(38))),
+              LOCAL_N = MUMPS_NUMROC( id%ND_STEPS(id%STEP(KEEP(38))),
      &              id%root%NBLOCK, id%root%MYCOL, 0,
      &              id%root%NPCOL )
             ELSE
@@ -3636,9 +3744,7 @@ C
 C            Convert SUM_NIRNEC SUM_NIRNEC_OOC into nb of reals 
              PEAK_ABOVE_L0 =  KEEP8(53)+ SUM_NRLADU + 
      &            ! SEND buffer
-     &              max ( int( 
-     &              (dble(SBUF_SEND_FR)*dble(KEEP(34)))/dble(KEEP(35))
-     &                     , 8), 100000_8 ) +
+     &            max( int(SBUF_SEND_FR,8),  100000_8) +
      &            ! MAXIS_above :
      &             int( 
      &              (dble(KEEP(15))*dble(KEEP(34)))/dble(KEEP(35)),
@@ -3672,7 +3778,7 @@ C            SUM_NIRNEC_OOC under L0 OMP
 C           DKEEP(15) is used for dynamic load balancing only
 C           it corresponds to the number of local operations
 C           (in Millions)
-            id%DKEEP(15)    = RINFO(1)/1000000.0
+            id%DKEEP(15)    = RINFO(1)/1000000.0D0
             IF(ASSOCIATED(locI_AM_CAND)) NULLIFY(locI_AM_CAND)
             id%MAX_SURF_MASTER = KEEP8(15)
 C
@@ -3737,7 +3843,10 @@ C
          UPDATE_BUFFER = .TRUE.
 C
          MIN_BUF_SIZE8 = KEEP8(22) / int(KEEP(238),8)
-         MIN_BUF_SIZE8 = min(MIN_BUF_SIZE8,int(huge(I4),8))
+C        MIN_BUF_SIZE8 is in number of entries of size (KEEP(35) bytes)
+C        and max buffer size in bytes is an integer*4
+         MIN_BUF_SIZE8 = min(MIN_BUF_SIZE8,
+     &                       int(huge(I4),8)/int(KEEP(35),8) )
          MIN_BUF_SIZE  = int( MIN_BUF_SIZE8 )
          IF (UPDATE_BUFFER) THEN
 C          Send buffer 
@@ -3893,7 +4002,7 @@ C     Per compute node factor real space
       CALL MPI_REDUCE( SUM_KEEP811_THIS_NODE, MAX_SUM_KEEP811_THIS_NODE,
      &                 1, MPI_INTEGER8, MPI_MAX, 0, id%COMM, IERR )
       IF (PROKG .AND. PRINT_NODEINFO) THEN
-        WRITE(MPG,'(A,I12)')
+        WRITE(MPG,'(A,I16)')
      &  '    Max. estimated space for factors per compute node       :',
      &  MAX_SUM_KEEP811_THIS_NODE ! * KEEP(35)/1000000_8
       ENDIF
@@ -3956,7 +4065,7 @@ C
            TOTAL_BYTES  = max (TOTAL_BYTES, TOTAL_BYTES_UNDER_L0)
          ENDIF
          IF ( PROK ) THEN
-            WRITE(MP,'(A,I12) ')
+            WRITE(MP,'(A,I16) ')
      & ' Estimated space in MBytes for IC factorization   (INFO(15)):',
      &           TOTAL_MBYTES
          END IF
@@ -3974,11 +4083,11 @@ C
      &     id%INFO(15), id%INFOG(16), IRANK )
       IF ( PROKG ) THEN
        IF (PRINT_MAXAVG) THEN
-         WRITE( MPG,'(A,I12) ')
+         WRITE( MPG,'(A,I16) ')
      & '    Maximum estim. space in Mbytes, IC facto.    (INFOG(16)):',
      &        id%INFOG(16)
        ENDIF
-       WRITE(MPG,'(A,I12) ')
+       WRITE(MPG,'(A,I16) ')
      & '    Total space in MBytes, IC factorization      (INFOG(17)):'
      &        ,id%INFOG(17)
       END IF
@@ -3989,7 +4098,7 @@ C     Per compute node memory informatio
       CALL MPI_REDUCE( SUM_INFO15_THIS_NODE, MAX_SUM_INFO15_THIS_NODE,
      &                 1, MPI_INTEGER, MPI_MAX, 0, id%COMM, IERR )
       IF ( PROKG .AND. PRINT_NODEINFO ) THEN
-        WRITE(MPG,'(A,I12)')
+        WRITE(MPG,'(A,I16)')
      &  '    Max. estim. space per compute node, in MBytes, IC fact  :',
      &  MAX_SUM_INFO15_THIS_NODE
       ENDIF
@@ -4066,11 +4175,11 @@ C
      &     id%INFO(17), id%INFOG(26), IRANK )
       IF ( PROKG  ) THEN
        IF (PRINT_MAXAVG) THEN
-         WRITE( MPG,'(A,I12) ')
+         WRITE( MPG,'(A,I16) ')
      & '    Maximum estim. space in Mbytes, OOC facto.   (INFOG(26)):',
      &        id%INFOG(26)
        ENDIF
-       WRITE(MPG,'(A,I12) ')
+       WRITE(MPG,'(A,I16) ')
      & '    Total space in MBytes,  OOC factorization    (INFOG(27)):'
      &        ,id%INFOG(27)
       END IF
@@ -4080,7 +4189,7 @@ C
       CALL MPI_REDUCE( SUM_INFO17_THIS_NODE, MAX_SUM_INFO17_THIS_NODE,
      &                 1, MPI_INTEGER, MPI_MAX, 0, id%COMM, IERR )
       IF (PROKG .AND. PRINT_NODEINFO) THEN
-        WRITE(MPG,'(A,I12)')
+        WRITE(MPG,'(A,I16)')
      &  '    Max. estim. space per compute node, in MBytes, OOC fact :',
      &  MAX_SUM_INFO17_THIS_NODE
       ENDIF
@@ -4181,9 +4290,9 @@ C     Deallocate allocated working space
       IF (allocated(FLAGGED_LEAVES)) DEALLOCATE(FLAGGED_LEAVES)
       IF (allocated(SIZEOFBLOCKS)) DEALLOCATE(SIZEOFBLOCKS)
       IF (allocated(DOF2BLOCK)) DEALLOCATE(DOF2BLOCK)
-      CALL MUMPS_AB_FREE_LMAT(LMAT_BLOCK)
-      CALL MUMPS_AB_FREE_LMAT(LUMAT)
-      CALL MUMPS_AB_FREE_LMAT(LUMAT_REMAP)
+      CALL MUMPS_AB_FREE_LMAT(LMAT_BLOCK,KEEP(147))
+      CALL MUMPS_AB_FREE_LMAT(LUMAT,KEEP(147))
+      CALL MUMPS_AB_FREE_LMAT(LUMAT_REMAP,KEEP(147))
       CALL MUMPS_AB_FREE_GCOMP(GCOMP, MEMCNT)
       CALL MUMPS_AB_FREE_GCOMP(GCOMP_DIST, MEMCNT)
       IF (INFO(1) .LT. 0) THEN
@@ -4266,7 +4375,11 @@ C     to stat that are incremented such
 C     the number of split nodes:
       id%KEEP(61)=0
       IF (id%MYID.eq.MASTER) THEN
+        id%KEEP(38) = 0 
+        id%KEEP(20) = 0 
+        id%KEEP(401) = 0
         id%KEEP(400) = 0
+        IF (id%ICNTL(48).EQ.1) id%KEEP(401)=1
         IF (id%KEEP(401) .GT. 0) THEN
 !$        id%KEEP(400)=omp_get_max_threads()
           IF ( id%KEEP(400) .EQ. 0 ) THEN
@@ -4274,14 +4387,14 @@ C           Compilation without OMP!
             id%INFO(1)=-58
             id%INFO(2)=0
             IF (LPOK) WRITE(LP,'(A)')
-     &      " FAILURE DETECTED IN ANALYSIS: KEEP(401) requires OpenMP"
+     &      " FAILURE DETECTED IN ANALYSIS: ICNTL(48) requires OpenMP"
             RETURN
           ELSE
-            IF ( PROKG ) THEN
-              WRITE(MPG, '(A,I8,A)')
-     &       'KEEP(401) config at analysis:', id%KEEP(400),
-     &       ' threads expected for multithreaded tree parallelism'
-            END IF
+C            IF ( PROKG ) THEN
+C              WRITE(MPG, '(A,I8,A)')
+C     &       'ICNTL(48) config at analysis:', id%KEEP(400),
+C     &       ' threads expected for multithreaded tree parallelism'
+C            END IF
 C           L0OMP feature is on (possibly with a single thread!)
             IF (id%KEEP(400).EQ.1
      &       ) THEN
@@ -4846,7 +4959,18 @@ C     Save ICNTL(56) (QR) in KEEP(53)
 C     Will be broadcasted to all other
 C     nodes in routine ZMUMPS_BDCAST
 C     --------------------------------
-         id%KEEP(53)=0
+         id%KEEP(53) = id%ICNTL(56)
+C     ---------------------------
+C     Possible values are 0..2 
+C     Other values are treated as 0
+C     ------------------------------
+         IF ( id%KEEP(53) .LT. 0 .OR.
+     &        id%KEEP(53) .GE. 2 
+     &      ) THEN
+            id%KEEP(53) = 0
+            IF (PROKG) WRITE(MPG,'(A)')
+     &    ' WARNING: ICNTL(56) treated as if set to 0 '
+         END IF
          IF(id%KEEP(86).EQ.1)THEN
 C     Force the exchange of both the memory and flops information during 
 C     the factorization
@@ -5430,11 +5554,16 @@ C
       INTEGER, TARGET                :: IRN_DUMMY(1), JCN_DUMMY(1)
       INTEGER, POINTER, DIMENSION(:) :: IRN_PASSED, JCN_PASSED
       COMPLEX(kind=8), POINTER, DIMENSION(:) :: A_PASSED
+      INTEGER              :: MPG
+      LOGICAL              :: PROKG
       PARAMETER( MASTER = 0 )
       I_AM_SLAVE = ( id%MYID .NE. MASTER  .OR.
      &     ( id%MYID .EQ. MASTER .AND.
      &     id%KEEP(46) .EQ. 1 ) )
       I_AM_MASTER = (id%MYID.EQ.MASTER)
+      MPG = id%ICNTL( 3 )
+      PROKG = ( MPG .GT. 0 .and. id%MYID .eq. MASTER )
+      PROKG = (PROKG.AND.(id%ICNTL(4).GE.2))
       NAME_INITIALIZED = id%WRITE_PROBLEM(1:20)
      &     .NE. "NAME_NOT_INITIALIZED"
       BINARY_FORMAT = .FALSE.
@@ -5450,6 +5579,11 @@ C
           BINARY_FORMAT = .TRUE.
         ENDIF
       ENDIF
+      IF (NAME_INITIALIZED.AND.PROKG) THEN
+        WRITE(MPG,'(/A,A/)') 
+     &    " Write input matrix to file, WRITE_PROBLEM= ", 
+     &    id%WRITE_PROBLEM(1:L)
+      ENDIF
 C     Check if RHS should also be dumped
       DUMP_RHS = id%MYID.EQ.MASTER .AND.
      &     associated(id%RHS) .AND. NAME_INITIALIZED
@@ -5740,14 +5874,14 @@ C     then describe binary file content
      &  '%    N,IRN(i),JCN(i): 32 bits',
      &  '%    NNZ: 64 bits'
       ENDIF
-      WRITE(IUNIT,FMT='(A,I12)') '% Matrix order: N=',N
-      WRITE(IUNIT,FMT='(A,I12)') '% Matrix nonzeros: NNZ=',NNZTOT
+      WRITE(IUNIT,FMT='(A,I16)') '% Matrix order: N=',N
+      WRITE(IUNIT,FMT='(A,I16)') '% Matrix nonzeros: NNZ=',NNZTOT
       IF (DUMP_RHS) THEN
         WRITE(IUNIT,FMT='(A)') '%'
         WRITE(IUNIT,FMT='(A,/,A,I10,A,I5)')
      &  '% A RHS was also written to disk by columns in binary form.',
      &  '%    Size: N rows x NRHS columns with N=',N,'  NRHS=',NRHS
-        WRITE(IUNIT,FMT='(A,I12,A)')
+        WRITE(IUNIT,FMT='(A,I16,A)')
      &  '%    Total:',int(N,8)*int(NRHS,8),' scalar values.'
         WRITE(IUNIT,'(A)') '%    Double complex storage'
       ENDIF
diff -pruN 5.6.2-2.1/src/zana_lr.F 5.7.1-1/src/zana_lr.F
--- 5.6.2-2.1/src/zana_lr.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zana_lr.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -65,10 +65,12 @@ C
       ENDIF 
       if(allocated(BIG_CUT)) DEALLOCATE(BIG_CUT)
       END SUBROUTINE GET_CUT
-      SUBROUTINE SEP_GROUPING(NV, VLIST, N, NZ, LRGROUPS, NBGROUPS, IW, 
+      SUBROUTINE SEP_GROUPING( NFRONT, KEEP,
+     &   NV, VLIST, N, NZ, LRGROUPS, NBGROUPS, IW, 
      &   LW, IPE, LEN, GROUP_SIZE, HALO_DEPTH, TRACE, WORKH, NODE,
      &   GEN2HALO, K482, K472, K469, SEP_SIZE, MAXSIZE_PARTS,
      &   KEEP10, LP, LPOK, IFLAG, IERROR)
+        INTEGER, INTENT(IN)    :: NFRONT, KEEP(500)
         INTEGER(8), INTENT(IN) :: NZ, LW
         INTEGER, INTENT(IN)    :: NV, N, GROUP_SIZE, HALO_DEPTH
         INTEGER, INTENT(IN)    :: IW(LW), LEN(N), NODE, K482
@@ -84,7 +86,7 @@ C
         INTEGER(8), ALLOCATABLE, DIMENSION(:) :: IPTRHALO
         INTEGER,    ALLOCATABLE, DIMENSION(:) :: PARTS, JCNHALO
         INTEGER(8) :: HALOEDGENBR
-        INTEGER    :: NHALO,
+        INTEGER    :: NHALO, NBG_CAPT,
      &       NBGROUPS_KWAY, I, GROUP_SIZE2, LRGROUPS_SIGN, IERR
         INTEGER    :: MAXSIZE_PARTS_LOC
 #if defined (metis) || defined (parmetis) || defined (metis4) || defined (parmetis3)
@@ -93,7 +95,8 @@ C
 #if defined (scotch) || defined (ptscotch)
         INTEGER :: SCOTCH_IDX_SIZE
 #endif
-        CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NV)
+        CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NV, 
+     &                       NFRONT, KEEP(35))
         NBGROUPS_KWAY = MAX(
      &                INT(dble(NV+GROUP_SIZE2-1)/dble(GROUP_SIZE2))
      &                ,1)
@@ -187,7 +190,7 @@ C
                WRITE(LP,*) " Internal error in SCOTCH during ",
      &                     " Kway partitioning, SCOTCHFGRAPHPART, " 
                WRITE(LP,*) 
-     &         " also provide METIS package to MUMPS "
+     &         " please also provide METIS package to MUMPS "
              ENDIF
 #endif
           ELSE
@@ -197,16 +200,17 @@ C
           IF (IFLAG.LT.0) GOTO 500
           CALL GET_GLOBAL_GROUPS(PARTS, VLIST, NV, 
      &     NBGROUPS_KWAY, LRGROUPS, N, NBGROUPS, LRGROUPS_SIGN,
-     &     MAXSIZE_PARTS_LOC)
+     &     MAXSIZE_PARTS_LOC, .FALSE., GROUP_SIZE2)
            MAXSIZE_PARTS = max(MAXSIZE_PARTS, MAXSIZE_PARTS_LOC)
         ELSE 
           MAXSIZE_PARTS = max(MAXSIZE_PARTS,NV)
-!$OMP CRITICAL(lrgrouping_cri)
+!$OMP ATOMIC CAPTURE
+          NBG_CAPT = NBGROUPS
+          NBGROUPS = NBGROUPS + 1
+!$OMP END ATOMIC 
           DO I=1,NV
-            LRGROUPS(VLIST(I)) = LRGROUPS_SIGN*(NBGROUPS + 1)
+            LRGROUPS(VLIST(I)) = LRGROUPS_SIGN*(NBG_CAPT + 1)
           END DO
-            NBGROUPS = NBGROUPS + 1
-!$OMP END CRITICAL(lrgrouping_cri)
         END IF
   500   IF (allocated(IPTRHALO)) then
            DEALLOCATE(IPTRHALO)
@@ -219,11 +223,13 @@ C
         ENDIF
         RETURN
       END SUBROUTINE SEP_GROUPING
-      SUBROUTINE SEP_GROUPING_AB (NV, NVEXPANDED, 
+      SUBROUTINE SEP_GROUPING_AB ( NFRONT, KEEP,
+     &   NV, NVEXPANDED, 
      &   VLIST, N, LRGROUPS, NBGROUPS, LUMAT, SIZEOFBLOCKS,
      &   GROUP_SIZE, HALO_DEPTH, TRACE, WORKH, NODE,
      &   GEN2HALO, K482, K472, K469, SEP_SIZE, MAXSIZE_PARTS,
      &   KEEP10, LP, LPOK, IFLAG, IERROR)
+        INTEGER, INTENT(IN)    :: NFRONT, KEEP(500)
         TYPE(LMATRIX_T)        :: LUMAT
         INTEGER, INTENT(IN)    :: NV, NVEXPANDED, 
      &                            N, GROUP_SIZE, HALO_DEPTH
@@ -241,17 +247,20 @@ C
         INTEGER,    ALLOCATABLE, DIMENSION(:) :: PARTS, JCNHALO
         INTEGER,    ALLOCATABLE, DIMENSION(:) :: VWGT
         INTEGER(8) :: HALOEDGENBR
-        INTEGER    :: NHALO,
+        INTEGER    :: NHALO, NBG_CAPT,
      &       NBGROUPS_KWAY, I, GROUP_SIZE2, LRGROUPS_SIGN, IERR
         INTEGER    :: MAXSIZE_PARTS_LOC
         DOUBLE PRECISION       :: COMPRESS_RATIO
+        LOGICAL    :: AB_ACTIVE
 #if defined (metis) || defined (parmetis) || defined (metis4) || defined (parmetis3)
         INTEGER :: METIS_IDX_SIZE
 #endif
 #if defined (scotch) || defined (ptscotch)
         INTEGER :: SCOTCH_IDX_SIZE
 #endif
-        CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NVEXPANDED)
+       AB_ACTIVE = (NVEXPANDED.GT.NV)
+        CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NVEXPANDED,
+     &                       NFRONT, KEEP(35))
         COMPRESS_RATIO= dble(NVEXPANDED)/dble(NV)
         NBGROUPS_KWAY = MAX(
      &          INT(dble(NVEXPANDED+GROUP_SIZE2-1)/dble(GROUP_SIZE2))
@@ -365,17 +374,18 @@ C
           IF (IFLAG.LT.0) GOTO 500
           CALL GET_GLOBAL_GROUPS(PARTS,VLIST, NV, 
      &     NBGROUPS_KWAY, LRGROUPS, N, NBGROUPS, LRGROUPS_SIGN,
-     &     MAXSIZE_PARTS_LOC)
+     &     MAXSIZE_PARTS_LOC, AB_ACTIVE, GROUP_SIZE2)
            MAXSIZE_PARTS = max( MAXSIZE_PARTS, 
      &                   int(dble(MAXSIZE_PARTS_LOC*COMPRESS_RATIO))  )
         ELSE 
           MAXSIZE_PARTS = max(MAXSIZE_PARTS,NV)
-!$OMP CRITICAL(lrgrouping_cri)
+!$OMP ATOMIC CAPTURE
+          NBG_CAPT = NBGROUPS
+          NBGROUPS = NBGROUPS + 1
+!$OMP END ATOMIC 
           DO I=1,NV
-            LRGROUPS(VLIST(I)) = LRGROUPS_SIGN*(NBGROUPS + 1)
+            LRGROUPS(VLIST(I)) = LRGROUPS_SIGN*(NBG_CAPT + 1)
           END DO
-            NBGROUPS = NBGROUPS + 1
-!$OMP END CRITICAL(lrgrouping_cri)
         END IF
   500   IF (allocated(IPTRHALO)) then
            DEALLOCATE(IPTRHALO)
@@ -495,9 +505,10 @@ C
       END SUBROUTINE GETHALOGRAPH_AB
       SUBROUTINE GET_GLOBAL_GROUPS(PARTS, SEP, NSEP, NPARTS, 
      &                    LRGROUPS, N, NBGROUPS, LRGROUPS_SIGN,
-     &                    MAXSIZE_PARTS_LOC)
-      INTEGER,INTENT(IN) :: NSEP, N, LRGROUPS_SIGN
+     &                    MAXSIZE_PARTS_LOC, AB_ACTIVE, GROUP_SIZE2)
+      INTEGER,INTENT(IN) :: NSEP, N, LRGROUPS_SIGN, GROUP_SIZE2
       INTEGER :: PARTS(:)
+      LOGICAL :: AB_ACTIVE
       INTEGER,DIMENSION(:),INTENT(INOUT) :: SEP 
       INTEGER, INTENT(INOUT) :: NPARTS 
       INTEGER, INTENT(INOUT) :: NBGROUPS
@@ -506,7 +517,7 @@ C
       INTRINSIC maxval
       INTEGER:: I,CNT,NB_PARTS_WITHOUT_SEP_NODE,allocok
       INTEGER:: TARGET_SIZE_KWAY
-      INTEGER:: MAXSIZE_PARTS_LOC_NEW
+      INTEGER:: MAXSIZE_PARTS_LOC_NEW, NBG_CAPT
       INTEGER,DIMENSION(:),ALLOCATABLE::SIZES, RIGHTPART
       INTEGER,DIMENSION(:),ALLOCATABLE::PARTPTR
 #if ! defined(NO_SPLIT_IN_BLRGROUPING)
@@ -522,8 +533,9 @@ C
          write(*,*) "Allocation error in GET_GLOBAL_GROUPS"
          CALL MUMPS_ABORT()
       ENDIF
-      TARGET_SIZE_KWAY  = (NSEP+NPARTS-1) / NPARTS
-      TARGET_SIZE_SPLIT = 2*TARGET_SIZE_KWAY
+      TARGET_SIZE_KWAY  = GROUP_SIZE2
+      TARGET_SIZE_SPLIT = TARGET_SIZE_KWAY
+      IF (AB_ACTIVE) TARGET_SIZE_SPLIT =huge(TARGET_SIZE_SPLIT)
       NB_PARTS_WITHOUT_SEP_NODE = 0
       RIGHTPART     = 0
       SIZES = 0
@@ -549,16 +561,17 @@ C
 #if ! defined(NO_SPLIT_IN_BLRGROUPING)
        IF (MAXSIZE_PARTS_LOC.LT.TARGET_SIZE_SPLIT) THEN
 #endif
-!$OMP    CRITICAL(lrgrouping_cri)
+!$OMP ATOMIC CAPTURE
+         NBG_CAPT = NBGROUPS
+         NBGROUPS = NBGROUPS + NPARTS
+!$OMP END ATOMIC 
          DO I=1,NSEP
           NEWSEP(PARTPTR(PARTS(I))) = SEP(I)  
           LRGROUPS(SEP(I)) = LRGROUPS_SIGN*(RIGHTPART(PARTS(I)) 
-     &      + NBGROUPS)
+     &      + NBG_CAPT)
           PARTPTR(PARTS(I)) = 
      &      PARTPTR(PARTS(I)) + 1
          END DO
-         NBGROUPS = NBGROUPS + NPARTS
-!$OMP    END CRITICAL(lrgrouping_cri)
          SEP = NEWSEP
 #if ! defined(NO_SPLIT_IN_BLRGROUPING)
       ELSE
@@ -572,9 +585,23 @@ C
          DO I=2,NPARTS+1
            PARTPTR(I) = PARTPTR(I-1) + SIZES(I-1)
          ENDDO
-         NB_PARTS_WITH_SPLIT = 0
+         NB_PARTS_WITH_SPLIT   = 0
          MAXSIZE_PARTS_LOC_NEW = 0
-!$OMP    CRITICAL(lrgrouping_cri)
+         DO IP =1, NPARTS
+           NB_SPLIT =   (SIZES(IP) + TARGET_SIZE_SPLIT-1) 
+     &                    / TARGET_SIZE_SPLIT
+           SZ_FINAL     = (SIZES(IP) + NB_SPLIT-1) / NB_SPLIT 
+           NB_PARTS_WITH_SPLIT = NB_PARTS_WITH_SPLIT +
+     &      ( 
+     &         ( (PARTPTR(IP+1) - PARTPTR(IP))+ SZ_FINAL-1 ) /
+     &          SZ_FINAL
+     &      )
+         ENDDO
+!$OMP ATOMIC CAPTURE
+         NBG_CAPT = NBGROUPS
+         NBGROUPS = NBGROUPS + NB_PARTS_WITH_SPLIT
+!$OMP END ATOMIC 
+         NB_PARTS_WITH_SPLIT = 0
          DO IP=1,NPARTS
            NB_SPLIT =   (SIZES(IP) + TARGET_SIZE_SPLIT-1) 
      &                    / TARGET_SIZE_SPLIT
@@ -585,12 +612,10 @@ C
              NB_PARTS_WITH_SPLIT = NB_PARTS_WITH_SPLIT +1
              DO II=I, min(I+SZ_FINAL-1,PARTPTR(IP+1)-1)
                LRGROUPS(SEP(II)) = LRGROUPS_SIGN*(NB_PARTS_WITH_SPLIT
-     &                           + NBGROUPS)
+     &                           + NBG_CAPT)
              ENDDO
            ENDDO
          ENDDO
-         NBGROUPS = NBGROUPS + NB_PARTS_WITH_SPLIT
-!$OMP    END CRITICAL(lrgrouping_cri)
          NPARTS = NB_PARTS_WITH_SPLIT
          MAXSIZE_PARTS_LOC = MAXSIZE_PARTS_LOC_NEW
       ENDIF
@@ -787,7 +812,8 @@ C
      &     LRGROUPS, SYM, ICNTL, HALO_DEPTH, GROUP_SIZE, SEP_SIZE,
      &     K38, K20, K60,
      &     IFLAG, IERROR, K264, K265, K482, K472, MAXFRONT, K10, 
-     &     K54, K142, LPOK, LP, GATHER_MATRIX_ALLOCATED)
+     &     K54, K142, LPOK, LP, GATHER_MATRIX_ALLOCATED,
+     &     KEEP, ND_STEPS)
       IMPLICIT NONE
       INTEGER, INTENT(IN)    :: N, NSTEPS, LNA, SYM,
      &     HALO_DEPTH, SEP_SIZE, GROUP_SIZE
@@ -804,6 +830,7 @@ C
       INTEGER             :: FILS(N), STEP(N), LRGROUPS(N)
       INTEGER, INTENT(IN)    :: K472, MAXFRONT
       LOGICAL, INTENT(INOUT) :: GATHER_MATRIX_ALLOCATED
+      INTEGER, INTENT(IN) :: KEEP(500), ND_STEPS(:)
       INTEGER :: K482_LOC, K38ou20
       INTEGER :: I, F, PV, NV, NLEAVES, NROOTS, PP, C, NF, NODE,
      &     SYMTRY, NBQD, AD
@@ -914,7 +941,8 @@ C
             WORK(NV) = F
             F = FILS(F)
          END DO
-         CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NV)
+         CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NV,
+     &                        ND_STEPS(NODE), KEEP(35))
          IF (NV .GE. GROUP_SIZE2)  THEN
            IF ( (K482_LOC.EQ.3)
      &           .OR.
@@ -926,7 +954,8 @@ C
                END DO
                NBGROUPS = NBGROUPS + (NV-1)/GROUP_SIZE2 + 1
             ELSE
-              CALL SEP_GROUPING(NV, WORK(1), N, NZ8,
+              CALL SEP_GROUPING( ND_STEPS(NODE), KEEP, 
+     &              NV, WORK(1), N, NZ8,
      &              LRGROUPS, NBGROUPS, IW(1), LW, IPE(1), LEN(1),
      &              GROUP_SIZE, HALO_DEPTH, TRACE(1), WORKH(1), NODE,
      &              GEN2HALO(1), K482_LOC, K472, 0, SEP_SIZE, K142,
@@ -986,7 +1015,8 @@ C
      &     FRERE_STEPS, DAD_STEPS, STEP, NA, LNA, LRGROUPS, 
      &     SYM, ICNTL, HALO_DEPTH, GROUP_SIZE, SEP_SIZE, K38, K20,
      &     K60, IFLAG, IERROR, K264, K265, K482, K472, MAXFRONT, K469, 
-     &     K10, K54, K142, LPOK, LP, GATHER_MATRIX_ALLOCATED)
+     &     K10, K54, K142, LPOK, LP, GATHER_MATRIX_ALLOCATED,
+     &     KEEP, ND_STEPS)
       IMPLICIT NONE
       INTEGER, INTENT(IN)    :: N, NSTEPS, LNA, SYM,
      &     HALO_DEPTH, SEP_SIZE, GROUP_SIZE
@@ -1003,12 +1033,13 @@ C
       INTEGER, INTENT(IN) :: K472, K469
       LOGICAL, INTENT(INOUT) :: GATHER_MATRIX_ALLOCATED
       INTEGER, INTENT(OUT)   :: K142
+      INTEGER, INTENT(IN) :: KEEP(500), ND_STEPS(:)
       INTEGER :: K482_LOC,  K469_LOC, K38ou20
       INTEGER :: I, F, PV, NV, NODE,
      &     SYMTRY, NBQD, AD
       LOGICAL :: PVSCHANGED
       INTEGER(8) :: LW, IWFR, NRORM, NIORM
-      INTEGER :: NBGROUPS, NBGROUPS_local
+      INTEGER :: NBGROUPS, NBGROUPS_local, NBG_CAPT
       INTEGER, ALLOCATABLE, DIMENSION (:) :: PVS, WORK
       INTEGER, ALLOCATABLE, DIMENSION (:) :: LEN, IW
       INTEGER(8), ALLOCATABLE, DIMENSION (:) :: IPE, IQ
@@ -1125,7 +1156,7 @@ C
       PVSCHANGED = .FALSE.
       OMP_NUM = 1
 !$    OMP_NUM = omp_get_max_threads()
-      OMP_NUM = min(OMP_NUM,8)
+      OMP_NUM = min(OMP_NUM,5)
 !$OMP PARALLEL PRIVATE(I, NODE, PV, NV, F, GROUP_SIZE2, WORK, IERR_PRIV,
 !$OMP&         WORKH_PRV, TRACE_PRV, GEN2HALO_PRV, NBGROUPS_local
 !$OMP&         )
@@ -1183,28 +1214,34 @@ C
           WORK(NV) = F
           F = FILS(F)
         END DO
-        CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NV)
-        IF (NV .GE. GROUP_SIZE2)  THEN
+        CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NV,
+     &                        ND_STEPS(NODE), KEEP(35))
+        IF (NV .GE. GROUP_SIZE2
+     &     .AND. NV.GE.int(dble(SEP_SIZE)*dble(1.5))
+     &      )  THEN
           IF ( (K482_LOC.EQ.3)
      &           .OR.
      &         ( (K60.NE.0).AND.(WORK(1).EQ.K38ou20) )
      &        ) 
      &    THEN
-!$OMP CRITICAL(lrgrouping_cri)
+!$OMP ATOMIC CAPTURE
+            NBG_CAPT = NBGROUPS
+            NBGROUPS = NBGROUPS + (NV-1)/GROUP_SIZE2 + 1
+!$OMP END ATOMIC 
             DO I=1,NV
-              LRGROUPS(WORK(I))=NBGROUPS+1+(I-1)/GROUP_SIZE2
+              LRGROUPS(WORK(I))=NBG_CAPT+1+(I-1)/GROUP_SIZE2
             END DO
-            NBGROUPS = NBGROUPS + (NV-1)/GROUP_SIZE2 + 1
-!$OMP END CRITICAL(lrgrouping_cri)
           ELSE
             IF (K469_LOC .EQ. 2) THEN
-              CALL SEP_GROUPING(NV, WORK(1), N, NZ8,
+              CALL SEP_GROUPING( ND_STEPS(NODE), KEEP,
+     &              NV, WORK(1), N, NZ8,
      &              LRGROUPS, NBGROUPS, IW(1), LW, IPE(1), LEN(1),
      &              GROUP_SIZE, HALO_DEPTH, TRACE_PRV, WORKH_PRV, 
      &              NODE, GEN2HALO_PRV, K482_LOC, K472, K469_LOC, 
      &              SEP_SIZE, K142, K10, LP, LPOK, IFLAG, IERROR)
             ELSE
-              CALL SEP_GROUPING(NV, WORK(1), N, NZ8,
+              CALL SEP_GROUPING( ND_STEPS(NODE), KEEP,
+     &              NV, WORK(1), N, NZ8,
      &              LRGROUPS, NBGROUPS, IW(1), LW, IPE(1), LEN(1),
      &              GROUP_SIZE, HALO_DEPTH, TRACE, WORKH, 
      &              NODE, GEN2HALO, K482_LOC, K472, K469_LOC, 
@@ -1232,10 +1269,10 @@ C
             ENDDO
           ENDIF
         ELSE
-!$OMP CRITICAL(lrgrouping_cri)
+!$OMP ATOMIC CAPTURE
           NBGROUPS = NBGROUPS + 1
           NBGROUPS_local = NBGROUPS
-!$OMP END CRITICAL(lrgrouping_cri)
+!$OMP END ATOMIC 
           IF (NV .GE. SEP_SIZE) THEN
             DO I = 1, NV
               LRGROUPS( WORK(I) ) = NBGROUPS_local
@@ -1306,7 +1343,8 @@ C
      &     SEP_SIZE, K38, K20,
      &     K60, IFLAG, IERROR, K264, K265, K482, K472, MAXFRONT, K469, 
      &     K10, K54, K142, LPOK, LP, 
-     &     COMM, MYID, NPROCS_ARG
+     &     COMM, MYID, NPROCS_ARG,
+     &     KEEP, ND_STEPS
      &     )
       IMPLICIT NONE
       INCLUDE 'mpif.h'
@@ -1331,13 +1369,14 @@ C
       INTEGER             :: FILS(N), STEP(N), LRGROUPS(N)
       INTEGER, INTENT(IN) :: SIZEOFBLOCKS(N)
       INTEGER, INTENT(IN) :: K472, K469
+      INTEGER, INTENT(IN) :: KEEP(500), ND_STEPS(:)
       INTEGER :: NPROCS
       INTEGER :: K482_LOC,  K469_LOC, K38ou20, K142_GLOB
       INTEGER :: I, F, PV, NV, NVEXPANDED, NODE
       DOUBLE PRECISION    :: COMPRESS_RATIO
       LOGICAL :: PVSCHANGED
       INTEGER :: PVSCHANGED_INT, PVSCHANGED_INT_GLOB, IPROC
-      INTEGER :: NBGROUPS, NBGROUPS_local 
+      INTEGER :: NBGROUPS, NBGROUPS_local, NBG_CAPT
       INTEGER, ALLOCATABLE, DIMENSION (:) :: PVS, WORK
       INTEGER :: NBGROUPS_sent
       INTEGER :: NBNODES_LOC, SIZE_SENT, ISHIFT, 
@@ -1347,7 +1386,7 @@ C
       INTEGER, ALLOCATABLE, DIMENSION (:) :: TRACE_PRV, WORKH_PRV, 
      &                                   GEN2HALO_PRV
       INTEGER :: STEP_SCALAPACK_ROOT
-      INTEGER :: GROUP_SIZE2, IERR, OMP_NUM
+      INTEGER :: GROUP_SIZE2, GROUP_SIZE2_TMP, IERR, OMP_NUM
       INTEGER :: IERR_PRIV 
       LOGICAL :: MAPCOL_PROVIDED
 #if defined(ptscotch) || defined(scotch)     
@@ -1453,10 +1492,10 @@ C
       PVSCHANGED = .FALSE.
       OMP_NUM = 1
 !$    OMP_NUM = omp_get_max_threads()
-      OMP_NUM = min(OMP_NUM,8)
+      OMP_NUM = min(OMP_NUM,5)
 !$OMP PARALLEL PRIVATE(I, NODE, PV, NV, F, GROUP_SIZE2, WORK, IERR_PRIV,
 !$OMP&         WORKH_PRV, TRACE_PRV, GEN2HALO_PRV, NBGROUPS_local,
-!$OMP&         NVEXPANDED, COMPRESS_RATIO, IPROC
+!$OMP&         NVEXPANDED, COMPRESS_RATIO, IPROC, GROUP_SIZE2_TMP
 !$OMP&         )
 !$OMP&         REDUCTION( max : K142)
 !$OMP&         IF (K469_LOC.GT.1) NUM_THREADS(OMP_NUM)
@@ -1522,29 +1561,37 @@ C
           F = FILS(F)
         END DO
         COMPRESS_RATIO = dble(NVEXPANDED)/dble(NV)
-        CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NVEXPANDED)
-        IF (NVEXPANDED .GE. GROUP_SIZE2)  THEN
+        CALL COMPUTE_BLR_VCS(K472, GROUP_SIZE2, GROUP_SIZE, NVEXPANDED,
+     &                        ND_STEPS(NODE), KEEP(35))
+        IF (NVEXPANDED .GE. GROUP_SIZE2
+     &     .AND. NVEXPANDED.GE.int(dble(SEP_SIZE)*dble(1.5))
+     &     )  THEN
           IF ( (K482_LOC.EQ.3)
      &           .OR.
      &         ( (K60.NE.0).AND.(WORK(1).EQ.K38ou20) )
      &        ) 
      &    THEN
-            GROUP_SIZE2 = max(int(dble(GROUP_SIZE2)/COMPRESS_RATIO), 1)
-!$OMP CRITICAL(lrgrouping_cri)
+            GROUP_SIZE2_TMP = GROUP_SIZE2
+            GROUP_SIZE2_TMP = max( int(dble(GROUP_SIZE2_TMP)
+     &                             /COMPRESS_RATIO), 1)
+!$OMP ATOMIC CAPTURE
+          NBG_CAPT = NBGROUPS
+          NBGROUPS = NBGROUPS + (NV-1)/GROUP_SIZE2_TMP + 1
+!$OMP END ATOMIC 
             DO I=1,NV
-              LRGROUPS(WORK(I))=NBGROUPS+1+(I-1)/GROUP_SIZE2
+              LRGROUPS(WORK(I))=NBG_CAPT+1+(I-1)/GROUP_SIZE2_TMP
             END DO
-            NBGROUPS = NBGROUPS + (NV-1)/GROUP_SIZE2 + 1
-!$OMP END CRITICAL(lrgrouping_cri)
           ELSE
             IF (K469_LOC .EQ. 2) THEN
-              CALL SEP_GROUPING_AB(NV, NVEXPANDED, WORK(1), N, 
+              CALL SEP_GROUPING_AB(  ND_STEPS(NODE), KEEP,
+     &              NV, NVEXPANDED, WORK(1), N, 
      &              LRGROUPS, NBGROUPS, LUMAT, SIZEOFBLOCKS,
      &              GROUP_SIZE, HALO_DEPTH, TRACE_PRV, WORKH_PRV, 
      &              NODE, GEN2HALO_PRV, K482_LOC, K472, K469_LOC, 
      &              SEP_SIZE, K142, K10, LP, LPOK, IFLAG, IERROR)
             ELSE
-              CALL SEP_GROUPING_AB(NV, NVEXPANDED, WORK(1), N, 
+              CALL SEP_GROUPING_AB(  ND_STEPS(NODE), KEEP,
+     &              NV, NVEXPANDED, WORK(1), N, 
      &              LRGROUPS, NBGROUPS, LUMAT, SIZEOFBLOCKS,
      &              GROUP_SIZE, HALO_DEPTH, TRACE, WORKH, 
      &              NODE, GEN2HALO, K482_LOC, K472, K469_LOC, 
diff -pruN 5.6.2-2.1/src/zana_mtrans.F 5.7.1-1/src/zana_mtrans.F
--- 5.6.2-2.1/src/zana_mtrans.F	2023-10-11 09:37:10.000000000 +0000
+++ 5.7.1-1/src/zana_mtrans.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/zana_reordertree.F 5.7.1-1/src/zana_reordertree.F
--- 5.6.2-2.1/src/zana_reordertree.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zana_reordertree.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -26,8 +26,6 @@ C
       INTEGER INFO(80)
       INTEGER SLAVEF,PROCNODE(NSTEPS)
       INTEGER :: SBTR_WHICH_M
-      EXTERNAL MUMPS_PROCNODE
-      INTEGER MUMPS_PROCNODE
       DOUBLE PRECISION PEAK
       DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE :: COST_TRAV
       INTEGER, DIMENSION (:), ALLOCATABLE :: DEPTH
diff -pruN 5.6.2-2.1/src/zarrowheads.F 5.7.1-1/src/zarrowheads.F
--- 5.6.2-2.1/src/zarrowheads.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/zarrowheads.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -185,10 +185,8 @@ C
       INTEGER    :: INTARR( LINTARR )
       COMPLEX(kind=8)    :: DBLARR( LDBLARR )
       COMPLEX(kind=8)    :: A( LA )
-      INTEGER MUMPS_PROCNODE, MUMPS_TYPENODE, numroc, 
-     &        MUMPS_TYPESPLIT
-      EXTERNAL MUMPS_PROCNODE, MUMPS_TYPENODE, numroc, 
-     &        MUMPS_TYPESPLIT
+      INTEGER MUMPS_TYPESPLIT
+      EXTERNAL MUMPS_TYPESPLIT
       INTEGER LP
       LOGICAL LPOK
       COMPLEX(kind=8) VAL, VAL_SHR
@@ -767,8 +765,6 @@ C
       PARAMETER(MASTER=0)
       INTEGER :: IERR
       INTEGER :: STATUS(MPI_STATUS_SIZE)
-      INTEGER numroc
-      EXTERNAL numroc
       TYPE_PARALL = KEEP(46)
       LP = ICNTL(1)
       LPOK = ( LP .GT. 0 .AND. ICNTL(4) .GE. 1 )
@@ -995,11 +991,11 @@ C
       INTEGER,    INTENT(OUT) :: LOCAL_M, LOCAL_N
       INTEGER(8), INTENT(OUT) :: PTR_ROOT
       INTEGER(8), INTENT(IN)  :: LA
-      INTEGER, EXTERNAL :: numroc
-      LOCAL_M = numroc( root%ROOT_SIZE, root%MBLOCK,
+      INTEGER, EXTERNAL :: MUMPS_NUMROC
+      LOCAL_M = MUMPS_NUMROC( root%ROOT_SIZE, root%MBLOCK,
      &         root%MYROW, 0, root%NPROW )
       LOCAL_M = max( 1, LOCAL_M )
-      LOCAL_N = numroc( root%ROOT_SIZE, root%NBLOCK,
+      LOCAL_N = MUMPS_NUMROC( root%ROOT_SIZE, root%NBLOCK,
      &         root%MYCOL, 0, root%NPCOL )
       PTR_ROOT = LA - int(LOCAL_M,8) * int(LOCAL_N,8) + 1_8
       RETURN
diff -pruN 5.6.2-2.1/src/zbcast_int.F 5.7.1-1/src/zbcast_int.F
--- 5.6.2-2.1/src/zbcast_int.F	2023-10-11 09:37:07.000000000 +0000
+++ 5.7.1-1/src/zbcast_int.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/zend_driver.F 5.7.1-1/src/zend_driver.F
--- 5.6.2-2.1/src/zend_driver.F	2023-10-11 09:37:10.000000000 +0000
+++ 5.7.1-1/src/zend_driver.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -323,9 +323,9 @@ C     Allocated at analysis:
         ENDIF
 !     ENDIF
 C     Allocated at analysis:
-      IF (associated(id%MPITOOMP_PROCS_MAP)) THEN
-        DEALLOCATE(id%MPITOOMP_PROCS_MAP)
-        NULLIFY(id%MPITOOMP_PROCS_MAP)
+      IF (associated(id%MTKO_PROCS_MAP)) THEN
+        DEALLOCATE(id%MTKO_PROCS_MAP)
+        NULLIFY(id%MTKO_PROCS_MAP)
       ENDIF
 C     Allocated at analysis:
       IF (associated(id%IPOOL_B_L0_OMP)) THEN
@@ -514,6 +514,16 @@ C     (this includes suppression of OOC
         DEALLOCATE(id%PIVNUL_LIST)
         NULLIFY(id%PIVNUL_LIST)
       ENDIF
+      IF (associated(id%ROWSCA_loc)) THEN
+        DEALLOCATE(id%ROWSCA_loc)
+        NULLIFY(id%ROWSCA_loc)
+      ENDIF
+      IF (id%KEEP(50) .EQ. 0) THEN
+        IF (associated(id%COLSCA_loc)) THEN
+          DEALLOCATE(id%COLSCA_loc)
+        ENDIF
+      ENDIF
+      NULLIFY(id%COLSCA_loc)
 C     IPIV is used both for ScaLAPACK and RR
 C     Keep it outside ZMUMPS_RR_FREE_POINTERS
       IF (associated(id%root%IPIV))    THEN
@@ -572,19 +582,19 @@ C     Data allocated during solve
 C     ---------------------------
 C
 C     (or for some of it, factorization -- forward during factorization)
-      IF (associated(id%RHSCOMP)) THEN
-        DEALLOCATE(id%RHSCOMP)
-        NULLIFY(id%RHSCOMP)
+      IF (associated(id%RHSINTR)) THEN
+        DEALLOCATE(id%RHSINTR)
+        NULLIFY(id%RHSINTR)
         id%KEEP8(25)=0_8
       ENDIF
-      IF (associated(id%POSINRHSCOMP_ROW)) THEN
-        DEALLOCATE(id%POSINRHSCOMP_ROW)
-        NULLIFY(id%POSINRHSCOMP_ROW)
-      ENDIF
-      IF (id%POSINRHSCOMP_COL_ALLOC) THEN
-        DEALLOCATE(id%POSINRHSCOMP_COL)
-        NULLIFY(id%POSINRHSCOMP_COL)
-        id%POSINRHSCOMP_COL_ALLOC = .FALSE.
+      IF (associated(id%GLOB2LOC_RHS)) THEN
+        DEALLOCATE(id%GLOB2LOC_RHS)
+        NULLIFY(id%GLOB2LOC_RHS)
+      ENDIF
+      IF (id%GLOB2LOC_SOL_ALLOC) THEN
+        DEALLOCATE(id%GLOB2LOC_SOL)
+        NULLIFY(id%GLOB2LOC_SOL)
+        id%GLOB2LOC_SOL_ALLOC = .FALSE.
       ENDIF
 C     Allocated during solve:
 C     (even in case of fwd in facto)
@@ -598,3 +608,39 @@ C     (even in case of fwd in facto)
       END IF
       RETURN
       END SUBROUTINE ZMUMPS_FREE_DATA_FACTO
+      SUBROUTINE ZMUMPS_FREE_DATA_RHSINTR(id)
+C
+C     Purpose:
+C     -------
+C       Free RHSINTR related data that might 
+C       have been generated after a forward only step (ICNTL(26)=1)
+C     Module depencies
+C     ----------------
+      USE ZMUMPS_STRUC_DEF
+      IMPLICIT NONE
+C
+C     Argument:
+C     --------
+C
+C     id is the main MUMPS structure, giving access to all internal
+C     objects allocated by the package.
+C
+      TYPE( ZMUMPS_STRUC) :: id
+C
+      IF (associated(id%RHSINTR)) THEN
+        DEALLOCATE(id%RHSINTR)
+        NULLIFY(id%RHSINTR)
+        id%KEEP8(25)=0_8
+        id%LD_RHSINTR = 0
+      ENDIF
+      IF (associated(id%GLOB2LOC_RHS)) THEN
+        DEALLOCATE(id%GLOB2LOC_RHS)
+        NULLIFY(id%GLOB2LOC_RHS)
+      ENDIF
+      IF (id%GLOB2LOC_SOL_ALLOC) THEN
+        DEALLOCATE(id%GLOB2LOC_SOL)
+        NULLIFY(id%GLOB2LOC_SOL)
+        id%GLOB2LOC_SOL_ALLOC = .FALSE.
+      ENDIF
+      RETURN
+      END SUBROUTINE ZMUMPS_FREE_DATA_RHSINTR
diff -pruN 5.6.2-2.1/src/zfac_asm.F 5.7.1-1/src/zfac_asm.F
--- 5.6.2-2.1/src/zfac_asm.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zfac_asm.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -41,7 +41,7 @@ C
       IOLDPS = PTLUST_S(STEP(INODE))
       POSELT = PTRAST(STEP(INODE))
       NFRONT = IW(IOLDPS+KEEP(IXSZ))
-      NASS1  = iabs(IW(IOLDPS + 2+KEEP(IXSZ)))
+      NASS1  = abs(IW(IOLDPS + 2+KEEP(IXSZ)))
       NSLAVES= IW(IOLDPS+5+KEEP(IXSZ))
       IF (KEEP(50).EQ.0) THEN
         LDAFS_PERE = NFRONT
@@ -145,7 +145,7 @@ C
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
       INTEGER, INTENT(IN) :: NINROWARR(KEEP(195))
       INTEGER, INTENT(IN) :: PTRDEBARR(KEEP(196))
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       COMPLEX(kind=8) :: A(LA)
       INTEGER :: INTARR(KEEP8(27))
       COMPLEX(kind=8) :: DBLARR(KEEP8(26))
@@ -202,7 +202,7 @@ C
       INTEGER NBROWS
       INTEGER IW(LIW), ITLOC(N+KEEP(253)), STEP(N),
      &        PTRIST(KEEP(28))
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INCLUDE 'mumps_headers.h'
       INTEGER IOLDPS, NBCOLF, NBROWF, NSLAVES, HF,
      &        K1,K2,K,J
@@ -238,7 +238,7 @@ C
       INTEGER ROWLIST(NBROWS), COLLIST(NBCOLS)
       INTEGER IW(LIW), ITLOC(N+KEEP(253)), STEP(N),
      &        PTRIST(KEEP(28)), FILS(N)
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INTEGER(8) :: PTRAST(KEEP(28))
       COMPLEX(kind=8) A(LA), VALSON(LDA_VALSON,NBROWS)
       DOUBLE PRECISION OPASSW, OPELIW
@@ -606,10 +606,10 @@ C
       INTEGER(8) POSELT, APOS, JJ2
       INCLUDE 'mumps_headers.h'
       LOGICAL SAME_PROC
-      INTRINSIC real
+      INTRINSIC dble
       IOLDPS = PTLUST_S(STEP(INODE))
       POSELT = PTRAST(STEP(INODE))
-      NASS1  = iabs(IW(IOLDPS + 2 + KEEP(IXSZ)))
+      NASS1  = abs(IW(IOLDPS + 2 + KEEP(IXSZ)))
       NSLAVES= IW(IOLDPS+5 + KEEP(IXSZ))
       HF      = 6 + NSLAVES + KEEP(IXSZ)
       ISTCHK = PIMASTER(STEP(ISON))
@@ -655,7 +655,7 @@ C
       INTEGER(8), intent(in) :: KEEP8(150)
       INTEGER, intent(inout) :: ITLOC(N+KEEP(253))
       COMPLEX(kind=8), intent(inout) :: A(LA)
-      COMPLEX(kind=8), intent(in)    :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8), intent(in)    :: RHS_MUMPS(KEEP8(85))
       COMPLEX(kind=8), intent(in)    :: DBLARR(LDBLARR)
       INTEGER, intent(in)    :: INTARR(LINTARR)
       INTEGER, intent(in)    :: FILS(N)
@@ -709,8 +709,9 @@ C
           NB_BLR_LS = NPARTSCB
           call MAX_CLUSTER(BEGS_BLR_LS,NB_BLR_LS+1,MAXI_CLUSTER)
           DEALLOCATE(BEGS_BLR_LS)
-          CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS)
-          MINSIZE = int(IBCKSZ2 / 2)
+          CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS, 
+     &                         NBCOLF, KEEP(35))
+          MINSIZE = int(IBCKSZ2 / 3)
           TOPDIAG = max(2*MINSIZE + MAXI_CLUSTER-1, TOPDIAG)
         ENDIF
 !$      CHUNK = max( KEEP(360)/2,
diff -pruN 5.6.2-2.1/src/zfac_asm_ELT.F 5.7.1-1/src/zfac_asm_ELT.F
--- 5.6.2-2.1/src/zfac_asm_ELT.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/zfac_asm_ELT.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -31,7 +31,7 @@ C
       INTEGER IW(LIW), ITLOC(N+KEEP(253)), STEP(N),
      &        PTRIST(KEEP(28)), FILS(N)
       INTEGER(8), INTENT(IN) :: PTRARW(NELT+1), PTRAIW(NELT+1)
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INTEGER INTARR(KEEP8(27))
       INTEGER FRT_PTR(N+1), FRT_ELT(NELT)
       COMPLEX(kind=8) :: A(LA)
@@ -92,7 +92,7 @@ C
       INTEGER(8), intent(in) :: KEEP8(150)
       INTEGER, intent(inout) :: ITLOC(N+KEEP(253))
       COMPLEX(kind=8), intent(inout) :: A(LA)
-      COMPLEX(kind=8), intent(in)    :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8), intent(in)    :: RHS_MUMPS(KEEP8(85))
       INTEGER, intent(in)    :: INTARR(LINTARR)
       COMPLEX(kind=8), intent(in)    :: DBLARR(LDBLARR)
       INTEGER, intent(in)    :: FRT_PTR(N+1), FRT_ELT(NELT)
@@ -148,8 +148,9 @@ C
           NB_BLR_LS = NPARTSCB
           call MAX_CLUSTER(BEGS_BLR_LS,NB_BLR_LS+1,MAXI_CLUSTER)
           DEALLOCATE(BEGS_BLR_LS)
-          CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS)
-          MINSIZE = int(IBCKSZ2 / 2)
+          CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS,
+     &                         NBCOLF, KEEP(35))
+          MINSIZE = int(IBCKSZ2 / 3)
           TOPDIAG = max(2*MINSIZE + MAXI_CLUSTER-1, TOPDIAG)
         ENDIF
 !$      CHUNK = max( KEEP(360)/2,
diff -pruN 5.6.2-2.1/src/zfac_asm_master_ELT_m.F 5.7.1-1/src/zfac_asm_master_ELT_m.F
--- 5.6.2-2.1/src/zfac_asm_master_ELT_m.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zfac_asm_master_ELT_m.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -78,7 +78,7 @@ C
      &        FILS(N), FRERE(KEEP(28)), DAD(KEEP(28)),
      &        PTRIST(KEEP(28)), PTLUST(KEEP(28)),
      &        STEP(N), PIMASTER(KEEP(28))
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INTEGER(8) :: PTRFAC(KEEP(28)), PTRAST(KEEP(28)),
      &              PAMASTER(KEEP(28))
       INTEGER COMM, NBFIN, SLAVEF, MYID
@@ -224,7 +224,7 @@ C
      &       NUMORG, KEEP(486),
      &       KEEP(489), KEEP(490), KEEP(491), KEEP(492), 
      &       KEEP(20), KEEP(60), DAD(STEP(INODE)), KEEP(38),
-     &       LRSTATUS, KEEP(280), LRGROUPS)
+     &       KEEP(123), LRSTATUS, KEEP(280), LRGROUPS)
       IF (DAD(STEP(INODE)).NE.0) THEN
         IF ( MUMPS_PROCNODE(PROCNODE_STEPS(STEP(DAD(STEP(INODE)))),
      &                                     KEEP(199) )
@@ -338,7 +338,7 @@ C
      &       IOLDPS + HF + 2 * NFRONT, IW, LIW)
       ENDIF
       NCB   = NFRONT - NASS1
-      MAXFRW = max0(MAXFRW, NFRONT)
+      MAXFRW = max(MAXFRW, NFRONT)
       ICT11 = IOLDPS + HF - 1 + NFRONT
       CALL ZMUMPS_SET_PARPIVT1 ( INODE, NFRONT, NASS1, KEEP, 
      &                           LR_ACTIVATED, PARPIV_T1) 
@@ -413,8 +413,9 @@ C
             NB_BLR = NPARTSASS + NPARTSCB
          CALL MAX_CLUSTER(BEGS_BLR,NB_BLR,MAXI_CLUSTER)
          DEALLOCATE(BEGS_BLR)
-         CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS1)
-         MINSIZE = int(IBCKSZ2 / 2)
+         CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS1,
+     &                        NFRONT, KEEP(35))
+         MINSIZE = int(IBCKSZ2 / 3)
          TOPDIAG = max(2*MINSIZE + MAXI_CLUSTER-1,TOPDIAG)
         ENDIF
         NUMROWS = NFRONT8
@@ -926,7 +927,7 @@ C
      &        STEP(N),
      & PIMASTER(KEEP(28)),
      &        NSTK_S(KEEP(28)), PERM(N)
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INTEGER   CAND(SLAVEF+1, max(1,KEEP(56)))
       INTEGER   ISTEP_TO_INIV2(KEEP(71)), 
      &          TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
@@ -1059,7 +1060,7 @@ C
       CALL IS_FRONT_BLR_CANDIDATE(INODE, 2, NFRONT, NASS1, KEEP(486),
      &       KEEP(489), KEEP(490), KEEP(491), KEEP(492), 
      &       KEEP(20), KEEP(60), DAD(STEP(INODE)), KEEP(38),
-     &       LRSTATUS, KEEP(280), LRGROUPS)
+     &       KEEP(123), LRSTATUS, KEEP(280), LRGROUPS)
       COMPRESS_PANEL = (LRSTATUS.GE.2)
       COMPRESS_CB    = ((LRSTATUS.EQ.1).OR.
      &                  (LRSTATUS.EQ.3))
@@ -1311,7 +1312,7 @@ C
      &       NBPANELS_L, NBPANELS_U, NASS1, 
      &       IOLDPS + HF + 2 * NFRONT, IW, LIW)
       ENDIF
-      MAXFRW = max0(MAXFRW, NFRONT)
+      MAXFRW = max(MAXFRW, NFRONT)
       PTLUST(STEP(INODE)) = IOLDPS
       IW(IOLDPS+KEEP(IXSZ))     = NFRONT
       IW(IOLDPS + 1+KEEP(IXSZ)) = 0
@@ -1432,8 +1433,9 @@ C
          NB_BLR = NPARTSASS + NPARTSCB
          CALL MAX_CLUSTER(BEGS_BLR,NB_BLR,MAXI_CLUSTER)
          DEALLOCATE(BEGS_BLR)
-         CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS1)
-         MINSIZE = int(IBCKSZ2 / 2)
+         CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS1,
+     &                        NFRONT, KEEP(35))
+         MINSIZE = int(IBCKSZ2 / 3)
          TOPDIAG = max(2*MINSIZE + MAXI_CLUSTER-1, TOPDIAG)
         ENDIF
 !$      CHUNK = max(KEEP(360)/2,
diff -pruN 5.6.2-2.1/src/zfac_asm_master_m.F 5.7.1-1/src/zfac_asm_master_m.F
--- 5.6.2-2.1/src/zfac_asm_master_m.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zfac_asm_master_m.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -76,7 +76,7 @@ C
      &        FILS(N), FRERE(KEEP(28)), DAD(KEEP(28)),
      &        PTRIST(KEEP(28)), PTLUST(KEEP(28)),
      &        STEP(N), PIMASTER(KEEP(28))
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INTEGER(8) :: PTRFAC(KEEP(28)), PTRAST(KEEP(28)),
      &              PAMASTER(KEEP(28))
       INTEGER COMM, NBFIN, SLAVEF, MYID
@@ -193,7 +193,7 @@ C
         ETATASS= 2 
         IOLDPS = PTLUST(STEP(INODE)) 
         NFRONT = IW(IOLDPS + KEEP(IXSZ)) 
-        NASS1  = iabs(IW(IOLDPS + 2 + KEEP(IXSZ)))
+        NASS1  = abs(IW(IOLDPS + 2 + KEEP(IXSZ)))
         ICT11 = IOLDPS + HF - 1 + NFRONT
         SSARBR=MUMPS_INSSARBR(PROCNODE_STEPS(STEP(INODE)),
      &                        KEEP(199))
@@ -246,7 +246,7 @@ C
      &       NUMORG, KEEP(486),
      &       KEEP(489), KEEP(490), KEEP(491), KEEP(492), 
      &       KEEP(20), KEEP(60), DAD(STEP(INODE)), KEEP(38),
-     &       LRSTATUS, KEEP(280), LRGROUPS)
+     &       KEEP(123), LRSTATUS, KEEP(280), LRGROUPS)
       IF (DAD(STEP(INODE)).NE.0) THEN
         IF ( MUMPS_PROCNODE(PROCNODE_STEPS(STEP(DAD(STEP(INODE)))),
      &                                     KEEP(199) )
@@ -384,7 +384,7 @@ C
      &       IOLDPS + HF + 2 * NFRONT, IW, LIW)
       ENDIF
       NCB   = NFRONT - NASS1
-      MAXFRW = max0(MAXFRW, NFRONT)
+      MAXFRW = max(MAXFRW, NFRONT)
       ICT11 = IOLDPS + HF - 1 + NFRONT
       CALL ZMUMPS_SET_PARPIVT1 ( INODE, NFRONT, NASS1, KEEP, 
      &                           LR_ACTIVATED, PARPIV_T1) 
@@ -465,8 +465,9 @@ C
             NB_BLR = NPARTSASS + NPARTSCB
          CALL MAX_CLUSTER(BEGS_BLR,NB_BLR,MAXI_CLUSTER)
          DEALLOCATE(BEGS_BLR)
-         CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS1)
-         MINSIZE = int(IBCKSZ2 / 2)
+         CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS1,
+     &                        NFRONT, KEEP(35))
+         MINSIZE = int(IBCKSZ2 / 3)
          TOPDIAG = max(2*MINSIZE + MAXI_CLUSTER-1,TOPDIAG)
         ENDIF
         IF (ETATASS.EQ.1) THEN
@@ -654,14 +655,6 @@ C
           ELSE
             IACHK = PAMASTER(STEP(ISON))
           ENDIF
-          IF (IS_CB_LR .AND. LEVEL1) THEN
-            POSEL1 = PTRAST(STEP(INODE))
-            CALL ZMUMPS_BLR_ASM_NIV1 (A, LA,
-     &           POSEL1, NFRONT, NASS1, SON_IW(ISTCHK+XXF),
-     &           SON_IW, SON_LIW,
-     &           LSTK, NELIM, K1, K1+LSTK-1, KEEP(50),
-     &           KEEP, KEEP8, OPASSW)
-          ENDIF
           IF ( KEEP(50) .eq. 0 ) THEN
             POSEL1 = PTRAST(STEP(INODE)) - NFRONT8
             IF (NFRONT .EQ. LSTK.AND. ISON.EQ.ISON_IN_PLACE
@@ -750,6 +743,14 @@ C
               ENDIF
             ENDIF 
           ENDIF
+          IF (IS_CB_LR .AND. LEVEL1) THEN
+            POSEL1 = PTRAST(STEP(INODE))
+            CALL ZMUMPS_BLR_ASM_NIV1 (A, LA,
+     &           POSEL1, NFRONT, NASS1, SON_IW(ISTCHK+XXF),
+     &           SON_IW, SON_LIW,
+     &           LSTK, NELIM, K1, K1+LSTK-1, KEEP(50),
+     &           KEEP, KEEP8, OPASSW)
+          ENDIF
   205     IF (LEVEL1) THEN 
            IF (SAME_PROC) ISTCHK = PTRIST(STEP(ISON))
            IF ((SAME_PROC).AND.ETATASS.NE.1) THEN
@@ -1077,7 +1078,7 @@ C
      &        STEP(N),
      & PIMASTER(KEEP(28)),
      &        NSTK_S(KEEP(28)), PERM(N)
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INTEGER   CAND(SLAVEF+1, max(1,KEEP(56)))
       INTEGER   ISTEP_TO_INIV2(KEEP(71)), 
      &          TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
@@ -1202,7 +1203,7 @@ C
       CALL IS_FRONT_BLR_CANDIDATE(INODE, 2, NFRONT, NASS1, KEEP(486),
      &       KEEP(489), KEEP(490), KEEP(491), KEEP(492), 
      &       KEEP(20), KEEP(60), DAD(STEP(INODE)), KEEP(38),
-     &       LRSTATUS, KEEP(280), LRGROUPS)
+     &       KEEP(123), LRSTATUS, KEEP(280), LRGROUPS)
       COMPRESS_PANEL = (LRSTATUS.GE.2)
       COMPRESS_CB    = ((LRSTATUS.EQ.1).OR.
      &                  (LRSTATUS.EQ.3))
@@ -1452,7 +1453,7 @@ C
      &       NBPANELS_L, NBPANELS_U, NASS1, 
      &       IOLDPS + HF + 2 * NFRONT, IW, LIW)
       ENDIF
-      MAXFRW = max0(MAXFRW, NFRONT)
+      MAXFRW = max(MAXFRW, NFRONT)
       PTLUST(STEP(INODE)) = IOLDPS
       IW(IOLDPS+KEEP(IXSZ))     = NFRONT
       IW(IOLDPS + 1+KEEP(IXSZ)) = 0
@@ -1571,8 +1572,9 @@ C
          NB_BLR = NPARTSASS + NPARTSCB
          CALL MAX_CLUSTER(BEGS_BLR,NB_BLR,MAXI_CLUSTER)
          DEALLOCATE(BEGS_BLR)
-         CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS1)
-         MINSIZE = int(IBCKSZ2 / 2)
+         CALL COMPUTE_BLR_VCS(KEEP(472), IBCKSZ2, KEEP(488), NASS1,
+     &                        NFRONT, KEEP(35))
+         MINSIZE = int(IBCKSZ2 / 3)
          TOPDIAG = max(2*MINSIZE + MAXI_CLUSTER-1, TOPDIAG)
         ENDIF
 !$      CHUNK = max(KEEP(360)/2,
diff -pruN 5.6.2-2.1/src/zfac_b.F 5.7.1-1/src/zfac_b.F
--- 5.6.2-2.1/src/zfac_b.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/zfac_b.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -71,7 +71,7 @@ C
       INTEGER(8) :: PTRFAC(KEEP(28))
       INTEGER   PTRIST(KEEP(28)), PTLUST_S(KEEP(28))
       INTEGER   IW1(2*KEEP(28)), ITLOC(N+KEEP(253)), POOL(LPOOL)
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INTEGER(8) :: IW2(2*KEEP(28))
       INTEGER   PROCNODE_STEPS(KEEP(28))
       INTEGER   COMM_LOAD, ASS_IRECV
@@ -96,8 +96,8 @@ C
       INTEGER, INTENT (IN) :: LL0_OMP_MAPPING
       INTEGER, INTENT (OUT):: L0_OMP_MAPPING( LL0_OMP_MAPPING )
       INTEGER, INTENT (IN) :: LL0_OMP_FACTORS
-      TYPE(ZMUMPS_L0OMPFAC_T), INTENT (OUT) :: L0_OMP_FACTORS(
-     &                                         LL0_OMP_FACTORS )
+      TYPE(ZMUMPS_L0OMPFAC_T), INTENT (INOUT) :: L0_OMP_FACTORS(
+     &                                           LL0_OMP_FACTORS )
       INTEGER, INTENT (IN) :: NBSTATS_I4, NBSTATS_I8
       INTEGER, INTENT (IN) :: NBCOLS_I4, NBCOLS_I8
       INTEGER, INTENT (IN) :: I4_L0_OMP(NBSTATS_I4, NBCOLS_I4)
@@ -552,7 +552,7 @@ C
       INTEGER LPOOL
       INTEGER PROCNODE_STEPS(KEEP(28))
       INTEGER ITLOC(N+KEEP(253))
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INTEGER IW(LIW), NSTK_STEPS(KEEP(28))
       INTEGER(8), INTENT(IN) :: PTRARW(LPTRAR), PTRAIW(LPTRAR)
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
diff -pruN 5.6.2-2.1/src/zfac_determinant.F 5.7.1-1/src/zfac_determinant.F
--- 5.6.2-2.1/src/zfac_determinant.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zfac_determinant.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -159,25 +159,24 @@ C
       NEXP=-NEXP
       RETURN
       END SUBROUTINE ZMUMPS_DETER_SCALING_INVERSE
-      SUBROUTINE ZMUMPS_DETER_SIGN_PERM(DETER, N, VISITED, PERM)
+      SUBROUTINE ZMUMPS_DETER_SIGN_PERM(DETER, N, PERM)
       IMPLICIT NONE
       COMPLEX(kind=8), intent(inout) :: DETER
       INTEGER, intent(in)    :: N
-      INTEGER, intent(inout) :: VISITED(N)
-      INTEGER, intent(in)    :: PERM(N)
+      INTEGER, intent(inout) :: PERM(N)
       INTEGER I, J, K
       K = 0
       DO I = 1, N
-        IF (VISITED(I) .GT. N) THEN
-          VISITED(I)=VISITED(I)-N-N-1
-          CYCLE
+        IF (PERM(I) .LT. 0) THEN
+          PERM(I)=-PERM(I)
+        ELSE 
+          J = PERM(I)
+          DO WHILE (J.NE.I)
+            PERM(J)=-PERM(J)
+            K = K + 1
+            J = -PERM(J) 
+          ENDDO
         ENDIF
-        J = PERM(I)
-        DO WHILE (J.NE.I)
-          VISITED(J) = VISITED(J) + N + N + 1
-          K = K + 1
-          J = PERM(J)
-        ENDDO
       ENDDO
       IF (mod(K,2).EQ.1) THEN
         DETER = -DETER
diff -pruN 5.6.2-2.1/src/zfac_diag.F 5.7.1-1/src/zfac_diag.F
--- 5.6.2-2.1/src/zfac_diag.F	1970-01-01 00:00:00.000000000 +0000
+++ 5.7.1-1/src/zfac_diag.F	2024-05-02 10:15:28.000000000 +0000
@@ -0,0 +1,20 @@
+C
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
+C
+C
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Mumps Technologies, University of Bordeaux.
+C
+C  This version of MUMPS is provided to you free of charge. It is
+C  released under the CeCILL-C license 
+C  (see doc/CeCILL-C_V1-en.txt, doc/CeCILL-C_V1-fr.txt, and
+C  https://cecill.info/licences/Licence_CeCILL-C_V1-en.html)
+C
+      SUBROUTINE ZMUMPS_GETSETDIAGRETURN()
+C
+C     This file contain code to access/return the
+C     diagonal of a factorized matrix in the future.
+C
+      RETURN
+      END SUBROUTINE ZMUMPS_GETSETDIAGRETURN
diff -pruN 5.6.2-2.1/src/zfac_dist_arrowheads_omp.F 5.7.1-1/src/zfac_dist_arrowheads_omp.F
--- 5.6.2-2.1/src/zfac_dist_arrowheads_omp.F	1970-01-01 00:00:00.000000000 +0000
+++ 5.7.1-1/src/zfac_dist_arrowheads_omp.F	2024-05-02 10:15:28.000000000 +0000
@@ -0,0 +1,1350 @@
+C
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
+C
+C
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Mumps Technologies, University of Bordeaux.
+C
+C  This version of MUMPS is provided to you free of charge. It is
+C  released under the CeCILL-C license 
+C  (see doc/CeCILL-C_V1-en.txt, doc/CeCILL-C_V1-fr.txt, and
+C  https://cecill.info/licences/Licence_CeCILL-C_V1-en.html)
+C
+#if ! defined(PCPRET)
+      SUBROUTINE ZMUMPS_FAC_DIST_ARROWHEADS_OMP  (      
+     & N, NZ_loc8, 
+     &    A_loc, IRN_loc, JCN_loc, 
+     &    SIZESCAL, LSCAL, COLSCA, ROWSCA, 
+     & DBLARR, LDBLARR, INTARR, LINTARR,
+     & PTR8ARR, NINCOLARR, NINROWARR, PTRDEBARR,
+     & FILS, KEEP,KEEP8, MYID, COMM, NBRECORDS,
+     &
+     & S, LA, root, PROCNODE_STEPS, NPROCS, SLAVEF, PERM, STEP,
+     & ICNTL, INFO, NSEND8, NLOCAL8,
+     & ISTEP_TO_INIV2, CANDIDATES
+     & )
+!$    USE OMP_LIB
+      USE ZMUMPS_STRUC_DEF
+      IMPLICIT NONE
+      INTEGER, INTENT(IN)    :: N, SIZESCAL
+      LOGICAL, INTENT(IN)    :: LSCAL
+      INTEGER(8), INTENT(IN) :: NZ_loc8
+      INTEGER, INTENT(IN)    :: IRN_LOC(max(1_8,NZ_loc8)), 
+     &                          JCN_LOC(max(1_8,NZ_loc8))
+      COMPLEX(kind=8), INTENT(IN)    :: A_loc(max(1_8,NZ_loc8))
+      DOUBLE PRECISION, INTENT(IN)       :: ROWSCA(SIZESCAL),
+     &                          COLSCA(SIZESCAL)
+      INTEGER(8), INTENT(IN) :: LDBLARR, LINTARR
+      COMPLEX(kind=8), INTENT(OUT)   :: DBLARR( LDBLARR )
+      INTEGER, INTENT(OUT)   :: INTARR( LINTARR )
+      INTEGER, INTENT(INOUT) :: KEEP(500)   
+      INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
+      INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
+      INTEGER, INTENT(IN) :: NINROWARR(KEEP(195))
+      INTEGER, INTENT(IN) :: PTRDEBARR(KEEP(196))
+      INTEGER(8), INTENT(INOUT):: KEEP8(150) 
+      INTEGER, INTENT(IN)    :: FILS( N )
+      INTEGER, INTENT(IN)    :: MYID, COMM, NBRECORDS
+      INTEGER(8), INTENT(IN) :: LA
+      INTEGER, INTENT(IN)    :: NPROCS, SLAVEF
+      INTEGER(8), INTENT(OUT):: NSEND8, NLOCAL8
+      INTEGER, INTENT(IN)    :: ISTEP_TO_INIV2(KEEP(71))
+      INTEGER, INTENT(IN)    :: CANDIDATES(SLAVEF+1, max(1,KEEP(56)))
+      COMPLEX(kind=8), INTENT(INOUT) :: S( LA )
+      TYPE (ZMUMPS_ROOT_STRUC), INTENT(INOUT) :: root
+      INTEGER, INTENT(IN)    :: PROCNODE_STEPS(KEEP(28)), 
+     &                         PERM( N ), STEP( N )
+      INTEGER, INTENT(INOUT) :: INFO( 80 ) 
+      INTEGER, INTENT(IN)    :: ICNTL(60)
+      INCLUDE 'mumps_tags.h'
+      INCLUDE 'mpif.h'
+      COMPLEX(kind=8) ZERO
+      PARAMETER( ZERO = (0.0D0,0.0D0) )
+      INTEGER, ALLOCATABLE, DIMENSION(:,:)  :: IW4
+      INTEGER(8), ALLOCATABLE, DIMENSION(:) :: PTRAW
+      INTEGER, ALLOCATABLE, DIMENSION(:,:,:) :: BUFSENDI
+      COMPLEX(kind=8), ALLOCATABLE, DIMENSION(:,:,:) :: BUFSENDR
+      INTEGER, ALLOCATABLE, DIMENSION(:,:)   :: BUFSEND_POSRESERVED
+      INTEGER, ALLOCATABLE, DIMENSION(:,:) :: BUFRECVI
+      COMPLEX(kind=8), ALLOCATABLE, DIMENSION(:,:) :: BUFRECVR
+      INTEGER, ALLOCATABLE, DIMENSION(:) :: IACT, ISENDREQI, ISENDREQR
+      LOGICAL, ALLOCATABLE, DIMENSION(:) :: SEND_ACTIVE
+      INTEGER, ALLOCATABLE, DIMENSION(:) :: IRECVREQI, IRECVREQR
+      INTEGER, ALLOCATABLE, DIMENSION(:):: RECV_BUF_STATUS
+         INTEGER, PARAMETER :: Processed_IrecNeeded          = 1
+         INTEGER, PARAMETER :: IrecPosted                    = 2
+         INTEGER, PARAMETER :: Received_NotProcessed         = 3
+         INTEGER, PARAMETER :: Processed_IrecNotneeded       = 4
+         INTEGER, PARAMETER :: Treating                      = 5
+         INTEGER, PARAMETER :: BeingTreatednotbyme           = 6 
+      INTEGER(8) :: ILOC8
+      INTEGER :: EndNZloc, NB_END_MSG_2_RECV
+      LOGICAL :: MPI_End_Send, End_TreatRecvBuf, MPI_InvolvedinSend, 
+     &           MPI_InvolvedinRecv, TH_InvolvedinComm, 
+     &           NO_ATOMIC_Wsendbuf, NO_ATOMIC_Warrow, FINISHED,
+     &           TH_InvolvedinArrange, TH_InvolvedinTreatRecv
+      INTEGER(8) :: PTR_ROOT
+      INTEGER    :: LOCAL_M, LOCAL_N, ARROW_ROOT
+      LOGICAL :: EARLYT3ROOTINS
+      LOGICAL :: I_AM_SLAVE, OneMPI
+      INTEGER :: IARR1, IORG, NOMP, NOMP_MAX
+      INTEGER :: ISTEP, ISLAVE_MAIN, IMAIN, JMAIN
+      INTEGER :: allocok 
+      LOGICAL :: OMP_FLAG
+      INTEGER(8) :: IS8MAIN
+      INTEGER :: TYPE_NODE_P, MASTER_NODE_P, NBJ_P
+      INTEGER(8) :: IS8_P
+      INTEGER :: LP, MP
+      LOGICAL :: LPOK, PROK
+      INTEGER(8) :: NB_RANGE_8
+      INTEGER :: SHIFT_PID
+      INTEGER :: NOMP_SHARED
+      LOGICAL    :: NOTHINGTOARRANGE_P
+      INTEGER    :: IOMP, NB_RANGE_P, EndNZloc_P
+      LOGICAL    :: ThWorking
+      INTEGER(8) :: ILOC8_P
+      INTEGER, PARAMETER :: MPI_MASTER = 0  
+      NSEND8  = 0_8
+      NLOCAL8 = 0_8
+      LP = ICNTL(1)
+      MP = ICNTL(2)
+      LPOK    = ((LP.GT.0).AND.(ICNTL(4).GE.1))
+      PROK    = ((MP.GT.0).AND.(ICNTL(4).GE.2))
+      NB_RANGE_8        = int(max(NBRECORDS/10, 1), 8)
+      IF (KEEP(46).EQ.0) THEN
+       SHIFT_PID = 1
+      ELSE
+       SHIFT_PID = 0
+      ENDIF
+      I_AM_SLAVE = (MYID.NE.0.OR.KEEP(46).EQ.1)
+      OneMPI     = NPROCS.EQ.1 
+      IF ( OneMPI.OR. 
+     &     (KEEP(54).EQ.0.AND.(MYID.NE.MPI_MASTER)) 
+     &   ) THEN
+        MPI_InvolvedinSend = .FALSE.  
+        MPI_End_Send       = .TRUE.
+      ELSE
+        MPI_InvolvedinSend = .TRUE.   
+        MPI_End_Send       = .FALSE.
+      ENDIF
+      IF (.NOT.OneMPI) THEN
+        ALLOCATE( 
+     &    BUFSENDI(NBRECORDS * 2 + 1, 2, NPROCS),  
+     &    BUFSENDR(NBRECORDS, 2, NPROCS),
+     &    IACT(NPROCS), SEND_ACTIVE(NPROCS), 
+     &    ISENDREQI(NPROCS), ISENDREQR(NPROCS),
+     &    BUFSEND_POSRESERVED(2, NPROCS),
+     &    stat=allocok)
+        IF ( allocok .GT. 0 ) THEN
+          IF ( LPOK ) THEN
+            WRITE(LP,*)
+     &     '** Error allocating SEND buffers for matrix distribution'
+          END IF
+          INFO(1) = -13
+          INFO(2) =  ( NBRECORDS * 2 + 1 ) * NPROCS * 2 +
+     &             NBRECORDS * NPROCS * 2 + 
+     &             NPROCS*6
+          GOTO 20
+        END IF
+        DO ISLAVE_MAIN=1, NPROCS
+          IACT (ISLAVE_MAIN)         = 1
+          ISENDREQI(ISLAVE_MAIN) = MPI_REQUEST_NULL
+          ISENDREQR(ISLAVE_MAIN) = MPI_REQUEST_NULL
+          BUFSENDI(1, 1, ISLAVE_MAIN)       = 0
+          BUFSEND_POSRESERVED(1,ISLAVE_MAIN)= 0
+          BUFSENDI(1, 2, ISLAVE_MAIN)       = NBRECORDS  
+          BUFSEND_POSRESERVED(2,ISLAVE_MAIN)= NBRECORDS
+          SEND_ACTIVE(ISLAVE_MAIN)   =  .FALSE.
+        ENDDO
+      ENDIF
+      IF (OneMPI.OR. 
+     &    (KEEP(54).EQ.0.AND.(MYID.EQ.MPI_MASTER))
+     &   ) THEN
+        NB_END_MSG_2_RECV  = 0
+        MPI_InvolvedinRecv = .FALSE. 
+        End_TreatRecvBuf   = .TRUE.
+      ELSE IF (KEEP(54).EQ.0.AND.MYID.NE.MPI_MASTER) THEN
+        NB_END_MSG_2_RECV  =  1
+        MPI_InvolvedinRecv = .TRUE.  
+        End_TreatRecvBuf   = .FALSE.
+      ELSE
+        NB_END_MSG_2_RECV  = NPROCS-1
+        MPI_InvolvedinRecv = .TRUE.  
+        End_TreatRecvBuf   = .FALSE.
+      ENDIF
+      IF (.NOT.OneMPI) THEN
+        ALLOCATE( 
+     &  BUFRECVI(NBRECORDS * 2 + 1, NPROCS),
+     &  BUFRECVR(NBRECORDS, NPROCS),
+     &  IRECVREQI(NPROCS), IRECVREQR(NPROCS), 
+     &  RECV_BUF_STATUS(NPROCS),
+     &            stat=allocok)
+        IF ( allocok .GT. 0 ) THEN
+           IF ( LPOK ) THEN
+             WRITE(LP,*)
+     &      '** Error allocating RECV buffers for matrix distribution'
+           END IF
+           INFO(1) = -13
+           INFO(2) =  ( NBRECORDS * 2 + 1 ) * NPROCS +
+     &              NBRECORDS * NPROCS  +      
+     &              NPROCS*3
+           GOTO 20
+        ENDIF
+        BUFRECVI(1, 1:NPROCS) = 0
+        IRECVREQI(1:NPROCS)   = MPI_REQUEST_NULL
+        IRECVREQR(1:NPROCS)   = MPI_REQUEST_NULL
+        RECV_BUF_STATUS (1:NPROCS)= Processed_IrecNeeded
+        RECV_BUF_STATUS (MYID+1)  = Processed_IrecNotneeded
+        IF (KEEP(54).EQ.0) THEN
+         DO ISLAVE_MAIN=1, NPROCS
+           RECV_BUF_STATUS (ISLAVE_MAIN)= Processed_IrecNotneeded
+         ENDDO
+         IF (MYID.NE.MPI_MASTER) THEN
+           RECV_BUF_STATUS(MPI_MASTER+1)  = Processed_IrecNeeded
+         ENDIF
+        ENDIF
+      ENDIF
+      ALLOCATE( IW4( N, 2 ), stat = allocok )
+      IF ( allocok .GT. 0 ) THEN
+        WRITE(LP,*) '** Error allocating IW4 for matrix distribution'
+        INFO(1) = -13
+        CALL MUMPS_SET_IERROR( int(N,8) * 2_8, INFO(2) )
+        GOTO 20
+      END IF
+      ALLOCATE( PTRAW( N ), stat = allocok )
+      IF ( allocok .GT. 0 ) THEN
+        WRITE(LP,*) '** Error allocating IW4 for matrix distribution'
+        INFO(1) = -13
+        CALL MUMPS_SET_IERROR( int(N,8) * KEEP(10), INFO(2) )
+        GOTO 20
+      END IF
+ 20   CONTINUE
+      CALL MUMPS_PROPINFO( ICNTL, INFO, COMM, MYID )
+      IF ( INFO(1) .LT. 0 ) GOTO 100
+      ARROW_ROOT = 0
+      EARLYT3ROOTINS = KEEP(200) .EQ.0
+     &        .OR.  ( KEEP(200) .LT. 0 .AND. KEEP(400) .EQ. 0 )
+      IF (I_AM_SLAVE) THEN
+       DO JMAIN = 1, N
+        ISTEP=STEP(JMAIN)
+        IF (ISTEP .GT. 0) THEN
+          IARR1 = PTRDEBARR( ISTEP )
+          IF ( IARR1 .GT. 0 ) THEN
+            IMAIN = JMAIN
+            IORG = 0
+            DO WHILE ( IMAIN .GT. 0 )
+              IORG = IORG + 1
+              IW4(IMAIN, 1)  = NINCOLARR( IARR1 + IORG - 1 )
+              IW4(IMAIN, 2)  = NINROWARR( IARR1 + IORG - 1 ) +
+     &                     NINCOLARR( IARR1 + IORG - 1 )
+              IS8MAIN        = PTR8ARR( IARR1 + IORG - 1 )
+              PTRAW( IMAIN ) = IS8MAIN
+              INTARR( IS8MAIN ) = IMAIN
+              DBLARR( IS8MAIN ) = ZERO
+              IMAIN = FILS(IMAIN)
+            ENDDO
+          ENDIF
+        ENDIF
+       ENDDO
+       IF ( KEEP(38) .NE. 0 .AND. EARLYT3ROOTINS ) THEN
+         CALL ZMUMPS_GET_ROOT_INFO(root,LOCAL_M, LOCAL_N, PTR_ROOT, LA)
+         CALL ZMUMPS_SET_ROOT_TO_ZERO(root, KEEP, S, LA)
+       ELSE
+         LOCAL_M = -19999; LOCAL_N = -29999; PTR_ROOT = -99999_8
+       END IF
+      ELSE 
+         LOCAL_M = -19999; LOCAL_N = -29999; PTR_ROOT = -99999_8
+      ENDIF
+      NOMP=1
+!$    NOMP=omp_get_max_threads()
+      NOMP_MAX = NOMP
+      IF (NOMP_MAX.GT.2.AND.KEEP(399).EQ.2) THEN
+       IF (.NOT.OneMPI) THEN
+        NOMP_MAX = 2
+       ENDIF
+      ENDIF
+      IF (NOMP_MAX.GT.3.AND.KEEP(399).EQ.3) THEN
+       IF (.NOT.OneMPI) THEN
+        NOMP_MAX = 3
+       ENDIF
+      ENDIF
+      ILOC8      = 1_8  
+      OMP_FLAG   = ((NOMP .GE.2).AND.(KEEP(399).NE.99))
+      FINISHED = .FALSE.
+      NOMP_SHARED = 1
+!$OMP PARALLEL 
+!$OMP&  NUM_THREADS(NOMP_MAX)
+!$OMP&    PRIVATE(
+!$OMP&         IOMP, ThWorking, ILOC8_P, NB_RANGE_P,
+!$OMP&         NOTHINGTOARRANGE_P, EndNZloc_P, TH_InvolvedinComm,
+!$OMP&         TH_InvolvedinTreatRecv,  TH_InvolvedinArrange )
+!$OMP& REDUCTION(+:NSEND8, NLOCAL8, ARROW_ROOT) 
+!$OMP& IF (OMP_FLAG)
+      IOMP        = 0
+!$    IOMP=omp_get_thread_num()
+!$OMP SINGLE
+!$      NOMP_SHARED= omp_get_num_threads()  
+        IF (OneMPI) THEN
+         EndNZloc = NOMP_SHARED
+        ELSE
+         EndNZloc = max(1,NOMP_SHARED -1)
+         IF ( KEEP(399).EQ.2.OR.KEEP(399).EQ.3 ) THEN
+          EndNZloc = min(EndNZloc,1)
+         ENDIF
+        ENDIF
+        IF (NZ_loc8.EQ.0_8) EndNZloc = 0  
+        IF (.NOT.MPI_InvolvedinSend.AND.(EndNZloc.EQ.0)) EndNZloc=-1
+        NO_ATOMIC_Wsendbuf = ( NOMP_SHARED.EQ.1 )
+        NO_ATOMIC_Warrow   = ( NOMP_SHARED.EQ.1 )
+        IF (NPROCS.GT.1) THEN
+          NO_ATOMIC_Warrow = (NOMP_SHARED.LE.2)
+          IF ( KEEP(399).EQ.2 .OR. KEEP(399).EQ.3) THEN
+           NO_ATOMIC_Wsendbuf =  .TRUE.
+           IF (.NOT.MPI_InvolvedinSend) NO_ATOMIC_Warrow=.TRUE.
+           IF (.NOT.MPI_InvolvedinRecv) NO_ATOMIC_Warrow=.TRUE.
+          ENDIF
+        ENDIF
+!$OMP END SINGLE
+      ThWorking          =  OneMPI.OR.
+     &                     (NOMP_SHARED.EQ.1) .OR. (IOMP.NE.0)
+      TH_InvolvedinTreatRecv = (MPI_InvolvedinRecv.AND.ThWorking)
+      IF ( TH_InvolvedinTreatRecv.AND.
+     &     (NOMP_SHARED.EQ.3).AND.(KEEP(399).EQ.3) ) THEN
+          IF (IOMP.NE.2) TH_InvolvedinTreatRecv = .FALSE.
+      ENDIF
+      TH_InvolvedinArrange = ThWorking
+      IF (.NOT.OneMPI.AND.ThWorking) THEN
+        IF (KEEP(399).EQ.2.OR.KEEP(399).EQ.3) 
+     &    THEN
+          IF ((NOMP_SHARED.NE.1).AND.(IOMP.NE.1)) 
+     &       TH_InvolvedinArrange = .FALSE.
+        ENDIF
+      ENDIF
+      TH_InvolvedinComm  = ((.NOT.OneMPI).AND.(IOMP.EQ.0))
+      NOTHINGTOARRANGE_P = (NZ_loc8.EQ.0_8)
+      ILOC8_P            = 0_8
+       DO WHILE ( .NOT.FINISHED )
+          IF (TH_InvolvedinComm) THEN
+            CALL ZMUMPS_ARROW_TRY_PROGRESS_COMM ( IOMP, MYID,
+     &       NPROCS, NBRECORDS, MPI_InvolvedinSend, MPI_InvolvedinRecv, 
+     &       COMM, ISENDREQI, ISENDREQR, BUFSENDI, BUFSENDR, 
+     &       IACT, SEND_ACTIVE, BUFSEND_POSRESERVED, 
+     &       IRECVREQI, IRECVREQR, BUFRECVI, BUFRECVR,
+     &       RECV_BUF_STATUS, NB_END_MSG_2_RECV, 
+     &       EndNZloc, MPI_End_Send, End_TreatRecvBuf
+     &        )
+          ENDIF
+          IF (.NOT.ThWorking) THEN
+            CALL MUMPS_USLEEP(20)
+            GOTO  50
+          ENDIF
+          IF (TH_InvolvedinTreatRecv) THEN
+            CALL ZMUMPS_ARROW_TRY_TREAT_RECV_BUF ( IOMP,
+     &             BUFRECVI, BUFRECVR, RECV_BUF_STATUS, 
+     &             NPROCS, NBRECORDS, N, IW4,
+     &             KEEP, LOCAL_M, LOCAL_N, root, PTR_ROOT, S, LA,
+     &             NB_END_MSG_2_RECV, MYID, PROCNODE_STEPS,
+     &             SLAVEF,
+     &             PTRAW, 
+     &             PTR8ARR, NINCOLARR, NINROWARR, PTRDEBARR,
+     &             PERM, STEP,
+     &             INTARR, LINTARR, DBLARR, LDBLARR, 
+     &             NOMP_SHARED, EARLYT3ROOTINS, NO_ATOMIC_Warrow )
+            IF (NOMP_SHARED.EQ.1) THEN
+              CALL ZMUMPS_ARROW_TRY_PROGRESS_COMM ( IOMP, MYID,
+     &        NPROCS, NBRECORDS, 
+     &        MPI_InvolvedinSend, MPI_InvolvedinRecv,
+     &        COMM, ISENDREQI, ISENDREQR, BUFSENDI, BUFSENDR, 
+     &        IACT, SEND_ACTIVE, BUFSEND_POSRESERVED, 
+     &        IRECVREQI, IRECVREQR, BUFRECVI, BUFRECVR,
+     &        RECV_BUF_STATUS, NB_END_MSG_2_RECV, 
+     &        EndNZloc, MPI_End_Send, End_TreatRecvBuf
+     &        )
+            ENDIF
+          ENDIF
+          IF (.NOT. NOTHINGTOARRANGE_P.AND.TH_InvolvedinArrange) THEN
+!$OMP ATOMIC CAPTURE
+            ILOC8_P = ILOC8
+            ILOC8   = ILOC8 + NB_RANGE_8
+!$OMP END ATOMIC 
+            IF (ILOC8_P.LE.NZ_loc8) THEN
+              NB_RANGE_P = int(min(NB_RANGE_8, NZ_loc8-ILOC8_P+1))
+              CALL ZMUMPS_FAC_ARROW_ARRANGE ( MYID, IOMP, N, SHIFT_PID,
+     &   SLAVEF, LSCAL, NSEND8, NLOCAL8, ILOC8_P, NB_RANGE_P, 
+     &   NZ_loc8, IRN_LOC, JCN_LOC, A_loc, SIZESCAL, ROWSCA, COLSCA,
+     &   ISTEP_TO_INIV2, CANDIDATES, KEEP, MPI_MASTER, NO_ATOMIC_Warrow,
+     &   NO_ATOMIC_Wsendbuf, TH_InvolvedinTreatRecv,
+     &   NPROCS, NBRECORDS, MPI_InvolvedinSend, MPI_InvolvedinRecv, 
+     &   COMM, ISENDREQI, ISENDREQR, BUFSENDI, BUFSENDR, IACT,
+     &   SEND_ACTIVE, BUFSEND_POSRESERVED, IRECVREQI, IRECVREQR,
+     &   BUFRECVI, BUFRECVR, RECV_BUF_STATUS, EndNZloc, MPI_End_Send,
+     &   End_TreatRecvBuf,
+     &   root, PTR_ROOT, ARROW_ROOT, EARLYT3ROOTINS, LOCAL_M, LOCAL_N,
+     &   S, LA, NB_END_MSG_2_RECV, PROCNODE_STEPS, IW4, PTRAW, PTR8ARR,
+     &   NINCOLARR, NINROWARR, PTRDEBARR, PERM, STEP, INTARR, LINTARR,
+     &   DBLARR, LDBLARR, NOMP_SHARED )
+            ENDIF
+            IF (ILOC8_P+NB_RANGE_8.GT.NZ_loc8) THEN
+              IF (.NOT. NOTHINGTOARRANGE_P) THEN
+               NOTHINGTOARRANGE_P=.TRUE. 
+!$OMP          ATOMIC CAPTURE
+               EndNZloc   = EndNZloc-1
+               EndNZloc_P = EndNZloc
+!$OMP          END ATOMIC
+               IF (MPI_End_Send.AND.EndNZloc_P.EQ.0) THEN
+!$OMP           ATOMIC WRITE
+                EndNZloc=-1
+!$OMP           END ATOMIC
+               ENDIF
+              ENDIF
+            ENDIF
+          ENDIF
+  50      CONTINUE  
+!$OMP     MASTER
+!$OMP     ATOMIC WRITE
+          FINISHED = ( (EndNZloc.EQ.-1) 
+     &            .AND.(MPI_End_Send.OR.(.not.MPI_InvolvedinSend))
+     &            .AND. End_TreatRecvBuf
+     &               )
+!$OMP     END ATOMIC
+!$OMP     END MASTER
+       ENDDO
+!$OMP END PARALLEL
+!$OMP PARALLEL DO SCHEDULE(DYNAMIC,1)
+!$OMP&         PRIVATE(ISTEP, TYPE_NODE_P, MASTER_NODE_P, NBJ_P, 
+!$OMP&                 IARR1, IS8_P  )
+!$OMP&        IF (OMP_FLAG)
+      DO ISTEP=1, KEEP(28)
+        CALL MUMPS_TYPEANDPROCNODE( TYPE_NODE_P, MASTER_NODE_P,
+     &    PROCNODE_STEPS(ISTEP), KEEP(199) )
+        MASTER_NODE_P = MASTER_NODE_P + SHIFT_PID
+        IF ( MASTER_NODE_P.NE.MYID.OR.
+     &      (  (TYPE_NODE_P.NE.1) .AND. (TYPE_NODE_P.NE.2) )
+     &     ) CYCLE
+        IARR1  = PTRDEBARR( ISTEP )
+        NBJ_P  = NINCOLARR( IARR1)
+        IF (NBJ_P.LE.0) CYCLE
+        IS8_P  = PTR8ARR( IARR1) + 1_8
+        CALL ZMUMPS_QUICK_SORT_ARROWHEADS( N, PERM,
+     &              INTARR( IS8_P ),
+     &              DBLARR( IS8_P ),
+     &              NBJ_P, 1, NBJ_P )
+      ENDDO
+!$OMP END PARALLEL DO
+ 100  CONTINUE
+      IF (ALLOCATED(IW4))         DEALLOCATE( IW4 )
+      IF (ALLOCATED(PTRAW))       DEALLOCATE( PTRAW )
+      IF (ALLOCATED(BUFSENDI))    DEALLOCATE( BUFSENDI )
+      IF (ALLOCATED(BUFSENDR))    DEALLOCATE( BUFSENDR )
+      IF (ALLOCATED(BUFRECVI))    DEALLOCATE( BUFRECVI )
+      IF (ALLOCATED(BUFRECVR))    DEALLOCATE( BUFRECVR )
+      IF (ALLOCATED(IACT))        DEALLOCATE( IACT )
+      IF (ALLOCATED(ISENDREQI))   DEALLOCATE( ISENDREQI )
+      IF (ALLOCATED(ISENDREQR))   DEALLOCATE( ISENDREQR )
+      IF (ALLOCATED(IRECVREQI))   DEALLOCATE( IRECVREQI )
+      IF (ALLOCATED(IRECVREQR))   DEALLOCATE( IRECVREQR )
+      IF (ALLOCATED(SEND_ACTIVE)) DEALLOCATE( SEND_ACTIVE )
+      IF (ALLOCATED(BUFSEND_POSRESERVED))   
+     &                      DEALLOCATE( BUFSEND_POSRESERVED )
+      IF (ALLOCATED(RECV_BUF_STATUS)) DEALLOCATE( RECV_BUF_STATUS )
+      RETURN
+      END SUBROUTINE ZMUMPS_FAC_DIST_ARROWHEADS_OMP 
+      SUBROUTINE ZMUMPS_ARROW_TRY_PROGRESS_COMM ( IOMP, MYID,
+     &     NPROCS, NBRECORDS, MPI_InvolvedinSend, MPI_InvolvedinRecv,
+     &     COMM, ISENDREQI, ISENDREQR, BUFSENDI, BUFSENDR, 
+     &     IACT, SEND_ACTIVE, BUFSEND_POSRESERVED, 
+     &     IRECVREQI, IRECVREQR, BUFRECVI, BUFRECVR,
+     &     RECV_BUF_STATUS, NB_END_MSG_2_RECV, 
+     &     EndNZloc, MPI_End_Send, End_TreatRecvBuf
+     &        )
+      IMPLICIT NONE
+      INTEGER, INTENT(IN) :: IOMP, MYID, NPROCS, NBRECORDS, COMM
+      LOGICAL, INTENT(IN) :: MPI_InvolvedinSend, MPI_InvolvedinRecv
+      INTEGER, INTENT(IN) :: NB_END_MSG_2_RECV
+      INTEGER, INTENT(INOUT) :: EndNZloc
+      LOGICAL, INTENT(INOUT) :: MPI_End_Send, End_TreatRecvBuf
+      INTEGER, INTENT(INOUT) :: 
+     &     ISENDREQI(NPROCS), ISENDREQR(NPROCS), 
+     &     BUFSENDI(NBRECORDS * 2 + 1, 2, NPROCS), 
+     &     IACT(NPROCS), BUFSEND_POSRESERVED(2,NPROCS)
+      COMPLEX(kind=8), INTENT(INOUT) :: BUFSENDR(NBRECORDS, 2, NPROCS)
+      LOGICAL, INTENT(INOUT) :: SEND_ACTIVE(NPROCS)
+      INTEGER, INTENT(INOUT) :: 
+     &     IRECVREQI(NPROCS), IRECVREQR(NPROCS), 
+     &     BUFRECVI(NBRECORDS * 2 + 1, NPROCS),
+     &     RECV_BUF_STATUS(NPROCS)
+      COMPLEX(kind=8), INTENT(INOUT) ::  BUFRECVR(NBRECORDS, NPROCS)
+         INTEGER, PARAMETER :: Processed_IrecNeeded          = 1
+         INTEGER, PARAMETER :: IrecPosted                    = 2
+         INTEGER, PARAMETER :: Received_NotProcessed         = 3
+         INTEGER, PARAMETER :: Processed_IrecNotneeded       = 4
+         INTEGER, PARAMETER :: Treating                      = 5
+      INCLUDE 'mumps_tags.h'
+      INCLUDE 'mpif.h'
+      INTEGER :: EndNZloc_copy, ISLAVE, NBREC, STATE, 
+     &           NB_END_MSG_2_RECV_COPY, ISLAVE_RECV 
+      INTEGER :: IERR, IACT_P, NEXT_IACT
+      INTEGER :: TAILLE_SEND_I, TAILLE_SEND_R
+      LOGICAL :: FLAG, FLAGRECV, ALL_LAST_MESS_SENT
+      INTEGER :: STATUS(MPI_STATUS_SIZE)
+      IF (MPI_InvolvedinSend.and.(.NOT.MPI_End_Send)) THEN
+        DO ISLAVE = 1, NPROCS
+          IF (ISLAVE-1.EQ.MYID) CYCLE
+          IF (SEND_ACTIVE( ISLAVE )) THEN
+              CALL MPI_TEST( ISENDREQR( ISLAVE ), FLAG, STATUS, IERR )
+              IF (FLAG) THEN
+                CALL MPI_WAIT( ISENDREQI( ISLAVE ), STATUS, IERR )
+                SEND_ACTIVE( ISLAVE ) = .FALSE.
+              ENDIF
+          ENDIF
+        ENDDO
+!$OMP   ATOMIC READ
+        EndNZloc_copy = EndNZloc
+!$OMP   END ATOMIC 
+        ALL_LAST_MESS_SENT = (EndNZloc_copy.EQ.0)
+        IF (EndNZloc_copy.NE.-1) THEN
+          DO ISLAVE=1, NPROCS
+            IF (ISLAVE-1.EQ.MYID) CYCLE
+            IF (EndNZloc_copy .EQ. 0) THEN
+             NBREC = 
+     &         min(BUFSEND_POSRESERVED(IACT(ISLAVE),ISLAVE),NBRECORDS)
+             IF (NBREC.EQ.-99) CYCLE
+             BUFSENDI(1,IACT(ISLAVE),ISLAVE) = - NBREC
+            ELSE
+!$OMP         ATOMIC READ
+              NBREC = BUFSENDI(1,IACT(ISLAVE),ISLAVE)
+!$OMP         END ATOMIC
+            ENDIF
+            IF ((EndNZloc_copy.EQ.0).OR.(NBREC.EQ.NBRECORDS)) THEN
+              IF (.NOT.SEND_ACTIVE(ISLAVE)) THEN
+                TAILLE_SEND_I = NBREC * 2 + 1
+                TAILLE_SEND_R = NBREC
+                IACT_P = IACT(ISLAVE)
+                CALL MPI_ISEND( BUFSENDI(1, IACT_P, ISLAVE ),
+     &              TAILLE_SEND_I,
+     &              MPI_INTEGER, ISLAVE - 1, 
+     &              ARR_INT, COMM,
+     &              ISENDREQI( ISLAVE ), IERR )
+                CALL MPI_ISEND( BUFSENDR(1, IACT_P, ISLAVE ),
+     &              TAILLE_SEND_R,
+     &              MPI_DOUBLE_COMPLEX, ISLAVE - 1, 
+     &              ARR_REAL, COMM,
+     &              ISENDREQR( ISLAVE ), IERR )
+                SEND_ACTIVE( ISLAVE ) = .TRUE.
+                IF (EndNZloc_copy.NE.0) THEN
+                  NEXT_IACT = 3-IACT_P
+!$OMP             ATOMIC WRITE
+                  BUFSEND_POSRESERVED(NEXT_IACT,ISLAVE) = 0
+!$OMP             END ATOMIC
+!$OMP             ATOMIC WRITE
+                  BUFSENDI(1,NEXT_IACT,ISLAVE) = 0
+!$OMP             END ATOMIC
+!$OMP             ATOMIC WRITE
+                  IACT( ISLAVE ) = NEXT_IACT
+!$OMP             END ATOMIC
+                ELSE
+                  BUFSEND_POSRESERVED(IACT_P,ISLAVE) = -99
+                ENDIF
+              ELSE
+                ALL_LAST_MESS_SENT=.FALSE.
+              ENDIF
+            ENDIF
+          ENDDO
+        ENDIF
+        IF (EndNZloc_copy.EQ.0.AND.ALL_LAST_MESS_SENT) THEN 
+            EndNZloc      = -1  
+            EndNZloc_copy = -1  
+        ENDIF
+        IF (.NOT.MPI_End_Send) THEN
+          IF ( (EndNZloc_copy.EQ.-1) )  THEN
+            MPI_End_Send = .TRUE.
+            DO ISLAVE = 1, NPROCS
+               IF (ISLAVE-1.EQ.MYID) CYCLE
+               IF (SEND_ACTIVE( ISLAVE )) THEN 
+                 MPI_End_Send=.FALSE.
+                 EXIT
+               ENDIF
+            ENDDO
+          ENDIF
+        ENDIF
+      ENDIF
+      IF (MPI_InvolvedinRecv.AND.(.NOT.End_TreatRecvBuf)) THEN
+        CALL MPI_TESTANY(NPROCS, IRECVREQR, ISLAVE_RECV, 
+     &                   FLAGRECV, STATUS,IERR)
+        IF (FLAGRECV.AND.(ISLAVE_RECV.NE.MPI_UNDEFINED)) 
+     &            THEN
+            CALL MPI_WAIT(IRECVREQI(ISLAVE_RECV),STATUS,IERR)
+!$OMP       ATOMIC WRITE
+            RECV_BUF_STATUS(ISLAVE_RECV)=Received_NotProcessed
+!$OMP       END ATOMIC
+        ENDIF
+        DO  ISLAVE = 1, NPROCS
+          IF (ISLAVE - 1 .EQ. MYID) CYCLE
+!$OMP     ATOMIC READ
+          STATE = RECV_BUF_STATUS(ISLAVE)
+!$OMP     END ATOMIC
+          IF (STATE.EQ.Processed_IrecNeeded) THEN
+            CALL MPI_IRECV ( BUFRECVI(1,ISLAVE), NBRECORDS * 2 + 1,  
+     &              MPI_INTEGER, ISLAVE-1, ARR_INT, COMM, 
+     &              IRECVREQI(ISLAVE), IERR)
+            CALL MPI_IRECV ( BUFRECVR(1,ISLAVE), NBRECORDS,
+     &              MPI_DOUBLE_COMPLEX, ISLAVE-1, 
+     &              ARR_REAL, COMM,
+     &              IRECVREQR(ISLAVE), IERR)
+!$OMP       ATOMIC WRITE
+            RECV_BUF_STATUS(ISLAVE) = IrecPosted
+!$OMP       END ATOMIC
+          ENDIF
+        ENDDO
+!$OMP   ATOMIC READ
+        NB_END_MSG_2_RECV_COPY = NB_END_MSG_2_RECV
+!$OMP   END ATOMIC
+        IF (NB_END_MSG_2_RECV_COPY.EQ.0) THEN
+          End_TreatRecvBuf = .TRUE.
+          DO ISLAVE = 1, NPROCS
+            IF (ISLAVE - 1 .EQ. MYID) CYCLE
+            IF (RECV_BUF_STATUS(ISLAVE).NE.Processed_IrecNotneeded) THEN
+               End_TreatRecvBuf = .FALSE.
+               EXIT
+            ENDIF
+          ENDDO
+        ENDIF
+      ENDIF
+      RETURN
+      END SUBROUTINE ZMUMPS_ARROW_TRY_PROGRESS_COMM 
+      SUBROUTINE ZMUMPS_ARROW_TRY_TREAT_RECV_BUF (IOMP,
+     &             BUFRECVI, BUFRECVR, RECV_BUF_STATUS, 
+     &             NPROCS, NBRECORDS, N, IW4,
+     &             KEEP, LOCAL_M, LOCAL_N, root, PTR_ROOT, S, LA,
+     &             NB_END_MSG_2_RECV, MYID, PROCNODE_STEPS,
+     &             SLAVEF,
+     &             PTRAW, 
+     &             PTR8ARR, NINCOLARR, NINROWARR, PTRDEBARR,
+     &             PERM, STEP,
+     &             INTARR, LINTARR, DBLARR, LDBLARR, 
+     &             NOMP_SHARED, EARLYT3ROOTINS, NO_ATOMIC_Warrow )
+      USE ZMUMPS_STRUC_DEF, ONLY : ZMUMPS_ROOT_STRUC
+      IMPLICIT NONE
+      TYPE (ZMUMPS_ROOT_STRUC) :: root
+      INTEGER, INTENT(IN):: IOMP, NPROCS, NBRECORDS, N, MYID, SLAVEF,
+     &                      NOMP_SHARED
+      LOGICAL, INTENT(IN):: EARLYT3ROOTINS
+      INTEGER, INTENT(IN):: BUFRECVI( NBRECORDS * 2 + 1, NPROCS )
+      COMPLEX(kind=8), INTENT(IN):: BUFRECVR( NBRECORDS, NPROCS )
+      INTEGER, INTENT(INOUT) :: RECV_BUF_STATUS(NPROCS)
+      INTEGER, INTENT(INOUT):: IW4( N, 2 )
+      INTEGER, INTENT(IN):: KEEP(500)
+      INTEGER, INTENT(INOUT):: NB_END_MSG_2_RECV
+      INTEGER(8), INTENT(IN) :: PTRAW( N )
+      INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
+      INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
+      INTEGER, INTENT(IN) :: NINROWARR(KEEP(195))
+      INTEGER, INTENT(IN) :: PTRDEBARR(KEEP(196))
+      INTEGER, INTENT(IN) :: PERM( N ), STEP( N )
+      INTEGER, INTENT(IN) :: PROCNODE_STEPS( KEEP(28) )
+      INTEGER(8), INTENT(IN) :: LINTARR, LDBLARR
+      INTEGER, INTENT(INOUT) ::  INTARR( LINTARR )
+      INTEGER, INTENT(IN)::  LOCAL_M, LOCAL_N
+      INTEGER(8), INTENT(IN) :: PTR_ROOT, LA
+      COMPLEX(kind=8), INTENT(INOUT) :: S( LA ), DBLARR( LDBLARR )
+      LOGICAL, INTENT(IN)    :: NO_ATOMIC_Warrow
+         INTEGER, PARAMETER :: Processed_IrecNeeded          = 1
+         INTEGER, PARAMETER :: IrecPosted                    = 2
+         INTEGER, PARAMETER :: Received_NotProcessed         = 3
+         INTEGER, PARAMETER :: Processed_IrecNotneeded       = 4
+         INTEGER, PARAMETER :: Treating                      = 5
+         INTEGER, PARAMETER :: BeingTreatednotbyme           = 6
+      INTEGER MUMPS_TYPENODE
+      EXTERNAL MUMPS_TYPENODE
+      INTEGER STATE, ISLAVE
+      DO ISLAVE =1, NPROCS
+         IF (MYID.EQ.ISLAVE-1) CYCLE
+!$OMP    ATOMIC READ
+         STATE = RECV_BUF_STATUS(ISLAVE)
+!$OMP    END ATOMIC
+         IF (STATE.EQ.Treating) CYCLE
+         IF (STATE.EQ.Received_NotProcessed) THEN
+          IF (NOMP_SHARED.EQ.1) THEN
+            RECV_BUF_STATUS(ISLAVE) = Treating
+            STATE                   = Treating
+          ELSE IF (KEEP(399).LE.3) THEN
+!$OMP       ATOMIC WRITE
+            RECV_BUF_STATUS(ISLAVE) = Treating
+!$OMP       END ATOMIC
+            STATE                   = Treating
+          ELSE
+!$OMP      CRITICAL(ARROW_RECV_BUF_STATUS)
+!$OMP        ATOMIC READ
+             STATE = RECV_BUF_STATUS(ISLAVE)
+!$OMP        END ATOMIC
+             IF (STATE.EQ.Received_NotProcessed) THEN
+!$OMP          ATOMIC WRITE
+               RECV_BUF_STATUS(ISLAVE) = Treating
+!$OMP          END ATOMIC 
+               STATE                   = Treating
+             ELSE
+               STATE                   = BeingTreatednotbyme
+             ENDIF
+!$OMP      END CRITICAL(ARROW_ RECV_BUF_STATUS)
+          ENDIF
+         ENDIF
+        IF (STATE.NE.Treating) CYCLE
+        IF (NO_ATOMIC_Warrow) THEN
+          CALL ZMUMPS_ARROW_TREAT_RECV_BUF_1TH()
+        ELSE
+          CALL ZMUMPS_ARROW_TREAT_RECV_BUF()
+        ENDIF
+      ENDDO 
+      RETURN
+      CONTAINS
+      SUBROUTINE  ZMUMPS_ARROW_TREAT_RECV_BUF()
+      INTEGER :: IREC, NB_REC, TYPE_NODE
+      INTEGER :: IPOSROOT, JPOSROOT, ILOCROOT, JLOCROOT
+      INTEGER(8) :: IS8
+      INTEGER    :: IARR, JARR, IW4_CAPTURED
+      INTEGER    :: NB_END_MSG_2_RECV_COPY
+      COMPLEX(kind=8)    :: VAL
+      LOGICAL    :: LAST_MESSAGE
+      LAST_MESSAGE = .FALSE.
+      NB_REC = BUFRECVI( 1, ISLAVE )
+      TYPE_NODE = -998
+      IF ( NB_REC .LE. 0 ) THEN
+        LAST_MESSAGE = .TRUE.
+!$OMP ATOMIC CAPTURE
+        NB_END_MSG_2_RECV_COPY = NB_END_MSG_2_RECV
+        NB_END_MSG_2_RECV      = NB_END_MSG_2_RECV - 1   
+!$OMP END ATOMIC
+        NB_REC = - NB_REC
+      END IF
+      IF ( NB_REC .eq. 0 ) GOTO 100
+      DO IREC = 1, NB_REC
+        IARR = BUFRECVI( IREC * 2, ISLAVE )
+        JARR = BUFRECVI( IREC * 2 + 1, ISLAVE )
+        VAL  = BUFRECVR( IREC, ISLAVE )
+        IF (EARLYT3ROOTINS) THEN
+          TYPE_NODE = MUMPS_TYPENODE( 
+     &              PROCNODE_STEPS(abs(STEP(abs( IARR )))),
+     &              KEEP(199) )
+        ENDIF
+        IF ( TYPE_NODE .eq. 3 .AND. EARLYT3ROOTINS ) THEN
+          IF ( IARR .GT. 0 ) THEN
+            IPOSROOT = root%RG2L( IARR )
+            JPOSROOT = root%RG2L( JARR )
+          ELSE
+            IPOSROOT = root%RG2L( JARR )
+            JPOSROOT = root%RG2L( -IARR )
+          END IF
+          ILOCROOT = root%MBLOCK * ( ( IPOSROOT - 1 ) /
+     &                 ( root%MBLOCK * root%NPROW ) )
+     &               + mod( IPOSROOT - 1, root%MBLOCK ) + 1
+          JLOCROOT = root%NBLOCK * ( ( JPOSROOT - 1 ) /
+     &                 ( root%NBLOCK * root%NPCOL ) )
+     &               + mod( JPOSROOT - 1, root%NBLOCK ) + 1
+          IF (KEEP(60)==0) THEN
+!$OMP ATOMIC UPDATE
+            S( PTR_ROOT + int(JLOCROOT-1,8) * int(LOCAL_M,8)
+     &        + int(ILOCROOT-1,8)) =  S( PTR_ROOT
+     &        + int(JLOCROOT - 1,8) * int(LOCAL_M,8)
+     &        + int(ILOCROOT - 1,8) )
+     &      + VAL
+!$OMP END ATOMIC
+          ELSE
+!$OMP ATOMIC UPDATE
+            root%SCHUR_POINTER( int(JLOCROOT-1,8)
+     &                      * int(root%SCHUR_LLD,8)
+     &                      + int(ILOCROOT,8) )
+     &      = root%SCHUR_POINTER( int(JLOCROOT - 1,8)
+     &                      * int(root%SCHUR_LLD,8)
+     &                      + int(ILOCROOT,8))
+     &      + VAL
+!$OMP END ATOMIC
+          ENDIF
+        ELSE IF (IARR.GE.0) THEN
+          IF (IARR.EQ.JARR) THEN
+            IS8 = PTRAW(IARR)
+!$OMP ATOMIC UPDATE
+            DBLARR(IS8) = DBLARR(IS8) + VAL
+!$OMP END ATOMIC
+          ELSE
+!$OMP ATOMIC CAPTURE
+            IW4_CAPTURED= IW4(IARR,2)
+            IW4(IARR,2) = IW4(IARR,2) - 1
+!$OMP END ATOMIC
+            IS8         = PTRAW(IARR)+int(IW4_CAPTURED,8)
+            INTARR(IS8) = JARR
+            DBLARR(IS8) = VAL
+          ENDIF
+        ELSE
+          IARR         = -IARR
+!$OMP ATOMIC CAPTURE
+          IW4_CAPTURED   = IW4(IARR,1)
+          IW4(IARR,1)    = IW4(IARR,1) - 1
+!$OMP END ATOMIC
+          IS8          = PTRAW(IARR) + int(IW4_CAPTURED,8)
+          INTARR(IS8)  = JARR
+          DBLARR(IS8)  = VAL
+        ENDIF
+      ENDDO
+ 100  CONTINUE
+      IF (LAST_MESSAGE) THEN
+!$OMP ATOMIC WRITE
+         RECV_BUF_STATUS(ISLAVE) = Processed_IrecNotneeded
+!$OMP END ATOMIC
+      ELSE
+!$OMP ATOMIC WRITE
+         RECV_BUF_STATUS(ISLAVE) = Processed_IrecNeeded
+!$OMP END ATOMIC
+      ENDIF
+      RETURN
+      END SUBROUTINE  ZMUMPS_ARROW_TREAT_RECV_BUF
+      SUBROUTINE  ZMUMPS_ARROW_TREAT_RECV_BUF_1TH()
+      INTEGER :: IREC, NB_REC, TYPE_NODE
+      INTEGER :: IPOSROOT, JPOSROOT, ILOCROOT, JLOCROOT
+      INTEGER(8) :: IS8
+      INTEGER    :: IARR, JARR
+      INTEGER    :: NB_END_MSG_2_RECV_COPY
+      COMPLEX(kind=8)    :: VAL
+      LOGICAL    :: LAST_MESSAGE
+      LAST_MESSAGE = .FALSE.
+      NB_REC = BUFRECVI( 1, ISLAVE )
+      IF ( NB_REC .LE. 0 ) THEN
+        LAST_MESSAGE = .TRUE.
+!$OMP ATOMIC CAPTURE
+        NB_END_MSG_2_RECV_COPY = NB_END_MSG_2_RECV
+        NB_END_MSG_2_RECV      = NB_END_MSG_2_RECV - 1   
+!$OMP END ATOMIC
+        NB_REC = - NB_REC
+      END IF 
+      IF ( NB_REC .eq. 0 ) GOTO 100
+      DO IREC = 1, NB_REC
+        IARR = BUFRECVI( IREC * 2, ISLAVE )
+        JARR = BUFRECVI( IREC * 2 + 1, ISLAVE )
+        VAL  = BUFRECVR( IREC, ISLAVE )
+        IF (EARLYT3ROOTINS) THEN
+          TYPE_NODE = MUMPS_TYPENODE( 
+     &              PROCNODE_STEPS(abs(STEP(abs( IARR )))),
+     &              KEEP(199) )
+        ENDIF
+        IF ( TYPE_NODE .eq. 3 .AND. EARLYT3ROOTINS ) THEN
+          IF ( IARR .GT. 0 ) THEN
+            IPOSROOT = root%RG2L( IARR )
+            JPOSROOT = root%RG2L( JARR )
+          ELSE
+            IPOSROOT = root%RG2L( JARR )
+            JPOSROOT = root%RG2L( -IARR )
+          END IF
+          ILOCROOT = root%MBLOCK * ( ( IPOSROOT - 1 ) /
+     &                 ( root%MBLOCK * root%NPROW ) )
+     &               + mod( IPOSROOT - 1, root%MBLOCK ) + 1
+          JLOCROOT = root%NBLOCK * ( ( JPOSROOT - 1 ) /
+     &                 ( root%NBLOCK * root%NPCOL ) )
+     &               + mod( JPOSROOT - 1, root%NBLOCK ) + 1
+          IF (KEEP(60)==0) THEN
+            S( PTR_ROOT + int(JLOCROOT-1,8) * int(LOCAL_M,8)
+     &        + int(ILOCROOT-1,8)) =  S( PTR_ROOT
+     &        + int(JLOCROOT - 1,8) * int(LOCAL_M,8)
+     &        + int(ILOCROOT - 1,8) )
+     &      + VAL
+          ELSE
+            root%SCHUR_POINTER( int(JLOCROOT-1,8)
+     &                      * int(root%SCHUR_LLD,8)
+     &                      + int(ILOCROOT,8) )
+     &      = root%SCHUR_POINTER( int(JLOCROOT - 1,8)
+     &                      * int(root%SCHUR_LLD,8)
+     &                      + int(ILOCROOT,8))
+     &      + VAL
+          ENDIF
+        ELSE IF (IARR.GE.0) THEN
+          IF (IARR.EQ.JARR) THEN
+            IS8 = PTRAW(IARR)
+            DBLARR(IS8) = DBLARR(IS8) + VAL
+          ELSE
+            IS8         = PTRAW(IARR)+IW4(IARR,2)
+            IW4(IARR,2) = IW4(IARR,2) - 1
+            INTARR(IS8) = JARR
+            DBLARR(IS8) = VAL
+          ENDIF
+        ELSE
+          IARR         = -IARR
+          IS8          = PTRAW(IARR)+IW4(IARR,1)
+          IW4(IARR,1)  = IW4(IARR,1) - 1
+          INTARR(IS8)  = JARR
+          DBLARR(IS8)  = VAL
+        ENDIF
+      ENDDO
+ 100  CONTINUE
+      IF (LAST_MESSAGE) THEN
+!$OMP ATOMIC WRITE
+         RECV_BUF_STATUS(ISLAVE) = Processed_IrecNotneeded
+!$OMP END ATOMIC
+      ELSE
+!$OMP ATOMIC WRITE
+         RECV_BUF_STATUS(ISLAVE) = Processed_IrecNeeded
+!$OMP END ATOMIC
+      ENDIF
+      RETURN
+      END SUBROUTINE  ZMUMPS_ARROW_TREAT_RECV_BUF_1TH
+      END SUBROUTINE ZMUMPS_ARROW_TRY_TREAT_RECV_BUF 
+      SUBROUTINE ZMUMPS_FAC_ARROW_ARRANGE ( 
+     &  MYID, IOMP, N, SHIFT_PID, SLAVEF, LSCAL, NSEND8, NLOCAL8,
+     &  ILOC8_P, NB_RANGE_P, NZ_loc8, IRN_LOC, JCN_LOC, A_loc, SIZESCAL,
+     &  ROWSCA, COLSCA, ISTEP_TO_INIV2, CANDIDATES, KEEP, MPI_MASTER, 
+     &  NO_ATOMIC_Warrow, NO_ATOMIC_Wsendbuf, TH_InvolvedinTreatRecv,
+     &  NPROCS, NBRECORDS, MPI_InvolvedinSend, MPI_InvolvedinRecv,
+     &  COMM, ISENDREQI, ISENDREQR, BUFSENDI, BUFSENDR, IACT,
+     &  SEND_ACTIVE, BUFSEND_POSRESERVED, IRECVREQI, IRECVREQR,
+     &  BUFRECVI, BUFRECVR, RECV_BUF_STATUS, EndNZloc, MPI_End_Send,
+     &  End_TreatRecvBuf,
+     &  root, PTR_ROOT, ARROW_ROOT, EARLYT3ROOTINS, LOCAL_M, LOCAL_N,
+     &  S, LA, NB_END_MSG_2_RECV, PROCNODE_STEPS, IW4, PTRAW, 
+     &  PTR8ARR, NINCOLARR, NINROWARR, PTRDEBARR,
+     &  PERM, STEP, INTARR, LINTARR, DBLARR, LDBLARR, NOMP_SHARED )
+!$    USE OMP_LIB
+      USE ZMUMPS_STRUC_DEF, ONLY : ZMUMPS_ROOT_STRUC
+      IMPLICIT NONE
+      INTEGER, INTENT(IN)      :: MYID, IOMP, N, SHIFT_PID, 
+     &                            SLAVEF, SIZESCAL, MPI_MASTER
+      INTEGER, INTENT(IN)      :: NB_RANGE_P, KEEP(500)
+      INTEGER(8), INTENT(IN)   :: NZ_loc8, ILOC8_P
+      INTEGER(8), INTENT(INOUT):: NSEND8, NLOCAL8
+      INTEGER, INTENT(IN)      :: IRN_LOC(max(1_8,NZ_loc8)), 
+     &                            JCN_LOC(max(1_8,NZ_loc8))
+      INTEGER, INTENT(IN):: ISTEP_TO_INIV2(KEEP(71))
+      INTEGER, INTENT(IN):: CANDIDATES(SLAVEF+1, max(1,KEEP(56)))
+      COMPLEX(kind=8), INTENT(IN):: A_loc(max(1_8,NZ_loc8))
+      DOUBLE PRECISION, INTENT(IN)   :: ROWSCA(SIZESCAL),
+     &                      COLSCA(SIZESCAL)
+      LOGICAL, INTENT(IN):: NO_ATOMIC_Warrow, NO_ATOMIC_Wsendbuf, 
+     &                      TH_InvolvedinTreatRecv
+      INTEGER, INTENT(IN) :: NPROCS, NBRECORDS, COMM, NOMP_SHARED
+      LOGICAL, INTENT(IN) :: MPI_InvolvedinSend, MPI_InvolvedinRecv, 
+     &                       LSCAL
+      INTEGER, INTENT(INOUT) :: EndNZloc
+      LOGICAL, INTENT(INOUT) :: MPI_End_Send, End_TreatRecvBuf
+      INTEGER, INTENT(INOUT) :: ISENDREQI(NPROCS), ISENDREQR(NPROCS), 
+     &     BUFSENDI(NBRECORDS * 2 + 1, 2, NPROCS), 
+     &     IACT(NPROCS), BUFSEND_POSRESERVED(2,NPROCS)
+      COMPLEX(kind=8), INTENT(INOUT) :: BUFSENDR(NBRECORDS, 2, NPROCS)
+      LOGICAL, INTENT(INOUT) :: SEND_ACTIVE(NPROCS)
+      INTEGER, INTENT(INOUT) :: IRECVREQI(NPROCS), IRECVREQR(NPROCS), 
+     &     BUFRECVI(NBRECORDS * 2 + 1, NPROCS),
+     &     RECV_BUF_STATUS(NPROCS)
+      COMPLEX(kind=8), INTENT(INOUT) :: BUFRECVR(NBRECORDS, NPROCS)
+         INTEGER, PARAMETER :: Processed_IrecNeeded          = 1
+         INTEGER, PARAMETER :: IrecPosted                    = 2
+         INTEGER, PARAMETER :: Received_NotProcessed         = 3
+         INTEGER, PARAMETER :: Processed_IrecNotneeded       = 4
+         INTEGER, PARAMETER :: Treating                      = 5
+      TYPE (ZMUMPS_ROOT_STRUC) :: root
+      INTEGER, INTENT(IN)      :: LOCAL_M, LOCAL_N
+      LOGICAL, INTENT(IN)      :: EARLYT3ROOTINS
+      INTEGER, INTENT(INOUT)   :: ARROW_ROOT
+      INTEGER, INTENT(INOUT):: IW4( N, 2 )
+      INTEGER, INTENT(INOUT):: NB_END_MSG_2_RECV
+      INTEGER(8), INTENT(IN) :: PTRAW( N )
+      INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
+      INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
+      INTEGER, INTENT(IN) :: NINROWARR(KEEP(195))
+      INTEGER, INTENT(IN) :: PTRDEBARR(KEEP(196))
+      INTEGER, INTENT(IN) :: PERM( N ), STEP( N )
+      INTEGER, INTENT(IN) :: PROCNODE_STEPS( KEEP(28) )
+      INTEGER(8), INTENT(IN) :: LINTARR, LDBLARR
+      INTEGER, INTENT(INOUT) ::  INTARR( LINTARR )
+      INTEGER(8), INTENT(IN) :: PTR_ROOT, LA
+      COMPLEX(kind=8), INTENT(INOUT) ::  S( LA ), DBLARR( LDBLARR )
+      INTEGER MUMPS_TYPESPLIT
+      EXTERNAL MUMPS_TYPESPLIT
+      INTEGER     :: DEST, JSEND, ISEND , DEST_SAVE
+      INTEGER     :: I, INIV2, NCAND, T4MASTER
+      INTEGER     :: IOLD, JOLD, IARR, TYPESPLIT
+      INTEGER(8)  :: IS8, IZ8, LAST8
+      LOGICAL     :: T4_MASTER_CONCERNED
+      INTEGER     :: MASTER_NODE, TYPE_NODE, ISTEP_P
+      INTEGER     :: IPOSROOT, JPOSROOT, ILOCROOT, JLOCROOT
+      INTEGER     :: IROW_GRID, JCOL_GRID, IW4_CAPTURED
+      LOGICAL     :: LOCAL_ASSEMBLY, LOCAL
+      COMPLEX(kind=8)     :: VAL
+      INTEGER     :: ISTEP_T3_1PROC
+      LAST8 = ILOC8_P + int(NB_RANGE_P-1,8)
+      LOCAL_ASSEMBLY  =  (NPROCS.EQ.1)
+      IF (NPROCS.EQ.1 .AND. KEEP(38).EQ.0) THEN
+        TYPE_NODE = 1
+        ISTEP_T3_1PROC  = -9999
+      ELSE IF (NPROCS.EQ.1 .AND. KEEP(38).NE.0) THEN
+        ISTEP_T3_1PROC = STEP(KEEP(38))
+      ELSE
+        ISTEP_T3_1PROC = -99999
+      ENDIF
+      DO IZ8=ILOC8_P, LAST8
+          IOLD = IRN_loc(IZ8)
+          JOLD = JCN_loc(IZ8)
+          IF ( (IOLD.GT.N).OR.(JOLD.GT.N).OR.(IOLD.LT.1)
+     &                 .OR.(JOLD.LT.1) ) THEN
+            CYCLE
+          ENDIF
+          IF (IOLD.EQ.JOLD) THEN
+            ISEND = IOLD
+            JSEND = IOLD
+            IARR  = IOLD
+          ELSE IF (PERM(IOLD).LT.PERM(JOLD)) THEN
+            IARR  = IOLD
+            IF ( KEEP(50) .NE. 0 ) THEN
+              ISEND = -IOLD
+            ELSE
+              ISEND = IOLD
+            ENDIF
+            JSEND = JOLD
+          ELSE
+            IARR  = JOLD
+            ISEND = -JOLD
+            JSEND = IOLD
+          ENDIF
+          VAL = A_loc(IZ8)
+          IF (LSCAL) THEN
+            VAL = VAL * ROWSCA(IOLD)*COLSCA(JOLD)
+          ENDIF
+          IF (NPROCS.GT.1 .OR. KEEP(38).NE.0) THEN
+            ISTEP_P = abs(STEP(IARR))
+            IF ( NPROCS.EQ.1 .AND. ISTEP_P.NE.ISTEP_T3_1PROC ) THEN
+              TYPE_NODE=1
+            ELSE IF (NPROCS.EQ.1) THEN
+              TYPE_NODE=3
+              IF (EARLYT3ROOTINS) THEN
+                IF ( ISEND < 0 ) THEN
+                  IPOSROOT = root%RG2L(JSEND)
+                  JPOSROOT = root%RG2L(IARR )
+                ELSE
+                  IPOSROOT = root%RG2L(IARR )
+                  JPOSROOT = root%RG2L(JSEND)
+                END IF
+              END IF
+            ELSE
+            ISTEP_P = abs(STEP(IARR))
+            CALL MUMPS_TYPEANDPROCNODE( TYPE_NODE, MASTER_NODE,
+     &      PROCNODE_STEPS(ISTEP_P), KEEP(199) )
+            MASTER_NODE = MASTER_NODE + SHIFT_PID
+            T4_MASTER_CONCERNED = .FALSE.
+            T4MASTER            = -9999
+            IF ( TYPE_NODE .eq. 1 ) THEN
+              DEST = MASTER_NODE
+            ELSE IF ( TYPE_NODE .eq. 2 ) THEN
+              IF ( ISEND .LT. 0 ) THEN
+                DEST = -1
+              ELSE
+                DEST = MASTER_NODE
+              END IF
+              INIV2         = ISTEP_TO_INIV2(ISTEP_P)
+              IF ( KEEP(79) .GT. 0) THEN
+                TYPESPLIT  = MUMPS_TYPESPLIT( PROCNODE_STEPS(ISTEP_P),
+     &                                        KEEP(199) )
+                IF ( (TYPESPLIT.EQ.5).OR.(TYPESPLIT.EQ.6)) THEN
+                  T4_MASTER_CONCERNED = .TRUE.
+                  T4MASTER=
+     &                   CANDIDATES(CANDIDATES(SLAVEF+1,INIV2)+1,INIV2)
+     &                 + SHIFT_PID
+                ENDIF
+              ENDIF
+            ELSE 
+              ARROW_ROOT = ARROW_ROOT + 1
+              IF (EARLYT3ROOTINS) THEN
+                IF ( ISEND < 0 ) THEN
+                  IPOSROOT = root%RG2L(JSEND)
+                  JPOSROOT = root%RG2L(IARR )
+                ELSE
+                  IPOSROOT = root%RG2L(IARR )
+                  JPOSROOT = root%RG2L(JSEND)
+                END IF
+                IROW_GRID = mod( ( IPOSROOT-1 )/root%MBLOCK, root%NPROW)
+                JCOL_GRID = mod( ( JPOSROOT-1 )/root%NBLOCK, root%NPCOL)
+                DEST = IROW_GRID * root%NPCOL + JCOL_GRID + SHIFT_PID
+              ELSE
+                DEST = -2
+              ENDIF
+            ENDIF
+            IF (DEST .eq. -1) THEN
+              NLOCAL8 = NLOCAL8 + 1_8
+              NSEND8  = NSEND8 + int(SLAVEF -1,8)
+            ELSE IF (DEST .EQ. -2) THEN
+              NLOCAL8 = NLOCAL8 + 1_8
+              NSEND8  = NSEND8 + int(SLAVEF -1,8)
+            ELSE
+              IF (DEST .eq.MYID ) THEN
+                NLOCAL8 = NLOCAL8 + 1_8
+              ELSE
+                NSEND8 = NSEND8 + 1_8
+              ENDIF
+            ENDIF
+            LOCAL_ASSEMBLY = .FALSE.
+            IF ( DEST.EQ.-1) THEN
+              INIV2 = ISTEP_TO_INIV2(ISTEP_P)
+              NCAND = CANDIDATES(SLAVEF+1,INIV2)
+              IF (KEEP(79) .GT. 0) THEN
+                DO I=1, SLAVEF
+                  DEST=CANDIDATES(I,INIV2) + SHIFT_PID
+                  IF (DEST.LT.0) EXIT 
+                  LOCAL = (DEST.EQ.MYID)
+                  IF (LOCAL) LOCAL_ASSEMBLY = .TRUE.
+                  IF (LOCAL) CYCLE
+                  IF (I.EQ.NCAND+1) CYCLE
+                  CALL ZMUMPS_DIST_FILL_SEND_BUFFER()
+                ENDDO
+              ELSE
+                DO I=1, NCAND
+                  DEST=CANDIDATES(I,INIV2) + SHIFT_PID
+                  LOCAL = (DEST.EQ.MYID)
+                  IF (LOCAL) LOCAL_ASSEMBLY = .TRUE.
+                  IF (LOCAL) CYCLE
+                  CALL ZMUMPS_DIST_FILL_SEND_BUFFER()
+                ENDDO
+              ENDIF
+              IF ( LOCAL_ASSEMBLY ) THEN
+                DEST_SAVE = DEST
+                DEST      = MASTER_NODE
+                IF (DEST.NE.MYID)
+     &           CALL ZMUMPS_DIST_FILL_SEND_BUFFER()
+                IF (T4_MASTER_CONCERNED) THEN
+                  DEST   = T4MASTER
+                  IF (DEST.NE.MYID)
+     &             CALL ZMUMPS_DIST_FILL_SEND_BUFFER()
+                ENDIF
+                DEST = DEST_SAVE
+              ELSE
+                DEST=MASTER_NODE
+                LOCAL_ASSEMBLY = (DEST.EQ.MYID)
+                IF (.NOT.LOCAL_ASSEMBLY) 
+     &           CALL ZMUMPS_DIST_FILL_SEND_BUFFER()
+                IF (T4_MASTER_CONCERNED) THEN
+                  DEST = T4MASTER
+                  LOCAL_ASSEMBLY = (DEST.EQ.MYID)
+                  IF (.NOT.LOCAL_ASSEMBLY) 
+     &             CALL ZMUMPS_DIST_FILL_SEND_BUFFER()
+                ENDIF
+              ENDIF
+            ELSE IF (DEST .GE. 0) THEN
+              LOCAL_ASSEMBLY = (DEST.EQ.MYID)
+              IF (.NOT.LOCAL_ASSEMBLY) 
+     &             CALL ZMUMPS_DIST_FILL_SEND_BUFFER()
+              IF (T4_MASTER_CONCERNED) THEN
+                DEST = T4MASTER
+                LOCAL_ASSEMBLY = (DEST.EQ.MYID)
+                IF (.NOT.LOCAL_ASSEMBLY) 
+     &             CALL ZMUMPS_DIST_FILL_SEND_BUFFER()
+              ENDIF
+            ELSE IF (DEST .EQ. -2) THEN
+              DO I = 0, SLAVEF-1
+                DEST=I + SHIFT_PID
+                IF (DEST.NE.MYID) 
+     &             CALL ZMUMPS_DIST_FILL_SEND_BUFFER()
+              ENDDO
+              IF (SHIFT_PID.EQ.1.AND.MYID.EQ.MPI_MASTER) THEN
+                LOCAL_ASSEMBLY=.FALSE.
+              ELSE
+                LOCAL_ASSEMBLY=.TRUE. 
+              ENDIF
+            ENDIF
+          ENDIF
+          ENDIF
+          IF (LOCAL_ASSEMBLY) THEN
+            IF ( TYPE_NODE .eq. 3 .AND. EARLYT3ROOTINS ) THEN
+              ILOCROOT = root%MBLOCK * ( ( IPOSROOT - 1 ) /
+     &                     ( root%MBLOCK * root%NPROW ) )
+     &                   + mod( IPOSROOT - 1, root%MBLOCK ) + 1
+              JLOCROOT = root%NBLOCK * ( ( JPOSROOT - 1 ) /
+     &                     ( root%NBLOCK * root%NPCOL ) )
+     &                   + mod( JPOSROOT - 1, root%NBLOCK ) + 1
+              IF (KEEP(60)==0) THEN
+!$OMP ATOMIC UPDATE
+                S( PTR_ROOT + int(JLOCROOT-1,8) * int(LOCAL_M,8)
+     &            + int(ILOCROOT-1,8)) =  S( PTR_ROOT
+     &            + int(JLOCROOT - 1,8) * int(LOCAL_M,8)
+     &            + int(ILOCROOT - 1,8) )
+     &          + VAL
+!$OMP END ATOMIC
+              ELSE
+!$OMP ATOMIC UPDATE
+                root%SCHUR_POINTER( int(JLOCROOT-1,8)
+     &                          * int(root%SCHUR_LLD,8)
+     &                          + int(ILOCROOT,8) )
+     &          = root%SCHUR_POINTER( int(JLOCROOT - 1,8)
+     &                          * int(root%SCHUR_LLD,8)
+     &                          + int(ILOCROOT,8))
+     &          + VAL
+!$OMP END ATOMIC
+              ENDIF
+            ELSE
+      IF (NO_ATOMIC_Warrow) THEN
+             IF (ISEND.EQ.JSEND) THEN
+               IS8         = PTRAW(ISEND)
+               DBLARR(IS8) = DBLARR(IS8) + VAL
+             ELSE IF (ISEND.GE.0) THEN 
+               IS8         = PTRAW(IARR)+IW4(IARR,2)
+               IW4(IARR,2) = IW4(IARR,2) - 1
+               INTARR(IS8) = JSEND
+               DBLARR(IS8) = VAL
+             ELSE 
+               IS8         = PTRAW(IARR)+IW4(IARR,1)
+               IW4(IARR,1) = IW4(IARR,1) - 1
+               INTARR(IS8) = JSEND
+               DBLARR(IS8) = VAL
+             ENDIF
+      ELSE
+             IF (ISEND.EQ.JSEND) THEN
+               IS8         = PTRAW(ISEND)
+!$OMP ATOMIC UPDATE
+               DBLARR(IS8) = DBLARR(IS8) + VAL
+!$OMP END ATOMIC
+             ELSE IF (ISEND.GE.0) THEN 
+!$OMP ATOMIC CAPTURE
+               IW4_CAPTURED = IW4(IARR,2)
+               IW4(IARR,2)  = IW4(IARR,2) - 1
+!$OMP END ATOMIC
+               IS8         = PTRAW(IARR) + int(IW4_CAPTURED,8)
+               INTARR(IS8) = JSEND
+               DBLARR(IS8) = VAL
+             ELSE 
+!$OMP ATOMIC CAPTURE
+               IW4_CAPTURED = IW4(IARR,1)
+               IW4(IARR,1)  = IW4(IARR,1) - 1
+!$OMP END ATOMIC
+               IS8         = PTRAW(IARR) + int(IW4_CAPTURED,8)
+               INTARR(IS8) = JSEND
+               DBLARR(IS8) = VAL
+             ENDIF
+      ENDIF
+            ENDIF
+          ENDIF
+      ENDDO
+      RETURN
+      CONTAINS
+      SUBROUTINE ZMUMPS_DIST_FILL_SEND_BUFFER( )
+      INTEGER IREQ, IACT_P, ISLAVE
+      ISLAVE = DEST+1
+ 100  CONTINUE
+!$OMP ATOMIC READ
+      IACT_P = IACT(ISLAVE)
+!$OMP END ATOMIC
+      IF (NO_ATOMIC_Wsendbuf) THEN
+        BUFSEND_POSRESERVED(IACT_P,ISLAVE) = 
+     &         BUFSEND_POSRESERVED(IACT_P, ISLAVE) + 1
+        IREQ = BUFSEND_POSRESERVED(IACT_P, ISLAVE)
+       IF (IREQ > NBRECORDS ) THEN
+         IF (IREQ > huge(NBRECORDS)-1000 - NOMP_SHARED-2) THEN
+          BUFSEND_POSRESERVED(IACT_P, ISLAVE) =  min(NBRECORDS+1, 
+     &                     BUFSEND_POSRESERVED(IACT_P, ISLAVE) )
+         ENDIF
+           IF (NOMP_SHARED.EQ.1)
+     &      CALL ZMUMPS_ARROW_TRY_PROGRESS_COMM (IOMP,
+     &       MYID, NPROCS, NBRECORDS, 
+     &       MPI_InvolvedinSend, MPI_InvolvedinRecv, 
+     &       COMM, ISENDREQI, ISENDREQR, BUFSENDI, BUFSENDR, 
+     &       IACT, SEND_ACTIVE, BUFSEND_POSRESERVED, 
+     &       IRECVREQI, IRECVREQR, BUFRECVI, BUFRECVR,
+     &       RECV_BUF_STATUS, NB_END_MSG_2_RECV, 
+     &       EndNZloc, MPI_End_Send, End_TreatRecvBuf
+     &       )
+          IF (TH_InvolvedinTreatRecv) 
+     &    CALL ZMUMPS_ARROW_TRY_TREAT_RECV_BUF (IOMP,
+     &             BUFRECVI, BUFRECVR, RECV_BUF_STATUS, 
+     &             NPROCS, NBRECORDS, N, IW4,
+     &             KEEP, LOCAL_M, LOCAL_N, root, PTR_ROOT, S, LA,
+     &             NB_END_MSG_2_RECV, MYID, PROCNODE_STEPS,
+     &             SLAVEF,
+     &             PTRAW, 
+     &             PTR8ARR, NINCOLARR, NINROWARR, PTRDEBARR,
+     &             PERM, STEP,
+     &             INTARR, LINTARR, DBLARR, LDBLARR, 
+     &             NOMP_SHARED, EARLYT3ROOTINS, NO_ATOMIC_Warrow)
+           IF (NOMP_SHARED.EQ.1) THEN
+             CALL ZMUMPS_ARROW_TRY_PROGRESS_COMM (IOMP,
+     &        MYID, NPROCS, NBRECORDS, 
+     &        MPI_InvolvedinSend, MPI_InvolvedinRecv, 
+     &        COMM, ISENDREQI, ISENDREQR, BUFSENDI, BUFSENDR, 
+     &        IACT, SEND_ACTIVE, BUFSEND_POSRESERVED, 
+     &        IRECVREQI, IRECVREQR, BUFRECVI, BUFRECVR,
+     &        RECV_BUF_STATUS, NB_END_MSG_2_RECV, 
+     &        EndNZloc, MPI_End_Send, End_TreatRecvBuf
+     &        )
+           ELSE
+              IF (.NOT.TH_InvolvedinTreatRecv) THEN
+               CALL MUMPS_USLEEP(200)
+              ELSE
+               CALL MUMPS_USLEEP(20)
+              ENDIF
+           ENDIF
+         GOTO 100
+       ENDIF
+       BUFSENDI(IREQ*2,IACT_P,ISLAVE)   = ISEND
+       BUFSENDI(IREQ*2+1,IACT_P,ISLAVE) = JSEND
+       BUFSENDR(IREQ,IACT_P,ISLAVE )    = VAL
+       IF (IREQ.EQ.NBRECORDS) THEN
+!$OMP    ATOMIC WRITE
+            BUFSENDI(1,IACT_P,ISLAVE) = NBRECORDS
+!$OMP    END ATOMIC 
+       ENDIF
+      ELSE
+!$OMP  ATOMIC CAPTURE
+       BUFSEND_POSRESERVED(IACT_P,ISLAVE) = 
+     &         BUFSEND_POSRESERVED(IACT_P, ISLAVE) + 1
+       IREQ = BUFSEND_POSRESERVED(IACT_P, ISLAVE)
+!$OMP  END ATOMIC
+       IF (IREQ > huge(NBRECORDS)-NOMP_SHARED-2) THEN
+!$OMP   ATOMIC UPDATE
+        BUFSEND_POSRESERVED(IACT_P, ISLAVE) =  min(NBRECORDS+1, 
+     &                     BUFSEND_POSRESERVED(IACT_P, ISLAVE) )
+!$OMP   END ATOMIC
+       ENDIF
+       IF (IREQ > NBRECORDS ) THEN
+          IF (NOMP_SHARED.EQ.1) THEN
+            CALL ZMUMPS_ARROW_TRY_PROGRESS_COMM (IOMP,
+     &       MYID, NPROCS, NBRECORDS, 
+     &       MPI_InvolvedinSend, MPI_InvolvedinRecv, 
+     &       COMM, ISENDREQI, ISENDREQR, BUFSENDI, BUFSENDR, 
+     &       IACT, SEND_ACTIVE, BUFSEND_POSRESERVED, 
+     &       IRECVREQI, IRECVREQR, BUFRECVI, BUFRECVR,
+     &       RECV_BUF_STATUS, NB_END_MSG_2_RECV, 
+     &       EndNZloc, MPI_End_Send, End_TreatRecvBuf
+     &       )
+          ENDIF
+          IF (TH_InvolvedinTreatRecv) 
+     &    CALL ZMUMPS_ARROW_TRY_TREAT_RECV_BUF (IOMP,
+     &             BUFRECVI, BUFRECVR, RECV_BUF_STATUS, 
+     &             NPROCS, NBRECORDS, N, IW4,
+     &             KEEP, LOCAL_M, LOCAL_N, root, PTR_ROOT, S, LA,
+     &             NB_END_MSG_2_RECV, MYID, PROCNODE_STEPS,
+     &             SLAVEF,
+     &             PTRAW, 
+     &             PTR8ARR, NINCOLARR, NINROWARR, PTRDEBARR,
+     &             PERM, STEP,
+     &             INTARR, LINTARR, DBLARR, LDBLARR, 
+     &             NOMP_SHARED, EARLYT3ROOTINS, NO_ATOMIC_Warrow)
+          IF (NOMP_SHARED.EQ.1) THEN
+             CALL ZMUMPS_ARROW_TRY_PROGRESS_COMM (IOMP,
+     &        MYID, NPROCS, NBRECORDS, 
+     &        MPI_InvolvedinSend, MPI_InvolvedinRecv, 
+     &        COMM, ISENDREQI, ISENDREQR, BUFSENDI, BUFSENDR, 
+     &        IACT, SEND_ACTIVE, BUFSEND_POSRESERVED, 
+     &        IRECVREQI, IRECVREQR, BUFRECVI, BUFRECVR,
+     &        RECV_BUF_STATUS, NB_END_MSG_2_RECV, 
+     &        EndNZloc, MPI_End_Send, End_TreatRecvBuf
+     &        )
+          ELSE 
+            IF (.NOT.TH_InvolvedinTreatRecv) THEN
+             CALL MUMPS_USLEEP(200)
+            ELSE
+             CALL MUMPS_USLEEP(20)
+            ENDIF
+          ENDIF
+         GOTO 100
+         ENDIF
+         BUFSENDI(IREQ*2,IACT_P,ISLAVE)   = ISEND
+         BUFSENDI(IREQ*2+1,IACT_P,ISLAVE) = JSEND
+         BUFSENDR(IREQ,IACT_P,ISLAVE )    = VAL
+!$OMP    ATOMIC UPDATE
+         BUFSENDI(1,IACT_P,ISLAVE) = BUFSENDI(1,IACT_P,ISLAVE) + 1
+!$OMP    END ATOMIC 
+      ENDIF
+      RETURN
+      END SUBROUTINE ZMUMPS_DIST_FILL_SEND_BUFFER
+      END SUBROUTINE ZMUMPS_FAC_ARROW_ARRANGE
+#endif
diff -pruN 5.6.2-2.1/src/zfac_distrib_ELT.F 5.7.1-1/src/zfac_distrib_ELT.F
--- 5.6.2-2.1/src/zfac_distrib_ELT.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/zfac_distrib_ELT.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -38,8 +38,6 @@ C
       COMPLEX(kind=8) A( LA )
       TYPE(ZMUMPS_STRUC)     :: id
       TYPE(ZMUMPS_ROOT_STRUC) :: root
-      INTEGER numroc
-      EXTERNAL numroc
       INCLUDE 'mpif.h'
       INCLUDE 'mumps_tags.h'
       INTEGER :: IERR_MPI
diff -pruN 5.6.2-2.1/src/zfac_distrib_distentry.F 5.7.1-1/src/zfac_distrib_distentry.F
--- 5.6.2-2.1/src/zfac_distrib_distentry.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/zfac_distrib_distentry.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -126,10 +126,8 @@ C
       TYPE (ZMUMPS_ROOT_STRUC) :: root
       INTEGER PROCNODE_STEPS(KEEP(28)), PERM( N ), STEP( N )
       INTEGER INFO( 80 ), ICNTL(60)
-      INTEGER MUMPS_PROCNODE, MUMPS_TYPENODE, numroc, 
-     &        MUMPS_TYPESPLIT
-      EXTERNAL MUMPS_PROCNODE, MUMPS_TYPENODE, numroc, 
-     &        MUMPS_TYPESPLIT
+      INTEGER MUMPS_TYPESPLIT
+      EXTERNAL MUMPS_TYPESPLIT
       INCLUDE 'mumps_tags.h'
       INCLUDE 'mpif.h'
       INTEGER :: IERR, MSGSOU
@@ -626,6 +624,7 @@ C
       KEEP(49) = ARROW_ROOT
  100  CONTINUE
       IF (ALLOCATED(IW4))     DEALLOCATE( IW4 )
+      IF (ALLOCATED(PTRAW))   DEALLOCATE( PTRAW )
       IF (ALLOCATED(BUFI))    DEALLOCATE( BUFI )
       IF (ALLOCATED(BUFR))    DEALLOCATE( BUFR )
       IF (ALLOCATED(BUFRECI)) DEALLOCATE( BUFRECI )
diff -pruN 5.6.2-2.1/src/zfac_driver.F 5.7.1-1/src/zfac_driver.F
--- 5.6.2-2.1/src/zfac_driver.F	2023-10-11 09:37:10.000000000 +0000
+++ 5.7.1-1/src/zfac_driver.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -137,8 +137,9 @@ C     (pointer to point on used-data in
       LOGICAL, PARAMETER :: BDUMMY =.FALSE.
       INTEGER, PARAMETER :: PANEL_TABSIZE = 20
       INTEGER COLOUR, COMM_FOR_SCALING ! For Simultaneous scaling
-      INTEGER LIWK, LWK_REAL
-      INTEGER(8) :: LWK
+      INTEGER(8) :: LIWK
+      INTEGER(8) :: LWK, LWK_REAL, LWRKR_TH, LWRKC_TH
+      INTEGER    :: NOMP_MAX
 C     I_AM_SLAVE: used to determine if proc has the role of a slave
 C     WK_USER_PROVIDED is set to true when WK_USER is provided by user
       LOGICAL I_AM_SLAVE, PERLU_ON, WK_USER_PROVIDED, EARLYT3ROOTINS
@@ -154,6 +155,7 @@ C     WK_USER_PROVIDED is set to true wh
 C temporary variables for collecting stats from all processors
       DOUBLE PRECISION :: TMP_MRY_LU_FR
       DOUBLE PRECISION :: TMP_MRY_LU_LRGAIN
+      INTEGER :: KEEP399_SAVE
       DOUBLE PRECISION :: TMP_MRY_CB_FR
       DOUBLE PRECISION :: TMP_MRY_CB_LRGAIN
       DOUBLE PRECISION :: TMP_FLOP_LRGAIN
@@ -203,18 +205,21 @@ C temporary variables for collecting sta
       DOUBLE PRECISION :: TMP_TIME_FRASM_MAPLIG1
       DOUBLE PRECISION :: TMP_TIME_FRASM_CONTRIB2
 C
-C  Workspace.
+C  Workspace
 C
       INTEGER, DIMENSION(:), ALLOCATABLE :: IWK
       COMPLEX(kind=8), DIMENSION(:), ALLOCATABLE :: WK
-      DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE :: WK_REAL
+      DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE    :: WK_REAL
+      DOUBLE PRECISION, DIMENSION(:,:), ALLOCATABLE:: WRKR_TH, 
+     &                                    WRKC_TH
       INTEGER(8), DIMENSION(:), ALLOCATABLE :: IWK8
       INTEGER, DIMENSION(:), ALLOCATABLE :: BURP
       INTEGER, DIMENSION(:), ALLOCATABLE :: BUCP
       INTEGER, DIMENSION(:), ALLOCATABLE :: BURS
       INTEGER, DIMENSION(:), ALLOCATABLE :: BUCS
-      INTEGER BUREGISTRE(12)
-      INTEGER BUINTSZ, BURESZ, BUJOB
+      INTEGER(8) :: BUREGISTRE(12)
+      INTEGER(8) :: BUINTSZ, BURESZ, NZ_loc8
+      INTEGER    :: BUJOB
       INTEGER BUMAXMN, M, SCMYID, SCNPROCS
       DOUBLE PRECISION    SCONEERR, SCINFERR
 C
@@ -224,21 +229,23 @@ C
 *     Control parameters: see description in ZMUMPSID
       DOUBLE PRECISION,DIMENSION(:),POINTER::RINFO, RINFOG
       DOUBLE PRECISION,DIMENSION(:),POINTER::    CNTL
-      INTEGER,DIMENSION(:),POINTER:: INFOG, KEEP
-      INTEGER, DIMENSION(:), POINTER :: MYIRN_loc, MYJCN_loc
-      COMPLEX(kind=8), DIMENSION(:), POINTER :: MYA_loc
+      INTEGER,DIMENSION(:),POINTER   :: INFOG, KEEP
+      INTEGER, DIMENSION(:), POINTER :: IRN_loc_PTR, JCN_loc_PTR
+      DOUBLE PRECISION, DIMENSION(:), POINTER   :: COLSCA_PTR, 
+     &                                 ROWSCA_PTR
+      COMPLEX(kind=8), DIMENSION(:), POINTER:: A_loc_PTR
       INTEGER, TARGET :: DUMMYIRN_loc(1), DUMMYJCN_loc(1)
+      DOUBLE PRECISION, TARGET    :: DUMMYSCA(1)
       COMPLEX(kind=8), TARGET :: DUMMYA_loc(1)
       INTEGER,DIMENSION(:),POINTER::ICNTL
       EXTERNAL MUMPS_GET_POOL_LENGTH
-      INTEGER MUMPS_GET_POOL_LENGTH
+      INTEGER MUMPS_GET_POOL_LENGTH, SIZESCAL
       INTEGER(8) :: TOTAL_BYTES
       INTEGER(8) :: I8TMP, LWK_USER_SUM8
 C
 C  External references
 C  ===================
-      INTEGER numroc
-      EXTERNAL numroc
+      INTEGER, EXTERNAL :: MUMPS_NUMROC
       INTEGER:: NWORKING
       LOGICAL:: MEM_EFF_ALLOCATED
       INTEGER   :: TOTAL_MBYTES_UNDER_L0
@@ -260,13 +267,13 @@ C     --------------------------
       KEEP=>id%KEEP
       ICNTL=>id%ICNTL
       IF (id%KEEP8(29) .NE. 0) THEN
-        MYIRN_loc=>id%IRN_loc
-        MYJCN_loc=>id%JCN_loc
-        MYA_loc=>id%A_loc
+        IRN_loc_PTR=>id%IRN_loc
+        JCN_loc_PTR=>id%JCN_loc
+        A_loc_PTR=>id%A_loc
       ELSE
-        MYIRN_loc=>DUMMYIRN_loc
-        MYJCN_loc=>DUMMYJCN_loc
-        MYA_loc=>DUMMYA_loc
+        IRN_loc_PTR=>DUMMYIRN_loc
+        JCN_loc_PTR=>DUMMYJCN_loc
+        A_loc_PTR=>DUMMYA_loc
       ENDIF
       NOMP = 1 
       N = id%N
@@ -295,13 +302,6 @@ C     Number of symmetric swaps
       id%KEEP8(80)=0_8
 C     Largest increase of internal panel size
       id%KEEP(425) =0
-C     and KEEP8(83) to the ddress of ICNTL(50)
-C     Set KEEP8(84) to the address of RINFO(3)
-      IF (id%KEEP(500) .EQ. 0 ) THEN ! MUMPS called from Fortran
-        CALL MUMPS_ADDR_C( ICNTL(50), id%KEEP8(83) )
-        CALL MUMPS_ADDR_C( RINFO (3), id%KEEP8(84) )
-      ENDIF
-C
       PRINT_MAXAVG = .NOT.(id%NSLAVES.EQ.1 .AND. KEEP(46).EQ.1)
 C     Print per node informtation only in case ther are several
 C     compute nodes (id%KEEP(412): #MPI procs on comupte node)
@@ -451,15 +451,19 @@ C       For symmetric (non general) matr
 C       set (directly) CNTL1 = 0.0
 C       ---------------------------------------
         KEEP(17)=0
-        IF ( KEEP(50) .eq. 1 ) THEN
-          IF (CNTL1 .ne. ZERO ) THEN
-            IF ( PROKG ) THEN
-              WRITE(MPG,'(A)')
-     & '** Warning : SPD solver called, resetting CNTL(1) to 0.0D0'
-            END IF
-          END IF
-          CNTL1 = ZERO
-        END IF
+C       Automatic choice if CNTL(1)<0
+C       For rank-revealing (KEEP(19).GT.0) then
+C       set CNTL1=0.1 even if SYM=1 
+        IF (CNTL1.LT.ZERO) THEN
+C        automatic choice
+         IF (KEEP(19).GT.0) THEN
+          CNTL1=0.1D0
+         ELSE IF (KEEP(50).EQ.1) THEN
+          CNTL1=ZERO
+         ELSE
+          CNTL1=0.01D0
+         ENDIF
+        ENDIF
 C       CNTL1 threshold value must be between 
 C       0.0 and 1.0 (for SYM=0) and 0.5 (for SYM=1,2)
         IF (CNTL1.GT.ONE)   CNTL1=ONE
@@ -482,7 +486,7 @@ C        out of range values
          PARPIV_T1 =0
         ENDIF
 C       note that KEEP(50).EQ.1 => CNTL1=0.0
-        IF (CNTL1.EQ.0.0.OR.(KEEP(50).eq.1)) PARPIV_T1 = 0 
+        IF (CNTL1.EQ.0.0D0.OR.(KEEP(50).eq.1)) PARPIV_T1 = 0 
 C
         IF (PARPIV_T1.EQ.-2) THEN
          IF (KEEP(19).NE.0) THEN
@@ -498,6 +502,22 @@ C         but do NOT switch off PARPIV_1
         CALL MPI_BCAST( KEEP(269), 1, MPI_INTEGER,
      &                  MASTER, id%COMM, IERR )
         IF (id%MYID.EQ.MASTER) THEN
+C{
+C         OMP parallelization of arrowheads
+C         out of range are treated as zero
+          IF (KEEP(399).LT.-1) KEEP(399)=-1
+          KEEP399_SAVE = KEEP(399)
+          IF (KEEP(399).EQ.-1) THEN
+            IF ((KEEP(54).EQ.0).AND.(id%NPROCS.GT.1)) THEN
+              KEEP(399) = 1
+            ELSE
+              KEEP(399) = 3
+            ENDIF
+          ENDIF
+#if defined(PCPRET)
+C         new multithreaded >=2 algo does not compile on PCPRET
+          KEEP(399) = 1
+#endif
 C         -----------------------------------------------------
 C         Decoding of ICNTL(35) for factorization: same as
 C         at analysis except that we store a copy of ICNTL(35)
@@ -628,11 +648,16 @@ C             Reset to 3 if 5 or to 4 if
             ENDIF
           ENDIF
  105    CONTINUE
+C}
         ENDIF  ! id%MYID .EQ. MASTER
         CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                        id%COMM, id%MYID )
 C
         IF (id%INFO(1).LT.0) GOTO 530
+        CALL MPI_BCAST( KEEP(281), 1, MPI_INTEGER,
+     &                  MASTER, id%COMM, IERR )
+        CALL MPI_BCAST( KEEP(399), 1, MPI_INTEGER,
+     &                  MASTER, id%COMM, IERR )
         CALL MPI_BCAST( KEEP(473), 14, MPI_INTEGER,
      &                  MASTER, id%COMM, IERR )
         IF (KEEP(486).NE.0) THEN
@@ -669,6 +694,8 @@ C         -- Low Level I/O strategy
      &                  MASTER, id%COMM, IERR )
           CALL MPI_BCAST( KEEP(211), 1, MPI_INTEGER,
      &                  MASTER, id%COMM, IERR )
+          CALL MPI_BCAST( KEEP(255), 1, MPI_INTEGER,
+     &                  MASTER, id%COMM, IERR )
         ENDIF
 C     Fwd in facto: explicitly forbid
 C     sparse RHS and A-1 computation
@@ -833,7 +860,7 @@ C       -- More expensive setting of SIM
 C
         IF ( ((KEEP(52).EQ.7).OR.(KEEP(52).EQ.8)) .AND. 
      &       KEEP(54).NE.0 ) THEN
-C         ------------------------------
+C{        ------------------------------
 C         Scaling for distributed matrix
 C         We need to allocate scaling
 C         arrays on all processors, not
@@ -858,13 +885,14 @@ C         ------------------------------
          M = N
          BUMAXMN=M
          IF(N > BUMAXMN) BUMAXMN = N
-         LIWK = 4*BUMAXMN
-         ALLOCATE (IWK(LIWK),BURP(M),BUCP(N),
-     &            BURS(2* (id%NPROCS)),BUCS(2* (id%NPROCS)),
+         LIWK = 4_8*int(BUMAXMN,8)
+         ALLOCATE (IWK(LIWK), BURP(M), BUCP(N),
+     &            BURS(2* id%NPROCS), BUCS(2* id%NPROCS),
      &            stat=allocok)
          IF (allocok > 0) THEN
             id%INFO(1)=-13
-            id%INFO(2)=LIWK+M+N+4* (id%NPROCS)
+            CALL MUMPS_SET_IERROR(LIWK+int(M,8)+int(N,8)+
+     &      4_8*int(id%NPROCS,8) , id%INFO(2))
          ENDIF
 C        --- Propagate enventual error
          CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
@@ -873,27 +901,38 @@ C        --- Propagate enventual error
 C        -- estimation of memory and construction of partvecs
          BUJOB = 1
 C        -- LWK not used
-         LWK_REAL   = 1
+         LWK_REAL = 1_8
+         LWRKR_TH = 1_8
+         LWRKC_TH = 1_8
+         NOMP_MAX   = 1
          ALLOCATE(WK_REAL(LWK_REAL),
+     &            WRKR_TH(LWRKR_TH,NOMP_MAX),
+     &            WRKC_TH(LWRKC_TH,NOMP_MAX),
      &            stat=allocok)
          IF (allocok > 0) THEN
             id%INFO(1)=-13
-            id%INFO(2)=LWK_REAL
+            CALL MUMPS_SET_IERROR(
+     &             LWK_REAL+ 
+     &             LWRKR_TH*int(NOMP_MAX,8)+
+     &             LWRKC_TH*int(NOMP_MAX,8),
+     &             id%INFO(2))
          ENDIF
 C        --- Propagate enventual error
          CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
      &        id%COMM, id%MYID )
          IF (id%INFO(1).LT.0) GOTO 517
          CALL ZMUMPS_SIMSCALEABS(
-     &        MYIRN_loc(1), MYJCN_loc(1), MYA_loc(1),
+     &        IRN_loc_PTR(1), JCN_loc_PTR(1), A_loc_PTR(1),
      &        id%KEEP8(29),
      &        M, N,  id%NPROCS, id%MYID, id%COMM,
      &        BURP, BUCP,
      &        BURS, BUCS, BUREGISTRE,
      &        IWK, LIWK,
      &        BUINTSZ, BURESZ, BUJOB,
-     &        id%ROWSCA(1), id%COLSCA(1), WK_REAL, LWK_REAL,
-     &        id%KEEP(50),
+     &        id%ROWSCA(1), id%COLSCA(1), WK_REAL, LWK_REAL, 
+     &        WRKR_TH, LWRKR_TH, 
+     &        WRKC_TH, LWRKC_TH,
+     &        NOMP_MAX, id%KEEP(50),
      &        K231, K232, K233, 
      &        id%DKEEP(3),
      &        SCONEERR, SCINFERR)
@@ -903,15 +942,40 @@ C        --- Propagate enventual error
             ALLOCATE(IWK(LIWK), stat=allocok)
             IF (allocok > 0) THEN
                id%INFO(1)=-13
-               id%INFO(2)=LIWK
+               CALL MUMPS_SET_IERROR(LIWK,id%INFO(2))
             ENDIF
          ENDIF
-         LWK_REAL = BURESZ
-         DEALLOCATE(WK_REAL)
-         ALLOCATE (WK_REAL(LWK_REAL), stat=allocok)
+         DEALLOCATE(WK_REAL, WRKR_TH, WRKC_TH)
+         LWK_REAL     = BURESZ
+C
+C        -- Set NOMP_MAX from KEEP(281)
+         CALL ZMUMPS_SET_NOMP_MAX(id%KEEP(281), id%KEEP(361), 
+     &                            N, NOMP_MAX)
+C
+         IF (NOMP_MAX.LE.1) THEN
+C          temp array per thread not used
+           LWRKR_TH = 1
+           LWRKC_TH = 1
+         ELSE
+           LWRKR_TH = N
+           IF (id%KEEP(50).NE.0) THEN
+C            WRKC_TH not used on symmetric matrices
+             LWRKC_TH = 1
+           ELSE
+             LWRKC_TH = N
+           ENDIF
+         ENDIF
+         ALLOCATE(WK_REAL(LWK_REAL),
+     &            WRKR_TH(LWRKR_TH,max(NOMP_MAX,1)),
+     &            WRKC_TH(LWRKC_TH,max(NOMP_MAX,1)),
+     &            stat=allocok)
          IF (allocok > 0) THEN
             id%INFO(1)=-13
-            id%INFO(2)=LWK_REAL
+            CALL MUMPS_SET_IERROR(
+     &             LWK_REAL+ 
+     &             LWRKR_TH*int(max(NOMP_MAX,1),8)+
+     &             LWRKC_TH*int(max(NOMP_MAX,1),8),
+     &             id%INFO(2))
          ENDIF
 C        --- Propagate enventual error
          CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
@@ -920,7 +984,7 @@ C        --- Propagate enventual error
 C        -- estimation of memory and construction of partvecs
          BUJOB = 2
          CALL ZMUMPS_SIMSCALEABS(
-     &        MYIRN_loc(1), MYJCN_loc(1), MYA_loc(1),
+     &        IRN_loc_PTR(1), JCN_loc_PTR(1), A_loc_PTR(1),
      &        id%KEEP8(29),
      &        M, N,  id%NPROCS, id%MYID, id%COMM,
      &        BURP, BUCP,
@@ -928,16 +992,20 @@ C        -- estimation of memory and con
      &        IWK, LIWK,
      &        BUINTSZ, BURESZ, BUJOB,
      &        id%ROWSCA(1), id%COLSCA(1), WK_REAL, LWK_REAL,
-     &        id%KEEP(50),
+     &        WRKR_TH, LWRKR_TH, 
+     &        WRKC_TH, LWRKC_TH,
+     &        NOMP_MAX, id%KEEP(50),
      &        K231, K232, K233, 
      &        id%DKEEP(3),
      &        SCONEERR, SCINFERR)
          id%DKEEP(4) = SCONEERR
          id%DKEEP(5) = SCINFERR
 CXXXX 
-         DEALLOCATE(IWK, WK_REAL,BURP,BUCP,BURS, BUCS)
+         DEALLOCATE(IWK, BURP,BUCP,BURS, BUCS)
+         DEALLOCATE(WK_REAL, WRKR_TH, WRKC_TH)
+C}
         ELSE IF ( KEEP(54) .EQ. 0 ) THEN
-C         ------------------
+C{        ------------------
 C         Centralized matrix
 C         ------------------
           IF ((KEEP(52).EQ.7).OR.(KEEP(52).EQ.8))  THEN
@@ -955,21 +1023,45 @@ C             --------------------------
                  M = N
                  BUMAXMN=N
                  IF(N > BUMAXMN) BUMAXMN = N
-                 LIWK = 1
-                 ALLOCATE(IWK(LIWK),BURP(1),BUCP(1),
-     &                BURS(1),BUCS(1),
+                 LIWK = 1_8
+                 ALLOCATE(IWK(LIWK), BURP(1), BUCP(1),
+     &                BURS(1), BUCS(1),
      &                stat=allocok)
                  IF (allocok > 0) THEN
                     id%INFO(1)=-13
-                    id%INFO(2)=LIWK+1+1+1+1
+                    CALL MUMPS_SET_IERROR( LIWK+4_8, id%INFO(2) )
                     GOTO 400
                  ENDIF
-                 LWK_REAL = M + N  
-                 ALLOCATE (WK_REAL(LWK_REAL), stat=allocok)
+                 LWK_REAL = int(M,8) + int(N,8)  
+C
+C                -- Set NOMP_MAX from KEEP(281)
+                 CALL ZMUMPS_SET_NOMP_MAX(id%KEEP(281), id%KEEP(361), 
+     &                                    N, NOMP_MAX)
+C
+                 IF (NOMP_MAX.LE.1) THEN
+C                  temp array per thread not used
+                   LWRKR_TH = 1
+                   LWRKC_TH = 1
+                 ELSE
+                   LWRKR_TH = N
+                   IF (id%KEEP(50).NE.0) THEN
+C                    WRKC_TH not used on symmetric matrices
+                     LWRKC_TH = 1
+                   ELSE
+                     LWRKC_TH = N
+                   ENDIF
+                 ENDIF
+                 ALLOCATE(WK_REAL(LWK_REAL),
+     &                    WRKR_TH(LWRKR_TH,max(NOMP_MAX,1)),
+     &                    WRKC_TH(LWRKC_TH,max(NOMP_MAX,1)),
+     &                    stat=allocok)
                  IF (allocok > 0) THEN
                     id%INFO(1)=-13
-                    id%INFO(2)=LWK_REAL
-                    GOTO 400
+                    CALL MUMPS_SET_IERROR(
+     &                     LWK_REAL+ 
+     &                     LWRKR_TH*int(max(NOMP_MAX,1),8)+
+     &                     LWRKC_TH*int(max(NOMP_MAX,1),8),
+     &                     id%INFO(2))
                  ENDIF
                  CALL MPI_COMM_RANK(COMM_FOR_SCALING, SCMYID, IERR)
                  CALL MPI_COMM_SIZE(COMM_FOR_SCALING, SCNPROCS, IERR)
@@ -983,7 +1075,9 @@ C             --------------------------
      &                IWK, LIWK,
      &                BUINTSZ, BURESZ, BUJOB,
      &                id%ROWSCA(1), id%COLSCA(1), WK_REAL, LWK_REAL,
-     &                id%KEEP(50),
+     &                WRKR_TH, LWRKR_TH, 
+     &                WRKC_TH, LWRKC_TH,
+     &                NOMP_MAX, id%KEEP(50),
      &                K231, K232, K233, 
      &                id%DKEEP(3),
      &                SCONEERR, SCINFERR)
@@ -1001,7 +1095,9 @@ C             --------------------------
      &                IWK, LIWK,
      &                BUINTSZ, BURESZ, BUJOB,
      &                id%ROWSCA(1), id%COLSCA(1), WK_REAL, LWK_REAL,
-     &                id%KEEP(50),
+     &                WRKR_TH, LWRKR_TH, 
+     &                WRKC_TH, LWRKC_TH,
+     &                NOMP_MAX, id%KEEP(50),
      &                K231, K232, K233, 
      &                id%DKEEP(3),
      &                SCONEERR, SCINFERR)
@@ -1009,6 +1105,8 @@ C             --------------------------
                  id%DKEEP(5) = SCINFERR
  400             CONTINUE
                  IF (allocated(WK_REAL)) DEALLOCATE(WK_REAL)
+                 IF (allocated(WRKR_TH)) DEALLOCATE(WRKR_TH)
+                 IF (allocated(WRKC_TH)) DEALLOCATE(WRKC_TH)
                  IF (allocated(IWK))     DEALLOCATE(IWK)
                  IF (allocated(BURP))    DEALLOCATE(BURP)
                  IF (allocated(BUCP))    DEALLOCATE(BUCP)
@@ -1027,31 +1125,34 @@ C               freed on the master proc
      &             id%COMM, id%MYID)
               IF (id%INFO(1).LT.0) GOTO 517
           ELSE IF (id%MYID.EQ.MASTER) THEN
-C           ----------------------------------
-C           Centralized scaling, options 1 to 6
-C           ----------------------------------
+C           -------------------
+C           Centralized scaling
+C           -------------------
             IF (KEEP(52).GT.0 .AND. KEEP(52).LE.6) THEN
 C             ---------------------
 C             Allocate temporary
 C             workspace for scaling
 C             ---------------------
-              IF ( KEEP(52) .eq. 5 .or. 
-     &          KEEP(52) .eq. 6 ) THEN
-C               We have an explicit copy of the original
-C               matrix in complex format which should probably
-C               be avoided (but do we want to keep all
-C               those old scaling options ?)
-                LWK = id%KEEP8(28)
-              ELSE
+              IF (KEEP(52) .eq. 1 ) THEN
+C               No workspace indeed needed
                 LWK = 1_8
+                LWK_REAL = 1_8
+              ELSE IF ( KEEP(52) .eq. 3 ) THEN 
+                LWK = 1_8
+                LWK_REAL = int(N,8)
+              ELSE IF ( KEEP(52) .eq. 4 ) THEN
+C               Options 3 or 4
+                LWK = 1_8
+                LWK_REAL = 2_8*int(N,8)
               END IF
-              LWK_REAL = 5 * N
+C             Real workarray
               ALLOCATE( WK_REAL( LWK_REAL ), stat = IERR )
               IF ( IERR .GT. 0 ) THEN
                 id%INFO(1) = -13
-                id%INFO(2) = LWK_REAL
+                CALL MUMPS_SET_IERROR( LWK_REAL, id%INFO(2) )
                 GOTO 137
               END IF
+C             Real/complex workarray
               ALLOCATE( WK( LWK ), stat = IERR )
               IF ( IERR .GT. 0 ) THEN
                 id%INFO(1) = -13
@@ -1066,11 +1167,12 @@ C               those old scaling option
               DEALLOCATE( WK )
             ENDIF
           ENDIF
+C}
         ENDIF ! Scaling distributed matrices or centralized
         IF (KEEP(125).NE.0) THEN
 C         ------------------------
 C           If we enable the scaling of the |A11 A12| block
-C           we et to 1 the scaling corresponding to the Schur
+C           we set to 1 the scaling corresponding to the Schur
 C           complement matrix A22
 C         ------------------------
             IF ((KEEP(60).GT.0) .and. (KEEP(116).GT.0)) THEN
@@ -1098,6 +1200,7 @@ C             Scaling available on maste
         IF (id%MYID.EQ.MASTER) THEN
             CALL MUMPS_SECFIN(TIMEET)
             id%DKEEP(92)=TIMEET
+          IF (PROKG) WRITE( MPG, 140 ) TIMEET
 C         Print inf-norm after last KEEP(233) iterations of
 C         scaling option KEEP(52)=7 or 8 (SimScale)
 C
@@ -1147,6 +1250,9 @@ C       of the original matrix.
 C       ********************
 C
  137  CONTINUE
+      CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
+     &     id%COMM, id%MYID )
+      IF (id%INFO(1).LT.0) GOTO 517
 C     Fwd in facto: in case of repeated factorizations
 C     with different Schur options we prefer to free
 C     systematically this array now than waiting for
@@ -1172,11 +1278,11 @@ C     to make it available on all proces
       IF (id%KEEP(252) .EQ. 1) THEN
           IF ( id%MYID.NE.MASTER ) THEN
             id%KEEP(254) = N              ! Leading dimension
-            id%KEEP(255) = N*id%KEEP(253) ! Tot size
-            ALLOCATE(RHS_MUMPS(id%KEEP(255)),stat=IERR)
+            id%KEEP8(85) = int(N,8)*int(id%KEEP(253),8) ! Tot size
+            ALLOCATE(RHS_MUMPS(id%KEEP8(85)),stat=IERR)
             IF (IERR > 0) THEN
                id%INFO(1)=-13
-               id%INFO(2)=id%KEEP(255)
+               CALL MUMPS_SET_IERROR(id%KEEP8(85), id%INFO(2))
                IF (LPOK)
      &         WRITE(LP,*) 'ERROR while allocating RHS on a slave'
                NULLIFY(RHS_MUMPS)
@@ -1185,7 +1291,8 @@ C     to make it available on all proces
           ELSE 
 C           Case of non working master
             id%KEEP(254)=id%LRHS              ! Leading dimension
-            id%KEEP(255)=id%LRHS*(id%KEEP(253)-1)+id%N ! Tot size
+            id%KEEP8(85)=int(id%LRHS,8)*int(id%KEEP(253)-1,8)+
+     &                   int(id%N,8) ! Tot size
             RHS_MUMPS=>id%RHS
             RHS_MUMPS_ALLOCATED = .FALSE.
             IF (LSCAL) THEN
@@ -1202,7 +1309,7 @@ C             transpose).
             ENDIF
           ENDIF
       ELSE
-          id%KEEP(255)=1
+          id%KEEP8(85)=1_8
           ALLOCATE(RHS_MUMPS(1),stat=IERR)
           IF (IERR > 0) THEN
              id%INFO(1)=-13
@@ -1215,7 +1322,7 @@ C             transpose).
       ENDIF
       CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
      &                    id%COMM, id%MYID )
-      IF ( id%INFO(1).lt.0 ) GOTO 517
+      IF ( id%INFO(1).lt.0 ) GOTO 516
       IF (KEEP(252) .EQ. 1) THEN
 C
 C         Broadcast the columns of the right-hand side
@@ -1236,7 +1343,7 @@ C       KEEP(110) defaults to 0 for out
       ENDIF
       CALL MPI_BCAST(KEEP(110), 1, MPI_INTEGER,
      &               MASTER, id%COMM, IERR)
-      IF (KEEP(219).NE.0) THEN
+      IF ((KEEP(50).EQ.2).AND.(KEEP(219).NE.0)) THEN
        CALL ZMUMPS_BUF_MAX_ARRAY_MINSIZE(max(KEEP(108),1),IERR)
        IF (IERR .NE. 0) THEN
 C      ------------------------
@@ -1254,6 +1361,7 @@ C               ( A row is considered as
 C         CNTL(5) is then used to define if a large 
 C                 value is set on the diagonal or if a 1 is set
 C                 and other values in the row are reset to zeros.
+C       -rank revealing on the Schur (ICNTL(56)/KEEP(19))
 C         SEUIL* corresponds to the minimum required 
 C                absolute value of pivot.
 C         SEUIL_LDLT_NIV2 is used only in the 
@@ -1338,6 +1446,10 @@ C      sing val.
          ELSE IF  (CNTL3 .GT. ZERO) THEN
            id%DKEEP(9) = CNTL3*ANORMINF
          ELSE  !  (CNTL(3) .EQ. ZERO) THEN
+           CALL MUMPS_NPIV_CRITICAL_PATH(
+     &     N, KEEP(28), id%STEP(1), id%FRERE_STEPS(1), id%FILS(1),
+     &     id%NA(1), id%LNA, id%NE_STEPS(1), NPIV_CRITICAL_PATH )
+           id%DKEEP(9) = sqrt(dble(NPIV_CRITICAL_PATH))*EPS*ANORMINF  
          ENDIF
          IF (PROKG) THEN 
            WRITE(MPG, '(A,I16)')
@@ -1430,6 +1542,7 @@ C     Find id of root node if RR is on
       ENDIF
 C Second pass:  set parameters for null pivot detection
 C Allocate PIVNUL_LIST_STRUCT in case of null pivot detection
+C and in case of rank revealing
       KEEP(109) = 0
       LPN_LIST  = 0
       IF(KEEP(110) .EQ. 1) THEN
@@ -1451,7 +1564,7 @@ C Allocate PIVNUL_LIST_STRUCT in case of
 C end set parameter for null pivot detection
       CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
      &                    id%COMM, id%MYID )
-      IF ( id%INFO(1).lt.0 ) GOTO 517
+      IF ( id%INFO(1).lt.0 ) GOTO 516
 C   --------------------------------------------------------------
 C   STATIC PIVOTING
 C     -- Static pivoting only when RR and Null pivot detection OFF
@@ -1515,7 +1628,7 @@ C       -- Set MAXS to size of WK_USER_
       CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
      &                    id%COMM, id%MYID )
       IF (id%INFO(1) .LT. 0) THEN
-        GOTO 517
+        GOTO 516
       ENDIF
 C
       id%KEEP8(75) = huge(id%KEEP8(75))
@@ -1604,7 +1717,7 @@ C
       CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
      &                    id%COMM, id%MYID )
       IF (id%INFO(1) .LT. 0) THEN
-        GOTO 517
+        GOTO 516
       ENDIF
       CALL MUMPS_SETI8TOI4(MAXS, id%INFO(39))
       CALL ZMUMPS_AVGMAX_STAT8(PROKG, MPG, MAXS, id%NSLAVES,
@@ -1996,11 +2109,11 @@ C     id%S will be checked later)
 C     ---------------------------------------------
       IF (EARLYT3ROOTINS .AND. KEEP(38).NE.0 .AND.
      &    KEEP(60) .EQ.0 .AND. I_AM_SLAVE) THEN
-        LWK = int(numroc( id%root%ROOT_SIZE, id%root%MBLOCK,
+        LWK = int(MUMPS_NUMROC( id%root%ROOT_SIZE, id%root%MBLOCK,
      &             id%root%MYROW, 0, id%root%NPROW ),8)
         LWK = max( 1_8, LWK )
         LWK = LWK*
-     &        int(numroc( id%root%ROOT_SIZE, id%root%NBLOCK,
+     &        int(MUMPS_NUMROC( id%root%ROOT_SIZE, id%root%NBLOCK,
      &        id%root%MYCOL, 0, id%root%NPCOL ),8)
         LWK = max( 1_8, LWK )
       ELSE
@@ -2017,6 +2130,122 @@ C     arrowheads of root.
      &                        id%COMM, id%MYID )
       IF ( id%INFO(1).LT.0 ) GOTO 500
 C
+C     =====================================================
+      IF (KEEP(399).GE.2) THEN
+C{    Multihtreaded algorithm taking into account all cases
+C     =====================================================
+C
+C        Timing on master.
+         IF (id%MYID.EQ.MASTER) THEN
+           CALL MUMPS_SECDEB(TIME)
+         END IF
+C
+         NZ_loc8   = 0_8
+         NBRECORDS = KEEP(39)
+         SIZESCAL = id%N
+C        Set  NZ_loc8, A_loc_PTR, IRN_loc_PTR, JCN_loc_PTR
+C        and update NBRECORDS
+         IF (KEEP(54).EQ.0) THEN
+C         centralized matrix
+          IF (id%KEEP8(28) .LT. int(NBRECORDS,8)) THEN
+              NBRECORDS = int(id%KEEP8(28))
+          ENDIF
+          IF (id%MYID.EQ.MASTER) THEN
+           NZ_loc8 = id%KEEP8(28)
+           A_loc_PTR   => id%A
+           IRN_loc_PTR => id%IRN
+           JCN_loc_PTR => id%JCN
+           IF (LSCAL) THEN
+             COLSCA_PTR => id%COLSCA
+             ROWSCA_PTR => id%ROWSCA
+           ELSE
+             COLSCA_PTR  => DUMMYSCA
+             ROWSCA_PTR  => DUMMYSCA
+             SIZESCAL  = 1
+           ENDIF
+          ELSE
+           A_loc_PTR   => DUMMYA_loc
+           IRN_loc_PTR => DUMMYIRN_loc
+           JCN_loc_PTR => DUMMYJCN_loc
+           COLSCA_PTR  => DUMMYSCA
+           ROWSCA_PTR  => DUMMYSCA
+           SIZESCAL  = 1
+          ENDIF
+         ELSE
+C         distributed matrix
+C         ---------------------------------------------------
+C         In order to have possibly IRN_loc/JCN_loc/A_loc
+C         of size 0, avoid to pass them inside REDISTRIBUTION
+C         and pass id instead
+C         NZ_locMAX8 gives as a maximum buffer size (send/recv) used
+C          an upper bound to limit buffers on small matrices
+C         ---------------------------------------------------
+          CALL MPI_ALLREDUCE(id%KEEP8(29), NZ_locMAX8, 1, 
+     &              MPI_INTEGER8, MPI_MAX, id%COMM, IERR)
+          IF (NZ_locMAX8 .LT. int(NBRECORDS,8)) THEN
+              NBRECORDS = int(NZ_locMAX8)
+          ENDIF
+          NZ_loc8 = id%KEEP8(29)
+          LSCAL   = (KEEP(52).EQ.7).OR.(KEEP(52).EQ.8)
+C         available on all MPI
+          IF (LSCAL) THEN
+            COLSCA_PTR => id%COLSCA
+            ROWSCA_PTR => id%ROWSCA
+          ELSE
+           COLSCA_PTR  => DUMMYSCA
+           ROWSCA_PTR  => DUMMYSCA
+           SIZESCAL  = 1
+          ENDIF
+         ENDIF
+#if ! defined(PCPRET)
+          IF (id%KEEP(72).EQ.1) THEN
+           NBRECORDS = max(3,NBRECORDS/10)
+          ENDIF
+         CALL ZMUMPS_FAC_DIST_ARROWHEADS_OMP ( id%N,
+     &     NZ_loc8, 
+C          replace id by:
+     &        A_loc_PTR(1), IRN_loc_PTR(1), JCN_loc_PTR(1),
+     &        SIZESCAL, LSCAL, COLSCA_PTR(1), ROWSCA_PTR(1), 
+     &     DBLARR(1), id%KEEP8(26), INTARR(1),
+     &     id%KEEP8(27),
+     &     id%PTR8ARR(1), id%NINCOLARR(1),
+     &     id%NINROWARR(1), id%PTRDEBARR(1),
+     &     id%FILS(1),
+     &     KEEP(1), id%KEEP8(1), id%MYID, id%COMM, NBRECORDS,
+     &     S_PTR_ARG(1), MAXS_ARG, id%root, id%PROCNODE_STEPS(1),
+     &     id%NPROCS, id%NSLAVES, id%SYM_PERM(1), id%STEP(1),
+     &     id%ICNTL(1), id%INFO(1), NSEND8, NLOCAL8,
+     &     id%ISTEP_TO_INIV2(1),
+     &     id%CANDIDATES(1,1) 
+     &     )
+         CALL MPI_BARRIER(id%COMM, IERR)
+#else 
+#endif
+C     
+         IF ( KEEP(46) .eq. 0 .AND. id%MYID.eq.MASTER ) THEN
+C          ------------------------------
+C          The host is not working -> had
+C          no data from initial matrix
+C          ------------------------------
+           NSEND8  = 0_8
+           NLOCAL8 = 0_8
+         END IF
+C        -------------------------
+C        Check for possible errors
+C        -------------------------
+         CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
+     &                    id%COMM, id%MYID )
+         IF ( id%INFO( 1 ) .LT. 0 ) GOTO 500
+         CALL MPI_REDUCE( NSEND8, NSEND_TOT8, 1, MPI_INTEGER8,
+     &                 MPI_SUM, MASTER, id%COMM, IERR )
+         CALL MPI_REDUCE( NLOCAL8, NLOCAL_TOT8, 1, MPI_INTEGER8,
+     &                 MPI_SUM, MASTER, id%COMM, IERR )
+         IF ( PROKG ) THEN
+           WRITE(MPG,125) NLOCAL_TOT8, NSEND_TOT8
+         END IF
+C}        
+      ELSE
+C{   =======================================================
       IF ( KEEP(54) .eq. 0 ) THEN
 C     {
 C       ================================================
@@ -2243,6 +2472,8 @@ C     --------------------------
 C     }
       ENDIF ! distributed matrix
 C     }
+      ENDIF !  "old" multithreaded algorithm 
+C     }
       ELSE
 C     {
 C       -------------------
@@ -2306,8 +2537,9 @@ C       We check the number of threads.
             id%INFO(1)=-58
             id%INFO(2)=KEEP(400)
             IF (LPOK) WRITE(LP,'(A,A,I5,A,I5)')
-     &" FAILURE DETECTED IN FACTORIZATION: #threads for KEEP(401)",
-     &" changed from",KEEP(400)," at analysis to", NOMP
+     &" FAILURE DETECTED IN FACTORIZATION: #threads for multithreaded",
+     &" tree parallelism changed from",KEEP(400)," at analysis to", 
+     &  NOMP
           ENDIF
 C       error check
         CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
@@ -2394,6 +2626,13 @@ C
         ZMUMPS_LBUFR_BYTES8 = min(ZMUMPS_LBUFR_BYTES8,
      &                            int(huge(I4)-100,8))
         ZMUMPS_LBUFR_BYTES  = int( ZMUMPS_LBUFR_BYTES8 )
+C       ZMUMPS_LBUFR is the size of the buffer as a number of integers,
+C       we round ZMUMPS_LBUFR (size in #integers) above to have at least
+C       ZMUMPS_LBUFR_BYTES available in the buffer.
+        ZMUMPS_LBUFR = (ZMUMPS_LBUFR_BYTES+KEEP(34)-1)/KEEP(34)
+C       Finally, make ZMUMPS_LBUFR_BYTES a multiple of KEEP(34) by setting
+C       ZMUMPS_LBUFR_BYTES to the number of bytes that will be allocated
+        ZMUMPS_LBUFR_BYTES = ZMUMPS_LBUFR*KEEP(34)
         IF (KEEP(48)==5) THEN
 C          Since the buffer is going to be allocated, use
 C          it as the constraint for memory/granularity
@@ -2464,12 +2703,17 @@ C       are in numbers of bytes).
         IF ( PROK ) THEN
           WRITE( MP, 9999 ) ZMUMPS_LBUFR_BYTES,
      &                      ZMUMPS_LBUF, ZMUMPS_LBUF_INT
+        ELSE 
+         IF (PROKG) THEN
+          WRITE( MPG, 9999 ) ZMUMPS_LBUFR_BYTES,
+     &                      ZMUMPS_LBUF, ZMUMPS_LBUF_INT
+         ENDIF
         END IF
  9999   FORMAT( /,' Allocated buffers',/,' ------------------',/,
-     &  ' Size of reception buffer in bytes ...... = ', I10,
+     &  ' Size of reception buffer in bytes ...... = ', I12,
      &  /,
-     &  ' Size of async. emission buffer (bytes).. = ', I10,/,
-     &  ' Small emission buffer (bytes) .......... = ', I10)
+     &  ' Size of async. emission buffer (bytes).. = ', I12,/,
+     &  ' Small emission buffer (bytes) .......... = ', I12)
 C       --------------------------
 C       Allocate small send buffer
 C       required for ZMUMPS_FAC_B
@@ -2491,7 +2735,6 @@ C       --------------------------------
 C       Allocate reception buffer on all procs
 C       This is done now.
 C       --------------------------------------
-        ZMUMPS_LBUFR = (ZMUMPS_LBUFR_BYTES+KEEP(34)-1)/KEEP(34)
         ALLOCATE( BUFR( ZMUMPS_LBUFR ),stat=IERR )
         IF ( IERR .NE. 0 ) THEN
           id%INFO(1) = -13
@@ -2821,7 +3064,7 @@ C     --------------------------------
       IF (allocated(BUFR)) DEALLOCATE(BUFR)
       CALL ZMUMPS_BUF_DEALL_SMALL_BUF( IERR )
 C//PIV
-      IF (KEEP(219).NE.0) THEN
+      IF ((KEEP(50).EQ.2).AND.(KEEP(219).NE.0)) THEN
       CALL ZMUMPS_BUF_DEALL_MAX_ARRAY()
       ENDIF
 C
@@ -2833,6 +3076,10 @@ C     not be necessary.
      &                    id%COMM, id%MYID )
 C
       CALL ZMUMPS_EXTRACT_SCHUR_REDRHS(id)
+C     return to user singular values
+      IF (id%KEEP(19) .NE.0) THEN
+       CALL ZMUMPS_EXTRACT_SINGULAR_VALUES(id)
+      ENDIF
       IF (KEEP(201) .GT. 0) THEN
          IF ((KEEP(201).EQ.1) .OR. (KEEP(201).EQ.2)) THEN
             IF ( I_AM_SLAVE ) THEN
@@ -3403,6 +3650,9 @@ C           flops when BLR activated
           ELSE
             RINFOG(14) = 0.0D00
           ENDIF
+        IF (id%MYID .eq. MASTER) THEN
+          KEEP(399) = KEEP399_SAVE
+        ENDIF
       ENDIF
 C     ==============================
 C     NULL PIVOTS AND RANK-REVEALING
@@ -3444,7 +3694,7 @@ C      (do not allocate)
         ENDIF
        ELSE
 C       id%PIVNUL_LIST(1:KEEP(109)) used during sol_driver on slaves 
-C       to initialize id%RHSCOMP
+C       to initialize id%RHSINTR
         IF (KEEP(109).GT.0) THEN
           ALLOCATE(id%PIVNUL_LIST(KEEP(109)), stat=IERR)
           IF ( IERR .GT. 0 ) THEN
@@ -3458,6 +3708,34 @@ C}
       CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
      &                    id%COMM, id%MYID )
       IF ( id%INFO(1).lt.0 ) GOTO 490
+      IF ( (KEEP(19).NE.0) .AND. (KEEP(143) .NE. KEEP(17)) ) THEN
+C
+C         Raise a warning (on all MPI processes) since determinant or
+C         inertia or null pivot list is not consistent with deficiency
+C         computed with ICNTL(46)=1.
+C
+        id%INFO(1) = id%INFO(1)+16
+        id%INFO(2) = KEEP(112)+KEEP(143)
+        IF (KEEP(118) .GE. 40) THEN
+          IF ( PROKG ) THEN
+            WRITE(MPG,'(/A,A/,A,A,I8/,A,A,I8/)')
+     &      " WARNING: in the context of rank-revealing,",
+     &      " the inertia, determinant and pivnul list",  
+     &      " are computed with RR (rank-revealing)-LU,", 
+     &      " but the deficiency found by RR-LU: ", 
+     &      id%INFO(2),
+     &      " is different from the deficiency computed",
+     &      " with ICNTL(56)>0: ",  KEEP(112)+KEEP(17)
+          ENDIF
+        ELSE
+          IF ( LP .GT. 0 ) THEN
+            WRITE(LP,'(/A,A/,A/)')
+     &      " ERROR : in the context of rank-revealing,",
+     &      " the inertia, determinant and pivnul list",  
+     &      " are not correct because RR LU not called "
+          ENDIF
+        ENDIF
+      ENDIF
 C     ========================================
 C     We now provide to the host the part of
 C     PIVNUL_LIST resulting from the processing
@@ -3615,9 +3893,6 @@ C         of max-weighted matching)
           IF (id%KEEP(23).NE.0) THEN
             CALL ZMUMPS_DETER_SIGN_PERM(
      &           RINFOG(12), id%N,
-C           id%STEP: used as workspace of size N still
-C                    allocated on master; restored on exit
-     &           id%STEP(1),
      &           id%UNS_PERM(1) )
 C           Remark that RINFOG(12/13) are modified only
 C           on the host but will be broadcast on exit
@@ -3690,6 +3965,14 @@ c         IF ( KEEP(17) .ne. 0 )
           !Total deficiency
           IF (KEEP(110).NE.0.OR.KEEP(19).NE.0)
      &    WRITE(MPG, 99992) KEEP(17)+KEEP(112) ! = INFOG(28)
+          !Smallest pivot with also null pivots in abs value
+          WRITE(MPG, 99995) RINFOG(19)
+          !Smallest pivot in abs value
+          WRITE(MPG, 99993) RINFOG(20)
+          !Largest pivot in abs value
+          WRITE(MPG, 99994) RINFOG(21)
+          !value of ICNTL(12) that was effectively used.
+          WRITE(MPG, 99996) INFOG(24)
           ! Memory compress
           WRITE(MPG, 99981) INFOG(14)
           ! Extra copies due to ip stack in unsym case
@@ -3907,7 +4190,7 @@ C     at the end of a phase S is always
       END IF
 C
 C     Goto 513 is done in case of error where LOAD_INIT was
-C     called but not OOC_INIT_FACTO.
+C     called but not the scaling nor OOC_INIT_FACTO.
  513  CONTINUE
       IF ( I_AM_SLAVE ) THEN
          CALL ZMUMPS_LOAD_END( id%INFO(1), id%NSLAVES, IERR )
@@ -3916,9 +4199,37 @@ C     called but not OOC_INIT_FACTO.
       CALL MUMPS_PROPINFO( ICNTL(1), id%INFO(1),
      &     id%COMM, id%MYID )
 C
-C     Goto 517 is done when an error occurs when GPU initialization
-C     has been performed but not LOAD_INIT or OOC_INIT_FACTO
+C     Goto 516 is done in case of error when GPU initialiwqtion
+C     has been performed and scaling was optionally computed but
+C     not LOAD_INIT nor OOC_INIT_FACTO. We can then extract
+C     scaling arrays in case of error.
+ 516  CONTINUE
+C     --------------------------------------------
+C     We now build id%ROWSCA_loc and id%COLSCA_loc
+C     in case of successful factorization, in the
+C     numbering associated to the fully summed
+C     variables of the frontal matrices.
+C     This requires the factorization to be
+C     successful because otherwise we do not have
+C     the final lists of pivots associated to
+C     the fronts, including delayed pivots and
+C     symmetric/unsymmetric permutations done
+C     during the factorization process.
+C     --------------------------------------------
+      IF (LSCAL .AND. id%INFO(1).GE.0) THEN
+        CALL ZMUMPS_EXTRACT_SCALING(id)
+C       occurs during scaling extraction, keep the error.
+        IF ( id%INFO(1) .LT. 0 ) THEN
+          IF (LPOK) THEN
+            WRITE(LP,*) "Facto OK but error during EXTRACT_SCALING",
+     &      id%INFO(1:2)
+          ENDIF
+        ENDIF
+      ENDIF
 C
+C     Goto 517 is done when an error occurs when GPU initialization
+C     has been performed but not LOAD_INIT or OOC_INIT_FACTO, e.g.
+C     when an error occurred during the scaling.
  517  CONTINUE
       IF (associated( PIVNUL_LIST_STRUCT%PIVNUL_LIST)) THEN
         DEALLOCATE(PIVNUL_LIST_STRUCT%PIVNUL_LIST)
@@ -3939,10 +4250,12 @@ C
  120  FORMAT(/' Local redistrib: data local/sent           =',I16,I16)
  125  FORMAT(/' Redistrib: total data local/sent           =',I16,I16)
  130  FORMAT(//'****** FACTORIZATION STEP ********'/)
+ 140  FORMAT(/' Statistics on the scaling phase'
+     & /' Elapsed time for scaling                   =',F12.4)
  160  FORMAT(
-     & /' Elapsed time to reformat/distribute matrix =',F12.4)
+     & ' Elapsed time to reformat/distribute matrix =',F12.4/)
  166  FORMAT(' Max difference from 1 after scaling the entries',
-     &       ' for ONE-NORM (option 7/8)   =',D9.2)
+     &       ' for ONE-NORM (option 7/8)   =',D9.2/)
  170  FORMAT(' STATISTICS PRIOR NUMERICAL FACTORIZATION ...'/
      &        ' Size of internal working array S           =',I16/
      &        ' Size of internal working array IS          =',I16/
@@ -4000,6 +4313,14 @@ C
      &      I16)
 99992 FORMAT( ' INFOG (28) Estimated deficiency                    =',
      &      I16)
+99995 FORMAT( ' RINFOG(19) Smallest pivot WITH perturbed pivots    =',
+     &     1PD10.3)
+99993 FORMAT( ' RINFOG(20) Smallest pivot WITHOUT perturbed pivots =',
+     &     1PD10.3)
+99994 FORMAT( ' RINFOG(21) Largest pivot in absolute value         =',
+     &     1PD10.3)
+99996 FORMAT( ' INFOG (24) Effective value of ICNTL(12)            =',
+     &     I16)
 99984 FORMAT(/'Leaving factorization with ...'/
      &        ' RINFOG (2) Operations in node assembly             =',
      &          1PD10.3/                                   
@@ -4086,6 +4407,186 @@ C
  110  FORMAT(A48,I18)
       END SUBROUTINE ZMUMPS_AVGMAX_STAT8
 C
+C
+C     ==================================================================
+C
+      SUBROUTINE ZMUMPS_EXTRACT_SCALING(id)
+      USE ZMUMPS_STRUC_DEF
+      IMPLICIT NONE
+C
+C     Purpose:
+C     =======
+C
+C     Extract distributed scaling arrays from ZMUMPS_EXTRACT_SCALING
+C     In case of unsymmetric permutation, ROWSCA and COLSCA correspond
+C     to Dr and Dc, in the expression Dr A Q Dc. In other terms, Dc
+C     is compatbile with the front column indices, it does not
+C     correspond to the column indices of A, meaning that Q is not
+C     needed to just extract the scaling values.
+C
+C
+      TYPE(ZMUMPS_STRUC) :: id
+      INTEGER, EXTERNAL  :: MUMPS_PROCNODE
+C
+C     MPI
+C     ===
+C
+      INCLUDE 'mpif.h'
+C
+C     Local declarations
+C     ==================
+C
+      DOUBLE PRECISION, DIMENSION(:), POINTER :: COLSCA
+      DOUBLE PRECISION, DIMENSION(:), POINTER :: ROWSCA
+      INTEGER, PARAMETER :: MASTER = 0
+C
+      INTEGER    :: ISTEP, NPIV, LIELL
+      INTEGER    :: IERR_MPI, allocok
+      INTEGER    :: ISCA
+      INTEGER    :: JROW, JCOL, IPOS, JJ ! access to IS
+      INTEGER    :: LIW_PASSED
+      INTEGER(8) :: LALLOC
+C
+C     Free and reallocate distributed scaling arrays :
+C     - in symmetric, COLSCA_loc points on ROWSCA_loc.
+C     - not allocated if KEEP(89)=0
+C
+      NULLIFY(ROWSCA)
+      NULLIFY(COLSCA)
+      IF (associated(id%ROWSCA_loc)) THEN
+        DEALLOCATE(id%ROWSCA_loc)
+        NULLIFY(id%ROWSCA_loc)
+      ENDIF
+      IF (associated(id%COLSCA_loc)) THEN
+        IF (id%KEEP(50) .EQ. 0) THEN
+          DEALLOCATE(id%COLSCA_loc)
+        ENDIF
+        NULLIFY(id%COLSCA_loc)
+      ENDIF
+C     id%ROWSCA and id%COLSCA are available on master,
+C     allocate ROWSCA and COLSCA of order N on other procs
+      IF ( id%MYID .EQ. MASTER ) THEN
+        ROWSCA => id%ROWSCA
+        COLSCA => id%COLSCA
+        IF (.NOT. associated(ROWSCA)) THEN
+          WRITE(*,*) "Internal error 1 in ZMUMPS_EXTRACT_SCALING"
+          CALL MUMPS_ABORT()
+        ENDIF
+        IF (.NOT. associated(COLSCA)) THEN
+          WRITE(*,*) "Internal error 2 in ZMUMPS_EXTRACT_SCALING"
+          CALL MUMPS_ABORT()
+        ENDIF
+      ELSE
+        IF (id%KEEP(50).EQ.0) THEN
+          ALLOCATE(ROWSCA(id%N),COLSCA(id%N),stat=allocok)
+          LALLOC = int(id%N+id%N,8)
+        ELSE
+          ALLOCATE(ROWSCA(id%N),stat=allocok)
+          COLSCA => ROWSCA
+          LALLOC = int(id%N,8)
+        ENDIF
+        IF (allocok .GT. 0) THEN
+          id%INFO(1)=-13
+          CALL MUMPS_SET_IERROR(LALLOC,id%INFO(2))
+        ENDIF
+      ENDIF
+      CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                        id%COMM, id%MYID )
+C     Jump to 110 in case of error on ROWSCA or COLSCA
+C     on one of the MPI processes.
+      IF (id%INFO(1) .LT. 0) GOTO 110
+C
+      IF ( id%KEEP(89) .GT. 0) THEN
+        IF (id%KEEP(50).EQ.0) THEN
+          ALLOCATE(id%ROWSCA_loc(id%KEEP(89)),
+     &             id%COLSCA_loc(id%KEEP(89)),stat=allocok)
+          LALLOC = int(id%KEEP(89),8)*2_8
+        ELSE
+          ALLOCATE(id%ROWSCA_loc(id%KEEP(89)),stat=allocok)
+          id%COLSCA_loc => id%ROWSCA_loc
+          LALLOC = int(id%KEEP(89),8)
+        ENDIF
+        IF (allocok .GT. 0) THEN
+          id%INFO(1)=-13
+          CALL MUMPS_SET_IERROR(LALLOC,id%INFO(2))
+        ENDIF
+      ENDIF
+      CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                        id%COMM, id%MYID )
+C     Jump to 100 in case of error (we free everything)
+      IF (id%INFO(1) .LT. 0) GOTO 100
+      CALL MPI_BCAST(ROWSCA(1), id%N, MPI_DOUBLE_PRECISION,
+     &               MASTER, id%COMM, IERR_MPI)
+      IF (id%KEEP(50) .EQ. 0) THEN
+        CALL MPI_BCAST(COLSCA(1), id%N, MPI_DOUBLE_PRECISION,
+     &                 MASTER, id%COMM, IERR_MPI)
+      ENDIF
+      LIW_PASSED = max(id%KEEP(32),1)
+      ISCA = 1
+      IF ( id%MYID .ne. MASTER .OR.
+     &     id%KEEP(46) .eq. 1 ) THEN ! I_AM_SLAVE
+        DO ISTEP = 1, id%KEEP(28)
+          IF ( id%MYID_NODES.EQ. MUMPS_PROCNODE(
+     &         id%PROCNODE_STEPS(ISTEP),
+     &         id%KEEP(199) ) ) THEN
+              CALL MUMPS_SOL_GET_NPIV_LIELL_IPOS( ISTEP, id%KEEP,
+     &        NPIV, LIELL, IPOS,
+     &        id%IS(1), LIW_PASSED, id%PTLUST_S(1), id%STEP(1), id%N)
+            IF ( id%KEEP(50) .EQ. 0 ) THEN
+C             Row indices:
+              JROW = IPOS + 1
+C             Column indices:
+              JCOL = IPOS + 1 + LIELL
+            ELSE
+C             Use row indices because column indices may have
+C             been set to negative to flag 2x2 pivots
+              JROW = IPOS + 1
+            ENDIF
+            IF (id%KEEP(50).EQ.0) THEN
+              DO JJ = 1, NPIV
+                id%ROWSCA_loc(ISCA+JJ-1) = ROWSCA(id%IS(JROW+JJ-1))
+                id%COLSCA_loc(ISCA+JJ-1) = COLSCA(id%IS(JCOL+JJ-1))
+              ENDDO
+            ELSE
+              DO JJ = 1, NPIV
+                id%ROWSCA_loc(ISCA+JJ-1) = ROWSCA(id%IS(JROW+JJ-1))
+              ENDDO
+            ENDIF
+            ISCA = ISCA + NPIV
+          ENDIF
+        ENDDO
+      ENDIF
+C     End of EXTRACT_SCALING, we keep id%ROWSCA_loc and id%COLSCA_loc
+C     but free ROWSCA and COLSCA
+      GOTO 110
+      RETURN
+ 100  CONTINUE
+C     Exit with error, free what was allocated
+      IF (associated(id%ROWSCA_loc)) THEN
+        DEALLOCATE(id%ROWSCA_loc)
+        NULLIFY(id%ROWSCA_loc)
+      ENDIF
+      IF (associated(id%COLSCA_loc)) THEN
+        IF (id%KEEP(50) .EQ. 0) THEN
+          DEALLOCATE(id%COLSCA_loc)
+        ENDIF
+        NULLIFY(id%COLSCA_loc)
+      ENDIF
+ 110  CONTINUE
+C     Free local ROWSCA and COLSCA arrays
+      IF ( id%MYID .NE. 0) THEN
+        IF (associated(ROWSCA)) DEALLOCATE(ROWSCA)
+        IF ( id%KEEP(50) .EQ. 0 ) THEN
+          IF (associated(COLSCA)) DEALLOCATE(COLSCA)
+        ENDIF
+      ENDIF
+      NULLIFY(ROWSCA)
+      NULLIFY(COLSCA)
+      RETURN
+      END SUBROUTINE ZMUMPS_EXTRACT_SCALING
+C
+C     ==================================================================
+C
       SUBROUTINE ZMUMPS_EXTRACT_SCHUR_REDRHS(id)
       USE ZMUMPS_STRUC_DEF
       IMPLICIT NONE
@@ -4326,3 +4827,145 @@ C                 of size SIZE_SCHUR.
       ENDIF
       RETURN
       END SUBROUTINE ZMUMPS_EXTRACT_SCHUR_REDRHS
+      SUBROUTINE ZMUMPS_EXTRACT_SINGULAR_VALUES(id)
+      USE ZMUMPS_STRUC_DEF
+      IMPLICIT NONE
+C
+C  Purpose
+C  =======
+C
+C     
+      TYPE(ZMUMPS_STRUC) :: id
+C
+C  Local variables
+C  ===============
+C
+      INCLUDE 'mpif.h'
+      INCLUDE 'mumps_tags.h'
+      INCLUDE 'mumps_headers.h'
+      INTEGER :: STATUS(MPI_STATUS_SIZE)
+      INTEGER :: IERR
+      INTEGER, PARAMETER :: MASTER = 0
+      INTEGER :: ID_ROOT, ALLOCOK
+C
+C  External functions
+C  ==================
+C
+      INTEGER MUMPS_PROCNODE
+      EXTERNAL MUMPS_PROCNODE
+C     Quick return in case factorization did not terminate correctly
+      IF (id%INFO(1) .LT. 0) RETURN
+C     Quick return if Postponing + rank revealing option off
+      IF (id%KEEP(19) .EQ. 0) RETURN
+C     Get Root id
+      ID_ROOT =MUMPS_PROCNODE(
+     &    id%PROCNODE_STEPS(id%STEP(id%KEEP(20))),
+     &    id%KEEP(199))
+      IF ( id%KEEP( 46 )  .NE. 1 ) THEN
+        ID_ROOT = ID_ROOT + 1
+      END IF  
+C     =================================
+C     Singular values are stored in 
+C     root%SINGULAR_VALUES
+C     We copy it to id%SINGULAR_VALUES
+C     =================================
+      IF ((ID_ROOT.EQ.id%MYID).AND.(id%MYID.EQ.MASTER)) THEN
+C        write(6,*) " singular_values already on host"
+         IF (associated(id%SINGULAR_VALUES))
+     &        DEALLOCATE(id%SINGULAR_VALUES)
+         NULLIFY(id%SINGULAR_VALUES)
+         id%NB_SINGULAR_VALUES=id%root%NB_SINGULAR_VALUES
+         ALLOCATE(id%SINGULAR_VALUES(id%NB_SINGULAR_VALUES)
+     &        , stat=ALLOCOK)
+         IF (ALLOCOK.GT.0) THEN
+            id%INFO(1)=-13
+            id%INFO(2)= id%NB_SINGULAR_VALUES
+            RETURN
+         END IF
+         CALL dcopy(id%NB_SINGULAR_VALUES,
+     &        id%root%SINGULAR_VALUES(1), 1,
+     &        id%SINGULAR_VALUES(1), 1)
+      ELSE
+         IF (id%MYID.EQ.ID_ROOT) THEN
+C     Send
+C           write(6,*) " id%MYID sends singular_values "
+            CALL MPI_SEND(
+     &           id%root%NB_SINGULAR_VALUES,
+     &           1,
+     &           MPI_INTEGER,
+     &           MASTER, TAG_ROOT1,
+     &           id%COMM, IERR )
+            CALL MPI_SEND(
+     &           id%root%SINGULAR_VALUES(1),
+     &           id%root%NB_SINGULAR_VALUES,
+     &           MPI_DOUBLE_PRECISION,
+     &           MASTER, TAG_ROOT2,
+     &           id%COMM, IERR )
+         ELSEIF (id%MYID.EQ.MASTER) THEN
+C     Receive
+            CALL MPI_RECV( id%NB_SINGULAR_VALUES,
+     &           1,
+     &           MPI_INTEGER, ID_ROOT, TAG_ROOT1,
+     &           id%COMM, STATUS, IERR )
+            IF (associated(id%SINGULAR_VALUES))
+     &           DEALLOCATE(id%SINGULAR_VALUES)
+            NULLIFY(id%SINGULAR_VALUES)
+            ALLOCATE(id%SINGULAR_VALUES(id%NB_SINGULAR_VALUES)
+     &           , stat=ALLOCOK)
+            IF (ALLOCOK.GT.0) THEN
+               id%INFO(1)=-13
+               id%INFO(2)= id%NB_SINGULAR_VALUES
+               RETURN
+            END IF
+            CALL MPI_RECV( id%SINGULAR_VALUES(1),
+     &           id%NB_SINGULAR_VALUES,
+     &           MPI_DOUBLE_PRECISION, ID_ROOT, TAG_ROOT2,
+     &           id%COMM, STATUS, IERR )
+         ENDIF
+      ENDIF
+      RETURN
+      END SUBROUTINE ZMUMPS_EXTRACT_SINGULAR_VALUES
+      SUBROUTINE ZMUMPS_SET_NOMP_MAX(KEEP281, KEEP361,
+     &                               N, NOMP_MAX)
+!$    USE OMP_LIB
+C
+C  Purpose
+C  =======
+C     set NOMP_MAX from KEEP(281)
+C     on output NOMP_MAX >=0
+C
+C  Parameters
+C  ==========
+C
+      INTEGER, INTENT(IN)    :: KEEP281, KEEP361, N
+      INTEGER, INTENT(OUT)   :: NOMP_MAX
+C     
+C     Local variables
+C   
+      INTEGER :: NOMP
+C
+C     out-of-range entries treated as -1
+      NOMP_MAX= max(-1, KEEP281)
+      NOMP    = 1
+!$    NOMP = omp_get_max_threads()
+      IF (NOMP_MAX.EQ.-1) THEN
+C     automatic setting
+       IF (N.LE.KEEP361) THEN
+         NOMP_MAX = 0
+         RETURN
+       ENDIF
+       IF (NOMP.GT.1) THEN
+C       conservative because of memory allocation
+        NOMP_MAX = min(NOMP, 10)
+       ELSE
+C       no multithreading and all parallel do suppressed
+        NOMP_MAX = 0
+       ENDIF
+      ELSE
+C     NOMP_MAX >=0
+C     use provided value
+       NOMP_MAX = min(NOMP_MAX, NOMP)
+      ENDIF
+C
+      RETURN
+      END SUBROUTINE ZMUMPS_SET_NOMP_MAX
diff -pruN 5.6.2-2.1/src/zfac_front_LDLT_type1.F 5.7.1-1/src/zfac_front_LDLT_type1.F
--- 5.6.2-2.1/src/zfac_front_LDLT_type1.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zfac_front_LDLT_type1.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -136,7 +136,7 @@ C
       XSIZE  = KEEP(IXSZ)
       NFRONT = IW(IOLDPS+XSIZE)
       LDA    = NFRONT
-      NASS   = iabs(IW(IOLDPS+2+XSIZE))
+      NASS   = abs(IW(IOLDPS+2+XSIZE))
       IW(IOLDPS+3+XSIZE) =  -99999
       LR_ACTIVATED= .FALSE.        
       COMPRESS_PANEL = .FALSE.
@@ -251,7 +251,8 @@ C
      &        NFRONT-NASS, LRGROUPS, NPARTSCB, 
      &        NPARTSASS, BEGS_BLR)
          CALL REGROUPING2(BEGS_BLR, NPARTSASS, NASS, NPARTSCB,
-     &        NFRONT-NASS, KEEP(488), .FALSE., KEEP(472))     
+     &        NFRONT-NASS, KEEP(488), .FALSE., KEEP(472), 
+     &        NFRONT, KEEP(1))     
          NB_BLR = NPARTSASS + NPARTSCB
          call MAX_CLUSTER(BEGS_BLR,NB_BLR,MAXI_CLUSTER)
          MAXI_RANK = KEEP(479)*MAXI_CLUSTER
diff -pruN 5.6.2-2.1/src/zfac_front_LDLT_type2.F 5.7.1-1/src/zfac_front_LDLT_type2.F
--- 5.6.2-2.1/src/zfac_front_LDLT_type2.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zfac_front_LDLT_type2.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -74,7 +74,7 @@ C
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
       INTEGER, INTENT(IN) :: NINROWARR(KEEP(195))
       INTEGER, INTENT(IN) :: PTRDEBARR(KEEP(196))
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INTEGER(8) :: PTRAST(KEEP(28))
       INTEGER(8) :: PTRFAC(KEEP(28))
       INTEGER(8) :: PAMASTER(KEEP(28))
@@ -187,7 +187,7 @@ C
       IOLDPS = PTLUST_S(STEP( INODE ))
       POSELT = PTRAST(STEP( INODE ))
       NFRONT = IW(IOLDPS+XSIZE)
-      NASS   = iabs(IW(IOLDPS+2+XSIZE))
+      NASS   = abs(IW(IOLDPS+2+XSIZE))
       LDAFS  = NASS
       IF ((KEEP(219).EQ.1).AND.(KEEP(207).EQ.1).AND.(KEEP(50).EQ.2)
      &   ) THEN
@@ -299,7 +299,8 @@ C
      &        0, LRGROUPS, NPARTSCB, 
      &        NPARTSASS, BEGS_BLR)
          CALL REGROUPING2(BEGS_BLR, NPARTSASS, NASS, NPARTSCB,
-     &        0, KEEP(488), .FALSE., KEEP(472))     
+     &        0, KEEP(488), .FALSE., KEEP(472), 
+     &        NFRONT, KEEP(1))     
          NB_BLR = NPARTSASS + NPARTSCB
          call MAX_CLUSTER(BEGS_BLR,NB_BLR,MAXI_CLUSTER)
          MAXI_RANK = KEEP(479)*MAXI_CLUSTER
diff -pruN 5.6.2-2.1/src/zfac_front_LU_type1.F 5.7.1-1/src/zfac_front_LU_type1.F
--- 5.6.2-2.1/src/zfac_front_LU_type1.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zfac_front_LU_type1.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -143,7 +143,7 @@ C
       LAFAC  = -9999_8  
       XSIZE      = KEEP(IXSZ)
       NFRONT     = IW(IOLDPS+XSIZE)
-      NASS       = iabs(IW(IOLDPS+2+XSIZE))
+      NASS       = abs(IW(IOLDPS+2+XSIZE))
       IW(IOLDPS+3+XSIZE) =  -99999
       LR_ACTIVATED = .FALSE.        
       COMPRESS_PANEL = .FALSE.
@@ -257,7 +257,8 @@ C
      &        NFRONT-NASS, LRGROUPS, NPARTSCB, 
      &        NPARTSASS, BEGS_BLR)
          CALL REGROUPING2(BEGS_BLR, NPARTSASS, NASS, NPARTSCB,
-     &        NFRONT-NASS, KEEP(488), .FALSE., KEEP(472))     
+     &        NFRONT-NASS, KEEP(488), .FALSE., KEEP(472), 
+     &        NFRONT, KEEP(1))     
          NB_BLR = NPARTSASS + NPARTSCB
          call MAX_CLUSTER(BEGS_BLR,NB_BLR,MAXI_CLUSTER)
          MAXI_RANK = KEEP(479)*MAXI_CLUSTER
diff -pruN 5.6.2-2.1/src/zfac_front_LU_type2.F 5.7.1-1/src/zfac_front_LU_type2.F
--- 5.6.2-2.1/src/zfac_front_LU_type2.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zfac_front_LU_type2.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -75,7 +75,7 @@ C
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
       INTEGER, INTENT(IN) :: NINROWARR(KEEP(195))
       INTEGER, INTENT(IN) :: PTRDEBARR(KEEP(196))
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INTEGER(8) :: PTRAST(KEEP(28))
       INTEGER(8) :: PTRFAC(KEEP(28))
       INTEGER(8) :: PAMASTER(KEEP(28))
@@ -166,7 +166,7 @@ C
       POSELT = PTRAST(STEP( INODE ))
       XSIZE  = KEEP(IXSZ)
       NFRONT = IW(IOLDPS+XSIZE)
-      NASS   = iabs(IW(IOLDPS+2+XSIZE))
+      NASS   = abs(IW(IOLDPS+2+XSIZE))
       IW(IOLDPS+3+XSIZE) =  -99999
       LR_ACTIVATED   = (IW(IOLDPS+XXLR).GT.0)
       COMPRESS_PANEL = (IW(IOLDPS+XXLR).GE.2)
@@ -286,7 +286,8 @@ C
      &        NFRONT-NASS, LRGROUPS, NPARTSCB, 
      &        NPARTSASS, BEGS_BLR)
          CALL REGROUPING2(BEGS_BLR, NPARTSASS, NASS, NPARTSCB,
-     &        NFRONT-NASS, KEEP(488), .FALSE., KEEP(472))     
+     &        NFRONT-NASS, KEEP(488), .FALSE., KEEP(472), 
+     &        NFRONT, KEEP(1))     
          NB_BLR = NPARTSASS + NPARTSCB
          call MAX_CLUSTER(BEGS_BLR,NB_BLR,MAXI_CLUSTER)
          MAXI_RANK = KEEP(479)*MAXI_CLUSTER
diff -pruN 5.6.2-2.1/src/zfac_front_aux.F 5.7.1-1/src/zfac_front_aux.F
--- 5.6.2-2.1/src/zfac_front_aux.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zfac_front_aux.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -129,7 +129,7 @@ C
             ELSE
               IF (J3.EQ.0) GOTO 370
 #if defined(_OPENMP)
-              IF (KEEP(351).EQ.1 .AND. J3.GE.KEEP(360)) THEN
+              IF (J3.GE.KEEP(360)) THEN
                 J1_ini = J1
                 CHUNK = max(KEEP(360)/2,(J3+NOMP-1)/NOMP)
 !$OMP  PARALLEL DO schedule(static, CHUNK)
@@ -289,7 +289,7 @@ C
           ENDIF
         ENDIF
 #endif
-        IF (KEEP(351).EQ.2) THEN
+        IF (KEEP(351).EQ.1) THEN
           MAXFROMN = 0.0D0
           IF (NEL2 > 0) THEN
             IS_MAXFROMN_AVAIL = .TRUE.
@@ -677,6 +677,9 @@ C
         NPIV   = IW(IOLDPS+1+XSIZE)
         IBEG_BLOCK = NPIV
         IF (NASS.EQ.NPIV) GOTO 500
+        IF (KEEP(19).GT.0) THEN
+         GOTO 500
+        ENDIF
         IS_MAXFROMN_AVAIL = .FALSE.
  120    CALL ZMUMPS_FAC_H(NFRONT,NASS,IW,LIW,A,LA,
      &     INOPV, NOFFW,
@@ -762,6 +765,7 @@ C
       COMPLEX(kind=8) ZERO
       PARAMETER( ZERO = (0.0D0,0.0D0) )
       DOUBLE PRECISION RZERO, RMAX, AMROW, MAX_PREV_in_PARPIV
+      DOUBLE PRECISION RCMAX
       INTEGER(8) :: APOSMAX, APOSROW
       DOUBLE PRECISION       :: RMAX_NORELAX
       DOUBLE PRECISION PIVNUL, ABS_PIVOT
@@ -1006,11 +1010,45 @@ C
             RMAX         = max(RMAX,abs(RMAX_NORELAX))
             IF (ABS_PIVOT .GE. UU*RMAX .AND.
      &          ABS_PIVOT .GT. max(SEUIL,tiny(RMAX))) THEN
+               IF (KEEP(19).GT.0) THEN
+                 IF (LAST_ROW.EQ.NFRONT) THEN
+                   LRLOC = LAST_ROW -KEEP(253)-NVSCHUR
+                 ELSE
+                   LRLOC = LAST_ROW
+                 ENDIF
+                 J1=POSELT+int(IPIV-1,8)+int(NPIV,8)*NFRONT8
+                 J2=POSELT+int(IPIV-1,8)+int(LRLOC-1,8)*NFRONT8
+                 RCMAX = RZERO
+                 DO JJ=J1, J2, NFRONT8
+                   RCMAX = max(abs(A(JJ)),RCMAX)
+                 ENDDO
+                 IF (ABS_PIVOT .GE. UU*RCMAX) THEN
+                   JMAX = IPIV - NPIV
+                   GO TO 380
+                 ENDIF
+               ELSE
                 JMAX = IPIV - NPIV
                 GO TO 380
+               ENDIF
             ENDIF
             IF ( .NOT. (AMROW .GE. UU*RMAX .AND.
      &                  AMROW .GT. max(SEUIL,tiny(RMAX))) ) GO TO 460
+            IF (KEEP(19).GT.0) THEN
+              IF (LAST_ROW.EQ.NFRONT) THEN
+                LRLOC = LAST_ROW -KEEP(253)-NVSCHUR
+              ELSE
+                LRLOC = LAST_ROW
+              ENDIF
+              J1=POSELT+int(NPIV+JMAX-1,8)+int(NPIV,8)*NFRONT8
+              J2=POSELT+int(NPIV+JMAX-1,8)+int(LRLOC-1,8)*NFRONT8
+              RCMAX = RZERO
+              DO JJ=J1, J2, NFRONT8
+                RCMAX = max(abs(A(JJ)),RCMAX)
+              ENDDO
+              IF (.NOT.(AMROW .GE. UU*RCMAX) ) THEN 
+                GO TO 460
+              ENDIF
+            ENDIF 
             NOFFW = NOFFW + 1
   380       CONTINUE
           IF (K206.GE.1) THEN
@@ -1844,10 +1882,6 @@ C
          LPOS1   = POSPV2 + LDA8 - 1_8
          LPOS2   = LPOS1 + 1_8
 #if defined(__ve__)
-#if defined(check)
-         IF (LDA8.NE.NFRONT8) CALL MUMPS_ABORT()
-         IF (NEL2 + NCB1.NE.LAST_ROW-NPIV_NEW) CALL MUMPS_ABORT()
-#endif
          CALL zcopy(LAST_ROW-NPIV_NEW, A(LPOS1), LDA, A(POSPV1+2_8), 1)
          CALL zcopy(LAST_ROW-NPIV_NEW, A(LPOS2), LDA, A(POSPV2+1_8), 1)
 !$       OMP_FLAG = (NEL2+NCB1 > 300)
@@ -2014,21 +2048,6 @@ C
            BLSIZE = LAST_COL_GEMM - IEND_BLOCK
           END IF
           IF ( LAST_COL_GEMM - IEND_BLOCK .GT. 0 ) THEN
-#if defined(SAK_BYROW)
-           DO IROW = IEND_BLOCK+1, LAST_COL_GEMM, BLSIZE
-            Block = min( BLSIZE, LAST_COL_GEMM - IROW + 1 )
-            LPOS = POSELT + int(IROW  - 1,8) * LDA8 +
-     &                      int(IBEG_BLOCK - 1,8)
-            UPOS = POSELT + int(IBEG_BLOCK - 1,8) * LDA8 +
-     &                      int(IROW - 1,8)
-            APOS = POSELT + int(IROW  - 1,8) * LDA8 + 
-     &             int(IEND_BLOCK,8)
-            CALL zgemm( 'N','N', IROW + Block - IEND_BLOCK - 1, 
-     &             Block, NPIV_BLOCK,
-     &                 ALPHA, A( UPOS ), LDA,
-     &                 A( LPOS ), LDA, ONE, A( APOS ), LDA )
-           ENDDO
-#else
            DO IROW = IEND_BLOCK+1, LAST_COL_GEMM, BLSIZE
             Block = min( BLSIZE, LAST_COL_GEMM - IROW + 1 )
             LPOS = POSELT + int( IROW - 1,8) * LDA8 +
@@ -2040,7 +2059,6 @@ C
      &                 NPIV_BLOCK, ALPHA, A( UPOS ), LDA,
      &                 A( LPOS ), LDA, ONE, A( APOS ), LDA )
            END DO
-#endif
           END IF
 #if defined(GEMMT_AVAILABLE)
          END IF 
diff -pruN 5.6.2-2.1/src/zfac_front_type2_aux.F 5.7.1-1/src/zfac_front_type2_aux.F
--- 5.6.2-2.1/src/zfac_front_type2_aux.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zfac_front_type2_aux.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -728,7 +728,7 @@ C
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
       INTEGER, INTENT(IN) :: NINROWARR(KEEP(195))
       INTEGER, INTENT(IN) :: PTRDEBARR(KEEP(196))
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INTEGER(8) :: PTRAST  (KEEP(28))
       INTEGER(8) :: PTRFAC  (KEEP(28))
       INTEGER(8) :: PAMASTER(KEEP(28))
@@ -798,7 +798,7 @@ C
      &               NSLAVES, WIDTH, COMM,
      &               NELIM, NPARTSASS, CURRENT_BLR_PANEL,
      &               LR_ACTIVATED, BLR_LorU, 
-     &        IERR )
+     &               ICNTL, IERR )
           IF (IERR.EQ.-1) THEN
             BLOCKING  = .FALSE.
             SET_IRECV = .TRUE.
diff -pruN 5.6.2-2.1/src/zfac_lastrtnelind.F 5.7.1-1/src/zfac_lastrtnelind.F
--- 5.6.2-2.1/src/zfac_lastrtnelind.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/zfac_lastrtnelind.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -68,7 +68,7 @@ C
      &        TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
       DOUBLE PRECISION OPASSW, OPELIW
       INTEGER ITLOC( N+KEEP(253) ), FILS( N ), DAD( KEEP(28) )
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
diff -pruN 5.6.2-2.1/src/zfac_lr.F 5.7.1-1/src/zfac_lr.F
--- 5.6.2-2.1/src/zfac_lr.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zfac_lr.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/zfac_mem_alloc_cb.F 5.7.1-1/src/zfac_mem_alloc_cb.F
--- 5.6.2-2.1/src/zfac_mem_alloc_cb.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/zfac_mem_alloc_cb.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/zfac_mem_compress_cb.F 5.7.1-1/src/zfac_mem_compress_cb.F
--- 5.6.2-2.1/src/zfac_mem_compress_cb.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/zfac_mem_compress_cb.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -148,9 +148,6 @@ C
       INTEGER(8) :: RCURRENT_SIZE, DYN_SIZE
       LOGICAL :: RECORD_CAN_BE_COMPRESSED
       INTEGER IXXP
-      INTEGER, EXTERNAL :: MUMPS_TYPENODE
-      INTEGER, EXTERNAL :: MUMPS_PROCNODE
-      LOGICAL, EXTERNAL :: ZMUMPS_ISBAND
       EXTERNAL MPI_WTIME
       DOUBLE PRECISION MPI_WTIME
       DOUBLE PRECISION TIME_STRT
diff -pruN 5.6.2-2.1/src/zfac_mem_dynamic.F 5.7.1-1/src/zfac_mem_dynamic.F
--- 5.6.2-2.1/src/zfac_mem_dynamic.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/zfac_mem_dynamic.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -251,7 +251,7 @@ C
             ENDIF
           ENDIF
           IF ( MOVE2DYNAMIC ) THEN
-#if defined(MUMPS_ALLOC_FROM_C)
+#if defined(MUMPS_ALLOC_FROM_C) || defined(_CRAYFTN)
             CALL MUMPS_MALLOC_C( TMP_ADDRESS,
      &      RCURRENT_SIZE * KEEP(35) )
             IF (TMP_ADDRESS .EQ. 0_8) THEN
@@ -279,7 +279,7 @@ C
      &        LIW-ICURRENT+1, SIZEHOLE, KEEP(IXSZ))
             ENDIF
             CALL MUMPS_STOREI8(RCURRENT_SIZE,IW(ICURRENT+XXD))
-#if defined(MUMPS_ALLOC_FROM_C)
+#if defined(MUMPS_ALLOC_FROM_C) || defined(_CRAYFTN)
             CALL ZMUMPS_DM_SET_PTR( TMP_ADDRESS, RCURRENT_SIZE,
      &                              DYNAMIC_CB )
 #else
@@ -438,7 +438,7 @@ C
       LOGICAL, INTENT(IN) :: ATOMIC_UPDATES
       INTEGER(8) :: KEEP8(150)
       INTEGER IDUMMY
-#if defined(MUMPS_ALLOC_FROM_C)
+#if defined(MUMPS_ALLOC_FROM_C) || defined(_CRAYFTN)
       CALL MUMPS_FREE_C(DYNPTR(1))
 #else
       DEALLOCATE(DYNPTR)
diff -pruN 5.6.2-2.1/src/zfac_mem_free_block_cb.F 5.7.1-1/src/zfac_mem_free_block_cb.F
--- 5.6.2-2.1/src/zfac_mem_free_block_cb.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/zfac_mem_free_block_cb.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/zfac_mem_stack.F 5.7.1-1/src/zfac_mem_stack.F
--- 5.6.2-2.1/src/zfac_mem_stack.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zfac_mem_stack.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -58,7 +58,7 @@ C
       INTEGER INTARR(KEEP8(27)) 
       INTEGER ITLOC( N + KEEP(253) ), FILS( N ), DAD( KEEP(28) ),
      &        ND( KEEP(28) ), FRERE( KEEP(28) )
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INTEGER ISTEP_TO_INIV2(KEEP(71)), 
      &        TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
       INTEGER NELT, LPTRAR
@@ -111,9 +111,8 @@ C
       DOUBLE PRECISION FLOP1, FLOP1_EFFECTIVE
       LOGICAL BLOCKING, SET_IRECV, MESSAGE_RECEIVED
       LOGICAL SSARBR, SSARBR_ROOT, MUMPS_INSSARBR,
-     & MUMPS_IN_OR_ROOT_SSARBR, MUMPS_ROOTSSARBR
-      EXTERNAL MUMPS_INSSARBR, MUMPS_IN_OR_ROOT_SSARBR,
-     & MUMPS_ROOTSSARBR
+     & MUMPS_IN_OR_ROOT_SSARBR
+      EXTERNAL MUMPS_INSSARBR, MUMPS_IN_OR_ROOT_SSARBR
       LP = ICNTL(1)
       IF (ICNTL(4) .LE. 0) LP = -1
       INPLACE = .FALSE.
@@ -123,7 +122,7 @@ C
       NFRONT = IW(IOLDPS+KEEP(IXSZ))
       NPIV   = IW(IOLDPS + 1+KEEP(IXSZ))       
       NMAXNPIV = max(NPIV, NMAXNPIV)
-      NASS   = iabs(IW(IOLDPS + 2+KEEP(IXSZ))) 
+      NASS   = abs(IW(IOLDPS + 2+KEEP(IXSZ))) 
       NSLAVES=  IW(IOLDPS+5+KEEP(IXSZ))
       H_INODE= 6 + NSLAVES + KEEP(IXSZ)
       LCONT = NFRONT - NPIV
diff -pruN 5.6.2-2.1/src/zfac_mem_stack_aux.F 5.7.1-1/src/zfac_mem_stack_aux.F
--- 5.6.2-2.1/src/zfac_mem_stack_aux.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zfac_mem_stack_aux.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/zfac_omp_m.F 5.7.1-1/src/zfac_omp_m.F
--- 5.6.2-2.1/src/zfac_omp_m.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/zfac_omp_m.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -64,7 +64,7 @@ C
       INTEGER(8), INTENT(IN) :: THREAD_LA
       INTEGER PROCNODE_STEPS(KEEP(28))
       INTEGER ITLOC(N+KEEP(253))
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INTEGER NSTK_STEPS(KEEP(28))
       INTEGER(8), INTENT(IN) :: PTRARW(LPTRAR), PTRAIW(LPTRAR)
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
@@ -118,14 +118,8 @@ C
       INTEGER, INTENT (IN)    :: NBCOLS_I4, NBCOLS_I8
       INTEGER, INTENT (IN)    :: I4_L0_OMP(NBSTATS_I4, NBCOLS_I4)
       INTEGER(8), INTENT (IN) :: I8_L0_OMP(NBSTATS_I8, NBCOLS_I8)
-      EXTERNAL MUMPS_TYPENODE, MUMPS_PROCNODE
-      INTEGER MUMPS_TYPENODE, MUMPS_PROCNODE
-      LOGICAL MUMPS_INSSARBR,MUMPS_ROOTSSARBR
-      EXTERNAL MUMPS_INSSARBR,MUMPS_ROOTSSARBR
       LOGICAL ZMUMPS_POOL_EMPTY
       EXTERNAL ZMUMPS_POOL_EMPTY, ZMUMPS_EXTRACT_POOL
-      INTEGER numroc
-      EXTERNAL numroc
       INTEGER :: MYTHREAD_ID, ITH  
       INTEGER :: THREAD_ID_P       
       DOUBLE PRECISION, PARAMETER :: DZERO = 0.0D0, DONE = 1.0D0
@@ -1216,7 +1210,7 @@ C
       INTEGER ITLOC( N + KEEP(253) ), FILS( N ),
      &        ND( KEEP(28) ), FRERE( KEEP(28) )
       INTEGER DAD( KEEP(28) )
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INTEGER ISTEP_TO_INIV2(KEEP(71)), 
      &        TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
       INTEGER NELT, LPTRAR
diff -pruN 5.6.2-2.1/src/zfac_par_m.F 5.7.1-1/src/zfac_par_m.F
--- 5.6.2-2.1/src/zfac_par_m.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/zfac_par_m.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -32,6 +32,7 @@ C
 !$    USE OMP_LIB
       USE ZMUMPS_DYNAMIC_MEMORY_M, ONLY : 
      &                                    ZMUMPS_DM_FREEALLDYNAMICCB
+      USE ZMUMPS_BUF, ONLY : ZMUMPS_BUF_TEST
       USE ZMUMPS_LOAD
       USE ZMUMPS_OOC
       USE ZMUMPS_FAC_ASM_MASTER_M
@@ -64,7 +65,7 @@ C
       INTEGER LPOOL
       INTEGER PROCNODE_STEPS(KEEP(28))
       INTEGER ITLOC(N+KEEP(253))
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INTEGER IW(LIW), NSTK_STEPS(KEEP(28))
       INTEGER(8), INTENT(IN) :: PTRARW(LPTRAR), PTRAIW(LPTRAR)
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
@@ -132,15 +133,31 @@ C
       INTEGER LOCAL_M, LOCAL_N
       INTEGER LRHS_CNTR_MASTER_ROOT, FWD_LOCAL_N_RHS
       LOGICAL ROOT_OWNER
+!$    INTEGER :: NOMP
+!$    INTEGER(8) :: CHUNK8  
+      INTEGER  LIWK_RR, PHASE, MBLOCK, NBLOCK
+      INTEGER(8) :: LWK_RR
+      INTEGER(8) :: I8
+      INTEGER  I, K, KEEP17_LU
+      INTEGER  NOFFNEGPV_ROOT, NTOTPV_ROOT, NB22T1_ROOT, NBTINY_ROOT,
+     &         NULLNEGPV_ROOT,
+     &         DET_EXP_ROOT, DET_SIGN_ROOT, 
+     &         LRecord, Header_ROOT(5)
+      COMPLEX(kind=8)  DET_MANT_ROOT  
+      DOUBLE PRECISION DKEEP_SAVE(230)
+      COMPLEX(kind=8), DIMENSION(:), POINTER     :: A_ROOT_SAVE
+      LOGICAL                            :: IS_A_ROOT_SAVE_ALLOCATED
+      INTEGER, DIMENSION(:), ALLOCATABLE :: RECORD_ROOT
+      INTEGER KEEP_SAVE(500)             
+      INTEGER(8) KEEP8_SAVE(150)
       EXTERNAL MUMPS_TYPENODE, MUMPS_PROCNODE
       INTEGER MUMPS_TYPENODE, MUMPS_PROCNODE
-      LOGICAL MUMPS_INSSARBR,MUMPS_ROOTSSARBR
-      EXTERNAL MUMPS_INSSARBR,MUMPS_ROOTSSARBR
+      LOGICAL MUMPS_INSSARBR
+      EXTERNAL MUMPS_INSSARBR
       LOGICAL ZMUMPS_POOL_EMPTY
       EXTERNAL ZMUMPS_POOL_EMPTY, ZMUMPS_EXTRACT_POOL
       LOGICAL STACK_RIGHT_AUTHORIZED
-      INTEGER numroc
-      EXTERNAL numroc
+      INTEGER, EXTERNAL :: MUMPS_NUMROC
       INTEGER JOBASS, ETATASS
       INTEGER(8) :: LAFAC
       INTEGER LIWFAC, STRAT, TYPEFile, NextPiv2beWritten,
@@ -153,13 +170,6 @@ C
       DOUBLE PRECISION :: ROOTTIME
       INTEGER:: ITH
       DOUBLE PRECISION :: DUMMY_FLOP_ESTIM_ACC
-#if defined(multicore_profiling)
-      DOUBLE PRECISION :: LATIME, LFTIME, LSTIME
-      DOUBLE PRECISION :: GATIME, GFTIME, GSTIME
-      GATIME = 0
-      GFTIME = 0
-      GSTIME = 0
-#endif
       DUMMY_FLOP_ESTIM_ACC = 0.0d0
       ITLOC(1:N+KEEP(253)) =0
       ASS_IRECV = MPI_REQUEST_NULL
@@ -169,6 +179,9 @@ C
       NULLIFY(BUFRX)
       IS_BUFRX_ALLOCATED = .FALSE.
       KEEP(143) = -1
+      KEEP17_LU = -1
+      NULLIFY(A_ROOT_SAVE)
+      IS_A_ROOT_SAVE_ALLOCATED = .FALSE.
       IF ( INFO(1) .LT. 0 ) THEN
         GOTO 640
       ENDIF
@@ -301,6 +314,8 @@ C
      &         MYID_NODES,KEEP,KEEP8,N)
             END IF
             GOTO 30
+          ELSE
+            CALL ZMUMPS_BUF_TEST()
           ENDIF
       ENDIF
       GO TO 20
@@ -532,8 +547,26 @@ C
           WRITE(*,*) "ERROR 2 in ZMUMPS_FAC_PAR", POSELT
           GOTO 635
         ENDIF
+        IF (KEEP(118).GE.40) THEN
+          IOLDPS = PTLUST(STEP(INODE))
+          LRecord = IW(IOLDPS+XXI)
+          IF (allocated(RECORD_ROOT)) DEALLOCATE(RECORD_ROOT)
+          ALLOCATE(RECORD_ROOT(LRecord), stat=IERR)
+          IF (IERR.GT.0) THEN
+            INFO(1)= -13
+            INFO(2)= LRecord
+            IF (LP > 0)
+     &      write(LP,*) "ERROR allocate RECORD_ROOT"
+            GOTO 635
+          ENDIF
+          RECORD_ROOT(1:LRecord) = IW(IOLDPS:IOLDPS+LRecord-1)
+        ENDIF
         CALL ZMUMPS_CHANGE_HEADER
      &       ( IW(PTLUST(STEP(INODE))+KEEP(IXSZ)), KEEP(253) )
+        IF (KEEP(118).GE.40) THEN
+          Header_ROOT(1:5) = IW(PTLUST(STEP(INODE))+KEEP(IXSZ):
+     &                        PTLUST(STEP(INODE))+KEEP(IXSZ)+4)
+        ENDIF
         GOTO 200
       END IF
       POSELT = PTRAST(STEP(INODE))
@@ -554,11 +587,6 @@ C
      &           , PERM
      &           )
            IF (INFO(1).LT.0) GOTO 635
-#if defined(multicore_profiling)
-         LFTIME = MPI_WTIME() - LFTIME
-         GFTIME = GFTIME + LFTIME
-         WRITE(*,*)'FAC ',LFTIME
-#endif
       ELSE  
             IW( IOLDPS+4+KEEP(IXSZ) ) = 1
               CALL ZMUMPS_FAC1_LDLT( N, INODE,
@@ -577,9 +605,6 @@ C
           ENDIF 
           JOBASS = ETATASS          
           IF (JOBASS.EQ.1) THEN
-#if defined(multicore_profiling)
-              LATIME = MPI_WTIME()
-#endif
               CALL ZMUMPS_FAC_ASM_NIV1(COMM_LOAD, ASS_IRECV,
      &        N,INODE,IW,LIW,A,LA,
      &        INFO(1),ND,
@@ -598,11 +623,6 @@ C
      &        JOBASS,ETATASS
      &               , LRGROUPS
      &         )
-#if defined(multicore_profiling)
-         LATIME = MPI_WTIME() - LATIME
-         GATIME = GATIME + LATIME
-         WRITE(*,*)'ASS ',LATIME
-#endif
           ENDIF
           IF (MPA.GT.0)
      &    CALL MUMPS_PRINT_STILL_ACTIVE (MYID_NODES, KEEP, 
@@ -617,9 +637,6 @@ C
       ELSE
         TYPEF = -9999
       END IF
-#if defined(multicore_profiling)
-         LSTIME = MPI_WTIME()
-#endif
       CALL ZMUMPS_FAC_STACK( COMM_LOAD, ASS_IRECV,
      &       N,INODE,TYPE,TYPEF,LA,IW,LIW,A,
      &       INFO(1),INFO(2),OPELI,NELVA,NMAXNPIV,
@@ -638,11 +655,6 @@ C
      &               , LRGROUPS
      &       ,DUMMY_FLOP_ESTIM_ACC
      &       )
-#if defined(multicore_profiling)
-         LSTIME = MPI_WTIME() - LSTIME
-         GSTIME = GSTIME + LSTIME
-         WRITE(*,*)'STK ',LSTIME
-#endif
       IF (MPA.GT.0)
      &   CALL MUMPS_PRINT_STILL_ACTIVE (MYID_NODES, KEEP, 
      &                        dble(DKEEP(17)), 
@@ -712,6 +724,7 @@ C
       ENDIF
       GO TO 20
  635  CONTINUE
+      IF (allocated(RECORD_ROOT)) DEALLOCATE(RECORD_ROOT)
       CALL ZMUMPS_BDC_ERROR( MYID_NODES, SLAVEF, COMM_NODES, KEEP )
  640  CONTINUE
         CALL ZMUMPS_CANCEL_IRECV( INFO(1),
@@ -914,8 +927,8 @@ C
                   CALL MUMPS_PROPINFO( ICNTL, INFO, COMM_NODES,
      &            MYID_NODES)
                   IF (root%yes .AND. INFO(1).GE.0) THEN
-                    FWD_LOCAL_N_RHS = numroc(KEEP(253), root%NBLOCK,
-     &              root%MYCOL, 0, root%NPCOL)
+                    FWD_LOCAL_N_RHS = MUMPS_NUMROC(KEEP(253),
+     &              root%NBLOCK, root%MYCOL, 0, root%NPCOL)
                     FWD_LOCAL_N_RHS = max(1,FWD_LOCAL_N_RHS)
                     CALL ZMUMPS_GATHER_ROOT( MYID_NODES,
      &              root%TOT_ROOT_SIZE, KEEP(253),
@@ -941,6 +954,280 @@ C
                    NTOTPV = NTOTPV + NFRONT 
                    NMAXNPIV = max(NMAXNPIV,NFRONT)
                 END IF
+                IF ( KEEP(60) .EQ. 0 ) THEN
+                 IF ( ROOT_OWNER ) THEN
+                  IF (KEEP(118).GE.40) THEN
+                   NOFFNEGPV_ROOT = 0        
+                   NULLNEGPV_ROOT = 0        
+                   NTOTPV_ROOT = 0
+                   NB22T1_ROOT = 0
+                   NBTINY_ROOT = 0
+                   DET_SIGN_ROOT = 1
+                   DET_EXP_ROOT = 0
+                   DET_MANT_ROOT = cmplx(1.0D0,0.0D0, 
+     &                                   kind=kind(1.0D0))
+                   DKEEP_SAVE(:) = DKEEP(:)
+                   KEEP_SAVE(:)  = KEEP(:)
+                   KEEP8_SAVE(:) = KEEP8(:)
+                   KEEP_SAVE(201) = 0
+                   IF (KEEP(110).EQ.0) THEN
+                     KEEP_SAVE(110)= 1        
+                     IF (KEEP(118).EQ.40) THEN
+                      IF ((DKEEP(10).LE.0).OR.(DKEEP(10).GT.1)) THEN
+                             DKEEP_SAVE(1) = DKEEP(9)*1D-1
+                      ELSE
+                             DKEEP_SAVE(1) = DKEEP(9)*DKEEP(10) 
+                      ENDIF    
+                     ELSE IF (KEEP(118).EQ.41) THEN
+                        DKEEP_SAVE(1) = DKEEP(9)
+                     ELSE IF (KEEP(118).EQ.42) THEN
+                      IF (DKEEP(13).LT.1)  THEN
+                          DKEEP_SAVE(1) = DKEEP(9)*10 
+                      ELSE
+                         DKEEP_SAVE(1) = DKEEP(9)*DKEEP(13)       
+                      ENDIF
+                     ENDIF  
+                   ELSE 
+                     DKEEP_SAVE(1) = DKEEP(9)
+                   ENDIF 
+                   IS_A_ROOT_SAVE_ALLOCATED = .FALSE.
+                   IF (LRLU.GT.NFRONT8*NFRONT8) THEN
+                     A_ROOT_SAVE  => A(POSFAC:POSFAC+LRLU-1_8)
+                   ELSE
+                    IF (associated(A_ROOT_SAVE)) 
+     &                               DEALLOCATE(A_ROOT_SAVE)
+                    ALLOCATE(A_ROOT_SAVE(NFRONT8*NFRONT8),stat=IERR)
+                    IF (IERR.GT.0) THEN
+                     INFO(1) = -13
+                     CALL MUMPS_SET_IERROR(NFRONT8*NFRONT8, INFO(2) )
+                     IF (LP > 0 )
+     &                 write(LP,*) "ERROR allocating A_ROOT_SAVE ",
+     &                 " of size ", NFRONT*NFRONT
+                     GOTO 735
+                    ENDIF
+                    IS_A_ROOT_SAVE_ALLOCATED = .TRUE.
+                   ENDIF
+!$        NOMP = OMP_GET_MAX_THREADS()
+!$        CHUNK8=int(KEEP(361),8)
+!$OMP     PARALLEL DO PRIVATE(I8) SCHEDULE(STATIC, CHUNK8)
+!$OMP&    IF ( NFRONT8*NFRONT8 > int(KEEP(361),8) .AND. NOMP .GT. 1)
+                   DO I8 =1_8, NFRONT8*NFRONT8
+                       A_ROOT_SAVE(I8) = 
+     &                   A(PTRAST(STEP(KEEP(20)))+I8-1_8)
+                   ENDDO
+                   IW(PTLUST(STEP(INODE))+KEEP(IXSZ): 
+     &                    PTLUST(STEP(INODE))+KEEP(IXSZ)+4)
+     &                 = RECORD_ROOT(KEEP(IXSZ)+1:KEEP(IXSZ)+5)
+                   IW(PTLUST(STEP(INODE))+XXLR) = 0
+                   IF (KEEP(50).EQ.0) THEN
+                    CALL ZMUMPS_FAC1_LU_I ( 
+     &               N, INODE, IW, LIW, A_ROOT_SAVE(1),
+     &               NFRONT8*NFRONT8, IPOSROOT, 1_8,
+     &               INFO(1), INFO(2), UU, NOFFNEGPV_ROOT, NTOTPV_ROOT,
+     &               NBTINY_ROOT,
+     &               DET_EXP_ROOT, DET_MANT_ROOT, DET_SIGN_ROOT,
+     &               KEEP_SAVE,KEEP8_SAVE,
+     &               STEP, PROCNODE_STEPS, MYID_NODES, SLAVEF,
+     &               SEUIL, AVOID_DELAYED, ETATASS,
+     &               DKEEP_SAVE(1), PIVNUL_LIST_STRUCT, IWPOS 
+     &               , LRGROUPS
+     &               , PERM
+     &               )
+                    IF (INFO(1).LT.0) THEN
+                     IF (LP.GT.0) 
+     &               write(LP,*) "ERROR after ZMUMPS_FAC1_LU ",
+     &               "on the root INFO(1)= ", INFO(1)
+                     GOTO 735
+                    ENDIF 
+                   ELSE
+                    CALL ZMUMPS_FAC1_LDLT_I (N,KEEP_SAVE(20),
+     &               IW, LIW, A_ROOT_SAVE(1), NFRONT8*NFRONT8,
+     &               IPOSROOT, 1_8,
+     &               INFO(1), INFO(2), UU,
+     &               NOFFNEGPV_ROOT, NULLNEGPV_ROOT, NTOTPV_ROOT,
+     &               NB22T1_ROOT, NBTINY_ROOT, 
+     &               DET_EXP_ROOT, DET_MANT_ROOT, DET_SIGN_ROOT,
+     &               KEEP_SAVE,KEEP8_SAVE, MYID_NODES, SEUIL, 
+     &               AVOID_DELAYED, ETATASS, DKEEP_SAVE(1),
+     &               PIVNUL_LIST_STRUCT, IWPOS
+     &               , LRGROUPS
+     &               , PERM
+     &               )
+                     IF (INFO(1).LT.0) THEN
+                      IF (LP.GT.0) 
+     &                write(LP,*) "ERROR after ZMUMPS_FAC1_LDLT ",
+     &                "on the root INFO(1)= ", INFO(1)
+                      GOTO 735
+                     ENDIF 
+                   ENDIF 
+                   LRecord = IW(IOLDPS+XXI)
+                   IW(PTLUST(STEP(INODE)):
+     &                PTLUST(STEP(INODE))+LRecord-1) = 
+     &                                    RECORD_ROOT(1:LRecord) 
+                   IW(PTLUST(STEP(INODE))+KEEP(IXSZ): 
+     &                PTLUST(STEP(INODE))+KEEP(IXSZ)+4) =
+     &                                          Header_ROOT(1:5)
+                   KEEP17_LU = KEEP_SAVE(109)-KEEP(109)
+                   IF (KEEP_SAVE(109).GT.KEEP(109)) THEN
+                     K = 1
+                     DO I = KEEP(109)+1, KEEP(109)+KEEP17_LU
+                        RECORD_ROOT(K) = 
+     &                          PIVNUL_LIST_STRUCT%PIVNUL_LIST(I)
+                        K = K+1
+                     ENDDO
+                   ENDIF
+                   IF (IS_A_ROOT_SAVE_ALLOCATED) DEALLOCATE(A_ROOT_SAVE)
+                   NULLIFY(A_ROOT_SAVE)
+                   IS_A_ROOT_SAVE_ALLOCATED = .FALSE.
+                   DET_SIGN = DET_SIGN * DET_SIGN_ROOT
+                   DET_EXP  = DET_EXP + DET_EXP_ROOT
+                   CALL ZMUMPS_UPDATEDETER ( DET_MANT_ROOT, 
+     &                                       DET_MANT, DET_EXP)
+                   NOFFNEGPV = NOFFNEGPV + NOFFNEGPV_ROOT
+                   NULLNEGPV = NULLNEGPV + NULLNEGPV_ROOT
+                  ENDIF 
+                  LOCAL_M = 0
+                  LOCAL_N = 0
+                  MBLOCK  = 0
+                  NBLOCK  = 0
+                  PHASE   = 1  
+                  CALL ZMUMPS_SVD_QR_ESTIM_WK( PHASE,
+     &             MBLOCK, NBLOCK, NFRONT, LOCAL_M, LOCAL_N,
+     &             ROOT_OWNER, KEEP,KEEP8,
+     &             LIWK_RR, LWK_RR )    
+                  LBUFRX             = LWK_RR
+                  IS_BUFRX_ALLOCATED = .FALSE.
+                  IF ( LRLU .GT. LBUFRX ) THEN
+                      BUFRX => A(POSFAC:POSFAC+LBUFRX-1_8)
+                  ELSE
+                      ALLOCATE( BUFRX( LBUFRX ), stat = IERR )
+                      IF (IERR.gt.0) THEN
+                        INFO(1) = -13
+                        CALL MUMPS_SET_IERROR(LBUFRX, INFO(2))
+                        IF (LP.GT.0)
+     &                  write(LP,*) ' Error allocating, real
+     &                        array ','of size ', LBUFRX,
+     &                        ' before ZMUMPS_SEQ_FACTO_ROOT_SVD_QR'
+                        GOTO 735
+                      ENDIF
+                      IS_BUFRX_ALLOCATED = .TRUE.
+                  ENDIF
+                 IF (PIVNUL_LIST_STRUCT%SIZE_PIVNUL_LIST .LT. 
+     &               KEEP(109)+NFRONT) THEN
+                  CALL MUMPS_RESIZE_PIVNUL(KEEP, N, PIVNUL_LIST_STRUCT, 
+     &                             KEEP(109)+NFRONT, INFO(1), INFO(2) ) 
+                  IF (INFO(1).LT.0) GOTO 735
+                 ENDIF
+                  CALL ZMUMPS_SEQ_FACTO_ROOT_SVD_QR(
+     &                 NFRONT,A(PTRAST(STEP(KEEP(20)))),
+     &                 root,
+     &                 BUFRX(1), int(LBUFRX),
+     &                 KEEP,KEEP8, INFO, LP, DKEEP,
+     &                 GLOBK109, OPELI,
+     &                 PIVNUL_LIST_STRUCT%PIVNUL_LIST(KEEP(109)+1),
+     &                 PIVNUL_LIST_STRUCT%SIZE_PIVNUL_LIST- KEEP(109), 
+     &                 IW(IPOSROOTROWINDICES))
+                  IF (IS_BUFRX_ALLOCATED) DEALLOCATE ( BUFRX )
+                  NULLIFY(BUFRX)
+                  IS_BUFRX_ALLOCATED = .FALSE.
+                  IF (INFO(1).LT.0) GOTO 735
+                  IF (MPA.GT.0)
+     &            CALL MUMPS_PRINT_STILL_ACTIVE (MYID_NODES, KEEP, 
+     &                     dble(DKEEP(17)), 
+     &                     OPELI,
+     &                     OPLAST_PRINTED, MPA)
+                  CALL ZMUMPS_UPDATE_PROGRESS( OPELI, KEEP8 )
+                  KEEP(143) = KEEP17_LU
+                  IF (KEEP(118).GE.40) THEN
+                    K = 1 
+                    IF (KEEP(17).GT.0) THEN
+                     DO I = KEEP(109)+1, KEEP(109)+KEEP(17)
+                      IF ( K .GT. KEEP17_LU ) THEN
+                        PIVNUL_LIST_STRUCT%PIVNUL_LIST(I) = -1
+                      ELSE
+                        PIVNUL_LIST_STRUCT%PIVNUL_LIST(I) = 
+     &                                 RECORD_ROOT(K)
+                      ENDIF
+                      K = K+1
+                     ENDDO
+                    ENDIF
+                  ENDIF
+                  IF (allocated(RECORD_ROOT)) DEALLOCATE(RECORD_ROOT)
+                      IF (KEEP(201).EQ.1) THEN 
+                        CALL MUMPS_GETI8(LAFAC, IW(IPOSROOT+XXR))
+                        LIWFAC    = IW(IPOSROOT+XXI)
+                        TYPEFile  = TYPEF_L
+                        NextPiv2beWritten = 1 
+                        MonBloc%INODE    = KEEP(20)   
+                        MonBloc%MASTER   = .TRUE.
+                        MonBloc%Typenode = 3
+                        MonBloc%NCOL     = NFRONT
+                        MonBloc%NROW     = NFRONT
+                        MonBloc%NFS      = NFRONT
+                        MonBloc%Last     = .TRUE.   
+                        MonBloc%LastPiv  = MonBloc%NCOL
+                        MonBloc%LastPanelWritten_L=-9999 
+                        MonBloc%LastPanelWritten_U=-9999 
+                        NULLIFY(MonBloc%INDICES)
+                        STRAT        = STRAT_WRITE_MAX
+                        MonBloc%Last = .TRUE.
+                        LAST_CALL    = .TRUE.
+                        CALL ZMUMPS_OOC_IO_LU_PANEL
+     &                                 ( STRAT, TYPEFile,
+     &                                  A(PTRAST(STEP(KEEP(20)))),
+     &                                  LAFAC, MonBloc,
+     &                                  NextPiv2beWritten, IDUMMY,
+     &                                  IW(IPOSROOT), LIWFAC,
+     &                              MYID, KEEP8(31), IERR, LAST_CALL)
+                        IF(IERR.LT.0)THEN
+                        IF (LP > 0)
+     &                  WRITE(LP,*)MYID,
+     &                  ': Error raised in ZMUMPS_OOC_IO_LU_PANEL',
+     &                  IERR
+                        INFO(1)=IERR
+                        ENDIF
+                      ELSE IF (KEEP(201).EQ.2) THEN 
+                        KEEP8(31)=KEEP8(31)+NFRONT8*NFRONT8
+                        CALL ZMUMPS_NEW_FACTOR(KEEP(20),PTRFAC,
+     &                  KEEP,KEEP8,A,LA, NFRONT8*NFRONT8, IERR)
+                        IF(IERR.LT.0)THEN
+                        WRITE(*,*)MYID,
+     &                  ': Internal error in ZMUMPS_NEW_FACTOR',
+     &                  IERR
+                        GOTO 735
+                        ENDIF
+                      ENDIF
+                      ITMP8  =  NFRONT8*NFRONT8
+                      IF(KEEP(201).NE.0)THEN 
+                        IF (PTRFAC(STEP(KEEP(20))).EQ.
+     &                      POSFAC-ITMP8) THEN
+                          POSFAC = POSFAC  - ITMP8
+                          LRLU   = LRLU    + ITMP8
+                          LRLUS  = LRLUS   + ITMP8
+                          KEEP8(69) = KEEP8(69) - ITMP8
+                        ELSE
+                          IF (LP.GT.0) 
+     &                    WRITE(LP,*) "Internal error",
+     &                    POSFAC,NFRONT8,
+     &                    "root KEEP(20) not on top in OOC"
+                          GOTO 735
+                         ENDIF
+                      ENDIF
+                      CALL ZMUMPS_LOAD_MEM_UPDATE(.FALSE.,.FALSE.,
+     &                LA-LRLUS,ITMP8,0_8,KEEP,KEEP8,LRLUS)
+                ENDIF
+ 735         CONTINUE
+             CALL MUMPS_PROPINFO( ICNTL, INFO, COMM_NODES, MYID_NODES )
+             IF (INFO(1).LT.0) GOTO 745
+                 CALL MPI_BCAST( KEEP(17), 1, MPI_INTEGER,
+     &                MUMPS_PROCNODE(PROCNODE_STEPS(STEP(KEEP(20))),
+     &                               KEEP(199)),
+     &                COMM_NODES, IERR )
+                 CALL MPI_BCAST( KEEP(143), 1, MPI_INTEGER,
+     &                MUMPS_PROCNODE(PROCNODE_STEPS(STEP(KEEP(20))),
+     &                               KEEP(199)),
+     &                COMM_NODES, IERR )
+                END IF
                 IF (ROOT_OWNER.AND.KEEP(60).NE.0) THEN 
                   ITMP8 = NFRONT8*NFRONT8
                   IF ( PTRFAC(STEP(KEEP(20))) .EQ. POSFAC -
@@ -954,6 +1241,12 @@ C
                   ENDIF
                 ENDIF
             END IF
+            GOTO 750
+ 745  CONTINUE
+            IF (allocated(RECORD_ROOT)) DEALLOCATE(RECORD_ROOT)
+            IF (IS_A_ROOT_SAVE_ALLOCATED) DEALLOCATE(A_ROOT_SAVE)
+            NULLIFY(A_ROOT_SAVE)
+ 750  CONTINUE
             IF (INFO(1).LT.0) GOTO 500
             CALL MUMPS_SECFIN(ROOTTIME)
             DKEEP(99)=ROOTTIME
diff -pruN 5.6.2-2.1/src/zfac_process_band.F 5.7.1-1/src/zfac_process_band.F
--- 5.6.2-2.1/src/zfac_process_band.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zfac_process_band.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -46,7 +46,7 @@ C
       INTEGER PTRIST(KEEP(28)), STEP(N), 
      & PIMASTER(KEEP(28)), 
      & ITLOC( N + KEEP(253) )
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INTEGER :: ISTEP_TO_INIV2(KEEP(71))
 #if ! defined(NO_FDM_DESCBAND)
       INTEGER IWHANDLER_IN
@@ -124,7 +124,7 @@ C
      &       COMP, LRLUS, KEEP8(67), IFLAG, IERROR
      &     )
         IF ( IFLAG .LT. 0 ) RETURN
-#if defined(MUMPS_ALLOC_FROM_C)
+#if defined(MUMPS_ALLOC_FROM_C) || defined(_CRAYFTN)
         CALL MUMPS_MALLOC_C( TMP_ADDRESS,
      &      LREQCB * int(KEEP(35),8) )
         IF (TMP_ADDRESS .EQ. 0_8) THEN
@@ -145,7 +145,7 @@ C
      &    KEEP8, IFLAG, IERROR,
      &    .TRUE., 
      &    .FALSE. ) 
-#if ! defined(MUMPS_ALLOC_FROM_C)
+#if ! defined(MUMPS_ALLOC_FROM_C) && ! defined(_CRAYFTN)
           CALL MUMPS_ADDR_C( DYNAMIC_CB(1), TMP_ADDRESS )
 #endif
           CALL MUMPS_STOREI8(LREQCB, IW(IWPOSCB+1+XXD))
@@ -289,7 +289,7 @@ C
       INTEGER NELT, LPTRAR
       INTEGER FRTPTR( N+1 ), FRTELT( NELT )
       INTEGER ITLOC( N + KEEP(253) ), FILS( N ), DAD( KEEP(28) )
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
diff -pruN 5.6.2-2.1/src/zfac_process_bf.F 5.7.1-1/src/zfac_process_bf.F
--- 5.6.2-2.1/src/zfac_process_bf.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/zfac_process_bf.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/zfac_process_blfac_slave.F 5.7.1-1/src/zfac_process_blfac_slave.F
--- 5.6.2-2.1/src/zfac_process_blfac_slave.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/zfac_process_blfac_slave.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -75,7 +75,7 @@ C
       INTEGER COMM, MYID
       INTEGER PTLUST_S(KEEP(28))
       INTEGER ITLOC( N + KEEP(253)), FILS( N ), DAD( KEEP(28) )
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INTEGER ND( KEEP(28) ), FRERE_STEPS( KEEP(28) )
       DOUBLE PRECISION OPASSW, OPELIW
       DOUBLE PRECISION FLOP1
diff -pruN 5.6.2-2.1/src/zfac_process_blocfacto.F 5.7.1-1/src/zfac_process_blocfacto.F
--- 5.6.2-2.1/src/zfac_process_blocfacto.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/zfac_process_blocfacto.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -71,7 +71,7 @@ C
       INTEGER FRTPTR( N+1 ), FRTELT( NELT )
       INTEGER PTLUST_S(KEEP(28)),
      &        ITLOC(N+KEEP(253)), FILS(N), DAD(KEEP(28)), ND(KEEP(28))
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) :: PTRAIW( LPTRAR ), PTRARW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
@@ -132,8 +132,6 @@ C
       INTEGER NPARTSASS, NPARTSCB, MAXI_CLUSTER, LWORK,
      &        MAXI_CLUSTER_L, MAXI_CLUSTER_U, MAXI_CLUSTER_COL
       INTEGER  :: allocok
-      INTEGER MUMPS_PROCNODE
-      EXTERNAL MUMPS_PROCNODE
       KEEP_BEGS_BLR_L = .FALSE.
       nullify(BEGS_BLR_L)
       NB_BLR_U = -7654321
@@ -384,8 +382,9 @@ C
           CALL GET_CUT(IW(IOLDPS+HS:IOLDPS+HS+NROW1-1), 0,
      &                    NROW1, LRGROUPS, NPARTSCB, 
      &                    NPARTSASS, BEGS_BLR_L)
-          CALL REGROUPING2(BEGS_BLR_L, NPARTSASS, 0, NPARTSCB,
-     &                        NROW1-0, KEEP(488), .TRUE., KEEP(472))
+          CALL REGROUPING2(BEGS_BLR_L, NPARTSASS, NASS1, NPARTSCB,
+     &                        NROW1-0, KEEP(488), .TRUE., KEEP(472),
+     &                        NCOL1, KEEP(1))
           NB_BLR_L =  NPARTSCB
           IF (IPANEL.EQ.1) THEN
            BEGS_BLR_COL=>BEGS_BLR_U
diff -pruN 5.6.2-2.1/src/zfac_process_blocfacto_LDLT.F 5.7.1-1/src/zfac_process_blocfacto_LDLT.F
--- 5.6.2-2.1/src/zfac_process_blocfacto_LDLT.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/zfac_process_blocfacto_LDLT.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -70,7 +70,7 @@ C
       INTEGER COMM, MYID
       INTEGER PTLUST_S(KEEP(28)),
      &        ITLOC(N+KEEP(253)), FILS(N), DAD(KEEP(28)), ND(KEEP(28))
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) :: PTRAIW( LPTRAR ), PTRARW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
@@ -564,8 +564,9 @@ C
           CALL GET_CUT(IW(IOLDPS+HS:IOLDPS+HS+NROW1-1), 0,
      &                    NROW1, LRGROUPS, NPARTSCB, 
      &                    NPARTSASS, BEGS_BLR_LS)
-              CALL REGROUPING2(BEGS_BLR_LS, NPARTSASS, 0, NPARTSCB,
-     &                        NROW1-0, KEEP(488), .TRUE., KEEP(472))
+              CALL REGROUPING2(BEGS_BLR_LS, NPARTSASS, NASS1, NPARTSCB,
+     &                        NROW1-0, KEEP(488), .TRUE., KEEP(472),
+     &                        NCOL1, KEEP(1))
              NB_BLR_LS = NPARTSCB
         ENDIF
         call MAX_CLUSTER(BEGS_BLR_LM,NB_BLR_LM+1,MAXI_CLUSTER_LM)
@@ -579,7 +580,8 @@ C
      &                    NPARTSASS_COL, BEGS_BLR_COL)
           CALL REGROUPING2(BEGS_BLR_COL, NPARTSASS_COL, NASS1, 
      &                     NPARTSCB_COL,
-     &                     NCOL1-NASS1, KEEP(488), .FALSE., KEEP(472))
+     &                     NCOL1-NASS1, KEEP(488), .FALSE., KEEP(472),
+     &                     NCOL1, KEEP(1))
           NB_BLR_COL = NPARTSCB_COL + NPARTSASS_COL
           IF (NPARTSASS_MASTER.NE.NPARTSASS_COL) THEN
              ALLOCATE(BEGS_BLR_COL_TMP(
diff -pruN 5.6.2-2.1/src/zfac_process_contrib_type1.F 5.7.1-1/src/zfac_process_contrib_type1.F
--- 5.6.2-2.1/src/zfac_process_contrib_type1.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/zfac_process_contrib_type1.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -42,7 +42,7 @@ C
       INTEGER COMP, FPERE
       LOGICAL FLAG
       INTEGER NSTK_S( KEEP(28) ), ITLOC( N + KEEP(253) )
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INTEGER IFLAG, IERROR, COMM
       INTEGER POSITION, FINODE, FLCONT, LREQ
       INTEGER(8) :: LREQCB
diff -pruN 5.6.2-2.1/src/zfac_process_contrib_type2.F 5.7.1-1/src/zfac_process_contrib_type2.F
--- 5.6.2-2.1/src/zfac_process_contrib_type2.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/zfac_process_contrib_type2.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -58,7 +58,7 @@ C
       INTEGER, intent(in) :: LRGROUPS(KEEP(280))
       INTEGER ITLOC( N + KEEP(253)), NSTK_S( KEEP(28) )
       INTEGER :: FILS( N ), DAD(KEEP(28))
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INTEGER ND(KEEP(28)), FRERE_STEPS( KEEP(28) )
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
@@ -449,7 +449,7 @@ C
              NSLAVES= IW(IOLDPS+5+KEEP(IXSZ))
              IF (NSLAVES.EQ.0) THEN 
                NFRONT = IW(IOLDPS+KEEP(IXSZ))
-               NASS1  = iabs(IW(IOLDPS + 2+KEEP(IXSZ)))
+               NASS1  = abs(IW(IOLDPS + 2+KEEP(IXSZ)))
                POSELT = PTRAST(STEP(INODE))
                PARPIV_T1 = -999 
                LR_ACTIVATED = (IW(IOLDPS+XXLR).GT.0)
diff -pruN 5.6.2-2.1/src/zfac_process_contrib_type3.F 5.7.1-1/src/zfac_process_contrib_type3.F
--- 5.6.2-2.1/src/zfac_process_contrib_type3.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/zfac_process_contrib_type3.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -45,7 +45,7 @@ C
       INTEGER PTRIST(KEEP(28))
       INTEGER PTLUST(KEEP(28))
       INTEGER STEP(N), PIMASTER(KEEP(28)), ITLOC( N+KEEP(253) )
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INTEGER BUFR( LBUFR_BYTES )
       INTEGER IW( LIW )
       INTEGER ND(KEEP(28)), PROCNODE_STEPS(KEEP(28))
@@ -65,8 +65,6 @@ C
       DOUBLE PRECISION OPASSW
         INCLUDE 'mpif.h'
         INTEGER IERR
-        EXTERNAL MUMPS_PROCNODE
-        INTEGER MUMPS_PROCNODE
         INTEGER POSITION, LOCAL_M, LOCAL_N, LREQI
         INTEGER(8) :: LREQA, POS_ROOT
         INTEGER NSUBSET_ROW, NSUBSET_COL, IROOT, ISON, NSUBSET_COL_EFF
diff -pruN 5.6.2-2.1/src/zfac_process_end_facto_slave.F 5.7.1-1/src/zfac_process_end_facto_slave.F
--- 5.6.2-2.1/src/zfac_process_end_facto_slave.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/zfac_process_end_facto_slave.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -71,7 +71,7 @@ C
       INTEGER NBFIN, SLAVEF
       DOUBLE PRECISION OPASSW, OPELIW
       INTEGER ITLOC( N + KEEP(253) ), FILS( N ), DAD( KEEP(28) )
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INTEGER ND( KEEP(28) )
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
diff -pruN 5.6.2-2.1/src/zfac_process_maprow.F 5.7.1-1/src/zfac_process_maprow.F
--- 5.6.2-2.1/src/zfac_process_maprow.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/zfac_process_maprow.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -84,7 +84,7 @@ C
       INTEGER LPTRAR, NELT
       INTEGER FRTPTR( N+1 ), FRTELT( NELT )
       INTEGER ITLOC( N+KEEP(253) ), FILS( N ), DAD( KEEP(28) )
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) ::  PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
@@ -573,6 +573,9 @@ C
                    IS_ERROR_BROADCASTED=.TRUE.
                    GOTO 600
                  ENDIF
+                 IF (.NOT. MESSAGE_RECEIVED) THEN
+                   CALL MUMPS_USLEEP(1000)
+                 ENDIF
                END IF
              END IF 
            ENDDO
@@ -708,7 +711,7 @@ C
       INTEGER PROCNODE_STEPS( KEEP(28) )
       INTEGER FRTPTR( N+1 ), FRTELT( NELT )
       INTEGER ITLOC( N+KEEP(253) ), FILS( N ), DAD( KEEP(28) )
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
@@ -1350,7 +1353,7 @@ C
       INTEGER, intent(inout) :: ITLOC(N)
       INTEGER, intent(in) :: FRTPTR( N+1 ), FRTELT( NELT )
       DOUBLE PRECISION, intent(inout) :: OPASSW, OPELIW
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INTEGER, intent(in) :: KEEP253_LOC, NVSCHUR
       INTEGER, intent(in) :: FILS(N), DAD( KEEP(28) )
       INTEGER(8), intent(in) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
diff -pruN 5.6.2-2.1/src/zfac_process_master2.F 5.7.1-1/src/zfac_process_master2.F
--- 5.6.2-2.1/src/zfac_process_master2.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/zfac_process_master2.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -43,7 +43,7 @@ C
       INTEGER(8) :: PAMASTER(KEEP(28))
       INTEGER PTRIST(KEEP(28)), STEP(N), PIMASTER(KEEP(28))
       INTEGER PROCNODE_STEPS( KEEP(28) ), ITLOC( N +KEEP(253) )
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INTEGER COMP
       INTEGER NSTK_S( KEEP(28) )
       INTEGER IFLAG, IERROR, COMM, COMM_LOAD
diff -pruN 5.6.2-2.1/src/zfac_process_message.F 5.7.1-1/src/zfac_process_message.F
--- 5.6.2-2.1/src/zfac_process_message.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/zfac_process_message.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -65,7 +65,7 @@ C
       INTEGER NELT, LPTRAR
       INTEGER FRTPTR( N+1), FRTELT( NELT )
       INTEGER ITLOC( N+KEEP(253) ), FILS( N ), DAD(KEEP(28))
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
@@ -515,7 +515,7 @@ C
       INTEGER NELT, LPTRAR
       INTEGER FRTPTR( N+1 ), FRTELT( NELT )
       INTEGER ITLOC( N+KEEP(253) ), FILS( N ), DAD( KEEP(28) )
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
@@ -623,7 +623,7 @@ C
       INTEGER NELT, LPTRAR
       INTEGER FRTPTR( N+1 ), FRTELT( NELT )
       INTEGER ITLOC( N + KEEP(253) ), FILS( N ), DAD( KEEP(28) )
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
@@ -749,7 +749,7 @@ C
                   IF ( IFLAG .LT. 0 ) RETURN
             ENDIF
           ENDIF
-       ENDIF
+       ENDIF 
       ELSE
         IF (BLOCKING) THEN
            CALL MPI_PROBE(MSGSOU,MSGTAG,
diff -pruN 5.6.2-2.1/src/zfac_process_root2slave.F 5.7.1-1/src/zfac_process_root2slave.F
--- 5.6.2-2.1/src/zfac_process_root2slave.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/zfac_process_root2slave.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -65,7 +65,7 @@ C
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
       INTEGER, INTENT(IN) :: NINROWARR(KEEP(195))
       INTEGER, INTENT(IN) :: PTRDEBARR(KEEP(196))
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INTEGER INTARR(KEEP8(27))
       COMPLEX(kind=8) DBLARR(KEEP8(26))
       INTEGER ::  allocok
@@ -80,17 +80,17 @@ C
       COMPLEX(kind=8) ZERO
       PARAMETER( ZERO = (0.0D0,0.0D0) )
       INCLUDE 'mumps_headers.h'
-      INTEGER numroc, MUMPS_PROCNODE
-      EXTERNAL numroc, MUMPS_PROCNODE
+      INTEGER MUMPS_NUMROC, MUMPS_PROCNODE
+      EXTERNAL MUMPS_NUMROC, MUMPS_PROCNODE
       IROOT = KEEP( 38 )
       root%TOT_ROOT_SIZE = TOT_ROOT_SIZE
       MASTER_OF_ROOT = ( MYID .EQ. 
      &                   MUMPS_PROCNODE( PROCNODE_STEPS(STEP(IROOT)),
      &                   KEEP(199) ) )
-      NEW_LOCAL_M  = numroc( TOT_ROOT_SIZE, root%MBLOCK,
+      NEW_LOCAL_M  = MUMPS_NUMROC( TOT_ROOT_SIZE, root%MBLOCK,
      &               root%MYROW, 0, root%NPROW )
       NEW_LOCAL_M  = max( 1, NEW_LOCAL_M )
-      NEW_LOCAL_N  = numroc( TOT_ROOT_SIZE, root%NBLOCK,
+      NEW_LOCAL_N  = MUMPS_NUMROC( TOT_ROOT_SIZE, root%NBLOCK,
      &               root%MYCOL, 0, root%NPCOL )
       IF ( PTRIST(STEP( IROOT )).GT.0) THEN
         OLD_LOCAL_N = -IW( PTRIST(STEP( IROOT )) + KEEP(IXSZ) )
@@ -275,7 +275,7 @@ C
       ENDIF 
       IF ( NO_OLD_ROOT ) THEN
           IF (KEEP(253) .GT.0) THEN
-            root%RHS_NLOC = numroc( KEEP(253), root%NBLOCK,
+            root%RHS_NLOC = MUMPS_NUMROC( KEEP(253), root%NBLOCK,
      &                      root%MYCOL, 0, root%NPCOL )
             root%RHS_NLOC = max( root%RHS_NLOC, 1 )
           ELSE
@@ -291,8 +291,8 @@ C
           ENDIF
           IF (KEEP(253) .NE. 0) THEN
             root%RHS_ROOT=ZERO
-            CALL ZMUMPS_ASM_RHS_ROOT( N, FILS, root, KEEP, RHS_MUMPS,
-     &      IFLAG, IERROR )
+            CALL ZMUMPS_ASM_RHS_ROOT( N, FILS, root, KEEP, KEEP8,
+     &      RHS_MUMPS, IFLAG, IERROR )
           ENDIF
       ELSE IF (NEW_LOCAL_M.GT.OLD_LOCAL_M .AND. KEEP(253) .GT.0) THEN
           TMP => root%RHS_ROOT
diff -pruN 5.6.2-2.1/src/zfac_process_root2son.F 5.7.1-1/src/zfac_process_root2son.F
--- 5.6.2-2.1/src/zfac_process_root2son.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/zfac_process_root2son.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -64,7 +64,7 @@ C
       INTEGER MYID, SLAVEF, NBFIN
       DOUBLE PRECISION OPASSW, OPELIW
       INTEGER ITLOC( N + KEEP(253) ), FILS( N ), DAD(KEEP(28))
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
       INTEGER, INTENT(IN) :: NINCOLARR(KEEP(194))
@@ -97,7 +97,7 @@ C
        IOLDPS   = PTLUST_S(STEP(INODE))
        NFRONT   = IW(IOLDPS+KEEP(IXSZ))
        NPIV     = IW(IOLDPS+1+KEEP(IXSZ))
-       NASS     = iabs(IW(IOLDPS + 2+KEEP(IXSZ)))
+       NASS     = abs(IW(IOLDPS + 2+KEEP(IXSZ)))
        NSLAVES  =  IW(IOLDPS+5+KEEP(IXSZ))
        H_INODE  = 6 + NSLAVES + KEEP(IXSZ)
        NELIM    = NASS - NPIV
diff -pruN 5.6.2-2.1/src/zfac_process_rtnelind.F 5.7.1-1/src/zfac_process_rtnelind.F
--- 5.6.2-2.1/src/zfac_process_rtnelind.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/zfac_process_rtnelind.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -46,7 +46,7 @@ C
       INTEGER STEP(N), PIMASTER(KEEP(28))
       INTEGER COMP
       INTEGER NSTK_S(KEEP(28)), ITLOC( N + KEEP(253) )
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INTEGER PROCNODE_STEPS( KEEP(28) )
       INTEGER IFLAG, IERROR
       INTEGER LPOOL, LEAF
diff -pruN 5.6.2-2.1/src/zfac_root_parallel.F 5.7.1-1/src/zfac_root_parallel.F
--- 5.6.2-2.1/src/zfac_root_parallel.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/zfac_root_parallel.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -51,8 +51,7 @@ C
       INTEGER FWD_LOCAL_N_RHS, FWD_MTYPE 
 #endif
       INCLUDE 'mumps_headers.h'
-      EXTERNAL numroc
-      INTEGER numroc
+      INTEGER, EXTERNAL :: MUMPS_NUMROC
         IF ( .NOT. root%yes ) RETURN
         IF ( KEEP(60) .NE. 0 ) THEN
           IF ((LDLT == 1 .OR. LDLT == 2) .AND. KEEP(60) == 3 ) THEN
@@ -181,7 +180,7 @@ C
      &         LDLT)
         ENDIF
         IF (KEEP(252) .NE. 0) THEN
-          FWD_LOCAL_N_RHS = numroc(KEEP(253), root%NBLOCK,
+          FWD_LOCAL_N_RHS = MUMPS_NUMROC(KEEP(253), root%NBLOCK,
      &                      root%MYCOL, 0, root%NPCOL)
           FWD_LOCAL_N_RHS = max(1,FWD_LOCAL_N_RHS)
           FWD_MTYPE       = 1 
diff -pruN 5.6.2-2.1/src/zfac_scalings.F 5.7.1-1/src/zfac_scalings.F
--- 5.6.2-2.1/src/zfac_scalings.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/zfac_scalings.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -22,54 +22,61 @@ C
       COMPLEX(kind=8), INTENT(IN) :: ASPK(NZ8)
       DOUBLE PRECISION COLSCA(*), ROWSCA(*)
       INTEGER(8), INTENT(IN) :: LWK8
-      INTEGER LWK_REAL
+      INTEGER(8), INTENT(IN) :: LWK_REAL
       COMPLEX(kind=8)    WK(LWK8)
       DOUBLE PRECISION WK_REAL(LWK_REAL)
       INTEGER MPG,LP
-      INTEGER IWNOR
       INTEGER I
-      LOGICAL PROK
+      LOGICAL PROKG
       DOUBLE PRECISION ONE
       PARAMETER( ONE = 1.0D0 )
       LP      = ICNTL(1)
       MPG     = ICNTL(2)
       MPG    = ICNTL(3)
-      PROK   = ((MPG.GT.0).AND.(ICNTL(4).GE.2))
-      IF (PROK) THEN
+      PROKG  = ((MPG.GT.0).AND.(ICNTL(4).GE.2))
+      IF (PROKG) THEN
         WRITE(MPG,101)
       ELSE
         MPG = 0
       ENDIF
- 101    FORMAT(/' ****** SCALING OF ORIGINAL MATRIX '/)
-        IF (NSCA.EQ.1) THEN
-         IF (PROK)
-     &    WRITE (MPG,*) ' DIAGONAL SCALING '
-        ELSEIF (NSCA.EQ.3) THEN
-         IF (PROK)
+ 101  FORMAT(/' ****** SCALING OF ORIGINAL MATRIX '/)
+      IF (NSCA.EQ.1) THEN
+        IF (PROKG) WRITE (MPG,*) ' DIAGONAL SCALING '
+      ELSEIF (NSCA.EQ.3) THEN
+         IF (PROKG)
      &   WRITE (MPG,*) ' COLUMN SCALING'
-        ELSEIF (NSCA.EQ.4) THEN
-         IF (PROK)
+      ELSEIF (NSCA.EQ.4) THEN
+         IF (PROKG)
      &   WRITE (MPG,*) ' ROW AND COLUMN SCALING (1 Pass)'
-       ENDIF
-        DO 10 I=1,N
-            COLSCA(I) = ONE
-            ROWSCA(I) = ONE
- 10     CONTINUE
-        IF (5*N.GT.LWK_REAL) GOTO 410
-        IWNOR = 1
-          IF (NSCA.EQ.1) THEN
+      ENDIF
+      DO 10 I=1,N
+        COLSCA(I) = ONE
+        ROWSCA(I) = ONE
+ 10   CONTINUE
+      IF (NSCA.EQ.1) THEN
             CALL ZMUMPS_FAC_V(N,NZ8,ASPK,IRN,ICN,
-     &        COLSCA,ROWSCA,MPG)
-          ELSEIF (NSCA.EQ.3) THEN
-            CALL ZMUMPS_FAC_Y(N,NZ8,ASPK,IRN,ICN,WK_REAL(IWNOR),
+     &      COLSCA,ROWSCA,MPG)
+      ELSEIF (NSCA.EQ.3) THEN
+            IF ( LWK_REAL .LT. int(N,8) ) THEN
+              GOTO 420
+            ENDIF
+            CALL ZMUMPS_FAC_Y(N,NZ8,ASPK,IRN,ICN,WK_REAL(1),
      &      COLSCA, MPG)
-          ELSEIF (NSCA.EQ.4) THEN
+      ELSEIF (NSCA.EQ.4) THEN
+            IF ( LWK_REAL .LT. 2_8*int(N,8) ) THEN
+              GOTO 430
+            ENDIF
             CALL ZMUMPS_ROWCOL(N,NZ8,IRN,ICN,ASPK,
-     &      WK_REAL(IWNOR),WK_REAL(IWNOR+N),COLSCA,ROWSCA,MPG)
-          ENDIF
+     &      WK_REAL(1),WK_REAL(1+N),COLSCA,ROWSCA,MPG)
+      ENDIF
+      GOTO 500
+ 420  INFO(1) = -5
+      CALL MUMPS_SET_IERROR(int(N,8)-LWK_REAL, INFO(2))
+      IF ((LP.GT.0).AND.(ICNTL(4).GE.1))
+     & WRITE(LP,*) '*** ERROR: Not enough space to scale matrix'
       GOTO 500
- 410  INFO(1) = -5
-      INFO(2) = 5*N-LWK_REAL
+ 430  INFO(1) = -5
+      CALL MUMPS_SET_IERROR(2_8*int(N,8)-LWK_REAL, INFO(2))
       IF ((LP.GT.0).AND.(ICNTL(4).GE.1))
      & WRITE(LP,*) '*** ERROR: Not enough space to scale matrix'
       GOTO 500
diff -pruN 5.6.2-2.1/src/zfac_scalings_simScaleAbs.F 5.7.1-1/src/zfac_scalings_simScaleAbs.F
--- 5.6.2-2.1/src/zfac_scalings_simScaleAbs.F	2023-10-11 09:37:10.000000000 +0000
+++ 5.7.1-1/src/zfac_scalings_simScaleAbs.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -18,7 +18,9 @@ C
      &     IWRK, IWRKSZ,
      &     INTSZ, RESZ, OP,
      &     ROWSCA, COLSCA, WRKRC, ISZWRKRC,
-     &     SYM, NB1, NB2, NB3, EPS,
+     &     WRKR_TH, LWRKR_TH,
+     &     WRKC_TH, LWRKC_TH,
+     &     NOMP_MAX, SYM, NB1, NB2, NB3, EPS,
      &     ONENORMERR,INFNORMERR)
 C----------------------------------------------------------------------
 C    IF SYM=0 CALLs unsymmetric variant ZMUMPS_SIMSCALEABSUNS.
@@ -29,13 +31,16 @@ C    For details, see the two subroutine
 C         ZMUMPS_SIMSCALEABSUNS and ZMUMPS_SIMSCALEABSSYM
 C ---------------------------------------------------------------------
 C
+!$    USE OMP_LIB
       IMPLICIT NONE
       INCLUDE 'mpif.h'
       INTEGER(8) NZ_loc
-      INTEGER IWRKSZ, ISZWRKRC
+      INTEGER(8) :: IWRKSZ
+      INTEGER(8) :: ISZWRKRC, LWRKR_TH, LWRKC_TH
+      INTEGER    :: NOMP_MAX
       INTEGER M, N, OP
       INTEGER NUMPROCS, MYID, COMM
-      INTEGER INTSZ, RESZ
+      INTEGER(8) :: INTSZ, RESZ
       INTEGER IRN_loc(NZ_loc)
       INTEGER JCN_loc(NZ_loc)
       COMPLEX(kind=8) A_loc(NZ_loc)
@@ -44,21 +49,29 @@ C
       INTEGER CPARTVEC(N) 
       INTEGER CSNDRCVSZ(2*NUMPROCS)
       INTEGER IWRK(IWRKSZ)
-      INTEGER REGISTRE(12)
+      INTEGER(8) :: REGISTRE(12)
       DOUBLE PRECISION ROWSCA(M)
       DOUBLE PRECISION COLSCA(N)
       DOUBLE PRECISION WRKRC(ISZWRKRC)
+      DOUBLE PRECISION WRKR_TH(LWRKR_TH,max(NOMP_MAX,1))
+      DOUBLE PRECISION WRKC_TH(LWRKC_TH,max(NOMP_MAX,1))
       DOUBLE PRECISION ONENORMERR,INFNORMERR
 C     LOCALS
-C IMPORTANT POINTERS
 C     FOR the scaling phase
       INTEGER SYM, NB1, NB2, NB3
       DOUBLE PRECISION EPS
 C     EXTERNALS
       EXTERNAL ZMUMPS_SIMSCALEABSUNS,ZMUMPS_SIMSCALEABSSYM, 
-     &     ZMUMPS_INITREAL
+     &         ZMUMPS_INITREAL
 C     MUST HAVE IT
       INTEGER I
+      INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER    :: NOMP 
+!$    INTEGER    :: CHUNK
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP  = omp_get_max_threads()
+!$     CHUNK= max(K361/2, (N+NOMP-1) / NOMP )
+!$    ENDIF
       IF(SYM.EQ.0) THEN
          CALL ZMUMPS_SIMSCALEABSUNS(IRN_loc, JCN_loc, A_loc, 
      &        NZ_loc,
@@ -67,7 +80,9 @@ C     MUST HAVE IT
      &        RSNDRCVSZ, CSNDRCVSZ, REGISTRE,
      &        IWRK, IWRKSZ,
      &        INTSZ, RESZ, OP,
-     &        ROWSCA, COLSCA, WRKRC, ISZWRKRC,
+     &        ROWSCA, COLSCA, WRKRC, ISZWRKRC, 
+     &        WRKR_TH, LWRKR_TH,
+     &        WRKC_TH, LWRKC_TH, NOMP_MAX,
      &        NB1, NB2, NB3, EPS,
      &        ONENORMERR, INFNORMERR)  
       ELSE
@@ -78,12 +93,24 @@ C     MUST HAVE IT
      &        RSNDRCVSZ, REGISTRE,
      &        IWRK, IWRKSZ,
      &        INTSZ, RESZ, OP,
-     &        ROWSCA, WRKRC, ISZWRKRC,
+     &        ROWSCA, WRKRC, ISZWRKRC,  
+     &        WRKR_TH, LWRKR_TH, NOMP_MAX,
      &        NB1, NB2, NB3, EPS,
      &        ONENORMERR, INFNORMERR)  
-         DO I=1,N
-            COLSCA(I) = ROWSCA(I)
-         ENDDO
+         IF (OP.EQ.2) THEN
+          IF (NOMP_MAX.LE.0) THEN
+            DO I=1,N
+             COLSCA(I) = ROWSCA(I)
+            ENDDO
+          ELSE 
+!$OMP      PARALLEL DO PRIVATE(I)
+!$OMP&     SCHEDULE(STATIC,CHUNK)
+!$OMP&     IF ( N > K361 .AND. NOMP .GT. 1)
+            DO I=1,N
+             COLSCA(I) = ROWSCA(I)
+            ENDDO
+          ENDIF
+         ENDIF
       ENDIF
       RETURN
       END SUBROUTINE ZMUMPS_SIMSCALEABS
@@ -93,7 +120,9 @@ C     MUST HAVE IT
      &     RSNDRCVSZ, CSNDRCVSZ, REGISTRE,
      &     IWRK, IWRKSZ,
      &     INTSZ, RESZ, OP,
-     &     ROWSCA, COLSCA, WRKRC, ISZWRKRC,
+     &     ROWSCA, COLSCA, WRKRC, ISZWRKRC, 
+     &     WRKR_TH, LWRKR_TH,
+     &     WRKC_TH, LWRKC_TH, NOMP_MAX,
      &     NB1, NB2, NB3, EPS,
      &     ONENORMERR, INFNORMERR)    
 C----------------------------------------------------------------------
@@ -191,13 +220,15 @@ C         In proceedings of VECPAR'08-In
 C         Performance Computing for Computational Science, Jan'08.
 C     and was supported by ANR-SOLSTICE project (ANR-06-CIS6-010)
 C ---------------------------------------------------------------------
+!$    USE OMP_LIB
       IMPLICIT NONE
       INCLUDE 'mpif.h'
-      INTEGER(8) NZ_loc
-      INTEGER IWRKSZ, INTSZ, ISZWRKRC
-      INTEGER M, N, OP
-      INTEGER NUMPROCS, MYID, COMM
-      INTEGER RESZ
+      INTEGER(8) :: NZ_loc
+      INTEGER(8) :: IWRKSZ, INTSZ
+      INTEGER(8) :: ISZWRKRC, LWRKR_TH, LWRKC_TH
+      INTEGER    :: M, N, OP
+      INTEGER    :: NUMPROCS, MYID, COMM, NOMP_MAX
+      INTEGER(8) :: RESZ
       INTEGER IRN_loc(NZ_loc)
       INTEGER JCN_loc(NZ_loc)
       COMPLEX(kind=8) A_loc(NZ_loc)
@@ -205,11 +236,13 @@ C --------------------------------------
       INTEGER CPARTVEC(N) 
       INTEGER RSNDRCVSZ(2*NUMPROCS)
       INTEGER CSNDRCVSZ(2*NUMPROCS)
-      INTEGER REGISTRE(12)
+      INTEGER(8) :: REGISTRE(12)
       INTEGER IWRK(IWRKSZ)
       DOUBLE PRECISION ROWSCA(M)
       DOUBLE PRECISION COLSCA(N)
-      DOUBLE PRECISION WRKRC(ISZWRKRC)  
+      DOUBLE PRECISION WRKRC(ISZWRKRC)
+      DOUBLE PRECISION WRKR_TH(LWRKR_TH,max(NOMP_MAX,1))
+      DOUBLE PRECISION WRKC_TH(LWRKC_TH,max(NOMP_MAX,1))
       DOUBLE PRECISION ONENORMERR,INFNORMERR
 C     LOCALS
       INTEGER IRSNDRCVNUM, ORSNDRCVNUM
@@ -218,14 +251,14 @@ C     LOCALS
       INTEGER ICSNDRCVVOL, OCSNDRCVVOL
       INTEGER  INUMMYR, INUMMYC
 C IMPORTANT POINTERS
-      INTEGER IMYRPTR,IMYCPTR 
-      INTEGER IRNGHBPRCS, IRSNDRCVIA,IRSNDRCVJA
-      INTEGER ORNGHBPRCS, ORSNDRCVIA,ORSNDRCVJA
-      INTEGER ICNGHBPRCS, ICSNDRCVIA,ICSNDRCVJA
-      INTEGER OCNGHBPRCS, OCSNDRCVIA,OCSNDRCVJA
-      INTEGER ISTATUS, REQUESTS, TMPWORK
-      INTEGER ITDRPTR, ITDCPTR, ISRRPTR
-      INTEGER OSRRPTR, ISRCPTR, OSRCPTR
+      INTEGER(8) :: IMYRPTR,IMYCPTR 
+      INTEGER(8) :: IRNGHBPRCS, IRSNDRCVIA,IRSNDRCVJA
+      INTEGER(8) :: ORNGHBPRCS, ORSNDRCVIA,ORSNDRCVJA
+      INTEGER(8) :: ICNGHBPRCS, ICSNDRCVIA,ICSNDRCVJA
+      INTEGER(8) :: OCNGHBPRCS, OCSNDRCVIA,OCSNDRCVJA
+      INTEGER(8) :: ISTATUS, REQUESTS, TMPWORK
+      INTEGER(8) :: ITDRPTR, ITDCPTR, ISRRPTR
+      INTEGER(8) :: OSRRPTR, ISRCPTR, OSRCPTR
 C     FOR the scaling phase
       INTEGER NB1, NB2, NB3
       DOUBLE PRECISION EPS
@@ -244,32 +277,39 @@ C     FUNCTIONS
       EXTERNAL ZMUMPS_CREATEPARTVEC,
      &     ZMUMPS_NUMVOLSNDRCV, 
      &     ZMUMPS_SETUPCOMMS,
-     &     ZMUMPS_FINDNUMMYROWCOL, 
-     &     ZMUMPS_CHKCONVGLO,
-     &     ZMUMPS_CHK1CONV,
      &     ZMUMPS_FILLMYROWCOLINDICES,
      &     ZMUMPS_INITREAL,
      &     ZMUMPS_INITREALLST,
      &     ZMUMPS_DOCOMMINF,
      &     ZMUMPS_DOCOMM1N
-      INTEGER ZMUMPS_CHKCONVGLO 
-      INTEGER ZMUMPS_CHK1CONV
       DOUBLE PRECISION ZMUMPS_ERRSCALOC
       DOUBLE PRECISION ZMUMPS_ERRSCA1
       INTRINSIC abs
       DOUBLE PRECISION RONE, RZERO
       PARAMETER(RONE=1.0D0,RZERO=0.0D0)
 C     TMP VARS
-      INTEGER RESZR, RESZC
-      INTEGER INTSZR, INTSZC
+      INTEGER(8) :: RESZR, RESZC
+      INTEGER(8) :: INTSZR, INTSZC
       INTEGER MAXMN
-      INTEGER I, IERROR
+      INTEGER I, IERROR, IOMP
       DOUBLE PRECISION ONEERRROW, ONEERRCOL, ONEERRL, ONEERRG
       DOUBLE PRECISION INFERRROW, INFERRCOL, INFERRL, INFERRG
-      INTEGER OORANGEIND
+      LOGICAL OORANGEIND
+      INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER    :: NOMP
+!$    INTEGER    :: CHUNK, CHUNK_NZ
+!$    ! Too large => pb with cache L3 ?
+!$    ! INTEGER(8) :: CHUNK8 
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP     = omp_get_max_threads()
+!$     CHUNK    = max(K361/2, (N+NOMP-1) / NOMP )
+!$    ! CHUNK8= (NZ_loc+int(NOMP-1,8) / int(NOMP,8) ) )
+!$     CHUNK_NZ = max(K361/2, (N+NOMP_MAX-1) / NOMP_MAX )
+!$    ENDIF
+C
+      OORANGEIND = .FALSE.
       INFERRG = -RONE
       ONEERRG = -RONE
-      OORANGEIND = 0
       MAXMN = M
       IF(MAXMN < N) MAXMN = N
 C     Create row partvec and col partvec
@@ -280,11 +320,11 @@ C     IF(IWRKSZ.LT.4*MAXMN) THEN   ERROR
             CALL ZMUMPS_CREATEPARTVEC(MYID, NUMPROCS, COMM,
      &           IRN_loc, JCN_loc, NZ_loc,
      &           RPARTVEC, M, N,
-     &           IWRK, IWRKSZ)
+     &           IWRK, IWRKSZ, INUMMYR, NOMP_MAX)
             CALL ZMUMPS_CREATEPARTVEC(MYID, NUMPROCS, COMM,
      &           JCN_loc, IRN_loc,  NZ_loc,
      &           CPARTVEC, N, M,
-     &           IWRK, IWRKSZ)         
+     &           IWRK, IWRKSZ, INUMMYC, NOMP_MAX)
 C     Compute sndrcv sizes, store them for later use           
             CALL ZMUMPS_NUMVOLSNDRCV(MYID, NUMPROCS, M, RPARTVEC,
      &           NZ_loc, IRN_loc, N, JCN_loc,
@@ -298,20 +338,14 @@ C     Compute sndrcv sizes, store them f
      &           OCSNDRCVNUM,OCSNDRCVVOL,
      &           IWRK,IWRKSZ, 
      &           CSNDRCVSZ(1), CSNDRCVSZ(1+NUMPROCS), COMM)         
-            CALL ZMUMPS_FINDNUMMYROWCOL(MYID, NUMPROCS, COMM,
-     &           IRN_loc, JCN_loc, NZ_loc,
-     &           RPARTVEC, CPARTVEC, M, N,
-     &           INUMMYR,
-     &           INUMMYC,     
-     &           IWRK, IWRKSZ)
-            INTSZR =  IRSNDRCVNUM + ORSNDRCVNUM + 
-     &           IRSNDRCVVOL + ORSNDRCVVOL +
-     &           2*(NUMPROCS+1) + INUMMYR
-            INTSZC = ICSNDRCVNUM + OCSNDRCVNUM + 
-     &           ICSNDRCVVOL + OCSNDRCVVOL +
-     &           2*(NUMPROCS+1) + INUMMYC
-            INTSZ = INTSZR + INTSZC + MAXMN + 
-     &           (MPI_STATUS_SIZE +1) *  NUMPROCS
+            INTSZR =  int(IRSNDRCVNUM,8) + int(ORSNDRCVNUM,8) + 
+     &           int(IRSNDRCVVOL,8) + int(ORSNDRCVVOL,8) +
+     &           2_8*int(NUMPROCS+1,8) + int(INUMMYR,8)
+            INTSZC = int(ICSNDRCVNUM,8) + int(OCSNDRCVNUM,8) + 
+     &           int(ICSNDRCVVOL,8) + int(OCSNDRCVVOL,8) +
+     &           2_8*int(NUMPROCS+1,8) + int(INUMMYC,8)
+            INTSZ = INTSZR + INTSZC + int(MAXMN,8) + 
+     &           int(MPI_STATUS_SIZE +1,8) * int(NUMPROCS,8)
          ELSE
 C     NUMPROCS IS 1
              IRSNDRCVNUM = 0
@@ -324,39 +358,39 @@ C     NUMPROCS IS 1
              ICSNDRCVVOL = 0
              OCSNDRCVVOL  = 0
              INUMMYC = 0
-             INTSZ = 0
+             INTSZ = 0_8
           ENDIF
 C     CALCULATE NECESSARY DOUBLE PRECISION SPACE
-          RESZR = M + IRSNDRCVVOL + ORSNDRCVVOL
-          RESZC = N + ICSNDRCVVOL + OCSNDRCVVOL
+          RESZR = int(M,8) + int(IRSNDRCVVOL,8) + int(ORSNDRCVVOL,8)
+          RESZC = int(N,8) + int(ICSNDRCVVOL,8) + int(OCSNDRCVVOL,8)
           RESZ = RESZR  + RESZC  
 C     CALCULATE NECESSARY INT SPACE
 C     The last maxmn is tmpwork for setup comm and fillmyrowcol
-          REGISTRE(1) = IRSNDRCVNUM 
-          REGISTRE(2) = ORSNDRCVNUM
-          REGISTRE(3) = IRSNDRCVVOL 
-          REGISTRE(4) = ORSNDRCVVOL
-          REGISTRE(5) = ICSNDRCVNUM 
-          REGISTRE(6) = OCSNDRCVNUM
-          REGISTRE(7) = ICSNDRCVVOL
-          REGISTRE(8) = OCSNDRCVVOL
-          REGISTRE(9) = INUMMYR
-          REGISTRE(10) = INUMMYC
+          REGISTRE(1)  = int(IRSNDRCVNUM,8)
+          REGISTRE(2)  = int(ORSNDRCVNUM,8)
+          REGISTRE(3)  = int(IRSNDRCVVOL,8)
+          REGISTRE(4)  = int(ORSNDRCVVOL,8)
+          REGISTRE(5)  = int(ICSNDRCVNUM,8)
+          REGISTRE(6)  = int(OCSNDRCVNUM,8)
+          REGISTRE(7)  = int(ICSNDRCVVOL,8)
+          REGISTRE(8)  = int(OCSNDRCVVOL,8)
+          REGISTRE(9)  = int(INUMMYR,8)
+          REGISTRE(10) = int(INUMMYC,8)
           REGISTRE(11) = INTSZ
           REGISTRE(12) = RESZ
        ELSE
 C     else of op=1. That is op=2 now.
 C     restore the numbers
-          IRSNDRCVNUM = REGISTRE(1) 
-          ORSNDRCVNUM = REGISTRE(2) 
-          IRSNDRCVVOL = REGISTRE(3)
-          ORSNDRCVVOL = REGISTRE(4) 
-          ICSNDRCVNUM = REGISTRE(5) 
-          OCSNDRCVNUM = REGISTRE(6) 
-          ICSNDRCVVOL = REGISTRE(7) 
-          OCSNDRCVVOL = REGISTRE(8) 
-          INUMMYR = REGISTRE(9) 
-          INUMMYC = REGISTRE(10)
+          IRSNDRCVNUM = int(REGISTRE(1))
+          ORSNDRCVNUM = int(REGISTRE(2))
+          IRSNDRCVVOL = int(REGISTRE(3))
+          ORSNDRCVVOL = int(REGISTRE(4))
+          ICSNDRCVNUM = int(REGISTRE(5))
+          OCSNDRCVNUM = int(REGISTRE(6))
+          ICSNDRCVVOL = int(REGISTRE(7))
+          OCSNDRCVVOL = int(REGISTRE(8))
+          INUMMYR     = int(REGISTRE(9))
+          INUMMYC     = int(REGISTRE(10))
           IF(NUMPROCS > 1) THEN
 C     Check done outsize
 C             IF(INTSZ < REGISTRE(11)) THEN ERROR
@@ -365,35 +399,36 @@ C     Fill up myrows and my colsX
              CALL ZMUMPS_FILLMYROWCOLINDICES(MYID, NUMPROCS,COMM,    
      &            IRN_loc, JCN_loc, NZ_loc,
      &            RPARTVEC, CPARTVEC, M, N,
-     &            IWRK(1), INUMMYR,
-     &            IWRK(1+INUMMYR), INUMMYC,     
-     &            IWRK(1+INUMMYR+INUMMYC), IWRKSZ-INUMMYR-INUMMYC )
-             IMYRPTR = 1
-             IMYCPTR = IMYRPTR + INUMMYR
+     &            IWRK(1_8), INUMMYR,
+     &            IWRK(1_8+int(INUMMYR,8)), INUMMYC,     
+     &            IWRK(1_8+int(INUMMYR,8)+int(INUMMYC,8)),
+     &            IWRKSZ-int(INUMMYR,8)-int(INUMMYC,8), NOMP_MAX )
+             IMYRPTR = 1_8
+             IMYCPTR = IMYRPTR + int(INUMMYR,8)
 C     Set up comm and run.
 C     set pointers in iwrk (4 parts)
 C     
 C     ROWS    [---------------------------------------------]
-             IRNGHBPRCS = IMYCPTR+ INUMMYC
-             IRSNDRCVIA = IRNGHBPRCS+IRSNDRCVNUM
-             IRSNDRCVJA = IRSNDRCVIA + NUMPROCS+1
-             ORNGHBPRCS = IRSNDRCVJA + IRSNDRCVVOL
-             ORSNDRCVIA = ORNGHBPRCS + ORSNDRCVNUM
-             ORSNDRCVJA = ORSNDRCVIA + NUMPROCS + 1
+             IRNGHBPRCS = IMYCPTR    + int(INUMMYC    ,8)
+             IRSNDRCVIA = IRNGHBPRCS + int(IRSNDRCVNUM,8)
+             IRSNDRCVJA = IRSNDRCVIA + int(NUMPROCS+1 ,8)
+             ORNGHBPRCS = IRSNDRCVJA + int(IRSNDRCVVOL,8)
+             ORSNDRCVIA = ORNGHBPRCS + int(ORSNDRCVNUM,8)
+             ORSNDRCVJA = ORSNDRCVIA + int(NUMPROCS+1 ,8)
 C     COLS    [---------------------------------------------]
-             ICNGHBPRCS = ORSNDRCVJA + ORSNDRCVVOL
-             ICSNDRCVIA = ICNGHBPRCS + ICSNDRCVNUM
-             ICSNDRCVJA = ICSNDRCVIA + NUMPROCS+1
-             OCNGHBPRCS = ICSNDRCVJA + ICSNDRCVVOL
-             OCSNDRCVIA = OCNGHBPRCS + OCSNDRCVNUM
-             OCSNDRCVJA = OCSNDRCVIA +  NUMPROCS + 1
+             ICNGHBPRCS = ORSNDRCVJA + int(ORSNDRCVVOL,8)
+             ICSNDRCVIA = ICNGHBPRCS + int(ICSNDRCVNUM,8)
+             ICSNDRCVJA = ICSNDRCVIA + int(NUMPROCS+1 ,8)
+             OCNGHBPRCS = ICSNDRCVJA + int(ICSNDRCVVOL,8)
+             OCSNDRCVIA = OCNGHBPRCS + int(OCSNDRCVNUM,8)
+             OCSNDRCVJA = OCSNDRCVIA + int(NUMPROCS+1 ,8)
 C     
 C     MPI     [-----------------]
-             REQUESTS = OCSNDRCVJA + OCSNDRCVVOL
-             ISTATUS = REQUESTS + NUMPROCS
+             REQUESTS = OCSNDRCVJA + int(OCSNDRCVVOL,8)
+             ISTATUS = REQUESTS + int(NUMPROCS,8)
 C     
 C     TMPWRK  [-----------------]
-             TMPWORK = ISTATUS + MPI_STATUS_SIZE *  NUMPROCS
+             TMPWORK = ISTATUS + int(MPI_STATUS_SIZE,8)*int(NUMPROCS,8)
              CALL ZMUMPS_SETUPCOMMS(MYID, NUMPROCS, M, RPARTVEC,
      &            NZ_loc, IRN_loc,N, JCN_loc,
      &            IRSNDRCVNUM, IRSNDRCVVOL, 
@@ -416,80 +451,165 @@ C     TMPWRK  [-----------------]
      &            IWRK(TMPWORK), 
      &            IWRK(ISTATUS),  IWRK(REQUESTS),
      &            TAG_COMM_COL, COMM)
-             CALL ZMUMPS_INITREAL(ROWSCA, M, RZERO)
-             CALL ZMUMPS_INITREAL(COLSCA, N, RZERO)
+             CALL ZMUMPS_INITREAL(ROWSCA, M, RZERO, NOMP_MAX)
+             CALL ZMUMPS_INITREAL(COLSCA, N, RZERO, NOMP_MAX)
              CALL ZMUMPS_INITREALLST(ROWSCA, M, 
-     &            IWRK(IMYRPTR),INUMMYR, RONE)
+     &            IWRK(IMYRPTR),INUMMYR, RONE, NOMP_MAX)
              CALL ZMUMPS_INITREALLST(COLSCA, N, 
-     &            IWRK(IMYCPTR),INUMMYC, RONE)   
+     &            IWRK(IMYCPTR),INUMMYC, RONE, NOMP_MAX)   
           ELSE
-             CALL ZMUMPS_INITREAL(ROWSCA, M, RONE)
-             CALL ZMUMPS_INITREAL(COLSCA, N, RONE)            
+             CALL ZMUMPS_INITREAL(ROWSCA, M, RONE, NOMP_MAX)
+             CALL ZMUMPS_INITREAL(COLSCA, N, RONE, NOMP_MAX)            
           ENDIF
-          ITDRPTR = 1
-          ITDCPTR = ITDRPTR + M
+          ITDRPTR = 1_8
+          ITDCPTR = ITDRPTR + int(M,8)
 C     
-          ISRRPTR = ITDCPTR + N
-          OSRRPTR = ISRRPTR + IRSNDRCVVOL
+          ISRRPTR = ITDCPTR + int(N,8)
+          OSRRPTR = ISRRPTR + int(IRSNDRCVVOL,8)
 C     
-          ISRCPTR = OSRRPTR + ORSNDRCVVOL
-          OSRCPTR = ISRCPTR + ICSNDRCVVOL
+          ISRCPTR = OSRRPTR + int(ORSNDRCVVOL,8)
+          OSRCPTR = ISRCPTR + int(ICSNDRCVVOL,8)
 C     To avoid bound check errors...
           IF(NUMPROCS == 1)THEN
-             OSRCPTR = OSRCPTR - 1
-             ISRCPTR = ISRCPTR - 1
-             OSRRPTR = OSRRPTR - 1
-             ISRRPTR = ISRRPTR - 1
+             OSRCPTR = OSRCPTR - 1_8
+             ISRCPTR = ISRCPTR - 1_8
+             OSRRPTR = OSRRPTR - 1_8
+             ISRRPTR = ISRRPTR - 1_8
           ELSE
-             IF(IRSNDRCVVOL == 0) ISRRPTR = ISRRPTR - 1
-             IF(ORSNDRCVVOL == 0) OSRRPTR = OSRRPTR - 1
-             IF(ICSNDRCVVOL == 0) ISRCPTR = ISRCPTR - 1
-             IF(OCSNDRCVVOL == 0) OSRCPTR = OSRCPTR - 1
+             IF(IRSNDRCVVOL == 0) ISRRPTR = ISRRPTR - 1_8
+             IF(ORSNDRCVVOL == 0) OSRRPTR = OSRRPTR - 1_8
+             IF(ICSNDRCVVOL == 0) ISRCPTR = ISRCPTR - 1_8
+             IF(OCSNDRCVVOL == 0) OSRCPTR = OSRCPTR - 1_8
           ENDIF
           ITER = 1
           DO WHILE (ITER.LE.NB1+NB2+NB3)
-C     CLEAR temporary Dr and Dc
-             IF(NUMPROCS > 1) THEN
-                CALL ZMUMPS_ZEROOUT(WRKRC(ITDRPTR),M,
-     &               IWRK(IMYRPTR),INUMMYR)
-                CALL ZMUMPS_ZEROOUT(WRKRC(ITDCPTR),N,
-     &               IWRK(IMYCPTR),INUMMYC)
-             ELSE
-                CALL ZMUMPS_INITREAL(WRKRC(ITDRPTR),M, RZERO)
-                CALL ZMUMPS_INITREAL(WRKRC(ITDCPTR),N, RZERO)
+C{
+C           -------------------------
+C           CLEAR temporary Dr and Dc
+C           -------------------------
+            IF (NOMP_MAX.GT.1 .AND. 
+     &        (ITER.GT.NB1 .AND.ITER.LE.NB1+NB2)
+     &      ) THEN
+C{
+!$OMP         PARALLEL
+!$OMP&         PRIVATE(IOMP)
+!$OMP&         NUM_THREADS(NOMP_MAX)
+               IOMP  = 1
+!$             IOMP = OMP_GET_THREAD_NUM() + 1
+               IF(NUMPROCS > 1) THEN
+                 CALL ZMUMPS_ZEROOUT(WRKR_TH(1,IOMP),N,
+     &                 IWRK(IMYRPTR),INUMMYR, 0)
+                 CALL ZMUMPS_ZEROOUT(WRKC_TH(1,IOMP),N,
+     &                 IWRK(IMYCPTR),INUMMYC, 0)
+               ELSE
+                 CALL ZMUMPS_INITREAL(WRKR_TH(1,IOMP),N, RZERO, 
+     &                                0)
+                 CALL ZMUMPS_INITREAL(WRKC_TH(1,IOMP),N, RZERO, 
+     &                                0)
+               ENDIF
+!$OMP         END PARALLEL
+C}
+            ELSE
+C{
+               IF(NUMPROCS > 1) THEN
+                  CALL ZMUMPS_ZEROOUT(WRKRC(ITDRPTR),M,
+     &                 IWRK(IMYRPTR),INUMMYR, NOMP_MAX)
+                  CALL ZMUMPS_ZEROOUT(WRKRC(ITDCPTR),N,
+     &                 IWRK(IMYCPTR),INUMMYC, NOMP_MAX)
+               ELSE
+                  CALL ZMUMPS_INITREAL(WRKRC(ITDRPTR),M, RZERO, 
+     &                                NOMP_MAX)
+                  CALL ZMUMPS_INITREAL(WRKRC(ITDCPTR),N, RZERO, 
+     &                                NOMP_MAX)
+               ENDIF
+C}
              ENDIF
              IF((ITER.LE.NB1).OR.(ITER > NB1+NB2)) THEN
+C     ------------------
 C     INF-NORM ITERATION
-                IF((ITER.EQ.1).OR.(OORANGEIND.EQ.1)) THEN
+C     ------------------
+               IF (NOMP_MAX.LE.0) THEN
+                IF((ITER.EQ.1).OR.(OORANGEIND)) THEN
                    DO NZIND=1_8,NZ_loc
                       IR = IRN_loc(NZIND)
                       IC = JCN_loc(NZIND)
                       IF((IR.GE.1).AND.(IR.LE.M).AND.
      &                     (IC.GE.1).AND.(IC.LE.N)) THEN
                          ELM = abs(A_loc(NZIND))*ROWSCA(IR)*COLSCA(IC)
-                         IF(WRKRC(ITDRPTR-1+IR)<ELM) THEN
-                            WRKRC(ITDRPTR-1+IR)= ELM
-                         ENDIF
-                         IF(WRKRC(ITDCPTR-1+IC)<ELM) THEN
-                            WRKRC(ITDCPTR-1+IC)= ELM
-                         ENDIF
+                         IF(WRKRC(IR)<ELM) WRKRC(IR)= ELM
+                         IF(WRKRC(ITDCPTR-1_8+int(IC,8))<ELM) 
+     &                      WRKRC(ITDCPTR-1_8+int(IC,8))= ELM
                       ELSE
-                         OORANGEIND = 1
+                         OORANGEIND = .TRUE.
                       ENDIF
                    ENDDO
-                ELSEIF(OORANGEIND.EQ.0) THEN
+                ELSEIF(.NOT.OORANGEIND) THEN
                    DO NZIND=1,NZ_loc
                       IR = IRN_loc(NZIND)
                       IC = JCN_loc(NZIND)
                       ELM = abs(A_loc(NZIND))*ROWSCA(IR)*COLSCA(IC)
-                      IF(WRKRC(ITDRPTR-1+IR)<ELM) THEN
-                         WRKRC(ITDRPTR-1+IR)= ELM
-                      ENDIF
-                      IF(WRKRC(ITDCPTR-1+IC)<ELM) THEN
-                         WRKRC(ITDCPTR-1+IC)= ELM
+                      IF(WRKRC(IR)<ELM) WRKRC(IR)= ELM
+                      IF(WRKRC(ITDCPTR-1_8+int(IC,8))<ELM) 
+     &                   WRKRC(ITDCPTR-1_8+int(IC,8))= ELM
+                   ENDDO
+                ENDIF
+               ELSE
+                IF((ITER.EQ.1).OR.(OORANGEIND)) THEN
+!$OMP   PARALLEL DO PRIVATE(NZIND,IR,IC,ELM) 
+!$OMP&  SCHEDULE(STATIC,CHUNK_NZ)
+!$OMP&  IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
+!$OMP&  REDUCTION(.OR.:OORANGEIND)
+                   DO NZIND=1_8,NZ_loc
+                      IR = IRN_loc(NZIND)
+                      IC = JCN_loc(NZIND)
+                      IF((IR.GE.1).AND.(IR.LE.M).AND.
+     &                     (IC.GE.1).AND.(IC.LE.N)) THEN
+                         ELM = abs(A_loc(NZIND))*ROWSCA(IR)*COLSCA(IC)
+!$OMP                    ATOMIC UPDATE
+                         WRKRC(IR)= max (ELM, WRKRC(IR))
+!$OMP                    END ATOMIC
+C                         IF(WRKRC(ITDRPTR-1_8+int(IR,8))<ELM) THEN
+C                            WRKRC(ITDRPTR-1_8+int(IR,8))= ELM
+C                         ENDIF
+C                        IF(WRKRC(ITDCPTR-1_8+int(IC,8))<ELM) THEN
+C                           WRKRC(ITDCPTR-1_8+int(IC,8))= ELM
+C                         ENDIF
+C                        ITDCPTR+IC might be > int4
+!$OMP                    ATOMIC UPDATE
+                         WRKRC(ITDCPTR-1_8+int(IC,8)) = 
+     &                   max (ELM,WRKRC(ITDCPTR-1_8+int(IC,8)))
+!$OMP                    END ATOMIC
+                      ELSE
+                         OORANGEIND = .TRUE.
                       ENDIF
                    ENDDO
+!$OMP   END PARALLEL DO
+                ELSEIF(.NOT.OORANGEIND) THEN
+!$OMP   PARALLEL DO PRIVATE(NZIND,IR,IC,ELM) 
+!$OMP&  SCHEDULE(STATIC,CHUNK_NZ)
+!$OMP&  IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
+                   DO NZIND=1,NZ_loc
+                      IR = IRN_loc(NZIND)
+                      IC = JCN_loc(NZIND)
+                      ELM = abs(A_loc(NZIND))*ROWSCA(IR)*COLSCA(IC)
+C                      IF(WRKRC(ITDRPTR-1_8+int(IR,8))<ELM) THEN
+C                         WRKRC(ITDRPTR-1_8+int(IR,8))= ELM
+C                      ENDIF
+!$OMP                 ATOMIC UPDATE
+                      WRKRC(IR)= max (ELM, WRKRC(IR))
+!$OMP                 END ATOMIC
+C                      IF(WRKRC(ITDCPTR-1_8+int(IC,8))<ELM) THEN
+C                         WRKRC(ITDCPTR-1_8+int(IC,8))= ELM
+C                      ENDIF
+!$OMP                 ATOMIC UPDATE
+                      WRKRC(ITDCPTR-1_8+int(IC,8)) = 
+     &                   max (ELM,WRKRC(ITDCPTR-1_8+int(IC,8)))
+!$OMP                 END ATOMIC
+                   ENDDO
+!$OMP   END PARALLEL DO
                 ENDIF
+C}
+               ENDIF
                 IF(NUMPROCS > 1) THEN
                    CALL ZMUMPS_DOCOMMINF(MYID, NUMPROCS,
      &                  WRKRC(ITDCPTR), N, TAG_ITERS+ITER, 
@@ -518,11 +638,11 @@ C
      &                 (NB1+NB3.GT.0))) THEN
                      INFERRROW = ZMUMPS_ERRSCALOC(ROWSCA, 
      &                    WRKRC(ITDRPTR), M,
-     &                    IWRK(IMYRPTR),INUMMYR)
+     &                    IWRK(IMYRPTR),INUMMYR, NOMP_MAX)
 C     find error for the cols
                      INFERRCOL = ZMUMPS_ERRSCALOC(COLSCA,  
      &                    WRKRC(ITDCPTR), N,
-     &                    IWRK(IMYCPTR),INUMMYC)
+     &                    IWRK(IMYCPTR),INUMMYC, NOMP_MAX)
 C     get max of those two errors
                      INFERRL = INFERRCOL
                      IF(INFERRROW > INFERRL ) THEN
@@ -535,10 +655,10 @@ C
                      IF(INFERRG.LE.EPS) THEN
                         CALL ZMUMPS_UPDATESCALE(COLSCA,  
      &                       WRKRC(ITDCPTR),N,
-     &                       IWRK(IMYCPTR),INUMMYC)
+     &                       IWRK(IMYCPTR),INUMMYC, NOMP_MAX)
                         CALL ZMUMPS_UPDATESCALE(ROWSCA,  
      &                       WRKRC(ITDRPTR),M,
-     &                       IWRK(IMYRPTR),INUMMYR)         
+     &                       IWRK(IMYRPTR),INUMMYR, NOMP_MAX)         
                         IF(ITER .LE. NB1) THEN
                            ITER = NB1+1
                            CYCLE
@@ -554,10 +674,10 @@ C     SINGLE PROCESSOR CASE: INF-NORM ER
      &                 ((ITER.EQ.NB1+NB2+NB3).AND.
      &                 (NB1+NB3.GT.0))) THEN
                      INFERRROW = ZMUMPS_ERRSCA1(ROWSCA, 
-     &                    WRKRC(ITDRPTR), M)
+     &                    WRKRC(ITDRPTR), M, NOMP_MAX)
 C     find error for the cols
                      INFERRCOL = ZMUMPS_ERRSCA1(COLSCA,  
-     &                    WRKRC(ITDCPTR), N)
+     &                    WRKRC(ITDCPTR), N, NOMP_MAX)
 C     get max of those two errors
                      INFERRL = INFERRCOL
                      IF(INFERRROW > INFERRL) THEN
@@ -565,8 +685,10 @@ C     get max of those two errors
                      ENDIF                     
                      INFERRG = INFERRL
                      IF(INFERRG.LE.EPS) THEN
-                        CALL ZMUMPS_UPSCALE1(COLSCA,  WRKRC(ITDCPTR), N)
-                        CALL ZMUMPS_UPSCALE1(ROWSCA,  WRKRC(ITDRPTR), M)
+                        CALL ZMUMPS_UPSCALE1(COLSCA, WRKRC(ITDCPTR), N, 
+     &                                       NOMP_MAX)
+                        CALL ZMUMPS_UPSCALE1(ROWSCA, WRKRC(ITDRPTR), M, 
+     &                                       NOMP_MAX)
                         IF(ITER .LE. NB1) THEN
                            ITER = NB1+1
                            CYCLE
@@ -577,30 +699,102 @@ C     get max of those two errors
                   ENDIF
                ENDIF
             ELSE
+C     ----------------------------------------
 C     WE HAVE ITER.GT.NB1 AND ITER.LE.NB1+NB2. 
 C     ONE-NORM ITERATION
-               IF((ITER .EQ.1).OR.(OORANGEIND.EQ.1))THEN
+C     ----------------------------------------
+             IF (NOMP_MAX.LE.1) THEN
+               IF((ITER .EQ.1).OR.(OORANGEIND))THEN
+                  DO NZIND=1_8,NZ_loc
+                     IR = IRN_loc(NZIND)
+                     IC = JCN_loc(NZIND)
+                     IF((IR.GE.1).AND.(IR.LE.M).AND.
+     &                    (IC.GE.1).AND.(IC.LE.N)) THEN
+                        ELM = abs(A_loc(NZIND))*ROWSCA(IR)*COLSCA(IC)
+C                       WRKRC(ITDRPTR-1_8+int(IR,8)) =
+C     &                 WRKRC(ITDRPTR-1_8+int(IR,8)) + ELM
+                        WRKRC(IR) =  WRKRC(IR) + ELM
+                        WRKRC(ITDCPTR-1_8+int(IC,8)) =
+     &                  WRKRC(ITDCPTR-1_8+int(IC,8)) + ELM
+                     ELSE
+                        OORANGEIND = .TRUE.
+                     ENDIF
+                  ENDDO
+               ELSEIF(.NOT.OORANGEIND) THEN
+                  DO NZIND=1,NZ_loc
+                     IR = IRN_loc(NZIND)
+                     IC = JCN_loc(NZIND)
+                     ELM = abs(A_loc(NZIND))*ROWSCA(IR)*COLSCA(IC)
+C                    WRKRC(ITDRPTR-1_8+int(IR,8)) =
+C     &              WRKRC(ITDRPTR-1_8+int(IR,8)) + ELM
+                     WRKRC(IR) =  WRKRC(IR) + ELM
+                     WRKRC(ITDCPTR-1_8+int(IC,8)) =
+     &               WRKRC(ITDCPTR-1_8+int(IC,8)) + ELM
+                  ENDDO
+               ENDIF
+C}
+             ELSE  ! NOMP_MAX>1
+               IF((ITER .EQ.1).OR.(OORANGEIND))THEN
+!$OMP   PARALLEL PRIVATE(IOMP)
+!$OMP&  NUM_THREADS(NOMP_MAX)
+!$OMP&    IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
+                    IOMP  = 1
+!$                  IOMP = OMP_GET_THREAD_NUM() + 1
+!$OMP     DO PRIVATE(NZIND,IR,IC,ELM)
+!$OMP&    SCHEDULE(STATIC,CHUNK_NZ)
+!$OMP&    REDUCTION(.OR.:OORANGEIND)
                   DO NZIND=1_8,NZ_loc
                      IR = IRN_loc(NZIND)
                      IC = JCN_loc(NZIND)
                      IF((IR.GE.1).AND.(IR.LE.M).AND.
      &                    (IC.GE.1).AND.(IC.LE.N)) THEN
                         ELM = abs(A_loc(NZIND))*ROWSCA(IR)*COLSCA(IC)
-                        WRKRC(ITDRPTR-1+IR) = WRKRC(ITDRPTR-1+IR) + ELM
-                        WRKRC(ITDCPTR-1+IC) = WRKRC(ITDCPTR-1+IC) + ELM
+                        WRKR_TH(IR,IOMP) = WRKR_TH(IR,IOMP) + ELM
+                        IF (IR.NE.IC)
+     &                  WRKC_TH(IC,IOMP) = WRKC_TH(IC,IOMP) + ELM
                      ELSE
-                        OORANGEIND = 1
+                        OORANGEIND = .TRUE.
                      ENDIF
                   ENDDO
-               ELSEIF(OORANGEIND.EQ.0) THEN
+!$OMP     END DO
+!$OMP   END PARALLEL
+               ELSEIF(.NOT.OORANGEIND) THEN
+!$OMP   PARALLEL PRIVATE(IOMP)
+!$OMP&  NUM_THREADS(NOMP_MAX)
+!$OMP&    IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
+                    IOMP  = 1
+!$                  IOMP = OMP_GET_THREAD_NUM() + 1
+!$OMP     DO PRIVATE(NZIND,IR,IC,ELM)
+!$OMP&    SCHEDULE(STATIC,CHUNK_NZ)
                   DO NZIND=1,NZ_loc
                      IR = IRN_loc(NZIND)
                      IC = JCN_loc(NZIND)
                      ELM = abs(A_loc(NZIND))*ROWSCA(IR)*COLSCA(IC)
-                     WRKRC(ITDRPTR-1+IR) = WRKRC(ITDRPTR-1+IR) + ELM
-                     WRKRC(ITDCPTR-1+IC) = WRKRC(ITDCPTR-1+IC) + ELM
+                     WRKR_TH(IR,IOMP) = WRKR_TH(IR,IOMP) + ELM
+                     IF (IR.NE.IC)
+     &               WRKC_TH(IC,IOMP) = WRKC_TH(IC,IOMP) + ELM
                   ENDDO
+!$OMP     END DO
+!$OMP   END PARALLEL
+               ENDIF
+C
+C              For all i on MYID:
+C              Build WRKRC(i) = Sum       (WRKR_TH(i,IOMP)
+C                              IOMP \in [1:NOMP_MAX]
+               IF(NUMPROCS > 1) THEN
+                 CALL ZMUMPS_REDUCE_WRK_MPI (WRKRC, N, WRKR_TH, 
+     &                 NOMP_MAX, 
+     &                 IWRK(IMYRPTR),INUMMYR)
+                 CALL ZMUMPS_REDUCE_WRK_MPI (WRKRC(ITDCPTR), 
+     &                 N, WRKC_TH, NOMP_MAX, 
+     &                 IWRK(IMYCPTR),INUMMYC)
+               ELSE
+                 CALL ZMUMPS_REDUCE_WRK (WRKRC, N, WRKR_TH, NOMP_MAX)
+                 CALL ZMUMPS_REDUCE_WRK (WRKRC(ITDCPTR), 
+     &                 N, WRKC_TH, NOMP_MAX)
                ENDIF
+C}
+             ENDIF
                IF(NUMPROCS > 1) THEN                 
                   CALL ZMUMPS_DOCOMM1N(MYID, NUMPROCS,
      &                 WRKRC(ITDCPTR), N, TAG_ITERS+ITER, 
@@ -628,11 +822,11 @@ C
      &                 (NB2.GT.0))) THEN
                      ONEERRROW = ZMUMPS_ERRSCALOC(ROWSCA, 
      &                    WRKRC(ITDRPTR), M,
-     &                    IWRK(IMYRPTR),INUMMYR)
+     &                    IWRK(IMYRPTR),INUMMYR, NOMP_MAX)
 C     find error for the cols
                      ONEERRCOL = ZMUMPS_ERRSCALOC(COLSCA,  
      &                    WRKRC(ITDCPTR), N,
-     &                    IWRK(IMYCPTR),INUMMYC)
+     &                    IWRK(IMYCPTR),INUMMYC, NOMP_MAX)
 C     get max of those two errors
                      ONEERRL = ONEERRCOL
                      IF(ONEERRROW > ONEERRL ) THEN
@@ -645,10 +839,10 @@ C
                      IF(ONEERRG.LE.EPS) THEN
                         CALL ZMUMPS_UPDATESCALE(COLSCA,
      &                       WRKRC(ITDCPTR),N,
-     &                       IWRK(IMYCPTR),INUMMYC)
+     &                       IWRK(IMYCPTR),INUMMYC, NOMP_MAX)
                         CALL ZMUMPS_UPDATESCALE(ROWSCA,
      &                       WRKRC(ITDRPTR),M,
-     &                       IWRK(IMYRPTR),INUMMYR)          
+     &                       IWRK(IMYRPTR),INUMMYR, NOMP_MAX)
                         ITER = NB1+NB2+1
                         CYCLE
                      ENDIF
@@ -659,10 +853,10 @@ C     SINGLE-PROCESSOR CASE: ONE-NORM ER
      &                 ((ITER.EQ.NB1+NB2).AND.
      &                 (NB2.GT.0))) THEN
                      ONEERRROW = ZMUMPS_ERRSCA1(ROWSCA, 
-     &                    WRKRC(ITDRPTR), M)
+     &                    WRKRC(ITDRPTR), M, NOMP_MAX)
 C     find error for the cols
                      ONEERRCOL = ZMUMPS_ERRSCA1(COLSCA,  
-     &                    WRKRC(ITDCPTR), N)
+     &                    WRKRC(ITDCPTR), N, NOMP_MAX)
 C     get max of those two errors
                      ONEERRL = ONEERRCOL
                      IF(ONEERRROW > ONEERRL) THEN
@@ -670,30 +864,36 @@ C     get max of those two errors
                      ENDIF                     
                      ONEERRG = ONEERRL
                      IF(ONEERRG.LE.EPS) THEN
-                        CALL ZMUMPS_UPSCALE1(COLSCA,  WRKRC(ITDCPTR), N)
-                        CALL ZMUMPS_UPSCALE1(ROWSCA,  WRKRC(ITDRPTR), M)
-                        ITER = NB1+NB2+1                        
-                        CYCLE
+                       CALL ZMUMPS_UPSCALE1(COLSCA, WRKRC(ITDCPTR), N, 
+     &                                      NOMP_MAX)
+                       CALL ZMUMPS_UPSCALE1(ROWSCA, WRKRC(ITDRPTR), M, 
+     &                                      NOMP_MAX)
+                       ITER = NB1+NB2+1                        
+                       CYCLE
                      ENDIF
                   ENDIF                  
                ENDIF 
             ENDIF
             IF(NUMPROCS > 1) THEN               
                CALL ZMUMPS_UPDATESCALE(COLSCA,  WRKRC(ITDCPTR), N,
-     &              IWRK(IMYCPTR),INUMMYC)
+     &              IWRK(IMYCPTR),INUMMYC, NOMP_MAX)
                CALL ZMUMPS_UPDATESCALE(ROWSCA,  WRKRC(ITDRPTR), M,
-     &              IWRK(IMYRPTR),INUMMYR)               
+     &              IWRK(IMYRPTR),INUMMYR, NOMP_MAX)               
 C   
             ELSE
 C     SINGLE PROCESSOR CASE: Conv check and update of sca arrays
-               CALL ZMUMPS_UPSCALE1(COLSCA,  WRKRC(ITDCPTR), N)
-               CALL ZMUMPS_UPSCALE1(ROWSCA,  WRKRC(ITDRPTR), M)
+               CALL ZMUMPS_UPSCALE1(COLSCA, WRKRC(ITDCPTR), N, 
+     &                              NOMP_MAX)
+               CALL ZMUMPS_UPSCALE1(ROWSCA, WRKRC(ITDRPTR), M, 
+     &                              NOMP_MAX)
             ENDIF
             ITER = ITER + 1
+C}
          ENDDO
          ONENORMERR = ONEERRG 
          INFNORMERR = INFERRG 
          IF(NUMPROCS > 1) THEN
+C{
             CALL MPI_REDUCE(ROWSCA, WRKRC(1), M, MPI_DOUBLE_PRECISION,
      &           MPI_MAX, 0, 
      &           COMM, IERROR)
@@ -707,14 +907,28 @@ C     WRITE (6,*) MYID, 'ROWSCA=',ROWSCA
 C     WRITE (6,*) MYID, 'COLSCA=',COLSCA
 C     CALL FLUSH(6)
 c     REduce the whole scaling factors to processor 0 of COMM
-            CALL MPI_REDUCE(COLSCA, WRKRC(1+M), N, MPI_DOUBLE_PRECISION,
+            CALL MPI_REDUCE(COLSCA, WRKRC(1_8+int(M,8)), N, 
+     &           MPI_DOUBLE_PRECISION,
      &           MPI_MAX, 0, 
      &           COMM, IERROR)
-            If(MYID.EQ.0) THEN
+            IF(MYID.EQ.0) THEN
+C{
+              IF (NOMP_MAX.LE.0) THEN
                DO I=1, N
-                  COLSCA(I) = WRKRC(I+M)
+                  COLSCA(I) = WRKRC(int(I,8)+int(M,8))
                ENDDO
+              ELSE
+!$OMP       PARALLEL DO PRIVATE(I)
+!$OMP&      SCHEDULE(STATIC,CHUNK)
+!$OMP&      IF ( N > K361 .AND. NOMP .GT. 1)
+               DO I=1, N
+                  COLSCA(I) = WRKRC(int(I,8)+int(M,8))
+               ENDDO
+!$OMP       END PARALLEL DO
+              ENDIF
+C}
             ENDIF         
+C}
          ENDIF
       ENDIF
       RETURN
@@ -732,6 +946,7 @@ C
      &     IWRK, IWRKSZ,
      &     INTSZ, RESZ, OP,
      &     SCA, WRKRC, ISZWRKRC,
+     &     WRKR_TH, LWRKR_TH, NOMP_MAX,
      &     NB1, NB2, NB3, EPS,
      &     ONENORMERR, INFNORMERR)    
 C----------------------------------------------------------------------
@@ -821,31 +1036,34 @@ C         In proceedings of VECPAR'08-In
 C         Performance Computing for Computational Science, Jan'08.
 C     and was supported by ANR-SOLSTICE project (ANR-06-CIS6-010)
 C ---------------------------------------------------------------------
+!$    USE OMP_LIB
       IMPLICIT NONE
       INCLUDE 'mpif.h'
       INTEGER(8) :: NZ_loc 
-      INTEGER N, IWRKSZ, OP
-      INTEGER NUMPROCS, MYID, COMM
-      INTEGER INTSZ, RESZ
+      INTEGER N, OP
+      INTEGER(8) :: IWRKSZ, LWRKR_TH
+      INTEGER NUMPROCS, MYID, COMM, NOMP_MAX
+      INTEGER(8) :: INTSZ, RESZ
       INTEGER IRN_loc(NZ_loc)
       INTEGER JCN_loc(NZ_loc)
       COMPLEX(kind=8) A_loc(NZ_loc)
       INTEGER PARTVEC(N), RSNDRCVSZ(2*NUMPROCS)
       INTEGER IWRK(IWRKSZ)
-      INTEGER REGISTRE(12)
+      INTEGER(8) :: REGISTRE(12)
       DOUBLE PRECISION SCA(N)
-      INTEGER ISZWRKRC
-      DOUBLE PRECISION WRKRC(ISZWRKRC)
+      INTEGER(8) :: ISZWRKRC
+      DOUBLE PRECISION WRKRC(ISZWRKRC), 
+     &     WRKR_TH(LWRKR_TH, max(NOMP_MAX,1))
 C     LOCALS
       INTEGER IRSNDRCVNUM, ORSNDRCVNUM
       INTEGER IRSNDRCVVOL, ORSNDRCVVOL
       INTEGER  INUMMYR
 C IMPORTANT POINTERS
-      INTEGER IMYRPTR,IMYCPTR 
-      INTEGER IRNGHBPRCS, IRSNDRCVIA,IRSNDRCVJA
-      INTEGER ORNGHBPRCS, ORSNDRCVIA,ORSNDRCVJA
-      INTEGER ISTATUS, REQUESTS, TMPWORK
-      INTEGER ITDRPTR, ISRRPTR, OSRRPTR
+      INTEGER(8) :: IMYRPTR,IMYCPTR 
+      INTEGER(8) :: IRNGHBPRCS, IRSNDRCVIA,IRSNDRCVJA
+      INTEGER(8) :: ORNGHBPRCS, ORSNDRCVIA,ORSNDRCVJA
+      INTEGER(8) :: ISTATUS, REQUESTS, TMPWORK
+      INTEGER(8) :: ITDRPTR, ISRRPTR, OSRRPTR
       DOUBLE PRECISION ONENORMERR,INFNORMERR
 C     FOR the scaling phase  
       INTEGER NB1, NB2, NB3
@@ -863,58 +1081,65 @@ C     FUNCTIONS
       EXTERNAL ZMUMPS_CREATEPARTVECSYM,
      &     ZMUMPS_NUMVOLSNDRCVSYM, 
      &     ZMUMPS_SETUPCOMMSSYM,
-     &     ZMUMPS_FINDNUMMYROWCOLSYM, 
-     &     ZMUMPS_CHKCONVGLOSYM,
-     &     ZMUMPS_CHK1CONV,
      &     ZMUMPS_FILLMYROWCOLINDICESSYM,
      &     ZMUMPS_DOCOMMINF,
      &     ZMUMPS_DOCOMM1N,
      &     ZMUMPS_INITREAL,
      &     ZMUMPS_INITREALLST
-      INTEGER ZMUMPS_CHKCONVGLOSYM 
-      INTEGER ZMUMPS_CHK1CONV
       DOUBLE PRECISION ZMUMPS_ERRSCALOC
       DOUBLE PRECISION ZMUMPS_ERRSCA1
       INTRINSIC abs
       DOUBLE PRECISION RONE, RZERO
       PARAMETER(RONE=1.0D0,RZERO=0.0D0)
 C     TMP VARS
-      INTEGER INTSZR
+      INTEGER(8) :: INTSZR
       INTEGER MAXMN
       INTEGER I, IERROR
       DOUBLE PRECISION ONEERRL, ONEERRG
       DOUBLE PRECISION INFERRL, INFERRG
-      INTEGER OORANGEIND
-      OORANGEIND = 0
+      LOGICAL OORANGEIND
+      INTEGER, PARAMETER :: K361 = 2048
+      INTEGER            :: IOMP
+!$    INTEGER    :: NOMP
+!$    INTEGER    :: CHUNK, CHUNK_NZ
+!$    ! Too large => pb with cache L3 ?
+!$    ! INTEGER(8) :: CHUNK8 
+!$    ! CHUNK8= max(int(K361/2,8), 
+!$    !  &   (NZ_loc+int(NOMP-1,8) / int(NOMP,8) ) )
+!$    ! CHUNK8   = min(CHUNK8, huge(CHUNK)-1_8)
+!$    NOMP  = omp_get_max_threads()
+!$    CHUNK= max(K361/2, (N+NOMP-1) / NOMP )
+!$    IF (NOMP_MAX.GT.0) THEN
+!$      CHUNK_NZ = max(K361/2, (N+NOMP_MAX-1) / NOMP_MAX )
+!$    ENDIF
+C
+      OORANGEIND = .FALSE.
       INFERRG = -RONE
       ONEERRG = -RONE
       MAXMN = N
       IF(OP == 1) THEN
+C{
          IF(NUMPROCS > 1) THEN
 C     Check done outside
 C     IF(IWRKSZ.LT.2*MAXMN) THEN   ERROR.... 
             CALL ZMUMPS_CREATEPARTVECSYM(MYID, NUMPROCS, COMM,
      &           IRN_loc, JCN_loc, NZ_loc,
      &           PARTVEC, N,
-     &           IWRK, IWRKSZ)
-C     
+     &           IWRK, IWRKSZ, INUMMYR )
+C
+C     Check done outside
             CALL ZMUMPS_NUMVOLSNDRCVSYM(MYID, NUMPROCS, N, PARTVEC,
      &           NZ_loc, IRN_loc, JCN_loc, IRSNDRCVNUM,IRSNDRCVVOL,
      &           ORSNDRCVNUM, ORSNDRCVVOL,
      &           IWRK,IWRKSZ, 
      &           RSNDRCVSZ(1), RSNDRCVSZ(1+NUMPROCS), COMM)
 C     
-            CALL ZMUMPS_FINDNUMMYROWCOLSYM(MYID, NUMPROCS, COMM,
-     &           IRN_loc, JCN_loc, NZ_loc,
-     &           PARTVEC, N,
-     &           INUMMYR,
-     &           IWRK, IWRKSZ)
 C     
-            INTSZR =  IRSNDRCVNUM + ORSNDRCVNUM + 
-     &           IRSNDRCVVOL + ORSNDRCVVOL +
-     &           2*(NUMPROCS+1) + INUMMYR
-            INTSZ = INTSZR + N + 
-     &           (MPI_STATUS_SIZE +1) *  NUMPROCS
+            INTSZR =  int(IRSNDRCVNUM,8) + int(ORSNDRCVNUM,8) + 
+     &           int(IRSNDRCVVOL,8) + int(ORSNDRCVVOL,8) +
+     &           2_8*int(NUMPROCS+1,8) + int(INUMMYR,8)
+            INTSZ = INTSZR + int(N,8) + 
+     &           int(MPI_STATUS_SIZE +1,8) * int(NUMPROCS,8)
          ELSE
 C     NUMPROCS IS 1
             IRSNDRCVNUM = 0
@@ -922,25 +1147,27 @@ C     NUMPROCS IS 1
             IRSNDRCVVOL = 0 
             ORSNDRCVVOL = 0
             INUMMYR = 0
-            INTSZ = 0
+            INTSZ = 0_8
          ENDIF
 C     CALCULATE NECESSARY DOUBLE PRECISION SPACE
-         RESZ = N + IRSNDRCVVOL + ORSNDRCVVOL
-         REGISTRE(1) = IRSNDRCVNUM 
-         REGISTRE(2) = ORSNDRCVNUM
-         REGISTRE(3) = IRSNDRCVVOL 
-         REGISTRE(4) = ORSNDRCVVOL
-         REGISTRE(9) = INUMMYR
+         RESZ = int(N,8) + int(IRSNDRCVVOL,8) + int(ORSNDRCVVOL,8)
+         REGISTRE(1)  = int(IRSNDRCVNUM,8)
+         REGISTRE(2)  = int(ORSNDRCVNUM,8)
+         REGISTRE(3)  = int(IRSNDRCVVOL,8)
+         REGISTRE(4)  = int(ORSNDRCVVOL,8)
+         REGISTRE(9)  = int(INUMMYR,8)
          REGISTRE(11) = INTSZ
          REGISTRE(12) = RESZ
+C}
       ELSE
+C{
 C     else of op=1. That is op=2 now.
 C     restore the numbers
-         IRSNDRCVNUM = REGISTRE(1) 
-         ORSNDRCVNUM = REGISTRE(2) 
-         IRSNDRCVVOL = REGISTRE(3)
-         ORSNDRCVVOL = REGISTRE(4) 
-         INUMMYR = REGISTRE(9) 
+         IRSNDRCVNUM = int(REGISTRE(1))
+         ORSNDRCVNUM = int(REGISTRE(2))
+         IRSNDRCVVOL = int(REGISTRE(3))
+         ORSNDRCVVOL = int(REGISTRE(4))
+         INUMMYR     = int(REGISTRE(9))
           IF(NUMPROCS > 1) THEN
 C     Check done outsize
 C             IF(INTSZ < REGISTRE(11)) THEN ERROR
@@ -950,24 +1177,24 @@ C     Fill up myrows and my colsX
      &            IRN_loc, JCN_loc, NZ_loc,
      &            PARTVEC, N,
      &            IWRK(1), INUMMYR,
-     &            IWRK(1+INUMMYR), IWRKSZ-INUMMYR)
-             IMYRPTR = 1
-             IMYCPTR = IMYRPTR + INUMMYR
+     &            IWRK(1+INUMMYR), IWRKSZ-int(INUMMYR,8), NOMP_MAX)
+             IMYRPTR = 1_8
+             IMYCPTR = IMYRPTR + int(INUMMYR,8)
 C     Set up comm and run.
 C     set pointers in iwrk (3 parts)
 C     
 C     ROWS    [---------------------------------------------]
              IRNGHBPRCS = IMYCPTR 
-             IRSNDRCVIA = IRNGHBPRCS+IRSNDRCVNUM
-             IRSNDRCVJA = IRSNDRCVIA + NUMPROCS+1
-             ORNGHBPRCS = IRSNDRCVJA + IRSNDRCVVOL
-             ORSNDRCVIA = ORNGHBPRCS + ORSNDRCVNUM
-             ORSNDRCVJA = ORSNDRCVIA + NUMPROCS + 1
+             IRSNDRCVIA = IRNGHBPRCS + int(IRSNDRCVNUM,8)
+             IRSNDRCVJA = IRSNDRCVIA + int(NUMPROCS+1,8)
+             ORNGHBPRCS = IRSNDRCVJA + int(IRSNDRCVVOL,8)
+             ORSNDRCVIA = ORNGHBPRCS + int(ORSNDRCVNUM,8)
+             ORSNDRCVJA = ORSNDRCVIA + int(NUMPROCS + 1,8)
 C     MPI     [-----------------]
-             REQUESTS = ORSNDRCVJA + ORSNDRCVVOL 
-             ISTATUS = REQUESTS + NUMPROCS
+             REQUESTS = ORSNDRCVJA + int(ORSNDRCVVOL,8)
+             ISTATUS = REQUESTS + int(NUMPROCS,8)
 C     TMPWRK  [-----------------]
-             TMPWORK = ISTATUS + MPI_STATUS_SIZE *  NUMPROCS
+             TMPWORK = ISTATUS + int(MPI_STATUS_SIZE,8)*int(NUMPROCS,8)
              CALL ZMUMPS_SETUPCOMMSSYM(MYID, NUMPROCS, N, PARTVEC,
      &            NZ_loc, IRN_loc, JCN_loc,
      &            IRSNDRCVNUM, IRSNDRCVVOL, 
@@ -978,15 +1205,15 @@ C     TMPWRK  [-----------------]
      &            IWRK(TMPWORK), 
      &            IWRK(ISTATUS), IWRK(REQUESTS),
      &            TAG_COMM_ROW, COMM)
-             CALL ZMUMPS_INITREAL(SCA, N, RZERO)
+             CALL ZMUMPS_INITREAL(SCA, N, RZERO, NOMP_MAX)
              CALL ZMUMPS_INITREALLST(SCA, N, 
-     &            IWRK(IMYRPTR),INUMMYR, RONE)
+     &            IWRK(IMYRPTR),INUMMYR, RONE, NOMP_MAX)
           ELSE
-             CALL ZMUMPS_INITREAL(SCA, N, RONE)
+             CALL ZMUMPS_INITREAL(SCA, N, RONE, NOMP_MAX)
           ENDIF
-          ITDRPTR = 1
-          ISRRPTR = ITDRPTR + N
-          OSRRPTR = ISRRPTR + IRSNDRCVVOL
+          ITDRPTR = 1_8
+          ISRRPTR = ITDRPTR + int(N,8)
+          OSRRPTR = ISRRPTR + int(IRSNDRCVVOL,8)
 C     
 C     To avoid bound check errors...
           IF(NUMPROCS == 1)THEN
@@ -999,46 +1226,123 @@ C     To avoid bound check errors...
 C     computation starts
           ITER = 1
           DO WHILE(ITER.LE.NB1+NB2+NB3)
-C     CLEAR temporary Dr and Dc
-             IF(NUMPROCS > 1) THEN
-                CALL ZMUMPS_ZEROOUT(WRKRC(ITDRPTR),N,
-     &               IWRK(IMYRPTR),INUMMYR)
+C{
+C            -------------------------
+C            CLEAR temporary Dr and Dc 
+C            -------------------------
+             IF (NOMP_MAX.GT.1 .AND. 
+     &         (ITER.GT.NB1 .AND.ITER.LE.NB1+NB2)
+     &       ) THEN
+C             if one norm iteration and multithreading activated
+C             WRKR_TH need be initialized and 
+C             WRKRC will be set by reduction of WRKR_TH
+!$OMP         PARALLEL
+!$OMP&         PRIVATE(IOMP)
+!$OMP&         NUM_THREADS(NOMP_MAX)
+               IOMP  = 1
+!$             IOMP = OMP_GET_THREAD_NUM() + 1
+               IF(NUMPROCS > 1) THEN
+                 CALL ZMUMPS_ZEROOUT(WRKR_TH(1,IOMP),N,
+     &                 IWRK(IMYRPTR),INUMMYR, 0)
+               ELSE
+                 CALL ZMUMPS_INITREAL(WRKR_TH(1,IOMP),N, RZERO, 
+     &                                0)
+               ENDIF
+!$OMP         END PARALLEL
              ELSE
-                CALL ZMUMPS_INITREAL(WRKRC(ITDRPTR),N, RZERO)
+              IF(NUMPROCS > 1) THEN
+CFIXME         Size N should be adjusted to effective size
+                 CALL ZMUMPS_ZEROOUT(WRKRC(ITDRPTR),N,
+     &                IWRK(IMYRPTR),INUMMYR, NOMP_MAX)
+              ELSE
+                 CALL ZMUMPS_INITREAL(WRKRC(ITDRPTR),N, RZERO,
+     &                                NOMP_MAX)
+              ENDIF
              ENDIF
+C
              IF((ITER.LE.NB1).OR.(ITER > NB1+NB2)) THEN
-C     INF-NORM ITERATION
-                IF((ITER.EQ.1).OR.(OORANGEIND.EQ.1)) THEN
+C            ------------------
+C{           INF-NORM ITERATION
+C            ------------------
+               IF (NOMP_MAX.LE.0) THEN
+                 IF((ITER .EQ.1).OR.(OORANGEIND))THEN
                    DO NZIND=1_8,NZ_loc
                       IR = IRN_loc(NZIND)
                       IC = JCN_loc(NZIND)
                       IF((IR.GE.1).AND.(IR.LE.N).AND.
      &                     (IC.GE.1).AND.(IC.LE.N)) THEN
                          ELM = abs(A_loc(NZIND))*SCA(IR)*SCA(IC)
-                         IF(WRKRC(ITDRPTR-1+IR)<ELM) THEN
-                            WRKRC(ITDRPTR-1+IR)= ELM
-                         ENDIF
-                         IF(WRKRC(ITDRPTR-1+IC)<ELM) THEN
-                            WRKRC(ITDRPTR-1+IC)= ELM
-                         ENDIF
+                         IF (WRKRC(IR)<ELM) WRKRC(IR)= ELM
+                         IF (WRKRC(IC)<ELM) WRKRC(IC)= ELM
                       ELSE
-                         OORANGEIND = 1
+                         OORANGEIND = .TRUE.
                       ENDIF
                    ENDDO
-                ELSEIF(OORANGEIND.EQ.0) THEN
+                 ELSEIF(.NOT.OORANGEIND) THEN
                    DO NZIND=1_8,NZ_loc
                       IR = IRN_loc(NZIND)
                       IC = JCN_loc(NZIND)
                       ELM = abs(A_loc(NZIND))*SCA(IR)*SCA(IC)
-                      IF(WRKRC(ITDRPTR-1+IR)<ELM) THEN
-                         WRKRC(ITDRPTR-1+IR)= ELM
-                      ENDIF
-                      IF(WRKRC(ITDRPTR-1+IC)<ELM) THEN
-                         WRKRC(ITDRPTR-1+IC)= ELM
+                      IF (WRKRC(IR)<ELM) WRKRC(IR)= ELM
+                      IF (WRKRC(IC)<ELM) WRKRC(IC)= ELM
+                   ENDDO
+                 ENDIF                      
+               ELSE
+                IF((ITER.EQ.1).OR.(OORANGEIND)) THEN
+!$OMP   PARALLEL DO PRIVATE(NZIND,IR,IC,ELM) 
+!$OMP&  SCHEDULE(STATIC,CHUNK_NZ)
+!$OMP&  IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
+!$OMP&  REDUCTION(.OR.:OORANGEIND)
+                   DO NZIND=1_8,NZ_loc
+                      IR = IRN_loc(NZIND)
+                      IC = JCN_loc(NZIND)
+                      IF((IR.GE.1).AND.(IR.LE.N).AND.
+     &                     (IC.GE.1).AND.(IC.LE.N)) THEN
+                         ELM = abs(A_loc(NZIND))*SCA(IR)*SCA(IC)
+!$OMP                    ATOMIC UPDATE
+                         WRKRC(IR)= max (ELM, WRKRC(IR))
+!$OMP                    END ATOMIC
+C                         IF(WRKRC(ITDRPTR-1_8+int(IR,8))<ELM) THEN
+C                            WRKRC(ITDRPTR-1_8+int(IR,8))= ELM
+C                         ENDIF
+!$OMP                    ATOMIC UPDATE
+                         WRKRC(IC) = max (ELM,WRKRC(IC))
+!$OMP                    END ATOMIC
+C                         IF(WRKRC(ITDRPTR-1_8+int(IC,8))<ELM) THEN
+C                            WRKRC(ITDRPTR-1_8+int(IC,8))= ELM
+C                         ENDIF
+                      ELSE
+                         OORANGEIND = .TRUE.
                       ENDIF
                    ENDDO
+!$OMP   END PARALLEL DO
+                ELSEIF(.NOT.OORANGEIND) THEN
+!$OMP   PARALLEL DO PRIVATE(NZIND,IR,IC,ELM) 
+!$OMP&  SCHEDULE(STATIC,CHUNK_NZ)
+!$OMP&  IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
+                   DO NZIND=1_8,NZ_loc
+                      IR = IRN_loc(NZIND)
+                      IC = JCN_loc(NZIND)
+                      ELM = abs(A_loc(NZIND))*SCA(IR)*SCA(IC)
+!$OMP                 ATOMIC UPDATE
+                      WRKRC(IR)= max (ELM, WRKRC(IR))
+!$OMP                 END ATOMIC
+C                      IF(WRKRC(ITDRPTR-1_8+int(IR,8))<ELM) THEN
+C                         WRKRC(ITDRPTR-1_8+int(IR,8))= ELM
+C                      ENDIF
+!$OMP                 ATOMIC UPDATE
+                      WRKRC(IC) = max (ELM, WRKRC(IC))
+!$OMP                 END ATOMIC
+C                      IF(WRKRC(ITDRPTR-1_8+int(IC,8))<ELM) THEN
+C                         WRKRC(ITDRPTR-1_8+int(IC,8))= ELM
+C                      ENDIF
+                   ENDDO
+!$OMP   END PARALLEL DO
                 ENDIF                      
-                IF(NUMPROCS > 1) THEN
+C}
+               ENDIF
+               IF(NUMPROCS > 1) THEN
+C{
                   CALL ZMUMPS_DOCOMMINF(MYID, NUMPROCS,
      &                  WRKRC(ITDRPTR), N, TAG_ITERS+2+ITER, 
      &                  IRSNDRCVNUM,IWRK(IRNGHBPRCS),
@@ -1049,19 +1353,20 @@ C     INF-NORM ITERATION
      &                  WRKRC( OSRRPTR),
      &                  IWRK(ISTATUS),IWRK(REQUESTS),
      &                  COMM)
+CCCC FIXME #if defined(dev_version)
                   IF((EPS .GT. RZERO) .OR. 
      &                 (ITER.EQ.NB1).OR.
      &                 ((ITER.EQ.NB1+NB2+NB3).AND.
      &                 (NB1+NB3.GT.0))) THEN
                      INFERRL = ZMUMPS_ERRSCALOC(SCA,  
      &                    WRKRC(ITDRPTR), N,
-     &                    IWRK(IMYRPTR),INUMMYR)                  
+     &                    IWRK(IMYRPTR),INUMMYR, NOMP_MAX) 
                      CALL MPI_ALLREDUCE(INFERRL, INFERRG, 
      &                    1, MPI_DOUBLE_PRECISION,
      &                    MPI_MAX, COMM, IERROR)   
                      IF(INFERRG.LE.EPS) THEN
                         CALL ZMUMPS_UPDATESCALE(SCA,  WRKRC(ITDRPTR), N,
-     &                       IWRK(IMYRPTR),INUMMYR)
+     &                       IWRK(IMYRPTR),INUMMYR, NOMP_MAX)
                         IF(ITER .LE. NB1) THEN
                            ITER = NB1+1
                            CYCLE
@@ -1070,17 +1375,20 @@ C     INF-NORM ITERATION
                         ENDIF
                      ENDIF
                   ENDIF
+CCC #endif
+C}
                ELSE
-C     SINGLE PROCESSOR CASE: INF-NORM ERROR COMPUTATION
+C{             SINGLE PROCESSOR CASE: INF-NORM ERROR COMPUTATION
                   IF((EPS .GT. RZERO) .OR. 
      &                 (ITER.EQ.NB1).OR.
      &                 ((ITER.EQ.NB1+NB2+NB3).AND.
      &                 (NB1+NB3.GT.0))) THEN
                      INFERRL = ZMUMPS_ERRSCA1(SCA, 
-     &                    WRKRC(ITDRPTR), N)
+     &                    WRKRC(ITDRPTR), N, NOMP_MAX)
                      INFERRG = INFERRL
                      IF(INFERRG.LE.EPS) THEN
-                        CALL ZMUMPS_UPSCALE1(SCA,  WRKRC(ITDRPTR), N)
+                        CALL ZMUMPS_UPSCALE1(SCA, WRKRC(ITDRPTR), N,
+     &                                       NOMP_MAX)
                         IF(ITER .LE. NB1) THEN
                            ITER = NB1+1
                            CYCLE
@@ -1089,38 +1397,102 @@ C     SINGLE PROCESSOR CASE: INF-NORM ER
                         ENDIF
                      ENDIF 
                   ENDIF
+C}
                ENDIF
+C}
             ELSE
-C     WE HAVE ITER.GT.NB1 AND ITER.LE.NB1+NB2. 
-C     ONE-NORM ITERATION
-               IF((ITER.EQ.1).OR.(OORANGEIND.EQ.1))THEN
+C           ----------------------------------------
+C{          WE HAVE ITER.GT.NB1 AND ITER.LE.NB1+NB2. 
+C           ONE-NORM ITERATION
+C           ----------------------------------------
+             IF (NOMP_MAX.LE.1) THEN
+               IF((ITER.EQ.1).OR.(OORANGEIND))THEN
+                  DO NZIND=1_8,NZ_loc
+                     IR = IRN_loc(NZIND)
+                     IC = JCN_loc(NZIND)
+                     IF((IR.GE.1).AND.(IR.LE.N).AND.
+     &                    (IC.GE.1).AND.(IC.LE.N)) THEN
+                        ELM = abs(A_loc(NZIND))*SCA(IR)*SCA(IC)
+                        WRKRC(IR) = WRKRC(IR) + ELM
+                        IF(IR.NE.IC) THEN
+                           WRKRC(IC) = WRKRC(IC) + ELM
+                        ENDIF
+                     ELSE
+                        OORANGEIND = .TRUE.
+                     ENDIF
+                  ENDDO
+               ELSEIF(.NOT.OORANGEIND)THEN
+                  DO NZIND=1_8,NZ_loc
+                     IR = IRN_loc(NZIND)
+                     IC = JCN_loc(NZIND)
+                     ELM = abs(A_loc(NZIND))*SCA(IR)*SCA(IC)
+                     WRKRC(IR) = WRKRC(IR) + ELM
+                     IF(IR.NE.IC) THEN
+                        WRKRC(IC) = WRKRC(IC) + ELM
+                     ENDIF
+                  ENDDO
+               ENDIF
+             ELSE ! NOMP_MAX>1
+               IF((ITER.EQ.1).OR.(OORANGEIND))THEN
+!$OMP   PARALLEL PRIVATE(IOMP)
+!$OMP&  NUM_THREADS(NOMP_MAX)
+!$OMP&    IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
+                    IOMP  = 1
+!$                  IOMP = OMP_GET_THREAD_NUM() + 1
+!$OMP     DO PRIVATE(NZIND,IR,IC,ELM)
+!$OMP&    SCHEDULE(STATIC,CHUNK_NZ)
+!$OMP&    REDUCTION(.OR.:OORANGEIND)
                   DO NZIND=1_8,NZ_loc
                      IR = IRN_loc(NZIND)
                      IC = JCN_loc(NZIND)
                      IF((IR.GE.1).AND.(IR.LE.N).AND.
      &                    (IC.GE.1).AND.(IC.LE.N)) THEN
                         ELM = abs(A_loc(NZIND))*SCA(IR)*SCA(IC)
-                        WRKRC(ITDRPTR-1+IR) = WRKRC(ITDRPTR-1+IR) + ELM
+                        WRKR_TH(IR,IOMP) = WRKR_TH(IR,IOMP) + ELM
                         IF(IR.NE.IC) THEN
-                           WRKRC(ITDRPTR-1+IC) = 
-     &                          WRKRC(ITDRPTR-1+IC) + ELM
+                          WRKR_TH(IC,IOMP) = WRKR_TH(IC,IOMP) + ELM
                         ENDIF
                      ELSE
-                        OORANGEIND = 1
+                        OORANGEIND = .TRUE.
                      ENDIF
                   ENDDO
-               ELSEIF(OORANGEIND.EQ.0)THEN
+!$OMP     END DO
+!$OMP   END PARALLEL
+               ELSEIF(.NOT.OORANGEIND)THEN
+!$OMP   PARALLEL PRIVATE(IOMP)
+!$OMP&  NUM_THREADS(NOMP_MAX)
+!$OMP&    IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
+                    IOMP  = 1
+!$                  IOMP = OMP_GET_THREAD_NUM() + 1
+!$OMP     DO PRIVATE(NZIND,IR,IC,ELM)
+!$OMP&    SCHEDULE(STATIC,CHUNK_NZ)
                   DO NZIND=1_8,NZ_loc
                      IR = IRN_loc(NZIND)
                      IC = JCN_loc(NZIND)
                      ELM = abs(A_loc(NZIND))*SCA(IR)*SCA(IC)
-                     WRKRC(ITDRPTR-1+IR) = WRKRC(ITDRPTR-1+IR) + ELM
+                     WRKR_TH(IR,IOMP) = WRKR_TH(IR,IOMP) + ELM
                      IF(IR.NE.IC) THEN
-                        WRKRC(ITDRPTR-1+IC) = WRKRC(ITDRPTR-1+IC) + ELM
+                       WRKR_TH(IC,IOMP) = WRKR_TH(IC,IOMP) + ELM
                      ENDIF
                   ENDDO
+!$OMP     END DO
+!$OMP   END PARALLEL
+C}
+               ENDIF
+C
+C              For all i on MYID:
+C              Build WRKRC(i) = Sum       (WRKR_TH(i,IOMP)
+C                              IOMP \in [1:NOMP_MAX]
+               IF(NUMPROCS > 1) THEN
+                 CALL ZMUMPS_REDUCE_WRK_MPI (WRKRC, N, WRKR_TH, 
+     &                 NOMP_MAX, 
+     &                 IWRK(IMYRPTR),INUMMYR)
+               ELSE
+                 CALL ZMUMPS_REDUCE_WRK (WRKRC, N, WRKR_TH, NOMP_MAX)
                ENDIF
+             ENDIF
                IF(NUMPROCS > 1) THEN
+C{
                   CALL ZMUMPS_DOCOMM1N(MYID, NUMPROCS,
      &                 WRKRC(ITDRPTR), N, TAG_ITERS+2+ITER, 
      &                 IRSNDRCVNUM, IWRK(IRNGHBPRCS),
@@ -1136,54 +1508,72 @@ C     ONE-NORM ITERATION
      &                 (NB2.GT.0))) THEN
                      ONEERRL = ZMUMPS_ERRSCALOC(SCA,  
      &                    WRKRC(ITDRPTR), N,
-     &                    IWRK(IMYRPTR),INUMMYR) 
+     &                    IWRK(IMYRPTR),INUMMYR, NOMP_MAX) 
 C     mpi allreduce.
                      CALL MPI_ALLREDUCE(ONEERRL, ONEERRG, 
      &                    1, MPI_DOUBLE_PRECISION,
      &                    MPI_MAX, COMM, IERROR)
                      IF(ONEERRG.LE.EPS) THEN
                         CALL ZMUMPS_UPDATESCALE(SCA,  WRKRC(ITDRPTR), N,
-     &                       IWRK(IMYRPTR),INUMMYR)
+     &                       IWRK(IMYRPTR),INUMMYR, NOMP_MAX)
                         ITER = NB1+NB2+1
                         CYCLE
                      ENDIF
                   ENDIF
+C}
                ELSE
-C     SINGLE-PROCESSOR CASE: ONE-NORM ERROR COMPUTATION
+C{             SINGLE-PROCESSOR CASE: ONE-NORM ERROR COMPUTATION
                   IF((EPS .GT. RZERO) .OR. 
      &                 ((ITER.EQ.NB1+NB2).AND.
      &                 (NB2.GT.0))) THEN
                      ONEERRL = ZMUMPS_ERRSCA1(SCA, 
-     &                    WRKRC(ITDRPTR), N)
+     &                    WRKRC(ITDRPTR), N, NOMP_MAX)
                      ONEERRG = ONEERRL
                      IF(ONEERRG.LE.EPS) THEN
-                        CALL ZMUMPS_UPSCALE1(SCA,  WRKRC(ITDRPTR), N)
+                        CALL ZMUMPS_UPSCALE1(SCA, WRKRC(ITDRPTR), N,
+     &                                       NOMP_MAX)
                         ITER = NB1+NB2+1
                         CYCLE
                      ENDIF
                   ENDIF
                ENDIF
+C}
             ENDIF
             IF(NUMPROCS > 1) THEN
-               CALL ZMUMPS_UPDATESCALE(SCA,  WRKRC(ITDRPTR), N,
-     &              IWRK(IMYRPTR),INUMMYR)
+               CALL ZMUMPS_UPDATESCALE(SCA, WRKRC(ITDRPTR), N,
+     &              IWRK(IMYRPTR),INUMMYR, NOMP_MAX)
             ELSE
-               CALL ZMUMPS_UPSCALE1(SCA,  WRKRC(ITDRPTR), N)
+               CALL ZMUMPS_UPSCALE1(SCA, WRKRC(ITDRPTR), N, 
+     &                              NOMP_MAX)
             ENDIF     
             ITER = ITER + 1
+C}
          ENDDO
          ONENORMERR = ONEERRG 
          INFNORMERR = INFERRG 
          IF(NUMPROCS > 1) THEN
+C{
             CALL MPI_REDUCE(SCA, WRKRC(1), N, MPI_DOUBLE_PRECISION,
      &           MPI_MAX, 0, 
      &           COMM, IERROR)
             IF(MYID.EQ.0) THEN
+              IF (NOMP_MAX.LE.0) THEN
+               DO I=1, N
+                  SCA(I) = WRKRC(I)
+               ENDDO
+              ELSE
+!$OMP       PARALLEL DO PRIVATE(I)
+!$OMP&      SCHEDULE(STATIC,CHUNK)
+!$OMP&      IF ( N > K361 .AND. NOMP .GT. 1)
                DO I=1, N
                   SCA(I) = WRKRC(I)
                ENDDO
+!$OMP       END PARALLEL DO
+              ENDIF
             ENDIF
+C}
          ENDIF
+C}
       ENDIF
       RETURN
       END SUBROUTINE ZMUMPS_SIMSCALEABSSYM
diff -pruN 5.6.2-2.1/src/zfac_scalings_simScale_util.F 5.7.1-1/src/zfac_scalings_simScale_util.F
--- 5.6.2-2.1/src/zfac_scalings_simScale_util.F	2023-10-11 09:37:10.000000000 +0000
+++ 5.7.1-1/src/zfac_scalings_simScale_util.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -14,19 +14,23 @@ C
       SUBROUTINE ZMUMPS_CREATEPARTVEC(MYID, NUMPROCS, COMM,
      & IRN_loc, JCN_loc, NZ_loc,
      & IPARTVEC, ISZ, OSZ,
-     & IWRK, IWSZ)
+     & IWRK, IWSZ, INUMMY, NOMP_MAX )
+!$    USE OMP_LIB
 C
       IMPLICIT NONE
       EXTERNAL ZMUMPS_BUREDUCE
-      INTEGER, INTENT(IN)    :: MYID, NUMPROCS, COMM
+      INTEGER, INTENT(IN)    :: MYID, NUMPROCS, COMM, NOMP_MAX
       INTEGER(8), INTENT(IN) :: NZ_loc 
-      INTEGER, INTENT(IN)    :: IWSZ
+      INTEGER(8), INTENT(IN) :: IWSZ
       INTEGER, INTENT(IN)    :: ISZ, OSZ
       INTEGER, INTENT(IN)    :: IRN_loc(NZ_loc), JCN_loc(NZ_loc)
 C  OUTPUT
 C     IPARTVEC(I) = proc number with largest number of entries 
 C                in row/col I
+C     INUMMY = number of local rows/columns with
+C              at least one local entry (NUMPROCS .NE. 1 only)
       INTEGER, INTENT(OUT) :: IPARTVEC(ISZ)
+      INTEGER, INTENT(OUT) :: INUMMY
 C
 C  INTERNAL WORKING ARRAY
 C     IWRK (1:2*ISZ) is initialized to couples (MYID, Nb of entries
@@ -46,42 +50,87 @@ C     LOCAL VARS
       INTEGER(8) :: I8
       INTEGER OP, IERROR
       INTEGER IR, IC
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
 C
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP  = omp_get_max_threads()
+!$     CHUNK= max(K361/2, (ISZ+NOMP-1) / NOMP )
+!$    ENDIF
+C
+      INUMMY = 0
       IF(NUMPROCS.NE.1) THEN
 C     CHECK done outsize
 C     IF(IWSZ < 4*ISZ) THEN
 C     CHECK ENDS
          CALL MPI_OP_CREATE(ZMUMPS_BUREDUCE, .TRUE., OP, IERROR)
 C     PERFORM THE REDUCTION
-#if defined(WORKAROUNDINTELILP64MPI2INTEGER)
-        CALL ZMUMPS_IBUINIT(IWRK, 4*ISZ, int(ISZ,4))
-#else
-        CALL ZMUMPS_IBUINIT(IWRK, 4*ISZ, ISZ)
-#endif
 C     WE FIRST ZERO OUT  
+       IF (NOMP_MAX.LE.0) THEN
+         DO I=1,ISZ
+            IWRK(2_8*int(I,8)-1_8) = 0
+            IWRK(2_8*int(I,8))     = MYID
+         ENDDO
+       ELSE
+!$OMP   PARALLEL DO PRIVATE(I) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1.AND.ISZ > K361 )
          DO I=1,ISZ
-            IWRK(2*I-1) = 0
-            IWRK(2*I) = MYID
+            IWRK(2_8*int(I,8)-1_8) = 0
+            IWRK(2_8*int(I,8))     = MYID
          ENDDO
+!$OMP   END PARALLEL DO
+       ENDIF
          DO I8=1_8,NZ_loc
             IR = IRN_loc(I8)
             IC = JCN_loc(I8)
             IF((IR.GE.1).AND.(IR.LE.ISZ).AND.
      &           (IC.GE.1).AND.(IC.LE.OSZ)) THEN
-               IWRK(2*IR-1) = IWRK(2*IR-1) + 1
+               IWRK(2_8*int(IR,8)-1_8) = IWRK(2_8*int(IR,8)-1_8) + 1
             ENDIF
          ENDDO
-         CALL MPI_ALLREDUCE(IWRK(1), IWRK(1+2*ISZ), ISZ,
+         CALL MUMPS_BIGALLREDUCE(.FALSE., IWRK(1),
+     &        IWRK(1_8+2_8*int(ISZ,8)), ISZ,
      &        MPI_2INTEGER, OP, COMM, IERROR)      
-         DO I=1,ISZ
-            IPARTVEC(I) = IWRK(2*I+2*ISZ)
-         ENDDO
+C
+        IF (NOMP_MAX.LE.0) THEN
+          DO I=1,ISZ
+             IPARTVEC(I) = IWRK(2_8*int(I,8)+2_8*int(ISZ,8))
+C            Compute INUMMY directly
+             IF ( IPARTVEC(I) .EQ. MYID. OR.
+     &            IWRK(2_8*int(I,8)-1_8) .GT. 0 ) THEN
+               INUMMY=INUMMY+1
+             ENDIF
+          ENDDO
+        ELSE
+!$OMP   PARALLEL DO PRIVATE(I) SCHEDULE(STATIC,CHUNK)
+!$OMP&  IF ( ISZ > K361 .AND. NOMP .GT. 1)
+!$OMP&  REDUCTION(+:INUMMY)
+          DO I=1,ISZ
+             IPARTVEC(I) = IWRK(2_8*int(I,8)+2_8*int(ISZ,8))
+C            Compute INUMMY directly
+             IF ( IPARTVEC(I) .EQ. MYID. OR.
+     &            IWRK(2_8*int(I,8)-1_8) .GT. 0 ) THEN
+               INUMMY=INUMMY+1
+             ENDIF
+          ENDDO
+!$OMP   END PARALLEL DO
+        ENDIF
 C     FREE THE OPERATOR
          CALL MPI_OP_FREE(OP, IERROR)
       ELSE
-         DO I=1,ISZ
-            IPARTVEC(I) = 0
-         ENDDO
+        IF (NOMP_MAX.LE.0) THEN
+          DO I=1,ISZ
+             IPARTVEC(I) = 0
+          ENDDO
+        ELSE
+!$OMP    PARALLEL DO PRIVATE(I) SCHEDULE(STATIC,CHUNK)
+!$OMP&   IF ( ISZ > K361 .AND. NOMP .GT. 1)
+          DO I=1,ISZ
+             IPARTVEC(I) = 0
+          ENDDO
+!$OMP    END PARALLEL DO
+       ENDIF
       ENDIF
       RETURN
       END SUBROUTINE ZMUMPS_CREATEPARTVEC
@@ -89,94 +138,17 @@ C
 C     SEPARATOR: Another function begins
 C
 C 
-      SUBROUTINE ZMUMPS_FINDNUMMYROWCOL(MYID, NUMPROCS, COMM,
-     &     IRN_loc, JCN_loc, NZ_loc,
-     &     ROWPARTVEC, COLPARTVEC, M, N,
-     &     INUMMYR,
-     &     INUMMYC,     
-     &     IWRK, IWSZ)
-      IMPLICIT NONE
-      INTEGER(8), INTENT(IN) :: NZ_loc
-      INTEGER, INTENT(IN) :: MYID, NUMPROCS, M, N, IWSZ
-      INTEGER, INTENT(IN) :: IRN_loc(NZ_loc), JCN_loc(NZ_loc)
-C     [ROW/COL]PARTVEC(I) holds proc number with largest number of entries 
-C                in row/col I
-      INTEGER, INTENT(IN) :: ROWPARTVEC(M)
-      INTEGER, INTENT(IN) :: COLPARTVEC(N)
-      INTEGER, INTENT(IN) :: COMM
-C
-C  OUTPUT PARAMETERS
-C     INUMMYR < M and INUMMYC < N  (CPA or <= ??)
-C     INUMMYR holds the number of rows allocated to me 
-C             or non empty on my proc
-C     INUMMYC idem with columns
-      INTEGER INUMMYR, INUMMYC
-C
-C  INTERNAL working array
-      INTEGER IWRK(IWSZ)
-C
-C   Local variables
-      INTEGER I, IR, IC
-      INTEGER(8) ::  I8
-C check done outsize     
-C     IF(IWSZ < M) THEN ERROR
-C     IF(IWSZ < N) THEN ERROR
-      INUMMYR = 0
-      INUMMYC = 0
-C     MARK MY ROWS. FIRST COUNT,
-C          IF DYNAMIC MEMORY ALLOCATIOn WILL USED
-C     INUMMYR first counts number of rows affected to me
-C             (that will be centralized on MYID)
-      DO I=1,M
-         IWRK(I) = 0
-         IF(ROWPARTVEC(I).EQ.MYID) THEN
-            IWRK(I)=1
-            INUMMYR = INUMMYR + 1
-         ENDIF
-      ENDDO
-      DO I8=1_8,NZ_loc
-         IR = IRN_loc(I8)
-         IC = JCN_loc(I8)
-         IF((IR.GE.1).AND.(IR.LE.M).AND.
-     &        ((IC.GE.1).AND.(IC.LE.N)) ) THEN
-            IF(IWRK(IR) .EQ. 0) THEN
-               IWRK(IR)= 1
-               INUMMYR = INUMMYR + 1
-            ENDIF
-         ENDIF
-      ENDDO
-C     DO THE SMAME THING FOR COLS
-      DO I=1,N
-         IWRK(I) = 0
-         IF(COLPARTVEC(I).EQ.MYID) THEN
-            IWRK(I)= 1
-            INUMMYC = INUMMYC + 1
-         ENDIF
-      ENDDO
-      DO I8=1_8,NZ_loc
-         IC = JCN_loc(I8)
-         IR = IRN_loc(I8)
-         IF((IR.GE.1).AND.(IR.LE.M).AND.
-     &        ((IC.GE.1).AND.(IC.LE.N)) ) THEN
-            IF(IWRK(IC) .EQ. 0) THEN
-               IWRK(IC)= 1
-               INUMMYC = INUMMYC + 1
-            ENDIF
-         ENDIF
-      ENDDO
-C
-      RETURN
-      END SUBROUTINE ZMUMPS_FINDNUMMYROWCOL
       SUBROUTINE ZMUMPS_FILLMYROWCOLINDICES(MYID, NUMPROCS,COMM,    
      &     IRN_loc, JCN_loc, NZ_loc,
      &     ROWPARTVEC, COLPARTVEC, M, N,
      &     MYROWINDICES, INUMMYR,
      &     MYCOLINDICES, INUMMYC,     
-     &     IWRK, IWSZ  )
+     &     IWRK, IWSZ, NOMP_MAX  )
+!$    USE OMP_LIB
       IMPLICIT NONE
-      INTEGER(8) :: NZ_loc
-      INTEGER MYID, NUMPROCS, M, N
-      INTEGER INUMMYR, INUMMYC, IWSZ
+      INTEGER(8) :: NZ_loc, IWSZ
+      INTEGER MYID, NUMPROCS, M, N, NOMP_MAX
+      INTEGER INUMMYR, INUMMYC
       INTEGER IRN_loc(NZ_loc), JCN_loc(NZ_loc)
       INTEGER ROWPARTVEC(M)
       INTEGER COLPARTVEC(N)
@@ -188,11 +160,32 @@ C
       INTEGER I, IR, IC, ITMP
       INTEGER(8) :: I8
 C      
+      INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP=omp_get_max_threads()
+C      note that M=N
+!$     CHUNK= max(K361/2, (M+NOMP-1) / NOMP )
+!$    ENDIF
+C      
 C     MARK MY ROWS. 
-      DO I=1,M
-         IWRK(I) = 0
-         IF(ROWPARTVEC(I).EQ.MYID) IWRK(I)=1
-      ENDDO
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,M
+           IWRK(I) = 0
+           IF(ROWPARTVEC(I).EQ.MYID) IWRK(I)=1
+        ENDDO
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I) 
+!$OMP&  SCHEDULE(STATIC,CHUNK)
+!$OMP&  IF ( M > K361 .AND. NOMP .GT. 1)
+        DO I=1,M
+           IWRK(I) = 0
+           IF(ROWPARTVEC(I).EQ.MYID) IWRK(I)=1
+        ENDDO
+!$OMP END PARALLEL DO
+      ENDIF
+CTEMP !$OMP  PARALLEL DO PRIVATE(I8,IR,IC) SCHEDULE(STATIC,CHUNK)
+CTEMP !$OMP& IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
       DO I8=1,NZ_loc
          IR = IRN_loc(I8)         
          IC = JCN_loc(I8)
@@ -201,6 +194,7 @@ C     MARK MY ROWS.
             IF(IWRK(IR) .EQ. 0) IWRK(IR)= 1
          ENDIF
       ENDDO
+CTEMP !$OMP END PARALLEL DO
 C     PUT MY ROWS INTO MYROWINDICES
       ITMP = 1
       DO I=1,M
@@ -212,10 +206,24 @@ C     PUT MY ROWS INTO MYROWINDICES
 C
 C
 C     DO THE SMAME THING FOR COLS
-      DO I=1,N
-         IWRK(I) = 0
-         IF(COLPARTVEC(I).EQ.MYID) IWRK(I)= 1
-      ENDDO
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,N
+           IWRK(I) = 0
+           IF(COLPARTVEC(I).EQ.MYID) IWRK(I)= 1
+        ENDDO
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I) 
+!$OMP&  SCHEDULE(STATIC,CHUNK)
+!$OMP&  IF ( N > K361 .AND. NOMP .GT. 1)
+        DO I=1,N
+           IWRK(I) = 0
+           IF(COLPARTVEC(I).EQ.MYID) IWRK(I)= 1
+        ENDDO
+!$OMP END PARALLEL DO
+      ENDIF
+C
+CTEMP !$OMP  PARALLEL DO PRIVATE(I8,IR,IC) SCHEDULE(STATIC,CHUNK)
+CTEMP !$OMP& IF ( NZ_loc > int(K361,8) .AND. NOMP .GT. 1)
       DO I8=1,NZ_loc
          IR = IRN_loc(I8)         
          IC = JCN_loc(I8)
@@ -224,6 +232,7 @@ C     DO THE SMAME THING FOR COLS
             IF(IWRK(IC) .EQ. 0) IWRK(IC)= 1
          ENDIF
       ENDDO
+CTEMP !$OMP END PARALLEL DO
 C     PUT MY ROWS INTO MYROWINDICES
       ITMP = 1
       DO I=1,N
@@ -305,11 +314,12 @@ C
 C     SEPARATOR: Another function begins
 C
       DOUBLE PRECISION FUNCTION ZMUMPS_ERRSCALOC(D, TMPD, DSZ,
-     &     INDX, INDXSZ)
+     &     INDX, INDXSZ, NOMP_MAX)
+!$    USE OMP_LIB
 C     THE VAR D IS NOT USED IN COMPUTATIONS.
 C     IT IS THERE FOR READIBLITY OF THE *simScaleAbs.F
       IMPLICIT NONE 
-      INTEGER DSZ, INDXSZ
+      INTEGER, INTENT(IN):: DSZ, INDXSZ, NOMP_MAX
       DOUBLE PRECISION D(DSZ)
       DOUBLE PRECISION TMPD(DSZ)
       INTEGER INDX(INDXSZ)
@@ -319,19 +329,40 @@ C     LOCAL VARS
       INTEGER I, IIND
       DOUBLE PRECISION ERRMAX
       INTRINSIC abs
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
       ERRMAX = -RONE
-      DO I=1,INDXSZ
-         IIND = INDX(I)
-         IF(abs(RONE-TMPD(IIND)).GT.ERRMAX) THEN
-            ERRMAX = abs(RONE-TMPD(IIND))
-         ENDIF
-      ENDDO           
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP  = OMP_GET_MAX_THREADS()
+!$     CHUNK= max(K361/2, (INDXSZ+NOMP-1) / NOMP )
+!$    ENDIF
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,INDXSZ
+           IIND = INDX(I)
+           IF(abs(RONE-TMPD(IIND)).GT.ERRMAX) THEN
+              ERRMAX = abs(RONE-TMPD(IIND))
+           ENDIF
+        ENDDO           
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I,IIND) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1 .AND. INDXSZ > K361 )
+!$OMP&  REDUCTION(max:ERRMAX)
+        DO I=1,INDXSZ
+           IIND = INDX(I)
+           IF(abs(RONE-TMPD(IIND)).GT.ERRMAX) THEN
+              ERRMAX = abs(RONE-TMPD(IIND))
+           ENDIF
+        ENDDO           
+!$OMP   END PARALLEL DO
+      ENDIF
       ZMUMPS_ERRSCALOC = ERRMAX
       RETURN
       END FUNCTION ZMUMPS_ERRSCALOC
-      DOUBLE PRECISION FUNCTION ZMUMPS_ERRSCA1(D, TMPD, DSZ)
+      DOUBLE PRECISION FUNCTION ZMUMPS_ERRSCA1(D, TMPD, DSZ, NOMP_MAX)
+!$    USE OMP_LIB
       IMPLICIT NONE 
-      INTEGER DSZ
+      INTEGER, INTENT(IN):: DSZ, NOMP_MAX
       DOUBLE PRECISION D(DSZ)
       DOUBLE PRECISION TMPD(DSZ)
 C     LOCAL VARS
@@ -340,12 +371,31 @@ C     LOCAL VARS
       INTEGER I
       DOUBLE PRECISION ERRMAX1
       INTRINSIC abs
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
       ERRMAX1 = -RONE
-      DO I=1,DSZ
-         IF(abs(RONE-TMPD(I)).GT.ERRMAX1) THEN
-            ERRMAX1 = abs(RONE-TMPD(I))
-         ENDIF
-      ENDDO
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP  = OMP_GET_MAX_THREADS()
+!$     CHUNK= max(K361/2, (DSZ+NOMP-1) / NOMP )
+!$    ENDIF
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,DSZ
+           IF(abs(RONE-TMPD(I)).GT.ERRMAX1) THEN
+              ERRMAX1 = abs(RONE-TMPD(I))
+           ENDIF
+        ENDDO
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1.AND.DSZ > K361 )
+!$OMP&  REDUCTION(max:ERRMAX1)
+        DO I=1,DSZ
+           IF(abs(RONE-TMPD(I)).GT.ERRMAX1) THEN
+              ERRMAX1 = abs(RONE-TMPD(I))
+           ENDIF
+        ENDDO
+!$OMP   END PARALLEL DO
+      ENDIF
       ZMUMPS_ERRSCA1 = ERRMAX1
       RETURN
       END FUNCTION ZMUMPS_ERRSCA1
@@ -353,9 +403,10 @@ C
 C     SEPARATOR: Another function begins
 C
       SUBROUTINE ZMUMPS_UPDATESCALE(D,  TMPD, DSZ,
-     &        INDX, INDXSZ)
+     &        INDX, INDXSZ, NOMP_MAX)
+!$    USE OMP_LIB
       IMPLICIT NONE
-      INTEGER DSZ, INDXSZ
+      INTEGER, INTENT(in) :: DSZ, INDXSZ, NOMP_MAX
       DOUBLE PRECISION D(DSZ)
       DOUBLE PRECISION TMPD(DSZ)
       INTEGER INDX(INDXSZ)
@@ -364,15 +415,34 @@ C     LOCAL VARS
       INTEGER I, IIND
       DOUBLE PRECISION RZERO
       PARAMETER(RZERO=0.0D0)
-      DO I=1,INDXSZ
-         IIND = INDX(I)
-         IF (TMPD(IIND).NE.RZERO) D(IIND) = D(IIND)/sqrt(TMPD(IIND))
-      ENDDO
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP  = OMP_GET_MAX_THREADS()
+!$     CHUNK= max(K361/2, (INDXSZ+NOMP-1) / NOMP )
+!$    ENDIF
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,INDXSZ
+           IIND = INDX(I)
+           IF (TMPD(IIND).NE.RZERO) D(IIND)=D(IIND)/sqrt(TMPD(IIND))
+        ENDDO
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I,IIND) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1.AND.  INDXSZ> K361 )
+        DO I=1,INDXSZ
+           IIND = INDX(I)
+           IF (TMPD(IIND).NE.RZERO) D(IIND)=D(IIND)/sqrt(TMPD(IIND))
+        ENDDO
+!$OMP   END PARALLEL DO
+      ENDIF
       RETURN
       END SUBROUTINE ZMUMPS_UPDATESCALE
-      SUBROUTINE ZMUMPS_UPSCALE1(D,  TMPD, DSZ)
+C
+      SUBROUTINE ZMUMPS_UPSCALE1(D,  TMPD, DSZ, NOMP_MAX)
+!$    USE OMP_LIB
       IMPLICIT NONE
-      INTEGER DSZ
+      INTEGER, INTENT(IN):: DSZ, NOMP_MAX
       DOUBLE PRECISION D(DSZ)
       DOUBLE PRECISION TMPD(DSZ)
       INTRINSIC sqrt
@@ -380,74 +450,186 @@ C     LOCAL VARS
       INTEGER I
       DOUBLE PRECISION RZERO
       PARAMETER(RZERO=0.0D0)
-      DO I=1,DSZ
-         IF (TMPD(I) .NE. RZERO) D(I) = D(I)/sqrt(TMPD(I))
-      ENDDO
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
+!$    IF (NOMP_MAX.GT.0) THEN
+!$      NOMP  = OMP_GET_MAX_THREADS()
+!$      CHUNK= max(K361/2, (DSZ+NOMP-1) / NOMP )
+!$    ENDIF
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,DSZ
+           IF (TMPD(I) .NE. RZERO) D(I) = D(I)/sqrt(TMPD(I))
+        ENDDO
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1.AND.  DSZ> K361 )
+        DO I=1,DSZ
+           IF (TMPD(I) .NE. RZERO) D(I) = D(I)/sqrt(TMPD(I))
+        ENDDO
+!$OMP   END PARALLEL DO
+      ENDIF
       RETURN
       END SUBROUTINE ZMUMPS_UPSCALE1
 C
 C     SEPARATOR: Another function begins
 C
-      SUBROUTINE ZMUMPS_INITREALLST(D, DSZ, INDX, INDXSZ, VAL)
+      SUBROUTINE ZMUMPS_INITREALLST(D, DSZ, INDX, INDXSZ, VAL,
+     &                              NOMP_MAX)
+!$    USE OMP_LIB
       IMPLICIT NONE
-      INTEGER DSZ, INDXSZ
+      INTEGER, INTENT(IN):: DSZ, INDXSZ, NOMP_MAX
       DOUBLE PRECISION D(DSZ)
       INTEGER INDX(INDXSZ)
       DOUBLE PRECISION VAL
 C     LOCAL VARS
       INTEGER I, IIND
-      DO I=1,INDXSZ
-         IIND = INDX(I)
-         D(IIND) = VAL
-      ENDDO
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP  = OMP_GET_MAX_THREADS()
+!$     CHUNK= max(K361/2, (INDXSZ+NOMP-1) / NOMP )
+!$    ENDIF
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,INDXSZ
+           IIND = INDX(I)
+           D(IIND) = VAL
+        ENDDO
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I,IIND) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1.AND.  INDXSZ > K361 )
+        DO I=1,INDXSZ
+           IIND = INDX(I)
+           D(IIND) = VAL
+        ENDDO
+!$OMP   END PARALLEL DO
+      ENDIF
       RETURN
       END SUBROUTINE ZMUMPS_INITREALLST
 C
 C     SEPARATOR: Another function begins
 C
-      SUBROUTINE ZMUMPS_INVLIST(D, DSZ, INDX, INDXSZ)
-      IMPLICIT NONE
-      INTEGER DSZ, INDXSZ
-      DOUBLE PRECISION D(DSZ)
-      INTEGER INDX(INDXSZ)
-C     LOCALS
-      INTEGER I, IIND
-      DO I=1,INDXSZ
-         IIND  = INDX(I)
-         D(IIND) = 1.0D0/D(IIND)
-      ENDDO
-      RETURN
-      END SUBROUTINE ZMUMPS_INVLIST
 C
 C     SEPARATOR: Another function begins
 C
-      SUBROUTINE ZMUMPS_INITREAL(D, DSZ, VAL)
+      SUBROUTINE ZMUMPS_INITREAL(D, DSZ, VAL, NOMP_MAX)
+!$    USE OMP_LIB
       IMPLICIT NONE
-      INTEGER DSZ
+      INTEGER, INTENT(IN):: DSZ, NOMP_MAX
       DOUBLE PRECISION D(DSZ)
       DOUBLE PRECISION VAL
 C     LOCAL VARS
       INTEGER I
-      DO I=1,DSZ
-         D(I) = VAL
-      ENDDO
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP  = omp_get_max_threads()
+!$     CHUNK= max(K361/2, (DSZ+NOMP-1) / NOMP )
+!$    ENDIF
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,DSZ
+           D(I) = VAL
+        ENDDO
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1.AND.DSZ > K361 )
+        DO I=1,DSZ
+           D(I) = VAL
+        ENDDO
+!$OMP   END PARALLEL DO
+      ENDIF
       RETURN
       END SUBROUTINE ZMUMPS_INITREAL
 C
 C     SEPARATOR: Another function begins
 C
-      SUBROUTINE ZMUMPS_ZEROOUT(TMPD, TMPSZ, INDX, INDXSZ)
+      SUBROUTINE ZMUMPS_REDUCE_WRK(WRK, N, WRK_TH, NOMP_MAX)
+C     Called only when NOMP_MAX>0
+!$    USE OMP_LIB
       IMPLICIT NONE
-      INTEGER TMPSZ,INDXSZ 
-      DOUBLE PRECISION TMPD(TMPSZ)
+      INTEGER N,NOMP_MAX
+      DOUBLE PRECISION WRK(N), WRK_TH(N,NOMP_MAX)
+C     LOCAL VAR
+      INTEGER I, IOMP
+      DOUBLE PRECISION DZERO
+      PARAMETER(DZERO=0.0D0)
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
+!$    NOMP  = OMP_GET_MAX_THREADS()
+!$    CHUNK= max(K361/2, (N+NOMP-1) / NOMP )
+!$OMP   PARALLEL DO PRIVATE(I,IOMP) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1.AND.  N > K361 )
+      DO I=1,N
+         WRK(I) = DZERO
+         DO IOMP=1,NOMP_MAX
+           WRK(I) = WRK_TH(I,IOMP) +  WRK(I)
+         ENDDO
+      ENDDO      
+!$OMP END PARALLEL DO
+      RETURN
+      END SUBROUTINE ZMUMPS_REDUCE_WRK
+      SUBROUTINE ZMUMPS_REDUCE_WRK_MPI(WRK, N, WRK_TH, NOMP_MAX, 
+     &           INDX, INDXSZ)
+C     Called only when NOMP_MAX>0
+!$    USE OMP_LIB
+      IMPLICIT NONE
+      INTEGER N,NOMP_MAX,INDXSZ 
+      DOUBLE PRECISION WRK(N), WRK_TH(N,NOMP_MAX)
       INTEGER INDX(INDXSZ)
 C     LOCAL VAR
-      INTEGER I
+      INTEGER I, J, IOMP
       DOUBLE PRECISION DZERO
       PARAMETER(DZERO=0.0D0)
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
+!$      NOMP  = OMP_GET_MAX_THREADS()
+!$      CHUNK= max(K361/2, (INDXSZ+NOMP-1) / NOMP )
+!$OMP   PARALLEL DO PRIVATE(I,J,IOMP) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1.AND.  INDXSZ > K361 )
       DO I=1,INDXSZ
-         TMPD(INDX(I)) = DZERO
+         J = INDX(I)
+         WRK(J) = DZERO
+         DO IOMP=1,NOMP_MAX
+           WRK(J) = WRK_TH(J,IOMP) + WRK(J)
+         ENDDO
       ENDDO      
+!$OMP END PARALLEL DO
+      RETURN
+      END SUBROUTINE ZMUMPS_REDUCE_WRK_MPI
+      SUBROUTINE ZMUMPS_ZEROOUT(TMPD, TMPSZ, INDX, INDXSZ, 
+     &                          NOMP_MAX)
+!$    USE OMP_LIB
+      IMPLICIT NONE
+      INTEGER, INTENT(IN):: TMPSZ,INDXSZ, NOMP_MAX
+      DOUBLE PRECISION TMPD(TMPSZ)
+      INTEGER INDX(INDXSZ)
+C     LOCAL VAR
+      INTEGER I
+      DOUBLE PRECISION DZERO
+      PARAMETER(DZERO=0.0D0)
+!$    INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
+!$    IF (NOMP_MAX.GT.0) THEN
+!$     NOMP  = OMP_GET_MAX_THREADS()
+!$     CHUNK= max(K361/2, (INDXSZ+NOMP-1) / NOMP )
+!$    ENDIF
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,INDXSZ
+           TMPD(INDX(I)) = DZERO
+        ENDDO      
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I) 
+!$OMP&  SCHEDULE(STATIC, CHUNK)
+!$OMP&  IF ( NOMP.GT.1.AND.  INDXSZ > K361 )
+        DO I=1,INDXSZ
+           TMPD(INDX(I)) = DZERO
+        ENDDO      
+!$OMP END PARALLEL DO
+      ENDIF
       RETURN
       END SUBROUTINE ZMUMPS_ZEROOUT
 C
@@ -509,7 +691,7 @@ C     SEPARATOR: Another function begins
 C
       SUBROUTINE ZMUMPS_IBUINIT(IW, IWSZ, IVAL)
       IMPLICIT NONE
-      INTEGER IWSZ
+      INTEGER(8) :: IWSZ
 #if defined(WORKAROUNDINTELILP64MPI2INTEGER)
       INTEGER(4) IW(IWSZ)
       INTEGER(4) IVAL
@@ -517,8 +699,8 @@ C
       INTEGER IW(IWSZ)
       INTEGER IVAL
 #endif
-      INTEGER I
-      DO I=1,IWSZ
+      INTEGER(8) :: I
+      DO I=1_8,IWSZ
          IW(I)=IVAL
       ENDDO
       RETURN
@@ -535,10 +717,10 @@ C
      &     IWRK,IWRKSZ, SNDSZ, RCVSZ, COMM)
       IMPLICIT NONE
       INTEGER(8), INTENT(IN) :: NZ_loc
-      INTEGER, INTENT(IN)    :: IWRKSZ
+      INTEGER(8), INTENT(IN) :: IWRKSZ
       INTEGER, INTENT(IN) ::  MYID, NUMPROCS, ISZ, OSZ
       INTEGER, INTENT(IN) ::  COMM
-C     When INDX holds row indices O(ther)INDX hold col indices
+C     When INDX holds row indices O(ther)INDX holds col indices
       INTEGER, INTENT(IN) :: INDX(NZ_loc)
       INTEGER, INTENT(IN) :: OINDX(NZ_loc)
 C     On entry IPARTVEC(I) holds proc number with largest number of entries 
@@ -582,7 +764,7 @@ C      IF(ISZ>IWRKSZ) THEN ERROR
          SNDSZ(I) = 0
          RCVSZ(I) = 0
       ENDDO
-      DO I=1,IWRKSZ
+      DO I=1,max(ISZ,OSZ)
          IWRK(I) = 0
       ENDDO
 C
@@ -595,7 +777,7 @@ C     set SNDSZ
             PIND = IPARTVEC(IIND)
             IF(PIND .NE. MYID) THEN
 C              MYID will send row/col IIND to proc PIND 
-C              (PIND has the largest nb of entries in row/con IIND
+C              (PIND has the largest nb of entries in row/col IIND
                IF(IWRK(IIND).EQ.0) THEN
                   IWRK(IIND) = 1
                   SNDSZ(PIND+1) = SNDSZ(PIND+1)+1
@@ -926,18 +1108,22 @@ C     COMMUNICATE THE UPDATED ONES
       SUBROUTINE ZMUMPS_CREATEPARTVECSYM(MYID, NUMPROCS, COMM,
      & IRN_loc, JCN_loc, NZ_loc,
      & IPARTVEC, ISZ,
-     & IWRK, IWSZ)
+     & IWRK, IWSZ, INUMMY)
+!$    USE OMP_LIB
       IMPLICIT NONE
       EXTERNAL ZMUMPS_BUREDUCE
       INTEGER, INTENT(IN) :: MYID, NUMPROCS, COMM
-      INTEGER(8)          :: NZ_loc
-      INTEGER, INTENT(IN) :: ISZ, IWSZ
+      INTEGER(8)          :: NZ_loc, IWSZ
+      INTEGER, INTENT(IN) :: ISZ
       INTEGER, INTENT(IN) :: IRN_loc(NZ_loc), JCN_loc(NZ_loc)
 C
 C  OUTPUT
 C     IPARTVEC(I) = proc number with largest number of entries 
 C                in row/col I
+C     INUMMY = number of local rows/columns with
+C              at least one local entry (NUMPROCS .NE. 1 only)
       INTEGER, INTENT(OUT) :: IPARTVEC(ISZ)
+      INTEGER, INTENT(OUT) :: INUMMY
 C
 C  INTERNAL WORKING ARRAY
 C     IWRK (1:2*ISZ) is initialized to couples (MYID, Nb of entries
@@ -957,39 +1143,55 @@ C     LOCAL VARS
       INTEGER(8) :: I8
       INTEGER OP, IERROR
       INTEGER IR, IC
+      INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
 C
+      INUMMY = 0
+!$    NOMP=omp_get_max_threads()
+!$    CHUNK= max(K361/2, (ISZ+NOMP-1) / NOMP )
       IF(NUMPROCS.NE.1) THEN
 C     CHECK done outsize
 C     IF(IWSZ < 2*ISZ) THEN
 C     CHECK ENDS
          CALL MPI_OP_CREATE(ZMUMPS_BUREDUCE, .TRUE., OP, IERROR)
 C     PERFORM THE REDUCTION
-#if defined(WORKAROUNDINTELILP64MPI2INTEGER)
-         CALL ZMUMPS_IBUINIT(IWRK, 4*ISZ, int(ISZ,4))
-#else
-         CALL ZMUMPS_IBUINIT(IWRK, 4*ISZ, ISZ)
-#endif
+!$OMP   PARALLEL DO PRIVATE(I) SCHEDULE(STATIC,CHUNK)
+!$OMP&  IF ( ISZ > K361 .AND. NOMP .GT. 1)
          DO I=1,ISZ
-            IWRK(2*I-1) = 0
-            IWRK(2*I) = MYID
+            IWRK(2_8*int(I,8)-1_8) = 0
+            IWRK(2_8*int(I,8)) = MYID
          ENDDO
+!$OMP   END PARALLEL DO
          DO I8=1_8,NZ_loc
             IR = IRN_loc(I8)
             IC = JCN_loc(I8)
             IF((IR.GE.1).AND.(IR.LE.ISZ).AND.
      &           (IC.GE.1).AND.(IC.LE.ISZ)) THEN
-               IWRK(2*IR-1) = IWRK(2*IR-1) + 1
-               IWRK(2*IC-1) = IWRK(2*IC-1) + 1
+               IWRK(2_8*int(IR,8)-1_8) = IWRK(2_8*int(IR,8)-1_8) + 1
+               IWRK(2_8*int(IC,8)-1_8) = IWRK(2_8*int(IC,8)-1_8) + 1
             ENDIF
          ENDDO
-         CALL MPI_ALLREDUCE(IWRK(1), IWRK(1+2*ISZ), ISZ,
+         CALL MUMPS_BIGALLREDUCE(.FALSE.,
+     &        IWRK(1), IWRK(1_8+2_8*int(ISZ,8)), ISZ,
      &        MPI_2INTEGER, OP, COMM, IERROR)      
+C       CHUNK computed in previous // do
+!$OMP   PARALLEL DO PRIVATE(I) SCHEDULE(STATIC,CHUNK)
+!$OMP&  IF ( ISZ > K361 .AND. NOMP .GT. 1)
+!$OMP&  REDUCTION(+:INUMMY)
          DO I=1,ISZ
-            IPARTVEC(I) = IWRK(2*I+2*ISZ)
+            IPARTVEC(I) = IWRK(2_8*int(I,8)+2_8*int(ISZ,8))
+C           Compute INUMMY directly
+            IF ( IPARTVEC(I) .EQ. MYID. OR.
+     &           IWRK(2_8*int(I,8)-1_8) .GT. 0 ) THEN
+              INUMMY=INUMMY+1
+            ENDIF
          ENDDO
+!$OMP   END PARALLEL DO
 C     FREE THE OPERATOR
          CALL MPI_OP_FREE(OP, IERROR)
       ELSE
+!$OMP   PARALLEL DO PRIVATE(I) SCHEDULE(STATIC,CHUNK)
+!$OMP&  IF ( ISZ > K361 .AND. NOMP .GT. 1)
          DO I=1,ISZ
             IPARTVEC(I) = 0
          ENDDO
@@ -1001,7 +1203,7 @@ C     FREE THE OPERATOR
      & IWRK,IWRKSZ, SNDSZ, RCVSZ, COMM)
       IMPLICIT NONE
       INTEGER(8), INTENT(IN) :: NZ_loc 
-      INTEGER, INTENT(IN)    :: IWRKSZ
+      INTEGER(8), INTENT(IN) :: IWRKSZ
       INTEGER, INTENT(IN)    :: MYID, NUMPROCS, ISZ
       INTEGER, INTENT(IN)    :: INDX(NZ_loc), OINDX(NZ_loc)
       INTEGER, INTENT(IN)    :: IPARTVEC(ISZ)
@@ -1044,7 +1246,7 @@ C      IF(ISZ>IWRKSZ) THEN ERROR
          SNDSZ(I) = 0
          RCVSZ(I) = 0
       ENDDO
-      DO I=1,IWRKSZ
+      DO I=1,ISZ
          IWRK(I) = 0
       ENDDO
 C
@@ -1057,7 +1259,7 @@ C     set SNDSZ
             PIND = IPARTVEC(IIND)
             IF(PIND .NE. MYID) THEN
 C              MYID will send row/col IIND to proc PIND 
-C              (PIND has the largest nb of entries in row/con IIND
+C              (PIND has the largest nb of entries in row/col IIND
                IF(IWRK(IIND).EQ.0) THEN
                   IWRK(IIND) = 1
                   SNDSZ(PIND+1) = SNDSZ(PIND+1)+1
@@ -1092,59 +1294,6 @@ C     number of row/col sent by MYID.
       ENDDO
       RETURN
       END SUBROUTINE ZMUMPS_NUMVOLSNDRCVSYM
-      SUBROUTINE ZMUMPS_FINDNUMMYROWCOLSYM(MYID, NUMPROCS, COMM,
-     &     IRN_loc, JCN_loc, NZ_loc,
-     &     PARTVEC, N,
-     &     INUMMYR,
-     &     IWRK, IWSZ)
-      IMPLICIT NONE
-      INTEGER MYID, NUMPROCS, N
-      INTEGER(8) :: NZ_loc
-      INTEGER IRN_loc(NZ_loc), JCN_loc(NZ_loc)
-      INTEGER PARTVEC(N)
-      INTEGER INUMMYR
-      INTEGER IWSZ
-      INTEGER IWRK(IWSZ)
-      INTEGER COMM
-C
-      INTEGER I, IR, IC
-      INTEGER(8) :: I8
-C check done outsize     
-C     IF(IWSZ < M) THEN ERROR
-C     IF(IWSZ < N) THEN ERROR
-      INUMMYR = 0
-C     MARK MY ROWS. FIRST COUNT,
-C          IF DYNAMIC MEMORY ALLOCATIOn WILL USED
-      DO I=1,N
-         IWRK(I) = 0
-         IF(PARTVEC(I).EQ.MYID) THEN
-            IWRK(I)=1
-            INUMMYR = INUMMYR + 1
-         ENDIF
-      ENDDO
-      DO I8=1_8,NZ_loc
-         IR = IRN_loc(I8)
-         IC = JCN_loc(I8)
-         IF((IR.GE.1).AND.(IR.LE.N).AND.
-     &        ((IC.GE.1).AND.(IC.LE.N))) THEN
-            IF(IWRK(IR) .EQ. 0) THEN
-               IWRK(IR)= 1
-               INUMMYR = INUMMYR + 1
-            ENDIF
-         ENDIF
-         IF((IR.GE.1).AND.(IR.LE.N).AND.
-     &        ((IC.GE.1).AND.(IC.LE.N))) THEN
-            IF(IWRK(IC).EQ.0) THEN
-               IWRK(IC)= 1
-               INUMMYR = INUMMYR + 1
-            ENDIF
-         ENDIF
-      ENDDO
-C     THE SMAME THING APPLIES FOR COLS
-C     No need to do anything
-C
-      RETURN
-      END SUBROUTINE ZMUMPS_FINDNUMMYROWCOLSYM
       INTEGER FUNCTION ZMUMPS_CHKCONVGLOSYM(D, N, INDXR, INDXRSZ,
      &     EPS, COMM)
       IMPLICIT NONE
@@ -1169,11 +1318,12 @@ C
      &     IRN_loc, JCN_loc, NZ_loc,
      &     PARTVEC, N,
      &     MYROWINDICES, INUMMYR,
-     &     IWRK, IWSZ  )
+     &     IWRK, IWSZ, NOMP_MAX )
+!$    USE OMP_LIB
       IMPLICIT NONE
-      INTEGER MYID, NUMPROCS, N
-      INTEGER(8) :: NZ_loc
-      INTEGER INUMMYR, IWSZ
+      INTEGER MYID, NUMPROCS, N, NOMP_MAX
+      INTEGER(8) :: NZ_loc, IWSZ
+      INTEGER INUMMYR
       INTEGER IRN_loc(NZ_loc), JCN_loc(NZ_loc)
       INTEGER PARTVEC(N)
       INTEGER MYROWINDICES(INUMMYR)
@@ -1182,21 +1332,36 @@ C
 C
       INTEGER I, IR, IC, ITMP
       INTEGER(8) :: I8
+      INTEGER, PARAMETER :: K361 = 2048
+!$    INTEGER NOMP, CHUNK
+!$    IF (NOMP_MAX.GT.0) THEN
+!$      NOMP=omp_get_max_threads()
+!$      CHUNK= max(K361/2, (N+NOMP-1) / NOMP )
+!$    ENDIF
 C      
 C     MARK MY ROWS. 
-      DO I=1,N
-         IWRK(I) = 0
-         IF(PARTVEC(I).EQ.MYID) IWRK(I)=1
-      ENDDO
+      IF (NOMP_MAX.LE.0) THEN
+        DO I=1,N
+           IWRK(I) = 0
+           IF(PARTVEC(I).EQ.MYID) IWRK(I)=1
+        ENDDO
+      ELSE
+!$OMP   PARALLEL DO PRIVATE(I) 
+!$OMP&  SCHEDULE(STATIC,CHUNK)
+!$OMP&  IF ( N > K361 .AND. NOMP .GT. 1)
+        DO I=1,N
+           IWRK(I) = 0
+           IF(PARTVEC(I).EQ.MYID) IWRK(I)=1
+        ENDDO
+!$OMP END PARALLEL DO
+      ENDIF
+C
       DO I8=1_8,NZ_loc
          IR = IRN_loc(I8)   
          IC = JCN_loc(I8)
          IF((IR.GE.1).AND.(IR.LE.N).AND.
      &        ((IC.GE.1).AND.(IC.LE.N))) THEN
             IF(IWRK(IR) .EQ. 0) IWRK(IR)= 1
-         ENDIF
-         IF((IR.GE.1).AND.(IR.LE.N).AND.
-     &        ((IC.GE.1).AND.(IC.LE.N))) THEN
             IF(IWRK(IC) .EQ.0) IWRK(IC)=1
          ENDIF
       ENDDO
diff -pruN 5.6.2-2.1/src/zfac_sispointers_m.F 5.7.1-1/src/zfac_sispointers_m.F
--- 5.6.2-2.1/src/zfac_sispointers_m.F	2023-10-11 09:37:10.000000000 +0000
+++ 5.7.1-1/src/zfac_sispointers_m.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/zfac_sol_l0omp_m.F 5.7.1-1/src/zfac_sol_l0omp_m.F
--- 5.6.2-2.1/src/zfac_sol_l0omp_m.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/zfac_sol_l0omp_m.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -15,7 +15,14 @@ C
       PRIVATE
       PUBLIC :: ZMUMPS_INIT_L0_OMP_FACTORS
      &        , ZMUMPS_FREE_L0_OMP_FACTORS
+#if ! defined(NO_SAVE_RESTORE)
      &        , ZMUMPS_SAVE_RESTORE_L0FACARRAY
+#endif
+#if ! defined(NO_SAVE_RESTORE)
+#endif
+#if ! defined(NO_SAVE_RESTORE)
+      INCLUDE 'mumps_save_restore_modes.h'
+#endif
       CONTAINS
       SUBROUTINE ZMUMPS_INIT_L0_OMP_FACTORS(id_L0_OMP_FACTORS)
       USE ZMUMPS_STRUC_DEF, ONLY : ZMUMPS_L0OMPFAC_T
@@ -48,6 +55,7 @@ C
       ENDIF
       RETURN
       END SUBROUTINE ZMUMPS_FREE_L0_OMP_FACTORS
+#if ! defined(NO_SAVE_RESTORE)
       SUBROUTINE ZMUMPS_SAVE_RESTORE_L0FACARRAY(L0_OMP_FACTORS
      &                 ,unit,MYID,mode
      &                 ,SIZE_GEST,SIZE_VARIABLES
@@ -59,7 +67,7 @@ C
       IMPLICIT NONE
       TYPE (ZMUMPS_L0OMPFAC_T), DIMENSION(:), POINTER :: L0_OMP_FACTORS
       INTEGER,intent(IN)::unit,MYID
-      CHARACTER(len=*),intent(IN) :: mode
+      INTEGER,intent(IN) :: mode
       INTEGER,INTENT(OUT) :: SIZE_GEST
       INTEGER(8),intent(OUT) :: SIZE_VARIABLES
       INTEGER,intent(INOUT):: INFO(2)
@@ -79,7 +87,7 @@ C
       SIZE_GEST_L0FAC_ARRAY_j1=0
       SIZE_VARIABLES_L0FAC_ARRAY_j1=0
       NbRecords = 0
-      IF (trim(mode).EQ."memory_save") THEN
+      IF (mode.EQ.memory_save_mode) THEN
         IF (associated(L0_OMP_FACTORS)) THEN
           NbRecords      = 1 
           SIZE_GEST      = SIZE_INT 
@@ -87,7 +95,7 @@ C
           DO j1=1,size(L0_OMP_FACTORS)
             CALL ZMUMPS_SAVE_RESTORE_L0FAC(
      &           L0_OMP_FACTORS(j1)
-     &           ,unit,MYID,"memory_save"
+     &           ,unit,MYID,memory_save_mode
      &           ,SIZE_GEST_L0FAC_ARRAY_j1
      &           ,SIZE_VARIABLES_L0FAC_ARRAY_J1
      &           ,SIZE_INT,SIZE_INT8,SIZE_ARITH_DEP
@@ -105,7 +113,7 @@ C
           SIZE_GEST      = 2*SIZE_INT
           SIZE_VARIABLES = 0
         ENDIF
-      ELSEIF (trim(mode).EQ."save") THEN
+      ELSEIF (mode.EQ.save_mode) THEN
         IF (associated(L0_OMP_FACTORS)) THEN
           NbRecords      = 1 
           SIZE_GEST      = SIZE_INT
@@ -120,7 +128,7 @@ C
           DO j1=1,size(L0_OMP_FACTORS)
             CALL ZMUMPS_SAVE_RESTORE_L0FAC(
      &           L0_OMP_FACTORS(j1)
-     &           ,unit,MYID,"save"
+     &           ,unit,MYID,save_mode
      &           ,SIZE_GEST_L0FAC_ARRAY_J1
      &           ,SIZE_VARIABLES_L0FAC_ARRAY_J1
      &           ,SIZE_INT,SIZE_INT8,SIZE_ARITH_DEP
@@ -147,7 +155,7 @@ C
             endif
             IF ( INFO(1) .LT. 0 ) GOTO 100
         ENDIF
-      ELSE IF (trim(mode).EQ."restore") THEN
+      ELSE IF (mode.EQ.restore_mode) THEN
         NULLIFY(L0_OMP_FACTORS)
          read(unit,iostat=err) size_array1
          if(err.ne.0) THEN
@@ -181,7 +189,7 @@ C
            DO j1=1,size(L0_OMP_FACTORS)
              CALL ZMUMPS_SAVE_RESTORE_L0FAC(
      &            L0_OMP_FACTORS(j1)
-     &            ,unit,MYID,"restore"
+     &            ,unit,MYID,restore_mode
      &            ,SIZE_GEST_L0FAC_ARRAY_J1
      &            ,SIZE_VARIABLES_L0FAC_ARRAY_J1
      &            ,SIZE_INT, SIZE_INT8, SIZE_ARITH_DEP
@@ -196,19 +204,19 @@ C
            ENDDO
          endif
       ENDIF
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          NbSubRecords=int(SIZE_VARIABLES/huge(I4))
          IF(NbSubRecords.GT.0) then
             NbRecords=NbRecords+NbSubRecords
          ENDIF
-      elseif(trim(mode).EQ."save") then
+      elseif(mode.EQ.save_mode) then
          size_written=size_written+SIZE_VARIABLES
      &        +int(SIZE_GEST,kind=8)
 #if defined(MUMPS_NOF2003)
          size_written=size_written
      &        +int(2*SIZE_INT*NbRecords,kind=8)
 #endif
-      elseif(trim(mode).EQ."restore") then
+      elseif(mode.EQ.restore_mode) then
          size_allocated=size_allocated+SIZE_VARIABLES
          size_read=size_read+SIZE_VARIABLES
      &        +int(SIZE_GEST,kind=8)
@@ -217,7 +225,7 @@ C
      &        +int(2*SIZE_INT*NbRecords,kind=8)
 #endif
       endif
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          SIZE_VARIABLES=SIZE_VARIABLES+SIZE_VARIABLES_L0FAC_ARRAY
          SIZE_GEST=SIZE_GEST+SIZE_GEST_L0FAC_ARRAY
 #if defined(MUMPS_NOF2003)
@@ -239,7 +247,7 @@ C
       IMPLICIT NONE
       TYPE (ZMUMPS_L0OMPFAC_T) :: L0_OMP_FACTORS_1THREAD
       INTEGER,intent(IN)::unit,MYID
-      CHARACTER(len=*),intent(IN) :: mode
+      INTEGER,intent(IN) :: mode
       INTEGER,INTENT(OUT) :: Local_SIZE_GEST
       INTEGER(8),intent(OUT) :: Local_SIZE_VARIABLES
       INTEGER,intent(INOUT):: INFO(2)
@@ -252,9 +260,9 @@ C
       Local_SIZE_GEST = 0
       Local_SIZE_VARIABLES = 0_8
       Local_NbRecords = Local_NbRecords+1
-      IF (trim(mode) .EQ. "memory_save") THEN
+      IF (mode .EQ. memory_save_mode) THEN
         Local_SIZE_VARIABLES = Local_SIZE_VARIABLES + SIZE_INT8
-      ELSE IF (trim(mode) .EQ. "save") THEN
+      ELSE IF (mode .EQ. save_mode) THEN
         Local_SIZE_VARIABLES = Local_SIZE_VARIABLES + SIZE_INT8
         WRITE(unit,iostat=err) L0_OMP_FACTORS_1THREAD%LA
         IF (err .NE. 0) THEN
@@ -264,7 +272,7 @@ C
           GOTO 100
         ENDIF
         size_written=size_written+SIZE_INT8
-      ELSE IF (trim(mode) .EQ. "restore") THEN
+      ELSE IF (mode .EQ. restore_mode) THEN
         Local_SIZE_VARIABLES = Local_SIZE_VARIABLES + SIZE_INT8
         READ(unit,iostat=err) L0_OMP_FACTORS_1THREAD%LA
         IF (err .NE. 0) THEN
@@ -275,7 +283,7 @@ C
         ENDIF
         size_read=size_read+SIZE_INT8
       ENDIF
-      IF (trim(mode).EQ."memory_save") THEN
+      IF (mode.EQ.memory_save_mode) THEN
         IF (associated(L0_OMP_FACTORS_1THREAD%A)) THEN
           Local_NbRecords = Local_NbRecords + 2
           Local_SIZE_GEST = Local_SIZE_GEST + SIZE_INT8
@@ -286,7 +294,7 @@ C
           Local_SIZE_GEST = Local_SIZE_GEST + SIZE_INT8
           Local_SIZE_VARIABLES = Local_SIZE_VARIABLES + 0
         ENDIF
-      ELSEIF (trim(mode).EQ."save") THEN
+      ELSEIF (mode.EQ.save_mode) THEN
         IF (associated(L0_OMP_FACTORS_1THREAD%A)) THEN
           Local_NbRecords = Local_NbRecords + 2
           write(unit,iostat=err) int(0,8) 
@@ -317,7 +325,7 @@ C
           endif
           size_written=size_written+SIZE_INT8
         ENDIF
-      ELSEIF (trim(mode).EQ."restore") THEN
+      ELSEIF (mode.EQ.restore_mode) THEN
         NULLIFY(L0_OMP_FACTORS_1THREAD%A)
         READ(unit,iostat=err) itmp
         if(err.ne.0) THEN
@@ -356,15 +364,16 @@ C
         ENDIF
       ENDIF
 #if defined(MUMPS_NOF2003)
-      IF (trim(mode).EQ."memory_save") THEN
+      IF (mode.EQ.memory_save_mode) THEN
         Local_SIZE_GEST = Local_SIZE_GEST+2*SIZE_INT*Local_NbRecords
-      ELSE IF (trim(mode).EQ."save") THEN
+      ELSE IF (mode.EQ.save_mode) THEN
         size_written = size_written+2*SIZE_INT*Local_NbRecords
-      ELSE IF (trim(mode).EQ."restore") THEN
+      ELSE IF (mode.EQ.restore_mode) THEN
         size_read = size_read+2*SIZE_INT*Local_NbRecords
       ENDIF
 #endif
   100 CONTINUE
       RETURN
       END SUBROUTINE ZMUMPS_SAVE_RESTORE_L0FAC
+#endif
       END MODULE ZMUMPS_FACSOL_L0OMP_M
diff -pruN 5.6.2-2.1/src/zfac_sol_pool.F 5.7.1-1/src/zfac_sol_pool.F
--- 5.6.2-2.1/src/zfac_sol_pool.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/zfac_sol_pool.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -177,8 +177,6 @@ C
      &        ND(KEEP(28))
       EXTERNAL MUMPS_INSSARBR, MUMPS_ROOTSSARBR, ZMUMPS_POOL_EMPTY
       LOGICAL MUMPS_INSSARBR, MUMPS_ROOTSSARBR, ZMUMPS_POOL_EMPTY
-      EXTERNAL MUMPS_PROCNODE
-      INTEGER MUMPS_PROCNODE
       INTEGER NBINSUBTREE, NBTOP, INSUBTREE, INODE_EFF, MYID
       LOGICAL LEFT, ATOMIC_SUBTREE,UPPER,FLAG_MEM,SBTR_FLAG,PROC_FLAG
       LOGICAL FORCE_EXTRACT_TOP_SBTR
@@ -386,8 +384,6 @@ C
       INTEGER INODE,LPOOL,N,MYID,SLAVEF,PROC,MIN_PROC
       INTEGER POOL(LPOOL),KEEP(500),STEP(N),PROCNODE(KEEP(28))
       INTEGER(8) KEEP8(150)
-      INTEGER MUMPS_PROCNODE
-      EXTERNAL MUMPS_PROCNODE
       LOGICAL SBTR,FLAG_SAME_PROC
       INTEGER POS_TO_EXTRACT,NODE_TO_EXTRACT,NBTOP,I,INSUBTREE,
      &     NBINSUBTREE
diff -pruN 5.6.2-2.1/src/zfac_type3_symmetrize.F 5.7.1-1/src/zfac_type3_symmetrize.F
--- 5.6.2-2.1/src/zfac_type3_symmetrize.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/zfac_type3_symmetrize.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/zini_defaults.F 5.7.1-1/src/zini_defaults.F
--- 5.6.2-2.1/src/zini_defaults.F	2023-10-11 09:37:10.000000000 +0000
+++ 5.7.1-1/src/zini_defaults.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -108,8 +108,9 @@ C     are set by ZMUMPSID.  The elements
 C     and INFO provide information on the action of ZMUMPS.
 C  
 C  CNTL(1) threshold for partial pivoting
-C     has default value 0.0 when SYM=1 and 0.01 otherwise
-C     Values and less than zero as treated as zero.
+C     has default -1.0 (automatic choice):
+C      0.1 in case of rank-revealing (ICNTL(56)=1,2)
+C      otherwise  0.0 when SYM=1 and 0.01 otherwise.
 C     Values greater than 1.0 are treated as 1.0 for
 C     SYM=1 and as 0.5 for SYM=2
 C     In general, a larger value of CNTL(1) leads to 
@@ -127,6 +128,7 @@ C     Default value is sqrt(macheps).
 C     Values less than zero are treated as sqrt(macheps).
 C
 C  CNTL(3) is used with null pivot row detection (ICNTL(24) .eq. 1)
+C     and/or with Rank-Revealing (RR) option (ICNTL(56)).
 C     Default value is 0.0. 
 C     Let A_{preproc} be the preprocessed matrix to be factored (see
 C       equation in the user's guide).
@@ -135,6 +137,35 @@ C     row/column is smaller than a thres
 C     machine precision and ||.|| be the infinite norm.
 C     The absolute value to detect a null pivot row (when ICNTL(24) .EQ.1) 
 C     is stored in DKEEP(1).
+C     In case of RR, CNTL(3) will define the thresholds for :
+C      
+C       - Postponing pseudo singularities (SEUIL):
+C         The computed threshold value for postponing pivots
+C         is stored in "SEUIL" and then "SEUIL_LDLT_NIV2"
+C         which are identical in current version.
+C
+C       - Defining singularities on root (DKEEP(9))
+C
+C       - Defining null pivot rows if ICNTL(24).EQ.1 (DKEEP(1)) 
+C         in this case DKEEP(1) must be smaller than DKEEP(9)
+C
+C     IF (ICNTL(56).NE.0) THEN 
+C      RR on root is active 
+C      IF  (CNTL3 .LT. ZERO) THEN
+C          DKEEP(9) = abs(CNTL(3))
+C      ELSE IF  (CNTL3 .GT. ZERO) THEN
+C          DKEEP(9) = CNTL3*||A_{preproc}||
+C      ELSE  !  (CNTL(3) .EQ. ZERO) THEN
+C          DKEEP(9) = sqrt(N_h)*MACHEPS*||A_{preproc}||  
+C          where Nh is the number of pivots on the deepest branch
+C          of the elimination tree.
+C      ENDIF
+C      IF (ICNTL(24).EQ.1) THEN
+C       null pivot detection
+C         DKEEP(1) = DKEEP(9)*DKEEP(10)
+C      ENDIF
+C
+C     ELSE (ONLY NULL PIVOT detection is active) 
 C      IF CNTL(3)  > 0 THEN
 C          DKEEP(1) = CNTL(3)  ||A_{preproc}|| 
 C      ELSE IF CNTL(3)  = 0.0 THEN 
@@ -143,6 +174,7 @@ C      ELSE IF CNTL(3)  < 0 THEN
 C          DKEEP(1) = abs(CNTL(3))! this was added for EDF 
 C                                 ! in the context of SOLSTICE project
 C      ENDIF
+C     ENDIF
 C
 C  CNTL(4) must be set to value for static pivoting.
 C     Default value is -1.0
@@ -387,6 +419,9 @@ C               The order of the root no
 C            ENDIF
 C            If ICNTL(13) .EQ. -1 then splitting of the root
 C            is done whatever the nb of procs is. 
+C            Authorizing extra root spliting during analysis might be
+C            interesting to further split the root node (combined for 
+C            example with null pivot detection option ICNTL(24)=1 OR ICNTL(56))
 C             
 C            To summarize:
 C               -1         : root splitting and scalapack on
@@ -647,12 +682,14 @@ C            For all other values, the d
 C            null pivots and static pivots are excluded from the
 C            computation of the determinant.
 C
+#if ! defined(NO_SAVE_RESTORE)
 C   ICNTL(34) Must be set before a call to MUMPS with JOB=-3 in case
 C             the save/restore feature was used and user wants to clean
 C             save/restore files (and possibly OOC files). 
 C             ICTNL(34)=0 => user wants to be able to restore instance later
 C             ICTNL(34)=1 => user will not restore the instance again (clean
 C                            to be done)
+#endif
 C
 C    ICNTL(35) : Block Low-Rank (BLR) functionality, 
 C                need be set before analysis
@@ -697,6 +734,25 @@ C                Between 0 and 1000; oth
 C                corresponds to an estimated compression rate of
 C                ICNTL(39)/1000%.
 C                Default value: 500 (50.0% compression rate).
+C
+C  ICNTL(56) has default value 0 and is only accessed by the host.
+C      During the analysis phase, a positive value prepares the data for
+C       later use of null space functionalities (saved in KEEP(53)).
+C       (the tree is modified to have only one root in analysis)
+C       If ICNTL(56) is negative or zero, null space feature will
+C       be forbidden during the factorization phase.
+C      During the factorization phase, if ICNTL(56) was positive 
+C      (KEEP(53)>0) for analysis, then the values of ICNTL(56) (saved
+C      in KEEP(19)) have the following meaning.
+C          0: No null space analysis,
+C          1: Null space analysis on last root node using SVD,
+C          2: Null space analysis on last root node using QR,
+C
+C       The singular values (ICNTL(56)=1) or the diagonal entries of R
+C       (ICNTL(56)=2) are available in root%SINGULAR_VALUES
+C
+C
+C
 C 
 C   ICNTL(58): strategy for symbolic factorization used
 C              with centralized ordering based on METIS (ICNTL(7)=5)
@@ -782,6 +838,10 @@ C  INFO(18)  On exit to factorization:
 C              Local number of null pivots (ICNTL(24)=1) 
 C              on the local processor even on master. 
 C              (local size of array PIVNUL_LIST).
+C              Note that it also includes null pivots 
+C              that might have been further detected on 
+C              the root if ICNTL(56).NE.0. and root 
+C              processed by MYID
 C
 C  INFO(19) - after analysis: 
 C           Estimated size of the main internal integer workarray IS
@@ -858,7 +918,7 @@ C     for the elimination process on the
 C
 C  RINFOG(3)  Number of floating-point operations
 C     for the elimination process on all processors.
-C
+C  
 C----------------------------------------------------
 C Statistics produced after solve with error analysis
 C----------------------------------------------------
@@ -919,6 +979,25 @@ C
 C  RINFOG(21) -  after factorization: largest pivot in absolute 
 C             value selected during factorization of the preprocessed
 C             matrix A_pre.
+C  
+C  RINFOG(22) - after factorization: 
+C             total number of floating-point operations offloaded to 
+C             the accelerator(s) by all MPI processes (see RINFO(9))
+C
+C  RINFOG(23) - after factorization: average (over all MPI processes) 
+C            time spent in operations offloaded to the accelerators
+C            including communication (see RINFO(10)).
+C
+C  Computed when solve involves exploit sparsity (fwd and/or bwd)
+C  here we only report off diagonal flops)
+C
+#if defined(STAT_ES_SOLVE)
+C  RINFOG(24) - FR FLOPS (off diagonal flops)
+C  RINFOG(25) - FR FLOPS (off diag) with Exploit sparsity 
+C               (possibly with nb_sparse algo used)
+#endif
+C
+C
 C===========================
 C DESCRIPTION OF KEEP8 ARRAY
 C===========================
@@ -926,6 +1005,8 @@ C
 C   KEEP8 is a 64-bit integer array of length 150 that need not
 C   be set by the user
 C
+#if ! defined(NO_SAVE_RESTORE)
+#endif
 C===========================
 C DESCRIPTION OF KEEP ARRAY
 C===========================
@@ -972,11 +1053,8 @@ C     Only options 0, 1, or 2 are availa
 C     -------------------------------------
       IF ( KEEP(50).NE.1 .and. KEEP(50).NE.2 ) KEEP( 50 ) = 0
 C     threshold value for pivoting
-      IF ( KEEP(50) .NE. 1 ) THEN
-        CNTL(1)   = 0.01D0
-      ELSE
-        CNTL(1)   = 0.0D0
-      END IF
+C     Automatic choice depending on (SYM and ICNTL(56))
+      CNTL(1) = -1.0D0
       CNTL(2) = sqrt(epsilon(0.0D0))
       CNTL(3) = 0.0D0
       CNTL(4) = -1.0D0
@@ -1067,6 +1145,14 @@ C     Default BLR compression rate of fa
       ICNTL(38) = 600
 C     Default BLR compression rate of factors (50%)
       ICNTL(39) = 500
+C     L0-thread feature
+#if defined(_OPENMP)
+C     Activate L0OMP
+      ICNTL(48) = 1
+#else
+C     Do not activate L0OMP
+      ICNTL(48) = 0
+#endif
       ICNTL(55) = 0
       ICNTL(56) = 0
       ICNTL(57) = 0
@@ -1092,7 +1178,7 @@ C===================================
         KEEP(6)  = 32
         KEEP(9)  = 700
         KEEP(85) =  300
-        KEEP(62) =  50
+        KEEP(62) =  10
       ELSE
         KEEP(4)  = 24
         KEEP(3)  = 96
@@ -1100,8 +1186,9 @@ C===================================
         KEEP(6)  = 32
         KEEP(9)  = 400
         KEEP(85) = 100
-        KEEP(62) = 50
+        KEEP(62) = 10
       END IF
+        KEEP(11)=200
       KEEP(63) = 60
       KEEP(48) = 5
       CALL ZMUMPS_SET_TYPE_SIZES( KEEP(34), KEEP(35),
@@ -1130,36 +1217,24 @@ C     Forcing proportional is ok with st
       KEEP(75) = 1
       KEEP(76) = 2
       KEEP(77) = 30
+      KEEP(78)= -1
       KEEP(79) = 0  ! old splitting
-      IF (NSLAVES.GT.4) THEN
-          KEEP(78)=max(
-     &       int(log(dble(NSLAVES))/log(dble(2))) - 2 
-     &       , 0         )
-      ENDIF
       KEEP(210) = 2 
       KEEP8(79) = -10_8
       KEEP(80) = 1
       KEEP(81) = 0
-      KEEP(82) = 30
-      KEEP(83) = min(8,NSLAVES/4)
-      KEEP(83) = max(min(4,NSLAVES),max(KEEP(83),1))
+      IF (SYM.EQ.0) THEN
+       KEEP(82)= 15
+      ELSE
+       KEEP(82) = 10
+      ENDIF
+      KEEP(83) = -1
       KEEP(86)=1
       KEEP(87)=0
       KEEP(88)=0
       KEEP(90)=1
-      KEEP(91)=min(8, NSLAVES)
-      KEEP(91) = max(min(4,NSLAVES),min(KEEP(83),KEEP(91)))
-      IF(NSLAVES.LT.48)THEN
-         KEEP(102)=150
-      ELSEIF(NSLAVES.LT.128)THEN
-         KEEP(102)=150
-      ELSEIF(NSLAVES.LT.256)THEN
-         KEEP(102)=200
-      ELSEIF(NSLAVES.LT.512)THEN
-         KEEP(102)=300
-      ELSEIF(NSLAVES.GE.512)THEN
-         KEEP(102)=400
-      ENDIF
+      KEEP(91)= -1
+      KEEP(102)= -1
 #if defined(OLD_OOC_NOPANEL)
       KEEP(99)=0  ! no panel -> synchronous / no buffer
 #else
@@ -1174,6 +1249,8 @@ C     strategy for MUMPS_BLOC2_GET_NSLAV
       KEEP(119)=0
 C     Scaling is enabled by default with the Schur complement option
       KEEP(125)=1
+C     Columns of LMAT handled by block of size KEEP(147)
+      KEEP(147)=20000
 C     More amalgamation of tiny fronts
       KEEP(197)=1
 C     KEEP(199) for MUMPS_PROCNODE, MUMPS_TYPENODE, etc
@@ -1190,6 +1267,9 @@ C     allocate id%S later otherwise.
       KEEP(107)=0
       KEEP(121)=-999999
       KEEP(122)=150
+C     Size of CB for which we want to force BLR compressCB
+C     even if NASS is small.
+      KEEP(123)=10000
        KEEP(141)=1 ! min needed
       KEEP(206)=1 
       KEEP(207) = 1
@@ -1203,7 +1283,11 @@ C     allocate id%S later otherwise.
       KEEP(215)=0
       KEEP(216)=1
       KEEP(218)=250
-      KEEP(219)=1
+      IF (SYM.EQ.2) THEN
+       KEEP(219)=1
+      ELSE
+       KEEP(219)=0
+      ENDIF
       IF (KEEP(50).EQ.2) THEN
         KEEP(227)= max(2,32)
       ELSE
@@ -1221,7 +1305,7 @@ C     allocate id%S later otherwise.
                         ! (default value is 10 set in fac_driver.F)
       DKEEP(24) = 1000.0D0 ! gap should be larger than dkeep(14)
       DKEEP(25) = 10.0D0 ! gap precision
-      DKEEP(22) = 0.2D0 ! to check for slow convergence
+      DKEEP(22) = 0.5D0 ! to check for slow convergence
       KEEP(238)=18
       KEEP(234)= 1
       KEEP(235)=-1
@@ -1229,9 +1313,11 @@ C     allocate id%S later otherwise.
       DKEEP(18)= 1.0D12
       KEEP(242) = -9
       KEEP(243) = -1
+      KEEP(255)=100
+      KEEP(281) = 0
 C     Parallel analysis compatible with analysis by blocks
 C                       and detection out-of-range 
-      KEEP(339)= 6
+      KEEP(339)= 1
       KEEP(249)=1
 !$    KEEP(249) = OMP_GET_MAX_THREADS()
       KEEP(250) = 1
@@ -1249,17 +1335,20 @@ C                       and detection ou
       KEEP(363) = 512
       KEEP(364) = 32768
       KEEP(378) = 1
-C     OMP parallelization of arrowheads
       KEEP(399) = 1
       KEEP(397) = -1
-#if defined(__ve__)
-      KEEP(401) = 1
-#else
-      KEEP(401) = 0
-#endif
       KEEP(402) = 1
       KEEP(405) = 0 ! 1 under L0OMP
       KEEP(406) = 2 
+#if defined(__PGLLVM__)
+C     With aocc version of Classic flang, we want to
+C     avoid an OpenMP bug during L0thread copies by
+C     switching to simpler copy algorithm.
+C     Since we cannot test __aocc__ in Fortran, we rely on the
+C     slower algorithm as soon as __PGLLVM__ is detected, even
+C     if this is "too careful".
+      KEEP(406)=0
+#endif
 C     0.9 equilibration
       KEEP(408) = 90
       KEEP(420) =  4*KEEP(6)   ! if KEEP(6)=32 then 128
@@ -1306,11 +1395,10 @@ C     probably a cache miss on the pivot
       KEEP(490) = 128
       KEEP(491) = 1000
 #if defined(__ve__)
-      KEEP(491)=512
+      KEEP(490)=512
       KEEP(491)=8000
 #endif
       KEEP(492) = 1
-      KEEP(82) = 30
       KEEP(493) = 0
       KEEP(496) = 1
       KEEP(495) = -1
@@ -1330,6 +1418,8 @@ C
          id%KEEP(5)=1
          id%KEEP(6)=2
          id%KEEP(9)=3
+C        KEEP(11) not too small either
+         id%KEEP(11)=3
          id%KEEP(39)=300
          id%KEEP(7) = 3
          id%KEEP(8) = 2
@@ -1342,6 +1432,8 @@ C
          id%KEEP(85)=-4
          id%KEEP(62) = 2  
          id%KEEP(1)  = 1   
+         id%KEEP(123) = 6
+         id%KEEP(147) = 3
          id%KEEP(197)  = 0
          id%KEEP(51) = 2
 !$       id%KEEP(360) = 2
@@ -1356,15 +1448,9 @@ C
          id%ICNTL(27)=-3
          id%KEEP(227)=3
          id%KEEP(30) = 1000
-#if defined(_OPENMP)
-C        Activate L0OMP with test_mumps in case KEEP(72)=1,
-C        but only if compiilation is with OpenMP
-         id%KEEP(401) = 1
-#endif
       ELSE IF (id%KEEP(72)==2) THEN
          id%KEEP(85)=2            ! default is 
          id%KEEP(85)=-10000         ! default is 160 
-         id%KEEP(62) = 10       ! default is 50
          id%KEEP(210) = 1       ! defaults is 0 (automatic)
          id%KEEP8(79) = 160000_8   
          id%KEEP(1) = 2  ! default is 8
diff -pruN 5.6.2-2.1/src/zini_driver.F 5.7.1-1/src/zini_driver.F
--- 5.6.2-2.1/src/zini_driver.F	2023-10-11 09:37:10.000000000 +0000
+++ 5.7.1-1/src/zini_driver.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -31,6 +31,10 @@ C
       INTEGER MASTER, IERR,PAR_loc,SYM_loc
       PARAMETER( MASTER = 0 )
       INTEGER color
+#if defined(metis) || defined(parmetis)
+      INTEGER I
+#endif
+      INTEGER(8) :: I8
 C     -----------------------------
 C     Initialize MPI related data
 C     -----------------------------
@@ -88,8 +92,10 @@ C     ----------------------------------
       CALL MUMPS_SET_VERSION( id%VERSION_NUMBER )
       id%OOC_TMPDIR="NAME_NOT_INITIALIZED"
       id%OOC_PREFIX="NAME_NOT_INITIALIZED"
+#if ! defined(NO_SAVE_RESTORE)
       id%SAVE_DIR="NAME_NOT_INITIALIZED"
       id%SAVE_PREFIX="NAME_NOT_INITIALIZED"
+#endif
 C     Default value for NRHS is 1
       id%NRHS = 1
 C     Leading dimension will be reset to id%N is ZMUMPS_SOL_DRIVER
@@ -118,13 +124,11 @@ C     set to default options
 C     Useful size is 40  
 C     This sets the default values
       CALL METIS_SETDEFAULTOPTIONS(id%METIS_OPTIONS)
-C     This number, 18, corresponds to METIS_OPTIONS_NUMBERING which
-C     tells METIS to use fortran numbering and is found in metis.h
-C     In Metis 5.0.3 and Parmetis 4.0.2, METIS_OPTIONS_NUMBERING 
-C     was METIS_OPTIONS(17). MUMPS doesnot support those versions anymore.
-C     To use them, just change METIS_OPTIONS(18) into METIS_OPTIONS(17)
-C     like that: METIS_OPTIONS(17) = 1
-      id%METIS_OPTIONS(18) = 1
+      CALL MUMPS_METIS_OPTION_NUMBERING(I)
+C     The value of I corresponds to "METIS_OPTION_NUMBERING", which tells
+C     METIS to use Fortran numbering. METIS_OPTION_NUMBERING is defined
+C     in metis.h and accessed through a C wrapper.
+      id%METIS_OPTIONS(I+1) = 1 ! +1 for Fortran indexing
 #endif
 #endif      
 C
@@ -154,6 +158,8 @@ C
       NULLIFY(id%RHS_loc)
       NULLIFY(id%COLSCA)
       NULLIFY(id%ROWSCA)
+      NULLIFY(id%ROWSCA_loc)
+      NULLIFY(id%COLSCA_loc)
       NULLIFY(id%PERM_IN)
       NULLIFY(id%IS)
       NULLIFY(id%STEP)
@@ -198,10 +204,11 @@ C     Info for pruning tree
       NULLIFY(id%MY_FIRST_LEAF)
       NULLIFY(id%MY_NB_LEAF)
       NULLIFY(id%COST_TRAV)
-      NULLIFY(id%RHSCOMP)
-      NULLIFY(id%POSINRHSCOMP_ROW)
-      NULLIFY(id%POSINRHSCOMP_COL)
-      id%POSINRHSCOMP_COL_ALLOC = .FALSE.
+      NULLIFY(id%RHSINTR)
+      id%LD_RHSINTR = 0
+      NULLIFY(id%GLOB2LOC_RHS)
+      NULLIFY(id%GLOB2LOC_SOL)
+      id%GLOB2LOC_SOL_ALLOC = .FALSE.
 C
 C     Out of Core management related data
 C
@@ -215,7 +222,7 @@ C
       NULLIFY(id%LRGROUPS)
       NULLIFY(id%FDM_F_ENCODING)
       NULLIFY(id%BLRARRAY_ENCODING)
-      NULLIFY(id%MPITOOMP_PROCS_MAP)
+      NULLIFY(id%MTKO_PROCS_MAP)
 C     Must be nullified because of routine
 C     ZMUMPS_SIZE_IN_STRUCT
       NULLIFY(id%CB_SON_SIZE)
@@ -286,6 +293,14 @@ C
 C
 C     Initializations for Rank detection/null space
 C
+C         -----------------------------
+C         RCOND is a threshold such that:
+C                   A * P = Q * [ R11 R12 ]
+C                               [  0  R22 ]
+C         with R11 defined as the largest leading submatrix whose estimated
+C         condition number is less than 1/RCOND.
+C         -------------------------------------------
+      id%ROOT%QR_RCOND = 1.0D-11
       NULLIFY(id%SINGULAR_VALUES)
       CALL ZMUMPS_RR_INIT_POINTERS(id)
 C     Architecture data
@@ -313,5 +328,21 @@ C     ----------------------------------
       ELSE
           id%MYID_NODES = -464646
       ENDIF
+C
+C     Check that KEEP(34), the size of a Fortran INTEGER,
+C     as initialized above during ZMUMPSID
+C     matches the size of an integer in C. If not,
+C     raise an error immediately.
+C
+      CALL MUMPS_INT_SIZE_C(I8)
+      IF (int(I8) .NE. id%KEEP(34)) THEN
+        id%INFO(1)=-69
+        id%INFO(2)=int(I8) ! size of MUMPS_INT
+C       Installation problem!
+C       WRITE on unit 6 since ICNTL(1:4) are not set by the user yet
+        IF (id%MYID .EQ. 0) WRITE(6,995) int(I8)
+ 995    FORMAT(' Installation error -69: ',
+     &' MUMPS_INT size (',I4,') incompatible with INTEGER size')
+      ENDIF
       RETURN
       END SUBROUTINE ZMUMPS_INI_DRIVER
diff -pruN 5.6.2-2.1/src/zlr_core.F 5.7.1-1/src/zlr_core.F
--- 5.6.2-2.1/src/zlr_core.F	2023-10-11 09:37:10.000000000 +0000
+++ 5.7.1-1/src/zlr_core.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -41,8 +41,9 @@ C
       SUBROUTINE IS_FRONT_BLR_CANDIDATE(INODE, NIV, NFRONT, NASS, 
      &                    BLRON, K489,
      &                    K490, K491, K492, K20, K60, IDAD, K38,
-     &                    LRSTATUS, K280, LRGROUPS)
-        INTEGER,INTENT(IN) :: INODE, NFRONT, NASS, BLRON, K489, K490,
+     &                    K123, LRSTATUS, K280, LRGROUPS)
+        INTEGER,INTENT(IN) :: INODE, NFRONT, NASS, BLRON, K123,
+     &                        K489, K490,
      &                        K491, K492, NIV, K20, K60, IDAD, K38
         INTEGER,INTENT(OUT):: LRSTATUS 
         INTEGER, INTENT(IN):: K280
@@ -180,8 +181,9 @@ C
         ENDIF
       END SUBROUTINE ALLOC_LRB_FROM_ACC
       SUBROUTINE REGROUPING2(CUT, NPARTSASS, NASS,
-     &                   NPARTSCB, NCB, IBCKSZ, ONLYCB, K472)
-        INTEGER, INTENT(IN) :: IBCKSZ, NASS, NCB
+     &                   NPARTSCB, NCB, IBCKSZ, ONLYCB, K472, 
+     &                   NFRONT, KEEP)
+        INTEGER, INTENT(IN) :: IBCKSZ, NASS, NCB, NFRONT, KEEP(500)
         INTEGER, INTENT(INOUT) :: NPARTSCB, NPARTSASS
         INTEGER, POINTER, DIMENSION(:) :: CUT
         INTEGER, POINTER, DIMENSION(:) :: NEW_CUT
@@ -197,8 +199,9 @@ C
      &          ' not enough memory? memory requested = ' , IERROR
            RETURN
         ENDIF
-        CALL COMPUTE_BLR_VCS(K472, IBCKSZ2, IBCKSZ, NASS)
-        MINSIZE = int(IBCKSZ2 / 2)
+        CALL COMPUTE_BLR_VCS(K472, IBCKSZ2, IBCKSZ, NASS, 
+     &                       NFRONT, KEEP(35))
+        MINSIZE = int(IBCKSZ2 / 3)
         NEW_NPARTSASS = max(NPARTSASS,1)
         IF (.NOT. ONLYCB) THEN
            NEW_CUT(1) = 1
@@ -435,7 +438,6 @@ CC
      &                          Y_RRQR(:,:)
         INTEGER, ALLOCATABLE :: JPVT_RRQR(:)
         INTEGER :: allocok, MREQ
-        DOUBLE PRECISION, EXTERNAL ::dznrm2
         COMPLEX(kind=8) :: ONE, MONE, ZERO
         PARAMETER (ONE=(1.0D0,0.0D0), MONE=(-1.0D0,0.0D0))
         PARAMETER (ZERO=(0.0D0,0.0D0))
@@ -875,10 +877,10 @@ C     Alloc NOT ok!!
         INTEGER(8), INTENT(IN) :: POSELTT
         INTEGER,intent(in) :: MIDBLK_COMPRESS, KPERCENT_RMB
         DOUBLE PRECISION, intent(in) :: TOLEPS
-        DOUBLE PRECISION,    ALLOCATABLE :: RWORK_RRQR(:)
-        COMPLEX(kind=8), ALLOCATABLE :: WORK_RRQR(:), TAU_RRQR(:)
-        COMPLEX(kind=8), ALLOCATABLE, DIMENSION(:,:), TARGET :: Q1, R1, 
-     &                                                  Q2, R2
+        DOUBLE PRECISION,    ALLOCATABLE:: RWORK_RRQR(:)
+        COMPLEX(kind=8), ALLOCATABLE:: WORK_RRQR(:), TAU_RRQR(:)
+        COMPLEX(kind=8), ALLOCATABLE, DIMENSION(:,:),TARGET:: Q1, R1,
+     &                                                Q2, R2
         INTEGER, ALLOCATABLE :: JPVT_RRQR(:)
         TYPE(LRB_TYPE)       :: LRB1, LRB2
         INTEGER :: INFO, RANK1, RANK2, RANK, MAXRANK, LWORK
diff -pruN 5.6.2-2.1/src/zlr_stats.F 5.7.1-1/src/zlr_stats.F
--- 5.6.2-2.1/src/zlr_stats.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zlr_stats.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/zlr_type.F 5.7.1-1/src/zlr_type.F
--- 5.6.2-2.1/src/zlr_type.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zlr_type.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/zmumps_comm_buffer.F 5.7.1-1/src/zmumps_comm_buffer.F
--- 5.6.2-2.1/src/zmumps_comm_buffer.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/zmumps_comm_buffer.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -13,7 +13,7 @@ C  https://cecill.info/licences/Licence_
 C
         MODULE ZMUMPS_BUF
         PRIVATE
-        PUBLIC :: ZMUMPS_BUF_TRY_FREE_CB, ZMUMPS_BUF_INIT,
+        PUBLIC :: ZMUMPS_BUF_INIT,
      &   ZMUMPS_BUF_INI_MYID,
      &   ZMUMPS_BUF_ALLOC_CB ,       ZMUMPS_BUF_DEALL_CB ,
      &   ZMUMPS_BUF_ALLOC_SMALL_BUF, ZMUMPS_BUF_DEALL_SMALL_BUF,
@@ -52,34 +52,6 @@ C
      &       , SAVE, TARGET :: BUF_MAX_ARRAY
         PUBLIC :: BUF_LMAX_ARRAY, BUF_MAX_ARRAY
       CONTAINS
-        SUBROUTINE ZMUMPS_BUF_TRY_FREE_CB()
-        CALL ZMUMPS_BUF_TRY_FREE(BUF_CB)
-        RETURN
-        END SUBROUTINE ZMUMPS_BUF_TRY_FREE_CB
-        SUBROUTINE ZMUMPS_BUF_TRY_FREE(B)
-        IMPLICIT NONE
-        TYPE ( ZMUMPS_COMM_BUFFER_TYPE ) :: B
-        INCLUDE 'mpif.h'
-        LOGICAL :: FLAG
-        INTEGER :: IERR_MPI
-        INTEGER :: STATUS(MPI_STATUS_SIZE)
-        IF ( B%HEAD .NE. B%TAIL ) THEN
- 10       CONTINUE
-          CALL MPI_TEST( B%CONTENT( B%HEAD + REQ ), FLAG,
-     &                   STATUS, IERR_MPI )
-          IF ( FLAG ) THEN
-            B%HEAD = B%CONTENT( B%HEAD + NEXT )
-            IF ( B%HEAD .EQ. 0 ) B%HEAD = B%TAIL
-            IF ( B%HEAD .NE. B%TAIL ) GOTO 10
-          END IF
-        END IF
-        IF ( B%HEAD .EQ. B%TAIL ) THEN
-          B%HEAD = 1
-          B%TAIL = 1
-          B%ILASTMSG = 1
-        END iF
-        RETURN
-        END SUBROUTINE ZMUMPS_BUF_TRY_FREE
         SUBROUTINE ZMUMPS_BUF_INI_MYID( MYID )
         IMPLICIT NONE
         INTEGER MYID
@@ -319,7 +291,7 @@ C
           ENDIF
         ENDIF
         IF (NBROWS_PACKET + NBROWS_ALREADY_SENT.NE.LCONT .AND.
-     &     SIZE_PACK  .LT. SIZE_RBUF_BYTES / 4
+     &     SIZE_PACK  .LT. SIZE_RBUF_BYTES / 10
      &    .AND. 
      &    .NOT. RECV_BUF_SMALLER_THAN_SEND)
      &       THEN
@@ -499,16 +471,16 @@ C
         SUBROUTINE ZMUMPS_BUF_SEND_VCB( NRHS_B, NODE1, NODE2, NCB, LDW,
      &             LONG,
      &             IW, W, JBDEB, JBFIN,
-     &             RHSCOMP, NRHS, LRHSCOMP, IPOSINRHSCOMP, NPIV,
+     &             RHSINTR, NRHS, LRHSINTR, IPOSINRHSINTR, NPIV,
      &             KEEP,
      &             DEST, TAG, COMM, IERR )
         IMPLICIT NONE
         INTEGER LDW, DEST, TAG, COMM, IERR
         INTEGER NRHS_B, NODE1, NODE2, NCB, LONG, JBDEB, JBFIN
         INTEGER IW( max( 1, LONG ) )
-        INTEGER, INTENT(IN) :: LRHSCOMP, NRHS, IPOSINRHSCOMP, NPIV
+        INTEGER, INTENT(IN) :: LRHSINTR, NRHS, IPOSINRHSINTR, NPIV
         COMPLEX(kind=8) W( max( 1, LDW * NRHS_B ) )
-        COMPLEX(kind=8) RHSCOMP(LRHSCOMP,NRHS)
+        COMPLEX(kind=8) RHSINTR(LRHSINTR,NRHS)
         INTEGER, INTENT(INOUT) :: KEEP(500)
         INCLUDE 'mpif.h'
         INTEGER :: IERR_MPI
@@ -566,7 +538,7 @@ C
           IF (NODE2.EQ.0) THEN
             DO K=1, NRHS_B
               IF (NPIV.GT.0) THEN
-              CALL MPI_PACK( RHSCOMP(IPOSINRHSCOMP,JBDEB+K-1), NPIV,
+              CALL MPI_PACK( RHSINTR(IPOSINRHSINTR,JBDEB+K-1), NPIV,
      &                          MPI_DOUBLE_COMPLEX,
      &                          BUF_CB%CONTENT( IPOS ), SIZE,
      &                          POSITION, COMM, IERR_MPI )
@@ -653,14 +625,13 @@ C
         FLAG = ( B%HEAD == B%TAIL )
         RETURN
         END SUBROUTINE ZMUMPS_BUF_EMPTY
-        SUBROUTINE ZMUMPS_BUF_SIZE_AVAILABLE( B, SIZE_AV )
+        SUBROUTINE ZMUMPS_BUF_FREEREQUESTS( B )
         IMPLICIT NONE
         TYPE ( ZMUMPS_COMM_BUFFER_TYPE ) :: B
-        INTEGER SIZE_AV
         INCLUDE 'mpif.h'
-        INTEGER :: IERR_MPI
+        INTEGER :: IERR_MPI, CURRENT, LAST_NOT_FREE, LAST_NOT_FREE_TAIL
         INTEGER :: STATUS(MPI_STATUS_SIZE)
-        LOGICAL :: FLAG
+        LOGICAL :: FLAG, BROADCAST_NOT_FREE
         IF ( B%HEAD .NE. B%TAIL ) THEN
  10       CONTINUE
           CALL MPI_TEST( B%CONTENT( B%HEAD + REQ ), FLAG, STATUS,
@@ -669,6 +640,41 @@ C
             B%HEAD = B%CONTENT( B%HEAD + NEXT )
             IF ( B%HEAD .EQ. 0 ) B%HEAD = B%TAIL
             IF ( B%HEAD .NE. B%TAIL ) GOTO 10
+          ELSE
+            LAST_NOT_FREE = B%HEAD
+            CURRENT = B%CONTENT( LAST_NOT_FREE + NEXT )
+            LAST_NOT_FREE_TAIL = CURRENT
+            BROADCAST_NOT_FREE = B%CONTENT(LAST_NOT_FREE+NEXT).EQ.
+     &                              LAST_NOT_FREE+OVHSIZE 
+            DO WHILE ( CURRENT .NE. 0 )
+              IF (BROADCAST_NOT_FREE) THEN
+                FLAG = .FALSE.
+              ELSE
+                CALL MPI_TEST( B%CONTENT( CURRENT + REQ ), FLAG, STATUS,
+     &                       IERR_MPI )
+              ENDIF
+              IF (FLAG) THEN
+                CURRENT = B%CONTENT( CURRENT + NEXT )
+                B%CONTENT( LAST_NOT_FREE + NEXT ) = CURRENT
+              ELSE
+                LAST_NOT_FREE = CURRENT
+                CURRENT = B%CONTENT( CURRENT + NEXT )
+                IF ( CURRENT .NE. 0 ) THEN
+                  LAST_NOT_FREE_TAIL = CURRENT
+                ELSE
+                  LAST_NOT_FREE_TAIL = B%TAIL
+                ENDIF
+                BROADCAST_NOT_FREE = B%CONTENT(LAST_NOT_FREE+NEXT).EQ.
+     &                               LAST_NOT_FREE+OVHSIZE 
+              ENDIF
+            ENDDO
+            IF ( LAST_NOT_FREE_TAIL .NE. 0 ) THEN
+              B%TAIL = LAST_NOT_FREE_TAIL
+              B%ILASTMSG = LAST_NOT_FREE
+            ELSE IF (B%ILASTMSG .NE. LAST_NOT_FREE) THEN
+              WRITE(*,*) "ABORT", B%ILASTMSG, LAST_NOT_FREE
+              CALL MUMPS_ABORT()
+            ENDIF
           END IF
         END IF
         IF ( B%HEAD .EQ. B%TAIL ) THEN
@@ -676,86 +682,78 @@ C
           B%TAIL = 1
           B%ILASTMSG = 1
         END IF
+        RETURN
+        END SUBROUTINE ZMUMPS_BUF_FREEREQUESTS
+        SUBROUTINE ZMUMPS_BUF_SIZE_AVAILABLE( B, SIZE_AV, SIZE_AV2 )
+        IMPLICIT NONE
+        TYPE ( ZMUMPS_COMM_BUFFER_TYPE ) :: B
+        INTEGER, INTENT(OUT) :: SIZE_AV
+        INTEGER, OPTIONAL, INTENT(OUT) :: SIZE_AV2
+        CALL ZMUMPS_BUF_FREEREQUESTS( B )
         IF ( B%HEAD .LE. B%TAIL ) THEN
-           SIZE_AV = max( B%LBUF_INT - B%TAIL, B%HEAD - 2 )
+          SIZE_AV = max( B%LBUF_INT - B%TAIL, B%HEAD - 2 )
+          IF ( B%LBUF_INT - B%TAIL .GT. B%HEAD - 2 ) THEN
+            SIZE_AV  = B%LBUF_INT - B%TAIL
+            IF (present(SIZE_AV2)) SIZE_AV2 = 0
+          ELSE
+            SIZE_AV = B%HEAD - 2
+            IF (present(SIZE_AV2)) SIZE_AV2 = B%LBUF_INT - B%TAIL
+          ENDIF
         ELSE
-           SIZE_AV = B%HEAD - B%TAIL - 1
+          SIZE_AV  = B%HEAD - B%TAIL - 1
+          IF (present(SIZE_AV2)) SIZE_AV2 = 0
         END IF
-        SIZE_AV = min(SIZE_AV - OVHSIZE, SIZE_AV)
+        SIZE_AV = max(0,SIZE_AV - OVHSIZE)
         SIZE_AV = SIZE_AV * SIZEofINT
+        IF (present(SIZE_AV2)) THEN
+          IF (SIZE_AV2 .NE. 0) THEN
+            SIZE_AV = max(0,SIZE_AV2 - OVHSIZE)
+            SIZE_AV2 = SIZE_AV2 * SIZEofINT
+          ENDIF
+        ENDIF
         RETURN
         END SUBROUTINE ZMUMPS_BUF_SIZE_AVAILABLE
         SUBROUTINE ZMUMPS_BUF_TEST()
-        INTEGER :: IPOS, IREQ, IERR
-        INTEGER, PARAMETER :: IONE=1
-        INTEGER :: MSG_SIZE
-        INTEGER :: DEST2(1)
-        DEST2=-10
-        MSG_SIZE=1
-        CALL BUF_LOOK( BUF_CB, IPOS, IREQ, MSG_SIZE, IERR, 
-     &                 IONE , DEST2,.TRUE.)
+        CALL ZMUMPS_BUF_FREEREQUESTS(BUF_CB)
         RETURN
         END SUBROUTINE ZMUMPS_BUF_TEST
         SUBROUTINE BUF_LOOK( B, IPOS, IREQ, MSG_SIZE, IERR, 
-     &    NDEST , PDEST, TEST_ONLY)
+     &    NDEST , PDEST )
         IMPLICIT NONE
         TYPE ( ZMUMPS_COMM_BUFFER_TYPE ) :: B
         INTEGER, INTENT(IN)        :: MSG_SIZE
         INTEGER, INTENT(OUT)       :: IPOS, IREQ, IERR
-        LOGICAL, INTENT(IN), OPTIONAL :: TEST_ONLY
         INTEGER NDEST
         INTEGER, INTENT(IN)        :: PDEST(max(1,NDEST))
         INCLUDE 'mpif.h'
-        INTEGER :: IERR_MPI
         INTEGER :: MSG_SIZE_INT
         INTEGER :: IBUF
-        LOGICAL :: FLAG
-        INTEGER :: STATUS(MPI_STATUS_SIZE)
         IERR = 0
-        IF ( B%HEAD .NE. B%TAIL ) THEN
- 10       CONTINUE
-          CALL MPI_TEST( B%CONTENT( B%HEAD + REQ ), FLAG, STATUS,
-     &                   IERR_MPI )
-          IF ( FLAG ) THEN
-            B%HEAD = B%CONTENT( B%HEAD + NEXT )
-            IF ( B%HEAD .EQ. 0 ) B%HEAD = B%TAIL
-            IF ( B%HEAD .NE. B%TAIL ) GOTO 10
-          END IF
-        END IF
-        IF ( B%HEAD .EQ. B%TAIL ) THEN
-          B%HEAD = 1
-          B%TAIL = 1
-          B%ILASTMSG = 1
-        END iF
+        CALL ZMUMPS_BUF_FREEREQUESTS( B )
         MSG_SIZE_INT = ( MSG_SIZE + ( SIZEofINT - 1 ) ) / SIZEofINT
         MSG_SIZE_INT = MSG_SIZE_INT + OVHSIZE
-        IF (present(TEST_ONLY)) RETURN
-        FLAG = (     ( B%HEAD .LE. B%TAIL )
-     &               .AND. (
-     &                 ( MSG_SIZE_INT .LE. B%LBUF_INT - B%TAIL )
-     &                 .OR. ( MSG_SIZE_INT .LE. B%HEAD - 2 ) ) )
-     &         .OR.
-     &               ( ( B%HEAD .GT. B%TAIL )
-     &               .AND. ( MSG_SIZE_INT .LE. B%HEAD - B%TAIL - 1 ) )
-        IF ( .NOT. FLAG
-     &       ) THEN
-        IERR = -1
         IF ( MSG_SIZE_INT .GT. B%LBUF_INT - 1 ) THEN
-           IERR = -2
-        ENDIF
-        IPOS = -1
-        IREQ = -1
-        RETURN
-      END IF
+          IERR = -2
+          IPOS = -1
+          IREQ = -1
+          RETURN
+        END IF
         IF ( B%HEAD .LE. B%TAIL ) THEN
-          IF ( MSG_SIZE_INT .LE. B%LBUF_INT - B%TAIL + 1 ) THEN
+          IF ( MSG_SIZE_INT .LE. B%LBUF_INT - B%TAIL ) THEN
             IBUF = B%TAIL
-          ELSE IF ( MSG_SIZE_INT .LE. B%HEAD - 1 ) THEN
+          ELSE IF ( MSG_SIZE_INT .LE. B%HEAD - 2 ) THEN
             IBUF = 1
+          ELSE
+            IERR = -1
           END IF
         ELSE
-          IBUF = B%TAIL
+          IF ( MSG_SIZE_INT .LE . B%HEAD - B%TAIL - 1) THEN
+            IBUF = B%TAIL
+          ELSE
+            IERR = -1
+          ENDIF
         END IF
+        IF (IERR .LT. 0) RETURN
         B%CONTENT( B%ILASTMSG + NEXT ) = IBUF
         B%ILASTMSG = IBUF
         B%TAIL = IBUF + MSG_SIZE_INT
@@ -955,7 +953,7 @@ C
           ENDIF
         ENDIF
        IF (NBROWS_PACKET + NBROWS_ALREADY_SENT.NE.NROW .AND.
-     &   SIZE_PACK - SIZE1  .LT. ( SIZE_RBUF_BYTES - SIZE1 ) / 2
+     &   SIZE_PACK - SIZE1  .LT. ( SIZE_RBUF_BYTES - SIZE1 ) / 10
      &  .AND. 
      &   .NOT. RECV_BUF_SMALLER_THAN_SEND)
      &       THEN
@@ -1239,17 +1237,14 @@ C
                SIZE1 = SIZE1+SIZE0
           ENDIF
       ENDIF
-      IF (KEEP(50) .EQ. 0) THEN
-        ONEorTWO = 1
-      ELSE
-        ONEorTWO = 2
-      ENDIF
+      ONEorTWO = 1
       IF (PDEST .EQ.PDEST_MASTER) THEN
         L = 0
       ELSE IF (KEEP(50) .EQ. 0) THEN
         L = LROW
       ELSE
         L = LROW + PERM(1) - LMAP + NBROWS_ALREADY_SENT - 1
+        ONEorTWO=ONEorTWO+1
       ENDIF
       NBINT = 6 + L + 1 
       IF (CB_IS_LR.AND.NBROW.GT.0) THEN
@@ -1269,7 +1264,8 @@ C
      &       SIZE_AV / ( ONEorTWO*SIZEofINT+LROW*SIZEofREAL)
         ELSE
           B = 2 * ONEorTWO + 
-     &      ( 1 + 2 *  LROW + 2 * PERM(1) + 2 * NBROWS_ALREADY_SENT )
+     &      ( -1 + 2 *  LROW + 2 * PERM(1) -2*LMAP
+     &                                  + 2 * NBROWS_ALREADY_SENT )
      &      * SIZEofREAL / SIZEofINT
           NBROWS_PACKET=int((dble(-B)+sqrt((dble(B)*dble(B))+
      &        dble(4)*dble(2)*dble(SIZE_AV)/dble(SIZEofINT) *
@@ -1318,9 +1314,9 @@ C
           MAX_ROW_LENGTH = -99999
           SIZE_REALS = NBROWS_PACKET * LROW
         ELSE
-          SIZE_REALS = (  LROW + PERM(1) + NBROWS_ALREADY_SENT ) *
+          SIZE_REALS = ( LROW + PERM(1) - LMAP + NBROWS_ALREADY_SENT ) *
      &      NBROWS_PACKET + ( NBROWS_PACKET *
-     &     ( NBROWS_PACKET + 1) ) / 2
+     &     ( NBROWS_PACKET - 1) ) / 2
           MAX_ROW_LENGTH = LROW+PERM(1)-LMAP+NBROWS_ALREADY_SENT
      &                 + NBROWS_PACKET-1
         ENDIF
@@ -1346,7 +1342,7 @@ C
       ENDIF
         SIZE_PACK = SIZE1 + SIZE2 + SIZE3
         IF (NBROWS_PACKET + NBROWS_ALREADY_SENT.NE.NBROW .AND.
-     &       SIZE_PACK  .LT. SIZE_RBUF_BYTES / 4 .AND.
+     &       SIZE_PACK  .LT. SIZE_RBUF_BYTES / 10 .AND.
      &    .NOT. RECV_BUF_SMALLER_THAN_SEND .AND.
      &    .NOT. CB_IS_LR)
      &       THEN
@@ -1804,7 +1800,7 @@ C
      &             WIDTH, COMM,
      &             NELIM, NPARTSASS, CURRENT_BLR_PANEL, 
      &             LR_ACTIVATED, BLR_LorU,
-     &
+     &             ICNTL,
      &             IERR )
       USE ZMUMPS_LR_TYPE
       IMPLICIT NONE
@@ -1820,19 +1816,28 @@ C
         LOGICAL, intent(in) :: LR_ACTIVATED
         INTEGER, intent(in) :: NELIM, NPARTSASS, CURRENT_BLR_PANEL
         TYPE (LRB_TYPE), DIMENSION(:), intent(in) :: BLR_LorU
+        INTEGER, intent(in) :: ICNTL(60)
         INTEGER, intent(inout) :: IERR
         INCLUDE 'mpif.h'
         INCLUDE 'mumps_tags.h'
         INTEGER :: IERR_MPI
-        INTEGER POSITION, IREQ, IPOS, SIZE1, SIZE2, SIZE3, SIZET,
+        INTEGER POSITION, IREQ, IPOS, SIZE1, SIZE3, SIZET,
      &          IDEST, IPOSMSG, I
+        LOGICAL OVERFLOW
+        INTEGER(8) :: SIZE2_8, SIZE3_8, SIZET_8, SIZE_OVERFLOW
         INTEGER NPIVSENT
         INTEGER SSS
         INTEGER  :: NBMSGS
+        INTEGER :: LP
+        LOGICAL :: LPOK
         INTEGER :: LRELAY_INFO, DEST_BLOCFACTO, TAG_BLOCFACTO
         INTEGER :: LR_ACTIVATED_INT
+        LP  = ICNTL( 1 )
+        LPOK    = ( LP.GT.0 .AND. ICNTL(4).GE.1 )
         IERR = 0
         LRELAY_INFO = 0
+        OVERFLOW = .FALSE.
+        SIZE_OVERFLOW = 0_8
         NBMSGS = NDEST
         IF ( LASTBL ) THEN
           IF ( KEEP(50) .eq. 0 ) THEN
@@ -1855,28 +1860,56 @@ C
      &                          MPI_INTEGER, COMM, SIZE1, IERR_MPI )
           END IF
         END IF
-        SIZE2 = 0
+        SIZE2_8 = 0_8
         CALL MPI_PACK_SIZE( 4, MPI_INTEGER, COMM, SIZE3, IERR_MPI )
-        SIZE2=SIZE2+SIZE3
+        SIZE2_8=SIZE2_8+SIZE3
         IF ( KEEP(50).NE.0 ) THEN
           CALL MPI_PACK_SIZE( 1, MPI_INTEGER, COMM, SIZE3, IERR_MPI )
-          SIZE2=SIZE2+SIZE3
+          SIZE2_8=SIZE2_8+SIZE3
         ENDIF
         IF ((NPIV.GT.0)
      &     ) THEN
           IF (.NOT. LR_ACTIVATED) THEN
-            CALL MPI_PACK_SIZE( NPIV*NCOL, MPI_DOUBLE_COMPLEX,
+            SIZE3_8 = int(NPIV,8)*int(NCOL,8)*int(KEEP(35),8)
+            IF (SIZE3_8 .GT. int(huge(SIZE3),8))  THEN
+              OVERFLOW      = .TRUE.
+              SIZE_OVERFLOW = SIZE3_8
+            ELSE
+              CALL MPI_PACK_SIZE( NPIV*NCOL, 
+     &                      MPI_DOUBLE_COMPLEX,
      &                      COMM, SIZE3, IERR_MPI )
-            SIZE2 = SIZE2+SIZE3
+              SIZE2_8 = SIZE2_8 + int(SIZE3,8)
+            ENDIF
           ELSE
-            CALL MPI_PACK_SIZE( NPIV*(NPIV+NELIM), MPI_DOUBLE_COMPLEX,
+            SIZE3_8 = int(NPIV,8)*int(NPIV+NELIM,8)*int(KEEP(35),8)
+            IF (SIZE3_8 .GT. int(huge(SIZE3),8)) THEN
+              OVERFLOW = .TRUE.
+              SIZE_OVERFLOW = SIZE3_8
+            ELSE
+              CALL MPI_PACK_SIZE( NPIV*(NPIV+NELIM), 
+     &                      MPI_DOUBLE_COMPLEX,
      &                      COMM, SIZE3, IERR_MPI )
-            SIZE2 = SIZE2+SIZE3
-              CALL MUMPS_MPI_PACK_SIZE_LR( BLR_LorU, SIZE3, COMM, IERR )
-            SIZE2 = SIZE2+SIZE3
-          ENDIF
+              SIZE2_8 = SIZE2_8+SIZE3
+            ENDIF
+              CALL MUMPS_MPI_PACK_SIZE_LR( BLR_LorU, SIZE3_8, 
+     &                                     COMM, IERR )
+            SIZE2_8 = SIZE2_8+SIZE3_8
+          ENDIF
+        ENDIF
+        SIZET_8 = int(SIZE1,8) + SIZE2_8
+        IF (SIZET_8 .GT. int(huge(SIZE3),8)) THEN
+              OVERFLOW      = .TRUE.
+              SIZE_OVERFLOW = SIZET_8
+        ENDIF
+        IF (OVERFLOW) THEN
+          IERR=-3
+          IF (LPOK) WRITE(LP,*)
+     & "Integer overflow message inZMUMPS_BUF_SEND_BLOCFACTO",
+     & "SIZE_OVERFLOW,NPIV,NFRONT,NELIM=",
+     &  SIZE_OVERFLOW, NPIV, NFRONT, NELIM
+          RETURN
         ENDIF
-        SIZET = SIZE1 + SIZE2 
+        SIZET = int(SIZET_8)
         IF (SIZET.GT.SIZE_RBUF_BYTES) THEN
           SSS = 0 
           IF ( LASTBL ) THEN
@@ -1896,7 +1929,7 @@ C
      &                        MPI_INTEGER, COMM, SSS, IERR_MPI )
            END IF
           END IF
-          SSS = SSS + SIZE2  
+          SSS = SSS + int(SIZE2_8)  
           IF (SSS.GT.SIZE_RBUF_BYTES) THEN
            IERR = -3 
             RETURN
@@ -2043,30 +2076,50 @@ C
         INCLUDE 'mumps_tags.h'
         INTEGER :: IERR_MPI
         INTEGER LR_ACTIVATED_INT
-        INTEGER POSITION, IREQ, IPOS, SIZE1, SIZE2, SIZET,
+        INTEGER POSITION, IREQ, IPOS, SIZE1, SIZET,
      &          IDEST, IPOSMSG, SSS, SSLR
-        IERR = 0
+        INTEGER(8) :: SIZE2_8, SSLR_8, SIZET_8, SIZE_OVERFLOW
+        LOGICAL    :: OVERFLOW
+        IERR          = 0
+        OVERFLOW      = .FALSE.
+        SIZE_OVERFLOW = 0_8
         CALL MPI_PACK_SIZE( 6 + ( NDEST - 1 ) * OVHSIZE,
      &                      MPI_INTEGER, COMM, SIZE1, IERR_MPI )
-        SIZE2  = 0
+        SIZE2_8  = 0_8
         CALL MPI_PACK_SIZE(2, MPI_INTEGER, COMM, SSLR, IERR_MPI )
-        SIZE2=SIZE2+SSLR
+        SIZE2_8 = SIZE2_8 + SSLR
         IF (.NOT. LR_ACTIVATED) THEN
-        CALL MPI_PACK_SIZE( abs(NPIV)*NCOLU, MPI_DOUBLE_COMPLEX,
+          SSLR_8 = int(abs(NPIV),8)*int(NCOLU,8)
+          IF (SSLR_8 .GT. int(huge(SSLR),8))  THEN
+              OVERFLOW      = .TRUE.
+              SIZE_OVERFLOW = SSLR_8
+          ELSE
+           CALL MPI_PACK_SIZE( abs(NPIV)*NCOLU, 
+     &                      MPI_DOUBLE_COMPLEX,
      &                      COMM, SSLR, IERR_MPI )
-         SIZE2=SIZE2+SSLR
+           SIZE2_8=SIZE2_8 + int(SSLR,8)
+          ENDIF
         ELSE
-          CALL MUMPS_MPI_PACK_SIZE_LR( BLR_LS, SSLR, COMM, IERR )
-          SIZE2=SIZE2+SSLR
+          CALL MUMPS_MPI_PACK_SIZE_LR( BLR_LS, SSLR_8, COMM, IERR )
+          SIZE2_8=SIZE2_8 + SSLR_8
+        ENDIF
+        SIZET_8 = int(SIZE1,8) + SIZE2_8
+        IF (SIZET_8 .GT. int(huge(SSLR),8)) THEN
+              OVERFLOW      = .TRUE.
+              SIZE_OVERFLOW = SIZET_8
         ENDIF
-        SIZET = SIZE1 + SIZE2
+        IF (OVERFLOW) THEN
+          IERR=-3
+          RETURN
+        ENDIF
+        SIZET = int(SIZET_8)
         IF (SIZET.GT.SIZE_RBUF_BYTES) THEN
          CALL MPI_PACK_SIZE( 6 ,
      &                      MPI_INTEGER, COMM, SSS, IERR_MPI )
-         SSS = SSS+SIZE2
-         IF (SSS.GT.SIZE_RBUF_BYTES) THEN
+         SIZE2_8 = int(SSS,8)+SIZE2_8
+         IF (int(SIZE2_8).GT.SIZE_RBUF_BYTES) THEN
            IERR = -2
-      RETURN
+           RETURN
          ENDIF
         END IF
         CALL BUF_LOOK( BUF_CB, IPOS, IREQ, SIZET, IERR, 
@@ -2254,7 +2307,7 @@ C
           ENDIF
           IF (N_PACKET + N_ALREADY_SENT .NE. NSUBSET_ROW - NSUPROW
      &         .AND.
-     &         SIZE_PACK .LT. SIZE_RBUF_BYTES / 4
+     &         SIZE_PACK .LT. SIZE_RBUF_BYTES / 10
      &         .AND. .NOT. RECV_BUF_SMALLER_THAN_SEND)
      &         THEN
              IERR = -1
@@ -2797,11 +2850,11 @@ C
      &             ( WHAT, COMM, NPROCS, 
      &               FUTURE_NIV2,
      &               LOAD, UPD_LOAD,
-     &               MYID, KEEP, IERR)
+     &               MYID, KEEP267, IERR)
         IMPLICIT NONE
         INTEGER COMM, NPROCS, MYID, IERR, WHAT
         DOUBLE PRECISION LOAD,UPD_LOAD
-        INTEGER, INTENT(INOUT) :: KEEP(500)
+        INTEGER, INTENT(INOUT) :: KEEP267
         INCLUDE 'mpif.h'
         INCLUDE 'mumps_tags.h'
         INTEGER :: IERR_MPI
@@ -2870,7 +2923,7 @@ C
         DO I = 0, NPROCS - 1
           IF ( I .NE. MYID .AND. FUTURE_NIV2(I+1) .NE. 0) THEN
             IDEST = IDEST + 1
-            KEEP(267)=KEEP(267)+1
+            KEEP267 = KEEP267 + 1
             CALL MPI_ISEND( BUF_LOAD%CONTENT( IPOSMSG ),
      &                      POSITION, MPI_PACKED, I,
      &                      UPDATE_LOAD, COMM,
@@ -2913,7 +2966,7 @@ C
      &          MPI_INTEGER, COMM,
      &          SIZE, IERR_MPI )
         ELSE
-           CALL MPI_PACK_SIZE( 2 + OVHSIZE, 
+           CALL MPI_PACK_SIZE( 2, 
      &          MPI_INTEGER, COMM,
      &          SIZE, IERR_MPI )
         ENDIF
@@ -3153,22 +3206,23 @@ C
         SIZE_RBUF_BYTES = ZMUMPS_LBUFR_BYTES
         RETURN
       END SUBROUTINE ZMUMPS_BUF_DIST_IRECV_SIZE
-      SUBROUTINE MUMPS_MPI_PACK_SIZE_LR( BLR_LorU, SIZE_OUT, COMM,
+      SUBROUTINE MUMPS_MPI_PACK_SIZE_LR( BLR_LorU, SIZE_OUT8, COMM,
      &                                   IERR )
       USE ZMUMPS_LR_TYPE
-      INTEGER, intent(out) :: SIZE_OUT, IERR
+      INTEGER, intent(out)     :: IERR
+      INTEGER(8), intent(out)  :: SIZE_OUT8
       INTEGER, intent(in)  :: COMM
       TYPE (LRB_TYPE), DIMENSION(:), intent(in) :: BLR_LorU
-      INTEGER :: I, SIZE_LOC, IERR_MPI
+      INTEGER     :: I, SIZE_LOC, IERR_MPI
       INCLUDE 'mpif.h'
-        IERR = 0
-        SIZE_OUT = 0
+        IERR      = 0
+        SIZE_OUT8 = 0_8
         CALL MPI_PACK_SIZE( 1, MPI_INTEGER, COMM, SIZE_LOC,  IERR_MPI )
-        SIZE_OUT = SIZE_OUT + SIZE_LOC
+        SIZE_OUT8 = SIZE_OUT8 + SIZE_LOC
         DO I = 1, size(BLR_LorU)
           CALL MUMPS_MPI_PACK_SIZE_LRB(BLR_LorU(I), SIZE_LOC, COMM, 
      &                                 IERR )
-          SIZE_OUT = SIZE_OUT + SIZE_LOC
+          SIZE_OUT8 = SIZE_OUT8 + SIZE_LOC
         ENDDO
         RETURN
       END SUBROUTINE MUMPS_MPI_PACK_SIZE_LR
diff -pruN 5.6.2-2.1/src/zmumps_config_file.F 5.7.1-1/src/zmumps_config_file.F
--- 5.6.2-2.1/src/zmumps_config_file.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zmumps_config_file.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/zmumps_driver.F 5.7.1-1/src/zmumps_driver.F
--- 5.6.2-2.1/src/zmumps_driver.F	2023-10-11 09:37:10.000000000 +0000
+++ 5.7.1-1/src/zmumps_driver.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -21,7 +21,9 @@ C
       USE MUMPS_MEMORY_MOD
       USE ZMUMPS_STRUC_DEF
       USE ZMUMPS_STATIC_PTR_M ! For Schur pointer
+#if ! defined(NO_SAVE_RESTORE)
       USE ZMUMPS_SAVE_RESTORE
+#endif
 C      
 !$    USE OMP_LIB
 C
@@ -345,6 +347,14 @@ C
 * Values 4, 5, 6 for the parameter JOB can invoke combinations
 * of the three basic operations corresponding to JOB=1, 2 or 3.
 * 
+* JOB = -4 : frees all data structures from the factorization
+* while keeping data structures from the analysis. Can be
+* followed by a JOB = 2 call.
+*
+#if ! defined(NO_SAVE_RESTORE)
+* JOB = -3, 7, 8 : save and restore feature, see userguide
+#endif
+* JOB = 9 : provide suggested data distribution for IRHS_LOC
 C
 *********
 C     --------------------------------------
@@ -584,7 +594,7 @@ C
 !$    INTEGER NOMP, NOMPMIN, NOMPMAX
       INTEGER I, J, MP, LP, MPG, KEEP235SAVE, KEEP242SAVE,
      &        KEEP243SAVE, KEEP495SAVE, KEEP497SAVE,
-     &        KEEP77SAVE, KEEP83SAVE, KEEP91SAVE
+     &        KEEP77SAVE, KEEP78SAVE, KEEP83SAVE, KEEP91SAVE
       INTEGER(8) :: I8
       LOGICAL LANA, LFACTO, LSOLVE, PROK, LPOK, FLAG, PROKG
       LOGICAL NOERRORBEFOREPERM
@@ -599,7 +609,9 @@ C     Local copy of JOB
       INTEGER, DIMENSION(:), ALLOCATABLE :: UNS_PERM_INV
 C     TIMINGS
       DOUBLE PRECISION TIMEG, TIMETOTAL
+#if ! defined(NO_SAVE_RESTORE)
       INTEGER(8) :: FILE_SIZE,STRUC_SIZE
+#endif
       INTEGER:: ICNTL16_LOC
 !$    INTEGER:: PREVIOUS_OMP_THREADS_NUM
       IF (id%JOB .EQ. -200) THEN
@@ -613,12 +625,14 @@ C       JOB=-200 to just suppress the ex
 C       before terminating the application and killing all
 C       processes. No checks are performed in this case,
 C       data is not freed and MPI should not be called
-C       (since MPI might no longer work)
+C       (since MPI might no longer work). In particular, there is
+C       no check that the value of JOB is the same on all the
+C       calling MPI processes.
         CALL ZMUMPS_OOC_CLEAN_FILES(id,IERR)
         RETURN
       ENDIF
       NOERRORBEFOREPERM = .FALSE.
-      UNS_PERM_DONE = .FALSE.
+      UNS_PERM_DONE     = .FALSE.
       LANA  = .FALSE.
       LFACTO = .FALSE.
       LSOLVE = .FALSE.
@@ -627,6 +641,14 @@ C
 C     Initialize error return codes to 0.
       id%INFO(1) = 0
       id%INFO(2) = 0
+C
+C     Default setting for printing, before ICNTL(1:4) are initialized
+      LP = 6
+      MP = 0
+      MPG = 0
+      LPOK  = .TRUE.
+      PROK  = .FALSE.
+      PROKG = .FALSE.
 C     -----------------------------------
 C     Check that MPI has been initialized
 C     -----------------------------------
@@ -636,7 +658,9 @@ C     ----------------------------------
         id%INFO(2) =   0
         id%INFOG(1) = -23
         id%INFOG(2) =   0
-        WRITE(6,990)
+C       JOB=-1: LPOK is true and LP=6 (see
+C       above) because not set yet by the user
+        IF (LPOK) WRITE(LP,990)
  990  FORMAT(' Unrecoverable Error in ZMUMPS initialization: ',
      &       ' MPI is not running.')
         RETURN               
@@ -646,16 +670,8 @@ C     Duplicate user communicator
 C     to avoid communications not
 C     related to ZMUMPS
 C     ---------------------------
-       COMM_SAVE = id%COMM
-       CALL MPI_COMM_DUP( COMM_SAVE, id%COMM, IERR )
-C
-C     Default setting for printing
-      LP = 6
-      MP = 0
-      MPG = 0
-      LPOK  = .TRUE.
-      PROK  = .FALSE.
-      PROKG = .FALSE.
+      COMM_SAVE = id%COMM
+      CALL MPI_COMM_DUP( COMM_SAVE, id%COMM, IERR )
       ICNTL16_LOC = 0
 C     -------------------------
 C     Check if value of JOB is
@@ -673,7 +689,11 @@ C     -------------------------
 C   
 C     Check value of JOB and previous value of JOB
 C
+#if ! defined(NO_SAVE_RESTORE)
       IF ((JOB.LT.-3.OR.JOB.EQ.0.OR.JOB.GT.8)
+#else
+      IF ((JOB.LT.-2.OR.JOB.EQ.0.OR.JOB.GT.6) 
+#endif
      &    .AND. JOB.NE.9
      &    .AND. JOB.NE.-4
      &  ) THEN
@@ -695,6 +715,7 @@ C      Warning: non initialized value
         GOTO 499
        END IF
       END IF
+#if ! defined(NO_SAVE_RESTORE)
       IF(JOB.NE.-1) THEN
 C     Always allow JOB=-1
          IF((JOB.GT.-2).AND.(id%KEEP(140).EQ.1)) then
@@ -705,6 +726,7 @@ C     are -2 or -3
             GOTO 499
          END IF
       ENDIF
+#endif
 C     ----------------------------------
 C     Initialize, LANA, LFACTO, LSOLVE
 C     LANA indicates if analysis must be performed
@@ -730,6 +752,7 @@ C       Value defined on MASTER is the r
      &         IERR )
         IF (LANA) THEN
            KEEP77SAVE = id%KEEP(77)
+           KEEP78SAVE = id%KEEP(78)
            KEEP83SAVE = id%KEEP(83)
            KEEP91SAVE = id%KEEP(91)
            id%KEEP(198) = 0
@@ -786,9 +809,11 @@ C       and factorization:
       ENDIF
 C
       IF (JOB.EQ.-2.OR.JOB.EQ.1.OR.JOB.EQ.2.OR.JOB.EQ.3.OR.
-     &    JOB.EQ.4.OR.JOB.EQ.5.OR.JOB.EQ.6
+     &    JOB.EQ.4.OR.JOB.EQ.5.OR.JOB.EQ.6.OR.JOB.EQ.-4
+#if ! defined(NO_SAVE_RESTORE)
      &     .OR.JOB.EQ.7.OR.JOB.EQ.8.OR.JOB.EQ.-3
-     *     .OR. JOB.EQ.9 ! LATER .OR.JOB.EQ.10
+#endif
+     &     .OR. JOB.EQ.9 
      &     ) THEN
 C       Value of JOB is correct and differnet from -1
 C       ICNTL should have been initialized and can be used
@@ -803,6 +828,10 @@ C       ICNTL should have been initializ
           FROM_C_INTERFACE_STRING=" from C interface"
         ELSE
           FROM_C_INTERFACE_STRING=" "
+C         and KEEP8(83) to the ddress of ICNTL(50)
+C         Set KEEP8(84) to the address of RINFO(3)
+          CALL MUMPS_ADDR_C( id%ICNTL(50), id%KEEP8(83) )
+          CALL MUMPS_ADDR_C( id%RINFO (3), id%KEEP8(84) )
         ENDIF
 C       -----------------------------
 C       Set the number of threads if required.
@@ -832,10 +861,14 @@ C       -----------------------------
         IF (PROKG) THEN
 C          Print basic information on MUMPS call
            IF (JOB .EQ. -2
+#            if ! defined(NO_SAVE_RESTORE)
      &       .OR. JOB .EQ. 8
+#            endif
      &       ) THEN
 C            N, NELT, NNZ not meaningful
+#            if ! defined(NO_SAVE_RESTORE)
 C            or not defined yet (JOB=8).
+#            endif
              WRITE(MPG,'(/A,A,A,A,I4)') 
      &               'Entering ZMUMPS ',
      &               trim(adjustl(id%VERSION_NUMBER)),
@@ -885,11 +918,6 @@ C          MPI and OpenMP information
 99996       FORMAT(/'Advanced settings:'/
      &       '   KEEP(370) Static mapping              =',I10/
      &       '   KEEP(371) Advanced optimizations      =',I10)
-            IF (id%KEEP(401) .GE. 1) THEN
-              WRITE(MPG, 99997) id%KEEP(401)
-            ENDIF
-99997       FORMAT('L0 thread based multithreading setting:'/
-     &       '   KEEP(401) (>=1 : ON)                  =',I10)
             WRITE(MPG, '(A)')
           ENDIF
         ENDIF
@@ -908,18 +936,18 @@ C
 C       ------------------------------------------
 C       Check that we have called (JOB=-2), ie
 C       that the previous JOB is not 1 2 or 3,
+C       or even -1
 C       before calling the initialization routine.
 C       --------------------------------------------
         id%INFO(1)=0
         id%INFO(2)=0
         OLDJOB = id%KEEP( 40 ) + 456789
-        IF ( OLDJOB .EQ. 1 .OR.
+        IF ( OLDJOB .EQ. -1 .OR.
+     &       OLDJOB .EQ. 1 .OR.
      &       OLDJOB .EQ. 2 .OR.
      &       OLDJOB .EQ. 3  ) THEN
-          IF ( id%N > 0 ) THEN
            id%INFO(1)=-3
            id%INFO(2)=JOB
-          ENDIF
         ENDIF
 C       Initialize id%MYID now because it is
 C       required by MUMPS_PROPINFO. id%MYID
@@ -976,6 +1004,7 @@ C
         id%DKEEP(70)=0.0D0
         CALL MUMPS_SECDEB(TIMETOTAL)
       ENDIF
+#if ! defined(NO_SAVE_RESTORE)
 C
 C----------------------------------------------------------------
 C
@@ -1046,6 +1075,7 @@ C
         IF ( id%INFO(1) .LT. 0 ) GOTO 499
         GOTO 500
       ENDIF
+#endif
 C----------------------------------------------------------------
 C
 C     JOB =  9 : fill IRHS_loc
@@ -1076,11 +1106,13 @@ C       Allowed if last factorization fa
           CALL ZMUMPS_FREE_DATA_FACTO(id)
 C         Reset last successful phase
           OLDJOB=min(OLDJOB, 1)
+          id%KEEP(40) = OLDJOB - 456789
         ENDIF
         IF ( id%INFO(1) .LT .0 ) GOTO 499
         GOTO 500
       ENDIF
 C
+C
 C----------------------------------------------------------------
 C
 C     MAIN DRIVER
@@ -1168,7 +1200,6 @@ C      refinement and error analysis)
 C     ------------------------------------------
 #if ! defined (LARGEMATRICES)
       NOERRORBEFOREPERM =.TRUE.
-      UNS_PERM_DONE=.FALSE.
       IF (id%MYID .eq. MASTER .AND. id%KEEP(23) .NE. 0) THEN
         IF ( id%JOB .EQ. 2 .OR. id%JOB .EQ. 5 .OR.
      &       (id%JOB .EQ. 3 .AND. (id%ICNTL(10) .NE.0 .OR.
@@ -1238,10 +1269,10 @@ C       ----------------------------
 C
         IF (id%MYID.EQ.MASTER) THEN
 C         Check N, [N]NZ, NELT
-          IF ((id%N.LE.0).OR.((id%N+id%N+id%N)/3.NE.id%N)) THEN
-             id%INFO(1) = -16
-             id%INFO(2) = id%N
-             GOTO 100
+          IF (id%N.LE.0) THEN
+            id%INFO(1) = -16
+            id%INFO(2) = id%N
+            GOTO 100
           END IF
           IF (id%ICNTL(5).NE.1) THEN
 C           Assembled input
@@ -1419,8 +1450,27 @@ C       ANALYSIS PHASE:
         CALL ZMUMPS_ANA_DRIVER( id )
 C       restore values
         id%KEEP(77) =  KEEP77SAVE 
+        id%KEEP(78) =  KEEP78SAVE 
         id%KEEP(83) =  KEEP83SAVE
         id%KEEP(91) =  KEEP91SAVE
+#if ! defined(LARGEMATRICES)
+        IF (id%MYID .eq. MASTER .AND. id%KEEP(23) .NE. 0) THEN
+         IF (.not.associated(id%UNS_PERM)) THEN
+C         I may happen 
+C           (for ex in case of error -7 during analysis:
+C           UNS_PERM can be not associated, 
+C           KEEP(23) was set to to automatic choice(=7) and
+C           an error of memory allocation occurs during analysis
+C           before having decided value of KEEP(23))
+C         UNS_PERM not associated and KEEP(23).NE.0
+C         Permuting JCN back does not make sense and KEEP(23) 
+C         should be reset to zero
+          id%KEEP(23) = 0
+         ELSE
+          UNS_PERM_DONE = .TRUE.
+         ENDIF
+        ENDIF
+#endif
 C
 C Check and save scaling option in INFOG(33)
         IF (id%MYID .eq. MASTER) THEN
@@ -1482,6 +1532,7 @@ C
 C-
 C-------------------------------------------------------
       IF ( LFACTO ) THEN
+C{
          IF (id%MYID .eq. MASTER) THEN
             id%DKEEP(91)=0.0D0
             CALL MUMPS_SECDEB(TIMEG)
@@ -1794,14 +1845,19 @@ C
              CALL ZMUMPS_CHECK_DENSE_RHS
      &       (id%RHS,id%INFO,id%N,id%NRHS,id%LRHS)
 C            Sets KEEP(221) and do some checks
-             CALL ZMUMPS_SET_K221(id)
-             CALL ZMUMPS_CHECK_REDRHS(id)
+C            in case of Schur check if reduced RHS 
+C            requested
+              CALL ZMUMPS_SET_K221(id,.FALSE.)
+             CALL ZMUMPS_CHECK_K221andREDRHS(id)
           ENDIF
  200      CONTINUE
         END IF        ! End of IF (MYID .eq. MASTER)
 C       KEEP(221) was set in ZMUMPS_SET_K221 but not broadcast
         CALL MPI_BCAST( id%KEEP(221), 1, MPI_INTEGER, MASTER, id%COMM,
      &       IERR )
+C       broadcast RR option 
+        CALL MPI_BCAST( id%KEEP(19), 1, MPI_INTEGER, MASTER, id%COMM,
+     &       IERR )
 C
 C       Check distributed matrices on all processors.
         I_AM_SLAVE = ( id%MYID .ne. MASTER  .OR.
@@ -1969,6 +2025,7 @@ C
 C       Update last successful step
 C
         id%KEEP(40) = 2 - 456789
+C}
       END IF
 C-------------------------------------------------------
 C-
@@ -2082,26 +2139,13 @@ C       done (no iterative refinement/
 C       error analysis), then we do not
 C       permute JCN back.
 C       -------------------------------
-        IF (id%JOB .NE. 3 .OR. UNS_PERM_DONE) THEN
-         IF (.not.associated(id%UNS_PERM)) THEN
-C         I may happen 
-C           (for ex in case of error -7 during analysis:
-C           UNS_PERM can be not associated, 
-C           KEEP(23) was set to to automatic choice(=7) and
-C           an error of memory allocation occurs during analysis
-C           before having decided value of KEEP(23))
-C         UNS_PERM not associated and KEEP(23).NE.0
-C         Permuting JCN back does not make sense and KEEP(23) 
-C         should be reset to zero
-          id%KEEP(23) = 0
-         ELSE
+        IF (UNS_PERM_DONE) THEN
            DO I8 = 1_8, id%KEEP8(28)
             J=id%JCN(I8)
 C           -- skip out-of range (that are ignored in ANA_O)
             IF (J.LE.0.OR.J.GT.id%N) CYCLE
             id%JCN(I8)=id%UNS_PERM(J)
            END DO
-          ENDIF
         END IF
       END IF
 #endif
@@ -2131,6 +2175,7 @@ C     the next time MUMPS is entered thr
 C     ------------------------------------------------------------
       NULLIFY(id%SCHUR_CINTERFACE)
 C
+#if ! defined(NO_SAVE_RESTORE)
 *=======================
 * Compute space for save
 *=======================
@@ -2147,6 +2192,7 @@ C
          id%RINFOG(17)=dble(id%KEEP8(57))/1D6
          id%RINFOG(18)=dble(id%KEEP8(58))/1D6
       ENDIF
+#endif
 !$    IF (ICNTL16_LOC .GT. 0) THEN
 #if defined(WORKAROUNDINTELILP64OPENMPLIMITATION)
 !$      CALL omp_set_num_threads(int(PREVIOUS_OMP_THREADS_NUM,4))
@@ -2168,8 +2214,8 @@ C
 C     -------------------------
 C     Restore user communicator
 C     -------------------------
-       CALL MPI_COMM_FREE( id%COMM, IERR )
-       id%COMM = COMM_SAVE
+      CALL MPI_COMM_FREE( id%COMM, IERR )
+      id%COMM = COMM_SAVE
       RETURN
 *
 99995 FORMAT (' ** ERROR RETURN ** FROM ZMUMPS INFO(1)=', I5)
@@ -2242,7 +2288,7 @@ C        INFOG(2) = MYID
         CALL MPI_BCAST( INFOG(2), 1, MPI_INTEGER, ROOT, COMM, IERR )
       END IF
 C
-C    Make INFOG available on all procs:
+C     Make INFOG available on all procs:
 C
       CALL MPI_BCAST(INFOG(3), SIZE_INFOG-2, MPI_INTEGER,
      &               MASTER, COMM, IERR )
@@ -2279,12 +2325,12 @@ C---------------------------------------
             WRITE (LP,991) ICNTL(5),ICNTL(6),ICNTL(7),ICNTL(12),
      &          ICNTL(13),
      &          ICNTL(15),
-     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(58)
+     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(48),ICNTL(58)
            ELSE
             WRITE (LP,891) ICNTL(5),ICNTL(6),ICNTL(7),
      &          ICNTL(13),
      &          ICNTL(15),
-     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(58)
+     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(48),ICNTL(58)
            ENDIF
            IF ((ICNTL(6).EQ.5).OR.(ICNTL(6).EQ.6).OR.
      &          (ICNTL(12).NE.1) )  THEN
@@ -2293,6 +2339,7 @@ C---------------------------------------
            IF (id%ICNTL(19).NE.0)
      &      WRITE(LP,998) id%SIZE_SCHUR
            WRITE (LP,993) ICNTL(14)
+           WRITE (LP,996) ICNTL(56)
          CASE(2);
            WRITE (LP,980) 
            WRITE (LP,981) CNTL(1), CNTL(3), CNTL(4), CNTL(5), CNTL(7)
@@ -2301,21 +2348,34 @@ C---------------------------------------
            WRITE (LP,993) ICNTL(14) 
            WRITE (LP,923) ICNTL(24), ICNTL(31), ICNTL(32), ICNTL(33),
      &                    ICNTL(35), ICNTL(36), ICNTL(49)
+           WRITE (LP,996) ICNTL(56)
          CASE(3);
            WRITE (LP,980)
            WRITE (LP,990) ICNTL(1),ICNTL(2),ICNTL(3),ICNTL(4)
            WRITE (LP,995)
-     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21)
+     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21),ICNTL(26)
          CASE(4);
            WRITE (LP,980) 
            WRITE (LP,981) CNTL(1), CNTL(3), CNTL(4), CNTL(5), CNTL(7)
            WRITE (LP,990) ICNTL(1),ICNTL(2),ICNTL(3),ICNTL(4)
+           IF (id%SYM.EQ.2) THEN
+            WRITE (LP,991) ICNTL(5),ICNTL(6),ICNTL(7),ICNTL(12),
+     &          ICNTL(13),
+     &          ICNTL(15),
+     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(48),ICNTL(58)
+           ELSE
+            WRITE (LP,891) ICNTL(5),ICNTL(6),ICNTL(7),
+     &          ICNTL(13),
+     &          ICNTL(15),
+     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(48),ICNTL(58)
+           ENDIF
            WRITE (LP,992) ICNTL(8)
            IF (id%ICNTL(19).NE.0)
      &      WRITE(LP,998) id%SIZE_SCHUR
            WRITE (LP,993) ICNTL(14)
            WRITE (LP,923) ICNTL(24), ICNTL(31), ICNTL(32), ICNTL(33),
      &                    ICNTL(35), ICNTL(36), ICNTL(49)
+           WRITE (LP,996) ICNTL(56)
          CASE(5);
            WRITE (LP,980) 
            WRITE (LP,981) CNTL(1), CNTL(3), CNTL(4), CNTL(5), CNTL(7)
@@ -2324,19 +2384,20 @@ C---------------------------------------
             WRITE (LP,991) ICNTL(5),ICNTL(6),ICNTL(7),ICNTL(12),
      &          ICNTL(13),
      &          ICNTL(15),
-     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(58)
+     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(48),ICNTL(58)
            ELSE
             WRITE (LP,891) ICNTL(5),ICNTL(6),ICNTL(7),
      &          ICNTL(13),
      &          ICNTL(15),
-     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(58)
+     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(48),ICNTL(58)
            ENDIF
            WRITE (LP,992) ICNTL(8)
            WRITE (LP,993) ICNTL(14)
            WRITE (LP,995)
-     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21)
+     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21),ICNTL(26)
            WRITE (LP,923) ICNTL(24), ICNTL(31), ICNTL(32), ICNTL(33),
      &                    ICNTL(35), ICNTL(36), ICNTL(49)
+           WRITE (LP,996) ICNTL(56)
          CASE(6);
            WRITE (LP,980)
            WRITE (LP,981) CNTL(1), CNTL(3), CNTL(4), CNTL(5), CNTL(7)
@@ -2345,27 +2406,28 @@ C---------------------------------------
             WRITE (LP,991) ICNTL(5),ICNTL(6),ICNTL(7),ICNTL(12),
      &          ICNTL(13),
      &          ICNTL(15),
-     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(58)
+     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(48),ICNTL(58)
            ELSE
             WRITE (LP,891) ICNTL(5),ICNTL(6),ICNTL(7),
      &          ICNTL(13),
      &          ICNTL(15),
-     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(58)
+     &          ICNTL(18),ICNTL(19),ICNTL(22),ICNTL(48),ICNTL(58)
            ENDIF
            IF (id%ICNTL(19).NE.0)
      &      WRITE(LP,998) id%SIZE_SCHUR
            WRITE (LP,992) ICNTL(8)
            WRITE (LP,995)
-     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21)
+     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21), ICNTL(26)
            WRITE (LP,993) ICNTL(14)
            WRITE (LP,923) ICNTL(24), ICNTL(31), ICNTL(32), ICNTL(33),
      &                    ICNTL(35), ICNTL(36), ICNTL(49)
+           WRITE (LP,996) ICNTL(56)
         END SELECT
       ENDIF
  980  FORMAT (/'***********CONTROL PARAMETERS (ICNTL)**************'/)
  981  FORMAT (
      &     ' CNTL(1)   Threshold for numerical pivoting        =',D16.4/
-     &     ' CNTL(3)   Null pivot detection threshold          =',D16.4/
+     &     ' CNTL(3)   Threshold to detect singularities       =',D16.4/
      &     ' CNTL(4)   Threshold for static pivoting           =',D16.4/
      &     ' CNTL(5)   Fixation for null pivots                =',D16.4/
      &     ' CNTL(7)   Dropping threshold for BLR compression  =',D16.4)
@@ -2375,25 +2437,27 @@ C---------------------------------------
      &     'ICNTL(3)   Output stream for global information    =',I10/
      &     'ICNTL(4)   Level of printing                       =',I10)
  991  FORMAT (
-     &     'ICNTL(5)   Matrix format  ( keep(55) )             =',I10/
-     &     'ICNTL(6)   Maximum transversal  ( keep(23) )       =',I10/
+     &     'ICNTL(5)   Matrix format                           =',I10/
+     &     'ICNTL(6)   Maximum transversal                     =',I10/
      &     'ICNTL(7)   Ordering                                =',I10/
-     &     'ICNTL(12)  LDLT ordering strat ( keep(95) )        =',I10/
+     &     'ICNTL(12)  LDLT ordering strat                     =',I10/
      &     'ICNTL(13)  Parallel root (0=on, 1=off)             =',I10/
      &     'ICNTL(15)  Analysis by block                       =',I10/
-     &     'ICNTL(18)  Distributed matrix  ( keep(54) )        =',I10/
+     &     'ICNTL(18)  Distributed matrix                      =',I10/
      &     'ICNTL(19)  Schur option ( keep(60) 0=off,else=on ) =',I10/
      &     'ICNTL(22)  Out-of-core option (1=on, off otherwise)=',I10/
+     &     'ICNTL(48)  Tree based multithreading               =',I10/
      &     'ICNTL(58)  Symbolic factorization option           =',I10)
  891  FORMAT (
-     &     'ICNTL(5)   Matrix format  ( keep(55) )             =',I10/
-     &     'ICNTL(6)   Maximum transversal  ( keep(23) )       =',I10/
+     &     'ICNTL(5)   Matrix format                           =',I10/
+     &     'ICNTL(6)   Maximum transversal                     =',I10/
      &     'ICNTL(7)   Ordering                                =',I10/
      &     'ICNTL(13)  Parallel root (0=on, 1=off)             =',I10/
      &     'ICNTL(15)  Analysis by block                       =',I10/
-     &     'ICNTL(18)  Distributed matrix  ( keep(54) )        =',I10/
-     &     'ICNTL(19)  Schur option ( keep(60) 0=off,else=on ) =',I10/
+     &     'ICNTL(18)  Distributed matrix                      =',I10/
+     &     'ICNTL(19)  Schur option ( 0=off,else=on )          =',I10/
      &     'ICNTL(22)  Out-of-core option (1=on, off otherwise)=',I10/
+     &     'ICNTL(48)  Tree based multithreading               =',I10/
      &     'ICNTL(58)  Symbolic factorization option           =',I10)
  992  FORMAT (
      &     'ICNTL(8)   Scaling strategy                        =',I10)
@@ -2407,12 +2471,15 @@ C---------------------------------------
      &     'ICNTL(49)  Compact workarray S (end of facto.)     =',I10)
  993  FORMAT (
      &     'ICNTL(14)  Percent of memory increase              =',I10)
+ 996  FORMAT (
+     &     'ICNTL(56)  Null space functionality                =',I10) 
  995  FORMAT (
      &     'ICNTL(9)   Solve A x=b (1) or A''x = b (else)       =',I10/
      &     'ICNTL(10)  Max steps iterative refinement          =',I10/
      &     'ICNTL(11)  Error analysis (1=all,2=some,else=off)  =',I10/
      &     'ICNTL(20)  Den.(0)/sparse(1,2,3)/dist.(10,11) RHS  =',I10/
-     &     'ICNTL(21)  Gathered (0) or distributed(1) solution =',I10)
+     &     'ICNTL(21)  Gathered (0) or distributed(1) solution =',I10/
+     &     'ICNTL(26)  Solution step                           =',I10)
  998  FORMAT (
      &     '           Size of SCHUR matrix (SIZE_SCHUR)       =',I10)
       END SUBROUTINE ZMUMPS_PRINT_ICNTL
@@ -2452,11 +2519,13 @@ C---------------------------------------
               WRITE (LP,992) KEEP(52)
            ENDIF   
            WRITE (LP,993) KEEP(12)
+           WRITE (LP,996) KEEP(19), KEEP(118)
+           WRITE (LP,994) KEEP(21)
          CASE(3);
            WRITE (LP,980)
            WRITE (LP,990) ICNTL(1),ICNTL(2),ICNTL(3),ICNTL(4) 
            WRITE (LP,995)
-     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21)
+     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21), ICNTL(26)
          CASE(4);
            WRITE (LP,980) 
            WRITE (LP,990) ICNTL(1),ICNTL(2),ICNTL(3),ICNTL(4)
@@ -2466,8 +2535,11 @@ C---------------------------------------
            WRITE (LP,991) KEEP(55),KEEP(23),ICNTL(7),KEEP(95),
      &          ICNTL(13),KEEP(54),KEEP(60),ICNTL(22)
            WRITE (LP,995)
-     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21)
+     &     ICNTL(9),ICNTL(10),ICNTL(11),ICNTL(20),ICNTL(21), ICNTL(26)
            WRITE (LP,993) KEEP(12)
+           WRITE (LP,997) KEEP(53)
+           WRITE (LP,996) KEEP(19), KEEP(118)
+           WRITE (LP,994) KEEP(21)
          CASE(5);
            WRITE (LP,980) 
            WRITE (LP,990) ICNTL(1),ICNTL(2),ICNTL(3),ICNTL(4)
@@ -2481,6 +2553,8 @@ C---------------------------------------
               WRITE (LP,992) KEEP(52)
            ENDIF   
            WRITE (LP,993) KEEP(12)
+           WRITE (LP,996) KEEP(19), KEEP(118)
+           WRITE (LP,994) KEEP(21)
          CASE(6);
            WRITE (LP,980)
            WRITE (LP,990) ICNTL(1),ICNTL(2),ICNTL(3),ICNTL(4)
@@ -2494,8 +2568,11 @@ C---------------------------------------
               WRITE (LP,992) KEEP(52)
            ENDIF   
            WRITE (LP,995)
-     &     ICNTL(9),ICNTL(10),ICNTL(11),KEEP(248),ICNTL(21)
+     &     ICNTL(9),ICNTL(10),ICNTL(11),KEEP(248),ICNTL(21), ICNTL(26)
            WRITE (LP,993) KEEP(12)
+           WRITE (LP,997) KEEP(53)
+           WRITE (LP,996) KEEP(19), KEEP(118)
+           WRITE (LP,994) KEEP(21)
         END SELECT
       ENDIF
  980  FORMAT (/'******INTERNAL VALUE OF PARAMETERS (ICNTL/KEEP)****'/)
@@ -2522,7 +2599,15 @@ C---------------------------------------
      &     'ICNTL(10)  Max steps iterative refinement          =',I10/
      &     'ICNTL(11)  Error analysis ( 0= off, else=on)       =',I10/
      &     'ICNTL(20)  Den.(0)/sparse(1,2,3)/dist.(10,11) RHS  =',I10/
-     &     'ICNTL(21)  Gathered (0) or distributed(1) solution =',I10)
+     &     'ICNTL(21)  Gathered (0) or distributed(1) solution =',I10/
+     &     'ICNTL(26)  Solution step                           =',I10)
+ 997  FORMAT (
+     &     'ICNTL(56)  Null space-analysis      ( keep(53) )   =',I10) 
+ 996  FORMAT (
+     &     'ICNTL(56)  Null space-factorisation ( keep(19) )   =',I10/ 
+     &     'KEEP(118)  Algorithm used for null space           =',I10) 
+ 994  FORMAT (
+     &     'ICNTL(57)  Estimate of null space size ( keep(21) )=',I10)
       END SUBROUTINE ZMUMPS_PRINT_KEEP
       SUBROUTINE ZMUMPS_CHECK_DENSE_RHS
      &       (idRHS, idINFO, idN, idNRHS, idLRHS)
@@ -2581,7 +2666,7 @@ C           perform the check if minimal
       RETURN
       END SUBROUTINE ZMUMPS_CHECK_DENSE_RHS
 C
-      SUBROUTINE ZMUMPS_SET_K221(id)
+      SUBROUTINE ZMUMPS_SET_K221(id,ATSOLVE)
       USE ZMUMPS_STRUC_DEF
       IMPLICIT NONE
 C
@@ -2589,21 +2674,30 @@ C     Purpose:
 C     =======
 C
 C     Sets KEEP(221) on master.
-C     Constraint: must be called before ZMUMPS_CHECK_REDRHS.
-C     Can be called at factorization or solve phase
+C     [Schur only] must be called before ZMUMPS_CHECK_REDRHS 
+C       
+C     Can be called at factorization 
+C     (in case of fwd in facto) or at solve phase
+C     ATSOLVE=.TRUE. if called during solve phase
 C
       TYPE (ZMUMPS_STRUC) :: id
+      LOGICAL, INTENT(IN) :: ATSOLVE 
+      LOGICAL :: PROKG
+      INTEGER :: MPG
       INTEGER MASTER
       PARAMETER( MASTER = 0 )
+      MPG = id%ICNTL( 3 )
+      PROKG = ( MPG .GT. 0 .and. id%MYID .eq. MASTER )
+      PROKG = (PROKG.AND.(id%ICNTL(4).GE.2))
       IF (id%MYID.EQ.MASTER) THEN
         id%KEEP(221)=id%ICNTL(26)
-        IF (id%KEEP(221).ne.0 .and. id%KEEP(221) .NE.1
-     &      .AND.id%KEEP(221).ne.2) id%KEEP(221)=0
+        IF (id%KEEP(221).NE.0 .AND. id%KEEP(221) .NE.1
+     &      .AND.id%KEEP(221).NE.2) id%KEEP(221)=0
       ENDIF
       RETURN
       END SUBROUTINE ZMUMPS_SET_K221
 C
-      SUBROUTINE ZMUMPS_CHECK_REDRHS(id)
+      SUBROUTINE ZMUMPS_CHECK_K221andREDRHS(id)
       USE ZMUMPS_STRUC_DEF
       IMPLICIT NONE
 C
@@ -2616,17 +2710,22 @@ C  * Constraints:
 C    - Must be called after solve phase.
 C    - KEEP(60) must have been set (ok to check
 C    since KEEP(60) was set during analysis phase)
-C  * Remark that during solve phase, ICNTL(26)=1 is
+C  * Remark that during solve phase, ICNTL(26)#0 is
 C    forbidden in case of fwd in facto.
 C
       TYPE (ZMUMPS_STRUC) :: id
       INTEGER MASTER
       PARAMETER( MASTER = 0 )
+C     write(6,*) " Entering ZMUMPS_CHECK_K221andREDRHS with : ", 
+C    & " id%JOB, id%KEEP(221), id%KEEP(60), id%SIZE_SCHUR= ", 
+C    & id%JOB, id%KEEP(221), id%KEEP(60), id%SIZE_SCHUR
       IF (id%MYID .EQ. MASTER) THEN
           IF ( id%KEEP(221) == 1 .or. id%KEEP(221) == 2 ) THEN
-            IF (id%KEEP(221) == 2 .and. id%JOB == 2) THEN
-              id%INFO(1)=-35
-              id%INFO(2)=id%KEEP(221)
+            IF (id%KEEP(221) == 2 .and. 
+     &                ( id%JOB .NE.3 )
+     &         ) THEN
+              id%INFO(1)=-33
+              id%INFO(2)=id%JOB
               GOTO 333
             ENDIF
             IF (id%KEEP(221) == 1 .and. id%KEEP(252) == 1
@@ -2637,29 +2736,39 @@ C
             IF ( id%KEEP(60).eq. 0 .or. id%SIZE_SCHUR.EQ.0 ) THEN
               id%INFO(1)=-33
               id%INFO(2)=id%KEEP(221)
+C              write(6,*) " id%KEEP(60), id%SIZE_SCHUR=", 
+C     &            id%KEEP(60), id%SIZE_SCHUR
               GOTO 333
             ENDIF
-            IF ( .NOT. associated( id%REDRHS)) THEN
-              id%INFO(1)=-22
-              id%INFO(2)=15
-              GOTO 333
-            ELSE IF (id%NRHS.EQ.1) THEN
-              IF (size(id%REDRHS) < id%SIZE_SCHUR ) THEN
+            IF ( id%KEEP(60).NE.0 ) THEN
+C           Schur feature
+              IF ( id%SIZE_SCHUR.EQ.0 ) THEN
+                id%INFO(1)=-33
+                id%INFO(2)=id%KEEP(221)
+                GOTO 333
+              ENDIF
+              IF ( .NOT. associated( id%REDRHS)) THEN
+                id%INFO(1)=-22
+                id%INFO(2)=15
+                GOTO 333
+              ELSE IF (id%NRHS.EQ.1) THEN
+                IF (size(id%REDRHS) < id%SIZE_SCHUR ) THEN
+                  id%INFO(1)=-22
+                  id%INFO(2)=15
+                  GOTO 333
+                ENDIF
+              ELSE IF (id%LREDRHS < id%SIZE_SCHUR) THEN
+                id%INFO(1)=-34
+                id%INFO(2)=id%LREDRHS
+                GOTO 333
+              ELSE IF
+     &        (size(id%REDRHS)<
+     &           id%NRHS*id%LREDRHS-id%LREDRHS+id%SIZE_SCHUR)
+     &        THEN
                 id%INFO(1)=-22
                 id%INFO(2)=15
                 GOTO 333
               ENDIF
-            ELSE IF (id%LREDRHS < id%SIZE_SCHUR) THEN
-              id%INFO(1)=-34
-              id%INFO(2)=id%LREDRHS
-              GOTO 333
-            ELSE IF
-     &      (size(id%REDRHS)<
-     &         id%NRHS*id%LREDRHS-id%LREDRHS+id%SIZE_SCHUR)
-     &      THEN
-              id%INFO(1)=-22
-              id%INFO(2)=15
-              GOTO 333
             ENDIF
           ENDIF
       ENDIF
@@ -2668,4 +2777,4 @@ C     Error is not propagated. It should
 C     The reason to propagate it outside is that there can be
 C     one call to PROPINFO instead of several ones.
       RETURN
-      END SUBROUTINE ZMUMPS_CHECK_REDRHS
+      END SUBROUTINE ZMUMPS_CHECK_K221andREDRHS
diff -pruN 5.6.2-2.1/src/zmumps_f77.F 5.7.1-1/src/zmumps_f77.F
--- 5.6.2-2.1/src/zmumps_f77.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zmumps_f77.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -16,8 +16,9 @@ C
      &     JCNhere, A, Ahere, NZ_loc, NNZ_loc, IRN_loc, IRN_lochere,
      &     JCN_loc, JCN_lochere, A_loc, A_lochere, NELT, ELTPTR,
      &     ELTPTRhere,  ELTVAR, ELTVARhere, A_ELT, A_ELThere,
-     &     BLKPTR, BLKPTRhere, BLKVAR, BLKVARhere,
-     &     PERM_IN, PERM_INhere, RHS, RHShere, REDRHS, REDRHShere,
+     &     BLKPTR, BLKPTRhere, BLKVAR, BLKVARhere, PERM_IN, PERM_INhere,
+     &     ROWIND, ROWINDhere, COLIND, COLINDhere, PIVOTS, PIVOTShere,
+     &     RHS, RHShere, REDRHS, REDRHShere,
      &     INFO, RINFO, INFOG, RINFOG, DEFICIENCY, LWK_USER,
      &     SIZE_SCHUR, LISTVAR_SCHUR, LISTVAR_SCHURhere, SCHUR,
      &     SCHURhere, WK_USER, WK_USERhere, COLSCA, COLSCAhere,
@@ -26,31 +27,38 @@ C
      &     RHS_loc, RHS_lochere,
      &     IRHS_SPARSE, IRHS_SPARSEhere, IRHS_PTR, IRHS_PTRhere,
      &     ISOL_loc, ISOL_lochere, IRHS_loc, IRHS_lochere, NZ_RHS,
-     &     LSOL_loc, LRHS_loc, Nloc_RHS,
+     &     LSOL_loc, LRHS_loc, NSOL_loc, Nloc_RHS,
      &     SCHUR_MLOC, SCHUR_NLOC, SCHUR_LLD,
-     &     MBLOCK, NBLOCK, NPROW, NPCOL,  
+     &     MBLOCK, NBLOCK, NPROW, NPCOL, LD_RHSINTR,
      &     OOC_TMPDIR, OOC_PREFIX, WRITE_PROBLEM,
+#if ! defined(NO_SAVE_RESTORE)
      &     SAVE_DIR, SAVE_PREFIX,
+#endif
      &     TMPDIRLEN, PREFIXLEN, WRITE_PROBLEMLEN,
+#if ! defined(NO_SAVE_RESTORE)
      &     SAVE_DIRLEN, SAVE_PREFIXLEN,
+#endif
      &     METIS_OPTIONS
      &     )
       USE ZMUMPS_STRUC_DEF
       IMPLICIT NONE
       INTEGER OOC_PREFIX_MAX_LENGTH, OOC_TMPDIR_MAX_LENGTH
       INTEGER PB_MAX_LENGTH
-      PARAMETER(OOC_PREFIX_MAX_LENGTH=63, OOC_TMPDIR_MAX_LENGTH=255)
-      PARAMETER(PB_MAX_LENGTH=255)
-      INTEGER, PARAMETER :: SAVE_DIR_MAX_LENGTH    = 255
+      PARAMETER(OOC_PREFIX_MAX_LENGTH=255, OOC_TMPDIR_MAX_LENGTH=1023)
+      PARAMETER(PB_MAX_LENGTH=1023)
+#if ! defined(NO_SAVE_RESTORE)
+      INTEGER, PARAMETER :: SAVE_DIR_MAX_LENGTH    = 1023
       INTEGER, PARAMETER :: SAVE_PREFIX_MAX_LENGTH = 255
+#endif
       INTEGER JOB, SYM, PAR, COMM_F77, N, NBLK, NZ, NZ_loc, NELT,
      &        DEFICIENCY, LWK_USER, SIZE_SCHUR, INSTANCE_NUMBER,
      &        NRHS, LRHS,
-     &        NZ_RHS, LSOL_loc,Nloc_RHS, LRHS_loc, LREDRHS
+     &        NZ_RHS, LSOL_loc,Nloc_RHS, LRHS_loc, NSOL_loc, LREDRHS
       INTEGER(8) :: NNZ, NNZ_loc
       INTEGER ICNTL(60), INFO(80), INFOG(80), KEEP(500)
       INTEGER SCHUR_MLOC, SCHUR_NLOC, SCHUR_LLD
       INTEGER MBLOCK, NBLOCK, NPROW, NPCOL
+      INTEGER LD_RHSINTR
       INTEGER TMPDIRLEN, PREFIXLEN, WRITE_PROBLEMLEN
       DOUBLE PRECISION CNTL(15), RINFO(40), RINFOG(40), DKEEP(230)
       INTEGER(8) KEEP8(150)
@@ -61,6 +69,8 @@ C
       INTEGER, TARGET :: ISOL_loc(*), IRHS_loc(*)
       INTEGER, TARGET :: BLKPTR(*), BLKVAR(*)
       COMPLEX(kind=8), TARGET :: A(*), A_ELT(*), A_loc(*), RHS(*)
+      INTEGER, TARGET :: ROWIND(*), COLIND(*)
+      COMPLEX(kind=8), TARGET :: PIVOTS(*)
       COMPLEX(kind=8), TARGET :: WK_USER(*)
       COMPLEX(kind=8), TARGET :: REDRHS(*)
       DOUBLE PRECISION, TARGET :: ROWSCA(*), COLSCA(*)
@@ -69,13 +79,15 @@ C
       INTEGER, INTENT(inout) :: OOC_TMPDIR(OOC_TMPDIR_MAX_LENGTH)
       INTEGER, INTENT(inout) :: OOC_PREFIX(OOC_PREFIX_MAX_LENGTH)
       INTEGER, INTENT(in) :: WRITE_PROBLEM(PB_MAX_LENGTH)
+#if ! defined(NO_SAVE_RESTORE)
       INTEGER SAVE_DIRLEN, SAVE_PREFIXLEN
       INTEGER, INTENT(in) :: SAVE_DIR(SAVE_DIR_MAX_LENGTH)
       INTEGER, INTENT(in) :: SAVE_PREFIX(SAVE_PREFIX_MAX_LENGTH)
+#endif
       INTEGER METIS_OPTIONS(40)
       INTEGER IRNhere, JCNhere, Ahere, ELTPTRhere, ELTVARhere,
      &        A_ELThere, BLKPTRhere, BLKVARhere, PERM_INhere,
-     &        WK_USERhere,
+     &        WK_USERhere, ROWINDhere, COLINDhere, PIVOTShere,
      &        RHShere, REDRHShere, IRN_lochere,
      &        JCN_lochere, A_lochere, LISTVAR_SCHURhere,
      &        SCHURhere, COLSCAhere, ROWSCAhere, RHS_SPARSEhere,
@@ -99,9 +111,27 @@ C
       EXTERNAL MUMPS_ASSIGN_MAPPING,
      &         MUMPS_ASSIGN_PIVNUL_LIST,
      &         MUMPS_ASSIGN_SYM_PERM,
-     &         MUMPS_ASSIGN_UNS_PERM
+     &         MUMPS_ASSIGN_UNS_PERM,
+     &         MUMPS_ASSIGN_GLOB2LOC_RHS,
+     &         MUMPS_ASSIGN_GLOB2LOC_SOL
+      EXTERNAL MUMPS_NULLIFY_C_MAPPING,
+     &         MUMPS_NULLIFY_C_PIVNUL_LIST,
+     &         MUMPS_NULLIFY_C_SYM_PERM,
+     &         MUMPS_NULLIFY_C_UNS_PERM,
+     &         MUMPS_NULLIFY_C_GLOB2LOC_RHS,
+     &         MUMPS_NULLIFY_C_GLOB2LOC_SOL
       EXTERNAL ZMUMPS_ASSIGN_COLSCA,
-     &         ZMUMPS_ASSIGN_ROWSCA
+     &         ZMUMPS_ASSIGN_ROWSCA,
+     &         ZMUMPS_ASSIGN_ROWSCA_LOC,
+     &         ZMUMPS_ASSIGN_COLSCA_LOC,
+     &         ZMUMPS_ASSIGN_RHSINTR,
+     &         ZMUMPS_ASSIGN_SINGULAR_VALUES
+      EXTERNAL ZMUMPS_NULLIFY_C_COLSCA,
+     &         ZMUMPS_NULLIFY_C_ROWSCA,
+     &         ZMUMPS_NULLIFY_C_ROWSCA_LOC,
+     &         ZMUMPS_NULLIFY_C_COLSCA_LOC,
+     &         ZMUMPS_NULLIFY_C_RHSINTR,
+     &         ZMUMPS_NULLIFY_C_SING_VALUES
       IF (JOB == -1) THEN
         DO I = 1, ZMUMPS_STRUC_ARRAY_SIZE
           IF ( .NOT. associated(mumps_par_array(I)%PTR) ) GOTO 10
@@ -175,20 +205,22 @@ C
       CALL MUMPS_ADDR_C( ICNTL(50), mumps_par%KEEP8(83) )
       CALL MUMPS_ADDR_C( RINFO(3), mumps_par%KEEP8(84) )
       mumps_par%METIS_OPTIONS(1:40)=METIS_OPTIONS(1:40)
-      mumps_par%NRHS  = NRHS
-      mumps_par%LRHS  = LRHS
-      mumps_par%LREDRHS = LREDRHS
-      mumps_par%NZ_RHS   = NZ_RHS
-      mumps_par%LSOL_loc = LSOL_loc
-      mumps_par%Nloc_RHS = Nloc_RHS
-      mumps_par%LRHS_loc = LRHS_loc
+      mumps_par%NRHS         = NRHS
+      mumps_par%LRHS         = LRHS
+      mumps_par%LREDRHS      = LREDRHS
+      mumps_par%NZ_RHS       = NZ_RHS
+      mumps_par%LSOL_loc     = LSOL_loc
+      mumps_par%Nloc_RHS     = Nloc_RHS
+      mumps_par%LRHS_loc     = LRHS_loc
+      mumps_par%NSOL_loc     = NSOL_loc
       mumps_par%SCHUR_MLOC   = SCHUR_MLOC
       mumps_par%SCHUR_NLOC   = SCHUR_NLOC
       mumps_par%SCHUR_LLD    = SCHUR_LLD
-      mumps_par%MBLOCK = MBLOCK
-      mumps_par%NBLOCK = NBLOCK
-      mumps_par%NPROW  = NPROW
-      mumps_par%NPCOL  = NPCOL
+      mumps_par%MBLOCK       = MBLOCK
+      mumps_par%NBLOCK       = NBLOCK
+      mumps_par%NPROW        = NPROW
+      mumps_par%NPCOL        = NPCOL
+      mumps_par%LD_RHSINTR   = LD_RHSINTR
       IF ( COMM_F77 .NE. -987654 ) THEN
         mumps_par%COMM = COMM_F77
       ELSE
@@ -226,6 +258,20 @@ C
       IF ( SCHURhere /= 0 ) THEN
         mumps_par%SCHUR_CINTERFACE=>SCHUR(1:1)
       ENDIF
+      IF (ROWINDhere /= 0) THEN
+        mumps_par%ROWIND => ROWIND(1:KEEP(89))
+      ENDIF
+      IF (COLINDhere /= 0) THEN
+        mumps_par%COLIND => COLIND(1:KEEP(89))
+      ENDIF
+      IF (PIVOTShere /= 0) THEN
+        IF (KEEP(50) .EQ.0 .OR.KEEP(50).EQ.1) THEN
+          mumps_par%PIVOTS => PIVOTS(1:KEEP(89))
+        ELSE
+          mumps_par%PIVOTS => PIVOTS(1_8:
+     &                        int(KEEP(89),8)+int(KEEP(89),8))
+        ENDIF
+      ENDIF
       IF (NRHS .NE. 1) THEN
         IF ( RHShere /= 0 ) mumps_par%RHS =>
      &                      RHS(1_8:int(NRHS,8)*int(LRHS,8))
@@ -276,6 +322,7 @@ C
       DO I=WRITE_PROBLEMLEN+1,PB_MAX_LENGTH
         mumps_par%WRITE_PROBLEM(I:I)=' '
       ENDDO
+#if ! defined(NO_SAVE_RESTORE)
       DO I=1,SAVE_DIRLEN
         mumps_par%SAVE_DIR(I:I)=char(SAVE_DIR(I))
       ENDDO
@@ -288,6 +335,7 @@ C
       DO I=SAVE_PREFIXLEN+1,SAVE_PREFIX_MAX_LENGTH
         mumps_par%SAVE_PREFIX(I:I)=' '
       ENDDO
+#endif
       CALL ZMUMPS( mumps_par )
       INFO(1:80)=mumps_par%INFO(1:80)
       INFOG(1:80)=mumps_par%INFOG(1:80)
@@ -315,6 +363,7 @@ C
       LSOL_loc   = mumps_par%LSOL_loc
       Nloc_RHS   = mumps_par%Nloc_RHS
       LRHS_loc   = mumps_par%LRHS_loc
+      NSOL_loc   = mumps_par%NSOL_loc
       SIZE_SCHUR = mumps_par%SIZE_SCHUR
       LWK_USER   = mumps_par%LWK_USER
       NELT       = mumps_par%NELT
@@ -326,6 +375,7 @@ C
       NBLOCK     = mumps_par%NBLOCK
       NPROW      = mumps_par%NPROW
       NPCOL      = mumps_par%NPCOL
+      LD_RHSINTR = mumps_par%LD_RHSINTR
       IF ( associated (mumps_par%MAPPING) ) THEN
          CALL MUMPS_ASSIGN_MAPPING(mumps_par%MAPPING(1))
       ELSE
@@ -336,6 +386,12 @@ C
       ELSE
          CALL MUMPS_NULLIFY_C_PIVNUL_LIST()
       ENDIF
+      IF ( associated (mumps_par%SINGULAR_VALUES) ) THEN
+         CALL ZMUMPS_ASSIGN_SINGULAR_VALUES(
+     &                  mumps_par%SINGULAR_VALUES(1))
+      ELSE
+         CALL ZMUMPS_NULLIFY_C_SING_VALUES()
+      ENDIF
       IF ( associated (mumps_par%SYM_PERM) ) THEN
          CALL MUMPS_ASSIGN_SYM_PERM(mumps_par%SYM_PERM(1))
       ELSE
@@ -346,22 +402,47 @@ C
       ELSE
          CALL MUMPS_NULLIFY_C_UNS_PERM()
       ENDIF
-      IF (associated( mumps_par%COLSCA)) THEN
+      IF ( associated (mumps_par%COLSCA_loc) ) THEN
+         CALL ZMUMPS_ASSIGN_COLSCA_LOC(1)
+      ELSE
+         CALL ZMUMPS_NULLIFY_C_COLSCA_LOC()
+      ENDIF
+      IF ( associated (mumps_par%ROWSCA_loc) ) THEN
+         CALL ZMUMPS_ASSIGN_ROWSCA_LOC(1)
+      ELSE
+         CALL ZMUMPS_NULLIFY_C_ROWSCA_LOC()
+      ENDIF
+      IF (associated( mumps_par%COLSCA )) THEN
           CALL ZMUMPS_ASSIGN_COLSCA(mumps_par%COLSCA(1))
       ELSE
           CALL ZMUMPS_NULLIFY_C_COLSCA()
       ENDIF
-      IF (associated( mumps_par%ROWSCA)) THEN
+      IF (associated( mumps_par%ROWSCA )) THEN
           CALL ZMUMPS_ASSIGN_ROWSCA(mumps_par%ROWSCA(1))
       ELSE
           CALL ZMUMPS_NULLIFY_C_ROWSCA()
       ENDIF
+      IF (associated( mumps_par%RHSINTR )) THEN
+          CALL ZMUMPS_ASSIGN_RHSINTR(mumps_par%RHSINTR(1))
+      ELSE
+          CALL ZMUMPS_NULLIFY_C_RHSINTR()
+      ENDIF
+      IF (associated(mumps_par%GLOB2LOC_RHS)) THEN
+          CALL MUMPS_ASSIGN_GLOB2LOC_RHS(mumps_par%GLOB2LOC_RHS(1))
+      ELSE
+          CALL MUMPS_NULLIFY_C_GLOB2LOC_RHS()
+      ENDIF
+      IF (associated(mumps_par%GLOB2LOC_SOL)) THEN
+          CALL MUMPS_ASSIGN_GLOB2LOC_SOL(mumps_par%GLOB2LOC_SOL(1))
+      ELSE
+          CALL MUMPS_NULLIFY_C_GLOB2LOC_SOL()
+      ENDIF
       TMPDIRLEN=len_trim(mumps_par%OOC_TMPDIR)
-      DO I=1,OOC_TMPDIR_MAX_LENGTH
+      DO I=1,TMPDIRLEN
          OOC_TMPDIR(I)=ichar(mumps_par%OOC_TMPDIR(I:I))
       ENDDO
       PREFIXLEN=len_trim(mumps_par%OOC_PREFIX)
-      DO I=1,OOC_PREFIX_MAX_LENGTH
+      DO I=1,PREFIXLEN
          OOC_PREFIX(I)=ichar(mumps_par%OOC_PREFIX(I:I))
       ENDDO
       IF ( JOB == -2 ) THEN
diff -pruN 5.6.2-2.1/src/zmumps_gpu.c 5.7.1-1/src/zmumps_gpu.c
--- 5.6.2-2.1/src/zmumps_gpu.c	2023-10-11 09:36:34.000000000 +0000
+++ 5.7.1-1/src/zmumps_gpu.c	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/zmumps_gpu.h 5.7.1-1/src/zmumps_gpu.h
--- 5.6.2-2.1/src/zmumps_gpu.h	2023-10-11 09:36:34.000000000 +0000
+++ 5.7.1-1/src/zmumps_gpu.h	2024-05-02 10:15:13.000000000 +0000
@@ -1,10 +1,10 @@
 /*
  *
- *  This file is part of MUMPS 5.6.2, released
- *  on Wed Oct 11 09:36:25 UTC 2023
+ *  This file is part of MUMPS 5.7.1, released
+ *  on Thu May  2 10:15:09 UTC 2024
  *
  *
- *  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+ *  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
  *  Mumps Technologies, University of Bordeaux.
  *
  *  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/zmumps_iXamax.F 5.7.1-1/src/zmumps_iXamax.F
--- 5.6.2-2.1/src/zmumps_iXamax.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zmumps_iXamax.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/zmumps_load.F 5.7.1-1/src/zmumps_load.F
--- 5.6.2-2.1/src/zmumps_load.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zmumps_load.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -793,7 +793,7 @@ C
          CALL ZMUMPS_BUF_BROADCAST( WHAT,
      &        COMM_LD, NPROCS,
      &        FUTURE_NIV2,
-     &        dble(MEMORY_MD),dble(0) ,MYID, id%KEEP, IERR  )
+     &        dble(MEMORY_MD),dble(0) ,MYID, id%KEEP(267), IERR )
          WHAT=9
          MEMORY_SENT = dble(LA-MAX_SURF_MASTER)-MAX_SBTR
      &      - max( dble(LA) * dble(3) / dble(100),
@@ -811,7 +811,7 @@ C
      &        COMM_LD, NPROCS,
      &        FUTURE_NIV2,
      &        MEMORY_SENT,
-     &        dble(0),MYID, id%KEEP, IERR  )
+     &        dble(0),MYID, id%KEEP(267), IERR  )
       ENDIF
       RETURN
       END SUBROUTINE ZMUMPS_LOAD_INIT
@@ -1907,7 +1907,7 @@ C
         CALL ZMUMPS_BUF_BROADCAST( WHAT,
      &         COMM, SLAVEF,
      &               FUTURE_NIV2,
-     &         COST, dble(0), MYID, KEEP, IERR  )
+     &         COST, dble(0), MYID, KEEP(267), IERR  )
         POOL_LAST_COST_SENT = COST
         POOL_MEM(MYID)=COST
         IF ( IERR == -1 )THEN
@@ -1970,7 +1970,7 @@ C
      &           WHAT, COMM, SLAVEF,
      &           FUTURE_NIV2,
      &           dble(MEM_SUBTREE(INDICE_SBTR)), dble(0),
-     &           MYID, KEEP, IERR  )
+     &           MYID, KEEP(267), IERR  )
             IF ( IERR == -1 )THEN
                CALL ZMUMPS_LOAD_RECV_MSGS(COMM_LD)
                CALL MUMPS_CHECK_COMM_NODES(COMM_NODES, EXIT_FLAG)
@@ -2000,7 +2000,7 @@ C
                CALL ZMUMPS_BUF_BROADCAST(
      &              WHAT, COMM, SLAVEF,
      &              FUTURE_NIV2,
-     &              COST, dble(0), MYID, KEEP, IERR  )
+     &              COST, dble(0), MYID, KEEP(267), IERR  )
                IF ( IERR == -1 )THEN
                   CALL ZMUMPS_LOAD_RECV_MSGS(COMM_LD)
                   CALL MUMPS_CHECK_COMM_NODES(COMM_NODES, EXIT_FLAG)
@@ -4648,10 +4648,8 @@ C
       INTEGER J
       DOUBLE PRECISION MEM_COST
       INTEGER NBINSUBTREE,i,NBTOP
-      EXTERNAL ZMUMPS_POOL_EMPTY,
-     & MUMPS_IN_OR_ROOT_SSARBR
-      LOGICAL ZMUMPS_POOL_EMPTY,
-     & MUMPS_IN_OR_ROOT_SSARBR
+      EXTERNAL MUMPS_IN_OR_ROOT_SSARBR
+      LOGICAL MUMPS_IN_OR_ROOT_SSARBR
       NBINSUBTREE = POOL(LPOOL)
       NBTOP       = POOL(LPOOL - 1)
       IF(KEEP(47).LT.2)THEN
@@ -4755,8 +4753,6 @@ C
       LOGICAL FLAG, EXIT_FLAG
       DOUBLE PRECISION COST
       DOUBLE PRECISION TO_BE_SENT
-      EXTERNAL MUMPS_TYPENODE
-      INTEGER MUMPS_TYPENODE
       IF(FLAG)THEN
          WHAT=17 
          IF(BDC_M2_FLOPS)THEN
@@ -4783,7 +4779,7 @@ C
      &               FUTURE_NIV2,
      &         COST, 
      &         TO_BE_SENT, 
-     &         MYID, KEEP_LOAD, IERR  )
+     &         MYID, KEEP_LOAD(267), IERR  )
       IF ( IERR == -1 )THEN
          CALL ZMUMPS_LOAD_RECV_MSGS(COMM_LD)
          CALL MUMPS_CHECK_COMM_NODES(COMM_NODES, EXIT_FLAG)
@@ -4946,8 +4942,6 @@ C
       RECURSIVE SUBROUTINE ZMUMPS_PROCESS_NIV2_MEM_MSG(INODE)
       IMPLICIT NONE
       INTEGER INODE
-      EXTERNAL MUMPS_TYPENODE
-      INTEGER MUMPS_TYPENODE
       IF((INODE.EQ.KEEP_LOAD(20)).OR.
      &     (INODE.EQ.KEEP_LOAD(38)))THEN
          RETURN
@@ -4985,8 +4979,6 @@ C
       RECURSIVE SUBROUTINE ZMUMPS_PROCESS_NIV2_FLOPS_MSG(INODE)
       IMPLICIT NONE
       INTEGER INODE
-      EXTERNAL MUMPS_TYPENODE
-      INTEGER MUMPS_TYPENODE
       IF((INODE.EQ.KEEP_LOAD(20)).OR.
      &     (INODE.EQ.KEEP_LOAD(38)))THEN
          RETURN
diff -pruN 5.6.2-2.1/src/zmumps_lr_data_m.F 5.7.1-1/src/zmumps_lr_data_m.F
--- 5.6.2-2.1/src/zmumps_lr_data_m.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zmumps_lr_data_m.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -35,7 +35,9 @@ C
      &  , BLR_STRUC_T, blr_panel_type, diag_block_type
 #endif
      &  , ZMUMPS_BLR_SAVE_DIAG_BLOCK, ZMUMPS_BLR_RETRIEVE_DIAG_BLOCK
+#if ! defined(NO_SAVE_RESTORE)
      &  , ZMUMPS_SAVE_RESTORE_BLR
+#endif      
       TYPE blr_panel_type
          integer                 :: NB_ACCESSES_LEFT
          type(LRB_TYPE), pointer :: LRB_PANEL(:)
@@ -68,6 +70,9 @@ C
      &           PANELS_NOTUSED=-1111, PANELS_FREED=-2222, 
      &           NB_PANELS_NOTINIT=-3333, 
      &           NFS4FATHER_NOTINIT=-4444 )
+#if ! defined(NO_SAVE_RESTORE)
+      INCLUDE 'mumps_save_restore_modes.h'
+#endif
       CONTAINS
       SUBROUTINE ZMUMPS_BLR_INIT_MODULE(INITIAL_SIZE, INFO)
        INTEGER, INTENT(IN) :: INITIAL_SIZE
@@ -1062,6 +1067,7 @@ C
        ENDIF
        RETURN
        END SUBROUTINE ZMUMPS_BLR_FREE_ALL_PANELS
+#if ! defined(NO_SAVE_RESTORE)
       SUBROUTINE ZMUMPS_SAVE_RESTORE_BLR(id_BLRARRAY_ENCODING
      &                 ,unit,MYID,mode
      &                 ,SIZE_GEST,SIZE_VARIABLES
@@ -1072,7 +1078,7 @@ C
       INCLUDE 'mpif.h'
       CHARACTER, DIMENSION(:), POINTER :: id_BLRARRAY_ENCODING
       INTEGER,intent(IN)::unit,MYID
-      CHARACTER(len=*),intent(IN) :: mode
+      INTEGER,intent(IN) :: mode
       INTEGER,INTENT(OUT) :: SIZE_GEST
       INTEGER(8),intent(OUT) :: SIZE_VARIABLES
       INTEGER(8),intent(IN) :: TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
@@ -1090,10 +1096,10 @@ C
       SIZE_VARIABLES_BLR_ARRAY_j1=0_8
       SIZE_GEST=0
       SIZE_VARIABLES=0_8
-      if((trim(mode).EQ."memory_save").OR.(trim(mode).EQ."save")) then
+      if(mode.EQ.memory_save_mode.OR.mode.EQ.save_mode) then
          call ZMUMPS_BLR_STRUC_TO_MOD(id_BLRARRAY_ENCODING)
       endif
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          IF(associated(BLR_ARRAY)) THEN
             NbRecords=1
             SIZE_GEST=SIZE_INT
@@ -1101,7 +1107,7 @@ C
             DO j1=1,size(BLR_ARRAY,1)
                CALL ZMUMPS_SAVE_RESTORE_BLR_STRUC(
      &              BLR_ARRAY(j1)
-     &              ,unit,MYID,"memory_save"
+     &              ,unit,MYID,memory_save_mode
      &              ,SIZE_GEST_BLR_ARRAY_j1
      &              ,SIZE_VARIABLES_BLR_ARRAY_j1
      &              ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -1118,7 +1124,7 @@ C
             SIZE_GEST=SIZE_INT*2
             SIZE_VARIABLES=0
          ENDIF
-      elseif(trim(mode).EQ."save") then
+      elseif(mode.EQ.save_mode) then
          IF(associated(BLR_ARRAY)) THEN
             NbRecords=1
             SIZE_GEST=SIZE_INT
@@ -1133,7 +1139,7 @@ C
             DO j1=1,size(BLR_ARRAY,1)
                CALL ZMUMPS_SAVE_RESTORE_BLR_STRUC(
      &              BLR_ARRAY(j1)
-     &              ,unit,MYID,"save"
+     &              ,unit,MYID,save_mode
      &              ,SIZE_GEST_BLR_ARRAY_j1
      &              ,SIZE_VARIABLES_BLR_ARRAY_j1
      &              ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -1161,7 +1167,7 @@ C
             endif
             IF ( INFO(1) .LT. 0 ) GOTO 100
          ENDIF 
-      elseif(trim(mode).EQ."restore") then
+      elseif(mode.EQ.restore_mode) then
          nullify(BLR_ARRAY)
          read(unit,iostat=err) size_array1
          if(err.ne.0) THEN
@@ -1195,7 +1201,7 @@ C
             DO j1=1,size_array1
                CALL ZMUMPS_SAVE_RESTORE_BLR_STRUC(
      &              BLR_ARRAY(j1)
-     &              ,unit,MYID,"restore"
+     &              ,unit,MYID,restore_mode
      &              ,SIZE_GEST_BLR_ARRAY_j1
      &              ,SIZE_VARIABLES_BLR_ARRAY_j1
      &              ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -1209,19 +1215,19 @@ C
             ENDDO
          endif
       endif
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          NbSubRecords=int(SIZE_VARIABLES/huge(I4))
          IF(NbSubRecords.GT.0) then
             NbRecords=NbRecords+NbSubRecords
          ENDIF
-      elseif(trim(mode).EQ."save") then
+      elseif(mode.EQ.save_mode) then
          size_written=size_written+SIZE_VARIABLES
      &        +int(SIZE_GEST,kind=8)
 #if defined(MUMPS_NOF2003)
          size_written=size_written
      &        +int(2*SIZE_INT*NbRecords,kind=8)
 #endif
-      elseif(trim(mode).EQ."restore") then
+      elseif(mode.EQ.restore_mode) then
          size_allocated=size_allocated+SIZE_VARIABLES
          size_read=size_read+SIZE_VARIABLES
      &        +int(SIZE_GEST,kind=8)
@@ -1230,7 +1236,7 @@ C
      &        +int(2*SIZE_INT*NbRecords,kind=8)
 #endif
       endif
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          SIZE_VARIABLES=SIZE_VARIABLES+SIZE_VARIABLES_BLR_ARRAY
          SIZE_GEST=SIZE_GEST+SIZE_GEST_BLR_ARRAY
 #if defined(MUMPS_NOF2003)
@@ -1251,18 +1257,29 @@ C
       INCLUDE 'mpif.h'
       TYPE(BLR_STRUC_T) :: BLR_STRUC
       INTEGER,intent(IN)::unit,MYID
-      CHARACTER(len=*),intent(IN) :: mode
+      INTEGER,intent(IN) :: mode
       INTEGER,INTENT(OUT) :: Local_SIZE_GEST
       INTEGER(8),intent(OUT) :: Local_SIZE_VARIABLES
       INTEGER,intent(INOUT):: INFO(2)
       INTEGER,intent(IN):: SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
       INTEGER(8),intent(IN) :: TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
       INTEGER(8),intent(INOUT):: size_read,size_allocated,size_written
-      INTEGER :: NBVARIABLES_BLR_STRUC_T
-      PARAMETER (NBVARIABLES_BLR_STRUC_T = 15)
-      CHARACTER(len=30), dimension(NBVARIABLES_BLR_STRUC_T)::
-     &     VARIABLES_BLR_STRUC_T
-      CHARACTER(len=30) :: TMP_STRING
+      INTEGER, PARAMETER :: NBVARIABLES_BLR_STRUC_T = 15
+      INTEGER, PARAMETER :: B_IsSYM=1
+      INTEGER, PARAMETER :: B_IsT2=2
+      INTEGER, PARAMETER :: B_IsSLAVE=3
+      INTEGER, PARAMETER :: B_PANELS_L=4
+      INTEGER, PARAMETER :: B_PANELS_U=5
+      INTEGER, PARAMETER :: B_CB_LRB=6
+      INTEGER, PARAMETER :: B_DIAG_BLOCKS=7
+      INTEGER, PARAMETER :: B_BEGS_BLR_STATIC=8
+      INTEGER, PARAMETER :: B_BEGS_BLR_DYNAMIC=9
+      INTEGER, PARAMETER :: B_BEGS_BLR_L=10
+      INTEGER, PARAMETER :: B_BEGS_BLR_COL=11
+      INTEGER, PARAMETER :: B_NB_ACCESSES_INIT=12
+      INTEGER, PARAMETER :: B_NB_PANELS=13
+      INTEGER, PARAMETER :: B_NFS4FATHER=14
+      INTEGER, PARAMETER :: B_M_ARRAY=15
       INTEGER(8),dimension(NBVARIABLES_BLR_STRUC_T)::
      &     SIZE_VARIABLES_BLR_STRUC_T
       INTEGER,dimension(NBVARIABLES_BLR_STRUC_T)::SIZE_GEST_BLR_STRUC_T
@@ -1282,21 +1299,6 @@ C
       INTEGER(8)::SIZE_VARIABLES_DIAG_BLOCKS
       INTEGER(8)::SIZE_VARIABLES_DIAG_BLOCKS_j1
       INTEGER(4)::I4
-      VARIABLES_BLR_STRUC_T(1)="IsSYM"
-      VARIABLES_BLR_STRUC_T(2)="IsT2"
-      VARIABLES_BLR_STRUC_T(3)="IsSLAVE"
-      VARIABLES_BLR_STRUC_T(4)="PANELS_L"
-      VARIABLES_BLR_STRUC_T(5)="PANELS_U"
-      VARIABLES_BLR_STRUC_T(6)="CB_LRB"
-      VARIABLES_BLR_STRUC_T(7)="BEGS_BLR_STATIC"
-      VARIABLES_BLR_STRUC_T(8)="BEGS_BLR_DYNAMIC"
-      VARIABLES_BLR_STRUC_T(9)="BEGS_BLR_L"
-      VARIABLES_BLR_STRUC_T(10)="BEGS_BLR_COL"
-      VARIABLES_BLR_STRUC_T(11)="NB_ACCESSES_INIT"
-      VARIABLES_BLR_STRUC_T(12)="NB_PANELS"
-      VARIABLES_BLR_STRUC_T(13)="DIAG_BLOCKS"
-      VARIABLES_BLR_STRUC_T(14)="NFS4FATHER"
-      VARIABLES_BLR_STRUC_T(15)="M_ARRAY"
       SIZE_VARIABLES_BLR_STRUC_T(:)=0_8
       SIZE_GEST_BLR_STRUC_T(:)=0
       NbRecords_BLR_STRUC_T(:)=0
@@ -1317,13 +1319,12 @@ C
       SIZE_VARIABLES_DIAG_BLOCKS=0_8
       SIZE_VARIABLES_DIAG_BLOCKS_j1=0_8
       DO i1=1,NBVARIABLES_BLR_STRUC_T 
-         TMP_STRING = VARIABLES_BLR_STRUC_T(i1)
-         SELECT CASE(TMP_STRING)
-         CASE("IsSYM")
+         SELECT CASE(i1)
+         CASE(B_IsSYM)
             NbRecords_BLR_STRUC_T(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_LOGICAL
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_LOGICAL
                write(unit,iostat=err) BLR_STRUC%IsSYM
                if(err.ne.0) then
@@ -1332,7 +1333,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_LOGICAL
                read(unit,iostat=err) BLR_STRUC%IsSYM
                if(err.ne.0) THEN
@@ -1342,11 +1343,11 @@ C
                endif 
                IF (INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("IsT2")
+         CASE(B_IsT2)
             NbRecords_BLR_STRUC_T(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_LOGICAL
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_LOGICAL
                write(unit,iostat=err) BLR_STRUC%IsT2
                if(err.ne.0) then
@@ -1355,7 +1356,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_LOGICAL
                read(unit,iostat=err) BLR_STRUC%IsT2
                if(err.ne.0) THEN
@@ -1365,11 +1366,11 @@ C
                endif 
                IF (INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("IsSLAVE")
+         CASE(B_IsSLAVE)
             NbRecords_BLR_STRUC_T(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_LOGICAL
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_LOGICAL
                write(unit,iostat=err) BLR_STRUC%IsSLAVE
                if(err.ne.0) then
@@ -1378,7 +1379,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_LOGICAL
                read(unit,iostat=err) BLR_STRUC%IsSLAVE
                if(err.ne.0) THEN
@@ -1388,9 +1389,9 @@ C
                endif 
                IF (INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("BEGS_BLR_STATIC")
+         CASE(B_BEGS_BLR_STATIC)
             NbRecords_BLR_STRUC_T(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(BLR_STRUC%BEGS_BLR_STATIC)) THEN
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=
@@ -1399,7 +1400,7 @@ C
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*2
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(BLR_STRUC%BEGS_BLR_STATIC)) THEN
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=
@@ -1431,7 +1432,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(BLR_STRUC%BEGS_BLR_STATIC)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -1465,9 +1466,9 @@ C
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("BEGS_BLR_DYNAMIC")
+         CASE(B_BEGS_BLR_DYNAMIC)
             NbRecords_BLR_STRUC_T(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(BLR_STRUC%BEGS_BLR_DYNAMIC)) THEN
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=
@@ -1476,7 +1477,7 @@ C
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*2
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(BLR_STRUC%BEGS_BLR_DYNAMIC)) THEN
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=
@@ -1508,7 +1509,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(BLR_STRUC%BEGS_BLR_DYNAMIC)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -1542,9 +1543,9 @@ C
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("BEGS_BLR_L")
+         CASE(B_BEGS_BLR_L)
             NbRecords_BLR_STRUC_T(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(BLR_STRUC%BEGS_BLR_L)) THEN
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=
@@ -1553,7 +1554,7 @@ C
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*2
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(BLR_STRUC%BEGS_BLR_L)) THEN
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=
@@ -1585,7 +1586,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(BLR_STRUC%BEGS_BLR_L)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -1619,9 +1620,9 @@ C
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("BEGS_BLR_COL")
+         CASE(B_BEGS_BLR_COL)
             NbRecords_BLR_STRUC_T(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(BLR_STRUC%BEGS_BLR_COL)) THEN
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=
@@ -1630,7 +1631,7 @@ C
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*2
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(BLR_STRUC%BEGS_BLR_COL)) THEN
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=
@@ -1662,7 +1663,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(BLR_STRUC%BEGS_BLR_COL)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -1696,11 +1697,11 @@ C
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("NB_ACCESSES_INIT")
+         CASE(B_NB_ACCESSES_INIT)
             NbRecords_BLR_STRUC_T(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_INT
                write(unit,iostat=err) BLR_STRUC%NB_ACCESSES_INIT
                if(err.ne.0) then
@@ -1709,7 +1710,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_INT
                read(unit,iostat=err) BLR_STRUC%NB_ACCESSES_INIT
                if(err.ne.0) THEN
@@ -1719,11 +1720,11 @@ C
                endif 
                IF (INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("NB_PANELS")
+         CASE(B_NB_PANELS)
             NbRecords_BLR_STRUC_T(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_INT
                write(unit,iostat=err) BLR_STRUC%NB_PANELS
                if(err.ne.0) then
@@ -1732,7 +1733,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_INT
                read(unit,iostat=err) BLR_STRUC%NB_PANELS
                if(err.ne.0) THEN
@@ -1742,8 +1743,8 @@ C
                endif 
                IF (INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PANELS_L")
-            if(trim(mode).EQ."memory_save") then
+         CASE(B_PANELS_L)
+            if(mode.EQ.memory_save_mode) then
                IF(associated(BLR_STRUC%PANELS_L)) THEN
                   NbRecords_BLR_STRUC_T(i1)=1
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
@@ -1751,7 +1752,7 @@ C
                   DO j1=1,size(BLR_STRUC%PANELS_L,1)
                      CALL ZMUMPS_SAVE_RESTORE_BLR_PANEL(
      &                    BLR_STRUC%PANELS_L(j1)
-     &                    ,unit,MYID,"memory_save"
+     &                    ,unit,MYID,memory_save_mode
      &                    ,SIZE_GEST_PANELS_L_j1
      &                    ,SIZE_VARIABLES_PANELS_L_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -1768,7 +1769,7 @@ C
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*2
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(BLR_STRUC%PANELS_L)) THEN
                   NbRecords_BLR_STRUC_T(i1)=1
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
@@ -1783,7 +1784,7 @@ C
                   DO j1=1,size(BLR_STRUC%PANELS_L,1)
                      CALL ZMUMPS_SAVE_RESTORE_BLR_PANEL(
      &                    BLR_STRUC%PANELS_L(j1)
-     &                    ,unit,MYID,"save"
+     &                    ,unit,MYID,save_mode
      &                    ,SIZE_GEST_PANELS_L_j1
      &                    ,SIZE_VARIABLES_PANELS_L_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -1811,7 +1812,7 @@ C
                   endif
                   IF ( INFO(1) .LT. 0 ) GOTO 100
                ENDIF 
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(BLR_STRUC%PANELS_L)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -1846,7 +1847,7 @@ C
                   DO j1=1,size_array1
                      CALL ZMUMPS_SAVE_RESTORE_BLR_PANEL(
      &                    BLR_STRUC%PANELS_L(j1)
-     &                    ,unit,MYID,"restore"
+     &                    ,unit,MYID,restore_mode
      &                    ,SIZE_GEST_PANELS_L_j1
      &                    ,SIZE_VARIABLES_PANELS_L_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -1860,8 +1861,8 @@ C
                   ENDDO
                endif
             endif
-            CASE("PANELS_U")
-            if(trim(mode).EQ."memory_save") then
+            CASE(B_PANELS_U)
+            if(mode.EQ.memory_save_mode) then
                IF(associated(BLR_STRUC%PANELS_U)) THEN
                   NbRecords_BLR_STRUC_T(i1)=1
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
@@ -1869,7 +1870,7 @@ C
                   DO j1=1,size(BLR_STRUC%PANELS_U,1)
                      CALL ZMUMPS_SAVE_RESTORE_BLR_PANEL(
      &                    BLR_STRUC%PANELS_U(j1)
-     &                    ,unit,MYID,"memory_save"
+     &                    ,unit,MYID,memory_save_mode
      &                    ,SIZE_GEST_PANELS_U_j1
      &                    ,SIZE_VARIABLES_PANELS_U_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -1886,7 +1887,7 @@ C
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*2
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(BLR_STRUC%PANELS_U)) THEN
                   NbRecords_BLR_STRUC_T(i1)=1
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
@@ -1901,7 +1902,7 @@ C
                   DO j1=1,size(BLR_STRUC%PANELS_U,1)
                      CALL ZMUMPS_SAVE_RESTORE_BLR_PANEL(
      &                    BLR_STRUC%PANELS_U(j1)
-     &                    ,unit,MYID,"save"
+     &                    ,unit,MYID,save_mode
      &                    ,SIZE_GEST_PANELS_U_j1
      &                    ,SIZE_VARIABLES_PANELS_U_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -1929,7 +1930,7 @@ C
                   endif
                   IF ( INFO(1) .LT. 0 ) GOTO 100
                ENDIF 
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(BLR_STRUC%PANELS_U)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -1964,7 +1965,7 @@ C
                   DO j1=1,size_array1
                      CALL ZMUMPS_SAVE_RESTORE_BLR_PANEL(
      &                    BLR_STRUC%PANELS_U(j1)
-     &                    ,unit,MYID,"restore"
+     &                    ,unit,MYID,restore_mode
      &                    ,SIZE_GEST_PANELS_U_j1
      &                    ,SIZE_VARIABLES_PANELS_U_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -1978,8 +1979,8 @@ C
                   ENDDO
                endif
             endif
-         CASE("CB_LRB")
-            if(trim(mode).EQ."memory_save") then
+         CASE(B_CB_LRB)
+            if(mode.EQ.memory_save_mode) then
                IF(associated(BLR_STRUC%CB_LRB)) THEN
                   NbRecords_BLR_STRUC_T(i1)=1
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*2
@@ -1988,7 +1989,7 @@ C
                      DO j2=1,size(BLR_STRUC%CB_LRB,2)
                         CALL ZMUMPS_SAVE_RESTORE_LRB(
      &                       BLR_STRUC%CB_LRB(j1,j2)
-     &                       ,unit,MYID,"memory_save"
+     &                       ,unit,MYID,memory_save_mode
      &                       ,SIZE_GEST_CB_LRB_j1j2
      &                       ,SIZE_VARIABLES_CB_LRB_j1j2
      &                       ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -2006,7 +2007,7 @@ C
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*3
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(BLR_STRUC%CB_LRB)) THEN
                   NbRecords_BLR_STRUC_T(i1)=1
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*2
@@ -2022,7 +2023,7 @@ C
                      DO j2=1,size(BLR_STRUC%CB_LRB,2)
                         CALL ZMUMPS_SAVE_RESTORE_LRB(
      &                       BLR_STRUC%CB_LRB(j1,j2)
-     &                       ,unit,MYID,"save"
+     &                       ,unit,MYID,save_mode
      &                       ,SIZE_GEST_CB_LRB_j1j2
      &                       ,SIZE_VARIABLES_CB_LRB_j1j2
      &                       ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -2051,7 +2052,7 @@ C
                   endif
                   IF ( INFO(1) .LT. 0 ) GOTO 100
                ENDIF 
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(BLR_STRUC%CB_LRB)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -2087,7 +2088,7 @@ C
                      DO j2=1,size_array2
                         CALL ZMUMPS_SAVE_RESTORE_LRB(
      &                       BLR_STRUC%CB_LRB(j1,j2)
-     &                       ,unit,MYID,"restore"
+     &                       ,unit,MYID,restore_mode
      &                       ,SIZE_GEST_CB_LRB_j1j2
      &                       ,SIZE_VARIABLES_CB_LRB_j1j2
      &                       ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -2102,8 +2103,8 @@ C
                   ENDDO
                endif
             endif
-         CASE("DIAG_BLOCKS")
-            if(trim(mode).EQ."memory_save") then
+         CASE(B_DIAG_BLOCKS)
+            if(mode.EQ.memory_save_mode) then
                IF(associated(BLR_STRUC%DIAG_BLOCKS)) THEN
                   NbRecords_BLR_STRUC_T(i1)=1
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
@@ -2111,7 +2112,7 @@ C
                   DO j1=1,size(BLR_STRUC%DIAG_BLOCKS,1)
                      CALL ZMUMPS_SAVE_RESTORE_DIAG_BLOCK(
      &                    BLR_STRUC%DIAG_BLOCKS(j1)
-     &                    ,unit,MYID,"memory_save"
+     &                    ,unit,MYID,memory_save_mode
      &                    ,SIZE_GEST_DIAG_BLOCKS_j1
      &                    ,SIZE_VARIABLES_DIAG_BLOCKS_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP
@@ -2129,7 +2130,7 @@ C
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT*2
                   SIZE_VARIABLES_BLR_STRUC_T(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(BLR_STRUC%DIAG_BLOCKS)) THEN
                   NbRecords_BLR_STRUC_T(i1)=1
                   SIZE_GEST_BLR_STRUC_T(i1)=SIZE_INT
@@ -2144,7 +2145,7 @@ C
                   DO j1=1,size(BLR_STRUC%DIAG_BLOCKS,1)
                      CALL ZMUMPS_SAVE_RESTORE_DIAG_BLOCK(
      &                    BLR_STRUC%DIAG_BLOCKS(j1)
-     &                    ,unit,MYID,"save"
+     &                    ,unit,MYID,save_mode
      &                    ,SIZE_GEST_DIAG_BLOCKS_j1
      &                    ,SIZE_VARIABLES_DIAG_BLOCKS_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP
@@ -2172,7 +2173,7 @@ C
                   endif
                   IF ( INFO(1) .LT. 0 ) GOTO 100
                ENDIF 
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(BLR_STRUC%DIAG_BLOCKS)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -2207,7 +2208,7 @@ C
                   DO j1=1,size_array1
                      CALL ZMUMPS_SAVE_RESTORE_DIAG_BLOCK(
      &                    BLR_STRUC%DIAG_BLOCKS(j1)
-     &                    ,unit,MYID,"restore"
+     &                    ,unit,MYID,restore_mode
      &                    ,SIZE_GEST_DIAG_BLOCKS_j1
      &                    ,SIZE_VARIABLES_DIAG_BLOCKS_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP
@@ -2222,11 +2223,11 @@ C
                   ENDDO
                endif
             endif
-         CASE("NFS4FATHER")
+         CASE(B_NFS4FATHER)
             NbRecords_BLR_STRUC_T(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_INT
                write(unit,iostat=err) BLR_STRUC%NFS4FATHER
                if(err.ne.0) then
@@ -2235,7 +2236,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_BLR_STRUC_T(i1)=SIZE_INT
                read(unit,iostat=err) BLR_STRUC%NFS4FATHER
                if(err.ne.0) THEN
@@ -2245,26 +2246,26 @@ C
                endif 
                IF (INFO(1) .LT. 0 ) GOTO 100
             endif
-            CASE("M_ARRAY")
-               if(trim(mode).EQ."restore") then
+            CASE(B_M_ARRAY)
+               if(mode.EQ.restore_mode) then
                   nullify(BLR_STRUC%M_ARRAY)
                endif
          CASE DEFAULT
          END SELECT
-         if(trim(mode).EQ."memory_save") then
+         if(mode.EQ.memory_save_mode) then
             NbSubRecords=int(SIZE_VARIABLES_BLR_STRUC_T(i1)/huge(I4))
             IF(NbSubRecords.GT.0) then
                NbRecords_BLR_STRUC_T(i1)=NbRecords_BLR_STRUC_T(i1)
      &              +NbSubRecords
             ENDIF
-         elseif(trim(mode).EQ."save") then
+         elseif(mode.EQ.save_mode) then
             size_written=size_written+SIZE_VARIABLES_BLR_STRUC_T(i1)
      &           +int(SIZE_GEST_BLR_STRUC_T(i1),kind=8)
 #if defined(MUMPS_NOF2003)
             size_written=size_written
      &           +int(2*SIZE_INT*NbRecords_BLR_STRUC_T(i1),kind=8)
 #endif
-         elseif(trim(mode).EQ."restore") then
+         elseif(mode.EQ.restore_mode) then
             size_allocated=size_allocated+
      &           SIZE_VARIABLES_BLR_STRUC_T(i1)
             size_read=size_read+SIZE_VARIABLES_BLR_STRUC_T(i1)
@@ -2275,7 +2276,7 @@ C
 #endif
          endif
       ENDDO
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          Local_SIZE_VARIABLES=sum(SIZE_VARIABLES_BLR_STRUC_T)
      &        +SIZE_VARIABLES_PANELS_L
      &        +SIZE_VARIABLES_PANELS_U
@@ -2304,18 +2305,20 @@ C
       INCLUDE 'mpif.h'
       TYPE(LRB_TYPE) :: LRB_T
       INTEGER,intent(IN)::unit,MYID
-      CHARACTER(len=*),intent(IN) :: mode
+      INTEGER,intent(IN) :: mode
       INTEGER,INTENT(OUT) :: Local_SIZE_GEST
       INTEGER(8),intent(OUT) :: Local_SIZE_VARIABLES
       INTEGER,intent(INOUT):: INFO(2)
       INTEGER,intent(IN):: SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
       INTEGER(8),intent(IN) :: TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
       INTEGER(8),intent(INOUT):: size_read,size_allocated,size_written
-      INTEGER :: NBVARIABLES_LRB_TYPE
-      PARAMETER (NBVARIABLES_LRB_TYPE = 6)
-      CHARACTER(len=30), dimension(NBVARIABLES_LRB_TYPE)::
-     &     VARIABLES_LRB_TYPE
-      CHARACTER(len=30) :: TMP_STRING
+      INTEGER, PARAMETER :: LRB_Q=1
+      INTEGER, PARAMETER :: LRB_R=2
+      INTEGER, PARAMETER :: LRB_K=3
+      INTEGER, PARAMETER :: LRB_M=4
+      INTEGER, PARAMETER :: LRB_N=5
+      INTEGER, PARAMETER :: LRB_ISLR=6
+      INTEGER, PARAMETER :: NBVARIABLES_LRB_TYPE=6
       INTEGER(8),dimension(NBVARIABLES_LRB_TYPE)::
      &     SIZE_VARIABLES_LRB_TYPE
       INTEGER,dimension(NBVARIABLES_LRB_TYPE)::
@@ -2328,21 +2331,14 @@ C
       INTEGER:: Local_NbRecords
 #endif
       INTEGER(4) ::I4
-      VARIABLES_LRB_TYPE(1)="Q"
-      VARIABLES_LRB_TYPE(2)="R"
-      VARIABLES_LRB_TYPE(3)="K"
-      VARIABLES_LRB_TYPE(4)="M"
-      VARIABLES_LRB_TYPE(5)="N"
-      VARIABLES_LRB_TYPE(6)="ISLR"
       SIZE_VARIABLES_LRB_TYPE(:)=0_8
       SIZE_GEST_LRB_TYPE(:)=0
       NbRecords_LRB_TYPE(:)=0
       DO i1=1,NBVARIABLES_LRB_TYPE
-         TMP_STRING = VARIABLES_LRB_TYPE(i1)
-         SELECT CASE(TMP_STRING)
-         CASE("Q")
+         SELECT CASE(i1)
+         CASE(LRB_Q)
             NbRecords_LRB_TYPE(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(LRB_T%Q)) THEN
                   SIZE_GEST_LRB_TYPE(i1)=SIZE_INT*2
                   SIZE_VARIABLES_LRB_TYPE(i1)=
@@ -2352,7 +2348,7 @@ C
                   SIZE_GEST_LRB_TYPE(i1)=SIZE_INT*3
                   SIZE_VARIABLES_LRB_TYPE(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(LRB_T%Q)) THEN
                   SIZE_GEST_LRB_TYPE(i1)=SIZE_INT*2
                   SIZE_VARIABLES_LRB_TYPE(i1)=
@@ -2384,7 +2380,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 300
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(LRB_T%Q)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -2419,9 +2415,9 @@ C
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 300
             endif
-         CASE("R")
+         CASE(LRB_R)
             NbRecords_LRB_TYPE(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(LRB_T%R)) THEN
                   SIZE_GEST_LRB_TYPE(i1)=SIZE_INT*2
                   SIZE_VARIABLES_LRB_TYPE(i1)=
@@ -2431,7 +2427,7 @@ C
                   SIZE_GEST_LRB_TYPE(i1)=SIZE_INT*3
                   SIZE_VARIABLES_LRB_TYPE(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(LRB_T%R)) THEN
                   SIZE_GEST_LRB_TYPE(i1)=SIZE_INT*2
                   SIZE_VARIABLES_LRB_TYPE(i1)=
@@ -2463,7 +2459,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 300
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(LRB_T%R)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -2498,11 +2494,11 @@ C
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 300
             endif
-         CASE("K")
+         CASE(LRB_K)
             NbRecords_LRB_TYPE(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_INT
                write(unit,iostat=err) LRB_T%K
                if(err.ne.0) then
@@ -2511,7 +2507,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 300
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_INT
                read(unit,iostat=err) LRB_T%K
                if(err.ne.0) THEN
@@ -2521,11 +2517,11 @@ C
                endif 
                IF ( INFO(1) .LT. 0 ) GOTO 300
             endif
-         CASE("M")
+         CASE(LRB_M)
             NbRecords_LRB_TYPE(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_INT
                write(unit,iostat=err) LRB_T%M
                if(err.ne.0) then
@@ -2534,7 +2530,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 300
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_INT
                read(unit,iostat=err) LRB_T%M
                if(err.ne.0) THEN
@@ -2544,11 +2540,11 @@ C
                endif 
                IF ( INFO(1) .LT. 0 ) GOTO 300
             endif
-         CASE("N")
+         CASE(LRB_N)
             NbRecords_LRB_TYPE(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_INT
                write(unit,iostat=err) LRB_T%N
                if(err.ne.0) then
@@ -2557,7 +2553,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 300
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_INT
                read(unit,iostat=err) LRB_T%N
                if(err.ne.0) THEN
@@ -2567,11 +2563,11 @@ C
                endif 
                IF ( INFO(1) .LT. 0 ) GOTO 300
             endif
-         CASE("ISLR")
+         CASE(LRB_ISLR)
             NbRecords_LRB_TYPE(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_LOGICAL
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_LOGICAL
                write(unit,iostat=err) LRB_T%ISLR
                if(err.ne.0) then
@@ -2580,7 +2576,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 300
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_LRB_TYPE(i1)=SIZE_LOGICAL
                read(unit,iostat=err) LRB_T%ISLR
                if(err.ne.0) THEN
@@ -2592,21 +2588,21 @@ C
             endif   
          CASE DEFAULT
          END SELECT
-         if(trim(mode).EQ."memory_save") then
+         if(mode.EQ.memory_save_mode) then
             NbSubRecords=int(SIZE_VARIABLES_LRB_TYPE(i1)/huge(I4))
             IF(NbSubRecords.GT.0) then
                NbRecords_LRB_TYPE(i1)=
      &              NbRecords_LRB_TYPE(i1)
      &              +NbSubRecords
             ENDIF
-         elseif(trim(mode).EQ."save") then
+         elseif(mode.EQ.save_mode) then
             size_written=size_written+SIZE_VARIABLES_LRB_TYPE(i1)
      &           +int(SIZE_GEST_LRB_TYPE(i1),kind=8)
 #if defined(MUMPS_NOF2003)
             size_written=size_written
      &           +int(2*SIZE_INT*NbRecords_LRB_TYPE(i1),kind=8)
 #endif
-         elseif(trim(mode).EQ."restore") then
+         elseif(mode.EQ.restore_mode) then
             size_allocated=size_allocated+
      &           SIZE_VARIABLES_LRB_TYPE(i1)
             size_read=size_read+SIZE_VARIABLES_LRB_TYPE(i1)
@@ -2617,7 +2613,7 @@ C
 #endif
          endif
       ENDDO
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          Local_SIZE_VARIABLES=sum(SIZE_VARIABLES_LRB_TYPE)
          Local_SIZE_GEST=sum(SIZE_GEST_LRB_TYPE)
 #if defined(MUMPS_NOF2003)
@@ -2638,18 +2634,16 @@ C
       INCLUDE 'mpif.h'
       TYPE(blr_panel_type) :: BLR_PANEL_T
       INTEGER,intent(IN)::unit,MYID
-      CHARACTER(len=*),intent(IN) :: mode
+      INTEGER,intent(IN) :: mode
       INTEGER,INTENT(OUT) :: Local_SIZE_GEST
       INTEGER(8),intent(OUT) :: Local_SIZE_VARIABLES
       INTEGER,intent(INOUT):: INFO(2)
       INTEGER,intent(IN):: SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
       INTEGER(8),intent(IN) :: TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
       INTEGER(8),intent(INOUT):: size_read,size_allocated,size_written
-      INTEGER :: NBVARIABLES_BLR_PANEL_TYPE
-      PARAMETER (NBVARIABLES_BLR_PANEL_TYPE = 2)
-      CHARACTER(len=30), dimension(NBVARIABLES_BLR_PANEL_TYPE)::
-     &     VARIABLES_BLR_PANEL_TYPE
-      CHARACTER(len=30) :: TMP_STRING
+      INTEGER, PARAMETER :: P_NB_ACCESSES_LEFT=1
+      INTEGER, PARAMETER :: P_LRB_PANEL=2
+      INTEGER, PARAMETER :: NBVARIABLES_BLR_PANEL_TYPE = 2
       INTEGER(8),dimension(NBVARIABLES_BLR_PANEL_TYPE)::
      &     SIZE_VARIABLES_BLR_PANEL_TYPE
       INTEGER,dimension(NBVARIABLES_BLR_PANEL_TYPE)::
@@ -2664,8 +2658,6 @@ C
       INTEGER:: SIZE_GEST_LRB_PANEL_j1,SIZE_GEST_LRB_PANEL
       INTEGER(8)::SIZE_VARIABLES_LRB_PANEL_j1,SIZE_VARIABLES_LRB_PANEL
       INTEGER(4)::I4
-      VARIABLES_BLR_PANEL_TYPE(1)="NB_ACCESSES_LEFT"
-      VARIABLES_BLR_PANEL_TYPE(2)="LRB_PANEL"
       SIZE_VARIABLES_BLR_PANEL_TYPE(:)=0_8
       SIZE_GEST_BLR_PANEL_TYPE(:)=0
       NbRecords_BLR_PANEL_TYPE(:)=0
@@ -2674,13 +2666,12 @@ C
       SIZE_VARIABLES_LRB_PANEL_j1=0_8
       SIZE_VARIABLES_LRB_PANEL=0_8
       DO i1=1,NBVARIABLES_BLR_PANEL_TYPE
-         TMP_STRING = VARIABLES_BLR_PANEL_TYPE(i1)
-         SELECT CASE(TMP_STRING)
-         CASE("NB_ACCESSES_LEFT")
+         SELECT CASE(i1)
+         CASE(P_NB_ACCESSES_LEFT)
             NbRecords_BLR_PANEL_TYPE(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES_BLR_PANEL_TYPE(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                SIZE_VARIABLES_BLR_PANEL_TYPE(i1)=SIZE_INT
                write(unit,iostat=err) BLR_PANEL_T%NB_ACCESSES_LEFT
                if(err.ne.0) then
@@ -2689,7 +2680,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 400
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES_BLR_PANEL_TYPE(i1)=SIZE_INT
                read(unit,iostat=err) BLR_PANEL_T%NB_ACCESSES_LEFT
                if(err.ne.0) THEN
@@ -2699,8 +2690,8 @@ C
                endif 
                IF ( INFO(1) .LT. 0 ) GOTO 400
             endif
-         CASE("LRB_PANEL")
-            if(trim(mode).EQ."memory_save") then
+         CASE(P_LRB_PANEL)
+            if(mode.EQ.memory_save_mode) then
                IF(associated(BLR_PANEL_T%LRB_PANEL)) THEN
                   NbRecords_BLR_PANEL_TYPE(i1)=1
                   SIZE_GEST_BLR_PANEL_TYPE(i1)=SIZE_INT
@@ -2708,7 +2699,7 @@ C
                   DO j1=1,size(BLR_PANEL_T%LRB_PANEL,1)
                      CALL ZMUMPS_SAVE_RESTORE_LRB(
      &                    BLR_PANEL_T%LRB_PANEL(j1)
-     &                    ,unit,MYID,"memory_save"
+     &                    ,unit,MYID,memory_save_mode
      &                    ,SIZE_GEST_LRB_PANEL_j1
      &                    ,SIZE_VARIABLES_LRB_PANEL_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -2725,7 +2716,7 @@ C
                   SIZE_GEST_BLR_PANEL_TYPE(i1)=SIZE_INT*2
                   SIZE_VARIABLES_BLR_PANEL_TYPE(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(BLR_PANEL_T%LRB_PANEL)) THEN
                   NbRecords_BLR_PANEL_TYPE(i1)=1
                   SIZE_GEST_BLR_PANEL_TYPE(i1)=SIZE_INT
@@ -2740,7 +2731,7 @@ C
                   DO j1=1,size(BLR_PANEL_T%LRB_PANEL,1)
                      CALL ZMUMPS_SAVE_RESTORE_LRB(
      &                    BLR_PANEL_T%LRB_PANEL(j1)
-     &                    ,unit,MYID,"save"
+     &                    ,unit,MYID,save_mode
      &                    ,SIZE_GEST_LRB_PANEL_j1
      &                    ,SIZE_VARIABLES_LRB_PANEL_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -2768,7 +2759,7 @@ C
                   endif
                   IF ( INFO(1) .LT. 0 ) GOTO 400
                ENDIF 
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(BLR_PANEL_T%LRB_PANEL)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -2803,7 +2794,7 @@ C
                   DO j1=1,size_array1
                      CALL ZMUMPS_SAVE_RESTORE_LRB(
      &                    BLR_PANEL_T%LRB_PANEL(j1)
-     &                    ,unit,MYID,"restore"
+     &                    ,unit,MYID,restore_mode
      &                    ,SIZE_GEST_LRB_PANEL_j1
      &                    ,SIZE_VARIABLES_LRB_PANEL_j1
      &                    ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
@@ -2819,21 +2810,21 @@ C
             endif
          CASE DEFAULT
          END SELECT
-         if(trim(mode).EQ."memory_save") then
+         if(mode.EQ.memory_save_mode) then
             NbSubRecords=int(SIZE_VARIABLES_BLR_PANEL_TYPE(i1)/huge(I4))
             IF(NbSubRecords.GT.0) then
                NbRecords_BLR_PANEL_TYPE(i1)=
      &              NbRecords_BLR_PANEL_TYPE(i1)
      &              +NbSubRecords
             ENDIF
-         elseif(trim(mode).EQ."save") then
+         elseif(mode.EQ.save_mode) then
             size_written=size_written+SIZE_VARIABLES_BLR_PANEL_TYPE(i1)
      &           +int(SIZE_GEST_BLR_PANEL_TYPE(i1),kind=8)
 #if defined(MUMPS_NOF2003)
             size_written=size_written
      &           +int(2*SIZE_INT*NbRecords_BLR_PANEL_TYPE(i1),kind=8)
 #endif
-         elseif(trim(mode).EQ."restore") then
+         elseif(mode.EQ.restore_mode) then
             size_allocated=size_allocated+
      &           SIZE_VARIABLES_BLR_PANEL_TYPE(i1)
             size_read=size_read+SIZE_VARIABLES_BLR_PANEL_TYPE(i1)
@@ -2844,7 +2835,7 @@ C
 #endif
          endif
       ENDDO
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          Local_SIZE_VARIABLES=sum(SIZE_VARIABLES_BLR_PANEL_TYPE)+
      &        SIZE_VARIABLES_LRB_PANEL
          Local_SIZE_GEST=sum(SIZE_GEST_BLR_PANEL_TYPE)+
@@ -2867,18 +2858,15 @@ C
       INCLUDE 'mpif.h'
       TYPE(diag_block_type) :: DIAG_BLOCK_T
       INTEGER,intent(IN)::unit,MYID
-      CHARACTER(len=*),intent(IN) :: mode
+      INTEGER,intent(IN) :: mode
       INTEGER,INTENT(OUT) :: Local_SIZE_GEST
       INTEGER(8),intent(OUT) :: Local_SIZE_VARIABLES
       INTEGER,intent(INOUT):: INFO(2)
       INTEGER,intent(IN):: SIZE_INT, SIZE_ARITH_DEP
       INTEGER(8),intent(IN) :: TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
       INTEGER(8),intent(INOUT):: size_read,size_allocated,size_written
-      INTEGER :: NBVARIABLES_DIAG_BLOCK_TYPE
-      PARAMETER (NBVARIABLES_DIAG_BLOCK_TYPE = 1)
-      CHARACTER(len=30), dimension(NBVARIABLES_DIAG_BLOCK_TYPE)::
-     &     VARIABLES_DIAG_BLOCK_TYPE
-      CHARACTER(len=30) :: TMP_STRING
+      INTEGER, PARAMETER :: D_DIAG_BLOCK=1
+      INTEGER, PARAMETER :: NBVARIABLES_DIAG_BLOCK_TYPE = 1
       INTEGER(8),dimension(NBVARIABLES_DIAG_BLOCK_TYPE)::
      &     SIZE_VARIABLES_DIAG_BLOCK_TYPE
       INTEGER,dimension(NBVARIABLES_DIAG_BLOCK_TYPE)::
@@ -2891,16 +2879,14 @@ C
       INTEGER:: Local_NbRecords
 #endif
       INTEGER(4) :: I4
-      VARIABLES_DIAG_BLOCK_TYPE(1)="DIAG_BLOCK"
       SIZE_VARIABLES_DIAG_BLOCK_TYPE(:)=0_8
       SIZE_GEST_DIAG_BLOCK_TYPE(:)=0
       NbRecords_DIAG_BLOCK_TYPE(:)=0
       DO i1=1,NBVARIABLES_DIAG_BLOCK_TYPE
-         TMP_STRING = VARIABLES_DIAG_BLOCK_TYPE(i1)
-         SELECT CASE(TMP_STRING)
-         CASE("DIAG_BLOCK")
+         SELECT CASE(i1)
+         CASE(D_DIAG_BLOCK)
             NbRecords_DIAG_BLOCK_TYPE(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(DIAG_BLOCK_T%DIAG_BLOCK)) THEN
                   SIZE_GEST_DIAG_BLOCK_TYPE(i1)=SIZE_INT
                   SIZE_VARIABLES_DIAG_BLOCK_TYPE(i1)=
@@ -2910,7 +2896,7 @@ C
                   SIZE_GEST_DIAG_BLOCK_TYPE(i1)=SIZE_INT*2
                   SIZE_VARIABLES_DIAG_BLOCK_TYPE(i1)=0
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(DIAG_BLOCK_T%DIAG_BLOCK)) THEN
                   SIZE_GEST_DIAG_BLOCK_TYPE(i1)=SIZE_INT
                   SIZE_VARIABLES_DIAG_BLOCK_TYPE(i1)=
@@ -2942,7 +2928,7 @@ C
      &                 INFO(2))
                endif
                IF ( INFO(1) .LT. 0 ) GOTO 200
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(DIAG_BLOCK_T%DIAG_BLOCK)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -2979,7 +2965,7 @@ C
             endif
          CASE DEFAULT
          END SELECT
-         if(trim(mode).EQ."memory_save") then
+         if(mode.EQ.memory_save_mode) then
             NbSubRecords=int(SIZE_VARIABLES_DIAG_BLOCK_TYPE(i1)/
      &      huge(I4))
             IF(NbSubRecords.GT.0) then
@@ -2987,14 +2973,14 @@ C
      &              NbRecords_DIAG_BLOCK_TYPE(i1)
      &              +NbSubRecords
             ENDIF
-         elseif(trim(mode).EQ."save") then
+         elseif(mode.EQ.save_mode) then
             size_written=size_written+SIZE_VARIABLES_DIAG_BLOCK_TYPE(i1)
      &           +int(SIZE_GEST_DIAG_BLOCK_TYPE(i1),kind=8)
 #if defined(MUMPS_NOF2003)
             size_written=size_written
      &           +int(2*SIZE_INT*NbRecords_DIAG_BLOCK_TYPE(i1),kind=8)
 #endif
-         elseif(trim(mode).EQ."restore") then
+         elseif(mode.EQ.restore_mode) then
             size_allocated=size_allocated+
      &           SIZE_VARIABLES_DIAG_BLOCK_TYPE(i1)
             size_read=size_read+SIZE_VARIABLES_DIAG_BLOCK_TYPE(i1)
@@ -3005,7 +2991,7 @@ C
 #endif
          endif
       ENDDO
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          Local_SIZE_VARIABLES=sum(SIZE_VARIABLES_DIAG_BLOCK_TYPE)
          Local_SIZE_GEST=sum(SIZE_GEST_DIAG_BLOCK_TYPE)
 #if defined(MUMPS_NOF2003)
@@ -3016,4 +3002,5 @@ C
  200  continue
       RETURN
       END SUBROUTINE ZMUMPS_SAVE_RESTORE_DIAG_BLOCK
+#endif
       END MODULE ZMUMPS_LR_DATA_M
diff -pruN 5.6.2-2.1/src/zmumps_mpi3_mod.F 5.7.1-1/src/zmumps_mpi3_mod.F
--- 5.6.2-2.1/src/zmumps_mpi3_mod.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zmumps_mpi3_mod.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/zmumps_ooc.F 5.7.1-1/src/zmumps_ooc.F
--- 5.6.2-2.1/src/zmumps_ooc.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zmumps_ooc.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -17,6 +17,7 @@ C
 !$   &                    OMP_INIT_LOCK, OMP_DESTROY_LOCK, OMP_TEST_LOCK
       IMPLICIT NONE
 !$     INTEGER(KIND=OMP_LOCK_KIND) :: LOCK_FOR_L0OMP
+      INTEGER, PARAMETER :: FILENAMELENGTH=1300
       INTEGER NOT_IN_MEM,BEING_READ,NOT_USED,PERMUTED,USED,
      &     USED_NOT_PERMUTED,ALREADY_USED
       PARAMETER (NOT_IN_MEM=0,BEING_READ=-1,NOT_USED=-2,
@@ -44,7 +45,6 @@ C
      &     ,NB_CALLED,REQ_ACT,NB_CALL
       INTEGER(8), SAVE :: OOC_VADDR_PTR
       INTEGER(8), SAVE :: SIZE_ZONE_REQ
-      DOUBLE PRECISION,SAVE :: MAX_OOC_FILE_SIZE
       INTEGER(8), DIMENSION(:), ALLOCATABLE :: SIZE_OF_READ, READ_DEST
       INTEGER,DIMENSION(:),ALLOCATABLE :: FIRST_POS_IN_READ,
      &     READ_MNG,REQ_TO_ZONE,POS_HOLE_T,
@@ -114,18 +114,16 @@ C
       USE ZMUMPS_STRUC_DEF
       USE ZMUMPS_OOC_BUFFER
       IMPLICIT NONE
-      INTEGER TMPDIR_MAX_LENGTH, PREFIX_MAX_LENGTH
-      PARAMETER (TMPDIR_MAX_LENGTH=255, PREFIX_MAX_LENGTH=63)
+      INTEGER OOC_TMPDIR_MAX_LENGTH, OOC_PREFIX_MAX_LENGTH
+      PARAMETER (OOC_TMPDIR_MAX_LENGTH=1023, OOC_PREFIX_MAX_LENGTH=255)
       INTEGER(8), intent(in) :: MAXS  
       TYPE(ZMUMPS_STRUC), TARGET :: id
       INTEGER IERR
       INTEGER allocok
-      CHARACTER(len=1):: TMP_DIR(TMPDIR_MAX_LENGTH),
-     &            TMP_PREFIX(PREFIX_MAX_LENGTH)
-      INTEGER DIM_DIR,DIM_PREFIX
+      INTEGER DIM_TMPDIR,DIM_PREFIX
       INTEGER, DIMENSION(:), ALLOCATABLE :: FILE_FLAG_TAB
       INTEGER TMP
-      INTEGER K211_LOC
+      INTEGER KEEP211_LOC
       ICNTL1=id%ICNTL(1)
       MAX_SIZE_FACTOR_OOC=0_8
       N_OOC=id%N
@@ -234,14 +232,10 @@ C
       ENDIF
       DIM_ERR_STR_OOC = ERR_STR_OOC_MAX_LEN
       CALL MUMPS_LOW_LEVEL_INIT_ERR_STR(DIM_ERR_STR_OOC,ERR_STR_OOC)
-      DIM_DIR=len(trim(id%OOC_TMPDIR))
+      DIM_TMPDIR=len(trim(id%OOC_TMPDIR))
       DIM_PREFIX=len(trim(id%OOC_PREFIX))
-      CALL ZMUMPS_CONVERT_STR_TO_CHR_ARRAY(TMP_DIR(1),
-     &     id%OOC_TMPDIR, TMPDIR_MAX_LENGTH, DIM_DIR )
-      CALL ZMUMPS_CONVERT_STR_TO_CHR_ARRAY(TMP_PREFIX(1),
-     &     id%OOC_PREFIX, PREFIX_MAX_LENGTH, DIM_PREFIX)
-      CALL MUMPS_LOW_LEVEL_INIT_PREFIX(DIM_PREFIX, TMP_PREFIX)
-      CALL MUMPS_LOW_LEVEL_INIT_TMPDIR(DIM_DIR, TMP_DIR)
+      CALL MUMPS_LOW_LEVEL_INIT_PREFIX(DIM_PREFIX, id%OOC_PREFIX)
+      CALL MUMPS_LOW_LEVEL_INIT_TMPDIR(DIM_TMPDIR, id%OOC_TMPDIR)
       ALLOCATE(FILE_FLAG_TAB(OOC_NB_FILE_TYPE),
      &     stat=allocok)
       IF (allocok .GT. 0) THEN
@@ -260,8 +254,8 @@ C
          TMP=max(1,TMP/2)
       ENDIF
       CALL MUMPS_LOW_LEVEL_INIT_OOC_C(MYID_OOC,TMP,
-     &     id%KEEP(35),LOW_LEVEL_STRAT_IO,K211_LOC,OOC_NB_FILE_TYPE,
-     &     FILE_FLAG_TAB,IERR)
+     &     id%KEEP(35),LOW_LEVEL_STRAT_IO,KEEP211_LOC,OOC_NB_FILE_TYPE,
+     &     FILE_FLAG_TAB,id%KEEP(255),IERR)
       IF(IERR.LT.0)THEN
          IF (ICNTL1 .GT. 0 ) THEN
            WRITE(ICNTL1,*)MYID_OOC,': PB in MUMPS_LOW_LEVEL_INIT_OOC_C'
@@ -271,7 +265,6 @@ C
          id%INFO(2) = 0
          RETURN
       ENDIF
-      CALL MUMPS_GET_MAX_FILE_SIZE_C(MAX_OOC_FILE_SIZE)
       DEALLOCATE(FILE_FLAG_TAB)
       RETURN
       END SUBROUTINE ZMUMPS_OOC_INIT_FACTO
@@ -506,7 +499,7 @@ C
       TYPE(ZMUMPS_STRUC), TARGET :: id
       INTEGER IERR
       INTEGER I,J,I1,K
-      CHARACTER(len=1):: TMP_NAME(350)
+      CHARACTER(len=1):: TMP_NAME(FILENAMELENGTH)
       IERR=0
       K=1
       IF(.NOT. id%ASSOCIATED_OOC_FILES) THEN
@@ -1367,7 +1360,9 @@ C
       IMPLICIT NONE
       INTEGER INODE
       IF ( (KEEP_OOC(237).EQ.0)
-     &     .AND. (KEEP_OOC(235).EQ.0) ) THEN
+     &     .AND. (KEEP_OOC(235).EQ.0) 
+     &     .AND. (KEEP_OOC(212).EQ.0)
+     &   ) THEN
       IF(OOC_STATE_NODE(STEP_OOC(INODE)).NE.NOT_USED)THEN
          WRITE(*,*)MYID_OOC,': INTERNAL ERROR (51) in OOC',INODE,
      &        OOC_STATE_NODE(STEP_OOC(INODE))
@@ -2618,7 +2613,8 @@ C
                  SET_POS_SEQUENCE = .FALSE.
                  CUR_POS_SEQUENCE = I
                ENDIF
-               IF (KEEP_OOC(237).EQ.0 .AND. KEEP_OOC(235).EQ.0) THEN
+               IF (KEEP_OOC(237).EQ.0 .AND. KEEP_OOC(235).EQ.0
+     &              .AND. KEEP_OOC(212).EQ.0 ) THEN
                  OOC_STATE_NODE(STEP_OOC(J)) = NOT_IN_MEM
                ENDIF
                CYCLE
@@ -2638,7 +2634,8 @@ C
                         CALL MUMPS_ABORT()
                      ENDIF                     
                   ENDIF
-                 IF (KEEP_OOC(237).NE.0 .OR. KEEP_OOC(235).NE.0) 
+                 IF (KEEP_OOC(237).NE.0 .OR. KEEP_OOC(235).NE.0
+     &               .OR.  KEEP_OOC(212).NE.0 ) 
      &              THEN
                   IF (OOC_STATE_NODE(STEP_OOC(J)).EQ.NOT_IN_MEM) THEN
                      OOC_STATE_NODE(STEP_OOC(J)) = USED
@@ -2657,13 +2654,15 @@ C
                     CALL MUMPS_ABORT()
                   ENDIF
                  ENDIF
-                 IF (KEEP_OOC(237).EQ.0 .AND. KEEP_OOC(235).EQ.0) THEN
+                 IF (KEEP_OOC(237).EQ.0 .AND. KEEP_OOC(235).EQ.0
+     &               .AND. KEEP_OOC(212).EQ.0 ) THEN
                     CALL ZMUMPS_SOLVE_UPD_NODE_INFO(J,PTRFAC,NSTEPS)
                  ENDIF
                ENDIF
             ENDIF 
       ENDDO
-         IF (KEEP_OOC(237).NE.0 .OR. KEEP_OOC(235).NE.0) 
+         IF (KEEP_OOC(237).NE.0 .OR. KEEP_OOC(235).NE.0 .OR.
+     &       KEEP_OOC(212).NE.0 ) 
      &      THEN
            IF (COMPRESS_TO_BE_DONE) THEN 
              DO ZONE=1,NB_Z-1
@@ -2789,7 +2788,7 @@ C
       TYPE(ZMUMPS_STRUC), TARGET :: id
       INTEGER, intent(out) :: IERR
       INTEGER I,DIM,J,TMP,SIZE,K,I1
-      CHARACTER(len=1):: TMP_NAME(350)
+      CHARACTER(len=1):: TMP_NAME(FILENAMELENGTH)
       EXTERNAL MUMPS_OOC_GET_NB_FILES_C, MUMPS_OOC_GET_FILE_NAME_C
       IERR=0
       SIZE=0
@@ -2803,7 +2802,7 @@ C
          DEALLOCATE(id%OOC_FILE_NAMES)
          NULLIFY(id%OOC_FILE_NAMES)
       ENDIF
-      ALLOCATE(id%OOC_FILE_NAMES(SIZE,350),stat=IERR)
+      ALLOCATE(id%OOC_FILE_NAMES(SIZE,FILENAMELENGTH),stat=IERR)
       IF (IERR .GT. 0) THEN
          IF (ICNTL1.GT.0) THEN
             WRITE(ICNTL1,*) 'PB allocation in ',
@@ -2812,7 +2811,7 @@ C
          IERR=-1
          IF(id%INFO(1).GE.0)THEN
             id%INFO(1) = -13
-            id%INFO(2) = SIZE*350
+            id%INFO(2) = SIZE*FILENAMELENGTH
             RETURN
          ENDIF
       ENDIF
@@ -2850,10 +2849,9 @@ C
       USE ZMUMPS_STRUC_DEF
       IMPLICIT NONE
       TYPE(ZMUMPS_STRUC), TARGET :: id
-      CHARACTER(len=1):: TMP_NAME(350)
+      CHARACTER(len=1):: TMP_NAME(FILENAMELENGTH)
       INTEGER I,I1,TMP,J,K,L,DIM,IERR
       INTEGER, DIMENSION(:),ALLOCATABLE :: NB_FILES
-      INTEGER K211
       ALLOCATE(NB_FILES(OOC_NB_FILE_TYPE),stat=IERR)
       IF (IERR .GT. 0) THEN
          IERR=-1
@@ -2872,7 +2870,6 @@ C
       I=id%MYID
       K=id%KEEP(35)
       L=mod(id%KEEP(204),3)
-      K211=id%KEEP(211)
       CALL MUMPS_OOC_ALLOC_POINTERS_C(OOC_NB_FILE_TYPE,NB_FILES,IERR)
       IF(IERR.LT.0)THEN
          IF (ICNTL1.GT.0)
@@ -2880,7 +2877,7 @@ C
          id%INFO(1)=IERR
          RETURN
       ENDIF
-      CALL MUMPS_OOC_INIT_VARS_C(I,K,L,K211,IERR)
+      CALL MUMPS_OOC_INIT_VARS_C(I,K,L,id%KEEP(211),id%KEEP(255),IERR)
       IF(IERR.LT.0)THEN
          IF (ICNTL1.GT.0)
      &   WRITE(ICNTL1,*)MYID_OOC,': ',ERR_STR_OOC(1:DIM_ERR_STR_OOC)
@@ -2916,16 +2913,6 @@ C
       DEALLOCATE(NB_FILES)
       RETURN
       END SUBROUTINE ZMUMPS_OOC_OPEN_FILES_FOR_SOLVE      
-      SUBROUTINE ZMUMPS_CONVERT_STR_TO_CHR_ARRAY(DEST,SRC,NB,NB_EFF)
-      IMPLICIT NONE
-      INTEGER NB, NB_EFF
-      CHARACTER(LEN=NB):: SRC
-      CHARACTER(len=1):: DEST(NB)
-      INTEGER I
-      DO I=1,NB_EFF
-         DEST(I)=SRC(I:I)
-      ENDDO
-      END SUBROUTINE ZMUMPS_CONVERT_STR_TO_CHR_ARRAY
       SUBROUTINE ZMUMPS_FORCE_WRITE_BUF(IERR)
       USE ZMUMPS_OOC_BUFFER
       IMPLICIT NONE
diff -pruN 5.6.2-2.1/src/zmumps_ooc_buffer.F 5.7.1-1/src/zmumps_ooc_buffer.F
--- 5.6.2-2.1/src/zmumps_ooc_buffer.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zmumps_ooc_buffer.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/zmumps_save_restore.F 5.7.1-1/src/zmumps_save_restore.F
--- 5.6.2-2.1/src/zmumps_save_restore.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/zmumps_save_restore.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -11,15 +11,18 @@ C  released under the CeCILL-C license
 C  (see doc/CeCILL-C_V1-en.txt, doc/CeCILL-C_V1-fr.txt, and
 C  https://cecill.info/licences/Licence_CeCILL-C_V1-en.html)
 C
+#if ! defined(NO_SAVE_RESTORE)
       MODULE ZMUMPS_SAVE_RESTORE
       USE ZMUMPS_STRUC_DEF
       USE ZMUMPS_SAVE_RESTORE_FILES
       USE ZMUMPS_LR_DATA_M
       USE MUMPS_FRONT_DATA_MGT_M
       IMPLICIT NONE
+      INCLUDE 'mumps_save_restore_modes.h'
       CONTAINS
       SUBROUTINE ZMUMPS_REMOVE_SAVED(id)
-      USE ZMUMPS_OOC
+      USE ZMUMPS_OOC 
+      IMPLICIT NONE
       INCLUDE 'mpif.h'
       INTEGER MASTER
       PARAMETER ( MASTER = 0 )
@@ -151,6 +154,7 @@ C
       RETURN
       END SUBROUTINE ZMUMPS_REMOVE_SAVED
       SUBROUTINE ZMUMPS_RESTORE_OOC(localid)
+      IMPLICIT NONE
       INCLUDE 'mpif.h'
       INTEGER::ierr,IN,NBVARIABLES,NBVARIABLES_ROOT
       CHARACTER(len=LEN_SAVE_FILE):: restore_file_ooc,INFO_FILE
@@ -161,7 +165,7 @@ C
       INTEGER:: INFO1,INFO2,INFOG1,INFOG2,allocok
       INTEGER(8) :: TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
       TYPE (ZMUMPS_STRUC) :: localid
-      NBVARIABLES=188
+      NBVARIABLES=194
       NBVARIABLES_ROOT=33
       allocate(SIZE_VARIABLES(NBVARIABLES),  stat=allocok)
       if (allocok .GT. 0) THEN
@@ -227,7 +231,7 @@ C
       CALL MUMPS_PROPINFO( localid%ICNTL(1), localid%INFO(1),
      &     localid%COMM, localid%MYID )
       IF ( localid%INFO(1) .LT. 0 ) RETURN
-      CALL ZMUMPS_SAVE_RESTORE_STRUCTURE(localid,IN,"restore_ooc"
+      CALL ZMUMPS_SAVE_RESTORE_STRUCTURE(localid,IN,restore_ooc_mode
      &     ,NBVARIABLES,SIZE_VARIABLES,SIZE_GEST
      &     ,NBVARIABLES_ROOT,SIZE_VARIABLES_ROOT,SIZE_GEST_ROOT
      &     ,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
@@ -239,6 +243,7 @@ C
       END SUBROUTINE ZMUMPS_RESTORE_OOC
       SUBROUTINE ZMUMPS_COMPUTE_MEMORY_SAVE(id,
      &     TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE)
+      IMPLICIT NONE
       INCLUDE 'mpif.h'
       INTEGER::NBVARIABLES,NBVARIABLES_ROOT
       INTEGER(8),allocatable, dimension(:)::SIZE_VARIABLES
@@ -248,7 +253,7 @@ C
       INTEGER :: INFO1,INFO2,INFOG1,INFOG2,allocok
       INTEGER(8) :: TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
       TYPE (ZMUMPS_STRUC) :: id
-      NBVARIABLES=188
+      NBVARIABLES=194
       NBVARIABLES_ROOT=33
       allocate(SIZE_VARIABLES(NBVARIABLES),  stat=allocok)
       if (allocok .GT. 0) THEN
@@ -292,7 +297,7 @@ C
       INFO2 = -999
       INFOG1 = -999
       INFOG2 = -999
-      CALL ZMUMPS_SAVE_RESTORE_STRUCTURE(id,0,"memory_save"
+      CALL ZMUMPS_SAVE_RESTORE_STRUCTURE(id,0,memory_save_mode
      &     ,NBVARIABLES,SIZE_VARIABLES,SIZE_GEST
      &     ,NBVARIABLES_ROOT,SIZE_VARIABLES_ROOT,SIZE_GEST_ROOT
      &     ,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
@@ -302,6 +307,7 @@ C
       RETURN
       END SUBROUTINE ZMUMPS_COMPUTE_MEMORY_SAVE
       SUBROUTINE ZMUMPS_SAVE(id)
+      IMPLICIT NONE
       INCLUDE 'mpif.h'
       INTEGER::ierr,OUT,NBVARIABLES,NBVARIABLES_ROOT,OUTINFO
       CHARACTER(len=LEN_SAVE_FILE):: SAVE_FILE,INFO_FILE
@@ -326,7 +332,7 @@ C
       id%INFOG(2)=0
       MPG= id%ICNTL(3)
       PROKG   = ( MPG .GT. 0 .and. id%MYID .eq. 0 )
-      NBVARIABLES=188
+      NBVARIABLES=194
       NBVARIABLES_ROOT=33
       allocate(SIZE_VARIABLES(NBVARIABLES),  stat=allocok)
       if (allocok .GT. 0) THEN
@@ -367,7 +373,7 @@ C
       TOTAL_FILE_SIZE=0_8
       TOTAL_STRUC_SIZE=0_8
       TMP_OOC_NAMES(:)="?"
-      CALL ZMUMPS_SAVE_RESTORE_STRUCTURE(id,0,"memory_save"
+      CALL ZMUMPS_SAVE_RESTORE_STRUCTURE(id,0,memory_save_mode
      &     ,NBVARIABLES,SIZE_VARIABLES,SIZE_GEST
      &     ,NBVARIABLES_ROOT,SIZE_VARIABLES_ROOT,SIZE_GEST_ROOT
      &     ,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
@@ -426,7 +432,7 @@ C
       CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &     id%COMM, id%MYID )
       IF ( id%INFO(1) .LT. 0 ) RETURN
-      CALL ZMUMPS_SAVE_RESTORE_STRUCTURE(id,OUT,"save"
+      CALL ZMUMPS_SAVE_RESTORE_STRUCTURE(id,OUT,save_mode
      &     ,NBVARIABLES,SIZE_VARIABLES,SIZE_GEST
      &     ,NBVARIABLES_ROOT,SIZE_VARIABLES_ROOT,SIZE_GEST_ROOT
      &     ,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
@@ -513,6 +519,7 @@ C
       RETURN
       END SUBROUTINE ZMUMPS_SAVE
       SUBROUTINE ZMUMPS_RESTORE(id)
+      IMPLICIT NONE
       INCLUDE 'mpif.h'
       INTEGER::ierr,IN,NBVARIABLES,NBVARIABLES_ROOT
       CHARACTER(len=LEN_SAVE_FILE):: restore_file,INFO_FILE
@@ -526,7 +533,7 @@ C
       INTEGER :: I,J,K,H,allocok
       CHARACTER(len=1) :: TMP_OOC_NAMES(350)
       TYPE (ZMUMPS_STRUC) :: id
-      NBVARIABLES=188
+      NBVARIABLES=194
       NBVARIABLES_ROOT=33
       allocate(SIZE_VARIABLES(NBVARIABLES),  stat=allocok)
       if (allocok .GT. 0) THEN
@@ -595,7 +602,7 @@ C
       IF ( id%INFO(1) .LT. 0 ) RETURN
       MP= id%ICNTL(2)
       MPG= id%ICNTL(3)
-      CALL ZMUMPS_SAVE_RESTORE_STRUCTURE(id,IN,"restore"
+      CALL ZMUMPS_SAVE_RESTORE_STRUCTURE(id,IN,restore_mode
      &     ,NBVARIABLES,SIZE_VARIABLES,SIZE_GEST
      &     ,NBVARIABLES_ROOT,SIZE_VARIABLES_ROOT,SIZE_GEST_ROOT
      &     ,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
@@ -660,8 +667,8 @@ C
       USE ZMUMPS_FACSOL_L0OMP_M, ONLY : ZMUMPS_SAVE_RESTORE_L0FACARRAY
       IMPLICIT NONE
       INCLUDE 'mpif.h'
-      INTEGER,intent(in)::unit,NBVARIABLES,NBVARIABLES_ROOT
-      CHARACTER(len=*),intent(in) :: mode
+      INTEGER, intent(in) ::unit,NBVARIABLES,NBVARIABLES_ROOT
+      INTEGER, intent(in) :: mode
       INTEGER(8),dimension(NBVARIABLES)::SIZE_VARIABLES
       INTEGER(8),dimension(NBVARIABLES_ROOT)::SIZE_VARIABLES_ROOT
       INTEGER,dimension(NBVARIABLES)::SIZE_GEST
@@ -669,9 +676,6 @@ C
       INTEGER(8) :: TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
       INTEGER:: INFO1,INFO2,INFOG1,INFOG2
       INTEGER:: j,i1,i2,err,ierr
-      CHARACTER(len=30), allocatable, dimension(:)::VARIABLES
-      CHARACTER(len=30), allocatable, dimension(:)::VARIABLES_ROOT
-      CHARACTER(len=30) :: TMP_STRING1, TMP_STRING2
       CHARACTER :: ARITH,READ_ARITH
       INTEGER(8) :: size_written,gest_size,WRITTEN_STRUC_SIZE
       INTEGER:: SIZE_INT, SIZE_INT8, SIZE_RL_OR_DBL, SIZE_ARITH_DEP
@@ -701,246 +705,237 @@ C
      &            SIZE_VARIABLES_L0FAC
       INTEGER::SIZE_GEST_BLR,SIZE_GEST_FRONT_DATA,SIZE_GEST_L0FAC
       INTEGER :: KEEP410_SAVE, KEEP411_SAVE 
+      INTEGER(8) :: KEEP883_SAVE, KEEP884_SAVE 
       INTEGER(4) :: I4
       TYPE (ZMUMPS_STRUC) :: id
-      allocate(VARIABLES(NBVARIABLES),  stat=allocok)
-      if (allocok .GT. 0) THEN
-       id%INFO(1)  =-13
-       id%INFO(2) = NBVARIABLES
-      endif
-      CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &     id%COMM, id%MYID )
-      IF ( id%INFO(1) .LT. 0 ) GOTO 100
-      VARIABLES(188)="ASSOCIATED_OOC_FILES"
-      VARIABLES(187)="pad16"
-      VARIABLES(186)="Deficiency"
-      VARIABLES(185)="NB_SINGULAR_VALUES"
-      VARIABLES(184)="SINGULAR_VALUES"
-      VARIABLES(183)="MPITOOMP_PROCS_MAP"
-      VARIABLES(182)="L0_OMP_MAPPING"
-      VARIABLES(181)="PTR_LEAFS_L0_OMP"
-      VARIABLES(180)="PERM_L0_OMP"
-      VARIABLES(179)="VIRT_L0_OMP_MAPPING"
-      VARIABLES(178)="VIRT_L0_OMP"
-      VARIABLES(177)="PHYS_L0_OMP"
-      VARIABLES(176)="IPOOL_A_L0_OMP"
-      VARIABLES(175)="IPOOL_B_L0_OMP"
-      VARIABLES(174)="I8_L0_OMP"
-      VARIABLES(173)="I4_L0_OMP"
-      VARIABLES(172)="THREAD_LA"
-      VARIABLES(171)="LL0_OMP_FACTORS"
-      VARIABLES(170)="LL0_OMP_MAPPING"
-      VARIABLES(169)="L_VIRT_L0_OMP"
-      VARIABLES(168)="L_PHYS_L0_OMP"
-      VARIABLES(167)="LPOOL_B_L0_OMP"
-      VARIABLES(166)="LPOOL_A_L0_OMP"
-      VARIABLES(165)="L0_OMP_FACTORS"
-      VARIABLES(164)="BLRARRAY_ENCODING"
-      VARIABLES(163)="FDM_F_ENCODING"
-      VARIABLES(162)="pad13"
-      VARIABLES(161)="NBGRP"
-      VARIABLES(160)="LRGROUPS"
-      VARIABLES(159)="root"
-      VARIABLES(158)="WORKING"
-      VARIABLES(157)="IPTR_WORKING"
-      VARIABLES(156)="pad14"
-      VARIABLES(155)="SUP_PROC"
-      VARIABLES(154)="PIVNUL_LIST"
-      VARIABLES(153)="OOC_FILE_NAMES"
-      VARIABLES(152)="OOC_FILE_NAME_LENGTH"
-      VARIABLES(151)="pad12"
-      VARIABLES(150)="OOC_NB_FILE_TYPE"
-      VARIABLES(149)="OOC_NB_FILES"
-      VARIABLES(148)="OOC_TOTAL_NB_NODES"
-      VARIABLES(147)="OOC_VADDR"
-      VARIABLES(146)="OOC_SIZE_OF_BLOCK"
-      VARIABLES(145)="OOC_INODE_SEQUENCE"
-      VARIABLES(144)="OOC_MAX_NB_NODES_FOR_ZONE"
-      VARIABLES(143)="INSTANCE_NUMBER"
-      VARIABLES(142)="CB_SON_SIZE"
-      VARIABLES(141)="DKEEP"
-      VARIABLES(140)="LWK_USER"
-      VARIABLES(139)="NBSA_LOCAL"
-      VARIABLES(138)="WK_USER"
-      VARIABLES(137)="CROIX_MANU"
-      VARIABLES(136)="SCHED_SBTR"
-      VARIABLES(135)="SCHED_GRP"
-      VARIABLES(134)="SCHED_DEP"
-      VARIABLES(133)="SBTR_ID"
-      VARIABLES(132)="DEPTH_FIRST_SEQ"
-      VARIABLES(131)="DEPTH_FIRST"
-      VARIABLES(130)="MY_NB_LEAF"
-      VARIABLES(129)="MY_FIRST_LEAF"
-      VARIABLES(128)="MY_ROOT_SBTR"
-      VARIABLES(127)="COST_TRAV"
-      VARIABLES(126)="MEM_SUBTREE"
-      VARIABLES(125)="RHSCOMP"
-      VARIABLES(124)="POSINRHSCOMP_COL"
-      VARIABLES(123)="pad11"
-      VARIABLES(122)="POSINRHSCOMP_COL_ALLOC"
-      VARIABLES(121)="POSINRHSCOMP_ROW"
-      VARIABLES(120)="MEM_DIST"
-      VARIABLES(119)="I_AM_CAND"
-      VARIABLES(118)="TAB_POS_IN_PERE"
-      VARIABLES(117)="FUTURE_NIV2"
-      VARIABLES(116)="ISTEP_TO_INIV2"
-      VARIABLES(115)="CANDIDATES"
-      VARIABLES(114)="ELTPROC"
-      VARIABLES(113)="LELTVAR"
-      VARIABLES(112)="NELT_loc"
-      VARIABLES(111)="PROCNODE"
-      VARIABLES(110)="S"
-      VARIABLES(109)="PTRFAC"
-      VARIABLES(108)="PTLUST_S"
-      VARIABLES(107)="Step2node"
-      VARIABLES(106)="PROCNODE_STEPS"
-      VARIABLES(105)="NA"
-      VARIABLES(104)="PTRDEBARR"
-      VARIABLES(103)="NINROWARR"
-      VARIABLES(102)="NINCOLARR"
-      VARIABLES(101)="PTR8ARR"
-      VARIABLES(100)="PTRAR"
-      VARIABLES(99)="FRTELT"
-      VARIABLES(98)="FRTPTR"
-      VARIABLES(97)="FILS"
-      VARIABLES(96)="DAD_STEPS"
-      VARIABLES(95)="FRERE_STEPS"
-      VARIABLES(94)="ND_STEPS"
-      VARIABLES(93)="NE_STEPS"
-      VARIABLES(92)="STEP"
-      VARIABLES(91)="NBSA"
-      VARIABLES(90)="LNA"
-      VARIABLES(89)="KEEP"
-      VARIABLES(88)="IS"
-      VARIABLES(87)="ASS_IRECV"
-      VARIABLES(86)="NSLAVES"
-      VARIABLES(85)="NPROCS"
-      VARIABLES(84)="MYID"
-      VARIABLES(83)="COMM_LOAD"
-      VARIABLES(82)="MYID_NODES"
-      VARIABLES(81)="COMM_NODES"
-      VARIABLES(80)="INST_Number"
-      VARIABLES(79)="MAX_SURF_MASTER"
-      VARIABLES(78)="KEEP8"
-      VARIABLES(77)="pad7"
-      VARIABLES(76)="SAVE_PREFIX"
-      VARIABLES(75)="SAVE_DIR"
-      VARIABLES(74)="WRITE_PROBLEM"
-      VARIABLES(73)="OOC_PREFIX"
-      VARIABLES(72)="OOC_TMPDIR"
-      VARIABLES(71)="VERSION_NUMBER"
-      VARIABLES(70)="MAPPING"
-      VARIABLES(69)="LISTVAR_SCHUR"
-      VARIABLES(68)="SCHUR_CINTERFACE"
-      VARIABLES(67)="SCHUR"
-      VARIABLES(66)="SIZE_SCHUR"
-      VARIABLES(65)="SCHUR_LLD"
-      VARIABLES(64)="SCHUR_NLOC"
-      VARIABLES(63)="SCHUR_MLOC"
-      VARIABLES(62)="NBLOCK"
-      VARIABLES(61)="MBLOCK"
-      VARIABLES(60)="NPCOL"
-      VARIABLES(59)="NPROW"
-      VARIABLES(58)="UNS_PERM"
-      VARIABLES(57)="SYM_PERM"
-      VARIABLES(56)="METIS_OPTIONS"
-      VARIABLES(55)="RINFOG"
-      VARIABLES(54)="RINFO"
-      VARIABLES(53)="CNTL"
-      VARIABLES(52)="COST_SUBTREES"
-      VARIABLES(51)="INFOG"
-      VARIABLES(50)="INFO"
-      VARIABLES(49)="ICNTL"
-      VARIABLES(48)="pad6"
-      VARIABLES(47)="LSOL_loc"
-      VARIABLES(46)="LREDRHS"
-      VARIABLES(45)="LRHS_loc"
-      VARIABLES(44)="Nloc_RHS"
-      VARIABLES(43)="NZ_RHS"
-      VARIABLES(42)="NRHS"
-      VARIABLES(41)="LRHS"
-      VARIABLES(40)="IRHS_loc"
-      VARIABLES(39)="ISOL_loc"
-      VARIABLES(38)="IRHS_PTR"
-      VARIABLES(37)="IRHS_SPARSE"
-      VARIABLES(36)="RHS_loc"
-      VARIABLES(35)="SOL_loc"
-      VARIABLES(34)="RHS_SPARSE"
-      VARIABLES(33)="REDRHS"
-      VARIABLES(32)="RHS"
-      VARIABLES(31)="BLKVAR"
-      VARIABLES(30)="BLKPTR"
-      VARIABLES(29)="pad5"
-      VARIABLES(28)="NBLK"
-      VARIABLES(27)="PERM_IN"
-      VARIABLES(26)="pad4"
-      VARIABLES(25)="A_ELT"
-      VARIABLES(24)="ELTVAR"
-      VARIABLES(23)="ELTPTR"
-      VARIABLES(22)="pad3"
-      VARIABLES(21)="NELT"
-      VARIABLES(20)="pad2"
-      VARIABLES(19)="A_loc"
-      VARIABLES(18)="JCN_loc"
-      VARIABLES(17)="IRN_loc"
-      VARIABLES(16)="NNZ_loc"
-      VARIABLES(15)="pad1"
-      VARIABLES(14)="NZ_loc"
-      VARIABLES(13)="pad0"
-      VARIABLES(12)="ROWSCA"
-      VARIABLES(11)="COLSCA"
-      VARIABLES(10)="JCN"
-      VARIABLES(9)="IRN"
-      VARIABLES(8)="A"
-      VARIABLES(7)="NNZ"
-      VARIABLES(6)="NZ"
-      VARIABLES(5)="N"
-      VARIABLES(4)="JOB"
-      VARIABLES(3)="PAR"
-      VARIABLES(2)="SYM"
-      VARIABLES(1)="COMM"
-      allocate(VARIABLES_ROOT(NBVARIABLES_ROOT),  stat=allocok)
-      if (allocok .GT. 0) THEN
-       id%INFO(1)  =-13
-       id%INFO(2) = NBVARIABLES_ROOT
-      endif
-      CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &        id%COMM, id%MYID )
-      IF ( id%INFO(1) .LT. 0 ) GOTO 100
-      VARIABLES_ROOT(33)="rootpad4"
-      VARIABLES_ROOT(32)="NB_SINGULAR_VALUES"
-      VARIABLES_ROOT(31)="SINGULAR_VALUES"
-      VARIABLES_ROOT(30)="SVD_VT"
-      VARIABLES_ROOT(29)="SVD_U"
-      VARIABLES_ROOT(28)="gridinit_done"
-      VARIABLES_ROOT(27)="yes"
-      VARIABLES_ROOT(26)="rootpad3"
-      VARIABLES_ROOT(25)="QR_RCOND"
-      VARIABLES_ROOT(24)="rootpad2"
-      VARIABLES_ROOT(23)="RHS_ROOT"
-      VARIABLES_ROOT(22)="rootpad1"
-      VARIABLES_ROOT(21)="QR_TAU"
-      VARIABLES_ROOT(20)="SCHUR_POINTER"
-      VARIABLES_ROOT(19)="RHS_CNTR_MASTER_ROOT"
-      VARIABLES_ROOT(18)="IPIV"
-      VARIABLES_ROOT(17)="RG2L"
-      VARIABLES_ROOT(16)="rootpad0"
-      VARIABLES_ROOT(15)="LPIV"
-      VARIABLES_ROOT(14)="CNTXT_BLACS"
-      VARIABLES_ROOT(13)="DESCRIPTOR"
-      VARIABLES_ROOT(12)="TOT_ROOT_SIZE"
-      VARIABLES_ROOT(11)="ROOT_SIZE"
-      VARIABLES_ROOT(10)="RHS_NLOC"
-      VARIABLES_ROOT(9)="SCHUR_LLD"
-      VARIABLES_ROOT(8)="SCHUR_NLOC"
-      VARIABLES_ROOT(7)="SCHUR_MLOC"
-      VARIABLES_ROOT(6)="MYCOL"
-      VARIABLES_ROOT(5)="MYROW"
-      VARIABLES_ROOT(4)="NPCOL"
-      VARIABLES_ROOT(3)="NPROW"
-      VARIABLES_ROOT(2)="NBLOCK"
-      VARIABLES_ROOT(1)="MBLOCK"
-      OOC_INDICES=(/149,150,152,153/)
+      INTEGER, PARAMETER :: S_ASSOCIATED_OOC_FILES=194
+      INTEGER, PARAMETER :: S_pad16=193
+      INTEGER, PARAMETER :: S_Deficiency=192
+      INTEGER, PARAMETER :: S_NB_SINGULAR_VALUES=191
+      INTEGER, PARAMETER :: S_SINGULAR_VALUES=190
+      INTEGER, PARAMETER :: S_MTKO_PROCS_MAP=189
+      INTEGER, PARAMETER :: S_L0_OMP_MAPPING=188
+      INTEGER, PARAMETER :: S_PTR_LEAFS_L0_OMP=187
+      INTEGER, PARAMETER :: S_PERM_L0_OMP=186
+      INTEGER, PARAMETER :: S_VIRT_L0_OMP_MAPPING=185
+      INTEGER, PARAMETER :: S_VIRT_L0_OMP=184
+      INTEGER, PARAMETER :: S_PHYS_L0_OMP=183
+      INTEGER, PARAMETER :: S_IPOOL_A_L0_OMP=182
+      INTEGER, PARAMETER :: S_IPOOL_B_L0_OMP=181
+      INTEGER, PARAMETER :: S_I8_L0_OMP=180
+      INTEGER, PARAMETER :: S_I4_L0_OMP=179
+      INTEGER, PARAMETER :: S_THREAD_LA=178
+      INTEGER, PARAMETER :: S_LL0_OMP_FACTORS=177
+      INTEGER, PARAMETER :: S_LL0_OMP_MAPPING=176
+      INTEGER, PARAMETER :: S_L_VIRT_L0_OMP=175
+      INTEGER, PARAMETER :: S_L_PHYS_L0_OMP=174
+      INTEGER, PARAMETER :: S_LPOOL_B_L0_OMP=173
+      INTEGER, PARAMETER :: S_LPOOL_A_L0_OMP=172
+      INTEGER, PARAMETER :: S_L0_OMP_FACTORS=171
+      INTEGER, PARAMETER :: S_BLRARRAY_ENCODING=170
+      INTEGER, PARAMETER :: S_FDM_F_ENCODING=169
+      INTEGER, PARAMETER :: S_pad13=168
+      INTEGER, PARAMETER :: S_NBGRP=167
+      INTEGER, PARAMETER :: S_LRGROUPS=166
+      INTEGER, PARAMETER :: S_root=165
+      INTEGER, PARAMETER :: S_WORKING=164
+      INTEGER, PARAMETER :: S_IPTR_WORKING=163
+      INTEGER, PARAMETER :: S_pad14=162
+      INTEGER, PARAMETER :: S_SUP_PROC=161
+      INTEGER, PARAMETER :: S_PIVNUL_LIST=160
+      INTEGER, PARAMETER :: S_OOC_FILE_NAMES=159
+      INTEGER, PARAMETER :: S_OOC_FILE_NAME_LENGTH=158
+      INTEGER, PARAMETER :: S_pad12=157
+      INTEGER, PARAMETER :: S_OOC_NB_FILE_TYPE=156
+      INTEGER, PARAMETER :: S_OOC_NB_FILES=155
+      INTEGER, PARAMETER :: S_OOC_TOTAL_NB_NODES=154
+      INTEGER, PARAMETER :: S_OOC_VADDR=153
+      INTEGER, PARAMETER :: S_OOC_SIZE_OF_BLOCK=152
+      INTEGER, PARAMETER :: S_OOC_INODE_SEQUENCE=151
+      INTEGER, PARAMETER :: S_OOC_MAX_NB_NODES_FOR_ZONE=150
+      INTEGER, PARAMETER :: S_INSTANCE_NUMBER=149
+      INTEGER, PARAMETER :: S_CB_SON_SIZE=148
+      INTEGER, PARAMETER :: S_DKEEP=147
+      INTEGER, PARAMETER :: S_LWK_USER=146
+      INTEGER, PARAMETER :: S_NBSA_LOCAL=145
+      INTEGER, PARAMETER :: S_WK_USER=144
+      INTEGER, PARAMETER :: S_CROIX_MANU=143
+      INTEGER, PARAMETER :: S_SCHED_SBTR=142
+      INTEGER, PARAMETER :: S_SCHED_GRP=141
+      INTEGER, PARAMETER :: S_SCHED_DEP=140
+      INTEGER, PARAMETER :: S_SBTR_ID=139
+      INTEGER, PARAMETER :: S_DEPTH_FIRST_SEQ=138
+      INTEGER, PARAMETER :: S_DEPTH_FIRST=137
+      INTEGER, PARAMETER :: S_MY_NB_LEAF=136
+      INTEGER, PARAMETER :: S_MY_FIRST_LEAF=135
+      INTEGER, PARAMETER :: S_MY_ROOT_SBTR=134
+      INTEGER, PARAMETER :: S_COST_TRAV=133
+      INTEGER, PARAMETER :: S_MEM_SUBTREE=132
+      INTEGER, PARAMETER :: S_RHSINTR=131
+      INTEGER, PARAMETER :: S_GLOB2LOC_SOL=130
+      INTEGER, PARAMETER :: S_pad11=129
+      INTEGER, PARAMETER :: S_GLOB2LOC_SOL_ALLOC=128
+      INTEGER, PARAMETER :: S_GLOB2LOC_RHS=127
+      INTEGER, PARAMETER :: S_MEM_DIST=126
+      INTEGER, PARAMETER :: S_I_AM_CAND=125
+      INTEGER, PARAMETER :: S_TAB_POS_IN_PERE=124
+      INTEGER, PARAMETER :: S_FUTURE_NIV2=123
+      INTEGER, PARAMETER :: S_ISTEP_TO_INIV2=122
+      INTEGER, PARAMETER :: S_CANDIDATES=121
+      INTEGER, PARAMETER :: S_ELTPROC=120
+      INTEGER, PARAMETER :: S_LELTVAR=119
+      INTEGER, PARAMETER :: S_NELT_loc=118
+      INTEGER, PARAMETER :: S_PROCNODE=117
+      INTEGER, PARAMETER :: S_S=116
+      INTEGER, PARAMETER :: S_PTRFAC=115
+      INTEGER, PARAMETER :: S_PTLUST_S=114
+      INTEGER, PARAMETER :: S_Step2node=113
+      INTEGER, PARAMETER :: S_PROCNODE_STEPS=112
+      INTEGER, PARAMETER :: S_NA=111
+      INTEGER, PARAMETER :: S_PTRDEBARR=110
+      INTEGER, PARAMETER :: S_NINROWARR=109
+      INTEGER, PARAMETER :: S_NINCOLARR=108
+      INTEGER, PARAMETER :: S_PTR8ARR=107
+      INTEGER, PARAMETER :: S_PTRAR=106
+      INTEGER, PARAMETER :: S_FRTELT=105
+      INTEGER, PARAMETER :: S_FRTPTR=104
+      INTEGER, PARAMETER :: S_FILS=103
+      INTEGER, PARAMETER :: S_DAD_STEPS=102
+      INTEGER, PARAMETER :: S_FRERE_STEPS=101
+      INTEGER, PARAMETER :: S_ND_STEPS=100
+      INTEGER, PARAMETER :: S_NE_STEPS=99
+      INTEGER, PARAMETER :: S_STEP=98
+      INTEGER, PARAMETER :: S_NBSA=97
+      INTEGER, PARAMETER :: S_LNA=96
+      INTEGER, PARAMETER :: S_KEEP=95
+      INTEGER, PARAMETER :: S_IS=94
+      INTEGER, PARAMETER :: S_ASS_IRECV=93
+      INTEGER, PARAMETER :: S_NSLAVES=92
+      INTEGER, PARAMETER :: S_NPROCS=91
+      INTEGER, PARAMETER :: S_MYID=90
+      INTEGER, PARAMETER :: S_COMM_LOAD=89
+      INTEGER, PARAMETER :: S_MYID_NODES=88
+      INTEGER, PARAMETER :: S_COMM_NODES=87
+      INTEGER, PARAMETER :: S_INST_Number=86
+      INTEGER, PARAMETER :: S_MAX_SURF_MASTER=85
+      INTEGER, PARAMETER :: S_KEEP8=84
+      INTEGER, PARAMETER :: S_pad7=83
+      INTEGER, PARAMETER :: S_SAVE_PREFIX=82
+      INTEGER, PARAMETER :: S_SAVE_DIR=81
+      INTEGER, PARAMETER :: S_WRITE_PROBLEM=80
+      INTEGER, PARAMETER :: S_OOC_PREFIX=79
+      INTEGER, PARAMETER :: S_OOC_TMPDIR=78
+      INTEGER, PARAMETER :: S_VERSION_NUMBER=77
+      INTEGER, PARAMETER :: S_MAPPING=76
+      INTEGER, PARAMETER :: S_LISTVAR_SCHUR=75
+      INTEGER, PARAMETER :: S_SCHUR_CINTERFACE=74
+      INTEGER, PARAMETER :: S_SCHUR=73
+      INTEGER, PARAMETER :: S_SIZE_SCHUR=72
+      INTEGER, PARAMETER :: S_SCHUR_LLD=71
+      INTEGER, PARAMETER :: S_SCHUR_NLOC=70
+      INTEGER, PARAMETER :: S_SCHUR_MLOC=69
+      INTEGER, PARAMETER :: S_NBLOCK=68
+      INTEGER, PARAMETER :: S_MBLOCK=67
+      INTEGER, PARAMETER :: S_NPCOL=66
+      INTEGER, PARAMETER :: S_NPROW=65
+      INTEGER, PARAMETER :: S_UNS_PERM=64
+      INTEGER, PARAMETER :: S_SYM_PERM=63
+      INTEGER, PARAMETER :: S_METIS_OPTIONS=62
+      INTEGER, PARAMETER :: S_RINFOG=61
+      INTEGER, PARAMETER :: S_RINFO=60
+      INTEGER, PARAMETER :: S_CNTL=59
+      INTEGER, PARAMETER :: S_COST_SUBTREES=58
+      INTEGER, PARAMETER :: S_INFOG=57
+      INTEGER, PARAMETER :: S_INFO=56
+      INTEGER, PARAMETER :: S_ICNTL=55
+      INTEGER, PARAMETER :: S_pad6=54
+      INTEGER, PARAMETER :: S_LD_RHSINTR=53
+      INTEGER, PARAMETER :: S_NSOL_loc=52
+      INTEGER, PARAMETER :: S_LSOL_loc=51
+      INTEGER, PARAMETER :: S_LREDRHS=50
+      INTEGER, PARAMETER :: S_LRHS_loc=49
+      INTEGER, PARAMETER :: S_Nloc_RHS=48
+      INTEGER, PARAMETER :: S_NZ_RHS=47
+      INTEGER, PARAMETER :: S_NRHS=46
+      INTEGER, PARAMETER :: S_LRHS=45
+      INTEGER, PARAMETER :: S_IRHS_loc=44
+      INTEGER, PARAMETER :: S_ISOL_loc=43
+      INTEGER, PARAMETER :: S_IRHS_PTR=42
+      INTEGER, PARAMETER :: S_IRHS_SPARSE=41
+      INTEGER, PARAMETER :: S_RHS_loc=40
+      INTEGER, PARAMETER :: S_SOL_loc=39
+      INTEGER, PARAMETER :: S_RHS_SPARSE=38
+      INTEGER, PARAMETER :: S_REDRHS=37
+      INTEGER, PARAMETER :: S_RHS=36
+      INTEGER, PARAMETER :: S_BLKVAR=35
+      INTEGER, PARAMETER :: S_BLKPTR=34
+      INTEGER, PARAMETER :: S_pad5=33
+      INTEGER, PARAMETER :: S_NBLK=32
+      INTEGER, PARAMETER :: S_PERM_IN=31
+      INTEGER, PARAMETER :: S_pad4=30
+      INTEGER, PARAMETER :: S_A_ELT=29
+      INTEGER, PARAMETER :: S_ELTVAR=28
+      INTEGER, PARAMETER :: S_ELTPTR=27
+      INTEGER, PARAMETER :: S_pad3=26
+      INTEGER, PARAMETER :: S_NELT=25
+      INTEGER, PARAMETER :: S_pad2=24
+      INTEGER, PARAMETER :: S_A_loc=23
+      INTEGER, PARAMETER :: S_JCN_loc=22
+      INTEGER, PARAMETER :: S_IRN_loc=21
+      INTEGER, PARAMETER :: S_NNZ_loc=20
+      INTEGER, PARAMETER :: S_pad1=19
+      INTEGER, PARAMETER :: S_NZ_loc=18
+      INTEGER, PARAMETER :: S_PIVOTS=17
+      INTEGER, PARAMETER :: S_COLIND=16
+      INTEGER, PARAMETER :: S_ROWIND=15
+      INTEGER, PARAMETER :: S_ROWSCA_loc=14
+      INTEGER, PARAMETER :: S_COLSCA_loc=13
+      INTEGER, PARAMETER :: S_ROWSCA=12
+      INTEGER, PARAMETER :: S_COLSCA=11
+      INTEGER, PARAMETER :: S_JCN=10
+      INTEGER, PARAMETER :: S_IRN=9
+      INTEGER, PARAMETER :: S_A=8
+      INTEGER, PARAMETER :: S_NNZ=7
+      INTEGER, PARAMETER :: S_NZ=6
+      INTEGER, PARAMETER :: S_N=5
+      INTEGER, PARAMETER :: S_JOB=4
+      INTEGER, PARAMETER :: S_PAR=3
+      INTEGER, PARAMETER :: S_SYM=2
+      INTEGER, PARAMETER :: S_COMM=1
+      INTEGER,  PARAMETER :: R_rootpad4=33
+      INTEGER,  PARAMETER :: R_NB_SINGULAR_VALUES=32
+      INTEGER,  PARAMETER :: R_SINGULAR_VALUES=31
+      INTEGER,  PARAMETER :: R_SVD_VT=30
+      INTEGER,  PARAMETER :: R_SVD_U=29
+      INTEGER,  PARAMETER :: R_gridinit_done=28
+      INTEGER,  PARAMETER :: R_yes=27
+      INTEGER,  PARAMETER :: R_rootpad3=26
+      INTEGER,  PARAMETER :: R_QR_RCOND=25
+      INTEGER,  PARAMETER :: R_rootpad2=24
+      INTEGER,  PARAMETER :: R_RHS_ROOT=23
+      INTEGER,  PARAMETER :: R_rootpad1=22
+      INTEGER,  PARAMETER :: R_QR_TAU=21
+      INTEGER,  PARAMETER :: R_SCHUR_POINTER=20
+      INTEGER,  PARAMETER :: R_RHS_CNTR_MASTER_ROOT=19
+      INTEGER,  PARAMETER :: R_IPIV=18
+      INTEGER,  PARAMETER :: R_RG2L=17
+      INTEGER,  PARAMETER :: R_rootpad0=16
+      INTEGER,  PARAMETER :: R_LPIV=15
+      INTEGER,  PARAMETER :: R_CNTXT_BLACS=14
+      INTEGER,  PARAMETER :: R_DESCRIPTOR=13
+      INTEGER,  PARAMETER :: R_TOT_ROOT_SIZE=12
+      INTEGER,  PARAMETER :: R_ROOT_SIZE=11
+      INTEGER,  PARAMETER :: R_RHS_NLOC=10
+      INTEGER,  PARAMETER :: R_SCHUR_LLD=9
+      INTEGER,  PARAMETER :: R_SCHUR_NLOC=8
+      INTEGER,  PARAMETER :: R_SCHUR_MLOC=7
+      INTEGER,  PARAMETER :: R_MYCOL=6
+      INTEGER,  PARAMETER :: R_MYROW=5
+      INTEGER,  PARAMETER :: R_NPCOL=4
+      INTEGER,  PARAMETER :: R_NPROW=3
+      INTEGER,  PARAMETER :: R_NBLOCK=2
+      INTEGER,  PARAMETER :: R_MBLOCK=1
+      OOC_INDICES=(/155,156,158,159/)
       SIZE_INT = id%KEEP(34)
       SIZE_INT8 = id%KEEP(34)*id%KEEP(10)
       SIZE_RL_OR_DBL = id%KEEP(16)
@@ -964,8 +959,8 @@ C
       SIZE_GEST_FRONT_DATA=0
       SIZE_VARIABLES_L0FAC=0
       SIZE_GEST_L0FAC=0
-      if(trim(mode).EQ."memory_save") then
-      elseif(trim(mode).EQ."save") then
+      if(mode.EQ.memory_save_mode) then
+      elseif(mode.EQ.save_mode) then
          write(unit,iostat=err) "MUMPS"
          if(err.ne.0) THEN
             id%INFO(1) = -72
@@ -1125,8 +1120,8 @@ C
      &           +int(2*id%KEEP(34)*1,kind=8)
 #endif
          ENDIF
-      elseif((trim(mode).EQ."restore").OR.
-     &        (trim(mode).EQ."restore_ooc")) then
+      elseif((mode.EQ.restore_mode).OR.
+     &        (mode.EQ.restore_ooc_mode)) then
         CALL MUMPS_READ_HEADER(unit,err,size_read,SIZE_INT,SIZE_INT8,
      &       TOTAL_FILE_SIZE, TOTAL_STRUC_SIZE, READ_ARITH,
      &       READ_INT_TYPE_64, READ_OOC_FILE_NAME_LENGTH,
@@ -1144,14 +1139,14 @@ C
      &        id%COMM, id%MYID )
          IF ( id%INFO(1) .LT. 0 ) GOTO 100
          BASIC_CHECK = .false.
-         IF (trim(mode).EQ."restore_ooc") THEN
+         IF (mode.EQ.restore_ooc_mode) THEN
            BASIC_CHECK = .true.
          ENDIF
          CALL ZMUMPS_CHECK_HEADER(id,BASIC_CHECK,READ_INT_TYPE_64,
      &              READ_HASH, READ_NPROCS,
      &              READ_ARITH, READ_SYM, READ_PAR)
          IF (id%INFO(1) .LT. 0) GOTO 100
-      elseif(trim(mode).EQ."fake_restore") then
+      elseif(mode.EQ.fake_restore_mode) then
          read(unit,iostat=err) READ_HASH
          if(err.ne.0) GOTO 100
          read(unit,iostat=err) TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
@@ -1163,11 +1158,10 @@ C
       endif
       DO j=1,size(OOC_INDICES)
          i1=OOC_INDICES(j)
-         TMP_STRING1 = VARIABLES(i1)
-         SELECT CASE(TMP_STRING1)
-         CASE("OOC_NB_FILES")
+         SELECT CASE(i1)
+         CASE(S_OOC_NB_FILES)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%OOC_NB_FILES)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%OOC_NB_FILES,1)*SIZE_INT
@@ -1175,7 +1169,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%OOC_NB_FILES)) THEN
                   write(unit,iostat=err) size(id%OOC_NB_FILES,1)
                   if(err.ne.0) then
@@ -1207,8 +1201,8 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif((trim(mode).EQ."restore").OR.
-     &             (trim(mode).EQ."restore_ooc")) then
+            elseif((mode.EQ.restore_mode).OR.
+     &             (mode.EQ.restore_ooc_mode)) then
                nullify(id%OOC_NB_FILES)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -1247,11 +1241,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("OOC_NB_FILE_TYPE")
+         CASE(S_OOC_NB_FILE_TYPE)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%OOC_NB_FILE_TYPE
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1261,8 +1255,8 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif((trim(mode).EQ."restore").OR.
-     &             (trim(mode).EQ."restore_ooc")) then
+            elseif((mode.EQ.restore_mode).OR.
+     &             (mode.EQ.restore_ooc_mode)) then
                SIZE_VARIABLES(i1)=SIZE_INT
                read(unit,iostat=err) id%OOC_NB_FILE_TYPE
                if(err.ne.0) THEN
@@ -1274,9 +1268,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("OOC_FILE_NAMES")
+         CASE(S_OOC_FILE_NAMES)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%OOC_FILE_NAMES)) THEN
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=size(id%OOC_FILE_NAMES,1)
@@ -1285,7 +1279,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*3
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%OOC_FILE_NAMES)) THEN
                   write(unit,iostat=err) size(id%OOC_FILE_NAMES,1)
      &                 ,size(id%OOC_FILE_NAMES,2)
@@ -1318,8 +1312,8 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif((trim(mode).EQ."restore").OR.
-     &             (trim(mode).EQ."restore_ooc")) then
+            elseif((mode.EQ.restore_mode).OR.
+     &             (mode.EQ.restore_ooc_mode)) then
                nullify(id%OOC_FILE_NAMES)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -1360,9 +1354,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("OOC_FILE_NAME_LENGTH")
+         CASE(S_OOC_FILE_NAME_LENGTH)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%OOC_FILE_NAME_LENGTH)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
@@ -1371,7 +1365,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%OOC_FILE_NAME_LENGTH)) THEN
                   write(unit,iostat=err) size(id%OOC_FILE_NAME_LENGTH,1)
                   if(err.ne.0) then
@@ -1403,8 +1397,8 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif((trim(mode).EQ."restore").OR.
-     &             (trim(mode).EQ."restore_ooc")) then
+            elseif((mode.EQ.restore_mode).OR.
+     &             (mode.EQ.restore_ooc_mode)) then
                nullify(id%OOC_FILE_NAME_LENGTH)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -1447,111 +1441,41 @@ C
          CASE DEFAULT
          END SELECT
       ENDDO
-      if(trim(mode).EQ."restore_ooc") then
+      if(mode.EQ.restore_ooc_mode) then
          goto 200
       endif
       DO i1=1,NBVARIABLES 
-         TMP_STRING1 = VARIABLES(i1)
-         SELECT CASE(TMP_STRING1)
-         CASE("COMM")
-            if(trim(mode).EQ."memory_save") then
+         SELECT CASE(i1)
+         CASE(S_COMM)
+            if(mode.EQ.memory_save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
             endif
-         CASE("SYM")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%SYM
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%SYM
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read,
-     &                 id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("PAR")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%PAR
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%PAR
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("JOB")
-            if(trim(mode).EQ."memory_save") then
+         CASE(S_SYM)
+           CALL MUMPS_SAVE_INT(id%SYM)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_PAR)
+           CALL MUMPS_SAVE_INT(id%PAR)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_JOB)
+            if(mode.EQ.memory_save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
             endif
-         CASE("N")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%N
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%N
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("ICNTL")
+         CASE(S_N)
+           CALL MUMPS_SAVE_INT(id%N)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_ICNTL)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%ICNTL,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%ICNTL
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1561,7 +1485,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%ICNTL,1)
                read(unit,iostat=err) id%ICNTL
                if(err.ne.0) THEN
@@ -1573,11 +1497,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("INFO")
+         CASE(S_INFO)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%INFO,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) INFO1,INFO2
      &              ,id%INFO(3:size(id%INFO,1))
                if(err.ne.0) then
@@ -1588,7 +1512,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%INFO,1)
                read(unit,iostat=err) INFO1,INFO2
      &              ,id%INFO(3:size(id%INFO,1))
@@ -1601,11 +1525,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("INFOG")
+         CASE(S_INFOG)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%INFOG,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) INFOG1,INFOG2
      &              ,id%INFOG(3:size(id%INFOG,1))
                if(err.ne.0) then
@@ -1616,7 +1540,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%INFOG,1)
                read(unit,iostat=err) INFOG1,INFOG2
      &              ,id%INFOG(3:size(id%INFOG,1))
@@ -1629,11 +1553,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("COST_SUBTREES")
+         CASE(S_COST_SUBTREES)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%COST_SUBTREES
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1643,7 +1567,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL
                read(unit,iostat=err) id%COST_SUBTREES
                if(err.ne.0) THEN
@@ -1655,11 +1579,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("CNTL")
+         CASE(S_CNTL)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL*size(id%CNTL,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%CNTL
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1669,7 +1593,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL*size(id%CNTL,1)
                read(unit,iostat=err) id%CNTL
                if(err.ne.0) THEN
@@ -1681,11 +1605,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("RINFO")
+         CASE(S_RINFO)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL*size(id%RINFO,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%RINFO
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1695,7 +1619,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL*size(id%RINFO,1)
                read(unit,iostat=err) id%RINFO
                if(err.ne.0) THEN
@@ -1707,11 +1631,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("RINFOG")
+         CASE(S_RINFOG)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL*size(id%RINFOG,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%RINFOG
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1721,7 +1645,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL*size(id%RINFOG,1)
                read(unit,iostat=err) id%RINFOG
                if(err.ne.0) THEN
@@ -1733,11 +1657,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("KEEP8")
+         CASE(S_KEEP8)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8*size(id%KEEP8,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%KEEP8
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1747,9 +1671,13 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8*size(id%KEEP8,1)
+               KEEP883_SAVE=id%KEEP8(83)
+               KEEP884_SAVE=id%KEEP8(84)
                read(unit,iostat=err) id%KEEP8
+               id%KEEP8(83)=KEEP883_SAVE
+               id%KEEP8(84)=KEEP884_SAVE
                if(err.ne.0) THEN
                   id%INFO(1) = -75
                   CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
@@ -1759,11 +1687,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("KEEP")
+         CASE(S_KEEP)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%KEEP,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%KEEP
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1773,7 +1701,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%KEEP,1)
                KEEP410_SAVE = id%KEEP(410)
                KEEP411_SAVE = id%KEEP(411)
@@ -1789,11 +1717,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("DKEEP")
+         CASE(S_DKEEP)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL*size(id%DKEEP,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%DKEEP
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1803,7 +1731,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_RL_OR_DBL*size(id%DKEEP,1)
                read(unit,iostat=err) id%DKEEP
                if(err.ne.0) THEN
@@ -1815,37 +1743,14 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("NZ")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NZ
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NZ
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("NNZ")
+         CASE(S_NZ)
+           CALL MUMPS_SAVE_INT(id%NZ)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NNZ)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%NNZ
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -1855,7 +1760,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8
                read(unit,iostat=err) id%NNZ
                if(err.ne.0) THEN
@@ -1867,174 +1772,32 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif  
-         CASE("A")
-         CASE("IRN")
-         CASE("JCN")
-         CASE("COLSCA")
+         CASE(S_A)
+         CASE(S_IRN)
+         CASE(S_JCN)
+         CASE(S_COLSCA)
             IF(id%KEEP(52).NE.-1) THEN
-               NbRecords(i1)=2
-               if(trim(mode).EQ."memory_save") then
-                  IF(associated(id%COLSCA)) THEN
-                     SIZE_GEST(i1)=SIZE_INT
-                     SIZE_VARIABLES(i1)=size(id%COLSCA,1)*SIZE_RL_OR_DBL
-                  ELSE
-                     SIZE_GEST(i1)=SIZE_INT*2
-                     SIZE_VARIABLES(i1)=0_8
-                  ENDIF
-               elseif(trim(mode).EQ."save") then
-                  IF(associated(id%COLSCA)) THEN
-                     write(unit,iostat=err) size(id%COLSCA,1)
-                     if(err.ne.0) then
-                        id%INFO(1) = -72
-                        CALL MUMPS_SETI8TOI4(
-     &                       TOTAL_FILE_SIZE-size_written,
-     &                       id%INFO(2))
-                     endif
-                     write(unit,iostat=err) id%COLSCA
-                  ELSE
-                     write(unit,iostat=err) -999
-                     if(err.ne.0) then
-                        id%INFO(1) = -72
-                        CALL MUMPS_SETI8TOI4(
-     &                       TOTAL_FILE_SIZE-size_written,
-     &                       id%INFO(2))
-                     endif
-                     write(unit,iostat=err) -999
-                  ENDIF 
-                  if(err.ne.0) then
-                     id%INFO(1) = -72
-                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-                  endif
-                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &                 id%COMM, id%MYID )
-                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
-                  nullify(id%COLSCA)
-                  read(unit,iostat=err) size_array1
-                  if(err.ne.0) THEN
-                     id%INFO(1) = -75
-                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                    ,id%INFO(2))
-                  endif
-                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &                 id%COMM, id%MYID )
-                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
-                  if(size_array1.EQ.-999) then
-                     SIZE_GEST(i1)=SIZE_INT*2
-                     SIZE_VARIABLES(i1)=0_8
-                     read(unit,iostat=err) dummy
-                  else
-                     SIZE_GEST(i1)=SIZE_INT
-                     SIZE_VARIABLES(i1)=size_array1*SIZE_RL_OR_DBL
-                     allocate(id%COLSCA(size_array1), stat=allocok)
-                     if (allocok .GT. 0) THEN
-                        id%INFO(1) = -78
-                        CALL MUMPS_SETI8TOI4(
-     &                       TOTAL_STRUC_SIZE-size_allocated
-     &                       ,id%INFO(2))
-                     endif
-                     read(unit,iostat=err) id%COLSCA
-                  endif
-                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &                 id%COMM, id%MYID )
-                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
-                  if(err.ne.0) THEN
-                     id%INFO(1) = -75
-                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                    ,id%INFO(2))
-                  endif
-                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &                 id%COMM, id%MYID )
-                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               endif
+              CALL MUMPS_SAVERSTR_REALARRAY(id%COLSCA)
             ELSE
             ENDIF
-         CASE("ROWSCA")
+            IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_ROWSCA)
             IF(id%KEEP(52).NE.-1) THEN
-               NbRecords(i1)=2
-               if(trim(mode).EQ."memory_save") then
-                  IF(associated(id%ROWSCA)) THEN
-                     SIZE_GEST(i1)=SIZE_INT
-                     SIZE_VARIABLES(i1)=size(id%ROWSCA,1)*SIZE_RL_OR_DBL
-                  ELSE
-                     SIZE_GEST(i1)=SIZE_INT*2
-                     SIZE_VARIABLES(i1)=0_8
-                  ENDIF
-               elseif(trim(mode).EQ."save") then
-                  IF(associated(id%ROWSCA)) THEN
-                     write(unit,iostat=err) size(id%ROWSCA,1)
-                     if(err.ne.0) then
-                        id%INFO(1) = -72
-                        CALL MUMPS_SETI8TOI4(
-     &                       TOTAL_FILE_SIZE-size_written,
-     &                       id%INFO(2))
-                     endif
-                     write(unit,iostat=err) id%ROWSCA
-                  ELSE
-                     write(unit,iostat=err) -999
-                     if(err.ne.0) then
-                        id%INFO(1) = -72
-                        CALL MUMPS_SETI8TOI4(
-     &                       TOTAL_FILE_SIZE-size_written,
-     &                       id%INFO(2))
-                     endif
-                     write(unit,iostat=err) -999
-                  ENDIF 
-                  if(err.ne.0) then
-                     id%INFO(1) = -72
-                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-                  endif
-                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &                 id%COMM, id%MYID )
-                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
-                  nullify(id%ROWSCA)
-                  read(unit,iostat=err) size_array1
-                  if(err.ne.0) THEN
-                     id%INFO(1) = -75
-                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                    ,id%INFO(2))
-                  endif
-                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &                 id%COMM, id%MYID )
-                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
-                  if(size_array1.EQ.-999) then
-                     SIZE_GEST(i1)=SIZE_INT*2
-                     SIZE_VARIABLES(i1)=0_8
-                     read(unit,iostat=err) dummy
-                  else
-                     SIZE_GEST(i1)=SIZE_INT
-                     SIZE_VARIABLES(i1)=size_array1*SIZE_RL_OR_DBL
-                     allocate(id%ROWSCA(size_array1), stat=allocok)
-                     if (allocok .GT. 0) THEN
-                        id%INFO(1) = -78
-                        CALL MUMPS_SETI8TOI4(
-     &                       TOTAL_STRUC_SIZE-size_allocated
-     &                       ,id%INFO(2))
-                     endif
-                     read(unit,iostat=err) id%ROWSCA
-                  endif
-                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &                 id%COMM, id%MYID )
-                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
-                  if(err.ne.0) THEN
-                     id%INFO(1) = -75
-                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                    ,id%INFO(2))
-                  endif 
-                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &                 id%COMM, id%MYID )
-                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               endif
+              CALL MUMPS_SAVERSTR_REALARRAY(id%ROWSCA)
             ELSE
             ENDIF
-         CASE("NZ_loc")
+            IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_COLSCA_loc)
+            CALL MUMPS_SAVERSTR_REALARRAY(id%COLSCA_loc)
+            IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_ROWSCA_loc)
+            CALL MUMPS_SAVERSTR_REALARRAY(id%ROWSCA_loc)
+            IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NZ_loc)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%NZ_loc
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -2044,7 +1807,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT
                read(unit,iostat=err) id%NZ_loc
                if(err.ne.0) THEN
@@ -2056,11 +1819,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("NNZ_loc")
+         CASE(S_NNZ_loc)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%NNZ_loc
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -2070,7 +1833,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8
                read(unit,iostat=err) id%NNZ_loc
                if(err.ne.0) THEN
@@ -2082,215 +1845,67 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("IRN_loc")
-         CASE("JCN_loc")
-         CASE("A_loc")
-         CASE("NELT")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NELT
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NELT
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("NBLK")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NBLK
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NBLK
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("ELTPTR")
-         CASE("ELTVAR")
-         CASE("A_ELT")
-         CASE("PERM_IN")
-         CASE("BLKPTR")
-         CASE("BLKVAR")
-         CASE("RHS")
-         CASE("REDRHS")
-         CASE("RHS_SPARSE")
-         CASE("SOL_loc")
-         CASE("RHS_loc")
-         CASE("IRHS_SPARSE")
-         CASE("IRHS_PTR")
-         CASE("ISOL_loc")
-         CASE("IRHS_loc")
-         CASE("LRHS")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%LRHS
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%LRHS
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("NRHS")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NRHS
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NRHS
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("NZ_RHS")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NZ_RHS
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NZ_RHS
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("LRHS_loc")
-         CASE("Nloc_RHS")
-         CASE("LSOL_loc")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%LSOL_loc
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%LSOL_loc
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("LREDRHS")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%LREDRHS
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%LREDRHS
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("SYM_PERM")
+         CASE(S_IRN_loc)
+         CASE(S_JCN_loc)
+         CASE(S_A_loc)
+         CASE(S_NELT)
+           CALL MUMPS_SAVE_INT(id%NELT)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NBLK)
+           CALL MUMPS_SAVE_INT(id%NBLK)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_ELTPTR)
+         CASE(S_ELTVAR)
+         CASE(S_A_ELT)
+         CASE(S_PERM_IN)
+         CASE(S_BLKPTR)
+         CASE(S_BLKVAR)
+         CASE(S_COLIND)
+         CASE(S_PIVOTS)
+         CASE(S_RHS)
+         CASE(S_REDRHS)
+         CASE(S_ROWIND)
+         CASE(S_RHS_SPARSE)
+         CASE(S_SOL_loc)
+         CASE(S_RHS_loc)
+         CASE(S_IRHS_SPARSE)
+         CASE(S_IRHS_PTR)
+         CASE(S_ISOL_loc)
+         CASE(S_IRHS_loc)
+         CASE(S_LRHS)
+         CALL MUMPS_SAVE_INT(id%LRHS)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NRHS)
+         CALL MUMPS_SAVE_INT(id%NRHS)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NZ_RHS)
+         CALL MUMPS_SAVE_INT(id%NZ_RHS)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_LRHS_loc)
+         CALL MUMPS_SAVE_INT(id%LRHS_loc)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_Nloc_RHS)
+         CALL MUMPS_SAVE_INT(id%Nloc_RHS)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_LD_RHSINTR)
+         CALL MUMPS_SAVE_INT(id%LD_RHSINTR)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NSOL_loc)
+         CALL MUMPS_SAVE_INT(id%NSOL_loc)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_LSOL_loc)
+         CALL MUMPS_SAVE_INT(id%LSOL_loc)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_LREDRHS)
+         CALL MUMPS_SAVE_INT(id%LREDRHS)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_SYM_PERM)
             CALL ZMUMPS_SAVE_INT_SHPTR_ARRAY(id%SYM_PERM
      &           ) 
             IF (id%INFO(1) .LT. 0 ) GOTO 100
-         CASE("UNS_PERM")
+         CASE(S_UNS_PERM)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%UNS_PERM)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%UNS_PERM,1)*SIZE_INT
@@ -2298,7 +1913,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%UNS_PERM)) THEN
                   write(unit,iostat=err) size(id%UNS_PERM,1)
                   if(err.ne.0) then
@@ -2330,7 +1945,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%UNS_PERM)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -2369,222 +1984,36 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("NPROW")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NPROW
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NPROW
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("NPCOL")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NPCOL
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               NbRecords(i1)=1
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NPCOL
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("MBLOCK")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%MBLOCK
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%MBLOCK
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("NBLOCK")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NBLOCK
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NBLOCK
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("SCHUR_MLOC")
-             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%SCHUR_MLOC
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%SCHUR_MLOC
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("SCHUR_NLOC")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%SCHUR_NLOC
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%SCHUR_NLOC
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("SCHUR_LLD")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%SCHUR_LLD
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%SCHUR_LLD
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("SIZE_SCHUR")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%SIZE_SCHUR
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               NbRecords(i1)=1
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%SIZE_SCHUR
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("SCHUR")
-         CASE("SCHUR_CINTERFACE")
-          CASE("LISTVAR_SCHUR")
-         CASE("MAPPING")
+         CASE(S_NPROW)
+         CALL MUMPS_SAVE_INT(id%NPROW)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NPCOL)
+         CALL MUMPS_SAVE_INT(id%NPCOL)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_MBLOCK)
+         CALL MUMPS_SAVE_INT(id%MBLOCK)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NBLOCK)
+         CALL MUMPS_SAVE_INT(id%NBLOCK)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_SCHUR_MLOC)
+         CALL MUMPS_SAVE_INT(id%SCHUR_MLOC)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_SCHUR_NLOC)
+         CALL MUMPS_SAVE_INT(id%SCHUR_NLOC)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_SCHUR_LLD)
+         CALL MUMPS_SAVE_INT(id%SCHUR_LLD)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_SIZE_SCHUR)
+         CALL MUMPS_SAVE_INT(id%SIZE_SCHUR)
+         IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_SCHUR)
+         CASE(S_SCHUR_CINTERFACE)
+          CASE(S_LISTVAR_SCHUR)
+         CASE(S_MAPPING)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%MAPPING)) THEN
                   SIZE_GEST(i1)=SIZE_INT8
                   SIZE_VARIABLES(i1)=id%KEEP8(28)*SIZE_INT
@@ -2592,7 +2021,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT8+SIZE_INT
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%MAPPING)) THEN
                   write(unit,iostat=err) id%KEEP8(28)
                   if(err.ne.0) then
@@ -2624,7 +2053,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%MAPPING)
                read(unit,iostat=err) size_array_INT8_1
                if(err.ne.0) THEN
@@ -2663,12 +2092,12 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("VERSION_NUMBER")
+         CASE(S_VERSION_NUMBER)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=len(id%VERSION_NUMBER)
      &              *SIZE_CHARACTER
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%VERSION_NUMBER
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -2678,7 +2107,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=len(id%VERSION_NUMBER)
      &              *SIZE_CHARACTER
                read(unit,iostat=err) id%VERSION_NUMBER
@@ -2691,12 +2120,12 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("OOC_TMPDIR")
+         CASE(S_OOC_TMPDIR)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=len(id%OOC_TMPDIR)
      &              *SIZE_CHARACTER
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%OOC_TMPDIR
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -2706,7 +2135,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=len(id%OOC_TMPDIR)
      &              *SIZE_CHARACTER
                read(unit,iostat=err) id%OOC_TMPDIR
@@ -2719,12 +2148,12 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("OOC_PREFIX")
+         CASE(S_OOC_PREFIX)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=len(id%OOC_PREFIX)
      &              *SIZE_CHARACTER
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%OOC_PREFIX
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -2735,7 +2164,7 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
                NbRecords(i1)=1
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=len(id%OOC_PREFIX)
      &              *SIZE_CHARACTER
                read(unit,iostat=err) id%OOC_PREFIX
@@ -2748,12 +2177,12 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("WRITE_PROBLEM")
+         CASE(S_WRITE_PROBLEM)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=len(id%WRITE_PROBLEM)
      &              *SIZE_CHARACTER
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%WRITE_PROBLEM
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -2763,7 +2192,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=len(id%WRITE_PROBLEM)
      &              *SIZE_CHARACTER
                read(unit,iostat=err) id%WRITE_PROBLEM
@@ -2776,11 +2205,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("MAX_SURF_MASTER")
+         CASE(S_MAX_SURF_MASTER)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%MAX_SURF_MASTER
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -2790,7 +2219,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8
                read(unit,iostat=err) id%MAX_SURF_MASTER
                if(err.ne.0) THEN
@@ -2802,181 +2231,43 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("INST_Number")
-               NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%INST_Number
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%INST_Number
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("COMM_NODES")
-            if(trim(mode).EQ."memory_save") then
+         CASE(S_INST_Number)
+           CALL MUMPS_SAVE_INT(id%INST_Number)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_COMM_NODES)
+            if(mode.EQ.memory_save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
             endif
-         CASE("MYID_NODES")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%MYID_NODES
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%MYID_NODES
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("COMM_LOAD")
-            if(trim(mode).EQ."memory_save") then
+         CASE(S_MYID_NODES)
+           CALL MUMPS_SAVE_INT(id%MYID_NODES)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_COMM_LOAD)
+            if(mode.EQ.memory_save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
             endif
-         CASE("MYID")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%MYID
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%MYID
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("NPROCS")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NPROCS
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NPROCS
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("NSLAVES")
-             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NSLAVES
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NSLAVES
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("ASS_IRECV")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%ASS_IRECV
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%ASS_IRECV
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif  
-         CASE("IS")
+         CASE(S_MYID)
+           CALL MUMPS_SAVE_INT(id%MYID)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NPROCS)
+           CALL MUMPS_SAVE_INT(id%NPROCS)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NSLAVES)
+           CALL MUMPS_SAVE_INT(id%NSLAVES)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_ASS_IRECV)
+           CALL MUMPS_SAVE_INT(id%ASS_IRECV)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_IS)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%IS)) THEN
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=id%KEEP(32)*SIZE_INT
@@ -2986,7 +2277,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*3
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%IS)) THEN
                   write(unit,iostat=err) size(id%IS,1),id%KEEP(32)
                   if(err.ne.0) then
@@ -3020,7 +2311,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%IS)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -3061,91 +2352,22 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("Deficiency")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%Deficiency
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%Deficiency
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("LNA")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%LNA
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%LNA
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("NBSA")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NBSA
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NBSA
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("STEP")
+         CASE(S_Deficiency)
+           CALL MUMPS_SAVE_INT(id%Deficiency)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_LNA)
+           CALL MUMPS_SAVE_INT(id%LNA)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_NBSA)
+           CALL MUMPS_SAVE_INT(id%NBSA)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_STEP)
             CALL ZMUMPS_SAVE_INT_SHPTR_ARRAY(id%STEP
      &           ) 
             IF (id%INFO(1) .LT. 0 ) GOTO 100
-         CASE("NE_STEPS")
+         CASE(S_NE_STEPS)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%NE_STEPS)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%NE_STEPS,1)*SIZE_INT
@@ -3153,7 +2375,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%NE_STEPS)) THEN
                   write(unit,iostat=err) size(id%NE_STEPS,1)
                   if(err.ne.0) then
@@ -3185,7 +2407,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%NE_STEPS)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3224,9 +2446,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("ND_STEPS")
+         CASE(S_ND_STEPS)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%ND_STEPS)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%ND_STEPS,1)*SIZE_INT
@@ -3234,7 +2456,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%ND_STEPS)) THEN
                   write(unit,iostat=err) size(id%ND_STEPS,1)
                   if(err.ne.0) then
@@ -3266,7 +2488,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%ND_STEPS)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3305,9 +2527,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("Step2node")
+         CASE(S_Step2node)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%Step2node)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%Step2node,1)*SIZE_INT
@@ -3315,7 +2537,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%Step2node)) THEN
                   write(unit,iostat=err) size(id%Step2node,1)
                   if(err.ne.0) then
@@ -3347,7 +2569,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%Step2node)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3386,9 +2608,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("FRERE_STEPS")
+         CASE(S_FRERE_STEPS)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%FRERE_STEPS)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%FRERE_STEPS,1)*SIZE_INT
@@ -3396,7 +2618,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%FRERE_STEPS)) THEN
                   write(unit,iostat=err) size(id%FRERE_STEPS,1)
                   if(err.ne.0) then
@@ -3428,7 +2650,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%FRERE_STEPS)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3467,9 +2689,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("DAD_STEPS")
+         CASE(S_DAD_STEPS)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%DAD_STEPS)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%DAD_STEPS,1)*SIZE_INT
@@ -3477,7 +2699,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%DAD_STEPS)) THEN
                   write(unit,iostat=err) size(id%DAD_STEPS,1)
                   if(err.ne.0) then
@@ -3509,7 +2731,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%DAD_STEPS)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3548,13 +2770,13 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("FILS")
+         CASE(S_FILS)
             CALL ZMUMPS_SAVE_INT_SHPTR_ARRAY(id%FILS
      &           ) 
             IF ( id%INFO(1) .LT. 0 ) GOTO 100
-         CASE("PTR8ARR")
+         CASE(S_PTR8ARR)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%PTR8ARR)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%PTR8ARR,1)*SIZE_INT8
@@ -3562,7 +2784,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PTR8ARR)) THEN
                   write(unit,iostat=err) size(id%PTR8ARR,1)
                   if(err.ne.0) then
@@ -3595,7 +2817,7 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
                NbRecords(i1)=2
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PTR8ARR)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3634,9 +2856,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("NINCOLARR")
+         CASE(S_NINCOLARR)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                NbRecords(i1)=2
                IF(associated(id%NINCOLARR)) THEN
                   SIZE_GEST(i1)=SIZE_INT
@@ -3645,7 +2867,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%NINCOLARR)) THEN
                   write(unit,iostat=err) size(id%NINCOLARR,1)
                   if(err.ne.0) then
@@ -3677,7 +2899,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%NINCOLARR)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3716,9 +2938,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("NINROWARR")
+         CASE(S_NINROWARR)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                NbRecords(i1)=2
                IF(associated(id%NINROWARR)) THEN
                   SIZE_GEST(i1)=SIZE_INT
@@ -3727,7 +2949,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%NINROWARR)) THEN
                   write(unit,iostat=err) size(id%NINROWARR,1)
                   if(err.ne.0) then
@@ -3759,7 +2981,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%NINROWARR)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3798,9 +3020,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PTRDEBARR")
+         CASE(S_PTRDEBARR)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                NbRecords(i1)=2
                IF(associated(id%PTRDEBARR)) THEN
                   SIZE_GEST(i1)=SIZE_INT
@@ -3809,7 +3031,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PTRDEBARR)) THEN
                   write(unit,iostat=err) size(id%PTRDEBARR,1)
                   if(err.ne.0) then
@@ -3841,7 +3063,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PTRDEBARR)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3880,9 +3102,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PTRAR")
+         CASE(S_PTRAR)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%PTRAR)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%PTRAR,1)*SIZE_INT8
@@ -3890,7 +3112,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PTRAR)) THEN
                   write(unit,iostat=err) size(id%PTRAR,1)
                   if(err.ne.0) then
@@ -3923,7 +3145,7 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
                NbRecords(i1)=2
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PTRAR)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -3962,9 +3184,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("FRTPTR")
+         CASE(S_FRTPTR)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%FRTPTR)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%FRTPTR,1)*SIZE_INT
@@ -3972,7 +3194,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%FRTPTR)) THEN
                   write(unit,iostat=err) size(id%FRTPTR,1)
                   if(err.ne.0) then
@@ -4004,7 +3226,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%FRTPTR)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -4042,9 +3264,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("FRTELT")
+         CASE(S_FRTELT)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%FRTELT)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%FRTELT,1)*SIZE_INT
@@ -4052,7 +3274,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%FRTELT)) THEN
                   write(unit,iostat=err) size(id%FRTELT,1)
                   if(err.ne.0) then
@@ -4078,7 +3300,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%FRTELT)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -4117,9 +3339,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("NA")
+         CASE(S_NA)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%NA)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%NA,1)*SIZE_INT
@@ -4127,7 +3349,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%NA)) THEN
                   write(unit,iostat=err) size(id%NA,1)
                   if(err.ne.0) then
@@ -4153,7 +3375,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%NA)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -4192,9 +3414,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PROCNODE_STEPS")
+         CASE(S_PROCNODE_STEPS)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                NbRecords(i1)=2
                IF(associated(id%PROCNODE_STEPS)) THEN
                   SIZE_GEST(i1)=SIZE_INT
@@ -4203,7 +3425,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PROCNODE_STEPS)) THEN
                   write(unit,iostat=err) size(id%PROCNODE_STEPS,1)
                   if(err.ne.0) then
@@ -4235,7 +3457,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PROCNODE_STEPS)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -4274,9 +3496,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PTLUST_S")
+         CASE(S_PTLUST_S)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%PTLUST_S)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%PTLUST_S,1)*SIZE_INT
@@ -4284,7 +3506,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PTLUST_S)) THEN
                   write(unit,iostat=err) size(id%PTLUST_S,1)
                   if(err.ne.0) then
@@ -4316,7 +3538,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PTLUST_S)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -4355,9 +3577,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PTRFAC")
+         CASE(S_PTRFAC)
             NbRecords(i1)=2  
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%PTRFAC)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%PTRFAC,1)*SIZE_INT8
@@ -4365,7 +3587,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PTRFAC)) THEN
                   write(unit,iostat=err) size(id%PTRFAC,1)
                   if(err.ne.0) then
@@ -4396,7 +3618,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PTRFAC)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -4435,9 +3657,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("S")
+         CASE(S_S)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%S)) THEN
                   SIZE_GEST(i1)=SIZE_INT8*2
                   SIZE_VARIABLES(i1)=id%KEEP8(31)*SIZE_ARITH_DEP
@@ -4447,7 +3669,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT8*2+SIZE_INT
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%S)) THEN
                   write(unit,iostat=err) id%KEEP8(23),id%KEEP8(31)
                   if(err.ne.0) then
@@ -4482,7 +3704,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%S)
                read(unit,iostat=err) size_array_INT8_1,size_array_INT8_2
                if(err.ne.0) THEN
@@ -4524,62 +3746,16 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PROCNODE")
-         CASE("NELT_loc")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NELT_loc
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NELT_loc
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("LELTVAR")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%LELTVAR
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%LELTVAR
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("ELTPROC")
+         CASE(S_PROCNODE)
+         CASE(S_NELT_loc)
+           CALL MUMPS_SAVE_INT(id%NELT_loc)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_LELTVAR)
+           CALL MUMPS_SAVE_INT(id%LELTVAR)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_ELTPROC)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%ELTPROC)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%ELTPROC,1)*SIZE_INT
@@ -4587,7 +3763,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%ELTPROC)) THEN
                   write(unit,iostat=err) size(id%ELTPROC,1)
                   if(err.ne.0) then
@@ -4619,7 +3795,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%ELTPROC)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -4658,9 +3834,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("I4_L0_OMP")
+         CASE(S_I4_L0_OMP)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%I4_L0_OMP)) THEN
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=size(id%I4_L0_OMP,1)
@@ -4669,7 +3845,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*3
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%I4_L0_OMP)) THEN
                   write(unit,iostat=err) size(id%I4_L0_OMP,1)
      &                 ,size(id%I4_L0_OMP,2)
@@ -4702,7 +3878,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%I4_L0_OMP)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -4742,9 +3918,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("I8_L0_OMP")
+         CASE(S_I8_L0_OMP)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%I8_L0_OMP)) THEN
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=size(id%I8_L0_OMP,1)
@@ -4753,7 +3929,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*3
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%I8_L0_OMP)) THEN
                   write(unit,iostat=err) size(id%I8_L0_OMP,1)
      &                 ,size(id%I8_L0_OMP,2)
@@ -4786,7 +3962,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%I8_L0_OMP)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -4826,9 +4002,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("CANDIDATES")
+         CASE(S_CANDIDATES)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%CANDIDATES)) THEN
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=size(id%CANDIDATES,1)
@@ -4837,7 +4013,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*3
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%CANDIDATES)) THEN
                   write(unit,iostat=err) size(id%CANDIDATES,1)
      &                 ,size(id%CANDIDATES,2)
@@ -4870,7 +4046,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%CANDIDATES)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -4910,9 +4086,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("ISTEP_TO_INIV2")
+         CASE(S_ISTEP_TO_INIV2)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%ISTEP_TO_INIV2)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%ISTEP_TO_INIV2,1)*SIZE_INT
@@ -4920,7 +4096,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%ISTEP_TO_INIV2)) THEN
                   write(unit,iostat=err) size(id%ISTEP_TO_INIV2,1)
                   if(err.ne.0) then
@@ -4952,7 +4128,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%ISTEP_TO_INIV2)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -4991,9 +4167,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("FUTURE_NIV2")
+         CASE(S_FUTURE_NIV2)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%FUTURE_NIV2)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%FUTURE_NIV2,1)*SIZE_INT
@@ -5001,7 +4177,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%FUTURE_NIV2)) THEN
                   write(unit,iostat=err) size(id%FUTURE_NIV2,1)
                   if(err.ne.0) then
@@ -5033,7 +4209,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%FUTURE_NIV2)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -5072,9 +4248,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("TAB_POS_IN_PERE")
+         CASE(S_TAB_POS_IN_PERE)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%TAB_POS_IN_PERE)) THEN
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=size(id%TAB_POS_IN_PERE,1)
@@ -5083,7 +4259,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*3
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%TAB_POS_IN_PERE)) THEN
                   write(unit,iostat=err) size(id%TAB_POS_IN_PERE,1)
      &                 ,size(id%TAB_POS_IN_PERE,2)
@@ -5116,7 +4292,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%TAB_POS_IN_PERE)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -5156,9 +4332,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("I_AM_CAND")
+         CASE(S_I_AM_CAND)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%I_AM_CAND)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%I_AM_CAND,1)*SIZE_LOGICAL
@@ -5166,7 +4342,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%I_AM_CAND)) THEN
                   write(unit,iostat=err) size(id%I_AM_CAND,1)
                   if(err.ne.0) then
@@ -5198,7 +4374,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%I_AM_CAND)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -5237,9 +4413,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("MEM_DIST")
+         CASE(S_MEM_DIST)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%MEM_DIST)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%MEM_DIST,1)*SIZE_INT
@@ -5247,7 +4423,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%MEM_DIST)) THEN
                   write(unit,iostat=err) size(id%MEM_DIST,1)
                   if(err.ne.0) then
@@ -5277,7 +4453,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%MEM_DIST)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -5316,20 +4492,20 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("POSINRHSCOMP_ROW")
+         CASE(S_GLOB2LOC_RHS)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
-               IF(associated(id%POSINRHSCOMP_ROW)) THEN
+            if(mode.EQ.memory_save_mode) then
+               IF(associated(id%GLOB2LOC_RHS)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
-     &                 size(id%POSINRHSCOMP_ROW,1)*SIZE_INT
+     &                 size(id%GLOB2LOC_RHS,1)*SIZE_INT
                ELSE
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
-               IF(associated(id%POSINRHSCOMP_ROW)) THEN
-                  write(unit,iostat=err) size(id%POSINRHSCOMP_ROW,1)
+            elseif(mode.EQ.save_mode) then
+               IF(associated(id%GLOB2LOC_RHS)) THEN
+                  write(unit,iostat=err) size(id%GLOB2LOC_RHS,1)
                   if(err.ne.0) then
                      id%INFO(1) = -72
                      CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
@@ -5338,7 +4514,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-                  write(unit,iostat=err) id%POSINRHSCOMP_ROW
+                  write(unit,iostat=err) id%GLOB2LOC_RHS
                ELSE
                   write(unit,iostat=err) -999
                   if(err.ne.0) then
@@ -5359,8 +4535,8 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               nullify(id%POSINRHSCOMP_ROW)
+            elseif(mode.EQ.restore_mode) then
+               nullify(id%GLOB2LOC_RHS)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
                   id%INFO(1) = -75
@@ -5377,7 +4553,7 @@ C
                else
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size_array1*SIZE_INT
-                  allocate(id%POSINRHSCOMP_ROW(size_array1), 
+                  allocate(id%GLOB2LOC_RHS(size_array1), 
      &                 stat=allocok)
                   if (allocok .GT. 0) THEN
                      id%INFO(1) = -78
@@ -5385,7 +4561,7 @@ C
      &                    TOTAL_STRUC_SIZE-size_allocated
      &                    ,id%INFO(2))
                   endif
-                  read(unit,iostat=err) id%POSINRHSCOMP_ROW
+                  read(unit,iostat=err) id%GLOB2LOC_RHS
                endif
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
@@ -5399,12 +4575,12 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("POSINRHSCOMP_COL_ALLOC")
+         CASE(S_GLOB2LOC_SOL_ALLOC)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_LOGICAL
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%POSINRHSCOMP_COL_ALLOC
+            elseif(mode.EQ.save_mode) then
+               write(unit,iostat=err) id%GLOB2LOC_SOL_ALLOC
                if(err.ne.0) then
                   id%INFO(1) = -72
                   CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
@@ -5413,9 +4589,9 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_LOGICAL
-               read(unit,iostat=err) id%POSINRHSCOMP_COL_ALLOC
+               read(unit,iostat=err) id%GLOB2LOC_SOL_ALLOC
                if(err.ne.0) THEN
                   id%INFO(1) = -75
                   CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
@@ -5425,14 +4601,14 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("POSINRHSCOMP_COL")
+         CASE(S_GLOB2LOC_SOL)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
-               IF(associated(id%POSINRHSCOMP_COL)) THEN
-                  IF(id%POSINRHSCOMP_COL_ALLOC) THEN
+            if(mode.EQ.memory_save_mode) then
+               IF(associated(id%GLOB2LOC_SOL)) THEN
+                  IF(id%GLOB2LOC_SOL_ALLOC) THEN
                      SIZE_GEST(i1)=SIZE_INT
                      SIZE_VARIABLES(i1)=
-     &                    size(id%POSINRHSCOMP_COL,1)*SIZE_INT
+     &                    size(id%GLOB2LOC_SOL,1)*SIZE_INT
                   ELSE
                      SIZE_GEST(i1)=SIZE_INT*2
                      SIZE_VARIABLES(i1)=0_8
@@ -5441,10 +4617,10 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
-               IF(associated(id%POSINRHSCOMP_COL)) THEN
-                  IF(id%POSINRHSCOMP_COL_ALLOC) THEN
-                     write(unit,iostat=err) size(id%POSINRHSCOMP_COL,1)
+            elseif(mode.EQ.save_mode) then
+               IF(associated(id%GLOB2LOC_SOL)) THEN
+                  IF(id%GLOB2LOC_SOL_ALLOC) THEN
+                     write(unit,iostat=err) size(id%GLOB2LOC_SOL,1)
                      if(err.ne.0) then
                         id%INFO(1) = -72
                         CALL MUMPS_SETI8TOI4(
@@ -5454,9 +4630,9 @@ C
                      CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                    id%COMM, id%MYID )
                      IF ( id%INFO(1) .LT. 0 ) GOTO 100
-                     write(unit,iostat=err) id%POSINRHSCOMP_COL
+                     write(unit,iostat=err) id%GLOB2LOC_SOL
                   ELSE
-                     write(unit,iostat=err) size(id%POSINRHSCOMP_COL,1)
+                     write(unit,iostat=err) size(id%GLOB2LOC_SOL,1)
                      if(err.ne.0) then
                         id%INFO(1) = -72
                         CALL MUMPS_SETI8TOI4(
@@ -5488,8 +4664,8 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               nullify(id%POSINRHSCOMP_COL)
+            elseif(mode.EQ.restore_mode) then
+               nullify(id%GLOB2LOC_SOL)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
                   id%INFO(1) = -75
@@ -5504,10 +4680,10 @@ C
                   SIZE_VARIABLES(i1)=0_8
                   read(unit,iostat=err) dummy
                else
-                  if(id%POSINRHSCOMP_COL_ALLOC) then
+                  if(id%GLOB2LOC_SOL_ALLOC) then
                      SIZE_GEST(i1)=SIZE_INT
                      SIZE_VARIABLES(i1)=size_array1*SIZE_INT
-                     allocate(id%POSINRHSCOMP_COL(size_array1), 
+                     allocate(id%GLOB2LOC_SOL(size_array1), 
      &                    stat=allocok)
                      if (allocok .GT. 0) THEN
                         id%INFO(1) = -78
@@ -5515,12 +4691,12 @@ C
      &                       TOTAL_STRUC_SIZE-size_allocated
      &                       ,id%INFO(2))
                      endif
-                     read(unit,iostat=err) id%POSINRHSCOMP_COL
+                     read(unit,iostat=err) id%GLOB2LOC_SOL
                   else
                      SIZE_GEST(i1)=SIZE_INT*2
                      SIZE_VARIABLES(i1)=0_8
                      read(unit,iostat=err) dummy
-                     id%POSINRHSCOMP_COL=>id%POSINRHSCOMP_ROW
+                     id%GLOB2LOC_SOL=>id%GLOB2LOC_RHS
                   endif
                endif
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
@@ -5535,18 +4711,18 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("RHSCOMP")
+         CASE(S_RHSINTR)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
-               IF(associated(id%RHSCOMP)) THEN
+            if(mode.EQ.memory_save_mode) then
+               IF(associated(id%RHSINTR)) THEN
                   SIZE_GEST(i1)=SIZE_INT8
                   SIZE_VARIABLES(i1)=id%KEEP8(25)*SIZE_ARITH_DEP
                ELSE
                   SIZE_GEST(i1)=SIZE_INT8+SIZE_INT
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
-               IF(associated(id%RHSCOMP)) THEN
+            elseif(mode.EQ.save_mode) then
+               IF(associated(id%RHSINTR)) THEN
                   write(unit,iostat=err) id%KEEP8(25)
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -5556,7 +4732,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-                  write(unit,iostat=err) id%RHSCOMP
+                  write(unit,iostat=err) id%RHSINTR
                ELSE
                   write(unit,iostat=err) int(-999,8)
                   if(err.ne.0) then
@@ -5577,8 +4753,8 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               nullify(id%RHSCOMP)
+            elseif(mode.EQ.restore_mode) then
+               nullify(id%RHSINTR)
                read(unit,iostat=err) size_array_INT8_1
                if(err.ne.0) THEN
                   id%INFO(1) = -75
@@ -5595,14 +4771,14 @@ C
                else
                   SIZE_GEST(i1)=SIZE_INT8
                   SIZE_VARIABLES(i1)=size_array_INT8_1*SIZE_ARITH_DEP
-                  allocate(id%RHSCOMP(size_array_INT8_1), stat=allocok)
+                  allocate(id%RHSINTR(size_array_INT8_1), stat=allocok)
                   if (allocok .GT. 0) THEN
                      id%INFO(1) = -78
                      CALL MUMPS_SETI8TOI4(
      &                    TOTAL_STRUC_SIZE-size_allocated
      &                    ,id%INFO(2))
                   endif
-                  read(unit,iostat=err) id%RHSCOMP
+                  read(unit,iostat=err) id%RHSINTR
                endif
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
@@ -5616,9 +4792,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("MEM_SUBTREE")
+         CASE(S_MEM_SUBTREE)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%MEM_SUBTREE)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
@@ -5627,7 +4803,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%MEM_SUBTREE)) THEN
                   write(unit,iostat=err) size(id%MEM_SUBTREE,1)
                   if(err.ne.0) then
@@ -5659,7 +4835,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%MEM_SUBTREE)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -5698,9 +4874,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("COST_TRAV")
+         CASE(S_COST_TRAV)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%COST_TRAV)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
@@ -5709,7 +4885,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%COST_TRAV)) THEN
                   write(unit,iostat=err) size(id%COST_TRAV,1)
                   if(err.ne.0) then
@@ -5741,7 +4917,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%COST_TRAV)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -5780,9 +4956,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("MY_ROOT_SBTR")
+         CASE(S_MY_ROOT_SBTR)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%MY_ROOT_SBTR)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%MY_ROOT_SBTR,1)*SIZE_INT
@@ -5790,7 +4966,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%MY_ROOT_SBTR)) THEN
                   write(unit,iostat=err) size(id%MY_ROOT_SBTR,1)
                   if(err.ne.0) then
@@ -5822,7 +4998,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%MY_ROOT_SBTR)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -5861,9 +5037,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("MY_FIRST_LEAF")
+         CASE(S_MY_FIRST_LEAF)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%MY_FIRST_LEAF)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%MY_FIRST_LEAF,1)*SIZE_INT
@@ -5871,7 +5047,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%MY_FIRST_LEAF)) THEN
                   write(unit,iostat=err) size(id%MY_FIRST_LEAF,1)
                   if(err.ne.0) then
@@ -5903,7 +5079,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%MY_FIRST_LEAF)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -5942,9 +5118,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("MY_NB_LEAF")
+         CASE(S_MY_NB_LEAF)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%MY_NB_LEAF)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%MY_NB_LEAF,1)*SIZE_INT
@@ -5952,7 +5128,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%MY_NB_LEAF)) THEN
                   write(unit,iostat=err) size(id%MY_NB_LEAF,1)
                   if(err.ne.0) then
@@ -5984,7 +5160,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%MY_NB_LEAF)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -6023,9 +5199,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("DEPTH_FIRST")
+         CASE(S_DEPTH_FIRST)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%DEPTH_FIRST)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%DEPTH_FIRST,1)*SIZE_INT
@@ -6033,7 +5209,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%DEPTH_FIRST)) THEN
                   write(unit,iostat=err) size(id%DEPTH_FIRST,1)
                   if(err.ne.0) then
@@ -6065,7 +5241,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%DEPTH_FIRST)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -6104,9 +5280,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("DEPTH_FIRST_SEQ")
+         CASE(S_DEPTH_FIRST_SEQ)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%DEPTH_FIRST_SEQ)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%DEPTH_FIRST_SEQ,1)*SIZE_INT
@@ -6114,7 +5290,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%DEPTH_FIRST_SEQ)) THEN
                   write(unit,iostat=err) size(id%DEPTH_FIRST_SEQ,1)
                   if(err.ne.0) then
@@ -6146,7 +5322,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%DEPTH_FIRST_SEQ)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -6186,9 +5362,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("SBTR_ID")
+         CASE(S_SBTR_ID)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%SBTR_ID)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%SBTR_ID,1)*SIZE_INT
@@ -6196,7 +5372,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%SBTR_ID)) THEN
                   write(unit,iostat=err) size(id%SBTR_ID,1)
                   if(err.ne.0) then
@@ -6228,7 +5404,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%SBTR_ID)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -6267,100 +5443,31 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("SCHED_DEP")
-         CASE("SCHED_GRP")
-         CASE("CROIX_MANU")
-         CASE("WK_USER")
-         CASE("NBSA_LOCAL")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NBSA_LOCAL
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NBSA_LOCAL
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("LWK_USER")
-            if(trim(mode).EQ."memory_save") then
+         CASE(S_SCHED_DEP)
+         CASE(S_SCHED_GRP)
+         CASE(S_CROIX_MANU)
+         CASE(S_WK_USER)
+         CASE(S_NBSA_LOCAL)
+           CALL MUMPS_SAVE_INT(id%NBSA_LOCAL)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_LWK_USER)
+            if(mode.EQ.memory_save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_INT
             endif
-         CASE("CB_SON_SIZE")
-         CASE("INSTANCE_NUMBER")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%INSTANCE_NUMBER
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%INSTANCE_NUMBER
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("OOC_MAX_NB_NODES_FOR_ZONE")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%OOC_MAX_NB_NODES_FOR_ZONE
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%OOC_MAX_NB_NODES_FOR_ZONE
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("OOC_INODE_SEQUENCE")
+         CASE(S_CB_SON_SIZE)
+         CASE(S_INSTANCE_NUMBER)
+           CALL MUMPS_SAVE_INT(id%INSTANCE_NUMBER)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_OOC_MAX_NB_NODES_FOR_ZONE)
+           CALL MUMPS_SAVE_INT(id%OOC_MAX_NB_NODES_FOR_ZONE)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_OOC_INODE_SEQUENCE)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%OOC_INODE_SEQUENCE)) THEN
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=size(id%OOC_INODE_SEQUENCE,1)
@@ -6369,7 +5476,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*3
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%OOC_INODE_SEQUENCE)) THEN
                   write(unit,iostat=err) size(id%OOC_INODE_SEQUENCE,1)
      &                 ,size(id%OOC_INODE_SEQUENCE,2)
@@ -6402,7 +5509,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%OOC_INODE_SEQUENCE)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -6442,9 +5549,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("OOC_SIZE_OF_BLOCK")
+         CASE(S_OOC_SIZE_OF_BLOCK)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%OOC_SIZE_OF_BLOCK)) THEN
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=size(id%OOC_SIZE_OF_BLOCK,1)
@@ -6453,7 +5560,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*3
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%OOC_SIZE_OF_BLOCK)) THEN
                   write(unit,iostat=err) size(id%OOC_SIZE_OF_BLOCK,1)
      &                 ,size(id%OOC_SIZE_OF_BLOCK,2)
@@ -6486,7 +5593,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%OOC_SIZE_OF_BLOCK)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -6526,9 +5633,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("OOC_VADDR")
+         CASE(S_OOC_VADDR)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%OOC_VADDR)) THEN
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=size(id%OOC_VADDR,1)
@@ -6537,7 +5644,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*3
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%OOC_VADDR)) THEN
                   write(unit,iostat=err) size(id%OOC_VADDR,1)
      &                 ,size(id%OOC_VADDR,2)
@@ -6570,7 +5677,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%OOC_VADDR)
                read(unit,iostat=err) size_array1,size_array2
                if(err.ne.0) THEN
@@ -6610,9 +5717,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("OOC_TOTAL_NB_NODES")
+         CASE(S_OOC_TOTAL_NB_NODES)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%OOC_TOTAL_NB_NODES)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
@@ -6621,7 +5728,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%OOC_TOTAL_NB_NODES)) THEN
                   write(unit,iostat=err) size(id%OOC_TOTAL_NB_NODES,1)
                   if(err.ne.0) then
@@ -6653,7 +5760,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%OOC_TOTAL_NB_NODES)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -6693,13 +5800,13 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("OOC_NB_FILES")
-         CASE("OOC_NB_FILE_TYPE")
-         CASE("OOC_FILE_NAMES")
-         CASE("OOC_FILE_NAME_LENGTH")
-         CASE("PIVNUL_LIST")
+         CASE(S_OOC_NB_FILES)
+         CASE(S_OOC_NB_FILE_TYPE)
+         CASE(S_OOC_FILE_NAMES)
+         CASE(S_OOC_FILE_NAME_LENGTH)
+         CASE(S_PIVNUL_LIST)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%PIVNUL_LIST)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%PIVNUL_LIST,1)*SIZE_INT
@@ -6707,7 +5814,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PIVNUL_LIST)) THEN
                   write(unit,iostat=err) size(id%PIVNUL_LIST,1)
                   if(err.ne.0) then
@@ -6739,7 +5846,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PIVNUL_LIST)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -6778,10 +5885,10 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("SUP_PROC")
-         CASE("IPTR_WORKING")
+         CASE(S_SUP_PROC)
+         CASE(S_IPTR_WORKING)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%IPTR_WORKING)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%IPTR_WORKING,1)*SIZE_INT
@@ -6789,7 +5896,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%IPTR_WORKING)) THEN
                   write(unit,iostat=err) size(id%IPTR_WORKING,1)
                   if(err.ne.0) then
@@ -6821,7 +5928,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%IPTR_WORKING)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -6860,9 +5967,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("WORKING")
+         CASE(S_WORKING)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%WORKING)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%WORKING,1)*SIZE_INT
@@ -6870,7 +5977,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%WORKING)) THEN
                   write(unit,iostat=err) size(id%WORKING,1)
                   if(err.ne.0) then
@@ -6902,7 +6009,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%WORKING)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -6941,15 +6048,14 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("root")
+         CASE(S_root)
             DO i2=1,NBVARIABLES_ROOT
-            TMP_STRING2 = VARIABLES_ROOT(i2)
-            SELECT CASE(TMP_STRING2)
-            CASE("MBLOCK")
+            SELECT CASE(i2)
+            CASE(R_MBLOCK)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%MBLOCK
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -6959,7 +6065,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%MBLOCK
                   if(err.ne.0) THEN
@@ -6971,11 +6077,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("NBLOCK")
+            CASE(R_NBLOCK)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%NBLOCK
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -6985,7 +6091,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100        
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%NBLOCK
                   if(err.ne.0) THEN
@@ -6997,11 +6103,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-            CASE("NPROW")
+            CASE(R_NPROW)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%NPROW
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7011,7 +6117,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100                 
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%NPROW
                   if(err.ne.0) THEN
@@ -7023,11 +6129,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("NPCOL")
+            CASE(R_NPCOL)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%NPCOL
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7037,7 +6143,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100                
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%NPCOL
                   if(err.ne.0) THEN
@@ -7049,12 +6155,12 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("MYROW")
+            CASE(R_MYROW)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   NbRecords_ROOT(i2)=1
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%MYROW
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7064,7 +6170,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%MYROW
                   if(err.ne.0) THEN
@@ -7076,11 +6182,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("MYCOL")
+            CASE(R_MYCOL)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%MYCOL
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7090,7 +6196,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%MYCOL
                   if(err.ne.0) THEN
@@ -7102,11 +6208,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("SCHUR_MLOC")
+            CASE(R_SCHUR_MLOC)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%SCHUR_MLOC
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7116,7 +6222,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%SCHUR_MLOC
                   if(err.ne.0) THEN
@@ -7128,11 +6234,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("SCHUR_NLOC")
+            CASE(R_SCHUR_NLOC)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%SCHUR_NLOC
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7142,7 +6248,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%SCHUR_NLOC
                   if(err.ne.0) THEN
@@ -7154,11 +6260,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("SCHUR_LLD")
+            CASE(R_SCHUR_LLD)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%SCHUR_LLD
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7168,7 +6274,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%SCHUR_LLD
                   if(err.ne.0) THEN
@@ -7180,11 +6286,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("RHS_NLOC")
+            CASE(R_RHS_NLOC)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%RHS_NLOC
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7194,7 +6300,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%RHS_NLOC
                   if(err.ne.0) THEN
@@ -7206,11 +6312,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("ROOT_SIZE")
+            CASE(R_ROOT_SIZE)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%ROOT_SIZE
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7220,7 +6326,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%ROOT_SIZE
                   if(err.ne.0) THEN
@@ -7232,11 +6338,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("TOT_ROOT_SIZE")
+            CASE(R_TOT_ROOT_SIZE)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%TOT_ROOT_SIZE
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7246,7 +6352,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%TOT_ROOT_SIZE
                   if(err.ne.0) THEN
@@ -7258,12 +6364,12 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("DESCRIPTOR")
+            CASE(R_DESCRIPTOR)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=size(id%root%DESCRIPTOR,1)
      &                 *SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%DESCRIPTOR
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7273,7 +6379,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT*
      &                 size(id%root%DESCRIPTOR,1)
                   read(unit,iostat=err) id%root%DESCRIPTOR
@@ -7286,11 +6392,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("CNTXT_BLACS")
+            CASE(R_CNTXT_BLACS)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%CNTXT_BLACS
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7300,7 +6406,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%CNTXT_BLACS
                   if(err.ne.0) THEN
@@ -7312,11 +6418,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("LPIV")
+            CASE(R_LPIV)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%LPIV
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7326,7 +6432,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%LPIV
                   if(err.ne.0) THEN
@@ -7338,10 +6444,10 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("RG2L")
-            CASE("IPIV")
+            CASE(R_RG2L)
+            CASE(R_IPIV)
                NbRecords_ROOT(i2)=2
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   IF(associated(id%root%IPIV)) THEN
                      SIZE_GEST_ROOT(i2)=SIZE_INT
                      SIZE_VARIABLES_ROOT(i2)=
@@ -7350,7 +6456,7 @@ C
                      SIZE_GEST_ROOT(i2)=SIZE_INT*2
                      SIZE_VARIABLES_ROOT(i2)=0_8
                   ENDIF
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   IF(associated(id%root%IPIV)) THEN
                      write(unit,iostat=err) size(id%root%IPIV,1)
                      if(err.ne.0) then
@@ -7384,7 +6490,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   nullify(id%root%IPIV)
                   read(unit,iostat=err) size_array1
                   if(err.ne.0) THEN
@@ -7423,9 +6529,9 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("RHS_CNTR_MASTER_ROOT")
+            CASE(R_RHS_CNTR_MASTER_ROOT)
                NbRecords_ROOT(i2)=2
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   IF(associated(id%root%RHS_CNTR_MASTER_ROOT)) THEN
                      SIZE_GEST_ROOT(i2)=SIZE_INT
                      SIZE_VARIABLES_ROOT(i2)=
@@ -7435,7 +6541,7 @@ C
                      SIZE_GEST_ROOT(i2)=SIZE_INT*2
                      SIZE_VARIABLES_ROOT(i2)=0_8
                   ENDIF
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   IF(associated(id%root%RHS_CNTR_MASTER_ROOT)) THEN
                      write(unit,iostat=err) 
      &                    size(id%root%RHS_CNTR_MASTER_ROOT,1)
@@ -7470,7 +6576,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   nullify(id%root%RHS_CNTR_MASTER_ROOT)
                   read(unit,iostat=err) size_array1
                   if(err.ne.0) THEN
@@ -7510,11 +6616,94 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("SCHUR_POINTER")
-            CASE("QR_TAU")
-            CASE("RHS_ROOT")
+            CASE(R_SCHUR_POINTER)
+            CASE(R_QR_TAU)
                NbRecords_ROOT(i2)=2
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
+                  IF(associated(id%root%QR_TAU)) THEN
+                     SIZE_GEST_ROOT(i2)=SIZE_INT
+                     SIZE_VARIABLES_ROOT(i2)=
+     &                    size(id%root%QR_TAU,1)*SIZE_ARITH_DEP
+                  ELSE
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*2
+                     SIZE_VARIABLES_ROOT(i2)=0_8
+                  ENDIF
+               elseif(mode.EQ.save_mode) then
+                  IF(associated(id%root%QR_TAU)) THEN
+                     write(unit,iostat=err) size(id%root%QR_TAU,1)
+                     if(err.ne.0) then
+                        id%INFO(1) = -72
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_FILE_SIZE-size_written
+     &                       ,id%INFO(2))
+                     endif
+                     CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                    id%COMM, id%MYID )
+                     IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                     write(unit,iostat=err) id%root%QR_TAU
+                  ELSE
+                     write(unit,iostat=err) -999
+                     if(err.ne.0) then
+                        id%INFO(1) = -72
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_FILE_SIZE-size_written
+     &                       ,id%INFO(2))
+                     endif
+                     CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                    id%COMM, id%MYID )
+                     IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                     write(unit,iostat=err) -999
+                  ENDIF 
+                  if(err.ne.0) then
+                     id%INFO(1) = -72
+                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written
+     &                    ,id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               elseif(mode.EQ.restore_mode) then
+                  nullify(id%root%QR_TAU)
+                  read(unit,iostat=err) size_array1
+                  if(err.ne.0) THEN
+                     id%INFO(1) = -75
+                     CALL MUMPS_SETI8TOI4(SIZE_VARIABLES_ROOT(i2),
+     &                    id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                  if(size_array1.EQ.-999) then
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*2
+                     SIZE_VARIABLES_ROOT(i2)=0_8
+                     read(unit,iostat=err) dummy
+                  else
+                     SIZE_GEST_ROOT(i2)=SIZE_INT
+                     SIZE_VARIABLES_ROOT(i2)=size_array1*SIZE_ARITH_DEP
+                     allocate(id%root%QR_TAU(size_array1), stat=allocok)
+                     if (allocok .GT. 0) THEN
+                        id%INFO(1) = -78
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_STRUC_SIZE-size_allocated
+     &                       ,id%INFO(2))
+                     endif
+                     read(unit,iostat=err) id%root%QR_TAU
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                  if(err.ne.0) THEN
+                     id%INFO(1) = -75
+                     CALL MUMPS_SETI8TOI4(SIZE_VARIABLES_ROOT(i2),
+     &                    id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               endif
+            CASE(R_RHS_ROOT)
+               NbRecords_ROOT(i2)=2
+               if(mode.EQ.memory_save_mode) then
                   IF(associated(id%root%RHS_ROOT)) THEN
                      SIZE_GEST_ROOT(i2)=SIZE_INT*2
                      SIZE_VARIABLES_ROOT(i2)=size(id%root%RHS_ROOT,1)
@@ -7523,7 +6712,7 @@ C
                      SIZE_GEST_ROOT(i2)=SIZE_INT*3
                      SIZE_VARIABLES_ROOT(i2)=0_8
                   ENDIF
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   IF(associated(id%root%RHS_ROOT)) THEN
                      write(unit,iostat=err) size(id%root%RHS_ROOT,1)
      &                    ,size(id%root%RHS_ROOT,2)
@@ -7558,7 +6747,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   nullify(id%root%RHS_ROOT)
                   read(unit,iostat=err) size_array1,size_array2
                   if(err.ne.0) THEN
@@ -7599,11 +6788,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("QR_RCOND")
+            CASE(R_QR_RCOND)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_RL_OR_DBL
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%QR_RCOND
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7613,7 +6802,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_RL_OR_DBL
                   read(unit,iostat=err) id%root%QR_RCOND
                   if(err.ne.0) THEN
@@ -7625,11 +6814,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("yes")
+            CASE(R_yes)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_LOGICAL
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%yes
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7639,7 +6828,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_LOGICAL
                   read(unit,iostat=err) id%root%yes
                   if(err.ne.0) THEN
@@ -7651,11 +6840,11 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("gridinit_done")
+            CASE(R_gridinit_done)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_LOGICAL
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%gridinit_done
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7665,7 +6854,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_LOGICAL
                   read(unit,iostat=err) id%root%gridinit_done
                   if(err.ne.0) THEN
@@ -7677,14 +6866,272 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("SVD_U")
-            CASE("SVD_VT")
-            CASE("SINGULAR_VALUES")
-            CASE("NB_SINGULAR_VALUES")
+            CASE(R_SVD_U)
+               NbRecords_ROOT(i2)=2
+               if(mode.EQ.memory_save_mode) then
+                  IF(associated(id%root%SVD_U)) THEN
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*2
+                     SIZE_VARIABLES_ROOT(i2)=size(id%root%SVD_U,1)
+     &                    *size(id%root%SVD_U,2)*SIZE_ARITH_DEP
+                  ELSE
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*3
+                     SIZE_VARIABLES_ROOT(i2)=0_8
+                  ENDIF
+               elseif(mode.EQ.save_mode) then
+                  IF(associated(id%root%SVD_U)) THEN
+                     write(unit,iostat=err) size(id%root%SVD_U,1)
+     &                    ,size(id%root%SVD_U,2)
+                     if(err.ne.0) then
+                        id%INFO(1) = -72
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_FILE_SIZE-size_written
+     &                       ,id%INFO(2))
+                     endif
+                     CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                    id%COMM, id%MYID )
+                     IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                     write(unit,iostat=err) id%root%SVD_U
+                  ELSE
+                     write(unit,iostat=err) -999,-998
+                     if(err.ne.0) then
+                        id%INFO(1) = -72
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_FILE_SIZE-size_written
+     &                       ,id%INFO(2))
+                     endif
+                     CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                    id%COMM, id%MYID )
+                     IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                     write(unit,iostat=err) -999
+                  ENDIF 
+                  if(err.ne.0) then
+                     id%INFO(1) = -72
+                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written
+     &                    ,id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               elseif(mode.EQ.restore_mode) then
+                  nullify(id%root%SVD_U)
+                  read(unit,iostat=err) size_array1,size_array2
+                  if(err.ne.0) THEN
+                     id%INFO(1) = -75
+                     CALL MUMPS_SETI8TOI4(SIZE_VARIABLES_ROOT(i2),
+     &                    id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                  if(size_array1.EQ.-999) then
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*3
+                     SIZE_VARIABLES_ROOT(i2)=0_8
+                     read(unit,iostat=err) dummy
+                  else
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*2
+                     SIZE_VARIABLES_ROOT(i2)=size_array1*size_array2
+     &                    *SIZE_ARITH_DEP
+                     allocate(id%root%SVD_U(size_array1,size_array2),
+     &                    stat=allocok)
+                     if (allocok .GT. 0) THEN
+                        id%INFO(1) = -78
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_STRUC_SIZE-size_allocated
+     &                       ,id%INFO(2))
+                     endif
+                     read(unit,iostat=err) id%root%SVD_U
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                  if(err.ne.0) THEN
+                     id%INFO(1) = -75
+                     CALL MUMPS_SETI8TOI4(SIZE_VARIABLES_ROOT(i2),
+     &                    id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               endif
+            CASE(R_SVD_VT)
+               NbRecords_ROOT(i2)=2
+               if(mode.EQ.memory_save_mode) then
+                  IF(associated(id%root%SVD_VT)) THEN
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*2
+                     SIZE_VARIABLES_ROOT(i2)=size(id%root%SVD_VT,1)
+     &                    *size(id%root%SVD_VT,2)*SIZE_ARITH_DEP
+                  ELSE
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*3
+                     SIZE_VARIABLES_ROOT(i2)=0_8
+                  ENDIF
+               elseif(mode.EQ.save_mode) then
+                  IF(associated(id%root%SVD_VT)) THEN
+                     write(unit,iostat=err) size(id%root%SVD_VT,1)
+     &                    ,size(id%root%SVD_VT,2)
+                     if(err.ne.0) then
+                        id%INFO(1) = -72
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_FILE_SIZE-size_written
+     &                       ,id%INFO(2))
+                     endif
+                     CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                    id%COMM, id%MYID )
+                     IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                     write(unit,iostat=err) id%root%SVD_VT
+                  ELSE
+                     write(unit,iostat=err) -999,-998
+                     if(err.ne.0) then
+                        id%INFO(1) = -72
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_FILE_SIZE-size_written
+     &                       ,id%INFO(2))
+                     endif
+                     CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                    id%COMM, id%MYID )
+                     IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                     write(unit,iostat=err) -999
+                  ENDIF 
+                  if(err.ne.0) then
+                     id%INFO(1) = -72
+                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written
+     &                    ,id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               elseif(mode.EQ.restore_mode) then
+                  nullify(id%root%SVD_VT)
+                  read(unit,iostat=err) size_array1,size_array2
+                  if(err.ne.0) THEN
+                     id%INFO(1) = -75
+                     CALL MUMPS_SETI8TOI4(SIZE_VARIABLES_ROOT(i2),
+     &                    id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                  if(size_array1.EQ.-999) then
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*3
+                     SIZE_VARIABLES_ROOT(i2)=0_8
+                     read(unit,iostat=err) dummy
+                  else
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*2
+                     SIZE_VARIABLES_ROOT(i2)=size_array1*size_array2
+     &                    *SIZE_ARITH_DEP
+                     allocate(id%root%SVD_VT(size_array1,size_array2),
+     &                    stat=allocok)
+                     if (allocok .GT. 0) THEN
+                        id%INFO(1) = -78
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_STRUC_SIZE-size_allocated
+     &                       ,id%INFO(2))
+                     endif
+                     read(unit,iostat=err) id%root%SVD_VT
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                  if(err.ne.0) THEN
+                     id%INFO(1) = -75
+                     CALL MUMPS_SETI8TOI4(SIZE_VARIABLES_ROOT(i2),
+     &                    id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               endif
+            CASE(R_SINGULAR_VALUES)
+               NbRecords_ROOT(i2)=2
+               if(mode.EQ.memory_save_mode) then
+                  IF(associated(id%root%SINGULAR_VALUES)) THEN
+                     SIZE_GEST_ROOT(i2)=SIZE_INT
+                     SIZE_VARIABLES_ROOT(i2)=
+     &                    size(id%root%SINGULAR_VALUES,1)
+     &                    *SIZE_RL_OR_DBL
+                  ELSE
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*2
+                     SIZE_VARIABLES_ROOT(i2)=0_8
+                  ENDIF
+               elseif(mode.EQ.save_mode) then
+                  IF(associated(id%root%SINGULAR_VALUES)) THEN
+                     write(unit,iostat=err) 
+     &                    size(id%root%SINGULAR_VALUES,1)
+                     if(err.ne.0) then
+                        id%INFO(1) = -72
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_FILE_SIZE-size_written
+     &                       ,id%INFO(2))
+                     endif
+                     CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                    id%COMM, id%MYID )
+                     IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                     write(unit,iostat=err) id%root%SINGULAR_VALUES
+                  ELSE
+                     write(unit,iostat=err) -999
+                     if(err.ne.0) then
+                        id%INFO(1) = -72
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_FILE_SIZE-size_written
+     &                       ,id%INFO(2))
+                     endif
+                     CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                    id%COMM, id%MYID )
+                     IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                     write(unit,iostat=err) -999
+                  ENDIF 
+                  if(err.ne.0) then
+                     id%INFO(1) = -72
+                     CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written
+     &                    ,id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               elseif(mode.EQ.restore_mode) then
+                  nullify(id%root%SINGULAR_VALUES)
+                  read(unit,iostat=err) size_array1
+                  if(err.ne.0) THEN
+                     id%INFO(1) = -75
+                     CALL MUMPS_SETI8TOI4(SIZE_VARIABLES_ROOT(i2)
+     &                    ,id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                  if(size_array1.EQ.-999) then
+                     SIZE_GEST_ROOT(i2)=SIZE_INT*2
+                     SIZE_VARIABLES_ROOT(i2)=0_8
+                     read(unit,iostat=err) dummy
+                  else
+                     SIZE_GEST_ROOT(i2)=SIZE_INT
+                     SIZE_VARIABLES_ROOT(i2)=size_array1*SIZE_RL_OR_DBL
+                     allocate(id%root%SINGULAR_VALUES(size_array1),
+     &                    stat=allocok)
+                     if (allocok .GT. 0) THEN
+                        id%INFO(1) = -78
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_STRUC_SIZE-size_allocated
+     &                       ,id%INFO(2))
+                     endif
+                     read(unit,iostat=err) id%root%SINGULAR_VALUES
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                  if(err.ne.0) THEN
+                     id%INFO(1) = -75
+                     CALL MUMPS_SETI8TOI4(SIZE_VARIABLES_ROOT(i2)
+     &                    ,id%INFO(2))
+                  endif
+                  CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+                  IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               endif
+            CASE(R_NB_SINGULAR_VALUES)
                NbRecords_ROOT(i2)=1
-               if(trim(mode).EQ."memory_save") then
+               if(mode.EQ.memory_save_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
-               elseif(trim(mode).EQ."save") then
+               elseif(mode.EQ.save_mode) then
                   write(unit,iostat=err) id%root%NB_SINGULAR_VALUES
                   if(err.ne.0) then
                      id%INFO(1) = -72
@@ -7694,7 +7141,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-               elseif(trim(mode).EQ."restore") then
+               elseif(mode.EQ.restore_mode) then
                   SIZE_VARIABLES_ROOT(i2)=SIZE_INT
                   read(unit,iostat=err) id%root%NB_SINGULAR_VALUES
                   if(err.ne.0) THEN
@@ -7706,23 +7153,23 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                endif
-            CASE("rootpad0","rootpad1","rootpad2","rootpad",
-     &              "rootpad3","rootpad4")
+            CASE(R_rootpad0,R_rootpad1,R_rootpad2,
+     &           R_rootpad3,R_rootpad4)
             CASE DEFAULT
             END SELECT
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                NbSubRecords=int(SIZE_VARIABLES_ROOT(i2)/huge(I4))
                IF(NbSubRecords.GT.0) then
                   NbRecords_ROOT(i2)=NbRecords_ROOT(i2)+NbSubRecords
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                size_written=size_written+SIZE_VARIABLES_ROOT(i2)
      &              +SIZE_GEST_ROOT(i2)
 #if defined(MUMPS_NOF2003)
                size_written=size_written
      &              +int(2*id%KEEP(34)*NbRecords_ROOT(i2),kind=8)
 #endif
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                size_allocated=size_allocated+SIZE_VARIABLES_ROOT(i2)+
      &              DIFF_SIZE_ALLOC_READ_ROOT(i2)
                size_read=size_read+SIZE_VARIABLES_ROOT(i2)
@@ -7731,53 +7178,30 @@ C
                size_read=size_read
      &              +int(2*id%KEEP(34)*NbRecords_ROOT(i2),kind=8)
 #endif
-            elseif(trim(mode).EQ."fake_restore") then
+            elseif(mode.EQ.fake_restore_mode) then
             endif
          ENDDO
-         CASE("NBGRP")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%NBGRP
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%NBGRP
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-        CASE("LRGROUPS")
+         CASE(S_NBGRP)
+           CALL MUMPS_SAVE_INT(id%NBGRP)
+           IF (id%INFO(1) .LT. 0) GOTO 100
+         CASE(S_LRGROUPS)
             CALL ZMUMPS_SAVE_INT_SHPTR_ARRAY(id%LRGROUPS
      &           ) 
             IF (id%INFO(1) .LT. 0 ) GOTO 100
-         CASE("FDM_F_ENCODING")
+         CASE(S_FDM_F_ENCODING)
             NbRecords(i1)=1
             SIZE_GEST(i1)=SIZE_INT
             SIZE_VARIABLES(i1)=0_8
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%FDM_F_ENCODING)) THEN
                   CALL MUMPS_SAVE_RESTORE_FRONT_DATA(id%FDM_F_ENCODING
-     &                 ,unit,id%MYID,"memory_save"
+     &                 ,unit,id%MYID,memory_save_mode
      &                 ,SIZE_GEST_FRONT_DATA,SIZE_VARIABLES_FRONT_DATA
      &                 ,SIZE_INT,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
      &                 ,size_read,size_allocated,size_written
      &                 ,id%INFO(1))                 
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%FDM_F_ENCODING)) THEN
                   write(unit,iostat=err) size(id%FDM_F_ENCODING,1)
                   if(err.ne.0) then
@@ -7789,7 +7213,7 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                   CALL MUMPS_SAVE_RESTORE_FRONT_DATA(id%FDM_F_ENCODING
-     &                 ,unit,id%MYID,"save"
+     &                 ,unit,id%MYID,save_mode
      &                 ,SIZE_GEST_FRONT_DATA,SIZE_VARIABLES_FRONT_DATA
      &                 ,SIZE_INT,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
      &                 ,size_read,size_allocated,size_written
@@ -7813,7 +7237,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%FDM_F_ENCODING)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -7826,7 +7250,7 @@ C
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
                if(size_array1.NE.-999) then
                   CALL MUMPS_SAVE_RESTORE_FRONT_DATA(id%FDM_F_ENCODING
-     &                 ,unit,id%MYID,"restore"
+     &                 ,unit,id%MYID,restore_mode
      &                 ,SIZE_GEST_FRONT_DATA,SIZE_VARIABLES_FRONT_DATA
      &                 ,SIZE_INT,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
      &                 ,size_read,size_allocated,size_written
@@ -7844,21 +7268,21 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("BLRARRAY_ENCODING")            
+         CASE(S_BLRARRAY_ENCODING)            
             NbRecords(i1)=1
             SIZE_GEST(i1)=SIZE_INT
             SIZE_VARIABLES(i1)=0_8
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%BLRARRAY_ENCODING)) THEN
                   CALL ZMUMPS_SAVE_RESTORE_BLR(id%BLRARRAY_ENCODING
-     &                 ,unit,id%MYID,"memory_save"
+     &                 ,unit,id%MYID,memory_save_mode
      &                 ,SIZE_GEST_BLR,SIZE_VARIABLES_BLR
      &                 ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
      &                 ,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
      &                 ,size_read,size_allocated,size_written
      &                 ,id%INFO(1))                 
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%BLRARRAY_ENCODING)) THEN
                   write(unit,iostat=err) size(id%BLRARRAY_ENCODING,1)
                   if(err.ne.0) then
@@ -7870,7 +7294,7 @@ C
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
                   CALL ZMUMPS_SAVE_RESTORE_BLR(id%BLRARRAY_ENCODING
-     &                 ,unit,id%MYID,"save"
+     &                 ,unit,id%MYID,save_mode
      &                 ,SIZE_GEST_BLR,SIZE_VARIABLES_BLR
      &                 ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
      &                 ,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
@@ -7895,7 +7319,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%BLRARRAY_ENCODING)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -7908,7 +7332,7 @@ C
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
                if(size_array1.NE.-999) then
                   CALL ZMUMPS_SAVE_RESTORE_BLR(id%BLRARRAY_ENCODING
-     &                 ,unit,id%MYID,"restore"
+     &                 ,unit,id%MYID,restore_mode
      &                 ,SIZE_GEST_BLR,SIZE_VARIABLES_BLR
      &                 ,SIZE_INT, SIZE_ARITH_DEP, SIZE_LOGICAL
      &                 ,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
@@ -7927,179 +7351,41 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("L0_OMP_FACTORS")
+         CASE(S_L0_OMP_FACTORS)
             NbRecords(i1)     =0   
             SIZE_GEST(i1)     =0   
             SIZE_VARIABLES(i1)=0_8 
             CALL ZMUMPS_SAVE_RESTORE_L0FACARRAY(id%L0_OMP_FACTORS
-     &                 ,unit,id%MYID,trim(mode)
+     &                 ,unit,id%MYID,mode
      &                 ,SIZE_GEST_L0FAC,SIZE_VARIABLES_L0FAC
      &                 ,SIZE_INT, SIZE_INT8, SIZE_ARITH_DEP
      &                 ,TOTAL_FILE_SIZE,TOTAL_STRUC_SIZE
      &                 ,size_read,size_allocated,size_written
      &                 ,id%INFO(1))                 
-         CASE("SCHED_SBTR")
-         CASE("LPOOL_A_L0_OMP")
+         CASE(S_SCHED_SBTR)
+         CASE(S_LPOOL_A_L0_OMP)
+           CALL MUMPS_SAVE_INT(id%LPOOL_A_L0_OMP)
+           IF ( id%INFO(1) .LT. 0 ) GOTO 100
+         CASE(S_LPOOL_B_L0_OMP)
+           CALL MUMPS_SAVE_INT(id%LPOOL_B_L0_OMP)
+           IF ( id%INFO(1) .LT. 0 ) GOTO 100
+         CASE(S_L_PHYS_L0_OMP)
+           CALL MUMPS_SAVE_INT(id%L_PHYS_L0_OMP)
+           IF ( id%INFO(1) .LT. 0 ) GOTO 100
+         CASE(S_L_VIRT_L0_OMP)     
+           CALL MUMPS_SAVE_INT(id%L_VIRT_L0_OMP)
+           IF ( id%INFO(1) .LT. 0 ) GOTO 100
+         CASE(S_LL0_OMP_MAPPING)
+           CALL MUMPS_SAVE_INT(id%LL0_OMP_MAPPING)
+           IF ( id%INFO(1) .LT. 0 ) GOTO 100
+         CASE(S_LL0_OMP_FACTORS)
+           CALL MUMPS_SAVE_INT(id%LL0_OMP_FACTORS)
+           IF ( id%INFO(1) .LT. 0 ) GOTO 100
+         CASE(S_THREAD_LA)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%LPOOL_A_L0_OMP
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%LPOOL_A_L0_OMP
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("LPOOL_B_L0_OMP")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%LPOOL_B_L0_OMP
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%LPOOL_B_L0_OMP
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("L_PHYS_L0_OMP")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%L_PHYS_L0_OMP
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%L_PHYS_L0_OMP
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("L_VIRT_L0_OMP")     
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%L_VIRT_L0_OMP
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%L_VIRT_L0_OMP
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("LL0_OMP_MAPPING")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%LL0_OMP_MAPPING
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%LL0_OMP_MAPPING
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("LL0_OMP_FACTORS")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-            elseif(trim(mode).EQ."save") then
-               write(unit,iostat=err) id%LL0_OMP_FACTORS
-               if(err.ne.0) then
-                  id%INFO(1) = -72
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                 id%INFO(2))
-               endif
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               SIZE_VARIABLES(i1)=SIZE_INT
-               read(unit,iostat=err) id%LL0_OMP_FACTORS
-               if(err.ne.0) THEN
-                  id%INFO(1) = -75
-                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                 ,id%INFO(2))
-               endif 
-               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &              id%COMM, id%MYID )
-               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            endif
-         CASE("THREAD_LA")
-            NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%THREAD_LA
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -8109,7 +7395,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT8
                read(unit,iostat=err) id%THREAD_LA
                if(err.ne.0) THEN
@@ -8121,9 +7407,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("IPOOL_A_L0_OMP")
+         CASE(S_IPOOL_A_L0_OMP)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%IPOOL_A_L0_OMP)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
@@ -8132,7 +7418,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%IPOOL_A_L0_OMP)) THEN
                   write(unit,iostat=err) size(id%IPOOL_A_L0_OMP,1)
                   if(err.ne.0) then
@@ -8164,7 +7450,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%IPOOL_A_L0_OMP)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -8204,9 +7490,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("IPOOL_B_L0_OMP")
+         CASE(S_IPOOL_B_L0_OMP)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%IPOOL_B_L0_OMP)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
@@ -8215,7 +7501,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%IPOOL_B_L0_OMP)) THEN
                   write(unit,iostat=err) size(id%IPOOL_B_L0_OMP,1)
                   if(err.ne.0) then
@@ -8247,7 +7533,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%IPOOL_B_L0_OMP)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -8287,9 +7573,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PHYS_L0_OMP")
+         CASE(S_PHYS_L0_OMP)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%PHYS_L0_OMP)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
@@ -8298,7 +7584,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PHYS_L0_OMP)) THEN
                   write(unit,iostat=err) size(id%PHYS_L0_OMP,1)
                   if(err.ne.0) then
@@ -8330,7 +7616,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PHYS_L0_OMP)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -8369,9 +7655,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("VIRT_L0_OMP")
+         CASE(S_VIRT_L0_OMP)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%VIRT_L0_OMP)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%VIRT_L0_OMP,1)*SIZE_INT
@@ -8379,7 +7665,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%VIRT_L0_OMP)) THEN
                   write(unit,iostat=err) size(id%VIRT_L0_OMP,1)
                   if(err.ne.0) then
@@ -8411,7 +7697,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%VIRT_L0_OMP)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -8450,9 +7736,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("VIRT_L0_OMP_MAPPING")
+         CASE(S_VIRT_L0_OMP_MAPPING)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%VIRT_L0_OMP_MAPPING)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%VIRT_L0_OMP_MAPPING,1)
@@ -8461,7 +7747,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%VIRT_L0_OMP_MAPPING)) THEN
                   write(unit,iostat=err) size(id%VIRT_L0_OMP_MAPPING,1)
                   if(err.ne.0) then
@@ -8493,7 +7779,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%VIRT_L0_OMP_MAPPING)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -8533,9 +7819,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PERM_L0_OMP")
+         CASE(S_PERM_L0_OMP)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%PERM_L0_OMP)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size(id%PERM_L0_OMP,1)*SIZE_INT
@@ -8543,7 +7829,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PERM_L0_OMP)) THEN
                   write(unit,iostat=err) size(id%PERM_L0_OMP,1)
                   if(err.ne.0) then
@@ -8575,7 +7861,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PERM_L0_OMP)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -8614,9 +7900,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("PTR_LEAFS_L0_OMP")
+         CASE(S_PTR_LEAFS_L0_OMP)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%PTR_LEAFS_L0_OMP)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
@@ -8625,7 +7911,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%PTR_LEAFS_L0_OMP)) THEN
                   write(unit,iostat=err) size(id%PTR_LEAFS_L0_OMP,1)
                   if(err.ne.0) then
@@ -8657,7 +7943,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%PTR_LEAFS_L0_OMP)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -8697,9 +7983,9 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("L0_OMP_MAPPING")
+         CASE(S_L0_OMP_MAPPING)
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id%L0_OMP_MAPPING)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
@@ -8708,7 +7994,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id%L0_OMP_MAPPING)) THEN
                   write(unit,iostat=err) size(id%L0_OMP_MAPPING,1)
                   if(err.ne.0) then
@@ -8740,7 +8026,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id%L0_OMP_MAPPING)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -8779,46 +8065,102 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("SINGULAR_VALUES")
-        CASE("NB_SINGULAR_VALUES")
-           NbRecords(i1)=1
-           if(trim(mode).EQ."memory_save") then
-              SIZE_VARIABLES(i1)=SIZE_INT
-           elseif(trim(mode).EQ."save") then
-              write(unit,iostat=err) id%NB_SINGULAR_VALUES
+         CASE(S_SINGULAR_VALUES)
+            NbRecords(i1)=2
+            if(mode.EQ.memory_save_mode) then
+               IF(associated(id%SINGULAR_VALUES)) THEN
+                  SIZE_GEST(i1)=SIZE_INT
+                  SIZE_VARIABLES(i1)=
+     &                 size(id%SINGULAR_VALUES,1)*SIZE_RL_OR_DBL
+              ELSE
+                 SIZE_GEST(i1)=SIZE_INT*2
+                 SIZE_VARIABLES(i1)=0_8
+              ENDIF
+           elseif(mode.EQ.save_mode) then
+              IF(associated(id%SINGULAR_VALUES)) THEN
+                 write(unit,iostat=err) size(id%SINGULAR_VALUES,1)
+                 if(err.ne.0) then
+                    id%INFO(1) = -72
+                    CALL MUMPS_SETI8TOI4(size_written,id%INFO(2))
+                 endif
+                 CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                id%COMM, id%MYID )
+                 IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                 write(unit,iostat=err) id%SINGULAR_VALUES
+              ELSE
+                 write(unit,iostat=err) -999
+                 if(err.ne.0) then
+                    id%INFO(1) = -72
+                    CALL MUMPS_SETI8TOI4(size_written,id%INFO(2))
+                 endif
+                 CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                id%COMM, id%MYID )
+                 IF ( id%INFO(1) .LT. 0 ) GOTO 100
+                 write(unit,iostat=err) -999
+              ENDIF 
               if(err.ne.0) then
                  id%INFO(1) = -72
-                 CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
-     &                id%INFO(2))
+                 CALL MUMPS_SETI8TOI4(size_written,id%INFO(2))
               endif
               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &             id%COMM, id%MYID )
               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-           elseif(trim(mode).EQ."restore") then
-              SIZE_VARIABLES(i1)=SIZE_INT
-              read(unit,iostat=err) id%NB_SINGULAR_VALUES
-              if(err.ne.0) THEN
-                 id%INFO(1) = -75
-                 CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
-     &                ,id%INFO(2))
-              endif 
-              CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
-     &             id%COMM, id%MYID )
-              IF ( id%INFO(1) .LT. 0 ) GOTO 100
+           elseif(mode.EQ.restore_mode) then
+              nullify(id%SINGULAR_VALUES)
+               read(unit,iostat=err) size_array1
+               if(err.ne.0) THEN
+                  id%INFO(1) = -75
+                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
+     &                 ,id%INFO(2))
+               endif
+               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &              id%COMM, id%MYID )
+               IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               if(size_array1.EQ.-999) then
+                  SIZE_GEST(i1)=SIZE_INT*2
+                  SIZE_VARIABLES(i1)=0_8
+                  read(unit,iostat=err) dummy
+               else
+                  SIZE_GEST(i1)=SIZE_INT
+                  SIZE_VARIABLES(i1)=size_array1*SIZE_RL_OR_DBL
+                  allocate(id%SINGULAR_VALUES(size_array1),
+     &                 stat=allocok)
+                  if (allocok .GT. 0) THEN
+                     id%INFO(1) = -78
+                     CALL MUMPS_SETI8TOI4(
+     &                    TOTAL_STRUC_SIZE-size_allocated
+     &                    ,id%INFO(2))
+                  endif
+                  read(unit,iostat=err) id%SINGULAR_VALUES
+               endif
+               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &              id%COMM, id%MYID )
+               IF ( id%INFO(1) .LT. 0 ) GOTO 100
+               if(err.ne.0) THEN
+                  id%INFO(1) = -75
+                  CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
+     &                 ,id%INFO(2))
+               endif
+               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &              id%COMM, id%MYID )
+               IF ( id%INFO(1) .LT. 0 ) GOTO 100
            endif
-        CASE("ASSOCIATED_OOC_FILES")
-            if(trim(mode).EQ."memory_save") then
+        CASE(S_NB_SINGULAR_VALUES)
+           CALL MUMPS_SAVE_INT(id%NB_SINGULAR_VALUES)
+           IF ( id%INFO(1) .LT. 0 ) GOTO 100
+        CASE(S_ASSOCIATED_OOC_FILES)
+            if(mode.EQ.memory_save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_LOGICAL
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_LOGICAL
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                DIFF_SIZE_ALLOC_READ(i1)=SIZE_LOGICAL
             endif
-        CASE("SAVE_DIR")
+        CASE(S_SAVE_DIR)
            NbRecords(i1)=1
-           if(trim(mode).EQ."memory_save") then
+           if(mode.EQ.memory_save_mode) then
               SIZE_VARIABLES(i1)=len(id%SAVE_DIR)*SIZE_CHARACTER
-           elseif(trim(mode).EQ."save") then
+           elseif(mode.EQ.save_mode) then
               write(unit,iostat=err) id%SAVE_DIR
               if(err.ne.0) then
                  id%INFO(1) = -72
@@ -8828,7 +8170,7 @@ C
               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &             id%COMM, id%MYID )
               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-           elseif(trim(mode).EQ."restore") then
+           elseif(mode.EQ.restore_mode) then
               SIZE_VARIABLES(i1)=len(id%SAVE_DIR)*SIZE_CHARACTER
               read(unit,iostat=err) id%SAVE_DIR
               if(err.ne.0) THEN
@@ -8840,11 +8182,11 @@ C
      &             id%COMM, id%MYID )
               IF ( id%INFO(1) .LT. 0 ) GOTO 100
            endif
-        CASE("SAVE_PREFIX")
+        CASE(S_SAVE_PREFIX)
            NbRecords(i1)=1
-           if(trim(mode).EQ."memory_save") then
+           if(mode.EQ.memory_save_mode) then
               SIZE_VARIABLES(i1)=len(id%SAVE_PREFIX)*SIZE_CHARACTER
-           elseif(trim(mode).EQ."save") then
+           elseif(mode.EQ.save_mode) then
               write(unit,iostat=err) id%SAVE_PREFIX
               if(err.ne.0) then
                  id%INFO(1) = -72
@@ -8854,7 +8196,7 @@ C
               CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &             id%COMM, id%MYID )
               IF ( id%INFO(1) .LT. 0 ) GOTO 100
-           elseif(trim(mode).EQ."restore") then
+           elseif(mode.EQ.restore_mode) then
               SIZE_VARIABLES(i1)=len(id%SAVE_PREFIX)*SIZE_CHARACTER
               read(unit,iostat=err) id%SAVE_PREFIX
               if(err.ne.0) THEN
@@ -8866,20 +8208,20 @@ C
      &             id%COMM, id%MYID )
               IF ( id%INFO(1) .LT. 0 ) GOTO 100
            endif
-        CASE("MPITOOMP_PROCS_MAP")
+        CASE(S_MTKO_PROCS_MAP)
            NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
-               IF(associated(id%MPITOOMP_PROCS_MAP)) THEN
+            if(mode.EQ.memory_save_mode) then
+               IF(associated(id%MTKO_PROCS_MAP)) THEN
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=
-     &                 size(id%MPITOOMP_PROCS_MAP,1)*SIZE_INT
+     &                 size(id%MTKO_PROCS_MAP,1)*SIZE_INT
                ELSE
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
-               IF(associated(id%MPITOOMP_PROCS_MAP)) THEN
-                  write(unit,iostat=err) size(id%MPITOOMP_PROCS_MAP,1)
+            elseif(mode.EQ.save_mode) then
+               IF(associated(id%MTKO_PROCS_MAP)) THEN
+                  write(unit,iostat=err) size(id%MTKO_PROCS_MAP,1)
                   if(err.ne.0) then
                      id%INFO(1) = -72
                      CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
@@ -8888,7 +8230,7 @@ C
                   CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &                 id%COMM, id%MYID )
                   IF ( id%INFO(1) .LT. 0 ) GOTO 100
-                  write(unit,iostat=err) id%MPITOOMP_PROCS_MAP
+                  write(unit,iostat=err) id%MTKO_PROCS_MAP
                ELSE
                   write(unit,iostat=err) -999
                   if(err.ne.0) then
@@ -8909,8 +8251,8 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
-               nullify(id%MPITOOMP_PROCS_MAP)
+            elseif(mode.EQ.restore_mode) then
+               nullify(id%MTKO_PROCS_MAP)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
                   id%INFO(1) = -75
@@ -8927,7 +8269,7 @@ C
                else
                   SIZE_GEST(i1)=SIZE_INT
                   SIZE_VARIABLES(i1)=size_array1*SIZE_INT
-                  allocate(id%MPITOOMP_PROCS_MAP(size_array1),
+                  allocate(id%MTKO_PROCS_MAP(0:size_array1-1),
      &                 stat=allocok)
                   if (allocok .GT. 0) THEN
                      id%INFO(1) = -78
@@ -8935,7 +8277,7 @@ C
      &                    TOTAL_STRUC_SIZE-size_allocated
      &                    ,id%INFO(2))
                   endif
-                  read(unit,iostat=err) id%MPITOOMP_PROCS_MAP
+                  read(unit,iostat=err) id%MTKO_PROCS_MAP
                endif
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
@@ -8949,11 +8291,11 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif
-         CASE("METIS_OPTIONS")
+         CASE(S_METIS_OPTIONS)
             NbRecords(i1)=1
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%METIS_OPTIONS,1)
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                write(unit,iostat=err) id%METIS_OPTIONS
                if(err.ne.0) then
                   id%INFO(1) = -72
@@ -8963,7 +8305,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                SIZE_VARIABLES(i1)=SIZE_INT*size(id%METIS_OPTIONS,1)
                read(unit,iostat=err) id%METIS_OPTIONS
                if(err.ne.0) THEN
@@ -8975,23 +8317,23 @@ C
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
             endif      
-      CASE("pad0","pad1","pad2","pad3","pad4","pad5","pad6","pad7",
-     &     "pad11","pad111", "pad12","pad13","pad14","pad15","pad16")
+      CASE(S_pad1,S_pad2,S_pad3,S_pad4,S_pad5,S_pad6,S_pad7,
+     &     S_pad11,S_pad12,S_pad13,S_pad14,S_pad16)
       CASE DEFAULT
       END SELECT
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          NbSubRecords=int(SIZE_VARIABLES(i1)/huge(I4))
          IF(NbSubRecords.GT.0) then
             NbRecords(i1)=NbRecords(i1)+NbSubRecords
          ENDIF
-      elseif(trim(mode).EQ."save") then
+      elseif(mode.EQ.save_mode) then
          size_written=size_written+SIZE_VARIABLES(i1)
      &        +int(SIZE_GEST(i1),kind=8)
 #if defined(MUMPS_NOF2003)
          size_written=size_written
      &        +int(2*id%KEEP(34)*NbRecords(i1),kind=8)
 #endif
-      elseif(trim(mode).EQ."restore") then
+      elseif(mode.EQ.restore_mode) then
          size_allocated=size_allocated+SIZE_VARIABLES(i1)+
      &        DIFF_SIZE_ALLOC_READ(i1)
          size_read=size_read+SIZE_VARIABLES(i1)
@@ -9000,11 +8342,11 @@ C
          size_read=size_read
      &        +int(2*id%KEEP(34)*NbRecords(i1),kind=8)
 #endif
-      elseif(trim(mode).EQ."fake_restore") then
+      elseif(mode.EQ.fake_restore_mode) then
       endif
       ENDDO
  200  continue
-      if(trim(mode).EQ."memory_save") then
+      if(mode.EQ.memory_save_mode) then
          WRITTEN_STRUC_SIZE=sum(SIZE_VARIABLES)+sum(SIZE_VARIABLES_ROOT)
      &        +SIZE_VARIABLES_BLR+SIZE_VARIABLES_FRONT_DATA+
      &         SIZE_VARIABLES_L0FAC
@@ -9031,8 +8373,8 @@ C
          gest_size=gest_size+int(2*id%KEEP(34)*tot_NbRecords,kind=8)
 #endif
          TOTAL_FILE_SIZE=WRITTEN_STRUC_SIZE+gest_size
-      elseif(trim(mode).EQ."save") then
-      elseif(trim(mode).EQ."restore") then
+      elseif(mode.EQ.save_mode) then
+      elseif(mode.EQ.restore_mode) then
 #if ! defined(NOSCALAPACK)
          if(id%root%gridinit_done) then
             id%root%CNTXT_BLACS = id%COMM_NODES
@@ -9042,18 +8384,131 @@ C
             id%root%DESCRIPTOR(2) = id%root%CNTXT_BLACS
          endif
 #endif
-      elseif(trim(mode).EQ."fake_restore") then
-      elseif(trim(mode).EQ."restore_ooc") then
+      elseif(mode.EQ.fake_restore_mode) then
+      elseif(mode.EQ.restore_ooc_mode) then
       endif
  100  continue
-      deallocate(VARIABLES, VARIABLES_ROOT)
       RETURN
       CONTAINS
+      SUBROUTINE MUMPS_SAVERSTR_REALARRAY(idREAL)
+      IMPLICIT NONE
+      DOUBLE PRECISION, DIMENSION(:), POINTER :: idREAL
+      NbRecords(i1)=2
+      if(mode.EQ.memory_save_mode) then
+         IF(associated(idREAL)) THEN
+            SIZE_GEST(i1)=SIZE_INT
+            SIZE_VARIABLES(i1)=size(idREAL,1)*SIZE_RL_OR_DBL
+         ELSE
+            SIZE_GEST(i1)=SIZE_INT*2
+            SIZE_VARIABLES(i1)=0_8
+         ENDIF
+      elseif(mode.EQ.save_mode) then
+         IF(associated(idREAL)) THEN
+            write(unit,iostat=err) size(idreal,1)
+            if(err.ne.0) then
+               id%INFO(1) = -72
+               CALL MUMPS_SETI8TOI4(
+     &              TOTAL_FILE_SIZE-size_written,
+     &              id%INFO(2))
+            endif
+            write(unit,iostat=err) idREAL
+         ELSE
+            write(unit,iostat=err) -999
+            if(err.ne.0) then
+               id%INFO(1) = -72
+               CALL MUMPS_SETI8TOI4(
+     &         TOTAL_FILE_SIZE-size_written,
+     &         id%INFO(2))
+            endif
+            write(unit,iostat=err) -999
+         ENDIF 
+         if(err.ne.0) then
+               id%INFO(1) = -72
+               CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
+     &         id%INFO(2))
+         endif
+         CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+         IF ( id%INFO(1) .LT. 0 ) GOTO 100
+      elseif(mode.EQ.restore_mode) then
+         nullify(idREAL)
+         read(unit,iostat=err) size_array1
+         if (err.ne.0) THEN
+           id%INFO(1) = -75
+           CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
+     &                    ,id%INFO(2))
+         endif
+         CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                 id%COMM, id%MYID )
+         IF ( id%INFO(1) .LT. 0 ) GOTO 100
+           if (size_array1.EQ.-999) then
+                     SIZE_GEST(i1)=SIZE_INT*2
+                     SIZE_VARIABLES(i1)=0_8
+                     read(unit,iostat=err) dummy
+           else
+                     SIZE_GEST(i1)=SIZE_INT
+                     SIZE_VARIABLES(i1)=size_array1*SIZE_RL_OR_DBL
+                     allocate(idREAL(size_array1), stat=allocok)
+                     if (allocok .GT. 0) THEN
+                        id%INFO(1) = -78
+                        CALL MUMPS_SETI8TOI4(
+     &                       TOTAL_STRUC_SIZE-size_allocated
+     &                       ,id%INFO(2))
+                     endif
+                     read(unit,iostat=err) idREAL
+           endif
+           CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                          id%COMM, id%MYID )
+           IF ( id%INFO(1) .LT. 0 ) GOTO 100
+           if (err.ne.0) THEN
+               id%INFO(1) = -75
+               CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
+     &                    ,id%INFO(2))
+           endif 
+           CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &                          id%COMM, id%MYID )
+           IF ( id%INFO(1) .LT. 0 ) GOTO 100
+      endif
+ 100  CONTINUE
+      RETURN
+      END SUBROUTINE MUMPS_SAVERSTR_REALARRAY
+      SUBROUTINE MUMPS_SAVE_INT(idINT)
+      IMPLICIT NONE
+      INTEGER, INTENT(INOUT) :: idINT
+      NbRecords(i1)=1
+      if(mode.EQ.memory_save_mode) then
+         SIZE_VARIABLES(i1)=SIZE_INT
+      elseif(mode.EQ.save_mode) then
+         write(unit,iostat=err) idINT
+         if(err.ne.0) then
+           id%INFO(1) = -72
+           CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_written,
+     &          id%INFO(2))
+         endif
+         CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &        id%COMM, id%MYID )
+         IF ( id%INFO(1) .LT. 0 ) GOTO 100
+      elseif(mode.EQ.restore_mode) then
+         SIZE_VARIABLES(i1)=SIZE_INT
+         read(unit,iostat=err) idINT
+         if(err.ne.0) THEN
+            id%INFO(1) = -75
+            CALL MUMPS_SETI8TOI4(TOTAL_FILE_SIZE-size_read
+     &           ,id%INFO(2))
+         endif 
+         CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &        id%COMM, id%MYID )
+         IF ( id%INFO(1) .LT. 0 ) GOTO 100
+      endif
+ 100  CONTINUE
+      RETURN
+      END SUBROUTINE MUMPS_SAVE_INT
       SUBROUTINE ZMUMPS_SAVE_INT_SHPTR_ARRAY(id_INTPTR
      &  )
+      IMPLICIT NONE
       INTEGER, POINTER, DIMENSION(:) :: id_INTPTR
             NbRecords(i1)=2
-            if(trim(mode).EQ."memory_save") then
+            if(mode.EQ.memory_save_mode) then
                IF(associated(id_INTPTR)
      &            ) THEN
                   SIZE_GEST(i1)=SIZE_INT
@@ -9062,7 +8517,7 @@ C
                   SIZE_GEST(i1)=SIZE_INT*2
                   SIZE_VARIABLES(i1)=0_8
                ENDIF
-            elseif(trim(mode).EQ."save") then
+            elseif(mode.EQ.save_mode) then
                IF(associated(id_INTPTR)
      &            ) THEN
                   write(unit,iostat=err) size(id_INTPTR,1)
@@ -9095,7 +8550,7 @@ C
                CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &              id%COMM, id%MYID )
                IF ( id%INFO(1) .LT. 0 ) GOTO 100
-            elseif(trim(mode).EQ."restore") then
+            elseif(mode.EQ.restore_mode) then
                nullify(id_INTPTR)
                read(unit,iostat=err) size_array1
                if(err.ne.0) THEN
@@ -9142,3 +8597,8 @@ C
       END SUBROUTINE ZMUMPS_SAVE_INT_SHPTR_ARRAY
       END SUBROUTINE ZMUMPS_SAVE_RESTORE_STRUCTURE
       END MODULE ZMUMPS_SAVE_RESTORE
+#else
+      SUBROUTINE ZMUMPS_SAVE_RESTORE_RETURN()
+      RETURN
+      END SUBROUTINE ZMUMPS_SAVE_RESTORE_RETURN
+#endif
diff -pruN 5.6.2-2.1/src/zmumps_save_restore_files.F 5.7.1-1/src/zmumps_save_restore_files.F
--- 5.6.2-2.1/src/zmumps_save_restore_files.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zmumps_save_restore_files.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -11,11 +11,11 @@ C  released under the CeCILL-C license
 C  (see doc/CeCILL-C_V1-en.txt, doc/CeCILL-C_V1-fr.txt, and
 C  https://cecill.info/licences/Licence_CeCILL-C_V1-en.html)
 C
+#if ! defined(NO_SAVE_RESTORE)
       MODULE ZMUMPS_SAVE_RESTORE_FILES
       USE ZMUMPS_STRUC_DEF
       IMPLICIT NONE
-      INTEGER :: LEN_SAVE_FILE
-      PARAMETER( LEN_SAVE_FILE = 550)
+      INTEGER, PARAMETER :: LEN_SAVE_FILE = 1318
       CONTAINS
       SUBROUTINE MUMPS_READ_HEADER(fileunit, ierr, size_read, SIZE_INT
      &     ,SIZE_INT8, TOTAL_FILE_SIZE, TOTAL_STRUC_SIZE
@@ -113,10 +113,6 @@ C
         size_read=size_read
      &           +int(2*SIZE_INT*1,kind=8)
 #endif
-#if defined(OOC_VERBOSE)
-        write(*,*) 'First ooc file: ',
-     &   READ_OOC_FIRST_FILE_NAME(1:READ_OOC_FILE_NAME_LENGTH-2)
-#endif
       ENDIF
  100  continue
       RETURN
@@ -237,60 +233,76 @@ C
       TYPE (ZMUMPS_STRUC),intent(inout) :: id
       CHARACTER(len=LEN_SAVE_FILE),intent(out):: SAVE_FILE, INFO_FILE
       INTEGER::len_save_dir,len_save_prefix
-      CHARACTER(len=255):: tmp_savedir,savedir
-      CHARACTER(len=255):: tmp_saveprefix,saveprefix
+      INTEGER, PARAMETER :: SAVE_PREFIX_MAX_LENGTH =  255
+      INTEGER, PARAMETER :: SAVE_DIR_MAX_LENGTH    = 1023
+      CHARACTER(len=SAVE_DIR_MAX_LENGTH)    :: tmp_save_dir
+      CHARACTER(len=SAVE_DIR_MAX_LENGTH)    :: save_dir
+      CHARACTER(len=SAVE_PREFIX_MAX_LENGTH) :: save_prefix
+      CHARACTER(len=SAVE_PREFIX_MAX_LENGTH) :: tmp_save_prefix
       CHARACTER(len=10):: STRING_MYID
       CHARACTER:: LAST_CHAR_DIR
       INFO_FILE=''
       SAVE_FILE=''
-      tmp_savedir=''
-      tmp_saveprefix=''
+      tmp_save_dir=''
+      tmp_save_prefix=''
       IF(id%SAVE_DIR.EQ."NAME_NOT_INITIALIZED") THEN
-         call mumps_get_save_dir_C(len_save_dir,tmp_savedir)
-         if(tmp_savedir(1:len_save_dir).EQ."NAME_NOT_INITIALIZED") then
-            id%INFO(1) = -77
-            id%INFO(2) = 0 
+         call MUMPS_GET_SAVE_DIR_C(len_save_dir,tmp_save_dir)
+         len_save_dir=min(SAVE_DIR_MAX_LENGTH,len_save_dir)
+         if (len_save_dir > SAVE_DIR_MAX_LENGTH) then
+           id%INFO(1) = -77
+           id%INFO(2) = SAVE_DIR_MAX_LENGTH
+         else if(tmp_save_dir(1:len_save_dir).EQ."NAME_NOT_INITIALIZED")
+     &     then
+           id%INFO(1) = -77
+           id%INFO(2) = 0 
          else
-            savedir=trim(adjustl(tmp_savedir(1:len_save_dir)))
-            len_save_dir=len_trim(savedir(1:len_save_dir))
+           save_dir=trim(adjustl(tmp_save_dir(1:len_save_dir)))
+           len_save_dir=len_trim(save_dir(1:len_save_dir))
          endif
       ELSE
-         savedir=trim(adjustl(id%SAVE_DIR))
-         len_save_dir=len_trim(savedir)
+         save_dir=trim(adjustl(id%SAVE_DIR))
+         len_save_dir=len_trim(save_dir)
       ENDIF
       CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
      &     id%COMM, id%MYID )
       IF ( id%INFO(1) .LT. 0 ) GOTO 100
       IF(id%SAVE_PREFIX.EQ."NAME_NOT_INITIALIZED") THEN
-         call mumps_get_save_prefix_C(len_save_prefix,tmp_saveprefix)
-         if(tmp_saveprefix(1:len_save_prefix).EQ."NAME_NOT_INITIALIZED")
-     &        then
-            saveprefix="save"
-            len_save_prefix=len_trim(saveprefix)
-         else
-            saveprefix=
-     &           trim(adjustl(tmp_saveprefix(1:len_save_prefix)))
-            len_save_prefix=len_trim(saveprefix(1:len_save_prefix))
-         endif
+        call MUMPS_GET_SAVE_PREFIX_C(len_save_prefix,tmp_save_prefix)
+        len_save_prefix=min(SAVE_PREFIX_MAX_LENGTH,len_save_prefix)
+        if(len_save_prefix.GT.SAVE_PREFIX_MAX_LENGTH) then
+          id%INFO(1)=-77
+          id%INFO(2)=-SAVE_PREFIX_MAX_LENGTH
+        else if(tmp_save_prefix(1:len_save_prefix).EQ.
+     &  "NAME_NOT_INITIALIZED") then
+           save_prefix="save"
+           len_save_prefix=len_trim(save_prefix)
+        else
+           save_prefix=
+     &          trim(adjustl(tmp_save_prefix(1:len_save_prefix)))
+           len_save_prefix=len_trim(save_prefix(1:len_save_prefix))
+        endif
       ELSE
-         saveprefix=trim(adjustl(id%SAVE_PREFIX))
-         len_save_prefix=len_trim(saveprefix)
+        save_prefix=trim(adjustl(id%SAVE_PREFIX))
+        len_save_prefix=len_trim(save_prefix)
       ENDIF
+      CALL MUMPS_PROPINFO( id%ICNTL(1), id%INFO(1),
+     &     id%COMM, id%MYID )
+      IF ( id%INFO(1) .LT. 0 ) GOTO 100
       write(STRING_MYID,'(I10)') id%MYID
-      LAST_CHAR_DIR=savedir(len_save_dir:len_save_dir)
+      LAST_CHAR_DIR=save_dir(len_save_dir:len_save_dir)
       if(LAST_CHAR_DIR.NE."/") then
-         SAVE_FILE=trim(adjustl(savedir))//"/"
+         SAVE_FILE=trim(adjustl(save_dir))//"/"
       else
-         SAVE_FILE=trim(adjustl(savedir))
+         SAVE_FILE=trim(adjustl(save_dir))
       endif
       INFO_FILE=trim(adjustl(SAVE_FILE))
       SAVE_FILE=trim(adjustl(SAVE_FILE))
-     &     //trim(adjustl(saveprefix))
+     &     //trim(adjustl(save_prefix))
      &     //"_"
      &     //trim(adjustl(STRING_MYID))
      &     //".mumps"
       INFO_FILE=trim(adjustl(INFO_FILE))
-     &        //trim(adjustl(saveprefix))
+     &        //trim(adjustl(save_prefix))
      &        //"_"
      &        //trim(adjustl(STRING_MYID))
      &        //".info"
@@ -323,3 +335,8 @@ C
       ENDIF
       END SUBROUTINE ZMUMPS_CHECK_FILE_NAME      
       END MODULE ZMUMPS_SAVE_RESTORE_FILES
+#else
+      SUBROUTINE ZMUMPS_SAVE_FILES_RETURN()
+      RETURN
+      END SUBROUTINE ZMUMPS_SAVE_FILES_RETURN
+#endif
diff -pruN 5.6.2-2.1/src/zmumps_sol_es.F 5.7.1-1/src/zmumps_sol_es.F
--- 5.6.2-2.1/src/zmumps_sol_es.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zmumps_sol_es.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -13,16 +13,24 @@ C  https://cecill.info/licences/Licence_
 C
       MODULE ZMUMPS_SOL_ES
       PRIVATE
-      PUBLIC:: PRUNED_SIZE_LOADED
       PUBLIC:: ZMUMPS_CHAIN_PRUN_NODES
       PUBLIC:: ZMUMPS_CHAIN_PRUN_NODES_STATS
       PUBLIC:: ZMUMPS_INITIALIZE_RHS_BOUNDS
       PUBLIC:: ZMUMPS_PROPAGATE_RHS_BOUNDS
       PUBLIC:: ZMUMPS_TREE_PRUN_NODES
-      PUBLIC:: ZMUMPS_TREE_PRUN_NODES_STATS
       PUBLIC:: ZMUMPS_SOL_ES_INIT
+#     if defined(STAT_ES_SOLVE)
+      PUBLIC:: ZMUMPS_SOL_ES_PRINT_STATS
+#     endif
+      PUBLIC:: ZMUMPS_ES_GET_SUM_Nloc
+      PUBLIC:: ZMUMPS_ES_NODES_SIZE_AND_FILL
       INTEGER(8), POINTER, DIMENSION(:,:) :: SIZE_OF_BLOCK
-      INTEGER(8) :: PRUNED_SIZE_LOADED
+#     if defined(STAT_ES_SOLVE)
+      DOUBLE PRECISION :: nb_flops,
+     &                    nb_sparse_flops,
+     &                    total_efficiency
+      INTEGER :: total_procs, total_blocks
+#endif
       INCLUDE 'mumps_headers.h'
       CONTAINS
       SUBROUTINE ZMUMPS_SOL_ES_INIT(SIZE_OF_BLOCK_ARG, KEEP201)
@@ -34,6 +42,13 @@ C
       ELSE
         NULLIFY(SIZE_OF_BLOCK)
       ENDIF
+#if defined(STAT_ES_SOLVE)
+      nb_flops=0.0d0
+      nb_sparse_flops=0.0d0
+      total_efficiency=0.0d0
+      total_procs=0
+      total_blocks=0
+#endif
       RETURN
       END SUBROUTINE ZMUMPS_SOL_ES_INIT
       SUBROUTINE ZMUMPS_TREE_PRUN_NODES( 
@@ -50,7 +65,7 @@ C
       INTEGER, INTENT(IN) :: N, KEEP28
       INTEGER, INTENT(IN) :: DAD(KEEP28),NE_STEPS(KEEP28),FRERE(KEEP28)
       INTEGER, INTENT(IN) :: FILS(N), STEP(N)
-      INTEGER, INTENT(IN) :: nodes_RHS(KEEP28),  nb_nodes_RHS
+      INTEGER, INTENT(IN) :: nodes_RHS(:),  nb_nodes_RHS
       INTEGER :: nb_prun_nodes
       INTEGER, OPTIONAL, INTENT(INOUT):: Pruned_List(nb_prun_nodes)
       INTEGER :: nb_prun_roots
@@ -143,15 +158,15 @@ C
       INTEGER, INTENT(IN) :: KEEP28
       INTEGER, INTENT(IN) :: DAD(KEEP28)
       INTEGER, INTENT(IN) :: nb_nodes_RHS
-      INTEGER, INTENT(IN) :: nodes_RHS(nb_nodes_RHS)
-      INTEGER :: nb_prun_nodes
+      INTEGER, INTENT(IN) :: nodes_RHS(max(nb_nodes_RHS,1))
+      INTEGER, INTENT(INOUT) :: nb_prun_nodes
       INTEGER, OPTIONAL, INTENT(INOUT):: Pruned_List(nb_prun_nodes)
-      INTEGER :: nb_prun_roots
+      INTEGER, INTENT(INOUT) :: nb_prun_roots
       INTEGER, OPTIONAL, INTENT(INOUT):: Pruned_Roots(nb_prun_roots)
-      INTEGER :: nb_prun_leaves
+      INTEGER, INTENT(INOUT) :: nb_prun_leaves
       INTEGER, OPTIONAL, INTENT(INOUT):: Pruned_Leaves(nb_prun_leaves)
-      INTEGER :: Pruned_SONS(KEEP28)
-      LOGICAL :: TO_PROCESS(KEEP28)
+      INTEGER, INTENT(OUT) :: Pruned_SONS(KEEP28)
+      LOGICAL, INTENT(OUT) :: TO_PROCESS(KEEP28)
       INTEGER :: IN, I, ISTEP, TMP
       nb_prun_nodes = 0
       nb_prun_roots = 0
@@ -265,6 +280,10 @@ C
      & STEP, N, Pruned_SONS,
      & DAD, RHS_BOUNDS, NSTEPS,
      & MYID, COMM, KEEP485,
+#if defined(STAT_ES_SOLVE)
+     & KEEP46,
+     & IPTR_WORKING, SIZE_IPTR_WORKING, WORKING, SIZE_WORKING,
+#endif
      & IW, LIW, PTRIST, KIXSZ,OOC_FCT_LOC, PHASE, LDLT, K38)
       IMPLICIT NONE
       INCLUDE 'mpif.h'
@@ -275,10 +294,26 @@ C
       INTEGER, INTENT(IN) :: pruned_leaves(nb_pruned_leaves)
       INTEGER, INTENT(IN) :: LIW, IW(LIW), PTRIST(NSTEPS)
       INTEGER, INTENT(IN) :: KIXSZ, OOC_FCT_LOC, PHASE, LDLT, K38
+#     if defined(STAT_ES_SOLVE)
+      INTEGER, INTENT(IN) :: KEEP46 
+      INTEGER, INTENT(IN) :: SIZE_IPTR_WORKING, SIZE_WORKING, 
+     &                       IPTR_WORKING(SIZE_IPTR_WORKING),
+     &                       WORKING(SIZE_WORKING)
+#endif
       INTEGER, INTENT(INOUT):: RHS_BOUNDS(2*NSTEPS)
       INTEGER :: I, node, father, size_pool, next_size_pool
       INTEGER :: IERR
       INTEGER, ALLOCATABLE, DIMENSION(:) :: POOL, NBSONS
+#if defined(STAT_ES_SOLVE)
+      LOGICAL, ALLOCATABLE, DIMENSION(:) :: isleaf
+      INTEGER :: J, NPROCS, proc, allocok
+      LOGICAL :: found
+      DOUBLE PRECISION :: avg_load, efficiency, max_load, effmax
+      DOUBLE PRECISION, ALLOCATABLE, DIMENSION(:) :: proc_flops_buf
+      DOUBLE PRECISION :: proc_block_flops, block_flops
+      INTEGER :: SK38  
+      INTEGER, PARAMETER :: MASTER  = 0
+#endif
       ALLOCATE(POOL(nb_pruned_leaves),
      &         NBSONS(NSTEPS),
      &         STAT=IERR)
@@ -289,6 +324,37 @@ C
       size_pool = nb_pruned_leaves
       POOL = pruned_leaves
       NBSONS = Pruned_SONS
+#     if defined(STAT_ES_SOLVE)
+      NPROCS = SIZE_IPTR_WORKING-1
+      IF((MYID.EQ.MASTER).AND.(KEEP46.EQ.1)) THEN
+        ALLOCATE(isleaf(NSTEPS), STAT=IERR)
+        IF (IERR.NE.0) THEN
+          WRITE(6,*)'Allocation problem in ZMUMPS_PROPAGATE_RHS_BOUNDS'
+          CALL MUMPS_ABORT()
+        END IF
+        isleaf = .FALSE.
+        DO I=1,nb_pruned_leaves
+          isleaf(abs(STEP(pruned_leaves(I)))) = .true.
+        END DO
+        proc = 0
+        DO I=1,NPROCS
+          found = .FALSE.
+          J = IPTR_WORKING(I)
+          DO WHILE((J.LE.IPTR_WORKING(I+1)-1).AND.(.NOT.found))
+            IF (isleaf(WORKING(J)))THEN
+              found = .TRUE.            
+            END IF
+            J = J + 1
+          END DO
+          IF(found) THEN
+            proc = proc + 1
+          END IF
+        END DO
+        total_procs = total_procs + proc
+        total_blocks = total_blocks + 1
+        DEALLOCATE(isleaf)
+      END IF
+#     endif
       DO WHILE (size_pool.ne.0)
         next_size_pool =0 
         DO I=1, size_pool 
@@ -314,6 +380,76 @@ C
         size_pool = next_size_pool 
       END DO
       DEALLOCATE(POOL, NBSONS)
+#     if defined(STAT_ES_SOLVE)
+      IF (KEEP46.EQ.1) THEN
+       IF(MYID.EQ.MASTER) THEN
+        block_flops = 0D0
+       END IF
+       proc_block_flops = 0D0
+       IF (K38 .GT. 0) THEN
+        SK38 = STEP(K38)
+       ELSE
+        SK38 = 0
+       END IF
+       DO I=1,NSTEPS
+        IF (RHS_BOUNDS(2*I).NE.0) THEN 
+          IF(PTRIST(I).GT.0) THEN
+            proc_block_flops = proc_block_flops
+     &           + dble(2*(RHS_BOUNDS(2*I) - RHS_BOUNDS(2*I-1) +1))
+     &           * dble(ZMUMPS_LOCAL_FACTOR_SIZE(IW, LIW,
+     &             PTRIST(I)+KIXSZ, 
+     &             PHASE,LDLT,I.EQ.SK38))
+          END IF
+        END IF
+       END DO
+       IF(MYID.EQ.MASTER) THEN
+          ALLOCATE(proc_flops_buf(SIZE_IPTR_WORKING-1),stat=allocok)
+          IF(allocok.GT.0) THEN
+             WRITE(6,*)'Allocation problem of proc_flops_buf'
+     &            ,' in ZMUMPS_PROPAGATE_RHS_BOUNDS'
+             CALL MUMPS_ABORT()
+          ENDIF
+          proc_flops_buf=0.0d0
+       ELSE 
+          ALLOCATE(proc_flops_buf(1),stat=allocok)
+          IF(allocok.GT.0) THEN
+             WRITE(6,*)'Allocation problem of proc_flops_buf'
+     &            ,' in ZMUMPS_PROPAGATE_RHS_BOUNDS'
+             CALL MUMPS_ABORT()
+          ENDIF
+          proc_flops_buf=0.0d0
+       END IF
+       CALL MPI_GATHER(proc_block_flops, 1, MPI_DOUBLE_PRECISION,
+     &       proc_flops_buf, 1, MPI_DOUBLE_PRECISION,
+     &       0, COMM, IERR)
+       CALL MPI_REDUCE(proc_block_flops, block_flops, 1,
+     &  MPI_DOUBLE_PRECISION, MPI_SUM, 0, COMM, IERR)  
+       IF(MYID.EQ.MASTER) THEN                         
+        nb_sparse_flops = nb_sparse_flops+block_flops
+        avg_load = sum(proc_flops_buf)/dble(NPROCS)
+        max_load = maxval(proc_flops_buf)
+        efficiency = 0D0
+        effmax = 0D0
+        DO I=1,NPROCS
+          efficiency= efficiency + (proc_flops_buf(I)-avg_load)**2
+          IF (proc_flops_buf(I)-avg_load.GT.0.0D0) THEN
+            effmax = effmax + (max_load-avg_load)**2
+          ELSE IF (proc_flops_buf(I)-avg_load.LT.0.0D0) THEN
+            effmax = effmax + avg_load**2
+          END IF
+        END DO
+        efficiency = sqrt(efficiency/dble(NPROCS))
+        effmax = sqrt(effmax/dble(NPROCS))
+        IF(effmax.ne.0.0d0) efficiency = efficiency / effmax
+        efficiency = 1.0d0 - efficiency
+        efficiency = efficiency * block_flops 
+        total_efficiency = total_efficiency + efficiency
+        DEALLOCATE(proc_flops_buf)
+       ELSE
+        DEALLOCATE(proc_flops_buf)
+       END IF
+      END IF
+#endif
       RETURN
       END SUBROUTINE ZMUMPS_PROPAGATE_RHS_BOUNDS
       INTEGER(8) FUNCTION ZMUMPS_LOCAL_FACTOR_SIZE(IW,LIW,PTR,
@@ -340,7 +476,7 @@ C
      &            NPIV*(NPIV-1_8)/2_8 + (NROW-NPIV)*NPIV
           ELSE
             ZMUMPS_LOCAL_FACTOR_SIZE =
-     &      NPIV*(NPIV+1_8)/2_8 + (LIELL-NPIV)*NPIV
+     &      NPIV*(NPIV-1_8)/2_8 + (LIELL-NPIV)*NPIV
           ENDIF
         ELSE
           ZMUMPS_LOCAL_FACTOR_SIZE =
@@ -348,90 +484,13 @@ C
         END IF
       RETURN
       END FUNCTION ZMUMPS_LOCAL_FACTOR_SIZE
-      INTEGER(8) FUNCTION ZMUMPS_LOCAL_FACTOR_SIZE_BLR(IW,LIW,PTR,
-     &                                LRSTATUS, IWHANDLER,
-     &                                PHASE, LDLT, IS_ROOT)
-      USE ZMUMPS_LR_DATA_M
-      USE ZMUMPS_LR_TYPE
-        INTEGER, INTENT(IN) :: LIW, PTR, PHASE, LDLT
-        INTEGER, INTENT(IN) :: LRSTATUS, IWHANDLER
-        INTEGER, INTENT(IN) :: IW(LIW)
-        LOGICAL, INTENT(IN) :: IS_ROOT
-        INTEGER(8) :: NPIV, NROW, FACTOR_SIZE
-        INTEGER :: NB_PANELS, IPANEL, LorU, IBLOCK
-        LOGICAL :: LR_ACTIVATED
-        TYPE(LRB_TYPE), POINTER, DIMENSION(:) :: LRB_PANEL
-        NROW  = int(IW(PTR+2),8)
-        NPIV  = int(IW(PTR+3),8)
-        LR_ACTIVATED=(LRSTATUS.GE.2)
-        IF (LR_ACTIVATED) THEN
-          FACTOR_SIZE = 0_8
-          CALL ZMUMPS_BLR_RETRIEVE_NB_PANELS(IWHANDLER, NB_PANELS)
-          IF (LDLT.EQ.0) THEN 
-            LorU = PHASE
-          ELSE
-            LorU = 0
-          ENDIF
-          DO IPANEL=1,NB_PANELS
-            IF (IS_ROOT.AND.IPANEL.EQ.NB_PANELS) THEN
-              CYCLE
-            ENDIF
-            IF (ZMUMPS_BLR_EMPTY_PANEL_LORU(IWHANDLER, LorU, IPANEL))
-     &        THEN
-              CYCLE
-            ENDIF
-             CALL ZMUMPS_BLR_RETRIEVE_PANEL_LORU(IWHANDLER, LorU,
-     &                       IPANEL, LRB_PANEL)
-            IF (size(LRB_PANEL).GT.0) THEN
-              IF (PHASE.EQ.0) THEN
-                FACTOR_SIZE = FACTOR_SIZE + 
-     &            int(LRB_PANEL(1)%N,8)*(int(LRB_PANEL(1)%N,8)-1_8)/2_8
-              ELSE
-                FACTOR_SIZE = FACTOR_SIZE + 
-     &           int(LRB_PANEL(1)%N,8)*(int(LRB_PANEL(1)%N,8)+1_8)/2_8
-              ENDIF
-            ENDIF
-            DO IBLOCK=1,size(LRB_PANEL)
-              IF (LRB_PANEL(IBLOCK)%ISLR) THEN
-                FACTOR_SIZE = FACTOR_SIZE + int(LRB_PANEL(IBLOCK)%K,8)*
-     &            int(LRB_PANEL(IBLOCK)%M+LRB_PANEL(IBLOCK)%M,8)
-              ELSE
-                FACTOR_SIZE = FACTOR_SIZE +
-     &             int(LRB_PANEL(IBLOCK)%M*LRB_PANEL(IBLOCK)%N,8)
-              ENDIF
-            ENDDO
-          ENDDO
-          ZMUMPS_LOCAL_FACTOR_SIZE_BLR = FACTOR_SIZE
-        ELSE
-          ZMUMPS_LOCAL_FACTOR_SIZE_BLR = 
-     &      ZMUMPS_LOCAL_FACTOR_SIZE(IW, LIW, PTR, PHASE, LDLT, IS_ROOT)
-        ENDIF
-      RETURN
-      END FUNCTION ZMUMPS_LOCAL_FACTOR_SIZE_BLR
-      SUBROUTINE ZMUMPS_TREE_PRUN_NODES_STATS(MYID, N, KEEP28, KEEP201,
-     &           FR_FACT,
-     &           STEP, Pruned_List, nb_prun_nodes, OOC_FCT_TYPE_LOC)
-      INTEGER, intent(in) :: KEEP28, KEEP201, OOC_FCT_TYPE_LOC, MYID, N
-      INTEGER(8), intent(in) :: FR_FACT
-      INTEGER, intent(in) :: nb_prun_nodes
-      INTEGER, intent(in) :: Pruned_List(nb_prun_nodes)
-      INTEGER, intent(in) :: STEP(N)
-      INTEGER I, ISTEP
-      INTEGER(8) :: Pruned_Size
-      IF (KEEP201 .GT. 0) THEN
-        Pruned_Size = 0_8
-        DO I = 1, nb_prun_nodes
-          ISTEP = STEP(Pruned_List(I))
-          Pruned_Size = Pruned_Size + SIZE_OF_BLOCK
-     &                  (ISTEP, OOC_FCT_TYPE_LOC)
-        ENDDO
-        PRUNED_SIZE_LOADED = PRUNED_SIZE_LOADED +Pruned_Size
-      ENDIF
-      RETURN
-      END SUBROUTINE ZMUMPS_TREE_PRUN_NODES_STATS
       SUBROUTINE ZMUMPS_CHAIN_PRUN_NODES_STATS
      &                (MYID, N, KEEP28, KEEP201, KEEP485, FR_FACT,
      &                STEP, Pruned_List, nb_prun_nodes, OOC_FCT_TYPE_LOC
+#     if defined(STAT_ES_SOLVE)
+     &                , NRHS, COMM, IW, LIW, PTRIST, KIXSZ, PHASE,
+     &                  LDLT, K38
+#endif     
      & )
       IMPLICIT NONE
       INTEGER, intent(in) :: KEEP28, KEEP201, OOC_FCT_TYPE_LOC, N,
@@ -440,24 +499,203 @@ C
       INTEGER, intent(in) :: nb_prun_nodes, MYID
       INTEGER, intent(in) :: Pruned_List(nb_prun_nodes)
       INTEGER, intent(in) :: STEP(N)
+#if defined(STAT_ES_SOLVE)
+      INTEGER, INTENT(IN):: LIW, COMM, NRHS, LDLT, K38
+      INTEGER, INTENT(IN):: IW(LIW), PTRIST(KEEP28), KIXSZ, PHASE  
+      DOUBLE PRECISION :: proc_block_flops, block_flops
+      INTEGER(8) :: Pruned_Size_ic 
+      INTEGER :: IERR
+      INTEGER :: SK38 
+#endif
       INCLUDE 'mpif.h'
       INTEGER I, ISTEP
       INTEGER(8) :: Pruned_Size
+#if defined(STAT_ES_SOLVE)
+      Pruned_Size_ic = 0_8
+#endif
       Pruned_Size = 0_8
+#if defined(STAT_ES_SOLVE)
+      IF (K38 .GT. 0) THEN
+        SK38 = STEP(K38)
+      ELSE
+        SK38 = 0
+      END IF
+#endif
       DO I = 1, nb_prun_nodes
         ISTEP = STEP(Pruned_List(I))
         IF (KEEP201 .GT. 0) THEN
             Pruned_Size = Pruned_Size + SIZE_OF_BLOCK
      &                    (ISTEP, OOC_FCT_TYPE_LOC)
         ENDIF
+#if       defined(STAT_ES_SOLVE)
+          IF (PTRIST(ISTEP) .GT. 0) THEN
+            Pruned_Size_ic = Pruned_Size_ic + 
+     &               ZMUMPS_LOCAL_FACTOR_SIZE(IW, LIW,
+     &               PTRIST(ISTEP)+KIXSZ, 
+     &               PHASE, LDLT,
+     &               ISTEP.EQ.SK38)
+          ENDIF
+#         endif
       ENDDO
-      IF (KEEP201.GT.0) THEN
-        IF (FR_FACT .NE. 0_8) THEN
-          PRUNED_SIZE_LOADED = PRUNED_SIZE_LOADED +Pruned_Size
-        ENDIF
-      ENDIF
+#if defined(STAT_ES_SOLVE)
+      proc_block_flops = dble(2_8*Pruned_Size_ic)*dble(NRHS)
+      CALL MPI_REDUCE(proc_block_flops, block_flops, 1,
+     & MPI_DOUBLE_PRECISION, MPI_SUM, 0, COMM, IERR)
+      IF(MYID.EQ.0) nb_flops = nb_flops + block_flops
+#endif
       RETURN
       END SUBROUTINE ZMUMPS_CHAIN_PRUN_NODES_STATS
+#if   defined(STAT_ES_SOLVE)
+      SUBROUTINE ZMUMPS_SOL_ES_PRINT_STATS(
+     &                  K212, K235, K237, K485, K497, NZLU8,
+     &                  NRHS, ICNTL27, N, K50, DKEEPS, RINFOGS, MPG)
+      IMPLICIT NONE
+      INTEGER, intent(in)    ::  K212, K235, K237, K485, K497, 
+     &                           NRHS, MPG, ICNTL27, N, K50
+      INTEGER(8), intent(in) :: NZLU8
+      DOUBLE PRECISION, intent(out)    :: DKEEPS(5), RINFOGS(5)
+      LOGICAL              :: AM1, ES_FWD, ES_BWD, DO_NBSPARSE
+      IF (MPG.LE.0) RETURN
+      AM1         = (K237 .NE. 0)
+      ES_FWD      = (K235 .NE. 0) .AND. (.NOT. AM1)
+      ES_BWD      = (K212 .NE. 0) .AND. (.NOT. AM1)
+      DO_NBSPARSE = (K497.NE.0).AND.(NRHS.GT.1).AND.(ICNTL27.GT.1)
+      IF (AM1) 
+     & WRITE(MPG,'(/A)') ' ** FLOPS SUMMARY during SOLVE AM1 ** '
+      IF ((ES_FWD).AND. (.NOT.ES_BWD)) 
+     & WRITE(MPG,'(/A,A)') ' ** FLOPS SUMMARY during fwd step',
+     &                  ' (exploit RHS sparsity) ** '
+      IF ((.NOT.ES_FWD).AND. (ES_BWD))
+     & WRITE(MPG,'(/A,A)') ' ** FLOPS SUMMARY during bwd step',
+     &                  ' (selected entries in solution) ** '
+      IF ((ES_FWD).AND. (ES_BWD)) 
+     & WRITE(MPG,'(/A,/A)') 
+     & ' ** FLOPS SUMMARY during SOLVE (fwd+bwd steps)',
+     & '    (sparse RHS and selected entries in solution) **'
+      IF (
+     &     (ES_FWD) .AND. (.NOT.ES_BWD)
+     &    .OR.
+     &     (.NOT.ES_FWD) .AND. (ES_BWD)
+     &   ) THEN
+       IF (K50.NE.0) THEN
+         DKEEPS(1)=(dble(NZLU8)-dble(N))*dble(2*NRHS)
+       ELSE
+         DKEEPS(1)=(dble(NZLU8)-dble(N))*dble(NRHS)
+       ENDIF
+      ELSE IF ((ES_FWD).AND.(ES_BWD)) THEN
+       IF (K50.NE.0) THEN
+         DKEEPS(1) = (dble(NZLU8)-dble(N))*dble(4*NRHS)
+       ELSE
+         DKEEPS(1)=(dble(NZLU8)-dble(N))*dble(2*NRHS)
+       ENDIF
+      ENDIF
+      RINFOGS(1) = DKEEPS(1)
+      IF (.NOT.AM1) THEN
+       WRITE(MPG,'(A,F25.1)') 
+     & ' RINFOG(24) FLOPS with dense full rank format  =', DKEEPS(1)
+      ENDIF
+      DKEEPS(2)=dble(nb_flops) 
+      IF (DO_NBSPARSE) DKEEPS(4)=dble(nb_sparse_flops)
+      IF (DO_NBSPARSE) THEN
+       RINFOGS(2)= DKEEPS(4)
+      ELSE
+       RINFOGS(2)= DKEEPS(2)
+      ENDIF
+      WRITE(MPG,'(A,F25.1)') 
+     & ' RINFOG(25) FLOPS with exploit sparsity (ES)   =', RINFOGS(2)
+      RETURN
+      END SUBROUTINE ZMUMPS_SOL_ES_PRINT_STATS
+#endif
+      SUBROUTINE ZMUMPS_ES_GET_SUM_Nloc (
+     &           N, Nloc_ITAB, ITAB_loc, COMM,
+     &           SUM_idNloc_8 )
+      IMPLICIT NONE
+      INTEGER, INTENT(IN)  :: N
+#if defined(MUMPS_NOF2003)
+        INTEGER, POINTER :: ITAB_loc (:)
+#else
+        INTEGER, INTENT( IN ), POINTER :: ITAB_loc (:)
+#endif
+      INTEGER, INTENT(IN)  :: Nloc_ITAB
+      INTEGER, INTENT(IN)  :: COMM
+      INTEGER(8)   :: SUM_idNloc_8
+      INCLUDE 'mpif.h'
+      INTEGER I, II, IERR_MPI 
+      INTEGER(8) :: idNloc_8
+      idNloc_8 = 0_8
+      DO I= 1, Nloc_ITAB
+          II = ITAB_loc(I)
+          IF (II.GE.1 .and. II.LE.N) 
+     &    idNloc_8 = idNloc_8 + 1_8
+      ENDDO
+      CALL MPI_ALLREDUCE (idNloc_8, SUM_idNloc_8, 1, 
+     &                  MPI_INTEGER8,
+     &                  MPI_SUM, COMM, IERR_MPI )
+      RETURN
+      END SUBROUTINE ZMUMPS_ES_GET_SUM_Nloc
+      SUBROUTINE ZMUMPS_ES_NODES_SIZE_AND_FILL (
+     &           fill, 
+     &           N, NSTEPS, KEEP, STEP, Step2node,
+     &           ITAB_loc, Nloc_ITAB, 
+     &           MYID, COMM,
+     &           Pruned_Sons, Lnodes_ITAB
+#if defined(AVOID_MPI_IN_PLACE)
+     &           , TMP_INT_ARRAY
+#endif
+     &           , nodes_ITAB
+     &           )
+      IMPLICIT NONE
+      LOGICAL, INTENT(IN)  :: fill
+      INTEGER, INTENT(IN)  :: N, NSTEPS, KEEP(500) 
+      INTEGER, INTENT(IN)  :: Nloc_ITAB
+      INTEGER, INTENT(IN)  :: STEP(N), Step2node(NSTEPS), 
+     &                        ITAB_loc(max(1,Nloc_ITAB))
+      INTEGER, INTENT(IN)  :: MYID, COMM
+#if defined(AVOID_MPI_IN_PLACE)
+      INTEGER              :: TMP_INT_ARRAY(NSTEPS) 
+#endif
+      INTEGER, INTENT(INOUT) :: Pruned_Sons(NSTEPS), Lnodes_ITAB
+      INTEGER, OPTIONAL, INTENT(OUT) :: nodes_ITAB(max(1,Lnodes_ITAB))
+      INCLUDE 'mpif.h'
+      INTEGER I, II, ISTEP, IERR_MPI, Lnodes_ITAB_loc, INODE_PRINC
+      IF (.NOT.fill) THEN
+        Pruned_SONS = 0
+        DO I= 1, Nloc_ITAB
+          II = ITAB_loc(I)
+          IF (II.GE.1 .and. II.LE.N) THEN
+            ISTEP = abs(STEP(II))
+            IF ( Pruned_SONS(ISTEP) .eq. 0 ) THEN
+              Pruned_SONS(ISTEP) = 1
+            ENDIF
+           ENDIF
+        ENDDO
+#if defined(AVOID_MPI_IN_PLACE)
+        TMP_INT_ARRAY = Pruned_Sons
+#endif
+        CALL MPI_ALLREDUCE(
+#if defined(AVOID_MPI_IN_PLACE)
+     &         TMP_INT_ARRAY, 
+#else
+     &         MPI_IN_PLACE,
+#endif
+     &         Pruned_Sons, NSTEPS, 
+     &         MPI_INTEGER, MPI_SUM, COMM, IERR_MPI)
+        Lnodes_ITAB = 0
+        DO ISTEP=1,NSTEPS
+          if (Pruned_SONS(ISTEP) .NE.0) Lnodes_ITAB=Lnodes_ITAB+1
+        ENDDO
+      ELSE IF (Lnodes_ITAB.GT.0) THEN
+        Lnodes_ITAB_loc = 0
+        DO ISTEP=1,NSTEPS
+          if (Pruned_SONS(ISTEP) .GT. 0) then
+            Lnodes_ITAB_loc=Lnodes_ITAB_loc+1
+            INODE_PRINC = Step2node( ISTEP )
+            nodes_ITAB(Lnodes_ITAB_loc)  = INODE_PRINC
+          endif
+        ENDDO
+      ENDIF
+      RETURN
+      END SUBROUTINE ZMUMPS_ES_NODES_SIZE_AND_FILL
       END MODULE ZMUMPS_SOL_ES
       SUBROUTINE ZMUMPS_PERMUTE_RHS_GS
      &          (LP, LPOK, PROKG, MPG, PERM_STRAT, 
diff -pruN 5.6.2-2.1/src/zmumps_struc_def.F 5.7.1-1/src/zmumps_struc_def.F
--- 5.6.2-2.1/src/zmumps_struc_def.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zmumps_struc_def.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/zomp_tps_m.F 5.7.1-1/src/zomp_tps_m.F
--- 5.6.2-2.1/src/zomp_tps_m.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zomp_tps_m.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/zooc_panel_piv.F 5.7.1-1/src/zooc_panel_piv.F
--- 5.6.2-2.1/src/zooc_panel_piv.F	2023-10-11 09:37:10.000000000 +0000
+++ 5.7.1-1/src/zooc_panel_piv.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/zrank_revealing.F 5.7.1-1/src/zrank_revealing.F
--- 5.6.2-2.1/src/zrank_revealing.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zrank_revealing.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -15,6 +15,25 @@ C
       IMPLICIT NONE
           INTEGER N, KEEP(500), ICNTL(60), MPG
           KEEP(19)=0
+          KEEP(19)=ICNTL(56)
+          IF ((KEEP(19).LT.1).OR.(KEEP(19).GE.2)) KEEP(19)=0
+          IF ( KEEP(53) .LE. 0 .and.
+     &         KEEP(19) .NE. 0 ) THEN
+             KEEP(19) = 0
+             IF ( MPG .GT. 0 ) THEN
+      WRITE( MPG,'(A)') '** Warning:  ICNTL(56) null space option'
+      WRITE( MPG,'(A)') '** disabled (incompatibility with analysis)'
+             END IF
+          END IF
+          KEEP(21) = min(ICNTL(57),N)
+          KEEP(22) = max(ICNTL(55),0)
+          IF ( KEEP(19) .ne. 0 .and. KEEP(60) .ne. 0 ) THEN
+             IF ( MPG .GT. 0 ) THEN
+      WRITE( MPG,'(A)') '** Warning: ICNTL(56)  null space option'
+      WRITE( MPG,'(A)') '** disabled (incompatibility with Schur)'
+             END IF
+            KEEP(19) = 0
+          END IF
           RETURN
       END SUBROUTINE ZMUMPS_GET_NS_OPTIONS_FACTO
       SUBROUTINE ZMUMPS_GET_NS_OPTIONS_SOLVE(ICNTL, KEEP, 
@@ -144,3 +163,522 @@ C
       ENDIF
       RETURN
       END SUBROUTINE ZMUMPS_RR_FREE_POINTERS
+      SUBROUTINE ZMUMPS_SEQ_SYMMETRIZE(N,A)
+      INTEGER N
+      COMPLEX(kind=8) A( N, N )
+      INTEGER I,J
+      DO I = 2, N
+        DO J = 1, I - 1
+          A( I, J ) = A( J, I )
+        END DO
+      END DO
+      RETURN
+      END SUBROUTINE ZMUMPS_SEQ_SYMMETRIZE
+      SUBROUTINE ZMUMPS_UXVSBP(N,PERM,X,RN01)
+      INTEGER N,PERM(N),I
+      COMPLEX(kind=8) RN01(N),X(N)
+      DO I=1,N
+        RN01(PERM(I))=X(I)
+      ENDDO
+      DO I=1,N
+        X(I)=RN01(I)
+      ENDDO
+      RETURN
+      END SUBROUTINE ZMUMPS_UXVSBP
+      SUBROUTINE ZMUMPS_UXVSFP(N,PERM,X,RN01)
+      INTEGER N,PERM(N),I
+      COMPLEX(kind=8) RN01(N),X(N)
+      DO I=1,N
+        RN01(I)=X(PERM(I))
+      ENDDO
+      DO I=1,N
+        X(I)=RN01(I)
+      ENDDO
+      RETURN
+      END SUBROUTINE ZMUMPS_UXVSFP
+      SUBROUTINE ZMUMPS_SVD_QR_ESTIM_WK( PHASE, MBLOCK, NBLOCK, 
+     &           SIZE_ROOT_ARG,
+     &           LOCAL_M, LOCAL_N, ROOT_OWNER, KEEP,KEEP8,
+     &           LIWK_RR, LWK_RR )
+      IMPLICIT NONE
+      INTEGER, INTENT(IN) :: PHASE, SIZE_ROOT_ARG
+      INTEGER, INTENT(IN) :: MBLOCK, NBLOCK, LOCAL_M, LOCAL_N
+      LOGICAL, INTENT(IN) :: ROOT_OWNER
+      INTEGER, INTENT(IN) :: KEEP(500)
+      INTEGER(8), INTENT(IN) :: KEEP8(150)
+      INTEGER, INTENT(OUT):: LIWK_RR
+      INTEGER(8), INTENT(OUT):: LWK_RR
+      INTEGER SIZE_ROOT
+      INTEGER NBPOSPONED_ESTIM
+      PARAMETER (NBPOSPONED_ESTIM=2000)
+      INTEGER SVD_QR,PAR_ROOT
+      SVD_QR = KEEP(19)
+      PAR_ROOT = KEEP(38)
+      LIWK_RR = 0
+      LWK_RR = 0_8
+      IF (PAR_ROOT.EQ.0) THEN
+         IF(ROOT_OWNER) THEN
+           IF (PHASE.EQ.0) THEN
+                  SIZE_ROOT=SIZE_ROOT_ARG+NBPOSPONED_ESTIM
+           ELSE
+                  SIZE_ROOT=SIZE_ROOT_ARG
+           ENDIF
+           IF(SVD_QR.EQ.1) THEN
+              LWK_RR=int(3*SIZE_ROOT+1,8)
+           ELSEIF(SVD_QR.EQ.2) THEN
+              LWK_RR=int(SIZE_ROOT+1,8)
+           END IF
+         END IF
+      ENDIF
+      RETURN
+      END SUBROUTINE ZMUMPS_SVD_QR_ESTIM_WK
+      SUBROUTINE ZMUMPS_SEQ_FACTO_ROOT_SVD_QR
+     &(NN,A,ROOT,WR03,LWR03,KEEP,KEEP8,INFO,LP,DKEEP,
+     & GLOBK109,OPELIW,PIVNUL_LIST,LPIVNUL_LIST,
+     & ROW_INDICES)
+      USE ZMUMPS_STRUC_DEF, ONLY : ZMUMPS_ROOT_STRUC
+      IMPLICIT NONE
+      TYPE ( ZMUMPS_ROOT_STRUC ) :: ROOT
+      INTEGER :: NN,LP,LWR03,LWR03_MINSIZE
+      COMPLEX(kind=8) :: A(NN*NN)
+      INTEGER :: INFO(2),KEEP(500)
+      INTEGER(8) :: KEEP8(150)
+      DOUBLE PRECISION :: DKEEP(230)
+      DOUBLE PRECISION :: OPELIW
+      INTEGER :: GLOBK109
+      INTEGER :: LPIVNUL_LIST
+      INTEGER :: PIVNUL_LIST(LPIVNUL_LIST)
+      INTEGER :: ROW_INDICES(NN)
+      COMPLEX(kind=8) :: WR03(LWR03)
+      INTEGER LDLT,DEFICIENCY
+      DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE :: RWORK
+      INTEGER :: I,LDA,LDU,LDVT,J
+      INTEGER :: IERR, LAST_BEFORE_GAP_IND
+      INTEGER :: LAST_BEFORE_GAPLIMIT_IND, FIRST_AFTER_MinPiv, 
+     &           FIRST_AFTER_GAPLIMIT, START_POINT, END_POINT 
+      INTEGER :: ALLOCOK,MAXDEF,MINDEF
+      DOUBLE PRECISION :: EPS, ZERO, GAPLIMIT, MaxGap, MaxGap1,
+     &        MinPiv, Tol_MaxGap
+      PARAMETER(ZERO=0.0D0)
+      EPS = epsilon(ZERO)
+      LDLT=KEEP(50)
+      IF ((KEEP(19) .NE. 1).AND.(KEEP(19) .NE. 2)) THEN
+        INFO(1)=-107
+        INFO(2)= KEEP(19)
+        IF ( LP .GT. 0 ) THEN
+            WRITE(LP,*) " *** Option ",KEEP(19),
+     &           " for null space no more available."
+        ENDIF  
+        GOTO 100
+      ENDIF
+      IF(KEEP(19).EQ.1) THEN
+              LWR03_MINSIZE=3*NN+1
+      ELSEIF(KEEP(19).EQ.2) THEN
+              LWR03_MINSIZE=NN+1
+      END IF
+      MAXDEF=KEEP(21)
+      IF ( MAXDEF .LE. 0 ) THEN
+        MAXDEF = NN
+      ELSE
+        MAXDEF = max(MAXDEF - GLOBK109,0)
+      ENDIF
+      MINDEF = max(KEEP(22) - GLOBK109,0)
+      MINDEF = min(MINDEF,NN)
+      MAXDEF = min(MAXDEF,NN)
+      IF(KEEP(19).EQ.1) THEN
+         OPELIW = OPELIW + dble(26)*dble(NN)*dble(NN)*dble(NN)
+      ELSEIF(KEEP(19).EQ.2) THEN
+         OPELIW = OPELIW +  dble(4)*dble(NN)*dble(NN)*dble(NN)/dble(3)
+      ENDIF
+      IF (associated(ROOT%SINGULAR_VALUES)) 
+     &     DEALLOCATE(ROOT%SINGULAR_VALUES)
+      NULLIFY(ROOT%SINGULAR_VALUES)
+      ROOT%NB_SINGULAR_VALUES=NN
+      ALLOCATE(ROOT%SINGULAR_VALUES(NN), stat=ALLOCOK)
+      IF (ALLOCOK.GT.0) THEN
+         INFO(1)=-13
+         INFO(2)=NN
+         IF ( LP .GT. 0 )
+     &        WRITE(LP,*) 'ZMUMPS_SEQ_FACTO_ROOT_SVD_QR: Problem '
+     &        //'allocating SINGULAR_VALUES'
+         GOTO 100
+      END IF
+      IF(KEEP(19).EQ.1) THEN     
+         IF(associated(ROOT%SVD_U)) DEALLOCATE(ROOT%SVD_U)
+         NULLIFY(ROOT%SVD_U)
+         ALLOCATE(ROOT%SVD_U(NN,NN),stat=ALLOCOK )
+         IF(ALLOCOK.GT.0) THEN
+            INFO(1)=-13
+            INFO(2)=NN*NN
+            IF ( LP .GT. 0 )
+     &           WRITE(LP,*) 'ZMUMPS_SEQ_FACTO_ROOT_SVD_QR: Problem '
+     &           //'allocating SVD_U'
+            GOTO 100
+         END IF
+         IF (associated(ROOT%SVD_VT)) DEALLOCATE(ROOT%SVD_VT)
+         NULLIFY(ROOT%SVD_VT)
+         ALLOCATE(ROOT%SVD_VT(NN,NN), stat=ALLOCOK)
+         IF (ALLOCOK.GT.0) THEN
+            INFO(1)=-13
+            INFO(2)=NN*NN
+            IF ( LP .GT. 0 )
+     &           WRITE(LP,*) 'ZMUMPS_SEQ_FACTO_ROOT_SVD_QR: Problem '
+     &           //'allocating SVD_VT'
+            GOTO 100
+         END IF
+         IF (allocated(RWORK)) DEALLOCATE(RWORK)
+         ALLOCATE(RWORK(5*NN), stat=ALLOCOK)
+         IF (ALLOCOK.GT.0) THEN
+            INFO(1)=-13
+            INFO(2)=5*NN
+            IF ( LP .GT. 0 )
+     &           WRITE(LP,*) 
+     &           'ZMUMPS_SEQ_FACTO_ROOT_SVD_QR: Problem '
+     &           //'allocating RWORK'
+            GOTO 100
+         END IF
+      ELSEIF(KEEP(19).EQ.2) THEN
+         IF (associated(ROOT%QR_TAU)) DEALLOCATE(ROOT%QR_TAU)
+         NULLIFY(ROOT%QR_TAU)
+         ALLOCATE(ROOT%QR_TAU(NN), stat=ALLOCOK)
+         IF (ALLOCOK.GT.0) THEN
+            INFO(1)=-13
+            INFO(2)=NN
+            IF ( LP .GT. 0 )
+     &           WRITE(LP,*) 
+     &           'ZMUMPS_SEQ_FACTO_ROOT_SVD_QR: Problem '
+     &           //'allocating QR_TAU'
+            GOTO 100
+         END IF
+         IF (associated(ROOT%IPIV)) DEALLOCATE(ROOT%IPIV)
+         NULLIFY(ROOT%IPIV)
+         ALLOCATE(ROOT%IPIV(NN), stat=ALLOCOK)
+         IF (ALLOCOK.GT.0) THEN
+            INFO(1)=-13
+            INFO(2)=NN
+            IF ( LP .GT. 0 )
+     &           WRITE(LP,*) 
+     &           'ZMUMPS_SEQ_FACTO_ROOT_SVD_QR: Problem '
+     &           //'allocating IPIV'
+            GOTO 100
+         END IF
+         IF (allocated(RWORK)) DEALLOCATE(RWORK)
+         ALLOCATE(RWORK(2*NN), stat=ALLOCOK)
+         IF (ALLOCOK.GT.0) THEN
+            INFO(1)=-13
+            INFO(2)=2*NN
+            IF ( LP .GT. 0 )
+     &           WRITE(LP,*) 
+     &           'ZMUMPS_SEQ_FACTO_ROOT_SVD_QR: Problem '
+     &           //'allocating RWORK'
+            GOTO 100
+         END IF
+      ENDIF
+      IF (LDLT.NE.0) THEN
+         CALL ZMUMPS_SEQ_SYMMETRIZE(NN,A)
+      END IF
+      LDA=NN
+      LDU=NN
+      LDVT=NN
+      IERR = 0
+      IF(KEEP(19).EQ.1) THEN
+         CALL zgesvd('A','A',NN,NN,A,LDA,ROOT%SINGULAR_VALUES(1)
+     &        ,ROOT%SVD_U(1,1)
+     &        ,LDU,ROOT%SVD_VT(1,1),LDVT,WR03,LWR03,RWORK,IERR)
+      ENDIF
+      IF(IERR.NE.0) THEN
+         INFO(1)=-107
+         INFO(2)=IERR
+         IF (LP.GT.0) THEN
+            IF(KEEP(19).EQ.1) THEN
+               WRITE(LP,*) ' Problem in zgesvd : IERR = ', IERR
+            ELSEIF(KEEP(19).EQ.2) THEN
+               WRITE(LP,*) ' Problem in zgeqpf : IERR = ', IERR
+            ENDIF
+           GOTO 100
+         END IF
+      ENDIF
+      IF(KEEP(19).EQ.2) THEN
+         DO I=1,NN
+            ROOT%SINGULAR_VALUES(I)=abs(A(I+NN*(I-1)))
+         ENDDO
+      ENDIF
+      DEFICIENCY=0
+      MinPiv = DKEEP(20)
+      GAPLIMIT = DKEEP(9)
+      IF (ROOT%SINGULAR_VALUES(NN).GT.MinPiv) THEN
+              DEFICIENCY = 0
+              GOTO 170
+      ENDIF
+      IF (ROOT%SINGULAR_VALUES(1).LE.GAPLIMIT) THEN
+           DEFICIENCY = NN
+           GOTO 170
+      ENDIF
+      LAST_BEFORE_GAPLIMIT_IND = 0
+      LAST_BEFORE_GAP_IND  = 0
+      FIRST_AFTER_MinPiv   = 0
+      FIRST_AFTER_GAPLIMIT = 0
+      MaxGap  = 0
+      MaxGap1 = 0
+      Tol_MaxGap = DKEEP(24)
+      DO I=NN,1,-1
+              IF (FIRST_AFTER_MinPiv.GT.0)  exit   
+         IF(ROOT%SINGULAR_VALUES(I).LE.GAPLIMIT) THEN
+                  LAST_BEFORE_GAPLIMIT_IND = I
+         ELSE IF  ((FIRST_AFTER_GAPLIMIT.EQ.0).AND.
+     &               (ROOT%SINGULAR_VALUES(I).LE.MinPiv)) THEN
+                 FIRST_AFTER_GAPLIMIT = I
+         ELSE IF (ROOT%SINGULAR_VALUES(I).GT.MinPiv) THEN
+                 FIRST_AFTER_MinPiv = I
+                 IF (FIRST_AFTER_GAPLIMIT.EQ.0) FIRST_AFTER_GAPLIMIT = I
+         ENDIF
+      ENDDO
+      START_POINT = LAST_BEFORE_GAPLIMIT_IND
+      IF ((LAST_BEFORE_GAPLIMIT_IND.EQ.0).AND.
+     &    (FIRST_AFTER_GAPLIMIT.GT. FIRST_AFTER_MinPiv)) 
+     &               START_POINT = FIRST_AFTER_GAPLIMIT
+      END_POINT = FIRST_AFTER_MinPiv
+      IF (FIRST_AFTER_MinPiv.EQ.0) END_POINT = 1
+      DO I=START_POINT,END_POINT+1,-1
+          IF (ROOT%SINGULAR_VALUES(I).EQ.0) THEN
+             LAST_BEFORE_GAP_IND = I
+          ELSE
+              MaxGap1 = ROOT%SINGULAR_VALUES(I-1)*
+     &                                    (1/ROOT%SINGULAR_VALUES(I))
+             IF (MaxGap1.GE. Tol_MaxGap) THEN
+                  IF (MaxGap1.GE. DKEEP(25)*MaxGap ) THEN 
+                     LAST_BEFORE_GAP_IND = I
+                     MaxGap =  MaxGap1
+                  ENDIF  
+             ENDIF  
+          ENDIF
+      ENDDO
+      IF (MaxGap.EQ.ZERO) THEN        
+          IF (LAST_BEFORE_GAPLIMIT_IND.EQ.0) THEN
+               DEFICIENCY = 0
+          ELSE
+               DEFICIENCY = NN - LAST_BEFORE_GAPLIMIT_IND +1  
+          ENDIF
+      ELSE
+          DEFICIENCY = NN - LAST_BEFORE_GAP_IND +1  
+      ENDIF 
+ 170  CONTINUE
+      DEFICIENCY=min(DEFICIENCY,MAXDEF)
+      DEFICIENCY=max(DEFICIENCY,MINDEF)      
+      KEEP(17)=DEFICIENCY
+      IF(KEEP(19).EQ.2) THEN
+         IF(DEFICIENCY.GT.0) THEN
+            CALL ztrtrs('U','N','N',NN-DEFICIENCY,DEFICIENCY,
+     &           A,LDA,A(LDA*(NN-DEFICIENCY)+1),LDA,IERR)
+            IF ( IERR .NE. 0 ) THEN
+               IF (LP.GT.0) 
+     &         WRITE(LP,*) ' Internal error in ztrtrs: IERR = ',IERR
+               CALL MUMPS_ABORT()
+            END IF
+         END IF
+      ENDIF
+      DO J=NN-DEFICIENCY+1, NN
+         IF(KEEP(19).EQ.1) THEN
+            PIVNUL_LIST(J-NN+DEFICIENCY) = ROW_INDICES(J)
+         ELSEIF(KEEP(19).EQ.2) THEN
+            PIVNUL_LIST(J-NN+DEFICIENCY) = ROW_INDICES(ROOT%IPIV(J))
+         ENDIF
+      ENDDO
+ 100  CONTINUE     
+      IF (allocated(RWORK)) DEALLOCATE(RWORK)
+      RETURN
+      END SUBROUTINE ZMUMPS_SEQ_FACTO_ROOT_SVD_QR
+      SUBROUTINE ZMUMPS_SEQ_SOLVE_ROOT_SVD_QR
+     &  (NRHS,NN,A,ROOT,
+     &   IBEG_ROOT_DEF, IEND_ROOT_DEF,
+     &   RHS,KEEP,KEEP8,MTYPE,INFO,LWK8,WK, LP)
+      USE ZMUMPS_STRUC_DEF, ONLY : ZMUMPS_ROOT_STRUC
+      IMPLICIT NONE
+      INTEGER NN, NRHS
+      INTEGER(8), INTENT(IN) :: LWK8
+      TYPE ( ZMUMPS_ROOT_STRUC ) :: root
+      COMPLEX(kind=8) A(NN*NN)
+      INTEGER IBEG_ROOT_DEF, IEND_ROOT_DEF, MTYPE
+      INTEGER INFO(2),KEEP(500)
+      INTEGER(8) KEEP8(150)
+      COMPLEX(kind=8) RHS(NN,NRHS), WK(LWK8)
+      INTEGER LP
+      INTEGER :: LWK
+      COMPLEX(kind=8),DIMENSION(:,:), allocatable :: TEMP_RHS
+      INTEGER :: I,IERR,K
+      INTEGER :: LDLT,RRSTRAT,DEFICIENCY,LDA,LDRHS
+      INTEGER :: ALLOCOK
+      DOUBLE PRECISION, PARAMETER    :: RONE=1.0D+0
+      COMPLEX(kind=8) ZERO, ONE, MINUSONE
+      PARAMETER( ZERO = (0.0D0,0.0D0), ONE = (1.0D0,0.0D0))
+      PARAMETER( MINUSONE=(-1.0D0,0.0D0))
+      LDLT      = KEEP(50)
+      RRSTRAT   = KEEP(19)
+      DEFICIENCY = KEEP(17)
+      LDA = NN
+      LDRHS = NN
+      LWK = int(min(int(huge(LWK),8),LWK8))
+      IERR = 0
+      IF ((RRSTRAT .NE. 1).AND.(RRSTRAT .NE. 2)) THEN
+         WRITE(*,*) " *** Internal error ption ",RRSTRAT,
+     &        " for null space no more available."
+         CALL MUMPS_ABORT()
+      ENDIF
+      IF (KEEP(111).EQ.0) THEN
+         IF(KEEP(19).EQ.1) THEN
+           IF ((MTYPE.EQ.0).OR.(LDLT.GT.0)) THEN
+               allocate(TEMP_RHS(NN,NRHS), stat=ALLOCOK)
+               IF (ALLOCOK.GT.0) THEN
+                 INFO(1)=-13
+                 INFO(2)=NN*NRHS
+                 IF ( LP .GT. 0 )
+     &              WRITE(LP,*) 
+     &              'ZMUMPS_SEQ_SOLVE_ROOT_SVD_QR: Problem '
+     &              //'allocating TEMP_RHS'
+                 RETURN
+               END IF
+               CALL zgemm('Conjugate transpose','N',NN,NRHS,NN,ONE,
+     &              root%SVD_U(1,1),NN,RHS,
+     &              NN,ZERO,TEMP_RHS,NN)
+               DO I=1,NN-DEFICIENCY
+                  TEMP_RHS( I, 1:NRHS ) = 
+     &         cmplx(RONE/root%SINGULAR_VALUES(I),kind=kind(TEMP_RHS))*
+     &                          TEMP_RHS( I, 1:NRHS )
+               ENDDO
+               DO I=NN-DEFICIENCY +1, NN
+                  TEMP_RHS(I, 1:NRHS) = ZERO 
+               ENDDO
+               CALL zgemm('Conjugate transpose','N',NN,NRHS,NN,ONE,
+     &               root%SVD_VT(1,1),NN,
+     &              TEMP_RHS, NN,ZERO,RHS,NN)
+               DEALLOCATE(TEMP_RHS)
+           ELSEIF(MTYPE.EQ.1) THEN
+               allocate(TEMP_RHS(NRHS,NN), stat=ALLOCOK)
+               IF (ALLOCOK.GT.0) THEN
+                  INFO(1)=-13
+                  INFO(2)=NN*NRHS
+                  IF ( LP .GT. 0 )
+     &              WRITE(LP,*) 
+     &              'ZMUMPS_SEQ_SOLVE_ROOT_SVD_QR: Problem '
+     &              //'allocating TEMP_RHS'
+                  RETURN
+               END IF
+               CALL zgemm('T','C',NRHS,NN, NN,ONE,RHS, NN, 
+     &               root%SVD_VT(1,1),NN,
+     &              ZERO,TEMP_RHS,NRHS)
+               DO I=1,NN-DEFICIENCY
+                  RHS(I, 1:NRHS ) = 
+     &         cmplx(RONE/root%SINGULAR_VALUES(I),kind=kind(TEMP_RHS))*
+     &                          TEMP_RHS(1:NRHS,I ) 
+               ENDDO
+               DO I=NN-DEFICIENCY +1, NN
+                  RHS(I,1:NRHS) = ZERO 
+               ENDDO
+               CALL zgemm('T','C',NRHS,NN,NN,ONE,RHS, NN, 
+     &             root%SVD_U(1,1),NN,
+     &             ZERO,TEMP_RHS,NRHS)
+                  DO I=1,NRHS
+                  RHS(1:NN,I) =TEMP_RHS(I,1:NN )
+                  ENDDO
+                 DEALLOCATE(TEMP_RHS)
+            ENDIF
+         ELSEIF(KEEP(19).EQ.2) THEN
+            IF ((MTYPE.EQ.0).OR.(LDLT.GT.0)) THEN
+               CALL zunmqr('L','Conjugate transpose',NN,NRHS,NN,
+     &              A,LDA,root%QR_TAU(1),
+     &              RHS,LDRHS,WK(1),LWK,IERR)
+               IF(IERR.LT.0) THEN
+                  WRITE(*,*) 
+     &         'Error return from zunmqr in root solve: IERR=', IERR
+                  RETURN
+               END IF
+               CALL ztrtrs('U','N','N',NN-DEFICIENCY,NRHS,A,LDA,
+     &              RHS,LDRHS,IERR)
+               IF ( IERR .LT. 0 ) THEN
+                  WRITE(*,*) 
+     &         'Error return from ztrtrs in roor solve: IERR =',IERR
+                  RETURN
+               END IF
+               DO I=1,NRHS
+                  RHS( NN - DEFICIENCY + 1: NN, I ) = ZERO  
+               ENDDO
+               DO I=1,NRHS
+                  CALL ZMUMPS_UXVSBP(NN,root%IPIV(1),RHS(1,I),WK)
+               ENDDO
+           ELSEIF(MTYPE.EQ.1) THEN
+               DO I=1,NRHS
+                 CALL ZMUMPS_UXVSFP(NN,root%IPIV(1),RHS(1,I),WK)
+               ENDDO
+               CALL ztrtrs('U','T','N',NN-DEFICIENCY,NRHS,
+     &              A,LDA,RHS,LDRHS,IERR)
+               IF(IERR.NE.0) THEN
+                  WRITE(*,*) 'Error return from trtrs: IERR=', IERR
+                  STOP    
+               END IF
+               allocate(TEMP_RHS(NRHS,NN), stat=ALLOCOK)
+               IF (ALLOCOK.GT.0) THEN
+                  INFO(1)=-13
+                  INFO(2)=NN*NRHS
+                  IF ( LP .GT. 0 )
+     &              WRITE(LP,*) 
+     &              'ZMUMPS_SEQ_SOLVE_ROOT_SVD_QR: Problem '
+     &              //'allocating TEMP_RHS'
+                  RETURN
+               END IF
+               DO I=1,NRHS
+                  TEMP_RHS(I,1:NN-DEFICIENCY)=RHS(1:NN-DEFICIENCY, I)
+               ENDDO
+               DO I=NN - DEFICIENCY + 1,NN
+                  TEMP_RHS( 1: NRHS, I ) = ZERO  
+               ENDDO
+                CALL zunmqr( 'R','Conjugate transpose',NRHS,NN,NN,A,LDA,
+     &              root%QR_TAU(1),
+     &              TEMP_RHS,NRHS,WK,LWK,IERR)
+               IF(IERR.LT.0) THEN
+                  WRITE(*,*) 'Error return from zunmqr: IERR=', IERR
+                  RETURN
+               END IF
+                DO I=1,NRHS
+                  RHS(1:NN, I)= TEMP_RHS(I,1:NN)
+               ENDDO
+               DEALLOCATE(TEMP_RHS)
+            ENDIF
+         ENDIF
+      ELSE
+         IF(KEEP(19).EQ.1) THEN
+           IF ((MTYPE.EQ.0).OR.(LDLT.GT.0)) THEN
+               DO I=IBEG_ROOT_DEF,IEND_ROOT_DEF
+                  RHS(:,I+1-IBEG_ROOT_DEF) = 
+     &                 CONJG(root%SVD_VT(NN-DEFICIENCY+I,:))
+               ENDDO
+           ELSEIF(MTYPE.EQ.1) THEN
+               DO I=IBEG_ROOT_DEF,IEND_ROOT_DEF
+                  RHS(:,I+1-IBEG_ROOT_DEF) = 
+     &               CONJG(root%SVD_U(:,NN-DEFICIENCY+I))
+               ENDDO
+            ENDIF
+         ELSEIF(KEEP(19).EQ.2) THEN
+           IF((MTYPE.EQ.0).OR.(LDLT.GT.0)) THEN        
+               DO I=IBEG_ROOT_DEF,IEND_ROOT_DEF
+                  RHS(NN-DEFICIENCY+I,I-IBEG_ROOT_DEF+1) = MINUSONE
+                  DO K=1,NN-DEFICIENCY
+                     RHS(K,I-IBEG_ROOT_DEF+1)=
+     &                    A(K + LDA*(NN-DEFICIENCY+I-1))
+                  ENDDO
+               ENDDO
+               DO I=1,IEND_ROOT_DEF-IBEG_ROOT_DEF+1
+                  CALL ZMUMPS_UXVSBP(NN,root%IPIV(1),RHS(1,I),WK)
+               ENDDO 
+           ELSEIF(MTYPE.EQ.1) THEN
+               WRITE(*,*) 'Computation of a null space basis'
+     &              // ' of A is unavailable for unsymetric matrices'
+            DO I=IBEG_ROOT_DEF,IEND_ROOT_DEF
+               RHS(NN-DEFICIENCY+I,I-IBEG_ROOT_DEF+1) = ONE
+            ENDDO
+            CALL zunmqr('L','N',NN,NRHS,NN, A,LDA,root%QR_TAU(1),
+     &              RHS,LDRHS,WK(1),LWK,IERR)
+            ENDIF
+         ENDIf
+      ENDIF
+      RETURN
+      END SUBROUTINE ZMUMPS_SEQ_SOLVE_ROOT_SVD_QR
diff -pruN 5.6.2-2.1/src/zsol_aux.F 5.7.1-1/src/zsol_aux.F
--- 5.6.2-2.1/src/zsol_aux.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zsol_aux.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -307,7 +307,8 @@ C
       COMPLEX(kind=8) W(N), X(N)
       DOUBLE PRECISION, intent(inout)    :: EST
       INTEGER, intent(in)    :: GRAIN
-      INTRINSIC abs, nint, real, sign
+      INTRINSIC abs, nint, sign
+      INTRINSIC dble
       INTEGER ZMUMPS_IXAMAX
       EXTERNAL ZMUMPS_IXAMAX
       INTEGER ITMAX
@@ -408,7 +409,7 @@ C
       DO 170 I = 1, N
         TEMP = TEMP + abs(X(I))
   170 CONTINUE
-      TEMP = 2.0D0 * TEMP / dble(3 * N)
+      TEMP = 2.0D0/3.0D0 * TEMP / dble(N)
       IF (TEMP .GT. EST) THEN
         DO 180 I = 1, N
           W(I) = X(I)
@@ -954,7 +955,7 @@ C
       DOUBLE PRECISION, PARAMETER :: ZERO = 0.0D0
       DOUBLE PRECISION, PARAMETER :: ONE  = 1.0D0
       INTEGER ZMUMPS_IXAMAX
-      INTRINSIC     abs, max
+      INTRINSIC     abs
       SAVE LCOND1, LCOND2, JUMP,  DXIMAX, DXMAX
       IF (KASE .EQ. 0) THEN
         LCOND1 = .FALSE.
@@ -1034,14 +1035,14 @@ C
   170 CONTINUE
       RETURN
       END SUBROUTINE ZMUMPS_SOL_LCOND
-      SUBROUTINE ZMUMPS_SOL_CPY_FS2RHSCOMP( JBDEB, JBFIN, NBROWS,
-     &   KEEP, RHSCOMP, NRHS, LRHSCOMP, FIRST_ROW_RHSCOMP, W, LD_W,
+      SUBROUTINE ZMUMPS_SOL_CPY_FS2RHSINTR( JBDEB, JBFIN, NBROWS,
+     &   KEEP, RHSINTR, NRHS, LRHSINTR, FIRST_ROW_RHSINTR, W, LD_W,
      &   FIRST_ROW_W )
          INTEGER :: JBDEB, JBFIN, NBROWS
-         INTEGER :: NRHS, LRHSCOMP
-         INTEGER :: FIRST_ROW_RHSCOMP
+         INTEGER :: NRHS, LRHSINTR
+         INTEGER :: FIRST_ROW_RHSINTR
          INTEGER, INTENT(IN) :: KEEP(500)
-         COMPLEX(kind=8), INTENT(INOUT) :: RHSCOMP(LRHSCOMP,NRHS)
+         COMPLEX(kind=8), INTENT(INOUT) :: RHSINTR(LRHSINTR,NRHS)
          INTEGER :: LD_W, FIRST_ROW_W
          COMPLEX(kind=8) :: W(LD_W*(JBFIN-JBDEB+1))
          INTEGER :: JJ, K, ISHIFT
@@ -1051,33 +1052,33 @@ C
          DO K = JBDEB, JBFIN
            ISHIFT = FIRST_ROW_W + LD_W * (K-JBDEB)
            DO JJ = 0, NBROWS-1
-              RHSCOMP(FIRST_ROW_RHSCOMP+JJ,K) = W(ISHIFT+JJ)
+              RHSINTR(FIRST_ROW_RHSINTR+JJ,K) = W(ISHIFT+JJ)
            END DO
          END DO
 !$OMP    END PARALLEL DO
       RETURN
-      END SUBROUTINE ZMUMPS_SOL_CPY_FS2RHSCOMP
+      END SUBROUTINE ZMUMPS_SOL_CPY_FS2RHSINTR
       SUBROUTINE ZMUMPS_SOL_BWD_GTHR( JBDEB, JBFIN, J1, J2,
-     &   RHSCOMP, NRHS, LRHSCOMP, W, LD_W, FIRST_ROW_W,
-     &   IW, LIW, KEEP, N, POSINRHSCOMP_BWD )
+     &   RHSINTR, NRHS, LRHSINTR, W, LD_W, FIRST_ROW_W,
+     &   IW, LIW, KEEP, N, POSINRHSINTR_BWD )
       INTEGER, INTENT(IN) :: JBDEB, JBFIN, J1, J2
-      INTEGER, INTENT(IN) :: NRHS, LRHSCOMP
+      INTEGER, INTENT(IN) :: NRHS, LRHSINTR
       INTEGER, INTENT(IN) :: FIRST_ROW_W, LD_W, LIW
       INTEGER, INTENT(IN) :: IW(LIW)
       INTEGER, INTENT(IN) :: KEEP(500)
-      COMPLEX(kind=8), INTENT(INOUT) :: RHSCOMP(LRHSCOMP,NRHS)
+      COMPLEX(kind=8), INTENT(INOUT) :: RHSINTR(LRHSINTR,NRHS)
       COMPLEX(kind=8) :: W(LD_W*(JBFIN-JBDEB+1))
       INTEGER, INTENT(IN) :: N
-      INTEGER, INTENT(IN) :: POSINRHSCOMP_BWD(N)
-      INTEGER :: ISHIFT, JJ, K, IPOSINRHSCOMP
-!$OMP PARALLEL DO PRIVATE(JJ,ISHIFT,IPOSINRHSCOMP), IF
+      INTEGER, INTENT(IN) :: POSINRHSINTR_BWD(N)
+      INTEGER :: ISHIFT, JJ, K, IPOSINRHSINTR
+!$OMP PARALLEL DO PRIVATE(JJ,ISHIFT,IPOSINRHSINTR), IF
 !$OMP& ((JBFIN-JBDEB+1 > 2*KEEP(362) .AND.
 !$OMP& (JBFIN-JBDEB+1)*(J2-KEEP(253)-J1+1)>2*KEEP(363)))
              DO K=JBDEB, JBFIN
                ISHIFT = FIRST_ROW_W+(K-JBDEB)*LD_W
                DO JJ = J1, J2-KEEP(253)   
-                 IPOSINRHSCOMP =  abs(POSINRHSCOMP_BWD(IW(JJ)))
-                 W(ISHIFT+JJ-J1)= RHSCOMP(IPOSINRHSCOMP,K)
+                 IPOSINRHSINTR =  abs(POSINRHSINTR_BWD(IW(JJ)))
+                 W(ISHIFT+JJ-J1)= RHSINTR(IPOSINRHSINTR,K)
                ENDDO
              ENDDO
 !$OMP END PARALLEL DO
@@ -1135,11 +1136,11 @@ C
       RESL2 = sqrt(RESL2)
       IF (PROK) WRITE( MPRINT, 90 ) RESMAX, RESL2, ANORM, XNORM, 
      &      SCLNRM
-   90  FORMAT (/' RESIDUAL IS ............ (MAX-NORM)        =',1PD9.2/
+   90  FORMAT (/' RESIDUAL IS ............ (INF-NORM)        =',1PD9.2/
      &       '                       .. (2-NORM)          =',1PD9.2/
-     &       ' RINFOG(4):NORM OF input  Matrix  (MAX-NORM)=',1PD9.2/
-     &       ' RINFOG(5):NORM OF Computed SOLUT (MAX-NORM)=',1PD9.2/
-     &       ' RINFOG(6):SCALED RESIDUAL ...... (MAX-NORM)=',1PD9.2)
+     &       ' RINFOG(4):NORM OF input  Matrix  (INF-NORM)=',1PD9.2/
+     &       ' RINFOG(5):NORM OF Computed SOLUT (INF-NORM)=',1PD9.2/
+     &       ' RINFOG(6):SCALED RESIDUAL ...... (INF-NORM)=',1PD9.2)
       RETURN
       END SUBROUTINE ZMUMPS_SOL_Q
       SUBROUTINE ZMUMPS_SOLVE_FWD_TRSOLVE (A, LA, APOS, NPIV, LDADIAG, 
@@ -1372,8 +1373,8 @@ C
      &  IW, IPOS, LIW, 
      &  A, LA, APOS,
      &  WCB, LWCB, LD_WCBPIV, 
-     &  RHSCOMP, LRHSCOMP, NRHS, 
-     &  POSINRHSCOMP_FWD, JBDEB, JBFIN, 
+     &  RHSINTR, LRHSINTR, NRHS, 
+     &  POSINRHSINTR_FWD, JBDEB, JBFIN, 
      &  MTYPE, KEEP, OOCWRITE_COMPATIBLE_WITH_BLR,
      &  IGNORE_K459
      &  )
@@ -1381,18 +1382,18 @@ C
       IMPLICIT NONE
       INTEGER, INTENT(IN) :: MTYPE, INODE, N, NPIV, LIELL,
      &                       NELIM, NSLAVES
-      INTEGER, INTENT(IN) :: LRHSCOMP, NRHS, LIW, JBDEB, JBFIN
-      INTEGER, INTENT(IN) :: IW(LIW), IPOS, POSINRHSCOMP_FWD(N)
+      INTEGER, INTENT(IN) :: LRHSINTR, NRHS, LIW, JBDEB, JBFIN
+      INTEGER, INTENT(IN) :: IW(LIW), IPOS, POSINRHSINTR_FWD(N)
       INTEGER(8), INTENT(IN) :: LWCB, APOS, LA, PPIV_COURANT
       INTEGER, INTENT(IN) :: LD_WCBPIV
       INTEGER, INTENT(IN) :: KEEP(500)
       COMPLEX(kind=8), INTENT(IN) ::  WCB( LWCB )
       COMPLEX(kind=8), INTENT(IN) :: A( LA )
-      COMPLEX(kind=8), INTENT(INOUT) :: RHSCOMP(LRHSCOMP, NRHS)
+      COMPLEX(kind=8), INTENT(INOUT) :: RHSINTR(LRHSINTR, NRHS)
       LOGICAL, INTENT(IN) :: OOCWRITE_COMPATIBLE_WITH_BLR
       LOGICAL, INTENT(IN) :: IGNORE_K459
       INTEGER    :: J1, J3
-      INTEGER    :: IPOSINRHSCOMP, JJ, K,
+      INTEGER    :: IPOSINRHSINTR, JJ, K,
      &              LDAJ, NRHS_B
       INTEGER(8) :: IFR8 , APOS1, APOS2, APOSOFF, IFR_ini8, 
      &              POSWCB1, POSWCB2
@@ -1414,7 +1415,7 @@ C
          J1 = IPOS + LIELL + 1
          J3 = IPOS + LIELL + NPIV
       END IF
-      IPOSINRHSCOMP =  POSINRHSCOMP_FWD(IW(J1)) 
+      IPOSINRHSINTR =  POSINRHSINTR_FWD(IW(J1)) 
       IF ( KEEP(50) .eq. 0 ) THEN
          OMP_FLAG = .FALSE.
 !$       OMP_FLAG=(int(NRHS_B,8)*int(NPIV,8).GE.int(KEEP(363),8))
@@ -1422,7 +1423,7 @@ C
 !$OMP PARALLEL DO PRIVATE(IFR8) COLLAPSE(2)
            DO K = JBDEB, JBFIN
              DO IFR8 = 0_8, int(NPIV-1,8)
-               RHSCOMP(IPOSINRHSCOMP+IFR8, K) =
+               RHSINTR(IPOSINRHSINTR+IFR8, K) =
      &            WCB(PPIV_COURANT+(K-JBDEB)*LD_WCBPIV+IFR8)
              ENDDO
            ENDDO
@@ -1430,7 +1431,7 @@ C
          ELSE
            DO K = JBDEB, JBFIN
              DO IFR8 = 0_8, int(NPIV-1,8)
-               RHSCOMP(IPOSINRHSCOMP+IFR8, K) =
+               RHSINTR(IPOSINRHSINTR+IFR8, K) =
      &            WCB(PPIV_COURANT+(K-JBDEB)*LD_WCBPIV+IFR8)
              ENDDO
            ENDDO
@@ -1450,7 +1451,7 @@ C
             DO JJ = J1, J3
               IPANEL = (JJ-J1)/NB_TARGET + 1
               IF ( JJ-J1+1 .LT. PANEL_COL(IPANEL) ) IPANEL = IPANEL -1
-              ICOL = JJ-J1+1 - PANEL_COL(IPANEL) + 1
+              ICOL = JJ-J1+1 - PANEL_COL(IPANEL) + 1 
               LDAJ = PANEL_COL(IPANEL+1) - PANEL_COL(IPANEL)
               APOS1 = APOS-1_8+PANEL_POS( IPANEL ) + int(ICOL-1,8) *
      &                int(LDAJ+1,8)
@@ -1468,7 +1469,7 @@ C
               IF (SKIP_IT) THEN
               ELSE IF ( IW(JJ+LIELL) .GT. 0 ) THEN
                 VALPIV  = ONE/A( APOS1 )
-                RHSCOMP(IPOSINRHSCOMP+JJ-J1 , K ) = 
+                RHSINTR(IPOSINRHSINTR+JJ-J1 , K ) = 
      &                 WCB( IFR8 ) * VALPIV
                 APOS1 = APOS1 + int(LDAJ + 1,8)
               ELSE
@@ -1483,10 +1484,10 @@ C
                 A12 = -A12/DETPIV
                 POSWCB1 = IFR8
                 POSWCB2 = POSWCB1+1_8
-                RHSCOMP(IPOSINRHSCOMP+JJ-J1,K) =
+                RHSINTR(IPOSINRHSINTR+JJ-J1,K) =
      &                 WCB(POSWCB1)*A11
      &                 + WCB(POSWCB2)*A12
-                RHSCOMP(IPOSINRHSCOMP+JJ-J1+1,K) = 
+                RHSINTR(IPOSINRHSINTR+JJ-J1+1,K) = 
      &                   WCB(POSWCB1)*A12
      &                   + WCB(POSWCB2)*A22
               ENDIF  
@@ -1502,26 +1503,26 @@ C
      &  IW, IPOS, LIW, 
      &  A, LA, APOS,
      &  WCB, LWCB, LD_WCBPIV, 
-     &  RHSCOMP, LRHSCOMP, NRHS, 
-     &  POSINRHSCOMP_FWD, JBDEB, JBFIN, 
+     &  RHSINTR, LRHSINTR, NRHS, 
+     &  POSINRHSINTR_FWD, JBDEB, JBFIN, 
      &  MTYPE, KEEP, OOCWRITE_COMPATIBLE_WITH_BLR,
      &  IGNORE_K459
      &  )
       USE ZMUMPS_OOC 
       INTEGER, INTENT(IN) :: MTYPE, INODE, N, NPIV, LIELL,
      &                       NELIM, NSLAVES
-      INTEGER, INTENT(IN) :: LRHSCOMP, NRHS, LIW, JBDEB, JBFIN
-      INTEGER, INTENT(IN) :: IW(LIW), IPOS, POSINRHSCOMP_FWD(N)
+      INTEGER, INTENT(IN) :: LRHSINTR, NRHS, LIW, JBDEB, JBFIN
+      INTEGER, INTENT(IN) :: IW(LIW), IPOS, POSINRHSINTR_FWD(N)
       INTEGER(8), INTENT(IN) :: LWCB, APOS, LA, PPIV_COURANT
       INTEGER, INTENT(IN) :: LD_WCBPIV
       INTEGER, INTENT(IN) :: KEEP(500)
       COMPLEX(kind=8), INTENT(IN) ::  WCB( LWCB )
       COMPLEX(kind=8), INTENT(IN) :: A( LA )
-      COMPLEX(kind=8), INTENT(INOUT) :: RHSCOMP(LRHSCOMP, NRHS)
+      COMPLEX(kind=8), INTENT(INOUT) :: RHSINTR(LRHSINTR, NRHS)
       LOGICAL, INTENT(IN) :: OOCWRITE_COMPATIBLE_WITH_BLR
       LOGICAL, INTENT(IN) :: IGNORE_K459
       INTEGER    :: TempNROW, J1, J3, PANEL_SIZE
-      INTEGER    :: IPOSINRHSCOMP, JJ, K, NBK, LDAJ, 
+      INTEGER    :: IPOSINRHSINTR, JJ, K, NBK, LDAJ, 
      &              LDAJ_ini, NBK_ini, LDAJ_FIRST_PANEL, NRHS_B
       INTEGER(8) :: IFR8 , APOS1, APOS2, APOSOFF, IFR_ini8, 
      &              POSWCB1, POSWCB2
@@ -1537,13 +1538,13 @@ C
          J1 = IPOS + LIELL + 1
          J3 = IPOS + LIELL + NPIV
       END IF
-      IPOSINRHSCOMP =  POSINRHSCOMP_FWD(IW(J1)) 
+      IPOSINRHSINTR =  POSINRHSINTR_FWD(IW(J1)) 
       IF ( KEEP(50) .eq. 0 ) THEN
 !$         OMP_FLAG=(NRHS_B.GE.KEEP(362).AND.NRHS_B*NPIV.GE.KEEP(363))
 !$OMP PARALLEL DO PRIVATE(IFR8) IF (OMP_FLAG)
            DO K=JBDEB,JBFIN
              IFR8 =  PPIV_COURANT + (K-JBDEB)*LD_WCBPIV
-             RHSCOMP(IPOSINRHSCOMP:IPOSINRHSCOMP+NPIV-1, K) =
+             RHSINTR(IPOSINRHSINTR:IPOSINRHSINTR+NPIV-1, K) =
      &            WCB(IFR8:IFR8+int(NPIV-1,8))
            ENDDO
 !$OMP END PARALLEL DO
@@ -1596,7 +1597,7 @@ C
             IFR8  = IFR8 + 1_8
             IF (IW(JJ+LIELL) .GT. 0) THEN
                VALPIV  = ONE/A( APOS1 )
-               RHSCOMP(IPOSINRHSCOMP+JJ-J1 , K ) = 
+               RHSINTR(IPOSINRHSINTR+JJ-J1 , K ) = 
      &                 WCB( IFR8 ) * VALPIV
               IF (KEEP(201).EQ.1.AND.OOCWRITE_COMPATIBLE_WITH_BLR)
      &        THEN
@@ -1629,10 +1630,10 @@ C
               A12 = -A12/DETPIV
               POSWCB1 = IFR8
               POSWCB2 = POSWCB1+1_8
-              RHSCOMP(IPOSINRHSCOMP+JJ-J1,K) =
+              RHSINTR(IPOSINRHSINTR+JJ-J1,K) =
      &               WCB(POSWCB1)*A11
      &               + WCB(POSWCB2)*A12
-              RHSCOMP(IPOSINRHSCOMP+JJ-J1+1,K) = 
+              RHSINTR(IPOSINRHSINTR+JJ-J1+1,K) = 
      &                 WCB(POSWCB1)*A12
      &                 + WCB(POSWCB2)*A22
               IF (KEEP(201).EQ.1.AND.OOCWRITE_COMPATIBLE_WITH_BLR)
@@ -1661,6 +1662,7 @@ C
         SEQUENCE
         DOUBLE PRECISION, dimension(:), pointer :: SCALING
         DOUBLE PRECISION, dimension(:), pointer :: SCALING_LOC
+        INTEGER, dimension(:), pointer :: SCALING_IND
       end type scaling_data_t
       type (scaling_data_t), INTENT(INOUT) :: scaling_data
       INTEGER, INTENT(IN) :: N, LILOC, COMM, MYID, MASTER, LP
diff -pruN 5.6.2-2.1/src/zsol_bwd.F 5.7.1-1/src/zsol_bwd.F
--- 5.6.2-2.1/src/zsol_bwd.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zsol_bwd.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -13,7 +13,7 @@ C  https://cecill.info/licences/Licence_
 C
       SUBROUTINE ZMUMPS_SOL_S(N, A, LA, IW, LIW, W, LWC,
      &    NRHS, 
-     &    RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &    RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &    PTRICB, PTRACB, IWCB, LIWW, W2, 
      &    NE_STEPS, STEP,
      &    FRERE, DAD, FILS, IPOOL, LPOOL, PTRIST, PTRFAC, 
@@ -59,8 +59,8 @@ C
       INTEGER BUFR(LBUFR)
       INTEGER ISTEP_TO_INIV2(KEEP(71)), 
      &        TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
-      INTEGER LRHSCOMP, POSINRHSCOMP_BWD(N)
-      COMPLEX(kind=8) RHSCOMP(LRHSCOMP,NRHS)
+      INTEGER LRHSINTR, POSINRHSINTR_BWD(N)
+      COMPLEX(kind=8) RHSINTR(LRHSINTR,NRHS)
       INTEGER(8), intent(in) :: LRHS_ROOT
       COMPLEX(kind=8) RHS_ROOT( LRHS_ROOT )
       LOGICAL, INTENT(in) :: PRUN_BELOW
@@ -124,22 +124,26 @@ C
       ERROR_WAS_BROADCASTED = .FALSE.
       DO_MCAST2_TERMBWD = .FALSE.
       DO WHILE ( NBFINF .NE. 0 .OR. MYLEAF_LEFT .NE. 0 )
-        BLOQ = (  III .EQ. IIPOOL  )
-        CALL ZMUMPS_BACKSLV_RECV_AND_TREAT( BLOQ, FLAG, BUFR, LBUFR,
-     &     LBUFR_BYTES, MYID, SLAVEF, COMM,
-     &     N, IWCB, LIWW, POSIWCB,
-     &     W, LWC, POSWCB,
-     &     IIPOOL, NBFINF, PTRICB, PTRACB, INFO,
-     &     IPOOL, LPOOL, PANEL_POS, LPANEL_POS,
-     &     STEP,  FRERE, FILS, PROCNODE_STEPS,
-     &     PLEFTW, KEEP,KEEP8, DKEEP,
-     &     PTRIST, PTRFAC, IW, LIW, A, LA, W2, MYLEAF_LEFT, 
-     &     NRHS, MTYPE, 
-     &     RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD
-     &     , PRUN_BELOW, TO_PROCESS, SIZE_TO_PROCESS
-     &     , FROM_PP
+        IF ( SLAVEF.EQ.1 ) THEN
+          FLAG = .FALSE.
+        ELSE
+          BLOQ = (  III .EQ. IIPOOL  )
+          CALL ZMUMPS_BACKSLV_RECV_AND_TREAT( BLOQ, FLAG, BUFR, LBUFR,
+     &       LBUFR_BYTES, MYID, SLAVEF, COMM,
+     &       N, IWCB, LIWW, POSIWCB,
+     &       W, LWC, POSWCB,
+     &       IIPOOL, NBFINF, PTRICB, PTRACB, INFO,
+     &       IPOOL, LPOOL, PANEL_POS, LPANEL_POS,
+     &       STEP,  FRERE, FILS, PROCNODE_STEPS,
+     &       PLEFTW, KEEP,KEEP8, DKEEP,
+     &       PTRIST, PTRFAC, IW, LIW, A, LA, W2, MYLEAF_LEFT, 
+     &       NRHS, MTYPE, 
+     &       RHSINTR, LRHSINTR, POSINRHSINTR_BWD
+     &       , PRUN_BELOW, TO_PROCESS, SIZE_TO_PROCESS
+     &       , FROM_PP
      &     )
-        IF ( INFO(1) .LT. 0 ) GOTO 340 
+          IF ( INFO(1) .LT. 0 ) GOTO 340 
+        ENDIF
         IF ( .NOT. FLAG ) THEN
           IF (III .NE. IIPOOL) THEN
             INODE = IPOOL(IIPOOL-1)
@@ -161,7 +165,7 @@ C
      &        N, IPOOL, LPOOL, IIPOOL, NBFINF,
      &        A_PTR(1), LA_PTR, IW, LIW, W, LWC, NRHS,
      &        POSWCB, PLEFTW, POSIWCB,
-     &        RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &        RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &        PTRICB, PTRACB, IWCB, LIWW, W2, 
      &        NE_STEPS, STEP,
      &        FRERE, FILS, PTRIST, PTRFAC,
diff -pruN 5.6.2-2.1/src/zsol_bwd_aux.F 5.7.1-1/src/zsol_bwd_aux.F
--- 5.6.2-2.1/src/zsol_bwd_aux.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zsol_bwd_aux.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -15,7 +15,7 @@ C
      &       N, IPOOL, LPOOL, IIPOOL, NBFINF,
      &       A, LA, IW, LIW, W, LWC, NRHS, 
      &       POSWCB, PLEFTW, POSIWCB,
-     &    RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &    RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &    PTRICB, PTRACB, IWCB, LIWW, W2, 
      &    NE_STEPS, STEP,
      &    FRERE, FILS, PTRIST, PTRFAC, 
@@ -62,8 +62,8 @@ C
       INTEGER BUFR(LBUFR)
       INTEGER ISTEP_TO_INIV2(KEEP(71)), 
      &        TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
-      INTEGER LRHSCOMP, POSINRHSCOMP_BWD(N)
-      COMPLEX(kind=8) RHSCOMP(LRHSCOMP,NRHS)
+      INTEGER LRHSINTR, POSINRHSINTR_BWD(N)
+      COMPLEX(kind=8) RHSINTR(LRHSINTR,NRHS)
       INTEGER(8), intent(in) :: LRHS_ROOT
       COMPLEX(kind=8) RHS_ROOT( LRHS_ROOT )
       LOGICAL, INTENT( IN ) :: PRUN_BELOW
@@ -99,7 +99,7 @@ C
       INTEGER :: PROCDEST, DEST
       INTEGER(8) :: PTWCB, PPIV_COURANT
       INTEGER :: Offset, EffectiveSize, ISLAVE, FirstIndex
-      INTEGER :: POSINDICES, IPOSINRHSCOMP, IPOSINRHSCOMP_PANEL
+      INTEGER :: POSINDICES, IPOSINRHSINTR, IPOSINRHSINTR_PANEL
       INTEGER(8) :: APOS, IST
       INTEGER(8) :: IFR8
       INTEGER(8) :: APOSDEB, NBENTRIES_ALLPANELS
@@ -141,9 +141,9 @@ C
             J2   = IPOS + NPIV
          END IF
          IFR8  = 0_8
-         IPOSINRHSCOMP = POSINRHSCOMP_BWD(IW(J1))  
-         CALL ZMUMPS_SOL_CPY_FS2RHSCOMP(JBDEB, JBFIN, J2-J1+1,
-     &          KEEP, RHSCOMP, NRHS, LRHSCOMP, IPOSINRHSCOMP,
+         IPOSINRHSINTR = POSINRHSINTR_BWD(IW(J1))  
+         CALL ZMUMPS_SOL_CPY_FS2RHSINTR(JBDEB, JBFIN, J2-J1+1,
+     &          KEEP, RHSINTR, NRHS, LRHSINTR, IPOSINRHSINTR,
      &          RHS_ROOT(1+NPIV*(JBDEB-1)), NPIV, 1)
         IN = INODE
  270    IN = FILS(IN)
@@ -210,8 +210,8 @@ C
      &                 LONG, LONG, IW( J1 ),
      &                 RHS_ROOT( 1+NPIV*(JBDEB-1) ), 
      &                 JBDEB, JBFIN,
-     &                 RHSCOMP(1, 1), NRHS, LRHSCOMP,
-     &                 IPOSINRHSCOMP, NPIV,
+     &                 RHSINTR(1, 1), NRHS, LRHSINTR,
+     &                 IPOSINRHSINTR, NPIV,
      &                 KEEP, PROCDEST,
      &                 NOEUD, COMM, IERR )
                 IF ( IERR .EQ. -1 ) THEN
@@ -228,7 +228,7 @@ C
      &                  PTRIST, PTRFAC, IW, LIW, A, LA, W2,
      &                  MYLEAF_LEFT, 
      &                  NRHS, MTYPE,
-     &                  RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &                  RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &                  PRUN_BELOW, TO_PROCESS, SIZE_TO_PROCESS
      &                  , FROM_PP
      &                  )
@@ -349,9 +349,9 @@ C
            END IF
            IFR8 = PTRACB(STEP( INODE )) - 1_8
           CALL ZMUMPS_SOL_BWD_GTHR( JBDEB, JBFIN, J1, J2,
-     &       RHSCOMP, NRHS, LRHSCOMP,
+     &       RHSINTR, NRHS, LRHSINTR,
      &       W(PTRACB(STEP(INODE))), NCB, 1,
-     &       IW, LIW, KEEP, N, POSINRHSCOMP_BWD )
+     &       IW, LIW, KEEP, N, POSINRHSINTR_BWD )
              IFR8 = IFR8 + int(J2-KEEP(253)-J1+1,8)
            IF (KEEP(252).NE.0) THEN
              DO JJ = J2-KEEP(253)+1, J2
@@ -394,7 +394,7 @@ C
      &              PROCNODE_STEPS, PLEFTW, KEEP,KEEP8, DKEEP,
      &              PTRIST, PTRFAC, IW, LIW, A, LA, W2, MYLEAF_LEFT,
      &              NRHS, MTYPE,
-     &              RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &              RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &              PRUN_BELOW , TO_PROCESS, SIZE_TO_PROCESS
      &               , FROM_PP
      &               )
@@ -518,15 +518,15 @@ C
         PTWCB = PTRACB(STEP( INODE ))
       ENDIF
       IF (J2.GE.J1) THEN
-        IPOSINRHSCOMP = POSINRHSCOMP_BWD(IW(J1)) 
+        IPOSINRHSINTR = POSINRHSINTR_BWD(IW(J1)) 
       ELSE
-        IPOSINRHSCOMP = -99999
+        IPOSINRHSINTR = -99999
       ENDIF
       IF (J2.GE.J1) THEN
         DO K=JBDEB, JBFIN
             IF (KEEP(252).NE.0) THEN
               DO JJ = J1, J2
-                RHSCOMP(IPOSINRHSCOMP+JJ-J1,K) = ZERO
+                RHSINTR(IPOSINRHSINTR+JJ-J1,K) = ZERO
               ENDDO
             ENDIF
         END DO
@@ -541,9 +541,9 @@ C
           J2 = IPOS + LIELL
         END IF
         CALL ZMUMPS_SOL_BWD_GTHR( JBDEB, JBFIN, J1, J2,
-     &       RHSCOMP, NRHS, LRHSCOMP,
+     &       RHSINTR, NRHS, LRHSINTR,
      &       W(PTWCB), LIELL, NPIV+1,
-     &       IW, LIW, KEEP, N, POSINRHSCOMP_BWD )
+     &       IW, LIW, KEEP, N, POSINRHSINTR_BWD )
           IFR8 = IFR8 + int(J2-KEEP(253)-J1+1,8)
         IF (KEEP(252).NE.0) THEN
           DO JJ = J2-KEEP(253)+1, J2
@@ -603,7 +603,7 @@ C
             ENDIF
             LDAJ    = LIELL-BEG_PANEL+1 
             APOSDEB = APOSDEB - int(NBJ,8)*int(LDAJ,8)
-            IPOSINRHSCOMP_PANEL = IPOSINRHSCOMP + BEG_PANEL - 1
+            IPOSINRHSINTR_PANEL = IPOSINRHSINTR + BEG_PANEL - 1
             NCB_PANEL   = LDAJ - NBJ
             IF (KEEP(50).NE.1.AND.MUST_BE_PERMUTED) THEN
               CALL ZMUMPS_GET_OOC_PERM_PTR(TYPEF, TMP_NBPANELS,
@@ -625,24 +625,24 @@ C
                   IF (NCB_PANEL - NCB.NE. 0) THEN
                     CALL zgemv( 'T', NCB_PANEL-NCB, NBJ, ALPHA, 
      &              A( APOSDEB + int(NBJ,8) ), LDAJ,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL+NBJ,JBDEB),
+     &              RHSINTR(IPOSINRHSINTR_PANEL+NBJ,JBDEB),
      &              1, ONE,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), 1 )
+     &              RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), 1 )
                   ENDIF
                   IF (NCB .NE. 0) THEN
                     CALL zgemv( 'T', NCB, NBJ, ALPHA,
      &              A( APOSDEB + int(LDAJ-NCB,8) ), LDAJ,
      &              W( PTWCB  + int(NPIV,8) ),
      &              1, ONE,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), 1 )
+     &              RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), 1 )
                   ENDIF
               ENDIF
               IF (MTYPE.NE.1) THEN
                 CALL ztrsv('L','T','U', NBJ, A(APOSDEB), LDAJ,
-     &            RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), 1)
+     &            RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), 1)
               ELSE
                 CALL ztrsv('L','T','N', NBJ, A(APOSDEB), LDAJ,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), 1)
+     &              RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), 1)
               ENDIF
             ELSE
 #endif
@@ -651,24 +651,24 @@ C
                   CALL zgemm( 'T', 'N', NBJ, NRHS_B,
      &                                         NCB_PANEL-NCB, ALPHA,
      &              A(APOSDEB +int(NBJ,8)), LDAJ,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL+NBJ,JBDEB), LRHSCOMP,
-     &              ONE, RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), LRHSCOMP)
+     &              RHSINTR(IPOSINRHSINTR_PANEL+NBJ,JBDEB), LRHSINTR,
+     &              ONE, RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), LRHSINTR)
                   ENDIF
                   IF (NCB .NE. 0) THEN
                   CALL zgemm( 'T', 'N', NBJ, NRHS_B, NCB, ALPHA,
      &              A(APOSDEB +int(LDAJ-NCB,8)), LDAJ,
      &              W( PTWCB+int(NPIV,8) ), LIELL,
-     &              ONE, RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB),LRHSCOMP)
+     &              ONE, RHSINTR(IPOSINRHSINTR_PANEL,JBDEB),LRHSINTR)
                   ENDIF
               ENDIF
               IF (MTYPE.NE.1) THEN
                 CALL ztrsm('L','L','T','U',NBJ, NRHS_B, ONE,
      &          A(APOSDEB), 
-     &          LDAJ, RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), LRHSCOMP)
+     &          LDAJ, RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), LRHSINTR)
               ELSE
                 CALL ztrsm('L','L','T','N',NBJ, NRHS_B, ONE,
      &          A(APOSDEB),
-     &          LDAJ, RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), LRHSCOMP)
+     &          LDAJ, RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), LRHSINTR)
               ENDIF
 #if defined(MUMPS_USE_BLAS2)
             ENDIF
@@ -682,8 +682,8 @@ C
           CALL ZMUMPS_SOL_BWD_LR_SU (
      &           INODE, IWHDLR, NPIV, NSLAVES, 
      &           LIELL, W, LWC, NRHS_B, PTWCB,
-     &           RHSCOMP, LRHSCOMP, NRHS,
-     &           IPOSINRHSCOMP, JBDEB, 
+     &           RHSINTR, LRHSINTR, NRHS,
+     &           IPOSINRHSINTR, JBDEB, 
      &           MTYPE, KEEP, KEEP8,
      &           INFO(1), INFO(2) )
           IF (INFO(1).LT.0) THEN
@@ -699,13 +699,13 @@ C
                 CALL zgemv( 'T', NCB, NPIV, ALPHA, A(IST), LIELL,
      &                 W(PTWCB+int(NPIV,8)), 1,
      &                 ONE,
-     &                 RHSCOMP(IPOSINRHSCOMP,JBDEB), 1 )
+     &                 RHSINTR(IPOSINRHSINTR,JBDEB), 1 )
               ELSE
 #endif
                 CALL zgemm('T','N', NPIV, NRHS_B, NCB, ALPHA,
      &                 A(IST),
      &                 LIELL, W(PTWCB+int(NPIV,8)), LIELL, ONE,
-     &                 RHSCOMP(IPOSINRHSCOMP,JBDEB), LRHSCOMP)
+     &                 RHSINTR(IPOSINRHSINTR,JBDEB), LRHSINTR)
 #if defined(MUMPS_USE_BLAS2)
               ENDIF
 #endif
@@ -725,13 +725,13 @@ C
                  CALL zgemv( 'N', NPIV, NCB, ALPHA, A( IST ), NPIV,
      &                W( PTWCB + int(NPIV,8) ),
      &                1, ONE,
-     &                RHSCOMP(IPOSINRHSCOMP,JBDEB), 1 )
+     &                RHSINTR(IPOSINRHSINTR,JBDEB), 1 )
               ELSE
 #endif
                  CALL zgemm( 'N', 'N', NPIV, NRHS_B, NCB, ALPHA,
      &                A(IST),
      &                NPIV, W(PTWCB+int(NPIV,8)), LIELL,
-     &                ONE, RHSCOMP(IPOSINRHSCOMP,JBDEB), LRHSCOMP)
+     &                ONE, RHSINTR(IPOSINRHSINTR,JBDEB), LRHSINTR)
 #if defined(MUMPS_USE_BLAS2)
               END IF
 #endif
@@ -750,17 +750,17 @@ C
               ENDIF
             ENDIF
           END IF 
-          PPIV_COURANT = int(JBDEB-1,8)*int(LRHSCOMP,8)
-     &                 + int(IPOSINRHSCOMP,8)
+          PPIV_COURANT = int(JBDEB-1,8)*int(LRHSINTR,8)
+     &                 + int(IPOSINRHSINTR,8)
           IF (KEEP(459).GT.1 .AND. KEEP(50).NE.0) THEN
           CALL ZMUMPS_SOLVE_BWD_PANELS( A, LA, APOS,
      &      NPIV, IW(IPOS+1+LIELL),
-     &      NRHS_B, RHSCOMP(1,1), KEEP8(25), LRHSCOMP, PPIV_COURANT, 
+     &      NRHS_B, RHSINTR(1,1), KEEP8(25), LRHSINTR, PPIV_COURANT, 
      &      MTYPE, KEEP )
           ELSE
           CALL ZMUMPS_SOLVE_BWD_TRSOLVE( A, LA, APOS,
      &      NPIV, LDAJ,
-     &      NRHS_B, RHSCOMP(1,1), KEEP8(25), LRHSCOMP, PPIV_COURANT, 
+     &      NRHS_B, RHSINTR(1,1), KEEP8(25), LRHSINTR, PPIV_COURANT, 
      &      MTYPE, KEEP )
           ENDIF
         ENDIF  
@@ -770,7 +770,7 @@ C
       ELSE
         J1 = IPOS + 1
       END IF
-      IPOSINRHSCOMP =  POSINRHSCOMP_BWD(IW(J1)) 
+      IPOSINRHSINTR =  POSINRHSINTR_BWD(IW(J1)) 
   160 CONTINUE
       IF (KEEP(201).GT.0.AND.OOCWRITE_COMPATIBLE_WITH_BLR) THEN
          CALL ZMUMPS_FREE_FACTORS_FOR_SOLVE(INODE,PTRFAC,KEEP(28),
@@ -876,8 +876,8 @@ C
      &          LIELL, LIELL - KEEP(253),
      &          IW( POSINDICES ),
      &          W( PTRACB(STEP(INODE)) ), JBDEB, JBFIN,
-     &          RHSCOMP(1, 1), NRHS, LRHSCOMP,
-     &          IPOSINRHSCOMP, NPIV,
+     &          RHSINTR(1, 1), NRHS, LRHSINTR,
+     &          IPOSINRHSINTR, NPIV,
      &          KEEP, PROCDEST, NOEUD, COMM, IERR )
               IF ( IERR .EQ. -1 ) THEN
                 CALL ZMUMPS_BACKSLV_RECV_AND_TREAT(
@@ -892,7 +892,7 @@ C
      &          PLEFTW, KEEP, KEEP8, DKEEP,
      &          PTRIST, PTRFAC, IW, LIW, A, LA, W2, MYLEAF_LEFT,
      &          NRHS, MTYPE, 
-     &          RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &          RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &          PRUN_BELOW, TO_PROCESS, SIZE_TO_PROCESS
      &            , FROM_PP
      &            )
@@ -960,7 +960,7 @@ C
      &     PLEFTW, KEEP, KEEP8, DKEEP,
      &     PTRIST, PTRFAC, IW, LIW, A, LA, W2, MYLEAF_LEFT, 
      &     NRHS, MTYPE,
-     &     RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &     RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &     PRUN_BELOW, TO_PROCESS, SIZE_TO_PROCESS
      &     , FROM_PP
      &    )
@@ -992,8 +992,8 @@ C
       COMPLEX(kind=8) A( LA ), W2( KEEP(133) )
       INTEGER NRHS
       INTEGER MYLEAF_LEFT, MTYPE
-      INTEGER LRHSCOMP, POSINRHSCOMP_BWD(N)
-      COMPLEX(kind=8) RHSCOMP(LRHSCOMP,NRHS)
+      INTEGER LRHSINTR, POSINRHSINTR_BWD(N)
+      COMPLEX(kind=8) RHSINTR(LRHSINTR,NRHS)
       LOGICAL, INTENT(IN) :: PRUN_BELOW
       INTEGER SIZE_TO_PROCESS
       LOGICAL TO_PROCESS(SIZE_TO_PROCESS)
@@ -1037,7 +1037,7 @@ C
      &                KEEP, KEEP8, DKEEP,
      &                PTRIST, PTRFAC, IW, LIW, A, LA, W2, MYLEAF_LEFT, 
      &                NRHS, MTYPE, 
-     &                RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &                RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &               PRUN_BELOW, TO_PROCESS, SIZE_TO_PROCESS
      &               , FROM_PP
      &          )
@@ -1057,7 +1057,7 @@ C
      &                KEEP, KEEP8, DKEEP,
      &                PTRIST, PTRFAC, IW, LIW, A, LA, W2, MYLEAF_LEFT, 
      &                NRHS, MTYPE, 
-     &                RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &                RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &                PRUN_BELOW, TO_PROCESS, SIZE_TO_PROCESS
      &               , FROM_PP
      &           )
@@ -1093,8 +1093,8 @@ C
       COMPLEX(kind=8) A( LA ), W2( KEEP(133) )
       INTEGER NRHS
       INTEGER MYLEAF_LEFT, MTYPE
-      INTEGER LRHSCOMP, POSINRHSCOMP_BWD(N)
-      COMPLEX(kind=8) RHSCOMP(LRHSCOMP,NRHS)
+      INTEGER LRHSINTR, POSINRHSINTR_BWD(N)
+      COMPLEX(kind=8) RHSINTR(LRHSINTR,NRHS)
       LOGICAL, INTENT(IN) :: PRUN_BELOW
       INTEGER  SIZE_TO_PROCESS
       LOGICAL TO_PROCESS(SIZE_TO_PROCESS), NO_CHILDREN
@@ -1108,7 +1108,7 @@ C
       INTEGER(8) :: IFR8
       INTEGER I, JJ, IN, PROCDEST, J1, J2, LDA
       INTEGER NSLAVES, NELIM, J, POSINDICES, INODEPOS,
-     &     IPOSINRHSCOMP, IPOSINRHSCOMP_PANEL
+     &     IPOSINRHSINTR, IPOSINRHSINTR_PANEL
       INTEGER JBDEB, JBFIN, NRHS_B, allocok
       INTEGER(8) :: P_UPDATE, P_SOL_MAS         
       INTEGER :: IWHDLR, MTYPE_SLAVE, LDA_SLAVE 
@@ -1190,11 +1190,11 @@ C
      &           W(POSWCB + 1), LONG, 
      &           MPI_DOUBLE_COMPLEX, COMM, IERR)
               DO JJ=0, LONG-1
-                IPOSINRHSCOMP = abs( POSINRHSCOMP_BWD( IWCB(
+                IPOSINRHSINTR = abs( POSINRHSINTR_BWD( IWCB(
      &                                    POSIWCB+1+JJ ) ) )
-                IF ( (IPOSINRHSCOMP.EQ.0) .OR.
-     &            ( IPOSINRHSCOMP.GT.N ) ) CYCLE  
-                RHSCOMP(IPOSINRHSCOMP,K) = W(POSWCB+1+JJ)
+                IF ( (IPOSINRHSINTR.EQ.0) .OR.
+     &            ( IPOSINRHSINTR.GT.N ) ) CYCLE  
+                RHSINTR(IPOSINRHSINTR,K) = W(POSWCB+1+JJ)
               ENDDO
             ENDDO
             POSIWCB = POSIWCB + LONG
@@ -1346,7 +1346,7 @@ C
      &     KEEP, KEEP8, DKEEP,
      &     PTRIST, PTRFAC, IW, LIW, A, LA, W2, MYLEAF_LEFT,
      &     NRHS, MTYPE,
-     &     RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &     RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &     PRUN_BELOW, TO_PROCESS, SIZE_TO_PROCESS
      &      , FROM_PP
      &      )
@@ -1400,7 +1400,7 @@ C
         J1 = IPOS + 1
         J2 = IPOS + NPIV
       ENDIF
-        IPOSINRHSCOMP =  POSINRHSCOMP_BWD(IW(J1)) 
+        IPOSINRHSINTR =  POSINRHSINTR_BWD(IW(J1)) 
         DO K=JBDEB, JBFIN
           CALL MPI_UNPACK( BUFR, LBUFR_BYTES, POSITION,
      &                     W2, NPIV, MPI_DOUBLE_COMPLEX,
@@ -1410,13 +1410,13 @@ C
      &         (IW(PTRIST(STEP(INODE))+XXS).EQ.C_FINI+NSLAVES) 
      &       ) THEN
           DO JJ = J1,J2   
-            RHSCOMP(IPOSINRHSCOMP+JJ-J1,K) = W2(I)
+            RHSINTR(IPOSINRHSINTR+JJ-J1,K) = W2(I)
             I = I+1
           ENDDO
          ELSE
           DO JJ = J1,J2   
-            RHSCOMP(IPOSINRHSCOMP+JJ-J1,K) = 
-     &      RHSCOMP(IPOSINRHSCOMP+JJ-J1,K) + W2(I)
+            RHSINTR(IPOSINRHSINTR+JJ-J1,K) = 
+     &      RHSINTR(IPOSINRHSINTR+JJ-J1,K) + W2(I)
             I = I+1
           ENDDO
          ENDIF
@@ -1482,7 +1482,7 @@ C
            POSINDICES = IPOS + 1
         END IF
         PTWCB = PTRACB(STEP( INODE ))
-        IPOSINRHSCOMP =  POSINRHSCOMP_BWD(IW(J1)) 
+        IPOSINRHSINTR =  POSINRHSINTR_BWD(IW(J1)) 
         IFR8 = PTRACB(STEP( INODE ))
       IFR8   = PTWCB + int(NPIV - 1,8)
         IF ( MTYPE .EQ. 1 .AND. KEEP(50).EQ.0 ) THEN
@@ -1493,9 +1493,9 @@ C
           J2 = IPOS + LIELL
         END IF
         CALL ZMUMPS_SOL_BWD_GTHR( JBDEB, JBFIN, J1, J2,
-     &       RHSCOMP, NRHS, LRHSCOMP,
+     &       RHSINTR, NRHS, LRHSINTR,
      &       W(PTWCB), LIELL, NPIV+1,
-     &       IW, LIW, KEEP, N, POSINRHSCOMP_BWD )
+     &       IW, LIW, KEEP, N, POSINRHSINTR_BWD )
           IFR8 = IFR8 + int(J2-KEEP(253)-J1+1,8)
       IF ( KEEP(201).EQ.1 .AND. OOCWRITE_COMPATIBLE_WITH_BLR .AND.
      &    (( NELIM .GT. 0 ).OR. (MTYPE.NE.1 )))  THEN
@@ -1540,7 +1540,7 @@ C
             LDAJ    = NROW_L-BEG_PANEL+1 
             APOSDEB = APOSDEB - int(NBJ,8)*int(LDAJ,8)
             PTWCB   = PTRACB(STEP(INODE))
-            IPOSINRHSCOMP_PANEL = IPOSINRHSCOMP + BEG_PANEL - 1
+            IPOSINRHSINTR_PANEL = IPOSINRHSINTR + BEG_PANEL - 1
             NCB_PANEL   = LDAJ - NBJ
             NCB     = NROW_L - NPIV
             IF (KEEP(50).NE.1 .AND.MUST_BE_PERMUTED) THEN
@@ -1559,24 +1559,24 @@ C
                   IF (NCB_PANEL - NCB.NE. 0) THEN
                     CALL zgemv( 'T', NCB_PANEL-NCB, NBJ, ALPHA, 
      &              A( APOSDEB + int(NBJ,8) ), LDAJ,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL+NBJ,JBDEB),
+     &              RHSINTR(IPOSINRHSINTR_PANEL+NBJ,JBDEB),
      &              1, ONE,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), 1 )
+     &              RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), 1 )
                   ENDIF
                   IF (NCB .NE. 0) THEN
                     CALL zgemv( 'T', NCB, NBJ, ALPHA,
      &              A( APOSDEB + int(LDAJ-NCB,8) ), LDAJ,
      &              W( PTWCB  + int(NPIV,8) ),
      &              1, ONE,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), 1 )
+     &              RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), 1 )
                   ENDIF
               ENDIF
               IF (MTYPE.NE.1) THEN
                 CALL ztrsv('L','T','U', NBJ, A(APOSDEB), LDAJ,
-     &            RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), 1)
+     &            RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), 1)
               ELSE
                 CALL ztrsv('L','T','N', NBJ, A(APOSDEB), LDAJ,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), 1)
+     &              RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), 1)
               ENDIF
             ELSE
 #endif
@@ -1585,24 +1585,24 @@ C
                   CALL zgemm( 'T', 'N', NBJ, NRHS_B,
      &                                         NCB_PANEL-NCB, ALPHA,
      &              A(APOSDEB +int(NBJ,8)), LDAJ,
-     &              RHSCOMP(IPOSINRHSCOMP_PANEL+NBJ,JBDEB), LRHSCOMP,
-     &              ONE, RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), LRHSCOMP)
+     &              RHSINTR(IPOSINRHSINTR_PANEL+NBJ,JBDEB), LRHSINTR,
+     &              ONE, RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), LRHSINTR)
                   ENDIF
                   IF (NCB .NE. 0) THEN
                   CALL zgemm( 'T', 'N', NBJ, NRHS_B, NCB, ALPHA,
      &              A(APOSDEB +int(LDAJ-NCB,8)), LDAJ,
      &              W( PTWCB+int(NPIV,8) ), LIELL,
-     &              ONE, RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB),LRHSCOMP)
+     &              ONE, RHSINTR(IPOSINRHSINTR_PANEL,JBDEB),LRHSINTR)
                   ENDIF
               ENDIF
               IF (MTYPE.NE.1) THEN
                 CALL ztrsm('L','L','T','U',NBJ, NRHS_B, ONE,
      &          A(APOSDEB), 
-     &          LDAJ, RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), LRHSCOMP)
+     &          LDAJ, RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), LRHSINTR)
               ELSE
                 CALL ztrsm('L','L','T','N',NBJ, NRHS_B, ONE,
      &          A(APOSDEB),
-     &          LDAJ, RHSCOMP(IPOSINRHSCOMP_PANEL,JBDEB), LRHSCOMP)
+     &          LDAJ, RHSINTR(IPOSINRHSINTR_PANEL,JBDEB), LRHSINTR)
               ENDIF
 #if defined(MUMPS_USE_BLAS2)
             ENDIF
@@ -1617,8 +1617,8 @@ C
           CALL ZMUMPS_SOL_BWD_LR_SU (
      &           INODE, IWHDLR, NPIV, NSLAVES,
      &           LIELL, W, LWC, NRHS_B, PTRACB(STEP(INODE)), 
-     &           RHSCOMP, LRHSCOMP, NRHS,
-     &           IPOSINRHSCOMP, JBDEB, 
+     &           RHSINTR, LRHSINTR, NRHS,
+     &           IPOSINRHSINTR, JBDEB, 
      &           MTYPE, KEEP, KEEP8,
      &           INFO(1), INFO(2) )
         ELSE
@@ -1638,27 +1638,27 @@ C
                  CALL zgemv( 'N', NPIV, NELIM, ALPHA, A( IST ), NPIV,
      &                 W( NPIV + PTRACB(STEP(INODE)) ),
      &                 1, ONE,
-     &                 RHSCOMP(IPOSINRHSCOMP,JBDEB), 1 )
+     &                 RHSINTR(IPOSINRHSINTR,JBDEB), 1 )
               ELSE
 #endif
                  CALL zgemm( 'N', 'N', NPIV, NRHS_B, NELIM, ALPHA,
      &                A(IST), NPIV, W(NPIV+PTRACB(STEP(INODE))), LIELL,
-     &                ONE, RHSCOMP(IPOSINRHSCOMP,JBDEB), LRHSCOMP)
+     &                ONE, RHSINTR(IPOSINRHSINTR,JBDEB), LRHSINTR)
 #if defined(MUMPS_USE_BLAS2)
               END IF
 #endif
           ENDIF 
-          PPIV_COURANT = int(JBDEB-1,8)*int(LRHSCOMP,8)
-     &                 + int(IPOSINRHSCOMP,8)
+          PPIV_COURANT = int(JBDEB-1,8)*int(LRHSINTR,8)
+     &                 + int(IPOSINRHSINTR,8)
           IF (KEEP(459).GT.1 .AND. KEEP(50).NE.0) THEN
           CALL ZMUMPS_SOLVE_BWD_PANELS( A, LA, APOS,
      &      NPIV, IW(IPOS+1+LIELL),
-     &      NRHS_B, RHSCOMP(1,1), KEEP8(25), LRHSCOMP, PPIV_COURANT, 
+     &      NRHS_B, RHSINTR(1,1), KEEP8(25), LRHSINTR, PPIV_COURANT, 
      &      MTYPE, KEEP )
           ELSE
           CALL ZMUMPS_SOLVE_BWD_TRSOLVE( A, LA, APOS,
      &      NPIV, LDA,
-     &      NRHS_B, RHSCOMP(1,1), KEEP8(25), LRHSCOMP, PPIV_COURANT, 
+     &      NRHS_B, RHSINTR(1,1), KEEP8(25), LRHSINTR, PPIV_COURANT, 
      &      MTYPE, KEEP )
           ENDIF
        ENDIF
@@ -1673,7 +1673,7 @@ C
            ENDIF
           ENDIF
           IPOS =   PTRIST(STEP(INODE)) +  KEEP(IXSZ) + 6 + NSLAVES
-          IPOSINRHSCOMP     = POSINRHSCOMP_BWD(IW(IPOS))
+          IPOSINRHSINTR     = POSINRHSINTR_BWD(IW(IPOS))
           IN = INODE
   170     IN = FILS(IN)
           IF (IN .GT. 0) GOTO 170
@@ -1734,8 +1734,8 @@ C
      &          LIELL, LIELL - KEEP(253),
      &          IW( POSINDICES ),
      &          W( PTRACB(STEP(INODE)) ), JBDEB, JBFIN,
-     &          RHSCOMP(1, 1), NRHS, LRHSCOMP,
-     &          IPOSINRHSCOMP, NPIV,
+     &          RHSINTR(1, 1), NRHS, LRHSINTR,
+     &          IPOSINRHSINTR, NPIV,
      &          KEEP, PROCDEST, NOEUD, COMM, IERR )
               IF ( IERR .EQ. -1 ) THEN
                 CALL ZMUMPS_BACKSLV_RECV_AND_TREAT(
@@ -1750,7 +1750,7 @@ C
      &          PLEFTW, KEEP, KEEP8, DKEEP,
      &          PTRIST, PTRFAC, IW, LIW, A, LA, W2, MYLEAF_LEFT,
      &          NRHS, MTYPE, 
-     &          RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &          RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &          PRUN_BELOW, TO_PROCESS, SIZE_TO_PROCESS
      &            , FROM_PP
      &            )
diff -pruN 5.6.2-2.1/src/zsol_c.F 5.7.1-1/src/zsol_c.F
--- 5.6.2-2.1/src/zsol_c.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zsol_c.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -18,11 +18,16 @@ C
      & COMM_NODES, MYID, MYID_NODES, BUFR, LBUFR, LBUFR_BYTES,
      & ISTEP_TO_INIV2, TAB_POS_IN_PERE, IBEG_ROOT_DEF, IEND_ROOT_DEF,
      & IROOT_DEF_RHS_COL1, RHS_ROOT, LRHS_ROOT, SIZE_ROOT, MASTER_ROOT,
-     & RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD, POSINRHSCOMP_BWD,
+     & RHSINTR, LRHSINTR, POSINRHSINTR_FWD, POSINRHSINTR_BWD,
+     &           Lnodes_FWD, Lnodes_BWD,
+     &           nodes_FWD, nodes_BWD,
      & NZ_RHS, NBCOL_INBLOC, NRHS_ORIG, JBEG_RHS, Step2node, LStep2node,
      & IRHS_SPARSE, IRHS_PTR, SIZE_PERM_RHS, PERM_RHS,
-     & SIZE_UNS_PERM_INV, UNS_PERM_INV, NB_FS_IN_RHSCOMP_F,
-     & NB_FS_IN_RHSCOMP_TOT, DO_NBSPARSE , RHS_BOUNDS, LRHS_BOUNDS
+     & SIZE_UNS_PERM_INV, UNS_PERM_INV, NB_FS_IN_RHSINTR_F,
+     & NB_FS_IN_RHSINTR_TOT, DO_NBSPARSE , RHS_BOUNDS, LRHS_BOUNDS
+#if defined(STAT_ES_SOLVE)
+     & , IPTR_WORKING, SIZE_IPTR_WORKING, WORKING, SIZE_WORKING
+#endif
      &  ,IPOOL_B_L0_OMP, LPOOL_B_L0_OMP, IPOOL_A_L0_OMP, LPOOL_A_L0_OMP,
      &  L_VIRT_L0_OMP, VIRT_L0_OMP, L_PHYS_L0_OMP, PHYS_L0_OMP,
      &  PERM_L0_OMP, PTR_LEAFS_L0_OMP, L0_OMP_MAPPING, LL0_OMP_MAPPING,
@@ -51,22 +56,26 @@ C
       INTEGER(8) ::  PTRFAC(KEEP(28))
       INTEGER    ::  LIWK_PTRACB
       INTEGER(8) ::  PTRACB(LIWK_PTRACB)
-      INTEGER NRHS, LRHSCOMP, NB_FS_IN_RHSCOMP_F, NB_FS_IN_RHSCOMP_TOT
+      INTEGER NRHS, LRHSINTR, NB_FS_IN_RHSINTR_F, NB_FS_IN_RHSINTR_TOT
       COMPLEX(kind=8)    A(LA), W(LWC), 
      &        W2(KEEP(133))
-      COMPLEX(kind=8) ::  RHSCOMP(LRHSCOMP,NRHS)
+      COMPLEX(kind=8) ::  RHSINTR(LRHSINTR,NRHS)
       INTEGER SLAVEF, COMM_NODES, MYID, MYID_NODES
-      INTEGER PROCNODE_STEPS(KEEP(28)), POSINRHSCOMP_FWD(N), 
-     &        POSINRHSCOMP_BWD(N)
+      INTEGER PROCNODE_STEPS(KEEP(28)), POSINRHSINTR_FWD(N), 
+     &        POSINRHSINTR_BWD(N)
       INTEGER LBUFR, LBUFR_BYTES
       INTEGER BUFR(LBUFR)
       INTEGER ISTEP_TO_INIV2(KEEP(71)), 
      &        TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
       INTEGER IBEG_ROOT_DEF, IEND_ROOT_DEF, IROOT_DEF_RHS_COL1
+      INTEGER NRHS_LOC
       INTEGER SIZE_ROOT, MASTER_ROOT
       INTEGER(8) :: LRHS_ROOT
       COMPLEX(kind=8) RHS_ROOT(LRHS_ROOT)
       LOGICAL, intent(in) :: FROM_PP 
+      INTEGER, intent(in) :: Lnodes_FWD, Lnodes_BWD
+      INTEGER, intent(in) :: nodes_FWD(max(1,Lnodes_FWD)), 
+     &                       nodes_BWD(max(1,Lnodes_BWD))
       INTEGER, intent(in)      :: NZ_RHS, NBCOL_INBLOC, NRHS_ORIG
       INTEGER, intent(in)      :: SIZE_UNS_PERM_INV 
       INTEGER, intent(in)      :: SIZE_PERM_RHS 
@@ -80,6 +89,11 @@ C
       LOGICAL, intent(in)  :: DO_NBSPARSE  
       INTEGER, intent(in)     :: LRHS_BOUNDS
       INTEGER, intent(inout)  :: RHS_BOUNDS (LRHS_BOUNDS) 
+#if defined(STAT_ES_SOLVE)
+       INTEGER, INTENT(IN) :: SIZE_WORKING, SIZE_IPTR_WORKING,
+     &                        IPTR_WORKING(SIZE_IPTR_WORKING),
+     &                        WORKING(SIZE_WORKING)
+#endif
       INTEGER, INTENT (IN) :: LPOOL_B_L0_OMP
       INTEGER, INTENT (IN) :: IPOOL_B_L0_OMP( LPOOL_B_L0_OMP )
       INTEGER, INTENT (IN) :: LPOOL_A_L0_OMP
@@ -103,6 +117,7 @@ C
       INTEGER NSTK_S,IPOOL,IPANEL_POS,PTRICB
       INTEGER MTYPE_LOC
       INTEGER MODE_RHS_BOUNDS 
+      INTEGER IPT_RHS_ROOT_LOC
       INTEGER IERR
       INTEGER(8) :: IAPOS
       INTEGER       IOLDPS,
@@ -116,26 +131,28 @@ C
       LOGICAL I_WORKED_ON_ROOT, SPECIAL_ROOT_REACHED
       INTEGER IROOT
       LOGICAL DOROOT_FWD_OOC, DOROOT_BWD_PANEL
-      LOGICAL SWITCH_OFF_ES
       LOGICAL DUMMY_BOOL
       INTEGER :: IDUMMY
       INTEGER :: NBROOT_UNDER_L0
       COMPLEX(kind=8), PARAMETER :: ZERO = (0.0D0,0.0D0)
       INCLUDE 'mumps_headers.h'
-      INTEGER, DIMENSION(:), ALLOCATABLE ::  nodes_RHS
-      INTEGER nb_nodes_RHS
+      INTEGER, DIMENSION(:), POINTER             ::  nodes_BWD_PTR
+      INTEGER, DIMENSION(:), ALLOCATABLE, TARGET :: Pruned_Roots_FWD
+      INTEGER, DIMENSION(:), ALLOCATABLE, TARGET :: Pruned_Roots_NS
+      INTEGER  :: Lnodes_BWD_PTR, LPruned_Roots_NS
+      INTEGER :: Lnodes_BWD_ROOTS
       INTEGER nb_prun_leaves
       INTEGER, DIMENSION(:), ALLOCATABLE :: Pruned_Leaves
       INTEGER, DIMENSION(:), ALLOCATABLE ::  Pruned_List
       INTEGER  nb_prun_nodes
-      INTEGER nb_prun_roots, JAM1
+      INTEGER INODE_PRINC, nb_prun_roots
       INTEGER, DIMENSION(:), ALLOCATABLE ::  Pruned_SONS, Pruned_Roots
       INTEGER                            :: SIZE_TO_PROCESS
       LOGICAL, DIMENSION(:), ALLOCATABLE :: TO_PROCESS
-      INTEGER ISTEP, INODE_PRINC
+      INTEGER ISTEP
       INTEGER :: INODE, ICHILD
-      LOGICAL AM1, DO_PRUN
-      LOGICAL Exploit_Sparsity
+      LOGICAL AM1, DO_PRUN_FWD, DO_PRUN_BWD
+      LOGICAL Exploit_Sparsity_FWD, Exploit_Sparsity_BWD
       LOGICAL DO_NBSPARSE_BWD, PRUN_BELOW_BWD
       INTEGER :: OOC_FCT_TYPE_TMP
       INTEGER :: MUMPS_OOC_GET_FCT_TYPE
@@ -179,7 +196,6 @@ C
       DOFORWARD = .TRUE.
       DOBACKWARD= .TRUE.
       SPECIAL_ROOT_REACHED = .TRUE.
-      SWITCH_OFF_ES    = .FALSE.
       IF ( KEEP(111).NE.0 .OR. KEEP(252).NE.0 ) THEN
         DOFORWARD = .FALSE.
       ENDIF
@@ -202,23 +218,28 @@ C
      &                     .AND. KEEP(201).EQ.1
       DOROOT_FWD_OOC = DOROOT .AND. .NOT.DOROOT_BWD_PANEL
       AM1              = (KEEP(237) .NE. 0)
-      Exploit_Sparsity = (KEEP(235) .NE. 0) .AND. (.NOT. AM1)
-      DO_PRUN          = (Exploit_Sparsity.OR.AM1)
+      Exploit_Sparsity_FWD  = (KEEP(235) .NE. 0) .AND. (.NOT. AM1)
+      Exploit_Sparsity_BWD  = (KEEP(212) .NE. 0) .AND. (.NOT. AM1)
+      Lnodes_BWD_ROOTS = NA(2)
+      DO_PRUN_FWD          = (Exploit_Sparsity_FWD.OR.AM1)
+      DO_PRUN_BWD          = (Exploit_Sparsity_BWD.OR.AM1)
       IF (FROM_PP) THEN
-        Exploit_Sparsity = .FALSE.
-        DO_PRUN          = .FALSE.
+        Exploit_Sparsity_FWD = .FALSE.
+        DO_PRUN_FWD          = .FALSE.
+        Exploit_Sparsity_BWD = .FALSE.
+        DO_PRUN_BWD          = .FALSE.
            IF ( AM1 ) THEN
           WRITE(*,*) "Internal error 2 in ZMUMPS_SOL_C"
           CALL MUMPS_ABORT()
         ENDIF
       ENDIF
-      DO_L0OMP_FWD= ( (KEEP(401).GT.0).AND.(KEEP(400).GT.0)
+      DO_L0OMP_FWD= ( (KEEP(401).EQ.1).AND.(KEEP(400).GT.0)
      &             .AND.DOFORWARD )
       DO_L0OMP_FWD = DO_L0OMP_FWD .AND. KEEP(201).EQ.0
-      DO_L0OMP_BWD = ( (KEEP(401).GT.0).AND.(KEEP(400).GT.0)
+      DO_L0OMP_BWD = ( (KEEP(401).EQ.1).AND.(KEEP(400).GT.0)
      &              .AND.DOBACKWARD )
       DO_L0OMP_BWD = DO_L0OMP_BWD .AND. KEEP(201).EQ.0
-      IF ( DO_PRUN ) THEN
+      IF ( DO_PRUN_FWD.OR.DO_PRUN_BWD ) THEN
          ALLOCATE (Pruned_SONS(KEEP(28)), stat=I)
          IF(I.GT.0) THEN
                INFO(1)=-13
@@ -227,7 +248,7 @@ C
          CALL MUMPS_PROPINFO(ICNTL, INFO, COMM_NODES, MYID )
          IF(INFO(1).LT.0) GOTO 500
       ENDIF
-      IF ( DO_PRUN 
+      IF ( DO_PRUN_FWD.OR.DO_PRUN_BWD
      &     .OR. DO_L0OMP_BWD
      &   ) THEN
          SIZE_TO_PROCESS = KEEP(28)
@@ -241,84 +262,12 @@ C
       END IF
       CALL MUMPS_PROPINFO(ICNTL, INFO, COMM_NODES, MYID )
       IF(INFO(1).LT.0) GOTO 500
-      IF ( DOFORWARD .AND. DO_PRUN ) THEN
-         nb_prun_nodes = 0
-         nb_prun_roots = 0
-         Pruned_SONS(:) = -1
-         IF ( Exploit_Sparsity ) THEN
-            nb_nodes_RHS = 0
-            DO I = 1, NZ_RHS
-               ISTEP       = abs( STEP(IRHS_SPARSE(I)) )
-               INODE_PRINC = Step2node( ISTEP )
-               IF ( Pruned_SONS(ISTEP) .eq. -1) THEN
-                  nb_nodes_RHS = nb_nodes_RHS +1
-                  Pruned_SONS(ISTEP) = 0 
-               ENDIF
-            ENDDO
-            ALLOCATE(nodes_RHS(nb_nodes_RHS), STAT = allocok)
-            IF(allocok.GT.0) THEN
-              INFO(1)=-13
-              INFO(2)=nb_nodes_RHS
-            END IF
-            CALL MUMPS_PROPINFO(ICNTL, INFO, COMM_NODES, MYID )
-            IF(INFO(1).LT.0) GOTO 500
-            nb_nodes_RHS = 0
-            Pruned_SONS = -1
-            DO I = 1, NZ_RHS
-               ISTEP       = abs( STEP(IRHS_SPARSE(I)) )
-               INODE_PRINC = Step2node( ISTEP )
-               IF ( Pruned_SONS(ISTEP) .eq. -1) THEN
-                  nb_nodes_RHS = nb_nodes_RHS +1
-                  nodes_RHS(nb_nodes_RHS)  = INODE_PRINC
-                  Pruned_SONS(ISTEP) = 0 
-               ENDIF
-            ENDDO
-         ELSE IF ( AM1 ) THEN  
-            nb_nodes_RHS = 0
-            DO I = 1, NBCOL_INBLOC
-              IF ( (IRHS_PTR(I+1)-IRHS_PTR(I)).EQ.0) CYCLE
-              IF ( (KEEP(242) .NE. 0 ).OR. (KEEP(243).NE.0) ) THEN
-                   JAM1 = PERM_RHS(JBEG_RHS+I-1)
-              ELSE
-                   JAM1 = JBEG_RHS+I-1
-              ENDIF       
-              ISTEP = abs(STEP(JAM1))
-              INODE_PRINC = Step2node(ISTEP)
-              IF ( Pruned_SONS(ISTEP) .eq. -1) THEN
-                 nb_nodes_RHS = nb_nodes_RHS +1
-                 Pruned_SONS(ISTEP) = 0                 
-              ENDIF
-            ENDDO
-            ALLOCATE(nodes_RHS(nb_nodes_RHS), STAT = allocok)
-            IF(allocok.GT.0) THEN
-               INFO(1)=-13
-               INFO(2)=nb_nodes_RHS
-            END IF
-            CALL MUMPS_PROPINFO(ICNTL, INFO, COMM_NODES, MYID )
-            IF(INFO(1).LT.0) GOTO 500
-            nb_nodes_RHS = 0
-            Pruned_SONS = -1
-            DO I = 1, NBCOL_INBLOC
-              IF ( (IRHS_PTR(I+1)-IRHS_PTR(I)).EQ.0) CYCLE
-              IF ( (KEEP(242) .NE. 0 ).OR. (KEEP(243).NE.0) ) THEN
-                   JAM1 = PERM_RHS(JBEG_RHS+I-1)
-              ELSE
-                   JAM1 = JBEG_RHS+I-1
-              ENDIF
-              ISTEP = abs(STEP(JAM1))
-              INODE_PRINC = Step2node(ISTEP)
-              IF ( Pruned_SONS(ISTEP) .eq. -1) THEN
-                 nb_nodes_RHS = nb_nodes_RHS +1
-                 nodes_RHS(nb_nodes_RHS)  = INODE_PRINC
-                 Pruned_SONS(ISTEP) = 0
-              ENDIF
-            ENDDO            
-         ENDIF                  
+      IF ( DOFORWARD .AND. DO_PRUN_FWD ) THEN
          CALL ZMUMPS_CHAIN_PRUN_NODES( 
      &        .FALSE.,
      &        DAD, KEEP(28),
      &        STEP, N,
-     &        nodes_RHS, nb_nodes_RHS,
+     &        nodes_FWD, Lnodes_FWD,
      &        Pruned_SONS, TO_PROCESS,
      &        nb_prun_nodes, nb_prun_roots,
      &        nb_prun_leaves )  
@@ -347,11 +296,10 @@ C
      &        .TRUE.,
      &        DAD, KEEP(28),
      &        STEP, N,
-     &        nodes_RHS, nb_nodes_RHS,
+     &        nodes_FWD, Lnodes_FWD,
      &        Pruned_SONS, TO_PROCESS,
      &        nb_prun_nodes, nb_prun_roots, nb_prun_leaves,
      &        Pruned_List, Pruned_Roots, Pruned_Leaves )
-         IF(allocated(nodes_RHS)) DEALLOCATE(nodes_RHS)
          CALL ZMUMPS_OOC_SET_STATES_ES(N,
      &          KEEP(201), Pruned_List, nb_prun_nodes,
      &          STEP)
@@ -365,11 +313,15 @@ C
      &        MYID_NODES, N, KEEP(28), KEEP(201), KEEP(485), 
      &        KEEP8(31)+KEEP8(64), 
      &        STEP, Pruned_List, nb_prun_nodes, OOC_FCT_TYPE_TMP
+#if defined(STAT_ES_SOLVE)
+     &        , NRHS, COMM_NODES, IW, LIW, PTRIST,KEEP(IXSZ),0,
+     &        KEEP(50), KEEP(38)
+#endif
      &   )
          IF (DO_NBSPARSE) THEN
            nb_sparse = max(1,KEEP(497))
            MODE_RHS_BOUNDS = 0 
-           IF (Exploit_Sparsity) MODE_RHS_BOUNDS = 2
+           IF (Exploit_Sparsity_FWD) MODE_RHS_BOUNDS = 2
            CALL ZMUMPS_INITIALIZE_RHS_BOUNDS(
      &      STEP, N,
      &      IRHS_PTR, NBCOL_INBLOC, IRHS_SPARSE, NZ_RHS,
@@ -383,6 +335,10 @@ C
      &      STEP, N, Pruned_SONS,
      &      DAD, RHS_BOUNDS, KEEP(28),
      &      MYID_NODES, COMM_NODES, KEEP(485),
+#if defined(STAT_ES_SOLVE)
+     &      KEEP(46), 
+     &      IPTR_WORKING, SIZE_IPTR_WORKING, WORKING, SIZE_WORKING,
+#endif
      &      IW, LIW, PTRIST,KEEP(IXSZ),OOC_FCT_TYPE_TMP,0,
      &      KEEP(50), KEEP(38))
          END IF
@@ -416,7 +372,7 @@ C
 #if defined(V_T)
         CALL VTBEGIN(forw_soln,ierr)
 #endif
-        IF ( .NOT. DO_PRUN ) THEN
+        IF ( .NOT. DO_PRUN_FWD ) THEN
           CALL MUMPS_INIT_NROOT_DIST(N, NBROOT, MYROOT, MYID_NODES,
      &           SLAVEF, NA, LNA, KEEP, STEP, PROCNODE_STEPS)
           DO ISTEP =1, KEEP(28)
@@ -427,12 +383,20 @@ C
      &         nb_prun_roots, Pruned_Roots,
      &         MYROOT, MYID_NODES, SLAVEF, KEEP, STEP,
      &         PROCNODE_STEPS )
-          IF (AM1) THEN 
+          IF ((Exploit_Sparsity_FWD).AND.(nb_prun_roots.NE.NA(2))) THEN
+             Lnodes_BWD_ROOTS = nb_prun_roots
+            ALLOCATE(Pruned_Roots_FWD(Lnodes_BWD_ROOTS), STAT=allocok)
+            IF(allocok.GT.0) THEN
+              WRITE(*,*)'Problem with allocation of nodes_FWD'
+              INFO(1) = -13
+              INFO(2) = Lnodes_BWD_ROOTS
+              CALL MUMPS_ABORT()
+            END IF
+            Pruned_Roots_FWD(1:Lnodes_BWD_ROOTS)=
+     &                        Pruned_Roots(1:Lnodes_BWD_ROOTS)
             DEALLOCATE(Pruned_Roots)
-          END IF
-          IF ((Exploit_Sparsity).AND.(nb_prun_roots.EQ.NA(2))) THEN
+          ELSE
             DEALLOCATE(Pruned_Roots)
-            SWITCH_OFF_ES = .TRUE.   
           ENDIF
           DO ISTEP = 1, KEEP(28)
             IW1(NSTK_S+ISTEP-1) = Pruned_SONS(ISTEP)
@@ -441,7 +405,7 @@ C
         IF ( DO_L0OMP_FWD ) THEN
           KEEP(405)=1
           CALL ZMUMPS_SOL_L0OMP_R( N, MTYPE_LOC, NRHS, LIW, IW,
-     &    IW1(PTRICB), RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD,
+     &    IW1(PTRICB), RHSINTR, LRHSINTR, POSINRHSINTR_FWD,
      &    STEP, FRERE, DAD, FILS, IW1(NSTK_S), 
      &    PTRIST, PTRFAC, INFO,
      &    KEEP, KEEP8, DKEEP, PROCNODE_STEPS, SLAVEF,
@@ -458,7 +422,7 @@ C
      &    PERM_L0_OMP, PTR_LEAFS_L0_OMP,
      &    L0_OMP_MAPPING, LL0_OMP_MAPPING,
      &    L0_OMP_FACTORS, LL0_OMP_FACTORS,
-     &    DO_PRUN, TO_PROCESS
+     &    DO_PRUN_FWD, TO_PROCESS
      &    )
           CALL MUMPS_STOP_ON_USER_REQUEST( KEEP, KEEP8, ICNTL,
      &                                    INFO, MYID )
@@ -469,7 +433,7 @@ C
           MYROOT = MYROOT - NBROOT_UNDER_L0
         ENDIF
         IF ( DO_L0OMP_FWD ) THEN
-          IF ( DO_PRUN ) THEN
+          IF ( DO_PRUN_FWD ) THEN
             MYLEAF_NOT_PRUNED = IPOOL_A_L0_OMP(LPOOL_A_L0_OMP)
             DO I=1, MYLEAF_NOT_PRUNED
               IF ( TO_PROCESS( STEP( IPOOL_A_L0_OMP(I) ))) THEN
@@ -513,7 +477,7 @@ C
             ENDDO
           ENDIF
         ELSE
-          IF ( DO_PRUN ) THEN
+          IF ( DO_PRUN_FWD ) THEN
             CALL MUMPS_INIT_POOL_DIST_NONA( N, MYLEAF, MYID_NODES,
      &            nb_prun_leaves, Pruned_Leaves, KEEP, KEEP8,
      &            STEP, PROCNODE_STEPS, IW1(IPOOL), LPOOL )
@@ -529,7 +493,7 @@ C
         CALL ZMUMPS_SOL_R(N, A(1), LA, IW(1), LIW, W(1),
      &       LWC, NRHS,
      &       IW1(PTRICB), IWCB, LIWW,
-     &       RHSCOMP,LRHSCOMP,POSINRHSCOMP_FWD,
+     &       RHSINTR,LRHSINTR,POSINRHSINTR_FWD,
      &       STEP, FRERE,DAD,FILS,
      &       IW1(NSTK_S),IW1(IPOOL),LPOOL,PTRIST,PTRFAC,
      &       MYLEAF, MYROOT, INFO,
@@ -543,7 +507,7 @@ C
      &          , L0_OMP_MAPPING, LL0_OMP_MAPPING,
      &            L0_OMP_FACTORS, LL0_OMP_FACTORS
      &       )
-        IF (DO_PRUN) THEN
+        IF (DO_PRUN_FWD) THEN
           MYLEAF = -1
         ENDIF
 #if defined(V_T)
@@ -567,9 +531,11 @@ C
          CALL MUMPS_SECFIN(TIME_FWD)
          DKEEP(117)=TIME_FWD + DKEEP(117)
       ENDIF
-      IF (DO_PRUN.AND.SWITCH_OFF_ES) THEN
-         DO_PRUN          = .FALSE.
-         Exploit_Sparsity = .FALSE.
+      IF ( .NOT.( 
+     &       DOBACKWARD.AND.
+     &      (DO_PRUN_BWD.OR.(Lnodes_BWD_ROOTS.NE.NA(2)))
+     &          )
+     &   ) THEN
          IF (.NOT. DO_L0OMP_BWD ) THEN
            IF ( allocated(TO_PROCESS) .AND. SIZE_TO_PROCESS.NE.1 ) THEN
              DEALLOCATE (TO_PROCESS)
@@ -578,58 +544,60 @@ C
            ENDIF
          ENDIF
       ENDIF
-      IF ( DOBACKWARD .AND. DO_PRUN )  THEN
-         nb_prun_leaves = 0
-        IF ( Exploit_Sparsity .AND. (KEEP(111).EQ.0) ) THEN
-          nb_nodes_RHS = nb_prun_roots
-          ALLOCATE(nodes_RHS(nb_nodes_RHS), STAT = allocok)
-          IF(allocok.GT.0) THEN
-            WRITE(*,*)'Problem with allocation of nodes_RHS'
-            INFO(1) = -13
-            INFO(2) = nb_nodes_RHS
-            CALL MUMPS_ABORT()
-          END IF
-          nodes_RHS(1:nb_prun_roots)=Pruned_Roots(1:nb_prun_roots)
-          DEALLOCATE(Pruned_Roots)
-        ELSE
-         nb_nodes_RHS = 0
-         Pruned_SONS(:) = -1 
-         DO II = 1, NZ_RHS
+      IF ( (KEEP(111).NE.0).AND.DOBACKWARD.AND.
+     &     (
+     &      DO_PRUN_BWD
+     &     )
+     &   )   THEN
+        nb_prun_leaves = 0
+        IF ( Lnodes_BWD_ROOTS.NE.NA(2) ) THEN
+          nodes_BWD_PTR => Pruned_Roots_FWD
+          Lnodes_BWD_PTR = Lnodes_BWD_ROOTS
+        ELSE IF ( (Exploit_Sparsity_BWD.AND.KEEP(111).NE.0) 
+     &          ) THEN
+          LPruned_Roots_NS = 0
+          Pruned_SONS(:)   = -1 
+          DO II = 1, NZ_RHS
             I = IRHS_SPARSE(II)
             IF (KEEP(23).NE.0) I = UNS_PERM_INV(I)          
             ISTEP = abs(STEP(I))
             IF ( Pruned_SONS(ISTEP) .eq. -1) THEN
-               nb_nodes_RHS = nb_nodes_RHS +1
+               LPruned_Roots_NS   = LPruned_Roots_NS +1
                Pruned_SONS(ISTEP) = 0
             ENDIF
-         ENDDO
-         ALLOCATE(nodes_RHS(nb_nodes_RHS), STAT = allocok)           
-         IF(allocok.GT.0) THEN
-           WRITE(*,*)'Problem with allocation of nodes_RHS'
+          ENDDO
+          ALLOCATE(Pruned_Roots_NS(LPruned_Roots_NS), STAT = allocok) 
+          IF(allocok.GT.0) THEN
+           WRITE(*,*)'Problem with allocation of nodes_BWD'
            INFO(1) = -13
-           INFO(2) = nb_nodes_RHS
+           INFO(2) = LPruned_Roots_NS
            CALL MUMPS_ABORT()
-         END IF
-         nb_nodes_RHS = 0         
-         Pruned_SONS(:) = -1  
-         DO II = 1, NZ_RHS
+          END IF
+          LPruned_Roots_NS = 0         
+          Pruned_SONS(:) = -1  
+          DO II = 1, NZ_RHS
             I = IRHS_SPARSE(II)
             IF (KEEP(23).NE.0) I = UNS_PERM_INV(I)
             ISTEP = abs(STEP(I))
             INODE_PRINC = Step2node(ISTEP)
             IF ( Pruned_SONS(ISTEP) .eq. -1) THEN
-               nb_nodes_RHS = nb_nodes_RHS +1
-               nodes_RHS(nb_nodes_RHS)  = INODE_PRINC
+               LPruned_Roots_NS = LPruned_Roots_NS +1
+               Pruned_Roots_NS(LPruned_Roots_NS)  = INODE_PRINC
                Pruned_SONS(ISTEP) = 0
             ENDIF
-         ENDDO
+          ENDDO
+          nodes_BWD_PTR => Pruned_Roots_NS
+          Lnodes_BWD_PTR = LPruned_Roots_NS
         ENDIF
-        IF ( Exploit_Sparsity ) THEN
+        IF ( 
+     &       (Exploit_Sparsity_BWD.AND.KEEP(111).NE.0) .OR.
+     &       (Lnodes_BWD_ROOTS.NE.NA(2))
+     &     ) THEN
            CALL ZMUMPS_TREE_PRUN_NODES( 
      &     .FALSE.,
      &     DAD, NE_STEPS, FRERE, KEEP(28),
      &     FILS, STEP, N,
-     &     nodes_RHS, nb_nodes_RHS,
+     &     nodes_BWD_PTR, Lnodes_BWD_PTR,
      &     TO_PROCESS,
      &     nb_prun_nodes, nb_prun_roots, nb_prun_leaves
      &     )
@@ -658,27 +626,22 @@ C
      &     .TRUE.,
      &     DAD, NE_STEPS, FRERE, KEEP(28),
      &     FILS, STEP, N,
-     &     nodes_RHS, nb_nodes_RHS,
+     &     nodes_BWD_PTR, Lnodes_BWD_PTR,
      &     TO_PROCESS,
      &     nb_prun_nodes, nb_prun_roots, nb_prun_leaves,
      &     Pruned_List, Pruned_Roots, Pruned_Leaves
      &     )
+           IF(allocated(Pruned_Roots_NS)) DEALLOCATE(Pruned_Roots_NS)
+           IF(allocated(Pruned_Roots_FWD)) DEALLOCATE(Pruned_Roots_FWD)
            CALL ZMUMPS_OOC_SET_STATES_ES(N,
      &          KEEP(201), Pruned_List, nb_prun_nodes,
      &          STEP)
-           IF(allocated(nodes_RHS)) DEALLOCATE(nodes_RHS)
            IF (KEEP(201).GT.0) THEN
              OOC_FCT_TYPE_TMP=MUMPS_OOC_GET_FCT_TYPE
      &                    ('B',MTYPE,KEEP(201),KEEP(50))
            ELSE
              OOC_FCT_TYPE_TMP = -5959 
            ENDIF
-           CALL ZMUMPS_TREE_PRUN_NODES_STATS(
-     &          MYID_NODES, N, KEEP(28), KEEP(201),
-     &        KEEP8(31)+KEEP8(64), 
-     &          STEP,
-     &          Pruned_List,
-     &          nb_prun_nodes, OOC_FCT_TYPE_TMP)
         ENDIF
       ENDIF
       IF(KEEP(201).EQ.1.AND.DOROOT_BWD_PANEL) THEN
@@ -705,7 +668,7 @@ C
         IF ( KEEP(60) .EQ. 0 .AND. KEEP(252) .EQ. 0 ) THEN
           IF ( root%yes ) THEN
             IF (KEEP(201).GT.0) THEN
-              IF ( (Exploit_Sparsity.AND.(KEEP(111).NE.0)) .and.
+              IF ( (Exploit_Sparsity_FWD.AND.(KEEP(111).NE.0)) .and.
      &            (OOC_STATE_NODE(STEP(KEEP(38))).eq.-6) ) THEN
                   GOTO 1010
               ENDIF
@@ -756,6 +719,49 @@ C
         ENDIF
       ELSE IF ( ( KEEP(20) .NE. 0) .AND. SPECIAL_ROOT_REACHED ) THEN
         IF ( MYID_NODES .eq.  MASTER_ROOT ) THEN
+          IF ( KEEP(60) .eq. 0 ) THEN
+            IF (KEEP(201).GT.0) THEN
+              CALL ZMUMPS_SOLVE_GET_OOC_NODE(
+     &              KEEP(20),PTRFAC,KEEP,A,LA,
+     &              STEP,KEEP8,N,DUMMY_BOOL,IERR)
+              IF(IERR.LT.0)THEN
+                INFO(1)=IERR
+                INFO(2)=0
+                WRITE(*,*) '** ERROR after ZMUMPS_SOLVE_GET_OOC_NODE', 
+     &          INFO(1)
+                call MUMPS_ABORT()
+              ENDIF
+            END IF
+            NRHS_LOC         = NRHS
+            IPT_RHS_ROOT_LOC = 1
+            IF ( KEEP(111).NE.0 ) THEN
+              RHS_ROOT( 1: NRHS*SIZE_ROOT) = ZERO
+              NRHS_LOC = IEND_ROOT_DEF - IBEG_ROOT_DEF + 1
+              IPT_RHS_ROOT_LOC = IPT_RHS_ROOT_LOC +
+     &                           (IROOT_DEF_RHS_COL1-1)*SIZE_ROOT
+           ENDIF
+           IF (NRHS_LOC .GT. 0) THEN
+              CALL ZMUMPS_SEQ_SOLVE_ROOT_SVD_QR(NRHS_LOC,
+     &             SIZE_ROOT,A( PTRFAC(
+     &             IW( PTRIST(STEP(KEEP(20)))+4+KEEP(IXSZ)))),
+     &             root, IBEG_ROOT_DEF, IEND_ROOT_DEF,
+     &             RHS_ROOT( IPT_RHS_ROOT_LOC ),
+     &             KEEP,KEEP8,
+     &             MTYPE,INFO,LWC,W(1), LP)
+        ENDIF
+            IF(KEEP(201).GT.0)THEN
+              CALL ZMUMPS_FREE_FACTORS_FOR_SOLVE(KEEP(20),
+     &             PTRFAC,KEEP(28),A,LA,.FALSE.,IERR)
+              IF(IERR.LT.0)THEN
+                 INFO(1)=IERR
+                 INFO(2)=0
+                 WRITE(*,*)
+     &           '** ERROR after ZMUMPS_FREE_FACTORS_FOR_SOLVE ', 
+     &           INFO(1)
+                 call MUMPS_ABORT()
+              ENDIF
+            ENDIF
+          ENDIF
         END IF 
       END IF 
       IF (.NOT.FROM_PP) THEN
@@ -773,13 +779,13 @@ C
      &    THEN
           I_WORKED_ON_ROOT = DOROOT
           IF (KEEP(38).gt.0 ) THEN
-             IF ( ( Exploit_Sparsity.AND.(KEEP(111).EQ.0) )
+             IF ( ( Exploit_Sparsity_FWD.AND.(KEEP(111).EQ.0) )
      &            .OR. AM1 ) THEN
                 IF (OOC_STATE_NODE(STEP(KEEP(38))).eq.-6) THEN
                    OOC_STATE_NODE(STEP(KEEP(38)))=-4
                 ENDIF
              ENDIF
-             IF (Exploit_Sparsity.AND.(KEEP(111).NE.0)) THEN
+             IF (Exploit_Sparsity_FWD.AND.(KEEP(111).NE.0)) THEN
                 IF (OOC_STATE_NODE(STEP(KEEP(38))).eq.-6) THEN
                    I_WORKED_ON_ROOT = .FALSE.
                 ENDIF
@@ -791,14 +797,14 @@ C
         ELSE
           DO_NBSPARSE_BWD = DO_NBSPARSE
         ENDIF
-        PRUN_BELOW_BWD = AM1
+        PRUN_BELOW_BWD = DO_PRUN_BWD .AND. KEEP(111).EQ.0
         PRUN_BELOW_BWD = PRUN_BELOW_BWD .OR. DO_L0OMP_BWD
-        IF ( AM1 ) THEN
+        IF ( DO_PRUN_BWD )  THEN
           CALL ZMUMPS_CHAIN_PRUN_NODES( 
      &        .FALSE.,
      &        DAD, KEEP(28),
      &        STEP, N,
-     &        nodes_RHS, nb_nodes_RHS,
+     &        nodes_BWD, Lnodes_BWD,
      &        Pruned_SONS, TO_PROCESS,
      &        nb_prun_nodes, nb_prun_roots,
      &        nb_prun_leaves)  
@@ -823,11 +829,11 @@ C
           END IF
           CALL MUMPS_PROPINFO(ICNTL, INFO, COMM_NODES, MYID )
           IF(INFO(1).LT.0) GOTO 500
-          CALL ZMUMPS_CHAIN_PRUN_NODES( 
+          CALL ZMUMPS_CHAIN_PRUN_NODES(
      &        .TRUE.,
      &        DAD, KEEP(28),
      &        STEP, N,
-     &        nodes_RHS, nb_nodes_RHS,
+     &        nodes_BWD, Lnodes_BWD,
      &        Pruned_SONS, TO_PROCESS,
      &        nb_prun_nodes, nb_prun_roots, nb_prun_leaves,
      &        Pruned_List, Pruned_Roots, Pruned_Leaves )
@@ -843,6 +849,10 @@ C
           CALL ZMUMPS_CHAIN_PRUN_NODES_STATS(
      &    MYID_NODES, N, KEEP(28), KEEP(201), KEEP(485), KEEP8(31),
      &    STEP, Pruned_List, nb_prun_nodes, OOC_FCT_TYPE_TMP
+#if defined(STAT_ES_SOLVE)
+     &          , NRHS, COMM_NODES, IW, LIW, PTRIST,KEEP(IXSZ),1,
+     &          KEEP(50), KEEP(38)
+#endif
      &    )
           IF (DO_NBSPARSE_BWD) THEN
             nb_sparse = max(1,KEEP(497))
@@ -859,6 +869,10 @@ C
      &       STEP, N, Pruned_SONS,
      &       DAD, RHS_BOUNDS, KEEP(28),
      &       MYID_NODES, COMM_NODES, KEEP(485),
+#if defined(STAT_ES_SOLVE)
+     &       KEEP(46), 
+     &       IPTR_WORKING, SIZE_IPTR_WORKING, WORKING, SIZE_WORKING,
+#endif     
      &       IW, LIW, PTRIST,KEEP(IXSZ),OOC_FCT_TYPE_TMP,1,
      &       KEEP(50), KEEP(38))
          END IF
@@ -882,17 +896,17 @@ C
         IF ( .NOT.SPECIAL_ROOT_REACHED ) THEN
           RHS_ROOT(1:NRHS*SIZE_ROOT) = ZERO
         ENDIF
-        IF (AM1.AND.(NB_FS_IN_RHSCOMP_F.NE.NB_FS_IN_RHSCOMP_TOT)) THEN
+        IF (AM1.AND.(NB_FS_IN_RHSINTR_F.NE.NB_FS_IN_RHSINTR_TOT)) THEN
          DO I =1, N
-           II = POSINRHSCOMP_BWD(I)
-           IF ((II.GT.0).AND.(II.GT.NB_FS_IN_RHSCOMP_F)) THEN
+           II = POSINRHSINTR_BWD(I)
+           IF ((II.GT.0).AND.(II.GT.NB_FS_IN_RHSINTR_F)) THEN
             DO K=1,NRHS
-             RHSCOMP(II, K) = ZERO
+             RHSINTR(II, K) = ZERO
             ENDDO
            ENDIF
          ENDDO
         ENDIF
-        IF ( .NOT. DO_PRUN ) THEN
+        IF ( .NOT. DO_PRUN_BWD ) THEN
            IF ( .NOT. DO_L0OMP_BWD ) THEN
              IF (DO_L0OMP_FWD) THEN
                MYLEAF = -1
@@ -988,7 +1002,7 @@ C
               IF ( .NOT. MUMPS_IN_OR_ROOT_SSARBR(PROCNODE_STEPS(I),
      &        KEEP(199)) ) THEN
                 IF ( L0_OMP_MAPPING(I) .EQ. 0 ) THEN
-                  IF ( DO_PRUN
+                  IF ( DO_PRUN_BWD
      &                 .OR. DO_L0OMP_BWD 
      &               ) THEN
                     IF ( TO_PROCESS(I) ) THEN
@@ -1007,7 +1021,7 @@ C
       IF(INFO(1).LT.0) GOTO 500
         CALL ZMUMPS_SOL_S( N, A, LA, IW, LIW, W(1), LWC,
      &          NRHS,
-     &          RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &          RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &          IW1(PTRICB),PTRACB,IWCB,LIWW, W2,
      &          NE_STEPS,
      &          STEP, FRERE,DAD,FILS,
@@ -1023,7 +1037,7 @@ C
      &          , L0_OMP_MAPPING, LL0_OMP_MAPPING,
      &            L0_OMP_FACTORS, LL0_OMP_FACTORS
      &          )
-        IF ( DO_L0OMP_BWD .AND. DO_PRUN ) THEN
+        IF ( DO_L0OMP_BWD .AND. DO_PRUN_BWD ) THEN
           DO I = 1, L_PHYS_L0_OMP
             IF ( PHYS_L0_OMP( I ) .LT. 0 ) THEN
               PHYS_L0_OMP( I ) = -PHYS_L0_OMP( I )
@@ -1034,10 +1048,10 @@ C
         CALL MUMPS_STOP_ON_USER_REQUEST(KEEP, KEEP8, ICNTL, INFO, MYID)
         IF (DO_L0OMP_BWD .AND. INFO(1) .GE. 0) THEN
           KEEP(31) = 0
-          PRUN_BELOW_BWD = AM1
+          PRUN_BELOW_BWD = DO_PRUN_BWD .AND. KEEP(111).EQ.0
           KEEP(405)=1
           CALL ZMUMPS_SOL_L0OMP_S(N, MTYPE_LOC, NRHS, LIW, IW,
-     &      IW1(PTRICB), PTRACB, RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &      IW1(PTRICB), PTRACB, RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &      STEP, FRERE, FILS, NE_STEPS, PTRIST, PTRFAC, INFO,
      &      KEEP, KEEP8, DKEEP, PROCNODE_STEPS, SLAVEF,
      &      COMM_NODES, MYID_NODES, BUFR, LBUFR, LBUFR_BYTES, 
@@ -1070,21 +1084,24 @@ C
       ENDIF
       IF (LDIAG.GT.2 .AND. MP.GT.0) THEN
         IF (DOFORWARD) THEN
-        K = min0(10,size(RHSCOMP,1))
-        IF (LDIAG.EQ.4) K = size(RHSCOMP,1)
+        K = min(10,size(RHSINTR,1))
+        IF (LDIAG.EQ.4) K = size(RHSINTR,1)
         IF ( .NOT. FROM_PP) THEN
           WRITE (MP,99992)
-          IF (size(RHSCOMP,1).GT.0) 
-     &    WRITE (MP,99993) (RHSCOMP(I,1),I=1,K)
-          IF (size(RHSCOMP,1).GT.0.and.NRHS>1) 
-     &              WRITE (MP,99994) (RHSCOMP(I,2),I=1,K)
+          IF (size(RHSINTR,1).GT.0) 
+     &    WRITE (MP,99993) (RHSINTR(I,1),I=1,K)
+          IF (size(RHSINTR,1).GT.0.and.NRHS>1) 
+     &              WRITE (MP,99994) (RHSINTR(I,2),I=1,K)
           ENDIF
         ENDIF
       ENDIF
 500   CONTINUE
       IF ( allocated(TO_PROCESS)) DEALLOCATE (TO_PROCESS)
-      IF (Exploit_Sparsity.OR.AM1.OR.SWITCH_OFF_ES) THEN
-         IF ( allocated(nodes_RHS)) DEALLOCATE (nodes_RHS)
+      IF (DO_PRUN_FWD.OR.DO_PRUN_BWD) THEN
+         IF ( allocated(Pruned_Roots_FWD)) 
+     &        DEALLOCATE (Pruned_Roots_FWD)
+         IF ( allocated(Pruned_Roots_NS)) 
+     &        DEALLOCATE (Pruned_Roots_NS)
          IF ( allocated(Pruned_SONS)) DEALLOCATE (Pruned_SONS)
          IF ( allocated(Pruned_Roots)) DEALLOCATE (Pruned_Roots)
          IF ( allocated(Pruned_List)) DEALLOCATE (Pruned_List)
@@ -1095,20 +1112,81 @@ C
 99994 FORMAT (' RHS (internal, 2 nd  column)'/(1X,1P,5D14.6))
 99992 FORMAT (//' LEAVING SOLVE (ZMUMPS_SOL_C) WITH')
       END SUBROUTINE ZMUMPS_SOL_C
+      SUBROUTINE ZMUMPS_SET_POSTPros (KEEP, ICNTL, NBRHS, MPG, PROKG, 
+     &                               ICNTL10, ICNTL11, POSTPros)
+      IMPLICIT NONE
+      INTEGER, INTENT(IN)  :: KEEP(500), ICNTL(60), NBRHS, MPG
+      LOGICAL, INTENT(IN)  :: PROKG
+      INTEGER, INTENT(OUT) :: ICNTL10, ICNTL11
+      LOGICAL, INTENT(OUT) :: POSTPros
+      POSTPros = .FALSE.
+      IF (ICNTL11.NE.0 .OR. ICNTL10.NE.0) THEN
+        POSTPros = .TRUE.
+        IF (KEEP(111).NE.0) THEN
+            IF (PROKG) WRITE(MPG,'(A,A)')
+     &     ' WARNING: Incompatible features: null space basis',
+     &              ' and Iter. Ref and/or Err. Anal.'
+            POSTPros = .FALSE.
+        ELSE IF ( KEEP(237) .NE.0 ) THEN
+            IF (PROKG) WRITE(MPG,'(A,A)')
+     &     ' WARNING: Incompatible features: AM1',
+     &              ' and Iter. Ref and/or Err. Anal.'
+            POSTPros = .FALSE.
+        ELSE IF ( KEEP(252) .NE.0 ) THEN
+            IF (PROKG) WRITE(MPG,'(A,A)')
+     &     ' WARNING: Incompatible features: Fwd in facto ',
+     &              ' and Iter. Ref and/or Err. Anal.'
+            POSTPros = .FALSE.
+        ELSE IF (KEEP(221).NE.0) THEN
+            IF (PROKG) WRITE(MPG,'(A,A)')
+     &     ' WARNING: Incompatible features: reduced RHS',
+     &     ' and Iter. Ref and/or Err. Anal.'
+            POSTPros = .FALSE.
+        ELSE IF  (NBRHS.GT. 1 .OR. ICNTL(21) .GT. 0) THEN
+            IF (PROKG) WRITE(MPG,'(A,A)')
+     &     ' WARNING:  Incompatible features: nrhs>1 or distrib sol',
+     &     ' and Iter. Ref and/or Err. Anal.'
+            POSTPros = .FALSE.
+        ELSE IF ( KEEP(248) .EQ. -1 ) THEN
+            IF (PROKG) WRITE(MPG,'(A,A)')
+     &     ' WARNING:  Incompatible features: distrib rhs',
+     &     ' and Iter. Ref and/or Err. Anal.'
+            POSTPros = .FALSE.
+        ENDIF  
+        IF (.NOT.POSTPros) THEN
+          ICNTL11 = 0
+          ICNTL10 = 0
+        ENDIF
+      ENDIF
+      IF ((ICNTL(10) .NE. 0) .AND. (ICNTL10 .EQ. 0)) THEN
+          IF (PROKG) WRITE(MPG,'(A)')
+     &  ' WARNING: ICNTL(10) treated as if set to 0 '
+      ENDIF
+      IF ((ICNTL(11) .NE. 0)
+     &      .AND.(ICNTL11 .EQ. 0)) THEN
+          IF (PROKG) WRITE(MPG,'(A)')
+     &  ' WARNING: ICNTL(11) treated as if set to 0 '
+      ENDIF
+      RETURN
+      END SUBROUTINE ZMUMPS_SET_POSTPros
       SUBROUTINE ZMUMPS_GATHER_SOLUTION( NSLAVES, N, MYID, COMM,
      &           NRHS,
      &           MTYPE, RHS, LRHS, NCOL_RHS, JBEG_RHS, PTRIST,
      &           KEEP,KEEP8, PROCNODE_STEPS, IW, LIW, STEP, BUFFER,
      &           SIZE_BUF, SIZE_BUF_BYTES, CWORK, LCWORK,
+#if defined(USE_OLD_SCALING)
      &           LSCAL, SCALING, LSCALING, 
-     &           RHSCOMP, LRHSCOMP, NCOL_RHSCOMP, 
-     &           POSINRHSCOMP, LPOS_N, PERM_RHS, SIZE_PERM_RHS )
+#else
+     &           LSCAL, SCALING_LOC_BWD, LSCALING_LOC_BWD, 
+#endif
+     &           RHSINTR, LRHSINTR, NCOL_RHSINTR, 
+     &           POSINRHSINTR, LPOS_N, PERM_RHS, SIZE_PERM_RHS )
 !$    USE OMP_LIB
       IMPLICIT NONE
       INCLUDE 'mpif.h'
       INCLUDE 'mumps_tags.h'
       INTEGER NSLAVES, N, MYID, COMM, LIW, MTYPE, NCOL_RHS
-      INTEGER NRHS, LRHS, LCWORK, LPOS_N, NCOL_RHSCOMP
+      INTEGER NRHS, LRHS, LCWORK, LPOS_N, NCOL_RHSINTR
       COMPLEX(kind=8) RHS   (LRHS, NCOL_RHS)
       INTEGER, INTENT(in) :: JBEG_RHS
       INTEGER KEEP(500)
@@ -1118,11 +1196,17 @@ C
       INTEGER IW(LIW), STEP(N)
       INTEGER SIZE_BUF, SIZE_BUF_BYTES
       INTEGER BUFFER(SIZE_BUF)
-      INTEGER LRHSCOMP, POSINRHSCOMP(LPOS_N) 
-      COMPLEX(kind=8), intent(in) :: RHSCOMP(LRHSCOMP, NCOL_RHSCOMP)
-      LOGICAL, intent(in) :: LSCAL
+      INTEGER LRHSINTR, POSINRHSINTR(LPOS_N) 
+#if defined(USE_OLD_SCALING)
+      COMPLEX(kind=8), intent(in) :: RHSINTR(LRHSINTR, NCOL_RHSINTR)
       INTEGER, intent(in) :: LSCALING
       DOUBLE PRECISION, intent(in)    :: SCALING(LSCALING)
+#else
+      COMPLEX(kind=8), intent(inout) :: RHSINTR(LRHSINTR, NCOL_RHSINTR)
+      INTEGER, intent(in) :: LSCALING_LOC_BWD
+      DOUBLE PRECISION, intent(in) :: SCALING_LOC_BWD(LSCALING_LOC_BWD)
+#endif
+      LOGICAL, intent(in) :: LSCAL
       INTEGER, INTENT(in) :: SIZE_PERM_RHS
       INTEGER, INTENT(in) :: PERM_RHS(SIZE_PERM_RHS)
       INTEGER I, II, J, J1, ISTEP, MASTER,
@@ -1133,7 +1217,7 @@ C
       PARAMETER(MASTER=0)
       LOGICAL I_AM_SLAVE
       INTEGER RECORD_SIZE_P_1, SIZE1, SIZE2
-      INTEGER POS_BUF, N2SEND, IPOSINRHSCOMP
+      INTEGER POS_BUF, N2SEND, IPOSINRHSINTR
       INTEGER :: JCOL_RHS
       INTEGER :: K242
       LOGICAL :: OMP_FLAG
@@ -1167,7 +1251,7 @@ C
              ENDIF
              IF (OMP_FLAG) THEN
 !$OMP PARALLEL FIRSTPRIVATE(JBEG_RHS,N,K242)
-!$OMP&  PRIVATE(J,IPOSINRHSCOMP,I,JCOL_RHS)
+!$OMP&  PRIVATE(J,IPOSINRHSINTR,I,JCOL_RHS)
                DO J=1, NRHS
                  IF (K242.EQ.0) THEN
                    JCOL_RHS = J+JBEG_RHS-1
@@ -1176,10 +1260,14 @@ C
                  ENDIF
 !$OMP DO SCHEDULE(DYNAMIC,CHUNK)
                  DO I=1, N
-                   IPOSINRHSCOMP = POSINRHSCOMP(I)
-                   IF (IPOSINRHSCOMP.GT.0) THEN 
-                     RHS(I,JCOL_RHS) =
-     &                   RHSCOMP(IPOSINRHSCOMP,J)*SCALING(I)
+                   IPOSINRHSINTR = POSINRHSINTR(I)
+                   IF (IPOSINRHSINTR.GT.0) THEN 
+                     RHS(I,JCOL_RHS) = RHSINTR(IPOSINRHSINTR,J)*
+#if defined(USE_OLD_SCALING)
+     &               SCALING(I)
+#else
+     &               SCALING_LOC_BWD(IPOSINRHSINTR)
+#endif
                    ELSE
                     RHS(I,JCOL_RHS) = ZERO
                   ENDIF
@@ -1195,10 +1283,14 @@ C
                    JCOL_RHS = PERM_RHS(J+JBEG_RHS-1)
                  ENDIF
                  DO I=1, N
-                   IPOSINRHSCOMP = POSINRHSCOMP(I)
-                   IF (IPOSINRHSCOMP.GT.0) THEN 
-                     RHS(I,JCOL_RHS) =
-     &                   RHSCOMP(IPOSINRHSCOMP,J)*SCALING(I)
+                   IPOSINRHSINTR = POSINRHSINTR(I)
+                   IF (IPOSINRHSINTR.GT.0) THEN 
+                     RHS(I,JCOL_RHS) = RHSINTR(IPOSINRHSINTR,J)*
+#if defined(USE_OLD_SCALING)
+     &               SCALING(I)
+#else
+     &               SCALING_LOC_BWD(IPOSINRHSINTR)
+#endif
                    ELSE
                      RHS(I,JCOL_RHS) = ZERO
                    ENDIF
@@ -1221,7 +1313,7 @@ C
              ENDIF
              IF (OMP_FLAG) THEN
 !$OMP PARALLEL FIRSTPRIVATE(JBEG_RHS,N,K242)
-!$OMP&  PRIVATE(IPOSINRHSCOMP,I,JCOL_RHS) IF (OMP_FLAG)
+!$OMP&  PRIVATE(IPOSINRHSINTR,I,JCOL_RHS) IF (OMP_FLAG)
                DO J=1, NRHS
                  IF (K242.EQ.0) THEN
                    JCOL_RHS = J+JBEG_RHS-1
@@ -1230,9 +1322,9 @@ C
                  ENDIF
 !$OMP DO SCHEDULE(DYNAMIC,CHUNK)
                  DO I=1, N
-                   IPOSINRHSCOMP = POSINRHSCOMP(I)
-                   IF (IPOSINRHSCOMP.GT.0) THEN
-                     RHS(I,JCOL_RHS) = RHSCOMP(IPOSINRHSCOMP,J)
+                   IPOSINRHSINTR = POSINRHSINTR(I)
+                   IF (IPOSINRHSINTR.GT.0) THEN
+                     RHS(I,JCOL_RHS) = RHSINTR(IPOSINRHSINTR,J)
                    ELSE
                      RHS(I,JCOL_RHS) = ZERO
                    ENDIF
@@ -1248,9 +1340,9 @@ C
                    JCOL_RHS = PERM_RHS(J+JBEG_RHS-1)
                  ENDIF
                  DO I=1, N
-                   IPOSINRHSCOMP = POSINRHSCOMP(I)
-                   IF (IPOSINRHSCOMP.GT.0) THEN
-                     RHS(I,JCOL_RHS) = RHSCOMP(IPOSINRHSCOMP,J)
+                   IPOSINRHSINTR = POSINRHSINTR(I)
+                   IF (IPOSINRHSINTR.GT.0) THEN
+                     RHS(I,JCOL_RHS) = RHSINTR(IPOSINRHSINTR,J)
                    ELSE
                      RHS(I,JCOL_RHS) = ZERO
                    ENDIF
@@ -1339,15 +1431,20 @@ C
             CALL MPI_UNPACK(BUFFER, SIZE_BUF_BYTES, POS_BUF,
      &                 CWORK, NPIV, MPI_DOUBLE_COMPLEX,
      &                 COMM, IERR)
+#if defined(USE_OLD_SCALING)
             IF (LSCAL) THEN
               DO I=1,NPIV
                 RHS(IROWlist(I),JCOL_RHS)=CWORK(I)*SCALING(IROWlist(I))
               ENDDO
             ELSE
+#else
+#endif
               DO I=1,NPIV
                 RHS(IROWlist(I),JCOL_RHS)=CWORK(I)
               ENDDO
+#if defined(USE_OLD_SCALING)
             ENDIF
+#endif
           ENDDO
           N2RECV=N2RECV-NPIV
           CALL MPI_UNPACK( BUFFER, SIZE_BUF_BYTES, POS_BUF,
@@ -1361,11 +1458,11 @@ C
         SUBROUTINE ZMUMPS_NPIV_BLOCK_ADD ( ON_MASTER )
         LOGICAL, intent(in) ::  ON_MASTER     
         INTEGER :: JPOS, K242
-        LOGICAL :: LOCAL_LSCAL
+        LOGICAL :: PRIV_LSCAL
         IF (ON_MASTER) THEN
         IF (KEEP(350).EQ.2
      &  .AND. (NRHS.EQ.1.OR.((NPIV*NRHS*2*KEEP(16)).GE.KEEP(364)))) THEN
-          LOCAL_LSCAL = LSCAL
+          PRIV_LSCAL = LSCAL
           K242 = KEEP(242)
           DO J=1, NRHS
             IF (K242.EQ.0) THEN
@@ -1375,53 +1472,67 @@ C
             ENDIF
             DO II=1,NPIV
               I=IW(J1+II-1)
-              IPOSINRHSCOMP= POSINRHSCOMP(I) 
-              IF (LOCAL_LSCAL) THEN
-                RHS(I,JPOS) = RHSCOMP(IPOSINRHSCOMP,J)*SCALING(I)
+              IPOSINRHSINTR= POSINRHSINTR(I) 
+              IF (PRIV_LSCAL) THEN
+                RHS(I,JPOS) = RHSINTR(IPOSINRHSINTR,J)*
+#if defined(USE_OLD_SCALING)
+     &          SCALING(I)
+#else
+     &          SCALING_LOC_BWD(IPOSINRHSINTR)
+#endif
               ELSE
-                RHS(I,JPOS) = RHSCOMP(IPOSINRHSCOMP,J)
+                RHS(I,JPOS) = RHSINTR(IPOSINRHSINTR,J)
               ENDIF
             ENDDO
           ENDDO
         ELSE
          IF (KEEP(242).EQ.0) THEN
            IF (LSCAL) THEN
-            DO II=1,NPIV
+             DO II=1,NPIV
                 I=IW(J1+II-1)
-                IPOSINRHSCOMP= POSINRHSCOMP(I) 
+                IPOSINRHSINTR= POSINRHSINTR(I) 
                 DO J=1, NRHS
-                  RHS(I,J+JBEG_RHS-1) =
-     &               RHSCOMP(IPOSINRHSCOMP,J)*SCALING(I)
+                  RHS(I,J+JBEG_RHS-1) = RHSINTR(IPOSINRHSINTR,J)*
+#if defined(USE_OLD_SCALING)
+     &            SCALING(I)
+#else
+     &            SCALING_LOC_BWD(IPOSINRHSINTR)
+#endif
                 ENDDO
-            ENDDO
+             ENDDO
            ELSE
-            DO II=1,NPIV
+             DO II=1,NPIV
                 I=IW(J1+II-1)
-                IPOSINRHSCOMP= POSINRHSCOMP(I)
+                IPOSINRHSINTR= POSINRHSINTR(I)
                 DO J=1, NRHS
-                  RHS(I,J+JBEG_RHS-1) = RHSCOMP(IPOSINRHSCOMP,J)
+                  RHS(I,J+JBEG_RHS-1) = RHSINTR(IPOSINRHSINTR,J)
                 ENDDO
-            ENDDO
+             ENDDO
            ENDIF
          ELSE
            IF (LSCAL) THEN
               DO II=1,NPIV
                 I=IW(J1+II-1)
-                IPOSINRHSCOMP= POSINRHSCOMP(I)
+                IPOSINRHSINTR= POSINRHSINTR(I)
 !DIR$ NOVECTOR
                 DO J=1, NRHS
                   RHS(I,PERM_RHS(J+JBEG_RHS-1)) =
-     &               RHSCOMP(IPOSINRHSCOMP,J)*SCALING(I)
+     &               RHSINTR(IPOSINRHSINTR,J)*
+#if defined(USE_OLD_SCALING)
+     &               SCALING(I)
+#else
+     &               SCALING_LOC_BWD(IPOSINRHSINTR)
+#endif
                 ENDDO
               ENDDO
            ELSE
               DO II=1,NPIV
                 I=IW(J1+II-1)
-                IPOSINRHSCOMP= POSINRHSCOMP(I)
+                IPOSINRHSINTR= POSINRHSINTR(I)
 !DIR$ NOVECTOR
                 DO J=1, NRHS
                   RHS(I,PERM_RHS(J+JBEG_RHS-1)) =
-     &               RHSCOMP(IPOSINRHSCOMP,J)
+     &               RHSINTR(IPOSINRHSINTR,J)
                 ENDDO
               ENDDO
            ENDIF
@@ -1433,9 +1544,17 @@ C
      &                SIZE_BUF_BYTES, POS_BUF, COMM, IERR )
         CALL MPI_PACK(IW(J1), NPIV, MPI_INTEGER, BUFFER,
      &                SIZE_BUF_BYTES, POS_BUF, COMM, IERR )
-        IPOSINRHSCOMP= POSINRHSCOMP(IW(J1)) 
+        IPOSINRHSINTR= POSINRHSINTR(IW(J1)) 
         DO J=1,NRHS
-          CALL MPI_PACK(RHSCOMP(IPOSINRHSCOMP,J), NPIV,
+#if ! defined(USE_OLD_SCALING)
+          IF (LSCAL) THEN
+            DO II=IPOSINRHSINTR, IPOSINRHSINTR+NPIV-1
+              RHSINTR(II,J)=
+     &        RHSINTR(II,J)*SCALING_LOC_BWD(II)
+            ENDDO
+          ENDIF
+#endif
+          CALL MPI_PACK(RHSINTR(IPOSINRHSINTR,J), NPIV,
      &              MPI_DOUBLE_COMPLEX,
      &              BUFFER, SIZE_BUF_BYTES, POS_BUF, COMM,
      &              IERR)
@@ -1459,38 +1578,47 @@ C
         END SUBROUTINE ZMUMPS_NPIV_BLOCK_SEND
       END SUBROUTINE ZMUMPS_GATHER_SOLUTION
       SUBROUTINE ZMUMPS_GATHER_SOLUTION_AM1(NSLAVES, N, MYID, COMM,
-     &           NRHS, RHSCOMP,  LRHSCOMP, NRHSCOMP_COL,
+     &           NRHS, RHSINTR,  LRHSINTR, NRHSINTR_COL,
      &           KEEP, BUFFER,
      &           SIZE_BUF, SIZE_BUF_BYTES, 
+#if defined(USE_OLD_SCALING)
      &           LSCAL, SCALING, LSCALING,
+#else
+     &           LSCAL, SCALING_LOC_BWD, LSCALING_LOC_BWD, 
+#endif
      &          IRHS_PTR_COPY, LIRHS_PTR_COPY, 
      &          IRHS_SPARSE_COPY, LIRHS_SPARSE_COPY,
      &          RHS_SPARSE_COPY, LRHS_SPARSE_COPY,
      &          UNS_PERM_INV, LUNS_PERM_INV,
-     &          POSINRHSCOMP, LPOS_ROW, NB_FS_IN_RHSCOMP )
+     &          POSINRHSINTR, LPOS_ROW, NB_FS_IN_RHSINTR )
       IMPLICIT NONE
       INCLUDE 'mpif.h'
       INCLUDE 'mumps_tags.h'
       INTEGER NSLAVES, N, MYID, COMM
-      INTEGER NRHS, LRHSCOMP, NRHSCOMP_COL 
-      COMPLEX(kind=8), intent(in) :: RHSCOMP (LRHSCOMP, NRHSCOMP_COL)
+      INTEGER NRHS, LRHSINTR, NRHSINTR_COL 
+      COMPLEX(kind=8), intent(in) :: RHSINTR (LRHSINTR, NRHSINTR_COL)
       INTEGER KEEP(500)
       INTEGER SIZE_BUF, SIZE_BUF_BYTES, LPOS_ROW
       INTEGER BUFFER(SIZE_BUF)
       INTEGER, intent(in) :: LIRHS_PTR_COPY, LIRHS_SPARSE_COPY, 
      &                       LRHS_SPARSE_COPY, LUNS_PERM_INV, 
-     &                       NB_FS_IN_RHSCOMP
+     &                       NB_FS_IN_RHSINTR
       INTEGER :: IRHS_SPARSE_COPY(LIRHS_SPARSE_COPY), 
      &           IRHS_PTR_COPY(LIRHS_PTR_COPY), 
      &           UNS_PERM_INV(LUNS_PERM_INV), 
-     &           POSINRHSCOMP(LPOS_ROW) 
+     &           POSINRHSINTR(LPOS_ROW) 
       COMPLEX(kind=8) :: RHS_SPARSE_COPY(LRHS_SPARSE_COPY)
-      LOGICAL, intent(in) :: LSCAL
+#if defined(USE_OLD_SCALING)
       INTEGER, intent(in) :: LSCALING
       DOUBLE PRECISION, intent(in)    :: SCALING(LSCALING)
+#else
+      INTEGER, intent(in) :: LSCALING_LOC_BWD
+      DOUBLE PRECISION, intent(in) :: SCALING_LOC_BWD(LSCALING_LOC_BWD)
+#endif
+      LOGICAL, intent(in) :: LSCAL
       INTEGER COLSIZE, K, IZ, IPREV, NBCOL_INBLOC
       INTEGER I, II, J, MASTER,
-     &         TYPE_PARAL, N2RECV, IPOSINRHSCOMP
+     &         TYPE_PARAL, N2RECV, IPOSINRHSINTR
       INTEGER :: STATUS(MPI_STATUS_SIZE)
       INTEGER :: IERR
       PARAMETER(MASTER=0)
@@ -1510,15 +1638,20 @@ C
            DO IZ=IRHS_PTR_COPY(J), IRHS_PTR_COPY(J+1)-1
              I = IRHS_SPARSE_COPY(IZ)
              IF (KEEP(23).NE.0) I = UNS_PERM_INV(I)
-             IPOSINRHSCOMP = POSINRHSCOMP(I)
-             IF (IPOSINRHSCOMP.GT.0) THEN 
+             IPOSINRHSINTR = POSINRHSINTR(I)
+             IF (IPOSINRHSINTR.GT.0) THEN 
                 IF (LSCAL) THEN
-                 RHS_SPARSE_COPY(IZ)=
-     &                      RHSCOMP(IPOSINRHSCOMP,K)*SCALING(I)
+                  RHS_SPARSE_COPY(IZ)=
+     &                      RHSINTR(IPOSINRHSINTR,K)
+#if defined(USE_OLD_SCALING)
+     &                      * SCALING(I)
+#else
+     &                      * SCALING_LOC_BWD(IPOSINRHSINTR)
+#endif
                 ELSE
-                 RHS_SPARSE_COPY(IZ)=RHSCOMP(IPOSINRHSCOMP,K)
+                  RHS_SPARSE_COPY(IZ)=RHSINTR(IPOSINRHSINTR,K)
                 ENDIF
-             ENDIF          
+             ENDIF
            ENDDO
            K = K + 1
         ENDDO
@@ -1532,9 +1665,18 @@ C
            DO IZ=IRHS_PTR_COPY(J), IRHS_PTR_COPY(J+1)-1
              I = IRHS_SPARSE_COPY(IZ)
              IF (KEEP(23).NE.0) I = UNS_PERM_INV(I)
-             IPOSINRHSCOMP = POSINRHSCOMP(I)
-             IF (IPOSINRHSCOMP.GT.0) THEN 
-               RHS_SPARSE_COPY(IZ)=RHSCOMP(IPOSINRHSCOMP,K)
+             IPOSINRHSINTR = POSINRHSINTR(I)
+             IF (IPOSINRHSINTR.GT.0) THEN 
+#if ! defined(USE_OLD_SCALING)
+               IF (LSCAL) THEN
+                 RHS_SPARSE_COPY(IZ)=RHSINTR(IPOSINRHSINTR,K)
+     &           * SCALING_LOC_BWD(IPOSINRHSINTR)
+               ELSE
+#endif
+                 RHS_SPARSE_COPY(IZ)=RHSINTR(IPOSINRHSINTR,K)
+#if ! defined(USE_OLD_SCALING)
+               ENDIF
+#endif
              ENDIF          
            ENDDO
            K = K + 1
@@ -1566,19 +1708,25 @@ C
              I = IRHS_SPARSE_COPY(IZ)
              II = I
              IF  (KEEP(23).NE.0) II = UNS_PERM_INV(I)
-             IPOSINRHSCOMP = POSINRHSCOMP(II)
-             IF (IPOSINRHSCOMP.GT.0) THEN
+             IPOSINRHSINTR = POSINRHSINTR(II)
+             IF (IPOSINRHSINTR.GT.0) THEN
                IF (MYID .EQ. MASTER) THEN
                   N2RECV=N2RECV-1
+#if defined(USE_OLD_SCALING)
                   IF (LSCAL) 
      &            CALL ZMUMPS_AM1_BLOCK_ADD ( .TRUE. )
+#endif
                   IRHS_SPARSE_COPY( IRHS_PTR_COPY(J) + K) =
      &               I
                   RHS_SPARSE_COPY( IRHS_PTR_COPY(J) + K) =
      &                RHS_SPARSE_COPY(IZ)
                   K = K+1 
                ELSE
-                  CALL ZMUMPS_AM1_BLOCK_ADD (  .FALSE. )
+#if defined(USE_OLD_SCALING)
+                  CALL ZMUMPS_AM1_BLOCK_ADD ( .FALSE. )
+#else
+                  CALL ZMUMPS_AM1_BLOCK_ADD ()
+#endif
                ENDIF
               ENDIF          
             ENDDO
@@ -1603,10 +1751,12 @@ C
           CALL MPI_UNPACK(BUFFER, SIZE_BUF_BYTES, POS_BUF,
      &             RHS_SPARSE_COPY(IZ), 1, MPI_DOUBLE_COMPLEX,
      &             COMM, IERR)
+#if defined(USE_OLD_SCALING)
           IF (LSCAL) THEN
               IF (KEEP(23).NE.0) I = UNS_PERM_INV(I)
               RHS_SPARSE_COPY(IZ) = RHS_SPARSE_COPY(IZ)*SCALING(I)    
           ENDIF
+#endif
           N2RECV=N2RECV-1
           IRHS_PTR_COPY(J) = IRHS_PTR_COPY(J) + 1
           CALL MPI_UNPACK( BUFFER, SIZE_BUF_BYTES, POS_BUF,
@@ -1622,10 +1772,21 @@ C
       ENDIF
       RETURN
       CONTAINS
-        SUBROUTINE ZMUMPS_AM1_BLOCK_ADD ( SCALE_ONLY )
+        SUBROUTINE ZMUMPS_AM1_BLOCK_ADD (
+#if defined(USE_OLD_SCALING)
+     &                                    SCALE_ONLY 
+#endif
+     &                                               )
+#if defined(USE_OLD_SCALING)
         LOGICAL, intent(in) ::  SCALE_ONLY    
+#endif
+#if defined(USE_OLD_SCALING)
         INTEGER III
+#endif
+#if defined(USE_OLD_SCALING)
         IF (SCALE_ONLY) THEN
+          WRITE(*,*) "ZMUMPS_AM1_BLOCK_ADD(true) should not be called"
+          CALL MUMPS_ABORT()
          III = I
          IF (KEEP(23).NE.0) III = UNS_PERM_INV(I)
          IF (LSCAL) THEN
@@ -1633,6 +1794,7 @@ C
          ENDIF
          RETURN
         ENDIF
+#endif
         CALL MPI_PACK(J, 1, MPI_INTEGER, BUFFER,
      &                SIZE_BUF_BYTES, POS_BUF, COMM, IERR )
         CALL MPI_PACK(I, 1, MPI_INTEGER, BUFFER,
@@ -1661,8 +1823,11 @@ C
       SUBROUTINE ZMUMPS_DISTSOL_INDICES(MTYPE, ISOL_LOC,
      &             PTRIST, KEEP,KEEP8,
      &             IW, LIW_PASSED, MYID_NODES, N, STEP,
-     &             PROCNODE, NSLAVES, scaling_data, LSCAL
-     &             , IRHS_loc_MEANINGFUL, IRHS_loc, Nloc_RHS
+     &             PROCNODE, NSLAVES,
+#if defined(USE_OLD_SCALING)
+     &             scaling_data, LSCAL,
+#endif
+     &             IRHS_loc_MEANINGFUL, IRHS_loc, Nloc_RHS
      &             )
       IMPLICIT NONE
       INTEGER MTYPE, MYID_NODES, N, NSLAVES
@@ -1673,16 +1838,21 @@ C
       INTEGER LIW_PASSED
       INTEGER IW(LIW_PASSED)
       INTEGER STEP(N)
+#if defined(USE_OLD_SCALING)
       LOGICAL LSCAL
+#endif
       LOGICAL :: IRHS_loc_MEANINGFUL
       INTEGER :: Nloc_RHS
       INTEGER :: IRHS_loc(Nloc_RHS)
+#if defined(USE_OLD_SCALING)
       type scaling_data_t
         SEQUENCE
         DOUBLE PRECISION, dimension(:), pointer :: SCALING
         DOUBLE PRECISION, dimension(:), pointer :: SCALING_LOC
+        INTEGER, dimension(:), pointer :: SCALING_IND 
       end type scaling_data_t
       type (scaling_data_t) :: scaling_data
+#endif
       INTEGER MUMPS_PROCNODE
       EXTERNAL MUMPS_PROCNODE
       INTEGER ISTEP, K
@@ -1720,49 +1890,103 @@ C
                     ENDIF
                   ENDIF
                   ISOL_LOC(K)=IW(JJ)
+#if defined(USE_OLD_SCALING)
                   IF (LSCAL) THEN
                     scaling_data%SCALING_LOC(K)=
      &              scaling_data%SCALING(IW(JJ))
                   ENDIF
+#endif
               ENDDO
           ENDIF
       ENDDO
       RETURN
       END SUBROUTINE ZMUMPS_DISTSOL_INDICES
+#if ! defined(USE_OLD_SCALING)
+      SUBROUTINE ZMUMPS_SCALINGRHSINTR(LSCAL, N,
+     &           SCALING_LOC, SCALING_RHSINTR,
+     &           L, POSINRHSINTR, KEEP, ROWORCOL, PTRIST,
+     &           IW, LIW_PASSED, MYID_NODES, STEP,
+     &           PROCNODE, NSLAVES)
+      IMPLICIT NONE
+      INTEGER              :: KEEP(500)
+      LOGICAL, INTENT(IN)  :: LSCAL
+      INTEGER, INTENT(IN)  :: N, L
+      INTEGER, INTENT(IN)  :: POSINRHSINTR(N)
+      DOUBLE PRECISION   , INTENT(IN)  :: SCALING_LOC(max(KEEP(89),1))
+      DOUBLE PRECISION   , INTENT(OUT) :: SCALING_RHSINTR(L)
+      INTEGER, INTENT(IN)  :: ROWORCOL, NSLAVES, LIW_PASSED, MYID_NODES
+      INTEGER, INTENT(IN)  :: STEP(KEEP(28)),
+     &                        PROCNODE(KEEP(28)),
+     &                        PTRIST(KEEP(28)),
+     &                        IW(LIW_PASSED)
+      INTEGER :: IPOSINRHSINTR
+      INTEGER, EXTERNAL :: MUMPS_PROCNODE
+      INTEGER :: ISTEP
+      INTEGER :: KLOC, J1, JJ, LIELL, IPOS, NPIV
+      IF (.NOT. LSCAL) THEN
+        WRITE(*,*) "Internal error 1 in ZMUMPS_DS_SCALINGRHSINTR"
+        CALL MUMPS_ABORT()
+      ENDIF
+      IF (ROWORCOL .NE. 1 .AND. ROWORCOL.NE.2) THEN
+        WRITE(*,*) "Internal error 2 in ZMUMPS_DS_SCALINGRHSINTR",
+     &  ROWORCOL
+      ENDIF
+      IF (KEEP(89).EQ.0) RETURN
+      KLOC = 1
+      DO ISTEP=1, KEEP(28)
+        IF ( MYID_NODES == MUMPS_PROCNODE( PROCNODE(ISTEP),
+     &               KEEP(199))) THEN
+          CALL MUMPS_SOL_GET_NPIV_LIELL_IPOS( ISTEP, KEEP,
+     &    NPIV, LIELL, IPOS, IW, LIW_PASSED, PTRIST, STEP, N)
+          IF (ROWORCOL .EQ. 1) THEN
+               J1=IPOS+1
+          ELSE
+               J1=IPOS+1+LIELL
+          END IF
+          IPOSINRHSINTR = POSINRHSINTR(IW(J1)) 
+          IF ( IPOSINRHSINTR .GT. 0 ) THEN
+            DO JJ=1, NPIV
+             SCALING_RHSINTR(IPOSINRHSINTR+JJ-1) =
+     &       SCALING_LOC(KLOC+JJ-1)
+            ENDDO
+          ENDIF
+          KLOC = KLOC + NPIV
+        ENDIF
+      ENDDO
+      RETURN
+      END SUBROUTINE ZMUMPS_SCALINGRHSINTR
+#endif
       SUBROUTINE ZMUMPS_DISTRIBUTED_SOLUTION(
      &           SLAVEF, N, MYID_NODES,
-     &           MTYPE, RHSCOMP, LRHSCOMP, NBRHS_EFF,
-     &           POSINRHSCOMP,
+     &           MTYPE, RHSINTR, LRHSINTR, NBRHS_EFF,
+     &           POSINRHSINTR,
      &           ISOL_LOC, 
      &           SOL_LOC, NRHS, BEG_RHS, LSOL_LOC,
      &           PTRIST,
      &           PROCNODE_STEPS, KEEP,KEEP8, IW, LIW, STEP,
-     &           scaling_data, LSCAL, NB_RHSSKIPPED,
+     &           SCALING_LOC_BWD, LSCALING_LOC_BWD,
+     &           LSCAL, NB_RHSSKIPPED,
      &           PERM_RHS, SIZE_PERM_RHS)
       IMPLICIT NONE
       INCLUDE 'mpif.h'
       INCLUDE 'mumps_tags.h'
-      type scaling_data_t
-        SEQUENCE
-        DOUBLE PRECISION, dimension(:), pointer :: SCALING
-        DOUBLE PRECISION, dimension(:), pointer :: SCALING_LOC
-      end type scaling_data_t
-      TYPE (scaling_data_t) :: scaling_data
-      LOGICAL LSCAL
-      INTEGER SLAVEF, N, MYID_NODES, LIW, MTYPE, NBRHS_EFF, LRHSCOMP
-      INTEGER POSINRHSCOMP(N), NB_RHSSKIPPED
+      LOGICAL, intent(in) :: LSCAL
+      INTEGER, intent(in) :: LSCALING_LOC_BWD
+      DOUBLE PRECISION, intent(in) :: SCALING_LOC_BWD(LSCALING_LOC_BWD)
+      INTEGER SLAVEF, N, MYID_NODES, LIW, MTYPE, NBRHS_EFF, LRHSINTR
+      INTEGER POSINRHSINTR(N), NB_RHSSKIPPED
       INTEGER LSOL_LOC, BEG_RHS
       INTEGER ISOL_LOC(LSOL_LOC)
       INTEGER, INTENT(in) :: NRHS 
       COMPLEX(kind=8) SOL_LOC( LSOL_LOC, NRHS )
-      COMPLEX(kind=8) RHSCOMP( LRHSCOMP, NBRHS_EFF )
+      COMPLEX(kind=8) RHSINTR( LRHSINTR, NBRHS_EFF )
       INTEGER KEEP(500)
       INTEGER(8) KEEP8(150)
       INTEGER PTRIST(KEEP(28)), PROCNODE_STEPS(KEEP(28))
       INTEGER IW(LIW), STEP(N)
       INTEGER, INTENT(in) :: SIZE_PERM_RHS
       INTEGER, INTENT(in) :: PERM_RHS( SIZE_PERM_RHS )
-      INTEGER :: JJ, J1, ISTEP, K, KLOC, IPOSINRHSCOMP, JEMPTY
+      INTEGER :: JJ, J1, ISTEP, K, KLOC, IPOSINRHSINTR, JEMPTY
       INTEGER :: JCOL, JCOL_PERM
       INTEGER :: IPOS, LIELL, NPIV, JEND
       LOGICAL :: ROOT
@@ -1814,7 +2038,7 @@ C
             ENDIF
 !$            OMP_FLAG = ( JEND-JEMPTY.GE.KEEP(362) .AND.
 !$   &                     (NPIV*(JEND-JEMPTY) .GE. KEEP(363)/2 ) )
-!$OMP PARALLEL DO PRIVATE(JCOL,JCOL_PERM,KLOC,JJ,IPOSINRHSCOMP) 
+!$OMP PARALLEL DO PRIVATE(JCOL,JCOL_PERM,KLOC,JJ,IPOSINRHSINTR) 
 !$OMP&         IF(OMP_FLAG)
             DO JCOL = JEMPTY+1, JEND
               IF (KEEP(242) .NE. 0) THEN
@@ -1824,14 +2048,13 @@ C
               ENDIF
               DO JJ=J1,J1+NPIV-1
                  KLOC=K + JJ-J1 + 1
-                IPOSINRHSCOMP = POSINRHSCOMP(IW(JJ))
                 IF (LSCAL) THEN
                   SOL_LOC(KLOC,JCOL_PERM) =
-     &            scaling_data%SCALING_LOC(KLOC)*
-     &            RHSCOMP(IPOSINRHSCOMP,JCOL-JEMPTY)
+     &            SCALING_LOC_BWD(KLOC)*
+     &            RHSINTR(KLOC,JCOL-JEMPTY)
                 ELSE
                   SOL_LOC(KLOC,JCOL_PERM) =
-     &            RHSCOMP(IPOSINRHSCOMP,JCOL-JEMPTY)
+     &            RHSINTR(KLOC,JCOL-JEMPTY)
                 ENDIF
               ENDDO
             ENDDO
@@ -1843,9 +2066,10 @@ C
       END SUBROUTINE ZMUMPS_DISTRIBUTED_SOLUTION
       SUBROUTINE ZMUMPS_SCATTER_RHS
      &           (NSLAVES, N, MYID, COMM,
+     &           LSCAL, SCALING_LOC_FWD,
      &           MTYPE, RHS, LRHS, NCOL_RHS, NRHS,
-     &           RHSCOMP, LRHSCOMP, NCOL_RHSCOMP,
-     &           POSINRHSCOMP_FWD, NB_FS_IN_RHSCOMP_F,
+     &           RHSINTR, LRHSINTR, NCOL_RHSINTR,
+     &           POSINRHSINTR_FWD, NB_FS_IN_RHSINTR_F,
      &           PTRIST,
      &           KEEP,KEEP8, PROCNODE_STEPS, IW, LIW, STEP, 
      &           ICNTL, INFO)
@@ -1854,15 +2078,17 @@ C
       INCLUDE 'mpif.h'
       INCLUDE 'mumps_tags.h'
       INTEGER NSLAVES, N, MYID, COMM, LIW, MTYPE
-      INTEGER NRHS, LRHS, NCOL_RHS,  LRHSCOMP, NCOL_RHSCOMP
+      INTEGER NRHS, LRHS, NCOL_RHS,  LRHSINTR, NCOL_RHSINTR
       INTEGER ICNTL(60), INFO(80)
       COMPLEX(kind=8), intent(in)  :: RHS (LRHS, NCOL_RHS)
-      COMPLEX(kind=8), intent(out) :: RHSCOMP(LRHSCOMP, NCOL_RHSCOMP)
-      INTEGER, intent(in)  :: POSINRHSCOMP_FWD(N), NB_FS_IN_RHSCOMP_F
+      COMPLEX(kind=8), intent(out) :: RHSINTR(LRHSINTR, NCOL_RHSINTR)
+      INTEGER, intent(in)  :: POSINRHSINTR_FWD(N), NB_FS_IN_RHSINTR_F
       INTEGER KEEP(500)
       INTEGER(8) KEEP8(150)
       INTEGER PTRIST(KEEP(28)), PROCNODE_STEPS(KEEP(28))
       INTEGER IW(LIW), STEP(N) 
+      LOGICAL, intent(in) :: LSCAL
+      DOUBLE PRECISION, intent(in) :: SCALING_LOC_FWD(max(1,KEEP(89)))
       INTEGER BUF_MAXSIZE, BUF_MAXREF
       PARAMETER (BUF_MAXREF=200000)
       INTEGER, ALLOCATABLE, DIMENSION(:) :: BUF_INDX
@@ -1913,10 +2139,10 @@ C
       IF (MYID.EQ.MASTER) THEN
         ENTRIES_2_PROCESS = N - KEEP(89)
         IF (TYPE_PARAL.EQ.1.AND.ENTRIES_2_PROCESS.NE.0) THEN
-         IF (NB_FS_IN_RHSCOMP_F.LT.LRHSCOMP) THEN
-           DO K=1, NCOL_RHSCOMP
-            DO I = NB_FS_IN_RHSCOMP_F +1, LRHSCOMP
-             RHSCOMP (I, K) = ZERO
+         IF (NB_FS_IN_RHSINTR_F.LT.LRHSINTR) THEN
+           DO K=1, NCOL_RHSINTR
+            DO I = NB_FS_IN_RHSINTR_F +1, LRHSINTR
+             RHSINTR (I, K) = ZERO
             ENDDO
            ENDDO
          ENDIF
@@ -1973,10 +2199,10 @@ C
       ENDIF
       IF (I_AM_SLAVE) THEN
         IF (MYID.NE.MASTER) THEN
-         IF (NB_FS_IN_RHSCOMP_F.LT.LRHSCOMP) THEN
-           DO K=1, NCOL_RHSCOMP
-            DO I = NB_FS_IN_RHSCOMP_F +1, LRHSCOMP
-             RHSCOMP (I, K) = ZERO
+         IF (NB_FS_IN_RHSINTR_F.LT.LRHSINTR) THEN
+           DO K=1, NCOL_RHSINTR
+            DO I = NB_FS_IN_RHSINTR_F +1, LRHSINTR
+             RHSINTR (I, K) = ZERO
             ENDDO
            ENDDO
          ENDIF
@@ -1992,7 +2218,7 @@ C
                    J1=IPOS+1+LIELL
               END IF
               IF (MYID.EQ.MASTER) THEN
-                INDX = POSINRHSCOMP_FWD(IW(J1))
+                INDX = POSINRHSINTR_FWD(IW(J1))
                 IF (KEEP(350).EQ.2 .AND.
      &   (NRHS.EQ.1.OR.((NPIV*NRHS*2*KEEP(16)).GE.KEEP(364)))) THEN
 !$                 OMP_FLAG = .FALSE.
@@ -2001,22 +2227,53 @@ C
 !$                   OMP_FLAG = .TRUE.
 !$                   CHUNK = max((NPIV*NRHS+NOMP-1)/NOMP,KEEP(363)/2)
 !$                 ENDIF
+#if ! defined(USE_OLD_SCALING)
+                  IF (LSCAL) THEN
+!$OMP PARALLEL DO COLLAPSE(2) SCHEDULE(STATIC,CHUNK) PRIVATE(J,JJ)
+!$OMP&  FIRSTPRIVATE(INDX) IF (OMP_FLAG)
+                     DO K = 1, NRHS
+                       DO JJ=J1,J1+NPIV-1
+                         J=IW(JJ)
+                         RHSINTR( INDX+JJ-J1, K ) = RHS( J, K ) *
+     &                   SCALING_LOC_FWD( INDX+JJ-J1 )
+                       ENDDO
+                     ENDDO
+!$OMP END PARALLEL DO
+                  ELSE
+#endif
 !$OMP PARALLEL DO COLLAPSE(2) SCHEDULE(STATIC,CHUNK) PRIVATE(J,JJ)
 !$OMP&  FIRSTPRIVATE(INDX) IF (OMP_FLAG)
-                   DO K = 1, NRHS
+                    DO K = 1, NRHS
                       DO JJ=J1,J1+NPIV-1
                          J=IW(JJ)
-                         RHSCOMP( INDX+JJ-J1, K ) = RHS( J, K )
+                         RHSINTR( INDX+JJ-J1, K ) = RHS( J, K )
                       ENDDO
-                   ENDDO
+                    ENDDO
 !$OMP END PARALLEL DO
+#if ! defined(USE_OLD_SCALING)
+                  ENDIF
+#endif
                 ELSE 
+#if ! defined(USE_OLD_SCALING)
+                  IF (LSCAL) THEN
+                   DO JJ=J1,J1+NPIV-1
+                      J=IW(JJ)
+                      DO K = 1, NRHS
+                         RHSINTR( INDX+JJ-J1, K ) = RHS( J, K )
+     &                 * SCALING_LOC_FWD( INDX + JJ - J1 )
+                      ENDDO
+                   ENDDO
+                  ELSE
+#endif
                    DO JJ=J1,J1+NPIV-1
                       J=IW(JJ)
                       DO K = 1, NRHS
-                         RHSCOMP( INDX+JJ-J1, K ) = RHS( J, K )
+                         RHSINTR( INDX+JJ-J1, K ) = RHS( J, K )
                       ENDDO
                    ENDDO
+#if ! defined(USE_OLD_SCALING)
+                  ENDIF
+#endif
                 END IF 
               ELSE
                 DO JJ=J1,J1+NPIV-1
@@ -2053,40 +2310,72 @@ C
 !$                    OMP_FLAG = .TRUE.
 !$              CHUNK = max((BUF_EFFSIZE*NRHS+NOMP-1)/NOMP,KEEP(363)/2)
 !$                  ENDIF
+#if ! defined(USE_OLD_SCALING)
+                    IF (LSCAL) THEN
 !$OMP PARALLEL DO COLLAPSE(2) SCHEDULE(STATIC,CHUNK) PRIVATE(INDX)
 !$OMP&  IF (OMP_FLAG)
-                    DO K = 1, NRHS
+                      DO K = 1, NRHS
                         DO I = 1, BUF_EFFSIZE
-                           INDX = POSINRHSCOMP_FWD(BUF_INDX(I))
-                           RHSCOMP( INDX, K ) =
-     &                              BUF_RHS_2( I+(K-1)*BUF_EFFSIZE)
+                           INDX = POSINRHSINTR_FWD(BUF_INDX(I))
+                          RHSINTR( INDX, K ) =
+     &                           BUF_RHS_2( I+(K-1)*BUF_EFFSIZE) *
+     &                           SCALING_LOC_FWD( INDX )
                         ENDDO
-                     ENDDO
+                      ENDDO
+!$OMP END PARALLEL DO
+                    ELSE
+#endif
+!$OMP PARALLEL DO COLLAPSE(2) SCHEDULE(STATIC,CHUNK) PRIVATE(INDX)
+!$OMP&  IF (OMP_FLAG)
+                      DO K = 1, NRHS
+                        DO I = 1, BUF_EFFSIZE
+                           INDX = POSINRHSINTR_FWD(BUF_INDX(I))
+                          RHSINTR( INDX, K ) =
+     &                           BUF_RHS_2( I+(K-1)*BUF_EFFSIZE)
+                        ENDDO
+                      ENDDO
 !$OMP END PARALLEL DO
+#if ! defined(USE_OLD_SCALING)
+                    ENDIF
+#endif
                    ELSE
                      CALL MPI_RECV(BUF_RHS, BUF_EFFSIZE*NRHS,
      &                 MPI_DOUBLE_COMPLEX,
      &                 MASTER,
      &                 ScatterRhsR, COMM, STATUS, IERR )
+#if ! defined(USE_OLD_SCALING)
+                     IF (LSCAL) THEN
+                     DO I = 1, BUF_EFFSIZE
+                        INDX = POSINRHSINTR_FWD(BUF_INDX(I))
+                        DO K = 1, NRHS
+                           RHSINTR( INDX, K ) = BUF_RHS( K, I )
+     &                     * SCALING_LOC_FWD( INDX )
+                        ENDDO
+                     ENDDO
+                     ELSE
+#endif
                      DO I = 1, BUF_EFFSIZE
-                        INDX = POSINRHSCOMP_FWD(BUF_INDX(I))
+                        INDX = POSINRHSINTR_FWD(BUF_INDX(I))
                         DO K = 1, NRHS
-                           RHSCOMP( INDX, K ) = BUF_RHS( K, I )
+                           RHSINTR( INDX, K ) = BUF_RHS( K, I )
                         ENDDO
                      ENDDO
+#if ! defined(USE_OLD_SCALING)
+                     ENDIF
+#endif
                   END IF 
                   BUF_EFFSIZE = 0
                   RETURN
                   END SUBROUTINE ZMUMPS_GET_BUF_INDX_RHS
       END SUBROUTINE ZMUMPS_SCATTER_RHS
-      SUBROUTINE ZMUMPS_BUILD_POSINRHSCOMP
+      SUBROUTINE ZMUMPS_BUILD_GLOB2LOC
      &           (NSLAVES, N, MYID_NODES,
      &           PTRIST,
      &           KEEP,KEEP8, PROCNODE_STEPS, IW, LIW, STEP, 
-     &           POSINRHSCOMP_ROW, POSINRHSCOMP_COL,
-     &           POSINRHSCOMP_COL_ALLOC,
+     &           GLOB2LOC_RHS, GLOB2LOC_SOL,
+     &           GLOB2LOC_SOL_ALLOC,
      &           MTYPE,
-     &           NBENT_RHSCOMP, NB_FS_IN_RHSCOMP )
+     &           NBENT_RHSINTR, NB_FS_IN_RHSINTR )
       IMPLICIT NONE
       INCLUDE 'mpif.h'
       INCLUDE 'mumps_tags.h'
@@ -2096,20 +2385,20 @@ C
       INTEGER, intent(in) :: PTRIST(KEEP(28)), PROCNODE_STEPS(KEEP(28))
       INTEGER, intent(in) :: IW(LIW), STEP(N)
       INTEGER, intent(in) :: MTYPE 
-      LOGICAL, intent(in) :: POSINRHSCOMP_COL_ALLOC
-      INTEGER, intent(out):: POSINRHSCOMP_ROW(N),POSINRHSCOMP_COL(N) 
-      INTEGER, intent(out):: NBENT_RHSCOMP, NB_FS_IN_RHSCOMP
+      LOGICAL, intent(in) :: GLOB2LOC_SOL_ALLOC
+      INTEGER, intent(out):: GLOB2LOC_RHS(N), GLOB2LOC_SOL(N) 
+      INTEGER, intent(out):: NBENT_RHSINTR, NB_FS_IN_RHSINTR
       INTEGER ISTEP
       INTEGER NPIV
       INTEGER IPOS, LIELL
       INTEGER JJ, J1, JCOL
-      INTEGER IPOSINRHSCOMP, IPOSINRHSCOMP_COL
+      INTEGER IPOSINRHSINTR, IPOSINRHSINTR_SOL
       INCLUDE 'mumps_headers.h'
       INTEGER MUMPS_PROCNODE
       EXTERNAL MUMPS_PROCNODE
-      POSINRHSCOMP_ROW = 0
-      IF (POSINRHSCOMP_COL_ALLOC) POSINRHSCOMP_COL = 0
-      IPOSINRHSCOMP   = 1     
+      GLOB2LOC_RHS = 0
+      IF (GLOB2LOC_SOL_ALLOC) GLOB2LOC_SOL = 0
+      IPOSINRHSINTR   = 1     
       DO ISTEP = 1, KEEP(28)
         IF (MYID_NODES == MUMPS_PROCNODE(PROCNODE_STEPS(ISTEP),
      &     KEEP(199))) THEN
@@ -2126,19 +2415,19 @@ C
                    JCOL = IPOS+1
            ENDIF
            DO JJ = J1, J1+NPIV-1
-                POSINRHSCOMP_ROW(IW(JJ)) = IPOSINRHSCOMP+JJ-J1
+                GLOB2LOC_RHS(IW(JJ)) = IPOSINRHSINTR+JJ-J1
            ENDDO
-           IF (POSINRHSCOMP_COL_ALLOC) THEN
+           IF (GLOB2LOC_SOL_ALLOC) THEN
              DO JJ = JCOL, JCOL+NPIV-1
-               POSINRHSCOMP_COL(IW(JJ)) = IPOSINRHSCOMP+JJ-JCOL
+               GLOB2LOC_SOL(IW(JJ)) = IPOSINRHSINTR+JJ-JCOL
              ENDDO
            ENDIF
-           IPOSINRHSCOMP       = IPOSINRHSCOMP + NPIV
+           IPOSINRHSINTR       = IPOSINRHSINTR + NPIV
         ENDIF
       ENDDO
-      NB_FS_IN_RHSCOMP = IPOSINRHSCOMP -1
-      IF (POSINRHSCOMP_COL_ALLOC) IPOSINRHSCOMP_COL=IPOSINRHSCOMP
-      IF (IPOSINRHSCOMP.GT.N) GOTO 500 
+      NB_FS_IN_RHSINTR = IPOSINRHSINTR -1
+      IF (GLOB2LOC_SOL_ALLOC) IPOSINRHSINTR_SOL=IPOSINRHSINTR
+      IF (IPOSINRHSINTR.GT.N) GOTO 500 
       DO ISTEP = 1, KEEP(28)
         IF (MYID_NODES == MUMPS_PROCNODE(PROCNODE_STEPS(ISTEP),
      &     KEEP(199))) THEN
@@ -2154,92 +2443,267 @@ C
            ELSE
                    JCOL = IPOS+1
            ENDIF
-           IF (POSINRHSCOMP_COL_ALLOC) THEN
+           IF (GLOB2LOC_SOL_ALLOC) THEN
             DO JJ = NPIV, LIELL-1-KEEP(253)
-              IF (POSINRHSCOMP_ROW(IW(J1+JJ)).EQ.0) THEN
-               POSINRHSCOMP_ROW(IW(J1+JJ)) = - IPOSINRHSCOMP
-               IPOSINRHSCOMP = IPOSINRHSCOMP + 1
-              ENDIF
-              IF (POSINRHSCOMP_COL(IW(JCOL+JJ)).EQ.0) THEN
-               POSINRHSCOMP_COL(IW(JCOL+JJ)) = - IPOSINRHSCOMP_COL
-               IPOSINRHSCOMP_COL = IPOSINRHSCOMP_COL + 1
+              IF (GLOB2LOC_RHS(IW(J1+JJ)).EQ.0) THEN
+               GLOB2LOC_RHS(IW(J1+JJ)) = - IPOSINRHSINTR
+               IPOSINRHSINTR = IPOSINRHSINTR + 1
+              ENDIF
+              IF (GLOB2LOC_SOL(IW(JCOL+JJ)).EQ.0) THEN
+               GLOB2LOC_SOL(IW(JCOL+JJ)) = - IPOSINRHSINTR_SOL
+               IPOSINRHSINTR_SOL = IPOSINRHSINTR_SOL + 1
               ENDIF
              ENDDO
            ELSE
              DO JJ = J1+NPIV, J1+LIELL-1-KEEP(253)
-              IF (POSINRHSCOMP_ROW(IW(JJ)).EQ.0) THEN
-               POSINRHSCOMP_ROW(IW(JJ)) = - IPOSINRHSCOMP
-               IPOSINRHSCOMP = IPOSINRHSCOMP + 1
+              IF (GLOB2LOC_RHS(IW(JJ)).EQ.0) THEN
+               GLOB2LOC_RHS(IW(JJ)) = - IPOSINRHSINTR
+               IPOSINRHSINTR = IPOSINRHSINTR + 1
               ENDIF
              ENDDO
            ENDIF
         ENDIF
       ENDDO
- 500  NBENT_RHSCOMP = IPOSINRHSCOMP - 1
-      IF (POSINRHSCOMP_COL_ALLOC) 
-     &     NBENT_RHSCOMP = max(NBENT_RHSCOMP, IPOSINRHSCOMP_COL-1)
+ 500  NBENT_RHSINTR = IPOSINRHSINTR - 1
+      IF (GLOB2LOC_SOL_ALLOC) 
+     &     NBENT_RHSINTR = max(NBENT_RHSINTR, IPOSINRHSINTR_SOL-1)
       RETURN
-      END SUBROUTINE ZMUMPS_BUILD_POSINRHSCOMP
-      SUBROUTINE ZMUMPS_BUILD_POSINRHSCOMP_AM1
-     &           (NSLAVES, N, MYID_NODES,
+      END SUBROUTINE ZMUMPS_BUILD_GLOB2LOC
+      SUBROUTINE ZMUMPS_NODES_FWD_BWD_SIZE_FILL (
+     &           fill, ICNTL,
+     &           N, NSTEPS, KEEP, STEP, Step2node,
+     &           IRHS_loc, Nloc_RHS, 
+     &           IRHS_PTR, NBCOL_INBLOC, IRHS_SPARSE, NZ_RHS,
+     &           PERM_RHS, SIZE_PERM_RHS, JBEG_RHS,
+     &           UNS_PERM_INV, SIZE_UNS_PERM_INV,
+     &           ICNTL21, 
+     &           MYID, COMM,
+     &           INFO, 
+     &           Pruned_Sons_FWD, Pruned_Sons_BWD, 
+     &           Lnodes_FWD, Lnodes_BWD
+     &           , nodes_FWD, nodes_BWD
+     &           , Lnodes_FWD_in, Lnodes_BWD_in
+     &           )
+      USE ZMUMPS_SOL_ES, ONLY : ZMUMPS_ES_NODES_SIZE_AND_FILL
+      IMPLICIT NONE
+      LOGICAL, INTENT(IN)  :: fill
+      INTEGER, INTENT(IN)  :: ICNTL(60),N, NSTEPS, KEEP(500) 
+      INTEGER, INTENT(IN)  :: STEP(N), Step2node(NSTEPS)
+      INTEGER, INTENT(IN)  :: Nloc_RHS, 
+     &                        IRHS_loc(max(1,Nloc_RHS))
+      INTEGER, intent(in) :: NBCOL_INBLOC, IRHS_PTR(NBCOL_INBLOC+1)
+      INTEGER, intent(in) :: NZ_RHS, IRHS_SPARSE(NZ_RHS)
+      INTEGER, intent(in) :: SIZE_PERM_RHS, PERM_RHS(SIZE_PERM_RHS)
+      INTEGER, intent(in) :: JBEG_RHS, SIZE_UNS_PERM_INV
+      INTEGER, intent(in) :: UNS_PERM_INV(SIZE_UNS_PERM_INV)
+      INTEGER, intent(IN)  :: ICNTL21
+      INTEGER, intent(in)  :: MYID, COMM
+      INTEGER, intent(inout) :: INFO(80)
+      INTEGER, intent(inout) :: Pruned_Sons_FWD(NSTEPS), 
+     &                          Pruned_Sons_BWD(NSTEPS)
+      INTEGER, intent(inout) :: Lnodes_FWD, Lnodes_BWD
+      INTEGER, intent(in) :: Lnodes_FWD_in, Lnodes_BWD_in
+      INTEGER, intent(out) :: nodes_FWD(Lnodes_FWD_in), 
+     &                        nodes_BWD(Lnodes_BWD_in)
+      INCLUDE 'mpif.h'
+      LOGICAL :: DO_PRUN_FWD, AM1, Exploit_Sparsity_FWD, 
+     &           Exploit_Sparsity_BWD
+      INTEGER :: Lnodes_FWD_loc, Lnodes_BWD_loc, ISTEP,
+     &           INODE_PRINC, I, II, JAM1
+#if defined(AVOID_MPI_IN_PLACE)
+      INTEGER, DIMENSION(:), ALLOCATABLE ::  TMP_INT_ARRAY
+#endif
+#if defined(AVOID_MPI_IN_PLACE)
+      ALLOCATE(TMP_INT_ARRAY(KEEP(28)), STAT = allocok)
+      IF(allocok.GT.0) THEN
+        INFO(1)=-13
+        INFO(2)=KEEP(28)
+      END IF
+      CALL MUMPS_PROPINFO(ICNTL, INFO, COMM, MYID )
+      IF(INFO(1).LT.0) GOTO 500
+#endif
+      AM1                  = (KEEP(237) .NE. 0)
+      Exploit_Sparsity_FWD = (KEEP(235) .NE. 0) .AND. (.NOT. AM1)
+      DO_PRUN_FWD          = (Exploit_Sparsity_FWD.OR.AM1)
+      Exploit_Sparsity_BWD = (KEEP(212) .NE. 0) .AND. (.NOT. AM1)
+      IF (.NOT.fill) Lnodes_FWD=-1
+      IF (.NOT.fill) Lnodes_BWD=-1
+      IF (.NOT.fill.AND.KEEP(252).NE.0) THEN
+        Lnodes_FWD = 0
+      ENDIF
+      IF ( KEEP(252).NE.0 ) DO_PRUN_FWD = .FALSE.  
+      IF ( DO_PRUN_FWD ) THEN
+        IF ( Exploit_Sparsity_FWD.AND.KEEP(248).EQ.-1 ) THEN
+         IF (.NOT.fill) THEN
+           CALL ZMUMPS_ES_NODES_SIZE_AND_FILL ( fill,
+     &           N, KEEP(28), KEEP, STEP, Step2node,
+     &           IRHS_loc, Nloc_RHS, MYID, COMM,
+     &           Pruned_Sons_FWD, Lnodes_FWD 
+#if defined(AVOID_MPI_IN_PLACE)
+     &           , TMP_INT_ARRAY
+#endif
+     &           )
+         ELSE IF (Lnodes_FWD.GT.0) THEN
+            CALL ZMUMPS_ES_NODES_SIZE_AND_FILL ( fill,
+     &           N, KEEP(28), KEEP, STEP, Step2node,
+     &           IRHS_loc, Nloc_RHS, MYID, COMM,
+     &           Pruned_Sons_FWD, Lnodes_FWD, 
+#if defined(AVOID_MPI_IN_PLACE)
+     &            TMP_INT_ARRAY, 
+#endif
+     &           nodes_FWD
+     &           )
+         ENDIF
+        ELSE IF ( Exploit_Sparsity_FWD.AND.KEEP(248).NE.-1 ) THEN
+           IF (.NOT.fill) THEN
+            Lnodes_FWD = 0
+            Pruned_Sons_FWD(:) = -1
+            DO I = 1, NZ_RHS
+               ISTEP       = abs( STEP(IRHS_SPARSE(I)) )
+               IF ( Pruned_Sons_FWD(ISTEP) .eq. -1) THEN
+                  Lnodes_FWD = Lnodes_FWD +1
+                  Pruned_Sons_FWD(ISTEP) = 0 
+               ENDIF
+            ENDDO
+           ELSE IF (Lnodes_FWD.GT.0) THEN
+            Lnodes_FWD_loc = 0
+            Pruned_Sons_FWD(:) = -1
+            DO I = 1, NZ_RHS
+               ISTEP       = abs( STEP(IRHS_SPARSE(I)) )
+               INODE_PRINC = Step2node( ISTEP )
+               IF ( Pruned_Sons_FWD(ISTEP) .eq. -1) THEN
+                  Lnodes_FWD_loc = Lnodes_FWD_loc +1
+                  nodes_FWD(Lnodes_FWD_loc)  = INODE_PRINC
+                  Pruned_Sons_FWD(ISTEP) = 0 
+               ENDIF
+            ENDDO
+           ENDIF
+        ELSE IF ( AM1 ) THEN  
+          IF (.NOT.fill) THEN
+            Lnodes_FWD = 0
+            Pruned_Sons_FWD(:) = -1
+            DO I = 1, NBCOL_INBLOC
+              IF ( (IRHS_PTR(I+1)-IRHS_PTR(I)).EQ.0) CYCLE
+              IF ( (KEEP(242) .NE. 0 ).OR. (KEEP(243).NE.0) ) THEN
+                   JAM1 = PERM_RHS(JBEG_RHS+I-1)
+              ELSE
+                   JAM1 = JBEG_RHS+I-1
+              ENDIF       
+              ISTEP = abs(STEP(JAM1))
+              INODE_PRINC = Step2node(ISTEP)
+              IF ( Pruned_Sons_FWD(ISTEP) .eq. -1) THEN
+                 Lnodes_FWD = Lnodes_FWD +1
+                 Pruned_Sons_FWD(ISTEP) = 0                 
+              ENDIF
+            ENDDO
+          ELSE IF (Lnodes_FWD.GT.0) THEN
+            Lnodes_FWD_loc = 0
+            Pruned_Sons_FWD = -1
+            DO I = 1, NBCOL_INBLOC
+              IF ( (IRHS_PTR(I+1)-IRHS_PTR(I)).EQ.0) CYCLE
+              IF ( (KEEP(242) .NE. 0 ).OR. (KEEP(243).NE.0) ) THEN
+                   JAM1 = PERM_RHS(JBEG_RHS+I-1)
+              ELSE
+                   JAM1 = JBEG_RHS+I-1
+              ENDIF
+              ISTEP = abs(STEP(JAM1))
+              INODE_PRINC = Step2node(ISTEP)
+              IF ( Pruned_Sons_FWD(ISTEP) .eq. -1) THEN
+                 Lnodes_FWD_loc = Lnodes_FWD_loc +1
+                 nodes_FWD(Lnodes_FWD_loc)  = INODE_PRINC
+                 Pruned_Sons_FWD(ISTEP) = 0
+              ENDIF
+            ENDDO            
+          ENDIF
+         ENDIF                  
+      ENDIF
+      IF (AM1) THEN
+        IF (.NOT.fill) THEN
+         Lnodes_BWD = 0
+         Pruned_Sons_BWD(:) = -1 
+         DO II = 1, NZ_RHS
+            I = IRHS_SPARSE(II)
+            IF (KEEP(23).NE.0) I = UNS_PERM_INV(I)          
+            ISTEP = abs(STEP(I))
+            IF ( Pruned_Sons_BWD(ISTEP) .eq. -1) THEN
+               Lnodes_BWD = Lnodes_BWD +1
+               Pruned_Sons_BWD(ISTEP) = 0
+            ENDIF
+         ENDDO
+        ELSE IF (Lnodes_BWD.GT.0) THEN
+         Lnodes_BWD_loc = 0         
+         Pruned_Sons_BWD(:) = -1  
+         DO II = 1, NZ_RHS
+            I = IRHS_SPARSE(II)
+            IF (KEEP(23).NE.0) I = UNS_PERM_INV(I)
+            ISTEP = abs(STEP(I))
+            INODE_PRINC = Step2node(ISTEP)
+            IF ( Pruned_Sons_BWD(ISTEP) .eq. -1) THEN
+               Lnodes_BWD_loc = Lnodes_BWD_loc +1
+               nodes_BWD(Lnodes_BWD_loc)  = INODE_PRINC
+               Pruned_Sons_BWD(ISTEP) = 0
+            ENDIF
+         ENDDO
+        ENDIF
+      ENDIF
+#if defined(AVOID_MPI_IN_PLACE)
+      GOTO 600  
+  500 CONTINUE
+      Lnodes_FWD = -1
+      Lnodes_BWD = -1
+  600 CONTINUE
+#endif
+#if defined(AVOID_MPI_IN_PLACE)
+      IF ( allocated(TMP_INT_ARRAY)) DEALLOCATE(TMP_INT_ARRAY)
+#endif
+      RETURN
+      END SUBROUTINE ZMUMPS_NODES_FWD_BWD_SIZE_FILL
+      SUBROUTINE ZMUMPS_BUILD_GLOB2LOC_NODES_ES (
+     &           NSLAVES, N, MYID_NODES,
      &           PTRIST, DAD,
      &           KEEP,KEEP8, PROCNODE_STEPS, IW, LIW, STEP,
-     &           POSINRHSCOMP_ROW, POSINRHSCOMP_COL,
-     &           POSINRHSCOMP_COL_ALLOC,
+     &           Lnodes_FWD, Lnodes_BWD,
+     &           nodes_FWD, nodes_BWD,
+     &           GLOB2LOC_RHS, GLOB2LOC_SOL,
+     &           GLOB2LOC_SOL_ALLOC,
      &           MTYPE,
-     &           IRHS_PTR, NBCOL_INBLOC, IRHS_SPARSE, NZ_RHS,
-     &           PERM_RHS, SIZE_PERM_RHS, JBEG_RHS,
-     &           NBENT_RHSCOMP,
-     &           NB_FS_IN_RHSCOMP_FWD, NB_FS_IN_RHSCOMP_TOT,
-     &           UNS_PERM_INV, SIZE_UNS_PERM_INV
+     &           NBENT_RHSINTR,
+     &           NB_FS_IN_RHSINTR_FWD, NB_FS_IN_RHSINTR_TOT
      &            )
       IMPLICIT NONE
       INCLUDE 'mpif.h'
       INCLUDE 'mumps_tags.h'
-      INTEGER, intent(in) :: NSLAVES, N, MYID_NODES, LIW, 
-     &                       SIZE_UNS_PERM_INV
-      INTEGER, intent(in) :: KEEP(500)
+      INTEGER, intent(in)    :: NSLAVES, N, MYID_NODES, LIW
+      INTEGER, intent(in)    :: KEEP(500)
       INTEGER(8), intent(in) :: KEEP8(150)
       INTEGER, intent(in) :: PTRIST(KEEP(28)), PROCNODE_STEPS(KEEP(28))
+      INTEGER, intent(in) :: Lnodes_FWD, Lnodes_BWD
+      INTEGER, intent(in) :: nodes_FWD(max(1,Lnodes_FWD)), 
+     &                       nodes_BWD(max(1,Lnodes_BWD))
       INTEGER, intent(inout) :: DAD(KEEP(28))
       INTEGER, intent(in) :: IW(LIW), STEP(N)
-      INTEGER, intent(in) :: NBCOL_INBLOC, IRHS_PTR(NBCOL_INBLOC+1)
-      INTEGER, intent(in) :: NZ_RHS, IRHS_SPARSE(NZ_RHS)
-      INTEGER, intent(in) :: SIZE_PERM_RHS, PERM_RHS(SIZE_PERM_RHS)
-      INTEGER, intent(in) :: JBEG_RHS
       INTEGER, intent(in) :: MTYPE
-      LOGICAL, intent(in) :: POSINRHSCOMP_COL_ALLOC
-      INTEGER, intent(out):: POSINRHSCOMP_ROW(N),POSINRHSCOMP_COL(N)
-      INTEGER, intent(out):: NBENT_RHSCOMP
-      INTEGER, intent(out):: NB_FS_IN_RHSCOMP_FWD, NB_FS_IN_RHSCOMP_TOT
-      INTEGER, intent(in) :: UNS_PERM_INV(SIZE_UNS_PERM_INV)
-      INTEGER I, JAM1
+      LOGICAL, intent(in) :: GLOB2LOC_SOL_ALLOC
+      INTEGER, intent(out):: GLOB2LOC_RHS(N), GLOB2LOC_SOL(N)
+      INTEGER, intent(out):: NBENT_RHSINTR
+      INTEGER, intent(out):: NB_FS_IN_RHSINTR_FWD, NB_FS_IN_RHSINTR_TOT
+      INTEGER I
       INTEGER ISTEP, OLDISTEP
       INTEGER NPIV
       INTEGER IPOS, LIELL
       INTEGER JJ, J1, JCOL, ABSJCOL
-      INTEGER IPOSINRHSCOMP_ROW, IPOSINRHSCOMP_COL
-      INTEGER NBENT_RHSCOMP_ROW, NBENT_RHSCOMP_COL
+      INTEGER IPOSINRHSINTR_RHS, IPOSINRHSINTR_SOL
+      INTEGER NBENT_RHSINTR_ROW, NBENT_RHSINTR_COL
       LOGICAL GO_UP
       INCLUDE 'mumps_headers.h'
       INTEGER MUMPS_PROCNODE
       EXTERNAL MUMPS_PROCNODE
-      IF(KEEP(237).EQ.0) THEN
-        WRITE(*,*)'BUILD_POSINRHSCOMP_SPARSE available for A-1 only !'
-        CALL MUMPS_ABORT()
-      END IF
-      POSINRHSCOMP_ROW = 0
-      IF (POSINRHSCOMP_COL_ALLOC) POSINRHSCOMP_COL = 0
-      IPOSINRHSCOMP_ROW = 0
-      IPOSINRHSCOMP_COL = 0
-      DO I = 1, NBCOL_INBLOC
-        IF ((IRHS_PTR(I+1)-IRHS_PTR(I)).EQ.0) CYCLE 
-        IF (KEEP(242).NE.0) THEN 
-          JAM1 = PERM_RHS(JBEG_RHS+I-1)
-        ELSE
-          JAM1 = JBEG_RHS+I-1
-        END IF
-        ISTEP = abs(STEP(JAM1))
+      GLOB2LOC_RHS = 0
+      IF (GLOB2LOC_SOL_ALLOC) GLOB2LOC_SOL = 0
+      IPOSINRHSINTR_RHS = 0
+      IPOSINRHSINTR_SOL = 0
+      DO I = 1, Lnodes_FWD
+        ISTEP = STEP(nodes_FWD(I))
         GO_UP = .TRUE.
         DO WHILE(GO_UP) 
           IF(MYID_NODES.EQ.
@@ -2257,18 +2721,18 @@ C
               JCOL = IPOS+1
             ENDIF
             IF(NPIV.GT.0) THEN 
-              IF(POSINRHSCOMP_ROW(IW(J1)).EQ.0) THEN 
+              IF(GLOB2LOC_RHS(IW(J1)).EQ.0) THEN 
                 DO JJ = J1, J1+NPIV-1
-                  POSINRHSCOMP_ROW(IW(JJ))
-     &            = IPOSINRHSCOMP_ROW + JJ - J1 + 1
+                  GLOB2LOC_RHS(IW(JJ))
+     &            = IPOSINRHSINTR_RHS + JJ - J1 + 1
                 ENDDO
-                IPOSINRHSCOMP_ROW = IPOSINRHSCOMP_ROW + NPIV
-                IF (POSINRHSCOMP_COL_ALLOC) THEN
+                IPOSINRHSINTR_RHS = IPOSINRHSINTR_RHS + NPIV
+                IF (GLOB2LOC_SOL_ALLOC) THEN
                   DO JJ = JCOL, JCOL+NPIV-1
-                    POSINRHSCOMP_COL(IW(JJ))
-     &              = - N - (IPOSINRHSCOMP_COL + JJ - JCOL + 1)
+                    GLOB2LOC_SOL(IW(JJ))
+     &              = - (IPOSINRHSINTR_SOL + JJ - JCOL + 1)
                   ENDDO
-                  IPOSINRHSCOMP_COL = IPOSINRHSCOMP_COL + NPIV
+                  IPOSINRHSINTR_SOL = IPOSINRHSINTR_SOL + NPIV
                 ENDIF
               ELSE
                 GO_UP = .FALSE. 
@@ -2282,12 +2746,10 @@ C
           END IF
         END DO 
       END DO 
-      NB_FS_IN_RHSCOMP_FWD = IPOSINRHSCOMP_ROW
-      IF(POSINRHSCOMP_COL_ALLOC) THEN 
-        DO I =1, NZ_RHS
-          JAM1 = IRHS_SPARSE(I)
-          IF (KEEP(23).NE.0) JAM1 = UNS_PERM_INV(JAM1)
-          ISTEP = abs(STEP(JAM1))
+      NB_FS_IN_RHSINTR_FWD = IPOSINRHSINTR_RHS
+      IF(GLOB2LOC_SOL_ALLOC) THEN 
+        DO I=1, Lnodes_BWD
+          ISTEP = STEP(nodes_BWD(I))
           GO_UP = .TRUE.
           DO WHILE(GO_UP) 
             IF(MYID_NODES.EQ.
@@ -2306,21 +2768,17 @@ C
               ENDIF
               ABSJCOL = abs(IW(JCOL))
               IF(NPIV.GT.0) THEN 
-                IF(POSINRHSCOMP_COL(ABSJCOL).EQ.0)  THEN
+                IF(GLOB2LOC_SOL(ABSJCOL).EQ.0)  THEN
                   DO JJ = JCOL, JCOL+NPIV-1
-                    POSINRHSCOMP_COL(abs(IW(JJ))) = 
-     &                     IPOSINRHSCOMP_COL+JJ-JCOL+1
+                    GLOB2LOC_SOL(abs(IW(JJ))) = 
+     &                     IPOSINRHSINTR_SOL+JJ-JCOL+1
                   END DO
-                  IPOSINRHSCOMP_COL = IPOSINRHSCOMP_COL + NPIV
-                ELSE IF (POSINRHSCOMP_COL(ABSJCOL).LT.-N) THEN
+                  IPOSINRHSINTR_SOL = IPOSINRHSINTR_SOL + NPIV
+                ELSE IF (GLOB2LOC_SOL(ABSJCOL).LT.0) THEN
                   DO JJ = JCOL, JCOL+NPIV-1
-                    POSINRHSCOMP_COL(abs(IW(JJ)))=
-     &                -(N+POSINRHSCOMP_COL(abs(IW(JJ))))
+                    GLOB2LOC_SOL(abs(IW(JJ)))=
+     &                -(GLOB2LOC_SOL(abs(IW(JJ))))
                   END DO
-                ELSE IF ((POSINRHSCOMP_COL(ABSJCOL).LT.0).AND.
-     &                 (POSINRHSCOMP_COL(ABSJCOL).GE.-N))THEN
-                  WRITE(*,*)'Internal error 7 in BUILD...SPARSE'
-                  CALL MUMPS_ABORT()
                 ELSE
                   GO_UP = .FALSE.
                 END IF
@@ -2334,16 +2792,10 @@ C
           END DO 
         END DO 
       END IF 
-      NB_FS_IN_RHSCOMP_TOT = IPOSINRHSCOMP_COL
-            IF (NSLAVES.NE.1) THEN
-      DO I = 1, NBCOL_INBLOC
-        IF ((IRHS_PTR(I+1)-IRHS_PTR(I)).EQ.0) CYCLE 
-        IF (KEEP(242).NE.0) THEN 
-          JAM1 = PERM_RHS(JBEG_RHS+I-1)
-        ELSE
-          JAM1 = JBEG_RHS+I-1
-        END IF
-        ISTEP = abs(STEP(JAM1))
+      NB_FS_IN_RHSINTR_TOT = IPOSINRHSINTR_SOL
+      IF (NSLAVES.NE.1) THEN
+      DO I = 1, Lnodes_FWD
+        ISTEP = STEP(nodes_FWD(I))
         GO_UP = .TRUE.
         DO WHILE(GO_UP) 
           IF(MYID_NODES.EQ.
@@ -2361,10 +2813,9 @@ C
               JCOL = IPOS+1
             ENDIF
             DO JJ = NPIV, LIELL-1-KEEP(253)
-              IF(POSINRHSCOMP_ROW(IW(J1+JJ)).EQ.0) THEN 
-                IPOSINRHSCOMP_ROW = IPOSINRHSCOMP_ROW + 1
-                POSINRHSCOMP_ROW(IW(JJ+J1))
-     &          = -IPOSINRHSCOMP_ROW
+              IF(GLOB2LOC_RHS(IW(J1+JJ)).EQ.0) THEN 
+                IPOSINRHSINTR_RHS = IPOSINRHSINTR_RHS + 1
+                GLOB2LOC_RHS(IW(JJ+J1)) = -IPOSINRHSINTR_RHS
               END IF
             END DO
           END IF
@@ -2378,11 +2829,9 @@ C
         END DO 
       END DO 
       DAD=ABS(DAD)
-      IF(POSINRHSCOMP_COL_ALLOC) THEN
-        DO I =1, NZ_RHS
-          JAM1 = IRHS_SPARSE(I)
-          IF (KEEP(23).NE.0) JAM1 = UNS_PERM_INV(JAM1)
-          ISTEP = abs(STEP(JAM1))
+      IF(GLOB2LOC_SOL_ALLOC) THEN
+        DO I=1, Lnodes_BWD
+        ISTEP = STEP(nodes_BWD(I))
           GO_UP = .TRUE.
           DO WHILE(GO_UP) 
             IF(MYID_NODES.EQ.
@@ -2399,16 +2848,10 @@ C
               ELSE
                 JCOL = IPOS+1
               ENDIF
-              IF (KEEP(23).NE.0) JAM1 = UNS_PERM_INV(JAM1)
               DO JJ = NPIV, LIELL-1-KEEP(253)
-                IF(POSINRHSCOMP_COL(IW(JCOL+JJ)).EQ.0) THEN 
-                  IPOSINRHSCOMP_COL = IPOSINRHSCOMP_COL + 1
-                  POSINRHSCOMP_COL(IW(JCOL+JJ))
-     &            = -IPOSINRHSCOMP_COL
-                ELSE IF (POSINRHSCOMP_COL(IW(JCOL+JJ)).LT.-N) THEN
-                  IPOSINRHSCOMP_COL = IPOSINRHSCOMP_COL + 1
-                  POSINRHSCOMP_COL(IW(JCOL+JJ))
-     &            = POSINRHSCOMP_COL(IW(JCOL+JJ)) + N              
+                IF(GLOB2LOC_SOL(IW(JCOL+JJ)).EQ.0) THEN 
+                  IPOSINRHSINTR_SOL = IPOSINRHSINTR_SOL + 1
+                  GLOB2LOC_SOL(IW(JCOL+JJ)) = -IPOSINRHSINTR_SOL
                 END IF
               END DO
             END IF
@@ -2424,8 +2867,8 @@ C
        DAD=ABS(DAD)
       END IF
       ENDIF
-      NBENT_RHSCOMP_ROW = IPOSINRHSCOMP_ROW
-      NBENT_RHSCOMP_COL = IPOSINRHSCOMP_COL
-      NBENT_RHSCOMP = max(NBENT_RHSCOMP_ROW,NBENT_RHSCOMP_COL)
+      NBENT_RHSINTR_ROW = IPOSINRHSINTR_RHS
+      NBENT_RHSINTR_COL = IPOSINRHSINTR_SOL
+      NBENT_RHSINTR = max(NBENT_RHSINTR_ROW,NBENT_RHSINTR_COL)
       RETURN
-      END SUBROUTINE ZMUMPS_BUILD_POSINRHSCOMP_AM1
+      END SUBROUTINE ZMUMPS_BUILD_GLOB2LOC_NODES_ES
diff -pruN 5.6.2-2.1/src/zsol_distrhs.F 5.7.1-1/src/zsol_distrhs.F
--- 5.6.2-2.1/src/zsol_distrhs.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zsol_distrhs.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -17,9 +17,14 @@ C
      &           NRHS_COL, NRHS_loc, LRHS_loc,
      &           MAP_RHS_loc,
      &           IRHS_loc, RHS_loc, RHS_loc_size,
-     &           RHSCOMP, LD_RHSCOMP,
-     &           POSINRHSCOMP_FWD, NB_FS_IN_RHSCOMP,
-     &           LSCAL, scaling_data_dr,
+     &           RHSINTR, LD_RHSINTR,
+     &           POSINRHSINTR_FWD, NB_FS_IN_RHSINTR,
+     &           LSCAL,
+#if defined(USE_OLD_SCALING)
+     &           scaling_data_dr,
+#else
+     &           SCALING_RHSINTR_FWD, LSCALING_RHSINTR_FWD,
+#endif
      &           LP, LPOK, KEEP, NB_BYTES_LOC, INFO )
       USE ZMUMPS_STRUC_DEF
 !$    USE OMP_LIB
@@ -32,17 +37,23 @@ C
       INTEGER, INTENT(IN)    :: IRHS_loc(NRHS_loc)
       INTEGER(8), INTENT(IN) :: RHS_loc_size
       COMPLEX(kind=8), INTENT(IN)    :: RHS_loc(RHS_loc_size)
-      INTEGER, INTENT(IN)    :: NB_FS_IN_RHSCOMP, LD_RHSCOMP
-      INTEGER, INTENT(IN)    :: POSINRHSCOMP_FWD(N)
-      COMPLEX(kind=8), INTENT(OUT)   :: RHSCOMP(LD_RHSCOMP, NRHS_COL)
+      INTEGER, INTENT(IN)    :: NB_FS_IN_RHSINTR, LD_RHSINTR
+      INTEGER, INTENT(IN)    :: POSINRHSINTR_FWD(N)
+      COMPLEX(kind=8), INTENT(OUT)   :: RHSINTR(LD_RHSINTR, NRHS_COL)
       INTEGER                :: KEEP(500)
       LOGICAL, INTENT(IN)    :: LSCAL
+#if defined(USE_OLD_SCALING)
       type scaling_data_t
         SEQUENCE
-        DOUBLE PRECISION, dimension(:), pointer :: SCALING
-        DOUBLE PRECISION, dimension(:), pointer :: SCALING_LOC
+        DOUBLE PRECISION,    dimension(:), pointer :: SCALING
+        DOUBLE PRECISION,    dimension(:), pointer :: SCALING_LOC
+        INTEGER, dimension(:), pointer :: SCALING_IND 
       end type scaling_data_t
       type(scaling_data_t), INTENT(IN) :: scaling_data_dr
+#else
+      INTEGER :: LSCALING_RHSINTR_FWD
+      DOUBLE PRECISION :: SCALING_RHSINTR_FWD( LSCALING_RHSINTR_FWD )
+#endif
       LOGICAL, INTENT(IN)    :: LPOK
       INTEGER, INTENT(IN)    :: LP      
       INTEGER, INTENT(INOUT) :: INFO(2) 
@@ -135,7 +146,7 @@ C
      &         IS_SEND_ACTIVE(MAX_ACTIVE_SENDS),
      &         BUFRECI(MAXRECORDS),                
      &         BUFRECR(MAXRECORDS*NRHS_COL),       
-     &         TOUCHED(NB_FS_IN_RHSCOMP),          
+     &         TOUCHED(NB_FS_IN_RHSINTR),          
      &         stat=allocok)
       IF (allocok .GT. 0) THEN
         IF (LP .GT. 0) WRITE(LP, '(A)')
@@ -143,11 +154,11 @@ C
         INFO(1)=-13
         INFO(2)=NRHS_COL*MAXRECORDS*MAX_ACTIVE_SENDS+
      &          3*MAX_ACTIVE_SENDS+MAXRECORDS*(1+NRHS_COL)
-     &          + NB_FS_IN_RHSCOMP
+     &          + NB_FS_IN_RHSINTR
       ENDIF
       NB_BYTES_LOC=NB_BYTES_LOC +
      &  KEEP(34) * ( int(2*MAX_ACTIVE_SENDS,8) + int(MAXRECORDS,8) ) +
-     &  KEEP(34) * (int(MAX_ACTIVE_SENDS,8) + int(NB_FS_IN_RHSCOMP,8)) +
+     &  KEEP(34) * (int(MAX_ACTIVE_SENDS,8) + int(NB_FS_IN_RHSINTR,8)) +
      &  KEEP(35) * (
      &      int( MAXRECORDS,8)*int(NRHS_COL,8)*int(MAX_ACTIVE_SENDS,8)
      &      + int(MAXRECORDS,8) * int(NRHS_COL,8) )
@@ -160,7 +171,7 @@ C
         IS_SEND_ACTIVE(IREQ) = .FALSE.
       ENDDO
       NB_FS_TOUCHED = 0
-      DO IFS = 1, NB_FS_IN_RHSCOMP
+      DO IFS = 1, NB_FS_IN_RHSINTR
         TOUCHED(IFS) = .FALSE.
       ENDDO
       IPROC_MAX=maxloc(NBROWSTOSEND,DIM=1)-1
@@ -223,7 +234,7 @@ C
         INTEGER, INTENT(INOUT) :: BUFRECI_ARG(NBRECORDS) 
         COMPLEX(kind=8), INTENT(IN) :: BUFRECR_ARG(NBRECORDS,
      &                                     NRHS_COL)
-        INTEGER :: I, K, IRHSCOMP, IFIRSTNOTTOUCHED, ILASTNOTTOUCHED
+        INTEGER :: I, K, IRHSINTR, IFIRSTNOTTOUCHED, ILASTNOTTOUCHED
         IFIRSTNOTTOUCHED = NBRECORDS+1
         ILASTNOTTOUCHED  = 0
         DO I = 1, NBRECORDS
@@ -232,9 +243,9 @@ C
      &      I, BUFRECI(I), BUFRECI(1)
             CALL MUMPS_ABORT()
           ENDIF
-          IRHSCOMP=POSINRHSCOMP_FWD(BUFRECI(I))
-          BUFRECI_ARG(I)=IRHSCOMP
-          IF ( .NOT. TOUCHED(IRHSCOMP) ) THEN
+          IRHSINTR=POSINRHSINTR_FWD(BUFRECI(I))
+          BUFRECI_ARG(I)=IRHSINTR
+          IF ( .NOT. TOUCHED(IRHSINTR) ) THEN
             IFIRSTNOTTOUCHED=min(IFIRSTNOTTOUCHED,I)
             ILASTNOTTOUCHED=max(ILASTNOTTOUCHED,I)
           ENDIF
@@ -243,41 +254,67 @@ C
 !$      OMP_FLAG = ( NRHS_COL.GE.KEEP(362) .AND.
 !$   &               NRHS_COL*NBRECORDS .GE. KEEP(363)/2)
         IF (OMP_FLAG) THEN
-!$OMP PARALLEL DO PRIVATE(I,IRHSCOMP) IF (OMP_FLAG)
+!$OMP PARALLEL DO PRIVATE(I,IRHSINTR)
         DO K = 1, NRHS_COL
           DO I = IFIRSTNOTTOUCHED, ILASTNOTTOUCHED
-            IRHSCOMP=BUFRECI_ARG(I)
-            IF (.NOT. TOUCHED(IRHSCOMP)) THEN
-              RHSCOMP(IRHSCOMP,K)=ZERO
+            IRHSINTR=BUFRECI_ARG(I)
+            IF (.NOT. TOUCHED(IRHSINTR)) THEN
+              RHSINTR(IRHSINTR,K)=ZERO
             ENDIF
           ENDDO
-          DO I = 1, NBRECORDS
-            IRHSCOMP=BUFRECI_ARG(I)
-            RHSCOMP(IRHSCOMP,K) = RHSCOMP(IRHSCOMP,K) +
+#if ! defined(USE_OLD_SCALING)
+          IF (LSCAL) THEN
+            DO I = 1, NBRECORDS
+              IRHSINTR=BUFRECI_ARG(I)
+              RHSINTR(IRHSINTR,K) = RHSINTR(IRHSINTR,K) +
+     &                            SCALING_RHSINTR_FWD(IRHSINTR) *
      &                            BUFRECR_ARG(I,K)
-          ENDDO
+            ENDDO
+          ELSE
+#endif
+            DO I = 1, NBRECORDS
+              IRHSINTR=BUFRECI_ARG(I)
+              RHSINTR(IRHSINTR,K) = RHSINTR(IRHSINTR,K) +
+     &                            BUFRECR_ARG(I,K)
+            ENDDO
+#if ! defined(USE_OLD_SCALING)
+          ENDIF
+#endif
         ENDDO
 !$OMP END PARALLEL DO
         ELSE
-        DO K = 1, NRHS_COL
-          DO I = IFIRSTNOTTOUCHED, ILASTNOTTOUCHED
-            IRHSCOMP=BUFRECI_ARG(I)
-            IF (.NOT. TOUCHED(IRHSCOMP)) THEN
-              RHSCOMP(IRHSCOMP,K)=ZERO
+          DO K = 1, NRHS_COL
+            DO I = IFIRSTNOTTOUCHED, ILASTNOTTOUCHED
+              IRHSINTR=BUFRECI_ARG(I)
+              IF (.NOT. TOUCHED(IRHSINTR)) THEN
+                RHSINTR(IRHSINTR,K)=ZERO
+              ENDIF
+            ENDDO
+#if ! defined(USE_OLD_SCALING)
+            IF ( LSCAL ) THEN
+              DO I = 1, NBRECORDS
+                IRHSINTR=BUFRECI_ARG(I)
+                RHSINTR(IRHSINTR,K) = RHSINTR(IRHSINTR,K) +
+     &                                SCALING_RHSINTR_FWD(IRHSINTR) *
+     &                                BUFRECR_ARG(I,K)
+              ENDDO
+            ELSE
+#endif
+              DO I = 1, NBRECORDS
+                IRHSINTR=BUFRECI_ARG(I)
+                RHSINTR(IRHSINTR,K) = RHSINTR(IRHSINTR,K) +
+     &                                BUFRECR_ARG(I,K)
+              ENDDO
+#if ! defined(USE_OLD_SCALING)
             ENDIF
+#endif
           ENDDO
-          DO I = 1, NBRECORDS
-            IRHSCOMP=BUFRECI_ARG(I)
-            RHSCOMP(IRHSCOMP,K) = RHSCOMP(IRHSCOMP,K) +
-     &                            BUFRECR_ARG(I,K)
-          ENDDO
-        ENDDO
         ENDIF
         DO I = 1, NBRECORDS
-          IRHSCOMP = BUFRECI_ARG(I)
-          IF (.NOT. TOUCHED(IRHSCOMP)) THEN
+          IRHSINTR = BUFRECI_ARG(I)
+          IF (.NOT. TOUCHED(IRHSINTR)) THEN
             NB_FS_TOUCHED = NB_FS_TOUCHED + 1
-            TOUCHED(IRHSCOMP) = .TRUE.
+            TOUCHED(IRHSINTR) = .TRUE.
           ENDIF
         ENDDO
         NBROWSTORECV = NBROWSTORECV - NBRECORDS
@@ -287,7 +324,7 @@ C
         INTEGER :: NBRECORDS, I, K, IFIRSTNOTTOUCHED
         INTEGER :: Iloc       
         INTEGER :: Iglob      
-        INTEGER :: IRHSCOMP   
+        INTEGER :: IRHSINTR   
         INTEGER(8) :: ISHIFT
         IF ( NBROWSTOSEND(MYID_NODES+1) .EQ. 0) THEN
           WRITE(*,*) "Internal error in ZMUMPS_DR_ASSEMBLE_LOCAL"
@@ -296,9 +333,9 @@ C
         NBRECORDS=min(MAXRECORDS, NBROWSTOSEND(MYID_NODES+1))
         IFIRSTNOTTOUCHED=NBRECORDS+1
         DO I = 1, NBRECORDS
-          IRHSCOMP = POSINRHSCOMP_FWD(IRHS_loc(
+          IRHSINTR = POSINRHSINTR_FWD(IRHS_loc(
      &               IRHS_loc_sorted(NEXTROWTOSEND(MYID_NODES+1)+I-1)))
-          IF (.NOT. TOUCHED(IRHSCOMP)) THEN
+          IF (.NOT. TOUCHED(IRHSINTR)) THEN
             IFIRSTNOTTOUCHED=I
             EXIT
           ENDIF
@@ -306,57 +343,61 @@ C
         IF (LSCAL) THEN
 !$        OMP_FLAG = (NRHS_COL.GE.KEEP(362) .AND.
 !$   &                NRHS_COL*NBRECORDS .GE. KEEP(363)/2)
-!$OMP PARALLEL DO PRIVATE(K, ISHIFT, I, IRHSCOMP, Iloc, Iglob)
+!$OMP PARALLEL DO PRIVATE(K, ISHIFT, I, IRHSINTR, Iloc, Iglob)
 !$OMP&  FIRSTPRIVATE(NBRECORDS) IF (OMP_FLAG)
           DO K = 1, NRHS_COL
-            ISHIFT = (K-1) * LRHS_loc
+            ISHIFT = int(K-1,8) * int(LRHS_loc,8)
             DO I = IFIRSTNOTTOUCHED, NBRECORDS
-              IRHSCOMP = POSINRHSCOMP_FWD(IRHS_loc(
+              IRHSINTR = POSINRHSINTR_FWD(IRHS_loc(
      &               IRHS_loc_sorted(NEXTROWTOSEND(MYID_NODES+1)+I-1)))
-               IF (.NOT. TOUCHED(IRHSCOMP)) THEN
-                 RHSCOMP(IRHSCOMP,K)=ZERO
+               IF (.NOT. TOUCHED(IRHSINTR)) THEN
+                 RHSINTR(IRHSINTR,K)=ZERO
                ENDIF
             ENDDO
             DO I = 1, NBRECORDS
               Iloc = IRHS_loc_sorted(NEXTROWTOSEND(MYID_NODES+1)+I-1)
               Iglob = IRHS_loc(Iloc)
-              IRHSCOMP = POSINRHSCOMP_FWD(Iglob)
-              RHSCOMP(IRHSCOMP,K) = RHSCOMP(IRHSCOMP,K)+
+              IRHSINTR = POSINRHSINTR_FWD(Iglob)
+              RHSINTR(IRHSINTR,K) = RHSINTR(IRHSINTR,K)+
      &                              RHS_loc(Iloc+ISHIFT)*
+#if defined(USE_OLD_SCALING)
      &                        scaling_data_dr%SCALING_LOC(Iloc)
+#else
+     &                        SCALING_RHSINTR_FWD(IRHSINTR)
+#endif
             ENDDO
           ENDDO
 !$OMP END PARALLEL DO
         ELSE
 !$        OMP_FLAG = (NRHS_COL.GE.KEEP(362) .AND.
 !$   &                NRHS_COL*NBRECORDS .GE. KEEP(363)/2)
-!$OMP PARALLEL DO PRIVATE(K, ISHIFT, I, IRHSCOMP, Iloc, Iglob)
+!$OMP PARALLEL DO PRIVATE(K, ISHIFT, I, IRHSINTR, Iloc, Iglob)
 !$OMP&  FIRSTPRIVATE(NBRECORDS) IF (OMP_FLAG)
           DO K = 1, NRHS_COL
-            ISHIFT = (K-1) * LRHS_loc
+            ISHIFT = int(K-1,8) * int(LRHS_loc,8)
             DO I = IFIRSTNOTTOUCHED, NBRECORDS
-              IRHSCOMP = POSINRHSCOMP_FWD(IRHS_loc(
+              IRHSINTR = POSINRHSINTR_FWD(IRHS_loc(
      &               IRHS_loc_sorted(NEXTROWTOSEND(MYID_NODES+1)+I-1)))
-               IF (.NOT. TOUCHED(IRHSCOMP)) THEN
-                 RHSCOMP(IRHSCOMP,K)=ZERO
+               IF (.NOT. TOUCHED(IRHSINTR)) THEN
+                 RHSINTR(IRHSINTR,K)=ZERO
                ENDIF
             ENDDO
             DO I = 1, NBRECORDS
               Iloc = IRHS_loc_sorted(NEXTROWTOSEND(MYID_NODES+1)+I-1)
               Iglob = IRHS_loc(Iloc)
-              IRHSCOMP = POSINRHSCOMP_FWD(Iglob)
-              RHSCOMP(IRHSCOMP,K) = RHSCOMP(IRHSCOMP,K)+
+              IRHSINTR = POSINRHSINTR_FWD(Iglob)
+              RHSINTR(IRHSINTR,K) = RHSINTR(IRHSINTR,K) +
      &                              RHS_loc(Iloc+ISHIFT)
             ENDDO
           ENDDO
 !$OMP END PARALLEL DO
         ENDIF
         DO I = 1, NBRECORDS
-          IRHSCOMP = POSINRHSCOMP_FWD(IRHS_loc(
+          IRHSINTR = POSINRHSINTR_FWD(IRHS_loc(
      &               IRHS_loc_sorted(NEXTROWTOSEND(MYID_NODES+1)+I-1)))
-          IF (.NOT. TOUCHED(IRHSCOMP)) THEN
+          IF (.NOT. TOUCHED(IRHSINTR)) THEN
             NB_FS_TOUCHED = NB_FS_TOUCHED + 1
-            TOUCHED(IRHSCOMP) = .TRUE.
+            TOUCHED(IRHSINTR) = .TRUE.
           ENDIF
         ENDDO
         NEXTROWTOSEND(MYID_NODES+1)=NEXTROWTOSEND(MYID_NODES+1)+
@@ -434,8 +475,10 @@ C
                 IPOSRHS = int(K-1,8)*int(LRHS_loc,8)
                 Iloc = IRHS_loc_sorted(NEXTROWTOSEND(IPROC_ARG+1)+I-1)
                 BUFR( IPOSBUF + I, IBUF )
-     &                = RHS_loc( IPOSRHS + Iloc ) *
-     &                  scaling_data_dr%SCALING_LOC(Iloc)
+     &                = RHS_loc( IPOSRHS + Iloc )
+#if defined(USE_OLD_SCALING)
+     &                  * scaling_data_dr%SCALING_LOC(Iloc)
+#endif
               ENDDO
             ENDDO
 !$OMP END PARALLEL DO
@@ -475,24 +518,25 @@ C
         END SUBROUTINE ZMUMPS_DR_TRY_SEND
         SUBROUTINE ZMUMPS_DR_EMPTY_ROWS()
         INTEGER :: K, IFS
-        IF ( NB_FS_TOUCHED .NE. NB_FS_IN_RHSCOMP ) THEN
+        IF ( NB_FS_TOUCHED .NE. NB_FS_IN_RHSINTR ) THEN
 !$        OMP_FLAG = (NRHS_COL .GE. KEEP(362)) .AND.
-!$   &    (NRHS_COL*NB_FS_IN_RHSCOMP >  KEEP(363)/2)
-!$OMP PARALLEL DO FIRSTPRIVATE(NB_FS_IN_RHSCOMP) IF (OMP_FLAG)
+!$   &    (NRHS_COL*NB_FS_IN_RHSINTR >  KEEP(363)/2)
+!$OMP PARALLEL DO FIRSTPRIVATE(NB_FS_IN_RHSINTR)
+!$OMP&    PRIVATE(IFS) IF (OMP_FLAG)
           DO K = 1, NRHS_COL
-            DO IFS = 1, NB_FS_IN_RHSCOMP
+            DO IFS = 1, NB_FS_IN_RHSINTR
               IF ( .NOT. TOUCHED(IFS) ) THEN
-                RHSCOMP( IFS, K) = ZERO
+                RHSINTR( IFS, K) = ZERO
               ENDIF
             ENDDO
-            DO IFS = NB_FS_IN_RHSCOMP +1, LD_RHSCOMP
-              RHSCOMP (IFS, K) = ZERO
+            DO IFS = NB_FS_IN_RHSINTR +1, LD_RHSINTR
+              RHSINTR (IFS, K) = ZERO
             ENDDO
           ENDDO
 !$OMP END PARALLEL DO
         ELSE
 !$        OMP_FLAG = .FALSE.
-!$        CHUNK8 = int(NRHS_COL,8)*int(LD_RHSCOMP-NB_FS_IN_RHSCOMP,8)
+!$        CHUNK8 = int(NRHS_COL,8)*int(LD_RHSINTR-NB_FS_IN_RHSINTR,8)
 !$        CHUNK8 = max(CHUNK8,1_8)
 !$        IF (CHUNK8 .GE. int(KEEP(363),8)) THEN
 !$          OMP_FLAG = .TRUE.
@@ -501,8 +545,8 @@ C
 !$OMP PARALLEL DO COLLAPSE(2) SCHEDULE(STATIC,CHUNK8)
 !$OMP&  IF (OMP_FLAG)
           DO K = 1, NRHS_COL
-            DO IFS = NB_FS_IN_RHSCOMP +1, LD_RHSCOMP
-             RHSCOMP (IFS, K) = ZERO
+            DO IFS = NB_FS_IN_RHSINTR +1, LD_RHSINTR
+             RHSINTR (IFS, K) = ZERO
             ENDDO
           ENDDO
 !$OMP END PARALLEL DO
@@ -532,15 +576,19 @@ C
      &               ( id%MYID .eq. MASTER .AND.
      &                 id%KEEP(46) .eq. 1 ) )
         IF (id%MYID .EQ. MASTER) THEN
-          IF (id%ICNTL(20).EQ.10) THEN
-            ROW_OR_COL_INDICES = 0 
-          ELSE IF (id%ICNTL(20).EQ.11) THEN
-            ROW_OR_COL_INDICES = 1 
-          ELSE 
-            ROW_OR_COL_INDICES = 0 
-          ENDIF
-          IF (id%ICNTL(9) .NE. 1) THEN
-            ROW_OR_COL_INDICES = 1 - ROW_OR_COL_INDICES
+          IF (id%KEEP(50).NE.0) THEN
+            ROW_OR_COL_INDICES = 0
+          ELSE
+            IF (id%ICNTL(20).EQ.10 .OR. id%KEEP(50).EQ.0) THEN
+              ROW_OR_COL_INDICES = 0 
+            ELSE IF (id%ICNTL(20).EQ.11) THEN
+              ROW_OR_COL_INDICES = 1 
+            ELSE 
+              ROW_OR_COL_INDICES = 0 
+            ENDIF
+            IF (id%ICNTL(9) .NE. 1) THEN
+              ROW_OR_COL_INDICES = 1 - ROW_OR_COL_INDICES
+            ENDIF
           ENDIF
           IF (id%KEEP(23).NE.0 .AND. id%ICNTL(9) .NE.1) THEN
             UNS_PERM_TO_BE_DONE = 1
@@ -577,7 +625,8 @@ C
           ELSE
             idIRHS_loc => IDUMMY
           ENDIF
-          CALL MUMPS_BUILD_IRHS_loc(id%MYID_NODES, id%NSLAVES, id%N,
+          CALL MUMPS_GET_INDICES
+     &    (id%MYID_NODES, id%NSLAVES, id%N,
      &    id%PTLUST_S(1), id%KEEP(1), id%KEEP8(1), id%IS(1),
      &    max(1, id%KEEP(32)),
      &    id%STEP(1), id%PROCNODE_STEPS(1), idIRHS_loc(1),
diff -pruN 5.6.2-2.1/src/zsol_distsol.F 5.7.1-1/src/zsol_distsol.F
--- 5.6.2-2.1/src/zsol_distsol.F	1970-01-01 00:00:00.000000000 +0000
+++ 5.7.1-1/src/zsol_distsol.F	2024-05-02 10:15:28.000000000 +0000
@@ -0,0 +1,16 @@
+C
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
+C
+C
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Mumps Technologies, University of Bordeaux.
+C
+C  This version of MUMPS is provided to you free of charge. It is
+C  released under the CeCILL-C license 
+C  (see doc/CeCILL-C_V1-en.txt, doc/CeCILL-C_V1-fr.txt, and
+C  https://cecill.info/licences/Licence_CeCILL-C_V1-en.html)
+C
+      SUBROUTINE ZMUMPS_DS_RETURN()
+      RETURN
+      END SUBROUTINE ZMUMPS_DS_RETURN
diff -pruN 5.6.2-2.1/src/zsol_driver.F 5.7.1-1/src/zsol_driver.F
--- 5.6.2-2.1/src/zsol_driver.F	2023-10-11 09:37:10.000000000 +0000
+++ 5.7.1-1/src/zsol_driver.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -25,7 +25,7 @@ C  Performs solution phase (solve), Iter
 C  and Error analysis.
 C
 C
-C
+c
 C
       USE ZMUMPS_BUF
       USE ZMUMPS_OOC
@@ -34,7 +34,9 @@ C
      &                           , ZMUMPS_BLR_MOD_TO_STRUC
       USE MUMPS_FRONT_DATA_MGT_M, only : MUMPS_FDM_STRUC_TO_MOD,
      &                                   MUMPS_FDM_MOD_TO_STRUC
+#if ! defined(NO_SAVE_RESTORE)
       USE ZMUMPS_SAVE_RESTORE
+#endif
 !$    USE OMP_LIB
       IMPLICIT NONE
 C     -------------------
@@ -76,8 +78,11 @@ C
       LOGICAL PROK, PROKG, LPOK
       INTEGER MTYPE, ICNTL21
       LOGICAL LSCAL, POSTPros, GIVSOL
-      INTEGER ICNTL10, ICNTL11
-      INTEGER I,IPERM,K,JPERM, J, II, IZ2
+      INTEGER ICNTL10, ICNTL11, ICNTL48_EFF
+      INTEGER I,K,JPERM, J, II, IZ2
+#if defined(USE_OLD_SCALING)
+      INTEGER IPERM
+#endif
       INTEGER IZ, NZ_THIS_BLOCK, PJ
 C     pointers in IS
       INTEGER LIW
@@ -101,6 +106,7 @@ C
       INTEGER NITREF, NOITER, SOLVET, KASE
 C     Meaningful only with tree pruning and sparse RHS
       LOGICAL INTERLEAVE_PAR, DO_PERMUTE_RHS
+      LOGICAL CALL_NODES_FWD_BWD, FIRST_CALL_NODES_FWD_BWD
 C     true if ZMUMPS_SOL_C called during postprocessing
       LOGICAL FROM_PP
 C
@@ -125,17 +131,23 @@ C     ----------------------------------
 C
       INTEGER, DIMENSION(:), ALLOCATABLE :: MAP_RHS_loc
       INTEGER, DIMENSION(:), POINTER :: IRHS_loc_PTR
-      LOGICAL :: IRHS_loc_PTR_allocated
+      LOGICAL :: IRHS_loc_PTR_ALLOCATED
+      INTEGER(8) :: SUM_idNloc_RHS_8
       COMPLEX(kind=8), DIMENSION(:), POINTER :: idRHS_loc
       INTEGER(8) :: DIFF_SOL_loc_RHS_loc
       INTEGER(8) :: RHS_loc_size, RHS_loc_shift
       INTEGER(8)  :: NBT
       INTEGER     :: NBCOL, COLSIZE, JBEG_RHS, JEND_RHS, JBEG_NEW,
-     &               NBCOL_INBLOC, IPOS, IPOSRHSCOMP
+     &               NBCOL_INBLOC, IPOS, IPOSRHSINTR
+C     Nb of pruned NE_STEPS, useful for FWD step; and list of root nodes
+      LOGICAL    :: fill
+      INTEGER, DIMENSION(:), ALLOCATABLE ::  Pruned_Sons_FWD, 
+     &                                       Pruned_Sons_BWD
       INTEGER, DIMENSION(:), ALLOCATABLE :: PERM_RHS
-      INTEGER, DIMENSION(:), POINTER :: PTR_POSINRHSCOMP_FWD,
-     &                                  PTR_POSINRHSCOMP_BWD
+      INTEGER, DIMENSION(:), POINTER :: PTR_POSINRHSINTR_FWD,
+     &                                  PTR_POSINRHSINTR_BWD
       COMPLEX(kind=8), DIMENSION(:), POINTER :: PTR_RHS
+      INTEGER, DIMENSION(:), POINTER :: idIPTR_WORKING, idWORKING
       INTEGER :: SIZE_IPTR_WORKING, SIZE_WORKING
 C     NRHS_NONEMPTY: holds
 C         either the original number of RHS (id%NRHS defined on host)
@@ -191,11 +203,12 @@ C     arrays only used for distributed m
 C     (KEEP(54) .NE. 0).
       DOUBLE PRECISION,    ALLOCATABLE, DIMENSION(:) :: R_LOCWK54
       COMPLEX(kind=8), ALLOCATABLE, DIMENSION(:) :: C_LOCWK54
-      INTEGER   :: NBENT_RHSCOMP, NB_FS_RHSCOMP_F,
-     &             NB_FS_RHSCOMP_TOT
+      INTEGER   :: NBENT_RHSINTR, NB_FS_RHSINTR_F,
+     &             NB_FS_RHSINTR_TOT
       INTEGER, DIMENSION(:), ALLOCATABLE :: UNS_PERM_INV
       LOGICAL :: UNS_PERM_INV_NEEDED_INMAINLOOP,
-     &           UNS_PERM_INV_NEEDED_BEFMAINLOOP
+     &           UNS_PERM_INV_NEEDED_BEFMAINLOOP,
+     &           UNS_PERM_INV_NEEDED_ONSLAVES
       INTEGER LIWK_SOLVE, LIWCB
       INTEGER, ALLOCATABLE :: IW1(:), IWK_SOLVE(:), IWCB(:)
       INTEGER ::  LIWK_PTRACB
@@ -214,7 +227,7 @@ C     SCALING issues:
 C       When scaling was performed
 C       RHS holds the solution of the scaled system
 C       The unscaled second member (b0) was given
-C       then we have to scale both rhs adn solution:
+C       then we have to scale both rhs and solution:
 C        A(sca) = LU  = D1*A*D2 , with D2 = COLSCA
 C                                      D1 = ROWSCA
 C        --------------
@@ -222,33 +235,65 @@ C        CASE OF A X =B
 C        --------------
 C         (ICNTL(9)=1 or MTYPE=1)
 C           A*x0 = b0
-C           b(sca) = D1 * b0 = ROWSCA*S(ISTW3)
+C           b(sca) = D1 * b0 = ROWSCA*b0
 C           A(sca) [(D2) **(-1)] x0 = b(sca)
-C           so the computed solution by Check y0 of LU *y0 = b(sca)
-C           is : y0 =[(D2) **(-1)] x0 and so x0= D2*y0 is modified
+C           so the computed solution of LU * x(sca) = b(sca)
+C           is : x(sca) =[(D2) **(-1)] x0 and so x0= D2*x(sca)
 C        --------------
 C        CASE OF AT X =B
 C        --------------
 C         (ICNTL(9).NE.1 or MTYPE=0)
 C           A(sca) = LU  = D1*A*D2
-C           AT*x0 = b0 => D2ATD1 D1-1 x0 = D2b0
-C           b(sca) = D2 * b0 = COLSCA*S(ISTW3)
+C           AT*x0 = b0 => D2*AT*D1 * D1-1 x0 = D2 * b0
+C           b(sca) = D2 * b0 = COLSCA*b0
 C           A(sca)T [(D1) **(-1)] x0 = b(sca)
-C           so the computed solution by Check y0 of LU *y0 = b(sca)
-C           is : y0 =[(D1) **(-1)] x0 and so x0= D1*y0 is modified
+C           so the computed solution of (LU)^T * x(sca) = b(sca)
+C           is : x(sca) =[(D1) **(-1)] x0 and so x0= D1*y0 is modified
 C
-C      In case of distributed RHS we need
-C      scaling information on each processor
+C     In case of distributed RHS or distributed solution we need
+C     scaling information on each processor and this information has
+C     been stored in ROWSCA_loc(1:INFO(23)) and COLSCA_loc(1:INFO(23))
+C     such that:
+C
+C     ----------------
+C     CASE OF A X  = B
+C     ----------------
+C
+C     - the scaling factor of row i of A is stored on the
+C     processor for which GLOB2LOC_RHS(i) > 0 at position
+C     ROWSCA_loc(GLOB2LOC_RHS(i))
+C     
+C     - the scaling factor of column j of A is stored on the
+C     processor for which GLOB2LOC_SOL(j) > 0 at position
+C     COLSCA_loc(GLOB2LOC_SOL(j))
+C
+C     ------------------
+C     CASE OF A^T X  = B
+C     ------------------
+C
+C     - the scaling factor of row i of A^T is stored on the
+C     processor for which GLOB2LOC_RHS(i) > 0 at position
+C     COLSCA_loc(GLOB2LOC_RHS(i))
+C     
+C     - the scaling factor of column j of A^T is stored on the
+C     processor for which GLOB2LOC_SOL(j) > 0 at position
+C     ROWSCA_loc(GLOB2LOC_SOL(j))
 C
+#if defined(USE_OLD_SCALING)
           type scaling_data_t
             SEQUENCE
-            DOUBLE PRECISION, dimension(:), pointer :: SCALING
-            DOUBLE PRECISION, dimension(:), pointer :: SCALING_LOC
+            DOUBLE PRECISION   , dimension(:), pointer :: SCALING
+            DOUBLE PRECISION   , dimension(:), pointer :: SCALING_LOC
+            INTEGER, dimension(:), pointer :: SCALING_IND
           end type scaling_data_t
-          type (scaling_data_t) :: scaling_data_sol, scaling_data_dr
-C      To scale on the fly during GATHER SOLUTION
+          type (scaling_data_t) :: scaling_data_dr
+          type (scaling_data_t) :: scaling_data_sol
+C      To scale on the fly during GATHER SOLUTION:
           DOUBLE PRECISION, DIMENSION(:), POINTER :: PT_SCALING
           DOUBLE PRECISION, TARGET                :: Dummy_SCAL(1)
+#else
+          INTEGER :: ROWORCOL
+#endif
 C
 C  ==================== END OF SCALING related data ================
 C
@@ -273,8 +318,8 @@ C     Interval associated to the subbloc
      &        MASTER_ROOT, MASTER_ROOT_IN_COMM
       INTEGER SIZE_ROOT, LD_REDRHS
       INTEGER(8) :: IPT_RHS_ROOT
-      INTEGER(8) :: IBEG, IBEG_RHSCOMP, KDEC, IBEG_loc, IBEG_REDRHS
-      INTEGER LD_RHSCOMP, NCOL_RHS_loc
+      INTEGER(8) :: IBEG, IBEG_RHSINTR, KDEC, IBEG_loc, IBEG_REDRHS
+      INTEGER NCOL_RHS_loc
       INTEGER LD_RHS_loc, JBEG_RHS_loc
       INTEGER NB_K133, IRANK, TSIZE
       INTEGER KMAX_246_247
@@ -292,8 +337,25 @@ C  Vampir
       INTEGER soln_drive_class, glob_comm_ini, perm_scal_ini, soln_dist,
      &        soln_assem, perm_scal_post
 #endif
-      LOGICAL I_AM_SLAVE, BUILD_POSINRHSCOMP
+      LOGICAL I_AM_SLAVE, BUILD_POSINRHSINTR
       LOGICAL :: BUILD_RHSMAPINFO
+      DOUBLE PRECISION, TARGET :: RDUMMY_TARGET(1)
+      LOGICAL :: ES_RHSINTR
+      INTEGER, DIMENSION(:), POINTER :: nodes_FWD, nodes_BWD
+C     to manage sparsity: compute target nodes for starting chains
+C     Lnodes_FWD/Lnodes_BWD = -1 => all nodes to be processed
+      INTEGER, DIMENSION(:), POINTER :: nodes_FWD_PTR, nodes_BWD_PTR
+      INTEGER :: Lnodes_FWD, Lnodes_BWD, Lnodes_FWD_PTR, Lnodes_BWD_PTR
+      DOUBLE PRECISION, POINTER, DIMENSION(:) :: SCALING_loc_FWD
+      DOUBLE PRECISION, POINTER, DIMENSION(:) :: SCALING_loc_BWD
+      DOUBLE PRECISION, POINTER, DIMENSION(:) :: SCALING_RHSINTR_BWD
+      DOUBLE PRECISION, POINTER, DIMENSION(:) :: SCALING_RHSINTR_FWD
+      INTEGER :: LSCALING_RHSINTR_BWD, LSCALING_RHSINTR_FWD
+      LOGICAL :: SCALING_RHSINTR_BWD_ALLOCATED,
+     &           SCALING_RHSINTR_FWD_ALLOCATED,
+     &           BUILD_SCALING_RHSINTR
+C    NSOL_loc will be equal to KEEP(89) in case ICNTL(21)=1
+      INTEGER :: NSOL_loc
       LOGICAL WORK_WCB_ALLOCATED, IS_INIT_OOC_DONE
       LOGICAL :: IS_LR_MOD_TO_STRUC_DONE
       INTEGER :: KEEP350_SAVE
@@ -303,7 +365,6 @@ C  Vampir
       INTEGER  MAT_ALLOC_LOC, MAT_ALLOC
       INTEGER MUMPS_PROCNODE
       EXTERNAL MUMPS_PROCNODE
-      INTEGER(8) :: FILE_SIZE,STRUC_SIZE
 C
 C  First executable statement
 C
@@ -318,9 +379,25 @@ C
       CALL VTFUNCDEF( 'perm_scal_post',soln_drive_class,
      &     perm_scal_post,IERR)
 #endif
+C     Depending on the type of parallelism,
+C     the master can have the role of a slave
+      I_AM_SLAVE = ( id%MYID .ne. MASTER  .OR.
+     &             ( id%MYID .eq. MASTER .AND.
+     &               id%KEEP(46) .eq. 1 ) )
 C     -- The following pointers xxCOPY might be allocated but then
 C     -- the associated xxCOPY_ALLOCATED will be set to
 C     -- enable deallocation
+      SCALING_RHSINTR_FWD_ALLOCATED = .FALSE.
+      SCALING_RHSINTR_BWD_ALLOCATED = .FALSE.
+C     Initialize scalings to possilby pass them as arguments
+C     (e.g. to ZMUMPS_DS_ALL2ALL) even on non working host
+C     and/or when LSCAL is false
+      SCALING_RHSINTR_FWD => RDUMMY_TARGET
+      SCALING_RHSINTR_BWD => RDUMMY_TARGET
+      LSCALING_RHSINTR_FWD = 1
+      LSCALING_RHSINTR_BWD = 1
+      SCALING_LOC_FWD => RDUMMY_TARGET
+      SCALING_LOC_BWD => RDUMMY_TARGET
       IRHS_PTR_COPY => IDUMMY_TARGET
       IRHS_PTR_COPY_ALLOCATED = .FALSE.
       IRHS_SPARSE_COPY => IDUMMY_TARGET
@@ -329,10 +406,16 @@ C     -- enable deallocation
       RHS_SPARSE_COPY_ALLOCATED=.FALSE.
       NULLIFY(RHS_IR)
       NULLIFY(WORK_WCB)
+#if defined(USE_OLD_SCALING)
       NULLIFY(scaling_data_dr%SCALING)
       NULLIFY(scaling_data_dr%SCALING_LOC)
+      NULLIFY(scaling_data_dr%SCALING_IND)
       NULLIFY(scaling_data_sol%SCALING)
       NULLIFY(scaling_data_sol%SCALING_LOC)
+      NULLIFY(scaling_data_sol%SCALING_IND)
+#endif
+      NULLIFY(nodes_FWD)
+      NULLIFY(nodes_BWD)
       IRHS_loc_PTR_allocated = .FALSE.
       IS_INIT_OOC_DONE   = .FALSE.
       IS_LR_MOD_TO_STRUC_DONE = .FALSE.
@@ -344,9 +427,6 @@ C     -- enable deallocation
       IS   =>id%IS
       ICNTL=>id%ICNTL
       INFO =>id%INFO
-C      ASPK =>id%A
-C      COLSCA =>id%COLSCA
-C      ROWSCA =>id%ROWSCA
       RINFOG =>id%RINFOG
       LP  = ICNTL( 1 )
       MP  = ICNTL( 2 )
@@ -366,7 +446,7 @@ C      ROWSCA =>id%ROWSCA
       K34_8    = int(KEEP(34), 8)
       K35_8    = int(KEEP(35), 8)
       K16_8    = int(KEEP(16), 8)
-      NBENT_RHSCOMP = 0
+      NBENT_RHSINTR = 0
 C     Used by DISTRIBUTED_SOLUTION to skip empty columns
 C     that are skipped (case of sparse RHS)
       NB_RHSSKIPPED = 0
@@ -375,47 +455,48 @@ C     to free space allocated
       LSCAL              = .FALSE.
       WORK_WCB_ALLOCATED = .FALSE.
       ICNTL21  = -99998  ! will be bcasted later to slaves
-      IBEG_RHSCOMP =-152525_8  ! Should not be used
-      BUILD_POSINRHSCOMP = .TRUE.
+      IBEG_RHSINTR =-152525_8  ! Should not be used
+      BUILD_POSINRHSINTR      = .TRUE.
+C     NSOL_loc, KEEP(212) will be set if ICNTL(21).EQ.2
+      NSOL_loc = 0
+      KEEP(212)= 0
+C     SCALING_RHSINTR was initialized to a dummy array of size 1
+C     on the non working host, no need to reset it at each block
+      BUILD_SCALING_RHSINTR = I_AM_SLAVE
       IBEG_GLOB_DEF = -9888  ! unitialized state
       IEND_GLOB_DEF = -9888  ! unitialized state
       IBEG_ROOT_DEF = -9777  ! unitialized state
       IEND_ROOT_DEF = -9777  ! unitialized state
       IROOT_DEF_RHS_COL1 = -9666 ! unitialized state
-C     Not needed anymore (since new version of gather)
-C     LD_RHSCOMP = max(KEEP(89),1)  ! at the nb of pivots eliminated on
-                                    ! that proc
-      LD_RHSCOMP = 1
-      NB_FS_RHSCOMP_TOT = KEEP(89)
+C     ------------------------------
+C     id%LD_RHSINTR will be set each
+C     time RHSINTR is allocated
+C     ------------------------------
+      NB_FS_RHSINTR_TOT = KEEP(89)
 !     number of FS var of the pruned tree
 !     mapped on this proc
-      NB_FS_RHSCOMP_F = NB_FS_RHSCOMP_TOT
+      NB_FS_RHSINTR_F = NB_FS_RHSINTR_TOT
 C     Save value of KEEP(350), in case of LR solve
 C     KEEP(350) may be overwritten and restored
 C     Old unoptimized version before 5.0.2 not available anymore
       IF (KEEP(350).LE.0) KEEP(350)=1
       IF (KEEP(350).GT.2) KEEP(350)=1
       KEEP350_SAVE = KEEP(350)
-C
-C     Depending on the type of parallelism,
-C     the master can have the role of a slave
-      I_AM_SLAVE = ( id%MYID .ne. MASTER  .OR.
-     &             ( id%MYID .eq. MASTER .AND.
-     &               KEEP(46) .eq. 1 ) )
 C     
 C     Compute the number of integers and nb of reals in the structure
       CALL ZMUMPS_SIZE_IN_STRUCT (id, NB_INT, NB_CMPLX, NB_CHAR)
       NB_BYTES = NB_BYTES + NB_INT * K34_8 + NB_CMPLX * K35_8 + NB_CHAR
       NB_BYTES_ON_ENTRY = NB_BYTES !used to check alloc/dealloc count ok
-      CALL ZMUMPS_COMPUTE_MEMORY_SAVE(id,FILE_SIZE,STRUC_SIZE)
       NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
 C     ======================================
 C     BEGIN CHECK KEEP ENTRIES AND INTERFACE
 C     ======================================
       IF (id%MYID .EQ. MASTER) THEN
 C     {
-c     subroutine only because called at facto and solve
-          CALL ZMUMPS_SET_K221(id)
+C         Set ICNTL(26) -> KEEP(221)  (called at facto and solve)
+C         (might be called at facto in case of fwd in facto 
+C          with Schur+reduced RHS requested)
+          CALL ZMUMPS_SET_K221(id, .TRUE.)
           id%KEEP(111) = id%ICNTL(25)
 C         For the case of ICNTL(20)=1 one could
 C         switch off exploit sparsity when RHS is too dense.
@@ -430,8 +511,12 @@ C         switch off exploit sparsity wh
           ELSE
             id%KEEP(248) = 0 !dense RHS
           ENDIF
+C
+C         set ICNTL21 and test for out-of range entries
           ICNTL21      = id%ICNTL(21)
-          IF (ICNTL21 .ne.0.and.ICNTL21.ne.1) ICNTL21=0
+          IF ( ICNTL21.NE.0 .AND. ICNTL21.NE.1
+     &       ) ICNTL21 = 0
+C
           IF ( id%ICNTL(30) .NE.0 ) THEN
 C           A-1 is on
             id%KEEP(237) = 1
@@ -445,25 +530,81 @@ C            Force KEEP(248) accordingly
              id%KEEP(248)=1
           ENDIF
           IF ((id%KEEP(221).EQ.2 ).AND.(id%KEEP(248).NE.0) ) THEN
-C          -- input RHS is indeed stored in REDRHS and RHSCOMP
-           id%KEEP(248) = 0
+           IF (KEEP(60).NE.0) THEN
+C            -- input RHS is stored in REDRHS and RHSINTR
+             id%KEEP(248) = 0
+           ENDIF
           ENDIF
+C}
+      ENDIF
+C     =============================================================
+C     KEEP(248) and KEEP(221): need be broadcasted
+C     before continuing other checking/settings
+      CALL MPI_BCAST( id%KEEP(221), 1, MPI_INTEGER, MASTER, id%COMM,
+     &                  IERR )
+      CALL MPI_BCAST( id%KEEP(248), 1, MPI_INTEGER, MASTER, id%COMM,
+     &                  IERR )
+      IF (KEEP(248).EQ.-1
+     &  ) THEN
+C{
+        CALL ZMUMPS_CHECK_DISTRHS(
+     &       id%Nloc_RHS,
+     &       id%LRHS_loc,
+     &       id%NRHS,
+     &       id%IRHS_loc,
+     &       id%RHS_loc,
+     &       I_AM_SLAVE,
+     &       id%INFO)
+        CALL MUMPS_PROPINFO( id%ICNTL(1),
+     &                      id%INFO(1),
+     &                      id%COMM, id%MYID )
+        IF ( id%INFO(1) .LT. 0 ) GO TO 90
+C         Compute sum of id%Nloc_RHS (without out-of-range)
+C         and store it in SUM_idNloc_RHS_8
+C         (to be used to decide whether exploit sparsity 
+C         is exploited)
+          CALL ZMUMPS_ES_GET_SUM_Nloc ( 
+     &             id%N, id%Nloc_RHS, id%IRHS_loc, id%COMM,
+     &             SUM_idNloc_RHS_8 )
+C}
+      ENDIF
+C     ===========================================================
+      IF (id%MYID .EQ. MASTER) THEN
+C     {
           IF ((id%KEEP(221).EQ.2 ).AND.(id%KEEP(235).NE.0) ) THEN
 C          -- input RHS is in fact effectively
-C          -- stored in REDRHS and RHSCOMP
-           id%KEEP(235) = 0
+C          -- stored in REDRHS and/or RHSINTR
+C          (for both Schur and bwd only)
+            id%KEEP(235) = 0
           ENDIF
           IF ( (id%KEEP(248).EQ.0).AND.(id%KEEP(111).EQ.0) ) THEN
 C           RHS is not sparse and thus exploit sparsity is reset to 0
             id%KEEP(235) = 0
           ENDIF
-          IF (KEEP(248) .EQ. -1) THEN
-C           V0 distributed RHS: no ES
-            id%KEEP(235) = 0
+          IF (id%KEEP(248) .EQ. -1
+     &       ) THEN
+            IF (id%KEEP(126).EQ.0)  THEN
+             id%KEEP(235) = 0
+            ELSE IF (id%KEEP(126).EQ.-1)  THEN
+             id%KEEP(235) = 1
+            ELSE IF (id%KEEP(126).GT.0) THEN
+             IF ( SUM_idNloc_RHS_8 .LE. 
+     &        int( 
+     &          (dble(id%KEEP(126))/dble(1000))*dble(id%N)
+     &          , 8)
+     &          ) THEN
+               id%KEEP(235) = 1
+             ELSE
+               id%KEEP(235) = 0
+             ENDIF
+            ELSE
+             id%KEEP(235) = 0
+            ENDIF
           ENDIF
 C         Case of Automatic setting of exploit sparsity (KEEP(235)=-1)
 C         (in MUMPS_DRIVER original value of KEEP(235) is reset)
           IF(id%KEEP(111).NE.0) id%KEEP(235)=0
+          IF(id%KEEP(111).NE.0) id%KEEP(212)=0
 C
           IF (id%KEEP(235).EQ.-1) THEN
             IF (id%KEEP(237).NE.0) THEN
@@ -476,8 +617,10 @@ C            for A-1
             id%KEEP(235)=1
           ENDIF
 C         Setting of KEEP(242) (permute RHS)
-          IF ((KEEP(111).NE.0)) THEN
-C          In the context of null space, the null pivots
+          IF ((KEEP(111).NE.0).OR.(KEEP(248) .EQ. -1)) THEN
+C          In the context of 
+C          - distributed RHS, all columns share the same structure
+C          - null space, the null pivots
 C          are by default permuted to post-order
 C          However for null space there is in this case no need to
 C          permute null pivots since they are already in correct order.
@@ -520,8 +663,8 @@ C           Automatic setting of permute
             ENDIF
 C           }
           ENDIF
-          IF ( (id%KEEP(221).EQ.1 ).AND.(id%KEEP(235).NE.0) ) THEN
-C          -- Do not permute RHS with REDRHS for the time being
+          IF ( id%KEEP(221).NE.0 ) THEN
+C          -- Do not permute RHS with REDRHS/RHSINTR 
             id%KEEP(242) = 0
           ENDIF
           IF (KEEP(242).EQ.0) KEEP(243)=0 ! interleave off
@@ -575,24 +718,31 @@ C
           ENDIF
 C     }
       ENDIF
+      id%KEEP(401) = 0
+      IF (id%ICNTL(48).EQ.1) id%KEEP(401)=1
 C     Bcast id%KEEP(401) strategy (which
 C     may be switched off or on during solve)
       CALL MPI_BCAST( id%KEEP(401), 1, MPI_INTEGER, MASTER, id%COMM,
      &                  IERR )
+C     define ICNTL48_EFF on master
+      IF (id%MYID.EQ.MASTER) THEN
+        IF ( (id%KEEP(401).EQ.1). AND. (id%KEEP(400).GT.0) ) THEN
+          ICNTL48_EFF = 1
+        ELSE
+          ICNTL48_EFF = 0
+        ENDIF
+      ENDIF
       CALL MPI_BCAST(MTYPE,1,MPI_INTEGER,MASTER,
      &               id%COMM,IERR)
       CALL MPI_BCAST( id%KEEP(111), 1, MPI_INTEGER, MASTER, id%COMM,
      &                  IERR )
-      CALL MPI_BCAST( id%KEEP(221), 1, MPI_INTEGER, MASTER, id%COMM,
-     &                  IERR )
       CALL MPI_BCAST( id%KEEP(235), 1, MPI_INTEGER, MASTER, id%COMM,
      &                  IERR )
       CALL MPI_BCAST( id%KEEP(237), 1, MPI_INTEGER, MASTER, id%COMM,
      &                  IERR )
       CALL MPI_BCAST( id%KEEP(242), 2, MPI_INTEGER, MASTER, id%COMM,
      &                  IERR )
-      CALL MPI_BCAST( id%KEEP(248), 1, MPI_INTEGER, MASTER, id%COMM,
-     &                  IERR )
+C Allready done   CALL MPI_BCAST( id%KEEP(248), ...)
       CALL MPI_BCAST( id%KEEP(350), 1, MPI_INTEGER, MASTER, id%COMM,
      &                  IERR )
       CALL MPI_BCAST( id%KEEP(485), 1, MPI_INTEGER, MASTER, id%COMM,
@@ -700,7 +850,7 @@ C            Fwd in facto is not compati
              INFO(2) = 9
              IF (LPOK) THEN
                 WRITE(LP,'(A)')
-     &               ' ERROR: Transpose system (ICNTL(9).NE.0) not ',
+     &               ' ERROR: Transpose system (ICNTL(9).NE.1) not ',
      &               ' compatible with forward performed during',
      &               ' factorization (ICNTL(32)=1)'
              ENDIF
@@ -773,27 +923,30 @@ C            Sparse RHS may be due to A-
           ENDIF
 C         Entries of A-1 are stored in place of the input sparse RHS
 C         thus no need for RHS to be allocated.
-          IF ( (id%KEEP(237).EQ.0) ) THEN
+          IF (id%KEEP(237).EQ.0)  THEN
              IF ((id%KEEP(248) == 0 .AND.KEEP(221).NE.2)
-     &            .OR. ICNTL21==0) THEN
-C              RHS must be of size N on the master either to
+     &            .OR. 
+     &            (ICNTL21==0.AND.(KEEP(221).NE.1)) 
+     &          )THEN
+C              RHS must be of size N*NRHS on the master either to
 C              store the dense centralized RHS, either to store
 C              the dense centralized solution.
-               CALL ZMUMPS_CHECK_DENSE_RHS
-     &         (id%RHS,id%INFO,id%N,id%NRHS,id%LRHS)
-               IF (id%INFO(1) .LT. 0) GOTO 333
+                CALL ZMUMPS_CHECK_DENSE_RHS
+     &          (id%RHS,id%INFO,id%N,id%NRHS,id%LRHS)
+                IF (id%INFO(1) .LT. 0) GOTO 333
              ENDIF
           ELSE
-C           Check that the constraint NRHS=N is respected
+C           AM1: check that the constraint NRHS=N is respected
 C           Check for valid sparse RHS structure done
             IF (id%NRHS .NE. id%N) THEN
-              id%INFO(1)=-47
+              id%INFO(1)= -47
               id%INFO(2)=id%NRHS
               GOTO 333
             ENDIF
           ENDIF
-          IF (id%KEEP(248) == 1) THEN
-C           ------------------------------------
+          IF (id%KEEP(248) == 1
+     &       ) THEN
+C{          ------------------------------------
 C           RHS_SPARSE, IRHS_SPARSE and IRHS_PTR
 C           must be allocated of adequate size
 C           ------------------------------------
@@ -866,6 +1019,7 @@ C             Possible in case of duppli
               id%INFO(2)=10
               GOTO 333
             END IF
+C}
           ENDIF
 C         --------------------------------
 C         Set null space options for solve
@@ -879,16 +1033,20 @@ C
 C     --------------------------------------
 C     Check distributed solution vectors
 C     --------------------------------------
-      IF (ICNTL21==1) THEN
-          IF ( I_AM_SLAVE ) THEN
+      IF (ICNTL21 .NE. 0 ) THEN 
+          IF (I_AM_SLAVE) THEN
+            NSOL_loc = id%KEEP(89)
+          ELSE
+            NSOL_loc = 0
+          ENDIF
 C           (I)SOL_loc should be allocated to hold the
 C           distributed solution on exit
-            IF ( id%LSOL_loc < id%KEEP(89) ) THEN
+            IF ( id%LSOL_loc .LT. NSOL_loc ) THEN
               id%INFO(1)= -29
               id%INFO(2)= id%LSOL_loc
               GOTO 333
             ENDIF
-            IF (id%KEEP(89) .NE. 0) THEN
+            IF ( NSOL_loc .GT. 0 ) THEN
               IF ( .not. associated(id%ISOL_loc) )THEN
                 id%INFO(1)=-22
                 id%INFO(2)=13
@@ -899,7 +1057,7 @@ C           distributed solution on exit
                 id%INFO(2)=14
                 GOTO 333
               ENDIF
-              IF (size(id%ISOL_loc) < id%KEEP(89) ) THEN
+              IF (size(id%ISOL_loc) < NSOL_loc ) THEN
                 id%INFO(1)=-22
                 id%INFO(2)=13
                 GOTO 333
@@ -913,7 +1071,7 @@ C             can result in such a situa
 C             suppressed if needed but might be still be ok in case
 C             the right-hand side overflows too.
               IF (size(id%SOL_loc) <
-     &              (id%NRHS-1)*id%LSOL_loc+id%KEEP(89)) THEN
+     &              (id%NRHS-1)*id%LSOL_loc+NSOL_loc) THEN
                 id%INFO(1)=-22
                 id%INFO(2)=14
                 GOTO 333
@@ -921,17 +1079,17 @@ C             the right-hand side overfl
 #             else
               IF (size(id%SOL_loc,kind=8) <
      &              int(id%NRHS-1,8)*int(id%LSOL_loc,8)+
-     &              int(id%KEEP(89),8)) THEN
+     &              int(NSOL_loc,8)) THEN
                 id%INFO(1)=-22
                 id%INFO(2)=14
                 GOTO 333
               END IF
 #             endif
-            ENDIF
-          ENDIF
-      ENDIF
+            ENDIF ! NSOL_loc > 0
+      ENDIF ! ICNTL21 .NE. 0
       IF (id%MYID .NE. MASTER) THEN
-          IF (id%KEEP(248) == 1) THEN
+          IF (id%KEEP(248) == 1
+     &    ) THEN
 C          RHS should NOT be associated
 C          if I am not master since it is
 C          not even used to store the solution
@@ -957,16 +1115,6 @@ C          not even used to store the so
            END IF
           END IF
       ENDIF
-      IF (I_AM_SLAVE .AND. id%KEEP(248).EQ.-1) THEN
-        CALL ZMUMPS_CHECK_DISTRHS(
-     &       id%Nloc_RHS,
-     &       id%LRHS_loc,
-     &       id%NRHS,
-     &       id%IRHS_loc,
-     &       id%RHS_loc,
-     &       id%INFO)
-        IF (id%INFO(1) .LT. 0) GOTO 333
-      ENDIF
 C     Prepare pointers to pass POINTERS(1) to
 C     routines with implicit interfaces which
 C     will then assume contiguous information
@@ -993,11 +1141,17 @@ C         so that IRHS_loc_PTR(1) is ok
       ELSE
         idRHS_loc=>CDUMMY_TARGET
       ENDIF
-      IF (I_AM_SLAVE .AND. ICNTL21.EQ.1 .AND.
-     &    KEEP(248) .EQ. -1) THEN  ! Dist RHS and dist solution
+C
+C
+C     Check as soon as solution is distributed
+      IF (I_AM_SLAVE .AND. ICNTL21.NE.0 .AND.
+     &    KEEP(248) .EQ. -1
+     &    ) THEN  ! Dist RHS and dist solution
+C
         IF (associated(id%RHS_loc) .AND.
      &      associated(id%SOL_loc)) THEN
-          IF (id%KEEP(89).GT.0) THEN
+C         NSOL_loc was defined earlier
+          IF (NSOL_loc.GT.0) THEN
 C           ----------------------------------------------------
 C           Check if RHS_loc and SOL_loc point to same object...
 C           id%SOL_loc(1) ok otherwise an error -22/14
@@ -1024,13 +1178,14 @@ C              we raise the error system
      &" ** Error RHS_loc and SOL_loc pointers match but LRHS_loc="
      &,id%LRHS_loc, " and LSOL_loc=", id%LSOL_loc
                ENDIF
+               GOTO 333
             ENDIF
           ENDIF
         ENDIF
       ENDIF
       IF (id%MYID.EQ.MASTER) THEN
-C         Do some checks (REDRHS), depending on KEEP(221)
-          CALL ZMUMPS_CHECK_REDRHS(id)
+C         Do some checks on KEEP(221) and REDRHS (in case of Schur)
+          CALL ZMUMPS_CHECK_K221andREDRHS(id)
       END IF ! MYID.EQ.MASTER
       IF (id%INFO(1) .LT. 0) GOTO 333
 C     -------------------------
@@ -1044,16 +1199,28 @@ C     -------------------------
 C     ====================================
 C     END CHECK INTERFACE AND KEEP ENTRIES
 C     ====================================
-C     ====================================
-C     Process case of NZ_RHS = 0  with
-C     sparse RHS and General Sparse (NOT A-1)
 C     -----------------------------------
       IF ((id%KEEP(248).EQ.1).AND.(id%KEEP(237).EQ.0)) THEN
-C
        CALL MPI_BCAST(id%NZ_RHS,1,MPI_INTEGER,MASTER,
      &               id%COMM,IERR)
+      ENDIF
 C
-       IF (id%NZ_RHS.EQ.0) THEN
+C     =======================================================
+C     BEGIN Test for empty RHS :
+C     sparse RHS and General Sparse (NOT A-1) and  NZ_RHS = 0
+C     OR
+C     Distributed RHS and sum of id%Nloc_RHS 
+C     (without off out-of-range) equal to 0
+C     =======================================================
+      IF 
+     & (
+     &     ( (id%KEEP(248).EQ.1).AND.(id%KEEP(237).EQ.0)
+     &       .AND. (id%NZ_RHS.EQ.0) ) 
+     &     .OR.
+     &     ( (id%KEEP(248).EQ.-1).AND. (SUM_idNloc_RHS_8.EQ.0_8)
+     &     ) 
+     & )  THEN
+C{      
 C       We reset solution to zero and we return
 C       (first freeing working space at label 90)
         IF ((ICNTL21.EQ.1).AND.(I_AM_SLAVE)) THEN
@@ -1073,38 +1240,46 @@ C         Note that LSOL_loc >= KEEP(89)
      &               id%KEEP(1),id%KEEP8(1),
      &               id%IS(1), LIW_PASSED,id%MYID_NODES,
      &               id%N, id%STEP(1), id%PROCNODE_STEPS(1),
-     &               id%NSLAVES, scaling_data_sol, LSCAL
+     &               id%NSLAVES,
+#if defined(USE_OLD_SCALING)
+     &               scaling_data_sol, .FALSE., ! empty RHS, no scaling
+#endif
 C                    For checking only
-     &               , .FALSE., IDUMMY(1), 1
+     &               .FALSE., IDUMMY(1), 1
      &               )
+          ENDIF
+        ENDIF
+C       Solution is null
+        IF (ICNTL21.NE.0) THEN  ! distributed solution
             DO J=1, id%NRHS
-              DO I=1, KEEP(89)
-                id%SOL_loc((J-1)*id%LSOL_loc + I) =ZERO
+C             (NSOL_loc=KEEP(89) or id%NSOL_loc, and in case
+C              ICNTL21=1, NSOL_loc is 0 on non-working host)
+              DO I=1, NSOL_loc
+                id%SOL_loc(int(J-1,8)*id%LSOL_loc + I) =ZERO
               ENDDO
             ENDDO
-          ENDIF
         ENDIF
-        IF (ICNTL21.NE.1) THEN  ! centralized solution
+        IF (ICNTL21.EQ.0) THEN  ! centralized solution
 C       ----------------------------
 C       RHS reset to zero on master
 C       ----------------------------
-         IF (id%MYID.EQ.MASTER) THEN
+          IF (id%MYID.EQ.MASTER) THEN
             DO J=1, id%NRHS
               DO I=1, id%N
                 id%RHS(int(J-1,8)*int(id%LRHS,8) + int(I,8)) =ZERO
               ENDDO
             ENDDO
-         ENDIF
+          ENDIF
         ENDIF
 C
 C       print solve phase stats if requested
         IF ( PROKG )  THEN
-C          write(6,*) " NZ_RHS is zero "
-           WRITE( MPG, 150 )
+            WRITE( MPG, 150 )
 C             ICNTL(35) should not been accessed during SOLVE thus
 C             print KEEP(486) value set during factorization
      &        id%NRHS, ICNTL(27), ICNTL(9), ICNTL(10), ICNTL(11),
-     &        ICNTL(20), ICNTL(21), ICNTL(30), KEEP(486)
+     &        ICNTL(20), ICNTL(21), ICNTL(30), KEEP(486), 
+     &        ICNTL48_EFF
            IF (KEEP(221).NE.0) THEN
             WRITE (MPG, 152) KEEP(221)
            ENDIF
@@ -1115,16 +1290,28 @@ C             print KEEP(486) value set
 C
 C       --------
         GOTO 90 ! end of solve deallocate what is needed
-C       ====================================
-C       END CHECK INTERFACE AND KEEP ENTRIES
-C       ====================================
-       ENDIF  ! test NZ_RHS.EQ.0
-C      --------
-      ENDIF ! (id%KEEP(248).EQ.1).AND.(id%KEEP(237).EQ.0)
+C}
+      ENDIF  ! test empty RHS (general sparse or Distributed)
+C     =======================================================
+C     END of Test for empty RHS :
+C     =======================================================
+C     ====================================
+C     END CHECK INTERFACE AND KEEP ENTRIES
+C     ====================================
       INTERLEAVE_PAR   =.FALSE.
       DO_PERMUTE_RHS   =.FALSE.
+      CALL_NODES_FWD_BWD       = .FALSE.
+      FIRST_CALL_NODES_FWD_BWD = .FALSE.
+C     Default is no sparsity exploited
+      nodes_FWD_PTR => IDUMMY_TARGET
+      nodes_BWD_PTR => IDUMMY_TARGET
+      Lnodes_FWD = -1
+      Lnodes_BWD = -1
 C
-      IF ((id%KEEP(235).NE.0).or.(id%KEEP(237).NE.0)) THEN
+      IF ((id%KEEP(235).NE.0).or.(id%KEEP(237).NE.0) 
+     &   ) THEN
+         CALL_NODES_FWD_BWD       = .TRUE.
+         FIRST_CALL_NODES_FWD_BWD = .TRUE.
 C        Case of pruned elimination tree or selected entries in A-1
          IF (id%KEEP(237).NE.0.AND.
      &        id%KEEP(248).EQ.0) THEN
@@ -1137,7 +1324,8 @@ C         sparse RHS has been forced to
           ENDIF
           CALL MUMPS_ABORT()
          ENDIF
-C        NBT is inout in MUMPS_REALLOC and should be initialized.
+C        NBT (in Bytes) is inout in MUMPS_REALLOC and 
+C                       should be initialized.
          NBT = 0
 C        -- Allocate Step2node on each proc
          CALL MUMPS_REALLOC(id%Step2node, id%KEEP(28), id%INFO, LP,
@@ -1161,26 +1349,37 @@ C          we reuse Step2node computed i
 C          Step2node is deallocated each time a new analysis is
 C          performed or when job=-2 is called
          ENDIF
-         NB_BYTES = NB_BYTES + NBT*K34_8
+C        --- NBT is the nb of extra bytes allocated
+         NB_BYTES = NB_BYTES + NBT
          NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
-         NB_BYTES_EXTRA = NB_BYTES_EXTRA + NBT * K34_8
+         NB_BYTES_EXTRA = NB_BYTES_EXTRA + NBT 
 C        Mapping information used during solve. In case of several
 C        facto+solve it has to be recomputed.
 C        In case of several solves with the same
 C        facto, it is not recomputed.
-C        It used to compute the interleaving
+C        It is used to compute the interleaving
 C        for A-1, and, in dev_version, passed to sol_c to compute
 C        some stats
          IF((KEEP(235).NE.0).OR.(KEEP(237).NE.0)) THEN
            IF(.NOT.associated(id%IPTR_WORKING)) THEN
              CALL ZMUMPS_BUILD_MAPPING_INFO(id)
            END IF
+           idIPTR_WORKING => id%IPTR_WORKING
+           idWORKING => id%WORKING
+         ELSE 
+C           case of selected entries in solution
+C           with no ES during fwd
+            SIZE_WORKING = 1
+            SIZE_IPTR_WORKING = 1
+            idIPTR_WORKING => IDUMMY_TARGET
+            idWORKING => IDUMMY_TARGET
          END IF
       ENDIF
 C
 C     Initialize SIZE_OF_BLOCK from MUMPS_SOL_ES module
-      IF ( I_AM_SLAVE )
-     &  CALL ZMUMPS_SOL_ES_INIT(id%OOC_SIZE_OF_BLOCK, id%KEEP(201))
+      IF ( I_AM_SLAVE ) THEN
+        CALL ZMUMPS_SOL_ES_INIT(id%OOC_SIZE_OF_BLOCK, id%KEEP(201))
+      ENDIF
       DO_NULL_PIV = .TRUE.
       NBCOL_INBLOC = -9998
       NZ_THIS_BLOCK= -9998
@@ -1188,7 +1387,7 @@ C     Initialize SIZE_OF_BLOCK from MUMP
 c
       IF (id%MYID.EQ.MASTER) THEN ! Compute NRHS_NONEMPTY
 C
-C       -- Sparse RHS does
+C       -- Sparse RHS (general, centralized)
         IF ( KEEP(111)==0 .AND. KEEP(248)==1
      &   ) THEN
 C       -- Note that KEEP(111).NE.0 (null space on)
@@ -1196,8 +1395,9 @@ C       -- and KEEP(248).NE.0 will be ma
 C       -- When computing entries of A-1 (or SparseRHS only)
            NRHS_NONEMPTY = 0
            DO I=1, id%NRHS
-              IF (id%IRHS_PTR(I).LT.id%IRHS_PTR(I+1))
-     &             NRHS_NONEMPTY = NRHS_NONEMPTY+1 !ith col in non empty
+              IF (id%IRHS_PTR(I).LT.id%IRHS_PTR(I+1)) THEN
+                   NRHS_NONEMPTY = NRHS_NONEMPTY+1 !ith col in non empty
+              ENDIF
            ENDDO
            IF (NRHS_NONEMPTY.LE.0) THEN
 C           Internal error: tested before in mumps_driver
@@ -1247,6 +1447,7 @@ C     We work on a maximum of NBRHS at a
 C     The leading dimension of RHS is id%LRHS on the host process
 C     and it is set to N on slave processes.
       IF (id%MYID .eq. MASTER) THEN
+C{
         KEEP(84) = ICNTL(27)
 C     Treating ICNTL(27)=0 as if ICNTL(27)=1
         IF(ICNTL(27).EQ.0) KEEP(84)=1
@@ -1262,11 +1463,12 @@ C     Treating ICNTL(27)=0 as if ICNTL(2
           IF (NBRHS .GT. NRHS_NONEMPTY ) NBRHS = NRHS_NONEMPTY
 C
         ENDIF
+C}
       ENDIF
 #if defined(V_T)
       CALL VTBEGIN(glob_comm_ini,IERR)
 #endif
-C     NRHS_NONEMPTY needed on all procs to allocate RHSCOMP on slaves
+C     NRHS_NONEMPTY needed on all procs to allocate RHSINTR on slaves
       CALL MPI_BCAST(NRHS_NONEMPTY,1,MPI_INTEGER,MASTER,
      &               id%COMM,IERR)
       CALL MPI_BCAST(NBRHS,1,MPI_INTEGER,MASTER,
@@ -1342,7 +1544,11 @@ C
             ENDIF
           END IF
         ENDIF
-        LWCB8_MIN = int(NB_K133,8)*int(KEEP(133),8)*int(NBRHS,8)
+CPA2ALL: int(min(NRHS_NONEMPTY,NBRHS),8) instead of NBRHS
+C       LWCB8_MIN = int(NB_K133,8)*int(KEEP(133),8)*int(NBRHS,8)
+        LWCB8_MIN = int(NB_K133,8)*int(KEEP(133),8)*
+     &        int(min(NRHS_NONEMPTY,NBRHS),8)
+C
 C
 C       ---------------------------------------------------------------
 C       Set WK_USER_PROVIDED to true when workspace WK_USER is provided
@@ -1537,12 +1743,14 @@ C         Access to OOC data in module d
         ENDIF
       ENDIF
       IF (id%MYID.EQ.MASTER) THEN
+C{
         IF ( PROKG )  THEN
           WRITE( MPG, 150 )
 C             ICNTL(35) should not been accessed during SOLVE thus
 C             print KEEP(486) value set during factorization
      &        id%NRHS, NBRHS, ICNTL(9), ICNTL(10), ICNTL(11),
-     &        ICNTL(20), ICNTL(21), ICNTL(30), KEEP(486)
+     &        ICNTL(20), ICNTL(21), ICNTL(30), KEEP(486),
+     &        ICNTL48_EFF
           IF (KEEP(111).NE.0) THEN
             WRITE (MPG, 151) KEEP(111)
           ENDIF
@@ -1553,11 +1761,9 @@ C             print KEEP(486) value set
             WRITE (MPG, 153) KEEP(252)
           ENDIF
         ENDIF
-C
 C     ====================================
 C       Define LSCAL, ICNTL10 and ICNTL11
 C     ====================================
-C
         LSCAL = (((KEEP(52) .GT. 0) .AND. (KEEP(52) .LE. 8)) .OR. (
      &    KEEP(52) .EQ. -1) .OR. KEEP(52) .EQ. -2)
         ICNTL10 = ICNTL(10)
@@ -1568,71 +1774,10 @@ C       Values of ICNTL(11) out of range
            IF (PROKG) WRITE(MPG,'(A)')
      &    ' WARNING: ICNTL(11) out of range'
         ENDIF
-        POSTPros = .FALSE.
-        IF (ICNTL11.NE.0 .OR. ICNTL10.NE.0) THEN
-          POSTPros = .TRUE.
-C       FORBID ERROR ANALYSIS AND ITERATIVE REFINEMENT
-C       if there are options that are not compatible
-          IF (KEEP(111).NE.0) THEN
-C       IF WE RETURN A NULL SPACE BASIS or compute entries in A-1
-C        of Fwd in facto
-C       -When only one columns of A-1 is requested then
-C        we could try to reactivate IR even if
-C          -code need be updated
-C          -accuracy could be # when one or more columns are requested
-              IF (PROKG) WRITE(MPG,'(A,A)')
-     &       ' WARNING: Incompatible features: null space basis ',
-     &                ' and Iter. Ref and/or Err. Anal.'
-              POSTPros = .FALSE.
-           ELSE IF ( KEEP(237) .NE.0 ) THEN
-              IF (PROKG) WRITE(MPG,'(A,A)')
-     &       ' WARNING: Incompatible features: AM1',
-     &                ' and Iter. Ref and/or Err. Anal.'
-              POSTPros = .FALSE.
-           ELSE IF ( KEEP(252) .NE.0 ) THEN
-              IF (PROKG) WRITE(MPG,'(A,A)')
-     &       ' WARNING: Incompatible features: Fwd in facto ',
-     &                ' and Iter. Ref and/or Err. Anal.'
-              POSTPros = .FALSE.
-           ELSE IF (KEEP(221).NE.0) THEN
-C       Forbid error analysis and iterative refinement
-C       in case of reduced rhs/solution
-              IF (PROKG) WRITE(MPG,'(A,A)')
-     &       ' WARNING: Incompatible features: reduced RHS ',
-     &       '          and Iter. Ref and/or Err. Anal.'
-              POSTPros = .FALSE.
-            ELSE IF  (NBRHS.GT. 1 .OR. ICNTL(21) .GT. 0) THEN
-C          Forbid error analysis and iterative refinement if
-C       the solution is distributed or
-C       in the case where nrhs > 1
-              IF (PROKG) WRITE(MPG,'(A,A)')
-     &       ' WARNING:  Incompatible features: nrhs>1 or distrib sol',
-     &       '           and Iter. Ref and/or Err. Anal.'
-              POSTPros = .FALSE.
-            ELSE IF ( KEEP(248) .EQ. -1 ) THEN
-C          Forbid error analysis and iterative refinement
-C          in case of distributed RHS
-              IF (PROKG) WRITE(MPG,'(A,A)')
-     &       ' WARNING:  Incompatible features: distrib rhs',
-     &       '           and Iter. Ref and/or Err. Anal.'
-              POSTPros = .FALSE.
-            ENDIF  
-            IF (.NOT.POSTPros) THEN
-              ICNTL11 = 0
-              ICNTL10 = 0
-            ENDIF
-        ENDIF
-C   Write a warning.
-        IF ((ICNTL(10) .NE. 0) .AND. (ICNTL10 .EQ. 0)) THEN
-            IF (PROKG) WRITE(MPG,'(A)')
-     &    ' WARNING: ICNTL(10) treated as if set to 0 '
-        ENDIF
-        IF ((ICNTL(11) .NE. 0)
-     &        .AND.(ICNTL11 .EQ. 0)) THEN
-            IF (PROKG) WRITE(MPG,'(A)')
-     &    ' WARNING: ICNTL(11) treated as if set to 0 '
-        ENDIF
-C     -- end of test master
+        CALL ZMUMPS_SET_POSTPros (
+     &                      KEEP(1), ICNTL(1), NBRHS, MPG, PROKG,
+     &                      ICNTL10, ICNTL11, POSTPros)
+C}    -- end of test master
       END IF
       CALL MPI_BCAST(POSTPros,1,MPI_LOGICAL,MASTER,
      &               id%COMM,IERR)
@@ -1687,28 +1832,29 @@ C        allocated, otherwise MAT_ALLOC_
       CALL MPI_REDUCE( MAT_ALLOC_LOC, MAT_ALLOC, 1,
      &                 MPI_INTEGER,
      &                 MPI_MIN, MASTER, id%COMM, IERR)
-      IF ( id%MYID .eq. MASTER ) THEN
+      IF ( POSTPros.and.(id%MYID .eq. MASTER) ) THEN
+C       if postprocessing requested matrix must be allocated
         IF (MAT_ALLOC.EQ.0) THEN
-            IF (KEEP(54).NE.0) THEN
+           IF (KEEP(54).NE.0) THEN
 C           Write on MPG this time (we wrote on MP before in
 C           case of distributed matrix and wrote on MPG already
 C           in case of centralized matrix)
             IF (PROKG) WRITE(MPG,'(A)')
      &      ' WARNING: original distributed matrix is not allocated'
-             ENDIF
-              POSTPros = .FALSE.
-              ICNTL11 = 0
-              ICNTL10 = 0
+           ENDIF
+           POSTPros = .FALSE.
+           ICNTL11 = 0
+           ICNTL10 = 0
 C   Write a warning.
            IF ((ICNTL(10) .NE. 0) .AND. (ICNTL10 .EQ. 0)) THEN
             IF (PROKG) WRITE(MPG,'(A)')
-     &    ' WARNING: ICNTL(10) treated as if set to 0'
+     &      ' WARNING: ICNTL(10) treated as if set to 0'
            ENDIF
            IF ((ICNTL(11) .EQ. 1).OR.(ICNTL(11) .EQ. 2) 
      &        .AND.(ICNTL11 .EQ. 0)) THEN
             IF (PROKG) WRITE(MPG,'(A)')
-     &    ' WARNING: ICNTL(11) treated as if set to 0 '
-          ENDIF
+     &      ' WARNING: ICNTL(11) treated as if set to 0 '
+           ENDIF
         ENDIF
         IF (POSTPros) THEN
             ALLOCATE(SAVERHS(id%N*NBRHS),stat = allocok)
@@ -1748,14 +1894,44 @@ C     ----------------------------------
      &               id%COMM,IERR)
       CALL MPI_BCAST(ICNTL11,1,MPI_INTEGER,MASTER,
      &               id%COMM,IERR)
-      CALL MPI_BCAST(ICNTL21,1,MPI_INTEGER,MASTER,
-     &               id%COMM,IERR)
       CALL MPI_BCAST(POSTPros,1,MPI_LOGICAL,MASTER,
      &               id%COMM,IERR)
       CALL MPI_BCAST(LSCAL,1,MPI_LOGICAL,MASTER,
      &               id%COMM,IERR)
       CALL MPI_BCAST(KEEP(237),1,MPI_INTEGER,MASTER,
      &               id%COMM,IERR)
+#if ! defined(USE_OLD_SCALING)
+C     ----------------------------------------------
+C     Initialize SCALING_LOC_FWD and SCALING_LOC_BWD
+C     They corespond to all pivots factorized on a
+C     given MPI process and point to a dummy array
+C     of size 1 on the host of if no pivot was
+C     factorized (KEEP(89))=0
+C     ----------------------------------------------
+      IF (LSCAL .AND. id%KEEP(89) .GT. 0) THEN
+          IF (MTYPE .EQ. 1) THEN
+            SCALING_LOC_FWD => id%ROWSCA_loc
+            SCALING_LOC_BWD => id%COLSCA_loc
+          ELSE
+            SCALING_LOC_FWD => id%COLSCA_loc
+            SCALING_LOC_BWD => id%ROWSCA_loc
+          ENDIF
+      ELSE ! includes non working master on which KEEP(89)=0
+          SCALING_LOC_FWD => RDUMMY_TARGET
+          SCALING_LOC_BWD => RDUMMY_TARGET
+      ENDIF
+C     Remarks related to scalings:
+C     * During postprocessing, one performs solves
+C       with alternatively A and A^T, meaning that
+C       SCALING_LOC_FWD and SCALING_LOC_BWD will
+C       be redefined.
+C     * In case of exploit sparsity, RHSINTR may
+C       have less rows than ROWSCA_loc/COLSCA_loc.
+C       SCALING_RHSINTR_FWD and SCALING_RHSINTR_BWD
+C       will then be extracted from
+C       SCALING_LOC_FWD and SCALING_LOC_BWD thanks
+C       to the subroutine ZMUMPS_SCALINGRHSINTR
+#endif
 C     KEEP(248)==1 if not_NullSpace (KEEP(111)=0)
 C           and sparse RHS on input (id%ICNTL(20)/KEEP(248)==1)
 C     (KEEP(248)==1 implies KEEP(111) = 0, otherwise error was raised)
@@ -1965,81 +2141,85 @@ c         --- ALLOCATE outside loop RHS_
 C     --------------------------------------------------
       IF ( I_AM_SLAVE ) THEN
         IF ((KEEP(221).EQ.2 .AND. KEEP(252).EQ.0)) THEN
-C          -- RHSCOMP must have been allocated in
+C          -- RHSINTR must have been allocated in
 C          -- previous solve step (with option KEEP(221)=1)
-           IF (.NOT.associated(id%RHSCOMP)) THEN
+           IF (.NOT.associated(id%RHSINTR)) THEN
              INFO(1) = -35
              INFO(2) = 1
              GOTO 111
            ENDIF
 C          IF ((KEEP(248).EQ.0) .OR. (id%NRHS.EQ.1)) THEN
-C          POSINRHSCOMP_ROW/COL are meaningful and could even be reused
-           IF (.NOT.associated(id%POSINRHSCOMP_ROW) ) ! .OR.
-!    &        .NOT.(id%POSINRHSCOMP_COL_ALLOC))
+C          GLOB2LOC_RHS/SOL are meaningful and could even be reused
+           IF (.NOT.associated(id%GLOB2LOC_RHS) ) ! .OR.
+!    &        .NOT.(id%GLOB2LOC_SOL_ALLOC))
      &     THEN
              INFO(1) = -35
              INFO(2) = 2
              GOTO 111
            ENDIF
-           IF (.not.id%POSINRHSCOMP_COL_ALLOC) THEN
-C             POSINRHSCOMP_COL that is kept from
+           IF (.not.id%GLOB2LOC_SOL_ALLOC) THEN
+C             GLOB2LOC_SOL that is kept from
 C             previous call to solve must then (already)
-C             point to id%POSINRHSCOMP_ROW
-              id%POSINRHSCOMP_COL => id%POSINRHSCOMP_ROW
+C             point to id%GLOB2LOC_RHS
+              id%GLOB2LOC_SOL => id%GLOB2LOC_RHS
            ENDIF
         ELSE
 C         ----------------------
-C         Allocate POSINRHSCOMP_ROW/COL
+C         Allocate GLOB2LOC_RHS/SOL
 C         ----------------------
-C         The size of POSINRHSCOMP arrays
+C         The size of POSINRHSINTR arrays
 C         does not depend on the block of RHS
-C         POSINRHSCOMP_ROW/COL are initialized in the loop of RHS
-          IF (associated(id%POSINRHSCOMP_ROW)) THEN
+C         GLOB2LOC_RHS/SOL are initialized in the loop of RHS
+          IF (associated(id%GLOB2LOC_RHS)) THEN
             NB_BYTES = NB_BYTES -
-     &          int(size(id%POSINRHSCOMP_ROW),8)*K34_8
-            DEALLOCATE(id%POSINRHSCOMP_ROW)
+     &          int(size(id%GLOB2LOC_RHS),8)*K34_8
+            DEALLOCATE(id%GLOB2LOC_RHS)
           ENDIF
-          ALLOCATE (id%POSINRHSCOMP_ROW(id%N), stat = allocok)
+          ALLOCATE (id%GLOB2LOC_RHS(id%N), stat = allocok)
           IF ( allocok .GT. 0 ) THEN
              INFO(1)=-13
              INFO(2)=id%N
              GOTO 111
           END IF
           NB_BYTES = NB_BYTES +
-     &          int(size(id%POSINRHSCOMP_ROW),8)*K34_8
+     &          int(size(id%GLOB2LOC_RHS),8)*K34_8
           NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
-          IF (id%POSINRHSCOMP_COL_ALLOC) THEN
+          IF (id%GLOB2LOC_SOL_ALLOC) THEN
             NB_BYTES = NB_BYTES -
-     &          int(size(id%POSINRHSCOMP_COL),8)*K34_8
-            DEALLOCATE(id%POSINRHSCOMP_COL)
-            NULLIFY(id%POSINRHSCOMP_COL)
-            id%POSINRHSCOMP_COL_ALLOC = .FALSE.
+     &          int(size(id%GLOB2LOC_SOL),8)*K34_8
+            DEALLOCATE(id%GLOB2LOC_SOL)
+            NULLIFY(id%GLOB2LOC_SOL)
+            id%GLOB2LOC_SOL_ALLOC = .FALSE.
           ENDIF
 C
-          IF ((KEEP(50).EQ.0).OR.KEEP(237).NE.0) THEN
-           ALLOCATE (id%POSINRHSCOMP_COL(id%N), stat = allocok)
+          IF ( (KEEP(50).EQ.0).OR.(KEEP(237).NE.0).OR.
+     &         (KEEP(212).NE.0)
+     &       ) THEN
+           ALLOCATE (id%GLOB2LOC_SOL(id%N), stat = allocok)
            IF ( allocok .GT. 0 ) THEN
              INFO(1)=-13
              INFO(2)=id%N
              GOTO 111
            END IF
-           id%POSINRHSCOMP_COL_ALLOC = .TRUE.
+           id%GLOB2LOC_SOL_ALLOC = .TRUE.
            NB_BYTES = NB_BYTES +
-     &          int(size(id%POSINRHSCOMP_COL),8)*K34_8
+     &          int(size(id%GLOB2LOC_SOL),8)*K34_8
            NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
           ELSE
-C          Do no allocate POSINRHSCOMP_COL
-           id%POSINRHSCOMP_COL => id%POSINRHSCOMP_ROW
-           id%POSINRHSCOMP_COL_ALLOC = .FALSE.
+C          Do no allocate GLOB2LOC_SOL
+           id%GLOB2LOC_SOL => id%GLOB2LOC_RHS
+           id%GLOB2LOC_SOL_ALLOC = .FALSE.
           ENDIF
           IF (KEEP(221).NE.2) THEN
-C         -- only in the case of bwd after reduced RHS
-C         -- we have to keep "old" RHSCOMP
-            IF (associated(id%RHSCOMP)) THEN
+C         -- only in the case of bwd after 
+C         -- fwd only (with or without Schur)
+C         -- we have to keep "old" RHSINTR
+            IF (associated(id%RHSINTR)) THEN
              NB_BYTES = NB_BYTES - id%KEEP8(25)*K35_8
-             DEALLOCATE(id%RHSCOMP)
-             NULLIFY(id%RHSCOMP)
-             id%KEEP8(25)=0_8
+             DEALLOCATE(id%RHSINTR)
+             NULLIFY(id%RHSINTR)
+             id%KEEP8(25)  = 0_8
+             id%LD_RHSINTR = 0
             ENDIF
           ENDIF
         ENDIF
@@ -2138,16 +2318,22 @@ C          migrated outside the blocking
             UNS_PERM_INV_NEEDED_INMAINLOOP = .TRUE.
       ENDIF
       UNS_PERM_INV_NEEDED_BEFMAINLOOP = .FALSE.
+      IF (KEEP(23) .GT. 0 .AND. MTYPE.EQ.1 .AND. ICNTL21.EQ.2) THEN
+           UNS_PERM_INV_NEEDED_INMAINLOOP = .TRUE.
+      ENDIF
       IF ( KEEP(23) .GT.0 .AND.
      &            MTYPE .NE. 1 .AND. KEEP(248).EQ.-1 ) THEN
 C          Similar to sparse RHS case, we need to modify IRHS_loc
 C          indices in the distributed RHS case. However, we need
-C          UNS_PERM_INV on all processors. But only before theC
+C          UNS_PERM_INV on all processors. But only before the
 C          main loop on the RHS blocks.
            UNS_PERM_INV_NEEDED_BEFMAINLOOP = .TRUE.
       ENDIF
+C
+      UNS_PERM_INV_NEEDED_ONSLAVES = .FALSE.
       IF ( UNS_PERM_INV_NEEDED_INMAINLOOP .OR.
      &     UNS_PERM_INV_NEEDED_BEFMAINLOOP ) THEN
+C          We need UNS_PERM_INV
            ALLOCATE(UNS_PERM_INV(id%N),stat=allocok)
            if (allocok .GT.0 ) THEN
              INFO(1)=-13
@@ -2188,8 +2374,14 @@ C     Propagate errors
 C
 C     UNS_PERM_INV needed on slaves:
       IF ( KEEP(23).NE.0 .AND.
-     &     ( KEEP(237).NE.0 .OR.
-     &     ( MTYPE.NE.1 .AND. KEEP(248).EQ.-1 ) ) ) THEN
+     &     (  KEEP(237).NE.0 .OR.
+     &        ( MTYPE.NE.1 .AND. KEEP(248).EQ.-1 ) .OR.
+     &        ( MTYPE.EQ.1 .AND. ICNTL21.EQ.2)
+     &     ) 
+     &   ) THEN
+        UNS_PERM_INV_NEEDED_ONSLAVES = .TRUE.
+      ENDIF
+      IF (UNS_PERM_INV_NEEDED_ONSLAVES) THEN
 C       Broadcast UNS_PERM_INV
         CALL MPI_BCAST( UNS_PERM_INV,id%N,MPI_INTEGER,MASTER,
      &                  id%COMM,IERR )
@@ -2198,7 +2390,8 @@ C     -------------------------------
 C     BEGIN
 C     Preparation for distributed RHS
 C     -------------------------------
-      IF (I_AM_SLAVE .AND. KEEP(248).EQ.-1) THEN
+      IF (I_AM_SLAVE .AND. KEEP(248).EQ.-1
+     & ) THEN
 C       Distributed RHS case
         ALLOCATE(MAP_RHS_loc(max(id%Nloc_RHS,1)), stat=allocok)
         IF (allocok .GT. 0) THEN
@@ -2208,10 +2401,10 @@ C       Distributed RHS case
         ENDIF
         NB_BYTES = NB_BYTES + max(int(id%Nloc_RHS,8),1_8)*K34_8
       ENDIF
-C     MAP_RHS_loc will be built in the main
-C     loop, when processing the first block.
-C     It requires POSINRHSCOMP to be built.
-      BUILD_RHSMAPINFO = .TRUE.
+C      MAP_RHS_loc will be built in the main
+C      loop, when processing the first block.
+C      It requires POSINRHSINTR to be built.
+       BUILD_RHSMAPINFO = .TRUE.
  20   CONTINUE
       CALL MUMPS_PROPINFO( ICNTL(1), INFO(1),
      &                         id%COMM,id%MYID)
@@ -2221,7 +2414,8 @@ C     transpose system, use MUMPS intern
 C     for IRHS_loc_PTR. Done before scaling since
 C     scaling is on permuted matrix
       IF ( I_AM_SLAVE .AND. KEEP(23).GT.0 .AND. KEEP(248).EQ.-1
-     &     .AND. MTYPE.NE.1 ) THEN
+     &     .AND. MTYPE.NE.1 
+     &   ) THEN
           IF (id%Nloc_RHS .GT. 0) THEN
             ALLOCATE(IRHS_loc_PTR(id%Nloc_RHS),stat=allocok)
             IF (allocok.GT.0) THEN
@@ -2252,7 +2446,9 @@ C     to free memory
         ALLOCATE(UNS_PERM_INV(1))  ! to posibly pass it as an argument
         NB_BYTES = NB_BYTES + K34_8
       ENDIF
-      IF (LSCAL .AND. id%KEEP(248).EQ.-1) THEN
+#if defined(USE_OLD_SCALING)
+      IF (LSCAL .AND. id%KEEP(248).EQ.-1
+     &   ) THEN
 C       Scaling done based on original indices
 C       provided by user
         IF (MTYPE == 1) THEN
@@ -2268,6 +2464,7 @@ C         Transpose
      &       NB_BYTES, NB_BYTES_MAX, K16_8, LP, LPOK,
      &       ICNTL(1), INFO(1) )
       ENDIF
+#endif
 C     -------------------------------
 C     END
 C     Preparation for distributed RHS
@@ -2280,9 +2477,11 @@ C     ----------------------------------
 C     BEGIN
 C     Preparation for distributed solution
 C     -------------------------------------
-      IF ( ICNTL21==1 ) THEN
+      IF ( ICNTL21 .NE. 0 ) THEN
+C{
+#if defined(USE_OLD_SCALING)
         IF (LSCAL) THEN
-C         In case of scaling we will need to scale
+C{        In case of scaling we will need to scale
 C         back the sol. Put the values of the scaling
 C         arrays needed to do that on each processor.
           IF (id%MYID.NE.MASTER) THEN
@@ -2306,17 +2505,20 @@ C         arrays needed to do that on ea
      &                         id%COMM,id%MYID)
           IF (INFO(1) .LT.0 ) GOTO 90
           IF (I_AM_SLAVE) THEN
-            ALLOCATE(scaling_data_sol%SCALING_LOC(id%KEEP(89)),
-     &               stat=allocok)
+              ALLOCATE(scaling_data_sol%SCALING_LOC(max(1,id%KEEP(89))),
+     &                 stat=allocok)
             IF (allocok > 0) THEN
               IF (LPOK) THEN
                 WRITE(LP,*) 'Error allocating local scaling array'
               ENDIF
               INFO(1)=-13
-              INFO(2)=id%KEEP(89)
+              INFO(2)=max(1,id%KEEP(89))
               GOTO 38
             ENDIF
-            NB_BYTES = NB_BYTES + int(id%KEEP(89),8)*K16_8
+            IF (ICNTL21.NE.0) THEN
+C            Real entries for scaling
+             NB_BYTES = NB_BYTES + int(max(1,id%KEEP(89)),8)*K16_8
+            ENDIF
             NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
           ENDIF ! I_AM_SLAVE
  38       CONTINUE
@@ -2336,11 +2538,17 @@ C         arrays needed to do that on ea
      &                       id%COMM,IERR)
               scaling_data_sol%SCALING=>id%ROWSCA
           ENDIF
+C}
         ENDIF ! LSCAL
-        IF ( I_AM_SLAVE ) THEN
-C         ----------------------
+#endif
+        IF ( ICNTL21.EQ.1 .AND. I_AM_SLAVE 
+     &     ) THEN
+C         --------------------------------
 C         Prepare ISOL_loc array
-C         ----------------------
+#if defined(USE_OLD_SCALING)
+C         and on the fly, scaling_data_sol
+#endif
+C         --------------------------------
           LIW_PASSED=max(1,LIW)
 C         Only called if more than 1 pivot
 C         was eliminated by the processor.
@@ -2351,12 +2559,19 @@ C         Note that LSOL_loc >= KEEP(89)
      &               id%KEEP(1),id%KEEP8(1),
      &               id%IS(1), LIW_PASSED,id%MYID_NODES,
      &               id%N, id%STEP(1), id%PROCNODE_STEPS(1),
-     &               id%NSLAVES, scaling_data_sol, LSCAL
+     &               id%NSLAVES,
+#if defined(USE_OLD_SCALING)
+     &               scaling_data_sol, LSCAL,
+#endif
 C                    For checking only
-     &               , (KEEP(248).EQ.-1), IRHS_loc_PTR(1), id%Nloc_RHS
+     &               (KEEP(248).EQ.-1), IRHS_loc_PTR(1), id%Nloc_RHS
      &               )
           ENDIF 
-          IF (id%MYID.NE.MASTER .AND. LSCAL) THEN
+        ENDIF ! I_AM_SLAVE
+#if defined(USE_OLD_SCALING)
+#endif
+#if defined(USE_OLD_SCALING)
+        IF (id%MYID.NE.MASTER .AND. LSCAL) THEN
 C           ---------------------------------
 C           Local (small) scaling arrays have
 C           been built, free temporary copies
@@ -2369,8 +2584,15 @@ C           ----------------------------
               NULLIFY(id%ROWSCA)
             ENDIF
             NB_BYTES = NB_BYTES - int(id%N,8)*K16_8
-          ENDIF
-        ENDIF ! I_AM_SLAVE
+        ENDIF
+#endif
+C}
+      ENDIF ! ICNTL21 .NE. 0
+      IF (ICNTL21 .EQ.1) THEN
+C       ---------------------------------------------------
+C       Take into account unsymmetric permutation to modify
+C       ISOL_loc, in case ISOL_loc is provided by MUMPS
+C       ---------------------------------------------------
         IF (KEEP(23) .NE. 0 .AND. MTYPE==1) THEN
 C         Broadcast the unsymmetric permutation and
 C         permute the indices in ISOL_loc
@@ -2409,11 +2631,14 @@ C     ----------------------------------
 C     Preparation for distributed solution
 C     END
 C     --------------------------------------
-C     ----------------------------
-C     Preparation for reduced RHS
-C     ----------------------------
-      IF ( ( KEEP(221) .EQ. 1 ) .OR.
+C     ---------------------------------------------
+C     In case of Schur, preparation for reduced RHS
+C     ---------------------------------------------
+      IF ( (KEEP(60).NE.0) .AND. 
+     &    (
+     &     ( KEEP(221) .EQ. 1 ) .OR.
      &     ( KEEP(221) .EQ. 2 )
+     &    )
      &   ) THEN
 C       -- First compute MASTER_ROOT_IN_COMM proc number in
 C          COMM_NODES on which is mapped the master of the root.
@@ -2452,7 +2677,8 @@ C          -- other procs not concerned
          ENDIF
       ENDIF
 C
-      IF ( KEEP(248)==1 ) THEN  ! Sparse RHS (A-1 or general sparse)
+      IF ( KEEP(248)==1 
+     &   ) THEN  ! Sparse RHS (A-1 or general sparse)
 !        JBEG_RHS - current starting column within A-1 or sparse rhs
 !                      set in the loop below and used to obtain the
 !                      global index of the column of the sparse RHS
@@ -2539,9 +2765,9 @@ C     Propagate errors
 c --------------------------
 c --------------------------
       IF (id%NSLAVES .EQ. 1) THEN
-c     - In case of NS/A-1 we may want to permute RHS
-c     - for NS thus is to apply permutation to PIVNUL_LIST
-*     - before starting loop of NBRHS
+C{    - In case of NS/A-1 we may want to permute RHS
+C     - for NS thus is to apply permutation to PIVNUL_LIST
+C     - before starting loop of NBRHS
        IF (DO_PERMUTE_RHS .AND. KEEP(111).NE.0 ) THEN
 C     NOTE:
 C        when host not working both master and slaves have
@@ -2551,6 +2777,7 @@ C        in this case the complete list
      &                 ' not available yet '
             CALL MUMPS_ABORT()
        ENDIF                     ! End Permute_RHS
+C}
       ELSE
          IF (DO_PERMUTE_RHS .AND. KEEP(111).NE.0 ) THEN
             WRITE(*,*) id%MYID, ':INTERNAL ERROR 2 : ',
@@ -2558,7 +2785,6 @@ C        in this case the complete list
      &                 ' not available yet '
             CALL MUMPS_ABORT()
 C
-C
          ENDIF                  !  End DO_PERMUTE_RHS
          IF (INTERLEAVE_PAR.AND. (KEEP(111).NE.0)) THEN
             WRITE(*,*) id%MYID, ':INTERNAL ERROR 3 : ',
@@ -2601,15 +2827,15 @@ C          to permute the null column pi
      &            MPI_INTEGER,
      &            MASTER, id%COMM,IERR)
       ENDIF
-C   L0-threads to be activated iff KEEP(401)>0 and KEEP(400)>0
-          IF (KEEP(401) .GT. 0) THEN
+C   L0-threads to be activated iff KEEP(401)=1 and KEEP(400)>0
+          IF (KEEP(401) .EQ. 1) THEN
 C          L0-threads was requested for solve phase
 C          and will be effective only if KEEP(400) >0 
 C          which indicates that L0-threads was 
 C          performed during analysis+factorization
            IF ( KEEP(400) .GT. 0 ) THEN
 C           Check if number of threads is consistent with
-C           the one used during factorization
+C           the one used during factorization for all procs
 C{
             NOMP = 1
 !$          NOMP=omp_get_max_threads()
@@ -2617,17 +2843,23 @@ C{
 C               NOMP should be the one from analysis
                 id%INFO(1) = -58
                 id%INFO(2) = KEEP(400)
-            IF (LPOK) WRITE(LP,'(A,A,I5,A,I5)')
-     &" FAILURE DETECTED IN SOLVE: #threads for KEEP(401)",
-     &" changed from",KEEP(400)," at analysis to", NOMP
+                IF (LPOK) WRITE(LP,'(A,A,I5,A,I5)')
+     &" FAILURE DETECTED IN SOLVE: #threads for multithreaded",
+     &" tree parallelism changed from",KEEP(400)," at analysis to", 
+     &  NOMP
               ENDIF
            ENDIF
+C          error check
+           CALL MUMPS_PROPINFO( ICNTL(1), INFO(1),
+     &                    id%COMM,id%MYID)
+           IF ( id%INFO(1) .LT. 0 ) GO TO 90
 C}
           ENDIF
       IF (KEEP(400) .GT. 0) THEN
         CALL ZMUMPS_SOL_L0OMP_LI(KEEP(400))
       ENDIF
 C     ==============================
+C     MAIN LOOP:
 C     BLOCKING ON the number of RHS
 C      We work on  a maximum of NBRHS at a time.
 C      the leading dimension of RHS is id%LRHS on master
@@ -2649,14 +2881,16 @@ C     {
 C       ==========================
 C       -- NBRHS     : Original block size
 C       -- BEG_RHS   : Column index of the first RHS in the list of
-C                      non empty RHS (RHS_LOC) to
+C                      non empty RHS (RHS_loc) to
 C                      be processed during this iteration
 C       -- NBRHS_EFF : Effective block size at current iteration
-C          In case of sparse RHS (KEEP(248)==1) NBRHS_EFF only refers to
-C                  non-empty columns and is used to compute NBCOL_INBLOC
-C          -- NBCOL_INBLOC  : the number of columns of sparse RHS needed
-C                        to get NBRHS_EFF non empty columns columns of
-C                        sparse RHS processed at each step
+C                      that we be set to nb of contiguous non empty 
+C                      columns
+C        In case of sparse RHS (KEEP(248)==1) NBRHS_EFF only refers to
+C                non-empty columns and is used to compute NBCOL_INBLOC
+C        -- NBCOL_INBLOC  : the number of columns of sparse RHS needed
+C                      to get NBRHS_EFF non empty columns columns of
+C                      sparse RHS processed at each step
 C
         NBRHS_EFF    = min(NRHS_NONEMPTY-BEG_RHS+1, NBRHS)
 C
@@ -2690,7 +2924,7 @@ C       id%RHS is accessed). Remark that
 C       overwritten later, in case of general sparse right-hand side
 C       and centralized solution to skip empty columns 
 C       ===========================================================
-        IF (
+        IF  (
 C           slave procs
      &      ( id%MYID .NE. MASTER )
 C       even on master when RHS not allocated
@@ -2734,7 +2968,8 @@ C       ================================
 C       Shift empty columns in case of sparse RHS
 C       ==========================================
         IF ( (id%MYID.EQ.MASTER) .AND.
-     &        KEEP(248)==1  ) THEN
+     &        KEEP(248)==1  
+     &     ) THEN
 C         update position of JBEG_RHS on first non-empty
 C         column of this block
           JBEG_RHS = JEND_RHS + 1
@@ -2743,7 +2978,8 @@ C         column of this block
      &          id%IRHS_PTR(PERM_RHS(JBEG_RHS)+1) )
 C             Empty column
               IF ((KEEP(237).EQ.0).AND.(ICNTL21.EQ.0).AND.
-     &              (KEEP(221).NE.1) ) THEN
+     &              (KEEP(221).NE.1) 
+     &           ) THEN
 C                General sparse RHS (NOT A-1) and centralized solution
 C                Set to zero part of the
 C                solution corresponding to empty columns
@@ -2758,7 +2994,8 @@ C                solution corresponding
             DO WHILE( id%IRHS_PTR(JBEG_RHS) .EQ.
      &        id%IRHS_PTR(JBEG_RHS+1) )
               IF ((KEEP(237).EQ.0).AND.(ICNTL21.EQ.0).AND.
-     &          (KEEP(221).NE.1) ) THEN
+     &             (KEEP(221).NE.1) 
+     &           ) THEN
 C               Case of general sparse RHS (NOT A-1) and
 C               centralized solution: set to zero part of
 C               the solution corresponding to empty columns
@@ -2768,11 +3005,13 @@ C               the solution correspondi
                 ENDDO
               ENDIF
               IF (KEEP(221).EQ.1) THEN
-C               Reduced RHS set to ZERO
-                DO I = 1, id%SIZE_SCHUR
-                  id%REDRHS(int(JBEG_RHS-1,8)*int(LD_REDRHS,8) +
-     &            int(I,8)) =  ZERO
-                ENDDO
+                IF (KEEP(60).NE.0) THEN
+C                 Fwd with Schur: reduced RHS set to ZERO
+                  DO I = 1, id%SIZE_SCHUR
+                    id%REDRHS(int(JBEG_RHS-1,8)*int(LD_REDRHS,8) +
+     &              int(I,8)) =  ZERO
+                  ENDDO
+                ENDIF
               ENDIF
               JBEG_RHS = JBEG_RHS +1
             ENDDO
@@ -2781,7 +3020,7 @@ C         Count nb of RHS columns skippe
 C         * ZMUMPS_DISTRIBUTED_SOLUTION to reset those
 C           columns to zero.
 C         * in case of reduced right-hand side, to set
-C           corresponding entries of RHSCOMP to 0 after
+C           corresponding entries of RHSINTR to 0 after
 C           forward phase.
           NB_RHSSKIPPED = JBEG_RHS - (JEND_RHS + 1)
           IF ((KEEP(248).EQ.1).AND.(KEEP(237).EQ.0)
@@ -2798,7 +3037,8 @@ C           forward phase.
 C
 C       Shift on REDRHS in reduced RHS functionality
 C
-        IF (id%MYID.EQ.MASTER .AND. KEEP(221).NE.0) THEN
+        IF (id%MYID.EQ.MASTER .AND. KEEP(221).NE.0 
+     &       .AND. KEEP(60).NE.0 ) THEN
 C         Initialize IBEG_REDRHS
 C         Note that REDRHS always has id%NRHS Colmuns
           IBEG_REDRHS= int(JBEG_RHS-1,8)*int(LD_REDRHS,8) + 1_8
@@ -2814,11 +3054,12 @@ C
         CALL VTBEGIN(perm_scal_ini,IERR)
 #endif
         IF (id%MYID .eq. MASTER) THEN
-C         ======================
-          IF (KEEP(248)==1) THEN
-C         ======================
+C{        ======================
+          IF (KEEP(248)==1
+     &       ) THEN
+C{        ======================
 C
-C         Sparse RHS format ( A-1 or sparse input format)
+C         Sparse RHS format ( A-1 or sparse centralized input format)
 C         is provided as input by the user (IRHS_SPARSE ...)
 C         --------------------------------------------------
 C         Compute NZ_THIS_BLOCK and NBCOL_INBLOC
@@ -2840,7 +3081,10 @@ C         the first non empty column; th
 C         maximum size NBRHS_EFF except if we reach another empty
 C         column. (We are not sure to have a copy allocated
 C         and thus cannot compress on the fly, as done naturally
-C         for A-1).
+C         for A-1)
+C         For A-1 we process NBRHS_EFF non empty columns 
+C         in the bloc that contains NBCOL_INBLOC columns
+C         (empty+non empty)
           STOP_AT_NEXT_EMPTY_COL = .FALSE.
           DO I=JBEG_RHS, id%NRHS
             NBCOL_INBLOC = NBCOL_INBLOC +1
@@ -2861,15 +3105,19 @@ C              --  sparse case (not AM-1
                STOP_AT_NEXT_EMPTY_COL =.TRUE.
             ENDIF
             IF (COLSIZE.GT.0
+C{
      &      ) THEN
               NBCOL = NBCOL+1
               NZ_THIS_BLOCK = NZ_THIS_BLOCK + COLSIZE
+C}
             ELSE IF (STOP_AT_NEXT_EMPTY_COL) THEN
-C We have reached an empty column with already selected non empty 
-C columns: reduce block size to non empty columns reached so far.
+C{ We have reached an empty column with already selected non empty 
+C  columns: reduce block size to non empty columns reached so far.
               NBCOL_INBLOC = NBCOL_INBLOC -1
+C Note that NBRHS_EFF is udated only on master 
               NBRHS_EFF = NBCOL
               EXIT
+C}
             ENDIF
             IF (NBCOL.EQ.NBRHS_EFF) EXIT
           ENDDO
@@ -3000,9 +3248,16 @@ c    *                   (1:NZ_THIS_BLOC
      &          id%IRHS_SPARSE(id%IRHS_PTR(JBEG_RHS):
      &             id%IRHS_PTR(JBEG_RHS)+NZ_THIS_BLOCK-1)
             ENDIF
+#if defined(USE_OLD_SCALING)
+C           Centralized scaling: perform scaling on master
+C           in RHS_SPARSE_COPY
             IF (LSCAL.OR.DO_PERMUTE_RHS.OR.INTERLEAVE_PAR.OR.
      &          (KEEP(237).NE.0)) THEN
-C             if scaling is on or if columns of the RHS are
+#else
+            IF (DO_PERMUTE_RHS.OR.INTERLEAVE_PAR.OR.
+     &          (KEEP(237).NE.0)) THEN
+#endif
+C             if columns of the RHS are
 C             permuted then a copy of RHS_SPARSE is needed.
 C             Also always allocated with A-1,
 c             to enable receiving during mumps_gather_solution
@@ -3034,23 +3289,36 @@ c    *            (1:NZ_THIS_BLOCK)
             IF (DO_PERMUTE_RHS.OR.INTERLEAVE_PAR.OR.
      &          (id%KEEP(237).NE.0)) THEN
               IF (id%KEEP(237).NE.0) THEN
-C               --initialized to one; it might be
-C               modified if scaling is on (one first entry in each col is scaled)
+C               --initialized to one
+#if defined(USE_OLD_SCALING)
+C               it might be modified if scaling is on (one first entry
+C               in each col is scaled)
                 RHS_SPARSE_COPY = ONE
-              ELSE IF (.NOT. LSCAL) THEN
+#else
+C               Local scalings are used: RHSINTR is initialized
+C               directly on the workers and RHS_SPARSE_COPY will
+C               only be used during ZMUMPS_GATHER_SOLUTION_AM1.
+#endif
+              ELSE
 C               -- Columns are not contiguous and need be copied one by one
+#if defined(USE_OLD_SCALING)
 C               -- This need not be done if scaling is on because it
 C               -- will done and scaled later.
-                IPOS = 1
-                DO I=JBEG_RHS, JBEG_RHS + NBCOL_INBLOC -1
-                  COLSIZE = id%IRHS_PTR(PERM_RHS(I)+1)
-     &                    - id%IRHS_PTR(PERM_RHS(I))
-                  IF (COLSIZE .EQ. 0) CYCLE
-                  RHS_SPARSE_COPY(IPOS:IPOS+COLSIZE-1) =
-     &            id%RHS_SPARSE(id%IRHS_PTR(PERM_RHS(I)):
-     &            id%IRHS_PTR(PERM_RHS(I)+1) -1)
-                  IPOS = IPOS + COLSIZE
-                ENDDO
+                IF (.NOT. LSCAL) THEN
+#endif
+                  IPOS = 1
+                  DO I=JBEG_RHS, JBEG_RHS + NBCOL_INBLOC -1
+                    COLSIZE = id%IRHS_PTR(PERM_RHS(I)+1)
+     &                      - id%IRHS_PTR(PERM_RHS(I))
+                    IF (COLSIZE .EQ. 0) CYCLE
+                    RHS_SPARSE_COPY(IPOS:IPOS+COLSIZE-1) =
+     &              id%RHS_SPARSE(id%IRHS_PTR(PERM_RHS(I)):
+     &              id%IRHS_PTR(PERM_RHS(I)+1) -1)
+                    IPOS = IPOS + COLSIZE
+                  ENDDO
+#if defined(USE_OLD_SCALING)
+                ENDIF
+#endif
               ENDIF
             ENDIF
 C           =========================
@@ -3085,9 +3353,9 @@ C                 (ii) columns might hav
               ENDIF ! MTYPE.NE.1
             ENDIF ! KEEP(23).NE.0
           ENDIF ! NZ_THIS_BLOCK .NE. 0
-C         -----
+C}        -----
           ENDIF  !  ============ KEEP(248)==1
-C         -----
+C}        -----
         ENDIF   !  (id%MYID .eq. MASTER)
 C
 C =====================  ERROR handling and propagation ================
@@ -3098,16 +3366,29 @@ C =====================  ERROR handling
 C ======================================================================
 C
 C       NBCOL_INBLOC depends on loop
-        IF (KEEP(248)==1) THEN
+        IF (KEEP(248)==1
+     &     ) THEN
             CALL MPI_BCAST( NBCOL_INBLOC,1, MPI_INTEGER,
      &           MASTER, id%COMM,IERR)
         ELSE
           NBCOL_INBLOC = NBRHS_EFF
         ENDIF
         JEND_RHS =JBEG_RHS + NBCOL_INBLOC - 1
+        IF ((KEEP(248).EQ.1).AND.(KEEP(237).EQ.0)) THEN
+C         Only case (in previous block) for which
+C         NBRHS_EFF has been modified only on master
+          ! case of general sparse: in case of empty columns
+          ! modifed version of
+          ! NBRHS_EFF need be broadcasted since it is used
+          ! to update BEG_RHS at the end of the DO WHILE
+            CALL MPI_BCAST( NBRHS_EFF,1, MPI_INTEGER,
+     &           MASTER, id%COMM,IERR)
+            CALL MPI_BCAST(NB_RHSSKIPPED,1,MPI_INTEGER,MASTER,
+     &               id%COMM,IERR)
+        ENDIF
         IF ((KEEP(111).eq.0).AND.(KEEP(252).EQ.0)
      &      .AND.(KEEP(221).NE.2 ).AND.(KEEP(248).EQ.1) ) THEN
-C         ----------------------------
+C{        ----------------------------
 C         -- SPARSE RIGHT-HAND-SIDE
 C         ----------------------------
           CALL MPI_BCAST( NZ_THIS_BLOCK,1, MPI_INTEGER,
@@ -3164,162 +3445,492 @@ C ======================================
      &             MPI_INTEGER,
      &             MASTER, id%COMM,IERR)
           ENDIF
+C}
         ENDIF
 C
 C       =========================================================
-C       INITIALIZE POSINRHSCOMP_ROW/COL, RHSCOMP and related data
-C       For distributed RHS, initialize RHSMAPINFO (at 1st block)
+C       INITIALIZE 
+C       - nodes_FWD and nodes_BWD
 C       =========================================================
-        IF ( I_AM_SLAVE ) THEN
-C         --------------------------------------------------
-C         If I am involved in the solve and if
-C         either
-C           no null space comput (keep(111)=0) and sparse rhs
-C         or
-C             null space computation
-C         then
-C           compute POSINRHSCOMP
-C         endif
+        IF (FIRST_CALL_NODES_FWD_BWD) THEN
+C{         First time ZMUMPS_NODES_FWD_BWD_SIZE_FILL 
+C          is called allocated Pruned_Sons_FWD
+           IF (allocated(Pruned_Sons_FWD)) THEN 
+             NB_BYTES = NB_BYTES - size(Pruned_Sons_FWD) * K34_8
+             DEALLOCATE(Pruned_Sons_FWD)
+           ENDIF
+           IF (allocated(Pruned_Sons_BWD)) THEN 
+            NB_BYTES = NB_BYTES - size(Pruned_Sons_BWD) * K34_8
+            DEALLOCATE(Pruned_Sons_BWD)
+           ENDIF
+           ALLOCATE (Pruned_Sons_FWD(KEEP(28)),
+     &             Pruned_Sons_BWD(KEEP(28)), 
+     &             stat=allocok)
+           IF (allocok .GT. 0 ) THEN
+            INFO(1)=-13
+            INFO(2)= 2*KEEP(28)
+           ELSE
+            NB_BYTES = NB_BYTES + 
+     &                int(size(Pruned_Sons_FWD),8)*K34_8 +
+     &                int(size(Pruned_Sons_BWD),8)*K34_8 
+            NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
+           ENDIF
+C}
+        ENDIF
+C =====================  ERROR handling and propagation ==============
+        CALL MUMPS_PROPINFO( ICNTL(1), INFO(1),
+     &                       id%COMM,id%MYID)
+        IF (INFO(1) .LT.0 ) GOTO 90
+C=====================================================================
+C       Reset FIRST_CALL_NODES_FWD_BWD for not allocating
+C       (Pruned_Sons_FWD/BWD within loop)
+        FIRST_CALL_NODES_FWD_BWD = .FALSE.
 C
-C         Fwd in facto: in this case only POSINRHSCOMP need be computed
+        IF (CALL_NODES_FWD_BWD) THEN
+C{
+          fill = .FALSE.
+          nodes_FWD_PTR => IDUMMY_TARGET
+          Lnodes_FWD_PTR = 1
+          nodes_BWD_PTR => IDUMMY_TARGET
+          Lnodes_BWD_PTR = 1
+          CALL ZMUMPS_NODES_FWD_BWD_SIZE_FILL (
+     &           fill, id%ICNTL(1), 
+     &           id%N, id%KEEP(28),  id%KEEP(1), 
+     &           id%STEP(1), id%Step2node(1),
+     &           IRHS_loc_PTR(1), id%Nloc_RHS,
+     &           IRHS_PTR_COPY(1), NBCOL_INBLOC, IRHS_SPARSE_COPY(1), 
+     &           NZ_THIS_BLOCK, PERM_RHS, size(PERM_RHS), JBEG_RHS,
+     &           UNS_PERM_INV, size(UNS_PERM_INV), ! size 1 if not used
+     &           ICNTL21, 
+     &           id%MYID, id%COMM,
+     &           id%INFO,
+     &           Pruned_Sons_FWD, Pruned_Sons_BWD,
+     &           Lnodes_FWD, Lnodes_BWD
+     &           , nodes_FWD_PTR(1), nodes_BWD_PTR(1)
+     &           , Lnodes_FWD_PTR, Lnodes_BWD_PTR
+     &           )
+C     
+C        ALLOCATE nodes_FWD and nodes_BWD  if needed
+C
+          IF (Lnodes_FWD.GT.0) THEN
+C           NBT is inout in MUMPS_REALLOC and should be initialized.
+            NBT = 0
+            CALL MUMPS_REALLOC(nodes_FWD, Lnodes_FWD, id%INFO, LP,
+     &         FORCE=.FALSE.,
+     &         STRING='nodes_FWD', MEMCNT=NBT, ERRCODE=-13)
+            IF (INFO(1).LT.0) GOTO 46
+C
+            nodes_FWD_PTR => nodes_FWD
+            Lnodes_FWD_PTR = Lnodes_FWD
+            NB_BYTES = NB_BYTES + NBT
+            NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
+          ELSE
+            nodes_FWD_PTR => IDUMMY_TARGET
+            Lnodes_FWD_PTR = 1
+          ENDIF
+          IF (Lnodes_BWD.GT.0) THEN
+C           NBT is inout in MUMPS_REALLOC and should be initialized.
+            NBT = 0
+            CALL MUMPS_REALLOC(nodes_BWD, Lnodes_BWD, id%INFO, LP,
+     &         FORCE=.FALSE.,
+     &         STRING='nodes_BWD', MEMCNT=NBT, ERRCODE=-13)
+            IF (INFO(1).LT.0) GOTO 46
+C
+            nodes_BWD_PTR => nodes_BWD
+            Lnodes_BWD_PTR = Lnodes_BWD
+            NB_BYTES = NB_BYTES + NBT
+            NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
+          ELSE
+            nodes_BWD_PTR => IDUMMY_TARGET
+            Lnodes_BWD_PTR = 1
+          ENDIF
 C
-C         (POSINRHSCOMP_ROW/COL indirection arrays should
+C =====================  ERROR handling and propagation ==============
+ 46       CONTINUE
+          CALL MUMPS_PROPINFO( ICNTL(1), INFO(1),
+     &                         id%COMM,id%MYID)
+          IF (INFO(1) .LT.0 ) GOTO 90
+C=====================================================================
+          IF (Lnodes_FWD.GT.0 .OR. Lnodes_BWD.GT.0) THEN
+C{
+C          we build nodes_FWD_PTR and/or nodes_BWD_PTR
+C          that will be used to prune flops 
+C          and even if one of the steps FWD/BWD does not
+C          lead to pruning (in this case 
+C          POSTINRHS_COMP will not benefit from pruning).
+           fill = .TRUE.
+           CALL ZMUMPS_NODES_FWD_BWD_SIZE_FILL (
+     &           fill, id%ICNTL(1), 
+     &           id%N, id%KEEP(28),  id%KEEP(1), 
+     &           id%STEP(1), id%Step2node(1),
+     &           IRHS_loc_PTR(1), id%Nloc_RHS,
+     &           IRHS_PTR_COPY(1), NBCOL_INBLOC, IRHS_SPARSE_COPY(1), 
+     &           NZ_THIS_BLOCK, PERM_RHS, size(PERM_RHS), JBEG_RHS,
+     &           UNS_PERM_INV, size(UNS_PERM_INV), ! size 1 if not used
+     &           ICNTL21, 
+     &           id%MYID, id%COMM,
+     &           id%INFO, 
+     &           Pruned_Sons_FWD, Pruned_Sons_BWD,
+     &           Lnodes_FWD, Lnodes_BWD
+     &           , nodes_FWD_PTR(1), nodes_BWD_PTR(1)
+     &           , Lnodes_FWD_PTR, Lnodes_BWD_PTR
+     &           )
+C}
+          ENDIF
+C         ------------------------------------------------
+C         Update CALL_NODES_FWD_BWD and free workspace if 
+C         not used again in loop of RHS
+C         ------------------------------------------------
+          IF (
+     &          (KEEP(237) .NE. 0).OR.                   ! AM1
+     &          ((KEEP(235) .NE. 0).AND.KEEP(248).NE.-1) ! GS
+     &       ) THEN
+C           target nodes for chain pruning 
+C           need be updated in case of AM1 or General Sparse
+            CALL_NODES_FWD_BWD = .TRUE.
+          ELSE
+C           all other cases including 
+C           distributed RHS and distributed solution 
+            CALL_NODES_FWD_BWD = .FALSE.
+          ENDIF
+          IF (.NOT. CALL_NODES_FWD_BWD
+     &       ) THEN
+C           Not needed anymore in the loop of RHS
+            IF (allocated(Pruned_Sons_FWD)) THEN 
+             NB_BYTES = NB_BYTES - size(Pruned_Sons_FWD) * K34_8
+             DEALLOCATE(Pruned_Sons_FWD)
+            ENDIF
+            IF (allocated(Pruned_Sons_BWD)) THEN 
+             NB_BYTES = NB_BYTES - size(Pruned_Sons_BWD) * K34_8
+             DEALLOCATE(Pruned_Sons_BWD)
+            ENDIF
+C         ELSE
+C           deallocate later
+          ENDIF
+C}
+        ENDIF
+C       =========================================================
+C       INITIALIZE 
+C       - GLOB2LOC_RHS/SOL, RHSINTR and related data
+C       - For distributed RHS, initialize RHSMAPINFO (at 1st block)
+C       =========================================================
+C         
+C         Fwd in facto: in this case we peronrly peonly POSINRHSINTR need be computed
+C
+C         (GLOB2LOC_RHS/SOL indirection arrays should
 C         have been allocated once outside loop)
-C         Compute size of RHSCOMP since it might depend
+C         Compute size of RHSINTR since it might depend
 C            on the process index and of the sparsity of the RHS
 C            if it is exploited.
-C         Initialize POSINRHSCOMP_ROW/COL
+C         Initialize GLOB2LOC_RHS/SOL
 C
-C         Note that LD_RHSCOMP and id%KEEP8(25)
+C         Note that id%LD_RHSINTR and id%KEEP8(25)
 C         are not set on the host in this routine in
 C         the case of a non-working host.
-C         Note that POSINRHSCOMP is now always computed in SOL_DRIVER
+C         Note that POSINRHSINTR is now always computed in SOL_DRIVER
 C         at least during the first block of RHS when sparsity of RHS
 C         is not exploited.
 C         -------------------------------
-C         INITTIALZE POSINRHSCOMP_ROW/COL
+C         INITTIALZE GLOB2LOC_RHS/SOL
 C         -------------------------------
 C
-          IF ( KEEP(221).EQ.2 .AND. KEEP(252).EQ.0
-     &      .AND.  (KEEP(248).NE.1 .OR. (id%NRHS.EQ.1))
-     &      ) THEN
-C           Reduced RHS was already computed during
-C           a previous forward step AND is valid.
-C           By valid we mean:
-C            -no forward in facto  (KEEP(252)==0) during which
-C             POSINRHSCOMP was not computed
-C           AND
-C            -no exploit sparsity with multiple RHS
-C            because in this case POSINRHSCOMP would
-C            be valid only for the last block processed during fwd.
-C           In those cases since we only perform the backward step, we do not
-C           need to compute POSINRHSCOMP
-            BUILD_POSINRHSCOMP = .FALSE.
-          ENDIF
+C       next block ok for Schur only
+        IF ( KEEP(221).EQ.2 .AND. KEEP(252).EQ.0
+     &    .AND.  (KEEP(248).NE.1 .OR. (id%NRHS.EQ.1))
+     &    ) THEN
+C         Reduced RHS (Schur feature) was already computed during
+C         a previous forward step AND is valid.
+C         By valid we mean:
+C          -no forward in facto  (KEEP(252)==0) during which
+C           POSINRHSINTR was not computed
+C         AND
+C          -no exploit sparsity with multiple RHS
+C          because in this case POSINRHSINTR would
+C          be valid only for the last block processed during fwd.
+C         In those cases since we only perform the backward step, 
+c         we do not need to compute POSINRHSINTR
+          BUILD_POSINRHSINTR = .FALSE.
+        ENDIF
 C         ------------------------
-C         INITIALIZE POSINRHSCOMP
+C         INITIALIZE POSINRHSINTR
 C         ------------------------
-          IF (BUILD_POSINRHSCOMP) THEN
-C           -- we first set MTYPE_LOC and
-C           -- reset BUILD_POSINRHSCOMP for next iteration in loop
-C
-C           general case only POSINRHSCOMP is computed
-            BUILD_POSINRHSCOMP = .FALSE.
-!           POSINRHSCOMP does not change between blocks
-            MTYPE_LOC = MTYPE
+        IF (BUILD_POSINRHSINTR) THEN
+C{        -- we first set MTYPE_LOC and
+C         -- reset BUILD_POSINRHSINTR for next iteration in loop
+C
+C         general case only POSINRHSINTR is computed
+          BUILD_POSINRHSINTR = .FALSE.
+!         POSINRHSINTR does not change between blocks
+          MTYPE_LOC = MTYPE
 C
-            IF ( (KEEP(111).NE.0) .OR. (KEEP(237).NE.0) .OR.
+          IF ( (KEEP(111).NE.0) .OR. (KEEP(237).NE.0) .OR.
      &         (KEEP(252).NE.0) ) THEN
 C
-              IF (KEEP(111).NE.0) THEN
-C               -- in the context of null space, we need to
-C               -- build RHSCOMP to skip SOL_R. Therefore
-C               -- we need to know for each concerned
-C               -- row index its position in
-C               -- RHSCOMP
-C               We use row indices, as these are the ones that
-C               were used to detect zero pivots during factorization.
-C               POSINRHSCOMP_ROW will allow to find the (row) index of a
-C               zero in RHSCOMP before calling ZMUMPS_SOL_S. Then
-C               ZMUMPS_SOL_S uses column indices to build the solution
-C               (corresponding to null space vectors)
-                MTYPE_LOC = 1
-              ELSE IF  (KEEP(252).NE.0) THEN
-C               -- Fwd in facto: since fwd is skipped we need to build POSINRHSCOMP
-                MTYPE_LOC = 1  ! (no transpose)
-C     BUILD_POSINRHSCOMP = .FALSE.  ! POSINRHSCOMP does not change between blocks
-              ELSE
-C               -- A-1 only
-                MTYPE_LOC = MTYPE
-                BUILD_POSINRHSCOMP = .TRUE.
-              ENDIF
+            IF (KEEP(111).NE.0) THEN
+C             -- in the context of null space, we need to
+C             -- build RHSINTR to skip SOL_R. Therefore
+C             -- we need to know for each concerned
+C             -- row index its position in
+C             -- RHSINTR
+C             We use row indices, as these are the ones that
+C             were used to detect zero pivots during factorization.
+C             GLOB2LOC_RHS will allow to find the (row) index of a
+C             zero in RHSINTR before calling ZMUMPS_SOL_S. Then
+C             ZMUMPS_SOL_S uses column indices to build the solution
+C             (corresponding to null space vectors)
+              MTYPE_LOC = 1
+            ELSE IF  (KEEP(252).NE.0) THEN
+C             -- Fwd in facto: since fwd is skipped we need to build POSINRHSINTR
+              MTYPE_LOC = 1  ! (no transpose)
+            ELSE
+C             -- A-1 only
+              MTYPE_LOC = MTYPE
+              BUILD_POSINRHSINTR = .TRUE.
             ENDIF
-C           -- compute POSINRHSCOMP
-            LIW_PASSED=max(1,LIW)
-            IF (KEEP(237).EQ.0) THEN
-              CALL ZMUMPS_BUILD_POSINRHSCOMP(
+          ENDIF
+C         -- compute POSINRHSINTR
+          LIW_PASSED=max(1,LIW)
+          IF ( 
+C                no sparsity at fwd or bwd:
+     &           (Lnodes_FWD.EQ.-1).OR.(Lnodes_BWD.EQ.-1)
+C              
+     &          ) THEN
+C
+C           RHSINTR is not sparse (in the sense that it has N rows
+C           distributed on the MPI procs) and thus POSINRHSINTR
+C           does not change with loop.
+C           Remarks:
+C             1/ sparsity might still be exploited during 
+C                fwd or bwd to reduce the number of operations.
+C             2/ 
+            BUILD_POSINRHSINTR = .FALSE.
+C
+            IF ( I_AM_SLAVE ) THEN
+C{
+              CALL ZMUMPS_BUILD_GLOB2LOC(
      &           id%NSLAVES,id%N,
      &           id%MYID_NODES, id%PTLUST_S(1),
      &           id%KEEP(1),id%KEEP8(1),
      &           id%PROCNODE_STEPS(1), id%IS(1), LIW_PASSED,
      &           id%STEP(1),
-     &           id%POSINRHSCOMP_ROW(1), id%POSINRHSCOMP_COL(1),
-     &           id%POSINRHSCOMP_COL_ALLOC,
+     &           id%GLOB2LOC_RHS(1), id%GLOB2LOC_SOL(1),
+     &           id%GLOB2LOC_SOL_ALLOC,
      &           MTYPE_LOC,
-     &           NBENT_RHSCOMP, NB_FS_RHSCOMP_TOT )
-                NB_FS_RHSCOMP_F = NB_FS_RHSCOMP_TOT
-            ELSE
-              CALL ZMUMPS_BUILD_POSINRHSCOMP_AM1(
+     &           NBENT_RHSINTR, NB_FS_RHSINTR_TOT )
+                NB_FS_RHSINTR_F = NB_FS_RHSINTR_TOT
+C}
+            ENDIF
+C
+          ELSE 
+C
+C  Note that POSINRHSINTR* need not be recomputed before IR :
+C  because distributed solution => NO IR.
+C
+C           Exploit sparsity in solution and RHS 
+C           (AM1 or (Sparse RHS and solution) )
+C           Since sparsity is exploited during
+C           both fwd and bwd then we need to recompute 
+C           POSINRHSINTR only  when CALL_NODES_FWD_BWD will
+C           be performed at next iteration.
+            IF (CALL_NODES_FWD_BWD) BUILD_POSINRHSINTR = .TRUE.
+C
+            IF ( I_AM_SLAVE ) THEN
+C{
+              CALL ZMUMPS_BUILD_GLOB2LOC_NODES_ES(
      &           id%NSLAVES,id%N,
      &           id%MYID_NODES, id%PTLUST_S(1), id%DAD_STEPS(1),
      &           id%KEEP(1),id%KEEP8(1),
      &           id%PROCNODE_STEPS(1), id%IS(1), LIW,
      &           id%STEP(1),
-     &           id%POSINRHSCOMP_ROW(1), id%POSINRHSCOMP_COL(1),
-     &           id%POSINRHSCOMP_COL_ALLOC,
+C
+     &            Lnodes_FWD, Lnodes_BWD,
+     &            nodes_FWD_PTR(1), nodes_BWD_PTR(1),
+C
+     &           id%GLOB2LOC_RHS(1), id%GLOB2LOC_SOL(1),
+     &           id%GLOB2LOC_SOL_ALLOC,
      &           MTYPE_LOC,
-     &           IRHS_PTR_COPY(1), NBCOL_INBLOC, IRHS_SPARSE_COPY(1),
-     &           NZ_THIS_BLOCK,PERM_RHS, size(PERM_RHS) , JBEG_RHS,
-     &           NBENT_RHSCOMP,
-     &           NB_FS_RHSCOMP_F, NB_FS_RHSCOMP_TOT,
-     &            UNS_PERM_INV, size(UNS_PERM_INV) ! size 1 if not used
-     &            )
+     &           NBENT_RHSINTR,
+     &           NB_FS_RHSINTR_F, NB_FS_RHSINTR_TOT
+     &           )
+C}
             ENDIF
-          ENDIF   ! BUILD_POSINRHSCOMP=.TRUE.
-          IF (BUILD_RHSMAPINFO .AND. KEEP(248).EQ.-1) THEN
+          ENDIF
+C}
+        ENDIF   ! BUILD_POSINRHSINTR=.TRUE.
+        IF (BUILD_RHSMAPINFO .AND. KEEP(248).EQ.-1
+     &        ) THEN
 C
 C           Prepare symbolic data for sends.
-C           For the moment: MAP_RHS_loc
+C           For the moment: only MAP_RHS_loc
 C
+C           id%GLOB2LOC_RHS is always associated to the
+C           forward step (with or without transposed system)
+          IF ( I_AM_SLAVE ) THEN
+C{
             CALL MUMPS_SOL_RHSMAPINFO( id%N, id%Nloc_RHS, id%KEEP(89),
-     &            IRHS_loc_PTR(1), MAP_RHS_loc, id%POSINRHSCOMP_ROW(1),
+     &            IRHS_loc_PTR(1), MAP_RHS_loc, id%GLOB2LOC_RHS(1),
      &            id%NSLAVES, id%MYID_NODES,
      &            id%COMM_NODES, id%ICNTL(1), id%INFO(1) )
             BUILD_RHSMAPINFO = .FALSE.
 C           MUMPS_SOL_RHSMAPINFO does not propagate errors
-          ENDIF
+C}
+          ENDIF ! I_AM_SLAVE
         ENDIF
         CALL MUMPS_PROPINFO( ICNTL(1), INFO(1),
      &                   id%COMM,id%MYID)
         IF (INFO(1) .LT.0 ) GOTO 90
+        IF ( BUILD_SCALING_RHSINTR ) THEN
+C{
+          IF (SCALING_RHSINTR_BWD_ALLOCATED) THEN
+            NB_BYTES = NB_BYTES - LSCALING_RHSINTR_BWD * K16_8
+            DEALLOCATE(SCALING_RHSINTR_BWD)
+          ENDIF
+          IF (SCALING_RHSINTR_FWD_ALLOCATED) THEN
+            NB_BYTES = NB_BYTES - LSCALING_RHSINTR_FWD * K16_8
+            DEALLOCATE(SCALING_RHSINTR_FWD)
+          ENDIF
+          NULLIFY(SCALING_RHSINTR_BWD)
+          NULLIFY(SCALING_RHSINTR_FWD)
+          SCALING_RHSINTR_BWD_ALLOCATED = .FALSE.
+          SCALING_RHSINTR_FWD_ALLOCATED = .FALSE.
+          SCALING_RHSINTR_BWD => RDUMMY_TARGET
+          SCALING_RHSINTR_FWD => RDUMMY_TARGET
+          LSCALING_RHSINTR_BWD = 1
+          LSCALING_RHSINTR_FWD = 1
+C         Define or allocate SCALING_RHSINTR if needed:
+          IF (LSCAL .AND. I_AM_SLAVE ) THEN
+            IF (KEEP(221).EQ.2) THEN
+C             In case of sparsity during bwd, we cannot
+C             rely on the value of Lnodes_FWD to know
+C             whether the scaling will match SCALING_LOC
+C             and should thus consider that (Lnodes_FWD.NE.-1)
+              ES_RHSINTR = (Lnodes_BWD.NE.-1)
+            ELSE
+C             sparsity at fwd and at bwd:
+              ES_RHSINTR = (Lnodes_FWD.NE.-1).AND.(Lnodes_BWD.NE.-1)
+            ENDIF
+C           Scaling allocations performed only if needed
+C             Forward or normal solve:
+              IF ( ES_RHSINTR ) THEN
+                LSCALING_RHSINTR_FWD = max(1, NB_FS_RHSINTR_F )
+                ALLOCATE(SCALING_RHSINTR_FWD(LSCALING_RHSINTR_FWD),
+     &                   stat=allocok)
+                IF (allocok .GT. 0) THEN
+                  INFO(1)=-13
+                  INFO(2)=LSCALING_RHSINTR_FWD
+                ELSE
+                  SCALING_RHSINTR_FWD_ALLOCATED = .TRUE.
+                  NB_BYTES = NB_BYTES + LSCALING_RHSINTR_FWD * K16_8
+                ENDIF
+              ELSE
+C               RHSINTR matches SCALING_loc, no need to
+C               allocate and compute a different scaling
+                LSCALING_RHSINTR_FWD = max(1,KEEP(89))
+#if defined(USE_OLD_SCALING)
+#else
+                SCALING_RHSINTR_FWD => SCALING_LOC_FWD
+#endif
+              ENDIF
+              IF (ES_RHSINTR) THEN
+                  LSCALING_RHSINTR_BWD = max(1, NB_FS_RHSINTR_TOT )
+                ALLOCATE(SCALING_RHSINTR_BWD(LSCALING_RHSINTR_BWD),
+     &                   stat=allocok)
+                IF (allocok .GT. 0) THEN
+                  INFO(1)=-13
+                  INFO(2)=LSCALING_RHSINTR_BWD
+                ELSE
+                  SCALING_RHSINTR_BWD_ALLOCATED = .TRUE.
+                  NB_BYTES = NB_BYTES + LSCALING_RHSINTR_BWD * K16_8
+                ENDIF
+              ELSE
+C               RHSINTR matches SCALING_loc, no need to
+C               allocate and compute a different scaling
+                LSCALING_RHSINTR_BWD = max(1,KEEP(89))
+#if defined(USE_OLD_SCALING)
+                SCALING_RHSINTR_BWD => scaling_data_sol%SCALING_LOC
+#else
+                SCALING_RHSINTR_BWD => SCALING_LOC_BWD
+                SCALING_RHSINTR_FWD => SCALING_LOC_FWD
+#endif
+              ENDIF
+          ENDIF
+C}
+        ENDIF
+        CALL MUMPS_PROPINFO( id%ICNTL, id%INFO, id%COMM,id%MYID)
+        IF (id%INFO(1) .LT.0 ) GOTO 90
+        IF (BUILD_SCALING_RHSINTR) THEN
+C{
+          IF ( LSCAL .AND. I_AM_SLAVE. AND. ES_RHSINTR ) THEN
+#if ! defined(USE_OLD_SCALING)
+C             SCALING_RHSINTR_FWD has been allocated and should
+C             now be filled. It is a compressed version of the
+C             local scaling array SCALING_LOC_FWD:
+              IF (MTYPE.eq.0 .AND. KEEP(50).EQ.0) THEN ! tranpose
+                ROWORCOL = 2 ! access 2nd list -- col indices
+              ELSE
+                ROWORCOL = 1 ! access 1st list -- row indices
+              ENDIF
+              CALL ZMUMPS_SCALINGRHSINTR(LSCAL, id%N,
+     &             SCALING_LOC_FWD(1),
+     &             SCALING_RHSINTR_FWD(1),
+     &             LSCALING_RHSINTR_FWD, id%GLOB2LOC_RHS(1),
+     &             id%KEEP, ROWORCOL, id%PTLUST_S(1),
+     &             id%IS(1), max(1,LIW),
+     &             id%MYID_NODES, id%STEP(1), id%PROCNODE_STEPS(1),
+     &             id%NSLAVES)
+C             SCALING_RHSINTR_BWD has been allocated and should
+C             now be filled. It is a compressed version of the
+C             local scaling array SCALING_LOC_BWD:
+              IF (MTYPE.eq.1 .AND. KEEP(50).EQ.0) THEN ! no tranpose
+C               access 2nd list corresponding to col indices
+                ROWORCOL = 2 
+              ELSE
+C               access 1st list corresponding to row indices
+                ROWORCOL = 1 
+              ENDIF
+              CALL ZMUMPS_SCALINGRHSINTR(LSCAL, id%N,
+     &             SCALING_LOC_BWD(1),
+     &             SCALING_RHSINTR_BWD(1),
+     &             LSCALING_RHSINTR_BWD, id%GLOB2LOC_SOL(1),
+     &             id%KEEP, ROWORCOL, id%PTLUST_S(1),
+     &             id%IS(1), max(1,LIW),
+     &             id%MYID_NODES, id%STEP(1), id%PROCNODE_STEPS(1),
+     &             id%NSLAVES)
+#endif
+#if defined(USE_OLD_SCALING)
+#endif
+          ENDIF
+C         Rebuild SCALING_RHSINTR* next time
+C         only if POSINRHSINTR has to be built
+C         again next time:
+          BUILD_SCALING_RHSINTR= BUILD_POSINRHSINTR
+C}
+        ENDIF
         IF (I_AM_SLAVE) THEN
-          IF (KEEP(221).EQ.1) THEN
-C           we need to save the reduced RHS for all RHS to perform
-C           later the backward phase with an updated reduced RHS
-C           thus we allocate NRHS_NONEMPTY columns in one shot.
-C           Note that RHSCOMP might have been allocated in previous block
-C           and RHSCOMP has been deallocated previous to entering loop on RHS
-            IF (.not. associated(id%RHSCOMP)) THEN
+          IF ((KEEP(221).EQ.1).OR.KEEP(221).EQ.-1) THEN
+C         For the following cases:
+C          -[Schur] we need to save the reduced RHS for all RHS 
+C                 to perform later the backward phase with an
+C                 updated reduced RHS
+C          -[Fwd only] return RHSINTR to user
+C          -KEEP(221)=-1, allocate RHSINTR to enable bwd only step
+C         We need to allocate NRHS_NONEMPTY columns in one shot.
+C         Note that 
+C            -RHSINTR might have been allocated in previous block
+C            -RHSINTR has been deallocated previous to entering 
+C             loop on RHS
+            IF (.not. associated(id%RHSINTR)) THEN
 C             So far we cannot combine this to exploit sparsity
-C             so that NBENT_RHSCOMP will not change in the loop
-C             and can be used to dimension RHSCOMP
+C             so that NBENT_RHSINTR will not change in the loop
+C             and can be used to dimension RHSINTR
+C
 C             Furthermore, during bwd phase the REDRHS provided
 C             by the user might also have a different non empty
 C             column pattern than the sparse RHS provided on input to
 C             this phase: thus we need to allocate id%NRHS columns too.
-              LD_RHSCOMP = max(NBENT_RHSCOMP,1)
-              id%KEEP8(25) = int(LD_RHSCOMP,8)*int(id%NRHS,8)
-              ALLOCATE (id%RHSCOMP(id%KEEP8(25)),  stat = allocok)
+              id%LD_RHSINTR = max(NBENT_RHSINTR,1)
+              id%KEEP8(25) = int(id%LD_RHSINTR,8)*int(id%NRHS,8)
+              ALLOCATE (id%RHSINTR(id%KEEP8(25)),  stat = allocok)
               IF ( allocok .GT. 0 ) THEN
                  INFO(1)=-13
                  CALL MUMPS_SET_IERROR(id%KEEP8(25),INFO(2))
@@ -3330,34 +3941,35 @@ C             this phase: thus we need t
               NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
             ENDIF
           ENDIF
-          IF ((KEEP(221).NE.1).AND.
+C 
+C
+          IF ((KEEP(221).NE.1).AND. 
      &        ((KEEP(221).NE.2).OR.(KEEP(252).NE.0))
      &       ) THEN
 C           ------------------
-C           Allocate RHSCOMP (case of RHSCOMP allocated at each block of RHS)
+C           Allocate RHSINTR
+C           (case of RHSINTR allocated at each block of RHS)
 C           ------------------
-C           RHSCOMP allocated per block of maximum size NBRHS
-            LD_RHSCOMP = max(NBENT_RHSCOMP, LD_RHSCOMP)
+C           RHSINTR allocated per block of maximum size NBRHS
 C           NBRHS_EFF could be used instead on NBRHS
-            IF (associated(id%RHSCOMP)) THEN
-              IF ( (id%KEEP8(25).LT.int(LD_RHSCOMP,8)*int(NBRHS,8))
-     &          .OR. (KEEP(235).NE.0).OR.(KEEP(237).NE.0) ) THEN
-                ! deallocate and reallocate if:
-                ! _larger array needed
-                ! OR 
-                ! _exploit sparsity/A-1: since size of RHSCOMP 
-                ! is expected to vary much in these cases
-                ! this should improve locality
+            IF (associated(id%RHSINTR)) THEN
+C             RHSINTR already associated for previous
+C             block, check if we can reuse it.
+              id%LD_RHSINTR = max(NBENT_RHSINTR, 1)
+              IF (id%KEEP8(25).LT.int(id%LD_RHSINTR,8)*int(NBRHS,8))
+     &        THEN
+                ! deallocate and reallocate since larger array is needed
                  NB_BYTES = NB_BYTES - id%KEEP8(25)*K35_8
-                 DEALLOCATE(id%RHSCOMP)
-                 NULLIFY(id%RHSCOMP)
-                 id%KEEP8(25)=0_8
+                 DEALLOCATE(id%RHSINTR)
+                 NULLIFY(id%RHSINTR)
+                 id%KEEP8(25)  = 0_8
+                 id%LD_RHSINTR = 0
               ENDIF
             ENDIF
-            IF (.not. associated(id%RHSCOMP)) THEN
-              LD_RHSCOMP = max(NBENT_RHSCOMP, 1)
-              id%KEEP8(25) = int(LD_RHSCOMP,8)*int(NBRHS,8)
-              ALLOCATE (id%RHSCOMP(id%KEEP8(25)),  stat = allocok )
+            IF (.not. associated(id%RHSINTR)) THEN
+              id%LD_RHSINTR = max(NBENT_RHSINTR, 1)
+              id%KEEP8(25) = int(id%LD_RHSINTR,8)*int(NBRHS,8)
+              ALLOCATE (id%RHSINTR(id%KEEP8(25)),  stat = allocok )
               IF ( allocok .GT. 0 ) THEN
                INFO(1)=-13
                CALL MUMPS_SET_IERROR(id%KEEP8(25),INFO(2))
@@ -3367,22 +3979,16 @@ C           NBRHS_EFF could be used inst
               NB_BYTES_MAX = max(NB_BYTES_MAX,NB_BYTES)
             ENDIF
           ENDIF
-          IF (KEEP(221).EQ.2) THEN
-C           RHSCOMP has been allocated (call with KEEP(221).EQ.1)
-C           even in the case fwd in facto
-            ! Not correct: LD_RHSCOMP = LENRHSCOMP/id%NRHS_NONEMPTY
-            LD_RHSCOMP = int(id%KEEP8(25)/int(id%NRHS,8))
-          ENDIF
 C
-C         Shift on RHSCOMP
+C         Shift on RHSINTR
 C
           IF ( KEEP(221).EQ.0 ) THEN
-C            -- RHSCOMP reused in the loop
-             IBEG_RHSCOMP= 1_8
+C            -- RHSINTR reused in the loop
+             IBEG_RHSINTR= 1_8
           ELSE
-C            Initialize IBEG_RHSCOMP
+C            Initialize IBEG_RHSINTR
 C
-             IBEG_RHSCOMP= int(JBEG_RHS-1,8)*int(LD_RHSCOMP,8) + 1_8
+            IBEG_RHSINTR= int(JBEG_RHS-1,8)*int(id%LD_RHSINTR,8)+1_8
           ENDIF
         ENDIF   ! I_AM_SLAVE
 C =====================  ERROR handling and propagation ================
@@ -3396,7 +4002,8 @@ C       ---------------------------
 C       Prepare RHS on master (case
 C       of dense and sparse RHS)
 C       ---------------------------
-        IF (id%MYID .eq. MASTER) THEN
+        IF (id%MYID .eq. MASTER
+     &     ) THEN
 C         =========================
           IF (KEEP(23) .NE. 0) THEN
 C         =========================
@@ -3459,8 +4066,10 @@ C
               ENDDO
             ENDIF
           ENDIF
+#if defined(USE_OLD_SCALING)
 C
 C         RHS is set to scaled right hand side
+C         (case of centralized scaling only)
 C
           IF (LSCAL) THEN
 C           scaling was performed
@@ -3571,6 +4180,7 @@ C                     Original IRHS_PTR
               ENDIF
             ENDIF  ! KEEP(248)==1
           ENDIF  ! LSCAL
+#endif
         ENDIF  ! id%MYID.EQ.MASTER
 #if defined(V_T)
         CALL VTEND(perm_scal_ini,IERR)
@@ -3579,16 +4189,6 @@ C
 C       Prepare RHS on master
 C       END
 C       =====================
-        IF ((KEEP(248).EQ.1).AND.(KEEP(237).EQ.0)) THEN
-          ! case of general sparse: in case of empty columns
-          ! modifed version of
-          ! NBRHS_EFF need be broadcasted since it is used
-          ! to update BEG_RHS at the end of the DO WHILE
-            CALL MPI_BCAST( NBRHS_EFF,1, MPI_INTEGER,
-     &           MASTER, id%COMM,IERR)
-            CALL MPI_BCAST(NB_RHSSKIPPED,1,MPI_INTEGER,MASTER,
-     &               id%COMM,IERR)
-        ENDIF
 C       -----------------------------------
 C       Two main cases depending on option
 C       for null space computation:
@@ -3605,7 +4205,7 @@ C       --------------------------------
         TIMESCATTER1=MPI_WTIME()
         IF ((KEEP(111).eq.0).AND.(KEEP(252).EQ.0)
      &        .AND.(KEEP(221).NE.2 )) THEN
-C           ------------------------
+C{          ------------------------
 C           Use RHS provided by user
 C           when not null space and not Fwd in facto
 C           ------------------------
@@ -3616,7 +4216,7 @@ C             --------------------------
               IF ( .NOT.I_AM_SLAVE ) THEN
 C               -- Master not working
                 CALL ZMUMPS_SCATTER_RHS(id%NSLAVES,id%N, id%MYID,
-     &          id%COMM,
+     &          id%COMM, LSCAL, SCALING_LOC_FWD(1),
      &          MTYPE, id%RHS(IBEG), LD_RHS, NBRHS_EFF,
      &          NBRHS_EFF,
      &          C_DUMMY, 1, 1,
@@ -3639,11 +4239,11 @@ C               -- Master not working
                 ENDIF
                 LIW_PASSED = max( LIW, 1 )
                 CALL ZMUMPS_SCATTER_RHS(id%NSLAVES,id%N, id%MYID,
-     &          id%COMM,
+     &          id%COMM, LSCAL, SCALING_LOC_FWD(1),
      &          MTYPE, PTR_RHS(IBEG_loc),LD_RHS_loc,NCOL_RHS_loc,
      &          NBRHS_EFF,
-     &          id%RHSCOMP(IBEG_RHSCOMP), LD_RHSCOMP, NBRHS_EFF,
-     &          id%POSINRHSCOMP_ROW(1), NB_FS_RHSCOMP_F,
+     &          id%RHSINTR(IBEG_RHSINTR), id%LD_RHSINTR, NBRHS_EFF,
+     &          id%GLOB2LOC_RHS(1), NB_FS_RHSINTR_F,
 C
      &          id%PTLUST_S(1), id%KEEP(1), id%KEEP8(1),
      &          id%PROCNODE_STEPS(1),
@@ -3671,9 +4271,14 @@ C
      &          IRHS_loc_PTR(1),
      &          idRHS_loc(RHS_loc_shift),
      &          RHS_loc_size,
-     &          id%RHSCOMP(IBEG_RHSCOMP), LD_RHSCOMP,
-     &          id%POSINRHSCOMP_ROW(1), NB_FS_RHSCOMP_F,
-     &          LSCAL, scaling_data_dr,
+     &          id%RHSINTR(IBEG_RHSINTR), id%LD_RHSINTR,
+     &          id%GLOB2LOC_RHS(1), NB_FS_RHSINTR_F,
+     &          LSCAL,
+#if defined(USE_OLD_SCALING)
+     &          scaling_data_dr,
+#else
+     &          SCALING_RHSINTR_FWD(1), LSCALING_RHSINTR_FWD,
+#endif
      &          LP, LPOK, KEEP(1), NB_BYTES_LOC, INFO(1))
 C               NB_BYTES_LOC were allocated and freed above
                 NB_BYTES_MAX = max(NB_BYTES_MAX,
@@ -3686,14 +4291,20 @@ C               NB_BYTES_LOC were alloca
 C             ===  KEEP(248)==1 =========
 C             -- SPARSE RIGHT-HAND-SIDE
 C             ----------------------------
-              IF (NZ_THIS_BLOCK > 0) THEN
+              IF (NZ_THIS_BLOCK > 0
+#if ! defined(USE_OLD_SCALING)
+C               For AM1, no need to broadcast RHS_SPARSE
+C               when using local scalings. RHSINTR will
+C               be initialized directly and RHS_SPARSE
+C               is used during ZMUMPS_GATHER_SOLUTION_AM1
+     &            .AND. id%KEEP(237) .EQ.0
+#endif
+     &        ) THEN
                 CALL MPI_BCAST(RHS_SPARSE_COPY(1),
      &                     NZ_THIS_BLOCK,
      &                     MPI_DOUBLE_COMPLEX,
      &                     MASTER, id%COMM, IERR)
               ENDIF
-C             -- At this point each process has a copy of the
-C             -- sparse RHS. We need to store it into RHSCOMP.
 C
               IF (KEEP(237).NE.0)  THEN
                 IF ( I_AM_SLAVE ) THEN
@@ -3701,37 +4312,43 @@ C                 -----
 C                 case of A-1
 C                 -----
 C                 - Take columns with non-zero entry, say j,
-C                 - to build Ej and store it in RHSCOMP
-                  K=1              ! Column index in RHSCOMP
-                  id%RHSCOMP(1_8:int(NBRHS_EFF,8)*int(LD_RHSCOMP,8))
+C                 - to build Ej and store it in RHSINTR
+                  K=1              ! Column index in RHSINTR
+                  id%RHSINTR(1_8:int(NBRHS_EFF,8)*int(id%LD_RHSINTR,8))
      &            = ZERO
                   IPOS = 1
                   DO I = 1, NBCOL_INBLOC
                     COLSIZE = IRHS_PTR_COPY(I+1) - IRHS_PTR_COPY(I)
                     IF (COLSIZE.GT.0) THEN
                       ! Find global column index J and set
-                      ! column K of RHSCOMP to ej (here IBEG is one)
+                      ! column K of RHSINTR to ej (here IBEG is one)
                       J = I - 1 + JBEG_RHS
                       IF (DO_PERMUTE_RHS.OR.INTERLEAVE_PAR) THEN
                         J = PERM_RHS(J)
                       ENDIF
-                      IPOSRHSCOMP = id%POSINRHSCOMP_ROW(J)
-C                     IF ( (IPOSRHSCOMP.LE.NB_FS_RHSCOMP_F)
-C     &               .AND.(IPOSRHSCOMP.GT.0) ) THEN
-                      IF (IPOSRHSCOMP.GT.0)  THEN
+                      IPOSRHSINTR = id%GLOB2LOC_RHS(J)
+C                     IF ( (IPOSRHSINTR.LE.NB_FS_RHSINTR_F)
+C     &               .AND.(IPOSRHSINTR.GT.0) ) THEN
+                      IF (IPOSRHSINTR.GT.0)  THEN
 C                       Columns J corresponds to ej and thus to variable j
-C                       that is on my proc
-C                       Note that :
-C                       In first entry in column
-C                       we have and MUST have already scaled value of diagonal.
-C                       This need have been done on master because we do not
-C                       have scaling arrays available on slaves.
-C                       Furthermore we know that only one entry is
-C                       needed the diagonal entry (for the forward with A-1).
-C
-                        id%RHSCOMP(int(K-1,8)*int(LD_RHSCOMP,8)+
-     &                       int(IPOSRHSCOMP,8)) =
+C                       that is on my proc.
+C                       We know that only one entry is needed,
+C                       the diagonal entry (for the forward with A-1).
+C
+#if defined(USE_OLD_SCALING)
+                        id%RHSINTR(int(K-1,8)*int(id%LD_RHSINTR,8)+
+     &                       int(IPOSRHSINTR,8)) =
      &                       RHS_SPARSE_COPY(IPOS)
+#else
+                        IF (LSCAL) THEN
+                          id%RHSINTR(int(K-1,8)*int(id%LD_RHSINTR,8)+
+     &                    int(IPOSRHSINTR,8)) =
+     &                    SCALING_RHSINTR_FWD(IPOSRHSINTR)
+                        ELSE
+                          id%RHSINTR(int(K-1,8)*int(id%LD_RHSINTR,8)+
+     &                    int(IPOSRHSINTR,8)) = ONE
+                        ENDIF
+#endif
                       ENDIF               ! End of J on my proc
                       K = K + 1
                       IPOS = IPOS + COLSIZE  ! go to next column
@@ -3750,12 +4367,14 @@ C               -------
 C               --------------
 C               General sparse
 C               --------------
-C               -- reset to zero RHSCOMP for skipped columns (if any)
+C               -- At this point each process has a copy of the
+C               -- sparse RHS. We need to store it into RHSINTR.
+C               -- reset to zero RHSINTR for skipped columns (if any)
                 IF ((KEEP(221).EQ.1).AND.(NB_RHSSKIPPED.GT.0)
      &            .AND.I_AM_SLAVE) THEN
                   DO K = JBEG_RHS-NB_RHSSKIPPED, JBEG_RHS-1
-                    DO I = 1,  LD_RHSCOMP
-                      id%RHSCOMP(int(K-1,8)*int(LD_RHSCOMP,8)
+                    DO I = 1,  id%LD_RHSINTR
+                      id%RHSINTR(int(K-1,8)*int(id%LD_RHSINTR,8)
      &                           + int(I,8)) =  ZERO
                     ENDDO
                   ENDDO
@@ -3763,36 +4382,62 @@ C               -- reset to zero RHSCOMP
                 IF (I_AM_SLAVE) THEN
                   DO K = 1, NBCOL_INBLOC
 !                   it is equal to NBRHS_EFF in this case
-                    KDEC = int(K-1,8) * int(LD_RHSCOMP,8) +
-     &                     IBEG_RHSCOMP - 1_8
-                    id%RHSCOMP(KDEC+1_8:KDEC+NBENT_RHSCOMP) = ZERO
-                    DO IZ=IRHS_PTR_COPY(K), IRHS_PTR_COPY(K+1)-1
-                      I=IRHS_SPARSE_COPY(IZ)
-                      IPOSRHSCOMP = id%POSINRHSCOMP_ROW(I)
-C                     Since all fully summed variables mapped
-C                     on each proc are stored at the beginning
-C                     of RHSCOMP, we can compare to KEEP(89)
-C                     to know if RHSCOMP should be initialized
-C                     So far the tree has not been pruned to exploit
-C                     sparsity to compress RHSCOMP so we compare to
-C                     NB_FS_RHSCOMP_TOT
-                      IF ( (IPOSRHSCOMP.LE.NB_FS_RHSCOMP_TOT)
-     &                .AND.(IPOSRHSCOMP.GT.0) ) THEN
-C                        ! I is fully summed var mapped on my proc
-                        id%RHSCOMP(KDEC+IPOSRHSCOMP)=
-     &                  id%RHSCOMP(KDEC+IPOSRHSCOMP) +
-     &                  RHS_SPARSE_COPY(IZ)
-                      ENDIF
-                    ENDDO
+                    KDEC = int(K-1,8) * int(id%LD_RHSINTR,8) +
+     &                     IBEG_RHSINTR - 1_8
+                    id%RHSINTR(KDEC+1_8:KDEC+NBENT_RHSINTR) = ZERO
+#if ! defined(USE_OLD_SCALING)
+                    IF (LSCAL) THEN
+                      DO IZ=IRHS_PTR_COPY(K), IRHS_PTR_COPY(K+1)-1
+                        I=IRHS_SPARSE_COPY(IZ)
+                        IPOSRHSINTR = id%GLOB2LOC_RHS(I)
+C                       Since all fully summed variables mapped
+C                       on each proc are stored at the beginning
+C                       of RHSINTR, we can compare to KEEP(89)
+C                       to know if RHSINTR should be initialized
+C                       So far the tree has not been pruned to exploit
+C                       sparsity to compress RHSINTR so we compare to
+C                       NB_FS_RHSINTR_TOT
+                        IF ( (IPOSRHSINTR.LE.NB_FS_RHSINTR_TOT)
+     &                  .AND.(IPOSRHSINTR.GT.0) ) THEN
+C                          ! I is fully summed var mapped on my proc
+                          id%RHSINTR(KDEC+IPOSRHSINTR)=
+     &                    id%RHSINTR(KDEC+IPOSRHSINTR) +
+     &                    RHS_SPARSE_COPY(IZ)
+     &                    * SCALING_RHSINTR_FWD(IPOSRHSINTR)
+                        ENDIF
+                      ENDDO
+                    ELSE
+#endif
+                      DO IZ=IRHS_PTR_COPY(K), IRHS_PTR_COPY(K+1)-1
+                        I=IRHS_SPARSE_COPY(IZ)
+                        IPOSRHSINTR = id%GLOB2LOC_RHS(I)
+C                       Since all fully summed variables mapped
+C                       on each proc are stored at the beginning
+C                       of RHSINTR, we can compare to KEEP(89)
+C                       to know if RHSINTR should be initialized
+C                       So far the tree has not been pruned to exploit
+C                       sparsity to compress RHSINTR so we compare to
+C                       NB_FS_RHSINTR_TOT
+                        IF ( (IPOSRHSINTR.LE.NB_FS_RHSINTR_TOT)
+     &                  .AND.(IPOSRHSINTR.GT.0) ) THEN
+C                          ! I is fully summed var mapped on my proc
+                          id%RHSINTR(KDEC+IPOSRHSINTR)=
+     &                    id%RHSINTR(KDEC+IPOSRHSINTR) +
+     &                    RHS_SPARSE_COPY(IZ)
+                        ENDIF
+                      ENDDO
+#if ! defined(USE_OLD_SCALING)
+                    ENDIF
+#endif
                   ENDDO
                 END IF ! I_AM_SLAVE
               ENDIF ! KEEP(237)
             ENDIF  ! ==== KEEP(248)==1 =====
-C
+C}
         ELSE IF (I_AM_SLAVE) THEN
             ! I_AM_SLAVE AND (null space or Fwd in facto)
             IF (KEEP(111).NE.0) THEN
-C             -----------------------
+C{            -----------------------
 C             Null space computations
 C             -----------------------
 C
@@ -3889,10 +4534,10 @@ C ======================================
 C               End IF Exploit Sparsity
               ENDIF
 c
-C             Initialize RHSCOMP to 0  ! to be suppressed
+C             Initialize RHSINTR to 0  ! to be suppressed
               DO K=1, NBRHS_EFF
-                KDEC = int(K-1,8) * int(LD_RHSCOMP,8)
-                id%RHSCOMP(KDEC+1_8:KDEC+int(LD_RHSCOMP,8))=ZERO
+                KDEC = int(K-1,8) * int(id%LD_RHSINTR,8)
+                id%RHSINTR(KDEC+1_8:KDEC+int(id%LD_RHSINTR,8))=ZERO
               END DO
 C             Loop over the columns.
 C             Note that if ( KEEP(220)+KEEP(109)-1 < IBEG_GLOB_DEF
@@ -3907,18 +4552,18 @@ C               step incompatible, do on
      &               min(IEND_GLOB_DEF,KEEP(220)+KEEP(109)-1)
 C                 Local processor is concerned by I-th column of
 C                 global right-hand side.
-                  JJ= id%POSINRHSCOMP_ROW(id%PIVNUL_LIST(I-KEEP(220)+1))
+                  JJ= id%GLOB2LOC_RHS(id%PIVNUL_LIST(I-KEEP(220)+1))
                   IF (JJ.GT.0) THEN
                     IF (KEEP(50).EQ.0) THEN
                       ! unsymmetric : always set to fixation
-                      id%RHSCOMP( IBEG_RHSCOMP+
-     &                    int(I-IBEG_GLOB_DEF,8)*int(LD_RHSCOMP,8) +
+                      id%RHSINTR( IBEG_RHSINTR+
+     &                    int(I-IBEG_GLOB_DEF,8)*int(id%LD_RHSINTR,8)+
      &                    int(JJ-1,8) ) =
-     &                    cmplx(id%DKEEP(2),kind=kind(id%RHSCOMP))
+     &                    cmplx(id%DKEEP(2),kind=kind(id%RHSINTR))
                     ELSE
                       ! Symmetric: always set to one
-                      id%RHSCOMP( IBEG_RHSCOMP+
-     &                int(I-IBEG_GLOB_DEF,8)*int(LD_RHSCOMP,8)+
+                      id%RHSINTR( IBEG_RHSINTR+
+     &                int(I-IBEG_GLOB_DEF,8)*int(id%LD_RHSINTR,8)+
      &                int(JJ-1,8) )=
      &                ONE
                     ENDIF
@@ -3949,9 +4594,10 @@ C               for this set of right-ha
                 IEND_ROOT_DEF = -95999
                 IROOT_DEF_RHS_COL1= 1
               ENDIF
+C}
             ELSE  ! End of null space (test on KEEP(111))
 C             case of Fwd in facto
-C             id%RHSCOMP need not be initialized. It will be set on the fly
+C             id%RHSINTR need not be initialized. It will be set on the fly
 C             to zero for normal fully summed variables of the fronts and
 C             to -1 on the roots for the id%N+KEEP(253) variables added
 C             to the roots.
@@ -3990,7 +4636,7 @@ C             Otherwise, we use workspac
             LWCB8_SOL_C = LWCB8_SOL_C - LPTR_RHS_ROOT
           ENDIF
         ENDIF
-        IF (KEEP(221) .EQ. 2 ) THEN
+        IF (KEEP(221) .EQ. 2 .AND. KEEP(60).NE.0 ) THEN
 C         Copy/send REDRHS in PTR_RHS_ROOT
 C         (column by column if leading dimension LD_REDRHS
 C         of REDRHS is not equal to SIZE_ROOT).
@@ -4053,13 +4699,13 @@ C         -- other procs are not concern
           LIW_PASSED = max( LIW, 1 )
           LA_PASSED  = max( LA, 1_8 )
 C
-          IF ((id%KEEP(235).EQ.0).and.(id%KEEP(237).EQ.0) ) THEN
+          IF (Lnodes_FWD.EQ.-1 .AND. Lnodes_BWD.EQ.-1) THEN
 C
-C         --- Normal case : we do not exploit sparsity of the RHS
+C         --- Normal case : we do not exploit sparsity during
+C             foward and backward steps
 C
             FROM_PP = .FALSE.
             NBSPARSE_LOC = (DO_NBSPARSE.AND.NBRHS_EFF.GT.1)
-            PRUNED_SIZE_LOADED = 0_8  ! From ZMUMPS_SOL_ES module
             CALL ZMUMPS_SOL_C(id%root, id%N, id%S(1), LA_PASSED, IS(1),
      & LIW_PASSED, WORK_WCB(1), LWCB8_SOL_C, IWCB, LIWCB, NBRHS_EFF,
      & id%NA(1),id%LNA,id%NE_STEPS(1), SRW3, MTYPE, ICNTL(1), FROM_PP,
@@ -4070,10 +4716,15 @@ C
      & BUFR(1), LBUFR, LBUFR_BYTES, id%ISTEP_TO_INIV2(1),
      & id%TAB_POS_IN_PERE(1,1), IBEG_ROOT_DEF, IEND_ROOT_DEF,
      & IROOT_DEF_RHS_COL1, PTR_RHS_ROOT(1), LPTR_RHS_ROOT, SIZE_ROOT,
-     & MASTER_ROOT, id%RHSCOMP(IBEG_RHSCOMP), LD_RHSCOMP,
-     & id%POSINRHSCOMP_ROW(1), id%POSINRHSCOMP_COL(1)
+     & MASTER_ROOT, id%RHSINTR(IBEG_RHSINTR), id%LD_RHSINTR,
+     & id%GLOB2LOC_RHS(1), id%GLOB2LOC_SOL(1)
+     &  , -1, -1,
+     &  IDUMMY(1), IDUMMY(1)
      & , 1, 1, 1, 1, IDUMMY, 1, JDUMMY, KDUMMY, 1, LDUMMY, 1, MDUMMY
      & , 1, 1, NBSPARSE_LOC, PTR_RHS_BOUNDS(1), LPTR_RHS_BOUNDS
+#if defined(STAT_ES_SOLVE)
+     & , IDUMMY, 1, JDUMMY, 1
+#endif
      & , id%IPOOL_B_L0_OMP(1), id%LPOOL_B_L0_OMP, id%IPOOL_A_L0_OMP(1),
      & id%LPOOL_A_L0_OMP, id%L_VIRT_L0_OMP, id%VIRT_L0_OMP(1),
      & id%L_PHYS_L0_OMP, id%PHYS_L0_OMP(1), id%PERM_L0_OMP(1),
@@ -4095,12 +4746,18 @@ C
      & id%DKEEP(1),id%COMM_NODES,id%MYID,id%MYID_NODES,BUFR(1),LBUFR,
      & LBUFR_BYTES, id%ISTEP_TO_INIV2(1), id%TAB_POS_IN_PERE(1,1),
      & IBEG_ROOT_DEF,IEND_ROOT_DEF,IROOT_DEF_RHS_COL1,PTR_RHS_ROOT(1),
-     & LPTR_RHS_ROOT, SIZE_ROOT, MASTER_ROOT, id%RHSCOMP(IBEG_RHSCOMP),
-     & LD_RHSCOMP, id%POSINRHSCOMP_ROW(1), id%POSINRHSCOMP_COL(1),
+     & LPTR_RHS_ROOT, SIZE_ROOT, MASTER_ROOT, id%RHSINTR(IBEG_RHSINTR),
+     & id%LD_RHSINTR, id%GLOB2LOC_RHS(1), id%GLOB2LOC_SOL(1),
+     &  Lnodes_FWD, Lnodes_BWD,
+     &  nodes_FWD_PTR(1), nodes_BWD_PTR(1),
      & NZ_THIS_BLOCK, NBCOL_INBLOC, id%NRHS, JBEG_RHS, id%Step2node(1),
      & id%KEEP(28),IRHS_SPARSE_COPY(1),IRHS_PTR_COPY(1), size(PERM_RHS),
-     & PERM_RHS, size(UNS_PERM_INV), UNS_PERM_INV, NB_FS_RHSCOMP_F,
-     & NB_FS_RHSCOMP_TOT,NBSPARSE_LOC,PTR_RHS_BOUNDS(1),LPTR_RHS_BOUNDS
+     & PERM_RHS, size(UNS_PERM_INV), UNS_PERM_INV, NB_FS_RHSINTR_F,
+     & NB_FS_RHSINTR_TOT,NBSPARSE_LOC,PTR_RHS_BOUNDS(1),LPTR_RHS_BOUNDS
+#if defined(STAT_ES_SOLVE)
+     & ,idIPTR_WORKING(1),SIZE_IPTR_WORKING,idWORKING(1),SIZE_WORKING
+C     & ,id%IPTR_WORKING(1),SIZE_IPTR_WORKING,id%WORKING(1),SIZE_WORKING
+#endif
      & ,id%IPOOL_B_L0_OMP(1),id%LPOOL_B_L0_OMP,id%IPOOL_A_L0_OMP(1),
      & id%LPOOL_A_L0_OMP,id%L_VIRT_L0_OMP,id%VIRT_L0_OMP(1),
      & id%L_PHYS_L0_OMP, id%PHYS_L0_OMP(1), id%PERM_L0_OMP(1),
@@ -4139,7 +4796,8 @@ C       ================================
 C       ONLY FORWARD was performed (case of reduced RHS with Schur
 C                               option during factorisation)
 C       ======================================================
-        IF ( KEEP(221) .EQ. 1 ) THEN ! === Begin OF REDUCED RHS ======
+        IF ( (KEEP(60).NE.0) .AND. 
+     &       KEEP(221) .EQ. 1 ) THEN ! === Begin OF REDUCED RHS ======
 C         --------------------------------------
 C         Send (or copy) reduced RHS from PTR_RHS_ROOT located on
 C         MASTER_ROOT_IN_COMM to REDRHS located on MASTER (host node).
@@ -4199,14 +4857,14 @@ C               -- send all in on shot
             ENDIF
 C         -- other procs are not concerned
           ENDIF
-        ENDIF ! ====== END OF REDUCED RHS (Fwd only performed) ======
+        ENDIF ! ===== END OF REDUCED RHS (Schur+Fwd only performed) ==
 C       =======================================================
 C       BACKWARD was PERFORMED
 C       Postprocess solution that is distributed
         IF ( KEEP(221) .NE. 1 ) THEN  ! BACKWARD was PERFORMED
 C       -- KEEP(221).NE.1 => we are sure that backward has been performed
           IF (ICNTL21 == 0) THEN ! CENTRALIZED SOLUTION
-C           ========================================================
+C{          ========================================================
 C           GATHER SOLUTION computed during bwd
 C           Each proc holds the pieces of solution corresponding
 C           to all fully summed variables mapped on that processor
@@ -4250,8 +4908,9 @@ C           Propagate errors
      &                       id%COMM,id%MYID)
 C           Return in case of error.
             IF (INFO(1).LT.0) GO TO 90
+#if defined(USE_OLD_SCALING)
             IF ((id%MYID.NE.MASTER).OR. .NOT.LSCAL) THEN
-             PT_SCALING => Dummy_SCAL
+              PT_SCALING => Dummy_SCAL
             ELSE
               IF (MTYPE.EQ.1) THEN
                 PT_SCALING => id%COLSCA
@@ -4259,11 +4918,12 @@ C           Return in case of error.
                 PT_SCALING => id%ROWSCA
               ENDIF
             ENDIF
+#endif
             LIW_PASSED = max( LIW, 1 )
             TIMEGATHER1=MPI_WTIME()
             IF ( .NOT.I_AM_SLAVE ) THEN
 C             I did not participate to computing part of the solution
-C             (id%RHSCOMP not set/allocate) : receive solution, store
+C             (id%RHSINTR not set/allocate) : receive solution, store
 C             it and scale it.
               IF (KEEP(237).EQ.0) THEN
 C               We need a workspace of minimal size KEEP(247)
@@ -4274,8 +4934,12 @@ C               in order to unpack piece
      &              JDUMMY, id%KEEP(1), id%KEEP8(1),
      &              id%PROCNODE_STEPS(1), IDUMMY, 1,
      &              id%STEP(1), BUFR(1), LBUFR, LBUFR_BYTES,
-     &              CWORK(1), LCWORK,
-     &              LSCAL, PT_SCALING(1), size(PT_SCALING),
+     &              CWORK(1), LCWORK, LSCAL,
+#if defined(USE_OLD_SCALING)
+     &              PT_SCALING(1), size(PT_SCALING),
+#else
+     &              SCALING_LOC_BWD(1), size(SCALING_LOC_BWD),
+#endif
      &              C_DUMMY, 1 , 1, IDUMMY, 1,
      &              PERM_RHS, size(PERM_RHS) ! for sparse permuted RHS
      &              )
@@ -4285,7 +4949,12 @@ C               only gather target entri
      &              id%MYID, id%COMM, NBRHS_EFF,
      &              C_DUMMY, 1, 1,
      &              id%KEEP(1), BUFR(1), LBUFR, LBUFR_BYTES,
+#if defined(USE_OLD_SCALING)
      &              LSCAL, PT_SCALING(1), size(PT_SCALING)
+#else
+     &              LSCAL, SCALING_RHSINTR_BWD(1),
+     &              size(SCALING_RHSINTR_BWD)
+#endif
 C                   --- A-1 related entries
      &             ,IRHS_PTR_COPY(1), size(IRHS_PTR_COPY),
      &              IRHS_SPARSE_COPY(1), size(IRHS_SPARSE_COPY),
@@ -4316,23 +4985,31 @@ C             compilers would do otherwi
      &          id%PROCNODE_STEPS(1), IS(1), LIW_PASSED,
      &          id%STEP(1), BUFR(1), LBUFR, LBUFR_BYTES,
      &          CWORK(1), LCWORK,
+#if defined(USE_OLD_SCALING)
      &          LSCAL, PT_SCALING(1), size(PT_SCALING),
-     &          id%RHSCOMP(IBEG_RHSCOMP), LD_RHSCOMP, NBRHS_EFF,
-     &          id%POSINRHSCOMP_COL(1), id%N,
+#else
+     &          LSCAL, SCALING_LOC_BWD(1), size(SCALING_LOC_BWD),
+#endif
+     &          id%RHSINTR(IBEG_RHSINTR), id%LD_RHSINTR, NBRHS_EFF,
+     &          id%GLOB2LOC_SOL(1), id%N,
      &          PERM_RHS, size(PERM_RHS) ! For sparse permuted RHS
      &          )
               ELSE ! only gather target entries of A-1
                 CALL ZMUMPS_GATHER_SOLUTION_AM1(id%NSLAVES,id%N,
      &          id%MYID, id%COMM, NBRHS_EFF,
-     &          id%RHSCOMP(IBEG_RHSCOMP), LD_RHSCOMP, NBRHS_EFF,
+     &          id%RHSINTR(IBEG_RHSINTR), id%LD_RHSINTR, NBRHS_EFF,
      &          id%KEEP(1), BUFR(1), LBUFR, LBUFR_BYTES,
+#if defined(USE_OLD_SCALING)
      &          LSCAL, PT_SCALING(1), size(PT_SCALING)
+#else
+     &          LSCAL, SCALING_RHSINTR_BWD(1), size(SCALING_RHSINTR_BWD)
+#endif
 C               --- A-1 related entries
      &          , IRHS_PTR_COPY(1), size(IRHS_PTR_COPY),
      &          IRHS_SPARSE_COPY(1), size(IRHS_SPARSE_COPY),
      &          RHS_SPARSE_COPY(1), size(RHS_SPARSE_COPY),
      &          UNS_PERM_INV, size(UNS_PERM_INV),
-     &          id%POSINRHSCOMP_COL(1), id%N, NB_FS_RHSCOMP_TOT
+     &          id%GLOB2LOC_SOL(1), id%N, NB_FS_RHSINTR_TOT
      &          )
               ENDIF
             ENDIF
@@ -4379,32 +5056,46 @@ C                 IZ - Column index in S
               ENDIF
             ENDIF             ! end A-1 on master
 C
-C         -- END of backward was performed with centralized solution
+C}        -- END of backward was performed with centralized solution
           ELSE   ! (KEEP(221).NE.1) .AND.(ICNTL21.NE.0))
 C
 C           BEGIN of backward performed with distributed solution
 C           time local copy + scaling
             TIMECOPYSCALE1=MPI_WTIME()
-C           The non working host should not do this:
-            IF ( I_AM_SLAVE ) THEN
-              LIW_PASSED = max( LIW, 1 )
-C             Only called if more than 1 pivot
-C             was eliminated by the processor.
-C             Note that LSOL_loc >= KEEP(89)
-              IF ( KEEP(89) .GT. 0 ) THEN
-                CALL ZMUMPS_DISTRIBUTED_SOLUTION(id%NSLAVES,
-     &          id%N,id%MYID_NODES,
-     &          MTYPE, id%RHSCOMP(IBEG_RHSCOMP), LD_RHSCOMP,
-     &          NBRHS_EFF, id%POSINRHSCOMP_COL(1),
-     &          id%ISOL_loc(1), id%SOL_loc(1), id%NRHS,
-     &          JBEG_RHS-NB_RHSSKIPPED, id%LSOL_loc,
-     &          id%PTLUST_S(1), id%PROCNODE_STEPS(1),
-     &          id%KEEP(1),id%KEEP8(1),
-     &          IS(1), LIW_PASSED,
-     &          id%STEP(1), scaling_data_sol, LSCAL, NB_RHSSKIPPED,
-     &          PERM_RHS, size(PERM_RHS) ) ! For permuted sparse RHS
+C             The non working host should not do this:
+              IF ( I_AM_SLAVE ) THEN
+                LIW_PASSED = max( LIW, 1 )
+C               Only called if more than 1 pivot
+C               was eliminated by the processor.
+C               Note that LSOL_loc >= KEEP(89)
+                IF ( KEEP(89) .GT. 0 ) THEN
+            IF ( LSCAL .AND. id%KEEP(89).GT.0) THEN
+#if defined(USE_OLD_SCALING)
+              SCALING_LOC_BWD => scaling_data_sol%SCALING_LOC
+#else
+              IF (MTYPE.EQ.1) THEN
+                SCALING_LOC_BWD => id%COLSCA_loc
+              ELSE
+                SCALING_LOC_BWD => id%ROWSCA_loc
               ENDIF
+#endif
+            ELSE
+              SCALING_LOC_BWD => RDUMMY_TARGET
             ENDIF
+                  CALL ZMUMPS_DISTRIBUTED_SOLUTION(id%NSLAVES,
+     &            id%N,id%MYID_NODES,
+     &            MTYPE, id%RHSINTR(IBEG_RHSINTR), id%LD_RHSINTR,
+     &            NBRHS_EFF, id%GLOB2LOC_SOL(1),
+     &            id%ISOL_loc(1), id%SOL_loc(1), id%NRHS,
+     &            JBEG_RHS-NB_RHSSKIPPED, id%LSOL_loc,
+     &            id%PTLUST_S(1), id%PROCNODE_STEPS(1),
+     &            id%KEEP(1),id%KEEP8(1),
+     &            IS(1), LIW_PASSED, id%STEP(1),
+     &            SCALING_LOC_BWD(1), size(SCALING_LOC_BWD),
+     &            LSCAL, NB_RHSSKIPPED,
+     &            PERM_RHS, size(PERM_RHS) ) ! For permuted sparse RHS
+                ENDIF
+              ENDIF
             TIMECOPYSCALE2=MPI_WTIME()-TIMECOPYSCALE1+TIMECOPYSCALE2
           ENDIF
 C         === BACKWARD was PERFORMED WITH DISTRIBUTED SOLUTION ===
@@ -4425,7 +5116,7 @@ C         Multiple RHS: apply a fixed nu
 C         of iterative refinement steps
 C         ----------------------------------
 C         DO I = 1, ICNTL10
-            write(6,*) ' Internal ERROR 15 in sol_driver '
+            write(6,*) ' Internal error 15 in sol_driver '
 C           Compute residual:  Y <- SAVERHS - A * RHS
 C           Solve RHS <- A^-1 Y, Y modified
 C           Assemble in RHS(REDUCE)
@@ -4433,7 +5124,7 @@ C           RHS <- RHS + Y
 C         END DO
         END IF
         IF (POSTPros) THEN
-C
+C{
 C         SAVERHS holds the original right hand side
 C         Sparse rhs are saved in SAVERHS as dense rhs
 C
@@ -5097,7 +5788,7 @@ C             We have used D only for LC
           DEALLOCATE(C_Y)
           DEALLOCATE(R_LOCWK54)
           DEALLOCATE(C_LOCWK54)
-C End POSTPros
+C} End POSTPros
         END IF
 C============================================
 C
@@ -5164,9 +5855,9 @@ C  ========================
 *         print out the solution
           IF ( INFO(1) .GE. 0 .AND. ICNTL(4).GE.3 .AND. ICNTL(3).GT.0)
      &    THEN
-            K = min0(10, id%N)
+            K = min(10, id%N)
             IF (ICNTL(4) .eq. 4 ) K = id%N
-            J = min0(10,NBRHS_EFF)
+            J = min(10,NBRHS_EFF)
             IF (ICNTL(4) .eq. 4 ) J = NBRHS_EFF
             DO II=1, J
               WRITE(ICNTL(3),110) BEG_RHS+II-1
@@ -5190,9 +5881,6 @@ C     }
       ENDDO
 C     END DO WHILE (BEG_RHS.LE.id%NRHS)
 C     =================================
-      IF (KEEP(400) .GT. 0) THEN
-        CALL ZMUMPS_SOL_L0OMP_LD(KEEP(400))
-      ENDIF
 C
 C     ========================================================
 C     Reset RHS to zero for all remaining columns that
@@ -5226,14 +5914,14 @@ C     ==================================
       ENDIF
 C     ========================================================
 C     Reset id%SOL_loc to zero for all remaining columns that
-C     have not been processed because they were emtpy
+C     have not been processed because they were empty
 C     ========================================================
       IF ( I_AM_SLAVE .AND. (ICNTL21.NE.0) .AND.
      &      ( JEND_RHS .LT. id%NRHS ) .AND. KEEP(221).NE.1 ) THEN
         JBEG_NEW = JEND_RHS + 1
         IF (DO_PERMUTE_RHS.OR.INTERLEAVE_PAR) THEN
            DO WHILE ( JBEG_NEW.LE. id%NRHS)
-              DO I=1, KEEP(89)
+              DO I=1, NSOL_loc
                  id%SOL_loc(int(PERM_RHS(JBEG_NEW) -1,8)*
      &                      int(id%LSOL_loc,8)+int(I,8)) = ZERO
               ENDDO
@@ -5242,7 +5930,7 @@ C     ==================================
         ELSE
 C
            DO WHILE ( JBEG_NEW.LE. id%NRHS)
-            DO I=1, KEEP(89)
+            DO I=1, NSOL_loc
                 id%SOL_loc((JBEG_NEW -1)*id%LSOL_loc + I) = ZERO
             ENDDO
             JBEG_NEW = JBEG_NEW +1
@@ -5251,7 +5939,7 @@ C
       ENDIF
 C
 C     ================================================================
-C     Reset id%RHSCOMP and id%REDRHS to zero for all remaining columns
+C     Reset id%RHSINTR and id%REDRHS to zero for all remaining columns
 C     that have not been processed because they were emtpy
 C     ================================================================
       IF ((KEEP(221).EQ.1) .AND.
@@ -5269,8 +5957,8 @@ C     ==================================
        IF (I_AM_SLAVE) THEN
            JBEG_NEW = JEND_RHS + 1
            DO WHILE ( JBEG_NEW.LE. id%NRHS)
-            DO I=1,NBENT_RHSCOMP
-              id%RHSCOMP(int(JBEG_NEW -1,8)*int(LD_RHSCOMP,8) +
+            DO I=1,NBENT_RHSINTR
+              id%RHSINTR(int(JBEG_NEW -1,8)*int(id%LD_RHSINTR,8) +
      &                   int(I,8)) =  ZERO
             ENDDO
             JBEG_NEW = JBEG_NEW +1
@@ -5362,9 +6050,43 @@ C
         WRITE( MP, 431 ) id%DKEEP(122)
       END IF
  90   CONTINUE
+      IF (KEEP(400) .GT. 0) THEN
+        CALL ZMUMPS_SOL_L0OMP_LD(KEEP(400))
+      ENDIF
       IF (INFO(1) .LT.0 ) THEN
          IF (INFO(1) .EQ. -80) INFO(1) = -81
       ENDIF
+C     -- related to exploit sparsity
+       IF (associated(nodes_FWD)) THEN 
+        NB_BYTES = NB_BYTES - size(nodes_FWD) * K34_8
+        DEALLOCATE(nodes_FWD)
+        NULLIFY(nodes_FWD)
+       ENDIF
+       IF (associated(nodes_BWD)) THEN 
+        NB_BYTES = NB_BYTES - size(nodes_BWD) * K34_8
+        DEALLOCATE(nodes_BWD)
+        NULLIFY(nodes_BWD)
+       ENDIF
+       IF (allocated(Pruned_Sons_FWD)) THEN 
+        NB_BYTES = NB_BYTES - size(Pruned_Sons_FWD) * K34_8
+        DEALLOCATE(Pruned_Sons_FWD)
+       ENDIF
+       IF (allocated(Pruned_Sons_BWD)) THEN 
+        NB_BYTES = NB_BYTES - size(Pruned_Sons_BWD) * K34_8
+        DEALLOCATE(Pruned_Sons_BWD)
+       ENDIF
+      IF (SCALING_RHSINTR_FWD_ALLOCATED) THEN
+        NB_BYTES = NB_BYTES - LSCALING_RHSINTR_FWD * K16_8
+        DEALLOCATE(SCALING_RHSINTR_FWD)
+      ENDIF
+      SCALING_RHSINTR_FWD_ALLOCATED = .FALSE.
+      NULLIFY(SCALING_RHSINTR_FWD)
+      IF (SCALING_RHSINTR_BWD_ALLOCATED) THEN
+        NB_BYTES = NB_BYTES - LSCALING_RHSINTR_BWD * K16_8
+        DEALLOCATE(SCALING_RHSINTR_BWD)
+      ENDIF
+      SCALING_RHSINTR_BWD_ALLOCATED = .FALSE.
+      NULLIFY(SCALING_RHSINTR_BWD)
       IF (KEEP(485) .EQ. 1) THEN
         KEEP(350) = KEEP350_SAVE
         IF (IS_LR_MOD_TO_STRUC_DONE) THEN
@@ -5421,12 +6143,16 @@ C       Free space and reset pointers if
          NULLIFY(IRHS_loc_PTR)
          IRHS_loc_PTR_ALLOCATED = .FALSE.
        ENDIF
+#if defined(USE_OLD_SCALING)
        IF (I_AM_SLAVE.AND.LSCAL.AND.KEEP(248).EQ.-1) THEN
-         NB_BYTES = NB_BYTES -
-     &   int(size(scaling_data_dr%SCALING_LOC),8)*K16_8
-         DEALLOCATE(scaling_data_dr%SCALING_LOC)
-         NULLIFY   (scaling_data_dr%SCALING_LOC)
+         IF (associated(scaling_data_dr%SCALING_LOC)) THEN
+           NB_BYTES = NB_BYTES -
+     &     int(size(scaling_data_dr%SCALING_LOC),8)*K16_8
+           DEALLOCATE(scaling_data_dr%SCALING_LOC)
+           NULLIFY   (scaling_data_dr%SCALING_LOC)
+         ENDIF
        ENDIF
+#endif
       IF (allocated(PERM_RHS)) THEN
         NB_BYTES = NB_BYTES - int(size(PERM_RHS),8)*K34_8
         DEALLOCATE(PERM_RHS)
@@ -5498,13 +6224,19 @@ C       Deallocate temporary workspace S
           NB_BYTES = NB_BYTES - int(size(SRW3),8)*K35_8
           DEALLOCATE(SRW3)
         ENDIF
-        IF (LSCAL .AND. ICNTL21==1) THEN
-C         Free local scaling arrays
-          NB_BYTES = NB_BYTES -
-     &              int(size(scaling_data_sol%SCALING_LOC),8)*K16_8
-          DEALLOCATE(scaling_data_sol%SCALING_LOC)
-          NULLIFY(scaling_data_sol%SCALING_LOC)
+#if defined(USE_OLD_SCALING)
+C       Free local scaling arrays
+        IF (LSCAL .AND. ICNTL21 .NE. 0) THEN
+          IF (associated(scaling_data_sol%SCALING_LOC)) THEN
+            NB_BYTES = NB_BYTES -
+     &                 int(size(scaling_data_sol%SCALING_LOC),8)*K16_8
+            DEALLOCATE(scaling_data_sol%SCALING_LOC)
+            NULLIFY(scaling_data_sol%SCALING_LOC)
+          ENDIF
         ENDIF
+#endif
+#if defined(USE_OLD_SCALING)
+#endif
 C       Free memory until next call to ZMUMPS
         IF (WK_USER_PROVIDED) THEN
 C         S points to WK_USER provided by user
@@ -5528,28 +6260,30 @@ C         at the beginning of the solve,
           NB_BYTES  = NB_BYTES - KEEP8(23) * K35_8
           KEEP8(23) = 0_8
         ENDIF
-        IF (KEEP(221).NE.1) THEN
+        IF (KEEP(221).NE.1
+     &     ) THEN
 C       -- After reduction of RHS to Schur variables
 C       -- keep compressed RHS generated during FWD step
 C       -- to be used for future expansion
-         IF (associated(id%RHSCOMP)) THEN
+         IF (associated(id%RHSINTR)) THEN
             NB_BYTES = NB_BYTES - id%KEEP8(25)*K35_8
-            DEALLOCATE(id%RHSCOMP)
-            NULLIFY(id%RHSCOMP)
-            id%KEEP8(25)=0_8
+            DEALLOCATE(id%RHSINTR)
+            NULLIFY(id%RHSINTR)
+            id%KEEP8(25)  = 0_8
+            id%LD_RHSINTR = 0
          ENDIF
-         IF (associated(id%POSINRHSCOMP_ROW)) THEN
+         IF (associated(id%GLOB2LOC_RHS)) THEN
             NB_BYTES = NB_BYTES -
-     &                 int(size(id%POSINRHSCOMP_ROW),8)*K34_8
-            DEALLOCATE(id%POSINRHSCOMP_ROW)
-            NULLIFY(id%POSINRHSCOMP_ROW)
+     &                 int(size(id%GLOB2LOC_RHS),8)*K34_8
+            DEALLOCATE(id%GLOB2LOC_RHS)
+            NULLIFY(id%GLOB2LOC_RHS)
          ENDIF
-         IF (id%POSINRHSCOMP_COL_ALLOC) THEN
+         IF (id%GLOB2LOC_SOL_ALLOC) THEN
             NB_BYTES = NB_BYTES -
-     &                 int(size(id%POSINRHSCOMP_COL),8)*K34_8
-            DEALLOCATE(id%POSINRHSCOMP_COL)
-            NULLIFY(id%POSINRHSCOMP_COL)
-            id%POSINRHSCOMP_COL_ALLOC = .FALSE.
+     &                 int(size(id%GLOB2LOC_SOL),8)*K34_8
+            DEALLOCATE(id%GLOB2LOC_SOL)
+            NULLIFY(id%GLOB2LOC_SOL)
+            id%GLOB2LOC_SOL_ALLOC = .FALSE.
          ENDIF
         ENDIF
         IF ( WORK_WCB_ALLOCATED ) THEN
@@ -5560,6 +6294,23 @@ C       Otherwise, WORK_WCB may point to
 C       position inside id%S, nullify it
         NULLIFY( WORK_WCB )
       ENDIF
+#if defined(STAT_ES_SOLVE)
+      IF (
+     & (id%MYID.EQ.MASTER).AND.
+     & ( (id%KEEP(235).NE.0).OR.(id%KEEP(212).NE.0) )
+     &   )
+     & THEN
+C       If exploit sparsity then
+C       stats saved in DKEEP(200:204) and
+C       set RINFOG(24), RINFOG(25), RINFOG(26)
+        CALL ZMUMPS_SOL_ES_PRINT_STATS( 
+     &      id%KEEP(212), id%KEEP(235), id%KEEP(237),
+     &      id%KEEP(485), id%KEEP(497), 
+     &      id%KEEP8(110),id%NRHS, id%ICNTL(27), id%N, 
+     &      id%KEEP(50), id%DKEEP(200:204),
+     &      id%RINFOG(24:28), MPG)
+      END IF
+#endif
  500  CONTINUE
       RETURN
  55   FORMAT (//' ERROR ANALYSIS BEFORE ITERATIVE REFINEMENT')
@@ -5572,7 +6323,7 @@ C       position inside id%S, nullify it
  437  FORMAT('  .. Time in ScaLAPACK root       =   ',F15.6)
  436  FORMAT('  .. Time in backward (bwd) step  =   ',F15.6)
  433  FORMAT(' Time to gather solution(cent.sol)=',F15.6)
- 431  FORMAT(' Time to copy/scale dist. solution=',F15.6)
+ 431  FORMAT(' Time for distributed solution    =',F15.6)
  150  FORMAT(' GLOBAL STATISTICS PRIOR SOLVE PHASE ...........'/
      &        ' Number of right-hand-sides                    =',I12/
      &        ' Blocking factor for multiple rhs              =',I12/
@@ -5582,7 +6333,8 @@ C       position inside id%S, nullify it
      &        '  --- (20)                                     =',I12/
      &        '  --- (21)                                     =',I12/
      &        '  --- (30)                                     =',I12/
-     &        '  --- (35)                                     =',I12
+     &        '  --- (35)                                     =',I12/
+     &        '  --- (48) (effective)                         =',I12
      &        )
  151  FORMAT ('  --- (25)                                     =',I12)
  152  FORMAT ('  --- (26)                                     =',I12)
@@ -5601,6 +6353,7 @@ C       position inside id%S, nullify it
      &       NRHS,
      &       idIRHS_loc,
      &       idRHS_loc,
+     &       I_AM_SLAVE,
      &       INFO)
 C
 C  Purpose:
@@ -5619,6 +6372,7 @@ C
         INTEGER, INTENT( IN ) :: idNloc_RHS
         INTEGER, INTENT( IN ) :: idLRHS_loc
         INTEGER, INTENT( IN ) :: NRHS
+        LOGICAL, INTENT( IN ) :: I_AM_SLAVE
 #if defined(MUMPS_NOF2003)
         INTEGER, POINTER :: idIRHS_loc (:)
         COMPLEX(kind=8), POINTER :: idRHS_loc  (:)
@@ -5638,6 +6392,14 @@ C  =====================
 C
 C       Quick return if nothing on this proc
         IF (idNloc_RHS .LE. 0) RETURN
+        IF (idNloc_RHS .GT. 0 .AND. .NOT. I_AM_SLAVE) THEN
+C         Nloc_RHS should not be greater than 0
+C         on a non working host because the distribution
+C         of the RHS does not include the non working host.
+          INFO(1)=-55
+          INFO(2)=-idLRHS_loc
+          RETURN
+        ENDIF
 C       Check for leading dimension
         IF (NRHS.NE.1) THEN
           IF ( idLRHS_loc .LT. idNloc_RHS) THEN
@@ -5716,6 +6478,7 @@ C         We force SOLVET to have value
 C         to be able to test both values, and also, be able to
 C         test whether SOLVET = MTYPE or not.
           IF ( SOLVET.EQ.2 ) SOLVET = 0
+#if defined(USE_OLD_SCALING)
           IF ( LSCAL ) THEN
             IF ( SOLVET .EQ. 1 ) THEN
 C             Apply rowscaling
@@ -5729,19 +6492,31 @@ C             Apply column scaling
               END DO
             END IF
           END IF
+#endif
         END IF ! MYID.EQ.MASTER
 C       ------------------------------
 C       Broadcast SOLVET to the slaves
 C       ------------------------------
         CALL MPI_BCAST( SOLVET, 1, MPI_INTEGER, MASTER,
      &                  id%COMM, IERR)
+#if ! defined(USE_OLD_SCALING)
+        IF (LSCAL .AND. id%KEEP(89) .GT. 0) THEN
+          IF (SOLVET .EQ. 1) THEN
+            SCALING_LOC_FWD => id%ROWSCA_LOC
+          ELSE
+            SCALING_LOC_FWD => id%COLSCA_LOC
+          ENDIF
+        ELSE
+            SCALING_LOC_FWD => RDUMMY_TARGET
+        ENDIF
+#endif
 C       --------------------------------------------
 C       Scatter the right hand side C_Y on all procs
 C       --------------------------------------------
         IF ( .NOT.I_AM_SLAVE ) THEN
 C         -- Master not working
           CALL ZMUMPS_SCATTER_RHS(id%NSLAVES,id%N, id%MYID,
-     &      id%COMM,
+     &      id%COMM, LSCAL, SCALING_LOC_FWD(1),
      &      SOLVET, C_Y(1), id%N, 1,
      &      1,
      &      C_DUMMY, 1, 1,
@@ -5752,21 +6527,21 @@ C         -- Master not working
      &      id%ICNTL(1),id%INFO(1))
         ELSE
           IF (SOLVET.EQ.MTYPE) THEN
-C           POSINRHSCOMP_ROW is with respect to the
+C           GLOB2LOC_RHS is with respect to the
 C           original linear system (transposed or not)
-            PTR_POSINRHSCOMP_FWD => id%POSINRHSCOMP_ROW
+            PTR_POSINRHSINTR_FWD => id%GLOB2LOC_RHS
           ELSE
 C           Transposed, use column indices of original
 C           system (ie, col indices of A or A^T)
-            PTR_POSINRHSCOMP_FWD => id%POSINRHSCOMP_COL
+            PTR_POSINRHSINTR_FWD => id%GLOB2LOC_SOL
           ENDIF
           LIW_PASSED = max( LIW, 1 )
           CALL ZMUMPS_SCATTER_RHS(id%NSLAVES,id%N, id%MYID,
-     &      id%COMM,
+     &      id%COMM, LSCAL, SCALING_LOC_FWD(1),
      &      SOLVET,  C_Y(1), id%N, 1,
      &      1,
-     &      id%RHSCOMP(IBEG_RHSCOMP), LD_RHSCOMP, 1,
-     &      PTR_POSINRHSCOMP_FWD(1), NB_FS_RHSCOMP_F,
+     &      id%RHSINTR(IBEG_RHSINTR), id%LD_RHSINTR, 1,
+     &      PTR_POSINRHSINTR_FWD(1), NB_FS_RHSINTR_F,
 C
      &      id%PTLUST_S(1), id%KEEP(1), id%KEEP8(1),
      &      id%PROCNODE_STEPS(1),
@@ -5782,11 +6557,11 @@ C
           LIW_PASSED = max( LIW, 1 )
           LA_PASSED = max( LA, 1_8 )
           IF (SOLVET.EQ.MTYPE) THEN
-            PTR_POSINRHSCOMP_FWD => id%POSINRHSCOMP_ROW
-            PTR_POSINRHSCOMP_BWD => id%POSINRHSCOMP_COL
+            PTR_POSINRHSINTR_FWD => id%GLOB2LOC_RHS
+            PTR_POSINRHSINTR_BWD => id%GLOB2LOC_SOL
           ELSE
-            PTR_POSINRHSCOMP_FWD => id%POSINRHSCOMP_COL
-            PTR_POSINRHSCOMP_BWD => id%POSINRHSCOMP_ROW
+            PTR_POSINRHSINTR_FWD => id%GLOB2LOC_SOL
+            PTR_POSINRHSINTR_BWD => id%GLOB2LOC_RHS
           ENDIF
           FROM_PP=.TRUE.
           NBSPARSE_LOC = .FALSE.
@@ -5800,10 +6575,15 @@ C
      & LBUFR_BYTES, id%ISTEP_TO_INIV2(1), id%TAB_POS_IN_PERE(1,1),
 C      Next 3 arguments are not used in this call
      & IBEG_ROOT_DEF,IEND_ROOT_DEF,IROOT_DEF_RHS_COL1, PTR_RHS_ROOT(1),
-     & LPTR_RHS_ROOT, SIZE_ROOT, MASTER_ROOT, id%RHSCOMP(IBEG_RHSCOMP),
-     & LD_RHSCOMP,PTR_POSINRHSCOMP_FWD(1),PTR_POSINRHSCOMP_BWD(1),
+     & LPTR_RHS_ROOT, SIZE_ROOT, MASTER_ROOT, id%RHSINTR(IBEG_RHSINTR),
+     & id%LD_RHSINTR,PTR_POSINRHSINTR_FWD(1),PTR_POSINRHSINTR_BWD(1),
+     & -1, -1,
+     & IDUMMY(1), IDUMMY(1),
      & 1,1,1,1, IDUMMY, 1, JDUMMY, KDUMMY, 1, LDUMMY, 1, MDUMMY, 1,1,
      & NBSPARSE_LOC, PTR_RHS_BOUNDS(1), LPTR_RHS_BOUNDS
+#if defined(STAT_ES_SOLVE)
+     & , IDUMMY, 1, JDUMMY, 1
+#endif
      & , id%IPOOL_B_L0_OMP(1), id%LPOOL_B_L0_OMP, id%IPOOL_A_L0_OMP(1),
      & id%LPOOL_A_L0_OMP, id%L_VIRT_L0_OMP, id%VIRT_L0_OMP(1),
      & id%L_PHYS_L0_OMP, id%PHYS_L0_OMP(1), id%PERM_L0_OMP(1),
@@ -5847,6 +6627,7 @@ C       then necessarily NBRHS_EFF = 1)
 C
 C       === GATHER and SCALE solution ==============
 C
+#if defined(USE_OLD_SCALING)
         IF ((id%MYID.NE.MASTER).OR. .NOT.LSCAL) THEN
           PT_SCALING => Dummy_SCAL
         ELSE
@@ -5856,12 +6637,23 @@ C
             PT_SCALING => id%ROWSCA
           ENDIF
         ENDIF
+#else
+        IF (id%KEEP(89) .EQ. 0 .OR. .NOT. LSCAL) THEN
+          SCALING_LOC_BWD => RDUMMY_TARGET
+        ELSE
+          IF (SOLVET.EQ.1) THEN
+            SCALING_LOC_BWD => id%COLSCA_loc
+          ELSE
+            SCALING_LOC_BWD => id%ROWSCA_loc
+          ENDIF
+        ENDIF
+#endif
         LIW_PASSED = max( LIW, 1 )
 C       Solution computed during ZMUMPS_SOL_C has been stored
-C       in id%RHSCOMP and is gathered on the master in C_Y
+C       in id%RHSINTR and is gathered on the master in C_Y
         IF ( .NOT. I_AM_SLAVE ) THEN
 C         I did not participate to computing part of the solution
-C         (id%RHSCOMP not set/allocate) : receive solution, store
+C         (id%RHSINTR not set/allocate) : receive solution, store
 C         it and scale it.
           CALL ZMUMPS_GATHER_SOLUTION(id%NSLAVES,id%N,
      &      id%MYID, id%COMM, NBRHS_EFF,
@@ -5870,8 +6662,12 @@ C         it and scale it.
      &      IDUMMY, 1,
      &      id%STEP(1), BUFR(1), LBUFR, LBUFR_BYTES,
      &      CWORK(1), size(CWORK),
+#if defined(USE_OLD_SCALING)
      &      LSCAL, PT_SCALING(1), size(PT_SCALING),
-!     RHSCOMP not on non-working master
+#else
+     &      LSCAL, SCALING_LOC_BWD(1), size(SCALING_LOC_BWD),
+#endif
+!     RHSINTR not on non-working master
      &      C_DUMMY, 1 , 1, IDUMMY, 1,
 !     for sparse permuted RHS on host
      &      PERM_RHS, size(PERM_RHS)
@@ -5885,9 +6681,13 @@ C         it and scale it.
      &      IS(1), LIW_PASSED,
      &      id%STEP(1), BUFR(1), LBUFR, LBUFR_BYTES,
      &      CWORK(1), size(CWORK),
+#if defined(USE_OLD_SCALING)
      &      LSCAL, PT_SCALING(1), size(PT_SCALING),
-     &      id%RHSCOMP(IBEG_RHSCOMP), LD_RHSCOMP, NBRHS_EFF,
-     &      PTR_POSINRHSCOMP_BWD(1), id%N,
+#else
+     &      LSCAL, SCALING_LOC_BWD(1), size(SCALING_LOC_BWD),
+#endif
+     &      id%RHSINTR(IBEG_RHSINTR), id%LD_RHSINTR, NBRHS_EFF,
+     &      PTR_POSINRHSINTR_BWD(1), id%N,
      &      PERM_RHS, size(PERM_RHS)) ! for sparse permuted RHS on host
         ENDIF
         DEALLOCATE( CWORK )
diff -pruN 5.6.2-2.1/src/zsol_fwd.F 5.7.1-1/src/zsol_fwd.F
--- 5.6.2-2.1/src/zsol_fwd.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zsol_fwd.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -14,7 +14,7 @@ C
       SUBROUTINE ZMUMPS_SOL_R(N, A, LA, IW, LIW, WCB, LWCB,
      &    NRHS,
      &    PTRICB, IWCB, LIWCB, 
-     &    RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD, 
+     &    RHSINTR, LRHSINTR, POSINRHSINTR_FWD, 
      &    STEP,
      &    FRERE, DAD, FILS,
      &    NSTK, IPOOL, LPOOL, PTRIST, PTRFAC, MYLEAF, MYROOT,
@@ -59,8 +59,8 @@ C
       INTEGER IW( LIW ), IWCB( LIWCB )
       INTEGER ISTEP_TO_INIV2(KEEP(71)), 
      &        TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
-      INTEGER, intent(in) ::  POSINRHSCOMP_FWD(N), LRHSCOMP 
-      COMPLEX(kind=8), intent(inout) :: RHSCOMP(LRHSCOMP,NRHS)
+      INTEGER, intent(in) ::  POSINRHSINTR_FWD(N), LRHSINTR 
+      COMPLEX(kind=8), intent(inout) :: RHSINTR(LRHSINTR,NRHS)
       LOGICAL, intent(in) :: FROM_PP
       INTEGER, INTENT( in ) :: LL0_OMP_MAPPING, LL0_OMP_FACTORS
       INTEGER, INTENT( in ) :: L0_OMP_MAPPING( LL0_OMP_MAPPING )
@@ -108,21 +108,25 @@ C
      &          KEEP(208) )
         GOTO 60
       ENDIF
-      BLOQ = ( ( III .EQ. LEAF )
+      IF (SLAVEF .EQ. 1) THEN
+        FLAG = .FALSE.
+      ELSE
+        BLOQ = ( ( III .EQ. LEAF )
      &     )
-      CALL ZMUMPS_SOLVE_RECV_AND_TREAT( BLOQ, FLAG,
-     &     BUFR, LBUFR, LBUFR_BYTES,
-     &     MYID, SLAVEF, COMM,
-     &     N, NRHS, IPOOL, LPOOL, LEAF,
-     &     NBFIN, NSTK, IW, LIW, A, LA, PTRIST, PTRFAC,
-     &     IWCB, LIWCB,
-     &     WCB, LWCB, POSWCB,
-     &     PLEFTWCB, POSIWCB,
-     &     PTRICB, INFO, KEEP,KEEP8, DKEEP, STEP,
-     &     PROCNODE_STEPS,
-     &     RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD
-     &     , FROM_PP
-     &    )
+        CALL ZMUMPS_SOLVE_RECV_AND_TREAT( BLOQ, FLAG,
+     &       BUFR, LBUFR, LBUFR_BYTES,
+     &       MYID, SLAVEF, COMM,
+     &       N, NRHS, IPOOL, LPOOL, LEAF,
+     &       NBFIN, NSTK, IW, LIW, A, LA, PTRIST, PTRFAC,
+     &       IWCB, LIWCB,
+     &       WCB, LWCB, POSWCB,
+     &       PLEFTWCB, POSIWCB,
+     &       PTRICB, INFO, KEEP,KEEP8, DKEEP, STEP,
+     &       PROCNODE_STEPS,
+     &       RHSINTR, LRHSINTR, POSINRHSINTR_FWD
+     &       , FROM_PP
+     &      )
+      ENDIF
       IF ( INFO( 1 ) .LT. 0 .OR. NBFIN .EQ. 0 ) GOTO 260
       IF (.not. FLAG) THEN
          IF (III .NE. LEAF) THEN
@@ -158,7 +162,7 @@ C
      &        PTRICB, PTRIST, PTRFAC, PROCNODE_STEPS,
      &        FILS, STEP, FRERE, DAD,
      &        INFO, KEEP,KEEP8, DKEEP, RHS_ROOT, LRHS_ROOT, MTYPE,
-     &        RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD,
+     &        RHSINTR, LRHSINTR, POSINRHSINTR_FWD,
      &        ISTEP_TO_INIV2, TAB_POS_IN_PERE
      &        , RHS_BOUNDS, LRHS_BOUNDS, DO_NBSPARSE 
      &        , FROM_PP
diff -pruN 5.6.2-2.1/src/zsol_fwd_aux.F 5.7.1-1/src/zsol_fwd_aux.F
--- 5.6.2-2.1/src/zsol_fwd_aux.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zsol_fwd_aux.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -21,7 +21,7 @@ C
      &     PLEFTWCB, POSIWCB,
      &     PTRICB,
      &     INFO, KEEP, KEEP8, DKEEP, STEP, PROCNODE_STEPS, 
-     &     RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD
+     &     RHSINTR, LRHSINTR, POSINRHSINTR_FWD
      &     , FROM_PP
      &    )
       USE ZMUMPS_OOC 
@@ -32,7 +32,7 @@ C
       INTEGER MSGTAG, MSGSOU, MYID, SLAVEF, COMM
       INTEGER LIW
       INTEGER(8), INTENT(IN) :: LA, LWCB
-      INTEGER N, NRHS, LPOOL, LEAF, NBFIN, LRHSCOMP
+      INTEGER N, NRHS, LPOOL, LEAF, NBFIN, LRHSINTR
       INTEGER LIWCB, POSIWCB
       INTEGER(8) :: POSWCB, PLEFTWCB
       INTEGER INFO( 80 ), KEEP( 500)
@@ -47,8 +47,8 @@ C
       INTEGER STEP(N)
       INTEGER PROCNODE_STEPS(KEEP(28))
       COMPLEX(kind=8) WCB( LWCB ), A( LA )
-      COMPLEX(kind=8) RHSCOMP( LRHSCOMP, NRHS )
-      INTEGER, intent(in) :: POSINRHSCOMP_FWD(N)
+      COMPLEX(kind=8) RHSINTR( LRHSINTR, NRHS )
+      INTEGER, intent(in) :: POSINRHSINTR_FWD(N)
       LOGICAL, intent(in) :: FROM_PP
       INCLUDE 'mpif.h'
       INCLUDE 'mumps_tags.h'
@@ -57,7 +57,7 @@ C
       INTEGER :: IWHDLR, LDA_SLAVE
       INTEGER :: MTYPE_SLAVE 
       INTEGER FINODE, FPERE, LONG, NCB, POSITION, NCV, NPIV
-      INTEGER PDEST, I, IPOSINRHSCOMP
+      INTEGER PDEST, I, IPOSINRHSINTR
       INTEGER J1
       INTEGER(8) :: APOS
       LOGICAL DUMMY
@@ -119,9 +119,9 @@ C
 !NEC$ IVDEP
 #endif
                  DO I = 1, LONG
-                   IPOSINRHSCOMP= abs(POSINRHSCOMP_FWD(IWCB(I)))
-                   RHSCOMP(IPOSINRHSCOMP,JBDEB+K-1) = 
-     &             RHSCOMP(IPOSINRHSCOMP,JBDEB+K-1) + 
+                   IPOSINRHSINTR= abs(POSINRHSINTR_FWD(IWCB(I)))
+                   RHSINTR(IPOSINRHSINTR,JBDEB+K-1) = 
+     &             RHSINTR(IPOSINRHSINTR,JBDEB+K-1) + 
      &                 WCB(PLEFTWCB+I-1)
                  ENDDO
               END DO
@@ -246,7 +246,7 @@ C
 !$           OMP_FLAG = ( JBFIN-JBDEB+1.GE.KEEP(362) .AND.
 !$   &                     (NCV*(JBFIN-JBDEB+1) .GE. KEEP(363) ) )
              IF (OMP_FLAG) THEN
-!$OMP PARALLEL DO PRIVATE(I,JJ,IFR8,IPOSINRHSCOMP)
+!$OMP PARALLEL DO PRIVATE(I,JJ,IFR8,IPOSINRHSINTR)
                DO K=1, NRHS_B
                   IFR8 = PTRY+int(K-1,8)*int(NCV,8)
 #if defined(__ve__)
@@ -254,9 +254,9 @@ C
 #endif
                   DO I = 1,NCV
                     JJ = IW(J1+I)
-                    IPOSINRHSCOMP= abs(POSINRHSCOMP_FWD(JJ))
-                    RHSCOMP(IPOSINRHSCOMP,JBDEB+K-1)= 
-     &                RHSCOMP(IPOSINRHSCOMP,JBDEB+K-1)
+                    IPOSINRHSINTR= abs(POSINRHSINTR_FWD(JJ))
+                    RHSINTR(IPOSINRHSINTR,JBDEB+K-1)= 
+     &                RHSINTR(IPOSINRHSINTR,JBDEB+K-1)
      &                + WCB(IFR8+int(I-1,8))
                   ENDDO
                ENDDO
@@ -269,9 +269,9 @@ C
 #endif
                   DO I = 1,NCV
                     JJ = IW(J1+I)
-                    IPOSINRHSCOMP= abs(POSINRHSCOMP_FWD(JJ))
-                    RHSCOMP(IPOSINRHSCOMP,JBDEB+K-1)= 
-     &                RHSCOMP(IPOSINRHSCOMP,JBDEB+K-1)
+                    IPOSINRHSINTR= abs(POSINRHSINTR_FWD(JJ))
+                    RHSINTR(IPOSINRHSINTR,JBDEB+K-1)= 
+     &                RHSINTR(IPOSINRHSINTR,JBDEB+K-1)
      &                + WCB(IFR8+int(I-1,8))
                   ENDDO
                ENDDO
@@ -297,7 +297,7 @@ C
      &            IW(PTRIST(STEP( FINODE )) + 2 + KEEP(IXSZ) ), NCV,NCV,
      &            IW(PTRIST(STEP(FINODE))+4+ KEEP(IXSZ) ),
      &            WCB( PTRY ), JBDEB, JBFIN,
-     &            RHSCOMP, 1, 1, -9999, -9999,
+     &            RHSINTR, 1, 1, -9999, -9999,
      &            KEEP, PDEST, ContVec, COMM, IERR )
             IF ( IERR .EQ. -1 ) THEN
               CALL ZMUMPS_SOLVE_RECV_AND_TREAT( .FALSE., FLAG,
@@ -309,7 +309,7 @@ C
      &              WCB, LWCB, POSWCB, PLEFTWCB, POSIWCB,
      &              PTRICB, INFO, KEEP,KEEP8, DKEEP, STEP,
      &              PROCNODE_STEPS, 
-     &              RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD
+     &              RHSINTR, LRHSINTR, POSINRHSINTR_FWD
      &              , FROM_PP
      &              )
               IF ( INFO( 1 )  .LT. 0 )  GOTO 270
@@ -356,7 +356,7 @@ C
      &     PTRICB, PTRIST, PTRFAC, PROCNODE_STEPS,
      &     FILS, STEP, FRERE, DAD,
      &     INFO, KEEP,KEEP8, DKEEP, RHS_ROOT, LRHS_ROOT, MTYPE,
-     &     RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD,
+     &     RHSINTR, LRHSINTR, POSINRHSINTR_FWD,
      &     
      &     ISTEP_TO_INIV2, TAB_POS_IN_PERE
      &    , RHS_BOUNDS, LRHS_BOUNDS, DO_NBSPARSE, FROM_PP
@@ -393,8 +393,8 @@ C
       INTEGER FILS( N ), STEP( N ), FRERE(KEEP(28)), DAD(KEEP(28))
       INTEGER ISTEP_TO_INIV2(KEEP(71)), 
      &     TAB_POS_IN_PERE(SLAVEF+2,max(1,KEEP(56)))
-      INTEGER POSINRHSCOMP_FWD(N), LRHSCOMP
-      COMPLEX(kind=8) RHSCOMP(LRHSCOMP, NRHS)
+      INTEGER POSINRHSINTR_FWD(N), LRHSINTR
+      COMPLEX(kind=8) RHSINTR(LRHSINTR, NRHS)
       LOGICAL, intent(in) :: DO_NBSPARSE
       INTEGER, intent(in) :: LRHS_BOUNDS
       INTEGER, intent(in) :: RHS_BOUNDS(LRHS_BOUNDS)
@@ -413,10 +413,10 @@ C
       INTEGER I, J, K, IPOS, NSLAVES, J1, J2, J3, FPERE, FPERE_MAPPING,
      &     NPIV, NCB, LIELL, JJ, NELIM, IERR
       INTEGER(8) :: PCB_COURANT, PPIV_COURANT, PPIV_PANEL, PCB_PANEL
-      INTEGER IPOSINRHSCOMP_TMP
+      INTEGER IPOSINRHSINTR_TMP
       INTEGER Effective_CB_Size, NUPDATE, ISLAVE, PDEST, FirstIndex
       LOGICAL FLAG
-      INTEGER :: NUPDATE_NONCRITICAL, IPOSINRHSCOMPLASTFSDYN 
+      INTEGER :: NUPDATE_NONCRITICAL, IPOSINRHSINTRLASTFSDYN 
       LOGICAL :: OMP_FLAG
       INCLUDE 'mumps_headers.h'
       INTEGER(8) :: APOSDEB
@@ -519,27 +519,27 @@ C
       ENDIF
       IF ( INODE .eq. KEEP( 38 ) .OR. INODE .eq. KEEP(20) ) THEN
         IFR8 = 0_8
-        IPOSINRHSCOMP_TMP = POSINRHSCOMP_FWD(IW(J1)) 
+        IPOSINRHSINTR_TMP = POSINRHSINTR_FWD(IW(J1)) 
         IFR_ini8 = IFR8
         OMP_FLAG = .FALSE.
 !$      OMP_FLAG = ( JBFIN-JBDEB+1.GE.KEEP(362) .AND.
 !$   &                     (J3-J1+1)*(JBFIN-JBDEB+1) .GE. KEEP(363) )
         IF (OMP_FLAG) THEN
 !$OMP PARALLEL DO PRIVATE(IFR8,JJ)
-          DO K=JBDEB,JBFIN
+          DO K=1,NRHS
              IFR8 = IFR_ini8 + int(K-1,8)*int(NPIV,8)
              DO JJ = J1, J3
                RHS_ROOT(IFR8+int(JJ-J1+1,8)) = 
-     &                 RHSCOMP(IPOSINRHSCOMP_TMP+JJ-J1,K)
+     &                 RHSINTR(IPOSINRHSINTR_TMP+JJ-J1,K)
              ENDDO
           ENDDO
 !$OMP END PARALLEL DO
         ELSE
-          DO K=JBDEB,JBFIN
+          DO K=1,NRHS
              IFR8 = IFR_ini8 + int(K-1,8)*int(NPIV,8)
              DO JJ = J1, J3
                RHS_ROOT(IFR8+int(JJ-J1+1,8)) = 
-     &                 RHSCOMP(IPOSINRHSCOMP_TMP+JJ-J1,K)
+     &                 RHSINTR(IPOSINRHSINTR_TMP+JJ-J1,K)
              ENDDO
           ENDDO
         ENDIF
@@ -604,10 +604,10 @@ C
       ELSE
         CBINITZERO = .FALSE. 
       ENDIF
-      CALL ZMUMPS_RHSCOMP_TO_WCB(
+      CALL ZMUMPS_RHSINTR_TO_WCB(
      &     NPIV, NCB, LIELL, CBINITZERO, LDEQLIELLPANEL,
-     &     RHSCOMP(1, JBDEB), LRHSCOMP, NRHS_B,
-     &     POSINRHSCOMP_FWD, N,
+     &     RHSINTR(1, JBDEB), LRHSINTR, NRHS_B,
+     &     POSINRHSINTR_FWD, N,
      &     WCB(PPIV_COURANT),
      &     IW, LIW, J1, J3, J2, KEEP, DKEEP)
       IF ( NPIV .NE. 0 ) THEN
@@ -704,8 +704,8 @@ C
      &           LIELL, WCB, LWCB, 
      &           LD_WCBPIV, LD_WCBCB,
      &           PPIV_COURANT, PCB_COURANT, 
-     &           RHSCOMP, LRHSCOMP, NRHS, 
-     &           POSINRHSCOMP_FWD, JBDEB, JBFIN,
+     &           RHSINTR, LRHSINTR, NRHS, 
+     &           POSINRHSINTR_FWD, JBDEB, JBFIN,
      &           MTYPE, KEEP, KEEP8, OOCWRITE_COMPATIBLE_WITH_BLR,
      &           INFO(1), INFO(2) )
             IF (INFO(1).LT.0) THEN
@@ -769,8 +769,8 @@ C
      &    IW, IPOS, LIW, 
      &    A, LA, APOS,
      &    WCB, LWCB, LD_WCBPIV, 
-     &    RHSCOMP, LRHSCOMP, NRHS, 
-     &    POSINRHSCOMP_FWD, JBDEB, JBFIN, 
+     &    RHSINTR, LRHSINTR, NRHS, 
+     &    POSINRHSINTR_FWD, JBDEB, JBFIN, 
      &    MTYPE, KEEP, OOCWRITE_COMPATIBLE_WITH_BLR,
      &    .FALSE.
      &    )
@@ -781,8 +781,8 @@ C
      &    IW, IPOS, LIW, 
      &    A, LA, APOS,
      &    WCB, LWCB, LD_WCBPIV, 
-     &    RHSCOMP, LRHSCOMP, NRHS, 
-     &    POSINRHSCOMP_FWD, JBDEB, JBFIN, 
+     &    RHSINTR, LRHSINTR, NRHS, 
+     &    POSINRHSINTR_FWD, JBDEB, JBFIN, 
      &    MTYPE, KEEP, OOCWRITE_COMPATIBLE_WITH_BLR,
      &    .FALSE.
      &    )
@@ -811,14 +811,14 @@ C
             NUPDATE_NONCRITICAL = NUPDATE
             IF (LASTFSL0DYN .LE. N) THEN
               IF ( LASTFSL0DYN .EQ. 0 ) THEN
-                IPOSINRHSCOMPLASTFSDYN = 0
+                IPOSINRHSINTRLASTFSDYN = 0
               ELSE
-                IPOSINRHSCOMPLASTFSDYN =
-     &                          abs(POSINRHSCOMP_FWD(LASTFSL0DYN))
+                IPOSINRHSINTRLASTFSDYN =
+     &                          abs(POSINRHSINTR_FWD(LASTFSL0DYN))
               ENDIF
               DO I = 1, NUPDATE
-                IF ( abs(POSINRHSCOMP_FWD( IW(J3+I) )) .GT. 
-     &               IPOSINRHSCOMPLASTFSDYN ) THEN
+                IF ( abs(POSINRHSINTR_FWD( IW(J3+I) )) .GT. 
+     &               IPOSINRHSINTRLASTFSDYN ) THEN
                   IF (abs(STEP(IW(J3+I))) .GT.
      &                abs(STEP( LASTFSL0STA))
      &                .OR. KEEP(261) .NE. 1) THEN
@@ -832,17 +832,17 @@ C
 !$          OMP_FLAG = ( NRHS_B.GE.KEEP(362) .AND.
 !$   &                  (NUPDATE*NRHS_B .GE. KEEP(363)) )
             IF (OMP_FLAG) THEN
-!$OMP PARALLEL DO PRIVATE(I,IFR8,IPOSINRHSCOMP_TMP)
+!$OMP PARALLEL DO PRIVATE(I,IFR8,IPOSINRHSINTR_TMP)
               DO K = JBDEB, JBFIN
                 IFR8 = PCB_COURANT + int(K-JBDEB,8)*int(LD_WCBCB,8)
 #if defined(__ve__)
 !NEC$ IVDEP
 #endif
                 DO I = 1, NUPDATE_NONCRITICAL
-                  IPOSINRHSCOMP_TMP = 
-     &            abs(POSINRHSCOMP_FWD(IW(J3 + I)))
-                  RHSCOMP( IPOSINRHSCOMP_TMP, K ) = 
-     &            RHSCOMP( IPOSINRHSCOMP_TMP, K )
+                  IPOSINRHSINTR_TMP = 
+     &            abs(POSINRHSINTR_FWD(IW(J3 + I)))
+                  RHSINTR( IPOSINRHSINTR_TMP, K ) = 
+     &            RHSINTR( IPOSINRHSINTR_TMP, K )
      &            + WCB(IFR8 + int(I-1,8))
                 ENDDO
               ENDDO
@@ -854,10 +854,10 @@ C
 !NEC$ IVDEP
 #endif
                 DO I = 1, NUPDATE_NONCRITICAL
-                  IPOSINRHSCOMP_TMP = 
-     &            abs(POSINRHSCOMP_FWD(IW(J3 + I)))
-                  RHSCOMP( IPOSINRHSCOMP_TMP, K ) = 
-     &            RHSCOMP( IPOSINRHSCOMP_TMP, K )
+                  IPOSINRHSINTR_TMP = 
+     &            abs(POSINRHSINTR_FWD(IW(J3 + I)))
+                  RHSINTR( IPOSINRHSINTR_TMP, K ) = 
+     &            RHSINTR( IPOSINRHSINTR_TMP, K )
      &            + WCB(IFR8 + int(I-1,8))
                 ENDDO
               ENDDO
@@ -880,10 +880,10 @@ C
 !NEC$ IVDEP
 #endif
                     DO I = NUPDATE_NONCRITICAL+1, NUPDATE
-                      IPOSINRHSCOMP_TMP = 
-     &                  abs(POSINRHSCOMP_FWD(IW(J3 + I)))
-                      RHSCOMP( IPOSINRHSCOMP_TMP, K ) = 
-     &                   RHSCOMP( IPOSINRHSCOMP_TMP, K )
+                      IPOSINRHSINTR_TMP = 
+     &                  abs(POSINRHSINTR_FWD(IW(J3 + I)))
+                      RHSINTR( IPOSINRHSINTR_TMP, K ) = 
+     &                   RHSINTR( IPOSINRHSINTR_TMP, K )
      &                   + WCB(IFR8 + int(I-1,8))
                     ENDDO
                   ENDDO
@@ -901,7 +901,7 @@ C
      &          NCB, LD_WCBCB,
      &          NUPDATE,
      &          IW( J3 + 1 ), WCB( PCB_COURANT ), JBDEB, JBFIN,
-     &          RHSCOMP, 1, 1, -9999, -9999,
+     &          RHSINTR, 1, 1, -9999, -9999,
      &          KEEP,
      &          MUMPS_PROCNODE(PROCNODE_STEPS(STEP(FPERE)), KEEP(199)),
      &          ContVec,
@@ -916,7 +916,7 @@ C
      &            WCB, LWCB, POSWCB, PLEFTWCB, POSIWCB,
      &            PTRICB, INFO, KEEP,KEEP8, DKEEP, STEP,
      &            PROCNODE_STEPS,
-     &            RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD
+     &            RHSINTR, LRHSINTR, POSINRHSINTR_FWD
      &            , FROM_PP
      &            )
             IF ( INFO( 1 )  .LT. 0 )  THEN
@@ -967,7 +967,7 @@ C
      &              WCB, LWCB, POSWCB, PLEFTWCB, POSIWCB,
      &              PTRICB, INFO, KEEP,KEEP8, DKEEP, STEP,
      &              PROCNODE_STEPS,
-     &              RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD
+     &              RHSINTR, LRHSINTR, POSINRHSINTR_FWD
      &              , FROM_PP
      &              )
                IF ( INFO( 1 )  .LT. 0 ) THEN
@@ -1003,7 +1003,7 @@ C
      &           WCB, LWCB, POSWCB,
      &           PLEFTWCB, POSIWCB,
      &           PTRICB, INFO, KEEP,KEEP8, DKEEP, STEP, PROCNODE_STEPS,
-     &           RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD
+     &           RHSINTR, LRHSINTR, POSINRHSINTR_FWD
      &            , FROM_PP
      &            )
       IMPLICIT NONE
@@ -1028,8 +1028,8 @@ C
       INTEGER STEP(N)
       INTEGER PROCNODE_STEPS(KEEP(28))
       LOGICAL FLAG
-      INTEGER LRHSCOMP, POSINRHSCOMP_FWD(N)
-      COMPLEX(kind=8) RHSCOMP(LRHSCOMP,NRHS)
+      INTEGER LRHSINTR, POSINRHSINTR_FWD(N)
+      COMPLEX(kind=8) RHSINTR(LRHSINTR,NRHS)
       LOGICAL, intent(in) :: FROM_PP
       INCLUDE 'mpif.h'
       INCLUDE 'mumps_tags.h'
@@ -1067,27 +1067,27 @@ C
      &          PLEFTWCB, POSIWCB,
      &          PTRICB, INFO, KEEP,KEEP8, DKEEP, STEP,
      &          PROCNODE_STEPS, 
-     &          RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD
+     &          RHSINTR, LRHSINTR, POSINRHSINTR_FWD
      &          , FROM_PP
      &          )
          END IF
       END IF
       RETURN
       END SUBROUTINE ZMUMPS_SOLVE_RECV_AND_TREAT
-      SUBROUTINE ZMUMPS_RHSCOMP_TO_WCB(
+      SUBROUTINE ZMUMPS_RHSINTR_TO_WCB(
      &      NPIV, NCB, LIELL, CBINITZERO, LDEQLIELLPANEL,
-     &      RHSCOMP, LRHSCOMP, NRHS_B,
-     &      POSINRHSCOMP_FWD, N,
+     &      RHSINTR, LRHSINTR, NRHS_B,
+     &      POSINRHSINTR_FWD, N,
      &      WCB,
      &      IW, LIW, J1, J3, J2, KEEP, DKEEP)
       IMPLICIT NONE
       INTEGER, INTENT( IN )    :: NPIV, NCB, LIELL, N,
-     &                            LRHSCOMP, NRHS_B,
+     &                            LRHSINTR, NRHS_B,
      &                            LIW, J1, J2, J3
       LOGICAL, INTENT( IN )    :: LDEQLIELLPANEL
       LOGICAL, INTENT( IN )    :: CBINITZERO
-      INTEGER, INTENT( IN )    :: POSINRHSCOMP_FWD( N ), IW( LIW )
-      COMPLEX(kind=8), INTENT( INOUT ) :: RHSCOMP( LRHSCOMP, NRHS_B )
+      INTEGER, INTENT( IN )    :: POSINRHSINTR_FWD( N ), IW( LIW )
+      COMPLEX(kind=8), INTENT( INOUT ) :: RHSINTR( LRHSINTR, NRHS_B )
       COMPLEX(kind=8), INTENT( OUT )   :: WCB( int(LIELL,8)*
      &                                 int(NRHS_B,8) )
       INTEGER                  :: KEEP(500)
@@ -1095,7 +1095,7 @@ C
       INTEGER, PARAMETER :: ZERO = (0.0D0,0.0D0)
       INTEGER(8), PARAMETER :: PPIV_COURANT = 1_8
       INTEGER(8) :: PCB_COURANT
-      INTEGER :: LD_WCBCB, LD_WCBPIV, J, JJ, K, IPOSINRHSCOMP
+      INTEGER :: LD_WCBCB, LD_WCBPIV, J, JJ, K, IPOSINRHSINTR
       INTEGER(8) :: IFR8, IFR_ini8 
       INCLUDE 'mpif.h' 
       LOGICAL :: OMP_FLAG
@@ -1111,11 +1111,11 @@ C
       IF ( LDEQLIELLPANEL ) THEN  
         DO K=1, NRHS_B
            IFR8 = PPIV_COURANT+int(K-1,8)*int(LD_WCBPIV,8)-1_8
-           IPOSINRHSCOMP = POSINRHSCOMP_FWD(IW(J1)) 
+           IPOSINRHSINTR = POSINRHSINTR_FWD(IW(J1)) 
            DO JJ = J1, J3
               IFR8 = IFR8 + 1_8
-              WCB(IFR8) = RHSCOMP(IPOSINRHSCOMP,K) 
-              IPOSINRHSCOMP = IPOSINRHSCOMP + 1
+              WCB(IFR8) = RHSINTR(IPOSINRHSINTR,K) 
+              IPOSINRHSINTR = IPOSINRHSINTR + 1
            ENDDO
            IF (NCB.GT.0 .AND. .NOT. CBINITZERO) THEN
 #if defined(__ve__)
@@ -1124,9 +1124,9 @@ C
               DO JJ = J3+1, J2
                  J = IW(JJ)
                  IFR8 = IFR8 + 1_8
-                 IPOSINRHSCOMP = abs(POSINRHSCOMP_FWD(J))
-                 WCB(IFR8) = RHSCOMP(IPOSINRHSCOMP,K) 
-                 RHSCOMP (IPOSINRHSCOMP,K) = ZERO
+                 IPOSINRHSINTR = abs(POSINRHSINTR_FWD(J))
+                 WCB(IFR8) = RHSINTR(IPOSINRHSINTR,K) 
+                 RHSINTR (IPOSINRHSINTR,K) = ZERO
               ENDDO
            ENDIF
         ENDDO
@@ -1134,7 +1134,7 @@ C
         PCB_COURANT = PPIV_COURANT + LD_WCBPIV*NRHS_B
         IFR8 = PPIV_COURANT - 1_8
         IFR_ini8 = IFR8
-        IPOSINRHSCOMP = POSINRHSCOMP_FWD(IW(J1)) 
+        IPOSINRHSINTR = POSINRHSINTR_FWD(IW(J1)) 
         OMP_FLAG = .FALSE.
 !$      OMP_FLAG = ( NRHS_B .GE. KEEP(362) .AND.
 !$   &               int(NCB,8)*int(NRHS_B,8) .GE. KEEP(363) )
@@ -1144,7 +1144,7 @@ C
             IFR8 = IFR_ini8 + int(K-1,8)*int(NPIV,8)
             DO  JJ = J1, J3
              WCB(IFR8+int(JJ-J1+1,8)) = 
-     &            RHSCOMP(IPOSINRHSCOMP+JJ-J1,K)
+     &            RHSINTR(IPOSINRHSINTR+JJ-J1,K)
             ENDDO
           ENDDO
 !$OMP END PARALLEL DO
@@ -1153,7 +1153,7 @@ C
             IFR8 = IFR_ini8 + int(K-1,8)*int(NPIV,8)
             DO  JJ = J1, J3
              WCB(IFR8+int(JJ-J1+1,8)) = 
-     &            RHSCOMP(IPOSINRHSCOMP+JJ-J1,K)
+     &            RHSINTR(IPOSINRHSINTR+JJ-J1,K)
             ENDDO
           ENDDO
         ENDIF
@@ -1164,7 +1164,7 @@ C
 !$        OMP_FLAG = ( NRHS_B.GE.KEEP(362) .AND.
 !$   &                 NCB*NRHS_B .GE. KEEP(363) )
           IF (OMP_FLAG) THEN
-!$OMP PARALLEL DO PRIVATE (IFR8, JJ, J, IPOSINRHSCOMP)
+!$OMP PARALLEL DO PRIVATE (IFR8, JJ, J, IPOSINRHSINTR)
             DO K=1, NRHS_B
               IFR8 = IFR_ini8+(K-1)*NCB
 #if defined(__ve__)
@@ -1172,9 +1172,9 @@ C
 #endif
               DO JJ = J3 + 1, J2
                 J = IW(JJ)
-                IPOSINRHSCOMP = abs(POSINRHSCOMP_FWD(J))
-                WCB(IFR8+int(JJ-J3,8)) = RHSCOMP(IPOSINRHSCOMP,K)
-                RHSCOMP(IPOSINRHSCOMP,K)=ZERO
+                IPOSINRHSINTR = abs(POSINRHSINTR_FWD(J))
+                WCB(IFR8+int(JJ-J3,8)) = RHSINTR(IPOSINRHSINTR,K)
+                RHSINTR(IPOSINRHSINTR,K)=ZERO
               ENDDO
             ENDDO
 !$OMP END PARALLEL DO
@@ -1186,9 +1186,9 @@ C
 #endif
               DO JJ = J3 + 1, J2
                 J = IW(JJ)
-                IPOSINRHSCOMP = abs(POSINRHSCOMP_FWD(J))
-                WCB(IFR8+int(JJ-J3,8)) = RHSCOMP(IPOSINRHSCOMP,K)
-                RHSCOMP(IPOSINRHSCOMP,K)=ZERO
+                IPOSINRHSINTR = abs(POSINRHSINTR_FWD(J))
+                WCB(IFR8+int(JJ-J3,8)) = RHSINTR(IPOSINRHSINTR,K)
+                RHSINTR(IPOSINRHSINTR,K)=ZERO
               ENDDO
             ENDDO
           ENDIF
@@ -1214,4 +1214,4 @@ C
         ENDIF
       ENDIF
       RETURN
-      END SUBROUTINE ZMUMPS_RHSCOMP_TO_WCB
+      END SUBROUTINE ZMUMPS_RHSINTR_TO_WCB
diff -pruN 5.6.2-2.1/src/zsol_lr.F 5.7.1-1/src/zsol_lr.F
--- 5.6.2-2.1/src/zsol_lr.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zsol_lr.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -24,20 +24,20 @@ C
      &     LIELL, WCB, LWCB, 
      &     LD_WCBPIV, LD_WCBCB,
      &     PPIV_INIT, PCB_INIT, 
-     &     RHSCOMP, LRHSCOMP, NRHS, 
-     &     POSINRHSCOMP_FWD, JBDEB, JBFIN, 
+     &     RHSINTR, LRHSINTR, NRHS, 
+     &     POSINRHSINTR_FWD, JBDEB, JBFIN, 
      &     MTYPE, KEEP, KEEP8, OOCWRITE_COMPATIBLE_WITH_BLR,
      &     IFLAG, IERROR )
        INTEGER, INTENT(IN) :: INODE, N, IWHDLR, NPIV_GLOBAL, NSLAVES
        INTEGER, INTENT(IN) :: MTYPE, LIELL, KEEP(500)
        INTEGER(8), INTENT(IN) :: KEEP8(150)
-       INTEGER, INTENT(IN) :: LIW, IPOS_INIT, LRHSCOMP
-       INTEGER, INTENT(IN) :: IW(LIW), POSINRHSCOMP_FWD(N)
+       INTEGER, INTENT(IN) :: LIW, IPOS_INIT, LRHSINTR
+       INTEGER, INTENT(IN) :: IW(LIW), POSINRHSINTR_FWD(N)
        INTEGER(8), INTENT(IN) :: LWCB, PPIV_INIT, PCB_INIT
        INTEGER, INTENT(IN) :: LD_WCBPIV, LD_WCBCB, NRHS, JBDEB, JBFIN
        COMPLEX(kind=8), INTENT(INOUT) :: WCB(LWCB)
        INTEGER, INTENT(INOUT) :: IFLAG, IERROR
-       COMPLEX(kind=8), INTENT(INOUT) :: RHSCOMP(LRHSCOMP, NRHS)
+       COMPLEX(kind=8), INTENT(INOUT) :: RHSINTR(LRHSINTR, NRHS)
        LOGICAL, INTENT(IN)    :: OOCWRITE_COMPATIBLE_WITH_BLR
         INTEGER :: I, NPARTSASS, NB_BLR , NELIM, LDADIAG,
      &             DIAGSIZ_DYN, DIAGSIZ_STA, IBEG_BLR, IEND_BLR,
@@ -167,8 +167,8 @@ C
      &  IW, IPOS, LIW, 
      &  DIAG(1), int(size(DIAG),8), 1_8, 
      &  WCB, LWCB, LD_WCBPIV, 
-     &  RHSCOMP, LRHSCOMP, NRHS, 
-     &  POSINRHSCOMP_FWD, JBDEB, JBFIN, 
+     &  RHSINTR, LRHSINTR, NRHS, 
+     &  POSINRHSINTR_FWD, JBDEB, JBFIN, 
      &  MTYPE, KEEP, OOCWRITE_COMPATIBLE_WITH_BLR,
      &  .TRUE.  
      &  )
@@ -381,19 +381,19 @@ C
       SUBROUTINE ZMUMPS_SOL_BWD_LR_SU 
      &   ( INODE, IWHDLR, NPIV_GLOBAL, NSLAVES,
      &     LIELL, WCB, LWCB, NRHS_B, PTWCB,
-     &     RHSCOMP, LRHSCOMP, NRHS,
-     &     IPOSINRHSCOMP, JBDEB, 
+     &     RHSINTR, LRHSINTR, NRHS,
+     &     IPOSINRHSINTR, JBDEB, 
      &     MTYPE, KEEP, KEEP8,
      &     IFLAG, IERROR )
        INTEGER, INTENT(IN) :: INODE, IWHDLR, NPIV_GLOBAL, NSLAVES
        INTEGER, INTENT(IN) :: MTYPE, LIELL, KEEP(500)
        INTEGER(8), INTENT(IN) :: KEEP8(150)
-       INTEGER, INTENT(IN) :: IPOSINRHSCOMP, JBDEB, LRHSCOMP, NRHS
+       INTEGER, INTENT(IN) :: IPOSINRHSINTR, JBDEB, LRHSINTR, NRHS
        INTEGER(8), INTENT(IN) :: LWCB, PTWCB
        INTEGER, INTENT(IN) ::  NRHS_B
        INTEGER, INTENT(INOUT) :: IFLAG, IERROR
        COMPLEX(kind=8), INTENT(INOUT) :: WCB(LWCB)
-       COMPLEX(kind=8) RHSCOMP(LRHSCOMP,NRHS)
+       COMPLEX(kind=8) RHSINTR(LRHSINTR,NRHS)
         INTEGER :: I, NPARTSASS, NB_BLR, LAST_BLR, 
      &             NELIM_PANEL, LD_WCB,
      &             DIAGSIZ_DYN, DIAGSIZ_STA, LDADIAG,
@@ -441,15 +441,15 @@ C
         ENDIF 
         IF (DIAGSIZ_DYN.EQ.0) GOTO 1000
         NELIM_PANEL = DIAGSIZ_STA - DIAGSIZ_DYN
-         IPIV_PANEL = IPOSINRHSCOMP + IBEG_BLR -1
+         IPIV_PANEL = IPOSINRHSINTR + IBEG_BLR -1
          IF ( MTYPE .EQ. 1 .AND. KEEP(50).EQ.0) THEN
           BLR_PANEL => BLR_ARRAY(IWHDLR)%PANELS_U(I)%LRB_PANEL
          ELSE
           BLR_PANEL => BLR_ARRAY(IWHDLR)%PANELS_L(I)%LRB_PANEL
          END IF
         CALL ZMUMPS_SOL_BWD_BLR_UPDATE ( 
-     &        RHSCOMP, int(LRHSCOMP,8), NRHS, LRHSCOMP, 
-     &        int(IPOSINRHSCOMP,8), JBDEB,
+     &        RHSINTR, int(LRHSINTR,8), NRHS, LRHSINTR, 
+     &        int(IPOSINRHSINTR,8), JBDEB,
      &        WCB, LWCB, LD_WCB, PWCB, 
      &        int(IPIV_PANEL,8), 
      &        NRHS_B, NPIV_GLOBAL,
@@ -465,26 +465,26 @@ C
              IF (IEND_BLR.EQ.NPIV_GLOBAL) THEN
                CALL zgemm('T', 'N', DIAGSIZ_DYN, NRHS_B, NELIM_PANEL, 
      &              MONE, DIAG(1+DIAGSIZ_DYN), DIAGSIZ_STA,  WCB(PWCB),
-     &              LD_WCB, ONE , RHSCOMP(IPIV_PANEL,JBDEB),LRHSCOMP)
+     &              LD_WCB, ONE , RHSINTR(IPIV_PANEL,JBDEB),LRHSINTR)
              ELSE
                IF (IEND_BLR+1.LE.NPIV_GLOBAL .AND.
      &            IEND_BLR+NELIM_PANEL.GT.NPIV_GLOBAL) THEN
                  CALL zgemm('T', 'N', DIAGSIZ_DYN, NRHS_B,
      &              NPIV_GLOBAL-IEND_BLR, 
      &              MONE, DIAG(1+DIAGSIZ_DYN), DIAGSIZ_STA, 
-     &              RHSCOMP(IPIV_PANEL+DIAGSIZ_DYN,JBDEB), LRHSCOMP,
-     &              ONE, RHSCOMP(IPIV_PANEL,JBDEB), LRHSCOMP)
+     &              RHSINTR(IPIV_PANEL+DIAGSIZ_DYN,JBDEB), LRHSINTR,
+     &              ONE, RHSINTR(IPIV_PANEL,JBDEB), LRHSINTR)
                  CALL zgemm('T', 'N', DIAGSIZ_DYN, NRHS_B,
      &              IEND_BLR+NELIM_PANEL-NPIV_GLOBAL, 
      &              MONE, DIAG(1+DIAGSIZ_DYN+NPIV_GLOBAL-IEND_BLR),
      &              DIAGSIZ_STA, 
      &              WCB(PWCB), LD_WCB,
-     &              ONE, RHSCOMP(IPIV_PANEL,JBDEB), LRHSCOMP)
+     &              ONE, RHSINTR(IPIV_PANEL,JBDEB), LRHSINTR)
                ELSE
                  CALL zgemm('T', 'N', DIAGSIZ_DYN, NRHS_B, NELIM_PANEL, 
      &              MONE, DIAG(1+DIAGSIZ_DYN), DIAGSIZ_STA, 
-     &              RHSCOMP(IPIV_PANEL+DIAGSIZ_DYN,JBDEB), LRHSCOMP,
-     &              ONE, RHSCOMP(IPIV_PANEL,JBDEB), LRHSCOMP)
+     &              RHSINTR(IPIV_PANEL+DIAGSIZ_DYN,JBDEB), LRHSINTR,
+     &              ONE, RHSINTR(IPIV_PANEL,JBDEB), LRHSINTR)
                ENDIF
              ENDIF
            ELSE
@@ -492,27 +492,27 @@ C
                CALL zgemm('N', 'N', DIAGSIZ_DYN, NRHS_B, NELIM_PANEL, 
      &              MONE, DIAG(1+DIAGSIZ_DYN*LDADIAG), DIAGSIZ_DYN, 
      &              WCB(PWCB), LD_WCB, ONE, 
-     &              RHSCOMP(IPIV_PANEL,JBDEB), LRHSCOMP)
+     &              RHSINTR(IPIV_PANEL,JBDEB), LRHSINTR)
              ELSE
                IF (IEND_BLR+1.LE.NPIV_GLOBAL .AND.
      &            IEND_BLR+NELIM_PANEL.GT.NPIV_GLOBAL) THEN
                  CALL zgemm('N', 'N', DIAGSIZ_DYN, NRHS_B,
      &              NPIV_GLOBAL-IEND_BLR, 
      &              MONE, DIAG(1+DIAGSIZ_DYN*LDADIAG), DIAGSIZ_DYN, 
-     &              RHSCOMP(IPIV_PANEL+DIAGSIZ_DYN,JBDEB), LRHSCOMP,
-     &              ONE, RHSCOMP(IPIV_PANEL,JBDEB), LRHSCOMP)
+     &              RHSINTR(IPIV_PANEL+DIAGSIZ_DYN,JBDEB), LRHSINTR,
+     &              ONE, RHSINTR(IPIV_PANEL,JBDEB), LRHSINTR)
                  CALL zgemm('N', 'N', DIAGSIZ_DYN, NRHS_B,
      &              IEND_BLR+NELIM_PANEL-NPIV_GLOBAL, 
      &              MONE, DIAG(1+DIAGSIZ_DYN*LDADIAG +
      &                  (NPIV_GLOBAL-IEND_BLR)*DIAGSIZ_DYN),
      &              DIAGSIZ_DYN, 
      &              WCB(PWCB), LD_WCB,
-     &              ONE, RHSCOMP(IPIV_PANEL,JBDEB), LRHSCOMP)
+     &              ONE, RHSINTR(IPIV_PANEL,JBDEB), LRHSINTR)
                ELSE
                  CALL zgemm('N', 'N', DIAGSIZ_DYN, NRHS_B, NELIM_PANEL, 
      &              MONE, DIAG(1+DIAGSIZ_DYN*LDADIAG), DIAGSIZ_DYN, 
-     &              RHSCOMP(IPIV_PANEL+DIAGSIZ_DYN,JBDEB), LRHSCOMP,
-     &              ONE, RHSCOMP(IPIV_PANEL,JBDEB), LRHSCOMP)
+     &              RHSINTR(IPIV_PANEL+DIAGSIZ_DYN,JBDEB), LRHSINTR,
+     &              ONE, RHSINTR(IPIV_PANEL,JBDEB), LRHSINTR)
                ENDIF
              ENDIF
            ENDIF
@@ -521,7 +521,7 @@ C
          CALL ZMUMPS_SOLVE_BWD_LR_TRSOLVE  (
      &         DIAG(1), size(DIAG), DIAGSIZ_DYN, NELIM_PANEL, LIELL,
      &         NRHS_B, WCB, LWCB, 
-     &         RHSCOMP, LRHSCOMP, NRHS,
+     &         RHSINTR, LRHSINTR, NRHS,
      &         IPIV_PANEL, JBDEB, 
      &         MTYPE, KEEP )
  1000 CONTINUE         
@@ -697,24 +697,24 @@ C
       SUBROUTINE ZMUMPS_SOLVE_BWD_LR_TRSOLVE (
      &           DIAG, LDIAG, NPIV, NELIM, LIELL,
      &           NRHS_B, W, LWC, 
-     &           RHSCOMP, LRHSCOMP, NRHS,
-     &           PPIVINRHSCOMP, JBDEB, 
+     &           RHSINTR, LRHSINTR, NRHS,
+     &           PPIVINRHSINTR, JBDEB, 
      &           MTYPE, KEEP)
        INTEGER, INTENT(IN) :: MTYPE, LIELL, NPIV, NELIM, KEEP(500)
        INTEGER, INTENT(IN) :: NRHS_B, LDIAG
-       INTEGER, INTENT(IN) :: PPIVINRHSCOMP, JBDEB, LRHSCOMP, NRHS
+       INTEGER, INTENT(IN) :: PPIVINRHSINTR, JBDEB, LRHSINTR, NRHS
        INTEGER(8), INTENT(IN) ::  LWC
        COMPLEX(kind=8), INTENT(IN) :: DIAG(LDIAG)
        COMPLEX(kind=8), INTENT(INOUT) :: W(LWC)
-       COMPLEX(kind=8) RHSCOMP(LRHSCOMP,NRHS)
+       COMPLEX(kind=8) RHSINTR(LRHSINTR,NRHS)
        INTEGER :: LDAJ
       COMPLEX(kind=8) ONE
       PARAMETER ( ONE=(1.0D0,0.0D0) )
         IF ( MTYPE .eq. 1 ) THEN
          LDAJ =  NPIV + NELIM
          CALL ztrsm('L','L','T','N', NPIV, NRHS_B, ONE, DIAG(1),
-     &              LDAJ, RHSCOMP(PPIVINRHSCOMP,JBDEB), 
-     &              LRHSCOMP)
+     &              LDAJ, RHSINTR(PPIVINRHSINTR,JBDEB), 
+     &              LRHSINTR)
         ELSE
          IF ( KEEP(50) .EQ. 0 ) THEN
            LDAJ=NPIV+NELIM
@@ -722,7 +722,7 @@ C
            LDAJ=NPIV
          ENDIF
          CALL ztrsm('L','U','N','U', NPIV, NRHS_B, ONE, DIAG(1),
-     &            LDAJ, RHSCOMP(PPIVINRHSCOMP,JBDEB), LRHSCOMP)
+     &            LDAJ, RHSINTR(PPIVINRHSINTR,JBDEB), LRHSINTR)
         END IF 
       RETURN
       END SUBROUTINE ZMUMPS_SOLVE_BWD_LR_TRSOLVE
diff -pruN 5.6.2-2.1/src/zsol_matvec.F 5.7.1-1/src/zsol_matvec.F
--- 5.6.2-2.1/src/zsol_matvec.F	2023-10-11 09:37:10.000000000 +0000
+++ 5.7.1-1/src/zsol_matvec.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/zsol_omp_m.F 5.7.1-1/src/zsol_omp_m.F
--- 5.6.2-2.1/src/zsol_omp_m.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zsol_omp_m.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -35,16 +35,18 @@ C
       IMPLICIT NONE
       INTEGER, INTENT(IN) :: K400
 !$    INTEGER :: I
-!$    IF (K400 .GT. 0) THEN
-!$      DO I = 1, min(NB_LOCK_MAX,K400)
-!$        CALL OMP_DESTROY_LOCK(LOCK_FOR_SCATTER(I))
-!$      ENDDO
-!$      DEALLOCATE(LOCK_FOR_SCATTER)
+!$    IF (allocated(LOCK_FOR_SCATTER)) THEN
+!$      IF (K400 .GT. 0) THEN
+!$        DO I = 1, min(NB_LOCK_MAX,K400)
+!$          CALL OMP_DESTROY_LOCK(LOCK_FOR_SCATTER(I))
+!$        ENDDO
+!$        DEALLOCATE(LOCK_FOR_SCATTER)
+!$      ENDIF
 !$    ENDIF
       RETURN
       END SUBROUTINE ZMUMPS_SOL_L0OMP_LD
       SUBROUTINE ZMUMPS_SOL_L0OMP_R(N, MTYPE,
-     &  NRHS, LIW, IW, PTRICB, RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD,
+     &  NRHS, LIW, IW, PTRICB, RHSINTR, LRHSINTR, POSINRHSINTR_FWD,
      &  STEP, FRERE, DAD, FILS, NSTK, PTRIST, PTRFAC, INFO,
      &  KEEP, KEEP8, DKEEP, PROCNODE_STEPS, SLAVEF,
      &  COMM, MYID,              
@@ -69,8 +71,8 @@ C
       DOUBLE PRECISION                  :: DKEEP(230)
       INTEGER, INTENT( in ) :: PROCNODE_STEPS( KEEP(28) )
       INTEGER               :: PTRICB( KEEP(28) ) 
-      INTEGER, INTENT( in ) :: POSINRHSCOMP_FWD(N), LRHSCOMP 
-      COMPLEX(kind=8), INTENT(inout):: RHSCOMP(LRHSCOMP,NRHS)
+      INTEGER, INTENT( in ) :: POSINRHSINTR_FWD(N), LRHSINTR 
+      COMPLEX(kind=8), INTENT(inout):: RHSINTR(LRHSINTR,NRHS)
       INTEGER, INTENT( in ) :: STEP(N), FRERE( KEEP(28) ), FILS( N ),
      &                         DAD( KEEP(28) )
       INTEGER, INTENT( inout ) :: NSTK(KEEP(28))
@@ -220,7 +222,7 @@ C
      &        PTRICB, PTRIST, PTRFAC, PROCNODE_STEPS,
      &        FILS, STEP, FRERE, DAD, INFO_P, KEEP, KEEP8, DKEEP,
      &        RHS_ROOT, LRHS_ROOT, MTYPE,
-     &        RHSCOMP, LRHSCOMP, POSINRHSCOMP_FWD,
+     &        RHSINTR, LRHSINTR, POSINRHSINTR_FWD,
      &        ISTEP_TO_INIV2, TAB_POS_IN_PERE, 
      &        RHS_BOUNDS, LRHS_BOUNDS, DO_NBSPARSE, FROM_PP
      &        , ERROR_WAS_BROADCASTED_P )
@@ -286,7 +288,7 @@ C
       RETURN
       END SUBROUTINE ZMUMPS_SOL_L0OMP_R
       SUBROUTINE ZMUMPS_SOL_L0OMP_S(N, MTYPE, NRHS, LIW, IW,
-     &  PTRICB, PTRACB, RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &  PTRICB, PTRACB, RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &  STEP, FRERE, FILS, NE_STEPS, PTRIST, PTRFAC, INFO,
      &  KEEP, KEEP8, DKEEP, PROCNODE_STEPS, SLAVEF,
      &  COMM, MYID, BUFR, LBUFR, LBUFR_BYTES, RHS_ROOT, LRHS_ROOT, 
@@ -307,8 +309,8 @@ C
       INTEGER, INTENT( in ) :: PROCNODE_STEPS( KEEP(28) )
       INTEGER               :: PTRICB( KEEP(28) ) 
       INTEGER(8)            :: PTRACB( KEEP(28) ) 
-      INTEGER, INTENT( in ) :: POSINRHSCOMP_BWD(N), LRHSCOMP 
-      COMPLEX(kind=8), INTENT(inout):: RHSCOMP(LRHSCOMP,NRHS)
+      INTEGER, INTENT( in ) :: POSINRHSINTR_BWD(N), LRHSINTR 
+      COMPLEX(kind=8), INTENT(inout):: RHSINTR(LRHSINTR,NRHS)
       INTEGER, INTENT( in ) :: STEP(N), FRERE( KEEP(28) ), FILS( N )
       INTEGER, INTENT( inout ) :: NE_STEPS(KEEP(28))
       INTEGER, INTENT( in )    :: PTRIST(KEEP(28))
@@ -440,7 +442,7 @@ C
      &      IIPOOL_P,  NBFIN_DUMMY, L0_OMP_FACTORS(IL0OMPFAC)%A(1),
      &      L0_OMP_FACTORS(IL0OMPFAC)%LA, IW, LIW, 
      &      WCB_P, LWCB_P, NRHS, POSWCB_P, PLEFTWCB_P, POSIWCB_P,
-     &      RHSCOMP, LRHSCOMP, POSINRHSCOMP_BWD,
+     &      RHSINTR, LRHSINTR, POSINRHSINTR_BWD,
      &      PTRICB, PTRACB, IWCB_P, LIWCB_P, W2_P, NE_STEPS, STEP,
      &      FRERE, FILS, PTRIST, PTRFAC, MYLEAF_LEFT_HUGE_P, INFO_P, 
      &      PROCNODE_STEPS,
diff -pruN 5.6.2-2.1/src/zsol_root_parallel.F 5.7.1-1/src/zsol_root_parallel.F
--- 5.6.2-2.1/src/zsol_root_parallel.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zsol_root_parallel.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -29,11 +29,10 @@ C
       INTEGER IERR, NPROW, NPCOL, MYROW, MYCOL
       INTEGER LOCAL_N_RHS
       COMPLEX(kind=8), ALLOCATABLE, DIMENSION( :,: ) ::RHS_PAR
-      EXTERNAL numroc
-      INTEGER  numroc
+      INTEGER, EXTERNAL :: MUMPS_NUMROC
       INTEGER allocok
       CALL blacs_gridinfo( CNTXT_PAR, NPROW, NPCOL, MYROW, MYCOL )
-      LOCAL_N_RHS = numroc(NRHS, NBLOCK, MYCOL, 0, NPCOL)
+      LOCAL_N_RHS = MUMPS_NUMROC(NRHS, NBLOCK, MYCOL, 0, NPCOL)
       LOCAL_N_RHS = max(1,LOCAL_N_RHS)
       ALLOCATE(RHS_PAR(LOCAL_M, LOCAL_N_RHS),stat=allocok)
       IF (allocok > 0 ) THEN
diff -pruN 5.6.2-2.1/src/zstatic_ptr_m.F 5.7.1-1/src/zstatic_ptr_m.F
--- 5.6.2-2.1/src/zstatic_ptr_m.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/zstatic_ptr_m.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
diff -pruN 5.6.2-2.1/src/ztools.F 5.7.1-1/src/ztools.F
--- 5.6.2-2.1/src/ztools.F	2023-10-11 09:37:09.000000000 +0000
+++ 5.7.1-1/src/ztools.F	2024-05-02 10:15:28.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -638,14 +638,6 @@ C
      & '    Total space in MBytes, OOC factorization     (INFOG(39)):'
      &        ,INFOG(39)
       END IF
-      IF ( PROKG.AND.SUM_OF_PEAKS) THEN
-       WRITE( MPG,'(A,A)') 
-     & ' Estimations with BLR compression of only',
-     & ' Contribution Blocks (CB):'
-       WRITE( MPG,'(A,I6,A) ')
-     & ' ICNTL(39) Estimated compression rate of CB         =', 
-     &   KEEP(465), '/1000'
-      ENDIF
       IF (SUM_OF_PEAKS) THEN
        OOC_STAT  =  0  
        BLR_STRAT =  3  
@@ -686,16 +678,6 @@ C
           LRCB_UD(3) = LRCB_UD(2)/NSLAVES
         ENDIF
        ENDIF
-       IF ( PROKG.AND.SUM_OF_PEAKS ) THEN
-        IF (COMPUTE_MAXAVG) THEN
-         WRITE( MPG,'(A,I12) ')
-     & '    Maximum estim. space in Mbytes, IC facto.    (INFOG(44)):',
-     &        INFOG(44)
-        ENDIF
-        WRITE(MPG,'(A,I12) ')
-     & '    Total space in MBytes, IC factorization      (INFOG(45)):'
-     &        ,INFOG(45)
-       END IF
        OOC_STAT  =  1  
        BLR_STRAT =  3  
        BLR_CASE  =  1  
@@ -735,16 +717,6 @@ C
           OOC_LRCB_UD(3) = OOC_LRCB_UD(2)/NSLAVES
         ENDIF
        ENDIF
-       IF ( PROKG.AND.SUM_OF_PEAKS  ) THEN
-        IF (COMPUTE_MAXAVG) THEN
-         WRITE( MPG,'(A,I12) ')
-     & '    Maximum estim. space in Mbytes, OOC facto.   (INFOG(46)):',
-     &        INFOG(46)
-        ENDIF
-        WRITE(MPG,'(A,I12) ')
-     & '    Total space in MBytes, OOC factorization     (INFOG(47)):'
-     &        ,INFOG(47)
-       END IF
       END IF
       IF ( PROKG.AND.SUM_OF_PEAKS  ) THEN
        WRITE( MPG,'(A,A)') 
@@ -927,7 +899,7 @@ C
       NB_INT = NB_INT + 5_8 * NSTEPS8
       NB_INT = NB_INT + NSTEPS8 + int(KEEP(56),8)*int(NSLAVES+2,8)
         NB_INT = NB_INT + 3_8*N8 + KEEP(280)
-        IF (KEEP(38) .NE. 0) NB_INT = NB_INT + N8
+        IF (KEEP(38) .NE. 0 .AND.I_AM_SLAVE) NB_INT = NB_INT + N8 
       IF (KEEP(23).ne.0 .and. I_AM_MASTER) NB_INT=NB_INT + N8
       IF (KEEP(55).eq.0) THEN
         NB_INT = NB_INT + KEEP(193)*I8OVERI
@@ -1128,9 +1100,6 @@ C
      &         .and. KEEP(55) .ne. 0 ) ) THEN
         NB_INT  = NB_INT  + KEEP8(27)
       END IF
-      IF ( I_AM_SLAVE .and. KEEP(38) .ne. 0 ) THEN
-        NB_INT = NB_INT + N8
-      END IF
       TEMPI= 0_8
       TEMPR = 0_8
       NBRECORDS = KEEP(39)
@@ -1971,10 +1940,10 @@ C
      &  NB_INT=NB_INT+size(id%I_AM_CAND)
       IF (associated(id%MEM_DIST)) 
      &  NB_INT=NB_INT+size(id%MEM_DIST)
-      IF (associated(id%POSINRHSCOMP_ROW))
-     &     NB_INT=NB_INT+size(id%POSINRHSCOMP_ROW)
-      IF(id%POSINRHSCOMP_COL_ALLOC.AND.associated(id%POSINRHSCOMP_COL))
-     &     NB_INT=NB_INT+size(id%POSINRHSCOMP_COL)
+      IF (associated(id%GLOB2LOC_RHS))
+     &     NB_INT=NB_INT+size(id%GLOB2LOC_RHS)
+      IF(id%GLOB2LOC_SOL_ALLOC.AND.associated(id%GLOB2LOC_SOL))
+     &     NB_INT=NB_INT+size(id%GLOB2LOC_SOL)
       IF       (associated(id%MEM_SUBTREE))
      &  NB_REAL=NB_REAL+size(id%MEM_SUBTREE)*(id%KEEP(35)/id%KEEP(16))
       IF       (associated(id%MY_ROOT_SBTR))
@@ -2055,12 +2024,16 @@ C
      &     NB_CMPLX=NB_CMPLX+size(id%root%SVD_VT)
       IF (associated(id%root%SINGULAR_VALUES))
      &     NB_REAL=NB_REAL+size(id%root%SINGULAR_VALUES)
-      IF (associated(id%RHSCOMP)) NB_CMPLX = NB_CMPLX + id%KEEP8(25)
+      IF (associated(id%RHSINTR)) NB_CMPLX = NB_CMPLX + id%KEEP8(25)
       IF (associated(id%S))       NB_CMPLX=NB_CMPLX+id%KEEP8(23)
       IF (associated(id%COLSCA).AND.(id%KEEP(52).NE.-1))
      &     NB_REAL=NB_REAL+size(id%COLSCA)
       IF (associated(id%ROWSCA).AND.(id%KEEP(52).NE.-1))
      &     NB_REAL=NB_REAL+size(id%ROWSCA)
+      IF (associated(id%ROWSCA_loc)) 
+     &     NB_REAL=NB_REAL+size(id%ROWSCA_loc)
+      IF (associated(id%COLSCA_loc).AND.id%KEEP(50).EQ.0)
+     &     NB_REAL=NB_REAL+size(id%COLSCA_loc)
       NB_REAL=NB_REAL+size(id%CNTL)
       NB_REAL=NB_REAL+size(id%RINFO)
       NB_REAL=NB_REAL+size(id%RINFOG)
@@ -2083,7 +2056,6 @@ C
       INTEGER(8) :: SHIFT8, HUG8
       INTEGER    :: I, I4SIZE
       IF(int(huge(I4SIZE),8) .EQ. int(huge(HUG8),8)) THEN
-         CALL zcopy(N8, SRC(1), 1, DEST(1), 1)
          CALL zcopy(int(N8), SRC(1), 1, DEST(1), 1)
       ELSE
          HUG8=int(huge(I4SIZE),8)
diff -pruN 5.6.2-2.1/src/ztype3_root.F 5.7.1-1/src/ztype3_root.F
--- 5.6.2-2.1/src/ztype3_root.F	2023-10-11 09:37:08.000000000 +0000
+++ 5.7.1-1/src/ztype3_root.F	2024-05-02 10:15:27.000000000 +0000
@@ -1,9 +1,9 @@
 C
-C  This file is part of MUMPS 5.6.2, released
-C  on Wed Oct 11 09:36:25 UTC 2023
+C  This file is part of MUMPS 5.7.1, released
+C  on Thu May  2 10:15:09 UTC 2024
 C
 C
-C  Copyright 1991-2023 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
+C  Copyright 1991-2024 CERFACS, CNRS, ENS Lyon, INP Toulouse, Inria,
 C  Mumps Technologies, University of Bordeaux.
 C
 C  This version of MUMPS is provided to you free of charge. It is
@@ -127,7 +127,7 @@ C
       DOUBLE PRECISION OPASSW, OPELIW
       INTEGER PROCNODE_STEPS( KEEP(28) )
       INTEGER ITLOC( N + KEEP(253) ), FILS( N ), DAD(KEEP(28))
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INTEGER ND( KEEP(28) ), FRERE( KEEP(28) )
       INTEGER(8), INTENT(IN) :: PTRARW( LPTRAR ), PTRAIW( LPTRAR )
       INTEGER(8), INTENT(IN) :: PTR8ARR(KEEP(193))
@@ -161,8 +161,6 @@ C
       INCLUDE 'mumps_headers.h'
       LOGICAL SKIPLAST_RHS_ROWS, BCP_SYM_NONEMPTY
       INTEGER BBPCBP
-      INTEGER MUMPS_PROCNODE
-      EXTERNAL MUMPS_PROCNODE
       BBPCBP  = 0   
       LP = ICNTL(1)
       IF ( ICNTL(4) .LE. 0 ) LP = -1
@@ -1176,7 +1174,7 @@ C
       INTEGER(8) :: PTRAST(KEEP(28)), PAMASTER(KEEP(28))
       INTEGER PIMASTER(KEEP(28))
       INTEGER ITLOC( N + KEEP(253) )
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INTEGER COMP, IFLAG, IERROR
       INCLUDE 'mumps_headers.h'
       INTEGER FILS( N ), DAD(KEEP(28))
@@ -1189,20 +1187,19 @@ C
       INTEGER, INTENT(IN) :: PTRDEBARR(KEEP(196))
       INTEGER INTARR(KEEP8(27))
       COMPLEX(kind=8) DBLARR(KEEP8(26))
-      INTEGER numroc
-      EXTERNAL numroc
+      INTEGER, EXTERNAL :: MUMPS_NUMROC
       COMPLEX(kind=8) ZERO
       PARAMETER( ZERO = (0.0D0,0.0D0) )
       INTEGER(8) :: LREQA_ROOT
       INTEGER LREQI_ROOT, LOCAL_M, LOCAL_N, allocok
       LOGICAL :: EARLYT3ROOTINS
-          LOCAL_M = numroc( root%ROOT_SIZE, root%MBLOCK,
+          LOCAL_M = MUMPS_NUMROC( root%ROOT_SIZE, root%MBLOCK,
      &              root%MYROW, 0, root%NPROW )
           LOCAL_M = max( 1, LOCAL_M )
-          LOCAL_N = numroc( root%ROOT_SIZE, root%NBLOCK,
+          LOCAL_N = MUMPS_NUMROC( root%ROOT_SIZE, root%NBLOCK,
      &              root%MYCOL, 0, root%NPCOL )
           IF (KEEP(253).GT.0) THEN
-            root%RHS_NLOC = numroc( KEEP(253), root%NBLOCK,
+            root%RHS_NLOC = MUMPS_NUMROC( KEEP(253), root%NBLOCK,
      &              root%MYCOL, 0, root%NPCOL )
             root%RHS_NLOC = max(1, root%RHS_NLOC)
           ELSE
@@ -1220,7 +1217,7 @@ C
           IF (KEEP(253).NE.0) THEN
             root%RHS_ROOT = ZERO
             CALL ZMUMPS_ASM_RHS_ROOT (  N, FILS, 
-     &           root, KEEP, RHS_MUMPS, 
+     &           root, KEEP, KEEP8, RHS_MUMPS, 
      &           IFLAG, IERROR )
             IF ( IFLAG .LT. 0 ) RETURN
           ENDIF
@@ -1373,14 +1370,15 @@ C
       RETURN
       END SUBROUTINE ZMUMPS_ASM_ELT_ROOT
       SUBROUTINE ZMUMPS_ASM_RHS_ROOT
-     &           ( N, FILS, root, KEEP, RHS_MUMPS, 
+     &           ( N, FILS, root, KEEP, KEEP8, RHS_MUMPS, 
      &             IFLAG, IERROR )
       USE ZMUMPS_STRUC_DEF, ONLY : ZMUMPS_ROOT_STRUC
       IMPLICIT NONE
       INTEGER N, KEEP(500), IFLAG, IERROR
+      INTEGER(8) :: KEEP8(150)
       INTEGER FILS(N)
       TYPE (ZMUMPS_ROOT_STRUC ) :: root
-      COMPLEX(kind=8) :: RHS_MUMPS(KEEP(255))
+      COMPLEX(kind=8) :: RHS_MUMPS(KEEP8(85))
       INTEGER JCOL, IPOS_ROOT, JPOS_ROOT,
      &        IROW_GRID, JCOL_GRID, ILOCRHS, JLOCRHS,
      &        INODE
